class
	P_XEYES_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_X11_INTRINSIC_STATIC
	S_X11_XLIB_STATIC
	S_X11_SHELL_STATIC

feature {ANY} -- public attributes

	options: CE_STATIC [CE_ARRAY [SD_XRMOPTIONDESCREC]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [SD_XRMOPTIONDESCREC]}.make_initialized (<<
					create {SD_XRMOPTIONDESCREC}.make_initialized ([ce_string ("-outline"), ce_string ("*eyes.outline"), {SC_XRMOPTIONKIND}.XrmoptionSepArg, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)]),
					create {SD_XRMOPTIONDESCREC}.make_initialized ([ce_string ("-center"), ce_string ("*eyes.center"), {SC_XRMOPTIONKIND}.XrmoptionSepArg, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)]),
					create {SD_XRMOPTIONDESCREC}.make_initialized ([ce_string ("-backing"), ce_string ("*eyes.backingStore"), {SC_XRMOPTIONKIND}.XrmoptionSepArg, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)]),
					create {SD_XRMOPTIONDESCREC}.make_initialized ([ce_string ("-shape"), ce_string ("*eyes.shapeWindow"), {SC_XRMOPTIONKIND}.XrmoptionNoArg, ce_string ("TRUE")]),
					create {SD_XRMOPTIONDESCREC}.make_initialized ([ce_string ("+shape"), ce_string ("*eyes.shapeWindow"), {SC_XRMOPTIONKIND}.XrmoptionNoArg, ce_string ("FALSE")])
				>>)
		end

	wm_delete_window: CE_STATIC [CE_ARRAY [NATURAL_32]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_32_ARRAY}.make (<<1>>)
		end

	actions: CE_STATIC [CE_ARRAY [SD_XTACTIONSREC]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [SD_XTACTIONSREC]}.make_initialized (<<
					create {SD_XTACTIONSREC}.make_initialized ([ce_string ("quit"), quit_address])
				>>)
		end

feature {ANY} -- public routines

	usage
		do
			Io.error.put_string ("usage: xeyes%N")
			Io.error.put_string ("       [-geometry [{width}][x{height}][{+-}{xoff}[{+-}{yoff}]]] [-display [{host}]:[{vs}]]%N")
			Io.error.put_string ("       [-fg {color}] [-bg {color}] [-bd {color}] [-bw {pixels}]")
			Io.error.put_string (" [-shape | +shape]")
			Io.error.put_string ("%N")
			Io.error.put_string ("       [-outline {color}] [-center {color}] [-backing {backing-store}]%N")
			exit (1)
		end

	quit (a_w: CE_POINTER [SD_WIDGETREC]; a_event: CE_POINTER [SD_XEVENT]; a_params: CE_POINTER [CE_POINTER [INTEGER_8]]; a_num_params: CE_POINTER [NATURAL_32])
		require
			not a_event.is_void
		local
			l_tmp___0: CE_POINTER [ANY]
		do
			if a_event.item.type = 33 then
				if (a_event.item.xclient.data.l[0]).to_natural_32 /= wm_delete_window.item.item then
					XBell ((XtDisplay (a_w)), 0).do_nothing
				else
					l_tmp___0 := XtWidgetToApplicationContext (a_w)
					XtDestroyApplicationContext (l_tmp___0)
					exit (0)
				end
			else
				l_tmp___0 := XtWidgetToApplicationContext (a_w)
				XtDestroyApplicationContext (l_tmp___0)
				exit (0)
			end
		end

	main (a_argc: INTEGER_32; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_argc: CE_ARRAY [INTEGER_32]
			l_app_context: CE_ARRAY [CE_POINTER [ANY]]
			l_toplevel: CE_POINTER [SD_WIDGETREC]
			l_arg: CE_ARRAY [SD_ARG]
			l_i: NATURAL_32
			l_tmp___1: CE_POINTER [SD_SCREEN]
			l_tmp___4: CE_POINTER [SD_SCREEN]
			l_tmp___7: NATURAL_32
		do
			create {CE_INTEGER_32_ARRAY} l_argc.make (<<1>>)
			create {CE_POINTER_ARRAY [ANY]} l_app_context.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_ARG]} l_arg.make (<<2>>)

			l_argc.item := a_argc
			XtSetLanguageProc (create {CE_VOID_POINTER}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
			l_toplevel := XtAppInitialize (l_app_context, ce_string ("XEyes"), options.item, ((create {SD_XRMOPTIONDESCREC}.make).structure_size.to_natural_32 * (5).to_natural_32) // (create {SD_XRMOPTIONDESCREC}.make).structure_size.to_natural_32, l_argc, a_argv, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), l_arg, {NATURAL_32} 0)
			if l_argc.item /= 1 then
				usage
			end
			wm_delete_window.item.item := XInternAtom ((XtDisplay (l_toplevel)), ce_string ("WM_DELETE_WINDOW"), 0)
			XtAppAddActions (l_app_context.item, actions.item, ((create {SD_XTACTIONSREC}.make).structure_size.to_natural_32 * (1).to_natural_32) // (create {SD_XTACTIONSREC}.make).structure_size.to_natural_32)
			XtOverrideTranslations (l_toplevel, (XtParseTranslationTable (ce_string ("<Message>WM_PROTOCOLS: quit()"))))
			l_i := {NATURAL_32} 0
			l_arg[l_i.to_integer_32].name := (XtShellStrings + 18)
			l_tmp___1 := XtScreen (l_toplevel)
			l_arg[l_i.to_integer_32].value := (XCreateBitmapFromData ((XtDisplay (l_toplevel)), l_tmp___1.item.root, create {CE_INTEGER_8_POINTER}.make_cast (((create {P_EYES_STATIC}).eyes_bits.item)), {NATURAL_32} 48, {NATURAL_32} 32)).to_integer_32
			l_i := l_i + 1
			l_arg[l_i.to_integer_32].name := (XtShellStrings + 62)
			l_tmp___4 := XtScreen (l_toplevel)
			l_arg[l_i.to_integer_32].value := (XCreateBitmapFromData ((XtDisplay (l_toplevel)), l_tmp___4.item.root, create {CE_INTEGER_8_POINTER}.make_cast (((create {P_EYESMASK_STATIC}).eyesmask_bits.item)), {NATURAL_32} 48, {NATURAL_32} 32)).to_integer_32
			l_i := l_i + 1
			XtSetValues (l_toplevel, l_arg, l_i)
			XtCreateManagedWidget (ce_string ("eyes"), (create {P_EYES_STATIC}).eyesWidgetClass.item, l_toplevel, create {CE_CLASS_POINTER [SD_ARG]}.make_shared (default_pointer), {NATURAL_32} 0).do_nothing
			XtRealizeWidget (l_toplevel)
			l_tmp___7 := XtWindow (l_toplevel)
			XSetWMProtocols ((XtDisplay (l_toplevel)), l_tmp___7, wm_delete_window.item, 1).do_nothing
			XtAppMainLoop (l_app_context.item)
			Result := 0
		end

feature {ANY} -- routine addresses

	quit_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent quit)
		end

end
