class
	SD_XSETWINDOWATTRIBUTES

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	background_pixmap: NATURAL_32 assign set_background_pixmap

	background_pixel: NATURAL_32 assign set_background_pixel

	border_pixmap: NATURAL_32 assign set_border_pixmap

	border_pixel: NATURAL_32 assign set_border_pixel

	bit_gravity: INTEGER_32 assign set_bit_gravity

	win_gravity: INTEGER_32 assign set_win_gravity

	backing_store: INTEGER_32 assign set_backing_store

	backing_planes: NATURAL_32 assign set_backing_planes

	backing_pixel: NATURAL_32 assign set_backing_pixel

	save_under: INTEGER_32 assign set_save_under

	event_mask: INTEGER_32 assign set_event_mask

	do_not_propagate_mask: INTEGER_32 assign set_do_not_propagate_mask

	override_redirect: INTEGER_32 assign set_override_redirect

	colormap: NATURAL_32 assign set_colormap

	cursor: NATURAL_32 assign set_cursor

feature {ANY} -- field setters

	set_background_pixmap (a_background_pixmap: NATURAL_32)
		do
			background_pixmap := a_background_pixmap
			update_memory_field ("background_pixmap")
		end

	set_background_pixel (a_background_pixel: NATURAL_32)
		do
			background_pixel := a_background_pixel
			update_memory_field ("background_pixel")
		end

	set_border_pixmap (a_border_pixmap: NATURAL_32)
		do
			border_pixmap := a_border_pixmap
			update_memory_field ("border_pixmap")
		end

	set_border_pixel (a_border_pixel: NATURAL_32)
		do
			border_pixel := a_border_pixel
			update_memory_field ("border_pixel")
		end

	set_bit_gravity (a_bit_gravity: INTEGER_32)
		do
			bit_gravity := a_bit_gravity
			update_memory_field ("bit_gravity")
		end

	set_win_gravity (a_win_gravity: INTEGER_32)
		do
			win_gravity := a_win_gravity
			update_memory_field ("win_gravity")
		end

	set_backing_store (a_backing_store: INTEGER_32)
		do
			backing_store := a_backing_store
			update_memory_field ("backing_store")
		end

	set_backing_planes (a_backing_planes: NATURAL_32)
		do
			backing_planes := a_backing_planes
			update_memory_field ("backing_planes")
		end

	set_backing_pixel (a_backing_pixel: NATURAL_32)
		do
			backing_pixel := a_backing_pixel
			update_memory_field ("backing_pixel")
		end

	set_save_under (a_save_under: INTEGER_32)
		do
			save_under := a_save_under
			update_memory_field ("save_under")
		end

	set_event_mask (a_event_mask: INTEGER_32)
		do
			event_mask := a_event_mask
			update_memory_field ("event_mask")
		end

	set_do_not_propagate_mask (a_do_not_propagate_mask: INTEGER_32)
		do
			do_not_propagate_mask := a_do_not_propagate_mask
			update_memory_field ("do_not_propagate_mask")
		end

	set_override_redirect (a_override_redirect: INTEGER_32)
		do
			override_redirect := a_override_redirect
			update_memory_field ("override_redirect")
		end

	set_colormap (a_colormap: NATURAL_32)
		do
			colormap := a_colormap
			update_memory_field ("colormap")
		end

	set_cursor (a_cursor: NATURAL_32)
		do
			cursor := a_cursor
			update_memory_field ("cursor")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			background_pixmap := a_other.background_pixmap
			background_pixel := a_other.background_pixel
			border_pixmap := a_other.border_pixmap
			border_pixel := a_other.border_pixel
			bit_gravity := a_other.bit_gravity
			win_gravity := a_other.win_gravity
			backing_store := a_other.backing_store
			backing_planes := a_other.backing_planes
			backing_pixel := a_other.backing_pixel
			save_under := a_other.save_under
			event_mask := a_other.event_mask
			do_not_propagate_mask := a_other.do_not_propagate_mask
			override_redirect := a_other.override_redirect
			colormap := a_other.colormap
			cursor := a_other.cursor
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				background_pixmap = a_other.background_pixmap and
				background_pixel = a_other.background_pixel and
				border_pixmap = a_other.border_pixmap and
				border_pixel = a_other.border_pixel and
				bit_gravity = a_other.bit_gravity and
				win_gravity = a_other.win_gravity and
				backing_store = a_other.backing_store and
				backing_planes = a_other.backing_planes and
				backing_pixel = a_other.backing_pixel and
				save_under = a_other.save_under and
				event_mask = a_other.event_mask and
				do_not_propagate_mask = a_other.do_not_propagate_mask and
				override_redirect = a_other.override_redirect and
				colormap = a_other.colormap and
				cursor = a_other.cursor
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("background_pixmap"),
					create {CE_STRUCTURE_FIELD}.make ("background_pixel"),
					create {CE_STRUCTURE_FIELD}.make ("border_pixmap"),
					create {CE_STRUCTURE_FIELD}.make ("border_pixel"),
					create {CE_STRUCTURE_FIELD}.make ("bit_gravity"),
					create {CE_STRUCTURE_FIELD}.make ("win_gravity"),
					create {CE_STRUCTURE_FIELD}.make ("backing_store"),
					create {CE_STRUCTURE_FIELD}.make ("backing_planes"),
					create {CE_STRUCTURE_FIELD}.make ("backing_pixel"),
					create {CE_STRUCTURE_FIELD}.make ("save_under"),
					create {CE_STRUCTURE_FIELD}.make ("event_mask"),
					create {CE_STRUCTURE_FIELD}.make ("do_not_propagate_mask"),
					create {CE_STRUCTURE_FIELD}.make ("override_redirect"),
					create {CE_STRUCTURE_FIELD}.make ("colormap"),
					create {CE_STRUCTURE_FIELD}.make ("cursor")
				>>)
			init_structure_info
		end

end
