class
	P_CH_STATIC

inherit
	CE_UTILITIES
	S_UNISTD_STATIC
	S_STDLIB_STATIC

feature {ANY} -- public attributes

	ignore_eoi: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	thisfile: CE_STATIC [CE_POINTER [PD_FILESTATE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_FILESTATE]}.make
		end

	ch_ungotchar: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	maxbufs: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	autobuf: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	sigs: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	tried: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	fch_get: INTEGER_32
		local
			l_bp: CE_POINTER [PD_BUF]
			l_n: INTEGER_32
			l_slept: INTEGER_32
			l_h: INTEGER_32
			l_pos2: INTEGER_32
			l_len: INTEGER_32
			l_parg: CE_ARRAY [PD_PARG]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_PARG]} l_parg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_slept := 0
					l_h := ((thisfile.item.item.block).bit_and (63)).to_integer_32
					l_bp := thisfile.item.item.hashtbl[l_h].buf_hnext
				when 1 then -- loop condition:
					if l_bp.is_equal (create {CE_CLASS_POINTER [PD_BUFLIST]}.make_shared (thisfile.item.c_pointer + (create {PD_FILESTATE}.make).offset_of ("hashtbl") + (create {PD_BUFLIST}.make).structure_size * (l_h))) then
						l_pos := -1 + 6 -- skip loop
					end
				when 2 then -- loop body:
						if l_bp.item.block /= thisfile.item.item.block then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if thisfile.item.item.offset >= l_bp.item.datasize then
							l_pos := -1 + 19 -- goto read_more
						end
				when 4 then
						l_pos := -1 + 20 -- goto found
				when 5 then
						l_bp := l_bp.item.hnext
						l_pos := -1 + 1 -- back to loop condition
				when 6 then -- loop done
					if not ((thisfile.item.item.buf_prev).is_equal (create {CE_POINTER_POINTER [PD_BUF]}.make_shared (thisfile.item.c_pointer + (create {PD_FILESTATE}.make).offset_of ("buf_next")))) then
						l_pos := -1 + 9 -- skip if block
					end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___2
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 9 then -- else:
						if (thisfile.item.item.buf_prev).item.block = -1 then
							l_pos := -1 + 18 -- skip if block
						end
				when 10 then -- if: | _L___2:
						if not ((autobuf.item.item).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if not ((thisfile.item.item.flags).bit_and (1)).to_boolean then
							l_pos := -1 + 17 -- goto _L___0
						else
							l_pos := -1 + 13 -- goto _L___1
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 13 then -- else: | _L___1:
						if not (maxbufs.item < 0) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if not (thisfile.item.item.nbufs < maxbufs.item) then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L___0:
						if (ch_addbuf).to_boolean then
							autobuf.item.item := 0
						end
				when 18 then -- if done | if done | if done | if done
					l_bp := thisfile.item.item.buf_prev;
					(l_bp.item.hnext).item.hprev := l_bp.item.hprev;
					(l_bp.item.hprev).item.hnext := l_bp.item.hnext
					l_bp.item.block := thisfile.item.item.block
					l_bp.item.datasize := {NATURAL_32} 0
					l_bp.item.hnext := thisfile.item.item.hashtbl[l_h].buf_hnext
					l_bp.item.hprev := create {CE_CLASS_POINTER [PD_BUF]}.make_cast ((create {CE_CLASS_POINTER [PD_BUFLIST]}.make_shared (thisfile.item.c_pointer + (create {PD_FILESTATE}.make).offset_of ("hashtbl") + (create {PD_BUFLIST}.make).structure_size * (l_h))));
					(thisfile.item.item.hashtbl[l_h].buf_hnext).item.hprev := l_bp
					thisfile.item.item.hashtbl[l_h].buf_hnext := l_bp
				when 19 then -- read_more:
					l_pos2 := ((thisfile.item.item.block * 8_192).to_natural_32 + (l_bp.item.datasize).to_natural_32).to_integer_32
					l_len := ch_length
					if l_len /= -1 then
						if l_pos2 >= l_len then
							Result := (-1)
							l_return := True
						end
					end
					if not l_return and then (l_pos2 /= thisfile.item.item.fpos) then
						if not ((thisfile.item.item.flags).bit_and (1)).to_boolean then
							Result := (('?').code)
							l_return := True
						end
						if not l_return then
							if (lseek (thisfile.item.item.file, l_pos2, 0)) = -1 then
								(create {P_OUTPUT_STATIC}).error (ce_string ("seek error"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer));
								(create {P_SCREEN_STATIC}).clear_eol
								Result := (-1)
								l_return := True
							end
						end
						if not l_return then
							thisfile.item.item.fpos := l_pos2
						end
					end
					if not l_return then
						if ch_ungotchar.item /= -1 then
							l_bp.item.data[(l_bp.item.datasize).to_integer_32] := ch_ungotchar.item.to_natural_8
							l_n := 1
							ch_ungotchar.item := -1
						elseif ((thisfile.item.item.flags).bit_and (8)).to_boolean then
							l_bp.item.data[(l_bp.item.datasize).to_integer_32] := ((create {P_HELP_STATIC}).helpdata.item[thisfile.item.item.fpos]).to_natural_8
							l_n := 1
						else
							l_n := (create {P_OS_STATIC}).iread (thisfile.item.item.file, create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_NATURAL_8_POINTER}.make_shared (l_bp.c_pointer + (create {PD_BUF}.make).offset_of ("data") + {PLATFORM}.Natural_8_bytes * ((l_bp.item.datasize).to_integer_32)))), {NATURAL_32} 8_192 - l_bp.item.datasize)
						end
						if l_n = -2 then
							Result := (-1)
							l_return := True
						end
					end
					if not l_return then
						if l_n < 0 then
							(create {P_OUTPUT_STATIC}).error (ce_string ("read error"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer));
							(create {P_SCREEN_STATIC}).clear_eol
							l_n := 0
						end
						if not ((create {P_MAIN_STATIC}).secure.item).to_boolean then
							if (create {P_MAIN_STATIC}).logfile.item >= 0 then
								if l_n > 0 then
									write ((create {P_MAIN_STATIC}).logfile.item, create {CE_VOID_POINTER}.make_cast ((create {CE_NATURAL_8_POINTER}.make_shared (l_bp.c_pointer + (create {PD_BUF}.make).offset_of ("data") + {PLATFORM}.Natural_8_bytes * ((l_bp.item.datasize).to_integer_32)))), l_n.to_natural_32).do_nothing
								end
							end
						end
						thisfile.item.item.fpos := thisfile.item.item.fpos + l_n.to_integer_32
						l_bp.item.datasize := l_bp.item.datasize + l_n.to_natural_32
						if l_n = 0 then
							thisfile.item.item.fsize := l_pos2
							if ignore_eoi.item.to_boolean then
								if not l_slept.to_boolean then
									l_parg.item.p_string := (create {P_PROMPT_STATIC}).wait_message;
									(create {P_OUTPUT_STATIC}).ierror (ce_string ("%%s"), l_parg)
								end
								sleep ({NATURAL_32} 1).do_nothing
								l_slept := 1
							end
							if sigs.item.to_boolean then
								Result := (-1)
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 22 -- skip if block
					end
				when 20 then -- if: | found:
						if not (thisfile.item.item.buf_next).is_equal (l_bp) then
							(l_bp.item.next).item.prev := l_bp.item.prev;
							(l_bp.item.prev).item.next := l_bp.item.next
							l_bp.item.next := thisfile.item.item.buf_next
							l_bp.item.prev := create {CE_CLASS_POINTER [PD_BUF]}.make_cast ((create {CE_POINTER_POINTER [PD_BUF]}.make_shared (thisfile.item.c_pointer + (create {PD_FILESTATE}.make).offset_of ("buf_next"))));
							(thisfile.item.item.buf_next).item.prev := l_bp
							thisfile.item.item.buf_next := l_bp;
							(l_bp.item.hnext).item.hprev := l_bp.item.hprev;
							(l_bp.item.hprev).item.hnext := l_bp.item.hnext
							l_bp.item.hnext := thisfile.item.item.hashtbl[l_h].buf_hnext
							l_bp.item.hprev := create {CE_CLASS_POINTER [PD_BUF]}.make_cast ((create {CE_CLASS_POINTER [PD_BUFLIST]}.make_shared (thisfile.item.c_pointer + (create {PD_FILESTATE}.make).offset_of ("hashtbl") + (create {PD_BUFLIST}.make).structure_size * (l_h))));
							(thisfile.item.item.hashtbl[l_h].buf_hnext).item.hprev := l_bp
							thisfile.item.item.hashtbl[l_h].buf_hnext := l_bp
						end
						if thisfile.item.item.offset >= l_bp.item.datasize then
							l_pos := -1 + 19 -- goto read_more
						end
				when 21 then
						Result := (l_bp.item.data[(thisfile.item.item.offset).to_integer_32]).to_integer_32
				when 22 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ch_ungetchar (a_c: INTEGER_32)
		do
			if a_c /= -1 then
				if ch_ungotchar.item /= -1 then
					(create {P_OUTPUT_STATIC}).error (ce_string ("ch_ungetchar overrun"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
				end
			end
			ch_ungotchar.item := a_c
		end

	end_logfile
		local
			l_return, l_break: BOOLEAN
		do
			if (create {P_MAIN_STATIC}).logfile.item < 0 then
				l_return := True
			end
			if not l_return then
				if not tried.item.to_boolean then
					if thisfile.item.item.fsize = -1 then
						tried.item := 1;
						(create {P_OUTPUT_STATIC}).ierror (ce_string ("Finishing logfile"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						from
						until
							(l_break)
						loop
							l_break := False
							if (ch_forw_get) = -1 then
								l_break := True
							end
							if not (l_break) and then (((sigs.item).bit_and (3)).to_boolean) then
								l_break := True
							end
						end
						l_break := False
					end
				end
				close ((create {P_MAIN_STATIC}).logfile.item).do_nothing;
				(create {P_MAIN_STATIC}).logfile.item := -1;
				(create {P_MAIN_STATIC}).namelogfile.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			end
		end

	sync_logfile
		local
			l_bp: CE_POINTER [PD_BUF]
			l_warned: INTEGER_32
			l_block: INTEGER_32
			l_nblocks: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_warned := 0
			l_nblocks := ((thisfile.item.item.fpos + 8_192) - 1) // 8_192
			l_block := (0).to_integer_32
			from
			until
				not (not (l_return) and then (l_block < l_nblocks))
			loop
				l_bp := thisfile.item.item.buf_next
				from
				until
					(l_break)
				loop
					l_break := False
					if l_bp.is_equal (create {CE_POINTER_POINTER [PD_BUF]}.make_shared (thisfile.item.c_pointer + (create {PD_FILESTATE}.make).offset_of ("buf_next"))) then
						if not l_warned.to_boolean then
							(create {P_OUTPUT_STATIC}).error (ce_string ("Warning: log file is incomplete"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_warned := 1
						end
						l_break := True
					end
					if not (l_break) and then (l_bp.item.block = l_block) then
						write ((create {P_MAIN_STATIC}).logfile.item, create {CE_VOID_POINTER}.make_cast ((l_bp.item.data)), l_bp.item.datasize).do_nothing
						l_break := True
					end
					if not (l_break) then
						l_bp := l_bp.item.next
					end
				end
				l_break := False
				l_block := l_block + 1
			end
		end

	buffered (a_block: INTEGER_32): INTEGER_32
		local
			l_bp: CE_POINTER [PD_BUF]
			l_h: INTEGER_32
			l_return: BOOLEAN
		do
			l_h := ((a_block).bit_and (63)).to_integer_32
			l_bp := thisfile.item.item.hashtbl[l_h].buf_hnext
			from
			until
				not (not (l_return) and then (not l_bp.is_equal (create {CE_CLASS_POINTER [PD_BUFLIST]}.make_shared (thisfile.item.c_pointer + (create {PD_FILESTATE}.make).offset_of ("hashtbl") + (create {PD_BUFLIST}.make).structure_size * (l_h)))))
			loop
				if l_bp.item.block = a_block then
					Result := 1
					l_return := True
				end
				if not l_return then
					l_bp := l_bp.item.hnext
				end
			end
			if not l_return then
				Result := 0
			end
		end

	ch_seek (a_pos: INTEGER_32): INTEGER_32
		local
			l_new_block: INTEGER_32
			l_len: INTEGER_32
			l_return: BOOLEAN
		do
			l_len := ch_length
			if a_pos < 0 then
				Result := 1
				l_return := True
			elseif l_len /= -1 then
				if a_pos > l_len then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				l_new_block := a_pos // 8_192
				if not ((thisfile.item.item.flags).bit_and (1)).to_boolean then
					if a_pos /= thisfile.item.item.fpos then
						if not (buffered (l_new_block)).to_boolean then
							if thisfile.item.item.fpos > a_pos then
								Result := 1
								l_return := True
							end
							if not l_return then
								from
								until
									not (not (l_return) and then (thisfile.item.item.fpos < a_pos))
								loop
									if (ch_forw_get) = -1 then
										Result := 1
										l_return := True
									end
									if not l_return and then (((sigs.item).bit_and (3)).to_boolean) then
										Result := 1
										l_return := True
									end
								end
							end
							if not l_return then
								Result := 0
								l_return := True
							end
						end
					end
				end
			end
			if not l_return then
				thisfile.item.item.block := l_new_block
				thisfile.item.item.offset := (a_pos \\ 8_192).to_natural_32
				Result := 0
			end
		end

	ch_end_seek: INTEGER_32
		local
			l_len: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if ((thisfile.item.item.flags).bit_and (1)).to_boolean then
				thisfile.item.item.fsize := (create {P_FILENAME_STATIC}).filesize (thisfile.item.item.file)
			end
			l_len := ch_length
			if l_len /= -1 then
				Result := (ch_seek (l_len))
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if (ch_forw_get) = -1 then
						l_break := True
					end
					if not (l_return or l_break) and then (((sigs.item).bit_and (3)).to_boolean) then
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 0
			end
		end

	ch_beg_seek: INTEGER_32
		local
			l_bp: CE_POINTER [PD_BUF]
			l_firstbp: CE_POINTER [PD_BUF]
			l_return, l_break: BOOLEAN
		do
			if (ch_seek ((0).to_integer_32)) = 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_bp := thisfile.item.item.buf_next
				l_firstbp := l_bp
				if l_bp.is_equal (create {CE_POINTER_POINTER [PD_BUF]}.make_shared (thisfile.item.c_pointer + (create {PD_FILESTATE}.make).offset_of ("buf_next"))) then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					l_bp := l_bp.item.next
					if l_bp.is_equal (create {CE_POINTER_POINTER [PD_BUF]}.make_shared (thisfile.item.c_pointer + (create {PD_FILESTATE}.make).offset_of ("buf_next"))) then
						l_break := True
					end
					if not (l_break) and then (l_bp.item.block < l_firstbp.item.block) then
						l_firstbp := l_bp
					end
				end
				l_break := False
				thisfile.item.item.block := l_firstbp.item.block
				thisfile.item.item.offset := {NATURAL_32} 0
				Result := 0
			end
		end

	ch_length: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ignore_eoi.item.to_boolean then
				Result := (-1).to_integer_32
				l_return := True
			end
			if not l_return and then (((thisfile.item.item.flags).bit_and (8)).to_boolean) then
				Result := ((create {P_HELP_STATIC}).size_helpdata.item).to_integer_32
				l_return := True
			end
			if not l_return then
				Result := (thisfile.item.item.fsize)
			end
		end

	ch_tell: INTEGER_32
		do
			Result := ((thisfile.item.item.block * 8_192).to_natural_32 + (thisfile.item.item.offset).to_natural_32).to_integer_32
		end

	ch_forw_get: INTEGER_32
		local
			l_c: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			if thisfile.item.item.block = (thisfile.item.item.buf_next).item.block then
				if thisfile.item.item.offset < (thisfile.item.item.buf_next).item.datasize then
					l_c := ((thisfile.item.item.buf_next).item.data[(thisfile.item.item.offset).to_integer_32]).to_integer_32
				else
					l_tmp := fch_get
					l_c := l_tmp
				end
			else
				l_tmp := fch_get
				l_c := l_tmp
			end
			if l_c = -1 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if thisfile.item.item.offset < {NATURAL_32} 8_191 then
					thisfile.item.item.offset := (thisfile.item.item.offset) + 1
				else
					thisfile.item.item.block := (thisfile.item.item.block) + 1
					thisfile.item.item.offset := {NATURAL_32} 0
				end
				Result := l_c
			end
		end

	ch_back_get: INTEGER_32
		local
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			if thisfile.item.item.offset > {NATURAL_32} 0 then
				thisfile.item.item.offset := (thisfile.item.item.offset) - 1
			else
				if thisfile.item.item.block <= 0 then
					Result := (-1)
					l_return := True
				end
				if not l_return and then (not ((thisfile.item.item.flags).bit_and (1)).to_boolean) then
					if not (buffered (thisfile.item.item.block - 1)).to_boolean then
						Result := (-1)
						l_return := True
					end
				end
				if not l_return then
					thisfile.item.item.block := (thisfile.item.item.block) - 1
					thisfile.item.item.offset := {NATURAL_32} 8_191
				end
			end
			if not l_return then
				if thisfile.item.item.block = (thisfile.item.item.buf_next).item.block then
					if thisfile.item.item.offset < (thisfile.item.item.buf_next).item.datasize then
						l_tmp___1 := ((thisfile.item.item.buf_next).item.data[(thisfile.item.item.offset).to_integer_32]).to_integer_32
					else
						l_tmp___0 := fch_get
						l_tmp___1 := l_tmp___0
					end
				else
					l_tmp___0 := fch_get
					l_tmp___1 := l_tmp___0
				end
				Result := l_tmp___1
			end
		end

	ch_setbufspace (a_bufspace___0: INTEGER_32)
		do
			if a_bufspace___0 < 0 then
				maxbufs.item := -1
			else
				maxbufs.item := ((a_bufspace___0 * 1_024 + 8_192) - 1) // 8_192
				if maxbufs.item < 1 then
					maxbufs.item := 1
				end
			end
		end

	ch_flush
		local
			l_bp: CE_POINTER [PD_BUF]
			l_return: BOOLEAN
		do
			if not ((thisfile.item.item.flags).bit_and (1)).to_boolean then
				thisfile.item.item.fsize := (-1).to_integer_32
				l_return := True
			end
			if not l_return then
				l_bp := thisfile.item.item.buf_next
				from
				until
					l_bp.is_equal (create {CE_POINTER_POINTER [PD_BUF]}.make_shared (thisfile.item.c_pointer + (create {PD_FILESTATE}.make).offset_of ("buf_next")))
				loop
					l_bp.item.block := (-1).to_integer_32
					l_bp := l_bp.item.next
				end
				thisfile.item.item.fsize := (create {P_FILENAME_STATIC}).filesize (thisfile.item.item.file)
				thisfile.item.item.fpos := (0).to_integer_32
				thisfile.item.item.block := (0).to_integer_32
				thisfile.item.item.offset := {NATURAL_32} 0
				if thisfile.item.item.fsize = 0 then
					thisfile.item.item.fsize := (-1).to_integer_32
					thisfile.item.item.flags := (thisfile.item.item.flags).bit_and ((-2))
				end
				if (lseek (thisfile.item.item.file, (0).to_integer_32, 0)) = -1 then
					(create {P_OUTPUT_STATIC}).error (ce_string ("seek error to 0"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
				end
			end
		end

	ch_addbuf: INTEGER_32
		local
			l_bp: CE_POINTER [PD_BUF]
			l_return: BOOLEAN
		do
			l_bp := create {CE_CLASS_POINTER [PD_BUF]}.make_cast ((calloc ((1).to_natural_32, (create {PD_BUF}.make).structure_size.to_natural_32)))
			if l_bp.is_void then
				Result := 1
				l_return := True
			end
			if not l_return then
				thisfile.item.item.nbufs := (thisfile.item.item.nbufs) + 1
				l_bp.item.block := (-1).to_integer_32
				l_bp.item.next := create {CE_CLASS_POINTER [PD_BUF]}.make_cast ((create {CE_POINTER_POINTER [PD_BUF]}.make_shared (thisfile.item.c_pointer + (create {PD_FILESTATE}.make).offset_of ("buf_next"))))
				l_bp.item.prev := thisfile.item.item.buf_prev;
				(thisfile.item.item.buf_prev).item.next := l_bp
				thisfile.item.item.buf_prev := l_bp
				l_bp.item.hnext := thisfile.item.item.hashtbl[0].buf_hnext
				l_bp.item.hprev := create {CE_CLASS_POINTER [PD_BUF]}.make_cast ((create {CE_CLASS_POINTER [PD_BUFLIST]}.make_shared (thisfile.item.c_pointer + (create {PD_FILESTATE}.make).offset_of ("hashtbl") + (create {PD_BUFLIST}.make).structure_size * (0))));
				(thisfile.item.item.hashtbl[0].buf_hnext).item.hprev := l_bp
				thisfile.item.item.hashtbl[0].buf_hnext := l_bp
				Result := 0
			end
		end

	init_hashtbl
		local
			l_h: INTEGER_32
		do
			l_h := 0
			from
			until
				not (l_h < 64)
			loop
				thisfile.item.item.hashtbl[l_h].buf_hnext := create {CE_CLASS_POINTER [PD_BUF]}.make_cast ((create {CE_CLASS_POINTER [PD_BUFLIST]}.make_shared (thisfile.item.c_pointer + (create {PD_FILESTATE}.make).offset_of ("hashtbl") + (create {PD_BUFLIST}.make).structure_size * (l_h))))
				thisfile.item.item.hashtbl[l_h].buf_hprev := create {CE_CLASS_POINTER [PD_BUF]}.make_cast ((create {CE_CLASS_POINTER [PD_BUFLIST]}.make_shared (thisfile.item.c_pointer + (create {PD_FILESTATE}.make).offset_of ("hashtbl") + (create {PD_BUFLIST}.make).structure_size * (l_h))))
				l_h := l_h + 1
			end
		end

	ch_delbufs
		local
			l_bp: CE_POINTER [PD_BUF]
		do
			from
			until
				(thisfile.item.item.buf_next).is_equal (create {CE_POINTER_POINTER [PD_BUF]}.make_shared (thisfile.item.c_pointer + (create {PD_FILESTATE}.make).offset_of ("buf_next")))
			loop
				l_bp := thisfile.item.item.buf_next;
				(l_bp.item.next).item.prev := l_bp.item.prev;
				(l_bp.item.prev).item.next := l_bp.item.next
				free (create {CE_VOID_POINTER}.make_cast (l_bp))
			end
			thisfile.item.item.nbufs := 0
			init_hashtbl
		end

	seekable (a_f: INTEGER_32): INTEGER_32
		do
			Result := ((lseek (a_f, (1).to_integer_32, 0)) /= -1).to_integer
		end

	ch_init (a_f, a_flags: INTEGER_32)
		local
			l_tmp___1: CE_POINTER [PD_BUF]
		do
			thisfile.item := create {CE_CLASS_POINTER [PD_FILESTATE]}.make_cast (((create {P_IFILE_STATIC}).get_filestate ((create {P_MAIN_STATIC}).curr_ifile.item)))
			if thisfile.item.is_void then
				thisfile.item := create {CE_CLASS_POINTER [PD_FILESTATE]}.make_cast ((calloc ((1).to_natural_32, (create {PD_FILESTATE}.make).structure_size.to_natural_32)))
				l_tmp___1 := create {CE_CLASS_POINTER [PD_BUF]}.make_cast ((create {CE_POINTER_POINTER [PD_BUF]}.make_shared (thisfile.item.c_pointer + (create {PD_FILESTATE}.make).offset_of ("buf_next"))))
				thisfile.item.item.buf_prev := l_tmp___1
				thisfile.item.item.buf_next := l_tmp___1
				thisfile.item.item.nbufs := 0
				thisfile.item.item.flags := 0
				thisfile.item.item.fpos := (0).to_integer_32
				thisfile.item.item.block := (0).to_integer_32
				thisfile.item.item.offset := {NATURAL_32} 0
				thisfile.item.item.file := -1
				thisfile.item.item.fsize := (-1).to_integer_32
				thisfile.item.item.flags := a_flags
				init_hashtbl
				if ((a_flags).bit_and (1)).to_boolean then
					if not (seekable (a_f)).to_boolean then
						thisfile.item.item.flags := (thisfile.item.item.flags).bit_and ((-2))
					end
				end
				(create {P_IFILE_STATIC}).set_filestate ((create {P_MAIN_STATIC}).curr_ifile.item, create {CE_VOID_POINTER}.make_cast (thisfile.item))
			end
			if thisfile.item.item.file = -1 then
				thisfile.item.item.file := a_f
			end
			ch_flush
		end

	ch_close
		local
			l_keepstate: INTEGER_32
		do
			l_keepstate := 0
			if ((thisfile.item.item.flags).bit_and (13)).to_boolean then
				ch_delbufs
			else
				l_keepstate := 1
			end
			if not ((thisfile.item.item.flags).bit_and (2)).to_boolean then
				if not ((thisfile.item.item.flags).bit_and (12)).to_boolean then
					close (thisfile.item.item.file).do_nothing
				end
				thisfile.item.item.file := -1
			else
				l_keepstate := 1
			end
			if not l_keepstate.to_boolean then
				free (create {CE_VOID_POINTER}.make_cast (thisfile.item))
				thisfile.item := create {CE_CLASS_POINTER [PD_FILESTATE]}.make_shared (default_pointer);
				(create {P_IFILE_STATIC}).set_filestate ((create {P_MAIN_STATIC}).curr_ifile.item, create {CE_VOID_POINTER}.make_shared (default_pointer))
			end
		end

	ch_getflags: INTEGER_32
		do
			Result := (thisfile.item.item.flags)
		end

feature {ANY} -- routine addresses

	ch_forw_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ch_forw_get)
		end

	ch_back_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ch_back_get)
		end

end
