class
	P_COMMAND_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_CTYPE_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	quit_at_eof: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	quit_if_one_screen: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	hit_eof: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	swindow: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	top_scroll: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	hshift: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	show_attn: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	screen_trashed: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	shift_count: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	ungot: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<100>>)
		end

	ungotp: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
		end

	shellcmd: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
		end

	mca: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	search_type: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	number: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	optchar: CE_STATIC [INTEGER_8]
		once ("PROCESS")
		end

	optflag: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	optgetname: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	bottompos: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	pipec: CE_STATIC [INTEGER_8]
		once ("PROCESS")
		end

feature {ANY} -- public routines

	cmd_exec
		do
			(create {P_SEARCH_STATIC}).clear_attn;
			(create {P_SCREEN_STATIC}).lower_left;
			(create {P_OUTPUT_STATIC}).flush
		end

	start_mca (a_action: INTEGER_32; a_prompt___0: CE_POINTER [INTEGER_8]; a_mlist: CE_POINTER [ANY]; a_cmdflags: INTEGER_32)
		require
			not a_prompt___0.is_void
		do
			mca.item := a_action;
			(create {P_CMDBUF_STATIC}).clear_cmd;
			(create {P_CMDBUF_STATIC}).cmd_putstr (a_prompt___0);
			(create {P_CMDBUF_STATIC}).set_mlist (a_mlist, a_cmdflags)
		end

	in_mca: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if mca.item /= 0 then
				if mca.item /= 22 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	mca_search
		do
			if ((search_type.item).bit_and (1)).to_boolean then
				mca.item := 15
			else
				mca.item := 5
			end
			(create {P_CMDBUF_STATIC}).clear_cmd
			if ((search_type.item).bit_and (64)).to_boolean then
				(create {P_CMDBUF_STATIC}).cmd_putstr (ce_string ("Non-match "))
			end
			if ((search_type.item).bit_and (256)).to_boolean then
				(create {P_CMDBUF_STATIC}).cmd_putstr (ce_string ("First-file "))
			end
			if ((search_type.item).bit_and (128)).to_boolean then
				(create {P_CMDBUF_STATIC}).cmd_putstr (ce_string ("EOF-ignore "))
			end
			if ((search_type.item).bit_and (4)).to_boolean then
				(create {P_CMDBUF_STATIC}).cmd_putstr (ce_string ("Keep-pos "))
			end
			if ((search_type.item).bit_and (512)).to_boolean then
				(create {P_CMDBUF_STATIC}).cmd_putstr (ce_string ("Regex-off "))
			end
			if ((search_type.item).bit_and (1)).to_boolean then
				(create {P_CMDBUF_STATIC}).cmd_putstr (ce_string ("/"))
			else
				(create {P_CMDBUF_STATIC}).cmd_putstr (ce_string ("?"))
			end
			(create {P_CMDBUF_STATIC}).set_mlist ((create {P_CMDBUF_STATIC}).ml_search.item, 0)
		end

	mca_opt_toggle
		local
			l_no_prompt: INTEGER_32
			l_flag: INTEGER_32
			l_dash: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_no_prompt := (optflag.item).bit_and (64)
					l_flag := (optflag.item).bit_and (-65)
					if l_flag = 0 then
						l_dash := ce_string ("_")
					else
						l_dash := ce_string ("-")
					end
					mca.item := 47;
					(create {P_CMDBUF_STATIC}).clear_cmd;
					(create {P_CMDBUF_STATIC}).cmd_putstr (l_dash)
					if optgetname.item.to_boolean then
						(create {P_CMDBUF_STATIC}).cmd_putstr (l_dash)
					end
					if l_no_prompt.to_boolean then
						(create {P_CMDBUF_STATIC}).cmd_putstr (ce_string ("(P)"))
					end
					inspect l_flag -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2;
					(create {P_CMDBUF_STATIC}).cmd_putstr (ce_string ("+"))
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 3;
					(create {P_CMDBUF_STATIC}).cmd_putstr (ce_string ("!"))
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:;
					(create {P_CMDBUF_STATIC}).set_mlist (create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	exec_mca
		local
			l_cbuf: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					cmd_exec
					l_cbuf := (create {P_CMDBUF_STATIC}).get_cmdbuf
					inspect mca.item -- switch 1 head
					when 15 then l_pos := -1 + 1
					when 5 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					when 47 then l_pos := -1 + 3
					when 35 then l_pos := -1 + 4
					when 36 then l_pos := -1 + 5
					when 9 then l_pos := -1 + 6
					when 27 then l_pos := -1 + 8
					when 37 then l_pos := -1 + 10
					else l_pos := -1 + 12
					end
				when 1 then -- switch 1, case 15 | switch 1, case 5
					multi_search (l_cbuf, number.item.to_integer_32)
					l_pos := -1 + 12 -- switch 1; break
				when 2 then -- switch 1, case 10
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_cbuf[0]).to_integer_32 /= 43 then
							if (l_cbuf[0]).to_integer_32 /= 32 then
								l_break := True
							end
						end
						if not (l_break) then
							l_cbuf := l_cbuf + 1
						end
					end
					l_break := False
					if not ((create {P_MAIN_STATIC}).every_first_cmd.item).is_void then
						free (create {CE_VOID_POINTER}.make_cast ((create {P_MAIN_STATIC}).every_first_cmd.item))
					end
					if (l_cbuf[0]).to_integer_32 = 0 then
						(create {P_MAIN_STATIC}).every_first_cmd.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					else
						(create {P_MAIN_STATIC}).every_first_cmd.item := (create {P_MAIN_STATIC}).save (l_cbuf)
					end
					l_pos := -1 + 12 -- switch 1; break
				when 3 then -- switch 1, case 47;
					(create {P_OPTION_STATIC}).toggle_option (optchar.item.to_integer_32, l_cbuf, optflag.item)
					optchar.item := (('%/0/').code).to_integer_8
					l_pos := -1 + 12 -- switch 1; break
				when 4 then -- switch 1, case 35;
					(create {P_BRAC_STATIC}).match_brac ((l_cbuf[0]).to_integer_32, (l_cbuf[1]).to_integer_32, 1, number.item.to_integer_32)
					l_pos := -1 + 12 -- switch 1; break
				when 5 then -- switch 1, case 36;
					(create {P_BRAC_STATIC}).match_brac ((l_cbuf[1]).to_integer_32, (l_cbuf[0]).to_integer_32, 0, number.item.to_integer_32)
					l_pos := -1 + 12 -- switch 1; break
				when 6 then -- switch 1, case 9
					if ((create {P_MAIN_STATIC}).secure.item).to_boolean then
						l_pos := -1 + 12 -- switch 1; break
					end
				when 7 then;
					(create {P_EDIT_STATIC}).edit_list (l_cbuf).do_nothing;
					(create {P_TAGS_STATIC}).cleantags
					l_pos := -1 + 12 -- switch 1; break
				when 8 then -- switch 1, case 27
					if (l_cbuf[0]).to_integer_32 /= 33 then
						if not shellcmd.item.is_void then
							free (create {CE_VOID_POINTER}.make_cast (shellcmd.item))
						end
						shellcmd.item := (create {P_FILENAME_STATIC}).fexpand (l_cbuf)
					end
					if ((create {P_MAIN_STATIC}).secure.item).to_boolean then
						l_pos := -1 + 12 -- switch 1; break
					end
				when 9 then
					if shellcmd.item.is_void then
						(create {P_LSYSTEM_STATIC}).lsystem (ce_string (""), ce_string ("!done"))
					else
						(create {P_LSYSTEM_STATIC}).lsystem (shellcmd.item, ce_string ("!done"))
					end
					l_pos := -1 + 12 -- switch 1; break
				when 10 then -- switch 1, case 37
					if ((create {P_MAIN_STATIC}).secure.item).to_boolean then
						l_pos := -1 + 12 -- switch 1; break
					end
				when 11 then;
					(create {P_LSYSTEM_STATIC}).pipe_mark (pipec.item.to_integer_32, l_cbuf).do_nothing;
					(create {P_OUTPUT_STATIC}).error (ce_string ("|done"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
					l_pos := -1 + 12 -- switch 1; break
				when 12 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mca_char (a_c: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			l_p: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_flag: INTEGER_32
			l_buf___1: CE_ARRAY [INTEGER_8]
			l_parg: CE_ARRAY [PD_PARG]
			l_o: CE_POINTER [PD_LOPTION]
			l_oname: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_lc: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_p.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_buf___1.make (<<3>>)
			create {CE_CLASS_ARRAY [PD_PARG]} l_parg.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_oname.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_c
					inspect mca.item -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 22 then l_pos := -1 + 2
					when 6 then l_pos := -1 + 3
					when 47 then l_pos := -1 + 10
					when 15 then l_pos := -1 + 34
					when 5 then l_pos := -1 + 34
					else l_pos := -1 + 44
					end
				when 1 then -- switch 1, case 0
					Result := 0
					l_return := True
				when 2 then -- switch 1, case 22
					if not l_return then
						Result := 0
						l_return := True
					end
				when 3 then -- switch 1, case 6
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 4 then -- if:
						if not (l_c < 48) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if not (l_c > 57) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if ((create {P_DECODE_STATIC}).editchar (l_c, 15)) = 100 then
							number.item := (create {P_CMDBUF_STATIC}).cmd_int
							mca.item := 0;
							(create {P_CMDBUF_STATIC}).cmd_accept
							Result := 0
							l_return := True
						end
				when 9 then -- if done | if done
					l_pos := -1 + 44 -- switch 1; break
				when 10 then -- switch 1, case 47
					if optchar.item.to_integer_32 /= 0 then
						l_pos := -1 + 21 -- skip if block
					end
				when 11 then -- if:
						if ((create {P_CMDBUF_STATIC}).len_cmdbuf) /= 0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 12 then -- if:
						l_flag := (optflag.item).bit_and (-65)
						if l_flag /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 13 then -- if:
						inspect l_c -- switch 2 head
						when 95 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 14 then -- switch 2, case 95
						optgetname.item := 1
						mca_opt_toggle
						Result := 2
						l_return := True
				when 15 then -- switch 2, done: | if block done, skip else block:
						l_pos := -1 + 21
				when 16 then -- else:
						inspect l_c -- switch 3 head
						when 43 then l_pos := -1 + 17
						when 33 then l_pos := -1 + 18
						when 16 then l_pos := -1 + 19
						when 45 then l_pos := -1 + 20
						else l_pos := -1 + 21
						end
				when 17 then -- switch 3, case 43
						if l_flag = 2 then
							optflag.item := 1
						else
							optflag.item := 2
						end
						mca_opt_toggle
						Result := 2
						l_return := True
				when 18 then -- switch 3, case 33
						if not l_return then
							if l_flag = 3 then
								optflag.item := 1
							else
								optflag.item := 3
							end
							mca_opt_toggle
							Result := 2
							l_return := True
						end
				when 19 then -- switch 3, case 16
						if not l_return then
							optflag.item := (optflag.item).bit_xor ((64))
							mca_opt_toggle
							Result := 2
							l_return := True
						end
				when 20 then -- switch 3, case 45
						if not l_return then
							optgetname.item := 1
							mca_opt_toggle
							Result := 2
							l_return := True
						end
				when 21 then -- switch 3, done: | if done | if done | if done
					if l_return then
						l_pos := -1 + 33 -- skip if block
					end
				when 22 then -- if:
						if not (optgetname.item.to_boolean) then
							l_pos := -1 + 31 -- skip if block
						end
				when 23 then -- if:
						if l_c /= 10 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 27 -- goto _L___0
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 26 then -- else:
						if l_c /= 13 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if: | _L___0:
						if optchar.item.to_integer_32 = 0 then
							l_parg.item.p_string := (create {P_CMDBUF_STATIC}).get_cmdbuf;
							(create {P_OUTPUT_STATIC}).error (ce_string ("There is no --%%s option"), l_parg)
							Result := 1
							l_return := True
						end
						if not l_return then
							optgetname.item := 0;
							(create {P_CMDBUF_STATIC}).cmd_reset
							l_c := optchar.item.to_integer_32
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						if optchar.item.to_integer_32 /= 0 then
							if l_c = (create {P_SCREEN_STATIC}).erase_char.item then
								Result := 1
								l_return := True
							elseif l_c = (create {P_SCREEN_STATIC}).kill_char.item then
								Result := 1
								l_return := True
							end
							if not l_return then
								Result := 2
								l_return := True
							end
						end
						if not l_return then
							if ((create {P_CMDBUF_STATIC}).cmd_char (l_c)) = 1 then
								Result := 1
								l_return := True
							end
						end
						if not l_return then
							l_p.item := (create {P_CMDBUF_STATIC}).get_cmdbuf
							l_lc := ((((ctype_b_loc).item[(l_p.item[0]).to_integer_32]).to_integer_32).bit_and (512))
							l_o := (create {P_OPTTBL_STATIC}).findopt_name (l_p, l_oname, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
							if not l_o.is_void then
								optchar.item := l_o.item.oletter
								if not l_lc.to_boolean then
									if ((((ctype_b_loc).item[optchar.item.to_integer_32]).to_integer_32).bit_and (512)).to_boolean then
										optchar.item := (toupper (optchar.item.to_integer_32)).to_integer_8
									end
								end
								(create {P_CMDBUF_STATIC}).cmd_reset
								mca_opt_toggle
								l_p.item := l_oname.item
								from
								until
									not (not (l_return) and then ((l_p.item[0]).to_integer_32 /= 0))
								loop
									l_c := (l_p.item[0]).to_integer_32
									if not l_lc.to_boolean then
										if ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (512)).to_boolean then
											l_c := toupper (l_c)
										end
									end
									if ((create {P_CMDBUF_STATIC}).cmd_char (l_c)) /= 0 then
										Result := 1
										l_return := True
									end
									if not l_return then
										l_p.item := l_p.item + 1
									end
								end
							end
						end
						if not l_return then
							Result := 2
							l_return := True
						end
				when 30 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 33
				when 31 then -- else:
						if l_c = (create {P_SCREEN_STATIC}).erase_char.item then
							l_pos := -1 + 44 -- switch 1; break
						elseif l_c = (create {P_SCREEN_STATIC}).kill_char.item then
							l_pos := -1 + 44 -- switch 1; break
						end
				when 32 then
						if optchar.item.to_integer_32 /= 0 then
							l_pos := -1 + 44 -- switch 1; break
						end
				when 33 then -- if done
					if not l_return then
						optchar.item := l_c.to_integer_8
						if ((optflag.item).bit_and (-65)) /= 1 then
							(create {P_OPTION_STATIC}).toggle_option (l_c, ce_string (""), optflag.item)
							Result := 1
							l_return := True
						elseif ((create {P_OPTION_STATIC}).single_char_option (l_c)).to_boolean then
							(create {P_OPTION_STATIC}).toggle_option (l_c, ce_string (""), optflag.item)
							Result := 1
							l_return := True
						end
					end
					if not l_return then
						l_p.item := (create {P_OPTION_STATIC}).opt_prompt (l_c)
						if (l_p.item).is_void then
							l_buf___1[0] := (('-').code).to_integer_8
							l_buf___1[1] := l_c.to_integer_8
							l_buf___1[2] := (('%/0/').code).to_integer_8
							l_p.item := l_buf___1
						end
						start_mca (47, l_p.item, create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
						Result := 2
						l_return := True
					end
				when 34 then -- switch 1, case 15 | switch 1, case 5
					if l_return then
						l_pos := -1 + 43 -- skip if block
					end
				when 35 then -- if:
						if ((create {P_CMDBUF_STATIC}).len_cmdbuf) > 0 then
							l_pos := -1 + 44 -- switch 1; break
						end
				when 36 then
						l_flag := 0
						inspect l_c -- switch 4 head
						when 5 then l_pos := -1 + 37
						when 42 then l_pos := -1 + 37
						when 6 then l_pos := -1 + 38
						when 64 then l_pos := -1 + 38
						when 11 then l_pos := -1 + 39
						when 18 then l_pos := -1 + 40
						when 14 then l_pos := -1 + 41
						when 33 then l_pos := -1 + 41
						else l_pos := -1 + 42
						end
				when 37 then -- switch 4, case 5 | switch 4, case 42
						l_flag := 128
						l_pos := -1 + 42 -- switch 4; break
				when 38 then -- switch 4, case 6 | switch 4, case 64
						l_flag := 256
						l_pos := -1 + 42 -- switch 4; break
				when 39 then -- switch 4, case 11
						l_flag := 4
						l_pos := -1 + 42 -- switch 4; break
				when 40 then -- switch 4, case 18
						l_flag := 512
						l_pos := -1 + 42 -- switch 4; break
				when 41 then -- switch 4, case 14 | switch 4, case 33
						l_flag := 64
						l_pos := -1 + 42 -- switch 4; break
				when 42 then -- switch 4, done:
						if l_flag /= 0 then
							search_type.item := (search_type.item).bit_xor (l_flag)
							mca_search
							Result := 2
							l_return := True
						end
				when 43 then -- if done
					l_pos := -1 + 44 -- switch 1; break
				when 44 then -- switch 1, done:
					if not l_return then
						if l_c = 10 then
							exec_mca
							Result := 1
							l_return := True
						elseif l_c = 13 then
							exec_mca
							Result := 1
							l_return := True
						end
					end
					if not l_return then
						if ((create {P_CMDBUF_STATIC}).cmd_char (l_c)) = 1 then
							Result := 1
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 50 -- skip if block
					end
				when 45 then -- if:
						if mca.item /= 35 then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						l_pos := -1 + 49 -- goto _L___1
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 48 then -- else:
						if mca.item /= 36 then
							l_pos := -1 + 50 -- skip if block
						end
				when 49 then -- if: | _L___1:
						if ((create {P_CMDBUF_STATIC}).len_cmdbuf) >= 2 then
							exec_mca
							Result := 1
							l_return := True
						end
				when 50 then -- if done | if done
					if not l_return then
						Result := 2
					end
				when 51 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	make_display
		local
			l_save_top_scroll: INTEGER_32
		do
			if ((create {P_POSITION_STATIC}).empty_screen).to_boolean then
				if (create {P_MAIN_STATIC}).initial_scrpos.item.item.pos = -1 then
					(create {P_JUMP_STATIC}).jump_loc ((0).to_integer_32, 1)
				else
					(create {P_JUMP_STATIC}).jump_loc ((create {P_MAIN_STATIC}).initial_scrpos.item.item.pos, (create {P_MAIN_STATIC}).initial_scrpos.item.item.ln)
				end
			elseif screen_trashed.item.to_boolean then
				l_save_top_scroll := top_scroll.item.item
				top_scroll.item.item := 1;
				(create {P_JUMP_STATIC}).repaint
				top_scroll.item.item := l_save_top_scroll
			end
		end

	prompt
		local
			l_p: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ungotp.item.is_void then
						if (ungotp.item.c_pointer.to_integer_32).to_natural_32 > (ungot.item.c_pointer.to_integer_32).to_natural_32 then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						make_display
						bottompos.item := (create {P_POSITION_STATIC}).position (-2)
						if quit_at_eof.item.item /= 2 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not ((quit_if_one_screen.item.item).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if hit_eof.item.to_boolean then
							if not ((((create {P_CH_STATIC}).ch_getflags)).bit_and (8)).to_boolean then
								if ((create {P_IFILE_STATIC}).next_ifile ((create {P_MAIN_STATIC}).curr_ifile.item)).is_void then
									(create {P_MAIN_STATIC}).quit (0)
								end
							end
						end
				when 6 then -- if done
						quit_if_one_screen.item.item := 0;
						(create {P_CMDBUF_STATIC}).clear_cmd
						l_p := (create {P_PROMPT_STATIC}).pr_string
						if l_p.is_void then
							(create {P_OUTPUT_STATIC}).putchr ((':').code).do_nothing
						else
							(create {P_SCREEN_STATIC}).so_enter;
							(create {P_OUTPUT_STATIC}).putstr (l_p);
							(create {P_SCREEN_STATIC}).so_exit
						end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dispversion
		local
			l_parg: CE_ARRAY [PD_PARG]
		do
			create {CE_CLASS_ARRAY [PD_PARG]} l_parg.make (<<1>>)

			l_parg.item.p_string := (create {P_VERSION_STATIC}).version.item;
			(create {P_OUTPUT_STATIC}).error (ce_string ("less %%s"), l_parg)
		end

	getcc: INTEGER_32
		local
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ungotp.item.is_void then
						Result := ((create {P_TTYIN_STATIC}).getchr)
						l_return := True
					end
					if not l_return and then ((ungotp.item.c_pointer.to_integer_32).to_natural_32 > (ungot.item.c_pointer.to_integer_32).to_natural_32) then
						ungotp.item := ungotp.item - 1
						Result := (ungotp.item[0]).to_integer_32
						l_return := True
					end
					if not l_return then
						ungotp.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						if ((create {P_CMDBUF_STATIC}).len_cmdbuf) = 0 then
							l_tmp___0 := (create {P_TTYIN_STATIC}).getchr
							Result := l_tmp___0
							l_return := True
						elseif not ((create {P_POSITION_STATIC}).empty_screen).to_boolean then
							l_tmp___0 := (create {P_TTYIN_STATIC}).getchr
							Result := l_tmp___0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						inspect mca.item -- switch 1 head
						when 6 then l_pos := -1 + 2
						when 15 then l_pos := -1 + 3
						when 5 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 2 then -- switch 1, case 6
						Result := (('g').code)
						l_return := True
				when 3 then -- switch 1, case 15 | switch 1, case 5
						if not l_return then
							Result := (('%N').code)
							l_return := True
						end
				when 4 then -- switch 1, default:
						if not l_return then
							Result := ((create {P_TTYIN_STATIC}).getchr)
						end
				when 5 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ungetcc (a_c: INTEGER_32)
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			if ungotp.item.is_void then
				ungotp.item := ungot.item
			end
			if (ungotp.item.c_pointer.to_integer_32).to_natural_32 >= ((ungot.item + ({PLATFORM}.Integer_8_bytes.to_natural_32 * (100).to_natural_32).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
				(create {P_OUTPUT_STATIC}).error (ce_string ("ungetcc overflow"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer));
				(create {P_MAIN_STATIC}).quit (1)
			end
			l_tmp := ungotp.item
			ungotp.item := ungotp.item + 1
			l_tmp[0] := a_c.to_integer_8
		end

	ungetsc (a_s: CE_POINTER [INTEGER_8])
		require
			not a_s.is_void
		local
			l_p: CE_POINTER [INTEGER_8]
		do
			l_p := (a_s + (strlen (a_s)).to_integer_32) - 1
			from
			until
				not ((l_p.c_pointer.to_integer_32).to_natural_32 >= (a_s.c_pointer.to_integer_32).to_natural_32)
			loop
				ungetcc ((l_p[0]).to_integer_32)
				l_p := l_p - 1
			end
		end

	multi_search (a_pattern: CE_POINTER [INTEGER_8]; a_n: INTEGER_32)
		local
			l_n: INTEGER_32
			l_nomore: INTEGER_32
			l_save_ifile: CE_POINTER [ANY]
			l_changed_file: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_n := a_n
			l_changed_file := 0
			l_save_ifile := (create {P_EDIT_STATIC}).save_curr_ifile
			if ((search_type.item).bit_and (256)).to_boolean then
				if ((search_type.item).bit_and (1)).to_boolean then
					l_nomore := (create {P_EDIT_STATIC}).edit_first
				else
					l_nomore := (create {P_EDIT_STATIC}).edit_last
				end
				if l_nomore.to_boolean then
					(create {P_EDIT_STATIC}).unsave_ifile (l_save_ifile)
					l_return := True
				end
				if not l_return then
					l_changed_file := 1
					search_type.item := (search_type.item).bit_and ((-257))
				end
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_n := (create {P_SEARCH_STATIC}).search (search_type.item, a_pattern, l_n)
					search_type.item := (search_type.item).bit_and ((-5))
					if l_n = 0 then
						(create {P_EDIT_STATIC}).unsave_ifile (l_save_ifile)
						l_return := True
					end
					if not l_return then
						if l_n < 0 then
							l_break := True
						end
						if not (l_return or l_break) and then (((search_type.item).bit_and (128)) = 0) then
							l_break := True
						end
						if not (l_return or l_break) then
							if ((search_type.item).bit_and (1)).to_boolean then
								l_nomore := (create {P_EDIT_STATIC}).edit_next (1)
							else
								l_nomore := (create {P_EDIT_STATIC}).edit_prev (1)
							end
							if l_nomore.to_boolean then
								l_break := True
							end
						end
						if not (l_return or l_break) then
							l_changed_file := 1
						end
					end
				end
			end
			if not l_return then
				l_break := False
				if l_n > 0 then
					(create {P_OUTPUT_STATIC}).error (ce_string ("Pattern not found"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
				end
				if l_changed_file.to_boolean then
					(create {P_EDIT_STATIC}).reedit_ifile (l_save_ifile)
				end
			end
		end

	commands
		local
			l_c: INTEGER_32
			l_action: INTEGER_32
			l_cbuf: CE_POINTER [INTEGER_8]
			l_newaction: INTEGER_32
			l_save_search_type: INTEGER_32
			l_extra: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_tbuf___0: CE_ARRAY [INTEGER_8]
			l_parg: CE_ARRAY [PD_PARG]
			l_old_ifile___0: CE_POINTER [ANY]
			l_new_ifile___0: CE_POINTER [ANY]
			l_tagfile: CE_POINTER [INTEGER_8]
			l_pos2: INTEGER_32
			l_pos___0: INTEGER_32
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_POINTER} l_cbuf.make
			create {CE_POINTER_ARRAY [INTEGER_8]} l_extra.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_tbuf___0.make (<<2>>)
			create {CE_CLASS_ARRAY [PD_PARG]} l_parg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					search_type.item := 1;
					(create {P_MAIN_STATIC}).wscroll.item := ((create {P_SCREEN_STATIC}).sc_height.item + 1) // 2
					l_newaction := 101
				when 1 then -- loop condition:
					if (l_return) then
						l_pos := -1 + 92 -- skip loop
					end
				when 2 then -- loop body:
						l_continue := False
						mca.item := 0;
						(create {P_CMDBUF_STATIC}).cmd_accept
						number.item := (0).to_integer_32
						optchar.item := (('%/0/').code).to_integer_8
						if ((create {P_CH_STATIC}).sigs.item).to_boolean then
							(create {P_SIGNAL_STATIC}).psignals
							if ((create {P_MAIN_STATIC}).quitting.item).to_boolean then
								(create {P_MAIN_STATIC}).quit (-1)
							end
						end
						(create {P_SCREEN_STATIC}).check_winch;
						(create {P_CMDBUF_STATIC}).cmd_reset
						prompt
						if ((create {P_CH_STATIC}).sigs.item).to_boolean then
							l_continue := True
						end
						if (l_return or l_continue) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_newaction = 101 then
							l_c := getcc
						end
				when 4 then -- again:
						if ((create {P_CH_STATIC}).sigs.item).to_boolean then
							l_continue := True
						end
				when 5 then -- if done
						if (l_return or l_continue) then
							l_pos := -1 + 15 -- skip if block
						end
				when 6 then -- if:
						if l_newaction = 101 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_action := l_newaction
						l_newaction := 101
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 9 then -- else:
						if not (mca.item.to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 10 then -- if:
						inspect (mca_char (l_c)) -- switch 1 head
						when 2 then l_pos := -1 + 11
						when 1 then l_pos := -1 + 12
						when 0 then l_pos := -1 + 13
						else l_pos := -1 + 14
						end
				when 11 then -- switch 1, case 2
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 12 then -- switch 1, case 1
						l_continue := True
				when 13 then -- switch 1, case 0
						l_pos := -1 + 14 -- switch 1; break
				when 14 then -- switch 1, done: | if done
						if not (l_return or l_continue) then
							if mca.item.to_boolean then
								if ((create {P_CMDBUF_STATIC}).cmd_char (l_c)) = 1 then
									l_continue := True
								elseif ((create {P_CMDBUF_STATIC}).len_cmdbuf) = 0 then
									l_continue := True
								end
								if not (l_return or l_continue) then
									l_cbuf := (create {P_CMDBUF_STATIC}).get_cmdbuf
								end
							else
								l_tbuf___0[0] := l_c.to_integer_8
								l_tbuf___0[1] := (('%/0/').code).to_integer_8
								l_cbuf := l_tbuf___0
							end
						end
						if not (l_return or l_continue) then
							l_extra.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_action := (create {P_DECODE_STATIC}).fcmd_decode (l_cbuf, l_extra)
							if not (l_extra.item).is_void then
								ungetsc (l_extra.item)
							end
						end
				when 15 then -- if done | if done
						if (l_return or l_continue) then
							l_pos := -1 + 91 -- skip if block
						end
				when 16 then -- if:
						if l_action /= 22 then
							(create {P_CMDBUF_STATIC}).cmd_reset
						end
						inspect l_action -- switch 2 head
						when 6 then l_pos := -1 + 17
						when 33 then l_pos := -1 + 18
						when 13 then l_pos := -1 + 19
						when 34 then l_pos := -1 + 20
						when 3 then l_pos := -1 + 21
						when 12 then l_pos := -1 + 22
						when 2 then l_pos := -1 + 23
						when 29 then l_pos := -1 + 24
						when 30 then l_pos := -1 + 25
						when 40 then l_pos := -1 + 26
						when 50 then l_pos := -1 + 27
						when 14 then l_pos := -1 + 29
						when 4 then l_pos := -1 + 30
						when 11 then l_pos := -1 + 31
						when 25 then l_pos := -1 + 32
						when 17 then l_pos := -1 + 33
						when 21 then l_pos := -1 + 34
						when 16 then l_pos := -1 + 35
						when 51 then l_pos := -1 + 36
						when 28 then l_pos := -1 + 37
						when 31 then l_pos := -1 + 39
						when 24 then l_pos := -1 + 40
						when 15 then l_pos := -1 + 42
						when 5 then l_pos := -1 + 43
						when 43 then l_pos := -1 + 44
						when 44 then l_pos := -1 + 45
						when 45 then l_pos := -1 + 46
						when 46 then l_pos := -1 + 47
						when 39 then l_pos := -1 + 48
						when 19 then l_pos := -1 + 49
						when 9 then l_pos := -1 + 51
						when 32 then l_pos := -1 + 53
						when 20 then l_pos := -1 + 58
						when 23 then l_pos := -1 + 60
						when 53 then l_pos := -1 + 62
						when 54 then l_pos := -1 + 64
						when 38 then l_pos := -1 + 66
						when 52 then l_pos := -1 + 67
						when 47 then l_pos := -1 + 71
						when 7 then l_pos := -1 + 72
						when 10 then l_pos := -1 + 73
						when 27 then l_pos := -1 + 74
						when 26 then l_pos := -1 + 76
						when 18 then l_pos := -1 + 79
						when 37 then l_pos := -1 + 81
						when 36 then l_pos := -1 + 85
						when 35 then l_pos := -1 + 85
						when 41 then l_pos := -1 + 86
						when 42 then l_pos := -1 + 87
						when 22 then l_pos := -1 + 88
						when 101 then l_pos := -1 + 89
						else l_pos := -1 + 90
						end
				when 17 then -- switch 2, case 6
						start_mca (6, ce_string (":"), create {CE_VOID_POINTER}.make_shared (default_pointer), 1)
						l_pos := -1 + 4 -- goto again
				when 18 then -- switch 2, case 33
						if number.item > 0 then
							swindow.item.item := number.item.to_integer_32
						end
				when 19 then -- switch 2, case 13
						if number.item <= 0 then
							number.item := ((create {P_OPTFUNC_STATIC}).get_swindow).to_integer_32
						end
						cmd_exec
						if (show_attn.item.item).to_boolean then
							(create {P_INPUT_STATIC}).set_attnpos (bottompos.item)
						end
						(create {P_FORWBACK_STATIC}).forward (number.item.to_integer_32, 0, 1)
						l_pos := -1 + 91 -- switch 2; break
				when 20 then -- switch 2, case 34
						if number.item > 0 then
							swindow.item.item := number.item.to_integer_32
						end
				when 21 then -- switch 2, case 3
						if number.item <= 0 then
							number.item := ((create {P_OPTFUNC_STATIC}).get_swindow).to_integer_32
						end
						cmd_exec;
						(create {P_FORWBACK_STATIC}).backward (number.item.to_integer_32, 0, 1)
						l_pos := -1 + 91 -- switch 2; break
				when 22 then -- switch 2, case 12
						if number.item <= 0 then
							number.item := (1).to_integer_32
						end
						cmd_exec
						if show_attn.item.item = 2 then
							if number.item > 1 then
								(create {P_INPUT_STATIC}).set_attnpos (bottompos.item)
							end
						end
						(create {P_FORWBACK_STATIC}).forward (number.item.to_integer_32, 0, 0)
						l_pos := -1 + 91 -- switch 2; break
				when 23 then -- switch 2, case 2
						if number.item <= 0 then
							number.item := (1).to_integer_32
						end
						cmd_exec;
						(create {P_FORWBACK_STATIC}).backward (number.item.to_integer_32, 0, 0)
						l_pos := -1 + 91 -- switch 2; break
				when 24 then -- switch 2, case 29
						if number.item <= 0 then
							number.item := (1).to_integer_32
						end
						cmd_exec
						if show_attn.item.item = 2 then
							if number.item > 1 then
								(create {P_INPUT_STATIC}).set_attnpos (bottompos.item)
							end
						end
						(create {P_FORWBACK_STATIC}).forward (number.item.to_integer_32, 1, 0)
						l_pos := -1 + 91 -- switch 2; break
				when 25 then -- switch 2, case 30
						if number.item <= 0 then
							number.item := (1).to_integer_32
						end
						cmd_exec;
						(create {P_FORWBACK_STATIC}).backward (number.item.to_integer_32, 1, 0)
						l_pos := -1 + 91 -- switch 2; break
				when 26 then -- switch 2, case 40
						if number.item <= 0 then
							number.item := ((create {P_OPTFUNC_STATIC}).get_swindow).to_integer_32
						end
						cmd_exec
						if show_attn.item.item = 2 then
							(create {P_INPUT_STATIC}).set_attnpos (bottompos.item)
						end
						(create {P_FORWBACK_STATIC}).forward (number.item.to_integer_32, 1, 0)
						l_pos := -1 + 91 -- switch 2; break
				when 27 then -- switch 2, case 50
						if ((((create {P_CH_STATIC}).ch_getflags)).bit_and (8)).to_boolean then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 28 then
						cmd_exec;
						(create {P_JUMP_STATIC}).jump_forw;
						(create {P_CH_STATIC}).ignore_eoi.item := 1
						hit_eof.item := 0
						from
						until
							((create {P_CH_STATIC}).sigs.item).to_boolean
						loop
							(create {P_FORWBACK_STATIC}).forward (1, 0, 0)
						end
						(create {P_CH_STATIC}).ignore_eoi.item := 0
						if ((create {P_CH_STATIC}).sigs.item).to_boolean then
							if not (((create {P_CH_STATIC}).sigs.item).bit_and (3)).to_boolean then
								l_newaction := 50
							end
						end
						l_pos := -1 + 91 -- switch 2; break
				when 29 then -- switch 2, case 14
						if number.item > 0 then
							(create {P_MAIN_STATIC}).wscroll.item := number.item.to_integer_32
						end
						cmd_exec
						if show_attn.item.item = 2 then
							(create {P_INPUT_STATIC}).set_attnpos (bottompos.item)
						end
						(create {P_FORWBACK_STATIC}).forward ((create {P_MAIN_STATIC}).wscroll.item, 0, 0)
						l_pos := -1 + 91 -- switch 2; break
				when 30 then -- switch 2, case 4
						if number.item > 0 then
							(create {P_MAIN_STATIC}).wscroll.item := number.item.to_integer_32
						end
						cmd_exec;
						(create {P_FORWBACK_STATIC}).backward ((create {P_MAIN_STATIC}).wscroll.item, 0, 0)
						l_pos := -1 + 91 -- switch 2; break
				when 31 then -- switch 2, case 11
						if ((((create {P_CH_STATIC}).ch_getflags)).bit_and (1)).to_boolean then
							(create {P_CH_STATIC}).ch_flush;
							(create {P_LINENUM_STATIC}).clr_linenum;
							(create {P_SEARCH_STATIC}).clr_hilite
						end
				when 32 then -- switch 2, case 25
						cmd_exec;
						(create {P_JUMP_STATIC}).repaint
						l_pos := -1 + 91 -- switch 2; break
				when 33 then -- switch 2, case 17
						if number.item <= 0 then
							number.item := (1).to_integer_32
						end
						cmd_exec;
						(create {P_JUMP_STATIC}).jump_back (number.item)
						l_pos := -1 + 91 -- switch 2; break
				when 34 then -- switch 2, case 21
						if number.item < 0 then
							number.item := (0).to_integer_32
						end
						if number.item > 100 then
							number.item := (100).to_integer_32
						end
						cmd_exec;
						(create {P_JUMP_STATIC}).jump_percent (number.item.to_integer_32)
						l_pos := -1 + 91 -- switch 2; break
				when 35 then -- switch 2, case 16
						cmd_exec
						if number.item <= 0 then
							(create {P_JUMP_STATIC}).jump_forw
						else
							(create {P_JUMP_STATIC}).jump_back (number.item)
						end
						l_pos := -1 + 91 -- switch 2; break
				when 36 then -- switch 2, case 51
						cmd_exec
						if number.item < 0 then
							number.item := (0).to_integer_32
						end
						(create {P_JUMP_STATIC}).jump_line_loc (number.item, (create {P_MAIN_STATIC}).jump_sline.item.item)
						l_pos := -1 + 91 -- switch 2; break
				when 37 then -- switch 2, case 28
						if ((((create {P_CH_STATIC}).ch_getflags)).bit_and (8)).to_boolean then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 38 then
						cmd_exec
						l_parg.item.p_string := (create {P_PROMPT_STATIC}).eq_message;
						(create {P_OUTPUT_STATIC}).error (ce_string ("%%s"), l_parg)
						l_pos := -1 + 91 -- switch 2; break
				when 39 then -- switch 2, case 31
						cmd_exec
						dispversion
						l_pos := -1 + 91 -- switch 2; break
				when 40 then -- switch 2, case 24
						if not ((create {P_MAIN_STATIC}).curr_ifile.item).is_void then
							if ((((create {P_CH_STATIC}).ch_getflags)).bit_and (8)).to_boolean then
								if ((create {P_EDIT_STATIC}).edit_prev (1)) = 0 then
									l_pos := -1 + 91 -- switch 2; break
								end
							end
						end
				when 41 then
						if not (l_extra.item).is_void then
							(create {P_MAIN_STATIC}).quit ((l_extra.item[0]).to_integer_32)
						end
						(create {P_MAIN_STATIC}).quit (0)
						l_pos := -1 + 91 -- switch 2; break
				when 42 then -- switch 2, case 15
						search_type.item := 1
						if number.item <= 0 then
							number.item := (1).to_integer_32
						end
						mca_search
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 43 then -- switch 2, case 5
						search_type.item := 2
						if number.item <= 0 then
							number.item := (1).to_integer_32
						end
						mca_search
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 44 then -- switch 2, case 43
						if number.item <= 0 then
							number.item := (1).to_integer_32
						end
						mca_search
						cmd_exec
						multi_search (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), number.item.to_integer_32)
						l_pos := -1 + 91 -- switch 2; break
				when 45 then -- switch 2, case 44
						search_type.item := (search_type.item).bit_or ((128))
						if number.item <= 0 then
							number.item := (1).to_integer_32
						end
						mca_search
						cmd_exec
						multi_search (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), number.item.to_integer_32)
						l_pos := -1 + 91 -- switch 2; break
				when 46 then -- switch 2, case 45
						l_save_search_type := search_type.item
						if ((search_type.item).bit_and (1)).to_boolean then
							search_type.item := (((search_type.item).bit_and (-2))).bit_or (2)
						else
							search_type.item := (((search_type.item).bit_and (-3))).bit_or (1)
						end
						if number.item <= 0 then
							number.item := (1).to_integer_32
						end
						mca_search
						cmd_exec
						multi_search (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), number.item.to_integer_32)
						search_type.item := l_save_search_type
						l_pos := -1 + 91 -- switch 2; break
				when 47 then -- switch 2, case 46
						l_save_search_type := search_type.item
						if ((search_type.item).bit_and (1)).to_boolean then
							search_type.item := (((search_type.item).bit_and (-2))).bit_or (2)
						else
							search_type.item := (((search_type.item).bit_and (-3))).bit_or (1)
						end
						search_type.item := (search_type.item).bit_or ((128))
						if number.item <= 0 then
							number.item := (1).to_integer_32
						end
						mca_search
						cmd_exec
						multi_search (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), number.item.to_integer_32)
						search_type.item := l_save_search_type
						l_pos := -1 + 91 -- switch 2; break
				when 48 then -- switch 2, case 39;
						(create {P_SEARCH_STATIC}).undo_search
						l_pos := -1 + 91 -- switch 2; break
				when 49 then -- switch 2, case 19
						if ((((create {P_CH_STATIC}).ch_getflags)).bit_and (8)).to_boolean then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 50 then
						cmd_exec;
						(create {P_EDIT_STATIC}).edit (ce_string ("@/\less/\help/\file/\@")).do_nothing
						l_pos := -1 + 91 -- switch 2; break
				when 51 then -- switch 2, case 9
						if ((create {P_MAIN_STATIC}).secure.item).to_boolean then
							(create {P_OUTPUT_STATIC}).error (ce_string ("Command not available"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 52 then
						start_mca (9, ce_string ("Examine: "), (create {P_CMDBUF_STATIC}).ml_examine.item, 0)
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 53 then -- switch 2, case 32
						if ((create {P_MAIN_STATIC}).secure.item).to_boolean then
							(create {P_OUTPUT_STATIC}).error (ce_string ("Command not available"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 54 then
						if ((((create {P_CH_STATIC}).ch_getflags)).bit_and (8)).to_boolean then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 55 then
						if (strcmp (((create {P_IFILE_STATIC}).get_filename ((create {P_MAIN_STATIC}).curr_ifile.item)), ce_string ("-"))) = 0 then
							(create {P_OUTPUT_STATIC}).error (ce_string ("Cannot edit standard input"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 56 then
						if not ((create {P_EDIT_STATIC}).curr_altfilename.item).is_void then
							(create {P_OUTPUT_STATIC}).error (ce_string ("Cannot edit file processed with LESSOPEN"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 57 then
						start_mca (27, ce_string ("!"), (create {P_CMDBUF_STATIC}).ml_shell.item, 0)
						make_display
						cmd_exec;
						(create {P_LSYSTEM_STATIC}).lsystem (((create {P_PROMPT_STATIC}).pr_expand ((create {P_MAIN_STATIC}).editproto.item, 0)), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
						l_pos := -1 + 91 -- switch 2; break
				when 58 then -- switch 2, case 20
						if ((create {P_TAGS_STATIC}).ntags).to_boolean then
							(create {P_OUTPUT_STATIC}).error (ce_string ("No next file"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 59 then
						if number.item <= 0 then
							number.item := (1).to_integer_32
						end
						if ((create {P_EDIT_STATIC}).edit_next (number.item.to_integer_32)).to_boolean then
							if (quit_at_eof.item.item).to_boolean then
								if hit_eof.item.to_boolean then
									if not ((((create {P_CH_STATIC}).ch_getflags)).bit_and (8)).to_boolean then
										(create {P_MAIN_STATIC}).quit (0)
									end
								end
							end
							if number.item > 1 then
								l_parg.item.p_string := ce_string ("(N-th) ")
							else
								l_parg.item.p_string := ce_string ("")
							end
							(create {P_OUTPUT_STATIC}).error (ce_string ("No %%snext file"), l_parg)
						end
						l_pos := -1 + 91 -- switch 2; break
				when 60 then -- switch 2, case 23
						if ((create {P_TAGS_STATIC}).ntags).to_boolean then
							(create {P_OUTPUT_STATIC}).error (ce_string ("No previous file"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 61 then
						if number.item <= 0 then
							number.item := (1).to_integer_32
						end
						if ((create {P_EDIT_STATIC}).edit_prev (number.item.to_integer_32)).to_boolean then
							if number.item > 1 then
								l_parg.item.p_string := ce_string ("(N-th) ")
							else
								l_parg.item.p_string := ce_string ("")
							end
							(create {P_OUTPUT_STATIC}).error (ce_string ("No %%sprevious file"), l_parg)
						end
						l_pos := -1 + 91 -- switch 2; break
				when 62 then -- switch 2, case 53
						if number.item <= 0 then
							number.item := (1).to_integer_32
						end
						l_tagfile := (create {P_TAGS_STATIC}).nexttag (number.item.to_integer_32)
						if l_tagfile.is_void then
							(create {P_OUTPUT_STATIC}).error (ce_string ("No next tag"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 63 then
						if ((create {P_EDIT_STATIC}).edit (l_tagfile)) = 0 then
							l_pos2 := ((create {P_TAGS_STATIC}).tagsearch)
							if l_pos2 /= -1 then
								(create {P_JUMP_STATIC}).jump_loc (l_pos2, (create {P_MAIN_STATIC}).jump_sline.item.item)
							end
						end
						l_pos := -1 + 91 -- switch 2; break
				when 64 then -- switch 2, case 54
						if number.item <= 0 then
							number.item := (1).to_integer_32
						end
						l_tagfile := (create {P_TAGS_STATIC}).prevtag (number.item.to_integer_32)
						if l_tagfile.is_void then
							(create {P_OUTPUT_STATIC}).error (ce_string ("No previous tag"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 65 then
						if ((create {P_EDIT_STATIC}).edit (l_tagfile)) = 0 then
							l_pos___0 := ((create {P_TAGS_STATIC}).tagsearch)
							if l_pos___0 /= -1 then
								(create {P_JUMP_STATIC}).jump_loc (l_pos___0, (create {P_MAIN_STATIC}).jump_sline.item.item)
							end
						end
						l_pos := -1 + 91 -- switch 2; break
				when 66 then -- switch 2, case 38
						if number.item <= 0 then
							number.item := (1).to_integer_32
						end
						if ((create {P_EDIT_STATIC}).edit_index (number.item.to_integer_32)).to_boolean then
							(create {P_OUTPUT_STATIC}).error (ce_string ("No such file"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						end
						l_pos := -1 + 91 -- switch 2; break
				when 67 then -- switch 2, case 52
						if ((((create {P_CH_STATIC}).ch_getflags)).bit_and (8)).to_boolean then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 68 then
						l_old_ifile___0 := (create {P_MAIN_STATIC}).curr_ifile.item
						l_new_ifile___0 := (create {P_IFILE_STATIC}).getoff_ifile ((create {P_MAIN_STATIC}).curr_ifile.item)
						if l_new_ifile___0.is_void then
							(create {P_SCREEN_STATIC}).bell
							l_pos := -1 + 91 -- switch 2; break
						end
				when 69 then
						if ((create {P_EDIT_STATIC}).edit_ifile (l_new_ifile___0)) /= 0 then
							(create {P_EDIT_STATIC}).reedit_ifile (l_old_ifile___0)
							l_pos := -1 + 91 -- switch 2; break
						end
				when 70 then;
						(create {P_IFILE_STATIC}).del_ifile (l_old_ifile___0)
						l_pos := -1 + 91 -- switch 2; break
				when 71 then -- switch 2, case 47
						optflag.item := 1
						optgetname.item := 0
						mca_opt_toggle
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 72 then -- switch 2, case 7
						optflag.item := 0
						optgetname.item := 0
						mca_opt_toggle
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 73 then -- switch 2, case 10
						start_mca (10, ce_string ("+"), create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 74 then -- switch 2, case 27
						if ((create {P_MAIN_STATIC}).secure.item).to_boolean then
							(create {P_OUTPUT_STATIC}).error (ce_string ("Command not available"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 75 then
						start_mca (27, ce_string ("!"), (create {P_CMDBUF_STATIC}).ml_shell.item, 0)
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 76 then -- switch 2, case 26
						if ((((create {P_CH_STATIC}).ch_getflags)).bit_and (8)).to_boolean then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 77 then
						start_mca (26, ce_string ("mark: "), create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
						l_c := getcc
						if l_c = (create {P_SCREEN_STATIC}).erase_char.item then
							l_pos := -1 + 91 -- switch 2; break
						elseif l_c = (create {P_SCREEN_STATIC}).kill_char.item then
							l_pos := -1 + 91 -- switch 2; break
						elseif l_c = 10 then
							l_pos := -1 + 91 -- switch 2; break
						elseif l_c = 13 then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 78 then;
						(create {P_MARK_STATIC}).setmark (l_c)
						l_pos := -1 + 91 -- switch 2; break
				when 79 then -- switch 2, case 18
						start_mca (18, ce_string ("goto mark: "), create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
						l_c := getcc
						if l_c = (create {P_SCREEN_STATIC}).erase_char.item then
							l_pos := -1 + 91 -- switch 2; break
						elseif l_c = (create {P_SCREEN_STATIC}).kill_char.item then
							l_pos := -1 + 91 -- switch 2; break
						elseif l_c = 10 then
							l_pos := -1 + 91 -- switch 2; break
						elseif l_c = 13 then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 80 then;
						(create {P_MARK_STATIC}).gomark (l_c)
						l_pos := -1 + 91 -- switch 2; break
				when 81 then -- switch 2, case 37
						if ((create {P_MAIN_STATIC}).secure.item).to_boolean then
							(create {P_OUTPUT_STATIC}).error (ce_string ("Command not available"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 91 -- switch 2; break
						end
				when 82 then
						start_mca (37, ce_string ("|mark: "), create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
						l_c := getcc
						if l_c = (create {P_SCREEN_STATIC}).erase_char.item then
							l_pos := -1 + 91 -- switch 2; break
						elseif l_c = (create {P_SCREEN_STATIC}).kill_char.item then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 83 then
						if l_c = 10 then
							l_c := ('.').code
						elseif l_c = 13 then
							l_c := ('.').code
						end
						if ((create {P_MARK_STATIC}).badmark (l_c)).to_boolean then
							l_pos := -1 + 91 -- switch 2; break
						end
				when 84 then
						pipec.item := l_c.to_integer_8
						start_mca (37, ce_string ("!"), (create {P_CMDBUF_STATIC}).ml_shell.item, 0)
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 85 then -- switch 2, case 36 | switch 2, case 35
						start_mca (l_action, ce_string ("Brackets: "), create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 86 then -- switch 2, case 41
						if number.item > 0 then
							shift_count.item.item := number.item.to_integer_32
						elseif shift_count.item.item > 0 then
							number.item := (shift_count.item.item).to_integer_32
						else
							number.item := ((create {P_SCREEN_STATIC}).sc_width.item // 2).to_integer_32
						end
						if number.item > hshift.item.to_integer_32 then
							number.item := hshift.item.to_integer_32
						end
						hshift.item := (hshift.item.to_integer_32 - number.item).to_integer_32
						screen_trashed.item := 1
						l_pos := -1 + 91 -- switch 2; break
				when 87 then -- switch 2, case 42
						if number.item > 0 then
							shift_count.item.item := number.item.to_integer_32
						elseif shift_count.item.item > 0 then
							number.item := (shift_count.item.item).to_integer_32
						else
							number.item := ((create {P_SCREEN_STATIC}).sc_width.item // 2).to_integer_32
						end
						hshift.item := (hshift.item.to_integer_32 + number.item).to_integer_32
						screen_trashed.item := 1
						l_pos := -1 + 91 -- switch 2; break
				when 88 then -- switch 2, case 22
						if mca.item /= 22 then
							(create {P_CMDBUF_STATIC}).cmd_reset
							start_mca (22, ce_string (" "), create {CE_VOID_POINTER}.make_shared (default_pointer), 1);
							(create {P_CMDBUF_STATIC}).cmd_char (l_c).do_nothing
						end
						l_c := getcc
						l_pos := -1 + 4 -- goto again
				when 89 then -- switch 2, case 101
						l_pos := -1 + 91 -- switch 2; break
				when 90 then -- switch 2, default:;
						(create {P_SCREEN_STATIC}).bell
						l_pos := -1 + 91 -- switch 2; break
				when 91 then -- switch 2, done: | if done
						if (not l_return) then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 92 then -- loop done
					l_continue := False
				when 93 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
