class
	P_FORWBACK_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	squished: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	no_back_scroll: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	forw_scroll: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	back_scroll: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	final_attr: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	first_time: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 1
		end

	cshift: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

feature {ANY} -- public routines

	eof_bell
		do
			if (create {P_SCREEN_STATIC}).quiet.item.item = 0 then
				(create {P_SCREEN_STATIC}).bell
			else
				(create {P_SCREEN_STATIC}).vbell
			end
		end

	eof_check
		local
			l_pos2: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_CH_STATIC}).ignore_eoi.item).to_boolean then
				l_return := True
			end
			if not l_return and then ((((create {P_CH_STATIC}).sigs.item).bit_and (3)).to_boolean) then
				l_return := True
			end
			if not l_return then
				l_pos2 := (create {P_POSITION_STATIC}).position (-2)
				if l_pos2 = -1 then
					(create {P_COMMAND_STATIC}).hit_eof.item := (create {P_COMMAND_STATIC}).hit_eof.item + 1
				elseif l_pos2 = ((create {P_CH_STATIC}).ch_length) then
					(create {P_COMMAND_STATIC}).hit_eof.item := (create {P_COMMAND_STATIC}).hit_eof.item + 1
				end
			end
		end

	squish_check
		local
			l_return: BOOLEAN
		do
			if not squished.item.to_boolean then
				l_return := True
			end
			if not l_return then
				squished.item := 0;
				(create {P_JUMP_STATIC}).repaint
			end
		end

	forw (a_n: INTEGER_32; a_pos: INTEGER_32; a_force, a_only_last, a_nblank: INTEGER_32)
		local
			l_n: INTEGER_32
			l_pos2: INTEGER_32
			l_force: INTEGER_32
			l_nblank: INTEGER_32
			l_eof: INTEGER_32
			l_nlines: INTEGER_32
			l_do_repaint: INTEGER_32
			l_tmp: INTEGER_32
			l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := a_n
					l_pos2 := a_pos
					l_force := a_force
					l_nblank := a_nblank
					l_eof := 0
					l_nlines := 0
					squish_check
					if not (a_only_last.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_n > (create {P_SCREEN_STATIC}).sc_height.item - 1 then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if forw_scroll.item.item >= 0 then
							if l_n > forw_scroll.item.item then
								if l_n /= (create {P_SCREEN_STATIC}).sc_height.item - 1 then
									l_tmp := 1
								else
									l_tmp := 0
								end
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 4 then
					l_do_repaint := l_tmp
					if l_do_repaint.to_boolean then
						l_pos := -1 + 10 -- skip if block
					end
				when 5 then -- if:
						cshift.item := 0
						if ((create {P_COMMAND_STATIC}).top_scroll.item.item).to_boolean then
							if l_n >= (create {P_SCREEN_STATIC}).sc_height.item - 1 then
								if l_pos2 /= ((create {P_CH_STATIC}).ch_length) then
									(create {P_POSITION_STATIC}).pos_clear;
									(create {P_POSITION_STATIC}).add_forw_pos (l_pos2)
									l_force := 1
									if (create {P_COMMAND_STATIC}).top_scroll.item.item = 2 then
										(create {P_SCREEN_STATIC}).clear
									elseif first_time.item.to_boolean then
										(create {P_SCREEN_STATIC}).clear
									end
									(create {P_SCREEN_STATIC}).home
								else
									(create {P_SCREEN_STATIC}).clear_bot
								end
							else
								(create {P_SCREEN_STATIC}).clear_bot
							end
						else
							(create {P_SCREEN_STATIC}).clear_bot
						end
						if l_pos2 = ((create {P_POSITION_STATIC}).position (-2)) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L___0
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if not (((create {P_POSITION_STATIC}).empty_screen).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L___0:;
						(create {P_POSITION_STATIC}).pos_clear;
						(create {P_POSITION_STATIC}).add_forw_pos (l_pos2)
						l_force := 1
						if ((create {P_COMMAND_STATIC}).top_scroll.item.item).to_boolean then
							if (create {P_COMMAND_STATIC}).top_scroll.item.item = 2 then
								(create {P_SCREEN_STATIC}).clear
							end
							(create {P_SCREEN_STATIC}).home
						elseif not first_time.item.to_boolean then
							(create {P_OUTPUT_STATIC}).putstr (ce_string ("...skipping...%N"))
						end
				when 10 then -- if done | if done
					from
					until
						(l_break)
					loop
						l_break := False
						l_continue := False
						l_n := l_n - 1
						if not (l_n >= 0) then
							l_break := True
						end
						if not (l_break or l_continue) then
							if l_nblank > 0 then
								l_nblank := l_nblank - 1
								if l_nblank = 0 then
									l_pos2 := (0).to_integer_32
								end
							else
								l_pos2 := (create {P_INPUT_STATIC}).forw_line (l_pos2)
								if l_pos2 = -1 then
									l_eof := 1
									if not l_force.to_boolean then
										if ((create {P_POSITION_STATIC}).position (0)) /= -1 then
											l_break := True
										end
									end
									if not (l_break or l_continue) then
										if not ((create {P_POSITION_STATIC}).empty_lines (0, 0)).to_boolean then
											if not ((create {P_POSITION_STATIC}).empty_lines (1, 1)).to_boolean then
												if ((create {P_POSITION_STATIC}).empty_lines (2, (create {P_SCREEN_STATIC}).sc_height.item - 1)).to_boolean then
													l_break := True
												end
											end
										end
									end
								end
							end
						end
						if not (l_break or l_continue) then
							(create {P_POSITION_STATIC}).add_forw_pos (l_pos2)
							l_nlines := l_nlines + 1
							if l_do_repaint.to_boolean then
								l_continue := True
							end
						end
						if not (l_break or l_continue) and then (first_time.item.to_boolean) then
							if l_pos2 = -1 then
								if not ((create {P_COMMAND_STATIC}).top_scroll.item.item).to_boolean then
									if ((create {P_OPTFUNC_STATIC}).tagoption.item).is_void then
										if not ((create {P_OPTION_STATIC}).plusoption.item).to_boolean then
											squished.item := 1
											l_continue := True
										end
									end
								end
							end
						end
						if not (l_break or l_continue) then
							if (create {P_COMMAND_STATIC}).top_scroll.item.item = 1 then
								(create {P_SCREEN_STATIC}).clear_eol
							end
							(create {P_OUTPUT_STATIC}).put_line
							if ((create {P_SCREEN_STATIC}).clear_bg.item).to_boolean then
								if final_attr.item /= 0 then
									(create {P_SCREEN_STATIC}).clear_eol
								end
							end
						end
					end
					l_break := False
					l_continue := False
					if ((create {P_CH_STATIC}).ignore_eoi.item).to_boolean then
						(create {P_COMMAND_STATIC}).hit_eof.item := 0
					elseif l_eof.to_boolean then
						if not (((create {P_CH_STATIC}).sigs.item).bit_and (3)).to_boolean then
							(create {P_COMMAND_STATIC}).hit_eof.item := (create {P_COMMAND_STATIC}).hit_eof.item + 1
						else
							eof_check
						end
					else
						eof_check
					end
					if l_nlines = 0 then
						eof_bell
					elseif l_do_repaint.to_boolean then
						(create {P_JUMP_STATIC}).repaint
					end
					first_time.item := 0;
					(create {P_LINENUM_STATIC}).currline (-1).do_nothing
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	back (a_n: INTEGER_32; a_pos: INTEGER_32; a_force, a_only_last: INTEGER_32)
		local
			l_n: INTEGER_32
			l_pos2: INTEGER_32
			l_nlines: INTEGER_32
			l_do_repaint: INTEGER_32
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_n := a_n
			l_pos2 := a_pos
			l_nlines := 0
			squish_check
			if l_n > (get_back_scroll) then
				l_tmp___0 := 1
			elseif a_only_last.to_boolean then
				if l_n > (create {P_SCREEN_STATIC}).sc_height.item - 1 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			l_do_repaint := l_tmp___0;
			(create {P_COMMAND_STATIC}).hit_eof.item := 0
			from
			until
				(l_break)
			loop
				l_break := False
				l_n := l_n - 1
				if not (l_n >= 0) then
					l_break := True
				end
				if not (l_break) then
					l_pos2 := (create {P_INPUT_STATIC}).back_line (l_pos2)
					if l_pos2 = -1 then
						if not a_force.to_boolean then
							l_break := True
						end
					end
				end
				if not (l_break) then
					(create {P_POSITION_STATIC}).add_back_pos (l_pos2)
					l_nlines := l_nlines + 1
					if not l_do_repaint.to_boolean then
						(create {P_SCREEN_STATIC}).home;
						(create {P_SCREEN_STATIC}).add_line;
						(create {P_OUTPUT_STATIC}).put_line
					end
				end
			end
			l_break := False
			eof_check
			if l_nlines = 0 then
				eof_bell
			elseif l_do_repaint.to_boolean then
				(create {P_JUMP_STATIC}).repaint
			end
			(create {P_LINENUM_STATIC}).currline (-1).do_nothing
		end

	forward (a_n, a_force, a_only_last: INTEGER_32)
		local
			l_pos2: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_COMMAND_STATIC}).quit_at_eof.item.item).to_boolean then
						if ((create {P_COMMAND_STATIC}).hit_eof.item).to_boolean then
							if not ((((create {P_CH_STATIC}).ch_getflags)).bit_and (8)).to_boolean then
								if ((create {P_EDIT_STATIC}).edit_next (1)).to_boolean then
									(create {P_MAIN_STATIC}).quit (0)
								end
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_pos2 := (create {P_POSITION_STATIC}).position (-2)
						if l_pos2 /= -1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if a_force.to_boolean then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if not (((create {P_POSITION_STATIC}).empty_lines (2, (create {P_SCREEN_STATIC}).sc_height.item - 1)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						if ((create {P_CH_STATIC}).ignore_eoi.item).to_boolean then
							if ((create {P_POSITION_STATIC}).empty_screen).to_boolean then
								l_pos2 := (0).to_integer_32
							else
								from
								until
									(l_break)
								loop
									l_break := False
									back (1, ((create {P_POSITION_STATIC}).position (0)), 1, 0)
									l_pos2 := (create {P_POSITION_STATIC}).position (-2)
									if l_pos2 /= -1 then
										l_break := True
									end
								end
								l_break := False
							end
						else
							eof_bell;
							(create {P_COMMAND_STATIC}).hit_eof.item := (create {P_COMMAND_STATIC}).hit_eof.item + 1
							l_return := True
						end
				when 7 then -- if done | if done | if done
					if not l_return then
						forw (a_n, l_pos2, a_force, a_only_last, 0)
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	backward (a_n, a_force, a_only_last: INTEGER_32)
		local
			l_pos2: INTEGER_32
			l_return: BOOLEAN
		do
			l_pos2 := (create {P_POSITION_STATIC}).position (0)
			if l_pos2 = -1 then
				if not a_force.to_boolean then
					eof_bell
					l_return := True
				elseif ((create {P_POSITION_STATIC}).position (-1)) = 0 then
					eof_bell
					l_return := True
				end
			end
			if not l_return then
				back (a_n, l_pos2, a_force, a_only_last)
			end
		end

	get_back_scroll: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if no_back_scroll.item.to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return and then (back_scroll.item.item >= 0) then
				Result := (back_scroll.item.item)
				l_return := True
			end
			if not l_return and then (((create {P_COMMAND_STATIC}).top_scroll.item.item).to_boolean) then
				Result := ((create {P_SCREEN_STATIC}).sc_height.item - 2)
				l_return := True
			end
			if not l_return then
				Result := 10_000
			end
		end

end
