class
	P_JUMP_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	jump_forw
		local
			l_pos2: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_CH_STATIC}).ch_end_seek).to_boolean then
				(create {P_OUTPUT_STATIC}).error (ce_string ("Cannot seek to end of file"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_pos2 := (create {P_INPUT_STATIC}).back_line (((create {P_CH_STATIC}).ch_tell))
				if l_pos2 = -1 then
					jump_loc ((0).to_integer_32, (create {P_SCREEN_STATIC}).sc_height.item - 1)
				else
					jump_loc (l_pos2, (create {P_SCREEN_STATIC}).sc_height.item - 1)
				end
			end
		end

	jump_back (a_linenum: INTEGER_32)
		local
			l_pos2: INTEGER_32
			l_parg: CE_ARRAY [PD_PARG]
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_PARG]} l_parg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pos2 := (create {P_LINENUM_STATIC}).find_pos (a_linenum)
					if l_pos2 = -1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_CH_STATIC}).ch_seek (l_pos2)) = 0 then
							if ((create {P_COMMAND_STATIC}).show_attn.item.item).to_boolean then
								(create {P_INPUT_STATIC}).set_attnpos (l_pos2)
							end
							jump_loc (l_pos2, (create {P_MAIN_STATIC}).jump_sline.item.item)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if a_linenum <= 1 then
							if ((create {P_CH_STATIC}).ch_beg_seek) = 0 then
								jump_loc (((create {P_CH_STATIC}).ch_tell), (create {P_MAIN_STATIC}).jump_sline.item.item);
								(create {P_OUTPUT_STATIC}).error (ce_string ("Cannot seek to beginning of file"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							else
								l_parg.item.p_linenum := a_linenum;
								(create {P_OUTPUT_STATIC}).error (ce_string ("Cannot seek to line number %%n"), l_parg)
							end
						else
							l_parg.item.p_linenum := a_linenum;
							(create {P_OUTPUT_STATIC}).error (ce_string ("Cannot seek to line number %%n"), l_parg)
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	repaint
		local
			l_scrpos: CE_ARRAY [PD_SCRPOS]
		do
			create {CE_CLASS_ARRAY [PD_SCRPOS]} l_scrpos.make (<<1>>)

			l_scrpos.item.get_scrpos;
			(create {P_POSITION_STATIC}).pos_clear
			jump_loc (l_scrpos.item.pos, l_scrpos.item.ln)
		end

	jump_percent (a_percent: INTEGER_32)
		local
			l_pos2: INTEGER_32
			l_len: INTEGER_32
			l_return: BOOLEAN
		do
			l_len := (create {P_CH_STATIC}).ch_length
			if l_len = -1 then
				(create {P_OUTPUT_STATIC}).ierror (ce_string ("Determining length of file"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer));
				(create {P_CH_STATIC}).ch_end_seek.do_nothing
			end
			l_len := (create {P_CH_STATIC}).ch_length
			if l_len = -1 then
				(create {P_OUTPUT_STATIC}).error (ce_string ("Don%'t know length of file"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_pos2 := (create {P_OS_STATIC}).percent_pos (l_len, a_percent)
				if l_pos2 >= l_len then
					l_pos2 := l_len - 1
				end
				jump_line_loc (l_pos2, (create {P_MAIN_STATIC}).jump_sline.item.item)
			end
		end

	jump_line_loc (a_pos: INTEGER_32; a_sline: INTEGER_32)
		local
			l_pos2: INTEGER_32
			l_c: INTEGER_32
			l_break: BOOLEAN
		do
			l_pos2 := a_pos
			if ((create {P_CH_STATIC}).ch_seek (l_pos2)) = 0 then
				from
				until
					(l_break)
				loop
					l_break := False
					l_c := (create {P_CH_STATIC}).ch_back_get
					if l_c /= 10 then
						if l_c = -1 then
							l_break := True
						end
					else
						l_break := True
					end
				end
				l_break := False
				if l_c = 10 then
					(create {P_CH_STATIC}).ch_forw_get.do_nothing
				end
				l_pos2 := (create {P_CH_STATIC}).ch_tell
			end
			if ((create {P_COMMAND_STATIC}).show_attn.item.item).to_boolean then
				(create {P_INPUT_STATIC}).set_attnpos (l_pos2)
			end
			jump_loc (l_pos2, a_sline)
		end

	jump_loc (a_pos: INTEGER_32; a_sline: INTEGER_32)
		local
			l_pos2: INTEGER_32
			l_sline: INTEGER_32
			l_nline: INTEGER_32
			l_tpos: INTEGER_32
			l_bpos: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pos2 := a_pos
					l_sline := a_sline
					l_sline := (create {P_POSITION_STATIC}).adjsline (l_sline)
					l_nline := (create {P_POSITION_STATIC}).onscreen (l_pos2)
					if l_nline >= 0 then
						l_nline := l_nline - l_sline
						if l_nline > 0 then
							(create {P_FORWBACK_STATIC}).forw (l_nline, ((create {P_POSITION_STATIC}).position (-2)), 1, 0, 0)
						else
							(create {P_FORWBACK_STATIC}).back (-l_nline, ((create {P_POSITION_STATIC}).position (0)), 1, 0)
						end
						if ((create {P_COMMAND_STATIC}).show_attn.item.item).to_boolean then
							(create {P_SEARCH_STATIC}).repaint_hilite (1)
						end
						l_return := True
					end
					if not l_return then
						if ((create {P_CH_STATIC}).ch_seek (l_pos2)).to_boolean then
							(create {P_OUTPUT_STATIC}).error (ce_string ("Cannot seek to that file position"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						l_tpos := (create {P_POSITION_STATIC}).position (0)
						l_bpos := (create {P_POSITION_STATIC}).position (-2)
						if l_tpos /= -1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (l_pos2 >= l_tpos) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						l_nline := 0
						from
						until
							not (not (l_return or l_break) and then (l_nline < l_sline))
						loop
							l_break := False
							if l_bpos /= -1 then
								if l_pos2 <= l_bpos then
									(create {P_FORWBACK_STATIC}).forw ((((create {P_SCREEN_STATIC}).sc_height.item - l_sline) + l_nline) - 1, l_bpos, 1, 0, 0)
									if ((create {P_COMMAND_STATIC}).show_attn.item.item).to_boolean then
										(create {P_SEARCH_STATIC}).repaint_hilite (1)
									end
									l_return := True
								end
							end
							if not l_return then
								l_pos2 := (create {P_INPUT_STATIC}).back_line (l_pos2)
								if l_pos2 = -1 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_nline := l_nline + 1
								end
							end
						end
						if not l_return then
							l_break := False;
							(create {P_MARK_STATIC}).lastmark;
							(create {P_COMMAND_STATIC}).hit_eof.item := 0;
							(create {P_FORWBACK_STATIC}).squished.item := 0;
							(create {P_COMMAND_STATIC}).screen_trashed.item := 0;
							(create {P_FORWBACK_STATIC}).forw ((create {P_SCREEN_STATIC}).sc_height.item - 1, l_pos2, 1, 0, l_sline - l_nline)
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_nline := l_sline
						from
						until
							not (not (l_return or l_break) and then (l_nline < (create {P_SCREEN_STATIC}).sc_height.item - 1))
						loop
							l_break := False
							l_pos2 := (create {P_INPUT_STATIC}).forw_line (l_pos2)
							if l_pos2 = -1 then
								l_break := True
							end
							if not (l_return or l_break) then
								if l_pos2 >= l_tpos then
									(create {P_FORWBACK_STATIC}).back (l_nline + 1, l_tpos, 1, 0)
									if ((create {P_COMMAND_STATIC}).show_attn.item.item).to_boolean then
										(create {P_SEARCH_STATIC}).repaint_hilite (1)
									end
									l_return := True
								end
								if not l_return then
									l_nline := l_nline + 1
								end
							end
						end
						if not l_return then
							l_break := False;
							(create {P_MARK_STATIC}).lastmark;
							(create {P_SCREEN_STATIC}).clear;
							(create {P_COMMAND_STATIC}).screen_trashed.item := 0;
							(create {P_POSITION_STATIC}).add_back_pos (l_pos2);
							(create {P_FORWBACK_STATIC}).back ((create {P_SCREEN_STATIC}).sc_height.item - 1, l_pos2, 1, 0)
						end
				when 8 then -- if done | if done
					if not l_return then
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
