class
	P_LINE_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC
	S_STDIO_STATIC

feature {ANY} -- public attributes

	linebuf: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
		end

	attr: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
		end

	size_linebuf: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	tabstops: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<32>>)
			Result.item[0] := 0
		end

	ntabstops: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 1
		end

	tabdefault: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 8
		end

	curr: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	column: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	overstrike: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	last_overstrike: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	is_null_line: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	lmargin: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	hilites: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	pendc: CE_STATIC [INTEGER_8]
		once ("PROCESS")
		end

	pendpos: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	end_ansi_chars: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	bs_mode: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	linenums: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	ctldisp: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	twiddle: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	status_col: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

feature {ANY} -- public routines

	init_line
		do
			end_ansi_chars.item := (create {P_DECODE_STATIC}).lgetenv (ce_string ("LESSANSIENDCHARS"))
			if end_ansi_chars.item.is_void then
				end_ansi_chars.item := ce_string ("m")
			elseif (end_ansi_chars.item[0]).to_integer_32 = 0 then
				end_ansi_chars.item := ce_string ("m")
			end
			linebuf.item := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MAIN_STATIC}).ecalloc (1_024, {PLATFORM}.Integer_8_bytes.to_natural_32)))
			attr.item := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MAIN_STATIC}).ecalloc (1_024, {PLATFORM}.Integer_8_bytes.to_natural_32)))
			size_linebuf.item := 1_024
		end

	expand_linebuf: INTEGER_32
		local
			l_new_size: INTEGER_32
			l_new_buf: CE_POINTER [INTEGER_8]
			l_new_attr: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_new_size := size_linebuf.item + 1_024
					l_new_buf := create {CE_INTEGER_8_POINTER}.make_cast ((calloc (l_new_size.to_natural_32, {PLATFORM}.Integer_8_bytes.to_natural_32)))
					l_new_attr := create {CE_INTEGER_8_POINTER}.make_cast ((calloc (l_new_size.to_natural_32, {PLATFORM}.Integer_8_bytes.to_natural_32)))
					if not (l_new_buf.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (l_new_attr.is_void) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if not l_new_attr.is_void then
							free (create {CE_VOID_POINTER}.make_cast (l_new_attr))
						end
						if not l_new_buf.is_void then
							free (create {CE_VOID_POINTER}.make_cast (l_new_buf))
						end
						Result := 1
						l_return := True
				when 5 then -- if done
					if not l_return then
						memcpy (create {CE_VOID_POINTER}.make_cast (l_new_buf), create {CE_VOID_POINTER}.make_cast (linebuf.item), size_linebuf.item.to_natural_32 * {PLATFORM}.Integer_8_bytes.to_natural_32).do_nothing
						memcpy (create {CE_VOID_POINTER}.make_cast (l_new_attr), create {CE_VOID_POINTER}.make_cast (attr.item), size_linebuf.item.to_natural_32 * {PLATFORM}.Integer_8_bytes.to_natural_32).do_nothing
						free (create {CE_VOID_POINTER}.make_cast (attr.item))
						free (create {CE_VOID_POINTER}.make_cast (linebuf.item))
						linebuf.item := l_new_buf
						attr.item := l_new_attr
						size_linebuf.item := l_new_size
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	prewind
		do
			curr.item := 0
			column.item := 0
			overstrike.item := 0
			is_null_line.item := 0
			pendc.item := (('%/0/').code).to_integer_8
			lmargin.item := 0
			if (status_col.item.item).to_boolean then
				lmargin.item := lmargin.item + 1
			end
			hilites.item := 0
		end

	plinenum (a_pos: INTEGER_32)
		local
			l_linenum: INTEGER_32
			l_i: INTEGER_32
			l_buf___1: CE_ARRAY [INTEGER_8]
			l_n: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_buf___1.make (<<((((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32>>)

			l_linenum := (0).to_integer_32
			if linenums.item.item = 2 then
				l_linenum := (create {P_LINENUM_STATIC}).find_linenum (a_pos)
			end
			if (status_col.item.item).to_boolean then
				linebuf.item[curr.item] := ((' ').code).to_integer_8
				if (create {P_MAIN_STATIC}).start_attnpos.item /= -1 then
					if a_pos >= (create {P_MAIN_STATIC}).start_attnpos.item then
						if a_pos < (create {P_MAIN_STATIC}).end_attnpos.item then
							attr.item[curr.item] := (5).to_integer_8
						else
							attr.item[curr.item] := (0).to_integer_8
						end
					else
						attr.item[curr.item] := (0).to_integer_8
					end
				else
					attr.item[curr.item] := (0).to_integer_8
				end
				curr.item := curr.item + 1
				column.item := column.item + 1
			end
			if linenums.item.item = 2 then
				(create {P_OUTPUT_STATIC}).linenumtoa (l_linenum, l_buf___1)
				l_n := (strlen (l_buf___1)).to_integer_32
				if l_n < 7 then
					l_n := 7
				end
				sprintf ([(linebuf.item + curr.item), ce_string ("%%*s "), l_n, l_buf___1]).do_nothing
				l_n := l_n + 1
				l_i := 0
				from
				until
					not (l_i < l_n)
				loop
					attr.item[(curr.item + l_i)] := (0).to_integer_8
					l_i := l_i + 1
				end
				curr.item := curr.item + l_n
				column.item := column.item + l_n
				lmargin.item := lmargin.item + l_n
			end
			from
			until
				not (column.item < lmargin.item)
			loop
				linebuf.item[curr.item] := ((' ').code).to_integer_8
				l_tmp___0 := curr.item
				curr.item := curr.item + 1
				attr.item[l_tmp___0] := (0).to_integer_8
				column.item := column.item + 1
			end
		end

	shift_chars (a_s: CE_POINTER [INTEGER_8]; a_len: INTEGER_32): INTEGER_32
		require
			not a_s.is_void
		local
			l_len: INTEGER_32
			l_p: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			l_len := a_len
			l_p := a_s
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if (l_p[0]).to_integer_32 /= 0 then
					if not (l_len > 0) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_return or l_break) then
					l_tmp___1 := l_p
					l_p := l_p + 1
					if (l_tmp___1[0]).to_integer_32 /= 27 then
						l_len := l_len - 1
					else
						from
						until
							not (not (l_break) and then ((l_p[0]).to_integer_32 /= 0))
						loop
							l_break := False
							l_tmp := l_p
							l_p := l_p + 1
							if (is_ansi_end (((l_tmp[0]).to_integer_32).to_integer_8)).to_boolean then
								l_break := True
							end
						end
						l_break := False
					end
				end
			end
			l_break := False
			Result := (l_p.distance (a_s))
		end

	utf_shift_chars (a_s: CE_POINTER [INTEGER_8]; a_len: INTEGER_32): INTEGER_32
		require
			not a_s.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_len: INTEGER_32
			l_ulen: INTEGER_32
			l_break: BOOLEAN
		do
			l_s := a_s
			l_len := a_len
			l_ulen := 0
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_s[0]).to_integer_32 /= 0 then
					if not (l_len > 0) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					if (((l_s[0]).to_integer_32).bit_and (192)) /= 128 then
						l_len := l_len - 1
					end
					l_s := l_s + 1
					l_ulen := l_ulen + 1
				end
			end
			l_break := False
			from
			until
				(((l_s[0]).to_integer_32).bit_and (192)) /= 128
			loop
				l_s := l_s + 1
				l_ulen := l_ulen + 1
			end
			Result := l_ulen
		end

	pshift (a_shift: INTEGER_32)
		local
			l_shift: INTEGER_32
			l_i: INTEGER_32
			l_nchars: INTEGER_32
		do
			l_shift := a_shift
			if l_shift > column.item - lmargin.item then
				l_shift := column.item - lmargin.item
			end
			if l_shift > curr.item - lmargin.item then
				l_shift := curr.item - lmargin.item
			end
			if ((create {P_CHARSET_STATIC}).utf_mode.item.item).to_boolean then
				l_nchars := utf_shift_chars (linebuf.item + lmargin.item, l_shift)
			else
				l_nchars := shift_chars (linebuf.item + lmargin.item, l_shift)
			end
			if l_nchars > curr.item then
				l_nchars := curr.item
			end
			l_i := 0
			from
			until
				not (l_i < curr.item - l_nchars)
			loop
				linebuf.item[(lmargin.item + l_i)] := linebuf.item[((lmargin.item + l_i) + l_nchars)]
				attr.item[(lmargin.item + l_i)] := attr.item[((lmargin.item + l_i) + l_nchars)]
				l_i := l_i + 1
			end
			curr.item := curr.item - l_nchars
			column.item := column.item - l_shift;
			(create {P_FORWBACK_STATIC}).cshift.item := (create {P_FORWBACK_STATIC}).cshift.item + l_shift
		end

	attr_swidth (a_a: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_a -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 5 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 2
					Result := ((create {P_SCREEN_STATIC}).bo_s_width.item)
					l_return := True
				when 2 then -- switch 1, case 1
					if not l_return then
						Result := ((create {P_SCREEN_STATIC}).ul_s_width.item)
						l_return := True
					end
				when 3 then -- switch 1, case 3
					if not l_return then
						Result := ((create {P_SCREEN_STATIC}).bl_s_width.item)
						l_return := True
					end
				when 4 then -- switch 1, case 5
					if not l_return then
						Result := ((create {P_SCREEN_STATIC}).so_s_width.item)
						l_return := True
					end
				when 5 then -- switch 1, done:
					if not l_return then
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	attr_ewidth (a_a: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_a -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 5 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 2
					Result := ((create {P_SCREEN_STATIC}).bo_e_width.item)
					l_return := True
				when 2 then -- switch 1, case 1
					if not l_return then
						Result := ((create {P_SCREEN_STATIC}).ul_e_width.item)
						l_return := True
					end
				when 3 then -- switch 1, case 3
					if not l_return then
						Result := ((create {P_SCREEN_STATIC}).bl_e_width.item)
						l_return := True
					end
				when 4 then -- switch 1, case 5
					if not l_return then
						Result := ((create {P_SCREEN_STATIC}).so_e_width.item)
						l_return := True
					end
				when 5 then -- switch 1, done:
					if not l_return then
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	pwidth (a_c, a_a: INTEGER_32): INTEGER_32
		local
			l_w: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_CHARSET_STATIC}).utf_mode.item.item).to_boolean then
				if ((a_c).bit_and (192)) = 128 then
					Result := 0
					l_return := True
				end
			end
			if not l_return and then (a_c = 8) then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if ((create {P_CHARSET_STATIC}).control_char (a_c)).to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_w := 1
				if curr.item > 0 then
					if (attr.item[(curr.item - 1)]).to_integer_32 /= a_a then
						l_w := l_w + (attr_ewidth ((attr.item[(curr.item - 1)]).to_integer_32))
					end
				end
				if a_a.to_boolean then
					if curr.item = 0 then
						l_tmp___1 := attr_swidth (a_a)
						l_w := l_w + l_tmp___1
					elseif (attr.item[(curr.item - 1)]).to_integer_32 /= a_a then
						l_tmp___1 := attr_swidth (a_a)
						l_w := l_w + l_tmp___1
					end
				end
				Result := l_w
			end
		end

	backc
		do
			curr.item := curr.item - 1
			column.item := column.item - (pwidth ((linebuf.item[curr.item]).to_integer_32, (attr.item[curr.item]).to_integer_32))
		end

	in_ansi_esc_seq: INTEGER_32
		local
			l_i: INTEGER_32
			l_return: BOOLEAN
		do
			l_i := curr.item - 1
			from
			until
				not (not (l_return) and then (l_i >= 0))
			loop
				if (linebuf.item[l_i]).to_integer_32 = 27 then
					Result := 1
					l_return := True
				end
				if not l_return then
					if (is_ansi_end (((linebuf.item[l_i]).to_integer_32).to_integer_8)).to_boolean then
						Result := 0
						l_return := True
					end
				end
				if not l_return then
					l_i := l_i - 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	is_ansi_end (a_c: INTEGER_8): INTEGER_32
		do
			Result := (not (strchr (end_ansi_chars.item, a_c.to_integer_32)).is_void).to_integer
		end

	store_char (a_c, a_a: INTEGER_32; a_pos: INTEGER_32): INTEGER_32
		local
			l_a: INTEGER_32
			l_w: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a := a_a
					if l_a /= 0 then
						last_overstrike.item := l_a
					end
					if ((create {P_SEARCH_STATIC}).is_hilited (a_pos, a_pos + 1, 0)).to_boolean then
						l_a := 5
						hilites.item := hilites.item + 1
					end
					if ctldisp.item.item = 2 then
						if (in_ansi_esc_seq).to_boolean then
							l_w := 0
						else
							l_w := pwidth (a_c, l_a)
						end
					else
						l_w := pwidth (a_c, l_a)
					end
					if ctldisp.item.item /= 1 then
						if (column.item + l_w) + (attr_ewidth (l_a)) > (create {P_SCREEN_STATIC}).sc_width.item then
							Result := 1
							l_return := True
						end
					end
					if not l_return and then (curr.item >= size_linebuf.item - 2) then
						if (expand_linebuf).to_boolean then
							Result := 1
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (curr.item > 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_a /= 0 then
							if (linebuf.item[(curr.item - 1)]).to_integer_32 = 32 then
								if (attr.item[(curr.item - 1)]).to_integer_32 = 0 then
									if (attr_swidth (l_a)) > 0 then
										attr.item[(curr.item - 1)] := (4).to_integer_8
										column.item := column.item - 1
									else
										l_pos := -1 + 4 -- goto _L___2
									end
								else
									l_pos := -1 + 4 -- goto _L___2
								end
							else
								l_pos := -1 + 4 -- goto _L___2
							end
						else
							l_pos := -1 + 4 -- goto _L___2
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L___2:
						if curr.item > 0 then
							if (attr.item[(curr.item - 1)]).to_integer_32 /= 0 then
								if (attr.item[(curr.item - 1)]).to_integer_32 /= 4 then
									if a_c = 32 then
										if l_a = 0 then
											if (attr_ewidth ((attr.item[(curr.item - 1)]).to_integer_32)) > 0 then
												l_a := 4
												column.item := column.item - 1
											end
										end
									end
								end
							end
						end
				when 5 then
						linebuf.item[curr.item] := a_c.to_integer_8
						attr.item[curr.item] := l_a.to_integer_8
						column.item := column.item + l_w
						Result := 0
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	store_tab (a_attr___0: INTEGER_32; a_pos: INTEGER_32): INTEGER_32
		local
			l_to_tab: INTEGER_32
			l_i: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_to_tab := (column.item + (create {P_FORWBACK_STATIC}).cshift.item) - lmargin.item
			if ntabstops.item < 2 then
				l_to_tab := tabdefault.item - (l_to_tab - tabstops.item[ntabstops.item - 1]) \\ tabdefault.item
			elseif l_to_tab >= tabstops.item[ntabstops.item - 1] then
				l_to_tab := tabdefault.item - (l_to_tab - tabstops.item[ntabstops.item - 1]) \\ tabdefault.item
			else
				l_i := ntabstops.item - 2
				from
				until
					not (not (l_break) and then (l_i >= 0))
				loop
					l_break := False
					if l_to_tab >= tabstops.item[l_i] then
						l_break := True
					end
					if not (l_break) then
						l_i := l_i - 1
					end
				end
				l_break := False
				l_to_tab := tabstops.item[l_i + 1] - l_to_tab
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if (store_char ((' ').code, a_attr___0, a_pos)).to_boolean then
						Result := 1
						l_return := True
					else
						curr.item := curr.item + 1
					end
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
					l_to_tab := l_to_tab - 1
					if not (l_to_tab > 0) then
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 0
			end
		end

	pappend (a_c: INTEGER_32; a_pos: INTEGER_32): INTEGER_32
		local
			l_r: INTEGER_32
			l_return: BOOLEAN
		do
			if pendc.item.to_boolean then
				if (do_append (pendc.item.to_integer_32, pendpos.item)).to_boolean then
					Result := 1
					l_return := True
				end
				if not l_return then
					pendc.item := (('%/0/').code).to_integer_8
				end
			end
			if not l_return and then (a_c = 13) then
				if bs_mode.item.item = 0 then
					pendc.item := a_c.to_integer_8
					pendpos.item := a_pos
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_r := do_append (a_c, a_pos)
				if (create {P_FORWBACK_STATIC}).cshift.item < (create {P_COMMAND_STATIC}).hshift.item then
					if column.item > (create {P_SCREEN_STATIC}).sc_width.item // 2 then
						linebuf.item[curr.item] := (('%/0/').code).to_integer_8
						pshift ((create {P_COMMAND_STATIC}).hshift.item - (create {P_FORWBACK_STATIC}).cshift.item)
					end
				end
				Result := l_r
			end
		end

	do_append (a_c: INTEGER_32; a_pos: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			l_a: INTEGER_32
			l_i: INTEGER_32
			l_tmp___18: NATURAL_32
			l_tmp___19: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_c /= 8 then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						inspect bs_mode.item.item -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 0 then l_pos := -1 + 4
						else l_pos := -1 + 6
						end
				when 2 then -- switch 1, case 1
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if (store_char (a_c, 0, a_pos)).to_boolean then
								Result := 1
								l_return := True
							else
								curr.item := curr.item + 1
							end
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
						l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 2
						l_pos := -1 + 55 -- goto do_control_char
				when 4 then -- switch 1, case 0
						if curr.item = 0 then
							l_pos := -1 + 6 -- switch 1; break
						end
				when 5 then
						backc
						overstrike.item := 1
						l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 67
				when 7 then -- else:
						if not (overstrike.item.to_boolean) then
							l_pos := -1 + 49 -- skip if block
						end
				when 8 then -- if:
						overstrike.item := overstrike.item - 1
						if not (((create {P_CHARSET_STATIC}).utf_mode.item.item).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if ((a_c).bit_and (248)) = 240 then
							if curr.item > 2 then
								if (a_c.to_integer_8).to_integer_32 = (linebuf.item[(curr.item - 3)]).to_integer_32 then
									backc
									backc
									backc
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										if (store_char ((linebuf.item[curr.item]).to_integer_32, 2, a_pos)).to_boolean then
											Result := 1
											l_return := True
										else
											curr.item := curr.item + 1
										end
										if not l_return then
											l_break := True
										end
									end
									if not l_return then
										l_break := False
										overstrike.item := 3
									end
								else
									l_pos := -1 + 11 -- goto _L___13
								end
							else
								l_pos := -1 + 11 -- goto _L___13
							end
						else
							l_pos := -1 + 11 -- goto _L___13
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 11 then -- else: | _L___13:
						if not (((create {P_CHARSET_STATIC}).utf_mode.item.item).to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 12 then -- if:
						if ((a_c).bit_and (240)) /= 224 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 17 -- goto _L___10
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else:
						if overstrike.item /= 2 then
							l_pos := -1 + 21 -- skip if block
						end
				when 16 then -- if:
						if ((a_c).bit_and (192)) /= 128 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if: | _L___10:
						if curr.item > 1 then
							if (a_c.to_integer_8).to_integer_32 = (linebuf.item[(curr.item - 2)]).to_integer_32 then
								backc
								backc
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (store_char ((linebuf.item[curr.item]).to_integer_32, 2, a_pos)).to_boolean then
										Result := 1
										l_return := True
									else
										curr.item := curr.item + 1
									end
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
									overstrike.item := 2
								end
							else
								l_pos := -1 + 23 -- goto _L___9
							end
						else
							l_pos := -1 + 23 -- goto _L___9
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						l_pos := -1 + 23 -- goto _L___9
				when 20 then -- if done | if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_pos := -1 + 23 -- goto _L___9
				when 22 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 48
				when 23 then -- else: | _L___9:
						if not (((create {P_CHARSET_STATIC}).utf_mode.item.item).to_boolean) then
							l_pos := -1 + 38 -- skip if block
						end
				when 24 then -- if:
						if not (curr.item > 0) then
							l_pos := -1 + 36 -- skip if block
						end
				when 25 then -- if:
						if ((a_c).bit_and (224)) /= 192 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 30 -- goto _L___5
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 28 then -- else:
						if overstrike.item /= 1 then
							l_pos := -1 + 34 -- skip if block
						end
				when 29 then -- if:
						if ((a_c).bit_and (192)) /= 128 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if: | _L___5:
						if (a_c.to_integer_8).to_integer_32 = (linebuf.item[(curr.item - 1)]).to_integer_32 then
							backc
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if (store_char ((linebuf.item[curr.item]).to_integer_32, 2, a_pos)).to_boolean then
									Result := 1
									l_return := True
								else
									curr.item := curr.item + 1
								end
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
								overstrike.item := 1
							end
						else
							l_pos := -1 + 38 -- goto _L___6
						end
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:
						l_pos := -1 + 38 -- goto _L___6
				when 33 then -- if done | if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else:
						l_pos := -1 + 38 -- goto _L___6
				when 35 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 37
				when 36 then -- else:
						l_pos := -1 + 38 -- goto _L___6
				when 37 then -- if done | if block done, skip else block:
						l_pos := -1 + 48
				when 38 then -- else: | _L___6:
						if not (((create {P_CHARSET_STATIC}).utf_mode.item.item).to_boolean) then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						if curr.item > 0 then
							if ((a_c).bit_and (192)) = 128 then
								if (attr.item[(curr.item - 1)]).to_integer_32 = 1 then
									if a_c = 9 then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											if (store_tab (1, a_pos)).to_boolean then
												Result := 1
												l_return := True
											end
											if not l_return then
												l_break := True
											end
										end
										if not l_return then
											l_break := False
										end
									else
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											if (store_char (a_c, 1, a_pos)).to_boolean then
												Result := 1
												l_return := True
											else
												curr.item := curr.item + 1
											end
											if not l_return then
												l_break := True
											end
										end
										if not l_return then
											l_break := False
										end
									end
								else
									l_pos := -1 + 41 -- goto _L___2
								end
							else
								l_pos := -1 + 41 -- goto _L___2
							end
						else
							l_pos := -1 + 41 -- goto _L___2
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 41 then -- else: | _L___2:
						if (a_c.to_integer_8).to_integer_32 /= (linebuf.item[curr.item]).to_integer_32 then
							l_pos := -1 + 47 -- skip if block
						end
				when 42 then -- if:
						if a_c /= 95 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						if last_overstrike.item /= 0 then
							if a_c = 9 then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (store_tab (last_overstrike.item, a_pos)).to_boolean then
										Result := 1
										l_return := True
									end
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							else
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (store_char (a_c, last_overstrike.item, a_pos)).to_boolean then
										Result := 1
										l_return := True
									else
										curr.item := curr.item + 1
									end
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							end
						else
							l_pos := -1 + 45 -- goto _L
						end
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else: | _L:
						if a_c = 9 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if (store_tab (2, a_pos)).to_boolean then
									Result := 1
									l_return := True
								end
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if (store_char (a_c, 2, a_pos)).to_boolean then
									Result := 1
									l_return := True
								else
									curr.item := curr.item + 1
								end
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
				when 46 then -- if done | if block done, skip else block:
						l_pos := -1 + 48
				when 47 then -- else:
						if a_c = 95 then
							if ((create {P_CHARSET_STATIC}).utf_mode.item.item).to_boolean then
								l_i := 0
								from
								until
									not (not (l_break) and then (l_i < 5))
								loop
									l_break := False
									if curr.item <= l_i then
										l_break := True
									elseif (((linebuf.item[(curr.item - l_i)]).to_integer_32).bit_and (192)) /= 128 then
										l_break := True
									end
									if not (l_return or l_break) then
										attr.item[((curr.item - l_i) - 1)] := (1).to_integer_8
										l_i := l_i + 1
									end
								end
								l_break := False
							end
							if (linebuf.item[curr.item]).to_integer_32 = 9 then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (store_tab (1, a_pos)).to_boolean then
										Result := 1
										l_return := True
									end
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							else
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (store_char ((linebuf.item[curr.item]).to_integer_32, 1, a_pos)).to_boolean then
										Result := 1
										l_return := True
									else
										curr.item := curr.item + 1
									end
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							end
						elseif (linebuf.item[curr.item]).to_integer_32 = 95 then
							if ((create {P_CHARSET_STATIC}).utf_mode.item.item).to_boolean then
								if ((a_c).bit_and (224)) = 192 then
									overstrike.item := 1
								elseif ((a_c).bit_and (240)) = 224 then
									overstrike.item := 2
								elseif ((a_c).bit_and (248)) = 240 then
									overstrike.item := 3
								end
							end
							if a_c = 9 then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (store_tab (1, a_pos)).to_boolean then
										Result := 1
										l_return := True
									end
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							else
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (store_char (a_c, 1, a_pos)).to_boolean then
										Result := 1
										l_return := True
									else
										curr.item := curr.item + 1
									end
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							end
						elseif ((create {P_CHARSET_STATIC}).control_char (a_c)).to_boolean then
							l_pos := -1 + 55 -- goto do_control_char
						elseif a_c = 9 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if (store_tab (0, a_pos)).to_boolean then
									Result := 1
									l_return := True
								end
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if (store_char (a_c, 0, a_pos)).to_boolean then
									Result := 1
									l_return := True
								else
									curr.item := curr.item + 1
								end
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
				when 48 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 67
				when 49 then -- else:
						if a_c /= 9 then
							l_pos := -1 + 54 -- skip if block
						end
				when 50 then -- if:
						inspect bs_mode.item.item -- switch 2 head
						when 2 then l_pos := -1 + 51
						when 1 then l_pos := -1 + 52
						when 0 then l_pos := -1 + 52
						else l_pos := -1 + 53
						end
				when 51 then -- switch 2, case 2
						l_pos := -1 + 55 -- goto do_control_char
				when 52 then -- switch 2, case 1 | switch 2, case 0
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if (store_tab (0, a_pos)).to_boolean then
								Result := 1
								l_return := True
							end
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
						l_pos := -1 + 53 -- switch 2; break
				when 53 then -- switch 2, done: | if block done, skip else block:
						l_pos := -1 + 67
				when 54 then -- else:
						if not (((create {P_CHARSET_STATIC}).control_char (a_c)).to_boolean) then
							l_pos := -1 + 66 -- skip if block
						end
				when 55 then -- if: | do_control_char:
						if ctldisp.item.item /= 1 then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						l_pos := -1 + 60 -- goto _L___14
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 65
				when 58 then -- else:
						if ctldisp.item.item /= 2 then
							l_pos := -1 + 64 -- skip if block
						end
				when 59 then -- if:
						if a_c /= 27 then
							l_pos := -1 + 62 -- skip if block
						end
				when 60 then -- if: | _L___14:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if (store_char (a_c, 0, a_pos)).to_boolean then
								Result := 1
								l_return := True
							else
								curr.item := curr.item + 1
							end
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 61 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 62 then -- else:
						l_pos := -1 + 64 -- goto _L___15
				when 63 then -- if done | if block done, skip else block:
						l_pos := -1 + 65
				when 64 then -- else: | _L___15:
						l_s := (create {P_CHARSET_STATIC}).prchar (a_c)
						l_a := (create {P_CHARSET_STATIC}).binattr.item
						l_tmp___18 := strlen (l_s)
						l_tmp___19 := attr_swidth (l_a)
						if ((column.item + l_tmp___18.to_integer_32) + l_tmp___19) + (attr_ewidth (l_a)) > (create {P_SCREEN_STATIC}).sc_width.item then
							Result := 1
							l_return := True
						end
						if not l_return then
							from
							until
								not (not (l_return) and then ((l_s[0]).to_integer_32 /= 0))
							loop
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (store_char ((l_s[0]).to_integer_32, l_a, a_pos)).to_boolean then
										Result := 1
										l_return := True
									else
										curr.item := curr.item + 1
									end
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
									l_s := l_s + 1
								end
							end
						end
				when 65 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 67
				when 66 then -- else:
						if a_c = 9 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if (store_tab (0, a_pos)).to_boolean then
									Result := 1
									l_return := True
								end
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if (store_char (a_c, 0, a_pos)).to_boolean then
									Result := 1
									l_return := True
								else
									curr.item := curr.item + 1
								end
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
				when 67 then -- if done | if done | if done
					if not l_return then
						Result := 0
					end
				when 68 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	pdone (a_endline: INTEGER_32)
		do
			if pendc.item.to_boolean then
				if pendc.item.to_integer_32 /= 13 then
					do_append (pendc.item.to_integer_32, pendpos.item).do_nothing
				elseif not a_endline.to_boolean then
					do_append (pendc.item.to_integer_32, pendpos.item).do_nothing
				end
			end
			if (create {P_FORWBACK_STATIC}).cshift.item < (create {P_COMMAND_STATIC}).hshift.item then
				pshift ((create {P_COMMAND_STATIC}).hshift.item - (create {P_FORWBACK_STATIC}).cshift.item)
			end
			if column.item < (create {P_SCREEN_STATIC}).sc_width.item then
				linebuf.item[curr.item] := (('%N').code).to_integer_8
				attr.item[curr.item] := (0).to_integer_8
				curr.item := curr.item + 1
			elseif not ((create {P_SCREEN_STATIC}).auto_wrap.item).to_boolean then
				linebuf.item[curr.item] := (('%N').code).to_integer_8
				attr.item[curr.item] := (0).to_integer_8
				curr.item := curr.item + 1
			elseif ((create {P_SCREEN_STATIC}).ignaw.item).to_boolean then
				linebuf.item[curr.item] := (('%N').code).to_integer_8
				attr.item[curr.item] := (0).to_integer_8
				curr.item := curr.item + 1
			elseif ctldisp.item.item = 1 then
				linebuf.item[curr.item] := (('%N').code).to_integer_8
				attr.item[curr.item] := (0).to_integer_8
				curr.item := curr.item + 1
			end
			linebuf.item[curr.item] := (('%/0/').code).to_integer_8
			attr.item[curr.item] := (0).to_integer_8
			if (status_col.item.item).to_boolean then
				if hilites.item > 0 then
					linebuf.item[0] := (('*').code).to_integer_8
					attr.item[0] := (5).to_integer_8
				end
			end
			if a_endline.to_boolean then
				(create {P_FORWBACK_STATIC}).cshift.item := 0
			end
		end

	gline (a_i: INTEGER_32; a_ap: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_ap.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			if is_null_line.item.to_boolean then
				a_ap.item := 2
				if (twiddle.item.item).to_boolean then
					l_s := ce_string ("~%N")
				else
					l_s := ce_string ("%N")
				end
				Result := (l_s[a_i]).to_integer_32
				l_return := True
			end
			if not l_return then
				a_ap.item := (attr.item[a_i]).to_integer_32
				Result := (((linebuf.item[a_i]).to_integer_32).bit_and (255))
			end
		end

	null_line
		do
			is_null_line.item := 1;
			(create {P_FORWBACK_STATIC}).cshift.item := 0
		end

	forw_raw_line (a_curr_pos: INTEGER_32; a_linep: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_n: INTEGER_32
			l_c: INTEGER_32
			l_new_pos: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if a_curr_pos = -1 then
				Result := (-1).to_integer_32
				l_return := True
			elseif ((create {P_CH_STATIC}).ch_seek (a_curr_pos)).to_boolean then
				Result := (-1).to_integer_32
				l_return := True
			else
				l_c := (create {P_CH_STATIC}).ch_forw_get
				if l_c = -1 then
					Result := (-1).to_integer_32
					l_return := True
				end
			end
			if not l_return then
				l_n := 0
				from
				until
					(l_break)
				loop
					l_break := False
					if l_c = 10 then
						l_new_pos := (create {P_CH_STATIC}).ch_tell
						l_break := True
					elseif l_c = -1 then
						l_new_pos := (create {P_CH_STATIC}).ch_tell
						l_break := True
					end
					if not (l_break) and then (l_n >= size_linebuf.item - 1) then
						if (expand_linebuf).to_boolean then
							l_new_pos := ((create {P_CH_STATIC}).ch_tell) - 1
							l_break := True
						end
					end
					if not (l_break) then
						l_tmp___2 := l_n
						l_n := l_n + 1
						linebuf.item[l_tmp___2] := l_c.to_integer_8
						l_c := (create {P_CH_STATIC}).ch_forw_get
					end
				end
				l_break := False
				linebuf.item[l_n] := (('%/0/').code).to_integer_8
				if not a_linep.is_void then
					a_linep.item := linebuf.item
				end
				Result := l_new_pos
			end
		end

	back_raw_line (a_curr_pos: INTEGER_32; a_linep: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_n: INTEGER_32
			l_c: INTEGER_32
			l_new_pos: INTEGER_32
			l_old_size_linebuf: INTEGER_32
			l_fm: CE_POINTER [INTEGER_8]
			l_to: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			if a_curr_pos = -1 then
				Result := (-1).to_integer_32
				l_return := True
			elseif a_curr_pos <= 0 then
				Result := (-1).to_integer_32
				l_return := True
			elseif ((create {P_CH_STATIC}).ch_seek (a_curr_pos - 1)).to_boolean then
				Result := (-1).to_integer_32
				l_return := True
			end
			if not l_return then
				l_n := size_linebuf.item
				l_n := l_n - 1
				linebuf.item[l_n] := (('%/0/').code).to_integer_8
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_c := (create {P_CH_STATIC}).ch_back_get
					if l_c = 10 then
						l_new_pos := ((create {P_CH_STATIC}).ch_tell) + 1
						l_break := True
					end
					if not (l_return or l_break) and then (l_c = -1) then
						l_new_pos := (0).to_integer_32
						l_break := True
					end
					if not (l_return or l_break) and then (l_n <= 0) then
						l_old_size_linebuf := size_linebuf.item
						if (expand_linebuf).to_boolean then
							l_new_pos := ((create {P_CH_STATIC}).ch_tell) + 1
							l_break := True
						end
						if not (l_return or l_break) then
							l_fm := linebuf.item + l_old_size_linebuf
							l_to := linebuf.item + size_linebuf.item
							from
							until
								not ((l_fm.c_pointer.to_integer_32).to_natural_32 >= (linebuf.item.c_pointer.to_integer_32).to_natural_32)
							loop
								l_to[0] := l_fm[0]
								l_fm := l_fm - 1
								l_to := l_to - 1
							end
							l_n := size_linebuf.item - l_old_size_linebuf
						end
					end
					if not (l_return or l_break) then
						l_n := l_n - 1
						linebuf.item[l_n] := l_c.to_integer_8
					end
				end
				l_break := False
				if not a_linep.is_void then
					a_linep.item := linebuf.item + l_n
				end
				Result := l_new_pos
			end
		end

end
