class
	P_MARK_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	marks: CE_STATIC [CE_ARRAY [PD_MARK]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MARK]}.make (<<53>>)
		end

	sm: CE_STATIC [CE_ARRAY [PD_MARK]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MARK]}.make (<<1>>)
		end

feature {ANY} -- public routines

	init_mark
		local
			l_i: INTEGER_32
		do
			l_i := 0
			from
			until
				not (l_i < 53)
			loop
				marks.item[l_i].m_scrpos.pos := (-1).to_integer_32
				l_i := l_i + 1
			end
		end

	getumark (a_c: INTEGER_32): CE_POINTER [PD_MARK]
		local
			l_return: BOOLEAN
		do
			if a_c >= 97 then
				if a_c <= 122 then
					Result := (marks.item + a_c - 97)
					l_return := True
				end
			end
			if not l_return and then (a_c >= 65) then
				if a_c <= 90 then
					Result := (marks.item + (a_c - 65) + 26)
					l_return := True
				end
			end
			if not l_return then
				(create {P_OUTPUT_STATIC}).error (ce_string ("Invalid mark letter"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
				Result := (create {CE_CLASS_POINTER [PD_MARK]}.make_shared (default_pointer))
			end
		end

	getmark (a_c: INTEGER_32): CE_POINTER [PD_MARK]
		local
			l_m: CE_POINTER [PD_MARK]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_c -- switch 1 head
					when 94 then l_pos := -1 + 1
					when 36 then l_pos := -1 + 2
					when 46 then l_pos := -1 + 3
					when 39 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 94
					l_m := sm.item
					l_m.item.m_scrpos.pos := (0).to_integer_32
					l_m.item.m_scrpos.ln := 0
					l_m.item.m_ifile := (create {P_MAIN_STATIC}).curr_ifile.item
					l_pos := -1 + 7 -- switch 1; break
				when 2 then -- switch 1, case 36
					if ((create {P_CH_STATIC}).ch_end_seek).to_boolean then
						(create {P_OUTPUT_STATIC}).error (ce_string ("Cannot seek to end of file"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						Result := (create {CE_CLASS_POINTER [PD_MARK]}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						l_m := sm.item
						l_m.item.m_scrpos.pos := (create {P_CH_STATIC}).ch_tell
						l_m.item.m_scrpos.ln := (create {P_SCREEN_STATIC}).sc_height.item - 1
						l_m.item.m_ifile := (create {P_MAIN_STATIC}).curr_ifile.item
					end
					l_pos := -1 + 7 -- switch 1; break
				when 3 then -- switch 1, case 46
					l_m := sm.item;
					(create {CE_CLASS_POINTER [PD_SCRPOS]}.make_shared (l_m.c_pointer + (create {PD_MARK}.make).offset_of ("m_scrpos"))).item.get_scrpos
					l_m.item.m_ifile := (create {P_MAIN_STATIC}).curr_ifile.item
					l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 39
					l_m := marks.item + 52
					l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, default:
					l_m := getumark (a_c)
					if l_m.is_void then
						l_pos := -1 + 7 -- switch 1; break
					end
				when 6 then
					if l_m.item.m_scrpos.pos = -1 then
						(create {P_OUTPUT_STATIC}).error (ce_string ("Mark not set"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						Result := (create {CE_CLASS_POINTER [PD_MARK]}.make_shared (default_pointer))
						l_return := True
					end
					l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
					if not l_return then
						Result := l_m
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	badmark (a_c: INTEGER_32): INTEGER_32
		do
			Result := ((getmark (a_c)).is_void).to_integer
		end

	setmark (a_c: INTEGER_32)
		local
			l_m: CE_POINTER [PD_MARK]
			l_scrpos: CE_ARRAY [PD_SCRPOS]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_SCRPOS]} l_scrpos.make (<<1>>)

			l_m := getumark (a_c)
			if l_m.is_void then
				l_return := True
			end
			if not l_return then
				l_scrpos.item.get_scrpos
				l_m.item.m_scrpos := (l_scrpos.item).twin
				l_m.item.m_ifile := (create {P_MAIN_STATIC}).curr_ifile.item
			end
		end

	lastmark
		local
			l_scrpos: CE_ARRAY [PD_SCRPOS]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_SCRPOS]} l_scrpos.make (<<1>>)

			if ((((create {P_CH_STATIC}).ch_getflags)).bit_and (8)).to_boolean then
				l_return := True
			end
			if not l_return then
				l_scrpos.item.get_scrpos
				if l_scrpos.item.pos = -1 then
					l_return := True
				end
			end
			if not l_return then
				marks.item[52].m_scrpos := (l_scrpos.item).twin
				marks.item[52].m_ifile := (create {P_MAIN_STATIC}).curr_ifile.item
			end
		end

	gomark (a_c: INTEGER_32)
		local
			l_m: CE_POINTER [PD_MARK]
			l_scrpos: PD_SCRPOS
			l_return: BOOLEAN
		do
			l_m := getmark (a_c)
			if l_m.is_void then
				l_return := True
			end
			if not l_return then
				if l_m.is_equal (marks.item + 52) then
					if l_m.item.m_scrpos.pos = -1 then
						l_m.item.m_ifile := (create {P_MAIN_STATIC}).curr_ifile.item
						l_m.item.m_scrpos.pos := (0).to_integer_32
						l_m.item.m_scrpos.ln := (create {P_MAIN_STATIC}).jump_sline.item.item
					end
				end
				l_scrpos := (l_m.item.m_scrpos).twin
				if not (l_m.item.m_ifile).is_equal ((create {P_MAIN_STATIC}).curr_ifile.item) then
					if ((create {P_EDIT_STATIC}).edit_ifile (l_m.item.m_ifile)).to_boolean then
						l_return := True
					end
				end
			end
			if not l_return then
				(create {P_JUMP_STATIC}).jump_loc (l_scrpos.pos, l_scrpos.ln)
			end
		end

	markpos (a_c: INTEGER_32): INTEGER_32
		local
			l_m: CE_POINTER [PD_MARK]
			l_return: BOOLEAN
		do
			l_m := getmark (a_c)
			if l_m.is_void then
				Result := (-1).to_integer_32
				l_return := True
			end
			if not l_return and then (not (l_m.item.m_ifile).is_equal ((create {P_MAIN_STATIC}).curr_ifile.item)) then
				(create {P_OUTPUT_STATIC}).error (ce_string ("Mark not in current file"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
				Result := (-1).to_integer_32
				l_return := True
			end
			if not l_return then
				Result := (l_m.item.m_scrpos.pos)
			end
		end

	unmark (a_ifile: CE_POINTER [ANY])
		local
			l_i: INTEGER_32
		do
			l_i := 0
			from
			until
				not (l_i < 53)
			loop
				if (marks.item[l_i].m_ifile).is_equal (a_ifile) then
					marks.item[l_i].m_scrpos.pos := (-1).to_integer_32
				end
				l_i := l_i + 1
			end
		end

end
