class
	P_OUTPUT_STATIC

inherit
	CE_UTILITIES
	S_UNISTD_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	need_clr: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	obuf: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<1_024>>)
		end

	ob: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := obuf.item
		end

	return_to_continue: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("  (press RETURN)%/0/")
		end

	intr_to_abort: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("... (interrupt to abort)%/0/")
		end

feature {ANY} -- public routines

	put_line
		local
			l_c: INTEGER_32
			l_i: INTEGER_32
			l_a: CE_ARRAY [INTEGER_32]
			l_curr_attr: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_a.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (((create {P_CH_STATIC}).sigs.item).bit_and (3)).to_boolean then
						(create {P_COMMAND_STATIC}).screen_trashed.item := 1
						l_return := True
					end
					if l_return then
						l_pos := -1 + 24 -- skip if block
					end
				when 1 then -- if:
						l_curr_attr := 0
						l_i := 0
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 18 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						l_c := (create {P_LINE_STATIC}).gline (l_i, l_a)
						if l_c = 0 then
							l_break := True
						end
						if (l_break or l_continue) then
							l_pos := -1 + 17 -- skip if block
						end
				when 4 then -- if:
						if l_a.item = l_curr_attr then
							l_pos := -1 + 16 -- skip if block
						end
				when 5 then -- if:
						inspect l_curr_attr -- switch 1 head
						when 1 then l_pos := -1 + 6
						when 2 then l_pos := -1 + 7
						when 3 then l_pos := -1 + 8
						when 5 then l_pos := -1 + 9
						else l_pos := -1 + 10
						end
				when 6 then -- switch 1, case 1;
						(create {P_SCREEN_STATIC}).ul_exit
						l_pos := -1 + 10 -- switch 1; break
				when 7 then -- switch 1, case 2;
						(create {P_SCREEN_STATIC}).bo_exit
						l_pos := -1 + 10 -- switch 1; break
				when 8 then -- switch 1, case 3;
						(create {P_SCREEN_STATIC}).bl_exit
						l_pos := -1 + 10 -- switch 1; break
				when 9 then -- switch 1, case 5;
						(create {P_SCREEN_STATIC}).so_exit
						l_pos := -1 + 10 -- switch 1; break
				when 10 then -- switch 1, done:
						inspect l_a.item -- switch 2 head
						when 1 then l_pos := -1 + 11
						when 2 then l_pos := -1 + 12
						when 3 then l_pos := -1 + 13
						when 5 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 11 then -- switch 2, case 1;
						(create {P_SCREEN_STATIC}).ul_enter
						l_pos := -1 + 15 -- switch 2; break
				when 12 then -- switch 2, case 2;
						(create {P_SCREEN_STATIC}).bo_enter
						l_pos := -1 + 15 -- switch 2; break
				when 13 then -- switch 2, case 3;
						(create {P_SCREEN_STATIC}).bl_enter
						l_pos := -1 + 15 -- switch 2; break
				when 14 then -- switch 2, case 5;
						(create {P_SCREEN_STATIC}).so_enter
						l_pos := -1 + 15 -- switch 2; break
				when 15 then -- switch 2, done:
						l_curr_attr := l_a.item
				when 16 then -- if done
						if l_curr_attr = 4 then
							l_continue := True
						end
				when 17 then -- if done
						if not (l_break or l_continue) then
							if l_c = 8 then
								(create {P_SCREEN_STATIC}).putbs
							else
								putchr (l_c).do_nothing
							end
						end
						if (not l_break) then
							l_i := l_i + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 18 then -- loop done
						l_break := False
						l_continue := False
						inspect l_curr_attr -- switch 3 head
						when 1 then l_pos := -1 + 19
						when 2 then l_pos := -1 + 20
						when 3 then l_pos := -1 + 21
						when 5 then l_pos := -1 + 22
						else l_pos := -1 + 23
						end
				when 19 then -- switch 3, case 1;
						(create {P_SCREEN_STATIC}).ul_exit
						l_pos := -1 + 23 -- switch 3; break
				when 20 then -- switch 3, case 2;
						(create {P_SCREEN_STATIC}).bo_exit
						l_pos := -1 + 23 -- switch 3; break
				when 21 then -- switch 3, case 3;
						(create {P_SCREEN_STATIC}).bl_exit
						l_pos := -1 + 23 -- switch 3; break
				when 22 then -- switch 3, case 5;
						(create {P_SCREEN_STATIC}).so_exit
						l_pos := -1 + 23 -- switch 3; break
				when 23 then -- switch 3, done:;
						(create {P_FORWBACK_STATIC}).final_attr.item := l_curr_attr
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	flush
		local
			l_n: INTEGER_32
			l_fd: INTEGER_32
			l_return: BOOLEAN
		do
			l_n := ob.item.distance (obuf.item)
			if l_n = 0 then
				l_return := True
			end
			if not l_return then
				if ((create {P_MAIN_STATIC}).any_display.item).to_boolean then
					l_fd := 1
				else
					l_fd := 2
				end
				if (write (l_fd, create {CE_VOID_POINTER}.make_cast (obuf.item), l_n.to_natural_32)) /= l_n then
					(create {P_COMMAND_STATIC}).screen_trashed.item := 1
				end
				ob.item := obuf.item
			end
		end

	putchr (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			if need_clr.item.to_boolean then
				need_clr.item := 0;
				(create {P_SCREEN_STATIC}).clear_bot
			end
			if (ob.item.c_pointer.to_integer_32).to_natural_32 >= ((obuf.item + (({PLATFORM}.Integer_8_bytes.to_natural_32 * (1_024).to_natural_32) - {NATURAL_32} 1).to_integer_32).c_pointer.to_integer_32).to_natural_32 then
				flush
			end
			l_tmp := ob.item
			ob.item := ob.item + 1
			l_tmp[0] := a_c.to_integer_8
			Result := a_c
		end

	putstr (a_s: CE_POINTER [INTEGER_8])
		require
			not a_s.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
		do
			l_s := a_s
			from
			until
				(l_s[0]).to_integer_32 = 0
			loop
				l_tmp := l_s
				l_s := l_s + 1
				putchr ((l_tmp[0]).to_integer_32).do_nothing
			end
		end

	postoa (a_num: INTEGER_32; a_buf___1: CE_POINTER [INTEGER_8])
		require
			not a_buf___1.is_void
		local
			l_num: INTEGER_32
			l_neg: INTEGER_32
			l_tbuf___0: CE_ARRAY [INTEGER_8]
			l_s: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_tbuf___0.make (<<((((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32>>)

			l_num := a_num
			l_neg := (l_num < 0).to_integer
			l_s := l_tbuf___0 + ({PLATFORM}.Integer_8_bytes.to_natural_32 * (((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32
			if l_neg.to_boolean then
				l_num := -l_num
			end
			l_s := l_s - 1
			l_s[0] := (('%/0/').code).to_integer_8
			from
			until
				(l_break)
			loop
				l_break := False
				l_s := l_s - 1
				l_s[0] := (l_num \\ 10 + 48).to_integer_8
				l_num := l_num // (10)
				if l_num = 0 then
					l_break := True
				end
			end
			l_break := False
			if l_neg.to_boolean then
				l_s := l_s - 1
				l_s[0] := (('-').code).to_integer_8
			end
			strcpy (a_buf___1, l_s).do_nothing
		end

	linenumtoa (a_num: INTEGER_32; a_buf___1: CE_POINTER [INTEGER_8])
		require
			not a_buf___1.is_void
		local
			l_num: INTEGER_32
			l_neg: INTEGER_32
			l_tbuf___0: CE_ARRAY [INTEGER_8]
			l_s: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_tbuf___0.make (<<((((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32>>)

			l_num := a_num
			l_neg := (l_num < 0).to_integer
			l_s := l_tbuf___0 + ({PLATFORM}.Integer_8_bytes.to_natural_32 * (((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32
			if l_neg.to_boolean then
				l_num := -l_num
			end
			l_s := l_s - 1
			l_s[0] := (('%/0/').code).to_integer_8
			from
			until
				(l_break)
			loop
				l_break := False
				l_s := l_s - 1
				l_s[0] := (l_num \\ 10 + 48).to_integer_8
				l_num := l_num // (10)
				if l_num = 0 then
					l_break := True
				end
			end
			l_break := False
			if l_neg.to_boolean then
				l_s := l_s - 1
				l_s[0] := (('-').code).to_integer_8
			end
			strcpy (a_buf___1, l_s).do_nothing
		end

	inttoa (a_num: INTEGER_32; a_buf___1: CE_POINTER [INTEGER_8])
		require
			not a_buf___1.is_void
		local
			l_num: INTEGER_32
			l_neg: INTEGER_32
			l_tbuf___0: CE_ARRAY [INTEGER_8]
			l_s: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_tbuf___0.make (<<((((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32>>)

			l_num := a_num
			l_neg := (l_num < 0).to_integer
			l_s := l_tbuf___0 + ({PLATFORM}.Integer_8_bytes.to_natural_32 * (((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32
			if l_neg.to_boolean then
				l_num := -l_num
			end
			l_s := l_s - 1
			l_s[0] := (('%/0/').code).to_integer_8
			from
			until
				(l_break)
			loop
				l_break := False
				l_s := l_s - 1
				l_s[0] := (l_num \\ 10 + 48).to_integer_8
				l_num := l_num // (10)
				if l_num = 0 then
					l_break := True
				end
			end
			l_break := False
			if l_neg.to_boolean then
				l_s := l_s - 1
				l_s[0] := (('-').code).to_integer_8
			end
			strcpy (a_buf___1, l_s).do_nothing
		end

	iprint_int (a_num: INTEGER_32): INTEGER_32
		local
			l_buf___1: CE_ARRAY [INTEGER_8]
		do
			create {CE_INTEGER_8_ARRAY} l_buf___1.make (<<(((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1).to_integer_32>>)

			inttoa (a_num, l_buf___1)
			putstr (l_buf___1)
			Result := (strlen (l_buf___1)).to_integer_32
		end

	iprint_linenum (a_num: INTEGER_32): INTEGER_32
		local
			l_buf___1: CE_ARRAY [INTEGER_8]
		do
			create {CE_INTEGER_8_ARRAY} l_buf___1.make (<<(((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1).to_integer_32>>)

			linenumtoa (a_num, l_buf___1)
			putstr (l_buf___1)
			Result := (strlen (l_buf___1)).to_integer_32
		end

	less_printf (a_fmt: CE_POINTER [INTEGER_8]; a_parg: CE_POINTER [PD_PARG]): INTEGER_32
		require
			not a_fmt.is_void
		local
			l_fmt: CE_POINTER [INTEGER_8]
			l_parg: CE_POINTER [PD_PARG]
			l_s: CE_POINTER [INTEGER_8]
			l_col: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fmt := a_fmt
					l_parg := a_parg
					l_col := 0
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_fmt[0]).to_integer_32 /= 0)) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						if (l_fmt[0]).to_integer_32 = 37 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_tmp := l_fmt
						l_fmt := l_fmt + 1
						putchr ((l_tmp[0]).to_integer_32).do_nothing
						l_col := l_col + 1
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						l_fmt := l_fmt + 1
						l_tmp___0 := l_fmt
						l_fmt := l_fmt + 1
						inspect (l_tmp___0[0]).to_integer_32 -- switch 1 head
						when 115 then l_pos := -1 + 6
						when 100 then l_pos := -1 + 7
						when 110 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 6 then -- switch 1, case 115
						l_s := l_parg.item.p_string
						l_parg := l_parg + 1
						from
						until
							(l_s[0]).to_integer_32 = 0
						loop
							l_tmp___1 := l_s
							l_s := l_s + 1
							putchr ((l_tmp___1[0]).to_integer_32).do_nothing
							l_col := l_col + 1
						end
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 100
						l_col := l_col + (iprint_int (l_parg.item.p_int))
						l_parg := l_parg + 1
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, case 110
						l_col := l_col + (iprint_linenum (l_parg.item.p_linenum))
						l_parg := l_parg + 1
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done: | if done
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					Result := l_col
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_return
		local
			l_c: INTEGER_32
		do
			l_c := (create {P_TTYIN_STATIC}).getchr
			if l_c /= 10 then
				if l_c /= 13 then
					if l_c /= 32 then
						if l_c /= -2 then
							(create {P_COMMAND_STATIC}).ungetcc (l_c)
						end
					end
				end
			end
		end

	error (a_fmt: CE_POINTER [INTEGER_8]; a_parg: CE_POINTER [PD_PARG])
		require
			not a_fmt.is_void
		local
			l_col: INTEGER_32
			l_return: BOOLEAN
		do
			l_col := 0;
			(create {P_EDIT_STATIC}).errmsgs.item := (create {P_EDIT_STATIC}).errmsgs.item + 1
			if ((create {P_MAIN_STATIC}).any_display.item).to_boolean then
				if ((create {P_MAIN_STATIC}).is_tty.item).to_boolean then
					(create {P_SCREEN_STATIC}).clear_bot;
					(create {P_SCREEN_STATIC}).so_enter
					l_col := l_col + ((create {P_SCREEN_STATIC}).so_s_width.item)
				end
			end
			l_col := l_col + (less_printf (a_fmt, a_parg))
			if ((create {P_MAIN_STATIC}).any_display.item).to_boolean then
				if not ((create {P_MAIN_STATIC}).is_tty.item).to_boolean then
					putchr (('%N').code).do_nothing
					l_return := True
				end
			else
				putchr (('%N').code).do_nothing
				l_return := True
			end
			if not l_return then
				putstr (return_to_continue.item);
				(create {P_SCREEN_STATIC}).so_exit
				l_col := (l_col.to_natural_32 + (({PLATFORM}.Integer_8_bytes.to_natural_32 * (17).to_natural_32) + ((create {P_SCREEN_STATIC}).so_e_width.item).to_natural_32)).to_integer_32
				get_return;
				(create {P_SCREEN_STATIC}).lower_left
				if l_col >= (create {P_SCREEN_STATIC}).sc_width.item then
					(create {P_COMMAND_STATIC}).screen_trashed.item := 1
				end
				flush
			end
		end

	ierror (a_fmt: CE_POINTER [INTEGER_8]; a_parg: CE_POINTER [PD_PARG])
		require
			not a_fmt.is_void
		do
			(create {P_SCREEN_STATIC}).clear_bot;
			(create {P_SCREEN_STATIC}).so_enter
			less_printf (a_fmt, a_parg).do_nothing
			putstr (intr_to_abort.item);
			(create {P_SCREEN_STATIC}).so_exit
			flush
			need_clr.item := 1
		end

	query (a_fmt: CE_POINTER [INTEGER_8]; a_parg: CE_POINTER [PD_PARG]): INTEGER_32
		require
			not a_fmt.is_void
		local
			l_c: INTEGER_32
			l_col: INTEGER_32
			l_return: BOOLEAN
		do
			l_col := 0
			if ((create {P_MAIN_STATIC}).any_display.item).to_boolean then
				if ((create {P_MAIN_STATIC}).is_tty.item).to_boolean then
					(create {P_SCREEN_STATIC}).clear_bot
				end
			end
			less_printf (a_fmt, a_parg).do_nothing
			l_c := (create {P_TTYIN_STATIC}).getchr
			if ((create {P_MAIN_STATIC}).any_display.item).to_boolean then
				if not ((create {P_MAIN_STATIC}).is_tty.item).to_boolean then
					putchr (('%N').code).do_nothing
					Result := l_c
					l_return := True
				end
			else
				putchr (('%N').code).do_nothing
				Result := l_c
				l_return := True
			end
			if not l_return then
				(create {P_SCREEN_STATIC}).lower_left
				if l_col >= (create {P_SCREEN_STATIC}).sc_width.item then
					(create {P_COMMAND_STATIC}).screen_trashed.item := 1
				end
				flush
				Result := l_c
			end
		end

feature {ANY} -- routine addresses

	putchr_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent putchr)
		end

end
