class
	PD_PARG

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	p_string: CE_POINTER [INTEGER_8] assign set_p_string

	p_int: INTEGER_32 assign set_p_int

	p_linenum: INTEGER_32 assign set_p_linenum

feature {ANY} -- field setters

	set_p_string (a_p_string: CE_POINTER [INTEGER_8])
		do
			p_string := a_p_string
			update_memory_field ("p_string")
		end

	set_p_int (a_p_int: INTEGER_32)
		do
			p_int := a_p_int
			update_memory_field ("p_int")
		end

	set_p_linenum (a_p_linenum: INTEGER_32)
		do
			p_linenum := a_p_linenum
			update_memory_field ("p_linenum")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			p_string := a_other.p_string
			p_int := a_other.p_int
			p_linenum := a_other.p_linenum
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				p_string.is_equal (a_other.p_string) and
				p_int = a_other.p_int and
				p_linenum = a_other.p_linenum
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("p_string"),
					create {CE_STRUCTURE_FIELD}.make ("p_int"),
					create {CE_STRUCTURE_FIELD}.make ("p_linenum")
				>>)
			init_structure_info
		end

end
