class
	PD_SCRPOS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	pos: INTEGER_32 assign set_pos

	ln: INTEGER_32 assign set_ln

feature {ANY} -- field setters

	set_pos (a_pos: INTEGER_32)
		do
			pos := a_pos
			update_memory_field ("pos")
		end

	set_ln (a_ln: INTEGER_32)
		do
			ln := a_ln
			update_memory_field ("ln")
		end

feature {ANY} -- public routines

	store_pos (a_ifile: CE_POINTER [ANY])
		do
			(create {CE_CLASS_POINTER [PD_IFILE]}.make_cast (a_ifile)).item.h_scrpos := twin
			update_class_fields -- Current might have been changed; synchronize
		end

	get_scrpos
		local
			l_i: INTEGER_32
			l_return: BOOLEAN
		do
			l_i := 0
			from
			until
				not (not (l_return) and then (l_i < (create {P_SCREEN_STATIC}).sc_height.item))
			loop
				if (create {P_POSITION_STATIC}).table.item[l_i] /= -1 then
					Current.ln := l_i + 1
					update_class_fields -- Current might have been changed; synchronize
					Current.pos := (create {P_POSITION_STATIC}).table.item[l_i]
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Current.pos := (-1).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pos := a_other.pos
			ln := a_other.ln
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pos = a_other.pos and
				ln = a_other.ln
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pos"),
					create {CE_STRUCTURE_FIELD}.make ("ln")
				>>)
			init_structure_info
		end

end
