class
	PD_TAG

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	PD_TAGLIST
		rename
			tl_first as next,
			tl_last as prev
		redefine
			make,
			copy,
			is_equal,
			structure_info
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} tag_file.make
			create {CE_INTEGER_8_POINTER} tag_pattern.make
			Precursor
		end

feature {ANY} -- fields

	tag_file: CE_POINTER [INTEGER_8] assign set_tag_file

	tag_linenum: INTEGER_32 assign set_tag_linenum

	tag_pattern: CE_POINTER [INTEGER_8] assign set_tag_pattern

	tag_endline: INTEGER_8 assign set_tag_endline

feature {ANY} -- field setters

	set_tag_file (a_tag_file: CE_POINTER [INTEGER_8])
		do
			tag_file := a_tag_file
			update_memory_field ("tag_file")
		end

	set_tag_linenum (a_tag_linenum: INTEGER_32)
		do
			tag_linenum := a_tag_linenum
			update_memory_field ("tag_linenum")
		end

	set_tag_pattern (a_tag_pattern: CE_POINTER [INTEGER_8])
		do
			tag_pattern := a_tag_pattern
			update_memory_field ("tag_pattern")
		end

	set_tag_endline (a_tag_endline: INTEGER_8)
		do
			tag_endline := a_tag_endline
			update_memory_field ("tag_endline")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			Precursor {PD_TAGLIST} (a_other)
			tag_file := a_other.tag_file
			tag_linenum := a_other.tag_linenum
			tag_pattern := a_other.tag_pattern
			tag_endline := a_other.tag_endline
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				Precursor {PD_TAGLIST} (a_other) and
				tag_file.is_equal (a_other.tag_file) and
				tag_linenum = a_other.tag_linenum and
				tag_pattern.is_equal (a_other.tag_pattern) and
				tag_endline = a_other.tag_endline
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tag_file"),
					create {CE_STRUCTURE_FIELD}.make ("tag_linenum"),
					create {CE_STRUCTURE_FIELD}.make ("tag_pattern"),
					create {CE_STRUCTURE_FIELD}.make ("tag_endline")
				>>)
			Result.set_superclasses (<<{PD_TAGLIST}>>)
			Result.add_rename ("tl_first", "next")
			Result.add_rename ("tl_last", "prev")
			init_structure_info
		end

end
