class
	P_CSS_URL_STATIC

inherit
	CE_UTILITIES
	S_BITS_ERRNO_STATIC
	S_STRING_STATIC
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public attributes

	token_names: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("CSSEOF"),
					ce_string ("S"),
					ce_string ("CDO"),
					ce_string ("CDC"),
					ce_string ("INCLUDES"),
					ce_string ("DASHMATCH"),
					ce_string ("LBRACE"),
					ce_string ("PLUS"),
					ce_string ("GREATER"),
					ce_string ("COMMA"),
					ce_string ("STRING"),
					ce_string ("INVALID"),
					ce_string ("IDENT"),
					ce_string ("HASH"),
					ce_string ("IMPORT_SYM"),
					ce_string ("PAGE_SYM"),
					ce_string ("MEDIA_SYM"),
					ce_string ("CHARSET_SYM"),
					ce_string ("IMPORTANT_SYM"),
					ce_string ("EMS"),
					ce_string ("EXS"),
					ce_string ("LENGTH"),
					ce_string ("ANGLE"),
					ce_string ("TIME"),
					ce_string ("FREQ"),
					ce_string ("DIMENSION"),
					ce_string ("PERCENTAGE"),
					ce_string ("NUMBER"),
					ce_string ("URI"),
					ce_string ("FUNCTION")
				>>)
		end

feature {ANY} -- public routines

	get_urls_css_file (a_file, a_url: CE_POINTER [INTEGER_8]): CE_POINTER [PD_URLPOS]
		local
			l_fm: CE_POINTER [PD_FILE_MEMORY]
			l_ctx: CE_ARRAY [PD_MAP_CONTEXT]
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_MAP_CONTEXT]} l_ctx.make (<<1>>)

			l_fm := (create {P_UTILS_STATIC}).read_file (a_file)
			if l_fm.is_void then
				(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_file, (strerror ((errno_location).item))])
				Result := (create {CE_CLASS_POINTER [PD_URLPOS]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Loaded %%s (size %%s).%N"), a_file, ((create {P_UTILS_STATIC}).number_to_static_string ((l_fm.item.length).to_integer_64))])
					end
					l_break := True
				end
				l_break := False
				l_ctx.item.text := l_fm.item.content
				l_ctx.item.tail := create {CE_CLASS_POINTER [PD_URLPOS]}.make_shared (default_pointer)
				l_ctx.item.head := l_ctx.item.tail
				l_ctx.item.base := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				if (not a_url.is_void) then
					l_ctx.item.parent_base := a_url
				else
					l_ctx.item.parent_base := (create {P_OPTIONS_STATIC}).opt.item.item.base_href
				end
				l_ctx.item.document_file := a_file
				l_ctx.item.nofollow := (0).to_boolean
				l_ctx.item.get_urls_css (0, (l_fm.item.length).to_integer_32)
				l_fm.item.read_file_free
				Result := (l_ctx.item.head)
			end
		end

end
