class
	P_GETPASS_STATIC

inherit
	CE_UTILITIES
	S_STDIO_STATIC
	S_STDIO_EXT_STATIC
	S_TERMIOS_STATIC

feature {ANY} -- public attributes

	buf___5: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make (<<1>>)
		end

	bufsize: CE_STATIC [CE_ARRAY [NATURAL_32]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_32_ARRAY}.make (<<1>>)
		end

feature {ANY} -- public routines

	call_fclose (a_arg: CE_POINTER [ANY])
		do
			if not a_arg.is_void then
				fclose (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_arg)).do_nothing
			end
		end

	gnu_getpass (a_prompt: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_tty: CE_POINTER [SD_IO_FILE]
			l_in: CE_POINTER [SD_IO_FILE]
			l_out: CE_POINTER [SD_IO_FILE]
			l_s: CE_ARRAY [SD_TERMIOS]
			l_t: CE_ARRAY [SD_TERMIOS]
			l_tty_changed: BOOLEAN
			l_nread: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_TERMIOS]} l_s.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TERMIOS]} l_t.make (<<1>>)

			l_tty_changed := (0).to_boolean
			l_tty := fopen (ce_string ("/dev/tty"), ce_string ("w+"))
			if l_tty.is_void then
				l_in := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer))
				l_out := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))
			else
				fsetlocking (l_tty, 2).do_nothing
				l_in := l_tty
				l_out := l_in
			end
			flockfile (l_out)
			if (tcgetattr ((fileno (l_in)), l_t)) = 0 then
				l_s.item := (l_t.item).twin
				l_t.item.c2_lflag := (l_t.item.c2_lflag).bit_and (({NATURAL_32} 4_294_967_286))
				l_tty_changed := ((tcsetattr ((fileno (l_in)), 2, l_t)) = 0)
			end
			fputs_unlocked (a_prompt, l_out).do_nothing
			fflush_unlocked (l_out).do_nothing
			l_nread := getline (buf___5.item, bufsize.item, l_in)
			fseeko (l_out, (0).to_integer_32, 1).do_nothing
			if not (buf___5.item.item).is_void then
				if l_nread < 0 then
					buf___5.item.item[0] := (('%/0/').code).to_integer_8
				elseif (buf___5.item.item[(l_nread - 1)]).to_integer_32 = 10 then
					buf___5.item.item[(l_nread - 1)] := (('%/0/').code).to_integer_8
					if l_tty_changed then
						putc_unlocked (('%N').code, l_out).do_nothing
					end
				end
			end
			if l_tty_changed then
				tcsetattr ((fileno (l_in)), 2, l_s).do_nothing
			end
			funlockfile (l_out)
			call_fclose (create {CE_VOID_POINTER}.make_cast (l_tty))
			Result := (buf___5.item.item)
		end

end
