class
	P_HTTP_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_ASSERT_STATIC
	S_LIBINTL_STATIC
	S_STDLIB_STATIC
	S_TIME_STATIC
	S_STDIO_STATIC
	S_SYS_STAT_STATIC
	S_BITS_ERRNO_STATIC
	S_LOCALE_STATIC

feature {ANY} -- public attributes

	cookies_loaded_p: CE_STATIC [BOOLEAN]
		once ("PROCESS")
		end

	wget_cookie_jar: CE_STATIC [CE_POINTER [PD_COOKIE_JAR]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_COOKIE_JAR]}.make
		end

	pconn: CE_STATIC [CE_ARRAY [PD_PCONN]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_PCONN]}.make (<<1>>)
		end

	time_formats: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("%%a, %%d %%b %%Y %%T"),
					ce_string ("%%A, %%d-%%b-%%y %%T"),
					ce_string ("%%a %%b %%d %%T %%Y"),
					ce_string ("%%a, %%d-%%b-%%Y %%T")
				>>)
		end

feature {ANY} -- public routines

	response_head_terminator (a_start, a_peeked: CE_POINTER [INTEGER_8]; a_peeklen: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_POINTER} l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_start.is_equal (a_peeked) then
						if a_peeklen > 4 then
							l_tmp := 4
						else
							l_tmp := a_peeklen
						end
						if 0 /= (memcmp (create {CE_VOID_POINTER}.make_cast (a_start), create {CE_VOID_POINTER}.make_cast (ce_string ("HTTP")), l_tmp.to_natural_32)) then
							Result := a_start
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_peeked.distance (a_start) < 2 then
							l_p___0 := a_start
						else
							l_p___0 := a_peeked - 2
						end
						l_end := a_peeked + a_peeklen
				when 2 then -- loop condition:
						if not (not (l_return) and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_end - 2).c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						if (l_p___0[0]).to_integer_32 /= 10 then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if (l_p___0[1]).to_integer_32 /= 13 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (l_p___0[2]).to_integer_32 = 10 then
							Result := (l_p___0 + 3)
							l_return := True
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if (l_p___0[1]).to_integer_32 = 10 then
							Result := (l_p___0 + 2)
							l_return := True
						end
				when 8 then -- if done
						if not l_return then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done | if done
					if not l_return and then ((l_p___0[0]).to_integer_32 = 10) then
						if (l_p___0[1]).to_integer_32 = 10 then
							Result := (l_p___0 + 2)
							l_return := True
						end
					end
					if not l_return then
						Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	http_loop (a_u: CE_POINTER [PD_URL]; a_newloc, a_local_file: CE_POINTER [CE_POINTER [INTEGER_8]]; a_referer: CE_POINTER [INTEGER_8]; a_dt: CE_POINTER [INTEGER_32]; a_proxy: CE_POINTER [PD_URL]; a_iri: CE_POINTER [PD_IRI]): NATURAL_32
		require
			not a_newloc.is_void
			not a_dt.is_void
		local
			l_count: INTEGER_32
			l_got_head: BOOLEAN
			l_time_came_from_head: BOOLEAN
			l_got_name: BOOLEAN
			l_tms: CE_POINTER [INTEGER_8]
			l_tmrate: CE_POINTER [INTEGER_8]
			l_err: NATURAL_32
			l_ret: NATURAL_32
			l_tmr: INTEGER_32
			l_hstat: CE_ARRAY [PD_HTTP_STAT]
			l_st: CE_ARRAY [SD_STAT]
			l_send_head_first: BOOLEAN
			l_file_name: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_hurl: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_ARRAY [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_hurl___0: CE_POINTER [INTEGER_8]
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_tmp___22: CE_POINTER [INTEGER_8]
			l_tmp___25: CE_POINTER [INTEGER_8]
			l_tmp___26: CE_POINTER [INTEGER_8]
			l_tmp___27: CE_POINTER [INTEGER_8]
			l_finished: BOOLEAN
			l_tmp___35: CE_POINTER [INTEGER_8]
			l_fl: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_newtmr: INTEGER_32
			l_write_to_stdout: BOOLEAN
			l_tmp___37: INTEGER_32
			l_tmp___38: CE_POINTER [INTEGER_8]
			l_tmp___39: CE_POINTER [INTEGER_8]
			l_tmp___41: CE_POINTER [INTEGER_8]
			l_tmp___44: CE_POINTER [INTEGER_8]
			l_tmp___45: CE_POINTER [INTEGER_8]
			l_write_to_stdout___0: BOOLEAN
			l_tmp___47: INTEGER_32
			l_tmp___48: CE_POINTER [INTEGER_8]
			l_tmp___50: CE_POINTER [INTEGER_8]
			l_tmp___53: CE_POINTER [INTEGER_8]
			l_tmp___55: CE_POINTER [INTEGER_8]
			l_tmp___57: CE_POINTER [INTEGER_8]
			l_tmp___59: CE_POINTER [INTEGER_8]
			l_tmp___60: CE_POINTER [INTEGER_8]
			l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_HTTP_STAT]} l_hstat.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_tmp___10.make (<<256>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_fl.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_got_head := (0).to_boolean
					l_time_came_from_head := (0).to_boolean
					l_got_name := (0).to_boolean
					l_ret := {PC_UERR_T}.TRYLIMEXC
					l_tmr := (-1).to_integer_32
					l_send_head_first := (1).to_boolean
					if not (a_local_file.is_void) then
						if not ((a_local_file.item).is_void) then
							assert_fail (ce_string ("local_file == ((void *)0) || *local_file == ((void *)0)"), ce_string ("http.c"), {NATURAL_32} 2_430, ce_string ("http_loop"))
						end
					end
					if (not a_local_file.is_void) then
						if (not ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void) then
							if (((create {P_OPTIONS_STATIC}).opt.item.item.output_document).item).to_integer_32 = 45 then
								if not ((create {P_OPTIONS_STATIC}).opt.item.item.output_document[1]).to_boolean then
									a_local_file.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								else
									l_tmp := (create {P_XMALLOC_STATIC}).xstrdup ((create {P_OPTIONS_STATIC}).opt.item.item.output_document)
									a_local_file.item := l_tmp
								end
							else
								l_tmp := (create {P_XMALLOC_STATIC}).xstrdup ((create {P_OPTIONS_STATIC}).opt.item.item.output_document)
								a_local_file.item := l_tmp
							end
						end
					end
					a_newloc.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					if (create {P_OPTIONS_STATIC}).opt.item.item.cookies then
						load_cookies
					end
					if (create {P_OPTIONS_STATIC}).opt.item.item.ftp_glob then
						if ((create {P_UTILS_STATIC}).has_wildcards_p (a_u.item.path)) then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Warning: wildcards not supported in HTTP.%N"))))
						end
					end
					memset (create {CE_VOID_POINTER}.make_cast (l_hstat), ('%/0/').code, (create {PD_HTTP_STAT}.make).structure_size.to_natural_32).do_nothing
					l_hstat.item.referer := a_referer
					if (not ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void) then
						l_hstat.item.local_file := (create {P_XMALLOC_STATIC}).xstrdup ((create {P_OPTIONS_STATIC}).opt.item.item.output_document)
						l_got_name := (1).to_boolean
					elseif not (create {P_OPTIONS_STATIC}).opt.item.item.content_disposition then
						l_hstat.item.local_file := a_u.item.url_file_name
						l_got_name := (1).to_boolean
					end
					if l_got_name then
						if ((create {P_UTILS_STATIC}).file_exists_p (l_hstat.item.local_file)) then
							if (create {P_OPTIONS_STATIC}).opt.item.item.noclobber then
								if ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void then
									l_tmp___2 := (create {P_QUOTE_STATIC}).quote (l_hstat.item.local_file);
									(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("File %%s already there; not retrieving.%N%N"))), l_tmp___2])
									a_dt.item := (a_dt.item).bit_or ((2))
									if ((create {P_UTILS_STATIC}).has_html_suffix_p (l_hstat.item.local_file)) then
										a_dt.item := (a_dt.item).bit_or ((1))
									end
									l_ret := {PC_UERR_T}.RETROK
									l_pos := -1 + 53 -- goto exit
								end
							end
						end
					end
				when 1 then
					l_count := 0
					a_dt.item := 0
					if not (create {P_OPTIONS_STATIC}).opt.item.item.spider then
						if l_got_name then
							l_send_head_first := (0).to_boolean
						elseif not (create {P_OPTIONS_STATIC}).opt.item.item.content_disposition then
							l_send_head_first := (0).to_boolean
						end
					end
					l_file_name := a_u.item.url_file_name
					if (create {P_OPTIONS_STATIC}).opt.item.item.timestamping then
						if not (create {P_OPTIONS_STATIC}).opt.item.item.content_disposition then
							if ((create {P_UTILS_STATIC}).file_exists_p (l_file_name)) then
								l_send_head_first := (1).to_boolean
							end
						end
					end
					free (create {CE_VOID_POINTER}.make_cast (l_file_name))
				when 2 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 52 -- skip loop
					end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						l_count := l_count + 1;
						(create {P_RETR_STATIC}).sleep_between_retrievals (l_count)
						l_tms := (create {P_UTILS_STATIC}).datetime_str ((time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))))
						if (create {P_OPTIONS_STATIC}).opt.item.item.spider then
							if not l_got_head then
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Spider mode enabled. Check if remote file exists.%N")))])
							end
						end
						if ((create {P_OPTIONS_STATIC}).opt.item.item.verbose).to_boolean then
							l_hurl := (a_u.item.url_string ({PC_URL_AUTH_MODE}.URL_AUTH_HIDE_PASSWD))
							if l_count > 1 then
								sprintf ([l_tmp___10, (gettext (ce_string ("(try:%%2d)"))), l_count]).do_nothing;
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("--%%s--  %%s  %%s%N"), l_tms, l_tmp___10, l_hurl])
							else
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("--%%s--  %%s%N"), l_tms, l_hurl])
							end
							free (create {CE_VOID_POINTER}.make_cast (l_hurl))
						end
						if l_send_head_first then
							if not l_got_head then
								a_dt.item := (a_dt.item).bit_or ((4))
							else
								a_dt.item := (a_dt.item).bit_and ((-5))
							end
						else
							a_dt.item := (a_dt.item).bit_and ((-5))
						end
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.always_rest) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_got_name then
							if (stat (l_hstat.item.local_file, l_st)) = 0 then
								if ((l_st.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 32_768 then
									l_hstat.item.restval := (l_st.item.st_size).to_integer_64
								else
									l_pos := -1 + 6 -- goto _L___1
								end
							else
								l_pos := -1 + 6 -- goto _L___1
							end
						else
							l_pos := -1 + 6 -- goto _L___1
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___1:
						if l_count > 1 then
							l_hstat.item.restval := l_hstat.item.len
						else
							l_hstat.item.restval := (0).to_integer_64
						end
				when 7 then
						if a_proxy.is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_count > 1 then
							a_dt.item := (a_dt.item).bit_or ((8))
						else
							l_pos := -1 + 10 -- goto _L___2
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___2:
						if not (create {P_OPTIONS_STATIC}).opt.item.item.allow_cache then
							a_dt.item := (a_dt.item).bit_or ((8))
						else
							a_dt.item := (a_dt.item).bit_and ((-9))
						end
				when 11 then
						l_err := a_u.item.gethttp (l_hstat, a_dt, a_proxy, a_iri)
						l_tms := (create {P_UTILS_STATIC}).datetime_str ((time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))))
						if (not (l_hstat.item.newloc).is_void) then
							a_newloc.item := (create {P_XMALLOC_STATIC}).xstrdup (l_hstat.item.newloc)
						end
						inspect l_err.to_integer_32 -- switch 1 head
						when 30 then l_pos := -1 + 12
						when 29 then l_pos := -1 + 12
						when 2 then l_pos := -1 + 12
						when 9 then l_pos := -1 + 12
						when 3 then l_pos := -1 + 12
						when 40 then l_pos := -1 + 12
						when 52 then l_pos := -1 + 12
						when 44 then l_pos := -1 + 12
						when 25 then l_pos := -1 + 12
						when 26 then l_pos := -1 + 13
						when 24 then l_pos := -1 + 13
						when 1 then l_pos := -1 + 14
						when 5 then l_pos := -1 + 14
						when 49 then l_pos := -1 + 14
						when 50 then l_pos := -1 + 14
						when 53 then l_pos := -1 + 14
						when 37 then l_pos := -1 + 14
						when 54 then l_pos := -1 + 14
						when 4 then l_pos := -1 + 15
						when 6 then l_pos := -1 + 16
						when 38 then l_pos := -1 + 17
						when 39 then l_pos := -1 + 18
						else l_pos := -1 + 19
						end
				when 12 then -- switch 1, case 30 | switch 1, case 29 | switch 1, case 2 | switch 1, case 9 | switch 1, case 3 | switch 1, case 40 | switch 1, case 52 | switch 1, case 44 | switch 1, case 25;
						(create {P_RETR_STATIC}).printwhat (l_count, (create {P_OPTIONS_STATIC}).opt.item.item.ntry)
						l_continue := True
				when 13 then -- switch 1, case 26 | switch 1, case 24
						if not (l_break or l_continue) then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							l_tmp___15 := strerror ((errno_location).item)
							l_tmp___16 := (create {P_QUOTE_STATIC}).quote (l_hstat.item.local_file);
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cannot write to %%s (%%s).%N"))), l_tmp___16, l_tmp___15])
						end
				when 14 then -- switch 1, case 1 | switch 1, case 5 | switch 1, case 49 | switch 1, case 50 | switch 1, case 53 | switch 1, case 37 | switch 1, case 54
						if not (l_break or l_continue) then
							l_ret := l_err
							l_pos := -1 + 53 -- goto exit
						end
				when 15 then -- switch 1, case 4
						if not (l_break or l_continue) then
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Unable to establish SSL connection.%N")))])
							l_ret := l_err
							l_pos := -1 + 53 -- goto exit
						end
				when 16 then -- switch 1, case 6
						if not (l_break or l_continue) then
							if (a_newloc.item).is_void then
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("ERROR: Redirection (%%d) without location.%N"))), l_hstat.item.statcode])
								l_ret := {PC_UERR_T}.WRONGCODE
							else
								l_ret := {PC_UERR_T}.NEWLOCATION
							end
							l_pos := -1 + 53 -- goto exit
						end
				when 17 then -- switch 1, case 38
						if not (l_break or l_continue) then
							l_ret := {PC_UERR_T}.RETROK
							l_pos := -1 + 53 -- goto exit
						end
				when 18 then -- switch 1, case 39
						l_pos := -1 + 20 -- switch 1; break
				when 19 then -- switch 1, default:
						abort
				when 20 then -- switch 1, done:
						if not (not (l_break or l_continue) and then (not ((a_dt.item).bit_and (2)).to_boolean)) then
							l_pos := -1 + 26 -- skip if block
						end
				when 21 then -- if:
						l_hurl___0 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.verbose).to_boolean then
							l_hurl___0 := a_u.item.url_string ({PC_URL_AUTH_MODE}.URL_AUTH_HIDE_PASSWD);
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NONVERBOSE, ce_string ("%%s:%N"), l_hurl___0])
						end
						if not (((a_dt.item).bit_and (4)).to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if l_hstat.item.statcode = 500 then
							l_got_head := (1).to_boolean
							l_continue := True
						elseif l_hstat.item.statcode = 501 then
							l_got_head := (1).to_boolean
							l_continue := True
						else
							l_pos := -1 + 24 -- goto _L___3
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L___3:
						if (create {P_OPTIONS_STATIC}).opt.item.item.spider then
							if not a_iri.item.utf8_encode then
								if l_hurl___0.is_void then
									l_hurl___0 := a_u.item.url_string ({PC_URL_AUTH_MODE}.URL_AUTH_HIDE_PASSWD)
								end
								(create {P_SPIDER_STATIC}).nonexisting_url (l_hurl___0);
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Remote file does not exist -- broken link!!!%N")))])
							else
								l_tmp___21 := (create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_hstat.item.error)
								l_tmp___22 := gettext (ce_string ("%%s ERROR %%d: %%s.%N"));
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___22, l_tms, l_hstat.item.statcode, l_tmp___21])
							end
						else
							l_tmp___21 := (create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_hstat.item.error)
							l_tmp___22 := gettext (ce_string ("%%s ERROR %%d: %%s.%N"));
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___22, l_tms, l_hstat.item.statcode, l_tmp___21])
						end
				when 25 then
						if not (l_break or l_continue) then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							l_ret := {PC_UERR_T}.WRONGCODE
							if (not l_hurl___0.is_void) then
								free (create {CE_VOID_POINTER}.make_cast (l_hurl___0))
							end
							l_pos := -1 + 53 -- goto exit
						end
				when 26 then
						if not (not (l_break or l_continue) and then (not l_got_head)) then
							l_pos := -1 + 41 -- skip if block
						end
				when 27 then -- if:
						l_got_head := (1).to_boolean
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.timestamping) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if (l_hstat.item.remote_time).is_void then
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Last-modified header missing -- time-stamps turned off.%N"))))
						else
							l_pos := -1 + 30 -- goto _L___4
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else: | _L___4:
						if (not (l_hstat.item.remote_time).is_void) then
							l_tmr := http_atotm (l_hstat.item.remote_time)
							if l_tmr = -1 then
								(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Last-modified header invalid -- time-stamp ignored.%N"))))
							end
							if ((a_dt.item).bit_and (4)).to_boolean then
								l_time_came_from_head := (1).to_boolean
							end
						end
				when 31 then
						if not l_send_head_first then
							l_pos := -1 + 41 -- skip if block
						end
				when 32 then -- if:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.timestamping) then
							l_pos := -1 + 39 -- skip if block
						end
				when 33 then -- if:
						if (l_hstat.item.orig_file_name).is_void then
							l_pos := -1 + 38 -- skip if block
						end
				when 34 then -- if:
						if (l_hstat.item.remote_time).is_void then
							l_pos := -1 + 38 -- skip if block
						end
				when 35 then -- if:
						if l_tmr = -1 then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						if l_hstat.item.orig_file_tstamp >= l_tmr then
							if l_hstat.item.contlen = -{INTEGER_64} 1 then
								l_tmp___25 := (create {P_QUOTE_STATIC}).quote (l_hstat.item.orig_file_name)
								l_tmp___26 := gettext (ce_string ("Server file no newer than local file %%s -- not retrieving.%N%N"));
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___26, l_tmp___25])
								l_ret := {PC_UERR_T}.RETROK
								l_pos := -1 + 53 -- goto exit
							elseif l_hstat.item.orig_file_size = l_hstat.item.contlen then
								l_tmp___25 := (create {P_QUOTE_STATIC}).quote (l_hstat.item.orig_file_name)
								l_tmp___26 := gettext (ce_string ("Server file no newer than local file %%s -- not retrieving.%N%N"));
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___26, l_tmp___25])
								l_ret := {PC_UERR_T}.RETROK
								l_pos := -1 + 53 -- goto exit
							else
								l_tmp___27 := (create {P_UTILS_STATIC}).number_to_static_string (l_hstat.item.orig_file_size);
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("The sizes do not match (local %%s) -- retrieving.%N"))), l_tmp___27])
							end
						else
							(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Remote file is newer, retrieving.%N"))))
						end
				when 37 then;
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
				when 38 then -- if done | if done | if done
						l_hstat.item.timestamp_checked := (1).to_boolean
				when 39 then -- if done
						if (create {P_OPTIONS_STATIC}).opt.item.item.spider then
							l_finished := (1).to_boolean
							if (create {P_OPTIONS_STATIC}).opt.item.item.recursive then
								if ((a_dt.item).bit_and (1)).to_boolean then
									(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Remote file exists and could contain links to other resources -- retrieving.%N%N"))))
									l_finished := (0).to_boolean
								else
									(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Remote file exists but does not contain any link -- not retrieving.%N%N")))])
									l_ret := {PC_UERR_T}.RETROK
								end
							else
								if ((a_dt.item).bit_and (1)).to_boolean then
									(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Remote file exists and could contain further links,%Nbut recursion is disabled -- not retrieving.%N%N")))])
								else
									(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Remote file exists.%N%N")))])
								end
								l_ret := {PC_UERR_T}.RETROK
							end
							if l_finished then
								if (not (l_hstat.item.message).is_void) then
									l_tmp___35 := ((create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_hstat.item.message))
								else
									l_tmp___35 := ce_string ("")
								end
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NONVERBOSE, (gettext (ce_string ("%%s URL: %%s %%2d %%s%N"))), l_tms, a_u.item.url, l_hstat.item.statcode, l_tmp___35])
								l_pos := -1 + 53 -- goto exit
							end
						end
				when 40 then
						l_got_name := (1).to_boolean
						a_dt.item := (a_dt.item).bit_and ((-5))
						l_count := 0
						l_continue := True
				when 41 then -- if done | if done
						if (l_break or l_continue) then
							l_pos := -1 + 50 -- skip if block
						end
				when 42 then -- if:
						if l_tmr = -1 then
							l_pos := -1 + 49 -- skip if block
						end
				when 43 then -- if:
						if l_hstat.item.len /= l_hstat.item.contlen then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						l_pos := -1 + 48 -- goto _L___5
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 46 then -- else:
						if l_hstat.item.res /= 0 then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						if l_hstat.item.contlen /= -{INTEGER_64} 1 then
							l_pos := -1 + 49 -- skip if block
						end
				when 48 then -- if: | _L___5:
						l_fl.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer);
						(create {P_RETR_STATIC}).set_local_file (l_fl, l_hstat.item.local_file)
						if (not (l_fl.item).is_void) then
							l_newtmr := (-1).to_integer_32
							if l_time_came_from_head then
								if (not (l_hstat.item.remote_time).is_void) then
									if (l_hstat.item.remote_time[0]).to_boolean then
										l_newtmr := http_atotm (l_hstat.item.remote_time)
										if l_newtmr /= -1 then
											l_tmr := l_newtmr
										end
									end
								end
							end
							(create {P_UTILS_STATIC}).touch (l_fl.item, l_tmr)
						end
				when 49 then -- if done | if done | if done
						l_tmrate := (create {P_RETR_STATIC}).retr_rate (l_hstat.item.rd_size, l_hstat.item.dltime);
						(create {P_RETR_STATIC}).total_download_time.item := (create {P_RETR_STATIC}).total_download_time.item + (l_hstat.item.dltime)
						if l_hstat.item.len = l_hstat.item.contlen then
							if ((a_dt.item).bit_and (2)).to_boolean then
								if (not ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void) then
									if (((create {P_OPTIONS_STATIC}).opt.item.item.output_document).item).to_integer_32 = 45 then
										if not ((create {P_OPTIONS_STATIC}).opt.item.item.output_document[1]).to_boolean then
											l_tmp___37 := 1
										else
											l_tmp___37 := 0
										end
									else
										l_tmp___37 := 0
									end
								else
									l_tmp___37 := 0
								end
								l_write_to_stdout := l_tmp___37.to_boolean
								l_tmp___38 := (create {P_UTILS_STATIC}).number_to_static_string (l_hstat.item.contlen)
								l_tmp___39 := (create {P_UTILS_STATIC}).number_to_static_string (l_hstat.item.len)
								if l_write_to_stdout then
									l_tmp___41 := ce_string ("")
								else
									l_tmp___41 := ((create {P_QUOTE_STATIC}).quote (l_hstat.item.local_file))
								end
								if l_write_to_stdout then
									l_tmp___44 := (gettext (ce_string ("%%s (%%s) - written to stdout %%s[%%s/%%s]%N%N")))
								else
									l_tmp___44 := (gettext (ce_string ("%%s (%%s) - %%s saved [%%s/%%s]%N%N")))
								end
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___44, l_tms, l_tmrate, l_tmp___41, l_tmp___39, l_tmp___38])
								l_tmp___45 := (create {P_UTILS_STATIC}).number_to_static_string (l_hstat.item.contlen);
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NONVERBOSE, ce_string ("%%s URL:%%s [%%s/%%s] -> %"%%s%" [%%d]%N"), l_tms, a_u.item.url, ((create {P_UTILS_STATIC}).number_to_static_string (l_hstat.item.len)), l_tmp___45, l_hstat.item.local_file, l_count])
							end
							(create {P_MAIN_STATIC}).numurls.item := (create {P_MAIN_STATIC}).numurls.item + 1;
							(create {P_RETR_STATIC}).total_downloaded_bytes.item := (create {P_RETR_STATIC}).total_downloaded_bytes.item + (l_hstat.item.len)
							if ((a_dt.item).bit_and (32)).to_boolean then
								(create {P_CONVERT_STATIC}).downloaded_file ({PC_DOWNLOADED_FILE_T}.FILE_DOWNLOADED_AND_HTML_EXTENSION_ADDED, l_hstat.item.local_file).do_nothing
							else
								(create {P_CONVERT_STATIC}).downloaded_file ({PC_DOWNLOADED_FILE_T}.FILE_DOWNLOADED_NORMALLY, l_hstat.item.local_file).do_nothing
							end
							l_ret := {PC_UERR_T}.RETROK
							l_pos := -1 + 53 -- goto exit
						elseif l_hstat.item.res = 0 then
							if l_hstat.item.contlen = -{INTEGER_64} 1 then
								if ((a_dt.item).bit_and (2)).to_boolean then
									if (not ((create {P_OPTIONS_STATIC}).opt.item.item.output_document).is_void) then
										if (((create {P_OPTIONS_STATIC}).opt.item.item.output_document).item).to_integer_32 = 45 then
											if not ((create {P_OPTIONS_STATIC}).opt.item.item.output_document[1]).to_boolean then
												l_tmp___47 := 1
											else
												l_tmp___47 := 0
											end
										else
											l_tmp___47 := 0
										end
									else
										l_tmp___47 := 0
									end
									l_write_to_stdout___0 := l_tmp___47.to_boolean
									l_tmp___48 := (create {P_UTILS_STATIC}).number_to_static_string (l_hstat.item.len)
									if l_write_to_stdout___0 then
										l_tmp___50 := ce_string ("")
									else
										l_tmp___50 := ((create {P_QUOTE_STATIC}).quote (l_hstat.item.local_file))
									end
									if l_write_to_stdout___0 then
										l_tmp___53 := (gettext (ce_string ("%%s (%%s) - written to stdout %%s[%%s]%N%N")))
									else
										l_tmp___53 := (gettext (ce_string ("%%s (%%s) - %%s saved [%%s]%N%N")))
									end
									(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___53, l_tms, l_tmrate, l_tmp___50, l_tmp___48]);
									(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NONVERBOSE, ce_string ("%%s URL:%%s [%%s] -> %"%%s%" [%%d]%N"), l_tms, a_u.item.url, ((create {P_UTILS_STATIC}).number_to_static_string (l_hstat.item.len)), l_hstat.item.local_file, l_count])
								end
								(create {P_MAIN_STATIC}).numurls.item := (create {P_MAIN_STATIC}).numurls.item + 1;
								(create {P_RETR_STATIC}).total_downloaded_bytes.item := (create {P_RETR_STATIC}).total_downloaded_bytes.item + (l_hstat.item.len)
								if ((a_dt.item).bit_and (32)).to_boolean then
									(create {P_CONVERT_STATIC}).downloaded_file ({PC_DOWNLOADED_FILE_T}.FILE_DOWNLOADED_AND_HTML_EXTENSION_ADDED, l_hstat.item.local_file).do_nothing
								else
									(create {P_CONVERT_STATIC}).downloaded_file ({PC_DOWNLOADED_FILE_T}.FILE_DOWNLOADED_NORMALLY, l_hstat.item.local_file).do_nothing
								end
								l_ret := {PC_UERR_T}.RETROK
								l_pos := -1 + 53 -- goto exit
							elseif l_hstat.item.len < l_hstat.item.contlen then
								l_tmp___55 := (create {P_UTILS_STATIC}).number_to_static_string (l_hstat.item.len);
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("%%s (%%s) - Connection closed at byte %%s. "))), l_tms, l_tmrate, l_tmp___55]);
								(create {P_RETR_STATIC}).printwhat (l_count, (create {P_OPTIONS_STATIC}).opt.item.item.ntry)
								l_continue := True
							elseif l_hstat.item.len /= l_hstat.item.restval then
								abort
							else
								l_ret := {PC_UERR_T}.RETROK
								l_pos := -1 + 53 -- goto exit
							end
						elseif l_hstat.item.contlen = -{INTEGER_64} 1 then
							l_tmp___57 := (create {P_UTILS_STATIC}).number_to_static_string (l_hstat.item.len);
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("%%s (%%s) - Read error at byte %%s (%%s)."))), l_tms, l_tmrate, l_tmp___57, l_hstat.item.rderrmsg]);
							(create {P_RETR_STATIC}).printwhat (l_count, (create {P_OPTIONS_STATIC}).opt.item.item.ntry)
							l_continue := True
						else
							l_tmp___59 := (create {P_UTILS_STATIC}).number_to_static_string (l_hstat.item.contlen)
							l_tmp___60 := (create {P_UTILS_STATIC}).number_to_static_string (l_hstat.item.len);
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("%%s (%%s) - Read error at byte %%s/%%s (%%s). "))), l_tms, l_tmrate, l_tmp___60, l_tmp___59, l_hstat.item.rderrmsg]);
							(create {P_RETR_STATIC}).printwhat (l_count, (create {P_OPTIONS_STATIC}).opt.item.item.ntry)
							l_continue := True
						end
				when 50 then
						if (not l_break) and then (((create {P_OPTIONS_STATIC}).opt.item.item.ntry).to_boolean) then
							if not (l_count < (create {P_OPTIONS_STATIC}).opt.item.item.ntry) then
								l_pos := -1 + 52 -- break
							end
						end
				when 51 then
						l_pos := -1 + 2 -- back to loop condition
				when 52 then -- loop done
					l_break := False
					l_continue := False
				when 53 then -- exit:
					if l_ret = {NATURAL_32} 31 then
						a_local_file.item := (create {P_XMALLOC_STATIC}).xstrdup (l_hstat.item.local_file)
					end
					l_hstat.item.free_hstat
					Result := l_ret
				when 54 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_end (a_p___0: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_p___0
					if l_p___0.is_void then
						Result := (0).to_boolean
						l_return := True
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
								l_break := True
							end
							if not (l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						if (l_p___0[0]).to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						Result := (1).to_boolean
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						if (l_p___0[0]).to_integer_32 /= 71 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (l_p___0[1]).to_integer_32 = 77 then
							if (l_p___0[2]).to_integer_32 = 84 then
								Result := (1).to_boolean
							else
								l_pos := -1 + 7 -- goto _L___1
							end
						else
							l_pos := -1 + 7 -- goto _L___1
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else: | _L___1:
						if (l_p___0[0]).to_integer_32 /= 43 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if (l_p___0[0]).to_integer_32 /= 45 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if: | _L:
						if ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[1]).to_integer_32)) then
							Result := (1).to_boolean
						else
							Result := (0).to_boolean
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						Result := (0).to_boolean
				when 14 then -- if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	http_atotm (a_time_string: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_oldlocale: CE_POINTER [INTEGER_8]
			l_savedlocale: CE_ARRAY [INTEGER_8]
			l_i: NATURAL_32
			l_ret: INTEGER_32
			l_l: NATURAL_32
			l_t: CE_ARRAY [SD_TM]
			l_break: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_savedlocale.make (<<256>>)
			create {CE_CLASS_ARRAY [SD_TM]} l_t.make (<<1>>)

			l_ret := (-1).to_integer_32
			l_oldlocale := (setlocale (2, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)))
			if (not l_oldlocale.is_void) then
				l_l := (strlen (l_oldlocale))
				if l_l >= ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32) then
					l_savedlocale[0] := (('%/0/').code).to_integer_8
				else
					memcpy (create {CE_VOID_POINTER}.make_cast (l_savedlocale), create {CE_VOID_POINTER}.make_cast (l_oldlocale), l_l).do_nothing
				end
			else
				l_savedlocale[0] := (('%/0/').code).to_integer_8
			end
			setlocale (2, ce_string ("C")).do_nothing
			l_i := (0).to_natural_32
			from
			until
				not (not (l_break) and then (l_i < ({PLATFORM}.Pointer_bytes.to_natural_32 * (4).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32))
			loop
				l_break := False
				memset (create {CE_VOID_POINTER}.make_cast (l_t), ('%/0/').code, (create {SD_TM}.make).structure_size.to_natural_32).do_nothing
				if (check_end ((strptime (a_time_string, time_formats.item[l_i.to_integer_32], l_t)))) then
					l_ret := timegm (l_t)
					l_break := True
				end
				if not (l_break) then
					l_i := l_i + 1
				end
			end
			l_break := False
			if (l_savedlocale[0]).to_boolean then
				setlocale (2, l_savedlocale).do_nothing
			end
			Result := l_ret
		end

	load_cookies
		do
			if wget_cookie_jar.item.is_void then
				wget_cookie_jar.item := (create {P_COOKIES_STATIC}).cookie_jar_new
			end
			if (not ((create {P_OPTIONS_STATIC}).opt.item.item.cookies_input).is_void) then
				if not cookies_loaded_p.item then
					(create {P_COOKIES_STATIC}).cookie_jar_load (wget_cookie_jar.item, (create {P_OPTIONS_STATIC}).opt.item.item.cookies_input)
					cookies_loaded_p.item := (1).to_boolean
				end
			end
		end

	save_cookies
		do
			if (not wget_cookie_jar.item.is_void) then
				(create {P_COOKIES_STATIC}).cookie_jar_save (wget_cookie_jar.item, (create {P_OPTIONS_STATIC}).opt.item.item.cookies_output)
			end
		end

	http_cleanup
		do
			if (not (pconn.item.item.host).is_void) then
				free (create {CE_VOID_POINTER}.make_cast (pconn.item.item.host))
			end
			if (not wget_cookie_jar.item.is_void) then
				wget_cookie_jar.item.item.cookie_jar_delete
			end
		end

feature {ANY} -- routine addresses

	response_head_terminator_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent response_head_terminator)
		end

end
