class
	P_MD5_STATIC

inherit
	CE_UTILITIES
	S_STDIO_STATIC

feature {ANY} -- public routines

	md5_stream (a_stream: CE_POINTER [SD_IO_FILE]; a_resblock: CE_POINTER [ANY]): INTEGER_32
		local
			l_ctx: CE_ARRAY [PD_MD5_CTX]
			l_buffer___0: CE_ARRAY [INTEGER_8]
			l_sum: NATURAL_32
			l_n: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_MD5_CTX]} l_ctx.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_buffer___0.make (<<4_168>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ctx.item.md5_init_ctx
				when 1 then -- loop condition:
					if (l_return) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						l_sum := (0).to_natural_32
				when 3 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 8 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						l_n := fread (create {CE_VOID_POINTER}.make_cast ((l_buffer___0 + l_sum.to_integer_32)), (1).to_natural_32, {NATURAL_32} 4_096 - l_sum, a_stream)
						l_sum := l_sum + l_n
						if l_sum = {NATURAL_32} 4_096 then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_n = {NATURAL_32} 0 then
							if (ferror (a_stream)).to_boolean then
								Result := 1
								l_return := True
							end
							if not l_return then
								l_pos := -1 + 10 -- goto process_partial_block
							end
						end
				when 6 then
						if not l_return then
							if (feof (a_stream)).to_boolean then
								l_pos := -1 + 10 -- goto process_partial_block
							end
						end
				when 7 then
						l_pos := -1 + 3 -- back to loop condition
				when 8 then -- loop done
						if not l_return then
							l_break := False
							l_ctx.item.md5_process_block (create {CE_VOID_POINTER}.make_cast (l_buffer___0), (4_096).to_natural_32)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 10 then -- if: | process_partial_block:
						if l_sum > {NATURAL_32} 0 then
							l_ctx.item.md5_process_bytes (create {CE_VOID_POINTER}.make_cast (l_buffer___0), l_sum)
						end
						l_ctx.item.md5_finish_ctx (a_resblock).do_nothing
						Result := 0
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	md5_buffer (a_buffer___0: CE_POINTER [INTEGER_8]; a_len: NATURAL_32; a_resblock: CE_POINTER [ANY]): CE_POINTER [ANY]
		local
			l_ctx: CE_ARRAY [PD_MD5_CTX]
		do
			create {CE_CLASS_ARRAY [PD_MD5_CTX]} l_ctx.make (<<1>>)

			l_ctx.item.md5_init_ctx
			l_ctx.item.md5_process_bytes (create {CE_VOID_POINTER}.make_cast (a_buffer___0), a_len)
			Result := (l_ctx.item.md5_finish_ctx (a_resblock))
		end

end
