class
	P_SPIDER_STATIC

inherit
	CE_UTILITIES
	S_LIBINTL_STATIC
	S_ASSERT_STATIC

feature {ANY} -- public attributes

	nonexisting_urls_set: CE_STATIC [CE_POINTER [PD_HASH_TABLE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make
		end

feature {ANY} -- public routines

	spider_cleanup
		do
			if (not nonexisting_urls_set.item.is_void) then
				nonexisting_urls_set.item.item.string_set_free
			end
		end

	nonexisting_url (a_url: CE_POINTER [INTEGER_8])
		local
			l_return: BOOLEAN
		do
			if ((create {P_RES_STATIC}).is_robots_txt_url (a_url)) then
				l_return := True
			end
			if not l_return then
				if nonexisting_urls_set.item.is_void then
					nonexisting_urls_set.item := (create {P_HASH_STATIC}).make_string_hash_table (0)
				end
				nonexisting_urls_set.item.item.string_set_add (a_url)
			end
		end

	print_broken_links
		local
			l_iter: CE_ARRAY [PD_HASH_TABLE_ITERATOR]
			l_num_elems: INTEGER_32
			l_url: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_HASH_TABLE_ITERATOR]} l_iter.make (<<1>>)

			if nonexisting_urls_set.item.is_void then
				(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Found no broken links.%N%N")))])
				l_return := True
			end
			if not l_return then
				l_num_elems := nonexisting_urls_set.item.item.hash_table_count
				if not (l_num_elems > 0) then
					assert_fail (ce_string ("num_elems > 0"), ce_string ("spider.c"), {NATURAL_32} 79, ce_string ("print_broken_links"))
				end
				(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (ngettext (ce_string ("Found %%d broken link.%N%N"), ce_string ("Found %%d broken links.%N%N"), l_num_elems.to_natural_32)), l_num_elems])
				nonexisting_urls_set.item.item.hash_table_iterate (l_iter)
				from
				until
					(l_break)
				loop
					l_break := False
					if not (l_iter.item.hash_table_iter_next).to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_url := create {CE_INTEGER_8_POINTER}.make_cast (l_iter.item.key);
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s%N"))), l_url])
					end
				end
				l_break := False;
				(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%N"))
			end
		end

end
