class
	PD_ATTR_PAIR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} name.make
			create {CE_INTEGER_8_POINTER} value.make
			create {CE_INTEGER_8_POINTER} value_raw_beginning.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	value: CE_POINTER [INTEGER_8] assign set_value

	value_raw_beginning: CE_POINTER [INTEGER_8] assign set_value_raw_beginning

	value_raw_size: INTEGER_32 assign set_value_raw_size

	name_pool_index: INTEGER_32 assign set_name_pool_index

	value_pool_index: INTEGER_32 assign set_value_pool_index

feature {ANY} -- field setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_value (a_value: CE_POINTER [INTEGER_8])
		do
			value := a_value
			update_memory_field ("value")
		end

	set_value_raw_beginning (a_value_raw_beginning: CE_POINTER [INTEGER_8])
		do
			value_raw_beginning := a_value_raw_beginning
			update_memory_field ("value_raw_beginning")
		end

	set_value_raw_size (a_value_raw_size: INTEGER_32)
		do
			value_raw_size := a_value_raw_size
			update_memory_field ("value_raw_size")
		end

	set_name_pool_index (a_name_pool_index: INTEGER_32)
		do
			name_pool_index := a_name_pool_index
			update_memory_field ("name_pool_index")
		end

	set_value_pool_index (a_value_pool_index: INTEGER_32)
		do
			value_pool_index := a_value_pool_index
			update_memory_field ("value_pool_index")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			value := a_other.value
			value_raw_beginning := a_other.value_raw_beginning
			value_raw_size := a_other.value_raw_size
			name_pool_index := a_other.name_pool_index
			value_pool_index := a_other.value_pool_index
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				value.is_equal (a_other.value) and
				value_raw_beginning.is_equal (a_other.value_raw_beginning) and
				value_raw_size = a_other.value_raw_size and
				name_pool_index = a_other.name_pool_index and
				value_pool_index = a_other.value_pool_index
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("value"),
					create {CE_STRUCTURE_FIELD}.make ("value_raw_beginning"),
					create {CE_STRUCTURE_FIELD}.make ("value_raw_size"),
					create {CE_STRUCTURE_FIELD}.make ("name_pool_index"),
					create {CE_STRUCTURE_FIELD}.make ("value_pool_index")
				>>)
			init_structure_info
		end

end
