class
	PD_COMMANDS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} name.make
			create {CE_VOID_POINTER} place.make
			create action.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	place: CE_POINTER [ANY] assign set_place

	action: CE_ROUTINE assign set_action

feature {ANY} -- field setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_place (a_place: CE_POINTER [ANY])
		do
			place := a_place
			update_memory_field ("place")
		end

	set_action (a_action: CE_ROUTINE)
		do
			action := a_action
			update_memory_field ("action")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			place := a_other.place
			action := a_other.action
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				place.is_equal (a_other.place) and
				action.is_equal (a_other.action)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("place"),
					create {CE_STRUCTURE_FIELD}.make ("action")
				>>)
			init_structure_info
		end

end
