class
	PD_HTTP_STAT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} rderrmsg.make
			create {CE_INTEGER_8_POINTER} newloc.make
			create {CE_INTEGER_8_POINTER} remote_time.make
			create {CE_INTEGER_8_POINTER} error.make
			create {CE_INTEGER_8_POINTER} message.make
			create {CE_INTEGER_8_POINTER} referer.make
			create {CE_INTEGER_8_POINTER} local_file.make
			create {CE_INTEGER_8_POINTER} orig_file_name.make
			Precursor
		end

feature {ANY} -- fields

	len: INTEGER_64 assign set_len

	contlen: INTEGER_64 assign set_contlen

	restval: INTEGER_64 assign set_restval

	res: INTEGER_32 assign set_res

	rderrmsg: CE_POINTER [INTEGER_8] assign set_rderrmsg

	newloc: CE_POINTER [INTEGER_8] assign set_newloc

	remote_time: CE_POINTER [INTEGER_8] assign set_remote_time

	error: CE_POINTER [INTEGER_8] assign set_error

	statcode: INTEGER_32 assign set_statcode

	message: CE_POINTER [INTEGER_8] assign set_message

	rd_size: INTEGER_64 assign set_rd_size

	dltime: REAL_64 assign set_dltime

	referer: CE_POINTER [INTEGER_8] assign set_referer

	local_file: CE_POINTER [INTEGER_8] assign set_local_file

	existence_checked: BOOLEAN assign set_existence_checked

	timestamp_checked: BOOLEAN assign set_timestamp_checked

	orig_file_name: CE_POINTER [INTEGER_8] assign set_orig_file_name

	orig_file_size: INTEGER_64 assign set_orig_file_size

	orig_file_tstamp: INTEGER_32 assign set_orig_file_tstamp

feature {ANY} -- field setters

	set_len (a_len: INTEGER_64)
		do
			len := a_len
			update_memory_field ("len")
		end

	set_contlen (a_contlen: INTEGER_64)
		do
			contlen := a_contlen
			update_memory_field ("contlen")
		end

	set_restval (a_restval: INTEGER_64)
		do
			restval := a_restval
			update_memory_field ("restval")
		end

	set_res (a_res: INTEGER_32)
		do
			res := a_res
			update_memory_field ("res")
		end

	set_rderrmsg (a_rderrmsg: CE_POINTER [INTEGER_8])
		do
			rderrmsg := a_rderrmsg
			update_memory_field ("rderrmsg")
		end

	set_newloc (a_newloc: CE_POINTER [INTEGER_8])
		do
			newloc := a_newloc
			update_memory_field ("newloc")
		end

	set_remote_time (a_remote_time: CE_POINTER [INTEGER_8])
		do
			remote_time := a_remote_time
			update_memory_field ("remote_time")
		end

	set_error (a_error: CE_POINTER [INTEGER_8])
		do
			error := a_error
			update_memory_field ("error")
		end

	set_statcode (a_statcode: INTEGER_32)
		do
			statcode := a_statcode
			update_memory_field ("statcode")
		end

	set_message (a_message: CE_POINTER [INTEGER_8])
		do
			message := a_message
			update_memory_field ("message")
		end

	set_rd_size (a_rd_size: INTEGER_64)
		do
			rd_size := a_rd_size
			update_memory_field ("rd_size")
		end

	set_dltime (a_dltime: REAL_64)
		do
			dltime := a_dltime
			update_memory_field ("dltime")
		end

	set_referer (a_referer: CE_POINTER [INTEGER_8])
		do
			referer := a_referer
			update_memory_field ("referer")
		end

	set_local_file (a_local_file: CE_POINTER [INTEGER_8])
		do
			local_file := a_local_file
			update_memory_field ("local_file")
		end

	set_existence_checked (a_existence_checked: BOOLEAN)
		do
			existence_checked := a_existence_checked
			update_memory_field ("existence_checked")
		end

	set_timestamp_checked (a_timestamp_checked: BOOLEAN)
		do
			timestamp_checked := a_timestamp_checked
			update_memory_field ("timestamp_checked")
		end

	set_orig_file_name (a_orig_file_name: CE_POINTER [INTEGER_8])
		do
			orig_file_name := a_orig_file_name
			update_memory_field ("orig_file_name")
		end

	set_orig_file_size (a_orig_file_size: INTEGER_64)
		do
			orig_file_size := a_orig_file_size
			update_memory_field ("orig_file_size")
		end

	set_orig_file_tstamp (a_orig_file_tstamp: INTEGER_32)
		do
			orig_file_tstamp := a_orig_file_tstamp
			update_memory_field ("orig_file_tstamp")
		end

feature {ANY} -- public routines

	free_hstat
		do
			if (not newloc.is_void) then
				free (create {CE_VOID_POINTER}.make_cast (newloc))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not remote_time.is_void) then
				free (create {CE_VOID_POINTER}.make_cast (remote_time))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not error.is_void) then
				free (create {CE_VOID_POINTER}.make_cast (error))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not rderrmsg.is_void) then
				free (create {CE_VOID_POINTER}.make_cast (rderrmsg))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not local_file.is_void) then
				free (create {CE_VOID_POINTER}.make_cast (local_file))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not orig_file_name.is_void) then
				free (create {CE_VOID_POINTER}.make_cast (orig_file_name))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not message.is_void) then
				free (create {CE_VOID_POINTER}.make_cast (message))
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.newloc := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Current.remote_time := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Current.error := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			len := a_other.len
			contlen := a_other.contlen
			restval := a_other.restval
			res := a_other.res
			rderrmsg := a_other.rderrmsg
			newloc := a_other.newloc
			remote_time := a_other.remote_time
			error := a_other.error
			statcode := a_other.statcode
			message := a_other.message
			rd_size := a_other.rd_size
			dltime := a_other.dltime
			referer := a_other.referer
			local_file := a_other.local_file
			existence_checked := a_other.existence_checked
			timestamp_checked := a_other.timestamp_checked
			orig_file_name := a_other.orig_file_name
			orig_file_size := a_other.orig_file_size
			orig_file_tstamp := a_other.orig_file_tstamp
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				len = a_other.len and
				contlen = a_other.contlen and
				restval = a_other.restval and
				res = a_other.res and
				rderrmsg.is_equal (a_other.rderrmsg) and
				newloc.is_equal (a_other.newloc) and
				remote_time.is_equal (a_other.remote_time) and
				error.is_equal (a_other.error) and
				statcode = a_other.statcode and
				message.is_equal (a_other.message) and
				rd_size = a_other.rd_size and
				dltime = a_other.dltime and
				referer.is_equal (a_other.referer) and
				local_file.is_equal (a_other.local_file) and
				existence_checked = a_other.existence_checked and
				timestamp_checked = a_other.timestamp_checked and
				orig_file_name.is_equal (a_other.orig_file_name) and
				orig_file_size = a_other.orig_file_size and
				orig_file_tstamp = a_other.orig_file_tstamp
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("len"),
					create {CE_STRUCTURE_FIELD}.make ("contlen"),
					create {CE_STRUCTURE_FIELD}.make ("restval"),
					create {CE_STRUCTURE_FIELD}.make ("res"),
					create {CE_STRUCTURE_FIELD}.make ("rderrmsg"),
					create {CE_STRUCTURE_FIELD}.make ("newloc"),
					create {CE_STRUCTURE_FIELD}.make ("remote_time"),
					create {CE_STRUCTURE_FIELD}.make ("error"),
					create {CE_STRUCTURE_FIELD}.make ("statcode"),
					create {CE_STRUCTURE_FIELD}.make ("message"),
					create {CE_STRUCTURE_FIELD}.make ("rd_size"),
					create {CE_STRUCTURE_FIELD}.make ("dltime"),
					create {CE_STRUCTURE_FIELD}.make ("referer"),
					create {CE_STRUCTURE_FIELD}.make ("local_file"),
					create {CE_STRUCTURE_FIELD}.make ("existence_checked"),
					create {CE_STRUCTURE_FIELD}.make ("timestamp_checked"),
					create {CE_STRUCTURE_FIELD}.make ("orig_file_name"),
					create {CE_STRUCTURE_FIELD}.make ("orig_file_size"),
					create {CE_STRUCTURE_FIELD}.make ("orig_file_tstamp")
				>>)
			init_structure_info
		end

end
