class
	PD_LOG_LN

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_ARRAY} static_line.make (<<129>>)
			create {CE_INTEGER_8_POINTER} malloced_line.make
			create {CE_INTEGER_8_POINTER} content.make
		end

feature {ANY} -- fields

	static_line: CE_ARRAY [INTEGER_8]

	malloced_line: CE_POINTER [INTEGER_8] assign set_malloced_line

	content: CE_POINTER [INTEGER_8] assign set_content

feature {ANY} -- field setters

	set_malloced_line (a_malloced_line: CE_POINTER [INTEGER_8])
		do
			malloced_line := a_malloced_line
			update_memory_field ("malloced_line")
		end

	set_content (a_content: CE_POINTER [INTEGER_8])
		do
			content := a_content
			update_memory_field ("content")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			static_line := a_other.static_line.twin
			malloced_line := a_other.malloced_line
			content := a_other.content
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				static_line.is_equal (a_other.static_line) and
				malloced_line.is_equal (a_other.malloced_line) and
				content.is_equal (a_other.content)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("static_line", <<129>>),
					create {CE_STRUCTURE_FIELD}.make ("malloced_line"),
					create {CE_STRUCTURE_FIELD}.make ("content")
				>>)
			init_structure_info
		end

end
