class
	PD_PATH_INFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} path.make
		end

feature {ANY} -- fields

	path: CE_POINTER [INTEGER_8] assign set_path

	allowedp: BOOLEAN assign set_allowedp

	user_agent_exact_p: BOOLEAN assign set_user_agent_exact_p

feature {ANY} -- field setters

	set_path (a_path: CE_POINTER [INTEGER_8])
		do
			path := a_path
			update_memory_field ("path")
		end

	set_allowedp (a_allowedp: BOOLEAN)
		do
			allowedp := a_allowedp
			update_memory_field ("allowedp")
		end

	set_user_agent_exact_p (a_user_agent_exact_p: BOOLEAN)
		do
			user_agent_exact_p := a_user_agent_exact_p
			update_memory_field ("user_agent_exact_p")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			path := a_other.path
			allowedp := a_other.allowedp
			user_agent_exact_p := a_other.user_agent_exact_p
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				path.is_equal (a_other.path) and
				allowedp = a_other.allowedp and
				user_agent_exact_p = a_other.user_agent_exact_p
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("path"),
					create {CE_STRUCTURE_FIELD}.make ("allowedp"),
					create {CE_STRUCTURE_FIELD}.make ("user_agent_exact_p")
				>>)
			init_structure_info
		end

end
