class
	PD_POOL

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_ASSERT_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} contents.make
			create {CE_INTEGER_8_POINTER} orig_contents.make
			Precursor
		end

feature {ANY} -- fields

	contents: CE_POINTER [INTEGER_8] assign set_contents

	size: INTEGER_32 assign set_size

	tail: INTEGER_32 assign set_tail

	resized: BOOLEAN assign set_resized

	orig_contents: CE_POINTER [INTEGER_8] assign set_orig_contents

	orig_size: INTEGER_32 assign set_orig_size

feature {ANY} -- field setters

	set_contents (a_contents: CE_POINTER [INTEGER_8])
		do
			contents := a_contents
			update_memory_field ("contents")
		end

	set_size (a_size: INTEGER_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_tail (a_tail: INTEGER_32)
		do
			tail := a_tail
			update_memory_field ("tail")
		end

	set_resized (a_resized: BOOLEAN)
		do
			resized := a_resized
			update_memory_field ("resized")
		end

	set_orig_contents (a_orig_contents: CE_POINTER [INTEGER_8])
		do
			orig_contents := a_orig_contents
			update_memory_field ("orig_contents")
		end

	set_orig_size (a_orig_size: INTEGER_32)
		do
			orig_size := a_orig_size
			update_memory_field ("orig_size")
		end

feature {ANY} -- public routines

	convert_and_copy (a_beg, a_end: CE_POINTER [INTEGER_8]; a_flags: INTEGER_32)
		local
			l_beg: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_old_tail: INTEGER_32
			l_tmp: BOOLEAN
			l_tmp___0: BOOLEAN
			l_from: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_to: CE_POINTER [INTEGER_8]
			l_squash_newlines: BOOLEAN
			l_ga_needed_size: INTEGER_32
			l_ga_newsize: INTEGER_32
			l_tmp___1: CE_POINTER [ANY]
			l_ga_new: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_entity: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_PAC_char: INTEGER_8
			l_ga_needed_size___0: INTEGER_32
			l_ga_newsize___0: INTEGER_32
			l_tmp___9: CE_POINTER [ANY]
			l_ga_new___0: CE_POINTER [ANY]
			l_tmp___10: CE_POINTER [ANY]
			l_tmp___11: INTEGER_32
			l_PA_beg: CE_POINTER [INTEGER_8]
			l_PA_size: INTEGER_32
			l_ga_needed_size___1: INTEGER_32
			l_ga_newsize___1: INTEGER_32
			l_tmp___12: CE_POINTER [ANY]
			l_ga_new___1: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			l_PAC_char___0: INTEGER_8
			l_ga_needed_size___2: INTEGER_32
			l_ga_newsize___2: INTEGER_32
			l_tmp___14: CE_POINTER [ANY]
			l_ga_new___2: CE_POINTER [ANY]
			l_tmp___15: CE_POINTER [ANY]
			l_tmp___16: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___17: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_from.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_beg := a_beg
					l_end := a_end
					l_old_tail := tail
					if ((a_flags).bit_and (4)).to_boolean then
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_beg.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
								l_tmp := (create {P_C_CTYPE_STATIC}).c2_isspace ((l_beg[0]).to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_beg := l_beg + 1
							end
						end
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_end.c_pointer.to_integer_32).to_natural_32 > (l_beg.c_pointer.to_integer_32).to_natural_32 then
								l_tmp___0 := (create {P_C_CTYPE_STATIC}).c2_isspace ((l_end[-1]).to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_end := l_end - 1
							end
						end
						l_break := False
					end
					if not (((a_flags).bit_and (2)).to_boolean) then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						l_from.item := l_beg
						update_class_fields -- Current might have been changed; synchronize
						l_squash_newlines := (((a_flags).bit_and (4)).to_boolean)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_ga_needed_size := (tail + (l_end.distance (l_beg))).to_integer_32
							l_ga_newsize := size.to_integer_32
							from
							until
								not (l_ga_newsize < l_ga_needed_size)
							loop
								l_ga_newsize := (l_ga_newsize).bit_shift_left ((1))
							end
							if l_ga_newsize /= size.to_integer_32 then
								if resized then
									l_tmp___1 := (create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (contents), (l_ga_newsize.to_natural_32 * ({PLATFORM}.Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
									Current.contents := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___1)
									update_class_fields -- Current might have been changed; synchronize
								else
									l_tmp___2 := (create {P_XMALLOC_STATIC}).xmalloc ((l_ga_newsize.to_natural_32 * ({PLATFORM}.Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
									l_ga_new := l_tmp___2
									memcpy (l_ga_new, create {CE_VOID_POINTER}.make_cast (contents), size.to_natural_32 * {PLATFORM}.Integer_8_bytes.to_natural_32).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									Current.contents := create {CE_INTEGER_8_POINTER}.make_cast (l_ga_new)
									update_class_fields -- Current might have been changed; synchronize
									Current.resized := (1).to_boolean
									update_class_fields -- Current might have been changed; synchronize
								end
								Current.size := l_ga_newsize.to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
						l_to := contents + tail
				when 2 then -- loop condition:
						if not (((l_from.item).c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 14 -- skip loop
						end
				when 3 then -- loop body:
						if (l_from.item[0]).to_integer_32 /= 38 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_tmp___3 := decode_entity (l_from, l_end)
						update_class_fields -- Current might have been changed; synchronize
						l_entity := l_tmp___3
						if l_entity /= -1 then
							l_tmp___4 := l_to
							l_to := l_to + 1
							l_tmp___4[0] := l_entity.to_integer_8
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___5 := l_to
							l_to := l_to + 1
							l_tmp___6 := l_from.item
							l_from.item := l_from.item + 1
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___5[0] := l_tmp___6[0]
							update_class_fields -- Current might have been changed; synchronize
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if (l_from.item[0]).to_integer_32 /= 10 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if (l_from.item[0]).to_integer_32 /= 13 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						if l_squash_newlines then
							l_from.item := l_from.item + 1
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___7 := l_to
							l_to := l_to + 1
							l_tmp___8 := l_from.item
							l_from.item := l_from.item + 1
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___7[0] := l_tmp___8[0]
							update_class_fields -- Current might have been changed; synchronize
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_tmp___7 := l_to
						l_to := l_to + 1
						l_tmp___8 := l_from.item
						l_from.item := l_from.item + 1
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___7[0] := l_tmp___8[0]
						update_class_fields -- Current might have been changed; synchronize
				when 13 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 14 then -- loop done
						if not (l_to.distance ((contents + tail)) <= l_end.distance (l_beg)) then
							assert_fail (ce_string ("to - (pool->contents + pool->tail) <= end - beg"), ce_string ("html-parse.c"), {NATURAL_32} 499, ce_string ("convert_and_copy"))
							update_class_fields -- Current might have been changed; synchronize
						end
						Current.tail := l_to.distance (contents)
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_PAC_char := (('%/0/').code).to_integer_8
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_ga_needed_size___0 := (tail + 1).to_integer_32
								l_ga_newsize___0 := size.to_integer_32
								from
								until
									not (l_ga_newsize___0 < l_ga_needed_size___0)
								loop
									l_ga_newsize___0 := (l_ga_newsize___0).bit_shift_left ((1))
								end
								if l_ga_newsize___0 /= size.to_integer_32 then
									if resized then
										l_tmp___9 := (create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (contents), (l_ga_newsize___0.to_natural_32 * ({PLATFORM}.Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)
										update_class_fields -- Current might have been changed; synchronize
										Current.contents := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___9)
										update_class_fields -- Current might have been changed; synchronize
									else
										l_tmp___10 := (create {P_XMALLOC_STATIC}).xmalloc ((l_ga_newsize___0.to_natural_32 * ({PLATFORM}.Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)
										update_class_fields -- Current might have been changed; synchronize
										l_ga_new___0 := l_tmp___10
										memcpy (l_ga_new___0, create {CE_VOID_POINTER}.make_cast (contents), size.to_natural_32 * {PLATFORM}.Integer_8_bytes.to_natural_32).do_nothing
										update_class_fields -- Current might have been changed; synchronize
										Current.contents := create {CE_INTEGER_8_POINTER}.make_cast (l_ga_new___0)
										update_class_fields -- Current might have been changed; synchronize
										Current.resized := (1).to_boolean
										update_class_fields -- Current might have been changed; synchronize
									end
									Current.size := l_ga_newsize___0.to_integer_32
									update_class_fields -- Current might have been changed; synchronize
								end
								l_break := True
							end
							l_break := False
							l_tmp___11 := tail
							Current.tail := tail + 1
							update_class_fields -- Current might have been changed; synchronize
							contents[l_tmp___11] := l_PAC_char
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_PA_beg := l_beg
							l_PA_size := l_end.distance (l_PA_beg)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_ga_needed_size___1 := (tail + l_PA_size).to_integer_32
								l_ga_newsize___1 := size.to_integer_32
								from
								until
									not (l_ga_newsize___1 < l_ga_needed_size___1)
								loop
									l_ga_newsize___1 := (l_ga_newsize___1).bit_shift_left ((1))
								end
								if l_ga_newsize___1 /= size.to_integer_32 then
									if resized then
										l_tmp___12 := (create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (contents), (l_ga_newsize___1.to_natural_32 * ({PLATFORM}.Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)
										update_class_fields -- Current might have been changed; synchronize
										Current.contents := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___12)
										update_class_fields -- Current might have been changed; synchronize
									else
										l_tmp___13 := (create {P_XMALLOC_STATIC}).xmalloc ((l_ga_newsize___1.to_natural_32 * ({PLATFORM}.Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)
										update_class_fields -- Current might have been changed; synchronize
										l_ga_new___1 := l_tmp___13
										memcpy (l_ga_new___1, create {CE_VOID_POINTER}.make_cast (contents), size.to_natural_32 * {PLATFORM}.Integer_8_bytes.to_natural_32).do_nothing
										update_class_fields -- Current might have been changed; synchronize
										Current.contents := create {CE_INTEGER_8_POINTER}.make_cast (l_ga_new___1)
										update_class_fields -- Current might have been changed; synchronize
										Current.resized := (1).to_boolean
										update_class_fields -- Current might have been changed; synchronize
									end
									Current.size := l_ga_newsize___1.to_integer_32
									update_class_fields -- Current might have been changed; synchronize
								end
								l_break := True
							end
							l_break := False
							memcpy (create {CE_VOID_POINTER}.make_cast ((contents + tail)), create {CE_VOID_POINTER}.make_cast (l_PA_beg), l_PA_size.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Current.tail := tail + l_PA_size
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_PAC_char___0 := (('%/0/').code).to_integer_8
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_ga_needed_size___2 := (tail + 1).to_integer_32
								l_ga_newsize___2 := size.to_integer_32
								from
								until
									not (l_ga_newsize___2 < l_ga_needed_size___2)
								loop
									l_ga_newsize___2 := (l_ga_newsize___2).bit_shift_left ((1))
								end
								if l_ga_newsize___2 /= size.to_integer_32 then
									if resized then
										l_tmp___14 := (create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (contents), (l_ga_newsize___2.to_natural_32 * ({PLATFORM}.Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)
										update_class_fields -- Current might have been changed; synchronize
										Current.contents := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___14)
										update_class_fields -- Current might have been changed; synchronize
									else
										l_tmp___15 := (create {P_XMALLOC_STATIC}).xmalloc ((l_ga_newsize___2.to_natural_32 * ({PLATFORM}.Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)
										update_class_fields -- Current might have been changed; synchronize
										l_ga_new___2 := l_tmp___15
										memcpy (l_ga_new___2, create {CE_VOID_POINTER}.make_cast (contents), size.to_natural_32 * {PLATFORM}.Integer_8_bytes.to_natural_32).do_nothing
										update_class_fields -- Current might have been changed; synchronize
										Current.contents := create {CE_INTEGER_8_POINTER}.make_cast (l_ga_new___2)
										update_class_fields -- Current might have been changed; synchronize
										Current.resized := (1).to_boolean
										update_class_fields -- Current might have been changed; synchronize
									end
									Current.size := l_ga_newsize___2.to_integer_32
									update_class_fields -- Current might have been changed; synchronize
								end
								l_break := True
							end
							l_break := False
							l_tmp___16 := tail
							Current.tail := tail + 1
							update_class_fields -- Current might have been changed; synchronize
							contents[l_tmp___16] := l_PAC_char___0
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
				when 17 then -- if done
					if ((a_flags).bit_and (1)).to_boolean then
						l_p___0 := contents + l_old_tail
						from
						until
							not ((l_p___0[0]).to_boolean)
						loop
							l_tmp___17 := (create {P_C_CTYPE_STATIC}).c2_tolower ((l_p___0[0]).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							l_p___0[0] := l_tmp___17.to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							l_p___0 := l_p___0 + 1
						end
					end
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {PD_POOL} -- private routines

	decode_entity (a_ptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_end: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_ptr.is_void
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_value: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_digits: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_ptr.item
					l_value := -1
					l_p___0 := l_p___0 + 1
					if l_p___0.is_equal (a_end) then
						Result := (-1)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 41 -- skip if block
					end
				when 1 then -- if:
						l_tmp := l_p___0
						l_p___0 := l_p___0 + 1
						inspect (l_tmp[0]).to_integer_32 -- switch 1 head
						when 35 then l_pos := -1 + 2
						when 103 then l_pos := -1 + 3
						when 108 then l_pos := -1 + 11
						when 97 then l_pos := -1 + 18
						when 113 then l_pos := -1 + 34
						else l_pos := -1 + 41
						end
				when 2 then -- switch 1, case 35
						l_digits := 0
						l_value := 0
						if (l_p___0[0]).to_integer_32 = 120 then
							l_p___0 := l_p___0 + 1
							from
							until
								(l_break)
							loop
								l_break := False
								if l_value < 256 then
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
										if not ((create {P_C_CTYPE_STATIC}).c2_isxdigit ((l_p___0[0]).to_integer_32)) then
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									if (l_p___0[0]).to_integer_32 < 65 then
										l_tmp___1 := (l_p___0[0]).to_integer_32 - 48
									else
										l_tmp___1 := ((((create {P_C_CTYPE_STATIC}).c2_toupper ((l_p___0[0]).to_integer_32)) - 65) + 10)
									end
									l_value := ((l_value).bit_shift_left (4)) + l_tmp___1
									l_p___0 := l_p___0 + 1
									l_digits := l_digits + 1
								end
							end
							l_break := False
						else
							from
							until
								(l_break)
							loop
								l_break := False
								if l_value < 256 then
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
										if not ((create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[0]).to_integer_32)) then
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_value := l_value * 10 + ((l_p___0[0]).to_integer_32 - 48)
									l_p___0 := l_p___0 + 1
									l_digits := l_digits + 1
								end
							end
							l_break := False
						end
						if not l_digits.to_boolean then
							Result := (-1)
							l_return := True
						end
						if not l_return then
							if not l_value.to_boolean then
								Result := (-1)
								l_return := True
							elseif ((l_value).bit_and (-128)).to_boolean then
								Result := (-1)
								l_return := True
							end
						end
						if not l_return then
							l_p___0 := l_p___0 + (0)
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0[0]).to_integer_32 = 59 then
									l_p___0 := l_p___0 + 1
									a_ptr.item := l_p___0
								else
									a_ptr.item := l_p___0
								end
							else
								a_ptr.item := l_p___0
							end
							Result := l_value
							l_return := True
						end
				when 3 then -- switch 1, case 103
						if l_return then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						if not ((l_p___0 + 1).is_equal (a_end)) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 7 then -- else:
						if not (((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if ((create {P_C_CTYPE_STATIC}).c2_isalnum ((l_p___0[1]).to_integer_32)) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if (l_p___0[0]).to_integer_32 = 116 then
							l_value := ('>').code
							l_p___0 := l_p___0 + 1
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0[0]).to_integer_32 = 59 then
									l_p___0 := l_p___0 + 1
									a_ptr.item := l_p___0
								else
									a_ptr.item := l_p___0
								end
							else
								a_ptr.item := l_p___0
							end
						end
				when 10 then -- if done | if done | if done
						l_pos := -1 + 41 -- switch 1; break
				when 11 then -- switch 1, case 108
						if not ((l_p___0 + 1).is_equal (a_end)) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 14 then -- else:
						if not (((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if ((create {P_C_CTYPE_STATIC}).c2_isalnum ((l_p___0[1]).to_integer_32)) then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L___0:
						if (l_p___0[0]).to_integer_32 = 116 then
							l_value := ('<').code
							l_p___0 := l_p___0 + 1
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0[0]).to_integer_32 = 59 then
									l_p___0 := l_p___0 + 1
									a_ptr.item := l_p___0
								else
									a_ptr.item := l_p___0
								end
							else
								a_ptr.item := l_p___0
							end
						end
				when 17 then -- if done | if done
						l_pos := -1 + 41 -- switch 1; break
				when 18 then -- switch 1, case 97
						if not ((l_p___0 + 2).is_equal (a_end)) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 25 -- goto _L___4
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 21 then -- else:
						if not (((l_p___0 + 2).c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 27 -- skip if block
						end
				when 22 then -- if:
						if not ((create {P_C_CTYPE_STATIC}).c2_isalnum ((l_p___0[2]).to_integer_32)) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 27 -- goto _L___5
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else: | _L___4:
						if (l_p___0[0]).to_integer_32 = 109 then
							if (l_p___0[1]).to_integer_32 = 112 then
								l_value := ('&').code
								l_p___0 := l_p___0 + (2)
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
									if (l_p___0[0]).to_integer_32 = 59 then
										l_p___0 := l_p___0 + 1
										a_ptr.item := l_p___0
									else
										a_ptr.item := l_p___0
									end
								else
									a_ptr.item := l_p___0
								end
							else
								l_pos := -1 + 27 -- goto _L___5
							end
						else
							l_pos := -1 + 27 -- goto _L___5
						end
				when 26 then -- if done | if block done, skip else block:
						l_pos := -1 + 33
				when 27 then -- else: | _L___5:
						if not ((l_p___0 + 3).is_equal (a_end)) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 32 -- goto _L___1
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 30 then -- else:
						if not (((l_p___0 + 3).c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						if ((create {P_C_CTYPE_STATIC}).c2_isalnum ((l_p___0[3]).to_integer_32)) then
							l_pos := -1 + 33 -- skip if block
						end
				when 32 then -- if: | _L___1:
						if (l_p___0[0]).to_integer_32 = 112 then
							if (l_p___0[1]).to_integer_32 = 111 then
								if (l_p___0[2]).to_integer_32 = 115 then
									l_value := ('%'').code
									l_p___0 := l_p___0 + (3)
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
										if (l_p___0[0]).to_integer_32 = 59 then
											l_p___0 := l_p___0 + 1
											a_ptr.item := l_p___0
										else
											a_ptr.item := l_p___0
										end
									else
										a_ptr.item := l_p___0
									end
								end
							end
						end
				when 33 then -- if done | if done | if done | if done
						l_pos := -1 + 41 -- switch 1; break
				when 34 then -- switch 1, case 113
						if not ((l_p___0 + 3).is_equal (a_end)) then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_pos := -1 + 39 -- goto _L___6
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 37 then -- else:
						if not (((l_p___0 + 3).c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if ((create {P_C_CTYPE_STATIC}).c2_isalnum ((l_p___0[3]).to_integer_32)) then
							l_pos := -1 + 40 -- skip if block
						end
				when 39 then -- if: | _L___6:
						if (l_p___0[0]).to_integer_32 = 117 then
							if (l_p___0[1]).to_integer_32 = 111 then
								if (l_p___0[2]).to_integer_32 = 116 then
									l_value := ('%"').code
									l_p___0 := l_p___0 + (3)
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
										if (l_p___0[0]).to_integer_32 = 59 then
											l_p___0 := l_p___0 + 1
											a_ptr.item := l_p___0
										else
											a_ptr.item := l_p___0
										end
									else
										a_ptr.item := l_p___0
									end
								end
							end
						end
				when 40 then -- if done | if done
						l_pos := -1 + 41 -- switch 1; break
				when 41 then -- switch 1, done: | if done
					if not l_return then
						Result := l_value
					end
				when 42 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			contents := a_other.contents
			size := a_other.size
			tail := a_other.tail
			resized := a_other.resized
			orig_contents := a_other.orig_contents
			orig_size := a_other.orig_size
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				contents.is_equal (a_other.contents) and
				size = a_other.size and
				tail = a_other.tail and
				resized = a_other.resized and
				orig_contents.is_equal (a_other.orig_contents) and
				orig_size = a_other.orig_size
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("contents"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("tail"),
					create {CE_STRUCTURE_FIELD}.make ("resized"),
					create {CE_STRUCTURE_FIELD}.make ("orig_contents"),
					create {CE_STRUCTURE_FIELD}.make ("orig_size")
				>>)
			init_structure_info
		end

end
