class
	PD_QUOTING_OPTIONS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_BITS_ERRNO_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_32_ARRAY} quote_these_too.make (<<({NATURAL_32} 255 // ({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8) + {NATURAL_32} 1).to_integer_32>>)
			create {CE_INTEGER_8_POINTER} left_quote.make
			create {CE_INTEGER_8_POINTER} right_quote.make
			Precursor
		end

feature {ANY} -- fields

	style: NATURAL_32 assign set_style

	flags: INTEGER_32 assign set_flags

	quote_these_too: CE_ARRAY [NATURAL_32]

	left_quote: CE_POINTER [INTEGER_8] assign set_left_quote

	right_quote: CE_POINTER [INTEGER_8] assign set_right_quote

feature {ANY} -- field setters

	set_style (a_style: NATURAL_32)
		do
			style := a_style
			update_memory_field ("style")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_left_quote (a_left_quote: CE_POINTER [INTEGER_8])
		do
			left_quote := a_left_quote
			update_memory_field ("left_quote")
		end

	set_right_quote (a_right_quote: CE_POINTER [INTEGER_8])
		do
			right_quote := a_right_quote
			update_memory_field ("right_quote")
		end

feature {ANY} -- public routines

	quotearg_n_options (a_n: INTEGER_32; a_arg: CE_POINTER [INTEGER_8]; a_argsize: NATURAL_32): CE_POINTER [INTEGER_8]
		local
			l_e: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_32]
			l_n0: NATURAL_32
			l_sv: CE_POINTER [PD_SLOTVEC]
			l_n1: NATURAL_32
			l_preallocated: BOOLEAN
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [PD_SLOTVEC]
			l_tmp___2: CE_POINTER [ANY]
			l_size: NATURAL_32
			l_val: CE_POINTER [INTEGER_8]
			l_flags: INTEGER_32
			l_qsize: NATURAL_32
			l_tmp___3: NATURAL_32
			l_tmp___4: CE_POINTER [INTEGER_32]
		do
			l_tmp := errno_location
			update_class_fields -- Current might have been changed; synchronize
			l_e := l_tmp.item
			l_n0 := a_n.to_natural_32
			l_sv := (create {P_QUOTEARG_STATIC}).slotvec.item
			if a_n < 0 then
				abort
				update_class_fields -- Current might have been changed; synchronize
			end
			if (create {P_QUOTEARG_STATIC}).nslots.item <= l_n0 then
				l_n1 := l_n0 + {NATURAL_32} 1
				l_preallocated := (l_sv.is_equal ((create {P_QUOTEARG_STATIC}).slotvec0.item))
				if {PLATFORM}.Integer_32_bytes.to_natural_32 <= {PLATFORM}.Natural_32_bytes.to_natural_32 then
					l_tmp___0 := -1
				else
					l_tmp___0 := -2
				end
				if l_tmp___0.to_natural_32 // (create {PD_SLOTVEC}.make).structure_size.to_natural_32 < l_n1 then
					(create {P_XALLOC_DIE_STATIC}).xalloc_die
					update_class_fields -- Current might have been changed; synchronize
				end
				if l_preallocated then
					l_tmp___1 := create {CE_CLASS_POINTER [PD_SLOTVEC]}.make_shared (default_pointer)
				else
					l_tmp___1 := l_sv
				end
				l_tmp___2 := (create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_tmp___1), l_n1 * (create {PD_SLOTVEC}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_sv := create {CE_CLASS_POINTER [PD_SLOTVEC]}.make_cast (l_tmp___2);
				(create {P_QUOTEARG_STATIC}).slotvec.item := l_sv
				update_class_fields -- Current might have been changed; synchronize
				if l_preallocated then
					l_sv.item := ((create {P_QUOTEARG_STATIC}).slotvec0.item.item).twin
					update_class_fields -- Current might have been changed; synchronize
				end
				memset (create {CE_VOID_POINTER}.make_cast ((l_sv + ((create {P_QUOTEARG_STATIC}).nslots.item).to_integer_32)), 0, (l_n1 - (create {P_QUOTEARG_STATIC}).nslots.item) * (create {PD_SLOTVEC}.make).structure_size.to_natural_32).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_QUOTEARG_STATIC}).nslots.item := l_n1
				update_class_fields -- Current might have been changed; synchronize
			end
			l_size := (l_sv + a_n).item.size
			l_val := (l_sv + a_n).item.val
			l_flags := ((flags).bit_or (1))
			l_tmp___3 := (create {P_QUOTEARG_STATIC}).quotearg_buffer_restyled (l_val, l_size, a_arg, a_argsize, style, l_flags, create {CE_NATURAL_32_POINTER}.make_cast (quote_these_too), left_quote, right_quote)
			update_class_fields -- Current might have been changed; synchronize
			l_qsize := l_tmp___3
			if l_size <= l_qsize then
				l_size := l_qsize + {NATURAL_32} 1;
				(l_sv + a_n).item.size := l_size
				update_class_fields -- Current might have been changed; synchronize
				if not l_val.is_equal ((create {P_QUOTEARG_STATIC}).slot0.item) then
					free (create {CE_VOID_POINTER}.make_cast (l_val))
					update_class_fields -- Current might have been changed; synchronize
				end
				l_val := (create {P_XALLOC_STATIC}).xcharalloc (l_size)
				update_class_fields; -- Current might have been changed; synchronize
				(l_sv + a_n).item.val := l_val
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_QUOTEARG_STATIC}).quotearg_buffer_restyled (l_val, l_size, a_arg, a_argsize, style, l_flags, create {CE_NATURAL_32_POINTER}.make_cast (quote_these_too), left_quote, right_quote).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			l_tmp___4 := errno_location
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___4.item := l_e
			update_class_fields -- Current might have been changed; synchronize
			Result := l_val
		end

feature {ANY}

	copy (a_other: like Current)
		do
			style := a_other.style
			flags := a_other.flags
			quote_these_too := a_other.quote_these_too.twin
			left_quote := a_other.left_quote
			right_quote := a_other.right_quote
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				style = a_other.style and
				flags = a_other.flags and
				quote_these_too.is_equal (a_other.quote_these_too) and
				left_quote.is_equal (a_other.left_quote) and
				right_quote.is_equal (a_other.right_quote)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("style"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("quote_these_too", <<({NATURAL_32} 255 // ({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8) + {NATURAL_32} 1).to_integer_32>>),
					create {CE_STRUCTURE_FIELD}.make ("left_quote"),
					create {CE_STRUCTURE_FIELD}.make ("right_quote")
				>>)
			init_structure_info
		end

end
