class
	PD_TAG_URL_ATTRIBUTES

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} attr_name.make
		end

feature {ANY} -- fields

	tagid: INTEGER_32 assign set_tagid

	attr_name: CE_POINTER [INTEGER_8] assign set_attr_name

	flags: INTEGER_32 assign set_flags

feature {ANY} -- field setters

	set_tagid (a_tagid: INTEGER_32)
		do
			tagid := a_tagid
			update_memory_field ("tagid")
		end

	set_attr_name (a_attr_name: CE_POINTER [INTEGER_8])
		do
			attr_name := a_attr_name
			update_memory_field ("attr_name")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tagid := a_other.tagid
			attr_name := a_other.attr_name
			flags := a_other.flags
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tagid = a_other.tagid and
				attr_name.is_equal (a_other.attr_name) and
				flags = a_other.flags
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tagid"),
					create {CE_STRUCTURE_FIELD}.make ("attr_name"),
					create {CE_STRUCTURE_FIELD}.make ("flags")
				>>)
			init_structure_info
		end

end
