class
	PD_URLPOS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end
	S_GCC_BUILTIN_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_UNISTD_STATIC
		redefine
			copy,
			is_equal
		end
	S_BITS_ERRNO_STATIC
		redefine
			copy,
			is_equal
		end
	S_ASSERT_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	url: CE_POINTER [PD_URL] assign set_url

	local_name: CE_POINTER [INTEGER_8] assign set_local_name

	ignore_when_downloading: NATURAL_32 assign set_ignore_when_downloading

	link_relative_p: NATURAL_32 assign set_link_relative_p

	link_complete_p: NATURAL_32 assign set_link_complete_p

	link_base_p: NATURAL_32 assign set_link_base_p

	link_inline_p: NATURAL_32 assign set_link_inline_p

	link_css_p: NATURAL_32 assign set_link_css_p

	link_expect_html: NATURAL_32 assign set_link_expect_html

	link_expect_css: NATURAL_32 assign set_link_expect_css

	link_refresh_p: NATURAL_32 assign set_link_refresh_p

	refresh_timeout: INTEGER_32 assign set_refresh_timeout

	convert2: NATURAL_32 assign set_convert2

	pos: INTEGER_32 assign set_pos

	size: INTEGER_32 assign set_size

	next: CE_POINTER [PD_URLPOS] assign set_next

feature {ANY} -- field setters

	set_url (a_url: CE_POINTER [PD_URL])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_local_name (a_local_name: CE_POINTER [INTEGER_8])
		do
			local_name := a_local_name
			update_memory_field ("local_name")
		end

	set_ignore_when_downloading (a_ignore_when_downloading: NATURAL_32)
		do
			ignore_when_downloading := a_ignore_when_downloading
			update_memory_field ("ignore_when_downloading")
		end

	set_link_relative_p (a_link_relative_p: NATURAL_32)
		do
			link_relative_p := a_link_relative_p
			update_memory_field ("link_relative_p")
		end

	set_link_complete_p (a_link_complete_p: NATURAL_32)
		do
			link_complete_p := a_link_complete_p
			update_memory_field ("link_complete_p")
		end

	set_link_base_p (a_link_base_p: NATURAL_32)
		do
			link_base_p := a_link_base_p
			update_memory_field ("link_base_p")
		end

	set_link_inline_p (a_link_inline_p: NATURAL_32)
		do
			link_inline_p := a_link_inline_p
			update_memory_field ("link_inline_p")
		end

	set_link_css_p (a_link_css_p: NATURAL_32)
		do
			link_css_p := a_link_css_p
			update_memory_field ("link_css_p")
		end

	set_link_expect_html (a_link_expect_html: NATURAL_32)
		do
			link_expect_html := a_link_expect_html
			update_memory_field ("link_expect_html")
		end

	set_link_expect_css (a_link_expect_css: NATURAL_32)
		do
			link_expect_css := a_link_expect_css
			update_memory_field ("link_expect_css")
		end

	set_link_refresh_p (a_link_refresh_p: NATURAL_32)
		do
			link_refresh_p := a_link_refresh_p
			update_memory_field ("link_refresh_p")
		end

	set_refresh_timeout (a_refresh_timeout: INTEGER_32)
		do
			refresh_timeout := a_refresh_timeout
			update_memory_field ("refresh_timeout")
		end

	set_convert2 (a_convert2: NATURAL_32)
		do
			convert2 := a_convert2
			update_memory_field ("convert2")
		end

	set_pos (a_pos: INTEGER_32)
		do
			pos := a_pos
			update_memory_field ("pos")
		end

	set_size (a_size: INTEGER_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_next (a_next: CE_POINTER [PD_URLPOS])
		do
			next := a_next
			update_memory_field ("next")
		end

feature {ANY} -- public routines

	download_child_p (a_parent: CE_POINTER [PD_URL]; a_depth___0: INTEGER_32; a_start_url_parsed: CE_POINTER [PD_URL]; a_blacklist: CE_POINTER [PD_HASH_TABLE]; a_iri: CE_POINTER [PD_IRI]): BOOLEAN
		require
			not a_blacklist.is_void
		local
			l_u: CE_POINTER [PD_URL]
			l_url: CE_POINTER [INTEGER_8]
			l_u_scheme_like_http: BOOLEAN
			l_tmp: INTEGER_32
			l_referrer: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: BOOLEAN
			l_tmp___9: INTEGER_32
			l_tmp___10: BOOLEAN
			l_tmp___11: BOOLEAN
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: BOOLEAN
			l_tmp___15: INTEGER_32
			l_tmp___16: BOOLEAN
			l_tmp___17: BOOLEAN
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: BOOLEAN
			l_specs: CE_POINTER [PD_ROBOT_SPECS]
			l_tmp___21: CE_POINTER [PD_ROBOT_SPECS]
			l_rfile: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_tmp___22: CE_POINTER [INTEGER_32]
			l_tmp___23: CE_POINTER [INTEGER_8]
			l_tmp___24: INTEGER_32
			l_tmp___25: BOOLEAN
			l_tmp___26: INTEGER_32
			l_tmp___27: BOOLEAN
			l_tmp___28: INTEGER_32
			l_tmp___29: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_rfile.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_u := url
					l_url := l_u.item.url
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp.to_boolean then
							(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Deciding whether to enqueue %"%%s%".%N"), l_url])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_break := True
					end
					l_break := False
					l_tmp___4 := a_blacklist.item.string_set_contains (l_url)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___4.to_boolean then
						if (create {P_OPTIONS_STATIC}).opt.item.item.spider then
							l_tmp___0 := a_parent.item.url_string ({PC_URL_AUTH_MODE}.URL_AUTH_HIDE_PASSWD)
							update_class_fields -- Current might have been changed; synchronize
							l_referrer := l_tmp___0
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___2 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___2.to_boolean then
									l_tmp___1 := (create {P_QUOTE_STATIC}).quote (a_parent.item.url)
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("download_child_p: parent->url is: %%s%N"), l_tmp___1])
									update_class_fields -- Current might have been changed; synchronize
								end
								l_break := True
							end
							l_break := False
							free (create {CE_VOID_POINTER}.make_cast (l_referrer))
							update_class_fields -- Current might have been changed; synchronize
						end
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___3 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___3.to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Already on the black list.%N")])
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
						l_pos := -1 + 42 -- goto out
					end
				when 1 then
					l_u_scheme_like_http := schemes_are_similar_p (l_u.item.scheme, {PC_URL_SCHEME}.SCHEME_HTTP)
					update_class_fields -- Current might have been changed; synchronize
					if l_u_scheme_like_http then
						l_pos := -1 + 6 -- skip if block
					end
				when 2 then -- if:
						if l_u.item.scheme /= {NATURAL_32} 1 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if not (create {P_OPTIONS_STATIC}).opt.item.item.follow_ftp then
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___5 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___5.to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Not following non-HTTP schemes.%N")])
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
						l_pos := -1 + 42 -- goto out
				when 6 then -- if done
					if l_u_scheme_like_http then
						if (create {P_OPTIONS_STATIC}).opt.item.item.relative_only then
							if not (link_relative_p).to_boolean then
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___6 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___6.to_boolean then
										(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("It doesn%'t really look like a relative link.%N")])
										update_class_fields -- Current might have been changed; synchronize
									end
									l_break := True
								end
								l_break := False
								l_pos := -1 + 42 -- goto out
							end
						end
					end
				when 7 then
					l_tmp___8 := accept_domain (l_u)
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp___8 then
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___7 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___7.to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("The domain was not accepted.%N")])
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
						l_pos := -1 + 42 -- goto out
					end
				when 8 then
					if not ((create {P_OPTIONS_STATIC}).opt.item.item.no_parent) then
						l_pos := -1 + 16 -- skip if block
					end
				when 9 then -- if:
						l_tmp___11 := schemes_are_similar_p (l_u.item.scheme, a_start_url_parsed.item.scheme)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___11 then
							l_pos := -1 + 16 -- skip if block
						end
				when 10 then -- if:
						l_tmp___12 := strcasecmp (l_u.item.host, a_start_url_parsed.item.host)
						update_class_fields -- Current might have been changed; synchronize
						if 0 /= l_tmp___12 then
							l_pos := -1 + 16 -- skip if block
						end
				when 11 then -- if:
						if l_u.item.port /= a_start_url_parsed.item.port then
							l_pos := -1 + 16 -- skip if block
						end
				when 12 then -- if:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.page_requisites) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if not (link_inline_p).to_boolean then
							l_pos := -1 + 15 -- goto _L___0
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L___0:
						l_tmp___10 := (create {P_UTILS_STATIC}).subdir_p (a_start_url_parsed.item.dir, l_u.item.dir)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___10 then
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___9 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___9.to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Going to %"%%s%" would escape %"%%s%" with no_parent on.%N"), l_u.item.dir, a_start_url_parsed.item.dir])
									update_class_fields -- Current might have been changed; synchronize
								end
								l_break := True
							end
							l_break := False
							l_pos := -1 + 42 -- goto out
						end
				when 16 then -- if done | if done | if done | if done
					if ((create {P_OPTIONS_STATIC}).opt.item.item.includes).is_void then
						l_pos := -1 + 19 -- skip if block
					end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L___1
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 19 then -- else:
						if ((create {P_OPTIONS_STATIC}).opt.item.item.excludes).is_void then
							l_pos := -1 + 21 -- skip if block
						end
				when 20 then -- if: | _L___1:
						l_tmp___14 := (create {P_UTILS_STATIC}).accdir (l_u.item.dir)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___14 then
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___13 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___13.to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%%s (%%s) is excluded/not-included.%N"), l_url, l_u.item.dir])
									update_class_fields -- Current might have been changed; synchronize
								end
								l_break := True
							end
							l_break := False
							l_pos := -1 + 42 -- goto out
						end
				when 21 then -- if done
					if (l_u.item.file[0]).to_integer_32 = 0 then
						l_pos := -1 + 26 -- skip if block
					end
				when 22 then -- if:
						l_tmp___17 := (create {P_UTILS_STATIC}).has_html_suffix_p (l_u.item.file)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___17 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if (create {P_OPTIONS_STATIC}).opt.item.item.reclevel /= -1 then
							if not (a_depth___0 < (create {P_OPTIONS_STATIC}).opt.item.item.reclevel - 1) then
								if not (create {P_OPTIONS_STATIC}).opt.item.item.page_requisites then
									l_pos := -1 + 25 -- goto _L___2
								end
							end
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else: | _L___2:
						l_tmp___16 := (create {P_UTILS_STATIC}).acceptable (l_u.item.file)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___16 then
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___15 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___15.to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%%s (%%s) does not match acc/rej rules.%N"), l_url, l_u.item.file])
									update_class_fields -- Current might have been changed; synchronize
								end
								l_break := True
							end
							l_break := False
							l_pos := -1 + 42 -- goto out
						end
				when 26 then -- if done
					l_tmp___20 := schemes_are_similar_p (l_u.item.scheme, a_parent.item.scheme)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___20 then
						if not (create {P_OPTIONS_STATIC}).opt.item.item.spanhost then
							l_tmp___19 := strcasecmp (a_parent.item.host, l_u.item.host)
							update_class_fields -- Current might have been changed; synchronize
							if 0 /= l_tmp___19 then
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___18 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___18.to_boolean then
										(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("This is not the same hostname as the parent%'s (%%s and %%s).%N"), l_u.item.host, a_parent.item.host])
										update_class_fields -- Current might have been changed; synchronize
									end
									l_break := True
								end
								l_break := False
								l_pos := -1 + 42 -- goto out
							end
						end
					end
				when 27 then
					if not ((create {P_OPTIONS_STATIC}).opt.item.item.use_robots) then
						l_pos := -1 + 41 -- skip if block
					end
				when 28 then -- if:
						if not l_u_scheme_like_http then
							l_pos := -1 + 41 -- skip if block
						end
				when 29 then -- if:
						l_tmp___21 := res_get_specs (l_u.item.host, l_u.item.port)
						update_class_fields -- Current might have been changed; synchronize
						l_specs := l_tmp___21
						if (not l_specs.is_void) then
							l_pos := -1 + 40 -- skip if block
						end
				when 30 then -- if:
						l_tmp___25 := res_retrieve_file (l_url, l_rfile, a_iri)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___25 then
							l_pos := -1 + 38 -- skip if block
						end
				when 31 then -- if:
						l_specs := res_parse_from_file (l_rfile.item)
						update_class_fields -- Current might have been changed; synchronize
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.delete_after) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 35 -- goto _L___3
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 34 then -- else:
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.spider) then
							l_pos := -1 + 36 -- skip if block
						end
				when 35 then -- if: | _L___3:;
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("Removing %%s.%N"), l_rfile.item])
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___24 := unlink (l_rfile.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___24.to_boolean then
							l_tmp___22 := errno_location
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___23 := strerror (l_tmp___22.item)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("unlink: %%s%N"), l_tmp___23])
							update_class_fields -- Current might have been changed; synchronize
						end
				when 36 then -- if done
						free (create {CE_VOID_POINTER}.make_cast (l_rfile.item))
						update_class_fields -- Current might have been changed; synchronize
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 38 then -- else:
						l_specs := res_parse (ce_string (""), 0)
						update_class_fields -- Current might have been changed; synchronize
				when 39 then -- if done
						res_register_specs (l_u.item.host, l_u.item.port, l_specs)
						update_class_fields -- Current might have been changed; synchronize
				when 40 then -- if done
						l_tmp___27 := res_match_path (l_specs, l_u.item.path)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___27 then
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___26 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___26.to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Not following %%s because robots.txt forbids it.%N"), l_url])
									update_class_fields -- Current might have been changed; synchronize
								end
								l_break := True
							end
							l_break := False
							a_blacklist.item.string_set_add (l_url)
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 42 -- goto out
						end
				when 41 then -- if done
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___28 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___28.to_boolean then
							(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Decided to load it.%N")])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_break := True
					end
					l_break := False
					Result := (1).to_boolean
					l_return := True
					if l_return then
						l_pos := -1 + 43 -- skip if block
					end
				when 42 then -- if: | out:
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___29 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___29.to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Decided NOT to load it.%N")])
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
						Result := (0).to_boolean
				when 43 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {PD_URLPOS} -- private routines

	accept_domain (a_u: CE_POINTER [PD_URL]): BOOLEAN
		require
			not a_u.is_void
		local
			l_return: BOOLEAN
		do
			if (a_u.item.host).is_void then
				assert_fail (ce_string ("u->host != ((void *)0)"), ce_string ("host.c"), {NATURAL_32} 850, ce_string ("accept_domain"))
			end
			if (not ((create {P_OPTIONS_STATIC}).opt.item.item.domains).is_void) then
				if not ((create {P_HOST_STATIC}).sufmatch ((create {P_OPTIONS_STATIC}).opt.item.item.domains, a_u.item.host)) then
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return and then (not ((create {P_OPTIONS_STATIC}).opt.item.item.exclude_domains).is_void) then
				if ((create {P_HOST_STATIC}).sufmatch ((create {P_OPTIONS_STATIC}).opt.item.item.exclude_domains, a_u.item.host)) then
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return then
				Result := (1).to_boolean
			end
		end

	res_parse_from_file (a_filename: CE_POINTER [INTEGER_8]): CE_POINTER [PD_ROBOT_SPECS]
		local
			l_specs: CE_POINTER [PD_ROBOT_SPECS]
			l_fm: CE_POINTER [PD_FILE_MEMORY]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_fm := ((create {P_UTILS_STATIC}).read_file (a_filename))
			if l_fm.is_void then
				l_tmp___1 := strerror ((errno_location).item);
				(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cannot open %%s: %%s"))), a_filename, l_tmp___1])
				Result := (create {CE_CLASS_POINTER [PD_ROBOT_SPECS]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_specs := res_parse (l_fm.item.content, (l_fm.item.length).to_integer_32)
				l_fm.item.read_file_free
				Result := l_specs
			end
		end

	res_parse (a_source: CE_POINTER [INTEGER_8]; a_length: INTEGER_32): CE_POINTER [PD_ROBOT_SPECS]
		local
			l_line_count: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_user_agent_applies: CE_ARRAY [BOOLEAN]
			l_user_agent_exact: CE_ARRAY [BOOLEAN]
			l_found_exact: BOOLEAN
			l_record_count: INTEGER_32
			l_specs: CE_POINTER [PD_ROBOT_SPECS]
			l_lineend: CE_POINTER [INTEGER_8]
			l_lineend_real: CE_POINTER [INTEGER_8]
			l_field_b: CE_POINTER [INTEGER_8]
			l_field_e: CE_POINTER [INTEGER_8]
			l_value_b: CE_POINTER [INTEGER_8]
			l_value_e: CE_POINTER [INTEGER_8]
			l_allowed: BOOLEAN
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_BOOLEAN_ARRAY} l_user_agent_applies.make (<<1>>)
			create {CE_BOOLEAN_ARRAY} l_user_agent_exact.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line_count := 1
					l_p___0 := a_source
					l_end := a_source + a_length
					l_user_agent_applies.item := (0).to_boolean
					l_user_agent_exact.item := (0).to_boolean
					l_found_exact := (0).to_boolean
					l_record_count := 0
					l_specs := create {CE_CLASS_POINTER [PD_ROBOT_SPECS]}.make_cast (((create {P_XMALLOC_STATIC}).xcalloc ((1).to_natural_32, (create {PD_ROBOT_SPECS}.make).structure_size.to_natural_32)))
				when 1 then -- loop condition:
					if not (not (l_return) and then (not (l_p___0.is_equal (l_end)))) then
						l_pos := -1 + 30 -- skip loop
					end
				when 2 then -- loop body:
						l_lineend_real := create {CE_INTEGER_8_POINTER}.make_cast ((memchr (create {CE_VOID_POINTER}.make_cast (l_p___0), ('%N').code, (l_end.distance (l_p___0)).to_natural_32)))
						if (not l_lineend_real.is_void) then
							l_lineend_real := l_lineend_real + 1
						else
							l_lineend_real := l_end
						end
						l_lineend := l_lineend_real
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_lineend.c_pointer.to_integer_32).to_natural_32) then
									if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_p___0 := l_p___0 + 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_lineend.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 29 -- goto next
						elseif (l_p___0[0]).to_integer_32 = 35 then
							l_pos := -1 + 29 -- goto next
						end
				when 3 then
						l_lineend := l_p___0
				when 4 then -- loop condition:
						if not (not (l_break) and then ((l_lineend.c_pointer.to_integer_32).to_natural_32 < (l_lineend_real.c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						if not (l_lineend.is_equal (l_p___0)) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_lineend[-1]).to_integer_32)) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if (l_lineend[0]).to_integer_32 = 35 then
							l_break := True
						end
				when 10 then -- if done
						if not (l_return or l_break) then
							l_lineend := l_lineend + 1
						end
						l_pos := -1 + 4 -- back to loop condition
				when 11 then -- loop done
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_lineend.c_pointer.to_integer_32).to_natural_32 > (l_p___0.c_pointer.to_integer_32).to_natural_32 then
								if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_lineend[-1]).to_integer_32)) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_lineend := l_lineend - 1
							end
						end
						l_break := False
						if ((l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_lineend.c_pointer.to_integer_32).to_natural_32) then
							assert_fail (ce_string ("!((p) >= lineend)"), ce_string ("res.c"), {NATURAL_32} 276, ce_string ("res_parse"))
						end
						l_field_b := l_p___0
						from
						until
							(l_break)
						loop
							l_break := False
							if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_lineend.c_pointer.to_integer_32).to_natural_32) then
								if not ((create {P_C_CTYPE_STATIC}).c2_isalnum ((l_p___0[0]).to_integer_32)) then
									if (l_p___0[0]).to_integer_32 /= 45 then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						l_field_e := l_p___0
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_lineend.c_pointer.to_integer_32).to_natural_32) then
									if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_p___0 := l_p___0 + 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if not (l_field_b.is_equal (l_field_e)) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 18 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 14 then -- else:
						if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_lineend.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L___0
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 17 then -- else:
						if (l_p___0[0]).to_integer_32 = 58 then
							l_pos := -1 + 19 -- skip if block
						end
				when 18 then -- if: | _L___0:
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Ignoring malformed line %%d"), l_line_count])
							end
							l_break := True
						end
						l_break := False
						l_pos := -1 + 29 -- goto next
				when 19 then -- if done | if done
						l_p___0 := l_p___0 + 1
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_lineend.c_pointer.to_integer_32).to_natural_32) then
									if not ((create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_p___0 := l_p___0 + 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_value_b := l_p___0
						from
						until
							((l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_lineend.c_pointer.to_integer_32).to_natural_32)
						loop
							l_p___0 := l_p___0 + 1
						end
						l_value_e := l_p___0
						if (l_field_e.distance (l_field_b)).to_natural_32 /= (("user-agent").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if (strncasecmp (l_field_b, ce_string ("user-agent"), (("user-agent").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
							l_pos := -1 + 22 -- goto _L___3
						else
							if l_record_count /= 0 then
								match_user_agent (l_value_b, l_value_e.distance (l_value_b), l_user_agent_applies, l_user_agent_exact)
							elseif (l_user_agent_applies.item).to_integer = 0 then
								match_user_agent (l_value_b, l_value_e.distance (l_value_b), l_user_agent_applies, l_user_agent_exact)
							end
							if l_user_agent_exact.item then
								l_found_exact := (1).to_boolean
							end
							l_record_count := 0
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 22 then -- else: | _L___3:
						if (l_field_e.distance (l_field_b)).to_natural_32 /= (("allow").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if (strncasecmp (l_field_b, ce_string ("allow"), (("allow").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
							l_pos := -1 + 25 -- goto _L___2
						else
							if l_user_agent_applies.item then
								add_path (l_specs, l_value_b, l_value_e, (1).to_boolean, l_user_agent_exact.item)
							end
							l_record_count := l_record_count + 1
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 25 then -- else: | _L___2:
						if (l_field_e.distance (l_field_b)).to_natural_32 /= (("disallow").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if (strncasecmp (l_field_b, ce_string ("disallow"), (("disallow").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
							l_pos := -1 + 28 -- goto _L___1
						else
							if l_user_agent_applies.item then
								l_allowed := (0).to_boolean
								if l_value_b.is_equal (l_value_e) then
									l_allowed := (1).to_boolean
								end
								add_path (l_specs, l_value_b, l_value_e, l_allowed, l_user_agent_exact.item)
							end
							l_record_count := l_record_count + 1
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else: | _L___1:
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Ignoring unknown field at line %%d"), l_line_count])
							end
							l_break := True
						end
						l_break := False
						l_pos := -1 + 29 -- goto next
				when 29 then -- if done | if done | next:
						l_p___0 := l_lineend_real
						l_line_count := l_line_count + 1
						l_pos := -1 + 1 -- back to loop condition
				when 30 then -- loop done
					if l_found_exact then
						prune_non_exact (l_specs)
					elseif l_specs.item.size > l_specs.item.count then
						l_specs.item.paths := create {CE_CLASS_POINTER [PD_PATH_INFO]}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_specs.item.paths), (l_specs.item.count).to_natural_32 * (create {PD_PATH_INFO}.make).structure_size.to_natural_32)))
						l_specs.item.size := l_specs.item.count
					end
					Result := l_specs
				when 31 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	match_user_agent (a_agent: CE_POINTER [INTEGER_8]; a_length: INTEGER_32; a_matches___0, a_exact_match: CE_POINTER [BOOLEAN])
		require
			not a_matches___0.is_void
			not a_exact_match.is_void
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_length /= 1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_agent[0]).to_integer_32 = 42 then
							a_matches___0.item := (1).to_boolean
							a_exact_match.item := (0).to_boolean
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if ((a_agent + a_length).distance (a_agent)).to_natural_32 = (("wget").count + 1).to_natural_32 - {NATURAL_32} 1 then
							if (strncasecmp (a_agent, ce_string ("wget"), (("wget").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
								a_matches___0.item := (0).to_boolean
								a_exact_match.item := (0).to_boolean
							else
								a_matches___0.item := (1).to_boolean
								a_exact_match.item := (1).to_boolean
							end
						else
							a_matches___0.item := (0).to_boolean
							a_exact_match.item := (0).to_boolean
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	add_path (a_specs: CE_POINTER [PD_ROBOT_SPECS]; a_path_b, a_path_e: CE_POINTER [INTEGER_8]; a_allowedp, a_exactp: BOOLEAN)
		require
			not a_specs.is_void
		local
			l_path_b: CE_POINTER [INTEGER_8]
			l_pp: PD_PATH_INFO
		do
			create l_pp.make

			l_path_b := a_path_b
			if (l_path_b.c_pointer.to_integer_32).to_natural_32 < (a_path_e.c_pointer.to_integer_32).to_natural_32 then
				if (l_path_b[0]).to_integer_32 = 47 then
					l_path_b := l_path_b + 1
				end
			end
			l_pp.path := (create {P_UTILS_STATIC}).strdupdelim (l_path_b, a_path_e)
			l_pp.allowedp := a_allowedp
			l_pp.user_agent_exact_p := a_exactp
			a_specs.item.count := (a_specs.item.count) + 1
			if a_specs.item.count > a_specs.item.size then
				if a_specs.item.size = 0 then
					a_specs.item.size := 1
				else
					a_specs.item.size := (a_specs.item.size).bit_shift_left ((1))
				end
				a_specs.item.paths := create {CE_CLASS_POINTER [PD_PATH_INFO]}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (a_specs.item.paths), (a_specs.item.size).to_natural_32 * (create {PD_PATH_INFO}.make).structure_size.to_natural_32)))
			end
			a_specs.item.paths[(a_specs.item.count - 1)] := l_pp.twin
		end

	prune_non_exact (a_specs: CE_POINTER [PD_ROBOT_SPECS])
		require
			not a_specs.is_void
		local
			l_newpaths: CE_POINTER [PD_PATH_INFO]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_cnt: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_cnt := 0
			l_i := 0
			from
			until
				not (l_i < a_specs.item.count)
			loop
				if (a_specs.item.paths + l_i).item.user_agent_exact_p then
					l_cnt := l_cnt + 1
				end
				l_i := l_i + 1
			end
			l_newpaths := create {CE_CLASS_POINTER [PD_PATH_INFO]}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc (l_cnt.to_natural_32 * (create {PD_PATH_INFO}.make).structure_size.to_natural_32)))
			l_i := 0
			l_j := 0
			from
			until
				not (l_i < a_specs.item.count)
			loop
				if (a_specs.item.paths + l_i).item.user_agent_exact_p then
					l_tmp___0 := l_j
					l_j := l_j + 1
					l_newpaths[l_tmp___0] := (a_specs.item.paths[l_i]).twin
				end
				l_i := l_i + 1
			end
			if l_j /= l_cnt then
				assert_fail (ce_string ("j == cnt"), ce_string ("res.c"), {NATURAL_32} 172, ce_string ("prune_non_exact"))
			end
			free (create {CE_VOID_POINTER}.make_cast (a_specs.item.paths))
			a_specs.item.paths := l_newpaths
			a_specs.item.count := l_cnt
			a_specs.item.size := l_cnt
		end

	res_match_path (a_specs: CE_POINTER [PD_ROBOT_SPECS]; a_path: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_i: INTEGER_32
			l_allowedp: BOOLEAN
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			if a_specs.is_void then
				Result := (1).to_boolean
				l_return := True
			end
			if not l_return then
				l_i := 0
				from
				until
					not (not (l_return) and then (l_i < a_specs.item.count))
				loop
					if (matches ((a_specs.item.paths + l_i).item.path, a_path)) then
						l_allowedp := (a_specs.item.paths + l_i).item.allowedp
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								l_tmp := (create {P_QUOTE_STATIC}).quote ((a_specs.item.paths + l_i).item.path)
								if l_allowedp then
									l_tmp___0 := ce_string ("Allowing")
								else
									l_tmp___0 := ce_string ("Rejecting")
								end
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%%s path %%s because of rule %%s.%N"), l_tmp___0, a_path, l_tmp])
							end
							l_break := True
						end
						l_break := False
						Result := l_allowedp
						l_return := True
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := (1).to_boolean
			end
		end

	matches (a_record_path, a_url_path: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_record_path.is_void
			not a_url_path.is_void
		local
			l_rp: CE_POINTER [INTEGER_8]
			l_up: CE_POINTER [INTEGER_8]
			l_rc: INTEGER_8
			l_uc: INTEGER_8
			l_decoded: INTEGER_8
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_decoded___0: INTEGER_8
			l_tmp___6: INTEGER_32
			l_tmp___8: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_rp := a_record_path
			l_up := a_url_path
			from
			until
				(l_return)
			loop
				l_rc := l_rp[0]
				l_uc := l_up[0]
				if not l_rc.to_boolean then
					Result := (1).to_boolean
					l_return := True
				end
				if not l_return and then (not l_uc.to_boolean) then
					Result := (0).to_boolean
					l_return := True
				end
				if not l_return then
					from
					until
						(l_break)
					loop
						l_break := False
						if l_rc.to_integer_32 = 37 then
							if ((create {P_C_CTYPE_STATIC}).c2_isxdigit ((l_rp[1]).to_integer_32)) then
								if ((create {P_C_CTYPE_STATIC}).c2_isxdigit ((l_rp[2]).to_integer_32)) then
									if (l_rp[1]).to_integer_32 < 65 then
										l_tmp___0 := (l_rp[1]).to_integer_32 - 48
									else
										l_tmp___0 := ((((create {P_C_CTYPE_STATIC}).c2_toupper ((l_rp[1]).to_integer_32)) - 65) + 10)
									end
									if (l_rp[2]).to_integer_32 < 65 then
										l_tmp___2 := (l_rp[2]).to_integer_32 - 48
									else
										l_tmp___2 := ((((create {P_C_CTYPE_STATIC}).c2_toupper ((l_rp[2]).to_integer_32)) - 65) + 10)
									end
									l_decoded := (((l_tmp___0).bit_shift_left (4)) + l_tmp___2).to_integer_8
									if l_decoded.to_integer_32 /= 47 then
										l_rc := l_decoded
										l_rp := l_rp + (2)
									end
								end
							end
						end
						l_break := True
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if l_uc.to_integer_32 = 37 then
							if ((create {P_C_CTYPE_STATIC}).c2_isxdigit ((l_up[1]).to_integer_32)) then
								if ((create {P_C_CTYPE_STATIC}).c2_isxdigit ((l_up[2]).to_integer_32)) then
									if (l_up[1]).to_integer_32 < 65 then
										l_tmp___6 := (l_up[1]).to_integer_32 - 48
									else
										l_tmp___6 := ((((create {P_C_CTYPE_STATIC}).c2_toupper ((l_up[1]).to_integer_32)) - 65) + 10)
									end
									if (l_up[2]).to_integer_32 < 65 then
										l_tmp___8 := (l_up[2]).to_integer_32 - 48
									else
										l_tmp___8 := ((((create {P_C_CTYPE_STATIC}).c2_toupper ((l_up[2]).to_integer_32)) - 65) + 10)
									end
									l_decoded___0 := (((l_tmp___6).bit_shift_left (4)) + l_tmp___8).to_integer_8
									if l_decoded___0.to_integer_32 /= 47 then
										l_uc := l_decoded___0
										l_up := l_up + (2)
									end
								end
							end
						end
						l_break := True
					end
					l_break := False
					if l_rc.to_integer_32 /= l_uc.to_integer_32 then
						Result := (0).to_boolean
						l_return := True
					end
				end
				if not l_return then
					l_rp := l_rp + 1
					l_up := l_up + 1
				end
			end
		end

	res_register_specs (a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32; a_specs: CE_POINTER [PD_ROBOT_SPECS])
		require
			not a_host.is_void
		local
			l_old: CE_ARRAY [CE_POINTER [PD_ROBOT_SPECS]]
			l_hp: CE_POINTER [INTEGER_8]
			l_hp_old: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_HP_len: INTEGER_32
			l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_ROBOT_SPECS]} l_old.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_hp_old.make (<<1>>)

			from
			until
				(l_break)
			loop
				l_break := False
				l_HP_len := (strlen (a_host)).to_integer_32
				l_hp := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new ((((l_HP_len + 1) + ((create {P_UTILS_STATIC}).numdigit (a_port.to_integer_64))) + 1).to_natural_32)))
				memcpy (create {CE_VOID_POINTER}.make_cast (l_hp), create {CE_VOID_POINTER}.make_cast (a_host), l_HP_len.to_natural_32).do_nothing
				l_hp[l_HP_len] := ((':').code).to_integer_8;
				(create {P_UTILS_STATIC}).number_to_string ((l_hp + l_HP_len) + 1, a_port.to_integer_64).do_nothing
				l_break := True
			end
			l_break := False
			if ((create {P_RES_STATIC}).registered_specs.item).is_void then
				(create {P_RES_STATIC}).registered_specs.item := (create {P_HASH_STATIC}).make_nocase_string_hash_table (0)
			end
			if (((create {P_RES_STATIC}).registered_specs.item).item.hash_table_get_pair (create {CE_VOID_POINTER}.make_cast (l_hp), create {CE_VOID_POINTER}.make_cast (l_hp_old), create {CE_VOID_POINTER}.make_cast (l_old))).to_boolean then
				if (not (l_old.item).is_void) then
					(l_old.item).item.free_specs
				end
				((create {P_RES_STATIC}).registered_specs.item).item.hash_table_put (create {CE_VOID_POINTER}.make_cast (l_hp_old.item), create {CE_VOID_POINTER}.make_cast (a_specs))
			else
				((create {P_RES_STATIC}).registered_specs.item).item.hash_table_put (create {CE_VOID_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xstrdup (l_hp))), create {CE_VOID_POINTER}.make_cast (a_specs))
			end
		end

	res_get_specs (a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32): CE_POINTER [PD_ROBOT_SPECS]
		require
			not a_host.is_void
		local
			l_hp: CE_POINTER [INTEGER_8]
			l_HP_len: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			from
			until
				(l_break)
			loop
				l_break := False
				l_HP_len := (strlen (a_host)).to_integer_32
				l_hp := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new ((((l_HP_len + 1) + ((create {P_UTILS_STATIC}).numdigit (a_port.to_integer_64))) + 1).to_natural_32)))
				memcpy (create {CE_VOID_POINTER}.make_cast (l_hp), create {CE_VOID_POINTER}.make_cast (a_host), l_HP_len.to_natural_32).do_nothing
				l_hp[l_HP_len] := ((':').code).to_integer_8;
				(create {P_UTILS_STATIC}).number_to_string ((l_hp + l_HP_len) + 1, a_port.to_integer_64).do_nothing
				l_break := True
			end
			l_break := False
			if ((create {P_RES_STATIC}).registered_specs.item).is_void then
				Result := (create {CE_CLASS_POINTER [PD_ROBOT_SPECS]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_ROBOT_SPECS]}.make_cast ((((create {P_RES_STATIC}).registered_specs.item).item.hash_table_get (create {CE_VOID_POINTER}.make_cast (l_hp)))))
			end
		end

	res_retrieve_file (a_url: CE_POINTER [INTEGER_8]; a_file: CE_POINTER [CE_POINTER [INTEGER_8]]; a_iri: CE_POINTER [PD_IRI]): BOOLEAN
		require
			not a_file.is_void
		local
			l_i: CE_POINTER [PD_IRI]
			l_err: NATURAL_32
			l_robots_url: CE_POINTER [INTEGER_8]
			l_saved_ts_val: INTEGER_32
			l_saved_sp_val: INTEGER_32
			l_url_err: CE_ARRAY [INTEGER_32]
			l_url_parsed: CE_POINTER [PD_URL]
			l_error___0: CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_32_ARRAY} l_url_err.make (<<1>>)

			l_i := (create {P_IRI_STATIC}).dummy_iri.item
			l_robots_url := ((create {P_URL_STATIC}).uri_merge (a_url, ce_string ("/robots.txt")))
			l_saved_ts_val := ((create {P_OPTIONS_STATIC}).opt.item.item.timestamping).to_integer
			l_saved_sp_val := ((create {P_OPTIONS_STATIC}).opt.item.item.spider).to_integer
			l_i.item.utf8_encode := (0).to_boolean;
			(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Loading robots.txt; please ignore errors.%N"))))
			a_file.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer);
			(create {P_OPTIONS_STATIC}).opt.item.item.timestamping := (0).to_boolean;
			(create {P_OPTIONS_STATIC}).opt.item.item.spider := (0).to_boolean
			l_url_parsed := (create {P_URL_STATIC}).url_parse (l_robots_url, l_url_err, a_iri, (1).to_boolean)
			if l_url_parsed.is_void then
				l_error___0 := ((create {P_URL_STATIC}).url_error (l_robots_url, l_url_err.item));
				(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s.%N"), l_robots_url, l_error___0])
				free (create {CE_VOID_POINTER}.make_cast (l_error___0))
				l_err := {PC_UERR_T}.URLERROR
			else
				l_err := (create {P_RETR_STATIC}).retrieve_url (l_url_parsed, l_robots_url, a_file, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), (0).to_boolean, l_i, (0).to_boolean)
				l_url_parsed.item.url_free
			end
			(create {P_OPTIONS_STATIC}).opt.item.item.timestamping := l_saved_ts_val.to_boolean;
			(create {P_OPTIONS_STATIC}).opt.item.item.spider := l_saved_sp_val.to_boolean
			free (create {CE_VOID_POINTER}.make_cast (l_robots_url))
			if l_err /= {NATURAL_32} 31 then
				if not (a_file.item).is_void then
					free (create {CE_VOID_POINTER}.make_cast (a_file.item))
					a_file.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				end
			end
			Result := (l_err = {NATURAL_32} 31)
		end

	schemes_are_similar_p (a_a, a_b: NATURAL_32): BOOLEAN
		local
			l_return: BOOLEAN
		do
			if a_a = a_b then
				Result := (1).to_boolean
				l_return := True
			end
			if not l_return then
				Result := (0).to_boolean
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			url := a_other.url
			local_name := a_other.local_name
			ignore_when_downloading := a_other.ignore_when_downloading
			link_relative_p := a_other.link_relative_p
			link_complete_p := a_other.link_complete_p
			link_base_p := a_other.link_base_p
			link_inline_p := a_other.link_inline_p
			link_css_p := a_other.link_css_p
			link_expect_html := a_other.link_expect_html
			link_expect_css := a_other.link_expect_css
			link_refresh_p := a_other.link_refresh_p
			refresh_timeout := a_other.refresh_timeout
			convert2 := a_other.convert2
			pos := a_other.pos
			size := a_other.size
			next := a_other.next
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				url.is_equal (a_other.url) and
				local_name.is_equal (a_other.local_name) and
				ignore_when_downloading = a_other.ignore_when_downloading and
				link_relative_p = a_other.link_relative_p and
				link_complete_p = a_other.link_complete_p and
				link_base_p = a_other.link_base_p and
				link_inline_p = a_other.link_inline_p and
				link_css_p = a_other.link_css_p and
				link_expect_html = a_other.link_expect_html and
				link_expect_css = a_other.link_expect_css and
				link_refresh_p = a_other.link_refresh_p and
				refresh_timeout = a_other.refresh_timeout and
				convert2 = a_other.convert2 and
				pos = a_other.pos and
				size = a_other.size and
				next.is_equal (a_other.next)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("local_name"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("ignore_when_downloading"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("link_relative_p"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("link_complete_p"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("link_base_p"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("link_inline_p"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("link_css_p"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("link_expect_html"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("link_expect_css"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("link_refresh_p"),
					create {CE_STRUCTURE_FIELD}.make ("refresh_timeout"),
					create {CE_STRUCTURE_FIELD}.make ("convert2"),
					create {CE_STRUCTURE_FIELD}.make ("pos"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("next")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline"
		alias
			"[
				struct urlpos {
					struct url * url;
					char * local_name;
					unsigned int ignore_when_downloading : 1;
					unsigned int link_relative_p : 1;
					unsigned int link_complete_p : 1;
					unsigned int link_base_p : 1;
					unsigned int link_inline_p : 1;
					unsigned int link_css_p : 1;
					unsigned int link_expect_html : 1;
					unsigned int link_expect_css : 1;
					unsigned int link_refresh_p : 1;
					int refresh_timeout;
					unsigned int convert;
					int pos;
					int size;
					struct urlpos * next;
				};
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct urlpos);
					if(strcmp(field_name, "refresh_timeout") == 0) return offsetof(struct urlpos, refresh_timeout);
				} else {
					struct urlpos *p = (struct urlpos *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "ignore_when_downloading") == 0) p->ignore_when_downloading = (unsigned int)$a_value;
						else if(strcmp(field_name, "link_relative_p") == 0) p->link_relative_p = (unsigned int)$a_value;
						else if(strcmp(field_name, "link_complete_p") == 0) p->link_complete_p = (unsigned int)$a_value;
						else if(strcmp(field_name, "link_base_p") == 0) p->link_base_p = (unsigned int)$a_value;
						else if(strcmp(field_name, "link_inline_p") == 0) p->link_inline_p = (unsigned int)$a_value;
						else if(strcmp(field_name, "link_css_p") == 0) p->link_css_p = (unsigned int)$a_value;
						else if(strcmp(field_name, "link_expect_html") == 0) p->link_expect_html = (unsigned int)$a_value;
						else if(strcmp(field_name, "link_expect_css") == 0) p->link_expect_css = (unsigned int)$a_value;
						else if(strcmp(field_name, "link_refresh_p") == 0) p->link_refresh_p = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "ignore_when_downloading") == 0) return p->ignore_when_downloading;
						if(strcmp(field_name, "link_relative_p") == 0) return p->link_relative_p;
						if(strcmp(field_name, "link_complete_p") == 0) return p->link_complete_p;
						if(strcmp(field_name, "link_base_p") == 0) return p->link_base_p;
						if(strcmp(field_name, "link_inline_p") == 0) return p->link_inline_p;
						if(strcmp(field_name, "link_css_p") == 0) return p->link_css_p;
						if(strcmp(field_name, "link_expect_html") == 0) return p->link_expect_html;
						if(strcmp(field_name, "link_expect_css") == 0) return p->link_expect_css;
						if(strcmp(field_name, "link_refresh_p") == 0) return p->link_refresh_p;
					}
				}
			]"
		end

end
