class
	P_DNS_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_NETDB_STATIC
	S_UNISTD_STATIC

feature {ANY} -- public attributes

	dns_cache: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (dns_cache.item), create {CE_VOID_POINTER}.make_cast (dns_cache.item)])
		end

feature {ANY} -- public routines

	get_addr_byte (a_ptr: CE_POINTER [CE_POINTER [NATURAL_8]]; a_res: CE_POINTER [NATURAL_8]; a_stp: INTEGER_8): INTEGER_32
		require
			not a_ptr.is_void
		local
			l_u: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_u := {NATURAL_32} 0
			if ((a_ptr.item).item).to_integer_32 >= 48 then
				if not (((a_ptr.item).item).to_integer_32 <= 57) then
					Result := (-1)
					l_return := True
				end
			else
				Result := (-1)
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if ((a_ptr.item).item).to_integer_32 >= 48 then
						if not (((a_ptr.item).item).to_integer_32 <= 57) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_return or l_break) then
						l_u := (l_u * {NATURAL_32} 10 + ((a_ptr.item).item).to_natural_32) - {NATURAL_32} 48
						if l_u >= {NATURAL_32} 256 then
							Result := (-1)
							l_return := True
						end
						if not l_return then
							a_ptr.item := (a_ptr.item) + 1
						end
					end
				end
			end
			if not l_return then
				l_break := False
				if ((a_ptr.item).item).to_integer_32 /= a_stp.to_integer_32 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				a_ptr.item := (a_ptr.item) + 1
				a_res.item := l_u.to_natural_8
				Result := 0
			end
		end

	do_real_lookup (a_name: CE_POINTER [NATURAL_8]; a_host: CE_POINTER [NATURAL_32]): INTEGER_32
		require
			not a_name.is_void
		local
			l_n: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hst: CE_POINTER [SD_HOSTENT]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_n.make (<<1>>)
			create {CE_CLASS_POINTER [SD_HOSTENT]} l_hst.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_name.item).to_boolean then
						Result := (-1)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_n.item := a_name
				when 2 then -- loop condition:
						if not ((l_n.item.item).to_boolean) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if (l_n.item.item).to_integer_32 /= 46 then
							if (l_n.item.item).to_integer_32 < 48 then
								l_pos := -1 + 12 -- goto nogethostbyaddr
							elseif (l_n.item.item).to_integer_32 > 57 then
								l_pos := -1 + 12 -- goto nogethostbyaddr
							end
						end
				when 4 then
						l_n.item := l_n.item + 1
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						l_n.item := a_name
						if (get_addr_byte (l_n, create {CE_NATURAL_8_POINTER}.make_cast (a_host) + 0, (('.').code).to_integer_8)).to_boolean then
							l_pos := -1 + 11 -- goto skip_addr
						end
				when 6 then
						if (get_addr_byte (l_n, create {CE_NATURAL_8_POINTER}.make_cast (a_host) + 1, (('.').code).to_integer_8)).to_boolean then
							l_pos := -1 + 11 -- goto skip_addr
						end
				when 7 then
						if (get_addr_byte (l_n, create {CE_NATURAL_8_POINTER}.make_cast (a_host) + 2, (('.').code).to_integer_8)).to_boolean then
							l_pos := -1 + 11 -- goto skip_addr
						end
				when 8 then
						if (get_addr_byte (l_n, create {CE_NATURAL_8_POINTER}.make_cast (a_host) + 3, (0).to_integer_8)).to_boolean then
							l_pos := -1 + 11 -- goto skip_addr
						end
				when 9 then
						Result := 0
						l_return := True
				when 10 then -- if done
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 11 then -- if: | skip_addr:
						l_hst := gethostbyaddr (create {CE_VOID_POINTER}.make_cast (a_name), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_name))), 2)
						if (not l_hst.is_void) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | nogethostbyaddr:
						l_hst := gethostbyname (create {CE_INTEGER_8_POINTER}.make_cast (a_name))
						if l_hst.is_void then
							Result := (-1)
							l_return := True
						end
				when 13 then -- if done | if done
					if not l_return then
						memcpy (create {CE_VOID_POINTER}.make_cast (a_host), create {CE_VOID_POINTER}.make_cast (l_hst.item.h_addr_list[0]), {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
						Result := 0
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	lookup_fn (a_name: CE_POINTER [NATURAL_8]; a_h: INTEGER_32)
		require
			not a_name.is_void
		local
			l_host: CE_ARRAY [NATURAL_32]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_host.make (<<1>>)

			if (do_real_lookup (a_name, l_host)).to_boolean then
				l_return := True
			end
			if not l_return then
				write (a_h, create {CE_VOID_POINTER}.make_cast (l_host), {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
			end
		end

	find_in_dns_cache (a_name: CE_POINTER [INTEGER_8]; a_dnsentry: CE_POINTER [CE_POINTER [PD_DNSENTRY]]): INTEGER_32
		local
			l_e: CE_POINTER [PD_DNSENTRY]
			l_return, l_break: BOOLEAN
		do
			l_e := create {CE_CLASS_POINTER [PD_DNSENTRY]}.make_cast (dns_cache.item.item.next)
			from
			until
				not (not (l_return) and then (not l_e.is_equal (dns_cache.item)))
			loop
				if not (strcasecmp ((l_e.item.name), a_name)).to_boolean then
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_e));
					(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_e.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_e.item.prev);
					(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_e.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_e.item.next);
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_e))
					from
					until
						(l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (dns_cache.item))
						l_e.item.next := (create {CE_CLASS_POINTER [PD_DNSENTRY]}.make_cast (dns_cache.item)).item.next
						l_e.item.prev := create {CE_CLASS_POINTER [PD_DNSENTRY]}.make_cast (dns_cache.item);
						(create {CE_CLASS_POINTER [PD_DNSENTRY]}.make_cast (dns_cache.item)).item.next := l_e;
						(l_e.item.next).item.prev := l_e;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (dns_cache.item))
						l_break := True
					end
					l_break := False
					a_dnsentry.item := l_e
					Result := 0
					l_return := True
				end
				if not l_return then
					l_e := l_e.item.next
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

	shrink_dns_cache (a_u: INTEGER_32)
		local
			l_d: CE_POINTER [PD_DNSENTRY]
			l_e: CE_POINTER [PD_DNSENTRY]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := create {CE_CLASS_POINTER [PD_DNSENTRY]}.make_cast (dns_cache.item.item.next)
				when 1 then -- loop condition:
					if l_d.is_equal (dns_cache.item) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						if not (a_u.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if not (((create {P_SELECT_STATIC}).get_time).to_natural_32 - (l_d.item.get_time).to_natural_32 > {NATURAL_32} 3_600_000) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						l_e := l_d
						l_d := l_d.item.prev;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_e));
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_e.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_e.item.prev);
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_e.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_e.item.next);
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_e));
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("dns.c")), 236, create {CE_VOID_POINTER}.make_cast (l_e))
				when 7 then -- if done
						l_d := l_d.item.next
						l_pos := -1 + 1 -- back to loop condition
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	lookup_fn_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent lookup_fn)
		end

end
