class
	P_OS_DEP_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_STDLIB_STATIC
	S_SYS_IOCTL_STATIC
	S_UNISTD_STATIC
	S_SIGNAL_STATIC
	S_FCNTL_STATIC
	S_TERMIOS_STATIC
	S_STDIO_STATIC

feature {ANY} -- public attributes

	xt: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	xt___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	resize_count: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (0).to_natural_32
		end

feature {ANY} -- public routines

	dir_sep (a_x: INTEGER_8): INTEGER_32
		do
			Result := (a_x.to_integer_32 = 47).to_integer
		end

	is_safe_in_shell (a_c: NATURAL_8): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_c.to_integer_32 /= 64 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_tmp := 1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 3 then -- else:
						if a_c.to_integer_32 /= 43 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_tmp := 1
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 6 then -- else:
						if a_c.to_integer_32 /= 45 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_tmp := 1
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 9 then -- else:
						if a_c.to_integer_32 /= 46 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_tmp := 1
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 12 then -- else:
						if a_c.to_integer_32 /= 44 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_tmp := 1
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else:
						if a_c.to_integer_32 /= 61 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_tmp := 1
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 18 then -- else:
						if not (a_c.to_integer_32 >= 48) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if a_c.to_integer_32 <= 57 then
							l_tmp := 1
						else
							l_pos := -1 + 21 -- goto _L___0
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else: | _L___0:
						if not (a_c.to_integer_32 >= 65) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if a_c.to_integer_32 <= 90 then
							l_tmp := 1
						else
							l_pos := -1 + 24 -- goto _L
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L:
						if a_c.to_integer_32 = 95 then
							l_tmp := 1
						elseif a_c.to_integer_32 >= 97 then
							if a_c.to_integer_32 <= 122 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 25 then -- if done | if done | if done | if done | if done | if done | if done
					Result := l_tmp
				when 26 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	is_safe_in_url (a_c: NATURAL_8): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (is_safe_in_shell (a_c)).to_boolean then
				l_tmp___0 := 1
			elseif a_c.to_integer_32 = 58 then
				l_tmp___0 := 1
			elseif a_c.to_integer_32 = 47 then
				l_tmp___0 := 1
			elseif a_c.to_integer_32 >= 128 then
				l_tmp___0 := 1
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	check_shell_security (a_cmd: CE_POINTER [CE_POINTER [NATURAL_8]])
		require
			not a_cmd.is_void
		local
			l_c: CE_POINTER [NATURAL_8]
		do
			l_c := a_cmd.item
			from
			until
				not ((l_c.item).to_boolean)
			loop
				if not (is_safe_in_shell (l_c.item)).to_boolean then
					l_c.item := (('_').code).to_natural_8
				end
				l_c := l_c + 1
			end
		end

	escape_path (a_path: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_result: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_i: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_result.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (not (strchr (create {CE_INTEGER_8_POINTER}.make_cast (a_path), ('%"').code)).is_void) then
						Result := ((create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("os_dep.c")), 47, a_path))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_i := (0).to_natural_32
				when 2 then -- loop condition:
						if not ((a_path[l_i.to_integer_32]).to_boolean) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if not (is_safe_in_url (a_path[l_i.to_integer_32])).to_boolean then
							l_pos := -1 + 7 -- goto do_esc
						end
				when 4 then
						l_i := l_i + 1
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						Result := ((create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("os_dep.c")), 49, a_path))
						l_return := True
				when 6 then -- if done
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 7 then -- if: | do_esc:
						l_result.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("os_dep.c")), 51, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%"")));
						(create {P_LINKS_STATIC}).add_to_strn (l_result, a_path);
						(create {P_LINKS_STATIC}).add_to_strn (l_result, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%"")))
						Result := (l_result.item)
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_e (a_env: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_env.is_void
		local
			l_v: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_v := getenv (a_env)
			if (not l_v.is_void) then
				Result := (atoi (l_v))
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	sigwinch (a_s: CE_POINTER [ANY])
		do
			(create {CE_ROUTINE}.make_cast (a_s)).call ([])
		end

	handle_terminal_resize (a_fd: INTEGER_32; a_fn: CE_ROUTINE)
		do
			(create {P_SELECT_STATIC}).install_signal_handler (28, sigwinch_address, create {CE_VOID_POINTER}.make_cast (a_fn), 0)
		end

	unhandle_terminal_resize (a_fd: INTEGER_32)
		do
			(create {P_SELECT_STATIC}).install_signal_handler (28, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0)
		end

	get_terminal_size (a_fd: INTEGER_32; a_x, a_y: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_ws: CE_ARRAY [SD_WINSIZE]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_WINSIZE]} l_ws.make (<<1>>)

			if a_x.is_void then
				Result := (-1)
				l_return := True
			elseif a_y.is_void then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if (ioctl ([1, {NATURAL_32} 21_523, l_ws])) /= -1 then
					l_tmp := (l_ws.item.ws_col).to_integer_32
					a_x.item := l_tmp
					if not l_tmp.to_boolean then
						l_tmp___0 := get_e (ce_string ("COLUMNS"))
						a_x.item := l_tmp___0
						if not l_tmp___0.to_boolean then
							a_x.item := 80
						end
					end
					l_tmp___1 := (l_ws.item.ws_row).to_integer_32
					a_y.item := l_tmp___1
					if not l_tmp___1.to_boolean then
						l_tmp___2 := get_e (ce_string ("LINES"))
						a_y.item := l_tmp___2
						if not l_tmp___2.to_boolean then
							a_y.item := 24
						end
					end
					Result := 0
					l_return := True
				else
					l_tmp___3 := get_e (ce_string ("COLUMNS"))
					a_x.item := l_tmp___3
					if not l_tmp___3.to_boolean then
						a_x.item := 80
					end
					l_tmp___4 := get_e (ce_string ("LINES"))
					a_y.item := l_tmp___4
					if not l_tmp___4.to_boolean then
						a_y.item := 24
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	set_bin (a_fd: INTEGER_32)
		do
		end

	c2_pipe (a_fd: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := (pipe (a_fd))
		end

	check_file_name (a_file: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := 1
		end

	can_twterm: INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if xt.item = -1 then
				if (not (getenv (ce_string ("TWDISPLAY"))).is_void) then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
				xt.item := l_tmp___0
			end
			Result := xt.item
		end

	is_xterm: INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if xt___0.item = -1 then
				if (not (getenv (ce_string ("DISPLAY"))).is_void) then
					if ((getenv (ce_string ("DISPLAY")))[0]).to_boolean then
						l_tmp___1 := 1
					else
						l_tmp___1 := 0
					end
				else
					l_tmp___1 := 0
				end
				xt___0.item := l_tmp___1
			end
			Result := xt___0.item
		end

	close_fork_tty
		local
			l_t: CE_POINTER [PD_TERMINAL]
			l_d: CE_POINTER [PD_DOWNLOAD]
			l_c: CE_POINTER [PD_CONNECTION]
			l_k: CE_POINTER [PD_K_CONN]
		do
			l_t := create {CE_CLASS_POINTER [PD_TERMINAL]}.make_cast ((create {P_TERMINAL_STATIC}).terminals.item.item.next)
			from
			until
				l_t.is_equal ((create {P_TERMINAL_STATIC}).terminals.item)
			loop
				if l_t.item.fdin > 0 then
					close (l_t.item.fdin).do_nothing
				end
				l_t := l_t.item.next
			end
			l_d := create {CE_CLASS_POINTER [PD_DOWNLOAD]}.make_cast ((create {P_SESSION_STATIC}).downloads.item.item.next)
			from
			until
				l_d.is_equal ((create {P_SESSION_STATIC}).downloads.item)
			loop
				if l_d.item.handle > 0 then
					close (l_d.item.handle).do_nothing
				end
				l_d := l_d.item.next
			end
			l_c := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast ((create {P_SCHED_STATIC}).queue.item.item.next)
			from
			until
				l_c.is_equal ((create {P_SCHED_STATIC}).queue.item)
			loop
				(create {P_CONNECT_STATIC}).close_socket (create {CE_INTEGER_32_POINTER}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock1")));
				(create {P_CONNECT_STATIC}).close_socket (create {CE_INTEGER_32_POINTER}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock2")))
				l_c := l_c.item.next
			end
			l_k := create {CE_CLASS_POINTER [PD_K_CONN]}.make_cast ((create {P_SCHED_STATIC}).keepalive_connections.item.item.next)
			from
			until
				l_k.is_equal ((create {P_SCHED_STATIC}).keepalive_connections.item)
			loop
				close (l_k.item.conn).do_nothing
				l_k := l_k.item.next
			end
		end

	get_path_to_exe
		do
			(create {P_LINKS_STATIC}).path_to_exe.item := (create {P_LINKS_STATIC}).g_argv.item[0]
		end

	exe (a_path: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			signal (20, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
			signal (18, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
			signal (28, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
			Result := (system (a_path))
		end

	get_clipboard_text: CE_POINTER [INTEGER_8]
		do
			Result := (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("os_dep.c")), 470, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))))))
		end

	set_clipboard_text (a_data: CE_POINTER [INTEGER_8])
		do
		end

	set_window_title (a_title: CE_POINTER [NATURAL_8])
		do
		end

	get_window_title: CE_POINTER [NATURAL_8]
		do
			Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
		end

	resize_window (a_x, a_y: INTEGER_32): INTEGER_32
		do
			Result := (-1)
		end

	terminate_osdep
		do
		end

	block_stdin
		do
		end

	unblock_stdin
		do
		end

	start_thread (a_fn: CE_ROUTINE; a_ptr: CE_POINTER [ANY]; a_l: INTEGER_32): INTEGER_32
		local
			l_p: CE_ARRAY [INTEGER_32]
			l_f: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_p.make (<<2>>)

			if (c2_pipe (l_p)) < 0 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				fcntl ([l_p[0], 4, 2_048]).do_nothing
				fcntl ([l_p[1], 4, 2_048]).do_nothing
				l_f := fork
				if not l_f.to_boolean then
					close_fork_tty
					close (l_p[0]).do_nothing
					a_fn.call ([a_ptr, l_p[1]])
					write (l_p[1], create {CE_VOID_POINTER}.make_cast (ce_string ("x")), (1).to_natural_32).do_nothing
					close (l_p[1]).do_nothing
					exit2 (0)
				end
				if l_f = -1 then
					close (l_p[0]).do_nothing
					close (l_p[1]).do_nothing
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				close (l_p[1]).do_nothing
				Result := (l_p[0])
			end
		end

	want_draw
		do
		end

	done_draw
		do
		end

	get_output_handle: INTEGER_32
		do
			Result := 1
		end

	get_ctl_handle: INTEGER_32
		do
			Result := 0
		end

	get_input_handle: INTEGER_32
		do
			Result := 0
		end

	os_cfmakeraw (a_t: CE_POINTER [SD_TERMIOS])
		require
			not a_t.is_void
		do
			cfmakeraw (a_t)
			a_t.item.c2_cc[6] := (1).to_natural_8
		end

	handle_mouse (a_cons: INTEGER_32; a_fn: CE_ROUTINE; a_data: CE_POINTER [ANY]): CE_POINTER [ANY]
		do
			Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
		end

	unhandle_mouse (a_data: CE_POINTER [ANY])
		do
		end

	get_system_env: INTEGER_32
		do
			Result := 0
		end

	exec_new_links (a_term: CE_POINTER [PD_TERMINAL]; a_xterm, a_exe___0, a_param: CE_POINTER [NATURAL_8])
		require
			not a_xterm.is_void
		local
			l_str: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
		do
			l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_xterm))
			l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_exe___0))
			l_str := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("os_dep.c")), 1_649, ((((l_tmp + {NATURAL_32} 1) + l_tmp___0) + {NATURAL_32} 1) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_param)))) + {NATURAL_32} 1)))
			if (a_xterm.item).to_boolean then
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_str), ce_string ("%%s %%s %%s"), a_xterm, a_exe___0, a_param]).do_nothing
			else
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_str), ce_string ("%%s %%s"), a_exe___0, a_param]).do_nothing
			end
			(create {P_TERMINAL_STATIC}).exec_on_terminal (a_term, l_str, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 2);
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("os_dep.c")), 1_653, create {CE_VOID_POINTER}.make_cast (l_str))
		end

	open_in_new_twterm (a_term: CE_POINTER [PD_TERMINAL]; a_exe___0, a_param: CE_POINTER [NATURAL_8])
		local
			l_twterm: CE_POINTER [NATURAL_8]
		do
			l_twterm := create {CE_NATURAL_8_POINTER}.make_cast ((getenv (ce_string ("LINKS_TWTERM"))))
			if l_twterm.is_void then
				l_twterm := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("twterm -e"))
			end
			exec_new_links (a_term, l_twterm, a_exe___0, a_param)
		end

	open_in_new_xterm (a_term: CE_POINTER [PD_TERMINAL]; a_exe___0, a_param: CE_POINTER [NATURAL_8])
		local
			l_xterm: CE_POINTER [NATURAL_8]
		do
			l_xterm := create {CE_NATURAL_8_POINTER}.make_cast ((getenv (ce_string ("LINKS_XTERM"))))
			if l_xterm.is_void then
				l_xterm := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("xterm -e"))
			end
			exec_new_links (a_term, l_xterm, a_exe___0, a_param)
		end

	open_in_new_screen (a_term: CE_POINTER [PD_TERMINAL]; a_exe___0, a_param: CE_POINTER [NATURAL_8])
		do
			exec_new_links (a_term, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("screen")), a_exe___0, a_param)
		end

	set_highpri
		do
		end

feature {ANY} -- routine addresses

	sigwinch_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent sigwinch)
		end

	open_in_new_twterm_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent open_in_new_twterm)
		end

	open_in_new_xterm_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent open_in_new_xterm)
		end

	open_in_new_screen_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent open_in_new_screen)
		end

end
