class
	PD_ALLOC_HEADER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_ALLOC_HEADER]} next.make
			create {CE_CLASS_POINTER [PD_ALLOC_HEADER]} prev.make
			create {CE_NATURAL_8_POINTER} file.make
			create {CE_NATURAL_8_POINTER} comment.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_ALLOC_HEADER] assign set_next

	prev: CE_POINTER [PD_ALLOC_HEADER] assign set_prev

	size: INTEGER_32 assign set_size

	line: INTEGER_32 assign set_line

	file: CE_POINTER [NATURAL_8] assign set_file

	comment: CE_POINTER [NATURAL_8] assign set_comment

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_ALLOC_HEADER])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_ALLOC_HEADER])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_size (a_size: INTEGER_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_line (a_line: INTEGER_32)
		do
			line := a_line
			update_memory_field ("line")
		end

	set_file (a_file: CE_POINTER [NATURAL_8])
		do
			file := a_file
			update_memory_field ("file")
		end

	set_comment (a_comment: CE_POINTER [NATURAL_8])
		do
			comment := a_comment
			update_memory_field ("comment")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			size := a_other.size
			line := a_other.line
			file := a_other.file
			comment := a_other.comment
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				size = a_other.size and
				line = a_other.line and
				file.is_equal (a_other.file) and
				comment.is_equal (a_other.comment)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("line"),
					create {CE_STRUCTURE_FIELD}.make ("file"),
					create {CE_STRUCTURE_FIELD}.make ("comment")
				>>)
			init_structure_info
		end

end
