class
	PD_BOOKMARK

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_BOOKMARK]} next.make
			create {CE_CLASS_POINTER [PD_BOOKMARK]} prev.make
			create {CE_NATURAL_8_POINTER} title.make
			create {CE_NATURAL_8_POINTER} url.make
			create {CE_VOID_POINTER} type_data.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_BOOKMARK] assign set_next

	prev: CE_POINTER [PD_BOOKMARK] assign set_prev

	id: INTEGER_32 assign set_id

	title: CE_POINTER [NATURAL_8] assign set_title

	url: CE_POINTER [NATURAL_8] assign set_url

	type: NATURAL_32 assign set_type

	type_data: CE_POINTER [ANY] assign set_type_data

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_BOOKMARK])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_BOOKMARK])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_id (a_id: INTEGER_32)
		do
			id := a_id
			update_memory_field ("id")
		end

	set_title (a_title: CE_POINTER [NATURAL_8])
		do
			title := a_title
			update_memory_field ("title")
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_type (a_type: NATURAL_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_type_data (a_type_data: CE_POINTER [ANY])
		do
			type_data := a_type_data
			update_memory_field ("type_data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			id := a_other.id
			title := a_other.title
			url := a_other.url
			type := a_other.type
			type_data := a_other.type_data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				id = a_other.id and
				title.is_equal (a_other.title) and
				url.is_equal (a_other.url) and
				type = a_other.type and
				type_data.is_equal (a_other.type_data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("id"),
					create {CE_STRUCTURE_FIELD}.make ("title"),
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("type_data")
				>>)
			init_structure_info
		end

end
