class
	PD_C2_SERVER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_C2_SERVER]} next.make
			create {CE_CLASS_POINTER [PD_C2_SERVER]} prev.make
			create {CE_NATURAL_8_ARRAY} server.make (<<1>>)
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_C2_SERVER] assign set_next

	prev: CE_POINTER [PD_C2_SERVER] assign set_prev

	accept: INTEGER_32 assign set_accept

	server: CE_ARRAY [NATURAL_8]

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_C2_SERVER])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_C2_SERVER])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_accept (a_accept: INTEGER_32)
		do
			accept := a_accept
			update_memory_field ("accept")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			accept := a_other.accept
			server := a_other.server.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				accept = a_other.accept and
				server.is_equal (a_other.server)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("accept"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("server", <<1>>)
				>>)
			init_structure_info
		end

end
