class
	PD_DIALOG_DATA

inherit
	PD_DIALOG_DATA_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_WINDOW]} win.make
			create {CE_CLASS_POINTER [PD_DIALOG]} dlg.make
			create {CE_CLASS_POINTER [PD_MEMORY_LIST]} ml.make
			create {CE_CLASS_ARRAY [PD_DIALOG_ITEM_DATA]} items.make (<<1>>)
			Precursor
		end

feature {ANY} -- fields

	win: CE_POINTER [PD_WINDOW] assign set_win

	dlg: CE_POINTER [PD_DIALOG] assign set_dlg

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	xw: INTEGER_32 assign set_xw

	yw: INTEGER_32 assign set_yw

	n: INTEGER_32 assign set_n

	selected: INTEGER_32 assign set_selected

	ml: CE_POINTER [PD_MEMORY_LIST] assign set_ml

	items: CE_ARRAY [PD_DIALOG_ITEM_DATA]

feature {ANY} -- field setters

	set_win (a_win: CE_POINTER [PD_WINDOW])
		do
			win := a_win
			update_memory_field ("win")
		end

	set_dlg (a_dlg: CE_POINTER [PD_DIALOG])
		do
			dlg := a_dlg
			update_memory_field ("dlg")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_xw (a_xw: INTEGER_32)
		do
			xw := a_xw
			update_memory_field ("xw")
		end

	set_yw (a_yw: INTEGER_32)
		do
			yw := a_yw
			update_memory_field ("yw")
		end

	set_n (a_n: INTEGER_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_selected (a_selected: INTEGER_32)
		do
			selected := a_selected
			update_memory_field ("selected")
		end

	set_ml (a_ml: CE_POINTER [PD_MEMORY_LIST])
		do
			ml := a_ml
			update_memory_field ("ml")
		end

feature {PD_DIALOG_DATA} -- private attributes

	bookmark_dialog_msg: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					(create {P_LINKS_STATIC}).dummyarray.item + 263
				>>)
		end

	bm_add_msg: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					(create {P_LINKS_STATIC}).dummyarray.item + 273,
					(create {P_LINKS_STATIC}).dummyarray.item + 241
				>>)
		end

	http_labels: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					(create {P_LINKS_STATIC}).dummyarray.item + 280,
					(create {P_LINKS_STATIC}).dummyarray.item + 281,
					(create {P_LINKS_STATIC}).dummyarray.item + 282,
					(create {P_LINKS_STATIC}).dummyarray.item + 283,
					(create {P_LINKS_STATIC}).dummyarray.item + 284
				>>)
		end

	ftp_texts: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					(create {P_LINKS_STATIC}).dummyarray.item + 285,
					(create {P_LINKS_STATIC}).dummyarray.item + 286,
					(create {P_LINKS_STATIC}).dummyarray.item + 287,
					(create {P_LINKS_STATIC}).dummyarray.item + 288,
					create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				>>)
		end

	net_msg: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					(create {P_LINKS_STATIC}).dummyarray.item + 57,
					(create {P_LINKS_STATIC}).dummyarray.item + 58,
					(create {P_LINKS_STATIC}).dummyarray.item + 60,
					(create {P_LINKS_STATIC}).dummyarray.item + 61,
					(create {P_LINKS_STATIC}).dummyarray.item + 62,
					(create {P_LINKS_STATIC}).dummyarray.item + 63,
					(create {P_LINKS_STATIC}).dummyarray.item + 64,
					(create {P_LINKS_STATIC}).dummyarray.item + 65,
					(create {P_LINKS_STATIC}).dummyarray.item + 66,
					create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")),
					create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
				>>)
		end

	prg_msg: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					(create {P_LINKS_STATIC}).dummyarray.item + 290,
					(create {P_LINKS_STATIC}).dummyarray.item + 291,
					(create {P_LINKS_STATIC}).dummyarray.item + 292,
					(create {P_LINKS_STATIC}).dummyarray.item + 293,
					create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
				>>)
		end

	ct_msg: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					(create {P_LINKS_STATIC}).dummyarray.item + 190,
					(create {P_LINKS_STATIC}).dummyarray.item + 191,
					(create {P_LINKS_STATIC}).dummyarray.item + 192,
					(create {P_LINKS_STATIC}).dummyarray.item + 193,
					(create {P_LINKS_STATIC}).dummyarray.item + 194,
					(create {P_LINKS_STATIC}).dummyarray.item + 195,
					(create {P_LINKS_STATIC}).dummyarray.item + 196
				>>)
		end

	ext_msg: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					(create {P_LINKS_STATIC}).dummyarray.item + 199,
					(create {P_LINKS_STATIC}).dummyarray.item + 200
				>>)
		end

feature {ANY} -- public routines

	display_dlg_item (a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_sel: INTEGER_32)
		require
			not a_di.is_void
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_co: INTEGER_32
			l_text: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_tmp___2: NATURAL_32
			l_tmp___4: NATURAL_32
			l_tmp___5: INTEGER_32
			l_tmp___6: NATURAL_32
			l_tmp___7: NATURAL_32
			l_tmp___8: NATURAL_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_term := win.item.term
					inspect (a_di.item.item).item.type -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 2
					when 4 then l_pos := -1 + 3
					when 5 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 1
					if (a_di.item.checked).to_boolean then
						(create {P_TERMINAL_STATIC}).print_text (l_term, a_di.item.x, a_di.item.y, 3, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("[X]")), {NATURAL_32} 14_336)
						update_class_fields -- Current might have been changed; synchronize
					else
						(create {P_TERMINAL_STATIC}).print_text (l_term, a_di.item.x, a_di.item.y, 3, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("[ ]")), {NATURAL_32} 14_336)
						update_class_fields -- Current might have been changed; synchronize
					end
					if a_sel.to_boolean then
						l_term.item.set_cursor (a_di.item.x + 1, a_di.item.y, a_di.item.x + 1, a_di.item.y)
						update_class_fields -- Current might have been changed; synchronize
						win.item.set_window_ptr (a_di.item.x, a_di.item.y)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 6 -- switch 1; break
				when 2 then -- switch 1, case 3 | switch 1, case 2
					if a_di.item.vpos + a_di.item.l <= a_di.item.cpos then
						a_di.item.vpos := (a_di.item.cpos - a_di.item.l) + 1
						update_class_fields -- Current might have been changed; synchronize
					end
					if a_di.item.vpos > a_di.item.cpos then
						a_di.item.vpos := a_di.item.cpos
						update_class_fields -- Current might have been changed; synchronize
					end
					if a_di.item.vpos < 0 then
						a_di.item.vpos := 0
						update_class_fields -- Current might have been changed; synchronize
					end
					l_term.item.fill_area (a_di.item.x, a_di.item.y, a_di.item.l, 1, {NATURAL_32} 1_792)
					update_class_fields -- Current might have been changed; synchronize
					if (a_di.item.item).item.type = 2 then
						l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((a_di.item.cdata + a_di.item.vpos)))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2 <= (a_di.item.l).to_natural_32 then
							l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((a_di.item.cdata + a_di.item.vpos)))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___1 := l_tmp___0.to_integer_32
						else
							l_tmp___1 := a_di.item.l
						end
						(create {P_TERMINAL_STATIC}).print_text (l_term, a_di.item.x, a_di.item.y, l_tmp___1, a_di.item.cdata + a_di.item.vpos, {NATURAL_32} 1_792)
						update_class_fields -- Current might have been changed; synchronize
					else
						l_tmp___6 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((a_di.item.cdata + a_di.item.vpos)))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___6 <= (a_di.item.l).to_natural_32 then
							l_tmp___4 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((a_di.item.cdata + a_di.item.vpos)))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___5 := l_tmp___4.to_integer_32
						else
							l_tmp___5 := a_di.item.l
						end
						l_term.item.fill_area (a_di.item.x, a_di.item.y, l_tmp___5, 1, {NATURAL_32} 1_834)
						update_class_fields -- Current might have been changed; synchronize
					end
					if a_sel.to_boolean then
						l_term.item.set_cursor ((a_di.item.x + a_di.item.cpos) - a_di.item.vpos, a_di.item.y, (a_di.item.x + a_di.item.cpos) - a_di.item.vpos, a_di.item.y)
						update_class_fields -- Current might have been changed; synchronize
						win.item.set_window_ptr (a_di.item.x, a_di.item.y)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 4
					if a_sel.to_boolean then
						l_co := 18_176
					else
						l_co := 14_336
					end
					l_text := (create {P_LANGUAGE_STATIC}).get_text_translation ((a_di.item.item).item.text, l_term)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_TERMINAL_STATIC}).print_text (l_term, a_di.item.x, a_di.item.y, 2, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("[ ")), l_co.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___7 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_text))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_TERMINAL_STATIC}).print_text (l_term, a_di.item.x + 2, a_di.item.y, l_tmp___7.to_integer_32, l_text, l_co.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___8 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_text))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_TERMINAL_STATIC}).print_text (l_term, ((a_di.item.x + 2).to_natural_32 + l_tmp___8).to_integer_32, a_di.item.y, 2, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ]")), l_co.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if a_sel.to_boolean then
						l_term.item.set_cursor (a_di.item.x + 2, a_di.item.y, a_di.item.x + 2, a_di.item.y)
						update_class_fields -- Current might have been changed; synchronize
						win.item.set_window_ptr (a_di.item.x, a_di.item.y)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 5;
					((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.show_dlg_item_box (a_di)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
					from
					until
						False
					loop
						(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).errline.item := 505
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Tried to draw unknown"))])
						update_class_fields -- Current might have been changed; synchronize
					end
				when 6 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	redraw_dialog
		local
			l_i: INTEGER_32
			l_term: CE_POINTER [PD_TERMINAL]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [NATURAL_8]
		do
			l_term := win.item.term
			l_term.item.draw_frame (x + 3, y + 1, xw - 6, yw - 2, {NATURAL_32} 14_336, 2)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_LANGUAGE_STATIC}).get_text_translation (dlg.item.title, l_term)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp))
			update_class_fields -- Current might have been changed; synchronize
			l_i := l_tmp___0.to_integer_32;
			(create {P_TERMINAL_STATIC}).print_text (l_term, ((xw - l_i) // 2 + x) - 1, y + 1, 1, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")), {NATURAL_32} 1_792)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___1 := (create {P_LANGUAGE_STATIC}).get_text_translation (dlg.item.title, l_term)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_TERMINAL_STATIC}).print_text (l_term, (xw - l_i) // 2 + x, y + 1, l_i, l_tmp___1, {NATURAL_32} 1_792)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_TERMINAL_STATIC}).print_text (l_term, ((xw - l_i) // 2 + x) + l_i, y + 1, 1, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")), {NATURAL_32} 1_792)
			update_class_fields -- Current might have been changed; synchronize
			l_i := 0
			from
			until
				not (l_i < n)
			loop
				((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.display_dlg_item (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (l_i)), (l_i = selected).to_integer)
				update_class_fields -- Current might have been changed; synchronize
				l_i := l_i + 1
			end
			(create {P_TERMINAL_STATIC}).redraw_from_window (win)
			update_class_fields -- Current might have been changed; synchronize
		end

	cancel_dialog (a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		do
			win.item.delete_window
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	check_dialog: INTEGER_32
		local
			l_i: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i := 0
				when 1 then -- loop condition:
					if not (not (l_return) and then (l_i < n)) then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						if dlg.item.items[l_i].type /= 1 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 5 then -- else:
						if dlg.item.items[l_i].type /= 2 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if dlg.item.items[l_i].type /= 3 then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if (not (dlg.item.items[l_i].fn).is_void) then
							l_tmp := (dlg.item.items[l_i].fn).integer_32_item ([(create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (l_i))])
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp.to_boolean then
								Current.selected := l_i
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.redraw_dialog
								update_class_fields -- Current might have been changed; synchronize
								Result := 1
								l_return := True
							end
						end
				when 10 then -- if done | if done
						if not l_return then
							l_i := l_i + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
					if not l_return then
						Result := 0
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ok_dialog (a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		local
			l_i: INTEGER_32
			l_fn: CE_ROUTINE
			l_data: CE_POINTER [ANY]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_fn := dlg.item.refresh
			l_data := dlg.item.refresh_data
			l_tmp := ((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.check_dialog
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_i := 0
				from
				until
					not (l_i < n)
				loop
					memcpy (create {CE_VOID_POINTER}.make_cast (dlg.item.items[l_i].data), create {CE_VOID_POINTER}.make_cast (items[l_i].cdata), (dlg.item.items[l_i].dlen).to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				if (not l_fn.is_void) then
					l_fn.call ([l_data])
					update_class_fields -- Current might have been changed; synchronize
				end
				l_i := ((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.cancel_dialog (a_di)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_i
			end
		end

	center_dlg
		do
			Current.x := ((win.item.term).item.x - xw) // 2
			update_class_fields -- Current might have been changed; synchronize
			Current.y := ((win.item.term).item.y - yw) // 2
			update_class_fields -- Current might have been changed; synchronize
		end

	draw_dlg
		do
			(win.item.term).item.fill_area (x, y, xw, yw, {NATURAL_32} 14_336)
			update_class_fields -- Current might have been changed; synchronize
		end

	checkbox_list_fn
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: CE_ARRAY [INTEGER_32]
			l_min: CE_ARRAY [INTEGER_32]
			l_w: INTEGER_32
			l_rw: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_max.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_min.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rw.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)

			l_term := win.item.term
			l_max.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_min.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := 0
			update_class_fields -- Current might have been changed; synchronize
			checkboxes_width (l_term, create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (dlg.item.udata), l_max, max_text_width_address)
			update_class_fields -- Current might have been changed; synchronize
			checkboxes_width (l_term, create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (dlg.item.udata), l_min, min_text_width_address)
			update_class_fields -- Current might have been changed; synchronize
			max_buttons_width (l_term, (items + n) - 2, 2, l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_buttons_width (l_term, (items + n) - 2, 2, l_min)
			update_class_fields -- Current might have been changed; synchronize
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max.item then
				l_w := l_max.item
			end
			if l_w < l_min.item then
				l_w := l_min.item
			end
			if l_w > l_term.item.x - 12 then
				l_w := l_term.item.x - 12
			end
			if l_w < 5 then
				l_w := 5
			end
			l_rw.item := 0
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_checkboxes (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, items, n - 2, 0, l_y, l_w, l_rw, create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (dlg.item.udata))
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, (items + n) - 2, 2, 0, l_y, l_w, l_rw, 1)
			update_class_fields -- Current might have been changed; synchronize
			l_w := l_rw.item
			Current.xw := l_rw.item + 12
			update_class_fields -- Current might have been changed; synchronize
			Current.yw := l_y.item + 4
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.center_dlg
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.draw_dlg
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := (y + 2) + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_checkboxes (l_term, l_term, items, n - 2, x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (dlg.item.udata))
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (l_term, l_term, (items + n) - 2, 2, x + 6, l_y, l_w, l_rw, 1)
			update_class_fields -- Current might have been changed; synchronize
		end

	group_fn
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: CE_ARRAY [INTEGER_32]
			l_min: CE_ARRAY [INTEGER_32]
			l_w: INTEGER_32
			l_rw: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_max.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_min.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rw.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)

			l_term := win.item.term
			l_max.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_min.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := 0
			update_class_fields -- Current might have been changed; synchronize
			max_group_width (l_term, create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (dlg.item.udata), items, n - 2, l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_group_width (l_term, create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (dlg.item.udata), items, n - 2, l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_buttons_width (l_term, (items + n) - 2, 2, l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_buttons_width (l_term, (items + n) - 2, 2, l_min)
			update_class_fields -- Current might have been changed; synchronize
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max.item then
				l_w := l_max.item
			end
			if l_w < l_min.item then
				l_w := l_min.item
			end
			if l_w > l_term.item.x - 12 then
				l_w := l_term.item.x - 12
			end
			if l_w < 1 then
				l_w := 1
			end
			l_rw.item := 0
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_group (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (dlg.item.udata), items, n - 2, 0, l_y, l_w, l_rw)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, (items + n) - 2, 2, 0, l_y, l_w, l_rw, 1)
			update_class_fields -- Current might have been changed; synchronize
			l_w := l_rw.item
			Current.xw := l_rw.item + 12
			update_class_fields -- Current might have been changed; synchronize
			Current.yw := l_y.item + 4
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.center_dlg
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.draw_dlg
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := (y + 2) + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_group (l_term, l_term, create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (dlg.item.udata), items, n - 2, x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (l_term, l_term, (items + n) - 2, 2, x + 6, l_y, l_w, l_rw, 1)
			update_class_fields -- Current might have been changed; synchronize
		end

	msg_box_fn
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: CE_ARRAY [INTEGER_32]
			l_min: CE_ARRAY [INTEGER_32]
			l_w: INTEGER_32
			l_rw: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_ptr: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_text: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp: CE_POINTER [NATURAL_8]
			l_textl: CE_ARRAY [INTEGER_32]
			l_tmp___0: CE_POINTER [NATURAL_8]
		do
			create {CE_INTEGER_32_ARRAY} l_max.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_min.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rw.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_text.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_textl.make (<<1>>)

			l_term := win.item.term
			l_max.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_min.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 1_175)
			update_class_fields -- Current might have been changed; synchronize
			l_text.item := l_tmp
			update_class_fields -- Current might have been changed; synchronize
			l_textl.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_ptr := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (dlg.item.udata)
			from
			until
				(l_ptr.item).is_void
			loop
				l_tmp___0 := (create {P_LANGUAGE_STATIC}).get_text_translation (l_ptr.item, l_term)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_LINKS_STATIC}).add_to_str (l_text, l_textl, l_tmp___0)
				update_class_fields -- Current might have been changed; synchronize
				l_ptr := l_ptr + 1
			end
			max_text_width (l_term, l_text.item, l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, l_text.item, l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_buttons_width (l_term, items, n, l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_buttons_width (l_term, items, n, l_min)
			update_class_fields -- Current might have been changed; synchronize
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max.item then
				l_w := l_max.item
			end
			if l_w < l_min.item then
				l_w := l_min.item
			end
			if l_w > l_term.item.x - 12 then
				l_w := l_term.item.x - 12
			end
			if l_w < 1 then
				l_w := 1
			end
			l_rw.item := 0
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, l_text.item, 0, l_y, l_w, l_rw, 14_336, dlg.item.align)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, items, n, 0, l_y, l_w, l_rw, 1)
			update_class_fields -- Current might have been changed; synchronize
			l_w := l_rw.item
			Current.xw := l_rw.item + 12
			update_class_fields -- Current might have been changed; synchronize
			Current.yw := l_y.item + 4
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.center_dlg
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.draw_dlg
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := (y + 2) + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (l_term, l_term, l_text.item, x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, dlg.item.align)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (l_term, l_term, items, n, x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 1_200, create {CE_VOID_POINTER}.make_cast (l_text.item))
			update_class_fields -- Current might have been changed; synchronize
		end

	msg_box_button (a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		require
			not a_di.is_void
		local
			l_fn: CE_ROUTINE
			l_data: CE_POINTER [ANY]
		do
			l_fn := create {CE_ROUTINE}.make_cast ((a_di.item.item).item.udata)
			l_data := dlg.item.udata2
			if (not l_fn.is_void) then
				l_fn.call ([l_data])
				update_class_fields -- Current might have been changed; synchronize
			end
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.cancel_dialog (a_di).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	input_field_cancel (a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		require
			not a_di.is_void
		local
			l_fn: CE_ROUTINE
			l_data: CE_POINTER [ANY]
		do
			l_fn := create {CE_ROUTINE}.make_cast ((a_di.item.item).item.udata)
			l_data := dlg.item.udata2
			if (not l_fn.is_void) then
				l_fn.call ([l_data])
				update_class_fields -- Current might have been changed; synchronize
			end
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.cancel_dialog (a_di).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	input_field_ok (a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		require
			not a_di.is_void
		local
			l_fn: CE_ROUTINE
			l_data: CE_POINTER [ANY]
			l_text: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_fn := create {CE_ROUTINE}.make_cast ((a_di.item.item).item.udata)
			l_data := dlg.item.udata2
			l_text := items[0].cdata
			l_tmp := ((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.check_dialog
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				Result := 1
				l_return := True
			end
			if not l_return then
				(create {P_BFU_STATIC}).add_to_history (dlg.item.items[0].history, l_text)
				update_class_fields -- Current might have been changed; synchronize
				if (not l_fn.is_void) then
					l_fn.call ([l_data, l_text])
					update_class_fields -- Current might have been changed; synchronize
				end
				((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.ok_dialog (a_di).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

	input_field_fn
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: CE_ARRAY [INTEGER_32]
			l_min: CE_ARRAY [INTEGER_32]
			l_w: INTEGER_32
			l_rw: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_max.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_min.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rw.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)

			l_term := win.item.term
			l_max.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_min.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := -1
			update_class_fields -- Current might have been changed; synchronize
			max_text_width (l_term, create {CE_NATURAL_8_POINTER}.make_cast (dlg.item.udata), l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, create {CE_NATURAL_8_POINTER}.make_cast (dlg.item.udata), l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_buttons_width (l_term, items + 1, 2, l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_buttons_width (l_term, items + 1, 2, l_min)
			update_class_fields -- Current might have been changed; synchronize
			if l_max.item < dlg.item.items[0].dlen then
				l_max.item := dlg.item.items[0].dlen
				update_class_fields -- Current might have been changed; synchronize
			end
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max.item then
				l_w := l_max.item
			end
			if l_w < l_min.item then
				l_w := l_min.item
			end
			l_rw.item := 0
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, create {CE_NATURAL_8_POINTER}.make_cast (dlg.item.udata), 0, l_y, l_w, l_rw, 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_field (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, items, 0, l_y, l_w, l_rw, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, items + 1, 2, 0, l_y, l_w, l_rw, 1)
			update_class_fields -- Current might have been changed; synchronize
			l_w := l_rw.item
			Current.xw := l_rw.item + 12
			update_class_fields -- Current might have been changed; synchronize
			Current.yw := l_y.item + 4
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.center_dlg
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.draw_dlg
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := y + 2
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (l_term, l_term, create {CE_NATURAL_8_POINTER}.make_cast (dlg.item.udata), x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_field (l_term, l_term, items, x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (l_term, l_term, items + 1, 2, x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1)
			update_class_fields -- Current might have been changed; synchronize
		end

	show_dlg_item_box (a_box_item_data: CE_POINTER [PD_DIALOG_ITEM_DATA])
		require
			not a_box_item_data.is_void
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]
			l_citem: CE_POINTER [PD_BOX_ITEM]
			l_n: INTEGER_32
			l_len: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
		do
			l_term := win.item.term
			l_box := create {CE_CLASS_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast ((a_box_item_data.item.item).item.data)
			l_n := 0
			l_term.item.fill_area (a_box_item_data.item.x, a_box_item_data.item.y, a_box_item_data.item.l, (a_box_item_data.item.item).item.gid, {NATURAL_32} 1_792)
			update_class_fields -- Current might have been changed; synchronize
			l_citem := create {CE_CLASS_POINTER [PD_BOX_ITEM]}.make_cast (l_box.item.items.next)
			from
			until
				l_citem.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_box.c_pointer + (create {PD_DLG_DATA_ITEM_DATA_BOX}.make).offset_of ("items")))
			loop
				l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_citem.item.text))
				update_class_fields -- Current might have been changed; synchronize
				l_len := l_tmp.to_integer_32
				if l_len > a_box_item_data.item.l then
					l_len := a_box_item_data.item.l
				end
				if l_n >= l_box.item.box_top then
					if l_n < l_box.item.box_top + (a_box_item_data.item.item).item.gid then
						if l_n = l_box.item.sel then
							l_tmp___0 := 18_176
						else
							l_tmp___0 := 1_792
						end
						(create {P_TERMINAL_STATIC}).print_text (l_term, a_box_item_data.item.x, (a_box_item_data.item.y + l_n) - l_box.item.box_top, l_len, l_citem.item.text, l_tmp___0.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_n := l_n + 1
				l_citem := l_citem.item.next
			end
			l_box.item.list_len := l_n
			update_class_fields -- Current might have been changed; synchronize
		end

	bookmark_dialog_abort_handler
		local
			l_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]
		do
			l_box := create {CE_CLASS_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (dlg.item.items[5].data);
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_box.c_pointer + (create {PD_DLG_DATA_ITEM_DATA_BOX}.make).offset_of ("items"))).item.bookmark_dlg_list_clear
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 335, create {CE_VOID_POINTER}.make_cast (l_box))
			update_class_fields -- Current might have been changed; synchronize
		end

	layout_bookmark_manager
		local
			l_max: CE_ARRAY [INTEGER_32]
			l_min: CE_ARRAY [INTEGER_32]
			l_w: INTEGER_32
			l_rw: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_term: CE_POINTER [PD_TERMINAL]
		do
			create {CE_INTEGER_32_ARRAY} l_max.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_min.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rw.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)

			l_max.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_min.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := -1
			update_class_fields -- Current might have been changed; synchronize
			l_term := win.item.term
			max_text_width (l_term, bookmark_dialog_msg.item[0], l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, bookmark_dialog_msg.item[0], l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_buttons_width (l_term, items + 2, 2, l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_buttons_width (l_term, items + 2, 2, l_min)
			update_class_fields -- Current might have been changed; synchronize
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max.item then
				l_w := l_max.item
			end
			if l_w < l_min.item then
				l_w := l_min.item
			end
			if l_w > l_term.item.x - 12 then
				l_w := l_term.item.x - 12
			end
			if l_w < 1 then
				l_w := 1
			end
			l_rw.item := 50
			update_class_fields -- Current might have been changed; synchronize
			l_w := l_rw.item
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_box (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (5)), x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, items, 5, 0, l_y, l_w, l_rw, 1)
			update_class_fields -- Current might have been changed; synchronize
			l_w := l_rw.item
			Current.xw := l_w + 12
			update_class_fields -- Current might have been changed; synchronize
			Current.yw := l_y.item + 4
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.center_dlg
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.draw_dlg
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := y + 2
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_box (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (5)), x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (0)), 5, x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1)
			update_class_fields -- Current might have been changed; synchronize
		end

	push_add_button (a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		do
			(win.item.term).item.launch_bm_add_doc_dialog ((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_SESSION]}.make_cast (dlg.item.udata))
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	push_goto_button (a_goto_btn: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		local
			l_id: INTEGER_32
			l_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]
		do
			l_box := create {CE_CLASS_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (dlg.item.items[5].data)
			l_id := bookmark_dlg_box_id_get (l_box)
			update_class_fields -- Current might have been changed; synchronize
			if l_id /= -1 then
				bookmark_goto (l_id, create {CE_CLASS_POINTER [PD_SESSION]}.make_cast ((a_goto_btn.item.item).item.udata))
				update_class_fields -- Current might have been changed; synchronize
			end
			win.item.delete_window
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	push_edit_button (a_edit_btn: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		local
			l_id: INTEGER_32
			l_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]
			l_name: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_url: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
		do
			l_box := create {CE_CLASS_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (dlg.item.items[5].data)
			l_id := bookmark_dlg_box_id_get (l_box)
			update_class_fields -- Current might have been changed; synchronize
			if l_id /= -1 then
				l_tmp := bookmark_get_name (l_id)
				update_class_fields -- Current might have been changed; synchronize
				l_name := l_tmp
				l_tmp___0 := bookmark_get_url (l_id)
				update_class_fields -- Current might have been changed; synchronize
				l_url := l_tmp___0;
				(win.item.term).item.bookmark_edit_dialog ((create {P_LINKS_STATIC}).dummyarray.item + 269, l_name, l_url, create {CE_CLASS_POINTER [PD_SESSION]}.make_cast ((a_edit_btn.item.item).item.udata), (create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer)), (create {PD_DIALOG_STATIC}).bookmark_edit_done_address, create {CE_VOID_POINTER}.make_shared (default_pointer + l_id))
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := 0
		end

	push_delete_button (a_some_useless_delete_button: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			l_hop: CE_POINTER [PD_PUSH_DEL_BUTTON_HOP_STRUCT]
			l_term: CE_POINTER [PD_TERMINAL]
			l_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: CE_POINTER [PD_MEMORY_LIST]
			l_return: BOOLEAN
		do
			l_term := win.item.term
			l_box := create {CE_CLASS_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (dlg.item.items[5].data)
			l_tmp := bookmark_dlg_box_id_get (l_box)
			update_class_fields -- Current might have been changed; synchronize
			l_bm := (create {P_BOOKMARK_STATIC}).get_bookmark_by_id (l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			if l_bm.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 645, (create {PD_PUSH_DEL_BUTTON_HOP_STRUCT}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_hop := create {CE_CLASS_POINTER [PD_PUSH_DEL_BUTTON_HOP_STRUCT]}.make_cast (l_tmp___0)
				l_hop.item.id := l_bm.item.id
				update_class_fields -- Current might have been changed; synchronize
				l_hop.item.dlg := dlg
				update_class_fields -- Current might have been changed; synchronize
				l_hop.item.box := l_box
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___1 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_hop), create {CE_VOID_POINTER}.make_shared (default_pointer)])
				update_class_fields -- Current might have been changed; synchronize
				l_term.item.msg_box ([l_tmp___1, (create {P_LINKS_STATIC}).dummyarray.item + 270, 129, (create {P_LINKS_STATIC}).dummyarray.item + 270, ce_string (" %""), l_bm.item.title, ce_string ("%" ("), (create {P_LINKS_STATIC}).dummyarray.item + 272, ce_string (": %""), l_bm.item.url, ce_string ("%")?"), create {CE_VOID_POINTER}.make_shared (default_pointer), l_hop, 2, (create {P_LINKS_STATIC}).dummyarray.item + 166, (create {P_BOOKMARK_STATIC}).really_del_bookmark_address, 1, (create {P_LINKS_STATIC}).dummyarray.item + 167, create {CE_VOID_POINTER}.make_shared (default_pointer), 2])
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

	layout_add_dialog
		local
			l_max: CE_ARRAY [INTEGER_32]
			l_min: CE_ARRAY [INTEGER_32]
			l_w: INTEGER_32
			l_rw: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_term: CE_POINTER [PD_TERMINAL]
		do
			create {CE_INTEGER_32_ARRAY} l_max.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_min.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rw.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)

			l_max.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_min.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := -1
			update_class_fields -- Current might have been changed; synchronize
			l_term := win.item.term
			max_text_width (l_term, bm_add_msg.item[0], l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, bm_add_msg.item[0], l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_text_width (l_term, bm_add_msg.item[1], l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, bm_add_msg.item[1], l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_buttons_width (l_term, items + 2, 2, l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_buttons_width (l_term, items + 2, 2, l_min)
			update_class_fields -- Current might have been changed; synchronize
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max.item then
				l_w := l_max.item
			end
			if l_w < l_min.item then
				l_w := l_min.item
			end
			if l_w > l_term.item.x - 12 then
				l_w := l_term.item.x - 12
			end
			if l_w < 1 then
				l_w := 1
			end
			l_rw.item := 50
			update_class_fields -- Current might have been changed; synchronize
			l_w := l_rw.item
			dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, bm_add_msg.item[0], 0, l_y, l_w, l_rw, 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + (2)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, bm_add_msg.item[1], 0, l_y, l_w, l_rw, 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + (2)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, items + 2, 2, 0, l_y, l_w, l_rw, 1)
			update_class_fields -- Current might have been changed; synchronize
			l_w := l_rw.item
			Current.xw := l_w + 12
			update_class_fields -- Current might have been changed; synchronize
			Current.yw := l_y.item + 4
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.center_dlg
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.draw_dlg
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := y + 2
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (l_term, l_term, bm_add_msg.item[0], x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_field (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (0)), x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (l_term, l_term, bm_add_msg.item[1], x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_field (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (1)), x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (2)), 2, x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1)
			update_class_fields -- Current might have been changed; synchronize
		end

	refresh_abort
		do
			end_refresh (create {CE_CLASS_POINTER [PD_REFRESH]}.make_cast (dlg.item.udata2))
			update_class_fields -- Current might have been changed; synchronize
		end

	dlg_http_options (a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		require
			not a_di.is_void
		local
			l_bugs: CE_POINTER [PD_HTTP_BUGS]
			l_d: CE_POINTER [PD_DIALOG]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [PD_MEMORY_LIST]
		do
			l_bugs := create {CE_CLASS_POINTER [PD_HTTP_BUGS]}.make_cast (a_di.item.cdata)
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 454, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 8 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_d := create {CE_CLASS_POINTER [PD_DIALOG]}.make_cast (l_tmp)
			memset (create {CE_VOID_POINTER}.make_cast (l_d), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 8 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.title := (create {P_LINKS_STATIC}).dummyarray.item + 279
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.fn := checkbox_list_fn_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.udata := create {CE_VOID_POINTER}.make_cast (http_labels.item)
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].type := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].gid := 0
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_bugs.c_pointer + (create {PD_HTTP_BUGS}.make).offset_of ("http10"))))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].type := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].gid := 0
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_bugs.c_pointer + (create {PD_HTTP_BUGS}.make).offset_of ("allow_blacklist"))))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].type := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].gid := 0
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_bugs.c_pointer + (create {PD_HTTP_BUGS}.make).offset_of ("bug_302_redirect"))))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].type := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].gid := 0
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_bugs.c_pointer + (create {PD_HTTP_BUGS}.make).offset_of ("bug_post_no_keepalive"))))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].type := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].gid := 0
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[4].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_bugs.c_pointer + (create {PD_HTTP_BUGS}.make).offset_of ("no_accept_charset"))))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].fn := ok_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[5].text := (create {P_LINKS_STATIC}).dummyarray.item + 14
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].gid := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].fn := cancel_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[6].text := (create {P_LINKS_STATIC}).dummyarray.item + 6
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[7].type := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_d), create {CE_VOID_POINTER}.make_shared (default_pointer)])
			update_class_fields; -- Current might have been changed; synchronize
			(win.item.term).item.do_dialog (l_d, l_tmp___0)
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	ftpopt_fn
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: CE_ARRAY [INTEGER_32]
			l_min: CE_ARRAY [INTEGER_32]
			l_w: INTEGER_32
			l_rw: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_max.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_min.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rw.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)

			l_term := win.item.term
			l_max.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_min.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := 0
			update_class_fields -- Current might have been changed; synchronize
			max_text_width (l_term, ftp_texts.item[0], l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, ftp_texts.item[0], l_min)
			update_class_fields -- Current might have been changed; synchronize
			checkboxes_width (l_term, ftp_texts.item + 1, l_max, max_text_width_address)
			update_class_fields -- Current might have been changed; synchronize
			checkboxes_width (l_term, ftp_texts.item + 1, l_min, min_text_width_address)
			update_class_fields -- Current might have been changed; synchronize
			max_buttons_width (l_term, (items + n) - 2, 2, l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_buttons_width (l_term, (items + n) - 2, 2, l_min)
			update_class_fields -- Current might have been changed; synchronize
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max.item then
				l_w := l_max.item
			end
			if l_w < l_min.item then
				l_w := l_min.item
			end
			if l_w > l_term.item.x - 12 then
				l_w := l_term.item.x - 12
			end
			if l_w < 5 then
				l_w := 5
			end
			l_rw.item := 0
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, ftp_texts.item[0], 0, l_y, l_w, l_rw, 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_checkboxes (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, items + 1, n - 3, 0, l_y, l_w, l_rw, ftp_texts.item + 1)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, (items + n) - 2, 2, 0, l_y, l_w, l_rw, 1)
			update_class_fields -- Current might have been changed; synchronize
			l_w := l_rw.item
			Current.xw := l_rw.item + 12
			update_class_fields -- Current might have been changed; synchronize
			Current.yw := l_y.item + 4
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.center_dlg
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.draw_dlg
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := y + 2
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (l_term, l_term, ftp_texts.item[0], x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_field (l_term, l_term, items, x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_checkboxes (l_term, l_term, items + 1, n - 3, x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), ftp_texts.item + 1)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (l_term, l_term, (items + n) - 2, 2, x + 6, l_y, l_w, l_rw, 1)
			update_class_fields -- Current might have been changed; synchronize
		end

	dlg_ftp_options (a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		require
			not a_di.is_void
		local
			l_a: INTEGER_32
			l_ftp_options___0: CE_POINTER [PD_FTP_OPTIONS]
			l_d: CE_POINTER [PD_DIALOG]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [PD_MEMORY_LIST]
		do
			l_ftp_options___0 := create {CE_CLASS_POINTER [PD_FTP_OPTIONS]}.make_cast (a_di.item.cdata)
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 537, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 7 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_d := create {CE_CLASS_POINTER [PD_DIALOG]}.make_cast (l_tmp)
			memset (create {CE_VOID_POINTER}.make_cast (l_d), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 7 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.title := (create {P_LINKS_STATIC}).dummyarray.item + 278
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.fn := ftpopt_fn_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].type := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].dlen := 1_024
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[0].data := l_ftp_options___0.item.anon_pass
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].type := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_ftp_options___0.c_pointer + (create {PD_FTP_OPTIONS}.make).offset_of ("passive_ftp"))))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[1].gid := 0
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].type := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[2].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_ftp_options___0.c_pointer + (create {PD_FTP_OPTIONS}.make).offset_of ("fast_ftp"))))
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].type := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[3].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_ftp_options___0.c_pointer + (create {PD_FTP_OPTIONS}.make).offset_of ("set_tos"))))
			update_class_fields -- Current might have been changed; synchronize
			l_a := 4
			l_d.item.items[l_a].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[l_a].gid := 1
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[l_a].fn := ok_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[l_a].text := (create {P_LINKS_STATIC}).dummyarray.item + 14
			update_class_fields -- Current might have been changed; synchronize
			l_a := l_a + 1
			l_d.item.items[l_a].type := 4
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[l_a].gid := 2
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[l_a].fn := cancel_dialog_address
			update_class_fields -- Current might have been changed; synchronize
			l_d.item.items[l_a].text := (create {P_LINKS_STATIC}).dummyarray.item + 6
			update_class_fields -- Current might have been changed; synchronize
			l_a := l_a + 1
			l_d.item.items[l_a].type := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_d), create {CE_VOID_POINTER}.make_shared (default_pointer)])
			update_class_fields; -- Current might have been changed; synchronize
			(win.item.term).item.do_dialog (l_d, l_tmp___0)
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	netopt_fn
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: CE_ARRAY [INTEGER_32]
			l_min: CE_ARRAY [INTEGER_32]
			l_w: INTEGER_32
			l_rw: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_max.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_min.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rw.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)

			l_term := win.item.term
			l_max.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_min.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := -1
			update_class_fields -- Current might have been changed; synchronize
			max_text_width (l_term, net_msg.item[0], l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, net_msg.item[0], l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_text_width (l_term, net_msg.item[1], l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, net_msg.item[1], l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_group_width (l_term, net_msg.item + 2, items + 2, 9, l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_group_width (l_term, net_msg.item + 2, items + 2, 9, l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_buttons_width (l_term, items + 11, 2, l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_buttons_width (l_term, items + 11, 2, l_min)
			update_class_fields -- Current might have been changed; synchronize
			l_w := ((win.item.term).item.x * 9) // 10 - 12
			if l_w > l_max.item then
				l_w := l_max.item
			end
			if l_w < l_min.item then
				l_w := l_min.item
			end
			if l_w > (win.item.term).item.x - 12 then
				l_w := (win.item.term).item.x - 12
			end
			if l_w < 1 then
				l_w := 1
			end
			l_rw.item := 0
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, net_msg.item[0], 0, l_y, l_w, l_rw, 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + (2)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, net_msg.item[1], 0, l_y, l_w, l_rw, 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + (2)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_group (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, net_msg.item + 2, items + 2, 9, 0, l_y, l_w, l_rw)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, items + 11, 2, 0, l_y, l_w, l_rw, 1)
			update_class_fields -- Current might have been changed; synchronize
			l_w := l_rw.item
			Current.xw := l_w + 12
			update_class_fields -- Current might have been changed; synchronize
			Current.yw := l_y.item + 4
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.center_dlg
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.draw_dlg
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := y + 2
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (l_term, l_term, net_msg.item[0], x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_field (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (0)), x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (l_term, l_term, net_msg.item[1], x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_field (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (1)), x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_group (l_term, l_term, net_msg.item + 2, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (2)), 9, x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (11)), 2, x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1)
			update_class_fields -- Current might have been changed; synchronize
		end

	netprog_fn
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: CE_ARRAY [INTEGER_32]
			l_min: CE_ARRAY [INTEGER_32]
			l_w: INTEGER_32
			l_rw: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_max.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_min.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rw.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)

			l_term := win.item.term
			l_max.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_min.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := -1
			update_class_fields -- Current might have been changed; synchronize
			max_text_width (l_term, prg_msg.item[0], l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, prg_msg.item[0], l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_text_width (l_term, prg_msg.item[1], l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, prg_msg.item[1], l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_text_width (l_term, prg_msg.item[2], l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, prg_msg.item[2], l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_text_width (l_term, prg_msg.item[3], l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, prg_msg.item[3], l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_buttons_width (l_term, items + 4, 2, l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_buttons_width (l_term, items + 4, 2, l_min)
			update_class_fields -- Current might have been changed; synchronize
			l_w := ((win.item.term).item.x * 9) // 10 - 12
			if l_w > l_max.item then
				l_w := l_max.item
			end
			if l_w < l_min.item then
				l_w := l_min.item
			end
			if l_w > (win.item.term).item.x - 12 then
				l_w := (win.item.term).item.x - 12
			end
			if l_w < 1 then
				l_w := 1
			end
			l_rw.item := 0
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, prg_msg.item[0], 0, l_y, l_w, l_rw, 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + (2)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, prg_msg.item[1], 0, l_y, l_w, l_rw, 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + (2)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, prg_msg.item[2], 0, l_y, l_w, l_rw, 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + (2)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, prg_msg.item[3], 0, l_y, l_w, l_rw, 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + (2)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, items + 4, 2, 0, l_y, l_w, l_rw, 1)
			update_class_fields -- Current might have been changed; synchronize
			l_w := l_rw.item
			Current.xw := l_w + 12
			update_class_fields -- Current might have been changed; synchronize
			Current.yw := l_y.item + 4
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.center_dlg
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.draw_dlg
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := y + 2
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (l_term, l_term, prg_msg.item[0], x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_field (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (0)), x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (l_term, l_term, prg_msg.item[1], x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_field (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (1)), x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (l_term, l_term, prg_msg.item[2], x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_field (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (2)), x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (l_term, l_term, prg_msg.item[3], x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_field (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (3)), x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (4)), 2, x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1)
			update_class_fields -- Current might have been changed; synchronize
		end

	dlg_assume_cp (a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		require
			not a_di.is_void
		do
			charset_sel_list (win.item.term, create {CE_CLASS_POINTER [PD_SESSION]}.make_cast (dlg.item.udata2), create {CE_INTEGER_32_POINTER}.make_cast (a_di.item.cdata))
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	dlg_abort_download (a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		do
			(create {P_SELECT_STATIC}).register_bottom_half (((create {PD_DOWNLOAD_STATIC}).abort_download_address), dlg.item.udata).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	dlg_undisplay_download (a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		do
			(create {P_SELECT_STATIC}).register_bottom_half (((create {PD_SESSION_STATIC}).undisplay_download_address), dlg.item.udata).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	download_abort_function
		local
			l_down___0: CE_POINTER [PD_DOWNLOAD]
		do
			l_down___0 := create {CE_CLASS_POINTER [PD_DOWNLOAD]}.make_cast (dlg.item.udata)
			l_down___0.item.win := create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
		end

	download_window_function
		local
			l_down___0: CE_POINTER [PD_DOWNLOAD]
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: CE_ARRAY [INTEGER_32]
			l_min: CE_ARRAY [INTEGER_32]
			l_w: INTEGER_32
			l_x: INTEGER_32
			l_y: CE_ARRAY [INTEGER_32]
			l_t: INTEGER_32
			l_m: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_u: CE_POINTER [NATURAL_8]
			l_stat___0: CE_POINTER [PD_STATUS]
			l_l: CE_ARRAY [INTEGER_32]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_q: CE_ARRAY [NATURAL_8]
			l_p: INTEGER_32
			l_tmp___10: NATURAL_32
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_max.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_min.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_m.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_q.make (<<64>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_down___0 := create {CE_CLASS_POINTER [PD_DOWNLOAD]}.make_cast (dlg.item.udata)
					l_term := win.item.term
					l_max.item := 0
					update_class_fields -- Current might have been changed; synchronize
					l_min.item := 0
					update_class_fields -- Current might have been changed; synchronize
					l_t := 0
					l_stat___0 := create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (l_down___0.c_pointer + (create {PD_DOWNLOAD}.make).offset_of ("stat"))
					redraw_below_window (win)
					update_class_fields -- Current might have been changed; synchronize
					l_down___0.item.win := win
					update_class_fields -- Current might have been changed; synchronize
					if l_stat___0.item.state = 8 then
						if ((l_stat___0.item.prg).item.elapsed // 100).to_boolean then
							l_l.item := 0
							update_class_fields -- Current might have been changed; synchronize
							l_m.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 360)
							update_class_fields -- Current might have been changed; synchronize
							l_t := 1
							l_tmp := (create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 155, l_term)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, l_tmp)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_SESSION_STATIC}).add_xnum_to_str (l_m, l_l, (l_stat___0.item.prg).item.pos)
							update_class_fields -- Current might have been changed; synchronize
							if (l_stat___0.item.prg).item.size >= 0 then
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___0 := (create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 156, l_term)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, l_tmp___0)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_SESSION_STATIC}).add_xnum_to_str (l_m, l_l, (l_stat___0.item.prg).item.size)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")))
							update_class_fields -- Current might have been changed; synchronize
							if (l_stat___0.item.prg).item.elapsed >= 10_000 then
								l_tmp___1 := (create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 159, l_term)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, l_tmp___1)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___2 := (create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 160, l_term)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, l_tmp___2)
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_SESSION_STATIC}).add_xnum_to_str (l_m, l_l, ((((l_stat___0.item.prg).item.loaded).to_integer_64 * {INTEGER_64} 10) // ((l_stat___0.item.prg).item.elapsed // 100).to_integer_64).to_integer_32)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/s")))
							update_class_fields -- Current might have been changed; synchronize
							if (l_stat___0.item.prg).item.elapsed >= 10_000 then
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___3 := (create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 161, l_term)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, l_tmp___3)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_SESSION_STATIC}).add_xnum_to_str (l_m, l_l, (l_stat___0.item.prg).item.cur_loaded // 5)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/s")))
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___4 := (create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 162, l_term)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, l_tmp___4)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
							update_class_fields -- Current might have been changed; synchronize
							add_time_to_str (l_m, l_l, (l_stat___0.item.prg).item.elapsed // 1_000)
							update_class_fields -- Current might have been changed; synchronize
							if (l_stat___0.item.prg).item.size >= 0 then
								if (l_stat___0.item.prg).item.loaded > 0 then
									(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")))
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___5 := (create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 163, l_term)
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, l_tmp___5)
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_LINKS_STATIC}).add_to_str (l_m, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
									update_class_fields -- Current might have been changed; synchronize
									add_time_to_str (l_m, l_l, (((l_stat___0.item.prg).item.size - (l_stat___0.item.prg).item.pos).to_integer_64 // ((((l_stat___0.item.prg).item.loaded).to_integer_64 * {INTEGER_64} 10) // ((l_stat___0.item.prg).item.elapsed // 100).to_integer_64)).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						else
							l_tmp___6 := (create {P_SESSION_STATIC}).get_err_msg (l_stat___0.item.state)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___7 := (create {P_LANGUAGE_STATIC}).get_text_translation (l_tmp___6, l_term)
							update_class_fields -- Current might have been changed; synchronize
							l_m.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 389, l_tmp___7)
							update_class_fields -- Current might have been changed; synchronize
						end
					else
						l_tmp___6 := (create {P_SESSION_STATIC}).get_err_msg (l_stat___0.item.state)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___7 := (create {P_LANGUAGE_STATIC}).get_text_translation (l_tmp___6, l_term)
						update_class_fields -- Current might have been changed; synchronize
						l_m.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 389, l_tmp___7)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_u := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 390, l_down___0.item.url)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___9 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_u), 1)
					update_class_fields -- Current might have been changed; synchronize
					if (not l_tmp___9.is_void) then
						l_tmp___8 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_u), 1)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___8[0] := (0).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
					end
					max_text_width (l_term, l_u, l_max)
					update_class_fields -- Current might have been changed; synchronize
					min_text_width (l_term, l_u, l_min)
					update_class_fields -- Current might have been changed; synchronize
					max_text_width (l_term, l_m.item, l_max)
					update_class_fields -- Current might have been changed; synchronize
					min_text_width (l_term, l_m.item, l_min)
					update_class_fields -- Current might have been changed; synchronize
					max_buttons_width (l_term, items, n, l_max)
					update_class_fields -- Current might have been changed; synchronize
					min_buttons_width (l_term, items, n, l_min)
					update_class_fields -- Current might have been changed; synchronize
					l_w := ((win.item.term).item.x * 9) // 10 - 12
					if l_w < l_min.item then
						l_w := l_min.item
					end
					if l_w > (win.item.term).item.x - 12 then
						l_w := (win.item.term).item.x - 12
					end
					if not (l_t.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (l_stat___0.item.prg).item.size >= 0 then
							if l_w < 20 then
								l_w := 20
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if l_w > l_max.item then
							l_w := l_max.item
						end
				when 4 then
					if l_w < 1 then
						l_w := 1
					end
					l_y.item := 0
					update_class_fields -- Current might have been changed; synchronize
					dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, l_u, 0, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
					update_class_fields -- Current might have been changed; synchronize
					l_y.item := l_y.item + 1
					update_class_fields -- Current might have been changed; synchronize
					if l_t.to_boolean then
						if (l_stat___0.item.prg).item.size >= 0 then
							l_y.item := l_y.item + (2)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, l_m.item, 0, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
					update_class_fields -- Current might have been changed; synchronize
					l_y.item := l_y.item + 1
					update_class_fields -- Current might have been changed; synchronize
					dlg_format_buttons (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, items, n, 0, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1)
					update_class_fields -- Current might have been changed; synchronize
					Current.xw := l_w + 12
					update_class_fields -- Current might have been changed; synchronize
					Current.yw := l_y.item + 4
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.center_dlg
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.draw_dlg
					update_class_fields -- Current might have been changed; synchronize
					l_y.item := (y + 2) + 1
					update_class_fields -- Current might have been changed; synchronize
					l_x := x + 6
					dlg_format_text (l_term, l_term, l_u, l_x, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_t.to_boolean then
						if (l_stat___0.item.prg).item.size >= 0 then
							l_p := l_w - 6
							l_y.item := l_y.item + 1
							update_class_fields -- Current might have been changed; synchronize
							l_term.item.set_only_char (l_x, l_y.item, (('[').code).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_term.item.set_only_char ((l_x + l_w) - 5, l_y.item, ((']').code).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_term.item.fill_area (l_x + 1, l_y.item, ((l_p.to_integer_64 * ((l_stat___0.item.prg).item.pos).to_integer_64) // ((l_stat___0.item.prg).item.size).to_integer_64).to_integer_32, 1, {NATURAL_32} 1_792)
							update_class_fields -- Current might have been changed; synchronize
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_q), ce_string ("%%3d%%%%"), (({INTEGER_64} 100 * ((l_stat___0.item.prg).item.pos).to_integer_64) // ((l_stat___0.item.prg).item.size).to_integer_64).to_integer_32]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___10 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_q))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_TERMINAL_STATIC}).print_text (l_term, (l_x + l_w) - 4, l_y.item, l_tmp___10.to_integer_32, l_q, {NATURAL_32} 14_336)
							update_class_fields -- Current might have been changed; synchronize
							l_y.item := l_y.item + 1
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_y.item := l_y.item + 1
					update_class_fields -- Current might have been changed; synchronize
					dlg_format_text (l_term, l_term, l_m.item, l_x, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
					update_class_fields -- Current might have been changed; synchronize
					l_y.item := l_y.item + 1
					update_class_fields -- Current might have been changed; synchronize
					dlg_format_buttons (l_term, l_term, items, n, l_x, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 436, create {CE_VOID_POINTER}.make_cast (l_u))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 437, create {CE_VOID_POINTER}.make_cast (l_m.item))
					update_class_fields -- Current might have been changed; synchronize
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	add_ct_fn
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: CE_ARRAY [INTEGER_32]
			l_min: CE_ARRAY [INTEGER_32]
			l_w: INTEGER_32
			l_rw: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_p: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
		do
			create {CE_INTEGER_32_ARRAY} l_max.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_min.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rw.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)

			l_term := win.item.term
			l_max.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_min.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := -1
			update_class_fields -- Current might have been changed; synchronize
			l_p := 1
			l_p := l_p + 1
			l_p := l_p + (2)
			max_text_width (l_term, ct_msg.item[0], l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, ct_msg.item[0], l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_text_width (l_term, ct_msg.item[1], l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, ct_msg.item[1], l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_text_width (l_term, ct_msg.item[2], l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, ct_msg.item[2], l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_group_width (l_term, ct_msg.item + 3, items + 3, l_p, l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_group_width (l_term, ct_msg.item + 3, items + 3, l_p, l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_buttons_width (l_term, (items + 3) + l_p, 2, l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_buttons_width (l_term, (items + 3) + l_p, 2, l_min)
			update_class_fields -- Current might have been changed; synchronize
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max.item then
				l_w := l_max.item
			end
			if l_w < l_min.item then
				l_w := l_min.item
			end
			if l_w > l_term.item.x - 12 then
				l_w := l_term.item.x - 12
			end
			if l_w < 1 then
				l_w := 1
			end
			l_rw.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_LANGUAGE_STATIC}).get_text_translation (ct_msg.item[0], l_term)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, l_tmp, 0, l_y, l_w, l_rw, 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + (2)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_LANGUAGE_STATIC}).get_text_translation (ct_msg.item[1], l_term)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, l_tmp___0, 0, l_y, l_w, l_rw, 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + (2)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___1 := (create {P_LANGUAGE_STATIC}).get_text_translation (ct_msg.item[2], l_term)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, l_tmp___1, 0, l_y, l_w, l_rw, 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + (2)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_group (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, ct_msg.item + 3, items + 3, l_p, 0, l_y, l_w, l_rw)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, (items + 3) + l_p, 2, 0, l_y, l_w, l_rw, 1)
			update_class_fields -- Current might have been changed; synchronize
			l_w := l_rw.item
			Current.xw := l_w + 12
			update_class_fields -- Current might have been changed; synchronize
			Current.yw := l_y.item + 4
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.center_dlg
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.draw_dlg
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := y + 2
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (l_term, l_term, ct_msg.item[0], x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_field (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (0)), x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (l_term, l_term, ct_msg.item[1], x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_field (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (1)), x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (l_term, l_term, ct_msg.item[2], x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_field (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (2)), x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_group (l_term, l_term, ct_msg.item + 3, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (3)), l_p, x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (3 + l_p)), 2, x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1)
			update_class_fields -- Current might have been changed; synchronize
		end

	add_ext_fn
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: CE_ARRAY [INTEGER_32]
			l_min: CE_ARRAY [INTEGER_32]
			l_w: INTEGER_32
			l_rw: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_max.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_min.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rw.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)

			l_term := win.item.term
			l_max.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_min.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := -1
			update_class_fields -- Current might have been changed; synchronize
			max_text_width (l_term, ext_msg.item[0], l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, ext_msg.item[0], l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_text_width (l_term, ext_msg.item[1], l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_text_width (l_term, ext_msg.item[1], l_min)
			update_class_fields -- Current might have been changed; synchronize
			max_buttons_width (l_term, items + 2, 2, l_max)
			update_class_fields -- Current might have been changed; synchronize
			min_buttons_width (l_term, items + 2, 2, l_min)
			update_class_fields -- Current might have been changed; synchronize
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max.item then
				l_w := l_max.item
			end
			if l_w < l_min.item then
				l_w := l_min.item
			end
			if l_w > l_term.item.x - 12 then
				l_w := l_term.item.x - 12
			end
			if l_w < 1 then
				l_w := 1
			end
			l_rw.item := 0
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, ext_msg.item[0], 0, l_y, l_w, l_rw, 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + (2)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, ext_msg.item[1], 0, l_y, l_w, l_rw, 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + (2)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, items + 2, 2, 0, l_y, l_w, l_rw, 1)
			update_class_fields -- Current might have been changed; synchronize
			l_w := l_rw.item
			Current.xw := l_w + 12
			update_class_fields -- Current might have been changed; synchronize
			Current.yw := l_y.item + 4
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.center_dlg
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (c_pointer))).item.draw_dlg
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := y + 2
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (l_term, l_term, ext_msg.item[0], x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_field (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (0)), x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_text (l_term, l_term, ext_msg.item[1], x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 14_336, 0)
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_field (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (1)), x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			l_y.item := l_y.item + 1
			update_class_fields -- Current might have been changed; synchronize
			dlg_format_buttons (l_term, l_term, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (2)), 2, x + 6, l_y, l_w, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1)
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_DIALOG_DATA_STATIC} -- private routines

	min_buttons_width (a_term: CE_POINTER [PD_TERMINAL]; a_butt: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_n: INTEGER_32; a_width: CE_POINTER [INTEGER_32])
		local
			l_butt: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_i: INTEGER_32
			l_w: INTEGER_32
			l_tmp: CE_POINTER [PD_DIALOG_ITEM_DATA]
		do
			l_butt := a_butt
			l_i := 0
			from
			until
				not (l_i < a_n)
			loop
				l_tmp := l_butt
				l_butt := l_butt + 1
				l_w := ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LANGUAGE_STATIC}).get_text_translation ((l_tmp.item.item).item.text, a_term))))) + {NATURAL_32} 4).to_integer_32
				if l_w > a_width.item then
					a_width.item := l_w
				end
				l_i := l_i + 1
			end
		end

	dlg_format_buttons (a_term, a_t2: CE_POINTER [PD_TERMINAL]; a_butt: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_n, a_x: INTEGER_32; a_y: CE_POINTER [INTEGER_32]; a_w: INTEGER_32; a_rw: CE_POINTER [INTEGER_32]; a_align: INTEGER_32)
		local
			l_i1: INTEGER_32
			l_i2: INTEGER_32
			l_mw: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_i: INTEGER_32
			l_p: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_mw.make (<<1>>)

			l_i1 := 0
			from
			until
				not (not (l_return) and then (l_i1 < a_n))
			loop
				l_i2 := l_i1 + 1
				from
				until
					not (not (l_break) and then (l_i2 < a_n))
				loop
					l_break := False
					l_mw.item := 0
					max_buttons_width (a_t2, a_butt + l_i1, (l_i2 - l_i1) + 1, l_mw)
					if l_mw.item <= a_w then
						l_i2 := l_i2 + 1
					else
						l_break := True
					end
				end
				l_break := False
				l_mw.item := 0
				max_buttons_width (a_t2, a_butt + l_i1, l_i2 - l_i1, l_mw)
				if (not a_rw.is_void) then
					if l_mw.item > a_rw.item then
						l_tmp := l_mw.item
						a_rw.item := l_tmp
						if l_tmp > a_w then
							a_rw.item := a_w
						end
					end
				end
				if (not a_term.is_void) then
					if ((a_align).bit_and (127)) = 1 then
						l_tmp___0 := (a_w - l_mw.item) // 2
					else
						l_tmp___0 := 0
					end
					l_p := a_x + l_tmp___0
					l_i := l_i1
					from
					until
						not (l_i < l_i2)
					loop
						(a_butt + l_i).item.x := l_p;
						(a_butt + l_i).item.y := a_y.item
						l_tmp___1 := ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LANGUAGE_STATIC}).get_text_translation (((a_butt + l_i).item.item).item.text, a_t2))))) + {NATURAL_32} 4).to_integer_32;
						(a_butt + l_i).item.l := l_tmp___1
						l_p := l_p + (l_tmp___1 + 2)
						l_i := l_i + 1
					end
				end
				a_y.item := a_y.item + (2)
				l_i1 := l_i2
			end
		end

	max_buttons_width (a_term: CE_POINTER [PD_TERMINAL]; a_butt: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_n: INTEGER_32; a_width: CE_POINTER [INTEGER_32])
		require
			not a_width.is_void
		local
			l_butt: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_w: INTEGER_32
			l_i: INTEGER_32
			l_tmp: CE_POINTER [PD_DIALOG_ITEM_DATA]
		do
			l_butt := a_butt
			l_w := -2
			l_i := 0
			from
			until
				not (l_i < a_n)
			loop
				l_tmp := l_butt
				l_butt := l_butt + 1
				l_w := (l_w.to_natural_32 + ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LANGUAGE_STATIC}).get_text_translation ((l_tmp.item.item).item.text, a_term))))) + {NATURAL_32} 6)).to_integer_32
				l_i := l_i + 1
			end
			if l_w > a_width.item then
				a_width.item := l_w
			end
		end

	max_text_width (a_term: CE_POINTER [PD_TERMINAL]; a_text: CE_POINTER [NATURAL_8]; a_width: CE_POINTER [INTEGER_32])
		require
			not a_width.is_void
		local
			l_text: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			l_text := a_text
			l_text := (create {P_LANGUAGE_STATIC}).get_text_translation (l_text, a_term)
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_c := 0
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_text.item).to_boolean then
						if (l_text.item).to_integer_32 = 10 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_text := l_text + 1
						l_c := l_c + 1
					end
				end
				l_break := False
				if l_c > a_width.item then
					a_width.item := l_c
				end
				l_tmp := l_text
				l_text := l_text + 1
				if not (l_tmp.item).to_boolean then
					l_break := True
				end
			end
			l_break := False
		end

	min_text_width (a_term: CE_POINTER [PD_TERMINAL]; a_text: CE_POINTER [NATURAL_8]; a_width: CE_POINTER [INTEGER_32])
		require
			not a_width.is_void
		local
			l_text: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			l_text := a_text
			l_text := (create {P_LANGUAGE_STATIC}).get_text_translation (l_text, a_term)
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_c := 0
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_text.item).to_boolean then
						if (l_text.item).to_integer_32 /= 10 then
							if (l_text.item).to_integer_32 = 32 then
								l_break := True
							end
						else
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_text := l_text + 1
						l_c := l_c + 1
					end
				end
				l_break := False
				if l_c > a_width.item then
					a_width.item := l_c
				end
				l_tmp := l_text
				l_text := l_text + 1
				if not (l_tmp.item).to_boolean then
					l_break := True
				end
			end
			l_break := False
		end

	dlg_format_field (a_term, a_t2: CE_POINTER [PD_TERMINAL]; a_item: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_x: INTEGER_32; a_y: CE_POINTER [INTEGER_32]; a_w: INTEGER_32; a_rw: CE_POINTER [INTEGER_32]; a_align: INTEGER_32)
		require
			not a_item.is_void
			not a_y.is_void
		local
			l_tmp: INTEGER_32
		do
			a_item.item.x := a_x
			a_item.item.y := a_y.item
			a_item.item.l := a_w
			if (not a_rw.is_void) then
				if a_item.item.l > a_rw.item then
					l_tmp := a_item.item.l
					a_rw.item := l_tmp
					if l_tmp > a_w then
						a_rw.item := a_w
					end
				end
			end
			a_y.item := (a_y.item) + 1
		end

	max_group_width (a_term: CE_POINTER [PD_TERMINAL]; a_texts: CE_POINTER [CE_POINTER [NATURAL_8]]; a_item: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_n: INTEGER_32; a_w: CE_POINTER [INTEGER_32])
		require
			not a_w.is_void
		local
			l_texts: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_item: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_n: INTEGER_32
			l_ww: INTEGER_32
			l_wx: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___5: INTEGER_32
			l_break: BOOLEAN
		do
			l_texts := a_texts
			l_item := a_item
			l_n := a_n
			l_ww := 0
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp___5 := l_n
				l_n := l_n - 1
				if not l_tmp___5.to_boolean then
					l_break := True
				end
				if not (l_break) then
					if (l_item.item.item).item.type = 1 then
						l_tmp___2 := (4).to_natural_32
					else
						if (l_item.item.item).item.type = 4 then
							l_tmp___1 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LANGUAGE_STATIC}).get_text_translation ((l_item.item.item).item.text, a_term))))) + {NATURAL_32} 5
						else
							l_tmp___1 := ((l_item.item.item).item.dlen).to_natural_32 + {NATURAL_32} 1
						end
						l_tmp___2 := l_tmp___1
					end
					l_wx := l_tmp___2.to_integer_32
					l_wx := (l_wx.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LANGUAGE_STATIC}).get_text_translation (l_texts[0], a_term)))))).to_integer_32
					if l_n.to_boolean then
						l_wx := l_wx + 1
					end
					l_ww := l_ww + l_wx
					l_texts := l_texts + 1
					l_item := l_item + 1
				end
			end
			l_break := False
			if l_ww > a_w.item then
				a_w.item := l_ww
			end
		end

	min_group_width (a_term: CE_POINTER [PD_TERMINAL]; a_texts: CE_POINTER [CE_POINTER [NATURAL_8]]; a_item: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_n: INTEGER_32; a_w: CE_POINTER [INTEGER_32])
		local
			l_texts: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_item: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_n: INTEGER_32
			l_wx: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___5: INTEGER_32
			l_break: BOOLEAN
		do
			l_texts := a_texts
			l_item := a_item
			l_n := a_n
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp___5 := l_n
				l_n := l_n - 1
				if not l_tmp___5.to_boolean then
					l_break := True
				end
				if not (l_break) then
					if (l_item.item.item).item.type = 1 then
						l_tmp___2 := (4).to_natural_32
					else
						if (l_item.item.item).item.type = 4 then
							l_tmp___1 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LANGUAGE_STATIC}).get_text_translation ((l_item.item.item).item.text, a_term))))) + {NATURAL_32} 5
						else
							l_tmp___1 := ((l_item.item.item).item.dlen).to_natural_32 + {NATURAL_32} 1
						end
						l_tmp___2 := l_tmp___1
					end
					l_wx := l_tmp___2.to_integer_32
					l_wx := (l_wx.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LANGUAGE_STATIC}).get_text_translation (l_texts[0], a_term)))))).to_integer_32
					if l_wx > a_w.item then
						a_w.item := l_wx
					end
					l_texts := l_texts + 1
					l_item := l_item + 1
				end
			end
			l_break := False
		end

	dlg_format_group (a_term, a_t2: CE_POINTER [PD_TERMINAL]; a_texts: CE_POINTER [CE_POINTER [NATURAL_8]]; a_item: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_n, a_x: INTEGER_32; a_y: CE_POINTER [INTEGER_32]; a_w: INTEGER_32; a_rw: CE_POINTER [INTEGER_32])
		require
			not a_y.is_void
		local
			l_texts: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_item: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_n: INTEGER_32
			l_nx: INTEGER_32
			l_sl: INTEGER_32
			l_wx: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_break: BOOLEAN
		do
			l_texts := a_texts
			l_item := a_item
			l_n := a_n
			l_nx := 0
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp___10 := l_n
				l_n := l_n - 1
				if not l_tmp___10.to_boolean then
					l_break := True
				end
				if not (l_break) then
					if (l_item.item.item).item.type = 1 then
						l_tmp___2 := (4).to_natural_32
					else
						if (l_item.item.item).item.type = 4 then
							l_tmp___1 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LANGUAGE_STATIC}).get_text_translation ((l_item.item.item).item.text, a_t2))))) + {NATURAL_32} 5
						else
							l_tmp___1 := ((l_item.item.item).item.dlen).to_natural_32 + {NATURAL_32} 1
						end
						l_tmp___2 := l_tmp___1
					end
					l_wx := l_tmp___2.to_integer_32
					if (((create {P_LANGUAGE_STATIC}).get_text_translation (l_texts[0], a_t2))[0]).to_boolean then
						l_sl := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LANGUAGE_STATIC}).get_text_translation (l_texts[0], a_t2))))).to_integer_32
					else
						l_sl := -1
					end
					l_wx := l_wx + l_sl
					if l_nx.to_boolean then
						if l_nx + l_wx > a_w then
							l_nx := 0
							a_y.item := a_y.item + (2)
						end
					end
					if (not a_term.is_void) then
						l_tmp___6 := (create {P_LANGUAGE_STATIC}).get_text_translation (l_texts[0], a_t2);
						(create {P_TERMINAL_STATIC}).print_text (a_term, (a_x + l_nx) + 4 * ((l_item.item.item).item.type = 1).to_integer, a_y.item, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LANGUAGE_STATIC}).get_text_translation (l_texts[0], a_t2))))).to_integer_32, l_tmp___6, {NATURAL_32} 14_336)
						l_item.item.x := (a_x + l_nx) + (l_sl + 1) * ((l_item.item.item).item.type /= 1).to_integer
						l_item.item.y := a_y.item
						if (l_item.item.item).item.type = 2 then
							l_item.item.l := (l_item.item.item).item.dlen
						elseif (l_item.item.item).item.type = 3 then
							l_item.item.l := (l_item.item.item).item.dlen
						end
					end
					if (not a_rw.is_void) then
						if l_nx + l_wx > a_rw.item then
							l_tmp___9 := l_nx + l_wx
							a_rw.item := l_tmp___9
							if l_tmp___9 > a_w then
								a_rw.item := a_w
							end
						end
					end
					l_nx := l_nx + (l_wx + 1)
					l_texts := l_texts + 1
					l_item := l_item + 1
				end
			end
			l_break := False
			a_y.item := (a_y.item) + 1
		end

	bookmark_dlg_box_id_get (a_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]): INTEGER_32
		require
			not a_box.is_void
		local
			l_citem: CE_POINTER [PD_BOX_ITEM]
			l_sel: INTEGER_32
			l_return: BOOLEAN
		do
			l_sel := a_box.item.sel
			if l_sel = -1 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_citem := create {CE_CLASS_POINTER [PD_BOX_ITEM]}.make_cast (a_box.item.items.next)
				from
				until
					not (not (l_return) and then (not l_citem.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_box.c_pointer + (create {PD_DLG_DATA_ITEM_DATA_BOX}.make).offset_of ("items")))))
				loop
					if l_sel = 0 then
						Result := ((l_citem.item.data).c_pointer.to_integer_32).to_integer_32
						l_return := True
					end
					if not l_return then
						l_sel := l_sel - 1
						l_citem := l_citem.item.next
					end
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

	dlg_format_checkboxes (a_term, a_t2: CE_POINTER [PD_TERMINAL]; a_chkb: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_n, a_x: INTEGER_32; a_y: CE_POINTER [INTEGER_32]; a_w: INTEGER_32; a_rw: CE_POINTER [INTEGER_32]; a_texts: CE_POINTER [CE_POINTER [NATURAL_8]])
		local
			l_chkb: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_n: INTEGER_32
			l_texts: CE_POINTER [CE_POINTER [NATURAL_8]]
		do
			l_chkb := a_chkb
			l_n := a_n
			l_texts := a_texts
			from
			until
				not (l_n.to_boolean)
			loop
				dlg_format_checkbox (a_term, a_t2, l_chkb, a_x, a_y, a_w, a_rw, ((create {P_LANGUAGE_STATIC}).get_text_translation (l_texts[0], a_t2)))
				l_texts := l_texts + 1
				l_chkb := l_chkb + 1
				l_n := l_n - 1
			end
		end

	checkboxes_width (a_term: CE_POINTER [PD_TERMINAL]; a_texts: CE_POINTER [CE_POINTER [NATURAL_8]]; a_w: CE_POINTER [INTEGER_32]; a_fn: CE_ROUTINE)
		require
			not a_texts.is_void
		local
			l_texts: CE_POINTER [CE_POINTER [NATURAL_8]]
		do
			l_texts := a_texts
			from
			until
				(l_texts[0]).is_void
			loop
				a_w.item := a_w.item - (4)
				a_fn.call ([a_term, ((create {P_LANGUAGE_STATIC}).get_text_translation (l_texts[0], a_term)), a_w])
				a_w.item := a_w.item + (4)
				l_texts := l_texts + 1
			end
		end

	dlg_format_checkbox (a_term, a_t2: CE_POINTER [PD_TERMINAL]; a_chkb: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_x: INTEGER_32; a_y: CE_POINTER [INTEGER_32]; a_w: INTEGER_32; a_rw: CE_POINTER [INTEGER_32]; a_text: CE_POINTER [NATURAL_8])
		require
			not a_y.is_void
		do
			if (not a_term.is_void) then
				a_chkb.item.x := a_x
				a_chkb.item.y := a_y.item
			end
			if (not a_rw.is_void) then
				a_rw.item := a_rw.item - (4)
			end
			dlg_format_text (a_term, a_t2, a_text, a_x + 4, a_y, a_w - 4, a_rw, 14_336, 0)
			if (not a_rw.is_void) then
				a_rw.item := a_rw.item + (4)
			end
		end

	dlg_format_text (a_term, a_t2: CE_POINTER [PD_TERMINAL]; a_text: CE_POINTER [NATURAL_8]; a_x: INTEGER_32; a_y: CE_POINTER [INTEGER_32]; a_w: INTEGER_32; a_rw: CE_POINTER [INTEGER_32]; a_co, a_align: INTEGER_32)
		require
			not a_y.is_void
		local
			l_text: CE_POINTER [NATURAL_8]
			l_rw: CE_POINTER [INTEGER_32]
			l_tx: CE_POINTER [NATURAL_8]
			l_tt: CE_POINTER [NATURAL_8]
			l_s: INTEGER_32
			l_xx: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_text := a_text
			l_rw := a_rw
			l_text := (create {P_LANGUAGE_STATIC}).get_text_translation (l_text, a_t2)
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_tt := l_text
				l_xx := a_x
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_text.item).to_boolean then
							if (l_text.item).to_integer_32 /= 10 then
								if (l_text.item).to_integer_32 = 32 then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_text := l_text + 1
							l_xx := l_xx + 1
						end
					end
					l_break := False
					l_text := l_text + 1
					l_tx := l_text
					l_xx := l_xx + 1
					if (l_text[-1]).to_integer_32 /= 32 then
						l_break := True
					end
					if not (l_return or l_break) then
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_tx.item).to_boolean then
								if (l_tx.item).to_integer_32 /= 10 then
									if (l_tx.item).to_integer_32 = 32 then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_tx := l_tx + 1
							end
						end
						l_break := False
						if not (((l_tx.distance (l_text)) + l_xx) - a_x <= a_w) then
							l_break := True
						end
					end
				end
				l_break := False
				if ((a_align).bit_and (127)) = 1 then
					l_s := (a_w - ((l_xx - 1) - a_x)) // 2
				else
					l_s := 0
				end
				if l_s < 0 then
					l_s := 0
				end
				from
				until
					not ((l_tt.c_pointer.to_integer_32).to_natural_32 < ((l_text - 1).c_pointer.to_integer_32).to_natural_32)
				loop
					if l_s >= a_w then
						l_s := 0
						a_y.item := (a_y.item) + 1
						if (not l_rw.is_void) then
							l_rw.item := a_w
						end
						l_rw := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
					end
					if (not a_term.is_void) then
						a_term.item.set_char (a_x + l_s, a_y.item, ((a_co).bit_or ((l_tt.item).to_integer_32)).to_natural_32)
					end
					l_s := l_s + 1
					l_tt := l_tt + 1
				end
				if (not l_rw.is_void) then
					if (l_xx - 1) - a_x > l_rw.item then
						l_rw.item := (l_xx - 1) - a_x
					end
				end
				a_y.item := (a_y.item) + 1
				if not (l_text[-1]).to_boolean then
					l_break := True
				end
			end
			l_break := False
		end

	dlg_format_box (a_term, a_t2: CE_POINTER [PD_TERMINAL]; a_item: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_x: INTEGER_32; a_y: CE_POINTER [INTEGER_32]; a_w: INTEGER_32; a_rw: CE_POINTER [INTEGER_32]; a_align: INTEGER_32)
		require
			not a_item.is_void
			not a_y.is_void
		local
			l_tmp: INTEGER_32
		do
			a_item.item.x := a_x
			a_item.item.y := a_y.item
			a_item.item.l := a_w
			if (not a_rw.is_void) then
				if a_item.item.l > a_rw.item then
					l_tmp := a_item.item.l
					a_rw.item := l_tmp
					if l_tmp > a_w then
						a_rw.item := a_w
					end
				end
			end
			a_y.item := a_y.item + ((a_item.item.item).item.gid)
		end

	bookmark_get_url (a_id: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			l_return: BOOLEAN
		do
			l_bm := ((create {P_BOOKMARK_STATIC}).get_bookmark_by_id (a_id))
			if l_bm.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := (l_bm.item.url)
			end
		end

	bookmark_get_name (a_id: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			l_return: BOOLEAN
		do
			l_bm := ((create {P_BOOKMARK_STATIC}).get_bookmark_by_id (a_id))
			if l_bm.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := (l_bm.item.title)
			end
		end

	bookmark_goto (a_id: INTEGER_32; a_ses: CE_POINTER [PD_SESSION])
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
		do
			l_bm := (create {P_BOOKMARK_STATIC}).get_bookmark_by_id (a_id)
			if (not l_bm.is_void) then
				(create {P_SESSION_STATIC}).goto_url (a_ses, l_bm.item.url)
			end
		end

	end_refresh (a_r: CE_POINTER [PD_REFRESH])
		require
			not a_r.is_void
		do
			if a_r.item.timer /= -1 then
				(create {P_SELECT_STATIC}).kill_timer (a_r.item.timer)
			end
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu.c")), 107, create {CE_VOID_POINTER}.make_cast (a_r))
		end

	charset_sel_list (a_term: CE_POINTER [PD_TERMINAL]; a_ses: CE_POINTER [PD_SESSION]; a_ptr: CE_POINTER [INTEGER_32])
		local
			l_i: INTEGER_32
			l_sel: INTEGER_32
			l_n: CE_POINTER [NATURAL_8]
			l_mi: CE_ARRAY [CE_POINTER [PD_MENU_ITEM]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_MENU_ITEM]} l_mi.make (<<1>>)

			l_mi.item := (create {P_BFU_STATIC}).new_menu (1)
			if (l_mi.item).is_void then
				l_return := True
			end
			if not l_return then
				l_i := 0
				from
				until
					(l_break)
				loop
					l_break := False
					l_n := (create {P_CHARSETS_STATIC}).get_cp_name (l_i)
					if l_n.is_void then
						l_break := True
					end
					if not (l_break) then
						(create {P_BFU_STATIC}).add_to_menu (l_mi, ((create {P_CHARSETS_STATIC}).get_cp_name (l_i)), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), ((create {P_MENU_STATIC}).set_val_address), create {CE_VOID_POINTER}.make_shared (default_pointer + l_i), 0)
						l_i := l_i + 1
					end
				end
				l_break := False
				l_sel := a_ptr.item
				if l_sel < 0 then
					l_sel := 0
				end
				a_term.item.do_menu_selected (l_mi.item, create {CE_VOID_POINTER}.make_cast (a_ptr), l_sel)
			end
		end

	add_time_to_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_t: INTEGER_32)
		require
			not a_s.is_void
			not a_l.is_void
		local
			l_t: INTEGER_32
			l_q: CE_ARRAY [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_q.make (<<64>>)

			l_t := a_t
			if l_t < 0 then
				l_t := (0).to_integer_32
			end
			l_t := ((l_t.to_natural_32).bit_and ({NATURAL_32} 4_294_967_295)).to_integer_32
			if l_t >= 86_400 then
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_q), ce_string ("%%dd "), (l_t // 86_400).to_integer_32]).do_nothing;
				(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, l_q)
			end
			if l_t >= 3_600 then
				l_t := l_t \\ (86_400)
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_q), ce_string ("%%d:%%02d"), (l_t // 3_600).to_integer_32, ((l_t // 60) \\ 60).to_integer_32]).do_nothing;
				(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, l_q)
			else
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_q), ce_string ("%%d"), (l_t // 60).to_integer_32]).do_nothing;
				(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, l_q)
			end
			sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_q), ce_string (":%%02d"), (l_t \\ 60).to_integer_32]).do_nothing;
			(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, l_q)
		end

	redraw_below_window (a_win: CE_POINTER [PD_WINDOW])
		require
			not a_win.is_void
		local
			l_win: CE_POINTER [PD_WINDOW]
			l_tr: INTEGER_32
			l_term: CE_POINTER [PD_TERMINAL]
			l_end: CE_POINTER [PD_WINDOW]
			l_ev: CE_ARRAY [PD_EVENT]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_EVENT]} l_ev.make (<<1>>)

			l_win := a_win
			l_term := l_win.item.term
			l_end := l_win
			l_ev.item.ev := 3
			l_ev.item.x := 0
			l_ev.item.y := 0
			l_ev.item.b := 0
			l_ev.item.x := (l_term.item.x).to_integer_32
			l_ev.item.y := (l_term.item.y).to_integer_32
			if l_term.item.redrawing >= 2 then
				l_return := True
			end
			if not l_return then
				l_tr := l_term.item.redrawing;
				(l_win.item.term).item.redrawing := 2
				l_win := create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast (l_term.item.windows.prev)
				from
				until
					l_win.is_equal (l_end)
				loop
					(l_win.item.handler).call ([l_win, l_ev, 0])
					l_win := l_win.item.prev
				end
				l_term.item.redrawing := l_tr
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			win := a_other.win
			dlg := a_other.dlg
			x := a_other.x
			y := a_other.y
			xw := a_other.xw
			yw := a_other.yw
			n := a_other.n
			selected := a_other.selected
			ml := a_other.ml
			items := a_other.items.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				win.is_equal (a_other.win) and
				dlg.is_equal (a_other.dlg) and
				x = a_other.x and
				y = a_other.y and
				xw = a_other.xw and
				yw = a_other.yw and
				n = a_other.n and
				selected = a_other.selected and
				ml.is_equal (a_other.ml) and
				items.is_equal (a_other.items)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("win"),
					create {CE_STRUCTURE_FIELD}.make ("dlg"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("xw"),
					create {CE_STRUCTURE_FIELD}.make ("yw"),
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("selected"),
					create {CE_STRUCTURE_FIELD}.make ("ml"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("items", <<1>>)
				>>)
			init_structure_info
		end

end
