class
	PD_DNSQUERY

inherit
	PD_DNSQUERY_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_UNISTD_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create fn.make
			create {CE_VOID_POINTER} data.make
			create xfn.make
			create {CE_POINTER_POINTER [PD_DNSQUERY]} s.make
			create {CE_NATURAL_32_POINTER} addr.make
			create {CE_INTEGER_8_ARRAY} name.make (<<1>>)
			Precursor
		end

feature {ANY} -- fields

	fn: CE_ROUTINE assign set_fn

	data: CE_POINTER [ANY] assign set_data

	xfn: CE_ROUTINE assign set_xfn

	h: INTEGER_32 assign set_h

	s: CE_POINTER [CE_POINTER [PD_DNSQUERY]] assign set_s

	addr: CE_POINTER [NATURAL_32] assign set_addr

	name: CE_ARRAY [INTEGER_8]

feature {ANY} -- field setters

	set_fn (a_fn: CE_ROUTINE)
		do
			fn := a_fn
			update_memory_field ("fn")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_xfn (a_xfn: CE_ROUTINE)
		do
			xfn := a_xfn
			update_memory_field ("xfn")
		end

	set_h (a_h: INTEGER_32)
		do
			h := a_h
			update_memory_field ("h")
		end

	set_s (a_s: CE_POINTER [CE_POINTER [PD_DNSQUERY]])
		do
			s := a_s
			update_memory_field ("s")
		end

	set_addr (a_addr: CE_POINTER [NATURAL_32])
		do
			addr := a_addr
			update_memory_field ("addr")
		end

feature {ANY} -- public routines

	end_real_lookup
		local
			l_r: INTEGER_32
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_r := 1
					if addr.is_void then
						l_pos := -1 + 2 -- goto end
					else
						l_tmp := read (h, create {CE_VOID_POINTER}.make_cast (addr), {PLATFORM}.Natural_32_bytes.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp.to_natural_32 /= {PLATFORM}.Natural_32_bytes.to_natural_32 then
							l_pos := -1 + 2 -- goto end
						end
					end
				when 1 then
					l_r := 0
				when 2 then -- end:;
					(create {P_SELECT_STATIC}).set_handlers (h, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
					update_class_fields -- Current might have been changed; synchronize
					close (h).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					xfn.call ([(create {CE_CLASS_POINTER [PD_DNSQUERY]}.make_shared (c_pointer)), l_r])
					update_class_fields -- Current might have been changed; synchronize
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	failed_real_lookup
		do
			(create {P_SELECT_STATIC}).set_handlers (h, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
			close (h).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			xfn.call ([(create {CE_CLASS_POINTER [PD_DNSQUERY]}.make_shared (c_pointer)), -1])
			update_class_fields -- Current might have been changed; synchronize
		end

	end_dns_lookup (a_a: INTEGER_32)
		local
			l_a: INTEGER_32
			l_dnsentry: CE_ARRAY [CE_POINTER [PD_DNSENTRY]]
			l_fn: CE_ROUTINE
			l_data: CE_POINTER [ANY]
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_DNSENTRY]} l_dnsentry.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a := a_a
					if fn.is_void then
						free (create {CE_VOID_POINTER}.make_shared (c_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					elseif addr.is_void then
						free (create {CE_VOID_POINTER}.make_shared (c_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_tmp := (create {P_DNS_STATIC}).find_in_dns_cache (name, l_dnsentry)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_a.to_boolean then
							memcpy (create {CE_VOID_POINTER}.make_cast (addr), create {CE_VOID_POINTER}.make_cast ((create {CE_NATURAL_32_POINTER}.make_shared (l_dnsentry.item.c_pointer + (create {PD_DNSENTRY}.make).offset_of ("addr")))), {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_a := 0
							l_pos := -1 + 6 -- goto e
						end
				when 3 then;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_dnsentry.item))
						update_class_fields; -- Current might have been changed; synchronize
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_dnsentry.item.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_dnsentry.item.item.prev)
						update_class_fields; -- Current might have been changed; synchronize
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_dnsentry.item.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_dnsentry.item.item.next)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_dnsentry.item))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("dns.c")), 171, create {CE_VOID_POINTER}.make_cast (l_dnsentry.item))
						update_class_fields -- Current might have been changed; synchronize
				when 4 then -- if done
						if l_a.to_boolean then
							l_pos := -1 + 6 -- goto e
						end
				when 5 then
						l_tmp___0 := strlen (name)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("dns.c")), 174, ((create {PD_DNSENTRY}.make).structure_size.to_natural_32 + l_tmp___0) + {NATURAL_32} 1)
						update_class_fields -- Current might have been changed; synchronize
						l_dnsentry.item := create {CE_CLASS_POINTER [PD_DNSENTRY]}.make_cast (l_tmp___1)
						update_class_fields -- Current might have been changed; synchronize
						strcpy ((l_dnsentry.item.item.name), name).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_NATURAL_32_POINTER}.make_shared (l_dnsentry.item.c_pointer + (create {PD_DNSENTRY}.make).offset_of ("addr")))), create {CE_VOID_POINTER}.make_cast (addr), {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_dnsentry.item.item.get_time := (create {P_SELECT_STATIC}).get_time
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_DNS_STATIC}).dns_cache.item)))
							update_class_fields -- Current might have been changed; synchronize
							l_dnsentry.item.item.next := (create {CE_CLASS_POINTER [PD_DNSENTRY]}.make_cast (((create {P_DNS_STATIC}).dns_cache.item))).item.next
							update_class_fields -- Current might have been changed; synchronize
							l_dnsentry.item.item.prev := create {CE_CLASS_POINTER [PD_DNSENTRY]}.make_cast (((create {P_DNS_STATIC}).dns_cache.item))
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_DNSENTRY]}.make_cast (((create {P_DNS_STATIC}).dns_cache.item))).item.next := l_dnsentry.item
							update_class_fields; -- Current might have been changed; synchronize
							(l_dnsentry.item.item.next).item.prev := l_dnsentry.item
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_DNS_STATIC}).dns_cache.item)))
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
				when 6 then -- e:
						if (not s.is_void) then
							s.item := create {CE_CLASS_POINTER [PD_DNSQUERY]}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_fn := fn
						l_data := data
						free (create {CE_VOID_POINTER}.make_shared (c_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_fn.call ([l_data, l_a])
						update_class_fields -- Current might have been changed; synchronize
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fn := a_other.fn
			data := a_other.data
			xfn := a_other.xfn
			h := a_other.h
			s := a_other.s
			addr := a_other.addr
			name := a_other.name.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fn.is_equal (a_other.fn) and
				data.is_equal (a_other.data) and
				xfn.is_equal (a_other.xfn) and
				h = a_other.h and
				s.is_equal (a_other.s) and
				addr.is_equal (a_other.addr) and
				name.is_equal (a_other.name)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fn"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("xfn"),
					create {CE_STRUCTURE_FIELD}.make ("h"),
					create {CE_STRUCTURE_FIELD}.make ("s"),
					create {CE_STRUCTURE_FIELD}.make ("addr"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("name", <<1>>)
				>>)
			init_structure_info
		end

end
