class
	PD_DOCUMENT_OPTIONS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create default_fg.make
			create default_bg.make
			create default_link.make
			create default_vlink.make
			create {CE_NATURAL_8_POINTER} framename.make
			Precursor
		end

feature {ANY} -- fields

	xw: INTEGER_32 assign set_xw

	yw: INTEGER_32 assign set_yw

	xp: INTEGER_32 assign set_xp

	yp: INTEGER_32 assign set_yp

	col: INTEGER_32 assign set_col

	cp: INTEGER_32 assign set_cp

	assume_cp: INTEGER_32 assign set_assume_cp

	hard_assume: INTEGER_32 assign set_hard_assume

	tables: INTEGER_32 assign set_tables

	frames: INTEGER_32 assign set_frames

	images: INTEGER_32 assign set_images

	margin: INTEGER_32 assign set_margin

	plain: INTEGER_32 assign set_plain

	num_links: INTEGER_32 assign set_num_links

	table_order: INTEGER_32 assign set_table_order

	default_fg: PD_RGB assign set_default_fg

	default_bg: PD_RGB assign set_default_bg

	default_link: PD_RGB assign set_default_link

	default_vlink: PD_RGB assign set_default_vlink

	framename: CE_POINTER [NATURAL_8] assign set_framename

	real_cp: INTEGER_32 assign set_real_cp

feature {ANY} -- field setters

	set_xw (a_xw: INTEGER_32)
		do
			xw := a_xw
			update_memory_field ("xw")
		end

	set_yw (a_yw: INTEGER_32)
		do
			yw := a_yw
			update_memory_field ("yw")
		end

	set_xp (a_xp: INTEGER_32)
		do
			xp := a_xp
			update_memory_field ("xp")
		end

	set_yp (a_yp: INTEGER_32)
		do
			yp := a_yp
			update_memory_field ("yp")
		end

	set_col (a_col: INTEGER_32)
		do
			col := a_col
			update_memory_field ("col")
		end

	set_cp (a_cp: INTEGER_32)
		do
			cp := a_cp
			update_memory_field ("cp")
		end

	set_assume_cp (a_assume_cp: INTEGER_32)
		do
			assume_cp := a_assume_cp
			update_memory_field ("assume_cp")
		end

	set_hard_assume (a_hard_assume: INTEGER_32)
		do
			hard_assume := a_hard_assume
			update_memory_field ("hard_assume")
		end

	set_tables (a_tables: INTEGER_32)
		do
			tables := a_tables
			update_memory_field ("tables")
		end

	set_frames (a_frames: INTEGER_32)
		do
			frames := a_frames
			update_memory_field ("frames")
		end

	set_images (a_images: INTEGER_32)
		do
			images := a_images
			update_memory_field ("images")
		end

	set_margin (a_margin: INTEGER_32)
		do
			margin := a_margin
			update_memory_field ("margin")
		end

	set_plain (a_plain: INTEGER_32)
		do
			plain := a_plain
			update_memory_field ("plain")
		end

	set_num_links (a_num_links: INTEGER_32)
		do
			num_links := a_num_links
			update_memory_field ("num_links")
		end

	set_table_order (a_table_order: INTEGER_32)
		do
			table_order := a_table_order
			update_memory_field ("table_order")
		end

	set_default_fg (a_default_fg: PD_RGB)
		do
			default_fg := a_default_fg
			update_memory_field ("default_fg")
		end

	set_default_bg (a_default_bg: PD_RGB)
		do
			default_bg := a_default_bg
			update_memory_field ("default_bg")
		end

	set_default_link (a_default_link: PD_RGB)
		do
			default_link := a_default_link
			update_memory_field ("default_link")
		end

	set_default_vlink (a_default_vlink: PD_RGB)
		do
			default_vlink := a_default_vlink
			update_memory_field ("default_vlink")
		end

	set_framename (a_framename: CE_POINTER [NATURAL_8])
		do
			framename := a_framename
			update_memory_field ("framename")
		end

	set_real_cp (a_real_cp: INTEGER_32)
		do
			real_cp := a_real_cp
			update_memory_field ("real_cp")
		end

feature {ANY} -- public routines

	compare_opt (a_o2: CE_POINTER [PD_DOCUMENT_OPTIONS]): INTEGER_32
		require
			not a_o2.is_void
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			if xw = a_o2.item.xw then
				if yw = a_o2.item.yw then
					if xp = a_o2.item.xp then
						if yp = a_o2.item.yp then
							if col = a_o2.item.col then
								if cp = a_o2.item.cp then
									if assume_cp = a_o2.item.assume_cp then
										if hard_assume = a_o2.item.hard_assume then
											if tables = a_o2.item.tables then
												if frames = a_o2.item.frames then
													if images = a_o2.item.images then
														if margin = a_o2.item.margin then
															if plain = a_o2.item.plain then
																l_tmp := memcmp (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_fg")))), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (a_o2.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_fg")))), (create {PD_RGB}.make).structure_size.to_natural_32)
																update_class_fields -- Current might have been changed; synchronize
																if not l_tmp.to_boolean then
																	l_tmp___0 := memcmp (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_bg")))), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (a_o2.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_bg")))), (create {PD_RGB}.make).structure_size.to_natural_32)
																	update_class_fields -- Current might have been changed; synchronize
																	if not l_tmp___0.to_boolean then
																		l_tmp___1 := memcmp (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_link")))), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (a_o2.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_link")))), (create {PD_RGB}.make).structure_size.to_natural_32)
																		update_class_fields -- Current might have been changed; synchronize
																		if not l_tmp___1.to_boolean then
																			l_tmp___2 := memcmp (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_vlink")))), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (a_o2.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_vlink")))), (create {PD_RGB}.make).structure_size.to_natural_32)
																			update_class_fields -- Current might have been changed; synchronize
																			if not l_tmp___2.to_boolean then
																				if num_links = a_o2.item.num_links then
																					if table_order = a_o2.item.table_order then
																						l_tmp___3 := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (framename), create {CE_INTEGER_8_POINTER}.make_cast (a_o2.item.framename))
																						update_class_fields -- Current might have been changed; synchronize
																						if not l_tmp___3.to_boolean then
																							Result := 0
																							l_return := True
																						end
																					end
																				end
																			end
																		end
																	end
																end
															end
														end
													end
												end
											end
										end
									end
								end
							end
						end
					end
				end
			end
			if not l_return then
				Result := 1
			end
		end

	copy_opt (a_o2: CE_POINTER [PD_DOCUMENT_OPTIONS])
		require
			not a_o2.is_void
		do
			memcpy (create {CE_VOID_POINTER}.make_shared (c_pointer), create {CE_VOID_POINTER}.make_cast (a_o2), (create {PD_DOCUMENT_OPTIONS}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Current.framename := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_072, a_o2.item.framename)
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			xw := a_other.xw
			yw := a_other.yw
			xp := a_other.xp
			yp := a_other.yp
			col := a_other.col
			cp := a_other.cp
			assume_cp := a_other.assume_cp
			hard_assume := a_other.hard_assume
			tables := a_other.tables
			frames := a_other.frames
			images := a_other.images
			margin := a_other.margin
			plain := a_other.plain
			num_links := a_other.num_links
			table_order := a_other.table_order
			default_fg := a_other.default_fg.twin
			default_bg := a_other.default_bg.twin
			default_link := a_other.default_link.twin
			default_vlink := a_other.default_vlink.twin
			framename := a_other.framename
			real_cp := a_other.real_cp
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				xw = a_other.xw and
				yw = a_other.yw and
				xp = a_other.xp and
				yp = a_other.yp and
				col = a_other.col and
				cp = a_other.cp and
				assume_cp = a_other.assume_cp and
				hard_assume = a_other.hard_assume and
				tables = a_other.tables and
				frames = a_other.frames and
				images = a_other.images and
				margin = a_other.margin and
				plain = a_other.plain and
				num_links = a_other.num_links and
				table_order = a_other.table_order and
				default_fg.is_equal (a_other.default_fg) and
				default_bg.is_equal (a_other.default_bg) and
				default_link.is_equal (a_other.default_link) and
				default_vlink.is_equal (a_other.default_vlink) and
				framename.is_equal (a_other.framename) and
				real_cp = a_other.real_cp
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("xw"),
					create {CE_STRUCTURE_FIELD}.make ("yw"),
					create {CE_STRUCTURE_FIELD}.make ("xp"),
					create {CE_STRUCTURE_FIELD}.make ("yp"),
					create {CE_STRUCTURE_FIELD}.make ("col"),
					create {CE_STRUCTURE_FIELD}.make ("cp"),
					create {CE_STRUCTURE_FIELD}.make ("assume_cp"),
					create {CE_STRUCTURE_FIELD}.make ("hard_assume"),
					create {CE_STRUCTURE_FIELD}.make ("tables"),
					create {CE_STRUCTURE_FIELD}.make ("frames"),
					create {CE_STRUCTURE_FIELD}.make ("images"),
					create {CE_STRUCTURE_FIELD}.make ("margin"),
					create {CE_STRUCTURE_FIELD}.make ("plain"),
					create {CE_STRUCTURE_FIELD}.make ("num_links"),
					create {CE_STRUCTURE_FIELD}.make ("table_order"),
					create {CE_STRUCTURE_FIELD}.make ("default_fg"),
					create {CE_STRUCTURE_FIELD}.make ("default_bg"),
					create {CE_STRUCTURE_FIELD}.make ("default_link"),
					create {CE_STRUCTURE_FIELD}.make ("default_vlink"),
					create {CE_STRUCTURE_FIELD}.make ("framename"),
					create {CE_STRUCTURE_FIELD}.make ("real_cp")
				>>)
			init_structure_info
		end

end
