class
	PD_EVENT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	ev: INTEGER_32 assign set_ev

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	b: INTEGER_32 assign set_b

feature {ANY} -- field setters

	set_ev (a_ev: INTEGER_32)
		do
			ev := a_ev
			update_memory_field ("ev")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_b (a_b: INTEGER_32)
		do
			b := a_b
			update_memory_field ("b")
		end

feature {ANY} -- public routines

	kbd_action (a_kmap: INTEGER_32): INTEGER_32
		local
			l_kb: CE_POINTER [PD_KEYBINDING]
			l_return: BOOLEAN
		do
			if ev = 1 then
				l_kb := create {CE_CLASS_POINTER [PD_KEYBINDING]}.make_cast ((create {P_KBDBIND_STATIC}).keymaps.item[a_kmap].next)
				from
				until
					not (not (l_return) and then (not l_kb.is_equal ((create {P_KBDBIND_STATIC}).keymaps.item + a_kmap)))
				loop
					if x = l_kb.item.x then
						if y = l_kb.item.y then
							Result := (l_kb.item.act)
							l_return := True
						end
					end
					if not l_return then
						l_kb := l_kb.item.next
					end
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ev := a_other.ev
			x := a_other.x
			y := a_other.y
			b := a_other.b
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ev = a_other.ev and
				x = a_other.x and
				y = a_other.y and
				b = a_other.b
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ev"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("b")
				>>)
			init_structure_info
		end

end
