class
	PD_EWD

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create fn.make
			create {CE_VOID_POINTER} data.make
		end

feature {ANY} -- fields

	fn: CE_ROUTINE assign set_fn

	data: CE_POINTER [ANY] assign set_data

	b: INTEGER_32 assign set_b

feature {ANY} -- field setters

	set_fn (a_fn: CE_ROUTINE)
		do
			fn := a_fn
			update_memory_field ("fn")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_b (a_b: INTEGER_32)
		do
			b := a_b
			update_memory_field ("b")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fn := a_other.fn
			data := a_other.data
			b := a_other.b
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fn.is_equal (a_other.fn) and
				data.is_equal (a_other.data) and
				b = a_other.b
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fn"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("b")
				>>)
			init_structure_info
		end

end
