class
	PD_EXTENSION

inherit
	PD_EXTENSION_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_EXTENSION]} next.make
			create {CE_CLASS_POINTER [PD_EXTENSION]} prev.make
			create {CE_NATURAL_8_POINTER} ext.make
			create {CE_NATURAL_8_POINTER} ct.make
			Precursor
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_EXTENSION] assign set_next

	prev: CE_POINTER [PD_EXTENSION] assign set_prev

	cnt: NATURAL_32 assign set_cnt

	ext: CE_POINTER [NATURAL_8] assign set_ext

	ct: CE_POINTER [NATURAL_8] assign set_ct

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_EXTENSION])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_EXTENSION])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_cnt (a_cnt: NATURAL_32)
		do
			cnt := a_cnt
			update_memory_field ("cnt")
		end

	set_ext (a_ext: CE_POINTER [NATURAL_8])
		do
			ext := a_ext
			update_memory_field ("ext")
		end

	set_ct (a_ct: CE_POINTER [NATURAL_8])
		do
			ct := a_ct
			update_memory_field ("ct")
		end

feature {ANY} -- public routines

	delete_extension
		do
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (next)).item.prev := create {CE_VOID_POINTER}.make_cast (prev)
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (prev)).item.next := create {CE_VOID_POINTER}.make_cast (next)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 31, create {CE_VOID_POINTER}.make_cast (ext))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 32, create {CE_VOID_POINTER}.make_cast (ct))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 33, create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	update_ext
		local
			l_repl: CE_POINTER [PD_EXTENSION]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (ext[0]).to_boolean then
						l_return := True
					elseif not (ct[0]).to_boolean then
						l_return := True
					end
					if not (not l_return and then (cnt.to_boolean)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_repl := create {CE_CLASS_POINTER [PD_EXTENSION]}.make_cast ((create {P_TYPES_STATIC}).extensions.item.item.next)
				when 2 then -- loop condition:
						if l_repl.is_equal ((create {P_TYPES_STATIC}).extensions.item) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if l_repl.item.cnt = cnt then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 392, create {CE_VOID_POINTER}.make_cast (l_repl.item.ext))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 393, create {CE_VOID_POINTER}.make_cast (l_repl.item.ct))
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 8 -- goto replace
						end
				when 4 then
						l_repl := l_repl.item.next
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						l_return := True
				when 6 then -- if done
					if not l_return then
						l_repl := create {CE_CLASS_POINTER [PD_EXTENSION]}.make_cast ((create {P_TYPES_STATIC}).extensions.item.item.next)
						from
						until
							not (not (l_return) and then (not l_repl.is_equal ((create {P_TYPES_STATIC}).extensions.item)))
						loop
							l_tmp := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_repl.item.ext), create {CE_INTEGER_8_POINTER}.make_cast (ext))
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp.to_boolean then
								l_tmp___0 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_repl.item.ct), create {CE_INTEGER_8_POINTER}.make_cast (ct))
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___0.to_boolean then
									(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_repl))
									update_class_fields; -- Current might have been changed; synchronize
									(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_repl.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_repl.item.prev)
									update_class_fields; -- Current might have been changed; synchronize
									(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_repl.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_repl.item.next)
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_repl))
									update_class_fields -- Current might have been changed; synchronize
									from
									until
										(l_break)
									loop
										l_break := False;
										(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_TYPES_STATIC}).extensions.item)))
										update_class_fields -- Current might have been changed; synchronize
										l_repl.item.next := (create {CE_CLASS_POINTER [PD_EXTENSION]}.make_cast (((create {P_TYPES_STATIC}).extensions.item))).item.next
										update_class_fields -- Current might have been changed; synchronize
										l_repl.item.prev := create {CE_CLASS_POINTER [PD_EXTENSION]}.make_cast (((create {P_TYPES_STATIC}).extensions.item))
										update_class_fields; -- Current might have been changed; synchronize
										(create {CE_CLASS_POINTER [PD_EXTENSION]}.make_cast (((create {P_TYPES_STATIC}).extensions.item))).item.next := l_repl
										update_class_fields; -- Current might have been changed; synchronize
										(l_repl.item.next).item.prev := l_repl
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_TYPES_STATIC}).extensions.item)))
										update_class_fields -- Current might have been changed; synchronize
										l_break := True
									end
									l_break := False
									l_return := True
								end
							end
							if not l_return then
								l_repl := l_repl.item.next
							end
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 7 then -- if:
						Current.cnt := (create {P_TYPES_STATIC}).get_assoc_cnt
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 404, (create {PD_EXTENSION}.make).structure_size.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_repl := create {CE_CLASS_POINTER [PD_EXTENSION]}.make_cast (l_tmp___1)
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_TYPES_STATIC}).extensions.item)))
							update_class_fields -- Current might have been changed; synchronize
							l_repl.item.next := (create {CE_CLASS_POINTER [PD_EXTENSION]}.make_cast (((create {P_TYPES_STATIC}).extensions.item))).item.next
							update_class_fields -- Current might have been changed; synchronize
							l_repl.item.prev := create {CE_CLASS_POINTER [PD_EXTENSION]}.make_cast (((create {P_TYPES_STATIC}).extensions.item))
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_EXTENSION]}.make_cast (((create {P_TYPES_STATIC}).extensions.item))).item.next := l_repl
							update_class_fields; -- Current might have been changed; synchronize
							(l_repl.item.next).item.prev := l_repl
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_TYPES_STATIC}).extensions.item)))
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
				when 8 then -- replace:
						l_repl.item.ext := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 407, ext)
						update_class_fields -- Current might have been changed; synchronize
						l_repl.item.ct := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 408, ct)
						update_class_fields -- Current might have been changed; synchronize
						l_repl.item.cnt := cnt
						update_class_fields -- Current might have been changed; synchronize
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			cnt := a_other.cnt
			ext := a_other.ext
			ct := a_other.ct
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				cnt = a_other.cnt and
				ext.is_equal (a_other.ext) and
				ct.is_equal (a_other.ct)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("cnt"),
					create {CE_STRUCTURE_FIELD}.make ("ext"),
					create {CE_STRUCTURE_FIELD}.make ("ct")
				>>)
			init_structure_info
		end

end
