class
	PD_FRAMESET_DESC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_ARRAY [PD_FRAME_DESC]} f.make (<<1>>)
		end

feature {ANY} -- fields

	n: INTEGER_32 assign set_n

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	xp: INTEGER_32 assign set_xp

	yp: INTEGER_32 assign set_yp

	f: CE_ARRAY [PD_FRAME_DESC]

feature {ANY} -- field setters

	set_n (a_n: INTEGER_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_xp (a_xp: INTEGER_32)
		do
			xp := a_xp
			update_memory_field ("xp")
		end

	set_yp (a_yp: INTEGER_32)
		do
			yp := a_yp
			update_memory_field ("yp")
		end

feature {ANY} -- public routines

	add_frameset_entry (a_subframe: CE_POINTER [PD_FRAMESET_DESC]; a_name, a_url: CE_POINTER [NATURAL_8])
		local
			l_return: BOOLEAN
		do
			if yp >= y then
				l_return := True
			end
			if not l_return then
				f[xp + yp * x].subframe := a_subframe
				update_class_fields -- Current might have been changed; synchronize
				f[xp + yp * x].name := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 679, a_name)
				update_class_fields -- Current might have been changed; synchronize
				f[xp + yp * x].url := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 680, a_url)
				update_class_fields -- Current might have been changed; synchronize
				Current.xp := xp + 1
				update_class_fields -- Current might have been changed; synchronize
				if xp >= x then
					Current.xp := 0
					update_class_fields -- Current might have been changed; synchronize
					Current.yp := yp + 1
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			x := a_other.x
			y := a_other.y
			xp := a_other.xp
			yp := a_other.yp
			f := a_other.f.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				x = a_other.x and
				y = a_other.y and
				xp = a_other.xp and
				yp = a_other.yp and
				f.is_equal (a_other.f)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("xp"),
					create {CE_STRUCTURE_FIELD}.make ("yp"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("f", <<1>>)
				>>)
			init_structure_info
		end

end
