class
	PD_H_CONN

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_H_CONN]} next.make
			create {CE_CLASS_POINTER [PD_H_CONN]} prev.make
			create {CE_NATURAL_8_POINTER} host.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_H_CONN] assign set_next

	prev: CE_POINTER [PD_H_CONN] assign set_prev

	host: CE_POINTER [NATURAL_8] assign set_host

	conn: INTEGER_32 assign set_conn

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_H_CONN])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_H_CONN])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_host (a_host: CE_POINTER [NATURAL_8])
		do
			host := a_host
			update_memory_field ("host")
		end

	set_conn (a_conn: INTEGER_32)
		do
			conn := a_conn
			update_memory_field ("conn")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			host := a_other.host
			conn := a_other.conn
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				host.is_equal (a_other.host) and
				conn = a_other.conn
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("host"),
					create {CE_STRUCTURE_FIELD}.make ("conn")
				>>)
			init_structure_info
		end

end
