class
	PD_MENU

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} data.make
			create {CE_CLASS_POINTER [PD_WINDOW]} win.make
			create {CE_CLASS_POINTER [PD_MENU_ITEM]} items.make
		end

feature {ANY} -- fields

	selected: INTEGER_32 assign set_selected

	view: INTEGER_32 assign set_view

	xp: INTEGER_32 assign set_xp

	yp: INTEGER_32 assign set_yp

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	xw: INTEGER_32 assign set_xw

	yw: INTEGER_32 assign set_yw

	ni: INTEGER_32 assign set_ni

	data: CE_POINTER [ANY] assign set_data

	win: CE_POINTER [PD_WINDOW] assign set_win

	items: CE_POINTER [PD_MENU_ITEM] assign set_items

feature {ANY} -- field setters

	set_selected (a_selected: INTEGER_32)
		do
			selected := a_selected
			update_memory_field ("selected")
		end

	set_view (a_view: INTEGER_32)
		do
			view := a_view
			update_memory_field ("view")
		end

	set_xp (a_xp: INTEGER_32)
		do
			xp := a_xp
			update_memory_field ("xp")
		end

	set_yp (a_yp: INTEGER_32)
		do
			yp := a_yp
			update_memory_field ("yp")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_xw (a_xw: INTEGER_32)
		do
			xw := a_xw
			update_memory_field ("xw")
		end

	set_yw (a_yw: INTEGER_32)
		do
			yw := a_yw
			update_memory_field ("yw")
		end

	set_ni (a_ni: INTEGER_32)
		do
			ni := a_ni
			update_memory_field ("ni")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_win (a_win: CE_POINTER [PD_WINDOW])
		do
			win := a_win
			update_memory_field ("win")
		end

	set_items (a_items: CE_POINTER [PD_MENU_ITEM])
		do
			items := a_items
			update_memory_field ("items")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			selected := a_other.selected
			view := a_other.view
			xp := a_other.xp
			yp := a_other.yp
			x := a_other.x
			y := a_other.y
			xw := a_other.xw
			yw := a_other.yw
			ni := a_other.ni
			data := a_other.data
			win := a_other.win
			items := a_other.items
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				selected = a_other.selected and
				view = a_other.view and
				xp = a_other.xp and
				yp = a_other.yp and
				x = a_other.x and
				y = a_other.y and
				xw = a_other.xw and
				yw = a_other.yw and
				ni = a_other.ni and
				data.is_equal (a_other.data) and
				win.is_equal (a_other.win) and
				items.is_equal (a_other.items)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("selected"),
					create {CE_STRUCTURE_FIELD}.make ("view"),
					create {CE_STRUCTURE_FIELD}.make ("xp"),
					create {CE_STRUCTURE_FIELD}.make ("yp"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("xw"),
					create {CE_STRUCTURE_FIELD}.make ("yw"),
					create {CE_STRUCTURE_FIELD}.make ("ni"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("win"),
					create {CE_STRUCTURE_FIELD}.make ("items")
				>>)
			init_structure_info
		end

end
