class
	PD_NODE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_NODE]} next.make
			create {CE_CLASS_POINTER [PD_NODE]} prev.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_NODE] assign set_next

	prev: CE_POINTER [PD_NODE] assign set_prev

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	xw: INTEGER_32 assign set_xw

	yw: INTEGER_32 assign set_yw

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_NODE])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_NODE])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_xw (a_xw: INTEGER_32)
		do
			xw := a_xw
			update_memory_field ("xw")
		end

	set_yw (a_yw: INTEGER_32)
		do
			yw := a_yw
			update_memory_field ("yw")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			x := a_other.x
			y := a_other.y
			xw := a_other.xw
			yw := a_other.yw
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				x = a_other.x and
				y = a_other.y and
				xw = a_other.xw and
				yw = a_other.yw
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("xw"),
					create {CE_STRUCTURE_FIELD}.make ("yw")
				>>)
			init_structure_info
		end

end
