class
	PD_PAR_ATTRIB

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create bgcolor.make
		end

feature {ANY} -- fields

	align: INTEGER_32 assign set_align

	leftmargin: INTEGER_32 assign set_leftmargin

	rightmargin: INTEGER_32 assign set_rightmargin

	width: INTEGER_32 assign set_width

	list_level: INTEGER_32 assign set_list_level

	list_number: NATURAL_32 assign set_list_number

	dd_margin: INTEGER_32 assign set_dd_margin

	flags: INTEGER_32 assign set_flags

	bgcolor: PD_RGB assign set_bgcolor

feature {ANY} -- field setters

	set_align (a_align: INTEGER_32)
		do
			align := a_align
			update_memory_field ("align")
		end

	set_leftmargin (a_leftmargin: INTEGER_32)
		do
			leftmargin := a_leftmargin
			update_memory_field ("leftmargin")
		end

	set_rightmargin (a_rightmargin: INTEGER_32)
		do
			rightmargin := a_rightmargin
			update_memory_field ("rightmargin")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_list_level (a_list_level: INTEGER_32)
		do
			list_level := a_list_level
			update_memory_field ("list_level")
		end

	set_list_number (a_list_number: NATURAL_32)
		do
			list_number := a_list_number
			update_memory_field ("list_number")
		end

	set_dd_margin (a_dd_margin: INTEGER_32)
		do
			dd_margin := a_dd_margin
			update_memory_field ("dd_margin")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_bgcolor (a_bgcolor: PD_RGB)
		do
			bgcolor := a_bgcolor
			update_memory_field ("bgcolor")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			align := a_other.align
			leftmargin := a_other.leftmargin
			rightmargin := a_other.rightmargin
			width := a_other.width
			list_level := a_other.list_level
			list_number := a_other.list_number
			dd_margin := a_other.dd_margin
			flags := a_other.flags
			bgcolor := a_other.bgcolor.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				align = a_other.align and
				leftmargin = a_other.leftmargin and
				rightmargin = a_other.rightmargin and
				width = a_other.width and
				list_level = a_other.list_level and
				list_number = a_other.list_number and
				dd_margin = a_other.dd_margin and
				flags = a_other.flags and
				bgcolor.is_equal (a_other.bgcolor)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("align"),
					create {CE_STRUCTURE_FIELD}.make ("leftmargin"),
					create {CE_STRUCTURE_FIELD}.make ("rightmargin"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("list_level"),
					create {CE_STRUCTURE_FIELD}.make ("list_number"),
					create {CE_STRUCTURE_FIELD}.make ("dd_margin"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("bgcolor")
				>>)
			init_structure_info
		end

end
