class
	PD_S_E

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} s.make
			create {CE_NATURAL_8_POINTER} e.make
		end

feature {ANY} -- fields

	s: CE_POINTER [NATURAL_8] assign set_s

	e: CE_POINTER [NATURAL_8] assign set_e

feature {ANY} -- field setters

	set_s (a_s: CE_POINTER [NATURAL_8])
		do
			s := a_s
			update_memory_field ("s")
		end

	set_e (a_e: CE_POINTER [NATURAL_8])
		do
			e := a_e
			update_memory_field ("e")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			s := a_other.s
			e := a_other.e
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				s.is_equal (a_other.s) and
				e.is_equal (a_other.e)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("s"),
					create {CE_STRUCTURE_FIELD}.make ("e")
				>>)
			init_structure_info
		end

end
