class
	PD_STATUS

inherit
	PD_STATUS_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_BITS_ERRNO_STATIC
		redefine
			copy,
			is_equal
		end
	S_UNISTD_STATIC
		redefine
			copy,
			is_equal
		end
	S_UTIME_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_STATUS]} next.make
			create {CE_CLASS_POINTER [PD_STATUS]} prev.make
			create {CE_CLASS_POINTER [PD_CONNECTION]} c.make
			create {CE_CLASS_POINTER [PD_CACHE_ENTRY]} ce.make
			create end2.make
			create {CE_VOID_POINTER} data.make
			create {CE_CLASS_POINTER [PD_REMAINING_INFO]} prg.make
			Precursor
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_STATUS] assign set_next

	prev: CE_POINTER [PD_STATUS] assign set_prev

	c: CE_POINTER [PD_CONNECTION] assign set_c

	ce: CE_POINTER [PD_CACHE_ENTRY] assign set_ce

	state: INTEGER_32 assign set_state

	prev_error: INTEGER_32 assign set_prev_error

	pri: INTEGER_32 assign set_pri

	end2: CE_ROUTINE assign set_end2

	data: CE_POINTER [ANY] assign set_data

	prg: CE_POINTER [PD_REMAINING_INFO] assign set_prg

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_STATUS])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_STATUS])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_c (a_c: CE_POINTER [PD_CONNECTION])
		do
			c := a_c
			update_memory_field ("c")
		end

	set_ce (a_ce: CE_POINTER [PD_CACHE_ENTRY])
		do
			ce := a_ce
			update_memory_field ("ce")
		end

	set_state (a_state: INTEGER_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_prev_error (a_prev_error: INTEGER_32)
		do
			prev_error := a_prev_error
			update_memory_field ("prev_error")
		end

	set_pri (a_pri: INTEGER_32)
		do
			pri := a_pri
			update_memory_field ("pri")
		end

	set_end2 (a_end2: CE_ROUTINE)
		do
			end2 := a_end2
			update_memory_field ("end2")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_prg (a_prg: CE_POINTER [PD_REMAINING_INFO])
		do
			prg := a_prg
			update_memory_field ("prg")
		end

feature {PD_STATUS} -- private attributes

	dump_red_count: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	end_dump (a_p: CE_POINTER [ANY])
		local
			l_ce: CE_POINTER [PD_CACHE_ENTRY]
			l_oh: INTEGER_32
			l_tmp: INTEGER_32
			l_u: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_frag: CE_POINTER [PD_FRAGMENT]
			l_l: INTEGER_32
			l_w: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_32]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_o: CE_ARRAY [PD_DOCUMENT_OPTIONS]
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_fd: CE_ARRAY [PD_F_DATA_C]
			l_tmp___5: NATURAL_32
			l_tmp___6: CE_POINTER [ANY]
			l_m: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_u.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_DOCUMENT_OPTIONS]} l_o.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_F_DATA_C]} l_fd.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ce := ce
					l_tmp := (create {P_OS_DEP_STATIC}).get_output_handle
					update_class_fields -- Current might have been changed; synchronize
					l_oh := l_tmp
					if l_oh = -1 then
						l_return := True
					end
					if not l_return and then (not l_ce.is_void) then
						if (not (l_ce.item.redirect).is_void) then
							l_tmp___1 := dump_red_count.item
							dump_red_count.item := dump_red_count.item + 1
							if l_tmp___1 < 10 then
								if state >= 0 then
									(create {P_SCHED_STATIC}).change_connection ((create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
									update_class_fields -- Current might have been changed; synchronize
								end
								l_u.item := (create {P_URL_STATIC}).join_urls (l_ce.item.url, l_ce.item.redirect)
								update_class_fields -- Current might have been changed; synchronize
								if not ((create {P_DEFAULT_STATIC}).http_bugs.item.item.bug_302_redirect).to_boolean then
									if not (l_ce.item.redirect_get).to_boolean then
										l_tmp___0 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_ce.item.url), 1)
										update_class_fields -- Current might have been changed; synchronize
										l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0)
										if (not l_p___0.is_void) then
											(create {P_LINKS_STATIC}).add_to_strn (l_u, l_p___0)
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								end
								(create {P_SCHED_STATIC}).load_url (l_u.item, (create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer)), 0, 0).do_nothing
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("main.c")), 176, create {CE_VOID_POINTER}.make_cast (l_u.item))
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							end
						end
					end
					if not l_return and then (state >= 0) then
						if state < 8 then
							l_return := True
						end
					end
					if not l_return and then (state >= 8) then
						if (create {P_DEFAULT_STATIC}).dmp.item /= 2 then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if (create {P_DEFAULT_STATIC}).dmp.item /= 2 then
							l_pos := -1 + 12 -- skip if block
						end
				when 2 then -- if:
						if l_ce.is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if: | nextfrag:
						l_frag := create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast (l_ce.item.frag.next)
				when 4 then -- loop condition:
						if l_frag.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_ce.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))) then
							l_pos := -1 + 10 -- skip loop
						end
				when 5 then -- loop body:
						if not (l_frag.item.offset <= (create {P_MAIN_STATIC}).dump_pos.item) then
							l_pos := -1 + 9 -- skip if block
						end
				when 6 then -- if:
						if not (l_frag.item.offset + l_frag.item.length > (create {P_MAIN_STATIC}).dump_pos.item) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_l := (l_frag.item.length - ((create {P_MAIN_STATIC}).dump_pos.item - l_frag.item.offset)).to_integer_32
						l_tmp___2 := (create {P_TERMINAL_STATIC}).hard_write (l_oh, (l_frag.item.data + (create {P_MAIN_STATIC}).dump_pos.item) - l_frag.item.offset, l_l)
						update_class_fields -- Current might have been changed; synchronize
						l_w := l_tmp___2
						if l_w /= l_l then
							((create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer))).item.detach_connection ((create {P_MAIN_STATIC}).dump_pos.item)
							update_class_fields -- Current might have been changed; synchronize
							if l_w < 0 then
								l_tmp___3 := errno_location
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___4 := strerror (l_tmp___3.item)
								update_class_fields -- Current might have been changed; synchronize
								Io.error.put_string ("Error writing to stdout: " + eif_string (l_tmp___4) + ".%N")
							else
								Io.error.put_string ("Can%'t write to stdout.%N")
							end
							(create {P_MAIN_STATIC}).retval.item := 1
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 15 -- goto terminate
						end
				when 8 then;
						(create {P_MAIN_STATIC}).dump_pos.item := (create {P_MAIN_STATIC}).dump_pos.item + l_w.to_integer_32
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer))).item.detach_connection ((create {P_MAIN_STATIC}).dump_pos.item)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 3 -- goto nextfrag
				when 9 then -- if done
						l_frag := l_frag.item.next
						l_pos := -1 + 4 -- back to loop condition
				when 10 then -- loop done | if done
						if state >= 0 then
							l_return := True
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						if (not l_ce.is_void) then
							l_tmp___5 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (ce.item.url))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___6 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("main.c")), 205, ((create {PD_VIEW_STATE}.make).structure_size.to_natural_32 + l_tmp___5) + {NATURAL_32} 1)
							update_class_fields -- Current might have been changed; synchronize
							l_vs := create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_cast (l_tmp___6)
							memset (create {CE_VOID_POINTER}.make_cast (l_o), 0, (create {PD_DOCUMENT_OPTIONS}.make).structure_size.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							memset (create {CE_VOID_POINTER}.make_cast (l_vs), 0, (create {PD_VIEW_STATE}.make).structure_size.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							memset (create {CE_VOID_POINTER}.make_cast (l_fd), 0, (create {PD_F_DATA_C}.make).structure_size.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_o.item.xp := 0
							update_class_fields -- Current might have been changed; synchronize
							l_o.item.yp := 1
							update_class_fields -- Current might have been changed; synchronize
							l_o.item.xw := (create {P_DEFAULT_STATIC}).screen_width.item.item
							update_class_fields -- Current might have been changed; synchronize
							l_o.item.yw := 25
							update_class_fields -- Current might have been changed; synchronize
							l_o.item.col := 0
							update_class_fields -- Current might have been changed; synchronize
							if (create {P_DEFAULT_STATIC}).dump_codepage.item.item = -1 then
								l_o.item.cp := 0
								update_class_fields -- Current might have been changed; synchronize
							else
								l_o.item.cp := (create {P_DEFAULT_STATIC}).dump_codepage.item.item
								update_class_fields -- Current might have been changed; synchronize
							end
							((create {P_DEFAULT_STATIC}).dds.item).item.ds2do (l_o)
							update_class_fields -- Current might have been changed; synchronize
							l_o.item.plain := 0
							update_class_fields -- Current might have been changed; synchronize
							l_o.item.frames := 0
							update_class_fields -- Current might have been changed; synchronize
							memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (l_o.item.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_fg")))), create {CE_VOID_POINTER}.make_cast (((create {P_DEFAULT_STATIC}).default_fg.item)), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (l_o.item.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_bg")))), create {CE_VOID_POINTER}.make_cast (((create {P_DEFAULT_STATIC}).default_bg.item)), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (l_o.item.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_link")))), create {CE_VOID_POINTER}.make_cast (((create {P_DEFAULT_STATIC}).default_link.item)), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (l_o.item.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_vlink")))), create {CE_VOID_POINTER}.make_cast (((create {P_DEFAULT_STATIC}).default_vlink.item)), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_o.item.framename := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
							update_class_fields -- Current might have been changed; synchronize
							l_vs.item.init_vs (ce.item.url)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_HTML_R_STATIC}).cached_format_html (l_vs, l_fd, l_o)
							update_class_fields; -- Current might have been changed; synchronize
							(l_fd.item.f_data).item.dump_to_file (l_oh).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_fd.item.detach_formatted
							update_class_fields -- Current might have been changed; synchronize
							l_vs.item.destroy_vs
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("main.c")), 228, create {CE_VOID_POINTER}.make_cast (l_vs))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 13 then -- if done | if done
					if l_return then
						l_pos := -1 + 16 -- skip if block
					end
				when 14 then -- if:
						if state /= -1_000 then
							l_tmp___7 := (create {P_SESSION_STATIC}).get_err_msg (state)
							update_class_fields -- Current might have been changed; synchronize
							l_m := l_tmp___7
							l_tmp___8 := get_english_translation (l_m)
							update_class_fields -- Current might have been changed; synchronize
							Io.error.put_string (eif_string (create {CE_INTEGER_8_POINTER}.make_shared (l_tmp___8.c_pointer)) + "%N");
							(create {P_MAIN_STATIC}).retval.item := 1
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 15 -- goto terminate
						end
				when 15 then -- terminate:;
						(create {P_SELECT_STATIC}).terminate.item := 1
						update_class_fields -- Current might have been changed; synchronize
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	detach_connection (a_pos___0: INTEGER_32)
		local
			l_c: CE_POINTER [PD_CONNECTION]
			l_i: INTEGER_32
			l_l: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [PD_CONNECTION]} l_c.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if state < 0 then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_c := c
						if (l_c.item.detached).to_boolean then
							l_pos := -1 + 5 -- goto detach_done
						end
				when 2 then
						if (l_c.item.cache).is_void then
							l_return := True
						end
				when 3 then -- if done
					if not l_return then
						if l_c.item.est_length = -1 then
							l_l := l_c.item.from2
						else
							l_l := l_c.item.est_length
						end
						if l_l < (create {P_DEFAULT_STATIC}).memory_cache_size.item.item // 4 then
							l_return := True
						end
					end
					if not l_return then
						l_l := (0).to_integer_32
						l_i := 0
						from
						until
							not (l_i < 5)
						loop
							l_l := l_l + (l_c.item.pri[l_i]).to_integer_32
							l_i := l_i + 1
						end
						if not l_l.to_boolean then
							from
							until
								False
							loop
								(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c"))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).errline.item := 697
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("detaching free connection"))])
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						(create {P_HTML_R_STATIC}).delete_unused_format_cache_entries
						update_class_fields -- Current might have been changed; synchronize
						if l_l /= 1 then
							l_return := True
						elseif ((l_c.item.cache).item.refcount).to_boolean then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 4 then -- if:;
						(l_c.item.cache).item.url[0] := (0).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_c.item.detached := 1
						update_class_fields -- Current might have been changed; synchronize
				when 5 then -- detach_done:
						free_entry_to (l_c.item.cache, a_pos___0)
						update_class_fields -- Current might have been changed; synchronize
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	download_data (a_down___0: CE_POINTER [PD_DOWNLOAD])
		require
			not a_down___0.is_void
		local
			l_ce: CE_POINTER [PD_CACHE_ENTRY]
			l_frag: CE_POINTER [PD_FRAGMENT]
			l_u: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p: CE_POINTER [NATURAL_8]
			l_pos___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_ev: CE_ARRAY [PD_EVENT]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_w: INTEGER_32
			l_emsg: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [INTEGER_32]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_msg: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [PD_MEMORY_LIST]
			l_tmp___7: CE_POINTER [PD_SESSION]
			l_t: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tt: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [PD_SESSION]
			l_tmp___13: CE_POINTER [PD_MEMORY_LIST]
			l_tmp___14: CE_POINTER [PD_SESSION]
			l_tmp___15: CE_POINTER [PD_SESSION]
			l_foo: CE_ARRAY [SD_UTIMBUF]
			l_ev___0: CE_ARRAY [PD_EVENT]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_u.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_EVENT]} l_ev.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_UTIMBUF]} l_foo.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_EVENT]} l_ev___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if state >= 0 then
						if state < 8 then
							l_pos := -1 + 10 -- goto end_store
						end
					end
				when 1 then
					l_ce := ce
					if l_ce.is_void then
						l_pos := -1 + 10 -- goto end_store
					end
				when 2 then
					if (not (l_ce.item.last_modified).is_void) then
						a_down___0.item.remotetime := (create {P_SESSION_STATIC}).parse_http_date (create {CE_INTEGER_8_POINTER}.make_cast (l_ce.item.last_modified))
						update_class_fields -- Current might have been changed; synchronize
					end
					if (l_ce.item.redirect).is_void then
						l_pos := -1 + 6 -- skip if block
					end
				when 3 then -- if:
						l_tmp___1 := a_down___0.item.redirect_cnt
						a_down___0.item.redirect_cnt := (a_down___0.item.redirect_cnt) + 1
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___1 < 10) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if state >= 0 then
							(create {P_SCHED_STATIC}).change_connection (create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (a_down___0.c_pointer + (create {PD_DOWNLOAD}.make).offset_of ("stat")), create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_u.item := (create {P_URL_STATIC}).join_urls (a_down___0.item.url, l_ce.item.redirect)
						update_class_fields -- Current might have been changed; synchronize
						if (l_u.item).is_void then
							l_pos := -1 + 7 -- goto x
						end
				when 5 then
						l_pos___0 := (create {P_URL_STATIC}).extract_position (l_u.item)
						update_class_fields -- Current might have been changed; synchronize
						if (not l_pos___0.is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 510, create {CE_VOID_POINTER}.make_cast (l_pos___0))
							update_class_fields -- Current might have been changed; synchronize
						end
						if not ((create {P_DEFAULT_STATIC}).http_bugs.item.item.bug_302_redirect).to_boolean then
							if not (l_ce.item.redirect_get).to_boolean then
								l_tmp := strchr (create {CE_INTEGER_8_POINTER}.make_cast (a_down___0.item.url), 1)
								update_class_fields -- Current might have been changed; synchronize
								l_p := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)
								if (not l_p.is_void) then
									(create {P_LINKS_STATIC}).add_to_strn (l_u, l_p)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 512, create {CE_VOID_POINTER}.make_cast (a_down___0.item.url))
						update_class_fields -- Current might have been changed; synchronize
						a_down___0.item.url := l_u.item
						update_class_fields -- Current might have been changed; synchronize
						a_down___0.item.stat.state := -999
						update_class_fields -- Current might have been changed; synchronize
						if (not (a_down___0.item.win).is_void) then
							l_ev.item.ev := 3
							update_class_fields -- Current might have been changed; synchronize
							l_ev.item.x := 0
							update_class_fields -- Current might have been changed; synchronize
							l_ev.item.y := 0
							update_class_fields -- Current might have been changed; synchronize
							l_ev.item.b := 0
							update_class_fields -- Current might have been changed; synchronize
							l_ev.item.x := (((a_down___0.item.win).item.term).item.x).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							l_ev.item.y := (((a_down___0.item.win).item.term).item.y).to_integer_32
							update_class_fields; -- Current might have been changed; synchronize
							((a_down___0.item.win).item.handler).call ([a_down___0.item.win, l_ev, 0])
							update_class_fields -- Current might have been changed; synchronize
						end
						if a_down___0.item.redirect_cnt < 5 then
							l_tmp___0 := 1
						else
							l_tmp___0 := 3
						end
						(create {P_SCHED_STATIC}).load_url (a_down___0.item.url, create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (a_down___0.c_pointer + (create {PD_DOWNLOAD}.make).offset_of ("stat")), 0, l_tmp___0).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
				when 6 then -- if done | if done
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 7 then -- if: | x:
						l_frag := create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast (l_ce.item.frag.next)
						from
						until
							not (not (l_return) and then (not l_frag.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_ce.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))))
						loop
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_frag.item.offset <= a_down___0.item.last_pos then
									if not (l_frag.item.offset + l_frag.item.length > a_down___0.item.last_pos) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_w := write (a_down___0.item.handle, create {CE_VOID_POINTER}.make_cast ((l_frag.item.data + (a_down___0.item.last_pos - l_frag.item.offset))), (l_frag.item.length - (a_down___0.item.last_pos - l_frag.item.offset)).to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
									if l_w = -1 then
										if not (((create {P_SESSION_STATIC}).sessions.item.item.next).is_equal ((create {P_SESSION_STATIC}).sessions.item)) then
											l_tmp___2 := errno_location
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___3 := strerror (l_tmp___2.item)
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___4 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 551, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___3))
											update_class_fields -- Current might have been changed; synchronize
											l_emsg := l_tmp___4
											l_tmp___5 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 552, a_down___0.item.file)
											update_class_fields -- Current might have been changed; synchronize
											l_msg := l_tmp___5
											l_tmp___6 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_msg), l_emsg, create {CE_VOID_POINTER}.make_shared (default_pointer)])
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___7 := get_download_ses (a_down___0)
											update_class_fields; -- Current might have been changed; synchronize
											(l_tmp___7.item.term).item.msg_box ([l_tmp___6, (create {P_LINKS_STATIC}).dummyarray.item + 168, 129, (create {P_LINKS_STATIC}).dummyarray.item + 169, ce_string (" "), l_msg, ce_string (": "), l_emsg, create {CE_VOID_POINTER}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
											update_class_fields -- Current might have been changed; synchronize
										end
										((create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer))).item.detach_connection (a_down___0.item.last_pos)
										update_class_fields -- Current might have been changed; synchronize
										a_down___0.item.abort_download
										update_class_fields -- Current might have been changed; synchronize
										l_return := True
									end
									if not l_return then
										a_down___0.item.last_pos := a_down___0.item.last_pos + l_w.to_integer_32
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
							if not l_return then
								l_break := False
								l_frag := l_frag.item.next
							end
						end
				when 8 then -- if done
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 9 then -- if:;
						((create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer))).item.detach_connection (a_down___0.item.last_pos)
						update_class_fields -- Current might have been changed; synchronize
				when 10 then -- end_store:
						
						if state < 0 then
							if state /= -1_000 then
								l_tmp___8 := (create {P_SESSION_STATIC}).get_err_msg (state)
								update_class_fields -- Current might have been changed; synchronize
								l_t := l_tmp___8
								if (not l_t.is_void) then
									l_tmp___9 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 567, a_down___0.item.url)
									update_class_fields -- Current might have been changed; synchronize
									l_tt := l_tmp___9
									l_tmp___11 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_tt), 1)
									update_class_fields -- Current might have been changed; synchronize
									if (not l_tmp___11.is_void) then
										l_tmp___10 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_tt), 1)
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___10[0] := (0).to_integer_8
										update_class_fields -- Current might have been changed; synchronize
									end
									l_tmp___12 := get_download_ses (a_down___0)
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___13 := (create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_tt), create {CE_VOID_POINTER}.make_shared (default_pointer)])
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___14 := get_download_ses (a_down___0)
									update_class_fields; -- Current might have been changed; synchronize
									(l_tmp___14.item.term).item.msg_box ([l_tmp___13, (create {P_LINKS_STATIC}).dummyarray.item + 168, 129, (create {P_LINKS_STATIC}).dummyarray.item + 170, ce_string (" "), l_tt, ce_string (":%N%N"), l_t, create {CE_VOID_POINTER}.make_shared (default_pointer), l_tmp___12, 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
									update_class_fields -- Current might have been changed; synchronize
								end
							elseif (not (a_down___0.item.prog).is_void) then
								(create {P_LINKS_STATIC}).prealloc_truncate (a_down___0.item.handle, a_down___0.item.last_pos)
								update_class_fields -- Current might have been changed; synchronize
								close (a_down___0.item.handle).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								a_down___0.item.handle := -1
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___15 := get_download_ses (a_down___0)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_TERMINAL_STATIC}).exec_on_terminal (l_tmp___15.item.term, a_down___0.item.prog, a_down___0.item.file, ((a_down___0.item.prog_flags).to_boolean).to_integer)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 576, create {CE_VOID_POINTER}.make_cast (a_down___0.item.prog))
								update_class_fields -- Current might have been changed; synchronize
								a_down___0.item.prog := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								update_class_fields -- Current might have been changed; synchronize
							elseif (a_down___0.item.remotetime).to_boolean then
								if ((create {P_DEFAULT_STATIC}).download_utime.item.item).to_boolean then
									l_foo.item.modtime := a_down___0.item.remotetime
									update_class_fields -- Current might have been changed; synchronize
									l_foo.item.actime := l_foo.item.modtime
									update_class_fields -- Current might have been changed; synchronize
									utime (create {CE_INTEGER_8_POINTER}.make_cast (a_down___0.item.file), l_foo).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							a_down___0.item.abort_download
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
				when 11 then -- if done
					if not l_return and then (not (a_down___0.item.win).is_void) then
						l_ev___0.item.ev := 3
						update_class_fields -- Current might have been changed; synchronize
						l_ev___0.item.x := 0
						update_class_fields -- Current might have been changed; synchronize
						l_ev___0.item.y := 0
						update_class_fields -- Current might have been changed; synchronize
						l_ev___0.item.b := 0
						update_class_fields -- Current might have been changed; synchronize
						l_ev___0.item.x := (((a_down___0.item.win).item.term).item.x).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_ev___0.item.y := (((a_down___0.item.win).item.term).item.y).to_integer_32
						update_class_fields; -- Current might have been changed; synchronize
						((a_down___0.item.win).item.handler).call ([a_down___0.item.win, l_ev___0, 0])
						update_class_fields -- Current might have been changed; synchronize
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	doc_end_load (a_ses: CE_POINTER [PD_SESSION])
		require
			not a_ses.is_void
		do
			if state < 0 then
				if a_ses.item.display_timer /= -1 then
					(create {P_SELECT_STATIC}).kill_timer (a_ses.item.display_timer)
					update_class_fields -- Current might have been changed; synchronize
					a_ses.item.display_timer := -1
					update_class_fields -- Current might have been changed; synchronize
				end
				a_ses.item.html_interpret
				update_class_fields -- Current might have been changed; synchronize
				a_ses.item.draw_formatted
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SESSION_STATIC}).load_frames (a_ses, a_ses.item.screen)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SESSION_STATIC}).process_file_requests (a_ses)
				update_class_fields -- Current might have been changed; synchronize
				if state /= -1_000 then
					(create {P_SESSION_STATIC}).print_error_dialog (a_ses, (create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer)), (create {P_LINKS_STATIC}).dummyarray.item + 186)
					update_class_fields -- Current might have been changed; synchronize
				end
			elseif a_ses.item.display_timer = -1 then
				a_ses.item.display_timer2
				update_class_fields -- Current might have been changed; synchronize
			end
			a_ses.item.print_screen_status
			update_class_fields -- Current might have been changed; synchronize
		end

	file_end_load (a_ftl: CE_POINTER [PD_FILE_TO_LOAD])
		require
			not a_ftl.is_void
		local
			l_tmp: CE_POINTER [PD_CACHE_ENTRY]
		do
			if (not (a_ftl.item.stat.ce).is_void) then
				if (not (a_ftl.item.ce).is_void) then
					(a_ftl.item.ce).item.refcount := ((a_ftl.item.ce).item.refcount) - 1
					update_class_fields -- Current might have been changed; synchronize
				end
				l_tmp := a_ftl.item.stat.ce
				a_ftl.item.ce := l_tmp
				update_class_fields -- Current might have been changed; synchronize
				l_tmp.item.refcount := (l_tmp.item.refcount) + 1
				update_class_fields -- Current might have been changed; synchronize
			end
			((create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer))).item.doc_end_load (a_ftl.item.ses)
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_STATUS} -- private routines

	free_entry_to (a_e: CE_POINTER [PD_CACHE_ENTRY]; a_off: INTEGER_32)
		require
			not a_e.is_void
		local
			l_f: CE_POINTER [PD_FRAGMENT]
			l_g: CE_POINTER [PD_FRAGMENT]
			l_tmp: INTEGER_32
			l_break: BOOLEAN
		do
			l_f := create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast (a_e.item.frag.next)
			from
			until
				not (not (l_break) and then (not l_f.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))))
			loop
				l_break := False
				if l_f.item.offset + l_f.item.length <= a_off then
					a_e.item.data_size := a_e.item.data_size + (-l_f.item.length);
					(create {P_CACHE_STATIC}).cache_size.item := (create {P_CACHE_STATIC}).cache_size.item + (-l_f.item.length)
					l_g := l_f
					l_f := l_f.item.prev;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_g));
					(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_g.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_g.item.prev);
					(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_g.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_g.item.next);
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_g));
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 242, create {CE_VOID_POINTER}.make_cast (l_g))
				elseif l_f.item.offset < a_off then
					a_e.item.data_size := a_e.item.data_size + (l_f.item.offset - a_off);
					(create {P_CACHE_STATIC}).cache_size.item := (create {P_CACHE_STATIC}).cache_size.item + (l_f.item.offset - a_off)
					l_tmp := l_f.item.length - (a_off - l_f.item.offset)
					l_f.item.length := l_tmp
					memmove (create {CE_VOID_POINTER}.make_cast ((l_f.item.data)), create {CE_VOID_POINTER}.make_cast ((l_f.item.data + (a_off - l_f.item.offset))), l_tmp.to_natural_32).do_nothing
					l_f.item.offset := a_off
				else
					l_break := True
				end
				if not (l_break) then
					l_f := l_f.item.next
				end
			end
			l_break := False
		end

	get_english_translation (a_text: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_return: BOOLEAN
		do
			if (a_text.c_pointer.to_integer_32).to_natural_32 < (((create {P_LINKS_STATIC}).dummyarray.item).c_pointer.to_integer_32).to_natural_32 then
				Result := a_text
				l_return := True
			elseif (a_text.c_pointer.to_integer_32).to_natural_32 > (((create {P_LINKS_STATIC}).dummyarray.item + 378).c_pointer.to_integer_32).to_natural_32 then
				Result := a_text
				l_return := True
			end
			if not l_return then
				Result := ((create {P_LANGUAGE_STATIC}).translation_english.item[a_text.distance (((create {P_LINKS_STATIC}).dummyarray.item))].name)
			end
		end

	get_download_ses (a_down___0: CE_POINTER [PD_DOWNLOAD]): CE_POINTER [PD_SESSION]
		local
			l_ses: CE_POINTER [PD_SESSION]
			l_return: BOOLEAN
		do
			l_ses := create {CE_CLASS_POINTER [PD_SESSION]}.make_cast ((create {P_SESSION_STATIC}).sessions.item.item.next)
			from
			until
				not (not (l_return) and then (not l_ses.is_equal ((create {P_SESSION_STATIC}).sessions.item)))
			loop
				if l_ses.is_equal (a_down___0.item.ses) then
					Result := l_ses
					l_return := True
				end
				if not l_return then
					l_ses := l_ses.item.next
				end
			end
			if not l_return and then (not (((create {P_SESSION_STATIC}).sessions.item.item.next).is_equal ((create {P_SESSION_STATIC}).sessions.item))) then
				Result := (create {CE_CLASS_POINTER [PD_SESSION]}.make_cast ((create {P_SESSION_STATIC}).sessions.item.item.next))
				l_return := True
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_SESSION]}.make_shared (default_pointer))
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			c := a_other.c
			ce := a_other.ce
			state := a_other.state
			prev_error := a_other.prev_error
			pri := a_other.pri
			end2 := a_other.end2
			data := a_other.data
			prg := a_other.prg
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				c.is_equal (a_other.c) and
				ce.is_equal (a_other.ce) and
				state = a_other.state and
				prev_error = a_other.prev_error and
				pri = a_other.pri and
				end2.is_equal (a_other.end2) and
				data.is_equal (a_other.data) and
				prg.is_equal (a_other.prg)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("c"),
					create {CE_STRUCTURE_FIELD}.make ("ce"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("prev_error"),
					create {CE_STRUCTURE_FIELD}.make ("pri"),
					create {CE_STRUCTURE_FIELD}.make ("end2"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("prg")
				>>)
			init_structure_info
		end

end
