class
	PD_STRERROR_VAL

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_STRERROR_VAL]} next.make
			create {CE_CLASS_POINTER [PD_STRERROR_VAL]} prev.make
			create {CE_NATURAL_8_ARRAY} msg.make (<<1>>)
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_STRERROR_VAL] assign set_next

	prev: CE_POINTER [PD_STRERROR_VAL] assign set_prev

	msg: CE_ARRAY [NATURAL_8]

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_STRERROR_VAL])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_STRERROR_VAL])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			msg := a_other.msg.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				msg.is_equal (a_other.msg)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("msg", <<1>>)
				>>)
			init_structure_info
		end

end
