class
	PD_TABLE_CACHE_ENTRY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_TABLE_CACHE_ENTRY]} next.make
			create {CE_CLASS_POINTER [PD_TABLE_CACHE_ENTRY]} prev.make
			create {CE_CLASS_POINTER [PD_TABLE_CACHE_ENTRY]} hash_next.make
			create {CE_NATURAL_8_POINTER} start.make
			create {CE_NATURAL_8_POINTER} end2.make
			create p.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_TABLE_CACHE_ENTRY] assign set_next

	prev: CE_POINTER [PD_TABLE_CACHE_ENTRY] assign set_prev

	hash_next: CE_POINTER [PD_TABLE_CACHE_ENTRY] assign set_hash_next

	start: CE_POINTER [NATURAL_8] assign set_start

	end2: CE_POINTER [NATURAL_8] assign set_end2

	align: INTEGER_32 assign set_align

	m: INTEGER_32 assign set_m

	width: INTEGER_32 assign set_width

	xs: INTEGER_32 assign set_xs

	link_num: INTEGER_32 assign set_link_num

	p: PD_PART assign set_p

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_TABLE_CACHE_ENTRY])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_TABLE_CACHE_ENTRY])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_hash_next (a_hash_next: CE_POINTER [PD_TABLE_CACHE_ENTRY])
		do
			hash_next := a_hash_next
			update_memory_field ("hash_next")
		end

	set_start (a_start: CE_POINTER [NATURAL_8])
		do
			start := a_start
			update_memory_field ("start")
		end

	set_end2 (a_end2: CE_POINTER [NATURAL_8])
		do
			end2 := a_end2
			update_memory_field ("end2")
		end

	set_align (a_align: INTEGER_32)
		do
			align := a_align
			update_memory_field ("align")
		end

	set_m (a_m: INTEGER_32)
		do
			m := a_m
			update_memory_field ("m")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_xs (a_xs: INTEGER_32)
		do
			xs := a_xs
			update_memory_field ("xs")
		end

	set_link_num (a_link_num: INTEGER_32)
		do
			link_num := a_link_num
			update_memory_field ("link_num")
		end

	set_p (a_p: PD_PART)
		do
			p := a_p
			update_memory_field ("p")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			hash_next := a_other.hash_next
			start := a_other.start
			end2 := a_other.end2
			align := a_other.align
			m := a_other.m
			width := a_other.width
			xs := a_other.xs
			link_num := a_other.link_num
			p := a_other.p.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				hash_next.is_equal (a_other.hash_next) and
				start.is_equal (a_other.start) and
				end2.is_equal (a_other.end2) and
				align = a_other.align and
				m = a_other.m and
				width = a_other.width and
				xs = a_other.xs and
				link_num = a_other.link_num and
				p.is_equal (a_other.p)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("hash_next"),
					create {CE_STRUCTURE_FIELD}.make ("start"),
					create {CE_STRUCTURE_FIELD}.make ("end2"),
					create {CE_STRUCTURE_FIELD}.make ("align"),
					create {CE_STRUCTURE_FIELD}.make ("m"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("xs"),
					create {CE_STRUCTURE_FIELD}.make ("link_num"),
					create {CE_STRUCTURE_FIELD}.make ("p")
				>>)
			init_structure_info
		end

end
