class
	PD_U

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	str: CE_POINTER [NATURAL_8] assign set_str

	tbl: CE_POINTER [PD_CONV_TABLE] assign set_tbl

feature {ANY} -- field setters

	set_str (a_str: CE_POINTER [NATURAL_8])
		do
			str := a_str
			update_memory_field ("str")
		end

	set_tbl (a_tbl: CE_POINTER [PD_CONV_TABLE])
		do
			tbl := a_tbl
			update_memory_field ("tbl")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			str := a_other.str
			tbl := a_other.tbl
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				str.is_equal (a_other.str) and
				tbl.is_equal (a_other.tbl)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("str"),
					create {CE_STRUCTURE_FIELD}.make ("tbl")
				>>)
			init_structure_info
		end

end
