class
	PD_WINDOW

inherit
	PD_WINDOW_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_WINDOW]} next.make
			create {CE_CLASS_POINTER [PD_WINDOW]} prev.make
			create handler.make
			create {CE_VOID_POINTER} data.make
			create {CE_CLASS_POINTER [PD_TERMINAL]} term.make
			Precursor
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_WINDOW] assign set_next

	prev: CE_POINTER [PD_WINDOW] assign set_prev

	handler: CE_ROUTINE assign set_handler

	data: CE_POINTER [ANY] assign set_data

	xp: INTEGER_32 assign set_xp

	yp: INTEGER_32 assign set_yp

	term: CE_POINTER [PD_TERMINAL] assign set_term

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_WINDOW])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_WINDOW])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_handler (a_handler: CE_ROUTINE)
		do
			handler := a_handler
			update_memory_field ("handler")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_xp (a_xp: INTEGER_32)
		do
			xp := a_xp
			update_memory_field ("xp")
		end

	set_yp (a_yp: INTEGER_32)
		do
			yp := a_yp
			update_memory_field ("yp")
		end

	set_term (a_term: CE_POINTER [PD_TERMINAL])
		do
			term := a_term
			update_memory_field ("term")
		end

feature {PD_WINDOW} -- private attributes

	session_id: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 1
		end

feature {ANY} -- public routines

	menu_func (a_ev: CE_POINTER [PD_EVENT]; a_fwd: INTEGER_32)
		require
			not a_ev.is_void
		local
			l_s: INTEGER_32
			l_menu: CE_POINTER [PD_MENU]
			l_w1: CE_POINTER [PD_WINDOW]
			l_m1: CE_POINTER [PD_MENU]
			l_s___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: CE_POINTER [PD_EVENT]
			l_i: INTEGER_32
			l_tmp___6: NATURAL_8
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_i___0: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := 0
					l_menu := create {CE_CLASS_POINTER [PD_MENU]}.make_cast (data)
					l_menu.item.win := (create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))
					update_class_fields -- Current might have been changed; synchronize
					inspect (a_ev.item.ev).to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 4 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 28
					when 5 then l_pos := -1 + 54
					else l_pos := -1 + 55
					end
				when 1 then -- switch 1, case 0 | switch 1, case 4 | switch 1, case 3;
					((create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))).item.get_parent_ptr (create {CE_INTEGER_32_POINTER}.make_shared (l_menu.c_pointer + (create {PD_MENU}.make).offset_of ("xp")), create {CE_INTEGER_32_POINTER}.make_shared (l_menu.c_pointer + (create {PD_MENU}.make).offset_of ("yp")))
					update_class_fields -- Current might have been changed; synchronize
					count_menu_size (term, l_menu)
					update_class_fields -- Current might have been changed; synchronize
					l_menu.item.selected := (l_menu.item.selected) - 1
					update_class_fields -- Current might have been changed; synchronize
					scroll_menu (l_menu, 1)
					update_class_fields -- Current might have been changed; synchronize
					display_menu (term, l_menu)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 55 -- switch 1; break
				when 2 then -- switch 1, case 2
					if not (a_ev.item.x < (l_menu.item.x).to_integer_32) then
						l_pos := -1 + 5 -- skip if block
					end
				when 3 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 5 then -- else:
						if not (a_ev.item.x >= (l_menu.item.x + l_menu.item.xw).to_integer_32) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 8 then -- else:
						if not (a_ev.item.y < (l_menu.item.y).to_integer_32) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 11 then -- else:
						if not (a_ev.item.y >= (l_menu.item.y + l_menu.item.yw).to_integer_32) then
							l_pos := -1 + 26 -- skip if block
						end
				when 12 then -- if: | _L:
						if ((a_ev.item.b).bit_and (12)) /= 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | del:;
						((create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))).item.delete_window_ev (a_ev)
						update_class_fields -- Current might have been changed; synchronize
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else:
						l_w1 := (create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))
				when 16 then -- loop condition:
						if not (not (l_break) and then (not l_w1.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))))) then
							l_pos := -1 + 24 -- skip loop
						end
				when 17 then -- loop body:
						l_break := False
						if not ((l_w1.item.handler).is_equal (mainmenu_func_address)) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if not (a_ev.item.y).to_boolean then
							l_pos := -1 + 13 -- goto del
						end
				when 19 then
						l_break := True
				when 20 then -- if done
						if not (l_break) and then (not (l_w1.item.handler).is_equal (menu_func_address)) then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_m1 := create {CE_CLASS_POINTER [PD_MENU]}.make_cast (l_w1.item.data)
						if a_ev.item.x > (l_m1.item.x).to_integer_32 then
							if a_ev.item.x < ((l_m1.item.x + l_m1.item.xw) - 1).to_integer_32 then
								if a_ev.item.y > (l_m1.item.y).to_integer_32 then
									if a_ev.item.y < ((l_m1.item.y + l_m1.item.yw) - 1).to_integer_32 then
										l_pos := -1 + 13 -- goto del
									end
								end
							end
						end
				when 22 then
						l_w1 := l_w1.item.next
				when 23 then -- if done
						l_pos := -1 + 16 -- back to loop condition
				when 24 then -- loop done
						l_break := False
				when 25 then -- if done | if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						if not (a_ev.item.x < (l_menu.item.x).to_integer_32) then
							if not (a_ev.item.x >= (l_menu.item.x + l_menu.item.xw).to_integer_32) then
								if not (a_ev.item.y < (l_menu.item.y + 1).to_integer_32) then
									if not (a_ev.item.y >= ((l_menu.item.y + l_menu.item.yw) - 1).to_integer_32) then
										l_s___0 := (((a_ev.item.y - (l_menu.item.y).to_integer_32) - 1) + (l_menu.item.view).to_integer_32).to_integer_32
										if l_s___0 >= 0 then
											if l_s___0 < l_menu.item.ni then
												if not ((l_menu.item.items + l_s___0).item.hotkey).is_equal ((create {P_BFU_STATIC}).m_bar.item) then
													l_menu.item.selected := l_s___0
													update_class_fields -- Current might have been changed; synchronize
													scroll_menu (l_menu, 0)
													update_class_fields -- Current might have been changed; synchronize
													display_menu (term, l_menu)
													update_class_fields -- Current might have been changed; synchronize
													if ((a_ev.item.b).bit_and (12)) = 4 then
														select_menu (term, l_menu)
														update_class_fields -- Current might have been changed; synchronize
													end
												end
											end
										end
									end
								end
							end
						end
				when 27 then -- if done | if done | if done
					l_pos := -1 + 55 -- switch 1; break
				when 28 then -- switch 1, case 1
					l_tmp := a_ev.item.kbd_action (2)
					update_class_fields -- Current might have been changed; synchronize
					inspect l_tmp -- switch 2 head
					when 23 then l_pos := -1 + 29
					when 35 then l_pos := -1 + 29
					when 45 then l_pos := -1 + 32
					when 9 then l_pos := -1 + 33
					when 20 then l_pos := -1 + 34
					when 11 then l_pos := -1 + 35
					when 29 then l_pos := -1 + 36
					when 28 then l_pos := -1 + 37
					else l_pos := -1 + 38
					end
				when 29 then -- switch 2, case 23 | switch 2, case 35
					if not next.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))) then
						if (next.item.handler).is_equal (mainmenu_func_address) then
							l_pos := -1 + 42 -- goto mm
						end
					end
				when 30 then
					l_tmp___0 := a_ev.item.kbd_action (2)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___0 = 35 then
						l_pos := -1 + 52 -- goto enter
					end
				when 31 then;
					((create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))).item.delete_window
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 53 -- goto break2
				when 32 then -- switch 2, case 45
					scroll_menu (l_menu, -1)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 45 -- switch 2; break
				when 33 then -- switch 2, case 9
					scroll_menu (l_menu, 1)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 45 -- switch 2; break
				when 34 then -- switch 2, case 20
					l_menu.item.selected := -1
					update_class_fields -- Current might have been changed; synchronize
					scroll_menu (l_menu, 1)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 45 -- switch 2; break
				when 35 then -- switch 2, case 11
					l_menu.item.selected := l_menu.item.ni
					update_class_fields -- Current might have been changed; synchronize
					scroll_menu (l_menu, -1)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 45 -- switch 2; break
				when 36 then -- switch 2, case 29
					l_tmp___1 := l_menu.item.selected - (l_menu.item.yw - 3)
					l_menu.item.selected := l_tmp___1
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___1 < -1 then
						l_menu.item.selected := -1
						update_class_fields -- Current might have been changed; synchronize
					end
					l_tmp___2 := l_menu.item.view - (l_menu.item.yw - 2)
					l_menu.item.view := l_tmp___2
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___2 < 0 then
						l_menu.item.view := 0
						update_class_fields -- Current might have been changed; synchronize
					end
					scroll_menu (l_menu, -1)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 45 -- switch 2; break
				when 37 then -- switch 2, case 28
					l_tmp___3 := l_menu.item.selected + (l_menu.item.yw - 3)
					l_menu.item.selected := l_tmp___3
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___3 > l_menu.item.ni then
						l_menu.item.selected := l_menu.item.ni
						update_class_fields -- Current might have been changed; synchronize
					end
					l_tmp___4 := l_menu.item.view + (l_menu.item.yw - 2)
					l_menu.item.view := l_tmp___4
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___4 >= (l_menu.item.ni - l_menu.item.yw) + 2 then
						l_menu.item.view := (l_menu.item.ni - l_menu.item.yw) + 2
						update_class_fields -- Current might have been changed; synchronize
					end
					scroll_menu (l_menu, 1)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 45 -- switch 2; break
				when 38 then -- switch 2, default:
					if not (a_ev.item.x >= 288) then
						l_pos := -1 + 41 -- skip if block
					end
				when 39 then -- if:
						if a_ev.item.x <= 299 then
							l_pos := -1 + 42 -- goto mm
						else
							l_pos := -1 + 41 -- goto _L___1
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 41 then -- else: | _L___1:
						if a_ev.item.y /= 4 then
							l_pos := -1 + 43 -- skip if block
						end
				when 42 then -- if: | mm:;
						((create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))).item.delete_window_ev (a_ev)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 53 -- goto break2
				when 43 then -- if done
					if a_ev.item.x = 259 then
						if not next.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))) then
							if (next.item.handler).is_equal (mainmenu_func_address) then
								l_tmp___5 := a_ev
							else
								l_tmp___5 := create {CE_CLASS_POINTER [PD_EVENT]}.make_shared (default_pointer)
							end
						else
							l_tmp___5 := create {CE_CLASS_POINTER [PD_EVENT]}.make_shared (default_pointer)
						end
						((create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))).item.delete_window_ev (l_tmp___5)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 53 -- goto break2
					end
				when 44 then
					if a_ev.item.x > 32 then
						if a_ev.item.x < 256 then
							l_i := 0
							from
							until
								not (l_i < l_menu.item.ni)
							loop
								l_tmp___6 := (create {P_LINKS_STATIC}).upcase ((a_ev.item.x).to_natural_8)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___7 := (create {P_LANGUAGE_STATIC}).get_text_translation ((l_menu.item.items + l_i).item.hotkey, term)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___8 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___7), l_tmp___6.to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
								if (not l_tmp___8.is_void) then
									l_menu.item.selected := l_i
									update_class_fields -- Current might have been changed; synchronize
									scroll_menu (l_menu, 0)
									update_class_fields -- Current might have been changed; synchronize
									l_s := 1
								end
								l_i := l_i + 1
							end
						end
					end
					l_pos := -1 + 45 -- switch 2; break
				when 45 then -- switch 2, done:
					display_menu (term, l_menu)
					update_class_fields -- Current might have been changed; synchronize
					if not (l_s.to_boolean) then
						l_pos := -1 + 48 -- skip if block
					end
				when 46 then -- if:
						l_pos := -1 + 52 -- goto enter
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 48 then -- else:
						if a_ev.item.x /= 256 then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						l_pos := -1 + 52 -- goto enter
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 51 then -- else:
						if a_ev.item.x /= 32 then
							l_pos := -1 + 53 -- skip if block
						end
				when 52 then -- if: | enter:
						select_menu (term, l_menu)
						update_class_fields -- Current might have been changed; synchronize
				when 53 then -- if done | if done | break2:
					l_pos := -1 + 55 -- switch 1; break
				when 54 then -- switch 1, case 5
					if ((l_menu.item.items).item.free_i).to_boolean then
						l_i___0 := 0
						from
						until
							((l_menu.item.items + l_i___0).item.text).is_void
						loop
							if (((l_menu.item.items + l_i___0).item.free_i).bit_and (2)).to_boolean then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 279, create {CE_VOID_POINTER}.make_cast ((l_menu.item.items + l_i___0).item.text))
								update_class_fields -- Current might have been changed; synchronize
							end
							if (((l_menu.item.items + l_i___0).item.free_i).bit_and (4)).to_boolean then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 280, create {CE_VOID_POINTER}.make_cast ((l_menu.item.items + l_i___0).item.rtext))
								update_class_fields -- Current might have been changed; synchronize
							end
							l_i___0 := l_i___0 + 1
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 282, create {CE_VOID_POINTER}.make_cast (l_menu.item.items))
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 55 -- switch 1; break
				when 55 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mainmenu_func (a_ev: CE_POINTER [PD_EVENT]; a_fwd: INTEGER_32)
		require
			not a_ev.is_void
		local
			l_s: INTEGER_32
			l_menu: CE_POINTER [PD_MAINMENU]
			l_i: INTEGER_32
			l_p: INTEGER_32
			l_o: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___2: NATURAL_8
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [PD_EVENT]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := 0
					l_menu := create {CE_CLASS_POINTER [PD_MAINMENU]}.make_cast (data)
					l_menu.item.win := (create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))
					update_class_fields -- Current might have been changed; synchronize
					inspect (a_ev.item.ev).to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 4 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 7
					when 5 then l_pos := -1 + 23
					else l_pos := -1 + 24
					end
				when 1 then -- switch 1, case 0 | switch 1, case 4 | switch 1, case 3
					display_mainmenu (term, l_menu)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 24 -- switch 1; break
				when 2 then -- switch 1, case 2
					if ((a_ev.item.b).bit_and (12)) /= 0 then
						l_pos := -1 + 5 -- skip if block
					end
				when 3 then -- if:
						if (a_ev.item.y).to_boolean then
							((create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))).item.delete_window_ev (a_ev)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if not (a_ev.item.y).to_boolean then
							l_p := 2
							l_i := 0
							from
							until
								not (not (l_break) and then (l_i < l_menu.item.ni))
							loop
								l_break := False
								l_o := l_p
								l_tmp := (create {P_LANGUAGE_STATIC}).get_text_translation ((l_menu.item.items + l_i).item.text, term)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp))
								update_class_fields -- Current might have been changed; synchronize
								l_p := (l_p.to_natural_32 + (l_tmp___0 + {NATURAL_32} 4)).to_integer_32
								if a_ev.item.x >= l_o.to_integer_32 then
									if a_ev.item.x < l_p.to_integer_32 then
										l_menu.item.selected := l_i
										update_class_fields -- Current might have been changed; synchronize
										display_mainmenu (term, l_menu)
										update_class_fields -- Current might have been changed; synchronize
										if ((a_ev.item.b).bit_and (12)) = 4 then
											select_mainmenu (term, l_menu)
											update_class_fields -- Current might have been changed; synchronize
										elseif ((l_menu.item.items + l_s).item.in_m).to_boolean then
											select_mainmenu (term, l_menu)
											update_class_fields -- Current might have been changed; synchronize
										end
										l_break := True
									end
								end
								if not (l_break) then
									l_i := l_i + 1
								end
							end
							l_break := False
						end
				when 6 then
					l_pos := -1 + 24 -- switch 1; break
				when 7 then -- switch 1, case 1
					if a_ev.item.x = 32 then
						select_mainmenu (term, l_menu)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 24 -- switch 1; break
					elseif a_ev.item.x = 256 then
						select_mainmenu (term, l_menu)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 24 -- switch 1; break
					elseif a_ev.item.x = 263 then
						select_mainmenu (term, l_menu)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 24 -- switch 1; break
					elseif a_ev.item.x = 262 then
						select_mainmenu (term, l_menu)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 24 -- switch 1; break
					elseif a_ev.item.x = 269 then
						select_mainmenu (term, l_menu)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 24 -- switch 1; break
					elseif a_ev.item.x = 268 then
						select_mainmenu (term, l_menu)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 24 -- switch 1; break
					end
				when 8 then
					if a_ev.item.x = 260 then
						l_tmp___1 := l_menu.item.selected
						l_menu.item.selected := (l_menu.item.selected) - 1
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___1.to_boolean then
							l_menu.item.selected := l_menu.item.ni - 1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_s := 1
					end
					if a_ev.item.x = 261 then
						l_menu.item.selected := (l_menu.item.selected) + 1
						update_class_fields -- Current might have been changed; synchronize
						if l_menu.item.selected >= l_menu.item.ni then
							l_menu.item.selected := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						l_s := 1
					end
					if a_ev.item.x = 266 then
						l_menu.item.selected := 0
						update_class_fields -- Current might have been changed; synchronize
						l_s := 1
					end
					if a_ev.item.x = 267 then
						l_menu.item.selected := l_menu.item.ni - 1
						update_class_fields -- Current might have been changed; synchronize
						l_s := 1
					end
					if a_ev.item.x /= 260 then
						l_pos := -1 + 11 -- skip if block
					end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if a_ev.item.x /= 261 then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L___0:
						if a_fwd.to_boolean then
							display_mainmenu (term, l_menu)
							update_class_fields -- Current might have been changed; synchronize
							select_mainmenu (term, l_menu)
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 24 -- switch 1; break
						end
				when 13 then -- if done
					if not (a_ev.item.x > 32) then
						l_pos := -1 + 16 -- skip if block
					end
				when 14 then -- if:
						if a_ev.item.x < 256 then
							l_s := 1
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_menu.item.ni)
							loop
								l_tmp___2 := (create {P_LINKS_STATIC}).upcase ((a_ev.item.x).to_natural_8)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___3 := (create {P_LANGUAGE_STATIC}).get_text_translation ((l_menu.item.items + l_i___0).item.hotkey, term)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___4 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___3), l_tmp___2.to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
								if (not l_tmp___4.is_void) then
									l_menu.item.selected := l_i___0
									update_class_fields -- Current might have been changed; synchronize
									l_s := 2
								end
								l_i___0 := l_i___0 + 1
							end
						else
							l_pos := -1 + 16 -- goto _L___2
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 16 then -- else: | _L___2:
						if l_s.to_boolean then
							l_pos := -1 + 22 -- skip if block
						end
				when 17 then -- if:
						if not (a_ev.item.x >= 288) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if a_ev.item.x <= 299 then
							l_tmp___5 := a_ev
						else
							l_pos := -1 + 20 -- goto _L___1
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else: | _L___1:
						if ((a_ev.item.y).bit_and (4)).to_boolean then
							l_tmp___5 := a_ev
						else
							l_tmp___5 := create {CE_CLASS_POINTER [PD_EVENT]}.make_shared (default_pointer)
						end
				when 21 then;
						((create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))).item.delete_window_ev (l_tmp___5)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 24 -- switch 1; break
				when 22 then -- if done
					display_mainmenu (term, l_menu)
					update_class_fields -- Current might have been changed; synchronize
					if l_s = 2 then
						select_mainmenu (term, l_menu)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 24 -- switch 1; break
				when 23 then -- switch 1, case 5
					l_pos := -1 + 24 -- switch 1; break
				when 24 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dialog_func (a_ev: CE_POINTER [PD_EVENT]; a_fwd: INTEGER_32)
		local
			l_i: INTEGER_32
			l_term: CE_POINTER [PD_TERMINAL]
			l_dlg: CE_POINTER [PD_DIALOG_DATA]
			l_di: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_tmp: INTEGER_32
			l_di___0: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: CE_POINTER [ANY]
			l_j: CE_POINTER [PD_HISTORY_ITEM]
			l_hi: CE_POINTER [PD_HISTORY_ITEM]
			l_tmp___2: NATURAL_32
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: NATURAL_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: NATURAL_32
			l_tmp___8: NATURAL_32
			l_tmp___9: NATURAL_32
			l_tmp___10: NATURAL_32
			l_tmp___11: NATURAL_32
			l_tmp___12: NATURAL_32
			l_clipboard: CE_POINTER [NATURAL_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: NATURAL_32
			l_tmp___15: NATURAL_32
			l_tmp___16: INTEGER_32
			l_tmp___17: NATURAL_32
			l_tmp___18: CE_POINTER [NATURAL_8]
			l_tmp___19: NATURAL_8
			l_tmp___20: NATURAL_8
			l_di___1: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_term := term
					l_dlg := create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_cast (data)
					l_dlg.item.win := (create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))
					update_class_fields -- Current might have been changed; synchronize
					if (not ((l_dlg.item.dlg).item.handle_event).is_void) then
						l_tmp := ((l_dlg.item.dlg).item.handle_event).integer_32_item ([l_dlg, a_ev])
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp = 0 then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 78 -- skip if block
					end
				when 1 then -- if:
						inspect (a_ev.item.ev).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 4 then l_pos := -1 + 11
						when 3 then l_pos := -1 + 11
						when 2 then l_pos := -1 + 12
						when 1 then l_pos := -1 + 13
						when 5 then l_pos := -1 + 76
						else l_pos := -1 + 77
						end
				when 2 then -- switch 1, case 0
						l_i := 0
				when 3 then -- loop condition:
						if not (not (l_return) and then (l_i < l_dlg.item.n)) then
							l_pos := -1 + 10 -- skip loop
						end
				when 4 then -- loop body:
						l_di___0 := create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (l_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (l_i))
						memset (create {CE_VOID_POINTER}.make_cast (l_di___0), 0, (create {PD_DIALOG_ITEM_DATA}.make).structure_size.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_di___0.item.item := create {CE_CLASS_POINTER [PD_DIALOG_ITEM]}.make_shared ((l_dlg.item.dlg).c_pointer + (create {PD_DIALOG}.make).offset_of ("items") + (create {PD_DIALOG_ITEM}.make).structure_size * (l_i))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 664, ((l_di___0.item.item).item.dlen).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_di___0.item.cdata := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0)
						update_class_fields -- Current might have been changed; synchronize
						memcpy (create {CE_VOID_POINTER}.make_cast (l_di___0.item.cdata), create {CE_VOID_POINTER}.make_cast ((l_di___0.item.item).item.data), ((l_di___0.item.item).item.dlen).to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if (l_di___0.item.item).item.type = 1 then
							if ((l_di___0.item.item).item.gid).to_boolean then
								if (create {CE_INTEGER_32_POINTER}.make_cast (l_di___0.item.cdata)).item = (l_di___0.item.item).item.gnum then
									l_di___0.item.checked := 1
									update_class_fields -- Current might have been changed; synchronize
								end
							elseif ((create {CE_INTEGER_32_POINTER}.make_cast (l_di___0.item.cdata)).item).to_boolean then
								l_di___0.item.checked := 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if (l_di___0.item.item).item.type = 5 then
							l_tmp___1 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 673, (create {PD_DLG_DATA_ITEM_DATA_BOX}.make).structure_size.to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_di___0.item.cdata := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).item.sel := -1
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).item.box_top := 0
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).item.list_len := -1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((create {CE_CLASS_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).c_pointer + (create {PD_DLG_DATA_ITEM_DATA_BOX}.make).offset_of ("items")))))
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).item.items.next := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((create {CE_CLASS_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).c_pointer + (create {PD_DLG_DATA_ITEM_DATA_BOX}.make).offset_of ("items"))))
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).item.items.prev := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((create {CE_CLASS_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).c_pointer + (create {PD_DLG_DATA_ITEM_DATA_BOX}.make).offset_of ("items"))))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((create {CE_CLASS_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).c_pointer + (create {PD_DLG_DATA_ITEM_DATA_BOX}.make).offset_of ("items")))))
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history")))))
						update_class_fields -- Current might have been changed; synchronize
						l_di___0.item.history.next := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history"))))
						update_class_fields -- Current might have been changed; synchronize
						l_di___0.item.history.prev := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history"))))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history")))))
						update_class_fields -- Current might have been changed; synchronize
						l_di___0.item.cur_hist := create {CE_CLASS_POINTER [PD_HISTORY_ITEM]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history"))))
						update_class_fields -- Current might have been changed; synchronize
						if (l_di___0.item.item).item.type /= 2 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if (l_di___0.item.item).item.type /= 3 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if (not ((l_di___0.item.item).item.history).is_void) then
							l_j := create {CE_CLASS_POINTER [PD_HISTORY_ITEM]}.make_cast (((l_di___0.item.item).item.history).item.items.next)
							from
							until
								not (not (l_return) and then (not l_j.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (((l_di___0.item.item).item.history).c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))))
							loop
								l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_j.item.d)))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___3 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 688, ((create {PD_HISTORY_ITEM}.make).structure_size.to_natural_32 + l_tmp___2) + {NATURAL_32} 1)
								update_class_fields -- Current might have been changed; synchronize
								l_hi := create {CE_CLASS_POINTER [PD_HISTORY_ITEM]}.make_cast (l_tmp___3)
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_hi.item.d)), create {CE_INTEGER_8_POINTER}.make_cast ((l_j.item.d))).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								from
								until
									(l_break)
								loop
									l_break := False;
									(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history")))))
									update_class_fields -- Current might have been changed; synchronize
									l_hi.item.next := (create {CE_CLASS_POINTER [PD_HISTORY_ITEM]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history"))))).item.next
									update_class_fields -- Current might have been changed; synchronize
									l_hi.item.prev := create {CE_CLASS_POINTER [PD_HISTORY_ITEM]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history"))))
									update_class_fields; -- Current might have been changed; synchronize
									(create {CE_CLASS_POINTER [PD_HISTORY_ITEM]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history"))))).item.next := l_hi
									update_class_fields; -- Current might have been changed; synchronize
									(l_hi.item.next).item.prev := l_hi
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history")))))
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
								l_break := False
								l_j := l_j.item.next
							end
						end
						l_tmp___4 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_di___0.item.cdata))
						update_class_fields -- Current might have been changed; synchronize
						l_di___0.item.cpos := l_tmp___4.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
				when 9 then -- if done
						l_i := l_i + 1
						l_pos := -1 + 3 -- back to loop condition
				when 10 then -- loop done
						l_dlg.item.selected := 0
						update_class_fields -- Current might have been changed; synchronize
				when 11 then -- switch 1, case 4 | switch 1, case 3;
						((l_dlg.item.dlg).item.fn).call ([l_dlg])
						update_class_fields -- Current might have been changed; synchronize
						l_dlg.item.redraw_dialog
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 77 -- switch 1; break
				when 12 then -- switch 1, case 2
						l_i := 0
						from
						until
							not (not (l_break) and then (l_i < l_dlg.item.n))
						loop
							l_break := False
							l_tmp___5 := dlg_mouse (l_dlg, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (l_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (l_i)), a_ev)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___5.to_boolean then
								l_break := True
							end
							if not (l_return or l_break) then
								l_i := l_i + 1
							end
						end
						l_break := False
						l_pos := -1 + 77 -- switch 1; break
				when 13 then -- switch 1, case 1
						l_di := create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (l_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (l_dlg.item.selected))
						if (l_di.item.item).item.type /= 2 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 16 then -- else:
						if (l_di.item.item).item.type /= 3 then
							l_pos := -1 + 37 -- skip if block
						end
				when 17 then -- if: | _L___0:
						l_tmp___6 := a_ev.item.kbd_action (1)
						update_class_fields -- Current might have been changed; synchronize
						inspect l_tmp___6 -- switch 2 head
						when 45 then l_pos := -1 + 18
						when 9 then l_pos := -1 + 20
						when 35 then l_pos := -1 + 22
						when 23 then l_pos := -1 + 23
						when 20 then l_pos := -1 + 24
						when 11 then l_pos := -1 + 25
						when 3 then l_pos := -1 + 26
						when 7 then l_pos := -1 + 27
						when 21 then l_pos := -1 + 28
						when 22 then l_pos := -1 + 29
						when 5 then l_pos := -1 + 30
						when 6 then l_pos := -1 + 31
						when 30 then l_pos := -1 + 32
						when 1 then l_pos := -1 + 33
						else l_pos := -1 + 34
						end
				when 18 then -- switch 2, case 45
						if not ((l_di.item.cur_hist).item.prev).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history"))) then
							l_di.item.cur_hist := (l_di.item.cur_hist).item.prev
							update_class_fields -- Current might have been changed; synchronize
							dlg_set_history (l_di)
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 36 -- goto dsp_f
						end
				when 19 then
						l_pos := -1 + 35 -- switch 2; break
				when 20 then -- switch 2, case 9
						if not (l_di.item.cur_hist).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history"))) then
							l_di.item.cur_hist := (l_di.item.cur_hist).item.next
							update_class_fields -- Current might have been changed; synchronize
							dlg_set_history (l_di)
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 36 -- goto dsp_f
						end
				when 21 then
						l_pos := -1 + 35 -- switch 2; break
				when 22 then -- switch 2, case 35
						l_tmp___7 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_di.item.cdata))
						update_class_fields -- Current might have been changed; synchronize
						if (l_di.item.cpos).to_natural_32 < l_tmp___7 then
							l_di.item.cpos := (l_di.item.cpos) + 1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 36 -- goto dsp_f
				when 23 then -- switch 2, case 23
						if l_di.item.cpos > 0 then
							l_di.item.cpos := (l_di.item.cpos) - 1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 36 -- goto dsp_f
				when 24 then -- switch 2, case 20
						l_di.item.cpos := 0
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 36 -- goto dsp_f
				when 25 then -- switch 2, case 11
						l_tmp___8 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_di.item.cdata))
						update_class_fields -- Current might have been changed; synchronize
						l_di.item.cpos := l_tmp___8.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 36 -- goto dsp_f
				when 26 then -- switch 2, case 3
						if (l_di.item.cpos).to_boolean then
							l_tmp___9 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_di.item.cdata))
							update_class_fields -- Current might have been changed; synchronize
							memmove (create {CE_VOID_POINTER}.make_cast (((l_di.item.cdata + l_di.item.cpos) - 1)), create {CE_VOID_POINTER}.make_cast ((l_di.item.cdata + l_di.item.cpos)), (l_tmp___9 - (l_di.item.cpos).to_natural_32) + {NATURAL_32} 1).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_di.item.cpos := (l_di.item.cpos) - 1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 36 -- goto dsp_f
				when 27 then -- switch 2, case 7
						l_tmp___11 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_di.item.cdata))
						update_class_fields -- Current might have been changed; synchronize
						if (l_di.item.cpos).to_natural_32 < l_tmp___11 then
							l_tmp___10 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_di.item.cdata))
							update_class_fields -- Current might have been changed; synchronize
							memmove (create {CE_VOID_POINTER}.make_cast ((l_di.item.cdata + l_di.item.cpos)), create {CE_VOID_POINTER}.make_cast (((l_di.item.cdata + l_di.item.cpos) + 1)), (l_tmp___10 - (l_di.item.cpos).to_natural_32) + {NATURAL_32} 1).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 36 -- goto dsp_f
				when 28 then -- switch 2, case 21
						l_tmp___12 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_di.item.cdata + l_di.item.cpos)))
						update_class_fields -- Current might have been changed; synchronize
						memmove (create {CE_VOID_POINTER}.make_cast (l_di.item.cdata), create {CE_VOID_POINTER}.make_cast ((l_di.item.cdata + l_di.item.cpos)), l_tmp___12 + {NATURAL_32} 1).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_di.item.cpos := 0
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 36 -- goto dsp_f
				when 29 then -- switch 2, case 22
						l_di.item.cdata[l_di.item.cpos] := (0).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 36 -- goto dsp_f
				when 30 then -- switch 2, case 5;
						(create {P_OS_DEP_STATIC}).set_clipboard_text (create {CE_INTEGER_8_POINTER}.make_cast (l_di.item.cdata))
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 35 -- switch 2; break
				when 31 then -- switch 2, case 6;
						(create {P_OS_DEP_STATIC}).set_clipboard_text (create {CE_INTEGER_8_POINTER}.make_cast (l_di.item.cdata))
						update_class_fields -- Current might have been changed; synchronize
						l_di.item.cdata[0] := (0).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_di.item.cpos := 0
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 36 -- goto dsp_f
				when 32 then -- switch 2, case 30
						l_tmp___13 := (create {P_OS_DEP_STATIC}).get_clipboard_text
						update_class_fields -- Current might have been changed; synchronize
						l_clipboard := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___13)
						if (not l_clipboard.is_void) then
							strncpy (create {CE_INTEGER_8_POINTER}.make_cast (l_di.item.cdata), create {CE_INTEGER_8_POINTER}.make_cast (l_clipboard), ((l_di.item.item).item.dlen).to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_di.item.cdata[((l_di.item.item).item.dlen - 1)] := (0).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___14 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_di.item.cdata))
							update_class_fields -- Current might have been changed; synchronize
							l_di.item.cpos := l_tmp___14.to_integer_32
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 769, create {CE_VOID_POINTER}.make_cast (l_clipboard))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 36 -- goto dsp_f
				when 33 then -- switch 2, case 1
						do_tab_compl (l_term, create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history")), (create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer)))
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 36 -- goto dsp_f
				when 34 then -- switch 2, default:
						if a_ev.item.x >= 32 then
							if a_ev.item.x < 256 then
								if not (a_ev.item.y).to_boolean then
									l_tmp___17 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_di.item.cdata))
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___17 + {NATURAL_32} 1 < ((l_di.item.item).item.dlen).to_natural_32 then
										l_tmp___15 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_di.item.cdata))
										update_class_fields -- Current might have been changed; synchronize
										memmove (create {CE_VOID_POINTER}.make_cast (((l_di.item.cdata + l_di.item.cpos) + 1)), create {CE_VOID_POINTER}.make_cast ((l_di.item.cdata + l_di.item.cpos)), (l_tmp___15 - (l_di.item.cpos).to_natural_32) + {NATURAL_32} 1).do_nothing
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___16 := l_di.item.cpos
										l_di.item.cpos := (l_di.item.cpos) + 1
										update_class_fields -- Current might have been changed; synchronize
										l_di.item.cdata[l_tmp___16] := (a_ev.item.x).to_natural_8
										update_class_fields -- Current might have been changed; synchronize
									end
									l_pos := -1 + 36 -- goto dsp_f
								end
							end
						end
				when 35 then -- switch 2, done:
						l_pos := -1 + 41 -- goto gh
				when 36 then -- dsp_f:
						l_dlg.item.display_dlg_item (l_di, 1)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_TERMINAL_STATIC}).redraw_from_window (l_dlg.item.win)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 77 -- switch 1; break
				when 37 then -- if done
						if a_ev.item.x /= 256 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if (l_di.item.item).item.type = 4 then
							dlg_select_item (l_dlg, l_di)
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 77 -- switch 1; break
						else
							l_pos := -1 + 40 -- goto _L___1
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else: | _L___1:
						if a_ev.item.x = 32 then
							dlg_select_item (l_dlg, l_di)
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 77 -- switch 1; break
						end
				when 41 then -- gh:
						if not (a_ev.item.x > 32) then
							l_pos := -1 + 49 -- skip if block
						end
				when 42 then -- if:
						if not (a_ev.item.x < 256) then
							l_pos := -1 + 49 -- skip if block
						end
				when 43 then -- if:
						l_i := 0
				when 44 then -- loop condition:
						if not (l_i < l_dlg.item.n) then
							l_pos := -1 + 49 -- skip loop
						end
				when 45 then -- loop body:
						if (l_dlg.item.dlg).item.items[l_i].type /= 4 then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						l_tmp___18 := (create {P_LANGUAGE_STATIC}).get_text_translation ((l_dlg.item.dlg).item.items[l_i].text, l_term)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___19 := (create {P_LINKS_STATIC}).upcase (l_tmp___18[0])
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___20 := (create {P_LINKS_STATIC}).upcase ((a_ev.item.x).to_natural_8)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___19.to_integer_32 /= l_tmp___20.to_integer_32 then
							l_pos := -1 + 48 -- skip if block
						end
				when 47 then -- if: | sel:
						if l_dlg.item.selected /= l_i then
							l_dlg.item.display_dlg_item (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (l_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (l_dlg.item.selected)), 0)
							update_class_fields -- Current might have been changed; synchronize
							l_dlg.item.display_dlg_item (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (l_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (l_i)), 1)
							update_class_fields -- Current might have been changed; synchronize
							l_dlg.item.selected := l_i
							update_class_fields -- Current might have been changed; synchronize
						end
						dlg_select_item (l_dlg, create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (l_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (l_i)))
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 77 -- goto bla
				when 48 then -- if done
						l_i := l_i + 1
						l_pos := -1 + 44 -- back to loop condition
				when 49 then -- loop done | if done | if done
						if a_ev.item.x /= 256 then
							l_pos := -1 + 54 -- skip if block
						end
				when 50 then -- if:
						l_i := 0
				when 51 then -- loop condition:
						if not (l_i < l_dlg.item.n) then
							l_pos := -1 + 54 -- skip loop
						end
				when 52 then -- loop body:
						if (l_dlg.item.dlg).item.items[l_i].type = 4 then
							if (((l_dlg.item.dlg).item.items[l_i].gid).bit_and (1)).to_boolean then
								l_pos := -1 + 47 -- goto sel
							end
						end
				when 53 then
						l_i := l_i + 1
						l_pos := -1 + 51 -- back to loop condition
				when 54 then -- loop done | if done
						if a_ev.item.x /= 259 then
							l_pos := -1 + 59 -- skip if block
						end
				when 55 then -- if:
						l_i := 0
				when 56 then -- loop condition:
						if not (l_i < l_dlg.item.n) then
							l_pos := -1 + 59 -- skip loop
						end
				when 57 then -- loop body:
						if (l_dlg.item.dlg).item.items[l_i].type = 4 then
							if (((l_dlg.item.dlg).item.items[l_i].gid).bit_and (2)).to_boolean then
								l_pos := -1 + 47 -- goto sel
							end
						end
				when 58 then
						l_i := l_i + 1
						l_pos := -1 + 56 -- back to loop condition
				when 59 then -- loop done | if done
						if a_ev.item.x /= 258 then
							l_pos := -1 + 62 -- skip if block
						end
				when 60 then -- if:
						if not (a_ev.item.y).to_boolean then
							l_pos := -1 + 66 -- goto _L___2
						else
							l_pos := -1 + 62 -- goto _L___3
						end
				when 61 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 62 then -- else: | _L___3:
						if a_ev.item.x /= 263 then
							l_pos := -1 + 65 -- skip if block
						end
				when 63 then -- if:
						l_pos := -1 + 66 -- goto _L___2
				when 64 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 65 then -- else:
						if a_ev.item.x /= 261 then
							l_pos := -1 + 67 -- skip if block
						end
				when 66 then -- if: | _L___2:
						l_dlg.item.display_dlg_item (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (l_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (l_dlg.item.selected)), 0)
						update_class_fields -- Current might have been changed; synchronize
						l_dlg.item.selected := (l_dlg.item.selected) + 1
						update_class_fields -- Current might have been changed; synchronize
						if l_dlg.item.selected >= l_dlg.item.n then
							l_dlg.item.selected := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						l_dlg.item.display_dlg_item (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (l_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (l_dlg.item.selected)), 1)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_TERMINAL_STATIC}).redraw_from_window (l_dlg.item.win)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 77 -- switch 1; break
				when 67 then -- if done | if done
						if a_ev.item.x /= 258 then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						if (a_ev.item.y).to_boolean then
							l_pos := -1 + 74 -- goto _L___4
						else
							l_pos := -1 + 70 -- goto _L___5
						end
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 70 then -- else: | _L___5:
						if a_ev.item.x /= 262 then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if:
						l_pos := -1 + 74 -- goto _L___4
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 73 then -- else:
						if a_ev.item.x /= 260 then
							l_pos := -1 + 75 -- skip if block
						end
				when 74 then -- if: | _L___4:
						l_dlg.item.display_dlg_item (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (l_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (l_dlg.item.selected)), 0)
						update_class_fields -- Current might have been changed; synchronize
						l_dlg.item.selected := (l_dlg.item.selected) - 1
						update_class_fields -- Current might have been changed; synchronize
						if l_dlg.item.selected < 0 then
							l_dlg.item.selected := l_dlg.item.n - 1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_dlg.item.display_dlg_item (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (l_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (l_dlg.item.selected)), 1)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_TERMINAL_STATIC}).redraw_from_window (l_dlg.item.win)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 77 -- switch 1; break
				when 75 then -- if done | if done
						l_pos := -1 + 77 -- switch 1; break
				when 76 then -- switch 1, case 5
						if (not ((l_dlg.item.dlg).item.abort).is_void) then
							((l_dlg.item.dlg).item.abort).call ([l_dlg])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_dlg.item.n))
						loop
							l_di___1 := create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (l_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (l_i))
							if (not (l_di___1.item.cdata).is_void) then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 832, create {CE_VOID_POINTER}.make_cast (l_di___1.item.cdata))
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di___1.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history")))))
							update_class_fields -- Current might have been changed; synchronize
							l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (l_di___1.item.history.next)
							from
							until
								l_a__.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di___1.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history")))
							loop
								(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
								update_class_fields -- Current might have been changed; synchronize
								l_a__ := l_a__.item.next
							end
							l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (l_di___1.item.history.prev)
							from
							until
								l_a__.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di___1.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history")))
							loop
								(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
								update_class_fields -- Current might have been changed; synchronize
								l_a__ := l_a__.item.prev
							end
							from
							until
								(l_di___1.item.history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di___1.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history")))
							loop
								l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (l_di___1.item.history.next);
								(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
								update_class_fields; -- Current might have been changed; synchronize
								(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev)
								update_class_fields; -- Current might have been changed; synchronize
								(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 833, create {CE_VOID_POINTER}.make_cast (l_a__))
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_di___1.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history")))))
							update_class_fields -- Current might have been changed; synchronize
							l_i := l_i + 1
						end
						(create {P_BFU_STATIC}).freeml (l_dlg.item.ml)
						update_class_fields -- Current might have been changed; synchronize
				when 77 then -- switch 1, done: | bla:
						
				when 78 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	create_session: CE_POINTER [PD_SESSION]
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_ses: CE_POINTER [PD_SESSION]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_term := term
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_189, (create {PD_SESSION}.make).structure_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_ses := create {CE_CLASS_POINTER [PD_SESSION]}.make_cast (l_tmp)
			memset (create {CE_VOID_POINTER}.make_cast (l_ses), 0, (create {PD_SESSION}.make).structure_size.to_natural_32).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("history")))))
			update_class_fields -- Current might have been changed; synchronize
			l_ses.item.history.next := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("history"))))
			update_class_fields -- Current might have been changed; synchronize
			l_ses.item.history.prev := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("history"))))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("history")))))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))))
			update_class_fields -- Current might have been changed; synchronize
			l_ses.item.scrn_frames.next := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames"))))
			update_class_fields -- Current might have been changed; synchronize
			l_ses.item.scrn_frames.prev := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames"))))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("more_files")))))
			update_class_fields -- Current might have been changed; synchronize
			l_ses.item.more_files.next := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("more_files"))))
			update_class_fields -- Current might have been changed; synchronize
			l_ses.item.more_files.prev := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("more_files"))))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("more_files")))))
			update_class_fields -- Current might have been changed; synchronize
			l_ses.item.term := l_term
			update_class_fields -- Current might have been changed; synchronize
			l_ses.item.win := (create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := session_id.item
			session_id.item := session_id.item + 1
			l_ses.item.id := l_tmp___0
			update_class_fields -- Current might have been changed; synchronize
			l_ses.item.screen := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_ses.item.wtd := 0
			update_class_fields -- Current might have been changed; synchronize
			l_ses.item.display_timer := -1
			update_class_fields -- Current might have been changed; synchronize
			l_ses.item.loading_url := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_ses.item.goto_position := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_DOCUMENT_SETUP]}.make_shared (l_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("ds")))), create {CE_VOID_POINTER}.make_cast (((create {P_DEFAULT_STATIC}).dds.item)), (create {PD_DOCUMENT_SETUP}.make).structure_size.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_SESSION_STATIC}).sessions.item)))
				update_class_fields -- Current might have been changed; synchronize
				l_ses.item.next := (create {CE_CLASS_POINTER [PD_SESSION]}.make_cast (((create {P_SESSION_STATIC}).sessions.item))).item.next
				update_class_fields -- Current might have been changed; synchronize
				l_ses.item.prev := create {CE_CLASS_POINTER [PD_SESSION]}.make_cast (((create {P_SESSION_STATIC}).sessions.item))
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_SESSION]}.make_cast (((create {P_SESSION_STATIC}).sessions.item))).item.next := l_ses
				update_class_fields; -- Current might have been changed; synchronize
				(l_ses.item.next).item.prev := l_ses
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_SESSION_STATIC}).sessions.item)))
				update_class_fields -- Current might have been changed; synchronize
				l_break := True
			end
			l_break := False
			if ((create {P_DEFAULT_STATIC}).first_use.item.item).to_boolean then
				(create {P_DEFAULT_STATIC}).first_use.item.item := 0
				update_class_fields -- Current might have been changed; synchronize
				l_term.item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 187, 129, (create {P_LINKS_STATIC}).dummyarray.item + 188, ce_string ("%N%N"), (create {P_LINKS_STATIC}).dummyarray.item + 189, create {CE_VOID_POINTER}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 14, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l_ses
		end

	win_func (a_ev: CE_POINTER [PD_EVENT]; a_fw: INTEGER_32)
		require
			not a_ev.is_void
		local
			l_ses: CE_POINTER [PD_SESSION]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [PD_SESSION]
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ses := create {CE_CLASS_POINTER [PD_SESSION]}.make_cast (data)
					inspect (a_ev.item.ev).to_integer_32 -- switch 1 head
					when 5 then l_pos := -1 + 1
					when 0 then l_pos := -1 + 2
					when 4 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					when 1 then l_pos := -1 + 5
					when 2 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 5
					if (not l_ses.is_void) then
						destroy_session (l_ses)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 7 -- switch 1; break
				when 2 then -- switch 1, case 0
					l_tmp___0 := ((create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))).item.create_session
					update_class_fields -- Current might have been changed; synchronize
					l_tmp := create {CE_VOID_POINTER}.make_cast (l_tmp___0)
					Current.data := l_tmp
					update_class_fields -- Current might have been changed; synchronize
					l_ses := create {CE_CLASS_POINTER [PD_SESSION]}.make_cast (l_tmp)
					if (not l_ses.is_void) then
						l_tmp___1 := read_session_info (term.item.fdin, l_ses, create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_shared (default_pointer + a_ev.item.b) + ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32)), (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer + a_ev.item.b)).item)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1.to_boolean then
							(create {P_SELECT_STATIC}).register_bottom_half (((create {PD_TERMINAL_STATIC}).destroy_terminal_address), create {CE_VOID_POINTER}.make_cast (term)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					else
						(create {P_SELECT_STATIC}).register_bottom_half (((create {PD_TERMINAL_STATIC}).destroy_terminal_address), create {CE_VOID_POINTER}.make_cast (term)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
				when 3 then -- switch 1, case 4
					if not l_return then
						l_ses.item.html_interpret
						update_class_fields -- Current might have been changed; synchronize
						l_ses.item.draw_formatted
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SESSION_STATIC}).load_frames (l_ses, l_ses.item.screen)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SESSION_STATIC}).process_file_requests (l_ses)
						update_class_fields -- Current might have been changed; synchronize
						l_ses.item.print_screen_status
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 3
					l_ses.item.draw_formatted
					update_class_fields -- Current might have been changed; synchronize
					l_ses.item.print_screen_status
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 1 | switch 1, case 2;
					(create {P_VIEW_STATIC}).send_event (l_ses, a_ev)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:;
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: unknown event"))])
					update_class_fields -- Current might have been changed; synchronize
				when 7 then -- switch 1, done:
					if not l_return then
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	delete_window
		local
			l_ev: CE_ARRAY [PD_EVENT]
		do
			create {CE_CLASS_ARRAY [PD_EVENT]} l_ev.make (<<1>>)

			l_ev.item.ev := 5
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.x := 0
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.y := 0
			update_class_fields -- Current might have been changed; synchronize
			l_ev.item.b := 0
			update_class_fields -- Current might have been changed; synchronize
			handler.call ([(create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer)), l_ev, 1])
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (next)).item.prev := create {CE_VOID_POINTER}.make_cast (prev)
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (prev)).item.next := create {CE_VOID_POINTER}.make_cast (next)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
			if (not data.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 187, data)
				update_class_fields -- Current might have been changed; synchronize
			end
			redraw_terminal (term)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 189, create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	delete_window_ev (a_ev: CE_POINTER [PD_EVENT])
		local
			l_w: CE_POINTER [PD_WINDOW]
		do
			l_w := next
			if l_w.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))) then
				l_w := create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (default_pointer)
			end
			((create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))).item.delete_window
			update_class_fields -- Current might have been changed; synchronize
			if (not a_ev.is_void) then
				if (not l_w.is_void) then
					if not (l_w.item.next).is_equal (l_w) then
						(l_w.item.handler).call ([l_w, a_ev, 1])
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
		end

	set_window_ptr (a_x, a_y: INTEGER_32)
		do
			Current.xp := a_x
			update_class_fields -- Current might have been changed; synchronize
			Current.yp := a_y
			update_class_fields -- Current might have been changed; synchronize
		end

	get_parent_ptr (a_x, a_y: CE_POINTER [INTEGER_32])
		require
			not a_x.is_void
			not a_y.is_void
		local
			l_tmp: INTEGER_32
		do
			if not next.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))) then
				a_x.item := next.item.xp
				update_class_fields -- Current might have been changed; synchronize
				a_y.item := next.item.yp
				update_class_fields -- Current might have been changed; synchronize
			else
				l_tmp := 0
				a_y.item := l_tmp
				update_class_fields -- Current might have been changed; synchronize
				a_x.item := l_tmp
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	empty_window_handler (a_ev: CE_POINTER [PD_EVENT]; a_fwd: INTEGER_32)
		local
			l_n: CE_POINTER [PD_WINDOW]
			l_ewd: CE_POINTER [PD_EWD]
			l_x: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_fn: CE_ROUTINE
			l_data: CE_POINTER [ANY]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_x.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ewd := create {CE_CLASS_POINTER [PD_EWD]}.make_cast (data)
					l_fn := l_ewd.item.fn
					l_data := l_ewd.item.data
					if (l_ewd.item.b).to_boolean then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						inspect (a_ev.item.ev).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 4 then l_pos := -1 + 2
						when 3 then l_pos := -1 + 2
						when 5 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 2 then -- switch 1, case 0 | switch 1, case 4 | switch 1, case 3;
						((create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))).item.get_parent_ptr (l_x, l_y)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))).item.set_window_ptr (l_x.item, l_y.item)
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
				when 3 then -- switch 1, case 5
						if not l_return then
							l_fn.call ([l_data])
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
				when 4 then -- switch 1, done: | if done
					if not l_return then
						l_ewd.item.b := 1
						update_class_fields -- Current might have been changed; synchronize
						l_n := next;
						((create {CE_CLASS_POINTER [PD_WINDOW]}.make_shared (c_pointer))).item.delete_window
						update_class_fields -- Current might have been changed; synchronize
						l_fn.call ([l_data])
						update_class_fields -- Current might have been changed; synchronize
						if not (l_n.item.next).is_equal (l_n) then
							(l_n.item.handler).call ([l_n, a_ev, a_fwd])
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {PD_WINDOW_STATIC} -- private routines

	select_menu (a_term: CE_POINTER [PD_TERMINAL]; a_menu: CE_POINTER [PD_MENU])
		require
			not a_menu.is_void
		local
			l_it: CE_POINTER [PD_MENU_ITEM]
			l_func: CE_ROUTINE
			l_data1: CE_POINTER [ANY]
			l_data2: CE_POINTER [ANY]
			l_win: CE_POINTER [PD_WINDOW]
			l_win1: CE_POINTER [PD_WINDOW]
			l_return, l_break: BOOLEAN
		do
			l_it := a_menu.item.items + a_menu.item.selected
			l_func := l_it.item.func
			l_data1 := l_it.item.data
			l_data2 := a_menu.item.data
			if a_menu.item.selected < 0 then
				l_return := True
			elseif a_menu.item.selected >= a_menu.item.ni then
				l_return := True
			elseif (l_it.item.hotkey).is_equal ((create {P_BFU_STATIC}).m_bar.item) then
				l_return := True
			end
			if not l_return then
				if not (l_it.item.in_m).to_boolean then
					l_win := create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast (a_term.item.windows.next)
					from
					until
						(l_break)
					loop
						l_break := False
						if not l_win.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))) then
							if not ((l_win.item.handler).is_equal (menu_func_address)) then
								if not ((l_win.item.handler).is_equal (mainmenu_func_address)) then
									l_break := True
								end
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_win1 := l_win.item.next
							l_win.item.delete_window
							l_win := l_win1
						end
					end
					l_break := False
				end
				l_func.call ([a_term, l_data1, l_data2])
			end
		end

	count_menu_size (a_term: CE_POINTER [PD_TERMINAL]; a_menu: CE_POINTER [PD_MENU])
		require
			not a_term.is_void
			not a_menu.is_void
		local
			l_sx: INTEGER_32
			l_sy: INTEGER_32
			l_mx: INTEGER_32
			l_my: INTEGER_32
			l_s: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
		do
			l_sx := a_term.item.x
			l_sy := a_term.item.y
			l_mx := 4
			l_my := 0
			from
			until
				((a_menu.item.items + l_my).item.text).is_void
			loop
				l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LANGUAGE_STATIC}).get_text_translation ((a_menu.item.items + l_my).item.text, a_term))))
				l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LANGUAGE_STATIC}).get_text_translation ((a_menu.item.items + l_my).item.rtext, a_term))))
				l_s := (((l_tmp___0 + l_tmp___2) + (2 * ((((create {P_LANGUAGE_STATIC}).get_text_translation ((a_menu.item.items + l_my).item.rtext, a_term))[0]).to_integer_32 /= 0).to_integer).to_natural_32) + {NATURAL_32} 4).to_integer_32
				if l_s > l_mx then
					l_mx := l_s
				end
				l_my := l_my + 1
			end
			a_menu.item.ni := l_my
			l_my := l_my + (2)
			if l_mx > l_sx then
				l_mx := l_sx
			end
			if l_my > l_sy then
				l_my := l_sy
			end
			a_menu.item.xw := l_mx
			a_menu.item.yw := l_my
			l_tmp___4 := a_menu.item.xp
			a_menu.item.x := l_tmp___4
			if l_tmp___4 < 0 then
				a_menu.item.x := 0
			end
			l_tmp___5 := a_menu.item.yp
			a_menu.item.y := l_tmp___5
			if l_tmp___5 < 0 then
				a_menu.item.y := 0
			end
			if a_menu.item.x + l_mx > l_sx then
				a_menu.item.x := l_sx - l_mx
			end
			if a_menu.item.y + l_my > l_sy then
				a_menu.item.y := l_sy - l_my
			end
		end

	scroll_menu (a_menu: CE_POINTER [PD_MENU]; a_d: INTEGER_32)
		require
			not a_menu.is_void
		local
			l_c: INTEGER_32
			l_w: INTEGER_32
			l_scr_i: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_c := 0
			l_w := a_menu.item.yw - 2
			if 2 > (l_w - 1) // 2 then
				l_tmp := (l_w - 1) // 2
			else
				l_tmp := 2
			end
			l_scr_i := l_tmp
			if l_scr_i < 0 then
				l_scr_i := 0
			end
			if l_w < 0 then
				l_w := 0
			end
			a_menu.item.selected := a_menu.item.selected + a_d
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_tmp___0 := l_c
				l_c := l_c + 1
				if l_tmp___0 > a_menu.item.ni then
					a_menu.item.selected := -1
					a_menu.item.view := 0
					l_return := True
				end
				if not l_return then
					if a_menu.item.selected < 0 then
						a_menu.item.selected := 0
					end
					if a_menu.item.selected >= a_menu.item.ni then
						a_menu.item.selected := a_menu.item.ni - 1
					end
					if (a_menu.item.ni).to_boolean then
						if not ((a_menu.item.items + a_menu.item.selected).item.hotkey).is_equal ((create {P_BFU_STATIC}).m_bar.item) then
							l_break := True
						end
					end
					if not (l_return or l_break) then
						a_menu.item.selected := a_menu.item.selected + a_d
					end
				end
			end
			if not l_return then
				l_break := False
				if a_menu.item.selected < a_menu.item.view + l_scr_i then
					a_menu.item.view := a_menu.item.selected - l_scr_i
				end
				if a_menu.item.selected >= ((a_menu.item.view + l_w) - l_scr_i) - 1 then
					a_menu.item.view := ((a_menu.item.selected - l_w) + l_scr_i) + 1
				end
				if a_menu.item.view > a_menu.item.ni - l_w then
					a_menu.item.view := a_menu.item.ni - l_w
				end
				if a_menu.item.view < 0 then
					a_menu.item.view := 0
				end
			end
		end

	display_menu (a_term: CE_POINTER [PD_TERMINAL]; a_menu: CE_POINTER [PD_MENU])
		require
			not a_term.is_void
			not a_menu.is_void
		local
			l_p: INTEGER_32
			l_s: INTEGER_32
			l_x: INTEGER_32
			l_h: INTEGER_32
			l_c: NATURAL_8
			l_tmptext: CE_POINTER [NATURAL_8]
			l_co: INTEGER_32
			l_tmp___0: INTEGER_32
			l_l: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: NATURAL_8
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_term.item.fill_area (a_menu.item.x + 1, a_menu.item.y + 1, a_menu.item.xw - 2, a_menu.item.yw - 2, {NATURAL_32} 14_336)
					a_term.item.draw_frame (a_menu.item.x, a_menu.item.y, a_menu.item.xw, a_menu.item.yw, {NATURAL_32} 14_336, 1)
					l_p := a_menu.item.view
					l_s := a_menu.item.y + 1
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if l_p < a_menu.item.ni then
							if not (l_p < (a_menu.item.view + a_menu.item.yw) - 2) then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 14 -- skip if block
						end
				when 3 then -- if:
						l_h := 0
						l_tmptext := ((create {P_LANGUAGE_STATIC}).get_text_translation ((a_menu.item.items + l_p).item.text, a_term))
						if l_p = a_menu.item.selected then
							l_h := 1
							l_tmp___0 := 1_792
						else
							l_tmp___0 := 14_336
						end
						l_co := l_tmp___0
						if l_h.to_boolean then
							a_term.item.set_cursor (a_menu.item.x + 1, l_s, a_term.item.x - 1, a_term.item.y - 1);
							(a_menu.item.win).item.set_window_ptr (a_menu.item.x + a_menu.item.xw, l_s)
							a_term.item.fill_area (a_menu.item.x + 1, l_s, a_menu.item.xw - 2, 1, l_co.to_natural_32)
						end
						if ((a_menu.item.items + l_p).item.hotkey).is_equal ((create {P_BFU_STATIC}).m_bar.item) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if l_tmptext.is_void then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if not ((l_tmptext[0]).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LANGUAGE_STATIC}).get_text_translation ((a_menu.item.items + l_p).item.rtext, a_term))))).to_integer_32
						l_x := l_l - 1
						from
						until
							(l_break)
						loop
							l_break := False
							if l_x >= 0 then
								if a_menu.item.xw - 4 >= l_l - l_x then
									l_c := ((create {P_LANGUAGE_STATIC}).get_text_translation ((a_menu.item.items + l_p).item.rtext, a_term))[l_x]
									if not l_c.to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								a_term.item.set_char ((((a_menu.item.x + a_menu.item.xw) - 2) - l_l) + l_x, l_s, ((l_c.to_integer_32).bit_or (l_co)).to_natural_32)
								l_x := l_x - 1
							end
						end
						l_break := False
						l_x := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if l_x < a_menu.item.xw - 4 then
								l_c := l_tmptext[l_x]
								if not l_c.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								if not l_h.to_boolean then
									l_tmp___8 := (create {P_LINKS_STATIC}).upcase (l_c)
									if (not (strchr (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LANGUAGE_STATIC}).get_text_translation ((a_menu.item.items + l_p).item.hotkey, a_term))), l_tmp___8.to_integer_32)).is_void) then
										l_h := 1
										l_tmp___7 := (1_792).bit_or (l_c.to_integer_32)
									else
										l_tmp___7 := (l_co).bit_or (l_c.to_integer_32)
									end
								else
									l_tmp___7 := (l_co).bit_or (l_c.to_integer_32)
								end
								a_term.item.set_char ((a_menu.item.x + l_x) + 2, l_s, l_tmp___7.to_natural_32)
								l_x := l_x + 1
							end
						end
						l_break := False
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						a_term.item.set_char (a_menu.item.x, l_s, {NATURAL_32} 47_299)
						a_term.item.fill_area (a_menu.item.x + 1, l_s, a_menu.item.xw - 2, 1, {NATURAL_32} 47_300)
						a_term.item.set_char ((a_menu.item.x + a_menu.item.xw) - 1, l_s, {NATURAL_32} 47_284)
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						a_term.item.set_char (a_menu.item.x, l_s, {NATURAL_32} 47_299)
						a_term.item.fill_area (a_menu.item.x + 1, l_s, a_menu.item.xw - 2, 1, {NATURAL_32} 47_300)
						a_term.item.set_char ((a_menu.item.x + a_menu.item.xw) - 1, l_s, {NATURAL_32} 47_284)
				when 13 then -- if done
						l_p := l_p + 1
						l_s := l_s + 1
				when 14 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					l_break := False;
					(create {P_TERMINAL_STATIC}).redraw_from_window (a_menu.item.win)
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	display_mainmenu (a_term: CE_POINTER [PD_TERMINAL]; a_menu: CE_POINTER [PD_MAINMENU])
		require
			not a_term.is_void
			not a_menu.is_void
		local
			l_i: INTEGER_32
			l_p: INTEGER_32
			l_s: INTEGER_32
			l_j: INTEGER_32
			l_c: NATURAL_8
			l_tmptext: CE_POINTER [NATURAL_8]
			l_co: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: NATURAL_8
			l_return, l_break: BOOLEAN
		do
			l_p := 2
			a_term.item.fill_area (0, 0, a_term.item.x, 1, {NATURAL_32} 14_368)
			l_i := 0
			from
			until
				not (not (l_return) and then (not ((a_menu.item.items + l_i).item.text).is_void))
			loop
				l_s := 0
				l_tmptext := ((create {P_LANGUAGE_STATIC}).get_text_translation ((a_menu.item.items + l_i).item.text, a_term))
				if l_i = a_menu.item.selected then
					l_s := 1
					l_tmp___0 := 1_792
				else
					l_tmp___0 := 14_336
				end
				l_co := l_tmp___0
				if l_s.to_boolean then
					a_term.item.fill_area (l_p, 0, 2, 1, l_co.to_natural_32)
					a_term.item.fill_area (((l_p.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tmptext)))) + {NATURAL_32} 2).to_integer_32, 0, 2, 1, l_co.to_natural_32)
					a_menu.item.sp := l_p
					a_term.item.set_cursor (l_p, 0, a_term.item.x - 1, a_term.item.y - 1);
					(a_menu.item.win).item.set_window_ptr (l_p, 1)
				end
				l_p := l_p + (2)
				l_j := 0
				from
				until
					(l_break)
				loop
					l_break := False
					l_c := l_tmptext[l_j]
					if not l_c.to_boolean then
						l_break := True
					end
					if not (l_break) then
						if not l_s.to_boolean then
							l_tmp___6 := (create {P_LINKS_STATIC}).upcase (l_c)
							if (not (strchr (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LANGUAGE_STATIC}).get_text_translation ((a_menu.item.items + l_i).item.hotkey, a_term))), l_tmp___6.to_integer_32)).is_void) then
								l_s := 1
								l_tmp___5 := 14_336
							else
								l_tmp___5 := l_co
							end
						else
							l_tmp___5 := l_co
						end
						a_term.item.set_char (l_p, 0, ((l_tmp___5).bit_or (l_c.to_integer_32)).to_natural_32)
						l_j := l_j + 1
						l_p := l_p + 1
					end
				end
				l_break := False
				l_p := l_p + (2)
				l_i := l_i + 1
			end
			a_menu.item.ni := l_i;
			(create {P_TERMINAL_STATIC}).redraw_from_window (a_menu.item.win)
		end

	select_mainmenu (a_term: CE_POINTER [PD_TERMINAL]; a_menu: CE_POINTER [PD_MAINMENU])
		require
			not a_menu.is_void
		local
			l_it: CE_POINTER [PD_MENU_ITEM]
			l_win: CE_POINTER [PD_WINDOW]
			l_win1: CE_POINTER [PD_WINDOW]
			l_return, l_break: BOOLEAN
		do
			l_it := a_menu.item.items + a_menu.item.selected
			if a_menu.item.selected < 0 then
				l_return := True
			elseif a_menu.item.selected >= a_menu.item.ni then
				l_return := True
			elseif (l_it.item.hotkey).is_equal ((create {P_BFU_STATIC}).m_bar.item) then
				l_return := True
			end
			if not l_return then
				if not (l_it.item.in_m).to_boolean then
					l_win := create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast (a_term.item.windows.next)
					from
					until
						(l_break)
					loop
						l_break := False
						if not l_win.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))) then
							if not ((l_win.item.handler).is_equal (menu_func_address)) then
								if not ((l_win.item.handler).is_equal (mainmenu_func_address)) then
									l_break := True
								end
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_win1 := l_win.item.next
							l_win.item.delete_window
							l_win := l_win1
						end
					end
					l_break := False
				end
				(l_it.item.func).call ([a_term, l_it.item.data, a_menu.item.data])
			end
		end

	dlg_set_history (a_di: CE_POINTER [PD_DIALOG_ITEM_DATA])
		require
			not a_di.is_void
		local
			l_s: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
		do
			l_s := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
			if not (a_di.item.cur_hist).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_di.c_pointer + (create {PD_DIALOG_ITEM_DATA}.make).offset_of ("history"))) then
				l_s := (a_di.item.cur_hist).item.d
			end
			l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))).to_integer_32
			if l_l > (a_di.item.item).item.dlen then
				l_l := (a_di.item.item).item.dlen - 1
			end
			memcpy (create {CE_VOID_POINTER}.make_cast (a_di.item.cdata), create {CE_VOID_POINTER}.make_cast (l_s), l_l.to_natural_32).do_nothing
			a_di.item.cdata[l_l] := (0).to_natural_8
			a_di.item.cpos := l_l
			a_di.item.vpos := 0
		end

	dlg_mouse (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_ev: CE_POINTER [PD_EVENT]): INTEGER_32
		require
			not a_di.is_void
		local
			l_tmp___2: INTEGER_32
			l_offset: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (a_di.item.item).item.type -- switch 1 head
					when 4 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 3
					when 5 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 4
					if a_ev.item.y /= (a_di.item.y).to_integer_32 then
						Result := 0
						l_return := True
					elseif a_ev.item.x < (a_di.item.x).to_integer_32 then
						Result := 0
						l_return := True
					elseif (a_ev.item.x).to_natural_32 >= ((a_di.item.x).to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LANGUAGE_STATIC}).get_text_translation ((a_di.item.item).item.text, (a_dlg.item.win).item.term)))))) + {NATURAL_32} 4 then
						Result := 0
						l_return := True
					end
					if not l_return then
						a_dlg.item.display_dlg_item (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (a_dlg.item.selected)), 0)
						a_dlg.item.selected := a_di.distance ((a_dlg.item.items))
						a_dlg.item.display_dlg_item (a_di, 1)
						if ((a_ev.item.b).bit_and (12)) = 4 then
							dlg_select_item (a_dlg, a_di)
						end
						Result := 1
						l_return := True
					end
				when 2 then -- switch 1, case 3 | switch 1, case 2
					if not l_return then
						if a_ev.item.y /= (a_di.item.y).to_integer_32 then
							Result := 0
							l_return := True
						elseif a_ev.item.x < (a_di.item.x).to_integer_32 then
							Result := 0
							l_return := True
						elseif a_ev.item.x >= (a_di.item.x + a_di.item.l).to_integer_32 then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_tmp___2 := (((a_di.item.vpos).to_integer_32 + a_ev.item.x) - (a_di.item.x).to_integer_32).to_integer_32
						a_di.item.cpos := l_tmp___2
						if l_tmp___2.to_natural_32 > (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_di.item.cdata))) then
							a_di.item.cpos := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_di.item.cdata))).to_integer_32
						end
						a_dlg.item.display_dlg_item (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (a_dlg.item.selected)), 0)
						a_dlg.item.selected := a_di.distance ((a_dlg.item.items))
						a_dlg.item.display_dlg_item (a_di, 1)
						Result := 1
						l_return := True
					end
				when 3 then -- switch 1, case 1
					if not l_return then
						if a_ev.item.y /= (a_di.item.y).to_integer_32 then
							Result := 0
							l_return := True
						elseif a_ev.item.x < (a_di.item.x).to_integer_32 then
							Result := 0
							l_return := True
						elseif a_ev.item.x >= (a_di.item.x + 3).to_integer_32 then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						a_dlg.item.display_dlg_item (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (a_dlg.item.selected)), 0)
						a_dlg.item.selected := a_di.distance ((a_dlg.item.items))
						a_dlg.item.display_dlg_item (a_di, 1)
						if ((a_ev.item.b).bit_and (12)) = 4 then
							dlg_select_item (a_dlg, a_di)
						end
						Result := 1
						l_return := True
					end
				when 4 then -- switch 1, case 5
					if not l_return and then (((a_ev.item.b).bit_and (12)) = 4) then
						if a_ev.item.y >= (a_di.item.y).to_integer_32 then
							if a_ev.item.x >= (a_di.item.x).to_integer_32 then
								if a_ev.item.x <= (a_di.item.l + a_di.item.x).to_integer_32 then
									l_offset := (a_ev.item.y - (a_di.item.y).to_integer_32).to_integer_32
									box_sel_set_visible (a_di, l_offset)
									a_dlg.item.display_dlg_item (a_di, 1)
									Result := 1
									l_return := True
								end
							end
						end
					end
				when 5 then -- switch 1, done:
					if not l_return then
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dlg_select_item (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA])
		require
			not a_di.is_void
		local
			l_tmp: INTEGER_32
			l_i: INTEGER_32
		do
			if (a_di.item.item).item.type = 1 then
				if not ((a_di.item.item).item.gid).to_boolean then
					l_tmp := (not ((create {CE_INTEGER_32_POINTER}.make_cast (a_di.item.cdata)).item).to_boolean).to_integer;
					(create {CE_INTEGER_32_POINTER}.make_cast (a_di.item.cdata)).item := l_tmp
					a_di.item.checked := l_tmp
				else
					l_i := 0
					from
					until
						not (l_i < a_dlg.item.n)
					loop
						if (a_dlg.item.items[l_i].item).item.type = 1 then
							if (a_dlg.item.items[l_i].item).item.gid = (a_di.item.item).item.gid then
								(create {CE_INTEGER_32_POINTER}.make_cast (a_dlg.item.items[l_i].cdata)).item := (a_di.item.item).item.gnum
								a_dlg.item.items[l_i].checked := 0
								a_dlg.item.display_dlg_item (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (l_i)), 0)
							end
						end
						l_i := l_i + 1
					end
					a_di.item.checked := 1
				end
				a_dlg.item.display_dlg_item (a_di, 1)
			elseif (a_di.item.item).item.type = 4 then
				((a_di.item.item).item.fn).call ([a_dlg, a_di])
			end
		end

	do_tab_compl (a_term: CE_POINTER [PD_TERMINAL]; a_history: CE_POINTER [PD_LIST_HEAD]; a_win: CE_POINTER [PD_WINDOW])
		require
			not a_history.is_void
			not a_win.is_void
		local
			l_cdata: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_n: INTEGER_32
			l_hi: CE_POINTER [PD_HISTORY_ITEM]
			l_items: CE_POINTER [PD_MENU_ITEM]
			l_return: BOOLEAN
		do
			l_cdata := (create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_cast (a_win.item.data)).item.items[(create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_cast (a_win.item.data)).item.selected].cdata
			l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_cdata))).to_integer_32
			l_n := 0
			l_items := create {CE_CLASS_POINTER [PD_MENU_ITEM]}.make_shared (default_pointer + -1)
			l_hi := create {CE_CLASS_POINTER [PD_HISTORY_ITEM]}.make_cast (a_history.item.next)
			from
			until
				not (not (l_return) and then (not l_hi.is_equal (a_history)))
			loop
				if not (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_cdata), create {CE_INTEGER_8_POINTER}.make_cast ((l_hi.item.d)), l_l.to_natural_32)).to_boolean then
					if not ((l_n).bit_and (63)).to_boolean then
						if l_n.to_natural_32 > ({NATURAL_32} 2_147_483_647 // (create {PD_MENU_ITEM}.make).structure_size.to_natural_32 - {NATURAL_32} 64) - {NATURAL_32} 1 then
							from
							until
								False
							loop
								(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 619]);
								(create {P_KBD_STATIC}).fatal_tty_exit
								exit (4)
							end
						end
						l_items := create {CE_CLASS_POINTER [PD_MENU_ITEM]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 620, create {CE_VOID_POINTER}.make_cast (l_items), ((l_n + 64) + 1).to_natural_32 * (create {PD_MENU_ITEM}.make).structure_size.to_natural_32)))
					end
					(l_items + l_n).item.text := l_hi.item.d;
					(l_items + l_n).item.rtext := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""));
					(l_items + l_n).item.hotkey := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""));
					(l_items + l_n).item.func := (tab_compl_address);
					(l_items + l_n).item.rtext := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""));
					(l_items + l_n).item.data := create {CE_VOID_POINTER}.make_cast ((l_hi.item.d));
					(l_items + l_n).item.in_m := 0;
					(l_items + l_n).item.free_i := 1
					if l_n = 2_147_483_647 then
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 630]);
							(create {P_KBD_STATIC}).fatal_tty_exit
							exit (4)
						end
					end
					l_n := l_n + 1
				end
				l_hi := l_hi.item.next
			end
			if l_n = 1 then
				tab_compl (a_term, create {CE_NATURAL_8_POINTER}.make_cast (l_items.item.data), a_win);
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 635, create {CE_VOID_POINTER}.make_cast (l_items))
				l_return := True
			end
			if not l_return and then (l_n.to_boolean) then
				memset (create {CE_VOID_POINTER}.make_cast ((l_items + l_n)), 0, (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).do_nothing
				a_term.item.do_menu_selected (l_items, create {CE_VOID_POINTER}.make_cast (a_win), l_n - 1)
			end
		end

	tab_compl (a_term: CE_POINTER [PD_TERMINAL]; a_item: CE_POINTER [NATURAL_8]; a_win: CE_POINTER [PD_WINDOW])
		require
			not a_term.is_void
			not a_win.is_void
		local
			l_ev: CE_ARRAY [PD_EVENT]
			l_di: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_l: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_EVENT]} l_ev.make (<<1>>)

			l_ev.item.ev := 3
			l_ev.item.x := 0
			l_ev.item.y := 0
			l_ev.item.b := 0
			l_di := create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared ((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_cast (a_win.item.data)).c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * ((create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_cast (a_win.item.data)).item.selected))
			l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_item))).to_integer_32
			if l_l >= (l_di.item.item).item.dlen then
				l_l := (l_di.item.item).item.dlen - 1
			end
			memcpy (create {CE_VOID_POINTER}.make_cast (l_di.item.cdata), create {CE_VOID_POINTER}.make_cast (a_item), l_l.to_natural_32).do_nothing
			l_di.item.cdata[l_l] := (0).to_natural_8
			l_di.item.cpos := l_l
			l_di.item.vpos := 0
			l_ev.item.x := (a_term.item.x).to_integer_32
			l_ev.item.y := (a_term.item.y).to_integer_32
			a_win.item.dialog_func (l_ev, 0)
		end

	box_sel_set_visible (a_box_item_data: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_offset: INTEGER_32)
		require
			not a_box_item_data.is_void
		local
			l_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]
			l_sel: INTEGER_32
			l_return: BOOLEAN
		do
			l_box := create {CE_CLASS_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast ((a_box_item_data.item.item).item.data)
			if a_offset > (a_box_item_data.item.item).item.gid then
				l_return := True
			elseif a_offset < 0 then
				l_return := True
			end
			if not l_return then
				l_sel := l_box.item.box_top + a_offset
				if l_sel > l_box.item.list_len then
					l_box.item.sel := l_box.item.list_len - 1
				else
					l_box.item.sel := l_sel
				end
			end
		end

	read_session_info (a_fd: INTEGER_32; a_ses: CE_POINTER [PD_SESSION]; a_data: CE_POINTER [ANY]; a_len: INTEGER_32): INTEGER_32
		local
			l_h: CE_POINTER [NATURAL_8]
			l_cpfrom: INTEGER_32
			l_sz: INTEGER_32
			l_s: CE_POINTER [PD_SESSION]
			l_u: CE_POINTER [INTEGER_8]
			l_uu: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			if a_len < 2 * ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_cpfrom := (create {CE_INTEGER_32_POINTER}.make_cast (a_data)).item
				l_sz := create {CE_INTEGER_32_POINTER}.make_cast (a_data)[1]
				l_s := create {CE_CLASS_POINTER [PD_SESSION]}.make_cast ((create {P_SESSION_STATIC}).sessions.item.item.next)
				from
				until
					not (not (l_break) and then (not l_s.is_equal ((create {P_SESSION_STATIC}).sessions.item)))
				loop
					l_break := False
					if l_s.item.id = l_cpfrom then
						copy_session (l_s, a_ses)
						l_break := True
					end
					if not (l_break) then
						l_s := l_s.item.next
					end
				end
				l_break := False
				if l_sz.to_boolean then
					if a_len < 2 * ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32 + l_sz then
						Result := 0
						l_return := True
					end
					if not l_return then
						if l_sz.to_natural_32 >= {NATURAL_32} 2_147_483_647 then
							from
							until
								False
							loop
								(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("session.c"), 1_295]);
								(create {P_KBD_STATIC}).fatal_tty_exit
								exit (4)
							end
						end
						l_u := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_296, (l_sz + 1).to_natural_32)))
						memcpy (create {CE_VOID_POINTER}.make_cast (l_u), create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_cast (a_data) + 2)), l_sz.to_natural_32).do_nothing
						l_u[l_sz] := (0).to_integer_8
						l_uu := create {CE_INTEGER_8_POINTER}.make_cast ((decode_url (create {CE_NATURAL_8_POINTER}.make_cast (l_u))));
						(create {P_SESSION_STATIC}).goto_url (a_ses, create {CE_NATURAL_8_POINTER}.make_cast (l_uu));
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_301, create {CE_VOID_POINTER}.make_cast (l_u));
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_302, create {CE_VOID_POINTER}.make_cast (l_uu))
					end
				else
					l_h := create {CE_NATURAL_8_POINTER}.make_cast ((getenv (ce_string ("WWW_HOME"))))
					if (not l_h.is_void) then
						if (l_h.item).to_boolean then
							(create {P_SESSION_STATIC}).goto_url (a_ses, l_h)
						end
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	copy_session (a_old, a_new: CE_POINTER [PD_SESSION])
		require
			not a_old.is_void
		do
			if not ((a_old.item.history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_old.c_pointer + (create {PD_SESSION}.make).offset_of ("history")))) then
				(create {P_SESSION_STATIC}).goto_url (a_new, (create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (a_old.item.history.next)).item.vs.url)
			end
		end

	decode_url (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_url.is_void
		local
			l_url: CE_POINTER [NATURAL_8]
			l_u: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_tmp___0: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_u.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)

			l_url := a_url
			l_u.item := ((create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_271))
			l_l.item := 0
			from
			until
				not ((l_url.item).to_boolean)
			loop
				if (l_url.item).to_integer_32 /= 43 then
					(create {P_LINKS_STATIC}).add_chr_to_str (l_u, l_l, l_url.item)
				elseif (unhx (l_url[1])) = -1 then
					(create {P_LINKS_STATIC}).add_chr_to_str (l_u, l_l, l_url.item)
				elseif (unhx (l_url[2])) = -1 then
					(create {P_LINKS_STATIC}).add_chr_to_str (l_u, l_l, l_url.item)
				else
					l_tmp___0 := unhx (l_url[1]);
					(create {P_LINKS_STATIC}).add_chr_to_str (l_u, l_l, (((l_tmp___0).bit_shift_left (4)) + (unhx (l_url[2]))).to_natural_8)
					l_url := l_url + (2)
				end
				l_url := l_url + 1
			end
			Result := (l_u.item)
		end

	unhx (a_a: NATURAL_8): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_a.to_integer_32 >= 48 then
				if a_a.to_integer_32 <= 57 then
					Result := (a_a.to_integer_32 - 48)
					l_return := True
				end
			end
			if not l_return and then (a_a.to_integer_32 >= 65) then
				if a_a.to_integer_32 <= 70 then
					Result := ((a_a.to_integer_32 - 65) + 10)
					l_return := True
				end
			end
			if not l_return and then (a_a.to_integer_32 >= 97) then
				if a_a.to_integer_32 <= 102 then
					Result := ((a_a.to_integer_32 - 97) + 10)
					l_return := True
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

	destroy_session (a_ses: CE_POINTER [PD_SESSION])
		local
			l_fdc: CE_POINTER [PD_F_DATA_C]
			l_d: CE_POINTER [PD_DOWNLOAD]
			l_l: CE_POINTER [PD_LOCATION]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
			l_frm: CE_POINTER [PD_FRAME]
			l_return, l_break: BOOLEAN
		do
			if a_ses.is_void then
				l_return := True
			end
			if not l_return then
				l_d := create {CE_CLASS_POINTER [PD_DOWNLOAD]}.make_cast ((create {P_SESSION_STATIC}).downloads.item.item.next)
				from
				until
					l_d.is_equal ((create {P_SESSION_STATIC}).downloads.item)
				loop
					if (l_d.item.ses).is_equal (a_ses) then
						if (not (l_d.item.prog).is_void) then
							l_d := l_d.item.prev;
							(l_d.item.next).item.abort_download
						end
					end
					l_d := l_d.item.next
				end
				a_ses.item.abort_loading
				a_ses.item.free_files
				if (not (a_ses.item.screen).is_void) then
					(a_ses.item.screen).item.detach_formatted;
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_338, create {CE_VOID_POINTER}.make_cast (a_ses.item.screen))
				end
				l_fdc := create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_cast (a_ses.item.scrn_frames.next)
				from
				until
					l_fdc.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))
				loop
					l_fdc.item.detach_formatted
					l_fdc := l_fdc.item.next
				end
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))))
				l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (a_ses.item.scrn_frames.next)
				from
				until
					l_a__.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))
				loop
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
					l_a__ := l_a__.item.next
				end
				l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (a_ses.item.scrn_frames.prev)
				from
				until
					l_a__.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))
				loop
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
					l_a__ := l_a__.item.prev
				end
				from
				until
					(a_ses.item.scrn_frames.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))
				loop
					l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (a_ses.item.scrn_frames.next);
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
					(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev);
					(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next);
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_340, create {CE_VOID_POINTER}.make_cast (l_a__))
				end
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("scrn_frames")))))
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_l := create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)
					if l_l.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
						l_break := True
					end
					if not (l_return or l_break) then
						from
						until
							(l_break)
						loop
							l_break := False
							l_frm := create {CE_CLASS_POINTER [PD_FRAME]}.make_cast (l_l.item.frames.next)
							if l_frm.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames"))) then
								l_break := True
							end
							if not (l_break) then
								(create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (l_frm.c_pointer + (create {PD_FRAME}.make).offset_of ("vs"))).item.destroy_vs;
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_345, create {CE_VOID_POINTER}.make_cast (l_frm.item.name));
								(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_frm));
								(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_frm.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_frm.item.prev);
								(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_frm.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_frm.item.next);
								(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_frm));
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_347, create {CE_VOID_POINTER}.make_cast (l_frm))
							end
						end
						l_break := False;
						(create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (l_l.c_pointer + (create {PD_LOCATION}.make).offset_of ("vs"))).item.destroy_vs;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_l));
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_l.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_l.item.prev);
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_l.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_l.item.next);
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_l));
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_351, create {CE_VOID_POINTER}.make_cast (l_l))
					end
				end
				l_break := False
				if (not (a_ses.item.loading_url).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_353, create {CE_VOID_POINTER}.make_cast (a_ses.item.loading_url))
				end
				if a_ses.item.display_timer /= -1 then
					(create {P_SELECT_STATIC}).kill_timer (a_ses.item.display_timer)
				end
				if (not (a_ses.item.goto_position).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_355, create {CE_VOID_POINTER}.make_cast (a_ses.item.goto_position))
				end
				if (not (a_ses.item.imgmap_href_base).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_356, create {CE_VOID_POINTER}.make_cast (a_ses.item.imgmap_href_base))
				end
				if (not (a_ses.item.imgmap_target_base).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_357, create {CE_VOID_POINTER}.make_cast (a_ses.item.imgmap_target_base))
				end
				if (not (a_ses.item.tq_ce).is_void) then
					(a_ses.item.tq_ce).item.refcount := ((a_ses.item.tq_ce).item.refcount) - 1
				end
				if (not (a_ses.item.tq_url).is_void) then
					(create {P_SCHED_STATIC}).change_connection (create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("tq")), create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (default_pointer), 5);
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_361, create {CE_VOID_POINTER}.make_cast (a_ses.item.tq_url))
				end
				if (not (a_ses.item.tq_goto_position).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_363, create {CE_VOID_POINTER}.make_cast (a_ses.item.tq_goto_position))
				end
				if (not (a_ses.item.tq_prog).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_364, create {CE_VOID_POINTER}.make_cast (a_ses.item.tq_prog))
				end
				if (not (a_ses.item.dn_url).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_365, create {CE_VOID_POINTER}.make_cast (a_ses.item.dn_url))
				end
				if (not (a_ses.item.search_word).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_366, create {CE_VOID_POINTER}.make_cast (a_ses.item.search_word))
				end
				if (not (a_ses.item.last_search_word).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_367, create {CE_VOID_POINTER}.make_cast (a_ses.item.last_search_word))
				end
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (a_ses));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (a_ses.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (a_ses.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (a_ses.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (a_ses.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (a_ses))
			end
		end

	redraw_terminal (a_term: CE_POINTER [PD_TERMINAL])
		require
			not a_term.is_void
		do
			a_term.item.redraw_terminal_ev (3)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			handler := a_other.handler
			data := a_other.data
			xp := a_other.xp
			yp := a_other.yp
			term := a_other.term
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				handler.is_equal (a_other.handler) and
				data.is_equal (a_other.data) and
				xp = a_other.xp and
				yp = a_other.yp and
				term.is_equal (a_other.term)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("handler"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("xp"),
					create {CE_STRUCTURE_FIELD}.make ("yp"),
					create {CE_STRUCTURE_FIELD}.make ("term")
				>>)
			init_structure_info
		end

end
