class
	S_STDIO_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	remove (a___filename: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_remove (a___filename.c_pointer)
		end

	c_remove (a___filename: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return remove($a___filename);"
		end

	rename2 (a___old, a___new: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_rename2 (a___old.c_pointer, a___new.c_pointer)
		end

	c_rename2 (a___old: POINTER; a___new: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return rename($a___old, $a___new);"
		end

	fclose (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fclose (a___stream.c_pointer)
		end

	c_fclose (a___stream: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return fclose($a___stream);"
		end

	fopen (a___filename, a___modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create {CE_CLASS_POINTER [SD_IO_FILE]} Result.make_shared (c_fopen (a___filename.c_pointer, a___modes.c_pointer))
		end

	c_fopen (a___filename: POINTER; a___modes: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return (EIF_POINTER)fopen($a___filename, $a___modes);"
		end

	fputc (a___c: INTEGER_32; a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputc (a___c, a___stream.c_pointer)
		end

	c_fputc (a___c: INTEGER_32; a___stream: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return fputc($a___c, $a___stream);"
		end

	fgets (a___s: CE_POINTER [INTEGER_8]; a___n: INTEGER_32; a___stream: CE_POINTER [SD_IO_FILE]): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_fgets (a___s.c_pointer, a___n, a___stream.c_pointer))
		end

	c_fgets (a___s: POINTER; a___n: INTEGER_32; a___stream: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return (EIF_POINTER)fgets($a___s, $a___n, $a___stream);"
		end

	fputs (a___s: CE_POINTER [INTEGER_8]; a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputs (a___s.c_pointer, a___stream.c_pointer)
		end

	c_fputs (a___s: POINTER; a___stream: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return fputs($a___s, $a___stream);"
		end

	ferror (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_ferror (a___stream.c_pointer)
		end

	c_ferror (a___stream: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return ferror($a___stream);"
		end

	fflush (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fflush (a___stream.c_pointer)
		end

	c_fflush (a___stream: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return fflush($a___stream);"
		end

	fprintf (a_args: TUPLE [a___stream: CE_POINTER [SD_IO_FILE]; a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fprintf)).integer_32_item (a_args)
		end

	c_fprintf: POINTER
		external
			"C inline use <links.h>"
		alias
			"return (EIF_POINTER)&fprintf;"
		end

	fread (a___ptr: CE_POINTER [ANY]; a___size, a___n: NATURAL_32; a___stream: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fread (a___ptr.c_pointer, a___size, a___n, a___stream.c_pointer)
		end

	c_fread (a___ptr: POINTER; a___size: NATURAL_32; a___n: NATURAL_32; a___stream: POINTER): NATURAL_32
		external
			"C inline use <links.h>"
		alias
			"return fread($a___ptr, $a___size, $a___n, $a___stream);"
		end

	popen (a___command, a___modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create {CE_CLASS_POINTER [SD_IO_FILE]} Result.make_shared (c_popen (a___command.c_pointer, a___modes.c_pointer))
		end

	c_popen (a___command: POINTER; a___modes: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return (EIF_POINTER)popen($a___command, $a___modes);"
		end

	pclose (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_pclose (a___stream.c_pointer)
		end

	c_pclose (a___stream: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return pclose($a___stream);"
		end

	sprintf (a_args: TUPLE [a___s, a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sprintf)).integer_32_item (a_args)
		end

	c_sprintf: POINTER
		external
			"C inline use <links.h>"
		alias
			"return (EIF_POINTER)&sprintf;"
		end

	vfprintf (a___s: CE_POINTER [SD_IO_FILE]; a___format: CE_POINTER [INTEGER_8]; a___arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vfprintf (a___s.c_pointer, a___format.c_pointer, a___arg.c_pointer)
		end

	c_vfprintf (a___s: POINTER; a___format: POINTER; a___arg: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return vfprintf($a___s, $a___format, $a___arg);"
		end

	tempnam (a___dir, a___pfx: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_tempnam (a___dir.c_pointer, a___pfx.c_pointer))
		end

	c_tempnam (a___dir: POINTER; a___pfx: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return (EIF_POINTER)tempnam($a___dir, $a___pfx);"
		end

end
