class
	SD_SIGACTION_HANDLER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	sa_handler: CE_ROUTINE assign set_sa_handler

	sa_sigaction: CE_ROUTINE assign set_sa_sigaction

feature {ANY} -- field setters

	set_sa_handler (a_sa_handler: CE_ROUTINE)
		do
			sa_handler := a_sa_handler
			update_memory_field ("sa_handler")
		end

	set_sa_sigaction (a_sa_sigaction: CE_ROUTINE)
		do
			sa_sigaction := a_sa_sigaction
			update_memory_field ("sa_sigaction")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sa_handler := a_other.sa_handler
			sa_sigaction := a_other.sa_sigaction
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sa_handler.is_equal (a_other.sa_handler) and
				sa_sigaction.is_equal (a_other.sa_sigaction)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("sa_handler"),
					create {CE_STRUCTURE_FIELD}.make ("sa_sigaction")
				>>)
			init_structure_info
		end

end
