class
	P_BUFFER_STATIC

inherit
	CE_UTILITIES
	S_LIBINTL_STATIC
	S_STRING_STATIC
	S_SYS_STAT_STATIC
	S_CTYPE_STATIC
	S_STDIO_STATIC
	S_LIBIO_STATIC

feature {ANY} -- public attributes

	msg_loclist: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("[Location List]")
		end

	msg_qflist: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("[Quickfix List]")
		end

	top_file_num: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 1
		end

	lasttitle: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				>>)
		end

	lasticon: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				>>)
		end

	entered: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	open_buffer (a_read_stdin___0: INTEGER_32; a_eap: CE_POINTER [PD_EXARG]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_retval: CE_ARRAY [INTEGER_32]
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_oldFire: INTEGER_32
			l_save_bin: INTEGER_32
			l_line_count: INTEGER_32
			l_aco: CE_ARRAY [PD_ACO_SAVE_T]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_retval.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_ACO_SAVE_T]} l_aco.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval.item := 1
					if ((create {P_GLOBALS_STATIC}).readonlymode.item).to_boolean then
						if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags).bit_and (4)).to_boolean then
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro := 1
							end
						end
					end
					if (((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_open) = 0 then
						close_buffer (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer), (create {P_GLOBALS_STATIC}).curbuf.item, 0);
						(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).firstbuf.item
						from
						until
							not (not (l_break) and then (not ((create {P_GLOBALS_STATIC}).curbuf.item).is_void))
						loop
							l_break := False
							if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_mfp).is_void then
								l_break := True
							end
							if not (l_break) then
								(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_next
							end
						end
						l_break := False
						if ((create {P_GLOBALS_STATIC}).curbuf.item).is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E82: Cannot allocate any buffer, exiting..."))))).do_nothing;
							(create {P_MAIN_STATIC}).getout (2)
						end
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E83: Cannot allocate buffer, using other one..."))))).do_nothing;
						((create {P_GLOBALS_STATIC}).curbuf.item).item.enter_buffer
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 22 -- skip if block
					end
				when 1 then -- if:
						l_old_curbuf := (create {P_GLOBALS_STATIC}).curbuf.item;
						(create {P_GLOBALS_STATIC}).modified_was_set.item := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := 0
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((create {P_GLOBALS_STATIC}).netbeansReadFile.item).to_boolean then
							l_oldFire := (create {P_GLOBALS_STATIC}).netbeansFireChanges.item;
							(create {P_GLOBALS_STATIC}).netbeansFireChanges.item := 0
							l_retval.item := (create {P_FILEIO_STATIC}).readfile ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname, (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname, (0).to_integer_32, (0).to_integer_32, 2_147_483_647, a_eap, (a_flags___0).bit_or (1));
							(create {P_GLOBALS_STATIC}).netbeansFireChanges.item := l_oldFire
							if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_help).to_boolean then
								(create {P_EX_CMDS_STATIC}).fix_help_buffer
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else: | _L___0:
						if not (a_read_stdin___0.to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 5 then -- if:
						l_save_bin := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bin;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bin := 1
						l_retval.item := (create {P_FILEIO_STATIC}).readfile (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), (0).to_integer_32, (0).to_integer_32, 2_147_483_647, create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), (a_flags___0).bit_or (5));
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bin := l_save_bin
						if l_retval.item /= 1 then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						l_line_count := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
						l_retval.item := (create {P_FILEIO_STATIC}).readfile (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_line_count, (0).to_integer_32, 2_147_483_647, a_eap, (a_flags___0).bit_or (8))
						if l_retval.item = 1 then
							from
							until
								(l_break)
							loop
								l_break := False
								l_line_count := l_line_count - 1
								if not (l_line_count >= 0) then
									l_break := True
								end
								if not (l_break) then
									(create {P_MEMLINE_STATIC}).ml_delete ((1).to_integer_32, 0).do_nothing
								end
							end
							l_break := False
						else
							from
							until
								not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count > l_line_count)
							loop
								(create {P_MEMLINE_STATIC}).ml_delete (l_line_count, 0).do_nothing
							end
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (1).to_integer_32;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
						if ((create {P_GLOBALS_STATIC}).readonlymode.item).to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count = 1 then
							if (((create {P_MEMLINE_STATIC}).ml_get ((1).to_integer_32)).item).to_integer_32 = 0 then
								l_pos := -1 + 9 -- goto _L
							else
								(create {P_MISC1_STATIC}).changed
							end
						else
							(create {P_MISC1_STATIC}).changed
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if l_retval.item /= 0 then
							((create {P_GLOBALS_STATIC}).curbuf.item).item.unchanged (0)
						end
				when 10 then;
						(create {P_FILEIO_STATIC}).apply_autocmds_retval ({PC_AUTO_EVENT}.EVENT_STDINREADPOST, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item, l_retval).do_nothing
				when 11 then -- if done | if done
						if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags).bit_and (4)).to_boolean then
							((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_init_chartab (0).do_nothing
						end
						if not (((create {P_GLOBALS_STATIC}).got_int.item).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('i').code)).is_void then
							(create {P_MISC1_STATIC}).changed
						else
							l_pos := -1 + 14 -- goto _L___2
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 14 then -- else: | _L___2:
						if not (((create {P_GLOBALS_STATIC}).modified_was_set.item).to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:;
						(create {P_MISC1_STATIC}).changed
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 17 then -- else:
						if not (((create {P_EX_EVAL_STATIC}).aborting).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('i').code)).is_void then
							(create {P_MISC1_STATIC}).changed
						else
							l_pos := -1 + 20 -- goto _L___1
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else: | _L___1:
						if l_retval.item /= 0 then
							if not a_read_stdin___0.to_boolean then
								((create {P_GLOBALS_STATIC}).curbuf.item).item.unchanged (0)
							end
						end
				when 21 then -- if done | if done;
						((create {P_GLOBALS_STATIC}).curbuf.item).item.save_file_ff
						if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags).bit_or ((64))
						end
						((create {P_GLOBALS_STATIC}).curwin.item).item.foldUpdateAll
						if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and (128)).to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := (1).to_integer_32;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := 0
						end
						(create {P_FILEIO_STATIC}).apply_autocmds_retval ({PC_AUTO_EVENT}.EVENT_BUFENTER, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item, l_retval).do_nothing
						if l_retval.item /= 0 then
							if (buf_valid (l_old_curbuf)).to_boolean then
								if not (l_old_curbuf.item.b_ml.ml_mfp).is_void then
									l_aco.item.aucmd_prepbuf (l_old_curbuf)
									do_modelines (0);
									(create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags).bit_and ((-7));
									(create {P_FILEIO_STATIC}).apply_autocmds_retval ({PC_AUTO_EVENT}.EVENT_BUFWINENTER, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item, l_retval).do_nothing
									l_aco.item.aucmd_restbuf
								end
							end
						end
						Result := (l_retval.item)
				when 22 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	buf_valid (a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_bp___0: CE_POINTER [PD_FILE_BUFFER]
			l_return: BOOLEAN
		do
			l_bp___0 := (create {P_GLOBALS_STATIC}).firstbuf.item
			from
			until
				not (not (l_return) and then (not l_bp___0.is_void))
			loop
				if l_bp___0.is_equal (a_buf___6) then
					Result := 1
					l_return := True
				end
				if not l_return then
					l_bp___0 := l_bp___0.item.b_next
				end
			end
			if not l_return then
				Result := 0
			end
		end

	close_buffer (a_win: CE_POINTER [PD_WINDOW_S]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_action: INTEGER_32)
		require
			not a_buf___6.is_void
		local
			l_is_curbuf: INTEGER_32
			l_nwindows: INTEGER_32
			l_unload_buf: INTEGER_32
			l_del_buf: INTEGER_32
			l_tmp: INTEGER_32
			l_wipe_buf: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return: BOOLEAN
		do
			l_unload_buf := (a_action /= 0).to_integer
			if a_action = 3 then
				l_tmp := 1
			elseif a_action = 4 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			l_del_buf := l_tmp
			l_wipe_buf := (a_action = 4).to_integer
			if (a_buf___6.item.b_p_bh[0]).to_integer_32 = 100 then
				l_del_buf := 1
				l_unload_buf := 1
			elseif (a_buf___6.item.b_p_bh[0]).to_integer_32 = 119 then
				l_del_buf := 1
				l_unload_buf := 1
				l_wipe_buf := 1
			elseif (a_buf___6.item.b_p_bh[0]).to_integer_32 = 117 then
				l_unload_buf := 1
			end
			if not a_win.is_void then
				if a_buf___6.item.b_nwindows = 1 then
					a_win.item.set_last_cursor
				end
				if a_win.item.w_cursor.lnum = 1 then
					l_tmp___0 := (0).to_integer_32
				else
					l_tmp___0 := a_win.item.w_cursor.lnum
				end
				a_buf___6.item.buflist_setfpos (a_win, l_tmp___0, a_win.item.w_cursor.col, 1)
			end
			if a_buf___6.item.b_nwindows = 1 then
				(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFWINLEAVE, a_buf___6.item.b_fname, a_buf___6.item.b_fname, 0, a_buf___6).do_nothing
				if not (buf_valid (a_buf___6)).to_boolean then
					l_return := True
				end
				if not l_return and then (not l_unload_buf.to_boolean) then
					(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFHIDDEN, a_buf___6.item.b_fname, a_buf___6.item.b_fname, 0, a_buf___6).do_nothing
					if not (buf_valid (a_buf___6)).to_boolean then
						l_return := True
					end
				end
				if not l_return then
					if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
						l_return := True
					end
				end
			end
			if not l_return then
				l_nwindows := a_buf___6.item.b_nwindows
				if a_buf___6.item.b_nwindows > 0 then
					a_buf___6.item.b_nwindows := (a_buf___6.item.b_nwindows) - 1
				end
				if a_buf___6.item.b_nwindows > 0 then
					l_return := True
				elseif not l_unload_buf.to_boolean then
					l_return := True
				end
			end
			if not l_return then
				if (a_buf___6.item.b_ffname).is_void then
					l_del_buf := 1
				end
				l_is_curbuf := (a_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item)).to_integer
				a_buf___6.item.b_nwindows := l_nwindows
				if l_del_buf.to_boolean then
					l_tmp___4 := 1
				else
					l_tmp___4 := 0
				end
				if l_wipe_buf.to_boolean then
					l_tmp___5 := 2
				else
					l_tmp___5 := 0
				end
				a_buf___6.item.buf_freeall (l_tmp___4 + l_tmp___5)
				if not (buf_valid (a_buf___6)).to_boolean then
					l_return := True
				end
			end
			if not l_return then
				if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
					l_return := True
				end
			end
			if not l_return then
				if a_buf___6.item.b_nwindows > 0 then
					a_buf___6.item.b_nwindows := (a_buf___6.item.b_nwindows) - 1
				end
				if a_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
					if not l_is_curbuf.to_boolean then
						l_return := True
					end
				end
			end
			if not l_return then
				if ((create {P_OPTION_STATIC}).p_acd.item.item).to_boolean then
					do_autochdir
				end
				if l_wipe_buf.to_boolean then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_buf___6.item.b_ffname));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_buf___6.item.b_sfname))
					if (a_buf___6.item.b_prev).is_void then
						(create {P_GLOBALS_STATIC}).firstbuf.item := a_buf___6.item.b_next
					else
						(a_buf___6.item.b_prev).item.b_next := a_buf___6.item.b_next
					end
					if (a_buf___6.item.b_next).is_void then
						(create {P_GLOBALS_STATIC}).lastbuf.item := a_buf___6.item.b_prev
					else
						(a_buf___6.item.b_next).item.b_prev := a_buf___6.item.b_prev
					end
					a_buf___6.item.free_buffer
				else
					if l_del_buf.to_boolean then
						a_buf___6.item.free_buffer_stuff (1)
						a_buf___6.item.b_flags := 6
						a_buf___6.item.b_p_initialized := 0
					end
					a_buf___6.item.buf_clear_file
					if l_del_buf.to_boolean then
						a_buf___6.item.b_p_bl := 0
					end
				end
			end
		end

	handle_swap_exists (a_old_curbuf: CE_POINTER [PD_FILE_BUFFER])
		local
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_cs: CE_ARRAY [PD_CLEANUP_STUFF]
		do
			create {CE_CLASS_ARRAY [PD_CLEANUP_STUFF]} l_cs.make (<<1>>)

			l_old_curbuf := a_old_curbuf
			if (create {P_GLOBALS_STATIC}).swap_exists_action.item = 2 then
				l_cs.item.enter_cleanup;
				(create {P_GLOBALS_STATIC}).swap_exists_action.item := 0;
				(create {P_GLOBALS_STATIC}).swap_exists_did_quit.item := 1
				close_buffer ((create {P_GLOBALS_STATIC}).curwin.item, (create {P_GLOBALS_STATIC}).curbuf.item, 2)
				if (buf_valid (l_old_curbuf)).to_boolean then
					if l_old_curbuf.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
						l_old_curbuf := buflist_new (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 1, 3)
					end
				else
					l_old_curbuf := buflist_new (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 1, 3)
				end
				if not l_old_curbuf.is_void then
					l_old_curbuf.item.enter_buffer
				end
				l_cs.item.leave_cleanup
			elseif (create {P_GLOBALS_STATIC}).swap_exists_action.item = 3 then
				l_cs.item.enter_cleanup;
				(create {P_GLOBALS_STATIC}).msg_scroll.item := 1;
				(create {P_MEMLINE_STATIC}).ml_recover;
				(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")));
				(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item
				do_modelines (0)
				l_cs.item.leave_cleanup
			end
			(create {P_GLOBALS_STATIC}).swap_exists_action.item := 0
		end

	do_bufdel (a_command: INTEGER_32; a_arg: CE_POINTER [NATURAL_8]; a_addr_count, a_start_bnr, a_end_bnr, a_forceit: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_arg: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_do_current: INTEGER_32
			l_deleted: INTEGER_32
			l_errormsg: CE_POINTER [NATURAL_8]
			l_bnr: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_arg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg.item := a_arg
					l_do_current := 0
					l_deleted := 0
					l_errormsg := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					if a_addr_count /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						do_buffer (a_command, 0, 1, 0, a_forceit).do_nothing
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 3 then -- else:
						if a_addr_count = 2 then
							if (l_arg.item.item).to_boolean then
								Result := (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_trailing.item))))))
								l_return := True
							end
							if not l_return then
								l_bnr := a_start_bnr
							end
						else
							l_bnr := a_end_bnr
						end
						if l_return then
							l_pos := -1 + 15 -- skip if block
						end
				when 4 then -- if: | loop condition:
						if not (not (l_break) and then (not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean)) then
							l_pos := -1 + 14 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						if l_bnr = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum then
							l_do_current := l_bnr
						elseif (do_buffer (a_command, 1, 1, l_bnr, a_forceit)) = 1 then
							l_deleted := l_deleted + 1
						end
						if a_addr_count /= 2 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_bnr := l_bnr + 1
						if l_bnr > a_end_bnr then
							l_break := True
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 8 then -- else:
						l_arg.item := (create {P_CHARSET_STATIC}).skipwhite (l_arg.item)
						if (l_arg.item.item).to_integer_32 = 0 then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 13 -- skip if block
						end
				when 9 then -- if:
						if not ((l_arg.item.item).to_integer_32 >= 48) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if (l_arg.item.item).to_integer_32 <= 57 then
							l_bnr := ((create {P_CHARSET_STATIC}).getdigits (l_arg)).to_integer_32
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						l_p___0 := (create {P_CHARSET_STATIC}).skiptowhite_esc (l_arg.item)
						l_bnr := buflist_findpat (l_arg.item, l_p___0, (a_command = 4).to_integer, 0)
						if l_bnr < 0 then
							l_break := True
						end
						if not (l_break) then
							l_arg.item := l_p___0
						end
				when 13 then -- if done | if done
						if not (l_break) then
							(create {P_UI_STATIC}).ui_breakcheck
						end
						l_pos := -1 + 4 -- back to loop condition
				when 14 then -- loop done
						l_break := False
						if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							if l_do_current.to_boolean then
								if (do_buffer (a_command, 1, 1, l_do_current, a_forceit)) = 1 then
									l_deleted := l_deleted + 1
								end
							end
						end
						if l_deleted = 0 then
							if a_command = 2 then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("E515: No buffers were unloaded")))).do_nothing
							elseif a_command = 3 then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("E516: No buffers were deleted")))).do_nothing
							else
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("E517: No buffers were wiped out")))).do_nothing
							end
							l_errormsg := (create {P_GLOBALS_STATIC}).IObuff.item
						elseif l_deleted.to_integer_32 >= (create {P_OPTION_STATIC}).p_report.item.item then
							if a_command = 2 then
								if l_deleted = 1 then
									(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("1 buffer unloaded"))))).do_nothing
								else
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%%d buffers unloaded")))), l_deleted]).do_nothing
								end
							elseif a_command = 3 then
								if l_deleted = 1 then
									(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("1 buffer deleted"))))).do_nothing
								else
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%%d buffers deleted")))), l_deleted]).do_nothing
								end
							elseif l_deleted = 1 then
								(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("1 buffer wiped out"))))).do_nothing
							else
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%%d buffers wiped out")))), l_deleted]).do_nothing
							end
						end
				when 15 then -- if done | if done
					if not l_return then
						Result := l_errormsg
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_buffer (a_action, a_start___1, a_dir___0, a_count___2, a_forceit: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_bp___0: CE_POINTER [PD_FILE_BUFFER]
			l_unload: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_forward: INTEGER_32
			l_retval: INTEGER_32
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___13: INTEGER_32
			l_jumpidx: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_count___2
					if a_action = 2 then
						l_tmp := 1
					elseif a_action = 3 then
						l_tmp := 1
					elseif a_action = 4 then
						l_tmp := 1
					else
						l_tmp := 0
					end
					l_unload := l_tmp
					inspect a_start___1 -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 1
					l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_buf___6 := (create {P_GLOBALS_STATIC}).lastbuf.item
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					l_buf___6 := (create {P_GLOBALS_STATIC}).curbuf.item
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					if a_start___1 /= 3 then
						l_pos := -1 + 7 -- skip if block
					end
				when 5 then -- if:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_tmp___1 := l_count___2
							l_count___2 := l_count___2 - 1
							if not (l_tmp___1 > 0) then
								l_break := True
							end
							if not (l_return or l_break) then
								from
								until
									(l_break)
								loop
									l_break := False
									l_buf___6 := l_buf___6.item.b_next
									if l_buf___6.is_void then
										l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
									end
									if not l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
										if (l_buf___6.item.bufIsChanged).to_boolean then
											l_break := True
										end
									else
										l_break := True
									end
								end
								l_break := False
							end
						end
						l_break := False
						if not (l_buf___6.item.bufIsChanged).to_boolean then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E84: No modified buffer found"))))).do_nothing
							Result := 0
							l_return := True
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if a_start___1 /= 1 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_count___2.to_boolean then
							from
							until
								(l_break)
							loop
								l_break := False
								if not l_buf___6.is_void then
									if l_buf___6.item.b_fnum = l_count___2 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_buf___6 := l_buf___6.item.b_next
								end
							end
							l_break := False
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						l_bp___0 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if not (l_count___2 > 0) then
								if not l_unload.to_boolean then
									if not (l_buf___6.item.b_p_bl).to_boolean then
										if l_bp___0.is_equal (l_buf___6) then
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
							end
							if not (l_return or l_break) then
								if l_bp___0.is_void then
									l_bp___0 := l_buf___6
								end
								if a_dir___0 = 1 then
									l_buf___6 := l_buf___6.item.b_next
									if l_buf___6.is_void then
										l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
									end
								else
									l_buf___6 := l_buf___6.item.b_prev
									if l_buf___6.is_void then
										l_buf___6 := (create {P_GLOBALS_STATIC}).lastbuf.item
									end
								end
								if l_unload.to_boolean then
									l_count___2 := l_count___2 - 1
									l_bp___0 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
								elseif (l_buf___6.item.b_p_bl).to_boolean then
									l_count___2 := l_count___2 - 1
									l_bp___0 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
								end
								if l_bp___0.is_equal (l_buf___6) then
									(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E85: There is no listed buffer"))))).do_nothing
									Result := 0
									l_return := True
								end
							end
						end
						if not l_return then
							l_break := False
						end
				when 11 then -- if done
					if not l_return and then (l_buf___6.is_void) then
						if a_start___1 = 1 then
							if not l_unload.to_boolean then
								(create {P_MISC2_STATIC}).emsgn (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E86: Buffer %%ld does not exist")))), l_count___2.to_integer_32).do_nothing
							end
						elseif a_dir___0 = 1 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E87: Cannot go beyond last buffer"))))).do_nothing
						else
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E88: Cannot go before first buffer"))))).do_nothing
						end
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 28 -- skip if block
					end
				when 12 then -- if:;
						(create {P_GLOBALS_STATIC}).need_mouse_correct.item := 1
						if not (l_unload.to_boolean) then
							l_pos := -1 + 28 -- skip if block
						end
				when 13 then -- if:
						if a_action /= 4 then
							if (l_buf___6.item.b_ml.ml_mfp).is_void then
								if not (l_buf___6.item.b_p_bl).to_boolean then
									Result := 0
									l_return := True
								end
							end
						end
						if not (not l_return and then (not a_forceit.to_boolean)) then
							l_pos := -1 + 22 -- skip if block
						end
				when 14 then -- if:
						if not ((l_buf___6.item.bufIsChanged).to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 15 then -- if:
						if not (((create {P_OPTION_STATIC}).p_confirm.item.item).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L___0
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else:
						if not (((create {P_GLOBALS_STATIC}).cmdmod.item.item.confirm).to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if: | _L___0:
						if ((create {P_OPTION_STATIC}).p_write.item.item).to_boolean then
							l_buf___6.item.dialog_changed (0)
							if not (buf_valid (l_buf___6)).to_boolean then
								Result := 0
								l_return := True
							end
							if not l_return then
								if (l_buf___6.item.bufIsChanged).to_boolean then
									Result := 0
									l_return := True
								end
							end
						else
							l_tmp___10 := gettext (ce_string ("E89: No write since last change for buffer %%ld (add ! to override)"));
							(create {P_MISC2_STATIC}).emsgn (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___10), (l_buf___6.item.b_fnum).to_integer_32).do_nothing
							Result := 0
							l_return := True
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_tmp___10 := gettext (ce_string ("E89: No write since last change for buffer %%ld (add ! to override)"));
						(create {P_MISC2_STATIC}).emsgn (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___10), (l_buf___6.item.b_fnum).to_integer_32).do_nothing
						Result := 0
						l_return := True
				when 22 then -- if done | if done | if done
						if not l_return then
							l_bp___0 := (create {P_GLOBALS_STATIC}).firstbuf.item
							from
							until
								not (not (l_break) and then (not l_bp___0.is_void))
							loop
								l_break := False
								if (l_bp___0.item.b_p_bl).to_boolean then
									if not l_bp___0.is_equal (l_buf___6) then
										l_break := True
									end
								end
								if not (l_return or l_break) then
									l_bp___0 := l_bp___0.item.b_next
								end
							end
							l_break := False
							if l_bp___0.is_void then
								if l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
									if a_action = 2 then
										(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E90: Cannot unload last buffer"))))).do_nothing
										Result := 0
										l_return := True
									end
									if not l_return then
										(create {P_WINDOW_STATIC}).close_windows (l_buf___6, 1);
										(create {P_MARK_STATIC}).setpcmark
										if a_forceit.to_boolean then
											l_tmp___13 := 8
										else
											l_tmp___13 := 0
										end
										l_retval := (create {P_EX_CMDS_STATIC}).do_ecmd (0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), (1).to_integer_32, l_tmp___13, (create {P_GLOBALS_STATIC}).curwin.item)
										if not l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
											if (buf_valid (l_buf___6)).to_boolean then
												if l_buf___6.item.b_nwindows = 0 then
													close_buffer (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer), l_buf___6, a_action)
												end
											end
										end
										Result := l_retval
										l_return := True
									end
								end
							end
						end
						if not l_return then
							from
							until
								(l_break)
							loop
								l_break := False
								if l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
									if ((create {P_GLOBALS_STATIC}).firstwin.item).is_equal ((create {P_GLOBALS_STATIC}).lastwin.item) then
										if ((create {P_GLOBALS_STATIC}).first_tabpage.item.item.tp_next).is_void then
											l_break := True
										end
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									(create {P_WINDOW_STATIC}).win_close ((create {P_GLOBALS_STATIC}).curwin.item, 0)
								end
							end
							l_break := False
							if not l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
								(create {P_WINDOW_STATIC}).close_windows (l_buf___6, 0)
								if not l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
									if (buf_valid (l_buf___6)).to_boolean then
										if l_buf___6.item.b_nwindows <= 0 then
											close_buffer (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer), l_buf___6, a_action)
										end
									end
								end
								Result := 1
								l_return := True
							end
						end
						if l_return then
							l_pos := -1 + 28 -- skip if block
						end
				when 23 then -- if:
						l_buf___6 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
						l_bp___0 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
						if ((create {P_GLOBALS_STATIC}).au_new_curbuf.item).is_void then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						if (buf_valid ((create {P_GLOBALS_STATIC}).au_new_curbuf.item)).to_boolean then
							l_buf___6 := (create {P_GLOBALS_STATIC}).au_new_curbuf.item
						else
							l_pos := -1 + 26 -- goto _L___1
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else: | _L___1:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen > 0 then
							l_jumpidx := (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistidx - 1
							if l_jumpidx < 0 then
								l_jumpidx := (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen - 1
							end
							l_forward := l_jumpidx
							from
							until
								not (not (l_break) and then (l_jumpidx /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistidx))
							loop
								l_break := False
								l_buf___6 := buflist_findnr ((create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplist[l_jumpidx].fmark.fnum)
								if not l_buf___6.is_void then
									if l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
										l_buf___6 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
									elseif not (l_buf___6.item.b_p_bl).to_boolean then
										l_buf___6 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
									elseif (l_buf___6.item.b_ml.ml_mfp).is_void then
										if l_bp___0.is_void then
											l_bp___0 := l_buf___6
										end
										l_buf___6 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
									end
								end
								if not l_buf___6.is_void then
									l_break := True
								end
								if not (l_return or l_break) and then (not l_jumpidx.to_boolean) then
									if (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistidx = (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen then
										l_break := True
									end
								end
								if not (l_return or l_break) then
									l_jumpidx := l_jumpidx - 1
									if l_jumpidx < 0 then
										l_jumpidx := (create {P_GLOBALS_STATIC}).curwin.item.item.w_jumplistlen - 1
									end
									if l_jumpidx = l_forward then
										l_break := True
									end
								end
							end
							l_break := False
						end
				when 27 then
						if l_buf___6.is_void then
							l_forward := 1
							l_buf___6 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_next
							from
							until
								(l_break)
							loop
								l_break := False
								l_continue := False
								if l_buf___6.is_void then
									if not l_forward.to_boolean then
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										l_buf___6 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_prev
										l_forward := 0
										l_continue := True
									end
								end
								if not (l_return or l_break or l_continue) and then (l_buf___6.item.b_help = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_help) then
									if (l_buf___6.item.b_p_bl).to_boolean then
										if not (l_buf___6.item.b_ml.ml_mfp).is_void then
											l_break := True
										end
										if not (l_return or l_break or l_continue) and then (l_bp___0.is_void) then
											l_bp___0 := l_buf___6
										end
									end
								end
								if not (l_return or l_break or l_continue) then
									if l_forward.to_boolean then
										l_buf___6 := l_buf___6.item.b_next
									else
										l_buf___6 := l_buf___6.item.b_prev
									end
								end
								if (not l_break) then
									
								end
							end
							l_break := False
							l_continue := False
						end
						if l_buf___6.is_void then
							l_buf___6 := l_bp___0
						end
						if l_buf___6.is_void then
							l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
							from
							until
								not (not (l_break) and then (not l_buf___6.is_void))
							loop
								l_break := False
								if (l_buf___6.item.b_p_bl).to_boolean then
									if not l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
										l_break := True
									end
								end
								if not (l_return or l_break or l_continue) then
									l_buf___6 := l_buf___6.item.b_next
								end
							end
							l_break := False
						end
						if l_buf___6.is_void then
							if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_next).is_void then
								l_buf___6 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_next
							else
								l_buf___6 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_prev
							end
						end
				when 28 then -- if done | if done | if done
					if not l_return and then (a_action = 1) then
						if (((create {P_OPTION_STATIC}).swb_flags.item.item).bit_and ({NATURAL_32} 1)).to_boolean then
							if (not ((create {P_WINDOW_STATIC}).buf_jump_open_win (l_buf___6)).is_void) then
								Result := 1
								l_return := True
							end
						end
						if not l_return and then ((((create {P_OPTION_STATIC}).swb_flags.item.item).bit_and ({NATURAL_32} 2)).to_boolean) then
							if (not ((create {P_WINDOW_STATIC}).buf_jump_open_tab (l_buf___6)).is_void) then
								Result := 1
								l_return := True
							end
						end
						if not l_return then
							if ((create {P_WINDOW_STATIC}).win_split (0, 0)) = 0 then
								Result := 0
								l_return := True
							end
						end
					end
					if not l_return and then (l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item)) then
						Result := 1
						l_return := True
					end
					if not (not l_return and then (a_action = 0)) then
						l_pos := -1 + 36 -- skip if block
					end
				when 29 then -- if:
						if (((create {P_GLOBALS_STATIC}).curbuf.item).item.can_abandon (a_forceit)).to_boolean then
							l_pos := -1 + 36 -- skip if block
						end
				when 30 then -- if:
						if not (((create {P_OPTION_STATIC}).p_confirm.item.item).to_boolean) then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						l_pos := -1 + 34 -- goto _L___2
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 33 then -- else:
						if not (((create {P_GLOBALS_STATIC}).cmdmod.item.item.confirm).to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 34 then -- if: | _L___2:
						if ((create {P_OPTION_STATIC}).p_write.item.item).to_boolean then
							((create {P_GLOBALS_STATIC}).curbuf.item).item.dialog_changed (0)
							if not (buf_valid (l_buf___6)).to_boolean then
								Result := 0
								l_return := True
							end
						end
				when 35 then -- if done
						if not l_return then
							if (((create {P_GLOBALS_STATIC}).curbuf.item).item.bufIsChanged).to_boolean then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_nowrtmsg.item)))))).do_nothing
								Result := 0
								l_return := True
							end
						end
				when 36 then -- if done | if done
					if not l_return then
						set_curbuf (l_buf___6, a_action)
						if a_action = 1 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_scb := 0
						end
						if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						Result := 1
					end
				when 37 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_curbuf (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_action: INTEGER_32)
		local
			l_prevbuf: CE_POINTER [PD_FILE_BUFFER]
			l_unload: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: CE_POINTER [PD_WINDOW_S]
		do
			if a_action = 2 then
				l_tmp := 1
			elseif a_action = 3 then
				l_tmp := 1
			elseif a_action = 4 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			l_unload := l_tmp;
			(create {P_MARK_STATIC}).setpcmark
			if not ((create {P_GLOBALS_STATIC}).cmdmod.item.item.keepalt).to_boolean then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_alt_fnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum
			end
			((create {P_GLOBALS_STATIC}).curwin.item).item.buflist_altfpos;
			(create {P_GLOBALS_STATIC}).VIsual_reselect.item := 0
			l_prevbuf := (create {P_GLOBALS_STATIC}).curbuf.item;
			(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFLEAVE, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
			if (buf_valid (l_prevbuf)).to_boolean then
				if not ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
					if l_unload.to_boolean then
						(create {P_WINDOW_STATIC}).close_windows (l_prevbuf, 0)
					end
					if (buf_valid (l_prevbuf)).to_boolean then
						if not ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
							if l_prevbuf.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
								(create {P_UNDO_STATIC}).u_sync (0)
							end
							if l_unload.to_boolean then
								l_tmp___5 := a_action
							else
								if a_action = 0 then
									if (l_prevbuf.item.buf_hide).to_boolean then
										l_tmp___2 := 0
									elseif (l_prevbuf.item.bufIsChanged).to_boolean then
										l_tmp___2 := 0
									else
										l_tmp___2 := 2
									end
								else
									l_tmp___2 := 0
								end
								l_tmp___5 := l_tmp___2
							end
							if l_prevbuf.is_equal ((create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer) then
								l_tmp___6 := (create {P_GLOBALS_STATIC}).curwin.item
							else
								l_tmp___6 := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
							end
							close_buffer (l_tmp___6, l_prevbuf, l_tmp___5)
						end
					end
				end
			end
			if (buf_valid (a_buf___6)).to_boolean then
				if not a_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
					if not ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
						a_buf___6.item.enter_buffer
					end
				end
			end
		end

	do_autochdir
		do
			if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
				if ((create {P_MISC2_STATIC}).vim_chdirfile ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname)) = 1 then
					(create {P_FILEIO_STATIC}).shorten_fnames (1)
				end
			end
		end

	buflist_new (a_ffname, a_sfname: CE_POINTER [NATURAL_8]; a_lnum: INTEGER_32; a_flags___0: INTEGER_32): CE_POINTER [PD_FILE_BUFFER]
		local
			l_sfname: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_ffname: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_st: CE_ARRAY [SD_STAT]
			l_tmp___5: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_sfname.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_ffname.make (<<1>>)
			create {CE_CLASS_POINTER [PD_FILE_BUFFER]} l_buf___6.make
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sfname.item := a_sfname
					l_ffname.item := a_ffname
					fname_expand ((create {P_GLOBALS_STATIC}).curbuf.item, l_ffname, l_sfname)
					if (l_sfname.item).is_void then
						l_st.item.st_dev := (-1).to_natural_64
					elseif (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_sfname.item), l_st)) < 0 then
						l_st.item.st_dev := (-1).to_natural_64
					end
					if not (l_ffname.item).is_void then
						if not ((a_flags___0).bit_and (4)).to_boolean then
							l_buf___6 := buflist_findname_stat (l_ffname.item, l_st)
							if not l_buf___6.is_void then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ffname.item))
								if a_lnum /= 0 then
									l_buf___6.item.buflist_setfpos ((create {P_GLOBALS_STATIC}).curwin.item, a_lnum, 0, 0)
								end
								(create {P_OPTION_STATIC}).buf_copy_options (l_buf___6, 0)
								if ((a_flags___0).bit_and (2)).to_boolean then
									if not (l_buf___6.item.b_p_bl).to_boolean then
										l_buf___6.item.b_p_bl := 1
										if not ((a_flags___0).bit_and (4)).to_boolean then
											(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFADD, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, l_buf___6).do_nothing
										end
									end
								end
								Result := l_buf___6
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_buf___6 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
						if not (((a_flags___0).bit_and (1)).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 2 then -- if:
						if ((create {P_GLOBALS_STATIC}).curbuf.item).is_void then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void) then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_nwindows <= 1) then
							l_pos := -1 + 11 -- skip if block
						end
				when 5 then -- if:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_mfp).is_void) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 8 then -- else:
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count /= 1 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if (((create {P_MEMLINE_STATIC}).ml_get ((1).to_integer_32)).item).to_integer_32 /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						l_buf___6 := (create {P_GLOBALS_STATIC}).curbuf.item
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bl).to_boolean then
							(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFDELETE, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
						end
						if l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
							(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFWIPEOUT, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
						end
						if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
							Result := (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return and then (l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item)) then
							(create {P_OPTION_STATIC}).clear_string_option (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_bh")));
							(create {P_OPTION_STATIC}).clear_string_option (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_bt")))
						end
				when 11 then -- if done | if done | if done | if done | if done | if done | if done
					if l_return then
						l_pos := -1 + 17 -- skip if block
					end
				when 12 then -- if:
						if l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item).is_void) then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L___0:
						l_buf___6 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_cast (((create {P_MISC2_STATIC}).alloc_clear ((create {PD_FILE_BUFFER}.make).structure_size.to_natural_32)))
						if l_buf___6.is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ffname.item))
							Result := (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
							l_return := True
						end
				when 17 then -- if done | if done
					if l_return then
						l_pos := -1 + 23 -- skip if block
					end
				when 18 then -- if:
						if not (l_ffname.item).is_void then
							l_buf___6.item.b_ffname := l_ffname.item
							l_buf___6.item.b_sfname := (create {P_MISC2_STATIC}).vim_strsave (l_sfname.item)
						end
						l_buf___6.item.clear_wininfo
						l_buf___6.item.b_wininfo := create {CE_CLASS_POINTER [PD_WININFO_S]}.make_cast (((create {P_MISC2_STATIC}).alloc_clear ((create {PD_WININFO_S}.make).structure_size.to_natural_32)))
						if (l_ffname.item).is_void then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if (l_buf___6.item.b_ffname).is_void then
							l_pos := -1 + 22 -- goto _L___1
						elseif (l_buf___6.item.b_sfname).is_void then
							l_pos := -1 + 22 -- goto _L___1
						else
							l_pos := -1 + 21 -- goto _L___2
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 21 then -- else: | _L___2:
						if not ((l_buf___6.item.b_wininfo).is_void) then
							l_pos := -1 + 23 -- skip if block
						end
				when 22 then -- if: | _L___1:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6.item.b_ffname))
						l_buf___6.item.b_ffname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6.item.b_sfname))
						l_buf___6.item.b_sfname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						if not l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
							l_buf___6.item.free_buffer
						end
						Result := (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
						l_return := True
				when 23 then -- if done | if done
					if not l_return then
						if l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
							l_buf___6.item.buf_freeall (0)
							if not l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
								Result := (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
								l_return := True
							end
							if not l_return then
								if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
									Result := (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
									l_return := True
								end
							end
							if not l_return then
								l_buf___6.item.free_buffer_stuff (0)
							end
						else
							l_buf___6.item.b_next := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
							if ((create {P_GLOBALS_STATIC}).firstbuf.item).is_void then
								l_buf___6.item.b_prev := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer);
								(create {P_GLOBALS_STATIC}).firstbuf.item := l_buf___6
							else
								(create {P_GLOBALS_STATIC}).lastbuf.item.item.b_next := l_buf___6
								l_buf___6.item.b_prev := (create {P_GLOBALS_STATIC}).lastbuf.item
							end
							(create {P_GLOBALS_STATIC}).lastbuf.item := l_buf___6
							l_tmp___5 := top_file_num.item
							top_file_num.item := top_file_num.item + 1
							l_buf___6.item.b_fnum := l_tmp___5
							if top_file_num.item < 0 then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("W14: Warning: List of file names overflow"))))).do_nothing
								if (create {P_GLOBALS_STATIC}).emsg_silent.item = 0 then
									(create {P_TERM_STATIC}).out_flush;
									(create {P_UI_STATIC}).ui_delay (3_000, 1)
								end
								top_file_num.item := 1
							end
							(create {P_OPTION_STATIC}).buf_copy_options (l_buf___6, 2)
						end
					end
					if not l_return then
						(l_buf___6.item.b_wininfo).item.wi_fpos.lnum := a_lnum;
						(l_buf___6.item.b_wininfo).item.wi_win := (create {P_GLOBALS_STATIC}).curwin.item;
						(create {CE_CLASS_POINTER [PD_DICTVAR_S]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_vars"))).item.init_var_dict (create {CE_CLASS_POINTER [PD_DICTITEM_S]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_bufvar")));
						(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_s") + (create {PD_SYNBLOCK_T}.make).offset_of ("b_keywtab"))).item.hash_init;
						(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_s") + (create {PD_SYNBLOCK_T}.make).offset_of ("b_keywtab_ic"))).item.hash_init
						l_buf___6.item.b_fname := l_buf___6.item.b_sfname
						if l_st.item.st_dev = 0xffffffffffffffff then
							l_buf___6.item.b_dev_valid := 0
						else
							l_buf___6.item.b_dev_valid := 1
							l_buf___6.item.b_dev := l_st.item.st_dev
							l_buf___6.item.b_ino := l_st.item.st_ino
						end
						l_buf___6.item.b_u_synced := 1
						l_buf___6.item.b_flags := 6
						if ((a_flags___0).bit_and (4)).to_boolean then
							l_buf___6.item.b_flags := (l_buf___6.item.b_flags).bit_or ((128))
						end
						l_buf___6.item.buf_clear_file
						l_buf___6.item.clrallmarks
						l_buf___6.item.fmarks_check_names
						if ((a_flags___0).bit_and (2)).to_boolean then
							l_buf___6.item.b_p_bl := 1
						else
							l_buf___6.item.b_p_bl := 0
						end
						if not ((a_flags___0).bit_and (4)).to_boolean then
							(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFNEW, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, l_buf___6).do_nothing
							if ((a_flags___0).bit_and (2)).to_boolean then
								(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFADD, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, l_buf___6).do_nothing
							end
							if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
								Result := (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
								l_return := True
							end
						end
					end
					if not l_return then
						Result := l_buf___6
					end
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	buflist_getfile (a_n: INTEGER_32; a_lnum: INTEGER_32; a_options___0, a_forceit: INTEGER_32): INTEGER_32
		local
			l_lnum: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_fpos: CE_POINTER [PD_POS_T]
			l_col: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := a_lnum
					l_wp___0 := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
					l_buf___6 := buflist_findnr (a_n)
					if l_buf___6.is_void then
						if ((a_options___0).bit_and (2)).to_boolean then
							if a_n = 0 then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_noalt.item)))))).do_nothing
							else
								l_tmp___0 := gettext (ce_string ("E92: Buffer %%ld not found"));
								(create {P_MISC2_STATIC}).emsgn (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0), a_n.to_integer_32).do_nothing
							end
						else
							l_tmp___0 := gettext (ce_string ("E92: Buffer %%ld not found"));
							(create {P_MISC2_STATIC}).emsgn (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0), a_n.to_integer_32).do_nothing
						end
						Result := 0
						l_return := True
					end
					if not l_return and then (l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item)) then
						Result := 1
						l_return := True
					end
					if not l_return then
						if ((create {P_EX_GETLN_STATIC}).text_locked).to_boolean then
							(create {P_EX_GETLN_STATIC}).text_locked_msg
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						if ((create {P_EX_GETLN_STATIC}).curbuf_locked).to_boolean then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if l_lnum = 0 then
							l_fpos := l_buf___6.item.buflist_findfpos
							l_lnum := l_fpos.item.lnum
							l_col := l_fpos.item.col
						else
							l_col := 0
						end
						if not (((a_options___0).bit_and (4)).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 2 then -- if:
						if (((create {P_OPTION_STATIC}).swb_flags.item.item).bit_and ({NATURAL_32} 1)).to_boolean then
							l_wp___0 := (create {P_WINDOW_STATIC}).buf_jump_open_win (l_buf___6)
						end
						if l_wp___0.is_void then
							if (((create {P_OPTION_STATIC}).swb_flags.item.item).bit_and ({NATURAL_32} 2)).to_boolean then
								l_wp___0 := (create {P_WINDOW_STATIC}).buf_jump_open_tab (l_buf___6)
							end
						end
						if not (l_wp___0.is_void) then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if not ((((create {P_OPTION_STATIC}).swb_flags.item.item).bit_and ({NATURAL_32} 12)).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (((create {P_MEMLINE_STATIC}).ml_get ((1).to_integer_32)).item).to_integer_32 /= 0 then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if (((create {P_OPTION_STATIC}).swb_flags.item.item).bit_and ({NATURAL_32} 8)).to_boolean then
							(create {P_EX_DOCMD_STATIC}).tabpage_new
						elseif ((create {P_WINDOW_STATIC}).win_split (0, 0)) = 0 then
							Result := 0
							l_return := True
						end
						if not l_return then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_scb := 0
						end
				when 8 then -- if done | if done | if done | if done
					if not l_return then
						(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item + 1
						if ((create {P_EX_CMDS_STATIC}).getfile (l_buf___6.item.b_fnum, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), (a_options___0).bit_and (1), l_lnum, a_forceit)) <= 0 then
							(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item - 1
							if not ((create {P_OPTION_STATIC}).p_sol.item.item).to_boolean then
								if l_col /= 0 then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_col;
									(create {P_MISC2_STATIC}).check_cursor_col;
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0;
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
								end
							end
							Result := 1
							l_return := True
						end
					end
					if not l_return then
						(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item - 1
						Result := 0
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	buflist_findname_exp (a_fname: CE_POINTER [NATURAL_8]): CE_POINTER [PD_FILE_BUFFER]
		local
			l_ffname: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
		do
			l_buf___6 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
			l_ffname := (create {P_MISC1_STATIC}).FullName_save (a_fname, 1)
			if not l_ffname.is_void then
				l_buf___6 := buflist_findname (l_ffname);
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ffname))
			end
			Result := l_buf___6
		end

	buflist_findname (a_ffname: CE_POINTER [NATURAL_8]): CE_POINTER [PD_FILE_BUFFER]
		local
			l_st: CE_ARRAY [SD_STAT]
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)

			if (stat (create {CE_INTEGER_8_POINTER}.make_cast (a_ffname), l_st)) < 0 then
				l_st.item.st_dev := (-1).to_natural_64
			end
			Result := (buflist_findname_stat (a_ffname, l_st))
		end

	buflist_findname_stat (a_ffname: CE_POINTER [NATURAL_8]; a_stp: CE_POINTER [SD_STAT]): CE_POINTER [PD_FILE_BUFFER]
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_return: BOOLEAN
		do
			l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
			from
			until
				not (not (l_return) and then (not l_buf___6.is_void))
			loop
				if ((l_buf___6.item.b_flags).bit_and (128)) = 0 then
					if not (l_buf___6.item.otherfile_buf (a_ffname, a_stp)).to_boolean then
						Result := l_buf___6
						l_return := True
					end
				end
				if not l_return then
					l_buf___6 := l_buf___6.item.b_next
				end
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
			end
		end

	buflist_findpat (a_pattern, a_pattern_end: CE_POINTER [NATURAL_8]; a_unlisted, a_diffmode: INTEGER_32): INTEGER_32
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_prog: CE_POINTER [PD_REGPROG_T]
			l_match: INTEGER_32
			l_find_listed: INTEGER_32
			l_pat: CE_POINTER [NATURAL_8]
			l_patend: CE_POINTER [NATURAL_8]
			l_attempt: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_toggledollar: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_match := -1
					if not (a_pattern_end.is_equal (a_pattern + 1)) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if (a_pattern.item).to_integer_32 /= 37 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___1
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if (a_pattern.item).to_integer_32 /= 35 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L___1:
						if (a_pattern.item).to_integer_32 = 37 then
							l_match := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum
						else
							l_match := (create {P_GLOBALS_STATIC}).curwin.item.item.w_alt_fnum
						end
						if a_diffmode.to_boolean then
							if not ((create {P_DIFF_STATIC}).diff_mode_buf ((buflist_findnr (l_match)))).to_boolean then
								l_match := -1
							end
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 9 -- goto _L___0
				when 8 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 28
				when 9 then -- else: | _L___0:
						l_pat := (create {P_FILEIO_STATIC}).file_pat_to_reg_pat (a_pattern, a_pattern_end, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), 0)
						if l_pat.is_void then
							Result := (-1)
							l_return := True
						end
						if l_return then
							l_pos := -1 + 27 -- skip if block
						end
				when 10 then -- if:
						l_patend := (l_pat + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_pat))).to_integer_32) - 1
						if (l_patend.c_pointer.to_integer_32).to_natural_32 > (l_pat.c_pointer.to_integer_32).to_natural_32 then
							if (l_patend.item).to_integer_32 = 36 then
								l_tmp___2 := 1
							else
								l_tmp___2 := 0
							end
						else
							l_tmp___2 := 0
						end
						l_toggledollar := l_tmp___2
						l_find_listed := 1
				when 11 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 27 -- skip loop
						end
				when 12 then -- loop body:
						l_break := False
						l_attempt := 0
				when 13 then -- loop condition:
						if not (not (l_return or l_break) and then (l_attempt <= 3)) then
							l_pos := -1 + 26 -- skip loop
						end
				when 14 then -- loop body:
						l_break := False
						if l_toggledollar.to_boolean then
							if l_attempt < 2 then
								l_patend.item := (('%/0/').code).to_natural_8
							else
								l_patend.item := (('$').code).to_natural_8
							end
						end
						l_p___0 := l_pat
						if (l_p___0.item).to_integer_32 = 94 then
							if not ((l_attempt).bit_and (1)).to_boolean then
								l_p___0 := l_p___0 + 1
							end
						end
						if ((create {P_OPTION_STATIC}).p_magic.item.item).to_boolean then
							l_tmp___3 := 1
						else
							l_tmp___3 := 0
						end
						l_prog := (create {P_REGEXP_STATIC}).vim_regcomp (l_p___0, l_tmp___3)
						if l_prog.is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pat))
							Result := (-1)
							l_return := True
						end
						if l_return then
							l_pos := -1 + 25 -- skip if block
						end
				when 15 then -- if:
						l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
				when 16 then -- loop condition:
						if not (not (l_break) and then (not l_buf___6.is_void)) then
							l_pos := -1 + 24 -- skip loop
						end
				when 17 then -- loop body:
						l_break := False
						if l_buf___6.item.b_p_bl /= l_find_listed then
							l_pos := -1 + 23 -- skip if block
						end
				when 18 then -- if:
						if a_diffmode.to_boolean then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 21 then -- else:
						if not (((create {P_DIFF_STATIC}).diff_mode_buf (l_buf___6)).to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 22 then -- if: | _L:
						if not (buflist_match (l_prog, l_buf___6)).is_void then
							if l_match >= 0 then
								l_match := -2
								l_break := True
							end
							if not (l_break) then
								l_match := l_buf___6.item.b_fnum
							end
						end
				when 23 then -- if done | if done
						if not (l_break) then
							l_buf___6 := l_buf___6.item.b_next
						end
						l_pos := -1 + 16 -- back to loop condition
				when 24 then -- loop done
						l_break := False;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_prog))
						if l_match >= 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_attempt := l_attempt + 1
						end
				when 25 then -- if done
						l_pos := -1 + 13 -- back to loop condition
				when 26 then -- loop done
						if not l_return then
							l_break := False
							if not a_unlisted.to_boolean then
								l_break := True
							elseif not l_find_listed.to_boolean then
								l_break := True
							elseif l_match /= -1 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_find_listed := 0
							end
						end
						l_pos := -1 + 11 -- back to loop condition
				when 27 then -- loop done | if done
						if not l_return then
							l_break := False;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pat))
						end
				when 28 then
					if not l_return then
						if l_match = -2 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E93: More than one match for %%s")))), a_pattern).do_nothing
						elseif l_match < 0 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E94: No matching buffer for %%s")))), a_pattern).do_nothing
						end
						Result := l_match
					end
				when 29 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	buflist_match (a_prog: CE_POINTER [PD_REGPROG_T]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]): CE_POINTER [NATURAL_8]
		require
			not a_buf___6.is_void
		local
			l_match: CE_POINTER [NATURAL_8]
		do
			l_match := fname_match (a_prog, a_buf___6.item.b_sfname)
			if l_match.is_void then
				l_match := fname_match (a_prog, a_buf___6.item.b_ffname)
			end
			Result := l_match
		end

	fname_match (a_prog: CE_POINTER [PD_REGPROG_T]; a_name___1: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_match: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
		do
			create {CE_CLASS_ARRAY [PD_REGMATCH_T]} l_regmatch___0.make (<<1>>)

			l_match := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if not a_name___1.is_void then
				l_regmatch___0.item.regprog := a_prog
				l_regmatch___0.item.rm_ic := 0
				if (l_regmatch___0.item.vim_regexec (a_name___1, 0)).to_boolean then
					l_match := a_name___1
				else
					l_p___0 := (create {P_MISC1_STATIC}).home_replace_save (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), a_name___1)
					if not l_p___0.is_void then
						if (l_regmatch___0.item.vim_regexec (l_p___0, 0)).to_boolean then
							l_match := a_name___1
						end
					end
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
				end
			end
			Result := l_match
		end

	buflist_findnr (a_nr: INTEGER_32): CE_POINTER [PD_FILE_BUFFER]
		local
			l_nr: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_return: BOOLEAN
		do
			l_nr := a_nr
			if l_nr = 0 then
				l_nr := (create {P_GLOBALS_STATIC}).curwin.item.item.w_alt_fnum
			end
			l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
			from
			until
				not (not (l_return) and then (not l_buf___6.is_void))
			loop
				if l_buf___6.item.b_fnum = l_nr then
					Result := l_buf___6
					l_return := True
				end
				if not l_return then
					l_buf___6 := l_buf___6.item.b_next
				end
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
			end
		end

	buflist_nr2name (a_n, a_fullname, a_helptail: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [PD_FILE_BUFFER]
			l_return: BOOLEAN
		do
			l_buf___6 := buflist_findnr (a_n)
			if l_buf___6.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				if a_fullname.to_boolean then
					l_tmp := l_buf___6.item.b_ffname
				else
					l_tmp := l_buf___6.item.b_fname
				end
				if a_helptail.to_boolean then
					l_tmp___0 := l_buf___6
				else
					l_tmp___0 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
				end
				Result := ((create {P_MISC1_STATIC}).home_replace_save (l_tmp___0, l_tmp))
			end
		end

	buflist_list (a_eap: CE_POINTER [PD_EXARG])
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___15: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_continue := False
				if not l_buf___6.is_void then
					if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_return or l_break or l_continue) and then (not (l_buf___6.item.b_p_bl).to_boolean) then
					if not (a_eap.item.forceit).to_boolean then
						l_continue := True
					end
				end
				if not (l_return or l_break or l_continue) then
					(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
					if not (l_buf___6.item.buf_spname).is_void then
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item), (l_buf___6.item.buf_spname)).do_nothing
					else
						(create {P_MISC1_STATIC}).home_replace (l_buf___6, l_buf___6.item.b_fname, (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096, 1)
					end
					if ((l_buf___6.item.b_flags).bit_and (64)).to_boolean then
						l_tmp___4 := ('x').code
					else
						if (l_buf___6.item.bufIsChanged).to_boolean then
							l_tmp___2 := ('+').code
						else
							l_tmp___2 := (' ').code
						end
						l_tmp___4 := l_tmp___2
					end
					if not (l_buf___6.item.b_p_ma).to_boolean then
						l_tmp___6 := ('-').code
					else
						if (l_buf___6.item.b_p_ro).to_boolean then
							l_tmp___5 := ('=').code
						else
							l_tmp___5 := (' ').code
						end
						l_tmp___6 := l_tmp___5
					end
					if (l_buf___6.item.b_ml.ml_mfp).is_void then
						l_tmp___8 := (' ').code
					else
						if l_buf___6.item.b_nwindows = 0 then
							l_tmp___7 := ('h').code
						else
							l_tmp___7 := ('a').code
						end
						l_tmp___8 := l_tmp___7
					end
					if l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
						l_tmp___10 := ('%%').code
					else
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_alt_fnum = l_buf___6.item.b_fnum then
							l_tmp___9 := ('#').code
						else
							l_tmp___9 := (' ').code
						end
						l_tmp___10 := l_tmp___9
					end
					if (l_buf___6.item.b_p_bl).to_boolean then
						l_tmp___11 := (' ').code
					else
						l_tmp___11 := ('u').code
					end
					l_len := (create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_005).to_natural_32, ce_string ("%%3d%%c%%c%%c%%c%%c %"%%s%""), l_buf___6.item.b_fnum, l_tmp___11, l_tmp___10, l_tmp___8, l_tmp___6, l_tmp___4, (create {P_GLOBALS_STATIC}).NameBuff.item.item])
					l_i___0 := 40 - ((create {P_CHARSET_STATIC}).vim_strsize ((create {P_GLOBALS_STATIC}).IObuff.item))
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___13 := l_len
						l_len := l_len + 1;
						(create {P_GLOBALS_STATIC}).IObuff.item[l_tmp___13] := ((' ').code).to_natural_8
						l_i___0 := l_i___0 - 1
						if l_i___0 > 0 then
							if not (l_len < 1_007) then
								l_break := True
							end
						else
							l_break := True
						end
					end
					l_break := False
					if l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
						l_tmp___15 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
					else
						l_tmp___15 := (l_buf___6.item.buflist_findlnum)
					end
					(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item) + l_len, (1_025 - l_len).to_natural_32, (gettext (ce_string ("line %%ld"))), l_tmp___15]).do_nothing;
					(create {P_MESSAGE_STATIC}).msg_outtrans ((create {P_GLOBALS_STATIC}).IObuff.item).do_nothing;
					(create {P_TERM_STATIC}).out_flush;
					(create {P_UI_STATIC}).ui_breakcheck
				end
				if (not l_return and not l_break) then
					l_buf___6 := l_buf___6.item.b_next
				end
			end
			l_break := False
			l_continue := False
		end

	buflist_name_nr (a_fnum___0: INTEGER_32; a_fname: CE_POINTER [CE_POINTER [NATURAL_8]]; a_lnum: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_return: BOOLEAN
		do
			l_buf___6 := buflist_findnr (a_fnum___0)
			if l_buf___6.is_void then
				Result := 0
				l_return := True
			elseif (l_buf___6.item.b_fname).is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				a_fname.item := l_buf___6.item.b_fname
				a_lnum.item := l_buf___6.item.buflist_findlnum
				Result := 1
			end
		end

	setfname (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_ffname, a_sfname: CE_POINTER [NATURAL_8]; a_message: INTEGER_32): INTEGER_32
		local
			l_ffname: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_sfname: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_obuf: CE_POINTER [PD_FILE_BUFFER]
			l_st: CE_ARRAY [SD_STAT]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_ffname.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_sfname.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)

			l_ffname.item := a_ffname
			l_sfname.item := a_sfname
			l_obuf := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
			if (l_ffname.item).is_void then
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_buf___6.item.b_ffname));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_buf___6.item.b_sfname))
				a_buf___6.item.b_ffname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				a_buf___6.item.b_sfname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				l_st.item.st_dev := (-1).to_natural_64
			elseif (l_ffname.item.item).to_integer_32 = 0 then
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_buf___6.item.b_ffname));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_buf___6.item.b_sfname))
				a_buf___6.item.b_ffname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				a_buf___6.item.b_sfname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				l_st.item.st_dev := (-1).to_natural_64
			else
				fname_expand (a_buf___6, l_ffname, l_sfname)
				if (l_ffname.item).is_void then
					Result := 0
					l_return := True
				end
				if not l_return then
					if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_ffname.item), l_st)) < 0 then
						l_st.item.st_dev := (-1).to_natural_64
					end
					if not ((a_buf___6.item.b_flags).bit_and (128)).to_boolean then
						l_obuf := buflist_findname_stat (l_ffname.item, l_st)
					end
					if not l_obuf.is_void then
						if not l_obuf.is_equal (a_buf___6) then
							if not (l_obuf.item.b_ml.ml_mfp).is_void then
								if a_message.to_boolean then
									(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E95: Buffer with this name already exists"))))).do_nothing
								end
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ffname.item))
								Result := 0
								l_return := True
							end
							if not l_return then
								close_buffer (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer), l_obuf, 4)
							end
						end
					end
				end
				if not l_return then
					l_sfname.item := (create {P_MISC2_STATIC}).vim_strsave (l_sfname.item)
					if (l_ffname.item).is_void then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_sfname.item));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ffname.item))
						Result := 0
						l_return := True
					elseif (l_sfname.item).is_void then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_sfname.item));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ffname.item))
						Result := 0
						l_return := True
					end
				end
				if not l_return then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_buf___6.item.b_ffname));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_buf___6.item.b_sfname))
					a_buf___6.item.b_ffname := l_ffname.item
					a_buf___6.item.b_sfname := l_sfname.item
				end
			end
			if not l_return then
				a_buf___6.item.b_fname := a_buf___6.item.b_sfname
				if l_st.item.st_dev = 0xffffffffffffffff then
					a_buf___6.item.b_dev_valid := 0
				else
					a_buf___6.item.b_dev_valid := 1
					a_buf___6.item.b_dev := l_st.item.st_dev
					a_buf___6.item.b_ino := l_st.item.st_ino
				end
				a_buf___6.item.b_shortname := 0
				a_buf___6.item.buf_name_changed
				Result := 1
			end
		end

	setaltfname (a_ffname, a_sfname: CE_POINTER [NATURAL_8]; a_lnum: INTEGER_32): CE_POINTER [PD_FILE_BUFFER]
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
		do
			l_buf___6 := buflist_new (a_ffname, a_sfname, a_lnum, 0)
			if not l_buf___6.is_void then
				if not ((create {P_GLOBALS_STATIC}).cmdmod.item.item.keepalt).to_boolean then
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_alt_fnum := l_buf___6.item.b_fnum
				end
			end
			Result := l_buf___6
		end

	getaltfname (a_errmsg: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_fname: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_dummy___0: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_fname.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_dummy___0.make (<<1>>)

			if (buflist_name_nr (0, l_fname, l_dummy___0)) = 0 then
				if a_errmsg.to_boolean then
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_noalt.item)))))).do_nothing
				end
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := (l_fname.item)
			end
		end

	buflist_add (a_fname: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_return: BOOLEAN
		do
			l_buf___6 := buflist_new (a_fname, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), (0).to_integer_32, a_flags___0)
			if not l_buf___6.is_void then
				Result := (l_buf___6.item.b_fnum)
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	otherfile (a_ffname: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := (((create {P_GLOBALS_STATIC}).curbuf.item).item.otherfile_buf (a_ffname, create {CE_CLASS_POINTER [SD_STAT]}.make_shared (default_pointer)))
		end

	fileinfo (a_fullname, a_shorthelp, a_dont_truncate: INTEGER_32)
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_buffer: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [PD_FILE_BUFFER]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___20: CE_POINTER [INTEGER_8]
			l_tmp___25: CE_POINTER [INTEGER_8]
			l_tmp___27: CE_POINTER [INTEGER_8]
			l_tmp___34: INTEGER_32
			l_return: BOOLEAN
		do
			l_buffer := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 1_025)
			if l_buffer.is_void then
				l_return := True
			end
			if not l_return then
				if a_fullname > 1 then
					(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buffer), (1_025).to_natural_32, ce_string ("buf %%d: "), (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum]).do_nothing
					l_p___0 := l_buffer + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buffer))).to_integer_32
				else
					l_p___0 := l_buffer
				end
				l_tmp___0 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___0.item := (('%"').code).to_natural_8
				if not (((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_spname).is_void then
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), (((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_spname)).do_nothing
				else
					if not a_fullname.to_boolean then
						if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname).is_void then
							l_name___1 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname
						else
							l_name___1 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname
						end
					else
						l_name___1 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname
					end
					if a_shorthelp.to_boolean then
						l_tmp___2 := (create {P_GLOBALS_STATIC}).curbuf.item
					else
						l_tmp___2 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
					end
					(create {P_MISC1_STATIC}).home_replace (l_tmp___2, l_name___1, l_p___0, 1_025 - (l_p___0.distance (l_buffer)), 1)
				end
				if ((create {P_UNDO_STATIC}).curbufIsChanged).to_boolean then
					l_tmp___5 := ce_string (" ")
				elseif (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags).bit_and (88)).to_boolean then
					l_tmp___5 := ce_string (" ")
				elseif ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro).to_boolean then
					l_tmp___5 := ce_string (" ")
				else
					l_tmp___5 := ce_string ("")
				end
				if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro).to_boolean then
					if ((create {P_OPTION_STATIC}).shortmess (('r').code)).to_boolean then
						l_tmp___9 := ce_string ("[RO]")
					else
						l_tmp___9 := (gettext (ce_string ("[readonly]")))
					end
					l_tmp___11 := l_tmp___9
				else
					l_tmp___11 := ce_string ("")
				end
				if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags).bit_and (64)).to_boolean then
					l_tmp___13 := (gettext (ce_string ("[Read errors]")))
				else
					l_tmp___13 := ce_string ("")
				end
				if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags).bit_and (16)).to_boolean then
					if (((create {P_GLOBALS_STATIC}).curbuf.item).item.bt_dontwrite).to_boolean then
						l_tmp___16 := ce_string ("")
					else
						l_tmp___16 := (gettext (ce_string ("[New file]")))
					end
				else
					l_tmp___16 := ce_string ("")
				end
				if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags).bit_and (8)).to_boolean then
					if (((create {P_GLOBALS_STATIC}).curbuf.item).item.bt_dontwrite).to_boolean then
						l_tmp___20 := ce_string ("")
					else
						l_tmp___20 := (gettext (ce_string ("[Not edited]")))
					end
				else
					l_tmp___20 := ce_string ("")
				end
				if ((create {P_UNDO_STATIC}).curbufIsChanged).to_boolean then
					if ((create {P_OPTION_STATIC}).shortmess (('m').code)).to_boolean then
						l_tmp___25 := ce_string (" [+]")
					else
						l_tmp___25 := (gettext (ce_string (" [Modified]")))
					end
					l_tmp___27 := l_tmp___25
				else
					l_tmp___27 := ce_string (" ")
				end
				(create {P_MESSAGE_STATIC}).vim_snprintf_add ([create {CE_INTEGER_8_POINTER}.make_cast (l_buffer), (1_025).to_natural_32, ce_string ("%"%%s%%s%%s%%s%%s%%s"), l_tmp___27, l_tmp___20, l_tmp___16, l_tmp___13, l_tmp___11, l_tmp___5]).do_nothing
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > 1_000_000 then
					l_n := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum // ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count // 100)).to_integer_32
				else
					l_n := (((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum * 100) // (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count).to_integer_32
				end
				if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_and (1)).to_boolean then
					(create {P_MESSAGE_STATIC}).vim_snprintf_add ([create {CE_INTEGER_8_POINTER}.make_cast (l_buffer), (1_025).to_natural_32, ce_string ("%%s"), (gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).no_lines_msg.item))))]).do_nothing
				elseif ((create {P_OPTION_STATIC}).p_ru.item.item).to_boolean then
					if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count = 1 then
						(create {P_MESSAGE_STATIC}).vim_snprintf_add ([create {CE_INTEGER_8_POINTER}.make_cast (l_buffer), (1_025).to_natural_32, (gettext (ce_string ("1 line --%%d%%%%--"))), l_n]).do_nothing
					else
						(create {P_MESSAGE_STATIC}).vim_snprintf_add ([create {CE_INTEGER_8_POINTER}.make_cast (l_buffer), (1_025).to_natural_32, (gettext (ce_string ("%%ld lines --%%d%%%%--"))), (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count, l_n]).do_nothing
					end
				else
					(create {P_MESSAGE_STATIC}).vim_snprintf_add ([create {CE_INTEGER_8_POINTER}.make_cast (l_buffer), (1_025).to_natural_32, (gettext (ce_string ("line %%ld of %%ld --%%d%%%%-- col "))), (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count, l_n]).do_nothing;
					(create {P_MOVE_STATIC}).validate_virtcol
					l_len := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buffer))
					col_print (l_buffer + l_len.to_integer_32, {NATURAL_32} 1_025 - l_len, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + 1, (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol + 1)
				end
				if ((create {P_OPTION_STATIC}).shortmess (('f').code)).to_boolean then
					l_tmp___34 := 0
				else
					l_tmp___34 := 1
				end
				append_arg_number ((create {P_GLOBALS_STATIC}).curwin.item, l_buffer, 1_025, l_tmp___34).do_nothing
				if a_dont_truncate.to_boolean then
					(create {P_MESSAGE_STATIC}).msg_start
					l_n := (create {P_GLOBALS_STATIC}).msg_scroll.item;
					(create {P_GLOBALS_STATIC}).msg_scroll.item := 1;
					(create {P_MESSAGE_STATIC}).msg (l_buffer).do_nothing;
					(create {P_GLOBALS_STATIC}).msg_scroll.item := l_n
				else
					l_p___0 := (create {P_MESSAGE_STATIC}).msg_trunc_attr (l_buffer, 0, 0)
					if (create {P_GLOBALS_STATIC}).restart_edit.item /= 0 then
						(create {P_MESSAGE_STATIC}).set_keep_msg (l_p___0, 0)
					elseif ((create {P_GLOBALS_STATIC}).msg_scrolled.item).to_boolean then
						if not ((create {P_GLOBALS_STATIC}).need_wait_return.item).to_boolean then
							(create {P_MESSAGE_STATIC}).set_keep_msg (l_p___0, 0)
						end
					end
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buffer))
			end
		end

	col_print (a_buf___6: CE_POINTER [NATURAL_8]; a_buflen: NATURAL_32; a_col, a_vcol: INTEGER_32)
		do
			if a_col = a_vcol then
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), a_buflen, ce_string ("%%d"), a_col]).do_nothing
			else
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), a_buflen, ce_string ("%%d-%%d"), a_col, a_vcol]).do_nothing
			end
		end

	maketitle
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_t_str: CE_POINTER [NATURAL_8]
			l_i_name: CE_POINTER [NATURAL_8]
			l_i_str: CE_POINTER [NATURAL_8]
			l_maxlen: INTEGER_32
			l_len: INTEGER_32
			l_mustset: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_off___0: INTEGER_32
			l_use_sandbox: INTEGER_32
			l_save_called_emsg: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_use_sandbox___0: INTEGER_32
			l_save_called_emsg___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<1_025>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_t_str := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_i_str := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_maxlen := 0
					if not ((create {P_SCREEN_STATIC}).redrawing).to_boolean then
						(create {P_GLOBALS_STATIC}).need_maketitle.item := 1
						l_return := True
					end
					if not l_return then
						(create {P_GLOBALS_STATIC}).need_maketitle.item := 0
						if not ((create {P_OPTION_STATIC}).p_title.item.item).to_boolean then
							if not ((create {P_OPTION_STATIC}).p_icon.item.item).to_boolean then
								if (lasttitle.item.item).is_void then
									if (lasticon.item.item).is_void then
										l_return := True
									end
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_OPTION_STATIC}).p_title.item.item).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 2 then -- if:
						if (create {P_OPTION_STATIC}).p_titlelen.item.item > 0 then
							l_maxlen := (((create {P_OPTION_STATIC}).p_titlelen.item.item * (create {P_GLOBALS_STATIC}).Columns.item.item) // 100).to_integer_32
							if l_maxlen < 10 then
								l_maxlen := 10
							end
						end
						l_t_str := l_buf___6
						if ((create {P_OPTION_STATIC}).p_titlestring.item.item.item).to_integer_32 = 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (((create {P_GLOBALS_STATIC}).stl_syntax.item).bit_and (2)).to_boolean then
							l_use_sandbox := 0
							l_save_called_emsg := (create {P_GLOBALS_STATIC}).called_emsg.item
							l_use_sandbox := (create {P_OPTION_STATIC}).was_set_insecurely (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("titlestring")), 0);
							(create {P_GLOBALS_STATIC}).called_emsg.item := 0;
							((create {P_GLOBALS_STATIC}).curwin.item).item.build_stl_str_hl (l_t_str, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (1_025).to_natural_32), (create {P_OPTION_STATIC}).p_titlestring.item.item, l_use_sandbox, 0, l_maxlen, create {CE_CLASS_POINTER [PD_STL_HLREC]}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_STL_HLREC]}.make_shared (default_pointer)).do_nothing
							if ((create {P_GLOBALS_STATIC}).called_emsg.item).to_boolean then
								(create {P_OPTION_STATIC}).set_string_option_direct (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("titlestring")), -1, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 1, -5)
							end
							(create {P_GLOBALS_STATIC}).called_emsg.item := ((create {P_GLOBALS_STATIC}).called_emsg.item).bit_or (l_save_called_emsg)
						else
							l_t_str := (create {P_OPTION_STATIC}).p_titlestring.item.item
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 5 then -- else:
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname).is_void then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), (gettext (ce_string ("[No Name]")))).do_nothing
						else
							l_p___0 := (create {P_CHARSET_STATIC}).transstr (((create {P_MISC1_STATIC}).gettail ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname)));
							(create {P_MISC2_STATIC}).vim_strncpy (l_buf___6, l_p___0, (925).to_natural_32);
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
						end
						inspect ((((create {P_GLOBALS_STATIC}).curbuf.item).item.bufIsChanged) + (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro * 2) + (not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ma).to_boolean).to_integer * 4 -- switch 1 head
						when 1 then l_pos := -1 + 6
						when 2 then l_pos := -1 + 7
						when 3 then l_pos := -1 + 8
						when 4 then l_pos := -1 + 9
						when 6 then l_pos := -1 + 9
						when 5 then l_pos := -1 + 10
						when 7 then l_pos := -1 + 10
						else l_pos := -1 + 11
						end
				when 6 then -- switch 1, case 1
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string (" +")).do_nothing
						l_pos := -1 + 11 -- switch 1; break
				when 7 then -- switch 1, case 2
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string (" =")).do_nothing
						l_pos := -1 + 11 -- switch 1; break
				when 8 then -- switch 1, case 3
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string (" =+")).do_nothing
						l_pos := -1 + 11 -- switch 1; break
				when 9 then -- switch 1, case 4 | switch 1, case 6
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string (" -")).do_nothing
						l_pos := -1 + 11 -- switch 1; break
				when 10 then -- switch 1, case 5 | switch 1, case 7
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string (" -+")).do_nothing
						l_pos := -1 + 11 -- switch 1; break
				when 11 then -- switch 1, done:
						if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname).is_void then
							l_off___0 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))).to_integer_32
							l_tmp___4 := l_off___0
							l_off___0 := l_off___0 + 1
							l_buf___6[l_tmp___4] := ((' ').code).to_natural_8
							l_tmp___5 := l_off___0
							l_off___0 := l_off___0 + 1
							l_buf___6[l_tmp___5] := (('(').code).to_natural_8;
							(create {P_MISC1_STATIC}).home_replace ((create {P_GLOBALS_STATIC}).curbuf.item, (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname, l_buf___6 + l_off___0, 1_025 - l_off___0, 1)
							l_p___0 := (create {P_MISC1_STATIC}).gettail_sep (l_buf___6 + l_off___0)
							if l_p___0.is_equal (l_buf___6 + l_off___0) then
								(create {P_MISC2_STATIC}).vim_strncpy (l_buf___6 + l_off___0, create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("help")))), ((1_025 - l_off___0) - 1).to_natural_32)
							else
								l_p___0.item := (('%/0/').code).to_natural_8
							end
							l_p___0 := (create {P_CHARSET_STATIC}).transstr (l_buf___6 + l_off___0);
							(create {P_MISC2_STATIC}).vim_strncpy (l_buf___6 + l_off___0, l_p___0, ((1_025 - l_off___0) - 1).to_natural_32);
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string (")")).do_nothing
						end
						append_arg_number ((create {P_GLOBALS_STATIC}).curwin.item, l_buf___6, 1_025, 0).do_nothing
						if not ((create {P_GLOBALS_STATIC}).serverName.item).is_void then
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string (" - ")).do_nothing
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).serverName.item)).do_nothing
						else
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string (" - VIM")).do_nothing
						end
						if l_maxlen > 0 then
							l_len := (create {P_CHARSET_STATIC}).vim_strsize (l_buf___6)
							if l_len > l_maxlen then
								(create {P_MESSAGE_STATIC}).trunc_string (l_buf___6, l_buf___6, l_maxlen)
							end
						end
				when 12 then -- if done | if done
						l_mustset := ti_change (l_t_str, lasttitle.item)
						if ((create {P_OPTION_STATIC}).p_icon.item.item).to_boolean then
							l_i_str := l_buf___6
							if ((create {P_OPTION_STATIC}).p_iconstring.item.item.item).to_integer_32 /= 0 then
								if (((create {P_GLOBALS_STATIC}).stl_syntax.item).bit_and (1)).to_boolean then
									l_use_sandbox___0 := 0
									l_save_called_emsg___0 := (create {P_GLOBALS_STATIC}).called_emsg.item
									l_use_sandbox___0 := (create {P_OPTION_STATIC}).was_set_insecurely (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("iconstring")), 0);
									(create {P_GLOBALS_STATIC}).called_emsg.item := 0;
									((create {P_GLOBALS_STATIC}).curwin.item).item.build_stl_str_hl (l_i_str, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (1_025).to_natural_32), (create {P_OPTION_STATIC}).p_iconstring.item.item, l_use_sandbox___0, 0, 0, create {CE_CLASS_POINTER [PD_STL_HLREC]}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_STL_HLREC]}.make_shared (default_pointer)).do_nothing
									if ((create {P_GLOBALS_STATIC}).called_emsg.item).to_boolean then
										(create {P_OPTION_STATIC}).set_string_option_direct (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("iconstring")), -1, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 1, -5)
									end
									(create {P_GLOBALS_STATIC}).called_emsg.item := ((create {P_GLOBALS_STATIC}).called_emsg.item).bit_or (l_save_called_emsg___0)
								else
									l_i_str := (create {P_OPTION_STATIC}).p_iconstring.item.item
								end
							else
								if not (((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_spname).is_void then
									l_i_name := create {CE_NATURAL_8_POINTER}.make_cast ((((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_spname))
								else
									l_i_name := (create {P_MISC1_STATIC}).gettail ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname)
								end
								l_i_str.item := (('%/0/').code).to_natural_8
								l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_i_name))).to_integer_32
								if l_len > 100 then
									l_len := l_len - (100)
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_len := l_len + (((create {P_MBYTE_STATIC}).mb_tail_off (l_i_name, l_i_name + l_len)) + 1)
									end
									l_i_name := l_i_name + l_len
								end
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_i_str), create {CE_INTEGER_8_POINTER}.make_cast (l_i_name)).do_nothing;
								(create {P_CHARSET_STATIC}).trans_characters (l_i_str, 1_025)
							end
						end
						l_mustset := (l_mustset).bit_or ((ti_change (l_i_str, lasticon.item)))
						if l_mustset.to_boolean then
							resettitle
						end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ti_change (a_str___1: CE_POINTER [NATURAL_8]; a_last: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		require
			not a_last.is_void
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_str___1.is_void) = ((a_last.item).is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_str___1.is_void then
							l_pos := -1 + 7 -- skip if block
						end
				when 4 then -- if:
						if (a_last.item).is_void then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_str___1), create {CE_INTEGER_8_POINTER}.make_cast (a_last.item))) = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_last.item))
						if a_str___1.is_void then
							a_last.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						else
							a_last.item := (create {P_MISC2_STATIC}).vim_strsave (a_str___1)
						end
						Result := 1
						l_return := True
				when 7 then -- if done | if done | if done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	resettitle
		do
			(create {P_OS_UNIX_STATIC}).mch_settitle (lasttitle.item.item, lasticon.item.item)
		end

	append_arg_number (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_buf___6: CE_POINTER [NATURAL_8]; a_buflen, a_add_file: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_alist).item.al_ga.ga_len <= 1 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_p___0 := a_buf___6 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6))).to_integer_32
				if (l_p___0.distance (a_buf___6)) + 35 >= a_buflen then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_tmp___0 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___0.item := ((' ').code).to_natural_8
				l_tmp___1 := l_p___0
				l_p___0 := l_p___0 + 1
				l_tmp___1.item := (('(').code).to_natural_8
				if a_add_file.to_boolean then
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("file ")).do_nothing
					l_p___0 := l_p___0 + (5)
				end
				if (a_wp___0.item.w_arg_idx_invalid).to_boolean then
					l_tmp___2 := ce_string ("(%%d) of %%d)")
				else
					l_tmp___2 := ce_string ("%%d of %%d)")
				end
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), (a_buflen - (l_p___0.distance (a_buf___6))).to_natural_32, l_tmp___2, a_wp___0.item.w_arg_idx + 1, ((create {P_GLOBALS_STATIC}).curwin.item.item.w_alist).item.al_ga.ga_len]).do_nothing
				Result := 1
			end
		end

	fix_fname (a_fname: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		do
			Result := ((create {P_MISC1_STATIC}).FullName_save (a_fname, 1))
		end

	fname_expand (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_ffname, a_sfname: CE_POINTER [CE_POINTER [NATURAL_8]])
		require
			not a_ffname.is_void
		local
			l_return: BOOLEAN
		do
			if (a_ffname.item).is_void then
				l_return := True
			end
			if not l_return then
				if (a_sfname.item).is_void then
					a_sfname.item := a_ffname.item
				end
				a_ffname.item := fix_fname (a_ffname.item)
			end
		end

	do_modelines (a_flags___0: INTEGER_32)
		local
			l_lnum: INTEGER_32
			l_nmlines: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ml).to_boolean then
				l_return := True
			else
				l_nmlines := ((create {P_OPTION_STATIC}).p_mls.item.item).to_integer_32
				if l_nmlines = 0 then
					l_return := True
				end
			end
			if not l_return and then (entered.item.to_boolean) then
				l_return := True
			end
			if not l_return then
				entered.item := entered.item + 1
				l_lnum := (1).to_integer_32
				from
				until
					(l_break)
				loop
					l_break := False
					if l_lnum <= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
						if not (l_lnum <= l_nmlines.to_integer_32) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						if (chk_modeline (l_lnum, a_flags___0)) = 0 then
							l_nmlines := 0
						end
						l_lnum := l_lnum + 1
					end
				end
				l_break := False
				l_lnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
				from
				until
					(l_break)
				loop
					l_break := False
					if l_lnum > 0 then
						if l_lnum > l_nmlines.to_integer_32 then
							if not (l_lnum > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count - l_nmlines.to_integer_32) then
								l_break := True
							end
						else
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						if (chk_modeline (l_lnum, a_flags___0)) = 0 then
							l_nmlines := 0
						end
						l_lnum := l_lnum - 1
					end
				end
				l_break := False
				entered.item := entered.item - 1
			end
		end

	chk_modeline (a_lnum: INTEGER_32; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_e: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_linecopy___0: CE_POINTER [NATURAL_8]
			l_prev: INTEGER_32
			l_vers: INTEGER_32
			l_end: INTEGER_32
			l_retval: INTEGER_32
			l_save_sourcing_name: CE_POINTER [NATURAL_8]
			l_save_sourcing_lnum: INTEGER_32
			l_save_SID: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_e.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := 1
					l_prev := -1
					l_s := (create {P_MEMLINE_STATIC}).ml_get (a_lnum)
				when 1 then -- loop condition:
					if not (not (l_break) and then ((l_s.item).to_integer_32 /= 0)) then
						l_pos := -1 + 27 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if l_prev /= -1 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L___3
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 5 then -- else:
						if not (((create {P_MISC2_STATIC}).vim_isspace (l_prev)).to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 6 then -- if: | _L___3:
						if l_prev = -1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("ex:"), (3).to_natural_32)) = 0 then
							l_break := True
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("vi:"), (3).to_natural_32)) = 0 then
							l_break := True
						end
				when 10 then
						if (l_break) then
							l_pos := -1 + 26 -- skip if block
						end
				when 11 then -- if:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("vim"), (3).to_natural_32)) /= 0 then
							l_pos := -1 + 26 -- skip if block
						end
				when 12 then -- if:
						if (l_s[3]).to_integer_32 = 60 then
							l_e.item := l_s + 4
						elseif (l_s[3]).to_integer_32 = 61 then
							l_e.item := l_s + 4
						elseif (l_s[3]).to_integer_32 = 62 then
							l_e.item := l_s + 4
						else
							l_e.item := l_s + 3
						end
						l_vers := ((create {P_CHARSET_STATIC}).getdigits (l_e)).to_integer_32
						if (l_e.item.item).to_integer_32 /= 58 then
							l_pos := -1 + 26 -- skip if block
						end
				when 13 then -- if:
						if (l_s[3]).to_integer_32 /= 58 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_break := True
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 16 then -- else:
						if not (703 >= l_vers) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if ((((ctype_b_loc).item[(l_s[3]).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
							l_break := True
						else
							l_pos := -1 + 19 -- goto _L___2
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 19 then -- else: | _L___2:
						if not (703 < l_vers) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if (l_s[3]).to_integer_32 = 60 then
							l_break := True
						else
							l_pos := -1 + 22 -- goto _L___1
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 22 then -- else: | _L___1:
						if not (703 > l_vers) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if (l_s[3]).to_integer_32 = 62 then
							l_break := True
						else
							l_pos := -1 + 25 -- goto _L___0
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else: | _L___0:
						if 703 = l_vers then
							if (l_s[3]).to_integer_32 = 61 then
								l_break := True
							end
						end
				when 26 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if not (l_break) then
							l_prev := (l_s.item).to_integer_32
							l_s := l_s + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 27 then -- loop done
					l_break := False
					if not ((l_s.item).to_boolean) then
						l_pos := -1 + 39 -- skip if block
					end
				when 28 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							l_s := l_s + 1
							if (l_s[-1]).to_integer_32 = 58 then
								l_break := True
							end
						end
						l_break := False
						l_linecopy___0 := (create {P_MISC2_STATIC}).vim_strsave (l_s)
						l_s := l_linecopy___0
						if l_linecopy___0.is_void then
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 39 -- skip if block
						end
				when 29 then -- if:
						l_save_sourcing_lnum := (create {P_GLOBALS_STATIC}).sourcing_lnum.item
						l_save_sourcing_name := (create {P_GLOBALS_STATIC}).sourcing_name.item;
						(create {P_GLOBALS_STATIC}).sourcing_lnum.item := a_lnum;
						(create {P_GLOBALS_STATIC}).sourcing_name.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("modelines"))
						l_end := 0
				when 30 then -- loop condition:
						if not (not (l_return or l_break) and then (l_end = 0)) then
							l_pos := -1 + 38 -- skip loop
						end
				when 31 then -- loop body:
						l_break := False
						l_s := (create {P_CHARSET_STATIC}).skipwhite (l_s)
						if (l_s.item).to_integer_32 = 0 then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 37 -- skip if block
						end
				when 32 then -- if:
						l_e.item := l_s
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_e.item.item).to_integer_32 /= 58 then
								if (l_e.item.item).to_integer_32 = 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								if (l_e.item[0]).to_integer_32 = 92 then
									if (l_e.item[1]).to_integer_32 = 58 then
										memmove (create {CE_VOID_POINTER}.make_cast (l_e.item), create {CE_VOID_POINTER}.make_cast ((l_e.item + 1)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_e.item + 1)))) + {NATURAL_32} 1).do_nothing
									end
								end
								l_e.item := l_e.item + 1
							end
						end
						l_break := False
						if (l_e.item.item).to_integer_32 = 0 then
							l_end := 1
						end
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("set "), (4).to_natural_32)) /= 0 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 36 -- goto _L___4
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 35 then -- else:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("se "), (3).to_natural_32)) /= 0 then
							l_pos := -1 + 37 -- skip if block
						end
				when 36 then -- if: | _L___4:
						if (l_e.item.item).to_integer_32 /= 58 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_end := 1
							l_s := ((create {P_MISC2_STATIC}).vim_strchr (l_s, (' ').code)) + 1
						end
				when 37 then -- if done | if done
						if not (l_return or l_break) then
							l_e.item.item := (('%/0/').code).to_natural_8
							if (l_s.item).to_integer_32 /= 0 then
								l_save_SID := (create {P_GLOBALS_STATIC}).current_SID.item;
								(create {P_GLOBALS_STATIC}).current_SID.item := -1
								l_retval := (create {P_OPTION_STATIC}).do_set (l_s, (12).bit_or (a_flags___0));
								(create {P_GLOBALS_STATIC}).current_SID.item := l_save_SID
								if l_retval = 0 then
									l_break := True
								end
							end
						end
						if not (l_return or l_break) then
							l_s := l_e.item + 1
						end
						l_pos := -1 + 30 -- back to loop condition
				when 38 then -- loop done
						l_break := False;
						(create {P_GLOBALS_STATIC}).sourcing_lnum.item := l_save_sourcing_lnum;
						(create {P_GLOBALS_STATIC}).sourcing_name.item := l_save_sourcing_name;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_linecopy___0))
				when 39 then -- if done | if done
					if not l_return then
						Result := l_retval
					end
				when 40 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	write_viminfo_bufferlist (a_fp: CE_POINTER [SD_IO_FILE])
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_win: CE_POINTER [PD_WINDOW_S]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_line: CE_POINTER [NATURAL_8]
			l_max_buffers: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			if ((create {P_OPTION_STATIC}).find_viminfo_parameter (('%%').code)).is_void then
				l_return := True
			end
			if not l_return then
				l_max_buffers := (create {P_OPTION_STATIC}).get_viminfo_parameter (('%%').code)
				l_line := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 4_136)
				if l_line.is_void then
					l_return := True
				end
			end
			if not l_return then
				l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
				from
				until
					not (not (l_return) and then (not l_tp.is_void))
				loop
					if l_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
						l_win := (create {P_GLOBALS_STATIC}).firstwin.item
					else
						l_win := l_tp.item.tp_firstwin
					end
					from
					until
						l_win.is_void
					loop
						l_win.item.set_last_cursor
						l_win := l_win.item.w_next
					end
					l_tp := l_tp.item.tp_next
				end
				fputs ((gettext (ce_string ("%N# Buffer list:%N"))), a_fp).do_nothing
				l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
				from
				until
					not (not (l_break) and then (not l_buf___6.is_void))
				loop
					l_break := False
					l_continue := False
					if (l_buf___6.item.b_fname).is_void then
						l_continue := True
					elseif not (l_buf___6.item.b_p_bl).to_boolean then
						l_continue := True
					elseif (l_buf___6.item.bt_quickfix).to_boolean then
						l_continue := True
					elseif ((create {P_MARK_STATIC}).removable (l_buf___6.item.b_ffname)).to_boolean then
						l_continue := True
					end
					if not (l_return or l_break or l_continue) then
						l_tmp___3 := l_max_buffers
						l_max_buffers := l_max_buffers - 1
						if l_tmp___3 = 0 then
							l_break := True
						end
					end
					if not (l_return or l_break or l_continue) then
						IO_putc (('%%').code, a_fp).do_nothing;
						(create {P_MISC1_STATIC}).home_replace (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_buf___6.item.b_ffname, l_line, 4_096, 1);
						(create {P_MESSAGE_STATIC}).vim_snprintf_add ([create {CE_INTEGER_8_POINTER}.make_cast (l_line), (4_136).to_natural_32, ce_string ("%T%%ld%T%%d"), l_buf___6.item.b_last_cursor.lnum, l_buf___6.item.b_last_cursor.col]).do_nothing;
						(create {P_EX_CMDS_STATIC}).viminfo_writestring (a_fp, l_line)
					end
					if (not l_break) then
						l_buf___6 := l_buf___6.item.b_next
					end
				end
				l_break := False
				l_continue := False;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_line))
			end
		end

	sign_mark_adjust (a_line1, a_line2, a_amount, a_amount_after: INTEGER_32)
		local
			l_sign: CE_POINTER [PD_SIGNLIST]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sign := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_signlist
				when 1 then -- loop condition:
					if l_sign.is_void then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						if not (l_sign.item.lnum >= a_line1) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_sign.item.lnum <= a_line2 then
							if a_amount = 2_147_483_647 then
								l_sign.item.lnum := a_line1
							else
								l_sign.item.lnum := l_sign.item.lnum + a_amount
							end
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if l_sign.item.lnum > a_line2 then
							l_sign.item.lnum := l_sign.item.lnum + a_amount_after
						end
				when 6 then
						l_sign := l_sign.item.next
						l_pos := -1 + 1 -- back to loop condition
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_buflisted (a_on: INTEGER_32)
		do
			if a_on /= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bl then
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bl := a_on
				if a_on.to_boolean then
					(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFADD, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
				else
					(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFDELETE, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
				end
			end
		end

feature {ANY} -- routine addresses

	buflist_list_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent buflist_list)
		end

end
