class
	P_DIFF_STATIC

inherit
	CE_UTILITIES
	S_LIBINTL_STATIC
	S_STDIO_STATIC
	S_STRING_STATIC
	S_UNISTD_STATIC
	S_STDLIB_STATIC
	S_SYS_STAT_STATIC
	S_CTYPE_STATIC

feature {ANY} -- public attributes

	diff_busy: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	diff_flags: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 1
		end

	diff_a_works: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 2
		end

feature {ANY} -- public routines

	diff_buf_add (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			if (diff_buf_idx (a_buf___6)) /= 4 then
				l_return := True
			end
			if not l_return then
				l_i___0 := 0
				from
				until
					not (not (l_return) and then (l_i___0 < 4))
				loop
					if ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_i___0]).is_void then
						(create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_i___0] := a_buf___6;
						(create {P_GLOBALS_STATIC}).curtab.item.item.tp_diff_invalid := 1
						diff_redraw (1)
						l_return := True
					end
					if not l_return then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not l_return then
				(create {P_MISC2_STATIC}).emsgn (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E96: Can not diff more than %%ld buffers")))), 4).do_nothing
			end
		end

	diff_buf_idx (a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_idx: INTEGER_32
			l_break: BOOLEAN
		do
			l_idx := 0
			from
			until
				not (not (l_break) and then (l_idx < 4))
			loop
				l_break := False
				if ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_idx]).is_equal (a_buf___6) then
					l_break := True
				end
				if not (l_break) then
					l_idx := l_idx + 1
				end
			end
			l_break := False
			Result := l_idx
		end

	diff_buf_idx_tp (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_tp: CE_POINTER [PD_TABPAGE_S]): INTEGER_32
		local
			l_idx: INTEGER_32
			l_break: BOOLEAN
		do
			l_idx := 0
			from
			until
				not (not (l_break) and then (l_idx < 4))
			loop
				l_break := False
				if (a_tp.item.tp_diffbuf[l_idx]).is_equal (a_buf___6) then
					l_break := True
				end
				if not (l_break) then
					l_idx := l_idx + 1
				end
			end
			l_break := False
			Result := l_idx
		end

	diff_invalidate (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_i___0: INTEGER_32
		do
			l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
			from
			until
				l_tp.is_void
			loop
				l_i___0 := diff_buf_idx_tp (a_buf___6, l_tp)
				if l_i___0 /= 4 then
					l_tp.item.tp_diff_invalid := 1
					if l_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
						diff_redraw (1)
					end
				end
				l_tp := l_tp.item.tp_next
			end
		end

	diff_mark_adjust (a_line1, a_line2, a_amount, a_amount_after: INTEGER_32)
		local
			l_idx: INTEGER_32
			l_tp: CE_POINTER [PD_TABPAGE_S]
		do
			l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
			from
			until
				l_tp.is_void
			loop
				l_idx := diff_buf_idx_tp ((create {P_GLOBALS_STATIC}).curbuf.item, l_tp)
				if l_idx /= 4 then
					l_tp.item.diff_mark_adjust_tp (l_idx, a_line1, a_line2, a_amount, a_amount_after)
				end
				l_tp := l_tp.item.tp_next
			end
		end

	diff_alloc_new (a_tp: CE_POINTER [PD_TABPAGE_S]; a_dprev, a_dp: CE_POINTER [PD_DIFFBLOCK_S]): CE_POINTER [PD_DIFFBLOCK_S]
		local
			l_dnew: CE_POINTER [PD_DIFFBLOCK_S]
		do
			l_dnew := create {CE_CLASS_POINTER [PD_DIFFBLOCK_S]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_DIFFBLOCK_S}.make).structure_size.to_natural_32)))
			if not l_dnew.is_void then
				l_dnew.item.df_next := a_dp
				if a_dprev.is_void then
					a_tp.item.tp_first_diff := l_dnew
				else
					a_dprev.item.df_next := l_dnew
				end
			end
			Result := l_dnew
		end

	diff_check_sanity (a_tp: CE_POINTER [PD_TABPAGE_S]; a_dp: CE_POINTER [PD_DIFFBLOCK_S]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				not (not (l_return) and then (l_i___0 < 4))
			loop
				if not (a_tp.item.tp_diffbuf[l_i___0]).is_void then
					if (a_dp.item.df_lnum[l_i___0] + a_dp.item.df_count[l_i___0]) - 1 > (a_tp.item.tp_diffbuf[l_i___0]).item.b_ml.ml_line_count then
						Result := 0
						l_return := True
					end
				end
				if not l_return then
					l_i___0 := l_i___0 + 1
				end
			end
			if not l_return then
				Result := 1
			end
		end

	diff_redraw (a_dofold: INTEGER_32)
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_n: INTEGER_32
		do
			l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
			from
			until
				l_wp___0.is_void
			loop
				if (l_wp___0.item.w_onebuf_opt.wo_diff).to_boolean then
					l_wp___0.item.redraw_win_later (35)
					if a_dofold.to_boolean then
						if (l_wp___0.item.foldmethodIsDiff).to_boolean then
							l_wp___0.item.foldUpdateAll
						end
					end
					if not l_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
						if l_wp___0.item.w_topfill > 0 then
							l_n := l_wp___0.item.diff_check (l_wp___0.item.w_topline)
							if l_wp___0.item.w_topfill > l_n then
								if l_n < 0 then
									l_wp___0.item.w_topfill := 0
								else
									l_wp___0.item.w_topfill := l_n
								end
							end
						end
					end
				end
				l_wp___0 := l_wp___0.item.w_next
			end
		end

	ex_diffupdate (a_eap: CE_POINTER [PD_EXARG])
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_idx_orig: INTEGER_32
			l_idx_new: INTEGER_32
			l_tmp_orig: CE_POINTER [NATURAL_8]
			l_tmp_new: CE_POINTER [NATURAL_8]
			l_tmp_diff: CE_POINTER [NATURAL_8]
			l_fd: CE_POINTER [SD_IO_FILE]
			l_ok: INTEGER_32
			l_io_error: INTEGER_32
			l_linebuf: CE_ARRAY [NATURAL_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_linebuf.make (<<50>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_io_error := 0;
					((create {P_GLOBALS_STATIC}).curtab.item).item.diff_clear;
					(create {P_GLOBALS_STATIC}).curtab.item.item.tp_diff_invalid := 0
					l_idx_orig := 0
					from
					until
						not (not (l_break) and then (l_idx_orig < 4))
					loop
						l_break := False
						if not ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_idx_orig]).is_void then
							l_break := True
						end
						if not (l_break) then
							l_idx_orig := l_idx_orig + 1
						end
					end
					l_break := False
					if l_idx_orig = 4 then
						l_return := True
					end
					if not l_return then
						l_idx_new := l_idx_orig + 1
						from
						until
							not (not (l_break) and then (l_idx_new < 4))
						loop
							l_break := False
							if not ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_idx_new]).is_void then
								l_break := True
							end
							if not (l_break) then
								l_idx_new := l_idx_new + 1
							end
						end
						l_break := False
						if l_idx_new = 4 then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_tmp_orig := (create {P_FILEIO_STATIC}).vim_tempname (('o').code)
						l_tmp_new := (create {P_FILEIO_STATIC}).vim_tempname (('n').code)
						l_tmp_diff := (create {P_FILEIO_STATIC}).vim_tempname (('d').code)
						if l_tmp_orig.is_void then
							l_pos := -1 + 5 -- goto theend
						elseif l_tmp_new.is_void then
							l_pos := -1 + 5 -- goto theend
						elseif l_tmp_diff.is_void then
							l_pos := -1 + 5 -- goto theend
						end
				when 2 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_ok := 0
							l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_orig), ce_string ("w"))
							if l_fd.is_void then
								l_io_error := 1
							else
								if (fwrite (create {CE_VOID_POINTER}.make_cast (ce_string ("line1%N")), (6).to_natural_32, (1).to_natural_32, l_fd)) /= {NATURAL_32} 1 then
									l_io_error := 1
								end
								fclose (l_fd).do_nothing
								l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_new), ce_string ("w"))
								if l_fd.is_void then
									l_io_error := 1
								else
									if (fwrite (create {CE_VOID_POINTER}.make_cast (ce_string ("line2%N")), (6).to_natural_32, (1).to_natural_32, l_fd)) /= {NATURAL_32} 1 then
										l_io_error := 1
									end
									fclose (l_fd).do_nothing
									diff_file (l_tmp_orig, l_tmp_new, l_tmp_diff)
									l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_diff), ce_string ("r"))
									if l_fd.is_void then
										l_io_error := 1
									else
										from
										until
											(l_break)
										loop
											l_break := False
											if ((create {P_FILEIO_STATIC}).vim_fgets (l_linebuf, 50, l_fd)).to_boolean then
												l_break := True
											end
											if not (l_break) then
												if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_linebuf), ce_string ("1c1"), (3).to_natural_32)) = 0 then
													l_ok := 1
												end
											end
										end
										l_break := False
										fclose (l_fd).do_nothing
									end
									unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_diff)).do_nothing
									unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_new)).do_nothing
								end
								unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_orig)).do_nothing
							end
							if ((create {P_OPTION_STATIC}).p_dex.item.item.item).to_integer_32 /= 0 then
								l_break := True
							end
							if not (l_return or l_break) and then (diff_a_works.item /= 2) then
								l_break := True
							end
							if not (l_return or l_break) then
								diff_a_works.item := l_ok
								if l_ok.to_boolean then
									l_break := True
								end
							end
						end
						l_break := False
						if not l_ok.to_boolean then
							if l_io_error.to_boolean then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E810: Cannot read or write temp files"))))).do_nothing
							end
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E97: Cannot create diffs"))))).do_nothing
							diff_a_works.item := 2
							l_pos := -1 + 5 -- goto theend
						end
				when 3 then
						l_buf___6 := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_idx_orig]
						if (l_buf___6.item.diff_write (l_tmp_orig)) = 0 then
							l_pos := -1 + 5 -- goto theend
						end
				when 4 then
						l_idx_new := l_idx_orig + 1
						from
						until
							not (l_idx_new < 4)
						loop
							l_continue := False
							l_buf___6 := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_idx_new]
							if l_buf___6.is_void then
								l_continue := True
							end
							if not (l_return or l_break or l_continue) then
								if (l_buf___6.item.diff_write (l_tmp_new)) = 0 then
									l_continue := True
								end
							end
							if not (l_return or l_break or l_continue) then
								diff_file (l_tmp_orig, l_tmp_new, l_tmp_diff)
								diff_read (l_idx_orig, l_idx_new, l_tmp_diff)
								unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_diff)).do_nothing
								unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_new)).do_nothing
							end
							l_idx_new := l_idx_new + 1
						end
						l_continue := False
						unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_orig)).do_nothing;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid_cursor.lnum := (0).to_integer_32
						diff_redraw (1)
				when 5 then -- theend:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tmp_orig));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tmp_new));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tmp_diff))
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	diff_file (a_tmp_orig, a_tmp_new, a_tmp_diff: CE_POINTER [NATURAL_8])
		local
			l_cmd: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: NATURAL_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
		do
			if ((create {P_OPTION_STATIC}).p_dex.item.item.item).to_integer_32 /= 0 then
				(create {P_EVAL_STATIC}).eval_diff (a_tmp_orig, a_tmp_new, a_tmp_diff)
			else
				l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_tmp_orig))
				l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_tmp_new))
				l_tmp___1 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_tmp_diff))
				l_len := (((l_tmp + l_tmp___0) + l_tmp___1) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_srr.item.item)))) + {NATURAL_32} 27
				l_cmd := (create {P_MISC2_STATIC}).alloc (l_len)
				if not l_cmd.is_void then
					if (not (getenv (ce_string ("DIFF_OPTIONS"))).is_void) then
						(create {P_MISC1_STATIC}).vim_setenv (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("DIFF_OPTIONS")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
					end
					if ((diff_flags.item).bit_and (2)).to_boolean then
						l_tmp___4 := ce_string ("-i ")
					else
						l_tmp___4 := ce_string ("")
					end
					if ((diff_flags.item).bit_and (4)).to_boolean then
						l_tmp___5 := ce_string ("-b ")
					else
						l_tmp___5 := ce_string ("")
					end
					if diff_a_works.item = 0 then
						l_tmp___6 := ce_string ("")
					else
						l_tmp___6 := ce_string ("-a ")
					end
					(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_cmd), l_len, ce_string ("diff %%s%%s%%s%%s%%s %%s"), l_tmp___6, ce_string (""), l_tmp___5, l_tmp___4, a_tmp_orig, a_tmp_new]).do_nothing;
					(create {P_EX_CMDS_STATIC}).append_redir (l_cmd, l_len.to_integer_32, (create {P_OPTION_STATIC}).p_srr.item.item, a_tmp_diff);
					(create {P_FILEIO_STATIC}).block_autocmds;
					(create {P_MISC2_STATIC}).call_shell (l_cmd, 25).do_nothing;
					(create {P_FILEIO_STATIC}).unblock_autocmds;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cmd))
				end
			end
		end

	ex_diffpatch (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tmp_orig: CE_POINTER [NATURAL_8]
			l_tmp_new: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_buflen: NATURAL_32
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_newname: CE_POINTER [NATURAL_8]
			l_dirbuf: CE_ARRAY [NATURAL_8]
			l_fullname: CE_POINTER [NATURAL_8]
			l_browseFile: CE_POINTER [NATURAL_8]
			l_browse_flag: INTEGER_32
			l_st: CE_ARRAY [SD_STAT]
			l_tmp___1: NATURAL_32
			l_tmp___4: NATURAL_32
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___16: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_dirbuf.make (<<4_096>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_old_curwin___1 := (create {P_GLOBALS_STATIC}).curwin.item
					l_newname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_fullname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_browseFile := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_browse_flag := (create {P_GLOBALS_STATIC}).cmdmod.item.item.browse
					if ((create {P_GLOBALS_STATIC}).cmdmod.item.item.browse).to_boolean then
						l_browseFile := (create {P_MESSAGE_STATIC}).do_browse (0, create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Patch file")))), a_eap.item.arg, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("All Files (*)%T*%N")), create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
						if l_browseFile.is_void then
							l_return := True
						end
						if not l_return then
							a_eap.item.arg := l_browseFile;
							(create {P_GLOBALS_STATIC}).cmdmod.item.item.browse := 0
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_tmp_orig := (create {P_FILEIO_STATIC}).vim_tempname (('o').code)
						l_tmp_new := (create {P_FILEIO_STATIC}).vim_tempname (('n').code)
						if l_tmp_orig.is_void then
							l_pos := -1 + 5 -- goto theend
						elseif l_tmp_new.is_void then
							l_pos := -1 + 5 -- goto theend
						end
				when 2 then
						if ((create {P_FILEIO_STATIC}).buf_write ((create {P_GLOBALS_STATIC}).curbuf.item, l_tmp_orig, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), (1).to_integer_32, (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count, create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), 0, 0, 0, 1)) = 0 then
							l_pos := -1 + 5 -- goto theend
						end
				when 3 then
						l_fullname := (create {P_MISC1_STATIC}).FullName_save (a_eap.item.arg, 0)
						l_tmp___1 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_orig))
						if not l_fullname.is_void then
							l_tmp___4 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fullname)))
						else
							l_tmp___4 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_eap.item.arg)))
						end
						l_buflen := ((l_tmp___1 + l_tmp___4) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_new)))) + {NATURAL_32} 16
						l_buf___6 := (create {P_MISC2_STATIC}).alloc (l_buflen)
						if l_buf___6.is_void then
							l_pos := -1 + 5 -- goto theend
						end
				when 4 then
						if ((create {P_OS_UNIX_STATIC}).mch_dirname (l_dirbuf, 4_096)) /= 1 then
							l_dirbuf[0] := (('%/0/').code).to_natural_8
						elseif ((create {P_OS_UNIX_STATIC}).mch_chdir (create {CE_INTEGER_8_POINTER}.make_cast (l_dirbuf))) /= 0 then
							l_dirbuf[0] := (('%/0/').code).to_natural_8
						else
							if not ((create {P_GLOBALS_STATIC}).vim_tempdir.item).is_void then
								(create {P_GLOBALS_STATIC}).ignored.item := (create {P_OS_UNIX_STATIC}).mch_chdir (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).vim_tempdir.item))
							else
								(create {P_GLOBALS_STATIC}).ignored.item := (create {P_OS_UNIX_STATIC}).mch_chdir (ce_string ("/tmp"))
							end
							(create {P_FILEIO_STATIC}).shorten_fnames (1)
						end
						if ((create {P_OPTION_STATIC}).p_pex.item.item.item).to_integer_32 /= 0 then
							if not l_fullname.is_void then
								l_tmp___8 := l_fullname
							else
								l_tmp___8 := a_eap.item.arg
							end
							(create {P_EVAL_STATIC}).eval_patch (l_tmp_orig, l_tmp___8, l_tmp_new)
						else
							if not l_fullname.is_void then
								l_tmp___9 := l_fullname
							else
								l_tmp___9 := a_eap.item.arg
							end
							(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), l_buflen, ce_string ("patch -o %%s %%s < %"%%s%""), l_tmp_new, l_tmp_orig, l_tmp___9]).do_nothing;
							(create {P_FILEIO_STATIC}).block_autocmds;
							(create {P_MISC2_STATIC}).call_shell (l_buf___6, 5).do_nothing;
							(create {P_FILEIO_STATIC}).unblock_autocmds
						end
						if (l_dirbuf[0]).to_integer_32 /= 0 then
							if ((create {P_OS_UNIX_STATIC}).mch_chdir (create {CE_INTEGER_8_POINTER}.make_cast (l_dirbuf))) /= 0 then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_prev_dir.item)))))).do_nothing
							end
							(create {P_FILEIO_STATIC}).shorten_fnames (1)
						end
						(create {P_SCREEN_STATIC}).redraw_later (50)
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_new)).do_nothing
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string (".orig")).do_nothing
						unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6)).do_nothing
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_new)).do_nothing
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string (".rej")).do_nothing
						unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6)).do_nothing
						if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_new), l_st)) < 0 then
							l_tmp___12 := gettext (ce_string ("E816: Cannot read patch output"));
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___12)).do_nothing
						elseif l_st.item.st_size = 0 then
							l_tmp___12 := gettext (ce_string ("E816: Cannot read patch output"));
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___12)).do_nothing
						else
							if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname).is_void then
								l_newname := (create {P_MISC2_STATIC}).vim_strnsave ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname, ((strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname))) + {NATURAL_32} 4).to_integer_32)
								if not l_newname.is_void then
									strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_newname), ce_string (".new")).do_nothing
								end
							end
							(create {P_GLOBALS_STATIC}).need_mouse_correct.item := 1;
							(create {P_GLOBALS_STATIC}).cmdmod.item.item.tab := 0
							if ((diff_flags.item).bit_and (16)).to_boolean then
								l_tmp___16 := 2
							else
								l_tmp___16 := 0
							end
							if ((create {P_WINDOW_STATIC}).win_split (0, l_tmp___16)) /= 0 then
								a_eap.item.cmdidx := {PC_CMD_INDEX}.CMD_split
								a_eap.item.arg := l_tmp_new;
								(create {P_EX_DOCMD_STATIC}).do_exedit (a_eap, l_old_curwin___1)
								if not ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_old_curwin___1) then
									if ((create {P_WINDOW_STATIC}).win_valid (l_old_curwin___1)).to_boolean then
										((create {P_GLOBALS_STATIC}).curwin.item).item.diff_win_options (1)
										l_old_curwin___1.item.diff_win_options (1)
										if not l_newname.is_void then
											a_eap.item.arg := l_newname
											a_eap.item.ex_file
											if ((create {P_FILEIO_STATIC}).au_has_group (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("filetypedetect")))).to_boolean then
												(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":doau filetypedetect BufRead"))).do_nothing
											end
										end
									end
								end
							end
						end
				when 5 then -- theend:
						if not l_tmp_orig.is_void then
							unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_orig)).do_nothing
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tmp_orig))
						if not l_tmp_new.is_void then
							unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_new)).do_nothing
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tmp_new));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_newname));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fullname));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_browseFile));
						(create {P_GLOBALS_STATIC}).cmdmod.item.item.browse := l_browse_flag
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_diffsplit (a_eap: CE_POINTER [PD_EXARG])
		local
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_tmp: INTEGER_32
		do
			l_old_curwin___1 := (create {P_GLOBALS_STATIC}).curwin.item;
			(create {P_GLOBALS_STATIC}).need_mouse_correct.item := 1;
			(create {P_GLOBALS_STATIC}).cmdmod.item.item.tab := 0
			if ((diff_flags.item).bit_and (16)).to_boolean then
				l_tmp := 2
			else
				l_tmp := 0
			end
			if ((create {P_WINDOW_STATIC}).win_split (0, l_tmp)) /= 0 then
				a_eap.item.cmdidx := {PC_CMD_INDEX}.CMD_split;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_diff := 1;
				(create {P_EX_DOCMD_STATIC}).do_exedit (a_eap, l_old_curwin___1)
				if not ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_old_curwin___1) then
					((create {P_GLOBALS_STATIC}).curwin.item).item.diff_win_options (1)
					l_old_curwin___1.item.diff_win_options (1)
				end
			end
		end

	ex_diffthis (a_eap: CE_POINTER [PD_EXARG])
		do
			((create {P_GLOBALS_STATIC}).curwin.item).item.diff_win_options (1)
		end

	ex_diffoff (a_eap: CE_POINTER [PD_EXARG])
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_diffwin: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_old_curwin___1 := (create {P_GLOBALS_STATIC}).curwin.item
					l_diffwin := 0
					l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
				when 1 then -- loop condition:
					if l_wp___0.is_void then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						if not (l_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item)) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 5 then -- else:
						if not ((a_eap.item.forceit).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if not ((l_wp___0.item.w_onebuf_opt.wo_diff).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_wp___0.item.w_onebuf_opt.wo_diff := 0
						l_wp___0.item.w_onebuf_opt.wo_crb := 0
						l_wp___0.item.w_onebuf_opt.wo_scb := 0
						l_wp___0.item.w_onebuf_opt.wo_wrap := 1;
						(create {P_GLOBALS_STATIC}).curwin.item := l_wp___0;
						(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer;
						(create {P_OPTION_STATIC}).set_string_option_direct (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("fdm")), -1, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("manual")), 5, 0);
						(create {P_GLOBALS_STATIC}).curwin.item := l_old_curwin___1;
						(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
						l_wp___0.item.w_onebuf_opt.wo_fdc := 0
						l_wp___0.item.w_onebuf_opt.wo_fen := 0
						l_wp___0.item.w_onebuf_opt.wo_fdl := 0
						l_wp___0.item.foldUpdateAll
						l_wp___0.item.changed_window_setting_win
						l_wp___0.item.diff_buf_adjust
				when 8 then -- if done | if done
						l_diffwin := (l_diffwin).bit_or ((l_wp___0.item.w_onebuf_opt.wo_diff))
						l_wp___0 := l_wp___0.item.w_next
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					if not l_diffwin.to_boolean then
						if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_sbo.item.item, ('h').code)).is_void then
							(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("set sbo-=hor"))).do_nothing
						end
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	diff_read (a_idx_orig, a_idx_new: INTEGER_32; a_fname: CE_POINTER [NATURAL_8])
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_dprev: CE_POINTER [PD_DIFFBLOCK_S]
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			l_dn: CE_POINTER [PD_DIFFBLOCK_S]
			l_dpl: CE_POINTER [PD_DIFFBLOCK_S]
			l_f1: INTEGER_32
			l_l1: INTEGER_32
			l_f2: INTEGER_32
			l_l2: INTEGER_32
			l_linebuf: CE_ARRAY [NATURAL_8]
			l_difftype: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_off___0: INTEGER_32
			l_i___0: INTEGER_32
			l_lnum_orig: INTEGER_32
			l_lnum_new: INTEGER_32
			l_count_orig: INTEGER_32
			l_count_new: INTEGER_32
			l_notset: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_linebuf.make (<<50>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dprev := create {CE_CLASS_POINTER [PD_DIFFBLOCK_S]}.make_shared (default_pointer)
					l_dp := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_first_diff
					l_notset := 1
					l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (a_fname), ce_string ("r"))
					if l_fd.is_void then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E98: Cannot read diff output"))))).do_nothing
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 10 -- skip loop
						end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						if ((create {P_FILEIO_STATIC}).vim_fgets (l_linebuf, 50, l_fd)).to_boolean then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							if not ((((ctype_b_loc).item[(l_linebuf[0]).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							l_p___0.item := l_linebuf
							l_f1 := (create {P_CHARSET_STATIC}).getdigits (l_p___0)
							if (l_p___0.item.item).to_integer_32 = 44 then
								l_p___0.item := l_p___0.item + 1
								l_l1 := (create {P_CHARSET_STATIC}).getdigits (l_p___0)
							else
								l_l1 := l_f1
							end
							if (l_p___0.item.item).to_integer_32 /= 97 then
								if (l_p___0.item.item).to_integer_32 /= 99 then
									if (l_p___0.item.item).to_integer_32 /= 100 then
										l_continue := True
									end
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_tmp___2 := l_p___0.item
							l_p___0.item := l_p___0.item + 1
							l_difftype := (l_tmp___2.item).to_integer_32
							l_f2 := (create {P_CHARSET_STATIC}).getdigits (l_p___0)
							if (l_p___0.item.item).to_integer_32 = 44 then
								l_p___0.item := l_p___0.item + 1
								l_l2 := (create {P_CHARSET_STATIC}).getdigits (l_p___0)
							else
								l_l2 := l_f2
							end
							if l_l1 < l_f1 then
								l_continue := True
							elseif l_l2 < l_f2 then
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if l_difftype = 97 then
							l_lnum_orig := l_f1 + 1
							l_count_orig := 0
						else
							l_lnum_orig := l_f1
							l_count_orig := (l_l1 - l_f1) + 1
						end
						if l_difftype = 100 then
							l_lnum_new := l_f2 + 1
							l_count_new := 0
						else
							l_lnum_new := l_f2
							l_count_new := (l_l2 - l_f2) + 1
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if not l_dp.is_void then
								if not (l_lnum_orig > l_dp.item.df_lnum[a_idx_orig] + l_dp.item.df_count[a_idx_orig]) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								if l_notset.to_boolean then
									diff_copy_entry (l_dprev, l_dp, a_idx_orig, a_idx_new)
								end
								l_dprev := l_dp
								l_dp := l_dp.item.df_next
								l_notset := 1
							end
						end
						l_break := False
						if l_dp.is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_lnum_orig <= l_dp.item.df_lnum[a_idx_orig] + l_dp.item.df_count[a_idx_orig] then
							if l_lnum_orig + l_count_orig >= l_dp.item.df_lnum[a_idx_orig] then
								l_dpl := l_dp
								from
								until
									not (not (l_break) and then (not (l_dpl.item.df_next).is_void))
								loop
									l_break := False
									if l_lnum_orig + l_count_orig < (l_dpl.item.df_next).item.df_lnum[a_idx_orig] then
										l_break := True
									end
									if not (l_break) then
										l_dpl := l_dpl.item.df_next
									end
								end
								l_break := False
								l_off___0 := l_dp.item.df_lnum[a_idx_orig] - l_lnum_orig
								if l_off___0 > 0 then
									l_i___0 := a_idx_orig
									from
									until
										not (l_i___0 < a_idx_new)
									loop
										if not ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_i___0]).is_void then
											l_dp.item.df_lnum[l_i___0] := l_dp.item.df_lnum[l_i___0] - l_off___0
										end
										l_i___0 := l_i___0 + 1
									end
									l_dp.item.df_lnum[a_idx_new] := l_lnum_new
									l_dp.item.df_count[a_idx_new] := l_count_new
								elseif l_notset.to_boolean then
									l_dp.item.df_lnum[a_idx_new] := l_lnum_new + l_off___0
									l_dp.item.df_count[a_idx_new] := l_count_new - l_off___0
								else
									l_dp.item.df_count[a_idx_new] := l_dp.item.df_count[a_idx_new] + ((((l_count_new - l_count_orig) + l_dpl.item.df_lnum[a_idx_orig]) + l_dpl.item.df_count[a_idx_orig]) - (l_dp.item.df_lnum[a_idx_orig] + l_dp.item.df_count[a_idx_orig]))
								end
								l_off___0 := (l_lnum_orig + l_count_orig) - (l_dpl.item.df_lnum[a_idx_orig] + l_dpl.item.df_count[a_idx_orig])
								if l_off___0 < 0 then
									if l_notset.to_boolean then
										l_dp.item.df_count[a_idx_new] := l_dp.item.df_count[a_idx_new] + (-l_off___0)
									end
									l_off___0 := 0
								end
								l_i___0 := a_idx_orig
								from
								until
									not (l_i___0 < a_idx_new)
								loop
									if not ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_i___0]).is_void then
										l_dp.item.df_count[l_i___0] := ((l_dpl.item.df_lnum[l_i___0] + l_dpl.item.df_count[l_i___0]) - l_dp.item.df_lnum[l_i___0]) + l_off___0
									end
									l_i___0 := l_i___0 + 1
								end
								l_dn := l_dp.item.df_next
								l_dp.item.df_next := l_dpl.item.df_next
								from
								until
									l_dn.is_equal (l_dp.item.df_next)
								loop
									l_dpl := l_dn.item.df_next;
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_dn))
									l_dn := l_dpl
								end
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else: | _L___0:
						l_dp := diff_alloc_new ((create {P_GLOBALS_STATIC}).curtab.item, l_dprev, l_dp)
						if l_dp.is_void then
							l_pos := -1 + 11 -- goto done
						end
				when 7 then
						l_dp.item.df_lnum[a_idx_orig] := l_lnum_orig
						l_dp.item.df_count[a_idx_orig] := l_count_orig
						l_dp.item.df_lnum[a_idx_new] := l_lnum_new
						l_dp.item.df_count[a_idx_new] := l_count_new
						l_i___0 := a_idx_orig + 1
						from
						until
							not (l_i___0 < a_idx_new)
						loop
							if not ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_i___0]).is_void then
								diff_copy_entry (l_dprev, l_dp, a_idx_orig, l_i___0)
							end
							l_i___0 := l_i___0 + 1
						end
				when 8 then
						l_notset := 0
				when 9 then -- if done
						if (not l_return and not l_break) then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
						l_break := False
						l_continue := False
						from
						until
							l_dp.is_void
						loop
							if l_notset.to_boolean then
								diff_copy_entry (l_dprev, l_dp, a_idx_orig, a_idx_new)
							end
							l_dprev := l_dp
							l_dp := l_dp.item.df_next
							l_notset := 1
						end
				when 11 then -- done:
						fclose (l_fd).do_nothing
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	diff_copy_entry (a_dprev, a_dp: CE_POINTER [PD_DIFFBLOCK_S]; a_idx_orig, a_idx_new: INTEGER_32)
		require
			not a_dp.is_void
		local
			l_off___0: INTEGER_32
		do
			if a_dprev.is_void then
				l_off___0 := 0
			else
				l_off___0 := (a_dprev.item.df_lnum[a_idx_orig] + a_dprev.item.df_count[a_idx_orig]) - (a_dprev.item.df_lnum[a_idx_new] + a_dprev.item.df_count[a_idx_new])
			end
			a_dp.item.df_lnum[a_idx_new] := a_dp.item.df_lnum[a_idx_orig] - l_off___0
			a_dp.item.df_count[a_idx_new] := a_dp.item.df_count[a_idx_orig]
		end

	diff_cmp (a_s1, a_s2: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p1: CE_POINTER [NATURAL_8]
			l_p2: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___7: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((diff_flags.item).bit_and (6)) = 0 then
						Result := (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_s1), create {CE_INTEGER_8_POINTER}.make_cast (a_s2)))
						l_return := True
					end
					if not l_return and then (((diff_flags.item).bit_and (2)).to_boolean) then
						if not ((diff_flags.item).bit_and (4)).to_boolean then
							Result := ((create {P_MBYTE_STATIC}).mb_strnicmp (a_s1, a_s2, (2_147_483_647).to_natural_32))
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_p1 := a_s1
						l_p2 := a_s2
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if (l_p1.item).to_integer_32 /= 0 then
							if (l_p2.item).to_integer_32 = 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						if (l_p1.item).to_integer_32 /= 32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L___0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if (l_p1.item).to_integer_32 /= 9 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L___0:
						if (l_p2.item).to_integer_32 = 32 then
							l_p1 := (create {P_CHARSET_STATIC}).skipwhite (l_p1)
							l_p2 := (create {P_CHARSET_STATIC}).skipwhite (l_p2)
						elseif (l_p2.item).to_integer_32 = 9 then
							l_p1 := (create {P_CHARSET_STATIC}).skipwhite (l_p1)
							l_p2 := (create {P_CHARSET_STATIC}).skipwhite (l_p2)
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						l_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p1])
						if l_l /= ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p2])) then
							l_break := True
						end
						if not (l_break) then
							if l_l > 1 then
								if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p1), create {CE_INTEGER_8_POINTER}.make_cast (l_p2), l_l.to_natural_32)) /= 0 then
									if not ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
										l_break := True
									elseif not ((diff_flags.item).bit_and (2)).to_boolean then
										l_break := True
									else
										l_tmp___4 := (create {P_MBYTE_STATIC}).utf_fold (((create {P_MBYTE_STATIC}).utf_ptr2char (l_p1)))
										if l_tmp___4 /= ((create {P_MBYTE_STATIC}).utf_fold (((create {P_MBYTE_STATIC}).utf_ptr2char (l_p2)))) then
											l_break := True
										end
									end
								end
								if not (l_break) then
									l_p1 := l_p1 + l_l
									l_p2 := l_p2 + l_l
								end
							else
								if (l_p1.item).to_integer_32 /= (l_p2.item).to_integer_32 then
									if not ((diff_flags.item).bit_and (2)).to_boolean then
										l_break := True
									else
										l_tmp___7 := tolower ((l_p1.item).to_integer_32)
										if l_tmp___7 /= (tolower ((l_p2.item).to_integer_32)) then
											l_break := True
										end
									end
								end
								if not (l_break) then
									l_p1 := l_p1 + 1
									l_p2 := l_p2 + 1
								end
							end
						end
				when 11 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- loop done
						l_break := False
						l_p1 := (create {P_CHARSET_STATIC}).skipwhite (l_p1)
						l_p2 := (create {P_CHARSET_STATIC}).skipwhite (l_p2)
						if (l_p1.item).to_integer_32 /= 0 then
							Result := 1
							l_return := True
						elseif (l_p2.item).to_integer_32 /= 0 then
							Result := 1
							l_return := True
						end
				when 13 then -- if done
					if not l_return then
						Result := 0
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	diff_check_fill (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_return: BOOLEAN
		do
			if not ((diff_flags.item).bit_and (1)).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_n := a_wp___0.item.diff_check (a_lnum)
				if l_n <= 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := l_n
			end
		end

	diffopt_changed: INTEGER_32
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_diff_context_new: INTEGER_32
			l_diff_flags_new: INTEGER_32
			l_diff_foldcolumn_new: INTEGER_32
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_diff_context_new := 6
					l_diff_flags_new := 0
					l_diff_foldcolumn_new := 2
					l_p___0.item := (create {P_OPTION_STATIC}).p_dip.item.item
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_p___0.item.item).to_integer_32 /= 0)) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), ce_string ("filler"), (6).to_natural_32)) /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_p___0.item := l_p___0.item + (6)
						l_diff_flags_new := (l_diff_flags_new).bit_or ((1))
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), ce_string ("context:"), (8).to_natural_32)) /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_p___0.item[8]).to_integer_32 >= 48 then
							if (l_p___0.item[8]).to_integer_32 <= 57 then
								l_p___0.item := l_p___0.item + (8)
								l_diff_context_new := ((create {P_CHARSET_STATIC}).getdigits (l_p___0)).to_integer_32
							else
								l_pos := -1 + 8 -- goto _L
							end
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), ce_string ("icase"), (5).to_natural_32)) = 0 then
							l_p___0.item := l_p___0.item + (5)
							l_diff_flags_new := (l_diff_flags_new).bit_or ((2))
						elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), ce_string ("iwhite"), (6).to_natural_32)) = 0 then
							l_p___0.item := l_p___0.item + (6)
							l_diff_flags_new := (l_diff_flags_new).bit_or ((4))
						elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), ce_string ("horizontal"), (10).to_natural_32)) = 0 then
							l_p___0.item := l_p___0.item + (10)
							l_diff_flags_new := (l_diff_flags_new).bit_or ((8))
						elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), ce_string ("vertical"), (8).to_natural_32)) = 0 then
							l_p___0.item := l_p___0.item + (8)
							l_diff_flags_new := (l_diff_flags_new).bit_or ((16))
						elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), ce_string ("foldcolumn:"), (11).to_natural_32)) = 0 then
							if (l_p___0.item[11]).to_integer_32 >= 48 then
								if (l_p___0.item[11]).to_integer_32 <= 57 then
									l_p___0.item := l_p___0.item + (11)
									l_diff_foldcolumn_new := ((create {P_CHARSET_STATIC}).getdigits (l_p___0)).to_integer_32
								end
							end
						end
				when 9 then -- if done
						if (l_p___0.item.item).to_integer_32 /= 44 then
							if (l_p___0.item.item).to_integer_32 /= 0 then
								Result := 0
								l_return := True
							end
						end
						if not l_return and then ((l_p___0.item.item).to_integer_32 = 44) then
							l_p___0.item := l_p___0.item + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					if not l_return and then (((l_diff_flags_new).bit_and (8)).to_boolean) then
						if ((l_diff_flags_new).bit_and (16)).to_boolean then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						if diff_flags.item /= l_diff_flags_new then
							l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
							from
							until
								l_tp.is_void
							loop
								l_tp.item.tp_diff_invalid := 1
								l_tp := l_tp.item.tp_next
							end
						end
						diff_flags.item := l_diff_flags_new;
						(create {P_GLOBALS_STATIC}).diff_context.item := l_diff_context_new;
						(create {P_GLOBALS_STATIC}).diff_foldcolumn.item := l_diff_foldcolumn_new
						diff_redraw (1);
						(create {P_NORMAL_STATIC}).check_scrollbind ((0).to_integer_32, 0)
						Result := 1
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	diffopt_horizontal: INTEGER_32
		do
			Result := (((diff_flags.item).bit_and (8)) /= 0).to_integer
		end

	diff_mode_buf (a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_return: BOOLEAN
		do
			l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
			from
			until
				not (not (l_return) and then (not l_tp.is_void))
			loop
				if (diff_buf_idx_tp (a_buf___6, l_tp)) /= 4 then
					Result := 1
					l_return := True
				end
				if not l_return then
					l_tp := l_tp.item.tp_next
				end
			end
			if not l_return then
				Result := 0
			end
		end

	diff_get_corresponding_line (a_buf1: CE_POINTER [PD_FILE_BUFFER]; a_lnum1: INTEGER_32; a_buf2: CE_POINTER [PD_FILE_BUFFER]; a_lnum3: INTEGER_32): INTEGER_32
		local
			l_idx1: INTEGER_32
			l_idx2: INTEGER_32
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			l_baseline: INTEGER_32
			l_lnum2: INTEGER_32
			l_return: BOOLEAN
		do
			l_baseline := 0
			l_idx1 := diff_buf_idx (a_buf1)
			l_idx2 := diff_buf_idx (a_buf2)
			if l_idx1 = 4 then
				Result := a_lnum1
				l_return := True
			elseif l_idx2 = 4 then
				Result := a_lnum1
				l_return := True
			elseif ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_first_diff).is_void then
				Result := a_lnum1
				l_return := True
			end
			if not l_return then
				if ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diff_invalid).to_boolean then
					ex_diffupdate (create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer))
				end
				if ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_first_diff).is_void then
					Result := a_lnum1
					l_return := True
				end
			end
			if not l_return then
				l_dp := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_first_diff
				from
				until
					not (not (l_return) and then (not l_dp.is_void))
				loop
					if l_dp.item.df_lnum[l_idx1] > a_lnum1 then
						l_lnum2 := a_lnum1 - l_baseline.to_integer_32
						if l_lnum2 > a_buf2.item.b_ml.ml_line_count then
							l_lnum2 := a_buf2.item.b_ml.ml_line_count
						end
						Result := l_lnum2
						l_return := True
					elseif l_dp.item.df_lnum[l_idx1] + l_dp.item.df_count[l_idx1] > a_lnum1 then
						l_baseline := (a_lnum1 - l_dp.item.df_lnum[l_idx1]).to_integer_32
						if l_baseline.to_integer_32 > l_dp.item.df_count[l_idx2] then
							l_baseline := (l_dp.item.df_count[l_idx2]).to_integer_32
						end
						Result := (l_dp.item.df_lnum[l_idx2] + l_baseline.to_integer_32)
						l_return := True
					elseif l_dp.item.df_lnum[l_idx1] = a_lnum1 then
						if l_dp.item.df_count[l_idx1] = 0 then
							if l_dp.item.df_lnum[l_idx2] <= a_lnum3 then
								if l_dp.item.df_lnum[l_idx2] + l_dp.item.df_count[l_idx2] > a_lnum3 then
									Result := a_lnum3
									l_return := True
								end
							end
						end
					end
					if not l_return then
						l_baseline := ((l_dp.item.df_lnum[l_idx1] + l_dp.item.df_count[l_idx1]) - (l_dp.item.df_lnum[l_idx2] + l_dp.item.df_count[l_idx2])).to_integer_32
						l_dp := l_dp.item.df_next
					end
				end
			end
			if not l_return then
				l_lnum2 := a_lnum1 - l_baseline.to_integer_32
				if l_lnum2 > a_buf2.item.b_ml.ml_line_count then
					l_lnum2 := a_buf2.item.b_ml.ml_line_count
				end
				Result := l_lnum2
			end
		end

	diff_lnum_win (a_lnum: INTEGER_32; a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			l_idx: INTEGER_32
			l_i___0: INTEGER_32
			l_n: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_idx := diff_buf_idx ((create {P_GLOBALS_STATIC}).curbuf.item)
			if l_idx = 4 then
				Result := (0).to_integer_32
				l_return := True
			end
			if not l_return then
				if ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diff_invalid).to_boolean then
					ex_diffupdate (create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer))
				end
				l_dp := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_first_diff
				from
				until
					not (not (l_break) and then (not l_dp.is_void))
				loop
					l_break := False
					if a_lnum <= l_dp.item.df_lnum[l_idx] + l_dp.item.df_count[l_idx] then
						l_break := True
					end
					if not (l_break) then
						l_dp := l_dp.item.df_next
					end
				end
				l_break := False
				if l_dp.is_void then
					Result := ((a_wp___0.item.w_buffer).item.b_ml.ml_line_count - ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count - a_lnum))
					l_return := True
				end
			end
			if not l_return then
				l_i___0 := diff_buf_idx (a_wp___0.item.w_buffer)
				if l_i___0 = 4 then
					Result := (0).to_integer_32
					l_return := True
				end
			end
			if not l_return then
				l_n := a_lnum + (l_dp.item.df_lnum[l_i___0] - l_dp.item.df_lnum[l_idx])
				if l_n > l_dp.item.df_lnum[l_i___0] + l_dp.item.df_count[l_i___0] then
					l_n := l_dp.item.df_lnum[l_i___0] + l_dp.item.df_count[l_i___0]
				end
				Result := l_n
			end
		end

feature {ANY} -- routine addresses

	ex_diffupdate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_diffupdate)
		end

	ex_diffpatch_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_diffpatch)
		end

	ex_diffsplit_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_diffsplit)
		end

	ex_diffthis_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_diffthis)
		end

	ex_diffoff_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_diffoff)
		end

end
