class
	P_EX_EVAL_STATIC

inherit
	CE_UTILITIES
	S_LIBINTL_STATIC
	S_STRING_STATIC
	S_STDIO_STATIC

feature {ANY} -- public attributes

	cause_abort: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	aborting: INTEGER_32
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (((create {P_GLOBALS_STATIC}).did_emsg.item).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_GLOBALS_STATIC}).force_abort.item).to_boolean then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_tmp := 1
						elseif ((create {P_GLOBALS_STATIC}).did_throw.item).to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
				when 4 then
					Result := l_tmp
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	update_force_abort
		do
			if cause_abort.item.to_boolean then
				(create {P_GLOBALS_STATIC}).force_abort.item := 1
			end
		end

	should_abort (a_retcode: INTEGER_32): INTEGER_32
		local
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_retcode /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (create {P_GLOBALS_STATIC}).trylevel.item /= 0 then
							if not ((create {P_GLOBALS_STATIC}).emsg_silent.item).to_boolean then
								l_tmp___0 := 1
							else
								l_pos := -1 + 3 -- goto _L___0
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___0:
						if (aborting).to_boolean then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
				when 4 then
					Result := l_tmp___0
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	aborted_in_try: INTEGER_32
		do
			Result := ((create {P_GLOBALS_STATIC}).force_abort.item)
		end

	cause_errthrow (a_mesg: CE_POINTER [NATURAL_8]; a_severe: INTEGER_32; a_ignore___0: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_elem: CE_POINTER [PD_MSGLIST]
			l_plist: CE_POINTER [CE_POINTER [PD_MSGLIST]]
			l_tmsg: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_GLOBALS_STATIC}).suppress_errthrow.item).to_boolean then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not ((create {P_GLOBALS_STATIC}).did_emsg.item).to_boolean then
							cause_abort.item := (create {P_GLOBALS_STATIC}).force_abort.item;
							(create {P_GLOBALS_STATIC}).force_abort.item := 0
						end
						if (create {P_GLOBALS_STATIC}).trylevel.item /= 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not cause_abort.item.to_boolean then
							l_pos := -1 + 5 -- goto _L
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else: | _L___0:
						if not (((create {P_GLOBALS_STATIC}).emsg_silent.item).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if not ((create {P_GLOBALS_STATIC}).did_throw.item).to_boolean then
							Result := 0
							l_return := True
						end
				when 6 then -- if done | if done
					if not l_return then
						if a_mesg.is_equal ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_interr.item))))) then
							a_ignore___0.item := 1
							Result := 1
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 7 then -- if:
						cause_abort.item := 1
						if ((create {P_GLOBALS_STATIC}).did_throw.item).to_boolean then
							if (create {P_GLOBALS_STATIC}).current_exception.item.item.type = 2 then
								(create {P_GLOBALS_STATIC}).got_int.item := 0
							end
							discard_current_exception
						end
						if ((create {P_GLOBALS_STATIC}).msg_list.item).is_void then
							l_pos := -1 + 19 -- skip if block
						end
				when 8 then -- if:
						l_plist := (create {P_GLOBALS_STATIC}).msg_list.item
						from
						until
							(l_plist.item).is_void
						loop
							l_plist := create {CE_POINTER_POINTER [PD_MSGLIST]}.make_shared ((l_plist.item).c_pointer + (create {PD_MSGLIST}.make).offset_of ("next"))
						end
						l_elem := create {CE_CLASS_POINTER [PD_MSGLIST]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_MSGLIST}.make).structure_size.to_natural_32)))
						if not (l_elem.is_void) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:;
						(create {P_GLOBALS_STATIC}).suppress_errthrow.item := 1;
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_outofmem.item)))))).do_nothing
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 11 then -- else:
						l_elem.item.msg := (create {P_MISC2_STATIC}).vim_strsave (a_mesg)
						if not ((l_elem.item.msg).is_void) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_elem));
						(create {P_GLOBALS_STATIC}).suppress_errthrow.item := 1;
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_outofmem.item)))))).do_nothing
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 14 then -- else:
						l_elem.item.next := create {CE_CLASS_POINTER [PD_MSGLIST]}.make_shared (default_pointer)
						l_elem.item.throw_msg := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_plist.item := l_elem
						if not (l_plist.is_equal ((create {P_GLOBALS_STATIC}).msg_list.item)) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L___1
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 17 then -- else:
						if not (a_severe.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 18 then -- if: | _L___1:
						l_tmsg := l_elem.item.msg
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_tmsg), ce_string ("Vim E"), (5).to_natural_32)) = 0 then
							if (l_tmsg[5]).to_integer_32 >= 48 then
								if (l_tmsg[5]).to_integer_32 <= 57 then
									if (l_tmsg[6]).to_integer_32 >= 48 then
										if (l_tmsg[6]).to_integer_32 <= 57 then
											if (l_tmsg[7]).to_integer_32 >= 48 then
												if (l_tmsg[7]).to_integer_32 <= 57 then
													if (l_tmsg[8]).to_integer_32 = 58 then
														if (l_tmsg[9]).to_integer_32 = 32 then
															((create {P_GLOBALS_STATIC}).msg_list.item.item).item.throw_msg := l_tmsg + 4
														else
															((create {P_GLOBALS_STATIC}).msg_list.item.item).item.throw_msg := l_tmsg
														end
													else
														((create {P_GLOBALS_STATIC}).msg_list.item.item).item.throw_msg := l_tmsg
													end
												else
													((create {P_GLOBALS_STATIC}).msg_list.item.item).item.throw_msg := l_tmsg
												end
											else
												((create {P_GLOBALS_STATIC}).msg_list.item.item).item.throw_msg := l_tmsg
											end
										else
											((create {P_GLOBALS_STATIC}).msg_list.item.item).item.throw_msg := l_tmsg
										end
									else
										((create {P_GLOBALS_STATIC}).msg_list.item.item).item.throw_msg := l_tmsg
									end
								else
									((create {P_GLOBALS_STATIC}).msg_list.item.item).item.throw_msg := l_tmsg
								end
							else
								((create {P_GLOBALS_STATIC}).msg_list.item.item).item.throw_msg := l_tmsg
							end
						else
							((create {P_GLOBALS_STATIC}).msg_list.item.item).item.throw_msg := l_tmsg
						end
				when 19 then -- if done | if done | if done | if done
						Result := 1
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	free_msglist (a_l: CE_POINTER [PD_MSGLIST])
		local
			l_messages: CE_POINTER [PD_MSGLIST]
			l_next: CE_POINTER [PD_MSGLIST]
		do
			l_messages := a_l
			from
			until
				l_messages.is_void
			loop
				l_next := l_messages.item.next;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_messages.item.msg));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_messages))
				l_messages := l_next
			end
		end

	do_errthrow (a_cstack: CE_POINTER [PD_CONDSTACK]; a_cmdname: CE_POINTER [NATURAL_8])
		local
			l_return: BOOLEAN
		do
			if cause_abort.item.to_boolean then
				cause_abort.item := 0;
				(create {P_GLOBALS_STATIC}).force_abort.item := 1
			end
			if ((create {P_GLOBALS_STATIC}).msg_list.item).is_void then
				l_return := True
			elseif ((create {P_GLOBALS_STATIC}).msg_list.item.item).is_void then
				l_return := True
			end
			if not l_return then
				if (throw_exception (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).msg_list.item.item), 1, a_cmdname)) = 0 then
					free_msglist ((create {P_GLOBALS_STATIC}).msg_list.item.item)
				elseif not a_cstack.is_void then
					a_cstack.item.do_throw
				else
					(create {P_GLOBALS_STATIC}).need_rethrow.item := 1
				end
				(create {P_GLOBALS_STATIC}).msg_list.item.item := create {CE_CLASS_POINTER [PD_MSGLIST]}.make_shared (default_pointer)
			end
		end

	do_intthrow (a_cstack: CE_POINTER [PD_CONDSTACK]): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
				Result := 0
				l_return := True
			elseif (create {P_GLOBALS_STATIC}).trylevel.item = 0 then
				if not ((create {P_GLOBALS_STATIC}).did_throw.item).to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return and then (((create {P_GLOBALS_STATIC}).did_throw.item).to_boolean) then
				if (create {P_GLOBALS_STATIC}).current_exception.item.item.type = 2 then
					Result := 0
					l_return := True
				end
				if not l_return then
					discard_current_exception
				end
			end
			if not l_return then
				if (throw_exception (create {CE_VOID_POINTER}.make_cast (ce_string ("Vim:Interrupt")), 2, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))) /= 0 then
					a_cstack.item.do_throw
				end
				Result := 1
			end
		end

	throw_exception (a_value: CE_POINTER [ANY]; a_type: INTEGER_32; a_cmdname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_excp: CE_POINTER [PD_VIM_EXCEPTION]
			l_p___0: CE_POINTER [NATURAL_8]
			l_mesg: CE_POINTER [NATURAL_8]
			l_val___0: CE_POINTER [NATURAL_8]
			l_cmdlen: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_save_msg_silent: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_type = 0 then
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (a_value), ce_string ("Vim"), (3).to_natural_32)) = 0 then
							if (create {CE_NATURAL_8_POINTER}.make_cast (a_value)[3]).to_integer_32 = 0 then
								l_tmp := gettext (ce_string ("E608: Cannot :throw exceptions with %'Vim%' prefix"));
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
								l_pos := -1 + 44 -- goto fail
							elseif (create {CE_NATURAL_8_POINTER}.make_cast (a_value)[3]).to_integer_32 = 58 then
								l_tmp := gettext (ce_string ("E608: Cannot :throw exceptions with %'Vim%' prefix"));
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
								l_pos := -1 + 44 -- goto fail
							elseif (create {CE_NATURAL_8_POINTER}.make_cast (a_value)[3]).to_integer_32 = 40 then
								l_tmp := gettext (ce_string ("E608: Cannot :throw exceptions with %'Vim%' prefix"));
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
								l_pos := -1 + 44 -- goto fail
							end
						end
					end
				when 1 then
					l_excp := create {CE_CLASS_POINTER [PD_VIM_EXCEPTION]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_VIM_EXCEPTION}.make).structure_size.to_natural_32)))
					if l_excp.is_void then
						l_pos := -1 + 43 -- goto nomem
					end
				when 2 then
					if a_type /= 1 then
						l_pos := -1 + 35 -- skip if block
					end
				when 3 then -- if:
						l_excp.item.messages := create {CE_CLASS_POINTER [PD_MSGLIST]}.make_cast (a_value)
						l_mesg := (l_excp.item.messages).item.throw_msg
						if a_cmdname.is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						if (a_cmdname.item).to_integer_32 = 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 5 then -- if:
						l_cmdlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_cmdname))).to_integer_32
						l_excp.item.value := (create {P_MISC2_STATIC}).vim_strnsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Vim(")), ((4 + l_cmdlen) + 2) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_mesg))).to_integer_32)
						if (l_excp.item.value).is_void then
							l_pos := -1 + 43 -- goto nomem
						end
				when 6 then
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_excp.item.value + 4)), create {CE_INTEGER_8_POINTER}.make_cast (a_cmdname)).do_nothing
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_excp.item.value + (4 + l_cmdlen))), ce_string ("):")).do_nothing
						l_val___0 := ((l_excp.item.value + 4) + l_cmdlen) + 2
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 10 -- goto _L
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else: | _L:
						l_excp.item.value := (create {P_MISC2_STATIC}).vim_strnsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Vim:")), 4 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_mesg))).to_integer_32)
						if (l_excp.item.value).is_void then
							l_pos := -1 + 43 -- goto nomem
						end
				when 11 then
						l_val___0 := l_excp.item.value + 4
				when 12 then
						l_p___0 := l_mesg
				when 13 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 33 -- skip loop
						end
				when 14 then -- loop body:
						l_break := False
						l_continue := False
						if (l_p___0.item).to_integer_32 /= 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 31 -- goto _L___2
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 17 then -- else:
						if (l_p___0.item).to_integer_32 /= 69 then
							l_pos := -1 + 32 -- skip if block
						end
				when 18 then -- if:
						if not ((l_p___0[1]).to_integer_32 >= 48) then
							l_pos := -1 + 32 -- skip if block
						end
				when 19 then -- if:
						if not ((l_p___0[1]).to_integer_32 <= 57) then
							l_pos := -1 + 32 -- skip if block
						end
				when 20 then -- if:
						if (l_p___0[2]).to_integer_32 /= 58 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 31 -- goto _L___2
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 23 then -- else:
						if not ((l_p___0[2]).to_integer_32 >= 48) then
							l_pos := -1 + 32 -- skip if block
						end
				when 24 then -- if:
						if not ((l_p___0[2]).to_integer_32 <= 57) then
							l_pos := -1 + 32 -- skip if block
						end
				when 25 then -- if:
						if (l_p___0[3]).to_integer_32 /= 58 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 31 -- goto _L___2
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 28 then -- else:
						if not ((l_p___0[3]).to_integer_32 >= 48) then
							l_pos := -1 + 32 -- skip if block
						end
				when 29 then -- if:
						if not ((l_p___0[3]).to_integer_32 <= 57) then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						if (l_p___0[4]).to_integer_32 /= 58 then
							l_pos := -1 + 32 -- skip if block
						end
				when 31 then -- if: | _L___2:
						if (l_p___0.item).to_integer_32 = 0 then
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_val___0), create {CE_INTEGER_8_POINTER}.make_cast (l_mesg)).do_nothing
						elseif l_p___0.is_equal (l_mesg) then
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_val___0), create {CE_INTEGER_8_POINTER}.make_cast (l_mesg)).do_nothing
						else
							if (l_mesg[0]).to_integer_32 /= 34 then
								l_continue := True
							elseif ((l_p___0 - 2).c_pointer.to_integer_32).to_natural_32 < ((l_mesg + 1).c_pointer.to_integer_32).to_natural_32 then
								l_continue := True
							elseif (l_p___0[-2]).to_integer_32 /= 34 then
								l_continue := True
							elseif (l_p___0[-1]).to_integer_32 /= 32 then
								l_continue := True
							end
							if not (l_break or l_continue) then
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_val___0), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0)).do_nothing
								l_p___0[-2] := (('%/0/').code).to_natural_8
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((l_val___0 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32)), ce_string (" (%%s)"), l_mesg + 1]).do_nothing
								l_p___0[-2] := (('%"').code).to_natural_8
							end
						end
						if not (l_break or l_continue) then
							l_break := True
						end
				when 32 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if (not l_break) then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 13 -- back to loop condition
				when 33 then -- loop done
						l_break := False
						l_continue := False
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else:
						l_excp.item.value := create {CE_NATURAL_8_POINTER}.make_cast (a_value)
				when 36 then -- if done
					l_excp.item.type := a_type
					if ((create {P_GLOBALS_STATIC}).sourcing_name.item).is_void then
						l_tmp___6 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
					else
						l_tmp___6 := (create {P_GLOBALS_STATIC}).sourcing_name.item
					end
					l_excp.item.throw_name := (create {P_MISC2_STATIC}).vim_strsave (l_tmp___6)
					if (l_excp.item.throw_name).is_void then
						if a_type = 1 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_excp.item.value))
						end
						l_pos := -1 + 43 -- goto nomem
					end
				when 37 then
					l_excp.item.throw_lnum := (create {P_GLOBALS_STATIC}).sourcing_lnum.item
					if not ((create {P_OPTION_STATIC}).p_verbose.item.item >= 13) then
						l_pos := -1 + 40 -- skip if block
					end
				when 38 then -- if:
						l_pos := -1 + 41 -- goto _L___3
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 40 then -- else:
						if not ((create {P_GLOBALS_STATIC}).debug_break_level.item > 0) then
							l_pos := -1 + 42 -- skip if block
						end
				when 41 then -- if: | _L___3:
						l_save_msg_silent := (create {P_GLOBALS_STATIC}).msg_silent.item
						if (create {P_GLOBALS_STATIC}).debug_break_level.item > 0 then
							(create {P_GLOBALS_STATIC}).msg_silent.item := 0
						else
							(create {P_MESSAGE_STATIC}).verbose_enter
						end
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item + 1
						if (create {P_GLOBALS_STATIC}).debug_break_level.item > 0 then
							(create {P_GLOBALS_STATIC}).msg_scroll.item := 1
						elseif ((create {P_OPTION_STATIC}).p_vfile.item.item.item).to_integer_32 = 0 then
							(create {P_GLOBALS_STATIC}).msg_scroll.item := 1
						end
						(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Exception thrown: %%s")))), l_excp.item.value]).do_nothing;
						(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")))
						if (create {P_GLOBALS_STATIC}).debug_break_level.item > 0 then
							(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item
						elseif ((create {P_OPTION_STATIC}).p_vfile.item.item.item).to_integer_32 = 0 then
							(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item
						end
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1
						if (create {P_GLOBALS_STATIC}).debug_break_level.item > 0 then
							(create {P_GLOBALS_STATIC}).msg_silent.item := l_save_msg_silent
						else
							(create {P_MESSAGE_STATIC}).verbose_leave
						end
				when 42 then -- if done;
					(create {P_GLOBALS_STATIC}).current_exception.item := l_excp
					Result := 1
					l_return := True
					if l_return then
						l_pos := -1 + 45 -- skip if block
					end
				when 43 then -- if: | nomem:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_excp));
						(create {P_GLOBALS_STATIC}).suppress_errthrow.item := 1;
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_outofmem.item)))))).do_nothing
				when 44 then -- fail:;
						(create {P_GLOBALS_STATIC}).current_exception.item := create {CE_CLASS_POINTER [PD_VIM_EXCEPTION]}.make_shared (default_pointer)
						Result := 0
				when 45 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	discard_exception (a_excp: CE_POINTER [PD_VIM_EXCEPTION]; a_was_finished: INTEGER_32)
		local
			l_saved_IObuff: CE_POINTER [NATURAL_8]
			l_save_msg_silent: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_excp.is_void then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_internal.item)))))).do_nothing
						l_return := True
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if not ((create {P_OPTION_STATIC}).p_verbose.item.item >= 13) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not ((create {P_GLOBALS_STATIC}).debug_break_level.item > 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_save_msg_silent := (create {P_GLOBALS_STATIC}).msg_silent.item
						l_saved_IObuff := (create {P_MISC2_STATIC}).vim_strsave ((create {P_GLOBALS_STATIC}).IObuff.item)
						if (create {P_GLOBALS_STATIC}).debug_break_level.item > 0 then
							(create {P_GLOBALS_STATIC}).msg_silent.item := 0
						else
							(create {P_MESSAGE_STATIC}).verbose_enter
						end
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item + 1
						if (create {P_GLOBALS_STATIC}).debug_break_level.item > 0 then
							(create {P_GLOBALS_STATIC}).msg_scroll.item := 1
						elseif ((create {P_OPTION_STATIC}).p_vfile.item.item.item).to_integer_32 = 0 then
							(create {P_GLOBALS_STATIC}).msg_scroll.item := 1
						end
						if a_was_finished.to_boolean then
							l_tmp___2 := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Exception finished: %%s"))))
						else
							l_tmp___2 := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Exception discarded: %%s"))))
						end
						(create {P_MESSAGE_STATIC}).smsg ([l_tmp___2, a_excp.item.value]).do_nothing;
						(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")))
						if (create {P_GLOBALS_STATIC}).debug_break_level.item > 0 then
							(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item
						elseif ((create {P_OPTION_STATIC}).p_vfile.item.item.item).to_integer_32 = 0 then
							(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item
						end
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1
						if (create {P_GLOBALS_STATIC}).debug_break_level.item > 0 then
							(create {P_GLOBALS_STATIC}).msg_silent.item := l_save_msg_silent
						else
							(create {P_MESSAGE_STATIC}).verbose_leave
						end
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), create {CE_INTEGER_8_POINTER}.make_cast (l_saved_IObuff)).do_nothing;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_saved_IObuff))
				when 6 then -- if done
						if a_excp.item.type /= 2 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_excp.item.value))
						end
						if a_excp.item.type = 1 then
							free_msglist (a_excp.item.messages)
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_excp.item.throw_name));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_excp))
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	discard_current_exception
		do
			discard_exception ((create {P_GLOBALS_STATIC}).current_exception.item, 0);
			(create {P_GLOBALS_STATIC}).current_exception.item := create {CE_CLASS_POINTER [PD_VIM_EXCEPTION]}.make_shared (default_pointer);
			(create {P_GLOBALS_STATIC}).did_throw.item := 0;
			(create {P_GLOBALS_STATIC}).need_rethrow.item := 0
		end

	report_pending (a_action, a_pending: INTEGER_32; a_value: CE_POINTER [ANY])
		local
			l_mesg: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [INTEGER_8]
			l_save_msg_silent: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_action -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 0
					l_mesg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%%s made pending"))))
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 1
					l_mesg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%%s resumed"))))
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					l_mesg := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%%s discarded"))))
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					inspect a_pending -- switch 2 head
					when 0 then l_pos := -1 + 5
					when 16 then l_pos := -1 + 6
					when 8 then l_pos := -1 + 7
					when 32 then l_pos := -1 + 8
					when 24 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 5 then -- switch 2, case 0
					l_return := True
				when 6 then -- switch 2, case 16
					if not l_return then
						l_s := ce_string (":continue")
					end
					l_pos := -1 + 17 -- switch 2; break
				when 7 then -- switch 2, case 8
					l_s := ce_string (":break")
					l_pos := -1 + 17 -- switch 2; break
				when 8 then -- switch 2, case 32
					l_s := ce_string (":finish")
					l_pos := -1 + 17 -- switch 2; break
				when 9 then -- switch 2, case 24
					l_s := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_EVAL_STATIC}).get_return_cmd (a_value)))
					l_pos := -1 + 17 -- switch 2; break
				when 10 then -- switch 2, default:
					if not (((a_pending).bit_and (4)).to_boolean) then
						l_pos := -1 + 13 -- skip if block
					end
				when 11 then -- if:;
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, create {CE_INTEGER_8_POINTER}.make_cast (l_mesg), (gettext (ce_string ("Exception")))]).do_nothing
						l_mesg := (create {P_MISC2_STATIC}).vim_strnsave ((create {P_GLOBALS_STATIC}).IObuff.item, (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item))).to_integer_32 + 4)
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_mesg), ce_string (": %%s")).do_nothing
						l_s := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_VIM_EXCEPTION]}.make_cast (a_value)).item.value)
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 13 then -- else:
						if not (((a_pending).bit_and (1)).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if ((a_pending).bit_and (2)).to_boolean then
							l_s := gettext (ce_string ("Error and interrupt"))
						else
							l_pos := -1 + 16 -- goto _L
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L:
						if ((a_pending).bit_and (1)).to_boolean then
							l_s := gettext (ce_string ("Error"))
						else
							l_s := gettext (ce_string ("Interrupt"))
						end
				when 17 then -- if done | switch 2, done:
					if not l_return then
						l_save_msg_silent := (create {P_GLOBALS_STATIC}).msg_silent.item
						if (create {P_GLOBALS_STATIC}).debug_break_level.item > 0 then
							(create {P_GLOBALS_STATIC}).msg_silent.item := 0
						end
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item + 1;
						(create {P_GLOBALS_STATIC}).msg_scroll.item := 1;
						(create {P_MESSAGE_STATIC}).smsg ([l_mesg, create {CE_NATURAL_8_POINTER}.make_cast (l_s)]).do_nothing;
						(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")));
						(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item;
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1
						if (create {P_GLOBALS_STATIC}).debug_break_level.item > 0 then
							(create {P_GLOBALS_STATIC}).msg_silent.item := l_save_msg_silent
						end
						if a_pending = 24 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_s))
						elseif ((a_pending).bit_and (4)).to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_mesg))
						end
					end
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	report_make_pending (a_pending: INTEGER_32; a_value: CE_POINTER [ANY])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((create {P_OPTION_STATIC}).p_verbose.item.item >= 14) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((create {P_GLOBALS_STATIC}).debug_break_level.item > 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if (create {P_GLOBALS_STATIC}).debug_break_level.item <= 0 then
							(create {P_MESSAGE_STATIC}).verbose_enter
						end
						report_pending (0, a_pending, a_value)
						if (create {P_GLOBALS_STATIC}).debug_break_level.item <= 0 then
							(create {P_MESSAGE_STATIC}).verbose_leave
						end
				when 5 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	report_resume_pending (a_pending: INTEGER_32; a_value: CE_POINTER [ANY])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((create {P_OPTION_STATIC}).p_verbose.item.item >= 14) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((create {P_GLOBALS_STATIC}).debug_break_level.item > 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if (create {P_GLOBALS_STATIC}).debug_break_level.item <= 0 then
							(create {P_MESSAGE_STATIC}).verbose_enter
						end
						report_pending (1, a_pending, a_value)
						if (create {P_GLOBALS_STATIC}).debug_break_level.item <= 0 then
							(create {P_MESSAGE_STATIC}).verbose_leave
						end
				when 5 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	report_discard_pending (a_pending: INTEGER_32; a_value: CE_POINTER [ANY])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((create {P_OPTION_STATIC}).p_verbose.item.item >= 14) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((create {P_GLOBALS_STATIC}).debug_break_level.item > 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if (create {P_GLOBALS_STATIC}).debug_break_level.item <= 0 then
							(create {P_MESSAGE_STATIC}).verbose_enter
						end
						report_pending (2, a_pending, a_value)
						if (create {P_GLOBALS_STATIC}).debug_break_level.item <= 0 then
							(create {P_MESSAGE_STATIC}).verbose_leave
						end
				when 5 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_endfunction (a_eap: CE_POINTER [PD_EXARG])
		do
			(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E193: :endfunction not inside a function"))))).do_nothing
		end

	has_loop_cmd (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_p___0
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0.item).to_integer_32 /= 32 then
								if (l_p___0.item).to_integer_32 /= 9 then
									if (l_p___0.item).to_integer_32 /= 58 then
										l_break := True
									end
								end
							end
							if not (l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						l_len := (create {P_EX_DOCMD_STATIC}).modifier_len (l_p___0)
						if l_len = 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_p___0 := l_p___0 + l_len
						end
					end
					l_break := False
					if (l_p___0[0]).to_integer_32 /= 119 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (l_p___0[1]).to_integer_32 = 104 then
							Result := 1
							l_return := True
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (l_p___0[0]).to_integer_32 = 102 then
							if (l_p___0[1]).to_integer_32 = 111 then
								if (l_p___0[2]).to_integer_32 = 114 then
									Result := 1
									l_return := True
								end
							end
						end
				when 4 then
					if not l_return then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	ex_endfunction_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_endfunction)
		end

end
