class
	P_MEMLINE_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_CTYPE_STATIC
	S_LIBINTL_STATIC
	S_UNISTD_STATIC
	S_SYS_STAT_STATIC
	S_TIME_STATIC
	S_FCNTL_STATIC
	S_SIGNAL_STATIC
	S_BITS_ERRNO_STATIC

feature {ANY} -- public attributes

	lowest_marked: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (0).to_integer_32
		end

	process_still_running: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

feature {ANY} -- public routines

	ml_open_files
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
		do
			l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
			from
			until
				l_buf___6.is_void
			loop
				if not (l_buf___6.item.b_p_ro).to_boolean then
					l_buf___6.item.ml_open_file
				elseif (l_buf___6.item.b_changed).to_boolean then
					l_buf___6.item.ml_open_file
				end
				l_buf___6 := l_buf___6.item.b_next
			end
		end

	check_need_swap (a_newfile: INTEGER_32)
		do
			if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_may_swap).to_boolean then
				if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro).to_boolean then
					((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_open_file
				elseif not a_newfile.to_boolean then
					((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_open_file
				end
			end
		end

	ml_close_all (a_del_file: INTEGER_32)
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp___0: INTEGER_32
		do
			l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
			from
			until
				l_buf___6.is_void
			loop
				if a_del_file.to_boolean then
					if ((l_buf___6.item.b_flags).bit_and (256)) = 0 then
						l_tmp___0 := 1
					elseif ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('&').code)).is_void then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 0
				end
				l_buf___6.item.ml_close (l_tmp___0)
				l_buf___6 := l_buf___6.item.b_next
			end
			(create {P_FILEIO_STATIC}).vim_deltempdir
		end

	ml_close_notmod
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
		do
			l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
			from
			until
				l_buf___6.is_void
			loop
				if not (l_buf___6.item.bufIsChanged).to_boolean then
					l_buf___6.item.ml_close (1)
				end
				l_buf___6 := l_buf___6.item.b_next
			end
		end

	ml_recover
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_mfp: CE_POINTER [PD_MEMFILE]
			l_fname: CE_POINTER [NATURAL_8]
			l_fname_used: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_b0p: CE_POINTER [PD_BLOCK0]
			l_b0_ff: INTEGER_32
			l_b0_fenc: CE_POINTER [NATURAL_8]
			l_b0_cm: INTEGER_32
			l_pp: CE_POINTER [PD_POINTER_BLOCK]
			l_dp: CE_POINTER [PD_DATA_BLOCK]
			l_ip: CE_POINTER [PD_INFO_POINTER]
			l_bnum: INTEGER_32
			l_page_count___0: INTEGER_32
			l_org_stat: CE_ARRAY [SD_STAT]
			l_swp_stat: CE_ARRAY [SD_STAT]
			l_len: INTEGER_32
			l_directly: INTEGER_32
			l_lnum: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_error: INTEGER_32
			l_cannot_open: INTEGER_32
			l_line_count: INTEGER_32
			l_has_error: INTEGER_32
			l_idx: INTEGER_32
			l_top: INTEGER_32
			l_txt_start: INTEGER_32
			l_size: INTEGER_32
			l_called_from_main: INTEGER_32
			l_serious_error: INTEGER_32
			l_mtime: INTEGER_32
			l_attr: INTEGER_32
			l_orig_file_status: INTEGER_32
			l_previous_page_size: NATURAL_32
			l_tmp___27: CE_POINTER [INTEGER_8]
			l_fnsize: INTEGER_32
			l_tmp___37: CE_POINTER [INTEGER_8]
			l_tmp___38: INTEGER_32
			l_tmp___39: CE_POINTER [INTEGER_8]
			l_tmp___40: INTEGER_32
			l_tmp___41: CE_POINTER [INTEGER_8]
			l_tmp___42: INTEGER_32
			l_tmp___44: CE_POINTER [INTEGER_8]
			l_tmp___45: INTEGER_32
			l_tmp___47: CE_POINTER [INTEGER_8]
			l_tmp___48: INTEGER_32
			l_tmp___49: CE_POINTER [INTEGER_8]
			l_tmp___50: INTEGER_32
			l_tmp___51: CE_POINTER [INTEGER_8]
			l_tmp___52: INTEGER_32
			l_tmp___53: INTEGER_32
			l_tmp___54: CE_POINTER [INTEGER_8]
			l_tmp___55: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_fname_used.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_org_stat.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_swp_stat.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
					l_mfp := create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (default_pointer)
					l_fname_used.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_hp := create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer)
					l_b0_fenc := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_b0_cm := -1
					l_serious_error := 1
					l_orig_file_status := 2;
					(create {P_GLOBALS_STATIC}).recoverymode.item := 1
					l_called_from_main := (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_mfp).is_void).to_integer
					l_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[3]
					l_fname := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname
					if l_fname.is_void then
						l_fname := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
					end
					l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fname))).to_integer_32
					if not (l_len >= 4) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (((l_fname + l_len) - 4)), ce_string (".s"), (2).to_natural_32)) = 0 then
							if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("UVWuvw")), (l_fname[(l_len - 2)]).to_integer_32)).is_void then
								if (l_fname[(l_len - 1)]).to_integer_32 < 127 then
									if ((((ctype_b_loc).item[(l_fname[(l_len - 1)]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
										l_directly := 1
										l_fname_used.item := (create {P_MISC2_STATIC}).vim_strsave (l_fname)
									else
										l_pos := -1 + 3 -- goto _L___1
									end
								else
									l_pos := -1 + 3 -- goto _L___1
								end
							else
								l_pos := -1 + 3 -- goto _L___1
							end
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 3 then -- else: | _L___1:
						l_directly := 0
						l_len := recover_names (l_fname, 0, 0, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
						if l_len = 0 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E305: No swap file found for %%s")))), l_fname).do_nothing
							l_pos := -1 + 51 -- goto theend
						end
				when 4 then
						if l_len = 1 then
							l_i___0 := 1
						else
							recover_names (l_fname, 1, 0, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing;
							(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code);
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Enter number of swap file to use (0 to quit): ")))))
							l_i___0 := (create {P_MISC1_STATIC}).get_number (0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
							if l_i___0 < 1 then
								l_pos := -1 + 51 -- goto theend
							elseif l_i___0 > l_len then
								l_pos := -1 + 51 -- goto theend
							end
						end
				when 5 then
						recover_names (l_fname, 0, l_i___0, l_fname_used).do_nothing
				when 6 then
					if (l_fname_used.item).is_void then
						l_pos := -1 + 51 -- goto theend
					end
				when 7 then
					if l_called_from_main.to_boolean then
						if (((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_open) = 0 then
							(create {P_MAIN_STATIC}).getout (1)
						end
					end
					l_buf___6 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_FILE_BUFFER}.make).structure_size.to_natural_32)))
					if l_buf___6.is_void then
						l_pos := -1 + 51 -- goto theend
					end
				when 8 then
					l_buf___6.item.b_ml.ml_stack_size := 0
					l_buf___6.item.b_ml.ml_stack := create {CE_CLASS_POINTER [PD_INFO_POINTER]}.make_shared (default_pointer)
					l_buf___6.item.b_ml.ml_stack_top := 0
					l_buf___6.item.b_ml.ml_line_lnum := (0).to_integer_32
					l_buf___6.item.b_ml.ml_locked := create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer)
					l_buf___6.item.b_ml.ml_flags := 0
					l_buf___6.item.b_p_key := (create {P_GLOBALS_STATIC}).empty_option.item
					l_buf___6.item.b_p_cm := (create {P_GLOBALS_STATIC}).empty_option.item
					l_p___0 := (create {P_MISC2_STATIC}).vim_strsave (l_fname_used.item)
					l_mfp := (create {P_MEMFILE_STATIC}).mf_open (l_fname_used.item, 0)
					l_fname_used.item := l_p___0
					if not (l_mfp.is_void) then
						l_pos := -1 + 11 -- skip if block
					end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___2
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not (l_mfp.item.mf_fd < 0) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L___2:
						if not (l_fname_used.item).is_void then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E306: Cannot open %%s")))), l_fname_used.item).do_nothing
						end
						l_pos := -1 + 51 -- goto theend
				when 13 then -- if done
					l_buf___6.item.b_ml.ml_mfp := l_mfp
					l_mfp.item.mf_buffer := l_buf___6
					l_mfp.item.mf_page_size := {NATURAL_32} 1_048
					l_hp := l_mfp.item.mf_get ((0).to_integer_32, 1)
					if l_hp.is_void then
						(create {P_MESSAGE_STATIC}).msg_start;
						(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Unable to read block 0 from ")))), (l_attr).bit_or (4_096));
						(create {P_MESSAGE_STATIC}).msg_outtrans_attr (l_mfp.item.mf_fname, (l_attr).bit_or (4_096)).do_nothing;
						(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%NMaybe no changes were made or Vim did not update the swap file.")))), (l_attr).bit_or (4_096));
						(create {P_MESSAGE_STATIC}).msg_end.do_nothing
						l_pos := -1 + 51 -- goto theend
					end
				when 14 then
					l_b0p := create {CE_CLASS_POINTER [PD_BLOCK0]}.make_cast (l_hp.item.bh_data)
					if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_b0p.item.b0_version)), ce_string ("VIM 3.0"), (7).to_natural_32)) = 0 then
						(create {P_MESSAGE_STATIC}).msg_start;
						(create {P_MESSAGE_STATIC}).msg_outtrans_attr (l_mfp.item.mf_fname, 4_096).do_nothing;
						(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string (" cannot be used with this version of Vim.%N")))), 4_096);
						(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Use Vim version 3.0.%N")))), 4_096);
						(create {P_MESSAGE_STATIC}).msg_end.do_nothing
						l_pos := -1 + 51 -- goto theend
					end
				when 15 then
					if (l_b0p.item.ml_check_b0_id) = 0 then
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E307: %%s does not look like a Vim swap file")))), l_mfp.item.mf_fname).do_nothing
						l_pos := -1 + 51 -- goto theend
					end
				when 16 then
					if (l_b0p.item.b0_magic_wrong).to_boolean then
						(create {P_MESSAGE_STATIC}).msg_start;
						(create {P_MESSAGE_STATIC}).msg_outtrans_attr (l_mfp.item.mf_fname, (l_attr).bit_or (4_096)).do_nothing;
						(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string (" cannot be used on this computer.%N")))), (l_attr).bit_or (4_096));
						(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("The file was created on ")))), (l_attr).bit_or (4_096))
						l_b0p.item.b0_fname[0] := (('%/0/').code).to_natural_8;
						(create {P_MESSAGE_STATIC}).msg_puts_attr (l_b0p.item.b0_hname, (l_attr).bit_or (4_096));
						(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string (",%Nor the file has been damaged.")))), (l_attr).bit_or (4_096));
						(create {P_MESSAGE_STATIC}).msg_end.do_nothing
						l_pos := -1 + 51 -- goto theend
					end
				when 17 then
					if (l_b0p.item.b0_id[1]).to_integer_32 = 99 then
						l_b0_cm := 0
					elseif (l_b0p.item.b0_id[1]).to_integer_32 = 67 then
						l_b0_cm := 1
						memmove (create {CE_VOID_POINTER}.make_cast ((l_mfp.item.mf_seed)), create {CE_VOID_POINTER}.make_cast ((create {CE_NATURAL_8_POINTER}.make_shared (l_b0p.c_pointer + (create {PD_BLOCK0}.make).offset_of ("b0_fname") + {PLATFORM}.Natural_8_bytes * (890)))), (8).to_natural_32).do_nothing
					end
					l_buf___6.item.set_crypt_method (l_b0_cm)
					if l_mfp.item.mf_page_size = (char_to_long (l_b0p.item.b0_page_size)).to_natural_32 then
						l_pos := -1 + 21 -- skip if block
					end
				when 18 then -- if:
						l_previous_page_size := l_mfp.item.mf_page_size
						l_mfp.item.mf_new_page_size ((char_to_long (l_b0p.item.b0_page_size)).to_natural_32)
						if l_mfp.item.mf_page_size < l_previous_page_size then
							(create {P_MESSAGE_STATIC}).msg_start;
							(create {P_MESSAGE_STATIC}).msg_outtrans_attr (l_mfp.item.mf_fname, (l_attr).bit_or (4_096)).do_nothing;
							(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string (" has been damaged (page size is smaller than minimum value).%N")))), (l_attr).bit_or (4_096));
							(create {P_MESSAGE_STATIC}).msg_end.do_nothing
							l_pos := -1 + 51 -- goto theend
						end
				when 19 then
						l_size := lseek (l_mfp.item.mf_fd, 0, 2)
						if l_size <= 0 then
							l_mfp.item.mf_blocknr_max := (0).to_integer_32
						else
							l_mfp.item.mf_blocknr_max := (l_size.to_natural_32 // (l_mfp.item.mf_page_size).to_natural_32).to_integer_32
						end
						l_mfp.item.mf_infile_count := l_mfp.item.mf_blocknr_max
						l_p___0 := (create {P_MISC2_STATIC}).alloc (l_mfp.item.mf_page_size)
						if l_p___0.is_void then
							l_pos := -1 + 51 -- goto theend
						end
				when 20 then
						memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_hp.item.bh_data), l_previous_page_size).do_nothing;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_hp.item.bh_data))
						l_hp.item.bh_data := l_p___0
						l_b0p := create {CE_CLASS_POINTER [PD_BLOCK0]}.make_cast (l_hp.item.bh_data)
				when 21 then -- if done
					if l_directly.to_boolean then
						(create {P_MISC1_STATIC}).expand_env (l_b0p.item.b0_fname, (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096)
						if ((create {P_BUFFER_STATIC}).setfname ((create {P_GLOBALS_STATIC}).curbuf.item, (create {P_GLOBALS_STATIC}).NameBuff.item.item, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 1)) = 0 then
							l_pos := -1 + 51 -- goto theend
						end
					end
				when 22 then;
					(create {P_MISC1_STATIC}).home_replace (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_mfp.item.mf_fname, (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096, 1);
					(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Using swap file %"%%s%"")))), (create {P_GLOBALS_STATIC}).NameBuff.item.item]).do_nothing
					if not (((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_spname).is_void then
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item), (((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_spname)).do_nothing
					else
						(create {P_MISC1_STATIC}).home_replace (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname, (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096, 1)
					end
					(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Original file %"%%s%"")))), (create {P_GLOBALS_STATIC}).NameBuff.item.item]).do_nothing;
					(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
					l_mtime := char_to_long (l_b0p.item.b0_mtime)
					if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
						l_pos := -1 + 28 -- skip if block
					end
				when 23 then -- if:
						if (stat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname), l_org_stat)) = -1 then
							l_pos := -1 + 28 -- skip if block
						end
				when 24 then -- if:
						if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_mfp.item.mf_fname), l_swp_stat)) = -1 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if l_org_stat.item.st_mtim.tv_sec > l_swp_stat.item.st_mtim.tv_sec then
							l_tmp___27 := gettext (ce_string ("E308: Warning: Original file may have been changed"));
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___27)).do_nothing
						else
							l_pos := -1 + 27 -- goto _L___3
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else: | _L___3:
						if l_org_stat.item.st_mtim.tv_sec /= l_mtime then
							l_tmp___27 := gettext (ce_string ("E308: Warning: Original file may have been changed"));
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___27)).do_nothing
						end
				when 28 then -- if done | if done;
					(create {P_TERM_STATIC}).out_flush
					l_b0_ff := ((l_b0p.item.b0_fname[898]).to_integer_32).bit_and (3)
					if (((l_b0p.item.b0_fname[898]).to_integer_32).bit_and (8)).to_boolean then
						l_fnsize := 898
						if (l_b0p.item.b0_id[1]).to_integer_32 /= 48 then
							l_fnsize := 890
						end
						l_p___0 := l_b0p.item.b0_fname + l_fnsize
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 > ((l_b0p.item.b0_fname).c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0[-1]).to_integer_32 = 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_p___0 := l_p___0 - 1
							end
						end
						l_break := False
						l_b0_fenc := (create {P_MISC2_STATIC}).vim_strnsave (l_p___0, (l_b0p.item.b0_fname + l_fnsize).distance (l_p___0))
					end
					(create {P_MEMFILE_STATIC}).mf_put (l_mfp, l_hp, 0, 0)
					l_hp := create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer)
					from
					until
						(((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_and (1)).to_boolean
					loop
						ml_delete ((1).to_integer_32, 0).do_nothing
					end
					if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
						l_orig_file_status := (create {P_FILEIO_STATIC}).readfile ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), (0).to_integer_32, (0).to_integer_32, 2_147_483_647, create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), 1)
					end
					if l_b0_cm >= 0 then
						if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_key).item).to_integer_32 /= 0 then
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Swap file is encrypted: %"%%s%"")))), l_fname_used.item]).do_nothing;
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%NIf you entered a new crypt key but did not write the text file,")))));
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%Nenter the new crypt key.")))));
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%NIf you wrote the text file after changing the crypt key press enter")))));
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%Nto use the same key for text file and swap file")))))
						else
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (((create {P_GLOBALS_STATIC}).need_key_msg.item)))), l_fname_used.item]).do_nothing
						end
						l_buf___6.item.b_p_key := (create {P_MISC2_STATIC}).get_crypt_key (0, 0)
						if (l_buf___6.item.b_p_key).is_void then
							l_buf___6.item.b_p_key := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_key
						elseif ((l_buf___6.item.b_p_key).item).to_integer_32 = 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6.item.b_p_key))
							l_buf___6.item.b_p_key := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_key
						end
						if (l_buf___6.item.b_p_key).is_void then
							l_buf___6.item.b_p_key := (create {P_GLOBALS_STATIC}).empty_option.item
						end
					end
					if l_b0_ff /= 0 then
						(create {P_MISC2_STATIC}).set_fileformat (l_b0_ff - 1, 4)
					end
					if not l_b0_fenc.is_void then
						(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("fenc")), 0, l_b0_fenc, 4);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_b0_fenc))
					end
					((create {P_GLOBALS_STATIC}).curbuf.item).item.unchanged (1)
					l_bnum := (1).to_integer_32
					l_page_count___0 := 1
					l_lnum := (0).to_integer_32
					l_line_count := (0).to_integer_32
					l_idx := 0
					l_error := 0
					l_buf___6.item.b_ml.ml_stack_top := 0
					l_buf___6.item.b_ml.ml_stack := create {CE_CLASS_POINTER [PD_INFO_POINTER]}.make_shared (default_pointer)
					l_buf___6.item.b_ml.ml_stack_size := 0
					if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
						l_cannot_open := 1
					else
						l_cannot_open := 0
					end
					l_serious_error := 0
				when 29 then -- loop condition:
					if not (not (l_return or l_break) and then (not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean)) then
						l_pos := -1 + 43 -- skip loop
					end
				when 30 then -- loop body:
						l_break := False
						l_continue := False
						if not l_hp.is_void then
							(create {P_MEMFILE_STATIC}).mf_put (l_mfp, l_hp, 0, 0)
						end
						l_hp := l_mfp.item.mf_get (l_bnum, l_page_count___0)
						if not (l_hp.is_void) then
							l_pos := -1 + 34 -- skip if block
						end
				when 31 then -- if:
						if l_bnum = 1 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E309: Unable to read block 1 from %%s")))), l_mfp.item.mf_fname).do_nothing
							l_pos := -1 + 51 -- goto theend
						end
				when 32 then
						l_error := l_error + 1
						l_tmp___37 := gettext (ce_string ("???MANY LINES MISSING"))
						l_tmp___38 := l_lnum
						l_lnum := l_lnum + 1
						ml_append (l_tmp___38, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___37), 0, 1).do_nothing
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 34 then -- else:
						l_pp := create {CE_CLASS_POINTER [PD_POINTER_BLOCK]}.make_cast (l_hp.item.bh_data)
						if (l_pp.item.pb_id).to_integer_32 /= ((112).bit_shift_left (8)) + 116 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						if l_idx = 0 then
							if l_line_count /= 0 then
								l_i___0 := 0
								from
								until
									not (l_i___0 < (l_pp.item.pb_count).to_integer_32)
								loop
									l_line_count := l_line_count - (l_pp.item.pb_pointer[l_i___0].pe_line_count)
									l_i___0 := l_i___0 + 1
								end
								if l_line_count /= 0 then
									l_error := l_error + 1
									l_tmp___39 := gettext (ce_string ("???LINE COUNT WRONG"))
									l_tmp___40 := l_lnum
									l_lnum := l_lnum + 1
									ml_append (l_tmp___40, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___39), 0, 1).do_nothing
								end
							end
						end
						if (l_pp.item.pb_count).to_integer_32 = 0 then
							l_tmp___41 := gettext (ce_string ("???EMPTY BLOCK"))
							l_tmp___42 := l_lnum
							l_lnum := l_lnum + 1
							ml_append (l_tmp___42, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___41), 0, 1).do_nothing
							l_error := l_error + 1
						elseif l_idx < (l_pp.item.pb_count).to_integer_32 then
							if l_pp.item.pb_pointer[l_idx].pe_bnum < 0 then
								if not l_cannot_open.to_boolean then
									l_line_count := l_pp.item.pb_pointer[l_idx].pe_line_count
									if ((create {P_FILEIO_STATIC}).readfile ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_lnum, l_pp.item.pb_pointer[l_idx].pe_old_lnum - 1, l_line_count, create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), 0)) = 0 then
										l_cannot_open := 1
									else
										l_lnum := l_lnum + l_line_count
									end
								end
								if l_cannot_open.to_boolean then
									l_error := l_error + 1
									l_tmp___44 := gettext (ce_string ("???LINES MISSING"))
									l_tmp___45 := l_lnum
									l_lnum := l_lnum + 1
									ml_append (l_tmp___45, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___44), 0, 1).do_nothing
								end
								l_idx := l_idx + 1
								l_continue := True
							end
							if not (l_return or l_break or l_continue) then
								l_top := l_buf___6.item.ml_add_stack
								if l_top < 0 then
									l_error := l_error + 1
									l_break := True
								end
							end
							if not (l_return or l_break or l_continue) then
								l_ip := l_buf___6.item.b_ml.ml_stack + l_top
								l_ip.item.ip_bnum := l_bnum
								l_ip.item.ip_index := l_idx
								l_bnum := l_pp.item.pb_pointer[l_idx].pe_bnum
								l_line_count := l_pp.item.pb_pointer[l_idx].pe_line_count
								l_page_count___0 := l_pp.item.pb_pointer[l_idx].pe_page_count
								l_continue := True
							end
						end
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 37 then -- else:
						l_dp := create {CE_CLASS_POINTER [PD_DATA_BLOCK]}.make_cast (l_hp.item.bh_data)
						if (l_dp.item.db_id).to_integer_32 = ((100).bit_shift_left (8)) + 97 then
							l_pos := -1 + 41 -- skip if block
						end
				when 38 then -- if:
						if l_bnum = 1 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E310: Block 1 ID wrong (%%s not a .swp file?)")))), l_mfp.item.mf_fname).do_nothing
							l_pos := -1 + 51 -- goto theend
						end
				when 39 then
						l_error := l_error + 1
						l_tmp___47 := gettext (ce_string ("???BLOCK MISSING"))
						l_tmp___48 := l_lnum
						l_lnum := l_lnum + 1
						ml_append (l_tmp___48, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___47), 0, 1).do_nothing
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else:
						l_has_error := 0
						if l_page_count___0.to_natural_32 * l_mfp.item.mf_page_size /= l_dp.item.db_txt_end then
							l_tmp___49 := gettext (ce_string ("??? from here until ???END lines may be messed up"))
							l_tmp___50 := l_lnum
							l_lnum := l_lnum + 1
							ml_append (l_tmp___50, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___49), 0, 1).do_nothing
							l_error := l_error + 1
							l_has_error := 1
							l_dp.item.db_txt_end := l_page_count___0.to_natural_32 * l_mfp.item.mf_page_size
						end
						(create {CE_NATURAL_8_POINTER}.make_cast (l_dp) + (l_dp.item.db_txt_end).to_integer_32)[-1] := (('%/0/').code).to_natural_8
						if l_line_count /= l_dp.item.db_line_count then
							l_tmp___51 := gettext (ce_string ("??? from here until ???END lines may have been inserted/deleted"))
							l_tmp___52 := l_lnum
							l_lnum := l_lnum + 1
							ml_append (l_tmp___52, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___51), 0, 1).do_nothing
							l_error := l_error + 1
							l_has_error := 1
						end
						l_i___0 := 0
						from
						until
							not (l_i___0.to_integer_32 < l_dp.item.db_line_count)
						loop
							l_txt_start := ((l_dp.item.db_index[l_i___0]).bit_and (((({NATURAL_32} 1).bit_shift_left (({PLATFORM}.Natural_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1).to_integer_32))).bit_not)).to_integer_32
							if l_txt_start <= ((create {PD_DATA_BLOCK}.make).structure_size.to_natural_32 - {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32 then
								l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("???"))
								l_error := l_error + 1
							elseif l_txt_start >= (l_dp.item.db_txt_end).to_integer_32 then
								l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("???"))
								l_error := l_error + 1
							else
								l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (l_dp) + l_txt_start
							end
							l_tmp___53 := l_lnum
							l_lnum := l_lnum + 1
							ml_append (l_tmp___53, l_p___0, 0, 1).do_nothing
							l_i___0 := l_i___0 + 1
						end
						if l_has_error.to_boolean then
							l_tmp___54 := gettext (ce_string ("???END"))
							l_tmp___55 := l_lnum
							l_lnum := l_lnum + 1
							ml_append (l_tmp___55, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___54), 0, 1).do_nothing
						end
				when 42 then -- if done | if done | if done
						if not (l_return or l_break or l_continue) and then (l_buf___6.item.b_ml.ml_stack_top = 0) then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_buf___6.item.b_ml.ml_stack_top := (l_buf___6.item.b_ml.ml_stack_top) - 1
							l_ip := l_buf___6.item.b_ml.ml_stack + l_buf___6.item.b_ml.ml_stack_top
							l_bnum := l_ip.item.ip_bnum
							l_idx := l_ip.item.ip_index + 1
							l_page_count___0 := 1
						end
						if (not l_return and not l_break) then
							(create {P_MISC1_STATIC}).line_breakcheck
						end
						l_pos := -1 + 29 -- back to loop condition
				when 43 then -- loop done
					l_break := False
					l_continue := False
					if l_orig_file_status = 1 then
						l_pos := -1 + 46 -- skip if block
					end
				when 44 then -- if:
						l_pos := -1 + 47 -- goto _L___4
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 46 then -- else:
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count = l_lnum * 2 + 1 then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if: | _L___4:
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count = 2 then
							if ((ml_get ((1).to_integer_32)).item).to_integer_32 /= 0 then
								(create {P_MISC1_STATIC}).changed_int;
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_changedtick := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changedtick) + 1
							end
						else
							(create {P_MISC1_STATIC}).changed_int;
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_changedtick := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changedtick) + 1
						end
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else:
						l_idx := 1
						from
						until
							not (not (l_break) and then (l_idx.to_integer_32 <= l_lnum))
						loop
							l_break := False
							l_p___0 := (create {P_MISC2_STATIC}).vim_strsave ((ml_get (l_idx.to_integer_32)))
							l_i___0 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), create {CE_INTEGER_8_POINTER}.make_cast ((ml_get (l_idx.to_integer_32 + l_lnum))));
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
							if l_i___0 /= 0 then
								(create {P_MISC1_STATIC}).changed_int;
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_changedtick := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changedtick) + 1
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_idx := l_idx + 1
							end
						end
						l_break := False
				when 50 then -- if done
					from
					until
						(l_break)
					loop
						l_break := False
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count > l_lnum then
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_and (1)).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							ml_delete ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count, 0).do_nothing
						end
					end
					l_break := False;
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags).bit_or ((1));
					(create {P_GLOBALS_STATIC}).recoverymode.item := 0
					if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E311: Recovery Interrupted"))))).do_nothing
					elseif l_error.to_boolean then
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item + 1;
						(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">>>>>>>>>>>>>"))).do_nothing;
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E312: Errors detected while recovering; look for lines starting with ???"))))).do_nothing;
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1;
						(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("See %":help E312%" for more information."))))).do_nothing;
						(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">>>>>>>>>>>>>"))).do_nothing
					else
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changed).to_boolean then
							(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Recovery completed. You should check if everything is OK."))))).do_nothing;
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%N(You might want to write out this file under another name%N")))));
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("and run diff with the original file to check for changes)")))))
						else
							(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Recovery completed. Buffer contents equals file contents."))))).do_nothing
						end
						(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%NYou may want to delete the .swp file now.%N%N")))));
						(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item
					end
					if ((l_buf___6.item.b_p_key).item).to_integer_32 /= 0 then
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_key), create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6.item.b_p_key))) /= 0 then
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Using crypt key from swap file for the text file.%N")))));
							(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("key")), 0, l_buf___6.item.b_p_key, 4)
						end
					end
					(create {P_SCREEN_STATIC}).redraw_curbuf_later (40)
				when 51 then -- theend:;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fname_used.item));
					(create {P_GLOBALS_STATIC}).recoverymode.item := 0
					if not l_mfp.is_void then
						if not l_hp.is_void then
							(create {P_MEMFILE_STATIC}).mf_put (l_mfp, l_hp, 0, 0)
						end
						(create {P_MEMFILE_STATIC}).mf_close (l_mfp, 0)
					end
					if not l_buf___6.is_void then
						if not (l_buf___6.item.b_p_key).is_equal ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_key) then
							(create {P_OPTION_STATIC}).free_string_option (l_buf___6.item.b_p_key)
						end
						(create {P_OPTION_STATIC}).free_string_option (l_buf___6.item.b_p_cm);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6.item.b_ml.ml_stack));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
					end
					if l_serious_error.to_boolean then
						if l_called_from_main.to_boolean then
							((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_close (1)
						else
							(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFREADPOST, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname, 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing;
							(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFWINENTER, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname, 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
						end
					else
						(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFREADPOST, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname, 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing;
						(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFWINENTER, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname, 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
					end
				when 52 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	recover_names (a_fname: CE_POINTER [NATURAL_8]; a_list, a_nr: INTEGER_32; a_fname_out: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_num_names: INTEGER_32
			l_names___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tail: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_num_files: CE_ARRAY [INTEGER_32]
			l_file_count: INTEGER_32
			l_files: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_i___0: INTEGER_32
			l_dirp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_dir_name: CE_POINTER [NATURAL_8]
			l_fname_res: CE_POINTER [NATURAL_8]
			l_fname_buf: CE_ARRAY [NATURAL_8]
			l_st: CE_ARRAY [SD_STAT]
			l_swapname: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_names___1.make (<<6>>)
			create {CE_INTEGER_32_ARRAY} l_num_files.make (<<1>>)
			create {CE_POINTER_ARRAY [CE_POINTER [NATURAL_8]]} l_files.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_dirp.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_fname_buf.make (<<4_096>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_file_count := 0
					l_fname_res := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					if not a_fname.is_void then
						if (resolve_symlink (a_fname, l_fname_buf)) = 1 then
							l_fname_res := l_fname_buf
						else
							l_fname_res := a_fname
						end
					end
					if a_list.to_boolean then
						(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Swap files found:"))))).do_nothing;
						(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
					end
					l_dir_name := (create {P_MISC2_STATIC}).alloc ((strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_dir.item.item))) + {NATURAL_32} 1)
					l_dirp.item := (create {P_OPTION_STATIC}).p_dir.item.item
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if not l_dir_name.is_void then
							if not (l_dirp.item.item).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:;
						(create {P_MISC2_STATIC}).copy_option_part (l_dirp, l_dir_name, 31_000, ce_string (",")).do_nothing
						if (l_dir_name[0]).to_integer_32 /= 46 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (l_dir_name[1]).to_integer_32 = 0 then
							if a_fname.is_void then
								l_names___1[0] := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("*.sw?")))
								l_names___1[1] := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".*.sw?")))
								l_names___1[2] := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".sw?")))
								l_num_names := 3
							else
								l_num_names := recov_file_names (l_names___1, l_fname_res, 1)
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if a_fname.is_void then
							l_names___1[0] := (create {P_MISC1_STATIC}).concat_fnames (l_dir_name, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("*.sw?")), 1)
							l_names___1[1] := (create {P_MISC1_STATIC}).concat_fnames (l_dir_name, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".*.sw?")), 1)
							l_names___1[2] := (create {P_MISC1_STATIC}).concat_fnames (l_dir_name, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".sw?")), 1)
							l_num_names := 3
						else
							l_p___0 := l_dir_name + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_dir_name))).to_integer_32
							if ((create {P_MISC2_STATIC}).after_pathsep (l_dir_name, l_p___0)).to_boolean then
								if (l_p___0[-1]).to_integer_32 = (l_p___0[-2]).to_integer_32 then
									l_tail := make_percent_swname (l_dir_name, l_fname_res)
								else
									l_tail := (create {P_MISC1_STATIC}).gettail (l_fname_res)
									l_tail := (create {P_MISC1_STATIC}).concat_fnames (l_dir_name, l_tail, 1)
								end
							else
								l_tail := (create {P_MISC1_STATIC}).gettail (l_fname_res)
								l_tail := (create {P_MISC1_STATIC}).concat_fnames (l_dir_name, l_tail, 1)
							end
							if l_tail.is_void then
								l_num_names := 0
							else
								l_num_names := recov_file_names (l_names___1, l_tail, 0);
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tail))
							end
						end
				when 7 then
						l_i___0 := 0
						from
						until
							not (not (l_return) and then (l_i___0 < l_num_names))
						loop
							if (l_names___1[l_i___0]).is_void then
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_num_names)
								loop
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_names___1[l_i___0]))
									l_i___0 := l_i___0 + 1
								end
								l_num_names := 0
							end
							l_i___0 := l_i___0 + 1
						end
						if l_num_names = 0 then
							l_num_files.item := 0
						elseif ((create {P_MISC1_STATIC}).expand_wildcards (l_num_names, l_names___1, l_num_files, l_files, 50)) = 0 then
							l_num_files.item := 0
						end
						if (l_dirp.item.item).to_integer_32 = 0 then
							if l_file_count + l_num_files.item = 0 then
								if not a_fname.is_void then
									l_swapname := (create {P_FILEIO_STATIC}).modname (l_fname_res, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".swp")), 1)
									if not l_swapname.is_void then
										if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_swapname), l_st)) /= -1 then
											l_files.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (((create {P_MISC2_STATIC}).alloc ({PLATFORM}.Pointer_bytes.to_natural_32)))
											if not (l_files.item).is_void then
												l_files.item[0] := l_swapname
												l_swapname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
												l_num_files.item := 1
											end
										end
										(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_swapname))
									end
								end
							end
						end
						if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_mfp).is_void then
							l_p___0 := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_mfp).item.mf_fname
							if not l_p___0.is_void then
								l_i___0 := 0
								from
								until
									not (not (l_return) and then (l_i___0 < l_num_files.item))
								loop
									if ((((create {P_MISC1_STATIC}).fullpathcmp (l_p___0, l_files.item[l_i___0], 1))).bit_and (1)).to_boolean then
										(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_files.item[l_i___0]))
										l_num_files.item := l_num_files.item - 1
										if l_num_files.item = 0 then
											(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_files.item))
										else
											from
											until
												not (l_i___0 < l_num_files.item)
											loop
												l_files.item[l_i___0] := l_files.item[(l_i___0 + 1)]
												l_i___0 := l_i___0 + 1
											end
										end
									end
									l_i___0 := l_i___0 + 1
								end
							end
						end
						if a_nr > 0 then
							l_file_count := l_file_count + (l_num_files.item)
							if a_nr <= l_file_count then
								a_fname_out.item := (create {P_MISC2_STATIC}).vim_strsave (l_files.item[(((a_nr - 1) + l_num_files.item) - l_file_count)])
								l_dirp.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
							end
						elseif a_list.to_boolean then
							if (l_dir_name[0]).to_integer_32 = 46 then
								if (l_dir_name[1]).to_integer_32 = 0 then
									if a_fname.is_void then
										(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("   In current directory:%N")))))
									else
										(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("   Using specified name:%N")))))
									end
								else
									l_tmp___10 := gettext (ce_string ("   In directory "));
									(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___10));
									(create {P_MESSAGE_STATIC}).msg_home_replace (l_dir_name);
									(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":%N")))
								end
							else
								l_tmp___10 := gettext (ce_string ("   In directory "));
								(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___10));
								(create {P_MESSAGE_STATIC}).msg_home_replace (l_dir_name);
								(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":%N")))
							end
							if (l_num_files.item).to_boolean then
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_num_files.item)
								loop
									l_file_count := l_file_count + 1;
									(create {P_MESSAGE_STATIC}).msg_outnum (l_file_count.to_integer_32);
									(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".    ")));
									(create {P_MESSAGE_STATIC}).msg_puts (((create {P_MISC1_STATIC}).gettail (l_files.item[l_i___0])));
									(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
									swapfile_info (l_files.item[l_i___0]).do_nothing
									l_i___0 := l_i___0 + 1
								end
							else
								(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("      -- none --%N")))))
							end
							(create {P_TERM_STATIC}).out_flush
						else
							l_file_count := l_file_count + (l_num_files.item)
						end
						l_i___0 := 0
						from
						until
							not (l_i___0 < l_num_names)
						loop
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_names___1[l_i___0]))
							l_i___0 := l_i___0 + 1
						end
						if l_num_files.item > 0 then
							(create {P_MISC1_STATIC}).FreeWild (l_num_files.item, l_files.item)
						end
				when 8 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					l_break := False;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_dir_name))
					Result := l_file_count
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	make_percent_swname (a_dir___0, a_name___1: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_d: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_f: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
		do
			if not a_name___1.is_void then
				l_tmp := a_name___1
			else
				l_tmp := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
			end
			l_f := (create {P_BUFFER_STATIC}).fix_fname (l_tmp)
			l_d := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if not l_f.is_void then
				l_s := (create {P_MISC2_STATIC}).alloc ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_f))) + {NATURAL_32} 1)
				if not l_s.is_void then
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_s), create {CE_INTEGER_8_POINTER}.make_cast (l_f)).do_nothing
					l_d := l_s
					from
					until
						(l_d.item).to_integer_32 = 0
					loop
						if ((create {P_MISC1_STATIC}).vim_ispathsep ((l_d.item).to_integer_32)).to_boolean then
							l_d.item := (('%%').code).to_natural_8
						end
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___2 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_d]))
						else
							l_tmp___2 := 1
						end
						l_d := l_d + l_tmp___2
					end
					l_d := (create {P_MISC1_STATIC}).concat_fnames (a_dir___0, l_s, 1);
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_s))
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_f))
			end
			Result := l_d
		end

	swapfile_info (a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_st: CE_ARRAY [SD_STAT]
			l_fd: INTEGER_32
			l_b0: CE_ARRAY [PD_BLOCK0]
			l_x___0: CE_ARRAY [INTEGER_32]
			l_p___0: CE_POINTER [INTEGER_8]
			l_uname___0: CE_ARRAY [NATURAL_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_BLOCK0]} l_b0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_x___0.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_uname___0.make (<<40>>)

			l_x___0.item := (0).to_integer_32
			if (stat (create {CE_INTEGER_8_POINTER}.make_cast (a_fname), l_st)) /= -1 then
				if ((create {P_OS_UNIX_STATIC}).mch_get_uname (l_st.item.st_uid, l_uname___0, 40)) = 1 then
					(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("          owned by: ")))));
					(create {P_MESSAGE_STATIC}).msg_outtrans (l_uname___0).do_nothing;
					(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("   dated: ")))))
				else
					(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("             dated: ")))))
				end
				l_x___0.item := l_st.item.st_mtim.tv_sec
				l_p___0 := ctime (l_x___0)
				if l_p___0.is_void then
					(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("(invalid)%N")))
				else
					(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (l_p___0))
				end
			end
			l_fd := open ([create {CE_INTEGER_8_POINTER}.make_cast (a_fname), 0, 0])
			if l_fd >= 0 then
				if (read (l_fd, create {CE_VOID_POINTER}.make_cast (l_b0), (create {PD_BLOCK0}.make).structure_size.to_natural_32)).to_natural_32 = (create {PD_BLOCK0}.make).structure_size.to_natural_32 then
					if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_b0.item.b0_version)), ce_string ("VIM 3.0"), (7).to_natural_32)) = 0 then
						(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("         [from Vim version 3.0]")))))
					elseif (l_b0.item.ml_check_b0_id) = 0 then
						(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("         [does not look like a Vim swap file]")))))
					else
						(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("         file name: ")))))
						if (l_b0.item.b0_fname[0]).to_integer_32 = 0 then
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("[No Name]")))))
						else
							(create {P_MESSAGE_STATIC}).msg_outtrans (l_b0.item.b0_fname).do_nothing
						end
						(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%N          modified: ")))))
						if (l_b0.item.b0_fname[899]).to_boolean then
							l_tmp___11 := (gettext (ce_string ("YES")))
						else
							l_tmp___11 := (gettext (ce_string ("no")))
						end
						(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___11))
						if (l_b0.item.b0_uname[0]).to_integer_32 /= 0 then
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%N         user name: ")))));
							(create {P_MESSAGE_STATIC}).msg_outtrans (l_b0.item.b0_uname).do_nothing
						end
						if (l_b0.item.b0_hname[0]).to_integer_32 /= 0 then
							if (l_b0.item.b0_uname[0]).to_integer_32 /= 0 then
								(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("   host name: ")))))
							else
								(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%N         host name: ")))))
							end
							(create {P_MESSAGE_STATIC}).msg_outtrans (l_b0.item.b0_hname).do_nothing
						end
						if (char_to_long (l_b0.item.b0_pid)) /= 0 then
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%N        process ID: ")))));
							(create {P_MESSAGE_STATIC}).msg_outnum ((char_to_long (l_b0.item.b0_pid)))
							if (kill ((char_to_long (l_b0.item.b0_pid)).to_integer_32, 0)) = 0 then
								(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string (" (still running)")))))
								process_still_running.item := 1
							end
						end
						if (l_b0.item.b0_magic_wrong).to_boolean then
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%N         [not usable on this computer]")))))
						end
					end
				else
					(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("         [cannot be read]")))))
				end
				close (l_fd).do_nothing
			else
				(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("         [cannot be opened]")))))
			end
			(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
			Result := (l_x___0.item)
		end

	recov_file_names (a_names___1: CE_POINTER [CE_POINTER [NATURAL_8]]; a_path: CE_POINTER [NATURAL_8]; a_prepend_dot: INTEGER_32): INTEGER_32
		require
			not a_names___1.is_void
		local
			l_num_names: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_shortname: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___2: NATURAL_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_shortname := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_shortname;
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_shortname := 0
					l_num_names := 0
					if not (a_prepend_dot.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_names___1[l_num_names] := (create {P_FILEIO_STATIC}).modname (a_path, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".sw?")), 1)
						if (a_names___1[l_num_names]).is_void then
							l_pos := -1 + 6 -- goto end
						end
				when 2 then
						l_num_names := l_num_names + 1
				when 3 then -- if done
					a_names___1[l_num_names] := (create {P_MISC1_STATIC}).concat_fnames (a_path, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".sw?")), 0)
					if (a_names___1[l_num_names]).is_void then
						l_pos := -1 + 6 -- goto end
					end
				when 4 then
					if l_num_names >= 1 then
						l_p___0 := a_names___1[(l_num_names - 1)]
						l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_names___1[(l_num_names - 1)]))
						l_i___0 := l_tmp.to_integer_32 - (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_names___1[l_num_names]))).to_integer_32
						if l_i___0 > 0 then
							l_p___0 := l_p___0 + l_i___0
						end
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), create {CE_INTEGER_8_POINTER}.make_cast (a_names___1[l_num_names]))) /= 0 then
							l_num_names := l_num_names + 1
						else
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_names___1[l_num_names]))
						end
					else
						l_num_names := l_num_names + 1
					end
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_shortname := 1
					a_names___1[l_num_names] := (create {P_FILEIO_STATIC}).modname (a_path, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".sw?")), 0)
					if (a_names___1[l_num_names]).is_void then
						l_pos := -1 + 6 -- goto end
					end
				when 5 then
					l_p___0 := a_names___1[l_num_names]
					l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_names___1[l_num_names]))
					l_i___0 := (l_tmp___2 - (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_names___1[(l_num_names - 1)])))).to_integer_32
					if l_i___0 > 0 then
						l_p___0 := l_p___0 + l_i___0
					end
					if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_names___1[(l_num_names - 1)]), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))) = 0 then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_names___1[l_num_names]))
					else
						l_num_names := l_num_names + 1
					end
				when 6 then -- end:;
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_shortname := l_shortname
					Result := l_num_names
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ml_sync_all (a_check_file, a_check_char: INTEGER_32)
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_st: CE_ARRAY [SD_STAT]
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			l_break, l_continue: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)

			l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
			from
			until
				not (not (l_break) and then (not l_buf___6.is_void))
			loop
				l_break := False
				l_continue := False
				if (l_buf___6.item.b_ml.ml_mfp).is_void then
					l_continue := True
				elseif ((l_buf___6.item.b_ml.ml_mfp).item.mf_fname).is_void then
					l_continue := True
				end
				if not (l_break or l_continue) then
					l_buf___6.item.ml_flush_line
					l_buf___6.item.ml_find_line ((0).to_integer_32, 2).do_nothing
					if (l_buf___6.item.bufIsChanged).to_boolean then
						if a_check_file.to_boolean then
							if ((l_buf___6.item.b_ml.ml_mfp).item.mf_need_trans).to_boolean then
								if not (l_buf___6.item.b_ffname).is_void then
									if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6.item.b_ffname), l_st)) = -1 then
										l_buf___6.item.ml_preserve (0);
										(create {P_GLOBALS_STATIC}).did_check_timestamps.item := 0;
										(create {P_GLOBALS_STATIC}).need_check_timestamps.item := 1
									elseif l_st.item.st_mtim.tv_sec /= l_buf___6.item.b_mtime_read then
										l_buf___6.item.ml_preserve (0);
										(create {P_GLOBALS_STATIC}).did_check_timestamps.item := 0;
										(create {P_GLOBALS_STATIC}).need_check_timestamps.item := 1
									elseif l_st.item.st_size /= l_buf___6.item.b_orig_size then
										l_buf___6.item.ml_preserve (0);
										(create {P_GLOBALS_STATIC}).did_check_timestamps.item := 0;
										(create {P_GLOBALS_STATIC}).need_check_timestamps.item := 1
									end
								end
							end
						end
					end
					if ((l_buf___6.item.b_ml.ml_mfp).item.mf_dirty).to_boolean then
						if a_check_char.to_boolean then
							l_tmp___2 := 2
						else
							l_tmp___2 := 0
						end
						if (l_buf___6.item.bufIsChanged).to_boolean then
							l_tmp___4 := 4
						else
							l_tmp___4 := 0
						end
						(l_buf___6.item.b_ml.ml_mfp).item.mf_sync ((l_tmp___2).bit_or (l_tmp___4)).do_nothing
						if a_check_char.to_boolean then
							if ((create {P_UI_STATIC}).ui_char_avail).to_boolean then
								l_break := True
							end
						end
					end
				end
				if (not l_break) then
					l_buf___6 := l_buf___6.item.b_next
				end
			end
			l_break := False
			l_continue := False
		end

	ml_get (a_lnum: INTEGER_32): CE_POINTER [NATURAL_8]
		do
			Result := (((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_get_buf (a_lnum, 0))
		end

	ml_get_curline: CE_POINTER [NATURAL_8]
		do
			Result := (((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_get_buf ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 0))
		end

	ml_get_cursor: CE_POINTER [NATURAL_8]
		do
			Result := ((((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_get_buf ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 0)) + (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col)
		end

	ml_line_alloced: INTEGER_32
		do
			Result := (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_and (2))
		end

	ml_append (a_lnum: INTEGER_32; a_line: CE_POINTER [NATURAL_8]; a_len, a_newfile: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_mfp).is_void then
				if ((create {P_BUFFER_STATIC}).open_buffer (0, create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), 0)) = 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_lnum /= 0 then
					((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_flush_line
				end
				Result := (((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_append_int (a_lnum, a_line, a_len, a_newfile, 0))
			end
		end

	ml_replace (a_lnum: INTEGER_32; a_line: CE_POINTER [NATURAL_8]; a_copy: INTEGER_32): INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_line := a_line
			if l_line.is_void then
				Result := 0
				l_return := True
			end
			if not l_return and then (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_mfp).is_void) then
				if ((create {P_BUFFER_STATIC}).open_buffer (0, create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), 0)) = 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return and then (a_copy.to_boolean) then
				l_line := (create {P_MISC2_STATIC}).vim_strsave (l_line)
				if l_line.is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if ((create {P_NETBEANS_STATIC}).netbeans_active).to_boolean then
					(create {P_NETBEANS_STATIC}).netbeans_removed ((create {P_GLOBALS_STATIC}).curbuf.item, a_lnum, 0, (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((ml_get (a_lnum))))).to_integer_32);
					(create {P_NETBEANS_STATIC}).netbeans_inserted ((create {P_GLOBALS_STATIC}).curbuf.item, a_lnum, 0, l_line, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))).to_integer_32)
				end
				if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_lnum /= a_lnum then
					((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_flush_line
				elseif (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_and (2)).to_boolean then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_ptr))
				end
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_ptr := l_line;
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_lnum := a_lnum;
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags := ((((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_or (2))).bit_and (-2)
				Result := 1
			end
		end

	ml_delete (a_lnum: INTEGER_32; a_message: INTEGER_32): INTEGER_32
		do
			((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_flush_line
			Result := (((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_delete_int (a_lnum, a_message))
		end

	ml_setmarked (a_lnum: INTEGER_32)
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_dp: CE_POINTER [PD_DATA_BLOCK]
			l_return: BOOLEAN
		do
			if a_lnum < 1 then
				l_return := True
			elseif a_lnum > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
				l_return := True
			elseif ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_mfp).is_void then
				l_return := True
			end
			if not l_return then
				if lowest_marked.item = 0 then
					lowest_marked.item := a_lnum
				elseif lowest_marked.item > a_lnum then
					lowest_marked.item := a_lnum
				end
				l_hp := ((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_find_line (a_lnum, 19)
				if l_hp.is_void then
					l_return := True
				end
			end
			if not l_return then
				l_dp := create {CE_CLASS_POINTER [PD_DATA_BLOCK]}.make_cast (l_hp.item.bh_data)
				l_dp.item.db_index[a_lnum - (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_locked_low] := (l_dp.item.db_index[a_lnum - (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_locked_low]).bit_or ((({NATURAL_32} 1).bit_shift_left (({PLATFORM}.Natural_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1).to_integer_32)));
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_or ((4))
			end
		end

	ml_firstmarked: INTEGER_32
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_dp: CE_POINTER [PD_DATA_BLOCK]
			l_lnum: INTEGER_32
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_mfp).is_void then
				Result := (0).to_integer_32
				l_return := True
			end
			if not l_return then
				l_lnum := lowest_marked.item
				from
				until
					not (not (l_return) and then (l_lnum <= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count))
				loop
					l_hp := ((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_find_line (l_lnum, 19)
					if l_hp.is_void then
						Result := (0).to_integer_32
						l_return := True
					end
					if not l_return then
						l_dp := create {CE_CLASS_POINTER [PD_DATA_BLOCK]}.make_cast (l_hp.item.bh_data)
						l_i___0 := (l_lnum - (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_locked_low).to_integer_32
						from
						until
							not (not (l_return) and then (l_lnum <= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_locked_high))
						loop
							if ((l_dp.item.db_index[l_i___0]).bit_and ((({NATURAL_32} 1).bit_shift_left (({PLATFORM}.Natural_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1).to_integer_32)))).to_boolean then
								l_dp.item.db_index[l_i___0] := (l_dp.item.db_index[l_i___0]).bit_and ((((({NATURAL_32} 1).bit_shift_left (({PLATFORM}.Natural_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1).to_integer_32))).bit_not));
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_or ((4))
								lowest_marked.item := l_lnum + 1
								Result := l_lnum
								l_return := True
							end
							if not l_return then
								l_i___0 := l_i___0 + 1
								l_lnum := l_lnum + 1
							end
						end
					end
				end
			end
			if not l_return then
				Result := (0).to_integer_32
			end
		end

	ml_clearmarked
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_dp: CE_POINTER [PD_DATA_BLOCK]
			l_lnum: INTEGER_32
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_mfp).is_void then
				l_return := True
			end
			if not l_return then
				l_lnum := lowest_marked.item
				from
				until
					not (not (l_return) and then (l_lnum <= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count))
				loop
					l_hp := ((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_find_line (l_lnum, 19)
					if l_hp.is_void then
						l_return := True
					end
					if not l_return then
						l_dp := create {CE_CLASS_POINTER [PD_DATA_BLOCK]}.make_cast (l_hp.item.bh_data)
						l_i___0 := (l_lnum - (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_locked_low).to_integer_32
						from
						until
							not (l_lnum <= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_locked_high)
						loop
							if ((l_dp.item.db_index[l_i___0]).bit_and ((({NATURAL_32} 1).bit_shift_left (({PLATFORM}.Natural_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1).to_integer_32)))).to_boolean then
								l_dp.item.db_index[l_i___0] := (l_dp.item.db_index[l_i___0]).bit_and ((((({NATURAL_32} 1).bit_shift_left (({PLATFORM}.Natural_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1).to_integer_32))).bit_not));
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_or ((4))
							end
							l_i___0 := l_i___0 + 1
							l_lnum := l_lnum + 1
						end
					end
				end
			end
			if not l_return then
				lowest_marked.item := (0).to_integer_32
			end
		end

	resolve_symlink (a_fname, a_buf___6: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp: CE_ARRAY [NATURAL_8]
			l_ret: INTEGER_32
			l_depth___1: INTEGER_32
			l_tail: CE_POINTER [NATURAL_8]
			l_tmp___3: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_tmp.make (<<4_096>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_depth___1 := 0
					if a_fname.is_void then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:;
						(create {P_MISC2_STATIC}).vim_strncpy (l_tmp, a_fname, (4_095).to_natural_32)
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 13 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_depth___1 := l_depth___1 + 1
						if l_depth___1 = 100 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E773: Symlink loop for %"%%s%"")))), a_fname).do_nothing
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						l_ret := readlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp), create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), (4_095).to_natural_32)
						if not (l_ret <= 0) then
							l_pos := -1 + 11 -- skip if block
						end
				when 5 then -- if:
						if (errno_location).item /= 22 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if (errno_location).item /= 2 then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if l_depth___1 = 1 then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_break := True
						end
				when 10 then -- if done
						if not (l_return or l_break) then
							Result := 0
							l_return := True
						end
				when 11 then -- if done
						if not (l_return or l_break) then
							a_buf___6[l_ret] := (('%/0/').code).to_natural_8
							if ((create {P_OS_UNIX_STATIC}).mch_isFullName (a_buf___6)).to_boolean then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp), create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6)).do_nothing
							else
								l_tail := (create {P_MISC1_STATIC}).gettail (l_tmp)
								l_tmp___3 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tail))
								if l_tmp___3 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6))) >= {NATURAL_32} 4_096 then
									Result := 0
									l_return := True
								end
								if not l_return then
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_tail), create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6)).do_nothing
								end
							end
						end
				when 12 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 13 then -- loop done | if done
					if not l_return then
						l_break := False
						Result := ((create {P_WINDOW_STATIC}).vim_FullName (l_tmp, a_buf___6, 4_096, 1))
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	makeswapname (a_fname, a_ffname: CE_POINTER [NATURAL_8]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_dir_name: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_r: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_fname_res: CE_POINTER [NATURAL_8]
			l_fname_buf: CE_ARRAY [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_fname_buf.make (<<4_096>>)

			l_fname_res := a_fname
			l_s := a_dir_name + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_dir_name))).to_integer_32
			if ((create {P_MISC2_STATIC}).after_pathsep (a_dir_name, l_s)).to_boolean then
				if (l_s[-1]).to_integer_32 = (l_s[-2]).to_integer_32 then
					l_r := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_s := make_percent_swname (a_dir_name, a_fname)
					if not l_s.is_void then
						l_r := (create {P_FILEIO_STATIC}).modname (l_s, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".swp")), 0);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_s))
					end
					Result := l_r
					l_return := True
				end
			end
			if not l_return then
				if (resolve_symlink (a_fname, l_fname_buf)) = 1 then
					l_fname_res := l_fname_buf
				end
				if (a_dir_name[0]).to_integer_32 = 46 then
					if (a_dir_name[1]).to_integer_32 = 0 then
						l_tmp___2 := 1
					else
						l_tmp___2 := 0
					end
				else
					l_tmp___2 := 0
				end
				if (a_buf___6.item.b_p_sn).to_boolean then
					l_tmp___3 := 1
				elseif (a_buf___6.item.b_shortname).to_boolean then
					l_tmp___3 := 1
				else
					l_tmp___3 := 0
				end
				l_r := (create {P_FILEIO_STATIC}).buf_modname (l_tmp___3, l_fname_res, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".swp")), l_tmp___2)
				if l_r.is_void then
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_s := get_file_in_dir (l_r, a_dir_name);
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_r))
				Result := l_s
			end
		end

	get_file_in_dir (a_fname, a_dname: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_dname.is_void
		local
			l_t: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_retval: CE_POINTER [NATURAL_8]
			l_save_char: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tail := (create {P_MISC1_STATIC}).gettail (a_fname)
					if (a_dname[0]).to_integer_32 /= 46 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_dname[1]).to_integer_32 = 0 then
							l_retval := (create {P_MISC2_STATIC}).vim_strsave (a_fname)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (a_dname[0]).to_integer_32 = 46 then
							if ((create {P_MISC1_STATIC}).vim_ispathsep ((a_dname[1]).to_integer_32)).to_boolean then
								if l_tail.is_equal (a_fname) then
									l_retval := (create {P_MISC1_STATIC}).concat_fnames (a_dname + 2, l_tail, 1)
								else
									l_save_char := (l_tail.item).to_integer_32
									l_tail.item := (('%/0/').code).to_natural_8
									l_t := (create {P_MISC1_STATIC}).concat_fnames (a_fname, a_dname + 2, 1)
									l_tail.item := l_save_char.to_natural_8
									if l_t.is_void then
										l_retval := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
									else
										l_retval := (create {P_MISC1_STATIC}).concat_fnames (l_t, l_tail, 1);
										(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_t))
									end
								end
							else
								l_retval := (create {P_MISC1_STATIC}).concat_fnames (a_dname, l_tail, 1)
							end
						else
							l_retval := (create {P_MISC1_STATIC}).concat_fnames (a_dname, l_tail, 1)
						end
				when 4 then
					Result := l_retval
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	char_to_long (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_s.is_void
		local
			l_retval: INTEGER_32
		do
			l_retval := (a_s[3]).to_integer_32
			l_retval := (l_retval).bit_shift_left ((8))
			l_retval := (l_retval).bit_or ((a_s[2]).to_integer_32)
			l_retval := (l_retval).bit_shift_left ((8))
			l_retval := (l_retval).bit_or ((a_s[1]).to_integer_32)
			l_retval := (l_retval).bit_shift_left ((8))
			l_retval := (l_retval).bit_or ((a_s[0]).to_integer_32)
			Result := l_retval
		end

	goto_byte (a_cnt: INTEGER_32)
		local
			l_boff: CE_ARRAY [INTEGER_32]
			l_lnum: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_boff.make (<<1>>)

			l_boff.item := a_cnt;
			((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_flush_line;
			(create {P_MARK_STATIC}).setpcmark
			if (l_boff.item).to_boolean then
				l_boff.item := l_boff.item - 1
			end
			l_lnum := ((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_find_line_or_offset ((0).to_integer_32, l_boff)
			if l_lnum < 1 then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant := (2_147_483_647).to_integer_32;
				(create {P_MISC2_STATIC}).coladvance ((2_147_483_647).to_integer_32).do_nothing
			else
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_lnum;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (l_boff.item).to_integer_32;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
			end
			(create {P_MISC2_STATIC}).check_cursor
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				(create {P_MBYTE_STATIC}).mb_adjust_cursor
			end
		end

end
