class
	P_TAG_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_LIBINTL_STATIC
	S_CTYPE_STATIC
	S_STDLIB_STATIC
	S_STDIO_STATIC
	S_UNISTD_STATIC
	S_SYS_STAT_STATIC

feature {ANY} -- public attributes

	mt_names: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("FSC"),
					ce_string ("F C"),
					ce_string ("F  "),
					ce_string ("FS "),
					ce_string (" SC"),
					ce_string ("  C"),
					ce_string ("   "),
					ce_string (" S ")
				>>)
		end

	nofile_fname: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	bottommsg: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E555: at bottom of tag stack"))
		end

	topmsg: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E556: at top of tag stack"))
		end

	tagmatchname: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	ptag_entry: CE_STATIC [PD_TAGGY]
		once ("PROCESS")
			Result.item := create {PD_TAGGY}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {PD_FILEMARK}.make_initialized ([create {PD_POS_T}.make_initialized ([(0).to_integer_32, 0, 0]), 0]), 0, 0])
		end

	num_matches: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	max_num_matches: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	matches: CE_STATIC [CE_POINTER [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
		end

	flags: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	tag_fnames: CE_STATIC [CE_ARRAY [PD_GROWARRAY]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GROWARRAY]}.make_initialized (<<
					create {PD_GROWARRAY}.make_initialized ([0, 0, 0, 0, create {CE_VOID_POINTER}.make_shared (default_pointer)])
				>>)
		end

feature {ANY} -- public routines

	do_tag (a_tag: CE_POINTER [NATURAL_8]; a_type, a_count___2, a_forceit, a_verbose: INTEGER_32): INTEGER_32
		require
			not a_tag.is_void
		local
			l_type: INTEGER_32
			l_tagstack: CE_POINTER [PD_TAGGY]
			l_tagstackidx: INTEGER_32
			l_tagstacklen: INTEGER_32
			l_cur_match: INTEGER_32
			l_cur_fnum: INTEGER_32
			l_oldtagstackidx: INTEGER_32
			l_prevtagstackidx: INTEGER_32
			l_prev_num_matches: INTEGER_32
			l_new_tag: INTEGER_32
			l_other_name: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_idx: INTEGER_32
			l_ic: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_name___1: CE_POINTER [NATURAL_8]
			l_no_regexp: INTEGER_32
			l_error_cur_match: INTEGER_32
			l_command_end: CE_POINTER [NATURAL_8]
			l_save_pos: INTEGER_32
			l_saved_fmark: PD_FILEMARK
			l_taglen: INTEGER_32
			l_tagp: CE_ARRAY [PD_TAG_POINTERS]
			l_tagp2: CE_ARRAY [PD_TAG_POINTERS]
			l_new_num_matches: CE_ARRAY [INTEGER_32]
			l_new_matches: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_attr: INTEGER_32
			l_use_tagstack: INTEGER_32
			l_skip_msg: INTEGER_32
			l_buf_ffname: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_old_KeyTyped: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp___11: INTEGER_32
			l_tmp___13: INTEGER_32
			l_ask_for_selection: INTEGER_32
			l_tmp___24: INTEGER_32
			l_list: CE_POINTER [PD_LISTVAR_S]
			l_tag_name: CE_ARRAY [NATURAL_8]
			l_fname: CE_ARRAY [NATURAL_8]
			l_cmd: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_cmd_len: INTEGER_32
			l_lnum: INTEGER_32
			l_dict: CE_POINTER [PD_DICTVAR_S]
			l_cmd_start: CE_POINTER [NATURAL_8]
			l_cmd_end: CE_POINTER [NATURAL_8]
			l_tmp___31: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_command_end.make
			create l_saved_fmark.make
			create {CE_CLASS_ARRAY [PD_TAG_POINTERS]} l_tagp.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_TAG_POINTERS]} l_tagp2.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_new_num_matches.make (<<1>>)
			create {CE_POINTER_ARRAY [CE_POINTER [NATURAL_8]]} l_new_matches.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_tag_name.make (<<129>>)
			create {CE_NATURAL_8_ARRAY} l_fname.make (<<4_097>>)
			create {CE_NATURAL_8_ARRAY} l_cmd.make (<<1_025>>)
			create {CE_CLASS_POINTER [PD_DICTVAR_S]} l_dict.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_type := a_type
					l_tagstack := (create {P_GLOBALS_STATIC}).curwin.item.item.w_tagstack
					l_tagstackidx := (create {P_GLOBALS_STATIC}).curwin.item.item.w_tagstackidx
					l_tagstacklen := (create {P_GLOBALS_STATIC}).curwin.item.item.w_tagstacklen
					l_cur_match := 0
					l_cur_fnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum
					l_oldtagstackidx := l_tagstackidx
					l_prevtagstackidx := l_tagstackidx
					l_new_tag := 0
					l_no_regexp := 0
					l_error_cur_match := 0
					l_save_pos := 0
					l_skip_msg := 0
					l_buf_ffname := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname
					if l_type = 8 then
						l_type := 1
						l_no_regexp := 1
					end
					l_prev_num_matches := num_matches.item;
					(create {P_OPTION_STATIC}).free_string_option (nofile_fname.item)
					nofile_fname.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_saved_fmark.mark.lnum := (0).to_integer_32
					l_saved_fmark.mark.col := 0
					l_saved_fmark.mark.coladd := 0
					l_saved_fmark.fnum := 0
					if ((create {P_OPTION_STATIC}).p_tgst.item.item).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_tag.item).to_integer_32 /= 0 then
							l_use_tagstack := 0
							l_new_tag := 1
						else
							l_pos := -1 + 3 -- goto _L___3
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 3 then -- else: | _L___3:
						if ((create {P_GLOBALS_STATIC}).g_do_tagpreview.item).to_boolean then
							l_use_tagstack := 0
						else
							l_use_tagstack := 1
						end
						if (a_tag.item).to_integer_32 = 0 then
							l_pos := -1 + 26 -- skip if block
						end
				when 4 then -- if:
						if l_type /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 14 -- goto _L___2
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 7 then -- else:
						if l_type /= 7 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 14 -- goto _L___2
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 10 then -- else:
						if l_type /= 9 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L___2
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 13 then -- else:
						if l_type /= 11 then
							l_pos := -1 + 24 -- skip if block
						end
				when 14 then -- if: | _L___2:
						if not (((create {P_GLOBALS_STATIC}).g_do_tagpreview.item).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 15 then -- if:
						if (ptag_entry.item.tagname).is_void then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (ptag_entry.item.tagname), create {CE_INTEGER_8_POINTER}.make_cast (a_tag))) = 0 then
							l_cur_match := ptag_entry.item.cur_match
							l_cur_fnum := ptag_entry.item.cur_fnum
						else
							l_pos := -1 + 18 -- goto _L
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (ptag_entry.item.tagname))
						ptag_entry.item.tagname := (create {P_MISC2_STATIC}).vim_strsave (a_tag)
						if (ptag_entry.item.tagname).is_void then
							l_pos := -1 + 155 -- goto end_do_tag
						end
				when 19 then -- if done | if block done, skip else block:
						l_pos := -1 + 22
				when 20 then -- else:
						from
						until
							not (l_tagstackidx < l_tagstacklen)
						loop
							l_tagstacklen := l_tagstacklen - 1;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((l_tagstack + l_tagstacklen).item.tagname))
						end
						l_tagstacklen := l_tagstacklen + 1
						if l_tagstacklen > 20 then
							l_tagstacklen := 20;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((l_tagstack + 0).item.tagname))
							l_i___0 := 1
							from
							until
								not (l_i___0 < l_tagstacklen)
							loop
								l_tagstack[(l_i___0 - 1)] := (l_tagstack[l_i___0]).twin
								l_i___0 := l_i___0 + 1
							end
							l_tagstackidx := l_tagstackidx - 1
						end
						l_tmp___0 := (create {P_MISC2_STATIC}).vim_strsave (a_tag);
						(l_tagstack + l_tagstackidx).item.tagname := l_tmp___0
						if l_tmp___0.is_void then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_tagstacklen := l_tagstacklen - 1
							l_pos := -1 + 155 -- goto end_do_tag
						end
				when 21 then;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_tagstacklen := l_tagstacklen
						l_save_pos := 1
				when 22 then
						l_new_tag := 1
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						l_pos := -1 + 26 -- goto _L___1
				when 25 then -- if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 56
				when 26 then -- else: | _L___1:
						if ((create {P_GLOBALS_STATIC}).g_do_tagpreview.item).to_boolean then
							l_tmp___2 := ((ptag_entry.item.tagname).is_void).to_integer
						else
							l_tmp___2 := (l_tagstacklen = 0).to_integer
						end
						if l_tmp___2.to_boolean then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_tagstack.item)))))).do_nothing
							l_pos := -1 + 155 -- goto end_do_tag
						end
				when 27 then
						if l_type /= 2 then
							l_pos := -1 + 39 -- skip if block
						end
				when 28 then -- if:
						l_old_KeyTyped := (create {P_GLOBALS_STATIC}).KeyTyped.item
						l_tagstackidx := l_tagstackidx - a_count___2
						if not (l_tagstackidx < 0) then
							l_pos := -1 + 32 -- skip if block
						end
				when 29 then -- if:;
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (bottommsg.item))))).do_nothing
						if l_tagstackidx + a_count___2 = 0 then
							l_tagstackidx := 0
							l_pos := -1 + 155 -- goto end_do_tag
						end
				when 30 then
						l_tagstackidx := 0
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:
						if l_tagstackidx >= l_tagstacklen then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (topmsg.item))))).do_nothing
							l_pos := -1 + 155 -- goto end_do_tag
						end
				when 33 then
						l_saved_fmark := ((l_tagstack + l_tagstackidx).item.fmark).twin
						if l_saved_fmark.fnum = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum then
							l_pos := -1 + 37 -- skip if block
						end
				when 34 then -- if:
						if ((create {P_BUFFER_STATIC}).buflist_getfile (l_saved_fmark.fnum, l_saved_fmark.mark.lnum, 1, a_forceit)) = 0 then
							l_tagstackidx := l_oldtagstackidx
							l_pos := -1 + 155 -- goto end_do_tag
						end
				when 35 then;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_saved_fmark.mark.lnum
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else:;
						(create {P_MARK_STATIC}).setpcmark;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_saved_fmark.mark.lnum
				when 38 then -- if done;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_saved_fmark.mark.col;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1;
						(create {P_MISC2_STATIC}).check_cursor
						if (((create {P_OPTION_STATIC}).fdo_flags.item.item).bit_and ({NATURAL_32} 128)).to_boolean then
							if l_old_KeyTyped.to_boolean then
								(create {P_FOLD_STATIC}).foldOpenCursor
							end
						end
						(create {P_MISC1_STATIC}).FreeWild (num_matches.item, matches.item)
						num_matches.item := 0
						tag_freematch
						l_pos := -1 + 155 -- goto end_do_tag
				when 39 then
						if l_type /= 1 then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						l_pos := -1 + 43 -- goto _L___0
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 56
				when 42 then -- else:
						if l_type /= 11 then
							l_pos := -1 + 50 -- skip if block
						end
				when 43 then -- if: | _L___0:
						if not (((create {P_GLOBALS_STATIC}).g_do_tagpreview.item).to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						l_cur_match := ptag_entry.item.cur_match
						l_cur_fnum := ptag_entry.item.cur_fnum
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 46 then -- else:
						l_save_pos := 1
						l_tagstackidx := l_tagstackidx + (a_count___2 - 1)
						if l_tagstackidx >= l_tagstacklen then
							l_tagstackidx := l_tagstacklen - 1;
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (topmsg.item))))).do_nothing
							l_save_pos := 0
						elseif l_tagstackidx < 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (bottommsg.item))))).do_nothing
							l_tagstackidx := 0
							l_pos := -1 + 155 -- goto end_do_tag
						end
				when 47 then
						l_cur_match := (l_tagstack + l_tagstackidx).item.cur_match
						l_cur_fnum := (l_tagstack + l_tagstackidx).item.cur_fnum
				when 48 then -- if done
						l_new_tag := 1
				when 49 then -- if block done, skip else block:
						l_pos := -1 + 56
				when 50 then -- else:
						l_prevtagstackidx := l_tagstackidx
						if ((create {P_GLOBALS_STATIC}).g_do_tagpreview.item).to_boolean then
							l_cur_match := ptag_entry.item.cur_match
							l_cur_fnum := ptag_entry.item.cur_fnum
						else
							l_tagstackidx := l_tagstackidx - 1
							if l_tagstackidx < 0 then
								l_tagstackidx := 0
							end
							l_cur_match := (l_tagstack + l_tagstackidx).item.cur_match
							l_cur_fnum := (l_tagstack + l_tagstackidx).item.cur_fnum
						end
						inspect l_type -- switch 1 head
						when 5 then l_pos := -1 + 51
						when 7 then l_pos := -1 + 52
						when 9 then l_pos := -1 + 52
						when 6 then l_pos := -1 + 52
						when 3 then l_pos := -1 + 53
						when 4 then l_pos := -1 + 54
						else l_pos := -1 + 55
						end
				when 51 then -- switch 1, case 5
						l_cur_match := a_count___2 - 1
						l_pos := -1 + 55 -- switch 1; break
				when 52 then -- switch 1, case 7 | switch 1, case 9 | switch 1, case 6
						l_cur_match := 2_147_483_646
						l_pos := -1 + 55 -- switch 1; break
				when 53 then -- switch 1, case 3
						l_cur_match := l_cur_match + a_count___2
						l_pos := -1 + 55 -- switch 1; break
				when 54 then -- switch 1, case 4
						l_cur_match := l_cur_match - a_count___2
						l_pos := -1 + 55 -- switch 1; break
				when 55 then -- switch 1, done:
						if l_cur_match.to_integer_32 >= 2_147_483_647 then
							l_cur_match := 2_147_483_646
						elseif l_cur_match < 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E425: Cannot go before first matching tag"))))).do_nothing
							l_skip_msg := 1
							l_cur_match := 0
							l_cur_fnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum
						end
				when 56 then -- if done | if done
						if ((create {P_GLOBALS_STATIC}).g_do_tagpreview.item).to_boolean then
							if l_type /= 7 then
								if l_type /= 9 then
									ptag_entry.item.cur_match := l_cur_match
									ptag_entry.item.cur_fnum := l_cur_fnum
								end
							end
						else
							l_saved_fmark := ((l_tagstack + l_tagstackidx).item.fmark).twin
							if l_save_pos.to_boolean then
								(l_tagstack + l_tagstackidx).item.fmark.mark := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
								(l_tagstack + l_tagstackidx).item.fmark.fnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum
							end
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_tagstackidx := l_tagstackidx
							if l_type /= 7 then
								if l_type /= 9 then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_tagstack[l_tagstackidx].cur_match := l_cur_match;
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_tagstack[l_tagstackidx].cur_fnum := l_cur_fnum
								end
							end
						end
				when 57 then
					if l_cur_fnum /= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum then
						l_buf___6 := ((create {P_BUFFER_STATIC}).buflist_findnr (l_cur_fnum))
						if not l_buf___6.is_void then
							l_buf_ffname := l_buf___6.item.b_ffname
						end
					end
				when 58 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 154 -- skip loop
					end
				when 59 then -- loop body:
						l_break := False
						l_continue := False
						if l_use_tagstack.to_boolean then
							l_name___1 := (l_tagstack + l_tagstackidx).item.tagname
						elseif ((create {P_GLOBALS_STATIC}).g_do_tagpreview.item).to_boolean then
							l_name___1 := ptag_entry.item.tagname
						else
							l_name___1 := a_tag
						end
						if tagmatchname.item.is_void then
							l_tmp___11 := 1
						elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (tagmatchname.item), create {CE_INTEGER_8_POINTER}.make_cast (l_name___1))) /= 0 then
							l_tmp___11 := 1
						else
							l_tmp___11 := 0
						end
						l_other_name := l_tmp___11
						if not (l_new_tag.to_boolean) then
							l_pos := -1 + 62 -- skip if block
						end
				when 60 then -- if:
						l_pos := -1 + 66 -- goto _L___4
				when 61 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 62 then -- else:
						if not (l_cur_match >= num_matches.item) then
							l_pos := -1 + 65 -- skip if block
						end
				when 63 then -- if:
						if max_num_matches.item.to_integer_32 /= 2_147_483_647 then
							l_pos := -1 + 66 -- goto _L___4
						else
							l_pos := -1 + 65 -- goto _L___5
						end
				when 64 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 65 then -- else: | _L___5:
						if not (l_other_name.to_boolean) then
							l_pos := -1 + 67 -- skip if block
						end
				when 66 then -- if: | _L___4:
						if l_other_name.to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (tagmatchname.item))
							tagmatchname.item := (create {P_MISC2_STATIC}).vim_strsave (l_name___1)
						end
						if l_type = 1 then
							if (a_tag.item).to_integer_32 /= 0 then
								if a_count___2 > 0 then
									l_cur_match := a_count___2 - 1
								end
							end
						end
						if l_type = 7 then
							l_cur_match := 2_147_483_646
						elseif l_type = 9 then
							l_cur_match := 2_147_483_646
						elseif l_type = 11 then
							l_cur_match := 2_147_483_646
						end
						max_num_matches.item := l_cur_match + 1
						if not l_no_regexp.to_boolean then
							if (l_name___1.item).to_integer_32 = 47 then
								flags.item := 4
								l_name___1 := l_name___1 + 1
							else
								flags.item := 8
							end
						else
							flags.item := 8
						end
						if a_verbose.to_boolean then
							flags.item := (flags.item).bit_or ((32))
						end
						if (find_tags (l_name___1, l_new_num_matches, l_new_matches, flags.item, max_num_matches.item, l_buf_ffname)) = 1 then
							if l_new_num_matches.item < max_num_matches.item then
								max_num_matches.item := 2_147_483_647
							end
						end
						if not l_new_tag.to_boolean then
							if not l_other_name.to_boolean then
								l_idx := 0
								l_j := 0
								from
								until
									not (not (l_return) and then (l_j < num_matches.item))
								loop
									l_tagp.item.parse_match (matches.item[l_j]).do_nothing
									l_i___0 := l_idx
									from
									until
										not (not (l_return or l_break) and then (l_i___0 < l_new_num_matches.item))
									loop
										l_break := False
										l_tagp2.item.parse_match (l_new_matches.item[l_i___0]).do_nothing
										if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_tagp.item.tagname), create {CE_INTEGER_8_POINTER}.make_cast (l_tagp2.item.tagname))) = 0 then
											l_p___0 := l_new_matches.item[l_i___0]
											l_k := l_i___0
											from
											until
												not (l_k > l_idx)
											loop
												l_new_matches.item[l_k] := l_new_matches.item[(l_k - 1)]
												l_k := l_k - 1
											end
											l_tmp___13 := l_idx
											l_idx := l_idx + 1
											l_new_matches.item[l_tmp___13] := l_p___0
											l_break := True
										end
										if not (l_return or l_break) then
											l_i___0 := l_i___0 + 1
										end
									end
									l_break := False
									l_j := l_j + 1
								end
							end
						end
						(create {P_MISC1_STATIC}).FreeWild (num_matches.item, matches.item)
						num_matches.item := l_new_num_matches.item
						matches.item := l_new_matches.item
				when 67 then -- if done | if done
						if not (num_matches.item <= 0) then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						if a_verbose.to_boolean then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E426: tag not found: %%s")))), l_name___1).do_nothing
						end
						(create {P_GLOBALS_STATIC}).g_do_tagpreview.item := 0
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 153
				when 70 then -- else:
						l_ask_for_selection := 0
						if l_type /= 7 then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if:
						l_pos := -1 + 75 -- goto _L___8
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 101
				when 73 then -- else:
						if l_type /= 9 then
							l_pos := -1 + 98 -- skip if block
						end
				when 74 then -- if:
						if not (num_matches.item > 1) then
							l_pos := -1 + 96 -- skip if block
						end
				when 75 then -- if: | _L___8:
						l_tagp.item.parse_match (matches.item[0]).do_nothing
						l_taglen := ((l_tagp.item.tagname_end).distance ((l_tagp.item.tagname))) + 2
						if l_taglen < 18 then
							l_taglen := 18
						end
						if l_taglen.to_integer_32 > (create {P_GLOBALS_STATIC}).Columns.item.item - 25 then
							l_taglen := 2_147_483_647
						end
						if (create {P_GLOBALS_STATIC}).msg_col.item = 0 then
							(create {P_GLOBALS_STATIC}).msg_didout.item := 0
						end
						(create {P_MESSAGE_STATIC}).msg_start;
						(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("  # pri kind tag")))), (create {P_GLOBALS_STATIC}).highlight_attr.item[14]);
						(create {P_MESSAGE_STATIC}).msg_clr_eos
						taglen_advance (l_taglen);
						(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("file%N")))), (create {P_GLOBALS_STATIC}).highlight_attr.item[14])
						l_i___0 := 0
				when 76 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 94 -- skip loop
						end
				when 77 then -- loop body:
						l_break := False
						if l_i___0 < num_matches.item then
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 86 -- skip if block
						end
				when 78 then -- if:
						l_tagp.item.parse_match (matches.item[l_i___0]).do_nothing
						if l_new_tag.to_boolean then
							l_pos := -1 + 84 -- skip if block
						end
				when 79 then -- if:
						if not (((create {P_GLOBALS_STATIC}).g_do_tagpreview.item).to_boolean) then
							l_pos := -1 + 82 -- skip if block
						end
				when 80 then -- if:
						if l_i___0 = ptag_entry.item.cur_match then
							(create {P_GLOBALS_STATIC}).IObuff.item.item := (('>').code).to_natural_8
						else
							l_pos := -1 + 82 -- goto _L___6
						end
				when 81 then -- if block done, skip else block:
						l_pos := -1 + 83
				when 82 then -- else: | _L___6:
						if l_use_tagstack.to_boolean then
							if l_i___0 = (l_tagstack + l_tagstackidx).item.cur_match then
								(create {P_GLOBALS_STATIC}).IObuff.item.item := (('>').code).to_natural_8
							else
								(create {P_GLOBALS_STATIC}).IObuff.item.item := ((' ').code).to_natural_8
							end
						else
							(create {P_GLOBALS_STATIC}).IObuff.item.item := ((' ').code).to_natural_8
						end
				when 83 then -- if done | if block done, skip else block:
						l_pos := -1 + 85
				when 84 then -- else:;
						(create {P_GLOBALS_STATIC}).IObuff.item.item := ((' ').code).to_natural_8
				when 85 then;
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item) + 1, (1_024).to_natural_32, ce_string ("%%2d %%s "), l_i___0 + 1, mt_names.item[(((matches.item[l_i___0])[0]).to_integer_32).bit_and (7)]]).do_nothing;
						(create {P_MESSAGE_STATIC}).msg_puts ((create {P_GLOBALS_STATIC}).IObuff.item)
						if not (l_tagp.item.tagkind).is_void then
							(create {P_MESSAGE_STATIC}).msg_outtrans_len (l_tagp.item.tagkind, (l_tagp.item.tagkind_end).distance ((l_tagp.item.tagkind))).do_nothing
						end
						(create {P_MESSAGE_STATIC}).msg_advance (13);
						(create {P_MESSAGE_STATIC}).msg_outtrans_len_attr (l_tagp.item.tagname, (l_tagp.item.tagname_end).distance ((l_tagp.item.tagname)), (create {P_GLOBALS_STATIC}).highlight_attr.item[14]).do_nothing;
						(create {P_MESSAGE_STATIC}).msg_putchar ((' ').code)
						taglen_advance (l_taglen)
						l_p___0 := l_tagp.item.tag_full_fname
						if not l_p___0.is_void then
							(create {P_MESSAGE_STATIC}).msg_puts_long_attr (l_p___0, (create {P_GLOBALS_STATIC}).highlight_attr.item[2]);
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
						end
						if (create {P_GLOBALS_STATIC}).msg_col.item > 0 then
							(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
						end
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_break := True
						end
				when 86 then -- if done
						if not (l_return or l_break or l_continue) then
							(create {P_MESSAGE_STATIC}).msg_advance (15)
							l_command_end := l_tagp.item.command_end
							if not l_command_end.is_void then
								l_p___0 := l_command_end + 3
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_continue := False
									if (l_p___0.item).to_boolean then
										if (l_p___0.item).to_integer_32 /= 13 then
											if (l_p___0.item).to_integer_32 = 10 then
												l_break := True
											end
										else
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										from
										until
											(l_p___0.item).to_integer_32 /= 9
										loop
											l_p___0 := l_p___0 + 1
										end
										if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("file:"), (5).to_natural_32)) = 0 then
											if ((create {P_MISC2_STATIC}).vim_isspace ((l_p___0[5]).to_integer_32)).to_boolean then
												l_p___0 := l_p___0 + (5)
												l_continue := True
											end
										end
									end
									if not (l_return or l_break or l_continue) then
										if l_p___0.is_equal (l_tagp.item.tagkind) then
											l_p___0 := l_tagp.item.tagkind_end
											l_continue := True
										elseif (l_p___0 + 5).is_equal (l_tagp.item.tagkind) then
											if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("kind:"), (5).to_natural_32)) = 0 then
												l_p___0 := l_tagp.item.tagkind_end
												l_continue := True
											end
										end
									end
									if not (l_return or l_break or l_continue) then
										l_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[8]
										from
										until
											(l_break)
										loop
											l_break := False
											if (l_p___0.item).to_boolean then
												if (l_p___0.item).to_integer_32 /= 13 then
													if (l_p___0.item).to_integer_32 = 10 then
														l_break := True
													end
												else
													l_break := True
												end
											else
												l_break := True
											end
											if not (l_return or l_break) then
												if ((create {P_GLOBALS_STATIC}).msg_col.item + ((create {P_CHARSET_STATIC}).ptr2cells (l_p___0))).to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item then
													(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
													if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
														l_break := True
													end
													if not (l_return or l_break) then
														(create {P_MESSAGE_STATIC}).msg_advance (15)
													end
												end
											end
											if not (l_return or l_break) then
												l_p___0 := (create {P_MESSAGE_STATIC}).msg_outtrans_one (l_p___0, l_attr)
												if (l_p___0.item).to_integer_32 = 9 then
													(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")), l_attr)
													l_break := True
												end
											end
											if not (l_return or l_break) and then ((l_p___0.item).to_integer_32 = 58) then
												l_attr := 0
											end
										end
										l_break := False
									end
								end
								l_break := False
								l_continue := False
								if (create {P_GLOBALS_STATIC}).msg_col.item > 15 then
									(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
									if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										(create {P_MESSAGE_STATIC}).msg_advance (15)
									end
								end
							else
								l_p___0 := l_tagp.item.command
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_p___0.item).to_boolean then
										if (l_p___0.item).to_integer_32 /= 13 then
											if (l_p___0.item).to_integer_32 = 10 then
												l_break := True
											end
										else
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										l_p___0 := l_p___0 + 1
									end
								end
								l_break := False
								l_command_end := l_p___0
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 93 -- skip if block
						end
				when 87 then -- if:
						l_p___0 := l_tagp.item.command
						if (l_p___0.item).to_integer_32 /= 47 then
							l_pos := -1 + 90 -- skip if block
						end
				when 88 then -- if:
						l_pos := -1 + 91 -- goto _L___7
				when 89 then -- if block done, skip else block:
						l_pos := -1 + 92
				when 90 then -- else:
						if (l_p___0.item).to_integer_32 /= 63 then
							l_pos := -1 + 92 -- skip if block
						end
				when 91 then -- if: | _L___7:
						l_p___0 := l_p___0 + 1
						if (l_p___0.item).to_integer_32 = 94 then
							l_p___0 := l_p___0 + 1
						end
				when 92 then -- if done
						from
						until
							(l_break)
						loop
							l_break := False
							if not l_p___0.is_equal (l_command_end) then
								if not ((create {P_MISC2_STATIC}).vim_isspace ((l_p___0.item).to_integer_32)).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						from
						until
							not (not (l_break) and then (not l_p___0.is_equal (l_command_end)))
						loop
							l_break := False
							if (l_p___0.item).to_integer_32 = 9 then
								l_tmp___24 := 1
							else
								l_tmp___24 := ((create {P_CHARSET_STATIC}).ptr2cells (l_p___0))
							end
							if ((create {P_GLOBALS_STATIC}).msg_col.item + l_tmp___24).to_integer_32 > (create {P_GLOBALS_STATIC}).Columns.item.item then
								(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
							end
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								(create {P_MESSAGE_STATIC}).msg_advance (15)
								if (l_p___0.item).to_integer_32 = 92 then
									if (l_p___0[1]).to_integer_32 = ((l_tagp.item.command).item).to_integer_32 then
										l_p___0 := l_p___0 + 1
									end
								end
								if (l_p___0.item).to_integer_32 = 9 then
									(create {P_MESSAGE_STATIC}).msg_putchar ((' ').code)
									l_p___0 := l_p___0 + 1
								else
									l_p___0 := (create {P_MESSAGE_STATIC}).msg_outtrans_one (l_p___0, 0)
								end
								if l_p___0.is_equal (l_command_end - 2) then
									if (l_p___0.item).to_integer_32 = 36 then
										if (l_p___0[1]).to_integer_32 = ((l_tagp.item.command).item).to_integer_32 then
											l_break := True
										end
									end
								end
							end
							if not (l_return or l_break or l_continue) and then (l_p___0.is_equal (l_command_end - 1)) then
								if (l_p___0.item).to_integer_32 = ((l_tagp.item.command).item).to_integer_32 then
									if (l_p___0.item).to_integer_32 = 47 then
										l_break := True
									elseif (l_p___0.item).to_integer_32 = 63 then
										l_break := True
									end
								end
							end
						end
						l_break := False
						if ((create {P_GLOBALS_STATIC}).msg_col.item).to_boolean then
							(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
						end
						(create {P_UI_STATIC}).ui_breakcheck
						l_i___0 := l_i___0 + 1
				when 93 then -- if done
						l_pos := -1 + 76 -- back to loop condition
				when 94 then -- loop done
						l_break := False
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							(create {P_GLOBALS_STATIC}).got_int.item := 0
						end
						l_ask_for_selection := 1
				when 95 then -- if block done, skip else block:
						l_pos := -1 + 97
				when 96 then -- else:
						l_pos := -1 + 98 -- goto _L___9
				when 97 then -- if done | if block done, skip else block:
						l_pos := -1 + 101
				when 98 then -- else: | _L___9:
						if l_type /= 11 then
							l_pos := -1 + 101 -- skip if block
						end
				when 99 then -- if:
						l_list := (create {P_EVAL_STATIC}).list_alloc
						if l_list.is_void then
							l_pos := -1 + 155 -- goto end_do_tag
						end
				when 100 then
						l_i___0 := 0
						from
						until
							not (not (l_return) and then (l_i___0 < num_matches.item))
						loop
							l_continue := False
							l_tagp.item.parse_match (matches.item[l_i___0]).do_nothing
							l_len := (l_tagp.item.tagname_end).distance ((l_tagp.item.tagname))
							if l_len > 128 then
								l_len := 128
							end
							(create {P_MISC2_STATIC}).vim_strncpy (l_tag_name, l_tagp.item.tagname, l_len.to_natural_32)
							l_tag_name[l_len] := (('%/0/').code).to_natural_8
							l_p___0 := l_tagp.item.tag_full_fname
							if l_p___0.is_void then
								l_continue := True
							end
							if not (l_return or l_break or l_continue) then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0)).do_nothing;
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
								l_lnum := 0
								if ((((ctype_b_loc).item[((l_tagp.item.command).item).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
									l_lnum := atol (create {CE_INTEGER_8_POINTER}.make_cast (l_tagp.item.command))
								else
									l_cmd_start := l_tagp.item.command
									l_cmd_end := l_tagp.item.command_end
									if l_cmd_end.is_void then
										l_p___0 := l_tagp.item.command
										from
										until
											(l_break)
										loop
											l_break := False
											if (l_p___0.item).to_boolean then
												if (l_p___0.item).to_integer_32 /= 13 then
													if (l_p___0.item).to_integer_32 = 10 then
														l_break := True
													end
												else
													l_break := True
												end
											else
												l_break := True
											end
											if not (l_return or l_break or l_continue) then
												l_p___0 := l_p___0 + 1
											end
										end
										l_break := False
										l_cmd_end := l_p___0
									end
									l_cmd_end := l_cmd_end - 1
									if (l_cmd_start.item).to_integer_32 = 47 then
										l_cmd_start := l_cmd_start + 1
									elseif (l_cmd_start.item).to_integer_32 = 63 then
										l_cmd_start := l_cmd_start + 1
									end
									if (l_cmd_end.item).to_integer_32 = 47 then
										l_cmd_end := l_cmd_end - 1
									elseif (l_cmd_end.item).to_integer_32 = 63 then
										l_cmd_end := l_cmd_end - 1
									end
									l_len := 0
									l_cmd[0] := (('%/0/').code).to_natural_8
									if (l_cmd_start.item).to_integer_32 = 94 then
										strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_cmd), ce_string ("^")).do_nothing
										l_cmd_start := l_cmd_start + 1
										l_len := l_len + 1
									end
									strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_cmd), ce_string ("\V")).do_nothing
									l_len := l_len + (2)
									l_cmd_len := (l_cmd_end.distance (l_cmd_start)) + 1
									if l_cmd_len > 1_019 then
										l_cmd_len := 1_019
									end
									strncat (create {CE_INTEGER_8_POINTER}.make_cast (l_cmd), create {CE_INTEGER_8_POINTER}.make_cast (l_cmd_start), l_cmd_len.to_natural_32).do_nothing
									l_len := l_len + l_cmd_len
									if (l_cmd[l_len - 1]).to_integer_32 = 36 then
										l_cmd[l_len - 1] := (('\').code).to_natural_8
										l_cmd[l_len] := (('$').code).to_natural_8
										l_len := l_len + 1
									end
									l_cmd[l_len] := (('%/0/').code).to_natural_8
								end
								l_dict := (create {P_EVAL_STATIC}).dict_alloc
								if l_dict.is_void then
									l_continue := True
								end
							end
							if not (l_return or l_break or l_continue) then
								if ((create {P_EVAL_STATIC}).list_append_dict (l_list, l_dict)) = 0 then
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_dict))
									l_continue := True
								end
							end
							if not (l_return or l_break or l_continue) then
								(create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("text"), 0, l_tag_name).do_nothing;
								(create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("filename"), 0, l_fname).do_nothing;
								(create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("lnum"), l_lnum, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)).do_nothing
								if l_lnum = 0 then
									(create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("pattern"), 0, l_cmd).do_nothing
								end
							end
							if (not l_return) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_continue := False;
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, ce_string ("ltag %%s"), a_tag]).do_nothing;
						(create {P_QUICKFIX_STATIC}).set_errorlist ((create {P_GLOBALS_STATIC}).curwin.item, l_list, (' ').code, (create {P_GLOBALS_STATIC}).IObuff.item).do_nothing
						l_list.item.list_free (1)
						l_cur_match := 0
				when 101 then -- if done | if done
						if l_ask_for_selection /= 1 then
							l_pos := -1 + 111 -- skip if block
						end
				when 102 then -- if:
						l_i___0 := (create {P_MISC1_STATIC}).prompt_for_number (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						if not (l_i___0 <= 0) then
							l_pos := -1 + 105 -- skip if block
						end
				when 103 then -- if:
						l_pos := -1 + 109 -- goto _L___10
				when 104 then -- if block done, skip else block:
						l_pos := -1 + 110
				when 105 then -- else:
						if not (l_i___0 > num_matches.item) then
							l_pos := -1 + 108 -- skip if block
						end
				when 106 then -- if:
						l_pos := -1 + 109 -- goto _L___10
				when 107 then -- if block done, skip else block:
						l_pos := -1 + 110
				when 108 then -- else:
						if not (((create {P_GLOBALS_STATIC}).got_int.item).to_boolean) then
							l_pos := -1 + 110 -- skip if block
						end
				when 109 then -- if: | _L___10:
						if l_use_tagstack.to_boolean then
							(l_tagstack + l_tagstackidx).item.fmark := l_saved_fmark.twin
							l_tagstackidx := l_prevtagstackidx
						end
						l_break := True
				when 110 then -- if done | if done
						if not (l_return or l_break or l_continue) then
							l_cur_match := l_i___0 - 1
						end
				when 111 then -- if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 153 -- skip if block
						end
				when 112 then -- if:
						if not (l_cur_match >= num_matches.item) then
							l_pos := -1 + 119 -- skip if block
						end
				when 113 then -- if:
						if l_type /= 3 then
							l_pos := -1 + 116 -- skip if block
						end
				when 114 then -- if:
						l_pos := -1 + 117 -- goto _L___11
				when 115 then -- if block done, skip else block:
						l_pos := -1 + 118
				when 116 then -- else:
						if l_type /= 5 then
							l_pos := -1 + 118 -- skip if block
						end
				when 117 then -- if: | _L___11:
						if nofile_fname.item.is_void then
							if num_matches.item = 1 then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E427: There is only one matching tag"))))).do_nothing
							else
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E428: Cannot go beyond last matching tag"))))).do_nothing
							end
							l_skip_msg := 1
						end
				when 118 then -- if done
						l_cur_match := num_matches.item - 1
				when 119 then -- if done
						if l_use_tagstack.to_boolean then
							(l_tagstack + l_tagstackidx).item.cur_match := l_cur_match;
							(l_tagstack + l_tagstackidx).item.cur_fnum := l_cur_fnum
							l_tagstackidx := l_tagstackidx + 1
						elseif ((create {P_GLOBALS_STATIC}).g_do_tagpreview.item).to_boolean then
							ptag_entry.item.cur_match := l_cur_match
							ptag_entry.item.cur_fnum := l_cur_fnum
						end
						if not nofile_fname.item.is_void then
							if l_error_cur_match /= l_cur_match then
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("File %"%%s%" does not exist")))), nofile_fname.item]).do_nothing
							end
						end
						l_ic := (((matches.item[l_cur_match])[0]).to_integer_32).bit_and (4)
						if l_type = 7 then
							l_pos := -1 + 134 -- skip if block
						end
				when 120 then -- if:
						if l_type = 9 then
							l_pos := -1 + 134 -- skip if block
						end
				when 121 then -- if:
						if not (num_matches.item > 1) then
							l_pos := -1 + 124 -- skip if block
						end
				when 122 then -- if:
						l_pos := -1 + 125 -- goto _L___13
				when 123 then -- if block done, skip else block:
						l_pos := -1 + 134
				when 124 then -- else:
						if not (l_ic.to_boolean) then
							l_pos := -1 + 134 -- skip if block
						end
				when 125 then -- if: | _L___13:
						if l_skip_msg.to_boolean then
							l_pos := -1 + 134 -- skip if block
						end
				when 126 then -- if:
						if max_num_matches.item.to_integer_32 /= 2_147_483_647 then
							l_tmp___31 := (gettext (ce_string (" or more")))
						else
							l_tmp___31 := ce_string ("")
						end
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("tag %%d of %%d%%s"))), l_cur_match + 1, num_matches.item, l_tmp___31]).do_nothing
						if l_ic.to_boolean then
							strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (gettext (ce_string ("  Using tag with different case!")))).do_nothing
						end
						if not (num_matches.item > l_prev_num_matches) then
							l_pos := -1 + 129 -- skip if block
						end
				when 127 then -- if:
						l_pos := -1 + 130 -- goto _L___12
				when 128 then -- if block done, skip else block:
						l_pos := -1 + 133
				when 129 then -- else:
						if not (l_new_tag.to_boolean) then
							l_pos := -1 + 132 -- skip if block
						end
				when 130 then -- if: | _L___12:
						if num_matches.item > 1 then
							if l_ic.to_boolean then
								(create {P_MESSAGE_STATIC}).msg_attr ((create {P_GLOBALS_STATIC}).IObuff.item, (create {P_GLOBALS_STATIC}).highlight_attr.item[17]).do_nothing
							else
								(create {P_MESSAGE_STATIC}).msg ((create {P_GLOBALS_STATIC}).IObuff.item).do_nothing
							end
							(create {P_GLOBALS_STATIC}).msg_scroll.item := 1
						else
							(create {P_MESSAGE_STATIC}).give_warning ((create {P_GLOBALS_STATIC}).IObuff.item, l_ic)
						end
				when 131 then -- if block done, skip else block:
						l_pos := -1 + 133
				when 132 then -- else:;
						(create {P_MESSAGE_STATIC}).give_warning ((create {P_GLOBALS_STATIC}).IObuff.item, l_ic)
				when 133 then -- if done
						if l_ic.to_boolean then
							if not ((create {P_GLOBALS_STATIC}).msg_scrolled.item).to_boolean then
								if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
									(create {P_TERM_STATIC}).out_flush;
									(create {P_UI_STATIC}).ui_delay (1_000, 1)
								end
							end
						end
				when 134 then -- if done | if done | if done | if done;
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, ce_string (":ta %%s%R"), l_name___1]).do_nothing;
						(create {P_EVAL_STATIC}).set_vim_var_string (47, (create {P_GLOBALS_STATIC}).IObuff.item, -1)
						l_i___0 := jumpto_tag (matches.item[l_cur_match], a_forceit, (l_type /= 10).to_integer);
						(create {P_EVAL_STATIC}).set_vim_var_string (47, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), -1)
						if l_i___0 /= 99 then
							l_pos := -1 + 152 -- skip if block
						end
				when 135 then -- if:
						if l_type /= 4 then
							l_pos := -1 + 138 -- skip if block
						end
				when 136 then -- if:
						if l_cur_match > 0 then
							l_pos := -1 + 149 -- goto _L___15
						else
							l_pos := -1 + 138 -- goto _L___17
						end
				when 137 then -- if block done, skip else block:
						l_pos := -1 + 150
				when 138 then -- else: | _L___17:
						if l_type /= 1 then
							l_pos := -1 + 141 -- skip if block
						end
				when 139 then -- if:
						l_pos := -1 + 145 -- goto _L___16
				when 140 then -- if block done, skip else block:
						l_pos := -1 + 150
				when 141 then -- else:
						if l_type /= 3 then
							l_pos := -1 + 144 -- skip if block
						end
				when 142 then -- if:
						l_pos := -1 + 145 -- goto _L___16
				when 143 then -- if block done, skip else block:
						l_pos := -1 + 150
				when 144 then -- else:
						if l_type /= 5 then
							l_pos := -1 + 150 -- skip if block
						end
				when 145 then -- if: | _L___16:
						if max_num_matches.item.to_integer_32 = 2_147_483_647 then
							l_pos := -1 + 148 -- skip if block
						end
				when 146 then -- if:
						l_pos := -1 + 149 -- goto _L___15
				when 147 then -- if block done, skip else block:
						l_pos := -1 + 150
				when 148 then -- else:
						if not (l_cur_match < num_matches.item - 1) then
							l_pos := -1 + 150 -- skip if block
						end
				when 149 then -- if: | _L___15:
						l_error_cur_match := l_cur_match
						if l_use_tagstack.to_boolean then
							l_tagstackidx := l_tagstackidx - 1
						end
						if l_type = 4 then
							l_cur_match := l_cur_match - 1
						else
							l_type := 3
							l_cur_match := l_cur_match + 1
						end
						l_continue := True
				when 150 then -- if done | if done | if done | if done | if done
						if not (l_return or l_break or l_continue) then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E429: File %"%%s%" does not exist")))), nofile_fname.item).do_nothing
						end
				when 151 then -- if block done, skip else block:
						l_pos := -1 + 153
				when 152 then -- else:
						if l_use_tagstack.to_boolean then
							if l_tagstackidx > (create {P_GLOBALS_STATIC}).curwin.item.item.w_tagstacklen then
								l_tagstackidx := (create {P_GLOBALS_STATIC}).curwin.item.item.w_tagstackidx
							end
						end
				when 153 then -- if done | if done | if done
						if not (l_return or l_break or l_continue) then
							l_break := True
						end
						if (not l_return and not l_break) then
							
						end
						l_pos := -1 + 58 -- back to loop condition
				when 154 then -- loop done
					l_break := False
					l_continue := False
				when 155 then -- end_do_tag:
					if l_use_tagstack.to_boolean then
						if l_tagstackidx <= (create {P_GLOBALS_STATIC}).curwin.item.item.w_tagstacklen then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_tagstackidx := l_tagstackidx
						end
					end
					(create {P_GLOBALS_STATIC}).postponed_split.item := 0
					Result := 0
				when 156 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tag_freematch
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (tagmatchname.item))
			tagmatchname.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	taglen_advance (a_l: INTEGER_32)
		do
			if a_l.to_integer_32 = 2_147_483_647 then
				(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code);
				(create {P_MESSAGE_STATIC}).msg_advance (24)
			else
				(create {P_MESSAGE_STATIC}).msg_advance (13 + a_l)
			end
		end

	do_tags (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
			l_name___1: CE_POINTER [NATURAL_8]
			l_tagstack: CE_POINTER [PD_TAGGY]
			l_tagstackidx: INTEGER_32
			l_tagstacklen: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_continue: BOOLEAN
		do
			l_tagstack := (create {P_GLOBALS_STATIC}).curwin.item.item.w_tagstack
			l_tagstackidx := (create {P_GLOBALS_STATIC}).curwin.item.item.w_tagstackidx
			l_tagstacklen := (create {P_GLOBALS_STATIC}).curwin.item.item.w_tagstacklen;
			(create {P_MESSAGE_STATIC}).msg_puts_title (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%N  # TO tag         FROM line  in file/text")))))
			l_i___0 := 0
			from
			until
				not (l_i___0 < l_tagstacklen)
			loop
				l_continue := False
				if not ((l_tagstack + l_i___0).item.tagname).is_void then
					l_name___1 := (create {CE_CLASS_POINTER [PD_FILEMARK]}.make_shared ((l_tagstack + l_i___0).c_pointer + (create {PD_TAGGY}.make).offset_of ("fmark"))).item.fm_getname (30)
					if l_name___1.is_void then
						l_continue := True
					end
					if not (l_continue) then
						(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
						if l_i___0 = l_tagstackidx then
							l_tmp___0 := ('>').code
						else
							l_tmp___0 := (' ').code
						end
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), ce_string ("%%c%%2d %%2d %%-15s %%5ld  "), l_tmp___0, l_i___0 + 1, (l_tagstack + l_i___0).item.cur_match + 1, (l_tagstack + l_i___0).item.tagname, (l_tagstack + l_i___0).item.fmark.mark.lnum]).do_nothing;
						(create {P_MESSAGE_STATIC}).msg_outtrans ((create {P_GLOBALS_STATIC}).IObuff.item).do_nothing
						if (l_tagstack + l_i___0).item.fmark.fnum = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum then
							l_tmp___1 := (create {P_GLOBALS_STATIC}).highlight_attr.item[2]
						else
							l_tmp___1 := 0
						end
						(create {P_MESSAGE_STATIC}).msg_outtrans_attr (l_name___1, l_tmp___1).do_nothing;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_name___1))
					end
				end
				if not (l_continue) then
					(create {P_TERM_STATIC}).out_flush
				end
				l_i___0 := l_i___0 + 1
			end
			l_continue := False
			if l_tagstackidx = l_tagstacklen then
				(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N>")))
			end
		end

	tag_strnicmp (a_s1, a_s2: CE_POINTER [NATURAL_8]; a_len: NATURAL_32): INTEGER_32
		local
			l_s1: CE_POINTER [NATURAL_8]
			l_s2: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_s1 := a_s1
			l_s2 := a_s2
			l_len := a_len
			from
			until
				not (not (l_return or l_break) and then (l_len > {NATURAL_32} 0))
			loop
				l_break := False
				if (l_s1.item).to_integer_32 < 97 then
					l_tmp := (l_s1.item).to_integer_32
				elseif (l_s1.item).to_integer_32 > 122 then
					l_tmp := (l_s1.item).to_integer_32
				else
					l_tmp := (l_s1.item).to_integer_32 - 32
				end
				if (l_s2.item).to_integer_32 < 97 then
					l_tmp___0 := (l_s2.item).to_integer_32
				elseif (l_s2.item).to_integer_32 > 122 then
					l_tmp___0 := (l_s2.item).to_integer_32
				else
					l_tmp___0 := (l_s2.item).to_integer_32 - 32
				end
				l_i___0 := l_tmp - l_tmp___0
				if l_i___0 /= 0 then
					Result := l_i___0
					l_return := True
				end
				if not l_return then
					if (l_s1.item).to_integer_32 = 0 then
						l_break := True
					end
					if not (l_return or l_break) then
						l_s1 := l_s1 + 1
						l_s2 := l_s2 + 1
						l_len := l_len - 1
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 0
			end
		end

	find_tags (a_pat: CE_POINTER [NATURAL_8]; a_num_matches___0: CE_POINTER [INTEGER_32]; a_matchesp: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_flags___0, a_mincount: INTEGER_32; a_buf_ffname: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_num_matches___0.is_void
			not a_matchesp.is_void
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_lbuf: CE_POINTER [NATURAL_8]
			l_tag_fname: CE_POINTER [NATURAL_8]
			l_tn: CE_ARRAY [PD_TAGNAME_T]
			l_first_file: INTEGER_32
			l_tagp: CE_ARRAY [PD_TAG_POINTERS]
			l_did_open: INTEGER_32
			l_stop_searching: INTEGER_32
			l_retval: INTEGER_32
			l_is_static: INTEGER_32
			l_is_current: INTEGER_32
			l_eof: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_search_info: CE_ARRAY [PD_TAG_SEARCH_INFO]
			l_filesize: INTEGER_32
			l_tagcmp: INTEGER_32
			l_offset: INTEGER_32
			l_round: INTEGER_32
			l_state: NATURAL_32
			l_cmplen: INTEGER_32
			l_match: INTEGER_32
			l_match_no_ic: INTEGER_32
			l_match_re: INTEGER_32
			l_matchoff: INTEGER_32
			l_mfp: CE_POINTER [PD_MATCH_FOUND]
			l_mfp2: CE_POINTER [PD_MATCH_FOUND]
			l_ga_match: CE_ARRAY [PD_GROWARRAY]
			l_match_count: INTEGER_32
			l_matches___0: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_mtt: INTEGER_32
			l_len: INTEGER_32
			l_help_save: INTEGER_32
			l_help_pri: INTEGER_32
			l_help_lang_find: CE_POINTER [NATURAL_8]
			l_help_lang: CE_ARRAY [NATURAL_8]
			l_saved_pat: CE_POINTER [NATURAL_8]
			l_pats: CE_POINTER [PD_PAT_T]
			l_orgpat: CE_ARRAY [PD_PAT_T]
			l_convpat: CE_ARRAY [PD_PAT_T]
			l_vimconv: CE_ARRAY [PD_VIMCONV_T]
			l_findall: INTEGER_32
			l_tmp: INTEGER_32
			l_sort_error: INTEGER_32
			l_linear: INTEGER_32
			l_sortic: INTEGER_32
			l_line_error: INTEGER_32
			l_has_re: INTEGER_32
			l_help_only: INTEGER_32
			l_name_only: INTEGER_32
			l_noic: INTEGER_32
			l_get_it_again: INTEGER_32
			l_verbose: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___22: INTEGER_32
			l_cc___0: INTEGER_32
			l_conv_line: CE_POINTER [NATURAL_8]
			l_lbuf_line: CE_POINTER [NATURAL_8]
			l_tmp___32: INTEGER_32
			l_temp_end: CE_POINTER [NATURAL_8]
			l_tmp___36: NATURAL_32
			l_tmp___41: INTEGER_32
			l_tmp___44: INTEGER_32
			l_tmp___50: INTEGER_32
			l_tmp___51: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [SD_IO_FILE]} l_fp.make
			create {CE_CLASS_ARRAY [PD_TAGNAME_T]} l_tn.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_TAG_POINTERS]} l_tagp.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_TAG_SEARCH_INFO]} l_search_info.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga_match.make (<<16>>)
			create {CE_NATURAL_8_ARRAY} l_help_lang.make (<<3>>)
			create {CE_CLASS_ARRAY [PD_PAT_T]} l_orgpat.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_PAT_T]} l_convpat.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_VIMCONV_T]} l_vimconv.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_did_open := 0
					l_stop_searching := 0
					l_retval := 0
					l_eof := 0
					l_match_no_ic := 0
					l_matchoff := 0
					l_match_count := 0
					l_help_pri := 0
					l_help_lang_find := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_saved_pat := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					if a_mincount.to_integer_32 = 2_147_483_647 then
						l_tmp := 1
					elseif a_mincount = 300 then
						l_tmp := 1
					else
						l_tmp := 0
					end
					l_findall := l_tmp
					l_sort_error := 0
					l_sortic := 0
					l_line_error := 0
					l_has_re := (a_flags___0).bit_and (4)
					l_help_only := (a_flags___0).bit_and (1)
					l_name_only := (a_flags___0).bit_and (2)
					l_noic := (a_flags___0).bit_and (8)
					l_get_it_again := 0
					l_verbose := (a_flags___0).bit_and (32)
					l_help_save := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_help
					l_orgpat.item.pat := a_pat
					l_pats := l_orgpat
					l_vimconv.item.vc_type := 0
					l_lbuf := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 512)
					l_tag_fname := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 4_097)
					l_mtt := 0
					from
					until
						not (l_mtt < 16)
					loop
						(l_ga_match + l_mtt).item.ga_init2 (({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 100)
						l_mtt := l_mtt + 1
					end
					if l_lbuf.is_void then
						l_pos := -1 + 63 -- goto findtag_end
					elseif l_tag_fname.is_void then
						l_pos := -1 + 63 -- goto findtag_end
					end
				when 1 then
					if l_help_only.to_boolean then
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_help := 1
					end
					l_pats.item.len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_pat))).to_integer_32
					if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_help).to_boolean then
						if l_pats.item.len > 3 then
							if (a_pat[(l_pats.item.len - 3)]).to_integer_32 = 64 then
								if (a_pat[(l_pats.item.len - 2)]).to_integer_32 < 127 then
									if ((((ctype_b_loc).item[(a_pat[(l_pats.item.len - 2)]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
										if (a_pat[(l_pats.item.len - 1)]).to_integer_32 < 127 then
											if ((((ctype_b_loc).item[(a_pat[(l_pats.item.len - 1)]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
												l_saved_pat := (create {P_MISC2_STATIC}).vim_strnsave (a_pat, l_pats.item.len - 3)
												if not l_saved_pat.is_void then
													l_help_lang_find := a_pat + (l_pats.item.len - 2)
													l_pats.item.pat := l_saved_pat
													l_pats.item.len := l_pats.item.len - (3)
												end
											end
										end
									end
								end
							end
						end
					end
					if (create {P_OPTION_STATIC}).p_tl.item.item /= 0 then
						if (l_pats.item.len).to_integer_32 > (create {P_OPTION_STATIC}).p_tl.item.item then
							l_pats.item.len := ((create {P_OPTION_STATIC}).p_tl.item.item).to_integer_32
						end
					end
					l_pats.item.prepare_pats (l_has_re)
					memset (create {CE_VOID_POINTER}.make_cast (l_search_info), 0, (1).to_natural_32).do_nothing
					if not (((create {P_OPTION_STATIC}).p_ic.item.item).to_boolean) then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if l_noic.to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if l_findall.to_boolean then
							l_tmp___3 := 1
						elseif l_pats.item.headlen = 0 then
							l_tmp___3 := 1
						elseif not ((create {P_OPTION_STATIC}).p_tbs.item.item).to_boolean then
							l_tmp___3 := 1
						else
							l_tmp___3 := 0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_tmp___3 := 0
				when 8 then -- if done
					l_pats.item.regmatch.rm_ic := l_tmp___3
					l_round := 1
				when 9 then -- loop condition:
					if not (not (l_return or l_break) and then (l_round <= 2)) then
						l_pos := -1 + 62 -- skip loop
					end
				when 10 then -- loop body:
						l_break := False
						if l_pats.item.headlen = 0 then
							l_tmp___4 := 1
						elseif not ((create {P_OPTION_STATIC}).p_tbs.item.item).to_boolean then
							l_tmp___4 := 1
						elseif l_round = 2 then
							l_tmp___4 := 1
						else
							l_tmp___4 := 0
						end
						l_linear := l_tmp___4
						l_first_file := 1
				when 11 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 51 -- skip loop
						end
				when 12 then -- loop body:
						l_break := False
						l_continue := False
						if (l_tn.item.get_tagfname (l_first_file, l_tag_fname)) /= 1 then
							l_break := True
						end
						if not (not (l_return or l_break or l_continue) and then (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_help).to_boolean)) then
							l_pos := -1 + 22 -- skip if block
						end
				when 13 then -- if:
						l_i___0 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tag_fname))).to_integer_32
						if l_i___0 > 3 then
							if (l_tag_fname[(l_i___0 - 3)]).to_integer_32 = 45 then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_help_lang), create {CE_INTEGER_8_POINTER}.make_cast (((l_tag_fname + l_i___0) - 2))).do_nothing
							else
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_help_lang), ce_string ("en")).do_nothing
							end
						else
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_help_lang), ce_string ("en")).do_nothing
						end
						if not l_help_lang_find.is_void then
							if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_help_lang), create {CE_INTEGER_8_POINTER}.make_cast (l_help_lang_find))) /= 0 then
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 22 -- skip if block
						end
				when 14 then -- if:
						if not (((a_flags___0).bit_and (128)).to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if l_help_lang_find.is_void then
							if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname).is_void then
								l_i___0 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname))).to_integer_32
								if l_i___0 > 4 then
									if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname[(l_i___0 - 1)]).to_integer_32 = 120 then
										if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname[(l_i___0 - 4)]).to_integer_32 = 46 then
											if (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname + l_i___0) - 3)), create {CE_INTEGER_8_POINTER}.make_cast (l_help_lang), (2).to_natural_32)) = 0 then
												l_help_pri := 0
											else
												l_pos := -1 + 17 -- goto _L___6
											end
										else
											l_pos := -1 + 17 -- goto _L___6
										end
									else
										l_pos := -1 + 17 -- goto _L___6
									end
								else
									l_pos := -1 + 17 -- goto _L___6
								end
							else
								l_pos := -1 + 17 -- goto _L___6
							end
						else
							l_pos := -1 + 17 -- goto _L___6
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 17 then -- else: | _L___6:
						l_help_pri := 1
						l_s := (create {P_OPTION_STATIC}).p_hlg.item.item
						from
						until
							not (not (l_break) and then ((l_s.item).to_integer_32 /= 0))
						loop
							l_break := False
							if (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), create {CE_INTEGER_8_POINTER}.make_cast (l_help_lang), (2).to_natural_32)) = 0 then
								l_break := True
							end
							if not (l_break) then
								l_help_pri := l_help_pri + 1
								l_s := (create {P_MISC2_STATIC}).vim_strchr (l_s, (',').code)
								if l_s.is_void then
									l_break := True
								end
							end
							if not (l_break) then
								l_s := l_s + 1
							end
						end
						l_break := False
						if not (l_s.is_void) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 20 then -- else:
						if (l_s.item).to_integer_32 /= 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 21 then -- if: | _L___0:
						l_help_pri := l_help_pri + 1
						if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_help_lang), ce_string ("en"))) /= 0 then
							l_help_pri := l_help_pri + 1
						end
				when 22 then -- if done | if done | if done | if done
						if not (l_return or l_break or l_continue) then
							l_fp := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_tag_fname), ce_string ("r"))
							if l_fp.is_void then
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 50 -- skip if block
						end
				when 23 then -- if:
						if (create {P_OPTION_STATIC}).p_verbose.item.item >= 5 then
							(create {P_MESSAGE_STATIC}).verbose_enter;
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Searching tags file %%s")))), l_tag_fname]).do_nothing;
							(create {P_MESSAGE_STATIC}).verbose_leave
						end
						l_did_open := 1
						l_state := {PC_STATE}.TS_START
				when 24 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 49 -- skip loop
						end
				when 25 then -- loop body:
						l_break := False
						l_continue := False;
						(create {P_MISC1_STATIC}).line_breakcheck
						if ((a_flags___0).bit_and (64)).to_boolean then
							(create {P_EDIT_STATIC}).ins_compl_check_keys (30)
						end
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_stop_searching := 1
							l_break := True
						elseif ((create {P_GLOBALS_STATIC}).compl_interrupted.item).to_boolean then
							l_stop_searching := 1
							l_break := True
						end
						if not (l_return or l_break or l_continue) and then (a_mincount = 300) then
							if l_match_count >= 300 then
								l_stop_searching := 1
								l_retval := 1
								l_break := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if l_get_it_again.to_boolean then
							l_pos := -1 + 37 -- goto line_read_in
						end
				when 27 then
						if l_state = {NATURAL_32} 2 then
							l_offset := l_search_info.item.low_offset + (l_search_info.item.high_offset - l_search_info.item.low_offset) // 2
							if l_offset = l_search_info.item.curr_offset then
								l_break := True
							else
								l_search_info.item.curr_offset := l_offset
							end
						elseif l_state = {NATURAL_32} 3 then
							l_search_info.item.curr_offset := l_search_info.item.curr_offset - (1_024)
							if l_search_info.item.curr_offset < 0 then
								l_search_info.item.curr_offset := (0).to_integer_32
								rewind (l_fp)
								l_state := {PC_STATE}.TS_STEP_FORWARD
							end
						end
				when 28 then -- if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 36 -- skip if block
						end
				when 29 then -- if:
						if l_state /= {NATURAL_32} 2 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 33 -- goto _L___7
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 32 then -- else:
						if l_state /= {NATURAL_32} 3 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if: | _L___7:
						l_search_info.item.curr_offset_used := l_search_info.item.curr_offset
						fseeko (l_fp, l_search_info.item.curr_offset, 0).do_nothing
						l_eof := (create {P_FILEIO_STATIC}).vim_fgets (l_lbuf, 512, l_fp)
						if not l_eof.to_boolean then
							if l_search_info.item.curr_offset /= 0 then
								l_search_info.item.curr_offset := ftello (l_fp)
								if l_search_info.item.curr_offset = l_search_info.item.high_offset then
									fseeko (l_fp, l_search_info.item.low_offset, 0).do_nothing
									l_search_info.item.curr_offset := l_search_info.item.low_offset
								end
								l_eof := (create {P_FILEIO_STATIC}).vim_fgets (l_lbuf, 512, l_fp)
							end
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if not l_eof.to_boolean then
								if not ((create {P_CHARSET_STATIC}).vim_isblankline (l_lbuf)).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_search_info.item.curr_offset := ftello (l_fp)
								l_eof := (create {P_FILEIO_STATIC}).vim_fgets (l_lbuf, 512, l_fp)
							end
						end
						l_break := False
						if l_eof.to_boolean then
							l_state := {PC_STATE}.TS_SKIP_BACK
							l_search_info.item.match_offset := ftello (l_fp)
							l_search_info.item.curr_offset := l_search_info.item.curr_offset_used
							l_continue := True
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else:
						from
						until
							(l_break)
						loop
							l_break := False
							l_eof := (create {P_FILEIO_STATIC}).vim_fgets (l_lbuf, 512, l_fp)
							if not l_eof.to_boolean then
								if not ((create {P_CHARSET_STATIC}).vim_isblankline (l_lbuf)).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
						end
						l_break := False
						if l_eof.to_boolean then
							l_break := True
						end
				when 36 then -- if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 38 -- skip if block
						end
				when 37 then -- if: | line_read_in:
						if l_state = {NATURAL_32} 0 then
							if l_linear.to_boolean then
								l_state := {PC_STATE}.TS_LINEAR
							elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_lbuf), ce_string ("!_TAG_"), (6).to_natural_32)) > 0 then
								l_state := {PC_STATE}.TS_BINARY
							elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_lbuf), ce_string ("!_TAG_FILE_SORTED%T"), (18).to_natural_32)) = 0 then
								if (l_lbuf[18]).to_integer_32 = 49 then
									l_state := {PC_STATE}.TS_BINARY
								elseif (l_lbuf[18]).to_integer_32 = 50 then
									l_state := {PC_STATE}.TS_BINARY
									l_sortic := 1
									if ((create {P_OPTION_STATIC}).p_ic.item.item).to_boolean then
										l_tmp___14 := 1
									elseif not l_noic.to_boolean then
										l_tmp___14 := 1
									else
										l_tmp___14 := 0
									end
									l_pats.item.regmatch.rm_ic := l_tmp___14
								else
									l_state := {PC_STATE}.TS_LINEAR
								end
							end
							if l_state = {NATURAL_32} 2 then
								if (l_pats.item.regmatch.rm_ic).to_boolean then
									if not l_sortic.to_boolean then
										l_linear := 1
										l_state := {PC_STATE}.TS_LINEAR
									end
								end
							end
							if l_state = {NATURAL_32} 2 then
								l_filesize := lseek ((fileno (l_fp)), 0, 2)
								if l_filesize <= 0 then
									l_state := {PC_STATE}.TS_LINEAR
								else
									lseek ((fileno (l_fp)), 0, 0).do_nothing
									l_search_info.item.low_offset := (0).to_integer_32
									l_search_info.item.low_char := 0
									l_search_info.item.high_offset := l_filesize
									l_search_info.item.curr_offset := (0).to_integer_32
									l_search_info.item.high_char := 255
								end
								l_continue := True
							end
						end
				when 38 then -- if done
						if not (l_return or l_break or l_continue) and then ((l_lbuf[0]).to_integer_32 = 33) then
							if l_pats.is_equal (l_orgpat) then
								if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_lbuf), ce_string ("!_TAG_FILE_ENCODING%T"), (20).to_natural_32)) = 0 then
									l_p___0 := l_lbuf + 20
									from
									until
										(l_break)
									loop
										l_break := False
										if (l_p___0.item).to_integer_32 > 32 then
											if not ((l_p___0.item).to_integer_32 < 127) then
												l_break := True
											end
										else
											l_break := True
										end
										if not (l_break) then
											l_p___0 := l_p___0 + 1
										end
									end
									l_break := False
									l_p___0.item := (('%/0/').code).to_natural_8
									l_vimconv.item.convert_setup ((create {P_OPTION_STATIC}).p_enc.item.item, l_lbuf + 20).do_nothing
									if l_vimconv.item.vc_type /= 0 then
										l_convpat.item.pat := (create {P_MBYTE_STATIC}).string_convert (l_vimconv, l_pats.item.pat, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
										if not (l_convpat.item.pat).is_void then
											l_pats := l_convpat
											l_pats.item.len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_pats.item.pat))).to_integer_32
											l_pats.item.prepare_pats (l_has_re)
											l_pats.item.regmatch.rm_ic := l_orgpat.item.regmatch.rm_ic
										end
									end
									l_vimconv.item.convert_setup (l_lbuf + 20, (create {P_OPTION_STATIC}).p_enc.item.item).do_nothing
									l_continue := True
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 48 -- skip if block
						end
				when 39 then -- if:
						if not ((l_pats.item.headlen).to_boolean) then
							l_pos := -1 + 47 -- skip if block
						end
				when 40 then -- if:
						l_tagp.item.tagname := l_lbuf
						l_tagp.item.tagname_end := (create {P_MISC2_STATIC}).vim_strchr (l_lbuf, ('%T').code)
						if (l_tagp.item.tagname_end).is_void then
							l_line_error := 1
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 45 -- skip if block
						end
				when 41 then -- if:
						l_tagp.item.fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_p___0 := l_lbuf
						from
						until
							not (not (l_break) and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_tagp.item.tagname_end).c_pointer.to_integer_32).to_natural_32))
						loop
							l_break := False
							if (l_p___0.item).to_integer_32 = 58 then
								if (l_tagp.item.fname).is_void then
									l_tagp.item.fname := l_tagp.item.tagname_end + 1
								end
								if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_lbuf), create {CE_INTEGER_8_POINTER}.make_cast (l_tagp.item.fname), (l_p___0.distance (l_lbuf)).to_natural_32)) = 0 then
									if (l_tagp.item.fname[(l_p___0.distance (l_lbuf))]).to_integer_32 = 9 then
										l_tagp.item.tagname := l_p___0 + 1
										l_break := True
									end
								end
							end
							if not (l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						l_cmplen := (l_tagp.item.tagname_end).distance ((l_tagp.item.tagname))
						if (create {P_OPTION_STATIC}).p_tl.item.item /= 0 then
							if l_cmplen.to_integer_32 > (create {P_OPTION_STATIC}).p_tl.item.item then
								l_cmplen := ((create {P_OPTION_STATIC}).p_tl.item.item).to_integer_32
							end
						end
						if not (l_has_re.to_boolean) then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						if l_pats.item.headlen < l_cmplen then
							l_cmplen := l_pats.item.headlen
						else
							l_pos := -1 + 44 -- goto _L___8
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else: | _L___8:
						if l_state = {NATURAL_32} 1 then
							if l_pats.item.headlen /= l_cmplen then
								l_continue := True
							end
						end
				when 45 then -- if done
						if not (l_return or l_break or l_continue) then
							if l_state = {NATURAL_32} 2 then
								l_i___0 := (l_tagp.item.tagname[0]).to_integer_32
								if l_sortic.to_boolean then
									if (l_tagp.item.tagname[0]).to_integer_32 < 97 then
										l_tmp___22 := (l_tagp.item.tagname[0]).to_integer_32
									elseif (l_tagp.item.tagname[0]).to_integer_32 > 122 then
										l_tmp___22 := (l_tagp.item.tagname[0]).to_integer_32
									else
										l_tmp___22 := (l_tagp.item.tagname[0]).to_integer_32 - 32
									end
									l_i___0 := l_tmp___22
								end
								if l_i___0 < l_search_info.item.low_char then
									l_sort_error := 1
								elseif l_i___0 > l_search_info.item.high_char then
									l_sort_error := 1
								end
								if l_sortic.to_boolean then
									l_tagcmp := tag_strnicmp (l_tagp.item.tagname, l_pats.item.head, l_cmplen.to_natural_32)
								else
									l_tagcmp := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_tagp.item.tagname), create {CE_INTEGER_8_POINTER}.make_cast (l_pats.item.head), l_cmplen.to_natural_32)
								end
								if l_tagcmp = 0 then
									if l_cmplen < l_pats.item.headlen then
										l_tagcmp := -1
									elseif l_cmplen > l_pats.item.headlen then
										l_tagcmp := 1
									end
								end
								if l_tagcmp = 0 then
									l_state := {PC_STATE}.TS_SKIP_BACK
									l_search_info.item.match_offset := l_search_info.item.curr_offset
									l_continue := True
								end
								if not (l_return or l_break or l_continue) and then (l_tagcmp < 0) then
									l_search_info.item.curr_offset := ftello (l_fp)
									if l_search_info.item.curr_offset < l_search_info.item.high_offset then
										l_search_info.item.low_offset := l_search_info.item.curr_offset
										if l_sortic.to_boolean then
											if (l_tagp.item.tagname[0]).to_integer_32 < 97 then
												l_search_info.item.low_char := (l_tagp.item.tagname[0]).to_integer_32
											elseif (l_tagp.item.tagname[0]).to_integer_32 > 122 then
												l_search_info.item.low_char := (l_tagp.item.tagname[0]).to_integer_32
											else
												l_search_info.item.low_char := (l_tagp.item.tagname[0]).to_integer_32 - 32
											end
										else
											l_search_info.item.low_char := (l_tagp.item.tagname[0]).to_integer_32
										end
										l_continue := True
									end
								end
								if not (l_return or l_break or l_continue) and then (l_tagcmp > 0) then
									if l_search_info.item.curr_offset /= l_search_info.item.high_offset then
										l_search_info.item.high_offset := l_search_info.item.curr_offset
										if l_sortic.to_boolean then
											if (l_tagp.item.tagname[0]).to_integer_32 < 97 then
												l_search_info.item.high_char := (l_tagp.item.tagname[0]).to_integer_32
											elseif (l_tagp.item.tagname[0]).to_integer_32 > 122 then
												l_search_info.item.high_char := (l_tagp.item.tagname[0]).to_integer_32
											else
												l_search_info.item.high_char := (l_tagp.item.tagname[0]).to_integer_32 - 32
											end
										else
											l_search_info.item.high_char := (l_tagp.item.tagname[0]).to_integer_32
										end
										l_continue := True
									end
								end
								if not (l_return or l_break or l_continue) then
									l_break := True
								end
							elseif l_state = {NATURAL_32} 3 then
								if ((create {P_MBYTE_STATIC}).mb_strnicmp (l_tagp.item.tagname, l_pats.item.head, l_cmplen.to_natural_32)) /= 0 then
									l_state := {PC_STATE}.TS_STEP_FORWARD
								else
									l_search_info.item.curr_offset := l_search_info.item.curr_offset_used
								end
								l_continue := True
							elseif l_state = {NATURAL_32} 4 then
								if ((create {P_MBYTE_STATIC}).mb_strnicmp (l_tagp.item.tagname, l_pats.item.head, l_cmplen.to_natural_32)) /= 0 then
									if (ftello (l_fp)) > l_search_info.item.match_offset then
										l_break := True
									else
										l_continue := True
									end
								end
							elseif ((create {P_MBYTE_STATIC}).mb_strnicmp (l_tagp.item.tagname, l_pats.item.head, l_cmplen.to_natural_32)) /= 0 then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if (l_tagp.item.fname).is_void then
								l_tagp.item.fname := l_tagp.item.tagname_end + 1
							end
							l_tagp.item.fname_end := (create {P_MISC2_STATIC}).vim_strchr (l_tagp.item.fname, ('%T').code)
							l_tagp.item.command := l_tagp.item.fname_end + 1
							if (l_tagp.item.fname_end).is_void then
								l_i___0 := 0
							else
								l_i___0 := 1
							end
						end
				when 46 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 47 then -- else:
						l_i___0 := l_tagp.item.parse_tag_line (l_lbuf)
				when 48 then -- if done | if done
						if not (l_return or l_break or l_continue) and then (l_i___0 = 0) then
							l_line_error := 1
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_cmplen := (l_tagp.item.tagname_end).distance ((l_tagp.item.tagname))
							if (create {P_OPTION_STATIC}).p_tl.item.item /= 0 then
								if l_cmplen.to_integer_32 > (create {P_OPTION_STATIC}).p_tl.item.item then
									l_cmplen := ((create {P_OPTION_STATIC}).p_tl.item.item).to_integer_32
								end
							end
							if l_pats.item.len /= l_cmplen then
								l_match := 0
							elseif (l_pats.item.regmatch.rm_ic).to_boolean then
								l_match := (((create {P_MBYTE_STATIC}).mb_strnicmp (l_tagp.item.tagname, l_pats.item.pat, l_cmplen.to_natural_32)) = 0).to_integer
								if l_match.to_boolean then
									l_match_no_ic := ((strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_tagp.item.tagname), create {CE_INTEGER_8_POINTER}.make_cast (l_pats.item.pat), l_cmplen.to_natural_32)) = 0).to_integer
								end
							else
								l_match := ((strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_tagp.item.tagname), create {CE_INTEGER_8_POINTER}.make_cast (l_pats.item.pat), l_cmplen.to_natural_32)) = 0).to_integer
							end
							l_match_re := 0
							if not l_match.to_boolean then
								if not (l_pats.item.regmatch.regprog).is_void then
									l_cc___0 := ((l_tagp.item.tagname_end).item).to_integer_32;
									(l_tagp.item.tagname_end).item := (('%/0/').code).to_natural_8
									l_match := (create {CE_CLASS_POINTER [PD_REGMATCH_T]}.make_shared (l_pats.c_pointer + (create {PD_PAT_T}.make).offset_of ("regmatch"))).item.vim_regexec (l_tagp.item.tagname, 0)
									if l_match.to_boolean then
										l_matchoff := (l_pats.item.regmatch.startp[0]).distance ((l_tagp.item.tagname))
										if (l_pats.item.regmatch.rm_ic).to_boolean then
											l_pats.item.regmatch.rm_ic := 0
											l_match_no_ic := (create {CE_CLASS_POINTER [PD_REGMATCH_T]}.make_shared (l_pats.c_pointer + (create {PD_PAT_T}.make).offset_of ("regmatch"))).item.vim_regexec (l_tagp.item.tagname, 0)
											l_pats.item.regmatch.rm_ic := 1
										end
									end
									(l_tagp.item.tagname_end).item := l_cc___0.to_natural_8
									l_match_re := 1
								end
							end
							if l_match.to_boolean then
								l_is_current := test_for_current (l_tagp.item.fname, l_tagp.item.fname_end, l_tag_fname, a_buf_ffname)
								if not (l_tagp.item.tagname).is_equal (l_lbuf) then
									l_is_static := 1
								else
									l_is_static := l_tagp.item.test_for_static
								end
								if l_is_static.to_boolean then
									if l_is_current.to_boolean then
										l_mtt := 0
									else
										l_mtt := 3
									end
								elseif l_is_current.to_boolean then
									l_mtt := 1
								else
									l_mtt := 2
								end
								if (l_pats.item.regmatch.rm_ic).to_boolean then
									if not l_match_no_ic.to_boolean then
										l_mtt := l_mtt + (4)
									end
								end
								if l_match_re.to_boolean then
									l_mtt := l_mtt + (8)
								end
								if ((l_ga_match + l_mtt).item.ga_grow (1)) = 1 then
									l_conv_line := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
									l_lbuf_line := l_lbuf
									if l_vimconv.item.vc_type /= 0 then
										l_conv_line := (create {P_MBYTE_STATIC}).string_convert (l_vimconv, l_lbuf, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
										if not l_conv_line.is_void then
											if (l_tagp.item.parse_tag_line (l_conv_line)) = 1 then
												l_lbuf_line := l_conv_line
											else
												l_tagp.item.parse_tag_line (l_lbuf).do_nothing
											end
										end
									end
									if l_help_only.to_boolean then
										(l_tagp.item.tagname_end).item := (('%/0/').code).to_natural_8
										l_len := (l_tagp.item.tagname_end).distance ((l_tagp.item.tagname))
										l_mfp := create {CE_CLASS_POINTER [PD_MATCH_FOUND]}.make_cast (((create {P_MISC2_STATIC}).alloc ((((((create {PD_MATCH_FOUND}.make).structure_size.to_natural_32).to_integer_32 + l_len) + 10) + 3).to_natural_32)))
										if not l_mfp.is_void then
											l_mfp.item.len := (l_len + 3) + 1
											l_p___0 := l_mfp.item.match
											strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), create {CE_INTEGER_8_POINTER}.make_cast (l_tagp.item.tagname)).do_nothing
											l_p___0[l_len] := (('@').code).to_natural_8
											strcpy (create {CE_INTEGER_8_POINTER}.make_cast (((l_p___0 + l_len) + 1)), create {CE_INTEGER_8_POINTER}.make_cast (l_help_lang)).do_nothing
											if l_match_re.to_boolean then
												l_tmp___32 := l_matchoff
											else
												l_tmp___32 := 0
											end
											sprintf ([(((create {CE_INTEGER_8_POINTER}.make_cast (l_p___0) + l_len) + 1) + 3), ce_string ("%%06d"), ((create {P_EX_CMDS_STATIC}).help_heuristic (l_tagp.item.tagname, l_tmp___32, (not l_match_no_ic.to_boolean).to_integer)) + l_help_pri]).do_nothing
										end
										(l_tagp.item.tagname_end).item := (('%T').code).to_natural_8
									elseif l_name_only.to_boolean then
										if l_get_it_again.to_boolean then
											l_temp_end := l_tagp.item.command
											if (l_temp_end.item).to_integer_32 = 47 then
												from
												until
													(l_break)
												loop
													l_break := False
													if (l_temp_end.item).to_boolean then
														if (l_temp_end.item).to_integer_32 /= 13 then
															if (l_temp_end.item).to_integer_32 /= 10 then
																if (l_temp_end.item).to_integer_32 = 36 then
																	l_break := True
																end
															else
																l_break := True
															end
														else
															l_break := True
														end
													else
														l_break := True
													end
													if not (l_break) then
														l_temp_end := l_temp_end + 1
													end
												end
												l_break := False
											end
											if ((l_tagp.item.command + 2).c_pointer.to_integer_32).to_natural_32 < (l_temp_end.c_pointer.to_integer_32).to_natural_32 then
												l_len := (l_temp_end.distance ((l_tagp.item.command))) - 2
												l_mfp := create {CE_CLASS_POINTER [PD_MATCH_FOUND]}.make_cast (((create {P_MISC2_STATIC}).alloc ((((create {PD_MATCH_FOUND}.make).structure_size.to_natural_32).to_integer_32 + l_len).to_natural_32)))
												if not l_mfp.is_void then
													l_mfp.item.len := l_len + 1
													l_p___0 := l_mfp.item.match;
													(create {P_MISC2_STATIC}).vim_strncpy (l_p___0, l_tagp.item.command + 2, l_len.to_natural_32)
												end
											else
												l_mfp := create {CE_CLASS_POINTER [PD_MATCH_FOUND]}.make_shared (default_pointer)
											end
											l_get_it_again := 0
										else
											l_len := (l_tagp.item.tagname_end).distance ((l_tagp.item.tagname))
											l_mfp := create {CE_CLASS_POINTER [PD_MATCH_FOUND]}.make_cast (((create {P_MISC2_STATIC}).alloc ((((create {PD_MATCH_FOUND}.make).structure_size.to_natural_32).to_integer_32 + l_len).to_natural_32)))
											if not l_mfp.is_void then
												l_mfp.item.len := l_len + 1
												l_p___0 := l_mfp.item.match;
												(create {P_MISC2_STATIC}).vim_strncpy (l_p___0, l_tagp.item.tagname, l_len.to_natural_32)
											end
											if (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
												l_get_it_again := (create {P_OPTION_STATIC}).p_sft.item.item
											end
										end
									else
										l_tmp___36 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tag_fname))
										l_len := (l_tmp___36.to_integer_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_lbuf_line))).to_integer_32) + 3
										l_mfp := create {CE_CLASS_POINTER [PD_MATCH_FOUND]}.make_cast (((create {P_MISC2_STATIC}).alloc ((((create {PD_MATCH_FOUND}.make).structure_size.to_natural_32).to_integer_32 + l_len).to_natural_32)))
										if not l_mfp.is_void then
											l_mfp.item.len := l_len
											l_p___0 := l_mfp.item.match
											l_p___0[0] := l_mtt.to_natural_8
											strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 1)), create {CE_INTEGER_8_POINTER}.make_cast (l_tag_fname)).do_nothing
											l_s := ((l_p___0 + 1) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tag_fname))).to_integer_32) + 1
											strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_s), create {CE_INTEGER_8_POINTER}.make_cast (l_lbuf_line)).do_nothing
										end
									end
									if not l_mfp.is_void then
										l_i___0 := l_ga_match[l_mtt].ga_len
										from
										until
											(l_break)
										loop
											l_break := False
											l_i___0 := l_i___0 - 1
											if l_i___0 >= 0 then
												if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
													l_break := True
												end
											else
												l_break := True
											end
											if not (l_break) then
												l_mfp2 := create {CE_POINTER_POINTER [PD_MATCH_FOUND]}.make_cast (l_ga_match[l_mtt].ga_data)[l_i___0]
												if l_mfp2.item.len = l_mfp.item.len then
													if (memcmp (create {CE_VOID_POINTER}.make_cast ((l_mfp2.item.match)), create {CE_VOID_POINTER}.make_cast ((l_mfp.item.match)), (l_mfp.item.len).to_natural_32)) = 0 then
														l_break := True
													end
												end
											end
											if not (l_break) then
												(create {P_MISC1_STATIC}).line_breakcheck
											end
										end
										l_break := False
										if l_i___0 < 0 then
											l_tmp___41 := l_ga_match[l_mtt].ga_len
											l_ga_match[l_mtt].ga_len := (l_ga_match[l_mtt].ga_len) + 1
											create {CE_POINTER_POINTER [PD_MATCH_FOUND]}.make_cast (l_ga_match[l_mtt].ga_data)[l_tmp___41] := l_mfp
											l_match_count := l_match_count + 1
										else
											(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_mfp))
										end
									end
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_conv_line))
								else
									l_retval := 1
									l_stop_searching := 1
									l_break := True
								end
							end
						end
						if (not l_return and not l_break) then
							
						end
						l_pos := -1 + 24 -- back to loop condition
				when 49 then -- loop done
						l_break := False
						l_continue := False
						if l_line_error.to_boolean then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E431: Format error in tags file %"%%s%"")))), l_tag_fname).do_nothing
							l_tmp___44 := ftello (l_fp);
							(create {P_MISC2_STATIC}).emsgn (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Before byte %%ld")))), l_tmp___44).do_nothing
							l_stop_searching := 1
							l_line_error := 0
						end
						fclose (l_fp).do_nothing
						if l_pats.is_equal (l_convpat) then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pats.item.pat));
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pats.item.regmatch.regprog))
							l_orgpat.item.regmatch.rm_ic := l_pats.item.regmatch.rm_ic
							l_pats := l_orgpat
						end
						if l_vimconv.item.vc_type /= 0 then
							l_vimconv.item.convert_setup (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)).do_nothing
						end
						if l_sort_error.to_boolean then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E432: Tags file not sorted: %%s")))), l_tag_fname).do_nothing
							l_sort_error := 0
						end
						if l_match_count >= a_mincount then
							l_retval := 1
							l_stop_searching := 1
						end
						if l_stop_searching.to_boolean then
							l_break := True
						end
				when 50 then -- if done
						if (not l_return and not l_break) then
							l_first_file := 0
						end
						l_pos := -1 + 11 -- back to loop condition
				when 51 then -- loop done
						l_break := False
						l_continue := False
						l_tn.item.tagname_free
						if not (l_stop_searching.to_boolean) then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
						l_break := True
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 54 then -- else:
						if not (l_linear.to_boolean) then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						l_break := True
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 57 then -- else:
						if ((create {P_OPTION_STATIC}).p_ic.item.item).to_boolean then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						if l_noic.to_boolean then
							l_break := True
						else
							l_pos := -1 + 60 -- goto _L___9
						end
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 60 then -- else: | _L___9:
						if (l_pats.item.regmatch.rm_ic).to_boolean then
							l_break := True
						end
				when 61 then -- if done | if done
						if not (l_return or l_break or l_continue) then
							l_pats.item.regmatch.rm_ic := 1
							l_round := l_round + 1
						end
						l_pos := -1 + 9 -- back to loop condition
				when 62 then -- loop done
					l_break := False
					if not l_stop_searching.to_boolean then
						if not l_did_open.to_boolean then
							if l_verbose.to_boolean then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E433: No tags file"))))).do_nothing
							end
						end
						l_retval := 1
					end
				when 63 then -- findtag_end:;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_lbuf));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pats.item.regmatch.regprog));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tag_fname))
					if l_retval = 0 then
						l_match_count := 0
					end
					if l_match_count > 0 then
						l_matches___0 := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (((create {P_MISC2_STATIC}).lalloc ((l_match_count.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32, 1)))
					else
						l_matches___0 := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
					l_match_count := 0
					l_mtt := 0
					from
					until
						not (not (l_return) and then (l_mtt < 16))
					loop
						l_i___0 := 0
						from
						until
							not (l_i___0 < l_ga_match[l_mtt].ga_len)
						loop
							l_mfp := create {CE_POINTER_POINTER [PD_MATCH_FOUND]}.make_cast (l_ga_match[l_mtt].ga_data)[l_i___0]
							if l_matches___0.is_void then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_mfp))
							else
								if l_help_only.to_boolean then
									l_tmp___50 := 6
								else
									l_tmp___50 := 0
								end
								memmove (create {CE_VOID_POINTER}.make_cast (l_mfp), create {CE_VOID_POINTER}.make_cast ((l_mfp.item.match)), (l_mfp.item.len + l_tmp___50).to_natural_32).do_nothing
								l_tmp___51 := l_match_count
								l_match_count := l_match_count + 1
								l_matches___0[l_tmp___51] := create {CE_NATURAL_8_POINTER}.make_cast (l_mfp)
							end
							l_i___0 := l_i___0 + 1
						end
						(l_ga_match + l_mtt).item.ga_clear
						l_mtt := l_mtt + 1
					end
					a_matchesp.item := l_matches___0
					a_num_matches___0.item := l_match_count;
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_help := l_help_save;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_saved_pat))
					Result := l_retval
				when 64 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	found_tagfile_cb (a_fname: CE_POINTER [NATURAL_8]; a_cookie: CE_POINTER [ANY])
		local
			l_tmp: INTEGER_32
		do
			if (tag_fnames.item.item.ga_grow (1)) = 1 then
				l_tmp := tag_fnames.item.item.ga_len
				tag_fnames.item.item.ga_len := (tag_fnames.item.item.ga_len) + 1
				create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (tag_fnames.item.item.ga_data)[l_tmp] := (create {P_MISC2_STATIC}).vim_strsave (a_fname)
			end
		end

	jumpto_tag (a_lbuf: CE_POINTER [NATURAL_8]; a_forceit, a_keep_help: INTEGER_32): INTEGER_32
		local
			l_save_secure: INTEGER_32
			l_save_magic: INTEGER_32
			l_save_p_ws: INTEGER_32
			l_save_p_scs: INTEGER_32
			l_save_p_ic: INTEGER_32
			l_save_lnum: INTEGER_32
			l_csave: INTEGER_32
			l_str___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pbuf: CE_POINTER [NATURAL_8]
			l_pbuf_end: CE_POINTER [NATURAL_8]
			l_tofree_fname: CE_POINTER [NATURAL_8]
			l_fname: CE_POINTER [NATURAL_8]
			l_tagp: CE_ARRAY [PD_TAG_POINTERS]
			l_retval: INTEGER_32
			l_getfile_result: INTEGER_32
			l_search_options: INTEGER_32
			l_save_no_hlsearch: INTEGER_32
			l_curwin_save: CE_POINTER [PD_WINDOW_S]
			l_full_fname: CE_POINTER [NATURAL_8]
			l_old_KeyTyped: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___5: INTEGER_32
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_found: INTEGER_32
			l_cc___0: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_str___1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_TAG_POINTERS]} l_tagp.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_csave := 0
					l_tofree_fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_retval := 0
					l_curwin_save := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
					l_full_fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_old_KeyTyped := (create {P_GLOBALS_STATIC}).KeyTyped.item
					l_pbuf := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 512)
					if l_pbuf.is_void then
						l_tagp.item.fname_end := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_pos := -1 + 28 -- goto erret
					elseif (l_tagp.item.parse_match (a_lbuf)) = 0 then
						l_tagp.item.fname_end := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_pos := -1 + 28 -- goto erret
					end
				when 1 then
					l_csave := ((l_tagp.item.fname_end).item).to_integer_32;
					(l_tagp.item.fname_end).item := (('%/0/').code).to_natural_8
					l_fname := l_tagp.item.fname
					l_str___1.item := l_tagp.item.command
					l_pbuf_end := l_pbuf
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_str___1.item.item).to_boolean then
							if (l_str___1.item.item).to_integer_32 /= 10 then
								if (l_str___1.item.item).to_integer_32 = 13 then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_tmp___0 := l_pbuf_end
							l_pbuf_end := l_pbuf_end + 1
							l_tmp___1 := l_str___1.item
							l_str___1.item := l_str___1.item + 1
							l_tmp___0.item := l_tmp___1.item
						end
					end
					l_break := False
					l_pbuf_end.item := (('%/0/').code).to_natural_8
					l_str___1.item := l_pbuf
					if (find_extra (l_str___1)) = 1 then
						l_pbuf_end := l_str___1.item
						l_pbuf_end.item := (('%/0/').code).to_natural_8
					end
					l_fname := expand_tag_fname (l_fname, l_tagp.item.tag_fname, 1)
					if l_fname.is_void then
						l_pos := -1 + 28 -- goto erret
					end
				when 2 then
					l_tofree_fname := l_fname
					if ((create {P_OS_UNIX_STATIC}).mch_getperm (l_fname)) < 0 then
						if not ((create {P_FILEIO_STATIC}).has_autocmd ({PC_AUTO_EVENT}.EVENT_BUFREADCMD, l_fname, create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))).to_boolean then
							l_retval := 99;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (nofile_fname.item))
							nofile_fname.item := (create {P_MISC2_STATIC}).vim_strsave (l_fname)
							if nofile_fname.item.is_void then
								nofile_fname.item := (create {P_GLOBALS_STATIC}).empty_option.item
							end
							l_pos := -1 + 28 -- goto erret
						end
					end
				when 3 then;
					(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item + 1;
					(create {P_GLOBALS_STATIC}).need_mouse_correct.item := 1
					if ((create {P_GLOBALS_STATIC}).g_do_tagpreview.item).to_boolean then
						(create {P_GLOBALS_STATIC}).postponed_split.item := 0
						l_curwin_save := (create {P_GLOBALS_STATIC}).curwin.item
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_pvw).to_boolean then
							l_full_fname := (create {P_MISC1_STATIC}).FullName_save (l_fname, 0)
							l_fname := l_full_fname;
							(create {P_EX_CMDS_STATIC}).prepare_tagpreview (1).do_nothing
						end
					end
					if not (((create {P_GLOBALS_STATIC}).postponed_split.item).to_boolean) then
						l_pos := -1 + 6 -- skip if block
					end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if (create {P_GLOBALS_STATIC}).cmdmod.item.item.tab = 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if (create {P_GLOBALS_STATIC}).postponed_split.item > 0 then
							l_tmp___5 := (create {P_GLOBALS_STATIC}).postponed_split.item
						else
							l_tmp___5 := 0
						end
						(create {P_WINDOW_STATIC}).win_split (l_tmp___5, (create {P_GLOBALS_STATIC}).postponed_split_flags.item).do_nothing;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_scb := 0
				when 8 then -- if done
					if a_keep_help.to_boolean then
						if ((create {P_GLOBALS_STATIC}).g_do_tagpreview.item).to_boolean then
							(create {P_GLOBALS_STATIC}).keep_help_flag.item := (l_curwin_save.item.w_buffer).item.b_help
						else
							(create {P_GLOBALS_STATIC}).keep_help_flag.item := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_help
						end
					end
					l_getfile_result := (create {P_EX_CMDS_STATIC}).getfile (0, l_fname, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 1, (0).to_integer_32, a_forceit);
					(create {P_GLOBALS_STATIC}).keep_help_flag.item := 0
					if not (l_getfile_result <= 0) then
						l_pos := -1 + 27 -- skip if block
					end
				when 9 then -- if:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1;
						(create {P_GLOBALS_STATIC}).postponed_split.item := 0
						l_save_secure := (create {P_GLOBALS_STATIC}).secure.item;
						(create {P_GLOBALS_STATIC}).secure.item := 1;
						(create {P_GLOBALS_STATIC}).sandbox.item := (create {P_GLOBALS_STATIC}).sandbox.item + 1
						l_save_magic := (create {P_OPTION_STATIC}).p_magic.item.item;
						(create {P_OPTION_STATIC}).p_magic.item.item := 0
						l_save_no_hlsearch := (create {P_GLOBALS_STATIC}).no_hlsearch.item
						if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('t').code)).is_void then
							l_search_options := 0
						else
							l_search_options := 1_024
						end
						l_str___1.item := l_pbuf
						if (l_pbuf[0]).to_integer_32 = 47 then
							l_tmp___7 := (create {P_REGEXP_STATIC}).skip_regexp (l_pbuf + 1, (l_pbuf[0]).to_integer_32, 0, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
							l_str___1.item := l_tmp___7 + 1
						elseif (l_pbuf[0]).to_integer_32 = 63 then
							l_tmp___7 := (create {P_REGEXP_STATIC}).skip_regexp (l_pbuf + 1, (l_pbuf[0]).to_integer_32, 0, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
							l_str___1.item := l_tmp___7 + 1
						end
						if not (((l_str___1.item).c_pointer.to_integer_32).to_natural_32 > ((l_pbuf_end - 1).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 24 -- skip if block
						end
				when 10 then -- if:
						l_save_p_ws := (create {P_OPTION_STATIC}).p_ws.item.item
						l_save_p_ic := (create {P_OPTION_STATIC}).p_ic.item.item
						l_save_p_scs := (create {P_OPTION_STATIC}).p_scs.item.item;
						(create {P_OPTION_STATIC}).p_ws.item.item := 1;
						(create {P_OPTION_STATIC}).p_ic.item.item := 0;
						(create {P_OPTION_STATIC}).p_scs.item.item := 0
						l_save_lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (0).to_integer_32
						if not (((create {P_SEARCH_STATIC}).do_search (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), (l_pbuf[0]).to_integer_32, l_pbuf + 1, 1, l_search_options, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_retval := 1
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 13 then -- else:
						l_found := 1;
						(create {P_OPTION_STATIC}).p_ic.item.item := 1
						if not ((create {P_SEARCH_STATIC}).do_search (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), (l_pbuf[0]).to_integer_32, l_pbuf + 1, 1, l_search_options, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))).to_boolean then
							l_found := 2
							l_tagp.item.test_for_static.do_nothing
							l_cc___0 := ((l_tagp.item.tagname_end).item).to_integer_32;
							(l_tagp.item.tagname_end).item := (('%/0/').code).to_natural_8
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_pbuf), ce_string ("^%%s\s\*("), l_tagp.item.tagname]).do_nothing
							if not ((create {P_SEARCH_STATIC}).do_search (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('/').code, l_pbuf, 1, l_search_options, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))).to_boolean then
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_pbuf), ce_string ("^\[#a-zA-Z_]\.\*\<%%s\s\*("), l_tagp.item.tagname]).do_nothing
								if not ((create {P_SEARCH_STATIC}).do_search (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('/').code, l_pbuf, 1, l_search_options, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))).to_boolean then
									l_found := 0
								end
							end
							(l_tagp.item.tagname_end).item := l_cc___0.to_natural_8
						end
						if l_found /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:;
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E434: Can%'t find tag pattern"))))).do_nothing;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_save_lnum
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 16 then -- else:
						if l_found /= 2 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 19 then -- else:
						if l_save_p_ic.to_boolean then
							l_pos := -1 + 21 -- skip if block
						end
				when 20 then -- if: | _L___0:;
						(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E435: Couldn%'t find tag, just guessing!"))))).do_nothing
						if not ((create {P_GLOBALS_STATIC}).msg_scrolled.item).to_boolean then
							if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
								(create {P_TERM_STATIC}).out_flush;
								(create {P_UI_STATIC}).ui_delay (1_000, 1)
							end
						end
				when 21 then -- if done
						l_retval := 1
				when 22 then -- if done | if done;
						(create {P_OPTION_STATIC}).p_ws.item.item := l_save_p_ws;
						(create {P_OPTION_STATIC}).p_ic.item.item := l_save_p_ic;
						(create {P_OPTION_STATIC}).p_scs.item.item := l_save_p_scs;
						(create {P_MISC2_STATIC}).check_cursor
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (1).to_integer_32;
						(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd (l_pbuf).do_nothing
						l_retval := 1
				when 25 then -- if done
						if (create {P_GLOBALS_STATIC}).secure.item = 2 then
							(create {P_MESSAGE_STATIC}).wait_return (1)
						end
						(create {P_GLOBALS_STATIC}).secure.item := l_save_secure;
						(create {P_OPTION_STATIC}).p_magic.item.item := l_save_magic;
						(create {P_GLOBALS_STATIC}).sandbox.item := (create {P_GLOBALS_STATIC}).sandbox.item - 1
						if l_search_options.to_boolean then
							(create {P_GLOBALS_STATIC}).no_hlsearch.item := l_save_no_hlsearch
						end
						if l_getfile_result = -1 then
							l_retval := 1
						end
						if l_retval = 1 then
							if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_help).to_boolean then
								((create {P_GLOBALS_STATIC}).curwin.item).item.set_topline ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)
							end
							if (((create {P_OPTION_STATIC}).fdo_flags.item.item).bit_and ({NATURAL_32} 128)).to_boolean then
								if l_old_KeyTyped.to_boolean then
									(create {P_FOLD_STATIC}).foldOpenCursor
								end
							end
						end
						if ((create {P_GLOBALS_STATIC}).g_do_tagpreview.item).to_boolean then
							if not ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_curwin_save) then
								if ((create {P_WINDOW_STATIC}).win_valid (l_curwin_save)).to_boolean then
									(create {P_MOVE_STATIC}).validate_cursor;
									(create {P_SCREEN_STATIC}).redraw_later (10);
									(create {P_WINDOW_STATIC}).win_enter (l_curwin_save, 1)
								end
							end
						end
						(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item - 1
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else:;
						(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item - 1
						if ((create {P_GLOBALS_STATIC}).postponed_split.item).to_boolean then
							(create {P_WINDOW_STATIC}).win_close ((create {P_GLOBALS_STATIC}).curwin.item, 0);
							(create {P_GLOBALS_STATIC}).postponed_split.item := 0
						end
				when 28 then -- erret:;
					(create {P_GLOBALS_STATIC}).g_do_tagpreview.item := 0
					if not (l_tagp.item.fname_end).is_void then
						(l_tagp.item.fname_end).item := l_csave.to_natural_8
					end
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pbuf));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tofree_fname));
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_full_fname))
					Result := l_retval
				when 29 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	expand_tag_fname (a_fname, a_tag_fname: CE_POINTER [NATURAL_8]; a_expand: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_retval: CE_POINTER [NATURAL_8]
			l_expanded_fname: CE_POINTER [NATURAL_8]
			l_xpc: CE_ARRAY [PD_EXPAND]
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_EXPAND]} l_xpc.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fname := a_fname
					l_expanded_fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					if a_expand.to_boolean then
						if ((create {P_OS_UNIX_STATIC}).mch_has_wildcard (l_fname)).to_boolean then
							l_xpc.item.ExpandInit
							l_xpc.item.xp_context := 2
							l_expanded_fname := l_xpc.item.ExpandOne (l_fname, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 65, 2)
							if not l_expanded_fname.is_void then
								l_fname := l_expanded_fname
							end
						end
					end
					if not (((create {P_OPTION_STATIC}).p_tr.item.item).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_help).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if ((create {P_WINDOW_STATIC}).vim_isAbsName (l_fname)).to_boolean then
							l_retval := (create {P_MISC2_STATIC}).vim_strsave (l_fname)
						else
							l_p___0 := (create {P_MISC1_STATIC}).gettail (a_tag_fname)
							if not l_p___0.is_equal (a_tag_fname) then
								l_retval := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 4_096)
								if not l_retval.is_void then
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_retval), create {CE_INTEGER_8_POINTER}.make_cast (a_tag_fname)).do_nothing;
									(create {P_MISC2_STATIC}).vim_strncpy (l_retval + (l_p___0.distance (a_tag_fname)), l_fname, ((4_096 - (l_p___0.distance (a_tag_fname))) - 1).to_natural_32)
									simplify_filename (l_retval)
								end
							else
								l_retval := (create {P_MISC2_STATIC}).vim_strsave (l_fname)
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_retval := (create {P_MISC2_STATIC}).vim_strsave (l_fname)
				when 7 then -- if done;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_expanded_fname))
					Result := l_retval
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	simplify_filename (a_filename: CE_POINTER [NATURAL_8])
		require
			not a_filename.is_void
		local
			l_components: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_start___1: CE_POINTER [NATURAL_8]
			l_stripping_disabled: INTEGER_32
			l_relative: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___7: INTEGER_32
			l_do_strip: INTEGER_32
			l_saved_char: NATURAL_8
			l_st: CE_ARRAY [SD_STAT]
			l_tmp___11: INTEGER_32
			l_new_st: CE_ARRAY [SD_STAT]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_new_st.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_components := 0
					l_stripping_disabled := 0
					l_relative := 1
					l_p___0 := a_filename
					if ((create {P_MISC1_STATIC}).vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
						l_relative := 0
						from
						until
							(l_break)
						loop
							l_break := False
							l_p___0 := l_p___0 + 1
							if not ((create {P_MISC1_STATIC}).vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
								l_break := True
							end
						end
						l_break := False
					end
					l_start___1 := l_p___0
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 44 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if not (((create {P_MISC1_STATIC}).vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + 1)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 1)))) + {NATURAL_32} 1).do_nothing
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 5 then -- else:
						if (l_p___0[0]).to_integer_32 /= 46 then
							l_pos := -1 + 17 -- skip if block
						end
				when 6 then -- if:
						if not (((create {P_MISC1_STATIC}).vim_ispathsep ((l_p___0[1]).to_integer_32)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___5
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 9 then -- else:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if: | _L___5:
						if not (l_p___0.is_equal (l_start___1)) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_relative.to_boolean then
							l_p___0 := l_p___0 + (1 + ((l_p___0[1]).to_integer_32 /= 0).to_integer)
						else
							l_pos := -1 + 13 -- goto _L
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						l_tail := l_p___0 + 1
						if (l_p___0[1]).to_integer_32 /= 0 then
							from
							until
								(l_break)
							loop
								l_break := False
								if not ((create {P_MISC1_STATIC}).vim_ispathsep ((l_tail.item).to_integer_32)).to_boolean then
									l_break := True
								end
								if not (l_break) then
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_tmp___3 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_tail]))
									else
										l_tmp___3 := 1
									end
									l_tail := l_tail + l_tmp___3
								end
							end
							l_break := False
						elseif (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_start___1.c_pointer.to_integer_32).to_natural_32 then
							l_p___0 := l_p___0 - 1
						end
						memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_tail), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tail))) + {NATURAL_32} 1).do_nothing
				when 14 then -- if done | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_pos := -1 + 17 -- goto _L___4
				when 16 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 43
				when 17 then -- else: | _L___4:
						if (l_p___0[0]).to_integer_32 /= 46 then
							l_pos := -1 + 42 -- skip if block
						end
				when 18 then -- if:
						if (l_p___0[1]).to_integer_32 /= 46 then
							l_pos := -1 + 40 -- skip if block
						end
				when 19 then -- if:
						if not (((create {P_MISC1_STATIC}).vim_ispathsep ((l_p___0[2]).to_integer_32)).to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___3
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 22 then -- else:
						if (l_p___0[2]).to_integer_32 /= 0 then
							l_pos := -1 + 38 -- skip if block
						end
				when 23 then -- if: | _L___3:
						l_tail := l_p___0 + 2
						from
						until
							(l_break)
						loop
							l_break := False
							if not ((create {P_MISC1_STATIC}).vim_ispathsep ((l_tail.item).to_integer_32)).to_boolean then
								l_break := True
							end
							if not (l_break) then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___7 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_tail]))
								else
									l_tmp___7 := 1
								end
								l_tail := l_tail + l_tmp___7
							end
						end
						l_break := False
						if not (l_components > 0) then
							l_pos := -1 + 33 -- skip if block
						end
				when 24 then -- if:
						l_do_strip := 0
						if not l_stripping_disabled.to_boolean then
							l_saved_char := l_p___0[-1]
							l_p___0[-1] := (('%/0/').code).to_natural_8
							if (lstat (create {CE_INTEGER_8_POINTER}.make_cast (a_filename), l_st)) < 0 then
								l_do_strip := 1
							end
							l_p___0[-1] := l_saved_char
							l_p___0 := l_p___0 - 1
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_start___1.c_pointer.to_integer_32).to_natural_32 then
									if ((create {P_MISC2_STATIC}).after_pathsep (l_start___1, l_p___0)).to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_tmp___11 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_start___1, l_p___0 - 1])) + 1
									else
										l_tmp___11 := 1
									end
									l_p___0 := l_p___0 - l_tmp___11
								end
							end
							l_break := False
							if not l_do_strip.to_boolean then
								l_saved_char := l_tail.item
								l_tail.item := (('%/0/').code).to_natural_8
								if (stat (create {CE_INTEGER_8_POINTER}.make_cast (a_filename), l_st)) >= 0 then
									l_do_strip := 1
								else
									l_stripping_disabled := 1
								end
								l_tail.item := l_saved_char
								if l_do_strip.to_boolean then
									if l_p___0.is_equal (l_start___1) then
										if l_relative.to_boolean then
											stat (ce_string ("."), l_new_st).do_nothing
										else
											l_saved_char := l_p___0.item
											l_p___0.item := (('%/0/').code).to_natural_8
											stat (create {CE_INTEGER_8_POINTER}.make_cast (a_filename), l_new_st).do_nothing
											l_p___0.item := l_saved_char
										end
									else
										l_saved_char := l_p___0.item
										l_p___0.item := (('%/0/').code).to_natural_8
										stat (create {CE_INTEGER_8_POINTER}.make_cast (a_filename), l_new_st).do_nothing
										l_p___0.item := l_saved_char
									end
									if l_new_st.item.st_ino /= l_st.item.st_ino then
										l_do_strip := 0
									elseif l_new_st.item.st_dev /= l_st.item.st_dev then
										l_do_strip := 0
									end
								end
							end
						end
						if l_do_strip.to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_p___0 := l_tail
						l_components := 0
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 27 then -- else:
						if not (l_p___0.is_equal (l_start___1)) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if l_relative.to_boolean then
							if (l_tail[-1]).to_integer_32 = 46 then
								l_tmp___14 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___14.item := (('.').code).to_natural_8
								l_p___0.item := (('%/0/').code).to_natural_8
							else
								l_pos := -1 + 30 -- goto _L___1
							end
						else
							l_pos := -1 + 30 -- goto _L___1
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else: | _L___1:
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_start___1.c_pointer.to_integer_32).to_natural_32 then
							if (l_tail[-1]).to_integer_32 = 46 then
								l_p___0 := l_p___0 - 1
							end
						end
						memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_tail), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tail))) + {NATURAL_32} 1).do_nothing
				when 31 then
						l_components := l_components - 1
				when 32 then -- if done | if block done, skip else block:
						l_pos := -1 + 37
				when 33 then -- else:
						if not (l_p___0.is_equal (l_start___1)) then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						if not l_relative.to_boolean then
							memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_tail), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tail))) + {NATURAL_32} 1).do_nothing
						else
							l_pos := -1 + 36 -- goto _L___2
						end
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 36 then -- else: | _L___2:
						if l_p___0.is_equal (l_start___1 + 2) then
							if (l_p___0[-2]).to_integer_32 = 46 then
								memmove (create {CE_VOID_POINTER}.make_cast ((l_p___0 - 2)), create {CE_VOID_POINTER}.make_cast (l_p___0), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))) + {NATURAL_32} 1).do_nothing
								l_tail := l_tail - (2)
							end
						end
						l_p___0 := l_tail
				when 37 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 39
				when 38 then -- else:
						l_components := l_components + 1
						l_p___0 := (create {P_MISC1_STATIC}).getnextcomp (l_p___0)
				when 39 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else:
						l_components := l_components + 1
						l_p___0 := (create {P_MISC1_STATIC}).getnextcomp (l_p___0)
				when 41 then -- if done | if block done, skip else block:
						l_pos := -1 + 43
				when 42 then -- else:
						l_components := l_components + 1
						l_p___0 := (create {P_MISC1_STATIC}).getnextcomp (l_p___0)
				when 43 then -- if done | if done
						if (l_p___0.item).to_integer_32 = 0 then
							l_break := True
						end
						l_pos := -1 + 1 -- back to loop condition
				when 44 then -- loop done
					l_break := False
				when 45 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	test_for_current (a_fname, a_fname_end, a_tag_fname, a_buf_ffname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_c: INTEGER_32
			l_retval: INTEGER_32
			l_fullname: CE_POINTER [NATURAL_8]
		do
			l_retval := 0
			if not a_buf_ffname.is_void then
				l_c := (a_fname_end.item).to_integer_32
				a_fname_end.item := (('%/0/').code).to_natural_8
				l_fullname := expand_tag_fname (a_fname, a_tag_fname, 1)
				if not l_fullname.is_void then
					l_retval := (((create {P_MISC1_STATIC}).fullpathcmp (l_fullname, a_buf_ffname, 1))).bit_and (1);
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fullname))
				end
				a_fname_end.item := l_c.to_natural_8
			end
			Result := l_retval
		end

	find_extra (a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		require
			not a_pp.is_void
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str___1 := a_pp.item
				when 1 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 23 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if not ((l_str___1.item).to_integer_32 >= 48) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_str___1.item).to_integer_32 <= 57 then
							l_str___1 := (create {P_CHARSET_STATIC}).skipdigits (l_str___1)
						else
							l_pos := -1 + 5 -- goto _L___0
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 5 then -- else: | _L___0:
						if (l_str___1.item).to_integer_32 /= 47 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if (l_str___1.item).to_integer_32 /= 63 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | _L:
						l_str___1 := (create {P_REGEXP_STATIC}).skip_regexp (l_str___1 + 1, (l_str___1.item).to_integer_32, 0, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
						if (l_str___1.item).to_integer_32 /= ((a_pp.item).item).to_integer_32 then
							l_str___1 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						else
							l_str___1 := l_str___1 + 1
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_str___1 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				when 12 then -- if done | if done
						if not (l_str___1.is_void) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_break := True
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else:
						if (l_str___1.item).to_integer_32 = 59 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_break := True
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else:
						if not ((l_str___1[1]).to_integer_32 >= 48) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if not ((l_str___1[1]).to_integer_32 <= 57) then
							l_pos := -1 + 21 -- goto _L___1
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else: | _L___1:
						if (l_str___1[1]).to_integer_32 /= 47 then
							if (l_str___1[1]).to_integer_32 /= 63 then
								l_break := True
							end
						end
				when 22 then -- if done | if done
						if not (l_break) then
							l_str___1 := l_str___1 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 23 then -- loop done
					l_break := False
					if not l_str___1.is_void then
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_str___1), ce_string (";%""), (2).to_natural_32)) = 0 then
							a_pp.item := l_str___1
							Result := 1
							l_return := True
						end
					end
					if not l_return then
						Result := 0
					end
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	add_tag_field (a_dict: CE_POINTER [PD_DICTVAR_S]; a_field_name: CE_POINTER [INTEGER_8]; a_start___1, a_end: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_end: CE_POINTER [NATURAL_8]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<4_096>>)

			l_end := a_end
			l_len := 0
			if not ((create {P_EVAL_STATIC}).dict_find (a_dict, create {CE_NATURAL_8_POINTER}.make_cast (a_field_name), -1)).is_void then
				if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
					(create {P_MESSAGE_STATIC}).verbose_enter;
					(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Duplicate field name: %%s")))), a_field_name]).do_nothing;
					(create {P_MESSAGE_STATIC}).verbose_leave
				end
				Result := 0
				l_return := True
			end
			if not l_return then
				if not a_start___1.is_void then
					if l_end.is_void then
						l_end := a_start___1 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_start___1))).to_integer_32
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_end.c_pointer.to_integer_32).to_natural_32 > (a_start___1.c_pointer.to_integer_32).to_natural_32 then
								if (l_end[-1]).to_integer_32 /= 13 then
									if (l_end[-1]).to_integer_32 /= 10 then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_end := l_end - 1
							end
						end
						l_break := False
					end
					l_len := l_end.distance (a_start___1)
					if l_len > ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32).to_integer_32 - 1 then
						l_len := (({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32) - {NATURAL_32} 1).to_integer_32
					end
					(create {P_MISC2_STATIC}).vim_strncpy (l_buf___6, a_start___1, l_len.to_natural_32)
				end
				l_buf___6[l_len] := (('%/0/').code).to_natural_8
				Result := ((create {P_EVAL_STATIC}).dict_add_nr_str (a_dict, a_field_name, 0, l_buf___6))
			end
		end

	get_tags (a_list: CE_POINTER [PD_LISTVAR_S]; a_pat: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_num_matches___0: CE_ARRAY [INTEGER_32]
			l_i___0: INTEGER_32
			l_ret: INTEGER_32
			l_matches___0: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_full_fname: CE_POINTER [NATURAL_8]
			l_dict: CE_POINTER [PD_DICTVAR_S]
			l_tp: CE_ARRAY [PD_TAG_POINTERS]
			l_is_static: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_n: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_num_matches___0.make (<<1>>)
			create {CE_POINTER_ARRAY [CE_POINTER [NATURAL_8]]} l_matches___0.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_TAG_POINTERS]} l_tp.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ret := find_tags (a_pat, l_num_matches___0, l_matches___0, 12, 2_147_483_647, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					if l_ret /= 1 then
						l_pos := -1 + 30 -- skip if block
					end
				when 1 then -- if:
						if not (l_num_matches___0.item > 0) then
							l_pos := -1 + 30 -- skip if block
						end
				when 2 then -- if:
						l_i___0 := 0
				when 3 then -- loop condition:
						if not (not (l_return) and then (l_i___0 < l_num_matches___0.item)) then
							l_pos := -1 + 29 -- skip loop
						end
				when 4 then -- loop body:
						l_continue := False
						l_tp.item.parse_match (l_matches___0.item[l_i___0]).do_nothing
						l_is_static := (l_tp.item.test_for_static).to_integer_32
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_tp.item.tagname), ce_string ("!_TAG_"), (6).to_natural_32)) = 0 then
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 28 -- skip if block
						end
				when 5 then -- if:
						l_dict := (create {P_EVAL_STATIC}).dict_alloc
						if l_dict.is_void then
							l_ret := 0
						end
						if ((create {P_EVAL_STATIC}).list_append_dict (a_list, l_dict)) = 0 then
							l_ret := 0
						end
						l_full_fname := l_tp.item.tag_full_fname
						if (add_tag_field (l_dict, ce_string ("name"), l_tp.item.tagname, l_tp.item.tagname_end)) = 0 then
							l_ret := 0
						elseif (add_tag_field (l_dict, ce_string ("filename"), l_full_fname, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))) = 0 then
							l_ret := 0
						elseif (add_tag_field (l_dict, ce_string ("cmd"), l_tp.item.command, l_tp.item.command_end)) = 0 then
							l_ret := 0
						elseif (add_tag_field (l_dict, ce_string ("kind"), l_tp.item.tagkind, l_tp.item.tagkind_end)) = 0 then
							l_ret := 0
						elseif ((create {P_EVAL_STATIC}).dict_add_nr_str (l_dict, ce_string ("static"), l_is_static, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))) = 0 then
							l_ret := 0
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_full_fname))
						if (l_tp.item.command_end).is_void then
							l_pos := -1 + 27 -- skip if block
						end
				when 6 then -- if:
						l_p___0 := l_tp.item.command_end + 3
				when 7 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 26 -- skip loop
						end
				when 8 then -- loop body:
						l_break := False
						if (l_p___0.item).to_integer_32 /= 0 then
							if (l_p___0.item).to_integer_32 /= 10 then
								if (l_p___0.item).to_integer_32 = 13 then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 25 -- skip if block
						end
				when 9 then -- if:
						if not (l_p___0.is_equal (l_tp.item.tagkind)) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_p___0 := l_tp.item.tagkind_end - 1
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 12 then -- else:
						if not ((l_p___0 + 5).is_equal (l_tp.item.tagkind)) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("kind:"), (5).to_natural_32)) = 0 then
							l_p___0 := l_tp.item.tagkind_end - 1
						else
							l_pos := -1 + 15 -- goto _L___0
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else: | _L___0:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("file:"), (5).to_natural_32)) /= 0 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_p___0 := l_p___0 + (4)
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 18 then -- else:
						if ((l_p___0.item).to_integer_32 = 32) then
							l_pos := -1 + 25 -- skip if block
						end
				when 19 then -- if:
						if ((l_p___0.item).to_integer_32 = 9) then
							l_pos := -1 + 25 -- skip if block
						end
				when 20 then -- if:
						l_n := l_p___0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0.item).to_integer_32 /= 0 then
								if (l_p___0.item).to_integer_32 >= 32 then
									if (l_p___0.item).to_integer_32 < 127 then
										if (l_p___0.item).to_integer_32 = 58 then
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						l_len := l_p___0.distance (l_n)
						if (l_p___0.item).to_integer_32 /= 58 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if l_len > 0 then
							l_p___0 := l_p___0 + 1
							l_s := l_p___0
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_p___0.item).to_integer_32 /= 0 then
									if not ((l_p___0.item).to_integer_32 >= 32) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_p___0 := l_p___0 + 1
								end
							end
							l_break := False
							l_n[l_len] := (('%/0/').code).to_natural_8
							if (add_tag_field (l_dict, create {CE_INTEGER_8_POINTER}.make_cast (l_n), l_s, l_p___0)) = 0 then
								l_ret := 0
							end
							l_n[l_len] := ((':').code).to_natural_8
						else
							l_pos := -1 + 23 -- goto _L
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else: | _L:
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0.item).to_integer_32 /= 0 then
								if not ((l_p___0.item).to_integer_32 >= 32) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
				when 24 then
						if (l_p___0.item).to_integer_32 = 0 then
							l_break := True
						end
				when 25 then -- if done | if done | if done | if done | if done
						if not (l_return or l_break) then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 7 -- back to loop condition
				when 26 then -- loop done
						l_break := False
				when 27 then -- if done;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_matches___0.item[l_i___0]))
				when 28 then -- if done
						if (not l_return) then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 3 -- back to loop condition
				when 29 then -- loop done
						l_continue := False;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_matches___0.item))
				when 30 then -- if done | if done
					Result := l_ret
				when 31 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	do_tags_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent do_tags)
		end

	found_tagfile_cb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent found_tagfile_cb)
		end

end
