class
	P_VERSION_STATIC

inherit
	CE_UTILITIES
	S_LIBINTL_STATIC
	S_STRING_STATIC
	S_TIME_STATIC
	S_CTYPE_STATIC
	S_STDIO_STATIC

feature {ANY} -- public attributes

	mediumVersion: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("7.3")
		end

	longVersion: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("VIM - Vi IMproved 7.3 (2010 Aug 15, compiled Apr 28 2011 13:49:45)")
		end

	features: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("-arabic"),
					ce_string ("+autocmd"),
					ce_string ("+balloon_eval"),
					ce_string ("+browse"),
					ce_string ("+builtin_terms"),
					ce_string ("+byte_offset"),
					ce_string ("+cindent"),
					ce_string ("+clientserver"),
					ce_string ("+clipboard"),
					ce_string ("+cmdline_compl"),
					ce_string ("+cmdline_hist"),
					ce_string ("+cmdline_info"),
					ce_string ("+comments"),
					ce_string ("-conceal"),
					ce_string ("+cryptv"),
					ce_string ("-cscope"),
					ce_string ("+cursorbind"),
					ce_string ("+cursorshape"),
					ce_string ("+dialog_con_gui"),
					ce_string ("+diff"),
					ce_string ("+digraphs"),
					ce_string ("+dnd"),
					ce_string ("-ebcdic"),
					ce_string ("-emacs_tags"),
					ce_string ("+eval"),
					ce_string ("+ex_extra"),
					ce_string ("+extra_search"),
					ce_string ("-farsi"),
					ce_string ("+file_in_path"),
					ce_string ("+find_in_path"),
					ce_string ("+float"),
					ce_string ("+folding"),
					ce_string ("-footer"),
					ce_string ("+fork()"),
					ce_string ("+gettext"),
					ce_string ("-hangul_input"),
					ce_string ("+iconv"),
					ce_string ("+insert_expand"),
					ce_string ("+jumplist"),
					ce_string ("-keymap"),
					ce_string ("-langmap"),
					ce_string ("+libcall"),
					ce_string ("+linebreak"),
					ce_string ("+lispindent"),
					ce_string ("+listcmds"),
					ce_string ("+localmap"),
					ce_string ("-lua"),
					ce_string ("+menu"),
					ce_string ("+mksession"),
					ce_string ("+modify_fname"),
					ce_string ("+mouse"),
					ce_string ("+mouseshape"),
					ce_string ("-mouse_dec"),
					ce_string ("-mouse_gpm"),
					ce_string ("-mouse_jsbterm"),
					ce_string ("-mouse_netterm"),
					ce_string ("-mouse_sysmouse"),
					ce_string ("+mouse_xterm"),
					ce_string ("+multi_byte"),
					ce_string ("+multi_lang"),
					ce_string ("-mzscheme"),
					ce_string ("+netbeans_intg"),
					ce_string ("-osfiletype"),
					ce_string ("+path_extra"),
					ce_string ("-perl"),
					ce_string ("+persistent_undo"),
					ce_string ("+postscript"),
					ce_string ("+printer"),
					ce_string ("-profile"),
					ce_string ("-python"),
					ce_string ("-python3"),
					ce_string ("+quickfix"),
					ce_string ("+reltime"),
					ce_string ("-rightleft"),
					ce_string ("-ruby"),
					ce_string ("+scrollbind"),
					ce_string ("+signs"),
					ce_string ("+smartindent"),
					ce_string ("-sniff"),
					ce_string ("+startuptime"),
					ce_string ("+statusline"),
					ce_string ("-sun_workshop"),
					ce_string ("+syntax"),
					ce_string ("+tag_binary"),
					ce_string ("+tag_old_static"),
					ce_string ("-tag_any_white"),
					ce_string ("-tcl"),
					ce_string ("+terminfo"),
					ce_string ("+termresponse"),
					ce_string ("+textobjects"),
					ce_string ("+title"),
					ce_string ("+toolbar"),
					ce_string ("+user_commands"),
					ce_string ("+vertsplit"),
					ce_string ("+virtualedit"),
					ce_string ("+visual"),
					ce_string ("+visualextra"),
					ce_string ("+viminfo"),
					ce_string ("+vreplace"),
					ce_string ("+wildignore"),
					ce_string ("+wildmenu"),
					ce_string ("+windows"),
					ce_string ("+writebackup"),
					ce_string ("+X11"),
					ce_string ("-xfontset"),
					ce_string ("+xim"),
					ce_string ("+xsmp_interact"),
					ce_string ("+xterm_clipboard"),
					ce_string ("-xterm_save"),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				>>)
		end

	included_patches: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					0
				>>)
		end

	extra_patches: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				>>)
		end

	lines: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("VIM - Vi IMproved"),
					ce_string (""),
					ce_string ("version "),
					ce_string ("by Bram Moolenaar et al."),
					ce_string ("Vim is open source and freely distributable"),
					ce_string (""),
					ce_string ("Help poor children in Uganda!"),
					ce_string ("type  :help iccf<Enter>       for information "),
					ce_string (""),
					ce_string ("type  :q<Enter>               to exit         "),
					ce_string ("type  :help<Enter>  or  <F1>  for on-line help"),
					ce_string ("type  :help version7<Enter>   for version info"),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
					ce_string (""),
					ce_string ("Running in Vi compatible mode"),
					ce_string ("type  :set nocp<Enter>        for Vim defaults"),
					ce_string ("type  :help cp-default<Enter> for info on this")
				>>)
		end

	gui_lines: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
					ce_string ("menu  Help->Orphans           for information    "),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
					ce_string ("Running modeless, typed text is inserted"),
					ce_string ("menu  Edit->Global Settings->Toggle Insert Mode  "),
					ce_string ("                              for two modes      "),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
					ce_string ("menu  Edit->Global Settings->Toggle Vi Compatible"),
					ce_string ("                              for Vim defaults   ")
				>>)
		end

feature {ANY} -- public routines

	highest_patch: INTEGER_32
		local
			l_i___0: INTEGER_32
			l_h: INTEGER_32
		do
			l_h := 0
			l_i___0 := 0
			from
			until
				included_patches.item[l_i___0] = 0
			loop
				if included_patches.item[l_i___0] > l_h then
					l_h := included_patches.item[l_i___0]
				end
				l_i___0 := l_i___0 + 1
			end
			Result := l_h
		end

	has_patch (a_n: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				not (not (l_return) and then (included_patches.item[l_i___0] /= 0))
			loop
				if included_patches.item[l_i___0] = a_n then
					Result := 1
					l_return := True
				end
				if not l_return then
					l_i___0 := l_i___0 + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	list_version
		local
			l_i___0: INTEGER_32
			l_first___0: INTEGER_32
			l_s: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := ce_string ("");
					(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast (longVersion.item)).do_nothing
					if included_patches.item[0] = 0 then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:;
						(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%NIncluded patches: ")))))
						l_first___0 := -1
						l_i___0 := 0
						from
						until
							included_patches.item[l_i___0] = 0
						loop
							l_i___0 := l_i___0 + 1
						end
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_i___0 := l_i___0 - 1
						if not (l_i___0 >= 0) then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if l_first___0 < 0 then
							l_first___0 := included_patches.item[l_i___0]
						end
						if l_i___0 /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if included_patches.item[l_i___0 - 1] = included_patches.item[l_i___0] + 1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:;
						(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (l_s))
						l_s := ce_string (", ");
						(create {P_MESSAGE_STATIC}).msg_outnum (l_first___0.to_integer_32)
						if l_first___0 /= included_patches.item[l_i___0] then
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-")));
							(create {P_MESSAGE_STATIC}).msg_outnum ((included_patches.item[l_i___0]).to_integer_32)
						end
						l_first___0 := -1
				when 9 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						l_break := False
				when 11 then -- if done
					if not (extra_patches.item[0]).is_void then
						(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%NExtra patches: ")))))
						l_s := ce_string ("")
						l_i___0 := 0
						from
						until
							(extra_patches.item[l_i___0]).is_void
						loop
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (l_s))
							l_s := ce_string (", ");
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (extra_patches.item[l_i___0]))
							l_i___0 := l_i___0 + 1
						end
					end
					if ((create {P_AUTO_PATHDEF_STATIC}).compiled_user.item.item).to_integer_32 = 0 then
						l_pos := -1 + 14 -- skip if block
					end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else:
						if ((create {P_AUTO_PATHDEF_STATIC}).compiled_sys.item.item).to_integer_32 = 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L___0:;
						(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%NCompiled ")))))
						if ((create {P_AUTO_PATHDEF_STATIC}).compiled_user.item.item).to_integer_32 /= 0 then
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("by ")))));
							(create {P_MESSAGE_STATIC}).msg_puts ((create {P_AUTO_PATHDEF_STATIC}).compiled_user.item)
						end
						if ((create {P_AUTO_PATHDEF_STATIC}).compiled_sys.item.item).to_integer_32 /= 0 then
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("@")));
							(create {P_MESSAGE_STATIC}).msg_puts ((create {P_AUTO_PATHDEF_STATIC}).compiled_sys.item)
						end
				when 16 then -- if done;
					(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%NNormal version ")))));
					(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("with GTK2 GUI.")))))
					version_msg ((gettext (ce_string ("  Features included (+) or not (-):%N"))))
					l_i___0 := 0
					from
					until
						(features.item[l_i___0]).is_void
					loop
						version_msg (features.item[l_i___0])
						if (create {P_GLOBALS_STATIC}).msg_col.item > 0 then
							version_msg (ce_string (" "))
						end
						l_i___0 := l_i___0 + 1
					end
					version_msg (ce_string ("%N"))
					version_msg ((gettext (ce_string ("   system vimrc file: %""))))
					version_msg (ce_string ("$VIM/vimrc"))
					version_msg (ce_string ("%"%N"))
					version_msg ((gettext (ce_string ("     user vimrc file: %""))))
					version_msg (ce_string ("$HOME/.vimrc"))
					version_msg (ce_string ("%"%N"))
					version_msg ((gettext (ce_string ("      user exrc file: %""))))
					version_msg (ce_string ("$HOME/.exrc"))
					version_msg (ce_string ("%"%N"))
					version_msg ((gettext (ce_string ("  system gvimrc file: %""))))
					version_msg (ce_string ("$VIM/gvimrc"))
					version_msg (ce_string ("%"%N"))
					version_msg ((gettext (ce_string ("    user gvimrc file: %""))))
					version_msg (ce_string ("$HOME/.gvimrc"))
					version_msg (ce_string ("%"%N"))
					version_msg ((gettext (ce_string ("    system menu file: %""))))
					version_msg (ce_string ("$VIMRUNTIME/menu.vim"))
					version_msg (ce_string ("%"%N"))
					if ((create {P_AUTO_PATHDEF_STATIC}).default_vim_dir.item.item).to_integer_32 /= 0 then
						version_msg ((gettext (ce_string ("  fall-back for $VIM: %""))))
						version_msg (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_AUTO_PATHDEF_STATIC}).default_vim_dir.item))
						version_msg (ce_string ("%"%N"))
					end
					if ((create {P_AUTO_PATHDEF_STATIC}).default_vimruntime_dir.item.item).to_integer_32 /= 0 then
						version_msg ((gettext (ce_string (" f-b for $VIMRUNTIME: %""))))
						version_msg (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_AUTO_PATHDEF_STATIC}).default_vimruntime_dir.item))
						version_msg (ce_string ("%"%N"))
					end
					version_msg ((gettext (ce_string ("Compilation: "))))
					version_msg (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_AUTO_PATHDEF_STATIC}).all_cflags.item))
					version_msg (ce_string ("%N"))
					version_msg ((gettext (ce_string ("Linking: "))))
					version_msg (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_AUTO_PATHDEF_STATIC}).all_lflags.item))
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	version_msg (a_s: CE_POINTER [INTEGER_8])
		require
			not a_s.is_void
		local
			l_len: INTEGER_32
		do
			l_len := (strlen (a_s)).to_integer_32
			if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
				if l_len < ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32 then
					if (create {P_GLOBALS_STATIC}).msg_col.item + l_len >= ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32 then
						if (a_s[0]).to_integer_32 /= 10 then
							(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
						end
					end
				end
			end
			if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
				(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (a_s))
			end
		end

	intro_message (a_colon: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_row: INTEGER_32
			l_blanklines: INTEGER_32
			l_sponsor: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_blanklines := ((((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32).to_natural_32 - (({PLATFORM}.Pointer_bytes.to_natural_32 * (17).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32 - {NATURAL_32} 1)).to_integer_32
					if not ((create {P_OPTION_STATIC}).p_cp.item.item).to_boolean then
						l_blanklines := l_blanklines + (4)
					end
					if (create {P_OPTION_STATIC}).p_ls.item.item > 1 then
						l_blanklines := (l_blanklines.to_integer_32 - ((create {P_GLOBALS_STATIC}).Rows.item.item - ((create {P_GLOBALS_STATIC}).topframe.item.item.fr_height).to_integer_32)).to_integer_32
					end
					if l_blanklines < 0 then
						l_blanklines := 0
					end
					l_sponsor := (time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))).to_integer_32
					l_sponsor := (((l_sponsor).bit_and (2)) = 0).to_integer - (((l_sponsor).bit_and (4)) = 0).to_integer
					l_row := l_blanklines // 2
					if not (l_row >= 2) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (create {P_GLOBALS_STATIC}).Columns.item.item >= 50 then
							l_pos := -1 + 4 -- goto _L
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else: | _L___0:
						if not (a_colon.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_i___0 := 0
						from
						until
							not (not (l_break) and then (l_i___0 < (({PLATFORM}.Pointer_bytes.to_natural_32 * (17).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32))
						loop
							l_break := False
							l_continue := False
							l_p___0 := lines.item[l_i___0]
							if ((create {P_OPTION_STATIC}).p_im.item.item).to_boolean then
								if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
									if not (gui_lines.item[l_i___0]).is_void then
										l_p___0 := gui_lines.item[l_i___0]
									end
								end
							end
							if l_p___0.is_void then
								if not ((create {P_OPTION_STATIC}).p_cp.item.item).to_boolean then
									l_break := True
								end
								if not (l_break or l_continue) then
									l_continue := True
								end
							end
							if not (l_break or l_continue) then
								if l_sponsor /= 0 then
									if not (strstr (l_p___0, ce_string ("children"))).is_void then
										if l_sponsor < 0 then
											l_p___0 := ce_string ("Sponsor Vim development!")
										else
											l_p___0 := ce_string ("Become a registered Vim user!")
										end
									elseif not (strstr (l_p___0, ce_string ("iccf"))).is_void then
										if l_sponsor < 0 then
											l_p___0 := ce_string ("type  :help sponsor<Enter>    for information ")
										else
											l_p___0 := ce_string ("type  :help register<Enter>   for information ")
										end
									elseif not (strstr (l_p___0, ce_string ("Orphans"))).is_void then
										l_p___0 := ce_string ("menu  Help->Sponsor/Register  for information    ")
									end
								end
								if (l_p___0[0]).to_integer_32 /= 0 then
									do_intro_line (l_row, create {CE_NATURAL_8_POINTER}.make_cast ((gettext (l_p___0))), (l_i___0 = 2).to_integer, 0)
								end
								l_row := l_row + 1
							end
							if (not l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						l_continue := False
				when 5 then -- if done
					if a_colon.to_boolean then
						(create {P_GLOBALS_STATIC}).msg_row.item := l_row
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_intro_line (a_row: INTEGER_32; a_mesg: CE_POINTER [NATURAL_8]; a_add_version, a_attr: INTEGER_32)
		require
			not a_mesg.is_void
		local
			l_vers: CE_ARRAY [NATURAL_8]
			l_col: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_clen: INTEGER_32
			l_tmp___9: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_vers.make (<<20>>)

			l_col := (create {P_CHARSET_STATIC}).vim_strsize (a_mesg)
			if a_add_version.to_boolean then
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_vers), mediumVersion.item).do_nothing
				if (highest_patch).to_boolean then
					if ((((ctype_b_loc).item[(mediumVersion.item[3]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
						if ((((ctype_b_loc).item[(mediumVersion.item[4]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
							sprintf ([(create {CE_INTEGER_8_POINTER}.make_cast (l_vers) + 5), ce_string (".%%d%%s"), (highest_patch), mediumVersion.item + 5]).do_nothing
						else
							sprintf ([(create {CE_INTEGER_8_POINTER}.make_cast (l_vers) + 4), ce_string (".%%d%%s"), (highest_patch), mediumVersion.item + 4]).do_nothing
						end
					else
						sprintf ([(create {CE_INTEGER_8_POINTER}.make_cast (l_vers) + 3), ce_string (".%%d"), (highest_patch)]).do_nothing
					end
				end
				l_col := l_col + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_vers))).to_integer_32
			end
			l_col := (((create {P_GLOBALS_STATIC}).Columns.item.item - l_col.to_integer_32) // 2).to_integer_32
			if l_col < 0 then
				l_col := 0
			end
			l_p___0 := a_mesg
			from
			until
				not (not (l_return) and then ((l_p___0.item).to_integer_32 /= 0))
			loop
				l_clen := 0
				l_l := 0
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_p___0[l_l]).to_integer_32 /= 0 then
						if l_l /= 0 then
							if (l_p___0[l_l]).to_integer_32 /= 60 then
								if (l_p___0[(l_l - 1)]).to_integer_32 = 62 then
									l_break := True
								end
							else
								l_break := True
							end
						end
					else
						l_break := True
					end
					if not (l_break) then
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_clen := l_clen + ((create {P_CHARSET_STATIC}).ptr2cells (l_p___0 + l_l))
							l_l := l_l + (((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0 + l_l])) - 1)
						else
							l_clen := l_clen + ((create {P_CHARSET_STATIC}).byte2cells ((l_p___0[l_l]).to_integer_32))
						end
						l_l := l_l + 1
					end
				end
				l_break := False
				if (l_p___0.item).to_integer_32 = 60 then
					l_tmp___9 := (create {P_GLOBALS_STATIC}).highlight_attr.item[0]
				else
					l_tmp___9 := a_attr
				end
				(create {P_SCREEN_STATIC}).screen_puts_len (l_p___0, l_l, a_row, l_col, l_tmp___9)
				l_col := l_col + l_clen
				l_p___0 := l_p___0 + l_l
			end
			if a_add_version.to_boolean then
				(create {P_SCREEN_STATIC}).screen_puts (l_vers, a_row, l_col, 0)
			end
		end

	ex_intro (a_eap: CE_POINTER [PD_EXARG])
		do
			(create {P_SCREEN_STATIC}).screenclear
			intro_message (1);
			(create {P_MESSAGE_STATIC}).wait_return (1)
		end

feature {ANY} -- routine addresses

	ex_intro_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_intro)
		end

end
