class
	PD_ARGENTRY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} ae_fname.make
		end

feature {ANY} -- fields

	ae_fname: CE_POINTER [NATURAL_8] assign set_ae_fname

	ae_fnum: INTEGER_32 assign set_ae_fnum

feature {ANY} -- field setters

	set_ae_fname (a_ae_fname: CE_POINTER [NATURAL_8])
		do
			ae_fname := a_ae_fname
			update_memory_field ("ae_fname")
		end

	set_ae_fnum (a_ae_fnum: INTEGER_32)
		do
			ae_fnum := a_ae_fnum
			update_memory_field ("ae_fnum")
		end

feature {ANY} -- public routines

	alist_name: CE_POINTER [NATURAL_8]
		local
			l_bp___0: CE_POINTER [PD_FILE_BUFFER]
			l_return: BOOLEAN
		do
			l_bp___0 := (create {P_BUFFER_STATIC}).buflist_findnr (ae_fnum)
			update_class_fields -- Current might have been changed; synchronize
			if l_bp___0.is_void then
				Result := ae_fname
				l_return := True
			elseif (l_bp___0.item.b_fname).is_void then
				Result := ae_fname
				l_return := True
			end
			if not l_return then
				Result := (l_bp___0.item.b_fname)
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ae_fname := a_other.ae_fname
			ae_fnum := a_other.ae_fnum
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ae_fname.is_equal (a_other.ae_fname) and
				ae_fnum = a_other.ae_fnum
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ae_fname"),
					create {CE_STRUCTURE_FIELD}.make ("ae_fnum")
				>>)
			init_structure_info
		end

end
