class
	PD_AUTOCMD

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} cmd.make
			create {CE_CLASS_POINTER [PD_AUTOCMD]} next.make
		end

feature {ANY} -- fields

	cmd: CE_POINTER [NATURAL_8] assign set_cmd

	nested: INTEGER_8 assign set_nested

	last: INTEGER_8 assign set_last

	scriptID: INTEGER_32 assign set_scriptID

	next: CE_POINTER [PD_AUTOCMD] assign set_next

feature {ANY} -- field setters

	set_cmd (a_cmd: CE_POINTER [NATURAL_8])
		do
			cmd := a_cmd
			update_memory_field ("cmd")
		end

	set_nested (a_nested: INTEGER_8)
		do
			nested := a_nested
			update_memory_field ("nested")
		end

	set_last (a_last: INTEGER_8)
		do
			last := a_last
			update_memory_field ("last")
		end

	set_scriptID (a_scriptID: INTEGER_32)
		do
			scriptID := a_scriptID
			update_memory_field ("scriptID")
		end

	set_next (a_next: CE_POINTER [PD_AUTOCMD])
		do
			next := a_next
			update_memory_field ("next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			cmd := a_other.cmd
			nested := a_other.nested
			last := a_other.last
			scriptID := a_other.scriptID
			next := a_other.next
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				cmd.is_equal (a_other.cmd) and
				nested = a_other.nested and
				last = a_other.last and
				scriptID = a_other.scriptID and
				next.is_equal (a_other.next)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("cmd"),
					create {CE_STRUCTURE_FIELD}.make ("nested"),
					create {CE_STRUCTURE_FIELD}.make ("last"),
					create {CE_STRUCTURE_FIELD}.make ("scriptID"),
					create {CE_STRUCTURE_FIELD}.make ("next")
				>>)
			init_structure_info
		end

end
