class
	PD_AUTOPATCMD

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_AUTOPAT]} curpat.make
			create {CE_CLASS_POINTER [PD_AUTOCMD]} nextcmd.make
			create {CE_NATURAL_8_POINTER} fname.make
			create {CE_NATURAL_8_POINTER} sfname.make
			create {CE_NATURAL_8_POINTER} tail.make
			create {CE_CLASS_POINTER [PD_AUTOPATCMD]} next.make
			Precursor
		end

feature {ANY} -- fields

	curpat: CE_POINTER [PD_AUTOPAT] assign set_curpat

	nextcmd: CE_POINTER [PD_AUTOCMD] assign set_nextcmd

	group: INTEGER_32 assign set_group

	fname: CE_POINTER [NATURAL_8] assign set_fname

	sfname: CE_POINTER [NATURAL_8] assign set_sfname

	tail: CE_POINTER [NATURAL_8] assign set_tail

	event: NATURAL_32 assign set_event

	arg_bufnr: INTEGER_32 assign set_arg_bufnr

	next: CE_POINTER [PD_AUTOPATCMD] assign set_next

feature {ANY} -- field setters

	set_curpat (a_curpat: CE_POINTER [PD_AUTOPAT])
		do
			curpat := a_curpat
			update_memory_field ("curpat")
		end

	set_nextcmd (a_nextcmd: CE_POINTER [PD_AUTOCMD])
		do
			nextcmd := a_nextcmd
			update_memory_field ("nextcmd")
		end

	set_group (a_group: INTEGER_32)
		do
			group := a_group
			update_memory_field ("group")
		end

	set_fname (a_fname: CE_POINTER [NATURAL_8])
		do
			fname := a_fname
			update_memory_field ("fname")
		end

	set_sfname (a_sfname: CE_POINTER [NATURAL_8])
		do
			sfname := a_sfname
			update_memory_field ("sfname")
		end

	set_tail (a_tail: CE_POINTER [NATURAL_8])
		do
			tail := a_tail
			update_memory_field ("tail")
		end

	set_event (a_event: NATURAL_32)
		do
			event := a_event
			update_memory_field ("event")
		end

	set_arg_bufnr (a_arg_bufnr: INTEGER_32)
		do
			arg_bufnr := a_arg_bufnr
			update_memory_field ("arg_bufnr")
		end

	set_next (a_next: CE_POINTER [PD_AUTOPATCMD])
		do
			next := a_next
			update_memory_field ("next")
		end

feature {ANY} -- public routines

	auto_next_pat (a_stop_at_last: INTEGER_32)
		local
			l_ap___0: CE_POINTER [PD_AUTOPAT]
			l_cp: CE_POINTER [PD_AUTOCMD]
			l_name___1: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [INTEGER_8]
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).sourcing_name.item))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GLOBALS_STATIC}).sourcing_name.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					l_ap___0 := curpat
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if not l_ap___0.is_void then
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						Current.curpat := create {CE_CLASS_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						if (l_ap___0.item.pat).is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						if (l_ap___0.item.cmds).is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if group /= -3 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if group /= l_ap___0.item.group then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if l_ap___0.item.buflocal_nr = 0 then
							l_tmp___2 := (create {P_FILEIO_STATIC}).match_file_pat (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_ap___0.item.reg_prog, fname, sfname, tail, (l_ap___0.item.allow_dirs).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___3 := l_tmp___2
						else
							l_tmp___3 := (l_ap___0.item.buflocal_nr = arg_bufnr).to_integer
						end
						if l_tmp___3.to_boolean then
							l_name___1 := (create {P_FILEIO_STATIC}).event_nr2name (event)
							update_class_fields -- Current might have been changed; synchronize
							l_s := gettext (ce_string ("%%s Auto commands for %"%%s%""))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp := strlen (l_s)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_name___1))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).sourcing_name.item := (create {P_MISC2_STATIC}).alloc (((l_tmp + l_tmp___0) + (l_ap___0.item.patlen).to_natural_32) + {NATURAL_32} 1)
							update_class_fields -- Current might have been changed; synchronize
							if not ((create {P_GLOBALS_STATIC}).sourcing_name.item).is_void then
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).sourcing_name.item), l_s, create {CE_INTEGER_8_POINTER}.make_cast (l_name___1), create {CE_INTEGER_8_POINTER}.make_cast (l_ap___0.item.pat)]).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								if (create {P_OPTION_STATIC}).p_verbose.item.item >= 8 then
									(create {P_MESSAGE_STATIC}).verbose_enter
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___1 := gettext (ce_string ("Executing %%s"))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1), (create {P_GLOBALS_STATIC}).sourcing_name.item]).do_nothing
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MESSAGE_STATIC}).verbose_leave
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							Current.curpat := l_ap___0
							update_class_fields -- Current might have been changed; synchronize
							Current.nextcmd := l_ap___0.item.cmds
							update_class_fields -- Current might have been changed; synchronize
							l_cp := l_ap___0.item.cmds
							from
							until
								(l_cp.item.next).is_void
							loop
								l_cp.item.last := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_cp := l_cp.item.next
							end
							l_cp.item.last := (1).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_MISC1_STATIC}).line_breakcheck
						update_class_fields -- Current might have been changed; synchronize
						if not curpat.is_void then
							l_break := True
						end
				when 10 then -- if done | if done | if done | if done
						if not (l_return or l_break) and then (a_stop_at_last.to_boolean) then
							if (l_ap___0.item.last).to_boolean then
								l_break := True
							end
						end
						if not (l_return or l_break) then
							l_ap___0 := l_ap___0.item.next
						end
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
					l_break := False
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			curpat := a_other.curpat
			nextcmd := a_other.nextcmd
			group := a_other.group
			fname := a_other.fname
			sfname := a_other.sfname
			tail := a_other.tail
			event := a_other.event
			arg_bufnr := a_other.arg_bufnr
			next := a_other.next
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				curpat.is_equal (a_other.curpat) and
				nextcmd.is_equal (a_other.nextcmd) and
				group = a_other.group and
				fname.is_equal (a_other.fname) and
				sfname.is_equal (a_other.sfname) and
				tail.is_equal (a_other.tail) and
				event = a_other.event and
				arg_bufnr = a_other.arg_bufnr and
				next.is_equal (a_other.next)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("curpat"),
					create {CE_STRUCTURE_FIELD}.make ("nextcmd"),
					create {CE_STRUCTURE_FIELD}.make ("group"),
					create {CE_STRUCTURE_FIELD}.make ("fname"),
					create {CE_STRUCTURE_FIELD}.make ("sfname"),
					create {CE_STRUCTURE_FIELD}.make ("tail"),
					create {CE_STRUCTURE_FIELD}.make ("event"),
					create {CE_STRUCTURE_FIELD}.make ("arg_bufnr"),
					create {CE_STRUCTURE_FIELD}.make ("next")
				>>)
			init_structure_info
		end

end
