class
	PD_BACKPOS_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} bp_scan.make
			create bp_pos.make
		end

feature {ANY} -- fields

	bp_scan: CE_POINTER [NATURAL_8] assign set_bp_scan

	bp_pos: PD_REGSAVE_T assign set_bp_pos

feature {ANY} -- field setters

	set_bp_scan (a_bp_scan: CE_POINTER [NATURAL_8])
		do
			bp_scan := a_bp_scan
			update_memory_field ("bp_scan")
		end

	set_bp_pos (a_bp_pos: PD_REGSAVE_T)
		do
			bp_pos := a_bp_pos
			update_memory_field ("bp_pos")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			bp_scan := a_other.bp_scan
			bp_pos := a_other.bp_pos.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				bp_scan.is_equal (a_other.bp_scan) and
				bp_pos.is_equal (a_other.bp_pos)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("bp_scan"),
					create {CE_STRUCTURE_FIELD}.make ("bp_pos")
				>>)
			init_structure_info
		end

end
