class
	PD_CMDQUEUE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} buffer.make
			create {CE_CLASS_POINTER [PD_CMDQUEUE]} next.make
			create {CE_CLASS_POINTER [PD_CMDQUEUE]} prev.make
		end

feature {ANY} -- fields

	buffer: CE_POINTER [NATURAL_8] assign set_buffer

	next: CE_POINTER [PD_CMDQUEUE] assign set_next

	prev: CE_POINTER [PD_CMDQUEUE] assign set_prev

feature {ANY} -- field setters

	set_buffer (a_buffer: CE_POINTER [NATURAL_8])
		do
			buffer := a_buffer
			update_memory_field ("buffer")
		end

	set_next (a_next: CE_POINTER [PD_CMDQUEUE])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_CMDQUEUE])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			buffer := a_other.buffer
			next := a_other.next
			prev := a_other.prev
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				buffer.is_equal (a_other.buffer) and
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("buffer"),
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev")
				>>)
			init_structure_info
		end

end
