class
	PD_DEBUGGY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} dbg_name.make
			create {CE_CLASS_POINTER [PD_REGPROG_T]} dbg_prog.make
		end

feature {ANY} -- fields

	dbg_nr: INTEGER_32 assign set_dbg_nr

	dbg_type: INTEGER_32 assign set_dbg_type

	dbg_name: CE_POINTER [NATURAL_8] assign set_dbg_name

	dbg_prog: CE_POINTER [PD_REGPROG_T] assign set_dbg_prog

	dbg_lnum: INTEGER_32 assign set_dbg_lnum

	dbg_forceit: INTEGER_32 assign set_dbg_forceit

feature {ANY} -- field setters

	set_dbg_nr (a_dbg_nr: INTEGER_32)
		do
			dbg_nr := a_dbg_nr
			update_memory_field ("dbg_nr")
		end

	set_dbg_type (a_dbg_type: INTEGER_32)
		do
			dbg_type := a_dbg_type
			update_memory_field ("dbg_type")
		end

	set_dbg_name (a_dbg_name: CE_POINTER [NATURAL_8])
		do
			dbg_name := a_dbg_name
			update_memory_field ("dbg_name")
		end

	set_dbg_prog (a_dbg_prog: CE_POINTER [PD_REGPROG_T])
		do
			dbg_prog := a_dbg_prog
			update_memory_field ("dbg_prog")
		end

	set_dbg_lnum (a_dbg_lnum: INTEGER_32)
		do
			dbg_lnum := a_dbg_lnum
			update_memory_field ("dbg_lnum")
		end

	set_dbg_forceit (a_dbg_forceit: INTEGER_32)
		do
			dbg_forceit := a_dbg_forceit
			update_memory_field ("dbg_forceit")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			dbg_nr := a_other.dbg_nr
			dbg_type := a_other.dbg_type
			dbg_name := a_other.dbg_name
			dbg_prog := a_other.dbg_prog
			dbg_lnum := a_other.dbg_lnum
			dbg_forceit := a_other.dbg_forceit
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				dbg_nr = a_other.dbg_nr and
				dbg_type = a_other.dbg_type and
				dbg_name.is_equal (a_other.dbg_name) and
				dbg_prog.is_equal (a_other.dbg_prog) and
				dbg_lnum = a_other.dbg_lnum and
				dbg_forceit = a_other.dbg_forceit
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("dbg_nr"),
					create {CE_STRUCTURE_FIELD}.make ("dbg_type"),
					create {CE_STRUCTURE_FIELD}.make ("dbg_name"),
					create {CE_STRUCTURE_FIELD}.make ("dbg_prog"),
					create {CE_STRUCTURE_FIELD}.make ("dbg_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("dbg_forceit")
				>>)
			init_structure_info
		end

end
