class
	PD_DECOMP_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	a: INTEGER_32 assign set_a

	b: INTEGER_32 assign set_b

	c: INTEGER_32 assign set_c

feature {ANY} -- field setters

	set_a (a_a: INTEGER_32)
		do
			a := a_a
			update_memory_field ("a")
		end

	set_b (a_b: INTEGER_32)
		do
			b := a_b
			update_memory_field ("b")
		end

	set_c (a_c: INTEGER_32)
		do
			c := a_c
			update_memory_field ("c")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			a := a_other.a
			b := a_other.b
			c := a_other.c
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				a = a_other.a and
				b = a_other.b and
				c = a_other.c
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("a"),
					create {CE_STRUCTURE_FIELD}.make ("b"),
					create {CE_STRUCTURE_FIELD}.make ("c")
				>>)
			init_structure_info
		end

end
