class
	PD_DICTVAR_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create dv_hashtab.make
			create {CE_CLASS_POINTER [PD_DICTVAR_S]} dv_copydict.make
			create {CE_CLASS_POINTER [PD_DICTVAR_S]} dv_used_next.make
			create {CE_CLASS_POINTER [PD_DICTVAR_S]} dv_used_prev.make
		end

feature {ANY} -- fields

	dv_refcount: INTEGER_32 assign set_dv_refcount

	dv_hashtab: PD_HASHTABLE_S assign set_dv_hashtab

	dv_copyID: INTEGER_32 assign set_dv_copyID

	dv_copydict: CE_POINTER [PD_DICTVAR_S] assign set_dv_copydict

	dv_lock: INTEGER_8 assign set_dv_lock

	dv_used_next: CE_POINTER [PD_DICTVAR_S] assign set_dv_used_next

	dv_used_prev: CE_POINTER [PD_DICTVAR_S] assign set_dv_used_prev

feature {ANY} -- field setters

	set_dv_refcount (a_dv_refcount: INTEGER_32)
		do
			dv_refcount := a_dv_refcount
			update_memory_field ("dv_refcount")
		end

	set_dv_hashtab (a_dv_hashtab: PD_HASHTABLE_S)
		do
			dv_hashtab := a_dv_hashtab
			update_memory_field ("dv_hashtab")
		end

	set_dv_copyID (a_dv_copyID: INTEGER_32)
		do
			dv_copyID := a_dv_copyID
			update_memory_field ("dv_copyID")
		end

	set_dv_copydict (a_dv_copydict: CE_POINTER [PD_DICTVAR_S])
		do
			dv_copydict := a_dv_copydict
			update_memory_field ("dv_copydict")
		end

	set_dv_lock (a_dv_lock: INTEGER_8)
		do
			dv_lock := a_dv_lock
			update_memory_field ("dv_lock")
		end

	set_dv_used_next (a_dv_used_next: CE_POINTER [PD_DICTVAR_S])
		do
			dv_used_next := a_dv_used_next
			update_memory_field ("dv_used_next")
		end

	set_dv_used_prev (a_dv_used_prev: CE_POINTER [PD_DICTVAR_S])
		do
			dv_used_prev := a_dv_used_prev
			update_memory_field ("dv_used_prev")
		end

feature {ANY} -- public routines

	dict_free (a_recurse___2: INTEGER_32)
		local
			l_todo: INTEGER_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_di: CE_POINTER [PD_DICTITEM_S]
		do
			if dv_used_prev.is_void then
				(create {P_EVAL_STATIC}).first_dict.item := dv_used_next
				update_class_fields -- Current might have been changed; synchronize
			else
				dv_used_prev.item.dv_used_next := dv_used_next
				update_class_fields -- Current might have been changed; synchronize
			end
			if not dv_used_next.is_void then
				dv_used_next.item.dv_used_prev := dv_used_prev
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_DICTVAR_S}.make).offset_of ("dv_hashtab"))).item.hash_lock
			update_class_fields -- Current might have been changed; synchronize
			l_todo := (dv_hashtab.ht_used).to_integer_32
			l_hi___1 := dv_hashtab.ht_array
			from
			until
				not (l_todo > 0)
			loop
				if not ((l_hi___1.item.hi_key).is_void) then
					if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
						l_di := create {CE_CLASS_POINTER [PD_DICTITEM_S]}.make_cast ((l_hi___1.item.hi_key - (((create {P_EVAL_STATIC}).dumdi.item.item.di_key).distance ((create {CE_NATURAL_8_POINTER}.make_cast (((create {P_EVAL_STATIC}).dumdi.item)))))));
						(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_DICTVAR_S}.make).offset_of ("dv_hashtab"))).item.hash_remove (l_hi___1)
						update_class_fields -- Current might have been changed; synchronize
						if a_recurse___2.to_boolean then
							(create {P_EVAL_STATIC}).clear_tv (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (l_di.c_pointer + (create {PD_DICTITEM_S}.make).offset_of ("di_tv")))
							update_class_fields -- Current might have been changed; synchronize
						elseif (l_di.item.di_tv.v_type).to_integer_32 /= 4 then
							if (l_di.item.di_tv.v_type).to_integer_32 /= 5 then
								(create {P_EVAL_STATIC}).clear_tv (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (l_di.c_pointer + (create {PD_DICTITEM_S}.make).offset_of ("di_tv")))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_di))
						update_class_fields -- Current might have been changed; synchronize
						l_todo := l_todo - 1
					end
				end
				l_hi___1 := l_hi___1 + 1
			end
			(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_DICTVAR_S}.make).offset_of ("dv_hashtab"))).item.hash_clear
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	init_var_dict (a_dict_var: CE_POINTER [PD_DICTITEM_S])
		require
			not a_dict_var.is_void
		do
			(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_DICTVAR_S}.make).offset_of ("dv_hashtab"))).item.hash_init
			update_class_fields -- Current might have been changed; synchronize
			Current.dv_refcount := 99_999
			update_class_fields -- Current might have been changed; synchronize
			Current.dv_copyID := 0
			update_class_fields -- Current might have been changed; synchronize
			a_dict_var.item.di_tv.vval.v_dict := (create {CE_CLASS_POINTER [PD_DICTVAR_S]}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
			a_dict_var.item.di_tv.v_type := (5).to_integer_8
			update_class_fields -- Current might have been changed; synchronize
			a_dict_var.item.di_tv.v_lock := (2).to_integer_8
			update_class_fields -- Current might have been changed; synchronize
			a_dict_var.item.di_flags := (5).to_natural_8
			update_class_fields -- Current might have been changed; synchronize
			a_dict_var.item.di_key[0] := (('%/0/').code).to_natural_8
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			dv_refcount := a_other.dv_refcount
			dv_hashtab := a_other.dv_hashtab.twin
			dv_copyID := a_other.dv_copyID
			dv_copydict := a_other.dv_copydict
			dv_lock := a_other.dv_lock
			dv_used_next := a_other.dv_used_next
			dv_used_prev := a_other.dv_used_prev
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				dv_refcount = a_other.dv_refcount and
				dv_hashtab.is_equal (a_other.dv_hashtab) and
				dv_copyID = a_other.dv_copyID and
				dv_copydict.is_equal (a_other.dv_copydict) and
				dv_lock = a_other.dv_lock and
				dv_used_next.is_equal (a_other.dv_used_next) and
				dv_used_prev.is_equal (a_other.dv_used_prev)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("dv_refcount"),
					create {CE_STRUCTURE_FIELD}.make ("dv_hashtab"),
					create {CE_STRUCTURE_FIELD}.make ("dv_copyID"),
					create {CE_STRUCTURE_FIELD}.make ("dv_copydict"),
					create {CE_STRUCTURE_FIELD}.make ("dv_lock"),
					create {CE_STRUCTURE_FIELD}.make ("dv_used_next"),
					create {CE_STRUCTURE_FIELD}.make ("dv_used_prev")
				>>)
			init_structure_info
		end

end
