class
	PD_DIR_STACK_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_DIR_STACK_T]} next.make
			create {CE_NATURAL_8_POINTER} dirname.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_DIR_STACK_T] assign set_next

	dirname: CE_POINTER [NATURAL_8] assign set_dirname

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_DIR_STACK_T])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_dirname (a_dirname: CE_POINTER [NATURAL_8])
		do
			dirname := a_dirname
			update_memory_field ("dirname")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			dirname := a_other.dirname
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				dirname.is_equal (a_other.dirname)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("dirname")
				>>)
			init_structure_info
		end

end
