class
	PD_EFM_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_REGPROG_T]} prog.make
			create {CE_CLASS_POINTER [PD_EFM_S]} next.make
			create {CE_NATURAL_8_ARRAY} addr.make (<<10>>)
		end

feature {ANY} -- fields

	prog: CE_POINTER [PD_REGPROG_T] assign set_prog

	next: CE_POINTER [PD_EFM_S] assign set_next

	addr: CE_ARRAY [NATURAL_8]

	prefix2: NATURAL_8 assign set_prefix2

	flags: NATURAL_8 assign set_flags

	conthere: INTEGER_32 assign set_conthere

feature {ANY} -- field setters

	set_prog (a_prog: CE_POINTER [PD_REGPROG_T])
		do
			prog := a_prog
			update_memory_field ("prog")
		end

	set_next (a_next: CE_POINTER [PD_EFM_S])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prefix2 (a_prefix2: NATURAL_8)
		do
			prefix2 := a_prefix2
			update_memory_field ("prefix2")
		end

	set_flags (a_flags: NATURAL_8)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_conthere (a_conthere: INTEGER_32)
		do
			conthere := a_conthere
			update_memory_field ("conthere")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			prog := a_other.prog
			next := a_other.next
			addr := a_other.addr.twin
			prefix2 := a_other.prefix2
			flags := a_other.flags
			conthere := a_other.conthere
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				prog.is_equal (a_other.prog) and
				next.is_equal (a_other.next) and
				addr.is_equal (a_other.addr) and
				prefix2 = a_other.prefix2 and
				flags = a_other.flags and
				conthere = a_other.conthere
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("prog"),
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("addr", <<10>>),
					create {CE_STRUCTURE_FIELD}.make ("prefix2"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("conthere")
				>>)
			init_structure_info
		end

end
