class
	PD_FLINE_T

inherit
	PD_FLINE_T_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_WINDOW_S]} wp.make
			Precursor
		end

feature {ANY} -- fields

	wp: CE_POINTER [PD_WINDOW_S] assign set_wp

	lnum: INTEGER_32 assign set_lnum

	off: INTEGER_32 assign set_off

	lnum_save: INTEGER_32 assign set_lnum_save

	lvl: INTEGER_32 assign set_lvl

	lvl_next: INTEGER_32 assign set_lvl_next

	start: INTEGER_32 assign set_start

	end2: INTEGER_32 assign set_end2

	had_end: INTEGER_32 assign set_had_end

feature {ANY} -- field setters

	set_wp (a_wp: CE_POINTER [PD_WINDOW_S])
		do
			wp := a_wp
			update_memory_field ("wp")
		end

	set_lnum (a_lnum: INTEGER_32)
		do
			lnum := a_lnum
			update_memory_field ("lnum")
		end

	set_off (a_off: INTEGER_32)
		do
			off := a_off
			update_memory_field ("off")
		end

	set_lnum_save (a_lnum_save: INTEGER_32)
		do
			lnum_save := a_lnum_save
			update_memory_field ("lnum_save")
		end

	set_lvl (a_lvl: INTEGER_32)
		do
			lvl := a_lvl
			update_memory_field ("lvl")
		end

	set_lvl_next (a_lvl_next: INTEGER_32)
		do
			lvl_next := a_lvl_next
			update_memory_field ("lvl_next")
		end

	set_start (a_start: INTEGER_32)
		do
			start := a_start
			update_memory_field ("start")
		end

	set_end2 (a_end2: INTEGER_32)
		do
			end2 := a_end2
			update_memory_field ("end2")
		end

	set_had_end (a_had_end: INTEGER_32)
		do
			had_end := a_had_end
			update_memory_field ("had_end")
		end

feature {ANY} -- public routines

	foldlevelIndent
		local
			l_s: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_lnum: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := lnum + off
					l_buf___6 := wp.item.w_buffer
					l_tmp := l_buf___6.item.ml_get_buf (l_lnum, 0)
					update_class_fields -- Current might have been changed; synchronize
					l_s := (create {P_CHARSET_STATIC}).skipwhite (l_tmp)
					update_class_fields -- Current might have been changed; synchronize
					if (l_s.item).to_integer_32 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						l_tmp___1 := (create {P_MISC2_STATIC}).vim_strchr (wp.item.w_onebuf_opt.wo_fdi, (l_s.item).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1.is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if l_lnum = 1 then
							Current.lvl := 0
							update_class_fields -- Current might have been changed; synchronize
						elseif l_lnum = l_buf___6.item.b_ml.ml_line_count then
							Current.lvl := 0
							update_class_fields -- Current might have been changed; synchronize
						else
							Current.lvl := -1
							update_class_fields -- Current might have been changed; synchronize
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tmp___0 := get_indent_buf (l_buf___6, l_lnum)
						update_class_fields -- Current might have been changed; synchronize
						Current.lvl := (l_tmp___0.to_integer_32 // l_buf___6.item.b_p_sw).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
				when 7 then -- if done
					if lvl.to_integer_32 > wp.item.w_onebuf_opt.wo_fdn then
						Current.lvl := (wp.item.w_onebuf_opt.wo_fdn).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						if lvl < 0 then
							Current.lvl := 0
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	foldlevelDiff
		local
			l_tmp: INTEGER_32
		do
			l_tmp := diff_infold (wp, lnum + off)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				Current.lvl := 1
				update_class_fields -- Current might have been changed; synchronize
			else
				Current.lvl := 0
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	foldlevelExpr
		local
			l_win: CE_POINTER [PD_WINDOW_S]
			l_n: INTEGER_32
			l_c: CE_ARRAY [INTEGER_32]
			l_lnum: INTEGER_32
			l_save_keytyped: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_c.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := lnum + off
					l_win := (create {P_GLOBALS_STATIC}).curwin.item;
					(create {P_GLOBALS_STATIC}).curwin.item := wp
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GLOBALS_STATIC}).curbuf.item := wp.item.w_buffer
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_EVAL_STATIC}).set_vim_var_nr (9, l_lnum)
					update_class_fields -- Current might have been changed; synchronize
					Current.start := 0
					update_class_fields -- Current might have been changed; synchronize
					Current.had_end := end2
					update_class_fields -- Current might have been changed; synchronize
					Current.end2 := 21
					update_class_fields -- Current might have been changed; synchronize
					if l_lnum <= 1 then
						Current.lvl := 0
						update_class_fields -- Current might have been changed; synchronize
					end
					l_save_keytyped := (create {P_GLOBALS_STATIC}).KeyTyped.item
					l_n := eval_foldexpr (wp.item.w_onebuf_opt.wo_fde, l_c)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GLOBALS_STATIC}).KeyTyped.item := l_save_keytyped
					update_class_fields -- Current might have been changed; synchronize
					inspect l_c.item -- switch 1 head
					when 97 then l_pos := -1 + 1
					when 115 then l_pos := -1 + 2
					when 62 then l_pos := -1 + 3
					when 60 then l_pos := -1 + 4
					when 61 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 97
					if lvl >= 0 then
						Current.lvl := lvl + l_n
						update_class_fields -- Current might have been changed; synchronize
						Current.lvl_next := lvl
						update_class_fields -- Current might have been changed; synchronize
					end
					Current.start := l_n
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 7 -- switch 1; break
				when 2 then -- switch 1, case 115
					if lvl >= 0 then
						if l_n > lvl then
							Current.lvl_next := 0
							update_class_fields -- Current might have been changed; synchronize
						else
							Current.lvl_next := lvl - l_n
							update_class_fields -- Current might have been changed; synchronize
						end
						Current.end2 := lvl_next + 1
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 7 -- switch 1; break
				when 3 then -- switch 1, case 62
					Current.lvl := l_n
					update_class_fields -- Current might have been changed; synchronize
					Current.lvl_next := l_n
					update_class_fields -- Current might have been changed; synchronize
					Current.start := 1
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 60
					Current.lvl_next := l_n - 1
					update_class_fields -- Current might have been changed; synchronize
					Current.end2 := l_n
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 61
					Current.lvl_next := lvl
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
					if l_n < 0 then
						Current.lvl_next := lvl
						update_class_fields -- Current might have been changed; synchronize
					else
						Current.lvl_next := l_n
						update_class_fields -- Current might have been changed; synchronize
					end
					Current.lvl := l_n
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
					if lvl < 0 then
						if l_lnum <= 1 then
							Current.lvl := 0
							update_class_fields -- Current might have been changed; synchronize
							Current.lvl_next := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_lnum = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							Current.lvl_next := 0
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					(create {P_GLOBALS_STATIC}).curwin.item := l_win
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
					update_class_fields -- Current might have been changed; synchronize
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	foldlevelMarker
		local
			l_startmarker: CE_POINTER [NATURAL_8]
			l_cstart: INTEGER_32
			l_cend: INTEGER_32
			l_start_lvl: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_start_lvl := lvl
					l_startmarker := wp.item.w_onebuf_opt.wo_fmr
					l_cstart := (l_startmarker.item).to_integer_32
					l_startmarker := l_startmarker + 1
					l_cend := ((create {P_FOLD_STATIC}).foldendmarker.item.item).to_integer_32
					Current.start := 0
					update_class_fields -- Current might have been changed; synchronize
					Current.lvl_next := lvl
					update_class_fields -- Current might have been changed; synchronize
					l_s := (wp.item.w_buffer).item.ml_get_buf (lnum + off, 0)
					update_class_fields -- Current might have been changed; synchronize
				when 1 then -- loop condition:
					if not ((l_s.item).to_boolean) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						if (l_s.item).to_integer_32 /= l_cstart then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_tmp___2 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_s + 1)), create {CE_INTEGER_8_POINTER}.make_cast (l_startmarker), ((create {P_FOLD_STATIC}).foldstartmarkerlen.item - 1).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2 = 0 then
							l_s := l_s + ((create {P_FOLD_STATIC}).foldstartmarkerlen.item)
							if (l_s.item).to_integer_32 >= 48 then
								if (l_s.item).to_integer_32 <= 57 then
									l_n := atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_s))
									update_class_fields -- Current might have been changed; synchronize
									if l_n > 0 then
										Current.lvl := l_n
										update_class_fields -- Current might have been changed; synchronize
										Current.lvl_next := l_n
										update_class_fields -- Current might have been changed; synchronize
										if l_n <= l_start_lvl then
											Current.start := 1
											update_class_fields -- Current might have been changed; synchronize
										else
											Current.start := l_n - l_start_lvl
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								else
									Current.lvl := lvl + 1
									update_class_fields -- Current might have been changed; synchronize
									Current.lvl_next := lvl_next + 1
									update_class_fields -- Current might have been changed; synchronize
									Current.start := start + 1
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								Current.lvl := lvl + 1
								update_class_fields -- Current might have been changed; synchronize
								Current.lvl_next := lvl_next + 1
								update_class_fields -- Current might have been changed; synchronize
								Current.start := start + 1
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_pos := -1 + 5 -- goto _L___0
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else: | _L___0:
						if (l_s.item).to_integer_32 /= l_cend then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_tmp___1 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_s + 1)), create {CE_INTEGER_8_POINTER}.make_cast (((create {P_FOLD_STATIC}).foldendmarker.item + 1)), ((create {P_FOLD_STATIC}).foldendmarkerlen.item - 1).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1 = 0 then
							l_s := l_s + ((create {P_FOLD_STATIC}).foldendmarkerlen.item)
							if (l_s.item).to_integer_32 >= 48 then
								if (l_s.item).to_integer_32 <= 57 then
									l_n := atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_s))
									update_class_fields -- Current might have been changed; synchronize
									if l_n > 0 then
										Current.lvl := l_n
										update_class_fields -- Current might have been changed; synchronize
										Current.lvl_next := l_n - 1
										update_class_fields -- Current might have been changed; synchronize
										if lvl_next > l_start_lvl then
											Current.lvl_next := l_start_lvl
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								else
									Current.lvl_next := lvl_next - 1
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								Current.lvl_next := lvl_next - 1
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s])
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___0 := l_tmp
						else
							l_tmp___0 := 1
						end
						l_s := l_s + l_tmp___0
				when 9 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					if lvl_next < 0 then
						Current.lvl_next := 0
						update_class_fields -- Current might have been changed; synchronize
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	foldlevelSyntax
		local
			l_lnum: INTEGER_32
			l_n: INTEGER_32
		do
			l_lnum := lnum + off
			Current.lvl := syn_get_foldlevel (wp, l_lnum)
			update_class_fields -- Current might have been changed; synchronize
			Current.start := 0
			update_class_fields -- Current might have been changed; synchronize
			if l_lnum < (wp.item.w_buffer).item.b_ml.ml_line_count then
				l_n := syn_get_foldlevel (wp, l_lnum + 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_n > lvl then
					Current.start := l_n - lvl
					update_class_fields -- Current might have been changed; synchronize
					Current.lvl := l_n
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

feature {PD_FLINE_T} -- private routines

	diff_infold (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32): INTEGER_32
		require
			not a_wp___0.is_void
		local
			l_i___0: INTEGER_32
			l_idx: INTEGER_32
			l_other: INTEGER_32
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			l_return, l_break: BOOLEAN
		do
			l_idx := -1
			l_other := 0
			if not (a_wp___0.item.w_onebuf_opt.wo_diff).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_i___0 := 0
				from
				until
					not (l_i___0 < 4)
				loop
					if ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_i___0]).is_equal (a_wp___0.item.w_buffer) then
						l_idx := l_i___0
					elseif not ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_i___0]).is_void then
						l_other := 1
					end
					l_i___0 := l_i___0 + 1
				end
				if l_idx = -1 then
					Result := 0
					l_return := True
				elseif not l_other.to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diff_invalid).to_boolean then
					(create {P_DIFF_STATIC}).ex_diffupdate (create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer))
				end
				if ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_first_diff).is_void then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				l_dp := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_first_diff
				from
				until
					not (not (l_return or l_break) and then (not l_dp.is_void))
				loop
					l_break := False
					if l_dp.item.df_lnum[l_idx] - ((create {P_GLOBALS_STATIC}).diff_context.item).to_integer_32 > a_lnum then
						l_break := True
					end
					if not (l_return or l_break) then
						if (l_dp.item.df_lnum[l_idx] + l_dp.item.df_count[l_idx]) + ((create {P_GLOBALS_STATIC}).diff_context.item).to_integer_32 > a_lnum then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_dp := l_dp.item.df_next
						end
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 1
			end
		end

	eval_foldexpr (a_arg: CE_POINTER [NATURAL_8]; a_cp: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_cp.is_void
		local
			l_tv: CE_ARRAY [PD_TYPVAL_T]
			l_retval: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_use_sandbox: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_TYPVAL_T]} l_tv.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_use_sandbox := ((create {P_OPTION_STATIC}).was_set_insecurely (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("foldexpr")), 4));
					(create {P_GLOBALS_STATIC}).emsg_off.item := (create {P_GLOBALS_STATIC}).emsg_off.item + 1
					if l_use_sandbox.to_boolean then
						(create {P_GLOBALS_STATIC}).sandbox.item := (create {P_GLOBALS_STATIC}).sandbox.item + 1
					end
					(create {P_GLOBALS_STATIC}).textlock.item := (create {P_GLOBALS_STATIC}).textlock.item + 1
					a_cp.item := ('%/0/').code
					if ((create {P_EVAL_STATIC}).eval0 (a_arg, l_tv, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), 1)) /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_retval := 0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 3 then -- else:
						if (l_tv.item.v_type).to_integer_32 /= 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_retval := l_tv.item.vval.v_number
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 6 then -- else:
						if (l_tv.item.v_type).to_integer_32 = 2 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_retval := 0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 9 then -- else:
						if not ((l_tv.item.vval.v_string).is_void) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_retval := 0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 12 then -- else:
						l_s := l_tv.item.vval.v_string
						if not ((l_s.item).to_integer_32 >= 48) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if not ((l_s.item).to_integer_32 <= 57) then
							l_pos := -1 + 15 -- goto _L
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L:
						if (l_s.item).to_integer_32 /= 45 then
							l_tmp___0 := l_s
							l_s := l_s + 1
							a_cp.item := (l_tmp___0.item).to_integer_32
						end
				when 16 then
						l_retval := (atol (create {CE_INTEGER_8_POINTER}.make_cast (l_s))).to_integer_32
				when 17 then -- if done | if done | if done;
						(create {P_EVAL_STATIC}).clear_tv (l_tv)
				when 18 then -- if done;
					(create {P_GLOBALS_STATIC}).emsg_off.item := (create {P_GLOBALS_STATIC}).emsg_off.item - 1
					if l_use_sandbox.to_boolean then
						(create {P_GLOBALS_STATIC}).sandbox.item := (create {P_GLOBALS_STATIC}).sandbox.item - 1
					end
					(create {P_GLOBALS_STATIC}).textlock.item := (create {P_GLOBALS_STATIC}).textlock.item - 1
					Result := l_retval
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_indent_buf (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_lnum: INTEGER_32): INTEGER_32
		require
			not a_buf___6.is_void
		do
			Result := ((create {P_MISC1_STATIC}).get_indent_str ((a_buf___6.item.ml_get_buf (a_lnum, 0)), (a_buf___6.item.b_p_ts).to_integer_32))
		end

	syn_get_foldlevel (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32): INTEGER_32
		require
			not a_wp___0.is_void
		local
			l_level: INTEGER_32
			l_i___0: INTEGER_32
		do
			l_level := 0
			if (a_wp___0.item.w_s).item.b_syn_folditems /= 0 then
				a_wp___0.item.syntax_start (a_lnum)
				l_i___0 := 0
				from
				until
					not (l_i___0 < (create {P_SYNTAX_STATIC}).current_state.item.item.ga_len)
				loop
					if (((create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_flags).bit_and (8_192)).to_boolean then
						l_level := l_level + 1
					end
					l_i___0 := l_i___0 + 1
				end
			end
			if l_level.to_integer_32 > a_wp___0.item.w_onebuf_opt.wo_fdn then
				l_level := (a_wp___0.item.w_onebuf_opt.wo_fdn).to_integer_32
				if l_level < 0 then
					l_level := 0
				end
			end
			Result := l_level
		end

feature {ANY}

	copy (a_other: like Current)
		do
			wp := a_other.wp
			lnum := a_other.lnum
			off := a_other.off
			lnum_save := a_other.lnum_save
			lvl := a_other.lvl
			lvl_next := a_other.lvl_next
			start := a_other.start
			end2 := a_other.end2
			had_end := a_other.had_end
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				wp.is_equal (a_other.wp) and
				lnum = a_other.lnum and
				off = a_other.off and
				lnum_save = a_other.lnum_save and
				lvl = a_other.lvl and
				lvl_next = a_other.lvl_next and
				start = a_other.start and
				end2 = a_other.end2 and
				had_end = a_other.had_end
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("wp"),
					create {CE_STRUCTURE_FIELD}.make ("lnum"),
					create {CE_STRUCTURE_FIELD}.make ("off"),
					create {CE_STRUCTURE_FIELD}.make ("lnum_save"),
					create {CE_STRUCTURE_FIELD}.make ("lvl"),
					create {CE_STRUCTURE_FIELD}.make ("lvl_next"),
					create {CE_STRUCTURE_FIELD}.make ("start"),
					create {CE_STRUCTURE_FIELD}.make ("end2"),
					create {CE_STRUCTURE_FIELD}.make ("had_end")
				>>)
			init_structure_info
		end

end
