class
	PD_GROWARRAY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_DIRENT_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} ga_data.make
			Precursor
		end

feature {ANY} -- fields

	ga_len: INTEGER_32 assign set_ga_len

	ga_maxlen: INTEGER_32 assign set_ga_maxlen

	ga_itemsize: INTEGER_32 assign set_ga_itemsize

	ga_growsize: INTEGER_32 assign set_ga_growsize

	ga_data: CE_POINTER [ANY] assign set_ga_data

feature {ANY} -- field setters

	set_ga_len (a_ga_len: INTEGER_32)
		do
			ga_len := a_ga_len
			update_memory_field ("ga_len")
		end

	set_ga_maxlen (a_ga_maxlen: INTEGER_32)
		do
			ga_maxlen := a_ga_maxlen
			update_memory_field ("ga_maxlen")
		end

	set_ga_itemsize (a_ga_itemsize: INTEGER_32)
		do
			ga_itemsize := a_ga_itemsize
			update_memory_field ("ga_itemsize")
		end

	set_ga_growsize (a_ga_growsize: INTEGER_32)
		do
			ga_growsize := a_ga_growsize
			update_memory_field ("ga_growsize")
		end

	set_ga_data (a_ga_data: CE_POINTER [ANY])
		do
			ga_data := a_ga_data
			update_memory_field ("ga_data")
		end

feature {PD_GROWARRAY} -- private attributes

	stardepth: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	recursive___8: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	debuggy_find (a_file: INTEGER_32; a_fname: CE_POINTER [NATURAL_8]; a_after: INTEGER_32; a_fp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_bp___0: CE_POINTER [PD_DEBUGGY]
			l_i___0: INTEGER_32
			l_lnum: INTEGER_32
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_name___1: CE_POINTER [NATURAL_8]
			l_prev_got_int: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_REGMATCH_T]} l_regmatch___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := (0).to_integer_32
					l_name___1 := a_fname
					if ga_len = 0 then
						Result := (0).to_integer_32
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if not a_file.to_boolean then
							if (a_fname[0]).to_integer_32 = 128 then
								l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_fname))
								update_class_fields -- Current might have been changed; synchronize
								l_name___1 := (create {P_MISC2_STATIC}).alloc (l_tmp + {NATURAL_32} 3)
								update_class_fields -- Current might have been changed; synchronize
								if l_name___1.is_void then
									l_name___1 := a_fname
								else
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_name___1), ce_string ("<SNR>")).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_name___1 + 5)), create {CE_INTEGER_8_POINTER}.make_cast ((a_fname + 3))).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						l_i___0 := 0
				when 2 then -- loop condition:
						if not (l_i___0 < ga_len) then
							l_pos := -1 + 11 -- skip loop
						end
				when 3 then -- loop body:
						l_bp___0 := create {CE_CLASS_POINTER [PD_DEBUGGY]}.make_cast (ga_data) + l_i___0
						if (l_bp___0.item.dbg_type = 2) /= a_file.to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						if not (l_bp___0.item.dbg_lnum > a_after) then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if l_lnum /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if not (l_bp___0.item.dbg_lnum < l_lnum) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						l_regmatch___0.item.regprog := l_bp___0.item.dbg_prog
						update_class_fields -- Current might have been changed; synchronize
						l_regmatch___0.item.rm_ic := 0
						update_class_fields -- Current might have been changed; synchronize
						l_prev_got_int := (create {P_GLOBALS_STATIC}).got_int.item;
						(create {P_GLOBALS_STATIC}).got_int.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := l_regmatch___0.item.vim_regexec (l_name___1, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0.to_boolean then
							l_lnum := l_bp___0.item.dbg_lnum
							if not a_fp.is_void then
								a_fp.item := l_bp___0.item.dbg_forceit
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						(create {P_GLOBALS_STATIC}).got_int.item := ((create {P_GLOBALS_STATIC}).got_int.item).bit_or (l_prev_got_int)
						update_class_fields -- Current might have been changed; synchronize
				when 10 then -- if done | if done | if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 2 -- back to loop condition
				when 11 then -- loop done
						if not l_name___1.is_equal (a_fname) then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_name___1))
							update_class_fields -- Current might have been changed; synchronize
						end
						Result := l_lnum
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	free_cmdlines
		do
			from
			until
				not (ga_len > 0)
			loop
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_WCMD_T]}.make_cast (ga_data) + (ga_len - 1)).item.line))
				update_class_fields -- Current might have been changed; synchronize
				Current.ga_len := ga_len - 1
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	uc_clear
		local
			l_i___0: INTEGER_32
			l_cmd: CE_POINTER [PD_UCMD]
		do
			l_i___0 := 0
			from
			until
				not (l_i___0 < ga_len)
			loop
				l_cmd := create {CE_CLASS_POINTER [PD_UCMD]}.make_cast (ga_data) + l_i___0;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cmd.item.uc_name))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cmd.item.uc_rep))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cmd.item.uc_compl_arg))
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := l_i___0 + 1
			end
			((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_clear
			update_class_fields -- Current might have been changed; synchronize
		end

	checkCloseRec (a_lnum: INTEGER_32; a_level: INTEGER_32): INTEGER_32
		local
			l_fp: CE_POINTER [PD_FOLD_T]
			l_retval: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_retval := 0
			l_fp := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (ga_data)
			l_i___0 := 0
			from
			until
				not (l_i___0 < ga_len)
			loop
				if ((l_fp + l_i___0).item.fd_flags).to_integer_32 = 0 then
					if a_level <= 0 then
						if a_lnum < (l_fp + l_i___0).item.fd_top then
							(l_fp + l_i___0).item.fd_flags := (2).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							l_retval := 1
						elseif a_lnum >= (l_fp + l_i___0).item.fd_top + (l_fp + l_i___0).item.fd_len then
							(l_fp + l_i___0).item.fd_flags := (2).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							l_retval := 1
						else
							l_tmp := (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared ((l_fp + l_i___0).c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))).item.checkCloseRec (a_lnum - (l_fp + l_i___0).item.fd_top, a_level - 1)
							update_class_fields -- Current might have been changed; synchronize
							l_retval := (l_retval).bit_or (l_tmp)
						end
					else
						l_tmp := (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared ((l_fp + l_i___0).c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))).item.checkCloseRec (a_lnum - (l_fp + l_i___0).item.fd_top, a_level - 1)
						update_class_fields -- Current might have been changed; synchronize
						l_retval := (l_retval).bit_or (l_tmp)
					end
				end
				l_i___0 := l_i___0 + 1
			end
			Result := l_retval
		end

	cloneFoldGrowArray (a_to: CE_POINTER [PD_GROWARRAY])
		require
			not a_to.is_void
		local
			l_i___0: INTEGER_32
			l_from_p: CE_POINTER [PD_FOLD_T]
			l_to_p: CE_POINTER [PD_FOLD_T]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			a_to.item.ga_init2 (ga_itemsize, ga_growsize)
			update_class_fields -- Current might have been changed; synchronize
			if ga_len = 0 then
				l_return := True
			else
				l_tmp := a_to.item.ga_grow (ga_len)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp = 0 then
					l_return := True
				end
			end
			if not l_return then
				l_from_p := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (ga_data)
				l_to_p := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_to.item.ga_data)
				l_i___0 := 0
				from
				until
					not (l_i___0 < ga_len)
				loop
					l_to_p.item.fd_top := l_from_p.item.fd_top
					update_class_fields -- Current might have been changed; synchronize
					l_to_p.item.fd_len := l_from_p.item.fd_len
					update_class_fields -- Current might have been changed; synchronize
					l_to_p.item.fd_flags := l_from_p.item.fd_flags
					update_class_fields -- Current might have been changed; synchronize
					l_to_p.item.fd_small := l_from_p.item.fd_small
					update_class_fields; -- Current might have been changed; synchronize
					(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_from_p.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))).item.cloneFoldGrowArray (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_to_p.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested")))
					update_class_fields -- Current might have been changed; synchronize
					a_to.item.ga_len := (a_to.item.ga_len) + 1
					update_class_fields -- Current might have been changed; synchronize
					l_from_p := l_from_p + 1
					l_to_p := l_to_p + 1
					l_i___0 := l_i___0 + 1
				end
			end
		end

	foldFind (a_lnum: INTEGER_32; a_fpp: CE_POINTER [CE_POINTER [PD_FOLD_T]]): INTEGER_32
		require
			not a_fpp.is_void
		local
			l_low: INTEGER_32
			l_high: INTEGER_32
			l_fp: CE_POINTER [PD_FOLD_T]
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_fp := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (ga_data)
			l_low := (0).to_integer_32
			l_high := (ga_len - 1).to_integer_32
			from
			until
				not (not (l_return) and then (l_low <= l_high))
			loop
				l_i___0 := ((l_low + l_high) // 2).to_integer_32
				if (l_fp + l_i___0).item.fd_top > a_lnum then
					l_high := (l_i___0 - 1).to_integer_32
				elseif (l_fp + l_i___0).item.fd_top + (l_fp + l_i___0).item.fd_len <= a_lnum then
					l_low := (l_i___0 + 1).to_integer_32
				else
					a_fpp.item := l_fp + l_i___0
					update_class_fields -- Current might have been changed; synchronize
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				a_fpp.item := l_fp + l_low
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

	deleteFoldEntry (a_idx, a_recursive___12: INTEGER_32)
		local
			l_fp: CE_POINTER [PD_FOLD_T]
			l_i___0: INTEGER_32
			l_moved: INTEGER_32
			l_nfp: CE_POINTER [PD_FOLD_T]
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fp := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (ga_data) + a_idx
					if not (a_recursive___12.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if l_fp.item.fd_nested.ga_len /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:;
						(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))).item.deleteFoldRecurse
						update_class_fields -- Current might have been changed; synchronize
						Current.ga_len := ga_len - 1
						update_class_fields -- Current might have been changed; synchronize
						if a_idx < ga_len then
							memmove (create {CE_VOID_POINTER}.make_cast (l_fp), create {CE_VOID_POINTER}.make_cast ((l_fp + 1)), (create {PD_FOLD_T}.make).structure_size.to_natural_32 * (ga_len - a_idx).to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_moved := (l_fp.item.fd_nested.ga_len).to_integer_32
						l_tmp := ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_grow ((l_moved - 1).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp = 1 then
							l_nfp := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_fp.item.fd_nested.ga_data)
							l_i___0 := 0
							from
							until
								not (l_i___0.to_integer_32 < l_moved)
							loop
								(l_nfp + l_i___0).item.fd_top := (l_nfp + l_i___0).item.fd_top + (l_fp.item.fd_top)
								update_class_fields -- Current might have been changed; synchronize
								if (l_fp.item.fd_flags).to_integer_32 = 2 then
									(l_nfp + l_i___0).item.fd_flags := (2).to_integer_8
									update_class_fields -- Current might have been changed; synchronize
								end
								if (l_fp.item.fd_small).to_integer_32 = 2 then
									(l_nfp + l_i___0).item.fd_small := (2).to_integer_8
									update_class_fields -- Current might have been changed; synchronize
								end
								l_i___0 := l_i___0 + 1
							end
							if a_idx < ga_len then
								memmove (create {CE_VOID_POINTER}.make_cast ((l_fp + l_moved)), create {CE_VOID_POINTER}.make_cast ((l_fp + 1)), (create {PD_FOLD_T}.make).structure_size.to_natural_32 * (ga_len - a_idx).to_natural_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
							memmove (create {CE_VOID_POINTER}.make_cast (l_fp), create {CE_VOID_POINTER}.make_cast (l_nfp), (((create {PD_FOLD_T}.make).structure_size.to_natural_32).to_natural_32 * l_moved.to_natural_32).to_natural_32).do_nothing
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_nfp))
							update_class_fields -- Current might have been changed; synchronize
							Current.ga_len := (ga_len.to_integer_32 + (l_moved - 1)).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
				when 7 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	deleteFoldRecurse
		local
			l_i___0: INTEGER_32
		do
			l_i___0 := 0
			from
			until
				not (l_i___0 < ga_len)
			loop
				(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (ga_data) + l_i___0).c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))).item.deleteFoldRecurse
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := l_i___0 + 1
			end
			((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_clear
			update_class_fields -- Current might have been changed; synchronize
		end

	foldMarkAdjustRecurse (a_line1, a_line2, a_amount, a_amount_after: INTEGER_32)
		local
			l_fp: CE_ARRAY [CE_POINTER [PD_FOLD_T]]
			l_i___0: INTEGER_32
			l_last: INTEGER_32
			l_top: INTEGER_32
			l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_FOLD_T]} l_fp.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
						if a_amount = 1 then
							if a_line2 = 2_147_483_647 then
								l_top := a_line1 + 1
							else
								l_top := a_line1
							end
						else
							l_top := a_line1
						end
					else
						l_top := a_line1
					end
					((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.foldFind (a_line1, l_fp).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := (l_fp.item).distance ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (ga_data)))
				when 1 then -- loop condition:
					if not (not (l_break) and then (l_i___0 < ga_len)) then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						l_last := (l_fp.item.item.fd_top + l_fp.item.item.fd_len) - 1
						if l_last < a_line1 then
							l_continue := True
						end
						if (l_break or l_continue) then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						if not (l_fp.item.item.fd_top > a_line2) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_amount_after = 0 then
							l_break := True
						end
						if not (l_break or l_continue) then
							l_fp.item.item.fd_top := l_fp.item.item.fd_top + a_amount_after
							update_class_fields -- Current might have been changed; synchronize
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (l_fp.item.item.fd_top >= l_top) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_last <= a_line2 then
							if a_amount = 2_147_483_647 then
								((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.deleteFoldEntry (l_i___0, 1)
								update_class_fields -- Current might have been changed; synchronize
								l_i___0 := l_i___0 - 1
								l_fp.item := l_fp.item - 1
								update_class_fields -- Current might have been changed; synchronize
							else
								l_fp.item.item.fd_top := l_fp.item.item.fd_top + a_amount
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if l_fp.item.item.fd_top < l_top then
							(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))).item.foldMarkAdjustRecurse (a_line1 - l_fp.item.item.fd_top, a_line2 - l_fp.item.item.fd_top, a_amount, a_amount_after)
							update_class_fields -- Current might have been changed; synchronize
							if l_last <= a_line2 then
								if a_amount = 2_147_483_647 then
									l_fp.item.item.fd_len := a_line1 - l_fp.item.item.fd_top
									update_class_fields -- Current might have been changed; synchronize
								else
									l_fp.item.item.fd_len := l_fp.item.item.fd_len + a_amount
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_fp.item.item.fd_len := l_fp.item.item.fd_len + a_amount_after
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))).item.foldMarkAdjustRecurse (a_line1 - l_fp.item.item.fd_top, a_line2 - l_fp.item.item.fd_top, a_amount, a_amount_after + (l_fp.item.item.fd_top - l_top))
							update_class_fields -- Current might have been changed; synchronize
							if a_amount = 2_147_483_647 then
								l_fp.item.item.fd_len := l_fp.item.item.fd_len - ((a_line2 - l_fp.item.item.fd_top) + 1)
								update_class_fields -- Current might have been changed; synchronize
								l_fp.item.item.fd_top := a_line1
								update_class_fields -- Current might have been changed; synchronize
							else
								l_fp.item.item.fd_len := l_fp.item.item.fd_len + (a_amount_after - a_amount)
								update_class_fields -- Current might have been changed; synchronize
								l_fp.item.item.fd_top := l_fp.item.item.fd_top + a_amount
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 10 then -- if done | if done
						if (not l_break) then
							l_i___0 := l_i___0 + 1
							l_fp.item := l_fp.item + 1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
					l_break := False
					l_continue := False
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	setSmallMaybe
		local
			l_i___0: INTEGER_32
			l_fp: CE_POINTER [PD_FOLD_T]
		do
			l_fp := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (ga_data)
			l_i___0 := 0
			from
			until
				not (l_i___0 < ga_len)
			loop
				(l_fp + l_i___0).item.fd_small := (2).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := l_i___0 + 1
			end
		end

	unix_expandpath (a_path: CE_POINTER [NATURAL_8]; a_wildoff, a_flags___0, a_didstar: INTEGER_32): INTEGER_32
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_path_end: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_start_len: INTEGER_32
			l_pat: CE_POINTER [NATURAL_8]
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_starts_with_dot: INTEGER_32
			l_matches___0: INTEGER_32
			l_len: INTEGER_32
			l_starstar: INTEGER_32
			l_dirp: CE_POINTER [ANY]
			l_dp: CE_POINTER [SD_DIRENT]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: NATURAL_32
			l_tmp___7: INTEGER_32
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: NATURAL_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_path_end.make
			create {CE_NATURAL_8_POINTER} l_s.make
			create {CE_NATURAL_8_POINTER} l_e.make
			create {CE_NATURAL_8_POINTER} l_pat.make
			create {CE_CLASS_ARRAY [PD_REGMATCH_T]} l_regmatch___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_start_len := ga_len
					l_starstar := 0
					if stardepth.item > 0 then
						(create {P_UI_STATIC}).ui_breakcheck
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_path))
						update_class_fields -- Current might have been changed; synchronize
						l_buf___6 := (create {P_MISC2_STATIC}).alloc (((l_tmp.to_integer_32 + 250) + 5).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_buf___6.is_void then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_p___0 := l_buf___6
						l_s := l_buf___6
						l_e := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_path_end := a_path
				when 2 then -- loop condition:
						if not (not (l_break) and then ((l_path_end.item).to_integer_32 /= 0)) then
							l_pos := -1 + 8 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if not ((l_path_end.c_pointer.to_integer_32).to_natural_32 >= ((a_path + a_wildoff).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_tmp___3 := (create {P_CHARSET_STATIC}).rem_backslash (l_path_end)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___3.to_boolean then
							l_tmp___0 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___1 := l_path_end
							l_path_end := l_path_end + 1
							l_tmp___0.item := l_tmp___1.item
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if (l_path_end.item).to_integer_32 = 47 then
							if not l_e.is_void then
								l_break := True
							end
							if not (l_break) then
								l_s := l_p___0 + 1
							end
						elseif (l_path_end.c_pointer.to_integer_32).to_natural_32 >= ((a_path + a_wildoff).c_pointer.to_integer_32).to_natural_32 then
							l_tmp___2 := (create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("*?[{~$")), (l_path_end.item).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___2.is_void then
								l_e := l_p___0
							end
						end
				when 7 then
						if not (l_break) then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_len := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_path_end])
								update_class_fields -- Current might have been changed; synchronize
								strncpy (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), create {CE_INTEGER_8_POINTER}.make_cast (l_path_end), l_len.to_natural_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_p___0 := l_p___0 + l_len
								l_path_end := l_path_end + l_len
							else
								l_tmp___4 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___5 := l_path_end
								l_path_end := l_path_end + 1
								l_tmp___4.item := l_tmp___5.item
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_pos := -1 + 2 -- back to loop condition
				when 8 then -- loop done
						l_break := False
						l_e := l_p___0
						l_e.item := (('%/0/').code).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_p___0 := l_buf___6 + a_wildoff
						from
						until
							not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_s.c_pointer.to_integer_32).to_natural_32)
						loop
							l_tmp___7 := (create {P_CHARSET_STATIC}).rem_backslash (l_p___0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___7.to_boolean then
								l_tmp___6 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 1)))
								update_class_fields -- Current might have been changed; synchronize
								memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + 1)), l_tmp___6 + {NATURAL_32} 1).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_e := l_e - 1
								l_s := l_s - 1
							end
							l_p___0 := l_p___0 + 1
						end
						l_p___0 := l_s
						from
						until
							not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32)
						loop
							if (l_p___0[0]).to_integer_32 = 42 then
								if (l_p___0[1]).to_integer_32 = 42 then
									l_starstar := 1
								end
							end
							l_p___0 := l_p___0 + 1
						end
						l_starts_with_dot := ((l_s.item).to_integer_32 = 46).to_integer
						l_pat := (create {P_FILEIO_STATIC}).file_pat_to_reg_pat (l_s, l_e, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_pat.is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
				when 9 then -- if done
					if not l_return then
						l_regmatch___0.item.rm_ic := 0
						update_class_fields -- Current might have been changed; synchronize
						l_regmatch___0.item.regprog := (create {P_REGEXP_STATIC}).vim_regcomp (l_pat, 1)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pat))
						update_class_fields -- Current might have been changed; synchronize
						if (l_regmatch___0.item.regprog).is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 21 -- skip if block
					end
				when 10 then -- if:
						if not a_didstar.to_boolean then
							if stardepth.item < 100 then
								if l_starstar.to_boolean then
									if l_e.distance (l_s) = 2 then
										if (l_path_end.item).to_integer_32 = 47 then
											strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_s), create {CE_INTEGER_8_POINTER}.make_cast ((l_path_end + 1))).do_nothing
											update_class_fields -- Current might have been changed; synchronize
											stardepth.item := stardepth.item + 1;
											((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.unix_expandpath (l_buf___6, l_s.distance (l_buf___6), a_flags___0, 1).do_nothing
											update_class_fields -- Current might have been changed; synchronize
											stardepth.item := stardepth.item - 1
										end
									end
								end
							end
						end
						l_s.item := (('%/0/').code).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						if (l_buf___6.item).to_integer_32 = 0 then
							l_tmp___8 := ce_string (".")
						else
							l_tmp___8 := create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6)
						end
						l_dirp := opendir (l_tmp___8)
						update_class_fields -- Current might have been changed; synchronize
						if l_dirp.is_void then
							l_pos := -1 + 20 -- skip if block
						end
				when 11 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 19 -- skip loop
						end
				when 12 then -- loop body:
						l_break := False
						l_dp := readdir (l_dirp)
						update_class_fields -- Current might have been changed; synchronize
						if l_dp.is_void then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 18 -- skip if block
						end
				when 13 then -- if:
						if (l_dp.item.d_name[0]).to_integer_32 = 46 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if not (l_starts_with_dot.to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L___0:
						l_tmp___12 := l_regmatch___0.item.vim_regexec (create {CE_NATURAL_8_POINTER}.make_cast ((l_dp.item.d_name)), 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___12.to_boolean then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_s), (l_dp.item.d_name)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___9 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))
							update_class_fields -- Current might have been changed; synchronize
							l_len := l_tmp___9.to_integer_32
							if l_starstar.to_boolean then
								if stardepth.item < 100 then
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_buf___6 + l_len)), ce_string ("/**")).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast (((l_buf___6 + l_len) + 3)), create {CE_INTEGER_8_POINTER}.make_cast (l_path_end)).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									stardepth.item := stardepth.item + 1;
									((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.unix_expandpath (l_buf___6, l_len + 1, a_flags___0, 1).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									stardepth.item := stardepth.item - 1
								end
							end
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_buf___6 + l_len)), create {CE_INTEGER_8_POINTER}.make_cast (l_path_end)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___11 := (create {P_OS_UNIX_STATIC}).mch_has_exp_wildcard (l_path_end)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___11.to_boolean then
								((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.unix_expandpath (l_buf___6, l_len + 1, a_flags___0, 0).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							else
								if (l_path_end.item).to_integer_32 /= 0 then
									(create {P_CHARSET_STATIC}).backslash_halve ((l_buf___6 + l_len) + 1)
									update_class_fields -- Current might have been changed; synchronize
								end
								l_tmp___10 := (create {P_OS_UNIX_STATIC}).mch_getperm (l_buf___6)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___10 >= 0 then
									(create {P_MISC1_STATIC}).addfile ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer)), l_buf___6, a_flags___0)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
				when 18 then -- if done | if done
						l_pos := -1 + 11 -- back to loop condition
				when 19 then -- loop done
						l_break := False
						closedir (l_dirp).do_nothing
						update_class_fields -- Current might have been changed; synchronize
				when 20 then -- if done;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_regmatch___0.item.regprog))
						update_class_fields -- Current might have been changed; synchronize
						l_matches___0 := ga_len - l_start_len
						if l_matches___0 > 0 then
							qsort (create {CE_VOID_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ga_data) + l_start_len)), l_matches___0.to_natural_32, {PLATFORM}.Pointer_bytes.to_natural_32, (create {P_MISC1_STATIC}).pstrcmp_address)
							update_class_fields -- Current might have been changed; synchronize
						end
						Result := l_matches___0
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	is_unique (a_maybe_unique: CE_POINTER [NATURAL_8]; a_i___0: INTEGER_32): INTEGER_32
		local
			l_j: INTEGER_32
			l_candidate_len: INTEGER_32
			l_other_path_len: INTEGER_32
			l_other_paths: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_rival: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_return, l_continue: BOOLEAN
		do
			l_other_paths := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ga_data)
			l_j := 0
			from
			until
				not (not (l_return) and then (l_j < ga_len))
			loop
				l_continue := False
				if l_j = a_i___0 then
					l_continue := True
				end
				if not (l_return or l_continue) then
					l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_maybe_unique))
					update_class_fields -- Current might have been changed; synchronize
					l_candidate_len := l_tmp.to_integer_32
					l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_other_paths[l_j]))
					update_class_fields -- Current might have been changed; synchronize
					l_other_path_len := l_tmp___0.to_integer_32
					if l_other_path_len < l_candidate_len then
						l_continue := True
					end
				end
				if not (l_return or l_continue) then
					l_rival := (l_other_paths[l_j] + l_other_path_len) - l_candidate_len
					l_tmp___1 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_maybe_unique), create {CE_INTEGER_8_POINTER}.make_cast (l_rival))
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___1 = 0 then
						Result := 0
						l_return := True
					end
				end
				if (not l_return) then
					l_j := l_j + 1
				end
			end
			if not l_return then
				l_continue := False
				Result := 1
			end
		end

	get_path_cutoff (a_fname: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_i___0: INTEGER_32
			l_maxlen: INTEGER_32
			l_path_part: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_cutoff: CE_POINTER [NATURAL_8]
			l_j: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_maxlen := 0
			l_path_part := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ga_data)
			l_cutoff := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_i___0 := 0
			from
			until
				not (not (l_return) and then (l_i___0 < ga_len))
			loop
				l_j := 0
				from
				until
					(l_break)
				loop
					l_break := False
					if (a_fname[l_j]).to_integer_32 = ((l_path_part[l_i___0])[l_j]).to_integer_32 then
						if (a_fname[l_j]).to_integer_32 /= 0 then
							if ((l_path_part[l_i___0])[l_j]).to_integer_32 = 0 then
								l_break := True
							end
						else
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_j := l_j + 1
					end
				end
				l_break := False
				if l_j > l_maxlen then
					l_maxlen := l_j
					l_cutoff := a_fname + l_j
				end
				l_i___0 := l_i___0 + 1
			end
			if not l_cutoff.is_void then
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___1 := (create {P_MISC1_STATIC}).vim_ispathsep ((l_cutoff.item).to_integer_32)
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp___1.to_boolean then
						l_break := True
					end
					if not (l_return or l_break) then
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_cutoff])
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___0 := l_tmp
						else
							l_tmp___0 := 1
						end
						l_cutoff := l_cutoff + l_tmp___0
					end
				end
				l_break := False
			end
			Result := l_cutoff
		end

	uniquefy_paths (a_pattern: CE_POINTER [NATURAL_8])
		local
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_fnames: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_sort_again: INTEGER_32
			l_pat: CE_POINTER [NATURAL_8]
			l_file_pattern: CE_POINTER [NATURAL_8]
			l_curdir: CE_POINTER [NATURAL_8]
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_path_ga: CE_ARRAY [PD_GROWARRAY]
			l_in_curdir: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_short_name: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_path: CE_POINTER [NATURAL_8]
			l_is_in_curdir: INTEGER_32
			l_dir_end: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_pathsep_p: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_path_cutoff: CE_POINTER [NATURAL_8]
			l_tmp___2: NATURAL_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: NATURAL_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: NATURAL_32
			l_tmp___10: NATURAL_32
			l_tmp___11: INTEGER_32
			l_rel_path: CE_POINTER [NATURAL_8]
			l_path___0: CE_POINTER [NATURAL_8]
			l_tmp___12: INTEGER_32
			l_tmp___13: NATURAL_32
			l_tmp___14: NATURAL_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_REGMATCH_T]} l_regmatch___0.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_path_ga.make (<<1>>)
			create {CE_NATURAL_8_POINTER} l_short_name.make
			create {CE_POINTER_ARRAY [NATURAL_8]} l_pathsep_p.make (<<1>>)
			create {CE_NATURAL_8_POINTER} l_path___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fnames := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ga_data)
					l_sort_again := 0
					l_in_curdir := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer);
					((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.remove_duplicates
					update_class_fields -- Current might have been changed; synchronize
					l_path_ga.item.ga_init2 (({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 1)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_pattern))
					update_class_fields -- Current might have been changed; synchronize
					l_len := l_tmp.to_integer_32
					l_file_pattern := (create {P_MISC2_STATIC}).alloc ((l_len + 2).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_file_pattern.is_void then
						l_return := True
					end
					if not l_return then
						l_file_pattern[0] := (('*').code).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_file_pattern[1] := (('%/0/').code).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_file_pattern), create {CE_INTEGER_8_POINTER}.make_cast (a_pattern)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_pat := (create {P_FILEIO_STATIC}).file_pat_to_reg_pat (l_file_pattern, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), 1)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_file_pattern))
						update_class_fields -- Current might have been changed; synchronize
						if l_pat.is_void then
							l_return := True
						end
					end
					if not l_return then
						l_regmatch___0.item.rm_ic := 1
						update_class_fields -- Current might have been changed; synchronize
						l_regmatch___0.item.regprog := (create {P_REGEXP_STATIC}).vim_regcomp (l_pat, 3)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pat))
						update_class_fields -- Current might have been changed; synchronize
						if (l_regmatch___0.item.regprog).is_void then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_curdir := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 4_096)
						update_class_fields -- Current might have been changed; synchronize
						if l_curdir.is_void then
							l_pos := -1 + 10 -- goto theend
						end
				when 2 then;
						(create {P_OS_UNIX_STATIC}).mch_dirname (l_curdir, 4_096).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC1_STATIC}).expand_path_option (l_curdir, l_path_ga)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := (create {P_MISC2_STATIC}).alloc_clear (ga_len.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_in_curdir := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_tmp___0)
						if l_in_curdir.is_void then
							l_pos := -1 + 10 -- goto theend
						end
				when 3 then
						l_i___0 := 0
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i___0 < ga_len then
								if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_path := l_fnames[l_i___0]
								l_tmp___1 := gettail_dir (l_path)
								update_class_fields -- Current might have been changed; synchronize
								l_dir_end := l_tmp___1
								l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_path))
								update_class_fields -- Current might have been changed; synchronize
								l_len := l_tmp___2.to_integer_32
								l_tmp___3 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_curdir), create {CE_INTEGER_8_POINTER}.make_cast (l_path), (l_dir_end.distance (l_path)).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___3 = 0 then
									if (l_curdir[(l_dir_end.distance (l_path))]).to_integer_32 = 0 then
										l_tmp___4 := 1
									else
										l_tmp___4 := 0
									end
								else
									l_tmp___4 := 0
								end
								l_is_in_curdir := l_tmp___4
								if l_is_in_curdir.to_boolean then
									l_in_curdir[l_i___0] := (create {P_MISC2_STATIC}).vim_strsave (l_path)
									update_class_fields -- Current might have been changed; synchronize
								end
								l_path_cutoff := l_path_ga.item.get_path_cutoff (l_path)
								update_class_fields -- Current might have been changed; synchronize
								l_pathsep_p.item := (l_path + l_len) - 1
								update_class_fields -- Current might have been changed; synchronize
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___8 := find_previous_pathsep (l_path, l_pathsep_p)
									update_class_fields -- Current might have been changed; synchronize
									if not l_tmp___8.to_boolean then
										l_break := True
									end
									if not (l_break) then
										l_tmp___6 := l_regmatch___0.item.vim_regexec (l_pathsep_p.item + 1, 0)
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___6.to_boolean then
											l_tmp___7 := ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.is_unique (l_pathsep_p.item + 1, l_i___0)
											update_class_fields -- Current might have been changed; synchronize
											if l_tmp___7.to_boolean then
												if not l_path_cutoff.is_void then
													if ((l_pathsep_p.item + 1).c_pointer.to_integer_32).to_natural_32 >= (l_path_cutoff.c_pointer.to_integer_32).to_natural_32 then
														l_sort_again := 1
														l_tmp___5 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_pathsep_p.item))
														update_class_fields -- Current might have been changed; synchronize
														memmove (create {CE_VOID_POINTER}.make_cast (l_path), create {CE_VOID_POINTER}.make_cast ((l_pathsep_p.item + 1)), l_tmp___5).do_nothing
														update_class_fields -- Current might have been changed; synchronize
														l_break := True
													end
												end
											end
										end
									end
								end
								l_break := False
								l_tmp___11 := (create {P_OS_UNIX_STATIC}).mch_isFullName (l_path)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___11.to_boolean then
									l_short_name := (create {P_FILEIO_STATIC}).shorten_fname (l_path, l_curdir)
									update_class_fields -- Current might have been changed; synchronize
									if not l_short_name.is_void then
										if (l_short_name.c_pointer.to_integer_32).to_natural_32 > ((l_path + 1).c_pointer.to_integer_32).to_natural_32 then
											strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_path), ce_string (".")).do_nothing
											update_class_fields; -- Current might have been changed; synchronize
											(create {P_MISC1_STATIC}).add_pathsep (l_path)
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___9 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_short_name))
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___10 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_path))
											update_class_fields -- Current might have been changed; synchronize
											memmove (create {CE_VOID_POINTER}.make_cast ((l_path + l_tmp___10.to_integer_32)), create {CE_VOID_POINTER}.make_cast (l_short_name), l_tmp___9 + {NATURAL_32} 1).do_nothing
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								end
								(create {P_UI_STATIC}).ui_breakcheck
								update_class_fields -- Current might have been changed; synchronize
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						l_i___0 := 0
				when 4 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 9 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						l_continue := False
						if l_i___0 < ga_len then
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_path___0 := l_in_curdir[l_i___0]
							if l_path___0.is_void then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							l_short_name := (create {P_FILEIO_STATIC}).shorten_fname (l_path___0, l_curdir)
							update_class_fields -- Current might have been changed; synchronize
							if l_short_name.is_void then
								l_short_name := l_path___0
							end
							l_tmp___12 := ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.is_unique (l_short_name, l_i___0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___12.to_boolean then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_fnames[l_i___0]), create {CE_INTEGER_8_POINTER}.make_cast (l_short_name)).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_tmp___13 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_short_name))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___14 := strlen (ce_string ("/"))
						update_class_fields -- Current might have been changed; synchronize
						l_rel_path := (create {P_MISC2_STATIC}).alloc ((((l_tmp___13 + l_tmp___14) + {NATURAL_32} 2).to_integer_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_rel_path.is_void then
							l_pos := -1 + 10 -- goto theend
						end
				when 7 then
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_rel_path), ce_string (".")).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC1_STATIC}).add_pathsep (l_rel_path)
						update_class_fields -- Current might have been changed; synchronize
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_rel_path), create {CE_INTEGER_8_POINTER}.make_cast (l_short_name)).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fnames[l_i___0]))
						update_class_fields -- Current might have been changed; synchronize
						l_fnames[l_i___0] := l_rel_path
						update_class_fields -- Current might have been changed; synchronize
						l_sort_again := 1;
						(create {P_UI_STATIC}).ui_breakcheck
						update_class_fields -- Current might have been changed; synchronize
				when 8 then -- if done
						if (not l_break) then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 4 -- back to loop condition
				when 9 then -- loop done
						l_break := False
						l_continue := False
				when 10 then -- theend:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_curdir))
						update_class_fields -- Current might have been changed; synchronize
						if not l_in_curdir.is_void then
							l_i___0 := 0
							from
							until
								not (l_i___0 < ga_len)
							loop
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_in_curdir[l_i___0]))
								update_class_fields -- Current might have been changed; synchronize
								l_i___0 := l_i___0 + 1
							end
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_in_curdir))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_path_ga.item.ga_clear_strings
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_regmatch___0.item.regprog))
						update_class_fields -- Current might have been changed; synchronize
						if l_sort_again.to_boolean then
							((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.remove_duplicates
							update_class_fields -- Current might have been changed; synchronize
						end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	remove_duplicates
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_fnames: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_fnames := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ga_data);
			(create {P_MISC2_STATIC}).sort_strings (l_fnames, ga_len)
			update_class_fields -- Current might have been changed; synchronize
			l_i___0 := ga_len - 1
			from
			until
				not (not (l_return) and then (l_i___0 > 0))
			loop
				l_tmp := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_fnames[(l_i___0 - 1)]), create {CE_INTEGER_8_POINTER}.make_cast (l_fnames[l_i___0]))
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp = 0 then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fnames[l_i___0]))
					update_class_fields -- Current might have been changed; synchronize
					l_j := l_i___0 + 1
					from
					until
						not (l_j < ga_len)
					loop
						l_fnames[(l_j - 1)] := l_fnames[l_j]
						update_class_fields -- Current might have been changed; synchronize
						l_j := l_j + 1
					end
					Current.ga_len := ga_len - 1
					update_class_fields -- Current might have been changed; synchronize
				end
				l_i___0 := l_i___0 - 1
			end
		end

	ga_clear
		do
			(create {P_MISC2_STATIC}).vim_free (ga_data)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_init
			update_class_fields -- Current might have been changed; synchronize
		end

	ga_clear_strings
		local
			l_i___0: INTEGER_32
		do
			l_i___0 := 0
			from
			until
				not (l_i___0 < ga_len)
			loop
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ga_data)[l_i___0]))
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := l_i___0 + 1
			end
			((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_clear
			update_class_fields -- Current might have been changed; synchronize
		end

	ga_init
		do
			Current.ga_data := create {CE_VOID_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Current.ga_maxlen := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.ga_len := 0
			update_class_fields -- Current might have been changed; synchronize
		end

	ga_init2 (a_itemsize, a_growsize: INTEGER_32)
		do
			((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_init
			update_class_fields -- Current might have been changed; synchronize
			Current.ga_itemsize := a_itemsize
			update_class_fields -- Current might have been changed; synchronize
			Current.ga_growsize := a_growsize
			update_class_fields -- Current might have been changed; synchronize
		end

	ga_grow (a_n: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_len: NATURAL_32
			l_pp: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_n := a_n
			if ga_maxlen - ga_len < l_n then
				if l_n < ga_growsize then
					l_n := ga_growsize
				end
				l_len := (ga_itemsize * (ga_len + l_n)).to_natural_32
				l_pp := (create {P_MISC2_STATIC}).alloc_clear (l_len)
				update_class_fields -- Current might have been changed; synchronize
				if l_pp.is_void then
					Result := 0
					l_return := True
				end
				if not l_return then
					Current.ga_maxlen := ga_len + l_n
					update_class_fields -- Current might have been changed; synchronize
					if not ga_data.is_void then
						memmove (create {CE_VOID_POINTER}.make_cast (l_pp), ga_data, (ga_itemsize * ga_len).to_natural_32).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (ga_data)
						update_class_fields -- Current might have been changed; synchronize
					end
					Current.ga_data := create {CE_VOID_POINTER}.make_cast (l_pp)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				Result := 1
			end
		end

	ga_concat_strings: CE_POINTER [NATURAL_8]
		local
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
		do
			l_len := 0
			l_i___0 := 0
			from
			until
				not (l_i___0 < ga_len)
			loop
				l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ga_data)[l_i___0]))
				update_class_fields -- Current might have been changed; synchronize
				l_len := l_len + (l_tmp.to_integer_32 + 1)
				l_i___0 := l_i___0 + 1
			end
			l_s := (create {P_MISC2_STATIC}).alloc ((l_len + 1).to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			if not l_s.is_void then
				l_s.item := (('%/0/').code).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := 0
				from
				until
					not (l_i___0 < ga_len)
				loop
					if (l_s.item).to_integer_32 /= 0 then
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string (",")).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_s), create {CE_INTEGER_8_POINTER}.make_cast (create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ga_data)[l_i___0])).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := l_i___0 + 1
				end
			end
			Result := l_s
		end

	ga_concat (a_s: CE_POINTER [NATURAL_8])
		local
			l_len: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
		do
			l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_s))
			update_class_fields -- Current might have been changed; synchronize
			l_len := l_tmp.to_integer_32
			l_tmp___0 := ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_grow (l_len)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___0 = 1 then
				memmove (create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (ga_data) + ga_len)), create {CE_VOID_POINTER}.make_cast (a_s), l_len.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Current.ga_len := ga_len + l_len
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	ga_append (a_c: INTEGER_32)
		local
			l_tmp: INTEGER_32
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_grow (1)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp = 1 then
				create {CE_INTEGER_8_POINTER}.make_cast (ga_data)[ga_len] := a_c.to_integer_8
				update_class_fields -- Current might have been changed; synchronize
				Current.ga_len := ga_len + 1
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	append_ga_line
		local
			l_tmp: INTEGER_32
		do
			if ga_len > 0 then
				if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bin).to_boolean then
					if (create {CE_NATURAL_8_POINTER}.make_cast (ga_data)[(ga_len - 1)]).to_integer_32 = 13 then
						Current.ga_len := ga_len - 1
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_append (('%/0/').code)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum;
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MEMLINE_STATIC}).ml_append (l_tmp, create {CE_NATURAL_8_POINTER}.make_cast (ga_data), 0, 0).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Current.ga_len := 0
			update_class_fields -- Current might have been changed; synchronize
		end

	mch_expandpath (a_path: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.unix_expandpath (a_path, 0, a_flags___0, 0)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	match_checkcompoundpattern (a_ptr: CE_POINTER [NATURAL_8]; a_wlen: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				not (not (l_return) and then (l_i___0 + 1 < ga_len))
			loop
				l_p___0 := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ga_data)[(l_i___0 + 1)]
				l_tmp___1 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___2 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((a_ptr + a_wlen)), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), l_tmp___1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___2 = 0 then
					l_p___0 := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ga_data)[l_i___0]
					l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))
					update_class_fields -- Current might have been changed; synchronize
					l_len := l_tmp.to_integer_32
					if l_len <= a_wlen then
						l_tmp___0 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (((a_ptr + a_wlen) - l_len)), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), l_len.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0 = 0 then
							Result := 1
							l_return := True
						end
					end
				end
				if not l_return then
					l_i___0 := l_i___0 + (2)
				end
			end
			if not l_return then
				Result := 0
			end
		end

	write_spell_prefcond (a_fd: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_totlen: INTEGER_32
			l_x___0: NATURAL_32
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
		do
			l_x___0 := (1).to_natural_32
			if not a_fd.is_void then
				(create {P_MISC2_STATIC}).put_bytes (a_fd, ga_len.to_natural_32, 2).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			l_totlen := 2 + ga_len
			l_i___0 := 0
			from
			until
				not (l_i___0 < ga_len)
			loop
				l_p___0 := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ga_data)[l_i___0]
				if not l_p___0.is_void then
					l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))
					update_class_fields -- Current might have been changed; synchronize
					l_len := l_tmp.to_integer_32
					if not a_fd.is_void then
						fputc (l_len, a_fd).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := fwrite (create {CE_VOID_POINTER}.make_cast (l_p___0), l_len.to_natural_32, (1).to_natural_32, a_fd)
						update_class_fields -- Current might have been changed; synchronize
						l_x___0 := (l_x___0).bit_and (l_tmp___0)
					end
					l_totlen := l_totlen + l_len
				elseif not a_fd.is_void then
					fputc (0, a_fd).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_i___0 := l_i___0 + 1
			end
			Result := l_totlen
		end

	spell_suggest_list (a_word: CE_POINTER [NATURAL_8]; a_maxcount, a_need_cap, a_interactive: INTEGER_32)
		local
			l_sug: CE_ARRAY [PD_SUGINFO_S]
			l_i___0: INTEGER_32
			l_stp: CE_POINTER [PD_SUGGEST_S]
			l_wcopy: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_SUGINFO_S]} l_sug.make (<<1>>);

			(create {P_SPELL_STATIC}).spell_find_suggest (a_word, 0, l_sug, a_maxcount, 0, a_need_cap, a_interactive)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_init2 (({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, l_sug.item.su_ga.ga_len + 1)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___1 := ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_grow (l_sug.item.su_ga.ga_len)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___1 = 1 then
				l_i___0 := 0
				from
				until
					not (not (l_break) and then (l_i___0 < l_sug.item.su_ga.ga_len))
				loop
					l_break := False
					l_stp := create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (l_sug.item.su_ga.ga_data) + l_i___0
					l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_sug.item.su_badptr + l_stp.item.st_orglen)))
					update_class_fields -- Current might have been changed; synchronize
					l_wcopy := (create {P_MISC2_STATIC}).alloc (((l_stp.item.st_wordlen).to_natural_32 + l_tmp) + {NATURAL_32} 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_wcopy.is_void then
						l_break := True
					end
					if not (l_break) then
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_wcopy), create {CE_INTEGER_8_POINTER}.make_cast (l_stp.item.st_word)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_wcopy + l_stp.item.st_wordlen)), create {CE_INTEGER_8_POINTER}.make_cast ((l_sug.item.su_badptr + l_stp.item.st_orglen))).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := ga_len
						Current.ga_len := ga_len + 1
						update_class_fields -- Current might have been changed; synchronize
						create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ga_data)[l_tmp___0] := l_wcopy
						update_class_fields -- Current might have been changed; synchronize
						l_i___0 := l_i___0 + 1
					end
				end
				l_break := False
			end
			l_sug.item.spell_find_cleanup
			update_class_fields -- Current might have been changed; synchronize
		end

	cleanup_suggestions (a_maxscore, a_keep: INTEGER_32): INTEGER_32
		local
			l_stp: CE_POINTER [PD_SUGGEST_S]
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_stp := create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (ga_data) + 0
			qsort (ga_data, ga_len.to_natural_32, (create {PD_SUGGEST_S}.make).structure_size.to_natural_32, (create {P_SPELL_STATIC}).sug_compare_address)
			update_class_fields -- Current might have been changed; synchronize
			if ga_len > a_keep then
				l_i___0 := a_keep
				from
				until
					not (l_i___0 < ga_len)
				loop
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((l_stp + l_i___0).item.st_word))
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := l_i___0 + 1
				end
				Current.ga_len := a_keep
				update_class_fields -- Current might have been changed; synchronize
				Result := ((l_stp + (a_keep - 1)).item.st_score)
				l_return := True
			end
			if not l_return then
				Result := a_maxscore
			end
		end

	get_attr_entry (a_aep: CE_POINTER [PD_ATTR_ENTRY]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_taep: CE_POINTER [PD_ATTR_ENTRY]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					Current.ga_itemsize := ((create {PD_ATTR_ENTRY}.make).structure_size.to_natural_32).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					Current.ga_growsize := 7
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := 0
				when 1 then -- loop condition:
					if not (not (l_return) and then (l_i___0 < ga_len)) then
						l_pos := -1 + 20 -- skip loop
					end
				when 2 then -- loop body:
						l_taep := create {CE_CLASS_POINTER [PD_ATTR_ENTRY]}.make_cast (ga_data) + l_i___0
						if (a_aep.item.ae_attr).to_integer_32 /= (l_taep.item.ae_attr).to_integer_32 then
							l_pos := -1 + 19 -- skip if block
						end
				when 3 then -- if:
						if not ((c_pointer = ((create {P_SYNTAX_STATIC}).gui_attr_table.item).c_pointer)) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_aep.item.ae_u.gui.fg_color = l_taep.item.ae_u.gui.fg_color then
							if a_aep.item.ae_u.gui.bg_color = l_taep.item.ae_u.gui.bg_color then
								if a_aep.item.ae_u.gui.sp_color = l_taep.item.ae_u.gui.sp_color then
									if (a_aep.item.ae_u.gui.font).is_equal (l_taep.item.ae_u.gui.font) then
										Result := (l_i___0 + 64)
										l_return := True
									else
										l_pos := -1 + 6 -- goto _L___4
									end
								else
									l_pos := -1 + 6 -- goto _L___4
								end
							else
								l_pos := -1 + 6 -- goto _L___4
							end
						else
							l_pos := -1 + 6 -- goto _L___4
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else: | _L___4:
						if not ((c_pointer = ((create {P_SYNTAX_STATIC}).term_attr_table.item).c_pointer)) then
							l_pos := -1 + 18 -- skip if block
						end
				when 7 then -- if:
						if ((a_aep.item.ae_u.term.start).is_void) /= ((l_taep.item.ae_u.term.start).is_void) then
							l_pos := -1 + 16 -- skip if block
						end
				when 8 then -- if:
						if not ((a_aep.item.ae_u.term.start).is_void) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___2
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 11 then -- else:
						l_tmp := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_aep.item.ae_u.term.start), create {CE_INTEGER_8_POINTER}.make_cast (l_taep.item.ae_u.term.start))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp /= 0 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if: | _L___2:
						if ((a_aep.item.ae_u.term.stop).is_void) = ((l_taep.item.ae_u.term.stop).is_void) then
							if (a_aep.item.ae_u.term.stop).is_void then
								Result := (l_i___0 + 64)
								l_return := True
							else
								l_tmp___0 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_aep.item.ae_u.term.stop), create {CE_INTEGER_8_POINTER}.make_cast (l_taep.item.ae_u.term.stop))
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___0 = 0 then
									Result := (l_i___0 + 64)
									l_return := True
								else
									l_pos := -1 + 18 -- goto _L___3
								end
							end
						else
							l_pos := -1 + 18 -- goto _L___3
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_pos := -1 + 18 -- goto _L___3
				when 15 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 18 -- goto _L___3
				when 17 then -- if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L___3:
						if (c_pointer = ((create {P_SYNTAX_STATIC}).cterm_attr_table.item).c_pointer) then
							if (a_aep.item.ae_u.cterm.fg_color).to_integer_32 = (l_taep.item.ae_u.cterm.fg_color).to_integer_32 then
								if (a_aep.item.ae_u.cterm.bg_color).to_integer_32 = (l_taep.item.ae_u.cterm.bg_color).to_integer_32 then
									Result := (l_i___0 + 64)
									l_return := True
								end
							end
						end
				when 19 then -- if done | if done
						if not l_return then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 20 then -- loop done
					if not l_return and then (ga_len + 64 > 65_535) then
						if recursive___8.item.to_boolean then
							l_tmp___1 := gettext (ce_string ("E424: Too many different highlighting attributes in use"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
						if not l_return then
							recursive___8.item := 1
							clear_hl_tables
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).must_redraw.item := 50
							update_class_fields -- Current might have been changed; synchronize
							l_i___0 := 0
							from
							until
								not (l_i___0 < (create {P_SYNTAX_STATIC}).highlight_ga.item.item.ga_len)
							loop
								(create {P_SYNTAX_STATIC}).set_hl_attr (l_i___0)
								update_class_fields -- Current might have been changed; synchronize
								l_i___0 := l_i___0 + 1
							end
							recursive___8.item := 0
						end
					end
					if not l_return then
						l_tmp___2 := ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_grow (1)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2 = 0 then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_taep := create {CE_CLASS_POINTER [PD_ATTR_ENTRY]}.make_cast (ga_data) + ga_len
						memset (create {CE_VOID_POINTER}.make_cast (l_taep), 0, (create {PD_ATTR_ENTRY}.make).structure_size.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_taep.item.ae_attr := a_aep.item.ae_attr
						update_class_fields -- Current might have been changed; synchronize
						if (c_pointer = ((create {P_SYNTAX_STATIC}).gui_attr_table.item).c_pointer) then
							l_taep.item.ae_u.gui.fg_color := a_aep.item.ae_u.gui.fg_color
							update_class_fields -- Current might have been changed; synchronize
							l_taep.item.ae_u.gui.bg_color := a_aep.item.ae_u.gui.bg_color
							update_class_fields -- Current might have been changed; synchronize
							l_taep.item.ae_u.gui.sp_color := a_aep.item.ae_u.gui.sp_color
							update_class_fields -- Current might have been changed; synchronize
							l_taep.item.ae_u.gui.font := a_aep.item.ae_u.gui.font
							update_class_fields -- Current might have been changed; synchronize
						end
						if (c_pointer = ((create {P_SYNTAX_STATIC}).term_attr_table.item).c_pointer) then
							if (a_aep.item.ae_u.term.start).is_void then
								l_taep.item.ae_u.term.start := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_taep.item.ae_u.term.start := (create {P_MISC2_STATIC}).vim_strsave (a_aep.item.ae_u.term.start)
								update_class_fields -- Current might have been changed; synchronize
							end
							if (a_aep.item.ae_u.term.stop).is_void then
								l_taep.item.ae_u.term.stop := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_taep.item.ae_u.term.stop := (create {P_MISC2_STATIC}).vim_strsave (a_aep.item.ae_u.term.stop)
								update_class_fields -- Current might have been changed; synchronize
							end
						elseif (c_pointer = ((create {P_SYNTAX_STATIC}).cterm_attr_table.item).c_pointer) then
							l_taep.item.ae_u.cterm.fg_color := a_aep.item.ae_u.cterm.fg_color
							update_class_fields -- Current might have been changed; synchronize
							l_taep.item.ae_u.cterm.bg_color := a_aep.item.ae_u.cterm.bg_color
							update_class_fields -- Current might have been changed; synchronize
						end
						Current.ga_len := ga_len + 1
						update_class_fields -- Current might have been changed; synchronize
						Result := ((ga_len - 1) + 64)
					end
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	win_size_save
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
		do
			((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_init2 (({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32, 1)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___1 := (create {P_WINDOW_STATIC}).win_count
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___2 := ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_grow (l_tmp___1 * 2)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___2 = 1 then
				l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
				from
				until
					l_wp___0.is_void
				loop
					l_tmp := ga_len
					Current.ga_len := ga_len + 1
					update_class_fields -- Current might have been changed; synchronize
					create {CE_INTEGER_32_POINTER}.make_cast (ga_data)[l_tmp] := l_wp___0.item.w_width + l_wp___0.item.w_vsep_width
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := ga_len
					Current.ga_len := ga_len + 1
					update_class_fields -- Current might have been changed; synchronize
					create {CE_INTEGER_32_POINTER}.make_cast (ga_data)[l_tmp___0] := l_wp___0.item.w_height
					update_class_fields -- Current might have been changed; synchronize
					l_wp___0 := l_wp___0.item.w_next
				end
			end
		end

	win_size_restore
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			l_tmp___1 := (create {P_WINDOW_STATIC}).win_count
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___1 * 2 = ga_len then
				l_i___0 := 0
				l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
				from
				until
					l_wp___0.is_void
				loop
					l_tmp := l_i___0
					l_i___0 := l_i___0 + 1;
					(l_wp___0.item.w_frame).item.frame_setwidth (create {CE_INTEGER_32_POINTER}.make_cast (ga_data)[l_tmp])
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := l_i___0
					l_i___0 := l_i___0 + 1
					l_wp___0.item.win_setheight_win (create {CE_INTEGER_32_POINTER}.make_cast (ga_data)[l_tmp___0])
					update_class_fields -- Current might have been changed; synchronize
					l_wp___0 := l_wp___0.item.w_next
				end
				(create {P_WINDOW_STATIC}).win_comp_pos.do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	get_arglist (a_str___1: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_str___1.is_void
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_str___1 := a_str___1;
			((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_init2 (({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 20)
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				not (not (l_return) and then ((l_str___1.item).to_integer_32 /= 0))
			loop
				l_tmp := ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_grow (1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp = 0 then
					((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_clear
					update_class_fields -- Current might have been changed; synchronize
					Result := 0
					l_return := True
				end
				if not l_return then
					l_tmp___0 := ga_len
					Current.ga_len := ga_len + 1
					update_class_fields -- Current might have been changed; synchronize
					create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ga_data)[l_tmp___0] := l_str___1
					update_class_fields -- Current might have been changed; synchronize
					l_str___1 := do_one_arg (l_str___1)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				Result := 1
			end
		end

	store_loop_line (a_line: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer))).item.ga_grow (1)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp = 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				(create {CE_CLASS_POINTER [PD_WCMD_T]}.make_cast (ga_data) + ga_len).item.line := (create {P_MISC2_STATIC}).vim_strsave (a_line)
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_WCMD_T]}.make_cast (ga_data) + ga_len).item.lnum := (create {P_GLOBALS_STATIC}).sourcing_lnum.item
				update_class_fields -- Current might have been changed; synchronize
				Current.ga_len := ga_len + 1
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
			end
		end

feature {PD_GROWARRAY} -- private routines

	do_one_arg (a_str___1: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_str___1.is_void
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_inbacktick: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			l_str___1 := a_str___1
			l_inbacktick := 0
			l_p___0 := l_str___1
			from
			until
				not (not (l_break) and then ((l_str___1.item).to_boolean))
			loop
				l_break := False
				if ((create {P_CHARSET_STATIC}).rem_backslash (l_str___1)).to_boolean then
					l_tmp := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___0 := l_str___1
					l_str___1 := l_str___1 + 1
					l_tmp.item := l_tmp___0.item
					l_tmp___1 := l_p___0
					l_p___0 := l_p___0 + 1
					l_tmp___1.item := l_str___1.item
				else
					if not l_inbacktick.to_boolean then
						if ((create {P_MISC2_STATIC}).vim_isspace ((l_str___1.item).to_integer_32)).to_boolean then
							l_break := True
						end
					end
					if not (l_break) then
						if (l_str___1.item).to_integer_32 = 96 then
							l_inbacktick := (l_inbacktick).bit_xor ((1))
						end
						l_tmp___3 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___3.item := l_str___1.item
					end
				end
				if not (l_break) then
					l_str___1 := l_str___1 + 1
				end
			end
			l_break := False
			l_str___1 := (create {P_CHARSET_STATIC}).skipwhite (l_str___1)
			l_p___0.item := (('%/0/').code).to_natural_8
			Result := l_str___1
		end

	gettail_dir (a_fname: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_fname.is_void
		local
			l_dir_end: CE_POINTER [NATURAL_8]
			l_next_dir_end: CE_POINTER [NATURAL_8]
			l_look_for_sep: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
		do
			l_dir_end := a_fname
			l_next_dir_end := a_fname
			l_look_for_sep := 1
			l_p___0 := a_fname
			from
			until
				(l_p___0.item).to_integer_32 = 0
			loop
				if ((create {P_MISC1_STATIC}).vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
					if l_look_for_sep.to_boolean then
						l_next_dir_end := l_p___0
						l_look_for_sep := 0
					end
				else
					if not l_look_for_sep.to_boolean then
						l_dir_end := l_next_dir_end
					end
					l_look_for_sep := 1
				end
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					l_tmp___1 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
				else
					l_tmp___1 := 1
				end
				l_p___0 := l_p___0 + l_tmp___1
			end
			Result := l_dir_end
		end

	find_previous_pathsep (a_path: CE_POINTER [NATURAL_8]; a_psep: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		require
			not a_psep.is_void
		local
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
		do
			if ((a_psep.item).c_pointer.to_integer_32).to_natural_32 > (a_path.c_pointer.to_integer_32).to_natural_32 then
				if ((create {P_MISC1_STATIC}).vim_ispathsep (((a_psep.item).item).to_integer_32)).to_boolean then
					a_psep.item := (a_psep.item) - 1
				end
			end
			from
			until
				not (not (l_return) and then (((a_psep.item).c_pointer.to_integer_32).to_natural_32 > (a_path.c_pointer.to_integer_32).to_natural_32))
			loop
				if ((create {P_MISC1_STATIC}).vim_ispathsep (((a_psep.item).item).to_integer_32)).to_boolean then
					Result := 1
					l_return := True
				end
				if not l_return then
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp___2 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([a_path, a_psep.item - 1])) + 1
					else
						l_tmp___2 := 1
					end
					a_psep.item := a_psep.item - l_tmp___2
				end
			end
			if not l_return then
				Result := 0
			end
		end

	clear_hl_tables
		local
			l_i___0: INTEGER_32
			l_taep: CE_POINTER [PD_ATTR_ENTRY]
		do
			((create {P_SYNTAX_STATIC}).gui_attr_table.item).item.ga_clear
			l_i___0 := 0
			from
			until
				not (l_i___0 < (create {P_SYNTAX_STATIC}).term_attr_table.item.item.ga_len)
			loop
				l_taep := create {CE_CLASS_POINTER [PD_ATTR_ENTRY]}.make_cast ((create {P_SYNTAX_STATIC}).term_attr_table.item.item.ga_data) + l_i___0;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_taep.item.ae_u.term.start));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_taep.item.ae_u.term.stop))
				l_i___0 := l_i___0 + 1
			end
			((create {P_SYNTAX_STATIC}).term_attr_table.item).item.ga_clear;
			((create {P_SYNTAX_STATIC}).cterm_attr_table.item).item.ga_clear
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ga_len := a_other.ga_len
			ga_maxlen := a_other.ga_maxlen
			ga_itemsize := a_other.ga_itemsize
			ga_growsize := a_other.ga_growsize
			ga_data := a_other.ga_data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ga_len = a_other.ga_len and
				ga_maxlen = a_other.ga_maxlen and
				ga_itemsize = a_other.ga_itemsize and
				ga_growsize = a_other.ga_growsize and
				ga_data.is_equal (a_other.ga_data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ga_len"),
					create {CE_STRUCTURE_FIELD}.make ("ga_maxlen"),
					create {CE_STRUCTURE_FIELD}.make ("ga_itemsize"),
					create {CE_STRUCTURE_FIELD}.make ("ga_growsize"),
					create {CE_STRUCTURE_FIELD}.make ("ga_data")
				>>)
			init_structure_info
		end

end
