class
	PD_LPOS_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	lnum: INTEGER_32 assign set_lnum

	col: INTEGER_32 assign set_col

feature {ANY} -- field setters

	set_lnum (a_lnum: INTEGER_32)
		do
			lnum := a_lnum
			update_memory_field ("lnum")
		end

	set_col (a_col: INTEGER_32)
		do
			col := a_col
			update_memory_field ("col")
		end

feature {ANY} -- public routines

	syn_add_end_off (a_regmatch___0: CE_POINTER [PD_REGMMATCH_T]; a_spp: CE_POINTER [PD_SYN_PATTERN]; a_idx, a_extra: INTEGER_32)
		require
			not a_regmatch___0.is_void
			not a_spp.is_void
		local
			l_col: INTEGER_32
			l_off___0: INTEGER_32
			l_base: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_break: BOOLEAN
		do
			if (((a_spp.item.sp_off_flags).to_integer_32).bit_and (((1).bit_shift_left (a_idx)))).to_boolean then
				Current.lnum := a_regmatch___0.item.startpos[0].lnum
				update_class_fields -- Current might have been changed; synchronize
				l_col := a_regmatch___0.item.startpos[0].col
				l_off___0 := a_spp.item.sp_offsets[a_idx] + a_extra
			else
				Current.lnum := a_regmatch___0.item.endpos[0].lnum
				update_class_fields -- Current might have been changed; synchronize
				l_col := a_regmatch___0.item.endpos[0].col
				l_off___0 := a_spp.item.sp_offsets[a_idx]
			end
			if lnum > (create {P_SYNTAX_STATIC}).syn_buf.item.item.b_ml.ml_line_count then
				l_col := 0
			elseif l_off___0 /= 0 then
				l_base := ((create {P_SYNTAX_STATIC}).syn_buf.item).item.ml_get_buf (lnum, 0)
				update_class_fields -- Current might have been changed; synchronize
				l_p___0 := l_base + l_col
				if l_off___0 > 0 then
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___1 := l_off___0
						l_off___0 := l_off___0 - 1
						if l_tmp___1 > 0 then
							if (l_p___0.item).to_integer_32 = 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___0 := l_tmp
							else
								l_tmp___0 := 1
							end
							l_p___0 := l_p___0 + l_tmp___0
						end
					end
					l_break := False
				elseif l_off___0 < 0 then
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___4 := l_off___0
						l_off___0 := l_off___0 + 1
						if l_tmp___4 < 0 then
							if not ((l_base.c_pointer.to_integer_32).to_natural_32 < (l_p___0.c_pointer.to_integer_32).to_natural_32) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___2 := (create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_base, l_p___0 - 1])
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___3 := l_tmp___2 + 1
							else
								l_tmp___3 := 1
							end
							l_p___0 := l_p___0 - l_tmp___3
						end
					end
					l_break := False
				end
				l_col := l_p___0.distance (l_base)
			end
			Current.col := l_col
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			lnum := a_other.lnum
			col := a_other.col
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				lnum = a_other.lnum and
				col = a_other.col
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("lnum"),
					create {CE_STRUCTURE_FIELD}.make ("col")
				>>)
			init_structure_info
		end

end
