class
	PD_MATCH_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create rm.make
			create {CE_CLASS_POINTER [PD_FILE_BUFFER]} buf.make
			create tm.make
		end

feature {ANY} -- fields

	rm: PD_REGMMATCH_T assign set_rm

	buf: CE_POINTER [PD_FILE_BUFFER] assign set_buf

	lnum: INTEGER_32 assign set_lnum

	attr: INTEGER_32 assign set_attr

	attr_cur: INTEGER_32 assign set_attr_cur

	first_lnum: INTEGER_32 assign set_first_lnum

	startcol: INTEGER_32 assign set_startcol

	endcol: INTEGER_32 assign set_endcol

	tm: SD_TIMEVAL assign set_tm

feature {ANY} -- field setters

	set_rm (a_rm: PD_REGMMATCH_T)
		do
			rm := a_rm
			update_memory_field ("rm")
		end

	set_buf (a_buf: CE_POINTER [PD_FILE_BUFFER])
		do
			buf := a_buf
			update_memory_field ("buf")
		end

	set_lnum (a_lnum: INTEGER_32)
		do
			lnum := a_lnum
			update_memory_field ("lnum")
		end

	set_attr (a_attr: INTEGER_32)
		do
			attr := a_attr
			update_memory_field ("attr")
		end

	set_attr_cur (a_attr_cur: INTEGER_32)
		do
			attr_cur := a_attr_cur
			update_memory_field ("attr_cur")
		end

	set_first_lnum (a_first_lnum: INTEGER_32)
		do
			first_lnum := a_first_lnum
			update_memory_field ("first_lnum")
		end

	set_startcol (a_startcol: INTEGER_32)
		do
			startcol := a_startcol
			update_memory_field ("startcol")
		end

	set_endcol (a_endcol: INTEGER_32)
		do
			endcol := a_endcol
			update_memory_field ("endcol")
		end

	set_tm (a_tm: SD_TIMEVAL)
		do
			tm := a_tm
			update_memory_field ("tm")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			rm := a_other.rm.twin
			buf := a_other.buf
			lnum := a_other.lnum
			attr := a_other.attr
			attr_cur := a_other.attr_cur
			first_lnum := a_other.first_lnum
			startcol := a_other.startcol
			endcol := a_other.endcol
			tm := a_other.tm.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				rm.is_equal (a_other.rm) and
				buf.is_equal (a_other.buf) and
				lnum = a_other.lnum and
				attr = a_other.attr and
				attr_cur = a_other.attr_cur and
				first_lnum = a_other.first_lnum and
				startcol = a_other.startcol and
				endcol = a_other.endcol and
				tm.is_equal (a_other.tm)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("rm"),
					create {CE_STRUCTURE_FIELD}.make ("buf"),
					create {CE_STRUCTURE_FIELD}.make ("lnum"),
					create {CE_STRUCTURE_FIELD}.make ("attr"),
					create {CE_STRUCTURE_FIELD}.make ("attr_cur"),
					create {CE_STRUCTURE_FIELD}.make ("first_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("startcol"),
					create {CE_STRUCTURE_FIELD}.make ("endcol"),
					create {CE_STRUCTURE_FIELD}.make ("tm")
				>>)
			init_structure_info
		end

end
