class
	PD_MEMFILE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_UNISTD_STATIC
		redefine
			copy,
			is_equal
		end
	S_BITS_ERRNO_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_SYS_STAT_STATIC
		redefine
			copy,
			is_equal
		end
	S_FCNTL_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} mf_fname.make
			create {CE_NATURAL_8_POINTER} mf_ffname.make
			create {CE_CLASS_POINTER [PD_BLOCK_HDR]} mf_free_first.make
			create {CE_CLASS_POINTER [PD_BLOCK_HDR]} mf_used_first.make
			create {CE_CLASS_POINTER [PD_BLOCK_HDR]} mf_used_last.make
			create {CE_POINTER_ARRAY [PD_BLOCK_HDR]} mf_hash.make (<<64>>)
			create {CE_POINTER_ARRAY [PD_NR_TRANS]} mf_trans.make (<<64>>)
			create {CE_CLASS_POINTER [PD_FILE_BUFFER]} mf_buffer.make
			create {CE_NATURAL_8_ARRAY} mf_seed.make (<<8>>)
			create {CE_NATURAL_8_POINTER} mf_old_key.make
			create {CE_NATURAL_8_ARRAY} mf_old_seed.make (<<8>>)
			Precursor
		end

feature {ANY} -- fields

	mf_fname: CE_POINTER [NATURAL_8] assign set_mf_fname

	mf_ffname: CE_POINTER [NATURAL_8] assign set_mf_ffname

	mf_fd: INTEGER_32 assign set_mf_fd

	mf_free_first: CE_POINTER [PD_BLOCK_HDR] assign set_mf_free_first

	mf_used_first: CE_POINTER [PD_BLOCK_HDR] assign set_mf_used_first

	mf_used_last: CE_POINTER [PD_BLOCK_HDR] assign set_mf_used_last

	mf_used_count: NATURAL_32 assign set_mf_used_count

	mf_used_count_max: NATURAL_32 assign set_mf_used_count_max

	mf_hash: CE_ARRAY [CE_POINTER [PD_BLOCK_HDR]]

	mf_trans: CE_ARRAY [CE_POINTER [PD_NR_TRANS]]

	mf_blocknr_max: INTEGER_32 assign set_mf_blocknr_max

	mf_blocknr_min: INTEGER_32 assign set_mf_blocknr_min

	mf_neg_count: INTEGER_32 assign set_mf_neg_count

	mf_infile_count: INTEGER_32 assign set_mf_infile_count

	mf_page_size: NATURAL_32 assign set_mf_page_size

	mf_dirty: INTEGER_32 assign set_mf_dirty

	mf_buffer: CE_POINTER [PD_FILE_BUFFER] assign set_mf_buffer

	mf_seed: CE_ARRAY [NATURAL_8]

	mf_old_key: CE_POINTER [NATURAL_8] assign set_mf_old_key

	mf_old_cm: INTEGER_32 assign set_mf_old_cm

	mf_old_seed: CE_ARRAY [NATURAL_8]

feature {ANY} -- field setters

	set_mf_fname (a_mf_fname: CE_POINTER [NATURAL_8])
		do
			mf_fname := a_mf_fname
			update_memory_field ("mf_fname")
		end

	set_mf_ffname (a_mf_ffname: CE_POINTER [NATURAL_8])
		do
			mf_ffname := a_mf_ffname
			update_memory_field ("mf_ffname")
		end

	set_mf_fd (a_mf_fd: INTEGER_32)
		do
			mf_fd := a_mf_fd
			update_memory_field ("mf_fd")
		end

	set_mf_free_first (a_mf_free_first: CE_POINTER [PD_BLOCK_HDR])
		do
			mf_free_first := a_mf_free_first
			update_memory_field ("mf_free_first")
		end

	set_mf_used_first (a_mf_used_first: CE_POINTER [PD_BLOCK_HDR])
		do
			mf_used_first := a_mf_used_first
			update_memory_field ("mf_used_first")
		end

	set_mf_used_last (a_mf_used_last: CE_POINTER [PD_BLOCK_HDR])
		do
			mf_used_last := a_mf_used_last
			update_memory_field ("mf_used_last")
		end

	set_mf_used_count (a_mf_used_count: NATURAL_32)
		do
			mf_used_count := a_mf_used_count
			update_memory_field ("mf_used_count")
		end

	set_mf_used_count_max (a_mf_used_count_max: NATURAL_32)
		do
			mf_used_count_max := a_mf_used_count_max
			update_memory_field ("mf_used_count_max")
		end

	set_mf_blocknr_max (a_mf_blocknr_max: INTEGER_32)
		do
			mf_blocknr_max := a_mf_blocknr_max
			update_memory_field ("mf_blocknr_max")
		end

	set_mf_blocknr_min (a_mf_blocknr_min: INTEGER_32)
		do
			mf_blocknr_min := a_mf_blocknr_min
			update_memory_field ("mf_blocknr_min")
		end

	set_mf_neg_count (a_mf_neg_count: INTEGER_32)
		do
			mf_neg_count := a_mf_neg_count
			update_memory_field ("mf_neg_count")
		end

	set_mf_infile_count (a_mf_infile_count: INTEGER_32)
		do
			mf_infile_count := a_mf_infile_count
			update_memory_field ("mf_infile_count")
		end

	set_mf_page_size (a_mf_page_size: NATURAL_32)
		do
			mf_page_size := a_mf_page_size
			update_memory_field ("mf_page_size")
		end

	set_mf_dirty (a_mf_dirty: INTEGER_32)
		do
			mf_dirty := a_mf_dirty
			update_memory_field ("mf_dirty")
		end

	set_mf_buffer (a_mf_buffer: CE_POINTER [PD_FILE_BUFFER])
		do
			mf_buffer := a_mf_buffer
			update_memory_field ("mf_buffer")
		end

	set_mf_old_key (a_mf_old_key: CE_POINTER [NATURAL_8])
		do
			mf_old_key := a_mf_old_key
			update_memory_field ("mf_old_key")
		end

	set_mf_old_cm (a_mf_old_cm: INTEGER_32)
		do
			mf_old_cm := a_mf_old_cm
			update_memory_field ("mf_old_cm")
		end

feature {ANY} -- public routines

	mf_new_page_size (a_new_size: NATURAL_32)
		do
			(create {P_MEMFILE_STATIC}).total_mem_used.item := (create {P_MEMFILE_STATIC}).total_mem_used.item + (a_new_size - mf_page_size).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Current.mf_page_size := a_new_size
			update_class_fields -- Current might have been changed; synchronize
		end

	mf_new (a_negative, a_page_count___0: INTEGER_32): CE_POINTER [PD_BLOCK_HDR]
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_freep: CE_POINTER [PD_BLOCK_HDR]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_hp := mf_release ((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer)), a_page_count___0)
					update_class_fields -- Current might have been changed; synchronize
					l_freep := mf_free_first
					if a_negative.to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not l_freep.is_void then
							if l_freep.item.bh_page_count >= a_page_count___0 then
								if l_freep.item.bh_page_count > a_page_count___0 then
									if l_hp.is_void then
										l_hp := mf_alloc_bhdr ((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer)), a_page_count___0)
										update_class_fields -- Current might have been changed; synchronize
										if l_hp.is_void then
											Result := (create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
											l_return := True
										end
									end
									if not l_return then
										l_hp.item.bh_bnum := l_freep.item.bh_bnum
										update_class_fields -- Current might have been changed; synchronize
										l_freep.item.bh_bnum := l_freep.item.bh_bnum + a_page_count___0.to_integer_32
										update_class_fields -- Current might have been changed; synchronize
										l_freep.item.bh_page_count := l_freep.item.bh_page_count - a_page_count___0
										update_class_fields -- Current might have been changed; synchronize
									end
								elseif l_hp.is_void then
									l_tmp := (create {P_MISC2_STATIC}).alloc (mf_page_size * a_page_count___0.to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
									l_p___0 := l_tmp
									if l_p___0.is_void then
										Result := (create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
										l_return := True
									end
									if not l_return then
										l_hp := ((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer))).item.mf_rem_free
										update_class_fields -- Current might have been changed; synchronize
										l_hp.item.bh_data := l_p___0
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									l_freep := ((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer))).item.mf_rem_free
									update_class_fields -- Current might have been changed; synchronize
									l_hp.item.bh_bnum := l_freep.item.bh_bnum
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_freep))
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_pos := -1 + 3 -- goto _L___0
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___0:
						if l_hp.is_void then
							l_hp := mf_alloc_bhdr ((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer)), a_page_count___0)
							update_class_fields -- Current might have been changed; synchronize
							if l_hp.is_void then
								Result := (create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
								l_return := True
							end
						end
						if not l_return then
							if a_negative.to_boolean then
								l_tmp___0 := mf_blocknr_min
								Current.mf_blocknr_min := mf_blocknr_min - 1
								update_class_fields -- Current might have been changed; synchronize
								l_hp.item.bh_bnum := l_tmp___0
								update_class_fields -- Current might have been changed; synchronize
								Current.mf_neg_count := mf_neg_count + 1
								update_class_fields -- Current might have been changed; synchronize
							else
								l_hp.item.bh_bnum := mf_blocknr_max
								update_class_fields -- Current might have been changed; synchronize
								Current.mf_blocknr_max := mf_blocknr_max + a_page_count___0.to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 4 then
					if not l_return then
						l_hp.item.bh_flags := (3).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						Current.mf_dirty := 1
						update_class_fields -- Current might have been changed; synchronize
						l_hp.item.bh_page_count := a_page_count___0
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer))).item.mf_ins_used (l_hp)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer))).item.mf_ins_hash (l_hp)
						update_class_fields -- Current might have been changed; synchronize
						memset (create {CE_VOID_POINTER}.make_cast (l_hp.item.bh_data), 0, mf_page_size * a_page_count___0.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Result := l_hp
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mf_get (a_nr: INTEGER_32; a_page_count___0: INTEGER_32): CE_POINTER [PD_BLOCK_HDR]
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			if a_nr >= mf_blocknr_max then
				Result := (create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
				l_return := True
			elseif a_nr <= mf_blocknr_min then
				Result := (create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_hp := ((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer))).item.mf_find_hash (a_nr)
				update_class_fields -- Current might have been changed; synchronize
				if l_hp.is_void then
					if a_nr < 0 then
						Result := (create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
						l_return := True
					elseif a_nr >= mf_infile_count then
						Result := (create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						l_hp := mf_release ((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer)), a_page_count___0)
						update_class_fields -- Current might have been changed; synchronize
						if l_hp.is_void then
							l_hp := mf_alloc_bhdr ((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer)), a_page_count___0)
							update_class_fields -- Current might have been changed; synchronize
							if l_hp.is_void then
								Result := (create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
								l_return := True
							end
						end
					end
					if not l_return then
						l_hp.item.bh_bnum := a_nr
						update_class_fields -- Current might have been changed; synchronize
						l_hp.item.bh_flags := (0).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_hp.item.bh_page_count := a_page_count___0
						update_class_fields -- Current might have been changed; synchronize
						l_tmp := ((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer))).item.mf_read (l_hp)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp = 0 then
							l_hp.item.mf_free_bhdr
							update_class_fields -- Current might have been changed; synchronize
							Result := (create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
							l_return := True
						end
					end
				else
					((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer))).item.mf_rem_used (l_hp)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MEMFILE_STATIC}).mf_rem_hash ((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer)), l_hp)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				l_hp.item.bh_flags := (((l_hp.item.bh_flags).to_integer_32).bit_or (2)).to_integer_8
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer))).item.mf_ins_used (l_hp)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer))).item.mf_ins_hash (l_hp)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_hp
			end
		end

	mf_sync (a_flags___0: INTEGER_32): INTEGER_32
		local
			l_status: INTEGER_32
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_got_int_save: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_got_int_save := (create {P_GLOBALS_STATIC}).got_int.item
					if mf_fd < 0 then
						Current.mf_dirty := 0
						update_class_fields -- Current might have been changed; synchronize
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:;
						(create {P_GLOBALS_STATIC}).got_int.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_status := 1
						l_hp := mf_used_last
				when 2 then -- loop condition:
						if not (not (l_break) and then (not l_hp.is_void)) then
							l_pos := -1 + 15 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						if not (((a_flags___0).bit_and (1)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 6 then -- else:
						if not (l_hp.item.bh_bnum >= 0) then
							l_pos := -1 + 14 -- skip if block
						end
				when 7 then -- if: | _L___0:
						if not ((((l_hp.item.bh_flags).to_integer_32).bit_and (1)).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
						if l_status /= 1 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 11 then -- else:
						if not (l_hp.item.bh_bnum >= 0) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if not (l_hp.item.bh_bnum < mf_infile_count) then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L:
						if ((a_flags___0).bit_and (8)).to_boolean then
							if l_hp.item.bh_bnum /= 0 then
								l_continue := True
							end
						end
						if not (l_break or l_continue) then
							l_tmp := ((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer))).item.mf_write (l_hp)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp = 0 then
								if l_status = 0 then
									l_break := True
								end
								if not (l_break or l_continue) then
									l_status := 0
								end
							end
						end
						if not (l_break or l_continue) then
							if ((a_flags___0).bit_and (2)).to_boolean then
								l_tmp___0 := (create {P_UI_STATIC}).ui_char_avail
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___0.to_boolean then
									l_break := True
								end
							else
								(create {P_UI_STATIC}).ui_breakcheck
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if not (l_break or l_continue) and then (((create {P_GLOBALS_STATIC}).got_int.item).to_boolean) then
							l_break := True
						end
				when 14 then -- if done | if done | if done | if done | if done
						if (not l_break) then
							l_hp := l_hp.item.bh_prev
						end
						l_pos := -1 + 2 -- back to loop condition
				when 15 then -- loop done
						l_break := False
						l_continue := False
						if l_hp.is_void then
							Current.mf_dirty := 0
							update_class_fields -- Current might have been changed; synchronize
						elseif l_status = 0 then
							Current.mf_dirty := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						if ((a_flags___0).bit_and (4)).to_boolean then
							if ((create {P_OPTION_STATIC}).p_sws.item.item.item).to_integer_32 /= 0 then
								l_tmp___2 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_sws.item.item), ce_string ("fsync"))
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___2 = 0 then
									l_tmp___1 := fsync (mf_fd)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___1.to_boolean then
										l_status := 0
									end
								else
									sync
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						(create {P_GLOBALS_STATIC}).got_int.item := ((create {P_GLOBALS_STATIC}).got_int.item).bit_or (l_got_int_save)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_status
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mf_ins_hash (a_hp: CE_POINTER [PD_BLOCK_HDR])
		require
			not a_hp.is_void
		local
			l_hhp: CE_POINTER [PD_BLOCK_HDR]
			l_hash: INTEGER_32
		do
			l_hash := ((a_hp.item.bh_bnum).bit_and (63)).to_integer_32
			l_hhp := mf_hash[l_hash]
			a_hp.item.bh_hash_next := l_hhp
			update_class_fields -- Current might have been changed; synchronize
			a_hp.item.bh_hash_prev := create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			if not l_hhp.is_void then
				l_hhp.item.bh_hash_prev := a_hp
				update_class_fields -- Current might have been changed; synchronize
			end
			mf_hash[l_hash] := a_hp
			update_class_fields -- Current might have been changed; synchronize
		end

	mf_find_hash (a_nr: INTEGER_32): CE_POINTER [PD_BLOCK_HDR]
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_break: BOOLEAN
		do
			l_hp := mf_hash[(a_nr).bit_and (63)]
			from
			until
				not (not (l_break) and then (not l_hp.is_void))
			loop
				l_break := False
				if l_hp.item.bh_bnum = a_nr then
					l_break := True
				end
				if not (l_break) then
					l_hp := l_hp.item.bh_hash_next
				end
			end
			l_break := False
			Result := l_hp
		end

	mf_ins_used (a_hp: CE_POINTER [PD_BLOCK_HDR])
		require
			not a_hp.is_void
		do
			a_hp.item.bh_next := mf_used_first
			update_class_fields -- Current might have been changed; synchronize
			Current.mf_used_first := a_hp
			update_class_fields -- Current might have been changed; synchronize
			a_hp.item.bh_prev := create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			if (a_hp.item.bh_next).is_void then
				Current.mf_used_last := a_hp
				update_class_fields -- Current might have been changed; synchronize
			else
				(a_hp.item.bh_next).item.bh_prev := a_hp
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.mf_used_count := mf_used_count + (a_hp.item.bh_page_count).to_natural_32
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MEMFILE_STATIC}).total_mem_used.item := (create {P_MEMFILE_STATIC}).total_mem_used.item + ((a_hp.item.bh_page_count).to_natural_32 * mf_page_size).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
		end

	mf_rem_used (a_hp: CE_POINTER [PD_BLOCK_HDR])
		require
			not a_hp.is_void
		do
			if (a_hp.item.bh_next).is_void then
				Current.mf_used_last := a_hp.item.bh_prev
				update_class_fields -- Current might have been changed; synchronize
			else
				(a_hp.item.bh_next).item.bh_prev := a_hp.item.bh_prev
				update_class_fields -- Current might have been changed; synchronize
			end
			if (a_hp.item.bh_prev).is_void then
				Current.mf_used_first := a_hp.item.bh_next
				update_class_fields -- Current might have been changed; synchronize
			else
				(a_hp.item.bh_prev).item.bh_next := a_hp.item.bh_next
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.mf_used_count := mf_used_count - (a_hp.item.bh_page_count).to_natural_32
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MEMFILE_STATIC}).total_mem_used.item := (create {P_MEMFILE_STATIC}).total_mem_used.item - ((a_hp.item.bh_page_count).to_natural_32 * mf_page_size).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
		end

	mf_rem_free: CE_POINTER [PD_BLOCK_HDR]
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
		do
			l_hp := mf_free_first
			Current.mf_free_first := l_hp.item.bh_next
			update_class_fields -- Current might have been changed; synchronize
			Result := l_hp
		end

	mf_read (a_hp: CE_POINTER [PD_BLOCK_HDR]): INTEGER_32
		local
			l_offset: INTEGER_32
			l_page_size: NATURAL_32
			l_size: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_32]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_32]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
			l_return: BOOLEAN
		do
			if mf_fd < 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_page_size := mf_page_size
				l_offset := l_page_size.to_integer_32 * a_hp.item.bh_bnum
				l_size := l_page_size * (a_hp.item.bh_page_count).to_natural_32
				l_tmp___2 := lseek (mf_fd, l_offset, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___2 /= l_offset then
					l_tmp := errno_location
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := strerror (l_tmp.item)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___1 := gettext (ce_string ("E294: Seek error in swap file read"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MISC2_STATIC}).emsg3 (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%s: %%s")), create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1), create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_tmp___6 := read (mf_fd, create {CE_VOID_POINTER}.make_cast (a_hp.item.bh_data), l_size)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___6.to_natural_32 /= l_size then
					l_tmp___3 := errno_location
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___4 := strerror (l_tmp___3.item)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___5 := gettext (ce_string ("E295: Read error in swap file"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MISC2_STATIC}).emsg3 (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%s: %%s")), create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___5), create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___4)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if ((mf_buffer.item.b_p_key).item).to_integer_32 /= 0 then
					ml_decrypt_data ((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer)), a_hp.item.bh_data, l_offset, l_size)
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := 1
			end
		end

	mf_write (a_hp: CE_POINTER [PD_BLOCK_HDR]): INTEGER_32
		local
			l_offset: INTEGER_32
			l_nr: INTEGER_32
			l_hp2: CE_POINTER [PD_BLOCK_HDR]
			l_page_size: NATURAL_32
			l_page_count___0: NATURAL_32
			l_size: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_32]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [PD_BLOCK_HDR]
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if mf_fd < 0 then
				Result := 0
				l_return := True
			end
			if not l_return and then (a_hp.item.bh_bnum < 0) then
				l_tmp := (create {P_MEMFILE_STATIC}).mf_trans_add ((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer)), a_hp)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp = 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_page_size := mf_page_size
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_nr := a_hp.item.bh_bnum
					if l_nr > mf_infile_count then
						l_nr := mf_infile_count
						l_hp2 := ((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer))).item.mf_find_hash (l_nr)
						update_class_fields -- Current might have been changed; synchronize
					else
						l_hp2 := a_hp
					end
					l_offset := l_page_size.to_integer_32 * l_nr
					l_tmp___3 := lseek (mf_fd, l_offset, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___3 /= l_offset then
						l_tmp___0 := errno_location
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := strerror (l_tmp___0.item)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := gettext (ce_string ("E296: Seek error in swap file write"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).emsg3 (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%s: %%s")), create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___2), create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Result := 0
						l_return := True
					end
					if not l_return then
						if l_hp2.is_void then
							l_page_count___0 := {NATURAL_32} 1
						else
							l_page_count___0 := (l_hp2.item.bh_page_count).to_natural_32
						end
						l_size := l_page_size * l_page_count___0
						if l_hp2.is_void then
							l_tmp___5 := a_hp
						else
							l_tmp___5 := l_hp2
						end
						l_tmp___6 := ((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer))).item.mf_write_block (l_tmp___5, l_offset, l_size)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___6 = 0 then
							if not ((create {P_GLOBALS_STATIC}).did_swapwrite_msg.item).to_boolean then
								l_tmp___4 := gettext (ce_string ("E297: Write error in swap file"))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___4)).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_GLOBALS_STATIC}).did_swapwrite_msg.item := 1
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						(create {P_GLOBALS_STATIC}).did_swapwrite_msg.item := 0
						update_class_fields -- Current might have been changed; synchronize
						if not l_hp2.is_void then
							l_hp2.item.bh_flags := (((l_hp2.item.bh_flags).to_integer_32).bit_and (-2)).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_nr + l_page_count___0.to_integer_32 > mf_infile_count then
							Current.mf_infile_count := (l_nr.to_natural_32 + l_page_count___0.to_natural_32).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_nr = a_hp.item.bh_bnum then
							l_break := True
						end
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 1
			end
		end

	mf_write_block (a_hp: CE_POINTER [PD_BLOCK_HDR]; a_offset: INTEGER_32; a_size: NATURAL_32): INTEGER_32
		require
			not a_hp.is_void
		local
			l_data: CE_POINTER [NATURAL_8]
			l_result___2: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_data := a_hp.item.bh_data
			l_result___2 := 1
			if ((mf_buffer.item.b_p_key).item).to_integer_32 /= 0 then
				l_data := ml_encrypt_data ((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer)), l_data, a_offset, a_size)
				update_class_fields -- Current might have been changed; synchronize
				if l_data.is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_tmp := write (mf_fd, create {CE_VOID_POINTER}.make_cast (l_data), a_size)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_natural_32 /= a_size then
					l_result___2 := 0
				end
				if not l_data.is_equal (a_hp.item.bh_data) then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_data))
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_result___2
			end
		end

	mf_set_ffname
		do
			Current.mf_ffname := (create {P_MISC1_STATIC}).FullName_save (mf_fname, 0)
			update_class_fields -- Current might have been changed; synchronize
		end

	mf_need_trans: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if not mf_fname.is_void then
				if mf_neg_count > 0 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	mf_do_open (a_fname: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32)
		local
			l_flags___0: INTEGER_32
			l_sb: CE_ARRAY [SD_STAT]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_fdflags: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_sb.make (<<1>>)

			l_flags___0 := a_flags___0
			Current.mf_fname := a_fname
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (c_pointer))).item.mf_set_ffname
			update_class_fields -- Current might have been changed; synchronize
			if ((l_flags___0).bit_and (64)).to_boolean then
				l_tmp___0 := lstat (create {CE_INTEGER_8_POINTER}.make_cast (mf_fname), l_sb)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0 >= 0 then
					Current.mf_fd := -1
					update_class_fields -- Current might have been changed; synchronize
					l_tmp := gettext (ce_string ("E300: Swap file already exists (symlink attack?)"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				else
					l_flags___0 := (l_flags___0).bit_or ((131_072))
					Current.mf_fd := open ([create {CE_INTEGER_8_POINTER}.make_cast (mf_fname), l_flags___0, (384).to_natural_32])
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				l_flags___0 := (l_flags___0).bit_or ((131_072))
				Current.mf_fd := open ([create {CE_INTEGER_8_POINTER}.make_cast (mf_fname), l_flags___0, (384).to_natural_32])
				update_class_fields -- Current might have been changed; synchronize
			end
			if mf_fd < 0 then
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (mf_fname))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (mf_ffname))
				update_class_fields -- Current might have been changed; synchronize
				Current.mf_fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				Current.mf_ffname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			else
				l_tmp___1 := fcntl ([mf_fd, 1])
				update_class_fields -- Current might have been changed; synchronize
				l_fdflags := l_tmp___1
				if l_fdflags >= 0 then
					if ((l_fdflags).bit_and (1)) = 0 then
						fcntl ([mf_fd, 2, (l_fdflags).bit_or (1)]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				mch_hide (mf_fname)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	ml_crypt_prepare (a_offset: INTEGER_32; a_reading: INTEGER_32)
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_salt: CE_ARRAY [NATURAL_8]
			l_method: INTEGER_32
			l_key: CE_POINTER [NATURAL_8]
			l_seed: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
		do
			create {CE_NATURAL_8_ARRAY} l_salt.make (<<50>>)

			l_buf___6 := mf_buffer
			if a_reading.to_boolean then
				if not mf_old_key.is_void then
					l_method := mf_old_cm
					l_key := mf_old_key
					l_seed := mf_old_seed
				else
					l_method := l_buf___6.item.get_crypt_method
					update_class_fields -- Current might have been changed; synchronize
					l_key := l_buf___6.item.b_p_key
					l_seed := mf_seed
				end
			else
				l_method := l_buf___6.item.get_crypt_method
				update_class_fields -- Current might have been changed; synchronize
				l_key := l_buf___6.item.b_p_key
				l_seed := mf_seed
			end
			(create {P_GLOBALS_STATIC}).use_crypt_method.item := l_method
			update_class_fields -- Current might have been changed; synchronize
			if l_method = 0 then
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_salt), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (50).to_natural_32), ce_string ("%%s%%ld"), l_key, a_offset]).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).crypt_init_keys (l_salt)
				update_class_fields -- Current might have been changed; synchronize
			else
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_salt), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (50).to_natural_32), ce_string ("%%ld"), a_offset]).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_salt))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_BLOWFISH_STATIC}).bf_key_init (l_key, l_salt, l_tmp.to_integer_32)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_BLOWFISH_STATIC}).bf_ofb_init (l_seed, 8)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

feature {PD_MEMFILE} -- private routines

	ml_encrypt_data (a_mfp: CE_POINTER [PD_MEMFILE]; a_data: CE_POINTER [NATURAL_8]; a_offset: INTEGER_32; a_size: NATURAL_32): CE_POINTER [NATURAL_8]
		local
			l_dp: CE_POINTER [PD_DATA_BLOCK]
			l_head_end: CE_POINTER [NATURAL_8]
			l_text_start: CE_POINTER [NATURAL_8]
			l_new_data: CE_POINTER [NATURAL_8]
			l_text_len: INTEGER_32
			l_return: BOOLEAN
		do
			l_dp := create {CE_CLASS_POINTER [PD_DATA_BLOCK]}.make_cast (a_data)
			if (l_dp.item.db_id).to_integer_32 /= ((100).bit_shift_left (8)) + 97 then
				Result := a_data
				l_return := True
			end
			if not l_return then
				l_new_data := ((create {P_MISC2_STATIC}).alloc (a_size))
				if l_new_data.is_void then
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_head_end := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_NATURAL_32_POINTER}.make_shared (l_dp.c_pointer + (create {PD_DATA_BLOCK}.make).offset_of ("db_index") + {PLATFORM}.Natural_32_bytes * (l_dp.item.db_line_count))))
				l_text_start := create {CE_NATURAL_8_POINTER}.make_cast (l_dp) + (l_dp.item.db_txt_start).to_integer_32
				l_text_len := (a_size - l_dp.item.db_txt_start).to_integer_32
				memmove (create {CE_VOID_POINTER}.make_cast (l_new_data), create {CE_VOID_POINTER}.make_cast (l_dp), (l_head_end.distance ((create {CE_NATURAL_8_POINTER}.make_cast (l_dp)))).to_natural_32).do_nothing;
				(create {P_MISC2_STATIC}).crypt_push_state
				a_mfp.item.ml_crypt_prepare (a_offset, 0);
				(create {P_MISC2_STATIC}).crypt_encode (l_text_start, l_text_len.to_natural_32, l_new_data + (l_dp.item.db_txt_start).to_integer_32);
				(create {P_MISC2_STATIC}).crypt_pop_state
				if (l_head_end.c_pointer.to_integer_32).to_natural_32 < (l_text_start.c_pointer.to_integer_32).to_natural_32 then
					memset (create {CE_VOID_POINTER}.make_cast ((l_new_data + (l_head_end.distance (a_data)))), 0, (l_text_start.distance (l_head_end)).to_natural_32).do_nothing
				end
				Result := l_new_data
			end
		end

	mf_release (a_mfp: CE_POINTER [PD_MEMFILE]; a_page_count___0: INTEGER_32): CE_POINTER [PD_BLOCK_HDR]
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_need_release: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).mf_dont_release.item).to_boolean then
				Result := (create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				if a_mfp.item.mf_used_count >= a_mfp.item.mf_used_count_max then
					l_tmp := 1
				elseif ((create {P_MEMFILE_STATIC}).total_mem_used.item).bit_shift_right (10) >= ((create {P_OPTION_STATIC}).p_mmt.item.item).to_natural_32 then
					l_tmp := 1
				else
					l_tmp := 0
				end
				l_need_release := l_tmp
				if a_mfp.item.mf_fd < 0 then
					if l_need_release.to_boolean then
						if ((create {P_OPTION_STATIC}).p_uc.item.item).to_boolean then
							l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
							from
							until
								not (not (l_break) and then (not l_buf___6.is_void))
							loop
								l_break := False
								if (l_buf___6.item.b_ml.ml_mfp).is_equal (a_mfp) then
									l_break := True
								end
								if not (l_break) then
									l_buf___6 := l_buf___6.item.b_next
								end
							end
							l_break := False
							if not l_buf___6.is_void then
								if (l_buf___6.item.b_may_swap).to_boolean then
									l_buf___6.item.ml_open_file
								end
							end
						end
					end
				end
				if a_mfp.item.mf_fd < 0 then
					Result := (create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
					l_return := True
				elseif not l_need_release.to_boolean then
					Result := (create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_hp := a_mfp.item.mf_used_last
				from
				until
					not (not (l_break) and then (not l_hp.is_void))
				loop
					l_break := False
					if not (((l_hp.item.bh_flags).to_integer_32).bit_and (2)).to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_hp := l_hp.item.bh_prev
					end
				end
				l_break := False
				if l_hp.is_void then
					Result := (create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return and then ((((l_hp.item.bh_flags).to_integer_32).bit_and (1)).to_boolean) then
				if (a_mfp.item.mf_write (l_hp)) = 0 then
					Result := (create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				a_mfp.item.mf_rem_used (l_hp);
				(create {P_MEMFILE_STATIC}).mf_rem_hash (a_mfp, l_hp)
				if l_hp.item.bh_page_count /= a_page_count___0 then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_hp.item.bh_data))
					l_tmp___1 := (create {P_MISC2_STATIC}).alloc (a_mfp.item.mf_page_size * a_page_count___0.to_natural_32)
					l_hp.item.bh_data := l_tmp___1
					if l_tmp___1.is_void then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_hp))
						Result := (create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						l_hp.item.bh_page_count := a_page_count___0
					end
				end
			end
			if not l_return then
				Result := l_hp
			end
		end

	mf_alloc_bhdr (a_mfp: CE_POINTER [PD_MEMFILE]; a_page_count___0: INTEGER_32): CE_POINTER [PD_BLOCK_HDR]
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_tmp: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_hp := create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_BLOCK_HDR}.make).structure_size.to_natural_32)))
			if not l_hp.is_void then
				l_tmp := ((create {P_MISC2_STATIC}).alloc (a_mfp.item.mf_page_size * a_page_count___0.to_natural_32))
				l_hp.item.bh_data := l_tmp
				if l_tmp.is_void then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_hp))
					Result := (create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
					l_return := True
				end
				if not l_return then
					l_hp.item.bh_page_count := a_page_count___0
				end
			end
			if not l_return then
				Result := l_hp
			end
		end

	ml_decrypt_data (a_mfp: CE_POINTER [PD_MEMFILE]; a_data: CE_POINTER [NATURAL_8]; a_offset: INTEGER_32; a_size: NATURAL_32)
		local
			l_dp: CE_POINTER [PD_DATA_BLOCK]
			l_head_end: CE_POINTER [NATURAL_8]
			l_text_start: CE_POINTER [NATURAL_8]
			l_text_len: INTEGER_32
			l_return: BOOLEAN
		do
			l_dp := create {CE_CLASS_POINTER [PD_DATA_BLOCK]}.make_cast (a_data)
			if (l_dp.item.db_id).to_integer_32 = ((100).bit_shift_left (8)) + 97 then
				l_head_end := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_NATURAL_32_POINTER}.make_shared (l_dp.c_pointer + (create {PD_DATA_BLOCK}.make).offset_of ("db_index") + {PLATFORM}.Natural_32_bytes * (l_dp.item.db_line_count))))
				l_text_start := create {CE_NATURAL_8_POINTER}.make_cast (l_dp) + (l_dp.item.db_txt_start).to_integer_32
				l_text_len := (l_dp.item.db_txt_end - l_dp.item.db_txt_start).to_integer_32
				if (l_head_end.c_pointer.to_integer_32).to_natural_32 > (l_text_start.c_pointer.to_integer_32).to_natural_32 then
					l_return := True
				elseif l_dp.item.db_txt_start > a_size then
					l_return := True
				elseif l_dp.item.db_txt_end > a_size then
					l_return := True
				end
				if not l_return then
					(create {P_MISC2_STATIC}).crypt_push_state
					a_mfp.item.ml_crypt_prepare (a_offset, 1);
					(create {P_MISC2_STATIC}).crypt_decode (l_text_start, l_text_len.to_integer_32);
					(create {P_MISC2_STATIC}).crypt_pop_state
				end
			end
			if not l_return then
			end
		end

	mch_hide (a_name___1: CE_POINTER [NATURAL_8])
		do
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mf_fname := a_other.mf_fname
			mf_ffname := a_other.mf_ffname
			mf_fd := a_other.mf_fd
			mf_free_first := a_other.mf_free_first
			mf_used_first := a_other.mf_used_first
			mf_used_last := a_other.mf_used_last
			mf_used_count := a_other.mf_used_count
			mf_used_count_max := a_other.mf_used_count_max
			mf_hash := a_other.mf_hash.twin
			mf_trans := a_other.mf_trans.twin
			mf_blocknr_max := a_other.mf_blocknr_max
			mf_blocknr_min := a_other.mf_blocknr_min
			mf_neg_count := a_other.mf_neg_count
			mf_infile_count := a_other.mf_infile_count
			mf_page_size := a_other.mf_page_size
			mf_dirty := a_other.mf_dirty
			mf_buffer := a_other.mf_buffer
			mf_seed := a_other.mf_seed.twin
			mf_old_key := a_other.mf_old_key
			mf_old_cm := a_other.mf_old_cm
			mf_old_seed := a_other.mf_old_seed.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mf_fname.is_equal (a_other.mf_fname) and
				mf_ffname.is_equal (a_other.mf_ffname) and
				mf_fd = a_other.mf_fd and
				mf_free_first.is_equal (a_other.mf_free_first) and
				mf_used_first.is_equal (a_other.mf_used_first) and
				mf_used_last.is_equal (a_other.mf_used_last) and
				mf_used_count = a_other.mf_used_count and
				mf_used_count_max = a_other.mf_used_count_max and
				mf_hash.is_equal (a_other.mf_hash) and
				mf_trans.is_equal (a_other.mf_trans) and
				mf_blocknr_max = a_other.mf_blocknr_max and
				mf_blocknr_min = a_other.mf_blocknr_min and
				mf_neg_count = a_other.mf_neg_count and
				mf_infile_count = a_other.mf_infile_count and
				mf_page_size = a_other.mf_page_size and
				mf_dirty = a_other.mf_dirty and
				mf_buffer.is_equal (a_other.mf_buffer) and
				mf_seed.is_equal (a_other.mf_seed) and
				mf_old_key.is_equal (a_other.mf_old_key) and
				mf_old_cm = a_other.mf_old_cm and
				mf_old_seed.is_equal (a_other.mf_old_seed)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("mf_fname"),
					create {CE_STRUCTURE_FIELD}.make ("mf_ffname"),
					create {CE_STRUCTURE_FIELD}.make ("mf_fd"),
					create {CE_STRUCTURE_FIELD}.make ("mf_free_first"),
					create {CE_STRUCTURE_FIELD}.make ("mf_used_first"),
					create {CE_STRUCTURE_FIELD}.make ("mf_used_last"),
					create {CE_STRUCTURE_FIELD}.make ("mf_used_count"),
					create {CE_STRUCTURE_FIELD}.make ("mf_used_count_max"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mf_hash", <<64>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mf_trans", <<64>>),
					create {CE_STRUCTURE_FIELD}.make ("mf_blocknr_max"),
					create {CE_STRUCTURE_FIELD}.make ("mf_blocknr_min"),
					create {CE_STRUCTURE_FIELD}.make ("mf_neg_count"),
					create {CE_STRUCTURE_FIELD}.make ("mf_infile_count"),
					create {CE_STRUCTURE_FIELD}.make ("mf_page_size"),
					create {CE_STRUCTURE_FIELD}.make ("mf_dirty"),
					create {CE_STRUCTURE_FIELD}.make ("mf_buffer"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mf_seed", <<8>>),
					create {CE_STRUCTURE_FIELD}.make ("mf_old_key"),
					create {CE_STRUCTURE_FIELD}.make ("mf_old_cm"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mf_old_seed", <<8>>)
				>>)
			init_structure_info
		end

end
