class
	PD_MENUTRANS_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} from2.make
			create {CE_NATURAL_8_POINTER} from_noamp.make
			create {CE_NATURAL_8_POINTER} to.make
		end

feature {ANY} -- fields

	from2: CE_POINTER [NATURAL_8] assign set_from2

	from_noamp: CE_POINTER [NATURAL_8] assign set_from_noamp

	to: CE_POINTER [NATURAL_8] assign set_to

feature {ANY} -- field setters

	set_from2 (a_from2: CE_POINTER [NATURAL_8])
		do
			from2 := a_from2
			update_memory_field ("from2")
		end

	set_from_noamp (a_from_noamp: CE_POINTER [NATURAL_8])
		do
			from_noamp := a_from_noamp
			update_memory_field ("from_noamp")
		end

	set_to (a_to: CE_POINTER [NATURAL_8])
		do
			to := a_to
			update_memory_field ("to")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			from2 := a_other.from2
			from_noamp := a_other.from_noamp
			to := a_other.to
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				from2.is_equal (a_other.from2) and
				from_noamp.is_equal (a_other.from_noamp) and
				to.is_equal (a_other.to)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("from2"),
					create {CE_STRUCTURE_FIELD}.make ("from_noamp"),
					create {CE_STRUCTURE_FIELD}.make ("to")
				>>)
			init_structure_info
		end

end
