class
	PD_NBBUF_STRUCT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	bufp: CE_POINTER [PD_FILE_BUFFER] assign set_bufp

	fireChanges: NATURAL_32 assign set_fireChanges

	initDone: NATURAL_32 assign set_initDone

	insertDone: NATURAL_32 assign set_insertDone

	modified: NATURAL_32 assign set_modified

	nbbuf_number: INTEGER_32 assign set_nbbuf_number

	displayname: CE_POINTER [INTEGER_8] assign set_displayname

	signmap: CE_POINTER [INTEGER_32] assign set_signmap

	signmaplen: NATURAL_16 assign set_signmaplen

	signmapused: NATURAL_16 assign set_signmapused

feature {ANY} -- field setters

	set_bufp (a_bufp: CE_POINTER [PD_FILE_BUFFER])
		do
			bufp := a_bufp
			update_memory_field ("bufp")
		end

	set_fireChanges (a_fireChanges: NATURAL_32)
		do
			fireChanges := a_fireChanges
			update_memory_field ("fireChanges")
		end

	set_initDone (a_initDone: NATURAL_32)
		do
			initDone := a_initDone
			update_memory_field ("initDone")
		end

	set_insertDone (a_insertDone: NATURAL_32)
		do
			insertDone := a_insertDone
			update_memory_field ("insertDone")
		end

	set_modified (a_modified: NATURAL_32)
		do
			modified := a_modified
			update_memory_field ("modified")
		end

	set_nbbuf_number (a_nbbuf_number: INTEGER_32)
		do
			nbbuf_number := a_nbbuf_number
			update_memory_field ("nbbuf_number")
		end

	set_displayname (a_displayname: CE_POINTER [INTEGER_8])
		do
			displayname := a_displayname
			update_memory_field ("displayname")
		end

	set_signmap (a_signmap: CE_POINTER [INTEGER_32])
		do
			signmap := a_signmap
			update_memory_field ("signmap")
		end

	set_signmaplen (a_signmaplen: NATURAL_16)
		do
			signmaplen := a_signmaplen
			update_memory_field ("signmaplen")
		end

	set_signmapused (a_signmapused: NATURAL_16)
		do
			signmapused := a_signmapused
			update_memory_field ("signmapused")
		end

feature {PD_NBBUF_STRUCT} -- private attributes

	globalsignmap: CE_STATIC [CE_POINTER [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer)
		end

	globalsignmaplen: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	globalsignmapused: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	addsigntype (a_typeNum: INTEGER_32; a_typeName, a_tooltip, a_glyphFile, a_fg, a_bg: CE_POINTER [NATURAL_8])
		require
			not a_fg.is_void
			not a_bg.is_void
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_use_fg: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_use_bg: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_fgbuf: CE_ARRAY [INTEGER_8]
			l_bgbuf: CE_ARRAY [INTEGER_8]
			l_ptr: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_value: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_incr: INTEGER_32
			l_oldlen: INTEGER_32
			l_tmp___11: CE_POINTER [ANY]
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_incr___0: INTEGER_32
			l_oldlen___0: INTEGER_32
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___14: NATURAL_16
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_fgbuf.make (<<81>>)
			create {CE_INTEGER_8_ARRAY} l_bgbuf.make (<<81>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_ptr.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_fg.item).to_boolean then
						l_tmp := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_fg), ce_string ("none"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp /= 0 then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
					else
						l_tmp___0 := 0
					end
					l_use_fg := l_tmp___0
					if (a_bg.item).to_boolean then
						l_tmp___1 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_bg), ce_string ("none"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1 /= 0 then
							l_tmp___2 := 1
						else
							l_tmp___2 := 0
						end
					else
						l_tmp___2 := 0
					end
					l_use_bg := l_tmp___2
					l_i___0 := 0
					from
					until
						not (not (l_break) and then (l_i___0 < globalsignmapused.item))
					loop
						l_break := False
						l_tmp___3 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_typeName), globalsignmap.item[l_i___0])
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___3 = 0 then
							l_break := True
						end
						if not (l_break) then
							l_i___0 := l_i___0 + 1
						end
					end
					l_break := False
					if l_i___0 /= globalsignmapused.item then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (l_use_fg.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (l_use_bg.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						l_tmp___4 := strtol (create {CE_INTEGER_8_POINTER}.make_cast (a_fg), l_ptr, 10)
						update_class_fields -- Current might have been changed; synchronize
						l_value := l_tmp___4.to_integer_32
						if not (l_ptr.item).is_equal (a_fg) then
							sprintf ([l_fgbuf, ce_string ("guifg=#%%06x"), (l_value).bit_and (16_777_215)]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						else
							sprintf ([l_fgbuf, ce_string ("guifg=%%s ctermfg=%%s"), a_fg, a_fg]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tmp___5 := strtol (create {CE_INTEGER_8_POINTER}.make_cast (a_bg), l_ptr, 10)
						update_class_fields -- Current might have been changed; synchronize
						l_value := l_tmp___5.to_integer_32
						if not (l_ptr.item).is_equal (a_bg) then
							sprintf ([l_bgbuf, ce_string ("guibg=#%%06x"), (l_value).bit_and (16_777_215)]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						else
							sprintf ([l_bgbuf, ce_string ("guibg=%%s ctermbg=%%s"), a_bg, a_bg]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_use_bg.to_boolean then
							l_tmp___6 := l_bgbuf
						else
							l_tmp___6 := ce_string ("")
						end
						if l_use_fg.to_boolean then
							l_tmp___7 := l_fgbuf
						else
							l_tmp___7 := ce_string ("")
						end
						(create {P_NETBEANS_STATIC}).coloncmd ([ce_string (":highlight NB_%%s %%s %%s"), a_typeName, l_tmp___7, l_tmp___6])
						update_class_fields -- Current might have been changed; synchronize
						if (a_glyphFile.item).to_integer_32 = 0 then
							(create {P_NETBEANS_STATIC}).coloncmd ([ce_string (":sign define %%d linehl=NB_%%s"), l_i___0 + 1, a_typeName])
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___8 := (create {P_CHARSET_STATIC}).vim_strsize (a_glyphFile)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___8 <= 2 then
								(create {P_NETBEANS_STATIC}).coloncmd ([ce_string (":sign define %%d text=%%s texthl=NB_%%s"), l_i___0 + 1, a_glyphFile, a_typeName])
								update_class_fields -- Current might have been changed; synchronize
							else
								(create {P_NETBEANS_STATIC}).coloncmd ([ce_string (":sign define %%d icon=%%s linehl=NB_%%s"), l_i___0 + 1, a_glyphFile, a_typeName])
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:;
						(create {P_NETBEANS_STATIC}).coloncmd ([ce_string (":sign define %%d icon=%%s"), l_i___0 + 1, a_glyphFile])
						update_class_fields -- Current might have been changed; synchronize
				when 8 then -- if done
						l_tmp___9 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_typeName), ce_string ("CurrentPC"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___9 = 0 then
							(create {P_NETBEANS_STATIC}).curPCtype.item := a_typeNum
							update_class_fields -- Current might have been changed; synchronize
						end
						if globalsignmapused.item = globalsignmaplen.item then
							if globalsignmaplen.item = 0 then
								globalsignmaplen.item := 20
								l_tmp___10 := (create {P_MISC2_STATIC}).alloc_clear (globalsignmaplen.item.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								globalsignmap.item := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (l_tmp___10)
							else
								l_oldlen := globalsignmaplen.item
								globalsignmaplen.item := globalsignmaplen.item * (2)
								l_incr := globalsignmaplen.item - l_oldlen
								l_tmp___11 := realloc (create {CE_VOID_POINTER}.make_cast (globalsignmap.item), globalsignmaplen.item.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								globalsignmap.item := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (l_tmp___11)
								memset (create {CE_VOID_POINTER}.make_cast ((globalsignmap.item + l_oldlen)), 0, l_incr.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						globalsignmap.item[l_i___0] := create {CE_INTEGER_8_POINTER}.make_cast (a_typeName)
						update_class_fields -- Current might have been changed; synchronize
						globalsignmapused.item := l_i___0 + 1
				when 9 then -- if done
					l_j := 0
					from
					until
						not (not (l_return) and then (l_j < signmapused.to_integer_32))
					loop
						if signmap[l_j] = l_i___0 + 1 then
							l_return := True
						end
						if not l_return then
							l_j := l_j + 1
						end
					end
					if not l_return then
						if signmapused.to_integer_32 = signmaplen.to_integer_32 then
							if signmaplen.to_integer_32 = 0 then
								Current.signmaplen := (5).to_natural_16
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___12 := (create {P_MISC2_STATIC}).alloc_clear (signmaplen.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								Current.signmap := create {CE_INTEGER_32_POINTER}.make_cast (l_tmp___12)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_oldlen___0 := signmaplen.to_integer_32
								Current.signmaplen := (signmaplen.to_integer_32 * 2).to_natural_16
								update_class_fields -- Current might have been changed; synchronize
								l_incr___0 := signmaplen.to_integer_32 - l_oldlen___0
								l_tmp___13 := realloc (create {CE_VOID_POINTER}.make_cast (signmap), signmaplen.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								Current.signmap := create {CE_INTEGER_32_POINTER}.make_cast (l_tmp___13)
								update_class_fields -- Current might have been changed; synchronize
								memset (create {CE_VOID_POINTER}.make_cast ((signmap + l_oldlen___0)), 0, l_incr___0.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_tmp___14 := signmapused
						Current.signmapused := (signmapused.to_integer_32 + 1).to_natural_16
						update_class_fields -- Current might have been changed; synchronize
						signmap[l_tmp___14.to_integer_32] := l_i___0 + 1
						update_class_fields -- Current might have been changed; synchronize
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	print_read_msg
		local
			l_lnum: INTEGER_32
			l_nchars: INTEGER_32
			l_c: NATURAL_8
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: INTEGER_32
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: INTEGER_32
		do
			l_lnum := (bufp.item.b_ml.ml_line_count).to_integer_32
			l_nchars := bufp.item.b_orig_size;
			(create {P_FILEIO_STATIC}).msg_add_fname (bufp, bufp.item.b_ffname)
			update_class_fields -- Current might have been changed; synchronize
			l_c := (0).to_natural_8
			if (bufp.item.b_p_ro).to_boolean then
				l_tmp___3 := (create {P_OPTION_STATIC}).shortmess (('r').code)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___3.to_boolean then
					l_tmp___0 := gettext (ce_string ("[RO]"))
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := l_tmp___0
				else
					l_tmp___1 := gettext (ce_string ("[readonly]"))
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := l_tmp___1
				end
				strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), l_tmp___2).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_c := (1).to_natural_8
			end
			if not (bufp.item.b_start_eol).to_boolean then
				l_tmp___8 := (create {P_OPTION_STATIC}).shortmess (('i').code)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___8.to_boolean then
					l_tmp___5 := gettext (ce_string ("[noeol]"))
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___7 := l_tmp___5
				else
					l_tmp___6 := gettext (ce_string ("[Incomplete last line]"))
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___7 := l_tmp___6
				end
				strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), l_tmp___7).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_c := (1).to_natural_8
			end
			(create {P_FILEIO_STATIC}).msg_add_lines (l_c.to_integer_32, l_lnum.to_integer_32, l_nchars)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).keep_msg.item))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).keep_msg.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).msg_scrolled_ign.item := 1
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MESSAGE_STATIC}).msg_trunc_attr ((create {P_GLOBALS_STATIC}).IObuff.item, 0, 0).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).msg_scrolled_ign.item := 0
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			bufp := a_other.bufp
			fireChanges := a_other.fireChanges
			initDone := a_other.initDone
			insertDone := a_other.insertDone
			modified := a_other.modified
			nbbuf_number := a_other.nbbuf_number
			displayname := a_other.displayname
			signmap := a_other.signmap
			signmaplen := a_other.signmaplen
			signmapused := a_other.signmapused
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				bufp.is_equal (a_other.bufp) and
				fireChanges = a_other.fireChanges and
				initDone = a_other.initDone and
				insertDone = a_other.insertDone and
				modified = a_other.modified and
				nbbuf_number = a_other.nbbuf_number and
				displayname.is_equal (a_other.displayname) and
				signmap.is_equal (a_other.signmap) and
				signmaplen = a_other.signmaplen and
				signmapused = a_other.signmapused
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("bufp"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("fireChanges"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("initDone"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("insertDone"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("modified"),
					create {CE_STRUCTURE_FIELD}.make ("nbbuf_number"),
					create {CE_STRUCTURE_FIELD}.make ("displayname"),
					create {CE_STRUCTURE_FIELD}.make ("signmap"),
					create {CE_STRUCTURE_FIELD}.make ("signmaplen"),
					create {CE_STRUCTURE_FIELD}.make ("signmapused")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline"
		alias
			"[
				struct nbbuf_struct {
					struct file_buffer * bufp;
					unsigned int fireChanges : 1;
					unsigned int initDone : 1;
					unsigned int insertDone : 1;
					unsigned int modified : 1;
					int nbbuf_number;
					char * displayname;
					int * signmap;
					unsigned short signmaplen;
					unsigned short signmapused;
				};
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct nbbuf_struct);
					if(strcmp(field_name, "nbbuf_number") == 0) return offsetof(struct nbbuf_struct, nbbuf_number);
				} else {
					struct nbbuf_struct *p = (struct nbbuf_struct *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "fireChanges") == 0) p->fireChanges = (unsigned int)$a_value;
						else if(strcmp(field_name, "initDone") == 0) p->initDone = (unsigned int)$a_value;
						else if(strcmp(field_name, "insertDone") == 0) p->insertDone = (unsigned int)$a_value;
						else if(strcmp(field_name, "modified") == 0) p->modified = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "fireChanges") == 0) return p->fireChanges;
						if(strcmp(field_name, "initDone") == 0) return p->initDone;
						if(strcmp(field_name, "insertDone") == 0) return p->insertDone;
						if(strcmp(field_name, "modified") == 0) return p->modified;
					}
				}
			]"
		end

end
