class
	PD_NV_CMD

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create cmd_func.make
		end

feature {ANY} -- fields

	cmd_char: INTEGER_32 assign set_cmd_char

	cmd_func: CE_ROUTINE assign set_cmd_func

	cmd_flags: NATURAL_16 assign set_cmd_flags

	cmd_arg: INTEGER_16 assign set_cmd_arg

feature {ANY} -- field setters

	set_cmd_char (a_cmd_char: INTEGER_32)
		do
			cmd_char := a_cmd_char
			update_memory_field ("cmd_char")
		end

	set_cmd_func (a_cmd_func: CE_ROUTINE)
		do
			cmd_func := a_cmd_func
			update_memory_field ("cmd_func")
		end

	set_cmd_flags (a_cmd_flags: NATURAL_16)
		do
			cmd_flags := a_cmd_flags
			update_memory_field ("cmd_flags")
		end

	set_cmd_arg (a_cmd_arg: INTEGER_16)
		do
			cmd_arg := a_cmd_arg
			update_memory_field ("cmd_arg")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			cmd_char := a_other.cmd_char
			cmd_func := a_other.cmd_func
			cmd_flags := a_other.cmd_flags
			cmd_arg := a_other.cmd_arg
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				cmd_char = a_other.cmd_char and
				cmd_func.is_equal (a_other.cmd_func) and
				cmd_flags = a_other.cmd_flags and
				cmd_arg = a_other.cmd_arg
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("cmd_char"),
					create {CE_STRUCTURE_FIELD}.make ("cmd_func"),
					create {CE_STRUCTURE_FIELD}.make ("cmd_flags"),
					create {CE_STRUCTURE_FIELD}.make ("cmd_arg")
				>>)
			init_structure_info
		end

end
