class
	PD_PENDINGCOMMAND

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} result2.make
			create {CE_CLASS_POINTER [PD_PENDINGCOMMAND]} nextPtr.make
		end

feature {ANY} -- fields

	serial: INTEGER_32 assign set_serial

	code: INTEGER_32 assign set_code

	result2: CE_POINTER [NATURAL_8] assign set_result2

	nextPtr: CE_POINTER [PD_PENDINGCOMMAND] assign set_nextPtr

feature {ANY} -- field setters

	set_serial (a_serial: INTEGER_32)
		do
			serial := a_serial
			update_memory_field ("serial")
		end

	set_code (a_code: INTEGER_32)
		do
			code := a_code
			update_memory_field ("code")
		end

	set_result2 (a_result2: CE_POINTER [NATURAL_8])
		do
			result2 := a_result2
			update_memory_field ("result2")
		end

	set_nextPtr (a_nextPtr: CE_POINTER [PD_PENDINGCOMMAND])
		do
			nextPtr := a_nextPtr
			update_memory_field ("nextPtr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			serial := a_other.serial
			code := a_other.code
			result2 := a_other.result2
			nextPtr := a_other.nextPtr
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				serial = a_other.serial and
				code = a_other.code and
				result2.is_equal (a_other.result2) and
				nextPtr.is_equal (a_other.nextPtr)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("serial"),
					create {CE_STRUCTURE_FIELD}.make ("code"),
					create {CE_STRUCTURE_FIELD}.make ("result2"),
					create {CE_STRUCTURE_FIELD}.make ("nextPtr")
				>>)
			init_structure_info
		end

end
