class
	PD_PRT_DSC_COMMENT_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} string.make
		end

feature {ANY} -- fields

	string: CE_POINTER [INTEGER_8] assign set_string

	len: INTEGER_32 assign set_len

	type: INTEGER_32 assign set_type

feature {ANY} -- field setters

	set_string (a_string: CE_POINTER [INTEGER_8])
		do
			string := a_string
			update_memory_field ("string")
		end

	set_len (a_len: INTEGER_32)
		do
			len := a_len
			update_memory_field ("len")
		end

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			string := a_other.string
			len := a_other.len
			type := a_other.type
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				string.is_equal (a_other.string) and
				len = a_other.len and
				type = a_other.type
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("string"),
					create {CE_STRUCTURE_FIELD}.make ("len"),
					create {CE_STRUCTURE_FIELD}.make ("type")
				>>)
			init_structure_info
		end

end
