class
	PD_PRT_DSC_LINE_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} string.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	string: CE_POINTER [NATURAL_8] assign set_string

	len: INTEGER_32 assign set_len

feature {ANY} -- field setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_string (a_string: CE_POINTER [NATURAL_8])
		do
			string := a_string
			update_memory_field ("string")
		end

	set_len (a_len: INTEGER_32)
		do
			len := a_len
			update_memory_field ("len")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			string := a_other.string
			len := a_other.len
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				string.is_equal (a_other.string) and
				len = a_other.len
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("string"),
					create {CE_STRUCTURE_FIELD}.make ("len")
				>>)
			init_structure_info
		end

end
