class
	PD_PRT_POS_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	lead_spaces: INTEGER_32 assign set_lead_spaces

	print_pos: INTEGER_32 assign set_print_pos

	column: INTEGER_32 assign set_column

	file_line: INTEGER_32 assign set_file_line

	bytes_printed: NATURAL_32 assign set_bytes_printed

	ff: INTEGER_32 assign set_ff

feature {ANY} -- field setters

	set_lead_spaces (a_lead_spaces: INTEGER_32)
		do
			lead_spaces := a_lead_spaces
			update_memory_field ("lead_spaces")
		end

	set_print_pos (a_print_pos: INTEGER_32)
		do
			print_pos := a_print_pos
			update_memory_field ("print_pos")
		end

	set_column (a_column: INTEGER_32)
		do
			column := a_column
			update_memory_field ("column")
		end

	set_file_line (a_file_line: INTEGER_32)
		do
			file_line := a_file_line
			update_memory_field ("file_line")
		end

	set_bytes_printed (a_bytes_printed: NATURAL_32)
		do
			bytes_printed := a_bytes_printed
			update_memory_field ("bytes_printed")
		end

	set_ff (a_ff: INTEGER_32)
		do
			ff := a_ff
			update_memory_field ("ff")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			lead_spaces := a_other.lead_spaces
			print_pos := a_other.print_pos
			column := a_other.column
			file_line := a_other.file_line
			bytes_printed := a_other.bytes_printed
			ff := a_other.ff
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				lead_spaces = a_other.lead_spaces and
				print_pos = a_other.print_pos and
				column = a_other.column and
				file_line = a_other.file_line and
				bytes_printed = a_other.bytes_printed and
				ff = a_other.ff
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("lead_spaces"),
					create {CE_STRUCTURE_FIELD}.make ("print_pos"),
					create {CE_STRUCTURE_FIELD}.make ("column"),
					create {CE_STRUCTURE_FIELD}.make ("file_line"),
					create {CE_STRUCTURE_FIELD}.make ("bytes_printed"),
					create {CE_STRUCTURE_FIELD}.make ("ff")
				>>)
			init_structure_info
		end

end
