class
	PD_QF_LIST_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_QFLINE_S]} qf_start.make
			create {CE_CLASS_POINTER [PD_QFLINE_S]} qf_ptr.make
			create {CE_NATURAL_8_POINTER} qf_title.make
		end

feature {ANY} -- fields

	qf_start: CE_POINTER [PD_QFLINE_S] assign set_qf_start

	qf_ptr: CE_POINTER [PD_QFLINE_S] assign set_qf_ptr

	qf_count: INTEGER_32 assign set_qf_count

	qf_index: INTEGER_32 assign set_qf_index

	qf_nonevalid: INTEGER_32 assign set_qf_nonevalid

	qf_title: CE_POINTER [NATURAL_8] assign set_qf_title

feature {ANY} -- field setters

	set_qf_start (a_qf_start: CE_POINTER [PD_QFLINE_S])
		do
			qf_start := a_qf_start
			update_memory_field ("qf_start")
		end

	set_qf_ptr (a_qf_ptr: CE_POINTER [PD_QFLINE_S])
		do
			qf_ptr := a_qf_ptr
			update_memory_field ("qf_ptr")
		end

	set_qf_count (a_qf_count: INTEGER_32)
		do
			qf_count := a_qf_count
			update_memory_field ("qf_count")
		end

	set_qf_index (a_qf_index: INTEGER_32)
		do
			qf_index := a_qf_index
			update_memory_field ("qf_index")
		end

	set_qf_nonevalid (a_qf_nonevalid: INTEGER_32)
		do
			qf_nonevalid := a_qf_nonevalid
			update_memory_field ("qf_nonevalid")
		end

	set_qf_title (a_qf_title: CE_POINTER [NATURAL_8])
		do
			qf_title := a_qf_title
			update_memory_field ("qf_title")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			qf_start := a_other.qf_start
			qf_ptr := a_other.qf_ptr
			qf_count := a_other.qf_count
			qf_index := a_other.qf_index
			qf_nonevalid := a_other.qf_nonevalid
			qf_title := a_other.qf_title
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				qf_start.is_equal (a_other.qf_start) and
				qf_ptr.is_equal (a_other.qf_ptr) and
				qf_count = a_other.qf_count and
				qf_index = a_other.qf_index and
				qf_nonevalid = a_other.qf_nonevalid and
				qf_title.is_equal (a_other.qf_title)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("qf_start"),
					create {CE_STRUCTURE_FIELD}.make ("qf_ptr"),
					create {CE_STRUCTURE_FIELD}.make ("qf_count"),
					create {CE_STRUCTURE_FIELD}.make ("qf_index"),
					create {CE_STRUCTURE_FIELD}.make ("qf_nonevalid"),
					create {CE_STRUCTURE_FIELD}.make ("qf_title")
				>>)
			init_structure_info
		end

end
