class
	PD_QFLINE_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_QFLINE_S]} qf_next.make
			create {CE_CLASS_POINTER [PD_QFLINE_S]} qf_prev.make
			create {CE_NATURAL_8_POINTER} qf_pattern.make
			create {CE_NATURAL_8_POINTER} qf_text.make
		end

feature {ANY} -- fields

	qf_next: CE_POINTER [PD_QFLINE_S] assign set_qf_next

	qf_prev: CE_POINTER [PD_QFLINE_S] assign set_qf_prev

	qf_lnum: INTEGER_32 assign set_qf_lnum

	qf_fnum: INTEGER_32 assign set_qf_fnum

	qf_col: INTEGER_32 assign set_qf_col

	qf_nr: INTEGER_32 assign set_qf_nr

	qf_pattern: CE_POINTER [NATURAL_8] assign set_qf_pattern

	qf_text: CE_POINTER [NATURAL_8] assign set_qf_text

	qf_viscol: NATURAL_8 assign set_qf_viscol

	qf_cleared: NATURAL_8 assign set_qf_cleared

	qf_type: NATURAL_8 assign set_qf_type

	qf_valid: NATURAL_8 assign set_qf_valid

feature {ANY} -- field setters

	set_qf_next (a_qf_next: CE_POINTER [PD_QFLINE_S])
		do
			qf_next := a_qf_next
			update_memory_field ("qf_next")
		end

	set_qf_prev (a_qf_prev: CE_POINTER [PD_QFLINE_S])
		do
			qf_prev := a_qf_prev
			update_memory_field ("qf_prev")
		end

	set_qf_lnum (a_qf_lnum: INTEGER_32)
		do
			qf_lnum := a_qf_lnum
			update_memory_field ("qf_lnum")
		end

	set_qf_fnum (a_qf_fnum: INTEGER_32)
		do
			qf_fnum := a_qf_fnum
			update_memory_field ("qf_fnum")
		end

	set_qf_col (a_qf_col: INTEGER_32)
		do
			qf_col := a_qf_col
			update_memory_field ("qf_col")
		end

	set_qf_nr (a_qf_nr: INTEGER_32)
		do
			qf_nr := a_qf_nr
			update_memory_field ("qf_nr")
		end

	set_qf_pattern (a_qf_pattern: CE_POINTER [NATURAL_8])
		do
			qf_pattern := a_qf_pattern
			update_memory_field ("qf_pattern")
		end

	set_qf_text (a_qf_text: CE_POINTER [NATURAL_8])
		do
			qf_text := a_qf_text
			update_memory_field ("qf_text")
		end

	set_qf_viscol (a_qf_viscol: NATURAL_8)
		do
			qf_viscol := a_qf_viscol
			update_memory_field ("qf_viscol")
		end

	set_qf_cleared (a_qf_cleared: NATURAL_8)
		do
			qf_cleared := a_qf_cleared
			update_memory_field ("qf_cleared")
		end

	set_qf_type (a_qf_type: NATURAL_8)
		do
			qf_type := a_qf_type
			update_memory_field ("qf_type")
		end

	set_qf_valid (a_qf_valid: NATURAL_8)
		do
			qf_valid := a_qf_valid
			update_memory_field ("qf_valid")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			qf_next := a_other.qf_next
			qf_prev := a_other.qf_prev
			qf_lnum := a_other.qf_lnum
			qf_fnum := a_other.qf_fnum
			qf_col := a_other.qf_col
			qf_nr := a_other.qf_nr
			qf_pattern := a_other.qf_pattern
			qf_text := a_other.qf_text
			qf_viscol := a_other.qf_viscol
			qf_cleared := a_other.qf_cleared
			qf_type := a_other.qf_type
			qf_valid := a_other.qf_valid
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				qf_next.is_equal (a_other.qf_next) and
				qf_prev.is_equal (a_other.qf_prev) and
				qf_lnum = a_other.qf_lnum and
				qf_fnum = a_other.qf_fnum and
				qf_col = a_other.qf_col and
				qf_nr = a_other.qf_nr and
				qf_pattern.is_equal (a_other.qf_pattern) and
				qf_text.is_equal (a_other.qf_text) and
				qf_viscol = a_other.qf_viscol and
				qf_cleared = a_other.qf_cleared and
				qf_type = a_other.qf_type and
				qf_valid = a_other.qf_valid
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("qf_next"),
					create {CE_STRUCTURE_FIELD}.make ("qf_prev"),
					create {CE_STRUCTURE_FIELD}.make ("qf_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("qf_fnum"),
					create {CE_STRUCTURE_FIELD}.make ("qf_col"),
					create {CE_STRUCTURE_FIELD}.make ("qf_nr"),
					create {CE_STRUCTURE_FIELD}.make ("qf_pattern"),
					create {CE_STRUCTURE_FIELD}.make ("qf_text"),
					create {CE_STRUCTURE_FIELD}.make ("qf_viscol"),
					create {CE_STRUCTURE_FIELD}.make ("qf_cleared"),
					create {CE_STRUCTURE_FIELD}.make ("qf_type"),
					create {CE_STRUCTURE_FIELD}.make ("qf_valid")
				>>)
			init_structure_info
		end

end
