class
	PD_RS_UN

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	sesave: PD_SAVE_SE_T assign set_sesave

	regsave: PD_REGSAVE_T assign set_regsave

feature {ANY} -- field setters

	set_sesave (a_sesave: PD_SAVE_SE_T)
		do
			sesave := a_sesave
			update_memory_field ("sesave")
		end

	set_regsave (a_regsave: PD_REGSAVE_T)
		do
			regsave := a_regsave
			update_memory_field ("regsave")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sesave := a_other.sesave.twin
			regsave := a_other.regsave.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sesave.is_equal (a_other.sesave) and
				regsave.is_equal (a_other.regsave)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("sesave"),
					create {CE_STRUCTURE_FIELD}.make ("regsave")
				>>)
			init_structure_info
		end

end
