class
	PD_SEARCHEDFILE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_IO_FILE]} fp.make
			create {CE_NATURAL_8_POINTER} name.make
		end

feature {ANY} -- fields

	fp: CE_POINTER [SD_IO_FILE] assign set_fp

	name: CE_POINTER [NATURAL_8] assign set_name

	lnum: INTEGER_32 assign set_lnum

	matched: INTEGER_32 assign set_matched

feature {ANY} -- field setters

	set_fp (a_fp: CE_POINTER [SD_IO_FILE])
		do
			fp := a_fp
			update_memory_field ("fp")
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_lnum (a_lnum: INTEGER_32)
		do
			lnum := a_lnum
			update_memory_field ("lnum")
		end

	set_matched (a_matched: INTEGER_32)
		do
			matched := a_matched
			update_memory_field ("matched")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fp := a_other.fp
			name := a_other.name
			lnum := a_other.lnum
			matched := a_other.matched
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fp.is_equal (a_other.fp) and
				name.is_equal (a_other.name) and
				lnum = a_other.lnum and
				matched = a_other.matched
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fp"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("lnum"),
					create {CE_STRUCTURE_FIELD}.make ("matched")
				>>)
			init_structure_info
		end

end
