class
	PD_SOFFSET

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	dir: INTEGER_32 assign set_dir

	line: INTEGER_32 assign set_line

	end2: INTEGER_32 assign set_end2

	off: INTEGER_32 assign set_off

feature {ANY} -- field setters

	set_dir (a_dir: INTEGER_32)
		do
			dir := a_dir
			update_memory_field ("dir")
		end

	set_line (a_line: INTEGER_32)
		do
			line := a_line
			update_memory_field ("line")
		end

	set_end2 (a_end2: INTEGER_32)
		do
			end2 := a_end2
			update_memory_field ("end2")
		end

	set_off (a_off: INTEGER_32)
		do
			off := a_off
			update_memory_field ("off")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			dir := a_other.dir
			line := a_other.line
			end2 := a_other.end2
			off := a_other.off
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				dir = a_other.dir and
				line = a_other.line and
				end2 = a_other.end2 and
				off = a_other.off
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("dir"),
					create {CE_STRUCTURE_FIELD}.make ("line"),
					create {CE_STRUCTURE_FIELD}.make ("end2"),
					create {CE_STRUCTURE_FIELD}.make ("off")
				>>)
			init_structure_info
		end

end
