class
	PD_SOURCE_COOKIE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_IO_FILE]} fp.make
			create {CE_NATURAL_8_POINTER} nextline.make
			create {CE_NATURAL_8_POINTER} fname.make
			create conv.make
		end

feature {ANY} -- fields

	fp: CE_POINTER [SD_IO_FILE] assign set_fp

	nextline: CE_POINTER [NATURAL_8] assign set_nextline

	finished: INTEGER_32 assign set_finished

	breakpoint: INTEGER_32 assign set_breakpoint

	fname: CE_POINTER [NATURAL_8] assign set_fname

	dbg_tick: INTEGER_32 assign set_dbg_tick

	level: INTEGER_32 assign set_level

	conv: PD_VIMCONV_T assign set_conv

feature {ANY} -- field setters

	set_fp (a_fp: CE_POINTER [SD_IO_FILE])
		do
			fp := a_fp
			update_memory_field ("fp")
		end

	set_nextline (a_nextline: CE_POINTER [NATURAL_8])
		do
			nextline := a_nextline
			update_memory_field ("nextline")
		end

	set_finished (a_finished: INTEGER_32)
		do
			finished := a_finished
			update_memory_field ("finished")
		end

	set_breakpoint (a_breakpoint: INTEGER_32)
		do
			breakpoint := a_breakpoint
			update_memory_field ("breakpoint")
		end

	set_fname (a_fname: CE_POINTER [NATURAL_8])
		do
			fname := a_fname
			update_memory_field ("fname")
		end

	set_dbg_tick (a_dbg_tick: INTEGER_32)
		do
			dbg_tick := a_dbg_tick
			update_memory_field ("dbg_tick")
		end

	set_level (a_level: INTEGER_32)
		do
			level := a_level
			update_memory_field ("level")
		end

	set_conv (a_conv: PD_VIMCONV_T)
		do
			conv := a_conv
			update_memory_field ("conv")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fp := a_other.fp
			nextline := a_other.nextline
			finished := a_other.finished
			breakpoint := a_other.breakpoint
			fname := a_other.fname
			dbg_tick := a_other.dbg_tick
			level := a_other.level
			conv := a_other.conv.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fp.is_equal (a_other.fp) and
				nextline.is_equal (a_other.nextline) and
				finished = a_other.finished and
				breakpoint = a_other.breakpoint and
				fname.is_equal (a_other.fname) and
				dbg_tick = a_other.dbg_tick and
				level = a_other.level and
				conv.is_equal (a_other.conv)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fp"),
					create {CE_STRUCTURE_FIELD}.make ("nextline"),
					create {CE_STRUCTURE_FIELD}.make ("finished"),
					create {CE_STRUCTURE_FIELD}.make ("breakpoint"),
					create {CE_STRUCTURE_FIELD}.make ("fname"),
					create {CE_STRUCTURE_FIELD}.make ("dbg_tick"),
					create {CE_STRUCTURE_FIELD}.make ("level"),
					create {CE_STRUCTURE_FIELD}.make ("conv")
				>>)
			init_structure_info
		end

end
