class
	PD_SP_SYN

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_16_POINTER} cont_in_list.make
		end

feature {ANY} -- fields

	inc_tag: INTEGER_32 assign set_inc_tag

	id: INTEGER_16 assign set_id

	cont_in_list: CE_POINTER [INTEGER_16] assign set_cont_in_list

feature {ANY} -- field setters

	set_inc_tag (a_inc_tag: INTEGER_32)
		do
			inc_tag := a_inc_tag
			update_memory_field ("inc_tag")
		end

	set_id (a_id: INTEGER_16)
		do
			id := a_id
			update_memory_field ("id")
		end

	set_cont_in_list (a_cont_in_list: CE_POINTER [INTEGER_16])
		do
			cont_in_list := a_cont_in_list
			update_memory_field ("cont_in_list")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			inc_tag := a_other.inc_tag
			id := a_other.id
			cont_in_list := a_other.cont_in_list
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				inc_tag = a_other.inc_tag and
				id = a_other.id and
				cont_in_list.is_equal (a_other.cont_in_list)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("inc_tag"),
					create {CE_STRUCTURE_FIELD}.make ("id"),
					create {CE_STRUCTURE_FIELD}.make ("cont_in_list")
				>>)
			init_structure_info
		end

end
