class
	PD_SYN_OPT_ARG_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_32_POINTER} sync_idx.make
			create {CE_INTEGER_16_POINTER} cont_list.make
			create {CE_INTEGER_16_POINTER} cont_in_list.make
			create {CE_INTEGER_16_POINTER} next_list.make
		end

feature {ANY} -- fields

	flags: INTEGER_32 assign set_flags

	keyword: INTEGER_32 assign set_keyword

	sync_idx: CE_POINTER [INTEGER_32] assign set_sync_idx

	has_cont_list: INTEGER_8 assign set_has_cont_list

	cont_list: CE_POINTER [INTEGER_16] assign set_cont_list

	cont_in_list: CE_POINTER [INTEGER_16] assign set_cont_in_list

	next_list: CE_POINTER [INTEGER_16] assign set_next_list

feature {ANY} -- field setters

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_keyword (a_keyword: INTEGER_32)
		do
			keyword := a_keyword
			update_memory_field ("keyword")
		end

	set_sync_idx (a_sync_idx: CE_POINTER [INTEGER_32])
		do
			sync_idx := a_sync_idx
			update_memory_field ("sync_idx")
		end

	set_has_cont_list (a_has_cont_list: INTEGER_8)
		do
			has_cont_list := a_has_cont_list
			update_memory_field ("has_cont_list")
		end

	set_cont_list (a_cont_list: CE_POINTER [INTEGER_16])
		do
			cont_list := a_cont_list
			update_memory_field ("cont_list")
		end

	set_cont_in_list (a_cont_in_list: CE_POINTER [INTEGER_16])
		do
			cont_in_list := a_cont_in_list
			update_memory_field ("cont_in_list")
		end

	set_next_list (a_next_list: CE_POINTER [INTEGER_16])
		do
			next_list := a_next_list
			update_memory_field ("next_list")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			flags := a_other.flags
			keyword := a_other.keyword
			sync_idx := a_other.sync_idx
			has_cont_list := a_other.has_cont_list
			cont_list := a_other.cont_list
			cont_in_list := a_other.cont_in_list
			next_list := a_other.next_list
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				flags = a_other.flags and
				keyword = a_other.keyword and
				sync_idx.is_equal (a_other.sync_idx) and
				has_cont_list = a_other.has_cont_list and
				cont_list.is_equal (a_other.cont_list) and
				cont_in_list.is_equal (a_other.cont_in_list) and
				next_list.is_equal (a_other.next_list)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("keyword"),
					create {CE_STRUCTURE_FIELD}.make ("sync_idx"),
					create {CE_STRUCTURE_FIELD}.make ("has_cont_list"),
					create {CE_STRUCTURE_FIELD}.make ("cont_list"),
					create {CE_STRUCTURE_FIELD}.make ("cont_in_list"),
					create {CE_STRUCTURE_FIELD}.make ("next_list")
				>>)
			init_structure_info
		end

end
