class
	PD_SYN_PATTERN

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create sp_syn.make
			create {CE_NATURAL_8_POINTER} sp_pattern.make
			create {CE_CLASS_POINTER [PD_REGPROG_T]} sp_prog.make
			create {CE_INTEGER_32_ARRAY} sp_offsets.make (<<7>>)
			create {CE_INTEGER_16_POINTER} sp_cont_list.make
			create {CE_INTEGER_16_POINTER} sp_next_list.make
			Precursor
		end

feature {ANY} -- fields

	sp_type: INTEGER_8 assign set_sp_type

	sp_syncing: INTEGER_8 assign set_sp_syncing

	sp_flags: INTEGER_32 assign set_sp_flags

	sp_syn: PD_SP_SYN assign set_sp_syn

	sp_syn_match_id: INTEGER_16 assign set_sp_syn_match_id

	sp_pattern: CE_POINTER [NATURAL_8] assign set_sp_pattern

	sp_prog: CE_POINTER [PD_REGPROG_T] assign set_sp_prog

	sp_ic: INTEGER_32 assign set_sp_ic

	sp_off_flags: INTEGER_16 assign set_sp_off_flags

	sp_offsets: CE_ARRAY [INTEGER_32]

	sp_cont_list: CE_POINTER [INTEGER_16] assign set_sp_cont_list

	sp_next_list: CE_POINTER [INTEGER_16] assign set_sp_next_list

	sp_sync_idx: INTEGER_32 assign set_sp_sync_idx

	sp_line_id: INTEGER_32 assign set_sp_line_id

	sp_startcol: INTEGER_32 assign set_sp_startcol

feature {ANY} -- field setters

	set_sp_type (a_sp_type: INTEGER_8)
		do
			sp_type := a_sp_type
			update_memory_field ("sp_type")
		end

	set_sp_syncing (a_sp_syncing: INTEGER_8)
		do
			sp_syncing := a_sp_syncing
			update_memory_field ("sp_syncing")
		end

	set_sp_flags (a_sp_flags: INTEGER_32)
		do
			sp_flags := a_sp_flags
			update_memory_field ("sp_flags")
		end

	set_sp_syn (a_sp_syn: PD_SP_SYN)
		do
			sp_syn := a_sp_syn
			update_memory_field ("sp_syn")
		end

	set_sp_syn_match_id (a_sp_syn_match_id: INTEGER_16)
		do
			sp_syn_match_id := a_sp_syn_match_id
			update_memory_field ("sp_syn_match_id")
		end

	set_sp_pattern (a_sp_pattern: CE_POINTER [NATURAL_8])
		do
			sp_pattern := a_sp_pattern
			update_memory_field ("sp_pattern")
		end

	set_sp_prog (a_sp_prog: CE_POINTER [PD_REGPROG_T])
		do
			sp_prog := a_sp_prog
			update_memory_field ("sp_prog")
		end

	set_sp_ic (a_sp_ic: INTEGER_32)
		do
			sp_ic := a_sp_ic
			update_memory_field ("sp_ic")
		end

	set_sp_off_flags (a_sp_off_flags: INTEGER_16)
		do
			sp_off_flags := a_sp_off_flags
			update_memory_field ("sp_off_flags")
		end

	set_sp_cont_list (a_sp_cont_list: CE_POINTER [INTEGER_16])
		do
			sp_cont_list := a_sp_cont_list
			update_memory_field ("sp_cont_list")
		end

	set_sp_next_list (a_sp_next_list: CE_POINTER [INTEGER_16])
		do
			sp_next_list := a_sp_next_list
			update_memory_field ("sp_next_list")
		end

	set_sp_sync_idx (a_sp_sync_idx: INTEGER_32)
		do
			sp_sync_idx := a_sp_sync_idx
			update_memory_field ("sp_sync_idx")
		end

	set_sp_line_id (a_sp_line_id: INTEGER_32)
		do
			sp_line_id := a_sp_line_id
			update_memory_field ("sp_line_id")
		end

	set_sp_startcol (a_sp_startcol: INTEGER_32)
		do
			sp_startcol := a_sp_startcol
			update_memory_field ("sp_startcol")
		end

feature {PD_SYN_PATTERN} -- private attributes

	spo_name_tab: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("ms="),
					ce_string ("me="),
					ce_string ("hs="),
					ce_string ("he="),
					ce_string ("rs="),
					ce_string ("re="),
					ce_string ("lc=")
				>>)
		end

	sepchars: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("/+=-#@%"|%'^&")
		end

feature {ANY} -- public routines

	put_pattern (a_s: CE_POINTER [INTEGER_8]; a_c, a_attr: INTEGER_32)
		local
			l_n: INTEGER_32
			l_mask: INTEGER_32
			l_first___0: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			if (create {P_SYNTAX_STATIC}).last_matchgroup.item /= sp_syn_match_id.to_integer_32 then
				(create {P_SYNTAX_STATIC}).last_matchgroup.item := sp_syn_match_id.to_integer_32
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("matchgroup")), a_attr)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MESSAGE_STATIC}).msg_putchar (('=').code)
				update_class_fields -- Current might have been changed; synchronize
				if (create {P_SYNTAX_STATIC}).last_matchgroup.item = 0 then
					(create {P_MESSAGE_STATIC}).msg_outtrans (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("NONE"))).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				else
					(create {P_MESSAGE_STATIC}).msg_outtrans ((create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast ((create {P_SYNTAX_STATIC}).highlight_ga.item.item.ga_data) + ((create {P_SYNTAX_STATIC}).last_matchgroup.item - 1)).item.sg_name).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_MESSAGE_STATIC}).msg_putchar ((' ').code)
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast (a_s), a_attr)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MESSAGE_STATIC}).msg_putchar (a_c)
			update_class_fields -- Current might have been changed; synchronize
			l_i___0 := 0
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp := (create {P_MISC2_STATIC}).vim_strchr (sp_pattern, (sepchars.item[l_i___0]).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.is_void then
					l_break := True
				end
				if not (l_break) then
					l_i___0 := l_i___0 + 1
					if (sepchars.item[l_i___0]).to_integer_32 = 0 then
						l_i___0 := 0
						l_break := True
					end
				end
			end
			l_break := False;
			(create {P_MESSAGE_STATIC}).msg_putchar ((sepchars.item[l_i___0]).to_integer_32)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MESSAGE_STATIC}).msg_outtrans (sp_pattern).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MESSAGE_STATIC}).msg_putchar ((sepchars.item[l_i___0]).to_integer_32)
			update_class_fields -- Current might have been changed; synchronize
			l_first___0 := 1
			l_i___0 := 0
			from
			until
				not (l_i___0 < 7)
			loop
				l_mask := (1).bit_shift_left (l_i___0)
				if ((sp_off_flags.to_integer_32).bit_and ((l_mask + ((l_mask).bit_shift_left (7))))).to_boolean then
					if not l_first___0.to_boolean then
						(create {P_MESSAGE_STATIC}).msg_putchar ((',').code)
						update_class_fields -- Current might have been changed; synchronize
					end
					(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (spo_name_tab.item[l_i___0]))
					update_class_fields -- Current might have been changed; synchronize
					l_n := (sp_offsets[l_i___0]).to_integer_32
					if l_i___0 /= 6 then
						if ((sp_off_flags.to_integer_32).bit_and (l_mask)).to_boolean then
							(create {P_MESSAGE_STATIC}).msg_putchar (('s').code)
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_MESSAGE_STATIC}).msg_putchar (('e').code)
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_n > 0 then
							(create {P_MESSAGE_STATIC}).msg_putchar (('+').code)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if l_n.to_boolean then
						(create {P_MESSAGE_STATIC}).msg_outnum (l_n)
						update_class_fields -- Current might have been changed; synchronize
					elseif l_i___0 = 6 then
						(create {P_MESSAGE_STATIC}).msg_outnum (l_n)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_first___0 := 0
				end
				l_i___0 := l_i___0 + 1
			end
			(create {P_MESSAGE_STATIC}).msg_putchar ((' ').code)
			update_class_fields -- Current might have been changed; synchronize
		end

	get_syn_pattern (a_arg: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_end: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p___0: CE_POINTER [INTEGER_32]
			l_idx: INTEGER_32
			l_cpo_save: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_end.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_arg.is_void then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					elseif (a_arg[1]).to_integer_32 = 0 then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					elseif (a_arg[2]).to_integer_32 = 0 then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						l_end.item := (create {P_REGEXP_STATIC}).skip_regexp (a_arg + 1, (a_arg.item).to_integer_32, 1, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if (l_end.item.item).to_integer_32 /= (a_arg.item).to_integer_32 then
							l_tmp := gettext (ce_string ("E401: Pattern delimiter not found: %%s"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp), a_arg).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
					if not l_return then
						l_tmp___0 := (create {P_MISC2_STATIC}).vim_strnsave (a_arg + 1, ((l_end.item).distance (a_arg)) - 1)
						update_class_fields -- Current might have been changed; synchronize
						Current.sp_pattern := l_tmp___0
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0.is_void then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
					if not l_return then
						l_cpo_save := (create {P_OPTION_STATIC}).p_cpo.item.item;
						(create {P_OPTION_STATIC}).p_cpo.item.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
						update_class_fields -- Current might have been changed; synchronize
						Current.sp_prog := (create {P_REGEXP_STATIC}).vim_regcomp (sp_pattern, 1)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_OPTION_STATIC}).p_cpo.item.item := l_cpo_save
						update_class_fields -- Current might have been changed; synchronize
						if sp_prog.is_void then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						Current.sp_ic := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_syn_ic
						update_class_fields -- Current might have been changed; synchronize
						l_end.item := l_end.item + 1
						update_class_fields -- Current might have been changed; synchronize
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_idx := 7
						from
						until
							(l_break)
						loop
							l_break := False
							l_idx := l_idx - 1
							if not (l_idx >= 0) then
								l_break := True
							end
							if not (l_break) then
								l_tmp___1 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_end.item), spo_name_tab.item[l_idx], (3).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___1 = 0 then
									l_break := True
								end
							end
						end
						l_break := False
						if not (l_idx >= 0) then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						l_p___0 := create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_SYN_PATTERN}.make).offset_of ("sp_offsets") + {PLATFORM}.Integer_32_bytes * (l_idx))
						if l_idx = 6 then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						inspect (l_end.item[3]).to_integer_32 -- switch 1 head
						when 115 then l_pos := -1 + 6
						when 98 then l_pos := -1 + 7
						when 101 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 6 then -- switch 1, case 115
						l_pos := -1 + 10 -- switch 1; break
				when 7 then -- switch 1, case 98
						l_pos := -1 + 10 -- switch 1; break
				when 8 then -- switch 1, case 101
						l_idx := l_idx + (7)
						l_pos := -1 + 10 -- switch 1; break
				when 9 then -- switch 1, default:
						l_idx := -1
						l_pos := -1 + 10 -- switch 1; break
				when 10 then -- switch 1, done: | if done
						if l_idx >= 0 then
							Current.sp_off_flags := ((sp_off_flags.to_integer_32).bit_or (((1).bit_shift_left (l_idx)))).to_integer_16
							update_class_fields -- Current might have been changed; synchronize
							if l_idx = 6 then
								l_end.item := l_end.item + (3)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___2 := (create {P_CHARSET_STATIC}).getdigits (l_end)
								update_class_fields -- Current might have been changed; synchronize
								l_p___0.item := l_tmp___2.to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								if not ((sp_off_flags.to_integer_32).bit_and (1)).to_boolean then
									Current.sp_off_flags := ((sp_off_flags.to_integer_32).bit_or (1)).to_integer_16
									update_class_fields -- Current might have been changed; synchronize
									sp_offsets[0] := l_p___0.item
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_end.item := l_end.item + (4)
								update_class_fields -- Current might have been changed; synchronize
								if (l_end.item.item).to_integer_32 = 43 then
									l_end.item := l_end.item + 1
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___3 := (create {P_CHARSET_STATIC}).getdigits (l_end)
									update_class_fields -- Current might have been changed; synchronize
									l_p___0.item := l_tmp___3.to_integer_32
									update_class_fields -- Current might have been changed; synchronize
								elseif (l_end.item.item).to_integer_32 = 45 then
									l_end.item := l_end.item + 1
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___4 := (create {P_CHARSET_STATIC}).getdigits (l_end)
									update_class_fields -- Current might have been changed; synchronize
									l_p___0.item := (-l_tmp___4).to_integer_32
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							if (l_end.item.item).to_integer_32 /= 44 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_end.item := l_end.item + 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 11 then -- if done
						if not (l_return or l_break) and then (not (l_idx >= 0)) then
							l_break := True
						end
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- loop done
						l_break := False
						l_tmp___6 := (create {P_EX_DOCMD_STATIC}).ends_excmd ((l_end.item.item).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___6.to_boolean then
							if (l_end.item.item).to_integer_32 /= 32 then
								if (l_end.item.item).to_integer_32 /= 9 then
									l_tmp___5 := gettext (ce_string ("E402: Garbage after pattern: %%s"))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___5), a_arg).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
									l_return := True
								end
							end
						end
				when 13 then -- if done
					if not l_return then
						l_tmp___7 := (create {P_CHARSET_STATIC}).skipwhite (l_end.item)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___7
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sp_type := a_other.sp_type
			sp_syncing := a_other.sp_syncing
			sp_flags := a_other.sp_flags
			sp_syn := a_other.sp_syn.twin
			sp_syn_match_id := a_other.sp_syn_match_id
			sp_pattern := a_other.sp_pattern
			sp_prog := a_other.sp_prog
			sp_ic := a_other.sp_ic
			sp_off_flags := a_other.sp_off_flags
			sp_offsets := a_other.sp_offsets.twin
			sp_cont_list := a_other.sp_cont_list
			sp_next_list := a_other.sp_next_list
			sp_sync_idx := a_other.sp_sync_idx
			sp_line_id := a_other.sp_line_id
			sp_startcol := a_other.sp_startcol
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sp_type = a_other.sp_type and
				sp_syncing = a_other.sp_syncing and
				sp_flags = a_other.sp_flags and
				sp_syn.is_equal (a_other.sp_syn) and
				sp_syn_match_id = a_other.sp_syn_match_id and
				sp_pattern.is_equal (a_other.sp_pattern) and
				sp_prog.is_equal (a_other.sp_prog) and
				sp_ic = a_other.sp_ic and
				sp_off_flags = a_other.sp_off_flags and
				sp_offsets.is_equal (a_other.sp_offsets) and
				sp_cont_list.is_equal (a_other.sp_cont_list) and
				sp_next_list.is_equal (a_other.sp_next_list) and
				sp_sync_idx = a_other.sp_sync_idx and
				sp_line_id = a_other.sp_line_id and
				sp_startcol = a_other.sp_startcol
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sp_type"),
					create {CE_STRUCTURE_FIELD}.make ("sp_syncing"),
					create {CE_STRUCTURE_FIELD}.make ("sp_flags"),
					create {CE_STRUCTURE_FIELD}.make ("sp_syn"),
					create {CE_STRUCTURE_FIELD}.make ("sp_syn_match_id"),
					create {CE_STRUCTURE_FIELD}.make ("sp_pattern"),
					create {CE_STRUCTURE_FIELD}.make ("sp_prog"),
					create {CE_STRUCTURE_FIELD}.make ("sp_ic"),
					create {CE_STRUCTURE_FIELD}.make ("sp_off_flags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sp_offsets", <<7>>),
					create {CE_STRUCTURE_FIELD}.make ("sp_cont_list"),
					create {CE_STRUCTURE_FIELD}.make ("sp_next_list"),
					create {CE_STRUCTURE_FIELD}.make ("sp_sync_idx"),
					create {CE_STRUCTURE_FIELD}.make ("sp_line_id"),
					create {CE_STRUCTURE_FIELD}.make ("sp_startcol")
				>>)
			init_structure_info
		end

end
