class
	PD_SYNBLOCK_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create b_keywtab.make
			create b_keywtab_ic.make
			create b_syn_patterns.make
			create b_syn_clusters.make
			create {CE_NATURAL_8_POINTER} b_syn_linecont_pat.make
			create {CE_CLASS_POINTER [PD_REGPROG_T]} b_syn_linecont_prog.make
			create {CE_CLASS_POINTER [PD_SYN_STATE]} b_sst_array.make
			create {CE_CLASS_POINTER [PD_SYN_STATE]} b_sst_first.make
			create {CE_CLASS_POINTER [PD_SYN_STATE]} b_sst_firstfree.make
			create b_langp.make
			create {CE_NATURAL_8_ARRAY} b_spell_ismw.make (<<256>>)
			create {CE_NATURAL_8_POINTER} b_spell_ismw_mb.make
			create {CE_NATURAL_8_POINTER} b_p_spc.make
			create {CE_CLASS_POINTER [PD_REGPROG_T]} b_cap_prog.make
			create {CE_NATURAL_8_POINTER} b_p_spf.make
			create {CE_NATURAL_8_POINTER} b_p_spl.make
		end

feature {ANY} -- fields

	b_keywtab: PD_HASHTABLE_S assign set_b_keywtab

	b_keywtab_ic: PD_HASHTABLE_S assign set_b_keywtab_ic

	b_syn_error: INTEGER_32 assign set_b_syn_error

	b_syn_ic: INTEGER_32 assign set_b_syn_ic

	b_syn_spell: INTEGER_32 assign set_b_syn_spell

	b_syn_patterns: PD_GROWARRAY assign set_b_syn_patterns

	b_syn_clusters: PD_GROWARRAY assign set_b_syn_clusters

	b_spell_cluster_id: INTEGER_32 assign set_b_spell_cluster_id

	b_nospell_cluster_id: INTEGER_32 assign set_b_nospell_cluster_id

	b_syn_containedin: INTEGER_32 assign set_b_syn_containedin

	b_syn_sync_flags: INTEGER_32 assign set_b_syn_sync_flags

	b_syn_sync_id: INTEGER_16 assign set_b_syn_sync_id

	b_syn_sync_minlines: INTEGER_32 assign set_b_syn_sync_minlines

	b_syn_sync_maxlines: INTEGER_32 assign set_b_syn_sync_maxlines

	b_syn_sync_linebreaks: INTEGER_32 assign set_b_syn_sync_linebreaks

	b_syn_linecont_pat: CE_POINTER [NATURAL_8] assign set_b_syn_linecont_pat

	b_syn_linecont_prog: CE_POINTER [PD_REGPROG_T] assign set_b_syn_linecont_prog

	b_syn_linecont_ic: INTEGER_32 assign set_b_syn_linecont_ic

	b_syn_topgrp: INTEGER_32 assign set_b_syn_topgrp

	b_syn_folditems: INTEGER_32 assign set_b_syn_folditems

	b_sst_array: CE_POINTER [PD_SYN_STATE] assign set_b_sst_array

	b_sst_len: INTEGER_32 assign set_b_sst_len

	b_sst_first: CE_POINTER [PD_SYN_STATE] assign set_b_sst_first

	b_sst_firstfree: CE_POINTER [PD_SYN_STATE] assign set_b_sst_firstfree

	b_sst_freecount: INTEGER_32 assign set_b_sst_freecount

	b_sst_check_lnum: INTEGER_32 assign set_b_sst_check_lnum

	b_sst_lasttick: NATURAL_16 assign set_b_sst_lasttick

	b_langp: PD_GROWARRAY assign set_b_langp

	b_spell_ismw: CE_ARRAY [NATURAL_8]

	b_spell_ismw_mb: CE_POINTER [NATURAL_8] assign set_b_spell_ismw_mb

	b_p_spc: CE_POINTER [NATURAL_8] assign set_b_p_spc

	b_cap_prog: CE_POINTER [PD_REGPROG_T] assign set_b_cap_prog

	b_p_spf: CE_POINTER [NATURAL_8] assign set_b_p_spf

	b_p_spl: CE_POINTER [NATURAL_8] assign set_b_p_spl

feature {ANY} -- field setters

	set_b_keywtab (a_b_keywtab: PD_HASHTABLE_S)
		do
			b_keywtab := a_b_keywtab
			update_memory_field ("b_keywtab")
		end

	set_b_keywtab_ic (a_b_keywtab_ic: PD_HASHTABLE_S)
		do
			b_keywtab_ic := a_b_keywtab_ic
			update_memory_field ("b_keywtab_ic")
		end

	set_b_syn_error (a_b_syn_error: INTEGER_32)
		do
			b_syn_error := a_b_syn_error
			update_memory_field ("b_syn_error")
		end

	set_b_syn_ic (a_b_syn_ic: INTEGER_32)
		do
			b_syn_ic := a_b_syn_ic
			update_memory_field ("b_syn_ic")
		end

	set_b_syn_spell (a_b_syn_spell: INTEGER_32)
		do
			b_syn_spell := a_b_syn_spell
			update_memory_field ("b_syn_spell")
		end

	set_b_syn_patterns (a_b_syn_patterns: PD_GROWARRAY)
		do
			b_syn_patterns := a_b_syn_patterns
			update_memory_field ("b_syn_patterns")
		end

	set_b_syn_clusters (a_b_syn_clusters: PD_GROWARRAY)
		do
			b_syn_clusters := a_b_syn_clusters
			update_memory_field ("b_syn_clusters")
		end

	set_b_spell_cluster_id (a_b_spell_cluster_id: INTEGER_32)
		do
			b_spell_cluster_id := a_b_spell_cluster_id
			update_memory_field ("b_spell_cluster_id")
		end

	set_b_nospell_cluster_id (a_b_nospell_cluster_id: INTEGER_32)
		do
			b_nospell_cluster_id := a_b_nospell_cluster_id
			update_memory_field ("b_nospell_cluster_id")
		end

	set_b_syn_containedin (a_b_syn_containedin: INTEGER_32)
		do
			b_syn_containedin := a_b_syn_containedin
			update_memory_field ("b_syn_containedin")
		end

	set_b_syn_sync_flags (a_b_syn_sync_flags: INTEGER_32)
		do
			b_syn_sync_flags := a_b_syn_sync_flags
			update_memory_field ("b_syn_sync_flags")
		end

	set_b_syn_sync_id (a_b_syn_sync_id: INTEGER_16)
		do
			b_syn_sync_id := a_b_syn_sync_id
			update_memory_field ("b_syn_sync_id")
		end

	set_b_syn_sync_minlines (a_b_syn_sync_minlines: INTEGER_32)
		do
			b_syn_sync_minlines := a_b_syn_sync_minlines
			update_memory_field ("b_syn_sync_minlines")
		end

	set_b_syn_sync_maxlines (a_b_syn_sync_maxlines: INTEGER_32)
		do
			b_syn_sync_maxlines := a_b_syn_sync_maxlines
			update_memory_field ("b_syn_sync_maxlines")
		end

	set_b_syn_sync_linebreaks (a_b_syn_sync_linebreaks: INTEGER_32)
		do
			b_syn_sync_linebreaks := a_b_syn_sync_linebreaks
			update_memory_field ("b_syn_sync_linebreaks")
		end

	set_b_syn_linecont_pat (a_b_syn_linecont_pat: CE_POINTER [NATURAL_8])
		do
			b_syn_linecont_pat := a_b_syn_linecont_pat
			update_memory_field ("b_syn_linecont_pat")
		end

	set_b_syn_linecont_prog (a_b_syn_linecont_prog: CE_POINTER [PD_REGPROG_T])
		do
			b_syn_linecont_prog := a_b_syn_linecont_prog
			update_memory_field ("b_syn_linecont_prog")
		end

	set_b_syn_linecont_ic (a_b_syn_linecont_ic: INTEGER_32)
		do
			b_syn_linecont_ic := a_b_syn_linecont_ic
			update_memory_field ("b_syn_linecont_ic")
		end

	set_b_syn_topgrp (a_b_syn_topgrp: INTEGER_32)
		do
			b_syn_topgrp := a_b_syn_topgrp
			update_memory_field ("b_syn_topgrp")
		end

	set_b_syn_folditems (a_b_syn_folditems: INTEGER_32)
		do
			b_syn_folditems := a_b_syn_folditems
			update_memory_field ("b_syn_folditems")
		end

	set_b_sst_array (a_b_sst_array: CE_POINTER [PD_SYN_STATE])
		do
			b_sst_array := a_b_sst_array
			update_memory_field ("b_sst_array")
		end

	set_b_sst_len (a_b_sst_len: INTEGER_32)
		do
			b_sst_len := a_b_sst_len
			update_memory_field ("b_sst_len")
		end

	set_b_sst_first (a_b_sst_first: CE_POINTER [PD_SYN_STATE])
		do
			b_sst_first := a_b_sst_first
			update_memory_field ("b_sst_first")
		end

	set_b_sst_firstfree (a_b_sst_firstfree: CE_POINTER [PD_SYN_STATE])
		do
			b_sst_firstfree := a_b_sst_firstfree
			update_memory_field ("b_sst_firstfree")
		end

	set_b_sst_freecount (a_b_sst_freecount: INTEGER_32)
		do
			b_sst_freecount := a_b_sst_freecount
			update_memory_field ("b_sst_freecount")
		end

	set_b_sst_check_lnum (a_b_sst_check_lnum: INTEGER_32)
		do
			b_sst_check_lnum := a_b_sst_check_lnum
			update_memory_field ("b_sst_check_lnum")
		end

	set_b_sst_lasttick (a_b_sst_lasttick: NATURAL_16)
		do
			b_sst_lasttick := a_b_sst_lasttick
			update_memory_field ("b_sst_lasttick")
		end

	set_b_langp (a_b_langp: PD_GROWARRAY)
		do
			b_langp := a_b_langp
			update_memory_field ("b_langp")
		end

	set_b_spell_ismw_mb (a_b_spell_ismw_mb: CE_POINTER [NATURAL_8])
		do
			b_spell_ismw_mb := a_b_spell_ismw_mb
			update_memory_field ("b_spell_ismw_mb")
		end

	set_b_p_spc (a_b_p_spc: CE_POINTER [NATURAL_8])
		do
			b_p_spc := a_b_p_spc
			update_memory_field ("b_p_spc")
		end

	set_b_cap_prog (a_b_cap_prog: CE_POINTER [PD_REGPROG_T])
		do
			b_cap_prog := a_b_cap_prog
			update_memory_field ("b_cap_prog")
		end

	set_b_p_spf (a_b_p_spf: CE_POINTER [NATURAL_8])
		do
			b_p_spf := a_b_p_spf
			update_memory_field ("b_p_spf")
		end

	set_b_p_spl (a_b_p_spl: CE_POINTER [NATURAL_8])
		do
			b_p_spl := a_b_p_spl
			update_memory_field ("b_p_spl")
		end

feature {ANY} -- public routines

	compile_cap_prog: CE_POINTER [NATURAL_8]
		local
			l_rp: CE_POINTER [PD_REGPROG_T]
			l_re: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_rp := b_cap_prog
			if (b_p_spc.item).to_integer_32 = 0 then
				Current.b_cap_prog := create {CE_CLASS_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			else
				l_re := (create {P_MISC1_STATIC}).concat_str (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("^")), b_p_spc)
				update_class_fields -- Current might have been changed; synchronize
				if not l_re.is_void then
					Current.b_cap_prog := (create {P_REGEXP_STATIC}).vim_regcomp (l_re, 1)
					update_class_fields -- Current might have been changed; synchronize
					if b_cap_prog.is_void then
						Current.b_cap_prog := l_rp
						update_class_fields -- Current might have been changed; synchronize
						Result := ((create {P_GLOBALS_STATIC}).e_invarg.item)
						l_return := True
					end
					if not l_return then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_re))
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_rp))
				update_class_fields -- Current might have been changed; synchronize
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
		end

	syn_stack_free_block
		local
			l_p___0: CE_POINTER [PD_SYN_STATE]
		do
			if not b_sst_array.is_void then
				l_p___0 := b_sst_first
				from
				until
					l_p___0.is_void
				loop
					l_p___0.item.clear_syn_state
					update_class_fields -- Current might have been changed; synchronize
					l_p___0 := l_p___0.item.sst_next
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (b_sst_array))
				update_class_fields -- Current might have been changed; synchronize
				Current.b_sst_array := create {CE_CLASS_POINTER [PD_SYN_STATE]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				Current.b_sst_len := 0
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	syn_stack_free_all
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tmp: INTEGER_32
		do
			((create {CE_CLASS_POINTER [PD_SYNBLOCK_T]}.make_shared (c_pointer))).item.syn_stack_free_block
			update_class_fields -- Current might have been changed; synchronize
			l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
			from
			until
				l_wp___0.is_void
			loop
				if ((l_wp___0.item.w_s).c_pointer = c_pointer) then
					l_tmp := l_wp___0.item.foldmethodIsSyntax
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						l_wp___0.item.foldUpdateAll
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_wp___0 := l_wp___0.item.w_next
			end
		end

	syn_stack_apply_changes_block (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_p___0: CE_POINTER [PD_SYN_STATE]
			l_prev: CE_POINTER [PD_SYN_STATE]
			l_np: CE_POINTER [PD_SYN_STATE]
			l_n: INTEGER_32
			l_return, l_continue: BOOLEAN
		do
			if b_sst_array.is_void then
				l_return := True
			end
			if not l_return then
				l_prev := create {CE_CLASS_POINTER [PD_SYN_STATE]}.make_shared (default_pointer)
				l_p___0 := b_sst_first
				from
				until
					l_p___0.is_void
				loop
					l_continue := False
					if l_p___0.item.sst_lnum + b_syn_sync_linebreaks > a_buf___6.item.b_mod_top then
						l_n := l_p___0.item.sst_lnum + a_buf___6.item.b_mod_xlines
						if l_n <= a_buf___6.item.b_mod_bot then
							l_np := l_p___0.item.sst_next
							if l_prev.is_void then
								Current.b_sst_first := l_np
								update_class_fields -- Current might have been changed; synchronize
							else
								l_prev.item.sst_next := l_np
								update_class_fields -- Current might have been changed; synchronize
							end
							((create {CE_CLASS_POINTER [PD_SYNBLOCK_T]}.make_shared (c_pointer))).item.syn_stack_free_entry (l_p___0)
							update_class_fields -- Current might have been changed; synchronize
							l_p___0 := l_np
							l_continue := True
						end
						if not (l_continue) then
							if l_p___0.item.sst_change_lnum /= 0 then
								if l_p___0.item.sst_change_lnum > a_buf___6.item.b_mod_top then
									if l_p___0.item.sst_change_lnum + a_buf___6.item.b_mod_xlines > a_buf___6.item.b_mod_top then
										l_p___0.item.sst_change_lnum := l_p___0.item.sst_change_lnum + (a_buf___6.item.b_mod_xlines)
										update_class_fields -- Current might have been changed; synchronize
									else
										l_p___0.item.sst_change_lnum := a_buf___6.item.b_mod_top
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
							if l_p___0.item.sst_change_lnum = 0 then
								l_p___0.item.sst_change_lnum := a_buf___6.item.b_mod_bot
								update_class_fields -- Current might have been changed; synchronize
							elseif l_p___0.item.sst_change_lnum < a_buf___6.item.b_mod_bot then
								l_p___0.item.sst_change_lnum := a_buf___6.item.b_mod_bot
								update_class_fields -- Current might have been changed; synchronize
							end
							l_p___0.item.sst_lnum := l_n
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if not (l_continue) then
						l_prev := l_p___0
						l_p___0 := l_p___0.item.sst_next
					end
					
				end
				l_continue := False
			end
		end

	syn_stack_free_entry (a_p___0: CE_POINTER [PD_SYN_STATE])
		require
			not a_p___0.is_void
		do
			a_p___0.item.clear_syn_state
			update_class_fields -- Current might have been changed; synchronize
			a_p___0.item.sst_next := b_sst_firstfree
			update_class_fields -- Current might have been changed; synchronize
			Current.b_sst_firstfree := a_p___0
			update_class_fields -- Current might have been changed; synchronize
			Current.b_sst_freecount := b_sst_freecount + 1
			update_class_fields -- Current might have been changed; synchronize
		end

	syntax_clear
		local
			l_i___0: INTEGER_32
			l_break: BOOLEAN
		do
			Current.b_syn_error := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.b_syn_ic := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.b_syn_spell := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.b_syn_containedin := 0
			update_class_fields -- Current might have been changed; synchronize
			clear_keywtab (create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_SYNBLOCK_T}.make).offset_of ("b_keywtab")))
			update_class_fields -- Current might have been changed; synchronize
			clear_keywtab (create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_SYNBLOCK_T}.make).offset_of ("b_keywtab_ic")))
			update_class_fields -- Current might have been changed; synchronize
			l_i___0 := b_syn_patterns.ga_len
			from
			until
				(l_break)
			loop
				l_break := False
				l_i___0 := l_i___0 - 1
				if not (l_i___0 >= 0) then
					l_break := True
				end
				if not (l_break) then
					((create {CE_CLASS_POINTER [PD_SYNBLOCK_T]}.make_shared (c_pointer))).item.syn_clear_pattern (l_i___0)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_break := False;
			(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SYNBLOCK_T}.make).offset_of ("b_syn_patterns"))).item.ga_clear
			update_class_fields -- Current might have been changed; synchronize
			l_i___0 := b_syn_clusters.ga_len
			from
			until
				(l_break)
			loop
				l_break := False
				l_i___0 := l_i___0 - 1
				if not (l_i___0 >= 0) then
					l_break := True
				end
				if not (l_break) then
					((create {CE_CLASS_POINTER [PD_SYNBLOCK_T]}.make_shared (c_pointer))).item.syn_clear_cluster (l_i___0)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_break := False;
			(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SYNBLOCK_T}.make).offset_of ("b_syn_clusters"))).item.ga_clear
			update_class_fields -- Current might have been changed; synchronize
			Current.b_spell_cluster_id := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.b_nospell_cluster_id := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.b_syn_sync_flags := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.b_syn_sync_minlines := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.b_syn_sync_maxlines := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.b_syn_sync_linebreaks := 0
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (b_syn_linecont_prog))
			update_class_fields -- Current might have been changed; synchronize
			Current.b_syn_linecont_prog := create {CE_CLASS_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (b_syn_linecont_pat))
			update_class_fields -- Current might have been changed; synchronize
			Current.b_syn_linecont_pat := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Current.b_syn_folditems := 0
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_SYNBLOCK_T]}.make_shared (c_pointer))).item.syn_stack_free_all
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SYNTAX_STATIC}).invalidate_current_state
			update_class_fields -- Current might have been changed; synchronize
		end

	syn_clear_pattern (a_i___0: INTEGER_32)
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast (b_syn_patterns.ga_data) + a_i___0).item.sp_pattern))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast (b_syn_patterns.ga_data) + a_i___0).item.sp_prog))
			update_class_fields -- Current might have been changed; synchronize
			if a_i___0 = 0 then
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast (b_syn_patterns.ga_data) + a_i___0).item.sp_cont_list))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast (b_syn_patterns.ga_data) + a_i___0).item.sp_next_list))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast (b_syn_patterns.ga_data) + a_i___0).item.sp_syn.cont_in_list))
				update_class_fields -- Current might have been changed; synchronize
			elseif ((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast (b_syn_patterns.ga_data) + (a_i___0 - 1)).item.sp_type).to_integer_32 /= 2 then
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast (b_syn_patterns.ga_data) + a_i___0).item.sp_cont_list))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast (b_syn_patterns.ga_data) + a_i___0).item.sp_next_list))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast (b_syn_patterns.ga_data) + a_i___0).item.sp_syn.cont_in_list))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	syn_clear_cluster (a_i___0: INTEGER_32)
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_SYN_CLUSTER_S]}.make_cast (b_syn_clusters.ga_data) + a_i___0).item.scl_name))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_SYN_CLUSTER_S]}.make_cast (b_syn_clusters.ga_data) + a_i___0).item.scl_name_u))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_SYN_CLUSTER_S]}.make_cast (b_syn_clusters.ga_data) + a_i___0).item.scl_list))
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_SYNBLOCK_T} -- private routines

	clear_keywtab (a_ht: CE_POINTER [PD_HASHTABLE_S])
		require
			not a_ht.is_void
		local
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_todo: INTEGER_32
			l_kp: CE_POINTER [PD_KEYENTRY]
			l_kp_next: CE_POINTER [PD_KEYENTRY]
			l_return: BOOLEAN
		do
			l_todo := (a_ht.item.ht_used).to_integer_32
			l_hi___1 := a_ht.item.ht_array
			from
			until
				not (not (l_return) and then (l_todo > 0))
			loop
				if not ((l_hi___1.item.hi_key).is_void) then
					if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
						l_todo := l_todo - 1
						l_kp := create {CE_CLASS_POINTER [PD_KEYENTRY]}.make_cast ((l_hi___1.item.hi_key - (((create {P_SYNTAX_STATIC}).dumkey.item.item.keyword).distance ((create {CE_NATURAL_8_POINTER}.make_cast (((create {P_SYNTAX_STATIC}).dumkey.item)))))))
						from
						until
							l_kp.is_void
						loop
							l_kp_next := l_kp.item.ke_next;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_kp.item.next_list));
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_kp.item.k_syn.cont_in_list));
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_kp))
							l_kp := l_kp_next
						end
					end
				end
				l_hi___1 := l_hi___1 + 1
			end
			a_ht.item.hash_clear
			a_ht.item.hash_init
		end

feature {ANY}

	copy (a_other: like Current)
		do
			b_keywtab := a_other.b_keywtab.twin
			b_keywtab_ic := a_other.b_keywtab_ic.twin
			b_syn_error := a_other.b_syn_error
			b_syn_ic := a_other.b_syn_ic
			b_syn_spell := a_other.b_syn_spell
			b_syn_patterns := a_other.b_syn_patterns.twin
			b_syn_clusters := a_other.b_syn_clusters.twin
			b_spell_cluster_id := a_other.b_spell_cluster_id
			b_nospell_cluster_id := a_other.b_nospell_cluster_id
			b_syn_containedin := a_other.b_syn_containedin
			b_syn_sync_flags := a_other.b_syn_sync_flags
			b_syn_sync_id := a_other.b_syn_sync_id
			b_syn_sync_minlines := a_other.b_syn_sync_minlines
			b_syn_sync_maxlines := a_other.b_syn_sync_maxlines
			b_syn_sync_linebreaks := a_other.b_syn_sync_linebreaks
			b_syn_linecont_pat := a_other.b_syn_linecont_pat
			b_syn_linecont_prog := a_other.b_syn_linecont_prog
			b_syn_linecont_ic := a_other.b_syn_linecont_ic
			b_syn_topgrp := a_other.b_syn_topgrp
			b_syn_folditems := a_other.b_syn_folditems
			b_sst_array := a_other.b_sst_array
			b_sst_len := a_other.b_sst_len
			b_sst_first := a_other.b_sst_first
			b_sst_firstfree := a_other.b_sst_firstfree
			b_sst_freecount := a_other.b_sst_freecount
			b_sst_check_lnum := a_other.b_sst_check_lnum
			b_sst_lasttick := a_other.b_sst_lasttick
			b_langp := a_other.b_langp.twin
			b_spell_ismw := a_other.b_spell_ismw.twin
			b_spell_ismw_mb := a_other.b_spell_ismw_mb
			b_p_spc := a_other.b_p_spc
			b_cap_prog := a_other.b_cap_prog
			b_p_spf := a_other.b_p_spf
			b_p_spl := a_other.b_p_spl
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				b_keywtab.is_equal (a_other.b_keywtab) and
				b_keywtab_ic.is_equal (a_other.b_keywtab_ic) and
				b_syn_error = a_other.b_syn_error and
				b_syn_ic = a_other.b_syn_ic and
				b_syn_spell = a_other.b_syn_spell and
				b_syn_patterns.is_equal (a_other.b_syn_patterns) and
				b_syn_clusters.is_equal (a_other.b_syn_clusters) and
				b_spell_cluster_id = a_other.b_spell_cluster_id and
				b_nospell_cluster_id = a_other.b_nospell_cluster_id and
				b_syn_containedin = a_other.b_syn_containedin and
				b_syn_sync_flags = a_other.b_syn_sync_flags and
				b_syn_sync_id = a_other.b_syn_sync_id and
				b_syn_sync_minlines = a_other.b_syn_sync_minlines and
				b_syn_sync_maxlines = a_other.b_syn_sync_maxlines and
				b_syn_sync_linebreaks = a_other.b_syn_sync_linebreaks and
				b_syn_linecont_pat.is_equal (a_other.b_syn_linecont_pat) and
				b_syn_linecont_prog.is_equal (a_other.b_syn_linecont_prog) and
				b_syn_linecont_ic = a_other.b_syn_linecont_ic and
				b_syn_topgrp = a_other.b_syn_topgrp and
				b_syn_folditems = a_other.b_syn_folditems and
				b_sst_array.is_equal (a_other.b_sst_array) and
				b_sst_len = a_other.b_sst_len and
				b_sst_first.is_equal (a_other.b_sst_first) and
				b_sst_firstfree.is_equal (a_other.b_sst_firstfree) and
				b_sst_freecount = a_other.b_sst_freecount and
				b_sst_check_lnum = a_other.b_sst_check_lnum and
				b_sst_lasttick = a_other.b_sst_lasttick and
				b_langp.is_equal (a_other.b_langp) and
				b_spell_ismw.is_equal (a_other.b_spell_ismw) and
				b_spell_ismw_mb.is_equal (a_other.b_spell_ismw_mb) and
				b_p_spc.is_equal (a_other.b_p_spc) and
				b_cap_prog.is_equal (a_other.b_cap_prog) and
				b_p_spf.is_equal (a_other.b_p_spf) and
				b_p_spl.is_equal (a_other.b_p_spl)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("b_keywtab"),
					create {CE_STRUCTURE_FIELD}.make ("b_keywtab_ic"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_error"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_ic"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_spell"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_patterns"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_clusters"),
					create {CE_STRUCTURE_FIELD}.make ("b_spell_cluster_id"),
					create {CE_STRUCTURE_FIELD}.make ("b_nospell_cluster_id"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_containedin"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_sync_flags"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_sync_id"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_sync_minlines"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_sync_maxlines"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_sync_linebreaks"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_linecont_pat"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_linecont_prog"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_linecont_ic"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_topgrp"),
					create {CE_STRUCTURE_FIELD}.make ("b_syn_folditems"),
					create {CE_STRUCTURE_FIELD}.make ("b_sst_array"),
					create {CE_STRUCTURE_FIELD}.make ("b_sst_len"),
					create {CE_STRUCTURE_FIELD}.make ("b_sst_first"),
					create {CE_STRUCTURE_FIELD}.make ("b_sst_firstfree"),
					create {CE_STRUCTURE_FIELD}.make ("b_sst_freecount"),
					create {CE_STRUCTURE_FIELD}.make ("b_sst_check_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("b_sst_lasttick"),
					create {CE_STRUCTURE_FIELD}.make ("b_langp"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b_spell_ismw", <<256>>),
					create {CE_STRUCTURE_FIELD}.make ("b_spell_ismw_mb"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_spc"),
					create {CE_STRUCTURE_FIELD}.make ("b_cap_prog"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_spf"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_spl")
				>>)
			init_structure_info
		end

end
