class
	PD_TABPAGE_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_TABPAGE_S]} tp_next.make
			create {CE_CLASS_POINTER [PD_FRAME_S]} tp_topframe.make
			create {CE_CLASS_POINTER [PD_WINDOW_S]} tp_curwin.make
			create {CE_CLASS_POINTER [PD_WINDOW_S]} tp_prevwin.make
			create {CE_CLASS_POINTER [PD_WINDOW_S]} tp_firstwin.make
			create {CE_CLASS_POINTER [PD_WINDOW_S]} tp_lastwin.make
			create {CE_INTEGER_32_ARRAY} tp_prev_which_scrollbars.make (<<3>>)
			create {CE_CLASS_POINTER [PD_DIFFBLOCK_S]} tp_first_diff.make
			create {CE_POINTER_ARRAY [PD_FILE_BUFFER]} tp_diffbuf.make (<<4>>)
			create {CE_POINTER_ARRAY [PD_FRAME_S]} tp_snapshot.make (<<2>>)
			create tp_winvar.make
			create tp_vars.make
		end

feature {ANY} -- fields

	tp_next: CE_POINTER [PD_TABPAGE_S] assign set_tp_next

	tp_topframe: CE_POINTER [PD_FRAME_S] assign set_tp_topframe

	tp_curwin: CE_POINTER [PD_WINDOW_S] assign set_tp_curwin

	tp_prevwin: CE_POINTER [PD_WINDOW_S] assign set_tp_prevwin

	tp_firstwin: CE_POINTER [PD_WINDOW_S] assign set_tp_firstwin

	tp_lastwin: CE_POINTER [PD_WINDOW_S] assign set_tp_lastwin

	tp_old_Rows: INTEGER_32 assign set_tp_old_Rows

	tp_old_Columns: INTEGER_32 assign set_tp_old_Columns

	tp_ch_used: INTEGER_32 assign set_tp_ch_used

	tp_prev_which_scrollbars: CE_ARRAY [INTEGER_32]

	tp_first_diff: CE_POINTER [PD_DIFFBLOCK_S] assign set_tp_first_diff

	tp_diffbuf: CE_ARRAY [CE_POINTER [PD_FILE_BUFFER]]

	tp_diff_invalid: INTEGER_32 assign set_tp_diff_invalid

	tp_snapshot: CE_ARRAY [CE_POINTER [PD_FRAME_S]]

	tp_winvar: PD_DICTITEM_S assign set_tp_winvar

	tp_vars: PD_DICTVAR_S assign set_tp_vars

feature {ANY} -- field setters

	set_tp_next (a_tp_next: CE_POINTER [PD_TABPAGE_S])
		do
			tp_next := a_tp_next
			update_memory_field ("tp_next")
		end

	set_tp_topframe (a_tp_topframe: CE_POINTER [PD_FRAME_S])
		do
			tp_topframe := a_tp_topframe
			update_memory_field ("tp_topframe")
		end

	set_tp_curwin (a_tp_curwin: CE_POINTER [PD_WINDOW_S])
		do
			tp_curwin := a_tp_curwin
			update_memory_field ("tp_curwin")
		end

	set_tp_prevwin (a_tp_prevwin: CE_POINTER [PD_WINDOW_S])
		do
			tp_prevwin := a_tp_prevwin
			update_memory_field ("tp_prevwin")
		end

	set_tp_firstwin (a_tp_firstwin: CE_POINTER [PD_WINDOW_S])
		do
			tp_firstwin := a_tp_firstwin
			update_memory_field ("tp_firstwin")
		end

	set_tp_lastwin (a_tp_lastwin: CE_POINTER [PD_WINDOW_S])
		do
			tp_lastwin := a_tp_lastwin
			update_memory_field ("tp_lastwin")
		end

	set_tp_old_Rows (a_tp_old_Rows: INTEGER_32)
		do
			tp_old_Rows := a_tp_old_Rows
			update_memory_field ("tp_old_Rows")
		end

	set_tp_old_Columns (a_tp_old_Columns: INTEGER_32)
		do
			tp_old_Columns := a_tp_old_Columns
			update_memory_field ("tp_old_Columns")
		end

	set_tp_ch_used (a_tp_ch_used: INTEGER_32)
		do
			tp_ch_used := a_tp_ch_used
			update_memory_field ("tp_ch_used")
		end

	set_tp_first_diff (a_tp_first_diff: CE_POINTER [PD_DIFFBLOCK_S])
		do
			tp_first_diff := a_tp_first_diff
			update_memory_field ("tp_first_diff")
		end

	set_tp_diff_invalid (a_tp_diff_invalid: INTEGER_32)
		do
			tp_diff_invalid := a_tp_diff_invalid
			update_memory_field ("tp_diff_invalid")
		end

	set_tp_winvar (a_tp_winvar: PD_DICTITEM_S)
		do
			tp_winvar := a_tp_winvar
			update_memory_field ("tp_winvar")
		end

	set_tp_vars (a_tp_vars: PD_DICTVAR_S)
		do
			tp_vars := a_tp_vars
			update_memory_field ("tp_vars")
		end

feature {ANY} -- public routines

	diff_mark_adjust_tp (a_idx: INTEGER_32; a_line1, a_line2, a_amount, a_amount_after: INTEGER_32)
		local
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			l_dprev: CE_POINTER [PD_DIFFBLOCK_S]
			l_dnext: CE_POINTER [PD_DIFFBLOCK_S]
			l_i___0: INTEGER_32
			l_inserted: INTEGER_32
			l_deleted: INTEGER_32
			l_n: INTEGER_32
			l_off___0: INTEGER_32
			l_last: INTEGER_32
			l_lnum_deleted: INTEGER_32
			l_check_unchanged: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum_deleted := a_line1
					if a_line2 = 2_147_483_647 then
						l_inserted := a_amount.to_integer_32
						l_deleted := 0
					elseif a_amount_after > 0 then
						l_inserted := a_amount_after.to_integer_32
						l_deleted := 0
					else
						l_inserted := 0
						l_deleted := (-a_amount_after).to_integer_32
					end
					l_dprev := create {CE_CLASS_POINTER [PD_DIFFBLOCK_S]}.make_shared (default_pointer)
					l_dp := tp_first_diff
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 16 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if not (l_dp.is_void) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 5 then -- else:
						if not (l_dp.item.df_lnum[a_idx] - 1 > a_line2) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 8 then -- else:
						if a_line2 /= 2_147_483_647 then
							l_pos := -1 + 15 -- skip if block
						end
				when 9 then -- if:
						if not (l_dp.item.df_lnum[a_idx] > a_line1) then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if: | _L___0:
						if not (l_dprev.is_void) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if not (l_dprev.item.df_lnum[a_idx] + l_dprev.item.df_count[a_idx] < a_line1) then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if not ((create {P_DIFF_STATIC}).diff_busy.item).to_boolean then
							l_dnext := (create {P_DIFF_STATIC}).diff_alloc_new ((create {CE_CLASS_POINTER [PD_TABPAGE_S]}.make_shared (c_pointer)), l_dprev, l_dp)
							update_class_fields -- Current might have been changed; synchronize
							if l_dnext.is_void then
								l_return := True
							end
							if not l_return then
								l_dnext.item.df_lnum[a_idx] := a_line1
								update_class_fields -- Current might have been changed; synchronize
								l_dnext.item.df_count[a_idx] := l_inserted.to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								l_i___0 := 0
								from
								until
									not (l_i___0 < 4)
								loop
									if not (tp_diffbuf[l_i___0]).is_void then
										if l_i___0 /= a_idx then
											if l_dprev.is_void then
												l_dnext.item.df_lnum[l_i___0] := a_line1
												update_class_fields -- Current might have been changed; synchronize
											else
												l_dnext.item.df_lnum[l_i___0] := (a_line1 + (l_dprev.item.df_lnum[l_i___0] + l_dprev.item.df_count[l_i___0])) - (l_dprev.item.df_lnum[a_idx] + l_dprev.item.df_count[a_idx])
												update_class_fields -- Current might have been changed; synchronize
											end
											l_dnext.item.df_count[l_i___0] := l_deleted.to_integer_32
											update_class_fields -- Current might have been changed; synchronize
										end
									end
									l_i___0 := l_i___0 + 1
								end
							end
						end
				when 15 then -- if done | if done | if done | if done | if done
						if not l_return then
							if l_dp.is_void then
								l_break := True
							end
							if not (l_return or l_break) then
								l_last := (l_dp.item.df_lnum[a_idx] + l_dp.item.df_count[a_idx]) - 1
								if l_last >= a_line1 - 1 then
									if l_dp.item.df_lnum[a_idx] - (l_deleted + l_inserted /= 0).to_integer > a_line2 then
										if a_amount_after = 0 then
											l_break := True
										end
										if not (l_return or l_break) then
											l_dp.item.df_lnum[a_idx] := l_dp.item.df_lnum[a_idx] + a_amount_after
											update_class_fields -- Current might have been changed; synchronize
										end
									else
										l_check_unchanged := 0
										if l_deleted > 0 then
											if l_dp.item.df_lnum[a_idx] >= a_line1 then
												l_off___0 := (l_dp.item.df_lnum[a_idx] - l_lnum_deleted).to_integer_32
												if l_last <= a_line2 then
													if not (l_dp.item.df_next).is_void then
														if (l_dp.item.df_next).item.df_lnum[a_idx] - 1 <= a_line2 then
															l_n := ((l_dp.item.df_next).item.df_lnum[a_idx] - l_lnum_deleted).to_integer_32
															l_deleted := l_deleted - l_n
															l_n := (l_n.to_integer_32 - l_dp.item.df_count[a_idx]).to_integer_32
															l_lnum_deleted := (l_dp.item.df_next).item.df_lnum[a_idx]
														else
															l_n := (l_deleted.to_integer_32 - l_dp.item.df_count[a_idx]).to_integer_32
														end
													else
														l_n := (l_deleted.to_integer_32 - l_dp.item.df_count[a_idx]).to_integer_32
													end
													l_dp.item.df_count[a_idx] := (0).to_integer_32
													update_class_fields -- Current might have been changed; synchronize
												else
													l_n := l_off___0
													l_dp.item.df_count[a_idx] := l_dp.item.df_count[a_idx] - ((a_line2 - l_dp.item.df_lnum[a_idx]) + 1)
													update_class_fields -- Current might have been changed; synchronize
													l_check_unchanged := 1
												end
												l_dp.item.df_lnum[a_idx] := a_line1
												update_class_fields -- Current might have been changed; synchronize
											else
												l_off___0 := 0
												if l_last < a_line2 then
													l_dp.item.df_count[a_idx] := l_dp.item.df_count[a_idx] - ((l_last - l_lnum_deleted) + 1)
													update_class_fields -- Current might have been changed; synchronize
													if not (l_dp.item.df_next).is_void then
														if (l_dp.item.df_next).item.df_lnum[a_idx] - 1 <= a_line2 then
															l_n := (((l_dp.item.df_next).item.df_lnum[a_idx] - 1) - l_last).to_integer_32
															l_deleted := (l_deleted.to_integer_32 - ((l_dp.item.df_next).item.df_lnum[a_idx] - l_lnum_deleted)).to_integer_32
															l_lnum_deleted := (l_dp.item.df_next).item.df_lnum[a_idx]
														else
															l_n := (a_line2 - l_last).to_integer_32
														end
													else
														l_n := (a_line2 - l_last).to_integer_32
													end
													l_check_unchanged := 1
												else
													l_n := 0
													l_dp.item.df_count[a_idx] := l_dp.item.df_count[a_idx] - l_deleted.to_integer_32
													update_class_fields -- Current might have been changed; synchronize
												end
											end
											l_i___0 := 0
											from
											until
												not (l_i___0 < 4)
											loop
												if not (tp_diffbuf[l_i___0]).is_void then
													if l_i___0 /= a_idx then
														l_dp.item.df_lnum[l_i___0] := l_dp.item.df_lnum[l_i___0] - l_off___0.to_integer_32
														update_class_fields -- Current might have been changed; synchronize
														l_dp.item.df_count[l_i___0] := l_dp.item.df_count[l_i___0] + l_n.to_integer_32
														update_class_fields -- Current might have been changed; synchronize
													end
												end
												l_i___0 := l_i___0 + 1
											end
										elseif l_dp.item.df_lnum[a_idx] <= a_line1 then
											l_dp.item.df_count[a_idx] := l_dp.item.df_count[a_idx] + l_inserted.to_integer_32
											update_class_fields -- Current might have been changed; synchronize
											l_check_unchanged := 1
										else
											l_dp.item.df_lnum[a_idx] := l_dp.item.df_lnum[a_idx] + l_inserted.to_integer_32
											update_class_fields -- Current might have been changed; synchronize
										end
										if l_check_unchanged.to_boolean then
											diff_check_unchanged ((create {CE_CLASS_POINTER [PD_TABPAGE_S]}.make_shared (c_pointer)), l_dp)
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								end
							end
							if not (l_return or l_break) then
								if not l_dprev.is_void then
									if l_dprev.item.df_lnum[a_idx] + l_dprev.item.df_count[a_idx] = l_dp.item.df_lnum[a_idx] then
										l_i___0 := 0
										from
										until
											not (l_i___0 < 4)
										loop
											if not (tp_diffbuf[l_i___0]).is_void then
												l_dprev.item.df_count[l_i___0] := l_dprev.item.df_count[l_i___0] + (l_dp.item.df_count[l_i___0])
												update_class_fields -- Current might have been changed; synchronize
											end
											l_i___0 := l_i___0 + 1
										end
										l_dprev.item.df_next := l_dp.item.df_next
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_dp))
										update_class_fields -- Current might have been changed; synchronize
										l_dp := l_dprev.item.df_next
									else
										l_dprev := l_dp
										l_dp := l_dp.item.df_next
									end
								else
									l_dprev := l_dp
									l_dp := l_dp.item.df_next
								end
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 16 then -- loop done
					if not l_return then
						l_break := False
						l_dprev := create {CE_CLASS_POINTER [PD_DIFFBLOCK_S]}.make_shared (default_pointer)
						l_dp := tp_first_diff
						from
						until
							not (not (l_return) and then (not l_dp.is_void))
						loop
							l_i___0 := 0
							from
							until
								not (not (l_break) and then (l_i___0 < 4))
							loop
								l_break := False
								if not (tp_diffbuf[l_i___0]).is_void then
									if l_dp.item.df_count[l_i___0] /= 0 then
										l_break := True
									end
								end
								if not (l_return or l_break) then
									l_i___0 := l_i___0 + 1
								end
							end
							l_break := False
							if l_i___0 = 4 then
								l_dnext := l_dp.item.df_next;
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_dp))
								update_class_fields -- Current might have been changed; synchronize
								l_dp := l_dnext
								if l_dprev.is_void then
									Current.tp_first_diff := l_dnext
									update_class_fields -- Current might have been changed; synchronize
								else
									l_dprev.item.df_next := l_dnext
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_dprev := l_dp
								l_dp := l_dp.item.df_next
							end
						end
						if (c_pointer = ((create {P_GLOBALS_STATIC}).curtab.item).c_pointer) then
							(create {P_DIFF_STATIC}).diff_redraw (1)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).diff_need_scrollbind.item := 1
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	diff_clear
		local
			l_p___0: CE_POINTER [PD_DIFFBLOCK_S]
			l_next_p: CE_POINTER [PD_DIFFBLOCK_S]
		do
			l_p___0 := tp_first_diff
			from
			until
				l_p___0.is_void
			loop
				l_next_p := l_p___0.item.df_next;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
				update_class_fields -- Current might have been changed; synchronize
				l_p___0 := l_next_p
			end
			Current.tp_first_diff := create {CE_CLASS_POINTER [PD_DIFFBLOCK_S]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
		end

	enter_tabpage (a_old_curbuf: CE_POINTER [PD_FILE_BUFFER])
		local
			l_old_off: INTEGER_32
			l_next_prevwin: CE_POINTER [PD_WINDOW_S]
			l_tmp: INTEGER_32
		do
			l_old_off := tp_firstwin.item.w_winrow
			l_next_prevwin := tp_prevwin;
			(create {P_GLOBALS_STATIC}).curtab.item := (create {CE_CLASS_POINTER [PD_TABPAGE_S]}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).firstwin.item := tp_firstwin
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).lastwin.item := tp_lastwin
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).topframe.item := tp_topframe
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_WINDOW_STATIC}).win_enter_ext (tp_curwin, 0, 1)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).prevwin.item := l_next_prevwin
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_TABENTER, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			if not a_old_curbuf.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
				(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFENTER, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_WINDOW_STATIC}).last_status (0)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_WINDOW_STATIC}).win_comp_pos.do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).must_redraw.item := 50
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).diff_need_scrollbind.item := 1
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_OPTION_STATIC}).p_ch.item.item := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_ch_used
			update_class_fields -- Current might have been changed; synchronize
			if (create {P_GLOBALS_STATIC}).curtab.item.item.tp_old_Rows /= (create {P_GLOBALS_STATIC}).Rows.item.item then
				(create {P_WINDOW_STATIC}).shell_new_rows
				update_class_fields -- Current might have been changed; synchronize
			elseif l_old_off /= (create {P_GLOBALS_STATIC}).firstwin.item.item.w_winrow then
				l_tmp := (create {P_GUI_STATIC}).gui_use_tabline
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp.to_boolean then
					(create {P_WINDOW_STATIC}).shell_new_rows
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if (create {P_GLOBALS_STATIC}).curtab.item.item.tp_old_Columns /= (create {P_GLOBALS_STATIC}).Columns.item.item then
				if (create {P_GLOBALS_STATIC}).starting.item = 0 then
					(create {P_WINDOW_STATIC}).shell_new_columns
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			(create {P_GUI_STATIC}).gui_may_update_scrollbars
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SCREEN_STATIC}).redraw_all_later (50)
			update_class_fields -- Current might have been changed; synchronize
		end

	clear_snapshot (a_idx: INTEGER_32)
		do
			clear_snapshot_rec (tp_snapshot[a_idx])
			update_class_fields -- Current might have been changed; synchronize
			tp_snapshot[a_idx] := create {CE_CLASS_POINTER [PD_FRAME_S]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_TABPAGE_S} -- private routines

	diff_check_unchanged (a_tp: CE_POINTER [PD_TABPAGE_S]; a_dp: CE_POINTER [PD_DIFFBLOCK_S])
		local
			l_i_org: INTEGER_32
			l_i_new: INTEGER_32
			l_off_org: INTEGER_32
			l_off_new: INTEGER_32
			l_line_org: CE_POINTER [NATURAL_8]
			l_dir___0: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			l_dir___0 := 1
			l_i_org := 0
			from
			until
				not (not (l_break) and then (l_i_org < 4))
			loop
				l_break := False
				if not (a_tp.item.tp_diffbuf[l_i_org]).is_void then
					l_break := True
				end
				if not (l_break) then
					l_i_org := l_i_org + 1
				end
			end
			l_break := False
			if l_i_org = 4 then
				l_return := True
			end
			if not l_return then
				if ((create {P_DIFF_STATIC}).diff_check_sanity (a_tp, a_dp)) = 0 then
					l_return := True
				end
			end
			if not l_return then
				l_off_org := 0
				l_off_new := 0
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						not (not (l_return or l_break) and then (a_dp.item.df_count[l_i_org] > 0))
					loop
						l_break := False
						if l_dir___0 = -1 then
							l_off_org := (a_dp.item.df_count[l_i_org] - 1).to_integer_32
						end
						l_line_org := (create {P_MISC2_STATIC}).vim_strsave (((a_tp.item.tp_diffbuf[l_i_org]).item.ml_get_buf (a_dp.item.df_lnum[l_i_org] + l_off_org.to_integer_32, 0)))
						if l_line_org.is_void then
							l_return := True
						end
						if not l_return then
							l_i_new := l_i_org + 1
							from
							until
								not (not (l_break) and then (l_i_new < 4))
							loop
								l_break := False
								l_continue := False
								if (a_tp.item.tp_diffbuf[l_i_new]).is_void then
									l_continue := True
								end
								if not (l_break or l_continue) then
									if l_dir___0 = -1 then
										l_off_new := (a_dp.item.df_count[l_i_new] - 1).to_integer_32
									end
									if l_off_new < 0 then
										l_break := True
									elseif l_off_new.to_integer_32 >= a_dp.item.df_count[l_i_new] then
										l_break := True
									end
								end
								if not (l_break or l_continue) then
									if ((create {P_DIFF_STATIC}).diff_cmp (l_line_org, ((a_tp.item.tp_diffbuf[l_i_new]).item.ml_get_buf (a_dp.item.df_lnum[l_i_new] + l_off_new.to_integer_32, 0)))) /= 0 then
										l_break := True
									end
								end
								if (not l_break) then
									l_i_new := l_i_new + 1
								end
							end
							l_break := False
							l_continue := False;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_line_org))
							if l_i_new /= 4 then
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_i_new := l_i_org
								from
								until
									not (l_i_new < 4)
								loop
									if not (a_tp.item.tp_diffbuf[l_i_new]).is_void then
										if l_dir___0 = 1 then
											a_dp.item.df_lnum[l_i_new] := (a_dp.item.df_lnum[l_i_new]) + 1
										end
										a_dp.item.df_count[l_i_new] := (a_dp.item.df_count[l_i_new]) - 1
									end
									l_i_new := l_i_new + 1
								end
							end
						end
					end
					if not l_return then
						l_break := False
						if l_dir___0 = -1 then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_dir___0 := -1
						end
					end
				end
			end
			if not l_return then
				l_break := False
			end
		end

	clear_snapshot_rec (a_fr: CE_POINTER [PD_FRAME_S])
		do
			if not a_fr.is_void then
				clear_snapshot_rec (a_fr.item.fr_next)
				clear_snapshot_rec (a_fr.item.fr_child);
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_fr))
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tp_next := a_other.tp_next
			tp_topframe := a_other.tp_topframe
			tp_curwin := a_other.tp_curwin
			tp_prevwin := a_other.tp_prevwin
			tp_firstwin := a_other.tp_firstwin
			tp_lastwin := a_other.tp_lastwin
			tp_old_Rows := a_other.tp_old_Rows
			tp_old_Columns := a_other.tp_old_Columns
			tp_ch_used := a_other.tp_ch_used
			tp_prev_which_scrollbars := a_other.tp_prev_which_scrollbars.twin
			tp_first_diff := a_other.tp_first_diff
			tp_diffbuf := a_other.tp_diffbuf.twin
			tp_diff_invalid := a_other.tp_diff_invalid
			tp_snapshot := a_other.tp_snapshot.twin
			tp_winvar := a_other.tp_winvar.twin
			tp_vars := a_other.tp_vars.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tp_next.is_equal (a_other.tp_next) and
				tp_topframe.is_equal (a_other.tp_topframe) and
				tp_curwin.is_equal (a_other.tp_curwin) and
				tp_prevwin.is_equal (a_other.tp_prevwin) and
				tp_firstwin.is_equal (a_other.tp_firstwin) and
				tp_lastwin.is_equal (a_other.tp_lastwin) and
				tp_old_Rows = a_other.tp_old_Rows and
				tp_old_Columns = a_other.tp_old_Columns and
				tp_ch_used = a_other.tp_ch_used and
				tp_prev_which_scrollbars.is_equal (a_other.tp_prev_which_scrollbars) and
				tp_first_diff.is_equal (a_other.tp_first_diff) and
				tp_diffbuf.is_equal (a_other.tp_diffbuf) and
				tp_diff_invalid = a_other.tp_diff_invalid and
				tp_snapshot.is_equal (a_other.tp_snapshot) and
				tp_winvar.is_equal (a_other.tp_winvar) and
				tp_vars.is_equal (a_other.tp_vars)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tp_next"),
					create {CE_STRUCTURE_FIELD}.make ("tp_topframe"),
					create {CE_STRUCTURE_FIELD}.make ("tp_curwin"),
					create {CE_STRUCTURE_FIELD}.make ("tp_prevwin"),
					create {CE_STRUCTURE_FIELD}.make ("tp_firstwin"),
					create {CE_STRUCTURE_FIELD}.make ("tp_lastwin"),
					create {CE_STRUCTURE_FIELD}.make ("tp_old_Rows"),
					create {CE_STRUCTURE_FIELD}.make ("tp_old_Columns"),
					create {CE_STRUCTURE_FIELD}.make ("tp_ch_used"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("tp_prev_which_scrollbars", <<3>>),
					create {CE_STRUCTURE_FIELD}.make ("tp_first_diff"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("tp_diffbuf", <<4>>),
					create {CE_STRUCTURE_FIELD}.make ("tp_diff_invalid"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("tp_snapshot", <<2>>),
					create {CE_STRUCTURE_FIELD}.make ("tp_winvar"),
					create {CE_STRUCTURE_FIELD}.make ("tp_vars")
				>>)
			init_structure_info
		end

end
