class
	PD_U_ENTRY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_U_ENTRY]} ue_next.make
			create {CE_POINTER_POINTER [NATURAL_8]} ue_array.make
		end

feature {ANY} -- fields

	ue_next: CE_POINTER [PD_U_ENTRY] assign set_ue_next

	ue_top: INTEGER_32 assign set_ue_top

	ue_bot: INTEGER_32 assign set_ue_bot

	ue_lcount: INTEGER_32 assign set_ue_lcount

	ue_array: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_ue_array

	ue_size: INTEGER_32 assign set_ue_size

feature {ANY} -- field setters

	set_ue_next (a_ue_next: CE_POINTER [PD_U_ENTRY])
		do
			ue_next := a_ue_next
			update_memory_field ("ue_next")
		end

	set_ue_top (a_ue_top: INTEGER_32)
		do
			ue_top := a_ue_top
			update_memory_field ("ue_top")
		end

	set_ue_bot (a_ue_bot: INTEGER_32)
		do
			ue_bot := a_ue_bot
			update_memory_field ("ue_bot")
		end

	set_ue_lcount (a_ue_lcount: INTEGER_32)
		do
			ue_lcount := a_ue_lcount
			update_memory_field ("ue_lcount")
		end

	set_ue_array (a_ue_array: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			ue_array := a_ue_array
			update_memory_field ("ue_array")
		end

	set_ue_size (a_ue_size: INTEGER_32)
		do
			ue_size := a_ue_size
			update_memory_field ("ue_size")
		end

feature {ANY} -- public routines

	u_freeentry (a_n: INTEGER_32)
		local
			l_n: INTEGER_32
		do
			l_n := a_n
			from
			until
				not (l_n > 0)
			loop
				l_n := l_n - 1;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (ue_array[l_n]))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (ue_array))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ue_next := a_other.ue_next
			ue_top := a_other.ue_top
			ue_bot := a_other.ue_bot
			ue_lcount := a_other.ue_lcount
			ue_array := a_other.ue_array
			ue_size := a_other.ue_size
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ue_next.is_equal (a_other.ue_next) and
				ue_top = a_other.ue_top and
				ue_bot = a_other.ue_bot and
				ue_lcount = a_other.ue_lcount and
				ue_array.is_equal (a_other.ue_array) and
				ue_size = a_other.ue_size
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ue_next"),
					create {CE_STRUCTURE_FIELD}.make ("ue_top"),
					create {CE_STRUCTURE_FIELD}.make ("ue_bot"),
					create {CE_STRUCTURE_FIELD}.make ("ue_lcount"),
					create {CE_STRUCTURE_FIELD}.make ("ue_array"),
					create {CE_STRUCTURE_FIELD}.make ("ue_size")
				>>)
			init_structure_info
		end

end
