class
	PD_VIM_EXCEPTION

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} value.make
			create {CE_CLASS_POINTER [PD_MSGLIST]} messages.make
			create {CE_NATURAL_8_POINTER} throw_name.make
			create {CE_CLASS_POINTER [PD_VIM_EXCEPTION]} caught.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	value: CE_POINTER [NATURAL_8] assign set_value

	messages: CE_POINTER [PD_MSGLIST] assign set_messages

	throw_name: CE_POINTER [NATURAL_8] assign set_throw_name

	throw_lnum: INTEGER_32 assign set_throw_lnum

	caught: CE_POINTER [PD_VIM_EXCEPTION] assign set_caught

feature {ANY} -- field setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_value (a_value: CE_POINTER [NATURAL_8])
		do
			value := a_value
			update_memory_field ("value")
		end

	set_messages (a_messages: CE_POINTER [PD_MSGLIST])
		do
			messages := a_messages
			update_memory_field ("messages")
		end

	set_throw_name (a_throw_name: CE_POINTER [NATURAL_8])
		do
			throw_name := a_throw_name
			update_memory_field ("throw_name")
		end

	set_throw_lnum (a_throw_lnum: INTEGER_32)
		do
			throw_lnum := a_throw_lnum
			update_memory_field ("throw_lnum")
		end

	set_caught (a_caught: CE_POINTER [PD_VIM_EXCEPTION])
		do
			caught := a_caught
			update_memory_field ("caught")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			value := a_other.value
			messages := a_other.messages
			throw_name := a_other.throw_name
			throw_lnum := a_other.throw_lnum
			caught := a_other.caught
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				value.is_equal (a_other.value) and
				messages.is_equal (a_other.messages) and
				throw_name.is_equal (a_other.throw_name) and
				throw_lnum = a_other.throw_lnum and
				caught.is_equal (a_other.caught)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("value"),
					create {CE_STRUCTURE_FIELD}.make ("messages"),
					create {CE_STRUCTURE_FIELD}.make ("throw_name"),
					create {CE_STRUCTURE_FIELD}.make ("throw_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("caught")
				>>)
			init_structure_info
		end

end
