class
	PD_VIMMENU

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_GTK_GTK_STATIC
		redefine
			copy,
			is_equal
		end
	S_GLIB_OBJECT_STATIC
		redefine
			copy,
			is_equal
		end
	S_GLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} name.make
			create {CE_NATURAL_8_POINTER} dname.make
			create {CE_NATURAL_8_POINTER} en_name.make
			create {CE_NATURAL_8_POINTER} en_dname.make
			create {CE_NATURAL_8_POINTER} actext.make
			create cb.make
			create {CE_NATURAL_8_POINTER} iconfile.make
			create {CE_POINTER_ARRAY [NATURAL_8]} strings.make (<<7>>)
			create {CE_INTEGER_32_ARRAY} noremap.make (<<7>>)
			create {CE_INTEGER_8_ARRAY} silent.make (<<7>>)
			create {CE_CLASS_POINTER [PD_VIMMENU]} children.make
			create {CE_CLASS_POINTER [PD_VIMMENU]} parent.make
			create {CE_CLASS_POINTER [PD_VIMMENU]} next.make
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} id.make
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} submenu_id.make
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} tearoff_handle.make
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} label.make
			Precursor
		end

feature {ANY} -- fields

	modes: INTEGER_32 assign set_modes

	enabled: INTEGER_32 assign set_enabled

	name: CE_POINTER [NATURAL_8] assign set_name

	dname: CE_POINTER [NATURAL_8] assign set_dname

	en_name: CE_POINTER [NATURAL_8] assign set_en_name

	en_dname: CE_POINTER [NATURAL_8] assign set_en_dname

	mnemonic: INTEGER_32 assign set_mnemonic

	actext: CE_POINTER [NATURAL_8] assign set_actext

	priority: INTEGER_32 assign set_priority

	cb: CE_ROUTINE assign set_cb

	iconfile: CE_POINTER [NATURAL_8] assign set_iconfile

	iconidx: INTEGER_32 assign set_iconidx

	icon_builtin: INTEGER_32 assign set_icon_builtin

	strings: CE_ARRAY [CE_POINTER [NATURAL_8]]

	noremap: CE_ARRAY [INTEGER_32]

	silent: CE_ARRAY [INTEGER_8]

	children: CE_POINTER [PD_VIMMENU] assign set_children

	parent: CE_POINTER [PD_VIMMENU] assign set_parent

	next: CE_POINTER [PD_VIMMENU] assign set_next

	id: CE_POINTER [SD_GTKWIDGET] assign set_id

	submenu_id: CE_POINTER [SD_GTKWIDGET] assign set_submenu_id

	tearoff_handle: CE_POINTER [SD_GTKWIDGET] assign set_tearoff_handle

	label: CE_POINTER [SD_GTKWIDGET] assign set_label

feature {ANY} -- field setters

	set_modes (a_modes: INTEGER_32)
		do
			modes := a_modes
			update_memory_field ("modes")
		end

	set_enabled (a_enabled: INTEGER_32)
		do
			enabled := a_enabled
			update_memory_field ("enabled")
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_dname (a_dname: CE_POINTER [NATURAL_8])
		do
			dname := a_dname
			update_memory_field ("dname")
		end

	set_en_name (a_en_name: CE_POINTER [NATURAL_8])
		do
			en_name := a_en_name
			update_memory_field ("en_name")
		end

	set_en_dname (a_en_dname: CE_POINTER [NATURAL_8])
		do
			en_dname := a_en_dname
			update_memory_field ("en_dname")
		end

	set_mnemonic (a_mnemonic: INTEGER_32)
		do
			mnemonic := a_mnemonic
			update_memory_field ("mnemonic")
		end

	set_actext (a_actext: CE_POINTER [NATURAL_8])
		do
			actext := a_actext
			update_memory_field ("actext")
		end

	set_priority (a_priority: INTEGER_32)
		do
			priority := a_priority
			update_memory_field ("priority")
		end

	set_cb (a_cb: CE_ROUTINE)
		do
			cb := a_cb
			update_memory_field ("cb")
		end

	set_iconfile (a_iconfile: CE_POINTER [NATURAL_8])
		do
			iconfile := a_iconfile
			update_memory_field ("iconfile")
		end

	set_iconidx (a_iconidx: INTEGER_32)
		do
			iconidx := a_iconidx
			update_memory_field ("iconidx")
		end

	set_icon_builtin (a_icon_builtin: INTEGER_32)
		do
			icon_builtin := a_icon_builtin
			update_memory_field ("icon_builtin")
		end

	set_children (a_children: CE_POINTER [PD_VIMMENU])
		do
			children := a_children
			update_memory_field ("children")
		end

	set_parent (a_parent: CE_POINTER [PD_VIMMENU])
		do
			parent := a_parent
			update_memory_field ("parent")
		end

	set_next (a_next: CE_POINTER [PD_VIMMENU])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_id (a_id: CE_POINTER [SD_GTKWIDGET])
		do
			id := a_id
			update_memory_field ("id")
		end

	set_submenu_id (a_submenu_id: CE_POINTER [SD_GTKWIDGET])
		do
			submenu_id := a_submenu_id
			update_memory_field ("submenu_id")
		end

	set_tearoff_handle (a_tearoff_handle: CE_POINTER [SD_GTKWIDGET])
		do
			tearoff_handle := a_tearoff_handle
			update_memory_field ("tearoff_handle")
		end

	set_label (a_label: CE_POINTER [SD_GTKWIDGET])
		do
			label := a_label
			update_memory_field ("label")
		end

feature {PD_VIMMENU} -- private attributes

	menu_stock_ids: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("gtk-new"),
					ce_string ("gtk-open"),
					ce_string ("gtk-save"),
					ce_string ("gtk-undo"),
					ce_string ("gtk-redo"),
					ce_string ("gtk-cut"),
					ce_string ("gtk-copy"),
					ce_string ("gtk-paste"),
					ce_string ("gtk-print"),
					ce_string ("gtk-help"),
					ce_string ("gtk-find"),
					ce_string ("vim-save-all"),
					ce_string ("vim-session-save"),
					ce_string ("vim-session-new"),
					ce_string ("vim-session-load"),
					ce_string ("gtk-execute"),
					ce_string ("gtk-find-and-replace"),
					ce_string ("gtk-close"),
					ce_string ("vim-window-maximize"),
					ce_string ("vim-window-minimize"),
					ce_string ("vim-window-split"),
					ce_string ("vim-shell"),
					ce_string ("gtk-go-back"),
					ce_string ("gtk-go-forward"),
					ce_string ("vim-find-help"),
					ce_string ("gtk-convert"),
					ce_string ("gtk-jump-to"),
					ce_string ("vim-build-tags"),
					ce_string ("vim-window-split-vertical"),
					ce_string ("vim-window-maximize-width"),
					ce_string ("vim-window-minimize-width"),
					ce_string ("gtk-quit")
				>>)
		end

	suffixes: CE_STATIC [CE_ARRAY [CE_ARRAY [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_ARRAY_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("png%/0/"),
					ce_string ("xpm%/0/"),
					ce_string ("bmp%/0/")
				>>)
		end

feature {ANY} -- public routines

	add_menu_path (a_menu_path: CE_POINTER [NATURAL_8]; a_pri_tab: CE_POINTER [INTEGER_32]; a_call_data: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_path_name: CE_POINTER [NATURAL_8]
			l_modes: INTEGER_32
			l_menup: CE_POINTER [CE_POINTER [PD_VIMMENU]]
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_parent: CE_POINTER [PD_VIMMENU]
			l_lower_pri: CE_POINTER [CE_POINTER [PD_VIMMENU]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_name___1: CE_POINTER [NATURAL_8]
			l_dname: CE_POINTER [NATURAL_8]
			l_next_name: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_c: INTEGER_32
			l_d: INTEGER_32
			l_idx: INTEGER_32
			l_new_idx: INTEGER_32
			l_pri_idx: INTEGER_32
			l_old_modes: INTEGER_32
			l_amenu: INTEGER_32
			l_en_name: CE_POINTER [NATURAL_8]
			l_map_to: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: INTEGER_32
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: NATURAL_32
			l_len: INTEGER_32
			l_tmp___12: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_POINTER [PD_VIMMENU]} l_menup.make
			create {CE_CLASS_POINTER [PD_VIMMENU]} l_parent.make
			create {CE_NATURAL_8_POINTER} l_dname.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_modes := modes
					l_menu___1 := create {CE_CLASS_POINTER [PD_VIMMENU]}.make_shared (default_pointer)
					l_pri_idx := 0
					l_old_modes := 0
					l_map_to := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_path_name := (create {P_MISC2_STATIC}).vim_strsave (a_menu_path)
					update_class_fields -- Current might have been changed; synchronize
					if l_path_name.is_void then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 45 -- skip if block
					end
				when 1 then -- if:
						l_menup := (create {P_GLOBALS_STATIC}).root_menu.item
						l_parent := create {CE_CLASS_POINTER [PD_VIMMENU]}.make_shared (default_pointer)
						l_name___1 := l_path_name
				when 2 then -- loop condition:
						if not (not (l_return) and then ((l_name___1.item).to_boolean)) then
							l_pos := -1 + 30 -- skip loop
						end
				when 3 then -- loop body:
						l_next_name := (create {P_MENU_STATIC}).menu_name_skip (l_name___1)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_name___1))
						update_class_fields -- Current might have been changed; synchronize
						l_map_to := menutrans_lookup (l_name___1, l_tmp.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if not l_map_to.is_void then
							l_en_name := l_name___1
							l_name___1 := l_map_to
						else
							l_en_name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
						l_dname := (create {P_MENU_STATIC}).menu_text (l_name___1, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if l_dname.is_void then
							l_pos := -1 + 46 -- goto erret
						end
				when 4 then
						if (l_dname.item).to_integer_32 = 0 then
							l_tmp___0 := gettext (ce_string ("E792: Empty menu name"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 46 -- goto erret
						end
				when 5 then
						l_lower_pri := l_menup
						l_idx := 0
						l_new_idx := 0
						l_menu___1 := l_menup.item
				when 6 then -- loop condition:
						if not (not (l_break) and then (not l_menu___1.is_void)) then
							l_pos := -1 + 22 -- skip loop
						end
				when 7 then -- loop body:
						l_break := False
						l_tmp___3 := l_menu___1.item.menu_name_equal (l_name___1)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___3.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						l_tmp___4 := l_menu___1.item.menu_name_equal (l_dname)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___4.to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 11 then -- if: | _L:
						if (l_next_name.item).to_integer_32 = 0 then
							if not (l_menu___1.item.children).is_void then
								if not ((create {P_GLOBALS_STATIC}).sys_menu.item).to_boolean then
									l_tmp___1 := gettext (ce_string ("E330: Menu path must not lead to a sub-menu"))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
								l_pos := -1 + 46 -- goto erret
							end
						end
				when 12 then
						if (l_next_name.item).to_integer_32 /= 0 then
							if (l_menu___1.item.children).is_void then
								if not ((create {P_GLOBALS_STATIC}).sys_menu.item).to_boolean then
									l_tmp___2 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MENU_STATIC}).e_notsubmenu.item)))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___2)).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
								l_pos := -1 + 46 -- goto erret
							end
						end
				when 13 then
						l_break := True
				when 14 then -- if done
						if (l_break) then
							l_pos := -1 + 21 -- skip if block
						end
				when 15 then -- if:
						l_menup := create {CE_POINTER_POINTER [PD_VIMMENU]}.make_shared (l_menu___1.c_pointer + (create {PD_VIMMENU}.make).offset_of ("next"))
						if l_parent.is_void then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L___0
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 18 then -- else:
						l_tmp___5 := menu_is_menubar (l_menu___1.item.name)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___5.to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 19 then -- if: | _L___0:
						l_idx := l_idx + 1
						if l_menu___1.item.priority <= a_pri_tab[l_pri_idx] then
							l_lower_pri := l_menup
							l_new_idx := l_idx
						end
				when 20 then -- if done
						l_menu___1 := l_menu___1.item.next
				when 21 then -- if done
						l_pos := -1 + 6 -- back to loop condition
				when 22 then -- loop done
						l_break := False
						if not (l_menu___1.is_void) then
							l_pos := -1 + 28 -- skip if block
						end
				when 23 then -- if:
						if (l_next_name.item).to_integer_32 = 0 then
							if l_parent.is_void then
								l_tmp___6 := gettext (ce_string ("E331: Must not add menu items directly to menu bar"))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___6)).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_pos := -1 + 46 -- goto erret
							end
						end
				when 24 then
						l_tmp___8 := (create {P_MENU_STATIC}).menu_is_separator (l_dname)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___8.to_boolean then
							if (l_next_name.item).to_integer_32 /= 0 then
								l_tmp___7 := gettext (ce_string ("E332: Separator cannot be part of a menu path"))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___7)).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_pos := -1 + 46 -- goto erret
							end
						end
				when 25 then
						l_tmp___9 := (create {P_MISC2_STATIC}).alloc_clear ((create {PD_VIMMENU}.make).structure_size.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_menu___1 := create {CE_CLASS_POINTER [PD_VIMMENU]}.make_cast (l_tmp___9)
						if l_menu___1.is_void then
							l_pos := -1 + 46 -- goto erret
						end
				when 26 then
						l_menu___1.item.modes := l_modes
						update_class_fields -- Current might have been changed; synchronize
						l_menu___1.item.enabled := ((1).bit_shift_left (6)) - 1
						update_class_fields -- Current might have been changed; synchronize
						l_menu___1.item.name := (create {P_MISC2_STATIC}).vim_strsave (l_name___1)
						update_class_fields -- Current might have been changed; synchronize
						l_menu___1.item.dname := (create {P_MENU_STATIC}).menu_text (l_name___1, create {CE_INTEGER_32_POINTER}.make_shared (l_menu___1.c_pointer + (create {PD_VIMMENU}.make).offset_of ("mnemonic")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (l_menu___1.c_pointer + (create {PD_VIMMENU}.make).offset_of ("actext")))
						update_class_fields -- Current might have been changed; synchronize
						if not l_en_name.is_void then
							l_menu___1.item.en_name := (create {P_MISC2_STATIC}).vim_strsave (l_en_name)
							update_class_fields -- Current might have been changed; synchronize
							l_menu___1.item.en_dname := (create {P_MENU_STATIC}).menu_text (l_en_name, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
						else
							l_menu___1.item.en_name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
							l_menu___1.item.en_dname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_menu___1.item.priority := a_pri_tab[l_pri_idx]
						update_class_fields -- Current might have been changed; synchronize
						l_menu___1.item.parent := l_parent
						update_class_fields -- Current might have been changed; synchronize
						l_menu___1.item.next := l_lower_pri.item
						update_class_fields -- Current might have been changed; synchronize
						l_lower_pri.item := l_menu___1
						update_class_fields -- Current might have been changed; synchronize
						l_old_modes := 0
						l_menu___1.item.iconidx := iconidx
						update_class_fields -- Current might have been changed; synchronize
						l_menu___1.item.icon_builtin := icon_builtin
						update_class_fields -- Current might have been changed; synchronize
						if (l_next_name.item).to_integer_32 = 0 then
							if not iconfile.is_void then
								l_menu___1.item.iconfile := (create {P_MISC2_STATIC}).vim_strsave (iconfile)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_old_modes := l_menu___1.item.modes
						l_menu___1.item.modes := (l_menu___1.item.modes).bit_or (l_modes)
						update_class_fields -- Current might have been changed; synchronize
						l_menu___1.item.enabled := (l_menu___1.item.enabled).bit_or (l_modes)
						update_class_fields -- Current might have been changed; synchronize
				when 29 then -- if done
						if ((l_old_modes).bit_and ((((1).bit_shift_left (6)) - 1))) = 0 then
							if ((l_menu___1.item.modes).bit_and ((((1).bit_shift_left (6)) - 1))) /= 0 then
								if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
									if (l_next_name.item).to_integer_32 = 0 then
										l_menu___1.item.gui_mch_add_menu_item (l_new_idx)
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_GLOBALS_STATIC}).force_menu_update.item := 1
										update_class_fields -- Current might have been changed; synchronize
									else
										l_menu___1.item.gui_mch_add_menu (l_new_idx)
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
						end
						l_menup := create {CE_POINTER_POINTER [PD_VIMMENU]}.make_shared (l_menu___1.c_pointer + (create {PD_VIMMENU}.make).offset_of ("children"))
						l_parent := l_menu___1
						l_name___1 := l_next_name;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_dname))
						update_class_fields -- Current might have been changed; synchronize
						l_dname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						if a_pri_tab[(l_pri_idx + 1)] /= -1 then
							l_pri_idx := l_pri_idx + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 30 then -- loop done;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_path_name))
						update_class_fields -- Current might have been changed; synchronize
						l_amenu := (((l_modes).bit_and (((1).bit_or (((1).bit_shift_left (4)))))) = ((1).bit_or (((1).bit_shift_left (4))))).to_integer
						if ((create {P_GLOBALS_STATIC}).sys_menu.item).to_boolean then
							l_modes := (l_modes).bit_and (((l_old_modes).bit_not))
						end
						if l_menu___1.is_void then
							l_pos := -1 + 44 -- skip if block
						end
				when 31 then -- if:
						if not (l_modes.to_boolean) then
							l_pos := -1 + 44 -- skip if block
						end
				when 32 then -- if:
						l_menu___1.item.cb := (create {P_GUI_STATIC}).gui_menu_cb_address
						update_class_fields -- Current might have been changed; synchronize
						if a_call_data.is_void then
							l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___10 := (create {P_MISC2_STATIC}).vim_strsave (a_call_data)
							update_class_fields -- Current might have been changed; synchronize
							l_p___0 := l_tmp___10
						end
						l_i___0 := 0
				when 33 then -- loop condition:
						if not (l_i___0 < 7) then
							l_pos := -1 + 43 -- skip loop
						end
				when 34 then -- loop body:
						if not (((l_modes).bit_and (((1).bit_shift_left (l_i___0)))).to_boolean) then
							l_pos := -1 + 42 -- skip if block
						end
				when 35 then -- if:
						l_menu___1.item.free_menu_string (l_i___0)
						update_class_fields -- Current might have been changed; synchronize
						l_c := 0
						l_d := 0
						if not (l_amenu.to_boolean) then
							l_pos := -1 + 41 -- skip if block
						end
				when 36 then -- if:
						if a_call_data.is_void then
							l_pos := -1 + 41 -- skip if block
						end
				when 37 then -- if:
						if (a_call_data.item).to_integer_32 = 0 then
							l_pos := -1 + 41 -- skip if block
						end
				when 38 then -- if:
						inspect (1).bit_shift_left (l_i___0) -- switch 1 head
						when 2 then l_pos := -1 + 39 -- (1).bit_shift_left (1)
						when 4 then l_pos := -1 + 39 -- (1).bit_shift_left (2)
						when 8 then l_pos := -1 + 39 -- (1).bit_shift_left (3)
						when 32 then l_pos := -1 + 39 -- (1).bit_shift_left (5)
						when 16 then l_pos := -1 + 40 -- (1).bit_shift_left (4)
						else l_pos := -1 + 41
						end
				when 39 then -- switch 1, case 1 << 1 | switch 1, case 1 << 2 | switch 1, case 1 << 3 | switch 1, case 1 << 5
						l_c := 3
						l_pos := -1 + 41 -- switch 1; break
				when 40 then -- switch 1, case 1 << 4
						l_c := 28
						l_d := 15
						l_pos := -1 + 41 -- switch 1; break
				when 41 then -- switch 1, done: | if done | if done | if done
						if l_c /= 0 then
							l_tmp___11 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_call_data))
							update_class_fields -- Current might have been changed; synchronize
							l_menu___1.item.strings[l_i___0] := (create {P_MISC2_STATIC}).alloc (l_tmp___11 + {NATURAL_32} 5)
							update_class_fields -- Current might have been changed; synchronize
							if not (l_menu___1.item.strings[l_i___0]).is_void then
								(l_menu___1.item.strings[l_i___0])[0] := l_c.to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								if l_d = 0 then
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_menu___1.item.strings[l_i___0] + 1)), create {CE_INTEGER_8_POINTER}.make_cast (a_call_data)).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								else
									(l_menu___1.item.strings[l_i___0])[1] := l_d.to_natural_8
									update_class_fields -- Current might have been changed; synchronize
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_menu___1.item.strings[l_i___0] + 2)), create {CE_INTEGER_8_POINTER}.make_cast (a_call_data)).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
								if l_c = 3 then
									l_tmp___12 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_menu___1.item.strings[l_i___0]))
									update_class_fields -- Current might have been changed; synchronize
									l_len := l_tmp___12.to_integer_32;
									(l_menu___1.item.strings[l_i___0])[l_len] := (28).to_natural_8
									update_class_fields; -- Current might have been changed; synchronize
									(l_menu___1.item.strings[l_i___0])[(l_len + 1)] := (7).to_natural_8
									update_class_fields; -- Current might have been changed; synchronize
									(l_menu___1.item.strings[l_i___0])[(l_len + 2)] := (('%/0/').code).to_natural_8
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						else
							l_menu___1.item.strings[l_i___0] := l_p___0
							update_class_fields -- Current might have been changed; synchronize
						end
						l_menu___1.item.noremap[l_i___0] := noremap[0]
						update_class_fields -- Current might have been changed; synchronize
						l_menu___1.item.silent[l_i___0] := silent[0]
						update_class_fields -- Current might have been changed; synchronize
				when 42 then -- if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 33 -- back to loop condition
				when 43 then -- loop done
						if ((l_modes).bit_and (((1).bit_shift_left (6)))).to_boolean then
							l_menu___1.item.gui_mch_menu_set_tip
							update_class_fields -- Current might have been changed; synchronize
						end
				when 44 then -- if done | if done
						Result := 1
						l_return := True
				when 45 then -- if done
					if l_return then
						l_pos := -1 + 47 -- skip if block
					end
				when 46 then -- if: | erret:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_path_name))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_dname))
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if not l_parent.is_void then
								if not ((l_parent.item.children).is_void) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								if (l_parent.item.parent).is_void then
									l_menup := (create {P_GLOBALS_STATIC}).root_menu.item
								else
									l_menup := create {CE_POINTER_POINTER [PD_VIMMENU]}.make_shared ((l_parent.item.parent).c_pointer + (create {PD_VIMMENU}.make).offset_of ("children"))
								end
								from
								until
									(l_break)
								loop
									l_break := False
									if not (l_menup.item).is_void then
										if (l_menup.item).is_equal (l_parent) then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_return or l_break) then
										l_menup := create {CE_POINTER_POINTER [PD_VIMMENU]}.make_shared ((l_menup.item).c_pointer + (create {PD_VIMMENU}.make).offset_of ("next"))
									end
								end
								l_break := False
								if (l_menup.item).is_void then
									l_break := True
								end
							end
							if not (l_return or l_break) then
								l_parent := l_parent.item.parent;
								(create {P_MENU_STATIC}).free_menu (l_menup)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						Result := 0
				when 47 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	free_menu_string (a_idx: INTEGER_32)
		local
			l_count___2: INTEGER_32
			l_i___0: INTEGER_32
		do
			l_count___2 := 0
			l_i___0 := 0
			from
			until
				not (l_i___0 < 7)
			loop
				if (strings[l_i___0]).is_equal (strings[a_idx]) then
					l_count___2 := l_count___2 + 1
				end
				l_i___0 := l_i___0 + 1
			end
			if l_count___2 = 1 then
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (strings[a_idx]))
				update_class_fields -- Current might have been changed; synchronize
			end
			strings[a_idx] := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
		end

	menu_name_equal (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			if not en_name.is_void then
				l_tmp := menu_namecmp (a_name___1, en_name)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					Result := 1
					l_return := True
				else
					l_tmp___0 := menu_namecmp (a_name___1, en_dname)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___0.to_boolean then
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return then
				l_tmp___1 := menu_namecmp (a_name___1, name)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___1.to_boolean then
					l_tmp___3 := 1
				else
					l_tmp___2 := menu_namecmp (a_name___1, dname)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___2.to_boolean then
						l_tmp___3 := 1
					else
						l_tmp___3 := 0
					end
				end
				Result := l_tmp___3
			end
		end

	create_menu_icon (a_icon_size: NATURAL_32): CE_POINTER [SD_GTKWIDGET]
		local
			l_image: CE_POINTER [SD_GTKWIDGET]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_stock_id: CE_POINTER [INTEGER_8]
			l_n_ids: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<4_096>>)

			l_image := create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
			if not iconfile.is_void then
				l_tmp := lookup_menu_iconfile (iconfile, l_buf___6)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					l_image := load_menu_iconfile (l_buf___6, a_icon_size)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if l_image.is_void then
				if not icon_builtin.to_boolean then
					l_tmp___0 := lookup_menu_iconfile (name, l_buf___6)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___0.to_boolean then
						l_image := load_menu_iconfile (l_buf___6, a_icon_size)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if l_image.is_void then
				l_n_ids := (({PLATFORM}.Pointer_bytes.to_natural_32 * (32).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32
				if iconidx >= 0 then
					if iconidx < l_n_ids then
						l_stock_id := menu_stock_ids.item[iconidx]
					else
						l_stock_id := ce_string ("gtk-missing-image")
					end
				else
					l_stock_id := ce_string ("gtk-missing-image")
				end
				l_image := gtk_image_new_from_stock (l_stock_id, a_icon_size)
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l_image
		end

	menu_item_new (a_parent_widget: CE_POINTER [SD_GTKWIDGET])
		local
			l_box: CE_POINTER [SD_GTKWIDGET]
			l_text: CE_POINTER [NATURAL_8]
			l_use_mnemonic: INTEGER_32
			l___inst: CE_POINTER [SD_GTYPEINSTANCE]
			l___t: NATURAL_32
			l_tmp: NATURAL_32
			l___r: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [SD_GTKWIDGET]
			l_tmp___5: NATURAL_32
			l_tmp___6: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___7: NATURAL_32
			l_tmp___8: CE_POINTER [SD_GTYPEINSTANCE]
		do
			Current.id := gtk_menu_item_new
			update_class_fields -- Current might have been changed; synchronize
			l_box := gtk_hbox_new (0, 20)
			update_class_fields -- Current might have been changed; synchronize
			if ((create {P_OPTION_STATIC}).p_wak.item.item[0]).to_integer_32 /= 110 then
				l_tmp___0 := 1
			else
				l___inst := create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_parent_widget)
				l_tmp := gtk_menu_bar_get_type
				update_class_fields -- Current might have been changed; synchronize
				l___t := l_tmp
				if l___inst.is_void then
					l___r := 0
				elseif (not (l___inst.item.g_class).is_void) then
					if (l___inst.item.g_class).item.g_type = l___t then
						l___r := 1
					else
						l___r := g_type_check_instance_is_a (l___inst, l___t)
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					l___r := g_type_check_instance_is_a (l___inst, l___t)
					update_class_fields -- Current might have been changed; synchronize
				end
				if l___r.to_boolean then
					l_tmp___0 := 0
				else
					l_tmp___0 := 1
				end
			end
			l_use_mnemonic := l_tmp___0
			l_text := (create {P_GUI_GTK_STATIC}).translate_mnemonic_tag (name, l_use_mnemonic)
			update_class_fields -- Current might have been changed; synchronize
			Current.label := gtk_label_new_with_mnemonic (create {CE_INTEGER_8_POINTER}.make_cast (l_text))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_text))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___1 := gtk_box_get_type
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___2 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_box), l_tmp___1)
			update_class_fields -- Current might have been changed; synchronize
			gtk_box_pack_start (create {CE_CLASS_POINTER [SD_GTKBOX]}.make_cast (l_tmp___2), label, 0, 0, (0).to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			if not actext.is_void then
				if (actext[0]).to_integer_32 /= 0 then
					if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
						l_text := actext
					elseif actext.is_void then
						l_text := actext
					else
						l_tmp___3 := (create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, actext, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_text := l_tmp___3
					end
					l_tmp___4 := gtk_label_new (create {CE_INTEGER_8_POINTER}.make_cast (l_text))
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___5 := gtk_box_get_type
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___6 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_box), l_tmp___5)
					update_class_fields -- Current might have been changed; synchronize
					gtk_box_pack_end (create {CE_CLASS_POINTER [SD_GTKBOX]}.make_cast (l_tmp___6), l_tmp___4, 0, 0, (0).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
						l_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					else
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_text))
						update_class_fields -- Current might have been changed; synchronize
						l_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
				end
			end
			l_tmp___7 := gtk_container_get_type
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___8 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (id), l_tmp___7)
			update_class_fields -- Current might have been changed; synchronize
			gtk_container_add (create {CE_CLASS_POINTER [SD_GTKCONTAINER]}.make_cast (l_tmp___8), l_box)
			update_class_fields -- Current might have been changed; synchronize
			gtk_widget_show_all (id)
			update_class_fields -- Current might have been changed; synchronize
		end

	gui_mch_add_menu (a_idx: INTEGER_32)
		local
			l_idx: INTEGER_32
			l_parent: CE_POINTER [PD_VIMMENU]
			l_parent_widget: CE_POINTER [SD_GTKWIDGET]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: NATURAL_32
			l_tmp___3: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___4: NATURAL_32
			l_tmp___5: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___6: NATURAL_32
			l_tmp___7: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: NATURAL_32
			l_tmp___10: CE_POINTER [SD_GTYPEINSTANCE]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [PD_VIMMENU]} l_parent.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_idx := a_idx
					if (name[0]).to_integer_32 = 93 then
						Current.submenu_id := gtk_menu_new
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					else
						l_tmp := (create {P_MENU_STATIC}).menu_is_popup (name)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp.to_boolean then
							Current.submenu_id := gtk_menu_new
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_parent := parent
						if l_parent.is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (l_parent.item.submenu_id).is_void then
							l_return := True
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_tmp___0 := menu_is_menubar (name)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___0.to_boolean then
							l_return := True
						end
				when 5 then -- if done
					if not l_return then
						if not l_parent.is_void then
							l_parent_widget := l_parent.item.submenu_id
						else
							l_parent_widget := (create {P_GUI_STATIC}).gui.item.item.menubar
						end
						((create {CE_CLASS_POINTER [PD_VIMMENU]}.make_shared (c_pointer))).item.menu_item_new (l_parent_widget)
						update_class_fields -- Current might have been changed; synchronize
						if not l_parent.is_void then
							l_tmp___1 := (create {P_MENU_STATIC}).menu_is_popup (l_parent.item.name)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___1.to_boolean then
								l_idx := l_idx + 1
							end
						end
						l_tmp___2 := gtk_menu_shell_get_type
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___3 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_parent_widget), l_tmp___2)
						update_class_fields -- Current might have been changed; synchronize
						gtk_menu_shell_insert (create {CE_CLASS_POINTER [SD_GTKMENUSHELL]}.make_cast (l_tmp___3), id, l_idx)
						update_class_fields -- Current might have been changed; synchronize
						Current.submenu_id := gtk_menu_new
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___4 := gtk_menu_get_type
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___5 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (submenu_id), l_tmp___4)
						update_class_fields -- Current might have been changed; synchronize
						gtk_menu_set_accel_group (create {CE_CLASS_POINTER [SD_GTKMENU]}.make_cast (l_tmp___5), (create {P_GUI_STATIC}).gui.item.item.accel_group)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___6 := gtk_menu_item_get_type
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___7 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (id), l_tmp___6)
						update_class_fields -- Current might have been changed; synchronize
						gtk_menu_item_set_submenu (create {CE_CLASS_POINTER [SD_GTKMENUITEM]}.make_cast (l_tmp___7), submenu_id)
						update_class_fields -- Current might have been changed; synchronize
						Current.tearoff_handle := gtk_tearoff_menu_item_new
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___8 := (create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_go.item.item, ('t').code)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___8.is_void then
							gtk_widget_show (tearoff_handle)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tmp___9 := gtk_menu_get_type
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___10 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (submenu_id), l_tmp___9)
						update_class_fields -- Current might have been changed; synchronize
						gtk_menu_shell_prepend (create {CE_CLASS_POINTER [SD_GTKMENUSHELL]}.make_cast (l_tmp___10), tearoff_handle)
						update_class_fields -- Current might have been changed; synchronize
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_mch_add_menu_item (a_idx: INTEGER_32)
		local
			l_idx: INTEGER_32
			l_parent: CE_POINTER [PD_VIMMENU]
			l_toolbar: CE_POINTER [SD_GTKTOOLBAR]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [SD_GTYPEINSTANCE]
			l_text: CE_POINTER [NATURAL_8]
			l_tooltip: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_tmp___4: NATURAL_32
			l_tmp___5: CE_POINTER [SD_GTKWIDGET]
			l_tmp___6: NATURAL_32
			l_tmp___7: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: NATURAL_32
			l_tmp___11: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___12: INTEGER_32
			l_tmp___13: NATURAL_32
			l_tmp___14: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___15: NATURAL_32
			l_tmp___16: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___17: INTEGER_32
			l_return: BOOLEAN
		do
			l_idx := a_idx
			l_parent := parent
			l_tmp___17 := (create {P_MENU_STATIC}).menu_is_toolbar (l_parent.item.name)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___17.to_boolean then
				l_tmp := gtk_toolbar_get_type
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {P_GUI_STATIC}).gui.item.item.toolbar), l_tmp)
				update_class_fields -- Current might have been changed; synchronize
				l_toolbar := create {CE_CLASS_POINTER [SD_GTKTOOLBAR]}.make_cast (l_tmp___0)
				Current.submenu_id := create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___8 := (create {P_MENU_STATIC}).menu_is_separator (name)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___8.to_boolean then
					gtk_toolbar_insert_space (l_toolbar, l_idx)
					update_class_fields -- Current might have been changed; synchronize
					Current.id := create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
				else
					if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
						l_text := dname
					elseif dname.is_void then
						l_text := dname
					else
						l_tmp___1 := (create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, dname, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_text := l_tmp___1
					end
					if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
						l_tooltip := strings[6]
					elseif (strings[6]).is_void then
						l_tooltip := strings[6]
					else
						l_tmp___2 := (create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, strings[6], create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_tooltip := l_tmp___2
					end
					if not l_tooltip.is_void then
						l_tmp___3 := (create {P_MBYTE_STATIC}).utf_valid_string (l_tooltip, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___3.to_boolean then
							if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
								l_tooltip := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							else
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tooltip))
								update_class_fields -- Current might have been changed; synchronize
								l_tooltip := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							end
						end
					end
					l_tmp___4 := gtk_toolbar_get_icon_size (l_toolbar)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___5 := ((create {CE_CLASS_POINTER [PD_VIMMENU]}.make_shared (c_pointer))).item.create_menu_icon (l_tmp___4)
					update_class_fields -- Current might have been changed; synchronize
					Current.id := gtk_toolbar_insert_item (l_toolbar, create {CE_INTEGER_8_POINTER}.make_cast (l_text), create {CE_INTEGER_8_POINTER}.make_cast (l_tooltip), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), l_tmp___5, ((create {P_GUI_GTK_STATIC}).menu_item_activate_address), create {CE_VOID_POINTER}.make_shared (c_pointer), l_idx)
					update_class_fields -- Current might have been changed; synchronize
					if (create {P_GLOBALS_STATIC}).gtk_socket_id.item /= {NATURAL_32} 0 then
						l_tmp___6 := gtk_object_get_type
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___7 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (id), l_tmp___6)
						update_class_fields -- Current might have been changed; synchronize
						gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___7), ce_string ("focus_in_event"), ((create {P_GUI_GTK_STATIC}).toolbar_button_focus_in_event_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
						l_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					else
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_text))
						update_class_fields -- Current might have been changed; synchronize
						l_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
					if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
						l_tooltip := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					else
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tooltip))
						update_class_fields -- Current might have been changed; synchronize
						l_tooltip := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
				end
			else
				if l_parent.is_void then
					l_return := True
				elseif (l_parent.item.submenu_id).is_void then
					l_return := True
				end
				if not l_return then
					l_tmp___9 := (create {P_MENU_STATIC}).menu_is_popup (l_parent.item.name)
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp___9.to_boolean then
						l_idx := l_idx + 1
					end
					l_tmp___12 := (create {P_MENU_STATIC}).menu_is_separator (name)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___12.to_boolean then
						Current.id := gtk_menu_item_new
						update_class_fields -- Current might have been changed; synchronize
						gtk_widget_set_sensitive (id, 0)
						update_class_fields -- Current might have been changed; synchronize
						gtk_widget_show (id)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___10 := gtk_menu_get_type
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___11 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_parent.item.submenu_id), l_tmp___10)
						update_class_fields -- Current might have been changed; synchronize
						gtk_menu_shell_insert (create {CE_CLASS_POINTER [SD_GTKMENUSHELL]}.make_cast (l_tmp___11), id, l_idx)
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
				end
				if not l_return then
					((create {CE_CLASS_POINTER [PD_VIMMENU]}.make_shared (c_pointer))).item.menu_item_new (l_parent.item.submenu_id)
					update_class_fields -- Current might have been changed; synchronize
					gtk_widget_show (id)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___13 := gtk_menu_get_type
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___14 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_parent.item.submenu_id), l_tmp___13)
					update_class_fields -- Current might have been changed; synchronize
					gtk_menu_shell_insert (create {CE_CLASS_POINTER [SD_GTKMENUSHELL]}.make_cast (l_tmp___14), id, l_idx)
					update_class_fields -- Current might have been changed; synchronize
					if not id.is_void then
						l_tmp___15 := gtk_object_get_type
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___16 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (id), l_tmp___15)
						update_class_fields -- Current might have been changed; synchronize
						gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___16), ce_string ("activate"), ((create {P_GUI_GTK_STATIC}).menu_item_activate_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (c_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if not l_return then
			end
		end

	get_menu_position: INTEGER_32
		local
			l_node: CE_POINTER [PD_VIMMENU]
			l_idx: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_idx := 0
			l_node := parent.item.children
			from
			until
				not (not (l_return) and then (not (l_node.c_pointer = c_pointer)))
			loop
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if l_node.is_void then
						g_return_if_fail_warning (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string ("get_menu_position"), ce_string ("node != NULL"))
						update_class_fields -- Current might have been changed; synchronize
						Result := (-1)
						l_return := True
					end
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
					l_idx := l_idx + 1
					l_node := l_node.item.next
				end
			end
			if not l_return then
				Result := l_idx
			end
		end

	gui_mch_menu_set_tip
		local
			l_tooltip: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
		do
			if not id.is_void then
				if not parent.is_void then
					if not ((create {P_GUI_STATIC}).gui.item.item.toolbar).is_void then
						l_tmp___3 := (create {P_MENU_STATIC}).menu_is_toolbar (parent.item.name)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___3.to_boolean then
							if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
								l_tooltip := strings[6]
							elseif (strings[6]).is_void then
								l_tooltip := strings[6]
							else
								l_tmp := (create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, strings[6], create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
								l_tooltip := l_tmp
							end
							if l_tooltip.is_void then
								l_tmp___0 := gtk_toolbar_get_type
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___1 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {P_GUI_STATIC}).gui.item.item.toolbar), l_tmp___0)
								update_class_fields -- Current might have been changed; synchronize
								gtk_tooltips_set_tip ((create {CE_CLASS_POINTER [SD_GTKTOOLBAR]}.make_cast (l_tmp___1)).item.tooltips, id, create {CE_INTEGER_8_POINTER}.make_cast (l_tooltip), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___2 := (create {P_MBYTE_STATIC}).utf_valid_string (l_tooltip, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___2.to_boolean then
									l_tmp___0 := gtk_toolbar_get_type
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___1 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {P_GUI_STATIC}).gui.item.item.toolbar), l_tmp___0)
									update_class_fields -- Current might have been changed; synchronize
									gtk_tooltips_set_tip ((create {CE_CLASS_POINTER [SD_GTKTOOLBAR]}.make_cast (l_tmp___1)).item.tooltips, id, create {CE_INTEGER_8_POINTER}.make_cast (l_tooltip), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
								l_tooltip := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							else
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tooltip))
								update_class_fields -- Current might have been changed; synchronize
								l_tooltip := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							end
						end
					end
				end
			end
		end

	gui_mch_destroy_menu
		local
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if parent.is_void then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_tmp___3 := (create {P_MENU_STATIC}).menu_is_toolbar (parent.item.name)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___3.to_boolean then
							l_tmp___2 := (create {P_MENU_STATIC}).menu_is_separator (name)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___2.to_boolean then
								l_tmp := ((create {CE_CLASS_POINTER [PD_VIMMENU]}.make_shared (c_pointer))).item.get_menu_position
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___0 := gtk_toolbar_get_type
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___1 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {P_GUI_STATIC}).gui.item.item.toolbar), l_tmp___0)
								update_class_fields -- Current might have been changed; synchronize
								gtk_toolbar_remove_space (create {CE_CLASS_POINTER [SD_GTKTOOLBAR]}.make_cast (l_tmp___1), l_tmp)
								update_class_fields -- Current might have been changed; synchronize
							elseif not id.is_void then
								gtk_widget_destroy (id)
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if not submenu_id.is_void then
							gtk_widget_destroy (submenu_id)
							update_class_fields -- Current might have been changed; synchronize
						end
						if not id.is_void then
							gtk_widget_destroy (id)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 4 then
					Current.submenu_id := create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					Current.id := create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_mch_show_popupmenu
		local
			l_menuitem: CE_POINTER [SD_GTKWIDGET]
			l_submenu: CE_POINTER [SD_GTKWIDGET]
			l_name___1: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: NATURAL_32
			l_tmp___4: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___5: NATURAL_32
			l_tmp___6: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___7: NATURAL_32
			l_tmp___8: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___9: NATURAL_32
			l_tmp___10: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___11: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___12: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___14: NATURAL_32
			l_tmp___15: CE_POINTER [SD_GTYPEINSTANCE]
		do
			if not ((create {P_GLOBALS_STATIC}).xic.item).is_void then
				l_tmp___12 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (submenu_id), ((20).bit_shift_left (2)).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___13 := g_object_get_data (create {CE_CLASS_POINTER [SD_GOBJECT]}.make_cast (l_tmp___12), ce_string ("vim-has-im-menu"))
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___13.is_void then
					l_menuitem := gtk_separator_menu_item_new
					update_class_fields -- Current might have been changed; synchronize
					gtk_widget_show (l_menuitem)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp := gtk_menu_shell_get_type
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (submenu_id), l_tmp)
					update_class_fields -- Current might have been changed; synchronize
					gtk_menu_shell_append (create {CE_CLASS_POINTER [SD_GTKMENUSHELL]}.make_cast (l_tmp___0), l_menuitem)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___1 := gettext (ce_string ("Input _Methods"))
					update_class_fields -- Current might have been changed; synchronize
					l_name___1 := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)
					if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
						l_name___1 := l_name___1
					elseif l_name___1.is_void then
						l_name___1 := l_name___1
					else
						l_tmp___2 := (create {P_MBYTE_STATIC}).string_convert ((create {P_GLOBALS_STATIC}).output_conv.item, l_name___1, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_name___1 := l_tmp___2
					end
					l_menuitem := gtk_menu_item_new_with_mnemonic (create {CE_INTEGER_8_POINTER}.make_cast (l_name___1))
					update_class_fields -- Current might have been changed; synchronize
					if (create {P_GLOBALS_STATIC}).output_conv.item.item.vc_type = 0 then
						l_name___1 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					else
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_name___1))
						update_class_fields -- Current might have been changed; synchronize
						l_name___1 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
					gtk_widget_show (l_menuitem)
					update_class_fields -- Current might have been changed; synchronize
					l_submenu := gtk_menu_new
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___3 := gtk_menu_item_get_type
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___4 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_menuitem), l_tmp___3)
					update_class_fields -- Current might have been changed; synchronize
					gtk_menu_item_set_submenu (create {CE_CLASS_POINTER [SD_GTKMENUITEM]}.make_cast (l_tmp___4), l_submenu)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___5 := gtk_menu_shell_get_type
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___6 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (submenu_id), l_tmp___5)
					update_class_fields -- Current might have been changed; synchronize
					gtk_menu_shell_append (create {CE_CLASS_POINTER [SD_GTKMENUSHELL]}.make_cast (l_tmp___6), l_menuitem)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___7 := gtk_menu_shell_get_type
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___8 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_submenu), l_tmp___7)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___9 := gtk_im_multicontext_get_type
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___10 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {P_GLOBALS_STATIC}).xic.item), l_tmp___9)
					update_class_fields -- Current might have been changed; synchronize
					gtk_im_multicontext_append_menuitems (create {CE_CLASS_POINTER [SD_GTKIMMULTICONTEXT]}.make_cast (l_tmp___10), create {CE_CLASS_POINTER [SD_GTKMENUSHELL]}.make_cast (l_tmp___8))
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___11 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (submenu_id), ((20).bit_shift_left (2)).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					g_object_set_data (create {CE_CLASS_POINTER [SD_GOBJECT]}.make_cast (l_tmp___11), ce_string ("vim-has-im-menu"), create {CE_VOID_POINTER}.make_shared (default_pointer + 1))
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_tmp___14 := gtk_menu_get_type
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___15 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (submenu_id), l_tmp___14)
			update_class_fields -- Current might have been changed; synchronize
			gtk_menu_popup (create {CE_CLASS_POINTER [SD_GTKMENU]}.make_cast (l_tmp___15), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), {NATURAL_32} 3, (0).to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
		end

	gui_mch_menu_grey (a_grey: INTEGER_32)
		local
			l_grey: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
		do
			l_grey := a_grey
			if id.is_void then
				l_return := True
			end
			if not l_return then
				l_tmp := (create {P_MENU_STATIC}).menu_is_separator (name)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					l_grey := 1
				end
				((create {CE_CLASS_POINTER [PD_VIMMENU]}.make_shared (c_pointer))).item.gui_mch_menu_hidden (0)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := gtk_object_get_type
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___1 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (id), l_tmp___0)
				update_class_fields -- Current might have been changed; synchronize
				if (((create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___1)).item.flags).bit_and ({NATURAL_32} 512)) /= {NATURAL_32} 0 then
					l_tmp___2 := 0
				else
					l_tmp___2 := 1
				end
				if l_tmp___2.to_boolean = not l_grey.to_boolean then
					gtk_widget_set_sensitive (id, (not l_grey.to_boolean).to_integer)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GUI_GTK_X11_STATIC}).gui_mch_update
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	gui_mch_menu_hidden (a_hidden: INTEGER_32)
		local
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___1: NATURAL_32
			l_tmp___2: CE_POINTER [SD_GTYPEINSTANCE]
			l_return: BOOLEAN
		do
			if id.is_void then
				l_return := True
			end
			if not l_return then
				if a_hidden.to_boolean then
					l_tmp := gtk_object_get_type
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (id), l_tmp)
					update_class_fields -- Current might have been changed; synchronize
					if (((create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___0)).item.flags).bit_and ({NATURAL_32} 256)) /= {NATURAL_32} 0 then
						gtk_widget_hide (id)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GUI_GTK_X11_STATIC}).gui_mch_update
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					l_tmp___1 := gtk_object_get_type
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (id), l_tmp___1)
					update_class_fields -- Current might have been changed; synchronize
					if (((create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___2)).item.flags).bit_and ({NATURAL_32} 256)) = {NATURAL_32} 0 then
						gtk_widget_show (id)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GUI_GTK_X11_STATIC}).gui_mch_update
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
		end

feature {PD_VIMMENU} -- private routines

	menu_is_menubar (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if ((create {P_MENU_STATIC}).menu_is_popup (a_name___1)).to_boolean then
				l_tmp___1 := 0
			elseif ((create {P_MENU_STATIC}).menu_is_toolbar (a_name___1)).to_boolean then
				l_tmp___1 := 0
			elseif (a_name___1.item).to_integer_32 /= 93 then
				l_tmp___1 := 1
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	menu_namecmp (a_name___1, a_mname: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_name___1.is_void
		local
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i___0 := 0
					from
					until
						(l_break)
					loop
						l_break := False
						if (a_name___1[l_i___0]).to_integer_32 /= 0 then
							if (a_name___1[l_i___0]).to_integer_32 = 9 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) and then ((a_name___1[l_i___0]).to_integer_32 /= (a_mname[l_i___0]).to_integer_32) then
							l_break := True
						end
						if not (l_break) then
							l_i___0 := l_i___0 + 1
						end
					end
					l_break := False
					if (a_name___1[l_i___0]).to_integer_32 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (a_name___1[l_i___0]).to_integer_32 /= 9 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if (a_mname[l_i___0]).to_integer_32 = 0 then
							l_tmp := 1
						elseif (a_mname[l_i___0]).to_integer_32 = 9 then
							l_tmp := 1
						else
							l_tmp := 0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tmp := 0
				when 7 then -- if done
					Result := l_tmp
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menutrans_lookup (a_name___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_tp: CE_POINTER [PD_MENUTRANS_T]
			l_i___0: INTEGER_32
			l_dname: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_tp := create {CE_CLASS_POINTER [PD_MENUTRANS_T]}.make_cast ((create {P_MENU_STATIC}).menutrans_ga.item.item.ga_data)
			l_i___0 := 0
			from
			until
				not (not (l_return) and then (l_i___0 < (create {P_MENU_STATIC}).menutrans_ga.item.item.ga_len))
			loop
				if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), create {CE_INTEGER_8_POINTER}.make_cast ((l_tp + l_i___0).item.from2), a_len.to_natural_32)) = 0 then
					if ((l_tp + l_i___0).item.from2[a_len]).to_integer_32 = 0 then
						Result := ((l_tp + l_i___0).item.to)
						l_return := True
					end
				end
				if not l_return then
					l_i___0 := l_i___0 + 1
				end
			end
			if not l_return then
				l_i___0 := (a_name___1[a_len]).to_integer_32
				a_name___1[a_len] := (('%/0/').code).to_natural_8
				l_dname := (create {P_MENU_STATIC}).menu_text (a_name___1, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
				a_name___1[a_len] := l_i___0.to_natural_8
				if not l_dname.is_void then
					l_i___0 := 0
					from
					until
						not (not (l_return) and then (l_i___0 < (create {P_MENU_STATIC}).menutrans_ga.item.item.ga_len))
					loop
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_dname), create {CE_INTEGER_8_POINTER}.make_cast ((l_tp + l_i___0).item.from_noamp))) = 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_dname))
							Result := ((l_tp + l_i___0).item.to)
							l_return := True
						end
						if not l_return then
							l_i___0 := l_i___0 + 1
						end
					end
					if not l_return then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_dname))
					end
				end
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
		end

	lookup_menu_iconfile (a_iconfile, a_dest: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_dest.is_void
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_i___0: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<4_096>>);

			(create {P_MISC1_STATIC}).expand_env (a_iconfile, a_dest, 4_096)
			if ((create {P_OS_UNIX_STATIC}).mch_isFullName (a_dest)).to_boolean then
				Result := ((create {P_MISC1_STATIC}).vim_fexists (a_dest))
			else
				l_i___0 := {NATURAL_32} 0
				from
				until
					not (not (l_return) and then (l_i___0 < (({PLATFORM}.Integer_8_bytes.to_natural_32 * (4).to_natural_32) * (3).to_natural_32) // ({PLATFORM}.Integer_8_bytes.to_natural_32 * (4).to_natural_32)))
				loop
					if (gui_find_bitmap (a_dest, l_buf___6, (suffixes.item[l_i___0.to_integer_32]))) = 1 then
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (a_dest), create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6)).do_nothing
						Result := 1
						l_return := True
					end
					if not l_return then
						l_i___0 := l_i___0 + 1
					end
				end
				if not l_return then
					Result := 0
				end
			end
		end

	gui_find_bitmap (a_name___1, a_buffer: CE_POINTER [NATURAL_8]; a_ext: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1))) > {NATURAL_32} 4_082 then
				Result := 0
				l_return := True
			end
			if not l_return then
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (a_buffer), (4_096).to_natural_32, ce_string ("bitmaps/%%s.%%s"), a_name___1, a_ext]).do_nothing
				if ((create {P_EX_CMDS2_STATIC}).do_in_runtimepath (a_buffer, 0, (create {P_GUI_STATIC}).gfp_setname_address, create {CE_VOID_POINTER}.make_cast (a_buffer))) = 0 then
					Result := 0
					l_return := True
				elseif (a_buffer.item).to_integer_32 = 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := 1
			end
		end

	load_menu_iconfile (a_name___1: CE_POINTER [NATURAL_8]; a_icon_size: NATURAL_32): CE_POINTER [SD_GTKWIDGET]
		local
			l_image: CE_POINTER [SD_GTKWIDGET]
			l_icon_set: CE_POINTER [ANY]
			l_icon_source: CE_POINTER [ANY]
		do
			l_image := create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
			l_icon_set := gtk_icon_set_new
			l_icon_source := gtk_icon_source_new
			gtk_icon_source_set_filename (l_icon_source, create {CE_INTEGER_8_POINTER}.make_cast (a_name___1))
			gtk_icon_set_add_source (l_icon_set, l_icon_source)
			l_image := gtk_image_new_from_icon_set (l_icon_set, a_icon_size)
			gtk_icon_source_free (l_icon_source)
			gtk_icon_set_unref (l_icon_set)
			Result := l_image
		end

feature {ANY}

	copy (a_other: like Current)
		do
			modes := a_other.modes
			enabled := a_other.enabled
			name := a_other.name
			dname := a_other.dname
			en_name := a_other.en_name
			en_dname := a_other.en_dname
			mnemonic := a_other.mnemonic
			actext := a_other.actext
			priority := a_other.priority
			cb := a_other.cb
			iconfile := a_other.iconfile
			iconidx := a_other.iconidx
			icon_builtin := a_other.icon_builtin
			strings := a_other.strings.twin
			noremap := a_other.noremap.twin
			silent := a_other.silent.twin
			children := a_other.children
			parent := a_other.parent
			next := a_other.next
			id := a_other.id
			submenu_id := a_other.submenu_id
			tearoff_handle := a_other.tearoff_handle
			label := a_other.label
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				modes = a_other.modes and
				enabled = a_other.enabled and
				name.is_equal (a_other.name) and
				dname.is_equal (a_other.dname) and
				en_name.is_equal (a_other.en_name) and
				en_dname.is_equal (a_other.en_dname) and
				mnemonic = a_other.mnemonic and
				actext.is_equal (a_other.actext) and
				priority = a_other.priority and
				cb.is_equal (a_other.cb) and
				iconfile.is_equal (a_other.iconfile) and
				iconidx = a_other.iconidx and
				icon_builtin = a_other.icon_builtin and
				strings.is_equal (a_other.strings) and
				noremap.is_equal (a_other.noremap) and
				silent.is_equal (a_other.silent) and
				children.is_equal (a_other.children) and
				parent.is_equal (a_other.parent) and
				next.is_equal (a_other.next) and
				id.is_equal (a_other.id) and
				submenu_id.is_equal (a_other.submenu_id) and
				tearoff_handle.is_equal (a_other.tearoff_handle) and
				label.is_equal (a_other.label)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("modes"),
					create {CE_STRUCTURE_FIELD}.make ("enabled"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("dname"),
					create {CE_STRUCTURE_FIELD}.make ("en_name"),
					create {CE_STRUCTURE_FIELD}.make ("en_dname"),
					create {CE_STRUCTURE_FIELD}.make ("mnemonic"),
					create {CE_STRUCTURE_FIELD}.make ("actext"),
					create {CE_STRUCTURE_FIELD}.make ("priority"),
					create {CE_STRUCTURE_FIELD}.make ("cb"),
					create {CE_STRUCTURE_FIELD}.make ("iconfile"),
					create {CE_STRUCTURE_FIELD}.make ("iconidx"),
					create {CE_STRUCTURE_FIELD}.make ("icon_builtin"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("strings", <<7>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("noremap", <<7>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("silent", <<7>>),
					create {CE_STRUCTURE_FIELD}.make ("children"),
					create {CE_STRUCTURE_FIELD}.make ("parent"),
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("id"),
					create {CE_STRUCTURE_FIELD}.make ("submenu_id"),
					create {CE_STRUCTURE_FIELD}.make ("tearoff_handle"),
					create {CE_STRUCTURE_FIELD}.make ("label")
				>>)
			init_structure_info
		end

end
