class
	PD_VISUALINFO_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create vi_start.make
			create vi_end.make
		end

feature {ANY} -- fields

	vi_start: PD_POS_T assign set_vi_start

	vi_end: PD_POS_T assign set_vi_end

	vi_mode: INTEGER_32 assign set_vi_mode

	vi_curswant: INTEGER_32 assign set_vi_curswant

feature {ANY} -- field setters

	set_vi_start (a_vi_start: PD_POS_T)
		do
			vi_start := a_vi_start
			update_memory_field ("vi_start")
		end

	set_vi_end (a_vi_end: PD_POS_T)
		do
			vi_end := a_vi_end
			update_memory_field ("vi_end")
		end

	set_vi_mode (a_vi_mode: INTEGER_32)
		do
			vi_mode := a_vi_mode
			update_memory_field ("vi_mode")
		end

	set_vi_curswant (a_vi_curswant: INTEGER_32)
		do
			vi_curswant := a_vi_curswant
			update_memory_field ("vi_curswant")
		end

feature {ANY} -- public routines

	serialize_visualinfo (a_fp: CE_POINTER [SD_IO_FILE])
		do
			(create {P_UNDO_STATIC}).serialize_pos (vi_start.twin, a_fp)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_UNDO_STATIC}).serialize_pos (vi_end.twin, a_fp)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).put_bytes (a_fp, vi_mode.to_natural_32, 4).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).put_bytes (a_fp, vi_curswant.to_natural_32, 4).do_nothing
			update_class_fields -- Current might have been changed; synchronize
		end

	unserialize_visualinfo (a_fp: CE_POINTER [SD_IO_FILE])
		do
			(create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (c_pointer + (create {PD_VISUALINFO_T}.make).offset_of ("vi_start"))).item.unserialize_pos (a_fp)
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (c_pointer + (create {PD_VISUALINFO_T}.make).offset_of ("vi_end"))).item.unserialize_pos (a_fp)
			update_class_fields -- Current might have been changed; synchronize
			Current.vi_mode := (create {P_MISC2_STATIC}).get4c (a_fp)
			update_class_fields -- Current might have been changed; synchronize
			Current.vi_curswant := (create {P_MISC2_STATIC}).get4c (a_fp)
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			vi_start := a_other.vi_start.twin
			vi_end := a_other.vi_end.twin
			vi_mode := a_other.vi_mode
			vi_curswant := a_other.vi_curswant
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				vi_start.is_equal (a_other.vi_start) and
				vi_end.is_equal (a_other.vi_end) and
				vi_mode = a_other.vi_mode and
				vi_curswant = a_other.vi_curswant
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("vi_start"),
					create {CE_STRUCTURE_FIELD}.make ("vi_end"),
					create {CE_STRUCTURE_FIELD}.make ("vi_mode"),
					create {CE_STRUCTURE_FIELD}.make ("vi_curswant")
				>>)
			init_structure_info
		end

end
