class
	PD_WN_U1

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	hashkey: CE_ARRAY [NATURAL_8]

	index: INTEGER_32 assign set_index

feature {ANY} -- field setters

	set_index (a_index: INTEGER_32)
		do
			index := a_index
			update_memory_field ("index")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			hashkey := a_other.hashkey.twin
			index := a_other.index
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				hashkey.is_equal (a_other.hashkey) and
				index = a_other.index
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("hashkey", <<6>>),
					create {CE_STRUCTURE_FIELD}.make ("index")
				>>)
			init_structure_info
		end

end
