class
	PD_XSMP_CONFIG_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} smcconn.make
			create {CE_VOID_POINTER} iceconn.make
			create {CE_INTEGER_8_POINTER} clientid.make
		end

feature {ANY} -- fields

	smcconn: CE_POINTER [ANY] assign set_smcconn

	iceconn: CE_POINTER [ANY] assign set_iceconn

	clientid: CE_POINTER [INTEGER_8] assign set_clientid

	save_yourself: INTEGER_32 assign set_save_yourself

	shutdown: INTEGER_32 assign set_shutdown

feature {ANY} -- field setters

	set_smcconn (a_smcconn: CE_POINTER [ANY])
		do
			smcconn := a_smcconn
			update_memory_field ("smcconn")
		end

	set_iceconn (a_iceconn: CE_POINTER [ANY])
		do
			iceconn := a_iceconn
			update_memory_field ("iceconn")
		end

	set_clientid (a_clientid: CE_POINTER [INTEGER_8])
		do
			clientid := a_clientid
			update_memory_field ("clientid")
		end

	set_save_yourself (a_save_yourself: INTEGER_32)
		do
			save_yourself := a_save_yourself
			update_memory_field ("save_yourself")
		end

	set_shutdown (a_shutdown: INTEGER_32)
		do
			shutdown := a_shutdown
			update_memory_field ("shutdown")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			smcconn := a_other.smcconn
			iceconn := a_other.iceconn
			clientid := a_other.clientid
			save_yourself := a_other.save_yourself
			shutdown := a_other.shutdown
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				smcconn.is_equal (a_other.smcconn) and
				iceconn.is_equal (a_other.iceconn) and
				clientid.is_equal (a_other.clientid) and
				save_yourself = a_other.save_yourself and
				shutdown = a_other.shutdown
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("smcconn"),
					create {CE_STRUCTURE_FIELD}.make ("iceconn"),
					create {CE_STRUCTURE_FIELD}.make ("clientid"),
					create {CE_STRUCTURE_FIELD}.make ("save_yourself"),
					create {CE_STRUCTURE_FIELD}.make ("shutdown")
				>>)
			init_structure_info
		end

end
