class
	S_STDIO_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	fputs (a___s: CE_POINTER [INTEGER_8]; a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputs (a___s.c_pointer, a___stream.c_pointer)
		end

	c_fputs (a___s: POINTER; a___stream: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return fputs($a___s, $a___stream);"
		end

	sscanf (a_args: TUPLE [a___s, a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sscanf)).integer_32_item (a_args)
		end

	c_sscanf: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)&sscanf;"
		end

	fclose (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fclose (a___stream.c_pointer)
		end

	c_fclose (a___stream: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return fclose($a___stream);"
		end

	fopen (a___filename, a___modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create {CE_CLASS_POINTER [SD_IO_FILE]} Result.make_shared (c_fopen (a___filename.c_pointer, a___modes.c_pointer))
		end

	c_fopen (a___filename: POINTER; a___modes: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)fopen($a___filename, $a___modes);"
		end

	fwrite (a___ptr: CE_POINTER [ANY]; a___size, a___n: NATURAL_32; a___s: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fwrite (a___ptr.c_pointer, a___size, a___n, a___s.c_pointer)
		end

	c_fwrite (a___ptr: POINTER; a___size: NATURAL_32; a___n: NATURAL_32; a___s: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return fwrite($a___ptr, $a___size, $a___n, $a___s);"
		end

	fprintf (a_args: TUPLE [a___stream: CE_POINTER [SD_IO_FILE]; a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fprintf)).integer_32_item (a_args)
		end

	c_fprintf: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)&fprintf;"
		end

	sprintf (a_args: TUPLE [a___s, a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sprintf)).integer_32_item (a_args)
		end

	c_sprintf: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)&sprintf;"
		end

	fread (a___ptr: CE_POINTER [ANY]; a___size, a___n: NATURAL_32; a___stream: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fread (a___ptr.c_pointer, a___size, a___n, a___stream.c_pointer)
		end

	c_fread (a___ptr: POINTER; a___size: NATURAL_32; a___n: NATURAL_32; a___stream: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return fread($a___ptr, $a___size, $a___n, $a___stream);"
		end

	fdopen (a___fd: INTEGER_32; a___modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create {CE_CLASS_POINTER [SD_IO_FILE]} Result.make_shared (c_fdopen (a___fd, a___modes.c_pointer))
		end

	c_fdopen (a___fd: INTEGER_32; a___modes: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)fdopen($a___fd, $a___modes);"
		end

	fileno (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fileno (a___stream.c_pointer)
		end

	c_fileno (a___stream: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return fileno($a___stream);"
		end

	fgets (a___s: CE_POINTER [INTEGER_8]; a___n: INTEGER_32; a___stream: CE_POINTER [SD_IO_FILE]): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_fgets (a___s.c_pointer, a___n, a___stream.c_pointer))
		end

	c_fgets (a___s: POINTER; a___n: INTEGER_32; a___stream: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)fgets($a___s, $a___n, $a___stream);"
		end

	fputc (a___c: INTEGER_32; a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputc (a___c, a___stream.c_pointer)
		end

	c_fputc (a___c: INTEGER_32; a___stream: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return fputc($a___c, $a___stream);"
		end

	rename2 (a___old, a___new: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_rename2 (a___old.c_pointer, a___new.c_pointer)
		end

	c_rename2 (a___old: POINTER; a___new: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return rename($a___old, $a___new);"
		end

	ferror (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_ferror (a___stream.c_pointer)
		end

	c_ferror (a___stream: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return ferror($a___stream);"
		end

	printf (a_args: TUPLE [a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_printf)).integer_32_item (a_args)
		end

	c_printf: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)&printf;"
		end

	putchar (a___c: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return putchar($a___c);"
		end

	fseek (a___stream: CE_POINTER [SD_IO_FILE]; a___off: INTEGER_32; a___whence: INTEGER_32): INTEGER_32
		do
			Result := c_fseek (a___stream.c_pointer, a___off, a___whence)
		end

	c_fseek (a___stream: POINTER; a___off: INTEGER_32; a___whence: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return fseek($a___stream, $a___off, $a___whence);"
		end

	ftell (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_ftell (a___stream.c_pointer)
		end

	c_ftell (a___stream: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return ftell($a___stream);"
		end

	ungetc (a___c: INTEGER_32; a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_ungetc (a___c, a___stream.c_pointer)
		end

	c_ungetc (a___c: INTEGER_32; a___stream: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return ungetc($a___c, $a___stream);"
		end

	rewind (a___stream: CE_POINTER [SD_IO_FILE])
		do
			c_rewind (a___stream.c_pointer)
		end

	c_rewind (a___stream: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"rewind($a___stream);"
		end

	fseeko (a___stream: CE_POINTER [SD_IO_FILE]; a___off: INTEGER_32; a___whence: INTEGER_32): INTEGER_32
		do
			Result := c_fseeko (a___stream.c_pointer, a___off, a___whence)
		end

	c_fseeko (a___stream: POINTER; a___off: INTEGER_32; a___whence: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return fseeko($a___stream, $a___off, $a___whence);"
		end

	ftello (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_ftello (a___stream.c_pointer)
		end

	c_ftello (a___stream: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return ftello($a___stream);"
		end

	fflush (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fflush (a___stream.c_pointer)
		end

	c_fflush (a___stream: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return fflush($a___stream);"
		end

end
