class
	SD_ATKOBJECT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create parent.make
			create {CE_INTEGER_8_POINTER} description.make
			create {CE_INTEGER_8_POINTER} name.make
			create {CE_CLASS_POINTER [SD_ATKOBJECT]} accessible_parent.make
			create {CE_CLASS_POINTER [SD_ATKRELATIONSET]} relation_set.make
		end

feature {ANY} -- fields

	parent: SD_GOBJECT assign set_parent

	description: CE_POINTER [INTEGER_8] assign set_description

	name: CE_POINTER [INTEGER_8] assign set_name

	accessible_parent: CE_POINTER [SD_ATKOBJECT] assign set_accessible_parent

	role: NATURAL_32 assign set_role

	relation_set: CE_POINTER [SD_ATKRELATIONSET] assign set_relation_set

	layer: NATURAL_32 assign set_layer

feature {ANY} -- field setters

	set_parent (a_parent: SD_GOBJECT)
		do
			parent := a_parent
			update_memory_field ("parent")
		end

	set_description (a_description: CE_POINTER [INTEGER_8])
		do
			description := a_description
			update_memory_field ("description")
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_accessible_parent (a_accessible_parent: CE_POINTER [SD_ATKOBJECT])
		do
			accessible_parent := a_accessible_parent
			update_memory_field ("accessible_parent")
		end

	set_role (a_role: NATURAL_32)
		do
			role := a_role
			update_memory_field ("role")
		end

	set_relation_set (a_relation_set: CE_POINTER [SD_ATKRELATIONSET])
		do
			relation_set := a_relation_set
			update_memory_field ("relation_set")
		end

	set_layer (a_layer: NATURAL_32)
		do
			layer := a_layer
			update_memory_field ("layer")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent := a_other.parent.twin
			description := a_other.description
			name := a_other.name
			accessible_parent := a_other.accessible_parent
			role := a_other.role
			relation_set := a_other.relation_set
			layer := a_other.layer
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent.is_equal (a_other.parent) and
				description.is_equal (a_other.description) and
				name.is_equal (a_other.name) and
				accessible_parent.is_equal (a_other.accessible_parent) and
				role = a_other.role and
				relation_set.is_equal (a_other.relation_set) and
				layer = a_other.layer
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent"),
					create {CE_STRUCTURE_FIELD}.make ("description"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("accessible_parent"),
					create {CE_STRUCTURE_FIELD}.make ("role"),
					create {CE_STRUCTURE_FIELD}.make ("relation_set"),
					create {CE_STRUCTURE_FIELD}.make ("layer")
				>>)
			init_structure_info
		end

end
