class
	SD_GDKDEVICE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create parent_instance.make
			create {CE_INTEGER_8_POINTER} name.make
			create {CE_CLASS_POINTER [SD_GDKDEVICEAXIS]} axes.make
			create {CE_CLASS_POINTER [SD_GDKDEVICEKEY]} keys.make
		end

feature {ANY} -- fields

	parent_instance: SD_GOBJECT assign set_parent_instance

	name: CE_POINTER [INTEGER_8] assign set_name

	source: NATURAL_32 assign set_source

	mode: NATURAL_32 assign set_mode

	has_cursor: INTEGER_32 assign set_has_cursor

	num_axes: INTEGER_32 assign set_num_axes

	axes: CE_POINTER [SD_GDKDEVICEAXIS] assign set_axes

	num_keys: INTEGER_32 assign set_num_keys

	keys: CE_POINTER [SD_GDKDEVICEKEY] assign set_keys

feature {ANY} -- field setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance := a_parent_instance
			update_memory_field ("parent_instance")
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_source (a_source: NATURAL_32)
		do
			source := a_source
			update_memory_field ("source")
		end

	set_mode (a_mode: NATURAL_32)
		do
			mode := a_mode
			update_memory_field ("mode")
		end

	set_has_cursor (a_has_cursor: INTEGER_32)
		do
			has_cursor := a_has_cursor
			update_memory_field ("has_cursor")
		end

	set_num_axes (a_num_axes: INTEGER_32)
		do
			num_axes := a_num_axes
			update_memory_field ("num_axes")
		end

	set_axes (a_axes: CE_POINTER [SD_GDKDEVICEAXIS])
		do
			axes := a_axes
			update_memory_field ("axes")
		end

	set_num_keys (a_num_keys: INTEGER_32)
		do
			num_keys := a_num_keys
			update_memory_field ("num_keys")
		end

	set_keys (a_keys: CE_POINTER [SD_GDKDEVICEKEY])
		do
			keys := a_keys
			update_memory_field ("keys")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_instance := a_other.parent_instance.twin
			name := a_other.name
			source := a_other.source
			mode := a_other.mode
			has_cursor := a_other.has_cursor
			num_axes := a_other.num_axes
			axes := a_other.axes
			num_keys := a_other.num_keys
			keys := a_other.keys
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_instance.is_equal (a_other.parent_instance) and
				name.is_equal (a_other.name) and
				source = a_other.source and
				mode = a_other.mode and
				has_cursor = a_other.has_cursor and
				num_axes = a_other.num_axes and
				axes.is_equal (a_other.axes) and
				num_keys = a_other.num_keys and
				keys.is_equal (a_other.keys)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_instance"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("source"),
					create {CE_STRUCTURE_FIELD}.make ("mode"),
					create {CE_STRUCTURE_FIELD}.make ("has_cursor"),
					create {CE_STRUCTURE_FIELD}.make ("num_axes"),
					create {CE_STRUCTURE_FIELD}.make ("axes"),
					create {CE_STRUCTURE_FIELD}.make ("num_keys"),
					create {CE_STRUCTURE_FIELD}.make ("keys")
				>>)
			init_structure_info
		end

end
