class
	SD_GDKEVENTANY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} window.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window

	send_event: INTEGER_8 assign set_send_event

feature {ANY} -- field setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			window := a_window
			update_memory_field ("window")
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			window := a_other.window
			send_event := a_other.send_event
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				window.is_equal (a_other.window) and
				send_event = a_other.send_event
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("send_event")
				>>)
			init_structure_info
		end

end
