class
	SD_GDKEVENTCROSSING

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} window.make
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} subwindow.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window

	send_event: INTEGER_8 assign set_send_event

	subwindow: CE_POINTER [SD_GDKDRAWABLE] assign set_subwindow

	time: NATURAL_32 assign set_time

	x: REAL_64 assign set_x

	y: REAL_64 assign set_y

	x_root: REAL_64 assign set_x_root

	y_root: REAL_64 assign set_y_root

	mode: NATURAL_32 assign set_mode

	detail: NATURAL_32 assign set_detail

	focus: INTEGER_32 assign set_focus

	state: NATURAL_32 assign set_state

feature {ANY} -- field setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			window := a_window
			update_memory_field ("window")
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_subwindow (a_subwindow: CE_POINTER [SD_GDKDRAWABLE])
		do
			subwindow := a_subwindow
			update_memory_field ("subwindow")
		end

	set_time (a_time: NATURAL_32)
		do
			time := a_time
			update_memory_field ("time")
		end

	set_x (a_x: REAL_64)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: REAL_64)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_x_root (a_x_root: REAL_64)
		do
			x_root := a_x_root
			update_memory_field ("x_root")
		end

	set_y_root (a_y_root: REAL_64)
		do
			y_root := a_y_root
			update_memory_field ("y_root")
		end

	set_mode (a_mode: NATURAL_32)
		do
			mode := a_mode
			update_memory_field ("mode")
		end

	set_detail (a_detail: NATURAL_32)
		do
			detail := a_detail
			update_memory_field ("detail")
		end

	set_focus (a_focus: INTEGER_32)
		do
			focus := a_focus
			update_memory_field ("focus")
		end

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			window := a_other.window
			send_event := a_other.send_event
			subwindow := a_other.subwindow
			time := a_other.time
			x := a_other.x
			y := a_other.y
			x_root := a_other.x_root
			y_root := a_other.y_root
			mode := a_other.mode
			detail := a_other.detail
			focus := a_other.focus
			state := a_other.state
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				window.is_equal (a_other.window) and
				send_event = a_other.send_event and
				subwindow.is_equal (a_other.subwindow) and
				time = a_other.time and
				x = a_other.x and
				y = a_other.y and
				x_root = a_other.x_root and
				y_root = a_other.y_root and
				mode = a_other.mode and
				detail = a_other.detail and
				focus = a_other.focus and
				state = a_other.state
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("subwindow"),
					create {CE_STRUCTURE_FIELD}.make ("time"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("x_root"),
					create {CE_STRUCTURE_FIELD}.make ("y_root"),
					create {CE_STRUCTURE_FIELD}.make ("mode"),
					create {CE_STRUCTURE_FIELD}.make ("detail"),
					create {CE_STRUCTURE_FIELD}.make ("focus"),
					create {CE_STRUCTURE_FIELD}.make ("state")
				>>)
			init_structure_info
		end

end
