class
	SD_GDKEVENTOWNERCHANGE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} window.make
			create {CE_VOID_POINTER} selection.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window

	send_event: INTEGER_8 assign set_send_event

	owner: NATURAL_32 assign set_owner

	reason: NATURAL_32 assign set_reason

	selection: CE_POINTER [ANY] assign set_selection

	time: NATURAL_32 assign set_time

	selection_time: NATURAL_32 assign set_selection_time

feature {ANY} -- field setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			window := a_window
			update_memory_field ("window")
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_owner (a_owner: NATURAL_32)
		do
			owner := a_owner
			update_memory_field ("owner")
		end

	set_reason (a_reason: NATURAL_32)
		do
			reason := a_reason
			update_memory_field ("reason")
		end

	set_selection (a_selection: CE_POINTER [ANY])
		do
			selection := a_selection
			update_memory_field ("selection")
		end

	set_time (a_time: NATURAL_32)
		do
			time := a_time
			update_memory_field ("time")
		end

	set_selection_time (a_selection_time: NATURAL_32)
		do
			selection_time := a_selection_time
			update_memory_field ("selection_time")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			window := a_other.window
			send_event := a_other.send_event
			owner := a_other.owner
			reason := a_other.reason
			selection := a_other.selection
			time := a_other.time
			selection_time := a_other.selection_time
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				window.is_equal (a_other.window) and
				send_event = a_other.send_event and
				owner = a_other.owner and
				reason = a_other.reason and
				selection.is_equal (a_other.selection) and
				time = a_other.time and
				selection_time = a_other.selection_time
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("owner"),
					create {CE_STRUCTURE_FIELD}.make ("reason"),
					create {CE_STRUCTURE_FIELD}.make ("selection"),
					create {CE_STRUCTURE_FIELD}.make ("time"),
					create {CE_STRUCTURE_FIELD}.make ("selection_time")
				>>)
			init_structure_info
		end

end
