class
	SD_GTKACCELGROUPENTRY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create key.make
			create {CE_CLASS_POINTER [SD_GCLOSURE]} closure.make
		end

feature {ANY} -- fields

	key: SD_GTKACCELKEY assign set_key

	closure: CE_POINTER [SD_GCLOSURE] assign set_closure

	accel_path_quark: NATURAL_32 assign set_accel_path_quark

feature {ANY} -- field setters

	set_key (a_key: SD_GTKACCELKEY)
		do
			key := a_key
			update_memory_field ("key")
		end

	set_closure (a_closure: CE_POINTER [SD_GCLOSURE])
		do
			closure := a_closure
			update_memory_field ("closure")
		end

	set_accel_path_quark (a_accel_path_quark: NATURAL_32)
		do
			accel_path_quark := a_accel_path_quark
			update_memory_field ("accel_path_quark")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			key := a_other.key.twin
			closure := a_other.closure
			accel_path_quark := a_other.accel_path_quark
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				key.is_equal (a_other.key) and
				closure.is_equal (a_other.closure) and
				accel_path_quark = a_other.accel_path_quark
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("key"),
					create {CE_STRUCTURE_FIELD}.make ("closure"),
					create {CE_STRUCTURE_FIELD}.make ("accel_path_quark")
				>>)
			init_structure_info
		end

end
