class
	SD_GTKBIN

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create container.make
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} child.make
		end

feature {ANY} -- fields

	container: SD_GTKCONTAINER assign set_container

	child: CE_POINTER [SD_GTKWIDGET] assign set_child

feature {ANY} -- field setters

	set_container (a_container: SD_GTKCONTAINER)
		do
			container := a_container
			update_memory_field ("container")
		end

	set_child (a_child: CE_POINTER [SD_GTKWIDGET])
		do
			child := a_child
			update_memory_field ("child")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			container := a_other.container.twin
			child := a_other.child
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				container.is_equal (a_other.container) and
				child.is_equal (a_other.child)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("container"),
					create {CE_STRUCTURE_FIELD}.make ("child")
				>>)
			init_structure_info
		end

end
