class
	SD_GTKMISC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create widget.make
		end

feature {ANY} -- fields

	widget: SD_GTKWIDGET assign set_widget

	xalign: REAL_32 assign set_xalign

	yalign: REAL_32 assign set_yalign

	xpad: NATURAL_16 assign set_xpad

	ypad: NATURAL_16 assign set_ypad

feature {ANY} -- field setters

	set_widget (a_widget: SD_GTKWIDGET)
		do
			widget := a_widget
			update_memory_field ("widget")
		end

	set_xalign (a_xalign: REAL_32)
		do
			xalign := a_xalign
			update_memory_field ("xalign")
		end

	set_yalign (a_yalign: REAL_32)
		do
			yalign := a_yalign
			update_memory_field ("yalign")
		end

	set_xpad (a_xpad: NATURAL_16)
		do
			xpad := a_xpad
			update_memory_field ("xpad")
		end

	set_ypad (a_ypad: NATURAL_16)
		do
			ypad := a_ypad
			update_memory_field ("ypad")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			widget := a_other.widget.twin
			xalign := a_other.xalign
			yalign := a_other.yalign
			xpad := a_other.xpad
			ypad := a_other.ypad
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				widget.is_equal (a_other.widget) and
				xalign = a_other.xalign and
				yalign = a_other.yalign and
				xpad = a_other.xpad and
				ypad = a_other.ypad
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("widget"),
					create {CE_STRUCTURE_FIELD}.make ("xalign"),
					create {CE_STRUCTURE_FIELD}.make ("yalign"),
					create {CE_STRUCTURE_FIELD}.make ("xpad"),
					create {CE_STRUCTURE_FIELD}.make ("ypad")
				>>)
			init_structure_info
		end

end
