class
	SD_GTKNOTEBOOK

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	container: SD_GTKCONTAINER assign set_container

	cur_page: CE_POINTER [ANY] assign set_cur_page

	children: CE_POINTER [SD_GLIST] assign set_children

	first_tab: CE_POINTER [SD_GLIST] assign set_first_tab

	focus_tab: CE_POINTER [SD_GLIST] assign set_focus_tab

	menu: CE_POINTER [SD_GTKWIDGET] assign set_menu

	event_window: CE_POINTER [SD_GDKDRAWABLE] assign set_event_window

	timer: NATURAL_32 assign set_timer

	tab_hborder: NATURAL_16 assign set_tab_hborder

	tab_vborder: NATURAL_16 assign set_tab_vborder

	show_tabs: NATURAL_32 assign set_show_tabs

	homogeneous: NATURAL_32 assign set_homogeneous

	show_border: NATURAL_32 assign set_show_border

	tab_pos: NATURAL_32 assign set_tab_pos

	scrollable: NATURAL_32 assign set_scrollable

	in_child: NATURAL_32 assign set_in_child

	click_child: NATURAL_32 assign set_click_child

	button: NATURAL_32 assign set_button

	need_timer: NATURAL_32 assign set_need_timer

	child_has_focus: NATURAL_32 assign set_child_has_focus

	have_visible_child: NATURAL_32 assign set_have_visible_child

	focus_out: NATURAL_32 assign set_focus_out

	has_before_previous: NATURAL_32 assign set_has_before_previous

	has_before_next: NATURAL_32 assign set_has_before_next

	has_after_previous: NATURAL_32 assign set_has_after_previous

	has_after_next: NATURAL_32 assign set_has_after_next

feature {ANY} -- field setters

	set_container (a_container: SD_GTKCONTAINER)
		do
			container := a_container
			update_memory_field ("container")
		end

	set_cur_page (a_cur_page: CE_POINTER [ANY])
		do
			cur_page := a_cur_page
			update_memory_field ("cur_page")
		end

	set_children (a_children: CE_POINTER [SD_GLIST])
		do
			children := a_children
			update_memory_field ("children")
		end

	set_first_tab (a_first_tab: CE_POINTER [SD_GLIST])
		do
			first_tab := a_first_tab
			update_memory_field ("first_tab")
		end

	set_focus_tab (a_focus_tab: CE_POINTER [SD_GLIST])
		do
			focus_tab := a_focus_tab
			update_memory_field ("focus_tab")
		end

	set_menu (a_menu: CE_POINTER [SD_GTKWIDGET])
		do
			menu := a_menu
			update_memory_field ("menu")
		end

	set_event_window (a_event_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			event_window := a_event_window
			update_memory_field ("event_window")
		end

	set_timer (a_timer: NATURAL_32)
		do
			timer := a_timer
			update_memory_field ("timer")
		end

	set_tab_hborder (a_tab_hborder: NATURAL_16)
		do
			tab_hborder := a_tab_hborder
			update_memory_field ("tab_hborder")
		end

	set_tab_vborder (a_tab_vborder: NATURAL_16)
		do
			tab_vborder := a_tab_vborder
			update_memory_field ("tab_vborder")
		end

	set_show_tabs (a_show_tabs: NATURAL_32)
		do
			show_tabs := a_show_tabs
			update_memory_field ("show_tabs")
		end

	set_homogeneous (a_homogeneous: NATURAL_32)
		do
			homogeneous := a_homogeneous
			update_memory_field ("homogeneous")
		end

	set_show_border (a_show_border: NATURAL_32)
		do
			show_border := a_show_border
			update_memory_field ("show_border")
		end

	set_tab_pos (a_tab_pos: NATURAL_32)
		do
			tab_pos := a_tab_pos
			update_memory_field ("tab_pos")
		end

	set_scrollable (a_scrollable: NATURAL_32)
		do
			scrollable := a_scrollable
			update_memory_field ("scrollable")
		end

	set_in_child (a_in_child: NATURAL_32)
		do
			in_child := a_in_child
			update_memory_field ("in_child")
		end

	set_click_child (a_click_child: NATURAL_32)
		do
			click_child := a_click_child
			update_memory_field ("click_child")
		end

	set_button (a_button: NATURAL_32)
		do
			button := a_button
			update_memory_field ("button")
		end

	set_need_timer (a_need_timer: NATURAL_32)
		do
			need_timer := a_need_timer
			update_memory_field ("need_timer")
		end

	set_child_has_focus (a_child_has_focus: NATURAL_32)
		do
			child_has_focus := a_child_has_focus
			update_memory_field ("child_has_focus")
		end

	set_have_visible_child (a_have_visible_child: NATURAL_32)
		do
			have_visible_child := a_have_visible_child
			update_memory_field ("have_visible_child")
		end

	set_focus_out (a_focus_out: NATURAL_32)
		do
			focus_out := a_focus_out
			update_memory_field ("focus_out")
		end

	set_has_before_previous (a_has_before_previous: NATURAL_32)
		do
			has_before_previous := a_has_before_previous
			update_memory_field ("has_before_previous")
		end

	set_has_before_next (a_has_before_next: NATURAL_32)
		do
			has_before_next := a_has_before_next
			update_memory_field ("has_before_next")
		end

	set_has_after_previous (a_has_after_previous: NATURAL_32)
		do
			has_after_previous := a_has_after_previous
			update_memory_field ("has_after_previous")
		end

	set_has_after_next (a_has_after_next: NATURAL_32)
		do
			has_after_next := a_has_after_next
			update_memory_field ("has_after_next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			container := a_other.container.twin
			cur_page := a_other.cur_page
			children := a_other.children
			first_tab := a_other.first_tab
			focus_tab := a_other.focus_tab
			menu := a_other.menu
			event_window := a_other.event_window
			timer := a_other.timer
			tab_hborder := a_other.tab_hborder
			tab_vborder := a_other.tab_vborder
			show_tabs := a_other.show_tabs
			homogeneous := a_other.homogeneous
			show_border := a_other.show_border
			tab_pos := a_other.tab_pos
			scrollable := a_other.scrollable
			in_child := a_other.in_child
			click_child := a_other.click_child
			button := a_other.button
			need_timer := a_other.need_timer
			child_has_focus := a_other.child_has_focus
			have_visible_child := a_other.have_visible_child
			focus_out := a_other.focus_out
			has_before_previous := a_other.has_before_previous
			has_before_next := a_other.has_before_next
			has_after_previous := a_other.has_after_previous
			has_after_next := a_other.has_after_next
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				container.is_equal (a_other.container) and
				cur_page.is_equal (a_other.cur_page) and
				children.is_equal (a_other.children) and
				first_tab.is_equal (a_other.first_tab) and
				focus_tab.is_equal (a_other.focus_tab) and
				menu.is_equal (a_other.menu) and
				event_window.is_equal (a_other.event_window) and
				timer = a_other.timer and
				tab_hborder = a_other.tab_hborder and
				tab_vborder = a_other.tab_vborder and
				show_tabs = a_other.show_tabs and
				homogeneous = a_other.homogeneous and
				show_border = a_other.show_border and
				tab_pos = a_other.tab_pos and
				scrollable = a_other.scrollable and
				in_child = a_other.in_child and
				click_child = a_other.click_child and
				button = a_other.button and
				need_timer = a_other.need_timer and
				child_has_focus = a_other.child_has_focus and
				have_visible_child = a_other.have_visible_child and
				focus_out = a_other.focus_out and
				has_before_previous = a_other.has_before_previous and
				has_before_next = a_other.has_before_next and
				has_after_previous = a_other.has_after_previous and
				has_after_next = a_other.has_after_next
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("container"),
					create {CE_STRUCTURE_FIELD}.make ("cur_page"),
					create {CE_STRUCTURE_FIELD}.make ("children"),
					create {CE_STRUCTURE_FIELD}.make ("first_tab"),
					create {CE_STRUCTURE_FIELD}.make ("focus_tab"),
					create {CE_STRUCTURE_FIELD}.make ("menu"),
					create {CE_STRUCTURE_FIELD}.make ("event_window"),
					create {CE_STRUCTURE_FIELD}.make ("timer"),
					create {CE_STRUCTURE_FIELD}.make ("tab_hborder"),
					create {CE_STRUCTURE_FIELD}.make ("tab_vborder"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("show_tabs"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("homogeneous"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("show_border"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("tab_pos"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("scrollable"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("in_child"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("click_child"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("button"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("need_timer"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("child_has_focus"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("have_visible_child"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("focus_out"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("has_before_previous"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("has_before_next"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("has_after_previous"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("has_after_next")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkNotebook);
				} else {
					struct _GtkNotebook *p = (struct _GtkNotebook *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "show_tabs") == 0) p->show_tabs = (unsigned int)$a_value;
						else if(strcmp(field_name, "homogeneous") == 0) p->homogeneous = (unsigned int)$a_value;
						else if(strcmp(field_name, "show_border") == 0) p->show_border = (unsigned int)$a_value;
						else if(strcmp(field_name, "tab_pos") == 0) p->tab_pos = (unsigned int)$a_value;
						else if(strcmp(field_name, "scrollable") == 0) p->scrollable = (unsigned int)$a_value;
						else if(strcmp(field_name, "in_child") == 0) p->in_child = (unsigned int)$a_value;
						else if(strcmp(field_name, "click_child") == 0) p->click_child = (unsigned int)$a_value;
						else if(strcmp(field_name, "button") == 0) p->button = (unsigned int)$a_value;
						else if(strcmp(field_name, "need_timer") == 0) p->need_timer = (unsigned int)$a_value;
						else if(strcmp(field_name, "child_has_focus") == 0) p->child_has_focus = (unsigned int)$a_value;
						else if(strcmp(field_name, "have_visible_child") == 0) p->have_visible_child = (unsigned int)$a_value;
						else if(strcmp(field_name, "focus_out") == 0) p->focus_out = (unsigned int)$a_value;
						else if(strcmp(field_name, "has_before_previous") == 0) p->has_before_previous = (unsigned int)$a_value;
						else if(strcmp(field_name, "has_before_next") == 0) p->has_before_next = (unsigned int)$a_value;
						else if(strcmp(field_name, "has_after_previous") == 0) p->has_after_previous = (unsigned int)$a_value;
						else if(strcmp(field_name, "has_after_next") == 0) p->has_after_next = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "show_tabs") == 0) return p->show_tabs;
						if(strcmp(field_name, "homogeneous") == 0) return p->homogeneous;
						if(strcmp(field_name, "show_border") == 0) return p->show_border;
						if(strcmp(field_name, "tab_pos") == 0) return p->tab_pos;
						if(strcmp(field_name, "scrollable") == 0) return p->scrollable;
						if(strcmp(field_name, "in_child") == 0) return p->in_child;
						if(strcmp(field_name, "click_child") == 0) return p->click_child;
						if(strcmp(field_name, "button") == 0) return p->button;
						if(strcmp(field_name, "need_timer") == 0) return p->need_timer;
						if(strcmp(field_name, "child_has_focus") == 0) return p->child_has_focus;
						if(strcmp(field_name, "have_visible_child") == 0) return p->have_visible_child;
						if(strcmp(field_name, "focus_out") == 0) return p->focus_out;
						if(strcmp(field_name, "has_before_previous") == 0) return p->has_before_previous;
						if(strcmp(field_name, "has_before_next") == 0) return p->has_before_next;
						if(strcmp(field_name, "has_after_previous") == 0) return p->has_after_previous;
						if(strcmp(field_name, "has_after_next") == 0) return p->has_after_next;
					}
				}
			]"
		end

end
