class
	SD_GTKRANGE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	widget: SD_GTKWIDGET assign set_widget

	adjustment: CE_POINTER [SD_GTKADJUSTMENT] assign set_adjustment

	update_policy: NATURAL_32 assign set_update_policy

	inverted: NATURAL_32 assign set_inverted

	flippable: NATURAL_32 assign set_flippable

	has_stepper_a: NATURAL_32 assign set_has_stepper_a

	has_stepper_b: NATURAL_32 assign set_has_stepper_b

	has_stepper_c: NATURAL_32 assign set_has_stepper_c

	has_stepper_d: NATURAL_32 assign set_has_stepper_d

	need_recalc: NATURAL_32 assign set_need_recalc

	slider_size_fixed: NATURAL_32 assign set_slider_size_fixed

	min_slider_size: INTEGER_32 assign set_min_slider_size

	orientation: NATURAL_32 assign set_orientation

	range_rect: SD_GDKRECTANGLE assign set_range_rect

	slider_start: INTEGER_32 assign set_slider_start

	slider_end: INTEGER_32 assign set_slider_end

	round_digits: INTEGER_32 assign set_round_digits

	trough_click_forward: NATURAL_32 assign set_trough_click_forward

	update_pending: NATURAL_32 assign set_update_pending

	layout: CE_POINTER [ANY] assign set_layout

	timer: CE_POINTER [ANY] assign set_timer

	slide_initial_slider_position: INTEGER_32 assign set_slide_initial_slider_position

	slide_initial_coordinate: INTEGER_32 assign set_slide_initial_coordinate

	update_timeout_id: NATURAL_32 assign set_update_timeout_id

	event_window: CE_POINTER [SD_GDKDRAWABLE] assign set_event_window

feature {ANY} -- field setters

	set_widget (a_widget: SD_GTKWIDGET)
		do
			widget := a_widget
			update_memory_field ("widget")
		end

	set_adjustment (a_adjustment: CE_POINTER [SD_GTKADJUSTMENT])
		do
			adjustment := a_adjustment
			update_memory_field ("adjustment")
		end

	set_update_policy (a_update_policy: NATURAL_32)
		do
			update_policy := a_update_policy
			update_memory_field ("update_policy")
		end

	set_inverted (a_inverted: NATURAL_32)
		do
			inverted := a_inverted
			update_memory_field ("inverted")
		end

	set_flippable (a_flippable: NATURAL_32)
		do
			flippable := a_flippable
			update_memory_field ("flippable")
		end

	set_has_stepper_a (a_has_stepper_a: NATURAL_32)
		do
			has_stepper_a := a_has_stepper_a
			update_memory_field ("has_stepper_a")
		end

	set_has_stepper_b (a_has_stepper_b: NATURAL_32)
		do
			has_stepper_b := a_has_stepper_b
			update_memory_field ("has_stepper_b")
		end

	set_has_stepper_c (a_has_stepper_c: NATURAL_32)
		do
			has_stepper_c := a_has_stepper_c
			update_memory_field ("has_stepper_c")
		end

	set_has_stepper_d (a_has_stepper_d: NATURAL_32)
		do
			has_stepper_d := a_has_stepper_d
			update_memory_field ("has_stepper_d")
		end

	set_need_recalc (a_need_recalc: NATURAL_32)
		do
			need_recalc := a_need_recalc
			update_memory_field ("need_recalc")
		end

	set_slider_size_fixed (a_slider_size_fixed: NATURAL_32)
		do
			slider_size_fixed := a_slider_size_fixed
			update_memory_field ("slider_size_fixed")
		end

	set_min_slider_size (a_min_slider_size: INTEGER_32)
		do
			min_slider_size := a_min_slider_size
			update_memory_field ("min_slider_size")
		end

	set_orientation (a_orientation: NATURAL_32)
		do
			orientation := a_orientation
			update_memory_field ("orientation")
		end

	set_range_rect (a_range_rect: SD_GDKRECTANGLE)
		do
			range_rect := a_range_rect
			update_memory_field ("range_rect")
		end

	set_slider_start (a_slider_start: INTEGER_32)
		do
			slider_start := a_slider_start
			update_memory_field ("slider_start")
		end

	set_slider_end (a_slider_end: INTEGER_32)
		do
			slider_end := a_slider_end
			update_memory_field ("slider_end")
		end

	set_round_digits (a_round_digits: INTEGER_32)
		do
			round_digits := a_round_digits
			update_memory_field ("round_digits")
		end

	set_trough_click_forward (a_trough_click_forward: NATURAL_32)
		do
			trough_click_forward := a_trough_click_forward
			update_memory_field ("trough_click_forward")
		end

	set_update_pending (a_update_pending: NATURAL_32)
		do
			update_pending := a_update_pending
			update_memory_field ("update_pending")
		end

	set_layout (a_layout: CE_POINTER [ANY])
		do
			layout := a_layout
			update_memory_field ("layout")
		end

	set_timer (a_timer: CE_POINTER [ANY])
		do
			timer := a_timer
			update_memory_field ("timer")
		end

	set_slide_initial_slider_position (a_slide_initial_slider_position: INTEGER_32)
		do
			slide_initial_slider_position := a_slide_initial_slider_position
			update_memory_field ("slide_initial_slider_position")
		end

	set_slide_initial_coordinate (a_slide_initial_coordinate: INTEGER_32)
		do
			slide_initial_coordinate := a_slide_initial_coordinate
			update_memory_field ("slide_initial_coordinate")
		end

	set_update_timeout_id (a_update_timeout_id: NATURAL_32)
		do
			update_timeout_id := a_update_timeout_id
			update_memory_field ("update_timeout_id")
		end

	set_event_window (a_event_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			event_window := a_event_window
			update_memory_field ("event_window")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			widget := a_other.widget.twin
			adjustment := a_other.adjustment
			update_policy := a_other.update_policy
			inverted := a_other.inverted
			flippable := a_other.flippable
			has_stepper_a := a_other.has_stepper_a
			has_stepper_b := a_other.has_stepper_b
			has_stepper_c := a_other.has_stepper_c
			has_stepper_d := a_other.has_stepper_d
			need_recalc := a_other.need_recalc
			slider_size_fixed := a_other.slider_size_fixed
			min_slider_size := a_other.min_slider_size
			orientation := a_other.orientation
			range_rect := a_other.range_rect.twin
			slider_start := a_other.slider_start
			slider_end := a_other.slider_end
			round_digits := a_other.round_digits
			trough_click_forward := a_other.trough_click_forward
			update_pending := a_other.update_pending
			layout := a_other.layout
			timer := a_other.timer
			slide_initial_slider_position := a_other.slide_initial_slider_position
			slide_initial_coordinate := a_other.slide_initial_coordinate
			update_timeout_id := a_other.update_timeout_id
			event_window := a_other.event_window
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				widget.is_equal (a_other.widget) and
				adjustment.is_equal (a_other.adjustment) and
				update_policy = a_other.update_policy and
				inverted = a_other.inverted and
				flippable = a_other.flippable and
				has_stepper_a = a_other.has_stepper_a and
				has_stepper_b = a_other.has_stepper_b and
				has_stepper_c = a_other.has_stepper_c and
				has_stepper_d = a_other.has_stepper_d and
				need_recalc = a_other.need_recalc and
				slider_size_fixed = a_other.slider_size_fixed and
				min_slider_size = a_other.min_slider_size and
				orientation = a_other.orientation and
				range_rect.is_equal (a_other.range_rect) and
				slider_start = a_other.slider_start and
				slider_end = a_other.slider_end and
				round_digits = a_other.round_digits and
				trough_click_forward = a_other.trough_click_forward and
				update_pending = a_other.update_pending and
				layout.is_equal (a_other.layout) and
				timer.is_equal (a_other.timer) and
				slide_initial_slider_position = a_other.slide_initial_slider_position and
				slide_initial_coordinate = a_other.slide_initial_coordinate and
				update_timeout_id = a_other.update_timeout_id and
				event_window.is_equal (a_other.event_window)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("widget"),
					create {CE_STRUCTURE_FIELD}.make ("adjustment"),
					create {CE_STRUCTURE_FIELD}.make ("update_policy"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("inverted"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("flippable"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("has_stepper_a"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("has_stepper_b"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("has_stepper_c"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("has_stepper_d"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("need_recalc"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("slider_size_fixed"),
					create {CE_STRUCTURE_FIELD}.make ("min_slider_size"),
					create {CE_STRUCTURE_FIELD}.make ("orientation"),
					create {CE_STRUCTURE_FIELD}.make ("range_rect"),
					create {CE_STRUCTURE_FIELD}.make ("slider_start"),
					create {CE_STRUCTURE_FIELD}.make ("slider_end"),
					create {CE_STRUCTURE_FIELD}.make ("round_digits"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("trough_click_forward"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("update_pending"),
					create {CE_STRUCTURE_FIELD}.make ("layout"),
					create {CE_STRUCTURE_FIELD}.make ("timer"),
					create {CE_STRUCTURE_FIELD}.make ("slide_initial_slider_position"),
					create {CE_STRUCTURE_FIELD}.make ("slide_initial_coordinate"),
					create {CE_STRUCTURE_FIELD}.make ("update_timeout_id"),
					create {CE_STRUCTURE_FIELD}.make ("event_window")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkRange);
					if(strcmp(field_name, "min_slider_size") == 0) return offsetof(struct _GtkRange, min_slider_size);
					if(strcmp(field_name, "layout") == 0) return offsetof(struct _GtkRange, layout);
				} else {
					struct _GtkRange *p = (struct _GtkRange *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "inverted") == 0) p->inverted = (unsigned int)$a_value;
						else if(strcmp(field_name, "flippable") == 0) p->flippable = (unsigned int)$a_value;
						else if(strcmp(field_name, "has_stepper_a") == 0) p->has_stepper_a = (unsigned int)$a_value;
						else if(strcmp(field_name, "has_stepper_b") == 0) p->has_stepper_b = (unsigned int)$a_value;
						else if(strcmp(field_name, "has_stepper_c") == 0) p->has_stepper_c = (unsigned int)$a_value;
						else if(strcmp(field_name, "has_stepper_d") == 0) p->has_stepper_d = (unsigned int)$a_value;
						else if(strcmp(field_name, "need_recalc") == 0) p->need_recalc = (unsigned int)$a_value;
						else if(strcmp(field_name, "slider_size_fixed") == 0) p->slider_size_fixed = (unsigned int)$a_value;
						else if(strcmp(field_name, "trough_click_forward") == 0) p->trough_click_forward = (unsigned int)$a_value;
						else if(strcmp(field_name, "update_pending") == 0) p->update_pending = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "inverted") == 0) return p->inverted;
						if(strcmp(field_name, "flippable") == 0) return p->flippable;
						if(strcmp(field_name, "has_stepper_a") == 0) return p->has_stepper_a;
						if(strcmp(field_name, "has_stepper_b") == 0) return p->has_stepper_b;
						if(strcmp(field_name, "has_stepper_c") == 0) return p->has_stepper_c;
						if(strcmp(field_name, "has_stepper_d") == 0) return p->has_stepper_d;
						if(strcmp(field_name, "need_recalc") == 0) return p->need_recalc;
						if(strcmp(field_name, "slider_size_fixed") == 0) return p->slider_size_fixed;
						if(strcmp(field_name, "trough_click_forward") == 0) return p->trough_click_forward;
						if(strcmp(field_name, "update_pending") == 0) return p->update_pending;
					}
				}
			]"
		end

end
