class
	SD_PANGOGLYPHSTRING

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_PANGOGLYPHINFO]} glyphs.make
			create {CE_INTEGER_32_POINTER} log_clusters.make
		end

feature {ANY} -- fields

	num_glyphs: INTEGER_32 assign set_num_glyphs

	glyphs: CE_POINTER [SD_PANGOGLYPHINFO] assign set_glyphs

	log_clusters: CE_POINTER [INTEGER_32] assign set_log_clusters

	space: INTEGER_32 assign set_space

feature {ANY} -- field setters

	set_num_glyphs (a_num_glyphs: INTEGER_32)
		do
			num_glyphs := a_num_glyphs
			update_memory_field ("num_glyphs")
		end

	set_glyphs (a_glyphs: CE_POINTER [SD_PANGOGLYPHINFO])
		do
			glyphs := a_glyphs
			update_memory_field ("glyphs")
		end

	set_log_clusters (a_log_clusters: CE_POINTER [INTEGER_32])
		do
			log_clusters := a_log_clusters
			update_memory_field ("log_clusters")
		end

	set_space (a_space: INTEGER_32)
		do
			space := a_space
			update_memory_field ("space")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			num_glyphs := a_other.num_glyphs
			glyphs := a_other.glyphs
			log_clusters := a_other.log_clusters
			space := a_other.space
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				num_glyphs = a_other.num_glyphs and
				glyphs.is_equal (a_other.glyphs) and
				log_clusters.is_equal (a_other.log_clusters) and
				space = a_other.space
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("num_glyphs"),
					create {CE_STRUCTURE_FIELD}.make ("glyphs"),
					create {CE_STRUCTURE_FIELD}.make ("log_clusters"),
					create {CE_STRUCTURE_FIELD}.make ("space")
				>>)
			init_structure_info
		end

end
