class
	SD_WAIT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	w_status: INTEGER_32 assign set_w_status

	wait_terminated: SD_WAIT_TERMINATED assign set_wait_terminated

	wait_stopped: SD_WAIT_STOPPED assign set_wait_stopped

feature {ANY} -- field setters

	set_w_status (a_w_status: INTEGER_32)
		do
			w_status := a_w_status
			update_memory_field ("w_status")
		end

	set_wait_terminated (a_wait_terminated: SD_WAIT_TERMINATED)
		do
			wait_terminated := a_wait_terminated
			update_memory_field ("wait_terminated")
		end

	set_wait_stopped (a_wait_stopped: SD_WAIT_STOPPED)
		do
			wait_stopped := a_wait_stopped
			update_memory_field ("wait_stopped")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			w_status := a_other.w_status
			wait_terminated := a_other.wait_terminated.twin
			wait_stopped := a_other.wait_stopped.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				w_status = a_other.w_status and
				wait_terminated.is_equal (a_other.wait_terminated) and
				wait_stopped.is_equal (a_other.wait_stopped)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("w_status"),
					create {CE_STRUCTURE_FIELD}.make ("wait_terminated"),
					create {CE_STRUCTURE_FIELD}.make ("wait_stopped")
				>>)
			init_structure_info
		end

end
