class
	SD_XSELECTIONCLEAREVENT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} display.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	serial: NATURAL_32 assign set_serial

	send_event: INTEGER_32 assign set_send_event

	display: CE_POINTER [ANY] assign set_display

	window: NATURAL_32 assign set_window

	selection: NATURAL_32 assign set_selection

	time: NATURAL_32 assign set_time

feature {ANY} -- field setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_serial (a_serial: NATURAL_32)
		do
			serial := a_serial
			update_memory_field ("serial")
		end

	set_send_event (a_send_event: INTEGER_32)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			display := a_display
			update_memory_field ("display")
		end

	set_window (a_window: NATURAL_32)
		do
			window := a_window
			update_memory_field ("window")
		end

	set_selection (a_selection: NATURAL_32)
		do
			selection := a_selection
			update_memory_field ("selection")
		end

	set_time (a_time: NATURAL_32)
		do
			time := a_time
			update_memory_field ("time")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			serial := a_other.serial
			send_event := a_other.send_event
			display := a_other.display
			window := a_other.window
			selection := a_other.selection
			time := a_other.time
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				serial = a_other.serial and
				send_event = a_other.send_event and
				display.is_equal (a_other.display) and
				window = a_other.window and
				selection = a_other.selection and
				time = a_other.time
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("serial"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("display"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("selection"),
					create {CE_STRUCTURE_FIELD}.make ("time")
				>>)
			init_structure_info
		end

end
