class
	SD_XTEXTPROPERTY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} value.make
		end

feature {ANY} -- fields

	value: CE_POINTER [NATURAL_8] assign set_value

	encoding: NATURAL_32 assign set_encoding

	format: INTEGER_32 assign set_format

	nitems: NATURAL_32 assign set_nitems

feature {ANY} -- field setters

	set_value (a_value: CE_POINTER [NATURAL_8])
		do
			value := a_value
			update_memory_field ("value")
		end

	set_encoding (a_encoding: NATURAL_32)
		do
			encoding := a_encoding
			update_memory_field ("encoding")
		end

	set_format (a_format: INTEGER_32)
		do
			format := a_format
			update_memory_field ("format")
		end

	set_nitems (a_nitems: NATURAL_32)
		do
			nitems := a_nitems
			update_memory_field ("nitems")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			value := a_other.value
			encoding := a_other.encoding
			format := a_other.format
			nitems := a_other.nitems
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				value.is_equal (a_other.value) and
				encoding = a_other.encoding and
				format = a_other.format and
				nitems = a_other.nitems
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("value"),
					create {CE_STRUCTURE_FIELD}.make ("encoding"),
					create {CE_STRUCTURE_FIELD}.make ("format"),
					create {CE_STRUCTURE_FIELD}.make ("nitems")
				>>)
			init_structure_info
		end

end
