class
	P_HOSTIP_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	curl_jmpenv: CE_STATIC [CE_EXCEPTION]
		once ("PROCESS")
		end

	hostname_cache: CE_STATIC [CE_ARRAY [PD_CURL_HASH]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HASH]}.make (<<1>>)
		end

	host_cache_initialized: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

feature {ANY} -- public routines

	Curl_global_host_cache_init: CE_POINTER [PD_CURL_HASH]
		local
			l_rc: INTEGER_32
			l_tmp: CE_POINTER [PD_CURL_HASH]
		do
			l_rc := 0
			if not host_cache_initialized.item.to_boolean then
				l_rc := hostname_cache.item.item.Curl_hash_init (7, (create {P_HASH_STATIC}).Curl_hash_str_address, (create {P_HASH_STATIC}).Curl_str_key_compare_address, freednsentry_address)
				if not l_rc.to_boolean then
					host_cache_initialized.item := 1
				end
			end
			if l_rc.to_boolean then
				l_tmp := create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (default_pointer)
			else
				l_tmp := hostname_cache.item
			end
			Result := l_tmp
		end

	Curl_global_host_cache_dtor
		do
			if host_cache_initialized.item.to_boolean then
				hostname_cache.item.item.Curl_hash_clean
				host_cache_initialized.item := 0
			end
		end

	alarmfunc (a_sig: INTEGER_32)
		do
			curl_jmpenv.item.raise (1)
		end

	freednsentry (a_freethis: CE_POINTER [ANY])
		local
			l_p: CE_POINTER [PD_CURL_DNS_ENTRY]
		do
			l_p := create {CE_CLASS_POINTER [PD_CURL_DNS_ENTRY]}.make_cast (a_freethis)
			l_p.item.timestamp := (0).to_integer_32
			if l_p.item.inuse = 0 then
				(create {P_CURL_ADDRINFO_STATIC}).Curl_freeaddrinfo (l_p.item.addr);
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_p)])
			end
		end

	Curl_mk_dnscache: CE_POINTER [PD_CURL_HASH]
		do
			Result := ((create {P_HASH_STATIC}).Curl_hash_alloc (7, (create {P_HASH_STATIC}).Curl_hash_str_address, (create {P_HASH_STATIC}).Curl_str_key_compare_address, freednsentry_address))
		end

feature {ANY} -- routine addresses

	alarmfunc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent alarmfunc)
		end

	freednsentry_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent freednsentry)
		end

end
