class
	P_IMAP_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	Curl_handler_imap: CE_STATIC [CE_ARRAY [PD_CURL_HANDLER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					create {PD_CURL_HANDLER}.make_initialized ([ce_string ("IMAP"), (create {PD_CONNECTDATA_STATIC}).imap_setup_connection_address, (create {PD_CONNECTDATA_STATIC}).imap_do_address, (create {PD_CONNECTDATA_STATIC}).imap_done_address, create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).imap_connect_address, imap_multi_statemach_address, imap_doing_address, imap_getsock_address, imap_getsock_address, create {CE_ROUTINE}.make_shared (default_pointer), imap_disconnect_address, 143, ((1).bit_shift_left (12)).to_integer_32])
				>>)
		end

	ids: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("A"),
					ce_string ("B"),
					ce_string ("C"),
					ce_string ("D")
				>>)
		end

feature {ANY} -- public routines

	imapsendf (a_args: TUPLE [a_conn: CE_POINTER [PD_CONNECTDATA]; a_idstr, a_fmt: CE_POINTER [INTEGER_8]]): NATURAL_32
		local
			l_res: NATURAL_32
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_ap: CE_VA_LIST
		do
			create l_ap.make_shared (default_pointer)

			l_imapc := create {CE_CLASS_POINTER [PD_IMAP_CONN]}.make_shared (a_args.a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("imapc"))
			l_ap := create {CE_VA_LIST}.make (a_args, agent imapsendf)
			l_imapc.item.idstr := a_args.a_idstr
			l_res := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_imapc.c_pointer + (create {PD_IMAP_CONN}.make).offset_of ("pp"))).item.Curl_pp_vsendf (a_args.a_fmt, l_ap.twin)
			Result := l_res
		end

	getcmdid (a_conn: CE_POINTER [PD_CONNECTDATA]): CE_POINTER [INTEGER_8]
		local
			l_imapc: CE_POINTER [PD_IMAP_CONN]
		do
			l_imapc := create {CE_CLASS_POINTER [PD_IMAP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("imapc"))
			l_imapc.item.cmdid := ((l_imapc.item.cmdid + 1).to_natural_32 \\ (({PLATFORM}.Pointer_bytes.to_natural_32 * (4).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32)).to_integer_32
			Result := (ids.item[l_imapc.item.cmdid])
		end

	imap_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		do
			Result := ((create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("imapc") + (create {PD_IMAP_CONN}.make).offset_of ("pp"))).item.Curl_pp_getsock (a_socks, a_numsocks))
		end

	state___0 (a_conn: CE_POINTER [PD_CONNECTDATA]; a_newstate: NATURAL_32)
		local
			l_imapc: CE_POINTER [PD_IMAP_CONN]
		do
			l_imapc := create {CE_CLASS_POINTER [PD_IMAP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("imapc"))
			l_imapc.item.state := a_newstate
		end

	imap_multi_statemach (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_result: NATURAL_32
		do
			l_imapc := create {CE_CLASS_POINTER [PD_IMAP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("imapc"))
			l_result := ((create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_imapc.c_pointer + (create {PD_IMAP_CONN}.make).offset_of ("pp"))).item.Curl_pp_multi_statemach)
			a_done.item := (l_imapc.item.state = {NATURAL_32} 0)
			Result := l_result
		end

	imap_easy_statemach (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_imapc: CE_POINTER [PD_IMAP_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_result: NATURAL_32
			l_break: BOOLEAN
		do
			l_imapc := create {CE_CLASS_POINTER [PD_IMAP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("imapc"))
			l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_imapc.c_pointer + (create {PD_IMAP_CONN}.make).offset_of ("pp"))
			l_result := {PC_CURLCODE}.CURLE_OK
			from
			until
				not (not (l_break) and then (l_imapc.item.state /= {NATURAL_32} 0))
			loop
				l_break := False
				l_result := l_pp.item.Curl_pp_easy_statemach
				if l_result.to_boolean then
					l_break := True
				end
			end
			l_break := False
			Result := l_result
		end

	imap_logout (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_str: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_str := getcmdid (a_conn)
			l_result := imapsendf ([a_conn, l_str, ce_string ("%%s LOGOUT"), l_str, create {CE_VOID_POINTER}.make_shared (default_pointer)])
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				state___0 (a_conn, {PC_IMAPSTATE}.IMAP_LOGOUT)
				l_result := imap_easy_statemach (a_conn)
				Result := l_result
			end
		end

	imap_disconnect (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_imapc: CE_POINTER [PD_IMAP_CONN]
		do
			l_imapc := create {CE_CLASS_POINTER [PD_IMAP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("imapc"))
			if (not (l_imapc.item.pp.conn).is_void) then
				imap_logout (a_conn).do_nothing
			end
			(create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_imapc.c_pointer + (create {PD_IMAP_CONN}.make).offset_of ("pp"))).item.Curl_pp_disconnect.do_nothing;
			(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_imapc.item.mailbox))
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	imap_doing (a_conn: CE_POINTER [PD_CONNECTDATA]; a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_dophase_done.is_void
		local
			l_result: NATURAL_32
		do
			l_result := imap_multi_statemach (a_conn, a_dophase_done)
			if a_dophase_done.item then
				l_result := a_conn.item.imap_dophase_done ((0).to_boolean)
			end
			Result := l_result
		end

feature {ANY} -- routine addresses

	imap_getsock_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent imap_getsock)
		end

	imap_multi_statemach_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent imap_multi_statemach)
		end

	imap_disconnect_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent imap_disconnect)
		end

	imap_doing_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent imap_doing)
		end

end
