class
	P_POP3_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	Curl_handler_pop3: CE_STATIC [CE_ARRAY [PD_CURL_HANDLER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					create {PD_CURL_HANDLER}.make_initialized ([ce_string ("POP3"), (create {PD_CONNECTDATA_STATIC}).pop3_setup_connection_address, (create {PD_CONNECTDATA_STATIC}).pop3_do_address, (create {PD_CONNECTDATA_STATIC}).pop3_done_address, create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).pop3_connect_address, pop3_multi_statemach_address, pop3_doing_address, pop3_getsock_address, pop3_getsock_address, create {CE_ROUTINE}.make_shared (default_pointer), pop3_disconnect_address, 110, ((1).bit_shift_left (14)).to_integer_32])
				>>)
		end

feature {ANY} -- public routines

	state___1 (a_conn: CE_POINTER [PD_CONNECTDATA]; a_newstate: NATURAL_32)
		local
			l_pop3c: CE_POINTER [PD_POP3_CONN]
		do
			l_pop3c := create {CE_CLASS_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_pop3c.item.state := a_newstate
		end

	pop3_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		do
			Result := ((create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c") + (create {PD_POP3_CONN}.make).offset_of ("pp"))).item.Curl_pp_getsock (a_socks, a_numsocks))
		end

	pop3_multi_statemach (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_result: NATURAL_32
		do
			l_pop3c := create {CE_CLASS_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_result := ((create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_pop3c.c_pointer + (create {PD_POP3_CONN}.make).offset_of ("pp"))).item.Curl_pp_multi_statemach)
			a_done.item := (l_pop3c.item.state = {NATURAL_32} 0)
			Result := l_result
		end

	pop3_easy_statemach (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_pop3c: CE_POINTER [PD_POP3_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_result: NATURAL_32
			l_break: BOOLEAN
		do
			l_pop3c := create {CE_CLASS_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_pop3c.c_pointer + (create {PD_POP3_CONN}.make).offset_of ("pp"))
			l_result := {PC_CURLCODE}.CURLE_OK
			from
			until
				not (not (l_break) and then (l_pop3c.item.state /= {NATURAL_32} 0))
			loop
				l_break := False
				l_result := l_pp.item.Curl_pp_easy_statemach
				if l_result.to_boolean then
					l_break := True
				end
			end
			l_break := False
			Result := l_result
		end

	pop3_quit (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c") + (create {PD_POP3_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("QUIT"), create {CE_VOID_POINTER}.make_shared (default_pointer)])
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				state___1 (a_conn, {PC_POP3STATE}.POP3_QUIT)
				l_result := pop3_easy_statemach (a_conn)
				Result := l_result
			end
		end

	pop3_disconnect (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_pop3c: CE_POINTER [PD_POP3_CONN]
		do
			l_pop3c := create {CE_CLASS_POINTER [PD_POP3_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("pop3c"))
			if (not (l_pop3c.item.pp.conn).is_void) then
				pop3_quit (a_conn).do_nothing
			end
			(create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_pop3c.c_pointer + (create {PD_POP3_CONN}.make).offset_of ("pp"))).item.Curl_pp_disconnect.do_nothing
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	pop3_doing (a_conn: CE_POINTER [PD_CONNECTDATA]; a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_dophase_done.is_void
		local
			l_result: NATURAL_32
		do
			l_result := pop3_multi_statemach (a_conn, a_dophase_done)
			if a_dophase_done.item then
				l_result := a_conn.item.pop3_dophase_done ((0).to_boolean)
			end
			Result := l_result
		end

feature {ANY} -- routine addresses

	pop3_getsock_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent pop3_getsock)
		end

	pop3_multi_statemach_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent pop3_multi_statemach)
		end

	pop3_disconnect_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent pop3_disconnect)
		end

	pop3_doing_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent pop3_doing)
		end

end
