class
	P_SELECT_STATIC

inherit
	CE_UTILITIES
	S_BITS_ERRNO_STATIC
	S_SYS_POLL_STATIC

feature {ANY} -- public routines

	wait_ms (a_timeout_ms: INTEGER_32): INTEGER_32
		local
			l_initial_tv: SD_TIMEVAL
			l_pending_ms: INTEGER_32
			l_error: INTEGER_32
			l_r: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_r := 0
			if not a_timeout_ms.to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return and then (a_timeout_ms < 0) then
				(errno_location).item := 22
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_pending_ms := a_timeout_ms
				l_initial_tv := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
				from
				until
					(l_break)
				loop
					l_break := False
					l_r := poll (create {CE_CLASS_POINTER [SD_POLLFD]}.make_shared (default_pointer), (0).to_natural_32, l_pending_ms)
					if l_r /= -1 then
						l_break := True
					end
					if not (l_break) then
						l_error := (errno_location).item
						if l_error.to_boolean then
							if l_error /= 4 then
								l_break := True
							end
						end
					end
					if not (l_break) then
						l_pending_ms := a_timeout_ms - ((create {P_TIMEVAL_STATIC}).curlx_tvdiff ((((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin).twin, l_initial_tv.twin)).to_integer_32
						if l_pending_ms <= 0 then
							l_break := True
						end
					end
					if not (l_break) and then (l_r /= -1) then
						l_break := True
					end
				end
				l_break := False
				if l_r.to_boolean then
					l_r := -1
				end
				Result := l_r
			end
		end

	Curl_socket_ready (a_readfd, a_writefd, a_timeout_ms: INTEGER_32): INTEGER_32
		local
			l_pfd: CE_ARRAY [SD_POLLFD]
			l_num: INTEGER_32
			l_initial_tv: SD_TIMEVAL
			l_pending_ms: INTEGER_32
			l_error: INTEGER_32
			l_r: INTEGER_32
			l_ret: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_POLLFD]} l_pfd.make (<<2>>)
			create l_initial_tv.make

			l_initial_tv.tv_sec := (0).to_integer_32
			l_initial_tv.tv_usec := (0).to_integer_32
			l_pending_ms := 0
			if a_readfd = -1 then
				if a_writefd = -1 then
					l_r := wait_ms (a_timeout_ms)
					Result := l_r
					l_return := True
				end
			end
			if not l_return then
				if a_timeout_ms > 0 then
					l_pending_ms := a_timeout_ms
					l_initial_tv := ((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin
				end
				l_num := 0
				if a_readfd /= -1 then
					l_pfd[l_num].fd := a_readfd
					l_pfd[l_num].events := (195).to_integer_16
					l_pfd[l_num].revents := (0).to_integer_16
					l_num := l_num + 1
				end
				if a_writefd /= -1 then
					l_pfd[l_num].fd := a_writefd
					l_pfd[l_num].events := (260).to_integer_16
					l_pfd[l_num].revents := (0).to_integer_16
					l_num := l_num + 1
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if a_timeout_ms < 0 then
						l_pending_ms := -1
					elseif not a_timeout_ms.to_boolean then
						l_pending_ms := 0
					end
					l_r := poll (l_pfd, l_num.to_natural_32, l_pending_ms)
					if l_r /= -1 then
						l_break := True
					end
					if not (l_break) then
						l_error := (errno_location).item
						if l_error.to_boolean then
							if l_error /= 4 then
								l_break := True
							end
						end
					end
					if not (l_break) and then (a_timeout_ms > 0) then
						l_pending_ms := a_timeout_ms - ((create {P_TIMEVAL_STATIC}).curlx_tvdiff ((((create {P_TIMEVAL_STATIC}).curlx_tvnow).twin).twin, l_initial_tv.twin)).to_integer_32
						if l_pending_ms <= 0 then
							l_break := True
						end
					end
					if not (l_break) and then (l_r /= -1) then
						l_break := True
					end
				end
				l_break := False
				if l_r < 0 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return and then (l_r = 0) then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_ret := 0
				l_num := 0
				if a_readfd /= -1 then
					if (((l_pfd[l_num].revents).to_integer_32).bit_and (89)).to_boolean then
						l_ret := (l_ret).bit_or ((1))
					end
					if (((l_pfd[l_num].revents).to_integer_32).bit_and (162)).to_boolean then
						l_ret := (l_ret).bit_or ((4))
					end
					l_num := l_num + 1
				end
				if a_writefd /= -1 then
					if (((l_pfd[l_num].revents).to_integer_32).bit_and (260)).to_boolean then
						l_ret := (l_ret).bit_or ((2))
					end
					if (((l_pfd[l_num].revents).to_integer_32).bit_and (56)).to_boolean then
						l_ret := (l_ret).bit_or ((4))
					end
				end
				Result := l_ret
			end
		end

end
