class
	P_SMTP_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	Curl_handler_smtp: CE_STATIC [CE_ARRAY [PD_CURL_HANDLER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CURL_HANDLER]}.make_initialized (<<
					create {PD_CURL_HANDLER}.make_initialized ([ce_string ("SMTP"), (create {PD_CONNECTDATA_STATIC}).smtp_setup_connection_address, (create {PD_CONNECTDATA_STATIC}).smtp_do_address, (create {PD_CONNECTDATA_STATIC}).smtp_done_address, create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_CONNECTDATA_STATIC}).smtp_connect_address, smtp_multi_statemach_address, smtp_doing_address, smtp_getsock_address, smtp_getsock_address, create {CE_ROUTINE}.make_shared (default_pointer), smtp_disconnect_address, 25, ((1).bit_shift_left (16)).to_integer_32])
				>>)
		end

feature {ANY} -- public routines

	state___2 (a_conn: CE_POINTER [PD_CONNECTDATA]; a_newstate: NATURAL_32)
		local
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
		do
			l_smtpc := create {CE_CLASS_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			l_smtpc.item.state := a_newstate
		end

	smtp_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		do
			Result := ((create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_getsock (a_socks, a_numsocks))
		end

	smtp_multi_statemach (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_done.is_void
		local
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_result: NATURAL_32
		do
			l_smtpc := create {CE_CLASS_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			l_result := ((create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_multi_statemach)
			a_done.item := (l_smtpc.item.state = {NATURAL_32} 0)
			Result := l_result
		end

	smtp_easy_statemach (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
			l_pp: CE_POINTER [PD_PINGPONG]
			l_result: NATURAL_32
			l_break: BOOLEAN
		do
			l_smtpc := create {CE_CLASS_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			l_pp := create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp"))
			l_result := {PC_CURLCODE}.CURLE_OK
			from
			until
				not (not (l_break) and then (l_smtpc.item.state /= {NATURAL_32} 0))
			loop
				l_break := False
				l_result := l_pp.item.Curl_pp_easy_statemach
				if l_result.to_boolean then
					l_break := True
				end
			end
			l_break := False
			Result := l_result
		end

	smtp_quit (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_result: NATURAL_32
			l_return: BOOLEAN
		do
			l_result := {PC_CURLCODE}.CURLE_OK
			l_result := (create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc") + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_sendf ([ce_string ("QUIT")])
			if l_result.to_boolean then
				Result := l_result
				l_return := True
			end
			if not l_return then
				state___2 (a_conn, {PC_SMTPSTATE}.SMTP_QUIT)
				l_result := smtp_easy_statemach (a_conn)
				Result := l_result
			end
		end

	smtp_disconnect (a_conn: CE_POINTER [PD_CONNECTDATA]): NATURAL_32
		local
			l_smtpc: CE_POINTER [PD_SMTP_CONN]
		do
			l_smtpc := create {CE_CLASS_POINTER [PD_SMTP_CONN]}.make_shared (a_conn.c_pointer + (create {PD_CONNECTDATA}.make).offset_of ("proto") + (create {PD_PROTO}.make).offset_of ("smtpc"))
			if (not (l_smtpc.item.pp.conn).is_void) then
				smtp_quit (a_conn).do_nothing
			end
			(create {CE_CLASS_POINTER [PD_PINGPONG]}.make_shared (l_smtpc.c_pointer + (create {PD_SMTP_CONN}.make).offset_of ("pp"))).item.Curl_pp_disconnect.do_nothing;
			(create {P_URL_STATIC}).Curl_safefree (create {CE_VOID_POINTER}.make_cast (l_smtpc.item.domain))
			l_smtpc.item.domain := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			Result := ({PC_CURLCODE}.CURLE_OK)
		end

	smtp_doing (a_conn: CE_POINTER [PD_CONNECTDATA]; a_dophase_done: CE_POINTER [BOOLEAN]): NATURAL_32
		require
			not a_dophase_done.is_void
		local
			l_result: NATURAL_32
		do
			l_result := smtp_multi_statemach (a_conn, a_dophase_done)
			if a_dophase_done.item then
				l_result := a_conn.item.smtp_dophase_done ((0).to_boolean)
			end
			Result := l_result
		end

feature {ANY} -- routine addresses

	smtp_getsock_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent smtp_getsock)
		end

	smtp_multi_statemach_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent smtp_multi_statemach)
		end

	smtp_disconnect_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent smtp_disconnect)
		end

	smtp_doing_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent smtp_doing)
		end

end
