class
	P_TIMEVAL_STATIC

inherit
	CE_UTILITIES
	S_TIME_STATIC
	S_SYS_TIME_STATIC

feature {ANY} -- public routines

	curlx_tvnow: SD_TIMEVAL
		local
			l_now: CE_ARRAY [SD_TIMEVAL]
			l_tsnow: CE_ARRAY [SD_TIMESPEC]
		do
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_now.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMESPEC]} l_tsnow.make (<<1>>)

			if 0 = (clock_gettime (1, l_tsnow)) then
				l_now.item.tv_sec := l_tsnow.item.tv_sec
				l_now.item.tv_usec := l_tsnow.item.tv_nsec // 1_000
			else
				gettimeofday (l_now, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
			end
			Result := (l_now.item).twin
		end

	curlx_tvdiff (a_newer, a_older: SD_TIMEVAL): INTEGER_32
		do
			Result := ((a_newer.tv_sec - a_older.tv_sec) * 1_000 + (a_newer.tv_usec - a_older.tv_usec) // 1_000)
		end

	curlx_tvdiff_secs (a_newer, a_older: SD_TIMEVAL): REAL_64
		do
			Result := ((a_newer.tv_sec - a_older.tv_sec).to_double + (a_newer.tv_usec - a_older.tv_usec).to_double / 1000000.0)
		end

end
