class
	PD_COOKIEINFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_COOKIE]} cookies.make
			create {CE_INTEGER_8_POINTER} filename.make
		end

feature {ANY} -- fields

	cookies: CE_POINTER [PD_COOKIE] assign set_cookies

	filename: CE_POINTER [INTEGER_8] assign set_filename

	running: BOOLEAN assign set_running

	numcookies: INTEGER_32 assign set_numcookies

	newsession: BOOLEAN assign set_newsession

feature {ANY} -- field setters

	set_cookies (a_cookies: CE_POINTER [PD_COOKIE])
		do
			cookies := a_cookies
			update_memory_field ("cookies")
		end

	set_filename (a_filename: CE_POINTER [INTEGER_8])
		do
			filename := a_filename
			update_memory_field ("filename")
		end

	set_running (a_running: BOOLEAN)
		do
			running := a_running
			update_memory_field ("running")
		end

	set_numcookies (a_numcookies: INTEGER_32)
		do
			numcookies := a_numcookies
			update_memory_field ("numcookies")
		end

	set_newsession (a_newsession: BOOLEAN)
		do
			newsession := a_newsession
			update_memory_field ("newsession")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			cookies := a_other.cookies
			filename := a_other.filename
			running := a_other.running
			numcookies := a_other.numcookies
			newsession := a_other.newsession
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				cookies.is_equal (a_other.cookies) and
				filename.is_equal (a_other.filename) and
				running = a_other.running and
				numcookies = a_other.numcookies and
				newsession = a_other.newsession
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("cookies"),
					create {CE_STRUCTURE_FIELD}.make ("filename"),
					create {CE_STRUCTURE_FIELD}.make ("running"),
					create {CE_STRUCTURE_FIELD}.make ("numcookies"),
					create {CE_STRUCTURE_FIELD}.make ("newsession")
				>>)
			init_structure_info
		end

end
