class
	PD_CURL_CHUNKER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_ARRAY} hexbuffer.make (<<17>>)
		end

feature {ANY} -- fields

	hexbuffer: CE_ARRAY [INTEGER_8]

	hexindex: INTEGER_32 assign set_hexindex

	state: NATURAL_32 assign set_state

	datasize: NATURAL_32 assign set_datasize

	dataleft: NATURAL_32 assign set_dataleft

feature {ANY} -- field setters

	set_hexindex (a_hexindex: INTEGER_32)
		do
			hexindex := a_hexindex
			update_memory_field ("hexindex")
		end

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_datasize (a_datasize: NATURAL_32)
		do
			datasize := a_datasize
			update_memory_field ("datasize")
		end

	set_dataleft (a_dataleft: NATURAL_32)
		do
			dataleft := a_dataleft
			update_memory_field ("dataleft")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			hexbuffer := a_other.hexbuffer.twin
			hexindex := a_other.hexindex
			state := a_other.state
			datasize := a_other.datasize
			dataleft := a_other.dataleft
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				hexbuffer.is_equal (a_other.hexbuffer) and
				hexindex = a_other.hexindex and
				state = a_other.state and
				datasize = a_other.datasize and
				dataleft = a_other.dataleft
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("hexbuffer", <<17>>),
					create {CE_STRUCTURE_FIELD}.make ("hexindex"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("datasize"),
					create {CE_STRUCTURE_FIELD}.make ("dataleft")
				>>)
			init_structure_info
		end

end
