class
	PD_CURL_ONE_EASY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_CURL_ONE_EASY]} next.make
			create {CE_CLASS_POINTER [PD_CURL_ONE_EASY]} prev.make
			create {CE_CLASS_POINTER [PD_SESSIONHANDLE]} easy_handle.make
			create {CE_CLASS_POINTER [PD_CONNECTDATA]} easy_conn.make
			create msg.make
			create {CE_INTEGER_32_ARRAY} sockets.make (<<5>>)
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_CURL_ONE_EASY] assign set_next

	prev: CE_POINTER [PD_CURL_ONE_EASY] assign set_prev

	easy_handle: CE_POINTER [PD_SESSIONHANDLE] assign set_easy_handle

	easy_conn: CE_POINTER [PD_CONNECTDATA] assign set_easy_conn

	state: NATURAL_32 assign set_state

	result2: NATURAL_32 assign set_result2

	msg: PD_CURL_MESSAGE assign set_msg

	sockets: CE_ARRAY [INTEGER_32]

	numsocks: INTEGER_32 assign set_numsocks

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_CURL_ONE_EASY])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_CURL_ONE_EASY])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_easy_handle (a_easy_handle: CE_POINTER [PD_SESSIONHANDLE])
		do
			easy_handle := a_easy_handle
			update_memory_field ("easy_handle")
		end

	set_easy_conn (a_easy_conn: CE_POINTER [PD_CONNECTDATA])
		do
			easy_conn := a_easy_conn
			update_memory_field ("easy_conn")
		end

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_result2 (a_result2: NATURAL_32)
		do
			result2 := a_result2
			update_memory_field ("result2")
		end

	set_msg (a_msg: PD_CURL_MESSAGE)
		do
			msg := a_msg
			update_memory_field ("msg")
		end

	set_numsocks (a_numsocks: INTEGER_32)
		do
			numsocks := a_numsocks
			update_memory_field ("numsocks")
		end

feature {ANY} -- public routines

	multistate (a_state___3: NATURAL_32)
		local
			l_oldstate: NATURAL_32
			l_return: BOOLEAN
		do
			l_oldstate := state
			if l_oldstate = a_state___3 then
				l_return := True
			end
			if not l_return then
				Current.state := a_state___3
				update_class_fields -- Current might have been changed; synchronize
				if a_state___3 = {NATURAL_32} 15 then
					(easy_handle.item.multi).item.num_alive := ((easy_handle.item.multi).item.num_alive) - 1
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	multi_getsock (a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if easy_handle.item.state.pipe_broke then
						Result := 0
						l_return := True
					elseif easy_conn.is_void then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if state > {NATURAL_32} 1 then
							if state < {NATURAL_32} 15 then
								easy_conn.item.data := easy_handle
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						inspect state.to_integer_32 -- switch 1 head
						when 2 then l_pos := -1 + 3
						when 5 then l_pos := -1 + 4
						when 7 then l_pos := -1 + 5
						when 8 then l_pos := -1 + 5
						when 4 then l_pos := -1 + 6
						when 3 then l_pos := -1 + 6
						when 9 then l_pos := -1 + 7
						when 10 then l_pos := -1 + 8
						when 12 then l_pos := -1 + 8
						when 11 then l_pos := -1 + 8
						else l_pos := -1 + 2
						end
				when 2 then -- switch 1, default:
						Result := 0
						l_return := True
				when 3 then -- switch 1, case 2
						if not l_return then
							l_tmp := Curl_resolv_getsock (easy_conn, a_socks, a_numsocks)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp
							l_return := True
						end
				when 4 then -- switch 1, case 5
						if not l_return then
							l_tmp___0 := Curl_protocol_getsock (easy_conn, a_socks, a_numsocks)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp___0
							l_return := True
						end
				when 5 then -- switch 1, case 7 | switch 1, case 8
						if not l_return then
							l_tmp___1 := Curl_doing_getsock (easy_conn, a_socks, a_numsocks)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp___1
							l_return := True
						end
				when 6 then -- switch 1, case 4 | switch 1, case 3
						if not l_return then
							l_tmp___2 := waitconnect_getsock (easy_conn, a_socks, a_numsocks)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp___2
							l_return := True
						end
				when 7 then -- switch 1, case 9
						if not l_return then
							l_tmp___3 := domore_getsock (easy_conn, a_socks, a_numsocks)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp___3
							l_return := True
						end
				when 8 then -- switch 1, case 10 | switch 1, case 12 | switch 1, case 11
						if not l_return then
							l_tmp___4 := Curl_single_getsock (easy_conn, a_socks, a_numsocks)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp___4
						end
				when 9 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {PD_CURL_ONE_EASY} -- private routines

	Curl_protocol_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		require
			not a_conn.is_void
		local
			l_return: BOOLEAN
		do
			if (not ((a_conn.item.handler).item.proto_getsock).is_void) then
				Result := (((a_conn.item.handler).item.proto_getsock).integer_32_item ([a_conn, a_socks, a_numsocks]))
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	Curl_doing_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_socks: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (not a_conn.is_void) then
				if (not ((a_conn.item.handler).item.doing_getsock).is_void) then
					Result := (((a_conn.item.handler).item.doing_getsock).integer_32_item ([a_conn, a_socks, a_numsocks]))
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	Curl_single_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_sock: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		require
			not a_conn.is_void
		local
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_bitmap: INTEGER_32
			l_sockindex: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := a_conn.item.data
					l_bitmap := 0
					l_sockindex := {NATURAL_32} 0
					if (not ((a_conn.item.handler).item.perform_getsock).is_void) then
						Result := (((a_conn.item.handler).item.perform_getsock).integer_32_item ([a_conn, a_sock, a_numsocks]))
						l_return := True
					end
					if not l_return and then (a_numsocks < 2) then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if ((l_data.item.req.keepon).bit_and (((((1).bit_or (((1).bit_shift_left (2))))).bit_or (((1).bit_shift_left (4)))))) = 1 then
							l_bitmap := (l_bitmap).bit_or (((1).bit_shift_left (l_sockindex.to_integer_32)))
							a_sock[l_sockindex.to_integer_32] := a_conn.item.sockfd
						end
						if ((l_data.item.req.keepon).bit_and (((((((1).bit_shift_left (1))).bit_or (((1).bit_shift_left (3))))).bit_or (((1).bit_shift_left (5)))))) /= ((1).bit_shift_left (1)) then
							l_pos := -1 + 8 -- skip if block
						end
				when 2 then -- if:
						if a_conn.item.sockfd = a_conn.item.writesockfd then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if ((l_data.item.req.keepon).bit_and (1)).to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						if ((l_data.item.req.keepon).bit_and (1)).to_boolean then
							l_sockindex := l_sockindex + 1
						end
						a_sock[l_sockindex.to_integer_32] := a_conn.item.writesockfd
				when 7 then -- if done
						l_bitmap := (l_bitmap).bit_or (((1).bit_shift_left (({NATURAL_32} 16 + l_sockindex).to_integer_32)))
				when 8 then -- if done
						Result := l_bitmap
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	waitconnect_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_sock: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if not a_numsocks.to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				a_sock[0] := a_conn.item.sock[0]
				if a_conn.item.bits.tunnel_connecting then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				Result := ((1).bit_shift_left (16))
			end
		end

	domore_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_sock: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if not a_numsocks.to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				a_sock[0] := a_conn.item.sock[1]
				Result := ((1).bit_shift_left (16))
			end
		end

	Curl_resolv_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_sock: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		do
			Result := 0
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			easy_handle := a_other.easy_handle
			easy_conn := a_other.easy_conn
			state := a_other.state
			result2 := a_other.result2
			msg := a_other.msg.twin
			sockets := a_other.sockets.twin
			numsocks := a_other.numsocks
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				easy_handle.is_equal (a_other.easy_handle) and
				easy_conn.is_equal (a_other.easy_conn) and
				state = a_other.state and
				result2 = a_other.result2 and
				msg.is_equal (a_other.msg) and
				sockets.is_equal (a_other.sockets) and
				numsocks = a_other.numsocks
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("easy_handle"),
					create {CE_STRUCTURE_FIELD}.make ("easy_conn"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("result2"),
					create {CE_STRUCTURE_FIELD}.make ("msg"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sockets", <<5>>),
					create {CE_STRUCTURE_FIELD}.make ("numsocks")
				>>)
			init_structure_info
		end

end
