class
	PD_PROGRESS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create start.make
			create t_startsingle.make
			create {CE_INTEGER_64_ARRAY} speeder.make (<<6>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} speeder_time.make (<<6>>)
		end

feature {ANY} -- fields

	lastshow: INTEGER_32 assign set_lastshow

	size_dl: INTEGER_64 assign set_size_dl

	size_ul: INTEGER_64 assign set_size_ul

	downloaded: INTEGER_64 assign set_downloaded

	uploaded: INTEGER_64 assign set_uploaded

	current_speed: INTEGER_64 assign set_current_speed

	callback: BOOLEAN assign set_callback

	width: INTEGER_32 assign set_width

	flags: INTEGER_32 assign set_flags

	timespent: REAL_64 assign set_timespent

	dlspeed: INTEGER_64 assign set_dlspeed

	ulspeed: INTEGER_64 assign set_ulspeed

	t_nslookup: REAL_64 assign set_t_nslookup

	t_connect: REAL_64 assign set_t_connect

	t_appconnect: REAL_64 assign set_t_appconnect

	t_pretransfer: REAL_64 assign set_t_pretransfer

	t_starttransfer: REAL_64 assign set_t_starttransfer

	t_redirect: REAL_64 assign set_t_redirect

	start: SD_TIMEVAL assign set_start

	t_startsingle: SD_TIMEVAL assign set_t_startsingle

	speeder: CE_ARRAY [INTEGER_64]

	speeder_time: CE_ARRAY [SD_TIMEVAL]

	speeder_c: INTEGER_32 assign set_speeder_c

feature {ANY} -- field setters

	set_lastshow (a_lastshow: INTEGER_32)
		do
			lastshow := a_lastshow
			update_memory_field ("lastshow")
		end

	set_size_dl (a_size_dl: INTEGER_64)
		do
			size_dl := a_size_dl
			update_memory_field ("size_dl")
		end

	set_size_ul (a_size_ul: INTEGER_64)
		do
			size_ul := a_size_ul
			update_memory_field ("size_ul")
		end

	set_downloaded (a_downloaded: INTEGER_64)
		do
			downloaded := a_downloaded
			update_memory_field ("downloaded")
		end

	set_uploaded (a_uploaded: INTEGER_64)
		do
			uploaded := a_uploaded
			update_memory_field ("uploaded")
		end

	set_current_speed (a_current_speed: INTEGER_64)
		do
			current_speed := a_current_speed
			update_memory_field ("current_speed")
		end

	set_callback (a_callback: BOOLEAN)
		do
			callback := a_callback
			update_memory_field ("callback")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_timespent (a_timespent: REAL_64)
		do
			timespent := a_timespent
			update_memory_field ("timespent")
		end

	set_dlspeed (a_dlspeed: INTEGER_64)
		do
			dlspeed := a_dlspeed
			update_memory_field ("dlspeed")
		end

	set_ulspeed (a_ulspeed: INTEGER_64)
		do
			ulspeed := a_ulspeed
			update_memory_field ("ulspeed")
		end

	set_t_nslookup (a_t_nslookup: REAL_64)
		do
			t_nslookup := a_t_nslookup
			update_memory_field ("t_nslookup")
		end

	set_t_connect (a_t_connect: REAL_64)
		do
			t_connect := a_t_connect
			update_memory_field ("t_connect")
		end

	set_t_appconnect (a_t_appconnect: REAL_64)
		do
			t_appconnect := a_t_appconnect
			update_memory_field ("t_appconnect")
		end

	set_t_pretransfer (a_t_pretransfer: REAL_64)
		do
			t_pretransfer := a_t_pretransfer
			update_memory_field ("t_pretransfer")
		end

	set_t_starttransfer (a_t_starttransfer: REAL_64)
		do
			t_starttransfer := a_t_starttransfer
			update_memory_field ("t_starttransfer")
		end

	set_t_redirect (a_t_redirect: REAL_64)
		do
			t_redirect := a_t_redirect
			update_memory_field ("t_redirect")
		end

	set_start (a_start: SD_TIMEVAL)
		do
			start := a_start
			update_memory_field ("start")
		end

	set_t_startsingle (a_t_startsingle: SD_TIMEVAL)
		do
			t_startsingle := a_t_startsingle
			update_memory_field ("t_startsingle")
		end

	set_speeder_c (a_speeder_c: INTEGER_32)
		do
			speeder_c := a_speeder_c
			update_memory_field ("speeder_c")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			lastshow := a_other.lastshow
			size_dl := a_other.size_dl
			size_ul := a_other.size_ul
			downloaded := a_other.downloaded
			uploaded := a_other.uploaded
			current_speed := a_other.current_speed
			callback := a_other.callback
			width := a_other.width
			flags := a_other.flags
			timespent := a_other.timespent
			dlspeed := a_other.dlspeed
			ulspeed := a_other.ulspeed
			t_nslookup := a_other.t_nslookup
			t_connect := a_other.t_connect
			t_appconnect := a_other.t_appconnect
			t_pretransfer := a_other.t_pretransfer
			t_starttransfer := a_other.t_starttransfer
			t_redirect := a_other.t_redirect
			start := a_other.start.twin
			t_startsingle := a_other.t_startsingle.twin
			speeder := a_other.speeder.twin
			speeder_time := a_other.speeder_time.twin
			speeder_c := a_other.speeder_c
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				lastshow = a_other.lastshow and
				size_dl = a_other.size_dl and
				size_ul = a_other.size_ul and
				downloaded = a_other.downloaded and
				uploaded = a_other.uploaded and
				current_speed = a_other.current_speed and
				callback = a_other.callback and
				width = a_other.width and
				flags = a_other.flags and
				timespent = a_other.timespent and
				dlspeed = a_other.dlspeed and
				ulspeed = a_other.ulspeed and
				t_nslookup = a_other.t_nslookup and
				t_connect = a_other.t_connect and
				t_appconnect = a_other.t_appconnect and
				t_pretransfer = a_other.t_pretransfer and
				t_starttransfer = a_other.t_starttransfer and
				t_redirect = a_other.t_redirect and
				start.is_equal (a_other.start) and
				t_startsingle.is_equal (a_other.t_startsingle) and
				speeder.is_equal (a_other.speeder) and
				speeder_time.is_equal (a_other.speeder_time) and
				speeder_c = a_other.speeder_c
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("lastshow"),
					create {CE_STRUCTURE_FIELD}.make ("size_dl"),
					create {CE_STRUCTURE_FIELD}.make ("size_ul"),
					create {CE_STRUCTURE_FIELD}.make ("downloaded"),
					create {CE_STRUCTURE_FIELD}.make ("uploaded"),
					create {CE_STRUCTURE_FIELD}.make ("current_speed"),
					create {CE_STRUCTURE_FIELD}.make ("callback"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("timespent"),
					create {CE_STRUCTURE_FIELD}.make ("dlspeed"),
					create {CE_STRUCTURE_FIELD}.make ("ulspeed"),
					create {CE_STRUCTURE_FIELD}.make ("t_nslookup"),
					create {CE_STRUCTURE_FIELD}.make ("t_connect"),
					create {CE_STRUCTURE_FIELD}.make ("t_appconnect"),
					create {CE_STRUCTURE_FIELD}.make ("t_pretransfer"),
					create {CE_STRUCTURE_FIELD}.make ("t_starttransfer"),
					create {CE_STRUCTURE_FIELD}.make ("t_redirect"),
					create {CE_STRUCTURE_FIELD}.make ("start"),
					create {CE_STRUCTURE_FIELD}.make ("t_startsingle"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("speeder", <<6>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("speeder_time", <<6>>),
					create {CE_STRUCTURE_FIELD}.make ("speeder_c")
				>>)
			init_structure_info
		end

end
