class
	PD_STATE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	UNIX: PD_UNIX assign set_UNIX

	NT: PD_NT assign set_NT

feature {ANY} -- field setters

	set_UNIX (a_UNIX: PD_UNIX)
		do
			UNIX := a_UNIX
			update_memory_field ("UNIX")
		end

	set_NT (a_NT: PD_NT)
		do
			NT := a_NT
			update_memory_field ("NT")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			UNIX := a_other.UNIX.twin
			NT := a_other.NT.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				UNIX.is_equal (a_other.UNIX) and
				NT.is_equal (a_other.NT)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("UNIX"),
					create {CE_STRUCTURE_FIELD}.make ("NT")
				>>)
			init_structure_info
		end

end
