class
	PD_WILDCARDDATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} path.make
			create {CE_INTEGER_8_POINTER} pattern.make
			create {CE_CLASS_POINTER [PD_CURL_LLIST]} filelist.make
			create {CE_VOID_POINTER} tmp.make
			create tmp_dtor.make
			create {CE_VOID_POINTER} customptr.make
		end

feature {ANY} -- fields

	state: NATURAL_32 assign set_state

	path: CE_POINTER [INTEGER_8] assign set_path

	pattern: CE_POINTER [INTEGER_8] assign set_pattern

	filelist: CE_POINTER [PD_CURL_LLIST] assign set_filelist

	tmp: CE_POINTER [ANY] assign set_tmp

	tmp_dtor: CE_ROUTINE assign set_tmp_dtor

	customptr: CE_POINTER [ANY] assign set_customptr

feature {ANY} -- field setters

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_path (a_path: CE_POINTER [INTEGER_8])
		do
			path := a_path
			update_memory_field ("path")
		end

	set_pattern (a_pattern: CE_POINTER [INTEGER_8])
		do
			pattern := a_pattern
			update_memory_field ("pattern")
		end

	set_filelist (a_filelist: CE_POINTER [PD_CURL_LLIST])
		do
			filelist := a_filelist
			update_memory_field ("filelist")
		end

	set_tmp (a_tmp: CE_POINTER [ANY])
		do
			tmp := a_tmp
			update_memory_field ("tmp")
		end

	set_tmp_dtor (a_tmp_dtor: CE_ROUTINE)
		do
			tmp_dtor := a_tmp_dtor
			update_memory_field ("tmp_dtor")
		end

	set_customptr (a_customptr: CE_POINTER [ANY])
		do
			customptr := a_customptr
			update_memory_field ("customptr")
		end

feature {ANY} -- public routines

	Curl_wildcard_init: NATURAL_32
		local
			l_return: BOOLEAN
		do
			Current.filelist := (create {P_LLIST_STATIC}).Curl_llist_alloc ((create {P_FILEINFO_STATIC}).Curl_fileinfo_dtor_address)
			update_class_fields -- Current might have been changed; synchronize
			if filelist.is_void then
				Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
				l_return := True
			end
			if not l_return then
				Result := ({PC_CURLCODE}.CURLE_OK)
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			state := a_other.state
			path := a_other.path
			pattern := a_other.pattern
			filelist := a_other.filelist
			tmp := a_other.tmp
			tmp_dtor := a_other.tmp_dtor
			customptr := a_other.customptr
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				state = a_other.state and
				path.is_equal (a_other.path) and
				pattern.is_equal (a_other.pattern) and
				filelist.is_equal (a_other.filelist) and
				tmp.is_equal (a_other.tmp) and
				tmp_dtor.is_equal (a_other.tmp_dtor) and
				customptr.is_equal (a_other.customptr)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("path"),
					create {CE_STRUCTURE_FIELD}.make ("pattern"),
					create {CE_STRUCTURE_FIELD}.make ("filelist"),
					create {CE_STRUCTURE_FIELD}.make ("tmp"),
					create {CE_STRUCTURE_FIELD}.make ("tmp_dtor"),
					create {CE_STRUCTURE_FIELD}.make ("customptr")
				>>)
			init_structure_info
		end

end
