class
	S_STDIO_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	fclose (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fclose (a___stream.c_pointer)
		end

	c_fclose (a___stream: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fclose($a___stream);"
		end

	fopen (a___filename, a___modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create {CE_CLASS_POINTER [SD_IO_FILE]} Result.make_shared (c_fopen (a___filename.c_pointer, a___modes.c_pointer))
		end

	c_fopen (a___filename: POINTER; a___modes: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return (EIF_POINTER)fopen($a___filename, $a___modes);"
		end

	fwrite (a___ptr: CE_POINTER [ANY]; a___size, a___n: NATURAL_32; a___s: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fwrite (a___ptr.c_pointer, a___size, a___n, a___s.c_pointer)
		end

	c_fwrite (a___ptr: POINTER; a___size: NATURAL_32; a___n: NATURAL_32; a___s: POINTER): NATURAL_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fwrite($a___ptr, $a___size, $a___n, $a___s);"
		end

	fileno (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fileno (a_stream.c_pointer)
		end

	c_fileno (a_stream: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fileno($a_stream);"
		end

	fflush (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fflush (a___stream.c_pointer)
		end

	c_fflush (a___stream: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fflush($a___stream);"
		end

	fread (a___ptr: CE_POINTER [ANY]; a___size, a___n: NATURAL_32; a___stream: CE_POINTER [SD_IO_FILE]): NATURAL_32
		do
			Result := c_fread (a___ptr.c_pointer, a___size, a___n, a___stream.c_pointer)
		end

	c_fread (a___ptr: POINTER; a___size: NATURAL_32; a___n: NATURAL_32; a___stream: POINTER): NATURAL_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fread($a___ptr, $a___size, $a___n, $a___stream);"
		end

	sscanf (a_args: TUPLE [a___s, a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sscanf)).integer_32_item (a_args)
		end

	c_sscanf: POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return (EIF_POINTER)&sscanf;"
		end

	fgets (a___s: CE_POINTER [INTEGER_8]; a___n: INTEGER_32; a___stream: CE_POINTER [SD_IO_FILE]): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_fgets (a___s.c_pointer, a___n, a___stream.c_pointer))
		end

	c_fgets (a___s: POINTER; a___n: INTEGER_32; a___stream: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return (EIF_POINTER)fgets($a___s, $a___n, $a___stream);"
		end

	fputs (a___s: CE_POINTER [INTEGER_8]; a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputs (a___s.c_pointer, a___stream.c_pointer)
		end

	c_fputs (a___s: POINTER; a___stream: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fputs($a___s, $a___stream);"
		end

	sprintf (a_args: TUPLE [a___s, a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sprintf)).integer_32_item (a_args)
		end

	c_sprintf: POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return (EIF_POINTER)&sprintf;"
		end

	fputc (a___c: INTEGER_32; a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fputc (a___c, a___stream.c_pointer)
		end

	c_fputc (a___c: INTEGER_32; a___stream: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fputc($a___c, $a___stream);"
		end

	fseek (a___stream: CE_POINTER [SD_IO_FILE]; a___off: INTEGER_32; a___whence: INTEGER_32): INTEGER_32
		do
			Result := c_fseek (a___stream.c_pointer, a___off, a___whence)
		end

	c_fseek (a___stream: POINTER; a___off: INTEGER_32; a___whence: INTEGER_32): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fseek($a___stream, $a___off, $a___whence);"
		end

feature {ANY} -- routine addresses

	fwrite_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent fwrite)
		end

	fread_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent fread)
		end

	fputc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent fputc)
		end

end
