class
	SD_IFA_IFU

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	ifu_broadaddr: CE_POINTER [SD_SOCKADDR] assign set_ifu_broadaddr

	ifu_dstaddr: CE_POINTER [SD_SOCKADDR] assign set_ifu_dstaddr

feature {ANY} -- field setters

	set_ifu_broadaddr (a_ifu_broadaddr: CE_POINTER [SD_SOCKADDR])
		do
			ifu_broadaddr := a_ifu_broadaddr
			update_memory_field ("ifu_broadaddr")
		end

	set_ifu_dstaddr (a_ifu_dstaddr: CE_POINTER [SD_SOCKADDR])
		do
			ifu_dstaddr := a_ifu_dstaddr
			update_memory_field ("ifu_dstaddr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ifu_broadaddr := a_other.ifu_broadaddr
			ifu_dstaddr := a_other.ifu_dstaddr
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ifu_broadaddr.is_equal (a_other.ifu_broadaddr) and
				ifu_dstaddr.is_equal (a_other.ifu_dstaddr)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("ifu_broadaddr"),
					create {CE_STRUCTURE_FIELD}.make ("ifu_dstaddr")
				>>)
			init_structure_info
		end

end
