class
	SD_IO_FILE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} IO_read_ptr.make
			create {CE_INTEGER_8_POINTER} IO_read_end.make
			create {CE_INTEGER_8_POINTER} IO_read_base.make
			create {CE_INTEGER_8_POINTER} IO_write_base.make
			create {CE_INTEGER_8_POINTER} IO_write_ptr.make
			create {CE_INTEGER_8_POINTER} IO_write_end.make
			create {CE_INTEGER_8_POINTER} IO_buf_base.make
			create {CE_INTEGER_8_POINTER} IO_buf_end.make
			create {CE_INTEGER_8_POINTER} IO_save_base.make
			create {CE_INTEGER_8_POINTER} IO_backup_base.make
			create {CE_INTEGER_8_POINTER} IO_save_end.make
			create {CE_CLASS_POINTER [SD_IO_MARKER]} markers.make
			create {CE_CLASS_POINTER [SD_IO_FILE]} chain.make
			create {CE_INTEGER_8_ARRAY} shortbuf.make (<<1>>)
			create {CE_VOID_POINTER} lock.make
			create {CE_VOID_POINTER} pad1.make
			create {CE_VOID_POINTER} pad2.make
			create {CE_VOID_POINTER} pad3.make
			create {CE_VOID_POINTER} pad4.make
			create {CE_INTEGER_8_ARRAY} unused2.make (<<(({NATURAL_32} 15 * {PLATFORM}.Integer_32_bytes.to_natural_32 - {NATURAL_32} 4 * {PLATFORM}.Pointer_bytes.to_natural_32) - {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32>>)
		end

feature {ANY} -- fields

	flags: INTEGER_32 assign set_flags

	IO_read_ptr: CE_POINTER [INTEGER_8] assign set_IO_read_ptr

	IO_read_end: CE_POINTER [INTEGER_8] assign set_IO_read_end

	IO_read_base: CE_POINTER [INTEGER_8] assign set_IO_read_base

	IO_write_base: CE_POINTER [INTEGER_8] assign set_IO_write_base

	IO_write_ptr: CE_POINTER [INTEGER_8] assign set_IO_write_ptr

	IO_write_end: CE_POINTER [INTEGER_8] assign set_IO_write_end

	IO_buf_base: CE_POINTER [INTEGER_8] assign set_IO_buf_base

	IO_buf_end: CE_POINTER [INTEGER_8] assign set_IO_buf_end

	IO_save_base: CE_POINTER [INTEGER_8] assign set_IO_save_base

	IO_backup_base: CE_POINTER [INTEGER_8] assign set_IO_backup_base

	IO_save_end: CE_POINTER [INTEGER_8] assign set_IO_save_end

	markers: CE_POINTER [SD_IO_MARKER] assign set_markers

	chain: CE_POINTER [SD_IO_FILE] assign set_chain

	fileno: INTEGER_32 assign set_fileno

	flags2: INTEGER_32 assign set_flags2

	old_offset: INTEGER_32 assign set_old_offset

	cur_column: NATURAL_16 assign set_cur_column

	vtable_offset: INTEGER_8 assign set_vtable_offset

	shortbuf: CE_ARRAY [INTEGER_8]

	lock: CE_POINTER [ANY] assign set_lock

	offset: INTEGER_64 assign set_offset

	pad1: CE_POINTER [ANY] assign set_pad1

	pad2: CE_POINTER [ANY] assign set_pad2

	pad3: CE_POINTER [ANY] assign set_pad3

	pad4: CE_POINTER [ANY] assign set_pad4

	pad5: NATURAL_32 assign set_pad5

	mode: INTEGER_32 assign set_mode

	unused2: CE_ARRAY [INTEGER_8]

feature {ANY} -- field setters

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_IO_read_ptr (a_IO_read_ptr: CE_POINTER [INTEGER_8])
		do
			IO_read_ptr := a_IO_read_ptr
			update_memory_field ("IO_read_ptr")
		end

	set_IO_read_end (a_IO_read_end: CE_POINTER [INTEGER_8])
		do
			IO_read_end := a_IO_read_end
			update_memory_field ("IO_read_end")
		end

	set_IO_read_base (a_IO_read_base: CE_POINTER [INTEGER_8])
		do
			IO_read_base := a_IO_read_base
			update_memory_field ("IO_read_base")
		end

	set_IO_write_base (a_IO_write_base: CE_POINTER [INTEGER_8])
		do
			IO_write_base := a_IO_write_base
			update_memory_field ("IO_write_base")
		end

	set_IO_write_ptr (a_IO_write_ptr: CE_POINTER [INTEGER_8])
		do
			IO_write_ptr := a_IO_write_ptr
			update_memory_field ("IO_write_ptr")
		end

	set_IO_write_end (a_IO_write_end: CE_POINTER [INTEGER_8])
		do
			IO_write_end := a_IO_write_end
			update_memory_field ("IO_write_end")
		end

	set_IO_buf_base (a_IO_buf_base: CE_POINTER [INTEGER_8])
		do
			IO_buf_base := a_IO_buf_base
			update_memory_field ("IO_buf_base")
		end

	set_IO_buf_end (a_IO_buf_end: CE_POINTER [INTEGER_8])
		do
			IO_buf_end := a_IO_buf_end
			update_memory_field ("IO_buf_end")
		end

	set_IO_save_base (a_IO_save_base: CE_POINTER [INTEGER_8])
		do
			IO_save_base := a_IO_save_base
			update_memory_field ("IO_save_base")
		end

	set_IO_backup_base (a_IO_backup_base: CE_POINTER [INTEGER_8])
		do
			IO_backup_base := a_IO_backup_base
			update_memory_field ("IO_backup_base")
		end

	set_IO_save_end (a_IO_save_end: CE_POINTER [INTEGER_8])
		do
			IO_save_end := a_IO_save_end
			update_memory_field ("IO_save_end")
		end

	set_markers (a_markers: CE_POINTER [SD_IO_MARKER])
		do
			markers := a_markers
			update_memory_field ("markers")
		end

	set_chain (a_chain: CE_POINTER [SD_IO_FILE])
		do
			chain := a_chain
			update_memory_field ("chain")
		end

	set_fileno (a_fileno: INTEGER_32)
		do
			fileno := a_fileno
			update_memory_field ("fileno")
		end

	set_flags2 (a_flags2: INTEGER_32)
		do
			flags2 := a_flags2
			update_memory_field ("flags2")
		end

	set_old_offset (a_old_offset: INTEGER_32)
		do
			old_offset := a_old_offset
			update_memory_field ("old_offset")
		end

	set_cur_column (a_cur_column: NATURAL_16)
		do
			cur_column := a_cur_column
			update_memory_field ("cur_column")
		end

	set_vtable_offset (a_vtable_offset: INTEGER_8)
		do
			vtable_offset := a_vtable_offset
			update_memory_field ("vtable_offset")
		end

	set_lock (a_lock: CE_POINTER [ANY])
		do
			lock := a_lock
			update_memory_field ("lock")
		end

	set_offset (a_offset: INTEGER_64)
		do
			offset := a_offset
			update_memory_field ("offset")
		end

	set_pad1 (a_pad1: CE_POINTER [ANY])
		do
			pad1 := a_pad1
			update_memory_field ("pad1")
		end

	set_pad2 (a_pad2: CE_POINTER [ANY])
		do
			pad2 := a_pad2
			update_memory_field ("pad2")
		end

	set_pad3 (a_pad3: CE_POINTER [ANY])
		do
			pad3 := a_pad3
			update_memory_field ("pad3")
		end

	set_pad4 (a_pad4: CE_POINTER [ANY])
		do
			pad4 := a_pad4
			update_memory_field ("pad4")
		end

	set_pad5 (a_pad5: NATURAL_32)
		do
			pad5 := a_pad5
			update_memory_field ("pad5")
		end

	set_mode (a_mode: INTEGER_32)
		do
			mode := a_mode
			update_memory_field ("mode")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			flags := a_other.flags
			IO_read_ptr := a_other.IO_read_ptr
			IO_read_end := a_other.IO_read_end
			IO_read_base := a_other.IO_read_base
			IO_write_base := a_other.IO_write_base
			IO_write_ptr := a_other.IO_write_ptr
			IO_write_end := a_other.IO_write_end
			IO_buf_base := a_other.IO_buf_base
			IO_buf_end := a_other.IO_buf_end
			IO_save_base := a_other.IO_save_base
			IO_backup_base := a_other.IO_backup_base
			IO_save_end := a_other.IO_save_end
			markers := a_other.markers
			chain := a_other.chain
			fileno := a_other.fileno
			flags2 := a_other.flags2
			old_offset := a_other.old_offset
			cur_column := a_other.cur_column
			vtable_offset := a_other.vtable_offset
			shortbuf := a_other.shortbuf.twin
			lock := a_other.lock
			offset := a_other.offset
			pad1 := a_other.pad1
			pad2 := a_other.pad2
			pad3 := a_other.pad3
			pad4 := a_other.pad4
			pad5 := a_other.pad5
			mode := a_other.mode
			unused2 := a_other.unused2.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				flags = a_other.flags and
				IO_read_ptr.is_equal (a_other.IO_read_ptr) and
				IO_read_end.is_equal (a_other.IO_read_end) and
				IO_read_base.is_equal (a_other.IO_read_base) and
				IO_write_base.is_equal (a_other.IO_write_base) and
				IO_write_ptr.is_equal (a_other.IO_write_ptr) and
				IO_write_end.is_equal (a_other.IO_write_end) and
				IO_buf_base.is_equal (a_other.IO_buf_base) and
				IO_buf_end.is_equal (a_other.IO_buf_end) and
				IO_save_base.is_equal (a_other.IO_save_base) and
				IO_backup_base.is_equal (a_other.IO_backup_base) and
				IO_save_end.is_equal (a_other.IO_save_end) and
				markers.is_equal (a_other.markers) and
				chain.is_equal (a_other.chain) and
				fileno = a_other.fileno and
				flags2 = a_other.flags2 and
				old_offset = a_other.old_offset and
				cur_column = a_other.cur_column and
				vtable_offset = a_other.vtable_offset and
				shortbuf.is_equal (a_other.shortbuf) and
				lock.is_equal (a_other.lock) and
				offset = a_other.offset and
				pad1.is_equal (a_other.pad1) and
				pad2.is_equal (a_other.pad2) and
				pad3.is_equal (a_other.pad3) and
				pad4.is_equal (a_other.pad4) and
				pad5 = a_other.pad5 and
				mode = a_other.mode and
				unused2.is_equal (a_other.unused2)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("IO_read_ptr"),
					create {CE_STRUCTURE_FIELD}.make ("IO_read_end"),
					create {CE_STRUCTURE_FIELD}.make ("IO_read_base"),
					create {CE_STRUCTURE_FIELD}.make ("IO_write_base"),
					create {CE_STRUCTURE_FIELD}.make ("IO_write_ptr"),
					create {CE_STRUCTURE_FIELD}.make ("IO_write_end"),
					create {CE_STRUCTURE_FIELD}.make ("IO_buf_base"),
					create {CE_STRUCTURE_FIELD}.make ("IO_buf_end"),
					create {CE_STRUCTURE_FIELD}.make ("IO_save_base"),
					create {CE_STRUCTURE_FIELD}.make ("IO_backup_base"),
					create {CE_STRUCTURE_FIELD}.make ("IO_save_end"),
					create {CE_STRUCTURE_FIELD}.make ("markers"),
					create {CE_STRUCTURE_FIELD}.make ("chain"),
					create {CE_STRUCTURE_FIELD}.make ("fileno"),
					create {CE_STRUCTURE_FIELD}.make ("flags2"),
					create {CE_STRUCTURE_FIELD}.make ("old_offset"),
					create {CE_STRUCTURE_FIELD}.make ("cur_column"),
					create {CE_STRUCTURE_FIELD}.make ("vtable_offset"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("shortbuf", <<1>>),
					create {CE_STRUCTURE_FIELD}.make ("lock"),
					create {CE_STRUCTURE_FIELD}.make ("offset"),
					create {CE_STRUCTURE_FIELD}.make ("pad1"),
					create {CE_STRUCTURE_FIELD}.make ("pad2"),
					create {CE_STRUCTURE_FIELD}.make ("pad3"),
					create {CE_STRUCTURE_FIELD}.make ("pad4"),
					create {CE_STRUCTURE_FIELD}.make ("pad5"),
					create {CE_STRUCTURE_FIELD}.make ("mode"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("unused2", <<(({NATURAL_32} 15 * {PLATFORM}.Integer_32_bytes.to_natural_32 - {NATURAL_32} 4 * {PLATFORM}.Pointer_bytes.to_natural_32) - {PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32>>)
				>>)
			init_structure_info
		end

end
