class
	SD_SIGCHLD

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	si_pid: INTEGER_32 assign set_si_pid

	si_uid: NATURAL_32 assign set_si_uid

	si_status: INTEGER_32 assign set_si_status

	si_utime: INTEGER_32 assign set_si_utime

	si_stime: INTEGER_32 assign set_si_stime

feature {ANY} -- field setters

	set_si_pid (a_si_pid: INTEGER_32)
		do
			si_pid := a_si_pid
			update_memory_field ("si_pid")
		end

	set_si_uid (a_si_uid: NATURAL_32)
		do
			si_uid := a_si_uid
			update_memory_field ("si_uid")
		end

	set_si_status (a_si_status: INTEGER_32)
		do
			si_status := a_si_status
			update_memory_field ("si_status")
		end

	set_si_utime (a_si_utime: INTEGER_32)
		do
			si_utime := a_si_utime
			update_memory_field ("si_utime")
		end

	set_si_stime (a_si_stime: INTEGER_32)
		do
			si_stime := a_si_stime
			update_memory_field ("si_stime")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			si_pid := a_other.si_pid
			si_uid := a_other.si_uid
			si_status := a_other.si_status
			si_utime := a_other.si_utime
			si_stime := a_other.si_stime
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				si_pid = a_other.si_pid and
				si_uid = a_other.si_uid and
				si_status = a_other.si_status and
				si_utime = a_other.si_utime and
				si_stime = a_other.si_stime
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("si_pid"),
					create {CE_STRUCTURE_FIELD}.make ("si_uid"),
					create {CE_STRUCTURE_FIELD}.make ("si_status"),
					create {CE_STRUCTURE_FIELD}.make ("si_utime"),
					create {CE_STRUCTURE_FIELD}.make ("si_stime")
				>>)
			init_structure_info
		end

end
