class
	P_DCPI1_DIV_QR_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_dcpi1_div_qr_n (a_qp, a_np, a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_dinv: CE_POINTER [PD_GMP_PI1_T]; a_tp: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_lo: INTEGER_32
			l_hi: INTEGER_32
			l_cy: NATURAL_32
			l_qh: NATURAL_32
			l_ql: NATURAL_32
		do
			l_lo := (a_n).bit_shift_right (1)
			l_hi := a_n - l_lo
			if 19 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_hi >= 19 then
					l_qh := gmpn_dcpi1_div_qr_n (a_qp + l_lo, a_np + 2 * l_lo, a_dp + l_lo, l_hi, a_dinv, a_tp)
				else
					l_qh := (create {P_SBPI1_DIV_QR_STATIC}).gmpn_sbpi1_div_qr (a_qp + l_lo, a_np + 2 * l_lo, 2 * l_hi, a_dp + l_lo, l_hi, a_dinv.item.inv32)
				end
			else
				l_qh := (create {P_SBPI1_DIV_QR_STATIC}).gmpn_sbpi1_div_qr (a_qp + l_lo, a_np + 2 * l_lo, 2 * l_hi, a_dp + l_lo, l_hi, a_dinv.item.inv32)
			end
			(create {P_MUL_STATIC}).gmpn_mul (a_tp, (a_qp + l_lo), l_hi, a_dp, l_lo).do_nothing
			l_cy := (create {P_GMP_STATIC}).gmpn_sub_n (a_np + l_lo, (a_np + l_lo), a_tp, a_n)
			if l_qh /= {NATURAL_32} 0 then
				l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_sub_n (a_np + a_n, (a_np + a_n), a_dp, l_lo))
			end
			from
			until
				l_cy = {NATURAL_32} 0
			loop
				l_qh := l_qh - ((create {P_GMP_STATIC}).gmpn_sub_1 (a_qp + l_lo, (a_qp + l_lo), l_hi, (1).to_natural_32))
				l_cy := l_cy - ((create {P_GMP_STATIC}).gmpn_add_n (a_np + l_lo, (a_np + l_lo), a_dp, a_n))
			end
			if 19 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_lo >= 19 then
					l_ql := gmpn_dcpi1_div_qr_n (a_qp, a_np + l_hi, a_dp + l_hi, l_lo, a_dinv, a_tp)
				else
					l_ql := (create {P_SBPI1_DIV_QR_STATIC}).gmpn_sbpi1_div_qr (a_qp, a_np + l_hi, 2 * l_lo, a_dp + l_hi, l_lo, a_dinv.item.inv32)
				end
			else
				l_ql := (create {P_SBPI1_DIV_QR_STATIC}).gmpn_sbpi1_div_qr (a_qp, a_np + l_hi, 2 * l_lo, a_dp + l_hi, l_lo, a_dinv.item.inv32)
			end
			(create {P_MUL_STATIC}).gmpn_mul (a_tp, a_dp, l_hi, a_qp, l_lo).do_nothing
			l_cy := (create {P_GMP_STATIC}).gmpn_sub_n (a_np, a_np, a_tp, a_n)
			if l_ql /= {NATURAL_32} 0 then
				l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_sub_n (a_np + l_lo, (a_np + l_lo), a_dp, l_hi))
			end
			from
			until
				l_cy = {NATURAL_32} 0
			loop
				(create {P_GMP_STATIC}).gmpn_sub_1 (a_qp, a_qp, l_lo, (1).to_natural_32).do_nothing
				l_cy := l_cy - ((create {P_GMP_STATIC}).gmpn_add_n (a_np, a_np, a_dp, a_n))
			end
			Result := l_qh
		end

	gmpn_dcpi1_div_qr (a_qp, a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_dinv: CE_POINTER [PD_GMP_PI1_T]): NATURAL_32
		local
			l_dinv: CE_ARRAY [CE_POINTER [PD_GMP_PI1_T]]
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_qn: INTEGER_32
			l_qh: NATURAL_32
			l_cy: NATURAL_32
			l_tp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_q: CE_ARRAY [NATURAL_32]
			l_n2: CE_ARRAY [NATURAL_32]
			l_n1: CE_ARRAY [NATURAL_32]
			l_n0: CE_ARRAY [NATURAL_32]
			l_d1: CE_ARRAY [NATURAL_32]
			l_d0: CE_ARRAY [NATURAL_32]
			l__q0: CE_ARRAY [NATURAL_32]
			l__t1: CE_ARRAY [NATURAL_32]
			l__t0: CE_ARRAY [NATURAL_32]
			l__mask: CE_ARRAY [NATURAL_32]
			l_cy___0: NATURAL_32
			l_cy1: NATURAL_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_GMP_PI1_T]} l_dinv.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_q.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_n2.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_n1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_n0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_d1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_d0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__q0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__t1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__t0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__mask.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dinv.item := a_dinv
					l_qp := a_qp
					l_np := a_np
					l_dp := a_dp
					l___tmp_marker := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
					l_tp := create {CE_NATURAL_32_POINTER}.make_cast ((l_aaf.new ((a_dn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					l_qn := a_nn - a_dn
					l_qp := l_qp + l_qn
					l_np := l_np + a_nn
					l_dp := l_dp + a_dn
					if not (l_qn > a_dn) then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							l_qn := l_qn - a_dn
							if not (l_qn > a_dn) then
								l_break := True
							end
						end
						l_break := False
						l_qp := l_qp - l_qn
						l_np := l_np - l_qn
						if l_qn /= 1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 2 then -- if:
						l_qh := (((create {P_GMP_STATIC}).gmpn_cmp (((l_np - a_dn) + 1), l_dp - a_dn, a_dn)) >= 0).to_integer.to_natural_32
						if l_qh.to_boolean then
							(create {P_GMP_STATIC}).gmpn_sub_n ((l_np - a_dn) + 1, ((l_np - a_dn) + 1), l_dp - a_dn, a_dn).do_nothing
						end
						l_n2.item := l_np[0]
						l_n1.item := l_np[-1]
						l_n0.item := l_np[-2]
						l_d1.item := l_dp[-1]
						l_d0.item := l_dp[-2]
						if not ((builtin_expect ((l_n2.item = l_d1.item).to_integer, 0)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_n1.item = l_d0.item then
							l_q.item := {NATURAL_32} 4_294_967_295
							l_cy := (create {P_GMP_STATIC}).gmpn_submul_1 (l_np - a_dn, l_dp - a_dn, a_dn, l_q.item)
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						from
						until
							(l_break)
						loop
							l_break := False
							asm298 (l__q0, l_q, l_n2, l_dinv)
							asm299 (l_q, l__q0, l_n2, l_n1)
							l_n1.item := l_n1.item - (l_d1.item * l_q.item)
							l_n0.item := l_n0.item
							asm300 (l_n1, l_n0, l_d1, l_d0)
							asm301 (l__t0, l__t1, l_d0, l_q)
							asm302 (l_n1, l_n0, l__t1, l__t0)
							l_q.item := l_q.item + 1
							l__mask.item := (-((l_n1.item >= l__q0.item).to_integer.to_natural_32).to_integer_32).to_natural_32
							l_q.item := l_q.item + (l__mask.item)
							asm303 (l_n1, l_n0, l__mask, l_d1, l_d0)
							if (builtin_expect ((l_n1.item >= l_d1.item).to_integer, 0)).to_boolean then
								if l_n1.item > l_d1.item then
									l_q.item := l_q.item + 1
									asm304 (l_n1, l_n0, l_d1, l_d0)
								elseif l_n0.item >= l_d0.item then
									l_q.item := l_q.item + 1
									asm305 (l_n1, l_n0, l_d1, l_d0)
								end
							end
							l_break := True
						end
						l_break := False
						if a_dn > 2 then
							l_cy___0 := (create {P_GMP_STATIC}).gmpn_submul_1 (l_np - a_dn, l_dp - a_dn, a_dn - 2, l_q.item)
							l_cy1 := (l_n0.item < l_cy___0).to_integer.to_natural_32
							l_n0.item := ((l_n0.item - l_cy___0)).bit_and ({NATURAL_32} 4_294_967_295)
							l_cy___0 := (l_n1.item < l_cy1).to_integer.to_natural_32
							l_n1.item := ((l_n1.item - l_cy1)).bit_and ({NATURAL_32} 4_294_967_295)
							l_np[-2] := l_n0.item
							if (builtin_expect ((l_cy___0 /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
								l_n1.item := l_n1.item + (l_d1.item + ((create {P_GMP_STATIC}).gmpn_add_n (l_np - a_dn, (l_np - a_dn), l_dp - a_dn, a_dn - 1)))
								l_qh := l_qh - (l_q.item = {NATURAL_32} 0).to_integer.to_natural_32
								l_q.item := ((l_q.item - {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
							end
						else
							l_np[-2] := l_n0.item
						end
						l_np[-1] := l_n1.item
				when 6 then
						l_qp[0] := l_q.item
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						if l_qn = 2 then
							l_qh := (create {P_GMP_STATIC}).gmpn_divrem_2 (l_qp, 0, l_np - 2, (4).to_integer_32, l_dp - 2)
						elseif 19 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_qn >= 19 then
								l_qh := gmpn_dcpi1_div_qr_n (l_qp, l_np - l_qn, l_dp - l_qn, l_qn, l_dinv.item, l_tp)
							else
								l_qh := (create {P_SBPI1_DIV_QR_STATIC}).gmpn_sbpi1_div_qr (l_qp, l_np - l_qn, 2 * l_qn, l_dp - l_qn, l_qn, l_dinv.item.item.inv32)
							end
						else
							l_qh := (create {P_SBPI1_DIV_QR_STATIC}).gmpn_sbpi1_div_qr (l_qp, l_np - l_qn, 2 * l_qn, l_dp - l_qn, l_qn, l_dinv.item.item.inv32)
						end
						if l_qn /= a_dn then
							if l_qn > a_dn - l_qn then
								(create {P_MUL_STATIC}).gmpn_mul (l_tp, l_qp, l_qn, l_dp - a_dn, a_dn - l_qn).do_nothing
							else
								(create {P_MUL_STATIC}).gmpn_mul (l_tp, l_dp - a_dn, a_dn - l_qn, l_qp, l_qn).do_nothing
							end
							l_cy := (create {P_GMP_STATIC}).gmpn_sub_n (l_np - a_dn, (l_np - a_dn), l_tp, a_dn)
							if l_qh /= {NATURAL_32} 0 then
								l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_sub_n ((l_np - a_dn) + l_qn, ((l_np - a_dn) + l_qn), l_dp - a_dn, a_dn - l_qn))
							end
							from
							until
								l_cy = {NATURAL_32} 0
							loop
								l_qh := l_qh - ((create {P_GMP_STATIC}).gmpn_sub_1 (l_qp, l_qp, l_qn, (1).to_natural_32))
								l_cy := l_cy - ((create {P_GMP_STATIC}).gmpn_add_n (l_np - a_dn, (l_np - a_dn), l_dp - a_dn, a_dn))
							end
						end
				when 9 then -- if done
						l_qn := (a_nn - a_dn) - l_qn
						from
						until
							(l_break)
						loop
							l_break := False
							l_qp := l_qp - a_dn
							l_np := l_np - a_dn
							gmpn_dcpi1_div_qr_n (l_qp, l_np - a_dn, l_dp - a_dn, a_dn, l_dinv.item, l_tp).do_nothing
							l_qn := l_qn - a_dn
							if not (l_qn > 0) then
								l_break := True
							end
						end
						l_break := False
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_qp := l_qp - l_qn
						l_np := l_np - l_qn
						if 19 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_qn >= 19 then
								l_qh := gmpn_dcpi1_div_qr_n (l_qp, l_np - l_qn, l_dp - l_qn, l_qn, l_dinv.item, l_tp)
							else
								l_qh := (create {P_SBPI1_DIV_QR_STATIC}).gmpn_sbpi1_div_qr (l_qp, l_np - l_qn, 2 * l_qn, l_dp - l_qn, l_qn, l_dinv.item.item.inv32)
							end
						else
							l_qh := (create {P_SBPI1_DIV_QR_STATIC}).gmpn_sbpi1_div_qr (l_qp, l_np - l_qn, 2 * l_qn, l_dp - l_qn, l_qn, l_dinv.item.item.inv32)
						end
						if l_qn /= a_dn then
							if l_qn > a_dn - l_qn then
								(create {P_MUL_STATIC}).gmpn_mul (l_tp, l_qp, l_qn, l_dp - a_dn, a_dn - l_qn).do_nothing
							else
								(create {P_MUL_STATIC}).gmpn_mul (l_tp, l_dp - a_dn, a_dn - l_qn, l_qp, l_qn).do_nothing
							end
							l_cy := (create {P_GMP_STATIC}).gmpn_sub_n (l_np - a_dn, (l_np - a_dn), l_tp, a_dn)
							if l_qh /= {NATURAL_32} 0 then
								l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_sub_n ((l_np - a_dn) + l_qn, ((l_np - a_dn) + l_qn), l_dp - a_dn, a_dn - l_qn))
							end
							from
							until
								l_cy = {NATURAL_32} 0
							loop
								l_qh := l_qh - ((create {P_GMP_STATIC}).gmpn_sub_1 (l_qp, l_qp, l_qn, (1).to_natural_32))
								l_cy := l_cy - ((create {P_GMP_STATIC}).gmpn_add_n (l_np - a_dn, (l_np - a_dn), l_dp - a_dn, a_dn))
							end
						end
				when 12 then -- if done
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect ((not l___tmp_marker.is_void).to_integer, 0)).to_boolean then
							(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker)
						end
						l_break := True
					end
					l_break := False
					Result := l_qh
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
