class
	P_GMP_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpn_add_n (a_arg1, a_arg2, a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_add_n (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4)
		end

	c_gmpn_add_n (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: INTEGER_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_add_n($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_sub_n (a_arg1, a_arg2, a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_sub_n (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4)
		end

	c_gmpn_sub_n (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: INTEGER_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_sub_n($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpz_getlimbn (a___gmp_z: CE_POINTER [PD_MPZ_STRUCT]; a___gmp_n: INTEGER_32): NATURAL_32
		local
			l___gmp_result: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l___gmp_result := (0).to_natural_32
			if a___gmp_n >= 0 then
				if a___gmp_z.item.mp_size >= 0 then
					l_tmp := a___gmp_z.item.mp_size
				else
					l_tmp := -a___gmp_z.item.mp_size
				end
				if a___gmp_n < l_tmp.to_integer_32 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			if (builtin_expect ((l_tmp___0 /= 0).to_integer, 1)).to_boolean then
				l___gmp_result := a___gmp_z.item.mp_d[a___gmp_n]
			end
			Result := l___gmp_result
		end

	gmpn_add (a___gmp_wp, a___gmp_xp: CE_POINTER [NATURAL_32]; a___gmp_xsize: INTEGER_32; a___gmp_yp: CE_POINTER [NATURAL_32]; a___gmp_ysize: INTEGER_32): NATURAL_32
		local
			l___gmp_c: NATURAL_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l___gmp_j: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (l_return or l_break) then
						l_pos := -1 + 9 -- skip loop
					end
				when 1 then -- loop body:
						l_break := False
						l___gmp_i := a___gmp_ysize
						if l___gmp_i = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if not ((gmpn_add_n (a___gmp_wp, a___gmp_xp, a___gmp_yp, l___gmp_i)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						if l___gmp_i >= a___gmp_xsize then
							l___gmp_c := (1).to_natural_32
							l_pos := -1 + 8 -- goto __gmp_done
						end
				when 5 then
						l___gmp_x := a___gmp_xp[l___gmp_i]
						l_tmp := l___gmp_i
						l___gmp_i := l___gmp_i + 1
						l_tmp___0 := ((l___gmp_x + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
						a___gmp_wp[l_tmp] := l_tmp___0
						if l_tmp___0 /= {NATURAL_32} 0 then
							l_break := True
						end
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						l_break := False
				when 7 then -- if done | if done
						if not a___gmp_wp.is_equal (a___gmp_xp) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l___gmp_j := l___gmp_i
								from
								until
									not (l___gmp_j < a___gmp_xsize)
								loop
									a___gmp_wp[l___gmp_j] := a___gmp_xp[l___gmp_j]
									l___gmp_j := l___gmp_j + 1
								end
								l_break := True
							end
							l_break := False
						end
						l___gmp_c := (0).to_natural_32
				when 8 then -- __gmp_done:
						
						l_break := True
						l_pos := -1 + 0 -- back to loop condition
				when 9 then -- loop done
					l_break := False
					Result := l___gmp_c
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_add_1 (a___gmp_dst, a___gmp_src: CE_POINTER [NATURAL_32]; a___gmp_size: INTEGER_32; a___gmp_n: NATURAL_32): NATURAL_32
		require
			not a___gmp_dst.is_void
			not a___gmp_src.is_void
		local
			l___gmp_c: NATURAL_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_r: NATURAL_32
			l___gmp_j: INTEGER_32
			l___gmp_j___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l___gmp_x := a___gmp_src[0]
				l___gmp_r := l___gmp_x + a___gmp_n
				a___gmp_dst[0] := l___gmp_r
				if l___gmp_r < a___gmp_n then
					l___gmp_c := (1).to_natural_32
					l___gmp_i := (1).to_integer_32
					from
					until
						not (not (l_return or l_break) and then (l___gmp_i < a___gmp_size))
					loop
						l_break := False
						l___gmp_x := a___gmp_src[l___gmp_i]
						l___gmp_r := l___gmp_x + {NATURAL_32} 1
						a___gmp_dst[l___gmp_i] := l___gmp_r
						l___gmp_i := l___gmp_i + 1
						if not (l___gmp_r < {NATURAL_32} 1) then
							if not a___gmp_src.is_equal (a___gmp_dst) then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l___gmp_j := l___gmp_i
									from
									until
										not (l___gmp_j < a___gmp_size)
									loop
										a___gmp_dst[l___gmp_j] := a___gmp_src[l___gmp_j]
										l___gmp_j := l___gmp_j + 1
									end
									l_break := True
								end
								l_break := False
							end
							l___gmp_c := (0).to_natural_32
							l_break := True
						end
					end
					l_break := False
				else
					if not a___gmp_src.is_equal (a___gmp_dst) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___gmp_j___0 := (1).to_integer_32
							from
							until
								not (l___gmp_j___0 < a___gmp_size)
							loop
								a___gmp_dst[l___gmp_j___0] := a___gmp_src[l___gmp_j___0]
								l___gmp_j___0 := l___gmp_j___0 + 1
							end
							l_break := True
						end
						l_break := False
					end
					l___gmp_c := (0).to_natural_32
				end
				l_break := True
			end
			l_break := False
			Result := l___gmp_c
		end

	gmpn_cmp (a___gmp_xp, a___gmp_yp: CE_POINTER [NATURAL_32]; a___gmp_size: INTEGER_32): INTEGER_32
		local
			l___gmp_result: INTEGER_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_y: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l___gmp_result := 0
				l___gmp_i := a___gmp_size
				from
				until
					(l_break)
				loop
					l_break := False
					l___gmp_i := l___gmp_i - 1
					if not (l___gmp_i >= 0) then
						l_break := True
					end
					if not (l_break) then
						l___gmp_x := a___gmp_xp[l___gmp_i]
						l___gmp_y := a___gmp_yp[l___gmp_i]
						if l___gmp_x /= l___gmp_y then
							if l___gmp_x > l___gmp_y then
								l___gmp_result := 1
							else
								l___gmp_result := -1
							end
							l_break := True
						end
					end
				end
				l_break := False
				l_break := True
			end
			l_break := False
			Result := l___gmp_result
		end

	gmpn_sub (a___gmp_wp, a___gmp_xp: CE_POINTER [NATURAL_32]; a___gmp_xsize: INTEGER_32; a___gmp_yp: CE_POINTER [NATURAL_32]; a___gmp_ysize: INTEGER_32): NATURAL_32
		local
			l___gmp_c: NATURAL_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l_tmp: INTEGER_32
			l___gmp_j: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (l_return or l_break) then
						l_pos := -1 + 9 -- skip loop
					end
				when 1 then -- loop body:
						l_break := False
						l___gmp_i := a___gmp_ysize
						if l___gmp_i = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if not ((gmpn_sub_n (a___gmp_wp, a___gmp_xp, a___gmp_yp, l___gmp_i)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						if l___gmp_i >= a___gmp_xsize then
							l___gmp_c := (1).to_natural_32
							l_pos := -1 + 8 -- goto __gmp_done
						end
				when 5 then
						l___gmp_x := a___gmp_xp[l___gmp_i]
						l_tmp := l___gmp_i
						l___gmp_i := l___gmp_i + 1
						a___gmp_wp[l_tmp] := ((l___gmp_x - {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
						if l___gmp_x /= {NATURAL_32} 0 then
							l_break := True
						end
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						l_break := False
				when 7 then -- if done | if done
						if not a___gmp_wp.is_equal (a___gmp_xp) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l___gmp_j := l___gmp_i
								from
								until
									not (l___gmp_j < a___gmp_xsize)
								loop
									a___gmp_wp[l___gmp_j] := a___gmp_xp[l___gmp_j]
									l___gmp_j := l___gmp_j + 1
								end
								l_break := True
							end
							l_break := False
						end
						l___gmp_c := (0).to_natural_32
				when 8 then -- __gmp_done:
						
						l_break := True
						l_pos := -1 + 0 -- back to loop condition
				when 9 then -- loop done
					l_break := False
					Result := l___gmp_c
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_sub_1 (a___gmp_dst, a___gmp_src: CE_POINTER [NATURAL_32]; a___gmp_size: INTEGER_32; a___gmp_n: NATURAL_32): NATURAL_32
		require
			not a___gmp_dst.is_void
			not a___gmp_src.is_void
		local
			l___gmp_c: NATURAL_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_r: NATURAL_32
			l___gmp_j: INTEGER_32
			l___gmp_j___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l___gmp_x := a___gmp_src[0]
				l___gmp_r := l___gmp_x - a___gmp_n
				a___gmp_dst[0] := l___gmp_r
				if l___gmp_x < a___gmp_n then
					l___gmp_c := (1).to_natural_32
					l___gmp_i := (1).to_integer_32
					from
					until
						not (not (l_return or l_break) and then (l___gmp_i < a___gmp_size))
					loop
						l_break := False
						l___gmp_x := a___gmp_src[l___gmp_i]
						l___gmp_r := l___gmp_x - {NATURAL_32} 1
						a___gmp_dst[l___gmp_i] := l___gmp_r
						l___gmp_i := l___gmp_i + 1
						if not (l___gmp_x < {NATURAL_32} 1) then
							if not a___gmp_src.is_equal (a___gmp_dst) then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l___gmp_j := l___gmp_i
									from
									until
										not (l___gmp_j < a___gmp_size)
									loop
										a___gmp_dst[l___gmp_j] := a___gmp_src[l___gmp_j]
										l___gmp_j := l___gmp_j + 1
									end
									l_break := True
								end
								l_break := False
							end
							l___gmp_c := (0).to_natural_32
							l_break := True
						end
					end
					l_break := False
				else
					if not a___gmp_src.is_equal (a___gmp_dst) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___gmp_j___0 := (1).to_integer_32
							from
							until
								not (l___gmp_j___0 < a___gmp_size)
							loop
								a___gmp_dst[l___gmp_j___0] := a___gmp_src[l___gmp_j___0]
								l___gmp_j___0 := l___gmp_j___0 + 1
							end
							l_break := True
						end
						l_break := False
					end
					l___gmp_c := (0).to_natural_32
				end
				l_break := True
			end
			l_break := False
			Result := l___gmp_c
		end

	gmpn_neg (a___gmp_rp, a___gmp_up: CE_POINTER [NATURAL_32]; a___gmp_n: INTEGER_32): NATURAL_32
		require
			not a___gmp_rp.is_void
			not a___gmp_up.is_void
		local
			l___gmp_rp: CE_POINTER [NATURAL_32]
			l___gmp_up: CE_POINTER [NATURAL_32]
			l___gmp_n: INTEGER_32
			l___gmp_ul: NATURAL_32
			l___gmp_cy: NATURAL_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_tmp___0: CE_POINTER [NATURAL_32]
			l_break: BOOLEAN
		do
			l___gmp_rp := a___gmp_rp
			l___gmp_up := a___gmp_up
			l___gmp_n := a___gmp_n
			l___gmp_cy := (0).to_natural_32
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp := l___gmp_up
				l___gmp_up := l___gmp_up + 1
				l___gmp_ul := l_tmp.item
				l_tmp___0 := l___gmp_rp
				l___gmp_rp := l___gmp_rp + 1
				l_tmp___0.item := (-l___gmp_ul.to_integer_32).to_natural_32 - l___gmp_cy
				l___gmp_cy := (l___gmp_cy).bit_or ((l___gmp_ul /= {NATURAL_32} 0).to_integer.to_natural_32)
				l___gmp_n := l___gmp_n - 1
				if l___gmp_n = 0 then
					l_break := True
				end
			end
			l_break := False
			Result := l___gmp_cy
		end

	gmpn_divrem_1 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32; a_arg5: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_divrem_1 (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4, a_arg5)
		end

	c_gmpn_divrem_1 (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER; a_arg4: INTEGER_32; a_arg5: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_divrem_1($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	gmpn_lshift (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_lshift (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_lshift (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_lshift($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_rshift (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_rshift (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_rshift (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_rshift($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_copyi (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32)
		do
			c_gmpn_copyi (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_gmpn_copyi (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32)
		external
			"C inline use <libgmp.h>"
		alias
			"__gmpn_copyi($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_mul_1 (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_mul_1 (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_mul_1 (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_mul_1($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_copyd (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32)
		do
			c_gmpn_copyd (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_gmpn_copyd (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32)
		external
			"C inline use <libgmp.h>"
		alias
			"__gmpn_copyd($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_addmul_1 (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_addmul_1 (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_addmul_1 (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_addmul_1($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_submul_1 (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_submul_1 (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_submul_1 (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_submul_1($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_divrem_2 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32; a_arg5: CE_POINTER [NATURAL_32]): NATURAL_32
		do
			Result := c_gmpn_divrem_2 (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4, a_arg5.c_pointer)
		end

	c_gmpn_divrem_2 (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER; a_arg4: INTEGER_32; a_arg5: POINTER): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_divrem_2($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

end
