class
	P_OBPRNTFFUNS_STATIC

inherit
	CE_UTILITIES
	S_OBSTACK_STATIC
	S_STRING_STATIC
	S_STDIO_STATIC

feature {ANY} -- public attributes

	gmp_obstack_printf_funs: CE_STATIC [CE_ARRAY [PD_DOPRNT_FUNS_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_DOPRNT_FUNS_T]}.make_initialized (<<
					create {PD_DOPRNT_FUNS_T}.make_initialized ([(obstack_vprintf_address), (gmp_obstack_memory_address), (gmp_obstack_reps_address), create {CE_ROUTINE}.make_shared (default_pointer)])
				>>)
		end

feature {ANY} -- public routines

	gmp_obstack_memory (a_ob: CE_POINTER [SD_OBSTACK]; a_ptr: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): INTEGER_32
		require
			not a_ob.is_void
		local
			l___o: CE_POINTER [SD_OBSTACK]
			l___len: INTEGER_32
		do
			l___o := a_ob
			l___len := a_len.to_integer_32
			if ((l___o.item.next_free + l___len).c_pointer.to_integer_32).to_natural_32 > ((l___o.item.chunk_limit).c_pointer.to_integer_32).to_natural_32 then
				obstack_newchunk (l___o, l___len)
			end
			memcpy (create {CE_VOID_POINTER}.make_cast (l___o.item.next_free), create {CE_VOID_POINTER}.make_cast (a_ptr), l___len.to_natural_32).do_nothing
			l___o.item.next_free := l___o.item.next_free + l___len
			Result := a_len.to_integer_32
		end

	gmp_obstack_reps (a_ob: CE_POINTER [SD_OBSTACK]; a_c, a_reps: INTEGER_32): INTEGER_32
		require
			not a_ob.is_void
		local
			l___o: CE_POINTER [SD_OBSTACK]
			l___len: INTEGER_32
		do
			l___o := a_ob
			l___len := a_reps
			if (l___o.item.chunk_limit).distance ((l___o.item.next_free)) < l___len then
				obstack_newchunk (l___o, l___len)
			end
			l___o.item.next_free := l___o.item.next_free + l___len
			memset (create {CE_VOID_POINTER}.make_cast ((a_ob.item.next_free - a_reps)), a_c, a_reps.to_natural_32).do_nothing
			Result := a_reps
		end

feature {ANY} -- routine addresses

	gmp_obstack_memory_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gmp_obstack_memory)
		end

	gmp_obstack_reps_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gmp_obstack_reps)
		end

end
