class
	P_REMOVE_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_remove (a_dest, a_src, a_f: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		require
			not a_src.is_void
			not a_f.is_void
		local
			l_fpow: CE_ARRAY [CE_ARRAY [PD_MPZ_STRUCT]]
			l_x___2: CE_ARRAY [PD_MPZ_STRUCT]
			l_rem: CE_ARRAY [PD_MPZ_STRUCT]
			l_pwr: NATURAL_32
			l_p: INTEGER_32
			l_s0: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_ARRAY_ARRAY [PD_MPZ_STRUCT]} l_fpow.make (<<32, 1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_x___2.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_rem.make (<<1>>)

			if (a_f.item.gmpz_cmp_ui ({NATURAL_32} 1)) <= 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
			end
			if a_src.item.mp_size = 0 then
				if not a_src.is_equal (a_dest) then
					a_dest.item.gmpz_set (a_src)
				end
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				if (a_f.item.gmpz_cmp_ui ({NATURAL_32} 2)) = 0 then
					l_s0 := a_src.item.gmpz_scan1 ((0).to_natural_32)
					a_dest.item.gmpz_fdiv_q_2exp (a_src, l_s0)
					Result := l_s0
					l_return := True
				end
			end
			if not l_return then
				l_rem.item.gmpz_init
				l_x___2.item.gmpz_init
				l_pwr := (0).to_natural_32;
				(l_fpow[0]).item.gmpz_init;
				(l_fpow[0]).item.gmpz_set (a_f)
				a_dest.item.gmpz_set (a_src)
				l_p := 0
				from
				until
					(l_break)
				loop
					l_break := False;
					(create {P_TDIV_QR_STATIC}).gmpz_tdiv_qr (l_x___2, l_rem, a_dest, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_fpow[l_p])))
					if l_rem[0].mp_size /= 0 then
						l_break := True
					end
					if not (l_break) then
						(l_fpow[l_p + 1]).item.gmpz_init;
						(l_fpow[l_p + 1]).item.gmpz_mul (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_fpow[l_p])), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_fpow[l_p])))
						a_dest.item.gmpz_set (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x___2))
						l_p := l_p + 1
					end
				end
				l_break := False
				l_pwr := (((1).bit_shift_left (l_p)) - 1).to_natural_32;
				(l_fpow[l_p]).item.gmpz_clear
				from
				until
					(l_break)
				loop
					l_break := False
					l_p := l_p - 1
					if not (l_p >= 0) then
						l_break := True
					end
					if not (l_break) then
						(create {P_TDIV_QR_STATIC}).gmpz_tdiv_qr (l_x___2, l_rem, a_dest, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_fpow[l_p])))
						if l_rem[0].mp_size = 0 then
							l_pwr := l_pwr + ((1).bit_shift_left (l_p)).to_natural_32
							a_dest.item.gmpz_set (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x___2))
						end
						(l_fpow[l_p]).item.gmpz_clear
					end
				end
				l_break := False
				l_x___2.item.gmpz_clear
				l_rem.item.gmpz_clear
				Result := l_pwr
			end
		end

	gmpn_remove (a_wp: CE_POINTER [NATURAL_32]; a_wn: CE_POINTER [INTEGER_32]; a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_vp: CE_POINTER [NATURAL_32]; a_vn: INTEGER_32; a_cap: NATURAL_32): NATURAL_32
		require
			not a_wn.is_void
		local
			l_pwpsp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_pwpsn: CE_ARRAY [INTEGER_32]
			l_npowers: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_pp: CE_POINTER [NATURAL_32]
			l_qp2: CE_POINTER [NATURAL_32]
			l_scratch_out: CE_POINTER [NATURAL_32]
			l_pn: INTEGER_32
			l_nn: INTEGER_32
			l_qn: INTEGER_32
			l_i: INTEGER_32
			l_pwr: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___12: CE_POINTER [ANY]
			l_tmp___17: CE_POINTER [ANY]
			l_tmp___25: CE_POINTER [ANY]
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l_return, l_break, l_continue: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_pwpsp.make (<<32>>)
			create {CE_INTEGER_32_ARRAY} l_pwpsn.make (<<32>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			if (builtin_expect ((((a_un + a_vn) // 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___2 := (l_aaf.new ((((a_un + a_vn) // 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___2 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (((a_un + a_vn) // 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
			if (builtin_expect ((a_un.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___7 := (l_aaf.new ((a_un.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___7 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (a_un.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_qp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___7)
			if (builtin_expect ((a_un.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___12 := (l_aaf.new ((a_un.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___12 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (a_un.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_qp2 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___12)
			if (builtin_expect (((a_un + 32).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___17 := (l_aaf.new (((a_un + 32).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___17 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((a_un + 32).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_np := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___17)
			l_pp := a_vp
			l_pn := a_vn
			if (builtin_expect ((((create {P_BDIV_QR_STATIC}).gmpn_bdiv_qr_itch (a_un, (a_un).bit_shift_right (1))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___25 := (l_aaf.new ((((create {P_BDIV_QR_STATIC}).gmpn_bdiv_qr_itch (a_un, (a_un).bit_shift_right (1))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___25 := ((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (((create {P_BDIV_QR_STATIC}).gmpn_bdiv_qr_itch (a_un, (a_un).bit_shift_right (1))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_scratch_out := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___25)
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (l_qp, a_up, a_un)
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			l_qn := a_un
			l_npowers := (0).to_integer_32
			from
			until
				not (not (l_return or l_break) and then (l_qn >= l_pn))
			loop
				l_break := False;
				(create {P_BDIV_QR_STATIC}).gmpn_bdiv_qr (l_qp2, l_tp, l_qp, l_qn, l_pp, l_pn, l_scratch_out).do_nothing
				if not ((create {P_GMP_IMPL_STATIC}).mpn_zero_p (l_tp, l_pn)).to_boolean then
					l_break := True
				end
				if not (l_return or l_break) then
					from
					until
						(l_break)
					loop
						l_break := False
						l___mp_ptr_swap__tmp := l_qp
						l_qp := l_qp2
						l_qp2 := l___mp_ptr_swap__tmp
						l_break := True
					end
					l_break := False
					l_qn := l_qn - l_pn
					l_qn := l_qn + (l_qp[l_qn] /= {NATURAL_32} 0).to_integer
					l_pwpsp[l_npowers] := l_pp
					l_pwpsn[l_npowers] := l_pn
					l_npowers := l_npowers + 1
					if (({NATURAL_32} 2).bit_shift_left (l_npowers)) - {NATURAL_32} 1 > a_cap then
						l_break := True
					end
				end
				if not (l_return or l_break) then
					l_nn := 2 * l_pn - 1
					if l_nn > l_qn then
						l_break := True
					end
				end
				if not (l_return or l_break) then
					(create {P_SQR_STATIC}).gmpn_sqr (l_np, l_pp, l_pn)
					l_nn := l_nn + (l_np[l_nn] /= {NATURAL_32} 0).to_integer
					l_pp := l_np
					l_pn := l_nn
					l_np := l_np + l_nn
				end
			end
			l_break := False
			l_pwr := (({NATURAL_32} 1).bit_shift_left (l_npowers)) - {NATURAL_32} 1
			l_i := l_npowers - 1
			from
			until
				not (not (l_return) and then (l_i >= 0))
			loop
				l_continue := False
				l_pp := l_pwpsp[l_i]
				l_pn := l_pwpsn[l_i]
				if l_qn < l_pn then
					l_continue := True
				end
				if not (l_return or l_break or l_continue) and then (l_pwr + (({NATURAL_32} 1).bit_shift_left (l_i)) > a_cap) then
					l_continue := True
				end
				if not (l_return or l_break or l_continue) then
					(create {P_BDIV_QR_STATIC}).gmpn_bdiv_qr (l_qp2, l_tp, l_qp, l_qn, l_pp, l_pn, l_scratch_out).do_nothing
					if not ((create {P_GMP_IMPL_STATIC}).mpn_zero_p (l_tp, l_pn)).to_boolean then
						l_continue := True
					end
				end
				if not (l_return or l_break or l_continue) then
					from
					until
						(l_break)
					loop
						l_break := False
						l___mp_ptr_swap__tmp___0 := l_qp
						l_qp := l_qp2
						l_qp2 := l___mp_ptr_swap__tmp___0
						l_break := True
					end
					l_break := False
					l_qn := l_qn - l_pn
					l_qn := l_qn + (l_qp[l_qn] /= {NATURAL_32} 0).to_integer
					l_pwr := l_pwr + (({NATURAL_32} 1).bit_shift_left (l_i))
				end
				if (not l_return) then
					l_i := l_i - 1
				end
			end
			l_continue := False
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (a_wp, l_qp, l_qn)
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			a_wn.item := l_qn
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
				end
				l_break := True
			end
			l_break := False
			Result := l_pwr
		end

end
