class
	PD_DOPRNT_FUNS_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_CTYPE_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_LANGINFO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create format.make
			create memory.make
			create reps.make
			create final.make
			Precursor
		end

feature {ANY} -- fields

	format: CE_ROUTINE assign set_format

	memory: CE_ROUTINE assign set_memory

	reps: CE_ROUTINE assign set_reps

	final: CE_ROUTINE assign set_final

feature {ANY} -- field setters

	set_format (a_format: CE_ROUTINE)
		do
			format := a_format
			update_memory_field ("format")
		end

	set_memory (a_memory: CE_ROUTINE)
		do
			memory := a_memory
			update_memory_field ("memory")
		end

	set_reps (a_reps: CE_ROUTINE)
		do
			reps := a_reps
			update_memory_field ("reps")
		end

	set_final (a_final: CE_ROUTINE)
		do
			final := a_final
			update_memory_field ("final")
		end

feature {ANY} -- public routines

	gmp_doprnt_mpf2 (a_data: CE_POINTER [ANY]; a_p: CE_POINTER [PD_DOPRNT_PARAMS_T]; a_point: CE_POINTER [INTEGER_8]; a_f: CE_POINTER [PD_MPF_STRUCT]): INTEGER_32
		require
			not a_p.is_void
			not a_f.is_void
		local
			l_prec: INTEGER_32
			l_ndigits: INTEGER_32
			l_free_size: INTEGER_32
			l_len: INTEGER_32
			l_newlen: INTEGER_32
			l_justify: INTEGER_32
			l_justlen: INTEGER_32
			l_explen: INTEGER_32
			l_showbaselen: INTEGER_32
			l_sign: INTEGER_32
			l_signlen: INTEGER_32
			l_intlen: INTEGER_32
			l_intzeros: INTEGER_32
			l_pointlen: INTEGER_32
			l_fraczeros: INTEGER_32
			l_fraclen: INTEGER_32
			l_preczeros: INTEGER_32
			l_s: CE_POINTER [INTEGER_8]
			l_free_ptr: CE_POINTER [INTEGER_8]
			l_exp: CE_ARRAY [INTEGER_32]
			l_exponent: CE_ARRAY [INTEGER_8]
			l_showbase: CE_POINTER [INTEGER_8]
			l_retval: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: NATURAL_32
			l_num_to_text: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_base: INTEGER_32
			l_tmp___3: INTEGER_32
			l_n: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___8: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___11: INTEGER_32
			l_tmp___12: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___13: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_expval: INTEGER_32
			l_expsign: INTEGER_8
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: NATURAL_32
			l___ret: INTEGER_32
			l___ret___0: INTEGER_32
			l___ret___1: INTEGER_32
			l___ret___2: INTEGER_32
			l___ret___3: INTEGER_32
			l___ret___4: INTEGER_32
			l___ret___5: INTEGER_32
			l___ret___6: INTEGER_32
			l___ret___7: INTEGER_32
			l___ret___8: INTEGER_32
			l___ret___9: INTEGER_32
			l___ret___10: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_exp.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_exponent.make (<<42>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := 0
					l_prec := a_p.item.prec
					if not (l_prec <= -1) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_ndigits := 0
						if a_p.item.conv = 3 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if a_p.item.base >= 0 then
									l_tmp := a_p.item.base
								else
									l_tmp := -a_p.item.base
								end
								l_prec := ({NATURAL_32} 2 + (((l_tmp.to_natural_32 - {NATURAL_32} 1) * {NATURAL_32} 32).to_real_64 * (create {P_MP_BASES_STATIC}).gmpn_bases.item[a_f.item.mp_prec].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32).to_integer_32
								l_break := True
							end
							l_break := False
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						inspect a_p.item.conv -- switch 1 head
						when 1 then l_pos := -1 + 4
						when 2 then l_pos := -1 + 5
						when 3 then l_pos := -1 + 6
						else l_pos := -1 + 6
						end
				when 4 then -- switch 1, case 1
						if a_p.item.base >= 0 then
							l_tmp___0 := a_p.item.base
						else
							l_tmp___0 := -a_p.item.base
						end
						l_ndigits := ((l_prec + 2).to_integer_32 + a_f.item.mp_exp * ((create {P_MP_BASES_STATIC}).gmpn_bases.item[l_tmp___0].chars_per_limb + (a_f.item.mp_exp >= 0).to_integer).to_integer_32).to_integer_32
						if l_ndigits > 1 then
							l_ndigits := l_ndigits
						else
							l_ndigits := 1
						end
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 2
						l_ndigits := l_prec + 1
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default: | switch 1, case 3
						if l_prec > 1 then
							l_ndigits := l_prec
						else
							l_ndigits := 1
						end
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done: | if done
					l_s := a_f.item.gmpf_get_str (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), l_exp, a_p.item.base, l_ndigits.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___1 := strlen (l_s)
					update_class_fields -- Current might have been changed; synchronize
					l_len := l_tmp___1.to_integer_32
					l_free_ptr := l_s
					l_free_size := l_len + 1
					l_sign := (a_p.item.sign).to_integer_32
					if (l_s[0]).to_integer_32 = 45 then
						l_sign := (l_s[0]).to_integer_32
						l_s := l_s + 1
						l_len := l_len - 1
					end
					l_signlen := (l_sign /= 0).to_integer
					inspect a_p.item.conv -- switch 2 head
					when 1 then l_pos := -1 + 8
					when 2 then l_pos := -1 + 10
					when 3 then l_pos := -1 + 12
					else l_pos := -1 + 12
					end
				when 8 then -- switch 2, case 1
					if l_prec <= -1 then
						if 0 > l_len.to_integer_32 - l_exp.item then
							l_prec := 0
						else
							l_prec := (l_len.to_integer_32 - l_exp.item).to_integer_32
						end
					end
					l_newlen := (l_exp.item + l_prec.to_integer_32).to_integer_32
					if l_newlen < 0 then
						l_len := 0
						l_exp.item := (0).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					elseif not (l_len <= l_newlen) then
						if a_p.item.base >= 0 then
							l_tmp___2 := ce_string ("0123456789abcdefghijklmnopqrstuvwxyz")
						else
							l_tmp___2 := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ")
						end
						l_num_to_text := l_tmp___2
						if a_p.item.base >= 0 then
							l_tmp___3 := a_p.item.base
						else
							l_tmp___3 := -a_p.item.base
						end
						l_base := l_tmp___3
						l_len := l_newlen
						l_tmp___8 := ctype_b_loc
						update_class_fields -- Current might have been changed; synchronize
						if (((l_tmp___8.item[(l_s[l_len]).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
							l_n := (l_s[l_len]).to_integer_32 - 48
						else
							l_tmp___7 := ctype_b_loc
							update_class_fields -- Current might have been changed; synchronize
							if (((l_tmp___7.item[(l_s[l_len]).to_integer_32]).to_integer_32).bit_and (512)).to_boolean then
								l_tmp___6 := ((l_s[l_len]).to_integer_32 - 97) + 10
							else
								l_tmp___6 := ((l_s[l_len]).to_integer_32 - 65) + 10
							end
							l_n := l_tmp___6
						end
						if l_n >= (l_base + 1) // 2 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_len = 0 then
									l_s[0] := (('1').code).to_integer_8
									update_class_fields -- Current might have been changed; synchronize
									l_len := 1
									l_exp.item := l_exp.item + 1
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
								if not (l_return or l_break) then
									l_tmp___13 := ctype_b_loc
									update_class_fields -- Current might have been changed; synchronize
									if (((l_tmp___13.item[(l_s[(l_len - 1)]).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
										l_n := (l_s[(l_len - 1)]).to_integer_32 - 48
									else
										l_tmp___12 := ctype_b_loc
										update_class_fields -- Current might have been changed; synchronize
										if (((l_tmp___12.item[(l_s[(l_len - 1)]).to_integer_32]).to_integer_32).bit_and (512)).to_boolean then
											l_tmp___11 := ((l_s[(l_len - 1)]).to_integer_32 - 97) + 10
										else
											l_tmp___11 := ((l_s[(l_len - 1)]).to_integer_32 - 65) + 10
										end
										l_n := l_tmp___11
									end
									l_n := l_n + 1
									if l_n /= l_base then
										l_s[(l_len - 1)] := l_num_to_text[l_n]
										update_class_fields -- Current might have been changed; synchronize
										l_break := True
									end
								end
								if not (l_return or l_break) then
									l_len := l_len - 1
								end
							end
							l_break := False
						else
							from
							until
								(l_break)
							loop
								l_break := False
								if l_len > 0 then
									if (l_s[(l_len - 1)]).to_integer_32 /= 48 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_len := l_len - 1
								end
							end
							l_break := False
						end
						if l_len = 0 then
							l_exp.item := (0).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				when 9 then -- fixed:
					
					if l_exp.item <= 0 then
						l_intlen := 0
						l_intzeros := 1
						l_fraczeros := (-l_exp.item).to_integer_32
						l_fraclen := l_len
					else
						if l_len.to_integer_32 < l_exp.item then
							l_intlen := l_len
						else
							l_intlen := (l_exp.item).to_integer_32
						end
						l_intzeros := (l_exp.item - l_intlen.to_integer_32).to_integer_32
						l_fraczeros := 0
						l_fraclen := l_len - l_intlen
					end
					l_explen := 0
					l_pos := -1 + 13 -- switch 2; break
				when 10 then -- switch 2, case 2
					if l_prec <= -1 then
						if 0 > l_len - 1 then
							l_prec := 0
						else
							l_prec := l_len - 1
						end
					end
				when 11 then -- scientific:
					
					if 1 < l_len then
						l_intlen := 1
					else
						l_intlen := l_len
					end
					if l_intlen = 0 then
						l_intzeros := 1
					else
						l_intzeros := 0
					end
					l_fraczeros := 0
					l_fraclen := l_len - l_intlen
					l_expval := l_exp.item - l_intlen.to_integer_32
					if (a_p.item.exptimes4).to_boolean then
						l_expval := (l_expval).bit_shift_left ((2))
					end
					if l_expval >= 0 then
						l_expsign := (('+').code).to_integer_8
					else
						l_expsign := (('-').code).to_integer_8
					end
					if l_expval >= 0 then
						l_expval := l_expval
					else
						l_expval := -l_expval
					end
					l_explen := snprintf ([l_exponent, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (42).to_natural_32), a_p.item.expfmt, l_expsign.to_integer_32, l_expval])
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 13 -- switch 2; break
				when 12 then -- switch 2, default: | switch 2, case 3
					if l_exp.item - 1 < -4 then
						l_pos := -1 + 11 -- goto scientific
					else
						if 1 > l_prec then
							l_tmp___14 := 1
						else
							l_tmp___14 := l_prec
						end
						if l_exp.item - 1 >= l_tmp___14.to_integer_32 then
							l_pos := -1 + 11 -- goto scientific
						else
							l_pos := -1 + 9 -- goto fixed
						end
					end
				when 13 then -- switch 2, done:
					if (a_p.item.showtrailing).to_boolean then
						if a_p.item.conv = 3 then
							l_tmp___15 := l_intlen + l_intzeros
						else
							l_tmp___15 := 0
						end
						l_preczeros := l_prec - ((l_fraczeros + l_fraclen) + l_tmp___15)
						if 0 > l_preczeros then
							l_preczeros := 0
						else
							l_preczeros := l_preczeros
						end
					else
						l_preczeros := 0
					end
					if (l_fraczeros + l_fraclen) + l_preczeros /= 0 then
						l_tmp___16 := strlen (a_point)
						update_class_fields -- Current might have been changed; synchronize
						l_pointlen := l_tmp___16.to_integer_32
					elseif a_p.item.showpoint /= 0 then
						l_tmp___16 := strlen (a_point)
						update_class_fields -- Current might have been changed; synchronize
						l_pointlen := l_tmp___16.to_integer_32
					else
						l_pointlen := 0
					end
					l_showbase := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_showbaselen := 0
					inspect a_p.item.showbase -- switch 3 head
					when 2 then l_pos := -1 + 14
					when 3 then l_pos := -1 + 15
					when 1 then l_pos := -1 + 16
					else l_pos := -1 + 14
					end
				when 14 then -- switch 3, default: | switch 3, case 2
					l_pos := -1 + 21 -- switch 3; break
				when 15 then -- switch 3, case 3
					if l_intlen = 0 then
						if l_fraclen = 0 then
							l_pos := -1 + 21 -- switch 3; break
						end
					end
				when 16 then -- switch 3, case 1
					inspect a_p.item.base -- switch 4 head
					when 16 then l_pos := -1 + 17
					when -16 then l_pos := -1 + 18 -- -16
					when 8 then l_pos := -1 + 19
					else l_pos := -1 + 20
					end
				when 17 then -- switch 4, case 16
					l_showbase := ce_string ("0x")
					l_showbaselen := 2
					l_pos := -1 + 20 -- switch 4; break
				when 18 then -- switch 4, case -16
					l_showbase := ce_string ("0X")
					l_showbaselen := 2
					l_pos := -1 + 20 -- switch 4; break
				when 19 then -- switch 4, case 8
					l_showbase := ce_string ("0")
					l_showbaselen := 1
					l_pos := -1 + 20 -- switch 4; break
				when 20 then -- switch 4, done:
					l_pos := -1 + 21 -- switch 3; break
				when 21 then -- switch 3, done:
					l_justlen := (a_p.item.width - ((((((((l_signlen + l_showbaselen) + l_intlen) + l_intzeros) + l_pointlen) + l_fraczeros) + l_fraclen) + l_preczeros) + l_explen))
					l_justify := a_p.item.justify
					if l_justlen <= 0 then
						l_justify := 0
					end
					if l_justify /= 2 then
						l_pos := -1 + 29 -- skip if block
					end
				when 22 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 28 -- skip loop
						end
				when 23 then -- loop body:
						l_break := False
				when 24 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 27 -- skip loop
						end
				when 25 then -- loop body:
						l_break := False
						l___ret := reps.integer_32_item ([a_data, (a_p.item.fill).to_integer_32, l_justlen])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret = -1 then
							l_pos := -1 + 136 -- goto error
						end
				when 26 then
						l_retval := l_retval + l___ret
						l_break := True
						l_pos := -1 + 24 -- back to loop condition
				when 27 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 22 -- back to loop condition
				when 28 then -- loop done
						l_break := False
				when 29 then -- if done
					if not (l_signlen.to_boolean) then
						l_pos := -1 + 37 -- skip if block
					end
				when 30 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 36 -- skip loop
						end
				when 31 then -- loop body:
						l_break := False
				when 32 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 35 -- skip loop
						end
				when 33 then -- loop body:
						l_break := False
						l___ret___0 := reps.integer_32_item ([a_data, l_sign, 1])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___0 = -1 then
							l_pos := -1 + 136 -- goto error
						end
				when 34 then
						l_retval := l_retval + l___ret___0
						l_break := True
						l_pos := -1 + 32 -- back to loop condition
				when 35 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 30 -- back to loop condition
				when 36 then -- loop done
						l_break := False
				when 37 then -- if done
					if (l_return or l_break) then
						l_pos := -1 + 47 -- skip loop
					end
				when 38 then -- loop body:
						l_break := False
						if l_showbaselen = 0 then
							l_pos := -1 + 46 -- skip if block
						end
				when 39 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 45 -- skip loop
						end
				when 40 then -- loop body:
						l_break := False
				when 41 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 44 -- skip loop
						end
				when 42 then -- loop body:
						l_break := False
						l___ret___1 := memory.integer_32_item ([a_data, l_showbase, l_showbaselen.to_natural_32])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___1 = -1 then
							l_pos := -1 + 136 -- goto error
						end
				when 43 then
						l_retval := l_retval + l___ret___1
						l_break := True
						l_pos := -1 + 41 -- back to loop condition
				when 44 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 39 -- back to loop condition
				when 45 then -- loop done
						l_break := False
				when 46 then -- if done
						l_break := True
						l_pos := -1 + 37 -- back to loop condition
				when 47 then -- loop done
					l_break := False
					if l_justify /= 3 then
						l_pos := -1 + 55 -- skip if block
					end
				when 48 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 54 -- skip loop
						end
				when 49 then -- loop body:
						l_break := False
				when 50 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 53 -- skip loop
						end
				when 51 then -- loop body:
						l_break := False
						l___ret___2 := reps.integer_32_item ([a_data, (a_p.item.fill).to_integer_32, l_justlen])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___2 = -1 then
							l_pos := -1 + 136 -- goto error
						end
				when 52 then
						l_retval := l_retval + l___ret___2
						l_break := True
						l_pos := -1 + 50 -- back to loop condition
				when 53 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 48 -- back to loop condition
				when 54 then -- loop done
						l_break := False
				when 55 then -- if done
					if (l_return or l_break) then
						l_pos := -1 + 61 -- skip loop
					end
				when 56 then -- loop body:
						l_break := False
				when 57 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 60 -- skip loop
						end
				when 58 then -- loop body:
						l_break := False
						l___ret___3 := memory.integer_32_item ([a_data, l_s, l_intlen.to_natural_32])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___3 = -1 then
							l_pos := -1 + 136 -- goto error
						end
				when 59 then
						l_retval := l_retval + l___ret___3
						l_break := True
						l_pos := -1 + 57 -- back to loop condition
				when 60 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 55 -- back to loop condition
				when 61 then -- loop done
					l_break := False
				when 62 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 72 -- skip loop
					end
				when 63 then -- loop body:
						l_break := False
						if l_intzeros = 0 then
							l_pos := -1 + 71 -- skip if block
						end
				when 64 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 70 -- skip loop
						end
				when 65 then -- loop body:
						l_break := False
				when 66 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 69 -- skip loop
						end
				when 67 then -- loop body:
						l_break := False
						l___ret___4 := reps.integer_32_item ([a_data, ('0').code, l_intzeros])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___4 = -1 then
							l_pos := -1 + 136 -- goto error
						end
				when 68 then
						l_retval := l_retval + l___ret___4
						l_break := True
						l_pos := -1 + 66 -- back to loop condition
				when 69 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 64 -- back to loop condition
				when 70 then -- loop done
						l_break := False
				when 71 then -- if done
						l_break := True
						l_pos := -1 + 62 -- back to loop condition
				when 72 then -- loop done
					l_break := False
				when 73 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 83 -- skip loop
					end
				when 74 then -- loop body:
						l_break := False
						if l_pointlen = 0 then
							l_pos := -1 + 82 -- skip if block
						end
				when 75 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 81 -- skip loop
						end
				when 76 then -- loop body:
						l_break := False
				when 77 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 80 -- skip loop
						end
				when 78 then -- loop body:
						l_break := False
						l___ret___5 := memory.integer_32_item ([a_data, a_point, l_pointlen.to_natural_32])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___5 = -1 then
							l_pos := -1 + 136 -- goto error
						end
				when 79 then
						l_retval := l_retval + l___ret___5
						l_break := True
						l_pos := -1 + 77 -- back to loop condition
				when 80 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 75 -- back to loop condition
				when 81 then -- loop done
						l_break := False
				when 82 then -- if done
						l_break := True
						l_pos := -1 + 73 -- back to loop condition
				when 83 then -- loop done
					l_break := False
				when 84 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 94 -- skip loop
					end
				when 85 then -- loop body:
						l_break := False
						if l_fraczeros = 0 then
							l_pos := -1 + 93 -- skip if block
						end
				when 86 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 92 -- skip loop
						end
				when 87 then -- loop body:
						l_break := False
				when 88 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 91 -- skip loop
						end
				when 89 then -- loop body:
						l_break := False
						l___ret___6 := reps.integer_32_item ([a_data, ('0').code, l_fraczeros])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___6 = -1 then
							l_pos := -1 + 136 -- goto error
						end
				when 90 then
						l_retval := l_retval + l___ret___6
						l_break := True
						l_pos := -1 + 88 -- back to loop condition
				when 91 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 86 -- back to loop condition
				when 92 then -- loop done
						l_break := False
				when 93 then -- if done
						l_break := True
						l_pos := -1 + 84 -- back to loop condition
				when 94 then -- loop done
					l_break := False
				when 95 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 105 -- skip loop
					end
				when 96 then -- loop body:
						l_break := False
						if l_fraclen = 0 then
							l_pos := -1 + 104 -- skip if block
						end
				when 97 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 103 -- skip loop
						end
				when 98 then -- loop body:
						l_break := False
				when 99 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 102 -- skip loop
						end
				when 100 then -- loop body:
						l_break := False
						l___ret___7 := memory.integer_32_item ([a_data, (l_s + l_intlen), l_fraclen.to_natural_32])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___7 = -1 then
							l_pos := -1 + 136 -- goto error
						end
				when 101 then
						l_retval := l_retval + l___ret___7
						l_break := True
						l_pos := -1 + 99 -- back to loop condition
				when 102 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 97 -- back to loop condition
				when 103 then -- loop done
						l_break := False
				when 104 then -- if done
						l_break := True
						l_pos := -1 + 95 -- back to loop condition
				when 105 then -- loop done
					l_break := False
				when 106 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 116 -- skip loop
					end
				when 107 then -- loop body:
						l_break := False
						if l_preczeros = 0 then
							l_pos := -1 + 115 -- skip if block
						end
				when 108 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 114 -- skip loop
						end
				when 109 then -- loop body:
						l_break := False
				when 110 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 113 -- skip loop
						end
				when 111 then -- loop body:
						l_break := False
						l___ret___8 := reps.integer_32_item ([a_data, ('0').code, l_preczeros])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___8 = -1 then
							l_pos := -1 + 136 -- goto error
						end
				when 112 then
						l_retval := l_retval + l___ret___8
						l_break := True
						l_pos := -1 + 110 -- back to loop condition
				when 113 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 108 -- back to loop condition
				when 114 then -- loop done
						l_break := False
				when 115 then -- if done
						l_break := True
						l_pos := -1 + 106 -- back to loop condition
				when 116 then -- loop done
					l_break := False
				when 117 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 127 -- skip loop
					end
				when 118 then -- loop body:
						l_break := False
						if l_explen = 0 then
							l_pos := -1 + 126 -- skip if block
						end
				when 119 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 125 -- skip loop
						end
				when 120 then -- loop body:
						l_break := False
				when 121 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 124 -- skip loop
						end
				when 122 then -- loop body:
						l_break := False
						l___ret___9 := memory.integer_32_item ([a_data, l_exponent, l_explen.to_natural_32])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___9 = -1 then
							l_pos := -1 + 136 -- goto error
						end
				when 123 then
						l_retval := l_retval + l___ret___9
						l_break := True
						l_pos := -1 + 121 -- back to loop condition
				when 124 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 119 -- back to loop condition
				when 125 then -- loop done
						l_break := False
				when 126 then -- if done
						l_break := True
						l_pos := -1 + 117 -- back to loop condition
				when 127 then -- loop done
					l_break := False
					if l_justify /= 1 then
						l_pos := -1 + 135 -- skip if block
					end
				when 128 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 134 -- skip loop
						end
				when 129 then -- loop body:
						l_break := False
				when 130 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 133 -- skip loop
						end
				when 131 then -- loop body:
						l_break := False
						l___ret___10 := reps.integer_32_item ([a_data, (a_p.item.fill).to_integer_32, l_justlen])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___10 = -1 then
							l_pos := -1 + 136 -- goto error
						end
				when 132 then
						l_retval := l_retval + l___ret___10
						l_break := True
						l_pos := -1 + 130 -- back to loop condition
				when 133 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 128 -- back to loop condition
				when 134 then -- loop done
						l_break := False
				when 135 then -- done:;
					(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (l_free_ptr), l_free_size.to_natural_32])
					update_class_fields -- Current might have been changed; synchronize
					Result := l_retval
					l_return := True
					if l_return then
						l_pos := -1 + 137 -- skip if block
					end
				when 136 then -- if: | error:
						l_retval := -1
						l_pos := -1 + 135 -- goto done
				when 137 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmp_doprnt_integer (a_data: CE_POINTER [ANY]; a_p: CE_POINTER [PD_DOPRNT_PARAMS_T]; a_s: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_p.is_void
			not a_s.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_retval: INTEGER_32
			l_slen: INTEGER_32
			l_justlen: INTEGER_32
			l_showbaselen: INTEGER_32
			l_sign: INTEGER_32
			l_signlen: INTEGER_32
			l_slashlen: INTEGER_32
			l_zeros: INTEGER_32
			l_justify: INTEGER_32
			l_den_showbaselen: INTEGER_32
			l_slash: CE_POINTER [INTEGER_8]
			l_showbase: CE_POINTER [INTEGER_8]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: NATURAL_32
			l___ret: INTEGER_32
			l___ret___0: INTEGER_32
			l___ret___1: INTEGER_32
			l___ret___2: INTEGER_32
			l___ret___3: INTEGER_32
			l___ret___4: INTEGER_32
			l___ret___5: INTEGER_32
			l___ret___6: INTEGER_32
			l___ret___7: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					l_retval := 0
					l_sign := (a_p.item.sign).to_integer_32
					if (l_s[0]).to_integer_32 = 45 then
						l_sign := (l_s[0]).to_integer_32
						l_s := l_s + 1
					end
					l_signlen := (l_sign /= 0).to_integer
					if (l_s[0]).to_integer_32 = 48 then
						if a_p.item.prec = 0 then
							l_s := l_s + 1
						end
					end
					l_tmp := strlen (l_s)
					update_class_fields -- Current might have been changed; synchronize
					l_slen := l_tmp.to_integer_32
					l_tmp___0 := strchr (l_s, ('/').code)
					update_class_fields -- Current might have been changed; synchronize
					l_slash := l_tmp___0
					l_showbase := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_showbaselen := 0
					if a_p.item.showbase = 2 then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						inspect a_p.item.base -- switch 1 head
						when 16 then l_pos := -1 + 2
						when -16 then l_pos := -1 + 3 -- -16
						when 8 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 2 then -- switch 1, case 16
						l_showbase := ce_string ("0x")
						l_showbaselen := 2
						l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case -16
						l_showbase := ce_string ("0X")
						l_showbaselen := 2
						l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, case 8
						l_showbase := ce_string ("0")
						l_showbaselen := 1
						l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done: | if done
					l_den_showbaselen := l_showbaselen
					if l_slash.is_void then
						l_den_showbaselen := 0
					elseif a_p.item.showbase = 3 then
						if (l_slash[1]).to_integer_32 = 48 then
							l_den_showbaselen := 0
						end
					end
					if a_p.item.showbase = 3 then
						if (l_s[0]).to_integer_32 = 48 then
							l_showbaselen := 0
						end
					end
					if 0 > (a_p.item.prec - l_slen) then
						l_zeros := 0
					else
						l_zeros := (a_p.item.prec - l_slen)
					end
					l_tmp___1 := strlen (l_s)
					update_class_fields -- Current might have been changed; synchronize
					l_justlen := ((a_p.item.width).to_natural_32 - ((((l_tmp___1 + l_signlen.to_natural_32) + l_showbaselen.to_natural_32) + l_den_showbaselen.to_natural_32) + l_zeros.to_natural_32)).to_integer_32
					l_justify := a_p.item.justify
					if l_justlen <= 0 then
						l_justify := 0
					end
					if l_justify /= 2 then
						l_pos := -1 + 13 -- skip if block
					end
				when 6 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 12 -- skip loop
						end
				when 7 then -- loop body:
						l_break := False
				when 8 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 11 -- skip loop
						end
				when 9 then -- loop body:
						l_break := False
						l___ret := reps.integer_32_item ([a_data, (a_p.item.fill).to_integer_32, l_justlen])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret = -1 then
							l_pos := -1 + 84 -- goto error
						end
				when 10 then
						l_retval := l_retval + l___ret
						l_break := True
						l_pos := -1 + 8 -- back to loop condition
				when 11 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 6 -- back to loop condition
				when 12 then -- loop done
						l_break := False
				when 13 then -- if done
					if (l_return or l_break) then
						l_pos := -1 + 23 -- skip loop
					end
				when 14 then -- loop body:
						l_break := False
						if l_signlen = 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 15 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 21 -- skip loop
						end
				when 16 then -- loop body:
						l_break := False
				when 17 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 20 -- skip loop
						end
				when 18 then -- loop body:
						l_break := False
						l___ret___0 := reps.integer_32_item ([a_data, l_sign, l_signlen])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___0 = -1 then
							l_pos := -1 + 84 -- goto error
						end
				when 19 then
						l_retval := l_retval + l___ret___0
						l_break := True
						l_pos := -1 + 17 -- back to loop condition
				when 20 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 15 -- back to loop condition
				when 21 then -- loop done
						l_break := False
				when 22 then -- if done
						l_break := True
						l_pos := -1 + 13 -- back to loop condition
				when 23 then -- loop done
					l_break := False
				when 24 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 34 -- skip loop
					end
				when 25 then -- loop body:
						l_break := False
						if l_showbaselen = 0 then
							l_pos := -1 + 33 -- skip if block
						end
				when 26 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 32 -- skip loop
						end
				when 27 then -- loop body:
						l_break := False
				when 28 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 31 -- skip loop
						end
				when 29 then -- loop body:
						l_break := False
						l___ret___1 := memory.integer_32_item ([a_data, l_showbase, l_showbaselen.to_natural_32])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___1 = -1 then
							l_pos := -1 + 84 -- goto error
						end
				when 30 then
						l_retval := l_retval + l___ret___1
						l_break := True
						l_pos := -1 + 28 -- back to loop condition
				when 31 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 26 -- back to loop condition
				when 32 then -- loop done
						l_break := False
				when 33 then -- if done
						l_break := True
						l_pos := -1 + 24 -- back to loop condition
				when 34 then -- loop done
					l_break := False
				when 35 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 45 -- skip loop
					end
				when 36 then -- loop body:
						l_break := False
						if l_zeros = 0 then
							l_pos := -1 + 44 -- skip if block
						end
				when 37 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 43 -- skip loop
						end
				when 38 then -- loop body:
						l_break := False
				when 39 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 42 -- skip loop
						end
				when 40 then -- loop body:
						l_break := False
						l___ret___2 := reps.integer_32_item ([a_data, ('0').code, l_zeros])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___2 = -1 then
							l_pos := -1 + 84 -- goto error
						end
				when 41 then
						l_retval := l_retval + l___ret___2
						l_break := True
						l_pos := -1 + 39 -- back to loop condition
				when 42 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 37 -- back to loop condition
				when 43 then -- loop done
						l_break := False
				when 44 then -- if done
						l_break := True
						l_pos := -1 + 35 -- back to loop condition
				when 45 then -- loop done
					l_break := False
					if l_justify /= 3 then
						l_pos := -1 + 53 -- skip if block
					end
				when 46 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 52 -- skip loop
						end
				when 47 then -- loop body:
						l_break := False
				when 48 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 51 -- skip loop
						end
				when 49 then -- loop body:
						l_break := False
						l___ret___3 := reps.integer_32_item ([a_data, (a_p.item.fill).to_integer_32, l_justlen])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___3 = -1 then
							l_pos := -1 + 84 -- goto error
						end
				when 50 then
						l_retval := l_retval + l___ret___3
						l_break := True
						l_pos := -1 + 48 -- back to loop condition
				when 51 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 46 -- back to loop condition
				when 52 then -- loop done
						l_break := False
				when 53 then -- if done
					if l_den_showbaselen = 0 then
						l_pos := -1 + 69 -- skip if block
					end
				when 54 then -- if:
						l_slashlen := (l_slash + 1).distance (l_s)
				when 55 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 61 -- skip loop
						end
				when 56 then -- loop body:
						l_break := False
				when 57 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 60 -- skip loop
						end
				when 58 then -- loop body:
						l_break := False
						l___ret___4 := memory.integer_32_item ([a_data, l_s, l_slashlen.to_natural_32])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___4 = -1 then
							l_pos := -1 + 84 -- goto error
						end
				when 59 then
						l_retval := l_retval + l___ret___4
						l_break := True
						l_pos := -1 + 57 -- back to loop condition
				when 60 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 55 -- back to loop condition
				when 61 then -- loop done
						l_break := False
						l_slen := l_slen - l_slashlen
						l_s := l_s + l_slashlen
				when 62 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 68 -- skip loop
						end
				when 63 then -- loop body:
						l_break := False
				when 64 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 67 -- skip loop
						end
				when 65 then -- loop body:
						l_break := False
						l___ret___5 := memory.integer_32_item ([a_data, l_showbase, l_den_showbaselen.to_natural_32])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___5 = -1 then
							l_pos := -1 + 84 -- goto error
						end
				when 66 then
						l_retval := l_retval + l___ret___5
						l_break := True
						l_pos := -1 + 64 -- back to loop condition
				when 67 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 62 -- back to loop condition
				when 68 then -- loop done
						l_break := False
				when 69 then -- if done
					if (l_return or l_break) then
						l_pos := -1 + 75 -- skip loop
					end
				when 70 then -- loop body:
						l_break := False
				when 71 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 74 -- skip loop
						end
				when 72 then -- loop body:
						l_break := False
						l___ret___6 := memory.integer_32_item ([a_data, l_s, l_slen.to_natural_32])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___6 = -1 then
							l_pos := -1 + 84 -- goto error
						end
				when 73 then
						l_retval := l_retval + l___ret___6
						l_break := True
						l_pos := -1 + 71 -- back to loop condition
				when 74 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 69 -- back to loop condition
				when 75 then -- loop done
					l_break := False
					if l_justify /= 1 then
						l_pos := -1 + 83 -- skip if block
					end
				when 76 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 82 -- skip loop
						end
				when 77 then -- loop body:
						l_break := False
				when 78 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 81 -- skip loop
						end
				when 79 then -- loop body:
						l_break := False
						l___ret___7 := reps.integer_32_item ([a_data, (a_p.item.fill).to_integer_32, l_justlen])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___7 = -1 then
							l_pos := -1 + 84 -- goto error
						end
				when 80 then
						l_retval := l_retval + l___ret___7
						l_break := True
						l_pos := -1 + 78 -- back to loop condition
				when 81 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 76 -- back to loop condition
				when 82 then -- loop done
						l_break := False
				when 83 then -- done:
					Result := l_retval
					l_return := True
					if l_return then
						l_pos := -1 + 85 -- skip if block
					end
				when 84 then -- if: | error:
						l_retval := -1
						l_pos := -1 + 83 -- goto done
				when 85 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmp_doprnt (a_data: CE_POINTER [ANY]; a_orig_fmt: CE_POINTER [INTEGER_8]; a_orig_ap: CE_VA_LIST): INTEGER_32
		require
			not a_orig_fmt.is_void
		local
			l_orig_ap: CE_VA_LIST
			l_ap: CE_VA_LIST
			l_this_ap: CE_VA_LIST
			l_last_ap: CE_VA_LIST
			l_alloc_fmt_size: NATURAL_32
			l_fmt: CE_POINTER [INTEGER_8]
			l_alloc_fmt: CE_POINTER [INTEGER_8]
			l_last_fmt: CE_POINTER [INTEGER_8]
			l_this_fmt: CE_POINTER [INTEGER_8]
			l_gmp_str: CE_POINTER [INTEGER_8]
			l_retval: INTEGER_32
			l_type: INTEGER_32
			l_fchar: INTEGER_32
			l_value: CE_POINTER [INTEGER_32]
			l_seen_precision: INTEGER_32
			l_param: CE_ARRAY [PD_DOPRNT_PARAMS_T]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_64
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_64
			l_xp: CE_POINTER [NATURAL_32]
			l_xsize: INTEGER_32
			l_abs_xsize: INTEGER_32
			l_z: CE_ARRAY [PD_MPZ_STRUCT]
			l___ret: INTEGER_32
			l_tmp___7: INTEGER_64
			l___ret___0: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: NATURAL_32
			l_ret: INTEGER_32
			l___ret___1: INTEGER_32
			l_tmp___12: NATURAL_32
			l___ret___2: INTEGER_32
			l_tmp___13: INTEGER_32
			l___ret___3: INTEGER_32
			l___ret___4: INTEGER_32
			l_tmp___14: CE_POINTER [PD_MPF_STRUCT]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: REAL_96
			l_tmp___17: REAL_64
			l_p: CE_POINTER [ANY]
			l___ret___5: INTEGER_32
			l_n: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___18: CE_POINTER [NATURAL_32]
			l_tmp___19: CE_POINTER [ANY]
			l_n___0: INTEGER_32
			l_n___1: INTEGER_32
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_tmp___22: CE_POINTER [CE_POINTER [NATURAL_16]]
			l___ret___6: INTEGER_32
			l_tmp___23: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_DOPRNT_PARAMS_T]} l_param.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_z.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_orig_ap := a_orig_ap.twin
					l_retval := 0
					l_ap := l_orig_ap.twin
					l_tmp := strlen (a_orig_fmt)
					update_class_fields -- Current might have been changed; synchronize
					l_alloc_fmt_size := l_tmp + {NATURAL_32} 1
					l_tmp___0 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([l_alloc_fmt_size * {PLATFORM}.Integer_8_bytes.to_natural_32]))
					update_class_fields -- Current might have been changed; synchronize
					l_alloc_fmt := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___0)
					l_fmt := l_alloc_fmt
					strcpy (l_fmt, a_orig_fmt).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_last_fmt := l_fmt
					l_last_ap := l_ap.twin
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 143 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_fmt := strchr (l_fmt, ('%%').code)
						update_class_fields -- Current might have been changed; synchronize
						if l_fmt.is_void then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 142 -- skip if block
						end
				when 3 then -- if:
						l_this_fmt := l_fmt
						l_this_ap := l_ap.twin
						l_fmt := l_fmt + 1
						l_type := ('%/0/').code
						l_value := create {CE_INTEGER_32_POINTER}.make_shared (l_param.item.c_pointer + (create {PD_DOPRNT_PARAMS_T}.make).offset_of ("width"))
						l_param.item.base := 10
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.conv := 0
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.expfmt := ce_string ("e%%c%%02ld")
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.exptimes4 := 0
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.fill := ((' ').code).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.justify := 2
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.prec := 6
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.showbase := 2
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.showpoint := 0
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.showtrailing := 1
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.sign := (('%/0/').code).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.width := 0
						update_class_fields -- Current might have been changed; synchronize
						l_seen_precision := 0
				when 4 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 140 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						l_tmp___1 := l_fmt
						l_fmt := l_fmt + 1
						l_fchar := (l_tmp___1[0]).to_integer_32
						if l_fchar = 0 then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 139 -- skip if block
						end
				when 6 then -- if:
						inspect l_fchar -- switch 1 head
						when 97 then l_pos := -1 + 7
						when 65 then l_pos := -1 + 8
						when 99 then l_pos := -1 + 10
						when 100 then l_pos := -1 + 11
						when 105 then l_pos := -1 + 11
						when 117 then l_pos := -1 + 11
						when 69 then l_pos := -1 + 64
						when 101 then l_pos := -1 + 65
						when 102 then l_pos := -1 + 88
						when 70 then l_pos := -1 + 89
						when 106 then l_pos := -1 + 89
						when 76 then l_pos := -1 + 89
						when 78 then l_pos := -1 + 89
						when 113 then l_pos := -1 + 89
						when 81 then l_pos := -1 + 89
						when 116 then l_pos := -1 + 89
						when 122 then l_pos := -1 + 89
						when 90 then l_pos := -1 + 89
						when 71 then l_pos := -1 + 90
						when 103 then l_pos := -1 + 91
						when 104 then l_pos := -1 + 92
						when 108 then l_pos := -1 + 94
						when 109 then l_pos := -1 + 96
						when 77 then l_pos := -1 + 97
						when 110 then l_pos := -1 + 98
						when 111 then l_pos := -1 + 125
						when 112 then l_pos := -1 + 126
						when 115 then l_pos := -1 + 126
						when 120 then l_pos := -1 + 127
						when 88 then l_pos := -1 + 128
						when 37 then l_pos := -1 + 129
						when 35 then l_pos := -1 + 130
						when 39 then l_pos := -1 + 131
						when 43 then l_pos := -1 + 132
						when 32 then l_pos := -1 + 132
						when 45 then l_pos := -1 + 133
						when 46 then l_pos := -1 + 134
						when 42 then l_pos := -1 + 135
						when 48 then l_pos := -1 + 136
						when 49 then l_pos := -1 + 137
						when 50 then l_pos := -1 + 137
						when 51 then l_pos := -1 + 137
						when 52 then l_pos := -1 + 137
						when 53 then l_pos := -1 + 137
						when 54 then l_pos := -1 + 137
						when 55 then l_pos := -1 + 137
						when 56 then l_pos := -1 + 137
						when 57 then l_pos := -1 + 137
						else l_pos := -1 + 138
						end
				when 7 then -- switch 1, case 97
						l_param.item.base := 16
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.expfmt := ce_string ("p%%c%%ld")
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 9 -- goto conv_a
				when 8 then -- switch 1, case 65
						l_param.item.base := -16
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.expfmt := ce_string ("P%%c%%ld")
						update_class_fields -- Current might have been changed; synchronize
				when 9 then -- conv_a:
						l_param.item.conv := 2
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.exptimes4 := 1
						update_class_fields -- Current might have been changed; synchronize
						if not l_seen_precision.to_boolean then
							l_param.item.prec := -1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_param.item.showbase := 1
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.showtrailing := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 67 -- goto floating_a
				when 10 then -- switch 1, case 99
						l_tmp___2 := l_ap.integer_32_item
						l_pos := -1 + 141 -- goto next
				when 11 then -- integer: | switch 1, case 100 | switch 1, case 105 | switch 1, case 117
						
						if not l_seen_precision.to_boolean then
							l_param.item.prec := -1
							update_class_fields -- Current might have been changed; synchronize
						end
						inspect l_type -- switch 2 head
						when 106 then l_pos := -1 + 12
						when 108 then l_pos := -1 + 13
						when 76 then l_pos := -1 + 14
						when 78 then l_pos := -1 + 15
						when 113 then l_pos := -1 + 28
						when 81 then l_pos := -1 + 29
						when 116 then l_pos := -1 + 42
						when 122 then l_pos := -1 + 43
						when 90 then l_pos := -1 + 44
						else l_pos := -1 + 62
						end
				when 12 then -- switch 2, case 106
						l_tmp___3 := l_ap.integer_64_item
						l_pos := -1 + 63 -- switch 2; break
				when 13 then -- switch 2, case 108
						l_tmp___4 := l_ap.integer_32_item
						l_pos := -1 + 63 -- switch 2; break
				when 14 then -- switch 2, case 76
						l_tmp___5 := l_ap.integer_64_item
						l_pos := -1 + 63 -- switch 2; break
				when 15 then -- switch 2, case 78
						if (l_return or l_break) then
							l_pos := -1 + 27 -- skip loop
						end
				when 16 then -- loop body:
						l_break := False
						if not (l_this_fmt.is_equal (l_last_fmt)) then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | if block done, skip else block:
						l_pos := -1 + 26
				when 18 then -- else:
						l_this_fmt[0] := (('%/0/').code).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
				when 19 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 25 -- skip loop
						end
				when 20 then -- loop body:
						l_break := False
				when 21 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 24 -- skip loop
						end
				when 22 then -- loop body:
						l_break := False
						l___ret := format.integer_32_item ([a_data, l_last_fmt, l_last_ap.twin])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret = -1 then
							l_pos := -1 + 153 -- goto error
						end
				when 23 then
						l_retval := l_retval + l___ret
						l_break := True
						l_pos := -1 + 21 -- back to loop condition
				when 24 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 19 -- back to loop condition
				when 25 then -- loop done
						l_break := False
				when 26 then -- if done
						l_break := True
						l_pos := -1 + 15 -- back to loop condition
				when 27 then -- loop done
						l_break := False
						l_xp := (create {CE_NATURAL_32_POINTER}.make_cast (l_ap.pointer_item))
						l_z[0].mp_d := l_xp
						update_class_fields -- Current might have been changed; synchronize
						l_xsize := ((l_ap.integer_32_item).to_integer_32).to_integer_32
						if l_xsize >= 0 then
							l_abs_xsize := l_xsize
						else
							l_abs_xsize := -l_xsize
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_abs_xsize > 0))
							loop
								l_break := False
								if l_xp[(l_abs_xsize - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_abs_xsize := l_abs_xsize - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if l_xsize >= 0 then
							l_z[0].mp_size := l_abs_xsize.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						else
							l_z[0].mp_size := (-l_abs_xsize).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
						l_gmp_str := (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_z)).item.gmpz_get_str (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), l_param.item.base)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 57 -- goto gmp_integer
				when 28 then -- switch 2, case 113
						l_tmp___7 := l_ap.integer_64_item
						l_pos := -1 + 63 -- switch 2; break
				when 29 then -- switch 2, case 81
						if (l_return or l_break) then
							l_pos := -1 + 41 -- skip loop
						end
				when 30 then -- loop body:
						l_break := False
						if not (l_this_fmt.is_equal (l_last_fmt)) then
							l_pos := -1 + 32 -- skip if block
						end
				when 31 then -- if: | if block done, skip else block:
						l_pos := -1 + 40
				when 32 then -- else:
						l_this_fmt[0] := (('%/0/').code).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
				when 33 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 39 -- skip loop
						end
				when 34 then -- loop body:
						l_break := False
				when 35 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 38 -- skip loop
						end
				when 36 then -- loop body:
						l_break := False
						l___ret___0 := format.integer_32_item ([a_data, l_last_fmt, l_last_ap.twin])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___0 = -1 then
							l_pos := -1 + 153 -- goto error
						end
				when 37 then
						l_retval := l_retval + l___ret___0
						l_break := True
						l_pos := -1 + 35 -- back to loop condition
				when 38 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 33 -- back to loop condition
				when 39 then -- loop done
						l_break := False
				when 40 then -- if done
						l_break := True
						l_pos := -1 + 29 -- back to loop condition
				when 41 then -- loop done
						l_break := False
						l_gmp_str := gmpq_get_str (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), l_param.item.base, (create {CE_CLASS_POINTER [PD_MPQ_STRUCT]}.make_cast (l_ap.pointer_item)))
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 57 -- goto gmp_integer
				when 42 then -- switch 2, case 116
						l_tmp___9 := l_ap.integer_32_item
						l_pos := -1 + 63 -- switch 2; break
				when 43 then -- switch 2, case 122
						l_tmp___10 := l_ap.natural_32_item
						l_pos := -1 + 63 -- switch 2; break
				when 44 then -- switch 2, case 90
						if (l_return or l_break) then
							l_pos := -1 + 56 -- skip loop
						end
				when 45 then -- loop body:
						l_break := False
						if not (l_this_fmt.is_equal (l_last_fmt)) then
							l_pos := -1 + 47 -- skip if block
						end
				when 46 then -- if: | if block done, skip else block:
						l_pos := -1 + 55
				when 47 then -- else:
						l_this_fmt[0] := (('%/0/').code).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
				when 48 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 54 -- skip loop
						end
				when 49 then -- loop body:
						l_break := False
				when 50 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 53 -- skip loop
						end
				when 51 then -- loop body:
						l_break := False
						l___ret___1 := format.integer_32_item ([a_data, l_last_fmt, l_last_ap.twin])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___1 = -1 then
							l_pos := -1 + 153 -- goto error
						end
				when 52 then
						l_retval := l_retval + l___ret___1
						l_break := True
						l_pos := -1 + 50 -- back to loop condition
				when 53 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 48 -- back to loop condition
				when 54 then -- loop done
						l_break := False
				when 55 then -- if done
						l_break := True
						l_pos := -1 + 44 -- back to loop condition
				when 56 then -- loop done
						l_break := False
						l_gmp_str := (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ap.pointer_item)).item.gmpz_get_str (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), l_param.item.base)
						update_class_fields -- Current might have been changed; synchronize
				when 57 then -- gmp_integer:
						l_ret := ((create {CE_CLASS_POINTER [PD_DOPRNT_FUNS_T]}.make_shared (c_pointer))).item.gmp_doprnt_integer (a_data, l_param, l_gmp_str)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___12 := strlen (l_gmp_str)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (l_gmp_str), l_tmp___12 + {NATURAL_32} 1])
						update_class_fields -- Current might have been changed; synchronize
				when 58 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 61 -- skip loop
						end
				when 59 then -- loop body:
						l_break := False
						l___ret___2 := l_ret
						if l___ret___2 = -1 then
							l_pos := -1 + 153 -- goto error
						end
				when 60 then
						l_retval := l_retval + l___ret___2
						l_break := True
						l_pos := -1 + 58 -- back to loop condition
				when 61 then -- loop done
						l_break := False
						l_last_ap := l_ap.twin
						l_last_fmt := l_fmt
						l_pos := -1 + 63 -- switch 2; break
				when 62 then -- switch 2, default:
						l_tmp___13 := l_ap.integer_32_item
						l_pos := -1 + 63 -- switch 2; break
				when 63 then -- switch 2, done:
						l_pos := -1 + 141 -- goto next
				when 64 then -- switch 1, case 69
						l_param.item.base := -10
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.expfmt := ce_string ("E%%c%%02ld")
						update_class_fields -- Current might have been changed; synchronize
				when 65 then -- switch 1, case 101
						l_param.item.conv := 2
						update_class_fields -- Current might have been changed; synchronize
				when 66 then -- floating:
						if l_param.item.showbase = 3 then
							l_param.item.showpoint := 1
							update_class_fields -- Current might have been changed; synchronize
							l_param.item.showtrailing := 1
							update_class_fields -- Current might have been changed; synchronize
						end
				when 67 then -- floating_a:
						inspect l_type -- switch 3 head
						when 70 then l_pos := -1 + 68
						when 76 then l_pos := -1 + 85
						else l_pos := -1 + 86
						end
				when 68 then -- switch 3, case 70
						if (l_return or l_break) then
							l_pos := -1 + 80 -- skip loop
						end
				when 69 then -- loop body:
						l_break := False
						if not (l_this_fmt.is_equal (l_last_fmt)) then
							l_pos := -1 + 71 -- skip if block
						end
				when 70 then -- if: | if block done, skip else block:
						l_pos := -1 + 79
				when 71 then -- else:
						l_this_fmt[0] := (('%/0/').code).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
				when 72 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 78 -- skip loop
						end
				when 73 then -- loop body:
						l_break := False
				when 74 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 77 -- skip loop
						end
				when 75 then -- loop body:
						l_break := False
						l___ret___3 := format.integer_32_item ([a_data, l_last_fmt, l_last_ap.twin])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___3 = -1 then
							l_pos := -1 + 153 -- goto error
						end
				when 76 then
						l_retval := l_retval + l___ret___3
						l_break := True
						l_pos := -1 + 74 -- back to loop condition
				when 77 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 72 -- back to loop condition
				when 78 then -- loop done
						l_break := False
				when 79 then -- if done
						l_break := True
						l_pos := -1 + 68 -- back to loop condition
				when 80 then -- loop done
						l_break := False
				when 81 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 84 -- skip loop
						end
				when 82 then -- loop body:
						l_break := False
						l_tmp___14 := (create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_cast (l_ap.pointer_item))
						l_tmp___15 := nl_langinfo (65_536)
						update_class_fields -- Current might have been changed; synchronize
						l___ret___4 := ((create {CE_CLASS_POINTER [PD_DOPRNT_FUNS_T]}.make_shared (c_pointer))).item.gmp_doprnt_mpf2 (a_data, l_param, l_tmp___15, l_tmp___14)
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___4 = -1 then
							l_pos := -1 + 153 -- goto error
						end
				when 83 then
						l_retval := l_retval + l___ret___4
						l_break := True
						l_pos := -1 + 81 -- back to loop condition
				when 84 then -- loop done
						l_break := False
						l_last_ap := l_ap.twin
						l_last_fmt := l_fmt
						l_pos := -1 + 87 -- switch 3; break
				when 85 then -- switch 3, case 76
						l_tmp___16 := l_ap.real_96_item
						l_pos := -1 + 87 -- switch 3; break
				when 86 then -- switch 3, default:
						l_tmp___17 := l_ap.real_64_item
						l_pos := -1 + 87 -- switch 3; break
				when 87 then -- switch 3, done:
						l_pos := -1 + 141 -- goto next
				when 88 then -- switch 1, case 102
						l_param.item.conv := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 66 -- goto floating
				when 89 then -- set_type: | switch 1, case 70 | switch 1, case 106 | switch 1, case 76 | switch 1, case 78 | switch 1, case 113 | switch 1, case 81 | switch 1, case 116 | switch 1, case 122 | switch 1, case 90
						l_type := l_fchar
						l_pos := -1 + 139 -- switch 1; break
				when 90 then -- switch 1, case 71
						l_param.item.base := -10
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.expfmt := ce_string ("E%%c%%02ld")
						update_class_fields -- Current might have been changed; synchronize
				when 91 then -- switch 1, case 103
						l_param.item.conv := 3
						update_class_fields -- Current might have been changed; synchronize
						l_param.item.showtrailing := 0
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 66 -- goto floating
				when 92 then -- switch 1, case 104
						if l_type /= 104 then
							l_pos := -1 + 89 -- goto set_type
						end
				when 93 then
						l_type := ('H').code
						l_pos := -1 + 139 -- switch 1; break
				when 94 then -- switch 1, case 108
						if l_type /= 108 then
							l_pos := -1 + 89 -- goto set_type
						end
				when 95 then
						l_type := ('L').code
						l_pos := -1 + 139 -- switch 1; break
				when 96 then -- switch 1, case 109
						l_pos := -1 + 141 -- goto next
				when 97 then -- switch 1, case 77
						l_fmt[-1] := (('l').code).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_type := ('l').code
						l_pos := -1 + 139 -- switch 1; break
				when 98 then -- switch 1, case 110
						if (l_return or l_break) then
							l_pos := -1 + 110 -- skip loop
						end
				when 99 then -- loop body:
						l_break := False
						if not (l_this_fmt.is_equal (l_last_fmt)) then
							l_pos := -1 + 101 -- skip if block
						end
				when 100 then -- if: | if block done, skip else block:
						l_pos := -1 + 109
				when 101 then -- else:
						l_this_fmt[0] := (('%/0/').code).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
				when 102 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 108 -- skip loop
						end
				when 103 then -- loop body:
						l_break := False
				when 104 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 107 -- skip loop
						end
				when 105 then -- loop body:
						l_break := False
						l___ret___5 := format.integer_32_item ([a_data, l_last_fmt, l_last_ap.twin])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___5 = -1 then
							l_pos := -1 + 153 -- goto error
						end
				when 106 then
						l_retval := l_retval + l___ret___5
						l_break := True
						l_pos := -1 + 104 -- back to loop condition
				when 107 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 102 -- back to loop condition
				when 108 then -- loop done
						l_break := False
				when 109 then -- if done
						l_break := True
						l_pos := -1 + 98 -- back to loop condition
				when 110 then -- loop done
						l_break := False
						l_p := (create {CE_VOID_POINTER}.make_cast (l_ap.pointer_item))
						inspect l_type -- switch 4 head
						when 0 then l_pos := -1 + 111
						when 70 then l_pos := -1 + 112
						when 72 then l_pos := -1 + 113
						when 104 then l_pos := -1 + 114
						when 106 then l_pos := -1 + 115
						when 108 then l_pos := -1 + 116
						when 113 then l_pos := -1 + 117
						when 76 then l_pos := -1 + 118
						when 78 then l_pos := -1 + 119
						when 81 then l_pos := -1 + 120
						when 116 then l_pos := -1 + 121
						when 122 then l_pos := -1 + 122
						when 90 then l_pos := -1 + 123
						else l_pos := -1 + 124
						end
				when 111 then -- switch 4, case 0;
						(create {CE_INTEGER_32_POINTER}.make_cast (l_p)).item := l_retval
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 124 -- switch 4; break
				when 112 then -- switch 4, case 70;
						(create {CE_CLASS_POINTER [PD_MPF_STRUCT]}.make_cast (l_p)).item.gmpf_set_si (l_retval.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 124 -- switch 4; break
				when 113 then -- switch 4, case 72;
						(create {CE_INTEGER_8_POINTER}.make_cast (l_p)).item := l_retval.to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 124 -- switch 4; break
				when 114 then -- switch 4, case 104;
						(create {CE_INTEGER_16_POINTER}.make_cast (l_p)).item := l_retval.to_integer_16
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 124 -- switch 4; break
				when 115 then -- switch 4, case 106;
						(create {CE_INTEGER_64_POINTER}.make_cast (l_p)).item := l_retval.to_integer_64
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 124 -- switch 4; break
				when 116 then -- switch 4, case 108;
						(create {CE_INTEGER_32_POINTER}.make_cast (l_p)).item := l_retval.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 124 -- switch 4; break
				when 117 then -- switch 4, case 113
						from
						until
							(l_break)
						loop
							l_break := False
							if {PLATFORM}.Integer_64_bytes.to_natural_32 /= {PLATFORM}.Integer_64_bytes.to_natural_32 then
								(create {P_ASSERT_STATIC}).gmp_assert_fail (ce_string ("doprnt.c"), 461, ce_string ("sizeof (quad_t) == sizeof (long long)"))
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
				when 118 then -- switch 4, case 76;
						(create {CE_INTEGER_64_POINTER}.make_cast (l_p)).item := l_retval.to_integer_64
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 124 -- switch 4; break
				when 119 then -- switch 4, case 78
						l_n := l_ap.integer_32_item
						if l_n >= 0 then
							l_n := l_n
						else
							l_n := -l_n
						end
						if l_n /= 0 then
							(create {CE_NATURAL_32_POINTER}.make_cast (l_p)).item := l_retval.to_natural_32
							update_class_fields -- Current might have been changed; synchronize
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_n - 1 /= 0 then
									l___dst := create {CE_NATURAL_32_POINTER}.make_cast (l_p) + 1
									l___n := l_n - 1
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp___18 := l___dst
										l___dst := l___dst + 1
										l_tmp___18.item := (0).to_natural_32
										update_class_fields -- Current might have been changed; synchronize
										l___n := l___n - 1
										if not l___n.to_boolean then
											l_break := True
										end
									end
									l_break := False
								end
								l_break := True
							end
							l_break := False
						end
						l_pos := -1 + 124 -- switch 4; break
				when 120 then -- switch 4, case 81;
						(create {CE_CLASS_POINTER [PD_MPQ_STRUCT]}.make_cast (l_p)).item.gmpq_set_si (l_retval.to_integer_32, {NATURAL_32} 1)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 124 -- switch 4; break
				when 121 then -- switch 4, case 116;
						(create {CE_INTEGER_32_POINTER}.make_cast (l_p)).item := l_retval
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 124 -- switch 4; break
				when 122 then -- switch 4, case 122;
						(create {CE_NATURAL_32_POINTER}.make_cast (l_p)).item := l_retval.to_natural_32
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 124 -- switch 4; break
				when 123 then -- switch 4, case 90;
						(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_p)).item.gmpz_set_si (l_retval.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 124 -- switch 4; break
				when 124 then -- switch 4, done:
						l_last_ap := l_ap.twin
						l_last_fmt := l_fmt
						l_pos := -1 + 141 -- goto next
				when 125 then -- switch 1, case 111
						l_param.item.base := 8
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 11 -- goto integer
				when 126 then -- switch 1, case 112 | switch 1, case 115
						l_tmp___19 := (create {CE_VOID_POINTER}.make_cast (l_ap.pointer_item))
						l_pos := -1 + 141 -- goto next
				when 127 then -- switch 1, case 120
						l_param.item.base := 16
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 11 -- goto integer
				when 128 then -- switch 1, case 88
						l_param.item.base := -16
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 11 -- goto integer
				when 129 then -- switch 1, case 37
						l_pos := -1 + 141 -- goto next
				when 130 then -- switch 1, case 35
						l_param.item.showbase := 3
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 139 -- switch 1; break
				when 131 then -- switch 1, case 39
						l_pos := -1 + 139 -- switch 1; break
				when 132 then -- switch 1, case 43 | switch 1, case 32
						l_param.item.sign := l_fchar.to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 139 -- switch 1; break
				when 133 then -- switch 1, case 45
						l_param.item.justify := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 139 -- switch 1; break
				when 134 then -- switch 1, case 46
						l_seen_precision := 1
						l_param.item.prec := -1
						update_class_fields -- Current might have been changed; synchronize
						l_value := create {CE_INTEGER_32_POINTER}.make_shared (l_param.item.c_pointer + (create {PD_DOPRNT_PARAMS_T}.make).offset_of ("prec"))
						l_pos := -1 + 139 -- switch 1; break
				when 135 then -- switch 1, case 42
						l_n___0 := (l_ap.integer_32_item)
						if l_value.is_equal (create {CE_INTEGER_32_POINTER}.make_shared (l_param.item.c_pointer + (create {PD_DOPRNT_PARAMS_T}.make).offset_of ("width"))) then
							if l_n___0 < 0 then
								l_param.item.justify := 1
								update_class_fields -- Current might have been changed; synchronize
								l_n___0 := -l_n___0
							end
							l_param.item.width := l_n___0
							update_class_fields -- Current might have been changed; synchronize
						elseif 0 > l_n___0 then
							l_param.item.prec := 0
							update_class_fields -- Current might have been changed; synchronize
						else
							l_param.item.prec := l_n___0
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 139 -- switch 1; break
				when 136 then -- switch 1, case 48
						if l_value.is_equal (create {CE_INTEGER_32_POINTER}.make_shared (l_param.item.c_pointer + (create {PD_DOPRNT_PARAMS_T}.make).offset_of ("width"))) then
							l_param.item.fill := (('0').code).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							if l_param.item.justify = 2 then
								l_param.item.justify := 3
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_value.item := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 139 -- switch 1; break
				when 137 then -- switch 1, case 49 | switch 1, case 50 | switch 1, case 51 | switch 1, case 52 | switch 1, case 53 | switch 1, case 54 | switch 1, case 55 | switch 1, case 56 | switch 1, case 57
						l_n___1 := 0
						from
						until
							(l_break)
						loop
							l_break := False
							l_n___1 := l_n___1 * 10 + (l_fchar - 48)
							l_tmp___21 := l_fmt
							l_fmt := l_fmt + 1
							l_fchar := (l_tmp___21[0]).to_integer_32
							if ((l_fchar).bit_and (-128)) = 0 then
								l_tmp___22 := ctype_b_loc
								update_class_fields -- Current might have been changed; synchronize
								if not (((l_tmp___22.item[l_fchar]).to_integer_32).bit_and (2_048)).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
						end
						l_break := False
						l_fmt := l_fmt - 1
						l_value.item := l_n___1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 139 -- switch 1; break
				when 138 then -- switch 1, default:
						l_pos := -1 + 141 -- goto next
				when 139 then -- switch 1, done: | if done
						l_pos := -1 + 4 -- back to loop condition
				when 140 then -- loop done
						l_break := False
				when 141 then -- next:
						
				when 142 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 143 then -- loop done
					l_break := False
					if (l_last_fmt[0]).to_integer_32 = 0 then
						l_pos := -1 + 151 -- skip if block
					end
				when 144 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 150 -- skip loop
						end
				when 145 then -- loop body:
						l_break := False
				when 146 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 149 -- skip loop
						end
				when 147 then -- loop body:
						l_break := False
						l___ret___6 := format.integer_32_item ([a_data, l_last_fmt, l_last_ap.twin])
						update_class_fields -- Current might have been changed; synchronize
						if l___ret___6 = -1 then
							l_pos := -1 + 153 -- goto error
						end
				when 148 then
						l_retval := l_retval + l___ret___6
						l_break := True
						l_pos := -1 + 146 -- back to loop condition
				when 149 then -- loop done
						l_break := False
						l_break := True
						l_pos := -1 + 144 -- back to loop condition
				when 150 then -- loop done
						l_break := False
				when 151 then -- if done
					if not final.is_void then
						l_tmp___23 := final.integer_32_item ([a_data])
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___23 = -1 then
							l_pos := -1 + 153 -- goto error
						end
					end
				when 152 then -- done:;
					(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (l_alloc_fmt), l_alloc_fmt_size])
					update_class_fields -- Current might have been changed; synchronize
					Result := l_retval
					l_return := True
					if l_return then
						l_pos := -1 + 154 -- skip if block
					end
				when 153 then -- if: | error:
						l_retval := -1
						l_pos := -1 + 152 -- goto done
				when 154 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {PD_DOPRNT_FUNS_T} -- private routines

	gmpq_get_str (a_str: CE_POINTER [INTEGER_8]; a_base: INTEGER_32; a_q: CE_POINTER [PD_MPQ_STRUCT]): CE_POINTER [INTEGER_8]
		require
			not a_q.is_void
		local
			l_str: CE_POINTER [INTEGER_8]
			l_str_alloc: NATURAL_32
			l_len: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: NATURAL_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str := a_str
					l_str_alloc := (0).to_natural_32
					if l_str.is_void then
						if a_q.item.mp_num.mp_size >= 0 then
							l_tmp := a_q.item.mp_num.mp_size
						else
							l_tmp := -a_q.item.mp_num.mp_size
						end
						if a_base >= 0 then
							l_tmp___0 := a_base
						else
							l_tmp___0 := -a_base
						end
						l_str_alloc := (((l_tmp + a_q.item.mp_den.mp_size) * 32).to_double * (create {P_MP_BASES_STATIC}).gmpn_bases.item[l_tmp___0].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32 + {NATURAL_32} 5
						l_str := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([l_str_alloc]))))
					end
					(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))).item.gmpz_get_str (l_str, a_base).do_nothing
					l_len := strlen (l_str)
					if a_q.item.mp_den.mp_size /= 1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_q.item.mp_den.mp_d[0] /= {NATURAL_32} 1 then
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_tmp___2 := l_len
						l_len := l_len + 1
						l_str[l_tmp___2.to_integer_32] := (('/').code).to_integer_8;
						(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))).item.gmpz_get_str (l_str + l_len.to_integer_32, a_base).do_nothing
						l_len := l_len + (strlen ((l_str + l_len.to_integer_32)))
				when 4 then
					if l_str_alloc /= {NATURAL_32} 0 then
						from
						until
							(l_break)
						loop
							l_break := False
							if l_str_alloc /= l_len + {NATURAL_32} 1 then
								l_str := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_str), l_str_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, (l_len + {NATURAL_32} 1) * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
							end
							l_break := True
						end
						l_break := False
					end
					Result := l_str
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			format := a_other.format
			memory := a_other.memory
			reps := a_other.reps
			final := a_other.final
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				format.is_equal (a_other.format) and
				memory.is_equal (a_other.memory) and
				reps.is_equal (a_other.reps) and
				final.is_equal (a_other.final)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("format"),
					create {CE_STRUCTURE_FIELD}.make ("memory"),
					create {CE_STRUCTURE_FIELD}.make ("reps"),
					create {CE_STRUCTURE_FIELD}.make ("final")
				>>)
			init_structure_info
		end

end
