class
	PD_GMP_RAND_LC_STRUCT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} mp_seed.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} mp_a.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} cp.make (<<1>>)
		end

feature {ANY} -- fields

	mp_seed: CE_ARRAY [PD_MPZ_STRUCT]

	mp_a: CE_ARRAY [PD_MPZ_STRUCT]

	cn: INTEGER_32 assign set_cn

	cp: CE_ARRAY [NATURAL_32]

	mp_m2exp: NATURAL_32 assign set_mp_m2exp

feature {ANY} -- field setters

	set_cn (a_cn: INTEGER_32)
		do
			cn := a_cn
			update_memory_field ("cn")
		end

	set_mp_m2exp (a_mp_m2exp: NATURAL_32)
		do
			mp_m2exp := a_mp_m2exp
			update_memory_field ("mp_m2exp")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mp_seed := a_other.mp_seed.twin
			mp_a := a_other.mp_a.twin
			cn := a_other.cn
			cp := a_other.cp.twin
			mp_m2exp := a_other.mp_m2exp
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mp_seed.is_equal (a_other.mp_seed) and
				mp_a.is_equal (a_other.mp_a) and
				cn = a_other.cn and
				cp.is_equal (a_other.cp) and
				mp_m2exp = a_other.mp_m2exp
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mp_seed", <<1>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mp_a", <<1>>),
					create {CE_STRUCTURE_FIELD}.make ("cn"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cp", <<1>>),
					create {CE_STRUCTURE_FIELD}.make ("mp_m2exp")
				>>)
			init_structure_info
		end

end
