class
	PD_HGCD_MATRIX

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_ARRAY_ARRAY [CE_POINTER [NATURAL_32]]} p.make (<<2, 2>>)
		end

feature {ANY} -- fields

	alloc: INTEGER_32 assign set_alloc

	n: INTEGER_32 assign set_n

	p: CE_ARRAY [CE_ARRAY [CE_POINTER [NATURAL_32]]]

feature {ANY} -- field setters

	set_alloc (a_alloc: INTEGER_32)
		do
			alloc := a_alloc
			update_memory_field ("alloc")
		end

	set_n (a_n: INTEGER_32)
		do
			n := a_n
			update_memory_field ("n")
		end

feature {ANY} -- public routines

	gmpn_hgcd_matrix_mul (a_M1: CE_POINTER [PD_HGCD_MATRIX]; a_tp: CE_POINTER [NATURAL_32])
		require
			not a_M1.is_void
		local
			l_n: INTEGER_32
		do
			gmpn_matrix22_mul ((p[0])[0], (p[0])[1], (p[1])[0], (p[1])[1], n, (a_M1.item.p[0])[0], (a_M1.item.p[0])[1], (a_M1.item.p[1])[0], (a_M1.item.p[1])[1], a_M1.item.n, a_tp)
			update_class_fields -- Current might have been changed; synchronize
			l_n := n + a_M1.item.n
			l_n := l_n - (((((((((p[0])[0])[l_n]).bit_or (((p[0])[1])[l_n]))).bit_or (((p[1])[0])[l_n]))).bit_or (((p[1])[1])[l_n])) = {NATURAL_32} 0).to_integer
			l_n := l_n - (((((((((p[0])[0])[l_n]).bit_or (((p[0])[1])[l_n]))).bit_or (((p[1])[0])[l_n]))).bit_or (((p[1])[1])[l_n])) = {NATURAL_32} 0).to_integer
			l_n := l_n - (((((((((p[0])[0])[l_n]).bit_or (((p[0])[1])[l_n]))).bit_or (((p[1])[0])[l_n]))).bit_or (((p[1])[1])[l_n])) = {NATURAL_32} 0).to_integer
			Current.n := l_n + 1
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_HGCD_MATRIX} -- private routines

	gmpn_matrix22_mul (a_r0, a_r1, a_r2, a_r3: CE_POINTER [NATURAL_32]; a_rn: INTEGER_32; a_m0, a_m1, a_m2, a_m3: CE_POINTER [NATURAL_32]; a_mn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_r0: CE_POINTER [NATURAL_32]
			l_r1: CE_POINTER [NATURAL_32]
			l_p0: CE_POINTER [NATURAL_32]
			l_p1: CE_POINTER [NATURAL_32]
			l_i: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_r0 := a_r0
					l_r1 := a_r1
					if 17 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (a_rn >= 17) then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if 17 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if a_mn >= 17 then
							gmpn_matrix22_mul_strassen (l_r0, l_r1, a_r2, a_r3, a_rn, a_m0, a_m1, a_m2, a_m3, a_mn, a_tp)
						else
							l_pos := -1 + 5 -- goto _L___0
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L___0:
						l_p0 := a_tp + a_rn
						l_p1 := (l_p0 + a_rn) + a_mn
						l_i := {NATURAL_32} 0
						from
						until
							not (not (l_return) and then (l_i < {NATURAL_32} 2))
						loop
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (a_tp, l_r0, a_rn)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							if a_rn >= a_mn then
								(create {P_MUL_STATIC}).gmpn_mul (l_p0, l_r0, a_rn, a_m0, a_mn).do_nothing;
								(create {P_MUL_STATIC}).gmpn_mul (l_p1, l_r1, a_rn, a_m3, a_mn).do_nothing;
								(create {P_MUL_STATIC}).gmpn_mul (l_r0, l_r1, a_rn, a_m2, a_mn).do_nothing;
								(create {P_MUL_STATIC}).gmpn_mul (l_r1, a_tp, a_rn, a_m1, a_mn).do_nothing
							else
								(create {P_MUL_STATIC}).gmpn_mul (l_p0, a_m0, a_mn, l_r0, a_rn).do_nothing;
								(create {P_MUL_STATIC}).gmpn_mul (l_p1, a_m3, a_mn, l_r1, a_rn).do_nothing;
								(create {P_MUL_STATIC}).gmpn_mul (l_r0, a_m2, a_mn, l_r1, a_rn).do_nothing;
								(create {P_MUL_STATIC}).gmpn_mul (l_r1, a_m1, a_mn, a_tp, a_rn).do_nothing
							end
							l_r0[(a_rn + a_mn)] := (create {P_GMP_STATIC}).gmpn_add_n (l_r0, l_r0, l_p0, a_rn + a_mn)
							l_r1[(a_rn + a_mn)] := (create {P_GMP_STATIC}).gmpn_add_n (l_r1, l_r1, l_p1, a_rn + a_mn)
							l_r0 := a_r2
							l_r1 := a_r3
							l_i := l_i + 1
						end
				when 6 then -- if done | if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 5 -- goto _L___0
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 5 -- goto _L___0
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_matrix22_mul_strassen (a_r0, a_r1, a_r2, a_r3: CE_POINTER [NATURAL_32]; a_rn: INTEGER_32; a_m0, a_m1, a_m2, a_m3: CE_POINTER [NATURAL_32]; a_mn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		require
			not a_r0.is_void
			not a_r1.is_void
			not a_tp.is_void
		local
			l_rn: INTEGER_32
			l_mn: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_s0: CE_POINTER [NATURAL_32]
			l_t0: CE_POINTER [NATURAL_32]
			l_u0: CE_POINTER [NATURAL_32]
			l_u1: CE_POINTER [NATURAL_32]
			l_r1s: INTEGER_32
			l_r3s: INTEGER_32
			l_s0s: INTEGER_32
			l_t0s: INTEGER_32
			l_u1s: INTEGER_32
			l_break: BOOLEAN
		do
			l_rn := a_rn
			l_mn := a_mn
			l_tp := a_tp
			l_s0 := l_tp
			l_tp := l_tp + (l_rn + 1)
			l_t0 := l_tp
			l_tp := l_tp + (l_mn + 1)
			l_u0 := l_tp
			l_tp := l_tp + ((l_rn + l_mn) + 1)
			l_u1 := l_tp
			from
			until
				(l_break)
			loop
				l_break := False
				if l_rn >= l_mn then
					(create {P_MUL_STATIC}).gmpn_mul (l_u0, a_r1, l_rn, a_m2, l_mn).do_nothing
				else
					(create {P_MUL_STATIC}).gmpn_mul (l_u0, a_m2, l_mn, a_r1, l_rn).do_nothing
				end
				l_break := True
			end
			l_break := False
			l_r3s := abs_sub_n (a_r3, a_r3, a_r2, l_rn)
			if l_r3s.to_boolean then
				l_r1s := abs_sub_n (a_r1, a_r1, a_r3, l_rn)
				a_r1[l_rn] := (0).to_natural_32
			else
				a_r1[l_rn] := (create {P_GMP_STATIC}).gmpn_add_n (a_r1, a_r1, a_r3, l_rn)
				l_r1s := 0
			end
			if l_r1s.to_boolean then
				l_s0[l_rn] := (create {P_GMP_STATIC}).gmpn_add_n (l_s0, a_r1, a_r0, l_rn)
				l_s0s := 0
			elseif a_r1[l_rn] /= {NATURAL_32} 0 then
				l_s0[l_rn] := a_r1[l_rn] - ((create {P_GMP_STATIC}).gmpn_sub_n (l_s0, a_r1, a_r0, l_rn))
				l_s0s := 1
			else
				l_s0s := abs_sub_n (l_s0, a_r0, a_r1, l_rn)
				l_s0[l_rn] := (0).to_natural_32
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if l_rn >= l_mn then
					(create {P_MUL_STATIC}).gmpn_mul (l_u1, a_r0, l_rn, a_m0, l_mn).do_nothing
				else
					(create {P_MUL_STATIC}).gmpn_mul (l_u1, a_m0, l_mn, a_r0, l_rn).do_nothing
				end
				l_break := True
			end
			l_break := False
			a_r0[(l_rn + l_mn)] := (create {P_GMP_STATIC}).gmpn_add_n (a_r0, l_u0, l_u1, l_rn + l_mn)
			l_t0s := abs_sub_n (l_t0, a_m3, a_m2, l_mn)
			l_u1s := (((l_r3s).bit_xor (l_t0s))).bit_xor (1)
			from
			until
				(l_break)
			loop
				l_break := False
				if l_rn >= l_mn then
					(create {P_MUL_STATIC}).gmpn_mul (l_u1, a_r3, l_rn, l_t0, l_mn).do_nothing
				else
					(create {P_MUL_STATIC}).gmpn_mul (l_u1, l_t0, l_mn, a_r3, l_rn).do_nothing
				end
				l_break := True
			end
			l_break := False
			l_u1[(l_rn + l_mn)] := (0).to_natural_32
			if l_t0s.to_boolean then
				l_t0s := abs_sub_n (l_t0, a_m1, l_t0, l_mn)
				l_t0[l_mn] := (0).to_natural_32
			else
				l_t0[l_mn] := (create {P_GMP_STATIC}).gmpn_add_n (l_t0, l_t0, a_m1, l_mn)
			end
			if l_t0[l_mn] /= {NATURAL_32} 0 then
				from
				until
					(l_break)
				loop
					l_break := False
					if l_rn >= l_mn + 1 then
						(create {P_MUL_STATIC}).gmpn_mul (a_r3, a_r1, l_rn, l_t0, l_mn + 1).do_nothing
					else
						(create {P_MUL_STATIC}).gmpn_mul (a_r3, l_t0, l_mn + 1, a_r1, l_rn).do_nothing
					end
					l_break := True
				end
				l_break := False
				if a_r1[l_rn] /= {NATURAL_32} 0 then
					(create {P_GMP_STATIC}).gmpn_add_n (a_r3 + l_rn, (a_r3 + l_rn), l_t0, l_mn + 1).do_nothing
				end
			else
				from
				until
					(l_break)
				loop
					l_break := False
					if l_rn + 1 >= l_mn then
						(create {P_MUL_STATIC}).gmpn_mul (a_r3, a_r1, l_rn + 1, l_t0, l_mn).do_nothing
					else
						(create {P_MUL_STATIC}).gmpn_mul (a_r3, l_t0, l_mn, a_r1, l_rn + 1).do_nothing
					end
					l_break := True
				end
				l_break := False
			end
			l_u0[(l_rn + l_mn)] := (0).to_natural_32
			if ((l_r1s).bit_xor (l_t0s)).to_boolean then
				l_r3s := abs_sub_n (a_r3, l_u0, a_r3, (l_rn + l_mn) + 1)
			else
				(create {P_GMP_STATIC}).gmpn_add_n (a_r3, a_r3, l_u0, (l_rn + l_mn) + 1).do_nothing
				l_r3s := 0
			end
			if l_t0s.to_boolean then
				l_t0[l_mn] := (create {P_GMP_STATIC}).gmpn_add_n (l_t0, l_t0, a_m0, l_mn)
			elseif l_t0[l_mn] /= {NATURAL_32} 0 then
				l_t0[l_mn] := l_t0[l_mn] - ((create {P_GMP_STATIC}).gmpn_sub_n (l_t0, l_t0, a_m0, l_mn))
			else
				l_t0s := abs_sub_n (l_t0, l_t0, a_m0, l_mn)
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if l_rn >= l_mn + 1 then
					(create {P_MUL_STATIC}).gmpn_mul (l_u0, a_r2, l_rn, l_t0, l_mn + 1).do_nothing
				else
					(create {P_MUL_STATIC}).gmpn_mul (l_u0, l_t0, l_mn + 1, a_r2, l_rn).do_nothing
				end
				l_break := True
			end
			l_break := False
			if l_r1s.to_boolean then
				(create {P_GMP_STATIC}).gmpn_sub_n (a_r1, a_r2, a_r1, l_rn).do_nothing
			else
				a_r1[l_rn] := a_r1[l_rn] + ((create {P_GMP_STATIC}).gmpn_add_n (a_r1, a_r1, a_r2, l_rn))
			end
			l_rn := l_rn + 1
			l_t0s := add_signed_n (a_r2, a_r3, l_r3s, l_u0, l_t0s, l_rn + l_mn)
			l_r3s := add_signed_n (a_r3, a_r3, l_r3s, l_u1, l_u1s, l_rn + l_mn)
			from
			until
				(l_break)
			loop
				l_break := False
				if l_rn >= l_mn then
					(create {P_MUL_STATIC}).gmpn_mul (l_u0, l_s0, l_rn, a_m1, l_mn).do_nothing
				else
					(create {P_MUL_STATIC}).gmpn_mul (l_u0, a_m1, l_mn, l_s0, l_rn).do_nothing
				end
				l_break := True
			end
			l_break := False
			l_t0[l_mn] := (create {P_GMP_STATIC}).gmpn_add_n (l_t0, a_m3, a_m1, l_mn)
			from
			until
				(l_break)
			loop
				l_break := False
				if l_rn >= l_mn + 1 then
					(create {P_MUL_STATIC}).gmpn_mul (l_u1, a_r1, l_rn, l_t0, l_mn + 1).do_nothing
				else
					(create {P_MUL_STATIC}).gmpn_mul (l_u1, l_t0, l_mn + 1, a_r1, l_rn).do_nothing
				end
				l_break := True
			end
			l_break := False
			l_mn := l_mn + l_rn
			add_signed_n (a_r1, a_r3, l_r3s, l_u0, l_s0s, l_mn).do_nothing
			if l_r3s.to_boolean then
				(create {P_GMP_STATIC}).gmpn_add_n (a_r3, l_u1, a_r3, l_mn).do_nothing
			else
				(create {P_GMP_STATIC}).gmpn_sub_n (a_r3, l_u1, a_r3, l_mn).do_nothing
			end
			if l_t0s.to_boolean then
				(create {P_GMP_STATIC}).gmpn_add_n (a_r2, l_u1, a_r2, l_mn).do_nothing
			else
				(create {P_GMP_STATIC}).gmpn_sub_n (a_r2, l_u1, a_r2, l_mn).do_nothing
			end
		end

	add_signed_n (a_rp, a_ap: CE_POINTER [NATURAL_32]; a_as: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bs: INTEGER_32; a_n: INTEGER_32): INTEGER_32
		do
			if a_as /= a_bs then
				Result := ((a_as).bit_xor ((abs_sub_n (a_rp, a_ap, a_bp, a_n))))
			else
				(create {P_GMP_STATIC}).gmpn_add_n (a_rp, a_ap, a_bp, a_n).do_nothing
				Result := a_as
			end
		end

	abs_sub_n (a_rp, a_ap, a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_y: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_c := 0
				l___gmp_i := a_n
				from
				until
					(l_break)
				loop
					l_break := False
					l___gmp_i := l___gmp_i - 1
					if not (l___gmp_i >= 0) then
						l_break := True
					end
					if not (l_break) then
						l___gmp_x := a_ap[l___gmp_i]
						l___gmp_y := a_bp[l___gmp_i]
						if l___gmp_x /= l___gmp_y then
							if l___gmp_x > l___gmp_y then
								l_c := 1
							else
								l_c := -1
							end
							l_break := True
						end
					end
				end
				l_break := False
				l_break := True
			end
			l_break := False
			if l_c >= 0 then
				(create {P_GMP_STATIC}).gmpn_sub_n (a_rp, a_ap, a_bp, a_n).do_nothing
				Result := 0
			else
				(create {P_GMP_STATIC}).gmpn_sub_n (a_rp, a_bp, a_ap, a_n).do_nothing
				Result := 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			alloc := a_other.alloc
			n := a_other.n
			p := a_other.p.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				alloc = a_other.alloc and
				n = a_other.n and
				p.is_equal (a_other.p)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("alloc"),
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("p", <<2, 2>>)
				>>)
			init_structure_info
		end

end
