class
	PD_POWERS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	LIBGMP_ASSEMBLER
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_32_POINTER} p.make
		end

feature {ANY} -- fields

	p: CE_POINTER [NATURAL_32] assign set_p

	n: INTEGER_32 assign set_n

	shift: INTEGER_32 assign set_shift

	digits_in_base: NATURAL_32 assign set_digits_in_base

	base: INTEGER_32 assign set_base

feature {ANY} -- field setters

	set_p (a_p: CE_POINTER [NATURAL_32])
		do
			p := a_p
			update_memory_field ("p")
		end

	set_n (a_n: INTEGER_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_shift (a_shift: INTEGER_32)
		do
			shift := a_shift
			update_memory_field ("shift")
		end

	set_digits_in_base (a_digits_in_base: NATURAL_32)
		do
			digits_in_base := a_digits_in_base
			update_memory_field ("digits_in_base")
		end

	set_base (a_base: INTEGER_32)
		do
			base := a_base
			update_memory_field ("base")
		end

feature {ANY} -- public routines

	gmpn_dc_set_str (a_rp: CE_POINTER [NATURAL_32]; a_str: CE_POINTER [NATURAL_8]; a_str_len: NATURAL_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_rp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_str: CE_POINTER [NATURAL_8]
			l_len_lo: NATURAL_32
			l_len_hi: NATURAL_32
			l_cy: CE_ARRAY [NATURAL_32]
			l_ln: CE_ARRAY [INTEGER_32]
			l_hn: INTEGER_32
			l_n: INTEGER_32
			l_sn: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_32]
			l___dst___0: CE_POINTER [NATURAL_32]
			l___n___0: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_rp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_ln.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			l_rp.item := a_rp
			update_class_fields -- Current might have been changed; synchronize
			l_str := a_str
			l_len_lo := digits_in_base
			if a_str_len <= l_len_lo then
				if 587 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if a_str_len >= {NATURAL_32} 587 then
						l_tmp___0 := ((create {CE_CLASS_POINTER [PD_POWERS]}.make_shared (c_pointer)) + 1).item.gmpn_dc_set_str (l_rp.item, l_str, a_str_len, a_tp)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___0
						l_return := True
					else
						l_tmp := (create {P_SET_STR_STATIC}).gmpn_bc_set_str (l_rp.item, l_str, a_str_len, base)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp
						l_return := True
					end
				else
					l_tmp := (create {P_SET_STR_STATIC}).gmpn_bc_set_str (l_rp.item, l_str, a_str_len, base)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_tmp
					l_return := True
				end
			end
			if not l_return then
				l_len_hi := a_str_len - l_len_lo
				if 587 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_len_hi >= {NATURAL_32} 587 then
						l_hn := ((create {CE_CLASS_POINTER [PD_POWERS]}.make_shared (c_pointer)) + 1).item.gmpn_dc_set_str (a_tp, l_str, l_len_hi, l_rp.item)
						update_class_fields -- Current might have been changed; synchronize
					else
						l_hn := (create {P_SET_STR_STATIC}).gmpn_bc_set_str (a_tp, l_str, l_len_hi, base)
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					l_hn := (create {P_SET_STR_STATIC}).gmpn_bc_set_str (a_tp, l_str, l_len_hi, base)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_sn := shift
				if l_hn = 0 then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if n + l_sn /= 0 then
							l___dst := l_rp.item
							l___n := (n + l_sn)
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___1 := l___dst
								l___dst := l___dst + 1
								l_tmp___1.item := (0).to_natural_32
								update_class_fields -- Current might have been changed; synchronize
								l___n := l___n - 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
				else
					if n > l_hn then
						(create {P_MUL_STATIC}).gmpn_mul (l_rp.item + l_sn, p, n, a_tp, l_hn).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					else
						(create {P_MUL_STATIC}).gmpn_mul (l_rp.item + l_sn, a_tp, l_hn, p, n).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_sn /= 0 then
							l___dst___0 := l_rp.item
							l___n___0 := l_sn
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___2 := l___dst___0
								l___dst___0 := l___dst___0 + 1
								l_tmp___2.item := (0).to_natural_32
								update_class_fields -- Current might have been changed; synchronize
								l___n___0 := l___n___0 - 1
								if not l___n___0.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
				end
				l_str := (l_str + a_str_len.to_integer_32) - l_len_lo.to_integer_32
				if 587 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_len_lo >= {NATURAL_32} 587 then
						l_ln.item := ((create {CE_CLASS_POINTER [PD_POWERS]}.make_shared (c_pointer)) + 1).item.gmpn_dc_set_str (a_tp, l_str, l_len_lo, ((a_tp + n) + l_sn) + 1)
						update_class_fields -- Current might have been changed; synchronize
					else
						l_ln.item := (create {P_SET_STR_STATIC}).gmpn_bc_set_str (a_tp, l_str, l_len_lo, base)
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					l_ln.item := (create {P_SET_STR_STATIC}).gmpn_bc_set_str (a_tp, l_str, l_len_lo, base)
					update_class_fields -- Current might have been changed; synchronize
				end
				if l_ln.item /= 0 then
					l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_rp.item, l_rp.item, a_tp, l_ln.item)
					update_class_fields -- Current might have been changed; synchronize
					from
					until
						(l_break)
					loop
						l_break := False
						asm105 (l___ptr_dummy, l_rp, l_ln, l_cy)
						l_break := True
					end
					l_break := False
				end
				l_n := (l_hn + n) + l_sn
				Result := (l_n - (l_rp.item[(l_n - 1)] = {NATURAL_32} 0).to_integer)
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			p := a_other.p
			n := a_other.n
			shift := a_other.shift
			digits_in_base := a_other.digits_in_base
			base := a_other.base
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				p.is_equal (a_other.p) and
				n = a_other.n and
				shift = a_other.shift and
				digits_in_base = a_other.digits_in_base and
				base = a_other.base
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("p"),
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("shift"),
					create {CE_STRUCTURE_FIELD}.make ("digits_in_base"),
					create {CE_STRUCTURE_FIELD}.make ("base")
				>>)
			init_structure_info
		end

end
