class
	PD_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	manl: NATURAL_32 assign set_manl

	manh: NATURAL_32 assign set_manh

	exp: NATURAL_32 assign set_exp

	sig: NATURAL_32 assign set_sig

feature {ANY} -- field setters

	set_manl (a_manl: NATURAL_32)
		do
			manl := a_manl
			update_memory_field ("manl")
		end

	set_manh (a_manh: NATURAL_32)
		do
			manh := a_manh
			update_memory_field ("manh")
		end

	set_exp (a_exp: NATURAL_32)
		do
			exp := a_exp
			update_memory_field ("exp")
		end

	set_sig (a_sig: NATURAL_32)
		do
			sig := a_sig
			update_memory_field ("sig")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			manl := a_other.manl
			manh := a_other.manh
			exp := a_other.exp
			sig := a_other.sig
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				manl = a_other.manl and
				manh = a_other.manh and
				exp = a_other.exp and
				sig = a_other.sig
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_bitfield ("manl"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("manh"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("exp"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("sig")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline"
		alias
			"[
				struct __anonstruct_s_13 {
					unsigned int manl : 32;
					unsigned int manh : 20;
					unsigned int exp : 11;
					unsigned int sig : 1;
				};
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct __anonstruct_s_13);
				} else {
					struct __anonstruct_s_13 *p = (struct __anonstruct_s_13 *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "manl") == 0) p->manl = (unsigned int)$a_value;
						else if(strcmp(field_name, "manh") == 0) p->manh = (unsigned int)$a_value;
						else if(strcmp(field_name, "exp") == 0) p->exp = (unsigned int)$a_value;
						else if(strcmp(field_name, "sig") == 0) p->sig = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "manl") == 0) return p->manl;
						if(strcmp(field_name, "manh") == 0) return p->manh;
						if(strcmp(field_name, "exp") == 0) return p->exp;
						if(strcmp(field_name, "sig") == 0) return p->sig;
					}
				}
			]"
		end

end
