class
	P_BESSEL_J_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_sf_bessel_jl_array (a_lmax: INTEGER_32; a_x: REAL_64; a_result_array: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_j: INTEGER_32
			l_j___0: INTEGER_32
			l_r_jellp1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_jell: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_0: INTEGER_32
			l_stat_1: INTEGER_32
			l_jellp1: REAL_64
			l_jell: REAL_64
			l_jellm1: REAL_64
			l_ell: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_r_jellp1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_r_jell.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_lmax < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_x < 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_j := 0
						from
						until
							not (l_j <= a_lmax)
						loop
							a_result_array[l_j] := 0.0
							l_j := l_j + 1
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("error"), ce_string ("bessel_j.c"), 254, 1)
							Result := 1
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_x = 0.0 then
							l_j___0 := 1
							from
							until
								not (l_j___0 <= a_lmax)
							loop
								a_result_array[l_j___0] := 0.0
								l_j___0 := l_j___0 + 1
							end
							a_result_array[0] := 1.0
							Result := 0
							l_return := True
						else
							l_stat_0 := (l_r_jellp1.item.gsl_sf_bessel_jl_e (a_lmax + 1, a_x))
							l_stat_1 := (l_r_jell.item.gsl_sf_bessel_jl_e (a_lmax, a_x))
							l_jellp1 := l_r_jellp1.item.val
							l_jell := l_r_jell.item.val
							a_result_array[a_lmax] := l_jell
							l_ell := a_lmax
							from
							until
								not (l_ell >= 1)
							loop
								l_jellm1 := -l_jellp1 + ((2 * l_ell + 1).to_double / a_x) * l_jell
								l_jellp1 := l_jell
								l_jell := l_jellm1
								a_result_array[(l_ell - 1)] := l_jellm1
								l_ell := l_ell - 1
							end
							if l_stat_0 /= 0 then
								l_tmp___2 := l_stat_0
							else
								if l_stat_1 /= 0 then
									l_tmp___1 := l_stat_1
								else
									l_tmp___1 := 0
								end
								l_tmp___2 := l_tmp___1
							end
							Result := l_tmp___2
							l_return := True
						end
				when 7 then -- if done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_bessel_jl_steed_array (a_lmax: INTEGER_32; a_x: REAL_64; a_jl_x: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_j: INTEGER_32
			l_j___0: INTEGER_32
			l_inv_fact: REAL_64
			l_x_l: REAL_64
			l_l: INTEGER_32
			l_x_inv: REAL_64
			l_W: REAL_64
			l_F___0: REAL_64
			l_FP: REAL_64
			l_B: REAL_64
			l_end: REAL_64
			l_D: REAL_64
			l_del: REAL_64
			l_tmp: REAL_64
			l_XP2: REAL_64
			l_PL: REAL_64
			l_L2: INTEGER_32
			l_LP: INTEGER_32
			l_L___0: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_lmax < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_x < 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_j := 0
						from
						until
							not (l_j <= a_lmax)
						loop
							a_jl_x[l_j] := 0.0
							l_j := l_j + 1
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("error"), ce_string ("bessel_j.c"), 292, 1)
							Result := 1
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_x = 0.0 then
							l_j___0 := 1
							from
							until
								not (l_j___0 <= a_lmax)
							loop
								a_jl_x[l_j___0] := 0.0
								l_j___0 := l_j___0 + 1
							end
							a_jl_x[0] := 1.0
							Result := 0
							l_return := True
						elseif a_x < 2.0 * 1.2207031250000000e-04 then
							l_inv_fact := 1.0
							l_x_l := 1.0
							l_l := 0
							from
							until
								not (l_l <= a_lmax)
							loop
								a_jl_x[l_l] := l_x_l * l_inv_fact
								a_jl_x[l_l] := a_jl_x[l_l] * (1.0 - ((0.5 * a_x) * a_x) / (2.0 * l_l.to_double + 3.0))
								l_inv_fact := l_inv_fact / (2.0 * l_l.to_double + 3.0)
								l_x_l := l_x_l * a_x
								l_l := l_l + 1
							end
							Result := 0
							l_return := True
						else
							l_x_inv := 1.0 / a_x
							l_W := 2.0 * l_x_inv
							l_F___0 := 1.0
							l_FP := (a_lmax.to_double + 1.0) * l_x_inv
							l_B := 2.0 * l_FP + l_x_inv
							l_end := l_B + 20000.0 * l_W
							l_D := 1.0 / l_B
							l_del := -l_D
							l_FP := l_FP + l_del
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_B := l_B + l_W
								l_D := 1.0 / (l_B - l_D)
								l_del := l_del * (l_B * l_D - 1.)
								l_FP := l_FP + l_del
								if l_D < 0.0 then
									l_F___0 := -l_F___0
								end
								if l_B > l_end then
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_ERROR_STATIC}).gsl_error (ce_string ("error"), ce_string ("bessel_j.c"), 334, 11)
										Result := 11
										l_return := True
										if not l_return then
											l_break := True
										end
									end
									if not l_return then
										l_break := False
									end
								end
								if not l_return then
									l_tmp := fabs (l_del)
									if not (l_tmp >= (fabs (l_FP)) * 2.2204460492503131e-16) then
										l_break := True
									end
								end
							end
							if not l_return then
								l_break := False
								l_FP := l_FP * l_F___0
								if a_lmax > 0 then
									l_XP2 := l_FP
									l_PL := a_lmax.to_double * l_x_inv
									l_L2 := a_lmax
									a_jl_x[a_lmax] := l_F___0
									l_LP := 1
									from
									until
										not (l_LP <= a_lmax)
									loop
										a_jl_x[(l_L2 - 1)] := l_PL * a_jl_x[l_L2] + l_XP2
										l_FP := l_PL * a_jl_x[(l_L2 - 1)] - a_jl_x[l_L2]
										l_XP2 := l_FP
										l_PL := l_PL - l_x_inv
										l_L2 := l_L2 - 1
										l_LP := l_LP + 1
									end
									l_F___0 := a_jl_x[0]
								end
								l_W := l_x_inv / (hypot (l_FP, l_F___0))
								a_jl_x[0] := l_W * l_F___0
								if a_lmax > 0 then
									l_L___0 := 1
									from
									until
										not (l_L___0 <= a_lmax)
									loop
										a_jl_x[l_L___0] := a_jl_x[l_L___0] * l_W
										l_L___0 := l_L___0 + 1
									end
								end
								Result := 0
								l_return := True
							end
						end
				when 7 then -- if done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_bessel_j0 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_bessel_j0_e (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_bessel_j0_e(x, &result)"), ce_string ("bessel_j.c"), 379, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_bessel_j12 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_bessel_j1_e2 (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_bessel_j1_e(x, &result)"), ce_string ("bessel_j.c"), 384, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_bessel_j2 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_bessel_j2_e (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_bessel_j2_e(x, &result)"), ce_string ("bessel_j.c"), 389, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_bessel_jl (a_l: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_bessel_jl_e (a_l, a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_bessel_jl_e(l, x, &result)"), ce_string ("bessel_j.c"), 394, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

end
