class
	P_BETA_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_beta_pdf (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_p: REAL_64
			l_gab: REAL_64
			l_ga: REAL_64
			l_gb: REAL_64
			l_tmp___2: REAL_64
			l_tmp___3: REAL_64
			l_tmp___4: REAL_64
			l_tmp___5: REAL_64
		do
			if a_x < (0).to_double then
				Result := (0).to_double
			elseif a_x > (1).to_double then
				Result := (0).to_double
			else
				l_gab := ((create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_a___5 + a_b___0))
				l_ga := ((create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_a___5))
				l_gb := ((create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_b___0))
				if a_x = 0.0 then
					l_tmp___2 := exp ((l_gab - l_ga) - l_gb)
					l_tmp___3 := pow (a_x, a_a___5 - (1).to_double)
					l_tmp___4 := pow ((1).to_double - a_x, a_b___0 - (1).to_double)
					l_p := (l_tmp___2 * l_tmp___3) * l_tmp___4
				elseif a_x = 1.0 then
					l_tmp___2 := exp ((l_gab - l_ga) - l_gb)
					l_tmp___3 := pow (a_x, a_a___5 - (1).to_double)
					l_tmp___4 := pow ((1).to_double - a_x, a_b___0 - (1).to_double)
					l_p := (l_tmp___2 * l_tmp___3) * l_tmp___4
				else
					l_tmp___5 := log (a_x)
					l_p := exp ((((l_gab - l_ga) - l_gb) + l_tmp___5 * (a_a___5 - (1).to_double)) + (log1p (-a_x)) * (a_b___0 - (1).to_double))
				end
				Result := l_p
			end
		end

	gsl_sf_lnbeta (a_x, a_y: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_lnbeta_e (a_x, a_y))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_lnbeta_e(x, y, &result)"), ce_string ("beta.c"), 163, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_beta (a_x, a_y: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_beta_e (a_x, a_y))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_beta_e(x, y, &result)"), ce_string ("beta.c"), 168, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_cdf_beta_P (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_P___2: REAL_64
			l_return: BOOLEAN
		do
			if a_x <= 0.0 then
				Result := (0.0)
				l_return := True
			end
			if not l_return and then (a_x >= 1.0) then
				Result := (1.0)
				l_return := True
			end
			if not l_return then
				l_P___2 := (create {P_BETA_INC_STATIC}).beta_inc_AXPY___0 (1.0, 0.0, a_a___5, a_b___0, a_x)
				Result := l_P___2
			end
		end

	gsl_cdf_beta_Q (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
			l_return: BOOLEAN
		do
			if a_x >= 1.0 then
				Result := (0.0)
				l_return := True
			end
			if not l_return and then (a_x <= 0.0) then
				Result := (1.0)
				l_return := True
			end
			if not l_return then
				l_Q___1 := (create {P_BETA_INC_STATIC}).beta_inc_AXPY___0 (-1.0, 1.0, a_a___5, a_b___0, a_x)
				Result := l_Q___1
			end
		end

end
