class
	P_BITREVERSE_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	fft_complex_bitreverse_order (a_data: CE_POINTER [REAL_64]; a_stride, a_n, a_logn: NATURAL_32): INTEGER_32
		local
			l_logn: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp_real: REAL_64
			l_tmp_imag: REAL_64
			l_return: BOOLEAN
		do
			l_logn := a_logn
			l_j := (0).to_natural_32
			l_logn := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n - {NATURAL_32} 1))
			loop
				l_k := a_n // {NATURAL_32} 2
				if l_i < l_j then
					l_tmp_real := a_data[(({NATURAL_32} 2 * a_stride) * l_i).to_integer_32]
					l_tmp_imag := a_data[(({NATURAL_32} 2 * a_stride) * l_i + {NATURAL_32} 1).to_integer_32]
					a_data[(({NATURAL_32} 2 * a_stride) * l_i).to_integer_32] := a_data[(({NATURAL_32} 2 * a_stride) * l_j).to_integer_32]
					a_data[(({NATURAL_32} 2 * a_stride) * l_i + {NATURAL_32} 1).to_integer_32] := a_data[(({NATURAL_32} 2 * a_stride) * l_j + {NATURAL_32} 1).to_integer_32]
					a_data[(({NATURAL_32} 2 * a_stride) * l_j).to_integer_32] := l_tmp_real
					a_data[(({NATURAL_32} 2 * a_stride) * l_j + {NATURAL_32} 1).to_integer_32] := l_tmp_imag
				end
				from
				until
					not (l_k <= l_j)
				loop
					l_j := l_j - l_k
					l_k := l_k // ({NATURAL_32} 2)
				end
				l_j := l_j + l_k
				l_i := l_i + 1
			end
			Result := 0
		end

	fft_real_bitreverse_order (a_data: CE_POINTER [REAL_64]; a_stride, a_n, a_logn: NATURAL_32): INTEGER_32
		local
			l_logn: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_64
			l_return: BOOLEAN
		do
			l_logn := a_logn
			l_j := (0).to_natural_32
			l_logn := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n - {NATURAL_32} 1))
			loop
				l_k := a_n // {NATURAL_32} 2
				if l_i < l_j then
					l_tmp := a_data[(a_stride * l_i).to_integer_32]
					a_data[(a_stride * l_i).to_integer_32] := a_data[(a_stride * l_j).to_integer_32]
					a_data[(a_stride * l_j).to_integer_32] := l_tmp
				end
				from
				until
					not (l_k <= l_j)
				loop
					l_j := l_j - l_k
					l_k := l_k // ({NATURAL_32} 2)
				end
				l_j := l_j + l_k
				l_i := l_i + 1
			end
			Result := 0
		end

	fft_complex_float_bitreverse_order (a_data: CE_POINTER [REAL_32]; a_stride, a_n, a_logn: NATURAL_32): INTEGER_32
		local
			l_logn: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp_real: REAL_32
			l_tmp_imag: REAL_32
			l_return: BOOLEAN
		do
			l_logn := a_logn
			l_j := (0).to_natural_32
			l_logn := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n - {NATURAL_32} 1))
			loop
				l_k := a_n // {NATURAL_32} 2
				if l_i < l_j then
					l_tmp_real := a_data[(({NATURAL_32} 2 * a_stride) * l_i).to_integer_32]
					l_tmp_imag := a_data[(({NATURAL_32} 2 * a_stride) * l_i + {NATURAL_32} 1).to_integer_32]
					a_data[(({NATURAL_32} 2 * a_stride) * l_i).to_integer_32] := a_data[(({NATURAL_32} 2 * a_stride) * l_j).to_integer_32]
					a_data[(({NATURAL_32} 2 * a_stride) * l_i + {NATURAL_32} 1).to_integer_32] := a_data[(({NATURAL_32} 2 * a_stride) * l_j + {NATURAL_32} 1).to_integer_32]
					a_data[(({NATURAL_32} 2 * a_stride) * l_j).to_integer_32] := l_tmp_real
					a_data[(({NATURAL_32} 2 * a_stride) * l_j + {NATURAL_32} 1).to_integer_32] := l_tmp_imag
				end
				from
				until
					not (l_k <= l_j)
				loop
					l_j := l_j - l_k
					l_k := l_k // ({NATURAL_32} 2)
				end
				l_j := l_j + l_k
				l_i := l_i + 1
			end
			Result := 0
		end

	fft_real_float_bitreverse_order (a_data: CE_POINTER [REAL_32]; a_stride, a_n, a_logn: NATURAL_32): INTEGER_32
		local
			l_logn: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_32
			l_return: BOOLEAN
		do
			l_logn := a_logn
			l_j := (0).to_natural_32
			l_logn := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n - {NATURAL_32} 1))
			loop
				l_k := a_n // {NATURAL_32} 2
				if l_i < l_j then
					l_tmp := a_data[(a_stride * l_i).to_integer_32]
					a_data[(a_stride * l_i).to_integer_32] := a_data[(a_stride * l_j).to_integer_32]
					a_data[(a_stride * l_j).to_integer_32] := l_tmp
				end
				from
				until
					not (l_k <= l_j)
				loop
					l_j := l_j - l_k
					l_k := l_k // ({NATURAL_32} 2)
				end
				l_j := l_j + l_k
				l_i := l_i + 1
			end
			Result := 0
		end

end
