class
	P_BROYDEN_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	broyden_type: CE_STATIC [CE_ARRAY [PD_GSL_MULTIROOT_FSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_MULTIROOT_FSOLVER_TYPE]}.make_initialized (<<
					create {PD_GSL_MULTIROOT_FSOLVER_TYPE}.make_initialized ([ce_string ("broyden"), (create {PD_BROYDEN_STATE_T}.make).structure_size.to_natural_32, broyden_alloc_address, (create {PD_GSL_MULTIROOT_FUNCTION_STRUCT_STATIC}).broyden_set_address, (create {PD_GSL_MULTIROOT_FUNCTION_STRUCT_STATIC}).broyden_iterate_address, broyden_free_address])
				>>)
		end

	gsl_multiroot_fsolver_broyden: CE_STATIC [CE_POINTER [PD_GSL_MULTIROOT_FSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := broyden_type.item
		end

feature {ANY} -- public routines

	broyden_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_BROYDEN_STATE_T]
			l_v: CE_POINTER [PD_GSL_VECTOR]
			l_w: CE_POINTER [PD_GSL_VECTOR]
			l_y: CE_POINTER [PD_GSL_VECTOR]
			l_fnew: CE_POINTER [PD_GSL_VECTOR]
			l_x_trial: CE_POINTER [PD_GSL_VECTOR]
			l_p: CE_POINTER [PD_GSL_VECTOR]
			l_perm: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX]
			l_H: CE_POINTER [PD_GSL_MATRIX]
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_BROYDEN_STATE_T]}.make_cast (a_vstate)
			l_m___4 := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_calloc (a_n, a_n)
			if l_m___4.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for lu"), ce_string ("broyden.c"), 77, 8)
					Result := 8
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.lu := l_m___4
				l_perm := (create {P_INIT_STATIC}).gsl_permutation_calloc (a_n)
				if l_perm.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_m___4)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for permutation"), ce_string ("broyden.c"), 88, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.permutation := l_perm
				l_H := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_calloc (a_n, a_n)
				if l_H.is_void then
					(create {P_INIT_STATIC}).gsl_permutation_free (l_perm);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_m___4)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for d"), ce_string ("broyden.c"), 100, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.H := l_H
				l_v := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_v.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_H);
					(create {P_INIT_STATIC}).gsl_permutation_free (l_perm);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_m___4)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for v"), ce_string ("broyden.c"), 113, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.v := l_v
				l_w := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_w.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_v);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_H);
					(create {P_INIT_STATIC}).gsl_permutation_free (l_perm);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_m___4)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for w"), ce_string ("broyden.c"), 127, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.w := l_w
				l_y := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_y.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_w);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_v);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_H);
					(create {P_INIT_STATIC}).gsl_permutation_free (l_perm);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_m___4)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for y"), ce_string ("broyden.c"), 142, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.y := l_y
				l_fnew := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_fnew.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_y);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_w);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_v);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_H);
					(create {P_INIT_STATIC}).gsl_permutation_free (l_perm);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_m___4)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for fnew"), ce_string ("broyden.c"), 158, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.fnew := l_fnew
				l_x_trial := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_x_trial.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_fnew);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_y);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_w);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_v);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_H);
					(create {P_INIT_STATIC}).gsl_permutation_free (l_perm);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_m___4)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for x_trial"), ce_string ("broyden.c"), 175, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.x_trial := l_x_trial
				l_p := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_p.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_x_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_fnew);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_y);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_w);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_v);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_H);
					(create {P_INIT_STATIC}).gsl_permutation_free (l_perm);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_m___4)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for p"), ce_string ("broyden.c"), 193, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.p := l_p
				Result := 0
			end
		end

	broyden_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_BROYDEN_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_BROYDEN_STATE_T]}.make_cast (a_vstate);
			(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_state.item.H);
			(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_state.item.lu);
			(create {P_INIT_STATIC}).gsl_permutation_free (l_state.item.permutation);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.v);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.w);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.y);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.p);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.fnew);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x_trial)
		end

feature {ANY} -- routine addresses

	broyden_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent broyden_alloc)
		end

	broyden_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent broyden_free)
		end

end
