class
	P_BSIMP_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC
	S_STRING_STATIC
	S_STDLIB_STATIC
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public attributes

	bd_sequence: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					2, 6, 10, 14, 22, 34, 50, 70
				>>)
		end

	bsimp_type: CE_STATIC [CE_ARRAY [PD_GSL_ODEIV_STEP_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_ODEIV_STEP_TYPE]}.make_initialized (<<
					create {PD_GSL_ODEIV_STEP_TYPE}.make_initialized ([ce_string ("bsimp"), 1, 1, bsimp_alloc_address, bsimp_apply_address, bsimp_reset_address, bsimp_order_address, bsimp_free_address])
				>>)
		end

	gsl_odeiv_step_bsimp: CE_STATIC [CE_POINTER [PD_GSL_ODEIV_STEP_TYPE]]
		once ("PROCESS")
			Result.item := bsimp_type.item
		end

feature {ANY} -- public routines

	compute_weights (a_y, a_w: CE_POINTER [REAL_64]; a_dim: NATURAL_32)
		local
			l_i: NATURAL_32
			l_u: REAL_64
		do
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_dim)
			loop
				l_u := (fabs (a_y[l_i.to_integer_32]))
				if l_u > 0.0 then
					a_w[l_i.to_integer_32] := l_u
				else
					a_w[l_i.to_integer_32] := 1.0
				end
				l_i := l_i + 1
			end
		end

	bsimp_deuf_kchoice (a_eps: REAL_64; a_dimension: NATURAL_32): NATURAL_32
		local
			l_safety_f: REAL_64
			l_small_eps: REAL_64
			l_a_work: CE_ARRAY [REAL_64]
			l_alpha: CE_ARRAY [CE_ARRAY [REAL_64]]
			l_i: INTEGER_32
			l_k: INTEGER_32
			l_tmp1: REAL_64
			l_return, l_break: BOOLEAN
		do
			create {CE_REAL_64_ARRAY} l_a_work.make (<<8>>)
			create {CE_ARRAY_ARRAY [REAL_64]} l_alpha.make (<<7, 7>>)

			l_safety_f := 0.25
			l_small_eps := l_safety_f * a_eps
			l_a_work[0] := (bd_sequence.item[0]).to_double + 1.0
			l_k := 0
			from
			until
				not (l_k < 7)
			loop
				l_a_work[l_k + 1] := l_a_work[l_k] + (bd_sequence.item[l_k + 1]).to_double
				l_k := l_k + 1
			end
			l_i := 0
			from
			until
				not (not (l_return) and then (l_i < 7))
			loop
				(l_alpha[l_i])[l_i] := 1.0
				l_k := 0
				from
				until
					not (l_k < l_i)
				loop
					l_tmp1 := l_a_work[l_k + 1] - l_a_work[l_i + 1];
					(l_alpha[l_k])[l_i] := pow (l_small_eps, l_tmp1 / (((l_a_work[l_i + 1] - l_a_work[0]) + 1.0) * (2 * l_k + 1).to_double))
					l_k := l_k + 1
				end
				l_i := l_i + 1
			end
			l_a_work[0] := l_a_work[0] + a_dimension.to_real_64
			l_k := 0
			from
			until
				not (l_k < 7)
			loop
				l_a_work[l_k + 1] := l_a_work[l_k] + (bd_sequence.item[l_k + 1]).to_double
				l_k := l_k + 1
			end
			l_k := 0
			from
			until
				not (not (l_break) and then (l_k < 6))
			loop
				l_break := False
				if l_a_work[l_k + 2] > l_a_work[l_k + 1] * (l_alpha[l_k])[l_k + 1] then
					l_break := True
				end
				if not (l_return or l_break) then
					l_k := l_k + 1
				end
			end
			l_break := False
			Result := l_k.to_natural_32
		end

	poly_extrap (a_d: CE_POINTER [PD_GSL_MATRIX]; a_x: CE_POINTER [REAL_64]; a_i_step: NATURAL_32; a_x_i: REAL_64; a_y_i, a_y_0, a_y_0_err, a_work: CE_POINTER [REAL_64]; a_dim: NATURAL_32)
		local
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_delta___0: REAL_64
			l_f1: REAL_64
			l_f2: REAL_64
			l_q_kj: REAL_64
			l_return: BOOLEAN
		do
			memcpy (create {CE_VOID_POINTER}.make_cast (a_y_0_err), create {CE_VOID_POINTER}.make_cast (a_y_i), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memcpy (create {CE_VOID_POINTER}.make_cast (a_y_0), create {CE_VOID_POINTER}.make_cast (a_y_i), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			if a_i_step = {NATURAL_32} 0 then
				l_j := (0).to_natural_32
				from
				until
					not (l_j < a_dim)
				loop
					a_d.item.gsl_matrix_set ((0).to_natural_32, l_j, a_y_i[l_j.to_integer_32])
					l_j := l_j + 1
				end
			else
				memcpy (create {CE_VOID_POINTER}.make_cast (a_work), create {CE_VOID_POINTER}.make_cast (a_y_i), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_k := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_k < a_i_step))
				loop
					l_delta___0 := 1.0 / (a_x[((a_i_step - l_k) - {NATURAL_32} 1).to_integer_32] - a_x_i)
					l_f1 := l_delta___0 * a_x_i
					l_f2 := l_delta___0 * a_x[((a_i_step - l_k) - {NATURAL_32} 1).to_integer_32]
					l_j := (0).to_natural_32
					from
					until
						not (l_j < a_dim)
					loop
						l_q_kj := (a_d.item.gsl_matrix_get (l_k, l_j))
						a_d.item.gsl_matrix_set (l_k, l_j, a_y_0_err[l_j.to_integer_32])
						l_delta___0 := a_work[l_j.to_integer_32] - l_q_kj
						a_y_0_err[l_j.to_integer_32] := l_f1 * l_delta___0
						a_work[l_j.to_integer_32] := l_f2 * l_delta___0
						a_y_0[l_j.to_integer_32] := a_y_0[l_j.to_integer_32] + (a_y_0_err[l_j.to_integer_32])
						l_j := l_j + 1
					end
					l_k := l_k + 1
				end
				l_j := (0).to_natural_32
				from
				until
					not (l_j < a_dim)
				loop
					a_d.item.gsl_matrix_set (a_i_step, l_j, a_y_0_err[l_j.to_integer_32])
					l_j := l_j + 1
				end
			end
		end

	bsimp_step_local (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t0, a_h_total: REAL_64; a_n_step: NATURAL_32; a_y, a_yp, a_dfdt: CE_POINTER [REAL_64]; a_dfdy: CE_POINTER [PD_GSL_MATRIX]; a_y_out: CE_POINTER [REAL_64]; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_state: CE_POINTER [PD_BSIMP_STATE_T]
			l_a_mat: CE_POINTER [PD_GSL_MATRIX]
			l_p_vec: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_delta___0: CE_POINTER [REAL_64]
			l_y_temp: CE_POINTER [REAL_64]
			l_delta_temp: CE_POINTER [REAL_64]
			l_rhs_temp: CE_POINTER [REAL_64]
			l_w: CE_POINTER [REAL_64]
			l_y_temp_vec: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_delta_temp_vec: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_rhs_temp_vec: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_h: REAL_64
			l_t: REAL_64
			l_sum: REAL_64
			l_max_sum: REAL_64
			l_signum: CE_ARRAY [INTEGER_32]
			l_status: INTEGER_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_n_inter: NATURAL_32
			l_di: REAL_64
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_VECTOR_VIEW]} l_y_temp_vec.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_VECTOR_VIEW]} l_delta_temp_vec.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_VECTOR_VIEW]} l_rhs_temp_vec.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_signum.make (<<1>>)

			l_state := create {CE_CLASS_POINTER [PD_BSIMP_STATE_T]}.make_cast (a_vstate)
			l_a_mat := l_state.item.a_mat
			l_p_vec := l_state.item.p_vec
			l_delta___0 := l_state.item.delta
			l_y_temp := l_state.item.y_temp
			l_delta_temp := l_state.item.delta_temp
			l_rhs_temp := l_state.item.rhs_temp
			l_w := l_state.item.weight
			l_y_temp_vec.item := (((create {P_VIEW_SOURCE_STATIC}).gsl_vector_view_array (l_y_temp, a_dim)).twin).twin
			l_delta_temp_vec.item := (((create {P_VIEW_SOURCE_STATIC}).gsl_vector_view_array (l_delta_temp, a_dim)).twin).twin
			l_rhs_temp_vec.item := (((create {P_VIEW_SOURCE_STATIC}).gsl_vector_view_array (l_rhs_temp, a_dim)).twin).twin
			l_h := a_h_total / a_n_step.to_real_64
			l_t := a_t0 + l_h
			l_max_sum := 100.0 * a_dim.to_real_64
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_dim))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < a_dim)
				loop
					l_a_mat.item.gsl_matrix_set (l_i, l_j, -l_h * (a_dfdy.item.gsl_matrix_get (l_i, l_j)))
					l_j := l_j + 1
				end
				l_a_mat.item.gsl_matrix_set (l_i, l_i, (l_a_mat.item.gsl_matrix_get (l_i, l_i)) + 1.0)
				l_i := l_i + 1
			end
			l_a_mat.item.gsl_linalg_LU_decomp (l_p_vec, l_signum).do_nothing
			compute_weights (a_y, l_w, a_dim)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_dim)
			loop
				l_y_temp[l_i.to_integer_32] := l_h * (a_yp[l_i.to_integer_32] + (l_h * a_dfdt[l_i.to_integer_32]))
				l_i := l_i + 1
			end
			l_a_mat.item.gsl_linalg_LU_solve (l_p_vec, (create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_y_temp_vec.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_delta_temp_vec.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))).do_nothing
			l_sum := 0.0
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_dim)
			loop
				l_di := l_delta_temp[l_i.to_integer_32]
				l_delta___0[l_i.to_integer_32] := l_di
				l_y_temp[l_i.to_integer_32] := (a_y[l_i.to_integer_32] + l_di)
				l_sum := l_sum + ((fabs (l_di)) / l_w[l_i.to_integer_32])
				l_i := l_i + 1
			end
			if l_sum > l_max_sum then
				Result := 5
				l_return := True
			end
			if not l_return then
				l_status := (a_sys.item.function).integer_32_item ([l_t, l_y_temp, a_y_out, a_sys.item.params])
				if l_status.to_boolean then
					Result := l_status
					l_return := True
				end
			end
			if not l_return then
				l_n_inter := (1).to_natural_32
				from
				until
					not (not (l_return) and then (l_n_inter < a_n_step))
				loop
					l_i := (0).to_natural_32
					from
					until
						not (l_i < a_dim)
					loop
						l_rhs_temp[l_i.to_integer_32] := l_h * a_y_out[l_i.to_integer_32] - l_delta___0[l_i.to_integer_32]
						l_i := l_i + 1
					end
					l_a_mat.item.gsl_linalg_LU_solve (l_p_vec, (create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_rhs_temp_vec.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_delta_temp_vec.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))).do_nothing
					l_sum := 0.0
					l_i := (0).to_natural_32
					from
					until
						not (l_i < a_dim)
					loop
						l_delta___0[l_i.to_integer_32] := l_delta___0[l_i.to_integer_32] + (2.0 * l_delta_temp[l_i.to_integer_32])
						l_y_temp[l_i.to_integer_32] := l_y_temp[l_i.to_integer_32] + (l_delta___0[l_i.to_integer_32])
						l_sum := l_sum + ((fabs (l_delta___0[l_i.to_integer_32])) / l_w[l_i.to_integer_32])
						l_i := l_i + 1
					end
					if l_sum > l_max_sum then
						Result := 5
						l_return := True
					end
					if not l_return then
						l_t := l_t + l_h
						l_status := (a_sys.item.function).integer_32_item ([l_t, l_y_temp, a_y_out, a_sys.item.params])
						if l_status.to_boolean then
							Result := l_status
							l_return := True
						end
					end
					if not l_return then
						l_n_inter := l_n_inter + 1
					end
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_rhs_temp[l_i.to_integer_32] := l_h * a_y_out[l_i.to_integer_32] - l_delta___0[l_i.to_integer_32]
					l_i := l_i + 1
				end
				l_a_mat.item.gsl_linalg_LU_solve (l_p_vec, (create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_rhs_temp_vec.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_delta_temp_vec.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))).do_nothing
				l_sum := 0.0
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_y_out[l_i.to_integer_32] := l_y_temp[l_i.to_integer_32] + l_delta_temp[l_i.to_integer_32]
					l_sum := l_sum + ((fabs (l_delta_temp[l_i.to_integer_32])) / l_w[l_i.to_integer_32])
					l_i := l_i + 1
				end
				if l_sum > l_max_sum then
					Result := 5
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	bsimp_alloc (a_dim: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_BSIMP_STATE_T]
			l_k_choice: NATURAL_32
		do
			l_state := create {CE_CLASS_POINTER [PD_BSIMP_STATE_T]}.make_cast ((malloc ((create {PD_BSIMP_STATE_T}.make).structure_size.to_natural_32)))
			l_state.item.d := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_alloc ((7).to_natural_32, a_dim)
			l_state.item.a_mat := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_alloc (a_dim, a_dim)
			l_state.item.p_vec := (create {P_INIT_STATIC}).gsl_permutation_alloc (a_dim)
			l_state.item.yp := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
			l_state.item.y_save := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
			l_state.item.yerr_save := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
			l_state.item.y_extrap_save := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
			l_state.item.y_extrap_sequence := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
			l_state.item.extrap_work := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
			l_state.item.dfdt := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
			l_state.item.y_temp := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
			l_state.item.delta_temp := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
			l_state.item.weight := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
			l_state.item.dfdy := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_alloc (a_dim, a_dim)
			l_state.item.rhs_temp := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
			l_state.item.delta := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
			l_k_choice := (bsimp_deuf_kchoice (1.4901161193847656e-08, a_dim))
			l_state.item.k_choice := l_k_choice
			l_state.item.k_current := l_k_choice
			l_state.item.order := {NATURAL_32} 2 * l_k_choice
			l_state.item.h_next := -1.3407807929942596e+154
			Result := (create {CE_VOID_POINTER}.make_cast (l_state))
		end

	bsimp_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t, a_h: REAL_64; a_y, a_yerr, a_dydt_in, a_dydt_out: CE_POINTER [REAL_64]; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_state: CE_POINTER [PD_BSIMP_STATE_T]
			l_x: CE_POINTER [REAL_64]
			l_yp: CE_POINTER [REAL_64]
			l_y_save: CE_POINTER [REAL_64]
			l_yerr_save: CE_POINTER [REAL_64]
			l_y_extrap_sequence: CE_POINTER [REAL_64]
			l_y_extrap_save: CE_POINTER [REAL_64]
			l_extrap_work: CE_POINTER [REAL_64]
			l_dfdt: CE_POINTER [REAL_64]
			l_d: CE_POINTER [PD_GSL_MATRIX]
			l_dfdy: CE_POINTER [PD_GSL_MATRIX]
			l_t_local: REAL_64
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_s: INTEGER_32
			l_s___0: INTEGER_32
			l_N: NATURAL_32
			l_r___3: REAL_64
			l_x_k: REAL_64
			l_status: INTEGER_32
			l_s___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_BSIMP_STATE_T]}.make_cast (a_vstate)
			l_x := l_state.item.x
			l_yp := l_state.item.yp
			l_y_save := l_state.item.y_save
			l_yerr_save := l_state.item.yerr_save
			l_y_extrap_sequence := l_state.item.y_extrap_sequence
			l_y_extrap_save := l_state.item.y_extrap_save
			l_extrap_work := l_state.item.extrap_work
			l_dfdt := l_state.item.dfdt
			l_d := l_state.item.d
			l_dfdy := l_state.item.dfdy
			l_t_local := a_t
			if a_h + l_t_local = l_t_local then
				Result := 15
				l_return := True
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_y_extrap_save), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				memcpy (create {CE_VOID_POINTER}.make_cast (l_y_save), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				memcpy (create {CE_VOID_POINTER}.make_cast (l_yerr_save), create {CE_VOID_POINTER}.make_cast (a_yerr), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				if not a_dydt_in.is_void then
					memcpy (create {CE_VOID_POINTER}.make_cast (l_yp), create {CE_VOID_POINTER}.make_cast (a_dydt_in), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				else
					l_s := ((a_sys.item.function).integer_32_item ([l_t_local, a_y, l_yp, a_sys.item.params]))
					if l_s /= 0 then
						Result := l_s
						l_return := True
					end
				end
			end
			if not l_return then
				l_s___0 := ((a_sys.item.jacobian).integer_32_item ([l_t_local, a_y, l_dfdy.item.data, l_dfdt, a_sys.item.params]))
				if l_s___0 /= 0 then
					Result := l_s___0
					l_return := True
				end
			end
			if not l_return then
				l_k := (0).to_natural_32
				from
				until
					not (not (l_return or l_break) and then (l_k <= l_state.item.k_current))
				loop
					l_break := False
					l_N := (bd_sequence.item[l_k.to_integer_32]).to_natural_32
					l_r___3 := a_h / l_N.to_real_64
					l_x_k := l_r___3 * l_r___3
					l_status := (bsimp_step_local (create {CE_VOID_POINTER}.make_cast (l_state), a_dim, l_t_local, a_h, l_N, l_y_extrap_save, l_yp, l_dfdt, l_dfdy, l_y_extrap_sequence, a_sys))
					if l_status = 5 then
						l_i := (0).to_natural_32
						from
						until
							not (l_i < a_dim)
						loop
							a_yerr[l_i.to_integer_32] := (builtin_inff).to_double
							l_i := l_i + 1
						end
						l_break := True
					elseif l_status /= 0 then
						Result := l_status
						l_return := True
					end
					if not (l_return or l_break) then
						l_x[l_k.to_integer_32] := l_x_k
						poly_extrap (l_d, l_x, l_k, l_x_k, l_y_extrap_sequence, a_y, a_yerr, l_extrap_work, a_dim)
						l_k := l_k + 1
					end
				end
			end
			if not l_return then
				l_break := False
				if not a_dydt_out.is_void then
					l_s___1 := ((a_sys.item.function).integer_32_item ([a_t + a_h, a_y, a_dydt_out, a_sys.item.params]))
					if l_s___1 /= 0 then
						memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_y_save), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						memcpy (create {CE_VOID_POINTER}.make_cast (a_yerr), create {CE_VOID_POINTER}.make_cast (l_yerr_save), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						Result := l_s___1
						l_return := True
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	bsimp_order (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_BSIMP_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_BSIMP_STATE_T]}.make_cast (a_vstate)
			Result := (l_state.item.order)
		end

	bsimp_reset (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_BSIMP_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_BSIMP_STATE_T]}.make_cast (a_vstate)
			l_state.item.h_next := (0).to_double
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.yp), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			Result := 0
		end

	bsimp_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_BSIMP_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_BSIMP_STATE_T]}.make_cast (a_vstate)
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.delta))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.rhs_temp));
			(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_state.item.dfdy)
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.weight))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.delta_temp))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y_temp))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.dfdt))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.extrap_work))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y_extrap_sequence))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y_extrap_save))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y_save))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.yerr_save))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.yp));
			(create {P_INIT_STATIC}).gsl_permutation_free (l_state.item.p_vec);
			(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_state.item.a_mat);
			(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_state.item.d)
			free (create {CE_VOID_POINTER}.make_cast (l_state))
		end

feature {ANY} -- routine addresses

	bsimp_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent bsimp_alloc)
		end

	bsimp_apply_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent bsimp_apply)
		end

	bsimp_order_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent bsimp_order)
		end

	bsimp_reset_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent bsimp_reset)
		end

	bsimp_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent bsimp_free)
		end

end
