class
	P_CHPR2_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	cblas_chpr2 (a_order, a_Uplo: NATURAL_32; a_N: INTEGER_32; a_alpha, a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_Y: CE_POINTER [ANY]; a_incY: INTEGER_32; a_Ap: CE_POINTER [ANY])
		local
			l_conj: INTEGER_32
			l_tmp: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_ix: INTEGER_32
			l_tmp___0: INTEGER_32
			l_iy: INTEGER_32
			l_tmp___1: INTEGER_32
			l_Xi_real: REAL_32
			l_Xi_imag: REAL_32
			l_tmp1_real: REAL_32
			l_tmp1_imag: REAL_32
			l_Yi_real: REAL_32
			l_Yi_imag: REAL_32
			l_tmp2_real: REAL_32
			l_tmp2_imag: REAL_32
			l_jx: INTEGER_32
			l_jy: INTEGER_32
			l_Xj_real: REAL_32
			l_Xj_imag: REAL_32
			l_Yj_real: REAL_32
			l_Yj_imag: REAL_32
			l_ix___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_iy___0: INTEGER_32
			l_tmp___3: INTEGER_32
			l_Xi_real___0: REAL_32
			l_Xi_imag___0: REAL_32
			l_tmp1_real___0: REAL_32
			l_tmp1_imag___0: REAL_32
			l_Yi_real___0: REAL_32
			l_Yi_imag___0: REAL_32
			l_tmp2_real___0: REAL_32
			l_tmp2_imag___0: REAL_32
			l_jx___0: INTEGER_32
			l_tmp___4: INTEGER_32
			l_jy___0: INTEGER_32
			l_tmp___5: INTEGER_32
			l_Xj_real___0: REAL_32
			l_Xj_imag___0: REAL_32
			l_Yj_real___0: REAL_32
			l_Yj_imag___0: REAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_order = {NATURAL_32} 102 then
						l_tmp := -1
					else
						l_tmp := 1
					end
					l_conj := l_tmp
					l_alpha_real := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[1]
					if l_alpha_real.to_double = 0.0 then
						if l_alpha_imag.to_double = 0.0 then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if a_Uplo = {NATURAL_32} 121 then
							l_pos := -1 + 6 -- goto _L___1
						else
							l_pos := -1 + 4 -- goto _L___3
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 4 then -- else: | _L___3:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___1:
						if a_incX > 0 then
							l_tmp___0 := 0
						else
							l_tmp___0 := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp___0
						if a_incY > 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := (a_N - 1) * -a_incY
						end
						l_iy := l_tmp___1
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_Xi_real := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix]
							l_Xi_imag := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
							l_tmp1_real := l_alpha_real * l_Xi_real - l_alpha_imag * l_Xi_imag
							l_tmp1_imag := l_alpha_imag * l_Xi_real + l_alpha_real * l_Xi_imag
							l_Yi_real := create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy]
							l_Yi_imag := create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy + 1)]
							l_tmp2_real := l_alpha_real * l_Yi_real + l_alpha_imag * l_Yi_imag
							l_tmp2_imag := -l_alpha_imag * l_Yi_real + l_alpha_real * l_Yi_imag
							l_jx := l_ix + a_incX
							l_jy := l_iy + a_incY
							create {CE_REAL_32_POINTER}.make_cast (a_Ap)[2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i)] := create {CE_REAL_32_POINTER}.make_cast (a_Ap)[2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i)] + ((2).to_real * (l_tmp1_real * l_Yi_real + l_tmp1_imag * l_Yi_imag))
							create {CE_REAL_32_POINTER}.make_cast (a_Ap)[(2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i) + 1)] := (0).to_real
							l_j := l_i + 1
							from
							until
								not (l_j < a_N)
							loop
								l_Xj_real := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_jx]
								l_Xj_imag := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_jx + 1)]
								l_Yj_real := create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_jy]
								l_Yj_imag := create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_jy + 1)]
								create {CE_REAL_32_POINTER}.make_cast (a_Ap)[2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i)] := create {CE_REAL_32_POINTER}.make_cast (a_Ap)[2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i)] + ((l_tmp1_real * l_Yj_real + l_tmp1_imag * l_Yj_imag) + (l_tmp2_real * l_Xj_real + l_tmp2_imag * l_Xj_imag))
								create {CE_REAL_32_POINTER}.make_cast (a_Ap)[(2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_Ap)[(2 * (((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i) + 1)] + (l_conj.to_real * ((l_tmp1_imag * l_Yj_real - l_tmp1_real * l_Yj_imag) + (l_tmp2_imag * l_Xj_real - l_tmp2_real * l_Xj_imag)))
								l_jx := l_jx + a_incX
								l_jy := l_jy + a_incY
								l_j := l_j + 1
							end
							l_ix := l_ix + a_incX
							l_iy := l_iy + a_incY
							l_i := l_i + 1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 10 -- goto _L___2
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 10 then -- else: | _L___2:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if a_Uplo = {NATURAL_32} 122 then
							l_pos := -1 + 15 -- goto _L
						else
							l_pos := -1 + 13 -- goto _L___0
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else: | _L___0:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L:
						if a_incX > 0 then
							l_tmp___2 := 0
						else
							l_tmp___2 := (a_N - 1) * -a_incX
						end
						l_ix___0 := l_tmp___2
						if a_incY > 0 then
							l_tmp___3 := 0
						else
							l_tmp___3 := (a_N - 1) * -a_incY
						end
						l_iy___0 := l_tmp___3
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_Xi_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___0]
							l_Xi_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)]
							l_tmp1_real___0 := l_alpha_real * l_Xi_real___0 - l_alpha_imag * l_Xi_imag___0
							l_tmp1_imag___0 := l_alpha_imag * l_Xi_real___0 + l_alpha_real * l_Xi_imag___0
							l_Yi_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___0]
							l_Yi_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___0 + 1)]
							l_tmp2_real___0 := l_alpha_real * l_Yi_real___0 + l_alpha_imag * l_Yi_imag___0
							l_tmp2_imag___0 := -l_alpha_imag * l_Yi_real___0 + l_alpha_real * l_Yi_imag___0
							if a_incX > 0 then
								l_tmp___4 := 0
							else
								l_tmp___4 := (a_N - 1) * -a_incX
							end
							l_jx___0 := l_tmp___4
							if a_incY > 0 then
								l_tmp___5 := 0
							else
								l_tmp___5 := (a_N - 1) * -a_incY
							end
							l_jy___0 := l_tmp___5
							l_j := 0
							from
							until
								not (l_j < l_i)
							loop
								l_Xj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_jx___0]
								l_Xj_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_jx___0 + 1)]
								l_Yj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_jy___0]
								l_Yj_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_jy___0 + 1)]
								create {CE_REAL_32_POINTER}.make_cast (a_Ap)[2 * ((l_i * (l_i + 1)) // 2 + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_Ap)[2 * ((l_i * (l_i + 1)) // 2 + l_j)] + ((l_tmp1_real___0 * l_Yj_real___0 + l_tmp1_imag___0 * l_Yj_imag___0) + (l_tmp2_real___0 * l_Xj_real___0 + l_tmp2_imag___0 * l_Xj_imag___0))
								create {CE_REAL_32_POINTER}.make_cast (a_Ap)[(2 * ((l_i * (l_i + 1)) // 2 + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_Ap)[(2 * ((l_i * (l_i + 1)) // 2 + l_j) + 1)] + (l_conj.to_real * ((l_tmp1_imag___0 * l_Yj_real___0 - l_tmp1_real___0 * l_Yj_imag___0) + (l_tmp2_imag___0 * l_Xj_real___0 - l_tmp2_real___0 * l_Xj_imag___0)))
								l_jx___0 := l_jx___0 + a_incX
								l_jy___0 := l_jy___0 + a_incY
								l_j := l_j + 1
							end
							create {CE_REAL_32_POINTER}.make_cast (a_Ap)[2 * ((l_i * (l_i + 1)) // 2 + l_i)] := create {CE_REAL_32_POINTER}.make_cast (a_Ap)[2 * ((l_i * (l_i + 1)) // 2 + l_i)] + ((2).to_real * (l_tmp1_real___0 * l_Yi_real___0 + l_tmp1_imag___0 * l_Yi_imag___0))
							create {CE_REAL_32_POINTER}.make_cast (a_Ap)[(2 * ((l_i * (l_i + 1)) // 2 + l_i) + 1)] := (0).to_real
							l_ix___0 := l_ix___0 + a_incX
							l_iy___0 := l_iy___0 + a_incY
							l_i := l_i + 1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_hpr2.h"), ce_string ("unrecognized operation")])
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_hpr2.h"), ce_string ("unrecognized operation")])
				when 20 then -- if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
