class
	P_DISCRETE_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	new_stack (a_N: NATURAL_32): CE_POINTER [PD_GSL_STACK_T]
		local
			l_s: CE_POINTER [PD_GSL_STACK_T]
		do
			l_s := create {CE_CLASS_POINTER [PD_GSL_STACK_T]}.make_cast ((malloc ((create {PD_GSL_STACK_T}.make).structure_size.to_natural_32)))
			l_s.item.N := a_N
			l_s.item.i := (0).to_natural_32
			l_s.item.v := create {CE_NATURAL_32_POINTER}.make_cast ((malloc ({PLATFORM}.Natural_32_bytes.to_natural_32 * a_N)))
			Result := l_s
		end

	gsl_ran_discrete_preproc (a_Kevents: NATURAL_32; a_ProbArray: CE_POINTER [REAL_64]): CE_POINTER [PD_GSL_RAN_DISCRETE_T]
		local
			l_k: NATURAL_32
			l_b___0: NATURAL_32
			l_s: NATURAL_32
			l_g: CE_POINTER [PD_GSL_RAN_DISCRETE_T]
			l_nBigs: NATURAL_32
			l_nSmalls: NATURAL_32
			l_Bigs: CE_POINTER [PD_GSL_STACK_T]
			l_Smalls: CE_POINTER [PD_GSL_STACK_T]
			l_E: CE_POINTER [REAL_64]
			l_pTotal: REAL_64
			l_mean: REAL_64
			l_d: REAL_64
			l_which: CE_POINTER [NATURAL_32]
			l_Dest: CE_POINTER [PD_GSL_STACK_T]
			l_tmp___3: CE_POINTER [PD_GSL_STACK_T]
			l_status: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			l_pTotal := 0.0
			if a_Kevents < {NATURAL_32} 1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("number of events must be a positive integer"), ce_string ("discrete.c"), 228, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_RAN_DISCRETE_T]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_k := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_k < a_Kevents))
				loop
					if a_ProbArray[l_k.to_integer_32] < (0).to_double then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("probabilities must be non-negative"), ce_string ("discrete.c"), 238, 4)
							Result := (create {CE_CLASS_POINTER [PD_GSL_RAN_DISCRETE_T]}.make_shared (default_pointer))
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_pTotal := l_pTotal + (a_ProbArray[l_k.to_integer_32])
						l_k := l_k + 1
					end
				end
			end
			if not l_return then
				l_g := create {CE_CLASS_POINTER [PD_GSL_RAN_DISCRETE_T]}.make_cast ((malloc ((create {PD_GSL_RAN_DISCRETE_T}.make).structure_size.to_natural_32)))
				l_g.item.K := a_Kevents
				l_g.item.F := create {CE_REAL_64_POINTER}.make_cast ((malloc ({PLATFORM}.Real_64_bytes.to_natural_32 * a_Kevents)))
				l_g.item.A := create {CE_NATURAL_32_POINTER}.make_cast ((malloc ({PLATFORM}.Natural_32_bytes.to_natural_32 * a_Kevents)))
				l_E := create {CE_REAL_64_POINTER}.make_cast ((malloc ({PLATFORM}.Real_64_bytes.to_natural_32 * a_Kevents)))
				if l_E.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("Cannot allocate memory for randevent"), ce_string ("discrete.c"), 252, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_RAN_DISCRETE_T]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_k := (0).to_natural_32
				from
				until
					not (l_k < a_Kevents)
				loop
					l_E[l_k.to_integer_32] := (a_ProbArray[l_k.to_integer_32] / l_pTotal)
					l_k := l_k + 1
				end
				l_mean := 1.0 / a_Kevents.to_real_64
				l_nBigs := (0).to_natural_32
				l_nSmalls := l_nBigs
				l_which := l_g.item.A
				l_k := (0).to_natural_32
				from
				until
					not (l_k < a_Kevents)
				loop
					if l_E[l_k.to_integer_32] < l_mean then
						l_nSmalls := l_nSmalls + 1
						l_which[l_k.to_integer_32] := (0).to_natural_32
					else
						l_nBigs := l_nBigs + 1
						l_which[l_k.to_integer_32] := (1).to_natural_32
					end
					l_k := l_k + 1
				end
				l_Bigs := new_stack (l_nBigs)
				l_Smalls := new_stack (l_nSmalls)
				l_k := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_k < a_Kevents))
				loop
					if (l_which[l_k.to_integer_32]).to_boolean then
						l_tmp___3 := l_Bigs
					else
						l_tmp___3 := l_Smalls
					end
					l_Dest := l_tmp___3
					l_status := (l_Dest.item.push_stack (l_k))
					if l_status.to_boolean then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to build stacks"), ce_string ("discrete.c"), 280, 5)
							Result := (create {CE_CLASS_POINTER [PD_GSL_RAN_DISCRETE_T]}.make_shared (default_pointer))
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					l_continue := False
					if not ((l_Smalls.item.size_stack) > {NATURAL_32} 0) then
						l_break := True
					end
					if not (l_return or l_break or l_continue) then
						l_s := l_Smalls.item.pop_stack
						if (l_Bigs.item.size_stack) = {NATURAL_32} 0 then
							l_g.item.A[l_s.to_integer_32] := l_s
							l_g.item.F[l_s.to_integer_32] := 1.0
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) then
						l_b___0 := l_Bigs.item.pop_stack
						l_g.item.A[l_s.to_integer_32] := l_b___0
						l_g.item.F[l_s.to_integer_32] := a_Kevents.to_real_64 * l_E[l_s.to_integer_32]
						l_d := l_mean - l_E[l_s.to_integer_32]
						l_E[l_s.to_integer_32] := l_E[l_s.to_integer_32] + l_d
						l_E[l_b___0.to_integer_32] := l_E[l_b___0.to_integer_32] - l_d
						if l_E[l_b___0.to_integer_32] < l_mean then
							l_Smalls.item.push_stack (l_b___0).do_nothing
						elseif l_E[l_b___0.to_integer_32] > l_mean then
							l_Bigs.item.push_stack (l_b___0).do_nothing
						else
							l_g.item.A[l_b___0.to_integer_32] := l_b___0
							l_g.item.F[l_b___0.to_integer_32] := 1.0
						end
					end
				end
				l_break := False
				l_continue := False
				from
				until
					(l_break)
				loop
					l_break := False
					if not ((l_Bigs.item.size_stack) > {NATURAL_32} 0) then
						l_break := True
					end
					if not (l_return or l_break or l_continue) then
						l_b___0 := l_Bigs.item.pop_stack
						l_g.item.A[l_b___0.to_integer_32] := l_b___0
						l_g.item.F[l_b___0.to_integer_32] := 1.0
					end
				end
				l_break := False
				if (l_Smalls.item.size_stack) /= {NATURAL_32} 0 then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("Smalls stack has not been emptied"), ce_string ("discrete.c"), 322, 7)
						Result := (create {CE_CLASS_POINTER [PD_GSL_RAN_DISCRETE_T]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_k := (0).to_natural_32
				from
				until
					not (l_k < a_Kevents)
				loop
					l_g.item.F[l_k.to_integer_32] := l_g.item.F[l_k.to_integer_32] + l_k.to_real_64
					l_g.item.F[l_k.to_integer_32] := l_g.item.F[l_k.to_integer_32] / a_Kevents.to_real_64
					l_k := l_k + 1
				end
				l_Bigs.item.free_stack
				l_Smalls.item.free_stack
				free (create {CE_VOID_POINTER}.make_cast (l_E))
				Result := l_g
			end
		end

	gsl_ran_discrete_free (a_g: CE_POINTER [PD_GSL_RAN_DISCRETE_T])
		local
			l_return: BOOLEAN
		do
			if a_g.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_g.item.A))
				free (create {CE_VOID_POINTER}.make_cast (a_g.item.F))
				free (create {CE_VOID_POINTER}.make_cast (a_g))
			end
		end

end
