class
	P_ENV_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_ieee_env_setup
		local
			l_p: CE_POINTER [INTEGER_8]
			l_precision: CE_ARRAY [INTEGER_32]
			l_rounding: CE_ARRAY [INTEGER_32]
			l_exception_mask: CE_ARRAY [INTEGER_32]
			l_comma: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_precision.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rounding.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_exception_mask.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p := (getenv (ce_string ("GSL_IEEE_MODE")))
					l_precision.item := 0
					l_rounding.item := 0
					l_exception_mask.item := 0
					l_comma := 0
					if l_p.is_void then
						l_return := True
					end
					if not l_return and then ((l_p[0]).to_integer_32 = 0) then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:;
						(create {P_READ_STATIC}).gsl_ieee_read_mode_string (l_p, l_precision, l_rounding, l_exception_mask).do_nothing;
						(create {P_FP_GNUX86_STATIC}).gsl_ieee_set_mode (l_precision.item, l_rounding.item, l_exception_mask.item).do_nothing
						Io.error.put_string ("GSL_IEEE_MODE=%"")
						inspect l_precision.item -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 2 then -- switch 1, case 1
						from
						until
							(l_break)
						loop
							l_break := False
							if l_comma.to_boolean then
								Io.error.put_string (",")
							end
							Io.error.put_string ("single-precision")
							l_comma := l_comma + 1
							l_break := True
						end
						l_break := False
						l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 2
						from
						until
							(l_break)
						loop
							l_break := False
							if l_comma.to_boolean then
								Io.error.put_string (",")
							end
							Io.error.put_string ("double-precision")
							l_comma := l_comma + 1
							l_break := True
						end
						l_break := False
						l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, case 3
						from
						until
							(l_break)
						loop
							l_break := False
							if l_comma.to_boolean then
								Io.error.put_string (",")
							end
							Io.error.put_string ("extended-precision")
							l_comma := l_comma + 1
							l_break := True
						end
						l_break := False
						l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
						inspect l_rounding.item -- switch 2 head
						when 1 then l_pos := -1 + 6
						when 2 then l_pos := -1 + 7
						when 3 then l_pos := -1 + 8
						when 4 then l_pos := -1 + 9
						else l_pos := -1 + 10
						end
				when 6 then -- switch 2, case 1
						from
						until
							(l_break)
						loop
							l_break := False
							if l_comma.to_boolean then
								Io.error.put_string (",")
							end
							Io.error.put_string ("round-to-nearest")
							l_comma := l_comma + 1
							l_break := True
						end
						l_break := False
						l_pos := -1 + 10 -- switch 2; break
				when 7 then -- switch 2, case 2
						from
						until
							(l_break)
						loop
							l_break := False
							if l_comma.to_boolean then
								Io.error.put_string (",")
							end
							Io.error.put_string ("round-down")
							l_comma := l_comma + 1
							l_break := True
						end
						l_break := False
						l_pos := -1 + 10 -- switch 2; break
				when 8 then -- switch 2, case 3
						from
						until
							(l_break)
						loop
							l_break := False
							if l_comma.to_boolean then
								Io.error.put_string (",")
							end
							Io.error.put_string ("round-up")
							l_comma := l_comma + 1
							l_break := True
						end
						l_break := False
						l_pos := -1 + 10 -- switch 2; break
				when 9 then -- switch 2, case 4
						from
						until
							(l_break)
						loop
							l_break := False
							if l_comma.to_boolean then
								Io.error.put_string (",")
							end
							Io.error.put_string ("round-to-zero")
							l_comma := l_comma + 1
							l_break := True
						end
						l_break := False
						l_pos := -1 + 10 -- switch 2; break
				when 10 then -- switch 2, done:
						if ((l_exception_mask.item).bit_and (31)) = 31 then
							from
							until
								(l_break)
							loop
								l_break := False
								if l_comma.to_boolean then
									Io.error.put_string (",")
								end
								Io.error.put_string ("mask-all")
								l_comma := l_comma + 1
								l_break := True
							end
							l_break := False
						elseif ((l_exception_mask.item).bit_and (31)) = 0 then
							from
							until
								(l_break)
							loop
								l_break := False
								if l_comma.to_boolean then
									Io.error.put_string (",")
								end
								Io.error.put_string ("trap-common")
								l_comma := l_comma + 1
								l_break := True
							end
							l_break := False
						else
							if ((l_exception_mask.item).bit_and (1)).to_boolean then
								from
								until
									(l_break)
								loop
									l_break := False
									if l_comma.to_boolean then
										Io.error.put_string (",")
									end
									Io.error.put_string ("mask-invalid")
									l_comma := l_comma + 1
									l_break := True
								end
								l_break := False
							end
							if ((l_exception_mask.item).bit_and (2)).to_boolean then
								from
								until
									(l_break)
								loop
									l_break := False
									if l_comma.to_boolean then
										Io.error.put_string (",")
									end
									Io.error.put_string ("mask-denormalized")
									l_comma := l_comma + 1
									l_break := True
								end
								l_break := False
							end
							if ((l_exception_mask.item).bit_and (4)).to_boolean then
								from
								until
									(l_break)
								loop
									l_break := False
									if l_comma.to_boolean then
										Io.error.put_string (",")
									end
									Io.error.put_string ("mask-division-by-zero")
									l_comma := l_comma + 1
									l_break := True
								end
								l_break := False
							end
							if ((l_exception_mask.item).bit_and (8)).to_boolean then
								from
								until
									(l_break)
								loop
									l_break := False
									if l_comma.to_boolean then
										Io.error.put_string (",")
									end
									Io.error.put_string ("mask-overflow")
									l_comma := l_comma + 1
									l_break := True
								end
								l_break := False
							end
							if ((l_exception_mask.item).bit_and (16)).to_boolean then
								from
								until
									(l_break)
								loop
									l_break := False
									if l_comma.to_boolean then
										Io.error.put_string (",")
									end
									Io.error.put_string ("mask-underflow")
									l_comma := l_comma + 1
									l_break := True
								end
								l_break := False
							end
						end
						if ((l_exception_mask.item).bit_and (32)).to_boolean then
							from
							until
								(l_break)
							loop
								l_break := False
								if l_comma.to_boolean then
									Io.error.put_string (",")
								end
								Io.error.put_string ("trap-inexact")
								l_comma := l_comma + 1
								l_break := True
							end
							l_break := False
						end
						Io.error.put_string ("%"%N")
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
