class
	P_EVOLVE_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_odeiv_evolve_alloc (a_dim: NATURAL_32): CE_POINTER [PD_GSL_ODEIV_EVOLVE]
		local
			l_e: CE_POINTER [PD_GSL_ODEIV_EVOLVE]
			l_return, l_break: BOOLEAN
		do
			l_e := create {CE_CLASS_POINTER [PD_GSL_ODEIV_EVOLVE]}.make_cast ((malloc ((create {PD_GSL_ODEIV_EVOLVE}.make).structure_size.to_natural_32)))
			if l_e.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for evolve struct"), ce_string ("evolve.c"), 40, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_ODEIV_EVOLVE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_e.item.y0 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_e.item.y0).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_e))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for y0"), ce_string ("evolve.c"), 48, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_ODEIV_EVOLVE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_e.item.yerr := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_e.item.yerr).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_e.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_e))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for yerr"), ce_string ("evolve.c"), 57, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_ODEIV_EVOLVE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_e.item.dydt_in := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_e.item.dydt_in).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_e.item.yerr))
					free (create {CE_VOID_POINTER}.make_cast (l_e.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_e))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for dydt_in"), ce_string ("evolve.c"), 67, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_ODEIV_EVOLVE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_e.item.dydt_out := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_e.item.dydt_out).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_e.item.dydt_in))
					free (create {CE_VOID_POINTER}.make_cast (l_e.item.yerr))
					free (create {CE_VOID_POINTER}.make_cast (l_e.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_e))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for dydt_out"), ce_string ("evolve.c"), 78, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_ODEIV_EVOLVE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_e.item.dimension := a_dim
				l_e.item.count := {NATURAL_32} 0
				l_e.item.failed_steps := {NATURAL_32} 0
				l_e.item.last_step := 0.0
				Result := l_e
			end
		end

	gsl_odeiv_evolve_free (a_e: CE_POINTER [PD_GSL_ODEIV_EVOLVE])
		local
			l_return: BOOLEAN
		do
			if a_e.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_e.item.dydt_out))
				free (create {CE_VOID_POINTER}.make_cast (a_e.item.dydt_in))
				free (create {CE_VOID_POINTER}.make_cast (a_e.item.yerr))
				free (create {CE_VOID_POINTER}.make_cast (a_e.item.y0))
				free (create {CE_VOID_POINTER}.make_cast (a_e))
			end
		end

end
