class
	P_EXPONENTIAL_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_exponential_pdf (a_x, a_mu: REAL_64): REAL_64
		local
			l_p: REAL_64
		do
			if a_x < (0).to_double then
				Result := (0).to_double
			else
				l_p := (exp (-a_x / a_mu)) / a_mu
				Result := l_p
			end
		end

	gsl_cdf_exponential_P (a_x, a_mu: REAL_64): REAL_64
		local
			l_P___2: REAL_64
		do
			if a_x < (0).to_double then
				Result := (0).to_double
			else
				l_P___2 := -(expm1 (-a_x / a_mu))
				Result := l_P___2
			end
		end

	gsl_cdf_exponential_Q (a_x, a_mu: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
		do
			if a_x < (0).to_double then
				Result := (1).to_double
			else
				l_Q___1 := (exp (-a_x / a_mu))
				Result := l_Q___1
			end
		end

end
