class
	P_FALSEPOS_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	falsepos_type: CE_STATIC [CE_ARRAY [PD_GSL_ROOT_FSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_ROOT_FSOLVER_TYPE]}.make_initialized (<<
					create {PD_GSL_ROOT_FSOLVER_TYPE}.make_initialized ([ce_string ("falsepos"), (create {PD_FALSEPOS_STATE_T}.make).structure_size.to_natural_32, (create {PD_GSL_FUNCTION_STRUCT_STATIC}).falsepos_init_address, falsepos_iterate_address])
				>>)
		end

	gsl_root_fsolver_falsepos: CE_STATIC [CE_POINTER [PD_GSL_ROOT_FSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := falsepos_type.item
		end

feature {ANY} -- public routines

	falsepos_iterate (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_root, a_x_lower, a_x_upper: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_x_lower.is_void
			not a_x_upper.is_void
		local
			l_state: CE_POINTER [PD_FALSEPOS_STATE_T]
			l_x_linear: REAL_64
			l_f_linear: REAL_64
			l_x_bisect: REAL_64
			l_f_bisect: REAL_64
			l_x_left: REAL_64
			l_x_right: REAL_64
			l_f_lower: REAL_64
			l_f_upper: REAL_64
			l_w: REAL_64
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state := create {CE_CLASS_POINTER [PD_FALSEPOS_STATE_T]}.make_cast (a_vstate)
					l_x_left := a_x_lower.item
					l_x_right := a_x_upper.item
					l_f_lower := l_state.item.f_lower
					l_f_upper := l_state.item.f_upper
					if l_f_lower = 0.0 then
						a_root.item := l_x_left
						a_x_upper.item := l_x_left
						Result := 0
						l_return := True
					end
					if not l_return and then (l_f_upper = 0.0) then
						a_root.item := l_x_right
						a_x_lower.item := l_x_right
						Result := 0
						l_return := True
					end
					if not l_return then
						l_x_linear := l_x_right - (l_f_upper * (l_x_left - l_x_right)) / (l_f_lower - l_f_upper)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_f_linear := (a_f.item.function).real_64_item ([l_x_linear, a_f.item.params])
							if not ((create {P_INFNAN_STATIC}).gsl_finite (l_f_linear)).to_boolean then
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_ERROR_STATIC}).gsl_error (ce_string ("function value is not finite"), ce_string ("falsepos.c"), 117, 9)
									Result := 9
									l_return := True
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							end
							if not l_return then
								l_break := True
							end
						end
					end
					if not l_return then
						l_break := False
						if l_f_linear = 0.0 then
							a_root.item := l_x_linear
							a_x_lower.item := l_x_linear
							a_x_upper.item := l_x_linear
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (l_f_lower > 0.0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_f_linear < 0.0 then
							a_root.item := l_x_linear
							a_x_upper.item := l_x_linear
							l_state.item.f_upper := l_f_linear
							l_w := l_x_linear - l_x_left
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_f_lower < 0.0 then
							if l_f_linear > 0.0 then
								a_root.item := l_x_linear
								a_x_upper.item := l_x_linear
								l_state.item.f_upper := l_f_linear
								l_w := l_x_linear - l_x_left
							else
								a_root.item := l_x_linear
								a_x_lower.item := l_x_linear
								l_state.item.f_lower := l_f_linear
								l_w := l_x_right - l_x_linear
							end
						else
							a_root.item := l_x_linear
							a_x_lower.item := l_x_linear
							l_state.item.f_lower := l_f_linear
							l_w := l_x_right - l_x_linear
						end
				when 5 then
						if l_w < 0.5 * (l_x_right - l_x_left) then
							Result := 0
							l_return := True
						end
				when 6 then -- if done
					if not l_return then
						l_x_bisect := 0.5 * (l_x_left + l_x_right)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_f_bisect := (a_f.item.function).real_64_item ([l_x_bisect, a_f.item.params])
							if not ((create {P_INFNAN_STATIC}).gsl_finite (l_f_bisect)).to_boolean then
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_ERROR_STATIC}).gsl_error (ce_string ("function value is not finite"), ce_string ("falsepos.c"), 151, 9)
									Result := 9
									l_return := True
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							end
							if not l_return then
								l_break := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 18 -- skip if block
					end
				when 7 then -- if:
						l_break := False
						if not (l_f_lower > 0.0) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_f_bisect < 0.0 then
							l_pos := -1 + 12 -- goto _L___0
						else
							l_pos := -1 + 10 -- goto _L___2
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 10 then -- else: | _L___2:
						if not (l_f_lower < 0.0) then
							l_pos := -1 + 16 -- skip if block
						end
				when 11 then -- if:
						if not (l_f_bisect > 0.0) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if: | _L___0:
						a_x_upper.item := l_x_bisect
						l_state.item.f_upper := l_f_bisect
						if a_root.item > l_x_bisect then
							a_root.item := 0.5 * (l_x_left + l_x_bisect)
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_pos := -1 + 16 -- goto _L___1
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L___1:
						a_x_lower.item := l_x_bisect
						l_state.item.f_lower := l_f_bisect
						if a_root.item < l_x_bisect then
							a_root.item := 0.5 * (l_x_bisect + l_x_right)
						end
				when 17 then -- if done
						Result := 0
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	falsepos_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent falsepos_iterate)
		end

end
