class
	P_FDFMINIMIZER_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_multimin_fdfminimizer_alloc (a_T: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE]; a_n: NATURAL_32): CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]
		local
			l_status: INTEGER_32
			l_s: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]
			l_return, l_break: BOOLEAN
		do
			l_s := create {CE_CLASS_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]}.make_cast ((malloc ((create {PD_GSL_MULTIMIN_FDFMINIMIZER}.make).structure_size.to_natural_32)))
			if l_s.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for minimizer struct"), ce_string ("fdfminimizer.c"), 36, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s.item.type := a_T
				l_s.item.x := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_s.item.x).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for x"), ce_string ("fdfminimizer.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.gradient := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_s.item.gradient).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for gradient"), ce_string ("fdfminimizer.c"), 55, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.dx := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_s.item.dx).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.gradient)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for dx"), ce_string ("fdfminimizer.c"), 65, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.state := malloc (a_T.item.size)
				if (l_s.item.state).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.gradient);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.dx)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for minimizer state"), ce_string ("fdfminimizer.c"), 77, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_status := (a_T.item.alloc).integer_32_item ([l_s.item.state, a_n])
				if l_status /= 0 then
					free (l_s.item.state);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.gradient);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.dx)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to initialize minimizer state"), ce_string ("fdfminimizer.c"), 90, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := l_s
			end
		end

	gsl_multimin_fdfminimizer_free (a_s: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER])
		local
			l_return: BOOLEAN
		do
			if a_s.is_void then
				l_return := True
			end
			if not l_return then
				((a_s.item.type).item.free).call ([a_s.item.state])
				free (a_s.item.state);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_s.item.dx);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_s.item.gradient);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_s.item.x)
				free (create {CE_VOID_POINTER}.make_cast (a_s))
			end
		end

end
