class
	P_FPRINTF_SOURCE_STATIC

inherit
	CE_UTILITIES
	S_LIBIO_STATIC
	S_STDIO_STATIC

feature {ANY} -- public routines

	gsl_block_complex_long_double_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_96]; a_n, a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 2))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_status := fprintf ([a_stream, a_format, a_data[(({NATURAL_32} 2 * l_i) * a_stride + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_complex_long_double_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_96]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_96]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_REAL_96_ARRAY} l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 2))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%Lg"), l_tmp]))
					a_data[(({NATURAL_32} 2 * l_i) * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_complex_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_64]; a_n, a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 2))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_status := fprintf ([a_stream, a_format, a_data[(({NATURAL_32} 2 * l_i) * a_stride + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_complex_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_64]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_64]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_REAL_64_ARRAY} l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 2))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%lg"), l_tmp]))
					a_data[(({NATURAL_32} 2 * l_i) * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_complex_float_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_32]; a_n, a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 2))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_status := fprintf ([a_stream, a_format, (a_data[(({NATURAL_32} 2 * l_i) * a_stride + l_k.to_natural_32).to_integer_32]).to_double])
						if l_status < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_complex_float_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_32]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_REAL_32_ARRAY} l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 2))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%g"), l_tmp]))
					a_data[(({NATURAL_32} 2 * l_i) * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_long_double_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_96]; a_n, a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_status := fprintf ([a_stream, a_format, a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_long_double_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_96]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_96]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_REAL_96_ARRAY} l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%Lg"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_64]; a_n, a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_status := fprintf ([a_stream, a_format, a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_64]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_64]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_REAL_64_ARRAY} l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%lg"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_float_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_32]; a_n, a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_status := fprintf ([a_stream, a_format, (a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]).to_double])
						if l_status < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_float_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_32]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_REAL_32_ARRAY} l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%g"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_ulong_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_32]; a_n, a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_status := fprintf ([a_stream, a_format, a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_ulong_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [NATURAL_32]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%lu"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_long_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_32]; a_n, a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_status := fprintf ([a_stream, a_format, a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_long_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [INTEGER_32]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%ld"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_uint_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_32]; a_n, a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_status := fprintf ([a_stream, a_format, a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_uint_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [NATURAL_32]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%u"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_int_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_32]; a_n, a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_status := fprintf ([a_stream, a_format, a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]])
						if l_status < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_int_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [INTEGER_32]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%d"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_ushort_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_16]; a_n, a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_status := fprintf ([a_stream, a_format, (a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]).to_integer_32])
						if l_status < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_ushort_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_16]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [NATURAL_16]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_16_ARRAY} l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%hu"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_short_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_16]; a_n, a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_status := fprintf ([a_stream, a_format, (a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]).to_integer_32])
						if l_status < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_short_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_16]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [INTEGER_16]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_16_ARRAY} l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%hd"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := l_tmp.item
					if l_status /= 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_uchar_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_8]; a_n, a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_status := fprintf ([a_stream, a_format, (a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]).to_integer_32])
						if l_status < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_uchar_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_8]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [NATURAL_32]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%u"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := (l_tmp.item).to_natural_8
					if l_status /= 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_char_raw_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_8]; a_n, a_stride: NATURAL_32; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						if l_status = -1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 121, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_status := fprintf ([a_stream, a_format, (a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32]).to_integer_32])
						if l_status < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 129, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_status := IO_putc (('%N').code, a_stream)
					if l_status = -1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 137, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_char_raw_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_8]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [INTEGER_32]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_tmp.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 1))
				loop
					l_status := (fscanf ([a_stream, ce_string ("%%d"), l_tmp]))
					a_data[(l_i * a_stride + l_k.to_natural_32).to_integer_32] := (l_tmp.item).to_integer_8
					if l_status /= 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 164, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

end
