class
	P_FRANCIS_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_eigen_francis_alloc: CE_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE]
			l_return, l_break: BOOLEAN
		do
			l_w := create {CE_CLASS_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE]}.make_cast ((calloc ((1).to_natural_32, (create {PD_GSL_EIGEN_FRANCIS_WORKSPACE}.make).structure_size.to_natural_32)))
			if l_w.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for workspace"), ce_string ("francis.c"), 82, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_w.item.size := (0).to_natural_32
				l_w.item.max_iterations := (0).to_natural_32
				l_w.item.n_iter := (0).to_natural_32
				l_w.item.n_evals := (0).to_natural_32
				l_w.item.compute_t := 0
				l_w.item.Z := create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
				l_w.item.H := create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
				Result := l_w
			end
		end

	gsl_eigen_francis_free (a_w: CE_POINTER [PD_GSL_EIGEN_FRANCIS_WORKSPACE])
		local
			l_return: BOOLEAN
		do
			if a_w.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_w))
			end
		end

end
