class
	P_FSOLVER_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_min_fminimizer_set (a_s: CE_POINTER [PD_GSL_MIN_FMINIMIZER]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x_minimum, a_x_lower, a_x_upper: REAL_64): INTEGER_32
		require
			not a_f.is_void
		local
			l_status: INTEGER_32
			l_f_minimum: CE_ARRAY [REAL_64]
			l_f_lower: CE_ARRAY [REAL_64]
			l_f_upper: CE_ARRAY [REAL_64]
			l_return: BOOLEAN
		do
			create {CE_REAL_64_ARRAY} l_f_minimum.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_f_lower.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_f_upper.make (<<1>>)

			l_status := a_f.item.compute_f_values (a_x_minimum, l_f_minimum, a_x_lower, l_f_lower, a_x_upper, l_f_upper)
			if l_status /= 0 then
				Result := l_status
				l_return := True
			end
			if not l_return then
				l_status := a_s.item.gsl_min_fminimizer_set_with_values (a_f, a_x_minimum, l_f_minimum.item, a_x_lower, l_f_lower.item, a_x_upper, l_f_upper.item)
				Result := l_status
			end
		end

	gsl_min_fminimizer_alloc (a_T: CE_POINTER [PD_GSL_MIN_FMINIMIZER_TYPE]): CE_POINTER [PD_GSL_MIN_FMINIMIZER]
		local
			l_s: CE_POINTER [PD_GSL_MIN_FMINIMIZER]
			l_return, l_break: BOOLEAN
		do
			l_s := create {CE_CLASS_POINTER [PD_GSL_MIN_FMINIMIZER]}.make_cast ((malloc ((create {PD_GSL_MIN_FMINIMIZER}.make).structure_size.to_natural_32)))
			if l_s.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for minimizer struct"), ce_string ("fsolver.c"), 79, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MIN_FMINIMIZER]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s.item.state := malloc (a_T.item.size)
				if (l_s.item.state).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for minimizer state"), ce_string ("fsolver.c"), 89, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MIN_FMINIMIZER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.type := a_T
				l_s.item.function := create {CE_CLASS_POINTER [PD_GSL_FUNCTION_STRUCT]}.make_shared (default_pointer)
				Result := l_s
			end
		end

	gsl_min_fminimizer_free (a_s: CE_POINTER [PD_GSL_MIN_FMINIMIZER])
		local
			l_return: BOOLEAN
		do
			if a_s.is_void then
				l_return := True
			end
			if not l_return then
				free (a_s.item.state)
				free (create {CE_VOID_POINTER}.make_cast (a_s))
			end
		end

	gsl_multifit_fsolver_alloc (a_T: CE_POINTER [PD_GSL_MULTIFIT_FSOLVER_TYPE]; a_n, a_p: NATURAL_32): CE_POINTER [PD_GSL_MULTIFIT_FSOLVER]
		local
			l_status: INTEGER_32
			l_s: CE_POINTER [PD_GSL_MULTIFIT_FSOLVER]
			l_return, l_break: BOOLEAN
		do
			if a_n < a_p then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("insufficient data points, n < p"), ce_string ("fsolver.c"), 36, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FSOLVER]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s := create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FSOLVER]}.make_cast ((malloc ((create {PD_GSL_MULTIFIT_FSOLVER}.make).structure_size.to_natural_32)))
				if l_s.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for multifit solver struct"), ce_string ("fsolver.c"), 44, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.x := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_p)
				if (l_s.item.x).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for x"), ce_string ("fsolver.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.f := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_s.item.f).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for f"), ce_string ("fsolver.c"), 61, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.dx := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_p)
				if (l_s.item.dx).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.f)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for dx"), ce_string ("fsolver.c"), 71, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.state := malloc (a_T.item.size)
				if (l_s.item.state).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.dx);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.f)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for multifit solver state"), ce_string ("fsolver.c"), 84, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.type := a_T
				l_status := ((l_s.item.type).item.alloc).integer_32_item ([l_s.item.state, a_n, a_p])
				if l_status /= 0 then
					((l_s.item.type).item.free).call ([l_s.item.state])
					free (l_s.item.state);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.dx);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.f)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to set solver"), ce_string ("fsolver.c"), 100, l_status)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.function := create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FUNCTION_STRUCT]}.make_shared (default_pointer)
				Result := l_s
			end
		end

	gsl_multifit_fsolver_free (a_s: CE_POINTER [PD_GSL_MULTIFIT_FSOLVER])
		local
			l_return: BOOLEAN
		do
			if a_s.is_void then
				l_return := True
			end
			if not l_return then
				((a_s.item.type).item.free).call ([a_s.item.state])
				free (a_s.item.state);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_s.item.dx);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_s.item.x);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_s.item.f)
				free (create {CE_VOID_POINTER}.make_cast (a_s))
			end
		end

	gsl_multiroot_fsolver_alloc (a_T: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER_TYPE]; a_n: NATURAL_32): CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]
		local
			l_status: INTEGER_32
			l_s: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER]
			l_return, l_break: BOOLEAN
		do
			l_s := create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FSOLVER]}.make_cast ((malloc ((create {PD_GSL_MULTIROOT_FSOLVER}.make).structure_size.to_natural_32)))
			if l_s.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for multiroot solver struct"), ce_string ("fsolver.c"), 39, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FSOLVER]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s.item.x := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_s.item.x).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for x"), ce_string ("fsolver.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.f := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_s.item.f).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for f"), ce_string ("fsolver.c"), 56, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.dx := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_s.item.dx).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.f)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for dx"), ce_string ("fsolver.c"), 66, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.state := malloc (a_T.item.size)
				if (l_s.item.state).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.dx);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.f)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for multiroot solver state"), ce_string ("fsolver.c"), 79, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.type := a_T
				l_status := ((l_s.item.type).item.alloc).integer_32_item ([l_s.item.state, a_n])
				if l_status /= 0 then
					((l_s.item.type).item.free).call ([l_s.item.state])
					free (l_s.item.state);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.dx);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.x);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_s.item.f)
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to set solver"), ce_string ("fsolver.c"), 95, l_status)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.function := create {CE_CLASS_POINTER [PD_GSL_MULTIROOT_FUNCTION_STRUCT]}.make_shared (default_pointer)
				Result := l_s
			end
		end

	gsl_multiroot_fsolver_free (a_s: CE_POINTER [PD_GSL_MULTIROOT_FSOLVER])
		local
			l_return: BOOLEAN
		do
			if a_s.is_void then
				l_return := True
			end
			if not l_return then
				((a_s.item.type).item.free).call ([a_s.item.state])
				free (a_s.item.state);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_s.item.dx);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_s.item.x);
				(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_s.item.f)
				free (create {CE_VOID_POINTER}.make_cast (a_s))
			end
		end

	gsl_root_fsolver_alloc (a_T: CE_POINTER [PD_GSL_ROOT_FSOLVER_TYPE]): CE_POINTER [PD_GSL_ROOT_FSOLVER]
		local
			l_s: CE_POINTER [PD_GSL_ROOT_FSOLVER]
			l_return, l_break: BOOLEAN
		do
			l_s := create {CE_CLASS_POINTER [PD_GSL_ROOT_FSOLVER]}.make_cast ((malloc ((create {PD_GSL_ROOT_FSOLVER}.make).structure_size.to_natural_32)))
			if l_s.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for root solver struct"), ce_string ("fsolver.c"), 34, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_ROOT_FSOLVER]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s.item.state := malloc (a_T.item.size)
				if (l_s.item.state).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for root solver state"), ce_string ("fsolver.c"), 44, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_ROOT_FSOLVER]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_s.item.type := a_T
				l_s.item.function := create {CE_CLASS_POINTER [PD_GSL_FUNCTION_STRUCT]}.make_shared (default_pointer)
				Result := l_s
			end
		end

	gsl_root_fsolver_free (a_s: CE_POINTER [PD_GSL_ROOT_FSOLVER])
		local
			l_return: BOOLEAN
		do
			if a_s.is_void then
				l_return := True
			end
			if not l_return then
				free (a_s.item.state)
				free (create {CE_VOID_POINTER}.make_cast (a_s))
			end
		end

end
