class
	P_FWRITE_SOURCE_STATIC

inherit
	CE_UTILITIES
	S_STDIO_STATIC

feature {ANY} -- public routines

	gsl_block_complex_long_double_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_96]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_VOID_POINTER}.make_cast (a_data), {NATURAL_32} 2 * {CE_UTILITIES}.Real_96_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_VOID_POINTER}.make_cast ((a_data + (({NATURAL_32} 2 * l_i) * a_stride).to_integer_32)), {NATURAL_32} 2 * {CE_UTILITIES}.Real_96_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_complex_long_double_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_96]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_VOID_POINTER}.make_cast (a_data), {NATURAL_32} 2 * {CE_UTILITIES}.Real_96_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_VOID_POINTER}.make_cast ((a_data + (({NATURAL_32} 2 * l_i) * a_stride).to_integer_32)), {NATURAL_32} 2 * {CE_UTILITIES}.Real_96_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_complex_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_64]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_VOID_POINTER}.make_cast (a_data), {NATURAL_32} 2 * {PLATFORM}.Real_64_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_VOID_POINTER}.make_cast ((a_data + (({NATURAL_32} 2 * l_i) * a_stride).to_integer_32)), {NATURAL_32} 2 * {PLATFORM}.Real_64_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_complex_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_64]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_VOID_POINTER}.make_cast (a_data), {NATURAL_32} 2 * {PLATFORM}.Real_64_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_VOID_POINTER}.make_cast ((a_data + (({NATURAL_32} 2 * l_i) * a_stride).to_integer_32)), {NATURAL_32} 2 * {PLATFORM}.Real_64_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_complex_float_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_VOID_POINTER}.make_cast (a_data), {NATURAL_32} 2 * {PLATFORM}.Real_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_VOID_POINTER}.make_cast ((a_data + (({NATURAL_32} 2 * l_i) * a_stride).to_integer_32)), {NATURAL_32} 2 * {PLATFORM}.Real_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_complex_float_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_VOID_POINTER}.make_cast (a_data), {NATURAL_32} 2 * {PLATFORM}.Real_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_VOID_POINTER}.make_cast ((a_data + (({NATURAL_32} 2 * l_i) * a_stride).to_integer_32)), {NATURAL_32} 2 * {PLATFORM}.Real_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_long_double_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_96]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_VOID_POINTER}.make_cast (a_data), {CE_UTILITIES}.Real_96_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {CE_UTILITIES}.Real_96_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_long_double_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_96]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_VOID_POINTER}.make_cast (a_data), {CE_UTILITIES}.Real_96_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {CE_UTILITIES}.Real_96_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_64]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Real_64_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Real_64_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_64]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Real_64_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Real_64_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_float_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Real_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Real_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_float_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Real_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Real_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_ulong_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Natural_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Natural_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_ulong_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Natural_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Natural_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_long_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Integer_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Integer_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_long_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Integer_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Integer_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_uint_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Natural_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Natural_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_uint_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Natural_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Natural_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_int_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Integer_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Integer_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_int_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_32]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Integer_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Integer_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_ushort_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_16]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Natural_16_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Natural_16_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_ushort_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_16]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Natural_16_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Natural_16_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_short_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_16]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Integer_16_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Integer_16_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_short_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_16]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Integer_16_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Integer_16_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_uchar_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_8]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Natural_8_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Natural_8_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_uchar_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_8]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Natural_8_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Natural_8_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_char_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_8]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Integer_8_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Integer_8_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_char_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_8]; a_n, a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_VOID_POINTER}.make_cast (a_data), {PLATFORM}.Integer_8_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_VOID_POINTER}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), {PLATFORM}.Integer_8_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

end
