class
	P_GAMMA_INC_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gamma_inc_P_series (a_a___5, a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_nmax: INTEGER_32
			l_D: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_D: INTEGER_32
			l_cf_res: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_tmp___1: REAL_64
			l_sum: REAL_64
			l_term: REAL_64
			l_remainder___0: REAL_64
			l_n: INTEGER_32
			l_nlow: INTEGER_32
			l_tmp___3: REAL_64
			l_tnp1: REAL_64
			l_tmp___5: REAL_64
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_D.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_cf_res.make (<<1>>)

			l_nmax := 10_000
			l_stat_D := (l_D.item.gamma_inc_D (a_a___5, a_x))
			if a_x > 0.995 * a_a___5 then
				if a_a___5 > 1.e5 then
					l_status := (l_cf_res.item.gsl_sf_exprel_n_CF_e (a_a___5, a_x))
					a_result.item.val := l_D.item.val * l_cf_res.item.val
					l_tmp___1 := fabs (l_D.item.val * l_cf_res.item.err)
					a_result.item.err := l_tmp___1 + (fabs (l_D.item.err * l_cf_res.item.val))
					Result := l_status
					l_return := True
				end
			end
			if not l_return and then (a_x > a_a___5 + l_nmax.to_double) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gamma_inc_P_series x>>a exceeds range"), ce_string ("gamma_inc.c"), 107, 11)
					Result := 11
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_sum := 1.0
				l_term := 1.0
				if a_x > a_a___5 then
					l_tmp___3 := a_x - a_a___5
				else
					l_tmp___3 := (0).to_double
				end
				l_nlow := l_tmp___3.truncated_to_integer
				l_n := 1
				from
				until
					not (l_n < l_nlow)
				loop
					l_term := l_term * (a_x / (a_a___5 + l_n.to_double))
					l_sum := l_sum + l_term
					l_n := l_n + 1
				end
				from
				until
					not (not (l_break) and then (l_n < l_nmax))
				loop
					l_break := False
					l_term := l_term * (a_x / (a_a___5 + l_n.to_double))
					l_sum := l_sum + l_term
					if (fabs (l_term / l_sum)) < 2.2204460492503131e-16 then
						l_break := True
					end
					if not (l_return or l_break) then
						l_n := l_n + 1
					end
				end
				l_break := False
				l_tnp1 := (a_x / (a_a___5 + l_n.to_double)) * l_term
				l_remainder___0 := l_tnp1 / (1.0 - a_x / ((a_a___5 + l_n.to_double) + 1.0))
				a_result.item.val := l_D.item.val * l_sum
				l_tmp___5 := fabs (l_sum)
				a_result.item.err := l_D.item.err * l_tmp___5 + (fabs (l_D.item.val * l_remainder___0))
				a_result.item.err := a_result.item.err + (((1.0 + l_n.to_double) * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				if l_n = l_nmax then
					if (fabs (l_remainder___0 / l_sum)) > 1.4901161193847656e-08 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("gamma_inc_P_series failed to converge"), ce_string ("gamma_inc.c"), 146, 11)
							Result := 11
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					else
						Result := l_stat_D
						l_return := True
					end
				else
					Result := l_stat_D
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_sf_gamma_inc_P_e (a_a___5, a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
			l_Q___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_Q: INTEGER_32
			l_Q___2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_Q___0: INTEGER_32
			l_Q___3: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_Q___1: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_Q___1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_Q___2.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_Q___3.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_a___5 <= 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 3 then -- else:
						if not (a_x < 0.0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___0:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("domain error"), ce_string ("gamma_inc.c"), 584, 1)
								Result := 1
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else:
						if a_x /= 0.0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						a_result.item.val := 0.0
						a_result.item.err := 0.0
						Result := 0
						l_return := True
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 9 then -- else:
						if not (a_x < 20.0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_tmp___1 := gamma_inc_P_series (a_a___5, a_x, a_result)
						Result := l_tmp___1
						l_return := True
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 12 then -- else:
						if not (a_x < 0.5 * a_a___5) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_tmp___1 := gamma_inc_P_series (a_a___5, a_x, a_result)
						Result := l_tmp___1
						l_return := True
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else:
						if not (a_a___5 > 1.0e+06) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if (a_x - a_a___5) * (a_x - a_a___5) < a_a___5 then
							l_stat_Q := (l_Q___1.item.gamma_inc_Q_asymp_unif (a_a___5, a_x))
							a_result.item.val := 1.0 - l_Q___1.item.val
							a_result.item.err := l_Q___1.item.err
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := l_stat_Q
							l_return := True
						else
							l_pos := -1 + 18 -- goto _L
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:
						if a_a___5 <= a_x then
							if a_a___5 > 0.2 * a_x then
								l_stat_Q___0 := l_Q___2.item.gamma_inc_Q_CF (a_a___5, a_x)
							else
								l_stat_Q___0 := l_Q___2.item.gamma_inc_Q_large_x (a_a___5, a_x)
							end
							a_result.item.val := 1.0 - l_Q___2.item.val
							a_result.item.err := l_Q___2.item.err
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := l_stat_Q___0
							l_return := True
						elseif (a_x - a_a___5) * (a_x - a_a___5) < a_a___5 then
							l_stat_Q___1 := (l_Q___3.item.gamma_inc_Q_CF (a_a___5, a_x))
							a_result.item.val := 1.0 - l_Q___3.item.val
							a_result.item.err := l_Q___3.item.err
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := l_stat_Q___1
							l_return := True
						else
							Result := (gamma_inc_P_series (a_a___5, a_x, a_result))
							l_return := True
						end
				when 19 then -- if done | if done | if done | if done | if done
					if not l_return then
						Result := 0
					end
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_gamma_inc_P (a_a___5, a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (gsl_sf_gamma_inc_P_e (a_a___5, a_x, l_result))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_gamma_inc_P_e(a, x, &result)"), ce_string ("gamma_inc.c"), 710, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_gamma_inc_Q (a_a___5, a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_gamma_inc_Q_e (a_a___5, a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_gamma_inc_Q_e(a, x, &result)"), ce_string ("gamma_inc.c"), 715, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_gamma_inc (a_a___5, a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_gamma_inc_e (a_a___5, a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_gamma_inc_e(a, x, &result)"), ce_string ("gamma_inc.c"), 720, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

end
