class
	P_GENSYMM_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_eigen_gensymm_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_EIGEN_GENSYMM_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_EIGEN_GENSYMM_WORKSPACE]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension must be positive integer"), ce_string ("gensymm.c"), 55, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_GENSYMM_WORKSPACE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_w := create {CE_CLASS_POINTER [PD_GSL_EIGEN_GENSYMM_WORKSPACE]}.make_cast ((calloc ((1).to_natural_32, (create {PD_GSL_EIGEN_GENSYMM_WORKSPACE}.make).structure_size.to_natural_32)))
				if l_w.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for workspace"), ce_string ("gensymm.c"), 62, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_GENSYMM_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.size := a_n
				l_w.item.symm_workspace_p := (create {P_SYMM_STATIC}).gsl_eigen_symm_alloc (a_n)
				if (l_w.item.symm_workspace_p).is_void then
					gsl_eigen_gensymm_free (l_w)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for symm workspace"), ce_string ("gensymm.c"), 71, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_GENSYMM_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := l_w
			end
		end

	gsl_eigen_gensymm_free (a_w: CE_POINTER [PD_GSL_EIGEN_GENSYMM_WORKSPACE])
		local
			l_return: BOOLEAN
		do
			if a_w.is_void then
				l_return := True
			end
			if not l_return then
				if (not (a_w.item.symm_workspace_p).is_void) then
					(create {P_SYMM_STATIC}).gsl_eigen_symm_free (a_w.item.symm_workspace_p)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_w))
			end
		end

end
