class
	P_GENV_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_eigen_genv_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_n = {NATURAL_32} 0 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension must be positive integer"), ce_string ("genv.c"), 68, 4)
							Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]}.make_shared (default_pointer))
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_w := create {CE_CLASS_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]}.make_cast ((calloc ((1).to_natural_32, (create {PD_GSL_EIGEN_GENV_WORKSPACE}.make).structure_size.to_natural_32)))
						if l_w.is_void then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for workspace"), ce_string ("genv.c"), 75, 8)
								Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]}.make_shared (default_pointer))
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_w.item.size := a_n
						l_w.item.Q := create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
						l_w.item.Z := create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (default_pointer)
						l_w.item.gen_workspace_p := (create {P_GEN_STATIC}).gsl_eigen_gen_alloc (a_n)
						if (l_w.item.gen_workspace_p).is_void then
							gsl_eigen_genv_free (l_w)
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for gen workspace"), ce_string ("genv.c"), 87, 8)
								Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]}.make_shared (default_pointer))
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if l_return then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:;
						(l_w.item.gen_workspace_p).item.gsl_eigen_gen_params (1, 1, 1)
						l_w.item.work1 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_n)
						l_w.item.work2 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_n)
						l_w.item.work3 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_n)
						l_w.item.work4 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_n)
						l_w.item.work5 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_n)
						l_w.item.work6 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_n)
						if not ((l_w.item.work1).is_void) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 4 then -- else:
						if not ((l_w.item.work2).is_void) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 7 then -- else:
						if not ((l_w.item.work3).is_void) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 10 then -- else:
						if not ((l_w.item.work4).is_void) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 13 then -- else:
						if not ((l_w.item.work5).is_void) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if not ((l_w.item.work6).is_void) then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L:
						gsl_eigen_genv_free (l_w)
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for additional workspace"), ce_string ("genv.c"), 104, 8)
							Result := (create {CE_CLASS_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE]}.make_shared (default_pointer))
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 18 then -- if done | if done | if done | if done | if done | if done
					if not l_return then
						Result := l_w
					end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_eigen_genv_free (a_w: CE_POINTER [PD_GSL_EIGEN_GENV_WORKSPACE])
		local
			l_return: BOOLEAN
		do
			if a_w.is_void then
				l_return := True
			end
			if not l_return then
				if (not (a_w.item.gen_workspace_p).is_void) then
					(create {P_GEN_STATIC}).gsl_eigen_gen_free (a_w.item.gen_workspace_p)
				end
				if (not (a_w.item.work1).is_void) then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_w.item.work1)
				end
				if (not (a_w.item.work2).is_void) then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_w.item.work2)
				end
				if (not (a_w.item.work3).is_void) then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_w.item.work3)
				end
				if (not (a_w.item.work4).is_void) then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_w.item.work4)
				end
				if (not (a_w.item.work5).is_void) then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_w.item.work5)
				end
				if (not (a_w.item.work6).is_void) then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (a_w.item.work6)
				end
				free (create {CE_VOID_POINTER}.make_cast (a_w))
			end
		end

end
