class
	P_HYBRIDJ_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	hybridj_type: CE_STATIC [CE_ARRAY [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]}.make_initialized (<<
					create {PD_GSL_MULTIROOT_FDFSOLVER_TYPE}.make_initialized ([ce_string ("hybridj"), (create {PD_HYBRIDJ_STATE_T}.make).structure_size.to_natural_32, hybridj_alloc_address, (create {PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT_STATIC}).hybridj_set_address, (create {PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT_STATIC}).hybridj_iterate_address, hybridj_free_address])
				>>)
		end

	hybridsj_type: CE_STATIC [CE_ARRAY [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]}.make_initialized (<<
					create {PD_GSL_MULTIROOT_FDFSOLVER_TYPE}.make_initialized ([ce_string ("hybridsj"), (create {PD_HYBRIDJ_STATE_T}.make).structure_size.to_natural_32, hybridj_alloc_address, (create {PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT_STATIC}).hybridsj_set_address, (create {PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT_STATIC}).hybridsj_iterate_address, hybridj_free_address])
				>>)
		end

	gsl_multiroot_fdfsolver_hybridj: CE_STATIC [CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := hybridj_type.item
		end

	gsl_multiroot_fdfsolver_hybridsj: CE_STATIC [CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := hybridsj_type.item
		end

feature {ANY} -- public routines

	hybridj_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_HYBRIDJ_STATE_T]
			l_q___3: CE_POINTER [PD_GSL_MATRIX]
			l_r___3: CE_POINTER [PD_GSL_MATRIX]
			l_tau: CE_POINTER [PD_GSL_VECTOR]
			l_diag: CE_POINTER [PD_GSL_VECTOR]
			l_qtf: CE_POINTER [PD_GSL_VECTOR]
			l_newton: CE_POINTER [PD_GSL_VECTOR]
			l_gradient: CE_POINTER [PD_GSL_VECTOR]
			l_x_trial: CE_POINTER [PD_GSL_VECTOR]
			l_f_trial: CE_POINTER [PD_GSL_VECTOR]
			l_df: CE_POINTER [PD_GSL_VECTOR]
			l_qtdf: CE_POINTER [PD_GSL_VECTOR]
			l_rdx: CE_POINTER [PD_GSL_VECTOR]
			l_w: CE_POINTER [PD_GSL_VECTOR]
			l_v: CE_POINTER [PD_GSL_VECTOR]
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_HYBRIDJ_STATE_T]}.make_cast (a_vstate)
			l_q___3 := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_calloc (a_n, a_n)
			if l_q___3.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for q"), ce_string ("hybridj.c"), 81, 8)
					Result := 8
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.q := l_q___3
				l_r___3 := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_calloc (a_n, a_n)
				if l_r___3.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_q___3)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for r"), ce_string ("hybridj.c"), 92, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.r := l_r___3
				l_tau := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_tau.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_q___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for tau"), ce_string ("hybridj.c"), 104, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.tau := l_tau
				l_diag := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_diag.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_q___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for diag"), ce_string ("hybridj.c"), 117, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.diag := l_diag
				l_qtf := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_qtf.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_q___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for qtf"), ce_string ("hybridj.c"), 131, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.qtf := l_qtf
				l_newton := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_newton.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_q___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for newton"), ce_string ("hybridj.c"), 146, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.newton := l_newton
				l_gradient := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_gradient.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_q___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for gradient"), ce_string ("hybridj.c"), 162, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.gradient := l_gradient
				l_x_trial := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_x_trial.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_q___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_gradient)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for x_trial"), ce_string ("hybridj.c"), 179, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.x_trial := l_x_trial
				l_f_trial := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_f_trial.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_q___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_gradient);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_x_trial)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for f_trial"), ce_string ("hybridj.c"), 197, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.f_trial := l_f_trial
				l_df := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_df.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_q___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_gradient);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_x_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_f_trial)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for df"), ce_string ("hybridj.c"), 216, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.df := l_df
				l_qtdf := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_qtdf.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_q___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_gradient);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_x_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_f_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_df)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for qtdf"), ce_string ("hybridj.c"), 236, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.qtdf := l_qtdf
				l_rdx := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_rdx.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_q___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_gradient);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_x_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_f_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_df);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtdf)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for rdx"), ce_string ("hybridj.c"), 258, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.rdx := l_rdx
				l_w := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_w.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_q___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_gradient);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_x_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_f_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_df);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtdf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_rdx)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for w"), ce_string ("hybridj.c"), 280, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.w := l_w
				l_v := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_v.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_q___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_gradient);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_x_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_f_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_df);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtdf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_rdx);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_w)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for v"), ce_string ("hybridj.c"), 303, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.v := l_v
				Result := 0
			end
		end

	hybridj_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_HYBRIDJ_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_HYBRIDJ_STATE_T]}.make_cast (a_vstate);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.v);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.w);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.rdx);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.qtdf);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.df);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.f_trial);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x_trial);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.gradient);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.newton);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.qtf);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.diag);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.tau);
			(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_state.item.r);
			(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_state.item.q)
		end

feature {ANY} -- routine addresses

	hybridj_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent hybridj_alloc)
		end

	hybridj_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent hybridj_free)
		end

end
