class
	P_HYPERG_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_hypergeometric (a_r___3: CE_POINTER [PD_GSL_RNG]; a_n1, a_n2, a_t: NATURAL_32): NATURAL_32
		local
			l_t: NATURAL_32
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_a___5: NATURAL_32
			l_b___0: NATURAL_32
			l_k: NATURAL_32
			l_u: REAL_64
			l_u___0: REAL_64
			l_return: BOOLEAN
		do
			l_t := a_t
			l_n := a_n1 + a_n2
			l_i := {NATURAL_32} 0
			l_a___5 := a_n1
			l_b___0 := a_n1 + a_n2
			l_k := {NATURAL_32} 0
			if l_t > l_n then
				l_t := l_n
			end
			if l_t < l_n // {NATURAL_32} 2 then
				l_i := {NATURAL_32} 0
				from
				until
					not (not (l_return) and then (l_i < l_t))
				loop
					l_u := (a_r___3.item.gsl_rng_uniform)
					if l_b___0.to_real_64 * l_u < l_a___5.to_real_64 then
						l_k := l_k + 1
						if l_k = a_n1 then
							Result := l_k
							l_return := True
						end
						if not l_return then
							l_a___5 := l_a___5 - 1
						end
					end
					if not l_return then
						l_b___0 := l_b___0 - 1
						l_i := l_i + 1
					end
				end
				if not l_return then
					Result := l_k
				end
			else
				l_i := {NATURAL_32} 0
				from
				until
					not (not (l_return) and then (l_i < l_n - l_t))
				loop
					l_u___0 := (a_r___3.item.gsl_rng_uniform)
					if l_b___0.to_real_64 * l_u___0 < l_a___5.to_real_64 then
						l_k := l_k + 1
						if l_k = a_n1 then
							Result := (a_n1 - l_k)
							l_return := True
						end
						if not l_return then
							l_a___5 := l_a___5 - 1
						end
					end
					if not l_return then
						l_b___0 := l_b___0 - 1
						l_i := l_i + 1
					end
				end
				if not l_return then
					Result := (a_n1 - l_k)
				end
			end
		end

	gsl_ran_hypergeometric_pdf (a_k, a_n1, a_n2, a_t: NATURAL_32): REAL_64
		local
			l_t: NATURAL_32
			l_p: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_t := a_t
					if l_t > a_n1 + a_n2 then
						l_t := a_n1 + a_n2
					end
					if not (a_k > a_n1) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Result := (0).to_double
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if not (a_k > l_t) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (0).to_double
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (l_t > a_n2) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_k + a_n2 < l_t then
							Result := (0).to_double
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						l_c1___2 := ((create {P_GAMMA_STATIC}).gsl_sf_lnchoose (a_n1, a_k))
						l_c2___0 := ((create {P_GAMMA_STATIC}).gsl_sf_lnchoose (a_n2, l_t - a_k))
						l_c3___3 := ((create {P_GAMMA_STATIC}).gsl_sf_lnchoose (a_n1 + a_n2, l_t))
						l_p := exp ((l_c1___2 + l_c2___0) - l_c3___3)
						Result := l_p
				when 10 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
