class
	P_INIT_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_cheb_alloc (a_order: NATURAL_32): CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT]
		local
			l_cs: CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT]
			l_return, l_break: BOOLEAN
		do
			l_cs := create {CE_CLASS_POINTER [PD_GSL_CHEB_SERIES_STRUCT]}.make_cast ((malloc ((create {PD_GSL_CHEB_SERIES_STRUCT}.make).structure_size.to_natural_32)))
			if l_cs.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate gsl_cheb_series struct"), ce_string ("init.c"), 35, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_CHEB_SERIES_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_cs.item.order := a_order
				l_cs.item.order_sp := a_order
				l_cs.item.c := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_order + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_cs.item.c).is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate cheb coefficients"), ce_string ("init.c"), 44, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_CHEB_SERIES_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_cs.item.f := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_order + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_cs.item.f).is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate cheb function space"), ce_string ("init.c"), 50, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_CHEB_SERIES_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := l_cs
			end
		end

	gsl_cheb_free (a_cs: CE_POINTER [PD_GSL_CHEB_SERIES_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_cs.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_cs.item.f))
				free (create {CE_VOID_POINTER}.make_cast (a_cs.item.c))
				free (create {CE_VOID_POINTER}.make_cast (a_cs))
			end
		end

	gsl_histogram_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_HISTOGRAM]
		local
			l_h: CE_POINTER [PD_GSL_HISTOGRAM]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("histogram length n must be positive integer"), ce_string ("init.c"), 33, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_h := create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM]}.make_cast ((malloc ((create {PD_GSL_HISTOGRAM}.make).structure_size.to_natural_32)))
				if l_h.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram struct"), ce_string ("init.c"), 41, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_h.item.range := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_n + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_h.item.range).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_h))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram ranges"), ce_string ("init.c"), 51, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_h.item.bin := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_h.item.bin).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_h.item.range))
					free (create {CE_VOID_POINTER}.make_cast (l_h))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram bins"), ce_string ("init.c"), 62, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_h.item.n := a_n
				Result := l_h
			end
		end

	make_uniform___0 (a_range: CE_POINTER [REAL_64]; a_n: NATURAL_32; a_xmin, a_xmax: REAL_64)
		local
			l_i: NATURAL_32
			l_f1: REAL_64
			l_f2: REAL_64
		do
			l_i := (0).to_natural_32
			from
			until
				not (l_i <= a_n)
			loop
				l_f1 := (a_n - l_i).to_real_64 / a_n.to_real_64
				l_f2 := l_i.to_real_64 / a_n.to_real_64
				a_range[l_i.to_integer_32] := l_f1 * a_xmin + l_f2 * a_xmax
				l_i := l_i + 1
			end
		end

	gsl_histogram_calloc_uniform (a_n: NATURAL_32; a_xmin, a_xmax: REAL_64): CE_POINTER [PD_GSL_HISTOGRAM]
		local
			l_h: CE_POINTER [PD_GSL_HISTOGRAM]
			l_return, l_break: BOOLEAN
		do
			if a_xmin >= a_xmax then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("xmin must be less than xmax"), ce_string ("init.c"), 91, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_h := gsl_histogram_calloc (a_n)
				if l_h.is_void then
					Result := l_h
					l_return := True
				end
			end
			if not l_return then
				make_uniform___0 (l_h.item.range, a_n, a_xmin, a_xmax)
				Result := l_h
			end
		end

	gsl_histogram_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_HISTOGRAM]
		local
			l_h: CE_POINTER [PD_GSL_HISTOGRAM]
			l_i: NATURAL_32
			l_return: BOOLEAN
		do
			l_h := (gsl_histogram_alloc (a_n))
			if l_h.is_void then
				Result := l_h
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n + {NATURAL_32} 1)
				loop
					l_h.item.range[l_i.to_integer_32] := l_i.to_real_64
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_h.item.bin[l_i.to_integer_32] := (0).to_double
					l_i := l_i + 1
				end
				l_h.item.n := a_n
				Result := l_h
			end
		end

	gsl_histogram_free (a_h: CE_POINTER [PD_GSL_HISTOGRAM])
		local
			l_return: BOOLEAN
		do
			if a_h.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_h.item.range))
				free (create {CE_VOID_POINTER}.make_cast (a_h.item.bin))
				free (create {CE_VOID_POINTER}.make_cast (a_h))
			end
		end

	gsl_permutation_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
		local
			l_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("permutation length n must be positive integer"), ce_string ("init.c"), 33, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_PERMUTATION_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_p := create {CE_CLASS_POINTER [PD_GSL_PERMUTATION_STRUCT]}.make_cast ((malloc ((create {PD_GSL_PERMUTATION_STRUCT}.make).structure_size.to_natural_32)))
				if l_p.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for permutation struct"), ce_string ("init.c"), 41, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_PERMUTATION_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_p.item.data := create {CE_NATURAL_32_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Natural_32_bytes.to_natural_32)))
				if (l_p.item.data).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_p))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for permutation data"), ce_string ("init.c"), 51, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_PERMUTATION_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_p.item.size := a_n
				Result := l_p
			end
		end

	gsl_permutation_calloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
		local
			l_i: NATURAL_32
			l_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_return: BOOLEAN
		do
			l_p := (gsl_permutation_alloc (a_n))
			if l_p.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_PERMUTATION_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					l_p.item.data[l_i.to_integer_32] := l_i
					l_i := l_i + 1
				end
				Result := l_p
			end
		end

	gsl_permutation_free (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_p.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_p.item.data))
				free (create {CE_VOID_POINTER}.make_cast (a_p))
			end
		end

	gsl_combination_alloc (a_n, a_k: NATURAL_32): CE_POINTER [PD_GSL_COMBINATION_STRUCT]
		local
			l_c___1: CE_POINTER [PD_GSL_COMBINATION_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("combination parameter n must be positive integer"), ce_string ("init.c"), 35, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_COMBINATION_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_k > a_n) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("combination length k must be an integer less than or equal to n"), ce_string ("init.c"), 40, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_COMBINATION_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_c___1 := create {CE_CLASS_POINTER [PD_GSL_COMBINATION_STRUCT]}.make_cast ((malloc ((create {PD_GSL_COMBINATION_STRUCT}.make).structure_size.to_natural_32)))
				if l_c___1.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for combination struct"), ce_string ("init.c"), 47, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_COMBINATION_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				if a_k > {NATURAL_32} 0 then
					l_c___1.item.data := create {CE_NATURAL_32_POINTER}.make_cast ((malloc (a_k * {PLATFORM}.Natural_32_bytes.to_natural_32)))
					if (l_c___1.item.data).is_void then
						free (create {CE_VOID_POINTER}.make_cast (l_c___1))
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for combination data"), ce_string ("init.c"), 59, 8)
							Result := (create {CE_CLASS_POINTER [PD_GSL_COMBINATION_STRUCT]}.make_shared (default_pointer))
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				else
					l_c___1.item.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				end
			end
			if not l_return then
				l_c___1.item.n := a_n
				l_c___1.item.k := a_k
				Result := l_c___1
			end
		end

	gsl_combination_calloc (a_n, a_k: NATURAL_32): CE_POINTER [PD_GSL_COMBINATION_STRUCT]
		local
			l_i: NATURAL_32
			l_c___1: CE_POINTER [PD_GSL_COMBINATION_STRUCT]
			l_return: BOOLEAN
		do
			l_c___1 := (gsl_combination_alloc (a_n, a_k))
			if l_c___1.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_COMBINATION_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_k)
				loop
					l_c___1.item.data[l_i.to_integer_32] := l_i
					l_i := l_i + 1
				end
				Result := l_c___1
			end
		end

	gsl_combination_free (a_c___1: CE_POINTER [PD_GSL_COMBINATION_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_c___1.is_void then
				l_return := True
			end
			if not l_return then
				if a_c___1.item.k > {NATURAL_32} 0 then
					free (create {CE_VOID_POINTER}.make_cast (a_c___1.item.data))
				end
				free (create {CE_VOID_POINTER}.make_cast (a_c___1))
			end
		end

	gsl_multiset_alloc (a_n, a_k: NATURAL_32): CE_POINTER [PD_GSL_MULTISET_STRUCT]
		local
			l_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("multiset parameter n must be positive integer"), ce_string ("init.c"), 37, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MULTISET_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_k > a_n) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("multiset length k must be an integer less than or equal to n"), ce_string ("init.c"), 42, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_MULTISET_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_c___1 := create {CE_CLASS_POINTER [PD_GSL_MULTISET_STRUCT]}.make_cast ((malloc ((create {PD_GSL_MULTISET_STRUCT}.make).structure_size.to_natural_32)))
				if l_c___1.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for multiset struct"), ce_string ("init.c"), 49, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_MULTISET_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				if a_k > {NATURAL_32} 0 then
					l_c___1.item.data := create {CE_NATURAL_32_POINTER}.make_cast ((malloc (a_k * {PLATFORM}.Natural_32_bytes.to_natural_32)))
					if (l_c___1.item.data).is_void then
						free (create {CE_VOID_POINTER}.make_cast (l_c___1))
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for multiset data"), ce_string ("init.c"), 61, 8)
							Result := (create {CE_CLASS_POINTER [PD_GSL_MULTISET_STRUCT]}.make_shared (default_pointer))
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				else
					l_c___1.item.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				end
			end
			if not l_return then
				l_c___1.item.n := a_n
				l_c___1.item.k := a_k
				Result := l_c___1
			end
		end

	gsl_multiset_calloc (a_n, a_k: NATURAL_32): CE_POINTER [PD_GSL_MULTISET_STRUCT]
		local
			l_i: NATURAL_32
			l_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT]
			l_return: BOOLEAN
		do
			l_c___1 := (gsl_multiset_alloc (a_n, a_k))
			if l_c___1.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_MULTISET_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_k)
				loop
					l_c___1.item.data[l_i.to_integer_32] := (0).to_natural_32
					l_i := l_i + 1
				end
				Result := l_c___1
			end
		end

	gsl_multiset_free (a_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_c___1.is_void then
				l_return := True
			end
			if not l_return then
				if a_c___1.item.k > {NATURAL_32} 0 then
					free (create {CE_VOID_POINTER}.make_cast (a_c___1.item.data))
				end
				free (create {CE_VOID_POINTER}.make_cast (a_c___1))
			end
		end

end
