class
	P_INVHYP_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gsl_acosh (a_x: REAL_64): REAL_64
		local
			l_t: REAL_64
		do
			if a_x > 1.0 / 1.4901161193847656e-08 then
				Result := ((log (a_x)) + 0.69314718055994530942)
			elseif a_x > (2).to_double then
				Result := (log ((2).to_double * a_x - (1).to_double / ((sqrt (a_x * a_x - (1).to_double)) + a_x)))
			elseif a_x > (1).to_double then
				l_t := a_x - (1).to_double
				Result := (log1p (l_t + (sqrt ((2).to_double * l_t + l_t * l_t))))
			elseif a_x = (1).to_double then
				Result := (0).to_double
			else
				Result := (builtin_nanf (ce_string (""))).to_double
			end
		end

	gsl_asinh (a_x: REAL_64): REAL_64
		local
			l_a___5: REAL_64
			l_s: REAL_64
			l_tmp___0: INTEGER_32
			l_a2___3: REAL_64
		do
			l_a___5 := (fabs (a_x))
			if a_x < (0).to_double then
				l_tmp___0 := -1
			else
				l_tmp___0 := 1
			end
			l_s := l_tmp___0.to_double
			if l_a___5 > (1).to_double / 1.4901161193847656e-08 then
				Result := (l_s * ((log (l_a___5)) + 0.69314718055994530942))
			elseif l_a___5 > (2).to_double then
				Result := (l_s * (log ((2).to_double * l_a___5 + (1).to_double / (l_a___5 + (sqrt (l_a___5 * l_a___5 + (1).to_double))))))
			elseif l_a___5 > 1.4901161193847656e-08 then
				l_a2___3 := l_a___5 * l_a___5
				Result := (l_s * (log1p (l_a___5 + l_a2___3 / ((1).to_double + (sqrt ((1).to_double + l_a2___3))))))
			else
				Result := a_x
			end
		end

	gsl_atanh (a_x: REAL_64): REAL_64
		local
			l_a___5: REAL_64
			l_s: REAL_64
			l_tmp___0: INTEGER_32
			l_tmp___4: REAL_32
		do
			l_a___5 := (fabs (a_x))
			if a_x < (0).to_double then
				l_tmp___0 := -1
			else
				l_tmp___0 := 1
			end
			l_s := l_tmp___0.to_double
			if l_a___5 > (1).to_double then
				Result := (builtin_nanf (ce_string (""))).to_double
			elseif l_a___5 = (1).to_double then
				if a_x < (0).to_double then
					l_tmp___4 := -(builtin_inff)
				else
					l_tmp___4 := (builtin_inff)
				end
				Result := l_tmp___4.to_double
			elseif l_a___5 >= 0.5 then
				Result := ((l_s * 0.5) * (log1p (((2).to_double * l_a___5) / ((1).to_double - l_a___5))))
			elseif l_a___5 > 2.2204460492503131e-16 then
				Result := ((l_s * 0.5) * (log1p ((2).to_double * l_a___5 + (((2).to_double * l_a___5) * l_a___5) / ((1).to_double - l_a___5))))
			else
				Result := a_x
			end
		end

end
