class
	P_LMITERATE_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	iterate (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT]; a_x, a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]; a_scale: INTEGER_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_LMDER_STATE_T]
			l_r___3: CE_POINTER [PD_GSL_MATRIX]
			l_tau: CE_POINTER [PD_GSL_VECTOR]
			l_diag: CE_POINTER [PD_GSL_VECTOR]
			l_qtf: CE_POINTER [PD_GSL_VECTOR]
			l_x_trial: CE_POINTER [PD_GSL_VECTOR]
			l_f_trial: CE_POINTER [PD_GSL_VECTOR]
			l_rptdx: CE_POINTER [PD_GSL_VECTOR]
			l_newton: CE_POINTER [PD_GSL_VECTOR]
			l_gradient: CE_POINTER [PD_GSL_VECTOR]
			l_sdiag: CE_POINTER [PD_GSL_VECTOR]
			l_w: CE_POINTER [PD_GSL_VECTOR]
			l_work1: CE_POINTER [PD_GSL_VECTOR]
			l_perm: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_prered: REAL_64
			l_actred: REAL_64
			l_pnorm: REAL_64
			l_fnorm1: REAL_64
			l_fnorm1p: REAL_64
			l_gnorm: REAL_64
			l_ratio: REAL_64
			l_dirder: REAL_64
			l_iter: INTEGER_32
			l_p1: REAL_64
			l_p25: REAL_64
			l_p5: REAL_64
			l_p75: REAL_64
			l_p0001: REAL_64
			l_iamax: NATURAL_32
			l_status: INTEGER_32
			l_status___0: INTEGER_32
			l_t1: REAL_64
			l_t2: REAL_64
			l_temp: REAL_64
			l_tmp___4: REAL_64
			l_status___1: INTEGER_32
			l_signum: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_signum.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state := create {CE_CLASS_POINTER [PD_LMDER_STATE_T]}.make_cast (a_vstate)
					l_r___3 := l_state.item.r
					l_tau := l_state.item.tau
					l_diag := l_state.item.diag
					l_qtf := l_state.item.qtf
					l_x_trial := l_state.item.x_trial
					l_f_trial := l_state.item.f_trial
					l_rptdx := l_state.item.rptdx
					l_newton := l_state.item.newton
					l_gradient := l_state.item.gradient
					l_sdiag := l_state.item.sdiag
					l_w := l_state.item.w
					l_work1 := l_state.item.work1
					l_perm := l_state.item.perm
					l_iter := 0
					l_p1 := 0.1
					l_p25 := 0.25
					l_p5 := 0.5
					l_p75 := 0.75
					l_p0001 := 0.0001
					if l_state.item.fnorm = 0.0 then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_qtf.item.gsl_vector_memcpy (a_f).do_nothing
						l_r___3.item.gsl_linalg_QR_QTvec (l_tau, l_qtf).do_nothing
						l_r___3.item.compute_gradient_direction (l_perm, l_qtf, l_diag, l_gradient)
						l_iamax := (l_gradient.item.gsl_blas_idamax)
						l_gnorm := fabs ((l_gradient.item.gsl_vector_get (l_iamax)) / l_state.item.fnorm)
				when 2 then -- lm_iteration:
						l_iter := l_iter + 1
						l_status := (l_r___3.item.lmpar (l_perm, l_qtf, l_diag, l_state.item.delta, create {CE_REAL_64_POINTER}.make_shared (l_state.c_pointer + (create {PD_LMDER_STATE_T}.make).offset_of ("par")), l_newton, l_gradient, l_sdiag, a_dx, l_w))
						if l_status.to_boolean then
							Result := l_status
							l_return := True
						end
				when 3 then -- if done
					if not l_return then
						a_dx.item.gsl_vector_scale (-1.0).do_nothing
						a_x.item.compute_trial_step (a_dx, l_state.item.x_trial)
						l_pnorm := (create {P_LMUTIL_STATIC}).scaled_enorm (l_diag, a_dx)
						if l_state.item.iter = {NATURAL_32} 1 then
							if l_pnorm < l_state.item.delta then
								l_state.item.delta := l_pnorm
							end
						end
						l_status___0 := ((a_fdf.item.f).integer_32_item ([l_x_trial, a_fdf.item.params, l_f_trial]))
						if l_status___0.to_boolean then
							Result := l_status___0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 4 then -- if:
						l_fnorm1 := l_f_trial.item.enorm
						l_actred := (create {P_LMUTIL_STATIC}).compute_actual_reduction (l_state.item.fnorm, l_fnorm1);
						(create {P_LMUTIL_STATIC}).compute_rptdx (l_r___3, l_perm, a_dx, l_rptdx)
						l_fnorm1p := l_rptdx.item.enorm
						l_t1 := l_fnorm1p / l_state.item.fnorm
						l_t2 := ((sqrt (l_state.item.par)) * l_pnorm) / l_state.item.fnorm
						l_prered := l_t1 * l_t1 + (l_t2 * l_t2) / l_p5
						l_dirder := -(l_t1 * l_t1 + l_t2 * l_t2)
						if l_prered > (0).to_double then
							l_ratio := l_actred / l_prered
						else
							l_ratio := (0).to_double
						end
						if l_ratio > l_p25 then
							if l_state.item.par = (0).to_double then
								l_state.item.delta := l_pnorm / l_p5
								l_state.item.par := l_state.item.par * l_p5
							elseif l_ratio >= l_p75 then
								l_state.item.delta := l_pnorm / l_p5
								l_state.item.par := l_state.item.par * l_p5
							end
						else
							if l_actred >= (0).to_double then
								l_tmp___4 := l_p5
							else
								l_tmp___4 := (l_p5 * l_dirder) / (l_dirder + l_p5 * l_actred)
							end
							l_temp := l_tmp___4
							if l_p1 * l_fnorm1 >= l_state.item.fnorm then
								l_temp := l_p1
							elseif l_temp < l_p1 then
								l_temp := l_p1
							end
							l_state.item.delta := l_temp * ((create {P_GSL_GSL_MINMAX_STATIC}).GSL_MIN_DBL (l_state.item.delta, l_pnorm / l_p1))
							l_state.item.par := l_state.item.par / l_temp
						end
						if not (l_ratio >= l_p0001) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						a_x.item.gsl_vector_memcpy (l_x_trial).do_nothing
						a_f.item.gsl_vector_memcpy (l_f_trial).do_nothing
						l_status___1 := ((a_fdf.item.df).integer_32_item ([l_x_trial, a_fdf.item.params, a_J]))
						if l_status___1.to_boolean then
							Result := l_status___1
							l_return := True
						end
						if not l_return then
							l_state.item.xnorm := (create {P_LMUTIL_STATIC}).scaled_enorm (l_diag, a_x)
							l_state.item.fnorm := l_fnorm1
							l_state.item.iter := (l_state.item.iter) + 1
							if a_scale.to_boolean then
								(create {P_LMUTIL_STATIC}).update_diag (a_J, l_diag)
							end
							l_r___3.item.gsl_matrix_memcpy (a_J).do_nothing
							l_r___3.item.gsl_linalg_QRPT_decomp (l_tau, l_perm, l_signum, l_work1).do_nothing
							Result := 0
							l_return := True
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if not ((fabs (l_actred)) <= 2.2204460492503131e-16) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_prered <= 2.2204460492503131e-16 then
							if l_p5 * l_ratio <= 1.0 then
								Result := 29
								l_return := True
							else
								l_pos := -1 + 10 -- goto _L___0
							end
						else
							l_pos := -1 + 10 -- goto _L___0
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___0:
						if l_state.item.delta <= 2.2204460492503131e-16 * l_state.item.xnorm then
							Result := 30
							l_return := True
						elseif l_gnorm <= 2.2204460492503131e-16 then
							Result := 31
							l_return := True
						elseif l_iter < 10 then
							l_pos := -1 + 2 -- goto lm_iteration
						end
				when 11 then -- if done | if done
					if not l_return then
						Result := 27
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
