class
	P_LOGNORMALINV_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_cdf_lognormal_Pinv (a_P___2, a_zeta, a_sigma: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_u: REAL_64
			l_return: BOOLEAN
		do
			if a_P___2 = 1.0 then
				Result := (builtin_inff).to_double
				l_return := True
			elseif a_P___2 = 0.0 then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				l_u := (create {P_GAUSSINV_STATIC}).gsl_cdf_ugaussian_Pinv (a_P___2)
				l_x := exp (a_zeta + a_sigma * l_u)
				Result := l_x
			end
		end

	gsl_cdf_lognormal_Qinv (a_Q___1, a_zeta, a_sigma: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_u: REAL_64
			l_return: BOOLEAN
		do
			if a_Q___1 = 0.0 then
				Result := (builtin_inff).to_double
				l_return := True
			elseif a_Q___1 = 1.0 then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				l_u := (create {P_GAUSSINV_STATIC}).gsl_cdf_ugaussian_Qinv (a_Q___1)
				l_x := exp (a_zeta + a_sigma * l_u)
				Result := l_x
			end
		end

end
