class
	P_MINMAX_SOURCE_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_stats_long_double_max (a_data: CE_POINTER [REAL_96]; a_stride, a_n: NATURAL_32): REAL_96
		require
			not a_data.is_void
		local
			l_max: REAL_96
			l_i: NATURAL_32
			l_xi: REAL_96
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi > l_max then
					l_max := l_xi
				end
				if {CE_UTILITIES}.Real_96_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi.truncated_to_real_32))
				else
					if {CE_UTILITIES}.Real_96_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi.truncated_to_real_64))
					else
						l_tmp___2 := (isnanl (l_xi))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					Result := l_xi
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := l_max
			end
		end

	gsl_stats_long_double_min (a_data: CE_POINTER [REAL_96]; a_stride, a_n: NATURAL_32): REAL_96
		require
			not a_data.is_void
		local
			l_min: REAL_96
			l_i: NATURAL_32
			l_xi: REAL_96
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
				end
				if {CE_UTILITIES}.Real_96_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi.truncated_to_real_32))
				else
					if {CE_UTILITIES}.Real_96_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi.truncated_to_real_64))
					else
						l_tmp___2 := (isnanl (l_xi))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					Result := l_xi
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := l_min
			end
		end

	gsl_stats_long_double_minmax (a_min_out, a_max_out, a_data: CE_POINTER [REAL_96]; a_stride, a_n: NATURAL_32)
		require
			not a_min_out.is_void
			not a_max_out.is_void
			not a_data.is_void
		local
			l_min: REAL_96
			l_max: REAL_96
			l_i: NATURAL_32
			l_xi: REAL_96
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_break: BOOLEAN
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (not (l_break) and then (l_i < a_n))
			loop
				l_break := False
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
				end
				if l_xi > l_max then
					l_max := l_xi
				end
				if {CE_UTILITIES}.Real_96_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi.truncated_to_real_32))
				else
					if {CE_UTILITIES}.Real_96_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi.truncated_to_real_64))
					else
						l_tmp___2 := (isnanl (l_xi))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					l_min := l_xi
					l_max := l_xi
					l_break := True
				end
				if not (l_break) then
					l_i := l_i + 1
				end
			end
			l_break := False
			a_min_out.item := l_min
			a_max_out.item := l_max
		end

	gsl_stats_long_double_max_index (a_data: CE_POINTER [REAL_96]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_max: REAL_96
			l_i: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: REAL_96
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi > l_max then
					l_max := l_xi
					l_max_index := l_i
				end
				if {CE_UTILITIES}.Real_96_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi.truncated_to_real_32))
				else
					if {CE_UTILITIES}.Real_96_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi.truncated_to_real_64))
					else
						l_tmp___2 := (isnanl (l_xi))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					Result := l_i
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := l_max_index
			end
		end

	gsl_stats_long_double_min_index (a_data: CE_POINTER [REAL_96]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_min: REAL_96
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_xi: REAL_96
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
					l_min_index := l_i
				end
				if {CE_UTILITIES}.Real_96_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi.truncated_to_real_32))
				else
					if {CE_UTILITIES}.Real_96_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi.truncated_to_real_64))
					else
						l_tmp___2 := (isnanl (l_xi))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					Result := l_i
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := l_min_index
			end
		end

	gsl_stats_long_double_minmax_index (a_min_index_out, a_max_index_out: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [REAL_96]; a_stride, a_n: NATURAL_32)
		require
			not a_min_index_out.is_void
			not a_max_index_out.is_void
			not a_data.is_void
		local
			l_min: REAL_96
			l_max: REAL_96
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: REAL_96
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_break: BOOLEAN
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not (l_break) and then (l_i < a_n))
			loop
				l_break := False
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
					l_min_index := l_i
				end
				if l_xi > l_max then
					l_max := l_xi
					l_max_index := l_i
				end
				if {CE_UTILITIES}.Real_96_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi.truncated_to_real_32))
				else
					if {CE_UTILITIES}.Real_96_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi.truncated_to_real_64))
					else
						l_tmp___2 := (isnanl (l_xi))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					l_min_index := l_i
					l_max_index := l_i
					l_break := True
				end
				if not (l_break) then
					l_i := l_i + 1
				end
			end
			l_break := False
			a_min_index_out.item := l_min_index
			a_max_index_out.item := l_max_index
		end

	gsl_stats_max (a_data: CE_POINTER [REAL_64]; a_stride, a_n: NATURAL_32): REAL_64
		require
			not a_data.is_void
		local
			l_max: REAL_64
			l_i: NATURAL_32
			l_xi: REAL_64
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi > l_max then
					l_max := l_xi
				end
				if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi.truncated_to_real))
				else
					if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi))
					else
						l_tmp___2 := (isnanl (real_96_from_real_64 (l_xi)))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					Result := l_xi
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := l_max
			end
		end

	gsl_stats_min (a_data: CE_POINTER [REAL_64]; a_stride, a_n: NATURAL_32): REAL_64
		require
			not a_data.is_void
		local
			l_min: REAL_64
			l_i: NATURAL_32
			l_xi: REAL_64
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
				end
				if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi.truncated_to_real))
				else
					if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi))
					else
						l_tmp___2 := (isnanl (real_96_from_real_64 (l_xi)))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					Result := l_xi
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := l_min
			end
		end

	gsl_stats_minmax (a_min_out, a_max_out, a_data: CE_POINTER [REAL_64]; a_stride, a_n: NATURAL_32)
		require
			not a_min_out.is_void
			not a_max_out.is_void
			not a_data.is_void
		local
			l_min: REAL_64
			l_max: REAL_64
			l_i: NATURAL_32
			l_xi: REAL_64
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_break: BOOLEAN
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (not (l_break) and then (l_i < a_n))
			loop
				l_break := False
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
				end
				if l_xi > l_max then
					l_max := l_xi
				end
				if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi.truncated_to_real))
				else
					if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi))
					else
						l_tmp___2 := (isnanl (real_96_from_real_64 (l_xi)))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					l_min := l_xi
					l_max := l_xi
					l_break := True
				end
				if not (l_break) then
					l_i := l_i + 1
				end
			end
			l_break := False
			a_min_out.item := l_min
			a_max_out.item := l_max
		end

	gsl_stats_max_index (a_data: CE_POINTER [REAL_64]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_max: REAL_64
			l_i: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: REAL_64
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi > l_max then
					l_max := l_xi
					l_max_index := l_i
				end
				if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi.truncated_to_real))
				else
					if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi))
					else
						l_tmp___2 := (isnanl (real_96_from_real_64 (l_xi)))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					Result := l_i
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := l_max_index
			end
		end

	gsl_stats_min_index (a_data: CE_POINTER [REAL_64]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_min: REAL_64
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_xi: REAL_64
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
					l_min_index := l_i
				end
				if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi.truncated_to_real))
				else
					if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi))
					else
						l_tmp___2 := (isnanl (real_96_from_real_64 (l_xi)))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					Result := l_i
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := l_min_index
			end
		end

	gsl_stats_minmax_index (a_min_index_out, a_max_index_out: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [REAL_64]; a_stride, a_n: NATURAL_32)
		require
			not a_min_index_out.is_void
			not a_max_index_out.is_void
			not a_data.is_void
		local
			l_min: REAL_64
			l_max: REAL_64
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: REAL_64
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_break: BOOLEAN
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not (l_break) and then (l_i < a_n))
			loop
				l_break := False
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
					l_min_index := l_i
				end
				if l_xi > l_max then
					l_max := l_xi
					l_max_index := l_i
				end
				if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi.truncated_to_real))
				else
					if {PLATFORM}.Real_64_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi))
					else
						l_tmp___2 := (isnanl (real_96_from_real_64 (l_xi)))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					l_min_index := l_i
					l_max_index := l_i
					l_break := True
				end
				if not (l_break) then
					l_i := l_i + 1
				end
			end
			l_break := False
			a_min_index_out.item := l_min_index
			a_max_index_out.item := l_max_index
		end

	gsl_stats_float_max (a_data: CE_POINTER [REAL_32]; a_stride, a_n: NATURAL_32): REAL_32
		require
			not a_data.is_void
		local
			l_max: REAL_32
			l_i: NATURAL_32
			l_xi: REAL_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi > l_max then
					l_max := l_xi
				end
				if {PLATFORM}.Real_32_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi))
				else
					if {PLATFORM}.Real_32_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi.to_double))
					else
						l_tmp___2 := (isnanl (real_96_from_real_32 (l_xi)))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					Result := l_xi
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := l_max
			end
		end

	gsl_stats_float_min (a_data: CE_POINTER [REAL_32]; a_stride, a_n: NATURAL_32): REAL_32
		require
			not a_data.is_void
		local
			l_min: REAL_32
			l_i: NATURAL_32
			l_xi: REAL_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
				end
				if {PLATFORM}.Real_32_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi))
				else
					if {PLATFORM}.Real_32_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi.to_double))
					else
						l_tmp___2 := (isnanl (real_96_from_real_32 (l_xi)))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					Result := l_xi
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := l_min
			end
		end

	gsl_stats_float_minmax (a_min_out, a_max_out, a_data: CE_POINTER [REAL_32]; a_stride, a_n: NATURAL_32)
		require
			not a_min_out.is_void
			not a_max_out.is_void
			not a_data.is_void
		local
			l_min: REAL_32
			l_max: REAL_32
			l_i: NATURAL_32
			l_xi: REAL_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_break: BOOLEAN
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (not (l_break) and then (l_i < a_n))
			loop
				l_break := False
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
				end
				if l_xi > l_max then
					l_max := l_xi
				end
				if {PLATFORM}.Real_32_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi))
				else
					if {PLATFORM}.Real_32_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi.to_double))
					else
						l_tmp___2 := (isnanl (real_96_from_real_32 (l_xi)))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					l_min := l_xi
					l_max := l_xi
					l_break := True
				end
				if not (l_break) then
					l_i := l_i + 1
				end
			end
			l_break := False
			a_min_out.item := l_min
			a_max_out.item := l_max
		end

	gsl_stats_float_max_index (a_data: CE_POINTER [REAL_32]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_max: REAL_32
			l_i: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: REAL_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi > l_max then
					l_max := l_xi
					l_max_index := l_i
				end
				if {PLATFORM}.Real_32_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi))
				else
					if {PLATFORM}.Real_32_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi.to_double))
					else
						l_tmp___2 := (isnanl (real_96_from_real_32 (l_xi)))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					Result := l_i
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := l_max_index
			end
		end

	gsl_stats_float_min_index (a_data: CE_POINTER [REAL_32]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_min: REAL_32
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_xi: REAL_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_n))
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
					l_min_index := l_i
				end
				if {PLATFORM}.Real_32_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi))
				else
					if {PLATFORM}.Real_32_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi.to_double))
					else
						l_tmp___2 := (isnanl (real_96_from_real_32 (l_xi)))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					Result := l_i
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := l_min_index
			end
		end

	gsl_stats_float_minmax_index (a_min_index_out, a_max_index_out: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [REAL_32]; a_stride, a_n: NATURAL_32)
		require
			not a_min_index_out.is_void
			not a_max_index_out.is_void
			not a_data.is_void
		local
			l_min: REAL_32
			l_max: REAL_32
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: REAL_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_break: BOOLEAN
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not (l_break) and then (l_i < a_n))
			loop
				l_break := False
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
					l_min_index := l_i
				end
				if l_xi > l_max then
					l_max := l_xi
					l_max_index := l_i
				end
				if {PLATFORM}.Real_32_bytes.to_natural_32 = {PLATFORM}.Real_32_bytes.to_natural_32 then
					l_tmp___3 := (isnanf (l_xi))
				else
					if {PLATFORM}.Real_32_bytes.to_natural_32 = {PLATFORM}.Real_64_bytes.to_natural_32 then
						l_tmp___2 := (isnan (l_xi.to_double))
					else
						l_tmp___2 := (isnanl (real_96_from_real_32 (l_xi)))
					end
					l_tmp___3 := l_tmp___2
				end
				if l_tmp___3.to_boolean then
					l_min_index := l_i
					l_max_index := l_i
					l_break := True
				end
				if not (l_break) then
					l_i := l_i + 1
				end
			end
			l_break := False
			a_min_index_out.item := l_min_index
			a_max_index_out.item := l_max_index
		end

	gsl_stats_ulong_max (a_data: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_max: NATURAL_32
			l_i: NATURAL_32
			l_xi: NATURAL_32
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi > l_max then
					l_max := l_xi
				end
				l_i := l_i + 1
			end
			Result := l_max
		end

	gsl_stats_ulong_min (a_data: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_min: NATURAL_32
			l_i: NATURAL_32
			l_xi: NATURAL_32
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
				end
				l_i := l_i + 1
			end
			Result := l_min
		end

	gsl_stats_ulong_minmax (a_min_out, a_max_out, a_data: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32)
		require
			not a_min_out.is_void
			not a_max_out.is_void
			not a_data.is_void
		local
			l_min: NATURAL_32
			l_max: NATURAL_32
			l_i: NATURAL_32
			l_xi: NATURAL_32
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
				end
				if l_xi > l_max then
					l_max := l_xi
				end
				l_i := l_i + 1
			end
			a_min_out.item := l_min
			a_max_out.item := l_max
		end

	gsl_stats_ulong_max_index (a_data: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_max: NATURAL_32
			l_i: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: NATURAL_32
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi > l_max then
					l_max := l_xi
					l_max_index := l_i
				end
				l_i := l_i + 1
			end
			Result := l_max_index
		end

	gsl_stats_ulong_min_index (a_data: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_min: NATURAL_32
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_xi: NATURAL_32
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
					l_min_index := l_i
				end
				l_i := l_i + 1
			end
			Result := l_min_index
		end

	gsl_stats_ulong_minmax_index (a_min_index_out, a_max_index_out: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32)
		require
			not a_min_index_out.is_void
			not a_max_index_out.is_void
			not a_data.is_void
		local
			l_min: NATURAL_32
			l_max: NATURAL_32
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: NATURAL_32
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
					l_min_index := l_i
				end
				if l_xi > l_max then
					l_max := l_xi
					l_max_index := l_i
				end
				l_i := l_i + 1
			end
			a_min_index_out.item := l_min_index
			a_max_index_out.item := l_max_index
		end

	gsl_stats_long_max (a_data: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32): INTEGER_32
		require
			not a_data.is_void
		local
			l_max: INTEGER_32
			l_i: NATURAL_32
			l_xi: INTEGER_32
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi > l_max then
					l_max := l_xi
				end
				l_i := l_i + 1
			end
			Result := l_max
		end

	gsl_stats_long_min (a_data: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32): INTEGER_32
		require
			not a_data.is_void
		local
			l_min: INTEGER_32
			l_i: NATURAL_32
			l_xi: INTEGER_32
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
				end
				l_i := l_i + 1
			end
			Result := l_min
		end

	gsl_stats_long_minmax (a_min_out, a_max_out, a_data: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32)
		require
			not a_min_out.is_void
			not a_max_out.is_void
			not a_data.is_void
		local
			l_min: INTEGER_32
			l_max: INTEGER_32
			l_i: NATURAL_32
			l_xi: INTEGER_32
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
				end
				if l_xi > l_max then
					l_max := l_xi
				end
				l_i := l_i + 1
			end
			a_min_out.item := l_min
			a_max_out.item := l_max
		end

	gsl_stats_long_max_index (a_data: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_max: INTEGER_32
			l_i: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: INTEGER_32
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi > l_max then
					l_max := l_xi
					l_max_index := l_i
				end
				l_i := l_i + 1
			end
			Result := l_max_index
		end

	gsl_stats_long_min_index (a_data: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_min: INTEGER_32
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_xi: INTEGER_32
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
					l_min_index := l_i
				end
				l_i := l_i + 1
			end
			Result := l_min_index
		end

	gsl_stats_long_minmax_index (a_min_index_out, a_max_index_out: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32)
		require
			not a_min_index_out.is_void
			not a_max_index_out.is_void
			not a_data.is_void
		local
			l_min: INTEGER_32
			l_max: INTEGER_32
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: INTEGER_32
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
					l_min_index := l_i
				end
				if l_xi > l_max then
					l_max := l_xi
					l_max_index := l_i
				end
				l_i := l_i + 1
			end
			a_min_index_out.item := l_min_index
			a_max_index_out.item := l_max_index
		end

	gsl_stats_uint_max (a_data: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_max: NATURAL_32
			l_i: NATURAL_32
			l_xi: NATURAL_32
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi > l_max then
					l_max := l_xi
				end
				l_i := l_i + 1
			end
			Result := l_max
		end

	gsl_stats_uint_min (a_data: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_min: NATURAL_32
			l_i: NATURAL_32
			l_xi: NATURAL_32
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
				end
				l_i := l_i + 1
			end
			Result := l_min
		end

	gsl_stats_uint_minmax (a_min_out, a_max_out, a_data: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32)
		require
			not a_min_out.is_void
			not a_max_out.is_void
			not a_data.is_void
		local
			l_min: NATURAL_32
			l_max: NATURAL_32
			l_i: NATURAL_32
			l_xi: NATURAL_32
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
				end
				if l_xi > l_max then
					l_max := l_xi
				end
				l_i := l_i + 1
			end
			a_min_out.item := l_min
			a_max_out.item := l_max
		end

	gsl_stats_uint_max_index (a_data: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_max: NATURAL_32
			l_i: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: NATURAL_32
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi > l_max then
					l_max := l_xi
					l_max_index := l_i
				end
				l_i := l_i + 1
			end
			Result := l_max_index
		end

	gsl_stats_uint_min_index (a_data: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_min: NATURAL_32
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_xi: NATURAL_32
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
					l_min_index := l_i
				end
				l_i := l_i + 1
			end
			Result := l_min_index
		end

	gsl_stats_uint_minmax_index (a_min_index_out, a_max_index_out, a_data: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32)
		require
			not a_min_index_out.is_void
			not a_max_index_out.is_void
			not a_data.is_void
		local
			l_min: NATURAL_32
			l_max: NATURAL_32
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: NATURAL_32
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
					l_min_index := l_i
				end
				if l_xi > l_max then
					l_max := l_xi
					l_max_index := l_i
				end
				l_i := l_i + 1
			end
			a_min_index_out.item := l_min_index
			a_max_index_out.item := l_max_index
		end

	gsl_stats_int_max (a_data: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32): INTEGER_32
		require
			not a_data.is_void
		local
			l_max: INTEGER_32
			l_i: NATURAL_32
			l_xi: INTEGER_32
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi > l_max then
					l_max := l_xi
				end
				l_i := l_i + 1
			end
			Result := l_max
		end

	gsl_stats_int_min (a_data: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32): INTEGER_32
		require
			not a_data.is_void
		local
			l_min: INTEGER_32
			l_i: NATURAL_32
			l_xi: INTEGER_32
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
				end
				l_i := l_i + 1
			end
			Result := l_min
		end

	gsl_stats_int_minmax (a_min_out, a_max_out, a_data: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32)
		require
			not a_min_out.is_void
			not a_max_out.is_void
			not a_data.is_void
		local
			l_min: INTEGER_32
			l_max: INTEGER_32
			l_i: NATURAL_32
			l_xi: INTEGER_32
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
				end
				if l_xi > l_max then
					l_max := l_xi
				end
				l_i := l_i + 1
			end
			a_min_out.item := l_min
			a_max_out.item := l_max
		end

	gsl_stats_int_max_index (a_data: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_max: INTEGER_32
			l_i: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: INTEGER_32
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi > l_max then
					l_max := l_xi
					l_max_index := l_i
				end
				l_i := l_i + 1
			end
			Result := l_max_index
		end

	gsl_stats_int_min_index (a_data: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_min: INTEGER_32
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_xi: INTEGER_32
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
					l_min_index := l_i
				end
				l_i := l_i + 1
			end
			Result := l_min_index
		end

	gsl_stats_int_minmax_index (a_min_index_out, a_max_index_out: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32)
		require
			not a_min_index_out.is_void
			not a_max_index_out.is_void
			not a_data.is_void
		local
			l_min: INTEGER_32
			l_max: INTEGER_32
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: INTEGER_32
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi < l_min then
					l_min := l_xi
					l_min_index := l_i
				end
				if l_xi > l_max then
					l_max := l_xi
					l_max_index := l_i
				end
				l_i := l_i + 1
			end
			a_min_index_out.item := l_min_index
			a_max_index_out.item := l_max_index
		end

	gsl_stats_ushort_max (a_data: CE_POINTER [NATURAL_16]; a_stride, a_n: NATURAL_32): NATURAL_16
		require
			not a_data.is_void
		local
			l_max: NATURAL_16
			l_i: NATURAL_32
			l_xi: NATURAL_16
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 > l_max.to_integer_32 then
					l_max := l_xi
				end
				l_i := l_i + 1
			end
			Result := l_max
		end

	gsl_stats_ushort_min (a_data: CE_POINTER [NATURAL_16]; a_stride, a_n: NATURAL_32): NATURAL_16
		require
			not a_data.is_void
		local
			l_min: NATURAL_16
			l_i: NATURAL_32
			l_xi: NATURAL_16
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 < l_min.to_integer_32 then
					l_min := l_xi
				end
				l_i := l_i + 1
			end
			Result := l_min
		end

	gsl_stats_ushort_minmax (a_min_out, a_max_out, a_data: CE_POINTER [NATURAL_16]; a_stride, a_n: NATURAL_32)
		require
			not a_min_out.is_void
			not a_max_out.is_void
			not a_data.is_void
		local
			l_min: NATURAL_16
			l_max: NATURAL_16
			l_i: NATURAL_32
			l_xi: NATURAL_16
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 < l_min.to_integer_32 then
					l_min := l_xi
				end
				if l_xi.to_integer_32 > l_max.to_integer_32 then
					l_max := l_xi
				end
				l_i := l_i + 1
			end
			a_min_out.item := l_min
			a_max_out.item := l_max
		end

	gsl_stats_ushort_max_index (a_data: CE_POINTER [NATURAL_16]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_max: NATURAL_16
			l_i: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: NATURAL_16
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 > l_max.to_integer_32 then
					l_max := l_xi
					l_max_index := l_i
				end
				l_i := l_i + 1
			end
			Result := l_max_index
		end

	gsl_stats_ushort_min_index (a_data: CE_POINTER [NATURAL_16]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_min: NATURAL_16
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_xi: NATURAL_16
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 < l_min.to_integer_32 then
					l_min := l_xi
					l_min_index := l_i
				end
				l_i := l_i + 1
			end
			Result := l_min_index
		end

	gsl_stats_ushort_minmax_index (a_min_index_out, a_max_index_out: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [NATURAL_16]; a_stride, a_n: NATURAL_32)
		require
			not a_min_index_out.is_void
			not a_max_index_out.is_void
			not a_data.is_void
		local
			l_min: NATURAL_16
			l_max: NATURAL_16
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: NATURAL_16
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 < l_min.to_integer_32 then
					l_min := l_xi
					l_min_index := l_i
				end
				if l_xi.to_integer_32 > l_max.to_integer_32 then
					l_max := l_xi
					l_max_index := l_i
				end
				l_i := l_i + 1
			end
			a_min_index_out.item := l_min_index
			a_max_index_out.item := l_max_index
		end

	gsl_stats_short_max (a_data: CE_POINTER [INTEGER_16]; a_stride, a_n: NATURAL_32): INTEGER_16
		require
			not a_data.is_void
		local
			l_max: INTEGER_16
			l_i: NATURAL_32
			l_xi: INTEGER_16
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 > l_max.to_integer_32 then
					l_max := l_xi
				end
				l_i := l_i + 1
			end
			Result := l_max
		end

	gsl_stats_short_min (a_data: CE_POINTER [INTEGER_16]; a_stride, a_n: NATURAL_32): INTEGER_16
		require
			not a_data.is_void
		local
			l_min: INTEGER_16
			l_i: NATURAL_32
			l_xi: INTEGER_16
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 < l_min.to_integer_32 then
					l_min := l_xi
				end
				l_i := l_i + 1
			end
			Result := l_min
		end

	gsl_stats_short_minmax (a_min_out, a_max_out, a_data: CE_POINTER [INTEGER_16]; a_stride, a_n: NATURAL_32)
		require
			not a_min_out.is_void
			not a_max_out.is_void
			not a_data.is_void
		local
			l_min: INTEGER_16
			l_max: INTEGER_16
			l_i: NATURAL_32
			l_xi: INTEGER_16
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 < l_min.to_integer_32 then
					l_min := l_xi
				end
				if l_xi.to_integer_32 > l_max.to_integer_32 then
					l_max := l_xi
				end
				l_i := l_i + 1
			end
			a_min_out.item := l_min
			a_max_out.item := l_max
		end

	gsl_stats_short_max_index (a_data: CE_POINTER [INTEGER_16]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_max: INTEGER_16
			l_i: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: INTEGER_16
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 > l_max.to_integer_32 then
					l_max := l_xi
					l_max_index := l_i
				end
				l_i := l_i + 1
			end
			Result := l_max_index
		end

	gsl_stats_short_min_index (a_data: CE_POINTER [INTEGER_16]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_min: INTEGER_16
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_xi: INTEGER_16
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 < l_min.to_integer_32 then
					l_min := l_xi
					l_min_index := l_i
				end
				l_i := l_i + 1
			end
			Result := l_min_index
		end

	gsl_stats_short_minmax_index (a_min_index_out, a_max_index_out: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [INTEGER_16]; a_stride, a_n: NATURAL_32)
		require
			not a_min_index_out.is_void
			not a_max_index_out.is_void
			not a_data.is_void
		local
			l_min: INTEGER_16
			l_max: INTEGER_16
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: INTEGER_16
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 < l_min.to_integer_32 then
					l_min := l_xi
					l_min_index := l_i
				end
				if l_xi.to_integer_32 > l_max.to_integer_32 then
					l_max := l_xi
					l_max_index := l_i
				end
				l_i := l_i + 1
			end
			a_min_index_out.item := l_min_index
			a_max_index_out.item := l_max_index
		end

	gsl_stats_uchar_max (a_data: CE_POINTER [NATURAL_8]; a_stride, a_n: NATURAL_32): NATURAL_8
		require
			not a_data.is_void
		local
			l_max: NATURAL_8
			l_i: NATURAL_32
			l_xi: NATURAL_8
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 > l_max.to_integer_32 then
					l_max := l_xi
				end
				l_i := l_i + 1
			end
			Result := l_max
		end

	gsl_stats_uchar_min (a_data: CE_POINTER [NATURAL_8]; a_stride, a_n: NATURAL_32): NATURAL_8
		require
			not a_data.is_void
		local
			l_min: NATURAL_8
			l_i: NATURAL_32
			l_xi: NATURAL_8
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 < l_min.to_integer_32 then
					l_min := l_xi
				end
				l_i := l_i + 1
			end
			Result := l_min
		end

	gsl_stats_uchar_minmax (a_min_out, a_max_out, a_data: CE_POINTER [NATURAL_8]; a_stride, a_n: NATURAL_32)
		require
			not a_min_out.is_void
			not a_max_out.is_void
			not a_data.is_void
		local
			l_min: NATURAL_8
			l_max: NATURAL_8
			l_i: NATURAL_32
			l_xi: NATURAL_8
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 < l_min.to_integer_32 then
					l_min := l_xi
				end
				if l_xi.to_integer_32 > l_max.to_integer_32 then
					l_max := l_xi
				end
				l_i := l_i + 1
			end
			a_min_out.item := l_min
			a_max_out.item := l_max
		end

	gsl_stats_uchar_max_index (a_data: CE_POINTER [NATURAL_8]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_max: NATURAL_8
			l_i: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: NATURAL_8
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 > l_max.to_integer_32 then
					l_max := l_xi
					l_max_index := l_i
				end
				l_i := l_i + 1
			end
			Result := l_max_index
		end

	gsl_stats_uchar_min_index (a_data: CE_POINTER [NATURAL_8]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_min: NATURAL_8
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_xi: NATURAL_8
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 < l_min.to_integer_32 then
					l_min := l_xi
					l_min_index := l_i
				end
				l_i := l_i + 1
			end
			Result := l_min_index
		end

	gsl_stats_uchar_minmax_index (a_min_index_out, a_max_index_out: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [NATURAL_8]; a_stride, a_n: NATURAL_32)
		require
			not a_min_index_out.is_void
			not a_max_index_out.is_void
			not a_data.is_void
		local
			l_min: NATURAL_8
			l_max: NATURAL_8
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: NATURAL_8
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 < l_min.to_integer_32 then
					l_min := l_xi
					l_min_index := l_i
				end
				if l_xi.to_integer_32 > l_max.to_integer_32 then
					l_max := l_xi
					l_max_index := l_i
				end
				l_i := l_i + 1
			end
			a_min_index_out.item := l_min_index
			a_max_index_out.item := l_max_index
		end

	gsl_stats_char_max (a_data: CE_POINTER [INTEGER_8]; a_stride, a_n: NATURAL_32): INTEGER_8
		require
			not a_data.is_void
		local
			l_max: INTEGER_8
			l_i: NATURAL_32
			l_xi: INTEGER_8
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 > l_max.to_integer_32 then
					l_max := l_xi
				end
				l_i := l_i + 1
			end
			Result := l_max
		end

	gsl_stats_char_min (a_data: CE_POINTER [INTEGER_8]; a_stride, a_n: NATURAL_32): INTEGER_8
		require
			not a_data.is_void
		local
			l_min: INTEGER_8
			l_i: NATURAL_32
			l_xi: INTEGER_8
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 < l_min.to_integer_32 then
					l_min := l_xi
				end
				l_i := l_i + 1
			end
			Result := l_min
		end

	gsl_stats_char_minmax (a_min_out, a_max_out, a_data: CE_POINTER [INTEGER_8]; a_stride, a_n: NATURAL_32)
		require
			not a_min_out.is_void
			not a_max_out.is_void
			not a_data.is_void
		local
			l_min: INTEGER_8
			l_max: INTEGER_8
			l_i: NATURAL_32
			l_xi: INTEGER_8
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 < l_min.to_integer_32 then
					l_min := l_xi
				end
				if l_xi.to_integer_32 > l_max.to_integer_32 then
					l_max := l_xi
				end
				l_i := l_i + 1
			end
			a_min_out[0] := l_min
			a_max_out[0] := l_max
		end

	gsl_stats_char_max_index (a_data: CE_POINTER [INTEGER_8]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_max: INTEGER_8
			l_i: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: INTEGER_8
		do
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 > l_max.to_integer_32 then
					l_max := l_xi
					l_max_index := l_i
				end
				l_i := l_i + 1
			end
			Result := l_max_index
		end

	gsl_stats_char_min_index (a_data: CE_POINTER [INTEGER_8]; a_stride, a_n: NATURAL_32): NATURAL_32
		require
			not a_data.is_void
		local
			l_min: INTEGER_8
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_xi: INTEGER_8
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 < l_min.to_integer_32 then
					l_min := l_xi
					l_min_index := l_i
				end
				l_i := l_i + 1
			end
			Result := l_min_index
		end

	gsl_stats_char_minmax_index (a_min_index_out, a_max_index_out: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [INTEGER_8]; a_stride, a_n: NATURAL_32)
		require
			not a_min_index_out.is_void
			not a_max_index_out.is_void
			not a_data.is_void
		local
			l_min: INTEGER_8
			l_max: INTEGER_8
			l_i: NATURAL_32
			l_min_index: NATURAL_32
			l_max_index: NATURAL_32
			l_xi: INTEGER_8
		do
			l_min := a_data[({NATURAL_32} 0).to_integer_32]
			l_max := a_data[({NATURAL_32} 0).to_integer_32]
			l_min_index := (0).to_natural_32
			l_max_index := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				l_xi := a_data[(l_i * a_stride).to_integer_32]
				if l_xi.to_integer_32 < l_min.to_integer_32 then
					l_min := l_xi
					l_min_index := l_i
				end
				if l_xi.to_integer_32 > l_max.to_integer_32 then
					l_max := l_xi
					l_max_index := l_i
				end
				l_i := l_i + 1
			end
			a_min_index_out.item := l_min_index
			a_max_index_out.item := l_max_index
		end

end
