class
	P_PDF2D_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_histogram2d_pdf_alloc (a_nx, a_ny: NATURAL_32): CE_POINTER [PD_GSL_HISTOGRAM2D_PDF]
		local
			l_n: NATURAL_32
			l_p: CE_POINTER [PD_GSL_HISTOGRAM2D_PDF]
			l_return, l_break: BOOLEAN
		do
			l_n := a_nx * a_ny
			if l_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("histogram2d pdf length n must be positive integer"), ce_string ("pdf2d.c"), 76, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D_PDF]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_p := create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D_PDF]}.make_cast ((malloc ((create {PD_GSL_HISTOGRAM2D_PDF}.make).structure_size.to_natural_32)))
				if l_p.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram2d pdf struct"), ce_string ("pdf2d.c"), 84, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D_PDF]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_p.item.xrange := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_nx + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_p.item.xrange).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_p))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram2d pdf xranges"), ce_string ("pdf2d.c"), 94, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D_PDF]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_p.item.yrange := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_ny + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_p.item.yrange).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_p.item.xrange))
					free (create {CE_VOID_POINTER}.make_cast (l_p))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram2d pdf yranges"), ce_string ("pdf2d.c"), 105, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D_PDF]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_p.item.sum := create {CE_REAL_64_POINTER}.make_cast ((malloc ((l_n + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_p.item.sum).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_p.item.yrange))
					free (create {CE_VOID_POINTER}.make_cast (l_p.item.xrange))
					free (create {CE_VOID_POINTER}.make_cast (l_p))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram2d pdf sums"), ce_string ("pdf2d.c"), 117, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D_PDF]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_p.item.nx := a_nx
				l_p.item.ny := a_ny
				Result := l_p
			end
		end

	gsl_histogram2d_pdf_free (a_p: CE_POINTER [PD_GSL_HISTOGRAM2D_PDF])
		local
			l_return: BOOLEAN
		do
			if a_p.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_p.item.xrange))
				free (create {CE_VOID_POINTER}.make_cast (a_p.item.yrange))
				free (create {CE_VOID_POINTER}.make_cast (a_p.item.sum))
				free (create {CE_VOID_POINTER}.make_cast (a_p))
			end
		end

end
