class
	P_PRINT_STATIC

inherit
	CE_UTILITIES
	S_STDIO_STATIC

feature {ANY} -- public attributes

	signs: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string (" -")
		end

feature {ANY} -- public routines

	gsl_ieee_fprintf_float (a_stream: CE_POINTER [SD_IO_FILE]; a_x: CE_POINTER [REAL_32])
		require
			not a_x.is_void
		local
			l_r___3: CE_ARRAY [PD_GSL_IEEE_FLOAT_REP]
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_IEEE_FLOAT_REP]} l_r___3.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_r___3.item.gsl_ieee_float_to_rep (a_x)
					inspect l_r___3.item.type -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 4 then l_pos := -1 + 4
					when 5 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 1
					fprintf ([a_stream, ce_string ("NaN")]).do_nothing
					l_pos := -1 + 7 -- switch 1; break
				when 2 then -- switch 1, case 2
					fprintf ([a_stream, ce_string ("%%cInf"), (signs.item[l_r___3.item.sign]).to_integer_32]).do_nothing
					l_pos := -1 + 7 -- switch 1; break
				when 3 then -- switch 1, case 3
					fprintf ([a_stream, ce_string ("%%c1.%%s*2^%%d"), (signs.item[l_r___3.item.sign]).to_integer_32, l_r___3.item.mantissa, l_r___3.item.exponent]).do_nothing
					l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 4
					fprintf ([a_stream, ce_string ("%%c0.%%s*2^%%d"), (signs.item[l_r___3.item.sign]).to_integer_32, l_r___3.item.mantissa, l_r___3.item.exponent + 1]).do_nothing
					l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 5
					fprintf ([a_stream, ce_string ("%%c0"), (signs.item[l_r___3.item.sign]).to_integer_32]).do_nothing
					l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
					fprintf ([a_stream, ce_string ("[non-standard IEEE float]")]).do_nothing
				when 7 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_ieee_printf_float (a_x: CE_POINTER [REAL_32])
		require
			not a_x.is_void
		do
			gsl_ieee_fprintf_float ((create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer)), a_x)
		end

	gsl_ieee_fprintf_double (a_stream: CE_POINTER [SD_IO_FILE]; a_x: CE_POINTER [REAL_64])
		require
			not a_x.is_void
		local
			l_r___3: CE_ARRAY [PD_GSL_IEEE_DOUBLE_REP]
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_IEEE_DOUBLE_REP]} l_r___3.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_r___3.item.gsl_ieee_double_to_rep (a_x)
					inspect l_r___3.item.type -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 4 then l_pos := -1 + 4
					when 5 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 1
					fprintf ([a_stream, ce_string ("NaN")]).do_nothing
					l_pos := -1 + 7 -- switch 1; break
				when 2 then -- switch 1, case 2
					fprintf ([a_stream, ce_string ("%%cInf"), (signs.item[l_r___3.item.sign]).to_integer_32]).do_nothing
					l_pos := -1 + 7 -- switch 1; break
				when 3 then -- switch 1, case 3
					fprintf ([a_stream, ce_string ("%%c1.%%s*2^%%d"), (signs.item[l_r___3.item.sign]).to_integer_32, l_r___3.item.mantissa, l_r___3.item.exponent]).do_nothing
					l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 4
					fprintf ([a_stream, ce_string ("%%c0.%%s*2^%%d"), (signs.item[l_r___3.item.sign]).to_integer_32, l_r___3.item.mantissa, l_r___3.item.exponent + 1]).do_nothing
					l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 5
					fprintf ([a_stream, ce_string ("%%c0"), (signs.item[l_r___3.item.sign]).to_integer_32]).do_nothing
					l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
					fprintf ([a_stream, ce_string ("[non-standard IEEE double]")]).do_nothing
				when 7 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_ieee_printf_double (a_x: CE_POINTER [REAL_64])
		require
			not a_x.is_void
		do
			gsl_ieee_fprintf_double ((create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer)), a_x)
		end

end
