class
	P_QAG_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_integration_qag (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5, a_b___0, a_epsabs, a_epsrel: REAL_64; a_limit: NATURAL_32; a_key: INTEGER_32; a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]; a_result, a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_key: INTEGER_32
			l_status: INTEGER_32
			l_integration_rule: CE_ROUTINE
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_key := a_key
					l_integration_rule := (create {PD_GSL_FUNCTION_STRUCT_STATIC}).gsl_integration_qk15_address
					if l_key < 1 then
						l_key := 1
					elseif l_key > 6 then
						l_key := 6
					end
					inspect l_key -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 4 then l_pos := -1 + 4
					when 5 then l_pos := -1 + 5
					when 6 then l_pos := -1 + 6
					else l_pos := -1 + 7
					end
				when 1 then -- switch 1, case 1
					l_integration_rule := (create {PD_GSL_FUNCTION_STRUCT_STATIC}).gsl_integration_qk15_address
					l_pos := -1 + 8 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_integration_rule := (create {PD_GSL_FUNCTION_STRUCT_STATIC}).gsl_integration_qk21_address
					l_pos := -1 + 8 -- switch 1; break
				when 3 then -- switch 1, case 3
					l_integration_rule := (create {PD_GSL_FUNCTION_STRUCT_STATIC}).gsl_integration_qk31_address
					l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 4
					l_integration_rule := (create {PD_GSL_FUNCTION_STRUCT_STATIC}).gsl_integration_qk41_address
					l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 5
					l_integration_rule := (create {PD_GSL_FUNCTION_STRUCT_STATIC}).gsl_integration_qk51_address
					l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 6
					l_integration_rule := (create {PD_GSL_FUNCTION_STRUCT_STATIC}).gsl_integration_qk61_address
					l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, default:
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("value of key does specify a known integration rule"), ce_string ("qag.c"), 82, 4)
						Result := 4
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				when 8 then -- switch 1, done:
					if not l_return then
						l_status := qag (a_f, a_a___5, a_b___0, a_epsabs, a_epsrel, a_limit, a_workspace, a_result, a_abserr, l_integration_rule)
						Result := l_status
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	qag (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5, a_b___0, a_epsabs, a_epsrel: REAL_64; a_limit: NATURAL_32; a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]; a_result, a_abserr: CE_POINTER [REAL_64]; a_q___3: CE_ROUTINE): INTEGER_32
		require
			not a_workspace.is_void
			not a_result.is_void
			not a_abserr.is_void
		local
			l_area: REAL_64
			l_errsum: REAL_64
			l_result0: CE_ARRAY [REAL_64]
			l_abserr0: CE_ARRAY [REAL_64]
			l_resabs0: CE_ARRAY [REAL_64]
			l_resasc0: CE_ARRAY [REAL_64]
			l_tolerance: REAL_64
			l_iteration: NATURAL_32
			l_roundoff_type1: INTEGER_32
			l_roundoff_type2: INTEGER_32
			l_error_type: INTEGER_32
			l_round_off: REAL_64
			l_a1___4: REAL_64
			l_b1___0: REAL_64
			l_a2___3: REAL_64
			l_b2: REAL_64
			l_a_i: CE_ARRAY [REAL_64]
			l_b_i: CE_ARRAY [REAL_64]
			l_r_i: CE_ARRAY [REAL_64]
			l_e_i: CE_ARRAY [REAL_64]
			l_area1: CE_ARRAY [REAL_64]
			l_area2: CE_ARRAY [REAL_64]
			l_area12: REAL_64
			l_error1: CE_ARRAY [REAL_64]
			l_error2: CE_ARRAY [REAL_64]
			l_error12: REAL_64
			l_resasc1: CE_ARRAY [REAL_64]
			l_resasc2: CE_ARRAY [REAL_64]
			l_resabs1: CE_ARRAY [REAL_64]
			l_resabs2: CE_ARRAY [REAL_64]
			l_delta___0: REAL_64
			l_tmp___0: REAL_64
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_REAL_64_ARRAY} l_result0.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_abserr0.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_resabs0.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_resasc0.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_a_i.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_b_i.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_r_i.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_e_i.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_area1.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_area2.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_error1.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_error2.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_resasc1.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_resasc2.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_resabs1.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_resabs2.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_iteration := (0).to_natural_32
					l_roundoff_type1 := 0
					l_roundoff_type2 := 0
					l_error_type := 0
					a_workspace.item.initialise (a_a___5, a_b___0)
					a_result.item := (0).to_double
					a_abserr.item := (0).to_double
					if a_limit > a_workspace.item.limit then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("iteration limit exceeds available workspace"), ce_string ("qag.c"), 119, 4)
							Result := 4
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not (not l_return and then (a_epsabs <= (0).to_double)) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (a_epsrel < (50).to_double * 2.2204460492503131e-16) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_epsrel < 0.5e-28) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("tolerance cannot be acheived with given epsabs and epsrel"), ce_string ("qag.c"), 125, 13)
							Result := 13
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 6 then -- if done | if done
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 7 then -- if:
						a_q___3.call ([a_f, a_a___5, a_b___0, l_result0, l_abserr0, l_resabs0, l_resasc0])
						a_workspace.item.set_initial_result (l_result0.item, l_abserr0.item)
						l_tolerance := (create {P_GSL_GSL_MINMAX_STATIC}).GSL_MAX_DBL (a_epsabs, a_epsrel * (fabs (l_result0.item)))
						l_round_off := (create {P_COERCE_STATIC}).gsl_coerce_double (((50).to_double * 2.2204460492503131e-16) * l_resabs0.item)
						if not (l_abserr0.item <= l_round_off) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_abserr0.item > l_tolerance then
							a_result.item := l_result0.item
							a_abserr.item := l_abserr0.item
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("cannot reach tolerance because of roundoff error on first attempt"), ce_string ("qag.c"), 148, 18)
								Result := 18
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						else
							l_pos := -1 + 10 -- goto _L___1
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else: | _L___1:
						if not (l_abserr0.item <= l_tolerance) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_abserr0.item /= l_resasc0.item then
							a_result.item := l_result0.item
							a_abserr.item := l_abserr0.item
							Result := 0
							l_return := True
						else
							l_pos := -1 + 13 -- goto _L___0
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___0:
						if l_abserr0.item = 0.0 then
							a_result.item := l_result0.item
							a_abserr.item := l_abserr0.item
							Result := 0
							l_return := True
						elseif a_limit = {NATURAL_32} 1 then
							a_result.item := l_result0.item
							a_abserr.item := l_abserr0.item
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("a maximum of one iteration was insufficient"), ce_string ("qag.c"), 162, 11)
								Result := 11
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
				when 14 then -- if done | if done
					if not l_return then
						l_area := l_result0.item
						l_errsum := l_abserr0.item
						l_iteration := (1).to_natural_32
						from
						until
							(l_break)
						loop
							l_break := False
							l_area1.item := (0).to_double
							l_area2.item := (0).to_double
							l_area12 := (0).to_double
							l_error1.item := (0).to_double
							l_error2.item := (0).to_double
							l_error12 := (0).to_double
							a_workspace.item.retrieve (l_a_i, l_b_i, l_r_i, l_e_i)
							l_a1___4 := l_a_i.item
							l_b1___0 := 0.5 * (l_a_i.item + l_b_i.item)
							l_a2___3 := l_b1___0
							l_b2 := l_b_i.item
							a_q___3.call ([a_f, l_a1___4, l_b1___0, l_area1, l_error1, l_resabs1, l_resasc1])
							a_q___3.call ([a_f, l_a2___3, l_b2, l_area2, l_error2, l_resabs2, l_resasc2])
							l_area12 := l_area1.item + l_area2.item
							l_error12 := l_error1.item + l_error2.item
							l_errsum := l_errsum + (l_error12 - l_e_i.item)
							l_area := l_area + (l_area12 - l_r_i.item)
							if l_resasc1.item /= l_error1.item then
								if l_resasc2.item /= l_error2.item then
									l_delta___0 := l_r_i.item - l_area12
									l_tmp___0 := fabs (l_delta___0)
									if l_tmp___0 <= 1.0e-5 * (fabs (l_area12)) then
										if l_error12 >= 0.99 * l_e_i.item then
											l_roundoff_type1 := l_roundoff_type1 + 1
										end
									end
									if l_iteration >= {NATURAL_32} 10 then
										if l_error12 > l_e_i.item then
											l_roundoff_type2 := l_roundoff_type2 + 1
										end
									end
								end
							end
							l_tolerance := (create {P_GSL_GSL_MINMAX_STATIC}).GSL_MAX_DBL (a_epsabs, a_epsrel * (fabs (l_area)))
							if l_errsum > l_tolerance then
								if l_roundoff_type1 >= 6 then
									l_error_type := 2
								elseif l_roundoff_type2 >= 20 then
									l_error_type := 2
								end
								if ((create {P_UTIL_STATIC}).subinterval_too_small (l_a1___4, l_a2___3, l_b2)).to_boolean then
									l_error_type := 3
								end
							end
							a_workspace.item.update (l_a1___4, l_b1___0, l_area1.item, l_error1.item, l_a2___3, l_b2, l_area2.item, l_error2.item)
							a_workspace.item.retrieve (l_a_i, l_b_i, l_r_i, l_e_i)
							l_iteration := l_iteration + 1
							if l_iteration < a_limit then
								if not l_error_type.to_boolean then
									if not (l_errsum > l_tolerance) then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
						end
						l_break := False
						a_result.item := a_workspace.item.sum_results
						a_abserr.item := l_errsum
						if l_errsum <= l_tolerance then
							Result := 0
							l_return := True
						elseif l_error_type = 2 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("roundoff error prevents tolerance from being achieved"), ce_string ("qag.c"), 248, 18)
								Result := 18
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						elseif l_error_type = 3 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("bad integrand behavior found in the integration interval"), ce_string ("qag.c"), 253, 21)
								Result := 21
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						elseif l_iteration = a_limit then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("maximum number of subdivisions reached"), ce_string ("qag.c"), 257, 11)
								Result := 11
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("could not integrate function"), ce_string ("qag.c"), 261, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						Result := 0
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
