class
	P_QAWC_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_integration_qawc (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5, a_b___0, a_c___1, a_epsabs, a_epsrel: REAL_64; a_limit: NATURAL_32; a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]; a_result, a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_workspace.is_void
			not a_result.is_void
			not a_abserr.is_void
		local
			l_area: REAL_64
			l_errsum: REAL_64
			l_result0: CE_ARRAY [REAL_64]
			l_abserr0: CE_ARRAY [REAL_64]
			l_tolerance: REAL_64
			l_iteration: NATURAL_32
			l_roundoff_type1: INTEGER_32
			l_roundoff_type2: INTEGER_32
			l_error_type: INTEGER_32
			l_err_reliable: CE_ARRAY [INTEGER_32]
			l_sign: INTEGER_32
			l_lower: REAL_64
			l_higher: REAL_64
			l_a1___4: REAL_64
			l_b1___0: REAL_64
			l_a2___3: REAL_64
			l_b2: REAL_64
			l_a_i: CE_ARRAY [REAL_64]
			l_b_i: CE_ARRAY [REAL_64]
			l_r_i: CE_ARRAY [REAL_64]
			l_e_i: CE_ARRAY [REAL_64]
			l_area1: CE_ARRAY [REAL_64]
			l_area2: CE_ARRAY [REAL_64]
			l_area12: REAL_64
			l_error1: CE_ARRAY [REAL_64]
			l_error2: CE_ARRAY [REAL_64]
			l_error12: REAL_64
			l_err_reliable1: CE_ARRAY [INTEGER_32]
			l_err_reliable2: CE_ARRAY [INTEGER_32]
			l_delta___0: REAL_64
			l_tmp___1: REAL_64
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_REAL_64_ARRAY} l_result0.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_abserr0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_err_reliable.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_a_i.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_b_i.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_r_i.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_e_i.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_area1.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_area2.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_error1.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_error2.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_err_reliable1.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_err_reliable2.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_iteration := (0).to_natural_32
					l_roundoff_type1 := 0
					l_roundoff_type2 := 0
					l_error_type := 0
					l_sign := 1
					a_result.item := (0).to_double
					a_abserr.item := (0).to_double
					if a_limit > a_workspace.item.limit then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("iteration limit exceeds available workspace"), ce_string ("qawc.c"), 57, 4)
							Result := 4
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if a_b___0 < a_a___5 then
							l_lower := a_b___0
							l_higher := a_a___5
							l_sign := -1
						else
							l_lower := a_a___5
							l_higher := a_b___0
						end
						a_workspace.item.initialise (l_lower, l_higher)
						if not (a_epsabs <= (0).to_double) then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if not (a_epsrel < (50).to_double * 2.2204460492503131e-16) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if not (a_epsrel < 0.5e-28) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("tolerance cannot be acheived with given epsabs and epsrel"), ce_string ("qawc.c"), 77, 13)
							Result := 13
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 7 then -- if done | if done | if done
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 8 then -- if:
						if a_c___1 /= a_a___5 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if a_c___1 /= a_b___0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L___0:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("cannot integrate with singularity on endpoint"), ce_string ("qawc.c"), 82, 4)
							Result := 4
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 13 then -- if done | if done
					if l_return then
						l_pos := -1 + 18 -- skip if block
					end
				when 14 then -- if:;
						(create {P_QC25C_STATIC}).qc25c (a_f, l_lower, l_higher, a_c___1, l_result0, l_abserr0, l_err_reliable)
						a_workspace.item.set_initial_result (l_result0.item, l_abserr0.item)
						l_tolerance := (create {P_GSL_GSL_MINMAX_STATIC}).GSL_MAX_DBL (a_epsabs, a_epsrel * (fabs (l_result0.item)))
						if not (l_abserr0.item < l_tolerance) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if l_abserr0.item < 0.01 * (fabs (l_result0.item)) then
							a_result.item := l_sign.to_double * l_result0.item
							a_abserr.item := l_abserr0.item
							Result := 0
							l_return := True
						else
							l_pos := -1 + 17 -- goto _L___1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L___1:
						if a_limit = {NATURAL_32} 1 then
							a_result.item := l_sign.to_double * l_result0.item
							a_abserr.item := l_abserr0.item
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("a maximum of one iteration was insufficient"), ce_string ("qawc.c"), 108, 11)
								Result := 11
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
				when 18 then -- if done
					if l_return then
						l_pos := -1 + 27 -- skip if block
					end
				when 19 then -- if:
						l_area := l_result0.item
						l_errsum := l_abserr0.item
						l_iteration := (1).to_natural_32
				when 20 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 26 -- skip loop
						end
				when 21 then -- loop body:
						l_break := False
						l_area1.item := (0).to_double
						l_area2.item := (0).to_double
						l_area12 := (0).to_double
						l_error1.item := (0).to_double
						l_error2.item := (0).to_double
						l_error12 := (0).to_double
						a_workspace.item.retrieve (l_a_i, l_b_i, l_r_i, l_e_i)
						l_a1___4 := l_a_i.item
						l_b1___0 := 0.5 * (l_a_i.item + l_b_i.item)
						l_a2___3 := l_b1___0
						l_b2 := l_b_i.item
						if not (a_c___1 > l_a1___4) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if a_c___1 <= l_b1___0 then
							l_b1___0 := 0.5 * (a_c___1 + l_b2)
							l_a2___3 := l_b1___0
						else
							l_pos := -1 + 24 -- goto _L___2
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L___2:
						if a_c___1 > l_b1___0 then
							if a_c___1 < l_b2 then
								l_b1___0 := 0.5 * (l_a1___4 + a_c___1)
								l_a2___3 := l_b1___0
							end
						end
				when 25 then;
						(create {P_QC25C_STATIC}).qc25c (a_f, l_a1___4, l_b1___0, a_c___1, l_area1, l_error1, l_err_reliable1);
						(create {P_QC25C_STATIC}).qc25c (a_f, l_a2___3, l_b2, a_c___1, l_area2, l_error2, l_err_reliable2)
						l_area12 := l_area1.item + l_area2.item
						l_error12 := l_error1.item + l_error2.item
						l_errsum := l_errsum + (l_error12 - l_e_i.item)
						l_area := l_area + (l_area12 - l_r_i.item)
						if (l_err_reliable1.item).to_boolean then
							if (l_err_reliable2.item).to_boolean then
								l_delta___0 := l_r_i.item - l_area12
								l_tmp___1 := fabs (l_delta___0)
								if l_tmp___1 <= 1.0e-5 * (fabs (l_area12)) then
									if l_error12 >= 0.99 * l_e_i.item then
										l_roundoff_type1 := l_roundoff_type1 + 1
									end
								end
								if l_iteration >= {NATURAL_32} 10 then
									if l_error12 > l_e_i.item then
										l_roundoff_type2 := l_roundoff_type2 + 1
									end
								end
							end
						end
						l_tolerance := (create {P_GSL_GSL_MINMAX_STATIC}).GSL_MAX_DBL (a_epsabs, a_epsrel * (fabs (l_area)))
						if l_errsum > l_tolerance then
							if l_roundoff_type1 >= 6 then
								l_error_type := 2
							elseif l_roundoff_type2 >= 20 then
								l_error_type := 2
							end
							if ((create {P_UTIL_STATIC}).subinterval_too_small (l_a1___4, l_a2___3, l_b2)).to_boolean then
								l_error_type := 3
							end
						end
						a_workspace.item.update (l_a1___4, l_b1___0, l_area1.item, l_error1.item, l_a2___3, l_b2, l_area2.item, l_error2.item)
						a_workspace.item.retrieve (l_a_i, l_b_i, l_r_i, l_e_i)
						l_iteration := l_iteration + 1
						if l_iteration < a_limit then
							if not l_error_type.to_boolean then
								if not (l_errsum > l_tolerance) then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						l_pos := -1 + 20 -- back to loop condition
				when 26 then -- loop done
						l_break := False
						a_result.item := l_sign.to_double * (a_workspace.item.sum_results)
						a_abserr.item := l_errsum
						if l_errsum <= l_tolerance then
							Result := 0
							l_return := True
						elseif l_error_type = 2 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("roundoff error prevents tolerance from being achieved"), ce_string ("qawc.c"), 204, 18)
								Result := 18
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						elseif l_error_type = 3 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("bad integrand behavior found in the integration interval"), ce_string ("qawc.c"), 209, 21)
								Result := 21
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						elseif l_iteration = a_limit then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("maximum number of subdivisions reached"), ce_string ("qawc.c"), 213, 11)
								Result := 11
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("could not integrate function"), ce_string ("qawc.c"), 217, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
				when 27 then -- if done
					if not l_return then
						Result := 0
					end
				when 28 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
