class
	P_RAN0_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	m___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (2_147_483_647).to_integer_32
		end

	a___1: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (16_807).to_integer_32
		end

	q___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (127_773).to_integer_32
		end

	r___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (2_836).to_integer_32
		end

	mask: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (123_459_876).to_natural_32
		end

	ran0_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("ran0"), {NATURAL_32} 2_147_483_646, {NATURAL_32} 1, (create {PD_RAN0_STATE_T}.make).structure_size.to_natural_32, ran0_set_address, ran0_get_address, ran0_get_double_address])
				>>)
		end

	gsl_rng_ran0: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ran0_type.item
		end

feature {ANY} -- public routines

	ran0_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN0_STATE_T]
			l_x: NATURAL_32
			l_h: INTEGER_32
			l_t: INTEGER_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN0_STATE_T]}.make_cast (a_vstate)
			l_x := l_state.item.x
			l_h := (l_x // q___0.item.to_natural_32).to_integer_32
			l_t := (a___1.item.to_natural_32 * (l_x - (l_h * q___0.item).to_natural_32) - (l_h * r___0.item).to_natural_32).to_integer_32
			if l_t < 0 then
				l_state.item.x := (l_t + m___0.item).to_natural_32
			else
				l_state.item.x := l_t.to_natural_32
			end
			Result := (l_state.item.x)
		end

	ran0_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((ran0_get (a_vstate)).to_real_64 / 2147483647.0)
		end

	ran0_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RAN0_STATE_T]
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN0_STATE_T]}.make_cast (a_vstate)
			if a_s = mask.item then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("ran0 should not use seed == mask"), ce_string ("ran0.c"), 83, 4)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.x := (a_s).bit_xor (mask.item)
			end
		end

feature {ANY} -- routine addresses

	ran0_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran0_get)
		end

	ran0_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran0_get_double)
		end

	ran0_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran0_set)
		end

end
