class
	P_RAYLEIGH_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_rayleigh_pdf (a_x, a_sigma: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_p: REAL_64
		do
			if a_x < (0).to_double then
				Result := (0).to_double
			else
				l_u := a_x / a_sigma
				l_p := (l_u / a_sigma) * (exp ((-l_u * l_u) / 2.0))
				Result := l_p
			end
		end

	gsl_ran_rayleigh_tail_pdf (a_x, a_a___5, a_sigma: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_v: REAL_64
			l_p: REAL_64
		do
			if a_x < a_a___5 then
				Result := (0).to_double
			else
				l_u := a_x / a_sigma
				l_v := a_a___5 / a_sigma
				l_p := (l_u / a_sigma) * (exp (((l_v + l_u) * (l_v - l_u)) / 2.0))
				Result := l_p
			end
		end

	gsl_cdf_rayleigh_P (a_x, a_sigma: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_P___2: REAL_64
		do
			l_u := a_x / a_sigma
			l_P___2 := -(expm1 ((-l_u * l_u) / (2).to_double))
			Result := l_P___2
		end

	gsl_cdf_rayleigh_Q (a_x, a_sigma: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_Q___1: REAL_64
		do
			l_u := a_x / a_sigma
			l_Q___1 := (exp ((-l_u * l_u) / (2).to_double))
			Result := l_Q___1
		end

end
