class
	P_SOBOL_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	sobol_type: CE_STATIC [CE_ARRAY [PD_GSL_QRNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_QRNG_TYPE]}.make_initialized (<<
					create {PD_GSL_QRNG_TYPE}.make_initialized ([ce_string ("sobol"), {NATURAL_32} 40, sobol_state_size_address, sobol_init_address, sobol_get_address])
				>>)
		end

	gsl_qrng_sobol: CE_STATIC [CE_POINTER [PD_GSL_QRNG_TYPE]]
		once ("PROCESS")
			Result.item := sobol_type.item
		end

	primitive_polynomials: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					1, 3, 7, 11, 13, 19, 25, 37, 59, 47, 61, 55, 41, 67, 97, 91, 109, 103, 115, 131, 193, 137, 145, 143,
					241, 157, 185, 167, 229, 171, 213, 191, 253, 203, 211, 239, 247, 285, 369, 299
				>>)
		end

	degree_table: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					0, 1, 2, 3, 3, 4, 4, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
					7, 7, 7, 7, 8, 8, 8
				>>)
		end

	v_init: CE_STATIC [CE_ARRAY [CE_ARRAY [INTEGER_32]]]
		once ("PROCESS")
			Result.item := create {CE_ARRAY_ARRAY [INTEGER_32]}.make_initialized (<<
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
							1, 1, 1, 1, 1, 1, 1, 1
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							0, 0, 1, 3, 1, 3, 1, 3, 3, 1, 3, 1, 3, 1, 3, 1, 1, 3, 1, 3, 1, 3, 1, 3, 3, 1, 3, 1, 3, 1, 3, 1,
							1, 3, 1, 3, 1, 3, 1, 3
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							0, 0, 0, 7, 5, 1, 3, 3, 7, 5, 5, 7, 7, 1, 3, 3, 7, 5, 1, 1, 5, 3, 3, 1, 7, 5, 1, 3, 3, 7, 5, 1,
							1, 5, 7, 7, 5, 1, 3, 3
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							0, 0, 0, 0, 0, 1, 7, 9, 13, 11, 1, 3, 7, 9, 5, 13, 13, 11, 3, 15, 5, 3, 15, 7, 9, 13, 9, 1, 11,
							7, 5, 15, 1, 15, 11, 5, 3, 1, 7, 9
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							0, 0, 0, 0, 0, 0, 0, 9, 3, 27, 15, 29, 21, 23, 19, 11, 25, 7, 13, 17, 1, 25, 29, 3, 31, 11, 5,
							23, 27, 19, 21, 5, 1, 17, 13, 7, 15, 9, 31, 9
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, 33, 7, 5, 11, 39, 63, 27, 17, 15, 23, 29, 3, 21, 13,
							31, 25, 9, 49, 33, 19, 29, 11, 19, 27, 15, 25
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 33, 115, 41, 79, 17, 29, 119, 75,
							73, 105, 7, 59, 65, 21, 3, 113, 61, 89, 45, 107
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							0, 0, 0, 0, 0, 7, 23, 39
						>>)
				>>)
		end

feature {ANY} -- public routines

	sobol_state_size (a_dimension: NATURAL_32): NATURAL_32
		do
			Result := ((create {PD_SOBOL_STATE_T}.make).structure_size.to_natural_32)
		end

	sobol_init (a_state: CE_POINTER [ANY]; a_dimension: NATURAL_32): INTEGER_32
		local
			l_s_state: CE_POINTER [PD_SOBOL_STATE_T]
			l_i_dim: NATURAL_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_ell: INTEGER_32
			l_poly_index: INTEGER_32
			l_degree_i: INTEGER_32
			l_includ: CE_ARRAY [INTEGER_32]
			l_p_i: INTEGER_32
			l_newv: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_includ.make (<<8>>)

			l_s_state := create {CE_CLASS_POINTER [PD_SOBOL_STATE_T]}.make_cast (a_state)
			if a_dimension < {NATURAL_32} 1 then
				Result := 4
				l_return := True
			elseif a_dimension > {NATURAL_32} 40 then
				Result := 4
				l_return := True
			end
			if not l_return then
				l_k := 0
				from
				until
					not (l_k < 30)
				loop
					(l_s_state.item.v_direction[l_k])[0] := 1
					l_k := l_k + 1
				end
				l_i_dim := {NATURAL_32} 1
				from
				until
					not (not (l_return) and then (l_i_dim < a_dimension))
				loop
					l_poly_index := l_i_dim.to_integer_32
					l_degree_i := degree_table.item[l_poly_index]
					l_p_i := primitive_polynomials.item[l_poly_index]
					l_k := l_degree_i - 1
					from
					until
						not (l_k >= 0)
					loop
						l_includ[l_k] := (l_p_i \\ 2 = 1).to_integer
						l_p_i := l_p_i // (2)
						l_k := l_k - 1
					end
					l_j := 0
					from
					until
						not (l_j < l_degree_i)
					loop
						(l_s_state.item.v_direction[l_j])[l_i_dim.to_integer_32] := (v_init.item[l_j])[l_i_dim.to_integer_32]
						l_j := l_j + 1
					end
					l_j := l_degree_i
					from
					until
						not (not (l_return) and then (l_j < 30))
					loop
						l_newv := (l_s_state.item.v_direction[l_j - l_degree_i])[l_i_dim.to_integer_32]
						l_ell := 1
						l_k := 0
						from
						until
							not (l_k < l_degree_i)
						loop
							l_ell := l_ell * (2)
							if (l_includ[l_k]).to_boolean then
								l_newv := (l_newv).bit_xor ((l_ell * (l_s_state.item.v_direction[(l_j - l_k) - 1])[l_i_dim.to_integer_32]))
							end
							l_k := l_k + 1
						end
						(l_s_state.item.v_direction[l_j])[l_i_dim.to_integer_32] := l_newv
						l_j := l_j + 1
					end
					l_i_dim := l_i_dim + 1
				end
				l_ell := 1
				l_j := 28
				from
				until
					not (not (l_return) and then (l_j >= 0))
				loop
					l_ell := l_ell * (2)
					l_i_dim := {NATURAL_32} 0
					from
					until
						not (l_i_dim < a_dimension)
					loop
						(l_s_state.item.v_direction[l_j])[l_i_dim.to_integer_32] := (l_s_state.item.v_direction[l_j])[l_i_dim.to_integer_32] * l_ell
						l_i_dim := l_i_dim + 1
					end
					l_j := l_j - 1
				end
				l_s_state.item.last_denominator_inv := 1.0 / (2.0 * l_ell.to_double)
				l_s_state.item.sequence_count := {NATURAL_32} 0
				l_i_dim := {NATURAL_32} 0
				from
				until
					not (l_i_dim < a_dimension)
				loop
					l_s_state.item.last_numerator_vec[l_i_dim.to_integer_32] := 0
					l_i_dim := l_i_dim + 1
				end
				Result := 0
			end
		end

	sobol_get (a_state: CE_POINTER [ANY]; a_dimension: NATURAL_32; a_v: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_s_state: CE_POINTER [PD_SOBOL_STATE_T]
			l_i_dimension: NATURAL_32
			l_ell: INTEGER_32
			l_c___1: INTEGER_32
			l_direction_i: INTEGER_32
			l_old_numerator_i: INTEGER_32
			l_new_numerator_i: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_s_state := create {CE_CLASS_POINTER [PD_SOBOL_STATE_T]}.make_cast (a_state)
			l_ell := 0
			l_c___1 := (l_s_state.item.sequence_count).to_integer_32
			from
			until
				(l_break)
			loop
				l_break := False
				l_ell := l_ell + 1
				if l_c___1 \\ 2 = 1 then
					l_c___1 := l_c___1 // (2)
				else
					l_break := True
				end
			end
			l_break := False
			if l_ell > 30 then
				Result := 5
				l_return := True
			end
			if not l_return then
				l_i_dimension := {NATURAL_32} 0
				from
				until
					not (l_i_dimension < a_dimension)
				loop
					l_direction_i := (l_s_state.item.v_direction[l_ell - 1])[l_i_dimension.to_integer_32]
					l_old_numerator_i := l_s_state.item.last_numerator_vec[l_i_dimension.to_integer_32]
					l_new_numerator_i := (l_old_numerator_i).bit_xor (l_direction_i)
					l_s_state.item.last_numerator_vec[l_i_dimension.to_integer_32] := l_new_numerator_i
					a_v[l_i_dimension.to_integer_32] := l_new_numerator_i.to_double * l_s_state.item.last_denominator_inv
					l_i_dimension := l_i_dimension + 1
				end
				l_s_state.item.sequence_count := (l_s_state.item.sequence_count) + 1
				Result := 0
			end
		end

feature {ANY} -- routine addresses

	sobol_state_size_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent sobol_state_size)
		end

	sobol_init_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent sobol_init)
		end

	sobol_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent sobol_get)
		end

end
