class
	P_SROTMG_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	cblas_srotmg (a_d1, a_d2, a_b1___0: CE_POINTER [REAL_32]; a_b2: REAL_32; a_P___2: CE_POINTER [REAL_32])
		require
			not a_d1.is_void
			not a_d2.is_void
			not a_b1___0.is_void
			not a_P___2.is_void
		local
			l_G: REAL_32
			l_G2: REAL_32
			l_D1: REAL_32
			l_D2: REAL_32
			l_x: REAL_32
			l_y: REAL_32
			l_h11: REAL_32
			l_h12: REAL_32
			l_h21: REAL_32
			l_h22: REAL_32
			l_u: REAL_32
			l_c___1: REAL_32
			l_s: REAL_32
			l_tmp___1: REAL_32
			l_return, l_break: BOOLEAN
		do
			l_G := (4096.0).truncated_to_real
			l_G2 := l_G * l_G
			l_D1 := a_d1.item
			l_D2 := a_d2.item
			l_x := a_b1___0.item
			l_y := a_b2
			if l_D1.to_double < 0.0 then
				a_P___2[0] := (-1).to_real
				a_P___2[1] := (0).to_real
				a_P___2[2] := (0).to_real
				a_P___2[3] := (0).to_real
				a_P___2[4] := (0).to_real
				a_d1.item := (0).to_real
				a_d2.item := (0).to_real
				a_b1___0.item := (0).to_real
				l_return := True
			end
			if not l_return and then ((l_D2 * l_y).to_double = 0.0) then
				a_P___2[0] := (-2).to_real
				l_return := True
			end
			if not l_return then
				l_c___1 := (fabs (((l_D1 * l_x) * l_x).to_double)).truncated_to_real
				l_s := (fabs (((l_D2 * l_y) * l_y).to_double)).truncated_to_real
				if l_c___1 > l_s then
					a_P___2[0] := (0.0).truncated_to_real
					l_h11 := (1).to_real
					l_h12 := (l_D2 * l_y) / (l_D1 * l_x)
					l_h21 := -l_y / l_x
					l_h22 := (1).to_real
					l_u := (1).to_real - l_h21 * l_h12
					if l_u.to_double <= 0.0 then
						a_P___2[0] := (-1).to_real
						a_P___2[1] := (0).to_real
						a_P___2[2] := (0).to_real
						a_P___2[3] := (0).to_real
						a_P___2[4] := (0).to_real
						a_d1.item := (0).to_real
						a_d2.item := (0).to_real
						a_b1___0.item := (0).to_real
						l_return := True
					end
					if not l_return then
						l_D1 := l_D1 / l_u
						l_D2 := l_D2 / l_u
						l_x := l_x * l_u
					end
				else
					if ((l_D2 * l_y) * l_y).to_double < 0.0 then
						a_P___2[0] := (-1).to_real
						a_P___2[1] := (0).to_real
						a_P___2[2] := (0).to_real
						a_P___2[3] := (0).to_real
						a_P___2[4] := (0).to_real
						a_d1.item := (0).to_real
						a_d2.item := (0).to_real
						a_b1___0.item := (0).to_real
						l_return := True
					end
					if not l_return then
						a_P___2[0] := (1).to_real
						l_h11 := (l_D1 * l_x) / (l_D2 * l_y)
						l_h12 := (1).to_real
						l_h21 := (-1).to_real
						l_h22 := l_x / l_y
						l_u := (1).to_real + l_h11 * l_h22
						l_D1 := l_D1 / l_u
						l_D2 := l_D2 / l_u
						l_tmp___1 := l_D2
						l_D2 := l_D1
						l_D1 := l_tmp___1
						l_x := l_y * l_u
					end
				end
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					if l_D1.to_double <= 1.0 / l_G2.to_double then
						if l_D1.to_double = 0.0 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						a_P___2[0] := (-1).to_real
						l_D1 := l_D1 * l_G2
						l_x := l_x / l_G
						l_h11 := l_h11 / l_G
						l_h12 := l_h12 / l_G
					end
				end
				l_break := False
				from
				until
					not (l_D1 >= l_G2)
				loop
					a_P___2[0] := (-1).to_real
					l_D1 := l_D1 / l_G2
					l_x := l_x * l_G
					l_h11 := l_h11 * l_G
					l_h12 := l_h12 * l_G
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if (fabs (l_D2.to_double)) <= 1.0 / l_G2.to_double then
						if l_D2.to_double = 0.0 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						a_P___2[0] := (-1).to_real
						l_D2 := l_D2 * l_G2
						l_h21 := l_h21 / l_G
						l_h22 := l_h22 / l_G
					end
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					if not ((fabs (l_D2.to_double)) >= l_G2.to_double) then
						l_break := True
					end
					if not (l_break) then
						a_P___2[0] := (-1).to_real
						l_D2 := l_D2 / l_G2
						l_h21 := l_h21 * l_G
						l_h22 := l_h22 * l_G
					end
				end
				l_break := False
				a_d1.item := l_D1
				a_d2.item := l_D2
				a_b1___0.item := l_x
				if (a_P___2[0]).to_double = -1.0 then
					a_P___2[1] := l_h11
					a_P___2[2] := l_h21
					a_P___2[3] := l_h12
					a_P___2[4] := l_h22
				elseif (a_P___2[0]).to_double = 0.0 then
					a_P___2[2] := l_h21
					a_P___2[3] := l_h12
				elseif (a_P___2[0]).to_double = 1.0 then
					a_P___2[1] := l_h11
					a_P___2[4] := l_h22
				end
			end
		end

end
