class
	P_SSPMV_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	cblas_sspmv (a_order, a_Uplo: NATURAL_32; a_N: INTEGER_32; a_alpha: REAL_32; a_Ap, a_X: CE_POINTER [REAL_32]; a_incX: INTEGER_32; a_beta: REAL_32; a_Y: CE_POINTER [REAL_32]; a_incY: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_iy: INTEGER_32
			l_tmp: INTEGER_32
			l_iy___0: INTEGER_32
			l_tmp___0: INTEGER_32
			l_ix: INTEGER_32
			l_tmp___1: INTEGER_32
			l_iy___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp1: REAL_32
			l_tmp2: REAL_32
			l_j_min: INTEGER_32
			l_j_max: INTEGER_32
			l_jx: INTEGER_32
			l_tmp___3: INTEGER_32
			l_jy: INTEGER_32
			l_tmp___4: INTEGER_32
			l_apk: REAL_32
			l_ix___0: INTEGER_32
			l_tmp___5: INTEGER_32
			l_iy___2: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp1___0: REAL_32
			l_tmp2___0: REAL_32
			l_j_min___0: INTEGER_32
			l_j_max___0: INTEGER_32
			l_jx___0: INTEGER_32
			l_tmp___7: INTEGER_32
			l_jy___0: INTEGER_32
			l_tmp___8: INTEGER_32
			l_apk___0: REAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_alpha.to_double = 0.0 then
						if a_beta.to_double = 1.0 then
							l_return := True
						end
					end
					if not l_return then
						if a_beta.to_double = 0.0 then
							if a_incY > 0 then
								l_tmp := 0
							else
								l_tmp := (a_N - 1) * -a_incY
							end
							l_iy := l_tmp
							l_i := 0
							from
							until
								not (l_i < a_N)
							loop
								a_Y[l_iy] := (0.0).truncated_to_real
								l_iy := l_iy + a_incY
								l_i := l_i + 1
							end
						elseif a_beta.to_double /= 1.0 then
							if a_incY > 0 then
								l_tmp___0 := 0
							else
								l_tmp___0 := (a_N - 1) * -a_incY
							end
							l_iy___0 := l_tmp___0
							l_i := 0
							from
							until
								not (l_i < a_N)
							loop
								a_Y[l_iy___0] := a_Y[l_iy___0] * a_beta
								l_iy___0 := l_iy___0 + a_incY
								l_i := l_i + 1
							end
						end
						if a_alpha.to_double = 0.0 then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if a_Uplo = {NATURAL_32} 121 then
							l_pos := -1 + 6 -- goto _L___1
						else
							l_pos := -1 + 4 -- goto _L___3
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 4 then -- else: | _L___3:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___1:
						if a_incX > 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp___1
						if a_incY > 0 then
							l_tmp___2 := 0
						else
							l_tmp___2 := (a_N - 1) * -a_incY
						end
						l_iy___1 := l_tmp___2
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_tmp1 := a_alpha * a_X[l_ix]
							l_tmp2 := (0.0).truncated_to_real
							l_j_min := l_i + 1
							l_j_max := a_N
							if a_incX > 0 then
								l_tmp___3 := 0
							else
								l_tmp___3 := (a_N - 1) * -a_incX
							end
							l_jx := l_tmp___3 + l_j_min * a_incX
							if a_incY > 0 then
								l_tmp___4 := 0
							else
								l_tmp___4 := (a_N - 1) * -a_incY
							end
							l_jy := l_tmp___4 + l_j_min * a_incY
							a_Y[l_iy___1] := a_Y[l_iy___1] + (l_tmp1 * a_Ap[(((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i)])
							l_j := l_j_min
							from
							until
								not (l_j < l_j_max)
							loop
								l_apk := a_Ap[(((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i)]
								a_Y[l_jy] := a_Y[l_jy] + (l_tmp1 * l_apk)
								l_tmp2 := l_tmp2 + (l_apk * a_X[l_jx])
								l_jy := l_jy + a_incY
								l_jx := l_jx + a_incX
								l_j := l_j + 1
							end
							a_Y[l_iy___1] := a_Y[l_iy___1] + (a_alpha * l_tmp2)
							l_ix := l_ix + a_incX
							l_iy___1 := l_iy___1 + a_incY
							l_i := l_i + 1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 10 -- goto _L___2
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 10 then -- else: | _L___2:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if a_Uplo = {NATURAL_32} 122 then
							l_pos := -1 + 15 -- goto _L
						else
							l_pos := -1 + 13 -- goto _L___0
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else: | _L___0:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L:
						if a_incX > 0 then
							l_tmp___5 := 0
						else
							l_tmp___5 := (a_N - 1) * -a_incX
						end
						l_ix___0 := l_tmp___5
						if a_incY > 0 then
							l_tmp___6 := 0
						else
							l_tmp___6 := (a_N - 1) * -a_incY
						end
						l_iy___2 := l_tmp___6
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_tmp1___0 := a_alpha * a_X[l_ix___0]
							l_tmp2___0 := (0.0).truncated_to_real
							l_j_min___0 := 0
							l_j_max___0 := l_i
							if a_incX > 0 then
								l_tmp___7 := 0
							else
								l_tmp___7 := (a_N - 1) * -a_incX
							end
							l_jx___0 := l_tmp___7 + l_j_min___0 * a_incX
							if a_incY > 0 then
								l_tmp___8 := 0
							else
								l_tmp___8 := (a_N - 1) * -a_incY
							end
							l_jy___0 := l_tmp___8 + l_j_min___0 * a_incY
							a_Y[l_iy___2] := a_Y[l_iy___2] + (l_tmp1___0 * a_Ap[((l_i * (l_i + 1)) // 2 + l_i)])
							l_j := l_j_min___0
							from
							until
								not (l_j < l_j_max___0)
							loop
								l_apk___0 := a_Ap[((l_i * (l_i + 1)) // 2 + l_j)]
								a_Y[l_jy___0] := a_Y[l_jy___0] + (l_tmp1___0 * l_apk___0)
								l_tmp2___0 := l_tmp2___0 + (l_apk___0 * a_X[l_jx___0])
								l_jy___0 := l_jy___0 + a_incY
								l_jx___0 := l_jx___0 + a_incX
								l_j := l_j + 1
							end
							a_Y[l_iy___2] := a_Y[l_iy___2] + (a_alpha * l_tmp2___0)
							l_ix___0 := l_ix___0 + a_incX
							l_iy___2 := l_iy___2 + a_incY
							l_i := l_i + 1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_spmv.h"), ce_string ("unrecognized operation")])
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_spmv.h"), ce_string ("unrecognized operation")])
				when 20 then -- if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
