class
	P_STEP_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_odeiv_step_alloc (a_T: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE]; a_dim: NATURAL_32): CE_POINTER [PD_GSL_ODEIV_STEP]
		local
			l_s: CE_POINTER [PD_GSL_ODEIV_STEP]
			l_return, l_break: BOOLEAN
		do
			l_s := create {CE_CLASS_POINTER [PD_GSL_ODEIV_STEP]}.make_cast ((malloc ((create {PD_GSL_ODEIV_STEP}.make).structure_size.to_natural_32)))
			if l_s.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for ode struct"), ce_string ("step.c"), 34, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_ODEIV_STEP]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s.item.type := a_T
				l_s.item.dimension := a_dim
				l_s.item.state := create {CE_VOID_POINTER}.make_cast (((l_s.item.type).item.alloc).pointer_item ([a_dim]))
				if (l_s.item.state).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_s))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for ode state"), ce_string ("step.c"), 46, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_ODEIV_STEP]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := l_s
			end
		end

	gsl_odeiv_step_free (a_s: CE_POINTER [PD_GSL_ODEIV_STEP])
		local
			l_return: BOOLEAN
		do
			if a_s.is_void then
				l_return := True
			end
			if not l_return then
				((a_s.item.type).item.free).call ([a_s.item.state])
				free (create {CE_VOID_POINTER}.make_cast (a_s))
			end
		end

end
