class
	P_STREAM_STATIC

inherit
	CE_UTILITIES
	S_STDIO_STATIC

feature {ANY} -- public attributes

	gsl_stream: CE_STATIC [CE_POINTER [SD_IO_FILE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
		end

	gsl_stream_handler: CE_STATIC [CE_ROUTINE]
		once ("PROCESS")
			Result.item := create {CE_ROUTINE}.make_shared (default_pointer)
		end

feature {ANY} -- public routines

	gsl_stream_printf (a_label, a_file: CE_POINTER [INTEGER_8]; a_line: INTEGER_32; a_reason: CE_POINTER [INTEGER_8])
		local
			l_return: BOOLEAN
		do
			if gsl_stream.item.is_void then
				gsl_stream.item := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))
			end
			if (not gsl_stream_handler.item.is_void) then
				gsl_stream_handler.item.call ([a_label, a_file, a_line, a_reason])
				l_return := True
			end
			if not l_return then
				fprintf ([gsl_stream.item, ce_string ("gsl: %%s:%%d: %%s: %%s%N"), a_file, a_line, a_label, a_reason]).do_nothing
			end
		end

	gsl_set_stream_handler (a_new_handler: CE_ROUTINE): CE_ROUTINE
		local
			l_previous_handler: CE_ROUTINE
		do
			l_previous_handler := gsl_stream_handler.item
			gsl_stream_handler.item := a_new_handler
			Result := l_previous_handler
		end

	gsl_set_stream (a_new_stream: CE_POINTER [SD_IO_FILE]): CE_POINTER [SD_IO_FILE]
		local
			l_previous_stream: CE_POINTER [SD_IO_FILE]
		do
			if gsl_stream.item.is_void then
				gsl_stream.item := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))
			end
			l_previous_stream := gsl_stream.item
			gsl_stream.item := a_new_stream
			Result := l_previous_stream
		end

end
