class
	P_WEIBULL_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_weibull_pdf (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_p: REAL_64
			l_tmp___0: REAL_64
		do
			if a_x < (0).to_double then
				Result := (0).to_double
			elseif a_x = (0).to_double then
				if a_b___0 = (1).to_double then
					Result := ((1).to_double / a_a___5)
				else
					Result := (0).to_double
				end
			elseif a_b___0 = (1).to_double then
				Result := ((exp (-a_x / a_a___5)) / a_a___5)
			else
				l_tmp___0 := pow (a_x / a_a___5, a_b___0)
				l_p := (a_b___0 / a_a___5) * (exp (-l_tmp___0 + (a_b___0 - (1).to_double) * (log (a_x / a_a___5))))
				Result := l_p
			end
		end

	gsl_cdf_weibull_P (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_P___2: REAL_64
		do
			l_P___2 := -(expm1 (-(pow (a_x / a_a___5, a_b___0))))
			Result := l_P___2
		end

	gsl_cdf_weibull_Q (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
		do
			l_Q___1 := (exp (-(pow (a_x / a_a___5, a_b___0))))
			Result := l_Q___1
		end

end
