class
	P_WORK_UTRUNC_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_sum_levin_utrunc_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("length n must be positive integer"), ce_string ("work_utrunc.c"), 13, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_w := create {CE_CLASS_POINTER [PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE]}.make_cast ((malloc ((create {PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE}.make).structure_size.to_natural_32)))
				if l_w.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate struct"), ce_string ("work_utrunc.c"), 20, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.q_num := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.q_num).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for q_num"), ce_string ("work_utrunc.c"), 29, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.q_den := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.q_den).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.q_num))
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for q_den"), ce_string ("work_utrunc.c"), 39, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.dsum := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.dsum).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.q_den))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.q_num))
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for dsum"), ce_string ("work_utrunc.c"), 50, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.size := a_n
				l_w.item.terms_used := (0).to_natural_32
				l_w.item.sum_plain := (0).to_double
				Result := l_w
			end
		end

	gsl_sum_levin_utrunc_free (a_w: CE_POINTER [PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE])
		local
			l_return: BOOLEAN
		do
			if a_w.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_w.item.dsum))
				free (create {CE_VOID_POINTER}.make_cast (a_w.item.q_den))
				free (create {CE_VOID_POINTER}.make_cast (a_w.item.q_num))
				free (create {CE_VOID_POINTER}.make_cast (a_w))
			end
		end

end
