class
	PD_DNEWTON_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} J.make
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} lu.make
			create {CE_CLASS_POINTER [PD_GSL_PERMUTATION_STRUCT]} permutation.make
		end

feature {ANY} -- fields

	J: CE_POINTER [PD_GSL_MATRIX] assign set_J

	lu: CE_POINTER [PD_GSL_MATRIX] assign set_lu

	permutation: CE_POINTER [PD_GSL_PERMUTATION_STRUCT] assign set_permutation

feature {ANY} -- field setters

	set_J (a_J: CE_POINTER [PD_GSL_MATRIX])
		do
			J := a_J
			update_memory_field ("J")
		end

	set_lu (a_lu: CE_POINTER [PD_GSL_MATRIX])
		do
			lu := a_lu
			update_memory_field ("lu")
		end

	set_permutation (a_permutation: CE_POINTER [PD_GSL_PERMUTATION_STRUCT])
		do
			permutation := a_permutation
			update_memory_field ("permutation")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			J := a_other.J
			lu := a_other.lu
			permutation := a_other.permutation
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				J.is_equal (a_other.J) and
				lu.is_equal (a_other.lu) and
				permutation.is_equal (a_other.permutation)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("J"),
					create {CE_STRUCTURE_FIELD}.make ("lu"),
					create {CE_STRUCTURE_FIELD}.make ("permutation")
				>>)
			init_structure_info
		end

end
