class
	PD_EXTRAPOLATION_TABLE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_MATH_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_REAL_64_ARRAY} rlist2.make (<<52>>)
			create {CE_REAL_64_ARRAY} res3la.make (<<3>>)
			Precursor
		end

feature {ANY} -- fields

	n: NATURAL_32 assign set_n

	rlist2: CE_ARRAY [REAL_64]

	nres: NATURAL_32 assign set_nres

	res3la: CE_ARRAY [REAL_64]

feature {ANY} -- field setters

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_nres (a_nres: NATURAL_32)
		do
			nres := a_nres
			update_memory_field ("nres")
		end

feature {ANY} -- public routines

	initialise_table
		do
			Current.n := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Current.nres := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
		end

	append_table (a_y: REAL_64)
		local
			l_n: NATURAL_32
		do
			l_n := n
			rlist2[l_n.to_integer_32] := a_y
			update_class_fields -- Current might have been changed; synchronize
			Current.n := n + 1
			update_class_fields -- Current might have been changed; synchronize
		end

	qelg (a_result, a_abserr: CE_POINTER [REAL_64])
		require
			not a_result.is_void
			not a_abserr.is_void
		local
			l_epstab: CE_POINTER [REAL_64]
			l_res3la: CE_POINTER [REAL_64]
			l_n: NATURAL_32
			l_current: REAL_64
			l_absolute: REAL_64
			l_relative: REAL_64
			l_tmp: REAL_64
			l_newelm: NATURAL_32
			l_n_orig: NATURAL_32
			l_n_final: NATURAL_32
			l_i: NATURAL_32
			l_nres_orig: NATURAL_32
			l_res: REAL_64
			l_e0: REAL_64
			l_e1: REAL_64
			l_e2: REAL_64
			l_e1abs: REAL_64
			l_tmp___0: REAL_64
			l_delta2: REAL_64
			l_err2: REAL_64
			l_tmp___1: REAL_64
			l_tol2: REAL_64
			l_tmp___2: REAL_64
			l_tmp___3: REAL_64
			l_delta3: REAL_64
			l_err3: REAL_64
			l_tmp___4: REAL_64
			l_tol3: REAL_64
			l_tmp___5: REAL_64
			l_tmp___6: REAL_64
			l_e3: REAL_64
			l_delta1: REAL_64
			l_err1: REAL_64
			l_tol1: REAL_64
			l_ss: REAL_64
			l_tmp___7: REAL_64
			l_tmp___8: REAL_64
			l_tmp___9: REAL_64
			l_tmp___10: REAL_64
			l_error: REAL_64
			l_tmp___11: REAL_64
			l_limexp: NATURAL_32
			l_tmp___12: REAL_64
			l_tmp___13: REAL_64
			l_tmp___14: REAL_64
			l_tmp___15: REAL_64
			l_return, l_break: BOOLEAN
		do
			l_epstab := rlist2
			l_res3la := res3la
			l_n := n - {NATURAL_32} 1
			l_current := l_epstab[l_n.to_integer_32]
			l_absolute := 1.7976931348623157e+308
			l_tmp := fabs (l_current)
			update_class_fields -- Current might have been changed; synchronize
			l_relative := ((5).to_double * 2.2204460492503131e-16) * l_tmp
			l_newelm := l_n // {NATURAL_32} 2
			l_n_orig := l_n
			l_n_final := l_n
			l_nres_orig := nres
			a_result.item := l_current
			update_class_fields -- Current might have been changed; synchronize
			a_abserr.item := 1.7976931348623157e+308
			update_class_fields -- Current might have been changed; synchronize
			if l_n < {NATURAL_32} 2 then
				a_result.item := l_current
				update_class_fields -- Current might have been changed; synchronize
				a_abserr.item := (create {P_GSL_GSL_MINMAX_STATIC}).GSL_MAX_DBL (l_absolute, l_relative)
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_epstab[(l_n + {NATURAL_32} 2).to_integer_32] := l_epstab[l_n.to_integer_32]
				update_class_fields -- Current might have been changed; synchronize
				l_epstab[l_n.to_integer_32] := 1.7976931348623157e+308
				update_class_fields -- Current might have been changed; synchronize
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return or l_break) and then (l_i < l_newelm))
				loop
					l_break := False
					l_res := l_epstab[((l_n - {NATURAL_32} 2 * l_i) + {NATURAL_32} 2).to_integer_32]
					l_e0 := l_epstab[((l_n - {NATURAL_32} 2 * l_i) - {NATURAL_32} 2).to_integer_32]
					l_e1 := l_epstab[((l_n - {NATURAL_32} 2 * l_i) - {NATURAL_32} 1).to_integer_32]
					l_e2 := l_res
					l_tmp___0 := fabs (l_e1)
					update_class_fields -- Current might have been changed; synchronize
					l_e1abs := l_tmp___0
					l_delta2 := l_e2 - l_e1
					l_tmp___1 := fabs (l_delta2)
					update_class_fields -- Current might have been changed; synchronize
					l_err2 := l_tmp___1
					l_tmp___2 := fabs (l_e2)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___3 := (create {P_GSL_GSL_MINMAX_STATIC}).GSL_MAX_DBL (l_tmp___2, l_e1abs)
					update_class_fields -- Current might have been changed; synchronize
					l_tol2 := l_tmp___3 * 2.2204460492503131e-16
					l_delta3 := l_e1 - l_e0
					l_tmp___4 := fabs (l_delta3)
					update_class_fields -- Current might have been changed; synchronize
					l_err3 := l_tmp___4
					l_tmp___5 := fabs (l_e0)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___6 := (create {P_GSL_GSL_MINMAX_STATIC}).GSL_MAX_DBL (l_e1abs, l_tmp___5)
					update_class_fields -- Current might have been changed; synchronize
					l_tol3 := l_tmp___6 * 2.2204460492503131e-16
					if l_err2 <= l_tol2 then
						if l_err3 <= l_tol3 then
							a_result.item := l_res
							update_class_fields -- Current might have been changed; synchronize
							l_absolute := l_err2 + l_err3
							l_tmp___7 := fabs (l_res)
							update_class_fields -- Current might have been changed; synchronize
							l_relative := ((5).to_double * 2.2204460492503131e-16) * l_tmp___7
							a_abserr.item := (create {P_GSL_GSL_MINMAX_STATIC}).GSL_MAX_DBL (l_absolute, l_relative)
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if not l_return then
						l_e3 := l_epstab[(l_n - {NATURAL_32} 2 * l_i).to_integer_32]
						l_epstab[(l_n - {NATURAL_32} 2 * l_i).to_integer_32] := l_e1
						update_class_fields -- Current might have been changed; synchronize
						l_delta1 := l_e1 - l_e3
						l_err1 := fabs (l_delta1)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___8 := fabs (l_e3)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___9 := (create {P_GSL_GSL_MINMAX_STATIC}).GSL_MAX_DBL (l_e1abs, l_tmp___8)
						update_class_fields -- Current might have been changed; synchronize
						l_tol1 := l_tmp___9 * 2.2204460492503131e-16
						if l_err1 <= l_tol1 then
							l_n_final := {NATURAL_32} 2 * l_i
							l_break := True
						elseif l_err2 <= l_tol2 then
							l_n_final := {NATURAL_32} 2 * l_i
							l_break := True
						elseif l_err3 <= l_tol3 then
							l_n_final := {NATURAL_32} 2 * l_i
							l_break := True
						end
						if not (l_return or l_break) then
							l_ss := ((1).to_double / l_delta1 + (1).to_double / l_delta2) - (1).to_double / l_delta3
							l_tmp___10 := fabs (l_ss * l_e1)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___10 <= 0.0001 then
								l_n_final := {NATURAL_32} 2 * l_i
								l_break := True
							end
						end
						if not (l_return or l_break) then
							l_res := l_e1 + (1).to_double / l_ss
							l_epstab[(l_n - {NATURAL_32} 2 * l_i).to_integer_32] := l_res
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___11 := fabs (l_res - l_e2)
							update_class_fields -- Current might have been changed; synchronize
							l_error := (l_err2 + l_tmp___11) + l_err3
							if l_error <= a_abserr.item then
								a_abserr.item := l_error
								update_class_fields -- Current might have been changed; synchronize
								a_result.item := l_res
								update_class_fields -- Current might have been changed; synchronize
							end
							l_i := l_i + 1
						end
					end
				end
			end
			if not l_return then
				l_break := False
				l_limexp := (49).to_natural_32
				if l_n_final = l_limexp then
					l_n_final := {NATURAL_32} 2 * (l_limexp // {NATURAL_32} 2)
				end
				if l_n_orig \\ {NATURAL_32} 2 = {NATURAL_32} 1 then
					l_i := (0).to_natural_32
					from
					until
						not (l_i <= l_newelm)
					loop
						l_epstab[({NATURAL_32} 1 + l_i * {NATURAL_32} 2).to_integer_32] := l_epstab[(l_i * {NATURAL_32} 2 + {NATURAL_32} 3).to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i + 1
					end
				else
					l_i := (0).to_natural_32
					from
					until
						not (l_i <= l_newelm)
					loop
						l_epstab[(l_i * {NATURAL_32} 2).to_integer_32] := l_epstab[(l_i * {NATURAL_32} 2 + {NATURAL_32} 2).to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i + 1
					end
				end
				if l_n_orig /= l_n_final then
					l_i := (0).to_natural_32
					from
					until
						not (l_i <= l_n_final)
					loop
						l_epstab[l_i.to_integer_32] := l_epstab[((l_n_orig - l_n_final) + l_i).to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i + 1
					end
				end
				Current.n := l_n_final + {NATURAL_32} 1
				update_class_fields -- Current might have been changed; synchronize
				if l_nres_orig < {NATURAL_32} 3 then
					l_res3la[l_nres_orig.to_integer_32] := a_result.item
					update_class_fields -- Current might have been changed; synchronize
					a_abserr.item := 1.7976931348623157e+308
					update_class_fields -- Current might have been changed; synchronize
				else
					l_tmp___12 := fabs (a_result.item - l_res3la[2])
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___13 := fabs (a_result.item - l_res3la[1])
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___14 := fabs (a_result.item - l_res3la[0])
					update_class_fields -- Current might have been changed; synchronize
					a_abserr.item := (l_tmp___12 + l_tmp___13) + l_tmp___14
					update_class_fields -- Current might have been changed; synchronize
					l_res3la[0] := l_res3la[1]
					update_class_fields -- Current might have been changed; synchronize
					l_res3la[1] := l_res3la[2]
					update_class_fields -- Current might have been changed; synchronize
					l_res3la[2] := a_result.item
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.nres := l_nres_orig + {NATURAL_32} 1
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___15 := fabs (a_result.item)
				update_class_fields -- Current might have been changed; synchronize
				a_abserr.item := (create {P_GSL_GSL_MINMAX_STATIC}).GSL_MAX_DBL (a_abserr.item, ((5).to_double * 2.2204460492503131e-16) * l_tmp___15)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	initialise_table___0
		do
			Current.n := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Current.nres := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
		end

	append_table___0 (a_y: REAL_64)
		local
			l_n: NATURAL_32
		do
			l_n := n
			rlist2[l_n.to_integer_32] := a_y
			update_class_fields -- Current might have been changed; synchronize
			Current.n := n + 1
			update_class_fields -- Current might have been changed; synchronize
		end

	initialise_table___1
		do
			Current.n := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Current.nres := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
		end

	append_table___1 (a_y: REAL_64)
		local
			l_n: NATURAL_32
		do
			l_n := n
			rlist2[l_n.to_integer_32] := a_y
			update_class_fields -- Current might have been changed; synchronize
			Current.n := n + 1
			update_class_fields -- Current might have been changed; synchronize
		end

	initialise_table___2
		do
			Current.n := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Current.nres := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
		end

	append_table___2 (a_y: REAL_64)
		local
			l_n: NATURAL_32
		do
			l_n := n
			rlist2[l_n.to_integer_32] := a_y
			update_class_fields -- Current might have been changed; synchronize
			Current.n := n + 1
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			rlist2 := a_other.rlist2.twin
			nres := a_other.nres
			res3la := a_other.res3la.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				rlist2.is_equal (a_other.rlist2) and
				nres = a_other.nres and
				res3la.is_equal (a_other.res3la)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("rlist2", <<52>>),
					create {CE_STRUCTURE_FIELD}.make ("nres"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("res3la", <<3>>)
				>>)
			init_structure_info
		end

end
