class
	PD_GSL_COMPLEX

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_MATH_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_REAL_64_ARRAY} dat.make (<<2>>)
			Precursor
		end

feature {ANY} -- fields

	dat: CE_ARRAY [REAL_64]

feature {ANY} -- public routines

	gsl_poly_complex_solve_cubic (a_a___5, a_b___0, a_c___1: REAL_64; a_z1, a_z2: CE_POINTER [PD_GSL_COMPLEX]): INTEGER_32
		require
			not a_z1.is_void
			not a_z2.is_void
		local
			l_q___3: REAL_64
			l_r___3: REAL_64
			l_Q___1: REAL_64
			l_R: REAL_64
			l_Q3___0: REAL_64
			l_R2: REAL_64
			l_CR2: REAL_64
			l_CQ3: REAL_64
			l_sqrtQ: REAL_64
			l_tmp: REAL_64
			l_sgnR: REAL_64
			l_tmp___0: INTEGER_32
			l_ratio: REAL_64
			l_tmp___1: REAL_64
			l_theta: REAL_64
			l_tmp___2: REAL_64
			l_norm___0: REAL_64
			l_tmp___3: REAL_64
			l_r0: REAL_64
			l_tmp___4: REAL_64
			l_r1___1: REAL_64
			l_tmp___5: REAL_64
			l_r2___0: REAL_64
			l_tmp___6: REAL_64
			l_tmp___7: REAL_64
			l_tmp___8: REAL_64
			l_tmp___9: REAL_64
			l_sgnR___0: REAL_64
			l_tmp___10: INTEGER_32
			l_A___0: REAL_64
			l_tmp___11: REAL_64
			l_tmp___12: REAL_64
			l_tmp___13: REAL_64
			l_B: REAL_64
			l_tmp___14: REAL_64
			l_tmp___15: REAL_64
			l_tmp___16: REAL_64
			l_tmp___17: REAL_64
			l_tmp___18: REAL_64
			l_tmp___19: REAL_64
			l_tmp___20: REAL_64
			l_tmp___21: REAL_64
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_q___3 := a_a___5 * a_a___5 - (3).to_double * a_b___0
					l_r___3 := ((((2).to_double * a_a___5) * a_a___5) * a_a___5 - ((9).to_double * a_a___5) * a_b___0) + (27).to_double * a_c___1
					l_Q___1 := l_q___3 / (9).to_double
					l_R := l_r___3 / (54).to_double
					l_Q3___0 := (l_Q___1 * l_Q___1) * l_Q___1
					l_R2 := l_R * l_R
					l_CR2 := ((729).to_double * l_r___3) * l_r___3
					l_CQ3 := (((2_916).to_double * l_q___3) * l_q___3) * l_q___3
					if l_R /= (0).to_double then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_Q___1 = (0).to_double then
							dat[0] := -a_a___5 / (3).to_double
							update_class_fields -- Current might have been changed; synchronize
							dat[1] := (0).to_double
							update_class_fields -- Current might have been changed; synchronize
							a_z1.item.dat[0] := -a_a___5 / (3).to_double
							update_class_fields -- Current might have been changed; synchronize
							a_z1.item.dat[1] := (0).to_double
							update_class_fields -- Current might have been changed; synchronize
							a_z2.item.dat[0] := -a_a___5 / (3).to_double
							update_class_fields -- Current might have been changed; synchronize
							a_z2.item.dat[1] := (0).to_double
							update_class_fields -- Current might have been changed; synchronize
							Result := 3
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if l_CR2 = l_CQ3 then
							l_tmp := sqrt (l_Q___1)
							update_class_fields -- Current might have been changed; synchronize
							l_sqrtQ := l_tmp
							if l_R > (0).to_double then
								dat[0] := (-2).to_double * l_sqrtQ - a_a___5 / (3).to_double
								update_class_fields -- Current might have been changed; synchronize
								dat[1] := (0).to_double
								update_class_fields -- Current might have been changed; synchronize
								a_z1.item.dat[0] := l_sqrtQ - a_a___5 / (3).to_double
								update_class_fields -- Current might have been changed; synchronize
								a_z1.item.dat[1] := (0).to_double
								update_class_fields -- Current might have been changed; synchronize
								a_z2.item.dat[0] := l_sqrtQ - a_a___5 / (3).to_double
								update_class_fields -- Current might have been changed; synchronize
								a_z2.item.dat[1] := (0).to_double
								update_class_fields -- Current might have been changed; synchronize
							else
								dat[0] := -l_sqrtQ - a_a___5 / (3).to_double
								update_class_fields -- Current might have been changed; synchronize
								dat[1] := (0).to_double
								update_class_fields -- Current might have been changed; synchronize
								a_z1.item.dat[0] := -l_sqrtQ - a_a___5 / (3).to_double
								update_class_fields -- Current might have been changed; synchronize
								a_z1.item.dat[1] := (0).to_double
								update_class_fields -- Current might have been changed; synchronize
								a_z2.item.dat[0] := (2).to_double * l_sqrtQ - a_a___5 / (3).to_double
								update_class_fields -- Current might have been changed; synchronize
								a_z2.item.dat[1] := (0).to_double
								update_class_fields -- Current might have been changed; synchronize
							end
							Result := 3
						elseif l_R2 < l_Q3___0 then
							if l_R >= (0).to_double then
								l_tmp___0 := 1
							else
								l_tmp___0 := -1
							end
							l_sgnR := l_tmp___0.to_double
							l_tmp___1 := sqrt (l_R2 / l_Q3___0)
							update_class_fields -- Current might have been changed; synchronize
							l_ratio := l_sgnR * l_tmp___1
							l_tmp___2 := acos (l_ratio)
							update_class_fields -- Current might have been changed; synchronize
							l_theta := l_tmp___2
							l_tmp___3 := sqrt (l_Q___1)
							update_class_fields -- Current might have been changed; synchronize
							l_norm___0 := (-2).to_double * l_tmp___3
							l_tmp___4 := cos (l_theta / (3).to_double)
							update_class_fields -- Current might have been changed; synchronize
							l_r0 := l_norm___0 * l_tmp___4 - a_a___5 / (3).to_double
							l_tmp___5 := cos ((l_theta + 2.0 * 3.14159265358979323846) / (3).to_double)
							update_class_fields -- Current might have been changed; synchronize
							l_r1___1 := l_norm___0 * l_tmp___5 - a_a___5 / (3).to_double
							l_tmp___6 := cos ((l_theta - 2.0 * 3.14159265358979323846) / (3).to_double)
							update_class_fields -- Current might have been changed; synchronize
							l_r2___0 := l_norm___0 * l_tmp___6 - a_a___5 / (3).to_double
							if l_r0 > l_r1___1 then
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___7 := l_r1___1
									l_r1___1 := l_r0
									l_r0 := l_tmp___7
									l_break := True
								end
								l_break := False
							end
							if l_r1___1 > l_r2___0 then
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___8 := l_r2___0
									l_r2___0 := l_r1___1
									l_r1___1 := l_tmp___8
									l_break := True
								end
								l_break := False
								if l_r0 > l_r1___1 then
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp___9 := l_r1___1
										l_r1___1 := l_r0
										l_r0 := l_tmp___9
										l_break := True
									end
									l_break := False
								end
							end
							dat[0] := l_r0
							update_class_fields -- Current might have been changed; synchronize
							dat[1] := (0).to_double
							update_class_fields -- Current might have been changed; synchronize
							a_z1.item.dat[0] := l_r1___1
							update_class_fields -- Current might have been changed; synchronize
							a_z1.item.dat[1] := (0).to_double
							update_class_fields -- Current might have been changed; synchronize
							a_z2.item.dat[0] := l_r2___0
							update_class_fields -- Current might have been changed; synchronize
							a_z2.item.dat[1] := (0).to_double
							update_class_fields -- Current might have been changed; synchronize
							Result := 3
						else
							if l_R >= (0).to_double then
								l_tmp___10 := 1
							else
								l_tmp___10 := -1
							end
							l_sgnR___0 := l_tmp___10.to_double
							l_tmp___11 := fabs (l_R)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___12 := sqrt (l_R2 - l_Q3___0)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___13 := pow (l_tmp___11 + l_tmp___12, 1.0 / 3.0)
							update_class_fields -- Current might have been changed; synchronize
							l_A___0 := -l_sgnR___0 * l_tmp___13
							l_B := l_Q___1 / l_A___0
							if l_A___0 + l_B < (0).to_double then
								dat[0] := (l_A___0 + l_B) - a_a___5 / (3).to_double
								update_class_fields -- Current might have been changed; synchronize
								dat[1] := (0).to_double
								update_class_fields -- Current might have been changed; synchronize
								a_z1.item.dat[0] := -0.5 * (l_A___0 + l_B) - a_a___5 / (3).to_double
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___14 := sqrt (3.0)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___15 := fabs (l_A___0 - l_B)
								update_class_fields -- Current might have been changed; synchronize
								a_z1.item.dat[1] := -(l_tmp___14 / 2.0) * l_tmp___15
								update_class_fields -- Current might have been changed; synchronize
								a_z2.item.dat[0] := -0.5 * (l_A___0 + l_B) - a_a___5 / (3).to_double
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___16 := sqrt (3.0)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___17 := fabs (l_A___0 - l_B)
								update_class_fields -- Current might have been changed; synchronize
								a_z2.item.dat[1] := (l_tmp___16 / 2.0) * l_tmp___17
								update_class_fields -- Current might have been changed; synchronize
							else
								dat[0] := -0.5 * (l_A___0 + l_B) - a_a___5 / (3).to_double
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___18 := sqrt (3.0)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___19 := fabs (l_A___0 - l_B)
								update_class_fields -- Current might have been changed; synchronize
								dat[1] := -(l_tmp___18 / 2.0) * l_tmp___19
								update_class_fields -- Current might have been changed; synchronize
								a_z1.item.dat[0] := -0.5 * (l_A___0 + l_B) - a_a___5 / (3).to_double
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___20 := sqrt (3.0)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___21 := fabs (l_A___0 - l_B)
								update_class_fields -- Current might have been changed; synchronize
								a_z1.item.dat[1] := (l_tmp___20 / 2.0) * l_tmp___21
								update_class_fields -- Current might have been changed; synchronize
								a_z2.item.dat[0] := (l_A___0 + l_B) - a_a___5 / (3).to_double
								update_class_fields -- Current might have been changed; synchronize
								a_z2.item.dat[1] := (0).to_double
								update_class_fields -- Current might have been changed; synchronize
							end
							Result := 3
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			dat := a_other.dat.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				dat.is_equal (a_other.dat)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("dat", <<2>>)
				>>)
			init_structure_info
		end

end
