class
	PD_GSL_FUNCTION_FDF_STRUCT

inherit
	PD_GSL_FUNCTION_FDF_STRUCT_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_GCC_BUILTIN_STATIC
		redefine
			copy,
			is_equal
		end
	S_MATH_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create f.make
			create df.make
			create fdf.make
			create {CE_VOID_POINTER} params.make
			Precursor
		end

feature {ANY} -- fields

	f: CE_ROUTINE assign set_f

	df: CE_ROUTINE assign set_df

	fdf: CE_ROUTINE assign set_fdf

	params: CE_POINTER [ANY] assign set_params

feature {ANY} -- field setters

	set_f (a_f: CE_ROUTINE)
		do
			f := a_f
			update_memory_field ("f")
		end

	set_df (a_df: CE_ROUTINE)
		do
			df := a_df
			update_memory_field ("df")
		end

	set_fdf (a_fdf: CE_ROUTINE)
		do
			fdf := a_fdf
			update_memory_field ("fdf")
		end

	set_params (a_params: CE_POINTER [ANY])
		do
			params := a_params
			update_memory_field ("params")
		end

feature {ANY} -- public routines

	minimize___2 (a_rho, a_sigma, a_tau1, a_tau2, a_tau3: REAL_64; a_order: INTEGER_32; a_alpha1: REAL_64; a_alpha_new: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_f0: CE_ARRAY [REAL_64]
			l_fp0: CE_ARRAY [REAL_64]
			l_falpha: REAL_64
			l_falpha_prev: REAL_64
			l_fpalpha: REAL_64
			l_fpalpha_prev: REAL_64
			l_delta___0: REAL_64
			l_alpha_next: REAL_64
			l_alpha: REAL_64
			l_alpha_prev: REAL_64
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_fa: REAL_64
			l_fb: REAL_64
			l_fpa: REAL_64
			l_fpb: REAL_64
			l_bracket_iters: NATURAL_32
			l_section_iters: NATURAL_32
			l_i: NATURAL_32
			l_tmp: REAL_32
			l_tmp___0: REAL_64
			l_lower: REAL_64
			l_upper: REAL_64
			l_tmp___1: NATURAL_32
			l_lower___0: REAL_64
			l_upper___0: REAL_64
			l_tmp___2: REAL_32
			l_tmp___3: REAL_64
			l_tmp___4: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_REAL_64_ARRAY} l_f0.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_fp0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_alpha := a_alpha1
					l_alpha_prev := 0.0
					l_bracket_iters := (100).to_natural_32
					l_section_iters := (100).to_natural_32
					l_i := (0).to_natural_32
					fdf.call ([0.0, params, l_f0, l_fp0])
					update_class_fields -- Current might have been changed; synchronize
					l_falpha_prev := l_f0.item
					l_fpalpha_prev := l_fp0.item
					l_a___5 := 0.0
					l_b___0 := l_alpha
					l_fa := l_f0.item
					l_fb := 0.0
					l_fpa := l_fp0.item
					l_fpb := 0.0
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_tmp___1 := l_i
						l_i := l_i + 1
						if not (l_tmp___1 < l_bracket_iters) then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						l_falpha := f.real_64_item ([l_alpha, params])
						update_class_fields -- Current might have been changed; synchronize
						if not (l_falpha > l_f0.item + (l_alpha * a_rho) * l_fp0.item) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if not (l_falpha >= l_falpha_prev) then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_a___5 := l_alpha_prev
						l_fa := l_falpha_prev
						l_fpa := l_fpalpha_prev
						l_b___0 := l_alpha
						l_fb := l_falpha
						l_tmp := builtin_nanf (ce_string (""))
						update_class_fields -- Current might have been changed; synchronize
						l_fpb := l_tmp.to_double
						l_break := True
				when 8 then -- if done | if done
						if not (l_return or l_break) then
							l_fpalpha := df.real_64_item ([l_alpha, params])
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___0 := fabs (l_fpalpha)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___0 <= -a_sigma * l_fp0.item then
								a_alpha_new.item := l_alpha
								update_class_fields -- Current might have been changed; synchronize
								Result := 0
								l_return := True
							end
							if not l_return then
								if l_fpalpha >= (0).to_double then
									l_a___5 := l_alpha
									l_fa := l_falpha
									l_fpa := l_fpalpha
									l_b___0 := l_alpha_prev
									l_fb := l_falpha_prev
									l_fpb := l_fpalpha_prev
									l_break := True
								end
								if not (l_return or l_break) then
									l_delta___0 := l_alpha - l_alpha_prev
									l_lower := l_alpha + l_delta___0
									l_upper := l_alpha + a_tau1 * l_delta___0
									l_alpha_next := interpolate (l_alpha_prev, l_falpha_prev, l_fpalpha_prev, l_alpha, l_falpha, l_fpalpha, l_lower, l_upper, a_order)
									update_class_fields -- Current might have been changed; synchronize
									l_alpha_prev := l_alpha
									l_falpha_prev := l_falpha
									l_fpalpha_prev := l_fpalpha
									l_alpha := l_alpha_next
								end
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					if l_return then
						l_pos := -1 + 32 -- skip if block
					end
				when 10 then -- if:
						l_break := False
				when 11 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 32 -- skip loop
						end
				when 12 then -- loop body:
						l_break := False
						l_tmp___4 := l_i
						l_i := l_i + 1
						if not (l_tmp___4 < l_section_iters) then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 31 -- skip if block
						end
				when 13 then -- if:
						l_delta___0 := l_b___0 - l_a___5
						l_lower___0 := l_a___5 + a_tau2 * l_delta___0
						l_upper___0 := l_b___0 - a_tau3 * l_delta___0
						l_alpha := interpolate (l_a___5, l_fa, l_fpa, l_b___0, l_fb, l_fpb, l_lower___0, l_upper___0, a_order)
						update_class_fields -- Current might have been changed; synchronize
						l_falpha := f.real_64_item ([l_alpha, params])
						update_class_fields -- Current might have been changed; synchronize
						if (l_a___5 - l_alpha) * l_fpa <= 2.2204460492503131e-16 then
							Result := 27
							l_return := True
						end
						if l_return then
							l_pos := -1 + 31 -- skip if block
						end
				when 14 then -- if:
						if not (l_falpha > l_f0.item + (a_rho * l_alpha) * l_fp0.item) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_b___0 := l_alpha
						l_fb := l_falpha
						l_tmp___2 := builtin_nanf (ce_string (""))
						update_class_fields -- Current might have been changed; synchronize
						l_fpb := l_tmp___2.to_double
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 17 then -- else:
						if not (l_falpha >= l_fa) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_b___0 := l_alpha
						l_fb := l_falpha
						l_tmp___2 := builtin_nanf (ce_string (""))
						update_class_fields -- Current might have been changed; synchronize
						l_fpb := l_tmp___2.to_double
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 20 then -- else:
						l_fpalpha := df.real_64_item ([l_alpha, params])
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___3 := fabs (l_fpalpha)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___3 <= -a_sigma * l_fp0.item then
							a_alpha_new.item := l_alpha
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 31 -- skip if block
						end
				when 21 then -- if:
						if not (l_b___0 - l_a___5 >= (0).to_double) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if l_fpalpha >= (0).to_double then
							l_pos := -1 + 26 -- goto _L___0
						else
							l_pos := -1 + 24 -- goto _L___1
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 24 then -- else: | _L___1:
						if not (l_b___0 - l_a___5 <= (0).to_double) then
							l_pos := -1 + 30 -- skip if block
						end
				when 25 then -- if:
						if not (l_fpalpha <= (0).to_double) then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if: | _L___0:
						l_b___0 := l_a___5
						l_fb := l_fa
						l_fpb := l_fpa
						l_a___5 := l_alpha
						l_fa := l_falpha
						l_fpa := l_fpalpha
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_a___5 := l_alpha
						l_fa := l_falpha
						l_fpa := l_fpalpha
				when 29 then -- if done | if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else:
						l_a___5 := l_alpha
						l_fa := l_falpha
						l_fpa := l_fpalpha
				when 31 then -- if done | if done | if done | if done | if done | if done
						l_pos := -1 + 11 -- back to loop condition
				when 32 then -- loop done | if done
					if not l_return then
						l_break := False
						Result := 0
					end
				when 33 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	newton_init (a_vstate: CE_POINTER [ANY]; a_root: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_root.is_void
		local
			l_state: CE_POINTER [PD_NEWTON_STATE_T2]
			l_x: REAL_64
		do
			l_state := create {CE_CLASS_POINTER [PD_NEWTON_STATE_T2]}.make_cast (a_vstate)
			l_x := a_root.item
			l_state.item.f := f.real_64_item ([l_x, params])
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.df := df.real_64_item ([l_x, params])
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	steffenson_init (a_vstate: CE_POINTER [ANY]; a_root: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_root.is_void
		local
			l_state: CE_POINTER [PD_STEFFENSON_STATE_T]
			l_x: REAL_64
		do
			l_state := create {CE_CLASS_POINTER [PD_STEFFENSON_STATE_T]}.make_cast (a_vstate)
			l_x := a_root.item
			l_state.item.f := f.real_64_item ([l_x, params])
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.df := df.real_64_item ([l_x, params])
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.x := l_x
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.x_1 := 0.0
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.x_2 := 0.0
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.count := 1
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	secant_init (a_vstate: CE_POINTER [ANY]; a_root: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_root.is_void
		local
			l_state: CE_POINTER [PD_SECANT_STATE_T]
			l_x: REAL_64
		do
			l_state := create {CE_CLASS_POINTER [PD_SECANT_STATE_T]}.make_cast (a_vstate)
			l_x := a_root.item
			fdf.call ([l_x, params, create {CE_REAL_64_POINTER}.make_shared (l_state.c_pointer + (create {PD_SECANT_STATE_T}.make).offset_of ("f")), create {CE_REAL_64_POINTER}.make_shared (l_state.c_pointer + (create {PD_SECANT_STATE_T}.make).offset_of ("df"))])
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

feature {PD_GSL_FUNCTION_FDF_STRUCT} -- private routines

	interpolate (a_a___5, a_fa, a_fpa, a_b___0, a_fb, a_fpb, a_xmin, a_xmax: REAL_64; a_order: INTEGER_32): REAL_64
		local
			l_z: REAL_64
			l_alpha: REAL_64
			l_zmin: REAL_64
			l_zmax: REAL_64
			l_tmp: REAL_64
		do
			l_zmin := (a_xmin - a_a___5) / (a_b___0 - a_a___5)
			l_zmax := (a_xmax - a_a___5) / (a_b___0 - a_a___5)
			if l_zmin > l_zmax then
				l_tmp := l_zmin
				l_zmin := l_zmax
				l_zmax := l_tmp
			end
			if a_order > 2 then
				if ((create {P_INFNAN_STATIC}).gsl_finite (a_fpb)).to_boolean then
					l_z := interp_cubic (a_fa, a_fpa * (a_b___0 - a_a___5), a_fb, a_fpb * (a_b___0 - a_a___5), l_zmin, l_zmax)
				else
					l_z := interp_quad (a_fa, a_fpa * (a_b___0 - a_a___5), a_fb, l_zmin, l_zmax)
				end
			else
				l_z := interp_quad (a_fa, a_fpa * (a_b___0 - a_a___5), a_fb, l_zmin, l_zmax)
			end
			l_alpha := a_a___5 + l_z * (a_b___0 - a_a___5)
			Result := l_alpha
		end

	interp_quad (a_f0, a_fp0, a_f1, a_zl, a_zh: REAL_64): REAL_64
		local
			l_fl: REAL_64
			l_fh: REAL_64
			l_c___1: REAL_64
			l_zmin: REAL_64
			l_fmin___0: REAL_64
			l_z: REAL_64
			l_f: REAL_64
		do
			l_fl := a_f0 + a_zl * (a_fp0 + a_zl * ((a_f1 - a_f0) - a_fp0))
			l_fh := a_f0 + a_zh * (a_fp0 + a_zh * ((a_f1 - a_f0) - a_fp0))
			l_c___1 := (2).to_double * ((a_f1 - a_f0) - a_fp0)
			l_zmin := a_zl
			l_fmin___0 := l_fl
			if l_fh < l_fmin___0 then
				l_zmin := a_zh
				l_fmin___0 := l_fh
			end
			if l_c___1 > (0).to_double then
				l_z := -a_fp0 / l_c___1
				if l_z > a_zl then
					if l_z < a_zh then
						l_f := a_f0 + l_z * (a_fp0 + l_z * ((a_f1 - a_f0) - a_fp0))
						if l_f < l_fmin___0 then
							l_zmin := l_z
							l_fmin___0 := l_f
						end
					end
				end
			end
			Result := l_zmin
		end

	interp_cubic (a_f0, a_fp0, a_f1, a_fp1, a_zl, a_zh: REAL_64): REAL_64
		local
			l_eta: REAL_64
			l_xi: REAL_64
			l_c0___0: REAL_64
			l_c1___2: REAL_64
			l_c2___0: REAL_64
			l_c3___3: REAL_64
			l_zmin: CE_ARRAY [REAL_64]
			l_fmin___0: CE_ARRAY [REAL_64]
			l_z0: CE_ARRAY [REAL_64]
			l_z1: CE_ARRAY [REAL_64]
			l_n: INTEGER_32
		do
			create {CE_REAL_64_ARRAY} l_zmin.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_fmin___0.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_z0.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_z1.make (<<1>>)

			l_eta := ((3).to_double * (a_f1 - a_f0) - (2).to_double * a_fp0) - a_fp1
			l_xi := (a_fp0 + a_fp1) - (2).to_double * (a_f1 - a_f0)
			l_c0___0 := a_f0
			l_c1___2 := a_fp0
			l_c2___0 := l_eta
			l_c3___3 := l_xi
			l_zmin.item := a_zl
			l_fmin___0.item := cubic (l_c0___0, l_c1___2, l_c2___0, l_c3___3, a_zl)
			check_extremum (l_c0___0, l_c1___2, l_c2___0, l_c3___3, a_zh, l_zmin, l_fmin___0)
			l_n := (gsl_poly_solve_quadratic ((3).to_double * l_c3___3, (2).to_double * l_c2___0, l_c1___2, l_z0, l_z1))
			if l_n = 2 then
				if l_z0.item > a_zl then
					if l_z0.item < a_zh then
						check_extremum (l_c0___0, l_c1___2, l_c2___0, l_c3___3, l_z0.item, l_zmin, l_fmin___0)
					end
				end
				if l_z1.item > a_zl then
					if l_z1.item < a_zh then
						check_extremum (l_c0___0, l_c1___2, l_c2___0, l_c3___3, l_z1.item, l_zmin, l_fmin___0)
					end
				end
			elseif l_n = 1 then
				if l_z0.item > a_zl then
					if l_z0.item < a_zh then
						check_extremum (l_c0___0, l_c1___2, l_c2___0, l_c3___3, l_z0.item, l_zmin, l_fmin___0)
					end
				end
			end
			Result := (l_zmin.item)
		end

	check_extremum (a_c0___0, a_c1___2, a_c2___0, a_c3___3, a_z: REAL_64; a_zmin, a_fmin___0: CE_POINTER [REAL_64])
		require
			not a_fmin___0.is_void
		local
			l_y: REAL_64
		do
			l_y := (cubic (a_c0___0, a_c1___2, a_c2___0, a_c3___3, a_z))
			if l_y < a_fmin___0.item then
				a_zmin.item := a_z
				a_fmin___0.item := l_y
			end
		end

	cubic (a_c0___0, a_c1___2, a_c2___0, a_c3___3, a_z: REAL_64): REAL_64
		do
			Result := (a_c0___0 + a_z * (a_c1___2 + a_z * (a_c2___0 + a_z * a_c3___3)))
		end

	gsl_poly_solve_quadratic (a_a___5, a_b___0, a_c___1: REAL_64; a_x0, a_x1___0: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_disc: REAL_64
			l_r___3: REAL_64
			l_sgnb: REAL_64
			l_tmp___1: INTEGER_32
			l_temp: REAL_64
			l_r1___1: REAL_64
			l_r2___0: REAL_64
			l_return: BOOLEAN
		do
			l_disc := a_b___0 * a_b___0 - ((4).to_double * a_a___5) * a_c___1
			if a_a___5 = (0).to_double then
				if a_b___0 = (0).to_double then
					Result := 0
					l_return := True
				else
					a_x0.item := -a_c___1 / a_b___0
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				if l_disc > (0).to_double then
					if a_b___0 = (0).to_double then
						l_r___3 := (fabs ((0.5 * (sqrt (l_disc))) / a_a___5))
						a_x0.item := -l_r___3
						a_x1___0.item := l_r___3
					else
						if a_b___0 > (0).to_double then
							l_tmp___1 := 1
						else
							l_tmp___1 := -1
						end
						l_sgnb := l_tmp___1.to_double
						l_temp := -0.5 * (a_b___0 + l_sgnb * (sqrt (l_disc)))
						l_r1___1 := l_temp / a_a___5
						l_r2___0 := a_c___1 / l_temp
						if l_r1___1 < l_r2___0 then
							a_x0.item := l_r1___1
							a_x1___0.item := l_r2___0
						else
							a_x0.item := l_r2___0
							a_x1___0.item := l_r1___1
						end
					end
					Result := 2
				elseif l_disc = (0).to_double then
					a_x0.item := (-0.5 * a_b___0) / a_a___5
					a_x1___0.item := (-0.5 * a_b___0) / a_a___5
					Result := 2
				else
					Result := 0
				end
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			f := a_other.f
			df := a_other.df
			fdf := a_other.fdf
			params := a_other.params
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				f.is_equal (a_other.f) and
				df.is_equal (a_other.df) and
				fdf.is_equal (a_other.fdf) and
				params.is_equal (a_other.params)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("f"),
					create {CE_STRUCTURE_FIELD}.make ("df"),
					create {CE_STRUCTURE_FIELD}.make ("fdf"),
					create {CE_STRUCTURE_FIELD}.make ("params")
				>>)
			init_structure_info
		end

end
