class
	PD_GSL_IEEE_DOUBLE_REP

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_ARRAY} mantissa.make (<<53>>)
		end

feature {ANY} -- fields

	sign: INTEGER_32 assign set_sign

	mantissa: CE_ARRAY [INTEGER_8]

	exponent: INTEGER_32 assign set_exponent

	type: INTEGER_32 assign set_type

feature {ANY} -- field setters

	set_sign (a_sign: INTEGER_32)
		do
			sign := a_sign
			update_memory_field ("sign")
		end

	set_exponent (a_exponent: INTEGER_32)
		do
			exponent := a_exponent
			update_memory_field ("exponent")
		end

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

feature {ANY} -- public routines

	gsl_ieee_double_to_rep (a_x: CE_POINTER [REAL_64])
		require
			not a_x.is_void
		local
			l_e: INTEGER_32
			l_non_zero: INTEGER_32
			l_u: CE_ARRAY [PD_U5]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_U5]} l_u.make (<<1>>)

			l_u.item.d := a_x.item
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_ENDIAN_STATIC}).little_endian_p
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				make_double_bigendian (create {CE_REAL_64_POINTER}.make_shared (l_u.item.c_pointer + (create {PD_U5}.make).offset_of ("d")))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (((l_u.item.ieee.byte[7]).to_integer_32).bit_shift_right (7)).to_boolean then
				Current.sign := 1
				update_class_fields -- Current might have been changed; synchronize
			else
				Current.sign := 0
				update_class_fields -- Current might have been changed; synchronize
			end
			l_e := ((((((l_u.item.ieee.byte[7]).to_integer_32).bit_and (127))).bit_shift_left (4))).bit_xor ((((((l_u.item.ieee.byte[6]).to_integer_32).bit_and (240))).bit_shift_right (4)))
			Current.exponent := l_e - 1_023
			update_class_fields -- Current might have been changed; synchronize
			sprint_nybble ((l_u.item.ieee.byte[6]).to_integer_32, mantissa)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MAKE_REP_STATIC}).sprint_byte ((l_u.item.ieee.byte[5]).to_integer_32, mantissa + 4)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MAKE_REP_STATIC}).sprint_byte ((l_u.item.ieee.byte[4]).to_integer_32, mantissa + 12)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MAKE_REP_STATIC}).sprint_byte ((l_u.item.ieee.byte[3]).to_integer_32, mantissa + 20)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MAKE_REP_STATIC}).sprint_byte ((l_u.item.ieee.byte[2]).to_integer_32, mantissa + 28)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MAKE_REP_STATIC}).sprint_byte ((l_u.item.ieee.byte[1]).to_integer_32, mantissa + 36)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MAKE_REP_STATIC}).sprint_byte ((l_u.item.ieee.byte[0]).to_integer_32, mantissa + 44)
			update_class_fields -- Current might have been changed; synchronize
			mantissa[52] := (('%/0/').code).to_integer_8
			update_class_fields -- Current might have been changed; synchronize
			if (l_u.item.ieee.byte[0]).to_boolean then
				l_tmp___0 := 1
			elseif (l_u.item.ieee.byte[1]).to_boolean then
				l_tmp___0 := 1
			elseif (l_u.item.ieee.byte[2]).to_boolean then
				l_tmp___0 := 1
			elseif (l_u.item.ieee.byte[3]).to_boolean then
				l_tmp___0 := 1
			elseif (l_u.item.ieee.byte[4]).to_boolean then
				l_tmp___0 := 1
			elseif (l_u.item.ieee.byte[5]).to_boolean then
				l_tmp___0 := 1
			elseif (((l_u.item.ieee.byte[6]).to_integer_32).bit_and (15)).to_boolean then
				l_tmp___0 := 1
			else
				l_tmp___0 := 0
			end
			l_non_zero := l_tmp___0
			Current.type := (create {P_MAKE_REP_STATIC}).determine_ieee_type (l_non_zero, l_e, 2_047)
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_GSL_IEEE_DOUBLE_REP} -- private routines

	make_double_bigendian (a_x: CE_POINTER [REAL_64])
		require
			not a_x.is_void
		local
			l_u: PD_U3
			l_v: PD_U3
		do
			create l_u.make
			create l_v.make

			l_u.d := a_x.item
			l_u.update_class_fields -- synchronize union
			l_v.b[0] := l_u.b[7]
			l_v.update_class_fields -- synchronize union
			l_v.b[1] := l_u.b[6]
			l_v.update_class_fields -- synchronize union
			l_v.b[2] := l_u.b[5]
			l_v.update_class_fields -- synchronize union
			l_v.b[3] := l_u.b[4]
			l_v.update_class_fields -- synchronize union
			l_v.b[4] := l_u.b[3]
			l_v.update_class_fields -- synchronize union
			l_v.b[5] := l_u.b[2]
			l_v.update_class_fields -- synchronize union
			l_v.b[6] := l_u.b[1]
			l_v.update_class_fields -- synchronize union
			l_v.b[7] := l_u.b[0]
			l_v.update_class_fields -- synchronize union
			a_x.item := l_v.d
		end

	sprint_nybble (a_i: INTEGER_32; a_s: CE_POINTER [INTEGER_8])
		require
			not a_s.is_void
		local
			l_c___1: CE_POINTER [INTEGER_8]
		do
			l_c___1 := (create {P_MAKE_REP_STATIC}).nybble.item[(a_i).bit_and (15)]
			a_s[0] := l_c___1[0]
			a_s[1] := l_c___1[1]
			a_s[2] := l_c___1[2]
			a_s[3] := l_c___1[3]
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sign := a_other.sign
			mantissa := a_other.mantissa.twin
			exponent := a_other.exponent
			type := a_other.type
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sign = a_other.sign and
				mantissa.is_equal (a_other.mantissa) and
				exponent = a_other.exponent and
				type = a_other.type
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sign"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("mantissa", <<53>>),
					create {CE_STRUCTURE_FIELD}.make ("exponent"),
					create {CE_STRUCTURE_FIELD}.make ("type")
				>>)
			init_structure_info
		end

end
