class
	PD_GSL_INTEGRATION_GLFIXED_TABLE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_REAL_64_POINTER} x.make
			create {CE_REAL_64_POINTER} w.make
			Precursor
		end

feature {ANY} -- fields

	n: NATURAL_32 assign set_n

	x: CE_POINTER [REAL_64] assign set_x

	w: CE_POINTER [REAL_64] assign set_w

	precomputed: INTEGER_32 assign set_precomputed

feature {ANY} -- field setters

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_x (a_x: CE_POINTER [REAL_64])
		do
			x := a_x
			update_memory_field ("x")
		end

	set_w (a_w: CE_POINTER [REAL_64])
		do
			w := a_w
			update_memory_field ("w")
		end

	set_precomputed (a_precomputed: INTEGER_32)
		do
			precomputed := a_precomputed
			update_memory_field ("precomputed")
		end

feature {ANY} -- public routines

	gsl_integration_glfixed_table_free
		do
			if not precomputed.to_boolean then
				free (create {CE_VOID_POINTER}.make_cast (x))
				update_class_fields -- Current might have been changed; synchronize
				free (create {CE_VOID_POINTER}.make_cast (w))
				update_class_fields -- Current might have been changed; synchronize
				free (create {CE_VOID_POINTER}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			x := a_other.x
			w := a_other.w
			precomputed := a_other.precomputed
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				x.is_equal (a_other.x) and
				w.is_equal (a_other.w) and
				precomputed = a_other.precomputed
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("w"),
					create {CE_STRUCTURE_FIELD}.make ("precomputed")
				>>)
			init_structure_info
		end

end
