class
	PD_GSL_INTEGRATION_WORKSPACE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_REAL_64_POINTER} alist.make
			create {CE_REAL_64_POINTER} blist.make
			create {CE_REAL_64_POINTER} rlist.make
			create {CE_REAL_64_POINTER} elist.make
			create {CE_NATURAL_32_POINTER} order.make
			create {CE_NATURAL_32_POINTER} level.make
		end

feature {ANY} -- fields

	limit: NATURAL_32 assign set_limit

	size: NATURAL_32 assign set_size

	nrmax: NATURAL_32 assign set_nrmax

	i: NATURAL_32 assign set_i

	maximum_level: NATURAL_32 assign set_maximum_level

	alist: CE_POINTER [REAL_64] assign set_alist

	blist: CE_POINTER [REAL_64] assign set_blist

	rlist: CE_POINTER [REAL_64] assign set_rlist

	elist: CE_POINTER [REAL_64] assign set_elist

	order: CE_POINTER [NATURAL_32] assign set_order

	level: CE_POINTER [NATURAL_32] assign set_level

feature {ANY} -- field setters

	set_limit (a_limit: NATURAL_32)
		do
			limit := a_limit
			update_memory_field ("limit")
		end

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_nrmax (a_nrmax: NATURAL_32)
		do
			nrmax := a_nrmax
			update_memory_field ("nrmax")
		end

	set_i (a_i: NATURAL_32)
		do
			i := a_i
			update_memory_field ("i")
		end

	set_maximum_level (a_maximum_level: NATURAL_32)
		do
			maximum_level := a_maximum_level
			update_memory_field ("maximum_level")
		end

	set_alist (a_alist: CE_POINTER [REAL_64])
		do
			alist := a_alist
			update_memory_field ("alist")
		end

	set_blist (a_blist: CE_POINTER [REAL_64])
		do
			blist := a_blist
			update_memory_field ("blist")
		end

	set_rlist (a_rlist: CE_POINTER [REAL_64])
		do
			rlist := a_rlist
			update_memory_field ("rlist")
		end

	set_elist (a_elist: CE_POINTER [REAL_64])
		do
			elist := a_elist
			update_memory_field ("elist")
		end

	set_order (a_order: CE_POINTER [NATURAL_32])
		do
			order := a_order
			update_memory_field ("order")
		end

	set_level (a_level: CE_POINTER [NATURAL_32])
		do
			level := a_level
			update_memory_field ("level")
		end

feature {ANY} -- public routines

	initialise (a_a___5, a_b___0: REAL_64)
		do
			Current.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Current.nrmax := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Current.i := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			alist[0] := a_a___5
			update_class_fields -- Current might have been changed; synchronize
			blist[0] := a_b___0
			update_class_fields -- Current might have been changed; synchronize
			rlist[0] := 0.0
			update_class_fields -- Current might have been changed; synchronize
			elist[0] := 0.0
			update_class_fields -- Current might have been changed; synchronize
			order[0] := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			level[0] := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Current.maximum_level := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
		end

	set_initial_result (a_result, a_error: REAL_64)
		do
			Current.size := (1).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			rlist[0] := a_result
			update_class_fields -- Current might have been changed; synchronize
			elist[0] := a_error
			update_class_fields -- Current might have been changed; synchronize
		end

	qpsrt
		local
			l_last: NATURAL_32
			l_limit: NATURAL_32
			l_elist: CE_POINTER [REAL_64]
			l_order: CE_POINTER [NATURAL_32]
			l_errmax: REAL_64
			l_errmin: REAL_64
			l_i: INTEGER_32
			l_k: INTEGER_32
			l_top: INTEGER_32
			l_i_nrmax: NATURAL_32
			l_i_maxerr: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_last := size - {NATURAL_32} 1
			l_limit := limit
			l_elist := elist
			l_order := order
			l_i_nrmax := nrmax
			l_i_maxerr := l_order[l_i_nrmax.to_integer_32]
			if l_last < {NATURAL_32} 2 then
				l_order[0] := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_order[1] := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				Current.i := l_i_maxerr
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_errmax := l_elist[l_i_maxerr.to_integer_32]
				from
				until
					(l_break)
				loop
					l_break := False
					if l_i_nrmax > {NATURAL_32} 0 then
						if not (l_errmax > l_elist[(l_order[(l_i_nrmax - {NATURAL_32} 1).to_integer_32]).to_integer_32]) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_order[l_i_nrmax.to_integer_32] := l_order[(l_i_nrmax - {NATURAL_32} 1).to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						l_i_nrmax := l_i_nrmax - 1
					end
				end
				l_break := False
				if l_last < l_limit // {NATURAL_32} 2 + {NATURAL_32} 2 then
					l_top := l_last.to_integer_32
				else
					l_top := ((l_limit - l_last) + {NATURAL_32} 1).to_integer_32
				end
				l_i := (l_i_nrmax + {NATURAL_32} 1).to_integer_32
				from
				until
					(l_break)
				loop
					l_break := False
					if l_i < l_top then
						if not (l_errmax < l_elist[(l_order[l_i]).to_integer_32]) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_order[(l_i - 1)] := l_order[l_i]
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i + 1
					end
				end
				l_break := False
				l_order[(l_i - 1)] := l_i_maxerr
				update_class_fields -- Current might have been changed; synchronize
				l_errmin := l_elist[l_last.to_integer_32]
				l_k := l_top - 1
				from
				until
					(l_break)
				loop
					l_break := False
					if l_k > l_i - 2 then
						if not (l_errmin >= l_elist[(l_order[l_k]).to_integer_32]) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_order[(l_k + 1)] := l_order[l_k]
						update_class_fields -- Current might have been changed; synchronize
						l_k := l_k - 1
					end
				end
				l_break := False
				l_order[(l_k + 1)] := l_last
				update_class_fields -- Current might have been changed; synchronize
				l_i_maxerr := l_order[l_i_nrmax.to_integer_32]
				Current.i := l_i_maxerr
				update_class_fields -- Current might have been changed; synchronize
				Current.nrmax := l_i_nrmax
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	update (a_a1___4, a_b1___0, a_area1, a_error1, a_a2___3, a_b2, a_area2, a_error2: REAL_64)
		local
			l_alist: CE_POINTER [REAL_64]
			l_blist: CE_POINTER [REAL_64]
			l_rlist: CE_POINTER [REAL_64]
			l_elist: CE_POINTER [REAL_64]
			l_level: CE_POINTER [NATURAL_32]
			l_i_max: NATURAL_32
			l_i_new: NATURAL_32
			l_new_level: NATURAL_32
		do
			l_alist := alist
			l_blist := blist
			l_rlist := rlist
			l_elist := elist
			l_level := level
			l_i_max := i
			l_i_new := size
			l_new_level := level[l_i_max.to_integer_32] + {NATURAL_32} 1
			if a_error2 > a_error1 then
				l_alist[l_i_max.to_integer_32] := a_a2___3
				update_class_fields -- Current might have been changed; synchronize
				l_rlist[l_i_max.to_integer_32] := a_area2
				update_class_fields -- Current might have been changed; synchronize
				l_elist[l_i_max.to_integer_32] := a_error2
				update_class_fields -- Current might have been changed; synchronize
				l_level[l_i_max.to_integer_32] := l_new_level
				update_class_fields -- Current might have been changed; synchronize
				l_alist[l_i_new.to_integer_32] := a_a1___4
				update_class_fields -- Current might have been changed; synchronize
				l_blist[l_i_new.to_integer_32] := a_b1___0
				update_class_fields -- Current might have been changed; synchronize
				l_rlist[l_i_new.to_integer_32] := a_area1
				update_class_fields -- Current might have been changed; synchronize
				l_elist[l_i_new.to_integer_32] := a_error1
				update_class_fields -- Current might have been changed; synchronize
				l_level[l_i_new.to_integer_32] := l_new_level
				update_class_fields -- Current might have been changed; synchronize
			else
				l_blist[l_i_max.to_integer_32] := a_b1___0
				update_class_fields -- Current might have been changed; synchronize
				l_rlist[l_i_max.to_integer_32] := a_area1
				update_class_fields -- Current might have been changed; synchronize
				l_elist[l_i_max.to_integer_32] := a_error1
				update_class_fields -- Current might have been changed; synchronize
				l_level[l_i_max.to_integer_32] := l_new_level
				update_class_fields -- Current might have been changed; synchronize
				l_alist[l_i_new.to_integer_32] := a_a2___3
				update_class_fields -- Current might have been changed; synchronize
				l_blist[l_i_new.to_integer_32] := a_b2
				update_class_fields -- Current might have been changed; synchronize
				l_rlist[l_i_new.to_integer_32] := a_area2
				update_class_fields -- Current might have been changed; synchronize
				l_elist[l_i_new.to_integer_32] := a_error2
				update_class_fields -- Current might have been changed; synchronize
				l_level[l_i_new.to_integer_32] := l_new_level
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.size := size + 1
			update_class_fields -- Current might have been changed; synchronize
			if l_new_level > maximum_level then
				Current.maximum_level := l_new_level
				update_class_fields -- Current might have been changed; synchronize
			end
			((create {CE_CLASS_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (c_pointer))).item.qpsrt
			update_class_fields -- Current might have been changed; synchronize
		end

	retrieve (a_a___5, a_b___0, a_r___3, a_e: CE_POINTER [REAL_64])
		require
			not a_a___5.is_void
			not a_b___0.is_void
			not a_r___3.is_void
			not a_e.is_void
		local
			l_i: NATURAL_32
			l_alist: CE_POINTER [REAL_64]
			l_blist: CE_POINTER [REAL_64]
			l_rlist: CE_POINTER [REAL_64]
			l_elist: CE_POINTER [REAL_64]
		do
			l_i := i
			l_alist := alist
			l_blist := blist
			l_rlist := rlist
			l_elist := elist
			a_a___5.item := l_alist[l_i.to_integer_32]
			update_class_fields -- Current might have been changed; synchronize
			a_b___0.item := l_blist[l_i.to_integer_32]
			update_class_fields -- Current might have been changed; synchronize
			a_r___3.item := l_rlist[l_i.to_integer_32]
			update_class_fields -- Current might have been changed; synchronize
			a_e.item := l_elist[l_i.to_integer_32]
			update_class_fields -- Current might have been changed; synchronize
		end

	sum_results: REAL_64
		local
			l_rlist: CE_POINTER [REAL_64]
			l_n: NATURAL_32
			l_k: NATURAL_32
			l_result_sum: REAL_64
		do
			l_rlist := rlist
			l_n := size
			l_result_sum := (0).to_double
			l_k := (0).to_natural_32
			from
			until
				not (l_k < l_n)
			loop
				l_result_sum := l_result_sum + (l_rlist[l_k.to_integer_32])
				l_k := l_k + 1
			end
			Result := l_result_sum
		end

	reset_nrmax
		do
			Current.nrmax := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Current.i := order[0]
			update_class_fields -- Current might have been changed; synchronize
		end

	increase_nrmax: INTEGER_32
		local
			l_k: INTEGER_32
			l_id: INTEGER_32
			l_jupbnd: INTEGER_32
			l_level: CE_POINTER [NATURAL_32]
			l_order: CE_POINTER [NATURAL_32]
			l_limit: NATURAL_32
			l_last: NATURAL_32
			l_i_max: NATURAL_32
			l_return: BOOLEAN
		do
			l_id := nrmax.to_integer_32
			l_level := level
			l_order := order
			l_limit := limit
			l_last := size - {NATURAL_32} 1
			if l_last > {NATURAL_32} 1 + l_limit // {NATURAL_32} 2 then
				l_jupbnd := ((l_limit + {NATURAL_32} 1) - l_last).to_integer_32
			else
				l_jupbnd := l_last.to_integer_32
			end
			l_k := l_id
			from
			until
				not (not (l_return) and then (l_k <= l_jupbnd))
			loop
				l_i_max := l_order[nrmax.to_integer_32]
				Current.i := l_i_max
				update_class_fields -- Current might have been changed; synchronize
				if l_level[l_i_max.to_integer_32] < maximum_level then
					Result := 1
					l_return := True
				end
				if not l_return then
					Current.nrmax := nrmax + 1
					update_class_fields -- Current might have been changed; synchronize
					l_k := l_k + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	large_interval: INTEGER_32
		local
			l_i: NATURAL_32
			l_level: CE_POINTER [NATURAL_32]
		do
			l_i := i
			l_level := level
			if l_level[l_i.to_integer_32] < maximum_level then
				Result := 1
			else
				Result := 0
			end
		end

	append_interval (a_a1___4, a_b1___0, a_area1, a_error1: REAL_64)
		local
			l_i_new: NATURAL_32
		do
			l_i_new := size
			alist[l_i_new.to_integer_32] := a_a1___4
			update_class_fields -- Current might have been changed; synchronize
			blist[l_i_new.to_integer_32] := a_b1___0
			update_class_fields -- Current might have been changed; synchronize
			rlist[l_i_new.to_integer_32] := a_area1
			update_class_fields -- Current might have been changed; synchronize
			elist[l_i_new.to_integer_32] := a_error1
			update_class_fields -- Current might have been changed; synchronize
			order[l_i_new.to_integer_32] := l_i_new
			update_class_fields -- Current might have been changed; synchronize
			level[l_i_new.to_integer_32] := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Current.size := size + 1
			update_class_fields -- Current might have been changed; synchronize
		end

	increase_nrmax___0: INTEGER_32
		local
			l_k: INTEGER_32
			l_id: INTEGER_32
			l_jupbnd: INTEGER_32
			l_level: CE_POINTER [NATURAL_32]
			l_order: CE_POINTER [NATURAL_32]
			l_limit: NATURAL_32
			l_last: NATURAL_32
			l_i_max: NATURAL_32
			l_return: BOOLEAN
		do
			l_id := nrmax.to_integer_32
			l_level := level
			l_order := order
			l_limit := limit
			l_last := size - {NATURAL_32} 1
			if l_last > {NATURAL_32} 1 + l_limit // {NATURAL_32} 2 then
				l_jupbnd := ((l_limit + {NATURAL_32} 1) - l_last).to_integer_32
			else
				l_jupbnd := l_last.to_integer_32
			end
			l_k := l_id
			from
			until
				not (not (l_return) and then (l_k <= l_jupbnd))
			loop
				l_i_max := l_order[nrmax.to_integer_32]
				Current.i := l_i_max
				update_class_fields -- Current might have been changed; synchronize
				if l_level[l_i_max.to_integer_32] < maximum_level then
					Result := 1
					l_return := True
				end
				if not l_return then
					Current.nrmax := nrmax + 1
					update_class_fields -- Current might have been changed; synchronize
					l_k := l_k + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	large_interval___0: INTEGER_32
		local
			l_i: NATURAL_32
			l_level: CE_POINTER [NATURAL_32]
		do
			l_i := i
			l_level := level
			if l_level[l_i.to_integer_32] < maximum_level then
				Result := 1
			else
				Result := 0
			end
		end

	increase_nrmax___1: INTEGER_32
		local
			l_k: INTEGER_32
			l_id: INTEGER_32
			l_jupbnd: INTEGER_32
			l_level: CE_POINTER [NATURAL_32]
			l_order: CE_POINTER [NATURAL_32]
			l_limit: NATURAL_32
			l_last: NATURAL_32
			l_i_max: NATURAL_32
			l_return: BOOLEAN
		do
			l_id := nrmax.to_integer_32
			l_level := level
			l_order := order
			l_limit := limit
			l_last := size - {NATURAL_32} 1
			if l_last > {NATURAL_32} 1 + l_limit // {NATURAL_32} 2 then
				l_jupbnd := ((l_limit + {NATURAL_32} 1) - l_last).to_integer_32
			else
				l_jupbnd := l_last.to_integer_32
			end
			l_k := l_id
			from
			until
				not (not (l_return) and then (l_k <= l_jupbnd))
			loop
				l_i_max := l_order[nrmax.to_integer_32]
				Current.i := l_i_max
				update_class_fields -- Current might have been changed; synchronize
				if l_level[l_i_max.to_integer_32] < maximum_level then
					Result := 1
					l_return := True
				end
				if not l_return then
					Current.nrmax := nrmax + 1
					update_class_fields -- Current might have been changed; synchronize
					l_k := l_k + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	large_interval___1: INTEGER_32
		local
			l_i: NATURAL_32
			l_level: CE_POINTER [NATURAL_32]
		do
			l_i := i
			l_level := level
			if l_level[l_i.to_integer_32] < maximum_level then
				Result := 1
			else
				Result := 0
			end
		end

	sort_results
		local
			l_i: NATURAL_32
			l_elist: CE_POINTER [REAL_64]
			l_order: CE_POINTER [NATURAL_32]
			l_nint: NATURAL_32
			l_i1: NATURAL_32
			l_e1: REAL_64
			l_i_max: NATURAL_32
			l_j: NATURAL_32
			l_i2: NATURAL_32
			l_e2: REAL_64
			l_return: BOOLEAN
		do
			l_elist := elist
			l_order := order
			l_nint := size
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_nint))
			loop
				l_i1 := l_order[l_i.to_integer_32]
				l_e1 := l_elist[l_i1.to_integer_32]
				l_i_max := l_i1
				l_j := l_i + {NATURAL_32} 1
				from
				until
					not (l_j < l_nint)
				loop
					l_i2 := l_order[l_j.to_integer_32]
					l_e2 := l_elist[l_i2.to_integer_32]
					if l_e2 >= l_e1 then
						l_i_max := l_i2
						l_e1 := l_e2
					end
					l_j := l_j + 1
				end
				if l_i_max /= l_i1 then
					l_order[l_i.to_integer_32] := l_order[l_i_max.to_integer_32]
					update_class_fields -- Current might have been changed; synchronize
					l_order[l_i_max.to_integer_32] := l_i1
					update_class_fields -- Current might have been changed; synchronize
				end
				l_i := l_i + 1
			end
			Current.i := l_order[0]
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			limit := a_other.limit
			size := a_other.size
			nrmax := a_other.nrmax
			i := a_other.i
			maximum_level := a_other.maximum_level
			alist := a_other.alist
			blist := a_other.blist
			rlist := a_other.rlist
			elist := a_other.elist
			order := a_other.order
			level := a_other.level
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				limit = a_other.limit and
				size = a_other.size and
				nrmax = a_other.nrmax and
				i = a_other.i and
				maximum_level = a_other.maximum_level and
				alist.is_equal (a_other.alist) and
				blist.is_equal (a_other.blist) and
				rlist.is_equal (a_other.rlist) and
				elist.is_equal (a_other.elist) and
				order.is_equal (a_other.order) and
				level.is_equal (a_other.level)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("limit"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("nrmax"),
					create {CE_STRUCTURE_FIELD}.make ("i"),
					create {CE_STRUCTURE_FIELD}.make ("maximum_level"),
					create {CE_STRUCTURE_FIELD}.make ("alist"),
					create {CE_STRUCTURE_FIELD}.make ("blist"),
					create {CE_STRUCTURE_FIELD}.make ("rlist"),
					create {CE_STRUCTURE_FIELD}.make ("elist"),
					create {CE_STRUCTURE_FIELD}.make ("order"),
					create {CE_STRUCTURE_FIELD}.make ("level")
				>>)
			init_structure_info
		end

end
