class
	PD_GSL_MATRIX_USHORT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_16_POINTER} data.make
			create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]} block.make
			Precursor
		end

feature {ANY} -- fields

	size1: NATURAL_32 assign set_size1

	size2: NATURAL_32 assign set_size2

	tda: NATURAL_32 assign set_tda

	data: CE_POINTER [NATURAL_16] assign set_data

	block: CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT] assign set_block

	owner: INTEGER_32 assign set_owner

feature {ANY} -- field setters

	set_size1 (a_size1: NATURAL_32)
		do
			size1 := a_size1
			update_memory_field ("size1")
		end

	set_size2 (a_size2: NATURAL_32)
		do
			size2 := a_size2
			update_memory_field ("size2")
		end

	set_tda (a_tda: NATURAL_32)
		do
			tda := a_tda
			update_memory_field ("tda")
		end

	set_data (a_data: CE_POINTER [NATURAL_16])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_block (a_block: CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT])
		do
			block := a_block
			update_memory_field ("block")
		end

	set_owner (a_owner: INTEGER_32)
		do
			owner := a_owner
			update_memory_field ("owner")
		end

feature {ANY} -- public routines

	gsl_matrix_ushort_get (a_i, a_j: NATURAL_32): NATURAL_16
		do
			Result := (data[(a_i * tda + a_j).to_integer_32])
		end

	gsl_matrix_ushort_set (a_i, a_j: NATURAL_32; a_x: NATURAL_16)
		do
			data[(a_i * tda + a_j).to_integer_32] := a_x
			update_class_fields -- Current might have been changed; synchronize
		end

	gsl_matrix_ushort_ptr (a_i, a_j: NATURAL_32): CE_POINTER [NATURAL_16]
		do
			Result := (data + (a_i * tda + a_j).to_integer_32)
		end

	gsl_matrix_ushort_const_ptr (a_i, a_j: NATURAL_32): CE_POINTER [NATURAL_16]
		do
			Result := (data + (a_i * tda + a_j).to_integer_32)
		end

	gsl_matrix_ushort_isnull: INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return: BOOLEAN
		do
			l_size1 := size1
			l_size2 := size2
			l_tda := tda
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not (l_return) and then (l_k < {NATURAL_32} 1))
					loop
						if (data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 /= 0.0 then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_k := l_k + 1
						end
					end
					if not l_return then
						l_j := l_j + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 1
			end
		end

	gsl_matrix_ushort_ispos: INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return: BOOLEAN
		do
			l_size1 := size1
			l_size2 := size2
			l_tda := tda
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not (l_return) and then (l_k < {NATURAL_32} 1))
					loop
						if (data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 <= 0.0 then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_k := l_k + 1
						end
					end
					if not l_return then
						l_j := l_j + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 1
			end
		end

	gsl_matrix_ushort_isneg: INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return: BOOLEAN
		do
			l_size1 := size1
			l_size2 := size2
			l_tda := tda
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not (l_return) and then (l_k < {NATURAL_32} 1))
					loop
						if (data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 >= 0.0 then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_k := l_k + 1
						end
					end
					if not l_return then
						l_j := l_j + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 1
			end
		end

	gsl_matrix_ushort_isnonneg: INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return: BOOLEAN
		do
			l_size1 := size1
			l_size2 := size2
			l_tda := tda
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not (l_return) and then (l_k < {NATURAL_32} 1))
					loop
						if (data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 < 0.0 then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_k := l_k + 1
						end
					end
					if not l_return then
						l_j := l_j + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 1
			end
		end

	gsl_matrix_ushort_max: NATURAL_16
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_max: NATURAL_16
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_x: NATURAL_16
			l_return: BOOLEAN
		do
			l_M := size1
			l_N := size2
			l_tda := tda
			l_max := data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_M))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					l_x := data[(l_i * l_tda + l_j).to_integer_32]
					if l_x.to_integer_32 > l_max.to_integer_32 then
						l_max := l_x
					end
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			Result := l_max
		end

	gsl_matrix_ushort_min: NATURAL_16
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_min: NATURAL_16
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_x: NATURAL_16
			l_return: BOOLEAN
		do
			l_M := size1
			l_N := size2
			l_tda := tda
			l_min := data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_M))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					l_x := data[(l_i * l_tda + l_j).to_integer_32]
					if l_x.to_integer_32 < l_min.to_integer_32 then
						l_min := l_x
					end
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			Result := l_min
		end

	gsl_matrix_ushort_minmax (a_min_out, a_max_out: CE_POINTER [NATURAL_16])
		require
			not a_min_out.is_void
			not a_max_out.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_max: NATURAL_16
			l_min: NATURAL_16
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_x: NATURAL_16
			l_return: BOOLEAN
		do
			l_M := size1
			l_N := size2
			l_tda := tda
			l_max := data[({NATURAL_32} 0).to_integer_32]
			l_min := data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_M))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					l_x := data[(l_i * l_tda + l_j).to_integer_32]
					if l_x.to_integer_32 < l_min.to_integer_32 then
						l_min := l_x
					end
					if l_x.to_integer_32 > l_max.to_integer_32 then
						l_max := l_x
					end
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			a_min_out.item := l_min
			update_class_fields -- Current might have been changed; synchronize
			a_max_out.item := l_max
			update_class_fields -- Current might have been changed; synchronize
		end

	gsl_matrix_ushort_max_index (a_imax_out, a_jmax_out: CE_POINTER [NATURAL_32])
		require
			not a_imax_out.is_void
			not a_jmax_out.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_max: NATURAL_16
			l_imax: NATURAL_32
			l_jmax: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_x: NATURAL_16
			l_return: BOOLEAN
		do
			l_M := size1
			l_N := size2
			l_tda := tda
			l_max := data[({NATURAL_32} 0).to_integer_32]
			l_imax := (0).to_natural_32
			l_jmax := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_M))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					l_x := data[(l_i * l_tda + l_j).to_integer_32]
					if l_x.to_integer_32 > l_max.to_integer_32 then
						l_max := l_x
						l_imax := l_i
						l_jmax := l_j
					end
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			a_imax_out.item := l_imax
			update_class_fields -- Current might have been changed; synchronize
			a_jmax_out.item := l_jmax
			update_class_fields -- Current might have been changed; synchronize
		end

	gsl_matrix_ushort_min_index (a_imin_out, a_jmin_out: CE_POINTER [NATURAL_32])
		require
			not a_imin_out.is_void
			not a_jmin_out.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_min: NATURAL_16
			l_imin: NATURAL_32
			l_jmin: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_x: NATURAL_16
			l_return: BOOLEAN
		do
			l_M := size1
			l_N := size2
			l_tda := tda
			l_min := data[({NATURAL_32} 0).to_integer_32]
			l_imin := (0).to_natural_32
			l_jmin := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_M))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					l_x := data[(l_i * l_tda + l_j).to_integer_32]
					if l_x.to_integer_32 < l_min.to_integer_32 then
						l_min := l_x
						l_imin := l_i
						l_jmin := l_j
					end
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			a_imin_out.item := l_imin
			update_class_fields -- Current might have been changed; synchronize
			a_jmin_out.item := l_jmin
			update_class_fields -- Current might have been changed; synchronize
		end

	gsl_matrix_ushort_minmax_index (a_imin_out, a_jmin_out, a_imax_out, a_jmax_out: CE_POINTER [NATURAL_32])
		require
			not a_imin_out.is_void
			not a_jmin_out.is_void
			not a_imax_out.is_void
			not a_jmax_out.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_imin: NATURAL_32
			l_jmin: NATURAL_32
			l_imax: NATURAL_32
			l_jmax: NATURAL_32
			l_max: NATURAL_16
			l_min: NATURAL_16
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_x: NATURAL_16
			l_return: BOOLEAN
		do
			l_M := size1
			l_N := size2
			l_tda := tda
			l_imin := (0).to_natural_32
			l_jmin := (0).to_natural_32
			l_imax := (0).to_natural_32
			l_jmax := (0).to_natural_32
			l_max := data[({NATURAL_32} 0).to_integer_32]
			l_min := data[({NATURAL_32} 0).to_integer_32]
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_M))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					l_x := data[(l_i * l_tda + l_j).to_integer_32]
					if l_x.to_integer_32 < l_min.to_integer_32 then
						l_min := l_x
						l_imin := l_i
						l_jmin := l_j
					end
					if l_x.to_integer_32 > l_max.to_integer_32 then
						l_max := l_x
						l_imax := l_i
						l_jmax := l_j
					end
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			a_imin_out.item := l_imin
			update_class_fields -- Current might have been changed; synchronize
			a_jmin_out.item := l_jmin
			update_class_fields -- Current might have been changed; synchronize
			a_imax_out.item := l_imax
			update_class_fields -- Current might have been changed; synchronize
			a_jmax_out.item := l_jmax
			update_class_fields -- Current might have been changed; synchronize
		end

	gsl_matrix_ushort_row (a_i: NATURAL_32): PD_GSL_VECTOR_USHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_i >= size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("rowcol_source.c"), 27, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := data + (a_i * tda).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.size := size2
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_column (a_j: NATURAL_32): PD_GSL_VECTOR_USHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_j >= size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("rowcol_source.c"), 51, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := data + a_j.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.size := size1
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := tda
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_diagonal: PD_GSL_VECTOR_USHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_VIEW
			l_v: PD_GSL_VECTOR_USHORT
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_v.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_v.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_v.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_v.data := data
			update_class_fields -- Current might have been changed; synchronize
			if size1 < size2 then
				l_v.size := size1
				update_class_fields -- Current might have been changed; synchronize
			else
				l_v.size := size2
				update_class_fields -- Current might have been changed; synchronize
			end
			l_v.stride := tda + {NATURAL_32} 1
			update_class_fields -- Current might have been changed; synchronize
			l_v.block := block
			update_class_fields -- Current might have been changed; synchronize
			l_v.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector := l_v.twin
			update_class_fields -- Current might have been changed; synchronize
			Result := l_view.twin
		end

	gsl_matrix_ushort_subdiagonal (a_k: NATURAL_32): PD_GSL_VECTOR_USHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_k >= size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("subdiagonal index is out of range"), ce_string ("rowcol_source.c"), 92, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := data + (a_k * tda).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				if size1 - a_k < size2 then
					l_v.size := size1 - a_k
					update_class_fields -- Current might have been changed; synchronize
				else
					l_v.size := size2
					update_class_fields -- Current might have been changed; synchronize
				end
				l_v.stride := tda + {NATURAL_32} 1
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_superdiagonal (a_k: NATURAL_32): PD_GSL_VECTOR_USHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_k >= size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("rowcol_source.c"), 118, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := data + a_k.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				if size1 < size2 - a_k then
					l_v.size := size1
					update_class_fields -- Current might have been changed; synchronize
				else
					l_v.size := size2 - a_k
					update_class_fields -- Current might have been changed; synchronize
				end
				l_v.stride := tda + {NATURAL_32} 1
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_subrow (a_i, a_offset, a_n: NATURAL_32): PD_GSL_VECTOR_USHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_i >= size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("rowcol_source.c"), 142, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("rowcol_source.c"), 147, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_offset + a_n > size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("dimension n overflows matrix"), ce_string ("rowcol_source.c"), 151, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := data + (a_i * tda + a_offset).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.size := a_n
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_subcolumn (a_j, a_offset, a_n: NATURAL_32): PD_GSL_VECTOR_USHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_j >= size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("rowcol_source.c"), 175, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("rowcol_source.c"), 180, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_offset + a_n > size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("dimension n overflows matrix"), ce_string ("rowcol_source.c"), 184, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := data + (a_offset * tda + a_j).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.size := a_n
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := tda
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_const_row (a_i: NATURAL_32): PD_GSL_VECTOR_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_CONST_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_i >= size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("rowcol_source.c"), 27, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := (data + (a_i * tda).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				l_v.size := size2
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_const_column (a_j: NATURAL_32): PD_GSL_VECTOR_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_CONST_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_j >= size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("rowcol_source.c"), 51, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := (data + a_j.to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				l_v.size := size1
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := tda
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_const_diagonal: PD_GSL_VECTOR_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_CONST_VIEW
			l_v: PD_GSL_VECTOR_USHORT
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_v.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_v.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_v.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_v.data := data
			update_class_fields -- Current might have been changed; synchronize
			if size1 < size2 then
				l_v.size := size1
				update_class_fields -- Current might have been changed; synchronize
			else
				l_v.size := size2
				update_class_fields -- Current might have been changed; synchronize
			end
			l_v.stride := (tda + {NATURAL_32} 1)
			update_class_fields -- Current might have been changed; synchronize
			l_v.block := block
			update_class_fields -- Current might have been changed; synchronize
			l_v.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector := l_v.twin
			update_class_fields -- Current might have been changed; synchronize
			Result := l_view.twin
		end

	gsl_matrix_ushort_const_subdiagonal (a_k: NATURAL_32): PD_GSL_VECTOR_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_CONST_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_k >= size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("subdiagonal index is out of range"), ce_string ("rowcol_source.c"), 92, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := (data + (a_k * tda).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				if size1 - a_k < size2 then
					l_v.size := (size1 - a_k)
					update_class_fields -- Current might have been changed; synchronize
				else
					l_v.size := size2
					update_class_fields -- Current might have been changed; synchronize
				end
				l_v.stride := (tda + {NATURAL_32} 1)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_const_superdiagonal (a_k: NATURAL_32): PD_GSL_VECTOR_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_CONST_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_k >= size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("rowcol_source.c"), 118, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := (data + a_k.to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				if size1 < size2 - a_k then
					l_v.size := size1
					update_class_fields -- Current might have been changed; synchronize
				else
					l_v.size := (size2 - a_k)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_v.stride := (tda + {NATURAL_32} 1)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_const_subrow (a_i, a_offset, a_n: NATURAL_32): PD_GSL_VECTOR_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_CONST_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_i >= size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("rowcol_source.c"), 142, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("rowcol_source.c"), 147, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_offset + a_n > size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("dimension n overflows matrix"), ce_string ("rowcol_source.c"), 151, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := (data + (a_i * tda + a_offset).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				l_v.size := a_n
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_const_subcolumn (a_j, a_offset, a_n: NATURAL_32): PD_GSL_VECTOR_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_CONST_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_j >= size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("rowcol_source.c"), 175, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("rowcol_source.c"), 180, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_offset + a_n > size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("dimension n overflows matrix"), ce_string ("rowcol_source.c"), 184, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := (data + (a_offset * tda + a_j).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				l_v.size := a_n
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := tda
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_swap_rows (a_i, a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row1: CE_POINTER [NATURAL_16]
			l_row2: CE_POINTER [NATURAL_16]
			l_k: NATURAL_32
			l_tmp: NATURAL_16
			l_return, l_break: BOOLEAN
		do
			l_size1 := size1
			l_size2 := size2
			if a_i >= l_size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("first row index is out of range"), ce_string ("swap_source.c"), 29, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_j >= l_size1) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("second row index is out of range"), ce_string ("swap_source.c"), 34, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				if a_i /= a_j then
					l_row1 := data + (a_i * tda).to_integer_32
					l_row2 := data + (a_j * tda).to_integer_32
					l_k := (0).to_natural_32
					from
					until
						not (l_k < l_size2)
					loop
						l_tmp := l_row1[l_k.to_integer_32]
						l_row1[l_k.to_integer_32] := l_row2[l_k.to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						l_row2[l_k.to_integer_32] := l_tmp
						update_class_fields -- Current might have been changed; synchronize
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_ushort_swap_columns (a_i, a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_col1: CE_POINTER [NATURAL_16]
			l_col2: CE_POINTER [NATURAL_16]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_n: NATURAL_32
			l_tmp: NATURAL_16
			l_return, l_break: BOOLEAN
		do
			l_size1 := size1
			l_size2 := size2
			if a_i >= l_size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("first column index is out of range"), ce_string ("swap_source.c"), 64, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_j >= l_size2) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("second column index is out of range"), ce_string ("swap_source.c"), 69, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				if a_i /= a_j then
					l_col1 := data + a_i.to_integer_32
					l_col2 := data + a_j.to_integer_32
					l_p := (0).to_natural_32
					from
					until
						not (not (l_return) and then (l_p < l_size1))
					loop
						l_n := l_p * tda
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_tmp := l_col1[(l_n + l_k).to_integer_32]
							l_col1[(l_n + l_k).to_integer_32] := l_col2[(l_n + l_k).to_integer_32]
							update_class_fields -- Current might have been changed; synchronize
							l_col2[(l_n + l_k).to_integer_32] := l_tmp
							update_class_fields -- Current might have been changed; synchronize
							l_k := l_k + 1
						end
						l_p := l_p + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_ushort_swap_rowcol (a_i, a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row: CE_POINTER [NATURAL_16]
			l_col: CE_POINTER [NATURAL_16]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_r___3: NATURAL_32
			l_c___1: NATURAL_32
			l_tmp: NATURAL_16
			l_return, l_break: BOOLEAN
		do
			l_size1 := size1
			l_size2 := size2
			if l_size1 /= l_size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix must be square to swap row and column"), ce_string ("swap_source.c"), 106, 20)
					update_class_fields -- Current might have been changed; synchronize
					Result := 20
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_i >= l_size1) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("swap_source.c"), 111, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_j >= l_size2) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("swap_source.c"), 116, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_row := data + (a_i * tda).to_integer_32
				l_col := data + a_j.to_integer_32
				l_p := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_p < l_size1))
				loop
					l_r___3 := l_p
					l_c___1 := l_p * tda
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_tmp := l_col[(l_c___1 + l_k).to_integer_32]
						l_col[(l_c___1 + l_k).to_integer_32] := l_row[(l_r___3 + l_k).to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						l_row[(l_r___3 + l_k).to_integer_32] := l_tmp
						update_class_fields -- Current might have been changed; synchronize
						l_k := l_k + 1
					end
					l_p := l_p + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ushort_transpose: INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_tmp: NATURAL_16
			l_return, l_break: BOOLEAN
		do
			l_size1 := size1
			l_size2 := size2
			if l_size1 /= l_size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix must be square to take transpose"), ce_string ("swap_source.c"), 154, 20)
					update_class_fields -- Current might have been changed; synchronize
					Result := 20
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_size1))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (not (l_return) and then (l_j < l_size2))
					loop
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 1)
						loop
							l_e1 := (l_i * tda + l_j) + l_k
							l_e2 := (l_j * tda + l_i) + l_k
							l_tmp := data[l_e1.to_integer_32]
							data[l_e1.to_integer_32] := data[l_e2.to_integer_32]
							update_class_fields -- Current might have been changed; synchronize
							data[l_e2.to_integer_32] := l_tmp
							update_class_fields -- Current might have been changed; synchronize
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ushort_transpose_memcpy (a_src: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		require
			not a_src.is_void
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := size1
					l_dest_size2 := size2
					if l_dest_size2 = l_src_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_dest_size1 = l_src_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("dimensions of dest matrix must be transpose of src matrix"), ce_string ("swap_source.c"), 192, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if done
					if not l_return then
						l_i := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_i < l_dest_size1))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (not (l_return) and then (l_j < l_dest_size2))
							loop
								l_k := (0).to_natural_32
								from
								until
									not (l_k < {NATURAL_32} 1)
								loop
									l_e1 := (l_i * tda + l_j) + l_k
									l_e2 := (l_j * a_src.item.tda + l_i) + l_k
									data[l_e1.to_integer_32] := a_src.item.data[l_e2.to_integer_32]
									update_class_fields -- Current might have been changed; synchronize
									l_k := l_k + 1
								end
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_matrix_ushort_memcpy (a_src: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		require
			not a_src.is_void
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := size1
					l_dest_size2 := size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 31, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if done
					if not l_return then
						l_src_tda := a_src.item.tda
						l_dest_tda := tda
						l_i := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_i < l_src_size1))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_src_size2)
							loop
								data[(l_dest_tda * l_i + l_j).to_integer_32] := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
								update_class_fields -- Current might have been changed; synchronize
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_matrix_ushort_swap (a_src: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		require
			not a_src.is_void
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: NATURAL_16
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := size1
					l_dest_size2 := size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 63, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if done
					if not l_return then
						l_src_tda := a_src.item.tda
						l_dest_tda := tda
						l_i := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_i < l_src_size1))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_src_size2)
							loop
								l_tmp := a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32]
								a_src.item.data[(l_src_tda * l_i + l_j).to_integer_32] := data[(l_dest_tda * l_i + l_j).to_integer_32]
								update_class_fields -- Current might have been changed; synchronize
								data[(l_dest_tda * l_i + l_j).to_integer_32] := l_tmp
								update_class_fields -- Current might have been changed; synchronize
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_matrix_ushort_add (a_b___0: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		require
			not a_b___0.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := size1
					l_N := size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_source.c"), 28, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								data[(l_i * l_tda_a + l_j).to_integer_32] := ((data[(l_i * l_tda_a + l_j).to_integer_32]).to_integer_32 + (a_b___0.item.data[(l_i * l_tda_b + l_j).to_integer_32]).to_integer_32).to_natural_16
								update_class_fields -- Current might have been changed; synchronize
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						l_return := True
				when 7 then -- if done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_matrix_ushort_sub (a_b___0: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		require
			not a_b___0.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := size1
					l_N := size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_source.c"), 57, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								data[(l_i * l_tda_a + l_j).to_integer_32] := ((data[(l_i * l_tda_a + l_j).to_integer_32]).to_integer_32 - (a_b___0.item.data[(l_i * l_tda_b + l_j).to_integer_32]).to_integer_32).to_natural_16
								update_class_fields -- Current might have been changed; synchronize
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						l_return := True
				when 7 then -- if done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_matrix_ushort_mul_elements (a_b___0: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		require
			not a_b___0.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := size1
					l_N := size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_source.c"), 86, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								data[(l_i * l_tda_a + l_j).to_integer_32] := ((data[(l_i * l_tda_a + l_j).to_integer_32]).to_integer_32 * (a_b___0.item.data[(l_i * l_tda_b + l_j).to_integer_32]).to_integer_32).to_natural_16
								update_class_fields -- Current might have been changed; synchronize
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						l_return := True
				when 7 then -- if done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_matrix_ushort_div_elements (a_b___0: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		require
			not a_b___0.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := size1
					l_N := size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_source.c"), 115, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								data[(l_i * l_tda_a + l_j).to_integer_32] := ((data[(l_i * l_tda_a + l_j).to_integer_32]).to_integer_32 // (a_b___0.item.data[(l_i * l_tda_b + l_j).to_integer_32]).to_integer_32).to_natural_16
								update_class_fields -- Current might have been changed; synchronize
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						l_return := True
				when 7 then -- if done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_matrix_ushort_scale (a_x: REAL_64): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_return: BOOLEAN
		do
			l_M := size1
			l_N := size2
			l_tda := tda
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_M))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					data[(l_i * l_tda + l_j).to_integer_32] := ((data[(l_i * l_tda + l_j).to_integer_32]).to_real_64 * a_x).truncated_to_integer_64.to_natural_16
					update_class_fields -- Current might have been changed; synchronize
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_matrix_ushort_add_constant (a_x: REAL_64): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_return: BOOLEAN
		do
			l_M := size1
			l_N := size2
			l_tda := tda
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_M))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					data[(l_i * l_tda + l_j).to_integer_32] := ((data[(l_i * l_tda + l_j).to_integer_32]).to_real_64 + a_x).truncated_to_integer_64.to_natural_16
					update_class_fields -- Current might have been changed; synchronize
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_matrix_ushort_add_diagonal (a_x: REAL_64): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_loop_lim: NATURAL_32
			l_tmp: NATURAL_32
			l_i: NATURAL_32
		do
			l_M := size1
			l_N := size2
			l_tda := tda
			if l_M < l_N then
				l_tmp := l_M
			else
				l_tmp := l_N
			end
			l_loop_lim := l_tmp
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_loop_lim)
			loop
				data[(l_i * l_tda + l_i).to_integer_32] := ((data[(l_i * l_tda + l_i).to_integer_32]).to_real_64 + a_x).truncated_to_integer_64.to_natural_16
				update_class_fields -- Current might have been changed; synchronize
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_matrix_ushort_set_row (a_i: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_16]
			l_row_data: CE_POINTER [NATURAL_16]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := size1
			l_N := size2
			l_tda := tda
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 99, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_N) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 105, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_row_data := data + (a_i * l_tda).to_integer_32
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_row_data[(l_j + l_k).to_integer_32] := l_v_data[(l_stride * l_j + l_k).to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ushort_set_col (a_j: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_16]
			l_column_data: CE_POINTER [NATURAL_16]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := size1
			l_N := size2
			l_tda := tda
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 140, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_M) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 146, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_column_data := data + a_j.to_integer_32
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_column_data[(l_i * l_tda + l_k).to_integer_32] := l_v_data[(l_stride * l_i + l_k).to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_ushort_alloc_row_from_matrix (a_i: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_USHORT]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_USHORT]
			l_M: NATURAL_32
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			l_M := size1
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 181, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_USHORT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_tmp := malloc ((create {PD_GSL_VECTOR_USHORT}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_USHORT]}.make_cast (l_tmp)
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 189, 8)
						update_class_fields -- Current might have been changed; synchronize
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_USHORT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := data + (a_i * tda).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.size := size2
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.stride := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_v
			end
		end

	gsl_vector_ushort_alloc_col_from_matrix (a_j: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_USHORT]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_USHORT]
			l_N: NATURAL_32
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			l_N := size2
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 210, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_USHORT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_tmp := malloc ((create {PD_GSL_VECTOR_USHORT}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_USHORT]}.make_cast (l_tmp)
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 218, 8)
						update_class_fields -- Current might have been changed; synchronize
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_USHORT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := data + a_j.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.size := size1
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.stride := tda
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_v
			end
		end

	gsl_matrix_ushort_fread (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_break: BOOLEAN
		do
			l_status := 0
			l_size1 := size1
			l_size2 := size2
			l_tda := tda
			if l_tda = l_size2 then
				l_status := (create {P_FWRITE_SOURCE_STATIC}).gsl_block_ushort_raw_fread (a_stream, data, l_size1 * l_size2, (1).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_break) and then (l_i < l_size1))
				loop
					l_break := False
					l_status := (create {P_FWRITE_SOURCE_STATIC}).gsl_block_ushort_raw_fread (a_stream, data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_status.to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_i := l_i + 1
					end
				end
				l_break := False
			end
			Result := l_status
		end

	gsl_matrix_ushort_fwrite (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_break: BOOLEAN
		do
			l_status := 0
			l_size1 := size1
			l_size2 := size2
			l_tda := tda
			if l_tda = l_size2 then
				l_status := (create {P_FWRITE_SOURCE_STATIC}).gsl_block_ushort_raw_fwrite (a_stream, data, l_size1 * l_size2, (1).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_break) and then (l_i < l_size1))
				loop
					l_break := False
					l_status := (create {P_FWRITE_SOURCE_STATIC}).gsl_block_ushort_raw_fwrite (a_stream, (data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_status.to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_i := l_i + 1
					end
				end
				l_break := False
			end
			Result := l_status
		end

	gsl_matrix_ushort_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_break: BOOLEAN
		do
			l_status := 0
			l_size1 := size1
			l_size2 := size2
			l_tda := tda
			if l_tda = l_size2 then
				l_status := (create {P_FPRINTF_SOURCE_STATIC}).gsl_block_ushort_raw_fprintf (a_stream, data, l_size1 * l_size2, (1).to_natural_32, a_format)
				update_class_fields -- Current might have been changed; synchronize
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_break) and then (l_i < l_size1))
				loop
					l_break := False
					l_status := (create {P_FPRINTF_SOURCE_STATIC}).gsl_block_ushort_raw_fprintf (a_stream, (data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32, a_format)
					update_class_fields -- Current might have been changed; synchronize
					if l_status.to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_i := l_i + 1
					end
				end
				l_break := False
			end
			Result := l_status
		end

	gsl_matrix_ushort_fscanf (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_break: BOOLEAN
		do
			l_status := 0
			l_size1 := size1
			l_size2 := size2
			l_tda := tda
			if l_tda = l_size2 then
				l_status := (create {P_FPRINTF_SOURCE_STATIC}).gsl_block_ushort_raw_fscanf (a_stream, data, l_size1 * l_size2, (1).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_break) and then (l_i < l_size1))
				loop
					l_break := False
					l_status := (create {P_FPRINTF_SOURCE_STATIC}).gsl_block_ushort_raw_fscanf (a_stream, data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_status.to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_i := l_i + 1
					end
				end
				l_break := False
			end
			Result := l_status
		end

	gsl_matrix_ushort_submatrix (a_i, a_j, a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_USHORT_VIEW
		local
			l_view: PD_GSL_MATRIX_USHORT_VIEW
			l_s: PD_GSL_MATRIX_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.size2 := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.tda := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_i >= size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_j >= size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_i + a_n1 > size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_j + a_n2 > size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s.size1 := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.size2 := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.tda := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_s.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_s.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_s.data := data + (a_i * tda + a_j).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.size1 := a_n1
				update_class_fields -- Current might have been changed; synchronize
				l_s.size2 := a_n2
				update_class_fields -- Current might have been changed; synchronize
				l_s.tda := tda
				update_class_fields -- Current might have been changed; synchronize
				l_s.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_s.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.matrix := l_s.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_const_submatrix (a_i, a_j, a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_USHORT_CONST_VIEW
			l_s: PD_GSL_MATRIX_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.size2 := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.tda := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_i >= size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_j >= size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_i + a_n1 > size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_j + a_n2 > size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s.size1 := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.size2 := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.tda := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_s.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_s.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_s.data := (data + (a_i * tda + a_j).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				l_s.size1 := a_n1
				update_class_fields -- Current might have been changed; synchronize
				l_s.size2 := a_n2
				update_class_fields -- Current might have been changed; synchronize
				l_s.tda := tda
				update_class_fields -- Current might have been changed; synchronize
				l_s.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_s.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.matrix := l_s.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_alloc_from_matrix (a_k1, a_k2, a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_USHORT]
		local
			l_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 146, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_USHORT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 151, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_USHORT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_k1 + a_n1 > size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("submatrix dimension 1 exceeds size of original"), ce_string ("init_source.c"), 156, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_USHORT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_k2 + a_n2 > size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("submatrix dimension 2 exceeds size of original"), ce_string ("init_source.c"), 161, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_USHORT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_tmp := malloc ((create {PD_GSL_MATRIX_USHORT}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX_USHORT]}.make_cast (l_tmp)
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 169, 8)
						update_class_fields -- Current might have been changed; synchronize
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_USHORT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := (data + (a_k1 * tda).to_integer_32) + a_k2.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.item.size1 := a_n1
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.item.size2 := a_n2
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.item.tda := tda
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.item.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.item.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := l_m___4
			end
		end

	gsl_matrix_ushort_set_identity
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_data: CE_POINTER [NATURAL_16]
			l_p: NATURAL_32
			l_q___3: NATURAL_32
			l_tda: NATURAL_32
			l_zero: NATURAL_16
			l_one: NATURAL_16
			l_return: BOOLEAN
		do
			l_data := data
			l_p := size1
			l_q___3 := size2
			l_tda := tda
			l_zero := (0).to_natural_16
			l_one := (1).to_natural_16
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_p))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_q___3)
				loop
					if l_i = l_j then
						l_data[(l_i * l_tda + l_j).to_integer_32] := l_one
						update_class_fields -- Current might have been changed; synchronize
					else
						l_data[(l_i * l_tda + l_j).to_integer_32] := l_zero
						update_class_fields -- Current might have been changed; synchronize
					end
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
		end

	gsl_matrix_ushort_set_zero
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_data: CE_POINTER [NATURAL_16]
			l_p: NATURAL_32
			l_q___3: NATURAL_32
			l_tda: NATURAL_32
			l_zero: NATURAL_16
			l_return: BOOLEAN
		do
			l_data := data
			l_p := size1
			l_q___3 := size2
			l_tda := tda
			l_zero := (0).to_natural_16
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_p))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_q___3)
				loop
					l_data[(l_i * l_tda + l_j).to_integer_32] := l_zero
					update_class_fields -- Current might have been changed; synchronize
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
		end

	gsl_matrix_ushort_set_all (a_x: NATURAL_16)
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_data: CE_POINTER [NATURAL_16]
			l_p: NATURAL_32
			l_q___3: NATURAL_32
			l_tda: NATURAL_32
			l_return: BOOLEAN
		do
			l_data := data
			l_p := size1
			l_q___3 := size2
			l_tda := tda
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_p))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_q___3)
				loop
					l_data[(l_i * l_tda + l_j).to_integer_32] := a_x
					update_class_fields -- Current might have been changed; synchronize
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size1 := a_other.size1
			size2 := a_other.size2
			tda := a_other.tda
			data := a_other.data
			block := a_other.block
			owner := a_other.owner
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size1 = a_other.size1 and
				size2 = a_other.size2 and
				tda = a_other.tda and
				data.is_equal (a_other.data) and
				block.is_equal (a_other.block) and
				owner = a_other.owner
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size1"),
					create {CE_STRUCTURE_FIELD}.make ("size2"),
					create {CE_STRUCTURE_FIELD}.make ("tda"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("block"),
					create {CE_STRUCTURE_FIELD}.make ("owner")
				>>)
			init_structure_info
		end

end
