class
	PD_GSL_MONTE_FUNCTION_STRUCT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create f.make
			create {CE_VOID_POINTER} params.make
		end

feature {ANY} -- fields

	f: CE_ROUTINE assign set_f

	dim: NATURAL_32 assign set_dim

	params: CE_POINTER [ANY] assign set_params

feature {ANY} -- field setters

	set_f (a_f: CE_ROUTINE)
		do
			f := a_f
			update_memory_field ("f")
		end

	set_dim (a_dim: NATURAL_32)
		do
			dim := a_dim
			update_memory_field ("dim")
		end

	set_params (a_params: CE_POINTER [ANY])
		do
			params := a_params
			update_memory_field ("params")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			f := a_other.f
			dim := a_other.dim
			params := a_other.params
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				f.is_equal (a_other.f) and
				dim = a_other.dim and
				params.is_equal (a_other.params)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("f"),
					create {CE_STRUCTURE_FIELD}.make ("dim"),
					create {CE_STRUCTURE_FIELD}.make ("params")
				>>)
			init_structure_info
		end

end
