class
	PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT

inherit
	PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_MATH_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create f.make
			create df.make
			create fdf.make
			create {CE_VOID_POINTER} params.make
			Precursor
		end

feature {ANY} -- fields

	f: CE_ROUTINE assign set_f

	df: CE_ROUTINE assign set_df

	fdf: CE_ROUTINE assign set_fdf

	n: NATURAL_32 assign set_n

	params: CE_POINTER [ANY] assign set_params

feature {ANY} -- field setters

	set_f (a_f: CE_ROUTINE)
		do
			f := a_f
			update_memory_field ("f")
		end

	set_df (a_df: CE_ROUTINE)
		do
			df := a_df
			update_memory_field ("df")
		end

	set_fdf (a_fdf: CE_ROUTINE)
		do
			fdf := a_fdf
			update_memory_field ("fdf")
		end

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_params (a_params: CE_POINTER [ANY])
		do
			params := a_params
			update_memory_field ("params")
		end

feature {ANY} -- public routines

	intermediate_point (a_x, a_p: CE_POINTER [PD_GSL_VECTOR]; a_lambda, a_pg, a_stepa, a_stepc, a_fa, a_fc: REAL_64; a_x1___0, a_dx, a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step, a_f: CE_POINTER [REAL_64])
		require
			not a_p.is_void
			not a_x1___0.is_void
			not a_dx.is_void
			not a_step.is_void
			not a_f.is_void
		local
			l_stepc: REAL_64
			l_fc: REAL_64
			l_stepb: REAL_64
			l_fb: REAL_64
			l_u: REAL_64
			l_tmp: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_stepc := a_stepc
					l_fc := a_fc
				when 1 then -- trial:
					l_tmp := fabs ((a_pg * a_lambda) * l_stepc)
					update_class_fields -- Current might have been changed; synchronize
					l_u := l_tmp
					l_stepb := ((0.5 * l_stepc) * l_u) / ((l_fc - a_fa) + l_u);
					(create {P_DIRECTIONAL_MINIMIZE_STATIC}).take_step (a_x, a_p, l_stepb, a_lambda, a_x1___0, a_dx)
					update_class_fields -- Current might have been changed; synchronize
					l_fb := f.real_64_item ([a_x1___0, params])
					update_class_fields -- Current might have been changed; synchronize
					if l_fb >= a_fa then
						if l_stepb > 0.0 then
							l_fc := l_fb
							l_stepc := l_stepb
							l_pos := -1 + 1 -- goto trial
						end
					end
				when 2 then
					a_step.item := l_stepb
					update_class_fields -- Current might have been changed; synchronize
					a_f.item := l_fb
					update_class_fields -- Current might have been changed; synchronize
					df.call ([a_x1___0, params, a_gradient])
					update_class_fields -- Current might have been changed; synchronize
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vector_bfgs_set (a_vstate: CE_POINTER [ANY]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step_size, a_tol: REAL_64): INTEGER_32
		require
			not a_gradient.is_void
		local
			l_state: CE_POINTER [PD_VECTOR_BFGS_STATE_T]
			l_gnorm: REAL_64
			l_tmp: REAL_64
		do
			l_state := create {CE_CLASS_POINTER [PD_VECTOR_BFGS_STATE_T]}.make_cast (a_vstate)
			l_state.item.iter := 0
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.step := a_step_size
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.max_step := a_step_size
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.tol := a_tol
			update_class_fields -- Current might have been changed; synchronize
			fdf.call ([a_x, params, a_f, a_gradient])
			update_class_fields; -- Current might have been changed; synchronize
			(l_state.item.x0).item.gsl_vector_memcpy (a_x).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(l_state.item.p).item.gsl_vector_memcpy (a_gradient).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(l_state.item.g0).item.gsl_vector_memcpy (a_gradient).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := a_gradient.item.gsl_blas_dnrm2
			update_class_fields -- Current might have been changed; synchronize
			l_gnorm := l_tmp
			l_state.item.pnorm := l_gnorm
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.g0norm := l_gnorm
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	intermediate_point___0 (a_x, a_p: CE_POINTER [PD_GSL_VECTOR]; a_lambda, a_pg, a_stepa, a_stepc, a_fa, a_fc: REAL_64; a_x1___0, a_dx, a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step, a_f: CE_POINTER [REAL_64])
		require
			not a_p.is_void
			not a_x1___0.is_void
			not a_dx.is_void
			not a_step.is_void
			not a_f.is_void
		local
			l_stepc: REAL_64
			l_fc: REAL_64
			l_stepb: REAL_64
			l_fb: REAL_64
			l_u: REAL_64
			l_tmp: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_stepc := a_stepc
					l_fc := a_fc
				when 1 then -- trial:
					l_tmp := fabs ((a_pg * a_lambda) * l_stepc)
					update_class_fields -- Current might have been changed; synchronize
					l_u := l_tmp
					l_stepb := ((0.5 * l_stepc) * l_u) / ((l_fc - a_fa) + l_u);
					(create {P_DIRECTIONAL_MINIMIZE_STATIC}).take_step___0 (a_x, a_p, l_stepb, a_lambda, a_x1___0, a_dx)
					update_class_fields -- Current might have been changed; synchronize
					l_fb := f.real_64_item ([a_x1___0, params])
					update_class_fields -- Current might have been changed; synchronize
					if l_fb >= a_fa then
						if l_stepb > 0.0 then
							l_fc := l_fb
							l_stepc := l_stepb
							l_pos := -1 + 1 -- goto trial
						end
					end
				when 2 then
					a_step.item := l_stepb
					update_class_fields -- Current might have been changed; synchronize
					a_f.item := l_fb
					update_class_fields -- Current might have been changed; synchronize
					df.call ([a_x1___0, params, a_gradient])
					update_class_fields -- Current might have been changed; synchronize
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	conjugate_pr_set (a_vstate: CE_POINTER [ANY]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step_size, a_tol: REAL_64): INTEGER_32
		require
			not a_gradient.is_void
		local
			l_state: CE_POINTER [PD_CONJUGATE_PR_STATE_T]
			l_gnorm: REAL_64
			l_tmp: REAL_64
		do
			l_state := create {CE_CLASS_POINTER [PD_CONJUGATE_PR_STATE_T]}.make_cast (a_vstate)
			l_state.item.iter := 0
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.step := a_step_size
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.max_step := a_step_size
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.tol := a_tol
			update_class_fields -- Current might have been changed; synchronize
			fdf.call ([a_x, params, a_f, a_gradient])
			update_class_fields; -- Current might have been changed; synchronize
			(l_state.item.p).item.gsl_vector_memcpy (a_gradient).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(l_state.item.g0).item.gsl_vector_memcpy (a_gradient).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := a_gradient.item.gsl_blas_dnrm2
			update_class_fields -- Current might have been changed; synchronize
			l_gnorm := l_tmp
			l_state.item.pnorm := l_gnorm
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.g0norm := l_gnorm
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	steepest_descent_set (a_vstate: CE_POINTER [ANY]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step_size, a_tol: REAL_64): INTEGER_32
		local
			l_state: CE_POINTER [PD_STEEPEST_DESCENT_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_STEEPEST_DESCENT_STATE_T]}.make_cast (a_vstate)
			fdf.call ([a_x, params, a_f, a_gradient])
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.step := a_step_size
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.max_step := a_step_size
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.tol := a_tol
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	intermediate_point___1 (a_x, a_p: CE_POINTER [PD_GSL_VECTOR]; a_lambda, a_pg, a_stepa, a_stepc, a_fa, a_fc: REAL_64; a_x1___0, a_dx, a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step, a_f: CE_POINTER [REAL_64])
		require
			not a_p.is_void
			not a_x1___0.is_void
			not a_dx.is_void
			not a_step.is_void
			not a_f.is_void
		local
			l_stepc: REAL_64
			l_fc: REAL_64
			l_stepb: REAL_64
			l_fb: REAL_64
			l_u: REAL_64
			l_tmp: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_stepc := a_stepc
					l_fc := a_fc
				when 1 then -- trial:
					l_tmp := fabs ((a_pg * a_lambda) * l_stepc)
					update_class_fields -- Current might have been changed; synchronize
					l_u := l_tmp
					l_stepb := ((0.5 * l_stepc) * l_u) / ((l_fc - a_fa) + l_u);
					(create {P_DIRECTIONAL_MINIMIZE_STATIC}).take_step___1 (a_x, a_p, l_stepb, a_lambda, a_x1___0, a_dx)
					update_class_fields -- Current might have been changed; synchronize
					l_fb := f.real_64_item ([a_x1___0, params])
					update_class_fields -- Current might have been changed; synchronize
					if l_fb >= a_fa then
						if l_stepb > 0.0 then
							l_fc := l_fb
							l_stepc := l_stepb
							l_pos := -1 + 1 -- goto trial
						end
					end
				when 2 then
					a_step.item := l_stepb
					update_class_fields -- Current might have been changed; synchronize
					a_f.item := l_fb
					update_class_fields -- Current might have been changed; synchronize
					df.call ([a_x1___0, params, a_gradient])
					update_class_fields -- Current might have been changed; synchronize
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	conjugate_fr_set (a_vstate: CE_POINTER [ANY]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step_size, a_tol: REAL_64): INTEGER_32
		require
			not a_gradient.is_void
		local
			l_state: CE_POINTER [PD_CONJUGATE_FR_STATE_T]
			l_gnorm: REAL_64
			l_tmp: REAL_64
		do
			l_state := create {CE_CLASS_POINTER [PD_CONJUGATE_FR_STATE_T]}.make_cast (a_vstate)
			l_state.item.iter := 0
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.step := a_step_size
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.max_step := a_step_size
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.tol := a_tol
			update_class_fields -- Current might have been changed; synchronize
			fdf.call ([a_x, params, a_f, a_gradient])
			update_class_fields; -- Current might have been changed; synchronize
			(l_state.item.p).item.gsl_vector_memcpy (a_gradient).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(l_state.item.g0).item.gsl_vector_memcpy (a_gradient).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := a_gradient.item.gsl_blas_dnrm2
			update_class_fields -- Current might have been changed; synchronize
			l_gnorm := l_tmp
			l_state.item.pnorm := l_gnorm
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.g0norm := l_gnorm
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	vector_bfgs2_set (a_vstate: CE_POINTER [ANY]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step_size, a_tol: REAL_64): INTEGER_32
		require
			not a_f.is_void
		local
			l_state: CE_POINTER [PD_VECTOR_BFGS2_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_VECTOR_BFGS2_STATE_T]}.make_cast (a_vstate)
			l_state.item.iter := 0
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.step := a_step_size
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.delta_f := (0).to_double
			update_class_fields -- Current might have been changed; synchronize
			fdf.call ([a_x, params, a_f, a_gradient])
			update_class_fields; -- Current might have been changed; synchronize
			(l_state.item.x0).item.gsl_vector_memcpy (a_x).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(l_state.item.g0).item.gsl_vector_memcpy (a_gradient).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.g0norm := (l_state.item.g0).item.gsl_blas_dnrm2
			update_class_fields; -- Current might have been changed; synchronize
			(l_state.item.p).item.gsl_vector_memcpy (a_gradient).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(l_state.item.p).item.gsl_blas_dscal ((-1).to_double / l_state.item.g0norm)
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.pnorm := (l_state.item.p).item.gsl_blas_dnrm2
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.fp0 := -l_state.item.g0norm
			update_class_fields -- Current might have been changed; synchronize
			prepare_wrapper (create {CE_CLASS_POINTER [PD_WRAPPER_T]}.make_shared (l_state.c_pointer + (create {PD_VECTOR_BFGS2_STATE_T}.make).offset_of ("wrap")), (create {CE_CLASS_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]}.make_shared (c_pointer)), l_state.item.x0, a_f.item, l_state.item.g0, l_state.item.p, l_state.item.x_alpha, l_state.item.g_alpha)
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.rho := 0.01
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.sigma := a_tol
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.tau1 := (9).to_double
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.tau2 := 0.05
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.tau3 := 0.5
			update_class_fields -- Current might have been changed; synchronize
			l_state.item.order := 3
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

feature {PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT} -- private routines

	prepare_wrapper (a_w: CE_POINTER [PD_WRAPPER_T]; a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: REAL_64; a_g, a_p, a_x_alpha, a_g_alpha: CE_POINTER [PD_GSL_VECTOR])
		require
			not a_w.is_void
		do
			a_w.item.fdf_linear.f := (create {PD_WRAPPER_T_STATIC}).wrap_f_address
			a_w.item.fdf_linear.df := (create {PD_WRAPPER_T_STATIC}).wrap_df_address
			a_w.item.fdf_linear.fdf := (create {PD_WRAPPER_T_STATIC}).wrap_fdf_address
			a_w.item.fdf_linear.params := create {CE_VOID_POINTER}.make_cast (a_w)
			a_w.item.fdf := a_fdf
			a_w.item.x := a_x
			a_w.item.g := a_g
			a_w.item.p := a_p
			a_w.item.x_alpha := a_x_alpha
			a_w.item.g_alpha := a_g_alpha;
			(a_w.item.x_alpha).item.gsl_vector_memcpy (a_w.item.x).do_nothing
			a_w.item.x_cache_key := 0.0
			a_w.item.f_alpha := a_f
			a_w.item.f_cache_key := 0.0;
			(a_w.item.g_alpha).item.gsl_vector_memcpy (a_w.item.g).do_nothing
			a_w.item.g_cache_key := 0.0
			a_w.item.df_alpha := a_w.item.slope
			a_w.item.df_cache_key := 0.0
		end

feature {ANY}

	copy (a_other: like Current)
		do
			f := a_other.f
			df := a_other.df
			fdf := a_other.fdf
			n := a_other.n
			params := a_other.params
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				f.is_equal (a_other.f) and
				df.is_equal (a_other.df) and
				fdf.is_equal (a_other.fdf) and
				n = a_other.n and
				params.is_equal (a_other.params)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("f"),
					create {CE_STRUCTURE_FIELD}.make ("df"),
					create {CE_STRUCTURE_FIELD}.make ("fdf"),
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("params")
				>>)
			init_structure_info
		end

end
