class
	PD_GSL_MULTIMIN_FUNCTION_STRUCT

inherit
	PD_GSL_MULTIMIN_FUNCTION_STRUCT_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_MATH_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create f.make
			create {CE_VOID_POINTER} params.make
			Precursor
		end

feature {ANY} -- fields

	f: CE_ROUTINE assign set_f

	n: NATURAL_32 assign set_n

	params: CE_POINTER [ANY] assign set_params

feature {ANY} -- field setters

	set_f (a_f: CE_ROUTINE)
		do
			f := a_f
			update_memory_field ("f")
		end

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_params (a_params: CE_POINTER [ANY])
		do
			params := a_params
			update_memory_field ("params")
		end

feature {ANY} -- public routines

	nmsimplex_set (a_vstate: CE_POINTER [ANY]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_size: CE_POINTER [REAL_64]; a_step_size: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		require
			not a_x.is_void
		local
			l_status: INTEGER_32
			l_i: NATURAL_32
			l_val: REAL_64
			l_state: CE_POINTER [PD_NMSIMPLEX_STATE_T]
			l_xtemp: CE_POINTER [PD_GSL_VECTOR]
			l_tmp: INTEGER_32
			l_tmp___0: REAL_64
			l_tmp___1: REAL_64
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_NMSIMPLEX_STATE_T]}.make_cast (a_vstate)
			l_xtemp := l_state.item.ws1
			if l_xtemp.item.size /= a_x.item.size then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("incompatible size of x"), ce_string ("simplex.c"), 251, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (l_xtemp.item.size /= a_step_size.item.size) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("incompatible size of step_size"), ce_string ("simplex.c"), 256, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_val := f.real_64_item ([a_x, params])
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := (create {P_INFNAN_STATIC}).gsl_finite (l_val)
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp.to_boolean then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("non-finite function value encountered"), ce_string ("simplex.c"), 265, 9)
						update_class_fields -- Current might have been changed; synchronize
						Result := 9
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				(l_state.item.x1).item.gsl_matrix_set_row ((0).to_natural_32, a_x).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(l_state.item.y1).item.gsl_vector_set ((0).to_natural_32, l_val)
				update_class_fields -- Current might have been changed; synchronize
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_x.item.size))
				loop
					l_status := l_xtemp.item.gsl_vector_memcpy (a_x)
					update_class_fields -- Current might have been changed; synchronize
					if l_status /= 0 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector memcopy failed"), ce_string ("simplex.c"), 279, 5)
							update_class_fields -- Current might have been changed; synchronize
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_tmp___0 := l_xtemp.item.gsl_vector_get (l_i)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := a_step_size.item.gsl_vector_get (l_i)
						update_class_fields -- Current might have been changed; synchronize
						l_val := l_tmp___0 + l_tmp___1
						l_xtemp.item.gsl_vector_set (l_i, l_val)
						update_class_fields -- Current might have been changed; synchronize
						l_val := f.real_64_item ([l_xtemp, params])
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := (create {P_INFNAN_STATIC}).gsl_finite (l_val)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___2.to_boolean then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("non-finite function value encountered"), ce_string ("simplex.c"), 288, 9)
								update_class_fields -- Current might have been changed; synchronize
								Result := 9
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						(l_state.item.x1).item.gsl_matrix_set_row (l_i + {NATURAL_32} 1, l_xtemp).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(l_state.item.y1).item.gsl_vector_set (l_i + {NATURAL_32} 1, l_val)
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				a_size.item := l_state.item.nmsimplex_size
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

	gsl_multimin_diff (a_x, a_g: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_h: REAL_64
			l_x1___0: CE_POINTER [PD_GSL_VECTOR]
			l_tmp: CE_POINTER [PD_GSL_VECTOR]
			l_fl: REAL_64
			l_fh: REAL_64
			l_xi: REAL_64
			l_tmp___0: REAL_64
			l_dx: REAL_64
			l_tmp___1: REAL_64
		do
			l_n := n
			l_h := 1.4901161193847656e-08
			l_tmp := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (l_n)
			update_class_fields -- Current might have been changed; synchronize
			l_x1___0 := l_tmp
			l_x1___0.item.gsl_vector_memcpy (a_x).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_tmp___0 := a_x.item.gsl_vector_get (l_i)
				update_class_fields -- Current might have been changed; synchronize
				l_xi := l_tmp___0
				l_tmp___1 := fabs (l_xi)
				update_class_fields -- Current might have been changed; synchronize
				l_dx := l_tmp___1 * l_h
				if l_dx = 0.0 then
					l_dx := l_h
				end
				l_x1___0.item.gsl_vector_set (l_i, l_xi + l_dx)
				update_class_fields -- Current might have been changed; synchronize
				l_fh := f.real_64_item ([l_x1___0, params])
				update_class_fields -- Current might have been changed; synchronize
				l_x1___0.item.gsl_vector_set (l_i, l_xi - l_dx)
				update_class_fields -- Current might have been changed; synchronize
				l_fl := f.real_64_item ([l_x1___0, params])
				update_class_fields -- Current might have been changed; synchronize
				l_x1___0.item.gsl_vector_set (l_i, l_xi)
				update_class_fields -- Current might have been changed; synchronize
				a_g.item.gsl_vector_set (l_i, (l_fh - l_fl) / (2.0 * l_dx))
				update_class_fields -- Current might have been changed; synchronize
				l_i := l_i + 1
			end
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_x1___0)
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	nmsimplex_set___0 (a_vstate: CE_POINTER [ANY]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_size: CE_POINTER [REAL_64]; a_step_size: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		require
			not a_x.is_void
		local
			l_status: INTEGER_32
			l_i: NATURAL_32
			l_val: REAL_64
			l_state: CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]
			l_xtemp: CE_POINTER [PD_GSL_VECTOR]
			l_tmp: INTEGER_32
			l_xi: REAL_64
			l_tmp___0: REAL_64
			l_si: REAL_64
			l_tmp___1: REAL_64
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_NMSIMPLEX_STATE_T_119__]}.make_cast (a_vstate)
			l_xtemp := l_state.item.ws1
			if l_xtemp.item.size /= a_x.item.size then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("incompatible size of x"), ce_string ("simplex2.c"), 358, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (l_xtemp.item.size /= a_step_size.item.size) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("incompatible size of step_size"), ce_string ("simplex2.c"), 363, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_val := f.real_64_item ([a_x, params])
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := (create {P_INFNAN_STATIC}).gsl_finite (l_val)
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp.to_boolean then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("non-finite function value encountered"), ce_string ("simplex2.c"), 372, 9)
						update_class_fields -- Current might have been changed; synchronize
						Result := 9
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				(l_state.item.x1).item.gsl_matrix_set_row ((0).to_natural_32, a_x).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(l_state.item.y1).item.gsl_vector_set ((0).to_natural_32, l_val)
				update_class_fields -- Current might have been changed; synchronize
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_x.item.size))
				loop
					l_status := l_xtemp.item.gsl_vector_memcpy (a_x)
					update_class_fields -- Current might have been changed; synchronize
					if l_status /= 0 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector memcopy failed"), ce_string ("simplex2.c"), 386, 5)
							update_class_fields -- Current might have been changed; synchronize
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_tmp___0 := a_x.item.gsl_vector_get (l_i)
						update_class_fields -- Current might have been changed; synchronize
						l_xi := l_tmp___0
						l_tmp___1 := a_step_size.item.gsl_vector_get (l_i)
						update_class_fields -- Current might have been changed; synchronize
						l_si := l_tmp___1
						l_xtemp.item.gsl_vector_set (l_i, l_xi + l_si)
						update_class_fields -- Current might have been changed; synchronize
						l_val := f.real_64_item ([l_xtemp, params])
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := (create {P_INFNAN_STATIC}).gsl_finite (l_val)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___2.to_boolean then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("non-finite function value encountered"), ce_string ("simplex2.c"), 399, 9)
								update_class_fields -- Current might have been changed; synchronize
								Result := 9
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						(l_state.item.x1).item.gsl_matrix_set_row (l_i + {NATURAL_32} 1, l_xtemp).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(l_state.item.y1).item.gsl_vector_set (l_i + {NATURAL_32} 1, l_val)
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				l_state.item.compute_center (l_state.item.center).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				a_size.item := l_state.item.compute_size (l_state.item.center)
				update_class_fields -- Current might have been changed; synchronize
				l_state.item.count := (l_state.item.count) + 1
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

	nmsimplex_set_rand (a_vstate: CE_POINTER [ANY]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_size: CE_POINTER [REAL_64]; a_step_size: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		require
			not a_x.is_void
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_val: REAL_64
			l_state: CE_POINTER [PD_NMSIMPLEX_STATE_T_119__]
			l_xtemp: CE_POINTER [PD_GSL_VECTOR]
			l_tmp: INTEGER_32
			l_m___4: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_tmp___0: PD_GSL_MATRIX_VIEW
			l_seed: CE_ARRAY [NATURAL_32]
			l_s: REAL_64
			l_tmp___1: REAL_64
			l_angle: REAL_64
			l_tmp___2: REAL_64
			l_c___1: REAL_64
			l_tmp___3: REAL_64
			l_s___0: REAL_64
			l_tmp___4: REAL_64
			l_c_i: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_tmp___5: PD_GSL_VECTOR_VIEW
			l_c_j: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_tmp___6: PD_GSL_VECTOR_VIEW
			l_x_i: REAL_64
			l_tmp___7: REAL_64
			l_s_i: REAL_64
			l_tmp___8: REAL_64
			l_c_i___0: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_tmp___9: PD_GSL_VECTOR_VIEW
			l_x_ij: REAL_64
			l_tmp___10: REAL_64
			l_r_i: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_tmp___11: PD_GSL_VECTOR_VIEW
			l_tmp___12: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_MATRIX_VIEW]} l_m___4.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_seed.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_VECTOR_VIEW]} l_c_i.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_VECTOR_VIEW]} l_c_j.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_VECTOR_VIEW]} l_c_i___0.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_VECTOR_VIEW]} l_r_i.make (<<1>>)

			l_state := create {CE_CLASS_POINTER [PD_NMSIMPLEX_STATE_T_119__]}.make_cast (a_vstate)
			l_xtemp := l_state.item.ws1
			if l_xtemp.item.size /= a_x.item.size then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("incompatible size of x"), ce_string ("simplex2.c"), 596, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (l_xtemp.item.size /= a_step_size.item.size) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("incompatible size of step_size"), ce_string ("simplex2.c"), 601, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_val := f.real_64_item ([a_x, params])
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := (create {P_INFNAN_STATIC}).gsl_finite (l_val)
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp.to_boolean then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("non-finite function value encountered"), ce_string ("simplex2.c"), 610, 9)
						update_class_fields -- Current might have been changed; synchronize
						Result := 9
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				(l_state.item.x1).item.gsl_matrix_set_row ((0).to_natural_32, a_x).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(l_state.item.y1).item.gsl_vector_set ((0).to_natural_32, l_val)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := ((l_state.item.x1).item.gsl_matrix_submatrix ((1).to_natural_32, (0).to_natural_32, a_x.item.size, a_x.item.size)).twin
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.item := l_tmp___0.twin
				update_class_fields -- Current might have been changed; synchronize
				l_seed.item := (l_state.item.count).bit_xor ({NATURAL_32} 305_419_896)
				update_class_fields -- Current might have been changed; synchronize
				ran_unif (l_seed).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).item.gsl_matrix_set_identity
				update_class_fields -- Current might have been changed; synchronize
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_x.item.size)
				loop
					l_tmp___1 := ran_unif (l_seed)
					update_class_fields -- Current might have been changed; synchronize
					l_s := l_tmp___1
					if l_s > 0.5 then
						(create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).item.gsl_matrix_set (l_i, l_i, -1.0)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_x.item.size))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (l_j < a_x.item.size)
					loop
						l_tmp___2 := ran_unif (l_seed)
						update_class_fields -- Current might have been changed; synchronize
						l_angle := (2.0 * 3.14159265358979323846) * l_tmp___2
						l_tmp___3 := cos (l_angle)
						update_class_fields -- Current might have been changed; synchronize
						l_c___1 := l_tmp___3
						l_tmp___4 := sin (l_angle)
						update_class_fields -- Current might have been changed; synchronize
						l_s___0 := l_tmp___4
						l_tmp___5 := ((create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).item.gsl_matrix_column (l_i)).twin
						update_class_fields -- Current might have been changed; synchronize
						l_c_i.item := l_tmp___5.twin
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___6 := ((create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).item.gsl_matrix_column (l_j)).twin
						update_class_fields -- Current might have been changed; synchronize
						l_c_j.item := l_tmp___6.twin
						update_class_fields; -- Current might have been changed; synchronize
						(create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_c_i.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))).item.gsl_blas_drot (create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_c_j.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), l_c___1, l_s___0).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_x.item.size))
				loop
					l_tmp___7 := a_x.item.gsl_vector_get (l_i)
					update_class_fields -- Current might have been changed; synchronize
					l_x_i := l_tmp___7
					l_tmp___8 := a_step_size.item.gsl_vector_get (l_i)
					update_class_fields -- Current might have been changed; synchronize
					l_s_i := l_tmp___8
					l_tmp___9 := ((create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).item.gsl_matrix_column (l_i)).twin
					update_class_fields -- Current might have been changed; synchronize
					l_c_i___0.item := l_tmp___9.twin
					update_class_fields -- Current might have been changed; synchronize
					l_j := (0).to_natural_32
					from
					until
						not (l_j < a_x.item.size)
					loop
						l_tmp___10 := (create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_c_i___0.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))).item.gsl_vector_get (l_j)
						update_class_fields -- Current might have been changed; synchronize
						l_x_ij := l_tmp___10;
						(create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_c_i___0.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))).item.gsl_vector_set (l_j, l_x_i + l_s_i * l_x_ij)
						update_class_fields -- Current might have been changed; synchronize
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_x.item.size))
				loop
					l_tmp___11 := ((create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (l_m___4.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).item.gsl_matrix_row (l_i)).twin
					update_class_fields -- Current might have been changed; synchronize
					l_r_i.item := l_tmp___11.twin
					update_class_fields -- Current might have been changed; synchronize
					l_val := f.real_64_item ([(create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_r_i.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), params])
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___12 := (create {P_INFNAN_STATIC}).gsl_finite (l_val)
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp___12.to_boolean then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("non-finite function value encountered"), ce_string ("simplex2.c"), 674, 9)
							update_class_fields -- Current might have been changed; synchronize
							Result := 9
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						(l_state.item.y1).item.gsl_vector_set (l_i + {NATURAL_32} 1, l_val)
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				l_state.item.compute_center (l_state.item.center).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				a_size.item := l_state.item.compute_size (l_state.item.center)
				update_class_fields -- Current might have been changed; synchronize
				l_state.item.count := (l_state.item.count) + 1
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

feature {PD_GSL_MULTIMIN_FUNCTION_STRUCT} -- private routines

	ran_unif (a_seed: CE_POINTER [NATURAL_32]): REAL_64
		require
			not a_seed.is_void
		local
			l_s: NATURAL_32
		do
			l_s := a_seed.item
			a_seed.item := ((l_s * {NATURAL_32} 69_069 + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
			Result := ((a_seed.item).to_real_64 / 4294967296.0)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			f := a_other.f
			n := a_other.n
			params := a_other.params
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				f.is_equal (a_other.f) and
				n = a_other.n and
				params.is_equal (a_other.params)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("f"),
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("params")
				>>)
			init_structure_info
		end

end
