class
	PD_GSL_NTUPLE_SELECT_FN

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create function.make
			create {CE_VOID_POINTER} params.make
		end

feature {ANY} -- fields

	function: CE_ROUTINE assign set_function

	params: CE_POINTER [ANY] assign set_params

feature {ANY} -- field setters

	set_function (a_function: CE_ROUTINE)
		do
			function := a_function
			update_memory_field ("function")
		end

	set_params (a_params: CE_POINTER [ANY])
		do
			params := a_params
			update_memory_field ("params")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			function := a_other.function
			params := a_other.params
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				function.is_equal (a_other.function) and
				params.is_equal (a_other.params)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("function"),
					create {CE_STRUCTURE_FIELD}.make ("params")
				>>)
			init_structure_info
		end

end
