class
	PD_GSL_SUM_LEVIN_U_WORKSPACE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_MATH_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_REAL_64_POINTER} q_num.make
			create {CE_REAL_64_POINTER} q_den.make
			create {CE_REAL_64_POINTER} dq_num.make
			create {CE_REAL_64_POINTER} dq_den.make
			create {CE_REAL_64_POINTER} dsum.make
			Precursor
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	i: NATURAL_32 assign set_i

	terms_used: NATURAL_32 assign set_terms_used

	sum_plain: REAL_64 assign set_sum_plain

	q_num: CE_POINTER [REAL_64] assign set_q_num

	q_den: CE_POINTER [REAL_64] assign set_q_den

	dq_num: CE_POINTER [REAL_64] assign set_dq_num

	dq_den: CE_POINTER [REAL_64] assign set_dq_den

	dsum: CE_POINTER [REAL_64] assign set_dsum

feature {ANY} -- field setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_i (a_i: NATURAL_32)
		do
			i := a_i
			update_memory_field ("i")
		end

	set_terms_used (a_terms_used: NATURAL_32)
		do
			terms_used := a_terms_used
			update_memory_field ("terms_used")
		end

	set_sum_plain (a_sum_plain: REAL_64)
		do
			sum_plain := a_sum_plain
			update_memory_field ("sum_plain")
		end

	set_q_num (a_q_num: CE_POINTER [REAL_64])
		do
			q_num := a_q_num
			update_memory_field ("q_num")
		end

	set_q_den (a_q_den: CE_POINTER [REAL_64])
		do
			q_den := a_q_den
			update_memory_field ("q_den")
		end

	set_dq_num (a_dq_num: CE_POINTER [REAL_64])
		do
			dq_num := a_dq_num
			update_memory_field ("dq_num")
		end

	set_dq_den (a_dq_den: CE_POINTER [REAL_64])
		do
			dq_den := a_dq_den
			update_memory_field ("dq_den")
		end

	set_dsum (a_dsum: CE_POINTER [REAL_64])
		do
			dsum := a_dsum
			update_memory_field ("dsum")
		end

feature {ANY} -- public routines

	gsl_sum_levin_u_minmax (a_array: CE_POINTER [REAL_64]; a_array_size, a_min_terms, a_max_terms: NATURAL_32; a_sum_accel, a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_sum_accel.is_void
			not a_abserr.is_void
		local
			l_size: NATURAL_32
			l_SMALL: REAL_64
			l_nmax: NATURAL_32
			l_tmp: NATURAL_32
			l_noise_n: REAL_64
			l_noise_nm1: REAL_64
			l_trunc_n: REAL_64
			l_trunc_nm1: REAL_64
			l_actual_trunc_n: REAL_64
			l_actual_trunc_nm1: REAL_64
			l_result_n: CE_ARRAY [REAL_64]
			l_result_nm1: REAL_64
			l_variance: REAL_64
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_better: INTEGER_32
			l_before: INTEGER_32
			l_converging: INTEGER_32
			l_least_trunc: REAL_64
			l_least_trunc_noise: REAL_64
			l_least_trunc_result: REAL_64
			l_t: REAL_64
			l_dn: REAL_64
			l_t___0: REAL_64
			l_dn___0: REAL_64
			l_tmp___0: REAL_64
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: REAL_64
			l_return, l_break: BOOLEAN
		do
			create {CE_REAL_64_ARRAY} l_result_n.make (<<1>>)

			l_size := a_array_size
			from
			until
				(l_break)
			loop
				l_break := False
				if l_size > {NATURAL_32} 0 then
					if a_array[(l_size - {NATURAL_32} 1).to_integer_32] /= (0).to_double then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_size := l_size - 1
				end
			end
			l_break := False
			if l_size = {NATURAL_32} 0 then
				a_sum_accel.item := 0.0
				update_class_fields -- Current might have been changed; synchronize
				a_abserr.item := 0.0
				update_class_fields -- Current might have been changed; synchronize
				Current.sum_plain := 0.0
				update_class_fields -- Current might have been changed; synchronize
				Current.terms_used := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			elseif l_size = {NATURAL_32} 1 then
				a_sum_accel.item := a_array[0]
				update_class_fields -- Current might have been changed; synchronize
				a_abserr.item := 0.0
				update_class_fields -- Current might have been changed; synchronize
				Current.sum_plain := a_array[0]
				update_class_fields -- Current might have been changed; synchronize
				Current.terms_used := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			else
				l_SMALL := 0.01
				if a_max_terms > a_array_size then
					l_tmp := a_max_terms
				else
					l_tmp := a_array_size
				end
				l_nmax := l_tmp - {NATURAL_32} 1
				l_noise_n := 0.0
				l_noise_nm1 := 0.0
				l_trunc_n := 0.0
				l_trunc_nm1 := 0.0
				l_actual_trunc_n := 0.0
				l_actual_trunc_nm1 := 0.0
				l_result_n.item := 0.0
				update_class_fields -- Current might have been changed; synchronize
				l_result_nm1 := 0.0
				l_variance := (0).to_double
				l_better := 0
				l_before := 0
				l_converging := 0
				l_least_trunc := 1.7976931348623157e+308
				l_least_trunc_noise := 1.7976931348623157e+308
				l_n := (0).to_natural_32
				from
				until
					not (l_n < a_min_terms)
				loop
					l_t := a_array[l_n.to_integer_32]
					l_result_nm1 := l_result_n.item;
					((create {CE_CLASS_POINTER [PD_GSL_SUM_LEVIN_U_WORKSPACE]}.make_shared (c_pointer))).item.gsl_sum_levin_u_step (l_t, l_n, l_nmax, l_result_n).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_n := l_n + 1
				end
				l_least_trunc_result := l_result_n.item
				l_variance := (0).to_double
				l_i := {NATURAL_32} 0
				from
				until
					not (l_i < l_n)
				loop
					l_dn := (dsum[l_i.to_integer_32] * 2.2204460492503131e-16) * a_array[l_i.to_integer_32]
					l_variance := l_variance + (l_dn * l_dn)
					l_i := l_i + 1
				end
				l_noise_n := sqrt (l_variance)
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					not (not (l_return or l_break) and then (l_n <= l_nmax))
				loop
					l_break := False
					l_t___0 := a_array[l_n.to_integer_32]
					l_result_nm1 := l_result_n.item;
					((create {CE_CLASS_POINTER [PD_GSL_SUM_LEVIN_U_WORKSPACE]}.make_shared (c_pointer))).item.gsl_sum_levin_u_step (l_t___0, l_n, l_nmax, l_result_n).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_actual_trunc_nm1 := l_actual_trunc_n
					l_actual_trunc_n := fabs (l_result_n.item - l_result_nm1)
					update_class_fields -- Current might have been changed; synchronize
					l_trunc_nm1 := l_trunc_n
					l_trunc_n := 0.5 * (l_actual_trunc_n + l_actual_trunc_nm1)
					l_noise_nm1 := l_noise_n
					l_variance := (0).to_double
					l_i := {NATURAL_32} 0
					from
					until
						not (l_i <= l_n)
					loop
						l_dn___0 := (dsum[l_i.to_integer_32] * 2.2204460492503131e-16) * a_array[l_i.to_integer_32]
						l_variance := l_variance + (l_dn___0 * l_dn___0)
						l_i := l_i + 1
					end
					l_noise_n := sqrt (l_variance)
					update_class_fields -- Current might have been changed; synchronize
					if l_trunc_n < l_trunc_nm1 then
						l_tmp___1 := 1
					else
						l_tmp___0 := fabs (l_result_n.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_trunc_n < l_SMALL * l_tmp___0 then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
					end
					l_better := l_tmp___1
					if l_converging.to_boolean then
						l_tmp___2 := 1
					elseif l_better.to_boolean then
						if l_before.to_boolean then
							l_tmp___2 := 1
						else
							l_tmp___2 := 0
						end
					else
						l_tmp___2 := 0
					end
					l_converging := l_tmp___2
					l_before := l_better
					if l_converging.to_boolean then
						if l_trunc_n < l_least_trunc then
							l_least_trunc_result := l_result_n.item
							l_least_trunc := l_trunc_n
							l_least_trunc_noise := l_noise_n
						end
						if l_noise_n > l_trunc_n / 3.0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_tmp___3 := fabs (l_result_n.item)
							update_class_fields -- Current might have been changed; synchronize
							if l_trunc_n < (10.0 * 2.2204460492503131e-16) * l_tmp___3 then
								l_break := True
							end
						end
					end
					if not (l_return or l_break) then
						l_n := l_n + 1
					end
				end
				l_break := False
				if l_converging.to_boolean then
					a_sum_accel.item := l_least_trunc_result
					update_class_fields -- Current might have been changed; synchronize
					a_abserr.item := (create {P_GSL_GSL_MINMAX_STATIC}).GSL_MAX_DBL (l_least_trunc, l_least_trunc_noise)
					update_class_fields -- Current might have been changed; synchronize
					Current.terms_used := l_n
					update_class_fields -- Current might have been changed; synchronize
					Result := 0
				else
					a_sum_accel.item := l_result_n.item
					update_class_fields -- Current might have been changed; synchronize
					a_abserr.item := (create {P_GSL_GSL_MINMAX_STATIC}).GSL_MAX_DBL (l_trunc_n, l_noise_n)
					update_class_fields -- Current might have been changed; synchronize
					Current.terms_used := l_n
					update_class_fields -- Current might have been changed; synchronize
					Result := 0
				end
			end
		end

	gsl_sum_levin_u_step (a_term: REAL_64; a_n, a_nmax: NATURAL_32; a_sum_accel: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_sum_accel.is_void
		local
			l_result: REAL_64
			l_factor: REAL_64
			l_ratio: REAL_64
			l_i: NATURAL_32
			l_j: INTEGER_32
			l_c___1: REAL_64
			l_return: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				a_sum_accel.item := a_term
				update_class_fields -- Current might have been changed; synchronize
				Current.sum_plain := a_term
				update_class_fields -- Current might have been changed; synchronize
				q_den[0] := 1.0 / a_term
				update_class_fields -- Current might have been changed; synchronize
				q_num[0] := 1.0
				update_class_fields -- Current might have been changed; synchronize
				dq_den[({NATURAL_32} 0).to_integer_32] := -1.0 / (a_term * a_term)
				update_class_fields -- Current might have been changed; synchronize
				dq_num[({NATURAL_32} 0).to_integer_32] := 0.0
				update_class_fields -- Current might have been changed; synchronize
				dsum[0] := 1.0
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			else
				l_factor := 1.0
				l_ratio := a_n.to_real_64 / (a_n.to_real_64 + 1.0)
				Current.sum_plain := sum_plain + a_term
				update_class_fields -- Current might have been changed; synchronize
				q_den[a_n.to_integer_32] := 1.0 / ((a_term * (a_n.to_real_64 + 1.0)) * (a_n.to_real_64 + 1.0))
				update_class_fields -- Current might have been changed; synchronize
				q_num[a_n.to_integer_32] := sum_plain * q_den[a_n.to_integer_32]
				update_class_fields -- Current might have been changed; synchronize
				l_i := {NATURAL_32} 0
				from
				until
					not (l_i < a_n)
				loop
					dq_den[(l_i * (a_nmax + {NATURAL_32} 1) + a_n).to_integer_32] := (0).to_double
					update_class_fields -- Current might have been changed; synchronize
					dq_num[(l_i * (a_nmax + {NATURAL_32} 1) + a_n).to_integer_32] := q_den[a_n.to_integer_32]
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				dq_den[(a_n * (a_nmax + {NATURAL_32} 1) + a_n).to_integer_32] := -q_den[a_n.to_integer_32] / a_term
				update_class_fields -- Current might have been changed; synchronize
				dq_num[(a_n * (a_nmax + {NATURAL_32} 1) + a_n).to_integer_32] := q_den[a_n.to_integer_32] + sum_plain * dq_den[(a_n * (a_nmax + {NATURAL_32} 1) + a_n).to_integer_32]
				update_class_fields -- Current might have been changed; synchronize
				l_j := (a_n - {NATURAL_32} 1).to_integer_32
				from
				until
					not (not (l_return) and then (l_j >= 0))
				loop
					l_c___1 := (l_factor * (l_j + 1).to_double) / (a_n + {NATURAL_32} 1).to_real_64
					l_factor := l_factor * l_ratio
					q_den[l_j] := q_den[(l_j + 1)] - l_c___1 * q_den[l_j]
					update_class_fields -- Current might have been changed; synchronize
					q_num[l_j] := q_num[(l_j + 1)] - l_c___1 * q_num[l_j]
					update_class_fields -- Current might have been changed; synchronize
					l_i := {NATURAL_32} 0
					from
					until
						not (l_i < a_n)
					loop
						dq_den[(l_i * (a_nmax + {NATURAL_32} 1) + l_j.to_natural_32).to_integer_32] := dq_den[(l_i * (a_nmax + {NATURAL_32} 1) + (l_j + 1).to_natural_32).to_integer_32] - l_c___1 * dq_den[(l_i * (a_nmax + {NATURAL_32} 1) + l_j.to_natural_32).to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						dq_num[(l_i * (a_nmax + {NATURAL_32} 1) + l_j.to_natural_32).to_integer_32] := dq_num[(l_i * (a_nmax + {NATURAL_32} 1) + (l_j + 1).to_natural_32).to_integer_32] - l_c___1 * dq_num[(l_i * (a_nmax + {NATURAL_32} 1) + l_j.to_natural_32).to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i + 1
					end
					dq_den[(a_n * (a_nmax + {NATURAL_32} 1) + l_j.to_natural_32).to_integer_32] := dq_den[(a_n * (a_nmax + {NATURAL_32} 1) + (l_j + 1).to_natural_32).to_integer_32]
					update_class_fields -- Current might have been changed; synchronize
					dq_num[(a_n * (a_nmax + {NATURAL_32} 1) + l_j.to_natural_32).to_integer_32] := dq_num[(a_n * (a_nmax + {NATURAL_32} 1) + (l_j + 1).to_natural_32).to_integer_32]
					update_class_fields -- Current might have been changed; synchronize
					l_j := l_j - 1
				end
				l_result := q_num[0] / q_den[0]
				a_sum_accel.item := l_result
				update_class_fields -- Current might have been changed; synchronize
				l_i := {NATURAL_32} 0
				from
				until
					not (l_i <= a_n)
				loop
					dsum[l_i.to_integer_32] := (dq_num[(l_i * (a_nmax + {NATURAL_32} 1)).to_integer_32] - l_result * dq_den[(l_i * (a_nmax + {NATURAL_32} 1)).to_integer_32]) / q_den[0]
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_sum_levin_u_accel (a_array: CE_POINTER [REAL_64]; a_array_size: NATURAL_32; a_sum_accel, a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_GSL_SUM_LEVIN_U_WORKSPACE]}.make_shared (c_pointer))).item.gsl_sum_levin_u_minmax (a_array, a_array_size, (0).to_natural_32, a_array_size - {NATURAL_32} 1, a_sum_accel, a_abserr)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			i := a_other.i
			terms_used := a_other.terms_used
			sum_plain := a_other.sum_plain
			q_num := a_other.q_num
			q_den := a_other.q_den
			dq_num := a_other.dq_num
			dq_den := a_other.dq_den
			dsum := a_other.dsum
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				i = a_other.i and
				terms_used = a_other.terms_used and
				sum_plain = a_other.sum_plain and
				q_num.is_equal (a_other.q_num) and
				q_den.is_equal (a_other.q_den) and
				dq_num.is_equal (a_other.dq_num) and
				dq_den.is_equal (a_other.dq_den) and
				dsum.is_equal (a_other.dsum)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("i"),
					create {CE_STRUCTURE_FIELD}.make ("terms_used"),
					create {CE_STRUCTURE_FIELD}.make ("sum_plain"),
					create {CE_STRUCTURE_FIELD}.make ("q_num"),
					create {CE_STRUCTURE_FIELD}.make ("q_den"),
					create {CE_STRUCTURE_FIELD}.make ("dq_num"),
					create {CE_STRUCTURE_FIELD}.make ("dq_den"),
					create {CE_STRUCTURE_FIELD}.make ("dsum")
				>>)
			init_structure_info
		end

end
