class
	PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_GCC_BUILTIN_STATIC
		redefine
			copy,
			is_equal
		end
	S_MATH_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_REAL_64_POINTER} q_num.make
			create {CE_REAL_64_POINTER} q_den.make
			create {CE_REAL_64_POINTER} dsum.make
			Precursor
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	i: NATURAL_32 assign set_i

	terms_used: NATURAL_32 assign set_terms_used

	sum_plain: REAL_64 assign set_sum_plain

	q_num: CE_POINTER [REAL_64] assign set_q_num

	q_den: CE_POINTER [REAL_64] assign set_q_den

	dsum: CE_POINTER [REAL_64] assign set_dsum

feature {ANY} -- field setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_i (a_i: NATURAL_32)
		do
			i := a_i
			update_memory_field ("i")
		end

	set_terms_used (a_terms_used: NATURAL_32)
		do
			terms_used := a_terms_used
			update_memory_field ("terms_used")
		end

	set_sum_plain (a_sum_plain: REAL_64)
		do
			sum_plain := a_sum_plain
			update_memory_field ("sum_plain")
		end

	set_q_num (a_q_num: CE_POINTER [REAL_64])
		do
			q_num := a_q_num
			update_memory_field ("q_num")
		end

	set_q_den (a_q_den: CE_POINTER [REAL_64])
		do
			q_den := a_q_den
			update_memory_field ("q_den")
		end

	set_dsum (a_dsum: CE_POINTER [REAL_64])
		do
			dsum := a_dsum
			update_memory_field ("dsum")
		end

feature {ANY} -- public routines

	gsl_sum_levin_utrunc_minmax (a_array: CE_POINTER [REAL_64]; a_array_size, a_min_terms, a_max_terms: NATURAL_32; a_sum_accel, a_abserr_trunc: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_sum_accel.is_void
			not a_abserr_trunc.is_void
		local
			l_tmp: REAL_32
			l_SMALL: REAL_64
			l_nmax: NATURAL_32
			l_tmp___0: NATURAL_32
			l_trunc_n: REAL_64
			l_trunc_nm1: REAL_64
			l_actual_trunc_n: REAL_64
			l_actual_trunc_nm1: REAL_64
			l_result_n: CE_ARRAY [REAL_64]
			l_result_nm1: REAL_64
			l_n: NATURAL_32
			l_better: INTEGER_32
			l_before: INTEGER_32
			l_converging: INTEGER_32
			l_least_trunc: REAL_64
			l_result_least_trunc: REAL_64
			l_t: REAL_64
			l_t___0: REAL_64
			l_tmp___1: REAL_64
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: REAL_64
			l_break: BOOLEAN
		do
			create {CE_REAL_64_ARRAY} l_result_n.make (<<1>>)

			if a_array_size = {NATURAL_32} 0 then
				a_sum_accel.item := 0.0
				update_class_fields -- Current might have been changed; synchronize
				a_abserr_trunc.item := 0.0
				update_class_fields -- Current might have been changed; synchronize
				Current.sum_plain := 0.0
				update_class_fields -- Current might have been changed; synchronize
				Current.terms_used := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			elseif a_array_size = {NATURAL_32} 1 then
				a_sum_accel.item := a_array[0]
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := builtin_inff
				update_class_fields -- Current might have been changed; synchronize
				a_abserr_trunc.item := l_tmp.to_double
				update_class_fields -- Current might have been changed; synchronize
				Current.sum_plain := a_array[0]
				update_class_fields -- Current might have been changed; synchronize
				Current.terms_used := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			else
				l_SMALL := 0.01
				if a_max_terms > a_array_size then
					l_tmp___0 := a_max_terms
				else
					l_tmp___0 := a_array_size
				end
				l_nmax := l_tmp___0 - {NATURAL_32} 1
				l_trunc_n := 0.0
				l_trunc_nm1 := 0.0
				l_actual_trunc_n := 0.0
				l_actual_trunc_nm1 := 0.0
				l_result_n.item := 0.0
				update_class_fields -- Current might have been changed; synchronize
				l_result_nm1 := 0.0
				l_better := 0
				l_before := 0
				l_converging := 0
				l_least_trunc := 1.7976931348623157e+308
				l_n := (0).to_natural_32
				from
				until
					not (l_n < a_min_terms)
				loop
					l_t := a_array[l_n.to_integer_32]
					l_result_nm1 := l_result_n.item
					gsl_sum_levin_utrunc_step (l_t, l_n, (create {CE_CLASS_POINTER [PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE]}.make_shared (c_pointer)), l_result_n).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_n := l_n + 1
				end
				l_result_least_trunc := l_result_n.item
				from
				until
					not (not (l_break) and then (l_n <= l_nmax))
				loop
					l_break := False
					l_t___0 := a_array[l_n.to_integer_32]
					l_result_nm1 := l_result_n.item
					gsl_sum_levin_utrunc_step (l_t___0, l_n, (create {CE_CLASS_POINTER [PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE]}.make_shared (c_pointer)), l_result_n).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_actual_trunc_nm1 := l_actual_trunc_n
					l_actual_trunc_n := fabs (l_result_n.item - l_result_nm1)
					update_class_fields -- Current might have been changed; synchronize
					l_trunc_nm1 := l_trunc_n
					l_trunc_n := 0.5 * (l_actual_trunc_n + l_actual_trunc_nm1)
					if l_trunc_n < l_trunc_nm1 then
						l_tmp___2 := 1
					else
						l_tmp___1 := fabs (l_result_n.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_trunc_n < l_SMALL * l_tmp___1 then
							l_tmp___2 := 1
						else
							l_tmp___2 := 0
						end
					end
					l_better := l_tmp___2
					if l_converging.to_boolean then
						l_tmp___3 := 1
					elseif l_better.to_boolean then
						if l_before.to_boolean then
							l_tmp___3 := 1
						else
							l_tmp___3 := 0
						end
					else
						l_tmp___3 := 0
					end
					l_converging := l_tmp___3
					l_before := l_better
					if l_converging.to_boolean then
						if l_trunc_n < l_least_trunc then
							l_least_trunc := l_trunc_n
							l_result_least_trunc := l_result_n.item
						end
						l_tmp___4 := fabs (l_trunc_n / l_result_n.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___4 < 10.0 * 2.2204460492503131e-16 then
							l_break := True
						end
					end
					if not (l_break) then
						l_n := l_n + 1
					end
				end
				l_break := False
				if l_converging.to_boolean then
					a_sum_accel.item := l_result_least_trunc
					update_class_fields -- Current might have been changed; synchronize
					a_abserr_trunc.item := l_least_trunc
					update_class_fields -- Current might have been changed; synchronize
					Current.terms_used := l_n
					update_class_fields -- Current might have been changed; synchronize
					Result := 0
				else
					a_sum_accel.item := l_result_n.item
					update_class_fields -- Current might have been changed; synchronize
					a_abserr_trunc.item := l_trunc_n
					update_class_fields -- Current might have been changed; synchronize
					Current.terms_used := l_n
					update_class_fields -- Current might have been changed; synchronize
					Result := 0
				end
			end
		end

	gsl_sum_levin_utrunc_accel (a_array: CE_POINTER [REAL_64]; a_array_size: NATURAL_32; a_sum_accel, a_abserr_trunc: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE]}.make_shared (c_pointer))).item.gsl_sum_levin_utrunc_minmax (a_array, a_array_size, (0).to_natural_32, a_array_size - {NATURAL_32} 1, a_sum_accel, a_abserr_trunc)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

feature {PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE} -- private routines

	gsl_sum_levin_utrunc_step (a_term: REAL_64; a_n: NATURAL_32; a_w: CE_POINTER [PD_GSL_SUM_LEVIN_UTRUNC_WORKSPACE]; a_sum_accel: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_factor: REAL_64
			l_ratio: REAL_64
			l_j: INTEGER_32
			l_c___1: REAL_64
		do
			if a_term = 0.0 then
				Result := 12
			elseif a_n = {NATURAL_32} 0 then
				a_sum_accel.item := a_term
				a_w.item.sum_plain := a_term
				a_w.item.q_den[0] := 1.0 / a_term
				a_w.item.q_num[0] := 1.0
				Result := 0
			else
				l_factor := 1.0
				l_ratio := a_n.to_real_64 / (a_n.to_real_64 + 1.0)
				a_w.item.sum_plain := a_w.item.sum_plain + a_term
				a_w.item.q_den[a_n.to_integer_32] := 1.0 / ((a_term * (a_n.to_real_64 + 1.0)) * (a_n.to_real_64 + 1.0))
				a_w.item.q_num[a_n.to_integer_32] := a_w.item.sum_plain * a_w.item.q_den[a_n.to_integer_32]
				l_j := (a_n - {NATURAL_32} 1).to_integer_32
				from
				until
					not (l_j >= 0)
				loop
					l_c___1 := (l_factor * (l_j + 1).to_double) / (a_n + {NATURAL_32} 1).to_real_64
					l_factor := l_factor * l_ratio
					a_w.item.q_den[l_j] := a_w.item.q_den[(l_j + 1)] - l_c___1 * a_w.item.q_den[l_j]
					a_w.item.q_num[l_j] := a_w.item.q_num[(l_j + 1)] - l_c___1 * a_w.item.q_num[l_j]
					l_j := l_j - 1
				end
				a_sum_accel.item := a_w.item.q_num[0] / a_w.item.q_den[0]
				Result := 0
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			i := a_other.i
			terms_used := a_other.terms_used
			sum_plain := a_other.sum_plain
			q_num := a_other.q_num
			q_den := a_other.q_den
			dsum := a_other.dsum
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				i = a_other.i and
				terms_used = a_other.terms_used and
				sum_plain = a_other.sum_plain and
				q_num.is_equal (a_other.q_num) and
				q_den.is_equal (a_other.q_den) and
				dsum.is_equal (a_other.dsum)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("i"),
					create {CE_STRUCTURE_FIELD}.make ("terms_used"),
					create {CE_STRUCTURE_FIELD}.make ("sum_plain"),
					create {CE_STRUCTURE_FIELD}.make ("q_num"),
					create {CE_STRUCTURE_FIELD}.make ("q_den"),
					create {CE_STRUCTURE_FIELD}.make ("dsum")
				>>)
			init_structure_info
		end

end
