class
	PD_MRG_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	x1: INTEGER_32 assign set_x1

	x2: INTEGER_32 assign set_x2

	x3: INTEGER_32 assign set_x3

	x4: INTEGER_32 assign set_x4

	x5: INTEGER_32 assign set_x5

feature {ANY} -- field setters

	set_x1 (a_x1: INTEGER_32)
		do
			x1 := a_x1
			update_memory_field ("x1")
		end

	set_x2 (a_x2: INTEGER_32)
		do
			x2 := a_x2
			update_memory_field ("x2")
		end

	set_x3 (a_x3: INTEGER_32)
		do
			x3 := a_x3
			update_memory_field ("x3")
		end

	set_x4 (a_x4: INTEGER_32)
		do
			x4 := a_x4
			update_memory_field ("x4")
		end

	set_x5 (a_x5: INTEGER_32)
		do
			x5 := a_x5
			update_memory_field ("x5")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x1 := a_other.x1
			x2 := a_other.x2
			x3 := a_other.x3
			x4 := a_other.x4
			x5 := a_other.x5
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x1 = a_other.x1 and
				x2 = a_other.x2 and
				x3 = a_other.x3 and
				x4 = a_other.x4 and
				x5 = a_other.x5
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x1"),
					create {CE_STRUCTURE_FIELD}.make ("x2"),
					create {CE_STRUCTURE_FIELD}.make ("x3"),
					create {CE_STRUCTURE_FIELD}.make ("x4"),
					create {CE_STRUCTURE_FIELD}.make ("x5")
				>>)
			init_structure_info
		end

end
