class
	PD_RK8PD_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_POINTER_ARRAY [REAL_64]} k.make (<<13>>)
			create {CE_REAL_64_POINTER} ytmp.make
			create {CE_REAL_64_POINTER} y0.make
		end

feature {ANY} -- fields

	k: CE_ARRAY [CE_POINTER [REAL_64]]

	ytmp: CE_POINTER [REAL_64] assign set_ytmp

	y0: CE_POINTER [REAL_64] assign set_y0

feature {ANY} -- field setters

	set_ytmp (a_ytmp: CE_POINTER [REAL_64])
		do
			ytmp := a_ytmp
			update_memory_field ("ytmp")
		end

	set_y0 (a_y0: CE_POINTER [REAL_64])
		do
			y0 := a_y0
			update_memory_field ("y0")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			k := a_other.k.twin
			ytmp := a_other.ytmp
			y0 := a_other.y0
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				k.is_equal (a_other.k) and
				ytmp.is_equal (a_other.ytmp) and
				y0.is_equal (a_other.y0)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("k", <<13>>),
					create {CE_STRUCTURE_FIELD}.make ("ytmp"),
					create {CE_STRUCTURE_FIELD}.make ("y0")
				>>)
			init_structure_info
		end

end
