class
	PD_STEEPEST_DESCENT_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} x1.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} g1.make
		end

feature {ANY} -- fields

	step: REAL_64 assign set_step

	max_step: REAL_64 assign set_max_step

	tol: REAL_64 assign set_tol

	x1: CE_POINTER [PD_GSL_VECTOR] assign set_x1

	g1: CE_POINTER [PD_GSL_VECTOR] assign set_g1

feature {ANY} -- field setters

	set_step (a_step: REAL_64)
		do
			step := a_step
			update_memory_field ("step")
		end

	set_max_step (a_max_step: REAL_64)
		do
			max_step := a_max_step
			update_memory_field ("max_step")
		end

	set_tol (a_tol: REAL_64)
		do
			tol := a_tol
			update_memory_field ("tol")
		end

	set_x1 (a_x1: CE_POINTER [PD_GSL_VECTOR])
		do
			x1 := a_x1
			update_memory_field ("x1")
		end

	set_g1 (a_g1: CE_POINTER [PD_GSL_VECTOR])
		do
			g1 := a_g1
			update_memory_field ("g1")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			step := a_other.step
			max_step := a_other.max_step
			tol := a_other.tol
			x1 := a_other.x1
			g1 := a_other.g1
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				step = a_other.step and
				max_step = a_other.max_step and
				tol = a_other.tol and
				x1.is_equal (a_other.x1) and
				g1.is_equal (a_other.g1)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("step"),
					create {CE_STRUCTURE_FIELD}.make ("max_step"),
					create {CE_STRUCTURE_FIELD}.make ("tol"),
					create {CE_STRUCTURE_FIELD}.make ("x1"),
					create {CE_STRUCTURE_FIELD}.make ("g1")
				>>)
			init_structure_info
		end

end
