class
	PD_MAP_CONTEXT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_GCC_BUILTIN_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_BITS_ERRNO_STATIC
		redefine
			copy,
			is_equal
		end
	S_CTYPE_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} text.make
			create {CE_INTEGER_8_POINTER} base.make
			create {CE_INTEGER_8_POINTER} parent_base.make
			create {CE_INTEGER_8_POINTER} document_file.make
			create {CE_CLASS_POINTER [PD_URLPOS]} head.make
			create {CE_CLASS_POINTER [PD_URLPOS]} tail.make
			Precursor
		end

feature {ANY} -- fields

	text: CE_POINTER [INTEGER_8] assign set_text

	base: CE_POINTER [INTEGER_8] assign set_base

	parent_base: CE_POINTER [INTEGER_8] assign set_parent_base

	document_file: CE_POINTER [INTEGER_8] assign set_document_file

	nofollow: BOOLEAN assign set_nofollow

	head: CE_POINTER [PD_URLPOS] assign set_head

	tail: CE_POINTER [PD_URLPOS] assign set_tail

feature {ANY} -- field setters

	set_text (a_text: CE_POINTER [INTEGER_8])
		do
			text := a_text
			update_memory_field ("text")
		end

	set_base (a_base: CE_POINTER [INTEGER_8])
		do
			base := a_base
			update_memory_field ("base")
		end

	set_parent_base (a_parent_base: CE_POINTER [INTEGER_8])
		do
			parent_base := a_parent_base
			update_memory_field ("parent_base")
		end

	set_document_file (a_document_file: CE_POINTER [INTEGER_8])
		do
			document_file := a_document_file
			update_memory_field ("document_file")
		end

	set_nofollow (a_nofollow: BOOLEAN)
		do
			nofollow := a_nofollow
			update_memory_field ("nofollow")
		end

	set_head (a_head: CE_POINTER [PD_URLPOS])
		do
			head := a_head
			update_memory_field ("head")
		end

	set_tail (a_tail: CE_POINTER [PD_URLPOS])
		do
			tail := a_tail
			update_memory_field ("tail")
		end

feature {PD_MAP_CONTEXT} -- private attributes

	yy_ec: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					0, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 1, 4, 5, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 6,
					7, 8, 9, 10, 11, 10, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30,
					10, 10, 31, 32, 33, 10, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 44, 51,
					52, 53, 54, 44, 44, 55, 44, 56, 10, 57, 10, 10, 44, 10, 58, 59, 60, 61, 62, 40, 63, 64, 65, 44, 66,
					67, 68, 69, 70, 71, 44, 72, 73, 74, 75, 44, 44, 76, 44, 77, 78, 79, 10, 80, 1, 81, 81, 81, 81, 81,
					81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
					81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
					81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
					81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81,
					81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81
				>>)
		end

	yy_accept: CE_STATIC [CE_ARRAY [INTEGER_16]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_16_ARRAY}.make_initialized (<<
					0, 0, 0, 43, 41, 1, 1, 41, 12, 41, 12, 8, 10, 41, 41, 41, 37, 41, 9, 41, 13, 13, 41, 7, 41, 41, 0,
					8, 10, 0, 9, 7, 0, 0, 0, 12, 11, 0, 14, 0, 12, 0, 0, 13, 0, 37, 0, 36, 0, 0, 37, 35, 35, 35, 35,
					35, 35, 35, 35, 35, 35, 35, 32, 0, 0, 0, 0, 0, 0, 40, 13, 0, 13, 13, 13, 6, 5, 0, 0, 0, 12, 12, 12,
					14, 14, 12, 12, 12, 4, 0, 0, 0, 35, 0, 23, 0, 35, 0, 20, 21, 0, 35, 0, 33, 0, 25, 0, 35, 0, 24, 31,
					0, 27, 26, 22, 0, 35, 0, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 32, 0, 0, 0, 0,
					0, 13, 13, 13, 13, 13, 0, 0, 0, 0, 0, 12, 12, 12, 14, 14, 12, 12, 12, 0, 2, 35, 35, 35, 35, 35, 23,
					28, 0, 35, 35, 35, 35, 35, 35, 35, 35, 20, 21, 35, 0, 35, 35, 35, 35, 35, 35, 35, 33, 35, 35, 35,
					25, 34, 0, 35, 35, 35, 35, 35, 35, 35, 35, 35, 24, 31, 35, 35, 35, 35, 35, 26, 22, 29, 0, 35, 35,
					35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 32, 35, 35, 3, 0, 0, 0, 0,
					13, 13, 40, 13, 0, 0, 0, 12, 14, 12, 0, 0, 35, 35, 35, 35, 35, 23, 23, 35, 35, 35, 28, 35, 35, 35,
					35, 35, 35, 35, 35, 35, 20, 21, 20, 30, 0, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 33, 33, 35, 35,
					35, 25, 25, 35, 35, 35, 34, 35, 35, 35, 35, 35, 35, 35, 35, 35, 24, 31, 24, 35, 35, 35, 35, 35, 27,
					26, 22, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35,
					32, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 27, 35, 35,
					35, 32, 32, 0, 0, 0, 16, 13, 0, 0, 0, 0, 39, 0, 0, 13, 0, 0, 0, 0, 0, 12, 14, 12, 35, 35, 35, 35,
					23, 23, 23, 23, 35, 35, 35, 28, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 20, 21, 20, 20, 20, 21,
					21, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 33, 33, 33, 33, 35, 35, 35,
					25, 25, 25, 25, 35, 35, 35, 34, 34, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 24, 31, 24, 24, 24,
					31, 31, 35, 35, 35, 35, 35, 27, 26, 22, 27, 27, 26, 26, 22, 22, 35, 35, 35, 29, 35, 35, 35, 35, 35,
					35, 29, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 32, 35, 35, 35, 27, 35, 29,
					0, 0, 17, 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 13, 0, 12, 14, 12, 35, 35, 35, 35, 23,
					23, 35, 35, 35, 28, 28, 28, 35, 35, 35, 35, 35, 35, 35, 35, 35, 20, 21, 20, 35, 35, 35, 30, 35, 35,
					35, 35, 35, 35, 30, 35, 35, 35, 35, 35, 30, 35, 35, 35, 33, 33, 35, 35, 35, 25, 25, 35, 35, 35, 34,
					34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 35, 35, 24, 31, 24, 35, 35, 35, 35, 35, 27, 26, 22, 35, 35,
					35, 29, 29, 29, 35, 35, 35, 35, 29, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 32,
					35, 35, 35, 27, 35, 29, 0, 15, 13, 0, 0, 0, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0,
					13, 0, 12, 14, 12, 35, 35, 35, 23, 23, 35, 35, 35, 28, 35, 35, 35, 35, 35, 35, 35, 20, 21, 20, 35,
					35, 35, 30, 30, 30, 35, 35, 35, 35, 35, 35, 35, 35, 30, 35, 35, 33, 33, 35, 35, 25, 25, 35, 35, 35,
					34, 34, 35, 35, 35, 35, 35, 35, 35, 24, 31, 24, 35, 35, 35, 35, 27, 26, 22, 35, 35, 35, 29, 35, 35,
					35, 29, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 32, 35, 35, 35, 27, 35, 29, 0, 13, 0, 0, 0, 0,
					39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 35,
					23, 23, 35, 35, 28, 35, 20, 21, 20, 35, 35, 35, 30, 35, 35, 35, 35, 35, 30, 33, 33, 25, 25, 35, 35,
					34, 34, 35, 24, 31, 24, 27, 26, 22, 35, 35, 29, 35, 29, 18, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0,
					39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 39,
					0, 0, 0, 0, 0, 19, 28, 35, 35, 30, 35, 34, 34, 29, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 0, 39, 0,
					0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 39, 0, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 38, 0, 39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0,
					0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0
				>>)
		end

	yy_meta: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					0, 1, 2, 3, 3, 3, 2, 4, 5, 4, 4, 4, 5, 6, 4, 4, 4, 4, 7, 4, 4, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 4, 4,
					4, 4, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
					9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 4, 4, 4, 9
				>>)
		end

	yy_base: CE_STATIC [CE_ARRAY [INTEGER_16]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_16_ARRAY}.make_initialized (<<
					0, 0, 0, 3_517, 17_264, 80, 85, 104, 84, 3_459, 81, 17_264, 17_264, 76, 127, 3_494, 159, 3_501, 17_264,
					200, 82, 225, 277, 17_264, 3_474, 3_462, 250, 17_264, 17_264, 3_478, 17_264, 17_264, 125, 3_456,
					51, 103, 17_264, 337, 3_413, 379, 87, 439, 3_436, 102, 481, 265, 3_453, 17_264, 3_400, 297, 0, 3_399,
					57, 64, 204, 65, 115, 200, 78, 377, 294, 108, 3_398, 543, 3_416, 70, 93, 84, 204, 17_264, 119, 604,
					365, 228, 665, 17_264, 17_264, 3_418, 3_417, 192, 273, 326, 726, 3_363, 787, 105, 368, 848, 17_264,
					3_404, 159, 890, 3_361, 943, 3_353, 985, 328, 363, 3_352, 3_351, 630, 275, 875, 3_321, 690, 3_320,
					465, 336, 1_008, 3_319, 3_318, 1_013, 3_310, 3_308, 3_307, 1_036, 390, 468, 3_306, 1_111, 427, 1_069,
					501, 397, 715, 207, 414, 425, 595, 877, 720, 603, 3_297, 3_335, 238, 386, 318, 386, 295, 1_172, 296,
					825, 1_214, 3_326, 229, 3_324, 328, 410, 337, 480, 1_256, 188, 1_298, 332, 642, 1_340, 3_323, 1_387,
					3_275, 1_464, 460, 385, 485, 3_274, 3_260, 1_384, 654, 3_289, 3_283, 774, 611, 3_266, 612, 3_265,
					3_223, 3_215, 721, 812, 329, 3_248, 3_240, 639, 686, 618, 675, 3_204, 747, 682, 742, 3_189, 3_180,
					1_136, 809, 3_207, 3_197, 741, 836, 768, 3_199, 781, 3_188, 3_141, 3_132, 963, 3_164, 249, 3_163,
					357, 3_129, 3_122, 3_121, 1_053, 868, 3_149, 3_147, 427, 1_506, 971, 1_412, 1_099, 820, 1_161, 1_567,
					1_550, 1_340, 1_572, 1_580, 1_598, 1_628, 1_647, 1_719, 1_794, 1_212, 1_674, 1_737, 17_264, 463,
					771, 670, 793, 891, 1_851, 1_745, 1_893, 3_136, 3_135, 840, 1_935, 1_977, 2_019, 3_128, 406, 840,
					2_061, 898, 829, 860, 1_064, 1_150, 1_027, 3_112, 3_104, 3_073, 1_050, 3_102, 3_093, 1_454, 1_198,
					875, 3_089, 890, 3_087, 1_253, 1_258, 1_295, 3_048, 2_103, 1_081, 3_081, 3_079, 918, 3_071, 3_068,
					1_503, 931, 942, 958, 1_300, 1_305, 1_326, 955, 956, 1_379, 1_424, 1_030, 984, 991, 3_021, 1_327,
					3_043, 3_036, 1_656, 1_396, 998, 3_040, 1_050, 3_039, 1_472, 1_477, 1_510, 1_661, 3_032, 655, 3_030,
					778, 1_545, 1_724, 1_758, 1_385, 3_021, 2_981, 1_424, 2_983, 2_977, 1_844, 2_145, 1_680, 1_806, 1_871,
					1_106, 1_913, 2_206, 2_189, 2_211, 2_218, 2_235, 2_291, 2_304, 2_317, 2_389, 2_464, 1_974, 2_323,
					2_331, 1_035, 1_687, 1_209, 1_559, 1_843, 1_733, 2_295, 1_109, 1_554, 1_102, 1_441, 1_386, 1_415,
					1_163, 1_653, 1_646, 2_215, 2_329, 2_359, 1_786, 1_171, 1_606, 2_403, 2_932, 863, 1_194, 1_217, 1_145,
					17_264, 2_502, 2_492, 2_563, 712, 748, 17_264, 2_576, 2_633, 2_713, 2_973, 756, 2_954, 820, 1_276,
					2_774, 2_835, 2_915, 2_957, 1_644, 1_184, 1_227, 1_765, 1_835, 2_878, 971, 1_647, 2_900, 2_887, 1_856,
					1_756, 2_888, 2_887, 2_513, 1_331, 2_185, 1_921, 1_252, 2_840, 1_294, 2_839, 1_979, 1_984, 2_016,
					2_810, 973, 2_798, 1_028, 2_002, 2_829, 2_826, 2_003, 2_786, 2_784, 2_448, 1_587, 2_770, 2_740, 2_058,
					1_523, 2_099, 1_358, 1_797, 1_461, 1_505, 2_063, 2_068, 2_688, 1_284, 2_082, 1_548, 1_560, 2_108,
					2_142, 2_687, 1_534, 2_132, 1_585, 1_700, 2_194, 2_311, 2_222, 2_704, 2_702, 2_405, 1_729, 2_173,
					2_328, 1_714, 2_701, 1_765, 2_608, 2_469, 2_474, 2_541, 2_561, 1_680, 2_560, 1_688, 2_530, 2_565,
					1_613, 2_563, 1_753, 2_595, 2_600, 2_605, 2_529, 1_697, 2_528, 1_788, 2_502, 2_047, 2_234, 2_527,
					2_495, 2_610, 2_320, 2_492, 2_486, 2_724, 1_847, 2_216, 0, 2_999, 1_899, 2_730, 2_598, 2_791, 2_821,
					3_005, 3_038, 2_998, 3_045, 3_065, 3_077, 3_084, 3_133, 3_205, 3_156, 2_955, 3_161, 3_170, 2_905,
					1_941, 3_167, 2_124, 1_804, 1_361, 17_264, 3_261, 3_227, 3_322, 857, 3_341, 3_377, 918, 3_437, 3_499,
					3_354, 3_518, 3_531, 3_556, 3_575, 3_631, 3_693, 3_773, 1_975, 3_834, 3_876, 3_937, 3_979, 148, 1_973,
					2_014, 2_625, 2_718, 2_352, 2_474, 2_465, 2_820, 2_427, 2_048, 250, 2_433, 2_430, 3_251, 2_274, 2_015,
					2_389, 2_056, 2_371, 2_920, 2_961, 3_105, 2_396, 2_372, 2_351, 3_151, 2_413, 2_348, 2_335, 3_272,
					2_098, 2_729, 0, 504, 2_308, 2_301, 3_386, 2_382, 0, 620, 2_060, 2_119, 3_264, 3_300, 960, 2_139,
					2_140, 3_346, 3_367, 2_250, 2_246, 2_309, 3_381, 3_391, 2_227, 2_132, 1_104, 2_241, 2_231, 3_544,
					2_508, 2_337, 2_221, 2_364, 2_211, 3_420, 3_425, 3_443, 2_567, 2_201, 1_779, 2_163, 1_799, 3_448,
					3_476, 3_481, 2_486, 2_161, 2_001, 3_486, 1_968, 2_187, 1_118, 1_986, 1_970, 3_624, 0, 4_021, 3_579,
					1_350, 3_790, 2_424, 3_819, 4_027, 3_876, 4_018, 3_978, 3_922, 4_068, 4_089, 4_094, 4_102, 3_644,
					4_110, 4_124, 2_248, 0, 2_708, 0, 1_379, 17_264, 4_177, 1_976, 4_239, 4_258, 17_264, 1_920, 1_405,
					2_398, 4_295, 1_061, 3_072, 4_356, 1_887, 4_265, 4_418, 1_878, 4_475, 4_532, 4_589, 4_288, 4_669,
					4_730, 1_548, 3_784, 4_772, 4_814, 4_856, 2_420, 2_449, 3_670, 3_778, 1_918, 1_855, 1_835, 3_841,
					1_791, 1_790, 4_115, 2_512, 1_763, 2_709, 1_744, 3_915, 3_951, 3_983, 2_767, 1_721, 1_711, 4_180,
					1_661, 2_261, 2_081, 1_689, 1_675, 4_220, 1_661, 1_631, 4_307, 2_726, 0, 2_726, 2_770, 4_185, 4_225,
					2_768, 2_804, 4_334, 4_344, 2_304, 2_912, 2_913, 4_367, 4_395, 1_618, 1_596, 4_405, 2_953, 1_582,
					3_038, 1_555, 4_400, 4_437, 4_442, 1_535, 1_878, 1_515, 2_227, 4_447, 4_452, 4_461, 2_388, 1_496,
					1_495, 4_466, 1_442, 1_432, 4_501, 0, 4_494, 4_506, 4_511, 4_853, 4_862, 4_769, 4_518, 4_682, 4_899,
					4_920, 4_524, 4_812, 4_934, 4_956, 4_979, 4_984, 5_012, 5_028, 1_440, 4_574, 1_371, 1_334, 5_041,
					5_085, 1_325, 5_142, 5_199, 5_256, 1_324, 1_453, 3_090, 5_336, 1_616, 3_111, 5_397, 1_064, 1_316,
					1_315, 5_060, 5_459, 1_297, 5_104, 5_516, 5_597, 5_654, 5_711, 5_768, 5_825, 5_882, 5_939, 5_996,
					6_058, 6_138, 1_628, 5_123, 5_128, 5_133, 6_199, 0, 4_674, 5_165, 5_170, 5_189, 5_347, 6_241, 2_476,
					2_547, 4_713, 359, 1_922, 5_438, 5_381, 5_443, 5_616, 5_621, 5_626, 5_631, 5_636, 3_069, 3_142, 4_775,
					4_817, 5_641, 5_646, 5_702, 5_730, 5_735, 5_740, 5_745, 139, 2_315, 5_227, 5_751, 5_758, 17_264,
					2_265, 1_206, 1_176, 5_233, 6_303, 1_175, 5_844, 6_360, 6_441, 6_498, 6_555, 6_612, 6_669, 6_726,
					6_783, 6_840, 6_902, 1_104, 2_407, 6_982, 7_043, 2_417, 1_094, 2_468, 5_482, 1_086, 1_072, 7_105,
					7_162, 7_219, 7_276, 7_357, 7_414, 7_471, 7_528, 7_585, 7_642, 7_699, 0, 1_022, 5_851, 7_761, 1_012,
					7_818, 7_875, 7_956, 8_013, 8_074, 17_264, 5_815, 8_135, 0, 4_739, 5_871, 5_901, 5_908, 5_913, 2_533,
					971, 2_914, 5_958, 945, 934, 8_197, 8_254, 8_311, 8_368, 8_449, 8_506, 8_563, 8_620, 8_677, 8_734,
					8_791, 0, 923, 6_322, 8_853, 912, 8_910, 8_967, 9_048, 9_105, 884, 9_166, 9_227, 9_289, 3_100, 9_346,
					9_403, 9_460, 877, 3_129, 6_329, 853, 816, 9_522, 9_579, 9_636, 9_693, 4_940, 3_607, 9_774, 9_831,
					9_888, 9_945, 10_002, 10_059, 10_116, 10_173, 0, 10_235, 10_315, 5_918, 3_182, 10_377, 10_434, 10_491,
					806, 3_184, 6_460, 764, 755, 10_553, 10_610, 10_667, 10_724, 10_805, 10_862, 10_919, 10_976, 11_033,
					11_090, 11_147, 0, 11_209, 730, 3_200, 11_270, 11_331, 11_393, 3_201, 11_474, 4_996, 6_467, 5_672,
					11_529, 4_271, 6_228, 11_589, 11_651, 11_708, 11_765, 11_827, 6_517, 11_908, 3_219, 11_989, 12_046,
					12_103, 12_165, 5_980, 6_284, 12_226, 6_524, 704, 694, 5_374, 6_574, 6_579, 12_286, 5_795, 4_706,
					6_587, 12_347, 5_922, 6_635, 12_407, 6_593, 3_587, 6_648, 12_468, 693, 6_692, 12_530, 668, 12_587,
					12_644, 12_725, 12_806, 12_868, 12_949, 13_030, 13_091, 3_220, 6_696, 6_745, 6_705, 13_151, 6_752,
					667, 632, 1_582, 2_941, 6_765, 5_044, 6_801, 13_212, 6_815, 6_824, 13_273, 6_630, 7_072, 13_333,
					2_080, 3_236, 7_123, 4_138, 7_127, 13_394, 7_140, 7_145, 13_455, 621, 3_229, 7_184, 620, 533, 13_517,
					13_574, 13_631, 13_688, 13_769, 13_826, 13_883, 13_940, 13_997, 14_054, 14_111, 0, 14_173, 14_254,
					14_311, 14_392, 14_473, 14_530, 532, 3_230, 7_238, 3_244, 7_188, 7_202, 7_375, 14_586, 14_647, 7_381,
					7_394, 7_398, 14_689, 14_731, 3_292, 14_793, 14_850, 14_887, 14_929, 14_971, 15_013, 523, 3_296,
					516, 5_487, 481, 457, 15_055, 15_097, 15_139, 15_181, 15_223, 15_265, 15_307, 405, 3_298, 17_264,
					397, 3_320, 15_349, 15_391, 15_433, 15_475, 15_517, 331, 296, 15_559, 15_601, 15_643, 15_685, 15_727,
					231, 178, 3_495, 15_769, 15_811, 15_853, 17_264, 15_915, 15_918, 15_927, 15_930, 15_934, 15_943,
					15_952, 15_961, 15_970, 15_979, 127, 15_982, 15_991, 16_000, 16_009, 16_018, 16_027, 16_036, 16_045,
					16_054, 16_062, 16_071, 16_080, 16_089, 16_098, 16_107, 16_116, 16_125, 16_134, 16_143, 16_152, 16_161,
					16_170, 16_179, 16_188, 16_197, 16_206, 16_215, 16_224, 16_232, 16_241, 16_250, 16_259, 16_268, 16_277,
					16_286, 16_295, 16_304, 16_313, 16_322, 16_331, 16_340, 16_349, 16_358, 16_367, 16_376, 16_385, 16_394,
					16_403, 16_412, 16_421, 16_430, 16_439, 16_448, 16_457, 16_466, 16_475, 16_484, 16_493, 16_501, 16_510,
					16_519, 16_528, 16_537, 16_546, 16_555, 16_564, 16_573, 16_582, 16_591, 16_600, 16_609, 16_618, 16_627,
					16_636, 16_645, 16_654, 16_663, 16_672, 16_680, 16_688, 16_697, 16_706, 16_715, 16_724, 16_733, 16_742,
					16_751, 16_760, 16_769, 16_778, 16_787, 16_796, 16_805, 16_814, 16_823, 16_832, 16_841, 16_850, 16_859,
					16_868, 16_877, 16_886, 16_894, 16_903, 16_912, 16_921, 16_930, 16_939, 16_948, 16_957, 16_966, 16_975,
					16_984, 16_993, 17_002, 17_011, 17_020, 17_029, 17_038, 17_047, 17_056, 17_065, 17_074, 17_083, 17_092,
					17_101, 17_110, 17_119, 17_128, 17_137, 17_146, 17_155, 17_164, 17_173, 17_182, 17_191, 17_200, 17_209,
					17_218, 17_227, 17_236, 17_245, 17_254
				>>)
		end

	yy_def: CE_STATIC [CE_ARRAY [INTEGER_16]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_16_ARRAY}.make_initialized (<<
					0, 1_152, 1, 1_152, 1_152, 1_152, 1_152, 1_152, 1_153, 1_154, 1_155, 1_152, 1_152, 1_156, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_157, 1_157, 1_158, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_153, 1_152, 1_159, 1_154, 1_160, 1_155, 1_161, 1_152,
					1_157, 1_158, 16, 1_162, 1_152, 1_163, 1_152, 16, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164,
					1_164, 1_164, 1_164, 1_164, 1_164, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_157, 1_165,
					1_157, 1_157, 1_157, 1_152, 1_152, 1_166, 1_167, 1_152, 1_153, 1_153, 1_153, 1_154, 1_154, 1_155,
					1_155, 1_155, 1_152, 1_162, 1_168, 63, 1_164, 1_169, 1_164, 1_169, 1_164, 95, 1_164, 1_164, 95, 1_164,
					95, 1_164, 95, 1_164, 95, 1_164, 95, 1_164, 1_164, 95, 1_164, 1_164, 1_164, 95, 1_164, 95, 1_164,
					1_164, 119, 119, 119, 121, 119, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_157, 74, 1_157, 1_157, 74, 1_166, 1_170, 1_167, 1_171, 1_152, 1_153, 1_153,
					82, 1_154, 84, 1_155, 1_155, 87, 1_172, 1_152, 1_164, 119, 159, 159, 159, 1_164, 1_164, 95, 159,
					159, 159, 159, 159, 159, 159, 159, 1_164, 1_164, 1_164, 95, 159, 159, 159, 1_164, 159, 159, 159,
					1_164, 159, 159, 159, 1_164, 1_164, 95, 159, 159, 159, 1_164, 159, 159, 159, 159, 159, 1_164, 1_164,
					159, 159, 159, 159, 159, 1_164, 1_164, 1_164, 95, 159, 159, 159, 1_164, 119, 216, 216, 216, 218,
					216, 216, 222, 222, 222, 222, 222, 222, 222, 222, 216, 231, 231, 222, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_157, 74, 1_173, 74, 1_174, 1_175, 1_152, 82, 152, 155, 1_172, 1_176, 1_164, 159, 253, 253,
					253, 253, 253, 159, 159, 159, 1_164, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
					1_164, 1_177, 159, 159, 159, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
					159, 159, 159, 1_164, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
					253, 253, 253, 253, 253, 159, 159, 159, 253, 253, 253, 253, 216, 325, 325, 325, 327, 325, 325, 331,
					331, 331, 331, 331, 331, 331, 331, 325, 340, 340, 331, 1_164, 1_164, 1_164, 1_164, 325, 1_164, 1_164,
					1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 325, 1_164, 1_164,
					325, 1_164, 1_164, 1_152, 1_152, 1_152, 1_152, 241, 1_173, 1_173, 1_178, 1_179, 1_152, 1_173, 1_152,
					373, 1_180, 1_181, 1_182, 1_183, 1_152, 1_184, 1_152, 1_185, 253, 390, 390, 390, 390, 390, 1_164,
					1_164, 253, 253, 253, 253, 390, 390, 390, 390, 1_164, 1_164, 390, 390, 390, 390, 390, 390, 390, 390,
					1_164, 1_164, 1_164, 1_164, 159, 159, 159, 253, 253, 253, 253, 390, 390, 390, 390, 1_164, 1_164,
					390, 390, 390, 390, 390, 390, 1_164, 1_164, 390, 390, 390, 390, 390, 1_164, 1_164, 253, 253, 253,
					253, 253, 390, 390, 390, 390, 1_164, 1_164, 390, 390, 390, 390, 390, 390, 390, 390, 1_164, 1_164,
					1_164, 1_164, 390, 390, 390, 390, 390, 390, 390, 390, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 253,
					253, 253, 253, 390, 390, 390, 390, 1_164, 1_164, 390, 325, 496, 496, 496, 496, 496, 496, 502, 502,
					502, 502, 502, 502, 502, 502, 496, 511, 511, 502, 496, 496, 496, 496, 1_152, 1_152, 1_152, 373, 1_152,
					1_173, 1_178, 1_152, 1_186, 1_179, 1_187, 1_188, 1_173, 1_173, 1_173, 1_173, 1_173, 1_173, 1_152,
					373, 1_152, 1_184, 388, 1_185, 390, 543, 543, 543, 543, 543, 390, 390, 390, 390, 1_164, 1_164, 543,
					543, 543, 543, 543, 543, 543, 543, 543, 543, 543, 543, 253, 253, 253, 253, 390, 390, 390, 390, 1_164,
					1_164, 390, 543, 543, 543, 543, 543, 543, 543, 543, 543, 543, 543, 543, 543, 543, 543, 543, 390,
					390, 390, 390, 390, 1_164, 1_164, 543, 543, 543, 543, 543, 543, 543, 543, 543, 543, 543, 543, 543,
					543, 543, 543, 543, 543, 543, 543, 390, 390, 390, 390, 1_164, 1_164, 543, 543, 543, 543, 543, 496,
					632, 632, 632, 632, 632, 632, 632, 632, 632, 632, 632, 632, 632, 632, 632, 632, 632, 632, 632, 632,
					632, 1_152, 1_152, 373, 1_152, 1_189, 1_152, 1_152, 1_152, 1_178, 1_178, 1_178, 1_179, 1_179, 1_179,
					1_190, 1_190, 1_188, 1_190, 1_191, 1_188, 1_152, 1_192, 1_192, 373, 1_152, 1_184, 541, 542, 543,
					682, 682, 682, 682, 543, 543, 543, 543, 682, 682, 682, 682, 682, 682, 682, 682, 682, 682, 390, 390,
					390, 390, 1_164, 1_164, 543, 543, 543, 543, 682, 682, 682, 682, 682, 682, 682, 682, 682, 682, 682,
					682, 682, 543, 543, 543, 543, 543, 682, 682, 682, 682, 682, 682, 682, 682, 682, 682, 682, 682, 682,
					682, 682, 682, 682, 543, 543, 543, 543, 682, 682, 682, 682, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164,
					1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_152, 677, 1_193,
					1_193, 1_193, 1_189, 1_193, 1_194, 1_189, 1_152, 1_195, 1_178, 1_178, 1_178, 1_179, 1_179, 1_179,
					1_196, 1_197, 1_198, 1_198, 1_199, 1_198, 1_192, 1_152, 1_200, 1_201, 1_201, 1_201, 1_201, 1_202,
					1_201, 1_201, 1_152, 1_192, 1_152, 1_164, 1_164, 1_164, 1_164, 811, 811, 1_164, 1_164, 1_164, 1_164,
					811, 818, 818, 818, 811, 811, 811, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 811, 811, 811,
					811, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 1_164, 811, 811, 811, 1_164, 1_164, 1_152, 1_203,
					1_204, 1_205, 1_205, 1_206, 1_205, 1_192, 1_152, 1_207, 1_208, 1_208, 1_208, 1_208, 1_209, 1_208,
					1_208, 1_152, 1_210, 1_211, 1_212, 1_213, 1_214, 1_215, 1_216, 1_215, 1_215, 1_215, 1_217, 1_218,
					1_217, 1_152, 1_217, 1_217, 1_217, 1_217, 1_218, 1_217, 1_217, 879, 1_219, 1_219, 1_220, 1_219, 1_208,
					1_152, 1_221, 1_221, 1_192, 1_152, 1_222, 1_222, 899, 899, 1_222, 1_222, 1_222, 1_222, 1_223, 1_224,
					1_225, 1_224, 1_224, 1_224, 1_226, 1_227, 1_226, 1_152, 1_226, 1_226, 1_226, 1_226, 1_227, 1_226,
					1_226, 915, 1_228, 1_228, 1_229, 1_228, 1_208, 1_152, 1_208, 1_208, 1_230, 1_231, 1_232, 1_208, 1_233,
					1_234, 1_235, 1_235, 1_236, 1_237, 1_236, 1_236, 1_236, 1_238, 1_239, 1_238, 1_152, 1_240, 1_241,
					1_208, 1_238, 1_238, 1_238, 1_238, 1_239, 1_238, 1_238, 948, 1_152, 1_242, 1_243, 1_244, 1_245, 1_246,
					1_246, 1_247, 1_248, 1_247, 1_247, 1_247, 1_249, 1_250, 1_249, 1_152, 1_249, 1_249, 1_249, 1_249,
					1_250, 1_249, 1_249, 975, 1_208, 1_251, 1_252, 1_253, 1_254, 1_152, 1_255, 1_256, 1_257, 1_258, 1_259,
					1_260, 1_261, 1_262, 1_263, 1_264, 1_265, 1_265, 1_152, 1_266, 1_152, 1_267, 1_268, 1_269, 1_269,
					1_152, 1_253, 1_254, 989, 1_258, 1_258, 1_258, 1_270, 1_271, 1_253, 1_272, 1_273, 1_273, 1_274, 1_273,
					1_275, 1_254, 1_276, 1_277, 1_277, 1_278, 1_277, 1_279, 1_279, 1_280, 1_279, 1_281, 1_152, 1_152,
					1_281, 1_152, 1_152, 1_152, 989, 1_282, 1_270, 1_271, 1_274, 1_272, 1_271, 1_271, 1_271, 1_283, 1_283,
					1_270, 1_270, 1_274, 1_270, 1_284, 1_284, 1_284, 1_285, 1_278, 1_286, 1_287, 1_287, 1_285, 1_285,
					1_278, 1_285, 1_288, 1_288, 1_288, 1_289, 1_290, 1_289, 1_289, 1_289, 1_291, 1_292, 1_291, 1_152,
					1_291, 1_291, 1_291, 1_291, 1_292, 1_291, 1_291, 1_080, 1_152, 1_293, 1_152, 1_152, 1_294, 1_295,
					1_296, 1_297, 1_298, 1_299, 1_284, 1_300, 1_300, 1_300, 1_284, 1_288, 1_285, 1_285, 1_068, 1_071,
					1_301, 1_302, 1_291, 1_087, 1_089, 1_091, 1_092, 1_296, 1_297, 1_303, 1_152, 1_298, 1_298, 1_102,
					1_103, 1_107, 1_108, 1_087, 1_089, 1_115, 1_303, 1_297, 1_152, 1_152, 1_304, 1_102, 1_103, 1_107,
					1_108, 1_087, 1_305, 1_306, 1_102, 1_103, 1_107, 1_108, 1_087, 1_305, 1_306, 1_297, 1_102, 1_107,
					1_087, 0, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152
				>>)
		end

	yy_nxt: CE_STATIC [CE_ARRAY [INTEGER_16]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_16_ARRAY}.make_initialized (<<
					0, 4, 5, 6, 5, 5, 5, 7, 8, 9, 4, 4, 10, 4, 4, 4, 11, 12, 13, 14, 15, 16, 16, 16, 16, 16, 16, 16,
					16, 16, 16, 17, 4, 18, 19, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
					20, 21, 20, 20, 22, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 21, 20, 20,
					23, 24, 25, 20, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 36, 36, 42, 69, 27, 28, 79, 36, 29, 27, 28,
					96, 94, 29, 32, 32, 32, 32, 32, 36, 134, 30, 95, 69, 101, 36, 30, 79, 107, 97, 102, 136, 33, 94,
					96, 32, 32, 32, 32, 32, 69, 44, 134, 108, 51, 101, 41, 71, 135, 37, 107, 116, 41, 33, 136, 34, 45,
					45, 45, 45, 45, 45, 45, 45, 45, 45, 31, 71, 37, 135, 41, 31, 905, 117, 116, 808, 34, 34, 47, 103,
					104, 683, 90, 684, 71, 48, 49, 157, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 34, 83, 103, 1_148, 51,
					51, 52, 53, 54, 51, 55, 56, 57, 51, 58, 51, 59, 51, 51, 60, 61, 62, 51, 51, 51, 51, 63, 51, 51, 52,
					53, 54, 55, 56, 57, 58, 51, 59, 51, 51, 60, 61, 62, 51, 51, 51, 51, 65, 69, 137, 51, 69, 147, 66,
					144, 39, 1_096, 67, 105, 26, 68, 98, 26, 26, 26, 26, 26, 106, 101, 99, 65, 100, 137, 147, 102, 66,
					27, 28, 67, 105, 29, 68, 98, 236, 316, 691, 72, 692, 317, 101, 99, 36, 71, 30, 1_152, 71, 45, 45,
					45, 45, 45, 45, 45, 45, 45, 45, 236, 72, 74, 74, 74, 74, 74, 74, 74, 74, 74, 74, 69, 242, 176, 1_148,
					74, 74, 74, 74, 74, 74, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 31, 35, 37, 112, 177, 176, 36, 74,
					74, 74, 74, 74, 35, 35, 81, 146, 36, 36, 1_096, 113, 32, 114, 280, 115, 71, 71, 112, 281, 238, 282,
					82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 113, 164, 114, 40, 82, 82, 82, 82, 82, 82, 69, 238, 36, 902,
					316, 37, 166, 165, 317, 808, 167, 41, 168, 164, 190, 191, 37, 82, 82, 82, 82, 82, 84, 84, 84, 84,
					84, 84, 84, 84, 84, 84, 158, 140, 1_139, 190, 84, 84, 84, 84, 84, 84, 1_130, 251, 71, 257, 109, 41,
					157, 239, 210, 110, 118, 158, 140, 233, 111, 234, 237, 84, 84, 84, 84, 84, 40, 40, 86, 109, 257,
					211, 217, 239, 110, 210, 217, 217, 217, 217, 233, 237, 234, 246, 87, 87, 87, 87, 87, 87, 87, 87,
					87, 87, 103, 104, 1_133, 105, 87, 87, 87, 87, 87, 87, 246, 254, 106, 80, 93, 255, 186, 256, 36, 212,
					187, 103, 188, 213, 105, 214, 867, 87, 87, 87, 87, 87, 74, 74, 74, 74, 74, 74, 74, 74, 74, 74, 158,
					189, 369, 158, 74, 74, 74, 74, 74, 74, 230, 258, 231, 232, 217, 217, 217, 217, 711, 1_130, 712, 158,
					189, 369, 158, 37, 1_117, 74, 74, 74, 74, 74, 118, 118, 258, 1_117, 1_109, 118, 118, 118, 118, 118,
					118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 119, 120, 120, 120, 121, 122, 123, 124, 120, 120,
					118, 118, 118, 118, 120, 120, 120, 120, 120, 120, 125, 126, 127, 118, 128, 118, 129, 118, 118, 130,
					131, 132, 118, 118, 118, 118, 118, 120, 120, 120, 120, 120, 125, 126, 127, 128, 118, 129, 118, 118,
					130, 131, 132, 118, 118, 118, 118, 118, 118, 118, 118, 139, 139, 139, 139, 139, 139, 139, 139, 139,
					139, 1_073, 1_073, 107, 116, 139, 139, 139, 139, 139, 139, 85, 716, 1_098, 717, 272, 274, 169, 108,
					287, 36, 170, 171, 172, 173, 107, 117, 116, 139, 139, 139, 139, 139, 73, 73, 73, 141, 73, 272, 274,
					176, 263, 287, 174, 69, 264, 477, 265, 908, 1_073, 478, 175, 142, 142, 142, 142, 142, 142, 142, 142,
					142, 142, 177, 176, 174, 41, 142, 142, 142, 142, 142, 142, 175, 284, 1_073, 1_043, 288, 182, 285,
					371, 286, 159, 183, 159, 184, 849, 526, 292, 71, 142, 142, 142, 142, 142, 148, 80, 80, 149, 148,
					288, 36, 371, 230, 158, 231, 232, 217, 217, 217, 217, 292, 986, 185, 150, 150, 150, 150, 150, 150,
					150, 150, 150, 150, 112, 158, 275, 526, 150, 150, 150, 150, 150, 150, 185, 289, 527, 1_005, 383,
					290, 113, 291, 114, 26, 115, 276, 968, 112, 293, 275, 37, 150, 150, 150, 150, 150, 83, 83, 83, 151,
					83, 113, 267, 114, 190, 191, 268, 269, 270, 271, 477, 293, 529, 307, 478, 152, 152, 152, 152, 152,
					152, 152, 152, 152, 152, 190, 309, 370, 968, 152, 152, 152, 152, 152, 152, 73, 307, 298, 990, 372,
					277, 299, 385, 300, 278, 69, 279, 32, 370, 309, 158, 39, 152, 152, 152, 152, 152, 153, 85, 85, 154,
					153, 372, 342, 302, 343, 158, 36, 303, 304, 305, 306, 526, 367, 394, 941, 155, 155, 155, 155, 155,
					155, 155, 155, 155, 155, 342, 158, 343, 71, 155, 155, 155, 155, 155, 155, 321, 394, 386, 941, 322,
					138, 323, 178, 93, 395, 986, 159, 179, 159, 180, 69, 41, 155, 155, 155, 155, 155, 120, 386, 413,
					527, 120, 120, 120, 120, 391, 93, 395, 158, 392, 109, 393, 181, 968, 415, 110, 526, 118, 118, 118,
					111, 118, 413, 118, 968, 427, 118, 118, 118, 158, 428, 109, 429, 181, 71, 963, 110, 415, 434, 118,
					118, 118, 118, 435, 118, 436, 908, 118, 118, 118, 159, 159, 159, 159, 159, 159, 159, 159, 159, 159,
					396, 529, 416, 437, 159, 159, 159, 159, 159, 159, 310, 720, 908, 721, 311, 312, 313, 314, 326, 438,
					444, 445, 326, 326, 326, 326, 437, 159, 159, 159, 159, 159, 160, 159, 159, 159, 161, 159, 162, 159,
					159, 159, 438, 444, 445, 451, 159, 159, 159, 159, 159, 159, 452, 941, 93, 192, 93, 418, 163, 193,
					196, 194, 464, 941, 197, 198, 199, 200, 451, 159, 159, 159, 159, 159, 398, 452, 195, 448, 399, 163,
					400, 158, 449, 203, 450, 464, 201, 204, 205, 206, 207, 202, 396, 396, 396, 397, 396, 402, 195, 526,
					318, 403, 158, 404, 319, 789, 320, 201, 94, 158, 374, 93, 202, 936, 466, 208, 217, 209, 95, 222,
					223, 224, 217, 225, 226, 227, 158, 872, 423, 94, 158, 228, 424, 229, 425, 872, 208, 466, 209, 118,
					118, 118, 215, 118, 529, 867, 339, 158, 340, 341, 326, 326, 326, 326, 228, 729, 229, 730, 216, 217,
					217, 217, 218, 219, 220, 221, 217, 217, 513, 750, 514, 751, 217, 217, 217, 217, 217, 217, 396, 396,
					396, 397, 396, 294, 103, 104, 101, 159, 295, 159, 296, 513, 102, 514, 93, 217, 217, 217, 217, 217,
					138, 138, 138, 240, 138, 103, 521, 101, 339, 158, 340, 341, 326, 326, 326, 326, 908, 908, 297, 241,
					241, 241, 241, 241, 241, 241, 241, 241, 241, 521, 158, 107, 116, 241, 241, 241, 241, 241, 241, 297,
					367, 367, 367, 368, 367, 408, 108, 906, 547, 409, 410, 411, 412, 107, 117, 116, 241, 241, 241, 241,
					241, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 547, 519, 326, 96, 243, 243, 243, 243, 243,
					243, 416, 416, 416, 417, 416, 418, 418, 418, 419, 418, 548, 97, 519, 520, 93, 326, 96, 243, 243,
					243, 243, 243, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 439, 548, 520, 564, 247, 247, 247,
					247, 247, 247, 416, 416, 416, 417, 416, 439, 439, 439, 440, 439, 439, 439, 439, 440, 439, 872, 564,
					247, 247, 247, 247, 247, 248, 248, 248, 248, 248, 248, 248, 248, 248, 248, 539, 872, 870, 566, 248,
					248, 248, 248, 248, 248, 867, 849, 93, 349, 349, 349, 350, 349, 441, 453, 849, 539, 442, 454, 443,
					455, 566, 248, 248, 248, 248, 248, 249, 249, 249, 249, 249, 249, 249, 249, 249, 249, 763, 164, 764,
					765, 249, 249, 249, 249, 249, 249, 446, 446, 446, 447, 446, 849, 98, 165, 26, 26, 26, 26, 26, 164,
					99, 583, 100, 249, 249, 249, 249, 249, 27, 28, 259, 485, 29, 98, 260, 486, 261, 487, 526, 655, 276,
					99, 459, 355, 583, 30, 460, 461, 462, 463, 262, 446, 446, 446, 447, 446, 158, 772, 326, 105, 655,
					331, 332, 333, 326, 334, 335, 336, 106, 353, 489, 848, 262, 337, 490, 338, 491, 158, 772, 846, 105,
					406, 406, 406, 407, 406, 526, 527, 105, 846, 31, 158, 158, 158, 252, 158, 337, 106, 338, 467, 467,
					467, 468, 467, 469, 469, 469, 470, 469, 105, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 164,
					587, 103, 104, 253, 253, 253, 253, 253, 253, 431, 431, 431, 432, 431, 527, 165, 467, 467, 467, 468,
					467, 164, 103, 587, 845, 845, 253, 253, 253, 253, 253, 325, 326, 326, 326, 327, 328, 329, 330, 326,
					326, 446, 433, 840, 588, 326, 326, 326, 326, 326, 326, 479, 479, 479, 480, 479, 346, 346, 346, 347,
					346, 351, 176, 840, 177, 433, 346, 588, 326, 326, 326, 326, 326, 344, 344, 344, 345, 344, 351, 351,
					351, 352, 351, 838, 177, 176, 353, 353, 353, 354, 353, 592, 326, 348, 526, 93, 326, 326, 326, 326,
					807, 92, 96, 593, 355, 355, 355, 356, 355, 101, 838, 97, 578, 364, 592, 102, 348, 579, 94, 580, 97,
					807, 92, 92, 597, 96, 593, 101, 95, 836, 101, 92, 526, 102, 357, 357, 357, 358, 357, 94, 103, 104,
					619, 527, 92, 116, 620, 597, 101, 92, 105, 836, 92, 359, 359, 359, 360, 359, 825, 106, 357, 103,
					457, 457, 457, 458, 457, 117, 116, 544, 92, 105, 549, 545, 107, 546, 550, 529, 551, 92, 357, 357,
					357, 358, 357, 897, 471, 467, 825, 108, 472, 473, 474, 475, 344, 469, 107, 109, 109, 107, 92, 824,
					110, 110, 479, 497, 897, 111, 111, 497, 497, 497, 497, 326, 108, 824, 190, 191, 109, 109, 107, 107,
					93, 110, 110, 361, 361, 361, 362, 361, 481, 481, 481, 482, 481, 108, 326, 190, 94, 598, 821, 93,
					107, 359, 359, 359, 360, 359, 95, 93, 821, 374, 374, 374, 374, 374, 610, 376, 93, 94, 363, 377, 598,
					378, 483, 483, 483, 484, 483, 379, 92, 396, 396, 396, 397, 396, 113, 816, 114, 610, 115, 555, 619,
					363, 98, 556, 620, 557, 109, 190, 191, 92, 99, 110, 100, 481, 816, 113, 111, 114, 364, 364, 364,
					365, 364, 98, 380, 612, 744, 109, 190, 497, 745, 99, 110, 497, 497, 497, 497, 326, 814, 814, 584,
					326, 326, 326, 326, 585, 744, 586, 612, 497, 745, 366, 502, 503, 504, 497, 505, 506, 507, 396, 396,
					396, 397, 396, 508, 654, 509, 93, 493, 493, 493, 494, 493, 117, 366, 138, 138, 138, 240, 138, 553,
					553, 553, 554, 553, 813, 497, 508, 654, 509, 497, 497, 497, 497, 373, 373, 373, 373, 373, 373, 373,
					373, 373, 373, 495, 813, 164, 210, 373, 373, 373, 373, 373, 373, 510, 789, 511, 512, 497, 497, 497,
					497, 165, 211, 789, 841, 211, 495, 164, 842, 210, 373, 373, 373, 373, 373, 381, 381, 381, 381, 381,
					381, 381, 381, 381, 381, 632, 632, 632, 632, 381, 381, 381, 381, 381, 381, 510, 782, 511, 512, 497,
					497, 497, 497, 559, 811, 902, 812, 560, 561, 562, 563, 808, 381, 381, 381, 381, 381, 387, 387, 387,
					387, 387, 387, 387, 387, 387, 387, 632, 632, 632, 632, 387, 387, 387, 387, 387, 387, 367, 367, 367,
					368, 367, 416, 416, 416, 417, 416, 418, 418, 418, 419, 418, 774, 752, 387, 387, 387, 387, 387, 388,
					388, 388, 388, 388, 388, 388, 388, 388, 388, 752, 497, 678, 685, 388, 388, 388, 388, 388, 388, 416,
					416, 416, 417, 416, 567, 571, 93, 749, 568, 572, 569, 573, 93, 497, 678, 685, 388, 388, 388, 388,
					388, 389, 389, 389, 389, 389, 389, 389, 389, 389, 389, 483, 553, 686, 698, 389, 389, 389, 389, 389,
					389, 431, 431, 431, 432, 431, 439, 439, 439, 440, 439, 439, 439, 439, 440, 439, 686, 698, 389, 389,
					389, 389, 389, 390, 390, 390, 390, 390, 390, 390, 390, 390, 390, 526, 582, 700, 718, 390, 390, 390,
					390, 390, 390, 431, 589, 93, 93, 822, 590, 823, 591, 446, 446, 446, 447, 446, 177, 582, 700, 718,
					390, 390, 390, 390, 390, 420, 159, 159, 159, 421, 159, 422, 159, 159, 159, 176, 599, 275, 529, 159,
					159, 159, 159, 159, 159, 446, 446, 446, 447, 446, 632, 632, 632, 632, 594, 719, 276, 177, 176, 595,
					275, 596, 159, 159, 159, 159, 159, 496, 497, 497, 497, 498, 499, 500, 501, 497, 497, 457, 719, 722,
					723, 497, 497, 497, 497, 497, 497, 749, 743, 406, 93, 625, 346, 346, 346, 347, 346, 599, 599, 599,
					600, 599, 722, 723, 497, 497, 497, 497, 497, 344, 344, 344, 345, 344, 349, 349, 349, 350, 349, 359,
					493, 351, 351, 351, 352, 351, 743, 164, 497, 515, 190, 191, 497, 497, 497, 497, 737, 92, 353, 353,
					353, 354, 353, 165, 601, 93, 737, 97, 602, 164, 603, 190, 515, 841, 94, 210, 621, 842, 92, 98, 622,
					731, 623, 109, 95, 705, 92, 99, 110, 100, 101, 731, 724, 111, 211, 94, 102, 725, 210, 726, 98, 849,
					727, 92, 109, 93, 523, 92, 99, 110, 164, 101, 103, 104, 355, 355, 355, 356, 355, 349, 694, 695, 696,
					697, 92, 727, 165, 357, 357, 357, 358, 357, 164, 103, 599, 599, 599, 600, 599, 93, 359, 359, 359,
					360, 359, 713, 357, 357, 357, 358, 357, 832, 713, 833, 359, 359, 359, 360, 359, 92, 105, 905, 627,
					98, 808, 728, 628, 107, 629, 106, 605, 99, 92, 100, 606, 607, 608, 609, 710, 497, 92, 105, 108, 361,
					98, 109, 107, 112, 728, 107, 110, 710, 99, 92, 687, 111, 736, 704, 688, 109, 689, 108, 497, 113,
					110, 114, 109, 115, 107, 111, 112, 110, 361, 361, 361, 362, 361, 112, 704, 736, 109, 699, 525, 738,
					113, 110, 114, 526, 457, 457, 457, 458, 457, 113, 843, 114, 844, 115, 701, 699, 112, 715, 702, 867,
					703, 497, 738, 516, 659, 497, 497, 497, 497, 789, 113, 707, 114, 92, 935, 708, 276, 709, 518, 113,
					715, 114, 763, 115, 764, 765, 516, 575, 575, 575, 576, 575, 527, 693, 92, 809, 693, 211, 190, 191,
					113, 518, 114, 364, 364, 364, 365, 364, 467, 467, 467, 468, 467, 469, 469, 469, 470, 469, 809, 190,
					872, 93, 497, 577, 810, 374, 497, 497, 497, 497, 690, 374, 374, 374, 374, 374, 517, 376, 901, 690,
					682, 377, 276, 378, 746, 630, 577, 810, 747, 379, 748, 630, 406, 406, 406, 407, 406, 624, 117, 517,
					522, 522, 522, 522, 522, 522, 522, 522, 522, 522, 732, 733, 734, 735, 522, 522, 522, 522, 522, 522,
					467, 467, 467, 468, 467, 849, 380, 815, 613, 624, 776, 164, 614, 615, 616, 617, 93, 522, 522, 522,
					522, 522, 523, 523, 523, 523, 523, 165, 1_152, 901, 815, 682, 1_152, 164, 378, 523, 523, 523, 523,
					523, 524, 1_152, 93, 93, 618, 1_152, 618, 378, 530, 739, 740, 741, 742, 524, 479, 479, 479, 480,
					479, 481, 481, 481, 482, 481, 483, 483, 483, 484, 483, 625, 625, 625, 626, 625, 93, 93, 645, 380,
					646, 647, 632, 632, 632, 632, 396, 396, 396, 397, 396, 611, 380, 531, 532, 523, 523, 523, 532, 533,
					531, 533, 533, 533, 531, 531, 534, 533, 533, 533, 533, 533, 535, 536, 536, 536, 536, 536, 536, 536,
					536, 536, 536, 533, 533, 533, 533, 536, 536, 536, 536, 536, 536, 533, 533, 533, 533, 533, 533, 533,
					533, 533, 533, 533, 533, 533, 533, 533, 533, 537, 536, 536, 536, 536, 536, 533, 533, 533, 533, 533,
					533, 533, 533, 533, 533, 533, 533, 533, 533, 533, 533, 533, 533, 533, 73, 73, 73, 141, 73, 396, 396,
					396, 397, 396, 611, 493, 493, 493, 494, 493, 604, 575, 604, 538, 538, 538, 538, 538, 538, 538, 538,
					538, 538, 93, 93, 771, 817, 538, 538, 538, 538, 538, 538, 637, 638, 639, 632, 640, 641, 642, 828,
					631, 581, 827, 211, 643, 275, 644, 771, 817, 538, 538, 538, 538, 538, 148, 80, 80, 149, 148, 211,
					36, 276, 828, 631, 276, 827, 818, 643, 275, 644, 819, 581, 820, 540, 540, 540, 540, 540, 540, 540,
					540, 540, 540, 829, 574, 830, 574, 540, 540, 540, 540, 540, 540, 637, 638, 639, 632, 640, 641, 642,
					553, 553, 553, 554, 553, 648, 829, 649, 830, 37, 540, 540, 540, 540, 540, 83, 83, 83, 151, 83, 645,
					831, 646, 647, 632, 632, 632, 632, 648, 570, 649, 38, 570, 93, 541, 541, 541, 541, 541, 541, 541,
					541, 541, 541, 831, 93, 565, 565, 541, 541, 541, 541, 541, 541, 38, 38, 38, 38, 38, 38, 38, 38, 38,
					38, 38, 38, 38, 38, 38, 38, 39, 541, 541, 541, 541, 541, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
					38, 38, 38, 38, 38, 558, 558, 552, 38, 153, 85, 85, 154, 153, 416, 416, 416, 417, 416, 36, 552, 908,
					632, 632, 632, 632, 523, 93, 542, 542, 542, 542, 542, 542, 542, 542, 542, 542, 164, 834, 835, 526,
					542, 542, 542, 542, 542, 542, 1_099, 367, 367, 367, 368, 367, 165, 418, 418, 418, 419, 418, 164,
					385, 834, 835, 41, 542, 542, 542, 542, 542, 543, 543, 543, 543, 543, 543, 543, 543, 543, 543, 383,
					93, 632, 837, 543, 543, 543, 543, 543, 543, 527, 492, 349, 349, 349, 350, 349, 492, 488, 344, 344,
					344, 345, 344, 93, 632, 837, 543, 543, 543, 543, 543, 632, 632, 632, 632, 633, 634, 635, 636, 632,
					632, 632, 632, 632, 632, 632, 632, 632, 632, 632, 632, 346, 346, 346, 347, 346, 98, 488, 351, 351,
					351, 352, 351, 94, 99, 476, 100, 476, 632, 632, 632, 632, 632, 95, 465, 465, 456, 98, 353, 353, 353,
					354, 353, 456, 94, 99, 528, 839, 650, 93, 355, 355, 355, 356, 355, 526, 92, 357, 357, 357, 358, 357,
					430, 92, 662, 430, 97, 101, 808, 526, 839, 650, 426, 102, 426, 903, 93, 92, 416, 416, 416, 417, 416,
					92, 92, 665, 941, 414, 101, 414, 405, 935, 103, 104, 526, 92, 105, 107, 903, 405, 529, 93, 92, 401,
					92, 106, 359, 359, 359, 360, 359, 401, 108, 103, 251, 941, 92, 105, 527, 107, 374, 385, 383, 92,
					705, 705, 705, 706, 705, 364, 364, 364, 365, 364, 357, 357, 357, 358, 357, 529, 324, 808, 324, 359,
					359, 359, 360, 359, 904, 93, 93, 109, 632, 632, 632, 632, 110, 93, 315, 315, 93, 111, 652, 632, 632,
					632, 632, 632, 968, 93, 968, 904, 109, 776, 107, 523, 653, 110, 361, 361, 361, 362, 361, 308, 117,
					652, 986, 941, 109, 108, 632, 659, 935, 110, 308, 211, 107, 301, 111, 653, 523, 523, 523, 523, 523,
					968, 1_096, 301, 93, 109, 776, 1_097, 378, 651, 110, 1_073, 1_096, 93, 657, 526, 374, 1_119, 1_104,
					92, 406, 406, 406, 407, 406, 113, 1_117, 114, 93, 115, 283, 1_097, 651, 439, 439, 439, 440, 439,
					283, 93, 92, 575, 575, 575, 576, 575, 113, 93, 114, 656, 656, 656, 656, 656, 656, 656, 656, 656,
					656, 164, 529, 273, 273, 656, 656, 656, 656, 656, 656, 439, 439, 439, 440, 439, 1_073, 165, 266,
					583, 1_117, 935, 1_130, 164, 266, 1_119, 93, 1_119, 656, 656, 656, 656, 656, 523, 523, 523, 523,
					523, 276, 1_152, 93, 93, 583, 1_152, 1_096, 378, 658, 251, 146, 1_013, 144, 524, 659, 659, 659, 659,
					659, 446, 446, 446, 447, 446, 235, 93, 660, 523, 523, 523, 523, 523, 661, 1_152, 93, 93, 93, 1_152,
					93, 378, 446, 446, 446, 447, 446, 524, 93, 93, 93, 93, 380, 525, 525, 663, 599, 599, 599, 600, 599,
					431, 431, 431, 432, 431, 599, 599, 599, 600, 599, 664, 664, 664, 664, 664, 664, 664, 664, 664, 664,
					93, 93, 93, 380, 664, 664, 664, 664, 664, 664, 93, 90, 39, 714, 467, 467, 467, 468, 467, 469, 469,
					469, 470, 469, 146, 144, 133, 664, 664, 664, 664, 664, 528, 528, 666, 177, 714, 467, 467, 467, 468,
					467, 479, 479, 479, 480, 479, 93, 93, 91, 667, 667, 667, 667, 667, 667, 667, 667, 667, 667, 90, 88,
					39, 78, 667, 667, 667, 667, 667, 667, 481, 481, 481, 482, 481, 483, 483, 483, 484, 483, 625, 625,
					625, 626, 625, 77, 76, 667, 667, 667, 667, 667, 668, 669, 669, 669, 669, 669, 75, 668, 64, 46, 1_148,
					668, 668, 671, 672, 1_119, 39, 1_152, 1_152, 673, 523, 523, 523, 523, 523, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 378, 523, 523, 523, 523, 523, 524, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					378, 457, 457, 457, 458, 457, 524, 1_152, 1_152, 1_152, 1_152, 674, 1_152, 523, 523, 523, 523, 523,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 378, 1_152, 1_152, 1_152, 1_152, 380, 524, 523,
					523, 523, 523, 523, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 380, 378, 658, 775, 775, 1_152, 1_152,
					524, 1_152, 1_152, 1_152, 993, 190, 191, 997, 755, 756, 757, 1_152, 758, 759, 760, 775, 775, 775,
					380, 1_152, 761, 1_152, 762, 1_152, 993, 1_152, 190, 997, 1_152, 1_152, 1_152, 493, 493, 493, 494,
					493, 1_152, 380, 532, 532, 532, 675, 532, 761, 1_152, 762, 1_152, 1_152, 1_152, 998, 378, 367, 367,
					367, 368, 367, 524, 676, 676, 676, 676, 676, 676, 676, 676, 676, 676, 753, 1_152, 998, 1_152, 676,
					676, 676, 676, 676, 676, 396, 396, 396, 397, 396, 1_152, 1_152, 1_152, 1_152, 211, 1_152, 1_152,
					1_152, 753, 1_152, 1_152, 380, 676, 676, 676, 676, 676, 531, 532, 523, 523, 523, 532, 533, 531, 533,
					533, 533, 531, 531, 534, 533, 533, 533, 533, 533, 535, 536, 536, 536, 536, 536, 536, 536, 536, 536,
					536, 533, 533, 533, 533, 536, 536, 536, 536, 536, 536, 533, 533, 533, 533, 533, 533, 533, 533, 533,
					533, 533, 533, 533, 533, 533, 533, 537, 536, 536, 536, 536, 536, 533, 533, 533, 533, 533, 533, 533,
					533, 533, 533, 533, 533, 533, 533, 533, 533, 533, 533, 533, 73, 73, 73, 141, 73, 396, 396, 396, 397,
					396, 1_152, 148, 80, 80, 149, 148, 1_152, 36, 1_152, 677, 677, 677, 677, 677, 677, 677, 677, 677,
					677, 1_152, 1_152, 1_152, 1_152, 677, 677, 677, 677, 677, 677, 755, 756, 757, 1_152, 758, 759, 760,
					344, 344, 344, 345, 344, 766, 1_152, 767, 1_152, 1_152, 677, 677, 677, 677, 677, 148, 80, 80, 149,
					148, 37, 36, 553, 553, 553, 554, 553, 1_152, 766, 1_152, 767, 1_152, 1_152, 1_152, 679, 679, 679,
					679, 679, 679, 679, 679, 679, 679, 1_152, 94, 1_152, 1_152, 679, 679, 679, 679, 679, 679, 1_152,
					95, 1_152, 349, 349, 349, 350, 349, 1_152, 1_152, 1_152, 1_152, 94, 1_152, 1_152, 1_152, 37, 679,
					679, 679, 679, 679, 680, 680, 680, 680, 680, 680, 680, 680, 680, 680, 1_152, 1_152, 1_152, 1_152,
					680, 680, 680, 680, 680, 680, 416, 416, 416, 417, 416, 1_152, 98, 355, 355, 355, 356, 355, 1_152,
					1_152, 99, 1_152, 100, 680, 680, 680, 680, 680, 153, 85, 85, 154, 153, 98, 1_152, 1_152, 1_152, 1_152,
					36, 1_152, 1_152, 99, 418, 418, 418, 419, 418, 681, 681, 681, 681, 681, 681, 681, 681, 681, 681,
					1_152, 1_152, 105, 1_152, 681, 681, 681, 681, 681, 681, 1_152, 106, 353, 353, 353, 354, 353, 416,
					416, 416, 417, 416, 1_152, 105, 1_152, 1_152, 41, 681, 681, 681, 681, 681, 682, 682, 682, 682, 682,
					682, 682, 682, 682, 682, 1_152, 1_152, 1_152, 1_152, 682, 682, 682, 682, 682, 682, 351, 351, 351,
					352, 351, 1_152, 1_152, 1_152, 1_152, 346, 346, 346, 347, 346, 103, 104, 1_152, 682, 682, 682, 682,
					682, 754, 754, 754, 754, 754, 754, 754, 754, 754, 754, 1_152, 1_152, 1_152, 103, 754, 754, 754, 754,
					754, 754, 1_152, 1_152, 1_152, 1_152, 768, 1_152, 1_152, 101, 357, 357, 357, 358, 357, 102, 1_152,
					1_152, 1_152, 754, 754, 754, 754, 754, 97, 1_152, 1_152, 1_152, 1_152, 768, 101, 359, 359, 359, 360,
					359, 361, 361, 361, 362, 361, 1_152, 1_152, 1_152, 364, 364, 364, 365, 364, 1_152, 107, 1_152, 357,
					357, 357, 358, 357, 406, 406, 406, 407, 406, 1_152, 1_152, 1_152, 108, 359, 359, 359, 360, 359, 769,
					107, 1_152, 1_152, 1_152, 109, 770, 1_152, 1_152, 1_152, 110, 907, 907, 1_152, 1_152, 111, 113, 1_152,
					114, 1_045, 115, 107, 1_061, 769, 1_152, 164, 109, 1_152, 117, 770, 1_152, 110, 1_152, 1_152, 1_152,
					1_152, 108, 113, 1_152, 114, 109, 165, 1_152, 107, 1_152, 110, 1_152, 164, 1_152, 1_152, 111, 705,
					705, 705, 706, 705, 439, 439, 439, 440, 439, 109, 1_152, 1_152, 1_062, 1_152, 110, 773, 773, 773,
					773, 773, 773, 773, 773, 773, 773, 1_152, 1_152, 1_152, 1_152, 773, 773, 773, 773, 773, 773, 1_152,
					1_152, 1_152, 1_152, 575, 575, 575, 576, 575, 439, 439, 439, 440, 439, 1_152, 1_152, 1_152, 773,
					773, 773, 773, 773, 775, 776, 776, 776, 776, 776, 1_152, 775, 1_152, 1_152, 1_152, 775, 775, 778,
					779, 1_152, 1_152, 1_152, 715, 780, 659, 659, 659, 659, 659, 1_152, 1_152, 669, 669, 669, 669, 669,
					660, 1_152, 775, 775, 775, 276, 661, 671, 789, 715, 1_152, 993, 1_152, 790, 997, 1_152, 1_152, 1_152,
					523, 532, 523, 523, 523, 1_152, 781, 783, 662, 662, 784, 783, 378, 526, 1_152, 1_152, 1_152, 1_152,
					524, 431, 431, 431, 432, 431, 1_152, 1_152, 785, 785, 785, 785, 785, 785, 785, 785, 785, 785, 1_152,
					1_152, 998, 1_152, 785, 785, 785, 785, 785, 785, 446, 446, 446, 447, 446, 1_152, 826, 1_152, 1_152,
					380, 446, 446, 446, 447, 446, 1_152, 527, 785, 785, 785, 785, 785, 786, 665, 665, 787, 786, 1_152,
					177, 826, 1_152, 1_152, 526, 599, 599, 599, 600, 599, 1_152, 1_152, 1_152, 788, 788, 788, 788, 788,
					788, 788, 788, 788, 788, 1_152, 1_152, 1_152, 1_152, 788, 788, 788, 788, 788, 788, 599, 599, 599,
					600, 599, 467, 467, 467, 468, 467, 457, 457, 457, 458, 457, 1_152, 529, 788, 788, 788, 788, 788,
					668, 669, 669, 669, 669, 669, 1_152, 668, 1_152, 1_152, 1_152, 668, 668, 671, 672, 1_152, 1_152,
					1_152, 1_152, 673, 469, 469, 469, 470, 469, 467, 467, 467, 468, 467, 479, 479, 479, 480, 479, 481,
					481, 481, 482, 481, 1_152, 1_152, 190, 191, 483, 483, 483, 484, 483, 625, 625, 625, 626, 625, 1_152,
					1_152, 674, 791, 792, 792, 792, 792, 792, 190, 791, 1_152, 1_152, 1_152, 791, 791, 794, 672, 1_152,
					1_152, 1_152, 1_152, 795, 118, 118, 118, 215, 118, 1_152, 1_152, 493, 493, 493, 494, 493, 344, 344,
					344, 345, 344, 346, 346, 346, 347, 346, 1_152, 1_152, 355, 355, 355, 356, 355, 1_152, 364, 364, 364,
					365, 364, 1_152, 796, 668, 669, 669, 669, 669, 669, 847, 668, 1_152, 1_152, 1_152, 668, 668, 671,
					797, 1_152, 1_152, 96, 93, 673, 94, 1_152, 1_152, 1_152, 1_152, 211, 116, 1_152, 1_152, 847, 95,
					1_152, 1_152, 105, 1_152, 97, 1_152, 1_152, 1_152, 1_152, 96, 94, 106, 138, 138, 138, 240, 138, 117,
					116, 1_152, 1_152, 1_152, 1_152, 105, 1_152, 674, 798, 799, 669, 669, 669, 799, 800, 798, 800, 800,
					800, 798, 798, 801, 802, 800, 800, 800, 800, 803, 804, 804, 804, 804, 804, 804, 804, 804, 804, 804,
					800, 800, 800, 800, 804, 804, 804, 804, 804, 804, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800,
					800, 800, 800, 800, 800, 800, 805, 804, 804, 804, 804, 804, 800, 800, 800, 800, 800, 800, 800, 800,
					800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 532, 532, 532, 675, 532, 553, 553, 553, 554,
					553, 1_152, 1_152, 378, 357, 357, 357, 358, 357, 524, 806, 806, 806, 806, 806, 806, 806, 806, 806,
					806, 1_152, 1_152, 808, 1_152, 806, 806, 806, 806, 806, 806, 775, 775, 1_152, 1_152, 993, 705, 705,
					705, 706, 705, 1_152, 994, 1_152, 1_152, 107, 1_152, 380, 806, 806, 806, 806, 806, 73, 73, 73, 141,
					73, 1_152, 682, 108, 682, 705, 705, 705, 706, 705, 107, 1_152, 1_152, 1_152, 1_152, 70, 70, 70, 70,
					70, 70, 70, 70, 70, 70, 1_152, 1_152, 995, 808, 70, 70, 70, 70, 70, 70, 353, 353, 353, 354, 353,
					1_152, 599, 599, 599, 600, 599, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 70, 70, 70, 70, 70, 38,
					38, 38, 38, 38, 38, 38, 38, 38, 38, 808, 1_152, 1_152, 1_152, 38, 38, 38, 38, 38, 38, 1_152, 367,
					367, 367, 368, 367, 599, 599, 599, 600, 599, 1_152, 103, 104, 1_152, 1_152, 1_152, 38, 38, 38, 38,
					38, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 808, 103, 1_152, 1_152, 40, 40, 40, 40, 40, 40, 349,
					349, 349, 350, 349, 1_152, 1_152, 1_152, 1_152, 351, 351, 351, 352, 351, 93, 1_152, 1_152, 40, 40,
					40, 40, 40, 808, 808, 808, 808, 808, 808, 808, 808, 808, 808, 1_152, 1_152, 1_152, 1_152, 808, 808,
					808, 808, 808, 808, 1_152, 1_152, 1_152, 98, 359, 359, 359, 360, 359, 1_152, 1_152, 99, 1_152, 100,
					1_152, 1_152, 101, 808, 808, 808, 808, 808, 102, 1_152, 98, 361, 361, 361, 362, 361, 1_152, 1_152,
					99, 1_152, 1_152, 1_152, 1_152, 101, 1_152, 357, 357, 357, 358, 357, 1_152, 1_152, 775, 775, 775,
					109, 1_152, 993, 1_152, 1_152, 110, 1_152, 1_152, 1_152, 994, 111, 112, 359, 359, 359, 360, 359,
					1_152, 1_152, 1_152, 1_152, 109, 1_152, 1_152, 1_152, 1_152, 110, 113, 1_152, 114, 107, 115, 1_152,
					1_152, 112, 118, 118, 118, 215, 118, 118, 118, 118, 215, 118, 108, 1_152, 1_152, 113, 1_152, 114,
					995, 107, 775, 775, 775, 1_152, 109, 993, 1_152, 1_152, 1_152, 110, 1_152, 1_152, 994, 1_152, 111,
					118, 118, 118, 215, 118, 1_152, 164, 1_152, 1_152, 1_152, 109, 1_152, 1_152, 1_152, 1_152, 110, 118,
					118, 118, 215, 118, 1_152, 165, 1_152, 1_152, 1_152, 1_152, 93, 164, 776, 776, 776, 776, 776, 907,
					907, 210, 1_152, 1_045, 995, 1_152, 778, 849, 1_152, 1_152, 1_046, 1_152, 850, 873, 873, 873, 873,
					873, 1_152, 1_152, 211, 1_152, 1_152, 1_152, 210, 874, 872, 1_152, 1_152, 1_152, 1_152, 875, 1_152,
					1_152, 1_152, 1_152, 93, 775, 776, 776, 776, 776, 776, 1_152, 775, 1_152, 1_152, 1_152, 775, 775,
					778, 779, 1_047, 1_152, 1_152, 1_152, 780, 374, 374, 374, 374, 374, 1_152, 376, 1_152, 1_152, 1_152,
					377, 1_152, 378, 658, 1_152, 1_152, 1_152, 1_152, 379, 158, 158, 158, 252, 158, 396, 396, 396, 397,
					396, 396, 396, 396, 397, 396, 1_152, 1_152, 781, 851, 852, 852, 852, 852, 852, 1_152, 851, 1_152,
					1_152, 1_152, 851, 851, 854, 779, 1_152, 1_152, 1_152, 380, 855, 1_152, 1_152, 1_152, 1_152, 406,
					406, 406, 407, 406, 416, 416, 416, 417, 416, 1_152, 1_152, 1_152, 93, 1_152, 1_152, 1_152, 1_152,
					93, 1_152, 1_152, 1_152, 1_152, 93, 418, 418, 418, 419, 418, 1_152, 1_152, 1_152, 856, 775, 776,
					776, 776, 776, 776, 164, 775, 1_152, 1_152, 1_152, 775, 775, 778, 857, 1_152, 1_152, 1_152, 1_152,
					780, 1_152, 1_152, 165, 1_152, 1_152, 1_152, 1_152, 93, 164, 625, 625, 625, 626, 625, 1_152, 909,
					909, 909, 909, 909, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 93, 910, 908, 1_152, 1_152, 1_152,
					1_152, 911, 1_152, 808, 781, 858, 859, 776, 776, 776, 859, 860, 858, 860, 860, 860, 858, 858, 861,
					862, 860, 860, 860, 860, 863, 864, 864, 864, 864, 864, 864, 864, 864, 864, 864, 860, 860, 860, 860,
					864, 864, 864, 864, 864, 864, 860, 860, 860, 860, 860, 860, 860, 860, 860, 860, 860, 860, 860, 860,
					860, 860, 865, 864, 864, 864, 864, 864, 860, 860, 860, 860, 860, 860, 860, 860, 860, 860, 860, 860,
					860, 860, 860, 860, 860, 860, 860, 783, 662, 662, 784, 783, 1_152, 526, 1_152, 1_152, 1_152, 1_152,
					416, 416, 416, 417, 416, 1_152, 1_152, 1_152, 868, 868, 868, 868, 868, 868, 868, 868, 868, 868, 1_152,
					1_152, 1_152, 1_152, 868, 868, 868, 868, 868, 868, 907, 907, 907, 1_152, 1_152, 1_045, 431, 431,
					431, 432, 431, 1_152, 1_046, 1_152, 1_152, 1_152, 527, 868, 868, 868, 868, 868, 786, 665, 665, 787,
					786, 93, 1_152, 1_152, 1_152, 1_152, 526, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 176, 1_152, 869,
					869, 869, 869, 869, 869, 869, 869, 869, 869, 1_152, 1_152, 1_152, 1_047, 869, 869, 869, 869, 869,
					869, 177, 176, 575, 575, 575, 576, 575, 158, 158, 158, 252, 158, 1_152, 1_152, 1_152, 1_152, 529,
					869, 869, 869, 869, 869, 871, 873, 873, 873, 873, 873, 808, 871, 1_152, 1_152, 1_152, 871, 871, 874,
					877, 1_152, 827, 1_152, 1_152, 878, 1_152, 275, 1_152, 1_152, 873, 873, 873, 873, 873, 1_119, 1_119,
					1_119, 1_119, 1_119, 1_152, 276, 874, 872, 1_152, 827, 276, 1_131, 875, 1_152, 275, 1_152, 1_152,
					1_132, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 879, 880, 881, 873, 873, 873, 881,
					882, 880, 882, 882, 882, 880, 880, 883, 884, 882, 882, 882, 882, 885, 886, 886, 886, 886, 886, 886,
					886, 886, 886, 886, 882, 882, 882, 882, 886, 886, 886, 886, 886, 886, 882, 882, 882, 882, 882, 882,
					882, 882, 882, 882, 882, 882, 882, 882, 882, 882, 887, 886, 886, 886, 886, 886, 882, 882, 882, 882,
					882, 882, 882, 882, 882, 882, 882, 882, 882, 882, 882, 882, 882, 882, 882, 888, 889, 889, 889, 889,
					889, 1_152, 888, 1_152, 1_152, 1_152, 888, 888, 891, 672, 1_152, 1_152, 1_152, 1_152, 892, 158, 158,
					158, 252, 158, 439, 439, 439, 440, 439, 439, 439, 439, 440, 439, 446, 446, 446, 447, 446, 446, 446,
					446, 447, 446, 457, 457, 457, 458, 457, 467, 467, 467, 468, 467, 1_152, 893, 668, 669, 669, 669,
					669, 669, 1_152, 668, 1_152, 1_152, 1_152, 668, 668, 671, 672, 1_152, 1_152, 1_152, 93, 673, 851,
					851, 851, 93, 1_152, 1_017, 1_152, 1_152, 93, 1_152, 1_152, 1_152, 994, 93, 1_152, 1_152, 1_152,
					1_018, 93, 1_152, 1_152, 1_152, 190, 191, 1_152, 1_152, 1_152, 1_152, 93, 469, 469, 469, 470, 469,
					1_152, 1_152, 674, 668, 669, 669, 669, 669, 669, 190, 668, 1_152, 1_152, 1_152, 668, 668, 671, 672,
					1_152, 1_152, 1_019, 1_152, 673, 467, 467, 467, 468, 467, 479, 479, 479, 480, 479, 481, 481, 481,
					482, 481, 483, 483, 483, 484, 483, 1_152, 493, 493, 493, 494, 493, 1_152, 93, 158, 158, 158, 252,
					158, 1_152, 1_152, 1_152, 674, 668, 669, 669, 669, 669, 669, 1_152, 668, 1_152, 1_152, 1_152, 668,
					668, 671, 672, 1_152, 1_152, 1_152, 93, 673, 210, 1_152, 1_152, 93, 1_152, 1_152, 1_152, 1_152, 93,
					775, 775, 775, 1_152, 93, 993, 1_152, 1_152, 1_152, 1_152, 211, 1_152, 994, 1_152, 210, 1_152, 1_152,
					93, 1_152, 553, 553, 553, 554, 553, 1_152, 1_152, 1_152, 674, 668, 669, 669, 669, 669, 669, 1_152,
					668, 1_152, 1_152, 1_152, 668, 668, 671, 672, 1_152, 1_152, 1_152, 1_152, 673, 523, 523, 523, 523,
					523, 1_152, 995, 942, 942, 942, 942, 942, 378, 658, 1_152, 1_152, 1_152, 1_152, 524, 943, 941, 1_152,
					1_152, 1_152, 1_152, 944, 93, 575, 575, 575, 576, 575, 1_152, 1_152, 1_152, 1_152, 674, 791, 792,
					792, 792, 792, 792, 1_152, 791, 1_152, 1_152, 1_152, 791, 791, 794, 672, 1_152, 1_152, 1_152, 380,
					795, 599, 599, 599, 600, 599, 1_152, 275, 599, 599, 599, 600, 599, 625, 625, 625, 626, 625, 705,
					705, 705, 706, 705, 907, 907, 907, 276, 1_152, 1_152, 1_152, 275, 1_152, 1_045, 1_152, 1_152, 1_061,
					1_152, 796, 668, 669, 669, 669, 669, 669, 1_152, 668, 1_152, 1_152, 1_152, 668, 668, 671, 797, 1_152,
					1_152, 1_152, 93, 673, 909, 909, 909, 909, 909, 93, 1_152, 1_152, 1_152, 1_152, 93, 1_152, 910, 908,
					1_152, 93, 1_152, 1_152, 911, 1_062, 1_152, 1_152, 783, 662, 662, 784, 783, 1_152, 526, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 674, 668, 799, 799, 799, 894, 799, 1_152, 668, 1_152, 1_152, 1_152,
					668, 668, 671, 672, 1_152, 1_152, 1_152, 1_152, 673, 895, 895, 895, 895, 895, 895, 895, 895, 895,
					895, 1_152, 1_152, 1_152, 1_152, 895, 895, 895, 895, 895, 895, 527, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 674, 895, 895, 895, 895, 895,
					798, 799, 669, 669, 669, 799, 800, 798, 800, 800, 800, 798, 798, 801, 802, 800, 800, 800, 800, 803,
					804, 804, 804, 804, 804, 804, 804, 804, 804, 804, 800, 800, 800, 800, 804, 804, 804, 804, 804, 804,
					800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 805, 804, 804, 804,
					804, 804, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800, 800,
					800, 532, 532, 532, 675, 532, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 378, 1_152, 1_152,
					1_152, 1_152, 1_152, 524, 896, 896, 896, 896, 896, 896, 896, 896, 896, 896, 1_152, 1_152, 1_152,
					1_152, 896, 896, 896, 896, 896, 896, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 380, 896, 896, 896, 896, 896, 158, 158, 158, 252,
					158, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					808, 808, 808, 808, 808, 808, 808, 898, 808, 808, 1_152, 851, 851, 851, 808, 808, 808, 808, 808,
					808, 1_017, 1_152, 1_152, 997, 1_152, 1_152, 1_152, 1_152, 1_025, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 93, 808, 808, 808, 808, 808, 682, 682, 682, 682, 899, 682, 900, 682, 682, 682, 1_152,
					1_152, 1_152, 1_152, 682, 682, 682, 682, 682, 682, 1_152, 1_152, 1_152, 1_026, 786, 665, 665, 787,
					786, 1_152, 1_152, 1_152, 1_152, 1_152, 526, 1_152, 1_152, 682, 682, 682, 682, 682, 907, 909, 909,
					909, 909, 909, 1_152, 907, 1_152, 1_152, 1_152, 907, 907, 910, 913, 1_152, 1_152, 1_152, 1_152, 914,
					969, 969, 969, 969, 969, 1_152, 1_152, 942, 942, 942, 942, 942, 970, 968, 1_152, 1_152, 1_152, 529,
					971, 943, 941, 1_152, 1_152, 1_152, 1_152, 944, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 915, 916, 917, 909, 909, 909, 917, 918, 916, 918, 918, 918, 916, 916, 919, 920,
					918, 918, 918, 918, 921, 922, 922, 922, 922, 922, 922, 922, 922, 922, 922, 918, 918, 918, 918, 922,
					922, 922, 922, 922, 922, 918, 918, 918, 918, 918, 918, 918, 918, 918, 918, 918, 918, 918, 918, 918,
					918, 923, 922, 922, 922, 922, 922, 918, 918, 918, 918, 918, 918, 918, 918, 918, 918, 918, 918, 918,
					918, 918, 918, 918, 918, 918, 924, 925, 925, 925, 925, 925, 1_152, 924, 1_152, 1_152, 1_152, 924,
					924, 927, 779, 1_152, 1_152, 1_152, 1_152, 928, 969, 969, 969, 969, 969, 1_152, 1_152, 1_013, 1_013,
					1_013, 1_013, 1_013, 970, 968, 1_152, 1_152, 1_152, 1_152, 971, 1_014, 849, 1_152, 1_152, 1_152,
					1_152, 1_015, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 929, 775, 776,
					776, 776, 776, 776, 1_152, 775, 1_152, 1_152, 1_152, 775, 775, 778, 779, 1_152, 1_152, 1_152, 1_152,
					780, 532, 532, 532, 675, 532, 1_152, 1_152, 1_013, 1_013, 1_013, 1_013, 1_013, 378, 1_152, 1_152,
					1_152, 1_152, 1_152, 524, 1_014, 849, 1_152, 1_152, 1_152, 1_152, 1_015, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 781, 775, 776, 776, 776, 776, 776, 1_152, 775, 1_152, 1_152,
					1_152, 775, 775, 778, 779, 1_152, 1_152, 1_152, 380, 780, 1_048, 1_048, 1_048, 1_048, 1_048, 1_018,
					523, 523, 523, 1_018, 1_152, 526, 1_049, 908, 851, 851, 851, 1_051, 1_050, 1_017, 775, 775, 775,
					1_052, 1_152, 1_152, 994, 1_152, 1_152, 993, 1_152, 1_018, 997, 1_152, 1_152, 1_152, 781, 775, 776,
					776, 776, 776, 776, 1_152, 775, 1_152, 1_152, 1_152, 775, 775, 778, 779, 1_152, 1_152, 1_152, 1_152,
					780, 907, 907, 907, 527, 1_025, 523, 523, 523, 1_025, 1_045, 1_152, 1_019, 1_061, 1_152, 526, 1_152,
					1_063, 998, 851, 851, 851, 1_152, 1_064, 1_152, 1_152, 1_152, 1_152, 1_017, 1_152, 1_152, 997, 1_152,
					1_152, 1_152, 1_152, 1_025, 781, 775, 776, 776, 776, 776, 776, 1_152, 775, 1_152, 1_152, 1_152, 775,
					775, 778, 779, 1_152, 1_152, 1_062, 1_152, 780, 1_152, 1_152, 529, 1_152, 1_074, 1_074, 1_074, 1_074,
					1_074, 907, 907, 907, 1_152, 1_152, 1_045, 1_026, 1_075, 1_073, 851, 851, 851, 1_046, 1_076, 1_017,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_046, 1_152, 1_152, 1_152, 1_152, 1_018, 781, 851, 852,
					852, 852, 852, 852, 1_152, 851, 1_152, 1_152, 1_152, 851, 851, 854, 779, 1_152, 1_152, 1_152, 1_152,
					855, 1_048, 1_048, 1_048, 1_048, 1_048, 1_152, 1_047, 1_048, 1_048, 1_048, 1_048, 1_048, 1_049, 908,
					1_152, 1_019, 1_152, 1_152, 1_050, 1_049, 908, 907, 907, 907, 1_152, 1_050, 1_045, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_046, 1_152, 1_152, 856, 775, 776, 776, 776, 776, 776, 1_152, 775, 1_152,
					1_152, 1_152, 775, 775, 778, 857, 1_152, 1_152, 1_152, 1_152, 780, 851, 851, 851, 1_152, 1_152, 1_017,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_046, 1_152, 775, 775, 775, 1_018, 1_047, 993, 1_152,
					1_152, 1_152, 1_020, 775, 775, 994, 1_152, 993, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 994, 781,
					775, 859, 859, 859, 930, 859, 1_152, 775, 1_152, 1_152, 1_152, 775, 775, 778, 779, 1_152, 1_152,
					1_019, 1_152, 780, 931, 931, 931, 931, 931, 931, 931, 931, 931, 931, 1_152, 995, 1_152, 1_152, 931,
					931, 931, 931, 931, 931, 995, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 781, 931, 931, 931, 931, 931, 858, 859, 776, 776, 776, 859, 860,
					858, 860, 860, 860, 858, 858, 861, 862, 860, 860, 860, 860, 863, 864, 864, 864, 864, 864, 864, 864,
					864, 864, 864, 860, 860, 860, 860, 864, 864, 864, 864, 864, 864, 860, 860, 860, 860, 860, 860, 860,
					860, 860, 860, 860, 860, 860, 860, 860, 860, 865, 864, 864, 864, 864, 864, 860, 860, 860, 860, 860,
					860, 860, 860, 860, 860, 860, 860, 860, 860, 860, 860, 860, 860, 860, 783, 662, 662, 784, 783, 1_152,
					526, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 933, 933,
					933, 933, 933, 933, 933, 933, 933, 933, 1_152, 1_152, 1_152, 1_152, 933, 933, 933, 933, 933, 933,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 527, 933, 933, 933, 933, 933, 786, 665, 665, 787, 786, 1_152, 1_152, 1_152, 1_152,
					1_152, 526, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 934, 934, 934, 934, 934, 934,
					934, 934, 934, 934, 1_152, 851, 851, 851, 934, 934, 934, 934, 934, 934, 1_017, 1_152, 1_152, 1_061,
					1_152, 1_152, 1_152, 1_152, 1_025, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 529, 934, 934,
					934, 934, 934, 871, 873, 873, 873, 873, 873, 1_152, 871, 1_152, 1_152, 1_152, 871, 871, 874, 877,
					1_152, 1_152, 1_152, 1_152, 878, 907, 907, 907, 1_026, 851, 851, 851, 1_152, 1_152, 1_045, 1_152,
					1_152, 1_061, 1_017, 1_152, 1_152, 1_061, 775, 775, 775, 1_152, 1_025, 1_027, 775, 775, 1_152, 993,
					1_152, 1_152, 997, 1_152, 993, 1_152, 1_152, 997, 1_152, 879, 791, 792, 792, 792, 792, 792, 1_152,
					791, 1_152, 1_152, 1_152, 791, 791, 794, 877, 1_152, 1_152, 1_062, 1_152, 795, 1_152, 1_026, 1_152,
					1_074, 1_074, 1_074, 1_074, 1_074, 775, 775, 775, 1_152, 1_152, 993, 998, 1_075, 1_073, 1_152, 1_152,
					998, 994, 1_076, 907, 907, 907, 1_152, 1_152, 1_045, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_046,
					1_152, 796, 871, 873, 873, 873, 873, 873, 1_152, 871, 1_152, 1_152, 1_152, 871, 871, 874, 937, 1_152,
					1_152, 1_152, 1_152, 878, 1_097, 1_097, 1_097, 1_097, 1_097, 995, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_120, 867, 1_152, 1_152, 1_152, 1_152, 1_121, 1_047, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 879, 880, 881, 873, 873, 873,
					881, 882, 880, 882, 882, 882, 880, 880, 883, 884, 882, 882, 882, 882, 885, 886, 886, 886, 886, 886,
					886, 886, 886, 886, 886, 882, 882, 882, 882, 886, 886, 886, 886, 886, 886, 882, 882, 882, 882, 882,
					882, 882, 882, 882, 882, 882, 882, 882, 882, 882, 882, 887, 886, 886, 886, 886, 886, 882, 882, 882,
					882, 882, 882, 882, 882, 882, 882, 882, 882, 882, 882, 882, 882, 882, 882, 882, 871, 873, 873, 873,
					873, 873, 1_152, 871, 1_152, 1_152, 1_152, 871, 871, 874, 877, 1_152, 1_152, 1_152, 1_152, 878, 1_053,
					907, 907, 1_152, 1_152, 1_045, 775, 775, 775, 1_152, 1_152, 1_152, 1_046, 1_152, 1_152, 993, 1_152,
					1_152, 997, 907, 907, 907, 1_152, 1_065, 907, 907, 1_152, 1_152, 1_045, 1_152, 1_152, 1_061, 1_045,
					1_152, 1_152, 1_061, 879, 871, 873, 873, 873, 873, 873, 1_152, 871, 1_152, 1_152, 1_152, 871, 871,
					874, 877, 1_152, 1_152, 1_047, 1_152, 878, 1_152, 1_152, 1_152, 998, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_062, 1_152, 1_152, 1_152, 1_062, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					879, 871, 873, 873, 873, 873, 873, 1_152, 871, 1_152, 1_152, 1_152, 871, 871, 874, 877, 1_152, 1_152,
					1_152, 1_152, 878, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 879, 871, 873, 873, 873, 873,
					873, 1_152, 871, 1_152, 1_152, 1_152, 871, 871, 874, 877, 1_152, 1_152, 1_152, 1_152, 878, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 879, 791, 792, 792, 792, 792, 792, 1_152, 791, 1_152,
					1_152, 1_152, 791, 791, 794, 877, 1_152, 1_152, 1_152, 1_152, 795, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 796, 871, 873, 873, 873, 873, 873, 1_152, 871, 1_152, 1_152, 1_152, 871, 871,
					874, 937, 1_152, 1_152, 1_152, 1_152, 878, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					879, 871, 881, 881, 881, 938, 881, 1_152, 871, 1_152, 1_152, 1_152, 871, 871, 874, 877, 1_152, 1_152,
					1_152, 1_152, 878, 939, 939, 939, 939, 939, 939, 939, 939, 939, 939, 1_152, 1_152, 1_152, 1_152,
					939, 939, 939, 939, 939, 939, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 879, 939, 939, 939, 939, 939, 940, 942, 942, 942, 942,
					942, 1_152, 940, 1_152, 1_152, 1_152, 940, 940, 943, 946, 1_152, 1_152, 1_152, 1_152, 947, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 948, 775, 935, 935, 935, 935, 935, 1_152, 949, 1_152,
					1_152, 1_152, 950, 775, 778, 857, 1_152, 1_152, 1_152, 1_152, 951, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 781, 952, 953, 942, 942, 942, 953, 954, 952, 954, 954, 954, 952, 952, 955, 956,
					954, 954, 954, 954, 957, 958, 958, 958, 958, 958, 958, 958, 958, 958, 958, 954, 954, 954, 954, 958,
					958, 958, 958, 958, 958, 954, 954, 954, 954, 954, 954, 954, 954, 954, 954, 954, 954, 954, 954, 954,
					954, 959, 958, 958, 958, 958, 958, 954, 954, 954, 954, 954, 954, 954, 954, 954, 954, 954, 954, 954,
					954, 954, 954, 954, 954, 954, 668, 669, 799, 669, 669, 669, 1_152, 668, 1_152, 1_152, 1_152, 668,
					668, 671, 672, 1_152, 1_152, 1_152, 1_152, 673, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 674, 668, 799, 799, 799, 894, 799, 1_152, 668, 1_152, 1_152, 1_152, 668, 668, 671, 672, 1_152,
					1_152, 1_152, 1_152, 673, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 1_152, 1_152, 1_152,
					1_152, 960, 960, 960, 960, 960, 960, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 674, 960, 960, 960, 960, 960, 532, 532, 532, 675,
					532, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 378, 1_152, 1_152, 1_152, 1_152, 1_152, 524,
					961, 961, 961, 961, 961, 961, 961, 961, 961, 961, 1_152, 1_152, 1_152, 1_152, 961, 961, 961, 961,
					961, 961, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 380, 961, 961, 961, 961, 961, 158, 158, 158, 252, 158, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 808, 808, 808, 808,
					962, 808, 808, 808, 808, 808, 1_152, 1_152, 1_152, 1_152, 808, 808, 808, 808, 808, 808, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					93, 808, 808, 808, 808, 808, 907, 909, 909, 909, 909, 909, 1_152, 907, 1_152, 1_152, 1_152, 907,
					907, 910, 913, 1_152, 1_152, 1_152, 1_152, 914, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 915, 851, 852, 852, 852, 852, 852, 1_152, 851, 1_152, 1_152, 1_152, 851, 851, 854, 913, 1_152,
					1_152, 1_152, 1_152, 855, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 856, 907, 909, 909,
					909, 909, 909, 1_152, 907, 1_152, 1_152, 1_152, 907, 907, 910, 964, 1_152, 1_152, 1_152, 1_152, 914,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 915, 916, 917, 909, 909, 909, 917, 918, 916,
					918, 918, 918, 916, 916, 919, 920, 918, 918, 918, 918, 921, 922, 922, 922, 922, 922, 922, 922, 922,
					922, 922, 918, 918, 918, 918, 922, 922, 922, 922, 922, 922, 918, 918, 918, 918, 918, 918, 918, 918,
					918, 918, 918, 918, 918, 918, 918, 918, 923, 922, 922, 922, 922, 922, 918, 918, 918, 918, 918, 918,
					918, 918, 918, 918, 918, 918, 918, 918, 918, 918, 918, 918, 918, 907, 909, 909, 909, 909, 909, 1_152,
					907, 1_152, 1_152, 1_152, 907, 907, 910, 913, 1_152, 1_152, 1_152, 1_152, 914, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 915, 907, 909, 909, 909, 909, 909, 1_152, 907, 1_152, 1_152, 1_152,
					907, 907, 910, 913, 1_152, 1_152, 1_152, 1_152, 914, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 915, 907, 909, 909, 909, 909, 909, 1_152, 907, 1_152, 1_152, 1_152, 907, 907, 910, 913, 1_152,
					1_152, 1_152, 1_152, 914, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 915, 907, 909, 909,
					909, 909, 909, 1_152, 907, 1_152, 1_152, 1_152, 907, 907, 910, 913, 1_152, 1_152, 1_152, 1_152, 914,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 915, 851, 852, 852, 852, 852, 852, 1_152,
					851, 1_152, 1_152, 1_152, 851, 851, 854, 913, 1_152, 1_152, 1_152, 1_152, 855, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 856, 907, 909, 909, 909, 909, 909, 1_152, 907, 1_152, 1_152, 1_152,
					907, 907, 910, 964, 1_152, 1_152, 1_152, 1_152, 914, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 915, 907, 917, 917, 917, 965, 917, 1_152, 907, 1_152, 1_152, 1_152, 907, 907, 910, 913, 1_152,
					1_152, 1_152, 1_152, 914, 966, 966, 966, 966, 966, 966, 966, 966, 966, 966, 1_152, 1_152, 1_152,
					1_152, 966, 966, 966, 966, 966, 966, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 915, 966, 966, 966, 966, 966, 967, 969, 969, 969,
					969, 969, 1_152, 967, 1_152, 1_152, 1_152, 967, 967, 970, 973, 1_152, 1_152, 1_152, 1_152, 974, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 975, 775, 776, 776, 776, 776, 776, 1_152, 775, 1_152,
					1_152, 1_152, 775, 775, 778, 857, 1_152, 1_152, 1_152, 1_152, 780, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 781, 976, 977, 969, 969, 969, 977, 978, 976, 978, 978, 978, 976, 976, 979, 980,
					978, 978, 978, 978, 981, 982, 982, 982, 982, 982, 982, 982, 982, 982, 982, 978, 978, 978, 978, 982,
					982, 982, 982, 982, 982, 978, 978, 978, 978, 978, 978, 978, 978, 978, 978, 978, 978, 978, 978, 978,
					978, 983, 982, 982, 982, 982, 982, 978, 978, 978, 978, 978, 978, 978, 978, 978, 978, 978, 978, 978,
					978, 978, 978, 978, 978, 978, 775, 776, 859, 776, 776, 776, 1_152, 775, 1_152, 1_152, 1_152, 775,
					775, 778, 779, 1_152, 1_152, 1_152, 1_152, 780, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 781, 775, 859, 859, 859, 930, 859, 1_152, 775, 1_152, 1_152, 1_152, 775, 775, 778, 779, 1_152,
					1_152, 1_152, 1_152, 780, 984, 984, 984, 984, 984, 984, 984, 984, 984, 984, 1_152, 1_152, 1_152,
					1_152, 984, 984, 984, 984, 984, 984, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 781, 984, 984, 984, 984, 984, 783, 662, 662, 784,
					783, 1_152, 526, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					987, 987, 987, 987, 987, 987, 987, 987, 987, 987, 1_152, 1_152, 1_152, 1_152, 987, 987, 987, 987,
					987, 987, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 527, 987, 987, 987, 987, 987, 786, 665, 665, 787, 786, 1_152, 1_152, 1_152,
					1_152, 1_152, 526, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 988, 988, 988, 988, 988,
					988, 988, 988, 988, 988, 1_152, 1_152, 1_152, 1_152, 988, 988, 988, 988, 988, 988, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					529, 988, 988, 988, 988, 988, 775, 935, 935, 935, 935, 935, 1_152, 949, 1_152, 1_152, 1_152, 950,
					775, 778, 779, 1_152, 1_152, 1_152, 1_152, 951, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 781, 888, 889, 889, 889, 889, 889, 1_152, 888, 1_152, 1_152, 1_152, 888, 888, 891, 946, 1_152,
					1_152, 1_152, 1_152, 892, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 893, 871, 873, 881,
					873, 873, 873, 1_152, 871, 1_152, 1_152, 1_152, 871, 871, 874, 877, 1_152, 1_152, 1_152, 1_152, 878,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 879, 871, 881, 881, 881, 938, 881, 1_152,
					871, 1_152, 1_152, 1_152, 871, 871, 874, 877, 1_152, 1_152, 1_152, 1_152, 878, 989, 989, 989, 989,
					989, 989, 989, 989, 989, 989, 1_152, 1_152, 1_152, 1_152, 989, 989, 989, 989, 989, 989, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					879, 989, 989, 989, 989, 989, 940, 942, 942, 942, 942, 942, 1_152, 940, 1_152, 1_152, 1_152, 940,
					940, 943, 946, 1_152, 1_152, 1_152, 1_152, 947, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 948, 791, 792, 792, 792, 792, 792, 1_152, 791, 1_152, 1_152, 1_152, 791, 791, 794, 946, 1_152,
					1_152, 1_152, 1_152, 795, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 796, 940, 942, 942,
					942, 942, 942, 1_152, 940, 1_152, 1_152, 1_152, 940, 940, 943, 991, 1_152, 1_152, 1_152, 1_152, 947,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 948, 952, 953, 942, 942, 942, 953, 954, 952,
					954, 954, 954, 952, 952, 955, 956, 954, 954, 954, 954, 957, 958, 958, 958, 958, 958, 958, 958, 958,
					958, 958, 954, 954, 954, 954, 958, 958, 958, 958, 958, 958, 954, 954, 954, 954, 954, 954, 954, 954,
					954, 954, 954, 954, 954, 954, 954, 954, 959, 958, 958, 958, 958, 958, 954, 954, 954, 954, 954, 954,
					954, 954, 954, 954, 954, 954, 954, 954, 954, 954, 954, 954, 954, 775, 776, 776, 776, 776, 776, 1_152,
					775, 1_152, 1_152, 1_152, 775, 775, 778, 999, 1_152, 1_152, 1_152, 1_152, 780, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 781, 940, 942, 942, 942, 942, 942, 1_152, 940, 1_152, 1_152, 1_152,
					940, 940, 943, 946, 1_152, 1_152, 1_152, 1_152, 947, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 948, 940, 942, 942, 942, 942, 942, 1_152, 940, 1_152, 1_152, 1_152, 940, 940, 943, 946, 1_152,
					1_152, 1_152, 1_152, 947, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 948, 940, 942, 942,
					942, 942, 942, 1_152, 940, 1_152, 1_152, 1_152, 940, 940, 943, 946, 1_152, 1_152, 1_152, 1_152, 947,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 948, 940, 942, 942, 942, 942, 942, 1_152,
					940, 1_152, 1_152, 1_152, 940, 940, 943, 946, 1_152, 1_152, 1_152, 1_152, 947, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 948, 791, 792, 792, 792, 792, 792, 1_152, 791, 1_152, 1_152, 1_152,
					791, 791, 794, 946, 1_152, 1_152, 1_152, 1_152, 795, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 796, 940, 942, 942, 942, 942, 942, 1_152, 940, 1_152, 1_152, 1_152, 940, 940, 943, 991, 1_152,
					1_152, 1_152, 1_152, 947, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 948, 940, 953, 953,
					953, 1_000, 953, 1_152, 940, 1_152, 1_152, 1_152, 940, 940, 943, 946, 1_152, 1_152, 1_152, 1_152,
					947, 1_001, 1_001, 1_001, 1_001, 1_001, 1_001, 1_001, 1_001, 1_001, 1_001, 1_152, 1_152, 1_152, 1_152,
					1_001, 1_001, 1_001, 1_001, 1_001, 1_001, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 948, 1_001, 1_001, 1_001, 1_001, 1_001, 668,
					799, 799, 799, 894, 799, 670, 668, 670, 670, 670, 668, 668, 671, 672, 670, 670, 670, 670, 673, 1_002,
					1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 670, 670, 670, 670, 1_002, 1_002,
					1_002, 1_002, 1_002, 1_002, 670, 670, 670, 670, 670, 670, 670, 670, 670, 670, 670, 670, 670, 670,
					670, 670, 674, 1_002, 1_002, 1_002, 1_002, 1_002, 670, 670, 670, 670, 670, 670, 670, 670, 670, 670,
					670, 670, 670, 670, 670, 670, 670, 670, 670, 532, 532, 532, 675, 532, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 378, 1_152, 1_152, 1_152, 1_152, 1_152, 524, 1_003, 1_003, 1_003, 1_003, 1_003,
					1_003, 1_003, 1_003, 1_003, 1_003, 1_152, 1_152, 1_152, 1_152, 1_003, 1_003, 1_003, 1_003, 1_003,
					1_003, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 380, 1_003, 1_003, 1_003, 1_003, 1_003, 924, 925, 925, 925, 925, 925, 1_152,
					924, 1_152, 1_152, 1_152, 924, 924, 927, 973, 1_152, 1_152, 1_152, 1_152, 928, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 929, 907, 909, 917, 909, 909, 909, 1_152, 907, 1_152, 1_152, 1_152,
					907, 907, 910, 913, 1_152, 1_152, 1_152, 1_152, 914, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 915, 907, 917, 917, 917, 965, 917, 1_152, 907, 1_152, 1_152, 1_152, 907, 907, 910, 913, 1_152,
					1_152, 1_152, 1_152, 914, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_152,
					1_152, 1_152, 1_152, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 915, 1_004, 1_004, 1_004,
					1_004, 1_004, 967, 969, 969, 969, 969, 969, 1_152, 967, 1_152, 1_152, 1_152, 967, 967, 970, 973,
					1_152, 1_152, 1_152, 1_152, 974, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 975, 851, 852,
					852, 852, 852, 852, 1_152, 851, 1_152, 1_152, 1_152, 851, 851, 854, 973, 1_152, 1_152, 1_152, 1_152,
					855, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 856, 967, 969, 969, 969, 969, 969, 1_152,
					967, 1_152, 1_152, 1_152, 967, 967, 970, 1_006, 1_152, 1_152, 1_152, 1_152, 974, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 975, 976, 977, 969, 969, 969, 977, 978, 976, 978, 978, 978, 976,
					976, 979, 980, 978, 978, 978, 978, 981, 982, 982, 982, 982, 982, 982, 982, 982, 982, 982, 978, 978,
					978, 978, 982, 982, 982, 982, 982, 982, 978, 978, 978, 978, 978, 978, 978, 978, 978, 978, 978, 978,
					978, 978, 978, 978, 983, 982, 982, 982, 982, 982, 978, 978, 978, 978, 978, 978, 978, 978, 978, 978,
					978, 978, 978, 978, 978, 978, 978, 978, 978, 967, 969, 969, 969, 969, 969, 1_152, 967, 1_152, 1_152,
					1_152, 967, 967, 970, 973, 1_152, 1_152, 1_152, 1_152, 974, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 975, 967, 969, 969, 969, 969, 969, 1_152, 967, 1_152, 1_152, 1_152, 967, 967, 970,
					973, 1_152, 1_152, 1_152, 1_152, 974, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 975, 967,
					969, 969, 969, 969, 969, 1_152, 967, 1_152, 1_152, 1_152, 967, 967, 970, 973, 1_152, 1_152, 1_152,
					1_152, 974, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 975, 967, 969, 969, 969, 969, 969,
					1_152, 967, 1_152, 1_152, 1_152, 967, 967, 970, 973, 1_152, 1_152, 1_152, 1_152, 974, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 975, 851, 852, 852, 852, 852, 852, 1_152, 851, 1_152, 1_152,
					1_152, 851, 851, 854, 973, 1_152, 1_152, 1_152, 1_152, 855, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 856, 967, 969, 969, 969, 969, 969, 1_152, 967, 1_152, 1_152, 1_152, 967, 967, 970,
					1_006, 1_152, 1_152, 1_152, 1_152, 974, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 975, 967,
					977, 977, 977, 1_007, 977, 1_152, 967, 1_152, 1_152, 1_152, 967, 967, 970, 973, 1_152, 1_152, 1_152,
					1_152, 974, 1_008, 1_008, 1_008, 1_008, 1_008, 1_008, 1_008, 1_008, 1_008, 1_008, 1_152, 1_152, 1_152,
					1_152, 1_008, 1_008, 1_008, 1_008, 1_008, 1_008, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 975, 1_008, 1_008, 1_008, 1_008, 1_008,
					775, 859, 859, 859, 930, 859, 1_152, 775, 1_152, 1_152, 1_152, 775, 775, 778, 779, 1_152, 1_152,
					1_152, 1_152, 780, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_152, 1_152,
					1_152, 1_152, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 781, 1_009, 1_009, 1_009, 1_009,
					1_009, 783, 662, 662, 784, 783, 1_152, 526, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_010, 1_010, 1_010, 1_010, 1_010, 1_010, 1_010, 1_010, 1_010, 1_010,
					1_152, 1_152, 1_152, 1_152, 1_010, 1_010, 1_010, 1_010, 1_010, 1_010, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 527, 1_010, 1_010,
					1_010, 1_010, 1_010, 786, 665, 665, 787, 786, 1_152, 1_152, 1_152, 1_152, 1_152, 526, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_011, 1_011, 1_011, 1_011, 1_011, 1_011, 1_011, 1_011,
					1_011, 1_011, 1_152, 1_152, 1_152, 1_152, 1_011, 1_011, 1_011, 1_011, 1_011, 1_011, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					529, 1_011, 1_011, 1_011, 1_011, 1_011, 871, 881, 881, 881, 938, 881, 876, 871, 876, 876, 876, 871,
					871, 874, 877, 876, 876, 876, 876, 878, 1_012, 1_012, 1_012, 1_012, 1_012, 1_012, 1_012, 1_012, 1_012,
					1_012, 876, 876, 876, 876, 1_012, 1_012, 1_012, 1_012, 1_012, 1_012, 876, 876, 876, 876, 876, 876,
					876, 876, 876, 876, 876, 876, 876, 876, 876, 876, 879, 1_012, 1_012, 1_012, 1_012, 1_012, 876, 876,
					876, 876, 876, 876, 876, 876, 876, 876, 876, 876, 876, 876, 876, 876, 876, 876, 876, 888, 889, 889,
					889, 889, 889, 1_152, 888, 1_152, 1_152, 1_152, 888, 888, 891, 946, 1_152, 1_152, 1_152, 1_152, 892,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 893, 992, 992, 1_021, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_022, 1_152, 1_152, 1_152, 1_152, 1_152, 1_023, 1_023,
					1_023, 1_023, 1_023, 1_023, 1_023, 1_023, 1_023, 1_023, 1_152, 1_152, 1_152, 1_152, 1_023, 1_023,
					1_023, 1_023, 1_023, 1_023, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_023, 1_023, 1_023, 1_023, 1_023, 996, 996, 1_028,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_029, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_030, 1_030, 1_030, 1_030, 1_030, 1_030, 1_030, 1_030, 1_030, 1_030, 1_152, 1_152, 1_152,
					1_152, 1_030, 1_030, 1_030, 1_030, 1_030, 1_030, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_030, 1_030, 1_030, 1_030,
					1_030, 1_031, 1_032, 1_032, 1_032, 1_032, 1_032, 1_152, 1_031, 1_152, 1_152, 1_152, 1_031, 1_031,
					1_034, 672, 1_152, 1_152, 1_152, 1_152, 1_035, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_036, 940, 942, 953, 942, 942, 942, 1_152, 940, 1_152, 1_152, 1_152, 940, 940, 943, 946, 1_152,
					1_152, 1_152, 1_152, 947, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 948, 940, 953, 953,
					953, 1_000, 953, 1_152, 940, 1_152, 1_152, 1_152, 940, 940, 943, 946, 1_152, 1_152, 1_152, 1_152,
					947, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_152, 1_152, 1_152, 1_152,
					1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 948, 1_037, 1_037, 1_037, 1_037, 1_037, 668,
					799, 799, 799, 894, 799, 670, 668, 670, 670, 670, 668, 668, 671, 672, 670, 670, 670, 670, 673, 1_038,
					1_038, 1_038, 1_038, 1_038, 1_038, 1_038, 1_038, 1_038, 1_038, 670, 670, 670, 670, 1_038, 1_038,
					1_038, 1_038, 1_038, 1_038, 670, 670, 670, 670, 670, 670, 670, 670, 670, 670, 670, 670, 670, 670,
					670, 670, 674, 1_038, 1_038, 1_038, 1_038, 1_038, 670, 670, 670, 670, 670, 670, 670, 670, 670, 670,
					670, 670, 670, 670, 670, 670, 670, 670, 670, 907, 917, 917, 917, 965, 917, 912, 907, 912, 912, 912,
					907, 907, 910, 913, 912, 912, 912, 912, 914, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039,
					1_039, 1_039, 912, 912, 912, 912, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 912, 912, 912, 912, 912,
					912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 915, 1_039, 1_039, 1_039, 1_039, 1_039, 912,
					912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 924, 925,
					925, 925, 925, 925, 1_152, 924, 1_152, 1_152, 1_152, 924, 924, 927, 973, 1_152, 1_152, 1_152, 1_152,
					928, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 929, 967, 969, 977, 969, 969, 969, 1_152,
					967, 1_152, 1_152, 1_152, 967, 967, 970, 973, 1_152, 1_152, 1_152, 1_152, 974, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 975, 967, 977, 977, 977, 1_007, 977, 1_152, 967, 1_152, 1_152,
					1_152, 967, 967, 970, 973, 1_152, 1_152, 1_152, 1_152, 974, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040,
					1_040, 1_040, 1_040, 1_040, 1_152, 1_152, 1_152, 1_152, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 975, 1_040, 1_040, 1_040, 1_040, 1_040, 775, 859, 859, 859, 930, 859, 777, 775, 777,
					777, 777, 775, 775, 778, 779, 777, 777, 777, 777, 780, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041,
					1_041, 1_041, 1_041, 1_041, 777, 777, 777, 777, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 777, 777,
					777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 781, 1_041, 1_041, 1_041, 1_041,
					1_041, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777,
					777, 1_042, 1_042, 1_042, 1_042, 1_042, 1_042, 1_042, 1_042, 1_042, 1_042, 1_152, 1_152, 1_152, 1_152,
					1_042, 1_042, 1_042, 1_042, 1_042, 1_042, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_042, 1_042, 1_042, 1_042, 1_042,
					1_044, 1_044, 1_054, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_055, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_056, 1_056, 1_056, 1_056, 1_056, 1_056, 1_056, 1_056, 1_056, 1_056,
					1_152, 1_152, 1_152, 1_152, 1_056, 1_056, 1_056, 1_056, 1_056, 1_056, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_056,
					1_056, 1_056, 1_056, 1_056, 1_057, 1_020, 1_020, 1_058, 1_057, 1_152, 993, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 994, 1_152, 1_152, 1_152, 1_152, 1_152, 1_059, 1_059, 1_059, 1_059, 1_059, 1_059, 1_059,
					1_059, 1_059, 1_059, 1_152, 1_152, 1_152, 1_152, 1_059, 1_059, 1_059, 1_059, 1_059, 1_059, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 995, 1_059, 1_059, 1_059, 1_059, 1_059, 1_060, 1_060, 1_066, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_067, 1_152, 1_152, 1_152, 1_152, 1_152, 1_068, 1_068, 1_068, 1_068,
					1_068, 1_068, 1_068, 1_068, 1_068, 1_068, 1_152, 1_152, 1_152, 1_152, 1_068, 1_068, 1_068, 1_068,
					1_068, 1_068, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_068, 1_068, 1_068, 1_068, 1_068, 1_069, 1_027, 1_027, 1_070,
					1_069, 1_152, 1_152, 1_152, 1_152, 1_152, 993, 1_152, 1_152, 997, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_071, 1_071, 1_071, 1_071, 1_071, 1_071, 1_071, 1_071, 1_071, 1_071, 1_152, 1_152, 1_152, 1_152,
					1_071, 1_071, 1_071, 1_071, 1_071, 1_071, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 998, 1_071, 1_071, 1_071, 1_071, 1_071, 1_072,
					1_074, 1_074, 1_074, 1_074, 1_074, 1_152, 1_072, 1_152, 1_152, 1_152, 1_072, 1_072, 1_075, 1_078,
					1_152, 1_152, 1_152, 1_152, 1_079, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_080,
					668, 669, 669, 669, 669, 669, 1_152, 668, 1_152, 1_152, 1_152, 668, 668, 671, 797, 1_152, 1_152,
					1_152, 1_152, 673, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 674, 1_081, 1_082, 1_074, 1_074,
					1_074, 1_082, 1_083, 1_081, 1_083, 1_083, 1_083, 1_081, 1_081, 1_084, 1_085, 1_083, 1_083, 1_083,
					1_083, 1_086, 1_087, 1_087, 1_087, 1_087, 1_087, 1_087, 1_087, 1_087, 1_087, 1_087, 1_083, 1_083,
					1_083, 1_083, 1_087, 1_087, 1_087, 1_087, 1_087, 1_087, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083,
					1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_088, 1_087, 1_087, 1_087,
					1_087, 1_087, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083,
					1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 940, 953, 953, 953, 1_000, 953, 945, 940, 945, 945,
					945, 940, 940, 943, 946, 945, 945, 945, 945, 947, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089,
					1_089, 1_089, 1_089, 945, 945, 945, 945, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 945, 945, 945,
					945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 948, 1_089, 1_089, 1_089, 1_089,
					1_089, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945,
					945, 668, 799, 799, 799, 894, 799, 1_152, 668, 1_152, 1_152, 1_152, 668, 668, 671, 672, 1_152, 1_152,
					1_152, 1_152, 673, 1_090, 1_090, 1_090, 1_090, 1_090, 1_090, 1_090, 1_090, 1_090, 1_090, 1_152, 1_152,
					1_152, 1_152, 1_090, 1_090, 1_090, 1_090, 1_090, 1_090, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 674, 1_090, 1_090, 1_090, 1_090,
					1_090, 907, 917, 917, 917, 965, 917, 912, 907, 912, 912, 912, 907, 907, 910, 913, 912, 912, 912,
					912, 914, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 912, 912, 912, 912,
					1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912,
					912, 912, 912, 912, 912, 915, 1_091, 1_091, 1_091, 1_091, 1_091, 912, 912, 912, 912, 912, 912, 912,
					912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 967, 977, 977, 977, 1_007, 977, 972,
					967, 972, 972, 972, 967, 967, 970, 973, 972, 972, 972, 972, 974, 1_092, 1_092, 1_092, 1_092, 1_092,
					1_092, 1_092, 1_092, 1_092, 1_092, 972, 972, 972, 972, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092,
					972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 975, 1_092, 1_092,
					1_092, 1_092, 1_092, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972,
					972, 972, 972, 775, 859, 859, 859, 930, 859, 777, 775, 777, 777, 777, 775, 775, 778, 779, 777, 777,
					777, 777, 780, 1_093, 1_093, 1_093, 1_093, 1_093, 1_093, 1_093, 1_093, 1_093, 1_093, 777, 777, 777,
					777, 1_093, 1_093, 1_093, 1_093, 1_093, 1_093, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777,
					777, 777, 777, 777, 777, 777, 781, 1_093, 1_093, 1_093, 1_093, 1_093, 777, 777, 777, 777, 777, 777,
					777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 777, 1_094, 1_094, 1_094, 1_094, 1_094,
					1_094, 1_094, 1_094, 1_094, 1_094, 1_152, 1_152, 1_152, 1_152, 1_094, 1_094, 1_094, 1_094, 1_094,
					1_094, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_094, 1_094, 1_094, 1_094, 1_094, 1_044, 1_044, 1_054, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_055, 1_152, 1_152, 1_152, 1_152, 1_152, 1_056,
					1_056, 1_056, 1_056, 1_056, 1_056, 1_056, 1_056, 1_056, 1_056, 1_152, 1_152, 1_152, 1_152, 1_056,
					1_056, 1_056, 1_056, 1_056, 1_056, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_056, 1_056, 1_056, 1_056, 1_056, 1_100,
					1_053, 1_053, 1_101, 1_100, 1_152, 1_045, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_046, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_102, 1_102, 1_102, 1_102, 1_102, 1_102, 1_102, 1_102, 1_102, 1_102,
					1_152, 1_152, 1_152, 1_152, 1_102, 1_102, 1_102, 1_102, 1_102, 1_102, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_047, 1_102,
					1_102, 1_102, 1_102, 1_102, 1_057, 1_020, 1_020, 1_058, 1_057, 1_152, 993, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 994, 1_152, 1_152, 1_152, 1_152, 1_152, 1_103, 1_103, 1_103, 1_103, 1_103, 1_103, 1_103,
					1_103, 1_103, 1_103, 1_152, 1_152, 1_152, 1_152, 1_103, 1_103, 1_103, 1_103, 1_103, 1_103, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 995, 1_103, 1_103, 1_103, 1_103, 1_103, 1_060, 1_060, 1_066, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_067, 1_152, 1_152, 1_152, 1_152, 1_152, 1_068, 1_068, 1_068, 1_068,
					1_068, 1_068, 1_068, 1_068, 1_068, 1_068, 1_152, 1_152, 1_152, 1_152, 1_068, 1_068, 1_068, 1_068,
					1_068, 1_068, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_068, 1_068, 1_068, 1_068, 1_068, 1_105, 1_065, 1_065, 1_106,
					1_105, 1_152, 1_152, 1_152, 1_152, 1_152, 1_045, 1_152, 1_152, 1_061, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_107, 1_107, 1_107, 1_107, 1_107, 1_107, 1_107, 1_107, 1_107, 1_107, 1_152, 1_152, 1_152,
					1_152, 1_107, 1_107, 1_107, 1_107, 1_107, 1_107, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_062, 1_107, 1_107, 1_107, 1_107,
					1_107, 1_069, 1_027, 1_027, 1_070, 1_069, 1_152, 1_152, 1_152, 1_152, 1_152, 993, 1_152, 1_152, 997,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_108, 1_108, 1_108, 1_108, 1_108, 1_108, 1_108, 1_108, 1_108,
					1_108, 1_152, 1_152, 1_152, 1_152, 1_108, 1_108, 1_108, 1_108, 1_108, 1_108, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 998, 1_108,
					1_108, 1_108, 1_108, 1_108, 1_072, 1_074, 1_074, 1_074, 1_074, 1_074, 1_152, 1_072, 1_152, 1_152,
					1_152, 1_072, 1_072, 1_075, 1_078, 1_152, 1_152, 1_152, 1_152, 1_079, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_080, 791, 792, 792, 792, 792, 792, 1_152, 791, 1_152, 1_152, 1_152,
					791, 791, 794, 1_078, 1_152, 1_152, 1_152, 1_152, 795, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 796, 1_072, 1_074, 1_074, 1_074, 1_074, 1_074, 1_152, 1_072, 1_152, 1_152, 1_152, 1_072,
					1_072, 1_075, 1_110, 1_152, 1_152, 1_152, 1_152, 1_079, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_080, 1_081, 1_082, 1_074, 1_074, 1_074, 1_082, 1_083, 1_081, 1_083, 1_083, 1_083,
					1_081, 1_081, 1_084, 1_085, 1_083, 1_083, 1_083, 1_083, 1_086, 1_087, 1_087, 1_087, 1_087, 1_087,
					1_087, 1_087, 1_087, 1_087, 1_087, 1_083, 1_083, 1_083, 1_083, 1_087, 1_087, 1_087, 1_087, 1_087,
					1_087, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083,
					1_083, 1_083, 1_083, 1_088, 1_087, 1_087, 1_087, 1_087, 1_087, 1_083, 1_083, 1_083, 1_083, 1_083,
					1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 1_083,
					1_072, 1_074, 1_074, 1_074, 1_074, 1_074, 1_152, 1_072, 1_152, 1_152, 1_152, 1_072, 1_072, 1_075,
					1_078, 1_152, 1_152, 1_152, 1_152, 1_079, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_080, 1_072, 1_074, 1_074, 1_074, 1_074, 1_074, 1_152, 1_072, 1_152, 1_152, 1_152, 1_072, 1_072,
					1_075, 1_078, 1_152, 1_152, 1_152, 1_152, 1_079, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_080, 1_072, 1_074, 1_074, 1_074, 1_074, 1_074, 1_152, 1_072, 1_152, 1_152, 1_152, 1_072,
					1_072, 1_075, 1_078, 1_152, 1_152, 1_152, 1_152, 1_079, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_080, 1_072, 1_074, 1_074, 1_074, 1_074, 1_074, 1_152, 1_072, 1_152, 1_152, 1_152,
					1_072, 1_072, 1_075, 1_078, 1_152, 1_152, 1_152, 1_152, 1_079, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_080, 791, 792, 792, 792, 792, 792, 1_152, 791, 1_152, 1_152, 1_152, 791, 791,
					794, 1_078, 1_152, 1_152, 1_152, 1_152, 795, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					796, 1_072, 1_074, 1_074, 1_074, 1_074, 1_074, 1_152, 1_072, 1_152, 1_152, 1_152, 1_072, 1_072, 1_075,
					1_110, 1_152, 1_152, 1_152, 1_152, 1_079, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_080, 1_072, 1_082, 1_082, 1_082, 1_111, 1_082, 1_152, 1_072, 1_152, 1_152, 1_152, 1_072, 1_072,
					1_075, 1_078, 1_152, 1_152, 1_152, 1_152, 1_079, 1_112, 1_112, 1_112, 1_112, 1_112, 1_112, 1_112,
					1_112, 1_112, 1_112, 1_152, 1_152, 1_152, 1_152, 1_112, 1_112, 1_112, 1_112, 1_112, 1_112, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_080, 1_112, 1_112, 1_112, 1_112, 1_112, 940, 953, 953, 953, 1_000, 953, 945, 940, 945, 945,
					945, 940, 940, 943, 946, 945, 945, 945, 945, 947, 1_113, 1_113, 1_113, 1_113, 1_113, 1_113, 1_113,
					1_113, 1_113, 1_113, 945, 945, 945, 945, 1_113, 1_113, 1_113, 1_113, 1_113, 1_113, 945, 945, 945,
					945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 948, 1_113, 1_113, 1_113, 1_113,
					1_113, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945,
					945, 668, 799, 799, 799, 894, 799, 1_152, 668, 1_152, 1_152, 1_152, 668, 668, 671, 672, 1_152, 1_152,
					1_152, 1_152, 673, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 674, 907, 917, 917, 917, 965,
					917, 912, 907, 912, 912, 912, 907, 907, 910, 913, 912, 912, 912, 912, 914, 1_114, 1_114, 1_114, 1_114,
					1_114, 1_114, 1_114, 1_114, 1_114, 1_114, 912, 912, 912, 912, 1_114, 1_114, 1_114, 1_114, 1_114,
					1_114, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 915, 1_114,
					1_114, 1_114, 1_114, 1_114, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912, 912,
					912, 912, 912, 912, 912, 967, 977, 977, 977, 1_007, 977, 972, 967, 972, 972, 972, 967, 967, 970,
					973, 972, 972, 972, 972, 974, 1_115, 1_115, 1_115, 1_115, 1_115, 1_115, 1_115, 1_115, 1_115, 1_115,
					972, 972, 972, 972, 1_115, 1_115, 1_115, 1_115, 1_115, 1_115, 972, 972, 972, 972, 972, 972, 972,
					972, 972, 972, 972, 972, 972, 972, 972, 972, 975, 1_115, 1_115, 1_115, 1_115, 1_115, 972, 972, 972,
					972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 972, 775, 859, 859, 859,
					930, 859, 1_152, 775, 1_152, 1_152, 1_152, 775, 775, 778, 779, 1_152, 1_152, 1_152, 1_152, 780, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 781, 871, 881, 881, 881, 938, 881, 1_152, 871, 1_152,
					1_152, 1_152, 871, 871, 874, 877, 1_152, 1_152, 1_152, 1_152, 878, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 879, 1_100, 1_053, 1_053, 1_101, 1_100, 1_152, 1_045, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_046, 1_152, 1_152, 1_152, 1_152, 1_152, 1_122, 1_122, 1_122, 1_122, 1_122, 1_122,
					1_122, 1_122, 1_122, 1_122, 1_152, 1_152, 1_152, 1_152, 1_122, 1_122, 1_122, 1_122, 1_122, 1_122,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_047, 1_122, 1_122, 1_122, 1_122, 1_122, 1_057, 1_020, 1_020, 1_058, 1_057, 1_152,
					993, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 994, 1_152, 1_152, 1_152, 1_152, 1_152, 1_123, 1_123,
					1_123, 1_123, 1_123, 1_123, 1_123, 1_123, 1_123, 1_123, 1_152, 1_152, 1_152, 1_152, 1_123, 1_123,
					1_123, 1_123, 1_123, 1_123, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 995, 1_123, 1_123, 1_123, 1_123, 1_123, 1_124, 1_124, 1_124,
					1_124, 1_124, 1_124, 1_124, 1_124, 1_124, 1_124, 1_152, 1_152, 1_152, 1_152, 1_124, 1_124, 1_124,
					1_124, 1_124, 1_124, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_124, 1_124, 1_124, 1_124, 1_124, 1_125, 1_125, 1_125,
					1_125, 1_125, 1_125, 1_125, 1_125, 1_125, 1_125, 1_152, 1_152, 1_152, 1_152, 1_125, 1_125, 1_125,
					1_125, 1_125, 1_125, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_125, 1_125, 1_125, 1_125, 1_125, 888, 889, 889, 889,
					889, 889, 1_152, 888, 1_152, 1_152, 1_152, 888, 888, 891, 1_078, 1_152, 1_152, 1_152, 1_152, 892,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 893, 1_072, 1_074, 1_082, 1_074, 1_074, 1_074,
					1_152, 1_072, 1_152, 1_152, 1_152, 1_072, 1_072, 1_075, 1_078, 1_152, 1_152, 1_152, 1_152, 1_079,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_080, 1_126, 1_126, 1_126, 1_126, 1_126,
					1_126, 1_126, 1_126, 1_126, 1_126, 1_152, 1_152, 1_152, 1_152, 1_126, 1_126, 1_126, 1_126, 1_126,
					1_126, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_126, 1_126, 1_126, 1_126, 1_126, 1_127, 1_127, 1_127, 1_127, 1_127,
					1_127, 1_127, 1_127, 1_127, 1_127, 1_152, 1_152, 1_152, 1_152, 1_127, 1_127, 1_127, 1_127, 1_127,
					1_127, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_127, 1_127, 1_127, 1_127, 1_127, 912, 912, 912, 912, 912, 912, 912,
					912, 912, 912, 1_152, 1_152, 1_152, 1_152, 912, 912, 912, 912, 912, 912, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 912, 912,
					912, 912, 912, 1_128, 1_128, 1_128, 1_128, 1_128, 1_128, 1_128, 1_128, 1_128, 1_128, 1_152, 1_152,
					1_152, 1_152, 1_128, 1_128, 1_128, 1_128, 1_128, 1_128, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_128, 1_128, 1_128,
					1_128, 1_128, 1_134, 1_134, 1_134, 1_134, 1_134, 1_134, 1_134, 1_134, 1_134, 1_134, 1_152, 1_152,
					1_152, 1_152, 1_134, 1_134, 1_134, 1_134, 1_134, 1_134, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_134, 1_134, 1_134,
					1_134, 1_134, 1_135, 1_135, 1_135, 1_135, 1_135, 1_135, 1_135, 1_135, 1_135, 1_135, 1_152, 1_152,
					1_152, 1_152, 1_135, 1_135, 1_135, 1_135, 1_135, 1_135, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_135, 1_135, 1_135,
					1_135, 1_135, 1_136, 1_136, 1_136, 1_136, 1_136, 1_136, 1_136, 1_136, 1_136, 1_136, 1_152, 1_152,
					1_152, 1_152, 1_136, 1_136, 1_136, 1_136, 1_136, 1_136, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_136, 1_136, 1_136,
					1_136, 1_136, 1_137, 1_137, 1_137, 1_137, 1_137, 1_137, 1_137, 1_137, 1_137, 1_137, 1_152, 1_152,
					1_152, 1_152, 1_137, 1_137, 1_137, 1_137, 1_137, 1_137, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_137, 1_137, 1_137,
					1_137, 1_137, 1_138, 1_138, 1_138, 1_138, 1_138, 1_138, 1_138, 1_138, 1_138, 1_138, 1_152, 1_152,
					1_152, 1_152, 1_138, 1_138, 1_138, 1_138, 1_138, 1_138, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_138, 1_138, 1_138,
					1_138, 1_138, 945, 945, 945, 945, 945, 945, 945, 945, 945, 945, 1_152, 1_152, 1_152, 1_152, 945,
					945, 945, 945, 945, 945, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 945, 945, 945, 945, 945, 972, 972, 972, 972, 972, 972,
					972, 972, 972, 972, 1_152, 1_152, 1_152, 1_152, 972, 972, 972, 972, 972, 972, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					972, 972, 972, 972, 972, 1_141, 1_141, 1_141, 1_141, 1_141, 1_141, 1_141, 1_141, 1_141, 1_141, 1_152,
					1_152, 1_152, 1_152, 1_141, 1_141, 1_141, 1_141, 1_141, 1_141, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_141, 1_141,
					1_141, 1_141, 1_141, 1_142, 1_142, 1_142, 1_142, 1_142, 1_142, 1_142, 1_142, 1_142, 1_142, 1_152,
					1_152, 1_152, 1_152, 1_142, 1_142, 1_142, 1_142, 1_142, 1_142, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_142, 1_142,
					1_142, 1_142, 1_142, 1_143, 1_143, 1_143, 1_143, 1_143, 1_143, 1_143, 1_143, 1_143, 1_143, 1_152,
					1_152, 1_152, 1_152, 1_143, 1_143, 1_143, 1_143, 1_143, 1_143, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_143, 1_143,
					1_143, 1_143, 1_143, 1_144, 1_144, 1_144, 1_144, 1_144, 1_144, 1_144, 1_144, 1_144, 1_144, 1_152,
					1_152, 1_152, 1_152, 1_144, 1_144, 1_144, 1_144, 1_144, 1_144, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_144, 1_144,
					1_144, 1_144, 1_144, 1_145, 1_145, 1_145, 1_145, 1_145, 1_145, 1_145, 1_145, 1_145, 1_145, 1_152,
					1_152, 1_152, 1_152, 1_145, 1_145, 1_145, 1_145, 1_145, 1_145, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_145, 1_145,
					1_145, 1_145, 1_145, 1_149, 1_149, 1_149, 1_149, 1_149, 1_149, 1_149, 1_149, 1_149, 1_149, 1_152,
					1_152, 1_152, 1_152, 1_149, 1_149, 1_149, 1_149, 1_149, 1_149, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_149, 1_149,
					1_149, 1_149, 1_149, 992, 992, 992, 992, 992, 992, 992, 992, 992, 992, 1_152, 1_152, 1_152, 1_152,
					992, 992, 992, 992, 992, 992, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 992, 992, 992, 992, 992, 1_150, 1_150, 1_150, 1_150,
					1_150, 1_150, 1_150, 1_150, 1_150, 1_150, 1_152, 1_152, 1_152, 1_152, 1_150, 1_150, 1_150, 1_150,
					1_150, 1_150, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_150, 1_150, 1_150, 1_150, 1_150, 996, 996, 996, 996, 996, 996,
					996, 996, 996, 996, 1_152, 1_152, 1_152, 1_152, 996, 996, 996, 996, 996, 996, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					996, 996, 996, 996, 996, 1_151, 1_151, 1_151, 1_151, 1_151, 1_151, 1_151, 1_151, 1_151, 1_151, 1_152,
					1_152, 1_152, 1_152, 1_151, 1_151, 1_151, 1_151, 1_151, 1_151, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_151, 1_151,
					1_151, 1_151, 1_151, 1_044, 1_044, 1_044, 1_044, 1_044, 1_044, 1_044, 1_044, 1_044, 1_044, 1_152,
					1_152, 1_152, 1_152, 1_044, 1_044, 1_044, 1_044, 1_044, 1_044, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_044, 1_044,
					1_044, 1_044, 1_044, 1_060, 1_060, 1_060, 1_060, 1_060, 1_060, 1_060, 1_060, 1_060, 1_060, 1_152,
					1_152, 1_152, 1_152, 1_060, 1_060, 1_060, 1_060, 1_060, 1_060, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_060, 1_060,
					1_060, 1_060, 1_060, 1_077, 1_077, 1_077, 1_077, 1_077, 1_077, 1_077, 1_077, 1_077, 1_077, 1_152,
					1_152, 1_152, 1_152, 1_077, 1_077, 1_077, 1_077, 1_077, 1_077, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_077, 1_077,
					1_077, 1_077, 1_077, 35, 35, 1_152, 35, 35, 35, 35, 35, 35, 38, 38, 38, 40, 40, 1_152, 40, 40, 40,
					40, 40, 40, 43, 1_152, 43, 70, 70, 70, 70, 73, 73, 1_152, 73, 73, 73, 73, 73, 73, 80, 80, 80, 80,
					80, 80, 80, 80, 80, 83, 83, 1_152, 83, 83, 83, 83, 83, 83, 85, 85, 85, 85, 85, 85, 85, 85, 85, 89,
					89, 89, 89, 89, 89, 89, 89, 89, 92, 92, 92, 138, 138, 1_152, 138, 138, 138, 138, 138, 138, 143, 143,
					143, 143, 143, 143, 143, 143, 143, 145, 145, 145, 145, 145, 145, 145, 145, 145, 156, 156, 156, 156,
					156, 156, 156, 156, 156, 158, 158, 1_152, 158, 158, 158, 158, 158, 158, 244, 244, 244, 244, 244,
					244, 244, 244, 244, 245, 245, 245, 245, 245, 245, 245, 245, 245, 250, 250, 250, 250, 250, 250, 250,
					250, 250, 375, 375, 375, 375, 1_152, 375, 375, 375, 382, 382, 382, 382, 382, 382, 382, 382, 382,
					384, 384, 384, 384, 384, 384, 384, 384, 384, 156, 156, 156, 156, 156, 156, 156, 156, 156, 158, 158,
					1_152, 158, 158, 158, 158, 158, 158, 525, 525, 1_152, 525, 525, 525, 525, 525, 525, 528, 528, 1_152,
					528, 528, 528, 528, 528, 528, 382, 382, 382, 382, 382, 382, 382, 382, 382, 244, 244, 244, 244, 244,
					244, 244, 244, 244, 384, 384, 384, 384, 384, 384, 384, 384, 384, 245, 245, 245, 245, 245, 245, 245,
					245, 245, 35, 35, 35, 35, 35, 35, 35, 35, 35, 40, 40, 40, 40, 40, 40, 40, 40, 40, 662, 662, 662,
					662, 662, 662, 662, 662, 662, 665, 665, 665, 665, 665, 665, 665, 665, 665, 670, 670, 670, 670, 670,
					670, 670, 670, 670, 777, 777, 777, 777, 777, 777, 777, 777, 777, 668, 668, 668, 668, 668, 668, 668,
					668, 668, 793, 793, 793, 793, 793, 793, 793, 793, 793, 375, 375, 375, 1_152, 1_152, 375, 375, 375,
					775, 775, 775, 775, 775, 775, 775, 775, 775, 853, 853, 853, 853, 853, 853, 853, 853, 853, 866, 866,
					866, 866, 866, 866, 866, 866, 866, 791, 791, 791, 791, 791, 791, 791, 791, 791, 668, 668, 668, 668,
					668, 668, 668, 668, 668, 871, 871, 871, 871, 871, 871, 871, 871, 871, 876, 876, 876, 876, 876, 876,
					876, 876, 876, 890, 890, 890, 890, 890, 890, 890, 890, 890, 670, 670, 670, 670, 670, 670, 670, 670,
					670, 793, 793, 793, 793, 793, 793, 793, 793, 793, 851, 851, 851, 851, 851, 851, 851, 851, 851, 775,
					775, 775, 775, 775, 775, 775, 775, 775, 907, 907, 907, 907, 907, 907, 907, 907, 907, 912, 912, 912,
					912, 912, 912, 912, 912, 912, 926, 926, 926, 926, 926, 926, 926, 926, 926, 777, 777, 777, 777, 777,
					777, 777, 777, 777, 853, 853, 853, 853, 853, 853, 853, 853, 853, 866, 866, 866, 866, 866, 866, 866,
					866, 866, 932, 932, 932, 932, 932, 932, 932, 932, 932, 525, 525, 525, 525, 525, 525, 525, 525, 525,
					528, 528, 528, 528, 528, 528, 528, 528, 528, 888, 888, 888, 888, 888, 888, 888, 888, 888, 871, 871,
					871, 871, 871, 871, 871, 871, 871, 791, 791, 791, 791, 791, 791, 791, 791, 791, 876, 876, 876, 876,
					876, 876, 876, 876, 876, 793, 793, 793, 793, 793, 793, 793, 793, 793, 940, 940, 940, 940, 940, 940,
					940, 940, 940, 945, 945, 945, 945, 945, 945, 945, 945, 945, 670, 670, 670, 670, 670, 670, 670, 670,
					670, 92, 92, 1_152, 1_152, 1_152, 92, 92, 92, 924, 924, 924, 924, 924, 924, 924, 924, 924, 907, 907,
					907, 907, 907, 907, 907, 907, 907, 851, 851, 851, 851, 851, 851, 851, 851, 851, 912, 912, 912, 912,
					912, 912, 912, 912, 912, 853, 853, 853, 853, 853, 853, 853, 853, 853, 967, 967, 967, 967, 967, 967,
					967, 967, 967, 972, 972, 972, 972, 972, 972, 972, 972, 972, 985, 985, 985, 985, 985, 985, 985, 985,
					985, 525, 525, 525, 525, 525, 525, 525, 525, 525, 528, 528, 528, 528, 528, 528, 528, 528, 528, 888,
					888, 888, 888, 888, 888, 888, 888, 888, 890, 890, 890, 890, 890, 890, 890, 890, 890, 876, 876, 876,
					876, 876, 876, 876, 876, 876, 940, 940, 940, 940, 940, 940, 940, 940, 940, 791, 791, 791, 791, 791,
					791, 791, 791, 791, 945, 945, 945, 945, 945, 945, 945, 945, 945, 793, 793, 793, 793, 793, 793, 793,
					793, 793, 992, 992, 992, 992, 992, 992, 992, 992, 992, 996, 996, 996, 996, 996, 996, 996, 996, 996,
					375, 375, 375, 1_152, 1_152, 375, 375, 375, 92, 92, 1_152, 1_152, 1_152, 92, 92, 92, 924, 924, 924,
					924, 924, 924, 924, 924, 924, 926, 926, 926, 926, 926, 926, 926, 926, 926, 912, 912, 912, 912, 912,
					912, 912, 912, 912, 967, 967, 967, 967, 967, 967, 967, 967, 967, 851, 851, 851, 851, 851, 851, 851,
					851, 851, 972, 972, 972, 972, 972, 972, 972, 972, 972, 853, 853, 853, 853, 853, 853, 853, 853, 853,
					985, 985, 985, 985, 985, 985, 985, 985, 985, 932, 932, 932, 932, 932, 932, 932, 932, 932, 525, 525,
					525, 525, 525, 525, 525, 525, 525, 528, 528, 528, 528, 528, 528, 528, 528, 528, 888, 888, 888, 888,
					888, 888, 888, 888, 888, 890, 890, 890, 890, 890, 890, 890, 890, 890, 992, 992, 992, 992, 992, 992,
					992, 992, 992, 775, 775, 775, 775, 775, 775, 775, 775, 775, 1_016, 1_016, 1_016, 1_016, 1_016, 1_016,
					1_016, 1_016, 1_016, 1_020, 1_020, 1_020, 1_020, 1_020, 1_020, 1_020, 1_020, 1_020, 996, 996, 996,
					996, 996, 996, 996, 996, 996, 1_024, 1_024, 1_024, 1_024, 1_024, 1_024, 1_024, 1_024, 1_024, 1_027,
					1_027, 1_027, 1_027, 1_027, 1_027, 1_027, 1_027, 1_027, 1_033, 1_033, 1_033, 1_033, 1_033, 1_033,
					1_033, 1_033, 1_033, 945, 945, 945, 945, 945, 945, 945, 945, 945, 375, 375, 375, 1_152, 1_152, 375,
					375, 375, 924, 924, 924, 924, 924, 924, 924, 924, 924, 926, 926, 926, 926, 926, 926, 926, 926, 926,
					972, 972, 972, 972, 972, 972, 972, 972, 972, 1_044, 1_044, 1_044, 1_044, 1_044, 1_044, 1_044, 1_044,
					1_044, 907, 907, 907, 907, 907, 907, 907, 907, 907, 1_053, 1_053, 1_053, 1_053, 1_053, 1_053, 1_053,
					1_053, 1_053, 992, 992, 992, 992, 992, 992, 992, 992, 992, 1_016, 1_016, 1_016, 1_016, 1_016, 1_016,
					1_016, 1_016, 1_016, 1_060, 1_060, 1_060, 1_060, 1_060, 1_060, 1_060, 1_060, 1_060, 1_065, 1_065,
					1_065, 1_065, 1_065, 1_065, 1_065, 1_065, 1_065, 996, 996, 996, 996, 996, 996, 996, 996, 996, 1_024,
					1_024, 1_024, 1_024, 1_024, 1_024, 1_024, 1_024, 1_024, 1_072, 1_072, 1_072, 1_072, 1_072, 1_072,
					1_072, 1_072, 1_072, 1_077, 1_077, 1_077, 1_077, 1_077, 1_077, 1_077, 1_077, 1_077, 670, 670, 670,
					670, 670, 670, 670, 670, 670, 1_095, 1_095, 1_095, 1_095, 1_095, 1_095, 1_095, 1_095, 1_095, 525,
					525, 1_152, 525, 525, 525, 525, 525, 525, 992, 992, 992, 992, 992, 992, 992, 992, 992, 1_060, 1_060,
					1_060, 1_060, 1_060, 1_060, 1_060, 1_060, 1_060, 1_065, 1_065, 1_065, 1_065, 1_065, 1_065, 1_065,
					1_065, 1_065, 528, 528, 1_152, 528, 528, 528, 528, 528, 528, 996, 996, 996, 996, 996, 996, 996, 996,
					996, 1_072, 1_072, 1_072, 1_072, 1_072, 1_072, 1_072, 1_072, 1_072, 791, 791, 791, 791, 791, 791,
					791, 791, 791, 1_077, 1_077, 1_077, 1_077, 1_077, 1_077, 1_077, 1_077, 1_077, 793, 793, 793, 793,
					793, 793, 793, 793, 793, 670, 670, 670, 670, 670, 670, 670, 670, 670, 777, 777, 777, 777, 777, 777,
					777, 777, 777, 876, 876, 876, 876, 876, 876, 876, 876, 876, 1_116, 1_116, 1_116, 1_116, 1_116, 1_116,
					1_116, 1_116, 1_116, 1_118, 1_118, 1_118, 1_118, 1_118, 1_118, 1_118, 1_118, 1_118, 866, 866, 866,
					866, 866, 866, 866, 866, 866, 1_095, 1_095, 1_095, 1_095, 1_095, 1_095, 1_095, 1_095, 1_095, 1_044,
					1_044, 1_044, 1_044, 1_044, 1_044, 1_044, 1_044, 1_044, 888, 888, 888, 888, 888, 888, 888, 888, 888,
					890, 890, 890, 890, 890, 890, 890, 890, 890, 1_129, 1_129, 1_129, 1_129, 1_129, 1_129, 1_129, 1_129,
					1_129, 1_140, 1_140, 1_140, 1_140, 1_140, 1_140, 1_140, 1_140, 1_140, 1_146, 1_146, 1_146, 1_146,
					1_146, 1_146, 1_146, 1_146, 1_146, 1_147, 1_147, 1_147, 1_147, 1_147, 1_147, 1_147, 1_147, 1_147,
					3, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152
				>>)
		end

	yy_chk: CE_STATIC [CE_ARRAY [INTEGER_16]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_16_ARRAY}.make_initialized (<<
					0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
					1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
					1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 8, 10, 13, 20, 5, 5,
					34, 40, 5, 6, 6, 53, 52, 6, 7, 7, 7, 7, 7, 35, 65, 5, 52, 43, 55, 85, 6, 34, 58, 53, 55, 67, 7, 52,
					53, 32, 32, 32, 32, 32, 70, 13, 65, 58, 1_163, 55, 10, 20, 66, 8, 58, 61, 40, 32, 67, 7, 14, 14,
					14, 14, 14, 14, 14, 14, 14, 14, 5, 43, 35, 66, 85, 6, 843, 61, 61, 843, 32, 7, 16, 56, 56, 544, 90,
					544, 70, 16, 16, 90, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 32, 151, 56, 1_147, 16, 16, 16, 16,
					16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16,
					16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 19, 21, 68, 16, 73, 79, 19, 144, 151, 1_146,
					19, 57, 144, 19, 54, 26, 26, 26, 26, 26, 57, 125, 54, 19, 54, 68, 79, 125, 19, 26, 26, 19, 57, 26,
					19, 54, 134, 205, 555, 21, 555, 205, 125, 54, 80, 21, 26, 45, 73, 45, 45, 45, 45, 45, 45, 45, 45,
					45, 45, 134, 21, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 138, 140, 101, 1_140, 22, 22, 22, 22, 22,
					22, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 26, 81, 80, 60, 101, 101, 81, 22, 22, 22, 22, 22, 37,
					37, 37, 146, 153, 148, 1_139, 60, 146, 60, 178, 60, 138, 140, 60, 178, 136, 178, 37, 37, 37, 37,
					37, 37, 37, 37, 37, 37, 60, 96, 60, 86, 37, 37, 37, 37, 37, 37, 72, 136, 86, 822, 207, 81, 97, 96,
					207, 822, 97, 153, 97, 96, 107, 107, 148, 37, 37, 37, 37, 37, 39, 39, 39, 39, 39, 39, 39, 39, 39,
					39, 97, 72, 1_132, 107, 39, 39, 39, 39, 39, 39, 1_129, 251, 72, 161, 59, 86, 251, 137, 116, 59, 215,
					97, 72, 123, 59, 123, 135, 39, 39, 39, 39, 39, 41, 41, 41, 59, 161, 116, 120, 137, 59, 116, 120,
					120, 120, 120, 123, 135, 123, 147, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 126, 126, 1_121, 127,
					41, 41, 41, 41, 41, 41, 147, 160, 127, 149, 215, 160, 106, 160, 149, 117, 106, 126, 106, 117, 127,
					117, 1_120, 41, 41, 41, 41, 41, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 106, 106, 236, 117, 44, 44,
					44, 44, 44, 44, 122, 162, 122, 122, 122, 122, 122, 122, 578, 1_118, 578, 106, 106, 236, 117, 149,
					1_116, 44, 44, 44, 44, 44, 63, 63, 162, 1_095, 1_076, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63,
					63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63,
					63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63,
					63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 71, 71, 71, 71, 71, 71, 71, 71, 71, 71,
					1_075, 1_072, 128, 131, 71, 71, 71, 71, 71, 71, 154, 584, 1_050, 584, 170, 172, 100, 128, 183, 154,
					100, 100, 100, 100, 128, 131, 131, 71, 71, 71, 71, 71, 74, 74, 74, 74, 74, 170, 172, 181, 166, 183,
					100, 74, 166, 312, 166, 1_049, 1_034, 312, 100, 74, 74, 74, 74, 74, 74, 74, 74, 74, 74, 181, 181,
					100, 154, 74, 74, 74, 74, 74, 74, 100, 182, 1_031, 1_015, 184, 104, 182, 238, 182, 104, 104, 104,
					104, 1_014, 376, 187, 74, 74, 74, 74, 74, 74, 82, 82, 82, 82, 82, 184, 82, 238, 124, 104, 124, 124,
					124, 124, 124, 124, 187, 985, 104, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 130, 104, 176, 377, 82,
					82, 82, 82, 82, 82, 104, 186, 376, 971, 383, 186, 130, 186, 130, 383, 130, 176, 970, 130, 188, 176,
					82, 82, 82, 82, 82, 82, 84, 84, 84, 84, 84, 130, 169, 130, 195, 195, 169, 169, 169, 169, 314, 188,
					377, 197, 314, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 195, 199, 237, 967, 84, 84, 84, 84, 84, 84,
					141, 197, 192, 944, 239, 177, 192, 385, 192, 177, 141, 177, 385, 237, 199, 252, 84, 84, 84, 84, 84,
					84, 87, 87, 87, 87, 87, 239, 220, 196, 220, 177, 87, 196, 196, 196, 196, 525, 368, 255, 943, 87,
					87, 87, 87, 87, 87, 87, 87, 87, 87, 220, 177, 220, 141, 87, 87, 87, 87, 87, 87, 212, 255, 246, 940,
					212, 240, 212, 102, 252, 256, 932, 102, 102, 102, 102, 240, 87, 87, 87, 87, 87, 87, 91, 246, 268,
					525, 91, 91, 91, 91, 254, 368, 256, 102, 254, 129, 254, 102, 927, 270, 129, 528, 91, 91, 91, 129,
					91, 268, 91, 924, 280, 91, 91, 91, 102, 280, 129, 280, 102, 240, 911, 129, 270, 284, 91, 91, 91,
					91, 284, 91, 284, 910, 91, 91, 91, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 397, 528, 417, 285, 93,
					93, 93, 93, 93, 93, 203, 589, 907, 589, 203, 203, 203, 203, 217, 286, 290, 291, 217, 217, 217, 217,
					285, 93, 93, 93, 93, 93, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 286, 290, 291, 295, 95, 95, 95,
					95, 95, 95, 296, 891, 397, 108, 417, 419, 95, 108, 111, 108, 303, 888, 111, 111, 111, 111, 295, 95,
					95, 95, 95, 95, 259, 296, 108, 294, 259, 95, 259, 108, 294, 115, 294, 303, 111, 115, 115, 115, 115,
					111, 257, 257, 257, 257, 257, 263, 108, 665, 211, 263, 108, 263, 211, 789, 211, 111, 344, 115, 789,
					419, 111, 875, 305, 115, 121, 115, 344, 121, 121, 121, 121, 121, 121, 121, 211, 874, 277, 344, 115,
					121, 277, 121, 277, 871, 115, 305, 115, 119, 119, 119, 119, 119, 665, 866, 219, 211, 219, 219, 219,
					219, 219, 219, 121, 601, 121, 601, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 329, 627, 329,
					627, 119, 119, 119, 119, 119, 119, 258, 258, 258, 258, 258, 191, 353, 353, 351, 191, 191, 191, 191,
					329, 351, 329, 119, 119, 119, 119, 119, 119, 139, 139, 139, 139, 139, 353, 371, 351, 221, 191, 221,
					221, 221, 221, 221, 221, 854, 851, 191, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 371, 191,
					357, 364, 139, 139, 139, 139, 139, 139, 191, 232, 232, 232, 232, 232, 267, 357, 850, 392, 267, 267,
					267, 267, 357, 364, 364, 139, 139, 139, 139, 139, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142,
					392, 369, 232, 346, 142, 142, 142, 142, 142, 142, 272, 272, 272, 272, 272, 273, 273, 273, 273, 273,
					393, 346, 369, 370, 232, 232, 346, 142, 142, 142, 142, 142, 150, 150, 150, 150, 150, 150, 150, 150,
					150, 150, 440, 393, 370, 409, 150, 150, 150, 150, 150, 150, 274, 274, 274, 274, 274, 287, 287, 287,
					287, 287, 288, 288, 288, 288, 288, 794, 409, 150, 150, 150, 150, 150, 152, 152, 152, 152, 152, 152,
					152, 152, 152, 152, 386, 791, 790, 411, 152, 152, 152, 152, 152, 152, 782, 778, 440, 224, 224, 224,
					224, 224, 289, 298, 775, 386, 289, 298, 289, 298, 411, 152, 152, 152, 152, 152, 155, 155, 155, 155,
					155, 155, 155, 155, 155, 155, 634, 406, 634, 634, 155, 155, 155, 155, 155, 155, 292, 292, 292, 292,
					292, 774, 224, 406, 157, 157, 157, 157, 157, 406, 224, 433, 224, 155, 155, 155, 155, 155, 157, 157,
					165, 318, 157, 224, 165, 318, 165, 318, 662, 520, 433, 224, 302, 356, 433, 157, 302, 302, 302, 302,
					165, 293, 293, 293, 293, 293, 165, 654, 218, 355, 520, 218, 218, 218, 218, 218, 218, 218, 355, 354,
					321, 772, 165, 218, 321, 218, 321, 165, 654, 751, 355, 266, 266, 266, 266, 266, 783, 662, 356, 750,
					157, 159, 159, 159, 159, 159, 218, 356, 218, 307, 307, 307, 307, 307, 308, 308, 308, 308, 308, 356,
					159, 159, 159, 159, 159, 159, 159, 159, 159, 159, 266, 435, 354, 354, 159, 159, 159, 159, 159, 159,
					283, 283, 283, 283, 283, 783, 266, 309, 309, 309, 309, 309, 266, 354, 435, 748, 747, 159, 159, 159,
					159, 159, 216, 216, 216, 216, 216, 216, 216, 216, 216, 216, 447, 283, 741, 436, 216, 216, 216, 216,
					216, 216, 315, 315, 315, 315, 315, 223, 223, 223, 223, 223, 352, 431, 739, 283, 283, 347, 436, 216,
					216, 216, 216, 216, 222, 222, 222, 222, 222, 225, 225, 225, 225, 225, 735, 431, 431, 226, 226, 226,
					226, 226, 442, 222, 223, 1_051, 447, 222, 222, 222, 222, 678, 223, 347, 443, 227, 227, 227, 227,
					227, 352, 733, 223, 427, 365, 442, 352, 223, 427, 222, 427, 347, 678, 223, 225, 449, 347, 443, 225,
					222, 730, 352, 226, 786, 225, 228, 228, 228, 228, 228, 222, 226, 226, 473, 1_051, 225, 365, 473,
					449, 225, 227, 227, 729, 226, 229, 229, 229, 229, 229, 712, 227, 358, 226, 301, 301, 301, 301, 301,
					365, 365, 391, 227, 227, 398, 391, 228, 391, 398, 786, 398, 228, 233, 233, 233, 233, 233, 807, 310,
					468, 711, 228, 310, 310, 310, 310, 345, 470, 228, 359, 229, 358, 228, 709, 359, 229, 480, 326, 807,
					359, 229, 326, 326, 326, 326, 233, 358, 708, 301, 301, 359, 229, 233, 358, 705, 359, 229, 230, 230,
					230, 230, 230, 316, 316, 316, 316, 316, 233, 233, 301, 345, 450, 703, 468, 233, 234, 234, 234, 234,
					234, 345, 470, 702, 242, 242, 242, 242, 242, 460, 242, 480, 345, 230, 242, 450, 242, 317, 317, 317,
					317, 317, 242, 230, 394, 394, 394, 394, 394, 230, 697, 230, 460, 230, 402, 475, 230, 349, 402, 475,
					402, 234, 457, 457, 230, 349, 234, 349, 482, 695, 230, 234, 230, 231, 231, 231, 231, 231, 349, 242,
					462, 615, 234, 457, 363, 615, 349, 234, 363, 363, 363, 363, 231, 692, 691, 434, 231, 231, 231, 231,
					434, 617, 434, 462, 327, 617, 231, 327, 327, 327, 327, 327, 327, 327, 395, 395, 395, 395, 395, 327,
					519, 327, 482, 324, 324, 324, 324, 324, 231, 231, 241, 241, 241, 241, 241, 401, 401, 401, 401, 401,
					689, 348, 327, 519, 327, 348, 348, 348, 348, 241, 241, 241, 241, 241, 241, 241, 241, 241, 241, 324,
					688, 348, 493, 241, 241, 241, 241, 241, 241, 328, 671, 328, 328, 328, 328, 328, 328, 348, 324, 668,
					740, 493, 324, 348, 740, 493, 241, 241, 241, 241, 241, 243, 243, 243, 243, 243, 243, 243, 243, 243,
					243, 497, 497, 497, 497, 243, 243, 243, 243, 243, 243, 330, 661, 330, 330, 330, 330, 330, 330, 408,
					687, 823, 687, 408, 408, 408, 408, 823, 243, 243, 243, 243, 243, 247, 247, 247, 247, 247, 247, 247,
					247, 247, 247, 516, 516, 516, 516, 247, 247, 247, 247, 247, 247, 341, 341, 341, 341, 341, 413, 413,
					413, 413, 413, 414, 414, 414, 414, 414, 657, 629, 247, 247, 247, 247, 247, 248, 248, 248, 248, 248,
					248, 248, 248, 248, 248, 628, 341, 539, 545, 248, 248, 248, 248, 248, 248, 415, 415, 415, 415, 415,
					420, 423, 625, 623, 420, 423, 420, 423, 341, 341, 539, 545, 248, 248, 248, 248, 248, 249, 249, 249,
					249, 249, 249, 249, 249, 249, 249, 484, 554, 546, 560, 249, 249, 249, 249, 249, 249, 430, 430, 430,
					430, 430, 437, 437, 437, 437, 437, 438, 438, 438, 438, 438, 546, 560, 249, 249, 249, 249, 249, 253,
					253, 253, 253, 253, 253, 253, 253, 253, 253, 1_063, 430, 562, 585, 253, 253, 253, 253, 253, 253,
					432, 441, 484, 554, 707, 441, 707, 441, 444, 444, 444, 444, 444, 430, 430, 562, 585, 253, 253, 253,
					253, 253, 276, 276, 276, 276, 276, 276, 276, 276, 276, 276, 432, 600, 575, 1_063, 276, 276, 276,
					276, 276, 276, 445, 445, 445, 445, 445, 518, 518, 518, 518, 448, 586, 575, 432, 432, 448, 575, 448,
					276, 276, 276, 276, 276, 325, 325, 325, 325, 325, 325, 325, 325, 325, 325, 458, 586, 590, 591, 325,
					325, 325, 325, 325, 325, 622, 616, 407, 600, 626, 332, 332, 332, 332, 332, 451, 451, 451, 451, 451,
					590, 591, 325, 325, 325, 325, 325, 331, 331, 331, 331, 331, 333, 333, 333, 333, 333, 360, 494, 334,
					334, 334, 334, 334, 614, 407, 331, 332, 458, 458, 331, 331, 331, 331, 609, 332, 335, 335, 335, 335,
					335, 407, 453, 626, 607, 332, 453, 407, 453, 458, 332, 742, 331, 494, 485, 742, 332, 333, 485, 603,
					485, 360, 331, 706, 334, 333, 360, 333, 334, 602, 594, 360, 494, 331, 334, 594, 494, 594, 333, 849,
					595, 335, 360, 599, 849, 334, 333, 360, 650, 334, 335, 335, 336, 336, 336, 336, 336, 350, 559, 559,
					559, 559, 335, 595, 650, 337, 337, 337, 337, 337, 650, 335, 452, 452, 452, 452, 452, 706, 338, 338,
					338, 338, 338, 580, 342, 342, 342, 342, 342, 724, 579, 724, 343, 343, 343, 343, 343, 336, 336, 844,
					489, 350, 844, 596, 489, 337, 489, 336, 459, 350, 337, 350, 459, 459, 459, 459, 573, 342, 336, 336,
					337, 362, 350, 338, 342, 361, 596, 337, 338, 572, 350, 337, 549, 338, 606, 569, 549, 343, 549, 342,
					342, 361, 343, 361, 338, 361, 342, 343, 361, 338, 339, 339, 339, 339, 339, 362, 568, 606, 343, 563,
					663, 608, 361, 343, 361, 663, 456, 456, 456, 456, 456, 362, 746, 362, 746, 362, 567, 561, 362, 582,
					567, 867, 567, 366, 608, 339, 867, 366, 366, 366, 366, 870, 362, 571, 362, 339, 870, 571, 582, 571,
					366, 339, 582, 339, 636, 339, 636, 636, 339, 426, 426, 426, 426, 426, 663, 557, 339, 683, 556, 366,
					456, 456, 339, 366, 339, 340, 340, 340, 340, 340, 464, 464, 464, 464, 464, 465, 465, 465, 465, 465,
					683, 456, 872, 553, 340, 426, 684, 872, 340, 340, 340, 340, 551, 374, 374, 374, 374, 374, 340, 374,
					819, 550, 819, 374, 426, 374, 621, 491, 426, 684, 621, 374, 621, 490, 405, 405, 405, 405, 405, 487,
					340, 340, 373, 373, 373, 373, 373, 373, 373, 373, 373, 373, 605, 605, 605, 605, 373, 373, 373, 373,
					373, 373, 466, 466, 466, 466, 466, 906, 374, 694, 471, 486, 906, 405, 471, 471, 471, 471, 483, 373,
					373, 373, 373, 373, 375, 375, 375, 375, 375, 405, 375, 820, 694, 820, 375, 405, 375, 379, 379, 379,
					379, 379, 375, 379, 481, 479, 474, 379, 472, 379, 379, 613, 613, 613, 613, 379, 476, 476, 476, 476,
					476, 477, 477, 477, 477, 477, 478, 478, 478, 478, 478, 488, 488, 488, 488, 488, 469, 467, 499, 375,
					499, 499, 499, 499, 499, 499, 547, 547, 547, 547, 547, 463, 379, 380, 380, 380, 380, 380, 380, 380,
					380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380,
					380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380,
					380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380,
					380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 381, 381, 381, 381, 381, 548,
					548, 548, 548, 548, 461, 492, 492, 492, 492, 492, 455, 576, 454, 381, 381, 381, 381, 381, 381, 381,
					381, 381, 381, 446, 439, 652, 696, 381, 381, 381, 381, 381, 381, 498, 498, 498, 498, 498, 498, 498,
					716, 492, 429, 714, 652, 498, 576, 498, 652, 696, 381, 381, 381, 381, 381, 387, 387, 387, 387, 387,
					492, 387, 714, 716, 492, 576, 714, 701, 498, 576, 498, 701, 428, 701, 387, 387, 387, 387, 387, 387,
					387, 387, 387, 387, 717, 425, 720, 424, 387, 387, 387, 387, 387, 387, 500, 500, 500, 500, 500, 500,
					500, 552, 552, 552, 552, 552, 500, 717, 500, 720, 387, 387, 387, 387, 387, 387, 388, 388, 388, 388,
					388, 501, 721, 501, 501, 501, 501, 501, 501, 500, 422, 500, 388, 421, 418, 388, 388, 388, 388, 388,
					388, 388, 388, 388, 388, 721, 416, 412, 410, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388,
					388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388,
					388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 404, 403, 400, 388, 389, 389, 389, 389,
					389, 564, 564, 564, 564, 564, 389, 399, 908, 515, 515, 515, 515, 908, 396, 389, 389, 389, 389, 389,
					389, 389, 389, 389, 389, 515, 725, 726, 1_052, 389, 389, 389, 389, 389, 389, 1_052, 512, 512, 512,
					512, 512, 515, 565, 565, 565, 565, 565, 515, 384, 725, 726, 389, 389, 389, 389, 389, 389, 390, 390,
					390, 390, 390, 390, 390, 390, 390, 390, 382, 367, 512, 732, 390, 390, 390, 390, 390, 390, 1_052,
					323, 504, 504, 504, 504, 504, 322, 320, 502, 502, 502, 502, 502, 512, 512, 732, 390, 390, 390, 390,
					390, 496, 496, 496, 496, 496, 496, 496, 496, 496, 496, 502, 502, 502, 502, 496, 496, 496, 496, 496,
					496, 503, 503, 503, 503, 503, 504, 319, 505, 505, 505, 505, 505, 502, 504, 313, 504, 311, 496, 496,
					496, 496, 496, 502, 306, 304, 300, 504, 506, 506, 506, 506, 506, 299, 502, 504, 666, 734, 503, 297,
					507, 507, 507, 507, 507, 666, 503, 508, 508, 508, 508, 508, 282, 505, 784, 281, 503, 505, 832, 784,
					734, 503, 279, 505, 278, 832, 275, 503, 566, 566, 566, 566, 566, 506, 505, 787, 936, 271, 505, 269,
					265, 936, 506, 506, 787, 507, 507, 508, 832, 264, 666, 262, 508, 261, 506, 507, 509, 509, 509, 509,
					509, 260, 508, 506, 250, 941, 507, 507, 784, 508, 941, 245, 244, 508, 570, 570, 570, 570, 570, 511,
					511, 511, 511, 511, 513, 513, 513, 513, 513, 787, 214, 833, 213, 514, 514, 514, 514, 514, 833, 210,
					209, 509, 511, 511, 511, 511, 509, 208, 206, 204, 202, 509, 511, 517, 517, 517, 517, 513, 963, 201,
					968, 833, 509, 963, 513, 968, 517, 509, 510, 510, 510, 510, 510, 200, 511, 511, 986, 990, 514, 513,
					513, 986, 990, 514, 198, 517, 513, 194, 514, 517, 523, 523, 523, 523, 523, 1_005, 1_043, 193, 190,
					514, 1_005, 1_043, 523, 510, 514, 1_073, 1_096, 189, 523, 1_064, 1_073, 1_096, 1_064, 510, 558, 558,
					558, 558, 558, 510, 1_098, 510, 185, 510, 180, 1_098, 510, 587, 587, 587, 587, 587, 179, 175, 510,
					574, 574, 574, 574, 574, 510, 174, 510, 522, 522, 522, 522, 522, 522, 522, 522, 522, 522, 558, 1_064,
					173, 171, 522, 522, 522, 522, 522, 522, 588, 588, 588, 588, 588, 1_109, 558, 168, 574, 1_117, 1_109,
					1_130, 558, 167, 1_117, 164, 1_130, 522, 522, 522, 522, 522, 524, 524, 524, 524, 524, 574, 524, 163,
					158, 574, 524, 1_133, 524, 524, 156, 145, 1_133, 143, 524, 526, 526, 526, 526, 526, 592, 592, 592,
					592, 592, 133, 132, 526, 531, 531, 531, 531, 531, 526, 531, 118, 114, 113, 531, 112, 531, 593, 593,
					593, 593, 593, 531, 110, 109, 105, 103, 524, 527, 527, 527, 597, 597, 597, 597, 597, 581, 581, 581,
					581, 581, 598, 598, 598, 598, 598, 527, 527, 527, 527, 527, 527, 527, 527, 527, 527, 99, 98, 94,
					531, 527, 527, 527, 527, 527, 527, 92, 89, 83, 581, 610, 610, 610, 610, 610, 611, 611, 611, 611,
					611, 78, 77, 64, 527, 527, 527, 527, 527, 529, 529, 529, 581, 581, 612, 612, 612, 612, 612, 618,
					618, 618, 618, 618, 62, 51, 48, 529, 529, 529, 529, 529, 529, 529, 529, 529, 529, 46, 42, 38, 33,
					529, 529, 529, 529, 529, 529, 619, 619, 619, 619, 619, 620, 620, 620, 620, 620, 624, 624, 624, 624,
					624, 29, 25, 529, 529, 529, 529, 529, 530, 530, 530, 530, 530, 530, 24, 530, 17, 15, 1_148, 530,
					530, 530, 530, 1_148, 9, 3, 0, 530, 532, 532, 532, 532, 532, 0, 532, 0, 0, 0, 532, 0, 532, 533, 533,
					533, 533, 533, 532, 533, 0, 0, 0, 533, 0, 533, 604, 604, 604, 604, 604, 533, 0, 0, 0, 0, 530, 0,
					534, 534, 534, 534, 534, 0, 534, 0, 0, 0, 534, 0, 534, 0, 0, 0, 0, 532, 534, 535, 535, 535, 535,
					535, 0, 535, 0, 0, 0, 535, 533, 535, 535, 1_028, 1_028, 0, 0, 535, 0, 0, 0, 1_028, 604, 604, 1_028,
					633, 633, 633, 0, 633, 633, 633, 950, 950, 950, 534, 0, 633, 0, 633, 0, 950, 0, 604, 950, 0, 0, 0,
					630, 630, 630, 630, 630, 0, 535, 536, 536, 536, 536, 536, 633, 536, 633, 0, 0, 536, 1_028, 536, 647,
					647, 647, 647, 647, 536, 536, 536, 536, 536, 536, 536, 536, 536, 536, 536, 630, 0, 950, 0, 536, 536,
					536, 536, 536, 536, 685, 685, 685, 685, 685, 0, 0, 0, 0, 630, 0, 0, 0, 630, 0, 0, 536, 536, 536,
					536, 536, 536, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537,
					537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537,
					537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537,
					537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537, 537,
					537, 537, 537, 537, 538, 538, 538, 538, 538, 686, 686, 686, 686, 686, 0, 679, 679, 679, 679, 679,
					0, 679, 0, 538, 538, 538, 538, 538, 538, 538, 538, 538, 538, 0, 0, 0, 0, 538, 538, 538, 538, 538,
					538, 635, 635, 635, 0, 635, 635, 635, 637, 637, 637, 637, 637, 635, 0, 635, 0, 0, 538, 538, 538,
					538, 538, 540, 540, 540, 540, 540, 679, 540, 690, 690, 690, 690, 690, 0, 635, 0, 635, 0, 0, 0, 540,
					540, 540, 540, 540, 540, 540, 540, 540, 540, 0, 637, 0, 0, 540, 540, 540, 540, 540, 540, 0, 637,
					0, 639, 639, 639, 639, 639, 0, 0, 0, 0, 637, 0, 0, 0, 540, 540, 540, 540, 540, 540, 541, 541, 541,
					541, 541, 541, 541, 541, 541, 541, 0, 0, 0, 0, 541, 541, 541, 541, 541, 541, 698, 698, 698, 698,
					698, 0, 639, 642, 642, 642, 642, 642, 0, 0, 639, 0, 639, 541, 541, 541, 541, 541, 542, 542, 542,
					542, 542, 639, 0, 0, 0, 0, 542, 0, 0, 639, 699, 699, 699, 699, 699, 542, 542, 542, 542, 542, 542,
					542, 542, 542, 542, 0, 0, 642, 0, 542, 542, 542, 542, 542, 542, 0, 642, 641, 641, 641, 641, 641,
					700, 700, 700, 700, 700, 0, 642, 0, 0, 542, 542, 542, 542, 542, 542, 543, 543, 543, 543, 543, 543,
					543, 543, 543, 543, 0, 0, 0, 0, 543, 543, 543, 543, 543, 543, 640, 640, 640, 640, 640, 0, 0, 0, 0,
					638, 638, 638, 638, 638, 641, 641, 0, 543, 543, 543, 543, 543, 632, 632, 632, 632, 632, 632, 632,
					632, 632, 632, 0, 0, 0, 641, 632, 632, 632, 632, 632, 632, 0, 0, 0, 0, 638, 0, 0, 640, 643, 643,
					643, 643, 643, 640, 0, 0, 0, 632, 632, 632, 632, 632, 638, 0, 0, 0, 0, 638, 640, 644, 644, 644, 644,
					644, 645, 645, 645, 645, 645, 0, 0, 0, 646, 646, 646, 646, 646, 0, 643, 0, 648, 648, 648, 648, 648,
					693, 693, 693, 693, 693, 0, 0, 0, 643, 649, 649, 649, 649, 649, 645, 643, 0, 0, 0, 644, 646, 0, 0,
					0, 644, 1_066, 1_066, 0, 0, 644, 645, 0, 645, 1_066, 645, 648, 1_066, 645, 0, 693, 644, 0, 646, 646,
					0, 644, 0, 0, 0, 0, 648, 645, 0, 645, 649, 693, 0, 648, 0, 649, 0, 693, 0, 0, 649, 704, 704, 704,
					704, 704, 718, 718, 718, 718, 718, 649, 0, 0, 1_066, 0, 649, 656, 656, 656, 656, 656, 656, 656, 656,
					656, 656, 0, 0, 0, 0, 656, 656, 656, 656, 656, 656, 0, 0, 0, 0, 710, 710, 710, 710, 710, 719, 719,
					719, 719, 719, 0, 0, 0, 656, 656, 656, 656, 656, 658, 658, 658, 658, 658, 658, 0, 658, 0, 0, 0, 658,
					658, 658, 658, 0, 0, 0, 710, 658, 659, 659, 659, 659, 659, 0, 0, 669, 669, 669, 669, 669, 659, 0,
					996, 996, 996, 710, 659, 669, 669, 710, 0, 996, 0, 669, 996, 0, 0, 0, 675, 675, 675, 675, 675, 0,
					658, 664, 664, 664, 664, 664, 675, 664, 0, 0, 0, 0, 675, 713, 713, 713, 713, 713, 0, 0, 664, 664,
					664, 664, 664, 664, 664, 664, 664, 664, 0, 0, 996, 0, 664, 664, 664, 664, 664, 664, 722, 722, 722,
					722, 722, 0, 713, 0, 0, 675, 723, 723, 723, 723, 723, 0, 664, 664, 664, 664, 664, 664, 667, 667,
					667, 667, 667, 0, 713, 713, 0, 0, 667, 727, 727, 727, 727, 727, 0, 0, 0, 667, 667, 667, 667, 667,
					667, 667, 667, 667, 667, 0, 0, 0, 0, 667, 667, 667, 667, 667, 667, 728, 728, 728, 728, 728, 736,
					736, 736, 736, 736, 731, 731, 731, 731, 731, 0, 667, 667, 667, 667, 667, 667, 670, 670, 670, 670,
					670, 670, 0, 670, 0, 0, 0, 670, 670, 670, 670, 0, 0, 0, 0, 670, 737, 737, 737, 737, 737, 738, 738,
					738, 738, 738, 743, 743, 743, 743, 743, 744, 744, 744, 744, 744, 0, 0, 731, 731, 745, 745, 745, 745,
					745, 749, 749, 749, 749, 749, 0, 0, 670, 672, 672, 672, 672, 672, 672, 731, 672, 0, 0, 0, 672, 672,
					672, 672, 0, 0, 0, 0, 672, 754, 754, 754, 754, 754, 0, 0, 752, 752, 752, 752, 752, 755, 755, 755,
					755, 755, 756, 756, 756, 756, 756, 0, 0, 760, 760, 760, 760, 760, 0, 764, 764, 764, 764, 764, 0,
					672, 673, 673, 673, 673, 673, 673, 752, 673, 0, 0, 0, 673, 673, 673, 673, 0, 0, 756, 754, 673, 755,
					0, 0, 0, 0, 752, 764, 0, 0, 752, 755, 0, 0, 760, 0, 756, 0, 0, 0, 0, 756, 755, 760, 773, 773, 773,
					773, 773, 764, 764, 0, 0, 0, 0, 760, 0, 673, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674,
					674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674,
					674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674,
					674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 674,
					674, 674, 674, 674, 674, 674, 674, 674, 674, 674, 676, 676, 676, 676, 676, 813, 813, 813, 813, 813,
					0, 0, 676, 761, 761, 761, 761, 761, 676, 676, 676, 676, 676, 676, 676, 676, 676, 676, 676, 0, 0,
					813, 0, 676, 676, 676, 676, 676, 676, 1_021, 1_021, 0, 0, 1_021, 821, 821, 821, 821, 821, 0, 1_021,
					0, 0, 761, 0, 676, 676, 676, 676, 676, 676, 677, 677, 677, 677, 677, 0, 821, 761, 821, 901, 901,
					901, 901, 901, 761, 0, 0, 0, 0, 677, 677, 677, 677, 677, 677, 677, 677, 677, 677, 0, 0, 1_021, 901,
					677, 677, 677, 677, 677, 677, 759, 759, 759, 759, 759, 0, 834, 834, 834, 834, 834, 0, 0, 0, 0, 0,
					0, 677, 677, 677, 677, 677, 680, 680, 680, 680, 680, 680, 680, 680, 680, 680, 834, 0, 0, 0, 680,
					680, 680, 680, 680, 680, 0, 765, 765, 765, 765, 765, 835, 835, 835, 835, 835, 0, 759, 759, 0, 0,
					0, 680, 680, 680, 680, 680, 681, 681, 681, 681, 681, 681, 681, 681, 681, 681, 835, 759, 0, 0, 681,
					681, 681, 681, 681, 681, 757, 757, 757, 757, 757, 0, 0, 0, 0, 758, 758, 758, 758, 758, 765, 0, 0,
					681, 681, 681, 681, 681, 682, 682, 682, 682, 682, 682, 682, 682, 682, 682, 0, 0, 0, 0, 682, 682,
					682, 682, 682, 682, 0, 0, 0, 757, 762, 762, 762, 762, 762, 0, 0, 757, 0, 757, 0, 0, 758, 682, 682,
					682, 682, 682, 758, 0, 757, 763, 763, 763, 763, 763, 0, 0, 757, 0, 0, 0, 0, 758, 0, 766, 766, 766,
					766, 766, 0, 0, 949, 949, 949, 762, 0, 949, 0, 0, 762, 0, 0, 0, 949, 762, 763, 767, 767, 767, 767,
					767, 0, 0, 0, 0, 762, 0, 0, 0, 0, 762, 763, 0, 763, 766, 763, 0, 0, 763, 768, 768, 768, 768, 768,
					769, 769, 769, 769, 769, 766, 0, 0, 763, 0, 763, 949, 766, 992, 992, 992, 0, 767, 992, 0, 0, 0, 767,
					0, 0, 992, 0, 767, 770, 770, 770, 770, 770, 0, 768, 0, 0, 0, 767, 0, 0, 0, 0, 767, 771, 771, 771,
					771, 771, 0, 768, 0, 0, 0, 0, 769, 768, 776, 776, 776, 776, 776, 1_054, 1_054, 770, 0, 1_054, 992,
					0, 776, 776, 0, 0, 1_054, 0, 776, 792, 792, 792, 792, 792, 0, 0, 770, 0, 0, 0, 770, 792, 792, 0,
					0, 0, 0, 792, 0, 0, 0, 0, 771, 777, 777, 777, 777, 777, 777, 0, 777, 0, 0, 0, 777, 777, 777, 777,
					1_054, 0, 0, 0, 777, 795, 795, 795, 795, 795, 0, 795, 0, 0, 0, 795, 0, 795, 795, 0, 0, 0, 0, 795,
					808, 808, 808, 808, 808, 809, 809, 809, 809, 809, 810, 810, 810, 810, 810, 0, 0, 777, 779, 779, 779,
					779, 779, 779, 0, 779, 0, 0, 0, 779, 779, 779, 779, 0, 0, 0, 795, 779, 0, 0, 0, 0, 814, 814, 814,
					814, 814, 815, 815, 815, 815, 815, 0, 0, 0, 808, 0, 0, 0, 0, 809, 0, 0, 0, 0, 810, 816, 816, 816,
					816, 816, 0, 0, 0, 779, 780, 780, 780, 780, 780, 780, 814, 780, 0, 0, 0, 780, 780, 780, 780, 0, 0,
					0, 0, 780, 0, 0, 814, 0, 0, 0, 0, 815, 814, 845, 845, 845, 845, 845, 0, 852, 852, 852, 852, 852,
					0, 0, 0, 0, 0, 0, 816, 852, 852, 0, 0, 0, 0, 852, 0, 845, 780, 781, 781, 781, 781, 781, 781, 781,
					781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781,
					781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781,
					781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781,
					781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 781, 785, 785, 785, 785, 785, 0,
					785, 0, 0, 0, 0, 817, 817, 817, 817, 817, 0, 0, 0, 785, 785, 785, 785, 785, 785, 785, 785, 785, 785,
					0, 0, 0, 0, 785, 785, 785, 785, 785, 785, 1_016, 1_016, 1_016, 0, 0, 1_016, 825, 825, 825, 825, 825,
					0, 1_016, 0, 0, 0, 785, 785, 785, 785, 785, 785, 788, 788, 788, 788, 788, 817, 0, 0, 0, 0, 788, 0,
					0, 0, 0, 0, 0, 825, 0, 788, 788, 788, 788, 788, 788, 788, 788, 788, 788, 0, 0, 0, 1_016, 788, 788,
					788, 788, 788, 788, 825, 825, 824, 824, 824, 824, 824, 826, 826, 826, 826, 826, 0, 0, 0, 0, 788,
					788, 788, 788, 788, 788, 793, 793, 793, 793, 793, 793, 824, 793, 0, 0, 0, 793, 793, 793, 793, 0,
					824, 0, 0, 793, 0, 826, 0, 0, 873, 873, 873, 873, 873, 1_119, 1_119, 1_119, 1_119, 1_119, 0, 824,
					873, 873, 0, 824, 826, 1_119, 873, 0, 826, 0, 0, 1_119, 0, 0, 0, 0, 0, 0, 0, 0, 793, 796, 796, 796,
					796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796,
					796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796,
					796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796,
					796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 796, 797, 797,
					797, 797, 797, 797, 0, 797, 0, 0, 0, 797, 797, 797, 797, 0, 0, 0, 0, 797, 827, 827, 827, 827, 827,
					828, 828, 828, 828, 828, 829, 829, 829, 829, 829, 830, 830, 830, 830, 830, 831, 831, 831, 831, 831,
					836, 836, 836, 836, 836, 837, 837, 837, 837, 837, 0, 797, 798, 798, 798, 798, 798, 798, 0, 798, 0,
					0, 0, 798, 798, 798, 798, 0, 0, 0, 827, 798, 994, 994, 994, 828, 0, 994, 0, 0, 829, 0, 0, 0, 994,
					830, 0, 0, 0, 994, 831, 0, 0, 0, 836, 836, 0, 0, 0, 0, 837, 838, 838, 838, 838, 838, 0, 0, 798, 799,
					799, 799, 799, 799, 799, 836, 799, 0, 0, 0, 799, 799, 799, 799, 0, 0, 994, 0, 799, 839, 839, 839,
					839, 839, 840, 840, 840, 840, 840, 841, 841, 841, 841, 841, 842, 842, 842, 842, 842, 0, 846, 846,
					846, 846, 846, 0, 838, 847, 847, 847, 847, 847, 0, 0, 0, 799, 800, 800, 800, 800, 800, 800, 0, 800,
					0, 0, 0, 800, 800, 800, 800, 0, 0, 0, 839, 800, 846, 0, 0, 840, 0, 0, 0, 0, 841, 1_020, 1_020, 1_020,
					0, 842, 1_020, 0, 0, 0, 0, 846, 0, 1_020, 0, 846, 0, 0, 847, 0, 898, 898, 898, 898, 898, 0, 0, 0,
					800, 801, 801, 801, 801, 801, 801, 0, 801, 0, 0, 0, 801, 801, 801, 801, 0, 0, 0, 0, 801, 855, 855,
					855, 855, 855, 0, 1_020, 889, 889, 889, 889, 889, 855, 855, 0, 0, 0, 0, 855, 889, 889, 0, 0, 0, 0,
					889, 898, 902, 902, 902, 902, 902, 0, 0, 0, 0, 801, 802, 802, 802, 802, 802, 802, 0, 802, 0, 0, 0,
					802, 802, 802, 802, 0, 0, 0, 855, 802, 903, 903, 903, 903, 903, 0, 902, 904, 904, 904, 904, 904,
					905, 905, 905, 905, 905, 962, 962, 962, 962, 962, 1_024, 1_024, 1_024, 902, 0, 0, 0, 902, 0, 1_024,
					0, 0, 1_024, 0, 802, 803, 803, 803, 803, 803, 803, 0, 803, 0, 0, 0, 803, 803, 803, 803, 0, 0, 0,
					903, 803, 909, 909, 909, 909, 909, 904, 0, 0, 0, 0, 905, 0, 909, 909, 0, 962, 0, 0, 909, 1_024, 0,
					0, 1_010, 1_010, 1_010, 1_010, 1_010, 0, 1_010, 0, 0, 0, 0, 0, 0, 0, 803, 804, 804, 804, 804, 804,
					804, 0, 804, 0, 0, 0, 804, 804, 804, 804, 0, 0, 0, 0, 804, 804, 804, 804, 804, 804, 804, 804, 804,
					804, 804, 0, 0, 0, 0, 804, 804, 804, 804, 804, 804, 1_010, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 804, 804, 804, 804, 804, 804, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805,
					805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805,
					805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805,
					805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805, 805,
					805, 805, 805, 805, 805, 805, 805, 805, 806, 806, 806, 806, 806, 0, 0, 0, 0, 0, 0, 0, 806, 0, 0,
					0, 0, 0, 806, 806, 806, 806, 806, 806, 806, 806, 806, 806, 806, 0, 0, 0, 0, 806, 806, 806, 806, 806,
					806, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 806, 806, 806, 806, 806, 806, 811, 811, 811,
					811, 811, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 811, 811, 811, 811, 811, 811, 811, 811, 811,
					811, 0, 997, 997, 997, 811, 811, 811, 811, 811, 811, 997, 0, 0, 997, 0, 0, 0, 0, 997, 0, 0, 0, 0,
					0, 0, 0, 811, 811, 811, 811, 811, 811, 818, 818, 818, 818, 818, 818, 818, 818, 818, 818, 0, 0, 0,
					0, 818, 818, 818, 818, 818, 818, 0, 0, 0, 997, 1_011, 1_011, 1_011, 1_011, 1_011, 0, 0, 0, 0, 0,
					1_011, 0, 0, 818, 818, 818, 818, 818, 853, 853, 853, 853, 853, 853, 0, 853, 0, 0, 0, 853, 853, 853,
					853, 0, 0, 0, 0, 853, 925, 925, 925, 925, 925, 0, 0, 942, 942, 942, 942, 942, 925, 925, 0, 0, 0,
					1_011, 925, 942, 942, 0, 0, 0, 0, 942, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 853, 856, 856, 856, 856, 856,
					856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856,
					856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856,
					856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856,
					856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 856, 857, 857, 857, 857,
					857, 857, 0, 857, 0, 0, 0, 857, 857, 857, 857, 0, 0, 0, 0, 857, 969, 969, 969, 969, 969, 0, 0, 993,
					993, 993, 993, 993, 969, 969, 0, 0, 0, 0, 969, 993, 993, 0, 0, 0, 0, 993, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 857, 858, 858, 858, 858, 858, 858, 0, 858, 0, 0, 0, 858, 858, 858, 858, 0, 0, 0, 0, 858, 1_003,
					1_003, 1_003, 1_003, 1_003, 0, 0, 1_013, 1_013, 1_013, 1_013, 1_013, 1_003, 0, 0, 0, 0, 0, 1_003,
					1_013, 1_013, 0, 0, 0, 0, 1_013, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 858, 859, 859, 859, 859, 859, 859,
					0, 859, 0, 0, 0, 859, 859, 859, 859, 0, 0, 0, 1_003, 859, 1_017, 1_017, 1_017, 1_017, 1_017, 1_018,
					1_018, 1_018, 1_018, 1_018, 0, 1_018, 1_017, 1_017, 1_022, 1_022, 1_022, 1_018, 1_017, 1_022, 1_027,
					1_027, 1_027, 1_018, 0, 0, 1_022, 0, 0, 1_027, 0, 1_022, 1_027, 0, 0, 0, 859, 860, 860, 860, 860,
					860, 860, 0, 860, 0, 0, 0, 860, 860, 860, 860, 0, 0, 0, 0, 860, 1_060, 1_060, 1_060, 1_018, 1_025,
					1_025, 1_025, 1_025, 1_025, 1_060, 0, 1_022, 1_060, 0, 1_025, 0, 1_025, 1_027, 1_029, 1_029, 1_029,
					0, 1_025, 0, 0, 0, 0, 1_029, 0, 0, 1_029, 0, 0, 0, 0, 1_029, 860, 861, 861, 861, 861, 861, 861, 0,
					861, 0, 0, 0, 861, 861, 861, 861, 0, 0, 1_060, 0, 861, 0, 0, 1_025, 0, 1_032, 1_032, 1_032, 1_032,
					1_032, 1_044, 1_044, 1_044, 0, 0, 1_044, 1_029, 1_032, 1_032, 1_046, 1_046, 1_046, 1_044, 1_032,
					1_046, 0, 0, 0, 0, 0, 0, 1_046, 0, 0, 0, 0, 1_046, 861, 862, 862, 862, 862, 862, 862, 0, 862, 0,
					0, 0, 862, 862, 862, 862, 0, 0, 0, 0, 862, 1_045, 1_045, 1_045, 1_045, 1_045, 0, 1_044, 1_048, 1_048,
					1_048, 1_048, 1_048, 1_045, 1_045, 0, 1_046, 0, 0, 1_045, 1_048, 1_048, 1_053, 1_053, 1_053, 0, 1_048,
					1_053, 0, 0, 0, 0, 0, 0, 1_053, 0, 0, 862, 863, 863, 863, 863, 863, 863, 0, 863, 0, 0, 0, 863, 863,
					863, 863, 0, 0, 0, 0, 863, 1_055, 1_055, 1_055, 0, 0, 1_055, 0, 0, 0, 0, 0, 0, 1_055, 0, 1_057, 1_057,
					1_057, 1_055, 1_053, 1_057, 0, 0, 0, 1_058, 1_058, 1_058, 1_057, 0, 1_058, 0, 0, 0, 0, 0, 0, 1_058,
					863, 864, 864, 864, 864, 864, 864, 0, 864, 0, 0, 0, 864, 864, 864, 864, 0, 0, 1_055, 0, 864, 864,
					864, 864, 864, 864, 864, 864, 864, 864, 864, 0, 1_057, 0, 0, 864, 864, 864, 864, 864, 864, 1_058,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 864, 864, 864, 864, 864, 864, 865, 865, 865, 865, 865,
					865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865,
					865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865,
					865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865,
					865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 865, 868, 868, 868, 868,
					868, 0, 868, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 868, 868, 868, 868, 868, 868, 868, 868, 868, 868,
					0, 0, 0, 0, 868, 868, 868, 868, 868, 868, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 868, 868,
					868, 868, 868, 868, 869, 869, 869, 869, 869, 0, 0, 0, 0, 0, 869, 0, 0, 0, 0, 0, 0, 0, 0, 869, 869,
					869, 869, 869, 869, 869, 869, 869, 869, 0, 1_061, 1_061, 1_061, 869, 869, 869, 869, 869, 869, 1_061,
					0, 0, 1_061, 0, 0, 0, 0, 1_061, 0, 0, 0, 0, 0, 0, 0, 869, 869, 869, 869, 869, 869, 876, 876, 876,
					876, 876, 876, 0, 876, 0, 0, 0, 876, 876, 876, 876, 0, 0, 0, 0, 876, 1_065, 1_065, 1_065, 1_061,
					1_067, 1_067, 1_067, 0, 0, 1_065, 0, 0, 1_065, 1_067, 0, 0, 1_067, 1_069, 1_069, 1_069, 0, 1_067,
					1_070, 1_070, 1_070, 0, 1_069, 0, 0, 1_069, 0, 1_070, 0, 0, 1_070, 0, 876, 877, 877, 877, 877, 877,
					877, 0, 877, 0, 0, 0, 877, 877, 877, 877, 0, 0, 1_065, 0, 877, 0, 1_067, 0, 1_074, 1_074, 1_074,
					1_074, 1_074, 1_099, 1_099, 1_099, 0, 0, 1_099, 1_069, 1_074, 1_074, 0, 0, 1_070, 1_099, 1_074, 1_100,
					1_100, 1_100, 0, 0, 1_100, 0, 0, 0, 0, 0, 0, 1_100, 0, 877, 878, 878, 878, 878, 878, 878, 0, 878,
					0, 0, 0, 878, 878, 878, 878, 0, 0, 0, 0, 878, 1_097, 1_097, 1_097, 1_097, 1_097, 1_099, 0, 0, 0,
					0, 0, 0, 1_097, 1_097, 0, 0, 0, 0, 1_097, 1_100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					878, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879,
					879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879,
					879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879,
					879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879, 879,
					879, 879, 880, 880, 880, 880, 880, 880, 0, 880, 0, 0, 0, 880, 880, 880, 880, 0, 0, 0, 0, 880, 1_101,
					1_101, 1_101, 0, 0, 1_101, 1_104, 1_104, 1_104, 0, 0, 0, 1_101, 0, 0, 1_104, 0, 0, 1_104, 1_105,
					1_105, 1_105, 0, 1_106, 1_106, 1_106, 0, 0, 1_105, 0, 0, 1_105, 1_106, 0, 0, 1_106, 880, 881, 881,
					881, 881, 881, 881, 0, 881, 0, 0, 0, 881, 881, 881, 881, 0, 0, 1_101, 0, 881, 0, 0, 0, 1_104, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_105, 0, 0, 0, 1_106, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 881, 882, 882, 882, 882, 882, 882, 0, 882, 0, 0, 0, 882, 882, 882, 882, 0, 0, 0, 0, 882, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 882, 883, 883, 883, 883, 883, 883, 0, 883, 0, 0, 0, 883, 883, 883, 883, 0, 0, 0, 0, 883, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 883, 884, 884, 884, 884, 884, 884, 0, 884, 0, 0, 0, 884, 884, 884, 884, 0, 0, 0, 0, 884, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 884, 885, 885, 885, 885, 885, 885, 0, 885, 0, 0, 0, 885, 885, 885, 885, 0, 0, 0, 0, 885, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 885, 886, 886, 886, 886, 886, 886, 0, 886, 0, 0, 0, 886, 886, 886, 886, 0, 0, 0, 0, 886, 886,
					886, 886, 886, 886, 886, 886, 886, 886, 886, 0, 0, 0, 0, 886, 886, 886, 886, 886, 886, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 886, 886, 886, 886, 886, 886, 890, 890, 890, 890, 890, 890, 0,
					890, 0, 0, 0, 890, 890, 890, 890, 0, 0, 0, 0, 890, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 890, 892, 892, 892, 892, 892, 892, 0,
					892, 0, 0, 0, 892, 892, 892, 892, 0, 0, 0, 0, 892, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 892, 893, 893, 893, 893, 893, 893, 893,
					893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893,
					893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893,
					893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893,
					893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 893, 894, 894, 894, 894, 894, 894,
					0, 894, 0, 0, 0, 894, 894, 894, 894, 0, 0, 0, 0, 894, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 894, 895, 895, 895, 895, 895, 895,
					0, 895, 0, 0, 0, 895, 895, 895, 895, 0, 0, 0, 0, 895, 895, 895, 895, 895, 895, 895, 895, 895, 895,
					895, 0, 0, 0, 0, 895, 895, 895, 895, 895, 895, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 895,
					895, 895, 895, 895, 895, 896, 896, 896, 896, 896, 0, 0, 0, 0, 0, 0, 0, 896, 0, 0, 0, 0, 0, 896, 896,
					896, 896, 896, 896, 896, 896, 896, 896, 896, 0, 0, 0, 0, 896, 896, 896, 896, 896, 896, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 896, 896, 896, 896, 896, 896, 899, 899, 899, 899, 899, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 899, 899, 899, 899, 899, 899, 899, 899, 899, 899, 0, 0, 0, 0,
					899, 899, 899, 899, 899, 899, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 899, 899, 899, 899,
					899, 899, 912, 912, 912, 912, 912, 912, 0, 912, 0, 0, 0, 912, 912, 912, 912, 0, 0, 0, 0, 912, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 912, 913, 913, 913, 913, 913, 913, 0, 913, 0, 0, 0, 913, 913, 913, 913, 0, 0, 0, 0, 913, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 913, 914, 914, 914, 914, 914, 914, 0, 914, 0, 0, 0, 914, 914, 914, 914, 0, 0, 0, 0, 914, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 914, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915,
					915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915,
					915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915,
					915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915, 915,
					915, 915, 915, 916, 916, 916, 916, 916, 916, 0, 916, 0, 0, 0, 916, 916, 916, 916, 0, 0, 0, 0, 916,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 916, 917, 917, 917, 917, 917, 917, 0, 917, 0, 0, 0, 917, 917, 917, 917, 0, 0, 0, 0, 917,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 917, 918, 918, 918, 918, 918, 918, 0, 918, 0, 0, 0, 918, 918, 918, 918, 0, 0, 0, 0, 918,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 918, 919, 919, 919, 919, 919, 919, 0, 919, 0, 0, 0, 919, 919, 919, 919, 0, 0, 0, 0, 919,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 919, 920, 920, 920, 920, 920, 920, 0, 920, 0, 0, 0, 920, 920, 920, 920, 0, 0, 0, 0, 920,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 920, 921, 921, 921, 921, 921, 921, 0, 921, 0, 0, 0, 921, 921, 921, 921, 0, 0, 0, 0, 921,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 921, 922, 922, 922, 922, 922, 922, 0, 922, 0, 0, 0, 922, 922, 922, 922, 0, 0, 0, 0, 922,
					922, 922, 922, 922, 922, 922, 922, 922, 922, 922, 0, 0, 0, 0, 922, 922, 922, 922, 922, 922, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 922, 922, 922, 922, 922, 922, 926, 926, 926, 926, 926,
					926, 0, 926, 0, 0, 0, 926, 926, 926, 926, 0, 0, 0, 0, 926, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 926, 928, 928, 928, 928, 928,
					928, 0, 928, 0, 0, 0, 928, 928, 928, 928, 0, 0, 0, 0, 928, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 928, 929, 929, 929, 929, 929,
					929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929,
					929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929,
					929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929,
					929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 929, 930, 930, 930, 930,
					930, 930, 0, 930, 0, 0, 0, 930, 930, 930, 930, 0, 0, 0, 0, 930, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 930, 931, 931, 931, 931,
					931, 931, 0, 931, 0, 0, 0, 931, 931, 931, 931, 0, 0, 0, 0, 931, 931, 931, 931, 931, 931, 931, 931,
					931, 931, 931, 0, 0, 0, 0, 931, 931, 931, 931, 931, 931, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 931, 931, 931, 931, 931, 931, 933, 933, 933, 933, 933, 0, 933, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 933, 933, 933, 933, 933, 933, 933, 933, 933, 933, 0, 0, 0, 0, 933, 933, 933, 933, 933, 933,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 933, 933, 933, 933, 933, 933, 934, 934, 934, 934,
					934, 0, 0, 0, 0, 0, 934, 0, 0, 0, 0, 0, 0, 0, 0, 934, 934, 934, 934, 934, 934, 934, 934, 934, 934,
					0, 0, 0, 0, 934, 934, 934, 934, 934, 934, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 934, 934,
					934, 934, 934, 934, 935, 935, 935, 935, 935, 935, 0, 935, 0, 0, 0, 935, 935, 935, 935, 0, 0, 0, 0,
					935, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 935, 937, 937, 937, 937, 937, 937, 0, 937, 0, 0, 0, 937, 937, 937, 937, 0, 0, 0, 0,
					937, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 937, 938, 938, 938, 938, 938, 938, 0, 938, 0, 0, 0, 938, 938, 938, 938, 0, 0, 0, 0,
					938, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 938, 939, 939, 939, 939, 939, 939, 0, 939, 0, 0, 0, 939, 939, 939, 939, 0, 0, 0, 0,
					939, 939, 939, 939, 939, 939, 939, 939, 939, 939, 939, 0, 0, 0, 0, 939, 939, 939, 939, 939, 939,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 939, 939, 939, 939, 939, 939, 945, 945, 945, 945,
					945, 945, 0, 945, 0, 0, 0, 945, 945, 945, 945, 0, 0, 0, 0, 945, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 945, 946, 946, 946, 946,
					946, 946, 0, 946, 0, 0, 0, 946, 946, 946, 946, 0, 0, 0, 0, 946, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 946, 947, 947, 947, 947,
					947, 947, 0, 947, 0, 0, 0, 947, 947, 947, 947, 0, 0, 0, 0, 947, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 947, 948, 948, 948, 948,
					948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948,
					948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948,
					948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948,
					948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 948, 951, 951, 951,
					951, 951, 951, 0, 951, 0, 0, 0, 951, 951, 951, 951, 0, 0, 0, 0, 951, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 951, 952, 952, 952,
					952, 952, 952, 0, 952, 0, 0, 0, 952, 952, 952, 952, 0, 0, 0, 0, 952, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 952, 953, 953, 953,
					953, 953, 953, 0, 953, 0, 0, 0, 953, 953, 953, 953, 0, 0, 0, 0, 953, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 953, 954, 954, 954,
					954, 954, 954, 0, 954, 0, 0, 0, 954, 954, 954, 954, 0, 0, 0, 0, 954, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 954, 955, 955, 955,
					955, 955, 955, 0, 955, 0, 0, 0, 955, 955, 955, 955, 0, 0, 0, 0, 955, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 955, 956, 956, 956,
					956, 956, 956, 0, 956, 0, 0, 0, 956, 956, 956, 956, 0, 0, 0, 0, 956, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 956, 957, 957, 957,
					957, 957, 957, 0, 957, 0, 0, 0, 957, 957, 957, 957, 0, 0, 0, 0, 957, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 957, 958, 958, 958,
					958, 958, 958, 0, 958, 0, 0, 0, 958, 958, 958, 958, 0, 0, 0, 0, 958, 958, 958, 958, 958, 958, 958,
					958, 958, 958, 958, 0, 0, 0, 0, 958, 958, 958, 958, 958, 958, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 958, 958, 958, 958, 958, 958, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960,
					960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960,
					960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960,
					960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 960,
					960, 960, 960, 960, 960, 960, 960, 960, 960, 960, 961, 961, 961, 961, 961, 0, 0, 0, 0, 0, 0, 0, 961,
					0, 0, 0, 0, 0, 961, 961, 961, 961, 961, 961, 961, 961, 961, 961, 961, 0, 0, 0, 0, 961, 961, 961,
					961, 961, 961, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 961, 961, 961, 961, 961, 961, 964,
					964, 964, 964, 964, 964, 0, 964, 0, 0, 0, 964, 964, 964, 964, 0, 0, 0, 0, 964, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 964, 965,
					965, 965, 965, 965, 965, 0, 965, 0, 0, 0, 965, 965, 965, 965, 0, 0, 0, 0, 965, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 965, 966,
					966, 966, 966, 966, 966, 0, 966, 0, 0, 0, 966, 966, 966, 966, 0, 0, 0, 0, 966, 966, 966, 966, 966,
					966, 966, 966, 966, 966, 966, 0, 0, 0, 0, 966, 966, 966, 966, 966, 966, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 966, 966, 966, 966, 966, 966, 972, 972, 972, 972, 972, 972, 0, 972, 0, 0, 0,
					972, 972, 972, 972, 0, 0, 0, 0, 972, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 972, 973, 973, 973, 973, 973, 973, 0, 973, 0, 0,
					0, 973, 973, 973, 973, 0, 0, 0, 0, 973, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 973, 974, 974, 974, 974, 974, 974, 0, 974, 0,
					0, 0, 974, 974, 974, 974, 0, 0, 0, 0, 974, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 974, 975, 975, 975, 975, 975, 975, 975, 975,
					975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975,
					975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975,
					975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975,
					975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 975, 976, 976, 976, 976, 976, 976, 0,
					976, 0, 0, 0, 976, 976, 976, 976, 0, 0, 0, 0, 976, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 976, 977, 977, 977, 977, 977, 977, 0,
					977, 0, 0, 0, 977, 977, 977, 977, 0, 0, 0, 0, 977, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 977, 978, 978, 978, 978, 978, 978, 0,
					978, 0, 0, 0, 978, 978, 978, 978, 0, 0, 0, 0, 978, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 978, 979, 979, 979, 979, 979, 979, 0,
					979, 0, 0, 0, 979, 979, 979, 979, 0, 0, 0, 0, 979, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 979, 980, 980, 980, 980, 980, 980, 0,
					980, 0, 0, 0, 980, 980, 980, 980, 0, 0, 0, 0, 980, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 980, 981, 981, 981, 981, 981, 981, 0,
					981, 0, 0, 0, 981, 981, 981, 981, 0, 0, 0, 0, 981, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 981, 982, 982, 982, 982, 982, 982, 0,
					982, 0, 0, 0, 982, 982, 982, 982, 0, 0, 0, 0, 982, 982, 982, 982, 982, 982, 982, 982, 982, 982, 982,
					0, 0, 0, 0, 982, 982, 982, 982, 982, 982, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 982, 982,
					982, 982, 982, 982, 984, 984, 984, 984, 984, 984, 0, 984, 0, 0, 0, 984, 984, 984, 984, 0, 0, 0, 0,
					984, 984, 984, 984, 984, 984, 984, 984, 984, 984, 984, 0, 0, 0, 0, 984, 984, 984, 984, 984, 984,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 984, 984, 984, 984, 984, 984, 987, 987, 987, 987,
					987, 0, 987, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 987, 987, 987, 987, 987, 987, 987, 987, 987, 987,
					0, 0, 0, 0, 987, 987, 987, 987, 987, 987, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 987, 987,
					987, 987, 987, 987, 988, 988, 988, 988, 988, 0, 0, 0, 0, 0, 988, 0, 0, 0, 0, 0, 0, 0, 0, 988, 988,
					988, 988, 988, 988, 988, 988, 988, 988, 0, 0, 0, 0, 988, 988, 988, 988, 988, 988, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 988, 988, 988, 988, 988, 988, 989, 989, 989, 989, 989, 989, 989,
					989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989,
					989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989,
					989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989,
					989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 989, 991, 991, 991, 991, 991, 991,
					0, 991, 0, 0, 0, 991, 991, 991, 991, 0, 0, 0, 0, 991, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 991, 995, 995, 995, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 995, 0, 0, 0, 0, 0, 995, 995, 995, 995, 995, 995, 995, 995, 995, 995, 0, 0, 0, 0, 995,
					995, 995, 995, 995, 995, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 995, 995, 995, 995, 995,
					998, 998, 998, 0, 0, 0, 0, 0, 0, 0, 0, 0, 998, 0, 0, 0, 0, 0, 998, 998, 998, 998, 998, 998, 998,
					998, 998, 998, 0, 0, 0, 0, 998, 998, 998, 998, 998, 998, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 998, 998, 998, 998, 998, 999, 999, 999, 999, 999, 999, 0, 999, 0, 0, 0, 999, 999, 999, 999,
					0, 0, 0, 0, 999, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 999, 1_000, 1_000, 1_000, 1_000, 1_000, 1_000, 0, 1_000, 0, 0, 0, 1_000,
					1_000, 1_000, 1_000, 0, 0, 0, 0, 1_000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_000, 1_001, 1_001, 1_001, 1_001, 1_001, 1_001,
					0, 1_001, 0, 0, 0, 1_001, 1_001, 1_001, 1_001, 0, 0, 0, 0, 1_001, 1_001, 1_001, 1_001, 1_001, 1_001,
					1_001, 1_001, 1_001, 1_001, 1_001, 0, 0, 0, 0, 1_001, 1_001, 1_001, 1_001, 1_001, 1_001, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_001, 1_001, 1_001, 1_001, 1_001, 1_001, 1_002, 1_002, 1_002,
					1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002,
					1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002,
					1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002,
					1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002,
					1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002,
					1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_002, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004,
					1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004,
					1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004,
					1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004,
					1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004,
					1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004, 1_004,
					1_004, 1_004, 1_004, 1_004, 1_004, 1_006, 1_006, 1_006, 1_006, 1_006, 1_006, 0, 1_006, 0, 0, 0, 1_006,
					1_006, 1_006, 1_006, 0, 0, 0, 0, 1_006, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_006, 1_007, 1_007, 1_007, 1_007, 1_007, 1_007,
					0, 1_007, 0, 0, 0, 1_007, 1_007, 1_007, 1_007, 0, 0, 0, 0, 1_007, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_007, 1_008, 1_008, 1_008,
					1_008, 1_008, 1_008, 0, 1_008, 0, 0, 0, 1_008, 1_008, 1_008, 1_008, 0, 0, 0, 0, 1_008, 1_008, 1_008,
					1_008, 1_008, 1_008, 1_008, 1_008, 1_008, 1_008, 1_008, 0, 0, 0, 0, 1_008, 1_008, 1_008, 1_008, 1_008,
					1_008, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_008, 1_008, 1_008, 1_008, 1_008, 1_008,
					1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009,
					1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009,
					1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009,
					1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009,
					1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009,
					1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_009, 1_012, 1_012, 1_012,
					1_012, 1_012, 1_012, 1_012, 1_012, 1_012, 1_012, 0, 0, 0, 0, 1_012, 1_012, 1_012, 1_012, 1_012, 1_012,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_012, 1_012, 1_012, 1_012, 1_012, 1_019, 1_019,
					1_019, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_019, 0, 0, 0, 0, 0, 1_019, 1_019, 1_019, 1_019, 1_019, 1_019,
					1_019, 1_019, 1_019, 1_019, 0, 0, 0, 0, 1_019, 1_019, 1_019, 1_019, 1_019, 1_019, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_019, 1_019, 1_019, 1_019, 1_019, 1_023, 1_023, 1_023, 1_023,
					1_023, 0, 1_023, 0, 0, 0, 0, 0, 0, 1_023, 0, 0, 0, 0, 0, 1_023, 1_023, 1_023, 1_023, 1_023, 1_023,
					1_023, 1_023, 1_023, 1_023, 0, 0, 0, 0, 1_023, 1_023, 1_023, 1_023, 1_023, 1_023, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_023, 1_023, 1_023, 1_023, 1_023, 1_023, 1_026, 1_026, 1_026, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 1_026, 0, 0, 0, 0, 0, 1_026, 1_026, 1_026, 1_026, 1_026, 1_026, 1_026, 1_026,
					1_026, 1_026, 0, 0, 0, 0, 1_026, 1_026, 1_026, 1_026, 1_026, 1_026, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 1_026, 1_026, 1_026, 1_026, 1_026, 1_030, 1_030, 1_030, 1_030, 1_030, 0, 0,
					0, 0, 0, 1_030, 0, 0, 1_030, 0, 0, 0, 0, 0, 1_030, 1_030, 1_030, 1_030, 1_030, 1_030, 1_030, 1_030,
					1_030, 1_030, 0, 0, 0, 0, 1_030, 1_030, 1_030, 1_030, 1_030, 1_030, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 1_030, 1_030, 1_030, 1_030, 1_030, 1_030, 1_033, 1_033, 1_033, 1_033, 1_033, 1_033,
					0, 1_033, 0, 0, 0, 1_033, 1_033, 1_033, 1_033, 0, 0, 0, 0, 1_033, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_033, 1_035, 1_035, 1_035,
					1_035, 1_035, 1_035, 0, 1_035, 0, 0, 0, 1_035, 1_035, 1_035, 1_035, 0, 0, 0, 0, 1_035, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_035,
					1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036,
					1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036,
					1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036,
					1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036,
					1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036,
					1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_036, 1_037, 1_037, 1_037,
					1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037,
					1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037,
					1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037,
					1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037,
					1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037,
					1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_037, 1_038, 1_038, 1_038, 1_038, 1_038, 1_038,
					0, 1_038, 0, 0, 0, 1_038, 1_038, 1_038, 1_038, 0, 0, 0, 0, 1_038, 1_038, 1_038, 1_038, 1_038, 1_038,
					1_038, 1_038, 1_038, 1_038, 1_038, 0, 0, 0, 0, 1_038, 1_038, 1_038, 1_038, 1_038, 1_038, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_038, 1_038, 1_038, 1_038, 1_038, 1_038, 1_039, 1_039, 1_039,
					1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039,
					1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039,
					1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039,
					1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039,
					1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039,
					1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_039, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040,
					1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040,
					1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040,
					1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040,
					1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040,
					1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040, 1_040,
					1_040, 1_040, 1_040, 1_040, 1_040, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041,
					1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041,
					1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041,
					1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041,
					1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041,
					1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041, 1_041,
					1_041, 1_041, 1_042, 1_042, 1_042, 1_042, 1_042, 1_042, 1_042, 1_042, 1_042, 1_042, 0, 0, 0, 0, 1_042,
					1_042, 1_042, 1_042, 1_042, 1_042, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_042, 1_042,
					1_042, 1_042, 1_042, 1_047, 1_047, 1_047, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_047, 0, 0, 0, 0, 0, 1_047,
					1_047, 1_047, 1_047, 1_047, 1_047, 1_047, 1_047, 1_047, 1_047, 0, 0, 0, 0, 1_047, 1_047, 1_047, 1_047,
					1_047, 1_047, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_047, 1_047, 1_047, 1_047, 1_047,
					1_056, 1_056, 1_056, 1_056, 1_056, 0, 1_056, 0, 0, 0, 0, 0, 0, 1_056, 0, 0, 0, 0, 0, 1_056, 1_056,
					1_056, 1_056, 1_056, 1_056, 1_056, 1_056, 1_056, 1_056, 0, 0, 0, 0, 1_056, 1_056, 1_056, 1_056, 1_056,
					1_056, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_056, 1_056, 1_056, 1_056, 1_056, 1_056,
					1_059, 1_059, 1_059, 1_059, 1_059, 0, 1_059, 0, 0, 0, 0, 0, 0, 1_059, 0, 0, 0, 0, 0, 1_059, 1_059,
					1_059, 1_059, 1_059, 1_059, 1_059, 1_059, 1_059, 1_059, 0, 0, 0, 0, 1_059, 1_059, 1_059, 1_059, 1_059,
					1_059, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_059, 1_059, 1_059, 1_059, 1_059, 1_059,
					1_062, 1_062, 1_062, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_062, 0, 0, 0, 0, 0, 1_062, 1_062, 1_062, 1_062,
					1_062, 1_062, 1_062, 1_062, 1_062, 1_062, 0, 0, 0, 0, 1_062, 1_062, 1_062, 1_062, 1_062, 1_062, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_062, 1_062, 1_062, 1_062, 1_062, 1_068, 1_068,
					1_068, 1_068, 1_068, 0, 0, 0, 0, 0, 1_068, 0, 0, 1_068, 0, 0, 0, 0, 0, 1_068, 1_068, 1_068, 1_068,
					1_068, 1_068, 1_068, 1_068, 1_068, 1_068, 0, 0, 0, 0, 1_068, 1_068, 1_068, 1_068, 1_068, 1_068, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_068, 1_068, 1_068, 1_068, 1_068, 1_068, 1_071, 1_071,
					1_071, 1_071, 1_071, 0, 0, 0, 0, 0, 1_071, 0, 0, 1_071, 0, 0, 0, 0, 0, 1_071, 1_071, 1_071, 1_071,
					1_071, 1_071, 1_071, 1_071, 1_071, 1_071, 0, 0, 0, 0, 1_071, 1_071, 1_071, 1_071, 1_071, 1_071, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_071, 1_071, 1_071, 1_071, 1_071, 1_071, 1_077, 1_077,
					1_077, 1_077, 1_077, 1_077, 0, 1_077, 0, 0, 0, 1_077, 1_077, 1_077, 1_077, 0, 0, 0, 0, 1_077, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 1_077, 1_078, 1_078, 1_078, 1_078, 1_078, 1_078, 0, 1_078, 0, 0, 0, 1_078, 1_078, 1_078, 1_078,
					0, 0, 0, 0, 1_078, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_078, 1_079, 1_079, 1_079, 1_079, 1_079, 1_079, 0, 1_079, 0, 0, 0,
					1_079, 1_079, 1_079, 1_079, 0, 0, 0, 0, 1_079, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_079, 1_080, 1_080, 1_080, 1_080, 1_080,
					1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080,
					1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080,
					1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080,
					1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080,
					1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_080,
					1_080, 1_080, 1_080, 1_080, 1_080, 1_080, 1_081, 1_081, 1_081, 1_081, 1_081, 1_081, 0, 1_081, 0,
					0, 0, 1_081, 1_081, 1_081, 1_081, 0, 0, 0, 0, 1_081, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_081, 1_082, 1_082, 1_082, 1_082,
					1_082, 1_082, 0, 1_082, 0, 0, 0, 1_082, 1_082, 1_082, 1_082, 0, 0, 0, 0, 1_082, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_082,
					1_083, 1_083, 1_083, 1_083, 1_083, 1_083, 0, 1_083, 0, 0, 0, 1_083, 1_083, 1_083, 1_083, 0, 0, 0,
					0, 1_083, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 1_083, 1_084, 1_084, 1_084, 1_084, 1_084, 1_084, 0, 1_084, 0, 0, 0, 1_084, 1_084,
					1_084, 1_084, 0, 0, 0, 0, 1_084, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_084, 1_085, 1_085, 1_085, 1_085, 1_085, 1_085, 0, 1_085,
					0, 0, 0, 1_085, 1_085, 1_085, 1_085, 0, 0, 0, 0, 1_085, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_085, 1_086, 1_086, 1_086, 1_086,
					1_086, 1_086, 0, 1_086, 0, 0, 0, 1_086, 1_086, 1_086, 1_086, 0, 0, 0, 0, 1_086, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_086,
					1_087, 1_087, 1_087, 1_087, 1_087, 1_087, 0, 1_087, 0, 0, 0, 1_087, 1_087, 1_087, 1_087, 0, 0, 0,
					0, 1_087, 1_087, 1_087, 1_087, 1_087, 1_087, 1_087, 1_087, 1_087, 1_087, 1_087, 0, 0, 0, 0, 1_087,
					1_087, 1_087, 1_087, 1_087, 1_087, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_087, 1_087,
					1_087, 1_087, 1_087, 1_087, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089,
					1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089,
					1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089,
					1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089,
					1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089,
					1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089, 1_089,
					1_089, 1_090, 1_090, 1_090, 1_090, 1_090, 1_090, 0, 1_090, 0, 0, 0, 1_090, 1_090, 1_090, 1_090, 0,
					0, 0, 0, 1_090, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 1_090, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091,
					1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091,
					1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091,
					1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091,
					1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091,
					1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091, 1_091,
					1_091, 1_091, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092,
					1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092,
					1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092,
					1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092,
					1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092,
					1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_092, 1_093,
					1_093, 1_093, 1_093, 1_093, 1_093, 0, 1_093, 0, 0, 0, 1_093, 1_093, 1_093, 1_093, 0, 0, 0, 0, 1_093,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 1_093, 1_094, 1_094, 1_094, 1_094, 1_094, 1_094, 0, 1_094, 0, 0, 0, 1_094, 1_094, 1_094,
					1_094, 0, 0, 0, 0, 1_094, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_094, 1_102, 1_102, 1_102, 1_102, 1_102, 0, 1_102, 0, 0, 0,
					0, 0, 0, 1_102, 0, 0, 0, 0, 0, 1_102, 1_102, 1_102, 1_102, 1_102, 1_102, 1_102, 1_102, 1_102, 1_102,
					0, 0, 0, 0, 1_102, 1_102, 1_102, 1_102, 1_102, 1_102, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 1_102, 1_102, 1_102, 1_102, 1_102, 1_102, 1_103, 1_103, 1_103, 1_103, 1_103, 0, 1_103, 0, 0, 0,
					0, 0, 0, 1_103, 0, 0, 0, 0, 0, 1_103, 1_103, 1_103, 1_103, 1_103, 1_103, 1_103, 1_103, 1_103, 1_103,
					0, 0, 0, 0, 1_103, 1_103, 1_103, 1_103, 1_103, 1_103, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 1_103, 1_103, 1_103, 1_103, 1_103, 1_103, 1_107, 1_107, 1_107, 1_107, 1_107, 1_107, 1_107, 1_107,
					1_107, 1_107, 0, 0, 0, 0, 1_107, 1_107, 1_107, 1_107, 1_107, 1_107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 1_107, 1_107, 1_107, 1_107, 1_107, 1_108, 1_108, 1_108, 1_108, 1_108, 1_108,
					1_108, 1_108, 1_108, 1_108, 0, 0, 0, 0, 1_108, 1_108, 1_108, 1_108, 1_108, 1_108, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_108, 1_108, 1_108, 1_108, 1_108, 1_110, 1_110, 1_110, 1_110,
					1_110, 1_110, 0, 1_110, 0, 0, 0, 1_110, 1_110, 1_110, 1_110, 0, 0, 0, 0, 1_110, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_110,
					1_111, 1_111, 1_111, 1_111, 1_111, 1_111, 0, 1_111, 0, 0, 0, 1_111, 1_111, 1_111, 1_111, 0, 0, 0,
					0, 1_111, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 1_111, 1_112, 1_112, 1_112, 1_112, 1_112, 1_112, 1_112, 1_112, 1_112, 1_112,
					0, 0, 0, 0, 1_112, 1_112, 1_112, 1_112, 1_112, 1_112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 1_112, 1_112, 1_112, 1_112, 1_112, 1_113, 1_113, 1_113, 1_113, 1_113, 1_113, 1_113, 1_113,
					1_113, 1_113, 0, 0, 0, 0, 1_113, 1_113, 1_113, 1_113, 1_113, 1_113, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 1_113, 1_113, 1_113, 1_113, 1_113, 1_114, 1_114, 1_114, 1_114, 1_114, 1_114,
					1_114, 1_114, 1_114, 1_114, 0, 0, 0, 0, 1_114, 1_114, 1_114, 1_114, 1_114, 1_114, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_114, 1_114, 1_114, 1_114, 1_114, 1_115, 1_115, 1_115, 1_115,
					1_115, 1_115, 1_115, 1_115, 1_115, 1_115, 0, 0, 0, 0, 1_115, 1_115, 1_115, 1_115, 1_115, 1_115, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_115, 1_115, 1_115, 1_115, 1_115, 1_122, 1_122,
					1_122, 1_122, 1_122, 1_122, 1_122, 1_122, 1_122, 1_122, 0, 0, 0, 0, 1_122, 1_122, 1_122, 1_122, 1_122,
					1_122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_122, 1_122, 1_122, 1_122, 1_122, 1_123,
					1_123, 1_123, 1_123, 1_123, 1_123, 1_123, 1_123, 1_123, 1_123, 0, 0, 0, 0, 1_123, 1_123, 1_123, 1_123,
					1_123, 1_123, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_123, 1_123, 1_123, 1_123, 1_123,
					1_124, 1_124, 1_124, 1_124, 1_124, 1_124, 1_124, 1_124, 1_124, 1_124, 0, 0, 0, 0, 1_124, 1_124, 1_124,
					1_124, 1_124, 1_124, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_124, 1_124, 1_124, 1_124,
					1_124, 1_125, 1_125, 1_125, 1_125, 1_125, 1_125, 1_125, 1_125, 1_125, 1_125, 0, 0, 0, 0, 1_125, 1_125,
					1_125, 1_125, 1_125, 1_125, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_125, 1_125, 1_125,
					1_125, 1_125, 1_126, 1_126, 1_126, 1_126, 1_126, 1_126, 1_126, 1_126, 1_126, 1_126, 0, 0, 0, 0, 1_126,
					1_126, 1_126, 1_126, 1_126, 1_126, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_126, 1_126,
					1_126, 1_126, 1_126, 1_127, 1_127, 1_127, 1_127, 1_127, 1_127, 1_127, 1_127, 1_127, 1_127, 0, 0,
					0, 0, 1_127, 1_127, 1_127, 1_127, 1_127, 1_127, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					1_127, 1_127, 1_127, 1_127, 1_127, 1_128, 1_128, 1_128, 1_128, 1_128, 1_128, 1_128, 1_128, 1_128,
					1_128, 0, 0, 0, 0, 1_128, 1_128, 1_128, 1_128, 1_128, 1_128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 1_128, 1_128, 1_128, 1_128, 1_128, 1_134, 1_134, 1_134, 1_134, 1_134, 1_134, 1_134,
					1_134, 1_134, 1_134, 0, 0, 0, 0, 1_134, 1_134, 1_134, 1_134, 1_134, 1_134, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 1_134, 1_134, 1_134, 1_134, 1_134, 1_135, 1_135, 1_135, 1_135, 1_135,
					1_135, 1_135, 1_135, 1_135, 1_135, 0, 0, 0, 0, 1_135, 1_135, 1_135, 1_135, 1_135, 1_135, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_135, 1_135, 1_135, 1_135, 1_135, 1_136, 1_136, 1_136,
					1_136, 1_136, 1_136, 1_136, 1_136, 1_136, 1_136, 0, 0, 0, 0, 1_136, 1_136, 1_136, 1_136, 1_136, 1_136,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_136, 1_136, 1_136, 1_136, 1_136, 1_137, 1_137,
					1_137, 1_137, 1_137, 1_137, 1_137, 1_137, 1_137, 1_137, 0, 0, 0, 0, 1_137, 1_137, 1_137, 1_137, 1_137,
					1_137, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_137, 1_137, 1_137, 1_137, 1_137, 1_138,
					1_138, 1_138, 1_138, 1_138, 1_138, 1_138, 1_138, 1_138, 1_138, 0, 0, 0, 0, 1_138, 1_138, 1_138, 1_138,
					1_138, 1_138, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_138, 1_138, 1_138, 1_138, 1_138,
					1_141, 1_141, 1_141, 1_141, 1_141, 1_141, 1_141, 1_141, 1_141, 1_141, 0, 0, 0, 0, 1_141, 1_141, 1_141,
					1_141, 1_141, 1_141, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_141, 1_141, 1_141, 1_141,
					1_141, 1_142, 1_142, 1_142, 1_142, 1_142, 1_142, 1_142, 1_142, 1_142, 1_142, 0, 0, 0, 0, 1_142, 1_142,
					1_142, 1_142, 1_142, 1_142, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_142, 1_142, 1_142,
					1_142, 1_142, 1_143, 1_143, 1_143, 1_143, 1_143, 1_143, 1_143, 1_143, 1_143, 1_143, 0, 0, 0, 0, 1_143,
					1_143, 1_143, 1_143, 1_143, 1_143, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_143, 1_143,
					1_143, 1_143, 1_143, 1_144, 1_144, 1_144, 1_144, 1_144, 1_144, 1_144, 1_144, 1_144, 1_144, 0, 0,
					0, 0, 1_144, 1_144, 1_144, 1_144, 1_144, 1_144, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					1_144, 1_144, 1_144, 1_144, 1_144, 1_145, 1_145, 1_145, 1_145, 1_145, 1_145, 1_145, 1_145, 1_145,
					1_145, 0, 0, 0, 0, 1_145, 1_145, 1_145, 1_145, 1_145, 1_145, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 1_145, 1_145, 1_145, 1_145, 1_145, 1_149, 1_149, 1_149, 1_149, 1_149, 1_149, 1_149,
					1_149, 1_149, 1_149, 0, 0, 0, 0, 1_149, 1_149, 1_149, 1_149, 1_149, 1_149, 0, 0, 0, 0, 0, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 1_149, 1_149, 1_149, 1_149, 1_149, 1_150, 1_150, 1_150, 1_150, 1_150,
					1_150, 1_150, 1_150, 1_150, 1_150, 0, 0, 0, 0, 1_150, 1_150, 1_150, 1_150, 1_150, 1_150, 0, 0, 0,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_150, 1_150, 1_150, 1_150, 1_150, 1_151, 1_151, 1_151,
					1_151, 1_151, 1_151, 1_151, 1_151, 1_151, 1_151, 0, 0, 0, 0, 1_151, 1_151, 1_151, 1_151, 1_151, 1_151,
					0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1_151, 1_151, 1_151, 1_151, 1_151, 1_153, 1_153,
					0, 1_153, 1_153, 1_153, 1_153, 1_153, 1_153, 1_154, 1_154, 1_154, 1_155, 1_155, 0, 1_155, 1_155,
					1_155, 1_155, 1_155, 1_155, 1_156, 0, 1_156, 1_157, 1_157, 1_157, 1_157, 1_158, 1_158, 0, 1_158,
					1_158, 1_158, 1_158, 1_158, 1_158, 1_159, 1_159, 1_159, 1_159, 1_159, 1_159, 1_159, 1_159, 1_159,
					1_160, 1_160, 0, 1_160, 1_160, 1_160, 1_160, 1_160, 1_160, 1_161, 1_161, 1_161, 1_161, 1_161, 1_161,
					1_161, 1_161, 1_161, 1_162, 1_162, 1_162, 1_162, 1_162, 1_162, 1_162, 1_162, 1_162, 1_164, 1_164,
					1_164, 1_165, 1_165, 0, 1_165, 1_165, 1_165, 1_165, 1_165, 1_165, 1_166, 1_166, 1_166, 1_166, 1_166,
					1_166, 1_166, 1_166, 1_166, 1_167, 1_167, 1_167, 1_167, 1_167, 1_167, 1_167, 1_167, 1_167, 1_168,
					1_168, 1_168, 1_168, 1_168, 1_168, 1_168, 1_168, 1_168, 1_169, 1_169, 0, 1_169, 1_169, 1_169, 1_169,
					1_169, 1_169, 1_170, 1_170, 1_170, 1_170, 1_170, 1_170, 1_170, 1_170, 1_170, 1_171, 1_171, 1_171,
					1_171, 1_171, 1_171, 1_171, 1_171, 1_171, 1_172, 1_172, 1_172, 1_172, 1_172, 1_172, 1_172, 1_172,
					1_172, 1_173, 1_173, 1_173, 1_173, 0, 1_173, 1_173, 1_173, 1_174, 1_174, 1_174, 1_174, 1_174, 1_174,
					1_174, 1_174, 1_174, 1_175, 1_175, 1_175, 1_175, 1_175, 1_175, 1_175, 1_175, 1_175, 1_176, 1_176,
					1_176, 1_176, 1_176, 1_176, 1_176, 1_176, 1_176, 1_177, 1_177, 0, 1_177, 1_177, 1_177, 1_177, 1_177,
					1_177, 1_178, 1_178, 0, 1_178, 1_178, 1_178, 1_178, 1_178, 1_178, 1_179, 1_179, 0, 1_179, 1_179,
					1_179, 1_179, 1_179, 1_179, 1_180, 1_180, 1_180, 1_180, 1_180, 1_180, 1_180, 1_180, 1_180, 1_181,
					1_181, 1_181, 1_181, 1_181, 1_181, 1_181, 1_181, 1_181, 1_182, 1_182, 1_182, 1_182, 1_182, 1_182,
					1_182, 1_182, 1_182, 1_183, 1_183, 1_183, 1_183, 1_183, 1_183, 1_183, 1_183, 1_183, 1_184, 1_184,
					1_184, 1_184, 1_184, 1_184, 1_184, 1_184, 1_184, 1_185, 1_185, 1_185, 1_185, 1_185, 1_185, 1_185,
					1_185, 1_185, 1_186, 1_186, 1_186, 1_186, 1_186, 1_186, 1_186, 1_186, 1_186, 1_187, 1_187, 1_187,
					1_187, 1_187, 1_187, 1_187, 1_187, 1_187, 1_188, 1_188, 1_188, 1_188, 1_188, 1_188, 1_188, 1_188,
					1_188, 1_189, 1_189, 1_189, 1_189, 1_189, 1_189, 1_189, 1_189, 1_189, 1_190, 1_190, 1_190, 1_190,
					1_190, 1_190, 1_190, 1_190, 1_190, 1_191, 1_191, 1_191, 1_191, 1_191, 1_191, 1_191, 1_191, 1_191,
					1_192, 1_192, 1_192, 0, 0, 1_192, 1_192, 1_192, 1_193, 1_193, 1_193, 1_193, 1_193, 1_193, 1_193,
					1_193, 1_193, 1_194, 1_194, 1_194, 1_194, 1_194, 1_194, 1_194, 1_194, 1_194, 1_195, 1_195, 1_195,
					1_195, 1_195, 1_195, 1_195, 1_195, 1_195, 1_196, 1_196, 1_196, 1_196, 1_196, 1_196, 1_196, 1_196,
					1_196, 1_197, 1_197, 1_197, 1_197, 1_197, 1_197, 1_197, 1_197, 1_197, 1_198, 1_198, 1_198, 1_198,
					1_198, 1_198, 1_198, 1_198, 1_198, 1_199, 1_199, 1_199, 1_199, 1_199, 1_199, 1_199, 1_199, 1_199,
					1_200, 1_200, 1_200, 1_200, 1_200, 1_200, 1_200, 1_200, 1_200, 1_201, 1_201, 1_201, 1_201, 1_201,
					1_201, 1_201, 1_201, 1_201, 1_202, 1_202, 1_202, 1_202, 1_202, 1_202, 1_202, 1_202, 1_202, 1_203,
					1_203, 1_203, 1_203, 1_203, 1_203, 1_203, 1_203, 1_203, 1_204, 1_204, 1_204, 1_204, 1_204, 1_204,
					1_204, 1_204, 1_204, 1_205, 1_205, 1_205, 1_205, 1_205, 1_205, 1_205, 1_205, 1_205, 1_206, 1_206,
					1_206, 1_206, 1_206, 1_206, 1_206, 1_206, 1_206, 1_207, 1_207, 1_207, 1_207, 1_207, 1_207, 1_207,
					1_207, 1_207, 1_208, 1_208, 1_208, 1_208, 1_208, 1_208, 1_208, 1_208, 1_208, 1_209, 1_209, 1_209,
					1_209, 1_209, 1_209, 1_209, 1_209, 1_209, 1_210, 1_210, 1_210, 1_210, 1_210, 1_210, 1_210, 1_210,
					1_210, 1_211, 1_211, 1_211, 1_211, 1_211, 1_211, 1_211, 1_211, 1_211, 1_212, 1_212, 1_212, 1_212,
					1_212, 1_212, 1_212, 1_212, 1_212, 1_213, 1_213, 1_213, 1_213, 1_213, 1_213, 1_213, 1_213, 1_213,
					1_214, 1_214, 1_214, 1_214, 1_214, 1_214, 1_214, 1_214, 1_214, 1_215, 1_215, 1_215, 1_215, 1_215,
					1_215, 1_215, 1_215, 1_215, 1_216, 1_216, 1_216, 1_216, 1_216, 1_216, 1_216, 1_216, 1_216, 1_217,
					1_217, 1_217, 1_217, 1_217, 1_217, 1_217, 1_217, 1_217, 1_218, 1_218, 1_218, 1_218, 1_218, 1_218,
					1_218, 1_218, 1_218, 1_219, 1_219, 1_219, 1_219, 1_219, 1_219, 1_219, 1_219, 1_219, 1_220, 1_220,
					1_220, 1_220, 1_220, 1_220, 1_220, 1_220, 1_220, 1_221, 1_221, 1_221, 1_221, 1_221, 1_221, 1_221,
					1_221, 1_221, 1_222, 1_222, 0, 0, 0, 1_222, 1_222, 1_222, 1_223, 1_223, 1_223, 1_223, 1_223, 1_223,
					1_223, 1_223, 1_223, 1_224, 1_224, 1_224, 1_224, 1_224, 1_224, 1_224, 1_224, 1_224, 1_225, 1_225,
					1_225, 1_225, 1_225, 1_225, 1_225, 1_225, 1_225, 1_226, 1_226, 1_226, 1_226, 1_226, 1_226, 1_226,
					1_226, 1_226, 1_227, 1_227, 1_227, 1_227, 1_227, 1_227, 1_227, 1_227, 1_227, 1_228, 1_228, 1_228,
					1_228, 1_228, 1_228, 1_228, 1_228, 1_228, 1_229, 1_229, 1_229, 1_229, 1_229, 1_229, 1_229, 1_229,
					1_229, 1_230, 1_230, 1_230, 1_230, 1_230, 1_230, 1_230, 1_230, 1_230, 1_231, 1_231, 1_231, 1_231,
					1_231, 1_231, 1_231, 1_231, 1_231, 1_232, 1_232, 1_232, 1_232, 1_232, 1_232, 1_232, 1_232, 1_232,
					1_233, 1_233, 1_233, 1_233, 1_233, 1_233, 1_233, 1_233, 1_233, 1_234, 1_234, 1_234, 1_234, 1_234,
					1_234, 1_234, 1_234, 1_234, 1_235, 1_235, 1_235, 1_235, 1_235, 1_235, 1_235, 1_235, 1_235, 1_236,
					1_236, 1_236, 1_236, 1_236, 1_236, 1_236, 1_236, 1_236, 1_237, 1_237, 1_237, 1_237, 1_237, 1_237,
					1_237, 1_237, 1_237, 1_238, 1_238, 1_238, 1_238, 1_238, 1_238, 1_238, 1_238, 1_238, 1_239, 1_239,
					1_239, 1_239, 1_239, 1_239, 1_239, 1_239, 1_239, 1_240, 1_240, 1_240, 1_240, 1_240, 1_240, 1_240,
					1_240, 1_240, 1_241, 1_241, 1_241, 1_241, 1_241, 1_241, 1_241, 1_241, 1_241, 1_242, 1_242, 1_242,
					0, 0, 1_242, 1_242, 1_242, 1_243, 1_243, 0, 0, 0, 1_243, 1_243, 1_243, 1_244, 1_244, 1_244, 1_244,
					1_244, 1_244, 1_244, 1_244, 1_244, 1_245, 1_245, 1_245, 1_245, 1_245, 1_245, 1_245, 1_245, 1_245,
					1_246, 1_246, 1_246, 1_246, 1_246, 1_246, 1_246, 1_246, 1_246, 1_247, 1_247, 1_247, 1_247, 1_247,
					1_247, 1_247, 1_247, 1_247, 1_248, 1_248, 1_248, 1_248, 1_248, 1_248, 1_248, 1_248, 1_248, 1_249,
					1_249, 1_249, 1_249, 1_249, 1_249, 1_249, 1_249, 1_249, 1_250, 1_250, 1_250, 1_250, 1_250, 1_250,
					1_250, 1_250, 1_250, 1_251, 1_251, 1_251, 1_251, 1_251, 1_251, 1_251, 1_251, 1_251, 1_252, 1_252,
					1_252, 1_252, 1_252, 1_252, 1_252, 1_252, 1_252, 1_253, 1_253, 1_253, 1_253, 1_253, 1_253, 1_253,
					1_253, 1_253, 1_254, 1_254, 1_254, 1_254, 1_254, 1_254, 1_254, 1_254, 1_254, 1_255, 1_255, 1_255,
					1_255, 1_255, 1_255, 1_255, 1_255, 1_255, 1_256, 1_256, 1_256, 1_256, 1_256, 1_256, 1_256, 1_256,
					1_256, 1_257, 1_257, 1_257, 1_257, 1_257, 1_257, 1_257, 1_257, 1_257, 1_258, 1_258, 1_258, 1_258,
					1_258, 1_258, 1_258, 1_258, 1_258, 1_259, 1_259, 1_259, 1_259, 1_259, 1_259, 1_259, 1_259, 1_259,
					1_260, 1_260, 1_260, 1_260, 1_260, 1_260, 1_260, 1_260, 1_260, 1_261, 1_261, 1_261, 1_261, 1_261,
					1_261, 1_261, 1_261, 1_261, 1_262, 1_262, 1_262, 1_262, 1_262, 1_262, 1_262, 1_262, 1_262, 1_263,
					1_263, 1_263, 1_263, 1_263, 1_263, 1_263, 1_263, 1_263, 1_264, 1_264, 1_264, 1_264, 1_264, 1_264,
					1_264, 1_264, 1_264, 1_265, 1_265, 1_265, 1_265, 1_265, 1_265, 1_265, 1_265, 1_265, 1_266, 1_266,
					1_266, 0, 0, 1_266, 1_266, 1_266, 1_267, 1_267, 1_267, 1_267, 1_267, 1_267, 1_267, 1_267, 1_267,
					1_268, 1_268, 1_268, 1_268, 1_268, 1_268, 1_268, 1_268, 1_268, 1_269, 1_269, 1_269, 1_269, 1_269,
					1_269, 1_269, 1_269, 1_269, 1_270, 1_270, 1_270, 1_270, 1_270, 1_270, 1_270, 1_270, 1_270, 1_271,
					1_271, 1_271, 1_271, 1_271, 1_271, 1_271, 1_271, 1_271, 1_272, 1_272, 1_272, 1_272, 1_272, 1_272,
					1_272, 1_272, 1_272, 1_273, 1_273, 1_273, 1_273, 1_273, 1_273, 1_273, 1_273, 1_273, 1_274, 1_274,
					1_274, 1_274, 1_274, 1_274, 1_274, 1_274, 1_274, 1_275, 1_275, 1_275, 1_275, 1_275, 1_275, 1_275,
					1_275, 1_275, 1_276, 1_276, 1_276, 1_276, 1_276, 1_276, 1_276, 1_276, 1_276, 1_277, 1_277, 1_277,
					1_277, 1_277, 1_277, 1_277, 1_277, 1_277, 1_278, 1_278, 1_278, 1_278, 1_278, 1_278, 1_278, 1_278,
					1_278, 1_279, 1_279, 1_279, 1_279, 1_279, 1_279, 1_279, 1_279, 1_279, 1_280, 1_280, 1_280, 1_280,
					1_280, 1_280, 1_280, 1_280, 1_280, 1_281, 1_281, 1_281, 1_281, 1_281, 1_281, 1_281, 1_281, 1_281,
					1_282, 1_282, 1_282, 1_282, 1_282, 1_282, 1_282, 1_282, 1_282, 1_283, 1_283, 0, 1_283, 1_283, 1_283,
					1_283, 1_283, 1_283, 1_284, 1_284, 1_284, 1_284, 1_284, 1_284, 1_284, 1_284, 1_284, 1_285, 1_285,
					1_285, 1_285, 1_285, 1_285, 1_285, 1_285, 1_285, 1_286, 1_286, 1_286, 1_286, 1_286, 1_286, 1_286,
					1_286, 1_286, 1_287, 1_287, 0, 1_287, 1_287, 1_287, 1_287, 1_287, 1_287, 1_288, 1_288, 1_288, 1_288,
					1_288, 1_288, 1_288, 1_288, 1_288, 1_289, 1_289, 1_289, 1_289, 1_289, 1_289, 1_289, 1_289, 1_289,
					1_290, 1_290, 1_290, 1_290, 1_290, 1_290, 1_290, 1_290, 1_290, 1_291, 1_291, 1_291, 1_291, 1_291,
					1_291, 1_291, 1_291, 1_291, 1_292, 1_292, 1_292, 1_292, 1_292, 1_292, 1_292, 1_292, 1_292, 1_293,
					1_293, 1_293, 1_293, 1_293, 1_293, 1_293, 1_293, 1_293, 1_294, 1_294, 1_294, 1_294, 1_294, 1_294,
					1_294, 1_294, 1_294, 1_295, 1_295, 1_295, 1_295, 1_295, 1_295, 1_295, 1_295, 1_295, 1_296, 1_296,
					1_296, 1_296, 1_296, 1_296, 1_296, 1_296, 1_296, 1_297, 1_297, 1_297, 1_297, 1_297, 1_297, 1_297,
					1_297, 1_297, 1_298, 1_298, 1_298, 1_298, 1_298, 1_298, 1_298, 1_298, 1_298, 1_299, 1_299, 1_299,
					1_299, 1_299, 1_299, 1_299, 1_299, 1_299, 1_300, 1_300, 1_300, 1_300, 1_300, 1_300, 1_300, 1_300,
					1_300, 1_301, 1_301, 1_301, 1_301, 1_301, 1_301, 1_301, 1_301, 1_301, 1_302, 1_302, 1_302, 1_302,
					1_302, 1_302, 1_302, 1_302, 1_302, 1_303, 1_303, 1_303, 1_303, 1_303, 1_303, 1_303, 1_303, 1_303,
					1_304, 1_304, 1_304, 1_304, 1_304, 1_304, 1_304, 1_304, 1_304, 1_305, 1_305, 1_305, 1_305, 1_305,
					1_305, 1_305, 1_305, 1_305, 1_306, 1_306, 1_306, 1_306, 1_306, 1_306, 1_306, 1_306, 1_306, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152,
					1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152, 1_152
				>>)
		end

	yy_last_accepting_state: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	yy_last_accepting_cpos: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

feature {ANY} -- public routines

	get_urls_css (a_offset, a_buf_length: INTEGER_32)
		local
			l_token: INTEGER_32
			l_buffer_pos: INTEGER_32
			l_pos2: CE_ARRAY [INTEGER_32]
			l_length: CE_ARRAY [INTEGER_32]
			l_uri: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [ANY]
			l_up: CE_POINTER [PD_URLPOS]
			l_tmp___0: CE_POINTER [PD_URLPOS]
			l_tmp___1: INTEGER_32
			l_up___0: CE_POINTER [PD_URLPOS]
			l_tmp___2: CE_POINTER [PD_URLPOS]
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_pos2.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_length.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buffer_pos := 0;
					(create {P_CSS_STATIC}).yy_scan_bytes ((text + a_offset), a_buf_length).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_token := yylex
						update_class_fields -- Current might have been changed; synchronize
						if l_token = 0 then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if:
						if l_token /= 14 then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							l_buffer_pos := l_buffer_pos + ((create {P_CSS_STATIC}).yyleng.item)
							l_token := yylex
							update_class_fields -- Current might have been changed; synchronize
							if l_token /= 1 then
								l_break := True
							end
						end
						l_break := False
						if l_token /= 10 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if l_token /= 28 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						l_pos2.item := l_buffer_pos + a_offset
						update_class_fields -- Current might have been changed; synchronize
						l_length.item := (create {P_CSS_STATIC}).yyleng.item
						update_class_fields -- Current might have been changed; synchronize
						if l_token = 28 then
							l_uri := get_uri_string (text, l_pos2, l_length)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos2.item := l_pos2.item + 1
							update_class_fields -- Current might have been changed; synchronize
							l_length.item := l_length.item - (2)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp := (create {P_XMALLOC_STATIC}).xmalloc ((l_length.item + 1).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_uri := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)
							strncpy (l_uri, ((create {P_CSS_STATIC}).yytext.item + 1), (l_length.item).to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_uri[l_length.item] := (('%/0/').code).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not l_uri.is_void) then
							l_tmp___0 := ((create {CE_CLASS_POINTER [PD_MAP_CONTEXT]}.make_shared (c_pointer))).item.append_url (l_uri, l_pos2.item, l_length.item)
							update_class_fields -- Current might have been changed; synchronize
							l_up := l_tmp___0
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___1 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___1.to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Found @import: [%%s] at %%d [%%s]%N"), (create {P_CSS_STATIC}).yytext.item, l_buffer_pos, l_uri])
									update_class_fields -- Current might have been changed; synchronize
								end
								l_break := True
							end
							l_break := False
							if (not l_up.is_void) then
								l_up.item.link_inline_p := {NATURAL_32} 1
								update_class_fields -- Current might have been changed; synchronize
								l_up.item.link_css_p := {NATURAL_32} 1
								update_class_fields -- Current might have been changed; synchronize
								l_up.item.link_expect_css := {NATURAL_32} 1
								update_class_fields -- Current might have been changed; synchronize
							end
							free (create {CE_VOID_POINTER}.make_cast (l_uri))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 9 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						if l_token = 28 then
							l_pos2.item := l_buffer_pos + a_offset
							update_class_fields -- Current might have been changed; synchronize
							l_length.item := (create {P_CSS_STATIC}).yyleng.item
							update_class_fields -- Current might have been changed; synchronize
							l_uri := get_uri_string (text, l_pos2, l_length)
							update_class_fields -- Current might have been changed; synchronize
							if (not l_uri.is_void) then
								l_tmp___2 := ((create {CE_CLASS_POINTER [PD_MAP_CONTEXT]}.make_shared (c_pointer))).item.append_url (l_uri, l_pos2.item, l_length.item)
								update_class_fields -- Current might have been changed; synchronize
								l_up___0 := l_tmp___2
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___3 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___3.to_boolean then
										(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Found URI: [%%s] at %%d [%%s]%N"), (create {P_CSS_STATIC}).yytext.item, l_buffer_pos, l_uri])
										update_class_fields -- Current might have been changed; synchronize
									end
									l_break := True
								end
								l_break := False
								if (not l_up___0.is_void) then
									l_up___0.item.link_inline_p := {NATURAL_32} 1
									update_class_fields -- Current might have been changed; synchronize
									l_up___0.item.link_css_p := {NATURAL_32} 1
									update_class_fields -- Current might have been changed; synchronize
								end
								free (create {CE_VOID_POINTER}.make_cast (l_uri))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 11 then
						l_buffer_pos := l_buffer_pos + ((create {P_CSS_STATIC}).yyleng.item)
				when 12 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___4 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___4.to_boolean then
							(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%N")])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_break := True
					end
					l_break := False
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	append_url (a_link_uri: CE_POINTER [INTEGER_8]; a_position, a_size: INTEGER_32): CE_POINTER [PD_URLPOS]
		local
			l_link_has_scheme: INTEGER_32
			l_tmp: BOOLEAN
			l_newel: CE_POINTER [PD_URLPOS]
			l_base: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_url: CE_POINTER [PD_URL]
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: INTEGER_32
			l_complete_uri: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: INTEGER_32
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___14: CE_POINTER [PD_URLPOS]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := (create {P_URL_STATIC}).url_has_scheme (a_link_uri)
					update_class_fields -- Current might have been changed; synchronize
					l_link_has_scheme := l_tmp.to_integer
					if (not base.is_void) then
						l_tmp___0 := base
					else
						l_tmp___0 := parent_base
					end
					l_base := l_tmp___0
					if l_base.is_void then
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___1 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___1.to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%%s: no base, merge will use %"%%s%".%N"), document_file, a_link_uri])
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
						if not l_link_has_scheme.to_boolean then
							l_tmp___2 := gettext (ce_string ("%%s: Cannot resolve incomplete link %%s.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, l_tmp___2, document_file, a_link_uri])
							update_class_fields -- Current might have been changed; synchronize
							Result := (create {CE_CLASS_POINTER [PD_URLPOS]}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return then
							l_url := (create {P_URL_STATIC}).url_parse (a_link_uri, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_IRI]}.make_shared (default_pointer), (0).to_boolean)
							update_class_fields -- Current might have been changed; synchronize
							if l_url.is_void then
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___3 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___3.to_boolean then
										(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%%s: link %"%%s%" doesn%'t parse.%N"), document_file, a_link_uri])
										update_class_fields -- Current might have been changed; synchronize
									end
									l_break := True
								end
								l_break := False
								Result := (create {CE_CLASS_POINTER [PD_URLPOS]}.make_shared (default_pointer))
								l_return := True
							end
						end
					else
						l_tmp___4 := (create {P_URL_STATIC}).uri_merge (l_base, a_link_uri)
						update_class_fields -- Current might have been changed; synchronize
						l_complete_uri := l_tmp___4
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___9 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___9.to_boolean then
								l_tmp___5 := (create {P_QUOTEARG_STATIC}).quotearg_n_style (3, {PC_QUOTING_STYLE}.escape_quoting_style, l_complete_uri)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___6 := (create {P_QUOTE_STATIC}).quote_n (2, a_link_uri)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___7 := (create {P_QUOTE_STATIC}).quote_n (1, l_base)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___8 := (create {P_QUOTEARG_STATIC}).quotearg_n_style (0, {PC_QUOTING_STYLE}.escape_quoting_style, document_file)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%%s: merge(%%s, %%s) -> %%s%N"), l_tmp___8, l_tmp___7, l_tmp___6, l_tmp___5])
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
						l_url := (create {P_URL_STATIC}).url_parse (l_complete_uri, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_IRI]}.make_shared (default_pointer), (0).to_boolean)
						update_class_fields -- Current might have been changed; synchronize
						if l_url.is_void then
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___10 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___10.to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("%%s: merged link %"%%s%" doesn%'t parse.%N"), document_file, l_complete_uri])
									update_class_fields -- Current might have been changed; synchronize
								end
								l_break := True
							end
							l_break := False
							free (create {CE_VOID_POINTER}.make_cast (l_complete_uri))
							update_class_fields -- Current might have been changed; synchronize
							Result := (create {CE_CLASS_POINTER [PD_URLPOS]}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return then
							free (create {CE_VOID_POINTER}.make_cast (l_complete_uri))
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___12 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___12.to_boolean then
								l_tmp___11 := (create {P_QUOTE_STATIC}).quote (l_url.item.url)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("appending %%s to urlpos.%N"), l_tmp___11])
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
						l_tmp___13 := (create {P_XMALLOC_STATIC}).xcalloc ((1).to_natural_32, (create {PD_URLPOS}.make).structure_size.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_newel := create {CE_CLASS_POINTER [PD_URLPOS]}.make_cast (l_tmp___13)
						l_newel.item.url := l_url
						update_class_fields -- Current might have been changed; synchronize
						l_newel.item.pos := a_position
						update_class_fields -- Current might have been changed; synchronize
						l_newel.item.size := a_size
						update_class_fields -- Current might have been changed; synchronize
						if l_link_has_scheme.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (a_link_uri[0]).to_integer_32 /= 47 then
							l_newel.item.link_relative_p := {NATURAL_32} 1
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_link_has_scheme.to_boolean then
							l_newel.item.link_complete_p := {NATURAL_32} 1
							update_class_fields -- Current might have been changed; synchronize
						end
				when 5 then
						if (not tail.is_void) then
							tail.item.next := l_newel
							update_class_fields -- Current might have been changed; synchronize
							Current.tail := l_newel
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___14 := l_newel
							Current.head := l_tmp___14
							update_class_fields -- Current might have been changed; synchronize
							Current.tail := l_tmp___14
							update_class_fields -- Current might have been changed; synchronize
						end
						Result := l_newel
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {PD_MAP_CONTEXT} -- private routines

	yylex: INTEGER_32
		local
			l_yy_current_state: INTEGER_32
			l_yy_cp: CE_POINTER [INTEGER_8]
			l_yy_bp: CE_POINTER [INTEGER_8]
			l_yy_act: INTEGER_32
			l_tmp: CE_POINTER [PD_YY_BUFFER_STATE]
			l_yy_c: NATURAL_8
			l_yy_amount_of_matched_text: INTEGER_32
			l_yy_next_state: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((create {P_CSS_STATIC}).yy_init.item).to_boolean then
						(create {P_CSS_STATIC}).yy_init.item := 1
						if not ((create {P_CSS_STATIC}).yy_start.item).to_boolean then
							(create {P_CSS_STATIC}).yy_start.item := 1
						end
						if ((create {P_CSS_STATIC}).yyin.item).is_void then
							(create {P_CSS_STATIC}).yyin.item := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer))
						end
						if ((create {P_CSS_STATIC}).yyout.item).is_void then
							(create {P_CSS_STATIC}).yyout.item := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))
						end
						if (not ((create {P_CSS_STATIC}).yy_buffer_stack.item).is_void) then
							l_tmp := (create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]
						else
							l_tmp := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
						end
						if l_tmp.is_void then
							(create {P_CSS_STATIC}).yyensure_buffer_stack;
							(create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32] := yy_create_buffer ((create {P_CSS_STATIC}).yyin.item, 16_384)
						end
						(create {P_CSS_STATIC}).yy_load_buffer_state
					end
				when 1 then -- loop condition:
					if (l_return) then
						l_pos := -1 + 62 -- skip loop
					end
				when 2 then -- loop body:
						l_yy_cp := (create {P_CSS_STATIC}).yy_c_buf_p.item
						l_yy_cp[0] := (create {P_CSS_STATIC}).yy_hold_char.item
						l_yy_bp := l_yy_cp
						l_yy_current_state := (create {P_CSS_STATIC}).yy_start.item
				when 3 then -- yy_match:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_yy_c := (yy_ec.item[(((l_yy_cp[0]).to_natural_8).to_natural_32).to_integer_32]).to_natural_8
							if (yy_accept.item[l_yy_current_state]).to_boolean then
								yy_last_accepting_state.item := l_yy_current_state
								yy_last_accepting_cpos.item := l_yy_cp
							end
							from
							until
								(yy_chk.item[(yy_base.item[l_yy_current_state]).to_integer_32 + l_yy_c.to_integer_32]).to_integer_32 = l_yy_current_state
							loop
								l_yy_current_state := (yy_def.item[l_yy_current_state]).to_integer_32
								if l_yy_current_state >= 1_153 then
									l_yy_c := (yy_meta.item[(l_yy_c.to_natural_32).to_integer_32]).to_natural_8
								end
							end
							l_yy_current_state := (yy_nxt.item[((yy_base.item[l_yy_current_state]).to_natural_32 + l_yy_c.to_natural_32).to_integer_32]).to_integer_32
							l_yy_cp := l_yy_cp + 1
							if l_yy_current_state = 1_152 then
								l_break := True
							end
						end
						l_break := False
						l_yy_cp := yy_last_accepting_cpos.item
						l_yy_current_state := yy_last_accepting_state.item
				when 4 then -- yy_find_action:
						l_yy_act := (yy_accept.item[l_yy_current_state]).to_integer_32;
						(create {P_CSS_STATIC}).yytext.item := l_yy_bp;
						(create {P_CSS_STATIC}).yyleng.item := ((l_yy_cp.distance (l_yy_bp)).to_natural_32).to_integer_32;
						(create {P_CSS_STATIC}).yy_hold_char.item := l_yy_cp[0]
						l_yy_cp[0] := (('%/0/').code).to_integer_8;
						(create {P_CSS_STATIC}).yy_c_buf_p.item := l_yy_cp
				when 5 then -- do_action:
						inspect l_yy_act -- switch 1 head
						when 0 then l_pos := -1 + 6
						when 1 then l_pos := -1 + 7
						when 2 then l_pos := -1 + 8
						when 3 then l_pos := -1 + 9
						when 4 then l_pos := -1 + 10
						when 5 then l_pos := -1 + 11
						when 6 then l_pos := -1 + 12
						when 7 then l_pos := -1 + 13
						when 8 then l_pos := -1 + 14
						when 9 then l_pos := -1 + 15
						when 10 then l_pos := -1 + 16
						when 11 then l_pos := -1 + 17
						when 12 then l_pos := -1 + 18
						when 13 then l_pos := -1 + 19
						when 14 then l_pos := -1 + 20
						when 15 then l_pos := -1 + 21
						when 16 then l_pos := -1 + 22
						when 17 then l_pos := -1 + 23
						when 18 then l_pos := -1 + 24
						when 19 then l_pos := -1 + 25
						when 20 then l_pos := -1 + 26
						when 21 then l_pos := -1 + 27
						when 22 then l_pos := -1 + 28
						when 23 then l_pos := -1 + 29
						when 24 then l_pos := -1 + 30
						when 25 then l_pos := -1 + 31
						when 26 then l_pos := -1 + 32
						when 27 then l_pos := -1 + 33
						when 28 then l_pos := -1 + 34
						when 29 then l_pos := -1 + 35
						when 30 then l_pos := -1 + 36
						when 31 then l_pos := -1 + 37
						when 32 then l_pos := -1 + 38
						when 33 then l_pos := -1 + 39
						when 34 then l_pos := -1 + 40
						when 35 then l_pos := -1 + 41
						when 36 then l_pos := -1 + 42
						when 37 then l_pos := -1 + 43
						when 38 then l_pos := -1 + 44
						when 39 then l_pos := -1 + 45
						when 40 then l_pos := -1 + 46
						when 41 then l_pos := -1 + 47
						when 42 then l_pos := -1 + 48
						when 44 then l_pos := -1 + 49
						when 43 then l_pos := -1 + 50
						else l_pos := -1 + 60
						end
				when 6 then -- switch 1, case 0
						l_yy_cp[0] := (create {P_CSS_STATIC}).yy_hold_char.item
						l_yy_cp := yy_last_accepting_cpos.item
						l_yy_current_state := yy_last_accepting_state.item
						l_pos := -1 + 4 -- goto yy_find_action
				when 7 then -- switch 1, case 1
						Result := 1
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 8 then -- switch 1, case 2
						Result := 1
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 9 then -- switch 1, case 3
						Result := 2
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 10 then -- switch 1, case 4
						Result := 3
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 11 then -- switch 1, case 5
						Result := 4
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 12 then -- switch 1, case 6
						Result := 5
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 13 then -- switch 1, case 7
						Result := 6
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 14 then -- switch 1, case 8
						Result := 7
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 15 then -- switch 1, case 9
						Result := 8
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 16 then -- switch 1, case 10
						Result := 9
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 17 then -- switch 1, case 11
						Result := 10
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 18 then -- switch 1, case 12
						Result := 11
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 19 then -- switch 1, case 13
						Result := 12
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 20 then -- switch 1, case 14
						Result := 13
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 21 then -- switch 1, case 15
						Result := 14
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 22 then -- switch 1, case 16
						Result := 15
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 23 then -- switch 1, case 17
						Result := 16
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 24 then -- switch 1, case 18
						Result := 17
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 25 then -- switch 1, case 19
						Result := 18
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 26 then -- switch 1, case 20
						Result := 19
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 27 then -- switch 1, case 21
						Result := 20
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 28 then -- switch 1, case 22
						Result := 21
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 29 then -- switch 1, case 23
						Result := 21
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 30 then -- switch 1, case 24
						Result := 21
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 31 then -- switch 1, case 25
						Result := 21
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 32 then -- switch 1, case 26
						Result := 21
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 33 then -- switch 1, case 27
						Result := 21
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 34 then -- switch 1, case 28
						Result := 22
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 35 then -- switch 1, case 29
						Result := 22
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 36 then -- switch 1, case 30
						Result := 22
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 37 then -- switch 1, case 31
						Result := 23
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 38 then -- switch 1, case 32
						Result := 23
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 39 then -- switch 1, case 33
						Result := 24
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 40 then -- switch 1, case 34
						Result := 24
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 41 then -- switch 1, case 35
						Result := 25
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 42 then -- switch 1, case 36
						Result := 26
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 43 then -- switch 1, case 37
						Result := 27
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 44 then -- switch 1, case 38
						Result := 28
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 45 then -- switch 1, case 39
						Result := 28
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 46 then -- switch 1, case 40
						Result := 29
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 47 then -- switch 1, case 41
						Result := ((create {P_CSS_STATIC}).yytext.item[0]).to_integer_32
						l_return := True
						l_pos := -1 + 61 -- switch 1; break
				when 48 then -- switch 1, case 42
						from
						until
							(l_break)
						loop
							l_break := False
							fwrite (create {CE_VOID_POINTER}.make_cast ((create {P_CSS_STATIC}).yytext.item), ((create {P_CSS_STATIC}).yyleng.item).to_natural_32, (1).to_natural_32, (create {P_CSS_STATIC}).yyout.item).do_nothing
							l_break := True
						end
						l_break := False
						l_pos := -1 + 61 -- switch 1; break
				when 49 then -- switch 1, case 44
						Result := 0
						l_return := True
				when 50 then -- switch 1, case 43
						if l_return then
							l_pos := -1 + 59 -- skip if block
						end
				when 51 then -- if:
						l_yy_amount_of_matched_text := (l_yy_cp.distance (((create {P_CSS_STATIC}).yytext.item))) - 1
						l_yy_cp[0] := (create {P_CSS_STATIC}).yy_hold_char.item
						if ((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_buffer_status = 0 then
							(create {P_CSS_STATIC}).yy_n_chars.item := ((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_n_chars;
							((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_input_file := (create {P_CSS_STATIC}).yyin.item;
							((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_buffer_status := 1
						end
						if not ((((create {P_CSS_STATIC}).yy_c_buf_p.item).c_pointer.to_integer_32).to_natural_32 <= ((((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_ch_buf + (create {P_CSS_STATIC}).yy_n_chars.item).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:;
						(create {P_CSS_STATIC}).yy_c_buf_p.item := (create {P_CSS_STATIC}).yytext.item + l_yy_amount_of_matched_text
						l_yy_current_state := yy_get_previous_state
						l_yy_next_state := yy_try_NUL_trans (l_yy_current_state)
						l_yy_bp := (create {P_CSS_STATIC}).yytext.item + 0
						if l_yy_next_state.to_boolean then
							(create {P_CSS_STATIC}).yy_c_buf_p.item := (create {P_CSS_STATIC}).yy_c_buf_p.item + 1
							l_yy_cp := (create {P_CSS_STATIC}).yy_c_buf_p.item
							l_yy_current_state := l_yy_next_state
							l_pos := -1 + 3 -- goto yy_match
						else
							l_yy_cp := yy_last_accepting_cpos.item
							l_yy_current_state := yy_last_accepting_state.item
							l_pos := -1 + 4 -- goto yy_find_action
						end
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 59
				when 54 then -- else:
						inspect (yy_get_next_buffer) -- switch 2 head
						when 1 then l_pos := -1 + 55
						when 0 then l_pos := -1 + 57
						when 2 then l_pos := -1 + 58
						else l_pos := -1 + 59
						end
				when 55 then -- switch 2, case 1;
						(create {P_CSS_STATIC}).yy_did_buffer_switch_on_eof.item := 0;
						(create {P_CSS_STATIC}).yy_c_buf_p.item := (create {P_CSS_STATIC}).yytext.item + 0
						l_yy_act := (43 + ((create {P_CSS_STATIC}).yy_start.item - 1) // 2) + 1
						l_pos := -1 + 5 -- goto do_action
				when 56 then
						l_pos := -1 + 59 -- switch 2; break
				when 57 then -- switch 2, case 0;
						(create {P_CSS_STATIC}).yy_c_buf_p.item := (create {P_CSS_STATIC}).yytext.item + l_yy_amount_of_matched_text
						l_yy_current_state := yy_get_previous_state
						l_yy_cp := (create {P_CSS_STATIC}).yy_c_buf_p.item
						l_yy_bp := (create {P_CSS_STATIC}).yytext.item + 0
						l_pos := -1 + 3 -- goto yy_match
				when 58 then -- switch 2, case 2;
						(create {P_CSS_STATIC}).yy_c_buf_p.item := ((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_ch_buf + (create {P_CSS_STATIC}).yy_n_chars.item
						l_yy_current_state := yy_get_previous_state
						l_yy_cp := (create {P_CSS_STATIC}).yy_c_buf_p.item
						l_yy_bp := (create {P_CSS_STATIC}).yytext.item + 0
						l_pos := -1 + 4 -- goto yy_find_action
				when 59 then -- switch 2, done: | if done
						l_pos := -1 + 61 -- switch 1; break
				when 60 then -- switch 1, default:;
						(create {P_CSS_STATIC}).yy_fatal_error (ce_string ("fatal flex scanner internal error--no action found"))
				when 61 then -- switch 1, done:
						l_pos := -1 + 1 -- back to loop condition
				when 62 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	yy_get_next_buffer: INTEGER_32
		local
			l_dest: CE_POINTER [INTEGER_8]
			l_source: CE_POINTER [INTEGER_8]
			l_number_to_move: INTEGER_32
			l_i: INTEGER_32
			l_ret_val: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_num_to_read: INTEGER_32
			l_b: CE_POINTER [PD_YY_BUFFER_STATE]
			l_tmp___1: CE_POINTER [PD_YY_BUFFER_STATE]
			l_yy_c_buf_p_offset: INTEGER_32
			l_new_size: INTEGER_32
			l_c: INTEGER_32
			l_n: NATURAL_32
			l_tmp___3: NATURAL_32
			l_new_size___0: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_dest := ((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_ch_buf
			l_source := (create {P_CSS_STATIC}).yytext.item
			if (((create {P_CSS_STATIC}).yy_c_buf_p.item).c_pointer.to_integer_32).to_natural_32 > ((((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_ch_buf + ((create {P_CSS_STATIC}).yy_n_chars.item + 1)).c_pointer.to_integer_32).to_natural_32 then
				(create {P_CSS_STATIC}).yy_fatal_error (ce_string ("fatal flex scanner internal error--end of buffer missed"))
			end
			if ((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_fill_buffer = 0 then
				if ((create {P_CSS_STATIC}).yy_c_buf_p.item).distance (((create {P_CSS_STATIC}).yytext.item)) = 1 then
					Result := 1
					l_return := True
				else
					Result := 2
					l_return := True
				end
			end
			if not l_return then
				l_number_to_move := (((create {P_CSS_STATIC}).yy_c_buf_p.item).distance (((create {P_CSS_STATIC}).yytext.item))) - 1
				l_i := 0
				from
				until
					not (l_i < l_number_to_move)
				loop
					l_tmp := l_dest
					l_dest := l_dest + 1
					l_tmp___0 := l_source
					l_source := l_source + 1
					l_tmp[0] := l_tmp___0[0]
					l_i := l_i + 1
				end
				if ((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_buffer_status = 2 then
					(create {P_CSS_STATIC}).yy_n_chars.item := 0;
					((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_n_chars := (create {P_CSS_STATIC}).yy_n_chars.item
				else
					l_num_to_read := ((((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_buf_size - l_number_to_move.to_natural_32) - {NATURAL_32} 1).to_integer_32
					from
					until
						not (l_num_to_read <= 0)
					loop
						if (not ((create {P_CSS_STATIC}).yy_buffer_stack.item).is_void) then
							l_tmp___1 := (create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]
						else
							l_tmp___1 := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
						end
						l_b := l_tmp___1
						l_yy_c_buf_p_offset := ((create {P_CSS_STATIC}).yy_c_buf_p.item).distance ((l_b.item.yy_ch_buf))
						if (l_b.item.yy_is_our_buffer).to_boolean then
							l_new_size := (l_b.item.yy_buf_size * {NATURAL_32} 2).to_integer_32
							if l_new_size <= 0 then
								l_b.item.yy_buf_size := l_b.item.yy_buf_size + (l_b.item.yy_buf_size // {NATURAL_32} 8)
							else
								l_b.item.yy_buf_size := l_b.item.yy_buf_size * ({NATURAL_32} 2)
							end
							l_b.item.yy_ch_buf := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_CSS_STATIC}).yyrealloc (create {CE_VOID_POINTER}.make_cast (l_b.item.yy_ch_buf), l_b.item.yy_buf_size + {NATURAL_32} 2)))
						else
							l_b.item.yy_ch_buf := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						end
						if (l_b.item.yy_ch_buf).is_void then
							(create {P_CSS_STATIC}).yy_fatal_error (ce_string ("fatal error - scanner input buffer overflow"))
						end
						(create {P_CSS_STATIC}).yy_c_buf_p.item := l_b.item.yy_ch_buf + l_yy_c_buf_p_offset
						l_num_to_read := ((((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_buf_size - l_number_to_move.to_natural_32) - {NATURAL_32} 1).to_integer_32
					end
					if l_num_to_read > 8_192 then
						l_num_to_read := 8_192
					end
					if (((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_is_interactive).to_boolean then
						l_c := ('*').code
						l_n := (0).to_natural_32
						from
						until
							(l_break)
						loop
							l_break := False
							if l_n < l_num_to_read.to_natural_32 then
								l_c := IO_getc ((create {P_CSS_STATIC}).yyin.item)
								if l_c /= -1 then
									if l_c = 10 then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								(((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_ch_buf + l_number_to_move)[l_n.to_integer_32] := l_c.to_integer_8
								l_n := l_n + 1
							end
						end
						l_break := False
						if l_c = 10 then
							l_tmp___3 := l_n
							l_n := l_n + 1;
							(((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_ch_buf + l_number_to_move)[l_tmp___3.to_integer_32] := l_c.to_integer_8
						end
						if l_c = -1 then
							if (ferror ((create {P_CSS_STATIC}).yyin.item)).to_boolean then
								(create {P_CSS_STATIC}).yy_fatal_error (ce_string ("input in flex scanner failed"))
							end
						end
						(create {P_CSS_STATIC}).yy_n_chars.item := l_n.to_integer_32
					else
						(errno_location).item := 0
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_CSS_STATIC}).yy_n_chars.item := (fread (create {CE_VOID_POINTER}.make_cast ((((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_ch_buf + l_number_to_move)), (1).to_natural_32, l_num_to_read.to_natural_32, (create {P_CSS_STATIC}).yyin.item)).to_integer_32
							if (create {P_CSS_STATIC}).yy_n_chars.item = 0 then
								if not (ferror ((create {P_CSS_STATIC}).yyin.item)).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								if (errno_location).item /= 4 then
									(create {P_CSS_STATIC}).yy_fatal_error (ce_string ("input in flex scanner failed"))
									l_break := True
								end
							end
							if not (l_break) then
								(errno_location).item := 0
								clearerr ((create {P_CSS_STATIC}).yyin.item)
							end
						end
						l_break := False
					end
					((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_n_chars := (create {P_CSS_STATIC}).yy_n_chars.item
				end
				if (create {P_CSS_STATIC}).yy_n_chars.item = 0 then
					if l_number_to_move = 0 then
						l_ret_val := 1
						yyrestart ((create {P_CSS_STATIC}).yyin.item)
					else
						l_ret_val := 2;
						((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_buffer_status := 2
					end
				else
					l_ret_val := 0
				end
				if ((create {P_CSS_STATIC}).yy_n_chars.item + l_number_to_move).to_natural_32 > ((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_buf_size then
					l_new_size___0 := (((create {P_CSS_STATIC}).yy_n_chars.item + l_number_to_move) + (((create {P_CSS_STATIC}).yy_n_chars.item).bit_shift_right (1))).to_natural_32;
					((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_ch_buf := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_CSS_STATIC}).yyrealloc (create {CE_VOID_POINTER}.make_cast (((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_ch_buf), l_new_size___0)))
					if (((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_ch_buf).is_void then
						(create {P_CSS_STATIC}).yy_fatal_error (ce_string ("out of dynamic memory in yy_get_next_buffer()"))
					end
				end
				(create {P_CSS_STATIC}).yy_n_chars.item := (create {P_CSS_STATIC}).yy_n_chars.item + l_number_to_move;
				((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_ch_buf[(create {P_CSS_STATIC}).yy_n_chars.item] := (0).to_integer_8;
				((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_ch_buf[((create {P_CSS_STATIC}).yy_n_chars.item + 1)] := (0).to_integer_8;
				(create {P_CSS_STATIC}).yytext.item := ((create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]).item.yy_ch_buf + 0
				Result := l_ret_val
			end
		end

	yy_get_previous_state: INTEGER_32
		local
			l_yy_current_state: INTEGER_32
			l_yy_cp: CE_POINTER [INTEGER_8]
			l_yy_c: NATURAL_8
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_yy_current_state := (create {P_CSS_STATIC}).yy_start.item
			l_yy_cp := (create {P_CSS_STATIC}).yytext.item + 0
			from
			until
				not (not (l_return) and then ((l_yy_cp.c_pointer.to_integer_32).to_natural_32 < (((create {P_CSS_STATIC}).yy_c_buf_p.item).c_pointer.to_integer_32).to_natural_32))
			loop
				if (l_yy_cp[0]).to_boolean then
					l_tmp := yy_ec.item[(((l_yy_cp[0]).to_natural_8).to_natural_32).to_integer_32]
				else
					l_tmp := 1
				end
				l_yy_c := l_tmp.to_natural_8
				if (yy_accept.item[l_yy_current_state]).to_boolean then
					yy_last_accepting_state.item := l_yy_current_state
					yy_last_accepting_cpos.item := l_yy_cp
				end
				from
				until
					(yy_chk.item[(yy_base.item[l_yy_current_state]).to_integer_32 + l_yy_c.to_integer_32]).to_integer_32 = l_yy_current_state
				loop
					l_yy_current_state := (yy_def.item[l_yy_current_state]).to_integer_32
					if l_yy_current_state >= 1_153 then
						l_yy_c := (yy_meta.item[(l_yy_c.to_natural_32).to_integer_32]).to_natural_8
					end
				end
				l_yy_current_state := (yy_nxt.item[((yy_base.item[l_yy_current_state]).to_natural_32 + l_yy_c.to_natural_32).to_integer_32]).to_integer_32
				l_yy_cp := l_yy_cp + 1
			end
			Result := l_yy_current_state
		end

	yy_try_NUL_trans (a_yy_current_state: INTEGER_32): INTEGER_32
		local
			l_yy_current_state: INTEGER_32
			l_yy_is_jam: INTEGER_32
			l_yy_cp: CE_POINTER [INTEGER_8]
			l_yy_c: NATURAL_8
			l_tmp: INTEGER_32
		do
			l_yy_current_state := a_yy_current_state
			l_yy_cp := (create {P_CSS_STATIC}).yy_c_buf_p.item
			l_yy_c := (1).to_natural_8
			if (yy_accept.item[l_yy_current_state]).to_boolean then
				yy_last_accepting_state.item := l_yy_current_state
				yy_last_accepting_cpos.item := l_yy_cp
			end
			from
			until
				(yy_chk.item[(yy_base.item[l_yy_current_state]).to_integer_32 + l_yy_c.to_integer_32]).to_integer_32 = l_yy_current_state
			loop
				l_yy_current_state := (yy_def.item[l_yy_current_state]).to_integer_32
				if l_yy_current_state >= 1_153 then
					l_yy_c := (yy_meta.item[(l_yy_c.to_natural_32).to_integer_32]).to_natural_8
				end
			end
			l_yy_current_state := (yy_nxt.item[((yy_base.item[l_yy_current_state]).to_natural_32 + l_yy_c.to_natural_32).to_integer_32]).to_integer_32
			l_yy_is_jam := (l_yy_current_state = 1_152).to_integer
			if l_yy_is_jam.to_boolean then
				l_tmp := 0
			else
				l_tmp := l_yy_current_state
			end
			Result := l_tmp
		end

	yyrestart (a_input_file: CE_POINTER [SD_IO_FILE])
		local
			l_tmp: CE_POINTER [PD_YY_BUFFER_STATE]
			l_tmp___0: CE_POINTER [PD_YY_BUFFER_STATE]
		do
			if (not ((create {P_CSS_STATIC}).yy_buffer_stack.item).is_void) then
				l_tmp := (create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]
			else
				l_tmp := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
			end
			if l_tmp.is_void then
				(create {P_CSS_STATIC}).yyensure_buffer_stack;
				(create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32] := yy_create_buffer ((create {P_CSS_STATIC}).yyin.item, 16_384)
			end
			if (not ((create {P_CSS_STATIC}).yy_buffer_stack.item).is_void) then
				l_tmp___0 := (create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]
			else
				l_tmp___0 := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
			end
			yy_init_buffer (l_tmp___0, a_input_file);
			(create {P_CSS_STATIC}).yy_load_buffer_state
		end

	yy_create_buffer (a_file: CE_POINTER [SD_IO_FILE]; a_size: INTEGER_32): CE_POINTER [PD_YY_BUFFER_STATE]
		local
			l_b: CE_POINTER [PD_YY_BUFFER_STATE]
		do
			l_b := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_cast (((create {P_CSS_STATIC}).yyalloc ((create {PD_YY_BUFFER_STATE}.make).structure_size.to_natural_32)))
			if l_b.is_void then
				(create {P_CSS_STATIC}).yy_fatal_error (ce_string ("out of dynamic memory in yy_create_buffer()"))
			end
			l_b.item.yy_buf_size := a_size.to_natural_32
			l_b.item.yy_ch_buf := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_CSS_STATIC}).yyalloc (l_b.item.yy_buf_size + {NATURAL_32} 2)))
			if (l_b.item.yy_ch_buf).is_void then
				(create {P_CSS_STATIC}).yy_fatal_error (ce_string ("out of dynamic memory in yy_create_buffer()"))
			end
			l_b.item.yy_is_our_buffer := 1
			yy_init_buffer (l_b, a_file)
			Result := l_b
		end

	yy_init_buffer (a_b: CE_POINTER [PD_YY_BUFFER_STATE]; a_file: CE_POINTER [SD_IO_FILE])
		require
			not a_b.is_void
		local
			l_oerrno: INTEGER_32
			l_tmp___0: CE_POINTER [PD_YY_BUFFER_STATE]
		do
			l_oerrno := (errno_location).item
			yy_flush_buffer (a_b)
			a_b.item.yy_input_file := a_file
			a_b.item.yy_fill_buffer := 1
			if (not ((create {P_CSS_STATIC}).yy_buffer_stack.item).is_void) then
				l_tmp___0 := (create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]
			else
				l_tmp___0 := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
			end
			if not a_b.is_equal (l_tmp___0) then
				a_b.item.yy_bs_lineno := 1
				a_b.item.yy_bs_column := 0
			end
			a_b.item.yy_is_interactive := 0;
			(errno_location).item := l_oerrno
		end

	yy_flush_buffer (a_b: CE_POINTER [PD_YY_BUFFER_STATE])
		local
			l_tmp: CE_POINTER [PD_YY_BUFFER_STATE]
			l_return: BOOLEAN
		do
			if a_b.is_void then
				l_return := True
			end
			if not l_return then
				a_b.item.yy_n_chars := 0
				a_b.item.yy_ch_buf[0] := (0).to_integer_8
				a_b.item.yy_ch_buf[1] := (0).to_integer_8
				a_b.item.yy_buf_pos := a_b.item.yy_ch_buf + 0
				a_b.item.yy_at_bol := 1
				a_b.item.yy_buffer_status := 0
				if (not ((create {P_CSS_STATIC}).yy_buffer_stack.item).is_void) then
					l_tmp := (create {P_CSS_STATIC}).yy_buffer_stack.item[((create {P_CSS_STATIC}).yy_buffer_stack_top.item).to_integer_32]
				else
					l_tmp := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
				end
				if a_b.is_equal (l_tmp) then
					(create {P_CSS_STATIC}).yy_load_buffer_state
				end
			end
		end

	get_uri_string (a_at: CE_POINTER [INTEGER_8]; a_pos, a_length: CE_POINTER [INTEGER_32]): CE_POINTER [INTEGER_8]
		require
			not a_pos.is_void
		local
			l_uri: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			if 0 /= (strncasecmp (a_at + a_pos.item, ce_string ("url("), (4).to_natural_32)) then
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				a_pos.item := a_pos.item + (4)
				a_length.item := a_length.item - (5)
				from
				until
					(l_break)
				loop
					l_break := False
					if not ((((ctype_b_loc).item[(a_at[a_pos.item]).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
						l_break := True
					end
					if not (l_break) then
						a_pos.item := (a_pos.item) + 1
						a_length.item := (a_length.item) - 1
					end
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					if not ((((ctype_b_loc).item[(a_at[((a_pos.item + a_length.item) - 1)]).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
						l_break := True
					end
					if not (l_break) then
						a_length.item := (a_length.item) - 1
					end
				end
				l_break := False
				if (a_at[a_pos.item]).to_integer_32 = 39 then
					a_pos.item := (a_pos.item) + 1
					a_length.item := a_length.item - (2)
				elseif (a_at[a_pos.item]).to_integer_32 = 34 then
					a_pos.item := (a_pos.item) + 1
					a_length.item := a_length.item - (2)
				end
				l_uri := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((a_length.item + 1).to_natural_32)))
				if (not l_uri.is_void) then
					strncpy (l_uri, (a_at + a_pos.item), (a_length.item).to_natural_32).do_nothing
					l_uri[a_length.item] := (('%/0/').code).to_integer_8
				end
				Result := l_uri
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			text := a_other.text
			base := a_other.base
			parent_base := a_other.parent_base
			document_file := a_other.document_file
			nofollow := a_other.nofollow
			head := a_other.head
			tail := a_other.tail
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				text.is_equal (a_other.text) and
				base.is_equal (a_other.base) and
				parent_base.is_equal (a_other.parent_base) and
				document_file.is_equal (a_other.document_file) and
				nofollow = a_other.nofollow and
				head.is_equal (a_other.head) and
				tail.is_equal (a_other.tail)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("text"),
					create {CE_STRUCTURE_FIELD}.make ("base"),
					create {CE_STRUCTURE_FIELD}.make ("parent_base"),
					create {CE_STRUCTURE_FIELD}.make ("document_file"),
					create {CE_STRUCTURE_FIELD}.make ("nofollow"),
					create {CE_STRUCTURE_FIELD}.make ("head"),
					create {CE_STRUCTURE_FIELD}.make ("tail")
				>>)
			init_structure_info
		end

end
