class
	PD_CONNECTION

inherit
	PD_CONNECTION_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_SYS_SOCKET_STATIC
		redefine
			copy,
			is_equal
		end
	S_BITS_ERRNO_STATIC
		redefine
			copy,
			is_equal
		end
	S_FCNTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_NETINET_IN_STATIC
		redefine
			copy,
			is_equal
		end
	S_UNISTD_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_SIGNAL_STATIC
		redefine
			copy,
			is_equal
		end
	S_SYS_STAT_STATIC
		redefine
			copy,
			is_equal
		end
	S_DIRENT_STATIC
		redefine
			copy,
			is_equal
		end
	S_PWD_STATIC
		redefine
			copy,
			is_equal
		end
	S_GRP_STATIC
		redefine
			copy,
			is_equal
		end
	S_TIME_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_CONNECTION]} next.make
			create {CE_CLASS_POINTER [PD_CONNECTION]} prev.make
			create {CE_NATURAL_8_POINTER} url.make
			create {CE_INTEGER_32_ARRAY} pri.make (<<6>>)
			create {CE_VOID_POINTER} dnsquery.make
			create statuss.make
			create {CE_VOID_POINTER} info.make
			create {CE_VOID_POINTER} buffer.make
			create conn_func.make
			create {CE_CLASS_POINTER [PD_CACHE_ENTRY]} cache.make
			create prg.make
			Precursor
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_CONNECTION] assign set_next

	prev: CE_POINTER [PD_CONNECTION] assign set_prev

	count: NATURAL_32 assign set_count

	url: CE_POINTER [NATURAL_8] assign set_url

	running: INTEGER_32 assign set_running

	state: INTEGER_32 assign set_state

	prev_error: INTEGER_32 assign set_prev_error

	from2: INTEGER_32 assign set_from2

	pri: CE_ARRAY [INTEGER_32]

	no_cache: INTEGER_32 assign set_no_cache

	sock1: INTEGER_32 assign set_sock1

	sock2: INTEGER_32 assign set_sock2

	dnsquery: CE_POINTER [ANY] assign set_dnsquery

	pid: INTEGER_32 assign set_pid

	tries: INTEGER_32 assign set_tries

	statuss: PD_LIST_HEAD assign set_statuss

	info: CE_POINTER [ANY] assign set_info

	buffer: CE_POINTER [ANY] assign set_buffer

	conn_func: CE_ROUTINE assign set_conn_func

	cache: CE_POINTER [PD_CACHE_ENTRY] assign set_cache

	received: INTEGER_32 assign set_received

	est_length: INTEGER_32 assign set_est_length

	unrestartable: INTEGER_32 assign set_unrestartable

	prg: PD_REMAINING_INFO assign set_prg

	timer: INTEGER_32 assign set_timer

	detached: INTEGER_32 assign set_detached

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_CONNECTION])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_CONNECTION])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_count (a_count: NATURAL_32)
		do
			count := a_count
			update_memory_field ("count")
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_running (a_running: INTEGER_32)
		do
			running := a_running
			update_memory_field ("running")
		end

	set_state (a_state: INTEGER_32)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_prev_error (a_prev_error: INTEGER_32)
		do
			prev_error := a_prev_error
			update_memory_field ("prev_error")
		end

	set_from2 (a_from2: INTEGER_32)
		do
			from2 := a_from2
			update_memory_field ("from2")
		end

	set_no_cache (a_no_cache: INTEGER_32)
		do
			no_cache := a_no_cache
			update_memory_field ("no_cache")
		end

	set_sock1 (a_sock1: INTEGER_32)
		do
			sock1 := a_sock1
			update_memory_field ("sock1")
		end

	set_sock2 (a_sock2: INTEGER_32)
		do
			sock2 := a_sock2
			update_memory_field ("sock2")
		end

	set_dnsquery (a_dnsquery: CE_POINTER [ANY])
		do
			dnsquery := a_dnsquery
			update_memory_field ("dnsquery")
		end

	set_pid (a_pid: INTEGER_32)
		do
			pid := a_pid
			update_memory_field ("pid")
		end

	set_tries (a_tries: INTEGER_32)
		do
			tries := a_tries
			update_memory_field ("tries")
		end

	set_statuss (a_statuss: PD_LIST_HEAD)
		do
			statuss := a_statuss
			update_memory_field ("statuss")
		end

	set_info (a_info: CE_POINTER [ANY])
		do
			info := a_info
			update_memory_field ("info")
		end

	set_buffer (a_buffer: CE_POINTER [ANY])
		do
			buffer := a_buffer
			update_memory_field ("buffer")
		end

	set_conn_func (a_conn_func: CE_ROUTINE)
		do
			conn_func := a_conn_func
			update_memory_field ("conn_func")
		end

	set_cache (a_cache: CE_POINTER [PD_CACHE_ENTRY])
		do
			cache := a_cache
			update_memory_field ("cache")
		end

	set_received (a_received: INTEGER_32)
		do
			received := a_received
			update_memory_field ("received")
		end

	set_est_length (a_est_length: INTEGER_32)
		do
			est_length := a_est_length
			update_memory_field ("est_length")
		end

	set_unrestartable (a_unrestartable: INTEGER_32)
		do
			unrestartable := a_unrestartable
			update_memory_field ("unrestartable")
		end

	set_prg (a_prg: PD_REMAINING_INFO)
		do
			prg := a_prg
			update_memory_field ("prg")
		end

	set_timer (a_timer: INTEGER_32)
		do
			timer := a_timer
			update_memory_field ("timer")
		end

	set_detached (a_detached: INTEGER_32)
		do
			detached := a_detached
			update_memory_field ("detached")
		end

feature {PD_CONNECTION} -- private attributes

	h_conns: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (h_conns.item), create {CE_VOID_POINTER}.make_cast (h_conns.item)])
		end

	st_r: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	smb_client: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	accept_cookies: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 2
		end

	cookie_id: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (0).to_natural_32
		end

	last_uid: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	last_gid: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	last_user: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<64>>)
		end

	last_group: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<64>>)
		end

	ftp_head: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('<').code).to_natural_8, (('h').code).to_natural_8, (('t').code).to_natural_8, (('m').code).to_natural_8,
					(('l').code).to_natural_8, (('>').code).to_natural_8, (('<').code).to_natural_8, (('h').code).to_natural_8,
					(('e').code).to_natural_8, (('a').code).to_natural_8, (('d').code).to_natural_8, (('>').code).to_natural_8,
					(('<').code).to_natural_8, (('t').code).to_natural_8, (('i').code).to_natural_8, (('t').code).to_natural_8,
					(('l').code).to_natural_8, (('e').code).to_natural_8, (('>').code).to_natural_8, (('/').code).to_natural_8,
					(('%/0/').code).to_natural_8
				>>)
		end

	ftp_head2: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('<').code).to_natural_8, (('/').code).to_natural_8, (('t').code).to_natural_8, (('i').code).to_natural_8,
					(('t').code).to_natural_8, (('l').code).to_natural_8, (('e').code).to_natural_8, (('>').code).to_natural_8,
					(('<').code).to_natural_8, (('/').code).to_natural_8, (('h').code).to_natural_8, (('e').code).to_natural_8,
					(('a').code).to_natural_8, (('d').code).to_natural_8, (('>').code).to_natural_8, (('<').code).to_natural_8,
					(('b').code).to_natural_8, (('o').code).to_natural_8, (('d').code).to_natural_8, (('y').code).to_natural_8,
					(('>').code).to_natural_8, (('<').code).to_natural_8, (('h').code).to_natural_8, (('2').code).to_natural_8,
					(('>').code).to_natural_8, (('D').code).to_natural_8, (('i').code).to_natural_8, (('r').code).to_natural_8,
					(('e').code).to_natural_8, (('c').code).to_natural_8, (('t').code).to_natural_8, (('o').code).to_natural_8,
					(('r').code).to_natural_8, (('y').code).to_natural_8, ((' ').code).to_natural_8, (('/').code).to_natural_8,
					(('%/0/').code).to_natural_8
				>>)
		end

	ftp_head3: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('<').code).to_natural_8, (('/').code).to_natural_8, (('h').code).to_natural_8, (('2').code).to_natural_8,
					(('>').code).to_natural_8, (('<').code).to_natural_8, (('p').code).to_natural_8, (('r').code).to_natural_8,
					(('e').code).to_natural_8, (('>').code).to_natural_8, (('%/0/').code).to_natural_8
				>>)
		end

	buggy_servers: CE_STATIC [CE_ARRAY [PD_BUGGY_SERVERS]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_BUGGY_SERVERS]}.make_initialized (<<
					create {PD_BUGGY_SERVERS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mod_czech/3.1.0")), 1]),
					create {PD_BUGGY_SERVERS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Purveyor")), 1]),
					create {PD_BUGGY_SERVERS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Netscape-Enterprise")), 3]),
					create {PD_BUGGY_SERVERS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Apache Coyote")), 1]),
					create {PD_BUGGY_SERVERS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lighttpd")), 1]),
					create {PD_BUGGY_SERVERS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("FORPSI")), 8]),
					create {PD_BUGGY_SERVERS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0])
				>>)
		end

	accept_charset: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

feature {ANY} -- public routines

	make_connection (a_port: INTEGER_32; a_sock: CE_POINTER [INTEGER_32]; a_func: CE_ROUTINE)
		local
			l_as: INTEGER_32
			l_host: CE_POINTER [NATURAL_8]
			l_b: CE_POINTER [PD_CONN_INFO]
			l_tmp: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			l_host := (create {P_URL_STATIC}).get_host_name (url)
			update_class_fields -- Current might have been changed; synchronize
			if l_host.is_void then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_003)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("connect.c")), 58, (create {PD_CONN_INFO}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_b := create {CE_CLASS_POINTER [PD_CONN_INFO]}.make_cast (l_tmp)
				l_b.item.func := a_func
				update_class_fields -- Current might have been changed; synchronize
				l_b.item.sock := a_sock
				update_class_fields -- Current might have been changed; synchronize
				l_b.item.port := a_port
				update_class_fields -- Current might have been changed; synchronize
				Current.buffer := create {CE_VOID_POINTER}.make_cast (l_b)
				update_class_fields -- Current might have been changed; synchronize
				if no_cache >= 3 then
					l_as := find_host_no_cache (l_host, create {CE_NATURAL_32_POINTER}.make_shared (l_b.c_pointer + (create {PD_CONN_INFO}.make).offset_of ("addr")), create {CE_POINTER_POINTER [ANY]}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("dnsquery")), (dns_found_address), create {CE_VOID_POINTER}.make_shared (c_pointer))
					update_class_fields -- Current might have been changed; synchronize
				else
					l_as := find_host (l_host, create {CE_NATURAL_32_POINTER}.make_shared (l_b.c_pointer + (create {PD_CONN_INFO}.make).offset_of ("addr")), create {CE_POINTER_POINTER [ANY]}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("dnsquery")), (dns_found_address), create {CE_VOID_POINTER}.make_shared (c_pointer))
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("connect.c")), 68, create {CE_VOID_POINTER}.make_cast (l_host))
				update_class_fields -- Current might have been changed; synchronize
				if l_as.to_boolean then
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (1)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	dns_found (a_state: INTEGER_32)
		local
			l_s: INTEGER_32
			l_b: CE_POINTER [PD_CONN_INFO]
			l_tmp: CE_POINTER [INTEGER_32]
			l_tmp___0: CE_POINTER [INTEGER_32]
			l_tmp___1: CE_POINTER [INTEGER_32]
			l_tmp___2: CE_POINTER [INTEGER_32]
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			l_b := create {CE_CLASS_POINTER [PD_CONN_INFO]}.make_cast (buffer)
			if a_state.to_boolean then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_005)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_s := socket (2, 1, 6)
				update_class_fields -- Current might have been changed; synchronize
				if l_s = -1 then
					l_tmp := errno_location
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-l_tmp.item)
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
				(l_b.item.sock).item := l_s
				update_class_fields -- Current might have been changed; synchronize
				fcntl ([l_s, 4, 2_048]).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				memset (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_SOCKADDR_IN]}.make_shared (l_b.c_pointer + (create {PD_CONN_INFO}.make).offset_of ("sa")))), 0, (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_b.item.sa.sin_family := (2).to_natural_16
				update_class_fields -- Current might have been changed; synchronize
				l_b.item.sa.sin_addr.s_addr := l_b.item.addr
				update_class_fields -- Current might have been changed; synchronize
				l_b.item.sa.sin_port := htons ((l_b.item.port).to_natural_16)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___3 := connect (l_s, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast ((create {CE_CLASS_POINTER [SD_SOCKADDR_IN]}.make_shared (l_b.c_pointer + (create {PD_CONN_INFO}.make).offset_of ("sa")))), (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___3.to_boolean then
					l_tmp___1 := errno_location
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___1.item /= 114 then
						l_tmp___2 := errno_location
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2.item /= 115 then
							l_tmp___0 := errno_location
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-l_tmp___0.item)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if not l_return then
						(create {P_SELECT_STATIC}).set_handlers (l_s, create {CE_ROUTINE}.make_shared (default_pointer), (connected_address), (exception_address), create {CE_VOID_POINTER}.make_shared (c_pointer))
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (2)
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.connected
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
			end
		end

	connected
		local
			l_b: CE_POINTER [PD_CONN_INFO]
			l_err: CE_ARRAY [INTEGER_32]
			l_len: CE_ARRAY [NATURAL_32]
			l_tmp: CE_POINTER [INTEGER_32]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_err.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_len.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_b := create {CE_CLASS_POINTER [PD_CONN_INFO]}.make_cast (buffer)
					l_err.item := 0
					update_class_fields -- Current might have been changed; synchronize
					l_len.item := {PLATFORM}.Integer_32_bytes.to_natural_32
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := getsockopt ((l_b.item.sock).item, 1, 4, create {CE_VOID_POINTER}.make_cast (l_err), l_len)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___0.to_boolean then
						l_tmp := errno_location
						update_class_fields -- Current might have been changed; synchronize
						l_err.item := l_tmp.item
						update_class_fields -- Current might have been changed; synchronize
						if not (l_err.item).to_boolean then
							l_err.item := 1_012
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 2 -- goto bla
						end
					end
				when 1 then
					if l_err.item >= 10_000 then
						l_err.item := l_err.item - (10_000)
						update_class_fields -- Current might have been changed; synchronize
					end
					if not (l_err.item > 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 2 then -- if: | bla:;
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-l_err.item)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
				when 3 then -- if done
					if not l_return then
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.set_timeout
						update_class_fields -- Current might have been changed; synchronize
						Current.buffer := create {CE_VOID_POINTER}.make_shared (default_pointer)
						update_class_fields; -- Current might have been changed; synchronize
						(l_b.item.func).call ([(create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("connect.c")), 206, create {CE_VOID_POINTER}.make_cast (l_b))
						update_class_fields -- Current might have been changed; synchronize
					end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	write_select
		local
			l_wb: CE_POINTER [PD_WRITE_BUFFER]
			l_wr: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_32]
			l_tmp___0: INTEGER_32
			l_f: CE_ROUTINE
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			l_wb := create {CE_CLASS_POINTER [PD_WRITE_BUFFER]}.make_cast (buffer)
			if l_wb.is_void then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("connect.c"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).errline.item := 222
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("write socket has no buffer"))])
					update_class_fields -- Current might have been changed; synchronize
				end
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_003)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.set_timeout
				update_class_fields -- Current might have been changed; synchronize
				l_wr := write (l_wb.item.sock, create {CE_VOID_POINTER}.make_cast ((l_wb.item.data + l_wb.item.pos)), (l_wb.item.len - l_wb.item.pos).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				if l_wr <= 0 then
					if l_wr.to_boolean then
						l_tmp := errno_location
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := -l_tmp.item
					else
						l_tmp___0 := -1_006
					end
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (l_tmp___0)
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
				l_tmp___1 := l_wb.item.pos + l_wr
				l_wb.item.pos := l_tmp___1
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___1 = l_wb.item.len then
					l_f := l_wb.item.done
					Current.buffer := create {CE_VOID_POINTER}.make_shared (default_pointer)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_SELECT_STATIC}).set_handlers (l_wb.item.sock, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("connect.c")), 257, create {CE_VOID_POINTER}.make_cast (l_wb))
					update_class_fields -- Current might have been changed; synchronize
					l_f.call ([(create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))])
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	write_to_socket (a_s: INTEGER_32; a_data: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_write_func: CE_ROUTINE)
		local
			l_wb: CE_POINTER [PD_WRITE_BUFFER]
			l_tmp: CE_POINTER [ANY]
		do
			if a_len.to_natural_32 > {NATURAL_32} 2_147_483_647 - (create {PD_WRITE_BUFFER}.make).structure_size.to_natural_32 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("connect.c"), 266])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_KBD_STATIC}).fatal_tty_exit
					update_class_fields -- Current might have been changed; synchronize
					exit (4)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("connect.c")), 267, (create {PD_WRITE_BUFFER}.make).structure_size.to_natural_32 + a_len.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_wb := create {CE_CLASS_POINTER [PD_WRITE_BUFFER]}.make_cast (l_tmp)
			l_wb.item.sock := a_s
			update_class_fields -- Current might have been changed; synchronize
			l_wb.item.len := a_len
			update_class_fields -- Current might have been changed; synchronize
			l_wb.item.pos := 0
			update_class_fields -- Current might have been changed; synchronize
			l_wb.item.done := a_write_func
			update_class_fields -- Current might have been changed; synchronize
			memcpy (create {CE_VOID_POINTER}.make_cast ((l_wb.item.data)), create {CE_VOID_POINTER}.make_cast (a_data), a_len.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			if (not buffer.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("connect.c")), 273, buffer)
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.buffer := create {CE_VOID_POINTER}.make_cast (l_wb)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SELECT_STATIC}).set_handlers (a_s, create {CE_ROUTINE}.make_shared (default_pointer), (write_select_address), (exception_address), create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	read_select
		local
			l_rb: CE_POINTER [PD_READ_BUFFER]
			l_rd: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [INTEGER_32]
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			l_rb := create {CE_CLASS_POINTER [PD_READ_BUFFER]}.make_cast (buffer)
			if l_rb.is_void then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("connect.c"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).errline.item := 285
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("read socket has no buffer"))])
					update_class_fields -- Current might have been changed; synchronize
				end
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_003)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				(create {P_SELECT_STATIC}).set_handlers (l_rb.item.sock, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				if (l_rb.item.len).to_natural_32 > ({NATURAL_32} 2_147_483_647 - (create {PD_READ_BUFFER}.make).structure_size.to_natural_32) - {NATURAL_32} 64_240 then
					from
					until
						False
					loop
						(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("connect.c"), 291])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_KBD_STATIC}).fatal_tty_exit
						update_class_fields -- Current might have been changed; synchronize
						exit (4)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_tmp := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("connect.c")), 292, create {CE_VOID_POINTER}.make_cast (l_rb), ((create {PD_READ_BUFFER}.make).structure_size.to_natural_32 + (l_rb.item.len).to_natural_32) + {NATURAL_32} 64_240)
				update_class_fields -- Current might have been changed; synchronize
				l_rb := create {CE_CLASS_POINTER [PD_READ_BUFFER]}.make_cast (l_tmp)
				Current.buffer := create {CE_VOID_POINTER}.make_cast (l_rb)
				update_class_fields -- Current might have been changed; synchronize
				l_rd := read (l_rb.item.sock, create {CE_VOID_POINTER}.make_cast ((l_rb.item.data + l_rb.item.len)), (64_240).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				if l_rd <= 0 then
					if (l_rb.item.close).to_boolean then
						if not l_rd.to_boolean then
							l_rb.item.close := 2
							update_class_fields; -- Current might have been changed; synchronize
							(l_rb.item.done).call ([(create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer)), l_rb])
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if not l_return then
						if l_rd.to_boolean then
							l_tmp___0 := errno_location
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___1 := -l_tmp___0.item
						else
							l_tmp___1 := -1_007
						end
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (l_tmp___1)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
				end
			end
			if not l_return then
				l_rb.item.len := l_rb.item.len + l_rd
				update_class_fields; -- Current might have been changed; synchronize
				(l_rb.item.done).call ([(create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer)), l_rb])
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	read_from_socket (a_s: INTEGER_32; a_buf___0: CE_POINTER [PD_READ_BUFFER]; a_read_func: CE_ROUTINE)
		require
			not a_buf___0.is_void
		do
			a_buf___0.item.done := a_read_func
			update_class_fields -- Current might have been changed; synchronize
			a_buf___0.item.sock := a_s
			update_class_fields -- Current might have been changed; synchronize
			if (not buffer.is_void) then
				if not a_buf___0.is_equal (buffer) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("connect.c")), 344, buffer)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			Current.buffer := create {CE_VOID_POINTER}.make_cast (a_buf___0)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SELECT_STATIC}).set_handlers (a_s, (read_select_address), create {CE_ROUTINE}.make_shared (default_pointer), (exception_address), create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	finger_func
		local
			l_p: INTEGER_32
			l_return: BOOLEAN
		do
			l_p := get_port (url)
			update_class_fields -- Current might have been changed; synchronize
			if l_p = -1 then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_003)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				Current.from2 := (0).to_integer_32
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.make_connection (l_p, create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock1")), finger_send_request_address)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	finger_send_request
		local
			l_req: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp: CE_POINTER [NATURAL_8]
			l_rl: CE_ARRAY [INTEGER_32]
			l_user: CE_POINTER [NATURAL_8]
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_req.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rl.make (<<1>>)

			l_tmp := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("finger.c")), 22)
			update_class_fields -- Current might have been changed; synchronize
			l_req.item := l_tmp
			update_class_fields -- Current might have been changed; synchronize
			l_rl.item := 0
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_req, l_rl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/W")))
			update_class_fields -- Current might have been changed; synchronize
			l_user := (create {P_URL_STATIC}).get_user_name (url)
			update_class_fields -- Current might have been changed; synchronize
			if (not l_user.is_void) then
				(create {P_LINKS_STATIC}).add_to_str (l_req, l_rl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_LINKS_STATIC}).add_to_str (l_req, l_rl, l_user)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("finger.c")), 29, create {CE_VOID_POINTER}.make_cast (l_user))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_LINKS_STATIC}).add_to_str (l_req, l_rl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.write_to_socket (sock1, l_req.item, l_rl.item, finger_sent_request_address)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("finger.c")), 33, create {CE_VOID_POINTER}.make_cast (l_req.item))
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (4)
			update_class_fields -- Current might have been changed; synchronize
		end

	finger_get_response (a_rb: CE_POINTER [PD_READ_BUFFER])
		local
			l_e: CE_ARRAY [CE_POINTER [PD_CACHE_ENTRY]]
			l_l: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_CACHE_ENTRY]} l_e.make (<<1>>);

			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.set_timeout
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_CACHE_STATIC}).get_cache_entry (url, l_e)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_004)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				Current.cache := l_e.item
				update_class_fields -- Current might have been changed; synchronize
				if a_rb.item.close = 2 then
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_000)
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.finger_end_request
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
				l_l := a_rb.item.len
				if from2 + l_l.to_integer_32 < 0 then
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_014)
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
				Current.received := received + l_l.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := add_fragment (cache, from2, a_rb.item.data, l_l.to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0 = 1 then
					Current.tries := 0
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.from2 := from2 + l_l.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				kill_buffer_data (a_rb, l_l)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.read_from_socket (sock1, a_rb, finger_get_response_address)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (8)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	finger_end_request
		do
			if state = -1_000 then
				if (not cache.is_void) then
					truncate_entry (cache, from2, 1)
					update_class_fields -- Current might have been changed; synchronize
					cache.item.incomplete := 0
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
			update_class_fields -- Current might have been changed; synchronize
		end

	ftp_login
		local
			l_login: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_u: CE_POINTER [NATURAL_8]
			l_logl: CE_ARRAY [INTEGER_32]
			l_fi: CE_POINTER [PD_FTP_CONNECTION_INFO]
			l_tmp: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_login.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_logl.make (<<1>>)

			l_logl.item := 0
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.set_timeout
			update_class_fields -- Current might have been changed; synchronize
			l_login.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 117)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("USER ")))
			update_class_fields -- Current might have been changed; synchronize
			l_u := (create {P_URL_STATIC}).get_user_name (url)
			update_class_fields -- Current might have been changed; synchronize
			if (not l_u.is_void) then
				if (l_u.item).to_boolean then
					(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, l_u)
					update_class_fields -- Current might have been changed; synchronize
				else
					(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("anonymous")))
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("anonymous")))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not l_u.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 121, create {CE_VOID_POINTER}.make_cast (l_u))
				update_class_fields -- Current might have been changed; synchronize
			end
			if ((create {P_DEFAULT_STATIC}).ftp_options.item.item.fast_ftp).to_boolean then
				(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%NPASS ")))
				update_class_fields -- Current might have been changed; synchronize
				l_u := get_pass (url)
				update_class_fields -- Current might have been changed; synchronize
				if (not l_u.is_void) then
					if (l_u.item).to_boolean then
						(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, l_u)
						update_class_fields -- Current might have been changed; synchronize
					else
						(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, (create {P_DEFAULT_STATIC}).ftp_options.item.item.anon_pass)
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, (create {P_DEFAULT_STATIC}).ftp_options.item.item.anon_pass)
					update_class_fields -- Current might have been changed; synchronize
				end
				if (not l_u.is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 127, create {CE_VOID_POINTER}.make_cast (l_u))
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
				update_class_fields -- Current might have been changed; synchronize
				l_fi := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.add_file_cmd_to_str
				update_class_fields -- Current might have been changed; synchronize
				if l_fi.is_void then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 130, create {CE_VOID_POINTER}.make_cast (l_login.item))
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
				if not l_return then
					(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, l_fi.item.cmdbuf)
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
				update_class_fields -- Current might have been changed; synchronize
			end
			if not l_return then
				l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_login.item))
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.write_to_socket (sock1, l_login.item, l_tmp.to_integer_32, (create {P_FTP_STATIC}).ftp_logged_address)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 136, create {CE_VOID_POINTER}.make_cast (l_login.item))
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (4)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	add_file_cmd_to_str: CE_POINTER [PD_FTP_CONNECTION_INFO]
		local
			l_d: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_de: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_del: CE_ARRAY [INTEGER_32]
			l_pc: CE_ARRAY [NATURAL_8]
			l_ps: INTEGER_32
			l_inf: CE_POINTER [PD_FTP_CONNECTION_INFO]
			l_inf2: CE_POINTER [PD_FTP_CONNECTION_INFO]
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [ANY]
			l_on: CE_ARRAY [INTEGER_32]
			l_tmp___2: NATURAL_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [ANY]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_de.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_del.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_pc.make (<<6>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_on.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := (create {P_URL_STATIC}).get_url_data (url)
					update_class_fields -- Current might have been changed; synchronize
					l_d := l_tmp
					if l_d.is_void then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).errline.item := 226
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("get_url_data failed"))])
							update_class_fields -- Current might have been changed; synchronize
						end
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_003)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
						update_class_fields -- Current might have been changed; synchronize
						Result := (create {CE_CLASS_POINTER [PD_FTP_CONNECTION_INFO]}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						l_de.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 231)
						update_class_fields -- Current might have been changed; synchronize
						l_del.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_d))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_de, l_del, l_d, l_tmp___0.to_integer_32, -2)
						update_class_fields -- Current might have been changed; synchronize
						l_d := l_de.item
						l_tmp___1 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 234, (create {PD_FTP_CONNECTION_INFO}.make).structure_size.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_inf := create {CE_CLASS_POINTER [PD_FTP_CONNECTION_INFO]}.make_cast (l_tmp___1)
						memset (create {CE_VOID_POINTER}.make_cast (l_inf), 0, (create {PD_FTP_CONNECTION_INFO}.make).structure_size.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_l.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_s.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 237)
						update_class_fields -- Current might have been changed; synchronize
						l_inf.item.pasv := (create {P_DEFAULT_STATIC}).ftp_options.item.item.passive_ftp
						update_class_fields -- Current might have been changed; synchronize
						Current.info := create {CE_VOID_POINTER}.make_cast (l_inf)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_inf.item.pasv).to_boolean then
							l_ps := get_pasv_socket ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer)), sock1, create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock2")), l_pc)
							update_class_fields -- Current might have been changed; synchronize
							if l_ps.to_boolean then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 241, create {CE_VOID_POINTER}.make_cast (l_d))
								update_class_fields -- Current might have been changed; synchronize
								Result := (create {CE_CLASS_POINTER [PD_FTP_CONNECTION_INFO]}.make_shared (default_pointer))
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_DEFAULT_STATIC}).ftp_options.item.item.set_tos).to_boolean then
							l_on.item := 8
							update_class_fields -- Current might have been changed; synchronize
							setsockopt (sock2, 0, 1, create {CE_VOID_POINTER}.make_cast (l_on), {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tmp___3 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_d), 1)
						update_class_fields -- Current might have been changed; synchronize
						l_de.item := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___3)
						update_class_fields -- Current might have been changed; synchronize
						if (l_de.item).is_void then
							l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_d))
							update_class_fields -- Current might have been changed; synchronize
							l_de.item := l_d + l_tmp___2.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
						if not (l_d.is_equal (l_de.item)) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if (l_de.item[-1]).to_integer_32 /= 47 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						l_inf.item.dir := 1
						update_class_fields -- Current might have been changed; synchronize
						l_inf.item.pending_commands := 4
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("TYPE A%R%N")))
						update_class_fields -- Current might have been changed; synchronize
						if not (l_inf.item.pasv).to_boolean then
							(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("PORT ")))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_num_to_str (l_s, l_l, (l_pc[0]).to_integer_32)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_num_to_str (l_s, l_l, (l_pc[1]).to_integer_32)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_num_to_str (l_s, l_l, (l_pc[2]).to_integer_32)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_num_to_str (l_s, l_l, (l_pc[3]).to_integer_32)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_num_to_str (l_s, l_l, (l_pc[4]).to_integer_32)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_num_to_str (l_s, l_l, (l_pc[5]).to_integer_32)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("PASV%R%N")))
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("CWD /")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_bytes_to_str (l_s, l_l, l_d, (l_de.item).distance (l_d))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%NLIST%R%N")))
						update_class_fields -- Current might have been changed; synchronize
						Current.from2 := (0).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_inf.item.dir := 0
						update_class_fields -- Current might have been changed; synchronize
						l_inf.item.pending_commands := 3
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("TYPE I%R%N")))
						update_class_fields -- Current might have been changed; synchronize
						if not (l_inf.item.pasv).to_boolean then
							(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("PORT ")))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_num_to_str (l_s, l_l, (l_pc[0]).to_integer_32)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_num_to_str (l_s, l_l, (l_pc[1]).to_integer_32)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_num_to_str (l_s, l_l, (l_pc[2]).to_integer_32)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_num_to_str (l_s, l_l, (l_pc[3]).to_integer_32)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_num_to_str (l_s, l_l, (l_pc[4]).to_integer_32)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_chr_to_str (l_s, l_l, ((',').code).to_natural_8)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_num_to_str (l_s, l_l, (l_pc[5]).to_integer_32)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("PASV%R%N")))
							update_class_fields -- Current might have been changed; synchronize
						end
						if from2.to_boolean then
							if no_cache < 2 then
								(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("REST ")))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_num_to_str (l_s, l_l, from2)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
								update_class_fields -- Current might have been changed; synchronize
								l_inf.item.rest_sent := 1
								update_class_fields -- Current might have been changed; synchronize
								l_inf.item.pending_commands := (l_inf.item.pending_commands) + 1
								update_class_fields -- Current might have been changed; synchronize
							else
								Current.from2 := (0).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							Current.from2 := (0).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("RETR /")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_bytes_to_str (l_s, l_l, l_d, (l_de.item).distance (l_d))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_s, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
						update_class_fields -- Current might have been changed; synchronize
				when 8 then -- if done
						l_inf.item.opc := l_inf.item.pending_commands
						update_class_fields -- Current might have been changed; synchronize
						if (l_l.item).to_natural_32 > ({NATURAL_32} 2_147_483_647 - (create {PD_FTP_CONNECTION_INFO}.make).structure_size.to_natural_32) - {NATURAL_32} 1 then
							from
							until
								False
							loop
								(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("ftp.c"), 309])
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_KBD_STATIC}).fatal_tty_exit
								update_class_fields -- Current might have been changed; synchronize
								exit (4)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_tmp___4 := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 310, create {CE_VOID_POINTER}.make_cast (l_inf), ((create {PD_FTP_CONNECTION_INFO}.make).structure_size.to_natural_32 + (l_l.item).to_natural_32) + {NATURAL_32} 1)
						update_class_fields -- Current might have been changed; synchronize
						l_inf2 := create {CE_CLASS_POINTER [PD_FTP_CONNECTION_INFO]}.make_cast (l_tmp___4)
						l_inf := l_inf2
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_inf.item.cmdbuf)), create {CE_INTEGER_8_POINTER}.make_cast (l_s.item)).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 312, create {CE_VOID_POINTER}.make_cast (l_s.item))
						update_class_fields -- Current might have been changed; synchronize
						Current.info := create {CE_VOID_POINTER}.make_cast (l_inf)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 314, create {CE_VOID_POINTER}.make_cast (l_d))
						update_class_fields -- Current might have been changed; synchronize
						Result := l_inf
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_send_retr_req (a_state: INTEGER_32)
		local
			l_fi: CE_POINTER [PD_FTP_CONNECTION_INFO]
			l_login: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_logl: CE_ARRAY [INTEGER_32]
			l_nl: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: NATURAL_32
			l_tmp___1: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_login.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_logl.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_logl.item := 0
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.set_timeout
					update_class_fields -- Current might have been changed; synchronize
					l_login.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 325)
					update_class_fields -- Current might have been changed; synchronize
					if info.is_void then
						l_fi := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.add_file_cmd_to_str
						update_class_fields -- Current might have been changed; synchronize
						if (not l_fi.is_void) then
							l_fi := create {CE_CLASS_POINTER [PD_FTP_CONNECTION_INFO]}.make_cast (info)
						else
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 327, create {CE_VOID_POINTER}.make_cast (l_login.item))
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					else
						l_fi := create {CE_CLASS_POINTER [PD_FTP_CONNECTION_INFO]}.make_cast (info)
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_DEFAULT_STATIC}).ftp_options.item.item.fast_ftp).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if: | a:;
						(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, l_fi.item.cmdbuf)
						update_class_fields -- Current might have been changed; synchronize
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						l_tmp := strchr (create {CE_INTEGER_8_POINTER}.make_cast ((l_fi.item.cmdbuf)), ('%N').code)
						update_class_fields -- Current might have been changed; synchronize
						l_nl := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)
						if l_nl.is_void then
							l_pos := -1 + 2 -- goto a
						end
				when 5 then
						l_nl := l_nl + 1;
						(create {P_LINKS_STATIC}).add_bytes_to_str (l_login, l_logl, l_fi.item.cmdbuf, l_nl.distance ((l_fi.item.cmdbuf)))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_nl))
						update_class_fields -- Current might have been changed; synchronize
						memmove (create {CE_VOID_POINTER}.make_cast ((l_fi.item.cmdbuf)), create {CE_VOID_POINTER}.make_cast (l_nl), l_tmp___0 + {NATURAL_32} 1).do_nothing
						update_class_fields -- Current might have been changed; synchronize
				when 6 then -- if done
						l_tmp___1 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_login.item))
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.write_to_socket (sock1, l_login.item, l_tmp___1.to_integer_32, (create {P_FTP_STATIC}).ftp_retr_1_address)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 339, create {CE_VOID_POINTER}.make_cast (l_login.item))
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (a_state)
						update_class_fields -- Current might have been changed; synchronize
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_retr_file (a_rb: CE_POINTER [PD_READ_BUFFER])
		local
			l_g: INTEGER_32
			l_inf: CE_POINTER [PD_FTP_CONNECTION_INFO]
			l_pc: CE_ARRAY [NATURAL_8]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_n: INTEGER_32
			l_a: NATURAL_32
			l_sa: CE_ARRAY [SD_SOCKADDR_IN]
			l_nl: CE_ARRAY [NATURAL_32]
			l_tmp: INTEGER_32
			l_sa___0: CE_ARRAY [SD_SOCKADDR_IN]
			l_tmp___0: CE_POINTER [INTEGER_32]
			l_tmp___1: INTEGER_32
			l_on: CE_ARRAY [INTEGER_32]
			l_tmp___2: CE_POINTER [INTEGER_32]
			l_tmp___3: CE_POINTER [INTEGER_32]
			l_tmp___4: CE_POINTER [INTEGER_32]
			l_tmp___5: INTEGER_32
			l_d: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_p: INTEGER_32
			l_tmp___6: INTEGER_32
			l_est: INTEGER_64
			l_tmp___7: INTEGER_64
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_pc.make (<<6>>)
			create {CE_CLASS_ARRAY [SD_SOCKADDR_IN]} l_sa.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_nl.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_SOCKADDR_IN]} l_sa___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_on.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_inf := create {CE_CLASS_POINTER [PD_FTP_CONNECTION_INFO]}.make_cast (info)
					if True then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | rep:
						if not ((create {P_DEFAULT_STATIC}).ftp_options.item.item.fast_ftp).to_boolean then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.ftp_send_retr_req (6)
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
				when 2 then -- if done
					if not (not l_return and then (l_inf.item.pending_commands > 1)) then
						l_pos := -1 + 39 -- skip if block
					end
				when 3 then -- if:
						if not ((l_inf.item.pasv).to_boolean) then
							l_pos := -1 + 33 -- skip if block
						end
				when 4 then -- if:
						if l_inf.item.opc - (l_inf.item.pending_commands - 1) /= 2 then
							l_pos := -1 + 33 -- skip if block
						end
				when 5 then -- if:
						l_i := 3
				when 6 then -- loop condition:
						if not (not (l_return) and then (l_i < a_rb.item.len)) then
							l_pos := -1 + 31 -- skip loop
						end
				when 7 then -- loop body:
						if not ((a_rb.item.data[l_i]).to_integer_32 >= 48) then
							l_pos := -1 + 30 -- skip if block
						end
				when 8 then -- if:
						if not ((a_rb.item.data[l_i]).to_integer_32 <= 57) then
							l_pos := -1 + 30 -- skip if block
						end
				when 9 then -- if:
						l_j := 0
				when 10 then -- loop condition:
						if not (not (l_return) and then (l_j < 6)) then
							l_pos := -1 + 29 -- skip loop
						end
				when 11 then -- loop body:
						l_n := 0
				when 12 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 17 -- skip loop
						end
				when 13 then -- loop body:
						l_break := False
						if (a_rb.item.data[l_i]).to_integer_32 >= 48 then
							if not ((a_rb.item.data[l_i]).to_integer_32 <= 57) then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_n := (l_n * 10 + (a_rb.item.data[l_i]).to_integer_32) - 48
						if l_n >= 256 then
							l_pos := -1 + 31 -- goto no_pasv
						end
				when 15 then
						l_i := l_i + 1
						if l_i >= a_rb.item.len then
							l_pos := -1 + 31 -- goto no_pasv
						end
				when 16 then
						l_pos := -1 + 12 -- back to loop condition
				when 17 then -- loop done
						l_break := False
						l_pc[l_j] := l_n.to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						if l_j = 5 then
							l_pos := -1 + 28 -- skip if block
						end
				when 18 then -- if:
						if (a_rb.item.data[l_i]).to_integer_32 /= 44 then
							l_pos := -1 + 24 -- goto xa
						end
				when 19 then
						l_i := l_i + 1
						if l_i >= a_rb.item.len then
							l_pos := -1 + 24 -- goto xa
						end
				when 20 then
						if not ((a_rb.item.data[l_i]).to_integer_32 < 48) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 24 -- goto xa
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 23 then -- else:
						if not ((a_rb.item.data[l_i]).to_integer_32 > 57) then
							l_pos := -1 + 28 -- skip if block
						end
				when 24 then -- if: | xa:
						if l_j /= 1 then
							l_pos := -1 + 31 -- goto no_pasv
						end
				when 25 then
						l_pc[4] := l_pc[0]
						update_class_fields -- Current might have been changed; synchronize
						l_pc[5] := l_pc[1]
						update_class_fields -- Current might have been changed; synchronize
						l_nl.item := (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32
						update_class_fields -- Current might have been changed; synchronize
						l_tmp := getpeername (sock1, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_sa), l_nl)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp.to_boolean then
							l_pos := -1 + 31 -- goto no_pasv
						end
				when 26 then
						if l_nl.item /= (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32 then
							l_pos := -1 + 31 -- goto no_pasv
						end
				when 27 then
						l_a := ntohl (l_sa.item.sin_addr.s_addr)
						update_class_fields -- Current might have been changed; synchronize
						l_pc[0] := ((l_a).bit_shift_right (24)).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_pc[1] := ((l_a).bit_shift_right (16)).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_pc[2] := ((l_a).bit_shift_right (8)).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_pc[3] := l_a.to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 32 -- goto pasv_ok
				when 28 then -- if done | if done
						l_j := l_j + 1
						l_pos := -1 + 10 -- back to loop condition
				when 29 then -- loop done
						l_pos := -1 + 32 -- goto pasv_ok
				when 30 then -- if done
						l_i := l_i + 1
						l_pos := -1 + 6 -- back to loop condition
				when 31 then -- no_pasv:
						memset (create {CE_VOID_POINTER}.make_cast (l_pc), 0, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (6).to_natural_32)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
				when 32 then -- pasv_ok:
						
				when 33 then -- if done | if done
						l_g := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.get_ftp_response (a_rb, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_g = -1 then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_300)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
						if not l_return and then (not l_g.to_boolean) then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.read_from_socket (sock1, a_rb, ftp_retr_file_address)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (6)
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
						if l_return then
							l_pos := -1 + 38 -- skip if block
						end
				when 34 then -- if:
						l_inf.item.pending_commands := (l_inf.item.pending_commands) - 1
						update_class_fields -- Current might have been changed; synchronize
						inspect l_inf.item.opc - l_inf.item.pending_commands -- switch 1 head
						when 1 then l_pos := -1 + 35
						when 2 then l_pos := -1 + 36
						when 3 then l_pos := -1 + 37
						else l_pos := -1 + 38
						end
				when 35 then -- switch 1, case 1
						l_pos := -1 + 1 -- goto rep
				when 36 then -- switch 1, case 2
						if l_g >= 400 then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_303)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
						if not l_return and then ((l_inf.item.pasv).to_boolean) then
							if not (l_pc[0]).to_boolean then
								if not (l_pc[1]).to_boolean then
									if not (l_pc[2]).to_boolean then
										if not (l_pc[3]).to_boolean then
											if not (l_pc[4]).to_boolean then
												if not (l_pc[5]).to_boolean then
													((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_300)
													update_class_fields; -- Current might have been changed; synchronize
													((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
													update_class_fields -- Current might have been changed; synchronize
													l_return := True
												end
											end
										end
									end
								end
							end
							if not l_return then
								l_sa___0.item.sin_family := (2).to_natural_16
								update_class_fields -- Current might have been changed; synchronize
								l_sa___0.item.sin_port := htons (((((l_pc[4]).to_integer_32).bit_shift_left (8)) + (l_pc[5]).to_integer_32).to_natural_16)
								update_class_fields -- Current might have been changed; synchronize
								l_sa___0.item.sin_addr.s_addr := htonl (((((((l_pc[0]).to_integer_32).bit_shift_left (24)) + (((l_pc[1]).to_integer_32).bit_shift_left (16))) + (((l_pc[2]).to_integer_32).bit_shift_left (8))) + (l_pc[3]).to_integer_32).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___1 := socket (2, 1, 6)
								update_class_fields -- Current might have been changed; synchronize
								Current.sock2 := l_tmp___1
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___1 = -1 then
									l_tmp___0 := errno_location
									update_class_fields; -- Current might have been changed; synchronize
									((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-l_tmp___0.item)
									update_class_fields; -- Current might have been changed; synchronize
									((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
									update_class_fields -- Current might have been changed; synchronize
									l_return := True
								end
							end
							if not l_return then
								fcntl ([sock2, 4, 2_048]).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								if ((create {P_DEFAULT_STATIC}).ftp_options.item.item.set_tos).to_boolean then
									l_on.item := 8
									update_class_fields -- Current might have been changed; synchronize
									setsockopt (sock2, 0, 1, create {CE_VOID_POINTER}.make_cast (l_on), {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
								l_tmp___5 := connect (sock2, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_sa___0), (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___5.to_boolean then
									l_tmp___3 := errno_location
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___3.item /= 115 then
										l_tmp___4 := errno_location
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___4.item /= 114 then
											l_tmp___2 := errno_location
											update_class_fields; -- Current might have been changed; synchronize
											((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-l_tmp___2.item)
											update_class_fields; -- Current might have been changed; synchronize
											((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
											update_class_fields -- Current might have been changed; synchronize
											l_return := True
										end
									end
								end
							end
							if not l_return then
								l_inf.item.d := 1
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_SELECT_STATIC}).set_handlers (sock2, (got_something_from_data_connection_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (c_pointer))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if not l_return then
							l_pos := -1 + 1 -- goto rep
						end
				when 37 then -- switch 1, case 3
						if not l_return and then (l_g >= 400) then
							if not (l_inf.item.dir).to_boolean then
								Current.from2 := (0).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							else
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_304)
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							end
						end
						if not l_return then
							l_pos := -1 + 1 -- goto rep
						end
				when 38 then -- switch 1, done: | if done
						if not l_return then
							from
							until
								False
							loop
								(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c"))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).errline.item := 457
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("WHAT???"))])
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 39 then -- if done
					if not l_return then
						l_g := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.get_ftp_response (a_rb, 2)
						update_class_fields -- Current might have been changed; synchronize
						if not l_g.to_boolean then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.read_from_socket (sock1, a_rb, ftp_retr_file_address)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (6)
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 54 -- skip if block
					end
				when 40 then -- if:
						if not (l_g >= 100) then
							l_pos := -1 + 53 -- skip if block
						end
				when 41 then -- if:
						if not (l_g < 200) then
							l_pos := -1 + 53 -- skip if block
						end
				when 42 then -- if:
						l_d := a_rb.item.data
						l_p := 0
						l_i___0 := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if l_i___0 < a_rb.item.len then
								if (l_d[l_i___0]).to_integer_32 = 10 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								if (l_d[l_i___0]).to_integer_32 = 40 then
									l_p := l_i___0
								end
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						if not l_p.to_boolean then
							l_pos := -1 + 52 -- goto nol
						elseif l_p = a_rb.item.len - 1 then
							l_pos := -1 + 52 -- goto nol
						end
				when 43 then
						l_p := l_p + 1
						if (l_d[l_p]).to_integer_32 < 48 then
							l_pos := -1 + 52 -- goto nol
						elseif (l_d[l_p]).to_integer_32 > 57 then
							l_pos := -1 + 52 -- goto nol
						end
				when 44 then
						l_i___0 := l_p
				when 45 then -- loop condition:
						if not (l_i___0 < a_rb.item.len) then
							l_pos := -1 + 48 -- skip loop
						end
				when 46 then -- loop body:
						if (l_d[l_i___0]).to_integer_32 < 48 then
							l_pos := -1 + 49 -- goto quak
						elseif (l_d[l_i___0]).to_integer_32 > 57 then
							l_pos := -1 + 49 -- goto quak
						end
				when 47 then
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 45 -- back to loop condition
				when 48 then -- loop done
						l_pos := -1 + 52 -- goto nol
				when 49 then -- quak:
						from
						until
							not (not (l_break) and then (l_i___0 < a_rb.item.len))
						loop
							l_break := False
							if (l_d[l_i___0]).to_integer_32 /= 32 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						if l_i___0 + 4 > a_rb.item.len then
							l_pos := -1 + 52 -- goto nol
						end
				when 50 then
						l_tmp___6 := (create {P_LINKS_STATIC}).casecmp (l_d + l_i___0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("byte")), (4).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___6.to_boolean then
							l_pos := -1 + 52 -- goto nol
						end
				when 51 then
						l_tmp___7 := strtoll (create {CE_INTEGER_8_POINTER}.make_cast ((l_d + l_p)), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10)
						update_class_fields -- Current might have been changed; synchronize
						l_est := l_tmp___7
						if l_est < {INTEGER_64} 0 then
							l_est := {INTEGER_64} 0
						elseif l_est.to_integer_32 < 0 then
							l_est := {INTEGER_64} 0
						elseif (l_est.to_integer_32).to_integer_64 /= l_est then
							l_est := {INTEGER_64} 0
						end
						if l_est.to_boolean then
							if not from2.to_boolean then
								Current.est_length := l_est.to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 52 then -- nol:
						
				when 53 then -- if done | if done
						if not (l_inf.item.pasv).to_boolean then
							(create {P_SELECT_STATIC}).set_handlers (sock2, (got_something_from_data_connection_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (c_pointer))
							update_class_fields -- Current might have been changed; synchronize
						end
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.ftp_got_final_response (a_rb)
						update_class_fields -- Current might have been changed; synchronize
				when 54 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_got_final_response (a_rb: CE_POINTER [PD_READ_BUFFER])
		require
			not a_rb.is_void
		local
			l_inf: CE_POINTER [PD_FTP_CONNECTION_INFO]
			l_g: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_inf := create {CE_CLASS_POINTER [PD_FTP_CONNECTION_INFO]}.make_cast (info)
					l_tmp := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.get_ftp_response (a_rb, 0)
					update_class_fields -- Current might have been changed; synchronize
					l_g := l_tmp
					if l_g = -1 then
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_300)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return and then (not l_g.to_boolean) then
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.read_from_socket (sock1, a_rb, ftp_got_final_response_address)
						update_class_fields -- Current might have been changed; synchronize
						if state /= 8 then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (6)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_return := True
					end
					if l_return then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						if l_g /= 425 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 4 then -- else:
						if l_g /= 450 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 7 then -- else:
						if l_g /= 500 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 10 then -- else:
						if l_g /= 501 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 13 then -- else:
						if l_g /= 550 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if: | _L:
						l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (url))
						update_class_fields -- Current might have been changed; synchronize
						if (url[(l_tmp___0 - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 47 then
							l_pos := -1 + 17 -- goto skip_redir
						end
				when 15 then
						if cache.is_void then
							l_tmp___1 := (create {P_CACHE_STATIC}).get_cache_entry (url, create {CE_POINTER_POINTER [PD_CACHE_ENTRY]}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("cache")))
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___1.to_boolean then
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_004)
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							end
						end
						if not l_return then
							if (not (cache.item.redirect).is_void) then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 507, create {CE_VOID_POINTER}.make_cast (cache.item.redirect))
								update_class_fields -- Current might have been changed; synchronize
							end
							cache.item.redirect := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 508, url)
							update_class_fields -- Current might have been changed; synchronize
							cache.item.redirect_get := 1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_strn (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (cache.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("redirect")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")))
							update_class_fields -- Current might have been changed; synchronize
							cache.item.incomplete := 0
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_000)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
				when 16 then -- if done | if done | if done | if done | if done
					if l_return then
						l_pos := -1 + 18 -- skip if block
					end
				when 17 then -- if: | skip_redir:
						if l_g >= 400 then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_305)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
				when 18 then -- if done
					if not l_return then
						if l_inf.item.conn_st = 2 then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_000)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.ftp_end_request
							update_class_fields -- Current might have been changed; synchronize
						else
							l_inf.item.conn_st := 1
							update_class_fields -- Current might have been changed; synchronize
							if state /= 8 then
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (6)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	got_something_from_data_connection
		local
			l_inf: CE_POINTER [PD_FTP_CONNECTION_INFO]
			l_l: INTEGER_32
			l_ns: INTEGER_32
			l_tmp: INTEGER_32
			l_ud: CE_POINTER [NATURAL_8]
			l_s0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_s0l: CE_ARRAY [INTEGER_32]
			l_tmp___0: NATURAL_32
			l_tmp___1: NATURAL_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: NATURAL_32
			l_tmp___6: NATURAL_32
			l_tmp___7: NATURAL_32
			l_tmp___8: NATURAL_32
			l_tmp___9: NATURAL_32
			l_tmp___10: NATURAL_32
			l_tmp___11: NATURAL_32
			l_tmp___12: NATURAL_32
			l_tmp___13: NATURAL_32
			l_tmp___14: CE_POINTER [INTEGER_32]
			l_tmp___15: INTEGER_32
			l_m: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_s0l.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_inf := create {CE_CLASS_POINTER [PD_FTP_CONNECTION_INFO]}.make_cast (info);
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.set_timeout
					update_class_fields -- Current might have been changed; synchronize
					if (l_inf.item.d).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_inf.item.d := 1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SELECT_STATIC}).set_handlers (sock2, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_ns := accept (sock2, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_shared (default_pointer), create {CE_NATURAL_32_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if l_ns = -1 then
							l_pos := -1 + 5 -- goto e
						end
				when 2 then
						close (sock2).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Current.sock2 := l_ns
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SELECT_STATIC}).set_handlers (l_ns, (got_something_from_data_connection_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (c_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
				when 3 then -- if done
					if not l_return and then (cache.is_void) then
						l_tmp := (create {P_CACHE_STATIC}).get_cache_entry (url, create {CE_POINTER_POINTER [PD_CACHE_ENTRY]}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("cache")))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp.to_boolean then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_004)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 4 then -- if:
						if (l_inf.item.dir).to_boolean then
							if not from2.to_boolean then
								l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (ftp_head.item))
								update_class_fields -- Current might have been changed; synchronize
								add_fragment (cache, from2, ftp_head.item, l_tmp___0.to_integer_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___1 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (ftp_head.item))
								update_class_fields -- Current might have been changed; synchronize
								Current.from2 := (from2.to_natural_32 + l_tmp___1.to_natural_32).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___2 := (create {P_URL_STATIC}).get_url_data (url)
								update_class_fields -- Current might have been changed; synchronize
								l_ud := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 700, l_tmp___2)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___4 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_ud), 1)
								update_class_fields -- Current might have been changed; synchronize
								if (not l_tmp___4.is_void) then
									l_tmp___3 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_ud), 1)
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___3[0] := (0).to_integer_8
									update_class_fields -- Current might have been changed; synchronize
								end
								l_s0.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 702)
								update_class_fields -- Current might have been changed; synchronize
								l_s0l.item := 0
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___5 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ud))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_URL_STATIC}).add_conv_str (l_s0, l_s0l, l_ud, l_tmp___5.to_integer_32, -1)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 705, create {CE_VOID_POINTER}.make_cast (l_ud))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___6 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s0.item))
								update_class_fields -- Current might have been changed; synchronize
								add_fragment (cache, from2, l_s0.item, l_tmp___6.to_integer_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___7 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s0.item))
								update_class_fields -- Current might have been changed; synchronize
								Current.from2 := (from2.to_natural_32 + l_tmp___7.to_natural_32).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___8 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (ftp_head2.item))
								update_class_fields -- Current might have been changed; synchronize
								add_fragment (cache, from2, ftp_head2.item, l_tmp___8.to_integer_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___9 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (ftp_head2.item))
								update_class_fields -- Current might have been changed; synchronize
								Current.from2 := (from2.to_natural_32 + l_tmp___9.to_natural_32).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___10 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s0.item))
								update_class_fields -- Current might have been changed; synchronize
								add_fragment (cache, from2, l_s0.item, l_tmp___10.to_integer_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___11 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s0.item))
								update_class_fields -- Current might have been changed; synchronize
								Current.from2 := (from2.to_natural_32 + l_tmp___11.to_natural_32).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___12 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (ftp_head3.item))
								update_class_fields -- Current might have been changed; synchronize
								add_fragment (cache, from2, ftp_head3.item, l_tmp___12.to_integer_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___13 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (ftp_head3.item))
								update_class_fields -- Current might have been changed; synchronize
								Current.from2 := (from2.to_natural_32 + l_tmp___13.to_natural_32).to_integer_32
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 710, create {CE_VOID_POINTER}.make_cast (l_s0.item))
								update_class_fields -- Current might have been changed; synchronize
								if (cache.item.head).is_void then
									cache.item.head := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 711, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
									update_class_fields -- Current might have been changed; synchronize
								end
								(create {P_LINKS_STATIC}).add_to_strn (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (cache.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("head")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Content-Type: text/html%R%N")))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_l := read (sock2, create {CE_VOID_POINTER}.make_cast ((l_inf.item.ftp_buffer + l_inf.item.buf_pos)), (16_384 - l_inf.item.buf_pos).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_l /= -1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | e:
						if l_inf.item.conn_st /= 1 then
							if not (l_inf.item.dir).to_boolean then
								if not from2.to_boolean then
									(create {P_SELECT_STATIC}).set_handlers (sock2, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_CONNECT_STATIC}).close_socket (create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock2")))
									update_class_fields -- Current might have been changed; synchronize
									l_inf.item.conn_st := 2
									update_class_fields -- Current might have been changed; synchronize
									l_return := True
								end
							end
						end
						if not l_return then
							l_tmp___14 := errno_location
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-l_tmp___14.item)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
				when 6 then -- if done | if done
					if not l_return and then (l_l > 0) then
						if not (l_inf.item.dir).to_boolean then
							if from2 + l_l.to_integer_32 < 0 then
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_014)
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							end
							if not l_return then
								Current.received := received + l_l.to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___15 := add_fragment (cache, from2, l_inf.item.ftp_buffer, l_l.to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___15 = 1 then
									Current.tries := 0
									update_class_fields -- Current might have been changed; synchronize
								end
								Current.from2 := from2 + l_l.to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							Current.received := received + l_l.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							l_m := ftp_process_dirlist (cache, create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("from2")), create {CE_INTEGER_32_POINTER}.make_shared (l_inf.c_pointer + (create {PD_FTP_CONNECTION_INFO}.make).offset_of ("dpos")), l_inf.item.ftp_buffer, l_l + l_inf.item.buf_pos, 0, create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("tries")))
							update_class_fields -- Current might have been changed; synchronize
							memmove (create {CE_VOID_POINTER}.make_cast ((l_inf.item.ftp_buffer)), create {CE_VOID_POINTER}.make_cast ((l_inf.item.ftp_buffer + l_m)), ((l_inf.item.buf_pos + l_l) - l_m).to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_inf.item.buf_pos := l_inf.item.buf_pos + (l_l - l_m)
							update_class_fields -- Current might have been changed; synchronize
						end
						if not l_return then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (8)
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if not l_return then
						ftp_process_dirlist (cache, create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("from2")), create {CE_INTEGER_32_POINTER}.make_shared (l_inf.c_pointer + (create {PD_FTP_CONNECTION_INFO}.make).offset_of ("dpos")), l_inf.item.ftp_buffer, l_inf.item.buf_pos, 1, create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("tries"))).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SELECT_STATIC}).set_handlers (sock2, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).close_socket (create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock2")))
						update_class_fields -- Current might have been changed; synchronize
						if l_inf.item.conn_st = 1 then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_000)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.ftp_end_request
							update_class_fields -- Current might have been changed; synchronize
						else
							l_inf.item.conn_st := 2
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_end_request
		do
			if state = -1_000 then
				if (not cache.is_void) then
					truncate_entry (cache, from2, 1)
					update_class_fields -- Current might have been changed; synchronize
					cache.item.incomplete := 0
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.add_keepalive_socket ((600_000).to_integer_32)
			update_class_fields -- Current might have been changed; synchronize
		end

	http_end_request (a_notrunc: INTEGER_32)
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			if state = -1_000 then
				if (not cache.is_void) then
					if not a_notrunc.to_boolean then
						truncate_entry (cache, from2, 1)
						update_class_fields -- Current might have been changed; synchronize
					end
					cache.item.incomplete := 0
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if (not info.is_void) then
				if not ((create {CE_CLASS_POINTER [PD_HTTP_CONNECTION_INFO]}.make_cast (info)).item.close).to_boolean then
					if not ((create {P_DEFAULT_STATIC}).http_bugs.item.item.bug_post_no_keepalive).to_boolean then
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.add_keepalive_socket ((60_000).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
					else
						l_tmp := strchr (create {CE_INTEGER_8_POINTER}.make_cast (url), 1)
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp.is_void) then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
						else
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.add_keepalive_socket ((60_000).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				else
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	http_send_header
		local
			l_info: CE_POINTER [PD_HTTP_CONNECTION_INFO]
			l_http10: INTEGER_32
			l_e: CE_POINTER [PD_CACHE_ENTRY]
			l_hdr: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_h: CE_POINTER [NATURAL_8]
			l_u: CE_POINTER [NATURAL_8]
			l_uu: CE_POINTER [NATURAL_8]
			l_sp: CE_POINTER [NATURAL_8]
			l_l: CE_ARRAY [INTEGER_32]
			l_la: INTEGER_32
			l_post: CE_POINTER [NATURAL_8]
			l_host: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: NATURAL_8
			l_tmp___3: CE_POINTER [ANY]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: NATURAL_8
			l_nu: CE_POINTER [NATURAL_8]
			l_tmp___6: NATURAL_32
			l_tmp___7: CE_POINTER [ANY]
			l_t: CE_POINTER [PD_TERMINAL]
			l_i: INTEGER_32
			l_cs: CE_POINTER [NATURAL_8]
			l_ac: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_aclen: CE_ARRAY [INTEGER_32]
			l_tmp___8: NATURAL_32
			l_tmp___9: CE_POINTER [ANY]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: NATURAL_8
			l_code: CE_ARRAY [INTEGER_32]
			l_vers: CE_ARRAY [INTEGER_32]
			l_tmp___14: INTEGER_32
			l_pd: CE_POINTER [NATURAL_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: NATURAL_32
			l_h1: INTEGER_32
			l_h2: INTEGER_32
			l_tmp___17: NATURAL_8
			l_tmp___18: INTEGER_32
			l_tmp___19: NATURAL_8
			l_tmp___20: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_hdr.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_ac.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_aclen.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_code.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_vers.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_http10 := (create {P_DEFAULT_STATIC}).http_bugs.item.item.http10
					l_e := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
					l_l.item := 0
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := (create {P_LINKS_STATIC}).upcase (url[0])
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___2.to_integer_32 /= 80 then
						l_tmp___1 := url
					else
						l_tmp___0 := (create {P_URL_STATIC}).get_url_data (url)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := l_tmp___0
					end
					l_host := l_tmp___1;
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.set_timeout
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___3 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 210, (create {PD_HTTP_CONNECTION_INFO}.make).structure_size.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_info := create {CE_CLASS_POINTER [PD_HTTP_CONNECTION_INFO]}.make_cast (l_tmp___3)
					memset (create {CE_VOID_POINTER}.make_cast (l_info), 0, (create {PD_HTTP_CONNECTION_INFO}.make).structure_size.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					Current.info := create {CE_VOID_POINTER}.make_cast (l_info)
					update_class_fields -- Current might have been changed; synchronize
					l_h := (create {P_URL_STATIC}).get_host_name (l_host)
					update_class_fields -- Current might have been changed; synchronize
					if (not l_h.is_void) then
						l_info.item.bl_flags := get_blacklist_flags (l_h)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 215, create {CE_VOID_POINTER}.make_cast (l_h))
						update_class_fields -- Current might have been changed; synchronize
					end
					if ((l_info.item.bl_flags).bit_and (1)).to_boolean then
						l_http10 := 1
					end
					l_info.item.http10 := l_http10
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___4 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (url), 1)
					update_class_fields -- Current might have been changed; synchronize
					l_post := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___4)
					if (not l_post.is_void) then
						l_post := l_post + 1
					end
					l_hdr.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 221)
					update_class_fields -- Current might have been changed; synchronize
					if l_post.is_void then
						(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("GET ")))
						update_class_fields -- Current might have been changed; synchronize
					else
						(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("POST ")))
						update_class_fields -- Current might have been changed; synchronize
						Current.unrestartable := 2
						update_class_fields -- Current might have been changed; synchronize
					end
					l_tmp___5 := (create {P_LINKS_STATIC}).upcase (url[0])
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___5.to_integer_32 /= 80 then
						(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")))
						update_class_fields -- Current might have been changed; synchronize
					end
					l_u := (create {P_URL_STATIC}).get_url_data (url)
					update_class_fields -- Current might have been changed; synchronize
					if l_u.is_void then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 229, create {CE_VOID_POINTER}.make_cast (l_hdr.item))
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_009)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.http_end_request (0)
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return and then (not l_post.is_void) then
						if (l_post.c_pointer.to_integer_32).to_natural_32 < (l_u.c_pointer.to_integer_32).to_natural_32 then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 235, create {CE_VOID_POINTER}.make_cast (l_hdr.item))
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_009)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.http_end_request (0)
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						if l_post.is_void then
							l_uu := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 240, l_u)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_uu := (create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 241, l_u, (l_post.distance (l_u)) - 1)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 2 then -- a:
						l_sp := l_uu
				when 3 then -- loop condition:
						if not ((l_sp.item).to_boolean) then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						if (l_sp.item).to_integer_32 <= 32 then
							l_tmp___6 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_uu))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___7 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 244, l_tmp___6 + {NATURAL_32} 3)
							update_class_fields -- Current might have been changed; synchronize
							l_nu := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___7)
							memcpy (create {CE_VOID_POINTER}.make_cast (l_nu), create {CE_VOID_POINTER}.make_cast (l_uu), (l_sp.distance (l_uu)).to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((l_nu + (l_sp.distance (l_uu)))), ce_string ("%%%%%%02X"), (l_sp.item).to_integer_32]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_nu), create {CE_INTEGER_8_POINTER}.make_cast ((l_sp + 1))).do_nothing
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 248, create {CE_VOID_POINTER}.make_cast (l_uu))
							update_class_fields -- Current might have been changed; synchronize
							l_uu := l_nu
							l_pos := -1 + 2 -- goto a
						elseif (l_sp.item).to_integer_32 = 92 then
							l_sp.item := (('/').code).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
						end
				when 5 then
						l_sp := l_sp + 1
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done;
						(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, l_uu)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 253, create {CE_VOID_POINTER}.make_cast (l_uu))
						update_class_fields -- Current might have been changed; synchronize
						if not l_http10.to_boolean then
							(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" HTTP/1.1%R%N")))
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" HTTP/1.0%R%N")))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_h := (create {P_URL_STATIC}).get_host_name (l_host)
						update_class_fields -- Current might have been changed; synchronize
						if (not l_h.is_void) then
							(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Host: ")))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, l_h)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 259, create {CE_VOID_POINTER}.make_cast (l_h))
							update_class_fields -- Current might have been changed; synchronize
							l_h := get_port_str (l_host)
							update_class_fields -- Current might have been changed; synchronize
							if (not l_h.is_void) then
								(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":")))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, l_h)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 263, create {CE_VOID_POINTER}.make_cast (l_h))
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("User-Agent: Links (1.00; ")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, (create {P_LINKS_STATIC}).system_name.item)
						update_class_fields -- Current might have been changed; synchronize
						if not (((create {P_TERMINAL_STATIC}).terminals.item.item.next).is_equal ((create {P_TERMINAL_STATIC}).terminals.item)) then
							l_t := create {CE_CLASS_POINTER [PD_TERMINAL]}.make_cast ((create {P_TERMINAL_STATIC}).terminals.item.item.prev);
							(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("; ")))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_num_to_str (l_hdr, l_l, (l_t.item.x).to_integer_32)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("x")))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_num_to_str (l_hdr, l_l, (l_t.item.y).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (")%R%N")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Accept: */*%R%N")))
						update_class_fields -- Current might have been changed; synchronize
						if accept_charset.item.is_void then
							l_aclen.item := 0
							update_class_fields -- Current might have been changed; synchronize
							l_ac.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 282)
							update_class_fields -- Current might have been changed; synchronize
							l_i := 0
							from
							until
								(l_break)
							loop
								l_break := False
								l_cs := (create {P_CHARSETS_STATIC}).get_cp_mime_name (l_i)
								update_class_fields -- Current might have been changed; synchronize
								if l_cs.is_void then
									l_break := True
								end
								if not (l_break) then
									if (l_aclen.item).to_boolean then
										(create {P_LINKS_STATIC}).add_to_str (l_ac, l_aclen, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")))
										update_class_fields -- Current might have been changed; synchronize
									else
										(create {P_LINKS_STATIC}).add_to_str (l_ac, l_aclen, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Accept-Charset: ")))
										update_class_fields -- Current might have been changed; synchronize
									end
									(create {P_LINKS_STATIC}).add_to_str (l_ac, l_aclen, l_cs)
									update_class_fields -- Current might have been changed; synchronize
									l_i := l_i + 1
								end
							end
							l_break := False
							if (l_aclen.item).to_boolean then
								(create {P_LINKS_STATIC}).add_to_str (l_ac, l_aclen, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
								update_class_fields -- Current might have been changed; synchronize
							end
							l_tmp___8 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ac.item))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___9 := malloc (l_tmp___8 + {NATURAL_32} 1)
							update_class_fields -- Current might have been changed; synchronize
							accept_charset.item := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___9)
							if (not accept_charset.item.is_void) then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (accept_charset.item), create {CE_INTEGER_8_POINTER}.make_cast (l_ac.item)).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							else
								accept_charset.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
							end
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 291, create {CE_VOID_POINTER}.make_cast (l_ac.item))
							update_class_fields -- Current might have been changed; synchronize
						end
						if not ((l_info.item.bl_flags).bit_and (4)).to_boolean then
							if not ((create {P_DEFAULT_STATIC}).http_bugs.item.item.no_accept_charset).to_boolean then
								(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, accept_charset.item)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if not ((l_info.item.bl_flags).bit_and (2)).to_boolean then
							(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Accept-Language: ")))
							update_class_fields -- Current might have been changed; synchronize
							l_la := l_l.item
							l_tmp___10 := (create {P_LANGUAGE_STATIC}).get_text_translation ((create {P_LINKS_STATIC}).dummyarray.item + 3, create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, l_tmp___10)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___11 := strstr (create {CE_INTEGER_8_POINTER}.make_cast ((l_hdr.item + l_la)), ce_string ("en,"))
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___11.is_void then
								l_tmp___12 := strstr (create {CE_INTEGER_8_POINTER}.make_cast ((l_hdr.item + l_la)), ce_string ("en;"))
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___12.is_void then
									(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("en;q=0.2, ")))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("*;q=0.1%R%N")))
							update_class_fields -- Current might have been changed; synchronize
						end
						if not l_http10.to_boolean then
							l_tmp___13 := (create {P_LINKS_STATIC}).upcase (url[0])
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___13.to_integer_32 /= 80 then
								(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Connection: ")))
								update_class_fields -- Current might have been changed; synchronize
							else
								(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Proxy-Connection: ")))
								update_class_fields -- Current might have been changed; synchronize
							end
							if l_post.is_void then
								(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Keep-Alive%R%N")))
								update_class_fields -- Current might have been changed; synchronize
							elseif not ((create {P_DEFAULT_STATIC}).http_bugs.item.item.bug_post_no_keepalive).to_boolean then
								(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Keep-Alive%R%N")))
								update_class_fields -- Current might have been changed; synchronize
							else
								(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("close%R%N")))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_e := cache
						if l_e.is_void then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_tmp___14 := get_http_code (l_e.item.head, l_code, l_vers)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___14.to_boolean then
							l_pos := -1 + 15 -- goto skip_ifmod_and_range
						elseif l_code.item >= 400 then
							l_pos := -1 + 15 -- goto skip_ifmod_and_range
						end
				when 8 then
						if not (l_e.item.incomplete).to_boolean then
							if (not (l_e.item.head).is_void) then
								if no_cache <= 2 then
									if (not (l_e.item.last_modified).is_void) then
										(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("If-Modified-Since: ")))
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, l_e.item.last_modified)
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
						end
				when 9 then -- if done
						if not (from2.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						if est_length /= -1 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if not (from2 < est_length) then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if no_cache < 2 then
							if not ((l_info.item.bl_flags).bit_and (8)).to_boolean then
								(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Range: bytes=")))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_num_to_str (l_hdr, l_l, from2)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-%R%N")))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 15 then -- if done | if done | skip_ifmod_and_range:
						if no_cache >= 4 then
							(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Pragma: no-cache%R%NCache-Control: no-cache%R%N")))
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not l_post.is_void) then
							l_tmp___15 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_post), ('%N').code)
							update_class_fields -- Current might have been changed; synchronize
							l_pd := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___15)
							if (not l_pd.is_void) then
								(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Content-Type: ")))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_bytes_to_str (l_hdr, l_l, l_post, l_pd.distance (l_post))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
								update_class_fields -- Current might have been changed; synchronize
								l_post := l_pd + 1
							end
							(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Content-Length: ")))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___16 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_post))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_num_to_str (l_hdr, l_l, (l_tmp___16 // {NATURAL_32} 2).to_integer_32)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
							update_class_fields -- Current might have been changed; synchronize
						end
						send_cookies (l_hdr, l_l, l_host)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_hdr, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_post.is_void) then
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_post[0]).to_boolean then
									if not (l_post[1]).to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									if (l_post[0]).to_integer_32 <= 57 then
										l_h1 := (l_post[0]).to_integer_32 - 48
									else
										if (l_post[0]).to_integer_32 >= 65 then
											l_tmp___17 := (create {P_LINKS_STATIC}).upcase (l_post[0])
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___18 := (l_tmp___17.to_integer_32 - 65) + 10
										else
											l_tmp___18 := 0
										end
										l_h1 := l_tmp___18
									end
									if l_h1 < 0 then
										l_h1 := 0
									elseif l_h1 >= 16 then
										l_h1 := 0
									end
									if (l_post[1]).to_integer_32 <= 57 then
										l_h2 := (l_post[1]).to_integer_32 - 48
									else
										if (l_post[1]).to_integer_32 >= 65 then
											l_tmp___19 := (create {P_LINKS_STATIC}).upcase (l_post[1])
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___20 := (l_tmp___19.to_integer_32 - 65) + 10
										else
											l_tmp___20 := 0
										end
										l_h2 := l_tmp___20
									end
									if l_h2 < 0 then
										l_h2 := 0
									elseif l_h2 >= 16 then
										l_h2 := 0
									end
									(create {P_LINKS_STATIC}).add_chr_to_str (l_hdr, l_l, (l_h1 * 16 + l_h2).to_natural_8)
									update_class_fields -- Current might have been changed; synchronize
									l_post := l_post + (2)
								end
							end
							l_break := False
						end
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.write_to_socket (sock1, l_hdr.item, l_l.item, http_get_header_address)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 351, create {CE_VOID_POINTER}.make_cast (l_hdr.item))
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (4)
						update_class_fields -- Current might have been changed; synchronize
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	read_http_data (a_rb: CE_POINTER [PD_READ_BUFFER])
		require
			not a_rb.is_void
		local
			l_info: CE_POINTER [PD_HTTP_CONNECTION_INFO]
			l_l: INTEGER_32
			l_tmp: INTEGER_32
			l_l___0: INTEGER_32
			l_l___1: INTEGER_32
			l_de: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_n: INTEGER_32
			l_tmp___0: INTEGER_32
			l_l___2: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_de.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_info := create {CE_CLASS_POINTER [PD_HTTP_CONNECTION_INFO]}.make_cast (info);
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.set_timeout
					update_class_fields -- Current might have been changed; synchronize
					if a_rb.item.close = 2 then
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_000)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.http_end_request (0)
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						if l_info.item.length = -2 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_l := a_rb.item.len
						if l_info.item.length >= 0 then
							if l_info.item.length < l_l then
								l_l := l_info.item.length
							end
						end
						if from2 + l_l.to_integer_32 < 0 then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_014)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
						if not l_return then
							Current.received := received + l_l.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							l_tmp := add_fragment (cache, from2, a_rb.item.data, l_l.to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp = 1 then
								Current.tries := 0
								update_class_fields -- Current might have been changed; synchronize
							end
							if l_info.item.length >= 0 then
								l_info.item.length := l_info.item.length - l_l
								update_class_fields -- Current might have been changed; synchronize
							end
							Current.from2 := from2 + l_l.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							kill_buffer_data (a_rb, l_l)
							update_class_fields -- Current might have been changed; synchronize
							if not (l_info.item.length).to_boolean then
								if not (a_rb.item.close).to_boolean then
									((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_000)
									update_class_fields; -- Current might have been changed; synchronize
									((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.http_end_request (0)
									update_class_fields -- Current might have been changed; synchronize
									l_return := True
								end
							end
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 4 then -- else: | next_chunk:
						if l_info.item.chunk_remaining /= -2 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_l___0 := is_line_in_buffer (a_rb)
						update_class_fields -- Current might have been changed; synchronize
						if l_l___0.to_boolean then
							if l_l___0 = -1 then
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_100)
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							end
							if not l_return then
								kill_buffer_data (a_rb, l_l___0)
								update_class_fields -- Current might have been changed; synchronize
								if l_l___0 <= 2 then
									((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_000)
									update_class_fields; -- Current might have been changed; synchronize
									((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.http_end_request (0)
									update_class_fields -- Current might have been changed; synchronize
									l_return := True
								end
							end
							if not l_return then
								l_pos := -1 + 4 -- goto next_chunk
							end
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 7 then -- else:
						if l_info.item.chunk_remaining /= -1 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_l___1 := is_line_in_buffer (a_rb)
						update_class_fields -- Current might have been changed; synchronize
						if l_l___1.to_boolean then
							l_n := 0
							if l_l___1 /= -1 then
								l_n := strtol (create {CE_INTEGER_8_POINTER}.make_cast ((a_rb.item.data)), create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (l_de), 16)
								update_class_fields -- Current might have been changed; synchronize
							end
							if l_l___1 = -1 then
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_100)
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							elseif l_n < 0 then
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_100)
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							elseif l_n >= 2_147_483_647 then
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_100)
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							elseif (l_de.item).is_equal (a_rb.item.data) then
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_100)
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							end
							if not l_return then
								kill_buffer_data (a_rb, l_l___1)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___0 := l_n.to_integer_32
								l_info.item.chunk_remaining := l_tmp___0
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___0.to_boolean then
									l_info.item.chunk_remaining := -2
									update_class_fields -- Current might have been changed; synchronize
								end
								l_pos := -1 + 4 -- goto next_chunk
							end
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 10 then -- else:
						l_l___2 := l_info.item.chunk_remaining
						if l_l___2 > a_rb.item.len then
							l_l___2 := a_rb.item.len
						end
						if from2 + l_l___2.to_integer_32 < 0 then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_014)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
						if l_return then
							l_pos := -1 + 20 -- skip if block
						end
				when 11 then -- if:
						Current.received := received + l_l___2.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := add_fragment (cache, from2, a_rb.item.data, l_l___2.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1 = 1 then
							Current.tries := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						l_info.item.chunk_remaining := l_info.item.chunk_remaining - l_l___2
						update_class_fields -- Current might have been changed; synchronize
						Current.from2 := from2 + l_l___2.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						kill_buffer_data (a_rb, l_l___2)
						update_class_fields -- Current might have been changed; synchronize
						if (l_info.item.chunk_remaining).to_boolean then
							l_pos := -1 + 20 -- skip if block
						end
				when 12 then -- if:
						if not (a_rb.item.len >= 1) then
							l_pos := -1 + 20 -- skip if block
						end
				when 13 then -- if:
						if (a_rb.item.data[0]).to_integer_32 /= 10 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						kill_buffer_data (a_rb, 1)
						update_class_fields -- Current might have been changed; synchronize
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 16 then -- else:
						if (a_rb.item.data[0]).to_integer_32 /= 13 then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_100)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						elseif a_rb.item.len >= 2 then
							if (a_rb.item.data[1]).to_integer_32 /= 10 then
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_100)
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							end
						end
						if l_return then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if a_rb.item.len < 2 then
							l_pos := -1 + 21 -- goto read_more
						end
				when 18 then
						kill_buffer_data (a_rb, 2)
						update_class_fields -- Current might have been changed; synchronize
				when 19 then -- if done | if done
						if not l_return then
							l_info.item.chunk_remaining := -1
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 4 -- goto next_chunk
						end
				when 20 then -- if done | if done | if done | if done | if done | if done
					if l_return then
						l_pos := -1 + 22 -- skip if block
					end
				when 21 then -- if: | read_more:;
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.read_from_socket (sock1, a_rb, read_http_data_address)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (8)
						update_class_fields -- Current might have been changed; synchronize
				when 22 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	http_got_header (a_rb: CE_POINTER [PD_READ_BUFFER])
		require
			not a_rb.is_void
		local
			l_cf: INTEGER_32
			l_state: INTEGER_32
			l_tmp: INTEGER_32
			l_head___0: CE_POINTER [NATURAL_8]
			l_cookie: CE_POINTER [NATURAL_8]
			l_ch: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a: INTEGER_32
			l_h: CE_ARRAY [INTEGER_32]
			l_version: CE_ARRAY [INTEGER_32]
			l_d: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [PD_CACHE_ENTRY]
			l_info: CE_POINTER [PD_HTTP_CONNECTION_INFO]
			l_host: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: NATURAL_8
			l_h___0: CE_POINTER [NATURAL_8]
			l_tmp___4: INTEGER_32
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_host___0: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: NATURAL_8
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_f: INTEGER_64
			l_tmp___14: INTEGER_64
			l_tmp___15: INTEGER_32
			l_tmp___16: NATURAL_32
			l_ep: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: INTEGER_64
			l_tmp___17: INTEGER_64
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_ch.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_h.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_version.make (<<1>>)
			create {CE_CLASS_POINTER [PD_CACHE_ENTRY]} l_e.make
			create {CE_POINTER_ARRAY [NATURAL_8]} l_ep.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if state /= 7 then
						l_tmp := 6
					else
						l_tmp := 7
					end
					l_state := l_tmp
					l_tmp___3 := (create {P_LINKS_STATIC}).upcase (url[0])
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___3.to_integer_32 /= 80 then
						l_tmp___2 := url
					else
						l_tmp___1 := (create {P_URL_STATIC}).get_url_data (url)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := l_tmp___1
					end
					l_host := l_tmp___2;
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.set_timeout
					update_class_fields -- Current might have been changed; synchronize
					l_info := create {CE_CLASS_POINTER [PD_HTTP_CONNECTION_INFO]}.make_cast (info)
					if a_rb.item.close = 2 then
						if not tries.to_boolean then
							l_h___0 := (create {P_URL_STATIC}).get_host_name (l_host)
							update_class_fields -- Current might have been changed; synchronize
							if (not l_h___0.is_void) then
								if ((l_info.item.bl_flags).bit_and (4)).to_boolean then
									del_blacklist_entry (l_h___0, 4)
									update_class_fields -- Current might have been changed; synchronize
								else
									add_blacklist_entry (l_h___0, 4)
									update_class_fields -- Current might have been changed; synchronize
									Current.tries := -1
									update_class_fields -- Current might have been changed; synchronize
								end
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 502, create {CE_VOID_POINTER}.make_cast (l_h___0))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_007)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if l_return then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						a_rb.item.close := 0
						update_class_fields -- Current might have been changed; synchronize
				when 2 then -- again:
						l_a := get_header (a_rb)
						update_class_fields -- Current might have been changed; synchronize
						if l_a = -1 then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_100)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
				when 3 then -- if done
					if not l_return and then (not l_a.to_boolean) then
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.read_from_socket (sock1, a_rb, http_got_header_address)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (l_state)
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return then
						l_tmp___4 := get_http_code (a_rb.item.data, l_h, l_version)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___4.to_boolean then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_100)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						elseif l_h.item = 101 then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_100)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if not l_return then
						l_tmp___5 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 525, (l_a + 1).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_head___0 := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___5)
						memcpy (create {CE_VOID_POINTER}.make_cast (l_head___0), create {CE_VOID_POINTER}.make_cast ((a_rb.item.data)), l_a.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_head___0[l_a] := (0).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___6 := check_http_server_bugs (l_host, create {CE_CLASS_POINTER [PD_HTTP_CONNECTION_INFO]}.make_cast (info), l_head___0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___6.to_boolean then
							l_tmp___7 := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.is_connection_restartable
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___7.to_boolean then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 528, create {CE_VOID_POINTER}.make_cast (l_head___0))
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_011)
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 4 then -- if:
						l_ch.item := l_head___0
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_break)
						loop
							l_break := False
							l_cookie := (create {P_HTTP_STATIC}).parse_http_header (l_ch.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Set-Cookie")), l_ch)
							update_class_fields -- Current might have been changed; synchronize
							if l_cookie.is_void then
								l_break := True
							end
							if not (l_break) then
								l_tmp___11 := (create {P_LINKS_STATIC}).upcase (url[0])
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___11.to_integer_32 /= 80 then
									l_tmp___10 := url
								else
									l_tmp___9 := (create {P_URL_STATIC}).get_url_data (url)
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___10 := l_tmp___9
								end
								l_host___0 := l_tmp___10
								set_cookie (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_host___0, l_cookie).do_nothing
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 537, create {CE_VOID_POINTER}.make_cast (l_cookie))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						if l_h.item = 100 then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 540, create {CE_VOID_POINTER}.make_cast (l_head___0))
							update_class_fields -- Current might have been changed; synchronize
							l_state := 7
							kill_buffer_data (a_rb, l_a)
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 2 -- goto again
						end
				when 5 then
						if l_h.item < 200 then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 546, create {CE_VOID_POINTER}.make_cast (l_head___0))
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_100)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
				when 6 then -- if done
					if not l_return and then (l_h.item = 304) then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 552, create {CE_VOID_POINTER}.make_cast (l_head___0))
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_000)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.http_end_request (1)
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return and then (l_h.item = 204) then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 558, create {CE_VOID_POINTER}.make_cast (l_head___0))
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_102)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.http_end_request (0)
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return and then (cache.is_void) then
						l_tmp___12 := (create {P_CACHE_STATIC}).get_cache_entry (url, create {CE_POINTER_POINTER [PD_CACHE_ENTRY]}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("cache")))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___12.to_boolean then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 564, create {CE_VOID_POINTER}.make_cast (l_head___0))
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_004)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 26 -- skip if block
					end
				when 7 then -- if:
						l_e := cache
						if (not (l_e.item.head).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 570, create {CE_VOID_POINTER}.make_cast (l_e.item.head))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_e.item.head := l_head___0
						update_class_fields -- Current might have been changed; synchronize
						if (not (l_e.item.redirect).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 584, create {CE_VOID_POINTER}.make_cast (l_e.item.redirect))
							update_class_fields -- Current might have been changed; synchronize
							l_e.item.redirect := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_h.item /= 301 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 10 then -- else:
						if l_h.item /= 302 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 13 then -- else:
						if l_h.item /= 303 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if l_h.item /= 307 then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L:
						l_d := (create {P_HTTP_STATIC}).parse_http_header (l_e.item.head, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Location")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_d.is_void) then
							if (not (l_e.item.redirect).is_void) then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 587, create {CE_VOID_POINTER}.make_cast (l_e.item.redirect))
								update_class_fields -- Current might have been changed; synchronize
							end
							l_e.item.redirect := l_d
							update_class_fields -- Current might have been changed; synchronize
							l_e.item.redirect_get := (l_h.item = 303).to_integer
							update_class_fields -- Current might have been changed; synchronize
						end
				when 18 then -- if done | if done | if done
						kill_buffer_data (a_rb, l_a)
						update_class_fields -- Current might have been changed; synchronize
						l_info.item.close := 0
						update_class_fields -- Current might have been changed; synchronize
						l_info.item.length := -1
						update_class_fields -- Current might have been changed; synchronize
						l_info.item.version := l_version.item
						update_class_fields -- Current might have been changed; synchronize
						l_d := (create {P_HTTP_STATIC}).parse_http_header (l_e.item.head, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Connection")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if l_d.is_void then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L___0
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else:
						l_d := (create {P_HTTP_STATIC}).parse_http_header (l_e.item.head, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Proxy-Connection")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if l_d.is_void then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if: | _L___0:
						l_tmp___13 := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_d), ce_string ("close"))
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___13.to_boolean then
							l_info.item.close := 1
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 598, create {CE_VOID_POINTER}.make_cast (l_d))
						update_class_fields -- Current might have been changed; synchronize
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						if l_version.item < 11 then
							l_info.item.close := 1
							update_class_fields -- Current might have been changed; synchronize
						end
				when 25 then -- if done
						l_cf := from2.to_integer_32
						Current.from2 := (0).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_d := (create {P_HTTP_STATIC}).parse_http_header (l_e.item.head, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Content-Range")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_d.is_void) then
							l_tmp___16 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_d))
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___16 > {NATURAL_32} 6 then
								l_d[5] := (0).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___15 := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_d), ce_string ("bytes"))
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___15.to_boolean then
									if (l_d[6]).to_integer_32 >= 48 then
										if (l_d[6]).to_integer_32 <= 57 then
											l_tmp___14 := strtoll (create {CE_INTEGER_8_POINTER}.make_cast ((l_d + 6)), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10)
											update_class_fields -- Current might have been changed; synchronize
											l_f := l_tmp___14
											if l_f >= {INTEGER_64} 0 then
												if l_f.to_integer_32 >= 0 then
													if (l_f.to_integer_32).to_integer_64 = l_f then
														Current.from2 := l_f.to_integer_32
														update_class_fields -- Current might have been changed; synchronize
													end
												end
											end
										end
									end
								end
							end
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 617, create {CE_VOID_POINTER}.make_cast (l_d))
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_cf.to_boolean then
							if not from2.to_boolean then
								if not unrestartable.to_boolean then
									Current.unrestartable := 1
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if from2 > l_cf.to_integer_32 then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_100)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						elseif from2 < 0 then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_100)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
				when 26 then -- if done
					if not l_return then
						l_d := (create {P_HTTP_STATIC}).parse_http_header (l_e.item.head, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Content-Length")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_d.is_void) then
							l_tmp___17 := strtoll (create {CE_INTEGER_8_POINTER}.make_cast (l_d), create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (l_ep), 10)
							update_class_fields -- Current might have been changed; synchronize
							l_l := l_tmp___17
							if not (l_ep.item.item).to_boolean then
								if l_l >= {INTEGER_64} 0 then
									if l_l.to_integer_32 >= 0 then
										if (l_l.to_integer_32).to_integer_64 = l_l then
											if not (l_info.item.close).to_boolean then
												l_info.item.length := l_l.to_integer_32
												update_class_fields -- Current might have been changed; synchronize
											elseif l_version.item >= 11 then
												l_info.item.length := l_l.to_integer_32
												update_class_fields -- Current might have been changed; synchronize
											end
											if from2.to_natural_32 + l_l.to_natural_32 < {NATURAL_32} 2_147_483_647 then
												Current.est_length := (from2.to_integer_64 + l_l).to_integer_32
												update_class_fields -- Current might have been changed; synchronize
											end
										end
									end
								end
							end
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 639, create {CE_VOID_POINTER}.make_cast (l_d))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_d := (create {P_HTTP_STATIC}).parse_http_header (l_e.item.head, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Accept-Ranges")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_d.is_void) then
							l_tmp___18 := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_d), ce_string ("none"))
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___18.to_boolean then
								if not unrestartable.to_boolean then
									Current.unrestartable := 1
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 643, create {CE_VOID_POINTER}.make_cast (l_d))
							update_class_fields -- Current might have been changed; synchronize
						elseif not unrestartable.to_boolean then
							if not from2.to_boolean then
								Current.unrestartable := 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if ((l_info.item.bl_flags).bit_and (8)).to_boolean then
							if not unrestartable.to_boolean then
								Current.unrestartable := 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_d := (create {P_HTTP_STATIC}).parse_http_header (l_e.item.head, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Transfer-Encoding")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_d.is_void) then
							l_tmp___19 := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_d), ce_string ("chunked"))
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___19.to_boolean then
								l_info.item.length := -2
								update_class_fields -- Current might have been changed; synchronize
								l_info.item.chunk_remaining := -1
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 653, create {CE_VOID_POINTER}.make_cast (l_d))
							update_class_fields -- Current might have been changed; synchronize
						end
						if not (l_info.item.close).to_boolean then
							if l_info.item.length = -1 then
								l_info.item.close := 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_d := (create {P_HTTP_STATIC}).parse_http_header (l_e.item.head, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Last-Modified")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_d.is_void) then
							if (not (l_e.item.last_modified).is_void) then
								l_tmp___20 := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_e.item.last_modified), create {CE_INTEGER_8_POINTER}.make_cast (l_d))
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___20.to_boolean then
									l_e.item.delete_entry_content
									update_class_fields -- Current might have been changed; synchronize
									if from2.to_boolean then
										Current.from2 := (0).to_integer_32
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 661, create {CE_VOID_POINTER}.make_cast (l_d))
										update_class_fields; -- Current might have been changed; synchronize
										((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_008)
										update_class_fields; -- Current might have been changed; synchronize
										((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
										update_class_fields -- Current might have been changed; synchronize
										l_return := True
									end
								end
							end
							if not l_return then
								if (l_e.item.last_modified).is_void then
									l_e.item.last_modified := l_d
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 668, create {CE_VOID_POINTER}.make_cast (l_d))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
					end
					if not l_return then
						if (l_e.item.last_modified).is_void then
							l_d := (create {P_HTTP_STATIC}).parse_http_header (l_e.item.head, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Date")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
							if (not l_d.is_void) then
								l_e.item.last_modified := l_d
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if l_info.item.length = -1 then
							a_rb.item.close := 1
							update_class_fields -- Current might have been changed; synchronize
						elseif l_version.item < 11 then
							if (l_info.item.close).to_boolean then
								a_rb.item.close := 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.read_http_data (a_rb)
						update_class_fields -- Current might have been changed; synchronize
					end
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	is_host_on_list: CE_POINTER [PD_H_CONN]
		local
			l_ho: CE_POINTER [NATURAL_8]
			l_h: CE_POINTER [PD_H_CONN]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_ho := (create {P_URL_STATIC}).get_host_name (url)
			update_class_fields -- Current might have been changed; synchronize
			if l_ho.is_void then
				Result := (create {CE_CLASS_POINTER [PD_H_CONN]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_h := create {CE_CLASS_POINTER [PD_H_CONN]}.make_cast (h_conns.item.item.next)
				from
				until
					not (not (l_return) and then (not l_h.is_equal (h_conns.item)))
				loop
					l_tmp := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_h.item.host), create {CE_INTEGER_8_POINTER}.make_cast (l_ho))
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp.to_boolean then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 59, create {CE_VOID_POINTER}.make_cast (l_ho))
						update_class_fields -- Current might have been changed; synchronize
						Result := l_h
						l_return := True
					end
					if not l_return then
						l_h := l_h.item.next
					end
				end
			end
			if not l_return then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 62, create {CE_VOID_POINTER}.make_cast (l_ho))
				update_class_fields -- Current might have been changed; synchronize
				Result := (create {CE_CLASS_POINTER [PD_H_CONN]}.make_shared (default_pointer))
			end
		end

	stat_timer
		local
			l_a: INTEGER_32
			l_r: CE_POINTER [PD_REMAINING_INFO]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
		do
			l_r := create {CE_CLASS_POINTER [PD_REMAINING_INFO]}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("prg"))
			l_tmp := (create {P_LINKS_STATIC}).getpri ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer)))
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp = 5 then
				if est_length > (create {P_DEFAULT_STATIC}).memory_cache_size.item.item // 4 then
					(create {P_SELECT_STATIC}).register_bottom_half ((create {P_SCHED_STATIC}).check_queue_address, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				elseif from2 > (create {P_DEFAULT_STATIC}).memory_cache_size.item.item // 4 then
					(create {P_SELECT_STATIC}).register_bottom_half ((create {P_SCHED_STATIC}).check_queue_address, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_r.item.loaded := received
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := est_length
			l_r.item.size := l_tmp___0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___1 := from2
			l_r.item.pos := l_tmp___1
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___0 < l_tmp___1 then
				if l_r.item.size /= -1 then
					l_r.item.size := from2
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_tmp___2 := (create {P_SELECT_STATIC}).get_time
			update_class_fields -- Current might have been changed; synchronize
			l_a := l_tmp___2 - l_r.item.last_time
			l_r.item.dis_b := l_r.item.dis_b + l_a
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				not (l_r.item.dis_b >= 5_000)
			loop
				l_r.item.cur_loaded := l_r.item.cur_loaded - (l_r.item.data_in_secs[0]).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				memmove (create {CE_VOID_POINTER}.make_cast ((l_r.item.data_in_secs)), create {CE_VOID_POINTER}.make_cast ((l_r.item.data_in_secs + 1)), {PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 49).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_r.item.data_in_secs[49] := 0
				update_class_fields -- Current might have been changed; synchronize
				l_r.item.dis_b := l_r.item.dis_b - (100)
				update_class_fields -- Current might have been changed; synchronize
			end
			l_r.item.data_in_secs[49] := ((l_r.item.data_in_secs[49]).to_integer_32 + (l_r.item.loaded - l_r.item.last_loaded)).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.cur_loaded := l_r.item.cur_loaded + (l_r.item.loaded - l_r.item.last_loaded)
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.last_loaded := l_r.item.loaded
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.last_time := l_r.item.last_time + l_a
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.elapsed := l_r.item.elapsed + l_a
			update_class_fields -- Current might have been changed; synchronize
			l_r.item.timer := (create {P_SELECT_STATIC}).install_timer ((100).to_integer_32, (stat_timer_address), create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
			if not st_r.item.to_boolean then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.send_connection_info
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	setcstate (a_state: INTEGER_32)
		local
			l_stat___0: CE_POINTER [PD_STATUS]
			l_r: CE_POINTER [PD_REMAINING_INFO]
			l_count: NATURAL_32
			l_tmp: INTEGER_32
			l_r___0: CE_POINTER [PD_REMAINING_INFO]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			if state < 0 then
				if a_state >= 0 then
					Current.prev_error := state
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_tmp___0 := a_state
			Current.state := l_tmp___0
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___0 = 8 then
				l_r := create {CE_CLASS_POINTER [PD_REMAINING_INFO]}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("prg"))
				if l_r.item.timer = -1 then
					l_count := count
					if not (l_r.item.valid).to_boolean then
						memset (create {CE_VOID_POINTER}.make_cast (l_r), 0, (create {PD_REMAINING_INFO}.make).structure_size.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_r.item.valid := 1
						update_class_fields -- Current might have been changed; synchronize
					end
					l_r.item.last_time := (create {P_SELECT_STATIC}).get_time
					update_class_fields -- Current might have been changed; synchronize
					l_r.item.last_loaded := l_r.item.loaded
					update_class_fields -- Current might have been changed; synchronize
					st_r.item := 1;
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.stat_timer
					update_class_fields -- Current might have been changed; synchronize
					st_r.item := 0
					l_tmp := connection_disappeared ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer)), l_count)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						l_return := True
					end
				end
			else
				l_r___0 := create {CE_CLASS_POINTER [PD_REMAINING_INFO]}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("prg"))
				if l_r___0.item.timer /= -1 then
					(create {P_SELECT_STATIC}).kill_timer (l_r___0.item.timer)
					update_class_fields -- Current might have been changed; synchronize
					l_r___0.item.timer := -1
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				l_stat___0 := create {CE_CLASS_POINTER [PD_STATUS]}.make_cast (statuss.next)
				from
				until
					l_stat___0.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))
				loop
					l_stat___0.item.state := a_state
					update_class_fields -- Current might have been changed; synchronize
					l_stat___0.item.prev_error := prev_error
					update_class_fields -- Current might have been changed; synchronize
					l_stat___0 := l_stat___0.item.next
				end
				if a_state >= 0 then
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.send_connection_info
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	is_host_on_keepalive_list: CE_POINTER [PD_K_CONN]
		local
			l_ho: CE_POINTER [NATURAL_8]
			l_po: INTEGER_32
			l_ph: CE_ROUTINE
			l_h: CE_POINTER [PD_K_CONN]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_po := get_port (url)
			update_class_fields -- Current might have been changed; synchronize
			if l_po = -1 then
				Result := (create {CE_CLASS_POINTER [PD_K_CONN]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_ph := get_protocol_handle (url)
				update_class_fields -- Current might have been changed; synchronize
				if l_ph.is_void then
					Result := (create {CE_CLASS_POINTER [PD_K_CONN]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_ho := get_host_and_pass (url)
				update_class_fields -- Current might have been changed; synchronize
				if l_ho.is_void then
					Result := (create {CE_CLASS_POINTER [PD_K_CONN]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_h := create {CE_CLASS_POINTER [PD_K_CONN]}.make_cast ((create {P_SCHED_STATIC}).keepalive_connections.item.item.next)
				from
				until
					not (not (l_return) and then (not l_h.is_equal ((create {P_SCHED_STATIC}).keepalive_connections.item)))
				loop
					if (l_h.item.protocol).is_equal (l_ph) then
						if l_h.item.port = l_po then
							l_tmp := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_h.item.host), create {CE_INTEGER_8_POINTER}.make_cast (l_ho))
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp.to_boolean then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 133, create {CE_VOID_POINTER}.make_cast (l_ho))
								update_class_fields -- Current might have been changed; synchronize
								Result := l_h
								l_return := True
							end
						end
					end
					if not l_return then
						l_h := l_h.item.next
					end
				end
			end
			if not l_return then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 136, create {CE_VOID_POINTER}.make_cast (l_ho))
				update_class_fields -- Current might have been changed; synchronize
				Result := (create {CE_CLASS_POINTER [PD_K_CONN]}.make_shared (default_pointer))
			end
		end

	get_keepalive_socket: INTEGER_32
		local
			l_k: CE_POINTER [PD_K_CONN]
			l_cc: INTEGER_32
			l_return: BOOLEAN
		do
			l_k := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.is_host_on_keepalive_list
			update_class_fields -- Current might have been changed; synchronize
			if l_k.is_void then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_cc := l_k.item.conn;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_k))
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_k.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_k.item.prev)
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_k.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_k.item.next)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_k))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 147, create {CE_VOID_POINTER}.make_cast (l_k.item.host))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 148, create {CE_VOID_POINTER}.make_cast (l_k))
				update_class_fields -- Current might have been changed; synchronize
				Current.sock1 := l_cc
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

	free_connection_data
		local
			l_h: CE_POINTER [PD_H_CONN]
		do
			if sock1 /= -1 then
				(create {P_SELECT_STATIC}).set_handlers (sock1, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
			end
			if sock2 /= -1 then
				(create {P_SELECT_STATIC}).set_handlers (sock2, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_CONNECT_STATIC}).close_socket (create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock2")))
			update_class_fields -- Current might have been changed; synchronize
			if pid.to_boolean then
				kill (pid, 2).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				kill (pid, 15).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				kill (pid, 9).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Current.pid := 0
				update_class_fields -- Current might have been changed; synchronize
			end
			if not running.to_boolean then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).errline.item := 176
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("connection already suspended"))])
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			Current.running := 0
			update_class_fields -- Current might have been changed; synchronize
			if (not dnsquery.is_void) then
				kill_dns_request (create {CE_POINTER_POINTER [ANY]}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("dnsquery")))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not buffer.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 181, buffer)
				update_class_fields -- Current might have been changed; synchronize
				Current.buffer := create {CE_VOID_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not info.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 185, info)
				update_class_fields -- Current might have been changed; synchronize
				Current.info := create {CE_VOID_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			if timer /= -1 then
				(create {P_SELECT_STATIC}).kill_timer (timer)
				update_class_fields -- Current might have been changed; synchronize
				Current.timer := -1
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_SCHED_STATIC}).active_connections.item := (create {P_SCHED_STATIC}).active_connections.item - 1
			update_class_fields -- Current might have been changed; synchronize
			if (create {P_SCHED_STATIC}).active_connections.item < 0 then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).errline.item := 190
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("active connections underflow"))])
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_SCHED_STATIC}).active_connections.item := 0
				update_class_fields -- Current might have been changed; synchronize
			end
			if state /= 0 then
				l_h := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.is_host_on_list
				update_class_fields -- Current might have been changed; synchronize
				if (not l_h.is_void) then
					l_h.item.conn := (l_h.item.conn) - 1
					update_class_fields -- Current might have been changed; synchronize
					if not (l_h.item.conn).to_boolean then
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_h))
						update_class_fields; -- Current might have been changed; synchronize
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_h.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_h.item.prev)
						update_class_fields; -- Current might have been changed; synchronize
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_h.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_h.item.next)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_h))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 197, create {CE_VOID_POINTER}.make_cast (l_h.item.host))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 198, create {CE_VOID_POINTER}.make_cast (l_h))
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					from
					until
						False
					loop
						(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).errline.item := 200
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("suspending connection that is not on the list (state %%d)")), state])
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
		end

	send_connection_info
		local
			l_st: INTEGER_32
			l_count: NATURAL_32
			l_stat___0: CE_POINTER [PD_STATUS]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_st := state
			l_count := count
			l_stat___0 := create {CE_CLASS_POINTER [PD_STATUS]}.make_cast (statuss.next)
			from
			until
				not (not (l_return) and then (not l_stat___0.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
			loop
				l_stat___0.item.ce := cache
				update_class_fields -- Current might have been changed; synchronize
				l_stat___0 := l_stat___0.item.next
				if (not ((l_stat___0.item.prev).item.end2).is_void) then
					((l_stat___0.item.prev).item.end2).call ([l_stat___0.item.prev, (l_stat___0.item.prev).item.data])
					update_class_fields -- Current might have been changed; synchronize
				end
				if l_st >= 0 then
					l_tmp := connection_disappeared ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer)), l_count)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						l_return := True
					end
				end
			end
			if not l_return then
			end
		end

	del_connection
		do
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (next)).item.prev := create {CE_VOID_POINTER}.make_cast (prev)
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (prev)).item.next := create {CE_VOID_POINTER}.make_cast (next)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.send_connection_info
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 221, create {CE_VOID_POINTER}.make_cast (url))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 222, create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	add_keepalive_socket (a_timeout: INTEGER_32)
		local
			l_k: CE_POINTER [PD_K_CONN]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_ROUTINE
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:;
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.free_connection_data
					update_class_fields -- Current might have been changed; synchronize
					if sock1 = -1 then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).errline.item := 234
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("keepalive connection not connected"))])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 3 -- goto del
					end
				when 1 then
					l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 237, (create {PD_K_CONN}.make).structure_size.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_k := create {CE_CLASS_POINTER [PD_K_CONN]}.make_cast (l_tmp)
					l_tmp___0 := get_port (url)
					update_class_fields -- Current might have been changed; synchronize
					l_k.item.port := l_tmp___0
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___0 = -1 then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 239, create {CE_VOID_POINTER}.make_cast (l_k))
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.del_connection
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 4 -- goto close
					else
						l_tmp___1 := get_protocol_handle (url)
						update_class_fields -- Current might have been changed; synchronize
						l_k.item.protocol := l_tmp___1
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp___1.is_void) then
							l_tmp___2 := get_host_and_pass (url)
							update_class_fields -- Current might have been changed; synchronize
							l_k.item.host := l_tmp___2
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___2.is_void then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 239, create {CE_VOID_POINTER}.make_cast (l_k))
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.del_connection
								update_class_fields -- Current might have been changed; synchronize
								l_pos := -1 + 4 -- goto close
							end
						else
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 239, create {CE_VOID_POINTER}.make_cast (l_k))
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.del_connection
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 4 -- goto close
						end
					end
				when 2 then
					l_k.item.conn := sock1
					update_class_fields -- Current might have been changed; synchronize
					l_k.item.timeout := a_timeout
					update_class_fields -- Current might have been changed; synchronize
					l_k.item.add_time := (create {P_SELECT_STATIC}).get_time
					update_class_fields -- Current might have been changed; synchronize
					from
					until
						(l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_SCHED_STATIC}).keepalive_connections.item)))
						update_class_fields -- Current might have been changed; synchronize
						l_k.item.next := (create {CE_CLASS_POINTER [PD_K_CONN]}.make_cast (((create {P_SCHED_STATIC}).keepalive_connections.item))).item.next
						update_class_fields -- Current might have been changed; synchronize
						l_k.item.prev := create {CE_CLASS_POINTER [PD_K_CONN]}.make_cast (((create {P_SCHED_STATIC}).keepalive_connections.item))
						update_class_fields; -- Current might have been changed; synchronize
						(create {CE_CLASS_POINTER [PD_K_CONN]}.make_cast (((create {P_SCHED_STATIC}).keepalive_connections.item))).item.next := l_k
						update_class_fields; -- Current might have been changed; synchronize
						(l_k.item.next).item.prev := l_k
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_SCHED_STATIC}).keepalive_connections.item)))
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
				when 3 then -- del:;
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.del_connection
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_SCHED_STATIC}).check_queue_bugs
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_SELECT_STATIC}).register_bottom_half ((create {P_SCHED_STATIC}).check_queue_address, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 4 then -- if: | close:
						close (sock1).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SCHED_STATIC}).check_queue_bugs
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SELECT_STATIC}).register_bottom_half ((create {P_SCHED_STATIC}).check_queue_address, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	add_to_queue
		local
			l_cc: CE_POINTER [PD_CONNECTION]
			l_pri: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_tmp := (create {P_LINKS_STATIC}).getpri ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer)))
			update_class_fields -- Current might have been changed; synchronize
			l_pri := l_tmp
			l_cc := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast ((create {P_SCHED_STATIC}).queue.item.item.next)
			from
			until
				not (not (l_break) and then (not l_cc.is_equal ((create {P_SCHED_STATIC}).queue.item)))
			loop
				l_break := False
				l_tmp___0 := (create {P_LINKS_STATIC}).getpri (l_cc)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0 > l_pri then
					l_break := True
				end
				if not (l_break) then
					l_cc := l_cc.item.next
				end
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_cc.item.prev))
				update_class_fields -- Current might have been changed; synchronize
				Current.next := (l_cc.item.prev).item.next
				update_class_fields -- Current might have been changed; synchronize
				Current.prev := l_cc.item.prev
				update_class_fields; -- Current might have been changed; synchronize
				(l_cc.item.prev).item.next := (create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
				next.item.prev := (create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_cc.item.prev))
				update_class_fields -- Current might have been changed; synchronize
				l_break := True
			end
			l_break := False
		end

	interrupt_connection
		do
			(create {P_CONNECT_STATIC}).close_socket (create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock1")))
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.free_connection_data
			update_class_fields -- Current might have been changed; synchronize
		end

	suspend_connection
		do
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.interrupt_connection
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (0)
			update_class_fields -- Current might have been changed; synchronize
		end

	run_connection
		local
			l_hc: CE_POINTER [PD_H_CONN]
			l_func: CE_ROUTINE
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			if running.to_boolean then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).errline.item := 369
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("connection already running"))])
					update_class_fields -- Current might have been changed; synchronize
				end
				l_return := True
			end
			if not l_return then
				l_func := get_protocol_handle (url)
				update_class_fields -- Current might have been changed; synchronize
				if l_func.is_void then
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_009)
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.del_connection
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
				l_hc := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.is_host_on_list
				update_class_fields -- Current might have been changed; synchronize
				if l_hc.is_void then
					l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 378, (create {PD_H_CONN}.make).structure_size.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_hc := create {CE_CLASS_POINTER [PD_H_CONN]}.make_cast (l_tmp)
					if l_hc.is_void then
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_004)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.del_connection
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return then
						l_tmp___0 := (create {P_URL_STATIC}).get_host_name (url)
						update_class_fields -- Current might have been changed; synchronize
						l_hc.item.host := l_tmp___0
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0.is_void then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_009)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.del_connection
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 386, create {CE_VOID_POINTER}.make_cast (l_hc))
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if not l_return then
						l_hc.item.conn := 0
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (h_conns.item))
							update_class_fields -- Current might have been changed; synchronize
							l_hc.item.next := (create {CE_CLASS_POINTER [PD_H_CONN]}.make_cast (h_conns.item)).item.next
							update_class_fields -- Current might have been changed; synchronize
							l_hc.item.prev := create {CE_CLASS_POINTER [PD_H_CONN]}.make_cast (h_conns.item)
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_H_CONN]}.make_cast (h_conns.item)).item.next := l_hc
							update_class_fields; -- Current might have been changed; synchronize
							(l_hc.item.next).item.prev := l_hc
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (h_conns.item))
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
					end
				end
			end
			if not l_return then
				l_hc.item.conn := (l_hc.item.conn) + 1
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SCHED_STATIC}).active_connections.item := (create {P_SCHED_STATIC}).active_connections.item + 1
				update_class_fields -- Current might have been changed; synchronize
				Current.running := 1
				update_class_fields -- Current might have been changed; synchronize
				l_func.call ([(create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))])
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	is_connection_restartable: INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			if unrestartable >= 2 then
				l_tmp___0 := 0
			else
				if ((create {P_DEFAULT_STATIC}).max_tries.item.item).to_boolean then
					l_tmp := (create {P_DEFAULT_STATIC}).max_tries.item.item
				else
					l_tmp := 1_000
				end
				if tries + 1 >= l_tmp then
					l_tmp___0 := 0
				else
					l_tmp___0 := 1
				end
			end
			Result := l_tmp___0
		end

	retry_connection
		local
			l_tmp: INTEGER_32
		do
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.interrupt_connection
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.is_connection_restartable
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				Current.tries := tries + 1
				update_class_fields -- Current might have been changed; synchronize
				Current.prev_error := state
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.run_connection
				update_class_fields -- Current might have been changed; synchronize
			else
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.del_connection
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SCHED_STATIC}).check_queue_bugs
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SELECT_STATIC}).register_bottom_half ((create {P_SCHED_STATIC}).check_queue_address, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	abort_connection
		do
			if running.to_boolean then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.interrupt_connection
				update_class_fields -- Current might have been changed; synchronize
			end
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.del_connection
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SCHED_STATIC}).check_queue_bugs
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SELECT_STATIC}).register_bottom_half ((create {P_SCHED_STATIC}).check_queue_address, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
			update_class_fields -- Current might have been changed; synchronize
		end

	try_connection: INTEGER_32
		local
			l_hc: CE_POINTER [PD_H_CONN]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_hc := create {CE_CLASS_POINTER [PD_H_CONN]}.make_shared (default_pointer)
			l_hc := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.is_host_on_list
			update_class_fields -- Current might have been changed; synchronize
			if (not l_hc.is_void) then
				if l_hc.item.conn >= (create {P_DEFAULT_STATIC}).max_connections_to_host.item.item then
					l_tmp := try_to_suspend_connection ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer)), l_hc.item.host)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						Result := 0
						l_return := True
					else
						Result := (-1)
						l_return := True
					end
				end
			end
			if not l_return and then ((create {P_SCHED_STATIC}).active_connections.item >= (create {P_DEFAULT_STATIC}).max_connections.item.item) then
				l_tmp___0 := try_to_suspend_connection ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer)), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					Result := 0
					l_return := True
				else
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.run_connection
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
			end
		end

	connection_timeout
		do
			Current.timer := -1
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_010)
			update_class_fields -- Current might have been changed; synchronize
			if (not dnsquery.is_void) then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
				update_class_fields -- Current might have been changed; synchronize
			else
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	connection_timeout_1
		local
			l_tmp: INTEGER_32
		do
			if unrestartable.to_boolean then
				l_tmp := (create {P_DEFAULT_STATIC}).unrestartable_receive_timeout.item.item
			else
				l_tmp := (create {P_DEFAULT_STATIC}).receive_timeout.item.item
			end
			Current.timer := (create {P_SELECT_STATIC}).install_timer ((l_tmp * 500).to_integer_32, (connection_timeout_address), create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	set_timeout
		local
			l_tmp: INTEGER_32
		do
			if timer /= -1 then
				(create {P_SELECT_STATIC}).kill_timer (timer)
				update_class_fields -- Current might have been changed; synchronize
			end
			if unrestartable.to_boolean then
				l_tmp := (create {P_DEFAULT_STATIC}).unrestartable_receive_timeout.item.item
			else
				l_tmp := (create {P_DEFAULT_STATIC}).receive_timeout.item.item
			end
			Current.timer := (create {P_SELECT_STATIC}).install_timer ((l_tmp * 500).to_integer_32, (connection_timeout_1_address), create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	reset_timeout
		do
			if timer /= -1 then
				(create {P_SELECT_STATIC}).kill_timer (timer)
				update_class_fields -- Current might have been changed; synchronize
				Current.timer := -1
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	smb_func
		local
			l_i: INTEGER_32
			l_po: CE_ARRAY [INTEGER_32]
			l_pe: CE_ARRAY [INTEGER_32]
			l_host: CE_POINTER [NATURAL_8]
			l_user: CE_POINTER [NATURAL_8]
			l_pass: CE_POINTER [NATURAL_8]
			l_port: CE_POINTER [NATURAL_8]
			l_data1: CE_POINTER [NATURAL_8]
			l_data: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_share: CE_POINTER [NATURAL_8]
			l_dir: CE_POINTER [NATURAL_8]
			l_datal: CE_ARRAY [INTEGER_32]
			l_p: CE_POINTER [NATURAL_8]
			l_r: INTEGER_32
			l_si: CE_POINTER [PD_SMB_CONNECTION_INFO]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: NATURAL_32
			l_tmp___4: NATURAL_32
			l_tmp___5: CE_POINTER [INTEGER_32]
			l_tmp___6: INTEGER_32
			l_tmp___7: CE_POINTER [INTEGER_32]
			l_tmp___8: INTEGER_32
			l_tmp___9: CE_POINTER [INTEGER_32]
			l_n: INTEGER_32
			l_v: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_uphp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_s___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___22: CE_POINTER [NATURAL_8]
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			l_tmp___25: INTEGER_32
			l_tmp___26: INTEGER_32
			l_tmp___27: INTEGER_32
			l_ss: CE_POINTER [NATURAL_8]
			l_s___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___28: CE_POINTER [NATURAL_8]
			l_tmp___29: CE_POINTER [INTEGER_8]
			l_tmp___30: INTEGER_32
			l_tmp___31: INTEGER_32
			l_tmp___32: NATURAL_32
			l_tmp___33: NATURAL_32
			l_tmp___34: INTEGER_32
			l_tmp___35: INTEGER_32
			l_tmp___36: INTEGER_32
			l_tmp___37: INTEGER_32
			l_tmp___38: INTEGER_32
			l_tmp___39: INTEGER_32
			l_d: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___40: CE_POINTER [NATURAL_8]
			l_dl: CE_ARRAY [INTEGER_32]
			l_dp: CE_POINTER [NATURAL_8]
			l_tmp___41: INTEGER_32
			l_tmp___42: INTEGER_32
			l_tmp___43: INTEGER_32
			l_tmp___44: NATURAL_32
			l_tmp___45: NATURAL_32
			l_tmp___46: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_po.make (<<2>>)
			create {CE_INTEGER_32_ARRAY} l_pe.make (<<2>>)
			create {CE_NATURAL_8_POINTER} l_user.make
			create {CE_NATURAL_8_POINTER} l_pass.make
			create {CE_NATURAL_8_POINTER} l_port.make
			create {CE_POINTER_ARRAY [NATURAL_8]} l_data.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_datal.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_v.make (<<32>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_uphp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s___1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_d.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_dl.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 35, (create {PD_SMB_CONNECTION_INFO}.make).structure_size.to_natural_32 + {NATURAL_32} 2)
					update_class_fields -- Current might have been changed; synchronize
					l_si := create {CE_CLASS_POINTER [PD_SMB_CONNECTION_INFO]}.make_cast (l_tmp)
					memset (create {CE_VOID_POINTER}.make_cast (l_si), 0, (create {PD_SMB_CONNECTION_INFO}.make).structure_size.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					Current.info := create {CE_VOID_POINTER}.make_cast (l_si)
					update_class_fields -- Current might have been changed; synchronize
					l_si.item.client := smb_client.item
					update_class_fields -- Current might have been changed; synchronize
					l_host := (create {P_URL_STATIC}).get_host_name (url)
					update_class_fields -- Current might have been changed; synchronize
					if l_host.is_void then
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_003)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_user := (create {P_URL_STATIC}).get_user_name (url)
						update_class_fields -- Current might have been changed; synchronize
						if l_user.is_void then
							l_user := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 45, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pass := get_pass (url)
						update_class_fields -- Current might have been changed; synchronize
						if l_pass.is_void then
							l_pass := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 46, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_port := get_port_str (url)
						update_class_fields -- Current might have been changed; synchronize
						if l_port.is_void then
							l_port := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 47, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_data1 := (create {P_URL_STATIC}).get_url_data (url)
						update_class_fields -- Current might have been changed; synchronize
						if l_data1.is_void then
							l_data1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
						end
						l_data.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 49)
						update_class_fields -- Current might have been changed; synchronize
						l_datal.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_data1))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_data, l_datal, l_data1, l_tmp___0.to_integer_32, -2)
						update_class_fields -- Current might have been changed; synchronize
						l_i := 0
				when 2 then -- loop condition:
						if not (not (l_return) and then ((l_data.item[l_i]).to_boolean)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 3 then -- loop body:
						if not ((l_data.item[l_i]).to_integer_32 < 32) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 6 then -- else:
						if (l_data.item[l_i]).to_integer_32 /= 59 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 9 then -- else:
						if (l_data.item[l_i]).to_integer_32 /= 34 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if smb_client.item /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 55, create {CE_VOID_POINTER}.make_cast (l_host))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 56, create {CE_VOID_POINTER}.make_cast (l_port))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 57, create {CE_VOID_POINTER}.make_cast (l_user))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 58, create {CE_VOID_POINTER}.make_cast (l_pass))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 59, create {CE_VOID_POINTER}.make_cast (l_data.item))
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_009)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
				when 12 then -- if done | if done | if done
						if not l_return then
							l_i := l_i + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 13 then -- loop done | if done
					if not l_return then
						l_tmp___2 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_data.item), ('/').code)
						update_class_fields -- Current might have been changed; synchronize
						l_p := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___2)
						if (not l_p.is_void) then
							l_share := (create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 65, l_data.item, l_p.distance ((l_data.item)))
							update_class_fields -- Current might have been changed; synchronize
							l_dir := l_p + 1
						elseif (l_data.item.item).to_boolean then
							if cache.is_void then
								l_tmp___1 := (create {P_CACHE_STATIC}).get_cache_entry (url, create {CE_POINTER_POINTER [PD_CACHE_ENTRY]}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("cache")))
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___1.to_boolean then
									(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 68, create {CE_VOID_POINTER}.make_cast (l_host))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 69, create {CE_VOID_POINTER}.make_cast (l_port))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 70, create {CE_VOID_POINTER}.make_cast (l_user))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 71, create {CE_VOID_POINTER}.make_cast (l_pass))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 72, create {CE_VOID_POINTER}.make_cast (l_data.item))
									update_class_fields; -- Current might have been changed; synchronize
									((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_004)
									update_class_fields; -- Current might have been changed; synchronize
									((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
									update_class_fields -- Current might have been changed; synchronize
									l_return := True
								end
							end
							if not l_return then
								if (not (cache.item.redirect).is_void) then
									(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 77, create {CE_VOID_POINTER}.make_cast (cache.item.redirect))
									update_class_fields -- Current might have been changed; synchronize
								end
								cache.item.redirect := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 78, url)
								update_class_fields -- Current might have been changed; synchronize
								cache.item.redirect_get := 1
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_strn (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (cache.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("redirect")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")))
								update_class_fields -- Current might have been changed; synchronize
								cache.item.incomplete := 0
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 82, create {CE_VOID_POINTER}.make_cast (l_host))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 83, create {CE_VOID_POINTER}.make_cast (l_port))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 84, create {CE_VOID_POINTER}.make_cast (l_user))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 85, create {CE_VOID_POINTER}.make_cast (l_pass))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 86, create {CE_VOID_POINTER}.make_cast (l_data.item))
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_000)
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							end
						else
							l_share := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 90, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
							update_class_fields -- Current might have been changed; synchronize
							l_dir := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
						end
					end
					if not l_return then
						if not (l_share.item).to_boolean then
							l_si.item.list := 1
							update_class_fields -- Current might have been changed; synchronize
						elseif not (l_dir.item).to_boolean then
							l_si.item.list := 2
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___3 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_dir))
							update_class_fields -- Current might have been changed; synchronize
							if (l_dir[(l_tmp___3 - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 47 then
								l_si.item.list := 2
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___4 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_dir))
								update_class_fields -- Current might have been changed; synchronize
								if (l_dir[(l_tmp___4 - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 92 then
									l_si.item.list := 2
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						l_tmp___6 := (create {P_OS_DEP_STATIC}).c2_pipe (l_po)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___6.to_boolean then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 94, create {CE_VOID_POINTER}.make_cast (l_host))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 95, create {CE_VOID_POINTER}.make_cast (l_port))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 96, create {CE_VOID_POINTER}.make_cast (l_user))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 97, create {CE_VOID_POINTER}.make_cast (l_pass))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 98, create {CE_VOID_POINTER}.make_cast (l_share))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 99, create {CE_VOID_POINTER}.make_cast (l_data.item))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___5 := errno_location
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-l_tmp___5.item)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if not l_return then
						l_tmp___8 := (create {P_OS_DEP_STATIC}).c2_pipe (l_pe)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___8.to_boolean then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 105, create {CE_VOID_POINTER}.make_cast (l_host))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 106, create {CE_VOID_POINTER}.make_cast (l_port))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 107, create {CE_VOID_POINTER}.make_cast (l_user))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 108, create {CE_VOID_POINTER}.make_cast (l_pass))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 109, create {CE_VOID_POINTER}.make_cast (l_share))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 110, create {CE_VOID_POINTER}.make_cast (l_data.item))
							update_class_fields -- Current might have been changed; synchronize
							close (l_po[0]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							close (l_po[1]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___7 := errno_location
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-l_tmp___7.item)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if not l_return then
						Current.from2 := (0).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_r := fork
						update_class_fields -- Current might have been changed; synchronize
						if l_r = -1 then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 120, create {CE_VOID_POINTER}.make_cast (l_host))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 121, create {CE_VOID_POINTER}.make_cast (l_port))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 122, create {CE_VOID_POINTER}.make_cast (l_user))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 123, create {CE_VOID_POINTER}.make_cast (l_pass))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 124, create {CE_VOID_POINTER}.make_cast (l_share))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 125, create {CE_VOID_POINTER}.make_cast (l_data.item))
							update_class_fields -- Current might have been changed; synchronize
							close (l_po[0]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							close (l_po[1]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							close (l_pe[0]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							close (l_pe[1]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___9 := errno_location
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-l_tmp___9.item)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 45 -- skip if block
					end
				when 14 then -- if:
						if l_r.to_boolean then
							l_pos := -1 + 44 -- skip if block
						end
				when 15 then -- if:;
						(create {P_OS_DEP_STATIC}).close_fork_tty
						update_class_fields -- Current might have been changed; synchronize
						close (1).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if (l_si.item.list).to_boolean then
							dup2 (l_pe[1], 1).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						else
							dup2 (l_po[1], 1).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						close (2).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						dup2 (l_pe[1], 2).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						close (0).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						open ([ce_string ("/dev/null"), 0]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						close (l_po[0]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						close (l_pe[0]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						close (l_po[1]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						close (l_pe[1]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_n := 0
						inspect l_si.item.client -- switch 1 head
						when 0 then l_pos := -1 + 16
						when 1 then l_pos := -1 + 28
						else l_pos := -1 + 42
						end
				when 16 then -- switch 1, case 0
						l_tmp___10 := l_n
						l_n := l_n + 1
						l_v[l_tmp___10] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smbclient"))
						update_class_fields -- Current might have been changed; synchronize
						if not (l_share.item).to_boolean then
							l_tmp___11 := l_n
							l_n := l_n + 1
							l_v[l_tmp___11] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-L"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___12 := l_n
							l_n := l_n + 1
							l_v[l_tmp___12] := l_host
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___13 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 158, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("//")))
							update_class_fields -- Current might have been changed; synchronize
							l_s.item := l_tmp___13
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_strn (l_s, l_host)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_strn (l_s, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_strn (l_s, l_share)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___14 := l_n
							l_n := l_n + 1
							l_v[l_tmp___14] := l_s.item
							update_class_fields -- Current might have been changed; synchronize
							if (l_pass.item).to_boolean then
								if not (l_user.item).to_boolean then
									l_tmp___15 := l_n
									l_n := l_n + 1
									l_v[l_tmp___15] := l_pass
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						l_tmp___16 := l_n
						l_n := l_n + 1
						l_v[l_tmp___16] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-N"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___17 := l_n
						l_n := l_n + 1
						l_v[l_tmp___17] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-E"))
						update_class_fields -- Current might have been changed; synchronize
						if (l_port.item).to_boolean then
							l_tmp___18 := l_n
							l_n := l_n + 1
							l_v[l_tmp___18] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-p"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___19 := l_n
							l_n := l_n + 1
							l_v[l_tmp___19] := l_port
							update_class_fields -- Current might have been changed; synchronize
						end
						if (l_user.item).to_boolean then
							l_tmp___20 := l_n
							l_n := l_n + 1
							l_v[l_tmp___20] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-U"))
							update_class_fields -- Current might have been changed; synchronize
							if not (l_pass.item).to_boolean then
								l_tmp___21 := l_n
								l_n := l_n + 1
								l_v[l_tmp___21] := l_user
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___22 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 178, l_user)
								update_class_fields -- Current might have been changed; synchronize
								l_s___0.item := l_tmp___22
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_strn (l_s___0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%")))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_strn (l_s___0, l_pass)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___23 := l_n
								l_n := l_n + 1
								l_v[l_tmp___23] := l_s___0.item
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if not ((l_share.item).to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 17 then -- if:
						if (l_dir.item).to_boolean then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 24 -- goto _L___0
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 20 then -- else:
						l_tmp___32 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_dir))
						update_class_fields -- Current might have been changed; synchronize
						if (l_dir[(l_tmp___32 - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 47 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 24 -- goto _L___0
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 23 then -- else:
						l_tmp___33 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_dir))
						update_class_fields -- Current might have been changed; synchronize
						if (l_dir[(l_tmp___33 - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 92 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if: | _L___0:
						if (l_dir.item).to_boolean then
							l_tmp___24 := l_n
							l_n := l_n + 1
							l_v[l_tmp___24] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-D"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___25 := l_n
							l_n := l_n + 1
							l_v[l_tmp___25] := l_dir
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tmp___26 := l_n
						l_n := l_n + 1
						l_v[l_tmp___26] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-c"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___27 := l_n
						l_n := l_n + 1
						l_v[l_tmp___27] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ls"))
						update_class_fields -- Current might have been changed; synchronize
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						l_tmp___28 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 194, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("get %"")))
						update_class_fields -- Current might have been changed; synchronize
						l_s___1.item := l_tmp___28
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_strn (l_s___1, l_dir)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_strn (l_s___1, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%" -")))
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___29 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_s___1.item), ('/').code)
							update_class_fields -- Current might have been changed; synchronize
							l_ss := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___29)
							if l_ss.is_void then
								l_break := True
							end
							if not (l_return or l_break) then
								l_ss.item := (('\').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						l_tmp___30 := l_n
						l_n := l_n + 1
						l_v[l_tmp___30] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-c"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___31 := l_n
						l_n := l_n + 1
						l_v[l_tmp___31] := l_s___1.item
						update_class_fields -- Current might have been changed; synchronize
				when 27 then -- if done | if done | if done
						l_pos := -1 + 43 -- switch 1; break
				when 28 then -- switch 1, case 1
						l_tmp___34 := l_n
						l_n := l_n + 1
						l_v[l_tmp___34] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smbc"))
						update_class_fields -- Current might have been changed; synchronize
						l_uphp.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 205, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
						update_class_fields -- Current might have been changed; synchronize
						if (l_user.item).to_boolean then
							(create {P_LINKS_STATIC}).add_to_strn (l_uphp, l_user)
							update_class_fields -- Current might have been changed; synchronize
							if (l_pass.item).to_boolean then
								(create {P_LINKS_STATIC}).add_to_strn (l_uphp, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":")))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_strn (l_uphp, l_pass)
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_LINKS_STATIC}).add_to_strn (l_uphp, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("@")))
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_LINKS_STATIC}).add_to_strn (l_uphp, l_host)
						update_class_fields -- Current might have been changed; synchronize
						if (l_port.item).to_boolean then
							(create {P_LINKS_STATIC}).add_to_strn (l_uphp, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":")))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_strn (l_uphp, l_port)
							update_class_fields -- Current might have been changed; synchronize
						end
						if (l_share.item).to_boolean then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						l_tmp___35 := l_n
						l_n := l_n + 1
						l_v[l_tmp___35] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-L"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___36 := l_n
						l_n := l_n + 1
						l_v[l_tmp___36] := l_uphp.item
						update_class_fields -- Current might have been changed; synchronize
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 31 then -- else:;
						(create {P_LINKS_STATIC}).add_to_strn (l_uphp, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_strn (l_uphp, l_share)
						update_class_fields -- Current might have been changed; synchronize
						if (l_dir.item).to_boolean then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 38 -- goto _L___1
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 34 then -- else:
						l_tmp___44 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_dir))
						update_class_fields -- Current might have been changed; synchronize
						if (l_dir[(l_tmp___44 - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 47 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_pos := -1 + 38 -- goto _L___1
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 37 then -- else:
						l_tmp___45 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_dir))
						update_class_fields -- Current might have been changed; synchronize
						if (l_dir[(l_tmp___45 - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 92 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if: | _L___1:;
						(create {P_LINKS_STATIC}).add_to_strn (l_uphp, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_strn (l_uphp, l_dir)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___37 := l_n
						l_n := l_n + 1
						l_v[l_tmp___37] := l_uphp.item
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___38 := l_n
						l_n := l_n + 1
						l_v[l_tmp___38] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-c"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___39 := l_n
						l_n := l_n + 1
						l_v[l_tmp___39] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ls"))
						update_class_fields -- Current might have been changed; synchronize
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else:
						l_tmp___40 := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 232)
						update_class_fields -- Current might have been changed; synchronize
						l_d.item := l_tmp___40
						update_class_fields -- Current might have been changed; synchronize
						l_dl.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_dp := l_dir
						l_tmp___41 := l_n
						l_n := l_n + 1
						l_v[l_tmp___41] := l_uphp.item
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___42 := l_n
						l_n := l_n + 1
						l_v[l_tmp___42] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-c"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_d, l_dl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("pipe cat ")))
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							not ((l_dp.item).to_boolean)
						loop
							if (l_dp.item).to_integer_32 <= 32 then
								(create {P_LINKS_STATIC}).add_chr_to_str (l_d, l_dl, (('\').code).to_natural_8)
								update_class_fields -- Current might have been changed; synchronize
							elseif (l_dp.item).to_integer_32 = 92 then
								(create {P_LINKS_STATIC}).add_chr_to_str (l_d, l_dl, (('\').code).to_natural_8)
								update_class_fields -- Current might have been changed; synchronize
							elseif (l_dp.item).to_integer_32 = 34 then
								(create {P_LINKS_STATIC}).add_chr_to_str (l_d, l_dl, (('\').code).to_natural_8)
								update_class_fields -- Current might have been changed; synchronize
							elseif (l_dp.item).to_integer_32 = 39 then
								(create {P_LINKS_STATIC}).add_chr_to_str (l_d, l_dl, (('\').code).to_natural_8)
								update_class_fields -- Current might have been changed; synchronize
							elseif (l_dp.item).to_integer_32 = 42 then
								(create {P_LINKS_STATIC}).add_chr_to_str (l_d, l_dl, (('\').code).to_natural_8)
								update_class_fields -- Current might have been changed; synchronize
							elseif (l_dp.item).to_integer_32 = 63 then
								(create {P_LINKS_STATIC}).add_chr_to_str (l_d, l_dl, (('\').code).to_natural_8)
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_LINKS_STATIC}).add_chr_to_str (l_d, l_dl, l_dp.item)
							update_class_fields -- Current might have been changed; synchronize
							l_dp := l_dp + 1
						end
						l_tmp___43 := l_n
						l_n := l_n + 1
						l_v[l_tmp___43] := l_d.item
						update_class_fields -- Current might have been changed; synchronize
				when 41 then -- if done | if done | if done
						l_pos := -1 + 43 -- switch 1; break
				when 42 then -- switch 1, default:
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).errline.item := 248
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("unsuported smb client"))])
							update_class_fields -- Current might have been changed; synchronize
						end
				when 43 then -- switch 1, done:
						l_tmp___46 := l_n
						l_n := l_n + 1
						l_v[l_tmp___46] := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						execvp (create {CE_INTEGER_8_POINTER}.make_cast (l_v[0]), create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (l_v)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Io.error.put_string ("client not found")
						Io.error.flush
						exit2 (1)
						update_class_fields -- Current might have been changed; synchronize
				when 44 then -- if done
						Current.pid := l_r
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 257, create {CE_VOID_POINTER}.make_cast (l_host))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 258, create {CE_VOID_POINTER}.make_cast (l_port))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 259, create {CE_VOID_POINTER}.make_cast (l_user))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 260, create {CE_VOID_POINTER}.make_cast (l_pass))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 261, create {CE_VOID_POINTER}.make_cast (l_share))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 262, create {CE_VOID_POINTER}.make_cast (l_data.item))
						update_class_fields -- Current might have been changed; synchronize
						Current.sock1 := l_po[0]
						update_class_fields -- Current might have been changed; synchronize
						Current.sock2 := l_pe[0]
						update_class_fields -- Current might have been changed; synchronize
						close (l_po[1]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						close (l_pe[1]).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SELECT_STATIC}).set_handlers (l_po[0], (smb_got_data_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (c_pointer))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SELECT_STATIC}).set_handlers (l_pe[0], (smb_got_text_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (c_pointer))
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (2)
						update_class_fields -- Current might have been changed; synchronize
				when 45 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	smb_read_text (a_sock: INTEGER_32)
		local
			l_r: INTEGER_32
			l_si: CE_POINTER [PD_SMB_CONNECTION_INFO]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [INTEGER_32]
			l_lasti: INTEGER_32
			l_i: CE_ARRAY [INTEGER_32]
			l_position: CE_ARRAY [INTEGER_32]
			l_total: CE_ARRAY [INTEGER_32]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_i.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_position.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_total.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_si := create {CE_CLASS_POINTER [PD_SMB_CONNECTION_INFO]}.make_cast (info)
					if (((create {PD_SMB_CONNECTION_INFO}.make).structure_size.to_natural_32 + (l_si.item.ntext).to_natural_32) + ((create {P_CACHE_STATIC}).page_size.item).to_natural_32) + {NATURAL_32} 2 > {NATURAL_32} 2_147_483_647 then
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("smb.c"), 314])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_KBD_STATIC}).fatal_tty_exit
							update_class_fields -- Current might have been changed; synchronize
							exit (4)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_tmp := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 315, create {CE_VOID_POINTER}.make_cast (l_si), (((create {PD_SMB_CONNECTION_INFO}.make).structure_size.to_natural_32 + (l_si.item.ntext).to_natural_32) + ((create {P_CACHE_STATIC}).page_size.item).to_natural_32) + {NATURAL_32} 2)
					update_class_fields -- Current might have been changed; synchronize
					l_si := create {CE_CLASS_POINTER [PD_SMB_CONNECTION_INFO]}.make_cast (l_tmp)
					Current.info := create {CE_VOID_POINTER}.make_cast (l_si)
					update_class_fields -- Current might have been changed; synchronize
					l_r := read (a_sock, create {CE_VOID_POINTER}.make_cast ((l_si.item.text + l_si.item.ntext)), ((create {P_CACHE_STATIC}).page_size.item).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_r = -1 then
						l_tmp___0 := errno_location
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-l_tmp___0.item)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return and then (l_r = 0) then
						if not (l_si.item.cl).to_boolean then
							l_si.item.cl := 1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_SELECT_STATIC}).set_handlers (a_sock, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
						if not l_return then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.end_smb_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 34 -- skip if block
					end
				when 1 then -- if:
						l_si.item.ntext := l_si.item.ntext + l_r
						update_class_fields -- Current might have been changed; synchronize
						if not from2.to_boolean then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (6)
							update_class_fields -- Current might have been changed; synchronize
						end
						if not (from2.to_boolean) then
							l_pos := -1 + 34 -- skip if block
						end
				when 2 then -- if:
						if l_si.item.client /= 1 then
							l_pos := -1 + 34 -- skip if block
						end
				when 3 then -- if:
						l_lasti := 0
						l_i.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_si.item.text[l_si.item.ntext] := (0).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_i.item := 0
						update_class_fields -- Current might have been changed; synchronize
				when 4 then -- loop condition:
						if not (not (l_return) and then (l_i.item + 7 < l_si.item.ntext)) then
							l_pos := -1 + 33 -- skip loop
						end
				when 5 then -- loop body: | nexti:
						if (l_si.item.text[l_i.item]).to_integer_32 /= 10 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L___2
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 8 then -- else:
						if (l_si.item.text[l_i.item]).to_integer_32 /= 13 then
							l_pos := -1 + 32 -- skip if block
						end
				when 9 then -- if: | _L___2:
						if (l_si.item.text[l_i.item + 1]).to_integer_32 /= 32 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 14 -- goto _L___1
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 12 then -- else:
						if not ((l_si.item.text[l_i.item + 1]).to_integer_32 >= 48) then
							l_pos := -1 + 32 -- skip if block
						end
				when 13 then -- if:
						if not ((l_si.item.text[l_i.item + 1]).to_integer_32 <= 57) then
							l_pos := -1 + 32 -- skip if block
						end
				when 14 then -- if: | _L___1:
						if (l_si.item.text[l_i.item + 2]).to_integer_32 /= 32 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if (l_si.item.text[l_i.item + 1]).to_integer_32 = 32 then
							l_pos := -1 + 19 -- goto _L
						else
							l_pos := -1 + 17 -- goto _L___0
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 17 then -- else: | _L___0:
						if not ((l_si.item.text[l_i.item + 2]).to_integer_32 >= 48) then
							l_pos := -1 + 32 -- skip if block
						end
				when 18 then -- if:
						if not ((l_si.item.text[l_i.item + 2]).to_integer_32 <= 57) then
							l_pos := -1 + 32 -- skip if block
						end
				when 19 then -- if: | _L:
						if not ((l_si.item.text[l_i.item + 3]).to_integer_32 >= 48) then
							l_pos := -1 + 32 -- skip if block
						end
				when 20 then -- if:
						if not ((l_si.item.text[l_i.item + 3]).to_integer_32 <= 57) then
							l_pos := -1 + 32 -- skip if block
						end
				when 21 then -- if:
						if (l_si.item.text[l_i.item + 4]).to_integer_32 /= 37 then
							l_pos := -1 + 32 -- skip if block
						end
				when 22 then -- if:
						if (l_si.item.text[l_i.item + 5]).to_integer_32 /= 32 then
							l_pos := -1 + 32 -- skip if block
						end
				when 23 then -- if:
						if (l_si.item.text[l_i.item + 6]).to_integer_32 /= 91 then
							l_pos := -1 + 32 -- skip if block
						end
				when 24 then -- if:
						l_i.item := l_i.item + (7)
						update_class_fields -- Current might have been changed; synchronize
				when 25 then -- loop condition:
						if (l_si.item.text[l_i.item]).to_integer_32 = 93 then
							l_pos := -1 + 28 -- skip loop
						end
				when 26 then -- loop body:
						if not (l_si.item.text[l_i.item]).to_boolean then
							l_pos := -1 + 5 -- goto nexti
						elseif (l_si.item.text[l_i.item]).to_integer_32 = 10 then
							l_pos := -1 + 5 -- goto nexti
						elseif (l_si.item.text[l_i.item]).to_integer_32 = 13 then
							l_pos := -1 + 5 -- goto nexti
						end
				when 27 then
						l_i.item := l_i.item + 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 25 -- back to loop condition
				when 28 then -- loop done
						l_i.item := l_i.item + 1
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := smbc_get_num (l_si.item.text, l_i, l_position)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1.to_boolean then
							l_pos := -1 + 5 -- goto nexti
						end
				when 29 then
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_si.item.text[l_i.item]).to_integer_32 /= 32 then
								if (l_si.item.text[l_i.item]).to_integer_32 /= 9 then
									l_break := True
								end
							end
							if not (l_break) then
								l_i.item := l_i.item + 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						if (l_si.item.text[l_i.item]).to_integer_32 /= 47 then
							l_pos := -1 + 5 -- goto nexti
						end
				when 30 then
						l_i.item := l_i.item + 1
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := smbc_get_num (l_si.item.text, l_i, l_total)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2.to_boolean then
							l_pos := -1 + 5 -- goto nexti
						end
				when 31 then
						if l_total.item < from2 then
							l_total.item := from2
							update_class_fields -- Current might have been changed; synchronize
						end
						Current.est_length := l_total.item
						update_class_fields -- Current might have been changed; synchronize
						l_lasti := l_i.item
				when 32 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						l_i.item := l_i.item + 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 4 -- back to loop condition
				when 33 then -- loop done
						if l_lasti.to_boolean then
							l_tmp___3 := l_si.item.ntext - l_lasti
							l_si.item.ntext := l_tmp___3
							update_class_fields -- Current might have been changed; synchronize
							memmove (create {CE_VOID_POINTER}.make_cast ((l_si.item.text)), create {CE_VOID_POINTER}.make_cast ((l_si.item.text + l_lasti)), l_tmp___3.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
				when 34 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	smb_got_data
		local
			l_si: CE_POINTER [PD_SMB_CONNECTION_INFO]
			l_buffer___0: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [ANY]
			l_r: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_32]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
		do
			l_si := create {CE_CLASS_POINTER [PD_SMB_CONNECTION_INFO]}.make_cast (info)
			l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 373, ((create {P_CACHE_STATIC}).page_size.item).to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_buffer___0 := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)
			if (l_si.item.list).to_boolean then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.smb_read_text (sock1)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 377, create {CE_VOID_POINTER}.make_cast (l_buffer___0))
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_r := read (sock1, create {CE_VOID_POINTER}.make_cast (l_buffer___0), ((create {P_CACHE_STATIC}).page_size.item).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				if l_r = -1 then
					l_tmp___0 := errno_location
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-l_tmp___0.item)
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 384, create {CE_VOID_POINTER}.make_cast (l_buffer___0))
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return and then (l_r = 0) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 388, create {CE_VOID_POINTER}.make_cast (l_buffer___0))
				update_class_fields -- Current might have been changed; synchronize
				if not (l_si.item.cl).to_boolean then
					l_si.item.cl := 1
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_SELECT_STATIC}).set_handlers (sock1, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
				if not l_return then
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.end_smb_connection
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (8)
				update_class_fields -- Current might have been changed; synchronize
				if cache.is_void then
					l_tmp___1 := (create {P_CACHE_STATIC}).get_cache_entry (url, create {CE_POINTER_POINTER [PD_CACHE_ENTRY]}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("cache")))
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___1.to_boolean then
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_004)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 401, create {CE_VOID_POINTER}.make_cast (l_buffer___0))
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
				end
			end
			if not l_return and then (from2 + l_r.to_integer_32 < 0) then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_014)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 407, create {CE_VOID_POINTER}.make_cast (l_buffer___0))
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				Current.received := received + l_r.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___2 := add_fragment (cache, from2, create {CE_NATURAL_8_POINTER}.make_cast (l_buffer___0), l_r.to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___2 = 1 then
					Current.tries := 0
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.from2 := from2 + l_r.to_integer_32
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 413, create {CE_VOID_POINTER}.make_cast (l_buffer___0))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	smb_got_text
		do
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.smb_read_text (sock2)
			update_class_fields -- Current might have been changed; synchronize
		end

	end_smb_connection
		local
			l_si: CE_POINTER [PD_SMB_CONNECTION_INFO]
			l_tmp: INTEGER_32
			l_sdir: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_st: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_ls: CE_POINTER [NATURAL_8]
			l_le: CE_POINTER [NATURAL_8]
			l_le2: CE_POINTER [NATURAL_8]
			l_ud: CE_POINTER [NATURAL_8]
			l_t: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_l: CE_ARRAY [INTEGER_32]
			l_type: INTEGER_32
			l_pos___0: INTEGER_32
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: NATURAL_32
			l_spos: CE_POINTER [NATURAL_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_gpos: CE_POINTER [NATURAL_8]
			l_p: CE_POINTER [NATURAL_8]
			l_pp: CE_POINTER [NATURAL_8]
			l_ppp: CE_POINTER [NATURAL_8]
			l_tmp___14: NATURAL_32
			l_tmp___15: NATURAL_32
			l_tmp___16: NATURAL_32
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_tmp___18: NATURAL_32
			l_tmp___19: NATURAL_32
			l_tmp___20: NATURAL_32
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_tmp___22: NATURAL_32
			l_tmp___23: NATURAL_32
			l_tmp___24: NATURAL_32
			l_tmp___25: NATURAL_32
			l_tmp___26: NATURAL_32
			l_tmp___27: NATURAL_32
			l_tmp___28: NATURAL_32
			l_lx: CE_POINTER [NATURAL_8]
			l_tmp___29: CE_POINTER [INTEGER_8]
			l_ll: CE_POINTER [NATURAL_8]
			l_lll: CE_POINTER [NATURAL_8]
			l_tmp___30: CE_POINTER [INTEGER_8]
			l_tmp___31: CE_POINTER [INTEGER_8]
			l_tmp___32: CE_POINTER [INTEGER_8]
			l_tmp___33: CE_POINTER [INTEGER_8]
			l_tmp___34: CE_POINTER [INTEGER_8]
			l_tmp___35: CE_POINTER [INTEGER_8]
			l_tmp___36: CE_POINTER [INTEGER_8]
			l_tmp___37: CE_POINTER [INTEGER_8]
			l_tmp___38: CE_POINTER [INTEGER_8]
			l_llll: CE_POINTER [NATURAL_8]
			l_tmp___39: CE_POINTER [INTEGER_8]
			l_tmp___40: NATURAL_32
			l_tmp___41: NATURAL_32
			l_tmp___42: NATURAL_32
			l_tmp___43: NATURAL_32
			l_tmp___44: CE_POINTER [INTEGER_8]
			l_dir: INTEGER_32
			l_pp___0: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_tmp___45: CE_POINTER [INTEGER_8]
			l_tmp___46: NATURAL_32
			l_tmp___47: NATURAL_32
			l_tmp___48: CE_POINTER [INTEGER_8]
			l_tmp___49: CE_POINTER [INTEGER_8]
			l_tmp___50: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_t.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_si := create {CE_CLASS_POINTER [PD_SMB_CONNECTION_INFO]}.make_cast (info)
					if cache.is_void then
						l_tmp := (create {P_CACHE_STATIC}).get_cache_entry (url, create {CE_POINTER_POINTER [PD_CACHE_ENTRY]}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("cache")))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp.to_boolean then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_004)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 165 -- skip if block
					end
				when 1 then -- if:
						if from2.to_boolean then
							l_pos := -1 + 164 -- skip if block
						end
				when 2 then -- if:
						if (l_si.item.ntext).to_boolean then
							if (l_si.item.text[l_si.item.ntext - 1]).to_integer_32 /= 10 then
								l_tmp___0 := l_si.item.ntext
								l_si.item.ntext := (l_si.item.ntext) + 1
								update_class_fields -- Current might have been changed; synchronize
								l_si.item.text[l_tmp___0] := (('%N').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_si.item.text[l_si.item.ntext] := (0).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_si.item.text)), ce_string ("client not found%N"))
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___1.to_boolean then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_500)
							update_class_fields -- Current might have been changed; synchronize
							l_si.item.client := (l_si.item.client) + 1
							update_class_fields -- Current might have been changed; synchronize
							if l_si.item.client < 2 then
								if l_si.item.client > smb_client.item then
									smb_client.item := l_si.item.client
								end
								Current.tries := -1
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
								update_class_fields -- Current might have been changed; synchronize
							else
								smb_client.item := 0;
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
								update_class_fields -- Current might have been changed; synchronize
							end
							l_return := True
						end
						if l_return then
							l_pos := -1 + 163 -- skip if block
						end
				when 3 then -- if:
						l_sdir := 0
						if l_si.item.client = 1 then
							l_st := l_si.item.text
							l_tmp___3 := memcmp (create {CE_VOID_POINTER}.make_cast (l_st), create {CE_VOID_POINTER}.make_cast (ce_string ("ServerName")), (10).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___3.to_boolean then
								l_tmp___4 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_st), ('%N').code)
								update_class_fields -- Current might have been changed; synchronize
								if (not l_tmp___4.is_void) then
									l_tmp___2 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_st), ('%N').code)
									update_class_fields -- Current might have been changed; synchronize
									l_st := create {CE_NATURAL_8_POINTER}.make_cast ((l_tmp___2 + 1))
								end
							end
							l_tmp___6 := memcmp (create {CE_VOID_POINTER}.make_cast (l_st), create {CE_VOID_POINTER}.make_cast (ce_string ("Logged")), (6).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___6.to_boolean then
								l_tmp___7 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_st), ('%N').code)
								update_class_fields -- Current might have been changed; synchronize
								if (not l_tmp___7.is_void) then
									l_tmp___5 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_st), ('%N').code)
									update_class_fields -- Current might have been changed; synchronize
									l_st := create {CE_NATURAL_8_POINTER}.make_cast ((l_tmp___5 + 1))
								end
							end
							l_tmp___8 := strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_st), ce_string ("ERR"))
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___8.is_void then
								l_sdir := 1
							end
						end
						if (l_si.item.list).to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 4 then -- if:
						if not ((url.item).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 5 then -- if:
						l_tmp___46 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (url))
						update_class_fields -- Current might have been changed; synchronize
						if (url[(l_tmp___46 - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 47 then
							l_pos := -1 + 23 -- skip if block
						end
				when 6 then -- if:
						l_tmp___47 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (url))
						update_class_fields -- Current might have been changed; synchronize
						if (url[(l_tmp___47 - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 92 then
							l_pos := -1 + 21 -- skip if block
						end
				when 7 then -- if:
						l_tmp___48 := strstr (create {CE_INTEGER_8_POINTER}.make_cast ((l_si.item.text)), ce_string ("NT_STATUS_FILE_IS_A_DIRECTORY"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___48.is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 17 -- goto _L___9
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 10 then -- else:
						l_tmp___49 := strstr (create {CE_INTEGER_8_POINTER}.make_cast ((l_si.item.text)), ce_string ("NT_STATUS_ACCESS_DENIED"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___49.is_void then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 17 -- goto _L___9
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else:
						l_tmp___50 := strstr (create {CE_INTEGER_8_POINTER}.make_cast ((l_si.item.text)), ce_string ("ERRbadfile"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___50.is_void then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___9
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else:
						if not (l_sdir.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if: | _L___9:
						if (not (cache.item.redirect).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 453, create {CE_VOID_POINTER}.make_cast (cache.item.redirect))
							update_class_fields -- Current might have been changed; synchronize
						end
						cache.item.redirect := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 454, url)
						update_class_fields -- Current might have been changed; synchronize
						cache.item.redirect_get := 1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_strn (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (cache.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("redirect")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")))
						update_class_fields -- Current might have been changed; synchronize
						cache.item.incomplete := 0
						update_class_fields -- Current might have been changed; synchronize
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						l_pos := -1 + 27 -- goto _L___12
				when 20 then -- if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_pos := -1 + 27 -- goto _L___12
				when 22 then -- if done | if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 27 -- goto _L___12
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_pos := -1 + 27 -- goto _L___12
				when 26 then -- if done | if block done, skip else block:
						l_pos := -1 + 163
				when 27 then -- else: | _L___12:
						l_tmp___9 := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 461)
						update_class_fields -- Current might have been changed; synchronize
						l_t.item := l_tmp___9
						update_class_fields -- Current might have been changed; synchronize
						l_l.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_type := 0
						l_pos___0 := 0;
						(create {P_LINKS_STATIC}).add_to_str (l_t, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<html><head><title>")))
						update_class_fields -- Current might have been changed; synchronize
						l_ud := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 466, url)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___11 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_ud), 1)
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp___11.is_void) then
							l_tmp___10 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_ud), 1)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___10[0] := (0).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tmp___12 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ud))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_t, l_l, l_ud, l_tmp___12.to_integer_32, -1)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 469, create {CE_VOID_POINTER}.make_cast (l_ud))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_t, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("</title></head><body><pre>")))
						update_class_fields -- Current might have been changed; synchronize
						if l_si.item.list /= 1 then
							l_pos := -1 + 32 -- skip if block
						end
				when 28 then -- if:
						if l_si.item.client /= 1 then
							l_pos := -1 + 32 -- skip if block
						end
				when 29 then -- if:
						l_tmp___13 := strstr (create {CE_INTEGER_8_POINTER}.make_cast ((l_si.item.text)), ce_string ("Server              Comment%N------              -------%N"))
						update_class_fields -- Current might have been changed; synchronize
						l_spos := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___13)
						if (not l_spos.is_void) then
							l_tmp___14 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_spos))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___15 := strlen (ce_string ("Server              Comment%N------              -------%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___16 := strlen (ce_string ("Server              Comment%N------              -------%N"))
							update_class_fields -- Current might have been changed; synchronize
							memmove (create {CE_VOID_POINTER}.make_cast (l_spos), create {CE_VOID_POINTER}.make_cast ((l_spos + l_tmp___16.to_integer_32)), (l_tmp___14 - l_tmp___15) + {NATURAL_32} 1).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tmp___17 := strstr (create {CE_INTEGER_8_POINTER}.make_cast ((l_si.item.text)), ce_string ("Workgroup           Master%N---------           ------%N"))
						update_class_fields -- Current might have been changed; synchronize
						l_gpos := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___17)
						if (not l_gpos.is_void) then
							l_tmp___18 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_gpos))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___19 := strlen (ce_string ("Workgroup           Master%N---------           ------%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___20 := strlen (ce_string ("Workgroup           Master%N---------           ------%N"))
							update_class_fields -- Current might have been changed; synchronize
							memmove (create {CE_VOID_POINTER}.make_cast (l_gpos), create {CE_VOID_POINTER}.make_cast ((l_gpos + l_tmp___20.to_integer_32)), (l_tmp___18 - l_tmp___19) + {NATURAL_32} 1).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_spos.is_void then
							if l_gpos.is_void then
								l_pos := -1 + 32 -- goto sc
							end
						end
				when 30 then
						l_pp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_ppp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_p := l_si.item.text
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___21 := strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_p), ce_string ("%N%N"))
							update_class_fields -- Current might have been changed; synchronize
							l_p := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___21)
							if l_p.is_void then
								l_break := True
							end
							if not (l_break) then
								l_ppp := l_pp
								l_pp := l_p + 2
								l_p := l_p + 1
							end
						end
						l_break := False
						if l_pp.is_void then
							l_pos := -1 + 32 -- goto sc
						end
				when 31 then
						if l_spos.is_void then
							l_ppp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						elseif l_gpos.is_void then
							l_ppp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
						if (not l_spos.is_void) then
							if l_ppp.is_void then
								l_ppp := l_pp
								l_pp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							end
							l_tmp___22 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ppp))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___23 := strlen (ce_string ("Server              Comment%N------              -------%N"))
							update_class_fields -- Current might have been changed; synchronize
							memmove (create {CE_VOID_POINTER}.make_cast ((l_ppp + l_tmp___23.to_integer_32)), create {CE_VOID_POINTER}.make_cast (l_ppp), l_tmp___22 + {NATURAL_32} 1).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___24 := strlen (ce_string ("Server              Comment%N------              -------%N"))
							update_class_fields -- Current might have been changed; synchronize
							memcpy (create {CE_VOID_POINTER}.make_cast (l_ppp), create {CE_VOID_POINTER}.make_cast (ce_string ("Server              Comment%N------              -------%N")), l_tmp___24).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							if (not l_pp.is_void) then
								l_tmp___25 := strlen (ce_string ("Server              Comment%N------              -------%N"))
								update_class_fields -- Current might have been changed; synchronize
								l_pp := l_pp + l_tmp___25.to_integer_32
							end
						end
						if (not l_gpos.is_void) then
							if (not l_pp.is_void) then
								l_tmp___26 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_pp))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___27 := strlen (ce_string ("Workgroup           Master%N---------           ------%N"))
								update_class_fields -- Current might have been changed; synchronize
								memmove (create {CE_VOID_POINTER}.make_cast ((l_pp + l_tmp___27.to_integer_32)), create {CE_VOID_POINTER}.make_cast (l_pp), l_tmp___26 + {NATURAL_32} 1).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___28 := strlen (ce_string ("Workgroup           Master%N---------           ------%N"))
								update_class_fields -- Current might have been changed; synchronize
								memcpy (create {CE_VOID_POINTER}.make_cast (l_pp), create {CE_VOID_POINTER}.make_cast (ce_string ("Workgroup           Master%N---------           ------%N")), l_tmp___28).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_pos := -1 + 32 -- goto sc
				when 32 then -- if done | sc:
						l_ls := l_si.item.text
				when 33 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 162 -- skip loop
						end
				when 34 then -- loop body:
						l_break := False
						l_tmp___45 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_ls), ('%N').code)
						update_class_fields -- Current might have been changed; synchronize
						l_le := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___45)
						if l_le.is_void then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 161 -- skip if block
						end
				when 35 then -- if:
						l_tmp___29 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_ls), ('%R').code)
						update_class_fields -- Current might have been changed; synchronize
						l_le2 := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___29)
						if l_le2.is_void then
							l_le2 := l_le
						elseif (l_le2.c_pointer.to_integer_32).to_natural_32 > (l_le.c_pointer.to_integer_32).to_natural_32 then
							l_le2 := l_le
						end
						l_lx := (create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 506, l_ls, l_le2.distance (l_ls))
						update_class_fields -- Current might have been changed; synchronize
						if l_si.item.list /= 1 then
							l_pos := -1 + 95 -- skip if block
						end
				when 36 then -- if:
						if not (l_lx.item).to_boolean then
							l_type := 0
						end
						l_tmp___32 := strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_lx), ce_string ("Sharename"))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp___32.is_void) then
							l_tmp___33 := strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_lx), ce_string ("Type"))
							update_class_fields -- Current might have been changed; synchronize
							if (not l_tmp___33.is_void) then
								l_tmp___31 := strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_lx), ce_string ("Type"))
								update_class_fields -- Current might have been changed; synchronize
								if (not l_tmp___31.is_void) then
									l_tmp___30 := strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_lx), ce_string ("Type"))
									update_class_fields -- Current might have been changed; synchronize
									l_pos___0 := (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___30)).distance (l_lx)
								else
									l_pos___0 := 0
								end
								l_type := 1
								l_pos := -1 + 159 -- goto af
							end
						end
				when 37 then
						l_tmp___34 := strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_lx), ce_string ("Server"))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp___34.is_void) then
							l_tmp___35 := strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_lx), ce_string ("Comment"))
							update_class_fields -- Current might have been changed; synchronize
							if (not l_tmp___35.is_void) then
								l_type := 2
								l_pos := -1 + 159 -- goto af
							end
						end
				when 38 then
						l_tmp___37 := strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_lx), ce_string ("Workgroup"))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp___37.is_void) then
							l_tmp___38 := strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_lx), ce_string ("Master"))
							update_class_fields -- Current might have been changed; synchronize
							if (not l_tmp___38.is_void) then
								l_tmp___36 := strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_lx), ce_string ("Master"))
								update_class_fields -- Current might have been changed; synchronize
								l_pos___0 := (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___36)).distance (l_lx)
								l_type := 3
								l_pos := -1 + 159 -- goto af
							end
						end
				when 39 then
						if not l_type.to_boolean then
							l_pos := -1 + 159 -- goto af
						end
				when 40 then
						l_ll := l_lx
				when 41 then -- loop condition:
						if not ((l_ll.item).to_boolean) then
							l_pos := -1 + 44 -- skip loop
						end
				when 42 then -- loop body:
						if (l_ll.item).to_integer_32 /= 9 then
							if (l_ll.item).to_integer_32 /= 10 then
								if (l_ll.item).to_integer_32 /= 12 then
									if (l_ll.item).to_integer_32 /= 13 then
										if (l_ll.item).to_integer_32 /= 32 then
											if (l_ll.item).to_integer_32 /= 45 then
												l_pos := -1 + 45 -- goto np
											end
										end
									end
								end
							end
						end
				when 43 then
						l_ll := l_ll + 1
						l_pos := -1 + 41 -- back to loop condition
				when 44 then -- loop done
						l_pos := -1 + 159 -- goto af
				when 45 then -- np:
						l_ll := l_lx
						from
						until
							not (not (l_break) and then ((l_ll.item).to_boolean))
						loop
							l_break := False
							if (l_ll.item).to_integer_32 /= 9 then
								if (l_ll.item).to_integer_32 /= 10 then
									if (l_ll.item).to_integer_32 /= 12 then
										if (l_ll.item).to_integer_32 /= 13 then
											if (l_ll.item).to_integer_32 /= 32 then
												l_break := True
											end
										end
									end
								end
							end
							if not (l_break) then
								l_ll := l_ll + 1
							end
						end
						l_break := False
						l_lll := l_ll
						from
						until
							not (not (l_break) and then ((l_lll.item).to_boolean))
						loop
							l_break := False
							if (l_lll.item).to_integer_32 = 9 then
								l_break := True
							elseif (l_lll.item).to_integer_32 = 10 then
								l_break := True
							elseif (l_lll.item).to_integer_32 = 12 then
								l_break := True
							elseif (l_lll.item).to_integer_32 = 13 then
								l_break := True
							elseif (l_lll.item).to_integer_32 = 32 then
								l_break := True
							end
							if not (l_break) then
								l_lll := l_lll + 1
							end
						end
						l_break := False
						if l_type /= 1 then
							l_pos := -1 + 65 -- skip if block
						end
				when 46 then -- if:
						l_tmp___39 := strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_lll), ce_string ("Disk"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___39.is_void then
							l_pos := -1 + 159 -- goto af
						end
				when 47 then
						if not (l_pos___0.to_boolean) then
							l_pos := -1 + 63 -- skip if block
						end
				when 48 then -- if:
						l_tmp___40 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_lx))
						update_class_fields -- Current might have been changed; synchronize
						if not (l_pos___0.to_natural_32 < l_tmp___40) then
							l_pos := -1 + 63 -- skip if block
						end
				when 49 then -- if:
						l_llll := (l_lx + l_pos___0) - 1
						if (l_llll.item).to_integer_32 /= 9 then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:
						l_pos := -1 + 62 -- goto _L
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 52 then -- else:
						l_llll := (l_lx + l_pos___0) - 1
						if (l_llll.item).to_integer_32 /= 10 then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:
						l_pos := -1 + 62 -- goto _L
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 55 then -- else:
						l_llll := (l_lx + l_pos___0) - 1
						if (l_llll.item).to_integer_32 /= 12 then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						l_pos := -1 + 62 -- goto _L
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 58 then -- else:
						l_llll := (l_lx + l_pos___0) - 1
						if (l_llll.item).to_integer_32 /= 13 then
							l_pos := -1 + 61 -- skip if block
						end
				when 59 then -- if:
						l_pos := -1 + 62 -- goto _L
				when 60 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 61 then -- else:
						l_llll := (l_lx + l_pos___0) - 1
						if (l_llll.item).to_integer_32 /= 32 then
							l_pos := -1 + 63 -- skip if block
						end
				when 62 then -- if: | _L:
						if (l_llll.c_pointer.to_integer_32).to_natural_32 > (l_ll.c_pointer.to_integer_32).to_natural_32 then
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_llll.c_pointer.to_integer_32).to_natural_32 > (l_ll.c_pointer.to_integer_32).to_natural_32 then
									if (l_llll.item).to_integer_32 /= 9 then
										if (l_llll.item).to_integer_32 /= 10 then
											if (l_llll.item).to_integer_32 /= 12 then
												if (l_llll.item).to_integer_32 /= 13 then
													if (l_llll.item).to_integer_32 /= 32 then
														l_break := True
													end
												end
											end
										end
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_llll := l_llll - 1
								end
							end
							l_break := False
							if (l_llll.item).to_integer_32 /= 9 then
								if (l_llll.item).to_integer_32 /= 10 then
									if (l_llll.item).to_integer_32 /= 12 then
										if (l_llll.item).to_integer_32 /= 13 then
											if (l_llll.item).to_integer_32 /= 32 then
												l_lll := l_llll + 1
											end
										end
									end
								end
							end
						end
				when 63 then -- if done | if done | if done | if done | if done | if done;
						(create {P_URL_STATIC}).add_conv_str (l_t, l_l, l_lx, l_ll.distance (l_lx), 0)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_t, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<a href=%"/")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_t, l_l, l_ll, l_lll.distance (l_ll), 1)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_t, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/%">")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_t, l_l, l_ll, l_lll.distance (l_ll), 0)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_t, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("</a>")))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___41 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_lll))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_t, l_l, l_lll, l_tmp___41.to_integer_32, 0)
						update_class_fields -- Current might have been changed; synchronize
				when 64 then -- if block done, skip else block:
						l_pos := -1 + 94
				when 65 then -- else:
						if l_type /= 2 then
							l_pos := -1 + 68 -- skip if block
						end
				when 66 then -- if: | sss:;
						(create {P_URL_STATIC}).add_conv_str (l_t, l_l, l_lx, l_ll.distance (l_lx), 0)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_t, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<a href=%"smb://")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_t, l_l, l_ll, l_lll.distance (l_ll), 1)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_t, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/%">")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_t, l_l, l_ll, l_lll.distance (l_ll), 0)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_t, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("</a>")))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___42 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_lll))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_t, l_l, l_lll, l_tmp___42.to_integer_32, 0)
						update_class_fields -- Current might have been changed; synchronize
				when 67 then -- if block done, skip else block:
						l_pos := -1 + 94
				when 68 then -- else:
						if l_type /= 3 then
							l_pos := -1 + 93 -- skip if block
						end
				when 69 then -- if:
						l_tmp___43 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_lx))
						update_class_fields -- Current might have been changed; synchronize
						if not (l_pos___0.to_natural_32 < l_tmp___43) then
							l_pos := -1 + 90 -- skip if block
						end
				when 70 then -- if:
						if not (l_pos___0.to_boolean) then
							l_pos := -1 + 88 -- skip if block
						end
				when 71 then -- if:
						if (l_lx[(l_pos___0 - 1)]).to_integer_32 /= 9 then
							l_pos := -1 + 74 -- skip if block
						end
				when 72 then -- if:
						l_pos := -1 + 84 -- goto _L___2
				when 73 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 74 then -- else:
						if (l_lx[(l_pos___0 - 1)]).to_integer_32 /= 10 then
							l_pos := -1 + 77 -- skip if block
						end
				when 75 then -- if:
						l_pos := -1 + 84 -- goto _L___2
				when 76 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 77 then -- else:
						if (l_lx[(l_pos___0 - 1)]).to_integer_32 /= 12 then
							l_pos := -1 + 80 -- skip if block
						end
				when 78 then -- if:
						l_pos := -1 + 84 -- goto _L___2
				when 79 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 80 then -- else:
						if (l_lx[(l_pos___0 - 1)]).to_integer_32 /= 13 then
							l_pos := -1 + 83 -- skip if block
						end
				when 81 then -- if:
						l_pos := -1 + 84 -- goto _L___2
				when 82 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 83 then -- else:
						if (l_lx[(l_pos___0 - 1)]).to_integer_32 /= 32 then
							l_pos := -1 + 86 -- skip if block
						end
				when 84 then -- if: | _L___2:
						if (l_lx[l_pos___0]).to_integer_32 = 9 then
							l_pos := -1 + 90 -- goto _L___3
						elseif (l_lx[l_pos___0]).to_integer_32 = 10 then
							l_pos := -1 + 90 -- goto _L___3
						elseif (l_lx[l_pos___0]).to_integer_32 = 12 then
							l_pos := -1 + 90 -- goto _L___3
						elseif (l_lx[l_pos___0]).to_integer_32 = 13 then
							l_pos := -1 + 90 -- goto _L___3
						elseif (l_lx[l_pos___0]).to_integer_32 = 32 then
							l_pos := -1 + 90 -- goto _L___3
						else
							l_ll := l_lx + l_pos___0
						end
				when 85 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 86 then -- else:
						l_pos := -1 + 90 -- goto _L___3
				when 87 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 89
				when 88 then -- else:
						l_pos := -1 + 90 -- goto _L___3
				when 89 then -- if done | if block done, skip else block:
						l_pos := -1 + 91
				when 90 then -- else: | _L___3:
						l_ll := l_lll
						from
						until
							not (not (l_break) and then ((l_ll.item).to_boolean))
						loop
							l_break := False
							if (l_ll.item).to_integer_32 /= 9 then
								if (l_ll.item).to_integer_32 /= 10 then
									if (l_ll.item).to_integer_32 /= 12 then
										if (l_ll.item).to_integer_32 /= 13 then
											if (l_ll.item).to_integer_32 /= 32 then
												l_break := True
											end
										end
									end
								end
							end
							if not (l_break) then
								l_ll := l_ll + 1
							end
						end
						l_break := False
				when 91 then
						l_lll := l_ll
						from
						until
							not (not (l_break) and then ((l_lll.item).to_boolean))
						loop
							l_break := False
							if (l_lll.item).to_integer_32 = 9 then
								l_break := True
							elseif (l_lll.item).to_integer_32 = 10 then
								l_break := True
							elseif (l_lll.item).to_integer_32 = 12 then
								l_break := True
							elseif (l_lll.item).to_integer_32 = 13 then
								l_break := True
							elseif (l_lll.item).to_integer_32 = 32 then
								l_break := True
							end
							if not (l_break) then
								l_lll := l_lll + 1
							end
						end
						l_break := False
						l_pos := -1 + 66 -- goto sss
				when 92 then -- if block done, skip else block:
						l_pos := -1 + 94
				when 93 then -- else:
						l_pos := -1 + 159 -- goto af
				when 94 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 160
				when 95 then -- else:
						if l_si.item.list /= 2 then
							l_pos := -1 + 119 -- skip if block
						end
				when 96 then -- if:
						if l_si.item.client /= 0 then
							l_pos := -1 + 117 -- skip if block
						end
				when 97 then -- if:
						l_tmp___44 := strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_lx), ce_string ("NT_STATUS"))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_tmp___44.is_void) then
							l_le[1] := (0).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 159 -- goto af
						end
				when 98 then
						if not (l_le2.distance (l_ls) >= 5) then
							l_pos := -1 + 115 -- skip if block
						end
				when 99 then -- if:
						if (l_ls[0]).to_integer_32 /= 32 then
							l_pos := -1 + 113 -- skip if block
						end
				when 100 then -- if:
						if (l_ls[1]).to_integer_32 /= 32 then
							l_pos := -1 + 111 -- skip if block
						end
				when 101 then -- if:
						if (l_ls[2]).to_integer_32 = 32 then
							l_pos := -1 + 109 -- skip if block
						end
				when 102 then -- if:
						l_p___0 := l_ls + 3
				when 103 then -- loop condition:
						if not (((l_p___0 + 2).c_pointer.to_integer_32).to_natural_32 <= (l_le2.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 106 -- skip loop
						end
				when 104 then -- loop body:
						if (l_p___0[0]).to_integer_32 = 32 then
							if (l_p___0[1]).to_integer_32 = 32 then
								l_pos := -1 + 107 -- goto o
							end
						end
				when 105 then
						l_p___0 := l_p___0 + 1
						l_pos := -1 + 103 -- back to loop condition
				when 106 then -- loop done
						l_pos := -1 + 159 -- goto af
				when 107 then -- o:
						l_dir := 0
						l_pp___0 := l_p___0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_pp___0.c_pointer.to_integer_32).to_natural_32 < (l_le2.c_pointer.to_integer_32).to_natural_32 then
								if (l_pp___0.item).to_integer_32 /= 32 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_pp___0 := l_pp___0 + 1
							end
						end
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_pp___0.c_pointer.to_integer_32).to_natural_32 < (l_le2.c_pointer.to_integer_32).to_natural_32 then
								if (l_pp___0.item).to_integer_32 = 32 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) and then ((l_pp___0.item).to_integer_32 = 68) then
								l_dir := 1
								l_break := True
							end
							if not (l_break) then
								l_pp___0 := l_pp___0 + 1
							end
						end
						l_break := False;
						(create {P_LINKS_STATIC}).add_to_str (l_t, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("  <a href=%"./")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_t, l_l, l_ls + 2, l_p___0.distance ((l_ls + 2)), 1)
						update_class_fields -- Current might have been changed; synchronize
						if l_dir.to_boolean then
							(create {P_LINKS_STATIC}).add_chr_to_str (l_t, l_l, (('/').code).to_natural_8)
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_LINKS_STATIC}).add_to_str (l_t, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%">")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_t, l_l, l_ls + 2, l_p___0.distance ((l_ls + 2)), 0)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_t, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("</a>")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_t, l_l, l_p___0, l_le.distance (l_p___0), 0)
						update_class_fields -- Current might have been changed; synchronize
				when 108 then -- if block done, skip else block:
						l_pos := -1 + 110
				when 109 then -- else:
						l_pos := -1 + 159 -- goto af
				when 110 then -- if done | if block done, skip else block:
						l_pos := -1 + 112
				when 111 then -- else:
						l_pos := -1 + 159 -- goto af
				when 112 then -- if done | if block done, skip else block:
						l_pos := -1 + 114
				when 113 then -- else:
						l_pos := -1 + 159 -- goto af
				when 114 then -- if done | if block done, skip else block:
						l_pos := -1 + 116
				when 115 then -- else:
						l_pos := -1 + 159 -- goto af
				when 116 then -- if done | if block done, skip else block:
						l_pos := -1 + 118
				when 117 then -- else:
						l_pos := -1 + 119 -- goto _L___7
				when 118 then -- if done | if block done, skip else block:
						l_pos := -1 + 160
				when 119 then -- else: | _L___7:
						if l_si.item.list /= 2 then
							l_pos := -1 + 159 -- skip if block
						end
				when 120 then -- if:
						if l_si.item.client /= 1 then
							l_pos := -1 + 157 -- skip if block
						end
				when 121 then -- if:
						if l_le2.distance (l_ls) <= 17 then
							l_pos := -1 + 159 -- goto af
						end
				when 122 then
						l_d := l_ls + 17
				when 123 then -- smbc_next_chr:
						if ((l_d + 9).c_pointer.to_integer_32).to_natural_32 >= (l_le2.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 159 -- goto af
						end
				when 124 then
						if (l_d[0]).to_integer_32 /= 58 then
							l_pos := -1 + 154 -- skip if block
						end
				when 125 then -- if:
						if not ((l_d[1]).to_integer_32 >= 48) then
							l_pos := -1 + 152 -- skip if block
						end
				when 126 then -- if:
						if not ((l_d[1]).to_integer_32 <= 57) then
							l_pos := -1 + 150 -- skip if block
						end
				when 127 then -- if:
						if not ((l_d[2]).to_integer_32 >= 48) then
							l_pos := -1 + 148 -- skip if block
						end
				when 128 then -- if:
						if not ((l_d[2]).to_integer_32 <= 57) then
							l_pos := -1 + 146 -- skip if block
						end
				when 129 then -- if:
						if (l_d[3]).to_integer_32 /= 32 then
							l_pos := -1 + 144 -- skip if block
						end
				when 130 then -- if:
						if (l_d[4]).to_integer_32 /= 49 then
							l_pos := -1 + 133 -- skip if block
						end
				when 131 then -- if:
						if (l_d[5]).to_integer_32 = 57 then
							l_pos := -1 + 136 -- goto _L___4
						else
							l_pos := -1 + 133 -- goto _L___5
						end
				when 132 then -- if block done, skip else block:
						l_pos := -1 + 143
				when 133 then -- else: | _L___5:
						if (l_d[4]).to_integer_32 /= 50 then
							l_pos := -1 + 142 -- skip if block
						end
				when 134 then -- if:
						if not ((l_d[5]).to_integer_32 >= 48) then
							l_pos := -1 + 140 -- skip if block
						end
				when 135 then -- if:
						if not ((l_d[5]).to_integer_32 <= 57) then
							l_pos := -1 + 138 -- skip if block
						end
				when 136 then -- if: | _L___4:
						if (l_d[6]).to_integer_32 >= 48 then
							if (l_d[6]).to_integer_32 <= 57 then
								if (l_d[7]).to_integer_32 >= 48 then
									if (l_d[7]).to_integer_32 <= 57 then
										if (l_d[8]).to_integer_32 /= 32 then
											l_d := l_d + 1
											l_pos := -1 + 123 -- goto smbc_next_chr
										end
									else
										l_d := l_d + 1
										l_pos := -1 + 123 -- goto smbc_next_chr
									end
								else
									l_d := l_d + 1
									l_pos := -1 + 123 -- goto smbc_next_chr
								end
							else
								l_d := l_d + 1
								l_pos := -1 + 123 -- goto smbc_next_chr
							end
						else
							l_d := l_d + 1
							l_pos := -1 + 123 -- goto smbc_next_chr
						end
				when 137 then -- if block done, skip else block:
						l_pos := -1 + 139
				when 138 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 139 then -- if done | if block done, skip else block:
						l_pos := -1 + 141
				when 140 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 141 then -- if done | if block done, skip else block:
						l_pos := -1 + 143
				when 142 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 143 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 145
				when 144 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 145 then -- if done | if block done, skip else block:
						l_pos := -1 + 147
				when 146 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 147 then -- if done | if block done, skip else block:
						l_pos := -1 + 149
				when 148 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 149 then -- if done | if block done, skip else block:
						l_pos := -1 + 151
				when 150 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 151 then -- if done | if block done, skip else block:
						l_pos := -1 + 153
				when 152 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 153 then -- if done | if block done, skip else block:
						l_pos := -1 + 155
				when 154 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 155 then
						l_d := l_d + (9);
						(create {P_URL_STATIC}).add_conv_str (l_t, l_l, l_ls, l_d.distance (l_ls), 0)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_t, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<a href=%"./")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_t, l_l, l_d, l_le2.distance (l_d), 1)
						update_class_fields -- Current might have been changed; synchronize
						if (l_ls[4]).to_integer_32 = 68 then
							(create {P_LINKS_STATIC}).add_chr_to_str (l_t, l_l, (('/').code).to_natural_8)
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_LINKS_STATIC}).add_to_str (l_t, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%">")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_t, l_l, l_d, l_le2.distance (l_d), 0)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_t, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("</a>")))
						update_class_fields -- Current might have been changed; synchronize
				when 156 then -- if block done, skip else block:
						l_pos := -1 + 158
				when 157 then -- else:
						l_pos := -1 + 159 -- goto af
				when 158 then -- if done | if block done, skip else block:
						l_pos := -1 + 160
				when 159 then -- else: | af:;
						(create {P_URL_STATIC}).add_conv_str (l_t, l_l, l_ls, l_le2.distance (l_ls), 0)
						update_class_fields -- Current might have been changed; synchronize
				when 160 then -- if done | if done;
						(create {P_LINKS_STATIC}).add_chr_to_str (l_t, l_l, (('%N').code).to_natural_8)
						update_class_fields -- Current might have been changed; synchronize
						l_ls := l_le + 1;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 614, create {CE_VOID_POINTER}.make_cast (l_lx))
						update_class_fields -- Current might have been changed; synchronize
				when 161 then -- if done
						l_pos := -1 + 33 -- back to loop condition
				when 162 then -- loop done
						l_break := False
						add_fragment (cache, (0).to_integer_32, l_t.item, (l_l.item).to_integer_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Current.from2 := from2 + (l_l.item).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						truncate_entry (cache, (l_l.item).to_integer_32, 1)
						update_class_fields -- Current might have been changed; synchronize
						cache.item.incomplete := 0
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 621, create {CE_VOID_POINTER}.make_cast (l_t.item))
						update_class_fields -- Current might have been changed; synchronize
						if (cache.item.head).is_void then
							cache.item.head := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb.c")), 622, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_LINKS_STATIC}).add_to_strn (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (cache.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("head")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Content-Type: text/html%R%N")))
						update_class_fields -- Current might have been changed; synchronize
				when 163 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 165
				when 164 then -- else:
						truncate_entry (cache, from2, 1)
						update_class_fields -- Current might have been changed; synchronize
						cache.item.incomplete := 0
						update_class_fields -- Current might have been changed; synchronize
				when 165 then -- if done
					if not l_return then
						(create {P_CONNECT_STATIC}).close_socket (create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock1")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_CONNECT_STATIC}).close_socket (create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock2")))
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_000)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
						update_class_fields -- Current might have been changed; synchronize
					end
				when 166 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	exception
		do
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_002)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
			update_class_fields -- Current might have been changed; synchronize
		end

	file_func
		local
			l_e: CE_ARRAY [CE_POINTER [PD_CACHE_ENTRY]]
			l_file: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_name: CE_POINTER [NATURAL_8]
			l_head___0: CE_POINTER [NATURAL_8]
			l_fl: CE_ARRAY [INTEGER_32]
			l_d: CE_POINTER [ANY]
			l_h: INTEGER_32
			l_r: INTEGER_32
			l_stt: CE_ARRAY [SD_STAT]
			l_tmp: CE_POINTER [INTEGER_32]
			l_tmp___0: INTEGER_32
			l_er___0: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_32]
			l_dir: CE_POINTER [PD_DIRS]
			l_dirl: INTEGER_32
			l_i: INTEGER_32
			l_de: CE_POINTER [SD_DIRENT]
			l_tmp___2: CE_POINTER [INTEGER_32]
			l_tmp___3: INTEGER_32
			l_tmp___4: NATURAL_32
			l_tmp___5: INTEGER_32
			l_tmp___6: NATURAL_32
			l_tmp___7: NATURAL_32
			l_stt___0: CE_ARRAY [SD_STAT]
			l_stp: CE_POINTER [SD_STAT]
			l_p: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_n: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___8: INTEGER_32
			l_tmp___9: CE_POINTER [ANY]
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_lnk: CE_POINTER [NATURAL_8]
			l_buf___0: CE_POINTER [NATURAL_8]
			l_size: INTEGER_32
			l_r___0: INTEGER_32
			l_n___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___13: CE_POINTER [ANY]
			l_tmp___14: NATURAL_32
			l_st: CE_ARRAY [SD_STAT]
			l_n___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___15: CE_POINTER [NATURAL_8]
			l_tmp___16: INTEGER_32
			l_tmp___17: NATURAL_32
			l_tmp___18: CE_POINTER [ANY]
			l_tmp___19: CE_POINTER [INTEGER_32]
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_CACHE_ENTRY]} l_e.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_file.make (<<1>>)
			create {CE_NATURAL_8_POINTER} l_head___0.make
			create {CE_INTEGER_32_ARRAY} l_fl.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_stt.make (<<1>>)
			create {CE_CLASS_POINTER [PD_DIRS]} l_dir.make
			create {CE_CLASS_ARRAY [SD_STAT]} l_stt___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_n.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_n___0.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_n___1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_DEFAULT_STATIC}).anonymous.item).to_boolean then
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_009)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return then
						l_name := get_filename (url)
						update_class_fields -- Current might have been changed; synchronize
						if l_name.is_void then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_004)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if not l_return then
						l_tmp___0 := stat (create {CE_INTEGER_8_POINTER}.make_cast (l_name), l_stt)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0.to_boolean then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 231, create {CE_VOID_POINTER}.make_cast (l_name))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp := errno_location
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-l_tmp.item)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if not l_return and then (((l_stt.item.st_mode).bit_and ({NATURAL_32} 61_440)) /= {NATURAL_32} 16_384) then
						if ((l_stt.item.st_mode).bit_and ({NATURAL_32} 61_440)) /= {NATURAL_32} 32_768 then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 235, create {CE_VOID_POINTER}.make_cast (l_name))
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_200)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						l_h := open ([create {CE_INTEGER_8_POINTER}.make_cast (l_name), 256])
						update_class_fields -- Current might have been changed; synchronize
						if l_h /= -1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_tmp___1 := errno_location
						update_class_fields -- Current might have been changed; synchronize
						l_er___0 := l_tmp___1.item
						l_d := opendir (create {CE_INTEGER_8_POINTER}.make_cast (l_name))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_d.is_void) then
							l_pos := -1 + 7 -- goto dir
						end
				when 3 then;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 241, create {CE_VOID_POINTER}.make_cast (l_name))
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-l_er___0)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
				when 4 then -- if done | if done
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 5 then -- if:;
						(create {P_OS_DEP_STATIC}).set_bin (l_h)
						update_class_fields -- Current might have been changed; synchronize
						if ((l_stt.item.st_mode).bit_and ({NATURAL_32} 61_440)) /= {NATURAL_32} 16_384 then
							l_pos := -1 + 19 -- skip if block
						end
				when 6 then -- if:
						l_d := opendir (create {CE_INTEGER_8_POINTER}.make_cast (l_name))
						update_class_fields -- Current might have been changed; synchronize
						close (l_h).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if l_d.is_void then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 253, create {CE_VOID_POINTER}.make_cast (l_name))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___2 := errno_location
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-l_tmp___2.item)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
						if l_return then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | dir:
						l_dir := create {CE_CLASS_POINTER [PD_DIRS]}.make_shared (default_pointer + -1)
						l_dirl := 0
						if (l_name[0]).to_boolean then
							l_tmp___4 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_name))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___5 := (create {P_OS_DEP_STATIC}).dir_sep ((l_name[(l_tmp___4 - {NATURAL_32} 1).to_integer_32]).to_integer_8)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___5.to_boolean then
								l_tmp___3 := (create {P_CACHE_STATIC}).get_cache_entry (url, l_e)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___3.to_boolean then
									(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 260, create {CE_VOID_POINTER}.make_cast (l_name))
									update_class_fields -- Current might have been changed; synchronize
									closedir (l_d).do_nothing
									update_class_fields; -- Current might have been changed; synchronize
									((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_004)
									update_class_fields; -- Current might have been changed; synchronize
									((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
									update_class_fields -- Current might have been changed; synchronize
									l_return := True
								end
								if not l_return then
									Current.cache := l_e.item
									update_class_fields -- Current might have been changed; synchronize
									if (not (l_e.item.item.redirect).is_void) then
										(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 265, create {CE_VOID_POINTER}.make_cast (l_e.item.item.redirect))
										update_class_fields -- Current might have been changed; synchronize
									end
									l_e.item.item.redirect := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 266, url)
									update_class_fields -- Current might have been changed; synchronize
									l_e.item.item.redirect_get := 1
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_LINKS_STATIC}).add_to_strn (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (l_e.item.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("redirect")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 269, create {CE_VOID_POINTER}.make_cast (l_name))
									update_class_fields -- Current might have been changed; synchronize
									closedir (l_d).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									l_pos := -1 + 22 -- goto end
								end
							end
						end
				when 8 then
						if l_return then
							l_pos := -1 + 18 -- skip if block
						end
				when 9 then -- if:
						last_uid.item := -1
						last_gid.item := -1
						l_file.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 275)
						update_class_fields -- Current might have been changed; synchronize
						l_fl.item := 0
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_file, l_fl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<html><head><title>")))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___6 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_name))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_file, l_fl, l_name, l_tmp___6.to_integer_32, -1)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_file, l_fl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("</title></head><body><h2>Directory ")))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___7 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_name))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_file, l_fl, l_name, l_tmp___7.to_integer_32, -1)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_file, l_fl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("</h2><pre>")))
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_continue := False
							l_de := readdir (l_d)
							update_class_fields -- Current might have been changed; synchronize
							if l_de.is_void then
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_tmp___8 := strcmp ((l_de.item.d_name), ce_string ("."))
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___8.to_boolean then
									l_continue := True
								end
							end
							if not (l_return or l_break or l_continue) then
								if l_dirl.to_natural_32 > {NATURAL_32} 2_147_483_647 // (create {PD_DIRS}.make).structure_size.to_natural_32 - {NATURAL_32} 1 then
									from
									until
										False
									loop
										(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("file.c"), 288])
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_KBD_STATIC}).fatal_tty_exit
										update_class_fields -- Current might have been changed; synchronize
										exit (4)
										update_class_fields -- Current might have been changed; synchronize
									end
								end
								l_tmp___9 := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 289, create {CE_VOID_POINTER}.make_cast (l_dir), (l_dirl + 1).to_natural_32 * (create {PD_DIRS}.make).structure_size.to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								l_dir := create {CE_CLASS_POINTER [PD_DIRS]}.make_cast (l_tmp___9);
								(l_dir + l_dirl).item.f := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 290, create {CE_NATURAL_8_POINTER}.make_cast ((l_de.item.d_name)))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___10 := l_dirl
								l_dirl := l_dirl + 1
								l_p := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((l_dir + l_tmp___10).c_pointer + (create {PD_DIRS}.make).offset_of ("s"))
								l_p.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 291)
								update_class_fields -- Current might have been changed; synchronize
								l_l.item := 0
								update_class_fields -- Current might have been changed; synchronize
								l_n.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 293, l_name)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LINKS_STATIC}).add_to_strn (l_n, create {CE_NATURAL_8_POINTER}.make_cast ((l_de.item.d_name)))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___11 := lstat (create {CE_INTEGER_8_POINTER}.make_cast (l_n.item), l_stt___0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___11.to_boolean then
									l_stp := create {CE_CLASS_POINTER [SD_STAT]}.make_shared (default_pointer)
								else
									l_stp := l_stt___0
								end
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 302, create {CE_VOID_POINTER}.make_cast (l_n.item))
								update_class_fields -- Current might have been changed; synchronize
								stat_mode (l_p, l_l, l_stp)
								update_class_fields -- Current might have been changed; synchronize
								stat_links (l_p, l_l, l_stp)
								update_class_fields -- Current might have been changed; synchronize
								stat_user (l_p, l_l, l_stp, 0)
								update_class_fields -- Current might have been changed; synchronize
								stat_user (l_p, l_l, l_stp, 1)
								update_class_fields -- Current might have been changed; synchronize
								stat_size (l_p, l_l, l_stp)
								update_class_fields -- Current might have been changed; synchronize
								stat_date (l_p, l_l, l_stp)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						l_continue := False
						closedir (l_d).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if l_dirl.to_boolean then
							qsort (create {CE_VOID_POINTER}.make_cast (l_dir), l_dirl.to_natural_32, (create {PD_DIRS}.make).structure_size.to_natural_32, ((create {PD_DIRS_STATIC}).comp_de_address))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_i := 0
				when 10 then -- loop condition:
						if not (not (l_return) and then (l_i < l_dirl)) then
							l_pos := -1 + 17 -- skip loop
						end
				when 11 then -- loop body:
						l_lnk := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						if ((l_dir + l_i).item.s[0]).to_integer_32 /= 108 then
							l_pos := -1 + 16 -- skip if block
						end
				when 12 then -- if:
						l_buf___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_size := 0
						l_tmp___12 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 319, l_name)
						update_class_fields -- Current might have been changed; synchronize
						l_n___0.item := l_tmp___12
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_strn (l_n___0, (l_dir + l_i).item.f)
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if (not l_buf___0.is_void) then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 322, create {CE_VOID_POINTER}.make_cast (l_buf___0))
								update_class_fields -- Current might have been changed; synchronize
							end
							l_size := l_size + (64)
							if l_size.to_natural_32 > {NATURAL_32} 2_147_483_647 then
								from
								until
									False
								loop
									(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("file.c"), 324])
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_KBD_STATIC}).fatal_tty_exit
									update_class_fields -- Current might have been changed; synchronize
									exit (4)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_tmp___13 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 325, l_size.to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_buf___0 := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___13)
							l_r___0 := readlink (create {CE_INTEGER_8_POINTER}.make_cast (l_n___0.item), create {CE_INTEGER_8_POINTER}.make_cast (l_buf___0), l_size.to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_r___0 /= l_size then
								l_break := True
							end
						end
						l_break := False
						if l_r___0 = -1 then
							l_pos := -1 + 14 -- goto yyy
						end
				when 13 then
						l_buf___0[l_r___0] := (0).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_lnk := l_buf___0
						l_pos := -1 + 15 -- goto xxx
				when 14 then -- yyy:;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 333, create {CE_VOID_POINTER}.make_cast (l_buf___0))
						update_class_fields -- Current might have been changed; synchronize
				when 15 then -- xxx:;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 335, create {CE_VOID_POINTER}.make_cast (l_n___0.item))
						update_class_fields -- Current might have been changed; synchronize
				when 16 then -- if done;
						(create {P_LINKS_STATIC}).add_to_str (l_file, l_fl, (l_dir + l_i).item.s)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_file, l_fl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<a href=%"./")))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___14 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_dir + l_i).item.f))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_file, l_fl, (l_dir + l_i).item.f, l_tmp___14.to_integer_32, 1)
						update_class_fields -- Current might have been changed; synchronize
						if ((l_dir + l_i).item.s[0]).to_integer_32 = 100 then
							(create {P_LINKS_STATIC}).add_to_str (l_file, l_fl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")))
							update_class_fields -- Current might have been changed; synchronize
						elseif (not l_lnk.is_void) then
							l_tmp___15 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 345, l_name)
							update_class_fields -- Current might have been changed; synchronize
							l_n___1.item := l_tmp___15
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_strn (l_n___1, (l_dir + l_i).item.f)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___16 := stat (create {CE_INTEGER_8_POINTER}.make_cast (l_n___1.item), l_st)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___16.to_boolean then
								if ((l_st.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 16_384 then
									(create {P_LINKS_STATIC}).add_to_str (l_file, l_fl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 348, create {CE_VOID_POINTER}.make_cast (l_n___1.item))
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_LINKS_STATIC}).add_to_str (l_file, l_fl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%">")))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___17 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_dir + l_i).item.f))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_URL_STATIC}).add_conv_str (l_file, l_fl, (l_dir + l_i).item.f, l_tmp___17.to_integer_32, 0)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_file, l_fl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("</a>")))
						update_class_fields -- Current might have been changed; synchronize
						if (not l_lnk.is_void) then
							(create {P_LINKS_STATIC}).add_to_str (l_file, l_fl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" -> ")))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_str (l_file, l_fl, l_lnk)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 358, create {CE_VOID_POINTER}.make_cast (l_lnk))
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_LINKS_STATIC}).add_to_str (l_file, l_fl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")))
						update_class_fields -- Current might have been changed; synchronize
						l_i := l_i + 1
						l_pos := -1 + 10 -- back to loop condition
				when 17 then -- loop done;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 362, create {CE_VOID_POINTER}.make_cast (l_name))
						update_class_fields -- Current might have been changed; synchronize
						l_i := 0
						from
						until
							not (l_i < l_dirl)
						loop
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 363, create {CE_VOID_POINTER}.make_cast ((l_dir + l_i).item.s))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 363, create {CE_VOID_POINTER}.make_cast ((l_dir + l_i).item.f))
							update_class_fields -- Current might have been changed; synchronize
							l_i := l_i + 1
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 364, create {CE_VOID_POINTER}.make_cast (l_dir))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).add_to_str (l_file, l_fl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("</pre></body></html>%N")))
						update_class_fields -- Current might have been changed; synchronize
						l_head___0 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 366, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%NContent-Type: text/html%R%N")))
						update_class_fields -- Current might have been changed; synchronize
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 368, create {CE_VOID_POINTER}.make_cast (l_name))
						update_class_fields -- Current might have been changed; synchronize
						if l_stt.item.st_size > 2_147_483_647 then
							close (l_h).do_nothing
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_014)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
						if not l_return then
							l_tmp___18 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 376, (l_stt.item.st_size + (not (l_stt.item.st_size).to_boolean).to_integer).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_file.item := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___18)
							update_class_fields -- Current might have been changed; synchronize
							l_r := read (l_h, create {CE_VOID_POINTER}.make_cast (l_file.item), (l_stt.item.st_size).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_r.to_integer_32 /= l_stt.item.st_size then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 378, create {CE_VOID_POINTER}.make_cast (l_file.item))
								update_class_fields -- Current might have been changed; synchronize
								close (l_h).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								if l_r = -1 then
									l_tmp___19 := errno_location
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___20 := -l_tmp___19.item
								else
									l_tmp___20 := -1_201
								end
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (l_tmp___20)
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							end
						end
						if not l_return then
							close (l_h).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_fl.item := (l_stt.item.st_size).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							l_head___0 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 384, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 20 then -- if done | if done
					if not l_return then
						l_tmp___21 := (create {P_CACHE_STATIC}).get_cache_entry (url, l_e)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___21.to_boolean then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 387, create {CE_VOID_POINTER}.make_cast (l_file.item))
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_004)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 23 -- skip if block
					end
				when 21 then -- if:
						if (not (l_e.item.item.head).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 390, create {CE_VOID_POINTER}.make_cast (l_e.item.item.head))
							update_class_fields -- Current might have been changed; synchronize
						end
						l_e.item.item.head := l_head___0
						update_class_fields -- Current might have been changed; synchronize
						Current.cache := l_e.item
						update_class_fields -- Current might have been changed; synchronize
						add_fragment (l_e.item, (0).to_integer_32, l_file.item, (l_fl.item).to_integer_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						truncate_entry (l_e.item, (l_fl.item).to_integer_32, 1)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 395, create {CE_VOID_POINTER}.make_cast (l_file.item))
						update_class_fields -- Current might have been changed; synchronize
				when 22 then -- end:
						cache.item.incomplete := 0
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_000)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
						update_class_fields -- Current might have been changed; synchronize
				when 23 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	finger_sent_request
		local
			l_rb: CE_POINTER [PD_READ_BUFFER]
			l_return: BOOLEAN
		do
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.set_timeout
			update_class_fields -- Current might have been changed; synchronize
			l_rb := (create {P_CONNECT_STATIC}).alloc_read_buffer ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer)))
			update_class_fields -- Current might have been changed; synchronize
			if l_rb.is_void then
				l_return := True
			end
			if not l_return then
				l_rb.item.close := 1
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.read_from_socket (sock1, l_rb, finger_get_response_address)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	get_ftp_response (a_rb: CE_POINTER [PD_READ_BUFFER]; a_part: INTEGER_32): INTEGER_32
		require
			not a_rb.is_void
		local
			l_l: INTEGER_32
			l_e: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_k: INTEGER_32
			l_tmp: NATURAL_32
			l_i: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_e.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:;
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.set_timeout
					update_class_fields -- Current might have been changed; synchronize
				when 1 then -- again:
					l_l := 0
				when 2 then -- loop condition:
					if not (not (l_return) and then (l_l < a_rb.item.len)) then
						l_pos := -1 + 23 -- skip loop
					end
				when 3 then -- loop body:
						if (a_rb.item.data[l_l]).to_integer_32 /= 10 then
							l_pos := -1 + 22 -- skip if block
						end
				when 4 then -- if:
						l_tmp := strtoul (create {CE_INTEGER_8_POINTER}.make_cast ((a_rb.item.data)), create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (l_e), 10)
						update_class_fields -- Current might have been changed; synchronize
						l_k := l_tmp.to_integer_32
						if not (l_e.item).is_equal (a_rb.item.data + 3) then
							Result := (-1)
							l_return := True
						elseif l_k < 100 then
							Result := (-1)
							l_return := True
						elseif l_k >= 1_000 then
							Result := (-1)
							l_return := True
						end
						if not (not l_return and then ((l_e.item.item).to_integer_32 = 45)) then
							l_pos := -1 + 18 -- skip if block
						end
				when 5 then -- if:
						l_i := 0
				when 6 then -- loop condition:
						if not (not (l_return) and then (l_i < a_rb.item.len - 5)) then
							l_pos := -1 + 16 -- skip loop
						end
				when 7 then -- loop body:
						if (a_rb.item.data[l_i]).to_integer_32 /= 10 then
							l_pos := -1 + 15 -- skip if block
						end
				when 8 then -- if:
						l_tmp___0 := memcmp (create {CE_VOID_POINTER}.make_cast (((a_rb.item.data + l_i) + 1)), create {CE_VOID_POINTER}.make_cast ((a_rb.item.data)), (3).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0.to_boolean then
							l_pos := -1 + 15 -- skip if block
						end
				when 9 then -- if:
						if (a_rb.item.data[l_i + 4]).to_integer_32 /= 32 then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						l_i := l_i + 1
				when 11 then -- loop condition:
						if not (l_i < a_rb.item.len) then
							l_pos := -1 + 14 -- skip loop
						end
				when 12 then -- loop body:
						if (a_rb.item.data[l_i]).to_integer_32 = 10 then
							l_pos := -1 + 17 -- goto ok
						end
				when 13 then
						l_i := l_i + 1
						l_pos := -1 + 11 -- back to loop condition
				when 14 then -- loop done
						Result := 0
						l_return := True
				when 15 then -- if done | if done | if done
						if not l_return then
							l_i := l_i + 1
						end
						l_pos := -1 + 6 -- back to loop condition
				when 16 then -- loop done
						if not l_return then
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | ok:
						l_l := l_i
				when 18 then -- if done | if done
						if l_return then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if not a_part.to_boolean then
							if l_k >= 100 then
								if l_k < 200 then
									kill_buffer_data (a_rb, l_l + 1)
									update_class_fields -- Current might have been changed; synchronize
									l_pos := -1 + 1 -- goto again
								end
							end
						end
				when 20 then
						if a_part = 2 then
							Result := l_k.to_integer_32
							l_return := True
						end
				when 21 then -- if done
						if not l_return then
							kill_buffer_data (a_rb, l_l + 1)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_k.to_integer_32
							l_return := True
						end
				when 22 then -- if done
						if not l_return then
							l_l := l_l + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 23 then -- loop done
					if not l_return then
						Result := 0
					end
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_func
		local
			l_p: INTEGER_32
			l_tmp: CE_ROUTINE
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_tmp___0 := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.get_keepalive_socket
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___0.to_boolean then
				l_p := get_port (url)
				update_class_fields -- Current might have been changed; synchronize
				if l_p = -1 then
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_003)
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
				if not l_return then
					if ((create {P_DEFAULT_STATIC}).ftp_options.item.item.fast_ftp).to_boolean then
						l_tmp := ftp_login_address
					else
						l_tmp := ftp_get_banner_address
					end
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.make_connection (l_p, create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock1")), l_tmp)
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.ftp_send_retr_req (4)
				update_class_fields -- Current might have been changed; synchronize
			end
			if not l_return then
			end
		end

	ftp_get_banner
		local
			l_rb: CE_POINTER [PD_READ_BUFFER]
			l_return: BOOLEAN
		do
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.set_timeout
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (4)
			update_class_fields -- Current might have been changed; synchronize
			l_rb := (create {P_CONNECT_STATIC}).alloc_read_buffer ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer)))
			update_class_fields -- Current might have been changed; synchronize
			if l_rb.is_void then
				l_return := True
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.read_from_socket (sock1, l_rb, ftp_got_banner_address)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	ftp_got_banner (a_rb: CE_POINTER [PD_READ_BUFFER])
		require
			not a_rb.is_void
		local
			l_g: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.get_ftp_response (a_rb, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_g := l_tmp
			if l_g = -1 then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_300)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return and then (not l_g.to_boolean) then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.read_from_socket (sock1, a_rb, ftp_got_banner_address)
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return and then (l_g >= 400) then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_301)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.ftp_login
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	ftp_got_info (a_rb: CE_POINTER [PD_READ_BUFFER])
		require
			not a_rb.is_void
		local
			l_g: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.get_ftp_response (a_rb, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_g := l_tmp
			if l_g = -1 then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_300)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return and then (not l_g.to_boolean) then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.read_from_socket (sock1, a_rb, ftp_got_info_address)
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return and then (l_g >= 400) then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_301)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.ftp_got_user_info (a_rb)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	ftp_got_user_info (a_rb: CE_POINTER [PD_READ_BUFFER])
		require
			not a_rb.is_void
		local
			l_g: INTEGER_32
			l_tmp: INTEGER_32
			l_login: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_u: CE_POINTER [NATURAL_8]
			l_logl: CE_ARRAY [INTEGER_32]
			l_tmp___0: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_login.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_logl.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.get_ftp_response (a_rb, 0)
					update_class_fields -- Current might have been changed; synchronize
					l_g := l_tmp
					if l_g = -1 then
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_300)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return and then (not l_g.to_boolean) then
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.read_from_socket (sock1, a_rb, ftp_got_user_info_address)
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return and then (l_g >= 530) then
						if l_g < 540 then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_302)
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if not l_return and then (l_g >= 400) then
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_301)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.retry_connection
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if not (l_g >= 200) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_g < 300 then
							if ((create {P_DEFAULT_STATIC}).ftp_options.item.item.fast_ftp).to_boolean then
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.ftp_dummy_info (a_rb)
								update_class_fields -- Current might have been changed; synchronize
							else
								((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.ftp_send_retr_req (6)
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if ((create {P_DEFAULT_STATIC}).ftp_options.item.item.fast_ftp).to_boolean then
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.ftp_pass_info (a_rb)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_logl.item := 0
							update_class_fields -- Current might have been changed; synchronize
							l_login.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 176)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("PASS ")))
							update_class_fields -- Current might have been changed; synchronize
							l_u := get_pass (url)
							update_class_fields -- Current might have been changed; synchronize
							if (not l_u.is_void) then
								if (l_u.item).to_boolean then
									(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, l_u)
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, (create {P_DEFAULT_STATIC}).ftp_options.item.item.anon_pass)
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, (create {P_DEFAULT_STATIC}).ftp_options.item.item.anon_pass)
								update_class_fields -- Current might have been changed; synchronize
							end
							if (not l_u.is_void) then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 180, create {CE_VOID_POINTER}.make_cast (l_u))
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_LINKS_STATIC}).add_to_str (l_login, l_logl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_login.item))
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.write_to_socket (sock1, l_login.item, l_tmp___0.to_integer_32, (create {P_FTP_STATIC}).ftp_sent_passwd_address)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 183, create {CE_VOID_POINTER}.make_cast (l_login.item))
							update_class_fields; -- Current might have been changed; synchronize
							((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (5)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 5 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_dummy_info (a_rb: CE_POINTER [PD_READ_BUFFER])
		require
			not a_rb.is_void
		local
			l_g: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.get_ftp_response (a_rb, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_g := l_tmp
			if l_g = -1 then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_300)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return and then (not l_g.to_boolean) then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.read_from_socket (sock1, a_rb, ftp_dummy_info_address)
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.ftp_retr_file (a_rb)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	ftp_pass_info (a_rb: CE_POINTER [PD_READ_BUFFER])
		require
			not a_rb.is_void
		local
			l_g: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.get_ftp_response (a_rb, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_g := l_tmp
			if l_g = -1 then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_300)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return and then (not l_g.to_boolean) then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.read_from_socket (sock1, a_rb, ftp_pass_info_address)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (5)
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return and then (l_g >= 530) then
				if l_g < 540 then
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_302)
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
			end
			if not l_return and then (l_g >= 400) then
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_301)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				if ((create {P_DEFAULT_STATIC}).ftp_options.item.item.fast_ftp).to_boolean then
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.ftp_retr_file (a_rb)
					update_class_fields -- Current might have been changed; synchronize
				else
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.ftp_send_retr_req (6)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	http_func
		local
			l_p: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.get_keepalive_socket
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				l_p := get_port (url)
				update_class_fields -- Current might have been changed; synchronize
				if l_p = -1 then
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_003)
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
					update_class_fields -- Current might have been changed; synchronize
					l_return := True
				end
				if not l_return then
					((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.make_connection (l_p, create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock1")), http_send_header_address)
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.http_send_header
				update_class_fields -- Current might have been changed; synchronize
			end
			if not l_return then
			end
		end

	proxy_func
		do
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.http_func
			update_class_fields -- Current might have been changed; synchronize
		end

	http_get_header
		local
			l_rb: CE_POINTER [PD_READ_BUFFER]
			l_return: BOOLEAN
		do
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.set_timeout
			update_class_fields -- Current might have been changed; synchronize
			l_rb := (create {P_CONNECT_STATIC}).alloc_read_buffer ((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer)))
			update_class_fields -- Current might have been changed; synchronize
			if l_rb.is_void then
				l_return := True
			end
			if not l_return then
				l_rb.item.close := 1
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.read_from_socket (sock1, l_rb, http_got_header_address)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	https_func
		do
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.setcstate (-1_401)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (c_pointer))).item.abort_connection
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_CONNECTION} -- private routines

	get_port (a_url: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_h: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hl: CE_ARRAY [INTEGER_32]
			l_n: INTEGER_32
			l_nn: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_h.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_hl.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_nn.make (<<1>>)

			l_n := -1
			if ((create {P_URL_STATIC}).parse_url (a_url, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_h, l_hl, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
				Result := (-1)
				l_return := True
			end
			if not l_return and then (not (l_h.item).is_void) then
				l_n := strtol (create {CE_INTEGER_8_POINTER}.make_cast (l_h.item), create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), 10)
				if l_n.to_boolean then
					if l_n < 2_147_483_647 then
						Result := l_n.to_integer_32
						l_return := True
					end
				end
			end
			if not l_return then
				l_h.item := (create {P_URL_STATIC}).get_protocol_name (a_url)
				if (not (l_h.item).is_void) then
					(create {P_URL_STATIC}).get_prot_info (l_h.item, l_nn, create {CE_ROUTINE_POINTER}.make_shared (default_pointer), create {CE_ROUTINE_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing;
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 187, create {CE_VOID_POINTER}.make_cast (l_h.item))
					l_n := (l_nn.item).to_integer_32
				end
				Result := l_n.to_integer_32
			end
		end

	kill_buffer_data (a_rb: CE_POINTER [PD_READ_BUFFER]; a_n: INTEGER_32)
		require
			not a_rb.is_void
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_n > a_rb.item.len) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (a_n < 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("connect.c"));
							(create {P_LINKS_STATIC}).errline.item := 352;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("called kill_buffer_data with bad value"))])
						end
						a_rb.item.len := 0
						l_return := True
				when 5 then -- if done
					if not l_return then
						memmove (create {CE_VOID_POINTER}.make_cast ((a_rb.item.data)), create {CE_VOID_POINTER}.make_cast ((a_rb.item.data + a_n)), (a_rb.item.len - a_n).to_natural_32).do_nothing
						a_rb.item.len := a_rb.item.len - a_n
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_pass (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_h: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hl: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_h.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_hl.make (<<1>>)

			if ((create {P_URL_STATIC}).parse_url (a_url, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_h, l_hl, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := ((create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 163, l_h.item, l_hl.item))
			end
		end

	get_protocol_handle (a_url: CE_POINTER [NATURAL_8]): CE_ROUTINE
		local
			l_p: CE_POINTER [NATURAL_8]
			l_f: CE_ARRAY [CE_ROUTINE]
			l_post: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_ROUTINE_ARRAY} l_f.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_post.make (<<1>>)

			l_f.item := create {CE_ROUTINE}.make_shared (default_pointer)
			l_post.item := 0
			l_p := (create {P_URL_STATIC}).get_protocol_name (a_url)
			if l_p.is_void then
				Result := (create {CE_ROUTINE}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				(create {P_URL_STATIC}).get_prot_info (l_p, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_f, create {CE_ROUTINE_POINTER}.make_shared (default_pointer), l_post).do_nothing;
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 200, create {CE_VOID_POINTER}.make_cast (l_p))
				if not (l_post.item).to_boolean then
					if (not (strchr (create {CE_INTEGER_8_POINTER}.make_cast (a_url), 1)).is_void) then
						Result := (create {CE_ROUTINE}.make_shared (default_pointer))
						l_return := True
					end
				end
			end
			if not l_return then
				Result := (l_f.item)
			end
		end

	get_http_code (a_head___0: CE_POINTER [NATURAL_8]; a_code, a_version: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_head___0.is_void
		local
			l_head___0: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_head___0 := a_head___0
			from
			until
				(l_head___0[0]).to_integer_32 /= 32
			loop
				l_head___0 := l_head___0 + 1
			end
			if ((create {P_LINKS_STATIC}).upcase (l_head___0[0])).to_integer_32 /= 72 then
				Result := (-1)
				l_return := True
			elseif ((create {P_LINKS_STATIC}).upcase (l_head___0[1])).to_integer_32 /= 84 then
				Result := (-1)
				l_return := True
			elseif ((create {P_LINKS_STATIC}).upcase (l_head___0[2])).to_integer_32 /= 84 then
				Result := (-1)
				l_return := True
			elseif ((create {P_LINKS_STATIC}).upcase (l_head___0[3])).to_integer_32 /= 80 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if (l_head___0[4]).to_integer_32 = 47 then
					if (l_head___0[5]).to_integer_32 >= 48 then
						if (l_head___0[5]).to_integer_32 <= 57 then
							if (l_head___0[6]).to_integer_32 = 46 then
								if (l_head___0[7]).to_integer_32 >= 48 then
									if (l_head___0[7]).to_integer_32 <= 57 then
										if (l_head___0[8]).to_integer_32 <= 32 then
											a_version.item := (((l_head___0[5]).to_integer_32 - 48) * 10 + (l_head___0[7]).to_integer_32) - 48
										else
											a_version.item := 0
										end
									else
										a_version.item := 0
									end
								else
									a_version.item := 0
								end
							else
								a_version.item := 0
							end
						else
							a_version.item := 0
						end
					else
						a_version.item := 0
					end
				else
					a_version.item := 0
				end
				l_head___0 := l_head___0 + (4)
				from
				until
					not ((l_head___0.item).to_integer_32 > 32)
				loop
					l_head___0 := l_head___0 + 1
				end
				l_tmp___3 := l_head___0
				l_head___0 := l_head___0 + 1
				if (l_tmp___3.item).to_integer_32 /= 32 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				if (l_head___0[0]).to_integer_32 < 49 then
					Result := (-1)
					l_return := True
				elseif (l_head___0[0]).to_integer_32 > 57 then
					Result := (-1)
					l_return := True
				elseif (l_head___0[1]).to_integer_32 < 48 then
					Result := (-1)
					l_return := True
				elseif (l_head___0[1]).to_integer_32 > 57 then
					Result := (-1)
					l_return := True
				elseif (l_head___0[2]).to_integer_32 < 48 then
					Result := (-1)
					l_return := True
				elseif (l_head___0[2]).to_integer_32 > 57 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				a_code.item := ((((l_head___0[0]).to_integer_32 - 48) * 100 + ((l_head___0[1]).to_integer_32 - 48) * 10) + (l_head___0[2]).to_integer_32) - 48
				Result := 0
			end
		end

	connection_disappeared (a_c: CE_POINTER [PD_CONNECTION]; a_count: NATURAL_32): INTEGER_32
		local
			l_d: CE_POINTER [PD_CONNECTION]
			l_return: BOOLEAN
		do
			l_d := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast ((create {P_SCHED_STATIC}).queue.item.item.next)
			from
			until
				not (not (l_return) and then (not l_d.is_equal ((create {P_SCHED_STATIC}).queue.item)))
			loop
				if a_c.is_equal (l_d) then
					if a_count = l_d.item.count then
						Result := 0
						l_return := True
					end
				end
				if not l_return then
					l_d := l_d.item.next
				end
			end
			if not l_return then
				Result := 1
			end
		end

	get_host_and_pass (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_u: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_h: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_z: CE_POINTER [NATURAL_8]
			l_k: CE_POINTER [NATURAL_8]
			l_hl: CE_ARRAY [INTEGER_32]
			l_pl: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_u.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_h.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_hl.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_pl.make (<<1>>)

			if ((create {P_URL_STATIC}).parse_url (a_url, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_u, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_h, l_hl, l_p, l_pl, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				if (not (l_u.item).is_void) then
					l_z := l_u.item
				else
					l_z := l_h.item
				end
				if (not (l_p.item).is_void) then
					l_k := l_p.item + l_pl.item
				else
					l_k := l_h.item + l_hl.item
				end
				Result := ((create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 139, l_z, l_k.distance (l_z)))
			end
		end

	get_port_str (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_h: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hl: CE_ARRAY [INTEGER_32]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_h.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_hl.make (<<1>>)

			if ((create {P_URL_STATIC}).parse_url (a_url, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_h, l_hl, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				if (l_hl.item).to_boolean then
					l_tmp___1 := ((create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 171, l_h.item, l_hl.item))
				else
					l_tmp___1 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				end
				Result := l_tmp___1
			end
		end

	get_pasv_socket (a_c: CE_POINTER [PD_CONNECTION]; a_cc: INTEGER_32; a_sock: CE_POINTER [INTEGER_32]; a_port: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_s: INTEGER_32
			l_sa: CE_ARRAY [SD_SOCKADDR_IN]
			l_sb: CE_ARRAY [SD_SOCKADDR_IN]
			l_len: CE_ARRAY [NATURAL_32]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_SOCKADDR_IN]} l_sa.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_SOCKADDR_IN]} l_sb.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_len.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len.item := (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32
					memset (create {CE_VOID_POINTER}.make_cast (l_sa), 0, (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32).do_nothing
					memset (create {CE_VOID_POINTER}.make_cast (l_sb), 0, (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32).do_nothing
					if not ((getsockname (a_cc, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_sa), l_len)).to_boolean) then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | e:
						a_c.item.setcstate (-(errno_location).item)
						a_c.item.retry_connection
						Result := (-1)
						l_return := True
				when 2 then -- if done
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 3 then -- if:
						l_s := socket (2, 1, 6)
						if l_s = -1 then
							l_pos := -1 + 1 -- goto e
						end
				when 4 then
						a_sock.item := l_s
						fcntl ([l_s, 4, 2_048]).do_nothing
						memcpy (create {CE_VOID_POINTER}.make_cast (l_sb), create {CE_VOID_POINTER}.make_cast (l_sa), (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32).do_nothing
						l_sb.item.sin_port := (0).to_natural_16
						if (bind (l_s, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_sb), (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32)).to_boolean then
							l_pos := -1 + 1 -- goto e
						end
				when 5 then
						l_len.item := (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32
						if (getsockname (l_s, create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_sa), l_len)).to_boolean then
							l_pos := -1 + 1 -- goto e
						end
				when 6 then
						if (listen (l_s, 1)).to_boolean then
							l_pos := -1 + 1 -- goto e
						end
				when 7 then
						memcpy (create {CE_VOID_POINTER}.make_cast (a_port), create {CE_VOID_POINTER}.make_cast ((create {CE_NATURAL_32_POINTER}.make_shared (l_sa.item.c_pointer + (create {SD_SOCKADDR_IN}.make).offset_of ("sin_addr") + (create {SD_IN_ADDR}.make).offset_of ("s_addr")))), (4).to_natural_32).do_nothing
						memcpy (create {CE_VOID_POINTER}.make_cast ((a_port + 4)), create {CE_VOID_POINTER}.make_cast ((create {CE_NATURAL_16_POINTER}.make_shared (l_sa.item.c_pointer + (create {SD_SOCKADDR_IN}.make).offset_of ("sin_port")))), (2).to_natural_32).do_nothing
						Result := 0
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_cookie (a_term: CE_POINTER [PD_TERMINAL]; a_url, a_str: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_noval: INTEGER_32
			l_cookie: CE_POINTER [PD_COOKIE]
			l_cs: CE_POINTER [PD_C2_SERVER]
			l_p: CE_POINTER [NATURAL_8]
			l_q: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_server: CE_POINTER [NATURAL_8]
			l_date: CE_POINTER [NATURAL_8]
			l_document: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___6: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [PD_COOKIE]} l_cookie.make
			create {CE_NATURAL_8_POINTER} l_server.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_noval := 0
					if accept_cookies.item = 0 then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_p := a_str
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p.item).to_integer_32 /= 59 then
								if not (l_p.item).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_p := l_p + 1
							end
						end
						l_break := False
						l_q := a_str
						from
						until
							not (not (l_break) and then ((l_q.item).to_integer_32 /= 61))
						loop
							l_break := False
							if not (l_q.item).to_boolean then
								l_noval := 1
								l_break := True
							elseif (l_q.c_pointer.to_integer_32).to_natural_32 >= (l_p.c_pointer.to_integer_32).to_natural_32 then
								l_noval := 1
								l_break := True
							end
							if not (l_break) then
								l_q := l_q + 1
							end
						end
						l_break := False
						if a_str.is_equal (l_q) then
							Result := 0
							l_return := True
						elseif (l_q + 1).is_equal (l_p) then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_cookie := create {CE_CLASS_POINTER [PD_COOKIE]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 88, (create {PD_COOKIE}.make).structure_size.to_natural_32)))
						l_document := (create {P_URL_STATIC}).get_url_data (a_url)
						l_server := (create {P_URL_STATIC}).get_host_name (a_url)
						l_cookie.item.name := (create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 91, a_str, l_q.distance (a_str))
						if not l_noval.to_boolean then
							l_cookie.item.value := ((create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 92, l_q + 1, (l_p.distance (l_q)) - 1))
						else
							l_cookie.item.value := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
						l_cookie.item.server := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 93, l_server)
						l_date := (create {P_HTTP_STATIC}).parse_header_param (a_str, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("expires")))
						if (not l_date.is_void) then
							l_cookie.item.expires := (create {P_SESSION_STATIC}).parse_http_date (create {CE_INTEGER_8_POINTER}.make_cast (l_date));
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 99, create {CE_VOID_POINTER}.make_cast (l_date))
						else
							l_cookie.item.expires := (0).to_integer_32
						end
						l_tmp___2 := (create {P_HTTP_STATIC}).parse_header_param (a_str, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("path")))
						l_cookie.item.path := l_tmp___2
						if (not l_tmp___2.is_void) then
							if (l_cookie.item.path[0]).to_integer_32 /= 47 then
								(create {P_LINKS_STATIC}).add_to_strn (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (l_cookie.c_pointer + (create {PD_COOKIE}.make).offset_of ("path")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("x")))
								memmove (create {CE_VOID_POINTER}.make_cast ((l_cookie.item.path + 1)), create {CE_VOID_POINTER}.make_cast (l_cookie.item.path), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_cookie.item.path))) - {NATURAL_32} 1).do_nothing
								l_cookie.item.path[0] := (('/').code).to_natural_8
							end
						else
							l_cookie.item.path := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 104, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")))
						end
						l_tmp___3 := (create {P_HTTP_STATIC}).parse_header_param (a_str, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("domain")))
						l_cookie.item.domain := l_tmp___3
						if l_tmp___3.is_void then
							l_cookie.item.domain := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 124, l_server)
						end
						if (l_cookie.item.domain[0]).to_integer_32 = 46 then
							memmove (create {CE_VOID_POINTER}.make_cast (l_cookie.item.domain), create {CE_VOID_POINTER}.make_cast ((l_cookie.item.domain + 1)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_cookie.item.domain)))).do_nothing
						end
						l_s := (create {P_HTTP_STATIC}).parse_header_param (a_str, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("secure")))
						if (not l_s.is_void) then
							l_cookie.item.secure := 1;
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 128, create {CE_VOID_POINTER}.make_cast (l_s))
						else
							l_cookie.item.secure := 0
						end
						if (check_domain_security (l_server, l_cookie.item.domain)).to_boolean then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 131, create {CE_VOID_POINTER}.make_cast (l_cookie.item.domain))
							l_cookie.item.domain := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 132, l_server)
						end
						l_tmp___6 := cookie_id.item
						cookie_id.item := cookie_id.item + 1
						l_cookie.item.id := l_tmp___6.to_integer_32
						l_cs := create {CE_CLASS_POINTER [PD_C2_SERVER]}.make_cast ((create {P_COOKIES_STATIC}).c2_servers.item.item.next)
				when 2 then -- loop condition:
						if not (not (l_return) and then (not l_cs.is_equal ((create {P_COOKIES_STATIC}).c2_servers.item))) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if not (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_cs.item.server)), create {CE_INTEGER_8_POINTER}.make_cast (l_server))).to_boolean then
							if (l_cs.item.accept).to_boolean then
								l_pos := -1 + 6 -- goto ok
							else
								l_cookie.item.free_cookie;
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 139, create {CE_VOID_POINTER}.make_cast (l_cookie));
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 140, create {CE_VOID_POINTER}.make_cast (l_server))
								Result := 0
								l_return := True
							end
						end
				when 4 then
						if not l_return then
							l_cs := l_cs.item.next
						end
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done | if done
					if not l_return and then (accept_cookies.item /= 2) then
						l_cookie.item.free_cookie;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 146, create {CE_VOID_POINTER}.make_cast (l_cookie));
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 147, create {CE_VOID_POINTER}.make_cast (l_server))
						Result := 1
						l_return := True
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 6 then -- if: | ok:
						accept_cookie (l_cookie);
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 152, create {CE_VOID_POINTER}.make_cast (l_server))
						Result := 0
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_domain_security (a_server, a_domain: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_domain.is_void
		local
			l_domain: CE_POINTER [NATURAL_8]
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_dl: NATURAL_32
			l_nd: INTEGER_32
			l_tmp___1: NATURAL_8
			l_tld: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_tld.make (<<8>>)

			l_domain := a_domain
			if (l_domain[0]).to_integer_32 = 46 then
				l_domain := l_domain + 1
			end
			l_dl := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_domain))
			if l_dl > (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_server))) then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_i := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_server))) - l_dl
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then ((a_server[l_i.to_integer_32]).to_boolean))
				loop
					l_tmp___1 := (create {P_LINKS_STATIC}).upcase (a_server[l_i.to_integer_32])
					if l_tmp___1.to_integer_32 /= ((create {P_LINKS_STATIC}).upcase (l_domain[l_j.to_integer_32])).to_integer_32 then
						Result := 1
						l_return := True
					end
					if not l_return then
						l_i := l_i + 1
						l_j := l_j + 1
					end
				end
			end
			if not l_return then
				l_nd := 2
				if l_dl > {NATURAL_32} 4 then
					if (l_domain[(l_dl - {NATURAL_32} 4).to_integer_32]).to_integer_32 = 46 then
						l_tld[0] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("com"))
						l_tld[1] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("edu"))
						l_tld[2] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("net"))
						l_tld[3] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("org"))
						l_tld[4] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("gov"))
						l_tld[5] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mil"))
						l_tld[6] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("int"))
						l_tld[7] := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_i := (0).to_natural_32
						from
						until
							not (not (l_break) and then (not (l_tld[l_i.to_integer_32]).is_void))
						loop
							l_break := False
							if not ((create {P_LINKS_STATIC}).casecmp (l_tld[l_i.to_integer_32], l_domain + (l_dl - {NATURAL_32} 3).to_integer_32, (3).to_natural_32)).to_boolean then
								l_nd := 1
								l_break := True
							end
							if not (l_return or l_break) then
								l_i := l_i + 1
							end
						end
						l_break := False
					end
				end
				l_i := (0).to_natural_32
				from
				until
					not (not (l_break) and then ((l_domain[l_i.to_integer_32]).to_boolean))
				loop
					l_break := False
					if (l_domain[l_i.to_integer_32]).to_integer_32 = 46 then
						l_nd := l_nd - 1
						if not l_nd.to_boolean then
							l_break := True
						end
					end
					if not (l_return or l_break) then
						l_i := l_i + 1
					end
				end
				l_break := False
				if l_nd > 0 then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	accept_cookie (a_c: CE_POINTER [PD_COOKIE])
		require
			not a_c.is_void
		local
			l_cd: CE_POINTER [PD_C2_DOMAIN]
			l_d: CE_POINTER [PD_COOKIE]
			l_e: CE_POINTER [PD_COOKIE]
			l_return, l_break: BOOLEAN
		do
			l_d := create {CE_CLASS_POINTER [PD_COOKIE]}.make_cast ((create {P_COOKIES_STATIC}).cookies.item.item.next)
			from
			until
				l_d.is_equal ((create {P_COOKIES_STATIC}).cookies.item)
			loop
				if not (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_d.item.name), create {CE_INTEGER_8_POINTER}.make_cast (a_c.item.name))).to_boolean then
					if not (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_d.item.domain), create {CE_INTEGER_8_POINTER}.make_cast (a_c.item.domain))).to_boolean then
						l_e := l_d
						l_d := l_d.item.prev;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_e));
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_e.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_e.item.prev);
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_e.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_e.item.next);
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_e))
						l_e.item.free_cookie;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 165, create {CE_VOID_POINTER}.make_cast (l_e))
					end
				end
				l_d := l_d.item.next
			end
			if (not (a_c.item.value).is_void) then
				if not (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_c.item.value), ce_string ("deleted"))).to_boolean then
					a_c.item.free_cookie;
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 169, create {CE_VOID_POINTER}.make_cast (a_c))
					l_return := True
				end
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_COOKIES_STATIC}).cookies.item)))
					a_c.item.next := (create {CE_CLASS_POINTER [PD_COOKIE]}.make_cast (((create {P_COOKIES_STATIC}).cookies.item))).item.next
					a_c.item.prev := create {CE_CLASS_POINTER [PD_COOKIE]}.make_cast (((create {P_COOKIES_STATIC}).cookies.item));
					(create {CE_CLASS_POINTER [PD_COOKIE]}.make_cast (((create {P_COOKIES_STATIC}).cookies.item))).item.next := a_c;
					(a_c.item.next).item.prev := a_c;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_COOKIES_STATIC}).cookies.item)))
					l_break := True
				end
				l_break := False
				l_cd := create {CE_CLASS_POINTER [PD_C2_DOMAIN]}.make_cast ((create {P_COOKIES_STATIC}).c2_domains.item.item.next)
				from
				until
					not (not (l_return) and then (not l_cd.is_equal ((create {P_COOKIES_STATIC}).c2_domains.item)))
				loop
					if not (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_cd.item.domain)), create {CE_INTEGER_8_POINTER}.make_cast (a_c.item.domain))).to_boolean then
						l_return := True
					end
					if not l_return then
						l_cd := l_cd.item.next
					end
				end
			end
			if not l_return then
				l_cd := create {CE_CLASS_POINTER [PD_C2_DOMAIN]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 174, ((create {PD_C2_DOMAIN}.make).structure_size.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_c.item.domain)))) + {NATURAL_32} 1)))
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_cd.item.domain)), create {CE_INTEGER_8_POINTER}.make_cast (a_c.item.domain)).do_nothing
				from
				until
					(l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_COOKIES_STATIC}).c2_domains.item)))
					l_cd.item.next := (create {CE_CLASS_POINTER [PD_C2_DOMAIN]}.make_cast (((create {P_COOKIES_STATIC}).c2_domains.item))).item.next
					l_cd.item.prev := create {CE_CLASS_POINTER [PD_C2_DOMAIN]}.make_cast (((create {P_COOKIES_STATIC}).c2_domains.item));
					(create {CE_CLASS_POINTER [PD_C2_DOMAIN]}.make_cast (((create {P_COOKIES_STATIC}).c2_domains.item))).item.next := l_cd;
					(l_cd.item.next).item.prev := l_cd;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_COOKIES_STATIC}).c2_domains.item)))
					l_break := True
				end
				l_break := False
			end
		end

	send_cookies (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_url: CE_POINTER [NATURAL_8])
		local
			l_nc: INTEGER_32
			l_cd: CE_POINTER [PD_C2_DOMAIN]
			l_c: CE_POINTER [PD_COOKIE]
			l_d: CE_POINTER [PD_COOKIE]
			l_server: CE_POINTER [NATURAL_8]
			l_data: CE_POINTER [NATURAL_8]
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nc := 0
					l_server := ((create {P_URL_STATIC}).get_host_name (a_url))
					l_data := ((create {P_URL_STATIC}).get_url_data (a_url))
					if (l_data.c_pointer.to_integer_32).to_natural_32 > (a_url.c_pointer.to_integer_32).to_natural_32 then
						l_data := l_data - 1
					end
					l_cd := create {CE_CLASS_POINTER [PD_C2_DOMAIN]}.make_cast ((create {P_COOKIES_STATIC}).c2_domains.item.item.next)
				when 1 then -- loop condition:
					if l_cd.is_equal ((create {P_COOKIES_STATIC}).c2_domains.item) then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if (is_in_domain (l_cd.item.domain, l_server)).to_boolean then
							l_pos := -1 + 5 -- goto ok
						end
				when 3 then
						l_cd := l_cd.item.next
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done;
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 268, create {CE_VOID_POINTER}.make_cast (l_server))
					l_return := True
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | ok:
						l_c := create {CE_CLASS_POINTER [PD_COOKIE]}.make_cast ((create {P_COOKIES_STATIC}).cookies.item.item.next)
						from
						until
							l_c.is_equal ((create {P_COOKIES_STATIC}).cookies.item)
						loop
							l_continue := False
							if (is_in_domain (l_c.item.domain, l_server)).to_boolean then
								if (is_path_prefix (l_c.item.path, l_data)).to_boolean then
									if (cookie_expired (l_c)).to_boolean then
										l_d := l_c
										l_c := l_c.item.prev;
										(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_d));
										(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_d.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_d.item.prev);
										(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_d.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_d.item.next);
										(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_d))
										l_d.item.free_cookie;
										(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 277, create {CE_VOID_POINTER}.make_cast (l_d))
										l_continue := True
									end
									if not (l_continue) and then ((l_c.item.secure).to_boolean) then
										if ((create {P_LINKS_STATIC}).casecmp (a_url, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("https://")), (8).to_natural_32)).to_boolean then
											l_continue := True
										end
									end
									if not (l_continue) then
										if not l_nc.to_boolean then
											(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Cookie: ")))
											l_nc := 1
										else
											(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("; ")))
										end
										(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, l_c.item.name)
										if (not (l_c.item.value).is_void) then
											(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("=")));
											(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, l_c.item.value)
										end
									end
								end
							end
							l_c := l_c.item.next
						end
						l_continue := False
						if l_nc.to_boolean then
							(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 290, create {CE_VOID_POINTER}.make_cast (l_server))
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	is_in_domain (a_d, a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_dl: INTEGER_32
			l_sl: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return: BOOLEAN
		do
			l_dl := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_d))).to_integer_32
			l_sl := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_s))).to_integer_32
			if l_dl > l_sl then
				Result := 0
				l_return := True
			end
			if not l_return and then (l_dl = l_sl) then
				if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_d), create {CE_INTEGER_8_POINTER}.make_cast (a_s))).to_boolean then
					l_tmp___2 := 0
				else
					l_tmp___2 := 1
				end
				Result := l_tmp___2
				l_return := True
			end
			if not l_return and then ((a_s[((l_sl - l_dl) - 1)]).to_integer_32 /= 46) then
				Result := 0
				l_return := True
			end
			if not l_return then
				if ((create {P_LINKS_STATIC}).casecmp (a_d, (a_s + l_sl) - l_dl, l_dl.to_natural_32)).to_boolean then
					l_tmp___4 := 0
				else
					l_tmp___4 := 1
				end
				Result := l_tmp___4
			end
		end

	is_path_prefix (a_d, a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_dl: INTEGER_32
			l_sl: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
		do
			l_dl := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_d))).to_integer_32
			l_sl := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_s))).to_integer_32
			if not l_dl.to_boolean then
				Result := 1
				l_return := True
			end
			if not l_return and then (l_dl > l_sl) then
				Result := 0
				l_return := True
			end
			if not l_return then
				if (memcmp (create {CE_VOID_POINTER}.make_cast (a_d), create {CE_VOID_POINTER}.make_cast (a_s), l_dl.to_natural_32)).to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if (a_d[(l_dl - 1)]).to_integer_32 = 47 then
					l_tmp___2 := 1
				elseif not (a_s[l_dl]).to_boolean then
					l_tmp___2 := 1
				elseif (a_s[l_dl]).to_integer_32 = 47 then
					l_tmp___2 := 1
				elseif (a_s[l_dl]).to_integer_32 = 1 then
					l_tmp___2 := 1
				elseif (a_s[l_dl]).to_integer_32 = 63 then
					l_tmp___2 := 1
				elseif (a_s[l_dl]).to_integer_32 = 38 then
					l_tmp___2 := 1
				else
					l_tmp___2 := 0
				end
				Result := l_tmp___2
			end
		end

	cookie_expired (a_c: CE_POINTER [PD_COOKIE]): INTEGER_32
		do
			Result := 0
		end

	find_host (a_name: CE_POINTER [NATURAL_8]; a_addr: CE_POINTER [NATURAL_32]; a_qp: CE_POINTER [CE_POINTER [ANY]]; a_fn: CE_ROUTINE; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_dnsentry: CE_ARRAY [CE_POINTER [PD_DNSENTRY]]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_DNSENTRY]} l_dnsentry.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (not a_qp.is_void) then
						a_qp.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
					end
					if ((create {P_DNS_STATIC}).find_in_dns_cache (create {CE_INTEGER_8_POINTER}.make_cast (a_name), l_dnsentry)).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_SELECT_STATIC}).get_time).to_natural_32 - (l_dnsentry.item.item.get_time).to_natural_32 > {NATURAL_32} 3_600_000 then
							l_pos := -1 + 4 -- goto timeout
						end
				when 2 then
						memcpy (create {CE_VOID_POINTER}.make_cast (a_addr), create {CE_VOID_POINTER}.make_cast ((create {CE_NATURAL_32_POINTER}.make_shared (l_dnsentry.item.c_pointer + (create {PD_DNSENTRY}.make).offset_of ("addr")))), {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
						a_fn.call ([a_data, 0])
						Result := 0
						l_return := True
				when 3 then -- if done
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 4 then -- if: | timeout:
						Result := (find_host_no_cache (a_name, a_addr, a_qp, a_fn, a_data))
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_host_no_cache (a_name: CE_POINTER [NATURAL_8]; a_addr: CE_POINTER [NATURAL_32]; a_qp: CE_POINTER [CE_POINTER [ANY]]; a_fn: CE_ROUTINE; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_q: CE_POINTER [PD_DNSQUERY]
			l_return: BOOLEAN
		do
			l_q := create {CE_CLASS_POINTER [PD_DNSQUERY]}.make_cast ((malloc (((create {PD_DNSQUERY}.make).structure_size.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_name)))) + {NATURAL_32} 1)))
			if l_q.is_void then
				a_fn.call ([a_data, -1])
				Result := 0
				l_return := True
			end
			if not l_return then
				l_q.item.fn := a_fn
				l_q.item.data := a_data
				l_q.item.s := create {CE_POINTER_POINTER [PD_DNSQUERY]}.make_cast (a_qp)
				l_q.item.addr := a_addr
				strcpy ((l_q.item.name), create {CE_INTEGER_8_POINTER}.make_cast (a_name)).do_nothing
				if (not a_qp.is_void) then
					(create {CE_POINTER_POINTER [PD_DNSQUERY]}.make_cast (a_qp)).item := l_q
				end
				l_q.item.xfn := (create {PD_DNSQUERY_STATIC}).end_dns_lookup_address
				Result := (do_queued_lookup (l_q))
			end
		end

	do_queued_lookup (a_q: CE_POINTER [PD_DNSQUERY]): INTEGER_32
		require
			not a_q.is_void
		do
			Result := (do_lookup (a_q, 0))
		end

	do_lookup (a_q: CE_POINTER [PD_DNSQUERY]; a_force_async: INTEGER_32): INTEGER_32
		require
			not a_q.is_void
		local
			l_r: INTEGER_32
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_DEFAULT_STATIC}).async_lookup.item.item).to_boolean then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if a_force_async.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if: | sync_lookup:
						l_r := (create {P_DNS_STATIC}).do_real_lookup (create {CE_NATURAL_8_POINTER}.make_cast ((a_q.item.name)), a_q.item.addr);
						(a_q.item.xfn).call ([a_q, l_r])
						Result := 0
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else:
						l_pos := -1 + 6 -- goto _L
				when 5 then -- if done | if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else: | _L:
						l_tmp := (create {P_OS_DEP_STATIC}).start_thread (((create {P_DNS_STATIC}).lookup_fn_address), create {CE_VOID_POINTER}.make_cast ((a_q.item.name)), ((strlen ((a_q.item.name))) + {NATURAL_32} 1).to_integer_32)
						a_q.item.h := l_tmp
						if l_tmp = -1 then
							l_pos := -1 + 2 -- goto sync_lookup
						end
				when 7 then;
						(create {P_SELECT_STATIC}).set_handlers (a_q.item.h, ((create {PD_DNSQUERY_STATIC}).end_real_lookup_address), create {CE_ROUTINE}.make_shared (default_pointer), ((create {PD_DNSQUERY_STATIC}).failed_real_lookup_address), create {CE_VOID_POINTER}.make_cast (a_q))
						Result := 1
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	kill_dns_request (a_qp: CE_POINTER [CE_POINTER [ANY]])
		require
			not a_qp.is_void
		local
			l_q: CE_POINTER [PD_DNSQUERY]
		do
			l_q := create {CE_CLASS_POINTER [PD_DNSQUERY]}.make_cast (a_qp.item)
			l_q.item.fn := create {CE_ROUTINE}.make_shared (default_pointer)
			l_q.item.addr := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			a_qp.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
		end

	stat_mode (a_p: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_stp: CE_POINTER [SD_STAT])
		require
			not a_p.is_void
			not a_l.is_void
		local
			l_c: NATURAL_8
			l_rwx: CE_ARRAY [NATURAL_8]
			l_mode: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_rwx.make (<<10>>)

			l_c := (('?').code).to_natural_8
			if (not a_stp.is_void) then
				if ((a_stp.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 24_576 then
					l_c := (('b').code).to_natural_8
				elseif ((a_stp.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 8_192 then
					l_c := (('c').code).to_natural_8
				elseif ((a_stp.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 16_384 then
					l_c := (('d').code).to_natural_8
				elseif ((a_stp.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 32_768 then
					l_c := (('-').code).to_natural_8
				elseif ((a_stp.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 4_096 then
					l_c := (('p').code).to_natural_8
				elseif ((a_stp.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 40_960 then
					l_c := (('l').code).to_natural_8
				elseif ((a_stp.item.st_mode).bit_and ({NATURAL_32} 61_440)) = {NATURAL_32} 49_152 then
					l_c := (('s').code).to_natural_8
				end
			end
			(create {P_LINKS_STATIC}).add_chr_to_str (a_p, a_l, l_c)
			l_rwx[0] := (('-').code).to_natural_8
			l_rwx[1] := (('-').code).to_natural_8
			l_rwx[2] := (('-').code).to_natural_8
			l_rwx[3] := (('-').code).to_natural_8
			l_rwx[4] := (('-').code).to_natural_8
			l_rwx[5] := (('-').code).to_natural_8
			l_rwx[6] := (('-').code).to_natural_8
			l_rwx[7] := (('-').code).to_natural_8
			l_rwx[8] := (('-').code).to_natural_8
			l_rwx[9] := (('%/0/').code).to_natural_8
			if (not a_stp.is_void) then
				l_mode := (a_stp.item.st_mode).to_integer_32
				setrwx (l_mode, l_rwx + 0)
				setrwx ((l_mode).bit_shift_left (3), l_rwx + 3)
				setrwx ((l_mode).bit_shift_left (6), l_rwx + 6)
				setst (l_mode, l_rwx)
			end
			(create {P_LINKS_STATIC}).add_to_str (a_p, a_l, l_rwx);
			(create {P_LINKS_STATIC}).add_chr_to_str (a_p, a_l, ((' ').code).to_natural_8)
		end

	setrwx (a_m: INTEGER_32; a_p: CE_POINTER [NATURAL_8])
		do
			if ((a_m).bit_and (256)).to_boolean then
				a_p[0] := (('r').code).to_natural_8
			end
			if ((a_m).bit_and (128)).to_boolean then
				a_p[1] := (('w').code).to_natural_8
			end
			if ((a_m).bit_and (64)).to_boolean then
				a_p[2] := (('x').code).to_natural_8
			end
		end

	setst (a_m: INTEGER_32; a_p: CE_POINTER [NATURAL_8])
		do
			if ((a_m).bit_and (2_048)).to_boolean then
				a_p[2] := (('S').code).to_natural_8
				if ((a_m).bit_and (64)).to_boolean then
					a_p[2] := (('s').code).to_natural_8
				end
			end
			if ((a_m).bit_and (1_024)).to_boolean then
				a_p[5] := (('S').code).to_natural_8
				if ((a_m).bit_and (((64).bit_shift_right (3)))).to_boolean then
					a_p[5] := (('s').code).to_natural_8
				end
			end
			if ((a_m).bit_and (512)).to_boolean then
				a_p[8] := (('T').code).to_natural_8
				if ((a_m).bit_and (((((64).bit_shift_right (3))).bit_shift_right (3)))).to_boolean then
					a_p[8] := (('t').code).to_natural_8
				end
			end
		end

	stat_links (a_p: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_stp: CE_POINTER [SD_STAT])
		require
			not a_p.is_void
			not a_l.is_void
		local
			l_lnk: CE_ARRAY [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_lnk.make (<<64>>)

			if a_stp.is_void then
				(create {P_LINKS_STATIC}).add_to_str (a_p, a_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("    ")))
			else
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_lnk), ce_string ("%%3d "), (a_stp.item.st_nlink).to_integer_32]).do_nothing;
				(create {P_LINKS_STATIC}).add_to_str (a_p, a_l, l_lnk)
			end
		end

	stat_user (a_p: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_stp: CE_POINTER [SD_STAT]; a_g: INTEGER_32)
		local
			l_pwd: CE_POINTER [SD_PASSWD]
			l_grp: CE_POINTER [SD_GROUP]
			l_id: INTEGER_32
			l_pp: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_stp.is_void then
						(create {P_LINKS_STATIC}).add_to_str (a_p, a_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("         ")))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if not a_g.to_boolean then
							l_id := (a_stp.item.st_uid).to_integer_32
						else
							l_id := (a_stp.item.st_gid).to_integer_32
						end
						if not a_g.to_boolean then
							l_pp := create {CE_NATURAL_8_POINTER}.make_cast (last_user.item)
						else
							l_pp := create {CE_NATURAL_8_POINTER}.make_cast (last_group.item)
						end
						if not a_g.to_boolean then
							if l_id = last_uid.item then
								if last_uid.item /= -1 then
									l_pos := -1 + 4 -- goto a
								end
							end
						end
				when 2 then
						if a_g.to_boolean then
							if l_id = last_gid.item then
								if last_gid.item /= -1 then
									l_pos := -1 + 4 -- goto a
								end
							end
						end
				when 3 then
						if not a_g.to_boolean then
							l_pwd := getpwuid (l_id.to_natural_32)
							if (not l_pwd.is_void) then
								if (l_pwd.item.pw_name).is_void then
									sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_pp), ce_string ("%%d"), l_id]).do_nothing
								else
									sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_pp), ce_string ("%%.8s"), l_pwd.item.pw_name]).do_nothing
								end
							else
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_pp), ce_string ("%%d"), l_id]).do_nothing
							end
							last_uid.item := l_id
						else
							l_grp := getgrgid (l_id.to_natural_32)
							if (not l_grp.is_void) then
								if (l_grp.item.gr_name).is_void then
									sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_pp), ce_string ("%%d"), l_id]).do_nothing
								else
									sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_pp), ce_string ("%%.8s"), l_grp.item.gr_name]).do_nothing
								end
							else
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_pp), ce_string ("%%d"), l_id]).do_nothing
							end
							last_gid.item := l_id
						end
				when 4 then -- a:;
						(create {P_LINKS_STATIC}).add_to_str (a_p, a_l, l_pp)
						l_i := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_pp))).to_integer_32
						from
						until
							not (l_i < 8)
						loop
							(create {P_LINKS_STATIC}).add_chr_to_str (a_p, a_l, ((' ').code).to_natural_8)
							l_i := l_i + 1
						end
						(create {P_LINKS_STATIC}).add_chr_to_str (a_p, a_l, ((' ').code).to_natural_8)
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	stat_size (a_p: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_stp: CE_POINTER [SD_STAT])
		require
			not a_p.is_void
			not a_l.is_void
		local
			l_size: CE_ARRAY [NATURAL_8]
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_size.make (<<64>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (not a_stp.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if: | z:;
						(create {P_LINKS_STATIC}).add_to_str (a_p, a_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("         ")))
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else:
						if ((a_stp.item.st_size).to_natural_32).to_integer_32 = a_stp.item.st_size then
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_size), ce_string ("%%8lu "), (a_stp.item.st_size).to_natural_32]).do_nothing;
							(create {P_LINKS_STATIC}).add_to_str (a_p, a_l, l_size)
						else
							l_pos := -1 + 1 -- goto z
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	stat_date (a_p: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_stp: CE_POINTER [SD_STAT])
		require
			not a_p.is_void
			not a_l.is_void
		local
			l_current_time: INTEGER_32
			l_when: CE_ARRAY [INTEGER_32]
			l_when_local: CE_POINTER [SD_TM]
			l_fmt: CE_POINTER [NATURAL_8]
			l_str: CE_ARRAY [NATURAL_8]
			l_wr: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_when.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_str.make (<<13>>)

			l_current_time := (time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
			if a_stp.is_void then
				(create {P_LINKS_STATIC}).add_to_str (a_p, a_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("             ")))
				l_return := True
			end
			if not l_return then
				l_when.item := a_stp.item.st_mtim.tv_sec
				l_when_local := localtime (l_when)
				if l_current_time > l_when.item + 15_552_000 then
					l_fmt := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%b %%e  %%Y"))
				elseif l_current_time < l_when.item - 3_600 then
					l_fmt := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%b %%e  %%Y"))
				else
					l_fmt := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%b %%e %%H:%%M"))
				end
				l_wr := (strftime (create {CE_INTEGER_8_POINTER}.make_cast (l_str), (13).to_natural_32, create {CE_INTEGER_8_POINTER}.make_cast (l_fmt), l_when_local)).to_integer_32
				from
				until
					not (l_wr < 12)
				loop
					l_tmp___1 := l_wr
					l_wr := l_wr + 1
					l_str[l_tmp___1] := ((' ').code).to_natural_8
				end
				l_str[12] := (0).to_natural_8;
				(create {P_LINKS_STATIC}).add_to_str (a_p, a_l, l_str);
				(create {P_LINKS_STATIC}).add_chr_to_str (a_p, a_l, ((' ').code).to_natural_8)
			end
		end

	get_filename (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p: CE_POINTER [NATURAL_8]
			l_m: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_ml: CE_ARRAY [INTEGER_32]
			l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_m.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_ml.make (<<1>>)

			l_p := a_url + 7
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_p.item).to_boolean then
					if (l_p.item).to_integer_32 = 1 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_p := l_p + 1
				end
			end
			l_break := False
			l_m.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file.c")), 193)
			l_ml.item := 0;
			(create {P_URL_STATIC}).add_conv_str (l_m, l_ml, a_url + 7, (l_p.distance (a_url)) - 7, -2)
			Result := (l_m.item)
		end

	ftp_process_dirlist (a_ce: CE_POINTER [PD_CACHE_ENTRY]; a_pos___0: CE_POINTER [INTEGER_32]; a_d: CE_POINTER [INTEGER_32]; a_bf: CE_POINTER [NATURAL_8]; a_ln, a_fin: INTEGER_32; a_tr: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_str: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_buf___0: CE_POINTER [NATURAL_8]
			l_sl: CE_ARRAY [INTEGER_32]
			l_ret: INTEGER_32
			l_p: INTEGER_32
			l_len: INTEGER_32
			l_f: INTEGER_32
			l_ee: INTEGER_32
			l_dir: INTEGER_32
			l_i: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_pp: INTEGER_32
			l_ppos: INTEGER_32
			l_bp: INTEGER_32
			l_bn: INTEGER_32
			l_i___0: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_str.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_sl.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ret := 0
				when 1 then -- again:
					l_buf___0 := a_bf + l_ret
					l_len := a_ln - l_ret
					l_p := 0
				when 2 then -- loop condition:
					if not (l_p < l_len) then
						l_pos := -1 + 5 -- skip loop
					end
				when 3 then -- loop body:
						if (l_buf___0[l_p]).to_integer_32 = 10 then
							l_pos := -1 + 7 -- goto lb
						end
				when 4 then
						l_p := l_p + 1
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
					if l_p.to_boolean then
						if a_fin.to_boolean then
							l_ret := l_ret + l_p
							l_pos := -1 + 8 -- goto pl
						elseif l_len >= 16_384 then
							l_ret := l_ret + l_p
							l_pos := -1 + 8 -- goto pl
						end
					end
				when 6 then
					Result := l_ret
					l_return := True
					if l_return then
						l_pos := -1 + 131 -- skip if block
					end
				when 7 then -- if: | lb:
						l_ret := l_ret + (l_p + 1)
						if l_p.to_boolean then
							if (l_buf___0[(l_p - 1)]).to_integer_32 = 13 then
								l_p := l_p - 1
							end
						end
				when 8 then -- pl:
						l_str.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 562)
						l_sl.item := 0
						l_f := a_d.item
						if not ((a_d.item).to_boolean) then
							l_pos := -1 + 47 -- skip if block
						end
				when 9 then -- if:
						if not (a_d.item < l_p) then
							l_pos := -1 + 45 -- skip if block
						end
				when 10 then -- if:
						if (l_buf___0[(a_d.item - 1)]).to_integer_32 /= 9 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 23 -- goto ppp
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 13 then -- else:
						if (l_buf___0[(a_d.item - 1)]).to_integer_32 /= 10 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 23 -- goto ppp
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 16 then -- else:
						if (l_buf___0[(a_d.item - 1)]).to_integer_32 /= 12 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 23 -- goto ppp
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 19 then -- else:
						if (l_buf___0[(a_d.item - 1)]).to_integer_32 /= 13 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto ppp
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 22 then -- else:
						if (l_buf___0[(a_d.item - 1)]).to_integer_32 /= 32 then
							l_pos := -1 + 43 -- skip if block
						end
				when 23 then -- if: | ppp:
						l_ee := a_d.item
				when 24 then -- loop condition:
						if not (l_ee <= l_p - 4) then
							l_pos := -1 + 27 -- skip loop
						end
				when 25 then -- loop body:
						if not (memcmp (create {CE_VOID_POINTER}.make_cast ((l_buf___0 + l_ee)), create {CE_VOID_POINTER}.make_cast (ce_string (" -> ")), (4).to_natural_32)).to_boolean then
							l_pos := -1 + 28 -- goto syml
						end
				when 26 then
						l_ee := l_ee + 1
						l_pos := -1 + 24 -- back to loop condition
				when 27 then -- loop done
						l_ee := l_p
				when 28 then -- syml:
						if l_f.to_boolean then
							l_pos := -1 + 41 -- skip if block
						end
				when 29 then -- if:
						if l_ee - a_d.item = 1 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 33 -- goto _L___0
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 32 then -- else:
						if (l_buf___0[a_d.item]).to_integer_32 = 46 then
							l_pos := -1 + 41 -- skip if block
						end
				when 33 then -- if: | _L___0:
						if l_ee - a_d.item = 2 then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_pos := -1 + 40 -- goto _L
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 36 then -- else:
						if (l_buf___0[a_d.item]).to_integer_32 = 46 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						l_pos := -1 + 40 -- goto _L
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 39 then -- else:
						if (l_buf___0[(a_d.item + 1)]).to_integer_32 = 46 then
							l_pos := -1 + 41 -- skip if block
						end
				when 40 then -- if: | _L:
						l_i := 0
						from
						until
							not (l_i < a_d.item)
						loop
							(create {P_LINKS_STATIC}).add_chr_to_str (l_str, l_sl, ((' ').code).to_natural_8)
							l_i := l_i + 1
						end
						(create {P_LINKS_STATIC}).add_to_str (l_str, l_sl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<a href=%"../%">..</a>%N")))
				when 41 then -- if done | if done | if done | if done | if done
						l_dir := ((l_buf___0[0]).to_integer_32 = 100).to_integer
						if not l_dir.to_boolean then
							l_p___0 := ((create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 583, l_buf___0, a_d.item))
							if (not (strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("<DIR>"))).is_void) then
								l_dir := 1
							end
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 585, create {CE_VOID_POINTER}.make_cast (l_p___0))
						end
						(create {P_URL_STATIC}).add_conv_str (l_str, l_sl, l_buf___0, a_d.item, 0);
						(create {P_LINKS_STATIC}).add_to_str (l_str, l_sl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<a href=%"./")));
						(create {P_URL_STATIC}).add_conv_str (l_str, l_sl, l_buf___0 + a_d.item, l_ee - a_d.item, 1)
						if l_dir.to_boolean then
							(create {P_LINKS_STATIC}).add_chr_to_str (l_str, l_sl, (('/').code).to_natural_8)
						end
						(create {P_LINKS_STATIC}).add_to_str (l_str, l_sl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%">")));
						(create {P_URL_STATIC}).add_conv_str (l_str, l_sl, l_buf___0 + a_d.item, l_ee - a_d.item, 0);
						(create {P_LINKS_STATIC}).add_to_str (l_str, l_sl, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("</a>")));
						(create {P_URL_STATIC}).add_conv_str (l_str, l_sl, l_buf___0 + l_ee, l_p - l_ee, 0)
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else:
						l_pos := -1 + 47 -- goto _L___11
				when 44 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else:
						l_pos := -1 + 47 -- goto _L___11
				when 46 then -- if done | if block done, skip else block:
						l_pos := -1 + 130
				when 47 then -- else: | _L___11:
						if l_p > 5 then
							if not ((create {P_LINKS_STATIC}).casecmp (l_buf___0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("total")), (5).to_natural_32)).to_boolean then
								l_pos := -1 + 129 -- goto raw
							end
						end
				when 48 then
						l_pp := l_p - 1
						from
						until
							not (not (l_break) and then (l_pp >= 0))
						loop
							l_break := False
							if (l_buf___0[l_pp]).to_integer_32 /= 9 then
								if (l_buf___0[l_pp]).to_integer_32 /= 10 then
									if (l_buf___0[l_pp]).to_integer_32 /= 12 then
										if (l_buf___0[l_pp]).to_integer_32 /= 13 then
											if (l_buf___0[l_pp]).to_integer_32 /= 32 then
												l_break := True
											end
										end
									end
								end
							end
							if not (l_break) then
								l_pp := l_pp - 1
							end
						end
						l_break := False
						if l_pp < 0 then
							l_pos := -1 + 129 -- goto raw
						end
				when 49 then
						l_ppos := -1
				when 50 then -- loop condition:
						if not (l_pp >= 10) then
							l_pos := -1 + 79 -- skip loop
						end
				when 51 then -- loop body:
						if (l_buf___0[l_pp]).to_integer_32 /= 9 then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
						l_pos := -1 + 64 -- goto _L___5
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 78
				when 54 then -- else:
						if (l_buf___0[l_pp]).to_integer_32 /= 10 then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						l_pos := -1 + 64 -- goto _L___5
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 78
				when 57 then -- else:
						if (l_buf___0[l_pp]).to_integer_32 /= 12 then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						l_pos := -1 + 64 -- goto _L___5
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 78
				when 60 then -- else:
						if (l_buf___0[l_pp]).to_integer_32 /= 13 then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						l_pos := -1 + 64 -- goto _L___5
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 78
				when 63 then -- else:
						if (l_buf___0[l_pp]).to_integer_32 /= 32 then
							l_pos := -1 + 78 -- skip if block
						end
				when 64 then -- if: | _L___5:
						if not ((is_date (create {CE_INTEGER_8_POINTER}.make_cast ((l_buf___0 + (l_pp - 6))))).to_boolean) then
							l_pos := -1 + 72 -- skip if block
						end
				when 65 then -- if:
						if (l_buf___0[(l_pp - 5)]).to_integer_32 /= 32 then
							l_pos := -1 + 72 -- skip if block
						end
				when 66 then -- if:
						if (l_buf___0[(l_pp - 4)]).to_integer_32 /= 50 then
							l_pos := -1 + 69 -- skip if block
						end
				when 67 then -- if:
						if (l_buf___0[(l_pp - 3)]).to_integer_32 = 48 then
							l_pos := -1 + 71 -- goto _L___1
						else
							l_pos := -1 + 69 -- goto _L___2
						end
				when 68 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 69 then -- else: | _L___2:
						if (l_buf___0[(l_pp - 4)]).to_integer_32 /= 49 then
							l_pos := -1 + 72 -- skip if block
						end
				when 70 then -- if:
						if (l_buf___0[(l_pp - 3)]).to_integer_32 /= 57 then
							l_pos := -1 + 72 -- skip if block
						end
				when 71 then -- if: | _L___1:
						if (l_buf___0[(l_pp - 2)]).to_integer_32 >= 48 then
							if (l_buf___0[(l_pp - 2)]).to_integer_32 <= 57 then
								if (l_buf___0[(l_pp - 1)]).to_integer_32 >= 48 then
									if (l_buf___0[(l_pp - 1)]).to_integer_32 <= 57 then
										if l_pp < l_p - 1 then
											if (l_buf___0[(l_pp + 1)]).to_integer_32 = 32 then
												l_ppos := l_pp + 1
											else
												l_ppos := l_pp
											end
										else
											l_ppos := l_pp
										end
									end
								end
							end
						end
				when 72 then -- if done | if done | if done | if done
						if (l_buf___0[(l_pp - 6)]).to_integer_32 /= 32 then
							l_pos := -1 + 78 -- skip if block
						end
				when 73 then -- if:
						if not ((l_buf___0[(l_pp - 5)]).to_integer_32 >= 48) then
							l_pos := -1 + 76 -- skip if block
						end
				when 74 then -- if:
						if (l_buf___0[(l_pp - 5)]).to_integer_32 <= 50 then
							l_pos := -1 + 77 -- goto _L___3
						else
							l_pos := -1 + 76 -- goto _L___4
						end
				when 75 then -- if block done, skip else block:
						l_pos := -1 + 78
				when 76 then -- else: | _L___4:
						if (l_buf___0[(l_pp - 5)]).to_integer_32 /= 32 then
							l_pos := -1 + 78 -- skip if block
						end
				when 77 then -- if: | _L___3:
						if (l_buf___0[(l_pp - 4)]).to_integer_32 >= 48 then
							if (l_buf___0[(l_pp - 4)]).to_integer_32 <= 57 then
								if (l_buf___0[(l_pp - 3)]).to_integer_32 = 58 then
									if (l_buf___0[(l_pp - 2)]).to_integer_32 >= 48 then
										if (l_buf___0[(l_pp - 2)]).to_integer_32 <= 53 then
											if (l_buf___0[(l_pp - 1)]).to_integer_32 >= 48 then
												if (l_buf___0[(l_pp - 1)]).to_integer_32 <= 57 then
													l_ppos := l_pp
												end
											end
										end
									end
								end
							end
						end
				when 78 then -- if done | if done | if done | if done | if done | if done | if done
						l_pp := l_pp - 1
						l_pos := -1 + 50 -- back to loop condition
				when 79 then -- loop done
						if l_ppos /= -1 then
							l_pp := l_ppos
							l_pos := -1 + 128 -- goto done
						end
				when 80 then
						l_pp := 0
				when 81 then -- loop condition:
						if not (not (l_return) and then (l_pp + 5 <= l_p)) then
							l_pos := -1 + 84 -- skip loop
						end
				when 82 then -- loop body:
						if not ((create {P_LINKS_STATIC}).casecmp (l_buf___0 + l_pp, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<DIR>")), (5).to_natural_32)).to_boolean then
							l_pp := l_pp + (4)
							from
							until
								(l_break)
							loop
								l_break := False
								if l_pp + 1 < l_p then
									if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 9 then
										if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 10 then
											if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 12 then
												if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 13 then
													if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 32 then
														l_break := True
													end
												end
											end
										end
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_pp := l_pp + 1
								end
							end
							l_break := False
							if l_pp + 1 < l_p then
								l_pos := -1 + 128 -- goto done
							end
						end
				when 83 then
						l_pp := l_pp + 1
						l_pos := -1 + 81 -- back to loop condition
				when 84 then -- loop done
						l_bn := -1
						l_bp := 0
						l_pp := 0
				when 85 then -- loop condition:
						if not (not (l_return) and then (l_pp < l_p)) then
							l_pos := -1 + 105 -- skip loop
						end
				when 86 then -- loop body:
						if not ((l_buf___0[l_pp]).to_integer_32 >= 48) then
							l_pos := -1 + 104 -- skip if block
						end
				when 87 then -- if:
						if not ((l_buf___0[l_pp]).to_integer_32 <= 57) then
							l_pos := -1 + 104 -- skip if block
						end
				when 88 then -- if:
						l_i___0 := l_pp
						from
						until
							not (not (l_break) and then (l_i___0 < l_p))
						loop
							l_break := False
							if (l_buf___0[l_i___0]).to_integer_32 < 48 then
								l_break := True
							elseif (l_buf___0[l_i___0]).to_integer_32 > 57 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						if not (l_i___0 < l_p) then
							l_pos := -1 + 103 -- skip if block
						end
				when 89 then -- if:
						if (l_buf___0[l_i___0]).to_integer_32 /= 9 then
							l_pos := -1 + 92 -- skip if block
						end
				when 90 then -- if:
						l_pos := -1 + 102 -- goto _L___6
				when 91 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 92 then -- else:
						if (l_buf___0[l_i___0]).to_integer_32 /= 10 then
							l_pos := -1 + 95 -- skip if block
						end
				when 93 then -- if:
						l_pos := -1 + 102 -- goto _L___6
				when 94 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 95 then -- else:
						if (l_buf___0[l_i___0]).to_integer_32 /= 12 then
							l_pos := -1 + 98 -- skip if block
						end
				when 96 then -- if:
						l_pos := -1 + 102 -- goto _L___6
				when 97 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 98 then -- else:
						if (l_buf___0[l_i___0]).to_integer_32 /= 13 then
							l_pos := -1 + 101 -- skip if block
						end
				when 99 then -- if:
						l_pos := -1 + 102 -- goto _L___6
				when 100 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 101 then -- else:
						if (l_buf___0[l_i___0]).to_integer_32 /= 32 then
							l_pos := -1 + 103 -- skip if block
						end
				when 102 then -- if: | _L___6:
						if l_i___0 - l_pp > l_bn then
							l_bn := l_i___0 - l_pp
							l_bp := l_pp
						end
				when 103 then -- if done | if done | if done | if done | if done
						l_pp := l_i___0
				when 104 then -- if done | if done
						from
						until
							(l_break)
						loop
							l_break := False
							if l_pp < l_p then
								if (l_buf___0[l_pp]).to_integer_32 = 9 then
									l_break := True
								elseif (l_buf___0[l_pp]).to_integer_32 = 10 then
									l_break := True
								elseif (l_buf___0[l_pp]).to_integer_32 = 12 then
									l_break := True
								elseif (l_buf___0[l_pp]).to_integer_32 = 13 then
									l_break := True
								elseif (l_buf___0[l_pp]).to_integer_32 = 32 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_pp := l_pp + 1
							end
						end
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if l_pp < l_p then
								if (l_buf___0[l_pp]).to_integer_32 /= 9 then
									if (l_buf___0[l_pp]).to_integer_32 /= 10 then
										if (l_buf___0[l_pp]).to_integer_32 /= 12 then
											if (l_buf___0[l_pp]).to_integer_32 /= 13 then
												if (l_buf___0[l_pp]).to_integer_32 /= 32 then
													l_break := True
												end
											end
										end
									end
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_pp := l_pp + 1
							end
						end
						l_break := False
						l_pos := -1 + 85 -- back to loop condition
				when 105 then -- loop done
						if l_bn >= 0 then
							l_pp := l_bp + l_bn
							from
							until
								(l_break)
							loop
								l_break := False
								if l_pp + 1 < l_p then
									if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 9 then
										if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 10 then
											if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 12 then
												if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 13 then
													if (l_buf___0[(l_pp + 1)]).to_integer_32 /= 32 then
														l_break := True
													end
												end
											end
										end
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_pp := l_pp + 1
								end
							end
							l_break := False
							if l_pp + 1 < l_p then
								l_pos := -1 + 128 -- goto done
							end
						end
				when 106 then
						l_pp := l_p - 1
						from
						until
							not (not (l_break) and then (l_pp >= 0))
						loop
							l_break := False
							if (l_buf___0[l_pp]).to_integer_32 /= 9 then
								if (l_buf___0[l_pp]).to_integer_32 /= 10 then
									if (l_buf___0[l_pp]).to_integer_32 /= 12 then
										if (l_buf___0[l_pp]).to_integer_32 /= 13 then
											if (l_buf___0[l_pp]).to_integer_32 /= 32 then
												l_break := True
											end
										end
									end
								end
							end
							if not (l_return or l_break) then
								l_pp := l_pp - 1
							end
						end
						l_break := False
						if l_pp < 0 then
							l_pos := -1 + 129 -- goto raw
						end
				when 107 then
						if not (not (l_break) and then (l_pp >= 0)) then
							l_pos := -1 + 127 -- skip loop
						end
				when 108 then -- loop body:
						l_break := False
						if (l_buf___0[l_pp]).to_integer_32 /= 9 then
							l_pos := -1 + 111 -- skip if block
						end
				when 109 then -- if:
						l_pos := -1 + 121 -- goto _L___8
				when 110 then -- if block done, skip else block:
						l_pos := -1 + 126
				when 111 then -- else:
						if (l_buf___0[l_pp]).to_integer_32 /= 10 then
							l_pos := -1 + 114 -- skip if block
						end
				when 112 then -- if:
						l_pos := -1 + 121 -- goto _L___8
				when 113 then -- if block done, skip else block:
						l_pos := -1 + 126
				when 114 then -- else:
						if (l_buf___0[l_pp]).to_integer_32 /= 12 then
							l_pos := -1 + 117 -- skip if block
						end
				when 115 then -- if:
						l_pos := -1 + 121 -- goto _L___8
				when 116 then -- if block done, skip else block:
						l_pos := -1 + 126
				when 117 then -- else:
						if (l_buf___0[l_pp]).to_integer_32 /= 13 then
							l_pos := -1 + 120 -- skip if block
						end
				when 118 then -- if:
						l_pos := -1 + 121 -- goto _L___8
				when 119 then -- if block done, skip else block:
						l_pos := -1 + 126
				when 120 then -- else:
						if (l_buf___0[l_pp]).to_integer_32 /= 32 then
							l_pos := -1 + 126 -- skip if block
						end
				when 121 then -- if: | _L___8:
						if not (l_pp < 3) then
							l_pos := -1 + 124 -- skip if block
						end
				when 122 then -- if:
						l_pos := -1 + 125 -- goto _L___7
				when 123 then -- if block done, skip else block:
						l_pos := -1 + 126
				when 124 then -- else:
						if not ((memcmp (create {CE_VOID_POINTER}.make_cast (((l_buf___0 + l_pp) - 3)), create {CE_VOID_POINTER}.make_cast (ce_string (" -> ")), (4).to_natural_32)).to_boolean) then
							l_pos := -1 + 126 -- skip if block
						end
				when 125 then -- if: | _L___7:
						if l_pp > l_p - 4 then
							l_break := True
						elseif (memcmp (create {CE_VOID_POINTER}.make_cast ((l_buf___0 + l_pp)), create {CE_VOID_POINTER}.make_cast (ce_string (" -> ")), (4).to_natural_32)).to_boolean then
							l_break := True
						end
				when 126 then -- if done | if done | if done | if done | if done | if done
						if not (l_return or l_break) then
							l_pp := l_pp - 1
						end
						l_pos := -1 + 107 -- back to loop condition
				when 127 then -- loop done
						l_break := False
				when 128 then -- done:
						a_d.item := l_pp + 1
						l_pos := -1 + 23 -- goto ppp
				when 129 then -- raw:;
						(create {P_URL_STATIC}).add_conv_str (l_str, l_sl, l_buf___0, l_p, 0)
				when 130 then;
						(create {P_LINKS_STATIC}).add_chr_to_str (l_str, l_sl, (('%N').code).to_natural_8)
						if (add_fragment (a_ce, a_pos___0.item, l_str.item, (l_sl.item).to_integer_32)).to_boolean then
							a_tr.item := 0
						end
						a_pos___0.item := a_pos___0.item + (l_sl.item).to_integer_32;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.c")), 667, create {CE_VOID_POINTER}.make_cast (l_str.item))
						l_pos := -1 + 1 -- goto again
				when 131 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	add_fragment (a_e: CE_POINTER [PD_CACHE_ENTRY]; a_offset: INTEGER_32; a_data: CE_POINTER [NATURAL_8]; a_length: INTEGER_32): INTEGER_32
		local
			l_f: CE_POINTER [PD_FRAGMENT]
			l_nf: CE_POINTER [PD_FRAGMENT]
			l_a: INTEGER_32
			l_trunc: INTEGER_32
			l_ca: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a := 0
					l_trunc := 0
					if not a_length.to_boolean then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 22 -- skip if block
					end
				when 1 then -- if:
						if not (a_offset + a_length < 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_offset + a_length < a_offset) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("cache.c"), 89]);
							(create {P_KBD_STATIC}).fatal_tty_exit
							exit (4)
						end
				when 6 then -- if done
						if not (a_offset.to_natural_32 + ((((((a_length.to_natural_32 + ((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) + {NATURAL_32} 64)).bit_or (((create {P_CACHE_STATIC}).page_size.item - 1).to_natural_32)) - ((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) - {NATURAL_32} 64) < {NATURAL_32} 0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if not (a_offset.to_natural_32 + ((((((a_length.to_natural_32 + ((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) + {NATURAL_32} 64)).bit_or (((create {P_CACHE_STATIC}).page_size.item - 1).to_natural_32)) - ((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) - {NATURAL_32} 64) < a_offset.to_natural_32) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L___0:
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("cache.c"), 90]);
							(create {P_KBD_STATIC}).fatal_tty_exit
							exit (4)
						end
				when 11 then -- if done
						if a_e.item.length < a_offset + a_length then
							a_e.item.length := a_offset + a_length
						end
						l_tmp := (create {P_CACHE_STATIC}).cache_count.item;
						(create {P_CACHE_STATIC}).cache_count.item := (create {P_CACHE_STATIC}).cache_count.item + 1
						a_e.item.count := l_tmp.to_natural_32
						l_f := create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast (a_e.item.frag.next)
				when 12 then -- loop condition:
						if not (not (l_break) and then (not l_f.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))))) then
							l_pos := -1 + 15 -- skip loop
						end
				when 13 then -- loop body:
						l_break := False
						if l_f.item.offset > a_offset then
							l_break := True
						end
						if not (l_break) and then (l_f.item.offset <= a_offset) then
							if l_f.item.offset + l_f.item.length >= a_offset then
								if a_offset + a_length > l_f.item.offset + l_f.item.length then
									if (memcmp (create {CE_VOID_POINTER}.make_cast (((l_f.item.data + a_offset) - l_f.item.offset)), create {CE_VOID_POINTER}.make_cast (a_data), ((l_f.item.offset + l_f.item.length) - a_offset).to_natural_32)).to_boolean then
										l_trunc := 1
									end
									l_a := 1
									if (a_offset - l_f.item.offset) + a_length <= l_f.item.real_length then
										a_e.item.data_size := a_e.item.data_size + ((a_offset + a_length) - (l_f.item.offset + l_f.item.length));
										(create {P_CACHE_STATIC}).cache_size.item := (create {P_CACHE_STATIC}).cache_size.item + ((a_offset + a_length) - (l_f.item.offset + l_f.item.length))
										l_f.item.length := (a_offset - l_f.item.offset) + a_length
									else
										a_e.item.data_size := a_e.item.data_size + (-((l_f.item.offset + l_f.item.length) - a_offset));
										(create {P_CACHE_STATIC}).cache_size.item := (create {P_CACHE_STATIC}).cache_size.item + (-((l_f.item.offset + l_f.item.length) - a_offset))
										l_f.item.length := a_offset - l_f.item.offset
										l_f := l_f.item.next
										l_break := True
									end
								elseif (memcmp (create {CE_VOID_POINTER}.make_cast (((l_f.item.data + a_offset) - l_f.item.offset)), create {CE_VOID_POINTER}.make_cast (a_data), a_length.to_natural_32)).to_boolean then
									l_trunc := 1
								end
								if not (l_break) then
									memcpy (create {CE_VOID_POINTER}.make_cast (((l_f.item.data + a_offset) - l_f.item.offset)), create {CE_VOID_POINTER}.make_cast (a_data), a_length.to_natural_32).do_nothing
									l_pos := -1 + 21 -- goto ch_o
								end
							end
						end
				when 14 then
						if not (l_break) then
							l_f := l_f.item.next
						end
						l_pos := -1 + 12 -- back to loop condition
				when 15 then -- loop done
						l_break := False
						l_ca := ((((((a_length.to_natural_32 + ((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) + {NATURAL_32} 64)).bit_or (((create {P_CACHE_STATIC}).page_size.item - 1).to_natural_32)) - ((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) - {NATURAL_32} 64).to_integer_32
						if not (l_ca.to_natural_32 > ({NATURAL_32} 2_147_483_647 - (create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L___1
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 18 then -- else:
						if not (l_ca < 0) then
							l_pos := -1 + 20 -- skip if block
						end
				when 19 then -- if: | _L___1:
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("cache.c"), 119]);
							(create {P_KBD_STATIC}).fatal_tty_exit
							exit (4)
						end
				when 20 then -- if done
						l_nf := create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 120, (((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32 + l_ca.to_natural_32).to_natural_32)))
						l_a := 1
						a_e.item.data_size := a_e.item.data_size + a_length;
						(create {P_CACHE_STATIC}).cache_size.item := (create {P_CACHE_STATIC}).cache_size.item + a_length
						l_nf.item.offset := a_offset
						l_nf.item.length := a_length
						l_nf.item.real_length := ((((((a_length.to_natural_32 + ((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) + {NATURAL_32} 64)).bit_or (((create {P_CACHE_STATIC}).page_size.item - 1).to_natural_32)) - ((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) - {NATURAL_32} 64).to_integer_32
						memcpy (create {CE_VOID_POINTER}.make_cast ((l_nf.item.data)), create {CE_VOID_POINTER}.make_cast (a_data), a_length.to_natural_32).do_nothing
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_f.item.prev))
							l_nf.item.next := (l_f.item.prev).item.next
							l_nf.item.prev := l_f.item.prev;
							(l_f.item.prev).item.next := l_nf;
							(l_nf.item.next).item.prev := l_nf;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_f.item.prev))
							l_break := True
						end
						l_break := False
						l_f := l_nf
				when 21 then -- ch_o:
						from
						until
							(l_break)
						loop
							l_break := False
							if not (l_f.item.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))) then
								if not (l_f.item.offset + l_f.item.length > (l_f.item.next).item.offset) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								if l_f.item.offset + l_f.item.length < (l_f.item.next).item.offset + (l_f.item.next).item.length then
									l_nf := create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 132, create {CE_VOID_POINTER}.make_cast (l_f), (((((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32 + ((l_f.item.next).item.offset).to_natural_32) - (l_f.item.offset).to_natural_32) + ((l_f.item.next).item.length).to_natural_32).to_natural_32)));
									(l_nf.item.prev).item.next := l_nf;
									(l_nf.item.next).item.prev := l_nf
									l_f := l_nf
									if (memcmp (create {CE_VOID_POINTER}.make_cast (((l_f.item.data + (l_f.item.next).item.offset) - l_f.item.offset)), create {CE_VOID_POINTER}.make_cast (((l_f.item.next).item.data)), ((l_f.item.offset + l_f.item.length) - (l_f.item.next).item.offset).to_natural_32)).to_boolean then
										l_trunc := 1
									end
									memcpy (create {CE_VOID_POINTER}.make_cast ((l_f.item.data + l_f.item.length)), create {CE_VOID_POINTER}.make_cast (((((l_f.item.next).item.data + l_f.item.offset) + l_f.item.length) - (l_f.item.next).item.offset)), ((((l_f.item.next).item.offset + (l_f.item.next).item.length) - l_f.item.offset) - l_f.item.length).to_natural_32).do_nothing
									a_e.item.data_size := a_e.item.data_size + ((((l_f.item.next).item.offset + (l_f.item.next).item.length) - l_f.item.offset) - l_f.item.length);
									(create {P_CACHE_STATIC}).cache_size.item := (create {P_CACHE_STATIC}).cache_size.item + ((((l_f.item.next).item.offset + (l_f.item.next).item.length) - l_f.item.offset) - l_f.item.length)
									l_tmp___5 := ((l_f.item.next).item.offset + (l_f.item.next).item.length) - l_f.item.offset
									l_f.item.real_length := l_tmp___5
									l_f.item.length := l_tmp___5
								elseif (memcmp (create {CE_VOID_POINTER}.make_cast (((l_f.item.data + (l_f.item.next).item.offset) - l_f.item.offset)), create {CE_VOID_POINTER}.make_cast (((l_f.item.next).item.data)), ((l_f.item.next).item.length).to_natural_32)).to_boolean then
									l_trunc := 1
								end
								l_nf := l_f.item.next;
								(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_nf));
								(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_nf.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_nf.item.prev);
								(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_nf.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_nf.item.next);
								(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_nf))
								a_e.item.data_size := a_e.item.data_size + (-l_nf.item.length);
								(create {P_CACHE_STATIC}).cache_size.item := (create {P_CACHE_STATIC}).cache_size.item + (-l_nf.item.length);
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 146, create {CE_VOID_POINTER}.make_cast (l_nf))
							end
						end
						l_break := False
						if l_trunc.to_boolean then
							truncate_entry (a_e, a_offset + a_length, 0)
						end
						Result := l_a
				when 22 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	truncate_entry (a_e: CE_POINTER [PD_CACHE_ENTRY]; a_off: INTEGER_32; a_final: INTEGER_32)
		require
			not a_e.is_void
		local
			l_modified: INTEGER_32
			l_f: CE_POINTER [PD_FRAGMENT]
			l_g: CE_POINTER [PD_FRAGMENT]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_modified := 0
					if a_e.item.length > a_off then
						a_e.item.length := a_off
						a_e.item.incomplete := 1
					end
					l_f := create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast (a_e.item.frag.next)
				when 1 then -- loop condition:
					if not (not (l_return) and then (not l_f.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))))) then
						l_pos := -1 + 6 -- skip loop
					end
				when 2 then -- loop body:
						if not (l_f.item.offset >= a_off) then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | del:
						from
						until
							l_f.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_e.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))
						loop
							l_modified := 1
							a_e.item.data_size := a_e.item.data_size + (-l_f.item.length);
							(create {P_CACHE_STATIC}).cache_size.item := (create {P_CACHE_STATIC}).cache_size.item + (-l_f.item.length)
							l_g := l_f.item.next;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_f));
							(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_f.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_f.item.prev);
							(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_f.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_f.item.next);
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_f));
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 207, create {CE_VOID_POINTER}.make_cast (l_f))
							l_f := l_g
						end
						l_pos := -1 + 6 -- goto ret
				when 4 then
						if l_f.item.offset + l_f.item.length > a_off then
							l_modified := 1
							a_e.item.data_size := a_e.item.data_size + (-((l_f.item.offset + l_f.item.length) - a_off));
							(create {P_CACHE_STATIC}).cache_size.item := (create {P_CACHE_STATIC}).cache_size.item + (-((l_f.item.offset + l_f.item.length) - a_off))
							l_f.item.length := a_off - l_f.item.offset
							if a_final.to_boolean then
								l_g := create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 217, create {CE_VOID_POINTER}.make_cast (l_f), (((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32 + (l_f.item.length).to_natural_32).to_natural_32)));
								(l_g.item.next).item.prev := l_g;
								(l_g.item.prev).item.next := l_g
								l_f := l_g
								l_f.item.real_length := l_f.item.length
							end
							l_f := l_f.item.next
							l_pos := -1 + 3 -- goto del
						end
				when 5 then
						l_f := l_f.item.next
						l_pos := -1 + 1 -- back to loop condition
				when 6 then -- ret:
					if l_modified.to_boolean then
						l_tmp___0 := (create {P_CACHE_STATIC}).cache_count.item;
						(create {P_CACHE_STATIC}).cache_count.item := (create {P_CACHE_STATIC}).cache_count.item + 1
						a_e.item.count := l_tmp___0.to_natural_32
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	is_date (a_data: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_data.is_void
		local
			l_data: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_data := a_data
					if (l_data[0]).to_integer_32 = 32 then
						l_data := l_data - 1
					end
					if not ((l_data[0]).to_integer_32 >= 48) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (l_data[0]).to_integer_32 <= 57 then
							if (l_data[-1]).to_integer_32 >= 48 then
								if (l_data[-1]).to_integer_32 <= 57 then
									l_data := l_data - (2)
								else
									l_pos := -1 + 3 -- goto _L___1
								end
							else
								l_pos := -1 + 3 -- goto _L___1
							end
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___1:
						if (l_data[0]).to_integer_32 >= 49 then
							if (l_data[0]).to_integer_32 <= 57 then
								if (l_data[-1]).to_integer_32 = 32 then
									l_data := l_data - (1 + ((l_data[-2]).to_integer_32 = 32).to_integer)
								else
									Result := 0
									l_return := True
								end
							else
								Result := 0
								l_return := True
							end
						else
							Result := 0
							l_return := True
						end
				when 4 then
					if not l_return and then ((l_data[0]).to_integer_32 = 58) then
						Result := 1
						l_return := True
					end
					if not l_return and then ((l_data[0]).to_integer_32 /= 32) then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 5 then -- if:
						if not ((l_data[-1]).to_integer_32 < 97) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L___2
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if not ((l_data[-1]).to_integer_32 > 122) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L___2:
						if (l_data[-1]).to_integer_32 < 65 then
							Result := 0
							l_return := True
						elseif (l_data[-1]).to_integer_32 > 90 then
							Result := 0
							l_return := True
						end
				when 10 then -- if done | if done
					if not l_return then
						Result := 1
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_http_server_bugs (a_url: CE_POINTER [NATURAL_8]; a_info: CE_POINTER [PD_HTTP_CONNECTION_INFO]; a_head___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_server: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			l_bugs: INTEGER_32
			l_return: BOOLEAN
		do
			if not ((create {P_DEFAULT_STATIC}).http_bugs.item.item.allow_blacklist).to_boolean then
				Result := 0
				l_return := True
			elseif (a_info.item.http10).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_server := (create {P_HTTP_STATIC}).parse_http_header (a_head___0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Server")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
				if l_server.is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_bugs := 0
				l_i := 0
				from
				until
					(buggy_servers.item[l_i].name).is_void
				loop
					if (not (strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_server), create {CE_INTEGER_8_POINTER}.make_cast (buggy_servers.item[l_i].name))).is_void) then
						l_bugs := (l_bugs).bit_or ((buggy_servers.item[l_i].bugs))
					end
					l_i := l_i + 1
				end
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 147, create {CE_VOID_POINTER}.make_cast (l_server))
				if l_bugs.to_boolean then
					l_server := (create {P_URL_STATIC}).get_host_name (a_url)
					if (not l_server.is_void) then
						add_blacklist_entry (l_server, l_bugs);
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http.c")), 150, create {CE_VOID_POINTER}.make_cast (l_server))
						Result := ((l_bugs).bit_and (-9))
						l_return := True
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	add_blacklist_entry (a_host: CE_POINTER [NATURAL_8]; a_flags: INTEGER_32)
		local
			l_b: CE_POINTER [PD_BLACKLIST_ENTRY]
			l_return, l_break: BOOLEAN
		do
			l_b := create {CE_CLASS_POINTER [PD_BLACKLIST_ENTRY]}.make_cast ((create {P_SCHED_STATIC}).blacklist.item.item.next)
			from
			until
				not (not (l_return) and then (not l_b.is_equal ((create {P_SCHED_STATIC}).blacklist.item)))
			loop
				if not (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_host), create {CE_INTEGER_8_POINTER}.make_cast ((l_b.item.host)))).to_boolean then
					l_b.item.flags := (l_b.item.flags).bit_or (a_flags)
					l_return := True
				end
				if not l_return then
					l_b := l_b.item.next
				end
			end
			if not l_return then
				l_b := create {CE_CLASS_POINTER [PD_BLACKLIST_ENTRY]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 778, ((create {PD_BLACKLIST_ENTRY}.make).structure_size.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_host)))) + {NATURAL_32} 1)))
				l_b.item.flags := a_flags
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_b.item.host)), create {CE_INTEGER_8_POINTER}.make_cast (a_host)).do_nothing
				from
				until
					(l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_SCHED_STATIC}).blacklist.item)))
					l_b.item.next := (create {CE_CLASS_POINTER [PD_BLACKLIST_ENTRY]}.make_cast (((create {P_SCHED_STATIC}).blacklist.item))).item.next
					l_b.item.prev := create {CE_CLASS_POINTER [PD_BLACKLIST_ENTRY]}.make_cast (((create {P_SCHED_STATIC}).blacklist.item));
					(create {CE_CLASS_POINTER [PD_BLACKLIST_ENTRY]}.make_cast (((create {P_SCHED_STATIC}).blacklist.item))).item.next := l_b;
					(l_b.item.next).item.prev := l_b;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_SCHED_STATIC}).blacklist.item)))
					l_break := True
				end
				l_break := False
			end
		end

	is_line_in_buffer (a_rb: CE_POINTER [PD_READ_BUFFER]): INTEGER_32
		require
			not a_rb.is_void
		local
			l_l: INTEGER_32
			l_return: BOOLEAN
		do
			l_l := 0
			from
			until
				not (not (l_return) and then (l_l < a_rb.item.len))
			loop
				if (a_rb.item.data[l_l]).to_integer_32 = 10 then
					Result := (l_l + 1)
					l_return := True
				end
				if not l_return and then (l_l < a_rb.item.len - 1) then
					if (a_rb.item.data[l_l]).to_integer_32 = 13 then
						if (a_rb.item.data[l_l + 1]).to_integer_32 = 10 then
							Result := (l_l + 2)
							l_return := True
						end
					end
				end
				if not l_return and then (l_l = a_rb.item.len - 1) then
					if (a_rb.item.data[l_l]).to_integer_32 = 13 then
						Result := 0
						l_return := True
					end
				end
				if not l_return and then ((a_rb.item.data[l_l]).to_integer_32 < 32) then
					Result := (-1)
					l_return := True
				end
				if not l_return then
					l_l := l_l + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	get_header (a_rb: CE_POINTER [PD_READ_BUFFER]): INTEGER_32
		require
			not a_rb.is_void
		local
			l_i: INTEGER_32
			l_a: NATURAL_8
			l_return: BOOLEAN
		do
			l_i := 0
			from
			until
				not (not (l_return) and then (l_i < a_rb.item.len))
			loop
				l_a := a_rb.item.data[l_i]
				if not l_a.to_boolean then
					Result := (-1)
					l_return := True
				end
				if not l_return and then (l_i < a_rb.item.len - 1) then
					if l_a.to_integer_32 = 10 then
						if (a_rb.item.data[l_i + 1]).to_integer_32 = 10 then
							Result := (l_i + 2)
							l_return := True
						end
					end
				end
				if not l_return and then (l_i < a_rb.item.len - 3) then
					if l_a.to_integer_32 = 13 then
						if (a_rb.item.data[l_i + 1]).to_integer_32 /= 10 then
							Result := (-1)
							l_return := True
						end
						if not l_return and then ((a_rb.item.data[l_i + 2]).to_integer_32 = 13) then
							if (a_rb.item.data[l_i + 3]).to_integer_32 /= 10 then
								Result := (-1)
								l_return := True
							end
							if not l_return then
								Result := (l_i + 4)
								l_return := True
							end
						end
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	try_to_suspend_connection (a_c: CE_POINTER [PD_CONNECTION]; a_ho: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_pri: INTEGER_32
			l_d: CE_POINTER [PD_CONNECTION]
			l_h: CE_POINTER [NATURAL_8]
			l_return, l_continue: BOOLEAN
		do
			l_pri := ((create {P_LINKS_STATIC}).getpri (a_c))
			l_d := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast ((create {P_SCHED_STATIC}).queue.item.item.prev)
			from
			until
				not (not (l_return) and then (not l_d.is_equal ((create {P_SCHED_STATIC}).queue.item)))
			loop
				l_continue := False
				if ((create {P_LINKS_STATIC}).getpri (l_d)) <= l_pri then
					Result := (-1)
					l_return := True
				end
				if not l_return then
					if l_d.item.state = 0 then
						l_continue := True
					end
					if not (l_return or l_continue) and then (l_d.item.unrestartable = 2) then
						if ((create {P_LINKS_STATIC}).getpri (l_d)) < 5 then
							l_continue := True
						end
					end
					if not (l_return or l_continue) and then (not a_ho.is_void) then
						l_h := (create {P_URL_STATIC}).get_host_name (l_d.item.url)
						if l_h.is_void then
							l_continue := True
						end
						if not (l_return or l_continue) then
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_h), create {CE_INTEGER_8_POINTER}.make_cast (a_ho))).to_boolean then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 353, create {CE_VOID_POINTER}.make_cast (l_h))
								l_continue := True
							end
						end
						if not (l_return or l_continue) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 356, create {CE_VOID_POINTER}.make_cast (l_h))
						end
					end
					if not (l_return or l_continue) then
						l_d.item.suspend_connection
						Result := 0
						l_return := True
					end
					if (not l_return) then
						l_d := l_d.item.prev
					end
				end
			end
			if not l_return then
				l_continue := False
				Result := (-1)
			end
		end

	del_blacklist_entry (a_host: CE_POINTER [NATURAL_8]; a_flags: INTEGER_32)
		local
			l_b: CE_POINTER [PD_BLACKLIST_ENTRY]
			l_return: BOOLEAN
		do
			l_b := create {CE_CLASS_POINTER [PD_BLACKLIST_ENTRY]}.make_cast ((create {P_SCHED_STATIC}).blacklist.item.item.next)
			from
			until
				not (not (l_return) and then (not l_b.is_equal ((create {P_SCHED_STATIC}).blacklist.item)))
			loop
				if not (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_host), create {CE_INTEGER_8_POINTER}.make_cast ((l_b.item.host)))).to_boolean then
					l_b.item.flags := (l_b.item.flags).bit_and (((a_flags).bit_not))
					if not (l_b.item.flags).to_boolean then
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_b));
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_b.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_b.item.prev);
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_b.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_b.item.next);
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_b));
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 791, create {CE_VOID_POINTER}.make_cast (l_b))
					end
					l_return := True
				end
				if not l_return then
					l_b := l_b.item.next
				end
			end
			if not l_return then
			end
		end

	get_blacklist_flags (a_host: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_b: CE_POINTER [PD_BLACKLIST_ENTRY]
			l_return: BOOLEAN
		do
			l_b := create {CE_CLASS_POINTER [PD_BLACKLIST_ENTRY]}.make_cast ((create {P_SCHED_STATIC}).blacklist.item.item.next)
			from
			until
				not (not (l_return) and then (not l_b.is_equal ((create {P_SCHED_STATIC}).blacklist.item)))
			loop
				if not (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_host), create {CE_INTEGER_8_POINTER}.make_cast ((l_b.item.host)))).to_boolean then
					Result := (l_b.item.flags)
					l_return := True
				end
				if not l_return then
					l_b := l_b.item.next
				end
			end
			if not l_return then
				Result := 0
			end
		end

	smbc_get_num (a_text: CE_POINTER [NATURAL_8]; a_ptr: CE_POINTER [INTEGER_32]; a_res: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_text.is_void
			not a_ptr.is_void
		local
			l_num: INTEGER_32
			l_dec: INTEGER_32
			l_dec_order: INTEGER_32
			l_unit: INTEGER_32
			l_was_digit: INTEGER_32
			l_i: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i := a_ptr.item
			from
			until
				(l_break)
			loop
				l_break := False
				if (a_text[l_i]).to_integer_32 /= 32 then
					if (a_text[l_i]).to_integer_32 /= 9 then
						l_break := True
					end
				end
				if not (l_break) then
					l_i := l_i + 1
				end
			end
			l_break := False
			l_was_digit := 0
			l_num := (0).to_integer_32
			from
			until
				(l_break)
			loop
				l_break := False
				if (a_text[l_i]).to_integer_32 >= 48 then
					if not ((a_text[l_i]).to_integer_32 <= 57) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_num := (l_num * 10 + (a_text[l_i]).to_integer_32) - 48
					l_i := l_i + 1
					l_was_digit := 1
				end
			end
			l_break := False
			l_dec := 0
			l_dec_order := 1
			if (a_text[l_i]).to_integer_32 = 46 then
				l_i := l_i + 1
				from
				until
					(l_break)
				loop
					l_break := False
					if (a_text[l_i]).to_integer_32 >= 48 then
						if not ((a_text[l_i]).to_integer_32 <= 57) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						if l_dec_order < 1_000_000 then
							l_dec := (l_dec * 10 + (a_text[l_i]).to_integer_32) - 48
							l_dec_order := l_dec_order * (10)
						end
						l_i := l_i + 1
						l_was_digit := 1
					end
				end
				l_break := False
			end
			if not l_was_digit.to_boolean then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if ((create {P_LINKS_STATIC}).upcase (a_text[l_i])).to_integer_32 = 66 then
					l_unit := 1
				elseif ((create {P_LINKS_STATIC}).upcase (a_text[l_i])).to_integer_32 = 75 then
					l_unit := (1).bit_shift_left (10)
				elseif ((create {P_LINKS_STATIC}).upcase (a_text[l_i])).to_integer_32 = 77 then
					l_unit := (1).bit_shift_left (20)
				elseif ((create {P_LINKS_STATIC}).upcase (a_text[l_i])).to_integer_32 = 71 then
					l_unit := (1).bit_shift_left (30)
				else
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_i := l_i + 1
				a_ptr.item := l_i
				a_res.item := ((l_num * l_unit.to_integer_32).to_double + l_dec.to_double * (l_unit.to_double / l_dec_order.to_double)).truncated_to_integer
				Result := 0
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			count := a_other.count
			url := a_other.url
			running := a_other.running
			state := a_other.state
			prev_error := a_other.prev_error
			from2 := a_other.from2
			pri := a_other.pri.twin
			no_cache := a_other.no_cache
			sock1 := a_other.sock1
			sock2 := a_other.sock2
			dnsquery := a_other.dnsquery
			pid := a_other.pid
			tries := a_other.tries
			statuss := a_other.statuss.twin
			info := a_other.info
			buffer := a_other.buffer
			conn_func := a_other.conn_func
			cache := a_other.cache
			received := a_other.received
			est_length := a_other.est_length
			unrestartable := a_other.unrestartable
			prg := a_other.prg.twin
			timer := a_other.timer
			detached := a_other.detached
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				count = a_other.count and
				url.is_equal (a_other.url) and
				running = a_other.running and
				state = a_other.state and
				prev_error = a_other.prev_error and
				from2 = a_other.from2 and
				pri.is_equal (a_other.pri) and
				no_cache = a_other.no_cache and
				sock1 = a_other.sock1 and
				sock2 = a_other.sock2 and
				dnsquery.is_equal (a_other.dnsquery) and
				pid = a_other.pid and
				tries = a_other.tries and
				statuss.is_equal (a_other.statuss) and
				info.is_equal (a_other.info) and
				buffer.is_equal (a_other.buffer) and
				conn_func.is_equal (a_other.conn_func) and
				cache.is_equal (a_other.cache) and
				received = a_other.received and
				est_length = a_other.est_length and
				unrestartable = a_other.unrestartable and
				prg.is_equal (a_other.prg) and
				timer = a_other.timer and
				detached = a_other.detached
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("count"),
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("running"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("prev_error"),
					create {CE_STRUCTURE_FIELD}.make ("from2"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("pri", <<6>>),
					create {CE_STRUCTURE_FIELD}.make ("no_cache"),
					create {CE_STRUCTURE_FIELD}.make ("sock1"),
					create {CE_STRUCTURE_FIELD}.make ("sock2"),
					create {CE_STRUCTURE_FIELD}.make ("dnsquery"),
					create {CE_STRUCTURE_FIELD}.make ("pid"),
					create {CE_STRUCTURE_FIELD}.make ("tries"),
					create {CE_STRUCTURE_FIELD}.make ("statuss"),
					create {CE_STRUCTURE_FIELD}.make ("info"),
					create {CE_STRUCTURE_FIELD}.make ("buffer"),
					create {CE_STRUCTURE_FIELD}.make ("conn_func"),
					create {CE_STRUCTURE_FIELD}.make ("cache"),
					create {CE_STRUCTURE_FIELD}.make ("received"),
					create {CE_STRUCTURE_FIELD}.make ("est_length"),
					create {CE_STRUCTURE_FIELD}.make ("unrestartable"),
					create {CE_STRUCTURE_FIELD}.make ("prg"),
					create {CE_STRUCTURE_FIELD}.make ("timer"),
					create {CE_STRUCTURE_FIELD}.make ("detached")
				>>)
			init_structure_info
		end

end
