class
	P_EX_GETLN_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_LIBINTL_STATIC
	S_CTYPE_STATIC
	S_STDIO_STATIC
	S_LIBIO_STATIC

feature {ANY} -- public attributes

	ccline: CE_STATIC [CE_ARRAY [PD_CMDLINE_INFO]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CMDLINE_INFO]}.make (<<1>>)
		end

	new_cmdpos: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	history: CE_STATIC [CE_ARRAY [CE_POINTER [PD_HIST_ENTRY]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [PD_HIST_ENTRY]}.make_initialized (<<
					create {CE_CLASS_POINTER [PD_HIST_ENTRY]}.make_shared (default_pointer),
					create {CE_CLASS_POINTER [PD_HIST_ENTRY]}.make_shared (default_pointer),
					create {CE_CLASS_POINTER [PD_HIST_ENTRY]}.make_shared (default_pointer),
					create {CE_CLASS_POINTER [PD_HIST_ENTRY]}.make_shared (default_pointer),
					create {CE_CLASS_POINTER [PD_HIST_ENTRY]}.make_shared (default_pointer)
				>>)
		end

	hisidx: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					-1, -1, -1, -1, -1
				>>)
		end

	hisnum: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					0, 0, 0, 0, 0
				>>)
		end

	hislen: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	prev_ccline: CE_STATIC [CE_ARRAY [PD_CMDLINE_INFO]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CMDLINE_INFO]}.make (<<1>>)
		end

	prev_ccline_used: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	history_names: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("cmd"),
					ce_string ("search"),
					ce_string ("expr"),
					ce_string ("input"),
					ce_string ("debug"),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				>>)
		end

	last_maptick: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

feature {ANY} -- public routines

	getcmdline (a_firstc: INTEGER_32; a_count___2: INTEGER_32; a_indent: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_firstc: INTEGER_32
			l_c: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_gotesc: INTEGER_32
			l_do_abbr: INTEGER_32
			l_lookfor: CE_POINTER [NATURAL_8]
			l_hiscnt: INTEGER_32
			l_histype: INTEGER_32
			l_old_cursor: PD_POS_T
			l_old_curswant: INTEGER_32
			l_old_leftcol___0: INTEGER_32
			l_old_topline___0: INTEGER_32
			l_old_topfill___0: INTEGER_32
			l_old_botline: INTEGER_32
			l_did_incsearch: INTEGER_32
			l_incsearch_postponed: INTEGER_32
			l_did_wild_list: INTEGER_32
			l_wim_index: INTEGER_32
			l_res: INTEGER_32
			l_save_msg_scroll: INTEGER_32
			l_save_State: INTEGER_32
			l_some_key_typed: INTEGER_32
			l_ignore_drag_release: INTEGER_32
			l_break_ctrl_c: INTEGER_32
			l_xpc: CE_ARRAY [PD_EXPAND]
			l_b_im_ptr: CE_POINTER [INTEGER_32]
			l_save_ccline: CE_ARRAY [PD_CMDLINE_INFO]
			l_tmp: INTEGER_32
			l_skt: INTEGER_32
			l_old_RedrawingDisabled: INTEGER_32
			l_found: INTEGER_32
			l_upseg: CE_ARRAY [NATURAL_8]
			l_found___0: INTEGER_32
			l_found___1: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_p_wmnu_save: INTEGER_32
			l_tmp___12: INTEGER_32
			l_p___1: CE_POINTER [NATURAL_8]
			l_tmp___24: INTEGER_32
			l_tmp___25: INTEGER_32
			l_tmp___26: INTEGER_32
			l_tmp___27: INTEGER_32
			l_tmp___29: INTEGER_32
			l_tmp___30: INTEGER_32
			l_button: INTEGER_32
			l_is_click: CE_ARRAY [INTEGER_32]
			l_is_drag: CE_ARRAY [INTEGER_32]
			l_tmp___44: CE_POINTER [INTEGER_8]
			l_tmp___47: INTEGER_32
			l_p___2: CE_POINTER [NATURAL_8]
			l_len___0: INTEGER_32
			l_old_firstc: INTEGER_32
			l_tmp___56: INTEGER_32
			l_tmp___58: CE_POINTER [NATURAL_8]
			l_end_pos: PD_POS_T
			l_tm: CE_ARRAY [SD_TIMEVAL]
			l_save_pos: PD_POS_T
			l_tmp___61: INTEGER_32
			l_p___3: CE_POINTER [NATURAL_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_EXPAND]} l_xpc.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_CMDLINE_INFO]} l_save_ccline.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_upseg.make (<<5>>)
			create {CE_INTEGER_32_ARRAY} l_is_click.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_is_drag.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_tm.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_firstc := a_firstc
					l_gotesc := 0
					l_lookfor := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_did_incsearch := 0
					l_incsearch_postponed := 0
					l_did_wild_list := 0
					l_wim_index := 0
					l_save_msg_scroll := (create {P_GLOBALS_STATIC}).msg_scroll.item
					l_save_State := (create {P_GLOBALS_STATIC}).State.item
					l_some_key_typed := 0
					l_ignore_drag_release := 1
					l_break_ctrl_c := 0
					l_b_im_ptr := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
					if l_firstc = -1 then
						l_firstc := ('%/0/').code
						l_break_ctrl_c := 1
					end
					ccline.item.item.overstrike := 0
					l_old_cursor := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
					l_old_curswant := (create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant
					l_old_leftcol___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol
					l_old_topline___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
					l_old_topfill___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
					l_old_botline := (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline
					if l_firstc = 64 then
						ccline.item.item.cmdfirstc := 0
					else
						ccline.item.item.cmdfirstc := l_firstc
					end
					if l_firstc > 0 then
						ccline.item.item.cmdindent := a_indent
					else
						ccline.item.item.cmdindent := 0
					end
					if ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
						l_tmp := 250
					else
						l_tmp := a_indent + 1
					end
					alloc_cmdbuff (l_tmp)
					if (ccline.item.item.cmdbuff).is_void then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 302 -- skip if block
					end
				when 1 then -- if:
						ccline.item.item.cmdpos := 0
						ccline.item.item.cmdlen := ccline.item.item.cmdpos
						ccline.item.item.cmdbuff[0] := (('%/0/').code).to_natural_8
						if l_firstc <= 0 then
							(create {P_MISC2_STATIC}).copy_spaces (ccline.item.item.cmdbuff, a_indent.to_natural_32)
							ccline.item.item.cmdbuff[a_indent] := (('%/0/').code).to_natural_8
							ccline.item.item.cmdpos := a_indent
							ccline.item.item.cmdspos := a_indent
							ccline.item.item.cmdlen := a_indent
						end
						l_xpc.item.ExpandInit
						ccline.item.item.xpc := l_xpc;
						(create {P_GLOBALS_STATIC}).redir_off.item := 1
						if not ((create {P_GLOBALS_STATIC}).cmd_silent.item).to_boolean then
							l_i___0 := (create {P_GLOBALS_STATIC}).msg_scrolled.item;
							(create {P_GLOBALS_STATIC}).msg_scrolled.item := 0
							gotocmdline (1);
							(create {P_GLOBALS_STATIC}).msg_scrolled.item := (create {P_GLOBALS_STATIC}).msg_scrolled.item + l_i___0
							redrawcmdprompt
							set_cmdspos
						end
						l_xpc.item.xp_context := 0
						l_xpc.item.xp_backslash := 0
						l_xpc.item.xp_shell := 0
						if (ccline.item.item.input_fn).to_boolean then
							l_xpc.item.xp_context := ccline.item.item.xp_context
							l_xpc.item.xp_pattern := ccline.item.item.cmdbuff
							l_xpc.item.xp_arg := ccline.item.item.xp_arg
						end
						(create {P_GLOBALS_STATIC}).msg_scroll.item := 0;
						(create {P_GLOBALS_STATIC}).State.item := 8
						if l_firstc /= 47 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						if l_firstc /= 63 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if l_firstc /= 64 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_imsearch = -1 then
							l_b_im_ptr := create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_iminsert"))
						else
							l_b_im_ptr := create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_imsearch"))
						end
						if l_b_im_ptr.item = 1 then
							(create {P_GLOBALS_STATIC}).State.item := ((create {P_GLOBALS_STATIC}).State.item).bit_or ((32))
						end
						(create {P_MBYTE_STATIC}).im_set_active ((l_b_im_ptr.item = 2).to_integer)
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						if ((create {P_OPTION_STATIC}).p_imcmdline.item.item).to_boolean then
							(create {P_MBYTE_STATIC}).im_set_active (1)
						end
				when 11 then -- if done | if done;
						(create {P_TERM_STATIC}).setmouse;
						(create {P_UI_STATIC}).ui_cursor_shape;
						(create {P_TERM_STATIC}).settmode (2)
						init_history
						l_hiscnt := hislen.item
						l_histype := hist_char2type (l_firstc);
						(create {P_DIGRAPH_STATIC}).do_digraph (-1).do_nothing
				when 12 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 291 -- skip loop
						end
				when 13 then -- loop body:
						l_break := False
						l_continue := False;
						(create {P_GLOBALS_STATIC}).redir_off.item := 1;
						(create {P_GLOBALS_STATIC}).dont_scroll.item := 0;
						(create {P_GLOBALS_STATIC}).quit_more.item := 0
						cursorcmd
						from
						until
							(l_break)
						loop
							l_break := False
							l_c := (create {P_GETCHAR_STATIC}).safe_vgetc
							if l_c /= -(253 + ((53).bit_shift_left (8))) then
								l_break := True
							end
						end
						l_break := False
						if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
							l_some_key_typed := 1
						end
						if l_c /= 3 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if l_c /= (create {P_GLOBALS_STATIC}).intr_char.item then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L___0:
						if l_firstc /= 64 then
							if not l_break_ctrl_c.to_boolean then
								if not ((create {P_GLOBALS_STATIC}).global_busy.item).to_boolean then
									(create {P_GLOBALS_STATIC}).got_int.item := 0
								end
							end
						end
				when 18 then -- if done
						if not l_lookfor.is_void then
							if l_c /= -(253 + ((5).bit_shift_left (8))) then
								if l_c /= -(253 + ((4).bit_shift_left (8))) then
									if l_c /= -(107 + ((100).bit_shift_left (8))) then
										if l_c /= -(107 + ((117).bit_shift_left (8))) then
											if l_c /= -(107 + ((78).bit_shift_left (8))) then
												if l_c /= -(107 + ((80).bit_shift_left (8))) then
													if l_c /= -(75 + ((53).bit_shift_left (8))) then
														if l_c /= -(75 + ((51).bit_shift_left (8))) then
															if l_c /= -(107 + ((108).bit_shift_left (8))) then
																if l_c /= -(107 + ((114).bit_shift_left (8))) then
																	if l_xpc.item.xp_numfiles > 0 then
																		(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_lookfor))
																		l_lookfor := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
																	elseif l_c /= 16 then
																		if l_c /= 14 then
																			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_lookfor))
																			l_lookfor := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
																		end
																	end
																end
															end
														end
													end
												end
											end
										end
									end
								end
							end
						end
						if l_c.to_integer_32 /= (create {P_OPTION_STATIC}).p_wc.item.item then
							if l_c = -(107 + ((66).bit_shift_left (8))) then
								if l_xpc.item.xp_numfiles > 0 then
									l_c := 16
								end
							end
						end
						if l_did_wild_list.to_boolean then
							if ((create {P_OPTION_STATIC}).p_wmnu.item.item).to_boolean then
								if l_c = -(107 + ((108).bit_shift_left (8))) then
									l_c := 16
								elseif l_c = -(107 + ((114).bit_shift_left (8))) then
									l_c := 14
								end
							end
						end
						if l_xpc.item.xp_context = 21 then
							if ((create {P_OPTION_STATIC}).p_wmnu.item.item).to_boolean then
								if ccline.item.item.cmdpos > 1 then
									if (ccline.item.item.cmdbuff[(ccline.item.item.cmdpos - 1)]).to_integer_32 = 46 then
										if (ccline.item.item.cmdbuff[(ccline.item.item.cmdpos - 2)]).to_integer_32 /= 92 then
											if l_c = 10 then
												l_c := -(107 + ((100).bit_shift_left (8)))
											elseif l_c = 13 then
												l_c := -(107 + ((100).bit_shift_left (8)))
											elseif l_c = -(75 + ((65).bit_shift_left (8))) then
												l_c := -(107 + ((100).bit_shift_left (8)))
											end
										end
									end
								end
							end
						end
						if l_xpc.item.xp_numfiles = -1 then
							l_pos := -1 + 23 -- skip if block
						end
				when 19 then -- if:
						if l_c.to_integer_32 /= (create {P_OPTION_STATIC}).p_wc.item.item then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if not ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
							l_pos := -1 + 22 -- goto _L___1
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else: | _L___1:
						if l_c.to_integer_32 /= (create {P_OPTION_STATIC}).p_wcm.item.item then
							if l_c /= 14 then
								if l_c /= 16 then
									if l_c /= 1 then
										if l_c /= 12 then
											l_xpc.item.ExpandOne (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, 1).do_nothing
											l_did_wild_list := 0
											if not ((create {P_OPTION_STATIC}).p_wmnu.item.item).to_boolean then
												l_xpc.item.xp_context := 0
											elseif l_c /= -(107 + ((117).bit_shift_left (8))) then
												if l_c /= -(107 + ((100).bit_shift_left (8))) then
													l_xpc.item.xp_context := 0
												end
											end
											l_wim_index := 0
											if ((create {P_OPTION_STATIC}).p_wmnu.item.item).to_boolean then
												if (create {P_GLOBALS_STATIC}).wild_menu_showing.item /= 0 then
													l_skt := (create {P_GLOBALS_STATIC}).KeyTyped.item
													l_old_RedrawingDisabled := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item
													if (ccline.item.item.input_fn).to_boolean then
														(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := 0
													end
													if (create {P_GLOBALS_STATIC}).wild_menu_showing.item = 2 then
														(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).cmdline_row.item - 1
														redrawcmd
													elseif (create {P_GLOBALS_STATIC}).save_p_ls.item /= -1 then
														(create {P_OPTION_STATIC}).p_ls.item.item := ((create {P_GLOBALS_STATIC}).save_p_ls.item).to_integer_32;
														(create {P_OPTION_STATIC}).p_wmh.item.item := ((create {P_GLOBALS_STATIC}).save_p_wmh.item).to_integer_32;
														(create {P_WINDOW_STATIC}).last_status (0)
														save_cmdline (l_save_ccline);
														(create {P_SCREEN_STATIC}).update_screen (10)
														l_save_ccline.item.restore_cmdline
														redrawcmd;
														(create {P_GLOBALS_STATIC}).save_p_ls.item := -1
													else
														(create {P_SCREEN_STATIC}).win_redraw_last_status ((create {P_GLOBALS_STATIC}).topframe.item);
														(create {P_SCREEN_STATIC}).redraw_statuslines
													end
													(create {P_GLOBALS_STATIC}).KeyTyped.item := l_skt;
													(create {P_GLOBALS_STATIC}).wild_menu_showing.item := 0
													if (ccline.item.item.input_fn).to_boolean then
														(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := l_old_RedrawingDisabled
													end
												end
											end
										end
									end
								end
							end
						end
				when 23 then -- if done
						if l_xpc.item.xp_context /= 21 then
							l_pos := -1 + 29 -- skip if block
						end
				when 24 then -- if:
						if not (((create {P_OPTION_STATIC}).p_wmnu.item.item).to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 25 then -- if:
						if l_c /= -(107 + ((100).bit_shift_left (8))) then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if ccline.item.item.cmdpos > 0 then
							if (ccline.item.item.cmdbuff[(ccline.item.item.cmdpos - 1)]).to_integer_32 = 46 then
								l_c := ((create {P_OPTION_STATIC}).p_wc.item.item).to_integer_32
							else
								l_pos := -1 + 28 -- goto _L___3
							end
						else
							l_pos := -1 + 28 -- goto _L___3
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else: | _L___3:
						if l_c = -(107 + ((117).bit_shift_left (8))) then
							l_found := 0
							l_j := (l_xpc.item.xp_pattern).distance ((ccline.item.item.cmdbuff))
							l_i___0 := 0
							from
							until
								(l_break)
							loop
								l_break := False
								l_j := l_j - 1
								if not (l_j > 0) then
									l_break := True
								end
								if not (l_break) and then ((ccline.item.item.cmdbuff[l_j]).to_integer_32 = 32) then
									if (ccline.item.item.cmdbuff[(l_j - 1)]).to_integer_32 /= 92 then
										l_i___0 := l_j + 1
										l_break := True
									end
								end
								if not (l_break) and then ((ccline.item.item.cmdbuff[l_j]).to_integer_32 = 46) then
									if (ccline.item.item.cmdbuff[(l_j - 1)]).to_integer_32 /= 92 then
										if l_found.to_boolean then
											l_i___0 := l_j + 1
											l_break := True
										else
											l_found := 1
										end
									end
								end
							end
							l_break := False
							if l_i___0 > 0 then
								cmdline_del (l_i___0)
							end
							l_c := ((create {P_OPTION_STATIC}).p_wc.item.item).to_integer_32
							l_xpc.item.xp_context := 0
						end
				when 29 then -- if done | if done
						if l_xpc.item.xp_context /= 2 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 36 -- goto _L___8
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 32 then -- else:
						if l_xpc.item.xp_context /= 3 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 36 -- goto _L___8
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 35 then -- else:
						if l_xpc.item.xp_context /= 32 then
							l_pos := -1 + 44 -- skip if block
						end
				when 36 then -- if: | _L___8:
						if not (((create {P_OPTION_STATIC}).p_wmnu.item.item).to_boolean) then
							l_pos := -1 + 44 -- skip if block
						end
				when 37 then -- if:
						l_upseg[0] := (('/').code).to_natural_8
						l_upseg[1] := (('.').code).to_natural_8
						l_upseg[2] := (('.').code).to_natural_8
						l_upseg[3] := (('/').code).to_natural_8
						l_upseg[4] := (('%/0/').code).to_natural_8
						if l_c /= -(107 + ((100).bit_shift_left (8))) then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if ccline.item.item.cmdpos > 0 then
							if (ccline.item.item.cmdbuff[(ccline.item.item.cmdpos - 1)]).to_integer_32 = 47 then
								if ccline.item.item.cmdpos < 3 then
									l_c := ((create {P_OPTION_STATIC}).p_wc.item.item).to_integer_32
								elseif (ccline.item.item.cmdbuff[(ccline.item.item.cmdpos - 2)]).to_integer_32 /= 46 then
									l_c := ((create {P_OPTION_STATIC}).p_wc.item.item).to_integer_32
								elseif (ccline.item.item.cmdbuff[(ccline.item.item.cmdpos - 3)]).to_integer_32 /= 46 then
									l_c := ((create {P_OPTION_STATIC}).p_wc.item.item).to_integer_32
								else
									l_pos := -1 + 40 -- goto _L___7
								end
							else
								l_pos := -1 + 40 -- goto _L___7
							end
						else
							l_pos := -1 + 40 -- goto _L___7
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 40 then -- else: | _L___7:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_xpc.item.xp_pattern), create {CE_INTEGER_8_POINTER}.make_cast ((l_upseg + 1)), (3).to_natural_32)) /= 0 then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						if l_c = -(107 + ((100).bit_shift_left (8))) then
							l_found___0 := 0
							l_j := ccline.item.item.cmdpos
							l_i___0 := (l_xpc.item.xp_pattern).distance ((ccline.item.item.cmdbuff))
							from
							until
								(l_break)
							loop
								l_break := False
								l_j := l_j - 1
								if not (l_j > l_i___0) then
									l_break := True
								end
								if not (l_break) then
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_j := l_j - ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([ccline.item.item.cmdbuff, ccline.item.item.cmdbuff + l_j]))
									end
									if ((create {P_MISC1_STATIC}).vim_ispathsep ((ccline.item.item.cmdbuff[l_j]).to_integer_32)).to_boolean then
										l_found___0 := 1
										l_break := True
									end
								end
							end
							l_break := False
							if l_found___0.to_boolean then
								if (ccline.item.item.cmdbuff[(l_j - 1)]).to_integer_32 = 46 then
									if (ccline.item.item.cmdbuff[(l_j - 2)]).to_integer_32 = 46 then
										if ((create {P_MISC1_STATIC}).vim_ispathsep ((ccline.item.item.cmdbuff[(l_j - 3)]).to_integer_32)).to_boolean then
											cmdline_del (l_j - 2)
											l_c := ((create {P_OPTION_STATIC}).p_wc.item.item).to_integer_32
										elseif l_j = l_i___0 + 2 then
											cmdline_del (l_j - 2)
											l_c := ((create {P_OPTION_STATIC}).p_wc.item.item).to_integer_32
										end
									end
								end
							end
						else
							l_pos := -1 + 43 -- goto _L___4
						end
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else: | _L___4:
						if l_c = -(107 + ((117).bit_shift_left (8))) then
							l_found___1 := 0
							l_j := ccline.item.item.cmdpos - 1
							l_i___0 := (l_xpc.item.xp_pattern).distance ((ccline.item.item.cmdbuff))
							from
							until
								(l_break)
							loop
								l_break := False
								l_j := l_j - 1
								if not (l_j > l_i___0) then
									l_break := True
								end
								if not (l_break) then
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_j := l_j - ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([ccline.item.item.cmdbuff, ccline.item.item.cmdbuff + l_j]))
									end
									if ((create {P_MISC1_STATIC}).vim_ispathsep ((ccline.item.item.cmdbuff[l_j]).to_integer_32)).to_boolean then
										if l_found___1.to_boolean then
											l_i___0 := l_j + 1
											l_break := True
										else
											l_found___1 := 1
										end
									end
								end
							end
							l_break := False
							if not l_found___1.to_boolean then
								l_j := l_i___0
							elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((ccline.item.item.cmdbuff + l_j)), create {CE_INTEGER_8_POINTER}.make_cast (l_upseg), (4).to_natural_32)) = 0 then
								l_j := l_j + (4)
							elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((ccline.item.item.cmdbuff + l_j)), create {CE_INTEGER_8_POINTER}.make_cast ((l_upseg + 1)), (3).to_natural_32)) = 0 then
								if l_j = l_i___0 then
									l_j := l_j + (3)
								else
									l_j := 0
								end
							else
								l_j := 0
							end
							if l_j > 0 then
								cmdline_del (l_j)
								put_on_cmdline (l_upseg + 1, 3, 0).do_nothing
							elseif ccline.item.item.cmdpos > l_i___0 then
								cmdline_del (l_i___0)
							end
							l_c := ((create {P_OPTION_STATIC}).p_wc.item.item).to_integer_32
						end
				when 44 then -- if done | if done | if done | if done | if done
						if l_c /= 28 then
							l_pos := -1 + 53 -- skip if block
						end
				when 45 then -- if:;
						(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item + 1;
						(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item + 1
						l_c := (create {P_GETCHAR_STATIC}).plain_vgetc;
						(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item - 1;
						(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item - 1
						if l_c = 14 then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						if l_c /= 7 then
							if l_c /= 101 then
								(create {P_GETCHAR_STATIC}).vungetc (l_c)
								l_c := 28
							elseif ccline.item.item.cmdfirstc = 61 then
								(create {P_GETCHAR_STATIC}).vungetc (l_c)
								l_c := 28
							else
								l_pos := -1 + 48 -- goto _L___10
							end
						else
							l_pos := -1 + 48 -- goto _L___10
						end
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 48 then -- else: | _L___10:
						if l_c /= 101 then
							l_pos := -1 + 52 -- skip if block
						end
				when 49 then -- if:
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						if ccline.item.item.cmdpos = ccline.item.item.cmdlen then
							new_cmdpos.item := 99_999
						else
							new_cmdpos.item := ccline.item.item.cmdpos
						end
						save_cmdline (l_save_ccline)
						l_c := (create {P_OPS_STATIC}).get_expr_register
						l_save_ccline.item.restore_cmdline
						if l_c = 61 then
							save_cmdline (l_save_ccline);
							(create {P_GLOBALS_STATIC}).textlock.item := (create {P_GLOBALS_STATIC}).textlock.item + 1
							l_p___0 := (create {P_OPS_STATIC}).get_expr_line;
							(create {P_GLOBALS_STATIC}).textlock.item := (create {P_GLOBALS_STATIC}).textlock.item - 1
							l_save_ccline.item.restore_cmdline
							l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32
							if not l_p___0.is_void then
								if (realloc_cmdbuff (l_len + 1)) = 1 then
									ccline.item.item.cmdlen := l_len
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast (ccline.item.item.cmdbuff), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0)).do_nothing;
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
									if new_cmdpos.item > ccline.item.item.cmdlen then
										ccline.item.item.cmdpos := ccline.item.item.cmdlen
									else
										ccline.item.item.cmdpos := new_cmdpos.item
									end
									(create {P_GLOBALS_STATIC}).KeyTyped.item := 0
									redrawcmd
									l_pos := -1 + 283 -- goto cmdline_changed
								end
							end
						end
				when 50 then;
						(create {P_MISC1_STATIC}).beep_flush
						l_c := ('%/27/').code
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 52 then -- else:
						if l_c = 7 then
							if ((create {P_OPTION_STATIC}).p_im.item.item).to_boolean then
								if (create {P_GLOBALS_STATIC}).restart_edit.item = 0 then
									(create {P_GLOBALS_STATIC}).restart_edit.item := ('a').code
								end
							end
						end
						l_gotesc := 1
						l_pos := -1 + 292 -- goto returncmd
				when 53 then -- if done | if done
						if l_c = (create {P_GLOBALS_STATIC}).cedit_key.item then
							l_c := ex_window
							l_some_key_typed := 1
						elseif l_c = -(253 + ((84).bit_shift_left (8))) then
							l_c := ex_window
							l_some_key_typed := 1
						else
							l_c := (create {P_DIGRAPH_STATIC}).do_digraph (l_c)
						end
						if l_c /= 10 then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if:
						l_pos := -1 + 67 -- goto _L___16
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 56 then -- else:
						if l_c /= 13 then
							l_pos := -1 + 59 -- skip if block
						end
				when 57 then -- if:
						l_pos := -1 + 67 -- goto _L___16
				when 58 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 59 then -- else:
						if l_c /= -(75 + ((65).bit_shift_left (8))) then
							l_pos := -1 + 62 -- skip if block
						end
				when 60 then -- if:
						l_pos := -1 + 67 -- goto _L___16
				when 61 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 62 then -- else:
						if l_c /= 27 then
							l_pos := -1 + 72 -- skip if block
						end
				when 63 then -- if:
						if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						l_pos := -1 + 67 -- goto _L___16
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 66 then -- else:
						if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('x').code)).is_void then
							l_pos := -1 + 72 -- skip if block
						end
				when 67 then -- if: | _L___16:
						if not (((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean) then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						if l_c /= 27 then
							if ccline.item.item.cmdpos = ccline.item.item.cmdlen then
								if ccline.item.item.cmdpos > 0 then
									if (ccline.item.item.cmdbuff[(ccline.item.item.cmdpos - 1)]).to_integer_32 = 92 then
										if l_c = -(75 + ((65).bit_shift_left (8))) then
											l_c := ('%N').code
										end
									else
										l_pos := -1 + 70 -- goto _L___14
									end
								else
									l_pos := -1 + 70 -- goto _L___14
								end
							else
								l_pos := -1 + 70 -- goto _L___14
							end
						else
							l_pos := -1 + 70 -- goto _L___14
						end
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 70 then -- else: | _L___14:
						l_gotesc := 0
						if (ccheck_abbr (l_c + 256)).to_boolean then
							l_pos := -1 + 283 -- goto cmdline_changed
						end
				when 71 then
						if not ((create {P_GLOBALS_STATIC}).cmd_silent.item).to_boolean then
							(create {P_SCREEN_STATIC}).windgoto ((create {P_GLOBALS_STATIC}).msg_row.item, 0);
							(create {P_TERM_STATIC}).out_flush
						end
						l_break := True
				when 72 then -- if done | if done | if done | if done | if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 273 -- skip if block
						end
				when 73 then -- if:
						if l_c.to_integer_32 /= (create {P_OPTION_STATIC}).p_wc.item.item then
							l_pos := -1 + 76 -- skip if block
						end
				when 74 then -- if:
						if not l_gotesc.to_boolean then
							if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
								l_pos := -1 + 77 -- goto _L___19
							else
								l_pos := -1 + 76 -- goto _L___21
							end
						else
							l_pos := -1 + 76 -- goto _L___21
						end
				when 75 then -- if block done, skip else block:
						l_pos := -1 + 98
				when 76 then -- else: | _L___21:
						if l_c.to_integer_32 /= (create {P_OPTION_STATIC}).p_wcm.item.item then
							l_pos := -1 + 98 -- skip if block
						end
				when 77 then -- if: | _L___19:
						if not (l_xpc.item.xp_numfiles > 0) then
							l_pos := -1 + 80 -- skip if block
						end
				when 78 then -- if:
						if l_xpc.item.xp_numfiles > 1 then
							if not l_did_wild_list.to_boolean then
								if ((((create {P_GLOBALS_STATIC}).wim_flags.item[l_wim_index]).to_integer_32).bit_and (4)).to_boolean then
									l_xpc.item.showmatches (0).do_nothing
									redrawcmd
									l_did_wild_list := 1
								end
							end
						end
						if ((((create {P_GLOBALS_STATIC}).wim_flags.item[l_wim_index]).to_integer_32).bit_and (2)).to_boolean then
							l_res := l_xpc.item.nextwild (7, 8)
						elseif ((((create {P_GLOBALS_STATIC}).wim_flags.item[l_wim_index]).to_integer_32).bit_and (1)).to_boolean then
							l_res := l_xpc.item.nextwild (4, 8)
						else
							l_res := 1
						end
				when 79 then -- if block done, skip else block:
						l_pos := -1 + 97
				when 80 then -- else:
						l_wim_index := 0
						l_j := ccline.item.item.cmdpos
						if ((((create {P_GLOBALS_STATIC}).wim_flags.item[0]).to_integer_32).bit_and (2)).to_boolean then
							l_res := l_xpc.item.nextwild (7, 8)
						else
							l_res := l_xpc.item.nextwild (3, 8)
						end
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							(create {P_GETCHAR_STATIC}).vpeekc.do_nothing;
							(create {P_GLOBALS_STATIC}).got_int.item := 0
							l_xpc.item.ExpandOne (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, 1).do_nothing
							l_xpc.item.xp_context := 0
							l_pos := -1 + 283 -- goto cmdline_changed
						end
				when 81 then
						if l_res /= 1 then
							l_pos := -1 + 96 -- skip if block
						end
				when 82 then -- if:
						if not (l_xpc.item.xp_numfiles > 1) then
							l_pos := -1 + 94 -- skip if block
						end
				when 83 then -- if:
						if ((create {P_GLOBALS_STATIC}).wim_flags.item[0]).to_integer_32 = 2 then
							if ccline.item.item.cmdpos = l_j then
								l_wim_index := 1
							end
						end
						if not (((((create {P_GLOBALS_STATIC}).wim_flags.item[l_wim_index]).to_integer_32).bit_and (4)).to_boolean) then
							l_pos := -1 + 86 -- skip if block
						end
				when 84 then -- if:
						l_pos := -1 + 88 -- goto _L___17
				when 85 then -- if block done, skip else block:
						l_pos := -1 + 93
				when 86 then -- else:
						if not (((create {P_OPTION_STATIC}).p_wmnu.item.item).to_boolean) then
							l_pos := -1 + 92 -- skip if block
						end
				when 87 then -- if:
						if ((((create {P_GLOBALS_STATIC}).wim_flags.item[l_wim_index]).to_integer_32).bit_and (1)) = 0 then
							l_pos := -1 + 90 -- skip if block
						end
				when 88 then -- if: | _L___17:
						if not ((((create {P_GLOBALS_STATIC}).wim_flags.item[0]).to_integer_32).bit_and (2)).to_boolean then
							l_p_wmnu_save := (create {P_OPTION_STATIC}).p_wmnu.item.item;
							(create {P_OPTION_STATIC}).p_wmnu.item.item := 0
							l_xpc.item.nextwild (5, 0).do_nothing;
							(create {P_OPTION_STATIC}).p_wmnu.item.item := l_p_wmnu_save
						end
						if ((create {P_OPTION_STATIC}).p_wmnu.item.item).to_boolean then
							if ((((create {P_GLOBALS_STATIC}).wim_flags.item[l_wim_index]).to_integer_32).bit_and (4)) = 0 then
								l_tmp___12 := 1
							else
								l_tmp___12 := 0
							end
						else
							l_tmp___12 := 0
						end
						l_xpc.item.showmatches (l_tmp___12).do_nothing
						redrawcmd
						l_did_wild_list := 1
						if ((((create {P_GLOBALS_STATIC}).wim_flags.item[l_wim_index]).to_integer_32).bit_and (2)).to_boolean then
							l_xpc.item.nextwild (7, 8).do_nothing
						elseif ((((create {P_GLOBALS_STATIC}).wim_flags.item[l_wim_index]).to_integer_32).bit_and (1)).to_boolean then
							l_xpc.item.nextwild (4, 8).do_nothing
						end
				when 89 then -- if block done, skip else block:
						l_pos := -1 + 91
				when 90 then -- else:;
						(create {P_MISC1_STATIC}).vim_beep
				when 91 then -- if done | if block done, skip else block:
						l_pos := -1 + 93
				when 92 then -- else:;
						(create {P_MISC1_STATIC}).vim_beep
				when 93 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 95
				when 94 then -- else:
						l_pos := -1 + 96 -- goto _L___18
				when 95 then -- if done | if block done, skip else block:
						l_pos := -1 + 97
				when 96 then -- else: | _L___18:
						if l_xpc.item.xp_numfiles = -1 then
							l_xpc.item.xp_context := 0
						end
				when 97 then -- if done
						if l_wim_index < 3 then
							l_wim_index := l_wim_index + 1
						end
						if l_c = 27 then
							l_gotesc := 1
						end
						if l_res = 1 then
							l_pos := -1 + 283 -- goto cmdline_changed
						end
				when 98 then -- if done
						l_gotesc := 0
						if l_c = -(107 + ((66).bit_shift_left (8))) then
							if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
								if (l_xpc.item.nextwild (3, 0)) = 1 then
									if (l_xpc.item.nextwild (5, 0)) = 1 then
										if (l_xpc.item.nextwild (5, 0)) = 1 then
											l_pos := -1 + 283 -- goto cmdline_changed
										end
									end
								end
							end
						end
				when 99 then
						if l_c = 0 then
							l_c := ('%N').code
						elseif l_c = -(255 + ((88).bit_shift_left (8))) then
							l_c := ('%N').code
						end
						l_do_abbr := 1
						inspect l_c -- switch 1 head
						when -25195 then l_pos := -1 + 100 -- -(107 + ((98).bit_shift_left (8)))
						when 8 then l_pos := -1 + 100
						when -17515 then l_pos := -1 + 100 -- -(107 + ((68).bit_shift_left (8)))
						when -20733 then l_pos := -1 + 100 -- -(253 + ((80).bit_shift_left (8)))
						when 23 then l_pos := -1 + 100
						when -18795 then l_pos := -1 + 110 -- -(107 + ((73).bit_shift_left (8)))
						when -20477 then l_pos := -1 + 110 -- -(253 + ((79).bit_shift_left (8)))
						when 30 then l_pos := -1 + 111
						when 21 then l_pos := -1 + 112
						when 25 then l_pos := -1 + 113
						when 27 then l_pos := -1 + 115
						when 3 then l_pos := -1 + 115
						when 18 then l_pos := -1 + 117
						when 4 then l_pos := -1 + 121
						when -29291 then l_pos := -1 + 123 -- -(107 + ((114).bit_shift_left (8)))
						when -26917 then l_pos := -1 + 123 -- -(37 + ((105).bit_shift_left (8)))
						when -22269 then l_pos := -1 + 123 -- -(253 + ((86).bit_shift_left (8)))
						when -27755 then l_pos := -1 + 138 -- -(107 + ((108).bit_shift_left (8)))
						when -13347 then l_pos := -1 + 138 -- -(35 + ((52).bit_shift_left (8)))
						when -22013 then l_pos := -1 + 138 -- -(253 + ((85).bit_shift_left (8)))
						when -13821 then l_pos := -1 + 156 -- -(253 + ((53).bit_shift_left (8)))
						when -12541 then l_pos := -1 + 157 -- -(253 + ((48).bit_shift_left (8)))
						when -12797 then l_pos := -1 + 157 -- -(253 + ((49).bit_shift_left (8)))
						when -12285 then l_pos := -1 + 158 -- -(253 + ((47).bit_shift_left (8)))
						when -24573 then l_pos := -1 + 161 -- -(253 + ((95).bit_shift_left (8)))
						when -11773 then l_pos := -1 + 162 -- -(253 + ((45).bit_shift_left (8)))
						when -12029 then l_pos := -1 + 162 -- -(253 + ((46).bit_shift_left (8)))
						when -13309 then l_pos := -1 + 162 -- -(253 + ((51).bit_shift_left (8)))
						when -13565 then l_pos := -1 + 162 -- -(253 + ((52).bit_shift_left (8)))
						when -11517 then l_pos := -1 + 163 -- -(253 + ((44).bit_shift_left (8)))
						when -13053 then l_pos := -1 + 163 -- -(253 + ((50).bit_shift_left (8)))
						when -19453 then l_pos := -1 + 167 -- -(253 + ((75).bit_shift_left (8)))
						when -19709 then l_pos := -1 + 167 -- -(253 + ((76).bit_shift_left (8)))
						when -19965 then l_pos := -1 + 167 -- -(253 + ((77).bit_shift_left (8)))
						when -20221 then l_pos := -1 + 167 -- -(253 + ((78).bit_shift_left (8)))
						when -23037 then l_pos := -1 + 167 -- -(253 + ((89).bit_shift_left (8)))
						when -23293 then l_pos := -1 + 167 -- -(253 + ((90).bit_shift_left (8)))
						when -23549 then l_pos := -1 + 167 -- -(253 + ((91).bit_shift_left (8)))
						when -23805 then l_pos := -1 + 167 -- -(253 + ((92).bit_shift_left (8)))
						when -24061 then l_pos := -1 + 167 -- -(253 + ((93).bit_shift_left (8)))
						when -24317 then l_pos := -1 + 167 -- -(253 + ((94).bit_shift_left (8)))
						when -17917 then l_pos := -1 + 168 -- -(253 + ((69).bit_shift_left (8)))
						when -18173 then l_pos := -1 + 168 -- -(253 + ((70).bit_shift_left (8)))
						when -22777 then l_pos := -1 + 169 -- -(249 + ((88).bit_shift_left (8)))
						when -22776 then l_pos := -1 + 170 -- -(248 + ((88).bit_shift_left (8)))
						when -22768 then l_pos := -1 + 171 -- -(240 + ((88).bit_shift_left (8)))
						when -22767 then l_pos := -1 + 171 -- -(239 + ((88).bit_shift_left (8)))
						when -22773 then l_pos := -1 + 172 -- -(245 + ((88).bit_shift_left (8)))
						when 2 then l_pos := -1 + 173
						when -26731 then l_pos := -1 + 173 -- -(107 + ((104).bit_shift_left (8)))
						when -12619 then l_pos := -1 + 173 -- -(75 + ((49).bit_shift_left (8)))
						when -12835 then l_pos := -1 + 173 -- -(35 + ((50).bit_shift_left (8)))
						when -22525 then l_pos := -1 + 173 -- -(253 + ((87).bit_shift_left (8)))
						when 5 then l_pos := -1 + 174
						when -14144 then l_pos := -1 + 174 -- -(64 + ((55).bit_shift_left (8)))
						when -13387 then l_pos := -1 + 174 -- -(75 + ((52).bit_shift_left (8)))
						when -14122 then l_pos := -1 + 174 -- -(42 + ((55).bit_shift_left (8)))
						when -22781 then l_pos := -1 + 174 -- -(253 + ((88).bit_shift_left (8)))
						when 1 then l_pos := -1 + 175
						when 12 then l_pos := -1 + 178
						when 14 then l_pos := -1 + 193
						when 16 then l_pos := -1 + 193
						when -30059 then l_pos := -1 + 196 -- -(107 + ((117).bit_shift_left (8)))
						when -25707 then l_pos := -1 + 196 -- -(107 + ((100).bit_shift_left (8)))
						when -1277 then l_pos := -1 + 196 -- -(253 + ((4).bit_shift_left (8)))
						when -1533 then l_pos := -1 + 196 -- -(253 + ((5).bit_shift_left (8)))
						when -20587 then l_pos := -1 + 196 -- -(107 + ((80).bit_shift_left (8)))
						when -13131 then l_pos := -1 + 196 -- -(75 + ((51).bit_shift_left (8)))
						when -20075 then l_pos := -1 + 196 -- -(107 + ((78).bit_shift_left (8)))
						when -13643 then l_pos := -1 + 196 -- -(75 + ((53).bit_shift_left (8)))
						when 22 then l_pos := -1 + 268
						when 17 then l_pos := -1 + 268
						when 11 then l_pos := -1 + 269
						else l_pos := -1 + 271
						end
				when 100 then -- switch 1, case -(107 + (98 << 8)) | switch 1, case 8 | switch 1, case -(107 + (68 << 8)) | switch 1, case -(253 + (80 << 8)) | switch 1, case 23
						if l_c = -(253 + ((80).bit_shift_left (8))) then
							l_c := -(107 + ((68).bit_shift_left (8)))
						end
						if l_c = -(107 + ((68).bit_shift_left (8))) then
							if ccline.item.item.cmdpos /= ccline.item.item.cmdlen then
								ccline.item.item.cmdpos := (ccline.item.item.cmdpos) + 1
							end
						end
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							if l_c = -(107 + ((68).bit_shift_left (8))) then
								ccline.item.item.cmdpos := ccline.item.item.cmdpos + ((create {P_MBYTE_STATIC}).mb_off_next (ccline.item.item.cmdbuff, ccline.item.item.cmdbuff + ccline.item.item.cmdpos))
							end
						end
						if not (ccline.item.item.cmdpos > 0) then
							l_pos := -1 + 103 -- skip if block
						end
				when 101 then -- if:
						l_j := ccline.item.item.cmdpos
						l_p___1 := ccline.item.item.cmdbuff + l_j
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_p___1 := (create {P_MBYTE_STATIC}).mb_prevptr (ccline.item.item.cmdbuff, l_p___1)
							if l_c = 23 then
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_p___1.c_pointer.to_integer_32).to_natural_32 > ((ccline.item.item.cmdbuff).c_pointer.to_integer_32).to_natural_32 then
										if not ((create {P_MISC2_STATIC}).vim_isspace ((l_p___1.item).to_integer_32)).to_boolean then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_p___1 := (create {P_MBYTE_STATIC}).mb_prevptr (ccline.item.item.cmdbuff, l_p___1)
									end
								end
								l_break := False
								l_i___0 := (create {P_MBYTE_STATIC}).mb_get_class (l_p___1)
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_p___1.c_pointer.to_integer_32).to_natural_32 > ((ccline.item.item.cmdbuff).c_pointer.to_integer_32).to_natural_32 then
										if ((create {P_MBYTE_STATIC}).mb_get_class (l_p___1)) /= l_i___0 then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_p___1 := (create {P_MBYTE_STATIC}).mb_prevptr (ccline.item.item.cmdbuff, l_p___1)
									end
								end
								l_break := False
								if ((create {P_MBYTE_STATIC}).mb_get_class (l_p___1)) /= l_i___0 then
									l_p___1 := l_p___1 + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___1]))
								end
							end
						elseif l_c = 23 then
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_p___1.c_pointer.to_integer_32).to_natural_32 > ((ccline.item.item.cmdbuff).c_pointer.to_integer_32).to_natural_32 then
									if not ((create {P_MISC2_STATIC}).vim_isspace ((l_p___1[-1]).to_integer_32)).to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_p___1 := l_p___1 - 1
								end
							end
							l_break := False
							l_i___0 := (create {P_CHARSET_STATIC}).vim_iswordc ((l_p___1[-1]).to_integer_32)
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_p___1.c_pointer.to_integer_32).to_natural_32 > ((ccline.item.item.cmdbuff).c_pointer.to_integer_32).to_natural_32 then
									if ((create {P_MISC2_STATIC}).vim_isspace ((l_p___1[-1]).to_integer_32)).to_boolean then
										l_break := True
									elseif ((create {P_CHARSET_STATIC}).vim_iswordc ((l_p___1[-1]).to_integer_32)) /= l_i___0 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_p___1 := l_p___1 - 1
								end
							end
							l_break := False
						else
							l_p___1 := l_p___1 - 1
						end
						ccline.item.item.cmdpos := l_p___1.distance ((ccline.item.item.cmdbuff))
						ccline.item.item.cmdlen := ccline.item.item.cmdlen - (l_j - ccline.item.item.cmdpos)
						l_i___0 := ccline.item.item.cmdpos
						from
						until
							not (l_i___0 < ccline.item.item.cmdlen)
						loop
							l_tmp___24 := l_i___0
							l_i___0 := l_i___0 + 1
							l_tmp___25 := l_j
							l_j := l_j + 1
							ccline.item.item.cmdbuff[l_tmp___24] := ccline.item.item.cmdbuff[l_tmp___25]
						end
						ccline.item.item.cmdbuff[ccline.item.item.cmdlen] := (('%/0/').code).to_natural_8
						redrawcmd
				when 102 then -- if block done, skip else block:
						l_pos := -1 + 109
				when 103 then -- else:
						if ccline.item.item.cmdlen /= 0 then
							l_pos := -1 + 109 -- skip if block
						end
				when 104 then -- if:
						if l_c = 23 then
							l_pos := -1 + 109 -- skip if block
						end
				when 105 then -- if:
						if not ((ccline.item.item.cmdprompt).is_void) then
							l_pos := -1 + 109 -- skip if block
						end
				when 106 then -- if:
						if a_indent /= 0 then
							l_pos := -1 + 109 -- skip if block
						end
				when 107 then -- if:
						if ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						elseif ccline.item.item.cmdfirstc = 62 then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 108 then;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (ccline.item.item.cmdbuff))
						ccline.item.item.cmdbuff := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						if not ((create {P_GLOBALS_STATIC}).cmd_silent.item).to_boolean then
							(create {P_GLOBALS_STATIC}).msg_col.item := 0;
							(create {P_MESSAGE_STATIC}).msg_putchar ((' ').code)
						end
						(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
						l_pos := -1 + 292 -- goto returncmd
				when 109 then -- if done | if done | if done | if done
						l_pos := -1 + 283 -- goto cmdline_changed
				when 110 then -- switch 1, case -(107 + (73 << 8)) | switch 1, case -(253 + (79 << 8))
						ccline.item.item.overstrike := (not (ccline.item.item.overstrike).to_boolean).to_integer;
						(create {P_UI_STATIC}).ui_cursor_shape
						l_pos := -1 + 281 -- goto cmdline_not_changed
				when 111 then -- switch 1, case 30
						if ((create {P_GETCHAR_STATIC}).map_to_exists_mode (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 32, 0)).to_boolean then
							(create {P_GLOBALS_STATIC}).State.item := ((create {P_GLOBALS_STATIC}).State.item).bit_xor ((32));
							(create {P_MBYTE_STATIC}).im_set_active (0)
							if not l_b_im_ptr.is_void then
								if (((create {P_GLOBALS_STATIC}).State.item).bit_and (32)).to_boolean then
									l_b_im_ptr.item := 1
								else
									l_b_im_ptr.item := 0
								end
							end
						else
							if ((create {P_OPTION_STATIC}).p_imdisable.item.item).to_boolean then
								if not l_b_im_ptr.is_void then
									l_tmp___27 := (l_b_im_ptr.item = 2).to_integer
								else
									l_tmp___26 := (create {P_MBYTE_STATIC}).im_get_status
									l_tmp___27 := l_tmp___26
								end
							else
								l_tmp___26 := (create {P_MBYTE_STATIC}).im_get_status
								l_tmp___27 := l_tmp___26
							end
							if l_tmp___27.to_boolean then
								(create {P_MBYTE_STATIC}).im_set_active (0)
								if not l_b_im_ptr.is_void then
									l_b_im_ptr.item := 0
								end
							else
								(create {P_MBYTE_STATIC}).im_set_active (1)
								if not l_b_im_ptr.is_void then
									l_b_im_ptr.item := 2
								end
							end
						end
						if not l_b_im_ptr.is_void then
							if l_b_im_ptr.is_equal (create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_iminsert"))) then
								(create {P_OPTION_STATIC}).set_iminsert_global
							else
								(create {P_OPTION_STATIC}).set_imsearch_global
							end
						end
						(create {P_UI_STATIC}).ui_cursor_shape
						l_pos := -1 + 281 -- goto cmdline_not_changed
				when 112 then -- switch 1, case 21
						l_j := ccline.item.item.cmdpos
						ccline.item.item.cmdlen := ccline.item.item.cmdlen - l_j
						ccline.item.item.cmdpos := 0
						l_i___0 := ccline.item.item.cmdpos
						from
						until
							not (l_i___0 < ccline.item.item.cmdlen)
						loop
							l_tmp___29 := l_i___0
							l_i___0 := l_i___0 + 1
							l_tmp___30 := l_j
							l_j := l_j + 1
							ccline.item.item.cmdbuff[l_tmp___29] := ccline.item.item.cmdbuff[l_tmp___30]
						end
						ccline.item.item.cmdbuff[ccline.item.item.cmdlen] := (('%/0/').code).to_natural_8
						redrawcmd
						l_pos := -1 + 283 -- goto cmdline_changed
				when 113 then -- switch 1, case 25
						if ((create {P_GLOBALS_STATIC}).clip_star.item.item.state).to_integer_32 /= 0 then
							if ((create {P_GLOBALS_STATIC}).clip_star.item.item.state).to_integer_32 = 2 then
								(create {P_UI_STATIC}).clip_copy_modeless_selection (1)
							end
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 114 then
						l_pos := -1 + 273 -- switch 1; break
				when 115 then -- switch 1, case 27 | switch 1, case 3
						if ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
							if (create {P_GLOBALS_STATIC}).ex_normal_busy.item = 0 then
								l_pos := -1 + 281 -- goto cmdline_not_changed
							elseif (create {P_GLOBALS_STATIC}).typebuf.item.tb_len > 0 then
								l_pos := -1 + 281 -- goto cmdline_not_changed
							end
						end
				when 116 then
						l_gotesc := 1
						l_pos := -1 + 292 -- goto returncmd
				when 117 then -- switch 1, case 18;
						(create {P_GLOBALS_STATIC}).dont_scroll.item := 1
						putcmdline (('%"').code, 1);
						(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item + 1
						l_c := (create {P_GETCHAR_STATIC}).plain_vgetc
						l_i___0 := l_c
						if l_i___0 = 15 then
							l_i___0 := 18
						end
						if l_i___0 = 18 then
							l_c := (create {P_GETCHAR_STATIC}).plain_vgetc
						end
						(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item - 1
						new_cmdpos.item := -1
						if l_c = 61 then
							if ccline.item.item.cmdfirstc = 61 then
								(create {P_MISC1_STATIC}).beep_flush
								l_c := ('%/27/').code
							else
								save_cmdline (l_save_ccline)
								l_c := (create {P_OPS_STATIC}).get_expr_register
								l_save_ccline.item.restore_cmdline
							end
						end
						if l_c = 27 then
							l_pos := -1 + 120 -- skip if block
						end
				when 118 then -- if:
						cmdline_paste (l_c, (l_i___0 = 18).to_integer, 0).do_nothing
						if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
							l_gotesc := 1
							l_pos := -1 + 292 -- goto returncmd
						end
				when 119 then;
						(create {P_GLOBALS_STATIC}).KeyTyped.item := 0
						if new_cmdpos.item >= 0 then
							if new_cmdpos.item > ccline.item.item.cmdlen then
								ccline.item.item.cmdpos := ccline.item.item.cmdlen
							else
								ccline.item.item.cmdpos := new_cmdpos.item
							end
						end
				when 120 then -- if done
						redrawcmd
						l_pos := -1 + 283 -- goto cmdline_changed
				when 121 then -- switch 1, case 4
						if (l_xpc.item.showmatches (0)) = 0 then
							l_pos := -1 + 273 -- switch 1; break
						end
				when 122 then
						redrawcmd
						l_continue := True
				when 123 then -- switch 1, case -(107 + (114 << 8)) | switch 1, case -(37 + (105 << 8)) | switch 1, case -(253 + (86 << 8))
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 138 -- skip if block
						end
				when 124 then -- if: | loop condition:
						if not (not (l_break) and then (not (ccline.item.item.cmdpos >= ccline.item.item.cmdlen))) then
							l_pos := -1 + 137 -- skip loop
						end
				when 125 then -- loop body:
						l_break := False
						l_i___0 := cmdline_charsize (ccline.item.item.cmdpos)
						if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
							if (ccline.item.item.cmdspos + l_i___0).to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item * (create {P_GLOBALS_STATIC}).Rows.item.item then
								l_break := True
							end
						end
						if (l_break) then
							l_pos := -1 + 136 -- skip if block
						end
				when 126 then -- if:
						ccline.item.item.cmdspos := ccline.item.item.cmdspos + l_i___0
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							ccline.item.item.cmdpos := ccline.item.item.cmdpos + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([ccline.item.item.cmdbuff + ccline.item.item.cmdpos]))
						else
							ccline.item.item.cmdpos := (ccline.item.item.cmdpos) + 1
						end
						if l_c /= -(37 + ((105).bit_shift_left (8))) then
							l_pos := -1 + 129 -- skip if block
						end
				when 127 then -- if:
						l_pos := -1 + 133 -- goto _L___22
				when 128 then -- if block done, skip else block:
						l_pos := -1 + 136
				when 129 then -- else:
						if l_c /= -(253 + ((86).bit_shift_left (8))) then
							l_pos := -1 + 132 -- skip if block
						end
				when 130 then -- if:
						l_pos := -1 + 133 -- goto _L___22
				when 131 then -- if block done, skip else block:
						l_pos := -1 + 136
				when 132 then -- else:
						if not ((((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (6)).to_boolean) then
							l_pos := -1 + 135 -- skip if block
						end
				when 133 then -- if: | _L___22:
						if (ccline.item.item.cmdbuff[ccline.item.item.cmdpos]).to_integer_32 = 32 then
							l_break := True
						end
				when 134 then -- if block done, skip else block:
						l_pos := -1 + 136
				when 135 then -- else:
						l_break := True
				when 136 then -- if done | if done | if done
						l_pos := -1 + 124 -- back to loop condition
				when 137 then -- loop done
						l_break := False
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							set_cmdspos_cursor
						end
						l_pos := -1 + 281 -- goto cmdline_not_changed
				when 138 then -- switch 1, case -(107 + (108 << 8)) | switch 1, case -(35 + (52 << 8)) | switch 1, case -(253 + (85 << 8))
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 156 -- skip if block
						end
				when 139 then -- if:
						if ccline.item.item.cmdpos = 0 then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 140 then
						if (l_break) then
							l_pos := -1 + 155 -- skip loop
						end
				when 141 then -- loop body:
						l_break := False
						ccline.item.item.cmdpos := (ccline.item.item.cmdpos) - 1
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							ccline.item.item.cmdpos := ccline.item.item.cmdpos - ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([ccline.item.item.cmdbuff, ccline.item.item.cmdbuff + ccline.item.item.cmdpos]))
						end
						ccline.item.item.cmdspos := ccline.item.item.cmdspos - (cmdline_charsize (ccline.item.item.cmdpos))
						if not (ccline.item.item.cmdpos > 0) then
							l_pos := -1 + 153 -- skip if block
						end
				when 142 then -- if:
						if l_c /= -(35 + ((52).bit_shift_left (8))) then
							l_pos := -1 + 145 -- skip if block
						end
				when 143 then -- if:
						l_pos := -1 + 149 -- goto _L___23
				when 144 then -- if block done, skip else block:
						l_pos := -1 + 152
				when 145 then -- else:
						if l_c /= -(253 + ((85).bit_shift_left (8))) then
							l_pos := -1 + 148 -- skip if block
						end
				when 146 then -- if:
						l_pos := -1 + 149 -- goto _L___23
				when 147 then -- if block done, skip else block:
						l_pos := -1 + 152
				when 148 then -- else:
						if not ((((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (6)).to_boolean) then
							l_pos := -1 + 151 -- skip if block
						end
				when 149 then -- if: | _L___23:
						if (ccline.item.item.cmdbuff[(ccline.item.item.cmdpos - 1)]).to_integer_32 = 32 then
							l_break := True
						end
				when 150 then -- if block done, skip else block:
						l_pos := -1 + 152
				when 151 then -- else:
						l_break := True
				when 152 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 154
				when 153 then -- else:
						l_break := True
				when 154 then
						l_pos := -1 + 140 -- back to loop condition
				when 155 then -- loop done
						l_break := False
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							set_cmdspos_cursor
						end
						l_pos := -1 + 281 -- goto cmdline_not_changed
				when 156 then -- switch 1, case -(253 + (53 << 8))
						if not (l_return or l_break or l_continue) then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 157 then -- switch 1, case -(253 + (48 << 8)) | switch 1, case -(253 + (49 << 8))
						if not (l_return or l_break or l_continue) then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 158 then -- switch 1, case -(253 + (47 << 8))
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 161 -- skip if block
						end
				when 159 then -- if:
						if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							if not ((create {P_TERM_STATIC}).mouse_has (('c').code)).to_boolean then
								l_pos := -1 + 281 -- goto cmdline_not_changed
							end
						end
				when 160 then
						if ((create {P_GLOBALS_STATIC}).clip_star.item.item.available).to_boolean then
							cmdline_paste (('*').code, 1, 1).do_nothing
						else
							cmdline_paste (0, 1, 1).do_nothing
						end
						redrawcmd
						l_pos := -1 + 283 -- goto cmdline_changed
				when 161 then -- switch 1, case -(253 + (95 << 8))
						if not (l_return or l_break or l_continue) then
							cmdline_paste (('~').code, 1, 0).do_nothing
							redrawcmd
							l_pos := -1 + 283 -- goto cmdline_changed
						end
				when 162 then -- switch 1, case -(253 + (45 << 8)) | switch 1, case -(253 + (46 << 8)) | switch 1, case -(253 + (51 << 8)) | switch 1, case -(253 + (52 << 8))
						if not (l_return or l_break or l_continue) and then (l_ignore_drag_release.to_boolean) then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 163 then -- switch 1, case -(253 + (44 << 8)) | switch 1, case -(253 + (50 << 8))
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 167 -- skip if block
						end
				when 164 then -- if:
						if l_c = -(253 + ((46).bit_shift_left (8))) then
							l_ignore_drag_release := 1
						elseif l_c = -(253 + ((52).bit_shift_left (8))) then
							l_ignore_drag_release := 1
						else
							l_ignore_drag_release := 0
						end
						if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							if not ((create {P_TERM_STATIC}).mouse_has (('c').code)).to_boolean then
								l_pos := -1 + 281 -- goto cmdline_not_changed
							end
						end
				when 165 then
						if (create {P_GLOBALS_STATIC}).mouse_row.item < (create {P_GLOBALS_STATIC}).cmdline_row.item then
							if ((create {P_GLOBALS_STATIC}).clip_star.item.item.available).to_boolean then
								l_button := (create {P_MISC2_STATIC}).get_mouse_button ((((((-l_c).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_integer_32, l_is_click, l_is_drag)
								if ((create {P_TERM_STATIC}).mouse_model_popup).to_boolean then
									if l_button = 0 then
										if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (2)).to_boolean then
											l_button := 2;
											(create {P_GLOBALS_STATIC}).mod_mask.item.item := ((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and ((-3))
										end
									end
								end
								(create {P_UI_STATIC}).clip_modeless (l_button, l_is_click.item, l_is_drag.item)
								l_pos := -1 + 281 -- goto cmdline_not_changed
							end
						end
				when 166 then
						set_cmdspos
						ccline.item.item.cmdpos := 0
						from
						until
							not (not (l_break) and then (ccline.item.item.cmdpos < ccline.item.item.cmdlen))
						loop
							l_break := False
							l_i___0 := cmdline_charsize (ccline.item.item.cmdpos)
							if ((create {P_GLOBALS_STATIC}).mouse_row.item).to_integer_32 <= ((create {P_GLOBALS_STATIC}).cmdline_row.item).to_integer_32 + (ccline.item.item.cmdspos).to_integer_32 // (create {P_GLOBALS_STATIC}).Columns.item.item then
								if ((create {P_GLOBALS_STATIC}).mouse_col.item).to_integer_32 < (ccline.item.item.cmdspos).to_integer_32 \\ (create {P_GLOBALS_STATIC}).Columns.item.item + l_i___0.to_integer_32 then
									l_break := True
								end
							end
							if not (l_break) then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									correct_cmdspos (ccline.item.item.cmdpos, l_i___0)
									ccline.item.item.cmdpos := ccline.item.item.cmdpos + (((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([ccline.item.item.cmdbuff + ccline.item.item.cmdpos])) - 1)
								end
								ccline.item.item.cmdspos := ccline.item.item.cmdspos + l_i___0
								ccline.item.item.cmdpos := (ccline.item.item.cmdpos) + 1
							end
						end
						l_break := False
						l_pos := -1 + 281 -- goto cmdline_not_changed
				when 167 then -- switch 1, case -(253 + (75 << 8)) | switch 1, case -(253 + (76 << 8)) | switch 1, case -(253 + (77 << 8)) | switch 1, case -(253 + (78 << 8)) | switch 1, case -(253 + (89 << 8)) | switch 1, case -(253 + (90 << 8)) | switch 1, case -(253 + (91 << 8)) | switch 1, case -(253 + (92 << 8)) | switch 1, case -(253 + (93 << 8)) | switch 1, case -(253 + (94 << 8))
						if not (l_return or l_break or l_continue) then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 168 then -- switch 1, case -(253 + (69 << 8)) | switch 1, case -(253 + (70 << 8))
						if not (l_return or l_break or l_continue) then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 169 then -- switch 1, case -(249 + (88 << 8))
						if not (l_return or l_break or l_continue) then
							if (create {P_GLOBALS_STATIC}).msg_scrolled.item = 0 then
								(create {P_GUI_STATIC}).gui_do_scroll.do_nothing
								redrawcmd
							end
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 170 then -- switch 1, case -(248 + (88 << 8))
						if not (l_return or l_break or l_continue) then
							if (create {P_GLOBALS_STATIC}).msg_scrolled.item = 0 then
								(create {P_GUI_STATIC}).gui_do_horiz_scroll ((create {P_GLOBALS_STATIC}).scrollbar_value.item, 0).do_nothing
								redrawcmd
							end
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 171 then -- switch 1, case -(240 + (88 << 8)) | switch 1, case -(239 + (88 << 8))
						if not (l_return or l_break or l_continue) then
							if ((create {P_GUI_STATIC}).gui_use_tabline).to_boolean then
								(create {P_GUI_GTK_X11_STATIC}).gui_mch_set_curtab (((create {P_WINDOW_STATIC}).tabpage_index ((create {P_GLOBALS_STATIC}).curtab.item)))
							end
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 172 then -- switch 1, case -(245 + (88 << 8))
						if not (l_return or l_break or l_continue) then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 173 then -- switch 1, case 2 | switch 1, case -(107 + (104 << 8)) | switch 1, case -(75 + (49 << 8)) | switch 1, case -(35 + (50 << 8)) | switch 1, case -(253 + (87 << 8))
						if not (l_return or l_break or l_continue) then
							ccline.item.item.cmdpos := 0
							set_cmdspos
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 174 then -- switch 1, case 5 | switch 1, case -(64 + (55 << 8)) | switch 1, case -(75 + (52 << 8)) | switch 1, case -(42 + (55 << 8)) | switch 1, case -(253 + (88 << 8))
						if not (l_return or l_break or l_continue) then
							ccline.item.item.cmdpos := ccline.item.item.cmdlen
							set_cmdspos_cursor
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 175 then -- switch 1, case 1
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 178 -- skip if block
						end
				when 176 then -- if:
						if (l_xpc.item.nextwild (6, 0)) = 0 then
							l_pos := -1 + 273 -- switch 1; break
						end
				when 177 then
						l_pos := -1 + 283 -- goto cmdline_changed
				when 178 then -- switch 1, case 12
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 193 -- skip if block
						end
				when 179 then -- if:
						if not (((create {P_OPTION_STATIC}).p_is.item.item).to_boolean) then
							l_pos := -1 + 191 -- skip if block
						end
				when 180 then -- if:
						if ((create {P_GLOBALS_STATIC}).cmd_silent.item).to_boolean then
							l_pos := -1 + 191 -- skip if block
						end
				when 181 then -- if:
						if l_firstc /= 47 then
							l_pos := -1 + 184 -- skip if block
						end
				when 182 then -- if:
						l_pos := -1 + 185 -- goto _L___26
				when 183 then -- if block done, skip else block:
						l_pos := -1 + 191
				when 184 then -- else:
						if l_firstc /= 63 then
							l_pos := -1 + 191 -- skip if block
						end
				when 185 then -- if: | _L___26:
						if not (l_did_incsearch.to_boolean) then
							l_pos := -1 + 190 -- skip if block
						end
				when 186 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= l_old_cursor.lnum then
							l_pos := -1 + 189 -- skip if block
						end
				when 187 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = l_old_cursor.col then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd /= l_old_cursor.coladd then
								l_pos := -1 + 189 -- goto _L___25
							end
						else
							l_pos := -1 + 189 -- goto _L___25
						end
				when 188 then -- if block done, skip else block:
						l_pos := -1 + 190
				when 189 then -- else: | _L___25:
						l_c := (create {P_MISC1_STATIC}).gchar_cursor
						if ((create {P_OPTION_STATIC}).p_ic.item.item).to_boolean then
							if ((create {P_OPTION_STATIC}).p_scs.item.item).to_boolean then
								if not ((create {P_SEARCH_STATIC}).pat_has_uppercase (ccline.item.item.cmdbuff)).to_boolean then
									l_c := (create {P_CHARSET_STATIC}).vim_tolower (l_c)
								end
							end
						end
						if l_c /= 0 then
							if l_c = l_firstc then
								(create {P_GETCHAR_STATIC}).stuffcharReadbuff (l_c)
								l_c := ('\').code
							else
								if ((create {P_OPTION_STATIC}).p_magic.item.item).to_boolean then
									l_tmp___44 := ce_string ("\^$.*[")
								else
									l_tmp___44 := ce_string ("\^$")
								end
								if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___44), l_c)).is_void then
									(create {P_GETCHAR_STATIC}).stuffcharReadbuff (l_c)
									l_c := ('\').code
								end
							end
							l_pos := -1 + 273 -- switch 1; break
						end
				when 190 then -- if done
						l_pos := -1 + 281 -- goto cmdline_not_changed
				when 191 then -- if done | if done | if done
						if (l_xpc.item.nextwild (7, 0)) = 0 then
							l_pos := -1 + 273 -- switch 1; break
						end
				when 192 then
						l_pos := -1 + 283 -- goto cmdline_changed
				when 193 then -- switch 1, case 14 | switch 1, case 16
						if not (not (l_return or l_break or l_continue) and then (l_xpc.item.xp_numfiles > 0)) then
							l_pos := -1 + 196 -- skip if block
						end
				when 194 then -- if:
						if l_c = 16 then
							l_tmp___47 := 5
						else
							l_tmp___47 := 4
						end
						if (l_xpc.item.nextwild (l_tmp___47, 0)) = 0 then
							l_pos := -1 + 273 -- switch 1; break
						end
				when 195 then
						l_pos := -1 + 283 -- goto cmdline_changed
				when 196 then -- switch 1, case -(107 + (117 << 8)) | switch 1, case -(107 + (100 << 8)) | switch 1, case -(253 + (4 << 8)) | switch 1, case -(253 + (5 << 8)) | switch 1, case -(107 + (80 << 8)) | switch 1, case -(75 + (51 << 8)) | switch 1, case -(107 + (78 << 8)) | switch 1, case -(75 + (53 << 8))
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 268 -- skip if block
						end
				when 197 then -- if:
						if hislen.item = 0 then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						elseif l_firstc = 0 then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 198 then
						l_i___0 := l_hiscnt
						if not (l_lookfor.is_void) then
							l_pos := -1 + 201 -- skip if block
						end
				when 199 then -- if:
						l_lookfor := (create {P_MISC2_STATIC}).vim_strsave (ccline.item.item.cmdbuff)
						if l_lookfor.is_void then
							l_pos := -1 + 281 -- goto cmdline_not_changed
						end
				when 200 then
						l_lookfor[ccline.item.item.cmdpos] := (('%/0/').code).to_natural_8
				when 201 then -- if done
						l_j := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_lookfor))).to_integer_32
				when 202 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 231 -- skip loop
						end
				when 203 then -- loop body:
						l_break := False
						if l_c /= -(107 + ((117).bit_shift_left (8))) then
							l_pos := -1 + 206 -- skip if block
						end
				when 204 then -- if:
						l_pos := -1 + 216 -- goto _L___28
				when 205 then -- if block done, skip else block:
						l_pos := -1 + 225
				when 206 then -- else:
						if l_c /= -(253 + ((4).bit_shift_left (8))) then
							l_pos := -1 + 209 -- skip if block
						end
				when 207 then -- if:
						l_pos := -1 + 216 -- goto _L___28
				when 208 then -- if block done, skip else block:
						l_pos := -1 + 225
				when 209 then -- else:
						if l_c /= 16 then
							l_pos := -1 + 212 -- skip if block
						end
				when 210 then -- if:
						l_pos := -1 + 216 -- goto _L___28
				when 211 then -- if block done, skip else block:
						l_pos := -1 + 225
				when 212 then -- else:
						if l_c /= -(107 + ((80).bit_shift_left (8))) then
							l_pos := -1 + 215 -- skip if block
						end
				when 213 then -- if:
						l_pos := -1 + 216 -- goto _L___28
				when 214 then -- if block done, skip else block:
						l_pos := -1 + 225
				when 215 then -- else:
						if l_c /= -(75 + ((51).bit_shift_left (8))) then
							l_pos := -1 + 224 -- skip if block
						end
				when 216 then -- if: | _L___28:
						if l_hiscnt /= hislen.item then
							l_pos := -1 + 219 -- skip if block
						end
				when 217 then -- if:
						l_hiscnt := hisidx.item[l_histype]
				when 218 then -- if block done, skip else block:
						l_pos := -1 + 223
				when 219 then -- else:
						if l_hiscnt /= 0 then
							l_pos := -1 + 222 -- skip if block
						end
				when 220 then -- if:
						if hisidx.item[l_histype] /= hislen.item - 1 then
							l_hiscnt := hislen.item - 1
						else
							l_pos := -1 + 222 -- goto _L___27
						end
				when 221 then -- if block done, skip else block:
						l_pos := -1 + 223
				when 222 then -- else: | _L___27:
						if l_hiscnt /= hisidx.item[l_histype] + 1 then
							l_hiscnt := l_hiscnt - 1
						else
							l_hiscnt := l_i___0
							l_break := True
						end
				when 223 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 225
				when 224 then -- else:
						if l_hiscnt = hisidx.item[l_histype] then
							l_hiscnt := hislen.item
							l_break := True
						end
						if not (l_break) and then (l_hiscnt = hislen.item) then
							l_break := True
						end
						if not (l_break) then
							if l_hiscnt = hislen.item - 1 then
								l_hiscnt := 0
							else
								l_hiscnt := l_hiscnt + 1
							end
						end
				when 225 then -- if done | if done | if done | if done
						if not (l_break) then
							if l_hiscnt < 0 then
								l_hiscnt := l_i___0
								l_break := True
							elseif ((history.item[l_histype] + l_hiscnt).item.hisstr).is_void then
								l_hiscnt := l_i___0
								l_break := True
							end
						end
						if (l_break) then
							l_pos := -1 + 230 -- skip if block
						end
				when 226 then -- if:
						if l_c = -(107 + ((117).bit_shift_left (8))) then
							l_pos := -1 + 229 -- skip if block
						end
				when 227 then -- if:
						if l_c /= -(107 + ((100).bit_shift_left (8))) then
							l_break := True
						else
							l_pos := -1 + 229 -- goto _L___29
						end
				when 228 then -- if block done, skip else block:
						l_pos := -1 + 230
				when 229 then -- else: | _L___29:
						if l_hiscnt = l_i___0 then
							l_break := True
						elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((history.item[l_histype] + l_hiscnt).item.hisstr), create {CE_INTEGER_8_POINTER}.make_cast (l_lookfor), l_j.to_natural_32)) = 0 then
							l_break := True
						end
				when 230 then -- if done
						l_pos := -1 + 202 -- back to loop condition
				when 231 then -- loop done
						l_break := False
						if l_hiscnt = l_i___0 then
							l_pos := -1 + 267 -- skip if block
						end
				when 232 then -- if:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (ccline.item.item.cmdbuff))
						l_xpc.item.xp_context := 0
						if l_hiscnt = hislen.item then
							l_p___2 := l_lookfor
						else
							l_p___2 := (history.item[l_histype] + l_hiscnt).item.hisstr
						end
						if l_histype /= 1 then
							l_pos := -1 + 264 -- skip if block
						end
				when 233 then -- if:
						if l_p___2.is_equal (l_lookfor) then
							l_pos := -1 + 262 -- skip if block
						end
				when 234 then -- if:
						l_old_firstc := (l_p___2[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___2))) + {NATURAL_32} 1).to_integer_32]).to_integer_32
						if l_old_firstc = l_firstc then
							l_pos := -1 + 260 -- skip if block
						end
				when 235 then -- if:
						l_i___0 := 0
				when 236 then -- loop condition:
						if not (not (l_return) and then (l_i___0 <= 1)) then
							l_pos := -1 + 258 -- skip loop
						end
				when 237 then -- loop body:
						l_len___0 := 0
						l_j := 0
				when 238 then -- loop condition:
						if (l_p___2[l_j]).to_integer_32 = 0 then
							l_pos := -1 + 256 -- skip loop
						end
				when 239 then -- loop body:
						if (l_p___2[l_j]).to_integer_32 /= l_old_firstc then
							l_pos := -1 + 248 -- skip if block
						end
				when 240 then -- if:
						if l_j /= 0 then
							l_pos := -1 + 243 -- skip if block
						end
				when 241 then -- if:
						l_pos := -1 + 244 -- goto _L___32
				when 242 then -- if block done, skip else block:
						l_pos := -1 + 247
				when 243 then -- else:
						if (l_p___2[(l_j - 1)]).to_integer_32 = 92 then
							l_pos := -1 + 246 -- skip if block
						end
				when 244 then -- if: | _L___32:
						if l_i___0 > 0 then
							ccline.item.item.cmdbuff[l_len___0] := l_firstc.to_natural_8
						end
				when 245 then -- if block done, skip else block:
						l_pos := -1 + 247
				when 246 then -- else:
						l_pos := -1 + 248 -- goto _L___31
				when 247 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 255
				when 248 then -- else: | _L___31:
						if (l_p___2[l_j]).to_integer_32 /= l_firstc then
							l_pos := -1 + 254 -- skip if block
						end
				when 249 then -- if:
						if l_j /= 0 then
							l_pos := -1 + 252 -- skip if block
						end
				when 250 then -- if:
						l_pos := -1 + 253 -- goto _L___30
				when 251 then -- if block done, skip else block:
						l_pos := -1 + 254
				when 252 then -- else:
						if (l_p___2[(l_j - 1)]).to_integer_32 = 92 then
							l_pos := -1 + 254 -- skip if block
						end
				when 253 then -- if: | _L___30:
						if l_i___0 > 0 then
							ccline.item.item.cmdbuff[l_len___0] := (('\').code).to_natural_8
						end
						l_len___0 := l_len___0 + 1
				when 254 then -- if done | if done
						if l_i___0 > 0 then
							ccline.item.item.cmdbuff[l_len___0] := l_p___2[l_j]
						end
				when 255 then
						l_len___0 := l_len___0 + 1
						l_j := l_j + 1
						l_pos := -1 + 238 -- back to loop condition
				when 256 then -- loop done
						if l_i___0 = 0 then
							alloc_cmdbuff (l_len___0)
							if (ccline.item.item.cmdbuff).is_void then
								l_pos := -1 + 292 -- goto returncmd
							end
						end
				when 257 then
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 236 -- back to loop condition
				when 258 then -- loop done
						ccline.item.item.cmdbuff[l_len___0] := (('%/0/').code).to_natural_8
				when 259 then -- if block done, skip else block:
						l_pos := -1 + 261
				when 260 then -- else:
						l_pos := -1 + 264 -- goto _L___34
				when 261 then -- if done | if block done, skip else block:
						l_pos := -1 + 263
				when 262 then -- else:
						l_pos := -1 + 264 -- goto _L___34
				when 263 then -- if done | if block done, skip else block:
						l_pos := -1 + 266
				when 264 then -- else: | _L___34:
						alloc_cmdbuff ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___2))).to_integer_32)
						if (ccline.item.item.cmdbuff).is_void then
							l_pos := -1 + 292 -- goto returncmd
						end
				when 265 then
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (ccline.item.item.cmdbuff), create {CE_INTEGER_8_POINTER}.make_cast (l_p___2)).do_nothing
				when 266 then
						ccline.item.item.cmdlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (ccline.item.item.cmdbuff))).to_integer_32
						ccline.item.item.cmdpos := ccline.item.item.cmdlen
						redrawcmd
						l_pos := -1 + 283 -- goto cmdline_changed
				when 267 then;
						(create {P_MISC1_STATIC}).beep_flush
						l_pos := -1 + 281 -- goto cmdline_not_changed
				when 268 then -- switch 1, case 22 | switch 1, case 17
						if not (l_return or l_break or l_continue) then
							l_ignore_drag_release := 1
							putcmdline (('^').code, 1)
							l_c := (create {P_EDIT_STATIC}).get_literal
							l_do_abbr := 0
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								if ((create {P_MBYTE_STATIC}).utf_iscomposing (l_c)).to_boolean then
									if not ((create {P_GLOBALS_STATIC}).cmd_silent.item).to_boolean then
										draw_cmdline (ccline.item.item.cmdpos, ccline.item.item.cmdlen - ccline.item.item.cmdpos);
										(create {P_MESSAGE_STATIC}).msg_putchar ((' ').code)
										cursorcmd
									end
								end
							end
						end
						l_pos := -1 + 273 -- switch 1; break
				when 269 then -- switch 1, case 11
						l_ignore_drag_release := 1
						putcmdline (('?').code, 1);
						(create {P_GLOBALS_STATIC}).dont_scroll.item := 1
						l_c := (create {P_DIGRAPH_STATIC}).get_digraph (1)
						if l_c /= 0 then
							l_pos := -1 + 273 -- switch 1; break
						end
				when 270 then
						redrawcmd
						l_pos := -1 + 281 -- goto cmdline_not_changed
				when 271 then -- switch 1, default:
						if l_c = (create {P_GLOBALS_STATIC}).intr_char.item then
							l_gotesc := 1
							l_pos := -1 + 292 -- goto returncmd
						end
				when 272 then
						if not (l_c < 0) then
							(create {P_GLOBALS_STATIC}).mod_mask.item.item := 0
						end
						l_pos := -1 + 273 -- switch 1; break
				when 273 then -- switch 1, done: | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 282 -- skip if block
						end
				when 274 then -- if:
						if not (l_do_abbr.to_boolean) then
							l_pos := -1 + 280 -- skip if block
						end
				when 275 then -- if:
						if not (l_c < 0) then
							l_pos := -1 + 278 -- skip if block
						end
				when 276 then -- if:
						l_pos := -1 + 279 -- goto _L___35
				when 277 then -- if block done, skip else block:
						l_pos := -1 + 280
				when 278 then -- else:
						if ((create {P_CHARSET_STATIC}).vim_iswordc (l_c)).to_boolean then
							l_pos := -1 + 280 -- skip if block
						end
				when 279 then -- if: | _L___35:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							if l_c >= 256 then
								l_tmp___56 := l_c + 256
							else
								l_tmp___56 := l_c
							end
						else
							l_tmp___56 := l_c
						end
						if (ccheck_abbr (l_tmp___56)).to_boolean then
							l_pos := -1 + 283 -- goto cmdline_changed
						end
				when 280 then -- if done | if done
						if l_c < 0 then
							l_tmp___58 := (create {P_MISC2_STATIC}).get_special_key_name (l_c, (create {P_GLOBALS_STATIC}).mod_mask.item.item)
							put_on_cmdline (l_tmp___58, -1, 1).do_nothing
						elseif (create {P_GLOBALS_STATIC}).mod_mask.item.item /= 0 then
							l_tmp___58 := (create {P_MISC2_STATIC}).get_special_key_name (l_c, (create {P_GLOBALS_STATIC}).mod_mask.item.item)
							put_on_cmdline (l_tmp___58, -1, 1).do_nothing
						elseif ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_j := (create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([l_c, (create {P_GLOBALS_STATIC}).IObuff.item]);
							(create {P_GLOBALS_STATIC}).IObuff.item[l_j] := (('%/0/').code).to_natural_8
							put_on_cmdline ((create {P_GLOBALS_STATIC}).IObuff.item, l_j, 1).do_nothing
						else
							(create {P_GLOBALS_STATIC}).IObuff.item[0] := l_c.to_natural_8
							put_on_cmdline ((create {P_GLOBALS_STATIC}).IObuff.item, 1, 1).do_nothing
						end
						l_pos := -1 + 283 -- goto cmdline_changed
				when 281 then -- cmdline_not_changed:
						if not l_incsearch_postponed.to_boolean then
							l_continue := True
						end
				when 282 then -- if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 290 -- skip if block
						end
				when 283 then -- if: | cmdline_changed:
						if not (((create {P_OPTION_STATIC}).p_is.item.item).to_boolean) then
							l_pos := -1 + 290 -- skip if block
						end
				when 284 then -- if:
						if ((create {P_GLOBALS_STATIC}).cmd_silent.item).to_boolean then
							l_pos := -1 + 290 -- skip if block
						end
				when 285 then -- if:
						if l_firstc /= 47 then
							l_pos := -1 + 288 -- skip if block
						end
				when 286 then -- if:
						l_pos := -1 + 289 -- goto _L___36
				when 287 then -- if block done, skip else block:
						l_pos := -1 + 290
				when 288 then -- else:
						if l_firstc /= 63 then
							l_pos := -1 + 290 -- skip if block
						end
				when 289 then -- if: | _L___36:
						if ((create {P_GETCHAR_STATIC}).char_avail).to_boolean then
							l_incsearch_postponed := 1
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							l_incsearch_postponed := 0;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_old_cursor.twin
							if ccline.item.item.cmdlen = 0 then
								l_i___0 := 0
							else
								(create {P_TERM_STATIC}).cursor_off;
								(create {P_TERM_STATIC}).out_flush;
								(create {P_GLOBALS_STATIC}).emsg_off.item := (create {P_GLOBALS_STATIC}).emsg_off.item + 1;
								(create {P_EX_CMDS2_STATIC}).profile_setlimit (500, l_tm)
								l_i___0 := (create {P_SEARCH_STATIC}).do_search (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), l_firstc, ccline.item.item.cmdbuff, a_count___2, 3_216, l_tm);
								(create {P_GLOBALS_STATIC}).emsg_off.item := (create {P_GLOBALS_STATIC}).emsg_off.item - 1
								if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
									(create {P_GETCHAR_STATIC}).vpeekc.do_nothing;
									(create {P_GLOBALS_STATIC}).got_int.item := 0
									l_i___0 := 0
								elseif ((create {P_GETCHAR_STATIC}).char_avail).to_boolean then
									l_incsearch_postponed := 1
								end
							end
							if l_i___0 /= 0 then
								(create {P_GLOBALS_STATIC}).highlight_match.item := 1
							else
								(create {P_GLOBALS_STATIC}).highlight_match.item := 0
							end
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol := l_old_leftcol___0;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := l_old_topline___0;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := l_old_topfill___0;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_botline := l_old_botline;
							(create {P_MOVE_STATIC}).changed_cline_bef_curs;
							(create {P_MOVE_STATIC}).update_topline
							if l_i___0 /= 0 then
								l_save_pos := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + ((create {P_GLOBALS_STATIC}).search_match_lines.item);
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).search_match_endcol.item
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count;
									(create {P_MISC2_STATIC}).coladvance ((2_147_483_647).to_integer_32).do_nothing
								end
								(create {P_MOVE_STATIC}).validate_cursor
								l_end_pos := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_save_pos.twin
							else
								l_end_pos := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
							end
							(create {P_MOVE_STATIC}).validate_cursor
							if ((create {P_OPTION_STATIC}).p_ru.item.item).to_boolean then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_status_height > 0 then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_redr_status := 1
								end
							end
							save_cmdline (l_save_ccline);
							(create {P_SCREEN_STATIC}).update_screen (35)
							l_save_ccline.item.restore_cmdline
							if l_i___0 /= 0 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_end_pos.twin
							end
							(create {P_MESSAGE_STATIC}).msg_starthere
							redrawcmdline
							l_did_incsearch := 1
						end
				when 290 then -- if done | if done | if done | if done
						if (not l_return and not l_break) then
							
						end
						l_pos := -1 + 12 -- back to loop condition
				when 291 then -- loop done
						l_break := False
						l_continue := False
				when 292 then -- returncmd:
						l_xpc.item.ExpandCleanup
						ccline.item.item.xpc := create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (default_pointer)
						if l_did_incsearch.to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_old_cursor.twin;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant := l_old_curswant;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol := l_old_leftcol___0;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topline := l_old_topline___0;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := l_old_topfill___0;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_botline := l_old_botline;
							(create {P_GLOBALS_STATIC}).highlight_match.item := 0;
							(create {P_MOVE_STATIC}).validate_cursor;
							(create {P_SCREEN_STATIC}).redraw_later (35)
						end
						if (ccline.item.item.cmdbuff).is_void then
							l_pos := -1 + 301 -- skip if block
						end
				when 293 then -- if:
						if not ((ccline.item.item.cmdlen).to_boolean) then
							l_pos := -1 + 300 -- skip if block
						end
				when 294 then -- if:
						if l_firstc = 0 then
							l_pos := -1 + 300 -- skip if block
						end
				when 295 then -- if:
						if not (l_some_key_typed.to_boolean) then
							l_pos := -1 + 298 -- skip if block
						end
				when 296 then -- if:
						l_pos := -1 + 299 -- goto _L___37
				when 297 then -- if block done, skip else block:
						l_pos := -1 + 300
				when 298 then -- else:
						if l_histype /= 1 then
							l_pos := -1 + 300 -- skip if block
						end
				when 299 then -- if: | _L___37:
						if l_histype = 1 then
							l_tmp___61 := l_firstc
						else
							l_tmp___61 := ('%/0/').code
						end
						add_to_history (l_histype, ccline.item.item.cmdbuff, 1, l_tmp___61)
						if l_firstc = 58 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).new_last_cmdline.item));
							(create {P_GLOBALS_STATIC}).new_last_cmdline.item := (create {P_MISC2_STATIC}).vim_strsave (ccline.item.item.cmdbuff)
						end
				when 300 then -- if done | if done | if done
						if l_gotesc.to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (ccline.item.item.cmdbuff))
							ccline.item.item.cmdbuff := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							if (create {P_GLOBALS_STATIC}).msg_scrolled.item = 0 then
								compute_cmdrow
							end
							(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))).do_nothing;
							(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
						end
				when 301 then -- if done;
						(create {P_MESSAGE_STATIC}).msg_check;
						(create {P_GLOBALS_STATIC}).msg_scroll.item := l_save_msg_scroll;
						(create {P_GLOBALS_STATIC}).redir_off.item := 0
						if l_some_key_typed.to_boolean then
							(create {P_GLOBALS_STATIC}).need_wait_return.item := 0
						end
						(create {P_GLOBALS_STATIC}).State.item := l_save_State
						if not l_b_im_ptr.is_void then
							if l_b_im_ptr.item /= 1 then
								(create {P_UI_STATIC}).im_save_status (l_b_im_ptr)
							end
						end
						(create {P_MBYTE_STATIC}).im_set_active (0);
						(create {P_TERM_STATIC}).setmouse;
						(create {P_UI_STATIC}).ui_cursor_shape
						l_p___3 := ccline.item.item.cmdbuff
						ccline.item.item.cmdbuff := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						Result := l_p___3
				when 302 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getcmdline_prompt (a_firstc: INTEGER_32; a_prompt: CE_POINTER [NATURAL_8]; a_attr, a_xp_context: INTEGER_32; a_xp_arg: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_s: CE_POINTER [NATURAL_8]
			l_save_ccline: CE_ARRAY [PD_CMDLINE_INFO]
			l_msg_col_save: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_CMDLINE_INFO]} l_save_ccline.make (<<1>>)

			l_msg_col_save := (create {P_GLOBALS_STATIC}).msg_col.item
			save_cmdline (l_save_ccline)
			ccline.item.item.cmdprompt := a_prompt
			ccline.item.item.cmdattr := a_attr
			ccline.item.item.xp_context := a_xp_context
			ccline.item.item.xp_arg := a_xp_arg
			ccline.item.item.input_fn := (a_firstc = 64).to_integer
			l_s := getcmdline (a_firstc, 1, 0)
			l_save_ccline.item.restore_cmdline;
			(create {P_GLOBALS_STATIC}).msg_col.item := l_msg_col_save
			Result := l_s
		end

	text_locked: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (create {P_GLOBALS_STATIC}).cmdwin_type.item /= 0 then
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := ((create {P_GLOBALS_STATIC}).textlock.item /= 0).to_integer
			end
		end

	text_locked_msg
		do
			if (create {P_GLOBALS_STATIC}).cmdwin_type.item /= 0 then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_cmdwin.item)))))).do_nothing
			else
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_secure.item)))))).do_nothing
			end
		end

	curbuf_locked: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (create {P_GLOBALS_STATIC}).curbuf_lock.item > 0 then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E788: Not allowed to edit another buffer now"))))).do_nothing
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := (allbuf_locked)
			end
		end

	allbuf_locked: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (create {P_GLOBALS_STATIC}).allbuf_lock.item > 0 then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E811: Not allowed to change buffer information now"))))).do_nothing
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	cmdline_charsize (a_idx: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (create {P_GLOBALS_STATIC}).cmdline_star.item > 0 then
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := ((create {P_CHARSET_STATIC}).ptr2cells (ccline.item.item.cmdbuff + a_idx))
			end
		end

	set_cmdspos
		do
			if ccline.item.item.cmdfirstc /= 0 then
				ccline.item.item.cmdspos := 1 + ccline.item.item.cmdindent
			else
				ccline.item.item.cmdspos := ccline.item.item.cmdindent
			end
		end

	set_cmdspos_cursor
		local
			l_i___0: INTEGER_32
			l_m: INTEGER_32
			l_c: INTEGER_32
			l_break: BOOLEAN
		do
			set_cmdspos
			if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
				l_m := ((create {P_GLOBALS_STATIC}).Columns.item.item * (create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32
				if l_m < 0 then
					l_m := 2_147_483_647
				end
			else
				l_m := 2_147_483_647
			end
			l_i___0 := 0
			from
			until
				(l_break)
			loop
				l_break := False
				if l_i___0 < ccline.item.item.cmdlen then
					if not (l_i___0 < ccline.item.item.cmdpos) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_c := cmdline_charsize (l_i___0)
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						correct_cmdspos (l_i___0, l_c)
					end
					ccline.item.item.cmdspos := ccline.item.item.cmdspos + l_c
					if ccline.item.item.cmdspos >= l_m then
						ccline.item.item.cmdspos := ccline.item.item.cmdspos - l_c
						l_break := True
					end
				end
				if not (l_break) then
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_i___0 := l_i___0 + (((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([ccline.item.item.cmdbuff + l_i___0])) - 1)
					end
					l_i___0 := l_i___0 + 1
				end
			end
			l_break := False
		end

	correct_cmdspos (a_idx, a_cells: INTEGER_32)
		do
			if ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([ccline.item.item.cmdbuff + a_idx])) > 1 then
				if ((create {P_GLOBALS_STATIC}).mb_ptr2cells.item.integer_32_item ([ccline.item.item.cmdbuff + a_idx])) > 1 then
					if (ccline.item.item.cmdspos).to_integer_32 \\ (create {P_GLOBALS_STATIC}).Columns.item.item + a_cells.to_integer_32 > (create {P_GLOBALS_STATIC}).Columns.item.item then
						ccline.item.item.cmdspos := (ccline.item.item.cmdspos) + 1
					end
				end
			end
		end

	getexline (a_c: INTEGER_32; a_cookie: CE_POINTER [ANY]; a_indent: INTEGER_32): CE_POINTER [NATURAL_8]
		do
			if ((create {P_GLOBALS_STATIC}).exec_from_reg.item).to_boolean then
				if ((create {P_GETCHAR_STATIC}).vpeekc) = 58 then
					(create {P_GETCHAR_STATIC}).vgetc.do_nothing
				end
			end
			Result := (getcmdline (a_c, 1, a_indent))
		end

	cmdline_overstrike: INTEGER_32
		do
			Result := (ccline.item.item.overstrike)
		end

	cmdline_at_end: INTEGER_32
		do
			Result := (ccline.item.item.cmdpos >= ccline.item.item.cmdlen).to_integer
		end

	cmdline_getvcol_cursor: INTEGER_32
		local
			l_col: INTEGER_32
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			if (ccline.item.item.cmdbuff).is_void then
				Result := (2_147_483_647).to_integer_32
				l_return := True
			elseif ccline.item.item.cmdpos > ccline.item.item.cmdlen then
				Result := (2_147_483_647).to_integer_32
				l_return := True
			end
			if not l_return then
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					l_i___0 := 0
					l_col := 0
					from
					until
						not (l_i___0 < ccline.item.item.cmdpos)
					loop
						l_i___0 := l_i___0 + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([ccline.item.item.cmdbuff + l_i___0]))
						l_col := l_col + 1
					end
					Result := l_col
				else
					Result := (ccline.item.item.cmdpos)
				end
			end
		end

	redrawcmd_preedit
		local
			l_cmdpos: INTEGER_32
			l_cmdspos: INTEGER_32
			l_old_row: INTEGER_32
			l_old_col: INTEGER_32
			l_col: INTEGER_32
			l_tmp: INTEGER_32
			l_char_len: INTEGER_32
			l_char_attr: INTEGER_32
			l_break: BOOLEAN
		do
			if (((create {P_GLOBALS_STATIC}).State.item).bit_and (8)).to_boolean then
				if not ((create {P_GLOBALS_STATIC}).xic.item).is_void then
					if not ((create {P_OPTION_STATIC}).p_imdisable.item.item).to_boolean then
						if ((create {P_MBYTE_STATIC}).im_is_preediting).to_boolean then
							l_cmdpos := 0
							l_old_row := (create {P_GLOBALS_STATIC}).msg_row.item
							l_old_col := (create {P_GLOBALS_STATIC}).msg_col.item
							if ccline.item.item.cmdfirstc /= 0 then
								l_tmp := 1
							else
								l_tmp := 0
							end
							l_cmdspos := l_tmp + ccline.item.item.cmdindent
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_col := 0
								from
								until
									(l_break)
								loop
									l_break := False
									if l_col < (create {P_GLOBALS_STATIC}).preedit_start_col.item.item then
										if not (l_cmdpos < ccline.item.item.cmdlen) then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_cmdspos := l_cmdspos + ((create {P_GLOBALS_STATIC}).mb_ptr2cells.item.integer_32_item ([ccline.item.item.cmdbuff + l_cmdpos]))
										l_cmdpos := l_cmdpos + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([ccline.item.item.cmdbuff + l_cmdpos]))
										l_col := l_col + 1
									end
								end
								l_break := False
							else
								l_cmdspos := l_cmdspos + ((create {P_GLOBALS_STATIC}).preedit_start_col.item.item)
								l_cmdpos := l_cmdpos + ((create {P_GLOBALS_STATIC}).preedit_start_col.item.item)
							end
							(create {P_GLOBALS_STATIC}).msg_row.item := (create {P_GLOBALS_STATIC}).cmdline_row.item + l_cmdspos // ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32;
							(create {P_GLOBALS_STATIC}).msg_col.item := l_cmdspos \\ ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32
							if ((create {P_GLOBALS_STATIC}).msg_row.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Rows.item.item then
								(create {P_GLOBALS_STATIC}).msg_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
							end
							l_col := 0
							from
							until
								not (not (l_break) and then (l_cmdpos < ccline.item.item.cmdlen))
							loop
								l_break := False
								l_char_attr := (create {P_MBYTE_STATIC}).im_get_feedback_attr (l_col)
								if l_char_attr < 0 then
									l_break := True
								end
								if not (l_break) then
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_char_len := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([ccline.item.item.cmdbuff + l_cmdpos])
									else
										l_char_len := 1
									end
									(create {P_MESSAGE_STATIC}).msg_outtrans_len_attr (ccline.item.item.cmdbuff + l_cmdpos, l_char_len, l_char_attr).do_nothing
									l_cmdpos := l_cmdpos + l_char_len
									l_col := l_col + 1
								end
							end
							l_break := False;
							(create {P_GLOBALS_STATIC}).msg_row.item := l_old_row;
							(create {P_GLOBALS_STATIC}).msg_col.item := l_old_col
						end
					end
				end
			end
		end

	alloc_cmdbuff (a_len: INTEGER_32)
		local
			l_len: INTEGER_32
		do
			l_len := a_len
			if l_len < 80 then
				l_len := 100
			else
				l_len := l_len + (20)
			end
			ccline.item.item.cmdbuff := (create {P_MISC2_STATIC}).alloc (l_len.to_natural_32)
			ccline.item.item.cmdbufflen := l_len
		end

	realloc_cmdbuff (a_len: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			if a_len < ccline.item.item.cmdbufflen then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_p___0 := ccline.item.item.cmdbuff
				alloc_cmdbuff (a_len)
				if (ccline.item.item.cmdbuff).is_void then
					ccline.item.item.cmdbuff := l_p___0
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				memmove (create {CE_VOID_POINTER}.make_cast (ccline.item.item.cmdbuff), create {CE_VOID_POINTER}.make_cast (l_p___0), (ccline.item.item.cmdlen).to_natural_32).do_nothing
				ccline.item.item.cmdbuff[ccline.item.item.cmdlen] := (('%/0/').code).to_natural_8;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
				if not (ccline.item.item.xpc).is_void then
					if not ((ccline.item.item.xpc).item.xp_pattern).is_void then
						if (ccline.item.item.xpc).item.xp_context /= 0 then
							if (ccline.item.item.xpc).item.xp_context /= -2 then
								l_i___0 := ((ccline.item.item.xpc).item.xp_pattern).distance (l_p___0)
								if l_i___0 >= 0 then
									if l_i___0 <= ccline.item.item.cmdlen then
										(ccline.item.item.xpc).item.xp_pattern := ccline.item.item.cmdbuff + l_i___0
									end
								end
							end
						end
					end
				end
				Result := 1
			end
		end

	draw_cmdline (a_start___1, a_len: INTEGER_32)
		local
			l_i___0: INTEGER_32
		do
			if (create {P_GLOBALS_STATIC}).cmdline_star.item > 0 then
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_len)
				loop
					(create {P_MESSAGE_STATIC}).msg_putchar (('*').code)
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_i___0 := l_i___0 + (((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([(ccline.item.item.cmdbuff + a_start___1) + l_i___0])) - 1)
					end
					l_i___0 := l_i___0 + 1
				end
			else
				(create {P_MESSAGE_STATIC}).msg_outtrans_len (ccline.item.item.cmdbuff + a_start___1, a_len).do_nothing
			end
		end

	putcmdline (a_c, a_shift: INTEGER_32)
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).cmd_silent.item).to_boolean then
				l_return := True
			end
			if not l_return then
				(create {P_GLOBALS_STATIC}).msg_no_more.item := 1;
				(create {P_MESSAGE_STATIC}).msg_putchar (a_c)
				if a_shift.to_boolean then
					draw_cmdline (ccline.item.item.cmdpos, ccline.item.item.cmdlen - ccline.item.item.cmdpos)
				end
				(create {P_GLOBALS_STATIC}).msg_no_more.item := 0
				cursorcmd
			end
		end

	unputcmdline
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).cmd_silent.item).to_boolean then
				l_return := True
			end
			if not l_return then
				(create {P_GLOBALS_STATIC}).msg_no_more.item := 1
				if ccline.item.item.cmdlen = ccline.item.item.cmdpos then
					(create {P_MESSAGE_STATIC}).msg_putchar ((' ').code)
				else
					draw_cmdline (ccline.item.item.cmdpos, 1)
				end
				(create {P_GLOBALS_STATIC}).msg_no_more.item := 0
				cursorcmd
			end
		end

	put_on_cmdline (a_str___1: CE_POINTER [NATURAL_8]; a_len, a_redraw: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_retval: INTEGER_32
			l_i___0: INTEGER_32
			l_m: INTEGER_32
			l_c: INTEGER_32
			l_break: BOOLEAN
		do
			l_len := a_len
			if l_len < 0 then
				l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_str___1))).to_integer_32
			end
			if (ccline.item.item.cmdlen + l_len) + 1 >= ccline.item.item.cmdbufflen then
				l_retval := realloc_cmdbuff ((ccline.item.item.cmdlen + l_len) + 1)
			else
				l_retval := 1
			end
			if l_retval = 1 then
				if not (ccline.item.item.overstrike).to_boolean then
					memmove (create {CE_VOID_POINTER}.make_cast (((ccline.item.item.cmdbuff + ccline.item.item.cmdpos) + l_len)), create {CE_VOID_POINTER}.make_cast ((ccline.item.item.cmdbuff + ccline.item.item.cmdpos)), (ccline.item.item.cmdlen - ccline.item.item.cmdpos).to_natural_32).do_nothing
					ccline.item.item.cmdlen := ccline.item.item.cmdlen + l_len
				elseif ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					l_m := 0
					l_i___0 := 0
					from
					until
						not (l_i___0 < l_len)
					loop
						l_m := l_m + 1
						l_i___0 := l_i___0 + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([a_str___1 + l_i___0]))
					end
					l_i___0 := ccline.item.item.cmdpos
					from
					until
						(l_break)
					loop
						l_break := False
						if l_i___0 < ccline.item.item.cmdlen then
							if not (l_m > 0) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_m := l_m - 1
							l_i___0 := l_i___0 + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([ccline.item.item.cmdbuff + l_i___0]))
						end
					end
					l_break := False
					if l_i___0 < ccline.item.item.cmdlen then
						memmove (create {CE_VOID_POINTER}.make_cast (((ccline.item.item.cmdbuff + ccline.item.item.cmdpos) + l_len)), create {CE_VOID_POINTER}.make_cast ((ccline.item.item.cmdbuff + l_i___0)), (ccline.item.item.cmdlen - l_i___0).to_natural_32).do_nothing
						ccline.item.item.cmdlen := ccline.item.item.cmdlen + ((ccline.item.item.cmdpos + l_len) - l_i___0)
					else
						ccline.item.item.cmdlen := ccline.item.item.cmdpos + l_len
					end
				elseif ccline.item.item.cmdpos + l_len > ccline.item.item.cmdlen then
					ccline.item.item.cmdlen := ccline.item.item.cmdpos + l_len
				end
				memmove (create {CE_VOID_POINTER}.make_cast ((ccline.item.item.cmdbuff + ccline.item.item.cmdpos)), create {CE_VOID_POINTER}.make_cast (a_str___1), l_len.to_natural_32).do_nothing
				ccline.item.item.cmdbuff[ccline.item.item.cmdlen] := (('%/0/').code).to_natural_8
				if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
					l_i___0 := 0
					l_c := (create {P_MBYTE_STATIC}).utf_ptr2char (ccline.item.item.cmdbuff + ccline.item.item.cmdpos)
					from
					until
						(l_break)
					loop
						l_break := False
						if ccline.item.item.cmdpos > 0 then
							if not ((create {P_MBYTE_STATIC}).utf_iscomposing (l_c)).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_i___0 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([ccline.item.item.cmdbuff, (ccline.item.item.cmdbuff + ccline.item.item.cmdpos) - 1])) + 1
							ccline.item.item.cmdpos := ccline.item.item.cmdpos - l_i___0
							l_len := l_len + l_i___0
							l_c := (create {P_MBYTE_STATIC}).utf_ptr2char (ccline.item.item.cmdbuff + ccline.item.item.cmdpos)
						end
					end
					l_break := False
					if l_i___0 /= 0 then
						l_i___0 := (create {P_CHARSET_STATIC}).ptr2cells (ccline.item.item.cmdbuff + ccline.item.item.cmdpos)
						ccline.item.item.cmdspos := ccline.item.item.cmdspos - l_i___0;
						(create {P_GLOBALS_STATIC}).msg_col.item := (create {P_GLOBALS_STATIC}).msg_col.item - l_i___0
						if (create {P_GLOBALS_STATIC}).msg_col.item < 0 then
							(create {P_GLOBALS_STATIC}).msg_col.item := (((create {P_GLOBALS_STATIC}).msg_col.item).to_integer_32 + (create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32;
							(create {P_GLOBALS_STATIC}).msg_row.item := (create {P_GLOBALS_STATIC}).msg_row.item - 1
						end
					end
				end
				if a_redraw.to_boolean then
					if not ((create {P_GLOBALS_STATIC}).cmd_silent.item).to_boolean then
						(create {P_GLOBALS_STATIC}).msg_no_more.item := 1
						l_i___0 := (create {P_GLOBALS_STATIC}).cmdline_row.item
						draw_cmdline (ccline.item.item.cmdpos, ccline.item.item.cmdlen - ccline.item.item.cmdpos)
						if (create {P_GLOBALS_STATIC}).cmdline_row.item /= l_i___0 then
							(create {P_MESSAGE_STATIC}).msg_clr_eos
						elseif (ccline.item.item.overstrike).to_boolean then
							(create {P_MESSAGE_STATIC}).msg_clr_eos
						end
						(create {P_GLOBALS_STATIC}).msg_no_more.item := 0
					end
				end
				if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
					l_m := ((create {P_GLOBALS_STATIC}).Columns.item.item * (create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32
					if l_m < 0 then
						l_m := 2_147_483_647
					end
				else
					l_m := 2_147_483_647
				end
				l_i___0 := 0
				from
				until
					not (l_i___0 < l_len)
				loop
					l_c := cmdline_charsize (ccline.item.item.cmdpos)
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						correct_cmdspos (ccline.item.item.cmdpos, l_c)
					end
					if ccline.item.item.cmdspos + l_c < l_m then
						ccline.item.item.cmdspos := ccline.item.item.cmdspos + l_c
					end
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_c := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([ccline.item.item.cmdbuff + ccline.item.item.cmdpos])) - 1
						if l_c > (l_len - l_i___0) - 1 then
							l_c := (l_len - l_i___0) - 1
						end
						ccline.item.item.cmdpos := ccline.item.item.cmdpos + l_c
						l_i___0 := l_i___0 + l_c
					end
					ccline.item.item.cmdpos := (ccline.item.item.cmdpos) + 1
					l_i___0 := l_i___0 + 1
				end
			end
			if a_redraw.to_boolean then
				(create {P_MESSAGE_STATIC}).msg_check
			end
			Result := l_retval
		end

	save_cmdline (a_ccp: CE_POINTER [PD_CMDLINE_INFO])
		require
			not a_ccp.is_void
		do
			if not prev_ccline_used.item.to_boolean then
				memset (create {CE_VOID_POINTER}.make_cast (prev_ccline.item), 0, (create {PD_CMDLINE_INFO}.make).structure_size.to_natural_32).do_nothing
				prev_ccline_used.item := 1
			end
			a_ccp.item := (prev_ccline.item.item).twin
			prev_ccline.item.item := (ccline.item.item).twin
			ccline.item.item.cmdbuff := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			ccline.item.item.cmdprompt := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			ccline.item.item.xpc := create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (default_pointer)
		end

	save_cmdline_alloc: CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [PD_CMDLINE_INFO]
		do
			l_p___0 := create {CE_CLASS_POINTER [PD_CMDLINE_INFO]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_CMDLINE_INFO}.make).structure_size.to_natural_32)))
			if not l_p___0.is_void then
				save_cmdline (l_p___0)
			end
			Result := (create {CE_NATURAL_8_POINTER}.make_cast (l_p___0))
		end

	restore_cmdline_alloc (a_p___0: CE_POINTER [NATURAL_8])
		do
			if not a_p___0.is_void then
				(create {CE_CLASS_POINTER [PD_CMDLINE_INFO]}.make_cast (a_p___0)).item.restore_cmdline;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_p___0))
			end
		end

	cmdline_paste (a_regname___0, a_literally, a_remcr: INTEGER_32): INTEGER_32
		local
			l_regname___0: INTEGER_32
			l_i___0: INTEGER_32
			l_arg: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_allocated: CE_ARRAY [INTEGER_32]
			l_save_ccline: CE_ARRAY [PD_CMDLINE_INFO]
			l_w: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp___7: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_arg.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_allocated.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_CMDLINE_INFO]} l_save_ccline.make (<<1>>)

			l_regname___0 := a_regname___0
			if l_regname___0 /= 6 then
				if l_regname___0 /= 16 then
					if l_regname___0 /= 23 then
						if l_regname___0 /= 1 then
							if not ((create {P_OPS_STATIC}).valid_yank_reg (l_regname___0, 0)).to_boolean then
								Result := 0
								l_return := True
							end
						end
					end
				end
			end
			if not l_return then
				(create {P_MISC1_STATIC}).line_breakcheck
				if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_regname___0 := (create {P_OPS_STATIC}).may_get_selection (l_regname___0)
				save_cmdline (l_save_ccline);
				(create {P_GLOBALS_STATIC}).textlock.item := (create {P_GLOBALS_STATIC}).textlock.item + 1
				l_i___0 := ((create {P_OPS_STATIC}).get_spec_reg (l_regname___0, l_arg, l_allocated, 1)).to_integer_32;
				(create {P_GLOBALS_STATIC}).textlock.item := (create {P_GLOBALS_STATIC}).textlock.item - 1
				l_save_ccline.item.restore_cmdline
				if l_i___0.to_boolean then
					if (l_arg.item).is_void then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_p___0 := l_arg.item
						if ((create {P_OPTION_STATIC}).p_is.item.item).to_boolean then
							if l_regname___0 = 23 then
								l_w := ccline.item.item.cmdbuff + ccline.item.item.cmdlen
								from
								until
									not (not (l_break) and then ((l_w.c_pointer.to_integer_32).to_natural_32 > ((ccline.item.item.cmdbuff).c_pointer.to_integer_32).to_natural_32))
								loop
									l_break := False
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_len := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([ccline.item.item.cmdbuff, l_w - 1])) + 1
										if not ((create {P_CHARSET_STATIC}).vim_iswordc (((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_w - l_len])))).to_boolean then
											l_break := True
										end
										if not (l_break) then
											l_w := l_w - l_len
										end
									else
										if not ((create {P_CHARSET_STATIC}).vim_iswordc ((l_w[-1]).to_integer_32)).to_boolean then
											l_break := True
										end
										if not (l_break) then
											l_w := l_w - 1
										end
									end
								end
								l_break := False
								l_len := (ccline.item.item.cmdbuff + ccline.item.item.cmdlen).distance (l_w)
								if ((create {P_OPTION_STATIC}).p_ic.item.item).to_boolean then
									l_tmp___7 := ((strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_w), create {CE_INTEGER_8_POINTER}.make_cast (l_arg.item), l_len.to_natural_32)) = 0).to_integer
								else
									l_tmp___7 := ((strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_w), create {CE_INTEGER_8_POINTER}.make_cast (l_arg.item), l_len.to_natural_32)) = 0).to_integer
								end
								if l_tmp___7.to_boolean then
									l_p___0 := l_p___0 + l_len
								end
							end
						end
						cmdline_paste_str (l_p___0, a_literally)
						if (l_allocated.item).to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_arg.item))
						end
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return then
				Result := ((create {P_OPS_STATIC}).cmdline_paste_reg (l_regname___0, a_literally, a_remcr))
			end
		end

	cmdline_paste_str (a_s: CE_POINTER [NATURAL_8]; a_literally: INTEGER_32)
		local
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_c: INTEGER_32
			l_cv: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s.make (<<1>>)

			l_s.item := a_s
			if a_literally.to_boolean then
				put_on_cmdline (l_s.item, -1, 1).do_nothing
			else
				from
				until
					(l_s.item.item).to_integer_32 = 0
				loop
					l_cv := (l_s.item.item).to_integer_32
					if l_cv = 22 then
						if (l_s.item[1]).to_boolean then
							l_s.item := l_s.item + 1
						end
					end
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_c := (create {P_MBYTE_STATIC}).mb_cptr2char_adv (l_s)
					else
						l_tmp := l_s.item
						l_s.item := l_s.item + 1
						l_c := (l_tmp.item).to_integer_32
					end
					if l_cv = 22 then
						(create {P_GETCHAR_STATIC}).stuffcharReadbuff (22)
					elseif l_c = 27 then
						(create {P_GETCHAR_STATIC}).stuffcharReadbuff (22)
					elseif l_c = 3 then
						(create {P_GETCHAR_STATIC}).stuffcharReadbuff (22)
					elseif l_c = 13 then
						(create {P_GETCHAR_STATIC}).stuffcharReadbuff (22)
					elseif l_c = 10 then
						(create {P_GETCHAR_STATIC}).stuffcharReadbuff (22)
					elseif l_c = (create {P_GLOBALS_STATIC}).intr_char.item then
						(create {P_GETCHAR_STATIC}).stuffcharReadbuff (22)
					elseif l_c = 28 then
						if (l_s.item.item).to_integer_32 = 14 then
							(create {P_GETCHAR_STATIC}).stuffcharReadbuff (22)
						end
					end
					(create {P_GETCHAR_STATIC}).stuffcharReadbuff (l_c)
				end
			end
		end

	cmdline_del (a_from: INTEGER_32)
		do
			memmove (create {CE_VOID_POINTER}.make_cast ((ccline.item.item.cmdbuff + a_from)), create {CE_VOID_POINTER}.make_cast ((ccline.item.item.cmdbuff + ccline.item.item.cmdpos)), ((ccline.item.item.cmdlen - ccline.item.item.cmdpos) + 1).to_natural_32).do_nothing
			ccline.item.item.cmdlen := ccline.item.item.cmdlen - (ccline.item.item.cmdpos - a_from)
			ccline.item.item.cmdpos := a_from
		end

	redrawcmdline
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).cmd_silent.item).to_boolean then
				l_return := True
			end
			if not l_return then
				(create {P_GLOBALS_STATIC}).need_wait_return.item := 0
				compute_cmdrow
				redrawcmd
				cursorcmd
			end
		end

	redrawcmdprompt
		local
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).cmd_silent.item).to_boolean then
				l_return := True
			end
			if not l_return then
				if ccline.item.item.cmdfirstc /= 0 then
					(create {P_MESSAGE_STATIC}).msg_putchar (ccline.item.item.cmdfirstc)
				end
				if not (ccline.item.item.cmdprompt).is_void then
					(create {P_MESSAGE_STATIC}).msg_puts_attr (ccline.item.item.cmdprompt, ccline.item.item.cmdattr)
					ccline.item.item.cmdindent := (((create {P_GLOBALS_STATIC}).msg_col.item).to_integer_32 + ((create {P_GLOBALS_STATIC}).msg_row.item - (create {P_GLOBALS_STATIC}).cmdline_row.item).to_integer_32 * (create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32
					if ccline.item.item.cmdfirstc /= 0 then
						ccline.item.item.cmdindent := (ccline.item.item.cmdindent) - 1
					end
				else
					l_i___0 := ccline.item.item.cmdindent
					from
					until
						not (l_i___0 > 0)
					loop
						(create {P_MESSAGE_STATIC}).msg_putchar ((' ').code)
						l_i___0 := l_i___0 - 1
					end
				end
			end
		end

	redrawcmd
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).cmd_silent.item).to_boolean then
				l_return := True
			end
			if not l_return and then ((ccline.item.item.cmdbuff).is_void) then
				(create {P_SCREEN_STATIC}).windgoto ((create {P_GLOBALS_STATIC}).cmdline_row.item, 0);
				(create {P_MESSAGE_STATIC}).msg_clr_eos
				l_return := True
			end
			if not l_return then
				(create {P_MESSAGE_STATIC}).msg_start
				redrawcmdprompt;
				(create {P_GLOBALS_STATIC}).msg_no_more.item := 1
				draw_cmdline (0, ccline.item.item.cmdlen);
				(create {P_MESSAGE_STATIC}).msg_clr_eos;
				(create {P_GLOBALS_STATIC}).msg_no_more.item := 0
				set_cmdspos_cursor;
				(create {P_GLOBALS_STATIC}).msg_scroll.item := 0;
				(create {P_GLOBALS_STATIC}).skip_redraw.item := 0
			end
		end

	compute_cmdrow
		do
			if ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
				(create {P_GLOBALS_STATIC}).cmdline_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
			elseif (create {P_GLOBALS_STATIC}).msg_scrolled.item /= 0 then
				(create {P_GLOBALS_STATIC}).cmdline_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
			else
				(create {P_GLOBALS_STATIC}).cmdline_row.item := ((create {P_GLOBALS_STATIC}).lastwin.item.item.w_winrow + (create {P_GLOBALS_STATIC}).lastwin.item.item.w_height) + (create {P_GLOBALS_STATIC}).lastwin.item.item.w_status_height
			end
		end

	cursorcmd
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).cmd_silent.item).to_boolean then
				l_return := True
			end
			if not l_return then
				(create {P_GLOBALS_STATIC}).msg_row.item := (create {P_GLOBALS_STATIC}).cmdline_row.item + ccline.item.item.cmdspos // ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32;
				(create {P_GLOBALS_STATIC}).msg_col.item := ccline.item.item.cmdspos \\ ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32
				if ((create {P_GLOBALS_STATIC}).msg_row.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Rows.item.item then
					(create {P_GLOBALS_STATIC}).msg_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
				end
				(create {P_SCREEN_STATIC}).windgoto ((create {P_GLOBALS_STATIC}).msg_row.item, (create {P_GLOBALS_STATIC}).msg_col.item)
				redrawcmd_preedit
			end
		end

	gotocmdline (a_clr: INTEGER_32)
		do
			(create {P_MESSAGE_STATIC}).msg_start;
			(create {P_GLOBALS_STATIC}).msg_col.item := 0
			if a_clr.to_boolean then
				(create {P_MESSAGE_STATIC}).msg_clr_eos
			end
			(create {P_SCREEN_STATIC}).windgoto ((create {P_GLOBALS_STATIC}).cmdline_row.item, 0)
		end

	ccheck_abbr (a_c: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_OPTION_STATIC}).p_paste.item.item).to_boolean then
				Result := 0
				l_return := True
			elseif ((create {P_GLOBALS_STATIC}).no_abbr.item).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := ((create {P_GETCHAR_STATIC}).check_abbr (a_c, ccline.item.item.cmdbuff, ccline.item.item.cmdpos, 0))
			end
		end

	ExpandEscape (a_xp: CE_POINTER [PD_EXPAND]; a_str___1: CE_POINTER [NATURAL_8]; a_numfiles: INTEGER_32; a_files: CE_POINTER [CE_POINTER [NATURAL_8]]; a_options___0: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((a_options___0).bit_and (2)).to_boolean then
						tilde_replace (a_str___1, a_numfiles, a_files)
					end
					if not (((a_options___0).bit_and (128)).to_boolean) then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if a_xp.item.xp_context /= 2 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						if a_xp.item.xp_context /= 32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else:
						if a_xp.item.xp_context /= 9 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if a_xp.item.xp_context /= 3 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if: | _L:
						l_i___0 := 0
						from
						until
							not (l_i___0 < a_numfiles)
						loop
							if a_xp.item.xp_backslash = 2 then
								l_p___0 := (create {P_MISC2_STATIC}).vim_strsave_escaped (a_files[l_i___0], create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
								if not l_p___0.is_void then
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_files[l_i___0]))
									a_files[l_i___0] := l_p___0
								end
							end
							l_p___0 := vim_strsave_fnameescape (a_files[l_i___0], a_xp.item.xp_shell)
							if not l_p___0.is_void then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_files[l_i___0]))
								a_files[l_i___0] := l_p___0
							end
							if (a_str___1[0]).to_integer_32 = 92 then
								if (a_str___1[1]).to_integer_32 = 126 then
									if ((a_files[l_i___0])[0]).to_integer_32 = 126 then
										escape_fname (a_files + l_i___0)
									end
								end
							end
							l_i___0 := l_i___0 + 1
						end
						a_xp.item.xp_backslash := 0
						if ((a_files[0]).item).to_integer_32 = 43 then
							escape_fname (a_files + 0)
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						if a_xp.item.xp_context = 6 then
							l_i___0 := 0
							from
							until
								not (l_i___0 < a_numfiles)
							loop
								l_p___0 := (create {P_MISC2_STATIC}).vim_strsave_escaped (a_files[l_i___0], create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("\|%"")))
								if not l_p___0.is_void then
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_files[l_i___0]))
									a_files[l_i___0] := l_p___0
								end
								l_i___0 := l_i___0 + 1
							end
						end
				when 14 then -- if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vim_strsave_fnameescape (a_fname: CE_POINTER [NATURAL_8]; a_shell: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			if a_shell.to_boolean then
				l_tmp := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" %T%N*?[{`$\%%#%'%"|!<>();&"))
			else
				l_tmp := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" %T%N*?[{`$\%%#%'%"|!<"))
			end
			l_p___0.item := (create {P_MISC2_STATIC}).vim_strsave_escaped (a_fname, l_tmp)
			if a_shell.to_boolean then
				if ((create {P_MISC2_STATIC}).csh_like_shell).to_boolean then
					if not (l_p___0.item).is_void then
						l_s := (create {P_MISC2_STATIC}).vim_strsave_escaped (l_p___0.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("!")));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0.item))
						l_p___0.item := l_s
					end
				end
			end
			if not (l_p___0.item).is_void then
				if (l_p___0.item.item).to_integer_32 = 62 then
					escape_fname (l_p___0)
				elseif (l_p___0.item.item).to_integer_32 = 43 then
					escape_fname (l_p___0)
				elseif (l_p___0.item.item).to_integer_32 = 45 then
					if (l_p___0.item[1]).to_integer_32 = 0 then
						escape_fname (l_p___0)
					end
				end
			end
			Result := (l_p___0.item)
		end

	escape_fname (a_pp: CE_POINTER [CE_POINTER [NATURAL_8]])
		require
			not a_pp.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			l_p___0 := (create {P_MISC2_STATIC}).alloc ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_pp.item))) + {NATURAL_32} 2)
			if not l_p___0.is_void then
				l_p___0[0] := (('\').code).to_natural_8
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 1)), create {CE_INTEGER_8_POINTER}.make_cast (a_pp.item)).do_nothing;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_pp.item))
				a_pp.item := l_p___0
			end
		end

	tilde_replace (a_orig_pat: CE_POINTER [NATURAL_8]; a_num_files: INTEGER_32; a_files: CE_POINTER [CE_POINTER [NATURAL_8]])
		require
			not a_orig_pat.is_void
		local
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
		do
			if (a_orig_pat[0]).to_integer_32 = 126 then
				if ((create {P_MISC1_STATIC}).vim_ispathsep ((a_orig_pat[1]).to_integer_32)).to_boolean then
					l_i___0 := 0
					from
					until
						not (l_i___0 < a_num_files)
					loop
						l_p___0 := (create {P_MISC1_STATIC}).home_replace_save (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), a_files[l_i___0])
						if not l_p___0.is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_files[l_i___0]))
							a_files[l_i___0] := l_p___0
						end
						l_i___0 := l_i___0 + 1
					end
				end
			end
		end

	addstar (a_fname: CE_POINTER [NATURAL_8]; a_len, a_context: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_len: INTEGER_32
			l_retval: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_new_len: INTEGER_32
			l_tail: CE_POINTER [NATURAL_8]
			l_ends_in_star: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := a_len
					if a_context = 2 then
						l_pos := -1 + 49 -- skip if block
					end
				when 1 then -- if:
						if a_context = 38 then
							l_pos := -1 + 47 -- skip if block
						end
				when 2 then -- if:
						if a_context = 32 then
							l_pos := -1 + 45 -- skip if block
						end
				when 3 then -- if:
						if a_context = 3 then
							l_pos := -1 + 43 -- skip if block
						end
				when 4 then -- if:
						if a_context /= 8 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_retval := (create {P_MISC2_STATIC}).vim_strnsave (a_fname, l_len)
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 7 then -- else:
						if a_context /= 28 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_retval := (create {P_MISC2_STATIC}).vim_strnsave (a_fname, l_len)
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 10 then -- else:
						if a_context /= 29 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_retval := (create {P_MISC2_STATIC}).vim_strnsave (a_fname, l_len)
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 13 then -- else:
						if a_context /= 39 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_retval := (create {P_MISC2_STATIC}).vim_strnsave (a_fname, l_len)
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 16 then -- else:
						if a_context /= 37 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_retval := (create {P_MISC2_STATIC}).vim_strnsave (a_fname, l_len)
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 19 then -- else:
						if a_context /= 6 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if (a_fname[0]).to_integer_32 = 47 then
							l_retval := (create {P_MISC2_STATIC}).vim_strnsave (a_fname, l_len)
						else
							l_pos := -1 + 22 -- goto _L___0
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 22 then -- else: | _L___0:
						l_new_len := l_len + 2
						l_i___0 := 0
				when 23 then -- loop condition:
						if not (l_i___0 < l_len) then
							l_pos := -1 + 30 -- skip loop
						end
				when 24 then -- loop body:
						if (a_fname[l_i___0]).to_integer_32 = 42 then
							l_new_len := l_new_len + 1
						elseif (a_fname[l_i___0]).to_integer_32 = 126 then
							l_new_len := l_new_len + 1
						end
						if a_context = 9 then
							if (a_fname[l_i___0]).to_integer_32 = 46 then
								l_new_len := l_new_len + 1
							end
						end
						if a_context /= 30 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 27 then -- else:
						if a_context /= 31 then
							l_pos := -1 + 29 -- skip if block
						end
				when 28 then -- if: | _L:
						if (a_fname[l_i___0]).to_integer_32 = 92 then
							l_new_len := l_new_len + 1
						end
				when 29 then -- if done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 23 -- back to loop condition
				when 30 then -- loop done
						l_retval := (create {P_MISC2_STATIC}).alloc (l_new_len.to_natural_32)
						if l_retval.is_void then
							l_pos := -1 + 42 -- skip if block
						end
				when 31 then -- if:
						l_retval[0] := (('^').code).to_natural_8
						l_j := 1
						l_i___0 := 0
				when 32 then -- loop condition:
						if not (not (l_break) and then (l_i___0 < l_len)) then
							l_pos := -1 + 41 -- skip loop
						end
				when 33 then -- loop body:
						l_break := False
						l_continue := False
						if a_context /= 30 then
							if a_context /= 31 then
								if (a_fname[l_i___0]).to_integer_32 = 92 then
									l_i___0 := l_i___0 + 1
									if l_i___0 = l_len then
										l_break := True
									end
								end
							end
						end
						if (l_break or l_continue) then
							l_pos := -1 + 40 -- skip if block
						end
				when 34 then -- if:
						inspect (a_fname[l_i___0]).to_integer_32 -- switch 1 head
						when 42 then l_pos := -1 + 35
						when 126 then l_pos := -1 + 36
						when 63 then l_pos := -1 + 37
						when 46 then l_pos := -1 + 38
						when 92 then l_pos := -1 + 39
						else l_pos := -1 + 40
						end
				when 35 then -- switch 1, case 42
						l_tmp := l_j
						l_j := l_j + 1
						l_retval[l_tmp] := (('.').code).to_natural_8
						l_pos := -1 + 40 -- switch 1; break
				when 36 then -- switch 1, case 126
						l_tmp___0 := l_j
						l_j := l_j + 1
						l_retval[l_tmp___0] := (('\').code).to_natural_8
						l_pos := -1 + 40 -- switch 1; break
				when 37 then -- switch 1, case 63
						l_retval[l_j] := (('.').code).to_natural_8
						l_continue := True
				when 38 then -- switch 1, case 46
						if not (l_break or l_continue) and then (a_context = 9) then
							l_tmp___1 := l_j
							l_j := l_j + 1
							l_retval[l_tmp___1] := (('\').code).to_natural_8
						end
						l_pos := -1 + 40 -- switch 1; break
				when 39 then -- switch 1, case 92
						if a_context = 30 then
							l_tmp___2 := l_j
							l_j := l_j + 1
							l_retval[l_tmp___2] := (('\').code).to_natural_8
						elseif a_context = 31 then
							l_tmp___2 := l_j
							l_j := l_j + 1
							l_retval[l_tmp___2] := (('\').code).to_natural_8
						end
						l_pos := -1 + 40 -- switch 1; break
				when 40 then -- switch 1, done: | if done
						if not (l_break or l_continue) then
							l_retval[l_j] := a_fname[l_i___0]
						end
						if (not l_break) then
							l_i___0 := l_i___0 + 1
							l_j := l_j + 1
						end
						l_pos := -1 + 32 -- back to loop condition
				when 41 then -- loop done
						l_break := False
						l_continue := False
						l_retval[l_j] := (('%/0/').code).to_natural_8
				when 42 then -- if done | if done | if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else:
						l_pos := -1 + 49 -- goto _L___7
				when 44 then -- if done | if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else:
						l_pos := -1 + 49 -- goto _L___7
				when 46 then -- if done | if block done, skip else block:
						l_pos := -1 + 48
				when 47 then -- else:
						l_pos := -1 + 49 -- goto _L___7
				when 48 then -- if done | if block done, skip else block:
						l_pos := -1 + 58
				when 49 then -- else: | _L___7:
						l_retval := (create {P_MISC2_STATIC}).alloc ((l_len + 4).to_natural_32)
						if l_retval.is_void then
							l_pos := -1 + 58 -- skip if block
						end
				when 50 then -- if:;
						(create {P_MISC2_STATIC}).vim_strncpy (l_retval, a_fname, l_len.to_natural_32)
						l_tail := (create {P_MISC1_STATIC}).gettail (l_retval)
						if l_len > 0 then
							if (l_retval[(l_len - 1)]).to_integer_32 = 42 then
								l_tmp___3 := 1
							else
								l_tmp___3 := 0
							end
						else
							l_tmp___3 := 0
						end
						l_ends_in_star := l_tmp___3
						l_i___0 := l_len - 2
						from
						until
							not (not (l_break) and then (l_i___0 >= 0))
						loop
							l_break := False
							if (l_retval[l_i___0]).to_integer_32 /= 92 then
								l_break := True
							end
							if not (l_break or l_continue) then
								l_ends_in_star := (not l_ends_in_star.to_boolean).to_integer
								l_i___0 := l_i___0 - 1
							end
						end
						l_break := False
						if (l_retval.item).to_integer_32 = 126 then
							l_pos := -1 + 53 -- skip if block
						end
				when 51 then -- if:
						l_pos := -1 + 54 -- goto _L___4
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 53 then -- else:
						if l_tail.is_equal (l_retval) then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if: | _L___4:
						if not l_ends_in_star.to_boolean then
							if ((create {P_MISC2_STATIC}).vim_strchr (l_tail, ('$').code)).is_void then
								if ((create {P_MISC2_STATIC}).vim_strchr (l_retval, ('`').code)).is_void then
									l_tmp___4 := l_len
									l_len := l_len + 1
									l_retval[l_tmp___4] := (('*').code).to_natural_8
								else
									l_pos := -1 + 56 -- goto _L___3
								end
							else
								l_pos := -1 + 56 -- goto _L___3
							end
						else
							l_pos := -1 + 56 -- goto _L___3
						end
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 56 then -- else: | _L___3:
						if l_len > 0 then
							if (l_retval[(l_len - 1)]).to_integer_32 = 36 then
								l_len := l_len - 1
							end
						end
				when 57 then -- if done
						l_retval[l_len] := (('%/0/').code).to_natural_8
				when 58 then -- if done
					Result := l_retval
				when 59 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_cmd_context (a_xp: CE_POINTER [PD_EXPAND]; a_str___1: CE_POINTER [NATURAL_8]; a_len, a_col: INTEGER_32)
		require
			not a_str___1.is_void
		local
			l_old_char___0: INTEGER_32
			l_nextcomm: CE_POINTER [NATURAL_8]
		do
			l_old_char___0 := ('%/0/').code
			if a_col < a_len then
				l_old_char___0 := (a_str___1[a_col]).to_integer_32
			end
			a_str___1[a_col] := (('%/0/').code).to_natural_8
			l_nextcomm := a_str___1
			if ccline.item.item.cmdfirstc = 61 then
				a_xp.item.set_context_for_expression (a_str___1, {PC_CMD_INDEX}.CMD_SIZE)
			elseif (ccline.item.item.input_fn).to_boolean then
				a_xp.item.xp_context := ccline.item.item.xp_context
				a_xp.item.xp_pattern := ccline.item.item.cmdbuff
				a_xp.item.xp_arg := ccline.item.item.xp_arg
			else
				from
				until
					l_nextcomm.is_void
				loop
					l_nextcomm := a_xp.item.set_one_cmd_context (l_nextcomm)
				end
			end
			a_str___1[a_col] := l_old_char___0.to_natural_8
		end

	globpath (a_path, a_file: CE_POINTER [NATURAL_8]; a_expand_options: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_path: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_xpc: CE_ARRAY [PD_EXPAND]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_num_p: CE_ARRAY [INTEGER_32]
			l_p___0: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_cur: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___4: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_path.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_EXPAND]} l_xpc.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_num_p.make (<<1>>)
			create {CE_POINTER_ARRAY [CE_POINTER [NATURAL_8]]} l_p___0.make (<<1>>)

			l_path.item := a_path
			l_cur := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_buf___6 := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 4_096)
			if l_buf___6.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_xpc.item.ExpandInit
				l_xpc.item.xp_context := 2
				l_ga.item.ga_init2 (1, 100)
				from
				until
					not (not (l_return) and then ((l_path.item.item).to_integer_32 /= 0))
				loop
					(create {P_MISC2_STATIC}).copy_option_part (l_path, l_buf___6, 4_096, ce_string (",")).do_nothing
					l_tmp___4 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))
					if (l_tmp___4 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_file)))) + {NATURAL_32} 2 < {NATURAL_32} 4_096 then
						(create {P_MISC1_STATIC}).add_pathsep (l_buf___6)
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (a_file)).do_nothing
						if (l_xpc.item.ExpandFromContext (l_buf___6, l_num_p, l_p___0, (64).bit_or (a_expand_options))) /= 0 then
							if l_num_p.item > 0 then
								ExpandEscape (l_xpc, l_buf___6, l_num_p.item, l_p___0.item, (64).bit_or (a_expand_options))
								l_len := 0
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_num_p.item)
								loop
									l_len := l_len + ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item[l_i___0]))).to_integer_32 + 1)
									l_i___0 := l_i___0 + 1
								end
								if (l_ga.item.ga_grow (l_len)) = 1 then
									l_cur := create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data) + l_ga.item.ga_len
									l_i___0 := 0
									from
									until
										not (l_i___0 < l_num_p.item)
									loop
										strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_cur), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item[l_i___0])).do_nothing
										l_cur := l_cur + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item[l_i___0]))).to_integer_32
										l_tmp___1 := l_cur
										l_cur := l_cur + 1
										l_tmp___1.item := (('%N').code).to_natural_8
										l_i___0 := l_i___0 + 1
									end
									l_ga.item.ga_len := l_ga.item.ga_len + l_len
								end
								(create {P_MISC1_STATIC}).FreeWild (l_num_p.item, l_p___0.item)
							end
						end
					end
				end
				if not l_cur.is_void then
					l_cur := l_cur - 1
					l_cur.item := (0).to_natural_8
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data))
			end
		end

	hist_char2type (a_c: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_c = 58 then
				Result := 0
				l_return := True
			end
			if not l_return and then (a_c = 61) then
				Result := 2
				l_return := True
			end
			if not l_return and then (a_c = 64) then
				Result := 3
				l_return := True
			end
			if not l_return and then (a_c = 62) then
				Result := 4
				l_return := True
			end
			if not l_return then
				Result := 1
			end
		end

	init_history
		local
			l_newlen: INTEGER_32
			l_temp: CE_POINTER [PD_HIST_ENTRY]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_type: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_newlen := ((create {P_OPTION_STATIC}).p_hi.item.item).to_integer_32
					if l_newlen = hislen.item then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_type := 0
				when 2 then -- loop condition:
						if not (not (l_return or l_break) and then (l_type < 5)) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						if l_newlen.to_boolean then
							l_temp := create {CE_CLASS_POINTER [PD_HIST_ENTRY]}.make_cast (((create {P_MISC2_STATIC}).lalloc ((l_newlen.to_natural_32 * (create {PD_HIST_ENTRY}.make).structure_size.to_natural_32).to_natural_32, 1)))
							if l_temp.is_void then
								if l_type = 0 then
									l_newlen := hislen.item
									l_break := True
								end
								if not (l_return or l_break or l_continue) then
									l_newlen := 0
									l_type := -1
									l_continue := True
								end
							end
						else
							l_temp := create {CE_CLASS_POINTER [PD_HIST_ENTRY]}.make_shared (default_pointer)
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if l_newlen /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if l_temp.is_void then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if hisidx.item[l_type] < 0 then
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_newlen)
							loop
								(l_temp + l_i___0).item.hisnum := 0;
								(l_temp + l_i___0).item.hisstr := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								l_i___0 := l_i___0 + 1
							end
						elseif l_newlen > hislen.item then
							l_i___0 := 0
							from
							until
								not (l_i___0 <= hisidx.item[l_type])
							loop
								l_temp[l_i___0] := ((history.item[l_type])[l_i___0]).twin
								l_i___0 := l_i___0 + 1
							end
							l_j := l_i___0
							from
							until
								not (l_i___0 <= l_newlen - (hislen.item - hisidx.item[l_type]))
							loop
								(l_temp + l_i___0).item.hisnum := 0;
								(l_temp + l_i___0).item.hisstr := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								l_i___0 := l_i___0 + 1
							end
							from
							until
								not (l_j < hislen.item)
							loop
								l_temp[l_i___0] := ((history.item[l_type])[l_j]).twin
								l_i___0 := l_i___0 + 1
								l_j := l_j + 1
							end
						else
							l_j := hisidx.item[l_type]
							l_i___0 := l_newlen - 1
							from
							until
								(l_break)
							loop
								l_break := False
								if l_i___0 >= 0 then
									l_temp[l_i___0] := ((history.item[l_type])[l_j]).twin
								else
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((history.item[l_type] + l_j).item.hisstr))
								end
								l_j := l_j - 1
								if l_j < 0 then
									l_j := hislen.item - 1
								end
								if l_j = hisidx.item[l_type] then
									l_break := True
								end
								if not (l_break) then
									l_i___0 := l_i___0 - 1
								end
							end
							l_break := False
							hisidx.item[l_type] := l_newlen - 1
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (history.item[l_type]))
						history.item[l_type] := l_temp
				when 9 then -- if done | if done
						if (not l_return and not l_break) then
							l_type := l_type + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						l_break := False
						l_continue := False
						hislen.item := l_newlen
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	in_history (a_type: INTEGER_32; a_str___1: CE_POINTER [NATURAL_8]; a_move_to_front: INTEGER_32): INTEGER_32
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_last_i: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_str___1 := a_str___1
			l_last_i := -1
			if hisidx.item[a_type] < 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_i___0 := hisidx.item[a_type]
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if ((history.item[a_type] + l_i___0).item.hisstr).is_void then
						Result := 0
						l_return := True
					end
					if not l_return then
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_str___1), create {CE_INTEGER_8_POINTER}.make_cast ((history.item[a_type] + l_i___0).item.hisstr))) = 0 then
							if not a_move_to_front.to_boolean then
								Result := 1
								l_return := True
							end
							if not l_return then
								l_last_i := l_i___0
								l_break := True
							end
						end
						if not (l_return or l_break) then
							l_i___0 := l_i___0 - 1
							if l_i___0 < 0 then
								l_i___0 := hislen.item - 1
							end
							if l_i___0 = hisidx.item[a_type] then
								l_break := True
							end
						end
					end
				end
			end
			if not l_return then
				l_break := False
				if l_last_i >= 0 then
					l_str___1 := (history.item[a_type] + l_i___0).item.hisstr
					from
					until
						l_i___0 = hisidx.item[a_type]
					loop
						l_i___0 := l_i___0 + 1
						if l_i___0 >= hislen.item then
							l_i___0 := 0
						end
						(history.item[a_type])[l_last_i] := ((history.item[a_type])[l_i___0]).twin
						l_last_i := l_i___0
					end
					(history.item[a_type] + l_i___0).item.hisstr := l_str___1
					hisnum.item[a_type] := (hisnum.item[a_type]) + 1;
					(history.item[a_type] + l_i___0).item.hisnum := hisnum.item[a_type]
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	get_histtype (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_return: BOOLEAN
		do
			l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1))).to_integer_32
			if l_len = 0 then
				Result := (hist_char2type (ccline.item.item.cmdfirstc))
				l_return := True
			end
			if not l_return then
				l_i___0 := 0
				from
				until
					not (not (l_return) and then (not (history_names.item[l_i___0]).is_void))
				loop
					if (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), history_names.item[l_i___0], l_len.to_natural_32)) = 0 then
						Result := l_i___0
						l_return := True
					end
					if not l_return then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not l_return then
				if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":=@>?/")), (a_name___1[0]).to_integer_32)).is_void then
					if (a_name___1[1]).to_integer_32 = 0 then
						Result := (hist_char2type ((a_name___1[0]).to_integer_32))
						l_return := True
					end
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

	add_to_history (a_histype: INTEGER_32; a_new_entry: CE_POINTER [NATURAL_8]; a_in_map, a_sep: INTEGER_32)
		local
			l_hisptr: CE_POINTER [PD_HIST_ENTRY]
			l_len: INTEGER_32
			l_return: BOOLEAN
		do
			if hislen.item = 0 then
				l_return := True
			end
			if not l_return then
				if a_histype = 1 then
					if a_in_map.to_boolean then
						if (create {P_GLOBALS_STATIC}).maptick.item = last_maptick.item then
							l_hisptr := history.item[1] + hisidx.item[1];
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_hisptr.item.hisstr))
							l_hisptr.item.hisstr := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							l_hisptr.item.hisnum := 0
							hisnum.item[a_histype] := (hisnum.item[a_histype]) - 1
							hisidx.item[1] := (hisidx.item[1]) - 1
							if hisidx.item[1] < 0 then
								hisidx.item[1] := hislen.item - 1
							end
						end
						last_maptick.item := -1
					end
				end
				if not (in_history (a_histype, a_new_entry, 1)).to_boolean then
					hisidx.item[a_histype] := (hisidx.item[a_histype]) + 1
					if hisidx.item[a_histype] = hislen.item then
						hisidx.item[a_histype] := 0
					end
					l_hisptr := history.item[a_histype] + hisidx.item[a_histype];
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_hisptr.item.hisstr))
					l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_new_entry))).to_integer_32
					l_hisptr.item.hisstr := (create {P_MISC2_STATIC}).vim_strnsave (a_new_entry, l_len + 2)
					if not (l_hisptr.item.hisstr).is_void then
						l_hisptr.item.hisstr[(l_len + 1)] := a_sep.to_natural_8
					end
					hisnum.item[a_histype] := (hisnum.item[a_histype]) + 1
					l_hisptr.item.hisnum := hisnum.item[a_histype]
					if a_histype = 1 then
						if a_in_map.to_boolean then
							last_maptick.item := (create {P_GLOBALS_STATIC}).maptick.item
						end
					end
				end
			end
		end

	get_history_idx (a_histype: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if hislen.item = 0 then
				Result := (-1)
				l_return := True
			elseif a_histype < 0 then
				Result := (-1)
				l_return := True
			elseif a_histype >= 5 then
				Result := (-1)
				l_return := True
			elseif hisidx.item[a_histype] < 0 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				Result := ((history.item[a_histype] + hisidx.item[a_histype]).item.hisnum)
			end
		end

	get_ccline_ptr: CE_POINTER [PD_CMDLINE_INFO]
		local
			l_return: BOOLEAN
		do
			if (((create {P_GLOBALS_STATIC}).State.item).bit_and (8)) = 0 then
				Result := (create {CE_CLASS_POINTER [PD_CMDLINE_INFO]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return and then (not (ccline.item.item.cmdbuff).is_void) then
				Result := ccline.item
				l_return := True
			end
			if not l_return and then (prev_ccline_used.item.to_boolean) then
				if not (prev_ccline.item.item.cmdbuff).is_void then
					Result := prev_ccline.item
					l_return := True
				end
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_CMDLINE_INFO]}.make_shared (default_pointer))
			end
		end

	get_cmdline_str: CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [PD_CMDLINE_INFO]
			l_return: BOOLEAN
		do
			l_p___0 := (get_ccline_ptr)
			if l_p___0.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := ((create {P_MISC2_STATIC}).vim_strnsave (l_p___0.item.cmdbuff, l_p___0.item.cmdlen))
			end
		end

	get_cmdline_pos: INTEGER_32
		local
			l_p___0: CE_POINTER [PD_CMDLINE_INFO]
			l_return: BOOLEAN
		do
			l_p___0 := (get_ccline_ptr)
			if l_p___0.is_void then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				Result := (l_p___0.item.cmdpos)
			end
		end

	set_cmdline_pos (a_pos___3: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [PD_CMDLINE_INFO]
			l_return: BOOLEAN
		do
			l_p___0 := (get_ccline_ptr)
			if l_p___0.is_void then
				Result := 1
				l_return := True
			end
			if not l_return then
				if a_pos___3 < 0 then
					new_cmdpos.item := 0
				else
					new_cmdpos.item := a_pos___3
				end
				Result := 0
			end
		end

	get_cmdline_type: INTEGER_32
		local
			l_p___0: CE_POINTER [PD_CMDLINE_INFO]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_p___0 := (get_ccline_ptr)
			if l_p___0.is_void then
				Result := (('%/0/').code)
				l_return := True
			end
			if not l_return and then (l_p___0.item.cmdfirstc = 0) then
				if (l_p___0.item.input_fn).to_boolean then
					l_tmp___0 := ('@').code
				else
					l_tmp___0 := ('-').code
				end
				Result := l_tmp___0
				l_return := True
			end
			if not l_return then
				Result := (l_p___0.item.cmdfirstc)
			end
		end

	calc_hist_idx (a_histype, a_num: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_hist: CE_POINTER [PD_HIST_ENTRY]
			l_wrapped: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_wrapped := 0
			if hislen.item = 0 then
				Result := (-1)
				l_return := True
			elseif a_histype < 0 then
				Result := (-1)
				l_return := True
			elseif a_histype >= 5 then
				Result := (-1)
				l_return := True
			else
				l_i___0 := hisidx.item[a_histype]
				if l_i___0 < 0 then
					Result := (-1)
					l_return := True
				elseif a_num = 0 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_hist := history.item[a_histype]
				if a_num > 0 then
					from
					until
						not (not (l_break) and then ((l_hist + l_i___0).item.hisnum > a_num))
					loop
						l_break := False
						l_i___0 := l_i___0 - 1
						if l_i___0 < 0 then
							if l_wrapped.to_boolean then
								l_break := True
							end
							if not (l_break) then
								l_i___0 := l_i___0 + hislen.item
								l_wrapped := 1
							end
						end
					end
					l_break := False
					if (l_hist + l_i___0).item.hisnum = a_num then
						if not ((l_hist + l_i___0).item.hisstr).is_void then
							Result := l_i___0
							l_return := True
						end
					end
				elseif -a_num <= hislen.item then
					l_i___0 := l_i___0 + (a_num + 1)
					if l_i___0 < 0 then
						l_i___0 := l_i___0 + hislen.item
					end
					if not ((l_hist + l_i___0).item.hisstr).is_void then
						Result := l_i___0
						l_return := True
					end
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

	get_history_entry (a_histype, a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_idx: INTEGER_32
		do
			l_idx := a_idx
			l_idx := calc_hist_idx (a_histype, l_idx)
			if l_idx >= 0 then
				Result := ((history.item[a_histype] + l_idx).item.hisstr)
			else
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
			end
		end

	clr_history (a_histype: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_hisptr: CE_POINTER [PD_HIST_ENTRY]
			l_tmp: CE_POINTER [PD_HIST_ENTRY]
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if hislen.item /= 0 then
				if a_histype >= 0 then
					if a_histype < 5 then
						l_hisptr := history.item[a_histype]
						l_i___0 := hislen.item
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___0 := l_i___0
							l_i___0 := l_i___0 - 1
							if not l_tmp___0.to_boolean then
								l_break := True
							end
							if not (l_break) then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_hisptr.item.hisstr))
								l_hisptr.item.hisnum := 0
								l_tmp := l_hisptr
								l_hisptr := l_hisptr + 1
								l_tmp.item.hisstr := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							end
						end
						l_break := False
						hisidx.item[a_histype] := -1
						hisnum.item[a_histype] := 0
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	del_history_entry (a_histype: INTEGER_32; a_str___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_hisptr: CE_POINTER [PD_HIST_ENTRY]
			l_idx: INTEGER_32
			l_i___0: INTEGER_32
			l_last: INTEGER_32
			l_found: INTEGER_32
			l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_REGMATCH_T]} l_regmatch___0.make (<<1>>)

			l_found := 0
			l_regmatch___0.item.regprog := create {CE_CLASS_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
			l_regmatch___0.item.rm_ic := 0
			if hislen.item /= 0 then
				if a_histype >= 0 then
					if a_histype < 5 then
						if (a_str___1.item).to_integer_32 /= 0 then
							l_idx := hisidx.item[a_histype]
							if l_idx >= 0 then
								l_regmatch___0.item.regprog := (create {P_REGEXP_STATIC}).vim_regcomp (a_str___1, 3)
								if not (l_regmatch___0.item.regprog).is_void then
									l_last := l_idx
									l_i___0 := l_last
									from
									until
										(l_break)
									loop
										l_break := False
										l_hisptr := history.item[a_histype] + l_i___0
										if (l_hisptr.item.hisstr).is_void then
											l_break := True
										end
										if not (l_break) then
											if (l_regmatch___0.item.vim_regexec (l_hisptr.item.hisstr, 0)).to_boolean then
												l_found := 1;
												(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_hisptr.item.hisstr))
												l_hisptr.item.hisstr := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
												l_hisptr.item.hisnum := 0
											else
												if l_i___0 /= l_last then
													(history.item[a_histype])[l_last] := (l_hisptr.item).twin
													l_hisptr.item.hisstr := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
													l_hisptr.item.hisnum := 0
												end
												l_last := l_last - 1
												if l_last < 0 then
													l_last := l_last + hislen.item
												end
											end
											l_i___0 := l_i___0 - 1
											if l_i___0 < 0 then
												l_i___0 := l_i___0 + hislen.item
											end
											if l_i___0 = l_idx then
												l_break := True
											end
										end
									end
									l_break := False
									if ((history.item[a_histype] + l_idx).item.hisstr).is_void then
										hisidx.item[a_histype] := -1
									end
								end
							end
						end
					end
				end
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_regmatch___0.item.regprog))
			Result := l_found
		end

	del_history_idx (a_histype, a_idx: INTEGER_32): INTEGER_32
		local
			l_idx: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_return: BOOLEAN
		do
			l_idx := a_idx
			l_i___0 := calc_hist_idx (a_histype, l_idx)
			if l_i___0 < 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_idx := hisidx.item[a_histype];
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((history.item[a_histype] + l_i___0).item.hisstr))
				if a_histype = 1 then
					if (create {P_GLOBALS_STATIC}).maptick.item = last_maptick.item then
						if l_i___0 = l_idx then
							last_maptick.item := -1
						end
					end
				end
				from
				until
					l_i___0 = l_idx
				loop
					l_j := (l_i___0 + 1) \\ hislen.item;
					(history.item[a_histype])[l_i___0] := ((history.item[a_histype])[l_j]).twin
					l_i___0 := l_j
				end
				(history.item[a_histype] + l_i___0).item.hisstr := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
				(history.item[a_histype] + l_i___0).item.hisnum := 0
				l_i___0 := l_i___0 - 1
				if l_i___0 < 0 then
					l_i___0 := l_i___0 + hislen.item
				end
				hisidx.item[a_histype] := l_i___0
				Result := 1
			end
		end

	remove_key_from_history
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i___0 := hisidx.item[0]
			if l_i___0 < 0 then
				l_return := True
			end
			if not l_return then
				l_p___0 := (history.item[0] + l_i___0).item.hisstr
				if not l_p___0.is_void then
					from
					until
						not (not (l_return or l_break) and then ((l_p___0.item).to_boolean))
					loop
						l_break := False
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("key"), (3).to_natural_32)) = 0 then
							if not ((((ctype_b_loc).item[(l_p___0[3]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
								l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (l_p___0 + 3, ('=').code)
								if l_p___0.is_void then
									l_break := True
								end
								if not (l_return or l_break) then
									l_p___0 := l_p___0 + 1
									l_i___0 := 0
									from
									until
										(l_break)
									loop
										l_break := False
										if (l_p___0[l_i___0]).to_boolean then
											if (l_p___0[l_i___0]).to_integer_32 = 32 then
												l_break := True
											elseif (l_p___0[l_i___0]).to_integer_32 = 9 then
												l_break := True
											end
										else
											l_break := True
										end
										if not (l_break) then
											if (l_p___0[l_i___0]).to_integer_32 = 92 then
												if (l_p___0[(l_i___0 + 1)]).to_boolean then
													l_i___0 := l_i___0 + 1
												end
											end
											l_i___0 := l_i___0 + 1
										end
									end
									l_break := False
									memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + l_i___0)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + l_i___0)))) + {NATURAL_32} 1).do_nothing
									l_p___0 := l_p___0 - 1
								end
							end
						end
						if not (l_return or l_break) then
							l_p___0 := l_p___0 + 1
						end
					end
					l_break := False
				end
			end
		end

	hist_type2char (a_type, a_use_question: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_type = 0 then
				Result := ((':').code)
				l_return := True
			end
			if not l_return and then (a_type = 1) then
				if a_use_question.to_boolean then
					Result := (('?').code)
					l_return := True
				else
					Result := (('/').code)
					l_return := True
				end
			end
			if not l_return and then (a_type = 2) then
				Result := (('=').code)
				l_return := True
			end
			if not l_return then
				Result := (('@').code)
			end
		end

	write_viminfo_history (a_fp: CE_POINTER [SD_IO_FILE])
		local
			l_i___0: INTEGER_32
			l_type: INTEGER_32
			l_num_saved: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			init_history
			if hislen.item = 0 then
				l_return := True
			end
			if not l_return then
				l_type := 0
				from
				until
					not (not (l_return) and then (l_type < 5))
				loop
					l_continue := False
					l_num_saved := (create {P_OPTION_STATIC}).get_viminfo_parameter ((hist_type2char (l_type, 0)))
					if l_num_saved = 0 then
						l_continue := True
					end
					if not (l_return or l_break or l_continue) then
						if l_num_saved < 0 then
							l_num_saved := hislen.item
						end
						if l_type = 0 then
							l_tmp___6 := (gettext (ce_string ("Command Line")))
						else
							if l_type = 1 then
								l_tmp___5 := (gettext (ce_string ("Search String")))
							else
								if l_type = 2 then
									l_tmp___4 := (gettext (ce_string ("Expression")))
								else
									l_tmp___4 := (gettext (ce_string ("Input Line")))
								end
								l_tmp___5 := l_tmp___4
							end
							l_tmp___6 := l_tmp___5
						end
						fprintf ([a_fp, (gettext (ce_string ("%N# %%s History (newest to oldest):%N"))), l_tmp___6]).do_nothing
						if l_num_saved > hislen.item then
							l_num_saved := hislen.item
						end
						l_i___0 := hisidx.item[l_type]
						if l_i___0 >= 0 then
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___11 := l_num_saved
								l_num_saved := l_num_saved - 1
								if not l_tmp___11.to_boolean then
									l_break := True
								end
								if not (l_break) then
									l_p___0 := (history.item[l_type] + l_i___0).item.hisstr
									if not l_p___0.is_void then
										fputc ((hist_type2char (l_type, 1)), a_fp).do_nothing
										if l_type = 1 then
											l_c := (l_p___0[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))) + {NATURAL_32} 1).to_integer_32]).to_integer_32
											if l_c = 0 then
												l_tmp___10 := (' ').code
											else
												l_tmp___10 := l_c
											end
											IO_putc (l_tmp___10, a_fp).do_nothing
										end
										(create {P_EX_CMDS_STATIC}).viminfo_writestring (a_fp, l_p___0)
									end
									l_i___0 := l_i___0 - 1
									if l_i___0 < 0 then
										l_i___0 := hislen.item - 1
									end
								end
							end
							l_break := False
						end
					end
					if (not l_return) then
						l_type := l_type + 1
					end
				end
				l_continue := False
			end
		end

	ex_window: INTEGER_32
		local
			l_save_ccline: PD_CMDLINE_INFO
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_bp___0: CE_POINTER [PD_FILE_BUFFER]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_i___0: INTEGER_32
			l_lnum: INTEGER_32
			l_histtype: INTEGER_32
			l_winsizes: CE_ARRAY [PD_GROWARRAY]
			l_typestr: CE_ARRAY [NATURAL_8]
			l_save_restart_edit: INTEGER_32
			l_save_State: INTEGER_32
			l_save_exmode: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_winsizes.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_typestr.make (<<2>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_old_curbuf := (create {P_GLOBALS_STATIC}).curbuf.item
					l_old_curwin___1 := (create {P_GLOBALS_STATIC}).curwin.item
					l_save_restart_edit := (create {P_GLOBALS_STATIC}).restart_edit.item
					l_save_State := (create {P_GLOBALS_STATIC}).State.item
					l_save_exmode := (create {P_GLOBALS_STATIC}).exmode_active.item
					if (create {P_GLOBALS_STATIC}).cmdwin_type.item /= 0 then
						(create {P_MISC1_STATIC}).beep_flush
						Result := (-(253 + ((53).bit_shift_left (8))))
						l_return := True
					elseif (create {P_GLOBALS_STATIC}).cmdline_star.item > 0 then
						(create {P_MISC1_STATIC}).beep_flush
						Result := (-(253 + ((53).bit_shift_left (8))))
						l_return := True
					end
					if not l_return then
						l_winsizes.item.win_size_save;
						(create {P_FILEIO_STATIC}).block_autocmds;
						(create {P_GLOBALS_STATIC}).cmdmod.item.item.tab := 0
						if ((create {P_WINDOW_STATIC}).win_split (((create {P_OPTION_STATIC}).p_cwh.item.item).to_integer_32, 8)) = 0 then
							(create {P_MISC1_STATIC}).beep_flush;
							(create {P_FILEIO_STATIC}).unblock_autocmds
							Result := (-(253 + ((53).bit_shift_left (8))))
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 21 -- skip if block
					end
				when 1 then -- if:;
						(create {P_GLOBALS_STATIC}).cmdwin_type.item := get_cmdline_type;
						(create {P_EX_CMDS_STATIC}).do_ecmd (0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), (1).to_integer_32, 1, create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)).do_nothing;
						(create {P_BUFFER_STATIC}).setfname ((create {P_GLOBALS_STATIC}).curbuf.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("[Command Line]")), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 1).do_nothing;
						(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bt")), 0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("nofile")), 4);
						(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("swf")), 0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 4);
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ma := 1;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_fen := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_scb := 0;
						(create {P_FILEIO_STATIC}).unblock_autocmds;
						(create {P_GLOBALS_STATIC}).need_wait_return.item := 0
						l_histtype := hist_char2type ((create {P_GLOBALS_STATIC}).cmdwin_type.item)
						if l_histtype /= 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if l_histtype /= 4 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (create {P_OPTION_STATIC}).p_wc.item.item = 9 then
							(create {P_GETCHAR_STATIC}).add_map (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<buffer> <Tab> <C-X><C-V>")), 16);
							(create {P_GETCHAR_STATIC}).add_map (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<buffer> <Tab> a<C-X><C-V>")), 1)
						end
						(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ft")), 0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vim")), 4)
				when 6 then -- if done;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_tw := 0
						init_history
						if hislen.item > 0 then
							l_i___0 := hisidx.item[l_histtype]
							if l_i___0 >= 0 then
								l_lnum := (0).to_integer_32
								from
								until
									(l_break)
								loop
									l_break := False
									l_i___0 := l_i___0 + 1
									if l_i___0 = hislen.item then
										l_i___0 := 0
									end
									if not ((history.item[l_histtype] + l_i___0).item.hisstr).is_void then
										l_tmp___0 := l_lnum
										l_lnum := l_lnum + 1;
										(create {P_MEMLINE_STATIC}).ml_append (l_tmp___0, (history.item[l_histtype] + l_i___0).item.hisstr, 0, 0).do_nothing
									end
									if l_i___0 = hisidx.item[l_histtype] then
										l_break := True
									end
								end
								l_break := False
							end
						end
						(create {P_MEMLINE_STATIC}).ml_replace ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count, ccline.item.item.cmdbuff, 1).do_nothing;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ccline.item.item.cmdpos;
						(create {P_MOVE_STATIC}).changed_line_abv_curs;
						(create {P_MOVE_STATIC}).invalidate_botline;
						(create {P_SCREEN_STATIC}).redraw_later (35)
						l_save_ccline := (ccline.item.item).twin
						ccline.item.item.cmdbuff := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						ccline.item.item.cmdprompt := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
						(create {P_GLOBALS_STATIC}).exmode_active.item := 0;
						(create {P_GLOBALS_STATIC}).State.item := 1;
						(create {P_TERM_STATIC}).setmouse
						l_typestr[0] := ((create {P_GLOBALS_STATIC}).cmdwin_type.item).to_natural_8
						l_typestr[1] := (('%/0/').code).to_natural_8;
						(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_CMDWINENTER, l_typestr, l_typestr, 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
						if (create {P_GLOBALS_STATIC}).restart_edit.item /= 0 then
							(create {P_GETCHAR_STATIC}).stuffcharReadbuff (-(253 + ((97).bit_shift_left (8))))
						end
						l_i___0 := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item;
						(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := 0;
						(create {P_GLOBALS_STATIC}).cmdwin_result.item := 0;
						(create {P_MAIN_STATIC}).main_loop (1, 0);
						(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := l_i___0;
						(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_CMDWINLEAVE, l_typestr, l_typestr, 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
						ccline.item.item := l_save_ccline.twin;
						(create {P_GLOBALS_STATIC}).cmdwin_type.item := 0;
						(create {P_GLOBALS_STATIC}).exmode_active.item := l_save_exmode
						if not (((create {P_WINDOW_STATIC}).win_valid (l_old_curwin___1)).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 7 then -- if:
						if not (((create {P_BUFFER_STATIC}).buf_valid (l_old_curbuf)).to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 8 then -- if:
						if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
							if (create {P_GLOBALS_STATIC}).cmdwin_result.item /= -(253 + ((53).bit_shift_left (8))) then
								(create {P_GLOBALS_STATIC}).cmdwin_result.item := 3
							end
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (ccline.item.item.cmdbuff))
						if (create {P_GLOBALS_STATIC}).cmdwin_result.item /= -(253 + ((57).bit_shift_left (8))) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 11 then -- else:
						if (create {P_GLOBALS_STATIC}).cmdwin_result.item /= -(253 + ((58).bit_shift_left (8))) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if: | _L___0:
						if (create {P_GLOBALS_STATIC}).cmdwin_result.item = -(253 + ((58).bit_shift_left (8))) then
							l_tmp___3 := ce_string ("qa")
						else
							l_tmp___3 := ce_string ("qa!")
						end
						l_p___0 := l_tmp___3
						if l_histtype = 0 then
							ccline.item.item.cmdbuff := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (l_p___0));
							(create {P_GLOBALS_STATIC}).cmdwin_result.item := ('%R').code
						else
							ccline.item.item.cmdbuff := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
							(create {P_GETCHAR_STATIC}).stuffcharReadbuff ((':').code);
							(create {P_GETCHAR_STATIC}).stuffReadbuff (create {CE_NATURAL_8_POINTER}.make_cast (l_p___0));
							(create {P_GETCHAR_STATIC}).stuffcharReadbuff (('%R').code)
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						if (create {P_GLOBALS_STATIC}).cmdwin_result.item = -(253 + ((58).bit_shift_left (8))) then
							ccline.item.item.cmdbuff := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("qa")));
							(create {P_GLOBALS_STATIC}).cmdwin_result.item := ('%R').code
						else
							ccline.item.item.cmdbuff := (create {P_MISC2_STATIC}).vim_strsave (((create {P_MEMLINE_STATIC}).ml_get_curline))
						end
				when 15 then -- if done
						if (ccline.item.item.cmdbuff).is_void then
							(create {P_GLOBALS_STATIC}).cmdwin_result.item := 3
						else
							ccline.item.item.cmdlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (ccline.item.item.cmdbuff))).to_integer_32
							ccline.item.item.cmdbufflen := ccline.item.item.cmdlen + 1
							ccline.item.item.cmdpos := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
							if ccline.item.item.cmdpos > ccline.item.item.cmdlen then
								ccline.item.item.cmdpos := ccline.item.item.cmdlen
							end
							if (create {P_GLOBALS_STATIC}).cmdwin_result.item = -(253 + ((53).bit_shift_left (8))) then
								set_cmdspos_cursor
								redrawcmd
							end
						end
						(create {P_FILEIO_STATIC}).block_autocmds
						l_wp___0 := (create {P_GLOBALS_STATIC}).curwin.item
						l_bp___0 := (create {P_GLOBALS_STATIC}).curbuf.item;
						(create {P_WINDOW_STATIC}).win_goto (l_old_curwin___1);
						(create {P_WINDOW_STATIC}).win_close (l_wp___0, 1)
						if ((create {P_BUFFER_STATIC}).buf_valid (l_bp___0)).to_boolean then
							(create {P_BUFFER_STATIC}).close_buffer (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer), l_bp___0, 4)
						end
						l_winsizes.item.win_size_restore;
						(create {P_FILEIO_STATIC}).unblock_autocmds
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:;
						(create {P_GLOBALS_STATIC}).cmdwin_result.item := 3
						l_tmp___1 := gettext (ce_string ("E199: Active window or buffer deleted"));
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:;
						(create {P_GLOBALS_STATIC}).cmdwin_result.item := 3
						l_tmp___1 := gettext (ce_string ("E199: Active window or buffer deleted"));
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
				when 20 then -- if done
						l_winsizes.item.ga_clear;
						(create {P_GLOBALS_STATIC}).restart_edit.item := l_save_restart_edit;
						(create {P_GLOBALS_STATIC}).State.item := l_save_State;
						(create {P_TERM_STATIC}).setmouse
						Result := ((create {P_GLOBALS_STATIC}).cmdwin_result.item)
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	getexline_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent getexline)
		end

end
