class
	P_GUI_STATIC

inherit
	CE_UTILITIES
	S_UNISTD_STATIC
	S_LIBINTL_STATIC
	S_STRING_STATIC
	S_SYS_STAT_STATIC
	S_PANGO_PANGO_STATIC
	S_STDLIB_STATIC
	S_GTK_GTK_STATIC
	S_CTYPE_STATIC

feature {ANY} -- public attributes

	gui: CE_STATIC [CE_ARRAY [PD_GUI]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GUI]}.make (<<1>>)
		end

	can_update_cursor: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 1
		end

	recursive___9: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	result___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 2
		end

	recursive___10: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	iid: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	busy___3: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	old_curwin___0: CE_STATIC [CE_POINTER [PD_WINDOW_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
		end

	prev_row___1: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	prev_col___1: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	prev_button: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	num_clicks: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 1
		end

	prev_which_scrollbars: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<3>>)
		end

	prev_menu_is_active: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	prev_toolbar: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	prev_tearoff: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	prev_curwin: CE_STATIC [CE_POINTER [PD_WINDOW_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
		end

	longest_lnum: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (0).to_integer_32
		end

	busy___4: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	entered___5: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	gui_start
		local
			l_old_term: CE_POINTER [NATURAL_8]
			l_dofork: INTEGER_32
			l_pipefd: CE_ARRAY [INTEGER_32]
			l_pipe_error: INTEGER_32
			l_dummy___0: CE_ARRAY [INTEGER_8]
			l_pid: INTEGER_32
			l_tmp___2: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_pipefd.make (<<2>>)
			create {CE_INTEGER_8_ARRAY} l_dummy___0.make (<<1>>)

			l_dofork := 1
			l_old_term := (create {P_MISC2_STATIC}).vim_strsave ((create {P_TERM_STATIC}).term_strings.item[0]);
			(create {P_TERM_STATIC}).settmode (0)
			if ((create {P_GLOBALS_STATIC}).full_screen.item).to_boolean then
				(create {P_TERM_STATIC}).cursor_on
			end
			gui.item.item.starting := 1;
			(create {P_GLOBALS_STATIC}).full_screen.item := 0
			if not (gui.item.item.dofork).to_boolean then
				l_dofork := 0
			elseif (not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_go.item.item, ('f').code)).is_void) then
				l_dofork := 0
			elseif recursive___9.item.to_boolean then
				l_dofork := 0
			end
			recursive___9.item := recursive___9.item + 1;
			(create {P_TERM_STATIC}).termcapinit (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("builtin_gui")))
			gui.item.item.starting := recursive___9.item - 1
			if not (gui.item.item.in_use).to_boolean then
				(create {P_TERM_STATIC}).termcapinit (l_old_term);
				(create {P_TERM_STATIC}).settmode (2);
				(create {P_OPTION_STATIC}).set_title_defaults
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_old_term))
			if (gui.item.item.in_use).to_boolean then
				display_errors
			end
			if (gui.item.item.in_use).to_boolean then
				if l_dofork.to_boolean then
					l_pid := -1
					l_pipe_error := ((pipe (create {CE_INTEGER_32_POINTER}.make_cast (l_pipefd))) < 0).to_integer
					l_pid := fork
					if l_pid > 0 then
						if l_pipe_error.to_boolean then
							(create {P_UI_STATIC}).ui_delay (300, 1)
						else
							close (l_pipefd[1]).do_nothing;
							(create {P_GLOBALS_STATIC}).ignored.item := (read (l_pipefd[0], create {CE_VOID_POINTER}.make_cast (l_dummy___0), (1).to_natural_32))
							close (l_pipefd[0]).do_nothing
						end
						if ((create {P_GLOBALS_STATIC}).newline_on_exit.item).to_boolean then
							(create {P_MESSAGE_STATIC}).mch_errmsg (ce_string ("%R%N"))
						end
						exit2 (0)
					end
					if l_pid = 0 then
						setsid.do_nothing
					end
					if not l_pipe_error.to_boolean then
						close (l_pipefd[0]).do_nothing
						close (l_pipefd[1]).do_nothing
					end
				end
			end
			(create {P_GUI_GTK_X11_STATIC}).gui_mch_update
			if (gui.item.item.in_use).to_boolean then
				l_tmp___2 := 41
			else
				l_tmp___2 := 42
			end
			(create {P_FILEIO_STATIC}).apply_autocmds (l_tmp___2.to_natural_32, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
			recursive___9.item := recursive___9.item - 1
		end

	gui_prepare (a_argc: CE_POINTER [INTEGER_32]; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			gui.item.item.in_use := 0
			gui.item.item.starting := 0;
			(create {P_GUI_GTK_X11_STATIC}).gui_mch_prepare (a_argc, a_argv)
		end

	gui_init_check: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if result___0.item /= 2 then
				if result___0.item = 0 then
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E229: Cannot start the GUI"))))).do_nothing
				end
				Result := result___0.item
				l_return := True
			end
			if not l_return then
				gui.item.item.shell_created := 0
				gui.item.item.dying := 0
				gui.item.item.in_focus := 1
				gui.item.item.dragged_sb := -1
				gui.item.item.dragged_wp := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
				gui.item.item.pointer_hidden := 0
				gui.item.item.col := 0
				gui.item.item.row := 0
				gui.item.item.num_cols := ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32
				gui.item.item.num_rows := ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32
				gui.item.item.cursor_is_valid := (0).to_integer_8
				gui.item.item.scroll_region_top := 0
				gui.item.item.scroll_region_bot := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
				gui.item.item.scroll_region_left := 0
				gui.item.item.scroll_region_right := ((create {P_GLOBALS_STATIC}).Columns.item.item - 1).to_integer_32
				gui.item.item.highlight_mask := 0
				gui.item.item.char_width := 1
				gui.item.item.char_height := 1
				gui.item.item.char_ascent := 0
				gui.item.item.border_width := 0
				gui.item.item.norm_font := create {CE_VOID_POINTER}.make_shared (default_pointer)
				gui.item.item.menu_is_active := (1).to_integer_8
				gui.item.item.scrollbar_height := 16
				gui.item.item.scrollbar_width := gui.item.item.scrollbar_height
				gui.item.item.prev_wrap := -1
				result___0.item := (create {P_GUI_GTK_X11_STATIC}).gui_mch_init_check
				Result := result___0.item
			end
		end

	gui_init
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tmp___8: INTEGER_32
			l_s: CE_ARRAY [SD_STAT]
			l_tmp___16: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_s.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not recursive___10.item.to_boolean then
						recursive___10.item := recursive___10.item + 1;
						(create {P_UI_STATIC}).clip_init (1)
						if (gui_init_check) = 0 then
							recursive___10.item := recursive___10.item - 1;
							(create {P_UI_STATIC}).clip_init (0)
							l_return := True
						end
						if not l_return then
							(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("paste")), 0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0)
							if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_go.item.item, ('M').code)).is_void then
								(create {P_GLOBALS_STATIC}).sys_menu.item := 1;
								(create {P_EX_CMDS2_STATIC}).do_source (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("$VIMRUNTIME/menu.vim")), 0, 0).do_nothing;
								(create {P_GLOBALS_STATIC}).sys_menu.item := 0
							end
							if not ((create {P_OPTION_STATIC}).option_was_set (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mouse")))).to_boolean then
								(create {P_OPTION_STATIC}).set_string_option_direct (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mouse")), -1, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("a")), 1, -6)
							end
							if not ((create {P_GLOBALS_STATIC}).use_gvimrc.item).is_void then
								if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).use_gvimrc.item), ce_string ("NONE"))) /= 0 then
									if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).use_gvimrc.item), ce_string ("NORC"))) /= 0 then
										if ((create {P_EX_CMDS2_STATIC}).do_source ((create {P_GLOBALS_STATIC}).use_gvimrc.item, 0, 0)) /= 1 then
											(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E230: Cannot read from %"%%s%"")))), (create {P_GLOBALS_STATIC}).use_gvimrc.item).do_nothing
										end
									end
								end
							else
								(create {P_EX_CMDS2_STATIC}).do_source (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("$VIM/gvimrc")), 0, 0).do_nothing
								if ((create {P_MAIN_STATIC}).process_env (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("GVIMINIT")), 0)) = 0 then
									if ((create {P_EX_CMDS2_STATIC}).do_source (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("$HOME/.gvimrc")), 1, 2)) = 0 then
										l_tmp___8 := 1
									else
										l_tmp___8 := 0
									end
								else
									l_tmp___8 := 0
								end
								if ((create {P_OPTION_STATIC}).p_exrc.item.item).to_boolean then
									if (stat (ce_string (".gvimrc"), l_s)).to_boolean then
										(create {P_GLOBALS_STATIC}).secure.item := (create {P_OPTION_STATIC}).p_secure.item.item
									elseif l_s.item.st_uid /= (getuid) then
										(create {P_GLOBALS_STATIC}).secure.item := (create {P_OPTION_STATIC}).p_secure.item.item
									end
									if ((create {P_MISC1_STATIC}).fullpathcmp (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("$HOME/.gvimrc")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".gvimrc")), 0)) /= 1 then
										if ((create {P_MISC1_STATIC}).fullpathcmp (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("$VIM/gvimrc")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".gvimrc")), 0)) /= 1 then
											(create {P_EX_CMDS2_STATIC}).do_source (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".gvimrc")), 1, 2).do_nothing
										end
									end
									if (create {P_GLOBALS_STATIC}).secure.item = 2 then
										(create {P_GLOBALS_STATIC}).need_wait_return.item := 1
									end
									(create {P_GLOBALS_STATIC}).secure.item := 0
								end
							end
							if ((create {P_GLOBALS_STATIC}).need_wait_return.item).to_boolean then
								(create {P_MESSAGE_STATIC}).wait_return (1)
							elseif ((create {P_GLOBALS_STATIC}).msg_didany.item).to_boolean then
								(create {P_MESSAGE_STATIC}).wait_return (1)
							end
							recursive___10.item := recursive___10.item - 1
						end
					end
					if not l_return and then ((gui.item.item.in_use).to_boolean) then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						gui.item.item.in_use := 1
						if ((create {P_GUI_GTK_X11_STATIC}).gui_mch_init) = 0 then
							l_pos := -1 + 5 -- goto error2
						end
				when 2 then;
						(create {P_GLOBALS_STATIC}).emsg_on_display.item := 0;
						(create {P_GLOBALS_STATIC}).msg_scrolled.item := 0;
						(create {P_MESSAGE_STATIC}).clear_sb_text;
						(create {P_GLOBALS_STATIC}).need_wait_return.item := 0;
						(create {P_GLOBALS_STATIC}).msg_didany.item := 0
						if gui.item.item.border_width < 0 then
							gui.item.item.border_width := 0
						end
						if not ((create {P_GLOBALS_STATIC}).font_argument.item).is_void then
							(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("gfn")), 0, create {CE_NATURAL_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).font_argument.item), 0)
						end
						if ((create {P_OPTION_STATIC}).p_guifont.item.item.item).to_integer_32 = 0 then
							l_tmp___16 := ((create {P_SYNTAX_STATIC}).hl_get_font_name)
						else
							l_tmp___16 := (create {P_OPTION_STATIC}).p_guifont.item.item
						end
						if (gui_init_font (l_tmp___16, 0)) = 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E665: Cannot start GUI, no valid font found"))))).do_nothing
							l_pos := -1 + 5 -- goto error2
						end
				when 3 then
						if (gui_get_wide_font) = 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E231: %'guifontwide%' invalid"))))).do_nothing
						end
						gui.item.item.num_cols := ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32
						gui.item.item.num_rows := ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32
						gui_reset_scroll_region
						l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
						from
						until
							l_wp___0.is_void
						loop
							(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (l_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (0))).item.gui_create_scrollbar (0, l_wp___0);
							(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (l_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (1))).item.gui_create_scrollbar (1, l_wp___0)
							l_wp___0 := l_wp___0.item.w_next
						end
						(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (gui.item.item.c_pointer + (create {PD_GUI}.make).offset_of ("bottom_sbar"))).item.gui_create_scrollbar (2, create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer));
						(create {P_MENU_STATIC}).gui_create_initial_menus ((create {P_GLOBALS_STATIC}).root_menu.item.item);
						(create {P_EX_CMDS_STATIC}).sign_gui_started
						gui_init_which_components (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						gui.item.item.shell_created := 1
						if ((create {P_GUI_GTK_X11_STATIC}).gui_mch_open) /= 0 then
							(create {P_BUFFER_STATIC}).maketitle;
							(create {P_BUFFER_STATIC}).resettitle;
							(create {P_OPTION_STATIC}).init_gui_options;
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_update
							if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_go.item.item, ('m').code)).is_void then
								gui.item.item.starting := (gui.item.item.starting) - 1;
								(create {P_GUI_GTK_X11_STATIC}).gui_mch_enable_menu (0)
								gui.item.item.starting := (gui.item.item.starting) + 1;
								(create {P_GUI_GTK_X11_STATIC}).gui_mch_update
							end
							gui_set_shellsize (0, 1, 15);
							(create {P_TERM_STATIC}).win_new_shellsize;
							(create {P_GLOBALS_STATIC}).balloonEval.item := (create {P_GUI_BEVAL_STATIC}).gui_mch_create_beval_area (create {CE_VOID_POINTER}.make_cast (gui.item.item.drawarea), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), (create {P_GUI_BEVAL_STATIC}).general_beval_cb_address, create {CE_VOID_POINTER}.make_shared (default_pointer))
							if not ((create {P_OPTION_STATIC}).p_beval.item.item).to_boolean then
								(create {P_GUI_BEVAL_STATIC}).gui_mch_disable_beval_area ((create {P_GLOBALS_STATIC}).balloonEval.item)
							end
							if not ((create {P_MBYTE_STATIC}).im_xim_isvalid_imactivate).to_boolean then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E599: Value of %'imactivatekey%' is invalid"))))).do_nothing
							end
							if (create {P_OPTION_STATIC}).p_ch.item.item /= 1 then
								(create {P_WINDOW_STATIC}).command_height
							end
							l_return := True
						end
				when 4 then -- if done
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | error2:
						gui.item.item.in_use := 0;
						(create {P_UI_STATIC}).clip_init (0)
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_exit (a_rc: INTEGER_32)
		do
			(create {P_SYNTAX_STATIC}).free_highlight_fonts
			gui.item.item.in_use := 0;
			(create {P_GUI_GTK_X11_STATIC}).gui_mch_exit (a_rc)
		end

	gui_shell_closed
		local
			l_save_cmdmod: PD_CMDMOD_T
		do
			l_save_cmdmod := ((create {P_GLOBALS_STATIC}).cmdmod.item.item).twin;
			(create {P_GLOBALS_STATIC}).exiting.item := 1;
			(create {P_GLOBALS_STATIC}).cmdmod.item.item.browse := 1;
			(create {P_GLOBALS_STATIC}).cmdmod.item.item.confirm := 1
			if not ((create {P_EX_CMDS2_STATIC}).check_changed_any (0)).to_boolean then
				(create {P_MAIN_STATIC}).getout (0)
			end
			(create {P_GLOBALS_STATIC}).exiting.item := 0;
			(create {P_GLOBALS_STATIC}).cmdmod.item.item := l_save_cmdmod.twin
			gui_update_screen
		end

	gui_init_font (a_font_list: CE_POINTER [NATURAL_8]; a_fontset: INTEGER_32): INTEGER_32
		local
			l_font_list: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_font_name: CE_ARRAY [NATURAL_8]
			l_font_list_empty: INTEGER_32
			l_ret: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_font_list.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_font_name.make (<<320>>)

			l_font_list.item := a_font_list
			l_font_list_empty := 0
			l_ret := 0
			if not (gui.item.item.in_use).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_font_name[0] := (('%/0/').code).to_natural_8
				if (l_font_list.item.item).to_integer_32 = 0 then
					l_font_list_empty := 1
				else
					from
					until
						not (not (l_break) and then ((l_font_list.item.item).to_integer_32 /= 0))
					loop
						l_break := False;
						(create {P_MISC2_STATIC}).copy_option_part (l_font_list, l_font_name, 320, ce_string (",")).do_nothing
						if ((create {P_GUI_GTK_X11_STATIC}).gui_mch_init_font (l_font_name, 0)) = 1 then
							l_ret := 1
							l_break := True
						end
					end
					l_break := False
				end
				if l_ret /= 1 then
					if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_font_list.item), ce_string ("*"))) /= 0 then
						if l_font_list_empty.to_boolean then
							l_ret := (create {P_GUI_GTK_X11_STATIC}).gui_mch_init_font (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0)
						elseif (gui.item.item.norm_font).is_void then
							l_ret := (create {P_GUI_GTK_X11_STATIC}).gui_mch_init_font (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0)
						end
					end
				end
				if l_ret = 1 then
					gui_set_shellsize (0, 0, 15)
				end
				Result := l_ret
			end
		end

	gui_get_wide_font: INTEGER_32
		local
			l_font: CE_POINTER [ANY]
			l_font_name: CE_ARRAY [NATURAL_8]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_font_name.make (<<320>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			l_font := create {CE_VOID_POINTER}.make_shared (default_pointer)
			if not (gui.item.item.in_use).to_boolean then
				Result := 1
				l_return := True
			end
			if not l_return and then (not ((create {P_OPTION_STATIC}).p_guifontwide.item.item).is_void) then
				if ((create {P_OPTION_STATIC}).p_guifontwide.item.item.item).to_integer_32 /= 0 then
					l_p___0.item := (create {P_OPTION_STATIC}).p_guifontwide.item.item
					from
					until
						not (not (l_break) and then ((l_p___0.item.item).to_integer_32 /= 0))
					loop
						l_break := False;
						(create {P_MISC2_STATIC}).copy_option_part (l_p___0, l_font_name, 320, ce_string (",")).do_nothing
						l_font := (create {P_GUI_GTK_X11_STATIC}).gui_mch_get_font (l_font_name, 0)
						if not l_font.is_void then
							l_break := True
						end
					end
					l_break := False
					if l_font.is_void then
						Result := 0
						l_return := True
					end
				end
			end
			if not l_return then
				(create {P_GUI_GTK_X11_STATIC}).gui_mch_free_font (gui.item.item.wide_font)
				if not l_font.is_void then
					if not (gui.item.item.norm_font).is_void then
						if (pango_font_description_equal (l_font, gui.item.item.norm_font)).to_boolean then
							gui.item.item.wide_font := create {CE_VOID_POINTER}.make_shared (default_pointer);
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_free_font (l_font)
						else
							gui.item.item.wide_font := l_font
						end
					else
						gui.item.item.wide_font := l_font
					end
				else
					gui.item.item.wide_font := l_font
				end
				Result := 1
			end
		end

	gui_set_cursor (a_row, a_col: INTEGER_32)
		do
			gui.item.item.row := a_row
			gui.item.item.col := a_col
		end

	gui_check_pos
		do
			if gui.item.item.row >= (create {P_GLOBALS_STATIC}).screen_Rows.item then
				gui.item.item.row := (create {P_GLOBALS_STATIC}).screen_Rows.item - 1
			end
			if gui.item.item.col >= (create {P_GLOBALS_STATIC}).screen_Columns.item then
				gui.item.item.col := (create {P_GLOBALS_STATIC}).screen_Columns.item - 1
			end
			if gui.item.item.cursor_row >= (create {P_GLOBALS_STATIC}).screen_Rows.item then
				gui.item.item.cursor_is_valid := (0).to_integer_8
			elseif gui.item.item.cursor_col >= (create {P_GLOBALS_STATIC}).screen_Columns.item then
				gui.item.item.cursor_is_valid := (0).to_integer_8
			end
		end

	gui_update_cursor (a_force, a_clear_selection: INTEGER_32)
		local
			l_cur_width: INTEGER_32
			l_cur_height: INTEGER_32
			l_old_hl_mask: INTEGER_32
			l_idx: INTEGER_32
			l_id: INTEGER_32
			l_cfg: CE_ARRAY [INTEGER_32]
			l_cbg: CE_ARRAY [INTEGER_32]
			l_cc___0: INTEGER_32
			l_cattr: INTEGER_32
			l_attr: INTEGER_32
			l_aep: CE_POINTER [PD_ATTR_ENTRY]
			l_fg: CE_ARRAY [INTEGER_32]
			l_bg: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_cfg.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_cbg.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_fg.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_bg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cur_width := 0
					l_cur_height := 0
					l_aep := create {CE_CLASS_POINTER [PD_ATTR_ENTRY]}.make_shared (default_pointer)
					if not can_update_cursor.item.to_boolean then
						l_return := True
					elseif (create {P_GLOBALS_STATIC}).screen_Columns.item /= gui.item.item.num_cols then
						l_return := True
					elseif (create {P_GLOBALS_STATIC}).screen_Rows.item /= gui.item.item.num_rows then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						gui_check_pos
						if (gui.item.item.cursor_is_valid).to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 4 then -- else:
						if not (a_force.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 7 then -- else:
						if gui.item.item.row = gui.item.item.cursor_row then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if gui.item.item.col = gui.item.item.cursor_col then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						gui_undraw_cursor
						if gui.item.item.row < 0 then
							l_return := True
						end
						if not l_return then
							if gui.item.item.row /= gui.item.item.cursor_row then
								(create {P_MBYTE_STATIC}).im_set_position (gui.item.item.row, gui.item.item.col)
							elseif gui.item.item.col /= gui.item.item.cursor_col then
								(create {P_MBYTE_STATIC}).im_set_position (gui.item.item.row, gui.item.item.col)
							end
							gui.item.item.cursor_row := gui.item.item.row
							gui.item.item.cursor_col := gui.item.item.col
							if not ((create {P_GLOBALS_STATIC}).screen_cleared.item).to_boolean then
								l_return := True
							elseif ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
								l_return := True
							end
						end
						if not l_return then
							if a_clear_selection.to_boolean then
								(create {P_UI_STATIC}).clip_may_clear_selection (gui.item.item.row, gui.item.item.row)
							end
							if gui.item.item.row >= (create {P_GLOBALS_STATIC}).screen_Rows.item then
								l_return := True
							elseif gui.item.item.col >= (create {P_GLOBALS_STATIC}).screen_Columns.item then
								l_return := True
							end
						end
						if not l_return then
							gui.item.item.cursor_is_valid := (1).to_integer_8
							l_idx := (create {P_MISC2_STATIC}).get_shape_idx (0)
							if (((create {P_GLOBALS_STATIC}).State.item).bit_and (32)).to_boolean then
								l_id := (create {P_MISC2_STATIC}).shape_table.item[l_idx].id_lm
							else
								l_id := (create {P_MISC2_STATIC}).shape_table.item[l_idx].id
							end
							l_cfg.item := (-11_111).to_integer_32
							l_cbg.item := (-11_111).to_integer_32
							l_cattr := 1;
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_set_blinking ((create {P_MISC2_STATIC}).shape_table.item[l_idx].blinkwait, (create {P_MISC2_STATIC}).shape_table.item[l_idx].blinkon, (create {P_MISC2_STATIC}).shape_table.item[l_idx].blinkoff)
							if l_id > 0 then
								l_cattr := (create {P_SYNTAX_STATIC}).syn_id2colors (l_id, l_cfg, l_cbg)
								if ((create {P_MBYTE_STATIC}).preedit_get_status).to_boolean then
									iid.item := (create {P_SYNTAX_STATIC}).syn_name2id (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("CursorIM")))
									if iid.item > 0 then
										(create {P_SYNTAX_STATIC}).syn_id2colors (iid.item, l_fg, l_bg).do_nothing
										if l_bg.item /= -11_111 then
											l_cbg.item := l_bg.item
										end
										if l_fg.item /= -11_111 then
											l_cfg.item := l_fg.item
										end
									end
								end
							end
							l_attr := ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[((create {P_GLOBALS_STATIC}).LineOffset.item[gui.item.item.row] + (gui.item.item.col).to_natural_32).to_integer_32]).to_integer_32
							if l_attr > 63 then
								l_aep := (create {P_SYNTAX_STATIC}).syn_gui_attr2entry (l_attr)
							end
							if not l_aep.is_void then
								l_attr := (l_aep.item.ae_attr).to_integer_32
								if l_cfg.item = -11_111 then
									if ((l_attr).bit_and (1)).to_boolean then
										l_cfg.item := l_aep.item.ae_u.gui.bg_color
									else
										l_cfg.item := l_aep.item.ae_u.gui.fg_color
									end
								end
								if l_cbg.item = -11_111 then
									if ((l_attr).bit_and (1)).to_boolean then
										l_cbg.item := l_aep.item.ae_u.gui.fg_color
									else
										l_cbg.item := l_aep.item.ae_u.gui.bg_color
									end
								end
							end
							if l_cfg.item = -11_111 then
								if ((l_attr).bit_and (1)).to_boolean then
									l_cfg.item := gui.item.item.back_pixel
								else
									l_cfg.item := gui.item.item.norm_pixel
								end
							end
							if l_cbg.item = -11_111 then
								if ((l_attr).bit_and (1)).to_boolean then
									l_cbg.item := gui.item.item.norm_pixel
								else
									l_cbg.item := gui.item.item.back_pixel
								end
							end
							if not l_aep.is_void then
								if ((l_attr).bit_and (1)).to_boolean then
									(create {P_GLOBALS_STATIC}).xim_bg_color.item := l_aep.item.ae_u.gui.fg_color
								else
									(create {P_GLOBALS_STATIC}).xim_bg_color.item := l_aep.item.ae_u.gui.bg_color
								end
								if ((l_attr).bit_and (1)).to_boolean then
									(create {P_GLOBALS_STATIC}).xim_fg_color.item := l_aep.item.ae_u.gui.bg_color
								else
									(create {P_GLOBALS_STATIC}).xim_fg_color.item := l_aep.item.ae_u.gui.fg_color
								end
								if (create {P_GLOBALS_STATIC}).xim_bg_color.item = -11_111 then
									if ((l_attr).bit_and (1)).to_boolean then
										(create {P_GLOBALS_STATIC}).xim_bg_color.item := gui.item.item.norm_pixel
									else
										(create {P_GLOBALS_STATIC}).xim_bg_color.item := gui.item.item.back_pixel
									end
								end
								if (create {P_GLOBALS_STATIC}).xim_fg_color.item = -11_111 then
									if ((l_attr).bit_and (1)).to_boolean then
										(create {P_GLOBALS_STATIC}).xim_fg_color.item := gui.item.item.back_pixel
									else
										(create {P_GLOBALS_STATIC}).xim_fg_color.item := gui.item.item.norm_pixel
									end
								end
							else
								if ((l_attr).bit_and (1)).to_boolean then
									(create {P_GLOBALS_STATIC}).xim_bg_color.item := gui.item.item.norm_pixel
								else
									(create {P_GLOBALS_STATIC}).xim_bg_color.item := gui.item.item.back_pixel
								end
								if ((l_attr).bit_and (1)).to_boolean then
									(create {P_GLOBALS_STATIC}).xim_fg_color.item := gui.item.item.back_pixel
								else
									(create {P_GLOBALS_STATIC}).xim_fg_color.item := gui.item.item.norm_pixel
								end
							end
							l_attr := (l_attr).bit_and ((-2))
							if ((l_cattr).bit_and (1)).to_boolean then
								l_cc___0 := l_cbg.item
								l_cbg.item := l_cfg.item
								l_cfg.item := l_cc___0
							end
							l_cattr := (l_cattr).bit_and ((-2))
							if not (gui.item.item.in_focus).to_boolean then
								(create {P_GUI_GTK_X11_STATIC}).gui_mch_draw_hollow_cursor (l_cbg.item)
								l_return := True
							end
						end
						if not l_return then
							l_old_hl_mask := gui.item.item.highlight_mask
							if (create {P_MISC2_STATIC}).shape_table.item[l_idx].shape = 0 then
								gui.item.item.highlight_mask := (l_cattr).bit_or (l_attr)
								gui_screenchar (((create {P_GLOBALS_STATIC}).LineOffset.item[gui.item.item.row] + (gui.item.item.col).to_natural_32).to_integer_32, 20, l_cfg.item, l_cbg.item, 0).do_nothing
							else
								if (create {P_MISC2_STATIC}).shape_table.item[l_idx].shape = 2 then
									l_cur_height := gui.item.item.char_height
									l_cur_width := (gui.item.item.char_width * (create {P_MISC2_STATIC}).shape_table.item[l_idx].percentage + 99) // 100
								else
									l_cur_height := (gui.item.item.char_height * (create {P_MISC2_STATIC}).shape_table.item[l_idx].percentage + 99) // 100
									l_cur_width := gui.item.item.char_width
								end
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									if ((create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([(create {P_GLOBALS_STATIC}).LineOffset.item[gui.item.item.row] + (gui.item.item.col).to_natural_32, (create {P_GLOBALS_STATIC}).LineOffset.item[gui.item.item.row] + ((create {P_GLOBALS_STATIC}).screen_Columns.item).to_natural_32])) > 1 then
										if (create {P_MISC2_STATIC}).shape_table.item[l_idx].shape /= 2 then
											l_cur_width := l_cur_width + (gui.item.item.char_width)
										end
									end
								end
								(create {P_GUI_GTK_X11_STATIC}).gui_mch_draw_part_cursor (l_cur_width, l_cur_height, l_cbg.item)
								gui.item.item.highlight_mask := ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[((create {P_GLOBALS_STATIC}).LineOffset.item[gui.item.item.row] + (gui.item.item.col).to_natural_32).to_integer_32]).to_integer_32
								gui_screenchar (((create {P_GLOBALS_STATIC}).LineOffset.item[gui.item.item.row] + (gui.item.item.col).to_natural_32).to_integer_32, 24, (0).to_integer_32, (0).to_integer_32, 0).do_nothing
							end
							gui.item.item.highlight_mask := l_old_hl_mask
						end
				when 12 then -- if done | if done | if done | if done
					if not l_return then
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_position_menu
		do
		end

	gui_position_components (a_total_width: INTEGER_32)
		local
			l_text_area_x: INTEGER_32
			l_text_area_y: INTEGER_32
			l_text_area_width: INTEGER_32
			l_text_area_height: INTEGER_32
		do
			(create {P_GLOBALS_STATIC}).hold_gui_events.item := (create {P_GLOBALS_STATIC}).hold_gui_events.item + (1)
			l_text_area_x := 0
			if (gui.item.item.which_scrollbars[0]).to_boolean then
				l_text_area_x := l_text_area_x + (gui.item.item.scrollbar_width)
			end
			l_text_area_y := 0
			l_text_area_width := gui.item.item.num_cols * gui.item.item.char_width + gui.item.item.border_offset * 2
			l_text_area_height := gui.item.item.num_rows * gui.item.item.char_height + gui.item.item.border_offset * 2;
			(create {P_GUI_GTK_STATIC}).gui_mch_set_text_area_pos (l_text_area_x, l_text_area_y, l_text_area_width, l_text_area_height)
			gui_position_menu
			if (gui.item.item.which_scrollbars[2]).to_boolean then
				(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (gui.item.item.c_pointer + (create {PD_GUI}.make).offset_of ("bottom_sbar"))).item.gui_mch_set_scrollbar_pos (l_text_area_x, l_text_area_y + l_text_area_height, l_text_area_width, gui.item.item.scrollbar_height)
			end
			gui.item.item.left_sbar_x := 0
			gui.item.item.right_sbar_x := l_text_area_x + l_text_area_width;
			(create {P_GLOBALS_STATIC}).hold_gui_events.item := (create {P_GLOBALS_STATIC}).hold_gui_events.item - (1)
		end

	gui_get_base_width: INTEGER_32
		local
			l_base_width: INTEGER_32
		do
			l_base_width := 2 * gui.item.item.border_offset
			if (gui.item.item.which_scrollbars[0]).to_boolean then
				l_base_width := l_base_width + (gui.item.item.scrollbar_width)
			end
			if (gui.item.item.which_scrollbars[1]).to_boolean then
				l_base_width := l_base_width + (gui.item.item.scrollbar_width)
			end
			Result := l_base_width
		end

	gui_get_base_height: INTEGER_32
		local
			l_base_height: INTEGER_32
		do
			l_base_height := 2 * gui.item.item.border_offset
			if (gui.item.item.which_scrollbars[2]).to_boolean then
				l_base_height := l_base_height + (gui.item.item.scrollbar_height)
			end
			Result := l_base_height
		end

	gui_resize_shell (a_pixel_width, a_pixel_height: INTEGER_32)
		local
			l_pixel_width: INTEGER_32
			l_pixel_height: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pixel_width := a_pixel_width
					l_pixel_height := a_pixel_height
					if not (gui.item.item.shell_created).to_boolean then
						l_return := True
					end
					if not l_return then
						if ((create {P_GLOBALS_STATIC}).updating_screen.item).to_boolean then
							(create {P_GLOBALS_STATIC}).new_pixel_width.item := l_pixel_width;
							(create {P_GLOBALS_STATIC}).new_pixel_height.item := l_pixel_height
							l_return := True
						elseif busy___3.item.to_boolean then
							(create {P_GLOBALS_STATIC}).new_pixel_width.item := l_pixel_width;
							(create {P_GLOBALS_STATIC}).new_pixel_height.item := l_pixel_height
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | again:
						busy___3.item := 1;
						(create {P_TERM_STATIC}).out_flush
						gui.item.item.num_cols := (l_pixel_width - (gui_get_base_width)) // gui.item.item.char_width
						gui.item.item.num_rows := (l_pixel_height - (gui_get_base_height)) // gui.item.item.char_height
						gui_position_components (l_pixel_width)
						gui_reset_scroll_region
						if (create {P_GLOBALS_STATIC}).State.item = 768 then
							gui.item.item.row := gui.item.item.num_rows
						elseif (create {P_GLOBALS_STATIC}).State.item = 2_048 then
							gui.item.item.row := gui.item.item.num_rows
						end
						if gui.item.item.num_rows /= (create {P_GLOBALS_STATIC}).screen_Rows.item then
							(create {P_TERM_STATIC}).shell_resized
						elseif gui.item.item.num_cols /= (create {P_GLOBALS_STATIC}).screen_Columns.item then
							(create {P_TERM_STATIC}).shell_resized
						elseif (gui.item.item.num_rows).to_integer_32 /= (create {P_GLOBALS_STATIC}).Rows.item.item then
							(create {P_TERM_STATIC}).shell_resized
						elseif (gui.item.item.num_cols).to_integer_32 /= (create {P_GLOBALS_STATIC}).Columns.item.item then
							(create {P_TERM_STATIC}).shell_resized
						end
						gui_update_scrollbars (1)
						gui_update_cursor (0, 1)
						busy___3.item := 0
						if ((create {P_GLOBALS_STATIC}).new_pixel_height.item).to_boolean then
							l_pixel_width := (create {P_GLOBALS_STATIC}).new_pixel_width.item
							l_pixel_height := (create {P_GLOBALS_STATIC}).new_pixel_height.item;
							(create {P_GLOBALS_STATIC}).new_pixel_width.item := 0;
							(create {P_GLOBALS_STATIC}).new_pixel_height.item := 0
							l_pos := -1 + 1 -- goto again
						end
				when 2 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_may_resize_shell
		local
			l_h: INTEGER_32
			l_w: INTEGER_32
		do
			if ((create {P_GLOBALS_STATIC}).new_pixel_height.item).to_boolean then
				l_w := (create {P_GLOBALS_STATIC}).new_pixel_width.item
				l_h := (create {P_GLOBALS_STATIC}).new_pixel_height.item;
				(create {P_GLOBALS_STATIC}).new_pixel_width.item := 0;
				(create {P_GLOBALS_STATIC}).new_pixel_height.item := 0
				gui_resize_shell (l_w, l_h)
			end
		end

	gui_get_shellsize: INTEGER_32
		do
			(create {P_GLOBALS_STATIC}).Rows.item.item := (gui.item.item.num_rows).to_integer_32;
			(create {P_GLOBALS_STATIC}).Columns.item.item := (gui.item.item.num_cols).to_integer_32
			Result := 1
		end

	gui_set_shellsize (a_mustset, a_fit_to_display, a_direction: INTEGER_32)
		local
			l_base_width: INTEGER_32
			l_base_height: INTEGER_32
			l_width: INTEGER_32
			l_height: INTEGER_32
			l_min_width: INTEGER_32
			l_min_height: INTEGER_32
			l_screen_w: CE_ARRAY [INTEGER_32]
			l_screen_h: CE_ARRAY [INTEGER_32]
			l_un_maximize: INTEGER_32
			l_did_adjust: INTEGER_32
			l_x___0: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_screen_w.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_screen_h.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_x___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_un_maximize := a_mustset
					l_did_adjust := 0
					l_x___0.item := -1
					l_y.item := -1
					if not (gui.item.item.shell_created).to_boolean then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if:
						l_base_width := gui_get_base_width
						l_base_height := gui_get_base_height
						if a_fit_to_display.to_boolean then
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_get_winpos (l_x___0, l_y).do_nothing
						end
						l_width := ((create {P_GLOBALS_STATIC}).Columns.item.item * (gui.item.item.char_width).to_integer_32 + l_base_width.to_integer_32).to_integer_32
						l_height := ((create {P_GLOBALS_STATIC}).Rows.item.item * (gui.item.item.char_height).to_integer_32 + l_base_height.to_integer_32).to_integer_32
						if a_fit_to_display.to_boolean then
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_get_screen_dimensions (l_screen_w, l_screen_h)
							if ((a_direction).bit_and (2)).to_boolean then
								if l_width > l_screen_w.item then
									(create {P_GLOBALS_STATIC}).Columns.item.item := ((l_screen_w.item - l_base_width) // gui.item.item.char_width).to_integer_32
									if (create {P_GLOBALS_STATIC}).Columns.item.item < 12 then
										(create {P_GLOBALS_STATIC}).Columns.item.item := 12
									end
									l_width := ((create {P_GLOBALS_STATIC}).Columns.item.item * (gui.item.item.char_width).to_integer_32 + l_base_width.to_integer_32).to_integer_32
									l_did_adjust := l_did_adjust + 1
								end
							end
							if ((a_direction).bit_and (1)).to_boolean then
								if l_height > l_screen_h.item then
									(create {P_GLOBALS_STATIC}).Rows.item.item := ((l_screen_h.item - l_base_height) // gui.item.item.char_height).to_integer_32;
									(create {P_TERM_STATIC}).check_shellsize
									l_height := ((create {P_GLOBALS_STATIC}).Rows.item.item * (gui.item.item.char_height).to_integer_32 + l_base_height.to_integer_32).to_integer_32
									l_did_adjust := l_did_adjust + 1
								end
							end
							if l_did_adjust = 2 then
								l_un_maximize := 0
							elseif l_width + gui.item.item.char_width >= l_screen_w.item then
								if l_height + gui.item.item.char_height >= l_screen_h.item then
									l_un_maximize := 0
								end
							end
						end
						gui.item.item.num_cols := ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32
						gui.item.item.num_rows := ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32
						l_min_width := l_base_width + 12 * gui.item.item.char_width
						l_min_height := l_base_height + 2 * gui.item.item.char_height
						l_min_height := l_min_height + (((create {P_WINDOW_STATIC}).tabline_height) * gui.item.item.char_height)
						if not (l_un_maximize.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:;
						(create {P_GUI_GTK_X11_STATIC}).gui_mch_get_screen_dimensions (l_screen_w, l_screen_h)
						if not (l_width + gui.item.item.char_width < l_screen_w.item) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if not (l_height + gui.item.item.char_height * 2 < l_screen_h.item) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						if ((create {P_GUI_GTK_X11_STATIC}).gui_mch_maximized).to_boolean then
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_unmaximize
						end
				when 7 then -- if done | if done;
						(create {P_GUI_GTK_X11_STATIC}).gui_mch_set_shellsize (l_width, l_height, l_min_width, l_min_height, l_base_width, l_base_height, a_direction)
						if not (a_fit_to_display.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 8 then -- if:
						if not (l_x___0.item >= 0) then
							l_pos := -1 + 16 -- skip if block
						end
				when 9 then -- if:
						if not (l_y.item >= 0) then
							l_pos := -1 + 16 -- skip if block
						end
				when 10 then -- if:;
						(create {P_GUI_GTK_X11_STATIC}).gui_mch_update
						if ((create {P_GUI_GTK_X11_STATIC}).gui_mch_get_winpos (l_x___0, l_y)) /= 1 then
							l_pos := -1 + 16 -- skip if block
						end
				when 11 then -- if:
						if not (l_x___0.item < 0) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else:
						if not (l_y.item < 0) then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L___0:
						if l_y.item < 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := l_y.item
						end
						if l_x___0.item < 0 then
							l_tmp___2 := 0
						else
							l_tmp___2 := l_x___0.item
						end
						(create {P_GUI_GTK_X11_STATIC}).gui_mch_set_winpos (l_tmp___2, l_tmp___1)
				when 16 then -- if done | if done | if done | if done | if done
						gui_position_components (l_width)
						gui_update_scrollbars (1)
						gui_reset_scroll_region
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_new_shellsize
		do
			gui_reset_scroll_region
		end

	gui_reset_scroll_region
		do
			gui.item.item.scroll_region_top := 0
			gui.item.item.scroll_region_bot := gui.item.item.num_rows - 1
			gui.item.item.scroll_region_left := 0
			gui.item.item.scroll_region_right := gui.item.item.num_cols - 1
		end

	gui_start_highlight (a_mask: INTEGER_32)
		do
			if a_mask > 63 then
				gui.item.item.highlight_mask := a_mask
			else
				gui.item.item.highlight_mask := (gui.item.item.highlight_mask).bit_or (a_mask)
			end
		end

	gui_stop_highlight (a_mask: INTEGER_32)
		do
			if a_mask > 63 then
				gui.item.item.highlight_mask := 0
			else
				gui.item.item.highlight_mask := (gui.item.item.highlight_mask).bit_and (((a_mask).bit_not))
			end
		end

	gui_clear_block (a_row1, a_col1, a_row2, a_col2: INTEGER_32)
		do
			(create {P_UI_STATIC}).clip_may_clear_selection (a_row1, a_row2);
			(create {P_GUI_GTK_X11_STATIC}).gui_mch_clear_block (a_row1, a_col1, a_row2, a_col2)
			if gui.item.item.cursor_row >= a_row1 then
				if gui.item.item.cursor_row <= a_row2 then
					if gui.item.item.cursor_col >= a_col1 then
						if gui.item.item.cursor_col <= a_col2 then
							gui.item.item.cursor_is_valid := (0).to_integer_8
						end
					end
				end
			end
		end

	gui_update_cursor_later
		do
			(create {P_TERM_STATIC}).out_str (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/|s")))
		end

	gui_write (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_arg1: INTEGER_32
			l_arg2: INTEGER_32
			l_force_cursor: INTEGER_32
			l_force_scrollbar: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					l_len := a_len
					l_arg1 := 0
					l_arg2 := 0
					l_force_cursor := 0
					l_force_scrollbar := 0
				when 1 then -- loop condition:
					if not (not (l_return or l_break) and then (l_len.to_boolean)) then
						l_pos := -1 + 29 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if (l_s[0]).to_integer_32 /= 27 then
							l_pos := -1 + 24 -- skip if block
						end
				when 3 then -- if:
						if (l_s[1]).to_integer_32 /= 124 then
							l_pos := -1 + 22 -- skip if block
						end
				when 4 then -- if:
						l_p___0.item := l_s + 2
						if (l_p___0.item.item).to_integer_32 >= 48 then
							if (l_p___0.item.item).to_integer_32 <= 57 then
								l_arg1 := ((create {P_CHARSET_STATIC}).getdigits (l_p___0)).to_integer_32
								if ((l_p___0.item).c_pointer.to_integer_32).to_natural_32 > ((l_s + l_len).c_pointer.to_integer_32).to_natural_32 then
									l_break := True
								end
								if not (l_return or l_break) and then ((l_p___0.item.item).to_integer_32 = 59) then
									l_p___0.item := l_p___0.item + 1
									l_arg2 := ((create {P_CHARSET_STATIC}).getdigits (l_p___0)).to_integer_32
									if ((l_p___0.item).c_pointer.to_integer_32).to_natural_32 > ((l_s + l_len).c_pointer.to_integer_32).to_natural_32 then
										l_break := True
									end
								end
							end
						end
						if (l_return or l_break) then
							l_pos := -1 + 21 -- skip if block
						end
				when 5 then -- if:
						inspect (l_p___0.item.item).to_integer_32 -- switch 1 head
						when 67 then l_pos := -1 + 6
						when 77 then l_pos := -1 + 7
						when 115 then l_pos := -1 + 8
						when 82 then l_pos := -1 + 9
						when 86 then l_pos := -1 + 10
						when 100 then l_pos := -1 + 11
						when 68 then l_pos := -1 + 12
						when 105 then l_pos := -1 + 13
						when 73 then l_pos := -1 + 14
						when 36 then l_pos := -1 + 15
						when 104 then l_pos := -1 + 16
						when 72 then l_pos := -1 + 17
						when 102 then l_pos := -1 + 18
						else l_pos := -1 + 19
						end
				when 6 then -- switch 1, case 67;
						(create {P_UI_STATIC}).clip_scroll_selection (9_999);
						(create {P_GUI_GTK_X11_STATIC}).gui_mch_clear_all
						gui.item.item.cursor_is_valid := (0).to_integer_8
						l_force_scrollbar := 1
						l_pos := -1 + 20 -- switch 1; break
				when 7 then -- switch 1, case 77
						gui_set_cursor (l_arg1, l_arg2)
						l_pos := -1 + 20 -- switch 1; break
				when 8 then -- switch 1, case 115
						l_force_cursor := 1
						l_pos := -1 + 20 -- switch 1; break
				when 9 then -- switch 1, case 82
						if l_arg1 < l_arg2 then
							gui.item.item.scroll_region_top := l_arg1
							gui.item.item.scroll_region_bot := l_arg2
						else
							gui.item.item.scroll_region_top := l_arg2
							gui.item.item.scroll_region_bot := l_arg1
						end
						l_pos := -1 + 20 -- switch 1; break
				when 10 then -- switch 1, case 86
						if l_arg1 < l_arg2 then
							gui.item.item.scroll_region_left := l_arg1
							gui.item.item.scroll_region_right := l_arg2
						else
							gui.item.item.scroll_region_left := l_arg2
							gui.item.item.scroll_region_right := l_arg1
						end
						l_pos := -1 + 20 -- switch 1; break
				when 11 then -- switch 1, case 100
						gui_delete_lines (gui.item.item.row, 1)
						l_pos := -1 + 20 -- switch 1; break
				when 12 then -- switch 1, case 68
						gui_delete_lines (gui.item.item.row, l_arg1)
						l_pos := -1 + 20 -- switch 1; break
				when 13 then -- switch 1, case 105
						gui_insert_lines (gui.item.item.row, 1)
						l_pos := -1 + 20 -- switch 1; break
				when 14 then -- switch 1, case 73
						gui_insert_lines (gui.item.item.row, l_arg1)
						l_pos := -1 + 20 -- switch 1; break
				when 15 then -- switch 1, case 36
						gui_clear_block (gui.item.item.row, gui.item.item.col, gui.item.item.row, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32 - 1)
						l_pos := -1 + 20 -- switch 1; break
				when 16 then -- switch 1, case 104
						gui_start_highlight (l_arg1)
						l_pos := -1 + 20 -- switch 1; break
				when 17 then -- switch 1, case 72
						gui_stop_highlight (l_arg1)
						l_pos := -1 + 20 -- switch 1; break
				when 18 then -- switch 1, case 102
						if l_arg1 = 0 then
							l_tmp___1 := 20
						else
							l_tmp___1 := l_arg1
						end
						(create {P_GUI_GTK_X11_STATIC}).gui_mch_flash (l_tmp___1)
						l_pos := -1 + 20 -- switch 1; break
				when 19 then -- switch 1, default:
						l_p___0.item := l_s + 1
						l_pos := -1 + 20 -- switch 1; break
				when 20 then -- switch 1, done:
						l_p___0.item := l_p___0.item + 1
						l_len := l_len - ((l_p___0.item).distance (l_s))
						l_s := l_p___0.item
				when 21 then -- if done | if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_pos := -1 + 24 -- goto _L___1
				when 23 then -- if done | if block done, skip else block:
						l_pos := -1 + 28
				when 24 then -- else: | _L___1:
						if not ((l_s[0]).to_integer_32 < 32) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if (l_s[0]).to_integer_32 /= 1 then
							if (l_s[0]).to_integer_32 /= 2 then
								if (l_s[0]).to_integer_32 = 10 then
									gui.item.item.col := 0
									if gui.item.item.row < gui.item.item.scroll_region_bot then
										gui.item.item.row := (gui.item.item.row) + 1
									else
										gui_delete_lines (gui.item.item.scroll_region_top, 1)
									end
								elseif (l_s[0]).to_integer_32 = 13 then
									gui.item.item.col := 0
								elseif (l_s[0]).to_integer_32 = 8 then
									if (gui.item.item.col).to_boolean then
										gui.item.item.col := (gui.item.item.col) - 1
									end
								elseif (l_s[0]).to_integer_32 = 12 then
									gui.item.item.col := (gui.item.item.col) + 1
								elseif (l_s[0]).to_integer_32 = 7 then
									(create {P_GUI_GTK_X11_STATIC}).gui_mch_beep
								end
								l_len := l_len - 1
								l_s := l_s + 1
							else
								l_pos := -1 + 27 -- goto _L___0
							end
						else
							l_pos := -1 + 27 -- goto _L___0
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else: | _L___0:
						l_p___0.item := l_s
						from
						until
							(l_break)
						loop
							l_break := False
							if l_len > 0 then
								if not ((l_p___0.item.item).to_integer_32 >= 32) then
									if (l_p___0.item.item).to_integer_32 /= 1 then
										if (l_p___0.item.item).to_integer_32 /= 2 then
											l_break := True
										end
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_len := l_len - 1
								l_p___0.item := l_p___0.item + 1
							end
						end
						l_break := False
						gui_outstr (l_s, (l_p___0.item).distance (l_s))
						l_s := l_p___0.item
				when 28 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 29 then -- loop done
					l_break := False
					if l_force_cursor.to_boolean then
						gui_update_cursor (1, 1)
					end
					if not old_curwin___0.item.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
						gui.item.item.dragged_sb := -1
					end
					if l_force_scrollbar.to_boolean then
						gui_update_scrollbars (l_force_scrollbar)
					elseif not old_curwin___0.item.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
						gui_update_scrollbars (l_force_scrollbar)
					else
						gui_update_horiz_scrollbar (0)
					end
					old_curwin___0.item := (create {P_GLOBALS_STATIC}).curwin.item
					gui.item.item.dragged_sb := -1;
					(create {P_GUI_GTK_X11_STATIC}).gui_mch_flush
				when 30 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_dont_update_cursor
		do
			if (gui.item.item.in_use).to_boolean then
				gui_undraw_cursor
				can_update_cursor.item := 0
			end
		end

	gui_can_update_cursor
		do
			can_update_cursor.item := 1
		end

	gui_outstr (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_this_len: INTEGER_32
			l_cells: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_s := a_s
			l_len := a_len
			if l_len = 0 then
				l_return := True
			end
			if not l_return then
				if l_len < 0 then
					l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))).to_integer_32
				end
				from
				until
					not (not (l_return) and then (l_len > 0))
				loop
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_cells := 0
						l_this_len := 0
						from
						until
							not (not (l_break) and then (l_this_len < l_len))
						loop
							l_break := False
							l_cells := l_cells + ((create {P_GLOBALS_STATIC}).mb_ptr2cells.item.integer_32_item ([l_s + l_this_len]))
							if (gui.item.item.col + l_cells).to_integer_32 > (create {P_GLOBALS_STATIC}).Columns.item.item then
								l_break := True
							end
							if not (l_break) then
								l_this_len := l_this_len + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s + l_this_len]))
							end
						end
						l_break := False
						if l_this_len > l_len then
							l_this_len := l_len
						end
					elseif (gui.item.item.col + l_len).to_integer_32 > (create {P_GLOBALS_STATIC}).Columns.item.item then
						l_this_len := ((create {P_GLOBALS_STATIC}).Columns.item.item - (gui.item.item.col).to_integer_32).to_integer_32
					else
						l_this_len := l_len
					end
					gui_outstr_nowrap (l_s, l_this_len, 0, (0).to_integer_32, (0).to_integer_32, 0).do_nothing
					l_s := l_s + l_this_len
					l_len := l_len - l_this_len
					if l_len > 0 then
						if (gui.item.item.col).to_integer_32 < (create {P_GLOBALS_STATIC}).Columns.item.item then
							gui_outstr_nowrap (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")), 1, 0, (0).to_integer_32, (0).to_integer_32, 0).do_nothing
						end
					end
					if (gui.item.item.col).to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item then
						gui.item.item.col := 0
						gui.item.item.row := (gui.item.item.row) + 1
					end
				end
			end
		end

	gui_screenchar (a_off___0, a_flags___0: INTEGER_32; a_fg, a_bg: INTEGER_32; a_back: INTEGER_32): INTEGER_32
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<22>>)

			if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
				if ((create {P_GLOBALS_STATIC}).ScreenLines.item[a_off___0]).to_integer_32 = 0 then
					Result := 1
					l_return := True
				end
			end
			if not l_return and then (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
				if (create {P_GLOBALS_STATIC}).ScreenLinesUC.item[a_off___0] /= {NATURAL_32} 0 then
					Result := (gui_outstr_nowrap (l_buf___6, ((create {P_MBYTE_STATIC}).utfc_char2bytes (a_off___0, l_buf___6)), a_flags___0, a_fg, a_bg, a_back))
					l_return := True
				end
			end
			if not l_return and then ((create {P_GLOBALS_STATIC}).enc_dbcs.item = 9_932) then
				if ((create {P_GLOBALS_STATIC}).ScreenLines.item[a_off___0]).to_integer_32 = 142 then
					l_buf___6[0] := (create {P_GLOBALS_STATIC}).ScreenLines.item[a_off___0]
					l_buf___6[1] := (create {P_GLOBALS_STATIC}).ScreenLines2.item[a_off___0]
					Result := (gui_outstr_nowrap (l_buf___6, 2, a_flags___0, a_fg, a_bg, a_back))
					l_return := True
				end
			end
			if not l_return then
				if ((create {P_GLOBALS_STATIC}).enc_dbcs.item).to_boolean then
					l_tmp___3 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([(create {P_GLOBALS_STATIC}).ScreenLines.item + a_off___0]))
				else
					l_tmp___3 := 1
				end
				Result := (gui_outstr_nowrap ((create {P_GLOBALS_STATIC}).ScreenLines.item + a_off___0, l_tmp___3, a_flags___0, a_fg, a_bg, a_back))
			end
		end

	gui_screenstr (a_off___0, a_len, a_flags___0: INTEGER_32; a_fg, a_bg: INTEGER_32; a_back: INTEGER_32): INTEGER_32
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_outlen: INTEGER_32
			l_i___0: INTEGER_32
			l_retval: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return, l_continue: BOOLEAN
		do
			l_outlen := 0
			if a_len <= 0 then
				Result := 1
				l_return := True
			end
			if not l_return then
				if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
					l_buf___6 := (create {P_MISC2_STATIC}).alloc ((a_len * 21 + 1).to_natural_32)
					if l_buf___6.is_void then
						Result := 1
						l_return := True
					end
					if not l_return then
						l_i___0 := a_off___0
						from
						until
							not (l_i___0 < a_off___0 + a_len)
						loop
							l_continue := False
							if ((create {P_GLOBALS_STATIC}).ScreenLines.item[l_i___0]).to_integer_32 = 0 then
								l_continue := True
							end
							if not (l_continue) then
								if (create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_i___0] = {NATURAL_32} 0 then
									l_tmp := l_outlen
									l_outlen := l_outlen + 1
									l_buf___6[l_tmp] := (create {P_GLOBALS_STATIC}).ScreenLines.item[l_i___0]
								else
									l_outlen := l_outlen + ((create {P_MBYTE_STATIC}).utfc_char2bytes (l_i___0, l_buf___6 + l_outlen))
								end
							end
							l_i___0 := l_i___0 + 1
						end
						l_continue := False
						l_buf___6[l_outlen] := (('%/0/').code).to_natural_8
						l_retval := gui_outstr_nowrap (l_buf___6, l_outlen, a_flags___0, a_fg, a_bg, a_back);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
						Result := l_retval
					end
				elseif (create {P_GLOBALS_STATIC}).enc_dbcs.item = 9_932 then
					l_buf___6 := (create {P_MISC2_STATIC}).alloc ((a_len * 2 + 1).to_natural_32)
					if l_buf___6.is_void then
						Result := 1
						l_return := True
					end
					if not l_return then
						l_i___0 := a_off___0
						from
						until
							not (l_i___0 < a_off___0 + a_len)
						loop
							l_tmp___1 := l_outlen
							l_outlen := l_outlen + 1
							l_buf___6[l_tmp___1] := (create {P_GLOBALS_STATIC}).ScreenLines.item[l_i___0]
							if ((create {P_GLOBALS_STATIC}).ScreenLines.item[l_i___0]).to_integer_32 = 142 then
								l_tmp___2 := l_outlen
								l_outlen := l_outlen + 1
								l_buf___6[l_tmp___2] := (create {P_GLOBALS_STATIC}).ScreenLines2.item[l_i___0]
							elseif ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[((create {P_GLOBALS_STATIC}).ScreenLines.item[l_i___0]).to_integer_32]).to_integer_32 = 2 then
								l_tmp___3 := l_outlen
								l_outlen := l_outlen + 1
								l_i___0 := l_i___0 + 1
								l_buf___6[l_tmp___3] := (create {P_GLOBALS_STATIC}).ScreenLines.item[l_i___0]
							end
							l_i___0 := l_i___0 + 1
						end
						l_buf___6[l_outlen] := (('%/0/').code).to_natural_8
						l_retval := gui_outstr_nowrap (l_buf___6, l_outlen, a_flags___0, a_fg, a_bg, a_back);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
						Result := l_retval
					end
				else
					Result := (gui_outstr_nowrap ((create {P_GLOBALS_STATIC}).ScreenLines.item + a_off___0, a_len, a_flags___0, a_fg, a_bg, a_back))
				end
			end
		end

	gui_outstr_nowrap (a_s: CE_POINTER [NATURAL_8]; a_len, a_flags___0: INTEGER_32; a_fg, a_bg: INTEGER_32; a_back: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_highlight_mask: NATURAL_32
			l_hl_mask_todo: NATURAL_32
			l_fg_color: INTEGER_32
			l_bg_color: INTEGER_32
			l_sp_color: INTEGER_32
			l_aep: CE_POINTER [PD_ATTR_ENTRY]
			l_draw_flags: INTEGER_32
			l_col: INTEGER_32
			l_draw_sign: INTEGER_32
			l_multi_sign: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					l_len := a_len
					l_aep := create {CE_CLASS_POINTER [PD_ATTR_ENTRY]}.make_shared (default_pointer)
					l_col := gui.item.item.col
					l_draw_sign := 0
					l_multi_sign := 0
					if l_len < 0 then
						l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))).to_integer_32
					end
					if l_len = 0 then
						Result := 1
						l_return := True
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if (l_s.item).to_integer_32 /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if (l_s.item).to_integer_32 /= 2 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if (l_s.item).to_integer_32 = 2 then
							l_multi_sign := 1
						end
						l_s := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("  "))
						if l_len = 1 then
							if l_col > 0 then
								l_col := l_col - 1
							end
						end
						l_len := 2
						l_draw_sign := 1
						l_highlight_mask := (0).to_natural_32
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						if gui.item.item.highlight_mask > 63 then
							l_aep := (create {P_SYNTAX_STATIC}).syn_gui_attr2entry (gui.item.item.highlight_mask)
							if l_aep.is_void then
								l_highlight_mask := (0).to_natural_32
							else
								l_highlight_mask := (l_aep.item.ae_attr).to_natural_32
							end
						else
							l_highlight_mask := (gui.item.item.highlight_mask).to_natural_32
						end
				when 8 then -- if done
						l_hl_mask_todo := l_highlight_mask
						l_draw_flags := 0
						l_bg_color := gui.item.item.back_pixel
						if not (((a_flags___0).bit_and (4)).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if (gui.item.item.in_focus).to_boolean then
							l_draw_flags := (l_draw_flags).bit_or ((32))
							l_fg_color := a_fg
							l_bg_color := a_bg
							l_sp_color := a_fg
						else
							l_pos := -1 + 11 -- goto _L___0
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L___0:
						if not l_aep.is_void then
							l_fg_color := l_aep.item.ae_u.gui.fg_color
							if l_fg_color = -11_111 then
								l_fg_color := gui.item.item.norm_pixel
							end
							l_bg_color := l_aep.item.ae_u.gui.bg_color
							if l_bg_color = -11_111 then
								l_bg_color := gui.item.item.back_pixel
							end
							l_sp_color := l_aep.item.ae_u.gui.sp_color
							if l_sp_color = -11_111 then
								l_sp_color := l_fg_color
							end
						else
							l_fg_color := gui.item.item.norm_pixel
							l_sp_color := l_fg_color
						end
				when 12 then
						if ((l_highlight_mask).bit_and ({NATURAL_32} 33)).to_boolean then
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_set_fg_color (l_bg_color);
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_set_bg_color (l_fg_color)
						else
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_set_fg_color (l_fg_color);
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_set_bg_color (l_bg_color)
						end
						(create {P_GUI_GTK_X11_STATIC}).gui_mch_set_sp_color (l_sp_color)
						if not ((a_flags___0).bit_and (16)).to_boolean then
							(create {P_UI_STATIC}).clip_may_clear_selection (gui.item.item.row, gui.item.item.row)
						end
						if ((l_hl_mask_todo).bit_and ({NATURAL_32} 34)).to_boolean then
							l_draw_flags := (l_draw_flags).bit_or ((2))
						end
						if a_back /= 0 then
							if ((l_draw_flags).bit_and (2)).to_boolean then
								Result := 0
								l_return := True
							elseif ((l_highlight_mask).bit_and ({NATURAL_32} 4)).to_boolean then
								Result := 0
								l_return := True
							end
						end
				when 13 then -- if done
					if not l_return then
						if ((l_hl_mask_todo).bit_and ({NATURAL_32} 4)).to_boolean then
							l_draw_flags := (l_draw_flags).bit_or ((16))
						end
						if ((l_hl_mask_todo).bit_and ({NATURAL_32} 8)).to_boolean then
							l_draw_flags := (l_draw_flags).bit_or ((4))
						end
						if ((l_hl_mask_todo).bit_and ({NATURAL_32} 16)).to_boolean then
							l_draw_flags := (l_draw_flags).bit_or ((8))
						end
						if ((a_flags___0).bit_and (8)).to_boolean then
							l_draw_flags := (l_draw_flags).bit_or ((1))
						end
						l_len := (create {P_GUI_GTK_X11_STATIC}).gui_gtk2_draw_string (gui.item.item.row, l_col, l_s, l_len, l_draw_flags)
						if not ((a_flags___0).bit_and (12)).to_boolean then
							gui.item.item.col := l_col + l_len
						end
						if ((a_flags___0).bit_and (16)).to_boolean then
							(create {P_UI_STATIC}).clip_may_redraw_selection (gui.item.item.row, l_col, l_len)
						end
						if not ((a_flags___0).bit_and (12)).to_boolean then
							if gui.item.item.cursor_row = gui.item.item.row then
								if gui.item.item.cursor_col >= l_col then
									if gui.item.item.cursor_col < l_col + l_len then
										gui.item.item.cursor_is_valid := (0).to_integer_8
									end
								end
							end
						end
						if l_draw_sign.to_boolean then
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_drawsign (gui.item.item.row, l_col, gui.item.item.highlight_mask)
						end
						if l_multi_sign.to_boolean then
							(create {P_NETBEANS_STATIC}).netbeans_draw_multisign_indicator (gui.item.item.row)
						end
						Result := 1
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_undraw_cursor
		do
			if (gui.item.item.cursor_is_valid).to_boolean then
				if (gui_redraw_block (gui.item.item.cursor_row, gui.item.item.cursor_col, gui.item.item.cursor_row, gui.item.item.cursor_col, 16)).to_boolean then
					if gui.item.item.cursor_col > 0 then
						gui_redraw_block (gui.item.item.cursor_row, gui.item.item.cursor_col - 1, gui.item.item.cursor_row, gui.item.item.cursor_col - 1, 16).do_nothing
					end
				end
				gui.item.item.cursor_is_valid := (0).to_integer_8
			end
		end

	gui_redraw (a_x___0, a_y, a_w, a_h: INTEGER_32)
		local
			l_row1: INTEGER_32
			l_col1: INTEGER_32
			l_row2: INTEGER_32
			l_col2: INTEGER_32
		do
			l_row1 := (a_y - gui.item.item.border_offset) // gui.item.item.char_height
			l_col1 := (a_x___0 - gui.item.item.border_offset) // gui.item.item.char_width
			l_row2 := (((a_y + a_h) - 1) - gui.item.item.border_offset) // gui.item.item.char_height
			l_col2 := (((a_x___0 + a_w) - 1) - gui.item.item.border_offset) // gui.item.item.char_width
			gui_redraw_block (l_row1, l_col1, l_row2, l_col2, 16).do_nothing
			if gui.item.item.row = gui.item.item.cursor_row then
				gui_update_cursor (1, 1)
			end
		end

	gui_redraw_block (a_row1, a_col1, a_row2, a_col2, a_flags___0: INTEGER_32): INTEGER_32
		local
			l_row1: INTEGER_32
			l_col1: INTEGER_32
			l_row2: INTEGER_32
			l_col2: INTEGER_32
			l_old_row: INTEGER_32
			l_old_col: INTEGER_32
			l_old_hl_mask: NATURAL_32
			l_off___0: INTEGER_32
			l_first_attr: NATURAL_16
			l_idx: INTEGER_32
			l_len: INTEGER_32
			l_back: INTEGER_32
			l_nback: INTEGER_32
			l_retval: INTEGER_32
			l_orig_col1: INTEGER_32
			l_orig_col2: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			l_row1 := a_row1
			l_col1 := a_col1
			l_row2 := a_row2
			l_col2 := a_col2
			l_retval := 0
			if not ((create {P_GLOBALS_STATIC}).screen_cleared.item).to_boolean then
				Result := l_retval
				l_return := True
			elseif ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
				Result := l_retval
				l_return := True
			end
			if not l_return then
				l_col1 := (create {P_UI_STATIC}).check_col (l_col1)
				l_col2 := (create {P_UI_STATIC}).check_col (l_col2)
				l_row1 := (create {P_UI_STATIC}).check_row (l_row1)
				l_row2 := (create {P_UI_STATIC}).check_row (l_row2)
				l_old_row := gui.item.item.row
				l_old_col := gui.item.item.col
				l_old_hl_mask := (gui.item.item.highlight_mask).to_natural_32
				l_orig_col1 := l_col1
				l_orig_col2 := l_col2
				gui.item.item.row := l_row1
				from
				until
					not (not (l_return) and then (gui.item.item.row <= l_row2))
				loop
					l_col1 := l_orig_col1
					l_col2 := l_orig_col2
					l_off___0 := ((create {P_GLOBALS_STATIC}).LineOffset.item[gui.item.item.row]).to_integer_32
					if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 0 then
						if l_col1 > 0 then
							l_col1 := l_col1 - ((create {P_MBYTE_STATIC}).dbcs_screen_head_off ((create {P_GLOBALS_STATIC}).ScreenLines.item + l_off___0, ((create {P_GLOBALS_STATIC}).ScreenLines.item + l_off___0) + l_col1))
						end
						l_col2 := l_col2 + ((create {P_MBYTE_STATIC}).dbcs_screen_tail_off ((create {P_GLOBALS_STATIC}).ScreenLines.item + l_off___0, ((create {P_GLOBALS_STATIC}).ScreenLines.item + l_off___0) + l_col2))
					elseif ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
						if ((create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off___0 + l_col1)]).to_integer_32 = 0 then
							l_col1 := l_col1 - 1
						end
						if (l_col2 + 1).to_integer_32 < (create {P_GLOBALS_STATIC}).Columns.item.item then
							if ((create {P_GLOBALS_STATIC}).ScreenLines.item[((l_off___0 + l_col2) + 1)]).to_integer_32 = 0 then
								l_col2 := l_col2 + 1
							end
						end
					end
					gui.item.item.col := l_col1
					l_off___0 := ((create {P_GLOBALS_STATIC}).LineOffset.item[gui.item.item.row] + (gui.item.item.col).to_natural_32).to_integer_32
					l_len := (l_col2 - l_col1) + 1
					l_back := 0
					from
					until
						not (not (l_break) and then (l_back < l_col1))
					loop
						l_break := False
						if ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[((l_off___0 - 1) - l_back)]).to_integer_32 /= ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0]).to_integer_32 then
							l_break := True
						elseif ((create {P_GLOBALS_STATIC}).ScreenLines.item[((l_off___0 - 1) - l_back)]).to_integer_32 = 32 then
							l_break := True
						end
						if not (l_break) then
							l_back := l_back + 1
						end
					end
					l_break := False
					if l_col1 > 0 then
						if ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[(l_off___0 - 1)]).to_integer_32 /= 0 then
							if l_back = 0 then
								if ((create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off___0 - 1)]).to_integer_32 /= 32 then
									l_tmp___1 := 1
								else
									l_tmp___1 := 0
								end
							else
								l_tmp___1 := 0
							end
						else
							l_tmp___1 := 0
						end
					else
						l_tmp___1 := 0
					end
					l_retval := l_tmp___1
					from
					until
						not (not (l_return) and then (l_len > 0))
					loop
						l_first_attr := (create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0]
						gui.item.item.highlight_mask := l_first_attr.to_integer_32
						l_idx := 0
						from
						until
							not (not (l_break) and then (l_idx < l_len))
						loop
							l_break := False
							l_continue := False
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								if ((create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off___0 + l_idx)]).to_integer_32 = 0 then
									l_continue := True
								end
							end
							if not (l_break or l_continue) and then (((create {P_GLOBALS_STATIC}).ScreenAttrs.item[(l_off___0 + l_idx)]).to_integer_32 /= l_first_attr.to_integer_32) then
								l_break := True
							end
							if (not l_break) then
								l_idx := l_idx + 1
							end
						end
						l_break := False
						l_continue := False
						l_nback := gui_screenstr (l_off___0, l_idx, a_flags___0, (0).to_integer_32, (0).to_integer_32, l_back)
						if l_nback = 0 then
							l_off___0 := l_off___0 - l_back
							l_len := l_len + l_back
							gui.item.item.col := gui.item.item.col - l_back
						else
							l_off___0 := l_off___0 + l_idx
							l_len := l_len - l_idx
						end
						l_back := 0
					end
					gui.item.item.row := (gui.item.item.row) + 1
				end
				gui.item.item.row := l_old_row
				gui.item.item.col := l_old_col
				gui.item.item.highlight_mask := l_old_hl_mask.to_integer_32
				Result := l_retval
			end
		end

	gui_delete_lines (a_row, a_count___2: INTEGER_32)
		local
			l_return: BOOLEAN
		do
			if a_count___2 <= 0 then
				l_return := True
			end
			if not l_return then
				if a_row + a_count___2 > gui.item.item.scroll_region_bot then
					gui_clear_block (a_row, gui.item.item.scroll_region_left, gui.item.item.scroll_region_bot, gui.item.item.scroll_region_right)
				else
					(create {P_GUI_GTK_X11_STATIC}).gui_mch_delete_lines (a_row, a_count___2)
					if gui.item.item.cursor_row >= a_row then
						if gui.item.item.cursor_col >= gui.item.item.scroll_region_left then
							if gui.item.item.cursor_col <= gui.item.item.scroll_region_right then
								if gui.item.item.cursor_row < a_row + a_count___2 then
									gui.item.item.cursor_is_valid := (0).to_integer_8
								elseif gui.item.item.cursor_row <= gui.item.item.scroll_region_bot then
									gui.item.item.cursor_row := gui.item.item.cursor_row - a_count___2
								end
							end
						end
					end
				end
			end
		end

	gui_insert_lines (a_row, a_count___2: INTEGER_32)
		local
			l_return: BOOLEAN
		do
			if a_count___2 <= 0 then
				l_return := True
			end
			if not l_return then
				if a_row + a_count___2 > gui.item.item.scroll_region_bot then
					gui_clear_block (a_row, gui.item.item.scroll_region_left, gui.item.item.scroll_region_bot, gui.item.item.scroll_region_right)
				else
					(create {P_GUI_GTK_X11_STATIC}).gui_mch_insert_lines (a_row, a_count___2)
					if gui.item.item.cursor_row >= gui.item.item.row then
						if gui.item.item.cursor_col >= gui.item.item.scroll_region_left then
							if gui.item.item.cursor_col <= gui.item.item.scroll_region_right then
								if gui.item.item.cursor_row <= gui.item.item.scroll_region_bot - a_count___2 then
									gui.item.item.cursor_row := gui.item.item.cursor_row + a_count___2
								elseif gui.item.item.cursor_row <= gui.item.item.scroll_region_bot then
									gui.item.item.cursor_is_valid := (0).to_integer_8
								end
							end
						end
					end
				end
			end
		end

	gui_wait_for_chars (a_wtime: INTEGER_32): INTEGER_32
		local
			l_retval: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<3>>)

			if a_wtime /= 0 then
				(create {P_MENU_STATIC}).gui_update_menus (0)
			end
			(create {P_GUI_GTK_X11_STATIC}).gui_mch_update
			if ((create {P_GETCHAR_STATIC}).input_available).to_boolean then
				Result := 1
				l_return := True
			end
			if not l_return and then (a_wtime = 0) then
				Result := 0
				l_return := True
			end
			if not l_return then
				(create {P_GUI_GTK_X11_STATIC}).gui_mch_flush
				if a_wtime > 0 then
					(create {P_GUI_GTK_X11_STATIC}).gui_mch_start_blink
					l_retval := (create {P_GUI_GTK_X11_STATIC}).gui_mch_wait_for_chars (a_wtime);
					(create {P_GUI_GTK_X11_STATIC}).gui_mch_stop_blink
					Result := l_retval
					l_return := True
				end
			end
			if not l_return then
				(create {P_GUI_GTK_X11_STATIC}).gui_mch_start_blink
				l_retval := 0
				if ((create {P_GUI_GTK_X11_STATIC}).gui_mch_wait_for_chars ((create {P_OPTION_STATIC}).p_ut.item.item)) = 1 then
					l_retval := 1
				elseif ((create {P_FILEIO_STATIC}).trigger_cursorhold).to_boolean then
					l_buf___6[0] := (155).to_natural_8
					l_buf___6[1] := (253).to_natural_8
					l_buf___6[2] := (96).to_natural_8;
					(create {P_UI_STATIC}).add_to_input_buf (l_buf___6, 3)
					l_retval := 1
				end
				if l_retval = 0 then
					(create {P_GETCHAR_STATIC}).before_blocking
					l_retval := (create {P_GUI_GTK_X11_STATIC}).gui_mch_wait_for_chars (-1)
				end
				(create {P_GUI_GTK_X11_STATIC}).gui_mch_stop_blink
				Result := l_retval
			end
		end

	fill_mouse_coord (a_p___0: CE_POINTER [NATURAL_8]; a_col, a_row: INTEGER_32)
		require
			not a_p___0.is_void
		do
			a_p___0[0] := ((a_col // 128 + 32) + 1).to_natural_8
			a_p___0[1] := ((a_col \\ 128 + 32) + 1).to_natural_8
			a_p___0[2] := ((a_row // 128 + 32) + 1).to_natural_8
			a_p___0[3] := ((a_row \\ 128 + 32) + 1).to_natural_8
		end

	gui_send_mouse_event (a_button, a_x___0, a_y, a_repeated_click: INTEGER_32; a_modifiers: NATURAL_32)
		local
			l_button: INTEGER_32
			l_repeated_click: INTEGER_32
			l_modifiers: NATURAL_32
			l_string___0: CE_ARRAY [NATURAL_8]
			l_button_char: NATURAL_32
			l_row: INTEGER_32
			l_col: CE_ARRAY [INTEGER_32]
			l_checkfor: INTEGER_32
			l_did_clip: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_string___0.make (<<10>>)
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_button := a_button
					l_repeated_click := a_repeated_click
					l_modifiers := a_modifiers
					l_did_clip := 0
					inspect l_button -- switch 1 head
					when 768 then l_pos := -1 + 1
					when 1024 then l_pos := -1 + 2
					when 256 then l_pos := -1 + 3
					when 512 then l_pos := -1 + 4
					when 1280 then l_pos := -1 + 5
					when 1536 then l_pos := -1 + 6
					else l_pos := -1 + 8
					end
				when 1 then -- switch 1, case 768
					l_button_char := {PC_KEY_EXTRA}.KE_X1MOUSE
					l_pos := -1 + 7 -- goto button_set
				when 2 then -- switch 1, case 1024
					l_button_char := {PC_KEY_EXTRA}.KE_X2MOUSE
					l_pos := -1 + 7 -- goto button_set
				when 3 then -- switch 1, case 256
					l_button_char := {PC_KEY_EXTRA}.KE_MOUSEDOWN
					l_pos := -1 + 7 -- goto button_set
				when 4 then -- switch 1, case 512
					l_button_char := {PC_KEY_EXTRA}.KE_MOUSEUP
					l_pos := -1 + 7 -- goto button_set
				when 5 then -- switch 1, case 1280
					l_button_char := {PC_KEY_EXTRA}.KE_MOUSELEFT
					l_pos := -1 + 7 -- goto button_set
				when 6 then -- switch 1, case 1536
					l_button_char := {PC_KEY_EXTRA}.KE_MOUSERIGHT
				when 7 then -- button_set:
					if ((create {P_GLOBALS_STATIC}).hold_gui_events.item).to_boolean then
						l_return := True
					end
					if not l_return then
						l_string___0[3] := (155).to_natural_8
						l_string___0[4] := (253).to_natural_8
						l_string___0[5] := (l_button_char.to_integer_32).to_natural_8
						l_row := gui_xy2colrow (a_x___0, a_y, l_col)
						l_string___0[6] := ((l_col.item // 128 + 32) + 1).to_natural_8
						l_string___0[7] := ((l_col.item \\ 128 + 32) + 1).to_natural_8
						l_string___0[8] := ((l_row // 128 + 32) + 1).to_natural_8
						l_string___0[9] := ((l_row \\ 128 + 32) + 1).to_natural_8
						if l_modifiers = {NATURAL_32} 0 then
							(create {P_UI_STATIC}).add_to_input_buf (l_string___0 + 3, 7)
						else
							l_string___0[0] := (155).to_natural_8
							l_string___0[1] := (252).to_natural_8
							l_string___0[2] := (0).to_natural_8
							if ((l_modifiers).bit_and ({NATURAL_32} 4)).to_boolean then
								l_string___0[2] := (((l_string___0[2]).to_integer_32).bit_or (2)).to_natural_8
							end
							if ((l_modifiers).bit_and ({NATURAL_32} 16)).to_boolean then
								l_string___0[2] := (((l_string___0[2]).to_integer_32).bit_or (4)).to_natural_8
							end
							if ((l_modifiers).bit_and ({NATURAL_32} 8)).to_boolean then
								l_string___0[2] := (((l_string___0[2]).to_integer_32).bit_or (8)).to_natural_8
							end
							(create {P_UI_STATIC}).add_to_input_buf (l_string___0, 10)
						end
						l_return := True
					end
				when 8 then -- switch 1, done:
					if not l_return and then (((create {P_GLOBALS_STATIC}).clip_star.item.item.state).to_integer_32 = 1) then
						(create {P_UI_STATIC}).clip_process_selection (l_button, (a_x___0 - gui.item.item.border_offset) // gui.item.item.char_width, (a_y - gui.item.item.border_offset) // gui.item.item.char_height, l_repeated_click.to_natural_32)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 30 -- skip if block
					end
				when 9 then -- if:
						inspect ((create {P_MISC2_STATIC}).get_real_state) -- switch 2 head
						when 257 then l_pos := -1 + 10
						when 4 then l_pos := -1 + 10
						when 1 then l_pos := -1 + 10
						when 2 then l_pos := -1 + 11
						when 4096 then l_pos := -1 + 12
						when 80 then l_pos := -1 + 13
						when 112 then l_pos := -1 + 13
						when 208 then l_pos := -1 + 13
						when 240 then l_pos := -1 + 13
						when 16 then l_pos := -1 + 13
						when 48 then l_pos := -1 + 13
						when 768 then l_pos := -1 + 14
						when 513 then l_pos := -1 + 14
						when 8 then l_pos := -1 + 15
						when 40 then l_pos := -1 + 15
						else l_pos := -1 + 16
						end
				when 10 then -- switch 2, case 257 | switch 2, case 4 | switch 2, case 1
						l_checkfor := ('n').code
						l_pos := -1 + 17 -- switch 2; break
				when 11 then -- switch 2, case 2
						l_checkfor := ('v').code
						l_pos := -1 + 17 -- switch 2; break
				when 12 then -- switch 2, case 4096
						l_checkfor := ('v').code
						l_pos := -1 + 17 -- switch 2; break
				when 13 then -- switch 2, case 80 | switch 2, case 112 | switch 2, case 208 | switch 2, case 240 | switch 2, case 16 | switch 2, case 48
						l_checkfor := ('i').code
						l_pos := -1 + 17 -- switch 2; break
				when 14 then -- switch 2, case 768 | switch 2, case 513
						if (a_y - gui.item.item.border_offset) // gui.item.item.char_height >= (create {P_GLOBALS_STATIC}).msg_row.item then
							l_checkfor := ('n').code
						else
							l_checkfor := ('r').code
						end
						l_pos := -1 + 17 -- switch 2; break
				when 15 then -- switch 2, case 8 | switch 2, case 40
						if (a_y - gui.item.item.border_offset) // gui.item.item.char_height < (create {P_GLOBALS_STATIC}).cmdline_row.item then
							if l_button /= 1 then
								l_checkfor := (' ').code
							else
								l_checkfor := ('c').code
							end
						else
							l_checkfor := ('c').code
						end
						l_pos := -1 + 17 -- switch 2; break
				when 16 then -- switch 2, default:
						l_checkfor := (' ').code
						l_pos := -1 + 17 -- switch 2; break
				when 17 then -- switch 2, done:
						if (create {P_GLOBALS_STATIC}).State.item /= 1 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 24 -- goto _L
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 20 then -- else:
						if (create {P_GLOBALS_STATIC}).State.item /= 257 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 24 -- goto _L
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 23 then -- else:
						if not ((((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 24 then -- if: | _L:
						if (a_y - gui.item.item.border_offset) // gui.item.item.char_height >= (create {P_GLOBALS_STATIC}).topframe.item.item.fr_height + (create {P_GLOBALS_STATIC}).firstwin.item.item.w_winrow then
							if l_button /= 67 then
								if not ((create {P_GLOBALS_STATIC}).drag_status_line.item).to_boolean then
									if not ((create {P_GLOBALS_STATIC}).drag_sep_line.item).to_boolean then
										l_checkfor := (' ').code
									end
								end
							end
						end
				when 25 then -- if done | if done
						if ((l_modifiers).bit_and ({NATURAL_32} 16)).to_boolean then
							if ((l_modifiers).bit_and ({NATURAL_32} 4)).to_boolean then
								l_checkfor := ('x').code
							end
						end
						if ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
							l_checkfor := (' ').code
						end
						if not (((create {P_TERM_STATIC}).mouse_has (l_checkfor)).to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 26 then -- if:
						if l_checkfor /= 99 then
							l_pos := -1 + 28 -- skip if block
						end
				when 27 then -- if: | _L___0:
						if l_checkfor /= 120 then
							if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
								if (((create {P_GLOBALS_STATIC}).State.item).bit_and (1)).to_boolean then
									l_return := True
								end
							end
						end
						if not l_return then
							if ((create {P_TERM_STATIC}).mouse_model_popup).to_boolean then
								if l_button = 0 then
									if ((l_modifiers).bit_and ({NATURAL_32} 4)).to_boolean then
										if not ((l_modifiers).bit_and ({NATURAL_32} 16)).to_boolean then
											l_button := 2
											l_modifiers := (l_modifiers).bit_and (({NATURAL_32} 4_294_967_291))
										end
									end
								end
							end
							if l_button = 2 then
								if ((create {P_GLOBALS_STATIC}).clip_star.item.item.state).to_integer_32 = 0 then
									if (((create {P_GLOBALS_STATIC}).State.item).bit_and (8)).to_boolean then
										l_col.item := (create {P_GLOBALS_STATIC}).msg_col.item
										l_row := (create {P_GLOBALS_STATIC}).msg_row.item
									else
										l_col.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol
										l_row := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow + (create {P_GLOBALS_STATIC}).curwin.item.item.w_winrow
									end
									(create {P_UI_STATIC}).clip_start_selection (l_col.item, l_row, 0)
								end
								(create {P_UI_STATIC}).clip_process_selection (l_button, (a_x___0 - gui.item.item.border_offset) // gui.item.item.char_width, (a_y - gui.item.item.border_offset) // gui.item.item.char_height, l_repeated_click.to_natural_32)
								l_did_clip := 1
							elseif l_button = 0 then
								(create {P_UI_STATIC}).clip_start_selection ((a_x___0 - gui.item.item.border_offset) // gui.item.item.char_width, (a_y - gui.item.item.border_offset) // gui.item.item.char_height, l_repeated_click)
								l_did_clip := 1
							end
							if l_button /= 1 then
								if ((create {P_TERM_STATIC}).mouse_has (l_checkfor)).to_boolean then
									if l_button = 3 then
										l_return := True
									end
								else
									l_return := True
								end
								if not l_return and then (l_checkfor /= 99) then
									l_button := 0
								end
							end
						end
						if not l_return then
							l_repeated_click := 0
						end
				when 28 then -- if done | if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						l_pos := -1 + 27 -- goto _L___0
				when 30 then -- if done
					if not l_return then
						if ((create {P_GLOBALS_STATIC}).clip_star.item.item.state).to_integer_32 /= 0 then
							if not l_did_clip.to_boolean then
								(create {P_UI_STATIC}).clip_clear_selection
							end
						end
						if ((create {P_GLOBALS_STATIC}).hold_gui_events.item).to_boolean then
							l_return := True
						end
					end
					if not l_return then
						l_row := gui_xy2colrow (a_x___0, a_y, l_col)
						if l_button = 67 then
							if l_row = prev_row___1.item then
								if l_col.item = prev_col___1.item then
									l_return := True
								end
							end
							if not l_return and then (a_y < 0) then
								l_row := -1
							end
						end
					end
					if not l_return then
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline /= (create {P_GLOBALS_STATIC}).gui_prev_topline.item then
							l_repeated_click := 0
						elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill /= (create {P_GLOBALS_STATIC}).gui_prev_topfill.item then
							l_repeated_click := 0
						end
						l_string___0[0] := (155).to_natural_8
						l_string___0[1] := (251).to_natural_8
						l_string___0[2] := (('X').code).to_natural_8
						if l_button /= 67 then
							if l_button /= 3 then
								if l_repeated_click.to_boolean then
									if l_button /= prev_button.item then
										num_clicks.item := 1
									elseif l_row /= prev_row___1.item then
										num_clicks.item := 1
									elseif l_col.item /= prev_col___1.item then
										num_clicks.item := 1
									else
										num_clicks.item := num_clicks.item + 1
										if num_clicks.item > 4 then
											num_clicks.item := 1
										end
									end
								else
									num_clicks.item := 1
								end
								prev_button.item := l_button;
								(create {P_GLOBALS_STATIC}).gui_prev_topline.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline;
								(create {P_GLOBALS_STATIC}).gui_prev_topfill.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
								l_string___0[3] := ((l_button).bit_or (32)).to_natural_8
								l_string___0[3] := (((((l_string___0[3]).to_integer_32).bit_and (63))).bit_or ((((((num_clicks.item - 1)).bit_and (3))).bit_shift_left (6)))).to_natural_8
							else
								l_string___0[3] := l_button.to_natural_8
							end
						else
							l_string___0[3] := l_button.to_natural_8
						end
						l_string___0[3] := (((l_string___0[3]).to_natural_32).bit_or (l_modifiers)).to_natural_8
						fill_mouse_coord (l_string___0 + 4, l_col.item, l_row);
						(create {P_UI_STATIC}).add_to_input_buf (l_string___0, 8)
						if l_row < 0 then
							prev_row___1.item := 0
						else
							prev_row___1.item := l_row
						end
						prev_col___1.item := l_col.item
						gui.item.item.dragged_sb := -1
					end
				when 31 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_xy2colrow (a_x___0, a_y: INTEGER_32; a_colp: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_colp.is_void
		local
			l_col: INTEGER_32
			l_row: INTEGER_32
		do
			l_col := ((create {P_UI_STATIC}).check_col ((a_x___0 - gui.item.item.border_offset) // gui.item.item.char_width))
			l_row := ((create {P_UI_STATIC}).check_row ((a_y - gui.item.item.border_offset) // gui.item.item.char_height))
			a_colp.item := (create {P_MBYTE_STATIC}).mb_fix_col (l_col, l_row)
			Result := l_row
		end

	gui_menu_cb (a_menu___1: CE_POINTER [PD_VIMMENU])
		local
			l_bytes___0: CE_ARRAY [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_bytes___0.make (<<({PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32>>)

			if ((create {P_GLOBALS_STATIC}).hold_gui_events.item).to_boolean then
				l_return := True
			end
			if not l_return then
				l_bytes___0[0] := (155).to_natural_8
				l_bytes___0[1] := (250).to_natural_8
				l_bytes___0[2] := (('X').code).to_natural_8;
				(create {P_UI_STATIC}).add_to_input_buf (l_bytes___0, 3);
				(create {P_TERM_STATIC}).add_long_to_buf ((a_menu___1.c_pointer.to_integer_32).to_natural_32, l_bytes___0);
				(create {P_UI_STATIC}).add_to_input_buf_csi (l_bytes___0, ({PLATFORM}.Natural_32_bytes.to_natural_32).to_integer_32)
			end
		end

	gui_init_which_components (a_oldval: CE_POINTER [NATURAL_8])
		local
			l_using_toolbar: INTEGER_32
			l_using_tabline: INTEGER_32
			l_using_tearoff: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_grey_old: INTEGER_32
			l_grey_new: INTEGER_32
			l_temp: CE_POINTER [NATURAL_8]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_need_set_size: INTEGER_32
			l_fix_size: INTEGER_32
			l_tmp___5: INTEGER_32
			l_prev_Columns: INTEGER_32
			l_prev_Rows: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_using_toolbar := 0
					l_using_tearoff := 0
					if not a_oldval.is_void then
						if (gui.item.item.in_use).to_boolean then
							l_grey_old := (not ((create {P_MISC2_STATIC}).vim_strchr (a_oldval, ('g').code)).is_void).to_integer
							l_grey_new := (not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_go.item.item, ('g').code)).is_void).to_integer
							if l_grey_old /= l_grey_new then
								l_temp := (create {P_OPTION_STATIC}).p_go.item.item;
								(create {P_OPTION_STATIC}).p_go.item.item := a_oldval;
								(create {P_MENU_STATIC}).gui_update_menus (((1).bit_shift_left (6)) - 1);
								(create {P_OPTION_STATIC}).p_go.item.item := l_temp
							end
						end
					end
					gui.item.item.menu_is_active := (0).to_integer_8
					l_i___0 := 0
					from
					until
						not (l_i___0 < 3)
					loop
						gui.item.item.which_scrollbars[l_i___0] := 0
						l_i___0 := l_i___0 + 1
					end
					l_p___0 := (create {P_OPTION_STATIC}).p_go.item.item
				when 1 then -- loop condition:
					if not ((l_p___0.item).to_boolean) then
						l_pos := -1 + 14 -- skip loop
					end
				when 2 then -- loop body:
						inspect (l_p___0.item).to_integer_32 -- switch 1 head
						when 108 then l_pos := -1 + 3
						when 114 then l_pos := -1 + 4
						when 76 then l_pos := -1 + 5
						when 82 then l_pos := -1 + 6
						when 98 then l_pos := -1 + 7
						when 109 then l_pos := -1 + 8
						when 103 then l_pos := -1 + 9
						when 84 then l_pos := -1 + 10
						when 116 then l_pos := -1 + 11
						else l_pos := -1 + 12
						end
				when 3 then -- switch 1, case 108
						gui.item.item.which_scrollbars[0] := 1
						l_pos := -1 + 13 -- switch 1; break
				when 4 then -- switch 1, case 114
						gui.item.item.which_scrollbars[1] := 1
						l_pos := -1 + 13 -- switch 1; break
				when 5 then -- switch 1, case 76
						if ((create {P_WINDOW_STATIC}).win_hasvertsplit).to_boolean then
							gui.item.item.which_scrollbars[0] := 1
						end
						l_pos := -1 + 13 -- switch 1; break
				when 6 then -- switch 1, case 82
						if ((create {P_WINDOW_STATIC}).win_hasvertsplit).to_boolean then
							gui.item.item.which_scrollbars[1] := 1
						end
						l_pos := -1 + 13 -- switch 1; break
				when 7 then -- switch 1, case 98
						gui.item.item.which_scrollbars[2] := 1
						l_pos := -1 + 13 -- switch 1; break
				when 8 then -- switch 1, case 109
						gui.item.item.menu_is_active := (1).to_integer_8
						l_pos := -1 + 13 -- switch 1; break
				when 9 then -- switch 1, case 103
						l_pos := -1 + 13 -- switch 1; break
				when 10 then -- switch 1, case 84
						l_using_toolbar := 1
						l_pos := -1 + 13 -- switch 1; break
				when 11 then -- switch 1, case 116
						l_using_tearoff := 1
						l_pos := -1 + 13 -- switch 1; break
				when 12 then -- switch 1, default:
						l_pos := -1 + 13 -- switch 1; break
				when 13 then -- switch 1, done:
						l_p___0 := l_p___0 + 1
						l_pos := -1 + 1 -- back to loop condition
				when 14 then -- loop done
					if not ((gui.item.item.in_use).to_boolean) then
						l_pos := -1 + 24 -- skip if block
					end
				when 15 then -- if:
						l_need_set_size := 0
						l_fix_size := 0
						l_using_tabline := gui_has_tabline
						if ((create {P_GUI_GTK_X11_STATIC}).gui_mch_showing_tabline).to_boolean then
							l_tmp___5 := 0
						else
							l_tmp___5 := 1
						end
						if l_tmp___5.to_boolean /= not l_using_tabline.to_boolean then
							l_i___0 := ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32
							gui_update_tabline;
							(create {P_GLOBALS_STATIC}).Rows.item.item := l_i___0.to_integer_32
							l_need_set_size := (l_need_set_size).bit_or ((1))
							if l_using_tabline.to_boolean then
								l_fix_size := 1
							end
							if not (gui_use_tabline).to_boolean then
								(create {P_GLOBALS_STATIC}).redraw_tabline.item := 1
							end
						end
						l_i___0 := 0
				when 16 then -- loop condition:
						if not (not (l_return) and then (l_i___0 < 3)) then
							l_pos := -1 + 23 -- skip loop
						end
				when 17 then -- loop body:
						if gui.item.item.which_scrollbars[l_i___0] = prev_which_scrollbars.item[l_i___0] then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 20 then -- else:
						if gui.item.item.which_scrollbars[l_i___0] = (create {P_GLOBALS_STATIC}).curtab.item.item.tp_prev_which_scrollbars[l_i___0] then
							l_pos := -1 + 22 -- skip if block
						end
				when 21 then -- if: | _L:
						if l_i___0 = 2 then
							(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (gui.item.item.c_pointer + (create {PD_GUI}.make).offset_of ("bottom_sbar"))).item.gui_mch_enable_scrollbar (gui.item.item.which_scrollbars[l_i___0])
						else
							l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
							from
							until
								l_wp___0.is_void
							loop
								l_wp___0.item.gui_do_scrollbar (l_i___0, gui.item.item.which_scrollbars[l_i___0])
								l_wp___0 := l_wp___0.item.w_next
							end
						end
						if gui.item.item.which_scrollbars[l_i___0] /= prev_which_scrollbars.item[l_i___0] then
							if l_i___0 = 2 then
								l_need_set_size := (l_need_set_size).bit_or ((1))
							else
								l_need_set_size := (l_need_set_size).bit_or ((2))
							end
							if (gui.item.item.which_scrollbars[l_i___0]).to_boolean then
								l_fix_size := 1
							end
						end
				when 22 then -- if done;
						(create {P_GLOBALS_STATIC}).curtab.item.item.tp_prev_which_scrollbars[l_i___0] := gui.item.item.which_scrollbars[l_i___0]
						prev_which_scrollbars.item[l_i___0] := gui.item.item.which_scrollbars[l_i___0]
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 16 -- back to loop condition
				when 23 then -- loop done
						if (gui.item.item.menu_is_active).to_integer_32 /= prev_menu_is_active.item then
							l_i___0 := ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32;
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_enable_menu ((gui.item.item.menu_is_active).to_integer_32);
							(create {P_GLOBALS_STATIC}).Rows.item.item := l_i___0.to_integer_32
							prev_menu_is_active.item := (gui.item.item.menu_is_active).to_integer_32
							l_need_set_size := (l_need_set_size).bit_or ((1))
							if (gui.item.item.menu_is_active).to_boolean then
								l_fix_size := 1
							end
						end
						if l_using_toolbar /= prev_toolbar.item then
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_show_toolbar (l_using_toolbar)
							prev_toolbar.item := l_using_toolbar
							l_need_set_size := (l_need_set_size).bit_or ((1))
							if l_using_toolbar.to_boolean then
								l_fix_size := 1
							end
						end
						if l_using_tearoff /= prev_tearoff.item then
							(create {P_GUI_GTK_STATIC}).gui_mch_toggle_tearoffs (l_using_tearoff)
							prev_tearoff.item := l_using_tearoff
						end
						if l_need_set_size /= 0 then
							l_prev_Columns := (create {P_GLOBALS_STATIC}).Columns.item.item
							l_prev_Rows := (create {P_GLOBALS_STATIC}).Rows.item.item
							gui_set_shellsize (0, l_fix_size, l_need_set_size)
							if not (gui.item.item.starting).to_boolean then
								if l_need_set_size /= 3 then
									(create {P_GETCHAR_STATIC}).char_avail.do_nothing
								end
							end
							if ((l_need_set_size).bit_and (1)) = 0 then
								(create {P_GLOBALS_STATIC}).Rows.item.item := l_prev_Rows
							end
							if ((l_need_set_size).bit_and (2)) = 0 then
								(create {P_GLOBALS_STATIC}).Columns.item.item := l_prev_Columns
							end
						end
						if (create {P_GLOBALS_STATIC}).firstwin.item.item.w_winrow /= ((create {P_WINDOW_STATIC}).tabline_height) then
							(create {P_WINDOW_STATIC}).shell_new_rows
						end
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_use_tabline: INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (gui.item.item.in_use).to_boolean then
				if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_go.item.item, ('e').code)).is_void then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	gui_has_tabline: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (gui_use_tabline).to_boolean then
				if (create {P_OPTION_STATIC}).p_stal.item.item = 0 then
					Result := 0
					l_return := True
				elseif (create {P_OPTION_STATIC}).p_stal.item.item = 1 then
					if ((create {P_GLOBALS_STATIC}).first_tabpage.item.item.tp_next).is_void then
						Result := 0
						l_return := True
					end
				end
			else
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := 1
			end
		end

	gui_update_tabline
		local
			l_showit: INTEGER_32
			l_shown: INTEGER_32
		do
			l_showit := (gui_has_tabline)
			l_shown := ((create {P_GUI_GTK_X11_STATIC}).gui_mch_showing_tabline)
			if not (gui.item.item.starting).to_boolean then
				if (create {P_GLOBALS_STATIC}).starting.item = 0 then
					(create {P_TERM_STATIC}).out_flush;
					(create {P_GUI_GTK_X11_STATIC}).gui_mch_flush
					if not l_showit.to_boolean /= not l_shown.to_boolean then
						(create {P_GUI_GTK_X11_STATIC}).gui_mch_show_tabline (l_showit)
					end
					if l_showit /= 0 then
						(create {P_GUI_GTK_X11_STATIC}).gui_mch_update_tabline
					end
					if not l_showit.to_boolean /= not l_shown.to_boolean then
						gui_set_shellsize (0, l_showit, 1)
					end
				end
			end
		end

	get_tabline_label (a_tp: CE_POINTER [PD_TABPAGE_S]; a_tooltip: INTEGER_32)
		local
			l_modified: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_wincount: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_opt: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_use_sandbox: INTEGER_32
			l_save_called_emsg: INTEGER_32
			l_res: CE_ARRAY [NATURAL_8]
			l_save_curtab: CE_POINTER [PD_TABPAGE_S]
			l_opt_name: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [PD_FILE_BUFFER]
			l_tmp___3: NATURAL_32
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<40>>)
			create {CE_NATURAL_8_ARRAY} l_res.make (<<4_096>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_modified := 0
					if a_tooltip.to_boolean then
						l_opt := (create {P_OPTION_STATIC}).p_gtt.item
					else
						l_opt := (create {P_OPTION_STATIC}).p_gtl.item
					end
					if ((l_opt.item).item).to_integer_32 /= 0 then
						l_use_sandbox := 0
						l_save_called_emsg := (create {P_GLOBALS_STATIC}).called_emsg.item
						if a_tooltip.to_boolean then
							l_tmp := ce_string ("guitabtooltip")
						else
							l_tmp := ce_string ("guitablabel")
						end
						l_opt_name := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp);
						(create {P_GLOBALS_STATIC}).called_emsg.item := 0;
						(create {P_GLOBALS_STATIC}).printer_page_num.item := ((create {P_WINDOW_STATIC}).tabpage_index (a_tp)).to_integer_32;
						(create {P_EVAL_STATIC}).set_vim_var_nr (9, (create {P_GLOBALS_STATIC}).printer_page_num.item)
						l_use_sandbox := (create {P_OPTION_STATIC}).was_set_insecurely (l_opt_name, 0);
						(create {P_GLOBALS_STATIC}).curtab.item.item.tp_firstwin := (create {P_GLOBALS_STATIC}).firstwin.item;
						(create {P_GLOBALS_STATIC}).curtab.item.item.tp_lastwin := (create {P_GLOBALS_STATIC}).lastwin.item;
						(create {P_GLOBALS_STATIC}).curtab.item.item.tp_curwin := (create {P_GLOBALS_STATIC}).curwin.item
						l_save_curtab := (create {P_GLOBALS_STATIC}).curtab.item;
						(create {P_GLOBALS_STATIC}).curtab.item := a_tp;
						(create {P_GLOBALS_STATIC}).topframe.item := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_topframe;
						(create {P_GLOBALS_STATIC}).firstwin.item := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_firstwin;
						(create {P_GLOBALS_STATIC}).lastwin.item := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_lastwin;
						(create {P_GLOBALS_STATIC}).curwin.item := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_curwin;
						(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer;
						((create {P_GLOBALS_STATIC}).curwin.item).item.build_stl_str_hl (l_res, (4_096).to_natural_32, l_opt.item, l_use_sandbox, 0, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32, create {CE_CLASS_POINTER [PD_STL_HLREC]}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_STL_HLREC]}.make_shared (default_pointer)).do_nothing
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item), create {CE_INTEGER_8_POINTER}.make_cast (l_res)).do_nothing;
						(create {P_GLOBALS_STATIC}).curtab.item := l_save_curtab;
						(create {P_GLOBALS_STATIC}).topframe.item := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_topframe;
						(create {P_GLOBALS_STATIC}).firstwin.item := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_firstwin;
						(create {P_GLOBALS_STATIC}).lastwin.item := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_lastwin;
						(create {P_GLOBALS_STATIC}).curwin.item := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_curwin;
						(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
						if ((create {P_GLOBALS_STATIC}).called_emsg.item).to_boolean then
							(create {P_OPTION_STATIC}).set_string_option_direct (l_opt_name, -1, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 1, -5)
						end
						(create {P_GLOBALS_STATIC}).called_emsg.item := ((create {P_GLOBALS_STATIC}).called_emsg.item).bit_or (l_save_called_emsg)
					end
					if ((l_opt.item).item).to_integer_32 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 3 then -- else:
						if ((create {P_GLOBALS_STATIC}).NameBuff.item.item.item).to_integer_32 /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if: | _L___0:
						if a_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
							l_tmp___1 := (create {P_GLOBALS_STATIC}).curbuf.item
						else
							l_tmp___1 := (a_tp.item.tp_curwin).item.w_buffer
						end
						l_tmp___1.item.get_trans_bufname
						if not a_tooltip.to_boolean then
							(create {P_MISC1_STATIC}).shorten_dir ((create {P_GLOBALS_STATIC}).NameBuff.item.item)
						end
						if a_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
							l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
						else
							l_wp___0 := a_tp.item.tp_firstwin
						end
						l_wincount := 0
						from
						until
							l_wp___0.is_void
						loop
							if ((l_wp___0.item.w_buffer).item.bufIsChanged).to_boolean then
								l_modified := 1
							end
							l_wp___0 := l_wp___0.item.w_next
							l_wincount := l_wincount + 1
						end
						if not (l_modified.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if not (l_wincount > 1) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if l_wincount > 1 then
							(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (40).to_natural_32), ce_string ("%%d"), l_wincount]).do_nothing
						else
							l_buf___6[0] := (('%/0/').code).to_natural_8
						end
						if l_modified.to_boolean then
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("+")).do_nothing
						end
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string (" ")).do_nothing
						l_tmp___3 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item))
						memmove (create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).NameBuff.item.item + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))).to_integer_32)), create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item), l_tmp___3 + {NATURAL_32} 1).do_nothing
						memmove (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item), create {CE_VOID_POINTER}.make_cast (l_buf___6), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6)))).do_nothing
				when 9 then -- if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	send_tabline_event (a_nr: INTEGER_32): INTEGER_32
		local
			l_string___0: CE_ARRAY [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_string___0.make (<<3>>)

			if a_nr = ((create {P_WINDOW_STATIC}).tabpage_index ((create {P_GLOBALS_STATIC}).curtab.item)) then
				Result := 0
				l_return := True
			end
			if not l_return then
				if ((create {P_GLOBALS_STATIC}).hold_gui_events.item).to_boolean then
					l_tmp___0 := (create {P_WINDOW_STATIC}).tabpage_index ((create {P_GLOBALS_STATIC}).curtab.item);
					(create {P_GUI_GTK_X11_STATIC}).gui_mch_set_curtab (l_tmp___0)
					Result := 0
					l_return := True
				elseif (create {P_GLOBALS_STATIC}).cmdwin_type.item /= 0 then
					l_tmp___0 := (create {P_WINDOW_STATIC}).tabpage_index ((create {P_GLOBALS_STATIC}).curtab.item);
					(create {P_GUI_GTK_X11_STATIC}).gui_mch_set_curtab (l_tmp___0)
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_string___0[0] := (155).to_natural_8
				l_string___0[1] := (240).to_natural_8
				l_string___0[2] := (('X').code).to_natural_8;
				(create {P_UI_STATIC}).add_to_input_buf (l_string___0, 3)
				l_string___0[0] := a_nr.to_natural_8;
				(create {P_UI_STATIC}).add_to_input_buf_csi (l_string___0, 1)
				Result := 1
			end
		end

	send_tabline_menu_event (a_tabidx, a_event: INTEGER_32)
		local
			l_string___0: CE_ARRAY [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_string___0.make (<<3>>)

			if ((create {P_GLOBALS_STATIC}).hold_gui_events.item).to_boolean then
				l_return := True
			end
			if not l_return then
				l_string___0[0] := (155).to_natural_8
				l_string___0[1] := (239).to_natural_8
				l_string___0[2] := (('X').code).to_natural_8;
				(create {P_UI_STATIC}).add_to_input_buf (l_string___0, 3)
				l_string___0[0] := a_tabidx.to_natural_8
				l_string___0[1] := (a_event.to_integer_32).to_natural_8;
				(create {P_UI_STATIC}).add_to_input_buf_csi (l_string___0, 2)
			end
		end

	gui_remove_scrollbars
		local
			l_i___0: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_return: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				not (not (l_return) and then (l_i___0 < 3))
			loop
				if l_i___0 = 2 then
					(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (gui.item.item.c_pointer + (create {PD_GUI}.make).offset_of ("bottom_sbar"))).item.gui_mch_enable_scrollbar (0)
				else
					l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
					from
					until
						l_wp___0.is_void
					loop
						l_wp___0.item.gui_do_scrollbar (l_i___0, 0)
						l_wp___0 := l_wp___0.item.w_next
					end
				end
				(create {P_GLOBALS_STATIC}).curtab.item.item.tp_prev_which_scrollbars[l_i___0] := -1
				l_i___0 := l_i___0 + 1
			end
		end

	gui_find_scrollbar (a_ident: INTEGER_32): CE_POINTER [PD_GUISCROLLBAR]
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_return: BOOLEAN
		do
			if gui.item.item.bottom_sbar.ident = a_ident then
				Result := (create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (gui.item.item.c_pointer + (create {PD_GUI}.make).offset_of ("bottom_sbar")))
				l_return := True
			end
			if not l_return then
				l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
				from
				until
					not (not (l_return) and then (not l_wp___0.is_void))
				loop
					if l_wp___0.item.w_scrollbars[0].ident = a_ident then
						Result := (create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (l_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (0)))
						l_return := True
					end
					if not l_return and then (l_wp___0.item.w_scrollbars[1].ident = a_ident) then
						Result := (create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (l_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (1)))
						l_return := True
					end
					if not l_return then
						l_wp___0 := l_wp___0.item.w_next
					end
				end
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (default_pointer))
			end
		end

	gui_drag_scrollbar (a_sb: CE_POINTER [PD_GUISCROLLBAR]; a_value: INTEGER_32; a_still_dragging: INTEGER_32)
		local
			l_sb: CE_POINTER [PD_GUISCROLLBAR]
			l_value: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_sb_num: INTEGER_32
			l_old_leftcol___0: INTEGER_32
			l_old_topline___0: INTEGER_32
			l_old_topfill___0: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sb := a_sb
					l_value := a_value
					l_old_leftcol___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol
					l_old_topline___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
					l_old_topfill___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
					if l_sb.is_void then
						l_return := True
					end
					if not l_return and then (((create {P_GLOBALS_STATIC}).hold_gui_events.item).to_boolean) then
						l_return := True
					end
					if not l_return and then ((create {P_GLOBALS_STATIC}).cmdwin_type.item /= 0) then
						if not (l_sb.item.wp).is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
							l_return := True
						end
					end
					if not l_return then
						if a_still_dragging.to_boolean then
							if (l_sb.item.wp).is_void then
								gui.item.item.dragged_sb := 2
							elseif l_sb.is_equal (create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared ((l_sb.item.wp).c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (0))) then
								gui.item.item.dragged_sb := 0
							else
								gui.item.item.dragged_sb := 1
							end
							gui.item.item.dragged_wp := l_sb.item.wp
						else
							gui.item.item.dragged_sb := -1
							gui.item.item.dragged_wp := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
						end
						if not (l_sb.item.wp).is_void then
							l_sb := create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared ((l_sb.item.wp).c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (0))
						end
						if l_value < 0 then
							l_value := 0
						end
						if l_value > (l_sb.item.max - l_sb.item.size) + 1 then
							l_value := (l_sb.item.max - l_sb.item.size) + 1
						end
						l_sb.item.value := l_value
						if ((create {P_GLOBALS_STATIC}).dont_scroll.item).to_boolean then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not ((l_sb.item.wp).is_void) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not ((l_sb.item.wp).is_equal ((create {P_GLOBALS_STATIC}).curwin.item)) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
							l_return := True
						end
				when 6 then -- if done | if done
					if not l_return then
						if not (l_sb.item.wp).is_void then
							l_sb_num := 0
							l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
							from
							until
								(l_break)
							loop
								l_break := False
								if not l_wp___0.is_equal (l_sb.item.wp) then
									if l_wp___0.is_void then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_sb_num := l_sb_num + 1
									l_wp___0 := l_wp___0.item.w_next
								end
							end
							l_break := False
							if l_wp___0.is_void then
								l_return := True
							end
							if not l_return then
								(create {P_GLOBALS_STATIC}).current_scrollbar.item := l_sb_num;
								(create {P_GLOBALS_STATIC}).scrollbar_value.item := l_value.to_natural_32
								if (((create {P_GLOBALS_STATIC}).State.item).bit_and (1)).to_boolean then
									gui_do_scroll.do_nothing;
									(create {P_SCREEN_STATIC}).setcursor
								elseif (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
									(create {P_EDIT_STATIC}).ins_scroll;
									(create {P_SCREEN_STATIC}).setcursor
								elseif (((create {P_GLOBALS_STATIC}).State.item).bit_and (8)).to_boolean then
									if (create {P_GLOBALS_STATIC}).msg_scrolled.item = 0 then
										gui_do_scroll.do_nothing;
										(create {P_EX_GETLN_STATIC}).redrawcmdline
									end
								end
								l_sb.item.value := (l_sb.item.wp).item.w_topline - 1
								if (gui.item.item.which_scrollbars[1]).to_boolean then
									if (gui.item.item.which_scrollbars[0]).to_boolean then
										if l_sb.is_equal (create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared ((l_sb.item.wp).c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (1))) then
											l_tmp___0 := 0
										else
											l_tmp___0 := 1
										end
										(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared ((l_sb.item.wp).c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (l_tmp___0))).item.gui_mch_set_scrollbar_thumb (l_sb.item.value, l_sb.item.size, l_sb.item.max)
									end
								end
							end
						else
							(create {P_GLOBALS_STATIC}).scrollbar_value.item := l_value.to_natural_32
							if (((create {P_GLOBALS_STATIC}).State.item).bit_and (1)).to_boolean then
								gui_do_horiz_scroll ((create {P_GLOBALS_STATIC}).scrollbar_value.item, 0).do_nothing
							elseif (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
								(create {P_EDIT_STATIC}).ins_horscroll
							elseif (((create {P_GLOBALS_STATIC}).State.item).bit_and (8)).to_boolean then
								if (create {P_GLOBALS_STATIC}).msg_scrolled.item = 0 then
									gui_do_horiz_scroll ((create {P_GLOBALS_STATIC}).scrollbar_value.item, 0).do_nothing;
									(create {P_EX_GETLN_STATIC}).redrawcmdline
								end
							end
							if l_old_leftcol___0 /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol then
								(create {P_SCREEN_STATIC}).updateWindow ((create {P_GLOBALS_STATIC}).curwin.item);
								(create {P_SCREEN_STATIC}).setcursor
							end
						end
					end
					if l_return then
						l_pos := -1 + 18 -- skip if block
					end
				when 7 then -- if:
						if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_scb).to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 8 then -- if:
						if not ((l_sb.item.wp).is_void) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol /= l_old_leftcol___0 then
							l_pos := -1 + 16 -- goto _L___1
						else
							l_pos := -1 + 11 -- goto _L___2
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 11 then -- else: | _L___2:
						if not ((l_sb.item.wp).is_equal ((create {P_GLOBALS_STATIC}).curwin.item)) then
							l_pos := -1 + 17 -- skip if block
						end
				when 12 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline = l_old_topline___0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L___1
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill = l_old_topfill___0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L___1:;
						(create {P_NORMAL_STATIC}).do_check_scrollbind (1)
						l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
						from
						until
							l_wp___0.is_void
						loop
							if l_wp___0.item.w_redr_type > 0 then
								(create {P_SCREEN_STATIC}).updateWindow (l_wp___0)
							end
							l_wp___0 := l_wp___0.item.w_next
						end
						(create {P_SCREEN_STATIC}).setcursor
				when 17 then -- if done | if done | if done | if done;
						(create {P_TERM_STATIC}).out_flush
						gui_update_cursor (0, 1)
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_may_update_scrollbars
		do
			if (gui.item.item.in_use).to_boolean then
				if (create {P_GLOBALS_STATIC}).starting.item = 0 then
					(create {P_TERM_STATIC}).out_flush
					gui_init_which_components (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					gui_update_scrollbars (1)
				end
			end
			(create {P_GLOBALS_STATIC}).need_mouse_correct.item := 1
		end

	gui_update_scrollbars (a_force: INTEGER_32)
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_sb: CE_POINTER [PD_GUISCROLLBAR]
			l_val___0: INTEGER_32
			l_size: INTEGER_32
			l_max: INTEGER_32
			l_which_sb: INTEGER_32
			l_h: INTEGER_32
			l_y: INTEGER_32
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [PD_GUISCROLLBAR]} l_sb.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					gui_update_horiz_scrollbar (a_force)
					if not (gui.item.item.which_scrollbars[0]).to_boolean then
						if not (gui.item.item.which_scrollbars[1]).to_boolean then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 52 -- skip if block
					end
				when 1 then -- if:
						if a_force.to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if gui.item.item.dragged_sb /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if gui.item.item.dragged_sb /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						if (gui.item.item.which_scrollbars[0]).to_boolean then
							if (gui.item.item.which_scrollbars[1]).to_boolean then
								l_which_sb := 1 - gui.item.item.dragged_sb
								if not (gui.item.item.dragged_wp).is_void then
									(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared ((gui.item.item.dragged_wp).c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (l_which_sb))).item.gui_mch_set_scrollbar_thumb ((gui.item.item.dragged_wp).item.w_scrollbars[0].value, (gui.item.item.dragged_wp).item.w_scrollbars[0].size, (gui.item.item.dragged_wp).item.w_scrollbars[0].max)
								end
							end
						end
				when 7 then -- if done | if done;
						(create {P_GLOBALS_STATIC}).hold_gui_events.item := (create {P_GLOBALS_STATIC}).hold_gui_events.item + (1)
						l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
				when 8 then -- loop condition:
						if l_wp___0.is_void then
							l_pos := -1 + 51 -- skip loop
						end
				when 9 then -- loop body:
						l_continue := False
						if (l_wp___0.item.w_buffer).is_void then
							l_continue := True
						end
						if not (not (l_continue) and then (not a_force.to_boolean)) then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						if gui.item.item.dragged_sb /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if gui.item.item.dragged_sb /= 1 then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L___0:
						if (gui.item.item.dragged_wp).is_equal (l_wp___0) then
							l_continue := True
						end
				when 15 then -- if done | if done
						if (l_continue) then
							l_pos := -1 + 21 -- skip if block
						end
				when 16 then -- if:
						l_max := ((l_wp___0.item.w_buffer).item.b_ml.ml_line_count + (l_wp___0.item.w_height).to_integer_32) - 2
						if l_max < 0 then
							l_max := 0
						end
						l_val___0 := l_wp___0.item.w_topline - 1
						l_size := (l_wp___0.item.w_height).to_integer_32
						if l_size > l_max + 1 then
							l_size := l_max + 1
						end
						if l_val___0 > (l_max - l_size) + 1 then
							l_val___0 := (l_max - l_size) + 1
						end
						if l_val___0 < 0 then
							l_val___0 := 0
						end
						l_sb := create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (l_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (0))
						if not (l_size < 1) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L___1
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 19 then -- else:
						if not (l_wp___0.item.w_botline - 2 > l_max) then
							l_pos := -1 + 21 -- skip if block
						end
				when 20 then -- if: | _L___1:
						l_sb.item.height := 0
						if (gui.item.item.which_scrollbars[0]).to_boolean then
							l_wp___0.item.gui_do_scrollbar (0, 0)
						end
						if (gui.item.item.which_scrollbars[1]).to_boolean then
							l_wp___0.item.gui_do_scrollbar (1, 0)
						end
						l_continue := True
				when 21 then -- if done | if done
						if (l_continue) then
							l_pos := -1 + 50 -- skip if block
						end
				when 22 then -- if:
						if not (a_force.to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 38 -- goto _L___2
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 25 then -- else:
						if l_sb.item.height = l_wp___0.item.w_height then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 38 -- goto _L___2
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 28 then -- else:
						if l_sb.item.top = l_wp___0.item.w_winrow then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						l_pos := -1 + 38 -- goto _L___2
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 31 then -- else:
						if l_sb.item.status_height = l_wp___0.item.w_status_height then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 38 -- goto _L___2
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 34 then -- else:
						if l_sb.item.width = l_wp___0.item.w_width then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_pos := -1 + 38 -- goto _L___2
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 37 then -- else:
						if prev_curwin.item.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
							l_pos := -1 + 39 -- skip if block
						end
				when 38 then -- if: | _L___2:
						l_sb.item.height := l_wp___0.item.w_height
						l_sb.item.top := l_wp___0.item.w_winrow
						l_sb.item.status_height := l_wp___0.item.w_status_height
						l_sb.item.width := l_wp___0.item.w_width
						l_h := (l_sb.item.height + l_sb.item.status_height) * gui.item.item.char_height
						l_y := l_sb.item.top * gui.item.item.char_height + gui.item.item.border_offset
						if l_wp___0.item.w_winrow = 0 then
							l_h := l_h + (gui.item.item.border_offset)
							l_y := l_y - (gui.item.item.border_offset)
						end
						if (gui.item.item.which_scrollbars[0]).to_boolean then
							(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (l_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (0))).item.gui_mch_set_scrollbar_pos (gui.item.item.left_sbar_x, l_y, gui.item.item.scrollbar_width, l_h)
							l_wp___0.item.gui_do_scrollbar (0, 1)
						end
						if (gui.item.item.which_scrollbars[1]).to_boolean then
							(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (l_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (1))).item.gui_mch_set_scrollbar_pos (gui.item.item.right_sbar_x, l_y, gui.item.item.scrollbar_width, l_h)
							l_wp___0.item.gui_do_scrollbar (1, 1)
						end
				when 39 then -- if done | if done | if done | if done | if done
						if not (a_force.to_boolean) then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						l_pos := -1 + 49 -- goto _L___3
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 42 then -- else:
						if l_sb.item.value = l_val___0 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						l_pos := -1 + 49 -- goto _L___3
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 45 then -- else:
						if l_sb.item.size = l_size then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						l_pos := -1 + 49 -- goto _L___3
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 48 then -- else:
						if l_sb.item.max = l_max then
							l_pos := -1 + 50 -- skip if block
						end
				when 49 then -- if: | _L___3:
						l_sb.item.value := l_val___0
						l_sb.item.size := l_size
						l_sb.item.max := l_max
						if (gui.item.item.which_scrollbars[0]).to_boolean then
							if gui.item.item.dragged_sb /= 0 then
								(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (l_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (0))).item.gui_mch_set_scrollbar_thumb (l_val___0, l_size, l_max)
							elseif not (gui.item.item.dragged_wp).is_equal (l_wp___0) then
								(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (l_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (0))).item.gui_mch_set_scrollbar_thumb (l_val___0, l_size, l_max)
							end
						end
						if (gui.item.item.which_scrollbars[1]).to_boolean then
							if gui.item.item.dragged_sb /= 1 then
								(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (l_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (1))).item.gui_mch_set_scrollbar_thumb (l_val___0, l_size, l_max)
							elseif not (gui.item.item.dragged_wp).is_equal (l_wp___0) then
								(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (l_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (1))).item.gui_mch_set_scrollbar_thumb (l_val___0, l_size, l_max)
							end
						end
				when 50 then -- if done | if done | if done | if done
						l_wp___0 := l_wp___0.item.w_next
						l_pos := -1 + 8 -- back to loop condition
				when 51 then -- loop done
						l_continue := False
						prev_curwin.item := (create {P_GLOBALS_STATIC}).curwin.item;
						(create {P_GLOBALS_STATIC}).hold_gui_events.item := (create {P_GLOBALS_STATIC}).hold_gui_events.item - (1)
				when 52 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_do_scroll: INTEGER_32
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_save_wp: CE_POINTER [PD_WINDOW_S]
			l_i___0: INTEGER_32
			l_nlines: INTEGER_32
			l_old_cursor: PD_POS_T
			l_old_topline___0: INTEGER_32
			l_old_topfill___0: INTEGER_32
			l_type: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
					l_i___0 := 0
					from
					until
						not (not (l_break) and then (l_i___0 < (create {P_GLOBALS_STATIC}).current_scrollbar.item))
					loop
						l_break := False
						if l_wp___0.is_void then
							l_break := True
						end
						if not (l_break) then
							l_wp___0 := l_wp___0.item.w_next
							l_i___0 := l_i___0 + 1
						end
					end
					l_break := False
					if l_wp___0.is_void then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_nlines := (((create {P_GLOBALS_STATIC}).scrollbar_value.item).to_integer_32 + 1) - l_wp___0.item.w_topline
						if l_nlines = 0 then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_save_wp := (create {P_GLOBALS_STATIC}).curwin.item
						l_old_topline___0 := l_wp___0.item.w_topline
						l_old_topfill___0 := l_wp___0.item.w_topfill
						l_old_cursor := (l_wp___0.item.w_cursor).twin;
						(create {P_GLOBALS_STATIC}).curwin.item := l_wp___0;
						(create {P_GLOBALS_STATIC}).curbuf.item := l_wp___0.item.w_buffer
						if l_nlines < 0 then
							(create {P_MOVE_STATIC}).scrolldown (-l_nlines, ((gui.item.item.dragged_wp).is_void).to_integer)
						else
							(create {P_MOVE_STATIC}).scrollup (l_nlines, ((gui.item.item.dragged_wp).is_void).to_integer)
						end
						if gui.item.item.dragged_sb = -1 then
							gui.item.item.dragged_wp := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
						end
						if l_old_topline___0 = l_wp___0.item.w_topline then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if l_old_topfill___0 = l_wp___0.item.w_topfill then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (create {P_OPTION_STATIC}).p_so.item.item /= 0 then
							(create {P_MOVE_STATIC}).cursor_correct;
							(create {P_MOVE_STATIC}).update_topline
						end
						if l_old_cursor.lnum /= l_wp___0.item.w_cursor.lnum then
							(create {P_MISC2_STATIC}).coladvance (l_wp___0.item.w_curswant).do_nothing
						end
						l_wp___0.item.w_scbind_pos := l_wp___0.item.w_topline
				when 6 then -- if done;
						(create {P_MOVE_STATIC}).validate_cursor;
						(create {P_GLOBALS_STATIC}).curwin.item := l_save_wp;
						(create {P_GLOBALS_STATIC}).curbuf.item := l_save_wp.item.w_buffer
						if l_old_topline___0 = l_wp___0.item.w_topline then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 13 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 9 then -- else:
						if l_wp___0.item.w_redr_type = 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L___0
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 12 then -- else:
						if l_old_topfill___0 = l_wp___0.item.w_topfill then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L___0:
						l_type := 10
						if ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
							l_type := 40
							l_wp___0.item.w_lines_valid := 0
						end
						if l_wp___0.item.w_redr_type < l_type then
							l_wp___0.item.w_redr_type := l_type
						end
						(create {P_SCREEN_STATIC}).updateWindow (l_wp___0)
				when 14 then -- if done | if done
						if ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
							(create {P_POPUPMNU_STATIC}).pum_redraw
						end
						if l_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = l_old_cursor.lnum then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = l_old_cursor.col then
									if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd = l_old_cursor.coladd then
										l_tmp___1 := 0
									else
										l_tmp___1 := 1
									end
								else
									l_tmp___1 := 1
								end
							else
								l_tmp___1 := 1
							end
						else
							l_tmp___1 := 0
						end
						Result := l_tmp___1
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	scroll_line_len (a_lnum: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
			l_w: INTEGER_32
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_p___0 := (create {P_MEMLINE_STATIC}).ml_get (a_lnum)
			l_col := 0
			if (l_p___0.item).to_integer_32 /= 0 then
				from
				until
					(l_break)
				loop
					l_break := False
					l_w := (create {P_CHARSET_STATIC}).chartabsize (l_p___0, l_col)
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
					else
						l_tmp___0 := 1
					end
					l_p___0 := l_p___0 + l_tmp___0
					if (l_p___0.item).to_integer_32 = 0 then
						l_break := True
					end
					if not (l_break) then
						l_col := l_col + l_w
					end
				end
				l_break := False
			end
			Result := l_col
		end

	gui_find_longest_lnum: INTEGER_32
		local
			l_ret: INTEGER_32
			l_lnum: INTEGER_32
			l_n: INTEGER_32
			l_max: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_ret := (0).to_integer_32
			if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_go.item.item, ('h').code)).is_void then
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline <= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline > (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline <= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count + 1 then
							l_max := 0
							l_lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
							from
							until
								not (l_lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline)
							loop
								l_n := scroll_line_len (l_lnum)
								if l_n > l_max.to_integer_32 then
									l_max := l_n.to_integer_32
									l_ret := l_lnum
								elseif l_n = l_max.to_integer_32 then
									l_tmp := abs ((l_lnum - (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum).to_integer_32)
									if l_tmp < (abs ((l_ret - (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum).to_integer_32)) then
										l_ret := l_lnum
									end
								end
								l_lnum := l_lnum + 1
							end
						else
							l_ret := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
						end
					else
						l_ret := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
					end
				else
					l_ret := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
				end
			else
				l_ret := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
			end
			Result := l_ret
		end

	gui_update_horiz_scrollbar (a_force: INTEGER_32)
		local
			l_value: INTEGER_32
			l_size: INTEGER_32
			l_max: INTEGER_32
			l_return: BOOLEAN
		do
			if not (gui.item.item.which_scrollbars[2]).to_boolean then
				l_return := True
			end
			if not l_return and then (not a_force.to_boolean) then
				if gui.item.item.dragged_sb = 2 then
					l_return := True
				end
			end
			if not l_return and then (not a_force.to_boolean) then
				if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_wrap).to_boolean then
					if (gui.item.item.prev_wrap).to_boolean then
						l_return := True
					end
				end
			end
			if not l_return and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count) then
				gui.item.item.bottom_sbar.value := -1
				l_return := True
			end
			if not l_return then
				l_size := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_width).to_integer_32
				if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_wrap).to_boolean then
					l_value := 0
					l_max := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_width - 1).to_integer_32
				else
					l_value := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol).to_integer_32
					longest_lnum.item := gui_find_longest_lnum
					l_max := (scroll_line_len (longest_lnum.item)).to_integer_32
					if ((create {P_MISC2_STATIC}).virtual_active).to_boolean then
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol >= l_max.to_integer_32 then
							l_max := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol).to_integer_32
						end
					end
					l_max := l_max + ((create {P_GLOBALS_STATIC}).curwin.item.item.w_width - 1).to_integer_32
					l_size := l_size - ((create {P_MOVE_STATIC}).curwin_col_off).to_integer_32
					l_max := l_max - ((create {P_MOVE_STATIC}).curwin_col_off).to_integer_32
				end
				if l_value > (l_max - l_size) + 1 then
					l_value := (l_max - l_size) + 1
				end
				if not a_force.to_boolean then
					if l_value = gui.item.item.bottom_sbar.value then
						if l_size = gui.item.item.bottom_sbar.size then
							if l_max = gui.item.item.bottom_sbar.max then
								l_return := True
							end
						end
					end
				end
			end
			if not l_return then
				gui.item.item.bottom_sbar.value := l_value
				gui.item.item.bottom_sbar.size := l_size
				gui.item.item.bottom_sbar.max := l_max
				gui.item.item.prev_wrap := (create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_wrap;
				(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (gui.item.item.c_pointer + (create {PD_GUI}.make).offset_of ("bottom_sbar"))).item.gui_mch_set_scrollbar_thumb (l_value, l_size, l_max)
			end
		end

	gui_do_horiz_scroll (a_leftcol: NATURAL_32; a_compute_longest_lnum: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_wrap).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol = a_leftcol.to_integer_32) then
				Result := 0
				l_return := True
			end
			if not l_return then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol := a_leftcol.to_integer_32
				if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_go.item.item, ('h').code)).is_void then
					if not ((create {P_MISC2_STATIC}).virtual_active).to_boolean then
						if a_leftcol.to_integer_32 > (scroll_line_len ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)) then
							if a_compute_longest_lnum.to_boolean then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := gui_find_longest_lnum;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
							elseif longest_lnum.item >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
								if longest_lnum.item < (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := longest_lnum.item;
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
								end
							end
						end
					end
				end
				Result := ((create {P_MISC2_STATIC}).leftcol_changed)
			end
		end

	gui_check_colors
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if gui.item.item.norm_pixel /= gui.item.item.back_pixel then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if gui.item.item.norm_pixel /= -11_111 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						gui_set_bg_color (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("White")))
						if gui.item.item.norm_pixel = gui.item.item.back_pixel then
							gui_set_fg_color (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Black")))
						elseif gui.item.item.norm_pixel = -11_111 then
							gui_set_fg_color (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Black")))
						end
				when 5 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_set_fg_color (a_name___1: CE_POINTER [NATURAL_8])
		do
			gui.item.item.norm_pixel := gui_get_color (a_name___1);
			(create {P_SYNTAX_STATIC}).hl_set_fg_color_name (((create {P_MISC2_STATIC}).vim_strsave (a_name___1)))
		end

	gui_set_bg_color (a_name___1: CE_POINTER [NATURAL_8])
		do
			gui.item.item.back_pixel := gui_get_color (a_name___1);
			(create {P_SYNTAX_STATIC}).hl_set_bg_color_name (((create {P_MISC2_STATIC}).vim_strsave (a_name___1)))
		end

	gui_get_color (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_name___1.is_void
		local
			l_t: INTEGER_32
			l_return: BOOLEAN
		do
			if (a_name___1.item).to_integer_32 = 0 then
				Result := (-11_111).to_integer_32
				l_return := True
			end
			if not l_return then
				l_t := (create {P_GUI_GTK_X11_STATIC}).gui_mch_get_color (a_name___1)
				if l_t = -11_111 then
					if (gui.item.item.in_use).to_boolean then
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E254: Cannot allocate color %%s")))), a_name___1).do_nothing
					end
				end
				Result := l_t
			end
		end

	gui_get_lightness (a_pixel: INTEGER_32): INTEGER_32
		local
			l_rgb: NATURAL_32
		do
			l_rgb := ((create {P_GUI_GTK_X11_STATIC}).gui_mch_get_rgb (a_pixel))
			Result := (((((((l_rgb).bit_shift_right (16))).bit_and ({NATURAL_32} 255)) * {NATURAL_32} 299 + ((((l_rgb).bit_shift_right (8))).bit_and ({NATURAL_32} 255)) * {NATURAL_32} 587) + ((l_rgb).bit_and ({NATURAL_32} 255)) * {NATURAL_32} 114).to_integer_32 // 1_000)
		end

	gui_focus_change (a_in_focus: INTEGER_32)
		local
			l_bytes___0: CE_ARRAY [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_bytes___0.make (<<3>>)

			gui.item.item.in_focus := a_in_focus;
			(create {P_TERM_STATIC}).out_flush
			gui_update_cursor (1, 0);
			(create {P_MBYTE_STATIC}).xim_set_focus (a_in_focus)
			if not ((create {P_GLOBALS_STATIC}).hold_gui_events.item).to_boolean then
				l_bytes___0[0] := (155).to_natural_8
				l_bytes___0[1] := (253).to_natural_8
				if a_in_focus.to_boolean then
					l_bytes___0[2] := (98).to_natural_8
				else
					l_bytes___0[2] := (99).to_natural_8
				end
				(create {P_UI_STATIC}).add_to_input_buf (l_bytes___0, 3)
			end
		end

	gui_mouse_moved (a_x___0, a_y: INTEGER_32)
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_st: CE_ARRAY [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_st.make (<<8>>)

			if not (gui.item.item.in_use).to_boolean then
				l_return := True
			elseif (gui.item.item.starting).to_boolean then
				l_return := True
			end
			if not l_return then
				l_wp___0 := xy2win (a_x___0, a_y)
				if ((create {P_OPTION_STATIC}).p_mousef.item.item).to_boolean then
					if not ((create {P_GLOBALS_STATIC}).hold_gui_events.item).to_boolean then
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (17)).to_boolean then
							if (create {P_GLOBALS_STATIC}).State.item /= 513 then
								if (create {P_GLOBALS_STATIC}).msg_scrolled.item = 0 then
									if not ((create {P_GLOBALS_STATIC}).need_mouse_correct.item).to_boolean then
										if (gui.item.item.in_focus).to_boolean then
											if a_x___0 < 0 then
												l_return := True
											elseif a_x___0.to_integer_32 > (create {P_GLOBALS_STATIC}).Columns.item.item * (gui.item.item.char_width).to_integer_32 then
												l_return := True
											end
											if not l_return then
												if l_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
													l_return := True
												elseif l_wp___0.is_void then
													l_return := True
												end
											end
											if not l_return then
												if (a_y - gui.item.item.border_offset) // gui.item.item.char_height < ((create {P_WINDOW_STATIC}).tabline_height) then
													l_return := True
												end
											end
											if not l_return then
												if ((create {P_GLOBALS_STATIC}).finish_op.item).to_boolean then
													l_st[0] := (('%/27/').code).to_natural_8;
													(create {P_UI_STATIC}).add_to_input_buf (l_st, 1)
												end
												l_st[0] := (155).to_natural_8
												l_st[1] := (251).to_natural_8
												l_st[2] := (('X').code).to_natural_8
												l_st[3] := (0).to_natural_8
												if l_wp___0.item.w_wincol = 0 then
													l_tmp___0 := -1
												else
													l_tmp___0 := l_wp___0.item.w_wincol + 10_000
												end
												fill_mouse_coord (l_st + 4, l_tmp___0, l_wp___0.item.w_height + l_wp___0.item.w_winrow);
												(create {P_UI_STATIC}).add_to_input_buf (l_st, 8)
												l_st[3] := (3).to_natural_8;
												(create {P_UI_STATIC}).add_to_input_buf (l_st, 8)
												if (gtk_main_level) > {NATURAL_32} 0 then
													gtk_main_quit
												end
											end
										end
									end
								end
							end
						end
					end
				end
			end
			if not l_return then
			end
		end

	gui_mouse_correct
		local
			l_x___0: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_x___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_y.make (<<1>>)

			l_wp___0 := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer);
			(create {P_GLOBALS_STATIC}).need_mouse_correct.item := 0
			if (gui.item.item.in_use).to_boolean then
				if not ((create {P_OPTION_STATIC}).p_mousef.item.item).to_boolean then
					l_return := True
				end
			else
				l_return := True
			end
			if not l_return then
				(create {P_GUI_GTK_X11_STATIC}).gui_mch_getmouse (l_x___0, l_y)
				if l_x___0.item < 0 then
					l_return := True
				elseif (l_x___0.item).to_integer_32 > (create {P_GLOBALS_STATIC}).Columns.item.item * (gui.item.item.char_width).to_integer_32 then
					l_return := True
				end
			end
			if not l_return then
				if l_y.item >= 0 then
					if (l_y.item - gui.item.item.border_offset) // gui.item.item.char_height >= ((create {P_WINDOW_STATIC}).tabline_height) then
						l_wp___0 := xy2win (l_x___0.item, l_y.item)
					end
				end
				if not l_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
					if not l_wp___0.is_void then
						(create {P_MOVE_STATIC}).validate_cline_row;
						(create {P_GUI_GTK_X11_STATIC}).gui_mch_setmouse (((create {P_GLOBALS_STATIC}).curwin.item.item.w_wincol + (create {P_GLOBALS_STATIC}).curwin.item.item.w_width) * gui.item.item.char_width - 3, ((create {P_GLOBALS_STATIC}).curwin.item.item.w_winrow + (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow) * gui.item.item.char_height + gui.item.item.char_height // 2)
					end
				end
			end
		end

	xy2win (a_x___0, a_y: INTEGER_32): CE_POINTER [PD_WINDOW_S]
		local
			l_row: CE_ARRAY [INTEGER_32]
			l_col: CE_ARRAY [INTEGER_32]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_row.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_row.item := (a_y - gui.item.item.border_offset) // gui.item.item.char_height
					l_col.item := (a_x___0 - gui.item.item.border_offset) // gui.item.item.char_width
					if l_row.item < 0 then
						Result := (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						l_return := True
					elseif l_col.item < 0 then
						Result := (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 27 -- skip if block
					end
				when 1 then -- if:
						l_wp___0 := (create {P_UI_STATIC}).mouse_find_win (l_row, l_col)
						if (create {P_GLOBALS_STATIC}).State.item /= 513 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___4
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 4 then -- else:
						if (create {P_GLOBALS_STATIC}).State.item /= 768 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L___4:
						if (a_y - gui.item.item.border_offset) // gui.item.item.char_height >= (create {P_GLOBALS_STATIC}).msg_row.item then
							(create {P_MISC2_STATIC}).update_mouseshape (15)
						else
							(create {P_MISC2_STATIC}).update_mouseshape (14)
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 7 then -- else:
						if not (l_row.item > l_wp___0.item.w_height) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:;
						(create {P_MISC2_STATIC}).update_mouseshape (9)
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 10 then -- else:
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (8)).to_boolean then
							l_pos := -1 + 25 -- skip if block
						end
				when 11 then -- if:
						if not (l_wp___0.item.w_vsep_width > 0) then
							l_pos := -1 + 23 -- skip if block
						end
				when 12 then -- if:
						if l_col.item /= l_wp___0.item.w_width then
							l_pos := -1 + 21 -- skip if block
						end
				when 13 then -- if:
						if l_row.item = l_wp___0.item.w_height then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 19 -- goto _L___1
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else:
						if not ((l_wp___0.item.stl_connected).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 25 -- goto _L___3
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___1:
						if (create {P_GLOBALS_STATIC}).msg_scrolled.item = 0 then
							(create {P_MISC2_STATIC}).update_mouseshape (12)
						else
							l_pos := -1 + 25 -- goto _L___3
						end
				when 20 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_pos := -1 + 25 -- goto _L___3
				when 22 then -- if done | if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 25 -- goto _L___3
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else: | _L___3:
						if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (8)).to_boolean then
							if l_wp___0.item.w_status_height > 0 then
								if l_row.item = l_wp___0.item.w_height then
									if (create {P_GLOBALS_STATIC}).msg_scrolled.item = 0 then
										(create {P_MISC2_STATIC}).update_mouseshape (10)
									else
										(create {P_MISC2_STATIC}).update_mouseshape (-2)
									end
								else
									(create {P_MISC2_STATIC}).update_mouseshape (-2)
								end
							else
								(create {P_MISC2_STATIC}).update_mouseshape (-2)
							end
						else
							(create {P_MISC2_STATIC}).update_mouseshape (-2)
						end
				when 26 then -- if done | if done | if done
						Result := l_wp___0
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gfp_setname (a_fname: CE_POINTER [NATURAL_8]; a_cookie: CE_POINTER [ANY])
		local
			l_gfp_buffer: CE_POINTER [NATURAL_8]
		do
			l_gfp_buffer := create {CE_NATURAL_8_POINTER}.make_cast (a_cookie)
			if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_fname))) >= {NATURAL_32} 4_096 then
				l_gfp_buffer.item := (('%/0/').code).to_natural_8
			else
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_gfp_buffer), create {CE_INTEGER_8_POINTER}.make_cast (a_fname)).do_nothing
			end
		end

	display_errors
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
		do
			if (isatty (2)).to_boolean then
				Io.error.flush
			elseif not ((create {P_GLOBALS_STATIC}).error_ga.item.item.ga_data).is_void then
				l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).error_ga.item.item.ga_data)
				from
				until
					not (not (l_break) and then ((l_p___0.item).to_integer_32 /= 0))
				loop
					l_break := False
					if not ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
						if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))) > {NATURAL_32} 2_000 then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (((l_p___0 + 2_000) - 14)), ce_string ("...(truncated)")).do_nothing
						end
						l_tmp___0 := gettext (ce_string ("&Ok"));
						(create {P_MESSAGE_STATIC}).do_dialog (1, create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Error")))), l_p___0, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0), 1, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)).do_nothing
						l_break := True
					end
					if not (l_break) then
						l_p___0 := l_p___0 + 1
					end
				end
				l_break := False;
				((create {P_GLOBALS_STATIC}).error_ga.item).item.ga_clear
			end
		end

	no_console_input: INTEGER_32
		local
			l_tmp___1: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (gui.item.item.in_use).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not ((gui.item.item.starting).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if (isatty (0)).to_boolean then
							l_tmp___1 := 0
						elseif (isatty (2)).to_boolean then
							l_tmp___1 := 0
						else
							l_tmp___1 := 1
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tmp___1 := 0
				when 7 then -- if done
					Result := l_tmp___1
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_update_screen
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:;
					(create {P_MOVE_STATIC}).update_topline;
					(create {P_MOVE_STATIC}).validate_cursor
					if ((create {P_GLOBALS_STATIC}).finish_op.item).to_boolean then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_FILEIO_STATIC}).has_cursormoved).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						if (create {P_GLOBALS_STATIC}).last_cursormoved.item.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (create {P_GLOBALS_STATIC}).last_cursormoved.item.col = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
							if (create {P_GLOBALS_STATIC}).last_cursormoved.item.coladd /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd then
								l_pos := -1 + 5 -- goto _L___0
							end
						else
							l_pos := -1 + 5 -- goto _L___0
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L___0:
						if ((create {P_FILEIO_STATIC}).has_cursormoved).to_boolean then
							(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_CURSORMOVED, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
						end
						(create {P_GLOBALS_STATIC}).last_cursormoved.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
				when 6 then -- if done | if done;
					(create {P_SCREEN_STATIC}).update_screen (0);
					(create {P_SCREEN_STATIC}).setcursor;
					(create {P_TERM_STATIC}).out_flush
					gui_update_cursor (1, 0);
					(create {P_GUI_GTK_X11_STATIC}).gui_mch_flush
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_find_dialog_text (a_arg: CE_POINTER [NATURAL_8]; a_wwordp, a_mcasep: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		require
			not a_arg.is_void
		local
			l_text: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_i___0: INTEGER_32
		do
			if (a_arg.item).to_integer_32 = 0 then
				l_text := (create {P_SEARCH_STATIC}).last_search_pat
			else
				l_text := a_arg
			end
			if not l_text.is_void then
				l_text := (create {P_MISC2_STATIC}).vim_strsave (l_text)
				if not l_text.is_void then
					l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_text))).to_integer_32
					if l_len >= 2 then
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_text), ce_string ("\V"), (2).to_natural_32)) = 0 then
							memmove (create {CE_VOID_POINTER}.make_cast (l_text), create {CE_VOID_POINTER}.make_cast ((l_text + 2)), (l_len - 1).to_natural_32).do_nothing
							l_len := l_len - (2)
						end
					end
					if l_len >= 2 then
						if (l_text.item).to_integer_32 = 92 then
							if (l_text[1]).to_integer_32 = 99 then
								a_mcasep.item := ((l_text[1]).to_integer_32 = 67).to_integer
								memmove (create {CE_VOID_POINTER}.make_cast (l_text), create {CE_VOID_POINTER}.make_cast ((l_text + 2)), (l_len - 1).to_natural_32).do_nothing
								l_len := l_len - (2)
							elseif (l_text[1]).to_integer_32 = 67 then
								a_mcasep.item := ((l_text[1]).to_integer_32 = 67).to_integer
								memmove (create {CE_VOID_POINTER}.make_cast (l_text), create {CE_VOID_POINTER}.make_cast ((l_text + 2)), (l_len - 1).to_natural_32).do_nothing
								l_len := l_len - (2)
							end
						end
					end
					if l_len >= 4 then
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_text), ce_string ("\<"), (2).to_natural_32)) = 0 then
							if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (((l_text + l_len) - 2)), ce_string ("\>"), (2).to_natural_32)) = 0 then
								a_wwordp.item := 1
								memmove (create {CE_VOID_POINTER}.make_cast (l_text), create {CE_VOID_POINTER}.make_cast ((l_text + 2)), (l_len - 4).to_natural_32).do_nothing
								l_text[(l_len - 4)] := (('%/0/').code).to_natural_8
							end
						end
					end
					l_i___0 := 0
					from
					until
						not (l_i___0 + 1 < l_len)
					loop
						if (l_text[l_i___0]).to_integer_32 = 92 then
							if (l_text[(l_i___0 + 1)]).to_integer_32 = 47 then
								memmove (create {CE_VOID_POINTER}.make_cast ((l_text + l_i___0)), create {CE_VOID_POINTER}.make_cast (((l_text + l_i___0) + 1)), (l_len - l_i___0).to_natural_32).do_nothing
								l_len := l_len - 1
							elseif (l_text[(l_i___0 + 1)]).to_integer_32 = 63 then
								memmove (create {CE_VOID_POINTER}.make_cast ((l_text + l_i___0)), create {CE_VOID_POINTER}.make_cast (((l_text + l_i___0) + 1)), (l_len - l_i___0).to_natural_32).do_nothing
								l_len := l_len - 1
							end
						end
						l_i___0 := l_i___0 + 1
					end
				end
			end
			Result := l_text
		end

	concat_esc (a_gap: CE_POINTER [PD_GROWARRAY]; a_text: CE_POINTER [NATURAL_8]; a_what: INTEGER_32)
		require
			not a_text.is_void
		local
			l_text: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return, l_break, l_continue: BOOLEAN
		do
			l_text := a_text
			from
			until
				not (not (l_return) and then ((l_text.item).to_integer_32 /= 0))
			loop
				l_continue := False
				l_l := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_text]))
				if l_l > 1 then
					from
					until
						(l_break)
					loop
						l_break := False
						l_l := l_l - 1
						if not (l_l >= 0) then
							l_break := True
						end
						if not (l_break) then
							l_tmp___0 := l_text
							l_text := l_text + 1
							a_gap.item.ga_append ((l_tmp___0.item).to_integer_32)
						end
					end
					l_break := False
					l_continue := True
				end
				if not (l_return or l_break or l_continue) then
					if (l_text.item).to_integer_32 = a_what then
						a_gap.item.ga_append (('\').code)
					end
					a_gap.item.ga_append ((l_text.item).to_integer_32)
					l_text := l_text + 1
				end
			end
			l_continue := False
		end

	gui_do_findrepl (a_flags___0: INTEGER_32; a_find_text, a_repl_text: CE_POINTER [NATURAL_8]; a_down: INTEGER_32): INTEGER_32
		local
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_i___0: INTEGER_32
			l_type: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_save_did_emsg: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_REGMATCH_T]} l_regmatch___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_type := (a_flags___0).bit_and (7)
					l_save_did_emsg := (create {P_GLOBALS_STATIC}).did_emsg.item
					if ((create {P_GLOBALS_STATIC}).updating_screen.item).to_boolean then
						Result := 0
						l_return := True
					elseif busy___4.item.to_boolean then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if l_type /= 3 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if l_type /= 4 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if ((create {P_EX_GETLN_STATIC}).text_locked).to_boolean then
							Result := 0
							l_return := True
						end
				when 6 then -- if done | if done
					if not l_return then
						busy___4.item := 1
						l_ga.item.ga_init2 (1, 100)
						if l_type = 4 then
							l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%s/")))
						end
						l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("\V")))
						if ((a_flags___0).bit_and (16)).to_boolean then
							l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("\C")))
						else
							l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("\c")))
						end
						if ((a_flags___0).bit_and (8)).to_boolean then
							l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("\<")))
						end
						if l_type = 4 then
							concat_esc (l_ga, a_find_text, ('/').code)
						elseif a_down.to_boolean then
							concat_esc (l_ga, a_find_text, ('/').code)
						else
							concat_esc (l_ga, a_find_text, ('?').code)
						end
						if ((a_flags___0).bit_and (8)).to_boolean then
							l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("\>")))
						end
						if l_type = 4 then
							l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")))
							l_p___0 := (create {P_MISC2_STATIC}).vim_strsave_escaped (a_repl_text, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/\")))
							if not l_p___0.is_void then
								l_ga.item.ga_concat (l_p___0)
							end
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
							l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/g")))
						end
						l_ga.item.ga_append (('%/0/').code)
						if l_type = 3 then
							l_regmatch___0.item.regprog := (create {P_REGEXP_STATIC}).vim_regcomp (create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data), 3)
							l_regmatch___0.item.rm_ic := 0
							if not (l_regmatch___0.item.regprog).is_void then
								l_p___0 := (create {P_MEMLINE_STATIC}).ml_get_cursor
								if (l_regmatch___0.item.vim_regexec_nl (l_p___0, 0)).to_boolean then
									if (l_regmatch___0.item.startp[0]).is_equal (l_p___0) then
										(create {P_MESSAGE_STATIC}).msg_end_prompt
										if ((create {P_UNDO_STATIC}).u_save_cursor) = 1 then
											(create {P_UNDO_STATIC}).u_sync (0);
											(create {P_MISC1_STATIC}).del_bytes (((l_regmatch___0.item.endp[0]).distance ((l_regmatch___0.item.startp[0]))).to_integer_32, 0, 0).do_nothing;
											(create {P_MISC1_STATIC}).ins_str (a_repl_text)
										end
									else
										l_tmp___1 := gettext (ce_string ("No match at cursor, finding next"));
										(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
									end
								else
									l_tmp___1 := gettext (ce_string ("No match at cursor, finding next"));
									(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
								end
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_regmatch___0.item.regprog))
							end
						end
						if l_type = 4 then
							(create {P_UNDO_STATIC}).u_sync (0);
							(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd (create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data)).do_nothing
						else
							l_i___0 := (create {P_GLOBALS_STATIC}).msg_scroll.item
							if a_down.to_boolean then
								l_tmp___3 := ('/').code
							else
								l_tmp___3 := ('?').code
							end
							(create {P_SEARCH_STATIC}).do_search (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), l_tmp___3, create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data), 1, 524, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer)).do_nothing;
							(create {P_GLOBALS_STATIC}).msg_scroll.item := l_i___0
						end
						(create {P_GLOBALS_STATIC}).did_emsg.item := l_save_did_emsg
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (17)).to_boolean then
							gui_update_screen;
							(create {P_GLOBALS_STATIC}).msg_didout.item := 0;
							(create {P_GLOBALS_STATIC}).need_wait_return.item := 0
						end
						(create {P_MISC2_STATIC}).vim_free (l_ga.item.ga_data)
						busy___4.item := 0
						Result := (l_ga.item.ga_len > 0).to_integer
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_wingoto_xy (a_x___0, a_y: INTEGER_32)
		local
			l_row: CE_ARRAY [INTEGER_32]
			l_col: CE_ARRAY [INTEGER_32]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			create {CE_INTEGER_32_ARRAY} l_row.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)

			l_row.item := (a_y - gui.item.item.border_offset) // gui.item.item.char_height
			l_col.item := (a_x___0 - gui.item.item.border_offset) // gui.item.item.char_width
			if l_row.item >= 0 then
				if l_col.item >= 0 then
					l_wp___0 := (create {P_UI_STATIC}).mouse_find_win (l_row, l_col)
					if not l_wp___0.is_void then
						if not l_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
							(create {P_WINDOW_STATIC}).win_goto (l_wp___0)
						end
					end
				end
			end
		end

	gui_handle_drop (a_x___0, a_y: INTEGER_32; a_modifiers: NATURAL_32; a_fnames: CE_POINTER [CE_POINTER [NATURAL_8]]; a_count___2: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			if entered___5.item.to_boolean then
				l_return := True
			end
			if not l_return then
				entered___5.item := 1
				if (((create {P_GLOBALS_STATIC}).State.item).bit_and (8)).to_boolean then
					(create {P_FILEIO_STATIC}).shorten_filenames (a_fnames, a_count___2)
					l_i___0 := 0
					from
					until
						not (l_i___0 < a_count___2)
					loop
						if not (a_fnames[l_i___0]).is_void then
							if l_i___0 > 0 then
								(create {P_UI_STATIC}).add_to_input_buf (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")), 1)
							end
							l_p___0 := (create {P_MISC2_STATIC}).vim_strsave_escaped (a_fnames[l_i___0], create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("\ %T%"|")))
							if not l_p___0.is_void then
								(create {P_UI_STATIC}).add_to_input_buf_csi (l_p___0, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32)
							end
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0));
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_fnames[l_i___0]))
						end
						l_i___0 := l_i___0 + 1
					end
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_fnames))
				else
					gui_wingoto_xy (a_x___0, a_y);
					(create {P_FILEIO_STATIC}).shorten_filenames (a_fnames, a_count___2)
					if ((a_modifiers).bit_and ({NATURAL_32} 4)) /= {NATURAL_32} 0 then
						l_p___0 := (create {P_MISC2_STATIC}).vim_strsave (a_fnames[0])
					else
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
					if a_count___2 = 1 then
						if ((a_modifiers).bit_and ({NATURAL_32} 4)) /= {NATURAL_32} 0 then
							if ((create {P_OS_UNIX_STATIC}).mch_isdir (a_fnames[0])).to_boolean then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_fnames[0]));
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_fnames))
							else
								(create {P_EX_DOCMD_STATIC}).handle_drop (a_count___2, a_fnames, (((a_modifiers).bit_and ({NATURAL_32} 16)) /= {NATURAL_32} 0).to_integer)
							end
						else
							(create {P_EX_DOCMD_STATIC}).handle_drop (a_count___2, a_fnames, (((a_modifiers).bit_and ({NATURAL_32} 16)) /= {NATURAL_32} 0).to_integer)
						end
					else
						(create {P_EX_DOCMD_STATIC}).handle_drop (a_count___2, a_fnames, (((a_modifiers).bit_and ({NATURAL_32} 16)) /= {NATURAL_32} 0).to_integer)
					end
					if not l_p___0.is_void then
						if ((create {P_OS_UNIX_STATIC}).mch_isdir (l_p___0)).to_boolean then
							if ((create {P_OS_UNIX_STATIC}).mch_chdir (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))) = 0 then
								(create {P_FILEIO_STATIC}).shorten_fnames (1)
							end
						elseif ((create {P_MISC2_STATIC}).vim_chdirfile (l_p___0)) = 1 then
							(create {P_FILEIO_STATIC}).shorten_fnames (1)
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
					end
					(create {P_SCREEN_STATIC}).update_screen (40);
					(create {P_MENU_STATIC}).gui_update_menus (0);
					(create {P_BUFFER_STATIC}).maketitle;
					(create {P_SCREEN_STATIC}).setcursor;
					(create {P_TERM_STATIC}).out_flush
					gui_update_cursor (0, 0);
					(create {P_GUI_GTK_X11_STATIC}).gui_mch_flush
				end
				entered___5.item := 0
			end
		end

feature {ANY} -- routine addresses

	gui_menu_cb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gui_menu_cb)
		end

	gfp_setname_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gfp_setname)
		end

end
