class
	P_MESSAGE_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_LIBINTL_STATIC
	S_STDIO_STATIC
	S_STDLIB_STATIC
	S_UNISTD_STATIC
	S_LIBIO_STATIC
	S_CTYPE_STATIC
	S_MATH_STATIC

feature {ANY} -- public attributes

	confirm_msg_used: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	confirm_msg: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	confirm_msg_tail: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	first_msg_hist: CE_STATIC [CE_POINTER [PD_MSG_HIST]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_MSG_HIST]}.make_shared (default_pointer)
		end

	last_msg_hist: CE_STATIC [CE_POINTER [PD_MSG_HIST]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_MSG_HIST]}.make_shared (default_pointer)
		end

	msg_hist_len: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	entered___1: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	last_sourcing_lnum: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	last_sourcing_name: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	buf___0: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<7>>)
		end

	last_msgchunk: CE_STATIC [CE_POINTER [PD_MSGCHUNK_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_MSGCHUNK_S]}.make_shared (default_pointer)
		end

	do_clear_sb_text: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	cur_col: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	verbose_fd: CE_STATIC [CE_POINTER [SD_IO_FILE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
		end

	verbose_did_open: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	cur_col___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	last_dir: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	e_printf: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("E766: Insufficient arguments for printf()")
		end

feature {ANY} -- public routines

	msg (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := (msg_attr_keep (a_s, 0, 0))
		end

	verb_msg (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_n: INTEGER_32
		do
			verbose_enter
			l_n := msg_attr_keep (a_s, 0, 0)
			verbose_leave
			Result := l_n
		end

	msg_attr (a_s: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32): INTEGER_32
		do
			Result := (msg_attr_keep (a_s, a_attr, 0))
		end

	msg_attr_keep (a_s: CE_POINTER [NATURAL_8]; a_attr, a_keep: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_buf___6: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_s := a_s
			l_buf___6 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if a_attr = 0 then
				(create {P_EVAL_STATIC}).set_vim_var_string (5, l_s, -1)
			end
			if entered___1.item >= 3 then
				Result := 1
				l_return := True
			end
			if not l_return then
				entered___1.item := entered___1.item + 1
				if not l_s.is_equal ((create {P_GLOBALS_STATIC}).keep_msg.item) then
					add_msg_hist (l_s, -1, a_attr)
				elseif (l_s.item).to_integer_32 /= 60 then
					if not last_msg_hist.item.is_void then
						if not (last_msg_hist.item.item.msg).is_void then
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), create {CE_INTEGER_8_POINTER}.make_cast (last_msg_hist.item.item.msg))).to_boolean then
								add_msg_hist (l_s, -1, a_attr)
							end
						end
					end
				end
				if l_s.is_equal ((create {P_GLOBALS_STATIC}).keep_msg.item) then
					(create {P_GLOBALS_STATIC}).keep_msg.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				end
				msg_start
				l_buf___6 := msg_strtrunc (l_s, 0)
				if not l_buf___6.is_void then
					l_s := l_buf___6
				end
				msg_outtrans_attr (l_s, a_attr).do_nothing
				msg_clr_eos
				l_retval := msg_end
				if a_keep.to_boolean then
					if l_retval.to_boolean then
						if ((create {P_CHARSET_STATIC}).vim_strsize (l_s)).to_integer_32 < ((((create {P_GLOBALS_STATIC}).Rows.item.item - ((create {P_GLOBALS_STATIC}).cmdline_row.item).to_integer_32) - 1).to_integer_32).to_integer_32 * (create {P_GLOBALS_STATIC}).Columns.item.item + ((create {P_GLOBALS_STATIC}).sc_col.item).to_integer_32 then
							set_keep_msg (l_s, 0)
						end
					end
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
				entered___1.item := entered___1.item - 1
				Result := l_retval
			end
		end

	msg_strtrunc (a_s: CE_POINTER [NATURAL_8]; a_force: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_room: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					if ((create {P_GLOBALS_STATIC}).msg_scroll.item).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not ((create {P_GLOBALS_STATIC}).need_wait_return.item).to_boolean then
							if ((create {P_OPTION_STATIC}).shortmess (('T').code)).to_boolean then
								if not ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
									if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
										l_pos := -1 + 4 -- goto _L
									else
										l_pos := -1 + 3 -- goto _L___3
									end
								else
									l_pos := -1 + 3 -- goto _L___3
								end
							else
								l_pos := -1 + 3 -- goto _L___3
							end
						else
							l_pos := -1 + 3 -- goto _L___3
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else: | _L___3:
						if not (a_force.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_len := (create {P_CHARSET_STATIC}).vim_strsize (a_s)
						if (create {P_GLOBALS_STATIC}).msg_scrolled.item /= 0 then
							l_room := ((((create {P_GLOBALS_STATIC}).Rows.item.item - ((create {P_GLOBALS_STATIC}).msg_row.item).to_integer_32).to_integer_32).to_integer_32 * (create {P_GLOBALS_STATIC}).Columns.item.item - 1).to_integer_32
						else
							l_room := ((((((create {P_GLOBALS_STATIC}).Rows.item.item - ((create {P_GLOBALS_STATIC}).msg_row.item).to_integer_32) - 1).to_integer_32).to_integer_32 * (create {P_GLOBALS_STATIC}).Columns.item.item + ((create {P_GLOBALS_STATIC}).sc_col.item).to_integer_32) - 1).to_integer_32
						end
						if l_len > l_room then
							if l_room > 0 then
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_buf___6 := (create {P_MISC2_STATIC}).alloc (((l_room + 2) * 18).to_natural_32)
								elseif (create {P_GLOBALS_STATIC}).enc_dbcs.item = 9_932 then
									l_buf___6 := (create {P_MISC2_STATIC}).alloc (((l_room + 2) * 2).to_natural_32)
								else
									l_buf___6 := (create {P_MISC2_STATIC}).alloc ((l_room + 2).to_natural_32)
								end
								if not l_buf___6.is_void then
									trunc_string (a_s, l_buf___6, l_room)
								end
							end
						end
				when 5 then -- if done
					Result := l_buf___6
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	trunc_string (a_s, a_buf___6: CE_POINTER [NATURAL_8]; a_room: INTEGER_32)
		local
			l_room: INTEGER_32
			l_half: INTEGER_32
			l_len: INTEGER_32
			l_e: INTEGER_32
			l_i___0: INTEGER_32
			l_n: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_room := a_room
			l_room := l_room - (3)
			l_half := l_room // 2
			l_len := 0
			l_e := 0
			from
			until
				not (not (l_return or l_break) and then (l_len < l_half))
			loop
				l_break := False
				if (a_s[l_e]).to_integer_32 = 0 then
					a_buf___6[l_e] := (('%/0/').code).to_natural_8
					l_return := True
				end
				if not l_return then
					l_n := (create {P_CHARSET_STATIC}).ptr2cells (a_s + l_e)
					if l_len + l_n >= l_half then
						l_break := True
					end
					if not (l_return or l_break) then
						l_len := l_len + l_n
						a_buf___6[l_e] := a_s[l_e]
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_n := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([a_s + l_e])
							from
							until
								(l_break)
							loop
								l_break := False
								l_n := l_n - 1
								if not (l_n > 0) then
									l_break := True
								end
								if not (l_break) then
									l_e := l_e + 1
									a_buf___6[l_e] := a_s[l_e]
								end
							end
							l_break := False
						end
						l_e := l_e + 1
					end
				end
			end
			if not l_return then
				l_break := False
				l_i___0 := l_e
				if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 0 then
					l_n := (create {P_CHARSET_STATIC}).vim_strsize (a_s + l_i___0)
					from
					until
						not (l_len + l_n > l_room)
					loop
						l_n := l_n - ((create {P_CHARSET_STATIC}).ptr2cells (a_s + l_i___0))
						l_i___0 := l_i___0 + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([a_s + l_i___0]))
					end
				elseif ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
					l_i___0 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_s))).to_integer_32
					l_half := l_i___0
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							l_half := (l_half - ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([a_s, (a_s + l_half) - 1]))) - 1
							if ((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_MBYTE_STATIC}).utf_ptr2char (a_s + l_half)))).to_boolean then
								if not (l_half > 0) then
									l_break := True
								end
							else
								l_break := True
							end
						end
						l_break := False
						l_n := (create {P_CHARSET_STATIC}).ptr2cells (a_s + l_half)
						if l_len + l_n > l_room then
							l_break := True
						end
						if not (l_return or l_break) then
							l_len := l_len + l_n
							l_i___0 := l_half
						end
					end
					l_break := False
				else
					l_i___0 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_s))).to_integer_32
					from
					until
						(l_break)
					loop
						l_break := False
						l_n := (create {P_CHARSET_STATIC}).ptr2cells ((a_s + l_i___0) - 1)
						if not (l_len + l_n <= l_room) then
							l_break := True
						end
						if not (l_return or l_break) then
							l_len := l_len + l_n
							l_i___0 := l_i___0 - 1
						end
					end
					l_break := False
				end
				memmove (create {CE_VOID_POINTER}.make_cast ((a_buf___6 + l_e)), create {CE_VOID_POINTER}.make_cast (ce_string ("...")), (3).to_natural_32).do_nothing
				memmove (create {CE_VOID_POINTER}.make_cast (((a_buf___6 + l_e) + 3)), create {CE_VOID_POINTER}.make_cast ((a_s + l_i___0)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((a_s + l_i___0)))) + {NATURAL_32} 1).do_nothing
			end
		end

	smsg (a_args: TUPLE [a_s: CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_arglist: CE_VA_LIST
		do
			create l_arglist.make_shared (default_pointer)

			l_arglist := create {CE_VA_LIST}.make (a_args, agent smsg)
			vim_vsnprintf (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, create {CE_INTEGER_8_POINTER}.make_cast (a_args.a_s), l_arglist.twin, create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (default_pointer)).do_nothing
			Result := (msg ((create {P_GLOBALS_STATIC}).IObuff.item))
		end

	smsg_attr (a_args: TUPLE [a_attr: INTEGER_32; a_s: CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_arglist: CE_VA_LIST
		do
			create l_arglist.make_shared (default_pointer)

			l_arglist := create {CE_VA_LIST}.make (a_args, agent smsg_attr)
			vim_vsnprintf (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, create {CE_INTEGER_8_POINTER}.make_cast (a_args.a_s), l_arglist.twin, create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (default_pointer)).do_nothing
			Result := (msg_attr ((create {P_GLOBALS_STATIC}).IObuff.item, a_args.a_attr))
		end

	reset_last_sourcing
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (last_sourcing_name.item))
			last_sourcing_name.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			last_sourcing_lnum.item := 0
		end

	other_sourcing_name: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if not ((create {P_GLOBALS_STATIC}).sourcing_name.item).is_void then
				if not last_sourcing_name.item.is_void then
					Result := ((strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).sourcing_name.item), create {CE_INTEGER_8_POINTER}.make_cast (last_sourcing_name.item))) /= 0).to_integer
					l_return := True
				end
				if not l_return then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	get_emsg_source: CE_POINTER [NATURAL_8]
		local
			l_Buf: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			l_return: BOOLEAN
		do
			if not ((create {P_GLOBALS_STATIC}).sourcing_name.item).is_void then
				if (other_sourcing_name).to_boolean then
					l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Error detected while processing %%s:"))))
					l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).sourcing_name.item))
					l_Buf := (create {P_MISC2_STATIC}).alloc (l_tmp___0 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))))
					if not l_Buf.is_void then
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_Buf), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), (create {P_GLOBALS_STATIC}).sourcing_name.item]).do_nothing
					end
					Result := l_Buf
					l_return := True
				end
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
		end

	get_emsg_lnum: CE_POINTER [NATURAL_8]
		local
			l_Buf: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_GLOBALS_STATIC}).sourcing_name.item).is_void then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not ((other_sourcing_name).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (create {P_GLOBALS_STATIC}).sourcing_lnum.item = last_sourcing_lnum.item.to_integer_32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (create {P_GLOBALS_STATIC}).sourcing_lnum.item /= 0 then
							l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("line %%4ld:"))))
							l_Buf := (create {P_MISC2_STATIC}).alloc ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))) + {NATURAL_32} 20)
							if not l_Buf.is_void then
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_Buf), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), (create {P_GLOBALS_STATIC}).sourcing_lnum.item]).do_nothing
							end
							Result := l_Buf
							l_return := True
						end
				when 6 then -- if done | if done
					if not l_return then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	msg_source (a_attr: INTEGER_32)
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:;
					(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item + 1
					l_p___0 := get_emsg_source
					if not l_p___0.is_void then
						msg_attr (l_p___0, a_attr).do_nothing;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
					end
					l_p___0 := get_emsg_lnum
					if not l_p___0.is_void then
						msg_attr (l_p___0, (create {P_GLOBALS_STATIC}).highlight_attr.item[9]).do_nothing;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
						last_sourcing_lnum.item := ((create {P_GLOBALS_STATIC}).sourcing_lnum.item).to_integer_32
					end
					if not (((create {P_GLOBALS_STATIC}).sourcing_name.item).is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((other_sourcing_name).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (last_sourcing_name.item))
						if ((create {P_GLOBALS_STATIC}).sourcing_name.item).is_void then
							last_sourcing_name.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						else
							last_sourcing_name.item := (create {P_MISC2_STATIC}).vim_strsave ((create {P_GLOBALS_STATIC}).sourcing_name.item)
						end
				when 5 then -- if done;
					(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	emsg_not_now: INTEGER_32
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((create {P_GLOBALS_STATIC}).emsg_off.item > 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_debug.item.item, ('m').code)).is_void then
							if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_debug.item.item, ('t').code)).is_void then
								Result := 1
								l_return := True
							else
								l_pos := -1 + 3 -- goto _L___0
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___0:
						if (create {P_GLOBALS_STATIC}).emsg_skip.item > 0 then
							Result := 1
							l_return := True
						end
				when 4 then
					if not l_return then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	emsg (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_attr: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_ignore___0: CE_ARRAY [INTEGER_32]
			l_severe: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_ignore___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ignore___0.item := 0;
					(create {P_GLOBALS_STATIC}).called_emsg.item := 1;
					(create {P_GLOBALS_STATIC}).ex_exitval.item := 1
					l_severe := (create {P_GLOBALS_STATIC}).emsg_severe.item;
					(create {P_GLOBALS_STATIC}).emsg_severe.item := 0
					if (emsg_not_now).to_boolean then
						Result := 1
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_GLOBALS_STATIC}).emsg_off.item).to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_debug.item.item, ('t').code)).is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if ((create {P_EX_EVAL_STATIC}).cause_errthrow (a_s, l_severe, l_ignore___0)) = 1 then
							if not (l_ignore___0.item).to_boolean then
								(create {P_GLOBALS_STATIC}).did_emsg.item := 1
							end
							Result := 1
							l_return := True
						end
						if not l_return then
							(create {P_EVAL_STATIC}).set_vim_var_string (3, a_s, -1)
							if (create {P_GLOBALS_STATIC}).emsg_silent.item /= 0 then
								msg_start
								l_p___0 := get_emsg_source
								if not l_p___0.is_void then
									strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("%N")).do_nothing
									redir_write (l_p___0, -1);
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
								end
								l_p___0 := get_emsg_lnum
								if not l_p___0.is_void then
									strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("%N")).do_nothing
									redir_write (l_p___0, -1);
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
								end
								redir_write (a_s, -1)
								Result := 1
								l_return := True
							end
						end
						if not l_return then
							(create {P_GLOBALS_STATIC}).msg_silent.item := 0;
							(create {P_GLOBALS_STATIC}).cmd_silent.item := 0
							if ((create {P_GLOBALS_STATIC}).global_busy.item).to_boolean then
								(create {P_GLOBALS_STATIC}).global_busy.item := (create {P_GLOBALS_STATIC}).global_busy.item + 1
							end
							if ((create {P_OPTION_STATIC}).p_eb.item.item).to_boolean then
								(create {P_MISC1_STATIC}).beep_flush
							else
								(create {P_GETCHAR_STATIC}).flush_buffers (0)
							end
							(create {P_GLOBALS_STATIC}).did_emsg.item := 1
						end
				when 6 then -- if done | if done
					if not l_return then
						(create {P_GLOBALS_STATIC}).emsg_on_display.item := 1;
						(create {P_GLOBALS_STATIC}).msg_scroll.item := (create {P_GLOBALS_STATIC}).msg_scroll.item + 1
						l_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[3]
						if (create {P_GLOBALS_STATIC}).msg_scrolled.item /= 0 then
							(create {P_GLOBALS_STATIC}).need_wait_return.item := 1
						end
						msg_source (l_attr);
						(create {P_GLOBALS_STATIC}).msg_nowait.item := 0
						Result := (msg_attr (a_s, l_attr))
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	emsg2 (a_s, a_a1: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := ((create {P_MISC2_STATIC}).emsg3 (a_s, a_a1, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)))
		end

	emsg_invreg (a_name___1: INTEGER_32)
		local
			l_tmp: CE_POINTER [NATURAL_8]
		do
			l_tmp := (create {P_CHARSET_STATIC}).transchar (a_name___1)
			emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E354: Invalid register name: %'%%s%'")))), l_tmp).do_nothing
		end

	msg_trunc_attr (a_s: CE_POINTER [NATURAL_8]; a_force, a_attr: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_s: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_return: BOOLEAN
		do
			l_s := a_s
			add_msg_hist (l_s, -1, a_attr)
			l_s := msg_may_trunc (a_force, l_s);
			(create {P_GLOBALS_STATIC}).msg_hist_off.item := 1
			l_n := msg_attr (l_s, a_attr);
			(create {P_GLOBALS_STATIC}).msg_hist_off.item := 0
			if l_n.to_boolean then
				Result := l_s
				l_return := True
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
		end

	msg_may_trunc (a_force: INTEGER_32; a_s: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_s: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_room: INTEGER_32
			l_size: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					l_room := ((((((create {P_GLOBALS_STATIC}).Rows.item.item - ((create {P_GLOBALS_STATIC}).cmdline_row.item).to_integer_32) - 1).to_integer_32).to_integer_32 * (create {P_GLOBALS_STATIC}).Columns.item.item + ((create {P_GLOBALS_STATIC}).sc_col.item).to_integer_32) - 1).to_integer_32
					if not (a_force.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 3 then -- else:
						if not (((create {P_OPTION_STATIC}).shortmess (('t').code)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_n := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))).to_integer_32 - l_room
						if l_n > 0 then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_size := ((create {P_CHARSET_STATIC}).vim_strsize (l_s))
								if l_size <= l_room then
									Result := l_s
									l_return := True
								end
								if not l_return then
									l_n := 0
									from
									until
										not (l_size >= l_room)
									loop
										l_size := l_size - ((create {P_GLOBALS_STATIC}).mb_ptr2cells.item.integer_32_item ([l_s + l_n]))
										l_n := l_n + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s + l_n]))
									end
									l_n := l_n - 1
								end
							end
							if not l_return then
								l_s := l_s + l_n
								l_s.item := (('<').code).to_natural_8
							end
						end
				when 6 then -- if done | if done
					if not l_return then
						Result := l_s
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	add_msg_hist (a_s: CE_POINTER [NATURAL_8]; a_len, a_attr: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_p___0: CE_POINTER [PD_MSG_HIST]
			l_return, l_break: BOOLEAN
		do
			l_s := a_s
			l_len := a_len
			if ((create {P_GLOBALS_STATIC}).msg_hist_off.item).to_boolean then
				l_return := True
			elseif (create {P_GLOBALS_STATIC}).msg_silent.item /= 0 then
				l_return := True
			end
			if not l_return then
				from
				until
					not (msg_hist_len.item > 200)
				loop
					delete_first_msg.do_nothing
				end
				l_p___0 := create {CE_CLASS_POINTER [PD_MSG_HIST]}.make_cast (((create {P_MISC2_STATIC}).alloc ((((create {PD_MSG_HIST}.make).structure_size.to_natural_32).to_integer_32).to_natural_32)))
				if not l_p___0.is_void then
					if l_len < 0 then
						l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))).to_integer_32
					end
					from
					until
						(l_break)
					loop
						l_break := False
						if l_len > 0 then
							if (l_s.item).to_integer_32 /= 10 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_s := l_s + 1
							l_len := l_len - 1
						end
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if l_len > 0 then
							if (l_s[(l_len - 1)]).to_integer_32 /= 10 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_len := l_len - 1
						end
					end
					l_break := False
					l_p___0.item.msg := (create {P_MISC2_STATIC}).vim_strnsave (l_s, l_len)
					l_p___0.item.next := create {CE_CLASS_POINTER [PD_MSG_HIST]}.make_shared (default_pointer)
					l_p___0.item.attr := a_attr
					if not last_msg_hist.item.is_void then
						last_msg_hist.item.item.next := l_p___0
					end
					last_msg_hist.item := l_p___0
					if first_msg_hist.item.is_void then
						first_msg_hist.item := last_msg_hist.item
					end
					msg_hist_len.item := msg_hist_len.item + 1
				end
			end
		end

	delete_first_msg: INTEGER_32
		local
			l_p___0: CE_POINTER [PD_MSG_HIST]
			l_return: BOOLEAN
		do
			if msg_hist_len.item <= 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_p___0 := first_msg_hist.item
				first_msg_hist.item := l_p___0.item.next
				if first_msg_hist.item.is_void then
					last_msg_hist.item := create {CE_CLASS_POINTER [PD_MSG_HIST]}.make_shared (default_pointer)
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0.item.msg));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
				msg_hist_len.item := msg_hist_len.item - 1
				Result := 1
			end
		end

	ex_messages (a_eap: CE_POINTER [PD_EXARG])
		local
			l_p___0: CE_POINTER [PD_MSG_HIST]
			l_s: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			(create {P_GLOBALS_STATIC}).msg_hist_off.item := 1
			l_s := create {CE_NATURAL_8_POINTER}.make_cast ((getenv (ce_string ("LANG"))))
			if not l_s.is_void then
				if (l_s.item).to_integer_32 /= 0 then
					msg_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Messages maintainer: Bram Moolenaar <Bram@vim.org>")))), (create {P_GLOBALS_STATIC}).highlight_attr.item[14]).do_nothing
				end
			end
			l_p___0 := first_msg_hist.item
			from
			until
				(l_break)
			loop
				l_break := False
				if not l_p___0.is_void then
					if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					if not (l_p___0.item.msg).is_void then
						msg_attr (l_p___0.item.msg, l_p___0.item.attr).do_nothing
					end
					l_p___0 := l_p___0.item.next
				end
			end
			l_break := False;
			(create {P_GLOBALS_STATIC}).msg_hist_off.item := 0
		end

	msg_end_prompt
		do
			(create {P_GLOBALS_STATIC}).need_wait_return.item := 0;
			(create {P_GLOBALS_STATIC}).emsg_on_display.item := 0;
			(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item;
			(create {P_GLOBALS_STATIC}).msg_col.item := 0
			msg_clr_eos
		end

	wait_return (a_redraw: INTEGER_32)
		local
			l_c: INTEGER_32
			l_oldState: INTEGER_32
			l_tmpState: INTEGER_32
			l_had_got_int: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_redraw = 1 then
						(create {P_GLOBALS_STATIC}).must_redraw.item := 50
					end
					if (create {P_GLOBALS_STATIC}).msg_silent.item /= 0 then
						l_return := True
					end
					if not l_return and then ((create {P_GLOBALS_STATIC}).vgetc_busy.item > 0) then
						l_return := True
					end
					if not l_return and then (((create {P_GLOBALS_STATIC}).no_wait_return.item).to_boolean) then
						(create {P_GLOBALS_STATIC}).need_wait_return.item := 1
						if not ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
							(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item
						end
						l_return := True
					end
					if l_return then
						l_pos := -1 + 42 -- skip if block
					end
				when 1 then -- if:;
						(create {P_GLOBALS_STATIC}).redir_off.item := 1
						l_oldState := (create {P_GLOBALS_STATIC}).State.item
						if not (((create {P_GLOBALS_STATIC}).quit_more.item).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_c := ('%R').code;
						(create {P_GLOBALS_STATIC}).quit_more.item := 0;
						(create {P_GLOBALS_STATIC}).got_int.item := 0
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 4 then -- else:
						if not (((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
						l_c := ('%R').code;
						(create {P_GLOBALS_STATIC}).got_int.item := 0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 7 then -- else:;
						(create {P_SCREEN_STATIC}).screenalloc (0);
						(create {P_GLOBALS_STATIC}).State.item := 513;
						(create {P_TERM_STATIC}).setmouse;
						(create {P_GLOBALS_STATIC}).dont_scroll.item := 1
						hit_return_msg
				when 8 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 32 -- skip loop
						end
				when 9 then -- loop body:
						l_break := False
						l_had_got_int := (create {P_GLOBALS_STATIC}).got_int.item;
						(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item + 1;
						(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item + 1
						l_c := (create {P_GETCHAR_STATIC}).safe_vgetc
						if l_had_got_int.to_boolean then
							if not ((create {P_GLOBALS_STATIC}).global_busy.item).to_boolean then
								(create {P_GLOBALS_STATIC}).got_int.item := 0
							end
						end
						(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item - 1;
						(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item - 1
						if l_c = 25 then
							if ((create {P_GLOBALS_STATIC}).clip_star.item.item.state).to_integer_32 = 2 then
								(create {P_UI_STATIC}).clip_copy_modeless_selection (1)
								l_c := -(253 + ((53).bit_shift_left (8)))
							end
						end
						if not (((create {P_OPTION_STATIC}).p_more.item.item).to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 10 then -- if:
						if ((create {P_OPTION_STATIC}).p_cp.item.item).to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 11 then -- if:
						if l_c /= 98 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 24 -- goto _L
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 14 then -- else:
						if l_c /= 107 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 24 -- goto _L
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 17 then -- else:
						if l_c /= 117 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 24 -- goto _L
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 20 then -- else:
						if l_c /= 103 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 24 -- goto _L
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 23 then -- else:
						if l_c /= -(107 + ((117).bit_shift_left (8))) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if: | _L:
						do_more_prompt (l_c).do_nothing
						if ((create {P_GLOBALS_STATIC}).quit_more.item).to_boolean then
							l_c := ('%R').code;
							(create {P_GLOBALS_STATIC}).quit_more.item := 0;
							(create {P_GLOBALS_STATIC}).got_int.item := 0
						else
							l_c := -(253 + ((53).bit_shift_left (8)))
							hit_return_msg
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						if ((create {P_GLOBALS_STATIC}).msg_scrolled.item).to_integer_32 > (create {P_GLOBALS_STATIC}).Rows.item.item - 2 then
							if l_c = 106 then
								l_c := -(253 + ((53).bit_shift_left (8)))
							elseif l_c = -(107 + ((100).bit_shift_left (8))) then
								l_c := -(253 + ((53).bit_shift_left (8)))
							elseif l_c = 100 then
								l_c := -(253 + ((53).bit_shift_left (8)))
							elseif l_c = 102 then
								l_c := -(253 + ((53).bit_shift_left (8)))
							end
						end
				when 27 then -- if done | if done | if done | if done | if done | if done
						if not (l_had_got_int.to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if l_c /= 3 then
							l_pos := -1 + 30 -- goto _L___0
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else: | _L___0:
						if l_c /= -(253 + ((53).bit_shift_left (8))) then
							if l_c /= -(249 + ((88).bit_shift_left (8))) then
								if l_c /= -(248 + ((88).bit_shift_left (8))) then
									if l_c /= -(253 + ((45).bit_shift_left (8))) then
										if l_c /= -(253 + ((46).bit_shift_left (8))) then
											if l_c /= -(253 + ((48).bit_shift_left (8))) then
												if l_c /= -(253 + ((49).bit_shift_left (8))) then
													if l_c /= -(253 + ((51).bit_shift_left (8))) then
														if l_c /= -(253 + ((52).bit_shift_left (8))) then
															if l_c /= -(253 + ((77).bit_shift_left (8))) then
																if l_c /= -(253 + ((78).bit_shift_left (8))) then
																	if l_c /= -(253 + ((75).bit_shift_left (8))) then
																		if l_c /= -(253 + ((76).bit_shift_left (8))) then
																			if ((create {P_TERM_STATIC}).mouse_has (('r').code)).to_boolean then
																				l_break := True
																			elseif (create {P_GLOBALS_STATIC}).mouse_row.item < (create {P_GLOBALS_STATIC}).msg_row.item then
																				if l_c /= -(253 + ((44).bit_shift_left (8))) then
																					if l_c /= -(253 + ((47).bit_shift_left (8))) then
																						if l_c /= -(253 + ((50).bit_shift_left (8))) then
																							if l_c /= -(253 + ((89).bit_shift_left (8))) then
																								if l_c /= -(253 + ((92).bit_shift_left (8))) then
																									l_break := True
																								end
																							end
																						end
																					end
																				end
																			else
																				l_break := True
																			end
																		end
																	end
																end
															end
														end
													end
												end
											end
										end
									end
								end
							end
						end
				when 31 then
						l_pos := -1 + 8 -- back to loop condition
				when 32 then -- loop done
						l_break := False;
						(create {P_UI_STATIC}).ui_breakcheck
						if l_c = -(253 + ((44).bit_shift_left (8))) then
							(create {P_UI_STATIC}).jump_to_mouse (8, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0).do_nothing
						elseif l_c = -(253 + ((47).bit_shift_left (8))) then
							(create {P_UI_STATIC}).jump_to_mouse (8, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0).do_nothing
						elseif l_c = -(253 + ((50).bit_shift_left (8))) then
							(create {P_UI_STATIC}).jump_to_mouse (8, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0).do_nothing
						elseif l_c = -(253 + ((89).bit_shift_left (8))) then
							(create {P_UI_STATIC}).jump_to_mouse (8, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0).do_nothing
						elseif l_c = -(253 + ((92).bit_shift_left (8))) then
							(create {P_UI_STATIC}).jump_to_mouse (8, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0).do_nothing
						elseif ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N ")), l_c)).is_void then
							if l_c /= 3 then
								(create {P_GETCHAR_STATIC}).ins_char_typebuf (l_c);
								(create {P_GLOBALS_STATIC}).do_redraw.item := 1
							end
						end
				when 33 then -- if done | if done;
						(create {P_GLOBALS_STATIC}).redir_off.item := 0
						if l_c /= 58 then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_pos := -1 + 40 -- goto _L___1
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 36 then -- else:
						if l_c /= 63 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						l_pos := -1 + 40 -- goto _L___1
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 39 then -- else:
						if l_c /= 47 then
							l_pos := -1 + 41 -- skip if block
						end
				when 40 then -- if: | _L___1:
						if not ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
							(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item
						end
						(create {P_GLOBALS_STATIC}).skip_redraw.item := 1;
						(create {P_GLOBALS_STATIC}).do_redraw.item := 0
				when 41 then -- if done | if done
						l_tmpState := (create {P_GLOBALS_STATIC}).State.item;
						(create {P_GLOBALS_STATIC}).State.item := l_oldState;
						(create {P_TERM_STATIC}).setmouse
						msg_check
						if ((create {P_TERM_STATIC}).swapping_screen).to_boolean then
							if not ((create {P_GLOBALS_STATIC}).termcap_active.item).to_boolean then
								(create {P_GLOBALS_STATIC}).newline_on_exit.item := 1
							end
						end
						(create {P_GLOBALS_STATIC}).need_wait_return.item := 0;
						(create {P_GLOBALS_STATIC}).did_wait_return.item := 1;
						(create {P_GLOBALS_STATIC}).emsg_on_display.item := 0;
						(create {P_GLOBALS_STATIC}).lines_left.item := -1
						reset_last_sourcing
						if not ((create {P_GLOBALS_STATIC}).keep_msg.item).is_void then
							if ((create {P_CHARSET_STATIC}).vim_strsize ((create {P_GLOBALS_STATIC}).keep_msg.item)).to_integer_32 >= (((create {P_GLOBALS_STATIC}).Rows.item.item - ((create {P_GLOBALS_STATIC}).cmdline_row.item).to_integer_32) - 1) * (create {P_GLOBALS_STATIC}).Columns.item.item + ((create {P_GLOBALS_STATIC}).sc_col.item).to_integer_32 then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).keep_msg.item));
								(create {P_GLOBALS_STATIC}).keep_msg.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							end
						end
						if l_tmpState = 1_024 then
							(create {P_TERM_STATIC}).starttermcap;
							(create {P_TERM_STATIC}).shell_resized
						elseif not ((create {P_GLOBALS_STATIC}).skip_redraw.item).to_boolean then
							if a_redraw = 1 then
								(create {P_TERM_STATIC}).starttermcap;
								(create {P_SCREEN_STATIC}).redraw_later (10)
							elseif (create {P_GLOBALS_STATIC}).msg_scrolled.item /= 0 then
								if a_redraw /= -1 then
									(create {P_TERM_STATIC}).starttermcap;
									(create {P_SCREEN_STATIC}).redraw_later (10)
								end
							end
						end
				when 42 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	hit_return_msg
		local
			l_save_p_more: INTEGER_32
		do
			l_save_p_more := (create {P_OPTION_STATIC}).p_more.item.item;
			(create {P_OPTION_STATIC}).p_more.item.item := 0
			if ((create {P_GLOBALS_STATIC}).msg_didout.item).to_boolean then
				msg_putchar (('%N').code)
			end
			if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
				msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Interrupt: ")))))
			end
			msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Press ENTER or type command to continue")))), (create {P_GLOBALS_STATIC}).highlight_attr.item[10])
			if not (msg_use_printf).to_boolean then
				msg_clr_eos
			end
			(create {P_OPTION_STATIC}).p_more.item.item := l_save_p_more
		end

	set_keep_msg (a_s: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32)
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).keep_msg.item))
			if not a_s.is_void then
				if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
					(create {P_GLOBALS_STATIC}).keep_msg.item := (create {P_MISC2_STATIC}).vim_strsave (a_s)
				else
					(create {P_GLOBALS_STATIC}).keep_msg.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				end
			else
				(create {P_GLOBALS_STATIC}).keep_msg.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			end
			(create {P_GLOBALS_STATIC}).keep_msg_more.item := 0;
			(create {P_GLOBALS_STATIC}).keep_msg_attr.item := a_attr
		end

	set_keep_msg_from_hist
		do
			if ((create {P_GLOBALS_STATIC}).keep_msg.item).is_void then
				if not last_msg_hist.item.is_void then
					if (create {P_GLOBALS_STATIC}).msg_scrolled.item = 0 then
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (1)).to_boolean then
							set_keep_msg (last_msg_hist.item.item.msg, last_msg_hist.item.item.attr)
						end
					end
				end
			end
		end

	msg_start
		local
			l_did_return: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_did_return := 0
					if not ((create {P_GLOBALS_STATIC}).msg_silent.item).to_boolean then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).keep_msg.item));
						(create {P_GLOBALS_STATIC}).keep_msg.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
					if ((create {P_GLOBALS_STATIC}).need_clr_eos.item).to_boolean then
						(create {P_GLOBALS_STATIC}).need_clr_eos.item := 0
						msg_clr_eos
					end
					if ((create {P_GLOBALS_STATIC}).msg_scroll.item).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_GLOBALS_STATIC}).full_screen.item).to_boolean then
							(create {P_GLOBALS_STATIC}).msg_row.item := (create {P_GLOBALS_STATIC}).cmdline_row.item;
							(create {P_GLOBALS_STATIC}).msg_col.item := 0
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if ((create {P_GLOBALS_STATIC}).msg_didout.item).to_boolean then
							msg_putchar (('%N').code)
							l_did_return := 1
							if (create {P_GLOBALS_STATIC}).exmode_active.item /= 1 then
								(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item
							end
						end
				when 4 then
					if not ((create {P_GLOBALS_STATIC}).msg_didany.item).to_boolean then
						msg_starthere
					elseif (create {P_GLOBALS_STATIC}).lines_left.item < 0 then
						msg_starthere
					end
					if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
						(create {P_GLOBALS_STATIC}).msg_didout.item := 0;
						(create {P_TERM_STATIC}).cursor_off
					end
					if not l_did_return.to_boolean then
						redir_write (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")), -1)
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	msg_starthere
		do
			(create {P_GLOBALS_STATIC}).lines_left.item := (create {P_GLOBALS_STATIC}).cmdline_row.item;
			(create {P_GLOBALS_STATIC}).msg_didany.item := 0
		end

	msg_putchar (a_c: INTEGER_32)
		do
			msg_putchar_attr (a_c, 0)
		end

	msg_putchar_attr (a_c, a_attr: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_tmp: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<22>>)

			if a_c < 0 then
				l_buf___6[0] := (128).to_natural_8
				if a_c = 128 then
					l_buf___6[1] := (254).to_natural_8
				else
					if a_c = 0 then
						l_tmp := 255
					else
						l_tmp := (-a_c).bit_and (255)
					end
					l_buf___6[1] := l_tmp.to_natural_8
				end
				if a_c = 128 then
					l_buf___6[2] := (('X').code).to_natural_8
				elseif a_c = 0 then
					l_buf___6[2] := (('X').code).to_natural_8
				else
					l_buf___6[2] := (((((-a_c).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_natural_8
				end
				l_buf___6[3] := (('%/0/').code).to_natural_8
			else
				l_buf___6[((create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([a_c, l_buf___6]))] := (('%/0/').code).to_natural_8
			end
			msg_puts_attr (l_buf___6, a_attr)
		end

	msg_outnum (a_n: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<20>>)

			sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("%%ld"), a_n]).do_nothing
			msg_puts (l_buf___6)
		end

	msg_home_replace (a_fname: CE_POINTER [NATURAL_8])
		do
			msg_home_replace_attr (a_fname, 0)
		end

	msg_home_replace_hl (a_fname: CE_POINTER [NATURAL_8])
		do
			msg_home_replace_attr (a_fname, (create {P_GLOBALS_STATIC}).highlight_attr.item[2])
		end

	msg_home_replace_attr (a_fname: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32)
		local
			l_name___1: CE_POINTER [NATURAL_8]
		do
			l_name___1 := (create {P_MISC1_STATIC}).home_replace_save (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), a_fname)
			if not l_name___1.is_void then
				msg_outtrans_attr (l_name___1, a_attr).do_nothing
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_name___1))
		end

	msg_outtrans (a_str___1: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := (msg_outtrans_attr (a_str___1, 0))
		end

	msg_outtrans_attr (a_str___1: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32): INTEGER_32
		do
			Result := (msg_outtrans_len_attr (a_str___1, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_str___1))).to_integer_32, a_attr))
		end

	msg_outtrans_len (a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		do
			Result := (msg_outtrans_len_attr (a_str___1, a_len, 0))
		end

	msg_outtrans_one (a_p___0: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_l: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				l_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([a_p___0])
				if l_l > 1 then
					msg_outtrans_len_attr (a_p___0, l_l, a_attr).do_nothing
					Result := (a_p___0 + l_l)
					l_return := True
				end
			end
			if not l_return then
				msg_puts_attr (((create {P_CHARSET_STATIC}).transchar_byte ((a_p___0.item).to_integer_32)), a_attr)
				Result := (a_p___0 + 1)
			end
		end

	msg_outtrans_len_attr (a_msgstr: CE_POINTER [NATURAL_8]; a_len, a_attr: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_attr: INTEGER_32
			l_retval: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			l_plain_start: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_mb_l: INTEGER_32
			l_c: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___6: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := a_len
					l_attr := a_attr
					l_retval := 0
					l_str___1 := a_msgstr
					l_plain_start := a_msgstr
					if ((l_attr).bit_and (4_096)).to_boolean then
						add_msg_hist (l_str___1, l_len, l_attr)
						l_attr := (l_attr).bit_and ((-4_097))
					end
					if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
						if ((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_MBYTE_STATIC}).utf_ptr2char (a_msgstr)))).to_boolean then
							msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")), l_attr)
						end
					end
				when 1 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_len := l_len - 1
						if not (l_len >= 0) then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							l_mb_l := (create {P_MBYTE_STATIC}).utfc_ptr2len_len (l_str___1, l_len + 1)
						elseif ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_mb_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_str___1])
						else
							l_mb_l := 1
						end
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_mb_l > 1 then
							l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_str___1])
							if ((create {P_CHARSET_STATIC}).vim_isprintc (l_c)).to_boolean then
								l_retval := l_retval + ((create {P_GLOBALS_STATIC}).mb_ptr2cells.item.integer_32_item ([l_str___1]))
							else
								if (l_str___1.c_pointer.to_integer_32).to_natural_32 > (l_plain_start.c_pointer.to_integer_32).to_natural_32 then
									msg_puts_attr_len (l_plain_start, l_str___1.distance (l_plain_start), l_attr)
								end
								l_plain_start := l_str___1 + l_mb_l
								if l_attr = 0 then
									l_tmp___2 := (create {P_GLOBALS_STATIC}).highlight_attr.item[0]
								else
									l_tmp___2 := l_attr
								end
								msg_puts_attr (((create {P_CHARSET_STATIC}).transchar (l_c)), l_tmp___2)
								l_retval := l_retval + ((create {P_CHARSET_STATIC}).char2cells (l_c))
							end
							l_len := l_len - (l_mb_l - 1)
							l_str___1 := l_str___1 + l_mb_l
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_s := (create {P_CHARSET_STATIC}).transchar_byte ((l_str___1.item).to_integer_32)
						if (l_s[1]).to_integer_32 /= 0 then
							if (l_str___1.c_pointer.to_integer_32).to_natural_32 > (l_plain_start.c_pointer.to_integer_32).to_natural_32 then
								msg_puts_attr_len (l_plain_start, l_str___1.distance (l_plain_start), l_attr)
							end
							l_plain_start := l_str___1 + 1
							if l_attr = 0 then
								l_tmp___6 := (create {P_GLOBALS_STATIC}).highlight_attr.item[0]
							else
								l_tmp___6 := l_attr
							end
							msg_puts_attr (l_s, l_tmp___6)
							l_retval := l_retval + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))).to_integer_32
						else
							l_retval := l_retval + 1
						end
						l_str___1 := l_str___1 + 1
				when 7 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 8 then -- loop done
					l_break := False
					if (l_str___1.c_pointer.to_integer_32).to_natural_32 > (l_plain_start.c_pointer.to_integer_32).to_natural_32 then
						msg_puts_attr_len (l_plain_start, l_str___1.distance (l_plain_start), l_attr)
					end
					Result := l_retval
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	msg_outtrans_special (a_strstart: CE_POINTER [NATURAL_8]; a_from: INTEGER_32): INTEGER_32
		local
			l_str___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_retval: INTEGER_32
			l_string___0: CE_POINTER [NATURAL_8]
			l_attr: INTEGER_32
			l_len: INTEGER_32
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_str___1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str___1.item := a_strstart
					l_retval := 0
					l_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[0]
				when 1 then -- loop condition:
					if (l_str___1.item.item).to_integer_32 = 0 then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						if not ((l_str___1.item).is_equal (a_strstart)) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if (l_str___1.item[1]).to_integer_32 /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L:
						if (l_str___1.item.item).to_integer_32 = 32 then
							l_string___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<Space>"))
							l_str___1.item := l_str___1.item + 1
						else
							l_string___0 := str2special (l_str___1, a_from)
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_string___0 := str2special (l_str___1, a_from)
				when 9 then -- if done
						l_len := (create {P_CHARSET_STATIC}).vim_strsize (l_string___0)
						if l_len > 1 then
							if ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_string___0])) <= 1 then
								l_tmp___0 := l_attr
							else
								l_tmp___0 := 0
							end
						else
							l_tmp___0 := 0
						end
						msg_puts_attr (l_string___0, l_tmp___0)
						l_retval := l_retval + l_len
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					Result := l_retval
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	str2special (a_sp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_from: INTEGER_32): CE_POINTER [NATURAL_8]
		require
			not a_sp.is_void
		local
			l_c: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			l_modifiers: INTEGER_32
			l_special: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_str___1 := a_sp.item
			l_modifiers := 0
			l_special := 0
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				l_p___0 := (create {P_MBYTE_STATIC}).mb_unescape (a_sp)
				if not l_p___0.is_void then
					Result := l_p___0
					l_return := True
				end
			end
			if not l_return then
				l_c := (l_str___1.item).to_integer_32
				if l_c = 128 then
					if (l_str___1[1]).to_integer_32 /= 0 then
						if (l_str___1[2]).to_integer_32 /= 0 then
							if (l_str___1[1]).to_integer_32 = 252 then
								l_modifiers := (l_str___1[2]).to_integer_32
								l_str___1 := l_str___1 + (3)
								l_c := (l_str___1.item).to_integer_32
							end
							if l_c = 128 then
								if (l_str___1[1]).to_integer_32 /= 0 then
									if (l_str___1[2]).to_integer_32 /= 0 then
										if (l_str___1[1]).to_integer_32 = 254 then
											l_c := 128
										else
											if (l_str___1[1]).to_integer_32 = 255 then
												l_tmp := -(255 + ((88).bit_shift_left (8)))
											else
												l_tmp := -((l_str___1[1]).to_integer_32 + (((l_str___1[2]).to_integer_32).bit_shift_left (8)))
											end
											l_c := l_tmp
										end
										l_str___1 := l_str___1 + (2)
										if l_c = -(255 + ((88).bit_shift_left (8))) then
											l_c := ('%/0/').code
										end
									end
								end
							end
							if l_c < 0 then
								l_special := 1
							elseif l_modifiers.to_boolean then
								l_special := 1
							end
						end
					end
				end
				a_sp.item := l_str___1 + 1
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					if ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_str___1.item).to_integer_32]).to_integer_32 > ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_str___1])) then
						(create {P_CHARSET_STATIC}).transchar_nonprint (buf___0.item, l_c)
						Result := buf___0.item
						l_return := True
					end
				end
			end
			if not l_return then
				if l_special.to_boolean then
					l_tmp___1 := (create {P_MISC2_STATIC}).get_special_key_name (l_c, l_modifiers)
					Result := l_tmp___1
					l_return := True
				elseif ((create {P_CHARSET_STATIC}).char2cells (l_c)) > 1 then
					l_tmp___1 := (create {P_MISC2_STATIC}).get_special_key_name (l_c, l_modifiers)
					Result := l_tmp___1
					l_return := True
				elseif a_from.to_boolean then
					if l_c = 32 then
						l_tmp___1 := (create {P_MISC2_STATIC}).get_special_key_name (l_c, l_modifiers)
						Result := l_tmp___1
						l_return := True
					end
				end
			end
			if not l_return then
				buf___0.item[0] := l_c.to_natural_8
				buf___0.item[1] := (('%/0/').code).to_natural_8
				Result := buf___0.item
			end
		end

	msg_prt_line (a_s: CE_POINTER [NATURAL_8]; a_list: INTEGER_32)
		require
			not a_s.is_void
		local
			l_s: CE_POINTER [NATURAL_8]
			l_list: INTEGER_32
			l_c: INTEGER_32
			l_col: INTEGER_32
			l_n_extra: INTEGER_32
			l_c_extra: INTEGER_32
			l_p_extra: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_attr: INTEGER_32
			l_trail: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<22>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					l_list := a_list
					l_col := 0
					l_n_extra := 0
					l_c_extra := 0
					l_p_extra := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_attr := 0
					l_trail := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list).to_boolean then
						l_list := 1
					end
					if l_list.to_boolean then
						if ((create {P_GLOBALS_STATIC}).lcs_trail.item.item).to_boolean then
							l_trail := l_s + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))).to_integer_32
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_trail.c_pointer.to_integer_32).to_natural_32 > (l_s.c_pointer.to_integer_32).to_natural_32 then
									if (l_trail[-1]).to_integer_32 /= 32 then
										if (l_trail[-1]).to_integer_32 /= 9 then
											l_break := True
										end
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_trail := l_trail - 1
								end
							end
							l_break := False
						end
					end
					if (l_s.item).to_integer_32 = 0 then
						if l_list.to_boolean then
							if (create {P_GLOBALS_STATIC}).lcs_eol.item.item = 0 then
								msg_putchar ((' ').code)
							end
						else
							msg_putchar ((' ').code)
						end
					end
				when 1 then -- loop condition:
					if not (not (l_break) and then (not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean)) then
						l_pos := -1 + 25 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						if not (l_n_extra > 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_n_extra := l_n_extra - 1
						if l_c_extra.to_boolean then
							l_c := l_c_extra
						else
							l_tmp___0 := l_p_extra
							l_p_extra := l_p_extra + 1
							l_c := (l_tmp___0.item).to_integer_32
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 5 then -- else:
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s])
						if l_l > 1 then
							l_col := l_col + ((create {P_GLOBALS_STATIC}).mb_ptr2cells.item.integer_32_item ([l_s]))
							memmove (create {CE_VOID_POINTER}.make_cast (l_buf___6), create {CE_VOID_POINTER}.make_cast (l_s), l_l.to_natural_32).do_nothing
							l_buf___6[l_l] := (('%/0/').code).to_natural_8
							msg_puts (l_buf___6)
							l_s := l_s + l_l
							l_continue := True
						else
							l_pos := -1 + 8 -- goto _L___4
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 8 then -- else: | _L___4:
						l_attr := 0
						l_tmp___2 := l_s
						l_s := l_s + 1
						l_c := (l_tmp___2.item).to_integer_32
						if l_c /= 9 then
							l_pos := -1 + 17 -- skip if block
						end
				when 9 then -- if:
						if l_list.to_boolean then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L___3
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else:
						if not (((create {P_GLOBALS_STATIC}).lcs_tab1.item).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | _L___3:
						l_n_extra := (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts - l_col.to_integer_32 \\ (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts) - 1).to_integer_32
						if not l_list.to_boolean then
							l_c := (' ').code
							l_c_extra := (' ').code
						else
							l_c := (create {P_GLOBALS_STATIC}).lcs_tab1.item
							l_c_extra := (create {P_GLOBALS_STATIC}).lcs_tab2.item.item
							l_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[0]
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_pos := -1 + 17 -- goto _L___2
				when 16 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 24
				when 17 then -- else: | _L___2:
						if l_c /= 0 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if l_list.to_boolean then
							if (create {P_GLOBALS_STATIC}).lcs_eol.item.item /= 0 then
								l_p_extra := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
								l_c_extra := ('%/0/').code
								l_n_extra := 1
								l_c := (create {P_GLOBALS_STATIC}).lcs_eol.item.item
								l_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[1]
								l_s := l_s - 1
							else
								l_pos := -1 + 20 -- goto _L___1
							end
						else
							l_pos := -1 + 20 -- goto _L___1
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 20 then -- else: | _L___1:
						if l_c = 0 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_n := (create {P_CHARSET_STATIC}).byte2cells (l_c)
						if l_n > 1 then
							l_n_extra := l_n - 1
							l_p_extra := (create {P_CHARSET_STATIC}).transchar_byte (l_c)
							l_c_extra := ('%/0/').code
							l_tmp___3 := l_p_extra
							l_p_extra := l_p_extra + 1
							l_c := (l_tmp___3.item).to_integer_32
							l_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[0]
						else
							l_pos := -1 + 23 -- goto _L
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else: | _L:
						if l_c = 32 then
							if not l_trail.is_void then
								if (l_s.c_pointer.to_integer_32).to_natural_32 > (l_trail.c_pointer.to_integer_32).to_natural_32 then
									l_c := (create {P_GLOBALS_STATIC}).lcs_trail.item.item
									l_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[0]
								end
							end
						end
				when 24 then -- if done | if done | if done | if done
						if not (l_break or l_continue) and then (l_c = 0) then
							l_break := True
						end
						if not (l_break or l_continue) then
							msg_putchar_attr (l_c, l_attr)
							l_col := l_col + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 25 then -- loop done
					l_break := False
					l_continue := False
					msg_clr_eos
				when 26 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	screen_puts_mbyte (a_s: CE_POINTER [NATURAL_8]; a_l, a_attr: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_cw: INTEGER_32
			l_return: BOOLEAN
		do
			(create {P_GLOBALS_STATIC}).msg_didout.item := 1
			l_cw := (create {P_GLOBALS_STATIC}).mb_ptr2cells.item.integer_32_item ([a_s])
			if l_cw > 1 then
				if ((create {P_GLOBALS_STATIC}).msg_col.item).to_integer_32 = (create {P_GLOBALS_STATIC}).Columns.item.item - 1 then
					msg_screen_putchar (('>').code, (create {P_GLOBALS_STATIC}).highlight_attr.item[1])
					Result := a_s
					l_return := True
				end
			end
			if not l_return then
				(create {P_SCREEN_STATIC}).screen_puts_len (a_s, a_l, (create {P_GLOBALS_STATIC}).msg_row.item, (create {P_GLOBALS_STATIC}).msg_col.item, a_attr);
				(create {P_GLOBALS_STATIC}).msg_col.item := (create {P_GLOBALS_STATIC}).msg_col.item + l_cw
				if ((create {P_GLOBALS_STATIC}).msg_col.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item then
					(create {P_GLOBALS_STATIC}).msg_col.item := 0;
					(create {P_GLOBALS_STATIC}).msg_row.item := (create {P_GLOBALS_STATIC}).msg_row.item + 1
				end
				Result := (a_s + a_l)
			end
		end

	msg_puts (a_s: CE_POINTER [NATURAL_8])
		do
			msg_puts_attr (a_s, 0)
		end

	msg_puts_title (a_s: CE_POINTER [NATURAL_8])
		do
			msg_puts_attr (a_s, (create {P_GLOBALS_STATIC}).highlight_attr.item[14])
		end

	msg_puts_long_attr (a_longstr: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32)
		do
			msg_puts_long_len_attr (a_longstr, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_longstr))).to_integer_32, a_attr)
		end

	msg_puts_long_len_attr (a_longstr: CE_POINTER [NATURAL_8]; a_len, a_attr: INTEGER_32)
		local
			l_slen: INTEGER_32
			l_room: INTEGER_32
		do
			l_slen := a_len
			l_room := ((create {P_GLOBALS_STATIC}).Columns.item.item - ((create {P_GLOBALS_STATIC}).msg_col.item).to_integer_32).to_integer_32
			if a_len > l_room then
				if l_room >= 20 then
					l_slen := (l_room - 3) // 2
					msg_outtrans_len_attr (a_longstr, l_slen, a_attr).do_nothing
					msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("...")), (create {P_GLOBALS_STATIC}).highlight_attr.item[0])
				end
			end
			msg_outtrans_len_attr ((a_longstr + a_len) - l_slen, l_slen, a_attr).do_nothing
		end

	msg_puts_attr (a_s: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32)
		do
			msg_puts_attr_len (a_s, -1, a_attr)
		end

	msg_puts_attr_len (a_str___1: CE_POINTER [NATURAL_8]; a_maxlen, a_attr: INTEGER_32)
		local
			l_attr: INTEGER_32
			l_return: BOOLEAN
		do
			l_attr := a_attr
			redir_write (a_str___1, a_maxlen)
			if (create {P_GLOBALS_STATIC}).msg_silent.item /= 0 then
				l_return := True
			end
			if not l_return then
				if ((l_attr).bit_and (4_096)).to_boolean then
					if a_maxlen < 0 then
						add_msg_hist (a_str___1, -1, l_attr)
						l_attr := (l_attr).bit_and ((-4_097))
					end
				end
				if (create {P_GLOBALS_STATIC}).msg_scrolled.item /= 0 then
					if not ((create {P_GLOBALS_STATIC}).msg_scrolled_ign.item).to_boolean then
						(create {P_GLOBALS_STATIC}).need_wait_return.item := 1
					end
				end
				(create {P_GLOBALS_STATIC}).msg_didany.item := 1
				if (msg_use_printf).to_boolean then
					msg_puts_printf (a_str___1, a_maxlen)
				else
					msg_puts_display (a_str___1, a_maxlen, l_attr, 0)
				end
			end
		end

	msg_puts_display (a_str___1: CE_POINTER [NATURAL_8]; a_maxlen, a_attr, a_recurse___2: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			l_t_s: CE_POINTER [NATURAL_8]
			l_t_col: CE_ARRAY [INTEGER_32]
			l_l: INTEGER_32
			l_cw: INTEGER_32
			l_sb_str: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_sb_col: CE_ARRAY [INTEGER_32]
			l_wrap: INTEGER_32
			l_did_last_char: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_t_col.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_sb_str.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_sb_col.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_str___1
					l_t_s := a_str___1
					l_t_col.item := 0
					l_sb_str.item := a_str___1
					l_sb_col.item := (create {P_GLOBALS_STATIC}).msg_col.item;
					(create {P_GLOBALS_STATIC}).did_wait_return.item := 0
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 46 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						if not (a_maxlen < 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L___3
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if not (l_s.distance (a_str___1) < a_maxlen) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___3:
						if (l_s.item).to_integer_32 = 0 then
							l_break := True
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_break := True
				when 9 then -- if done
						if not (not (l_return or l_break or l_continue) and then (not a_recurse___2.to_boolean)) then
							l_pos := -1 + 24 -- skip if block
						end
				when 10 then -- if:
						if not (((create {P_GLOBALS_STATIC}).msg_row.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Rows.item.item - 1) then
							l_pos := -1 + 24 -- skip if block
						end
				when 11 then -- if:
						if (l_s.item).to_integer_32 /= 10 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 23 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 14 then -- else:
						if not (((create {P_GLOBALS_STATIC}).msg_col.item + l_t_col.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item - 1) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 23 -- goto _L___0
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 17 then -- else:
						if (l_s.item).to_integer_32 /= 9 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if ((create {P_GLOBALS_STATIC}).msg_col.item + l_t_col.item).to_integer_32 >= ((((create {P_GLOBALS_STATIC}).Columns.item.item - 1)).bit_and (-8)) then
							l_pos := -1 + 23 -- goto _L___0
						else
							l_pos := -1 + 20 -- goto _L___1
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 20 then -- else: | _L___1:
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 21 then -- if:
						if not (((create {P_GLOBALS_STATIC}).mb_ptr2cells.item.integer_32_item ([l_s])) > 1) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if not (((create {P_GLOBALS_STATIC}).msg_col.item + l_t_col.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item - 2) then
							l_pos := -1 + 24 -- skip if block
						end
				when 23 then -- if: | _L___0:
						if l_t_col.item > 0 then
							t_puts (l_t_col, l_t_s, l_s, a_attr)
						end
						if ((create {P_GLOBALS_STATIC}).msg_no_more.item).to_boolean then
							if (create {P_GLOBALS_STATIC}).lines_left.item = 0 then
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) then
							msg_scroll_up;
							(create {P_GLOBALS_STATIC}).msg_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 2).to_integer_32
							if ((create {P_GLOBALS_STATIC}).msg_col.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item then
								(create {P_GLOBALS_STATIC}).msg_col.item := ((create {P_GLOBALS_STATIC}).Columns.item.item - 1).to_integer_32
							end
							if (l_s.item).to_integer_32 >= 32 then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
										if a_maxlen >= 0 then
											l_l := (create {P_MBYTE_STATIC}).utfc_ptr2len_len (l_s, (a_str___1 + a_maxlen).distance (l_s))
										else
											l_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s])
										end
									else
										l_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s])
									end
									l_s := screen_puts_mbyte (l_s, l_l, a_attr)
								else
									l_tmp := l_s
									l_s := l_s + 1
									msg_screen_putchar ((l_tmp.item).to_integer_32, a_attr)
								end
								l_did_last_char := 1
							else
								l_did_last_char := 0
							end
							if ((create {P_OPTION_STATIC}).p_more.item.item).to_boolean then
								store_sb_text (l_sb_str, l_s, a_attr, l_sb_col, 1)
							end
							inc_msg_scrolled;
							(create {P_GLOBALS_STATIC}).need_wait_return.item := 1
							if (create {P_GLOBALS_STATIC}).must_redraw.item < 10 then
								(create {P_GLOBALS_STATIC}).must_redraw.item := 10
							end
							(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
							if (create {P_GLOBALS_STATIC}).cmdline_row.item > 0 then
								if not ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
									(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).cmdline_row.item - 1
								end
							end
							if (create {P_GLOBALS_STATIC}).lines_left.item > 0 then
								(create {P_GLOBALS_STATIC}).lines_left.item := (create {P_GLOBALS_STATIC}).lines_left.item - 1
							end
							if ((create {P_OPTION_STATIC}).p_more.item.item).to_boolean then
								if (create {P_GLOBALS_STATIC}).lines_left.item = 0 then
									if (create {P_GLOBALS_STATIC}).State.item /= 513 then
										if not ((create {P_GLOBALS_STATIC}).msg_no_more.item).to_boolean then
											if not ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
												if (do_more_prompt (('%/0/').code)).to_boolean then
													l_s := confirm_msg_tail.item
												end
												if ((create {P_GLOBALS_STATIC}).quit_more.item).to_boolean then
													l_return := True
												end
											end
										end
									end
								end
							end
							if not l_return and then (l_did_last_char.to_boolean) then
								l_continue := True
							end
						end
				when 24 then -- if done | if done | if done | if done | if done | if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 45 -- skip if block
						end
				when 25 then -- if:
						if (l_s.item).to_integer_32 = 10 then
							l_tmp___3 := 1
						elseif ((create {P_GLOBALS_STATIC}).msg_col.item + l_t_col.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item then
							l_tmp___3 := 1
						elseif ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).mb_ptr2cells.item.integer_32_item ([l_s])) > 1 then
								if ((create {P_GLOBALS_STATIC}).msg_col.item + l_t_col.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item - 1 then
									l_tmp___3 := 1
								else
									l_tmp___3 := 0
								end
							else
								l_tmp___3 := 0
							end
						else
							l_tmp___3 := 0
						end
						l_wrap := l_tmp___3
						if l_t_col.item > 0 then
							if l_wrap.to_boolean then
								t_puts (l_t_col, l_t_s, l_s, a_attr)
							elseif (l_s.item).to_integer_32 = 13 then
								t_puts (l_t_col, l_t_s, l_s, a_attr)
							elseif (l_s.item).to_integer_32 = 8 then
								t_puts (l_t_col, l_t_s, l_s, a_attr)
							elseif (l_s.item).to_integer_32 = 9 then
								t_puts (l_t_col, l_t_s, l_s, a_attr)
							elseif (l_s.item).to_integer_32 = 7 then
								t_puts (l_t_col, l_t_s, l_s, a_attr)
							end
						end
						if l_wrap.to_boolean then
							if ((create {P_OPTION_STATIC}).p_more.item.item).to_boolean then
								if not a_recurse___2.to_boolean then
									store_sb_text (l_sb_str, l_s, a_attr, l_sb_col, 1)
								end
							end
						end
						if (l_s.item).to_integer_32 /= 10 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:;
						(create {P_GLOBALS_STATIC}).msg_didout.item := 0;
						(create {P_GLOBALS_STATIC}).msg_col.item := 0;
						(create {P_GLOBALS_STATIC}).msg_row.item := (create {P_GLOBALS_STATIC}).msg_row.item + 1
						if ((create {P_GLOBALS_STATIC}).msg_row.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Rows.item.item then
							(create {P_GLOBALS_STATIC}).msg_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 28 then -- else:
						if (l_s.item).to_integer_32 /= 13 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:;
						(create {P_GLOBALS_STATIC}).msg_col.item := 0
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 31 then -- else:
						if (l_s.item).to_integer_32 /= 8 then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						if ((create {P_GLOBALS_STATIC}).msg_col.item).to_boolean then
							(create {P_GLOBALS_STATIC}).msg_col.item := (create {P_GLOBALS_STATIC}).msg_col.item - 1
						end
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 34 then -- else:
						if (l_s.item).to_integer_32 /= 9 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							msg_screen_putchar ((' ').code, a_attr)
							if not (((create {P_GLOBALS_STATIC}).msg_col.item).bit_and (7)).to_boolean then
								l_break := True
							end
						end
						l_break := False
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 37 then -- else:
						if (l_s.item).to_integer_32 /= 7 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:;
						(create {P_MISC1_STATIC}).vim_beep
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 40 then -- else:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_cw := (create {P_GLOBALS_STATIC}).mb_ptr2cells.item.integer_32_item ([l_s])
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								if a_maxlen >= 0 then
									l_l := (create {P_MBYTE_STATIC}).utfc_ptr2len_len (l_s, (a_str___1 + a_maxlen).distance (l_s))
								else
									l_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s])
								end
							else
								l_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s])
							end
						else
							l_cw := 1
							l_l := 1
						end
						if not (l_cw > 1) then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						if ((create {P_GLOBALS_STATIC}).msg_col.item + l_t_col.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item - 1 then
							if l_l > 1 then
								l_s := (screen_puts_mbyte (l_s, l_l, a_attr)) - 1
							else
								msg_screen_putchar ((l_s.item).to_integer_32, a_attr)
							end
						else
							l_pos := -1 + 43 -- goto _L___2
						end
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else: | _L___2:
						if l_t_col.item = 0 then
							l_t_s := l_s
						end
						l_t_col.item := l_t_col.item + l_cw
						l_s := l_s + (l_l - 1)
				when 44 then -- if done | if done | if done | if done | if done
						l_s := l_s + 1
				when 45 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 46 then -- loop done
					if not l_return then
						l_break := False
						l_continue := False
						if l_t_col.item > 0 then
							t_puts (l_t_col, l_t_s, l_s, a_attr)
						end
						if ((create {P_OPTION_STATIC}).p_more.item.item).to_boolean then
							if not a_recurse___2.to_boolean then
								store_sb_text (l_sb_str, l_s, a_attr, l_sb_col, 0)
							end
						end
						msg_check
					end
				when 47 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	msg_scroll_up
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_GUI_STATIC}).gui_undraw_cursor
			end
			(create {P_SCREEN_STATIC}).screen_del_lines (0, 0, 1, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32, 1, create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)).do_nothing
			if not ((create {P_SCREEN_STATIC}).can_clear (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))).to_boolean then
				(create {P_SCREEN_STATIC}).screen_fill (((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 1, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32, 0, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32, (' ').code, (' ').code, 0)
				if ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[((((create {P_GLOBALS_STATIC}).LineOffset.item[((create {P_GLOBALS_STATIC}).Rows.item.item - 2)]).to_natural_32 + ((create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 65_535 then
					(create {P_SCREEN_STATIC}).screen_fill (((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 2, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 1, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32 - 1, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32, (' ').code, (' ').code, 0)
				end
			end
		end

	inc_msg_scrolled
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tofree: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
		do
			if (((create {P_EVAL_STATIC}).get_vim_var_str (44)).item).to_integer_32 = 0 then
				l_p___0 := (create {P_GLOBALS_STATIC}).sourcing_name.item
				l_tofree := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				if l_p___0.is_void then
					l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Unknown"))))
				else
					l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32 + 40
					l_tofree := (create {P_MISC2_STATIC}).alloc (l_len.to_natural_32)
					if not l_tofree.is_void then
						vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_tofree), l_len.to_natural_32, (gettext (ce_string ("%%s line %%ld"))), l_p___0, (create {P_GLOBALS_STATIC}).sourcing_lnum.item]).do_nothing
						l_p___0 := l_tofree
					end
				end
				(create {P_EVAL_STATIC}).set_vim_var_string (44, l_p___0, -1);
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tofree))
			end
			(create {P_GLOBALS_STATIC}).msg_scrolled.item := (create {P_GLOBALS_STATIC}).msg_scrolled.item + 1
		end

	store_sb_text (a_sb_str: CE_POINTER [CE_POINTER [NATURAL_8]]; a_s: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32; a_sb_col: CE_POINTER [INTEGER_32]; a_finish: INTEGER_32)
		require
			not a_sb_str.is_void
			not a_sb_col.is_void
		local
			l_mp: CE_POINTER [PD_MSGCHUNK_S]
		do
			if do_clear_sb_text.item.to_boolean then
				clear_sb_text
				do_clear_sb_text.item := 0
			end
			if (a_s.c_pointer.to_integer_32).to_natural_32 > ((a_sb_str.item).c_pointer.to_integer_32).to_natural_32 then
				l_mp := create {CE_CLASS_POINTER [PD_MSGCHUNK_S]}.make_cast (((create {P_MISC2_STATIC}).alloc ((((create {PD_MSGCHUNK_S}.make).structure_size.to_natural_32 + (a_s.distance ((a_sb_str.item))).to_natural_32).to_integer_32).to_natural_32)))
				if not l_mp.is_void then
					l_mp.item.sb_eol := a_finish.to_integer_8
					l_mp.item.sb_msg_col := a_sb_col.item
					l_mp.item.sb_attr := a_attr;
					(create {P_MISC2_STATIC}).vim_strncpy (l_mp.item.sb_text, a_sb_str.item, (a_s.distance ((a_sb_str.item))).to_natural_32)
					if last_msgchunk.item.is_void then
						last_msgchunk.item := l_mp
						l_mp.item.sb_prev := create {CE_CLASS_POINTER [PD_MSGCHUNK_S]}.make_shared (default_pointer)
					else
						l_mp.item.sb_prev := last_msgchunk.item
						last_msgchunk.item.item.sb_next := l_mp
						last_msgchunk.item := l_mp
					end
					l_mp.item.sb_next := create {CE_CLASS_POINTER [PD_MSGCHUNK_S]}.make_shared (default_pointer)
				end
			elseif a_finish.to_boolean then
				if not last_msgchunk.item.is_void then
					last_msgchunk.item.item.sb_eol := (1).to_integer_8
				end
			end
			a_sb_str.item := a_s
			a_sb_col.item := 0
		end

	may_clear_sb_text
		do
			do_clear_sb_text.item := 1
		end

	clear_sb_text
		local
			l_mp: CE_POINTER [PD_MSGCHUNK_S]
		do
			from
			until
				last_msgchunk.item.is_void
			loop
				l_mp := last_msgchunk.item.item.sb_prev;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (last_msgchunk.item))
				last_msgchunk.item := l_mp
			end
		end

	msg_sb_start (a_mps: CE_POINTER [PD_MSGCHUNK_S]): CE_POINTER [PD_MSGCHUNK_S]
		local
			l_mp: CE_POINTER [PD_MSGCHUNK_S]
			l_break: BOOLEAN
		do
			l_mp := a_mps
			from
			until
				(l_break)
			loop
				l_break := False
				if not l_mp.is_void then
					if not (l_mp.item.sb_prev).is_void then
						if ((l_mp.item.sb_prev).item.sb_eol).to_boolean then
							l_break := True
						end
					else
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_mp := l_mp.item.sb_prev
				end
			end
			l_break := False
			Result := l_mp
		end

	disp_sb_line (a_row: INTEGER_32; a_smp: CE_POINTER [PD_MSGCHUNK_S]): CE_POINTER [PD_MSGCHUNK_S]
		require
			not a_smp.is_void
		local
			l_mp: CE_POINTER [PD_MSGCHUNK_S]
			l_p___0: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			l_mp := a_smp
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_GLOBALS_STATIC}).msg_row.item := a_row;
				(create {P_GLOBALS_STATIC}).msg_col.item := l_mp.item.sb_msg_col
				l_p___0 := l_mp.item.sb_text
				if (l_p___0.item).to_integer_32 = 10 then
					l_p___0 := l_p___0 + 1
				end
				msg_puts_display (l_p___0, -1, l_mp.item.sb_attr, 1)
				if (l_mp.item.sb_eol).to_boolean then
					l_break := True
				elseif (l_mp.item.sb_next).is_void then
					l_break := True
				end
				if not (l_break) then
					l_mp := l_mp.item.sb_next
				end
			end
			l_break := False
			Result := (l_mp.item.sb_next)
		end

	t_puts (a_t_col: CE_POINTER [INTEGER_32]; a_t_s, a_s: CE_POINTER [NATURAL_8]; a_attr: INTEGER_32)
		require
			not a_t_col.is_void
		do
			(create {P_GLOBALS_STATIC}).msg_didout.item := 1;
			(create {P_SCREEN_STATIC}).screen_puts_len (a_t_s, a_s.distance (a_t_s), (create {P_GLOBALS_STATIC}).msg_row.item, (create {P_GLOBALS_STATIC}).msg_col.item, a_attr);
			(create {P_GLOBALS_STATIC}).msg_col.item := (create {P_GLOBALS_STATIC}).msg_col.item + (a_t_col.item)
			a_t_col.item := 0
			if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
				if ((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_MBYTE_STATIC}).utf_ptr2char (a_t_s)))).to_boolean then
					(create {P_GLOBALS_STATIC}).msg_col.item := (create {P_GLOBALS_STATIC}).msg_col.item - 1
				end
			end
			if ((create {P_GLOBALS_STATIC}).msg_col.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item then
				(create {P_GLOBALS_STATIC}).msg_col.item := 0;
				(create {P_GLOBALS_STATIC}).msg_row.item := (create {P_GLOBALS_STATIC}).msg_row.item + 1
			end
		end

	msg_use_printf: INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (msg_check_screen).to_boolean then
				if ((create {P_TERM_STATIC}).swapping_screen).to_boolean then
					if not ((create {P_GLOBALS_STATIC}).termcap_active.item).to_boolean then
						l_tmp___1 := 1
					else
						l_tmp___1 := 0
					end
				else
					l_tmp___1 := 0
				end
			else
				l_tmp___1 := 1
			end
			Result := l_tmp___1
		end

	msg_puts_printf (a_str___1: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32)
		require
			not a_str___1.is_void
		local
			l_s: CE_POINTER [NATURAL_8]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<4>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_str___1
				when 1 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if (l_s.item).to_integer_32 /= 0 then
							if not (a_maxlen < 0) then
								if not (l_s.distance (a_str___1) < a_maxlen) then
									l_break := True
								end
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if not (((create {P_GLOBALS_STATIC}).silent_mode.item).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (create {P_OPTION_STATIC}).p_verbose.item.item /= 0 then
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_p___0 := l_buf___6 + 0
						if (l_s.item).to_integer_32 = 10 then
							if not ((create {P_GLOBALS_STATIC}).info_message.item).to_boolean then
								l_tmp := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp.item := (('%R').code).to_natural_8
							end
						end
						l_tmp___0 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___0.item := l_s.item
						l_p___0.item := (('%/0/').code).to_natural_8
						if ((create {P_GLOBALS_STATIC}).info_message.item).to_boolean then
							mch_msg (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))
						else
							mch_errmsg (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))
						end
				when 7 then
						if (l_s.item).to_integer_32 = 13 then
							(create {P_GLOBALS_STATIC}).msg_col.item := 0
						elseif (l_s.item).to_integer_32 = 10 then
							(create {P_GLOBALS_STATIC}).msg_col.item := 0
						else
							(create {P_GLOBALS_STATIC}).msg_col.item := (create {P_GLOBALS_STATIC}).msg_col.item + 1
						end
						l_s := l_s + 1
				when 8 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					l_break := False;
					(create {P_GLOBALS_STATIC}).msg_didout.item := 1
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_more_prompt (a_typed_char: INTEGER_32): INTEGER_32
		local
			l_used_typed_char: INTEGER_32
			l_oldState: INTEGER_32
			l_c: INTEGER_32
			l_retval: INTEGER_32
			l_scroll: INTEGER_32
			l_mp_last: CE_POINTER [PD_MSGCHUNK_S]
			l_mp: CE_POINTER [PD_MSGCHUNK_S]
			l_i___0: INTEGER_32
			l_idx: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_used_typed_char := a_typed_char
					l_oldState := (create {P_GLOBALS_STATIC}).State.item
					l_retval := 0
					l_mp_last := create {CE_CLASS_POINTER [PD_MSGCHUNK_S]}.make_shared (default_pointer)
					if a_typed_char = 71 then
						l_mp_last := msg_sb_start (last_msgchunk.item)
						l_i___0 := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if l_i___0.to_integer_32 < (create {P_GLOBALS_STATIC}).Rows.item.item - 2 then
								if not l_mp_last.is_void then
									if (l_mp_last.item.sb_prev).is_void then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_mp_last := msg_sb_start (l_mp_last.item.sb_prev)
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
					end
					(create {P_GLOBALS_STATIC}).State.item := 768;
					(create {P_TERM_STATIC}).setmouse
					if a_typed_char = 0 then
						msg_moremsg (0)
					end
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 29 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						if l_used_typed_char /= 0 then
							l_c := l_used_typed_char
							l_used_typed_char := ('%/0/').code
						else
							l_c := (create {P_MISC1_STATIC}).get_keystroke
						end
						if l_c = -(250 + ((88).bit_shift_left (8))) then
							l_idx := ((create {P_MENU_STATIC}).get_menu_index ((create {P_GLOBALS_STATIC}).current_menu.item, 768))
							if l_idx = -1 then
								l_continue := True
							end
							if not (l_return or l_break or l_continue) then
								l_c := (((create {P_GLOBALS_STATIC}).current_menu.item.item.strings[l_idx]).item).to_integer_32
								if l_c /= 0 then
									if (((create {P_GLOBALS_STATIC}).current_menu.item.item.strings[l_idx])[1]).to_integer_32 /= 0 then
										(create {P_GETCHAR_STATIC}).ins_typebuf ((create {P_GLOBALS_STATIC}).current_menu.item.item.strings[l_idx] + 1, (create {P_GLOBALS_STATIC}).current_menu.item.item.noremap[l_idx], 0, 1, ((create {P_GLOBALS_STATIC}).current_menu.item.item.silent[l_idx]).to_integer_32).do_nothing
									end
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 16 -- skip if block
						end
				when 3 then -- if:
						l_scroll := 0
						inspect l_c -- switch 1 head
						when 8 then l_pos := -1 + 4
						when -25195 then l_pos := -1 + 4 -- -(107 + ((98).bit_shift_left (8)))
						when 107 then l_pos := -1 + 4
						when -30059 then l_pos := -1 + 4 -- -(107 + ((117).bit_shift_left (8)))
						when 13 then l_pos := -1 + 5
						when 10 then l_pos := -1 + 5
						when 106 then l_pos := -1 + 5
						when -25707 then l_pos := -1 + 5 -- -(107 + ((100).bit_shift_left (8)))
						when 117 then l_pos := -1 + 6
						when 100 then l_pos := -1 + 7
						when 98 then l_pos := -1 + 8
						when -20587 then l_pos := -1 + 8 -- -(107 + ((80).bit_shift_left (8)))
						when 32 then l_pos := -1 + 9
						when 102 then l_pos := -1 + 9
						when -20075 then l_pos := -1 + 9 -- -(107 + ((78).bit_shift_left (8)))
						when -11517 then l_pos := -1 + 9 -- -(253 + ((44).bit_shift_left (8)))
						when 103 then l_pos := -1 + 10
						when 71 then l_pos := -1 + 11
						when 58 then l_pos := -1 + 12
						when 113 then l_pos := -1 + 13
						when 3 then l_pos := -1 + 13
						when 27 then l_pos := -1 + 13
						when 25 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 4 then -- switch 1, case 8 | switch 1, case -(107 + (98 << 8)) | switch 1, case 107 | switch 1, case -(107 + (117 << 8))
						l_scroll := -1
						l_pos := -1 + 16 -- switch 1; break
				when 5 then -- switch 1, case 13 | switch 1, case 10 | switch 1, case 106 | switch 1, case -(107 + (100 << 8))
						l_scroll := 1
						l_pos := -1 + 16 -- switch 1; break
				when 6 then -- switch 1, case 117
						l_scroll := (-((create {P_GLOBALS_STATIC}).Rows.item.item // 2)).to_integer_32
						l_pos := -1 + 16 -- switch 1; break
				when 7 then -- switch 1, case 100
						l_scroll := ((create {P_GLOBALS_STATIC}).Rows.item.item // 2).to_integer_32
						l_pos := -1 + 16 -- switch 1; break
				when 8 then -- switch 1, case 98 | switch 1, case -(107 + (80 << 8))
						l_scroll := (-((create {P_GLOBALS_STATIC}).Rows.item.item - 1)).to_integer_32
						l_pos := -1 + 16 -- switch 1; break
				when 9 then -- switch 1, case 32 | switch 1, case 102 | switch 1, case -(107 + (78 << 8)) | switch 1, case -(253 + (44 << 8))
						l_scroll := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
						l_pos := -1 + 16 -- switch 1; break
				when 10 then -- switch 1, case 103
						l_scroll := -999_999
						l_pos := -1 + 16 -- switch 1; break
				when 11 then -- switch 1, case 71
						l_scroll := 999_999;
						(create {P_GLOBALS_STATIC}).lines_left.item := 999_999
						l_pos := -1 + 16 -- switch 1; break
				when 12 then -- switch 1, case 58
						if not confirm_msg_used.item.to_boolean then
							(create {P_GETCHAR_STATIC}).typeahead_noflush ((':').code);
							(create {P_GLOBALS_STATIC}).cmdline_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32;
							(create {P_GLOBALS_STATIC}).skip_redraw.item := 1;
							(create {P_GLOBALS_STATIC}).need_wait_return.item := 0
						end
				when 13 then -- switch 1, case 113 | switch 1, case 3 | switch 1, case 27
						if confirm_msg_used.item.to_boolean then
							l_retval := 1
						else
							(create {P_GLOBALS_STATIC}).got_int.item := 1;
							(create {P_GLOBALS_STATIC}).quit_more.item := 1
						end
						(create {P_GLOBALS_STATIC}).lines_left.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
						l_pos := -1 + 16 -- switch 1; break
				when 14 then -- switch 1, case 25
						if ((create {P_GLOBALS_STATIC}).clip_star.item.item.state).to_integer_32 = 2 then
							(create {P_UI_STATIC}).clip_copy_modeless_selection (1)
						end
						l_continue := True
				when 15 then -- switch 1, default:
						if not (l_return or l_break or l_continue) then
							msg_moremsg (1)
							l_continue := True
						end
				when 16 then -- switch 1, done: | if done
						if not (not (l_return or l_break or l_continue) and then (l_scroll /= 0)) then
							l_pos := -1 + 28 -- skip if block
						end
				when 17 then -- if:
						if not (l_scroll < 0) then
							l_pos := -1 + 26 -- skip if block
						end
				when 18 then -- if:
						if l_mp_last.is_void then
							l_mp := msg_sb_start (last_msgchunk.item)
						elseif not (l_mp_last.item.sb_prev).is_void then
							l_mp := msg_sb_start (l_mp_last.item.sb_prev)
						else
							l_mp := create {CE_CLASS_POINTER [PD_MSGCHUNK_S]}.make_shared (default_pointer)
						end
						l_i___0 := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if l_i___0.to_integer_32 < (create {P_GLOBALS_STATIC}).Rows.item.item - 2 then
								if not l_mp.is_void then
									if (l_mp.item.sb_prev).is_void then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_mp := msg_sb_start (l_mp.item.sb_prev)
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						if l_mp.is_void then
							l_pos := -1 + 25 -- skip if block
						end
				when 19 then -- if:
						if (l_mp.item.sb_prev).is_void then
							l_pos := -1 + 25 -- skip if block
						end
				when 20 then -- if:
						l_i___0 := 0
						from
						until
							not (not (l_break) and then (l_i___0 > l_scroll))
						loop
							l_break := False
							if l_mp.is_void then
								l_break := True
							elseif (l_mp.item.sb_prev).is_void then
								l_break := True
							end
							if not (l_break) then
								l_mp := msg_sb_start (l_mp.item.sb_prev)
								if l_mp_last.is_void then
									l_mp_last := msg_sb_start (last_msgchunk.item)
								else
									l_mp_last := msg_sb_start (l_mp_last.item.sb_prev)
								end
								l_i___0 := l_i___0 - 1
							end
						end
						l_break := False
						if l_scroll /= -1 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if ((create {P_SCREEN_STATIC}).screen_ins_lines (0, 0, 1, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32, create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))) = 1 then
							disp_sb_line (0, l_mp).do_nothing
						else
							l_pos := -1 + 23 -- goto _L
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else: | _L:;
						(create {P_SCREEN_STATIC}).screenclear
						l_i___0 := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if not l_mp.is_void then
								if not (l_i___0.to_integer_32 < (create {P_GLOBALS_STATIC}).Rows.item.item - 1) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_mp := disp_sb_line (l_i___0, l_mp);
								(create {P_GLOBALS_STATIC}).msg_scrolled.item := (create {P_GLOBALS_STATIC}).msg_scrolled.item + 1
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
				when 24 then
						l_scroll := 0
				when 25 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						from
						until
							(l_break)
						loop
							l_break := False
							if l_scroll > 0 then
								if l_mp_last.is_void then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								msg_scroll_up
								inc_msg_scrolled;
								(create {P_SCREEN_STATIC}).screen_fill (((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 2, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 1, 0, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32, (' ').code, (' ').code, 0)
								l_mp_last := disp_sb_line (((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 2, l_mp_last)
								l_scroll := l_scroll - 1
							end
						end
						l_break := False
				when 27 then -- if done
						if l_scroll <= 0 then
							(create {P_SCREEN_STATIC}).screen_fill (((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 1, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32, 0, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32, (' ').code, (' ').code, 0)
							msg_moremsg (0)
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							(create {P_GLOBALS_STATIC}).lines_left.item := l_scroll
						end
				when 28 then -- if done
						if not (l_return or l_break or l_continue) then
							l_break := True
						end
						if (not l_return and not l_break) then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 29 then -- loop done
					l_break := False
					l_continue := False;
					(create {P_SCREEN_STATIC}).screen_fill (((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 1, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32, 0, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32, (' ').code, (' ').code, 0);
					(create {P_GLOBALS_STATIC}).State.item := l_oldState;
					(create {P_TERM_STATIC}).setmouse
					if ((create {P_GLOBALS_STATIC}).quit_more.item).to_boolean then
						(create {P_GLOBALS_STATIC}).msg_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32;
						(create {P_GLOBALS_STATIC}).msg_col.item := 0
					end
					Result := l_retval
				when 30 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mch_errmsg (a_str___1: CE_POINTER [INTEGER_8])
		require
			not a_str___1.is_void
		local
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			if (isatty (2)).to_boolean then
				Io.error.put_string (eif_string (a_str___1))
				l_return := True
			elseif not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				if not ((create {P_GUI_STATIC}).gui.item.item.starting).to_boolean then
					Io.error.put_string (eif_string (a_str___1))
					l_return := True
				end
			end
			if not l_return then
				(create {P_GLOBALS_STATIC}).emsg_on_display.item := 0
				l_len := (strlen (a_str___1)).to_integer_32 + 1
				if (create {P_GLOBALS_STATIC}).error_ga.item.item.ga_growsize = 0 then
					(create {P_GLOBALS_STATIC}).error_ga.item.item.ga_growsize := 80;
					(create {P_GLOBALS_STATIC}).error_ga.item.item.ga_itemsize := 1
				end
				if (((create {P_GLOBALS_STATIC}).error_ga.item).item.ga_grow (l_len)) = 1 then
					memmove (create {CE_VOID_POINTER}.make_cast ((create {CE_NATURAL_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).error_ga.item.item.ga_data) + (create {P_GLOBALS_STATIC}).error_ga.item.item.ga_len)), create {CE_VOID_POINTER}.make_cast (a_str___1), l_len.to_natural_32).do_nothing
					l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).error_ga.item.item.ga_data) + (create {P_GLOBALS_STATIC}).error_ga.item.item.ga_len
					from
					until
						(l_break)
					loop
						l_break := False
						l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (l_p___0, ('%R').code)
						if l_p___0.is_void then
							l_break := True
						end
						if not (l_break) then
							l_p___0.item := ((' ').code).to_natural_8
						end
					end
					l_break := False
					l_len := l_len - 1;
					(create {P_GLOBALS_STATIC}).error_ga.item.item.ga_len := (create {P_GLOBALS_STATIC}).error_ga.item.item.ga_len + l_len
				end
			end
		end

	mch_msg (a_str___1: CE_POINTER [INTEGER_8])
		require
			not a_str___1.is_void
		local
			l_return: BOOLEAN
		do
			if (isatty (2)).to_boolean then
				Io.put_string (eif_string (a_str___1))
				l_return := True
			elseif not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				if not ((create {P_GUI_STATIC}).gui.item.item.starting).to_boolean then
					Io.put_string (eif_string (a_str___1))
					l_return := True
				end
			end
			if not l_return then
				mch_errmsg (a_str___1)
			end
		end

	msg_screen_putchar (a_c, a_attr: INTEGER_32)
		do
			(create {P_GLOBALS_STATIC}).msg_didout.item := 1;
			(create {P_SCREEN_STATIC}).screen_putchar (a_c, (create {P_GLOBALS_STATIC}).msg_row.item, (create {P_GLOBALS_STATIC}).msg_col.item, a_attr);
			(create {P_GLOBALS_STATIC}).msg_col.item := (create {P_GLOBALS_STATIC}).msg_col.item + 1
			if ((create {P_GLOBALS_STATIC}).msg_col.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item then
				(create {P_GLOBALS_STATIC}).msg_col.item := 0;
				(create {P_GLOBALS_STATIC}).msg_row.item := (create {P_GLOBALS_STATIC}).msg_row.item + 1
			end
		end

	msg_moremsg (a_full: INTEGER_32)
		local
			l_attr: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
		do
			l_s := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("-- More --"))))
			l_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[7];
			(create {P_SCREEN_STATIC}).screen_puts (l_s, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 1, 0, l_attr)
			if a_full.to_boolean then
				l_tmp___0 := (create {P_CHARSET_STATIC}).vim_strsize (l_s);
				(create {P_SCREEN_STATIC}).screen_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string (" SPACE/d/j: screen/page/line down, b/u/k: up, q: quit ")))), ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 1, l_tmp___0, l_attr)
			end
		end

	repeat_message
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (create {P_GLOBALS_STATIC}).State.item /= 768 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						msg_moremsg (1);
						(create {P_GLOBALS_STATIC}).msg_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 3 then -- else:
						if (create {P_GLOBALS_STATIC}).State.item /= 2_048 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						display_confirm_msg;
						(create {P_GLOBALS_STATIC}).msg_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 6 then -- else:
						if (create {P_GLOBALS_STATIC}).State.item /= 1_536 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:;
						(create {P_SCREEN_STATIC}).windgoto ((create {P_GLOBALS_STATIC}).msg_row.item, (create {P_GLOBALS_STATIC}).msg_col.item)
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 9 then -- else:
						if (create {P_GLOBALS_STATIC}).State.item /= 513 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 12 then -- else:
						if (create {P_GLOBALS_STATIC}).State.item /= 1_024 then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L:
						if ((create {P_GLOBALS_STATIC}).msg_row.item).to_integer_32 = (create {P_GLOBALS_STATIC}).Rows.item.item - 1 then
							(create {P_GLOBALS_STATIC}).msg_didout.item := 0;
							(create {P_GLOBALS_STATIC}).msg_col.item := 0
							msg_clr_eos
						end
						hit_return_msg;
						(create {P_GLOBALS_STATIC}).msg_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
				when 14 then -- if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	msg_check_screen: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if not ((create {P_GLOBALS_STATIC}).full_screen.item).to_boolean then
				Result := 0
				l_return := True
			elseif not ((create {P_SCREEN_STATIC}).screen_valid (0)).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				if ((create {P_GLOBALS_STATIC}).msg_row.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Rows.item.item then
					(create {P_GLOBALS_STATIC}).msg_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
				end
				if ((create {P_GLOBALS_STATIC}).msg_col.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item then
					(create {P_GLOBALS_STATIC}).msg_col.item := ((create {P_GLOBALS_STATIC}).Columns.item.item - 1).to_integer_32
				end
				Result := 1
			end
		end

	msg_clr_eos
		do
			if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
				msg_clr_eos_force
			end
		end

	msg_clr_eos_force
		do
			if (msg_use_printf).to_boolean then
				if ((create {P_GLOBALS_STATIC}).full_screen.item).to_boolean then
					if (((create {P_TERM_STATIC}).term_strings.item[8]).item).to_boolean then
						(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[8])
					elseif (((create {P_TERM_STATIC}).term_strings.item[1]).item).to_boolean then
						(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[1])
					end
				end
			else
				(create {P_SCREEN_STATIC}).screen_fill ((create {P_GLOBALS_STATIC}).msg_row.item, (create {P_GLOBALS_STATIC}).msg_row.item + 1, (create {P_GLOBALS_STATIC}).msg_col.item, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32, (' ').code, (' ').code, 0);
				(create {P_SCREEN_STATIC}).screen_fill ((create {P_GLOBALS_STATIC}).msg_row.item + 1, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32, 0, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32, (' ').code, (' ').code, 0)
			end
		end

	msg_clr_cmdline
		do
			(create {P_GLOBALS_STATIC}).msg_row.item := (create {P_GLOBALS_STATIC}).cmdline_row.item;
			(create {P_GLOBALS_STATIC}).msg_col.item := 0
			msg_clr_eos_force
		end

	msg_end: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if not ((create {P_GLOBALS_STATIC}).exiting.item).to_boolean then
				if ((create {P_GLOBALS_STATIC}).need_wait_return.item).to_boolean then
					if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (8)).to_boolean then
						wait_return (0)
						Result := 0
						l_return := True
					end
				end
			end
			if not l_return then
				(create {P_TERM_STATIC}).out_flush
				Result := 1
			end
		end

	msg_check
		do
			if ((create {P_GLOBALS_STATIC}).msg_row.item).to_integer_32 = (create {P_GLOBALS_STATIC}).Rows.item.item - 1 then
				if (create {P_GLOBALS_STATIC}).msg_col.item >= (create {P_GLOBALS_STATIC}).sc_col.item then
					(create {P_GLOBALS_STATIC}).need_wait_return.item := 1;
					(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
				end
			end
		end

	redir_write (a_str___1: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			l_s := a_str___1
			if ((create {P_GLOBALS_STATIC}).redir_off.item).to_boolean then
				l_return := True
			end
			if not l_return then
				if ((create {P_OPTION_STATIC}).p_vfile.item.item.item).to_integer_32 /= 0 then
					verbose_write (l_s, a_maxlen)
				end
				if (redirecting).to_boolean then
					if (l_s.item).to_integer_32 /= 10 then
						if (l_s.item).to_integer_32 /= 13 then
							from
							until
								not (cur_col.item < (create {P_GLOBALS_STATIC}).msg_col.item)
							loop
								if ((create {P_GLOBALS_STATIC}).redir_reg.item).to_boolean then
									(create {P_OPS_STATIC}).write_reg_contents ((create {P_GLOBALS_STATIC}).redir_reg.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")), -1, 1)
								elseif ((create {P_GLOBALS_STATIC}).redir_vname.item).to_boolean then
									(create {P_EVAL_STATIC}).var_redir_str (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")), -1)
								elseif (not ((create {P_GLOBALS_STATIC}).redir_fd.item).is_void) then
									fputs (ce_string (" "), (create {P_GLOBALS_STATIC}).redir_fd.item).do_nothing
								end
								cur_col.item := cur_col.item + 1
							end
						end
					end
					if ((create {P_GLOBALS_STATIC}).redir_reg.item).to_boolean then
						(create {P_OPS_STATIC}).write_reg_contents ((create {P_GLOBALS_STATIC}).redir_reg.item, l_s, a_maxlen, 1)
					end
					if ((create {P_GLOBALS_STATIC}).redir_vname.item).to_boolean then
						(create {P_EVAL_STATIC}).var_redir_str (l_s, a_maxlen)
					end
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_s.item).to_integer_32 /= 0 then
							if not (a_maxlen < 0) then
								if not (l_s.distance (a_str___1) < a_maxlen) then
									l_break := True
								end
							end
						else
							l_break := True
						end
						if not (l_break) then
							if not ((create {P_GLOBALS_STATIC}).redir_reg.item).to_boolean then
								if not ((create {P_GLOBALS_STATIC}).redir_vname.item).to_boolean then
									if not ((create {P_GLOBALS_STATIC}).redir_fd.item).is_void then
										IO_putc ((l_s.item).to_integer_32, (create {P_GLOBALS_STATIC}).redir_fd.item).do_nothing
									end
								end
							end
							if (l_s.item).to_integer_32 = 13 then
								cur_col.item := 0
							elseif (l_s.item).to_integer_32 = 10 then
								cur_col.item := 0
							elseif (l_s.item).to_integer_32 = 9 then
								cur_col.item := cur_col.item + (8 - cur_col.item \\ 8)
							else
								cur_col.item := cur_col.item + 1
							end
							l_s := l_s + 1
						end
					end
					l_break := False
					if (create {P_GLOBALS_STATIC}).msg_silent.item /= 0 then
						(create {P_GLOBALS_STATIC}).msg_col.item := cur_col.item
					end
				end
			end
		end

	redirecting: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if not ((create {P_GLOBALS_STATIC}).redir_fd.item).is_void then
				l_tmp := 1
			elseif ((create {P_GLOBALS_STATIC}).redir_reg.item).to_boolean then
				l_tmp := 1
			elseif ((create {P_GLOBALS_STATIC}).redir_vname.item).to_boolean then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	verbose_enter
		do
			if ((create {P_OPTION_STATIC}).p_vfile.item.item.item).to_integer_32 /= 0 then
				(create {P_GLOBALS_STATIC}).msg_silent.item := (create {P_GLOBALS_STATIC}).msg_silent.item + 1
			end
		end

	verbose_leave
		do
			if ((create {P_OPTION_STATIC}).p_vfile.item.item.item).to_integer_32 /= 0 then
				(create {P_GLOBALS_STATIC}).msg_silent.item := (create {P_GLOBALS_STATIC}).msg_silent.item - 1
				if (create {P_GLOBALS_STATIC}).msg_silent.item < 0 then
					(create {P_GLOBALS_STATIC}).msg_silent.item := 0
				end
			end
		end

	verbose_enter_scroll
		do
			if ((create {P_OPTION_STATIC}).p_vfile.item.item.item).to_integer_32 /= 0 then
				(create {P_GLOBALS_STATIC}).msg_silent.item := (create {P_GLOBALS_STATIC}).msg_silent.item + 1
			else
				(create {P_GLOBALS_STATIC}).msg_scroll.item := 1
			end
		end

	verbose_leave_scroll
		do
			if ((create {P_OPTION_STATIC}).p_vfile.item.item.item).to_integer_32 /= 0 then
				(create {P_GLOBALS_STATIC}).msg_silent.item := (create {P_GLOBALS_STATIC}).msg_silent.item - 1
				if (create {P_GLOBALS_STATIC}).msg_silent.item < 0 then
					(create {P_GLOBALS_STATIC}).msg_silent.item := 0
				end
			else
				(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item
			end
		end

	verbose_stop
		do
			if not verbose_fd.item.is_void then
				fclose (verbose_fd.item).do_nothing
				verbose_fd.item := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
			end
			verbose_did_open.item := 0
		end

	verbose_open: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if verbose_fd.item.is_void then
				if not verbose_did_open.item.to_boolean then
					verbose_did_open.item := 1
					verbose_fd.item := fopen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_vfile.item.item), ce_string ("a"))
					if verbose_fd.item.is_void then
						emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_notopen.item))))), (create {P_OPTION_STATIC}).p_vfile.item.item).do_nothing
						Result := 0
						l_return := True
					end
				end
			end
			if not l_return then
				Result := 1
			end
		end

	verbose_write (a_str___1: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32)
		local
			l_s: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			l_s := a_str___1
			if verbose_fd.item.is_void then
				verbose_open.do_nothing
			end
			if not verbose_fd.item.is_void then
				if (l_s.item).to_integer_32 /= 10 then
					if (l_s.item).to_integer_32 /= 13 then
						from
						until
							not (cur_col___0.item < (create {P_GLOBALS_STATIC}).msg_col.item)
						loop
							fputs (ce_string (" "), verbose_fd.item).do_nothing
							cur_col___0.item := cur_col___0.item + 1
						end
					end
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_s.item).to_integer_32 /= 0 then
						if not (a_maxlen < 0) then
							if not (l_s.distance (a_str___1) < a_maxlen) then
								l_break := True
							end
						end
					else
						l_break := True
					end
					if not (l_break) then
						IO_putc ((l_s.item).to_integer_32, verbose_fd.item).do_nothing
						if (l_s.item).to_integer_32 = 13 then
							cur_col___0.item := 0
						elseif (l_s.item).to_integer_32 = 10 then
							cur_col___0.item := 0
						elseif (l_s.item).to_integer_32 = 9 then
							cur_col___0.item := cur_col___0.item + (8 - cur_col___0.item \\ 8)
						else
							cur_col___0.item := cur_col___0.item + 1
						end
						l_s := l_s + 1
					end
				end
				l_break := False
			end
		end

	give_warning (a_message: CE_POINTER [NATURAL_8]; a_hl: INTEGER_32)
		local
			l_return: BOOLEAN
		do
			if (create {P_GLOBALS_STATIC}).msg_silent.item /= 0 then
				l_return := True
			end
			if not l_return then
				(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item + 1;
				(create {P_EVAL_STATIC}).set_vim_var_string (4, a_message, -1);
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).keep_msg.item));
				(create {P_GLOBALS_STATIC}).keep_msg.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				if a_hl.to_boolean then
					(create {P_GLOBALS_STATIC}).keep_msg_attr.item := (create {P_GLOBALS_STATIC}).highlight_attr.item[17]
				else
					(create {P_GLOBALS_STATIC}).keep_msg_attr.item := 0
				end
				if (msg_attr (a_message, (create {P_GLOBALS_STATIC}).keep_msg_attr.item)).to_boolean then
					if (create {P_GLOBALS_STATIC}).msg_scrolled.item = 0 then
						set_keep_msg (a_message, (create {P_GLOBALS_STATIC}).keep_msg_attr.item)
					end
				end
				(create {P_GLOBALS_STATIC}).msg_didout.item := 0;
				(create {P_GLOBALS_STATIC}).msg_nowait.item := 1;
				(create {P_GLOBALS_STATIC}).msg_col.item := 0;
				(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1
			end
		end

	msg_advance (a_col: INTEGER_32)
		local
			l_col: INTEGER_32
			l_return: BOOLEAN
		do
			l_col := a_col
			if (create {P_GLOBALS_STATIC}).msg_silent.item /= 0 then
				(create {P_GLOBALS_STATIC}).msg_col.item := l_col
				l_return := True
			end
			if not l_return then
				if l_col.to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item then
					l_col := ((create {P_GLOBALS_STATIC}).Columns.item.item - 1).to_integer_32
				end
				from
				until
					not ((create {P_GLOBALS_STATIC}).msg_col.item < l_col)
				loop
					msg_putchar ((' ').code)
				end
			end
		end

	do_dialog (a_type: INTEGER_32; a_title, a_message, a_buttons: CE_POINTER [NATURAL_8]; a_dfltbutton: INTEGER_32; a_textfield: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_oldState: INTEGER_32
			l_retval: INTEGER_32
			l_hotkeys: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_i___0: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := 0
					if ((create {P_GLOBALS_STATIC}).silent_mode.item).to_boolean then
						Result := a_dfltbutton
						l_return := True
					end
					if not l_return and then (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
						if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_go.item.item, ('c').code)).is_void then
							l_c := (create {P_GUI_GTK_STATIC}).gui_mch_dialog (a_type, a_title, a_message, a_buttons, a_dfltbutton, a_textfield);
							(create {P_GLOBALS_STATIC}).need_wait_return.item := 0;
							(create {P_GLOBALS_STATIC}).emsg_on_display.item := 0;
							(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item;
							(create {P_TERM_STATIC}).out_flush;
							(create {P_GUI_GTK_X11_STATIC}).gui_mch_update
							Result := l_c
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_oldState := (create {P_GLOBALS_STATIC}).State.item;
						(create {P_GLOBALS_STATIC}).State.item := 2_048;
						(create {P_TERM_STATIC}).setmouse;
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item + 1
						l_hotkeys := msg_show_console_dialog (a_message, a_buttons, a_dfltbutton)
						if l_hotkeys.is_void then
							l_pos := -1 + 11 -- skip if block
						end
				when 2 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						l_c := (create {P_MISC1_STATIC}).get_keystroke
						inspect l_c -- switch 1 head
						when 13 then l_pos := -1 + 4
						when 10 then l_pos := -1 + 4
						when 3 then l_pos := -1 + 5
						when 27 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 4 then -- switch 1, case 13 | switch 1, case 10
						l_retval := a_dfltbutton
						l_pos := -1 + 9 -- switch 1; break
				when 5 then -- switch 1, case 3 | switch 1, case 27
						l_retval := 0
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, default:
						if l_c < 0 then
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_c := (create {P_CHARSET_STATIC}).vim_tolower (l_c)
						l_retval := 1
						l_i___0 := 0
						from
						until
							not (not (l_break) and then ((l_hotkeys[l_i___0]).to_boolean))
						loop
							l_break := False
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								if ((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_hotkeys + l_i___0])) = l_c then
									l_break := True
								end
								if not (l_break) then
									l_i___0 := l_i___0 + (((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_hotkeys + l_i___0])) - 1)
								end
							elseif (l_hotkeys[l_i___0]).to_integer_32 = l_c then
								l_break := True
							end
							if not (l_break) then
								l_retval := l_retval + 1
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						if (l_hotkeys[l_i___0]).to_boolean then
							l_pos := -1 + 9 -- switch 1; break
						end
				when 8 then
						l_continue := True
				when 9 then -- switch 1, done:
						if not (l_return or l_break or l_continue) then
							l_break := True
						end
						if (not l_return and not l_break) then
							
						end
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						l_break := False
						l_continue := False;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_hotkeys))
				when 11 then -- if done;
						(create {P_GLOBALS_STATIC}).State.item := l_oldState;
						(create {P_TERM_STATIC}).setmouse;
						(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1
						msg_end_prompt
						Result := l_retval
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	copy_char (a_from, a_to: CE_POINTER [NATURAL_8]; a_lowercase: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_c: INTEGER_32
		do
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				if a_lowercase.to_boolean then
					l_c := (create {P_CHARSET_STATIC}).vim_tolower (((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([a_from])))
					Result := ((create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([l_c, a_to]))
				else
					l_len := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([a_from])
					memmove (create {CE_VOID_POINTER}.make_cast (a_to), create {CE_VOID_POINTER}.make_cast (a_from), l_len.to_natural_32).do_nothing
					Result := l_len
				end
			else
				if a_lowercase.to_boolean then
					a_to.item := (tolower ((a_from.item).to_integer_32)).to_natural_8
				else
					a_to.item := a_from.item
				end
				Result := 1
			end
		end

	msg_show_console_dialog (a_message, a_buttons: CE_POINTER [NATURAL_8]; a_dfltbutton: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_dfltbutton: INTEGER_32
			l_len: INTEGER_32
			l_lenhotkey: INTEGER_32
			l_tmp: INTEGER_32
			l_hotk: CE_POINTER [NATURAL_8]
			l_msgp: CE_POINTER [NATURAL_8]
			l_hotkp: CE_POINTER [NATURAL_8]
			l_r: CE_POINTER [NATURAL_8]
			l_copy: INTEGER_32
			l_has_hotkey: CE_ARRAY [NATURAL_8]
			l_first_hotkey: INTEGER_32
			l_idx: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___4: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___12: INTEGER_32
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_tmp___15: NATURAL_32
			l_tmp___19: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_has_hotkey.make (<<30>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dfltbutton := a_dfltbutton
					l_len := 0
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp := 21
					else
						l_tmp := 1
					end
					l_lenhotkey := l_tmp
					l_hotk := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_msgp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_hotkp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_first_hotkey := 0
					l_has_hotkey[0] := (0).to_natural_8
					l_copy := 0
				when 1 then -- loop condition:
					if not (not (l_return) and then (l_copy <= 1)) then
						l_pos := -1 + 16 -- skip loop
					end
				when 2 then -- loop body:
						l_r := a_buttons
						l_idx := 0
				when 3 then -- loop condition:
						if not ((l_r.item).to_boolean) then
							l_pos := -1 + 15 -- skip loop
						end
				when 4 then -- loop body:
						if (l_r.item).to_integer_32 /= 10 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_copy.to_boolean then
							l_tmp___0 := l_msgp
							l_msgp := l_msgp + 1
							l_tmp___0.item := ((',').code).to_natural_8
							l_tmp___1 := l_msgp
							l_msgp := l_msgp + 1
							l_tmp___1.item := ((' ').code).to_natural_8
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_hotkp := l_hotkp + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_hotkp))).to_integer_32
							else
								l_hotkp := l_hotkp + 1
							end
							l_hotkp[(copy_char (l_r + 1, l_hotkp, 1))] := (('%/0/').code).to_natural_8
							if l_dfltbutton.to_boolean then
								l_dfltbutton := l_dfltbutton - 1
							end
							if l_idx < 29 then
								l_idx := l_idx + 1
								if not (l_has_hotkey[l_idx]).to_boolean then
									l_first_hotkey := 1
								end
							end
						else
							l_len := l_len + (3)
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___4 := 21
							else
								l_tmp___4 := 1
							end
							l_lenhotkey := l_lenhotkey + l_tmp___4
							if l_idx < 29 then
								l_idx := l_idx + 1
								l_has_hotkey[l_idx] := (0).to_natural_8
							end
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else:
						if (l_r.item).to_integer_32 /= 38 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if not (l_first_hotkey.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if: | _L:
						if (l_r.item).to_integer_32 = 38 then
							l_r := l_r + 1
						end
						l_first_hotkey := 0
						if l_copy.to_boolean then
							if (l_r.item).to_integer_32 = 38 then
								l_tmp___5 := l_msgp
								l_msgp := l_msgp + 1
								l_tmp___5.item := l_r.item
							else
								l_tmp___6 := l_msgp
								l_msgp := l_msgp + 1
								if l_dfltbutton = 1 then
									l_tmp___6.item := (('[').code).to_natural_8
								else
									l_tmp___6.item := (('(').code).to_natural_8
								end
								l_msgp := l_msgp + (copy_char (l_r, l_msgp, 0))
								l_tmp___8 := l_msgp
								l_msgp := l_msgp + 1
								if l_dfltbutton = 1 then
									l_tmp___8.item := ((']').code).to_natural_8
								else
									l_tmp___8.item := ((')').code).to_natural_8
								end
								l_hotkp[(copy_char (l_r, l_hotkp, 1))] := (('%/0/').code).to_natural_8
							end
						else
							l_len := l_len + 1
							if l_idx < 29 then
								l_has_hotkey[l_idx] := (1).to_natural_8
							end
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						if l_copy.to_boolean then
							l_msgp := l_msgp + (copy_char (l_r, l_msgp, 0))
						end
				when 14 then -- if done | if done
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___12 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_r]))
						else
							l_tmp___12 := 1
						end
						l_r := l_r + l_tmp___12
						l_pos := -1 + 3 -- back to loop condition
				when 15 then -- loop done
						if l_copy.to_boolean then
							l_tmp___13 := l_msgp
							l_msgp := l_msgp + 1
							l_tmp___13.item := ((':').code).to_natural_8
							l_tmp___14 := l_msgp
							l_msgp := l_msgp + 1
							l_tmp___14.item := ((' ').code).to_natural_8
							l_msgp.item := (('%/0/').code).to_natural_8
						else
							l_tmp___15 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_message))
							l_len := l_len + (((l_tmp___15 + {NATURAL_32} 2) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_buttons)))) + {NATURAL_32} 3).to_integer_32
							l_lenhotkey := l_lenhotkey + 1
							if not (l_has_hotkey[0]).to_boolean then
								l_first_hotkey := 1
								l_len := l_len + (2)
							end
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (confirm_msg.item))
							confirm_msg.item := (create {P_MISC2_STATIC}).alloc (l_len.to_natural_32)
							if confirm_msg.item.is_void then
								Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
								l_return := True
							end
							if not l_return then
								confirm_msg.item.item := (('%/0/').code).to_natural_8
								l_hotk := (create {P_MISC2_STATIC}).alloc (l_lenhotkey.to_natural_32)
								if l_hotk.is_void then
									Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
									l_return := True
								end
							end
							if not l_return then
								confirm_msg.item.item := (('%N').code).to_natural_8
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((confirm_msg.item + 1)), create {CE_INTEGER_8_POINTER}.make_cast (a_message)).do_nothing
								l_msgp := (confirm_msg.item + 1) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_message))).to_integer_32
								l_hotkp := l_hotk
								l_hotkp[(copy_char (a_buttons, l_hotkp, 1))] := (('%/0/').code).to_natural_8
								confirm_msg_tail.item := l_msgp
								l_tmp___19 := l_msgp
								l_msgp := l_msgp + 1
								l_tmp___19.item := (('%N').code).to_natural_8
							end
						end
						if not l_return then
							l_copy := l_copy + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 16 then -- loop done
					if not l_return then
						display_confirm_msg
						Result := l_hotk
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	display_confirm_msg
		do
			confirm_msg_used.item := confirm_msg_used.item + 1
			if not confirm_msg.item.is_void then
				msg_puts_attr (confirm_msg.item, (create {P_GLOBALS_STATIC}).highlight_attr.item[7])
			end
			confirm_msg_used.item := confirm_msg_used.item - 1
		end

	vim_dialog_yesno (a_type: INTEGER_32; a_title, a_message: CE_POINTER [NATURAL_8]; a_dflt: INTEGER_32): INTEGER_32
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_tmp := gettext (ce_string ("&Yes%N&No"))
			if a_title.is_void then
				l_tmp___1 := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Question"))))
			else
				l_tmp___1 := a_title
			end
			if (do_dialog (a_type, l_tmp___1, a_message, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp), a_dflt, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))) = 1 then
				Result := 2
				l_return := True
			end
			if not l_return then
				Result := 3
			end
		end

	do_browse (a_flags___0: INTEGER_32; a_title, a_dflt, a_ext, a_initdir, a_filter: CE_POINTER [NATURAL_8]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]): CE_POINTER [NATURAL_8]
		local
			l_title: CE_POINTER [NATURAL_8]
			l_dflt: CE_POINTER [NATURAL_8]
			l_initdir: CE_POINTER [NATURAL_8]
			l_filter: CE_POINTER [NATURAL_8]
			l_fname: CE_POINTER [NATURAL_8]
			l_tofree: CE_POINTER [NATURAL_8]
			l_save_browse: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_title := a_title
					l_dflt := a_dflt
					l_initdir := a_initdir
					l_filter := a_filter
					l_tofree := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_save_browse := (create {P_GLOBALS_STATIC}).cmdmod.item.item.browse;
					(create {P_GLOBALS_STATIC}).cmdmod.item.item.browse := 0
					if not (l_title.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if (l_title.item).to_integer_32 /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if ((a_flags___0).bit_and (2)).to_boolean then
							l_title := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Select Directory dialog"))))
						elseif ((a_flags___0).bit_and (1)).to_boolean then
							l_title := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Save File dialog"))))
						else
							l_title := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Open File dialog"))))
						end
				when 5 then -- if done
					if not (l_initdir.is_void) then
						l_pos := -1 + 8 -- skip if block
					end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L___0
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if (l_initdir.item).to_integer_32 /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L___0:
						if not l_dflt.is_void then
							if (l_dflt.item).to_integer_32 /= 0 then
								if ((create {P_OS_UNIX_STATIC}).mch_isdir (l_dflt)).to_boolean then
									l_initdir := l_dflt
									l_dflt := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								elseif not ((create {P_MISC1_STATIC}).gettail (l_dflt)).is_equal (l_dflt) then
									l_tofree := (create {P_MISC2_STATIC}).vim_strsave (l_dflt)
									if not l_tofree.is_void then
										l_initdir := l_tofree;
										((create {P_MISC1_STATIC}).gettail (l_initdir)).item := (('%/0/').code).to_natural_8
										l_dflt := (create {P_MISC1_STATIC}).gettail (l_dflt)
									end
								end
							end
						end
				when 10 then -- if done
					if not (l_initdir.is_void) then
						l_pos := -1 + 13 -- skip if block
					end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L___7
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 13 then -- else:
						if (l_initdir.item).to_integer_32 /= 0 then
							l_pos := -1 + 24 -- skip if block
						end
				when 14 then -- if: | _L___7:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_bsdir.item.item), ce_string ("last"))) = 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_bsdir.item.item), ce_string ("buffer"))) /= 0 then
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_bsdir.item.item), ce_string ("current"))) /= 0 then
								if ((create {P_OS_UNIX_STATIC}).mch_isdir ((create {P_OPTION_STATIC}).p_bsdir.item.item)).to_boolean then
									l_initdir := (create {P_OPTION_STATIC}).p_bsdir.item.item
								else
									l_pos := -1 + 17 -- goto _L___6
								end
							else
								l_pos := -1 + 17 -- goto _L___6
							end
						else
							l_pos := -1 + 17 -- goto _L___6
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 17 then -- else: | _L___6:
						if not (((a_flags___0).bit_and (1)).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L___3
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 20 then -- else:
						if ((create {P_OPTION_STATIC}).p_bsdir.item.item.item).to_integer_32 /= 98 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if: | _L___3:
						if not a_buf___6.is_void then
							if not (a_buf___6.item.b_ffname).is_void then
								if l_dflt.is_void then
									l_dflt := (create {P_MISC1_STATIC}).gettail ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname)
								elseif (l_dflt.item).to_integer_32 = 0 then
									l_dflt := (create {P_MISC1_STATIC}).gettail ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname)
								end
								l_tofree := (create {P_MISC2_STATIC}).vim_strsave ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname)
								if not l_tofree.is_void then
									l_initdir := l_tofree;
									((create {P_MISC1_STATIC}).gettail (l_initdir)).item := (('%/0/').code).to_natural_8
								end
							else
								l_pos := -1 + 23 -- goto _L___2
							end
						else
							l_pos := -1 + 23 -- goto _L___2
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else: | _L___2:
						if ((create {P_OPTION_STATIC}).p_bsdir.item.item.item).to_integer_32 = 108 then
							l_initdir := last_dir.item
						end
				when 24 then -- if done | if done | if done | if done
					if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
						if l_filter.is_void then
							l_filter := (create {P_EVAL_STATIC}).get_var_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("b:browsefilter")))
							if l_filter.is_void then
								l_filter := (create {P_EVAL_STATIC}).get_var_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("g:browsefilter")))
								if l_filter.is_void then
									l_filter := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("All Files (*)%T*%NC source (*.c, *.h)%T*.c;*.h%NC++ source (*.cpp, *.hpp)%T*.cpp;*.hpp%NVim files (*.vim, _vimrc, _gvimrc)%T*.vim;_vimrc;_gvimrc%N"))
								end
							end
						end
						if ((a_flags___0).bit_and (2)).to_boolean then
							l_fname := (create {P_GUI_GTK_STATIC}).gui_mch_browsedir (l_title, l_initdir)
						else
							l_fname := (create {P_GUI_GTK_STATIC}).gui_mch_browse ((a_flags___0).bit_and (1), l_title, l_dflt, a_ext, l_initdir, l_filter)
						end
						(create {P_GLOBALS_STATIC}).need_check_timestamps.item := 1;
						(create {P_GLOBALS_STATIC}).did_check_timestamps.item := 0
					else
						emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E338: Sorry, no file browser in console mode"))))).do_nothing
						l_fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
					if not l_fname.is_void then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (last_dir.item))
						last_dir.item := (create {P_MISC2_STATIC}).vim_strsave (l_fname)
						if not last_dir.item.is_void then
							if not ((a_flags___0).bit_and (2)).to_boolean then
								((create {P_MISC1_STATIC}).gettail (last_dir.item)).item := (('%/0/').code).to_natural_8
								if (last_dir.item.item).to_integer_32 = 0 then
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (last_dir.item))
									last_dir.item := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 4_096)
									if not last_dir.item.is_void then
										(create {P_OS_UNIX_STATIC}).mch_dirname (last_dir.item, 4_096).do_nothing
									end
								end
							end
						end
					end
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tofree));
					(create {P_GLOBALS_STATIC}).cmdmod.item.item.browse := l_save_browse
					Result := l_fname
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tv_nr (a_tvs: CE_POINTER [PD_TYPVAL_T]; a_idxp: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_idxp.is_void
		local
			l_idx: INTEGER_32
			l_n: INTEGER_32
			l_err: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_err.make (<<1>>)

			l_idx := a_idxp.item - 1
			l_n := 0
			l_err.item := 0
			if ((a_tvs + l_idx).item.v_type).to_integer_32 = 0 then
				emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (e_printf.item)))).do_nothing
			else
				a_idxp.item := (a_idxp.item) + 1
				l_n := (a_tvs + l_idx).item.get_tv_number_chk (l_err)
				if (l_err.item).to_boolean then
					l_n := 0
				end
			end
			Result := l_n
		end

	tv_str (a_tvs: CE_POINTER [PD_TYPVAL_T]; a_idxp: CE_POINTER [INTEGER_32]): CE_POINTER [INTEGER_8]
		require
			not a_idxp.is_void
		local
			l_idx: INTEGER_32
			l_s: CE_POINTER [INTEGER_8]
		do
			l_idx := a_idxp.item - 1
			l_s := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			if ((a_tvs + l_idx).item.v_type).to_integer_32 = 0 then
				emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (e_printf.item)))).do_nothing
			else
				a_idxp.item := (a_idxp.item) + 1
				l_s := create {CE_INTEGER_8_POINTER}.make_cast (((a_tvs + l_idx).item.get_tv_string_chk))
			end
			Result := l_s
		end

	tv_float (a_tvs: CE_POINTER [PD_TYPVAL_T]; a_idxp: CE_POINTER [INTEGER_32]): REAL_64
		require
			not a_idxp.is_void
		local
			l_idx: INTEGER_32
			l_f: REAL_64
		do
			l_idx := a_idxp.item - 1
			l_f := (0).to_double
			if ((a_tvs + l_idx).item.v_type).to_integer_32 = 0 then
				emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (e_printf.item)))).do_nothing
			else
				a_idxp.item := (a_idxp.item) + 1
				if ((a_tvs + l_idx).item.v_type).to_integer_32 = 6 then
					l_f := (a_tvs + l_idx).item.vval.v_float
				elseif ((a_tvs + l_idx).item.v_type).to_integer_32 = 1 then
					l_f := ((a_tvs + l_idx).item.vval.v_number).to_double
				else
					emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E807: Expected Float argument for printf()"))))).do_nothing
				end
			end
			Result := l_f
		end

	vim_snprintf_add (a_args: TUPLE [a_str___1: CE_POINTER [INTEGER_8]; a_str_m: NATURAL_32; a_fmt: CE_POINTER [INTEGER_8]]): INTEGER_32
		require
			not a_args.a_str___1.is_void
		local
			l_ap___0: CE_VA_LIST
			l_str_l: INTEGER_32
			l_len: NATURAL_32
			l_space: NATURAL_32
		do
			create l_ap___0.make_shared (default_pointer)

			l_len := (strlen (a_args.a_str___1))
			if a_args.a_str_m <= l_len then
				l_space := (0).to_natural_32
			else
				l_space := a_args.a_str_m - l_len
			end
			l_ap___0 := create {CE_VA_LIST}.make (a_args, agent vim_snprintf_add)
			l_str_l := vim_vsnprintf (a_args.a_str___1 + l_len.to_integer_32, l_space, a_args.a_fmt, l_ap___0.twin, create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (default_pointer))
			Result := l_str_l
		end

	vim_snprintf (a_args: TUPLE [a_str___1: CE_POINTER [INTEGER_8]; a_str_m: NATURAL_32; a_fmt: CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_ap___0: CE_VA_LIST
			l_str_l: INTEGER_32
		do
			create l_ap___0.make_shared (default_pointer)

			l_ap___0 := create {CE_VA_LIST}.make (a_args, agent vim_snprintf)
			l_str_l := vim_vsnprintf (a_args.a_str___1, a_args.a_str_m, a_args.a_fmt, l_ap___0.twin, create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (default_pointer))
			Result := l_str_l
		end

	vim_vsnprintf (a_str___1: CE_POINTER [INTEGER_8]; a_str_m: NATURAL_32; a_fmt: CE_POINTER [INTEGER_8]; a_ap___0: CE_VA_LIST; a_tvs: CE_POINTER [PD_TYPVAL_T]): INTEGER_32
		local
			l_ap___0: CE_VA_LIST
			l_str_l: NATURAL_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_arg_idx: CE_ARRAY [INTEGER_32]
			l_q: CE_POINTER [INTEGER_8]
			l_n: NATURAL_32
			l_tmp___1: NATURAL_32
			l_avail: NATURAL_32
			l_tmp___2: NATURAL_32
			l_min_field_width: NATURAL_32
			l_precision: NATURAL_32
			l_zero_padding: INTEGER_32
			l_precision_specified: INTEGER_32
			l_justify_left: INTEGER_32
			l_alternate_form: INTEGER_32
			l_force_sign: INTEGER_32
			l_space_for_positive: INTEGER_32
			l_length_modifier: INTEGER_8
			l_tmp___3: CE_ARRAY [INTEGER_8]
			l_str_arg: CE_POINTER [INTEGER_8]
			l_str_arg_l: NATURAL_32
			l_uchar_arg: CE_ARRAY [NATURAL_8]
			l_number_of_zeros_to_pad: NATURAL_32
			l_zero_padding_insertion_ind: NATURAL_32
			l_fmt_spec: INTEGER_8
			l_j: INTEGER_32
			l_uj: NATURAL_32
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_j___0: INTEGER_32
			l_uj___0: NATURAL_32
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_j___1: INTEGER_32
			l_q___0: CE_POINTER [INTEGER_8]
			l_tmp___16: NATURAL_32
			l_arg_sign: INTEGER_32
			l_int_arg: INTEGER_32
			l_uint_arg: NATURAL_32
			l_long_arg: INTEGER_32
			l_ulong_arg: NATURAL_32
			l_ptr_arg: CE_POINTER [ANY]
			l_tmp___28: NATURAL_32
			l_tmp___29: NATURAL_32
			l_tmp___30: NATURAL_32
			l_f: CE_ARRAY [INTEGER_8]
			l_f_l: INTEGER_32
			l_tmp___31: INTEGER_32
			l_tmp___32: INTEGER_32
			l_tmp___33: INTEGER_32
			l_tmp___34: INTEGER_32
			l_tmp___35: INTEGER_32
			l_tmp___36: INTEGER_32
			l_num_of_digits: NATURAL_32
			l_n___0: INTEGER_32
			l_f___0: REAL_64
			l_abs_f: REAL_64
			l_format: CE_ARRAY [INTEGER_8]
			l_l: INTEGER_32
			l_remove_trailing_zeroes: INTEGER_32
			l_max_prec: NATURAL_32
			l_i___0: INTEGER_32
			l_tp: CE_POINTER [INTEGER_8]
			l_tmp___47: INTEGER_32
			l_tp___0: CE_POINTER [INTEGER_8]
			l_tmp___52: INTEGER_32
			l_pn: INTEGER_32
			l_avail___0: NATURAL_32
			l_tmp___57: NATURAL_32
			l_tmp___58: INTEGER_32
			l_zn: INTEGER_32
			l_avail___1: NATURAL_32
			l_tmp___59: NATURAL_32
			l_avail___2: NATURAL_32
			l_tmp___60: NATURAL_32
			l_sn: INTEGER_32
			l_avail___3: NATURAL_32
			l_tmp___61: NATURAL_32
			l_pn___0: INTEGER_32
			l_avail___4: NATURAL_32
			l_tmp___62: NATURAL_32
			l_tmp___63: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_arg_idx.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_tmp___3.make (<<350>>)
			create {CE_NATURAL_8_ARRAY} l_uchar_arg.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_f.make (<<5>>)
			create {CE_INTEGER_8_ARRAY} l_format.make (<<40>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ap___0 := a_ap___0.twin
					l_str_l := (0).to_natural_32
					l_p___0 := a_fmt
					l_arg_idx.item := 1
					if l_p___0.is_void then
						l_p___0 := ce_string ("")
					end
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_p___0[0]).to_integer_32 /= 0)) then
						l_pos := -1 + 104 -- skip loop
					end
				when 2 then -- loop body:
						if (l_p___0[0]).to_integer_32 = 37 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_q := (strchr ((l_p___0 + 1), ('%%').code))
						if l_q.is_void then
							l_tmp___1 := (strlen (l_p___0))
						else
							l_tmp___1 := (l_q.distance (l_p___0)).to_natural_32
						end
						l_n := l_tmp___1
						if l_str_l < a_str_m then
							l_avail := a_str_m - l_str_l
							if l_n > l_avail then
								l_tmp___2 := l_avail
							else
								l_tmp___2 := l_n
							end
							memmove (create {CE_VOID_POINTER}.make_cast ((a_str___1 + l_str_l.to_integer_32)), create {CE_VOID_POINTER}.make_cast (l_p___0), l_tmp___2).do_nothing
						end
						l_p___0 := l_p___0 + l_n.to_integer_32
						l_str_l := l_str_l + l_n
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 5 then -- else:
						l_min_field_width := (0).to_natural_32
						l_precision := (0).to_natural_32
						l_zero_padding := 0
						l_precision_specified := 0
						l_justify_left := 0
						l_alternate_form := 0
						l_force_sign := 0
						l_space_for_positive := 1
						l_length_modifier := (('%/0/').code).to_integer_8
						l_number_of_zeros_to_pad := (0).to_natural_32
						l_zero_padding_insertion_ind := (0).to_natural_32
						l_fmt_spec := (('%/0/').code).to_integer_8
						l_str_arg := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						l_p___0 := l_p___0 + 1
				when 6 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 17 -- skip loop
						end
				when 7 then -- loop body:
						l_break := False
						if (l_p___0[0]).to_integer_32 /= 48 then
							if (l_p___0[0]).to_integer_32 /= 45 then
								if (l_p___0[0]).to_integer_32 /= 43 then
									if (l_p___0[0]).to_integer_32 /= 32 then
										if (l_p___0[0]).to_integer_32 /= 35 then
											if (l_p___0[0]).to_integer_32 /= 39 then
												l_break := True
											end
										end
									end
								end
							end
						end
						if (l_break) then
							l_pos := -1 + 16 -- skip if block
						end
				when 8 then -- if:
						inspect (l_p___0[0]).to_integer_32 -- switch 1 head
						when 48 then l_pos := -1 + 9
						when 45 then l_pos := -1 + 10
						when 43 then l_pos := -1 + 11
						when 32 then l_pos := -1 + 12
						when 35 then l_pos := -1 + 13
						when 39 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 9 then -- switch 1, case 48
						l_zero_padding := 1
						l_pos := -1 + 15 -- switch 1; break
				when 10 then -- switch 1, case 45
						l_justify_left := 1
						l_pos := -1 + 15 -- switch 1; break
				when 11 then -- switch 1, case 43
						l_force_sign := 1
						l_space_for_positive := 0
						l_pos := -1 + 15 -- switch 1; break
				when 12 then -- switch 1, case 32
						l_force_sign := 1
						l_pos := -1 + 15 -- switch 1; break
				when 13 then -- switch 1, case 35
						l_alternate_form := 1
						l_pos := -1 + 15 -- switch 1; break
				when 14 then -- switch 1, case 39
						l_pos := -1 + 15 -- switch 1; break
				when 15 then -- switch 1, done:
						l_p___0 := l_p___0 + 1
				when 16 then -- if done
						l_pos := -1 + 6 -- back to loop condition
				when 17 then -- loop done
						l_break := False
						if (l_p___0[0]).to_integer_32 = 42 then
							l_p___0 := l_p___0 + 1
							if not a_tvs.is_void then
								l_j := (tv_nr (a_tvs, l_arg_idx)).to_integer_32
							else
								l_j := (l_ap___0.integer_32_item)
							end
							if l_j >= 0 then
								l_min_field_width := l_j.to_natural_32
							else
								l_min_field_width := (-l_j).to_natural_32
								l_justify_left := 1
							end
						elseif (l_p___0[0]).to_integer_32 >= 48 then
							if (l_p___0[0]).to_integer_32 <= 57 then
								l_tmp___6 := l_p___0
								l_p___0 := l_p___0 + 1
								l_uj := ((l_tmp___6[0]).to_integer_32 - 48).to_natural_32
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_p___0[0]).to_integer_32 >= 48 then
										if not ((l_p___0[0]).to_integer_32 <= 57) then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_tmp___7 := l_p___0
										l_p___0 := l_p___0 + 1
										l_uj := {NATURAL_32} 10 * l_uj + ((l_tmp___7[0]).to_integer_32 - 48).to_natural_32
									end
								end
								l_break := False
								l_min_field_width := l_uj
							end
						end
						if (l_p___0[0]).to_integer_32 = 46 then
							l_p___0 := l_p___0 + 1
							l_precision_specified := 1
							if (l_p___0[0]).to_integer_32 = 42 then
								if not a_tvs.is_void then
									l_j___0 := (tv_nr (a_tvs, l_arg_idx)).to_integer_32
								else
									l_j___0 := (l_ap___0.integer_32_item)
								end
								l_p___0 := l_p___0 + 1
								if l_j___0 >= 0 then
									l_precision := l_j___0.to_natural_32
								else
									l_precision_specified := 0
									l_precision := (0).to_natural_32
								end
							elseif (l_p___0[0]).to_integer_32 >= 48 then
								if (l_p___0[0]).to_integer_32 <= 57 then
									l_tmp___10 := l_p___0
									l_p___0 := l_p___0 + 1
									l_uj___0 := ((l_tmp___10[0]).to_integer_32 - 48).to_natural_32
									from
									until
										(l_break)
									loop
										l_break := False
										if (l_p___0[0]).to_integer_32 >= 48 then
											if not ((l_p___0[0]).to_integer_32 <= 57) then
												l_break := True
											end
										else
											l_break := True
										end
										if not (l_break) then
											l_tmp___11 := l_p___0
											l_p___0 := l_p___0 + 1
											l_uj___0 := {NATURAL_32} 10 * l_uj___0 + ((l_tmp___11[0]).to_integer_32 - 48).to_natural_32
										end
									end
									l_break := False
									l_precision := l_uj___0
								end
							end
						end
						if (l_p___0[0]).to_integer_32 /= 104 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 20 then -- else:
						if (l_p___0[0]).to_integer_32 /= 108 then
							l_pos := -1 + 22 -- skip if block
						end
				when 21 then -- if: | _L:
						l_length_modifier := l_p___0[0]
						l_p___0 := l_p___0 + 1
						if l_length_modifier.to_integer_32 = 108 then
							if (l_p___0[0]).to_integer_32 = 108 then
								l_length_modifier := (('l').code).to_integer_8
								l_p___0 := l_p___0 + 1
							end
						end
				when 22 then -- if done
						l_fmt_spec := l_p___0[0]
						inspect l_fmt_spec.to_integer_32 -- switch 2 head
						when 105 then l_pos := -1 + 23
						when 68 then l_pos := -1 + 24
						when 85 then l_pos := -1 + 25
						when 79 then l_pos := -1 + 26
						when 70 then l_pos := -1 + 27
						else l_pos := -1 + 28
						end
				when 23 then -- switch 2, case 105
						l_fmt_spec := (('d').code).to_integer_8
						l_pos := -1 + 29 -- switch 2; break
				when 24 then -- switch 2, case 68
						l_fmt_spec := (('d').code).to_integer_8
						l_length_modifier := (('l').code).to_integer_8
						l_pos := -1 + 29 -- switch 2; break
				when 25 then -- switch 2, case 85
						l_fmt_spec := (('u').code).to_integer_8
						l_length_modifier := (('l').code).to_integer_8
						l_pos := -1 + 29 -- switch 2; break
				when 26 then -- switch 2, case 79
						l_fmt_spec := (('o').code).to_integer_8
						l_length_modifier := (('l').code).to_integer_8
						l_pos := -1 + 29 -- switch 2; break
				when 27 then -- switch 2, case 70
						l_fmt_spec := (('f').code).to_integer_8
						l_pos := -1 + 29 -- switch 2; break
				when 28 then -- switch 2, default:
						l_pos := -1 + 29 -- switch 2; break
				when 29 then -- switch 2, done:
						inspect l_fmt_spec.to_integer_32 -- switch 3 head
						when 37 then l_pos := -1 + 30
						when 99 then l_pos := -1 + 30
						when 115 then l_pos := -1 + 30
						when 100 then l_pos := -1 + 36
						when 117 then l_pos := -1 + 36
						when 111 then l_pos := -1 + 36
						when 120 then l_pos := -1 + 36
						when 88 then l_pos := -1 + 36
						when 112 then l_pos := -1 + 36
						when 102 then l_pos := -1 + 79
						when 101 then l_pos := -1 + 79
						when 69 then l_pos := -1 + 79
						when 103 then l_pos := -1 + 79
						when 71 then l_pos := -1 + 79
						else l_pos := -1 + 101
						end
				when 30 then -- switch 3, case 37 | switch 3, case 99 | switch 3, case 115
						l_length_modifier := (('%/0/').code).to_integer_8
						l_str_arg_l := (1).to_natural_32
						inspect l_fmt_spec.to_integer_32 -- switch 4 head
						when 37 then l_pos := -1 + 31
						when 99 then l_pos := -1 + 32
						when 115 then l_pos := -1 + 33
						else l_pos := -1 + 34
						end
				when 31 then -- switch 4, case 37
						l_str_arg := l_p___0
						l_pos := -1 + 35 -- switch 4; break
				when 32 then -- switch 4, case 99
						if not a_tvs.is_void then
							l_j___1 := (tv_nr (a_tvs, l_arg_idx)).to_integer_32
						else
							l_j___1 := (l_ap___0.integer_32_item)
						end
						l_uchar_arg.item := l_j___1.to_natural_8
						l_str_arg := create {CE_INTEGER_8_POINTER}.make_cast (l_uchar_arg)
						l_pos := -1 + 35 -- switch 4; break
				when 33 then -- switch 4, case 115
						if not a_tvs.is_void then
							l_str_arg := (tv_str (a_tvs, l_arg_idx))
						else
							l_str_arg := (create {CE_INTEGER_8_POINTER}.make_cast (l_ap___0.pointer_item))
						end
						if l_str_arg.is_void then
							l_str_arg := ce_string ("[NULL]")
							l_str_arg_l := (6).to_natural_32
						elseif not l_precision_specified.to_boolean then
							l_str_arg_l := strlen (l_str_arg)
						elseif l_precision = {NATURAL_32} 0 then
							l_str_arg_l := (0).to_natural_32
						else
							if l_precision <= {NATURAL_32} 2_147_483_647 then
								l_tmp___16 := l_precision
							else
								l_tmp___16 := (2_147_483_647).to_natural_32
							end
							l_q___0 := create {CE_INTEGER_8_POINTER}.make_cast ((memchr (create {CE_VOID_POINTER}.make_cast (l_str_arg), ('%/0/').code, l_tmp___16)))
							if l_q___0.is_void then
								l_str_arg_l := l_precision
							else
								l_str_arg_l := (l_q___0.distance (l_str_arg)).to_natural_32
							end
						end
						l_pos := -1 + 35 -- switch 4; break
				when 34 then -- switch 4, default:
						l_pos := -1 + 35 -- switch 4; break
				when 35 then -- switch 4, done:
						l_pos := -1 + 102 -- switch 3; break
				when 36 then -- switch 3, case 100 | switch 3, case 117 | switch 3, case 111 | switch 3, case 120 | switch 3, case 88 | switch 3, case 112
						l_arg_sign := 0
						l_int_arg := 0
						l_uint_arg := {NATURAL_32} 0
						l_long_arg := 0
						l_ulong_arg := {NATURAL_32} 0
						l_ptr_arg := create {CE_VOID_POINTER}.make_shared (default_pointer)
						if l_fmt_spec.to_integer_32 /= 112 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						l_length_modifier := (('%/0/').code).to_integer_8
						if not a_tvs.is_void then
							l_ptr_arg := create {CE_VOID_POINTER}.make_cast ((tv_str (a_tvs, l_arg_idx)))
						else
							l_ptr_arg := (create {CE_VOID_POINTER}.make_cast (l_ap___0.pointer_item))
						end
						if not l_ptr_arg.is_void then
							l_arg_sign := 1
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 39 then -- else:
						if l_fmt_spec.to_integer_32 /= 100 then
							l_pos := -1 + 44 -- skip if block
						end
				when 40 then -- if:
						inspect l_length_modifier.to_integer_32 -- switch 5 head
						when 0 then l_pos := -1 + 41
						when 104 then l_pos := -1 + 41
						when 108 then l_pos := -1 + 42
						else l_pos := -1 + 43
						end
				when 41 then -- switch 5, case 0 | switch 5, case 104
						if not a_tvs.is_void then
							l_int_arg := (tv_nr (a_tvs, l_arg_idx)).to_integer_32
						else
							l_int_arg := (l_ap___0.integer_32_item)
						end
						if l_int_arg > 0 then
							l_arg_sign := 1
						elseif l_int_arg < 0 then
							l_arg_sign := -1
						end
						l_pos := -1 + 43 -- switch 5; break
				when 42 then -- switch 5, case 108
						if not a_tvs.is_void then
							l_long_arg := (tv_nr (a_tvs, l_arg_idx))
						else
							l_long_arg := (l_ap___0.integer_32_item)
						end
						if l_long_arg > 0 then
							l_arg_sign := 1
						elseif l_long_arg < 0 then
							l_arg_sign := -1
						end
						l_pos := -1 + 43 -- switch 5; break
				when 43 then -- switch 5, done: | if block done, skip else block:
						l_pos := -1 + 47
				when 44 then -- else:
						inspect l_length_modifier.to_integer_32 -- switch 6 head
						when 0 then l_pos := -1 + 45
						when 104 then l_pos := -1 + 45
						when 108 then l_pos := -1 + 46
						else l_pos := -1 + 47
						end
				when 45 then -- switch 6, case 0 | switch 6, case 104
						if not a_tvs.is_void then
							l_uint_arg := (tv_nr (a_tvs, l_arg_idx)).to_natural_32
						else
							l_uint_arg := (l_ap___0.natural_32_item)
						end
						if l_uint_arg /= {NATURAL_32} 0 then
							l_arg_sign := 1
						end
						l_pos := -1 + 47 -- switch 6; break
				when 46 then -- switch 6, case 108
						if not a_tvs.is_void then
							l_ulong_arg := (tv_nr (a_tvs, l_arg_idx)).to_natural_32
						else
							l_ulong_arg := (l_ap___0.natural_32_item)
						end
						if l_ulong_arg /= {NATURAL_32} 0 then
							l_arg_sign := 1
						end
						l_pos := -1 + 47 -- switch 6; break
				when 47 then -- switch 6, done: | if done | if done
						l_str_arg := l_tmp___3
						l_str_arg_l := (0).to_natural_32
						if l_precision_specified.to_boolean then
							l_zero_padding := 0
						end
						if l_fmt_spec.to_integer_32 /= 100 then
							l_pos := -1 + 50 -- skip if block
						end
				when 48 then -- if:
						if l_force_sign.to_boolean then
							if l_arg_sign >= 0 then
								l_tmp___28 := l_str_arg_l
								l_str_arg_l := l_str_arg_l + 1
								if l_space_for_positive.to_boolean then
									l_tmp___3[l_tmp___28.to_integer_32] := ((' ').code).to_integer_8
								else
									l_tmp___3[l_tmp___28.to_integer_32] := (('+').code).to_integer_8
								end
							end
						end
				when 49 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 50 then -- else:
						if not (l_alternate_form.to_boolean) then
							l_pos := -1 + 57 -- skip if block
						end
				when 51 then -- if:
						if l_arg_sign = 0 then
							l_pos := -1 + 57 -- skip if block
						end
				when 52 then -- if:
						if l_fmt_spec.to_integer_32 /= 120 then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:
						l_pos := -1 + 56 -- goto _L___0
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 55 then -- else:
						if l_fmt_spec.to_integer_32 /= 88 then
							l_pos := -1 + 57 -- skip if block
						end
				when 56 then -- if: | _L___0:
						l_tmp___29 := l_str_arg_l
						l_str_arg_l := l_str_arg_l + 1
						l_tmp___3[l_tmp___29.to_integer_32] := (('0').code).to_integer_8
						l_tmp___30 := l_str_arg_l
						l_str_arg_l := l_str_arg_l + 1
						l_tmp___3[l_tmp___30.to_integer_32] := l_fmt_spec
				when 57 then -- if done | if done | if done | if done
						l_zero_padding_insertion_ind := l_str_arg_l
						if not l_precision_specified.to_boolean then
							l_precision := (1).to_natural_32
						end
						if l_precision /= {NATURAL_32} 0 then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						if l_arg_sign /= 0 then
							l_pos := -1 + 60 -- goto _L___1
						end
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 60 then -- else: | _L___1:
						l_f_l := 0
						l_tmp___31 := l_f_l
						l_f_l := l_f_l + 1
						l_f[l_tmp___31] := (('%%').code).to_integer_8
						if l_length_modifier.to_boolean then
							if l_length_modifier.to_integer_32 = 50 then
								l_tmp___32 := l_f_l
								l_f_l := l_f_l + 1
								l_f[l_tmp___32] := (('l').code).to_integer_8
								l_tmp___33 := l_f_l
								l_f_l := l_f_l + 1
								l_f[l_tmp___33] := (('l').code).to_integer_8
							else
								l_tmp___34 := l_f_l
								l_f_l := l_f_l + 1
								l_f[l_tmp___34] := l_length_modifier
							end
						end
						l_tmp___35 := l_f_l
						l_f_l := l_f_l + 1
						l_f[l_tmp___35] := l_fmt_spec
						l_tmp___36 := l_f_l
						l_f_l := l_f_l + 1
						l_f[l_tmp___36] := (('%/0/').code).to_integer_8
						if l_fmt_spec.to_integer_32 /= 112 then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						l_str_arg_l := l_str_arg_l + (sprintf ([(l_tmp___3 + l_str_arg_l.to_integer_32), l_f, l_ptr_arg])).to_natural_32
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 71
				when 63 then -- else:
						if l_fmt_spec.to_integer_32 /= 100 then
							l_pos := -1 + 68 -- skip if block
						end
				when 64 then -- if:
						inspect l_length_modifier.to_integer_32 -- switch 7 head
						when 0 then l_pos := -1 + 65
						when 104 then l_pos := -1 + 65
						when 108 then l_pos := -1 + 66
						else l_pos := -1 + 67
						end
				when 65 then -- switch 7, case 0 | switch 7, case 104
						l_str_arg_l := l_str_arg_l + (sprintf ([(l_tmp___3 + l_str_arg_l.to_integer_32), l_f, l_int_arg])).to_natural_32
						l_pos := -1 + 67 -- switch 7; break
				when 66 then -- switch 7, case 108
						l_str_arg_l := l_str_arg_l + (sprintf ([(l_tmp___3 + l_str_arg_l.to_integer_32), l_f, l_long_arg])).to_natural_32
						l_pos := -1 + 67 -- switch 7; break
				when 67 then -- switch 7, done: | if block done, skip else block:
						l_pos := -1 + 71
				when 68 then -- else:
						inspect l_length_modifier.to_integer_32 -- switch 8 head
						when 0 then l_pos := -1 + 69
						when 104 then l_pos := -1 + 69
						when 108 then l_pos := -1 + 70
						else l_pos := -1 + 71
						end
				when 69 then -- switch 8, case 0 | switch 8, case 104
						l_str_arg_l := l_str_arg_l + (sprintf ([(l_tmp___3 + l_str_arg_l.to_integer_32), l_f, l_uint_arg])).to_natural_32
						l_pos := -1 + 71 -- switch 8; break
				when 70 then -- switch 8, case 108
						l_str_arg_l := l_str_arg_l + (sprintf ([(l_tmp___3 + l_str_arg_l.to_integer_32), l_f, l_ulong_arg])).to_natural_32
						l_pos := -1 + 71 -- switch 8; break
				when 71 then -- switch 8, done: | if done | if done
						if l_zero_padding_insertion_ind < l_str_arg_l then
							if (l_tmp___3[l_zero_padding_insertion_ind.to_integer_32]).to_integer_32 = 45 then
								l_zero_padding_insertion_ind := l_zero_padding_insertion_ind + 1
							end
						end
						if l_zero_padding_insertion_ind + {NATURAL_32} 1 < l_str_arg_l then
							if (l_tmp___3[l_zero_padding_insertion_ind.to_integer_32]).to_integer_32 = 48 then
								if (l_tmp___3[(l_zero_padding_insertion_ind + {NATURAL_32} 1).to_integer_32]).to_integer_32 = 120 then
									l_zero_padding_insertion_ind := l_zero_padding_insertion_ind + ({NATURAL_32} 2)
								elseif (l_tmp___3[(l_zero_padding_insertion_ind + {NATURAL_32} 1).to_integer_32]).to_integer_32 = 88 then
									l_zero_padding_insertion_ind := l_zero_padding_insertion_ind + ({NATURAL_32} 2)
								end
							end
						end
				when 72 then
						l_num_of_digits := l_str_arg_l - l_zero_padding_insertion_ind
						if not (l_alternate_form.to_boolean) then
							l_pos := -1 + 78 -- skip if block
						end
				when 73 then -- if:
						if l_fmt_spec.to_integer_32 /= 111 then
							l_pos := -1 + 78 -- skip if block
						end
				when 74 then -- if:
						if not (l_zero_padding_insertion_ind < l_str_arg_l) then
							l_pos := -1 + 77 -- skip if block
						end
				when 75 then -- if:
						if (l_tmp___3[l_zero_padding_insertion_ind.to_integer_32]).to_integer_32 /= 48 then
							l_pos := -1 + 77 -- goto _L___2
						end
				when 76 then -- if block done, skip else block:
						l_pos := -1 + 78
				when 77 then -- else: | _L___2:
						if not l_precision_specified.to_boolean then
							l_precision := l_num_of_digits + {NATURAL_32} 1
							l_precision_specified := 1
						elseif l_precision < l_num_of_digits + {NATURAL_32} 1 then
							l_precision := l_num_of_digits + {NATURAL_32} 1
							l_precision_specified := 1
						end
				when 78 then -- if done | if done
						if l_num_of_digits < l_precision then
							l_number_of_zeros_to_pad := l_precision - l_num_of_digits
						end
						if not l_justify_left.to_boolean then
							if l_zero_padding.to_boolean then
								l_n___0 := (l_min_field_width - (l_str_arg_l + l_number_of_zeros_to_pad)).to_integer_32
								if l_n___0 > 0 then
									l_number_of_zeros_to_pad := l_number_of_zeros_to_pad + l_n___0.to_natural_32
								end
							end
						end
						l_pos := -1 + 102 -- switch 3; break
				when 79 then -- switch 3, case 102 | switch 3, case 101 | switch 3, case 69 | switch 3, case 103 | switch 3, case 71
						l_remove_trailing_zeroes := 0
						if not a_tvs.is_void then
							l_f___0 := (tv_float (a_tvs, l_arg_idx))
						else
							l_f___0 := (l_ap___0.real_64_item)
						end
						if l_f___0 < (0).to_double then
							l_abs_f := -l_f___0
						else
							l_abs_f := l_f___0
						end
						if l_fmt_spec.to_integer_32 /= 103 then
							l_pos := -1 + 82 -- skip if block
						end
				when 80 then -- if:
						l_pos := -1 + 83 -- goto _L___4
				when 81 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 82 then -- else:
						if l_fmt_spec.to_integer_32 /= 71 then
							l_pos := -1 + 88 -- skip if block
						end
				when 83 then -- if: | _L___4:
						if not (l_abs_f >= 0.001) then
							l_pos := -1 + 86 -- skip if block
						end
				when 84 then -- if:
						if l_abs_f < 10000000.0 then
							l_fmt_spec := (('f').code).to_integer_8
						else
							l_pos := -1 + 86 -- goto _L___3
						end
				when 85 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 86 then -- else: | _L___3:
						if l_abs_f = 0.0 then
							l_fmt_spec := (('f').code).to_integer_8
						elseif l_fmt_spec.to_integer_32 = 103 then
							l_fmt_spec := (('e').code).to_integer_8
						else
							l_fmt_spec := (('E').code).to_integer_8
						end
				when 87 then
						l_remove_trailing_zeroes := 1
				when 88 then -- if done
						if l_fmt_spec.to_integer_32 /= 102 then
							l_pos := -1 + 91 -- skip if block
						end
				when 89 then -- if:
						if l_abs_f > 1.0e307 then
							strcpy (l_tmp___3, ce_string ("inf")).do_nothing
							l_str_arg_l := (3).to_natural_32
						else
							l_pos := -1 + 91 -- goto _L___6
						end
				when 90 then -- if block done, skip else block:
						l_pos := -1 + 100
				when 91 then -- else: | _L___6:
						l_format[0] := (('%%').code).to_integer_8
						l_l := 1
						if l_precision_specified.to_boolean then
							l_max_prec := (340).to_natural_32
							if l_fmt_spec.to_integer_32 = 102 then
								if l_abs_f > 1.0 then
									l_max_prec := l_max_prec - (log10 (l_abs_f)).truncated_to_integer_64.to_natural_32
								end
							end
							if l_precision > l_max_prec then
								l_precision := l_max_prec
							end
							l_l := l_l + (sprintf ([(l_format + 1), ce_string (".%%d"), l_precision.to_integer_32]))
						end
						l_format[l_l] := l_fmt_spec
						l_format[l_l + 1] := (('%/0/').code).to_integer_8
						l_str_arg_l := (sprintf ([l_tmp___3, l_format, l_f___0])).to_natural_32
						if not (l_remove_trailing_zeroes.to_boolean) then
							l_pos := -1 + 94 -- skip if block
						end
				when 92 then -- if:
						if l_fmt_spec.to_integer_32 = 102 then
							l_tp := (l_tmp___3 + l_str_arg_l.to_integer_32) - 1
						else
							if l_fmt_spec.to_integer_32 = 101 then
								l_tmp___47 := ('e').code
							else
								l_tmp___47 := ('E').code
							end
							l_tp := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___3), l_tmp___47)))
							if not l_tp.is_void then
								if (l_tp[1]).to_integer_32 = 43 then
									memmove (create {CE_VOID_POINTER}.make_cast ((l_tp + 1)), create {CE_VOID_POINTER}.make_cast ((l_tp + 2)), (strlen ((l_tp + 2))) + {NATURAL_32} 1).do_nothing
									l_str_arg_l := l_str_arg_l - 1
								end
								if (l_tp[1]).to_integer_32 = 45 then
									l_i___0 := 2
								else
									l_i___0 := 1
								end
								from
								until
									(l_tp[l_i___0]).to_integer_32 /= 48
								loop
									memmove (create {CE_VOID_POINTER}.make_cast ((l_tp + l_i___0)), create {CE_VOID_POINTER}.make_cast (((l_tp + l_i___0) + 1)), (strlen (((l_tp + l_i___0) + 1))) + {NATURAL_32} 1).do_nothing
									l_str_arg_l := l_str_arg_l - 1
								end
								l_tp := l_tp - 1
							end
						end
						if not l_tp.is_void then
							if not l_precision_specified.to_boolean then
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_tp.c_pointer.to_integer_32).to_natural_32 > ((l_tmp___3 + 2).c_pointer.to_integer_32).to_natural_32 then
										if (l_tp[0]).to_integer_32 = 48 then
											if (l_tp[-1]).to_integer_32 = 46 then
												l_break := True
											end
										else
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										memmove (create {CE_VOID_POINTER}.make_cast (l_tp), create {CE_VOID_POINTER}.make_cast ((l_tp + 1)), (strlen ((l_tp + 1))) + {NATURAL_32} 1).do_nothing
										l_tp := l_tp - 1
										l_str_arg_l := l_str_arg_l - 1
									end
								end
								l_break := False
							end
						end
				when 93 then -- if block done, skip else block:
						l_pos := -1 + 100
				when 94 then -- else:
						if l_fmt_spec.to_integer_32 = 101 then
							l_tmp___52 := ('e').code
						else
							l_tmp___52 := ('E').code
						end
						l_tp___0 := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___3), l_tmp___52)))
						if l_tp___0.is_void then
							l_pos := -1 + 100 -- skip if block
						end
				when 95 then -- if:
						if (l_tp___0[1]).to_integer_32 /= 43 then
							l_pos := -1 + 98 -- skip if block
						end
				when 96 then -- if:
						l_pos := -1 + 99 -- goto _L___5
				when 97 then -- if block done, skip else block:
						l_pos := -1 + 100
				when 98 then -- else:
						if (l_tp___0[1]).to_integer_32 /= 45 then
							l_pos := -1 + 100 -- skip if block
						end
				when 99 then -- if: | _L___5:
						if (l_tp___0[2]).to_integer_32 = 48 then
							if ((create {P_CHARSET_STATIC}).vim_isdigit ((l_tp___0[3]).to_integer_32)).to_boolean then
								if ((create {P_CHARSET_STATIC}).vim_isdigit ((l_tp___0[4]).to_integer_32)).to_boolean then
									memmove (create {CE_VOID_POINTER}.make_cast ((l_tp___0 + 2)), create {CE_VOID_POINTER}.make_cast ((l_tp___0 + 3)), (strlen ((l_tp___0 + 3))) + {NATURAL_32} 1).do_nothing
									l_str_arg_l := l_str_arg_l - 1
								end
							end
						end
				when 100 then -- if done | if done | if done | if done
						l_str_arg := l_tmp___3
						l_pos := -1 + 102 -- switch 3; break
				when 101 then -- switch 3, default:
						l_zero_padding := 0
						l_justify_left := 1
						l_min_field_width := (0).to_natural_32
						l_str_arg := l_p___0
						l_str_arg_l := (0).to_natural_32
						if (l_p___0[0]).to_integer_32 /= 0 then
							l_str_arg_l := l_str_arg_l + 1
						end
						l_pos := -1 + 102 -- switch 3; break
				when 102 then -- switch 3, done:
						if (l_p___0[0]).to_integer_32 /= 0 then
							l_p___0 := l_p___0 + 1
						end
						if not l_justify_left.to_boolean then
							l_pn := (l_min_field_width - (l_str_arg_l + l_number_of_zeros_to_pad)).to_integer_32
							if l_pn > 0 then
								if l_str_l < a_str_m then
									l_avail___0 := a_str_m - l_str_l
									if l_pn.to_natural_32 > l_avail___0 then
										l_tmp___57 := l_avail___0
									else
										l_tmp___57 := l_pn.to_natural_32
									end
									if l_zero_padding.to_boolean then
										l_tmp___58 := ('0').code
									else
										l_tmp___58 := (' ').code
									end
									memset (create {CE_VOID_POINTER}.make_cast ((a_str___1 + l_str_l.to_integer_32)), l_tmp___58, l_tmp___57).do_nothing
								end
								l_str_l := l_str_l + l_pn.to_natural_32
							end
						end
						if l_number_of_zeros_to_pad = {NATURAL_32} 0 then
							l_zero_padding_insertion_ind := (0).to_natural_32
						else
							l_zn := l_zero_padding_insertion_ind.to_integer_32
							if l_zn > 0 then
								if l_str_l < a_str_m then
									l_avail___1 := a_str_m - l_str_l
									if l_zn.to_natural_32 > l_avail___1 then
										l_tmp___59 := l_avail___1
									else
										l_tmp___59 := l_zn.to_natural_32
									end
									memmove (create {CE_VOID_POINTER}.make_cast ((a_str___1 + l_str_l.to_integer_32)), create {CE_VOID_POINTER}.make_cast (l_str_arg), l_tmp___59).do_nothing
								end
								l_str_l := l_str_l + l_zn.to_natural_32
							end
							l_zn := l_number_of_zeros_to_pad.to_integer_32
							if l_zn > 0 then
								if l_str_l < a_str_m then
									l_avail___2 := a_str_m - l_str_l
									if l_zn.to_natural_32 > l_avail___2 then
										l_tmp___60 := l_avail___2
									else
										l_tmp___60 := l_zn.to_natural_32
									end
									memset (create {CE_VOID_POINTER}.make_cast ((a_str___1 + l_str_l.to_integer_32)), ('0').code, l_tmp___60).do_nothing
								end
								l_str_l := l_str_l + l_zn.to_natural_32
							end
						end
						l_sn := (l_str_arg_l - l_zero_padding_insertion_ind).to_integer_32
						if l_sn > 0 then
							if l_str_l < a_str_m then
								l_avail___3 := a_str_m - l_str_l
								if l_sn.to_natural_32 > l_avail___3 then
									l_tmp___61 := l_avail___3
								else
									l_tmp___61 := l_sn.to_natural_32
								end
								memmove (create {CE_VOID_POINTER}.make_cast ((a_str___1 + l_str_l.to_integer_32)), create {CE_VOID_POINTER}.make_cast ((l_str_arg + l_zero_padding_insertion_ind.to_integer_32)), l_tmp___61).do_nothing
							end
							l_str_l := l_str_l + l_sn.to_natural_32
						end
						if l_justify_left.to_boolean then
							l_pn___0 := (l_min_field_width - (l_str_arg_l + l_number_of_zeros_to_pad)).to_integer_32
							if l_pn___0 > 0 then
								if l_str_l < a_str_m then
									l_avail___4 := a_str_m - l_str_l
									if l_pn___0.to_natural_32 > l_avail___4 then
										l_tmp___62 := l_avail___4
									else
										l_tmp___62 := l_pn___0.to_natural_32
									end
									memset (create {CE_VOID_POINTER}.make_cast ((a_str___1 + l_str_l.to_integer_32)), (' ').code, l_tmp___62).do_nothing
								end
								l_str_l := l_str_l + l_pn___0.to_natural_32
							end
						end
				when 103 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 104 then -- loop done
					if a_str_m > {NATURAL_32} 0 then
						if l_str_l <= a_str_m - {NATURAL_32} 1 then
							l_tmp___63 := l_str_l
						else
							l_tmp___63 := a_str_m - {NATURAL_32} 1
						end
						a_str___1[l_tmp___63.to_integer_32] := (('%/0/').code).to_integer_8
					end
					if not a_tvs.is_void then
						if ((a_tvs + (l_arg_idx.item - 1)).item.v_type).to_integer_32 /= 0 then
							emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E767: Too many arguments to printf()"))))).do_nothing
						end
					end
					Result := l_str_l.to_integer_32
				when 105 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	ex_messages_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_messages)
		end

end
