class
	P_SCREEN_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_LIBINTL_STATIC
	S_STDLIB_STATIC
	S_STDIO_STATIC

feature {ANY} -- public attributes

	screen_attr: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	screen_cur_row: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	screen_cur_col: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	search_hl: CE_STATIC [CE_ARRAY [PD_MATCH_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MATCH_T]}.make (<<1>>)
		end

	win_foldinfo: CE_STATIC [CE_ARRAY [PD_FOLDINFO]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_FOLDINFO]}.make (<<1>>)
		end

	current_ScreenLine: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	screen_char_attr: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	did_intro: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	busy___1: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	entered___3: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	entered___4: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	done_outofmem_msg: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	redraw_later (a_type: INTEGER_32)
		do
			((create {P_GLOBALS_STATIC}).curwin.item).item.redraw_win_later (a_type)
		end

	redraw_later_clear
		do
			redraw_all_later (50)
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				screen_attr.item := 64
			else
				screen_attr.item := 11
			end
		end

	redraw_all_later (a_type: INTEGER_32)
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
			from
			until
				l_wp___0.is_void
			loop
				l_wp___0.item.redraw_win_later (a_type)
				l_wp___0 := l_wp___0.item.w_next
			end
		end

	redraw_curbuf_later (a_type: INTEGER_32)
		do
			redraw_buf_later ((create {P_GLOBALS_STATIC}).curbuf.item, a_type)
		end

	redraw_buf_later (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_type: INTEGER_32)
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
			from
			until
				l_wp___0.is_void
			loop
				if (l_wp___0.item.w_buffer).is_equal (a_buf___6) then
					l_wp___0.item.redraw_win_later (a_type)
				end
				l_wp___0 := l_wp___0.item.w_next
			end
		end

	redrawWinline (a_lnum: INTEGER_32; a_invalid: INTEGER_32)
		local
			l_i___0: INTEGER_32
		do
			if (create {P_GLOBALS_STATIC}).curwin.item.item.w_redraw_top = 0 then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_redraw_top := a_lnum
			elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_redraw_top > a_lnum then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_redraw_top := a_lnum
			end
			if (create {P_GLOBALS_STATIC}).curwin.item.item.w_redraw_bot = 0 then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_redraw_bot := a_lnum
			elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_redraw_bot < a_lnum then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_redraw_bot := a_lnum
			end
			redraw_later (10)
			if a_invalid.to_boolean then
				l_i___0 := ((create {P_GLOBALS_STATIC}).curwin.item).item.find_wl_entry (a_lnum)
				if l_i___0 >= 0 then
					((create {P_GLOBALS_STATIC}).curwin.item.item.w_lines + l_i___0).item.wl_valid := (0).to_integer_8
				end
			end
		end

	update_curbuf (a_type: INTEGER_32)
		do
			redraw_curbuf_later (a_type)
			update_screen (a_type)
		end

	update_screen (a_type: INTEGER_32)
		local
			l_type: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_did_one: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_wwp: CE_POINTER [PD_WINDOW_S]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_type := a_type
					if not (screen_valid (1)).to_boolean then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_GLOBALS_STATIC}).must_redraw.item).to_boolean then
							if l_type < (create {P_GLOBALS_STATIC}).must_redraw.item then
								l_type := (create {P_GLOBALS_STATIC}).must_redraw.item
							end
							(create {P_GLOBALS_STATIC}).must_redraw.item := 0
						end
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_lines_valid = 0 then
							if l_type < 40 then
								l_type := 40
							end
						end
						if not ((redrawing).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						if not (((create {P_GLOBALS_STATIC}).updating_screen.item).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | _L:
						redraw_later (l_type);
						(create {P_GLOBALS_STATIC}).must_redraw.item := l_type
						if l_type > 25 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_lines_valid := 0
						end
						l_return := True
				when 4 then -- if done | if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else:
						l_pos := -1 + 3 -- goto _L
				when 6 then -- if done
					if l_return then
						l_pos := -1 + 28 -- skip if block
					end
				when 7 then -- if:;
						(create {P_GLOBALS_STATIC}).updating_screen.item := 1;
						(create {P_GLOBALS_STATIC}).display_tick.item := (((create {P_GLOBALS_STATIC}).display_tick.item).to_integer_32 + 1).to_natural_16
						if not (((create {P_GLOBALS_STATIC}).msg_scrolled.item).to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 8 then -- if:;
						(create {P_GLOBALS_STATIC}).clear_cmdline.item := 1
						if not (((create {P_GLOBALS_STATIC}).msg_scrolled.item).to_integer_32 > (create {P_GLOBALS_STATIC}).Rows.item.item - 5) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_type := 50
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 11 then -- else:
						if l_type = 50 then
							l_pos := -1 + 21 -- skip if block
						end
				when 12 then -- if:
						check_for_delay (0)
						if (screen_ins_lines (0, 0, (create {P_GLOBALS_STATIC}).msg_scrolled.item, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32, create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))) = 0 then
							l_type := 50
						end
						l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
				when 13 then -- loop condition:
						if l_wp___0.is_void then
							l_pos := -1 + 20 -- skip loop
						end
				when 14 then -- loop body:
						if not (l_wp___0.item.w_winrow < (create {P_GLOBALS_STATIC}).msg_scrolled.item) then
							l_pos := -1 + 19 -- skip if block
						end
				when 15 then -- if:
						if not (l_wp___0.item.w_winrow + l_wp___0.item.w_height > (create {P_GLOBALS_STATIC}).msg_scrolled.item) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if l_wp___0.item.w_redr_type < 30 then
							if l_wp___0.item.w_lines_valid > 0 then
								if l_wp___0.item.w_topline = (l_wp___0.item.w_lines + 0).item.wl_lnum then
									l_wp___0.item.w_upd_rows := (create {P_GLOBALS_STATIC}).msg_scrolled.item - l_wp___0.item.w_winrow
									l_wp___0.item.w_redr_type := 30
								else
									l_pos := -1 + 18 -- goto _L___2
								end
							else
								l_pos := -1 + 18 -- goto _L___2
							end
						else
							l_pos := -1 + 18 -- goto _L___2
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L___2:
						l_wp___0.item.w_redr_type := 40
						if (l_wp___0.item.w_winrow + l_wp___0.item.w_height) + l_wp___0.item.w_status_height <= (create {P_GLOBALS_STATIC}).msg_scrolled.item then
							l_wp___0.item.w_redr_status := 1
						end
				when 19 then -- if done
						l_wp___0 := l_wp___0.item.w_next
						l_pos := -1 + 13 -- back to loop condition
				when 20 then -- loop done;
						(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1;
						(create {P_GLOBALS_STATIC}).redraw_tabline.item := 1
				when 21 then -- if done | if done;
						(create {P_GLOBALS_STATIC}).msg_scrolled.item := 0;
						(create {P_GLOBALS_STATIC}).need_wait_return.item := 0
				when 22 then -- if done;
						(create {P_EX_GETLN_STATIC}).compute_cmdrow
						if ((create {P_GLOBALS_STATIC}).need_highlight_changed.item).to_boolean then
							(create {P_SYNTAX_STATIC}).highlight_changed.do_nothing
						end
						if l_type = 50 then
							screenclear
							l_type := 40
						end
						if ((create {P_GLOBALS_STATIC}).clear_cmdline.item).to_boolean then
							check_for_delay (0)
						end
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_redr_type < 40 then
							if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_nu).to_boolean then
								l_tmp___2 := ((create {P_GLOBALS_STATIC}).curwin.item).item.number_width
								l_tmp___3 := l_tmp___2
							elseif ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_rnu).to_boolean then
								l_tmp___2 := ((create {P_GLOBALS_STATIC}).curwin.item).item.number_width
								l_tmp___3 := l_tmp___2
							else
								l_tmp___3 := 0
							end
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_nrwidth /= l_tmp___3 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_redr_type := 40
							end
						end
						if l_type = 20 then
							(create {P_MOVE_STATIC}).update_curswant
						end
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_redr_type < l_type) then
							l_pos := -1 + 27 -- skip if block
						end
				when 23 then -- if:
						if l_type /= 10 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						if (((create {P_GLOBALS_STATIC}).curwin.item.item.w_lines + 0).item.wl_valid).to_boolean then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill = (create {P_GLOBALS_STATIC}).curwin.item.item.w_old_topfill then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_botfill = (create {P_GLOBALS_STATIC}).curwin.item.item.w_old_botfill then
									if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline /= ((create {P_GLOBALS_STATIC}).curwin.item.item.w_lines + 0).item.wl_lnum then
										l_pos := -1 + 26 -- goto _L___6
									end
								else
									l_pos := -1 + 26 -- goto _L___6
								end
							else
								l_pos := -1 + 26 -- goto _L___6
							end
						else
							l_pos := -1 + 26 -- goto _L___6
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else: | _L___6:
						if l_type = 20 then
							if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_old_cursor_lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
									if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_old_visual_mode).to_integer_32 = (create {P_GLOBALS_STATIC}).VIsual_mode.item then
										if (((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and (4)).to_boolean then
											if (create {P_GLOBALS_STATIC}).curwin.item.item.w_old_curswant /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant then
												(create {P_GLOBALS_STATIC}).curwin.item.item.w_redr_type := l_type
											end
										else
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_redr_type := l_type
										end
									else
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_redr_type := l_type
									end
								else
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_redr_type := l_type
								end
							else
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_redr_type := l_type
							end
						else
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_redr_type := l_type
						end
				when 27 then -- if done
						if ((create {P_GLOBALS_STATIC}).redraw_tabline.item).to_boolean then
							draw_tabline
						elseif l_type >= 40 then
							draw_tabline
						end
						l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
						from
						until
							not (not (l_return) and then (not l_wp___0.is_void))
						loop
							if ((l_wp___0.item.w_buffer).item.b_mod_set).to_boolean then
								l_wwp := (create {P_GLOBALS_STATIC}).firstwin.item
								from
								until
									not (not (l_break) and then (not l_wwp.is_equal (l_wp___0)))
								loop
									l_break := False
									if (l_wwp.item.w_buffer).is_equal (l_wp___0.item.w_buffer) then
										l_break := True
									end
									if not (l_break) then
										l_wwp := l_wwp.item.w_next
									end
								end
								l_break := False
								if l_wwp.is_equal (l_wp___0) then
									if (l_wp___0.item.syntax_present).to_boolean then
										(create {P_SYNTAX_STATIC}).syn_stack_apply_changes (l_wp___0.item.w_buffer)
									end
								end
							end
							l_wp___0 := l_wp___0.item.w_next
						end
						l_did_one := 0
						search_hl.item.item.rm.regprog := create {CE_CLASS_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
						l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
						from
						until
							l_wp___0.is_void
						loop
							if l_wp___0.item.w_redr_type /= 0 then
								(create {P_TERM_STATIC}).cursor_off
								if not l_did_one.to_boolean then
									l_did_one := 1
									start_search_hl
									if ((create {P_GLOBALS_STATIC}).clip_star.item.item.available).to_boolean then
										if ((create {P_UI_STATIC}).clip_isautosel).to_boolean then
											(create {P_UI_STATIC}).clip_update_selection
										end
									end
									if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
										(create {P_GUI_STATIC}).gui_undraw_cursor
									end
								end
								l_wp___0.item.win_update
							end
							if (l_wp___0.item.w_redr_status).to_boolean then
								(create {P_TERM_STATIC}).cursor_off
								win_redr_status (l_wp___0)
							end
							l_wp___0 := l_wp___0.item.w_next
						end
						end_search_hl
						l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
						from
						until
							l_wp___0.is_void
						loop
							(l_wp___0.item.w_buffer).item.b_mod_set := 0
							l_wp___0 := l_wp___0.item.w_next
						end
						(create {P_GLOBALS_STATIC}).updating_screen.item := 0;
						(create {P_GUI_STATIC}).gui_may_resize_shell
						if ((create {P_GLOBALS_STATIC}).clear_cmdline.item).to_boolean then
							showmode.do_nothing
						elseif ((create {P_GLOBALS_STATIC}).redraw_cmdline.item).to_boolean then
							showmode.do_nothing
						end
						if not did_intro.item.to_boolean then
							if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count = 1 then
								if (((create {P_MEMLINE_STATIC}).ml_get ((1).to_integer_32)).item).to_integer_32 = 0 then
									if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname).is_void then
										if ((create {P_GLOBALS_STATIC}).firstwin.item.item.w_next).is_void then
											if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_shm.item.item, ('I').code)).is_void then
												(create {P_VERSION_STATIC}).intro_message (0)
											end
										end
									end
								end
							end
						end
						did_intro.item := 1
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							(create {P_TERM_STATIC}).out_flush
							if l_did_one.to_boolean then
								(create {P_GUI_STATIC}).gui_update_cursor (0, 0)
							end
							(create {P_GUI_STATIC}).gui_update_scrollbars (0)
						end
				when 28 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	update_prepare
		do
			(create {P_TERM_STATIC}).cursor_off;
			(create {P_GLOBALS_STATIC}).updating_screen.item := 1
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_GUI_STATIC}).gui_undraw_cursor
			end
			start_search_hl
		end

	update_finish
		do
			if ((create {P_GLOBALS_STATIC}).redraw_cmdline.item).to_boolean then
				showmode.do_nothing
			end
			end_search_hl;
			(create {P_GLOBALS_STATIC}).updating_screen.item := 0;
			(create {P_GUI_STATIC}).gui_may_resize_shell
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_TERM_STATIC}).out_flush;
				(create {P_GUI_STATIC}).gui_update_cursor (0, 0);
				(create {P_GUI_STATIC}).gui_update_scrollbars (0)
			end
		end

	update_debug_sign (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_lnum: INTEGER_32)
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_doit: INTEGER_32
			l_return: BOOLEAN
		do
			l_doit := 0
			win_foldinfo.item.item.fi_level := 0
			l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
			from
			until
				l_wp___0.is_void
			loop
				if not a_buf___6.is_void then
					if a_lnum > 0 then
						if (l_wp___0.item.w_buffer).is_equal (a_buf___6) then
							if a_lnum >= l_wp___0.item.w_topline then
								if a_lnum < l_wp___0.item.w_botline then
									if l_wp___0.item.w_redraw_top = 0 then
										l_wp___0.item.w_redraw_top := a_lnum
									elseif l_wp___0.item.w_redraw_top > a_lnum then
										l_wp___0.item.w_redraw_top := a_lnum
									end
									if l_wp___0.item.w_redraw_bot = 0 then
										l_wp___0.item.w_redraw_bot := a_lnum
									elseif l_wp___0.item.w_redraw_bot < a_lnum then
										l_wp___0.item.w_redraw_bot := a_lnum
									end
									l_wp___0.item.redraw_win_later (10)
								end
							end
						end
					else
						l_wp___0.item.redraw_win_later (10)
					end
				else
					l_wp___0.item.redraw_win_later (10)
				end
				if l_wp___0.item.w_redr_type /= 0 then
					l_doit := 1
				end
				l_wp___0 := l_wp___0.item.w_next
			end
			if not l_doit.to_boolean then
				l_return := True
			elseif ((create {P_GLOBALS_STATIC}).updating_screen.item).to_boolean then
				l_return := True
			end
			if not l_return then
				update_prepare
				l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
				from
				until
					l_wp___0.is_void
				loop
					if l_wp___0.item.w_redr_type /= 0 then
						l_wp___0.item.win_update
					end
					if (l_wp___0.item.w_redr_status).to_boolean then
						win_redr_status (l_wp___0)
					end
					l_wp___0 := l_wp___0.item.w_next
				end
				update_finish
			end
		end

	updateWindow (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).updating_screen.item).to_boolean then
				l_return := True
			end
			if not l_return then
				update_prepare
				if ((create {P_GLOBALS_STATIC}).clip_star.item.item.available).to_boolean then
					if ((create {P_UI_STATIC}).clip_isautosel).to_boolean then
						(create {P_UI_STATIC}).clip_update_selection
					end
				end
				a_wp___0.item.win_update
				if ((create {P_GLOBALS_STATIC}).redraw_tabline.item).to_boolean then
					draw_tabline
				end
				if (a_wp___0.item.w_redr_status).to_boolean then
					win_redr_status (a_wp___0)
				elseif ((create {P_OPTION_STATIC}).p_ru.item.item).to_boolean then
					win_redr_status (a_wp___0)
				elseif ((create {P_OPTION_STATIC}).p_stl.item.item.item).to_integer_32 /= 0 then
					win_redr_status (a_wp___0)
				elseif ((a_wp___0.item.w_onebuf_opt.wo_stl).item).to_integer_32 /= 0 then
					win_redr_status (a_wp___0)
				end
				update_finish
			end
		end

	status_redraw_all
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
			from
			until
				l_wp___0.is_void
			loop
				if (l_wp___0.item.w_status_height).to_boolean then
					l_wp___0.item.w_redr_status := 1
					redraw_later (10)
				end
				l_wp___0 := l_wp___0.item.w_next
			end
		end

	redraw_statuslines
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
			from
			until
				l_wp___0.is_void
			loop
				if (l_wp___0.item.w_redr_status).to_boolean then
					win_redr_status (l_wp___0)
				end
				l_wp___0 := l_wp___0.item.w_next
			end
			if ((create {P_GLOBALS_STATIC}).redraw_tabline.item).to_boolean then
				draw_tabline
			end
		end

	win_redraw_last_status (a_frp: CE_POINTER [PD_FRAME_S])
		require
			not a_frp.is_void
		local
			l_frp: CE_POINTER [PD_FRAME_S]
		do
			l_frp := a_frp
			if (l_frp.item.fr_layout).to_integer_32 = 0 then
				(l_frp.item.fr_win).item.w_redr_status := 1
			elseif (l_frp.item.fr_layout).to_integer_32 = 1 then
				l_frp := l_frp.item.fr_child
				from
				until
					l_frp.is_void
				loop
					win_redraw_last_status (l_frp)
					l_frp := l_frp.item.fr_next
				end
			else
				l_frp := l_frp.item.fr_child
				from
				until
					(l_frp.item.fr_next).is_void
				loop
					l_frp := l_frp.item.fr_next
				end
				win_redraw_last_status (l_frp)
			end
		end

	win_redr_status (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_row: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_fillchar: INTEGER_32
			l_attr: CE_ARRAY [INTEGER_32]
			l_this_ru_col: INTEGER_32
			l_tmp___0: INTEGER_32
			l_clen: INTEGER_32
			l_i___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_attr.make (<<1>>)

			if busy___1.item.to_boolean then
				l_return := True
			end
			if not l_return then
				busy___1.item := 1
				a_wp___0.item.w_redr_status := 0
				if a_wp___0.item.w_status_height = 0 then
					(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
				elseif (redrawing).to_boolean then
					if ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
						a_wp___0.item.w_redr_status := 1
					elseif ((create {P_OPTION_STATIC}).p_stl.item.item.item).to_integer_32 /= 0 then
						redraw_custom_statusline (a_wp___0)
					elseif ((a_wp___0.item.w_onebuf_opt.wo_stl).item).to_integer_32 /= 0 then
						redraw_custom_statusline (a_wp___0)
					else
						l_fillchar := fillchar_status (l_attr, (a_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item)).to_integer);
						(a_wp___0.item.w_buffer).item.get_trans_bufname
						l_p___0 := (create {P_GLOBALS_STATIC}).NameBuff.item.item
						l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32
						if ((a_wp___0.item.w_buffer).item.b_help).to_boolean then
							l_tmp___0 := l_len
							l_len := l_len + 1
							l_p___0[l_tmp___0] := ((' ').code).to_natural_8
						elseif (a_wp___0.item.w_onebuf_opt.wo_pvw).to_boolean then
							l_tmp___0 := l_len
							l_len := l_len + 1
							l_p___0[l_tmp___0] := ((' ').code).to_natural_8
						elseif ((a_wp___0.item.w_buffer).item.bufIsChanged).to_boolean then
							l_tmp___0 := l_len
							l_len := l_len + 1
							l_p___0[l_tmp___0] := ((' ').code).to_natural_8
						elseif ((a_wp___0.item.w_buffer).item.b_p_ro).to_boolean then
							l_tmp___0 := l_len
							l_len := l_len + 1
							l_p___0[l_tmp___0] := ((' ').code).to_natural_8
						end
						if ((a_wp___0.item.w_buffer).item.b_help).to_boolean then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + l_len)), (gettext (ce_string ("[Help]")))).do_nothing
							l_len := l_len + (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + l_len)))).to_integer_32
						end
						if (a_wp___0.item.w_onebuf_opt.wo_pvw).to_boolean then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + l_len)), (gettext (ce_string ("[Preview]")))).do_nothing
							l_len := l_len + (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + l_len)))).to_integer_32
						end
						if ((a_wp___0.item.w_buffer).item.bufIsChanged).to_boolean then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + l_len)), ce_string ("[+]")).do_nothing
							l_len := l_len + (3)
						end
						if ((a_wp___0.item.w_buffer).item.b_p_ro).to_boolean then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + l_len)), ce_string ("[RO]")).do_nothing
							l_len := l_len + (4)
						end
						l_this_ru_col := (((create {P_GLOBALS_STATIC}).ru_col.item).to_integer_32 - ((create {P_GLOBALS_STATIC}).Columns.item.item - (a_wp___0.item.w_width).to_integer_32)).to_integer_32
						if l_this_ru_col < (a_wp___0.item.w_width + 1) // 2 then
							l_this_ru_col := (a_wp___0.item.w_width + 1) // 2
						end
						if l_this_ru_col <= 1 then
							l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<"))
							l_len := 1
						elseif ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_clen := 0
							l_clen := (create {P_MBYTE_STATIC}).mb_string2cells (l_p___0, -1)
							l_i___0 := 0
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_p___0[l_i___0]).to_integer_32 /= 0 then
									if not (l_clen >= l_this_ru_col - 1) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_clen := l_clen - ((create {P_GLOBALS_STATIC}).mb_ptr2cells.item.integer_32_item ([l_p___0 + l_i___0]))
									l_i___0 := l_i___0 + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0 + l_i___0]))
								end
							end
							l_break := False
							l_len := l_clen
							if l_i___0 > 0 then
								l_p___0 := (l_p___0 + l_i___0) - 1
								l_p___0.item := (('<').code).to_natural_8
								l_len := l_len + 1
							end
						elseif l_len > l_this_ru_col - 1 then
							l_p___0 := l_p___0 + (l_len - (l_this_ru_col - 1))
							l_p___0.item := (('<').code).to_natural_8
							l_len := l_this_ru_col - 1
						end
						l_row := a_wp___0.item.w_winrow + a_wp___0.item.w_height
						screen_puts (l_p___0, l_row, a_wp___0.item.w_wincol, l_attr.item)
						screen_fill (l_row, l_row + 1, l_len + a_wp___0.item.w_wincol, l_this_ru_col + a_wp___0.item.w_wincol, l_fillchar, l_fillchar, l_attr.item)
						if (a_wp___0.item.get_keymap_str ((create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096)).to_boolean then
							if l_this_ru_col - l_len > ((strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item))) + {NATURAL_32} 1).to_integer_32 then
								screen_puts ((create {P_GLOBALS_STATIC}).NameBuff.item.item, l_row, (((l_this_ru_col.to_natural_32 - (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item)))) - {NATURAL_32} 1) + (a_wp___0.item.w_wincol).to_natural_32).to_integer_32, l_attr.item)
							end
						end
						win_redr_ruler (a_wp___0, 1)
					end
				else
					a_wp___0.item.w_redr_status := 1
				end
				if a_wp___0.item.w_vsep_width /= 0 then
					if a_wp___0.item.w_status_height /= 0 then
						if (redrawing).to_boolean then
							if (a_wp___0.item.stl_connected).to_boolean then
								l_fillchar := fillchar_status (l_attr, (a_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item)).to_integer)
							else
								l_fillchar := fillchar_vsep (l_attr)
							end
							screen_putchar (l_fillchar, a_wp___0.item.w_winrow + a_wp___0.item.w_height, a_wp___0.item.w_wincol + a_wp___0.item.w_width, l_attr.item)
						end
					end
				end
				busy___1.item := 0
			end
		end

	redraw_custom_statusline (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_save_called_emsg: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_save_called_emsg := (create {P_GLOBALS_STATIC}).called_emsg.item
			if entered___3.item.to_boolean then
				l_return := True
			end
			if not l_return then
				entered___3.item := 1;
				(create {P_GLOBALS_STATIC}).called_emsg.item := 0
				win_redr_custom (a_wp___0, 0)
				if ((create {P_GLOBALS_STATIC}).called_emsg.item).to_boolean then
					if ((a_wp___0.item.w_onebuf_opt.wo_stl).item).to_integer_32 /= 0 then
						l_tmp := 4
					else
						l_tmp := 2
					end
					(create {P_OPTION_STATIC}).set_string_option_direct (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("statusline")), -1, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (1).bit_or (l_tmp), -5)
				end
				(create {P_GLOBALS_STATIC}).called_emsg.item := ((create {P_GLOBALS_STATIC}).called_emsg.item).bit_or (l_save_called_emsg)
				entered___3.item := 0
			end
		end

	win_redr_custom (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_draw_ruler: INTEGER_32)
		local
			l_attr: CE_ARRAY [INTEGER_32]
			l_curattr: INTEGER_32
			l_row: INTEGER_32
			l_col: INTEGER_32
			l_maxwidth: INTEGER_32
			l_width: INTEGER_32
			l_n: INTEGER_32
			l_len: INTEGER_32
			l_fillchar: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_stl: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_hltab: CE_ARRAY [PD_STL_HLREC]
			l_tabtab: CE_ARRAY [PD_STL_HLREC]
			l_use_sandbox: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [PD_WINDOW_S]
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_attr.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<4_096>>)
			create {CE_CLASS_ARRAY [PD_STL_HLREC]} l_hltab.make (<<80>>)
			create {CE_CLASS_ARRAY [PD_STL_HLREC]} l_tabtab.make (<<80>>)

			l_col := 0
			l_use_sandbox := 0
			if a_wp___0.is_void then
				l_stl := (create {P_OPTION_STATIC}).p_tal.item.item
				l_row := 0
				l_fillchar := (' ').code
				l_attr.item := (create {P_GLOBALS_STATIC}).highlight_attr.item[37]
				l_maxwidth := ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32
				l_use_sandbox := (create {P_OPTION_STATIC}).was_set_insecurely (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tabline")), 0)
			else
				l_row := a_wp___0.item.w_winrow + a_wp___0.item.w_height
				l_fillchar := fillchar_status (l_attr, (a_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item)).to_integer)
				l_maxwidth := a_wp___0.item.w_width
				if a_draw_ruler.to_boolean then
					l_stl := (create {P_OPTION_STATIC}).p_ruf.item.item
					if (l_stl.item).to_integer_32 = 37 then
						l_stl := l_stl + 1
						if (l_stl.item).to_integer_32 = 45 then
							l_stl := l_stl + 1
						end
						if (atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_stl))).to_boolean then
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_stl.item).to_integer_32 >= 48 then
									if not ((l_stl.item).to_integer_32 <= 57) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_stl := l_stl + 1
								end
							end
							l_break := False
						end
						l_tmp___0 := l_stl
						l_stl := l_stl + 1
						if (l_tmp___0.item).to_integer_32 /= 40 then
							l_stl := (create {P_OPTION_STATIC}).p_ruf.item.item
						end
					end
					l_col := (((create {P_GLOBALS_STATIC}).ru_col.item).to_integer_32 - ((create {P_GLOBALS_STATIC}).Columns.item.item - (a_wp___0.item.w_width).to_integer_32)).to_integer_32
					if l_col < (a_wp___0.item.w_width + 1) // 2 then
						l_col := (a_wp___0.item.w_width + 1) // 2
					end
					l_maxwidth := a_wp___0.item.w_width - l_col
					if not (a_wp___0.item.w_status_height).to_boolean then
						l_row := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
						l_maxwidth := l_maxwidth - 1
						l_fillchar := (' ').code
						l_attr.item := 0
					end
					l_use_sandbox := (create {P_OPTION_STATIC}).was_set_insecurely (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("rulerformat")), 0)
				else
					if ((a_wp___0.item.w_onebuf_opt.wo_stl).item).to_integer_32 /= 0 then
						l_stl := a_wp___0.item.w_onebuf_opt.wo_stl
					else
						l_stl := (create {P_OPTION_STATIC}).p_stl.item.item
					end
					if ((a_wp___0.item.w_onebuf_opt.wo_stl).item).to_integer_32 = 0 then
						l_tmp___1 := 0
					else
						l_tmp___1 := 4
					end
					l_use_sandbox := (create {P_OPTION_STATIC}).was_set_insecurely (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("statusline")), l_tmp___1)
				end
				l_col := l_col + (a_wp___0.item.w_wincol)
			end
			if l_maxwidth <= 0 then
				l_return := True
			end
			if not l_return then
				l_stl := (create {P_MISC2_STATIC}).vim_strsave (l_stl)
				if a_wp___0.is_void then
					l_tmp___2 := (create {P_GLOBALS_STATIC}).curwin.item
				else
					l_tmp___2 := a_wp___0
				end
				l_width := l_tmp___2.item.build_stl_str_hl (l_buf___6, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32), l_stl, l_use_sandbox, l_fillchar, l_maxwidth, l_hltab, l_tabtab);
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_stl))
				l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))).to_integer_32
				from
				until
					(l_break)
				loop
					l_break := False
					if l_width < l_maxwidth then
						if not (l_len < ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32).to_integer_32 - 1) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_len := l_len + ((create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([l_fillchar, l_buf___6 + l_len]))
						l_width := l_width + 1
					end
				end
				l_break := False
				l_buf___6[l_len] := (('%/0/').code).to_natural_8
				l_curattr := l_attr.item
				l_p___0 := l_buf___6
				l_n := 0
				from
				until
					(l_hltab[l_n].start).is_void
				loop
					l_len := (l_hltab[l_n].start).distance (l_p___0)
					screen_puts_len (l_p___0, l_len, l_row, l_col, l_curattr)
					l_col := l_col + ((create {P_CHARSET_STATIC}).vim_strnsize (l_p___0, l_len))
					l_p___0 := l_hltab[l_n].start
					if l_hltab[l_n].userhl = 0 then
						l_curattr := l_attr.item
					elseif l_hltab[l_n].userhl < 0 then
						l_curattr := (create {P_SYNTAX_STATIC}).syn_id2attr (-l_hltab[l_n].userhl)
					elseif not a_wp___0.is_void then
						if not a_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
							if a_wp___0.item.w_status_height /= 0 then
								l_curattr := (create {P_GLOBALS_STATIC}).highlight_stlnc.item[l_hltab[l_n].userhl - 1]
							else
								l_curattr := (create {P_GLOBALS_STATIC}).highlight_user.item[l_hltab[l_n].userhl - 1]
							end
						else
							l_curattr := (create {P_GLOBALS_STATIC}).highlight_user.item[l_hltab[l_n].userhl - 1]
						end
					else
						l_curattr := (create {P_GLOBALS_STATIC}).highlight_user.item[l_hltab[l_n].userhl - 1]
					end
					l_n := l_n + 1
				end
				screen_puts (l_p___0, l_row, l_col, l_curattr)
				if a_wp___0.is_void then
					l_col := 0
					l_len := 0
					l_p___0 := l_buf___6
					l_fillchar := 0
					l_n := 0
					from
					until
						not (not (l_return) and then (not (l_tabtab[l_n].start).is_void))
					loop
						l_len := l_len + ((create {P_CHARSET_STATIC}).vim_strnsize (l_p___0, (l_tabtab[l_n].start).distance (l_p___0)))
						from
						until
							not (l_col < l_len)
						loop
							l_tmp___7 := l_col
							l_col := l_col + 1;
							(create {P_GLOBALS_STATIC}).TabPageIdxs.item[l_tmp___7] := l_fillchar.to_integer_16
						end
						l_p___0 := l_tabtab[l_n].start
						l_fillchar := l_tabtab[l_n].userhl
						l_n := l_n + 1
					end
					from
					until
						not (l_col.to_integer_32 < (create {P_GLOBALS_STATIC}).Columns.item.item)
					loop
						l_tmp___8 := l_col
						l_col := l_col + 1;
						(create {P_GLOBALS_STATIC}).TabPageIdxs.item[l_tmp___8] := l_fillchar.to_integer_16
					end
				end
			end
		end

	screen_putchar (a_c, a_row, a_col, a_attr: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<22>>)

			l_buf___6[((create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([a_c, l_buf___6]))] := (('%/0/').code).to_natural_8
			screen_puts (l_buf___6, a_row, a_col, a_attr)
		end

	screen_getbytes (a_row, a_col: INTEGER_32; a_bytes___0: CE_POINTER [NATURAL_8]; a_attrp: CE_POINTER [INTEGER_32])
		local
			l_off___0: NATURAL_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						if not (a_row < (create {P_GLOBALS_STATIC}).screen_Rows.item) then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						if not (a_col < (create {P_GLOBALS_STATIC}).screen_Columns.item) then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						l_off___0 := (create {P_GLOBALS_STATIC}).LineOffset.item[a_row] + a_col.to_natural_32
						a_attrp.item := ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0.to_integer_32]).to_integer_32
						a_bytes___0[0] := (create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0.to_integer_32]
						a_bytes___0[1] := (('%/0/').code).to_natural_8
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off___0.to_integer_32] /= {NATURAL_32} 0 then
							a_bytes___0[((create {P_MBYTE_STATIC}).utfc_char2bytes (l_off___0.to_integer_32, a_bytes___0))] := (('%/0/').code).to_natural_8
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else: | _L___0:
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 9_932 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if ((create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0.to_integer_32]).to_integer_32 = 142 then
							a_bytes___0[0] := (create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0.to_integer_32]
							a_bytes___0[1] := (create {P_GLOBALS_STATIC}).ScreenLines2.item[l_off___0.to_integer_32]
							a_bytes___0[2] := (('%/0/').code).to_natural_8
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if ((create {P_GLOBALS_STATIC}).enc_dbcs.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(a_bytes___0[0]).to_integer_32]).to_integer_32 > 1 then
								a_bytes___0[1] := (create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off___0 + {NATURAL_32} 1).to_integer_32]
								a_bytes___0[2] := (('%/0/').code).to_natural_8
							end
						end
				when 10 then -- if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	screen_comp_differs (a_off___0: INTEGER_32; a_u8cc: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				not (not (l_return or l_break) and then (l_i___0 < (create {P_GLOBALS_STATIC}).Screen_mco.item))
			loop
				l_break := False
				if ((create {P_GLOBALS_STATIC}).ScreenLinesC.item[l_i___0])[a_off___0] /= (a_u8cc[l_i___0]).to_natural_32 then
					Result := 1
					l_return := True
				end
				if not l_return then
					if a_u8cc[l_i___0] = 0 then
						l_break := True
					end
					if not (l_return or l_break) then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 0
			end
		end

	screen_puts (a_text: CE_POINTER [NATURAL_8]; a_row, a_col, a_attr: INTEGER_32)
		do
			screen_puts_len (a_text, -1, a_row, a_col, a_attr)
		end

	screen_puts_len (a_text: CE_POINTER [NATURAL_8]; a_len, a_row, a_col, a_attr: INTEGER_32)
		local
			l_col: INTEGER_32
			l_off___0: NATURAL_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_max_off: NATURAL_32
			l_mbyte_blen: INTEGER_32
			l_mbyte_cells: INTEGER_32
			l_u8c: INTEGER_32
			l_u8cc: CE_ARRAY [INTEGER_32]
			l_clear_next_cell: INTEGER_32
			l_force_redraw_this: INTEGER_32
			l_force_redraw_next: INTEGER_32
			l_need_redraw: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_n: INTEGER_32
			l_tmp___4: INTEGER_32
			l_i___0: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_u8cc.make (<<6>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_col := a_col
					l_ptr := a_text
					l_mbyte_blen := 1
					l_mbyte_cells := 1
					l_u8c := 0
					l_clear_next_cell := 0
					l_force_redraw_next := 0
					if ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
						l_return := True
					elseif a_row >= (create {P_GLOBALS_STATIC}).screen_Rows.item then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 68 -- skip if block
					end
				when 1 then -- if:
						l_off___0 := (create {P_GLOBALS_STATIC}).LineOffset.item[a_row] + l_col.to_natural_32
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							if l_col > 0 then
								if l_col < (create {P_GLOBALS_STATIC}).screen_Columns.item then
									if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
										if ((create {P_MBYTE_STATIC}).mb_fix_col (l_col, a_row)) /= l_col then
											(create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off___0 - {NATURAL_32} 1).to_integer_32] := ((' ').code).to_natural_8;
											(create {P_GLOBALS_STATIC}).ScreenAttrs.item[(l_off___0 - {NATURAL_32} 1).to_integer_32] := (0).to_natural_16
											if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
												(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[(l_off___0 - {NATURAL_32} 1).to_integer_32] := (0).to_natural_32;
												((create {P_GLOBALS_STATIC}).ScreenLinesC.item[0])[(l_off___0 - {NATURAL_32} 1).to_integer_32] := (0).to_natural_32
											end
											screen_char (l_off___0 - {NATURAL_32} 1, a_row, l_col - 1)
											l_force_redraw_next := 1
										end
									end
								end
							end
						end
						l_max_off := (create {P_GLOBALS_STATIC}).LineOffset.item[a_row] + ((create {P_GLOBALS_STATIC}).screen_Columns.item).to_natural_32
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 67 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if not (l_col < (create {P_GLOBALS_STATIC}).screen_Columns.item) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if not (a_len < 0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L___9
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if not (l_ptr.distance (a_text) < a_len) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L___9:
						if (l_ptr.item).to_integer_32 = 0 then
							l_break := True
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_break := True
				when 11 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_break := True
				when 13 then
						if (l_return or l_break) then
							l_pos := -1 + 66 -- skip if block
						end
				when 14 then -- if:
						l_c := (l_ptr.item).to_integer_32
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 15 then -- if:
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							if a_len > 0 then
								l_mbyte_blen := (create {P_MBYTE_STATIC}).utfc_ptr2len_len (l_ptr, (a_text + a_len).distance (l_ptr))
							else
								l_mbyte_blen := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr])
							end
						else
							l_mbyte_blen := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr])
						end
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 9_932 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if l_c = 142 then
							l_mbyte_cells := 1
						else
							l_pos := -1 + 18 -- goto _L
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 0 then
							l_mbyte_cells := l_mbyte_blen
						else
							if a_len >= 0 then
								l_u8c := (create {P_MBYTE_STATIC}).utfc_ptr2char_len (l_ptr, l_u8cc, (a_text + a_len).distance (l_ptr))
							else
								l_u8c := (create {P_MBYTE_STATIC}).utfc_ptr2char (l_ptr, l_u8cc)
							end
							l_mbyte_cells := (create {P_MBYTE_STATIC}).utf_char2cells (l_u8c)
							if l_col + l_mbyte_cells > (create {P_GLOBALS_STATIC}).screen_Columns.item then
								l_c := ('>').code
								l_mbyte_cells := 1
							end
						end
				when 19 then -- if done
						l_force_redraw_this := l_force_redraw_next
						l_force_redraw_next := 0
						if ((create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0.to_integer_32]).to_integer_32 = l_c then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_tmp___3 := 1
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 22 then -- else:
						if l_mbyte_cells /= 2 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if ((create {P_GLOBALS_STATIC}).enc_dbcs.item).to_boolean then
							l_tmp___0 := (l_ptr[1]).to_integer_32
						else
							l_tmp___0 := 0
						end
						if ((create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off___0 + {NATURAL_32} 1).to_integer_32]).to_integer_32 /= l_tmp___0 then
							l_tmp___3 := 1
						else
							l_pos := -1 + 25 -- goto _L___3
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 25 then -- else: | _L___3:
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 9_932 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if l_c = 142 then
							if ((create {P_GLOBALS_STATIC}).ScreenLines2.item[l_off___0.to_integer_32]).to_integer_32 /= (l_ptr[1]).to_integer_32 then
								l_tmp___3 := 1
							else
								l_pos := -1 + 28 -- goto _L___2
							end
						else
							l_pos := -1 + 28 -- goto _L___2
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 28 then -- else: | _L___2:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						if l_c < 128 then
							if l_u8cc[0] = 0 then
								l_tmp___1 := 0
							else
								l_tmp___1 := l_u8c
							end
						else
							l_tmp___1 := l_u8c
						end
						if (create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off___0.to_integer_32] /= l_tmp___1.to_natural_32 then
							l_tmp___3 := 1
						elseif (create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off___0.to_integer_32] /= {NATURAL_32} 0 then
							if (screen_comp_differs (l_off___0.to_integer_32, l_u8cc)).to_boolean then
								l_tmp___3 := 1
							else
								l_pos := -1 + 31 -- goto _L___0
							end
						else
							l_pos := -1 + 31 -- goto _L___0
						end
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else: | _L___0:
						if ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0.to_integer_32]).to_integer_32 /= a_attr then
							l_tmp___3 := 1
						elseif ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
							l_tmp___3 := 1
						else
							l_tmp___3 := 0
						end
				when 32 then -- if done | if done | if done
						l_need_redraw := l_tmp___3
						if not (l_need_redraw.to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 36 -- goto _L___8
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 65
				when 35 then -- else:
						if not (l_force_redraw_this.to_boolean) then
							l_pos := -1 + 65 -- skip if block
						end
				when 36 then -- if: | _L___8:
						if not (l_need_redraw.to_boolean) then
							l_pos := -1 + 43 -- skip if block
						end
				when 37 then -- if:
						if ((create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0.to_integer_32]).to_integer_32 = 32 then
							l_pos := -1 + 43 -- skip if block
						end
				when 38 then -- if:
						if not (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						l_pos := -1 + 42 -- goto _L___4
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 41 then -- else:
						if not (((create {P_GLOBALS_STATIC}).term_is_xterm.item).to_boolean) then
							l_pos := -1 + 43 -- skip if block
						end
				when 42 then -- if: | _L___4:
						l_n := ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0.to_integer_32]).to_integer_32
						if l_n > 63 then
							l_n := (create {P_SYNTAX_STATIC}).syn_attr2attr (l_n)
						end
						if ((l_n).bit_and (2)).to_boolean then
							l_force_redraw_next := 1
						end
				when 43 then -- if done | if done | if done
						if not (l_clear_next_cell.to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						l_clear_next_cell := 0
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 46 then -- else:
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 52 -- skip if block
						end
				when 47 then -- if:
						if a_len < 0 then
							l_tmp___4 := ((l_ptr[l_mbyte_blen]).to_integer_32 = 0).to_integer
						else
							l_tmp___4 := (((l_ptr + l_mbyte_blen).c_pointer.to_integer_32).to_natural_32 >= ((a_text + a_len).c_pointer.to_integer_32).to_natural_32).to_integer
						end
						if not (l_tmp___4.to_boolean) then
							l_pos := -1 + 52 -- skip if block
						end
				when 48 then -- if:
						if l_mbyte_cells /= 1 then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						if ((create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([l_off___0, l_max_off])) > 1 then
							l_clear_next_cell := 1
						else
							l_pos := -1 + 51 -- goto _L___5
						end
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 51 then -- else: | _L___5:
						if l_mbyte_cells = 2 then
							if ((create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([l_off___0, l_max_off])) = 1 then
								if ((create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([l_off___0 + {NATURAL_32} 1, l_max_off])) > 1 then
									l_clear_next_cell := 1
								end
							end
						end
				when 52 then -- if done | if done | if done
						if not (((create {P_GLOBALS_STATIC}).enc_dbcs.item).to_boolean) then
							l_pos := -1 + 57 -- skip if block
						end
				when 53 then -- if:
						if l_mbyte_cells /= 1 then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if:
						if ((create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([l_off___0, l_max_off])) > 1 then
							(create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off___0 + l_mbyte_blen.to_natural_32).to_integer_32] := (0).to_natural_8
						else
							l_pos := -1 + 56 -- goto _L___6
						end
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 56 then -- else: | _L___6:
						if l_mbyte_cells = 2 then
							if ((create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([l_off___0, l_max_off])) = 1 then
								if ((create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([l_off___0 + {NATURAL_32} 1, l_max_off])) > 1 then
									(create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off___0 + l_mbyte_blen.to_natural_32).to_integer_32] := (0).to_natural_8
								end
							end
						end
				when 57 then -- if done;
						(create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0.to_integer_32] := l_c.to_natural_8;
						(create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0.to_integer_32] := a_attr.to_natural_16
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 64 -- skip if block
						end
				when 58 then -- if:
						if not (l_c < 128) then
							l_pos := -1 + 61 -- skip if block
						end
				when 59 then -- if:
						if l_u8cc[0] = 0 then
							(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off___0.to_integer_32] := (0).to_natural_32
						else
							l_pos := -1 + 61 -- goto _L___7
						end
				when 60 then -- if block done, skip else block:
						l_pos := -1 + 62
				when 61 then -- else: | _L___7:;
						(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off___0.to_integer_32] := l_u8c.to_natural_32
						l_i___0 := 0
						from
						until
							not (not (l_break) and then (l_i___0 < (create {P_GLOBALS_STATIC}).Screen_mco.item))
						loop
							l_break := False;
							((create {P_GLOBALS_STATIC}).ScreenLinesC.item[l_i___0])[l_off___0.to_integer_32] := (l_u8cc[l_i___0]).to_natural_32
							if l_u8cc[l_i___0] = 0 then
								l_break := True
							end
							if not (l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
				when 62 then
						if l_mbyte_cells = 2 then
							(create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off___0 + {NATURAL_32} 1).to_integer_32] := (0).to_natural_8;
							(create {P_GLOBALS_STATIC}).ScreenAttrs.item[(l_off___0 + {NATURAL_32} 1).to_integer_32] := a_attr.to_natural_16
						end
						screen_char (l_off___0, a_row, l_col)
				when 63 then -- if block done, skip else block:
						l_pos := -1 + 65
				when 64 then -- else:
						if l_mbyte_cells = 2 then
							(create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off___0 + {NATURAL_32} 1).to_integer_32] := l_ptr[1];
							(create {P_GLOBALS_STATIC}).ScreenAttrs.item[(l_off___0 + {NATURAL_32} 1).to_integer_32] := a_attr.to_natural_16
							screen_char_2 (l_off___0, a_row, l_col)
						elseif (create {P_GLOBALS_STATIC}).enc_dbcs.item = 9_932 then
							if l_c = 142 then
								(create {P_GLOBALS_STATIC}).ScreenLines2.item[l_off___0.to_integer_32] := l_ptr[1]
								screen_char (l_off___0, a_row, l_col)
							else
								screen_char (l_off___0, a_row, l_col)
							end
						else
							screen_char (l_off___0, a_row, l_col)
						end
				when 65 then -- if done | if done
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_off___0 := l_off___0 + l_mbyte_cells.to_natural_32
							l_col := l_col + l_mbyte_cells
							l_ptr := l_ptr + l_mbyte_blen
							if l_clear_next_cell.to_boolean then
								l_ptr := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" "))
							end
						else
							l_off___0 := l_off___0 + 1
							l_col := l_col + 1
							l_ptr := l_ptr + 1
						end
				when 66 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 67 then -- loop done
						l_break := False
						if l_force_redraw_next.to_boolean then
							if l_col < (create {P_GLOBALS_STATIC}).screen_Columns.item then
								if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 0 then
									if ((create {P_MBYTE_STATIC}).dbcs_off2cells (l_off___0, l_max_off)) > 1 then
										screen_char_2 (l_off___0, a_row, l_col)
									else
										screen_char (l_off___0, a_row, l_col)
									end
								else
									screen_char (l_off___0, a_row, l_col)
								end
							end
						end
				when 68 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	start_search_hl
		do
			if ((create {P_OPTION_STATIC}).p_hls.item.item).to_boolean then
				if not ((create {P_GLOBALS_STATIC}).no_hlsearch.item).to_boolean then
					(create {P_SEARCH_STATIC}).last_pat_prog (create {CE_CLASS_POINTER [PD_REGMMATCH_T]}.make_shared (search_hl.item.item.c_pointer + (create {PD_MATCH_T}.make).offset_of ("rm")))
					search_hl.item.item.attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[6];
					(create {P_EX_CMDS2_STATIC}).profile_setlimit ((create {P_OPTION_STATIC}).p_rdt.item.item, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (search_hl.item.item.c_pointer + (create {PD_MATCH_T}.make).offset_of ("tm")))
				end
			end
		end

	end_search_hl
		do
			if not (search_hl.item.item.rm.regprog).is_void then
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (search_hl.item.item.rm.regprog))
				search_hl.item.item.rm.regprog := create {CE_CLASS_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
			end
		end

	screen_start_highlight (a_attr: INTEGER_32)
		local
			l_attr: INTEGER_32
			l_aep: CE_POINTER [PD_ATTR_ENTRY]
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_buf___6.make (<<20>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_attr := a_attr
					l_aep := create {CE_CLASS_POINTER [PD_ATTR_ENTRY]}.make_shared (default_pointer)
					screen_attr.item := l_attr
					if not (((create {P_GLOBALS_STATIC}).full_screen.item).to_boolean) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						sprintf ([l_buf___6, ce_string ("%/27/|%%dh"), l_attr]).do_nothing;
						(create {P_TERM_STATIC}).out_str (create {CE_NATURAL_8_POINTER}.make_cast (l_buf___6))
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 4 then -- else:
						if l_attr > 63 then
							if (create {P_GLOBALS_STATIC}).t_colors.item > 1 then
								l_aep := (create {P_SYNTAX_STATIC}).syn_cterm_attr2entry (l_attr)
							else
								l_aep := (create {P_SYNTAX_STATIC}).syn_term_attr2entry (l_attr)
							end
							if l_aep.is_void then
								l_attr := 0
							else
								l_attr := (l_aep.item.ae_attr).to_integer_32
							end
						end
						if not (((l_attr).bit_and (2)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not ((create {P_TERM_STATIC}).term_strings.item[17]).is_void then
							(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[17])
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if not l_aep.is_void then
							if (create {P_GLOBALS_STATIC}).t_colors.item > 1 then
								if (l_aep.item.ae_u.cterm.fg_color).to_boolean then
									if ((create {P_GLOBALS_STATIC}).cterm_normal_fg_bold.item).to_boolean then
										(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[15])
									end
								end
							end
						end
				when 8 then
						if ((l_attr).bit_and (32)).to_boolean then
							if not ((create {P_TERM_STATIC}).term_strings.item[19]).is_void then
								(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[19])
							end
						end
						if ((l_attr).bit_and (24)).to_boolean then
							if not ((create {P_TERM_STATIC}).term_strings.item[23]).is_void then
								(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[23])
							end
						end
						if ((l_attr).bit_and (4)).to_boolean then
							if not ((create {P_TERM_STATIC}).term_strings.item[20]).is_void then
								(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[20])
							end
						end
						if ((l_attr).bit_and (1)).to_boolean then
							if not ((create {P_TERM_STATIC}).term_strings.item[16]).is_void then
								(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[16])
							end
						end
						if not l_aep.is_void then
							if (create {P_GLOBALS_STATIC}).t_colors.item > 1 then
								if (l_aep.item.ae_u.cterm.fg_color).to_boolean then
									(create {P_TERM_STATIC}).term_fg_color ((l_aep.item.ae_u.cterm.fg_color).to_integer_32 - 1)
								end
								if (l_aep.item.ae_u.cterm.bg_color).to_boolean then
									(create {P_TERM_STATIC}).term_bg_color ((l_aep.item.ae_u.cterm.bg_color).to_integer_32 - 1)
								end
							elseif not (l_aep.item.ae_u.term.start).is_void then
								(create {P_TERM_STATIC}).out_str (l_aep.item.ae_u.term.start)
							end
						end
				when 9 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	screen_stop_highlight
		local
			l_do_ME: INTEGER_32
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_aep: CE_POINTER [PD_ATTR_ENTRY]
		do
			create {CE_INTEGER_8_ARRAY} l_buf___6.make (<<20>>)

			l_do_ME := 0
			if screen_attr.item /= 0 then
				if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
					sprintf ([l_buf___6, ce_string ("%/27/|%%dH"), screen_attr.item]).do_nothing;
					(create {P_TERM_STATIC}).out_str (create {CE_NATURAL_8_POINTER}.make_cast (l_buf___6))
				else
					if screen_attr.item > 63 then
						if (create {P_GLOBALS_STATIC}).t_colors.item > 1 then
							l_aep := (create {P_SYNTAX_STATIC}).syn_cterm_attr2entry (screen_attr.item)
							if not l_aep.is_void then
								if (l_aep.item.ae_u.cterm.fg_color).to_boolean then
									l_do_ME := 1
								elseif (l_aep.item.ae_u.cterm.bg_color).to_boolean then
									l_do_ME := 1
								end
							end
						else
							l_aep := (create {P_SYNTAX_STATIC}).syn_term_attr2entry (screen_attr.item)
							if not l_aep.is_void then
								if not (l_aep.item.ae_u.term.stop).is_void then
									if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_aep.item.ae_u.term.stop), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_TERM_STATIC}).term_strings.item[15]))) = 0 then
										l_do_ME := 1
									else
										(create {P_TERM_STATIC}).out_str (l_aep.item.ae_u.term.stop)
									end
								end
							end
						end
						if l_aep.is_void then
							screen_attr.item := 0
						else
							screen_attr.item := (l_aep.item.ae_attr).to_integer_32
						end
					end
					if ((screen_attr.item).bit_and (32)).to_boolean then
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_TERM_STATIC}).term_strings.item[18]), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_TERM_STATIC}).term_strings.item[15]))) = 0 then
							l_do_ME := 1
						else
							(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[18])
						end
					end
					if ((screen_attr.item).bit_and (24)).to_boolean then
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_TERM_STATIC}).term_strings.item[22]), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_TERM_STATIC}).term_strings.item[15]))) = 0 then
							l_do_ME := 1
						else
							(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[22])
						end
					end
					if ((screen_attr.item).bit_and (4)).to_boolean then
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_TERM_STATIC}).term_strings.item[21]), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_TERM_STATIC}).term_strings.item[15]))) = 0 then
							l_do_ME := 1
						else
							(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[21])
						end
					end
					if l_do_ME.to_boolean then
						(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[15])
					elseif ((screen_attr.item).bit_and (3)).to_boolean then
						(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[15])
					end
					if (create {P_GLOBALS_STATIC}).t_colors.item > 1 then
						if (create {P_GLOBALS_STATIC}).cterm_normal_fg_color.item /= 0 then
							(create {P_TERM_STATIC}).term_fg_color ((create {P_GLOBALS_STATIC}).cterm_normal_fg_color.item - 1)
						end
						if (create {P_GLOBALS_STATIC}).cterm_normal_bg_color.item /= 0 then
							(create {P_TERM_STATIC}).term_bg_color ((create {P_GLOBALS_STATIC}).cterm_normal_bg_color.item - 1)
						end
						if ((create {P_GLOBALS_STATIC}).cterm_normal_fg_bold.item).to_boolean then
							(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[17])
						end
					end
				end
			end
			screen_attr.item := 0
		end

	reset_cterm_colors
		do
			if (create {P_GLOBALS_STATIC}).t_colors.item > 1 then
				if (create {P_GLOBALS_STATIC}).cterm_normal_fg_color.item > 0 then
					(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[56])
					screen_attr.item := -1
				elseif (create {P_GLOBALS_STATIC}).cterm_normal_bg_color.item > 0 then
					(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[56])
					screen_attr.item := -1
				end
				if ((create {P_GLOBALS_STATIC}).cterm_normal_fg_bold.item).to_boolean then
					(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[15])
					screen_attr.item := -1
				end
			end
		end

	screen_char (a_off___0: NATURAL_32; a_row, a_col: INTEGER_32)
		local
			l_attr: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<22>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_row >= (create {P_GLOBALS_STATIC}).screen_Rows.item then
						l_return := True
					elseif a_col >= (create {P_GLOBALS_STATIC}).screen_Columns.item then
						l_return := True
					end
					if not l_return and then (a_row = (create {P_GLOBALS_STATIC}).screen_Rows.item - 1) then
						if a_col = (create {P_GLOBALS_STATIC}).screen_Columns.item - 1 then
							(create {P_GLOBALS_STATIC}).ScreenAttrs.item[a_off___0.to_integer_32] := (-1).to_natural_16
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if screen_char_attr.item /= 0 then
							l_attr := screen_char_attr.item
						else
							l_attr := ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[a_off___0.to_integer_32]).to_integer_32
						end
						if screen_attr.item /= l_attr then
							screen_stop_highlight
						end
						windgoto (a_row, a_col)
						if screen_attr.item /= l_attr then
							screen_start_highlight (l_attr)
						end
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (create {P_GLOBALS_STATIC}).ScreenLinesUC.item[a_off___0.to_integer_32] /= {NATURAL_32} 0 then
							l_buf___6[((create {P_MBYTE_STATIC}).utfc_char2bytes (a_off___0.to_integer_32, l_buf___6))] := (('%/0/').code).to_natural_8;
							(create {P_TERM_STATIC}).out_str (l_buf___6)
							if ((create {P_MBYTE_STATIC}).utf_char2cells (((create {P_GLOBALS_STATIC}).ScreenLinesUC.item[a_off___0.to_integer_32]).to_integer_32)) > 1 then
								screen_cur_col.item := screen_cur_col.item + 1
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:;
						(create {P_TERM_STATIC}).out_flush_check;
						(create {P_TERM_STATIC}).out_char (((create {P_GLOBALS_STATIC}).ScreenLines.item[a_off___0.to_integer_32]).to_natural_32)
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 9_932 then
							if ((create {P_GLOBALS_STATIC}).ScreenLines.item[a_off___0.to_integer_32]).to_integer_32 = 142 then
								(create {P_TERM_STATIC}).out_char (((create {P_GLOBALS_STATIC}).ScreenLines2.item[a_off___0.to_integer_32]).to_natural_32)
							end
						end
				when 5 then
						screen_cur_col.item := screen_cur_col.item + 1
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	screen_char_2 (a_off___0: NATURAL_32; a_row, a_col: INTEGER_32)
		local
			l_return: BOOLEAN
		do
			if a_off___0 + {NATURAL_32} 1 >= ((create {P_GLOBALS_STATIC}).screen_Rows.item * (create {P_GLOBALS_STATIC}).screen_Columns.item).to_natural_32 then
				l_return := True
			end
			if not l_return and then (a_row = (create {P_GLOBALS_STATIC}).screen_Rows.item - 1) then
				if a_col >= (create {P_GLOBALS_STATIC}).screen_Columns.item - 2 then
					(create {P_GLOBALS_STATIC}).ScreenAttrs.item[a_off___0.to_integer_32] := (-1).to_natural_16
					l_return := True
				end
			end
			if not l_return then
				screen_char (a_off___0, a_row, a_col);
				(create {P_TERM_STATIC}).out_char (((create {P_GLOBALS_STATIC}).ScreenLines.item[(a_off___0 + {NATURAL_32} 1).to_integer_32]).to_natural_32)
				screen_cur_col.item := screen_cur_col.item + 1
			end
		end

	screen_draw_rectangle (a_row, a_col, a_height, a_width, a_invert: INTEGER_32)
		local
			l_r: INTEGER_32
			l_c: INTEGER_32
			l_off___0: INTEGER_32
			l_max_off: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if a_invert.to_boolean then
							screen_char_attr.item := 1
						end
						l_r := a_row
				when 2 then -- loop condition:
						if not (not (l_return) and then (l_r < a_row + a_height)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 3 then -- loop body:
						l_off___0 := ((create {P_GLOBALS_STATIC}).LineOffset.item[l_r]).to_integer_32
						l_max_off := l_off___0 + (create {P_GLOBALS_STATIC}).screen_Columns.item
						l_c := a_col
				when 4 then -- loop condition:
						if not (l_c < a_col + a_width) then
							l_pos := -1 + 10 -- skip loop
						end
				when 5 then -- loop body:
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if ((create {P_MBYTE_STATIC}).dbcs_off2cells ((l_off___0 + l_c).to_natural_32, l_max_off.to_natural_32)) > 1 then
							screen_char_2 ((l_off___0 + l_c).to_natural_32, l_r, l_c)
							l_c := l_c + 1
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						screen_char ((l_off___0 + l_c).to_natural_32, l_r, l_c)
						if ((create {P_MBYTE_STATIC}).utf_off2cells ((l_off___0 + l_c).to_natural_32, l_max_off.to_natural_32)) > 1 then
							l_c := l_c + 1
						end
				when 9 then
						l_c := l_c + 1
						l_pos := -1 + 4 -- back to loop condition
				when 10 then -- loop done
						l_r := l_r + 1
						l_pos := -1 + 2 -- back to loop condition
				when 11 then -- loop done
						screen_char_attr.item := 0
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	redraw_block (a_row, a_end: INTEGER_32; a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_col: INTEGER_32
			l_width: INTEGER_32
		do
			(create {P_UI_STATIC}).clip_may_clear_selection (a_row, a_end - 1)
			if a_wp___0.is_void then
				l_col := 0
				l_width := ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32
			else
				l_col := a_wp___0.item.w_wincol
				l_width := a_wp___0.item.w_width
			end
			screen_draw_rectangle (a_row, l_col, a_end - a_row, l_width, 0)
		end

	screen_fill (a_start_row, a_end_row, a_start_col, a_end_col, a_c1, a_c2, a_attr: INTEGER_32)
		local
			l_end_row: INTEGER_32
			l_end_col: INTEGER_32
			l_row: INTEGER_32
			l_col: INTEGER_32
			l_off___0: INTEGER_32
			l_end_off: INTEGER_32
			l_did_delete: INTEGER_32
			l_c: INTEGER_32
			l_norm_term: INTEGER_32
			l_force_next: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_end_row := a_end_row
					l_end_col := a_end_col
					l_force_next := 0
					if l_end_row > (create {P_GLOBALS_STATIC}).screen_Rows.item then
						l_end_row := (create {P_GLOBALS_STATIC}).screen_Rows.item
					end
					if l_end_col > (create {P_GLOBALS_STATIC}).screen_Columns.item then
						l_end_col := (create {P_GLOBALS_STATIC}).screen_Columns.item
					end
					if ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
						l_return := True
					elseif a_start_row >= l_end_row then
						l_return := True
					elseif a_start_col >= l_end_col then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 33 -- skip if block
					end
				when 1 then -- if:
						if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							if (create {P_GLOBALS_STATIC}).t_colors.item <= 1 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
						l_norm_term := l_tmp
						l_row := a_start_row
				when 2 then -- loop condition:
						if not (not (l_return) and then (l_row < l_end_row)) then
							l_pos := -1 + 33 -- skip loop
						end
				when 3 then -- loop body:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
								if a_start_col > 0 then
									if ((create {P_MBYTE_STATIC}).mb_fix_col (a_start_col, l_row)) /= a_start_col then
										screen_puts_len (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")), 1, l_row, a_start_col - 1, 0)
									end
								end
								if l_end_col < (create {P_GLOBALS_STATIC}).screen_Columns.item then
									if ((create {P_MBYTE_STATIC}).mb_fix_col (l_end_col, l_row)) /= l_end_col then
										screen_puts_len (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")), 1, l_row, l_end_col, 0)
									end
								end
							end
						end
						l_did_delete := 0
						if a_c2 /= 32 then
							l_pos := -1 + 13 -- skip if block
						end
				when 4 then -- if:
						if l_end_col.to_integer_32 /= (create {P_GLOBALS_STATIC}).Columns.item.item then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if not ((can_clear ((create {P_TERM_STATIC}).term_strings.item[1])).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 6 then -- if:
						if a_attr /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not (l_norm_term.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 10 then -- if:
						if not (a_attr <= 63) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if ((a_attr).bit_and (-7)) /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						l_col := a_start_col
						if a_c1 /= 32 then
							l_col := l_col + 1
						end
						l_off___0 := ((create {P_GLOBALS_STATIC}).LineOffset.item[l_row] + l_col.to_natural_32).to_integer_32
						l_end_off := ((create {P_GLOBALS_STATIC}).LineOffset.item[l_row] + l_end_col.to_natural_32).to_integer_32
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							from
							until
								(l_break)
							loop
								l_break := False
								if l_off___0 < l_end_off then
									if ((create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0]).to_integer_32 = 32 then
										if ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0]).to_integer_32 = 0 then
											if (create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off___0] /= {NATURAL_32} 0 then
												l_break := True
											end
										else
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_off___0 := l_off___0 + 1
								end
							end
							l_break := False
						else
							from
							until
								(l_break)
							loop
								l_break := False
								if l_off___0 < l_end_off then
									if ((create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0]).to_integer_32 = 32 then
										if ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0]).to_integer_32 /= 0 then
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_off___0 := l_off___0 + 1
								end
							end
							l_break := False
						end
						if l_off___0 < l_end_off then
							l_col := (l_off___0.to_natural_32 - (create {P_GLOBALS_STATIC}).LineOffset.item[l_row]).to_integer_32
							screen_stop_highlight;
							(create {P_TERM_STATIC}).term_windgoto (l_row, l_col);
							(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[1])
							screen_start
							l_col := l_end_col - l_col
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___2 := l_col
								l_col := l_col - 1
								if not l_tmp___2.to_boolean then
									l_break := True
								end
								if not (l_break) then
									(create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0] := ((' ').code).to_natural_8
									if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
										(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off___0] := (0).to_natural_32
									end
									(create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0] := (0).to_natural_16
									l_off___0 := l_off___0 + 1
								end
							end
							l_break := False
						end
						l_did_delete := 1
				when 13 then -- if done | if done | if done | if done | if done | if done
						l_off___0 := ((create {P_GLOBALS_STATIC}).LineOffset.item[l_row] + a_start_col.to_natural_32).to_integer_32
						l_c := a_c1
						l_col := a_start_col
				when 14 then -- loop condition:
						if not (not (l_break) and then (l_col < l_end_col)) then
							l_pos := -1 + 32 -- skip loop
						end
				when 15 then -- loop body:
						l_break := False
						if ((create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0]).to_integer_32 = l_c then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 25 -- goto _L___1
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 18 then -- else:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if l_c >= 128 then
							l_tmp___4 := l_c
						else
							l_tmp___4 := 0
						end
						if ((create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off___0]).to_integer_32 /= l_tmp___4 then
							l_pos := -1 + 25 -- goto _L___1
						else
							l_pos := -1 + 21 -- goto _L___2
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 21 then -- else: | _L___2:
						if ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0]).to_integer_32 = a_attr then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L___1
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 24 then -- else:
						if not (l_force_next.to_boolean) then
							l_pos := -1 + 31 -- skip if block
						end
				when 25 then -- if: | _L___1:
						if not (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 29 -- goto _L___0
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 28 then -- else:
						if not (((create {P_GLOBALS_STATIC}).term_is_xterm.item).to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 29 then -- if: | _L___0:
						if ((create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0]).to_integer_32 /= 32 then
							if ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0]).to_integer_32 > 63 then
								l_force_next := 1
							elseif ((((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0]).to_integer_32).bit_and (2)).to_boolean then
								l_force_next := 1
							else
								l_force_next := 0
							end
						else
							l_force_next := 0
						end
				when 30 then -- if done;
						(create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0] := l_c.to_natural_8
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							if l_c >= 128 then
								(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off___0] := l_c.to_natural_32;
								((create {P_GLOBALS_STATIC}).ScreenLinesC.item[0])[l_off___0] := (0).to_natural_32
							else
								(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off___0] := (0).to_natural_32
							end
						end
						(create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0] := a_attr.to_natural_16
						if not l_did_delete.to_boolean then
							screen_char (l_off___0.to_natural_32, l_row, l_col)
						elseif l_c /= 32 then
							screen_char (l_off___0.to_natural_32, l_row, l_col)
						end
				when 31 then -- if done | if done | if done
						l_off___0 := l_off___0 + 1
						if l_col = a_start_col then
							if l_did_delete.to_boolean then
								l_break := True
							end
							if not (l_break) then
								l_c := a_c2
							end
						end
						if not (l_break) then
							l_col := l_col + 1
						end
						l_pos := -1 + 14 -- back to loop condition
				when 32 then -- loop done
						l_break := False
						if l_end_col.to_integer_32 = (create {P_GLOBALS_STATIC}).Columns.item.item then
							(create {P_GLOBALS_STATIC}).LineWraps.item[l_row] := (0).to_natural_8
						end
						if l_row.to_integer_32 = (create {P_GLOBALS_STATIC}).Rows.item.item - 1 then
							(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
							if a_c1 = 32 then
								if a_c2 = 32 then
									(create {P_GLOBALS_STATIC}).clear_cmdline.item := 0
								end
							end
							if a_start_col = 0 then
								(create {P_GLOBALS_STATIC}).mode_displayed.item := 0
							end
						end
						l_row := l_row + 1
						l_pos := -1 + 2 -- back to loop condition
				when 33 then -- loop done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_for_delay (a_check_msg_scroll: INTEGER_32)
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (((create {P_GLOBALS_STATIC}).emsg_on_display.item).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 3 then -- else:
						if not (a_check_msg_scroll.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not (((create {P_GLOBALS_STATIC}).msg_scroll.item).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if not ((create {P_GLOBALS_STATIC}).did_wait_return.item).to_boolean then
							if (create {P_GLOBALS_STATIC}).emsg_silent.item = 0 then
								(create {P_TERM_STATIC}).out_flush;
								(create {P_UI_STATIC}).ui_delay (1_000, 1);
								(create {P_GLOBALS_STATIC}).emsg_on_display.item := 0
								if a_check_msg_scroll.to_boolean then
									(create {P_GLOBALS_STATIC}).msg_scroll.item := 0
								end
							end
						end
				when 6 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	screen_valid (a_clear: INTEGER_32): INTEGER_32
		do
			screenalloc (a_clear)
			Result := (not ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void).to_integer
		end

	screenalloc (a_clear: INTEGER_32)
		local
			l_new_row: INTEGER_32
			l_old_row: INTEGER_32
			l_old_Rows___0: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_outofmem: INTEGER_32
			l_len: INTEGER_32
			l_new_ScreenLines: CE_POINTER [NATURAL_8]
			l_new_ScreenLinesUC: CE_POINTER [NATURAL_32]
			l_new_ScreenLinesC: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_new_ScreenLines2: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_new_ScreenAttrs: CE_POINTER [NATURAL_16]
			l_new_LineOffset: CE_POINTER [NATURAL_32]
			l_new_LineWraps: CE_POINTER [NATURAL_8]
			l_new_TabPageIdxs: CE_POINTER [INTEGER_16]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_retry_count: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_new_ScreenLinesC.make (<<6>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_outofmem := 0
					l_new_ScreenLinesUC := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
					l_new_ScreenLines2 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_retry_count := 0
				when 1 then -- retry:
					if ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						if (create {P_GLOBALS_STATIC}).Rows.item.item = ((create {P_GLOBALS_STATIC}).screen_Rows.item).to_integer_32 then
							if (create {P_GLOBALS_STATIC}).Columns.item.item = ((create {P_GLOBALS_STATIC}).screen_Columns.item).to_integer_32 then
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean = (not ((create {P_GLOBALS_STATIC}).ScreenLinesUC.item).is_void) then
									if ((create {P_GLOBALS_STATIC}).enc_dbcs.item = 9_932) = (not ((create {P_GLOBALS_STATIC}).ScreenLines2.item).is_void) then
										if (create {P_OPTION_STATIC}).p_mco.item.item = ((create {P_GLOBALS_STATIC}).Screen_mco.item).to_integer_32 then
											l_return := True
										else
											l_pos := -1 + 4 -- goto _L___3
										end
									else
										l_pos := -1 + 4 -- goto _L___3
									end
								else
									l_pos := -1 + 4 -- goto _L___3
								end
							else
								l_pos := -1 + 4 -- goto _L___3
							end
						else
							l_pos := -1 + 4 -- goto _L___3
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L___3:
						if (create {P_GLOBALS_STATIC}).Rows.item.item = 0 then
							l_return := True
						elseif (create {P_GLOBALS_STATIC}).Columns.item.item = 0 then
							l_return := True
						elseif not ((create {P_GLOBALS_STATIC}).full_screen.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
								l_return := True
							end
						end
				when 5 then
					if not l_return and then (entered___4.item.to_boolean) then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 51 -- skip if block
					end
				when 6 then -- if:
						entered___4.item := 1;
						(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item + 1;
						(create {P_TERM_STATIC}).win_new_shellsize;
						(create {P_OPTION_STATIC}).comp_col
						l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
						from
						until
							not (not (l_return) and then (not l_tp.is_void))
						loop
							if l_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
								l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
							else
								l_wp___0 := l_tp.item.tp_firstwin
							end
							from
							until
								l_wp___0.is_void
							loop
								l_wp___0.item.win_free_lsize
								l_wp___0 := l_wp___0.item.w_next
							end
							l_tp := l_tp.item.tp_next
						end
						if not ((create {P_GLOBALS_STATIC}).aucmd_win.item).is_void then
							((create {P_GLOBALS_STATIC}).aucmd_win.item).item.win_free_lsize
						end
						l_new_ScreenLines := ((create {P_MISC2_STATIC}).lalloc ((((create {P_GLOBALS_STATIC}).Rows.item.item + 1) * (create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32 * ({PLATFORM}.Natural_8_bytes.to_natural_32).to_natural_32, 0))
						memset (create {CE_VOID_POINTER}.make_cast (l_new_ScreenLinesC), 0, {PLATFORM}.Pointer_bytes.to_natural_32 * {NATURAL_32} 6).do_nothing
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							l_new_ScreenLinesUC := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_MISC2_STATIC}).lalloc ((((create {P_GLOBALS_STATIC}).Rows.item.item + 1) * (create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32, 0)))
							l_i___0 := 0
							from
							until
								not (l_i___0.to_integer_32 < (create {P_OPTION_STATIC}).p_mco.item.item)
							loop
								l_new_ScreenLinesC[l_i___0] := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_MISC2_STATIC}).lalloc_clear ((((create {P_GLOBALS_STATIC}).Rows.item.item + 1) * (create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32, 0)))
								l_i___0 := l_i___0 + 1
							end
						end
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 9_932 then
							l_new_ScreenLines2 := ((create {P_MISC2_STATIC}).lalloc ((((create {P_GLOBALS_STATIC}).Rows.item.item + 1) * (create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32 * ({PLATFORM}.Natural_8_bytes.to_natural_32).to_natural_32, 0))
						end
						l_new_ScreenAttrs := create {CE_NATURAL_16_POINTER}.make_cast (((create {P_MISC2_STATIC}).lalloc ((((create {P_GLOBALS_STATIC}).Rows.item.item + 1) * (create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32 * ({PLATFORM}.Natural_16_bytes.to_natural_32).to_natural_32, 0)))
						l_new_LineOffset := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_MISC2_STATIC}).lalloc (((create {P_GLOBALS_STATIC}).Rows.item.item).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32, 0)))
						l_new_LineWraps := ((create {P_MISC2_STATIC}).lalloc (((create {P_GLOBALS_STATIC}).Rows.item.item).to_natural_32 * ({PLATFORM}.Natural_8_bytes.to_natural_32).to_natural_32, 0))
						l_new_TabPageIdxs := create {CE_INTEGER_16_POINTER}.make_cast (((create {P_MISC2_STATIC}).lalloc (((create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32 * ({PLATFORM}.Integer_16_bytes.to_natural_32).to_natural_32, 0)))
						l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
				when 7 then -- loop condition:
						if not (not (l_return) and then (not l_tp.is_void)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 8 then -- loop body:
						if l_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
							l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
						else
							l_wp___0 := l_tp.item.tp_firstwin
						end
				when 9 then -- loop condition:
						if l_wp___0.is_void then
							l_pos := -1 + 12 -- skip loop
						end
				when 10 then -- loop body:
						if (l_wp___0.item.win_alloc_lines) = 0 then
							l_outofmem := 1
							l_pos := -1 + 14 -- goto give_up
						end
				when 11 then
						l_wp___0 := l_wp___0.item.w_next
						l_pos := -1 + 9 -- back to loop condition
				when 12 then -- loop done
						l_tp := l_tp.item.tp_next
						l_pos := -1 + 7 -- back to loop condition
				when 13 then -- loop done
						if not ((create {P_GLOBALS_STATIC}).aucmd_win.item).is_void then
							if ((create {P_GLOBALS_STATIC}).aucmd_win.item.item.w_lines).is_void then
								if (((create {P_GLOBALS_STATIC}).aucmd_win.item).item.win_alloc_lines) = 0 then
									l_outofmem := 1
								end
							end
						end
				when 14 then -- give_up:
						l_i___0 := 0
						from
						until
							not (not (l_break) and then (l_i___0.to_integer_32 < (create {P_OPTION_STATIC}).p_mco.item.item))
						loop
							l_break := False
							if (l_new_ScreenLinesC[l_i___0]).is_void then
								l_break := True
							end
							if not (l_return or l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						if not (l_new_ScreenLines.is_void) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 36 -- goto _L___5
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 17 then -- else:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if l_new_ScreenLinesUC.is_void then
							l_pos := -1 + 36 -- goto _L___5
						elseif l_i___0.to_integer_32 /= (create {P_OPTION_STATIC}).p_mco.item.item then
							l_pos := -1 + 36 -- goto _L___5
						else
							l_pos := -1 + 20 -- goto _L___7
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 20 then -- else: | _L___7:
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 9_932 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if l_new_ScreenLines2.is_void then
							l_pos := -1 + 36 -- goto _L___5
						else
							l_pos := -1 + 23 -- goto _L___6
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 23 then -- else: | _L___6:
						if not (l_new_ScreenAttrs.is_void) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 36 -- goto _L___5
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 26 then -- else:
						if not (l_new_LineOffset.is_void) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						l_pos := -1 + 36 -- goto _L___5
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 29 then -- else:
						if not (l_new_LineWraps.is_void) then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 36 -- goto _L___5
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 32 then -- else:
						if not (l_new_TabPageIdxs.is_void) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 36 -- goto _L___5
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 35 then -- else:
						if not (l_outofmem.to_boolean) then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if: | _L___5:
						if not ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
							(create {P_MISC2_STATIC}).do_outofmem_msg ((((create {P_GLOBALS_STATIC}).Rows.item.item + 1) * (create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32)
							done_outofmem_msg.item := 1
						elseif not done_outofmem_msg.item.to_boolean then
							(create {P_MISC2_STATIC}).do_outofmem_msg ((((create {P_GLOBALS_STATIC}).Rows.item.item + 1) * (create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32)
							done_outofmem_msg.item := 1
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_new_ScreenLines))
						l_new_ScreenLines := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_new_ScreenLinesUC))
						l_new_ScreenLinesUC := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
						l_i___0 := 0
						from
						until
							not (l_i___0.to_integer_32 < (create {P_OPTION_STATIC}).p_mco.item.item)
						loop
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_new_ScreenLinesC[l_i___0]))
							l_new_ScreenLinesC[l_i___0] := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
							l_i___0 := l_i___0 + 1
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_new_ScreenLines2))
						l_new_ScreenLines2 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_new_ScreenAttrs))
						l_new_ScreenAttrs := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_new_LineOffset))
						l_new_LineOffset := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_new_LineWraps))
						l_new_LineWraps := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_new_TabPageIdxs))
						l_new_TabPageIdxs := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 38 then -- else:
						done_outofmem_msg.item := 0
						l_new_row := 0
				when 39 then -- loop condition:
						if not (not (l_return) and then (l_new_row.to_integer_32 < (create {P_GLOBALS_STATIC}).Rows.item.item)) then
							l_pos := -1 + 49 -- skip loop
						end
				when 40 then -- loop body:
						l_new_LineOffset[l_new_row] := (l_new_row.to_integer_32 * (create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32
						l_new_LineWraps[l_new_row] := (0).to_natural_8
						if a_clear.to_boolean then
							l_pos := -1 + 48 -- skip if block
						end
				when 41 then -- if:
						memset (create {CE_VOID_POINTER}.make_cast ((l_new_ScreenLines + l_new_row.to_integer_32 * (create {P_GLOBALS_STATIC}).Columns.item.item)), (' ').code, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32 * {PLATFORM}.Natural_8_bytes.to_natural_32).do_nothing
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							memset (create {CE_VOID_POINTER}.make_cast ((l_new_ScreenLinesUC + l_new_row.to_integer_32 * (create {P_GLOBALS_STATIC}).Columns.item.item)), 0, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
							l_i___0 := 0
							from
							until
								not (l_i___0.to_integer_32 < (create {P_OPTION_STATIC}).p_mco.item.item)
							loop
								memset (create {CE_VOID_POINTER}.make_cast ((l_new_ScreenLinesC[l_i___0] + l_new_row.to_integer_32 * (create {P_GLOBALS_STATIC}).Columns.item.item)), 0, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
								l_i___0 := l_i___0 + 1
							end
						end
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 9_932 then
							memset (create {CE_VOID_POINTER}.make_cast ((l_new_ScreenLines2 + l_new_row.to_integer_32 * (create {P_GLOBALS_STATIC}).Columns.item.item)), 0, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32 * {PLATFORM}.Natural_8_bytes.to_natural_32).do_nothing
						end
						memset (create {CE_VOID_POINTER}.make_cast ((l_new_ScreenAttrs + l_new_row.to_integer_32 * (create {P_GLOBALS_STATIC}).Columns.item.item)), 0, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32 * {PLATFORM}.Natural_16_bytes.to_natural_32).do_nothing
						l_old_row := (l_new_row.to_integer_32 + (((create {P_GLOBALS_STATIC}).screen_Rows.item).to_integer_32 - (create {P_GLOBALS_STATIC}).Rows.item.item)).to_integer_32
						if not (l_old_row >= 0) then
							l_pos := -1 + 48 -- skip if block
						end
				when 42 then -- if:
						if ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
							l_pos := -1 + 48 -- skip if block
						end
				when 43 then -- if:
						if ((create {P_GLOBALS_STATIC}).screen_Columns.item).to_integer_32 < (create {P_GLOBALS_STATIC}).Columns.item.item then
							l_len := (create {P_GLOBALS_STATIC}).screen_Columns.item
						else
							l_len := ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32
						end
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						if not (((create {P_GLOBALS_STATIC}).ScreenLinesUC.item).is_void) then
							l_pos := -1 + 46 -- goto _L___4
						end
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else: | _L___4:
						if (create {P_OPTION_STATIC}).p_mco.item.item = ((create {P_GLOBALS_STATIC}).Screen_mco.item).to_integer_32 then
							memmove (create {CE_VOID_POINTER}.make_cast ((l_new_ScreenLines + (l_new_LineOffset[l_new_row]).to_integer_32)), create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenLines.item + ((create {P_GLOBALS_STATIC}).LineOffset.item[l_old_row]).to_integer_32)), l_len.to_natural_32 * {PLATFORM}.Natural_8_bytes.to_natural_32).do_nothing
						end
				when 47 then
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							if not ((create {P_GLOBALS_STATIC}).ScreenLinesUC.item).is_void then
								if (create {P_OPTION_STATIC}).p_mco.item.item = ((create {P_GLOBALS_STATIC}).Screen_mco.item).to_integer_32 then
									memmove (create {CE_VOID_POINTER}.make_cast ((l_new_ScreenLinesUC + (l_new_LineOffset[l_new_row]).to_integer_32)), create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenLinesUC.item + ((create {P_GLOBALS_STATIC}).LineOffset.item[l_old_row]).to_integer_32)), l_len.to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
									l_i___0 := 0
									from
									until
										not (l_i___0.to_integer_32 < (create {P_OPTION_STATIC}).p_mco.item.item)
									loop
										memmove (create {CE_VOID_POINTER}.make_cast ((l_new_ScreenLinesC[l_i___0] + (l_new_LineOffset[l_new_row]).to_integer_32)), create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenLinesC.item[l_i___0] + ((create {P_GLOBALS_STATIC}).LineOffset.item[l_old_row]).to_integer_32)), l_len.to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
										l_i___0 := l_i___0 + 1
									end
								end
							end
						end
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 9_932 then
							if not ((create {P_GLOBALS_STATIC}).ScreenLines2.item).is_void then
								memmove (create {CE_VOID_POINTER}.make_cast ((l_new_ScreenLines2 + (l_new_LineOffset[l_new_row]).to_integer_32)), create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenLines2.item + ((create {P_GLOBALS_STATIC}).LineOffset.item[l_old_row]).to_integer_32)), l_len.to_natural_32 * {PLATFORM}.Natural_8_bytes.to_natural_32).do_nothing
							end
						end
						memmove (create {CE_VOID_POINTER}.make_cast ((l_new_ScreenAttrs + (l_new_LineOffset[l_new_row]).to_integer_32)), create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenAttrs.item + ((create {P_GLOBALS_STATIC}).LineOffset.item[l_old_row]).to_integer_32)), l_len.to_natural_32 * {PLATFORM}.Natural_16_bytes.to_natural_32).do_nothing
				when 48 then -- if done | if done | if done
						l_new_row := l_new_row + 1
						l_pos := -1 + 39 -- back to loop condition
				when 49 then -- loop done
						current_ScreenLine.item := l_new_ScreenLines + (create {P_GLOBALS_STATIC}).Rows.item.item * (create {P_GLOBALS_STATIC}).Columns.item.item
				when 50 then -- if done | if done | if done | if done | if done | if done | if done
						free_screenlines;
						(create {P_GLOBALS_STATIC}).ScreenLines.item := l_new_ScreenLines;
						(create {P_GLOBALS_STATIC}).ScreenLinesUC.item := l_new_ScreenLinesUC
						l_i___0 := 0
						from
						until
							not (l_i___0.to_integer_32 < (create {P_OPTION_STATIC}).p_mco.item.item)
						loop
							(create {P_GLOBALS_STATIC}).ScreenLinesC.item[l_i___0] := l_new_ScreenLinesC[l_i___0]
							l_i___0 := l_i___0 + 1
						end
						(create {P_GLOBALS_STATIC}).Screen_mco.item := ((create {P_OPTION_STATIC}).p_mco.item.item).to_integer_32;
						(create {P_GLOBALS_STATIC}).ScreenLines2.item := l_new_ScreenLines2;
						(create {P_GLOBALS_STATIC}).ScreenAttrs.item := l_new_ScreenAttrs;
						(create {P_GLOBALS_STATIC}).LineOffset.item := l_new_LineOffset;
						(create {P_GLOBALS_STATIC}).LineWraps.item := l_new_LineWraps;
						(create {P_GLOBALS_STATIC}).TabPageIdxs.item := l_new_TabPageIdxs
						l_old_Rows___0 := (create {P_GLOBALS_STATIC}).screen_Rows.item;
						(create {P_GLOBALS_STATIC}).screen_Rows.item := ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32;
						(create {P_GLOBALS_STATIC}).screen_Columns.item := ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32;
						(create {P_GLOBALS_STATIC}).must_redraw.item := 50
						if a_clear.to_boolean then
							screenclear2
						elseif ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							if not ((create {P_GUI_STATIC}).gui.item.item.starting).to_boolean then
								if not ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
									if l_old_Rows___0.to_integer_32 /= (create {P_GLOBALS_STATIC}).Rows.item.item then
										(create {P_GUI_STATIC}).gui_redraw_block (0, 0, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 1, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32 - 1, 0).do_nothing
										if ((create {P_GLOBALS_STATIC}).msg_row.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Rows.item.item then
											(create {P_GLOBALS_STATIC}).msg_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
										elseif (create {P_GLOBALS_STATIC}).Rows.item.item > l_old_Rows___0.to_integer_32 then
											(create {P_GLOBALS_STATIC}).msg_row.item := (((create {P_GLOBALS_STATIC}).msg_row.item).to_integer_32 + ((create {P_GLOBALS_STATIC}).Rows.item.item - l_old_Rows___0.to_integer_32)).to_integer_32
										end
										if ((create {P_GLOBALS_STATIC}).msg_col.item).to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item then
											(create {P_GLOBALS_STATIC}).msg_col.item := ((create {P_GLOBALS_STATIC}).Columns.item.item - 1).to_integer_32
										end
									end
								end
							end
						end
						entered___4.item := 0;
						(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item - 1
						if (create {P_GLOBALS_STATIC}).starting.item = 0 then
							l_retry_count := l_retry_count + 1
							if l_retry_count <= 3 then
								(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_VIMRESIZED, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
								l_pos := -1 + 1 -- goto retry
							end
						end
				when 51 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	free_screenlines
		local
			l_i___0: INTEGER_32
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).ScreenLinesUC.item))
			l_i___0 := 0
			from
			until
				not (l_i___0 < (create {P_GLOBALS_STATIC}).Screen_mco.item)
			loop
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).ScreenLinesC.item[l_i___0]))
				l_i___0 := l_i___0 + 1
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).ScreenLines2.item));
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).ScreenLines.item));
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).ScreenAttrs.item));
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).LineOffset.item));
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).LineWraps.item));
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).TabPageIdxs.item))
		end

	screenclear
		do
			check_for_delay (0)
			screenalloc (0)
			screenclear2
		end

	screenclear2
		local
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			if (create {P_GLOBALS_STATIC}).starting.item = 2 then
				l_return := True
			elseif ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
				l_return := True
			elseif ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				if ((create {P_GUI_STATIC}).gui.item.item.starting).to_boolean then
					l_return := True
				end
			end
			if not l_return then
				if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
					screen_attr.item := -1
				end
				screen_stop_highlight;
				(create {P_UI_STATIC}).clip_scroll_selection (9_999)
				l_i___0 := 0
				from
				until
					not (l_i___0.to_integer_32 < (create {P_GLOBALS_STATIC}).Rows.item.item)
				loop
					lineclear ((create {P_GLOBALS_STATIC}).LineOffset.item[l_i___0], ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32);
					(create {P_GLOBALS_STATIC}).LineWraps.item[l_i___0] := (0).to_natural_8
					l_i___0 := l_i___0 + 1
				end
				if (can_clear ((create {P_TERM_STATIC}).term_strings.item[7])).to_boolean then
					(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[7]);
					(create {P_GLOBALS_STATIC}).clear_cmdline.item := 0;
					(create {P_GLOBALS_STATIC}).mode_displayed.item := 0
				else
					l_i___0 := 0
					from
					until
						not (l_i___0.to_integer_32 < (create {P_GLOBALS_STATIC}).Rows.item.item)
					loop
						lineinvalid ((create {P_GLOBALS_STATIC}).LineOffset.item[l_i___0], ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32)
						l_i___0 := l_i___0 + 1
					end
					(create {P_GLOBALS_STATIC}).clear_cmdline.item := 1
				end
				(create {P_GLOBALS_STATIC}).screen_cleared.item := 1
				win_rest_invalid ((create {P_GLOBALS_STATIC}).firstwin.item);
				(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1;
				(create {P_GLOBALS_STATIC}).redraw_tabline.item := 1
				if (create {P_GLOBALS_STATIC}).must_redraw.item = 50 then
					(create {P_GLOBALS_STATIC}).must_redraw.item := 40
				end
				(create {P_EX_GETLN_STATIC}).compute_cmdrow;
				(create {P_GLOBALS_STATIC}).msg_row.item := (create {P_GLOBALS_STATIC}).cmdline_row.item;
				(create {P_GLOBALS_STATIC}).msg_col.item := 0
				screen_start;
				(create {P_GLOBALS_STATIC}).msg_scrolled.item := 0;
				(create {P_GLOBALS_STATIC}).msg_didany.item := 0;
				(create {P_GLOBALS_STATIC}).msg_didout.item := 0
			end
		end

	lineclear (a_off___0: NATURAL_32; a_width: INTEGER_32)
		do
			memset (create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenLines.item + a_off___0.to_integer_32)), (' ').code, a_width.to_natural_32 * {PLATFORM}.Natural_8_bytes.to_natural_32).do_nothing
			if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
				memset (create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenLinesUC.item + a_off___0.to_integer_32)), 0, a_width.to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
			end
			memset (create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenAttrs.item + a_off___0.to_integer_32)), 0, a_width.to_natural_32 * {PLATFORM}.Natural_16_bytes.to_natural_32).do_nothing
		end

	lineinvalid (a_off___0: NATURAL_32; a_width: INTEGER_32)
		do
			memset (create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenAttrs.item + a_off___0.to_integer_32)), -1, a_width.to_natural_32 * {PLATFORM}.Natural_16_bytes.to_natural_32).do_nothing
		end

	can_clear (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_tmp: INTEGER_32
		do
			if (a_p___0.item).to_integer_32 /= 0 then
				if (create {P_GLOBALS_STATIC}).t_colors.item <= 1 then
					l_tmp := 1
				elseif ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
					l_tmp := 1
				elseif (create {P_GLOBALS_STATIC}).cterm_normal_bg_color.item = 0 then
					l_tmp := 1
				elseif (((create {P_TERM_STATIC}).term_strings.item[9]).item).to_integer_32 /= 0 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	screen_start
		do
			screen_cur_col.item := 9_999
			screen_cur_row.item := screen_cur_col.item
		end

	windgoto (a_row, a_col: INTEGER_32)
		local
			l_row: INTEGER_32
			l_col: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_16]
			l_i___0: INTEGER_32
			l_plan: INTEGER_32
			l_cost: INTEGER_32
			l_wouldbe_col: INTEGER_32
			l_noinvcurs: INTEGER_32
			l_bs: CE_POINTER [NATURAL_8]
			l_goto_cost: INTEGER_32
			l_attr: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_16]
			l_tmp___1: CE_POINTER [NATURAL_16]
			l_tmp___2: INTEGER_32
			l_off___0: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_row := a_row
					l_col := a_col
					if ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 22 -- skip if block
					end
				when 1 then -- if:
						if l_col = screen_cur_col.item then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___1
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 4 then -- else:
						if l_row = screen_cur_row.item then
							l_pos := -1 + 22 -- skip if block
						end
				when 5 then -- if: | _L___1:
						if l_row < 0 then
							l_row := 0
						end
						if l_row >= (create {P_GLOBALS_STATIC}).screen_Rows.item then
							l_row := (create {P_GLOBALS_STATIC}).screen_Rows.item - 1
						end
						if l_col >= (create {P_GLOBALS_STATIC}).screen_Columns.item then
							l_col := (create {P_GLOBALS_STATIC}).screen_Columns.item - 1
						end
						if screen_attr.item.to_boolean then
							if (((create {P_TERM_STATIC}).term_strings.item[26]).item).to_integer_32 = 0 then
								l_noinvcurs := 5
							else
								l_noinvcurs := 0
							end
						else
							l_noinvcurs := 0
						end
						l_goto_cost := 7 + l_noinvcurs
						if not (l_row >= screen_cur_row.item) then
							l_pos := -1 + 20 -- skip if block
						end
				when 6 then -- if:
						if not (screen_cur_col.item.to_integer_32 < (create {P_GLOBALS_STATIC}).Columns.item.item) then
							l_pos := -1 + 18 -- skip if block
						end
				when 7 then -- if:
						l_bs := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_attr := screen_attr.item
						if l_row /= screen_cur_row.item then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_col < screen_cur_col.item then
							if (((create {P_TERM_STATIC}).term_strings.item[44]).item).to_boolean then
								l_bs := (create {P_TERM_STATIC}).term_strings.item[44]
							else
								l_bs := (create {P_TERM_STATIC}).term_strings.item[35]
							end
							if (l_bs.item).to_boolean then
								l_cost := (screen_cur_col.item - l_col) * (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_bs))).to_integer_32
							else
								l_cost := 999
							end
							if l_col + 1 < l_cost then
								l_plan := 2
								l_wouldbe_col := 0
								l_cost := 1
							else
								l_plan := 1
								l_wouldbe_col := l_col
							end
							if l_noinvcurs.to_boolean then
								l_cost := l_cost + l_noinvcurs
								l_attr := 0
							end
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if l_row > screen_cur_row.item then
							l_plan := 3
							l_wouldbe_col := 0
							l_cost := (l_row - screen_cur_row.item) * 2
							if l_noinvcurs.to_boolean then
								l_cost := l_cost + l_noinvcurs
								l_attr := 0
							end
						else
							l_plan := 4
							l_wouldbe_col := screen_cur_col.item
							l_cost := 0
						end
				when 11 then
						l_i___0 := l_col - l_wouldbe_col
						if l_i___0 > 0 then
							l_cost := l_cost + l_i___0
						end
						if l_cost < l_goto_cost then
							if l_i___0 > 0 then
								l_p___0 := ((create {P_GLOBALS_STATIC}).ScreenAttrs.item + ((create {P_GLOBALS_STATIC}).LineOffset.item[l_row]).to_integer_32) + l_wouldbe_col
								from
								until
									(l_break)
								loop
									l_break := False
									if l_i___0.to_boolean then
										l_tmp___0 := l_p___0
										l_p___0 := l_p___0 + 1
										if (l_tmp___0.item).to_integer_32 /= l_attr then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_i___0 := l_i___0 - 1
									end
								end
								l_break := False
								if l_i___0 /= 0 then
									l_p___0 := l_p___0 - 1
									if (l_p___0.item).to_integer_32 = 0 then
										l_cost := l_cost + l_noinvcurs
										from
										until
											(l_break)
										loop
											l_break := False
											if l_i___0.to_boolean then
												l_tmp___1 := l_p___0
												l_p___0 := l_p___0 + 1
												if (l_tmp___1.item).to_integer_32 /= 0 then
													l_break := True
												end
											else
												l_break := True
											end
											if not (l_break) then
												l_i___0 := l_i___0 - 1
											end
										end
										l_break := False
									end
									if l_i___0 /= 0 then
										l_cost := 999
									end
								end
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_i___0 := l_wouldbe_col
									from
									until
										not (not (l_break) and then (l_i___0 < l_col))
									loop
										l_break := False
										if (create {P_GLOBALS_STATIC}).ScreenLinesUC.item[((create {P_GLOBALS_STATIC}).LineOffset.item[l_row] + l_i___0.to_natural_32).to_integer_32] /= {NATURAL_32} 0 then
											l_cost := 999
											l_break := True
										end
										if not (l_break) then
											l_i___0 := l_i___0 + 1
										end
									end
									l_break := False
								end
							end
						end
						if not (l_cost < l_goto_cost) then
							l_pos := -1 + 17 -- skip if block
						end
				when 12 then -- if:
						if l_plan = 1 then
							if l_noinvcurs.to_boolean then
								screen_stop_highlight
							end
							from
							until
								not (screen_cur_col.item > l_col)
							loop
								(create {P_TERM_STATIC}).out_str (l_bs)
								screen_cur_col.item := screen_cur_col.item - 1
							end
						elseif l_plan = 2 then
							if l_noinvcurs.to_boolean then
								screen_stop_highlight
							end
							(create {P_TERM_STATIC}).out_char ((('%R').code).to_natural_32)
							screen_cur_col.item := 0
						elseif l_plan = 3 then
							if l_noinvcurs.to_boolean then
								screen_stop_highlight
							end
							from
							until
								not (screen_cur_row.item < l_row)
							loop
								(create {P_TERM_STATIC}).out_char ((('%N').code).to_natural_32)
								screen_cur_row.item := screen_cur_row.item + 1
							end
							screen_cur_col.item := 0
						end
						l_i___0 := l_col - screen_cur_col.item
						if not (l_i___0 > 0) then
							l_pos := -1 + 17 -- skip if block
						end
				when 13 then -- if:
						if (((create {P_TERM_STATIC}).term_strings.item[45])[0]).to_integer_32 = 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if (((create {P_TERM_STATIC}).term_strings.item[45])[1]).to_integer_32 = 0 then
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___2 := l_i___0
								l_i___0 := l_i___0 - 1
								if not (l_tmp___2 > 0) then
									l_break := True
								end
								if not (l_break) then
									(create {P_TERM_STATIC}).out_char ((((create {P_TERM_STATIC}).term_strings.item[45]).item).to_natural_32)
								end
							end
							l_break := False
						else
							l_pos := -1 + 16 -- goto _L___0
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L___0:
						l_off___0 := ((create {P_GLOBALS_STATIC}).LineOffset.item[l_row] + screen_cur_col.item.to_natural_32).to_integer_32
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___3 := l_i___0
							l_i___0 := l_i___0 - 1
							if not (l_tmp___3 > 0) then
								l_break := True
							end
							if not (l_break) then
								if ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0]).to_integer_32 /= screen_attr.item then
									screen_stop_highlight
								end
								(create {P_TERM_STATIC}).out_flush_check;
								(create {P_TERM_STATIC}).out_char (((create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0]).to_natural_32)
								if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 9_932 then
									if ((create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0]).to_integer_32 = 142 then
										(create {P_TERM_STATIC}).out_char (((create {P_GLOBALS_STATIC}).ScreenLines2.item[l_off___0]).to_natural_32)
									end
								end
								l_off___0 := l_off___0 + 1
							end
						end
						l_break := False
				when 17 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_cost := 999
				when 19 then -- if done | if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_cost := 999
				when 21 then
						if l_cost >= l_goto_cost then
							if l_noinvcurs.to_boolean then
								screen_stop_highlight
							end
							if l_row = screen_cur_row.item then
								if l_col > screen_cur_col.item then
									if (((create {P_TERM_STATIC}).term_strings.item[29]).item).to_integer_32 /= 0 then
										(create {P_TERM_STATIC}).term_cursor_right (l_col - screen_cur_col.item)
									else
										(create {P_TERM_STATIC}).term_windgoto (l_row, l_col)
									end
								else
									(create {P_TERM_STATIC}).term_windgoto (l_row, l_col)
								end
							else
								(create {P_TERM_STATIC}).term_windgoto (l_row, l_col)
							end
						end
						screen_cur_row.item := l_row
						screen_cur_col.item := l_col
				when 22 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	setcursor
		do
			if (redrawing).to_boolean then
				(create {P_MOVE_STATIC}).validate_cursor
				windgoto ((create {P_GLOBALS_STATIC}).curwin.item.item.w_winrow + (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow, (create {P_GLOBALS_STATIC}).curwin.item.item.w_wincol + (create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol)
			end
		end

	win_rest_invalid (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			l_wp___0 := a_wp___0
			from
			until
				l_wp___0.is_void
			loop
				l_wp___0.item.redraw_win_later (40)
				l_wp___0.item.w_redr_status := 1
				l_wp___0 := l_wp___0.item.w_next
			end
			(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
		end

	screen_ins_lines (a_off___0, a_row, a_line_count, a_end: INTEGER_32; a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_row: INTEGER_32
			l_end: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_temp: NATURAL_32
			l_cursor_row: INTEGER_32
			l_type: INTEGER_32
			l_result_empty: INTEGER_32
			l_can_ce: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_row := a_row
					l_end := a_end
					l_can_ce := (can_clear ((create {P_TERM_STATIC}).term_strings.item[1]))
					if (screen_valid (1)).to_boolean then
						if a_line_count <= 0 then
							Result := 0
							l_return := True
						elseif a_line_count.to_integer_32 > (create {P_OPTION_STATIC}).p_ttyscroll.item.item then
							Result := 0
							l_return := True
						end
					else
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 23 -- skip if block
					end
				when 1 then -- if:
						l_result_empty := (l_row + a_line_count >= l_end).to_integer
						if a_wp___0.is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (a_wp___0.item.w_width).to_integer_32 /= (create {P_GLOBALS_STATIC}).Columns.item.item then
							if (((create {P_TERM_STATIC}).term_strings.item[55]).item).to_integer_32 = 0 then
								l_type := 9
							else
								l_pos := -1 + 4 -- goto _L___6
							end
						else
							l_pos := -1 + 4 -- goto _L___6
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 4 then -- else: | _L___6:
						if not ((can_clear ((create {P_TERM_STATIC}).term_strings.item[8])).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_result_empty.to_boolean then
							l_type := 8
						else
							l_pos := -1 + 7 -- goto _L___4
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 7 then -- else: | _L___4:
						if (((create {P_TERM_STATIC}).term_strings.item[3]).item).to_integer_32 = 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if a_line_count > 1 then
							l_type := 1
						elseif (((create {P_TERM_STATIC}).term_strings.item[2]).item).to_integer_32 = 0 then
							l_type := 1
						else
							l_pos := -1 + 10 -- goto _L___3
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 10 then -- else: | _L___3:
						if (((create {P_TERM_STATIC}).term_strings.item[5]).item).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_result_empty.to_boolean then
							if a_line_count > 1 then
								l_type := 2
							elseif not l_can_ce.to_boolean then
								l_type := 2
							else
								l_pos := -1 + 13 -- goto _L___2
							end
						else
							l_pos := -1 + 13 -- goto _L___2
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 13 then -- else: | _L___2:
						if (((create {P_TERM_STATIC}).term_strings.item[2]).item).to_integer_32 = 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_type := 3
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 16 then -- else:
						if not (l_can_ce.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if l_result_empty.to_boolean then
							l_type := 4
						else
							l_pos := -1 + 19 -- goto _L___0
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 19 then -- else: | _L___0:
						if (((create {P_TERM_STATIC}).term_strings.item[4]).item).to_integer_32 = 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if l_result_empty.to_boolean then
							l_type := 5
						else
							l_pos := -1 + 22 -- goto _L
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else: | _L:
						if (((create {P_TERM_STATIC}).term_strings.item[28]).item).to_integer_32 /= 0 then
							if l_row = 0 then
								if (((create {P_TERM_STATIC}).term_strings.item[10]).item).to_integer_32 = 0 then
									l_type := 6
								elseif l_can_ce.to_boolean then
									l_type := 6
								else
									Result := 0
									l_return := True
								end
							else
								Result := 0
								l_return := True
							end
						else
							Result := 0
							l_return := True
						end
				when 23 then -- if done | if done | if done | if done | if done | if done | if done
					if not l_return then
						if l_type = 8 then
							l_tmp___2 := screen_del_lines (a_off___0, l_row, a_line_count, l_end, 0, a_wp___0)
							Result := l_tmp___2
							l_return := True
						elseif l_type = 2 then
							l_tmp___2 := screen_del_lines (a_off___0, l_row, a_line_count, l_end, 0, a_wp___0)
							Result := l_tmp___2
							l_return := True
						elseif l_type = 4 then
							l_tmp___2 := screen_del_lines (a_off___0, l_row, a_line_count, l_end, 0, a_wp___0)
							Result := l_tmp___2
							l_return := True
						elseif l_type = 5 then
							l_tmp___2 := screen_del_lines (a_off___0, l_row, a_line_count, l_end, 0, a_wp___0)
							Result := l_tmp___2
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 32 -- skip if block
					end
				when 24 then -- if:
						if (((create {P_TERM_STATIC}).term_strings.item[11]).item).to_boolean then
							screen_del_lines (a_off___0, l_end - a_line_count, a_line_count, l_end, 0, a_wp___0).do_nothing
						end
						if a_off___0 + l_row > 0 then
							(create {P_UI_STATIC}).clip_clear_selection
						elseif not a_wp___0.is_void then
							if (a_wp___0.item.w_width).to_integer_32 /= (create {P_GLOBALS_STATIC}).Columns.item.item then
								(create {P_UI_STATIC}).clip_clear_selection
							else
								(create {P_UI_STATIC}).clip_scroll_selection (-a_line_count)
							end
						else
							(create {P_UI_STATIC}).clip_scroll_selection (-a_line_count)
						end
						(create {P_GUI_STATIC}).gui_dont_update_cursor
						if (((create {P_TERM_STATIC}).term_strings.item[36]).item).to_integer_32 /= 0 then
							l_cursor_row := l_row
						else
							l_cursor_row := l_row + a_off___0
						end
						l_row := l_row + a_off___0
						l_end := l_end + a_off___0
						l_i___0 := 0
				when 25 then -- loop condition:
						if not (not (l_return) and then (l_i___0 < a_line_count)) then
							l_pos := -1 + 31 -- skip loop
						end
				when 26 then -- loop body:
						if a_wp___0.is_void then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						if (a_wp___0.item.w_width).to_integer_32 /= (create {P_GLOBALS_STATIC}).Columns.item.item then
							l_j := (l_end - 1) - l_i___0
							from
							until
								(l_break)
							loop
								l_break := False
								l_j := l_j - a_line_count
								if not (l_j >= l_row) then
									l_break := True
								end
								if not (l_break) then
									a_wp___0.item.linecopy (l_j + a_line_count, l_j)
								end
							end
							l_break := False
							l_j := l_j + a_line_count
							if (can_clear (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))).to_boolean then
								lineclear ((create {P_GLOBALS_STATIC}).LineOffset.item[l_j] + (a_wp___0.item.w_wincol).to_natural_32, a_wp___0.item.w_width)
							else
								lineinvalid ((create {P_GLOBALS_STATIC}).LineOffset.item[l_j] + (a_wp___0.item.w_wincol).to_natural_32, a_wp___0.item.w_width)
							end
							(create {P_GLOBALS_STATIC}).LineWraps.item[l_j] := (0).to_natural_8
						else
							l_pos := -1 + 29 -- goto _L___7
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else: | _L___7:
						l_j := (l_end - 1) - l_i___0
						l_temp := (create {P_GLOBALS_STATIC}).LineOffset.item[l_j]
						from
						until
							(l_break)
						loop
							l_break := False
							l_j := l_j - a_line_count
							if not (l_j >= l_row) then
								l_break := True
							end
							if not (l_break) then
								(create {P_GLOBALS_STATIC}).LineOffset.item[(l_j + a_line_count)] := (create {P_GLOBALS_STATIC}).LineOffset.item[l_j];
								(create {P_GLOBALS_STATIC}).LineWraps.item[(l_j + a_line_count)] := (create {P_GLOBALS_STATIC}).LineWraps.item[l_j]
							end
						end
						l_break := False;
						(create {P_GLOBALS_STATIC}).LineOffset.item[(l_j + a_line_count)] := l_temp;
						(create {P_GLOBALS_STATIC}).LineWraps.item[(l_j + a_line_count)] := (0).to_natural_8
						if (can_clear (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))).to_boolean then
							lineclear (l_temp, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32)
						else
							lineinvalid (l_temp, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32)
						end
				when 30 then
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 25 -- back to loop condition
				when 31 then -- loop done
						screen_stop_highlight
						windgoto (l_cursor_row, 0)
						if l_type = 9 then
							redraw_block (l_row, l_end, a_wp___0)
						elseif l_type = 1 then
							(create {P_TERM_STATIC}).term_append_lines (a_line_count)
							screen_start
						else
							l_i___0 := 0
							from
							until
								not (l_i___0 < a_line_count)
							loop
								if l_type = 3 then
									if l_i___0.to_boolean then
										if l_cursor_row /= 0 then
											windgoto (l_cursor_row, 0)
										end
									end
									(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[2])
								else
									(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[28])
								end
								screen_start
								l_i___0 := l_i___0 + 1
							end
						end
						if l_type = 6 then
							if (((create {P_TERM_STATIC}).term_strings.item[10]).item).to_boolean then
								l_i___0 := 0
								from
								until
									not (l_i___0 < a_line_count)
								loop
									windgoto (a_off___0 + l_i___0, 0);
									(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[1])
									screen_start
									l_i___0 := l_i___0 + 1
								end
							end
						end
						(create {P_GUI_STATIC}).gui_can_update_cursor
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							(create {P_TERM_STATIC}).out_flush
						end
						Result := 1
				when 32 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	screen_del_lines (a_off___0, a_row, a_line_count, a_end, a_force: INTEGER_32; a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_row: INTEGER_32
			l_end: INTEGER_32
			l_j: INTEGER_32
			l_i___0: INTEGER_32
			l_temp: NATURAL_32
			l_cursor_row: INTEGER_32
			l_cursor_end: INTEGER_32
			l_result_empty: INTEGER_32
			l_can_delete: INTEGER_32
			l_type: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_row := a_row
					l_end := a_end
					if (screen_valid (1)).to_boolean then
						if a_line_count <= 0 then
							Result := 0
							l_return := True
						elseif not a_force.to_boolean then
							if a_line_count.to_integer_32 > (create {P_OPTION_STATIC}).p_ttyscroll.item.item then
								Result := 0
								l_return := True
							end
						end
					else
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						l_result_empty := (l_row + a_line_count >= l_end).to_integer
						if (((create {P_TERM_STATIC}).term_strings.item[11]).item).to_integer_32 = 0 then
							l_tmp___1 := 1
						elseif (can_clear ((create {P_TERM_STATIC}).term_strings.item[1])).to_boolean then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
						l_can_delete := l_tmp___1
						if a_wp___0.is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (a_wp___0.item.w_width).to_integer_32 /= (create {P_GLOBALS_STATIC}).Columns.item.item then
							if (((create {P_TERM_STATIC}).term_strings.item[55]).item).to_integer_32 = 0 then
								l_type := 9
							else
								l_pos := -1 + 4 -- goto _L___7
							end
						else
							l_pos := -1 + 4 -- goto _L___7
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 4 then -- else: | _L___7:
						if not ((can_clear ((create {P_TERM_STATIC}).term_strings.item[8])).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_result_empty.to_boolean then
							l_type := 8
						else
							l_pos := -1 + 7 -- goto _L___5
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 7 then -- else: | _L___5:
						if l_row /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if a_line_count = 1 then
							l_type := 7
						elseif (((create {P_TERM_STATIC}).term_strings.item[5]).item).to_integer_32 = 0 then
							l_type := 7
						else
							l_pos := -1 + 10 -- goto _L___4
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 10 then -- else: | _L___4:
						if (((create {P_TERM_STATIC}).term_strings.item[5]).item).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if a_line_count > 1 then
							if l_can_delete.to_boolean then
								l_type := 2
							else
								l_pos := -1 + 13 -- goto _L___3
							end
						else
							l_pos := -1 + 13 -- goto _L___3
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else: | _L___3:
						if not ((can_clear ((create {P_TERM_STATIC}).term_strings.item[1])).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_result_empty.to_boolean then
							if a_wp___0.is_void then
								l_type := 4
							elseif (a_wp___0.item.w_width).to_integer_32 = (create {P_GLOBALS_STATIC}).Columns.item.item then
								l_type := 4
							else
								l_pos := -1 + 16 -- goto _L___1
							end
						else
							l_pos := -1 + 16 -- goto _L___1
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else: | _L___1:
						if (((create {P_TERM_STATIC}).term_strings.item[4]).item).to_integer_32 = 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if l_can_delete.to_boolean then
							l_type := 5
						else
							l_pos := -1 + 19 -- goto _L
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L:
						if (((create {P_TERM_STATIC}).term_strings.item[5]).item).to_integer_32 /= 0 then
							if l_can_delete.to_boolean then
								l_type := 2
							else
								Result := 0
								l_return := True
							end
						else
							Result := 0
							l_return := True
						end
				when 20 then -- if done | if done | if done | if done | if done | if done
					if l_return then
						l_pos := -1 + 35 -- skip if block
					end
				when 21 then -- if:
						if a_off___0 + l_row > 0 then
							(create {P_UI_STATIC}).clip_clear_selection
						elseif not a_wp___0.is_void then
							if (a_wp___0.item.w_width).to_integer_32 /= (create {P_GLOBALS_STATIC}).Columns.item.item then
								(create {P_UI_STATIC}).clip_clear_selection
							else
								(create {P_UI_STATIC}).clip_scroll_selection (a_line_count)
							end
						else
							(create {P_UI_STATIC}).clip_scroll_selection (a_line_count)
						end
						(create {P_GUI_STATIC}).gui_dont_update_cursor
						if (((create {P_TERM_STATIC}).term_strings.item[36]).item).to_integer_32 /= 0 then
							l_cursor_row := l_row
							l_cursor_end := l_end
						else
							l_cursor_row := l_row + a_off___0
							l_cursor_end := l_end + a_off___0
						end
						l_row := l_row + a_off___0
						l_end := l_end + a_off___0
						l_i___0 := 0
				when 22 then -- loop condition:
						if not (not (l_return) and then (l_i___0 < a_line_count)) then
							l_pos := -1 + 28 -- skip loop
						end
				when 23 then -- loop body:
						if a_wp___0.is_void then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						if (a_wp___0.item.w_width).to_integer_32 /= (create {P_GLOBALS_STATIC}).Columns.item.item then
							l_j := l_row + l_i___0
							from
							until
								(l_break)
							loop
								l_break := False
								l_j := l_j + a_line_count
								if not (l_j <= l_end - 1) then
									l_break := True
								end
								if not (l_break) then
									a_wp___0.item.linecopy (l_j - a_line_count, l_j)
								end
							end
							l_break := False
							l_j := l_j - a_line_count
							if (can_clear (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))).to_boolean then
								lineclear ((create {P_GLOBALS_STATIC}).LineOffset.item[l_j] + (a_wp___0.item.w_wincol).to_natural_32, a_wp___0.item.w_width)
							else
								lineinvalid ((create {P_GLOBALS_STATIC}).LineOffset.item[l_j] + (a_wp___0.item.w_wincol).to_natural_32, a_wp___0.item.w_width)
							end
							(create {P_GLOBALS_STATIC}).LineWraps.item[l_j] := (0).to_natural_8
						else
							l_pos := -1 + 26 -- goto _L___8
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else: | _L___8:
						l_j := l_row + l_i___0
						l_temp := (create {P_GLOBALS_STATIC}).LineOffset.item[l_j]
						from
						until
							(l_break)
						loop
							l_break := False
							l_j := l_j + a_line_count
							if not (l_j <= l_end - 1) then
								l_break := True
							end
							if not (l_break) then
								(create {P_GLOBALS_STATIC}).LineOffset.item[(l_j - a_line_count)] := (create {P_GLOBALS_STATIC}).LineOffset.item[l_j];
								(create {P_GLOBALS_STATIC}).LineWraps.item[(l_j - a_line_count)] := (create {P_GLOBALS_STATIC}).LineWraps.item[l_j]
							end
						end
						l_break := False;
						(create {P_GLOBALS_STATIC}).LineOffset.item[(l_j - a_line_count)] := l_temp;
						(create {P_GLOBALS_STATIC}).LineWraps.item[(l_j - a_line_count)] := (0).to_natural_8
						if (can_clear (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))).to_boolean then
							lineclear (l_temp, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32)
						else
							lineinvalid (l_temp, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32)
						end
				when 27 then
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 22 -- back to loop condition
				when 28 then -- loop done
						screen_stop_highlight
						if l_type = 9 then
							redraw_block (l_row, l_end, a_wp___0)
						elseif l_type = 8 then
							windgoto (l_cursor_row, 0);
							(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[8])
							screen_start
						elseif l_type = 2 then
							windgoto (l_cursor_row, 0);
							(create {P_TERM_STATIC}).term_delete_lines (a_line_count)
							screen_start
						elseif l_type = 7 then
							windgoto (l_cursor_end - 1, 0)
							l_i___0 := a_line_count
							from
							until
								(l_break)
							loop
								l_break := False
								l_i___0 := l_i___0 - 1
								if not (l_i___0 >= 0) then
									l_break := True
								end
								if not (l_return or l_break) then
									(create {P_TERM_STATIC}).out_char ((('%N').code).to_natural_32)
								end
							end
							l_break := False
						else
							l_i___0 := a_line_count
							from
							until
								(l_break)
							loop
								l_break := False
								l_i___0 := l_i___0 - 1
								if not (l_i___0 >= 0) then
									l_break := True
								end
								if not (l_return or l_break) then
									if l_type = 5 then
										windgoto (l_cursor_row, 0);
										(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[4])
									else
										windgoto (l_cursor_row + l_i___0, 0);
										(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[1])
									end
									screen_start
								end
							end
							l_break := False
						end
						if not ((((create {P_TERM_STATIC}).term_strings.item[11]).item).to_boolean) then
							l_pos := -1 + 34 -- skip if block
						end
				when 29 then -- if:
						if l_type /= 5 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 33 -- goto _L___9
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 32 then -- else:
						if l_type /= 2 then
							l_pos := -1 + 34 -- skip if block
						end
				when 33 then -- if: | _L___9:
						l_i___0 := a_line_count
						from
						until
							not (l_i___0 > 0)
						loop
							windgoto (l_cursor_end - l_i___0, 0);
							(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[1])
							screen_start
							l_i___0 := l_i___0 - 1
						end
				when 34 then -- if done | if done;
						(create {P_GUI_STATIC}).gui_can_update_cursor
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							(create {P_TERM_STATIC}).out_flush
						end
						Result := 1
				when 35 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	showmode: INTEGER_32
		local
			l_need_clear: INTEGER_32
			l_length: INTEGER_32
			l_do_mode: INTEGER_32
			l_attr: INTEGER_32
			l_nwr_save: INTEGER_32
			l_sub_attr: INTEGER_32
			l_tmp: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___13: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_length := 0
					if ((create {P_OPTION_STATIC}).p_smd.item.item).to_boolean then
						if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
							if (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
								l_tmp := 1
							elseif ((create {P_GLOBALS_STATIC}).restart_edit.item).to_boolean then
								l_tmp := 1
							elseif ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_do_mode := l_tmp
					if not (l_do_mode.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 3 then -- else:
						if not (((create {P_GLOBALS_STATIC}).Recording.item).to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 4 then -- if: | _L___0:
						if not ((redrawing).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if not (((create {P_GETCHAR_STATIC}).char_avail).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if not ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
							(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
							Result := 0
							l_return := True
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if (create {P_GLOBALS_STATIC}).msg_silent.item /= 0 then
							(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
							Result := 0
							l_return := True
						end
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:;
						(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
						Result := 0
						l_return := True
				when 11 then
						if l_return then
							l_pos := -1 + 28 -- skip if block
						end
				when 12 then -- if:
						l_nwr_save := (create {P_GLOBALS_STATIC}).need_wait_return.item
						check_for_delay (0)
						l_need_clear := (create {P_GLOBALS_STATIC}).clear_cmdline.item
						if ((create {P_GLOBALS_STATIC}).clear_cmdline.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).cmdline_row.item).to_integer_32 < (create {P_GLOBALS_STATIC}).Rows.item.item - 1 then
								(create {P_MESSAGE_STATIC}).msg_clr_cmdline
							end
						end
						msg_pos_mode;
						(create {P_TERM_STATIC}).cursor_off
						l_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[8]
						if not (l_do_mode.to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 13 then -- if:;
						(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("--")), l_attr)
						if ((create {P_MBYTE_STATIC}).preedit_get_status).to_boolean then
							(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" IM")), l_attr)
						end
						if ((create {P_GLOBALS_STATIC}).edit_submode.item).is_void then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_length := (((create {P_GLOBALS_STATIC}).Rows.item.item - ((create {P_GLOBALS_STATIC}).msg_row.item).to_integer_32) * (create {P_GLOBALS_STATIC}).Columns.item.item - 3).to_integer_32
						if not ((create {P_GLOBALS_STATIC}).edit_submode_extra.item).is_void then
							l_length := l_length - ((create {P_CHARSET_STATIC}).vim_strsize ((create {P_GLOBALS_STATIC}).edit_submode_extra.item))
						end
						if l_length > 0 then
							if not ((create {P_GLOBALS_STATIC}).edit_submode_pre.item).is_void then
								l_length := l_length - ((create {P_CHARSET_STATIC}).vim_strsize ((create {P_GLOBALS_STATIC}).edit_submode_pre.item))
							end
							if l_length - ((create {P_CHARSET_STATIC}).vim_strsize ((create {P_GLOBALS_STATIC}).edit_submode.item)) > 0 then
								if not ((create {P_GLOBALS_STATIC}).edit_submode_pre.item).is_void then
									(create {P_MESSAGE_STATIC}).msg_puts_attr ((create {P_GLOBALS_STATIC}).edit_submode_pre.item, l_attr)
								end
								(create {P_MESSAGE_STATIC}).msg_puts_attr ((create {P_GLOBALS_STATIC}).edit_submode.item, l_attr)
							end
							if not ((create {P_GLOBALS_STATIC}).edit_submode_extra.item).is_void then
								(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")), l_attr)
								if ((create {P_GLOBALS_STATIC}).edit_submode_highl.item).to_integer_32 < 41 then
									l_sub_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[((create {P_GLOBALS_STATIC}).edit_submode_highl.item).to_integer_32]
								else
									l_sub_attr := l_attr
								end
								(create {P_MESSAGE_STATIC}).msg_puts_attr ((create {P_GLOBALS_STATIC}).edit_submode_extra.item, l_sub_attr)
							end
						end
						l_length := 0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 16 then -- else:
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
							(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string (" VREPLACE")))), l_attr)
						elseif (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
							(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string (" REPLACE")))), l_attr)
						elseif (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
							(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string (" INSERT")))), l_attr)
						elseif (create {P_GLOBALS_STATIC}).restart_edit.item = 73 then
							(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string (" (insert)")))), l_attr)
						elseif (create {P_GLOBALS_STATIC}).restart_edit.item = 82 then
							(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string (" (replace)")))), l_attr)
						elseif (create {P_GLOBALS_STATIC}).restart_edit.item = 86 then
							(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string (" (vreplace)")))), l_attr)
						end
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
							if ((create {P_OPTION_STATIC}).p_paste.item.item).to_boolean then
								(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string (" (paste)")))), l_attr)
							end
						end
						if not (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 17 then -- if:
						if ((create {P_GLOBALS_STATIC}).VIsual_select.item).to_boolean then
							l_tmp___13 := 4
						else
							l_tmp___13 := 0
						end
						inspect (l_tmp___13 + ((create {P_GLOBALS_STATIC}).VIsual_mode.item = 22).to_integer * 2) + ((create {P_GLOBALS_STATIC}).VIsual_mode.item = 86).to_integer -- switch 1 head
						when 0 then l_pos := -1 + 18
						when 1 then l_pos := -1 + 19
						when 2 then l_pos := -1 + 20
						when 4 then l_pos := -1 + 21
						when 5 then l_pos := -1 + 22
						else l_pos := -1 + 23
						end
				when 18 then -- switch 1, case 0
						l_p___0 := ce_string (" VISUAL")
						l_pos := -1 + 24 -- switch 1; break
				when 19 then -- switch 1, case 1
						l_p___0 := ce_string (" VISUAL LINE")
						l_pos := -1 + 24 -- switch 1; break
				when 20 then -- switch 1, case 2
						l_p___0 := ce_string (" VISUAL BLOCK")
						l_pos := -1 + 24 -- switch 1; break
				when 21 then -- switch 1, case 4
						l_p___0 := ce_string (" SELECT")
						l_pos := -1 + 24 -- switch 1; break
				when 22 then -- switch 1, case 5
						l_p___0 := ce_string (" SELECT LINE")
						l_pos := -1 + 24 -- switch 1; break
				when 23 then -- switch 1, default:
						l_p___0 := ce_string (" SELECT BLOCK")
						l_pos := -1 + 24 -- switch 1; break
				when 24 then -- switch 1, done:;
						(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (l_p___0))), l_attr)
				when 25 then -- if done;
						(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" --")), l_attr)
				when 26 then -- if done
						l_need_clear := 1
				when 27 then -- if done
						if ((create {P_GLOBALS_STATIC}).Recording.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).edit_submode.item).is_void then
								(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("recording")))), l_attr)
								l_need_clear := 1
							end
						end
						(create {P_GLOBALS_STATIC}).mode_displayed.item := 1
						if l_need_clear.to_boolean then
							(create {P_MESSAGE_STATIC}).msg_clr_eos
						elseif ((create {P_GLOBALS_STATIC}).clear_cmdline.item).to_boolean then
							(create {P_MESSAGE_STATIC}).msg_clr_eos
						end
						(create {P_GLOBALS_STATIC}).msg_didout.item := 0
						l_length := (create {P_GLOBALS_STATIC}).msg_col.item;
						(create {P_GLOBALS_STATIC}).msg_col.item := 0;
						(create {P_GLOBALS_STATIC}).need_wait_return.item := l_nwr_save
				when 28 then -- if done | if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						if ((create {P_GLOBALS_STATIC}).clear_cmdline.item).to_boolean then
							if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
								(create {P_MESSAGE_STATIC}).msg_clr_cmdline
							end
						end
				when 30 then -- if done
					if not l_return then
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							(create {P_NORMAL_STATIC}).clear_showcmd
						end
						if (redrawing).to_boolean then
							if (create {P_GLOBALS_STATIC}).lastwin.item.item.w_status_height = 0 then
								win_redr_ruler ((create {P_GLOBALS_STATIC}).lastwin.item, 1)
							end
						end
						(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 0;
						(create {P_GLOBALS_STATIC}).clear_cmdline.item := 0
						Result := l_length
					end
				when 31 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	msg_pos_mode
		do
			(create {P_GLOBALS_STATIC}).msg_col.item := 0;
			(create {P_GLOBALS_STATIC}).msg_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
		end

	unshowmode (a_force: INTEGER_32)
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((redrawing).to_boolean) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if a_force.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((create {P_GETCHAR_STATIC}).char_avail).to_boolean then
							if not ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
								(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
							else
								l_pos := -1 + 4 -- goto _L___0
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L___0:
						msg_pos_mode
						if ((create {P_GLOBALS_STATIC}).Recording.item).to_boolean then
							(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("recording")))), (create {P_GLOBALS_STATIC}).highlight_attr.item[8])
						end
						(create {P_MESSAGE_STATIC}).msg_clr_eos
				when 5 then -- if done | if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:;
						(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	draw_tabline
		local
			l_tabcount: INTEGER_32
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_tabwidth: INTEGER_32
			l_col: INTEGER_32
			l_scol: INTEGER_32
			l_attr: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_cwp: CE_POINTER [PD_WINDOW_S]
			l_wincount: INTEGER_32
			l_modified: INTEGER_32
			l_c: INTEGER_32
			l_len: INTEGER_32
			l_attr_sel: INTEGER_32
			l_attr_nosel: INTEGER_32
			l_attr_fill: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_room: INTEGER_32
			l_use_sep_chars: INTEGER_32
			l_tmp: INTEGER_32
			l_save_called_emsg: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tabcount := 0
					l_col := 0
					l_scol := 0
					l_attr_sel := (create {P_GLOBALS_STATIC}).highlight_attr.item[36]
					l_attr_nosel := (create {P_GLOBALS_STATIC}).highlight_attr.item[35]
					l_attr_fill := (create {P_GLOBALS_STATIC}).highlight_attr.item[37]
					if (create {P_GLOBALS_STATIC}).t_colors.item < 8 then
						if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_use_sep_chars := l_tmp;
					(create {P_GLOBALS_STATIC}).redraw_tabline.item := 0
					if ((create {P_GUI_STATIC}).gui_use_tabline).to_boolean then
						(create {P_GUI_STATIC}).gui_update_tabline
						l_return := True
					end
					if not l_return then
						if ((create {P_WINDOW_STATIC}).tabline_height) < 1 then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_scol := 0
						from
						until
							not (l_scol.to_integer_32 < (create {P_GLOBALS_STATIC}).Columns.item.item)
						loop
							(create {P_GLOBALS_STATIC}).TabPageIdxs.item[l_scol] := (0).to_integer_16
							l_scol := l_scol + 1
						end
						if ((create {P_OPTION_STATIC}).p_tal.item.item.item).to_integer_32 = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_save_called_emsg := (create {P_GLOBALS_STATIC}).called_emsg.item;
						(create {P_GLOBALS_STATIC}).called_emsg.item := 0
						win_redr_custom (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer), 0)
						if ((create {P_GLOBALS_STATIC}).called_emsg.item).to_boolean then
							(create {P_OPTION_STATIC}).set_string_option_direct (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tabline")), -1, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 1, -5)
						end
						(create {P_GLOBALS_STATIC}).called_emsg.item := ((create {P_GLOBALS_STATIC}).called_emsg.item).bit_or (l_save_called_emsg)
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
						from
						until
							l_tp.is_void
						loop
							l_tabcount := l_tabcount + 1
							l_tp := l_tp.item.tp_next
						end
						l_tabwidth := ((((create {P_GLOBALS_STATIC}).Columns.item.item - 1) + (l_tabcount // 2).to_integer_32) // l_tabcount.to_integer_32).to_integer_32
						if l_tabwidth < 6 then
							l_tabwidth := 6
						end
						l_attr := l_attr_nosel
						l_tabcount := 0
						l_scol := 0
						l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
				when 5 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 13 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						if not l_tp.is_void then
							if not (l_col.to_integer_32 < (create {P_GLOBALS_STATIC}).Columns.item.item - 4) then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						l_scol := l_col
						if (l_tp.item.tp_topframe).is_equal ((create {P_GLOBALS_STATIC}).topframe.item) then
							l_attr := l_attr_sel
						end
						if l_use_sep_chars.to_boolean then
							if l_col > 0 then
								l_tmp___2 := l_col
								l_col := l_col + 1
								screen_putchar (('|').code, 0, l_tmp___2, l_attr)
							end
						end
						if not (l_tp.item.tp_topframe).is_equal ((create {P_GLOBALS_STATIC}).topframe.item) then
							l_attr := l_attr_nosel
						end
						l_tmp___3 := l_col
						l_col := l_col + 1
						screen_putchar ((' ').code, 0, l_tmp___3, l_attr)
						if l_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
							l_cwp := (create {P_GLOBALS_STATIC}).curwin.item
							l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
						else
							l_cwp := l_tp.item.tp_curwin
							l_wp___0 := l_tp.item.tp_firstwin
						end
						l_modified := 0
						l_wincount := 0
						from
						until
							l_wp___0.is_void
						loop
							if ((l_wp___0.item.w_buffer).item.bufIsChanged).to_boolean then
								l_modified := 1
							end
							l_wp___0 := l_wp___0.item.w_next
							l_wincount := l_wincount + 1
						end
						if not (l_modified.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if not (l_wincount > 1) then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						if l_wincount > 1 then
							(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item), (4_096).to_natural_32, ce_string ("%%d"), l_wincount]).do_nothing
							l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item))).to_integer_32
							if (l_col + l_len).to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item - 3 then
								l_break := True
							end
							if not (l_return or l_break) then
								screen_puts_len ((create {P_GLOBALS_STATIC}).NameBuff.item.item, l_len, 0, l_col, ((create {P_SYNTAX_STATIC}).hl_combine_attr (l_attr, (create {P_GLOBALS_STATIC}).highlight_attr.item[14])))
								l_col := l_col + l_len
							end
						end
						if not (l_return or l_break) then
							if l_modified.to_boolean then
								l_tmp___7 := l_col
								l_col := l_col + 1
								screen_puts_len (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("+")), 1, 0, l_tmp___7, l_attr)
							end
							l_tmp___8 := l_col
							l_col := l_col + 1
							screen_putchar ((' ').code, 0, l_tmp___8, l_attr)
						end
				when 12 then -- if done | if done
						if not (l_return or l_break) then
							l_room := ((l_scol - l_col) + l_tabwidth) - 1
							if l_room > 0 then
								(l_cwp.item.w_buffer).item.get_trans_bufname;
								(create {P_MISC1_STATIC}).shorten_dir ((create {P_GLOBALS_STATIC}).NameBuff.item.item)
								l_len := (create {P_CHARSET_STATIC}).vim_strsize ((create {P_GLOBALS_STATIC}).NameBuff.item.item)
								l_p___0 := (create {P_GLOBALS_STATIC}).NameBuff.item.item
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									from
									until
										not (l_len > l_room)
									loop
										l_len := l_len - ((create {P_CHARSET_STATIC}).ptr2cells (l_p___0))
										if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
											l_tmp___11 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
										else
											l_tmp___11 := 1
										end
										l_p___0 := l_p___0 + l_tmp___11
									end
								elseif l_len > l_room then
									l_p___0 := l_p___0 + (l_len - l_room)
									l_len := l_room
								end
								if l_len.to_integer_32 > ((create {P_GLOBALS_STATIC}).Columns.item.item - l_col.to_integer_32) - 1 then
									l_len := (((create {P_GLOBALS_STATIC}).Columns.item.item - l_col.to_integer_32) - 1).to_integer_32
								end
								screen_puts_len (l_p___0, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32, 0, l_col, l_attr)
								l_col := l_col + l_len
							end
							l_tmp___13 := l_col
							l_col := l_col + 1
							screen_putchar ((' ').code, 0, l_tmp___13, l_attr)
							l_tabcount := l_tabcount + 1
							from
							until
								not (l_scol < l_col)
							loop
								l_tmp___14 := l_scol
								l_scol := l_scol + 1;
								(create {P_GLOBALS_STATIC}).TabPageIdxs.item[l_tmp___14] := l_tabcount.to_integer_16
							end
							l_tp := l_tp.item.tp_next
						end
						l_pos := -1 + 5 -- back to loop condition
				when 13 then -- loop done
						l_break := False
						if l_use_sep_chars.to_boolean then
							l_c := ('_').code
						else
							l_c := (' ').code
						end
						screen_fill (0, 1, l_col, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32, l_c, l_c, l_attr_fill)
						if not ((create {P_GLOBALS_STATIC}).first_tabpage.item.item.tp_next).is_void then
							screen_putchar (('X').code, 0, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32 - 1, l_attr_nosel);
							(create {P_GLOBALS_STATIC}).TabPageIdxs.item[((create {P_GLOBALS_STATIC}).Columns.item.item - 1)] := (-999).to_integer_16
						end
				when 14 then -- if done;
						(create {P_GLOBALS_STATIC}).redraw_tabline.item := 0
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	fillchar_status (a_attr: CE_POINTER [INTEGER_32]; a_is_curwin: INTEGER_32): INTEGER_32
		require
			not a_attr.is_void
		local
			l_fill: INTEGER_32
			l_return: BOOLEAN
		do
			if a_is_curwin.to_boolean then
				a_attr.item := (create {P_GLOBALS_STATIC}).highlight_attr.item[11]
				l_fill := (create {P_GLOBALS_STATIC}).fill_stl.item.item
			else
				a_attr.item := (create {P_GLOBALS_STATIC}).highlight_attr.item[12]
				l_fill := (create {P_GLOBALS_STATIC}).fill_stlnc.item.item
			end
			if a_attr.item /= 0 then
				if (create {P_GLOBALS_STATIC}).highlight_attr.item[11] /= (create {P_GLOBALS_STATIC}).highlight_attr.item[12] then
					Result := l_fill
					l_return := True
				elseif not a_is_curwin.to_boolean then
					Result := l_fill
					l_return := True
				elseif ((create {P_GLOBALS_STATIC}).firstwin.item).is_equal ((create {P_GLOBALS_STATIC}).lastwin.item) then
					Result := l_fill
					l_return := True
				elseif (create {P_GLOBALS_STATIC}).fill_stl.item.item /= (create {P_GLOBALS_STATIC}).fill_stlnc.item.item then
					Result := l_fill
					l_return := True
				end
			end
			if not l_return and then (a_is_curwin.to_boolean) then
				Result := (('^').code)
				l_return := True
			end
			if not l_return then
				Result := (('=').code)
			end
		end

	fillchar_vsep (a_attr: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_attr.is_void
		do
			a_attr.item := (create {P_GLOBALS_STATIC}).highlight_attr.item[13]
			if a_attr.item = 0 then
				if (create {P_GLOBALS_STATIC}).fill_vert.item.item = 32 then
					Result := (('|').code)
				else
					Result := ((create {P_GLOBALS_STATIC}).fill_vert.item.item)
				end
			else
				Result := ((create {P_GLOBALS_STATIC}).fill_vert.item.item)
			end
		end

	redrawing: INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if not ((create {P_GLOBALS_STATIC}).RedrawingDisabled.item).to_boolean then
				if ((create {P_OPTION_STATIC}).p_lz.item.item).to_boolean then
					if ((create {P_GETCHAR_STATIC}).char_avail).to_boolean then
						if not ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
							if not ((create {P_GLOBALS_STATIC}).do_redraw.item).to_boolean then
								l_tmp___0 := 0
							else
								l_tmp___0 := 1
							end
						else
							l_tmp___0 := 1
						end
					else
						l_tmp___0 := 1
					end
				else
					l_tmp___0 := 1
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	messaging: INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if ((create {P_OPTION_STATIC}).p_lz.item.item).to_boolean then
				if ((create {P_GETCHAR_STATIC}).char_avail).to_boolean then
					if not ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
						l_tmp___0 := 0
					else
						l_tmp___0 := 1
					end
				else
					l_tmp___0 := 1
				end
			else
				l_tmp___0 := 1
			end
			Result := l_tmp___0
		end

	showruler (a_always: INTEGER_32)
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not a_always.to_boolean then
						if not (redrawing).to_boolean then
							l_return := True
						end
					end
					if not l_return then
						if ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_redr_status := 1
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_OPTION_STATIC}).p_stl.item.item.item).to_integer_32 = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if (((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_stl).item).to_integer_32 = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_status_height).to_boolean then
							redraw_custom_statusline ((create {P_GLOBALS_STATIC}).curwin.item)
						else
							win_redr_ruler ((create {P_GLOBALS_STATIC}).curwin.item, a_always)
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						win_redr_ruler ((create {P_GLOBALS_STATIC}).curwin.item, a_always)
				when 8 then -- if done
						if not (((create {P_GLOBALS_STATIC}).need_maketitle.item).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:;
						(create {P_BUFFER_STATIC}).maketitle
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 11 then -- else:
						if not (((create {P_OPTION_STATIC}).p_icon.item.item).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (((create {P_GLOBALS_STATIC}).stl_syntax.item).bit_and (1)).to_boolean then
							(create {P_BUFFER_STATIC}).maketitle
						else
							l_pos := -1 + 14 -- goto _L___0
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L___0:
						if ((create {P_OPTION_STATIC}).p_title.item.item).to_boolean then
							if (((create {P_GLOBALS_STATIC}).stl_syntax.item).bit_and (2)).to_boolean then
								(create {P_BUFFER_STATIC}).maketitle
							end
						end
				when 15 then -- if done
						if ((create {P_GLOBALS_STATIC}).redraw_tabline.item).to_boolean then
							draw_tabline
						end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	win_redr_ruler (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_always: INTEGER_32)
		local
			l_buffer: CE_ARRAY [NATURAL_8]
			l_row: INTEGER_32
			l_fillchar: INTEGER_32
			l_attr: CE_ARRAY [INTEGER_32]
			l_empty_line: INTEGER_32
			l_virtcol: CE_ARRAY [INTEGER_32]
			l_i___0: INTEGER_32
			l_len: NATURAL_32
			l_o: INTEGER_32
			l_this_ru_col: INTEGER_32
			l_off___0: INTEGER_32
			l_width: INTEGER_32
			l_save_called_emsg: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buffer.make (<<70>>)
			create {CE_INTEGER_32_ARRAY} l_attr.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_virtcol.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_empty_line := 0
					l_off___0 := 0
					l_width := ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32
					if not ((create {P_OPTION_STATIC}).p_ru.item.item).to_boolean then
						l_return := True
					end
					if not l_return and then (a_wp___0.item.w_cursor.lnum > (a_wp___0.item.w_buffer).item.b_ml.ml_line_count) then
						l_return := True
					end
					if not l_return and then (a_wp___0.is_equal ((create {P_GLOBALS_STATIC}).lastwin.item)) then
						if (create {P_GLOBALS_STATIC}).lastwin.item.item.w_status_height = 0 then
							if not ((create {P_GLOBALS_STATIC}).edit_submode.item).is_void then
								l_return := True
							end
						end
					end
					if not l_return then
						if ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
							l_return := True
						end
					end
					if not l_return and then (((create {P_OPTION_STATIC}).p_ruf.item.item.item).to_boolean) then
						l_save_called_emsg := (create {P_GLOBALS_STATIC}).called_emsg.item;
						(create {P_GLOBALS_STATIC}).called_emsg.item := 0
						win_redr_custom (a_wp___0, 1)
						if ((create {P_GLOBALS_STATIC}).called_emsg.item).to_boolean then
							(create {P_OPTION_STATIC}).set_string_option_direct (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("rulerformat")), -1, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 1, -5)
						end
						(create {P_GLOBALS_STATIC}).called_emsg.item := ((create {P_GLOBALS_STATIC}).called_emsg.item).bit_or (l_save_called_emsg)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 30 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
							if (((a_wp___0.item.w_buffer).item.ml_get_buf (a_wp___0.item.w_cursor.lnum, 0)).item).to_integer_32 = 0 then
								l_empty_line := 1
							end
						end
						a_wp___0.item.validate_virtcol_win
						if not (((create {P_GLOBALS_STATIC}).redraw_cmdline.item).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 4 then -- else:
						if not (a_always.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 7 then -- else:
						if a_wp___0.item.w_cursor.lnum = a_wp___0.item.w_ru_cursor.lnum then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 10 then -- else:
						if a_wp___0.item.w_cursor.col = a_wp___0.item.w_ru_cursor.col then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 13 then -- else:
						if a_wp___0.item.w_virtcol = a_wp___0.item.w_ru_virtcol then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 16 then -- else:
						if a_wp___0.item.w_cursor.coladd = a_wp___0.item.w_ru_cursor.coladd then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 19 then -- else:
						if a_wp___0.item.w_topline = a_wp___0.item.w_ru_topline then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 22 then -- else:
						if (a_wp___0.item.w_buffer).item.b_ml.ml_line_count = a_wp___0.item.w_ru_line_count then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 25 then -- else:
						if a_wp___0.item.w_topfill = a_wp___0.item.w_ru_topfill then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 28 then -- else:
						if l_empty_line = (a_wp___0.item.w_ru_empty).to_integer_32 then
							l_pos := -1 + 30 -- skip if block
						end
				when 29 then -- if: | _L:;
						(create {P_TERM_STATIC}).cursor_off
						if (a_wp___0.item.w_status_height).to_boolean then
							l_row := a_wp___0.item.w_winrow + a_wp___0.item.w_height
							l_fillchar := fillchar_status (l_attr, (a_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item)).to_integer)
							l_off___0 := a_wp___0.item.w_wincol
							l_width := a_wp___0.item.w_width
						else
							l_row := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
							l_fillchar := (' ').code
							l_attr.item := 0
							l_width := ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32
							l_off___0 := 0
						end
						l_virtcol.item := a_wp___0.item.w_virtcol
						if (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
							if (create {P_GLOBALS_STATIC}).lcs_tab1.item = 0 then
								a_wp___0.item.w_onebuf_opt.wo_list := 0
								a_wp___0.item.getvvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_virtcol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
								a_wp___0.item.w_onebuf_opt.wo_list := 1
							end
						end
						if (((a_wp___0.item.w_buffer).item.b_ml.ml_flags).bit_and (1)).to_boolean then
							l_tmp___1 := 0
						else
							l_tmp___1 := a_wp___0.item.w_cursor.lnum
						end
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buffer), (70).to_natural_32, ce_string ("%%ld,"), l_tmp___1]).do_nothing
						l_len := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buffer))
						if l_empty_line.to_boolean then
							l_tmp___2 := 0
						else
							l_tmp___2 := a_wp___0.item.w_cursor.col + 1
						end
						(create {P_BUFFER_STATIC}).col_print (l_buffer + l_len.to_integer_32, {NATURAL_32} 70 - l_len, l_tmp___2, l_virtcol.item + 1)
						l_i___0 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buffer))).to_integer_32
						a_wp___0.item.get_rel_pos ((l_buffer + l_i___0) + 1, (70 - l_i___0) - 1)
						l_o := l_i___0 + ((create {P_CHARSET_STATIC}).vim_strsize ((l_buffer + l_i___0) + 1))
						if a_wp___0.item.w_status_height = 0 then
							l_o := l_o + 1
						end
						l_this_ru_col := (((create {P_GLOBALS_STATIC}).ru_col.item).to_integer_32 - ((create {P_GLOBALS_STATIC}).Columns.item.item - l_width.to_integer_32)).to_integer_32
						if l_this_ru_col < 0 then
							l_this_ru_col := 0
						end
						if l_this_ru_col < (l_width + 1) // 2 then
							l_this_ru_col := (l_width + 1) // 2
						end
						if l_this_ru_col + l_o < l_width then
							from
							until
								not (l_this_ru_col + l_o < l_width)
							loop
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_i___0 := l_i___0 + ((create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([l_fillchar, l_buffer + l_i___0]))
								else
									l_tmp___6 := l_i___0
									l_i___0 := l_i___0 + 1
									l_buffer[l_tmp___6] := l_fillchar.to_natural_8
								end
								l_o := l_o + 1
							end
							a_wp___0.item.get_rel_pos (l_buffer + l_i___0, 70 - l_i___0)
						end
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_o := 0
							l_i___0 := 0
							from
							until
								not (not (l_break) and then ((l_buffer[l_i___0]).to_integer_32 /= 0))
							loop
								l_break := False
								l_o := l_o + ((create {P_GLOBALS_STATIC}).mb_ptr2cells.item.integer_32_item ([l_buffer + l_i___0]))
								if l_this_ru_col + l_o > l_width then
									l_buffer[l_i___0] := (('%/0/').code).to_natural_8
									l_break := True
								end
								if not (l_break) then
									l_i___0 := l_i___0 + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_buffer + l_i___0]))
								end
							end
							l_break := False
						elseif l_this_ru_col + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buffer))).to_integer_32 > l_width then
							l_buffer[l_width - l_this_ru_col] := (('%/0/').code).to_natural_8
						end
						screen_puts (l_buffer, l_row, l_this_ru_col + l_off___0, l_attr.item)
						l_i___0 := (create {P_GLOBALS_STATIC}).redraw_cmdline.item
						screen_fill (l_row, l_row + 1, (l_this_ru_col + l_off___0) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buffer))).to_integer_32, l_off___0 + l_width, l_fillchar, l_fillchar, l_attr.item);
						(create {P_GLOBALS_STATIC}).redraw_cmdline.item := l_i___0
						a_wp___0.item.w_ru_cursor := (a_wp___0.item.w_cursor).twin
						a_wp___0.item.w_ru_virtcol := a_wp___0.item.w_virtcol
						a_wp___0.item.w_ru_empty := l_empty_line.to_integer_8
						a_wp___0.item.w_ru_topline := a_wp___0.item.w_topline
						a_wp___0.item.w_ru_line_count := (a_wp___0.item.w_buffer).item.b_ml.ml_line_count
						a_wp___0.item.w_ru_topfill := a_wp___0.item.w_topfill
				when 30 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
