class
	P_SPELL_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_LIBINTL_STATIC
	S_STDIO_STATIC
	S_LIBIO_STATIC
	S_CTYPE_STATIC
	S_WCTYPE_STATIC
	S_UNISTD_STATIC
	S_STDLIB_STATIC
	S_TIME_STATIC
	S_SYS_STAT_STATIC

feature {ANY} -- public attributes

	first_lang: CE_STATIC [CE_POINTER [PD_SLANG_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (default_pointer)
		end

	int_wordlist: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	dumwc: CE_STATIC [CE_ARRAY [PD_WORDCOUNT_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_WORDCOUNT_S]}.make (<<1>>)
		end

	spelltab: CE_STATIC [CE_ARRAY [PD_SPELLTAB_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_SPELLTAB_S]}.make (<<1>>)
		end

	did_set_spelltab: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	e_format: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("E759: Format error in spell file")
		end

	e_spell_trunc: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("E758: Truncated spell file")
		end

	e_afftrailing: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("Trailing text in %%s line %%d: %%s")
		end

	e_affname: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("Affix name too long in %%s line %%d: %%s")
		end

	e_affform: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("E761: Format error in affix file FOL, LOW or UPP")
		end

	e_affrange: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("E762: Character in FOL, LOW or UPP is out of range")
		end

	msg_compressing: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("Compressing word tree...")
		end

	repl_from: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	repl_to: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	recursive___5: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	compress_start: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 30_000
		end

	compress_inc: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 100
		end

	compress_added: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 500_000
		end

	sps_flags: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 1
		end

	sps_limit: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 9_999
		end

	expr_busy: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	spell_expand_need_cap: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

feature {ANY} -- public routines

	valid_word_prefix (a_totprefcnt, a_arridx, a_flags___0: INTEGER_32; a_word: CE_POINTER [NATURAL_8]; a_slang: CE_POINTER [PD_SLANG_S]; a_cond_req: INTEGER_32): INTEGER_32
		local
			l_prefcnt: INTEGER_32
			l_pidx: INTEGER_32
			l_rp: CE_POINTER [PD_REGPROG_T]
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_prefid: INTEGER_32
			l_return, l_continue: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_REGMATCH_T]} l_regmatch___0.make (<<1>>)

			l_prefid := ((a_flags___0.to_natural_32).bit_shift_right (24)).to_integer_32
			l_prefcnt := a_totprefcnt - 1
			from
			until
				not (not (l_return) and then (l_prefcnt >= 0))
			loop
				l_continue := False
				l_pidx := a_slang.item.sl_pidxs[(a_arridx + l_prefcnt)]
				if l_prefid /= ((l_pidx).bit_and (255)) then
					l_continue := True
				end
				if not (l_return or l_continue) and then (((a_flags___0).bit_and (256)).to_boolean) then
					if ((l_pidx).bit_and (((2).bit_shift_left (24)))).to_boolean then
						l_continue := True
					end
				end
				if not (l_return or l_continue) then
					l_rp := a_slang.item.sl_prefprog[((((l_pidx.to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 65_535)).to_integer_32]
					if not l_rp.is_void then
						l_regmatch___0.item.regprog := l_rp
						l_regmatch___0.item.rm_ic := 0
						if not (l_regmatch___0.item.vim_regexec (a_word, 0)).to_boolean then
							l_continue := True
						end
					elseif a_cond_req.to_boolean then
						l_continue := True
					end
				end
				if not (l_return or l_continue) then
					Result := l_pidx
					l_return := True
				end
				if (not l_return) then
					l_prefcnt := l_prefcnt - 1
				end
			end
			if not l_return then
				l_continue := False
				Result := 0
			end
		end

	spell_valid_case (a_wordflags, a_treeflags: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_wordflags /= 4 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((a_treeflags).bit_and (64)) = 0 then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if ((a_treeflags).bit_and (132)) = 0 then
							if ((a_treeflags).bit_and (2)) = 0 then
								l_tmp := 1
							elseif ((a_wordflags).bit_and (2)) /= 0 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 4 then
					Result := l_tmp
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_load_lang (a_lang: CE_POINTER [NATURAL_8])
		local
			l_fname_enc: CE_ARRAY [NATURAL_8]
			l_r: INTEGER_32
			l_sl: CE_ARRAY [PD_SPELLOAD_S]
			l_round: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_break, l_continue: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_fname_enc.make (<<85>>)
			create {CE_CLASS_ARRAY [PD_SPELLOAD_S]} l_sl.make (<<1>>)

			strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_sl.item.sl_lang)), create {CE_INTEGER_8_POINTER}.make_cast (a_lang)).do_nothing
			l_sl.item.sl_slang := create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (default_pointer)
			l_sl.item.sl_nobreak := 0
			l_round := 1
			from
			until
				not (not (l_break) and then (l_round <= 2))
			loop
				l_break := False
				l_continue := False;
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_fname_enc), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (85).to_natural_32) - {NATURAL_32} 5, ce_string ("spell/%%s.%%s.spl"), a_lang, (spell_enc)]).do_nothing
				l_r := (create {P_EX_CMDS2_STATIC}).do_in_runtimepath (l_fname_enc, 0, spell_load_cb_address, create {CE_VOID_POINTER}.make_cast (l_sl))
				if l_r = 0 then
					if (l_sl.item.sl_lang[0]).to_integer_32 /= 0 then
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_fname_enc), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (85).to_natural_32) - {NATURAL_32} 5, ce_string ("spell/%%s.ascii.spl"), a_lang]).do_nothing
						l_r := (create {P_EX_CMDS2_STATIC}).do_in_runtimepath (l_fname_enc, 0, spell_load_cb_address, create {CE_VOID_POINTER}.make_cast (l_sl))
						if l_r = 0 then
							if (l_sl.item.sl_lang[0]).to_integer_32 /= 0 then
								if l_round = 1 then
									if ((create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_SPELLFILEMISSING, a_lang, (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname, 0, (create {P_GLOBALS_STATIC}).curbuf.item)).to_boolean then
										l_continue := True
									end
								end
							end
						end
						if not (l_break or l_continue) then
							l_break := True
						end
					end
				end
				if not (l_break or l_continue) then
					l_break := True
				end
				if (not l_break) then
					l_round := l_round + 1
				end
			end
			l_break := False
			l_continue := False
			if l_r = 0 then
				l_tmp___1 := spell_enc;
				(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Warning: Cannot find word list %"%%s.%%s.spl%" or %"%%s.ascii.spl%"")))), a_lang, l_tmp___1, a_lang]).do_nothing
			elseif not (l_sl.item.sl_slang).is_void then
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (((l_fname_enc + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fname_enc))).to_integer_32) - 3)), ce_string ("add.spl")).do_nothing;
				(create {P_EX_CMDS2_STATIC}).do_in_runtimepath (l_fname_enc, 1, spell_load_cb_address, create {CE_VOID_POINTER}.make_cast (l_sl)).do_nothing
			end
		end

	spell_enc: CE_POINTER [NATURAL_8]
		local
			l_return: BOOLEAN
		do
			if (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_enc.item.item))) < {NATURAL_32} 60 then
				if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_enc.item.item), ce_string ("iso-8859-15"))) /= 0 then
					Result := ((create {P_OPTION_STATIC}).p_enc.item.item)
					l_return := True
				end
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("latin1")))
			end
		end

	int_wordlist_spl (a_fname: CE_POINTER [NATURAL_8])
		do
			(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (a_fname), (4_096).to_natural_32, ce_string ("%%s.%%s.spl"), int_wordlist.item, (spell_enc)]).do_nothing
		end

	slang_alloc (a_lang: CE_POINTER [NATURAL_8]): CE_POINTER [PD_SLANG_S]
		local
			l_lp: CE_POINTER [PD_SLANG_S]
		do
			l_lp := create {CE_CLASS_POINTER [PD_SLANG_S]}.make_cast (((create {P_MISC2_STATIC}).alloc_clear ((create {PD_SLANG_S}.make).structure_size.to_natural_32)))
			if not l_lp.is_void then
				if not a_lang.is_void then
					l_lp.item.sl_name := (create {P_MISC2_STATIC}).vim_strsave (a_lang)
				end
				(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_rep"))).item.ga_init2 (((create {PD_FROMTO_S}.make).structure_size.to_natural_32).to_integer_32, 10);
				(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_repsal"))).item.ga_init2 (((create {PD_FROMTO_S}.make).structure_size.to_natural_32).to_integer_32, 10)
				l_lp.item.sl_compmax := 250
				l_lp.item.sl_compsylmax := 250;
				(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_wordcount"))).item.hash_init
			end
			Result := l_lp
		end

	spell_load_cb (a_fname: CE_POINTER [NATURAL_8]; a_cookie: CE_POINTER [ANY])
		local
			l_slp: CE_POINTER [PD_SPELLOAD_S]
			l_slang: CE_POINTER [PD_SLANG_S]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_slp := create {CE_CLASS_POINTER [PD_SPELLOAD_S]}.make_cast (a_cookie)
					l_slang := spell_load_file (a_fname, l_slp.item.sl_lang, create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (default_pointer), 0)
					if l_slang.is_void then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not ((l_slp.item.sl_nobreak).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (l_slang.item.sl_add).to_boolean then
							l_slang.item.sl_nobreak := (1).to_natural_8
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if (l_slang.item.sl_nobreak).to_boolean then
							l_slp.item.sl_nobreak := 1
						end
				when 5 then
						l_slp.item.sl_slang := l_slang
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_load_file (a_fname, a_lang: CE_POINTER [NATURAL_8]; a_old_lp: CE_POINTER [PD_SLANG_S]; a_silent: INTEGER_32): CE_POINTER [PD_SLANG_S]
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_n: INTEGER_32
			l_len: INTEGER_32
			l_save_sourcing_name: CE_POINTER [NATURAL_8]
			l_save_sourcing_lnum: INTEGER_32
			l_lp: CE_POINTER [PD_SLANG_S]
			l_c: INTEGER_32
			l_res: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<8>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_save_sourcing_name := (create {P_GLOBALS_STATIC}).sourcing_name.item
					l_save_sourcing_lnum := (create {P_GLOBALS_STATIC}).sourcing_lnum.item
					l_lp := create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (default_pointer)
					l_c := 0
					l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (a_fname), ce_string ("r"))
					if l_fd.is_void then
						if not a_silent.to_boolean then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_notopen.item))))), a_fname).do_nothing
						elseif (create {P_OPTION_STATIC}).p_verbose.item.item > 2 then
							(create {P_MESSAGE_STATIC}).verbose_enter;
							(create {P_MESSAGE_STATIC}).smsg ([(create {P_GLOBALS_STATIC}).e_notopen.item, a_fname]).do_nothing;
							(create {P_MESSAGE_STATIC}).verbose_leave
						end
						l_pos := -1 + 48 -- goto endFAIL
					end
				when 1 then
					if (create {P_OPTION_STATIC}).p_verbose.item.item > 2 then
						(create {P_MESSAGE_STATIC}).verbose_enter;
						(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Reading spell file %"%%s%"")))), a_fname]).do_nothing;
						(create {P_MESSAGE_STATIC}).verbose_leave
					end
					if not (a_old_lp.is_void) then
						l_pos := -1 + 6 -- skip if block
					end
				when 2 then -- if:
						l_lp := slang_alloc (a_lang)
						if l_lp.is_void then
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 3 then
						l_lp.item.sl_fname := (create {P_MISC2_STATIC}).vim_strsave (a_fname)
						if (l_lp.item.sl_fname).is_void then
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 4 then
						l_lp.item.sl_add := (not (strstr (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC1_STATIC}).gettail (a_fname))), ce_string (".add."))).is_void).to_integer
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_lp := a_old_lp
				when 7 then -- if done;
					(create {P_GLOBALS_STATIC}).sourcing_name.item := a_fname;
					(create {P_GLOBALS_STATIC}).sourcing_lnum.item := (0).to_integer_32
					l_i___0 := 0
					from
					until
						not (l_i___0 < 8)
					loop
						l_buf___6[l_i___0] := (IO_getc (l_fd)).to_natural_8
						l_i___0 := l_i___0 + 1
					end
					if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("VIMspell"), (8).to_natural_32)) /= 0 then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E757: This does not look like a spell file"))))).do_nothing
						l_pos := -1 + 48 -- goto endFAIL
					end
				when 8 then
					l_c := IO_getc (l_fd)
					if l_c < 50 then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E771: Old spell file, needs to be updated"))))).do_nothing
						l_pos := -1 + 48 -- goto endFAIL
					elseif l_c > 50 then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E772: Spell file is for newer version of Vim"))))).do_nothing
						l_pos := -1 + 48 -- goto endFAIL
					end
				when 9 then
					if (l_return or l_break) then
						l_pos := -1 + 44 -- skip loop
					end
				when 10 then -- loop body:
						l_break := False
						l_n := IO_getc (l_fd)
						if l_n = 255 then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 43 -- skip if block
						end
				when 11 then -- if:
						l_c := IO_getc (l_fd)
						l_len := (create {P_MISC2_STATIC}).get4c (l_fd)
						if l_len < 0 then
							l_pos := -1 + 41 -- goto truncerr
						end
				when 12 then
						l_res := 0
						inspect l_n -- switch 1 head
						when 15 then l_pos := -1 + 13
						when 0 then l_pos := -1 + 15
						when 1 then l_pos := -1 + 16
						when 2 then l_pos := -1 + 17
						when 3 then l_pos := -1 + 19
						when 4 then l_pos := -1 + 20
						when 12 then l_pos := -1 + 21
						when 5 then l_pos := -1 + 22
						when 6 then l_pos := -1 + 23
						when 7 then l_pos := -1 + 24
						when 13 then l_pos := -1 + 26
						when 11 then l_pos := -1 + 27
						when 14 then l_pos := -1 + 28
						when 8 then l_pos := -1 + 29
						when 10 then l_pos := -1 + 30
						when 9 then l_pos := -1 + 31
						else l_pos := -1 + 34
						end
				when 13 then -- switch 1, case 15
						l_lp.item.sl_info := (create {P_MISC2_STATIC}).read_string (l_fd, l_len)
						if (l_lp.item.sl_info).is_void then
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 14 then
						l_pos := -1 + 39 -- switch 1; break
				when 15 then -- switch 1, case 0
						l_res := l_lp.item.read_region_section (l_fd, l_len)
						l_pos := -1 + 39 -- switch 1; break
				when 16 then -- switch 1, case 1
						l_res := read_charflags_section (l_fd)
						l_pos := -1 + 39 -- switch 1; break
				when 17 then -- switch 1, case 2
						l_lp.item.sl_midword := (create {P_MISC2_STATIC}).read_string (l_fd, l_len)
						if (l_lp.item.sl_midword).is_void then
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 18 then
						l_pos := -1 + 39 -- switch 1; break
				when 19 then -- switch 1, case 3
						l_res := read_prefcond_section (l_fd, l_lp)
						l_pos := -1 + 39 -- switch 1; break
				when 20 then -- switch 1, case 4
						l_res := read_rep_section (l_fd, create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_rep")), l_lp.item.sl_rep_first)
						l_pos := -1 + 39 -- switch 1; break
				when 21 then -- switch 1, case 12
						l_res := read_rep_section (l_fd, create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_repsal")), l_lp.item.sl_repsal_first)
						l_pos := -1 + 39 -- switch 1; break
				when 22 then -- switch 1, case 5
						l_res := l_lp.item.read_sal_section (l_fd)
						l_pos := -1 + 39 -- switch 1; break
				when 23 then -- switch 1, case 6
						l_res := l_lp.item.read_sofo_section (l_fd)
						l_pos := -1 + 39 -- switch 1; break
				when 24 then -- switch 1, case 7
						l_p___0 := (create {P_MISC2_STATIC}).read_string (l_fd, l_len)
						if l_p___0.is_void then
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 25 then
						l_lp.item.set_map_str (l_p___0);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
						l_pos := -1 + 39 -- switch 1; break
				when 26 then -- switch 1, case 13
						l_res := read_words_section (l_fd, l_lp, l_len)
						l_pos := -1 + 39 -- switch 1; break
				when 27 then -- switch 1, case 11
						l_lp.item.sl_sugtime := (create {P_MISC2_STATIC}).get8ctime (l_fd)
						l_pos := -1 + 39 -- switch 1; break
				when 28 then -- switch 1, case 14
						l_lp.item.sl_nosplitsugs := 1
						l_pos := -1 + 39 -- switch 1; break
				when 29 then -- switch 1, case 8
						l_res := read_compound (l_fd, l_lp, l_len)
						l_pos := -1 + 39 -- switch 1; break
				when 30 then -- switch 1, case 10
						l_lp.item.sl_nobreak := (1).to_natural_8
						l_pos := -1 + 39 -- switch 1; break
				when 31 then -- switch 1, case 9
						l_lp.item.sl_syllable := (create {P_MISC2_STATIC}).read_string (l_fd, l_len)
						if (l_lp.item.sl_syllable).is_void then
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 32 then
						if (l_lp.item.init_syl_tab) = 0 then
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 33 then
						l_pos := -1 + 39 -- switch 1; break
				when 34 then -- switch 1, default:
						if ((l_c).bit_and (1)).to_boolean then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E770: Unsupported section in spell file"))))).do_nothing
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 35 then
						if (l_break) then
							l_pos := -1 + 38 -- skip loop
						end
				when 36 then -- loop body:
						l_break := False
						l_len := l_len - 1
						if not (l_len >= 0) then
							l_break := True
						end
						if not (l_break) then
							if (IO_getc (l_fd)) < 0 then
								l_pos := -1 + 41 -- goto truncerr
							end
						end
				when 37 then
						l_pos := -1 + 35 -- back to loop condition
				when 38 then -- loop done
						l_break := False
						l_pos := -1 + 39 -- switch 1; break
				when 39 then -- switch 1, done: | someerror:
						if l_res = -2 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (e_format.item)))).do_nothing
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 40 then
						if l_res /= -1 then
							l_pos := -1 + 42 -- skip if block
						end
				when 41 then -- if: | truncerr:;
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (e_spell_trunc.item)))).do_nothing
						l_pos := -1 + 48 -- goto endFAIL
				when 42 then
						if l_res = -3 then
							l_pos := -1 + 48 -- goto endFAIL
						end
				when 43 then
						l_pos := -1 + 9 -- back to loop condition
				when 44 then -- loop done
					l_break := False
					l_res := spell_read_tree (l_fd, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_fbyts")), create {CE_POINTER_POINTER [INTEGER_32]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_fidxs")), 0, 0)
					if l_res /= 0 then
						l_pos := -1 + 39 -- goto someerror
					end
				when 45 then
					l_res := spell_read_tree (l_fd, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_kbyts")), create {CE_POINTER_POINTER [INTEGER_32]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_kidxs")), 0, 0)
					if l_res /= 0 then
						l_pos := -1 + 39 -- goto someerror
					end
				when 46 then
					l_res := spell_read_tree (l_fd, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_pbyts")), create {CE_POINTER_POINTER [INTEGER_32]}.make_shared (l_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_pidxs")), 1, l_lp.item.sl_prefixcnt)
					if l_res /= 0 then
						l_pos := -1 + 39 -- goto someerror
					end
				when 47 then
					if a_old_lp.is_void then
						if not a_lang.is_void then
							l_lp.item.sl_next := first_lang.item
							first_lang.item := l_lp
						end
					end
					l_pos := -1 + 49 -- goto endOK
				when 48 then -- endFAIL:
					if not a_lang.is_void then
						a_lang.item := (('%/0/').code).to_natural_8
					end
					if not l_lp.is_void then
						if a_old_lp.is_void then
							l_lp.item.slang_free
						end
					end
					l_lp := create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (default_pointer)
				when 49 then -- endOK:
					if not l_fd.is_void then
						fclose (l_fd).do_nothing
					end
					(create {P_GLOBALS_STATIC}).sourcing_name.item := l_save_sourcing_name;
					(create {P_GLOBALS_STATIC}).sourcing_lnum.item := l_save_sourcing_lnum
					Result := l_lp
				when 50 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	read_cnt_string (a_fd: CE_POINTER [SD_IO_FILE]; a_cnt_bytes: INTEGER_32; a_cntp: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		require
			not a_cntp.is_void
		local
			l_cnt: INTEGER_32
			l_i___0: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_cnt := 0
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_cnt_bytes)
			loop
				l_cnt := ((l_cnt).bit_shift_left (8)) + (IO_getc (a_fd))
				l_i___0 := l_i___0 + 1
			end
			if l_cnt < 0 then
				a_cntp.item := -1
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				a_cntp.item := l_cnt
				if l_cnt = 0 then
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_str___1 := (create {P_MISC2_STATIC}).read_string (a_fd, l_cnt)
				if l_str___1.is_void then
					a_cntp.item := -3
				end
				Result := l_str___1
			end
		end

	read_charflags_section (a_fd: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_flags___0: CE_POINTER [NATURAL_8]
			l_fol: CE_POINTER [NATURAL_8]
			l_flagslen: CE_ARRAY [INTEGER_32]
			l_follen: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_flagslen.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_follen.make (<<1>>)

			l_flags___0 := read_cnt_string (a_fd, 1, l_flagslen)
			if l_flagslen.item < 0 then
				Result := (l_flagslen.item)
				l_return := True
			end
			if not l_return then
				l_fol := read_cnt_string (a_fd, 2, l_follen)
				if l_follen.item < 0 then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_flags___0))
					Result := (l_follen.item)
					l_return := True
				end
			end
			if not l_return then
				if not l_flags___0.is_void then
					if not l_fol.is_void then
						set_spell_charflags (l_flags___0, l_flagslen.item, l_fol)
					end
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_flags___0));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fol))
				if (l_flags___0.is_void) /= (l_fol.is_void) then
					Result := (-2)
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	read_prefcond_section (a_fd: CE_POINTER [SD_IO_FILE]; a_lp: CE_POINTER [PD_SLANG_S]): INTEGER_32
		local
			l_cnt: INTEGER_32
			l_i___0: INTEGER_32
			l_n: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<251>>)

			l_cnt := (create {P_MISC2_STATIC}).get2c (a_fd)
			if l_cnt <= 0 then
				Result := (-2)
				l_return := True
			end
			if not l_return then
				a_lp.item.sl_prefprog := create {CE_POINTER_POINTER [PD_REGPROG_T]}.make_cast (((create {P_MISC2_STATIC}).alloc_clear ({PLATFORM}.Pointer_bytes.to_natural_32 * l_cnt.to_natural_32)))
				if (a_lp.item.sl_prefprog).is_void then
					Result := (-3)
					l_return := True
				end
			end
			if not l_return then
				a_lp.item.sl_prefixcnt := l_cnt
				l_i___0 := 0
				from
				until
					not (not (l_return) and then (l_i___0 < l_cnt))
				loop
					l_n := IO_getc (a_fd)
					if l_n < 0 then
						Result := (-2)
						l_return := True
					elseif l_n >= 250 then
						Result := (-2)
						l_return := True
					end
					if not l_return then
						if l_n > 0 then
							l_buf___6[0] := (('^').code).to_natural_8
							l_p___0 := l_buf___6 + 1
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___2 := l_n
								l_n := l_n - 1
								if not (l_tmp___2 > 0) then
									l_break := True
								end
								if not (l_break) then
									l_tmp___0 := l_p___0
									l_p___0 := l_p___0 + 1
									l_tmp___0.item := (IO_getc (a_fd)).to_natural_8
								end
							end
							l_break := False
							l_p___0.item := (('%/0/').code).to_natural_8
							a_lp.item.sl_prefprog[l_i___0] := (create {P_REGEXP_STATIC}).vim_regcomp (l_buf___6, 3)
						end
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	read_rep_section (a_fd: CE_POINTER [SD_IO_FILE]; a_gap: CE_POINTER [PD_GROWARRAY]; a_first___0: CE_POINTER [INTEGER_16]): INTEGER_32
		local
			l_cnt: INTEGER_32
			l_ftp: CE_POINTER [PD_FROMTO_S]
			l_i___0: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_i___0.make (<<1>>)

			l_cnt := (create {P_MISC2_STATIC}).get2c (a_fd)
			if l_cnt < 0 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if (a_gap.item.ga_grow (l_cnt)) = 0 then
					Result := (-3)
					l_return := True
				end
			end
			if not l_return then
				from
				until
					not (not (l_return) and then (a_gap.item.ga_len < l_cnt))
				loop
					l_ftp := create {CE_CLASS_POINTER [PD_FROMTO_S]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len
					l_ftp.item.ft_from := read_cnt_string (a_fd, 1, l_i___0)
					if l_i___0.item < 0 then
						Result := (l_i___0.item)
						l_return := True
					end
					if not l_return and then (l_i___0.item = 0) then
						Result := (-2)
						l_return := True
					end
					if not l_return then
						l_ftp.item.ft_to := read_cnt_string (a_fd, 1, l_i___0)
						if l_i___0.item <= 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ftp.item.ft_from))
							if l_i___0.item < 0 then
								Result := (l_i___0.item)
								l_return := True
							end
							if not l_return then
								Result := (-2)
								l_return := True
							end
						end
					end
					if not l_return then
						a_gap.item.ga_len := (a_gap.item.ga_len) + 1
					end
				end
			end
			if not l_return then
				l_i___0.item := 0
				from
				until
					not (l_i___0.item < 256)
				loop
					a_first___0[l_i___0.item] := (-1).to_integer_16
					l_i___0.item := l_i___0.item + 1
				end
				l_i___0.item := 0
				from
				until
					not (l_i___0.item < a_gap.item.ga_len)
				loop
					l_ftp := create {CE_CLASS_POINTER [PD_FROMTO_S]}.make_cast (a_gap.item.ga_data) + l_i___0.item
					if (a_first___0[((l_ftp.item.ft_from).item).to_integer_32]).to_integer_32 = -1 then
						a_first___0[((l_ftp.item.ft_from).item).to_integer_32] := (l_i___0.item).to_integer_16
					end
					l_i___0.item := l_i___0.item + 1
				end
				Result := 0
			end
		end

	read_words_section (a_fd: CE_POINTER [SD_IO_FILE]; a_lp: CE_POINTER [PD_SLANG_S]; a_len: INTEGER_32): INTEGER_32
		local
			l_done___2: INTEGER_32
			l_i___0: INTEGER_32
			l_c: INTEGER_32
			l_word: CE_ARRAY [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_word.make (<<250>>)

			l_done___2 := 0
			from
			until
				not (not (l_return) and then (l_done___2 < a_len))
			loop
				l_i___0 := 0
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_c := IO_getc (a_fd)
					if l_c = -1 then
						Result := (-1)
						l_return := True
					end
					if not l_return then
						l_word[l_i___0] := l_c.to_natural_8
						if (l_word[l_i___0]).to_integer_32 = 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							if l_i___0 = 249 then
								Result := (-2)
								l_return := True
							end
							if not l_return then
								l_i___0 := l_i___0 + 1
							end
						end
					end
				end
				if not l_return then
					l_break := False
					count_common_word (a_lp, l_word, -1, 10)
					l_done___2 := l_done___2 + (l_i___0 + 1)
				end
			end
			if not l_return then
				Result := 0
			end
		end

	count_common_word (a_lp: CE_POINTER [PD_SLANG_S]; a_word: CE_POINTER [NATURAL_8]; a_len, a_count___2: INTEGER_32)
		require
			not a_word.is_void
		local
			l_hash: NATURAL_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_wc: CE_POINTER [PD_WORDCOUNT_S]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: NATURAL_16
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<250>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_len = -1 then
						l_p___0 := a_word
					else
						(create {P_MISC2_STATIC}).vim_strncpy (l_buf___6, a_word, a_len.to_natural_32)
						l_p___0 := l_buf___6
					end
					l_hash := (create {P_HASHTAB_STATIC}).hash_hash (l_p___0)
					l_hi___1 := (create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_wordcount"))).item.hash_lookup (l_p___0, l_hash)
					if not ((l_hi___1.item.hi_key).is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_wc := create {CE_CLASS_POINTER [PD_WORDCOUNT_S]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_WORDCOUNT_S}.make).structure_size.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))))))
						if l_wc.is_void then
							l_return := True
						end
						if not l_return then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_wc.item.wc_word)), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0)).do_nothing
							l_wc.item.wc_count := a_count___2.to_natural_16;
							(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_lp.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_wordcount"))).item.hash_add_item (l_hi___1, l_wc.item.wc_word, l_hash).do_nothing
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_wc := create {CE_CLASS_POINTER [PD_WORDCOUNT_S]}.make_cast ((l_hi___1.item.hi_key - (((dumwc.item.item.wc_word).distance ((create {CE_NATURAL_8_POINTER}.make_cast (dumwc.item)))).to_natural_32).to_integer_32))
						l_tmp___1 := ((l_wc.item.wc_count).to_integer_32 + a_count___2).to_natural_16
						l_wc.item.wc_count := l_tmp___1
						if l_tmp___1.to_natural_32 < a_count___2.to_natural_32 then
							l_wc.item.wc_count := (65_535).to_natural_16
						end
				when 7 then -- if done
					if not l_return then
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	read_compound (a_fd: CE_POINTER [SD_IO_FILE]; a_slang: CE_POINTER [PD_SLANG_S]; a_len: INTEGER_32): INTEGER_32
		local
			l_todo: INTEGER_32
			l_c: INTEGER_32
			l_atstart: INTEGER_32
			l_pat: CE_POINTER [NATURAL_8]
			l_pp: CE_POINTER [NATURAL_8]
			l_cp: CE_POINTER [NATURAL_8]
			l_ap___0: CE_POINTER [NATURAL_8]
			l_crp: CE_POINTER [NATURAL_8]
			l_cnt: CE_ARRAY [INTEGER_32]
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_tmp: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_tmp___15: INTEGER_32
			l_tmp___16: CE_POINTER [NATURAL_8]
			l_tmp___17: CE_POINTER [NATURAL_8]
			l_tmp___18: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_cnt.make (<<1>>)

			l_todo := a_len
			if l_todo < 2 then
				Result := (-2)
				l_return := True
			end
			if not l_return then
				l_todo := l_todo - 1
				l_c := IO_getc (a_fd)
				if l_c < 2 then
					l_c := 250
				end
				a_slang.item.sl_compmax := l_c
				l_todo := l_todo - 1
				l_c := IO_getc (a_fd)
				if l_c < 1 then
					l_c := 0
				end
				a_slang.item.sl_compminlen := l_c
				l_todo := l_todo - 1
				l_c := IO_getc (a_fd)
				if l_c < 1 then
					l_c := 250
				end
				a_slang.item.sl_compsylmax := l_c
				l_c := IO_getc (a_fd)
				if l_c /= 0 then
					ungetc (l_c, a_fd).do_nothing
				else
					l_todo := l_todo - 1
					l_c := IO_getc (a_fd)
					l_todo := l_todo - 1
					a_slang.item.sl_compoptions := l_c
					l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_comppat"))
					l_c := (create {P_MISC2_STATIC}).get2c (a_fd)
					l_todo := l_todo - (2)
					l_gap.item.ga_init2 (({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, l_c)
					if (l_gap.item.ga_grow (l_c)) = 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_c := l_c - 1
							if not (l_c >= 0) then
								l_break := True
							end
							if not (l_return or l_break) then
								l_tmp := l_gap.item.ga_len
								l_gap.item.ga_len := (l_gap.item.ga_len) + 1
								create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_gap.item.ga_data)[l_tmp] := read_cnt_string (a_fd, 1, l_cnt)
								if l_cnt.item < 0 then
									Result := (l_cnt.item)
									l_return := True
								end
								if not l_return then
									l_todo := l_todo - (l_cnt.item + 1)
								end
							end
						end
						if not l_return then
							l_break := False
						end
					end
				end
			end
			if not l_return and then (l_todo < 0) then
				Result := (-2)
				l_return := True
			end
			if not l_return then
				l_c := l_todo * 2 + 7
				if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
					l_c := l_c + (l_todo * 2)
				end
				l_pat := (create {P_MISC2_STATIC}).alloc (l_c.to_natural_32)
				if l_pat.is_void then
					Result := (-3)
					l_return := True
				end
			end
			if not l_return then
				l_cp := (create {P_MISC2_STATIC}).alloc ((l_todo + 1).to_natural_32)
				if l_cp.is_void then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pat))
					Result := (-3)
					l_return := True
				end
			end
			if not l_return then
				a_slang.item.sl_compstartflags := l_cp
				l_cp.item := (('%/0/').code).to_natural_8
				l_ap___0 := (create {P_MISC2_STATIC}).alloc ((l_todo + 1).to_natural_32)
				if l_ap___0.is_void then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pat))
					Result := (-3)
					l_return := True
				end
			end
			if not l_return then
				a_slang.item.sl_compallflags := l_ap___0
				l_ap___0.item := (('%/0/').code).to_natural_8
				l_crp := (create {P_MISC2_STATIC}).alloc ((l_todo + 1).to_natural_32)
				a_slang.item.sl_comprules := l_crp
				l_pp := l_pat
				l_tmp___1 := l_pp
				l_pp := l_pp + 1
				l_tmp___1.item := (('^').code).to_natural_8
				l_tmp___2 := l_pp
				l_pp := l_pp + 1
				l_tmp___2.item := (('\').code).to_natural_8
				l_tmp___3 := l_pp
				l_pp := l_pp + 1
				l_tmp___3.item := (('(').code).to_natural_8
				l_atstart := 1
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_tmp___15 := l_todo
					l_todo := l_todo - 1
					if not (l_tmp___15 > 0) then
						l_break := True
					end
					if not (l_return or l_break) then
						l_c := IO_getc (a_fd)
						if l_c = -1 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pat))
							Result := (-1)
							l_return := True
						end
						if not l_return then
							if ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("+*[]/")), l_c)).is_void then
								if not (byte_in_str (a_slang.item.sl_compallflags, l_c)).to_boolean then
									l_tmp___4 := l_ap___0
									l_ap___0 := l_ap___0 + 1
									l_tmp___4.item := l_c.to_natural_8
									l_ap___0.item := (('%/0/').code).to_natural_8
								end
							end
							if l_atstart /= 0 then
								if l_c = 91 then
									l_atstart := 2
								elseif l_c = 93 then
									l_atstart := 0
								else
									if not (byte_in_str (a_slang.item.sl_compstartflags, l_c)).to_boolean then
										l_tmp___7 := l_cp
										l_cp := l_cp + 1
										l_tmp___7.item := l_c.to_natural_8
										l_cp.item := (('%/0/').code).to_natural_8
									end
									if l_atstart = 1 then
										l_atstart := 0
									end
								end
							end
							if not l_crp.is_void then
								if l_c = 43 then
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_slang.item.sl_comprules))
									a_slang.item.sl_comprules := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
									l_crp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								elseif l_c = 42 then
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_slang.item.sl_comprules))
									a_slang.item.sl_comprules := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
									l_crp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								else
									l_tmp___9 := l_crp
									l_crp := l_crp + 1
									l_tmp___9.item := l_c.to_natural_8
								end
							end
							if l_c = 47 then
								l_tmp___10 := l_pp
								l_pp := l_pp + 1
								l_tmp___10.item := (('\').code).to_natural_8
								l_tmp___11 := l_pp
								l_pp := l_pp + 1
								l_tmp___11.item := (('|').code).to_natural_8
								l_atstart := 1
							else
								if l_c = 43 then
									l_tmp___12 := l_pp
									l_pp := l_pp + 1
									l_tmp___12.item := (('\').code).to_natural_8
								elseif l_c = 126 then
									l_tmp___12 := l_pp
									l_pp := l_pp + 1
									l_tmp___12.item := (('\').code).to_natural_8
								end
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_pp := l_pp + ((create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([l_c, l_pp]))
								else
									l_tmp___14 := l_pp
									l_pp := l_pp + 1
									l_tmp___14.item := l_c.to_natural_8
								end
							end
						end
					end
				end
			end
			if not l_return then
				l_break := False
				l_tmp___16 := l_pp
				l_pp := l_pp + 1
				l_tmp___16.item := (('\').code).to_natural_8
				l_tmp___17 := l_pp
				l_pp := l_pp + 1
				l_tmp___17.item := ((')').code).to_natural_8
				l_tmp___18 := l_pp
				l_pp := l_pp + 1
				l_tmp___18.item := (('$').code).to_natural_8
				l_pp.item := (('%/0/').code).to_natural_8
				if not l_crp.is_void then
					l_crp.item := (('%/0/').code).to_natural_8
				end
				a_slang.item.sl_compprog := (create {P_REGEXP_STATIC}).vim_regcomp (l_pat, 7);
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pat))
				if (a_slang.item.sl_compprog).is_void then
					Result := (-2)
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	byte_in_str (a_str___1: CE_POINTER [NATURAL_8]; a_n: INTEGER_32): INTEGER_32
		require
			not a_str___1.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_p___0 := a_str___1
			from
			until
				not (not (l_return) and then ((l_p___0.item).to_integer_32 /= 0))
			loop
				if (l_p___0.item).to_integer_32 = a_n then
					Result := 1
					l_return := True
				end
				if not l_return then
					l_p___0 := l_p___0 + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	spell_read_tree (a_fd: CE_POINTER [SD_IO_FILE]; a_bytsp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_idxsp: CE_POINTER [CE_POINTER [INTEGER_32]]; a_prefixtree, a_prefixcnt: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_idx: INTEGER_32
			l_bp___0: CE_POINTER [NATURAL_8]
			l_ip: CE_POINTER [INTEGER_32]
			l_return: BOOLEAN
		do
			l_len := (create {P_MISC2_STATIC}).get4c (a_fd)
			if l_len < 0 then
				Result := (-1)
				l_return := True
			end
			if not l_return and then (l_len > 0) then
				l_bp___0 := (create {P_MISC2_STATIC}).lalloc (l_len.to_natural_32, 1)
				if l_bp___0.is_void then
					Result := (-3)
					l_return := True
				end
				if not l_return then
					a_bytsp.item := l_bp___0
					l_ip := create {CE_INTEGER_32_POINTER}.make_cast (((create {P_MISC2_STATIC}).lalloc_clear ((l_len.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32).to_natural_32, 1)))
					if l_ip.is_void then
						Result := (-3)
						l_return := True
					end
				end
				if not l_return then
					a_idxsp.item := l_ip
					l_idx := read_tree_node (a_fd, l_bp___0, l_ip, l_len, 0, a_prefixtree, a_prefixcnt)
					if l_idx < 0 then
						Result := l_idx
						l_return := True
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	read_tree_node (a_fd: CE_POINTER [SD_IO_FILE]; a_byts: CE_POINTER [NATURAL_8]; a_idxs: CE_POINTER [INTEGER_32]; a_maxidx, a_startidx, a_prefixtree, a_maxprefcondnr: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_n: INTEGER_32
			l_idx: INTEGER_32
			l_c: INTEGER_32
			l_c2: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_idx := a_startidx
					l_len := IO_getc (a_fd)
					if l_len <= 0 then
						Result := (-1)
						l_return := True
					end
					if not l_return and then (a_startidx + l_len >= a_maxidx) then
						Result := (-2)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_tmp := l_idx
						l_idx := l_idx + 1
						a_byts[l_tmp] := l_len.to_natural_8
						l_i___0 := 1
				when 2 then -- loop condition:
						if not (not (l_return) and then (l_i___0 <= l_len)) then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						l_c := IO_getc (a_fd)
						if l_c < 0 then
							Result := (-1)
							l_return := True
						end
						if not (not l_return and then (l_c <= 3)) then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if l_c /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not a_prefixtree.to_boolean then
							a_idxs[l_idx] := 0
							l_c := 0
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if l_c /= 1 then
							if a_prefixtree.to_boolean then
								if l_c = 2 then
									l_c := ((IO_getc (a_fd))).bit_shift_left (24)
								else
									l_c := 0
								end
								l_c := (l_c).bit_or ((IO_getc (a_fd)))
								l_n := (create {P_MISC2_STATIC}).get2c (a_fd)
								if l_n >= a_maxprefcondnr then
									Result := (-2)
									l_return := True
								end
								if not l_return then
									l_c := (l_c).bit_or (((l_n).bit_shift_left (8)))
								end
							else
								l_c2 := l_c
								l_c := IO_getc (a_fd)
								if l_c2 = 3 then
									l_c := (((IO_getc (a_fd))).bit_shift_left (8)) + l_c
								end
								if ((l_c).bit_and (1)).to_boolean then
									l_c := (((IO_getc (a_fd))).bit_shift_left (16)) + l_c
								end
								if ((l_c).bit_and (32)).to_boolean then
									l_c := (((IO_getc (a_fd))).bit_shift_left (24)) + l_c
								end
							end
							if not l_return then
								a_idxs[l_idx] := l_c
								l_c := 0
							end
						else
							l_n := (create {P_MISC2_STATIC}).get3c (a_fd)
							if l_n < 0 then
								Result := (-2)
								l_return := True
							elseif l_n >= a_maxidx then
								Result := (-2)
								l_return := True
							end
							if not l_return then
								a_idxs[l_idx] := l_n + 134_217_728
								l_c := IO_getc (a_fd)
							end
						end
				when 8 then -- if done
						if not l_return then
							l_tmp___5 := l_idx
							l_idx := l_idx + 1
							a_byts[l_tmp___5] := l_c.to_natural_8
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done | if done
					if not l_return then
						l_i___0 := 1
						from
						until
							not (not (l_break) and then (l_i___0 <= l_len))
						loop
							l_break := False
							if (a_byts[(a_startidx + l_i___0)]).to_integer_32 /= 0 then
								if ((a_idxs[(a_startidx + l_i___0)]).bit_and (134_217_728)).to_boolean then
									a_idxs[(a_startidx + l_i___0)] := (a_idxs[(a_startidx + l_i___0)]).bit_and ((-134_217_729))
								else
									a_idxs[(a_startidx + l_i___0)] := l_idx
									l_idx := read_tree_node (a_fd, a_byts, a_idxs, a_maxidx, l_idx, a_prefixtree, a_maxprefcondnr)
									if l_idx < 0 then
										l_break := True
									end
								end
							end
							if not (l_return or l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						Result := l_idx
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	did_set_spelllang (a_wp___0: CE_POINTER [PD_WINDOW_S]): CE_POINTER [NATURAL_8]
		local
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_splp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_region: CE_POINTER [NATURAL_8]
			l_region_cp: CE_ARRAY [NATURAL_8]
			l_filename: INTEGER_32
			l_region_mask: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
			l_c: INTEGER_32
			l_lang: CE_ARRAY [NATURAL_8]
			l_spf_name: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_round: INTEGER_32
			l_spf: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_use_region: CE_POINTER [NATURAL_8]
			l_dont_use_region: INTEGER_32
			l_nobreak: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_lp: CE_POINTER [PD_LANGP_S]
			l_lp2: CE_POINTER [PD_LANGP_S]
			l_ret_msg: CE_POINTER [NATURAL_8]
			l_spl_copy: CE_POINTER [NATURAL_8]
			l_tmp___13: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_splp.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_region_cp.make (<<3>>)
			create {CE_NATURAL_8_ARRAY} l_lang.make (<<251>>)
			create {CE_NATURAL_8_ARRAY} l_spf_name.make (<<4_096>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_spf.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_use_region := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_dont_use_region := 0
					l_nobreak := 0
					l_ret_msg := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					if recursive___5.item.to_boolean then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						recursive___5.item := 1
						l_ga.item.ga_init2 (((create {PD_LANGP_S}.make).structure_size.to_natural_32).to_integer_32, 2)
						a_wp___0.item.clear_midword
						l_spl_copy := (create {P_MISC2_STATIC}).vim_strsave ((a_wp___0.item.w_s).item.b_p_spl)
						if l_spl_copy.is_void then
							l_pos := -1 + 18 -- goto theend
						end
				when 2 then
						l_splp.item := l_spl_copy
				when 3 then -- loop condition:
						if not (not (l_return) and then ((l_splp.item.item).to_integer_32 /= 0)) then
							l_pos := -1 + 17 -- skip loop
						end
				when 4 then -- loop body:;
						(create {P_MISC2_STATIC}).copy_option_part (l_splp, l_lang, 250, ce_string (",")).do_nothing
						l_region := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_lang))).to_integer_32
						if not (l_len > 4) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (((l_lang + l_len) - 4)), ce_string (".spl"))) = 0 then
							l_filename := 1
							l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (((create {P_MISC1_STATIC}).gettail (l_lang)), ('_').code)
							if not l_p___0.is_void then
								if (l_p___0[1]).to_integer_32 < 127 then
									if ((((ctype_b_loc).item[(l_p___0[1]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
										if (l_p___0[2]).to_integer_32 < 127 then
											if ((((ctype_b_loc).item[(l_p___0[2]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
												if (l_p___0[3]).to_integer_32 < 127 then
													if ((((ctype_b_loc).item[(l_p___0[3]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
														l_dont_use_region := 1
													else
														(create {P_MISC2_STATIC}).vim_strncpy (l_region_cp, l_p___0 + 1, (2).to_natural_32)
														memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + 3)), ((l_len - (l_p___0.distance (l_lang))) - 2).to_natural_32).do_nothing
														l_len := l_len - (3)
														l_region := l_region_cp
													end
												else
													(create {P_MISC2_STATIC}).vim_strncpy (l_region_cp, l_p___0 + 1, (2).to_natural_32)
													memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + 3)), ((l_len - (l_p___0.distance (l_lang))) - 2).to_natural_32).do_nothing
													l_len := l_len - (3)
													l_region := l_region_cp
												end
											else
												l_dont_use_region := 1
											end
										else
											l_dont_use_region := 1
										end
									else
										l_dont_use_region := 1
									end
								else
									l_dont_use_region := 1
								end
							else
								l_dont_use_region := 1
							end
							l_slang := first_lang.item
							from
							until
								not (not (l_break) and then (not l_slang.is_void))
							loop
								l_break := False
								if ((create {P_MISC1_STATIC}).fullpathcmp (l_lang, l_slang.item.sl_fname, 0)) = 1 then
									l_break := True
								end
								if not (l_break) then
									l_slang := l_slang.item.sl_next
								end
							end
							l_break := False
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						l_filename := 0
						if l_len > 3 then
							if (l_lang[l_len - 3]).to_integer_32 = 95 then
								l_region := (l_lang + l_len) - 2
								l_len := l_len - (3)
								l_lang[l_len] := (('%/0/').code).to_natural_8
							else
								l_dont_use_region := 1
							end
						else
							l_dont_use_region := 1
						end
						l_slang := first_lang.item
						from
						until
							not (not (l_break) and then (not l_slang.is_void))
						loop
							l_break := False
							if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_lang), create {CE_INTEGER_8_POINTER}.make_cast (l_slang.item.sl_name))) = 0 then
								l_break := True
							end
							if not (l_break) then
								l_slang := l_slang.item.sl_next
							end
						end
						l_break := False
				when 8 then
						if not l_region.is_void then
							if not l_use_region.is_void then
								if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_region), create {CE_INTEGER_8_POINTER}.make_cast (l_use_region))) /= 0 then
									l_dont_use_region := 1
								end
							end
							l_use_region := l_region
						end
						if l_slang.is_void then
							if l_filename.to_boolean then
								spell_load_file (l_lang, l_lang, create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (default_pointer), 0).do_nothing
							else
								spell_load_lang (l_lang)
								if not ((create {P_BUFFER_STATIC}).buf_valid (a_wp___0.item.w_buffer)).to_boolean then
									l_ret_msg := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E797: SpellFileMissing autocommand deleted buffer"))
									l_pos := -1 + 18 -- goto theend
								end
							end
						end
				when 9 then
						l_slang := first_lang.item
				when 10 then -- loop condition:
						if l_slang.is_void then
							l_pos := -1 + 16 -- skip loop
						end
				when 11 then -- loop body:
						if l_filename.to_boolean then
							l_tmp___13 := (((create {P_MISC1_STATIC}).fullpathcmp (l_lang, l_slang.item.sl_fname, 0)) = 1).to_integer
						else
							l_tmp___13 := ((strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_lang), create {CE_INTEGER_8_POINTER}.make_cast (l_slang.item.sl_name))) = 0).to_integer
						end
						if not (l_tmp___13.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 12 then -- if:
						l_region_mask := 255
						if not l_filename.to_boolean then
							if not l_region.is_void then
								l_c := find_region (l_slang.item.sl_regions, l_region)
								if l_c = 255 then
									if (l_slang.item.sl_add).to_boolean then
										if (l_slang.item.sl_regions[0]).to_integer_32 /= 0 then
											l_region_mask := 0
										end
									else
										(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Warning: region %%s not supported")))), l_region]).do_nothing
									end
								else
									l_region_mask := (1).bit_shift_left (l_c)
								end
							end
						end
						if l_region_mask = 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if (l_ga.item.ga_grow (1)) = 0 then
							l_ga.item.ga_clear
							l_ret_msg := (create {P_GLOBALS_STATIC}).e_outofmem.item
							l_pos := -1 + 18 -- goto theend
						end
				when 14 then;
						(create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_ga.item.ga_len).item.lp_slang := l_slang;
						(create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_ga.item.ga_len).item.lp_region := l_region_mask
						l_ga.item.ga_len := (l_ga.item.ga_len) + 1
						l_slang.item.use_midword (a_wp___0)
						if (l_slang.item.sl_nobreak).to_boolean then
							l_nobreak := 1
						end
				when 15 then -- if done | if done
						l_slang := l_slang.item.sl_next
						l_pos := -1 + 10 -- back to loop condition
				when 16 then -- loop done
						l_pos := -1 + 3 -- back to loop condition
				when 17 then -- loop done
						l_spf.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_p_spf
						l_round := 0
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_continue := False
							if l_round /= 0 then
								if (l_spf.item.item).to_integer_32 = 0 then
									l_break := True
								end
							end
							if not (l_return or l_break or l_continue) then
								if l_round = 0 then
									if int_wordlist.item.is_void then
										l_continue := True
									end
									if not (l_return or l_break or l_continue) then
										int_wordlist_spl (l_spf_name)
									end
								else
									(create {P_MISC2_STATIC}).copy_option_part (l_spf, l_spf_name, 4_091, ce_string (",")).do_nothing
									strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_spf_name), ce_string (".spl")).do_nothing
									l_c := 0
									from
									until
										not (not (l_break) and then (l_c < l_ga.item.ga_len))
									loop
										l_break := False
										l_p___0 := ((create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_c).item.lp_slang).item.sl_fname
										if not l_p___0.is_void then
											if ((create {P_MISC1_STATIC}).fullpathcmp (l_spf_name, l_p___0, 0)) = 1 then
												l_break := True
											end
										end
										if not (l_return or l_break) then
											l_c := l_c + 1
										end
									end
									l_break := False
									if l_c < l_ga.item.ga_len then
										l_continue := True
									end
								end
							end
							if not (l_return or l_break or l_continue) then
								l_slang := first_lang.item
								from
								until
									not (not (l_break) and then (not l_slang.is_void))
								loop
									l_break := False
									if ((create {P_MISC1_STATIC}).fullpathcmp (l_spf_name, l_slang.item.sl_fname, 0)) = 1 then
										l_break := True
									end
									if not (l_return or l_break) then
										l_slang := l_slang.item.sl_next
									end
								end
								l_break := False
								if l_slang.is_void then
									if l_round = 0 then
										strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_lang), ce_string ("internal wordlist")).do_nothing
									else
										(create {P_MISC2_STATIC}).vim_strncpy (l_lang, ((create {P_MISC1_STATIC}).gettail (l_spf_name)), (250).to_natural_32)
										l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (l_lang, ('.').code)
										if not l_p___0.is_void then
											l_p___0.item := (('%/0/').code).to_natural_8
										end
									end
									l_slang := spell_load_file (l_spf_name, l_lang, create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (default_pointer), 1)
									if not l_slang.is_void then
										if l_nobreak.to_boolean then
											l_slang.item.sl_nobreak := (1).to_natural_8
										end
									end
								end
								if not l_slang.is_void then
									if (l_ga.item.ga_grow (1)) = 1 then
										l_region_mask := 255
										if not l_use_region.is_void then
											if not l_dont_use_region.to_boolean then
												l_c := find_region (l_slang.item.sl_regions, l_use_region)
												if l_c /= 255 then
													l_region_mask := (1).bit_shift_left (l_c)
												elseif (l_slang.item.sl_regions[0]).to_integer_32 /= 0 then
													l_region_mask := 0
												end
											end
										end
										if l_region_mask /= 0 then
											(create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_ga.item.ga_len).item.lp_slang := l_slang;
											(create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_ga.item.ga_len).item.lp_sallang := create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (default_pointer);
											(create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_ga.item.ga_len).item.lp_replang := create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (default_pointer);
											(create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_ga.item.ga_len).item.lp_region := l_region_mask
											l_ga.item.ga_len := (l_ga.item.ga_len) + 1
											l_slang.item.use_midword (a_wp___0)
										end
									end
								end
							end
							if (not l_return and not l_break) then
								l_round := l_round + 1
							end
						end
						l_break := False
						l_continue := False;
						(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared ((a_wp___0.item.w_s).c_pointer + (create {PD_SYNBLOCK_T}.make).offset_of ("b_langp"))).item.ga_clear;
						(a_wp___0.item.w_s).item.b_langp := (l_ga.item).twin
						l_i___0 := 0
						from
						until
							not (not (l_return) and then (l_i___0 < l_ga.item.ga_len))
						loop
							l_lp := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_i___0
							if (l_lp.item.lp_slang).item.sl_sal.ga_len > 0 then
								l_lp.item.lp_sallang := l_lp.item.lp_slang
							else
								l_j := 0
								from
								until
									not (not (l_break) and then (l_j < l_ga.item.ga_len))
								loop
									l_break := False
									l_lp2 := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_j
									if (l_lp2.item.lp_slang).item.sl_sal.ga_len > 0 then
										if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_lp.item.lp_slang).item.sl_name), create {CE_INTEGER_8_POINTER}.make_cast ((l_lp2.item.lp_slang).item.sl_name), (2).to_natural_32)) = 0 then
											l_lp.item.lp_sallang := l_lp2.item.lp_slang
											l_break := True
										end
									end
									if not (l_return or l_break or l_continue) then
										l_j := l_j + 1
									end
								end
								l_break := False
							end
							if (l_lp.item.lp_slang).item.sl_rep.ga_len > 0 then
								l_lp.item.lp_replang := l_lp.item.lp_slang
							else
								l_j := 0
								from
								until
									not (not (l_break) and then (l_j < l_ga.item.ga_len))
								loop
									l_break := False
									l_lp2 := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (l_ga.item.ga_data) + l_j
									if (l_lp2.item.lp_slang).item.sl_rep.ga_len > 0 then
										if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_lp.item.lp_slang).item.sl_name), create {CE_INTEGER_8_POINTER}.make_cast ((l_lp2.item.lp_slang).item.sl_name), (2).to_natural_32)) = 0 then
											l_lp.item.lp_replang := l_lp2.item.lp_slang
											l_break := True
										end
									end
									if not (l_return or l_break or l_continue) then
										l_j := l_j + 1
									end
								end
								l_break := False
							end
							l_i___0 := l_i___0 + 1
						end
				when 18 then -- theend:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_spl_copy))
						recursive___5.item := 0
						Result := l_ret_msg
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_region (a_rp, a_region: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_rp.is_void
		local
			l_i___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if (a_rp[l_i___0]).to_integer_32 = 0 then
					Result := 255
					l_return := True
				end
				if not l_return then
					if (a_rp[l_i___0]).to_integer_32 = (a_region[0]).to_integer_32 then
						if (a_rp[(l_i___0 + 1)]).to_integer_32 = (a_region[1]).to_integer_32 then
							l_break := True
						end
					end
					if not (l_return or l_break) then
						l_i___0 := l_i___0 + (2)
					end
				end
			end
			if not l_return then
				l_break := False
				Result := (l_i___0 // 2)
			end
		end

	captype (a_word, a_end: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_c: INTEGER_32
			l_firstcap: INTEGER_32
			l_allcap: INTEGER_32
			l_past_second: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___6: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___15: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_past_second := 0
					l_p___0.item := a_word
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if (spell_iswordp_nmw (l_p___0.item)).to_boolean then
							l_break := True
						end
						if not (l_return or l_break) then
							if a_end.is_void then
								l_tmp___1 := ((l_p___0.item.item).to_integer_32 = 0).to_integer
							else
								l_tmp___1 := (((l_p___0.item).c_pointer.to_integer_32).to_natural_32 >= (a_end.c_pointer.to_integer_32).to_natural_32).to_integer
							end
							if l_tmp___1.to_boolean then
								Result := 0
								l_return := True
							end
							if not l_return then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0.item]))
								else
									l_tmp___0 := 1
								end
								l_p___0.item := l_p___0.item + l_tmp___0
							end
						end
					end
					if l_return then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						l_break := False
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_c := (create {P_MBYTE_STATIC}).mb_ptr2char_adv (l_p___0)
						else
							l_tmp___3 := l_p___0.item
							l_p___0.item := l_p___0.item + 1
							l_c := (l_tmp___3.item).to_integer_32
						end
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_c >= 128 then
							l_allcap := ((create {P_MBYTE_STATIC}).utf_isupper (l_c))
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_c < 256 then
							l_tmp___6 := (spelltab.item.item.st_isu[l_c]).to_integer_32
						else
							l_tmp___6 := (iswupper (l_c.to_natural_32))
						end
						l_allcap := l_tmp___6
				when 5 then
						l_firstcap := l_allcap
				when 6 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 16 -- skip loop
						end
				when 7 then -- loop body:
						l_break := False
						if a_end.is_void then
							l_tmp___15 := ((l_p___0.item.item).to_integer_32 /= 0).to_integer
						else
							l_tmp___15 := (((l_p___0.item).c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32).to_integer
						end
						if not l_tmp___15.to_boolean then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 15 -- skip if block
						end
				when 8 then -- if:
						if not ((spell_iswordp_nmw (l_p___0.item)).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_c := ((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0.item]))
						else
							l_c := (l_p___0.item.item).to_integer_32
						end
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_c >= 128 then
							l_tmp___13 := ((create {P_MBYTE_STATIC}).utf_isupper (l_c))
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						if l_c < 256 then
							l_tmp___12 := (spelltab.item.item.st_isu[l_c]).to_integer_32
						else
							l_tmp___12 := (iswupper (l_c.to_natural_32))
						end
						l_tmp___13 := l_tmp___12
				when 13 then
						if l_tmp___13.to_boolean then
							if not l_allcap.to_boolean then
								Result := 128
								l_return := True
							end
						else
							if l_past_second.to_boolean then
								if l_allcap.to_boolean then
									Result := 128
									l_return := True
								end
							end
							if not l_return then
								l_allcap := 0
							end
						end
						if not l_return then
							l_past_second := 1
						end
				when 14 then -- if done
						if not l_return then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___8 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0.item]))
							else
								l_tmp___8 := 1
							end
							l_p___0.item := l_p___0.item + l_tmp___8
						end
				when 15 then -- if done
						l_pos := -1 + 6 -- back to loop condition
				when 16 then -- loop done | if done
					if not l_return then
						l_break := False
						if l_allcap.to_boolean then
							Result := 4
							l_return := True
						end
					end
					if not l_return and then (l_firstcap.to_boolean) then
						Result := 2
						l_return := True
					end
					if not l_return then
						Result := 0
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	badword_captype (a_word, a_end: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_flags___0: INTEGER_32
			l_c: INTEGER_32
			l_l: INTEGER_32
			l_u: INTEGER_32
			l_first___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_flags___0 := (captype (a_word, a_end))
					if not (((l_flags___0).bit_and (128)).to_boolean) then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_u := 0
						l_l := l_u
						l_first___0 := 0
						l_p___0 := a_word
				when 2 then -- loop condition:
						if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 8 -- skip loop
						end
				when 3 then -- loop body:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_c := ((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0]))
						else
							l_c := (l_p___0.item).to_integer_32
						end
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_c >= 128 then
							l_tmp___6 := ((create {P_MBYTE_STATIC}).utf_isupper (l_c))
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if l_c < 256 then
							l_tmp___5 := (spelltab.item.item.st_isu[l_c]).to_integer_32
						else
							l_tmp___5 := (iswupper (l_c.to_natural_32))
						end
						l_tmp___6 := l_tmp___5
				when 7 then
						if l_tmp___6.to_boolean then
							l_u := l_u + 1
							if l_p___0.is_equal (a_word) then
								l_first___0 := 1
							end
						else
							l_l := l_l + 1
						end
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___1 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
						else
							l_tmp___1 := 1
						end
						l_p___0 := l_p___0 + l_tmp___1
						l_pos := -1 + 2 -- back to loop condition
				when 8 then -- loop done
						if not (l_u > l_l) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if l_u > 2 then
							l_flags___0 := (l_flags___0).bit_or ((4))
						else
							l_pos := -1 + 11 -- goto _L___0
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L___0:
						if l_first___0.to_boolean then
							l_flags___0 := (l_flags___0).bit_or ((2))
						end
				when 12 then
						if l_u >= 2 then
							if l_l >= 2 then
								l_flags___0 := (l_flags___0).bit_or ((32))
							end
						end
				when 13 then -- if done
					Result := l_flags___0
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_free_all
		local
			l_slang: CE_POINTER [PD_SLANG_S]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_fname: CE_ARRAY [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_fname.make (<<4_096>>)

			l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
			from
			until
				l_buf___6.is_void
			loop
				(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_s") + (create {PD_SYNBLOCK_T}.make).offset_of ("b_langp"))).item.ga_clear
				l_buf___6 := l_buf___6.item.b_next
			end
			from
			until
				first_lang.item.is_void
			loop
				l_slang := first_lang.item
				first_lang.item := l_slang.item.sl_next
				l_slang.item.slang_free
			end
			if not int_wordlist.item.is_void then
				unlink (create {CE_INTEGER_8_POINTER}.make_cast (int_wordlist.item)).do_nothing
				int_wordlist_spl (l_fname)
				unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_fname)).do_nothing;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (int_wordlist.item))
				int_wordlist.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			end
			init_spell_chartab;
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (repl_to.item))
			repl_to.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (repl_from.item))
			repl_from.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	spell_reload
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_break: BOOLEAN
		do
			init_spell_chartab
			spell_free_all
			l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
			from
			until
				not (not (l_break) and then (not l_wp___0.is_void))
			loop
				l_break := False
				if (((l_wp___0.item.w_s).item.b_p_spl).item).to_integer_32 /= 0 then
					if (l_wp___0.item.w_onebuf_opt.wo_spell).to_boolean then
						did_set_spelllang (l_wp___0).do_nothing
						l_break := True
					end
				end
				if not (l_break) then
					l_wp___0 := l_wp___0.item.w_next
				end
			end
			l_break := False
		end

	spell_reload_one (a_fname: CE_POINTER [NATURAL_8]; a_added_word: INTEGER_32)
		local
			l_slang: CE_POINTER [PD_SLANG_S]
			l_didit: INTEGER_32
		do
			l_didit := 0
			l_slang := first_lang.item
			from
			until
				l_slang.is_void
			loop
				if ((create {P_MISC1_STATIC}).fullpathcmp (a_fname, l_slang.item.sl_fname, 0)) = 1 then
					l_slang.item.slang_clear
					if (spell_load_file (a_fname, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_slang, 0)).is_void then
						l_slang.item.slang_clear
					end
					(create {P_SCREEN_STATIC}).redraw_all_later (35)
					l_didit := 1
				end
				l_slang := l_slang.item.sl_next
			end
			if a_added_word.to_boolean then
				if not l_didit.to_boolean then
					did_set_spelllang ((create {P_GLOBALS_STATIC}).curwin.item).do_nothing
				end
			end
		end

	spell_read_aff (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_fname: CE_POINTER [NATURAL_8]): CE_POINTER [PD_AFFFILE_S]
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_aff: CE_POINTER [PD_AFFFILE_S]
			l_rline: CE_ARRAY [NATURAL_8]
			l_line: CE_POINTER [NATURAL_8]
			l_pc: CE_POINTER [NATURAL_8]
			l_items: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_itemcnt: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_lnum: INTEGER_32
			l_cur_aff: CE_POINTER [PD_AFFHEADER_S]
			l_did_postpone_prefix: INTEGER_32
			l_aff_todo: INTEGER_32
			l_tp: CE_POINTER [PD_HASHTABLE_S]
			l_low: CE_POINTER [NATURAL_8]
			l_fol: CE_POINTER [NATURAL_8]
			l_upp: CE_POINTER [NATURAL_8]
			l_do_rep: INTEGER_32
			l_do_repsal: INTEGER_32
			l_do_sal: INTEGER_32
			l_do_mapline: INTEGER_32
			l_found_map: INTEGER_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_l: INTEGER_32
			l_compminlen: INTEGER_32
			l_compsylmax: INTEGER_32
			l_compoptions: INTEGER_32
			l_compmax: INTEGER_32
			l_compflags: CE_POINTER [NATURAL_8]
			l_midword: CE_POINTER [NATURAL_8]
			l_syllable: CE_POINTER [NATURAL_8]
			l_sofofrom: CE_POINTER [NATURAL_8]
			l_sofoto: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___14: NATURAL_32
			l_tmp___15: NATURAL_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_i___0: INTEGER_32
			l_tmp___34: INTEGER_32
			l_tmp___35: INTEGER_32
			l_lasti: INTEGER_32
			l_key: CE_ARRAY [NATURAL_8]
			l_tmp___41: CE_POINTER [INTEGER_8]
			l_aff_entry: CE_POINTER [PD_AFFENTRY_S]
			l_upper: INTEGER_32
			l_lasti___0: INTEGER_32
			l_tmp___47: CE_POINTER [INTEGER_8]
			l_tmp___51: CE_POINTER [NATURAL_8]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_c: INTEGER_32
			l_c_up: INTEGER_32
			l_tmp___58: INTEGER_32
			l_tmp___61: INTEGER_32
			l_buf___7: CE_ARRAY [NATURAL_8]
			l_tmp___63: INTEGER_32
			l_tmp___65: INTEGER_32
			l_idx: INTEGER_32
			l_pp: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_n: INTEGER_32
			l_tmp___68: INTEGER_32
			l_tmp___76: INTEGER_32
			l_tmp___78: INTEGER_32
			l_tmp___79: CE_POINTER [PD_GROWARRAY]
			l_tmp___80: INTEGER_32
			l_c___0: INTEGER_32
			l_tmp___83: CE_POINTER [INTEGER_8]
			l_tmp___87: CE_POINTER [NATURAL_8]
			l_i___1: INTEGER_32
			l_tmp___149: CE_POINTER [INTEGER_8]
			l_tmp___151: CE_POINTER [INTEGER_8]
			l_tmp___152: CE_POINTER [INTEGER_8]
			l_tmp___154: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_rline.make (<<500>>)
			create {CE_NATURAL_8_POINTER} l_line.make
			create {CE_POINTER_ARRAY [NATURAL_8]} l_items.make (<<30>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_key.make (<<17>>)
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<500>>)
			create {CE_NATURAL_8_ARRAY} l_buf___7.make (<<500>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pc := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_lnum := 0
					l_cur_aff := create {CE_CLASS_POINTER [PD_AFFHEADER_S]}.make_shared (default_pointer)
					l_did_postpone_prefix := 0
					l_aff_todo := 0
					l_low := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_fol := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_upp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_found_map := 0
					l_compminlen := 0
					l_compsylmax := 0
					l_compoptions := 0
					l_compmax := 0
					l_compflags := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_midword := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_syllable := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_sofofrom := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_sofoto := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (a_fname), ce_string ("r"))
					if l_fd.is_void then
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_notopen.item))))), a_fname).do_nothing
						Result := (create {CE_CLASS_POINTER [PD_AFFFILE_S]}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, (gettext (ce_string ("Reading affix file %%s ..."))), a_fname]).do_nothing
						a_spin.item.spell_message ((create {P_GLOBALS_STATIC}).IObuff.item)
						l_do_rep := (a_spin.item.si_rep.ga_len = 0).to_integer
						l_do_repsal := (a_spin.item.si_repsal.ga_len = 0).to_integer
						l_do_sal := (a_spin.item.si_sal.ga_len = 0).to_integer
						l_do_mapline := (a_spin.item.si_map.ga_len = 0).to_integer
						l_aff := create {CE_CLASS_POINTER [PD_AFFFILE_S]}.make_cast ((a_spin.item.getroom ((create {PD_AFFFILE_S}.make).structure_size.to_natural_32, 1)))
						if l_aff.is_void then
							fclose (l_fd).do_nothing
							Result := (create {CE_CLASS_POINTER [PD_AFFFILE_S]}.make_shared (default_pointer))
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 253 -- skip if block
					end
				when 1 then -- if:;
						(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (l_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_pref"))).item.hash_init;
						(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (l_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_suff"))).item.hash_init;
						(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (l_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_comp"))).item.hash_init
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 233 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						if ((create {P_FILEIO_STATIC}).vim_fgets (l_rline, 500, l_fd)).to_boolean then
							l_break := True
						elseif ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							(create {P_MISC1_STATIC}).line_breakcheck
							l_lnum := l_lnum + 1
							if (l_rline[0]).to_integer_32 = 35 then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pc))
							if a_spin.item.si_conv.vc_type /= 0 then
								l_pc := (create {P_MBYTE_STATIC}).string_convert (create {CE_CLASS_POINTER [PD_VIMCONV_T]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_conv")), l_rline, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
								if l_pc.is_void then
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Conversion failure for word in %%s line %%d: %%s")))), a_fname, l_lnum, l_rline]).do_nothing
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_line := l_pc
								end
							else
								l_pc := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								l_line := l_rline
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 232 -- skip if block
						end
				when 4 then -- if:
						l_itemcnt := 0
						l_p___0.item := l_line
				when 5 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 13 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0.item.item).to_integer_32 /= 0 then
								if not ((l_p___0.item.item).to_integer_32 <= 32) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_p___0.item := l_p___0.item + 1
							end
						end
						l_break := False
						if (l_p___0.item.item).to_integer_32 = 0 then
							l_break := True
						end
						if not (l_return or l_break) and then (l_itemcnt = 30) then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						l_tmp___3 := l_itemcnt
						l_itemcnt := l_itemcnt + 1
						l_items[l_tmp___3] := l_p___0.item
						if l_itemcnt /= 2 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if (spell_info_item (l_items[0])).to_boolean then
							from
							until
								(l_break)
							loop
								l_break := False
								if not ((l_p___0.item.item).to_integer_32 >= 32) then
									if (l_p___0.item.item).to_integer_32 /= 9 then
										l_break := True
									end
								end
								if not (l_break) then
									l_p___0.item := l_p___0.item + 1
								end
							end
							l_break := False
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						from
						until
							not ((l_p___0.item.item).to_integer_32 > 32)
						loop
							l_p___0.item := l_p___0.item + 1
						end
				when 11 then
						if (l_p___0.item.item).to_integer_32 = 0 then
							l_break := True
						end
				when 12 then -- if done
						if not (l_return or l_break) then
							l_tmp___5 := l_p___0.item
							l_p___0.item := l_p___0.item + 1
							l_tmp___5.item := (('%/0/').code).to_natural_8
						end
						l_pos := -1 + 5 -- back to loop condition
				when 13 then -- loop done
						l_break := False
						if not (l_itemcnt > 0) then
							l_pos := -1 + 232 -- skip if block
						end
				when 14 then -- if:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("SET"), 2)).to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if (l_aff.item.af_enc).is_void then
							l_aff.item.af_enc := (create {P_MBYTE_STATIC}).enc_canonize (l_items[1])
							if not (l_aff.item.af_enc).is_void then
								if not (a_spin.item.si_ascii).to_boolean then
									if ((create {CE_CLASS_POINTER [PD_VIMCONV_T]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_conv"))).item.convert_setup (l_aff.item.af_enc, (create {P_OPTION_STATIC}).p_enc.item.item)) = 0 then
										(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Conversion in %%s not supported: from %%s to %%s")))), a_fname, l_aff.item.af_enc, (create {P_OPTION_STATIC}).p_enc.item.item]).do_nothing
									end
								end
							end
							a_spin.item.si_conv.vc_fail := 1
						else
							l_pos := -1 + 17 -- goto _L___42
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 17 then -- else: | _L___42:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("FLAG"), 2)).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if l_aff.item.af_flagtype = 0 then
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[1]), ce_string ("long"))) = 0 then
								l_aff.item.af_flagtype := 1
							elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[1]), ce_string ("num"))) = 0 then
								l_aff.item.af_flagtype := 3
							elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[1]), ce_string ("caplong"))) = 0 then
								l_aff.item.af_flagtype := 2
							else
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Invalid value for FLAG in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[1]]).do_nothing
							end
							if l_aff.item.af_rare /= {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_keepcase /= {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_bad /= {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_needaffix /= {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_circumfix /= {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_needcomp /= {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_comproot /= {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_nosuggest /= {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif not l_compflags.is_void then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_suff.ht_used > {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_aff.item.af_pref.ht_used > {NATURAL_32} 0 then
								l_tmp___12 := gettext (ce_string ("FLAG after using flags in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___12), a_fname, l_lnum, l_items[1]]).do_nothing
							end
						else
							l_pos := -1 + 20 -- goto _L___41
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 20 then -- else: | _L___41:
						if not ((spell_info_item (l_items[0])).to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if (a_spin.item.si_info).is_void then
							l_tmp___14 := (0).to_natural_32
						else
							l_tmp___14 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_spin.item.si_info)))
						end
						l_tmp___15 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_items[0]))
						l_p___0.item := create {CE_NATURAL_8_POINTER}.make_cast ((a_spin.item.getroom (((l_tmp___14 + l_tmp___15) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_items[1])))) + {NATURAL_32} 3, 0)))
						if not (l_p___0.item).is_void then
							if not (a_spin.item.si_info).is_void then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), create {CE_INTEGER_8_POINTER}.make_cast (a_spin.item.si_info)).do_nothing
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), ce_string ("%N")).do_nothing
							end
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), create {CE_INTEGER_8_POINTER}.make_cast (l_items[0])).do_nothing
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), ce_string (" ")).do_nothing
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), create {CE_INTEGER_8_POINTER}.make_cast (l_items[1])).do_nothing
							a_spin.item.si_info := l_p___0.item
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 23 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("MIDWORD"), 2)).to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						if l_midword.is_void then
							l_midword := a_spin.item.getroom_save (l_items[1])
						else
							l_pos := -1 + 26 -- goto _L___40
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 26 then -- else: | _L___40:
						if (is_aff_rule (l_items, l_itemcnt, ce_string ("TRY"), 2)).to_boolean then
							l_pos := -1 + 232 -- skip if block
						end
				when 27 then -- if:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("RAR"), 2)).to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 31 -- goto _L___39
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 30 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("RARE"), 2)).to_boolean) then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if: | _L___39:
						if l_aff.item.af_rare = {NATURAL_32} 0 then
							l_aff.item.af_rare := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
						else
							l_pos := -1 + 33 -- goto _L___38
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 33 then -- else: | _L___38:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("KEP"), 2)).to_boolean) then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_pos := -1 + 37 -- goto _L___37
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 36 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("KEEPCASE"), 2)).to_boolean) then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if: | _L___37:
						if l_aff.item.af_keepcase = {NATURAL_32} 0 then
							l_aff.item.af_keepcase := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
						else
							l_pos := -1 + 39 -- goto _L___36
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 39 then -- else: | _L___36:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("BAD"), 2)).to_boolean) then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						l_pos := -1 + 43 -- goto _L___35
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 42 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("FORBIDDENWORD"), 2)).to_boolean) then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if: | _L___35:
						if l_aff.item.af_bad = {NATURAL_32} 0 then
							l_aff.item.af_bad := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
						else
							l_pos := -1 + 45 -- goto _L___34
						end
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 45 then -- else: | _L___34:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("NEEDAFFIX"), 2)).to_boolean) then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						if l_aff.item.af_needaffix = {NATURAL_32} 0 then
							l_aff.item.af_needaffix := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
						else
							l_pos := -1 + 48 -- goto _L___33
						end
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 48 then -- else: | _L___33:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("CIRCUMFIX"), 2)).to_boolean) then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						if l_aff.item.af_circumfix = {NATURAL_32} 0 then
							l_aff.item.af_circumfix := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
						else
							l_pos := -1 + 51 -- goto _L___32
						end
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 51 then -- else: | _L___32:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("NOSUGGEST"), 2)).to_boolean) then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
						if l_aff.item.af_nosuggest = {NATURAL_32} 0 then
							l_aff.item.af_nosuggest := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
						else
							l_pos := -1 + 54 -- goto _L___31
						end
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 54 then -- else: | _L___31:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("NEEDCOMPOUND"), 2)).to_boolean) then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						l_pos := -1 + 58 -- goto _L___30
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 57 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("ONLYINCOMPOUND"), 2)).to_boolean) then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if: | _L___30:
						if l_aff.item.af_needcomp = {NATURAL_32} 0 then
							l_aff.item.af_needcomp := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
						else
							l_pos := -1 + 60 -- goto _L___29
						end
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 60 then -- else: | _L___29:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDROOT"), 2)).to_boolean) then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						if l_aff.item.af_comproot = {NATURAL_32} 0 then
							l_aff.item.af_comproot := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
						else
							l_pos := -1 + 63 -- goto _L___28
						end
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 63 then -- else: | _L___28:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDFORBIDFLAG"), 2)).to_boolean) then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						if l_aff.item.af_compforbid = {NATURAL_32} 0 then
							l_aff.item.af_compforbid := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
							if l_aff.item.af_pref.ht_used > {NATURAL_32} 0 then
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Defining COMPOUNDFORBIDFLAG after PFX item may give wrong results in %%s line %%d")))), a_fname, l_lnum]).do_nothing
							end
						else
							l_pos := -1 + 66 -- goto _L___27
						end
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 66 then -- else: | _L___27:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDPERMITFLAG"), 2)).to_boolean) then
							l_pos := -1 + 69 -- skip if block
						end
				when 67 then -- if:
						if l_aff.item.af_comppermit = {NATURAL_32} 0 then
							l_aff.item.af_comppermit := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
							if l_aff.item.af_pref.ht_used > {NATURAL_32} 0 then
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Defining COMPOUNDPERMITFLAG after PFX item may give wrong results in %%s line %%d")))), a_fname, l_lnum]).do_nothing
							end
						else
							l_pos := -1 + 69 -- goto _L___26
						end
				when 68 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 69 then -- else: | _L___26:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDFLAG"), 2)).to_boolean) then
							l_pos := -1 + 72 -- skip if block
						end
				when 70 then -- if:
						if l_compflags.is_void then
							l_p___0.item := create {CE_NATURAL_8_POINTER}.make_cast ((a_spin.item.getroom ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_items[1]))) + {NATURAL_32} 2, 0)))
							if not (l_p___0.item).is_void then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), create {CE_INTEGER_8_POINTER}.make_cast (l_items[1])).do_nothing
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), ce_string ("+")).do_nothing
								l_compflags := l_p___0.item
							end
						else
							l_pos := -1 + 72 -- goto _L___25
						end
				when 71 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 72 then -- else: | _L___25:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDRULES"), 2)).to_boolean) then
							l_pos := -1 + 75 -- skip if block
						end
				when 73 then -- if:
						if (atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_items[1]))) = 0 then
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Wrong COMPOUNDRULES value in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[1]]).do_nothing
						end
				when 74 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 75 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDRULE"), 2)).to_boolean) then
							l_pos := -1 + 78 -- skip if block
						end
				when 76 then -- if:
						l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_items[1]))).to_integer_32 + 1
						if not l_compflags.is_void then
							l_l := l_l + ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_compflags))).to_integer_32 + 1)
						end
						l_p___0.item := create {CE_NATURAL_8_POINTER}.make_cast ((a_spin.item.getroom (l_l.to_natural_32, 0)))
						if not (l_p___0.item).is_void then
							if not l_compflags.is_void then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), create {CE_INTEGER_8_POINTER}.make_cast (l_compflags)).do_nothing
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), ce_string ("/")).do_nothing
							end
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), create {CE_INTEGER_8_POINTER}.make_cast (l_items[1])).do_nothing
							l_compflags := l_p___0.item
						end
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 78 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDWORDMAX"), 2)).to_boolean) then
							l_pos := -1 + 81 -- skip if block
						end
				when 79 then -- if:
						if l_compmax = 0 then
							l_compmax := atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_items[1]))
							if l_compmax = 0 then
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Wrong COMPOUNDWORDMAX value in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[1]]).do_nothing
							end
						else
							l_pos := -1 + 81 -- goto _L___24
						end
				when 80 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 81 then -- else: | _L___24:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDMIN"), 2)).to_boolean) then
							l_pos := -1 + 84 -- skip if block
						end
				when 82 then -- if:
						if l_compminlen = 0 then
							l_compminlen := atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_items[1]))
							if l_compminlen = 0 then
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Wrong COMPOUNDMIN value in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[1]]).do_nothing
							end
						else
							l_pos := -1 + 84 -- goto _L___23
						end
				when 83 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 84 then -- else: | _L___23:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("COMPOUNDSYLMAX"), 2)).to_boolean) then
							l_pos := -1 + 87 -- skip if block
						end
				when 85 then -- if:
						if l_compsylmax = 0 then
							l_compsylmax := atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_items[1]))
							if l_compsylmax = 0 then
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Wrong COMPOUNDSYLMAX value in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[1]]).do_nothing
							end
						else
							l_pos := -1 + 87 -- goto _L___22
						end
				when 86 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 87 then -- else: | _L___22:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("CHECKCOMPOUNDDUP"), 1)).to_boolean) then
							l_pos := -1 + 90 -- skip if block
						end
				when 88 then -- if:
						l_compoptions := (l_compoptions).bit_or ((1))
				when 89 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 90 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("CHECKCOMPOUNDREP"), 1)).to_boolean) then
							l_pos := -1 + 93 -- skip if block
						end
				when 91 then -- if:
						l_compoptions := (l_compoptions).bit_or ((2))
				when 92 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 93 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("CHECKCOMPOUNDCASE"), 1)).to_boolean) then
							l_pos := -1 + 96 -- skip if block
						end
				when 94 then -- if:
						l_compoptions := (l_compoptions).bit_or ((4))
				when 95 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 96 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("CHECKCOMPOUNDTRIPLE"), 1)).to_boolean) then
							l_pos := -1 + 99 -- skip if block
						end
				when 97 then -- if:
						l_compoptions := (l_compoptions).bit_or ((8))
				when 98 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 99 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("CHECKCOMPOUNDPATTERN"), 2)).to_boolean) then
							l_pos := -1 + 102 -- skip if block
						end
				when 100 then -- if:
						if (atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_items[1]))) = 0 then
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Wrong CHECKCOMPOUNDPATTERN value in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[1]]).do_nothing
						end
				when 101 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 102 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("CHECKCOMPOUNDPATTERN"), 3)).to_boolean) then
							l_pos := -1 + 105 -- skip if block
						end
				when 103 then -- if:
						l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_comppat"))
						l_i___0 := 0
						from
						until
							not (not (l_break) and then (l_i___0 < l_gap.item.ga_len - 1))
						loop
							l_break := False
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_gap.item.ga_data)[l_i___0]), create {CE_INTEGER_8_POINTER}.make_cast (l_items[1]))) = 0 then
								if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_gap.item.ga_data)[(l_i___0 + 1)]), create {CE_INTEGER_8_POINTER}.make_cast (l_items[2]))) = 0 then
									l_break := True
								end
							end
							if not (l_return or l_break) then
								l_i___0 := l_i___0 + (2)
							end
						end
						l_break := False
						if l_i___0 >= l_gap.item.ga_len then
							if (l_gap.item.ga_grow (2)) = 1 then
								l_tmp___34 := l_gap.item.ga_len
								l_gap.item.ga_len := (l_gap.item.ga_len) + 1
								create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_gap.item.ga_data)[l_tmp___34] := a_spin.item.getroom_save (l_items[1])
								l_tmp___35 := l_gap.item.ga_len
								l_gap.item.ga_len := (l_gap.item.ga_len) + 1
								create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_gap.item.ga_data)[l_tmp___35] := a_spin.item.getroom_save (l_items[2])
							end
						end
				when 104 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 105 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("SYLLABLE"), 2)).to_boolean) then
							l_pos := -1 + 108 -- skip if block
						end
				when 106 then -- if:
						if l_syllable.is_void then
							l_syllable := a_spin.item.getroom_save (l_items[1])
						else
							l_pos := -1 + 108 -- goto _L___21
						end
				when 107 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 108 then -- else: | _L___21:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("NOBREAK"), 1)).to_boolean) then
							l_pos := -1 + 111 -- skip if block
						end
				when 109 then -- if:
						a_spin.item.si_nobreak := (1).to_natural_8
				when 110 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 111 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("NOSPLITSUGS"), 1)).to_boolean) then
							l_pos := -1 + 114 -- skip if block
						end
				when 112 then -- if:
						a_spin.item.si_nosplitsugs := 1
				when 113 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 114 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("NOSUGFILE"), 1)).to_boolean) then
							l_pos := -1 + 117 -- skip if block
						end
				when 115 then -- if:
						a_spin.item.si_nosugfile := 1
				when 116 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 117 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("PFXPOSTPONE"), 1)).to_boolean) then
							l_pos := -1 + 120 -- skip if block
						end
				when 118 then -- if:
						l_aff.item.af_pfxpostpone := 1
				when 119 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 120 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[0]), ce_string ("PFX"))) /= 0 then
							l_pos := -1 + 123 -- skip if block
						end
				when 121 then -- if:
						l_pos := -1 + 124 -- goto _L___20
				when 122 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 123 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[0]), ce_string ("SFX"))) /= 0 then
							l_pos := -1 + 139 -- skip if block
						end
				when 124 then -- if: | _L___20:
						if l_aff_todo /= 0 then
							l_pos := -1 + 137 -- skip if block
						end
				when 125 then -- if:
						if not (l_itemcnt >= 4) then
							l_pos := -1 + 135 -- skip if block
						end
				when 126 then -- if:
						l_lasti := 4
						if ((l_items[0]).item).to_integer_32 = 80 then
							l_tp := create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (l_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_pref"))
						else
							l_tp := create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (l_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_suff"))
						end
						(create {P_MISC2_STATIC}).vim_strncpy (l_key, l_items[1], (16).to_natural_32)
						l_hi___1 := l_tp.item.hash_find (l_key)
						if not ((l_hi___1.item.hi_key).is_void) then
							l_pos := -1 + 129 -- skip if block
						end
				when 127 then -- if:
						l_pos := -1 + 130 -- goto _L___0
				when 128 then -- if block done, skip else block:
						l_pos := -1 + 133
				when 129 then -- else:
						if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
							l_pos := -1 + 132 -- skip if block
						end
				when 130 then -- if: | _L___0:
						l_cur_aff := create {CE_CLASS_POINTER [PD_AFFHEADER_S]}.make_cast ((a_spin.item.getroom ((create {PD_AFFHEADER_S}.make).structure_size.to_natural_32, 1)))
						if l_cur_aff.is_void then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_cur_aff.item.ah_flag := affitem2flag (l_aff.item.af_flagtype, l_items[1], a_fname, l_lnum)
							if l_cur_aff.item.ah_flag = {NATURAL_32} 0 then
								l_break := True
							elseif (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_items[1]))) >= {NATURAL_32} 17 then
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if l_cur_aff.item.ah_flag = l_aff.item.af_bad then
								l_tmp___41 := gettext (ce_string ("Affix also used for BAD/RARE/KEEPCASE/NEEDAFFIX/NEEDCOMPOUND/NOSUGGEST in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___41), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_cur_aff.item.ah_flag = l_aff.item.af_rare then
								l_tmp___41 := gettext (ce_string ("Affix also used for BAD/RARE/KEEPCASE/NEEDAFFIX/NEEDCOMPOUND/NOSUGGEST in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___41), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_cur_aff.item.ah_flag = l_aff.item.af_keepcase then
								l_tmp___41 := gettext (ce_string ("Affix also used for BAD/RARE/KEEPCASE/NEEDAFFIX/NEEDCOMPOUND/NOSUGGEST in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___41), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_cur_aff.item.ah_flag = l_aff.item.af_needaffix then
								l_tmp___41 := gettext (ce_string ("Affix also used for BAD/RARE/KEEPCASE/NEEDAFFIX/NEEDCOMPOUND/NOSUGGEST in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___41), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_cur_aff.item.ah_flag = l_aff.item.af_circumfix then
								l_tmp___41 := gettext (ce_string ("Affix also used for BAD/RARE/KEEPCASE/NEEDAFFIX/NEEDCOMPOUND/NOSUGGEST in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___41), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_cur_aff.item.ah_flag = l_aff.item.af_nosuggest then
								l_tmp___41 := gettext (ce_string ("Affix also used for BAD/RARE/KEEPCASE/NEEDAFFIX/NEEDCOMPOUND/NOSUGGEST in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___41), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_cur_aff.item.ah_flag = l_aff.item.af_needcomp then
								l_tmp___41 := gettext (ce_string ("Affix also used for BAD/RARE/KEEPCASE/NEEDAFFIX/NEEDCOMPOUND/NOSUGGEST in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___41), a_fname, l_lnum, l_items[1]]).do_nothing
							elseif l_cur_aff.item.ah_flag = l_aff.item.af_comproot then
								l_tmp___41 := gettext (ce_string ("Affix also used for BAD/RARE/KEEPCASE/NEEDAFFIX/NEEDCOMPOUND/NOSUGGEST in %%s line %%d: %%s"));
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___41), a_fname, l_lnum, l_items[1]]).do_nothing
							end
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_cur_aff.item.ah_key)), create {CE_INTEGER_8_POINTER}.make_cast (l_items[1])).do_nothing
							l_tp.item.hash_add (l_cur_aff.item.ah_key).do_nothing
							l_cur_aff.item.ah_combine := (((l_items[2]).item).to_integer_32 = 89).to_integer
						end
				when 131 then -- if block done, skip else block:
						l_pos := -1 + 133
				when 132 then -- else:
						l_cur_aff := create {CE_CLASS_POINTER [PD_AFFHEADER_S]}.make_cast (l_hi___1.item.hi_key)
						if (l_cur_aff.item.ah_combine).to_boolean /= (((l_items[2]).item).to_integer_32 = 89) then
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Different combining flag in continued affix block in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[1]]).do_nothing
						end
						if not (l_cur_aff.item.ah_follows).to_boolean then
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Duplicate affix in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[1]]).do_nothing
						end
				when 133 then -- if done
						if not (l_return or l_break or l_continue) then
							if l_itemcnt > l_lasti then
								if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[l_lasti]), ce_string ("S"))) = 0 then
									l_lasti := l_lasti + 1
									l_cur_aff.item.ah_follows := 1
								else
									l_cur_aff.item.ah_follows := 0
								end
							else
								l_cur_aff.item.ah_follows := 0
							end
							if l_itemcnt > l_lasti then
								if ((l_items[l_lasti]).item).to_integer_32 /= 35 then
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (e_afftrailing.item))), a_fname, l_lnum, l_items[l_lasti]]).do_nothing
								end
							end
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[2]), ce_string ("Y"))) /= 0 then
								if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[2]), ce_string ("N"))) /= 0 then
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Expected Y or N in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[2]]).do_nothing
								end
							end
							if ((l_items[0]).item).to_integer_32 = 80 then
								if (l_aff.item.af_pfxpostpone).to_boolean then
									if l_cur_aff.item.ah_newID = 0 then
										a_spin.item.check_renumber
										a_spin.item.si_newprefID := (a_spin.item.si_newprefID) + 1
										l_cur_aff.item.ah_newID := a_spin.item.si_newprefID
										l_did_postpone_prefix := 0
									else
										l_did_postpone_prefix := 1
									end
								end
							end
							l_aff_todo := atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_items[3]))
						end
				when 134 then -- if block done, skip else block:
						l_pos := -1 + 136
				when 135 then -- else:
						l_pos := -1 + 139 -- goto _L___19
				when 136 then -- if done | if block done, skip else block:
						l_pos := -1 + 138
				when 137 then -- else:
						l_pos := -1 + 139 -- goto _L___19
				when 138 then -- if done | if block done, skip else block:
						l_pos := -1 + 232
				when 139 then -- else: | _L___19:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[0]), ce_string ("PFX"))) /= 0 then
							l_pos := -1 + 142 -- skip if block
						end
				when 140 then -- if:
						l_pos := -1 + 143 -- goto _L___17
				when 141 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 142 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[0]), ce_string ("SFX"))) /= 0 then
							l_pos := -1 + 176 -- skip if block
						end
				when 143 then -- if: | _L___17:
						if not (l_aff_todo > 0) then
							l_pos := -1 + 174 -- skip if block
						end
				when 144 then -- if:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_cur_aff.item.ah_key)), create {CE_INTEGER_8_POINTER}.make_cast (l_items[1]))) /= 0 then
							l_pos := -1 + 172 -- skip if block
						end
				when 145 then -- if:
						if not (l_itemcnt >= 5) then
							l_pos := -1 + 170 -- skip if block
						end
				when 146 then -- if:
						l_upper := 0
						l_lasti___0 := 5
						if l_itemcnt > l_lasti___0 then
							if ((l_items[l_lasti___0]).item).to_integer_32 /= 35 then
								if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[l_lasti___0]), ce_string ("-"))) /= 0 then
									l_tmp___47 := gettext (e_afftrailing.item);
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___47), a_fname, l_lnum, l_items[l_lasti___0]]).do_nothing
								elseif l_itemcnt /= l_lasti___0 + 1 then
									l_tmp___47 := gettext (e_afftrailing.item);
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___47), a_fname, l_lnum, l_items[l_lasti___0]]).do_nothing
								end
							end
						end
						l_aff_todo := l_aff_todo - 1
						l_aff_entry := create {CE_CLASS_POINTER [PD_AFFENTRY_S]}.make_cast ((a_spin.item.getroom ((create {PD_AFFENTRY_S}.make).structure_size.to_natural_32, 1)))
						if l_aff_entry.is_void then
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 169 -- skip if block
						end
				when 147 then -- if:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[2]), ce_string ("0"))) /= 0 then
							l_aff_entry.item.ae_chop := a_spin.item.getroom_save (l_items[2])
						end
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[3]), ce_string ("0"))) /= 0 then
							l_aff_entry.item.ae_add := a_spin.item.getroom_save (l_items[3])
							l_aff_entry.item.ae_flags := (create {P_MISC2_STATIC}).vim_strchr (l_aff_entry.item.ae_add, ('/').code)
							if not (l_aff_entry.item.ae_flags).is_void then
								l_tmp___51 := l_aff_entry.item.ae_flags
								l_aff_entry.item.ae_flags := (l_aff_entry.item.ae_flags) + 1
								l_tmp___51.item := (('%/0/').code).to_natural_8
								aff_process_flags (l_aff, l_aff_entry)
							end
						end
						if (a_spin.item.si_ascii).to_boolean then
							l_pos := -1 + 150 -- skip if block
						end
				when 148 then -- if:
						l_pos := -1 + 152 -- goto _L___3
				when 149 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 150 then -- else:
						if (has_non_ascii (l_aff_entry.item.ae_chop)).to_boolean then
							l_pos := -1 + 169 -- skip if block
						end
				when 151 then -- if:
						if (has_non_ascii (l_aff_entry.item.ae_add)).to_boolean then
							l_pos := -1 + 169 -- skip if block
						end
				when 152 then -- if: | _L___3:
						l_aff_entry.item.ae_next := l_cur_aff.item.ah_first
						l_cur_aff.item.ah_first := l_aff_entry
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[4]), ce_string ("."))) /= 0 then
							l_aff_entry.item.ae_cond := a_spin.item.getroom_save (l_items[4])
							if ((l_items[0]).item).to_integer_32 = 80 then
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("^%%s"), l_items[4]]).do_nothing
							else
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("%%s$"), l_items[4]]).do_nothing
							end
							l_aff_entry.item.ae_prog := (create {P_REGEXP_STATIC}).vim_regcomp (l_buf___6, 7)
							if (l_aff_entry.item.ae_prog).is_void then
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Broken condition in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[4]]).do_nothing
							end
						end
						if ((l_items[0]).item).to_integer_32 /= 80 then
							l_pos := -1 + 169 -- skip if block
						end
				when 153 then -- if:
						if not ((l_aff.item.af_pfxpostpone).to_boolean) then
							l_pos := -1 + 169 -- skip if block
						end
				when 154 then -- if:
						if not ((l_aff_entry.item.ae_flags).is_void) then
							l_pos := -1 + 169 -- skip if block
						end
				when 155 then -- if:
						if (l_aff_entry.item.ae_chop).is_void then
							l_pos := -1 + 168 -- skip if block
						end
				when 156 then -- if:
						if (l_aff_entry.item.ae_add).is_void then
							l_pos := -1 + 168 -- skip if block
						end
				when 157 then -- if:
						if (l_aff_entry.item.ae_chop[((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_aff_entry.item.ae_chop]))]).to_integer_32 /= 0 then
							l_pos := -1 + 168 -- skip if block
						end
				when 158 then -- if:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_c := ((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_aff_entry.item.ae_chop]))
						else
							l_c := ((l_aff_entry.item.ae_chop).item).to_integer_32
						end
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 161 -- skip if block
						end
				when 159 then -- if:
						if l_c >= 128 then
							l_c_up := ((create {P_MBYTE_STATIC}).utf_toupper (l_c))
						else
							l_pos := -1 + 161 -- goto _L___1
						end
				when 160 then -- if block done, skip else block:
						l_pos := -1 + 162
				when 161 then -- else: | _L___1:
						if l_c < 256 then
							l_tmp___58 := (spelltab.item.item.st_upper[l_c]).to_integer_32
						else
							l_tmp___58 := (towupper (l_c.to_natural_32)).to_integer_32
						end
						l_c_up := l_tmp___58
				when 162 then
						if l_c_up = l_c then
							l_pos := -1 + 168 -- skip if block
						end
				when 163 then -- if:
						if not ((l_aff_entry.item.ae_cond).is_void) then
							l_pos := -1 + 166 -- skip if block
						end
				when 164 then -- if:
						l_pos := -1 + 167 -- goto _L___2
				when 165 then -- if block done, skip else block:
						l_pos := -1 + 168
				when 166 then -- else:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___65 := ((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_aff_entry.item.ae_cond]))
						else
							l_tmp___65 := ((l_aff_entry.item.ae_cond).item).to_integer_32
						end
						if l_tmp___65 /= l_c then
							l_pos := -1 + 168 -- skip if block
						end
				when 167 then -- if: | _L___2:
						l_p___0.item := l_aff_entry.item.ae_add + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_aff_entry.item.ae_add))).to_integer_32
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___61 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_aff_entry.item.ae_add, l_p___0.item - 1])) + 1
						else
							l_tmp___61 := 1
						end
						l_p___0.item := l_p___0.item - l_tmp___61
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___63 := ((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0.item]))
						else
							l_tmp___63 := (l_p___0.item.item).to_integer_32
						end
						if l_tmp___63 = l_c_up then
							l_upper := 1
							l_aff_entry.item.ae_chop := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							l_p___0.item.item := (('%/0/').code).to_natural_8
							if not (l_aff_entry.item.ae_cond).is_void then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									onecap_copy (l_items[4], l_buf___7, 1)
									l_aff_entry.item.ae_cond := a_spin.item.getroom_save (l_buf___7)
								else
									(l_aff_entry.item.ae_cond).item := l_c_up.to_natural_8
								end
								if not (l_aff_entry.item.ae_cond).is_void then
									sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___7), ce_string ("^%%s"), l_aff_entry.item.ae_cond]).do_nothing;
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_aff_entry.item.ae_prog))
									l_aff_entry.item.ae_prog := (create {P_REGEXP_STATIC}).vim_regcomp (l_buf___7, 3)
								end
							end
						end
				when 168 then -- if done | if done | if done | if done | if done
						if (l_aff_entry.item.ae_chop).is_void then
							if (l_aff_entry.item.ae_flags).is_void then
								l_idx := a_spin.item.si_prefcond.ga_len - 1
								from
								until
									not (not (l_break) and then (l_idx >= 0))
								loop
									l_break := False
									l_p___0.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (a_spin.item.si_prefcond.ga_data)[l_idx]
									if (str_equal (l_p___0.item, l_aff_entry.item.ae_cond)).to_boolean then
										l_break := True
									end
									if not (l_return or l_break) then
										l_idx := l_idx - 1
									end
								end
								l_break := False
								if l_idx < 0 then
									if ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_prefcond"))).item.ga_grow (1)) = 1 then
										l_tmp___68 := a_spin.item.si_prefcond.ga_len
										a_spin.item.si_prefcond.ga_len := (a_spin.item.si_prefcond.ga_len) + 1
										l_idx := l_tmp___68
										l_pp := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (a_spin.item.si_prefcond.ga_data) + l_idx
										if (l_aff_entry.item.ae_cond).is_void then
											l_pp.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
										else
											l_pp.item := a_spin.item.getroom_save (l_aff_entry.item.ae_cond)
										end
									end
								end
								if (l_aff_entry.item.ae_add).is_void then
									l_p___0.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
								else
									l_p___0.item := l_aff_entry.item.ae_add
								end
								l_n := -256
								if not (l_cur_aff.item.ah_combine).to_boolean then
									l_n := (l_n).bit_or ((2))
								end
								if l_upper.to_boolean then
									l_n := (l_n).bit_or ((4))
								end
								if (l_aff_entry.item.ae_comppermit).to_boolean then
									l_n := (l_n).bit_or ((8))
								end
								if (l_aff_entry.item.ae_compforbid).to_boolean then
									l_n := (l_n).bit_or ((16))
								end
								a_spin.item.tree_add_word (l_p___0.item, a_spin.item.si_prefroot, l_n, l_idx, l_cur_aff.item.ah_newID).do_nothing
								l_did_postpone_prefix := 1
							end
						end
						if l_aff_todo = 0 then
							if not l_did_postpone_prefix.to_boolean then
								a_spin.item.si_newprefID := (a_spin.item.si_newprefID) - 1
								l_cur_aff.item.ah_newID := 0
							end
						end
				when 169 then -- if done | if done | if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 171
				when 170 then -- else:
						l_pos := -1 + 176 -- goto _L___16
				when 171 then -- if done | if block done, skip else block:
						l_pos := -1 + 173
				when 172 then -- else:
						l_pos := -1 + 176 -- goto _L___16
				when 173 then -- if done | if block done, skip else block:
						l_pos := -1 + 175
				when 174 then -- else:
						l_pos := -1 + 176 -- goto _L___16
				when 175 then -- if done | if block done, skip else block:
						l_pos := -1 + 232
				when 176 then -- else: | _L___16:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("FOL"), 2)).to_boolean) then
							l_pos := -1 + 179 -- skip if block
						end
				when 177 then -- if:
						if l_fol.is_void then
							l_fol := (create {P_MISC2_STATIC}).vim_strsave (l_items[1])
						else
							l_pos := -1 + 179 -- goto _L___13
						end
				when 178 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 179 then -- else: | _L___13:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("LOW"), 2)).to_boolean) then
							l_pos := -1 + 182 -- skip if block
						end
				when 180 then -- if:
						if l_low.is_void then
							l_low := (create {P_MISC2_STATIC}).vim_strsave (l_items[1])
						else
							l_pos := -1 + 182 -- goto _L___12
						end
				when 181 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 182 then -- else: | _L___12:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("UPP"), 2)).to_boolean) then
							l_pos := -1 + 185 -- skip if block
						end
				when 183 then -- if:
						if l_upp.is_void then
							l_upp := (create {P_MISC2_STATIC}).vim_strsave (l_items[1])
						else
							l_pos := -1 + 185 -- goto _L___11
						end
				when 184 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 185 then -- else: | _L___11:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("REP"), 2)).to_boolean) then
							l_pos := -1 + 188 -- skip if block
						end
				when 186 then -- if:
						l_pos := -1 + 189 -- goto _L___10
				when 187 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 188 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("REPSAL"), 2)).to_boolean) then
							l_pos := -1 + 191 -- skip if block
						end
				when 189 then -- if: | _L___10:
						if not ((((ctype_b_loc).item[((l_items[1]).item).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Expected REP(SAL) count in %%s line %%d")))), a_fname, l_lnum]).do_nothing
						end
				when 190 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 191 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[0]), ce_string ("REP"))) /= 0 then
							l_pos := -1 + 194 -- skip if block
						end
				when 192 then -- if:
						l_pos := -1 + 195 -- goto _L___9
				when 193 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 194 then -- else:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[0]), ce_string ("REPSAL"))) /= 0 then
							l_pos := -1 + 197 -- skip if block
						end
				when 195 then -- if: | _L___9:
						if l_itemcnt >= 3 then
							if l_itemcnt > 3 then
								if ((l_items[3])[0]).to_integer_32 /= 35 then
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (e_afftrailing.item))), a_fname, l_lnum, l_items[3]]).do_nothing
								end
							end
							if ((l_items[0])[3]).to_integer_32 = 83 then
								l_tmp___80 := l_do_repsal
							else
								l_tmp___80 := l_do_rep
							end
							if l_tmp___80.to_boolean then
								l_p___0.item := l_items[1]
								from
								until
									(l_p___0.item.item).to_integer_32 = 0
								loop
									if (l_p___0.item.item).to_integer_32 = 95 then
										l_p___0.item.item := ((' ').code).to_natural_8
									end
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_tmp___76 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0.item]))
									else
										l_tmp___76 := 1
									end
									l_p___0.item := l_p___0.item + l_tmp___76
								end
								l_p___0.item := l_items[2]
								from
								until
									(l_p___0.item.item).to_integer_32 = 0
								loop
									if (l_p___0.item.item).to_integer_32 = 95 then
										l_p___0.item.item := ((' ').code).to_natural_8
									end
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_tmp___78 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0.item]))
									else
										l_tmp___78 := 1
									end
									l_p___0.item := l_p___0.item + l_tmp___78
								end
								if ((l_items[0])[3]).to_integer_32 = 83 then
									l_tmp___79 := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_repsal"))
								else
									l_tmp___79 := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_rep"))
								end
								add_fromto (a_spin, l_tmp___79, l_items[1], l_items[2])
							end
						else
							l_pos := -1 + 197 -- goto _L___8
						end
				when 196 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 197 then -- else: | _L___8:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("MAP"), 2)).to_boolean) then
							l_pos := -1 + 211 -- skip if block
						end
				when 198 then -- if:
						if l_found_map.to_boolean then
							l_pos := -1 + 201 -- skip if block
						end
				when 199 then -- if:
						l_found_map := 1
						if not ((((ctype_b_loc).item[((l_items[1]).item).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Expected MAP count in %%s line %%d")))), a_fname, l_lnum]).do_nothing
						end
				when 200 then -- if block done, skip else block:
						l_pos := -1 + 210
				when 201 then -- else:
						if not (l_do_mapline.to_boolean) then
							l_pos := -1 + 210 -- skip if block
						end
				when 202 then -- if:
						l_p___0.item := l_items[1]
				when 203 then -- loop condition:
						if (l_p___0.item.item).to_integer_32 = 0 then
							l_pos := -1 + 209 -- skip loop
						end
				when 204 then -- loop body:
						l_c___0 := (create {P_MBYTE_STATIC}).mb_ptr2char_adv (l_p___0)
						if not (a_spin.item.si_map.ga_len > 0) then
							l_pos := -1 + 207 -- skip if block
						end
				when 205 then -- if:
						if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (a_spin.item.si_map.ga_data), l_c___0)).is_void then
							l_tmp___83 := gettext (ce_string ("Duplicate character in MAP in %%s line %%d"));
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___83), a_fname, l_lnum]).do_nothing
						else
							l_pos := -1 + 207 -- goto _L___4
						end
				when 206 then -- if block done, skip else block:
						l_pos := -1 + 208
				when 207 then -- else: | _L___4:
						if not ((create {P_MISC2_STATIC}).vim_strchr (l_p___0.item, l_c___0)).is_void then
							l_tmp___83 := gettext (ce_string ("Duplicate character in MAP in %%s line %%d"));
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___83), a_fname, l_lnum]).do_nothing
						end
				when 208 then
						l_pos := -1 + 203 -- back to loop condition
				when 209 then -- loop done;
						(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_map"))).item.ga_concat (l_items[1]);
						(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_map"))).item.ga_append (('/').code)
				when 210 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 232
				when 211 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("SAL"), 3)).to_boolean) then
							l_pos := -1 + 214 -- skip if block
						end
				when 212 then -- if:
						if l_do_sal.to_boolean then
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[1]), ce_string ("followup"))) = 0 then
								a_spin.item.si_followup := sal_to_bool (l_items[2])
							elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[1]), ce_string ("collapse_result"))) = 0 then
								a_spin.item.si_collapse := sal_to_bool (l_items[2])
							elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[1]), ce_string ("remove_accents"))) = 0 then
								a_spin.item.si_rem_accents := sal_to_bool (l_items[2])
							else
								if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[2]), ce_string ("_"))) = 0 then
									l_tmp___87 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
								else
									l_tmp___87 := l_items[2]
								end
								add_fromto (a_spin, create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_sal")), l_items[1], l_tmp___87)
							end
						end
				when 213 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 214 then -- else:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("SOFOFROM"), 2)).to_boolean) then
							l_pos := -1 + 217 -- skip if block
						end
				when 215 then -- if:
						if l_sofofrom.is_void then
							l_sofofrom := a_spin.item.getroom_save (l_items[1])
						else
							l_pos := -1 + 217 -- goto _L___7
						end
				when 216 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 217 then -- else: | _L___7:
						if not ((is_aff_rule (l_items, l_itemcnt, ce_string ("SOFOTO"), 2)).to_boolean) then
							l_pos := -1 + 220 -- skip if block
						end
				when 218 then -- if:
						if l_sofoto.is_void then
							l_sofoto := a_spin.item.getroom_save (l_items[1])
						else
							l_pos := -1 + 220 -- goto _L___6
						end
				when 219 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 220 then -- else: | _L___6:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_items[0]), ce_string ("COMMON"))) /= 0 then
							l_pos := -1 + 231 -- skip if block
						end
				when 221 then -- if:
						l_i___1 := 1
				when 222 then -- loop condition:
						if not (not (l_break) and then (l_i___1 < l_itemcnt)) then
							l_pos := -1 + 229 -- skip loop
						end
				when 223 then -- loop body:
						l_break := False
						if not ((((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_commonwords"))).item.hash_find (l_items[l_i___1])).item.hi_key).is_void) then
							l_pos := -1 + 226 -- skip if block
						end
				when 224 then -- if:
						l_pos := -1 + 227 -- goto _L___5
				when 225 then -- if block done, skip else block:
						l_pos := -1 + 228
				when 226 then -- else:
						if not ((((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_commonwords"))).item.hash_find (l_items[l_i___1])).item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
							l_pos := -1 + 228 -- skip if block
						end
				when 227 then -- if: | _L___5:
						l_p___0.item := (create {P_MISC2_STATIC}).vim_strsave (l_items[l_i___1])
						if (l_p___0.item).is_void then
							l_break := True
						end
						if not (l_return or l_break) then
							(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_commonwords"))).item.hash_add (l_p___0.item).do_nothing
						end
				when 228 then -- if done
						if not (l_return or l_break) then
							l_i___1 := l_i___1 + 1
						end
						l_pos := -1 + 222 -- back to loop condition
				when 229 then -- loop done
						l_break := False
				when 230 then -- if block done, skip else block:
						l_pos := -1 + 232
				when 231 then -- else:;
						(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Unrecognized or duplicate item in %%s line %%d: %%s")))), a_fname, l_lnum, l_items[0]]).do_nothing
				when 232 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 233 then -- loop done
						l_break := False
						l_continue := False
						if l_fol.is_void then
							l_pos := -1 + 236 -- skip if block
						end
				when 234 then -- if:
						l_pos := -1 + 240 -- goto _L___43
				when 235 then -- if block done, skip else block:
						l_pos := -1 + 241
				when 236 then -- else:
						if l_low.is_void then
							l_pos := -1 + 239 -- skip if block
						end
				when 237 then -- if:
						l_pos := -1 + 240 -- goto _L___43
				when 238 then -- if block done, skip else block:
						l_pos := -1 + 241
				when 239 then -- else:
						if l_upp.is_void then
							l_pos := -1 + 241 -- skip if block
						end
				when 240 then -- if: | _L___43:
						if (a_spin.item.si_clear_chartab).to_boolean then
							init_spell_chartab
							a_spin.item.si_clear_chartab := 0
						end
						if not (a_spin.item.si_ascii).to_boolean then
							if not ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								if l_fol.is_void then
									l_tmp___149 := gettext (ce_string ("Missing FOL/LOW/UPP line in %%s"));
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___149), a_fname]).do_nothing
								elseif l_low.is_void then
									l_tmp___149 := gettext (ce_string ("Missing FOL/LOW/UPP line in %%s"));
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___149), a_fname]).do_nothing
								elseif l_upp.is_void then
									l_tmp___149 := gettext (ce_string ("Missing FOL/LOW/UPP line in %%s"));
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___149), a_fname]).do_nothing
								else
									set_spell_chartab (l_fol, l_low, l_upp).do_nothing
								end
							end
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fol));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_low));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_upp))
				when 241 then -- if done | if done
						if l_compmax /= 0 then
							aff_check_number (a_spin.item.si_compmax, l_compmax, ce_string ("COMPOUNDWORDMAX"))
							a_spin.item.si_compmax := l_compmax
						end
						if l_compminlen /= 0 then
							aff_check_number (a_spin.item.si_compminlen, l_compminlen, ce_string ("COMPOUNDMIN"))
							a_spin.item.si_compminlen := l_compminlen
						end
						if l_compsylmax /= 0 then
							if l_syllable.is_void then
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("COMPOUNDSYLMAX used without SYLLABLE"))))]).do_nothing
							end
							aff_check_number (a_spin.item.si_compsylmax, l_compsylmax, ce_string ("COMPOUNDSYLMAX"))
							a_spin.item.si_compsylmax := l_compsylmax
						end
						if l_compoptions /= 0 then
							aff_check_number (a_spin.item.si_compoptions, l_compoptions, ce_string ("COMPOUND options"))
							a_spin.item.si_compoptions := (a_spin.item.si_compoptions).bit_or (l_compoptions)
						end
						if not l_compflags.is_void then
							a_spin.item.process_compflags (l_aff, l_compflags)
						end
						if a_spin.item.si_newcompID < a_spin.item.si_newprefID then
							if a_spin.item.si_newcompID = 127 then
								l_tmp___151 := gettext (ce_string ("Too many postponed prefixes"));
								(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___151)).do_nothing
							elseif a_spin.item.si_newcompID = 255 then
								l_tmp___151 := gettext (ce_string ("Too many postponed prefixes"));
								(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___151)).do_nothing
							elseif a_spin.item.si_newprefID = 0 then
								l_tmp___152 := gettext (ce_string ("Too many compound flags"));
								(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___152)).do_nothing
							elseif a_spin.item.si_newprefID = 127 then
								l_tmp___152 := gettext (ce_string ("Too many compound flags"));
								(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___152)).do_nothing
							else
								(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Too many postponed prefixes and/or compound flags"))))).do_nothing
							end
						end
						if not l_syllable.is_void then
							aff_check_string (a_spin.item.si_syllable, l_syllable, ce_string ("SYLLABLE"))
							a_spin.item.si_syllable := l_syllable
						end
						if l_sofofrom.is_void then
							l_pos := -1 + 244 -- skip if block
						end
				when 242 then -- if:
						l_pos := -1 + 245 -- goto _L___45
				when 243 then -- if block done, skip else block:
						l_pos := -1 + 252
				when 244 then -- else:
						if l_sofoto.is_void then
							l_pos := -1 + 252 -- skip if block
						end
				when 245 then -- if: | _L___45:
						if not (l_sofofrom.is_void) then
							l_pos := -1 + 248 -- skip if block
						end
				when 246 then -- if:
						l_pos := -1 + 249 -- goto _L___44
				when 247 then -- if block done, skip else block:
						l_pos := -1 + 252
				when 248 then -- else:
						if not (l_sofoto.is_void) then
							l_pos := -1 + 251 -- skip if block
						end
				when 249 then -- if: | _L___44:
						if l_sofofrom.is_void then
							l_tmp___154 := ce_string ("FROM")
						else
							l_tmp___154 := ce_string ("TO")
						end
						(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Missing SOFO%%s line in %%s")))), l_tmp___154, a_fname]).do_nothing
				when 250 then -- if block done, skip else block:
						l_pos := -1 + 252
				when 251 then -- else:
						if a_spin.item.si_sal.ga_len > 0 then
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Both SAL and SOFO lines in %%s")))), a_fname]).do_nothing
						else
							aff_check_string (a_spin.item.si_sofofr, l_sofofrom, ce_string ("SOFOFROM"))
							aff_check_string (a_spin.item.si_sofoto, l_sofoto, ce_string ("SOFOTO"))
							a_spin.item.si_sofofr := l_sofofrom
							a_spin.item.si_sofoto := l_sofoto
						end
				when 252 then -- if done | if done | if done
						if not l_midword.is_void then
							aff_check_string (a_spin.item.si_midword, l_midword, ce_string ("MIDWORD"))
							a_spin.item.si_midword := l_midword
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pc))
						fclose (l_fd).do_nothing
						Result := l_aff
				when 253 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	is_aff_rule (a_items: CE_POINTER [CE_POINTER [NATURAL_8]]; a_itemcnt: INTEGER_32; a_rulename: CE_POINTER [INTEGER_8]; a_mincount: INTEGER_32): INTEGER_32
		require
			not a_items.is_void
			not a_rulename.is_void
		local
			l_tmp___0: INTEGER_32
		do
			if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_items[0]), a_rulename)) = 0 then
				if a_itemcnt = a_mincount then
					l_tmp___0 := 1
				elseif a_itemcnt > a_mincount then
					if ((a_items[a_mincount])[0]).to_integer_32 = 35 then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	aff_process_flags (a_affile: CE_POINTER [PD_AFFFILE_S]; a_entry: CE_POINTER [PD_AFFENTRY_S])
		require
			not a_entry.is_void
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_prevp: CE_POINTER [NATURAL_8]
			l_flag: NATURAL_32
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_entry.item.ae_flags).is_void then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if a_affile.item.af_compforbid = {NATURAL_32} 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___0
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						if a_affile.item.af_comppermit = {NATURAL_32} 0 then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if: | _L___0:
						l_p___0.item := a_entry.item.ae_flags
				when 6 then -- loop condition:
						if (l_p___0.item.item).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip loop
						end
				when 7 then -- loop body:
						l_prevp := l_p___0.item
						l_flag := get_affitem (a_affile.item.af_flagtype, l_p___0)
						if l_flag /= a_affile.item.af_comppermit then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if l_flag /= a_affile.item.af_compforbid then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						memmove (create {CE_VOID_POINTER}.make_cast (l_prevp), create {CE_VOID_POINTER}.make_cast (l_p___0.item), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item))) + {NATURAL_32} 1).do_nothing
						l_p___0.item := l_prevp
						if l_flag = a_affile.item.af_comppermit then
							a_entry.item.ae_comppermit := (1).to_integer_8
						else
							a_entry.item.ae_compforbid := (1).to_integer_8
						end
				when 12 then -- if done
						if a_affile.item.af_flagtype = 3 then
							if (l_p___0.item.item).to_integer_32 = 44 then
								l_p___0.item := l_p___0.item + 1
							end
						end
						l_pos := -1 + 6 -- back to loop condition
				when 13 then -- loop done
						if ((a_entry.item.ae_flags).item).to_integer_32 = 0 then
							a_entry.item.ae_flags := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
				when 14 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_info_item (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___5: INTEGER_32
		do
			if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_s), ce_string ("NAME"))) = 0 then
				l_tmp___5 := 1
			elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_s), ce_string ("HOME"))) = 0 then
				l_tmp___5 := 1
			elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_s), ce_string ("VERSION"))) = 0 then
				l_tmp___5 := 1
			elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_s), ce_string ("AUTHOR"))) = 0 then
				l_tmp___5 := 1
			elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_s), ce_string ("EMAIL"))) = 0 then
				l_tmp___5 := 1
			elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_s), ce_string ("COPYRIGHT"))) = 0 then
				l_tmp___5 := 1
			else
				l_tmp___5 := 0
			end
			Result := l_tmp___5
		end

	affitem2flag (a_flagtype: INTEGER_32; a_item, a_fname: CE_POINTER [NATURAL_8]; a_lnum: INTEGER_32): NATURAL_32
		local
			l_res: NATURAL_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			l_p___0.item := a_item
			l_res := get_affitem (a_flagtype, l_p___0)
			if l_res = {NATURAL_32} 0 then
				if a_flagtype = 3 then
					(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Flag is not a number in %%s line %%d: %%s")))), a_fname, a_lnum, a_item]).do_nothing
				else
					(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Illegal flag in %%s line %%d: %%s")))), a_fname, a_lnum, a_item]).do_nothing
				end
			end
			if (l_p___0.item.item).to_integer_32 /= 0 then
				(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (e_affname.item))), a_fname, a_lnum, a_item]).do_nothing
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				Result := l_res
			end
		end

	get_affitem (a_flagtype: INTEGER_32; a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]): NATURAL_32
		require
			not a_pp.is_void
		local
			l_res: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_flagtype /= 3 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((a_pp.item).item).to_integer_32 >= 48 then
							if not (((a_pp.item).item).to_integer_32 <= 57) then
								a_pp.item := (a_pp.item) + 1
								Result := {NATURAL_32} 0
								l_return := True
							end
						else
							a_pp.item := (a_pp.item) + 1
							Result := {NATURAL_32} 0
							l_return := True
						end
						if not l_return then
							l_res := ((create {P_CHARSET_STATIC}).getdigits (a_pp)).to_integer_32
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						l_res := (create {P_MBYTE_STATIC}).mb_ptr2char_adv (a_pp)
						if a_flagtype /= 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if a_flagtype /= 2 then
							l_pos := -1 + 10 -- skip if block
						end
				when 7 then -- if:
						if not (l_res >= 65) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if not (l_res <= 90) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if ((a_pp.item).item).to_integer_32 = 0 then
							Result := {NATURAL_32} 0
							l_return := True
						end
						if not l_return then
							l_res := ((create {P_MBYTE_STATIC}).mb_ptr2char_adv (a_pp)) + ((l_res).bit_shift_left (16))
						end
				when 10 then -- if done | if done | if done | if done
					if not l_return then
						Result := l_res.to_natural_32
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	flag_in_afflist (a_flagtype: INTEGER_32; a_afflist: CE_POINTER [NATURAL_8]; a_flag: NATURAL_32): INTEGER_32
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_n: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_flagtype -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 13
					else l_pos := -1 + 14
					end
				when 1 then -- switch 1, case 0
					Result := (not ((create {P_MISC2_STATIC}).vim_strchr (a_afflist, a_flag.to_integer_32)).is_void).to_integer
					l_return := True
				when 2 then -- switch 1, case 2 | switch 1, case 1
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 3 then -- if:
						l_p___0.item := a_afflist
				when 4 then -- loop condition:
						if not (not (l_return) and then ((l_p___0.item.item).to_integer_32 /= 0)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 5 then -- loop body:
						l_n := ((create {P_MBYTE_STATIC}).mb_ptr2char_adv (l_p___0)).to_natural_32
						if a_flagtype /= 1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 8 then -- else:
						if not (l_n >= {NATURAL_32} 65) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if not (l_n <= {NATURAL_32} 90) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						if (l_p___0.item.item).to_integer_32 /= 0 then
							l_n := ((create {P_MBYTE_STATIC}).mb_ptr2char_adv (l_p___0)).to_natural_32 + ((l_n).bit_shift_left (16))
						end
				when 11 then -- if done | if done
						if l_n = a_flag then
							Result := 1
							l_return := True
						end
						l_pos := -1 + 4 -- back to loop condition
				when 12 then -- loop done | if done
					l_pos := -1 + 14 -- switch 1; break
				when 13 then -- switch 1, case 3
					l_p___0.item := a_afflist
					from
					until
						not (not (l_return) and then ((l_p___0.item.item).to_integer_32 /= 0))
					loop
						l_n := ((create {P_CHARSET_STATIC}).getdigits (l_p___0)).to_natural_32
						if l_n = a_flag then
							Result := 1
							l_return := True
						end
						if not l_return and then ((l_p___0.item.item).to_integer_32 /= 0) then
							l_p___0.item := l_p___0.item + 1
						end
					end
					l_pos := -1 + 14 -- switch 1; break
				when 14 then -- switch 1, done:
					if not l_return then
						Result := 0
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	aff_check_number (a_spinval, a_affval: INTEGER_32; a_name___1: CE_POINTER [INTEGER_8])
		do
			if a_spinval /= 0 then
				if a_spinval /= a_affval then
					(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%%s value differs from what is used in another .aff file")))), a_name___1]).do_nothing
				end
			end
		end

	aff_check_string (a_spinval, a_affval: CE_POINTER [NATURAL_8]; a_name___1: CE_POINTER [INTEGER_8])
		do
			if not a_spinval.is_void then
				if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_spinval), create {CE_INTEGER_8_POINTER}.make_cast (a_affval))) /= 0 then
					(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%%s value differs from what is used in another .aff file")))), a_name___1]).do_nothing
				end
			end
		end

	str_equal (a_s1, a_s2: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_s1.is_void then
				Result := (a_s1.is_equal (a_s2)).to_integer
				l_return := True
			elseif a_s2.is_void then
				Result := (a_s1.is_equal (a_s2)).to_integer
				l_return := True
			end
			if not l_return then
				Result := ((strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_s1), create {CE_INTEGER_8_POINTER}.make_cast (a_s2))) = 0).to_integer
			end
		end

	add_fromto (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_gap: CE_POINTER [PD_GROWARRAY]; a_from, a_to: CE_POINTER [NATURAL_8])
		require
			not a_gap.is_void
		local
			l_ftp: CE_POINTER [PD_FROMTO_S]
			l_word: CE_ARRAY [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_word.make (<<250>>)

			if (a_gap.item.ga_grow (1)) = 1 then
				l_ftp := create {CE_CLASS_POINTER [PD_FROMTO_S]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len
				spell_casefold (a_from, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_from))).to_integer_32, l_word, 250).do_nothing
				l_ftp.item.ft_from := a_spin.item.getroom_save (l_word)
				spell_casefold (a_to, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_to))).to_integer_32, l_word, 250).do_nothing
				l_ftp.item.ft_to := a_spin.item.getroom_save (l_word)
				a_gap.item.ga_len := (a_gap.item.ga_len) + 1
			end
		end

	sal_to_bool (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_s), ce_string ("1"))) = 0 then
				l_tmp___1 := 1
			elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_s), ce_string ("true"))) = 0 then
				l_tmp___1 := 1
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	has_non_ascii (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			if not a_s.is_void then
				l_p___0 := a_s
				from
				until
					not (not (l_return) and then ((l_p___0.item).to_integer_32 /= 0))
				loop
					if (l_p___0.item).to_integer_32 >= 128 then
						Result := 1
						l_return := True
					end
					if not l_return then
						l_p___0 := l_p___0 + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	spell_read_dic (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_fname: CE_POINTER [NATURAL_8]; a_affile: CE_POINTER [PD_AFFFILE_S]): INTEGER_32
		local
			l_ht: CE_ARRAY [PD_HASHTABLE_S]
			l_line: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_afflist: CE_POINTER [NATURAL_8]
			l_store_afflist: CE_ARRAY [NATURAL_8]
			l_pfxlen: INTEGER_32
			l_need_affix: INTEGER_32
			l_dw: CE_POINTER [NATURAL_8]
			l_pc: CE_POINTER [NATURAL_8]
			l_w: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_hash: NATURAL_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_fd: CE_POINTER [SD_IO_FILE]
			l_lnum: INTEGER_32
			l_non_ascii: INTEGER_32
			l_retval: INTEGER_32
			l_message: CE_ARRAY [NATURAL_8]
			l_flags___0: INTEGER_32
			l_duplicate: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: NATURAL_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_HASHTABLE_S]} l_ht.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_line.make (<<500>>)
			create {CE_NATURAL_8_POINTER} l_afflist.make
			create {CE_NATURAL_8_ARRAY} l_store_afflist.make (<<250>>)
			create {CE_NATURAL_8_POINTER} l_dw.make
			create {CE_NATURAL_8_POINTER} l_pc.make
			create {CE_NATURAL_8_POINTER} l_w.make
			create {CE_NATURAL_8_ARRAY} l_message.make (<<750>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := 1
					l_non_ascii := 0
					l_retval := 1
					l_duplicate := 0
					l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (a_fname), ce_string ("r"))
					if l_fd.is_void then
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_notopen.item))))), a_fname).do_nothing
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l_ht.item.hash_init;
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, (gettext (ce_string ("Reading dictionary file %%s ..."))), a_fname]).do_nothing
						a_spin.item.spell_message ((create {P_GLOBALS_STATIC}).IObuff.item)
						a_spin.item.si_msg_count := 999_999;
						(create {P_FILEIO_STATIC}).vim_fgets (l_line, 500, l_fd).do_nothing
						if not ((create {P_CHARSET_STATIC}).vim_isdigit ((((create {P_CHARSET_STATIC}).skipwhite (l_line)).item).to_integer_32)).to_boolean then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E760: No word count in %%s")))), a_fname).do_nothing
						end
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 13 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						if ((create {P_FILEIO_STATIC}).vim_fgets (l_line, 500, l_fd)).to_boolean then
							l_break := True
						elseif ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							(create {P_MISC1_STATIC}).line_breakcheck
							l_lnum := l_lnum + 1
							if (l_line[0]).to_integer_32 = 35 then
								l_continue := True
							elseif (l_line[0]).to_integer_32 = 47 then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))).to_integer_32
							from
							until
								(l_break)
							loop
								l_break := False
								if l_l > 0 then
									if not ((l_line[l_l - 1]).to_integer_32 <= 32) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_l := l_l - 1
								end
							end
							l_break := False
							if l_l = 0 then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							l_line[l_l] := (('%/0/').code).to_natural_8
							if a_spin.item.si_conv.vc_type /= 0 then
								l_pc := (create {P_MBYTE_STATIC}).string_convert (create {CE_CLASS_POINTER [PD_VIMCONV_T]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_conv")), l_line, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
								if l_pc.is_void then
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Conversion failure for word in %%s line %%d: %%s")))), a_fname, l_lnum, l_line]).do_nothing
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_w := l_pc
								end
							else
								l_pc := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								l_w := l_line
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						l_afflist := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_p___0 := l_w
				when 5 then -- loop condition:
						if not (not (l_break) and then ((l_p___0.item).to_integer_32 /= 0)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						if (l_p___0.item).to_integer_32 /= 92 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (l_p___0[1]).to_integer_32 = 92 then
							l_tmp___8 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 1)))
							memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + 1)), l_tmp___8 + {NATURAL_32} 1).do_nothing
						elseif (l_p___0[1]).to_integer_32 = 47 then
							l_tmp___8 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 1)))
							memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + 1)), l_tmp___8 + {NATURAL_32} 1).do_nothing
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if (l_p___0.item).to_integer_32 = 47 then
							l_p___0.item := (('%/0/').code).to_natural_8
							l_afflist := l_p___0 + 1
							l_break := True
						end
				when 10 then
						if not (l_break) then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___7 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
							else
								l_tmp___7 := 1
							end
							l_p___0 := l_p___0 + l_tmp___7
						end
						l_pos := -1 + 5 -- back to loop condition
				when 11 then -- loop done
						l_break := False
						if (a_spin.item.si_ascii).to_boolean then
							if (has_non_ascii (l_w)).to_boolean then
								l_non_ascii := l_non_ascii + 1;
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pc))
								l_continue := True
							end
						end
				when 12 then -- if done
						if not (l_return or l_break or l_continue) then
							if (a_spin.item.si_verbose).to_boolean then
								if a_spin.item.si_msg_count > 10_000 then
									a_spin.item.si_msg_count := 0;
									(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_message), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (750).to_natural_32), (gettext (ce_string ("line %%6d, word %%6d - %%s"))), l_lnum, a_spin.item.si_foldwcount + a_spin.item.si_keepwcount, l_w]).do_nothing;
									(create {P_MESSAGE_STATIC}).msg_start;
									(create {P_MESSAGE_STATIC}).msg_puts_long_attr (l_message, 0);
									(create {P_MESSAGE_STATIC}).msg_clr_eos;
									(create {P_GLOBALS_STATIC}).msg_didout.item := 0;
									(create {P_GLOBALS_STATIC}).msg_col.item := 0;
									(create {P_TERM_STATIC}).out_flush
								end
							end
							l_dw := (a_spin.item.getroom_save (l_w))
							if l_dw.is_void then
								l_retval := 0;
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pc))
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) then
							l_hash := (create {P_HASHTAB_STATIC}).hash_hash (l_dw)
							l_hi___1 := l_ht.item.hash_lookup (l_dw, l_hash)
							if (l_hi___1.item.hi_key).is_void then
								l_ht.item.hash_add_item (l_hi___1, l_dw, l_hash).do_nothing
							elseif (l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item) then
								l_ht.item.hash_add_item (l_hi___1, l_dw, l_hash).do_nothing
							else
								if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Duplicate word in %%s line %%d: %%s")))), a_fname, l_lnum, l_dw]).do_nothing
								elseif l_duplicate = 0 then
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("First duplicate word in %%s line %%d: %%s")))), a_fname, l_lnum, l_dw]).do_nothing
								end
								l_duplicate := l_duplicate + 1
							end
							l_flags___0 := 0
							l_store_afflist[0] := (('%/0/').code).to_natural_8
							l_pfxlen := 0
							l_need_affix := 0
							if not l_afflist.is_void then
								l_flags___0 := (l_flags___0).bit_or ((a_affile.item.get_affix_flags (l_afflist)))
								if a_affile.item.af_needaffix /= {NATURAL_32} 0 then
									if (flag_in_afflist (a_affile.item.af_flagtype, l_afflist, a_affile.item.af_needaffix)).to_boolean then
										l_need_affix := 1
									end
								end
								if (a_affile.item.af_pfxpostpone).to_boolean then
									l_pfxlen := get_pfxlist (a_affile, l_afflist, l_store_afflist)
								end
								if not (a_spin.item.si_compflags).is_void then
									get_compflags (a_affile, l_afflist, l_store_afflist + l_pfxlen)
								end
							end
							if (a_spin.item.store_word (l_dw, l_flags___0, a_spin.item.si_region, l_store_afflist, l_need_affix)) = 0 then
								l_retval := 0
							end
							if not l_afflist.is_void then
								if (store_aff_word (a_spin, l_dw, l_afflist, a_affile, create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_affile.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_suff")), create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_affile.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_pref")), 4, l_flags___0, l_store_afflist, l_pfxlen)) = 0 then
									l_retval := 0
								end
								if (store_aff_word (a_spin, l_dw, l_afflist, a_affile, create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_affile.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_pref")), create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (default_pointer), 4, l_flags___0, l_store_afflist, l_pfxlen)) = 0 then
									l_retval := 0
								end
							end
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pc))
						end
						l_pos := -1 + 2 -- back to loop condition
				when 13 then -- loop done
						l_break := False
						l_continue := False
						if l_duplicate > 0 then
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%%d duplicate word(s) in %%s")))), l_duplicate, a_fname]).do_nothing
						end
						if (a_spin.item.si_ascii).to_boolean then
							if l_non_ascii > 0 then
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Ignored %%d word(s) with non-ASCII characters in %%s")))), l_non_ascii, a_fname]).do_nothing
							end
						end
						l_ht.item.hash_clear
						fclose (l_fd).do_nothing
						Result := l_retval
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_pfxlist (a_affile: CE_POINTER [PD_AFFFILE_S]; a_afflist, a_store_afflist: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_store_afflist.is_void
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_prevp: CE_POINTER [NATURAL_8]
			l_cnt: INTEGER_32
			l_id: INTEGER_32
			l_key: CE_ARRAY [NATURAL_8]
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_tmp: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_key.make (<<17>>)

			l_cnt := 0
			l_p___0.item := a_afflist
			from
			until
				(l_p___0.item.item).to_integer_32 = 0
			loop
				l_prevp := l_p___0.item
				if (get_affitem (a_affile.item.af_flagtype, l_p___0)) /= {NATURAL_32} 0 then
					(create {P_MISC2_STATIC}).vim_strncpy (l_key, l_prevp, ((l_p___0.item).distance (l_prevp)).to_natural_32)
					l_hi___1 := (create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_affile.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_pref"))).item.hash_find (l_key)
					if not ((l_hi___1.item.hi_key).is_void) then
						if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
							l_id := (create {CE_CLASS_POINTER [PD_AFFHEADER_S]}.make_cast (l_hi___1.item.hi_key)).item.ah_newID
							if l_id /= 0 then
								l_tmp := l_cnt
								l_cnt := l_cnt + 1
								a_store_afflist[l_tmp] := l_id.to_natural_8
							end
						end
					end
				end
				if a_affile.item.af_flagtype = 3 then
					if (l_p___0.item.item).to_integer_32 = 44 then
						l_p___0.item := l_p___0.item + 1
					end
				end
			end
			a_store_afflist[l_cnt] := (('%/0/').code).to_natural_8
			Result := l_cnt
		end

	get_compflags (a_affile: CE_POINTER [PD_AFFFILE_S]; a_afflist, a_store_afflist: CE_POINTER [NATURAL_8])
		require
			not a_store_afflist.is_void
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_prevp: CE_POINTER [NATURAL_8]
			l_cnt: INTEGER_32
			l_key: CE_ARRAY [NATURAL_8]
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_tmp: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_key.make (<<17>>)

			l_cnt := 0
			l_p___0.item := a_afflist
			from
			until
				(l_p___0.item.item).to_integer_32 = 0
			loop
				l_prevp := l_p___0.item
				if (get_affitem (a_affile.item.af_flagtype, l_p___0)) /= {NATURAL_32} 0 then
					(create {P_MISC2_STATIC}).vim_strncpy (l_key, l_prevp, ((l_p___0.item).distance (l_prevp)).to_natural_32)
					l_hi___1 := (create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_affile.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_comp"))).item.hash_find (l_key)
					if not ((l_hi___1.item.hi_key).is_void) then
						if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
							l_tmp := l_cnt
							l_cnt := l_cnt + 1
							a_store_afflist[l_tmp] := ((create {CE_CLASS_POINTER [PD_COMPITEM_S]}.make_cast (l_hi___1.item.hi_key)).item.ci_newID).to_natural_8
						end
					end
				end
				if a_affile.item.af_flagtype = 3 then
					if (l_p___0.item.item).to_integer_32 = 44 then
						l_p___0.item := l_p___0.item + 1
					end
				end
			end
			a_store_afflist[l_cnt] := (('%/0/').code).to_natural_8
		end

	store_aff_word (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_word, a_afflist: CE_POINTER [NATURAL_8]; a_affile: CE_POINTER [PD_AFFFILE_S]; a_ht, a_xht: CE_POINTER [PD_HASHTABLE_S]; a_condit, a_flags___0: INTEGER_32; a_pfxlist: CE_POINTER [NATURAL_8]; a_pfxlen: INTEGER_32): INTEGER_32
		require
			not a_ht.is_void
		local
			l_todo: INTEGER_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_ah: CE_POINTER [PD_AFFHEADER_S]
			l_ae: CE_POINTER [PD_AFFENTRY_S]
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_newword: CE_ARRAY [NATURAL_8]
			l_retval: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_use_flags: INTEGER_32
			l_use_pfxlist: CE_POINTER [NATURAL_8]
			l_use_pfxlen: INTEGER_32
			l_need_affix: INTEGER_32
			l_store_afflist: CE_ARRAY [NATURAL_8]
			l_pfx_pfxlist: CE_ARRAY [NATURAL_8]
			l_wordlen: NATURAL_32
			l_use_condit: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___22: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_REGMATCH_T]} l_regmatch___0.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_newword.make (<<250>>)
			create {CE_NATURAL_8_ARRAY} l_store_afflist.make (<<250>>)
			create {CE_NATURAL_8_ARRAY} l_pfx_pfxlist.make (<<250>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := 1
					l_wordlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_word)))
					l_todo := (a_ht.item.ht_used).to_integer_32
					l_hi___1 := a_ht.item.ht_array
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 41 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if l_todo > 0 then
							if l_retval /= 1 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 40 -- skip if block
						end
				when 3 then -- if:
						if ((l_hi___1.item.hi_key).is_void) then
							l_pos := -1 + 39 -- skip if block
						end
				when 4 then -- if:
						if ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
							l_pos := -1 + 39 -- skip if block
						end
				when 5 then -- if:
						l_todo := l_todo - 1
						l_ah := create {CE_CLASS_POINTER [PD_AFFHEADER_S]}.make_cast (l_hi___1.item.hi_key)
						if ((a_condit).bit_and (1)) /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L___3
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 8 then -- else:
						if not ((l_ah.item.ah_combine).to_boolean) then
							l_pos := -1 + 39 -- skip if block
						end
				when 9 then -- if: | _L___3:
						if not ((flag_in_afflist (a_affile.item.af_flagtype, a_afflist, l_ah.item.ah_flag)).to_boolean) then
							l_pos := -1 + 39 -- skip if block
						end
				when 10 then -- if:
						l_ae := l_ah.item.ah_first
				when 11 then -- loop condition:
						if not (not (l_return) and then (not l_ae.is_void)) then
							l_pos := -1 + 39 -- skip loop
						end
				when 12 then -- loop body:
						l_regmatch___0.item.regprog := l_ae.item.ae_prog
						l_regmatch___0.item.rm_ic := 0
						if a_xht.is_void then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 22 -- goto _L___2
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 15 then -- else:
						if (a_affile.item.af_pfxpostpone).to_boolean then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 22 -- goto _L___2
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 18 then -- else:
						if (l_ae.item.ae_chop).is_void then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L___2
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 21 then -- else:
						if (l_ae.item.ae_flags).is_void then
							l_pos := -1 + 38 -- skip if block
						end
				when 22 then -- if: | _L___2:
						if not ((l_ae.item.ae_chop).is_void) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L___1
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 25 then -- else:
						if not ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ae.item.ae_chop))) < l_wordlen) then
							l_pos := -1 + 38 -- skip if block
						end
				when 26 then -- if: | _L___1:
						if not ((l_ae.item.ae_prog).is_void) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						l_pos := -1 + 30 -- goto _L___0
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 29 then -- else:
						if not ((l_regmatch___0.item.vim_regexec (a_word, 0)).to_boolean) then
							l_pos := -1 + 38 -- skip if block
						end
				when 30 then -- if: | _L___0:
						if ((a_condit).bit_and (8)) = 0 then
							l_tmp___22 := 1
						elseif (l_ae.item.ae_flags).is_void then
							l_tmp___22 := 1
						elseif (flag_in_afflist (a_affile.item.af_flagtype, l_ae.item.ae_flags, a_affile.item.af_circumfix)).to_boolean then
							l_tmp___22 := 0
						else
							l_tmp___22 := 1
						end
						if (((a_condit).bit_and (2)) = 0) /= l_tmp___22.to_boolean then
							l_pos := -1 + 38 -- skip if block
						end
				when 31 then -- if:
						if a_xht.is_void then
							if (l_ae.item.ae_add).is_void then
								l_newword[0] := (('%/0/').code).to_natural_8
							else
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_newword), create {CE_INTEGER_8_POINTER}.make_cast (l_ae.item.ae_add)).do_nothing
							end
							l_p___0 := a_word
							if not (l_ae.item.ae_chop).is_void then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_i___0 := (create {P_MBYTE_STATIC}).mb_charlen (l_ae.item.ae_chop)
									from
									until
										not (l_i___0 > 0)
									loop
										if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
											l_tmp___1 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
										else
											l_tmp___1 := 1
										end
										l_p___0 := l_p___0 + l_tmp___1
										l_i___0 := l_i___0 - 1
									end
								else
									l_p___0 := l_p___0 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ae.item.ae_chop))).to_integer_32
								end
							end
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_newword), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0)).do_nothing
						else
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_newword), create {CE_INTEGER_8_POINTER}.make_cast (a_word)).do_nothing
							if not (l_ae.item.ae_chop).is_void then
								l_p___0 := l_newword + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_newword))).to_integer_32
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___6 := ((create {P_MBYTE_STATIC}).mb_charlen (l_ae.item.ae_chop))
								else
									l_tmp___6 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ae.item.ae_chop))).to_integer_32
								end
								l_i___0 := l_tmp___6
								from
								until
									not (l_i___0 > 0)
								loop
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_tmp___8 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_newword, l_p___0 - 1])) + 1
									else
										l_tmp___8 := 1
									end
									l_p___0 := l_p___0 - l_tmp___8
									l_i___0 := l_i___0 - 1
								end
								l_p___0.item := (('%/0/').code).to_natural_8
							end
							if not (l_ae.item.ae_add).is_void then
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_newword), create {CE_INTEGER_8_POINTER}.make_cast (l_ae.item.ae_add)).do_nothing
							end
						end
						l_use_flags := a_flags___0
						l_use_pfxlist := a_pfxlist
						l_use_pfxlen := a_pfxlen
						l_need_affix := 0
						l_use_condit := (((a_condit).bit_or (1))).bit_or (8)
						if (l_ae.item.ae_flags).is_void then
							l_pos := -1 + 37 -- skip if block
						end
				when 32 then -- if:
						l_use_flags := (l_use_flags).bit_or ((a_affile.item.get_affix_flags (l_ae.item.ae_flags)))
						if a_affile.item.af_needaffix /= {NATURAL_32} 0 then
							if (flag_in_afflist (a_affile.item.af_flagtype, l_ae.item.ae_flags, a_affile.item.af_needaffix)).to_boolean then
								l_need_affix := 1
							end
						end
						if a_affile.item.af_circumfix /= {NATURAL_32} 0 then
							if (flag_in_afflist (a_affile.item.af_flagtype, l_ae.item.ae_flags, a_affile.item.af_circumfix)).to_boolean then
								l_use_condit := (l_use_condit).bit_or ((2))
								if ((a_condit).bit_and (2)) = 0 then
									l_need_affix := 1
								end
							end
						end
						if not ((a_affile.item.af_pfxpostpone).to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 36 -- goto _L
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 35 then -- else:
						if (a_spin.item.si_compflags).is_void then
							l_pos := -1 + 37 -- skip if block
						end
				when 36 then -- if: | _L:
						if (a_affile.item.af_pfxpostpone).to_boolean then
							l_use_pfxlen := get_pfxlist (a_affile, l_ae.item.ae_flags, l_store_afflist)
						else
							l_use_pfxlen := 0
						end
						l_use_pfxlist := l_store_afflist
						l_i___0 := 0
						from
						until
							not (not (l_return) and then (l_i___0 < a_pfxlen))
						loop
							l_j := 0
							from
							until
								not (not (l_break) and then (l_j < l_use_pfxlen))
							loop
								l_break := False
								if (a_pfxlist[l_i___0]).to_integer_32 = (l_use_pfxlist[l_j]).to_integer_32 then
									l_break := True
								end
								if not (l_break) then
									l_j := l_j + 1
								end
							end
							l_break := False
							if l_j = l_use_pfxlen then
								l_tmp___12 := l_use_pfxlen
								l_use_pfxlen := l_use_pfxlen + 1
								l_use_pfxlist[l_tmp___12] := a_pfxlist[l_i___0]
							end
							l_i___0 := l_i___0 + 1
						end
						if not (a_spin.item.si_compflags).is_void then
							get_compflags (a_affile, l_ae.item.ae_flags, l_use_pfxlist + l_use_pfxlen)
						end
						l_i___0 := a_pfxlen
						from
						until
							not (not (l_return) and then ((a_pfxlist[l_i___0]).to_integer_32 /= 0))
						loop
							l_j := l_use_pfxlen
							from
							until
								not (not (l_break) and then ((l_use_pfxlist[l_j]).to_integer_32 /= 0))
							loop
								l_break := False
								if (a_pfxlist[l_i___0]).to_integer_32 = (l_use_pfxlist[l_j]).to_integer_32 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_j := l_j + 1
								end
							end
							l_break := False
							if (l_use_pfxlist[l_j]).to_integer_32 = 0 then
								l_tmp___13 := l_j
								l_j := l_j + 1
								l_use_pfxlist[l_tmp___13] := a_pfxlist[l_i___0]
								l_use_pfxlist[l_j] := (('%/0/').code).to_natural_8
							end
							l_i___0 := l_i___0 + 1
						end
				when 37 then -- if done | if done
						if not l_use_pfxlist.is_void then
							if (l_ae.item.ae_compforbid).to_boolean then
								(create {P_MISC2_STATIC}).vim_strncpy (l_pfx_pfxlist, l_use_pfxlist, l_use_pfxlen.to_natural_32)
								l_use_pfxlist := l_pfx_pfxlist
							end
						end
						if not (a_spin.item.si_prefroot).is_void then
							if not ((a_spin.item.si_prefroot).item.wn_sibling).is_void then
								l_use_flags := (l_use_flags).bit_or ((256))
								if not (l_ah.item.ah_combine).to_boolean then
									if not l_use_pfxlist.is_void then
										l_use_pfxlist := l_use_pfxlist + l_use_pfxlen
									end
								end
							end
						end
						if not (a_spin.item.si_compflags).is_void then
							if not (l_ae.item.ae_comppermit).to_boolean then
								if not a_xht.is_void then
									l_use_flags := (l_use_flags).bit_or ((8_192))
								else
									l_use_flags := (l_use_flags).bit_or ((4_096))
								end
							end
						end
						if (a_spin.item.store_word (l_newword, l_use_flags, a_spin.item.si_region, l_use_pfxlist, l_need_affix)) = 0 then
							l_retval := 0
						end
						if ((a_condit).bit_and (4)).to_boolean then
							if not (l_ae.item.ae_flags).is_void then
								if a_xht.is_void then
									l_tmp___15 := (0).bit_not
								else
									l_tmp___15 := (4).bit_not
								end
								if (store_aff_word (a_spin, l_newword, l_ae.item.ae_flags, a_affile, create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_affile.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_suff")), a_xht, (l_use_condit).bit_and (l_tmp___15), l_use_flags, l_use_pfxlist, a_pfxlen)) = 0 then
									l_retval := 0
								end
							end
						end
						if not a_xht.is_void then
							if (l_ah.item.ah_combine).to_boolean then
								if (store_aff_word (a_spin, l_newword, a_afflist, a_affile, a_xht, create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (default_pointer), l_use_condit, l_use_flags, l_use_pfxlist, a_pfxlen)) = 0 then
									l_retval := 0
								elseif not (l_ae.item.ae_flags).is_void then
									if (store_aff_word (a_spin, l_newword, l_ae.item.ae_flags, a_affile, a_xht, create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (default_pointer), l_use_condit, l_use_flags, l_use_pfxlist, a_pfxlen)) = 0 then
										l_retval := 0
									end
								end
							end
						end
				when 38 then -- if done | if done | if done | if done | if done | if done | if done | if done
						l_ae := l_ae.item.ae_next
						l_pos := -1 + 11 -- back to loop condition
				when 39 then -- loop done | if done | if done | if done | if done
						l_hi___1 := l_hi___1 + 1
				when 40 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 41 then -- loop done
					l_break := False
					Result := l_retval
				when 42 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_read_wordfile (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_lnum: INTEGER_32
			l_rline: CE_ARRAY [NATURAL_8]
			l_line: CE_POINTER [NATURAL_8]
			l_pc: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_retval: INTEGER_32
			l_did_word: INTEGER_32
			l_non_ascii: INTEGER_32
			l_flags___0: INTEGER_32
			l_regionmask: INTEGER_32
			l_enc: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_rline.make (<<500>>)
			create {CE_NATURAL_8_POINTER} l_line.make

			l_lnum := 0
			l_pc := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_retval := 1
			l_did_word := 0
			l_non_ascii := 0
			l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (a_fname), ce_string ("r"))
			if l_fd.is_void then
				(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_notopen.item))))), a_fname).do_nothing
				Result := 0
				l_return := True
			end
			if not l_return then
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, (gettext (ce_string ("Reading word file %%s ..."))), a_fname]).do_nothing
				a_spin.item.spell_message ((create {P_GLOBALS_STATIC}).IObuff.item)
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_continue := False
					if ((create {P_FILEIO_STATIC}).vim_fgets (l_rline, 500, l_fd)).to_boolean then
						l_break := True
					elseif ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						l_break := True
					end
					if not (l_return or l_break or l_continue) then
						(create {P_MISC1_STATIC}).line_breakcheck
						l_lnum := l_lnum + 1
						if (l_rline[0]).to_integer_32 = 35 then
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) then
						l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_rline))).to_integer_32
						from
						until
							(l_break)
						loop
							l_break := False
							if l_l > 0 then
								if not ((l_rline[l_l - 1]).to_integer_32 <= 32) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_l := l_l - 1
							end
						end
						l_break := False
						if l_l = 0 then
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) then
						l_rline[l_l] := (('%/0/').code).to_natural_8;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pc))
						if a_spin.item.si_conv.vc_type /= 0 then
							l_pc := (create {P_MBYTE_STATIC}).string_convert (create {CE_CLASS_POINTER [PD_VIMCONV_T]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_conv")), l_rline, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
							if l_pc.is_void then
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Conversion failure for word in %%s line %%d: %%s")))), a_fname, l_lnum, l_rline]).do_nothing
								l_continue := True
							end
							if not (l_return or l_break or l_continue) then
								l_line := l_pc
							end
						else
							l_pc := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							l_line := l_rline
						end
					end
					if not (l_return or l_break or l_continue) and then ((l_line.item).to_integer_32 = 47) then
						l_line := l_line + 1
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_line), ce_string ("encoding="), (9).to_natural_32)) = 0 then
							if a_spin.item.si_conv.vc_type /= 0 then
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Duplicate /encoding= line ignored in %%s line %%d: %%s")))), a_fname, l_lnum, l_line - 1]).do_nothing
							elseif l_did_word.to_boolean then
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("/encoding= line after word ignored in %%s line %%d: %%s")))), a_fname, l_lnum, l_line - 1]).do_nothing
							else
								l_line := l_line + (9)
								l_enc := (create {P_MBYTE_STATIC}).enc_canonize (l_line)
								if not l_enc.is_void then
									if not (a_spin.item.si_ascii).to_boolean then
										if ((create {CE_CLASS_POINTER [PD_VIMCONV_T]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_conv"))).item.convert_setup (l_enc, (create {P_OPTION_STATIC}).p_enc.item.item)) = 0 then
											(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Conversion in %%s not supported: from %%s to %%s")))), a_fname, l_line, (create {P_OPTION_STATIC}).p_enc.item.item]).do_nothing
										end
									end
								end
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_enc))
								a_spin.item.si_conv.vc_fail := 1
							end
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_line), ce_string ("regions="), (8).to_natural_32)) = 0 then
								if a_spin.item.si_region_count > 1 then
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Duplicate /regions= line ignored in %%s line %%d: %%s")))), a_fname, l_lnum, l_line]).do_nothing
								else
									l_line := l_line + (8)
									if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))) > {NATURAL_32} 16 then
										(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Too many regions in %%s line %%d: %%s")))), a_fname, l_lnum, l_line]).do_nothing
									else
										a_spin.item.si_region_count := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))).to_integer_32 // 2
										strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((a_spin.item.si_region_name)), create {CE_INTEGER_8_POINTER}.make_cast (l_line)).do_nothing
										a_spin.item.si_region := ((1).bit_shift_left (a_spin.item.si_region_count)) - 1
									end
								end
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("/ line ignored in %%s line %%d: %%s")))), a_fname, l_lnum, l_line - 1]).do_nothing
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) then
						l_flags___0 := 0
						l_regionmask := a_spin.item.si_region
						l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (l_line, ('/').code)
						if not l_p___0.is_void then
							l_tmp___14 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___14.item := (('%/0/').code).to_natural_8
							from
							until
								not (not (l_break) and then ((l_p___0.item).to_integer_32 /= 0))
							loop
								l_break := False
								if (l_p___0.item).to_integer_32 = 61 then
									l_flags___0 := (l_flags___0).bit_or ((192))
								elseif (l_p___0.item).to_integer_32 = 33 then
									l_flags___0 := (l_flags___0).bit_or ((16))
								elseif (l_p___0.item).to_integer_32 = 63 then
									l_flags___0 := (l_flags___0).bit_or ((8))
								elseif (l_p___0.item).to_integer_32 >= 48 then
									if (l_p___0.item).to_integer_32 <= 57 then
										if ((l_flags___0).bit_and (1)) = 0 then
											l_regionmask := 0
										end
										l_flags___0 := (l_flags___0).bit_or ((1))
										l_l := (l_p___0.item).to_integer_32 - 48
										if l_l > a_spin.item.si_region_count then
											(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Invalid region nr in %%s line %%d: %%s")))), a_fname, l_lnum, l_p___0]).do_nothing
											l_break := True
										end
										if not (l_break) then
											l_regionmask := (l_regionmask).bit_or (((1).bit_shift_left ((l_l - 1))))
										end
									else
										l_tmp___16 := gettext (ce_string ("Unrecognized flags in %%s line %%d: %%s"));
										(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___16), a_fname, l_lnum, l_p___0]).do_nothing
										l_break := True
									end
								else
									l_tmp___16 := gettext (ce_string ("Unrecognized flags in %%s line %%d: %%s"));
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___16), a_fname, l_lnum, l_p___0]).do_nothing
									l_break := True
								end
								if not (l_break) then
									l_p___0 := l_p___0 + 1
								end
							end
							l_break := False
						end
						if (a_spin.item.si_ascii).to_boolean then
							if (has_non_ascii (l_line)).to_boolean then
								l_non_ascii := l_non_ascii + 1
								l_continue := True
							end
						end
					end
					if not (l_return or l_break or l_continue) then
						if (a_spin.item.store_word (l_line, l_flags___0, l_regionmask, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0)) = 0 then
							l_retval := 0
							l_break := True
						end
					end
					if not (l_return or l_break or l_continue) then
						l_did_word := 1
					end
				end
				l_break := False
				l_continue := False;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pc))
				fclose (l_fd).do_nothing
				if (a_spin.item.si_ascii).to_boolean then
					if l_non_ascii > 0 then
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, (gettext (ce_string ("Ignored %%d words with non-ASCII characters"))), l_non_ascii]).do_nothing
						a_spin.item.spell_message ((create {P_GLOBALS_STATIC}).IObuff.item)
					end
				end
				Result := l_retval
			end
		end

	free_blocks (a_bl: CE_POINTER [PD_SBLOCK_S])
		local
			l_bl: CE_POINTER [PD_SBLOCK_S]
			l_next: CE_POINTER [PD_SBLOCK_S]
		do
			l_bl := a_bl
			from
			until
				l_bl.is_void
			loop
				l_next := l_bl.item.sb_next;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_bl))
				l_bl := l_next
			end
		end

	spell_check_msm: INTEGER_32
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_start___1: INTEGER_32
			l_incr: INTEGER_32
			l_added: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			l_p___0.item := (create {P_OPTION_STATIC}).p_msm.item.item
			l_start___1 := 0
			l_incr := 0
			l_added := 0
			if (l_p___0.item.item).to_integer_32 >= 48 then
				if not ((l_p___0.item.item).to_integer_32 <= 57) then
					Result := 0
					l_return := True
				end
			else
				Result := 0
				l_return := True
			end
			if not l_return then
				l_start___1 := (((create {P_CHARSET_STATIC}).getdigits (l_p___0)) * 10) // 156
				if (l_p___0.item.item).to_integer_32 /= 44 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_p___0.item := l_p___0.item + 1
				if (l_p___0.item.item).to_integer_32 >= 48 then
					if not ((l_p___0.item.item).to_integer_32 <= 57) then
						Result := 0
						l_return := True
					end
				else
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_incr := (((create {P_CHARSET_STATIC}).getdigits (l_p___0)) * 102) // 1_600
				if (l_p___0.item.item).to_integer_32 /= 44 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_p___0.item := l_p___0.item + 1
				if (l_p___0.item.item).to_integer_32 >= 48 then
					if not ((l_p___0.item.item).to_integer_32 <= 57) then
						Result := 0
						l_return := True
					end
				else
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_added := ((create {P_CHARSET_STATIC}).getdigits (l_p___0)) * 1_024
				if (l_p___0.item.item).to_integer_32 /= 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if l_start___1 = 0 then
					Result := 0
					l_return := True
				elseif l_incr = 0 then
					Result := 0
					l_return := True
				elseif l_added = 0 then
					Result := 0
					l_return := True
				elseif l_incr > l_start___1 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				compress_start.item := l_start___1
				compress_inc.item := l_incr
				compress_added.item := l_added
				Result := 1
			end
		end

	deref_wordnode (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_node: CE_POINTER [PD_WORDNODE_S]): INTEGER_32
		require
			not a_node.is_void
		local
			l_np: CE_POINTER [PD_WORDNODE_S]
			l_cnt: INTEGER_32
		do
			l_cnt := 0
			a_node.item.wn_refs := (a_node.item.wn_refs) - 1
			if a_node.item.wn_refs = 0 then
				l_np := a_node
				from
				until
					l_np.is_void
				loop
					if not (l_np.item.wn_child).is_void then
						l_cnt := l_cnt + (deref_wordnode (a_spin, l_np.item.wn_child))
					end
					a_spin.item.free_wordnode (l_np)
					l_cnt := l_cnt + 1
					l_np := l_np.item.wn_sibling
				end
				l_cnt := l_cnt + 1
			end
			Result := l_cnt
		end

	wordtree_compress (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_root: CE_POINTER [PD_WORDNODE_S])
		require
			not a_root.is_void
		local
			l_ht: CE_ARRAY [PD_HASHTABLE_S]
			l_n: INTEGER_32
			l_tot: CE_ARRAY [INTEGER_32]
			l_perc: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_HASHTABLE_S]} l_ht.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_tot.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tot.item := 0
					if (a_root.item.wn_sibling).is_void then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_ht.item.hash_init
						l_n := node_compress (a_spin, a_root.item.wn_sibling, l_ht, l_tot)
						if not ((a_spin.item.si_verbose).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not ((create {P_OPTION_STATIC}).p_verbose.item.item > 2) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if l_tot.item > 1_000_000 then
							l_perc := (l_tot.item - l_n) // (l_tot.item // 100)
						elseif l_tot.item = 0 then
							l_perc := 0
						else
							l_perc := ((l_tot.item - l_n) * 100) // l_tot.item
						end
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, (gettext (ce_string ("Compressed %%d of %%d nodes; %%d (%%d%%%%) remaining"))), l_n, l_tot.item, l_tot.item - l_n, l_perc]).do_nothing
						a_spin.item.spell_message ((create {P_GLOBALS_STATIC}).IObuff.item)
				when 6 then -- if done
						l_ht.item.hash_clear
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	node_compress (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_node: CE_POINTER [PD_WORDNODE_S]; a_ht: CE_POINTER [PD_HASHTABLE_S]; a_tot: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_node.is_void
			not a_tot.is_void
		local
			l_np: CE_POINTER [PD_WORDNODE_S]
			l_tp: CE_POINTER [PD_WORDNODE_S]
			l_child: CE_POINTER [PD_WORDNODE_S]
			l_hash: NATURAL_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_len: INTEGER_32
			l_nr: NATURAL_32
			l_n: NATURAL_32
			l_compressed: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_len := 0
			l_compressed := 0
			l_np := a_node
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if not l_np.is_void then
					if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_return or l_break) then
					l_len := l_len + 1
					l_child := l_np.item.wn_child
					if not l_child.is_void then
						l_compressed := l_compressed + (node_compress (a_spin, l_child, a_ht, a_tot))
						l_hash := (create {P_HASHTAB_STATIC}).hash_hash (l_child.item.wn_u1.hashkey)
						l_hi___1 := a_ht.item.hash_lookup (l_child.item.wn_u1.hashkey, l_hash)
						if (l_hi___1.item.hi_key).is_void then
							a_ht.item.hash_add_item (l_hi___1, l_child.item.wn_u1.hashkey, l_hash).do_nothing
						elseif (l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item) then
							a_ht.item.hash_add_item (l_hi___1, l_child.item.wn_u1.hashkey, l_hash).do_nothing
						else
							l_tp := create {CE_CLASS_POINTER [PD_WORDNODE_S]}.make_cast (l_hi___1.item.hi_key)
							from
							until
								not (not (l_break) and then (not l_tp.is_void))
							loop
								l_break := False
								if (node_equal (l_child, l_tp)).to_boolean then
									l_tp.item.wn_refs := (l_tp.item.wn_refs) + 1
									l_compressed := l_compressed + (deref_wordnode (a_spin, l_child))
									l_np.item.wn_child := l_tp
									l_break := True
								end
								if not (l_break) then
									l_tp := l_tp.item.wn_u2.next
								end
							end
							l_break := False
							if l_tp.is_void then
								l_tp := create {CE_CLASS_POINTER [PD_WORDNODE_S]}.make_cast (l_hi___1.item.hi_key)
								l_child.item.wn_u2.next := l_tp.item.wn_u2.next
								l_tp.item.wn_u2.next := l_child
							end
						end
					end
					l_np := l_np.item.wn_sibling
				end
			end
			l_break := False
			a_tot.item := a_tot.item + (l_len + 1)
			a_node.item.wn_u1.hashkey[0] := l_len.to_natural_8
			l_nr := {NATURAL_32} 0
			l_np := a_node
			from
			until
				l_np.is_void
			loop
				if (l_np.item.wn_byte).to_integer_32 = 0 then
					l_n := (((l_np.item.wn_flags).to_integer_32 + (((l_np.item.wn_region).to_integer_32).bit_shift_left (8))) + (((l_np.item.wn_affixID).to_integer_32).bit_shift_left (16))).to_natural_32
				else
					l_n := ((l_np.item.wn_byte).to_natural_32 + ((((l_np.item.wn_child).c_pointer.to_integer_32).to_natural_32).bit_shift_left (8))).to_natural_32
				end
				l_nr := l_nr * {NATURAL_32} 101 + l_n
				l_np := l_np.item.wn_sibling
			end
			l_n := (l_nr).bit_and ({NATURAL_32} 255)
			if l_n = {NATURAL_32} 0 then
				a_node.item.wn_u1.hashkey[1] := (1).to_natural_8
			else
				a_node.item.wn_u1.hashkey[1] := l_n.to_natural_8
			end
			l_n := (((l_nr).bit_shift_right (8))).bit_and ({NATURAL_32} 255)
			if l_n = {NATURAL_32} 0 then
				a_node.item.wn_u1.hashkey[2] := (1).to_natural_8
			else
				a_node.item.wn_u1.hashkey[2] := l_n.to_natural_8
			end
			l_n := (((l_nr).bit_shift_right (16))).bit_and ({NATURAL_32} 255)
			if l_n = {NATURAL_32} 0 then
				a_node.item.wn_u1.hashkey[3] := (1).to_natural_8
			else
				a_node.item.wn_u1.hashkey[3] := l_n.to_natural_8
			end
			l_n := (((l_nr).bit_shift_right (24))).bit_and ({NATURAL_32} 255)
			if l_n = {NATURAL_32} 0 then
				a_node.item.wn_u1.hashkey[4] := (1).to_natural_8
			else
				a_node.item.wn_u1.hashkey[4] := l_n.to_natural_8
			end
			a_node.item.wn_u1.hashkey[5] := (('%/0/').code).to_natural_8;
			(create {P_MISC1_STATIC}).fast_breakcheck
			Result := l_compressed
		end

	node_equal (a_n1, a_n2: CE_POINTER [PD_WORDNODE_S]): INTEGER_32
		local
			l_p1: CE_POINTER [PD_WORDNODE_S]
			l_p2: CE_POINTER [PD_WORDNODE_S]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_break: BOOLEAN
		do
			l_p1 := a_n1
			l_p2 := a_n2
			from
			until
				(l_break)
			loop
				l_break := False
				if not l_p1.is_void then
					if l_p2.is_void then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					if (l_p1.item.wn_byte).to_integer_32 /= (l_p2.item.wn_byte).to_integer_32 then
						l_break := True
					else
						if (l_p1.item.wn_byte).to_integer_32 = 0 then
							if (l_p1.item.wn_flags).to_integer_32 /= (l_p2.item.wn_flags).to_integer_32 then
								l_tmp := 1
							elseif (l_p1.item.wn_region).to_integer_32 /= (l_p2.item.wn_region).to_integer_32 then
								l_tmp := 1
							elseif (l_p1.item.wn_affixID).to_integer_32 /= (l_p2.item.wn_affixID).to_integer_32 then
								l_tmp := 1
							else
								l_tmp := 0
							end
							l_tmp___0 := l_tmp
						else
							l_tmp___0 := (not (l_p1.item.wn_child).is_equal (l_p2.item.wn_child)).to_integer
						end
						if l_tmp___0.to_boolean then
							l_break := True
						end
					end
				end
				if not (l_break) then
					l_p1 := l_p1.item.wn_sibling
					l_p2 := l_p2.item.wn_sibling
				end
			end
			l_break := False
			if l_p1.is_void then
				if l_p2.is_void then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	rep_compare (a_s1, a_s2: CE_POINTER [ANY]): INTEGER_32
		local
			l_p1: CE_POINTER [PD_FROMTO_S]
			l_p2: CE_POINTER [PD_FROMTO_S]
		do
			l_p1 := create {CE_CLASS_POINTER [PD_FROMTO_S]}.make_cast (a_s1)
			l_p2 := create {CE_CLASS_POINTER [PD_FROMTO_S]}.make_cast (a_s2)
			Result := (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p1.item.ft_from), create {CE_INTEGER_8_POINTER}.make_cast (l_p2.item.ft_from)))
		end

	write_vim_spell (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_regionmask: INTEGER_32
			l_round: INTEGER_32
			l_tree: CE_POINTER [PD_WORDNODE_S]
			l_nodecount: INTEGER_32
			l_i___0: INTEGER_32
			l_l: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_ftp: CE_POINTER [PD_FROMTO_S]
			l_p___0: CE_POINTER [NATURAL_8]
			l_rr: INTEGER_32
			l_retval: INTEGER_32
			l_fwv: NATURAL_32
			l_folchars: CE_ARRAY [NATURAL_8]
			l_flags___0: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___9: INTEGER_32
			l_todo: INTEGER_32
			l_len: INTEGER_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [PD_GROWARRAY]} l_gap.make
			create {CE_NATURAL_8_ARRAY} l_folchars.make (<<1_024>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := 1
					l_fwv := (1).to_natural_32
					l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (a_fname), ce_string ("w"))
					if l_fd.is_void then
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_notopen.item))))), a_fname).do_nothing
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						l_fwv := (l_fwv).bit_and ((fwrite (create {CE_VOID_POINTER}.make_cast (ce_string ("VIMspell")), (8).to_natural_32, (1).to_natural_32, l_fd)))
						if l_fwv /= {NATURAL_32} 1 then
							l_pos := -1 + 3 -- goto theend
						end
				when 2 then
						IO_putc (50, l_fd).do_nothing
						if not (a_spin.item.si_info).is_void then
							IO_putc (15, l_fd).do_nothing
							IO_putc (0, l_fd).do_nothing
							l_i___0 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_spin.item.si_info))).to_integer_32;
							(create {P_MISC2_STATIC}).put_bytes (l_fd, l_i___0.to_natural_32, 4).do_nothing
							l_fwv := (l_fwv).bit_and ((fwrite (create {CE_VOID_POINTER}.make_cast (a_spin.item.si_info), l_i___0.to_natural_32, (1).to_natural_32, l_fd)))
						end
						if a_spin.item.si_region_count > 1 then
							IO_putc (0, l_fd).do_nothing
							IO_putc (1, l_fd).do_nothing
							l_l := a_spin.item.si_region_count * 2;
							(create {P_MISC2_STATIC}).put_bytes (l_fd, l_l.to_natural_32, 4).do_nothing
							l_fwv := (l_fwv).bit_and ((fwrite (create {CE_VOID_POINTER}.make_cast ((a_spin.item.si_region_name)), l_l.to_natural_32, (1).to_natural_32, l_fd)))
							l_regionmask := ((1).bit_shift_left (a_spin.item.si_region_count)) - 1
						else
							l_regionmask := 0
						end
						if not (a_spin.item.si_ascii).to_boolean then
							if not (a_spin.item.si_add).to_boolean then
								IO_putc (1, l_fd).do_nothing
								IO_putc (1, l_fd).do_nothing
								l_l := 0
								l_i___0 := 128
								from
								until
									not (l_i___0 < 256)
								loop
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_l := l_l + ((create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([(spelltab.item.item.st_fold[l_i___0]).to_integer_32, l_folchars + l_l]))
									else
										l_tmp___5 := l_l
										l_l := l_l + 1
										l_folchars[l_tmp___5] := spelltab.item.item.st_fold[l_i___0]
									end
									l_i___0 := l_i___0 + 1
								end
								(create {P_MISC2_STATIC}).put_bytes (l_fd, (131 + l_l).to_natural_32, 4).do_nothing
								fputc (128, l_fd).do_nothing
								l_i___0 := 128
								from
								until
									not (l_i___0 < 256)
								loop
									l_flags___0 := 0
									if (spelltab.item.item.st_isw[l_i___0]).to_boolean then
										l_flags___0 := (l_flags___0).bit_or ((1))
									end
									if (spelltab.item.item.st_isu[l_i___0]).to_boolean then
										l_flags___0 := (l_flags___0).bit_or ((2))
									end
									fputc (l_flags___0, l_fd).do_nothing
									l_i___0 := l_i___0 + 1
								end
								(create {P_MISC2_STATIC}).put_bytes (l_fd, l_l.to_natural_32, 2).do_nothing
								l_fwv := (l_fwv).bit_and ((fwrite (create {CE_VOID_POINTER}.make_cast (l_folchars), l_l.to_natural_32, (1).to_natural_32, l_fd)))
							end
						end
						if not (a_spin.item.si_midword).is_void then
							IO_putc (2, l_fd).do_nothing
							IO_putc (1, l_fd).do_nothing
							l_i___0 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_spin.item.si_midword))).to_integer_32;
							(create {P_MISC2_STATIC}).put_bytes (l_fd, l_i___0.to_natural_32, 4).do_nothing
							l_fwv := (l_fwv).bit_and ((fwrite (create {CE_VOID_POINTER}.make_cast (a_spin.item.si_midword), l_i___0.to_natural_32, (1).to_natural_32, l_fd)))
						end
						if a_spin.item.si_prefcond.ga_len > 0 then
							IO_putc (3, l_fd).do_nothing
							IO_putc (1, l_fd).do_nothing
							l_l := (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_prefcond"))).item.write_spell_prefcond (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer));
							(create {P_MISC2_STATIC}).put_bytes (l_fd, l_l.to_natural_32, 4).do_nothing;
							(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_prefcond"))).item.write_spell_prefcond (l_fd).do_nothing
						end
						l_round := 1
						from
						until
							not (not (l_return) and then (l_round <= 3))
						loop
							l_continue := False
							if l_round = 1 then
								l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_rep"))
							elseif l_round = 2 then
								if not (a_spin.item.si_sofofr).is_void then
									if not (a_spin.item.si_sofoto).is_void then
										l_continue := True
									end
								end
								if not (l_return or l_continue) then
									l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_sal"))
								end
							else
								l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_spin.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_repsal"))
							end
							if not (l_return or l_continue) and then (l_gap.item.ga_len = 0) then
								l_continue := True
							end
							if not (l_return or l_continue) then
								if l_round /= 2 then
									qsort (l_gap.item.ga_data, (l_gap.item.ga_len).to_natural_32, (create {PD_FROMTO_S}.make).structure_size.to_natural_32, rep_compare_address)
								end
								if l_round = 1 then
									l_i___0 := 4
								else
									if l_round = 2 then
										l_tmp___9 := 5
									else
										l_tmp___9 := 12
									end
									l_i___0 := l_tmp___9
								end
								IO_putc (l_i___0, l_fd).do_nothing
								IO_putc (0, l_fd).do_nothing
								l_l := 2
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_gap.item.ga_len)
								loop
									l_ftp := create {CE_CLASS_POINTER [PD_FROMTO_S]}.make_cast (l_gap.item.ga_data) + l_i___0
									l_l := l_l + (1 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ftp.item.ft_from))).to_integer_32)
									l_l := l_l + (1 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ftp.item.ft_to))).to_integer_32)
									l_i___0 := l_i___0 + 1
								end
								if l_round = 2 then
									l_l := l_l + 1
								end
								(create {P_MISC2_STATIC}).put_bytes (l_fd, l_l.to_natural_32, 4).do_nothing
								if l_round = 2 then
									l_i___0 := 0
									if (a_spin.item.si_followup).to_boolean then
										l_i___0 := (l_i___0).bit_or ((1))
									end
									if (a_spin.item.si_collapse).to_boolean then
										l_i___0 := (l_i___0).bit_or ((2))
									end
									if (a_spin.item.si_rem_accents).to_boolean then
										l_i___0 := (l_i___0).bit_or ((4))
									end
									IO_putc (l_i___0, l_fd).do_nothing
								end
								(create {P_MISC2_STATIC}).put_bytes (l_fd, (l_gap.item.ga_len).to_natural_32, 2).do_nothing
								l_i___0 := 0
								from
								until
									not (not (l_return) and then (l_i___0 < l_gap.item.ga_len))
								loop
									l_ftp := create {CE_CLASS_POINTER [PD_FROMTO_S]}.make_cast (l_gap.item.ga_data) + l_i___0
									l_rr := 1
									from
									until
										not (l_rr <= 2)
									loop
										if l_rr = 1 then
											l_p___0 := l_ftp.item.ft_from
										else
											l_p___0 := l_ftp.item.ft_to
										end
										l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32
										IO_putc (l_l, l_fd).do_nothing
										if l_l > 0 then
											l_fwv := (l_fwv).bit_and ((fwrite (create {CE_VOID_POINTER}.make_cast (l_p___0), l_l.to_natural_32, (1).to_natural_32, l_fd)))
										end
										l_rr := l_rr + 1
									end
									l_i___0 := l_i___0 + 1
								end
							end
							if (not l_return) then
								l_round := l_round + 1
							end
						end
						l_continue := False
						if not (a_spin.item.si_sofofr).is_void then
							if not (a_spin.item.si_sofoto).is_void then
								IO_putc (6, l_fd).do_nothing
								IO_putc (0, l_fd).do_nothing
								l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_spin.item.si_sofofr))).to_integer_32;
								(create {P_MISC2_STATIC}).put_bytes (l_fd, ((l_l.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_spin.item.si_sofoto)))) + {NATURAL_32} 4).to_natural_32, 4).do_nothing;
								(create {P_MISC2_STATIC}).put_bytes (l_fd, l_l.to_natural_32, 2).do_nothing
								l_fwv := (l_fwv).bit_and ((fwrite (create {CE_VOID_POINTER}.make_cast (a_spin.item.si_sofofr), l_l.to_natural_32, (1).to_natural_32, l_fd)))
								l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_spin.item.si_sofoto))).to_integer_32;
								(create {P_MISC2_STATIC}).put_bytes (l_fd, l_l.to_natural_32, 2).do_nothing
								l_fwv := (l_fwv).bit_and ((fwrite (create {CE_VOID_POINTER}.make_cast (a_spin.item.si_sofoto), l_l.to_natural_32, (1).to_natural_32, l_fd)))
							end
						end
						if a_spin.item.si_commonwords.ht_used > {NATURAL_32} 0 then
							IO_putc (13, l_fd).do_nothing
							IO_putc (0, l_fd).do_nothing
							l_round := 1
							from
							until
								not (not (l_return) and then (l_round <= 2))
							loop
								l_len := 0
								l_todo := (a_spin.item.si_commonwords.ht_used).to_integer_32
								l_hi___1 := a_spin.item.si_commonwords.ht_array
								from
								until
									not (l_todo > 0)
								loop
									if not ((l_hi___1.item.hi_key).is_void) then
										if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
											l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_hi___1.item.hi_key))).to_integer_32 + 1
											l_len := l_len + l_l
											if l_round = 2 then
												l_fwv := (l_fwv).bit_and ((fwrite (create {CE_VOID_POINTER}.make_cast (l_hi___1.item.hi_key), l_l.to_natural_32, (1).to_natural_32, l_fd)))
											end
											l_todo := l_todo - 1
										end
									end
									l_hi___1 := l_hi___1 + 1
								end
								if l_round = 1 then
									(create {P_MISC2_STATIC}).put_bytes (l_fd, l_len.to_natural_32, 4).do_nothing
								end
								l_round := l_round + 1
							end
						end
						if a_spin.item.si_map.ga_len > 0 then
							IO_putc (7, l_fd).do_nothing
							IO_putc (0, l_fd).do_nothing
							l_l := a_spin.item.si_map.ga_len;
							(create {P_MISC2_STATIC}).put_bytes (l_fd, l_l.to_natural_32, 4).do_nothing
							l_fwv := (l_fwv).bit_and ((fwrite (a_spin.item.si_map.ga_data, l_l.to_natural_32, (1).to_natural_32, l_fd)))
						end
						if not (a_spin.item.si_nosugfile).to_boolean then
							if a_spin.item.si_sal.ga_len > 0 then
								IO_putc (11, l_fd).do_nothing
								IO_putc (0, l_fd).do_nothing;
								(create {P_MISC2_STATIC}).put_bytes (l_fd, (8).to_natural_32, 4).do_nothing
								a_spin.item.si_sugtime := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer));
								(create {P_MISC2_STATIC}).put_time (l_fd, a_spin.item.si_sugtime)
							elseif not (a_spin.item.si_sofofr).is_void then
								if not (a_spin.item.si_sofoto).is_void then
									IO_putc (11, l_fd).do_nothing
									IO_putc (0, l_fd).do_nothing;
									(create {P_MISC2_STATIC}).put_bytes (l_fd, (8).to_natural_32, 4).do_nothing
									a_spin.item.si_sugtime := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer));
									(create {P_MISC2_STATIC}).put_time (l_fd, a_spin.item.si_sugtime)
								end
							end
						end
						if (a_spin.item.si_nosplitsugs).to_boolean then
							IO_putc (14, l_fd).do_nothing
							IO_putc (0, l_fd).do_nothing;
							(create {P_MISC2_STATIC}).put_bytes (l_fd, (0).to_natural_32, 4).do_nothing
						end
						if not (a_spin.item.si_compflags).is_void then
							IO_putc (8, l_fd).do_nothing
							IO_putc (0, l_fd).do_nothing
							l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_spin.item.si_compflags))).to_integer_32
							l_i___0 := 0
							from
							until
								not (l_i___0 < a_spin.item.si_comppat.ga_len)
							loop
								l_l := l_l + ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (a_spin.item.si_comppat.ga_data)[l_i___0]))).to_integer_32 + 1)
								l_i___0 := l_i___0 + 1
							end
							(create {P_MISC2_STATIC}).put_bytes (l_fd, (l_l + 7).to_natural_32, 4).do_nothing
							IO_putc (a_spin.item.si_compmax, l_fd).do_nothing
							IO_putc (a_spin.item.si_compminlen, l_fd).do_nothing
							IO_putc (a_spin.item.si_compsylmax, l_fd).do_nothing
							IO_putc (0, l_fd).do_nothing
							IO_putc (a_spin.item.si_compoptions, l_fd).do_nothing;
							(create {P_MISC2_STATIC}).put_bytes (l_fd, (a_spin.item.si_comppat.ga_len).to_natural_32, 2).do_nothing
							l_i___0 := 0
							from
							until
								not (l_i___0 < a_spin.item.si_comppat.ga_len)
							loop
								l_p___0 := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (a_spin.item.si_comppat.ga_data)[l_i___0]
								IO_putc ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32, l_fd).do_nothing
								l_fwv := (l_fwv).bit_and ((fwrite (create {CE_VOID_POINTER}.make_cast (l_p___0), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))), (1).to_natural_32, l_fd)))
								l_i___0 := l_i___0 + 1
							end
							l_fwv := (l_fwv).bit_and ((fwrite (create {CE_VOID_POINTER}.make_cast (a_spin.item.si_compflags), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_spin.item.si_compflags))), (1).to_natural_32, l_fd)))
						end
						if (a_spin.item.si_nobreak).to_boolean then
							IO_putc (10, l_fd).do_nothing
							IO_putc (0, l_fd).do_nothing;
							(create {P_MISC2_STATIC}).put_bytes (l_fd, (0).to_natural_32, 4).do_nothing
						end
						if not (a_spin.item.si_syllable).is_void then
							IO_putc (9, l_fd).do_nothing
							IO_putc (0, l_fd).do_nothing
							l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_spin.item.si_syllable))).to_integer_32;
							(create {P_MISC2_STATIC}).put_bytes (l_fd, l_l.to_natural_32, 4).do_nothing
							l_fwv := (l_fwv).bit_and ((fwrite (create {CE_VOID_POINTER}.make_cast (a_spin.item.si_syllable), l_l.to_natural_32, (1).to_natural_32, l_fd)))
						end
						IO_putc (255, l_fd).do_nothing
						a_spin.item.si_memtot := 0
						l_round := 1
						from
						until
							not (l_round <= 3)
						loop
							if l_round = 1 then
								l_tree := (a_spin.item.si_foldroot).item.wn_sibling
							elseif l_round = 2 then
								l_tree := (a_spin.item.si_keeproot).item.wn_sibling
							else
								l_tree := (a_spin.item.si_prefroot).item.wn_sibling
							end
							clear_node (l_tree)
							l_nodecount := put_node (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer), l_tree, 0, l_regionmask, (l_round = 3).to_integer);
							(create {P_MISC2_STATIC}).put_bytes (l_fd, l_nodecount.to_natural_32, 4).do_nothing
							a_spin.item.si_memtot := ((a_spin.item.si_memtot).to_natural_32 + (l_nodecount.to_natural_32 + l_nodecount.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)).to_integer_32
							put_node (l_fd, l_tree, 0, l_regionmask, (l_round = 3).to_integer).do_nothing
							l_round := l_round + 1
						end
						if (IO_putc (0, l_fd)) = -1 then
							l_retval := 0
						end
				when 3 then -- theend:
						if (fclose (l_fd)) = -1 then
							l_retval := 0
						end
						if l_fwv /= {NATURAL_32} 1 then
							l_retval := 0
						end
						if l_retval = 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_write.item)))))).do_nothing
						end
						Result := l_retval
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clear_node (a_node: CE_POINTER [PD_WORDNODE_S])
		local
			l_np: CE_POINTER [PD_WORDNODE_S]
		do
			if not a_node.is_void then
				l_np := a_node
				from
				until
					l_np.is_void
				loop
					l_np.item.wn_u1.index := 0
					l_np.item.wn_u2.wnode := create {CE_CLASS_POINTER [PD_WORDNODE_S]}.make_shared (default_pointer)
					if (l_np.item.wn_byte).to_integer_32 /= 0 then
						clear_node (l_np.item.wn_child)
					end
					l_np := l_np.item.wn_sibling
				end
			end
		end

	put_node (a_fd: CE_POINTER [SD_IO_FILE]; a_node: CE_POINTER [PD_WORDNODE_S]; a_idx, a_regionmask, a_prefixtree: INTEGER_32): INTEGER_32
		local
			l_newindex: INTEGER_32
			l_siblingcount: INTEGER_32
			l_np: CE_POINTER [PD_WORDNODE_S]
			l_flags___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_newindex := a_idx
					l_siblingcount := 0
					if a_node.is_void then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						a_node.item.wn_u1.index := a_idx
						l_np := a_node
						from
						until
							l_np.is_void
						loop
							l_siblingcount := l_siblingcount + 1
							l_np := l_np.item.wn_sibling
						end
						if not a_fd.is_void then
							IO_putc (l_siblingcount, a_fd).do_nothing
						end
						l_np := a_node
				when 2 then -- loop condition:
						if not (not (l_return) and then (not l_np.is_void)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						if (l_np.item.wn_byte).to_integer_32 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not a_fd.is_void then
							if a_prefixtree.to_boolean then
								if (l_np.item.wn_flags).to_integer_32 = 65_280 then
									IO_putc (0, a_fd).do_nothing
								else
									IO_putc (2, a_fd).do_nothing
									IO_putc ((l_np.item.wn_flags).to_integer_32, a_fd).do_nothing
								end
								IO_putc ((l_np.item.wn_affixID).to_integer_32, a_fd).do_nothing;
								(create {P_MISC2_STATIC}).put_bytes (a_fd, (l_np.item.wn_region).to_natural_32, 2).do_nothing
							else
								l_flags___0 := (l_np.item.wn_flags).to_integer_32
								if a_regionmask /= 0 then
									if (l_np.item.wn_region).to_integer_32 /= a_regionmask then
										l_flags___0 := (l_flags___0).bit_or ((1))
									end
								end
								if (l_np.item.wn_affixID).to_integer_32 /= 0 then
									l_flags___0 := (l_flags___0).bit_or ((32))
								end
								if l_flags___0 = 0 then
									IO_putc (0, a_fd).do_nothing
								else
									if (l_np.item.wn_flags).to_integer_32 >= 256 then
										IO_putc (3, a_fd).do_nothing
										IO_putc (l_flags___0, a_fd).do_nothing
										IO_putc (((l_flags___0.to_natural_32).bit_shift_right (8)).to_integer_32, a_fd).do_nothing
									else
										IO_putc (2, a_fd).do_nothing
										IO_putc (l_flags___0, a_fd).do_nothing
									end
									if ((l_flags___0).bit_and (1)).to_boolean then
										IO_putc ((l_np.item.wn_region).to_integer_32, a_fd).do_nothing
									end
									if ((l_flags___0).bit_and (32)).to_boolean then
										IO_putc ((l_np.item.wn_affixID).to_integer_32, a_fd).do_nothing
									end
								end
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if (l_np.item.wn_child).item.wn_u1.index = 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if not ((l_np.item.wn_child).item.wn_u2.wnode).is_equal (a_node) then
							if not a_fd.is_void then
								IO_putc (1, a_fd).do_nothing;
								(create {P_MISC2_STATIC}).put_bytes (a_fd, ((l_np.item.wn_child).item.wn_u1.index).to_natural_32, 3).do_nothing
							end
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if ((l_np.item.wn_child).item.wn_u2.wnode).is_void then
							(l_np.item.wn_child).item.wn_u2.wnode := a_node
						end
				when 10 then
						if not a_fd.is_void then
							if (IO_putc ((l_np.item.wn_byte).to_integer_32, a_fd)) = -1 then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_write.item)))))).do_nothing
								Result := 0
								l_return := True
							end
						end
				when 11 then -- if done
						if not l_return then
							l_np := l_np.item.wn_sibling
						end
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- loop done | if done
					if not l_return then
						l_newindex := l_newindex + (l_siblingcount + 1)
						l_np := a_node
						from
						until
							l_np.is_void
						loop
							if (l_np.item.wn_byte).to_integer_32 /= 0 then
								if ((l_np.item.wn_child).item.wn_u2.wnode).is_equal (a_node) then
									l_newindex := put_node (a_fd, l_np.item.wn_child, l_newindex, a_regionmask, a_prefixtree)
								end
							end
							l_np := l_np.item.wn_sibling
						end
						Result := l_newindex
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_make_sugfile (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_wfname: CE_POINTER [NATURAL_8])
		local
			l_fname: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
			l_free_slang: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_fname.make (<<4_096>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_free_slang := 0
					l_slang := first_lang.item
					from
					until
						not (not (l_break) and then (not l_slang.is_void))
					loop
						l_break := False
						if ((create {P_MISC1_STATIC}).fullpathcmp (a_wfname, l_slang.item.sl_fname, 0)) = 1 then
							l_break := True
						end
						if not (l_break) then
							l_slang := l_slang.item.sl_next
						end
					end
					l_break := False
					if l_slang.is_void then
						a_spin.item.spell_message (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Reading back spell file...")))))
						l_slang := spell_load_file (a_wfname, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (default_pointer), 0)
						if l_slang.is_void then
							l_return := True
						end
						if not l_return then
							l_free_slang := 1
						end
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						a_spin.item.si_blocks := create {CE_CLASS_POINTER [PD_SBLOCK_S]}.make_shared (default_pointer)
						a_spin.item.si_blocks_cnt := 0
						a_spin.item.si_compress_cnt := 0
						a_spin.item.si_free_count := 0
						a_spin.item.si_first_free := create {CE_CLASS_POINTER [PD_WORDNODE_S]}.make_shared (default_pointer)
						a_spin.item.si_foldwcount := 0
						a_spin.item.spell_message (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Performing soundfolding...")))))
						if (a_spin.item.sug_filltree (l_slang)) = 0 then
							l_pos := -1 + 4 -- goto theend
						end
				when 2 then
						if (a_spin.item.sug_maketable) = 0 then
							l_pos := -1 + 4 -- goto theend
						end
				when 3 then;
						(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Number of words after soundfolding: %%ld")))), (a_spin.item.si_spellbuf).item.b_ml.ml_line_count]).do_nothing
						a_spin.item.spell_message (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (msg_compressing.item))))
						wordtree_compress (a_spin, a_spin.item.si_foldroot)
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), create {CE_INTEGER_8_POINTER}.make_cast (a_wfname)).do_nothing
						l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fname))).to_integer_32
						l_fname[l_len - 2] := (('u').code).to_natural_8
						l_fname[l_len - 1] := (('g').code).to_natural_8
						sug_write (a_spin, l_fname)
				when 4 then -- theend:
						if l_free_slang.to_boolean then
							l_slang.item.slang_free
						end
						free_blocks (a_spin.item.si_blocks)
						close_spellbuf (a_spin.item.si_spellbuf)
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	sug_write (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_fname: CE_POINTER [NATURAL_8])
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_tree: CE_POINTER [PD_WORDNODE_S]
			l_nodecount: INTEGER_32
			l_wcount: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_len: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (a_fname), ce_string ("w"))
					if l_fd.is_void then
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_notopen.item))))), a_fname).do_nothing
						l_return := True
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:;
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, (gettext (ce_string ("Writing suggestion file %%s ..."))), a_fname]).do_nothing
						a_spin.item.spell_message ((create {P_GLOBALS_STATIC}).IObuff.item)
						if (fwrite (create {CE_VOID_POINTER}.make_cast (ce_string ("VIMsug")), (6).to_natural_32, (1).to_natural_32, l_fd)) /= {NATURAL_32} 1 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_write.item)))))).do_nothing
							l_pos := -1 + 7 -- goto theend
						end
				when 2 then
						IO_putc (1, l_fd).do_nothing;
						(create {P_MISC2_STATIC}).put_time (l_fd, a_spin.item.si_sugtime)
						a_spin.item.si_memtot := 0
						l_tree := (a_spin.item.si_foldroot).item.wn_sibling
						clear_node (l_tree)
						l_nodecount := put_node (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer), l_tree, 0, 0, 0);
						(create {P_MISC2_STATIC}).put_bytes (l_fd, l_nodecount.to_natural_32, 4).do_nothing
						a_spin.item.si_memtot := ((a_spin.item.si_memtot).to_natural_32 + (l_nodecount.to_natural_32 + l_nodecount.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)).to_integer_32
						put_node (l_fd, l_tree, 0, 0, 0).do_nothing
						l_wcount := ((a_spin.item.si_spellbuf).item.b_ml.ml_line_count).to_integer_32;
						(create {P_MISC2_STATIC}).put_bytes (l_fd, l_wcount.to_natural_32, 4).do_nothing
						l_lnum := (1).to_integer_32
				when 3 then -- loop condition:
						if not (l_lnum <= l_wcount.to_integer_32) then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						l_line := (a_spin.item.si_spellbuf).item.ml_get_buf (l_lnum, 0)
						l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))).to_integer_32 + 1
						if (fwrite (create {CE_VOID_POINTER}.make_cast (l_line), l_len.to_natural_32, (1).to_natural_32, l_fd)) = {NATURAL_32} 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_write.item)))))).do_nothing
							l_pos := -1 + 7 -- goto theend
						end
				when 5 then
						a_spin.item.si_memtot := a_spin.item.si_memtot + l_len
						l_lnum := l_lnum + 1
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						if (IO_putc (0, l_fd)) = -1 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_write.item)))))).do_nothing
						end
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, (gettext (ce_string ("Estimated runtime memory use: %%d bytes"))), a_spin.item.si_memtot]).do_nothing
						a_spin.item.spell_message ((create {P_GLOBALS_STATIC}).IObuff.item)
				when 7 then -- theend:
						fclose (l_fd).do_nothing
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	open_spellbuf: CE_POINTER [PD_FILE_BUFFER]
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
		do
			l_buf___6 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_cast (((create {P_MISC2_STATIC}).alloc_clear ((create {PD_FILE_BUFFER}.make).structure_size.to_natural_32)))
			if not l_buf___6.is_void then
				l_buf___6.item.b_spell := 1
				l_buf___6.item.b_p_swf := 1
				l_buf___6.item.ml_open.do_nothing
				l_buf___6.item.ml_open_file
			end
			Result := l_buf___6
		end

	close_spellbuf (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		do
			if not a_buf___6.is_void then
				a_buf___6.item.ml_close (1);
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_buf___6))
			end
		end

	mkspell (a_fcount: INTEGER_32; a_fnames: CE_POINTER [CE_POINTER [NATURAL_8]]; a_ascii, a_overwrite, a_added_word: INTEGER_32)
		local
			l_fname: CE_ARRAY [NATURAL_8]
			l_wfname: CE_ARRAY [NATURAL_8]
			l_innames: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_incount: INTEGER_32
			l_afile: CE_ARRAY [CE_POINTER [PD_AFFFILE_S]]
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_st: CE_ARRAY [SD_STAT]
			l_error: INTEGER_32
			l_spin: CE_ARRAY [PD_SPELLINFO_S]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___18: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_fname.make (<<4_096>>)
			create {CE_NATURAL_8_ARRAY} l_wfname.make (<<4_096>>)
			create {CE_POINTER_ARRAY [PD_AFFFILE_S]} l_afile.make (<<8>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_SPELLINFO_S]} l_spin.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_error := 0
					memset (create {CE_VOID_POINTER}.make_cast (l_spin), 0, (create {PD_SPELLINFO_S}.make).structure_size.to_natural_32).do_nothing
					l_spin.item.si_verbose := (not a_added_word.to_boolean).to_integer
					l_spin.item.si_ascii := a_ascii
					l_spin.item.si_followup := 1
					l_spin.item.si_rem_accents := 1;
					(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_rep"))).item.ga_init2 (((create {PD_FROMTO_S}.make).structure_size.to_natural_32).to_integer_32, 20);
					(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_repsal"))).item.ga_init2 (((create {PD_FROMTO_S}.make).structure_size.to_natural_32).to_integer_32, 20);
					(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_sal"))).item.ga_init2 (((create {PD_FROMTO_S}.make).structure_size.to_natural_32).to_integer_32, 20);
					(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_map"))).item.ga_init2 (({PLATFORM}.Natural_8_bytes.to_natural_32).to_integer_32, 100);
					(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_comppat"))).item.ga_init2 (({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 20);
					(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_prefcond"))).item.ga_init2 (({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 50);
					(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_commonwords"))).item.hash_init
					l_spin.item.si_newcompID := 127
					l_innames := a_fnames + 1
					l_incount := a_fcount - 1
					if not (a_fcount >= 1) then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_fnames[0]))).to_integer_32
						if a_fcount /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_len > 4 then
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (((a_fnames[0] + l_len) - 4)), ce_string (".add"))) = 0 then
								l_innames := a_fnames + 0
								l_incount := 1;
								(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_wfname), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32), ce_string ("%%s.spl"), a_fnames[0]]).do_nothing
							else
								l_pos := -1 + 4 -- goto _L___1
							end
						else
							l_pos := -1 + 4 -- goto _L___1
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else: | _L___1:
						if a_fcount /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_innames := a_fnames + 0
						l_incount := 1
						if (l_spin.item.si_ascii).to_boolean then
							l_tmp___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ascii"))
						else
							l_tmp___1 := (spell_enc)
						end
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_wfname), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32), ce_string ("%%s.%%s.spl"), a_fnames[0], l_tmp___1]).do_nothing
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if not (l_len > 4) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (((a_fnames[0] + l_len) - 4)), ce_string (".spl"))) = 0 then
							(create {P_MISC2_STATIC}).vim_strncpy (l_wfname, a_fnames[0], ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32) - {NATURAL_32} 1)
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if (l_spin.item.si_ascii).to_boolean then
							l_tmp___3 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ascii"))
						else
							l_tmp___3 := (spell_enc)
						end
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_wfname), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32), ce_string ("%%s.%%s.spl"), a_fnames[0], l_tmp___3]).do_nothing
				when 11 then -- if done | if done
						if not (strstr (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC1_STATIC}).gettail (l_wfname))), ce_string (".ascii."))).is_void then
							l_spin.item.si_ascii := 1
						end
						if not (strstr (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC1_STATIC}).gettail (l_wfname))), ce_string (".add."))).is_void then
							l_spin.item.si_add := 1
						end
				when 12 then -- if done
					if l_incount <= 0 then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_invarg.item)))))).do_nothing
					elseif not ((create {P_MISC2_STATIC}).vim_strchr (((create {P_MISC1_STATIC}).gettail (l_wfname)), ('_').code)).is_void then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E751: Output file name must not have region name"))))).do_nothing
					elseif l_incount > 8 then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E754: Only up to 8 regions supported"))))).do_nothing
					else
						if not a_overwrite.to_boolean then
							if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_wfname), l_st)) >= 0 then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_exists.item)))))).do_nothing
								l_return := True
							end
						end
						if not l_return then
							if ((create {P_OS_UNIX_STATIC}).mch_isdir (l_wfname)).to_boolean then
								(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_isadir2.item))))), l_wfname).do_nothing
								l_return := True
							end
						end
						if not l_return then
							l_i___0 := 0
							from
							until
								not (not (l_return) and then (l_i___0 < l_incount))
							loop
								l_afile[l_i___0] := create {CE_CLASS_POINTER [PD_AFFFILE_S]}.make_shared (default_pointer)
								if l_incount > 1 then
									l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_innames[l_i___0]))).to_integer_32
									if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC1_STATIC}).gettail (l_innames[l_i___0]))))) < {NATURAL_32} 5 then
										l_tmp___18 := gettext (ce_string ("E755: Invalid region in %%s"));
										(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___18), l_innames[l_i___0]).do_nothing
										l_return := True
									elseif ((l_innames[l_i___0])[(l_len - 3)]).to_integer_32 /= 95 then
										l_tmp___18 := gettext (ce_string ("E755: Invalid region in %%s"));
										(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___18), l_innames[l_i___0]).do_nothing
										l_return := True
									end
									if not l_return then
										if ((l_innames[l_i___0])[(l_len - 2)]).to_integer_32 < 65 then
											l_spin.item.si_region_name[l_i___0 * 2] := (l_innames[l_i___0])[(l_len - 2)]
										elseif ((l_innames[l_i___0])[(l_len - 2)]).to_integer_32 > 90 then
											l_spin.item.si_region_name[l_i___0 * 2] := (l_innames[l_i___0])[(l_len - 2)]
										else
											l_spin.item.si_region_name[l_i___0 * 2] := (((l_innames[l_i___0])[(l_len - 2)]).to_integer_32 + 32).to_natural_8
										end
										if ((l_innames[l_i___0])[(l_len - 1)]).to_integer_32 < 65 then
											l_spin.item.si_region_name[l_i___0 * 2 + 1] := (l_innames[l_i___0])[(l_len - 1)]
										elseif ((l_innames[l_i___0])[(l_len - 1)]).to_integer_32 > 90 then
											l_spin.item.si_region_name[l_i___0 * 2 + 1] := (l_innames[l_i___0])[(l_len - 1)]
										else
											l_spin.item.si_region_name[l_i___0 * 2 + 1] := (((l_innames[l_i___0])[(l_len - 1)]).to_integer_32 + 32).to_natural_8
										end
									end
								end
								if not l_return then
									l_i___0 := l_i___0 + 1
								end
							end
						end
						if not l_return then
							l_spin.item.si_region_count := l_incount
							l_spin.item.si_foldroot := l_spin.item.wordtree_alloc
							l_spin.item.si_keeproot := l_spin.item.wordtree_alloc
							l_spin.item.si_prefroot := l_spin.item.wordtree_alloc
							if (l_spin.item.si_foldroot).is_void then
								free_blocks (l_spin.item.si_blocks)
								l_return := True
							elseif (l_spin.item.si_keeproot).is_void then
								free_blocks (l_spin.item.si_blocks)
								l_return := True
							elseif (l_spin.item.si_prefroot).is_void then
								free_blocks (l_spin.item.si_blocks)
								l_return := True
							end
						end
						if not l_return then
							if not (l_spin.item.si_add).to_boolean then
								l_spin.item.si_clear_chartab := 1
							end
							l_i___0 := 0
							from
							until
								(l_break)
							loop
								l_break := False
								if l_i___0 < l_incount then
									if l_error.to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_spin.item.si_conv.vc_type := 0
									l_spin.item.si_region := (1).bit_shift_left (l_i___0);
									(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_fname), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32), ce_string ("%%s.aff"), l_innames[l_i___0]]).do_nothing
									if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), l_st)) >= 0 then
										l_afile[l_i___0] := spell_read_aff (l_spin, l_fname)
										if (l_afile[l_i___0]).is_void then
											l_error := 1
										else
											(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_fname), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4_096).to_natural_32), ce_string ("%%s.dic"), l_innames[l_i___0]]).do_nothing
											if (spell_read_dic (l_spin, l_fname, l_afile[l_i___0])) = 0 then
												l_error := 1
											end
										end
									elseif (spell_read_wordfile (l_spin, l_innames[l_i___0])) = 0 then
										l_error := 1
									end
									(create {CE_CLASS_POINTER [PD_VIMCONV_T]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_conv"))).item.convert_setup (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)).do_nothing
									l_i___0 := l_i___0 + 1
								end
							end
							l_break := False
							if not (l_spin.item.si_compflags).is_void then
								if (l_spin.item.si_nobreak).to_boolean then
									(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Warning: both compounding and NOBREAK specified"))))).do_nothing
								end
							end
							if not l_error.to_boolean then
								if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
									l_spin.item.spell_message (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (msg_compressing.item))))
									wordtree_compress (l_spin, l_spin.item.si_foldroot)
									wordtree_compress (l_spin, l_spin.item.si_keeproot)
									wordtree_compress (l_spin, l_spin.item.si_prefroot)
								end
							end
							if not l_error.to_boolean then
								if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
									(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, (gettext (ce_string ("Writing spell file %%s ..."))), l_wfname]).do_nothing
									l_spin.item.spell_message ((create {P_GLOBALS_STATIC}).IObuff.item)
									l_error := ((write_vim_spell (l_spin, l_wfname)) = 0).to_integer
									l_spin.item.spell_message (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Done!")))));
									(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, (gettext (ce_string ("Estimated runtime memory use: %%d bytes"))), l_spin.item.si_memtot]).do_nothing
									l_spin.item.spell_message ((create {P_GLOBALS_STATIC}).IObuff.item)
									if not l_error.to_boolean then
										spell_reload_one (l_wfname, a_added_word)
									end
								end
							end
							(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_rep"))).item.ga_clear;
							(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_repsal"))).item.ga_clear;
							(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_sal"))).item.ga_clear;
							(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_map"))).item.ga_clear;
							(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_comppat"))).item.ga_clear;
							(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_prefcond"))).item.ga_clear;
							(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (l_spin.item.c_pointer + (create {PD_SPELLINFO_S}.make).offset_of ("si_commonwords"))).item.hash_clear_all (0)
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_incount)
							loop
								if not (l_afile[l_i___0]).is_void then
									(l_afile[l_i___0]).item.spell_free_aff
								end
								l_i___0 := l_i___0 + 1
							end
							free_blocks (l_spin.item.si_blocks)
							if l_spin.item.si_sugtime /= 0 then
								if not l_error.to_boolean then
									if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
										spell_make_sugfile (l_spin, l_wfname)
									end
								end
							end
						end
					end
					if not l_return then
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_add_word (a_word: CE_POINTER [NATURAL_8]; a_len, a_bad, a_idx, a_undo: INTEGER_32)
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_new_spf: INTEGER_32
			l_fname: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_fnamebuf: CE_ARRAY [NATURAL_8]
			l_line: CE_ARRAY [NATURAL_8]
			l_fpos: INTEGER_32
			l_fpos_next: INTEGER_32
			l_i___0: INTEGER_32
			l_spf: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_fname.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_fnamebuf.make (<<4_096>>)
			create {CE_NATURAL_8_ARRAY} l_line.make (<<500>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_spf.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fd := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
					l_buf___6 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
					l_new_spf := 0
					l_fpos_next := 0
					if a_idx = 0 then
						if int_wordlist.item.is_void then
							int_wordlist.item := (create {P_FILEIO_STATIC}).vim_tempname (('s').code)
							if int_wordlist.item.is_void then
								l_return := True
							end
						end
						if not l_return then
							l_fname.item := int_wordlist.item
						end
					else
						if ((((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_p_spf).item).to_integer_32 = 0 then
							init_spellfile
							l_new_spf := 1
						end
						if ((((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_p_spf).item).to_integer_32 = 0 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_notset.item))))), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("spellfile"))).do_nothing
							l_return := True
						end
						if not l_return then
							l_spf.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_p_spf
							l_i___0 := 1
							from
							until
								not (not (l_return or l_break) and then ((l_spf.item.item).to_integer_32 /= 0))
							loop
								l_break := False;
								(create {P_MISC2_STATIC}).copy_option_part (l_spf, l_fnamebuf, 4_096, ce_string (",")).do_nothing
								if l_i___0 = a_idx then
									l_break := True
								end
								if not (l_return or l_break) then
									if (l_spf.item.item).to_integer_32 = 0 then
										(create {P_MISC2_STATIC}).emsgn (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E765: %'spellfile%' does not have %%ld entries")))), a_idx.to_integer_32).do_nothing
										l_return := True
									end
									if not l_return then
										l_i___0 := l_i___0 + 1
									end
								end
							end
						end
						if not l_return then
							l_break := False
							l_buf___6 := (create {P_BUFFER_STATIC}).buflist_findname_exp (l_fnamebuf)
							if not l_buf___6.is_void then
								if (l_buf___6.item.b_ml.ml_mfp).is_void then
									l_buf___6 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
								end
							end
							if not l_buf___6.is_void then
								if (l_buf___6.item.bufIsChanged).to_boolean then
									(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_bufloaded.item)))))).do_nothing
									l_return := True
								end
							end
						end
						if not l_return then
							l_fname.item := l_fnamebuf
						end
					end
					if l_return then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if:
						if not (a_bad.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___0
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 4 then -- else:
						if not (a_undo.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 5 then -- if: | _L___0:
						l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_fname.item), ce_string ("r"))
						if l_fd.is_void then
							l_pos := -1 + 16 -- skip if block
						end
				when 6 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 15 -- skip loop
						end
				when 7 then -- loop body:
						l_break := False
						if ((create {P_FILEIO_STATIC}).vim_fgets (l_line, 500, l_fd)).to_boolean then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
						l_fpos := l_fpos_next
						l_fpos_next := ftell (l_fd)
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (a_word), create {CE_INTEGER_8_POINTER}.make_cast (l_line), a_len.to_natural_32)) /= 0 then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if:
						if (l_line[a_len]).to_integer_32 /= 47 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 12 then -- else:
						if not ((l_line[a_len]).to_integer_32 < 32) then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L:
						fclose (l_fd).do_nothing
						l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_fname.item), ce_string ("r+"))
						if l_fd.is_void then
							l_break := True
						end
						if not (l_return or l_break) then
							if (fseek (l_fd, l_fpos, 0)) = 0 then
								fputc (('#').code, l_fd).do_nothing
								if a_undo.to_boolean then
									(create {P_MISC1_STATIC}).home_replace (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_fname.item, (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096, 1);
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Word removed from %%s")))), (create {P_GLOBALS_STATIC}).NameBuff.item.item]).do_nothing
								end
							end
							fseek (l_fd, l_fpos_next, 0).do_nothing
						end
				when 14 then -- if done | if done | if done
						l_pos := -1 + 6 -- back to loop condition
				when 15 then -- loop done
						l_break := False
						if not l_fd.is_void then
							fclose (l_fd).do_nothing
						end
				when 16 then -- if done | if done
						if not a_undo.to_boolean then
							l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_fname.item), ce_string ("a"))
							if l_fd.is_void then
								if l_new_spf.to_boolean then
									if not ((create {P_MISC1_STATIC}).dir_of_file_exists (l_fname.item)).to_boolean then
										l_p___0 := (create {P_MISC1_STATIC}).gettail_sep (l_fname.item)
										if not l_p___0.is_equal (l_fname.item) then
											l_c := (l_p___0.item).to_integer_32
											l_p___0.item := (('%/0/').code).to_natural_8
											mkdir (create {CE_INTEGER_8_POINTER}.make_cast (l_fname.item), (493).to_natural_32).do_nothing
											l_p___0.item := l_c.to_natural_8
											l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_fname.item), ce_string ("a"))
										end
									end
								end
							end
							if l_fd.is_void then
								(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_notopen.item))))), l_fname.item).do_nothing
							else
								if a_bad.to_boolean then
									fprintf ([l_fd, ce_string ("%%.*s/!%N"), a_len, a_word]).do_nothing
								else
									fprintf ([l_fd, ce_string ("%%.*s%N"), a_len, a_word]).do_nothing
								end
								fclose (l_fd).do_nothing;
								(create {P_MISC1_STATIC}).home_replace (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_fname.item, (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096, 1);
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Word added to %%s")))), (create {P_GLOBALS_STATIC}).NameBuff.item.item]).do_nothing
							end
						end
						if not l_fd.is_void then
							mkspell (1, l_fname, 0, 1, 1)
							if not l_buf___6.is_void then
								l_buf___6.item.buf_reload (l_buf___6.item.b_orig_mode)
							end
							(create {P_SCREEN_STATIC}).redraw_all_later (35)
						end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	init_spellfile
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_l: INTEGER_32
			l_fname: CE_POINTER [NATURAL_8]
			l_rtp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_lend: CE_POINTER [NATURAL_8]
			l_aspath: INTEGER_32
			l_lstart: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<4_096>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_rtp.make (<<1>>)

			l_aspath := 0
			l_lstart := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_s.b_p_spl
			if ((((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_p_spl).item).to_integer_32 /= 0 then
				if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_len > 0 then
					l_lend := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_p_spl
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_lend.item).to_integer_32 /= 0 then
							if not (((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (",._")), (l_lend.item).to_integer_32)).is_void) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							if ((create {P_MISC1_STATIC}).vim_ispathsep ((l_lend.item).to_integer_32)).to_boolean then
								l_aspath := 1
								l_lstart := l_lend + 1
							end
							l_lend := l_lend + 1
						end
					end
					l_break := False
					l_rtp.item := (create {P_OPTION_STATIC}).p_rtp.item.item
					from
					until
						not (not (l_break) and then ((l_rtp.item.item).to_integer_32 /= 0))
					loop
						l_break := False
						if l_aspath.to_boolean then
							(create {P_MISC2_STATIC}).vim_strncpy (l_buf___6, (create {P_GLOBALS_STATIC}).curbuf.item.item.b_s.b_p_spl, ((l_lstart.distance (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_s.b_p_spl))) - 1).to_natural_32)
						else
							(create {P_MISC2_STATIC}).copy_option_part (l_rtp, l_buf___6, 4_096, ce_string (",")).do_nothing
						end
						if ((create {P_MISC2_STATIC}).filewritable (l_buf___6)) = 2 then
							if l_aspath.to_boolean then
								(create {P_MISC2_STATIC}).vim_strncpy (l_buf___6, (create {P_GLOBALS_STATIC}).curbuf.item.item.b_s.b_p_spl, (l_lend.distance (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_s.b_p_spl))).to_natural_32)
							else
								l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))).to_integer_32;
								(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6) + l_l, (4_096 - l_l).to_natural_32, ce_string ("/spell")]).do_nothing
								if ((create {P_MISC2_STATIC}).filewritable (l_buf___6)).to_boolean then
									l_tmp___3 := 0
								else
									l_tmp___3 := 1
								end
								if l_tmp___3 /= 2 then
									mkdir (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), (493).to_natural_32).do_nothing
								end
								l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))).to_integer_32;
								(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6) + l_l, (4_096 - l_l).to_natural_32, ce_string ("/%%.*s"), l_lend.distance (l_lstart), l_lstart]).do_nothing
							end
							l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))).to_integer_32
							l_fname := ((create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_data) + 0).item.lp_slang).item.sl_fname
							if not l_fname.is_void then
								if not (strstr (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC1_STATIC}).gettail (l_fname))), ce_string (".ascii."))).is_void then
									l_tmp___9 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ascii"))
								else
									l_tmp___8 := spell_enc
									l_tmp___9 := l_tmp___8
								end
							else
								l_tmp___8 := spell_enc
								l_tmp___9 := l_tmp___8
							end
							(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6) + l_l, (4_096 - l_l).to_natural_32, ce_string (".%%s.add"), l_tmp___9]).do_nothing;
							(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("spellfile")), 0, l_buf___6, 4)
							l_break := True
						end
						if not (l_break) then
							l_aspath := 0
						end
					end
					l_break := False
				end
			end
		end

	init_spell_chartab
		local
			l_i___0: INTEGER_32
			l_f: INTEGER_32
			l_u: INTEGER_32
			l_tmp___3: INTEGER_32
		do
			did_set_spelltab.item := 0
			spelltab.item.item.clear_spell_chartab
			if ((create {P_GLOBALS_STATIC}).enc_dbcs.item).to_boolean then
				l_i___0 := 128
				from
				until
					not (l_i___0 <= 255)
				loop
					if ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[l_i___0]).to_integer_32 = 2 then
						spelltab.item.item.st_isw[l_i___0] := (1).to_natural_8
					end
					l_i___0 := l_i___0 + 1
				end
			elseif ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
				l_i___0 := 128
				from
				until
					not (l_i___0 < 256)
				loop
					l_f := ((create {P_MBYTE_STATIC}).utf_fold (l_i___0))
					l_u := ((create {P_MBYTE_STATIC}).utf_toupper (l_i___0))
					spelltab.item.item.st_isu[l_i___0] := ((create {P_MBYTE_STATIC}).utf_isupper (l_i___0)).to_natural_8
					if (spelltab.item.item.st_isu[l_i___0]).to_boolean then
						l_tmp___3 := 1
					elseif ((create {P_MBYTE_STATIC}).utf_islower (l_i___0)).to_boolean then
						l_tmp___3 := 1
					else
						l_tmp___3 := 0
					end
					spelltab.item.item.st_isw[l_i___0] := l_tmp___3.to_natural_8
					if l_f < 256 then
						spelltab.item.item.st_fold[l_i___0] := l_f.to_natural_8
					else
						spelltab.item.item.st_fold[l_i___0] := l_i___0.to_natural_8
					end
					if l_u < 256 then
						spelltab.item.item.st_upper[l_i___0] := l_u.to_natural_8
					else
						spelltab.item.item.st_upper[l_i___0] := l_i___0.to_natural_8
					end
					l_i___0 := l_i___0 + 1
				end
			else
				l_i___0 := 128
				from
				until
					not (l_i___0 < 256)
				loop
					if ((create {P_CHARSET_STATIC}).vim_isupper (l_i___0)).to_boolean then
						spelltab.item.item.st_isw[l_i___0] := (1).to_natural_8
						spelltab.item.item.st_isu[l_i___0] := (1).to_natural_8
						spelltab.item.item.st_fold[l_i___0] := ((create {P_CHARSET_STATIC}).vim_tolower (l_i___0)).to_natural_8
					elseif ((create {P_CHARSET_STATIC}).vim_islower (l_i___0)).to_boolean then
						spelltab.item.item.st_isw[l_i___0] := (1).to_natural_8
						spelltab.item.item.st_upper[l_i___0] := ((create {P_CHARSET_STATIC}).vim_toupper (l_i___0)).to_natural_8
					end
					l_i___0 := l_i___0 + 1
				end
			end
		end

	set_spell_chartab (a_fol, a_low, a_upp: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_new_st: CE_ARRAY [PD_SPELLTAB_S]
			l_pf: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pl: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pu: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_f: INTEGER_32
			l_l: INTEGER_32
			l_u: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_SPELLTAB_S]} l_new_st.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_pf.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_pl.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_pu.make (<<1>>)

			l_pf.item := a_fol
			l_pl.item := a_low
			l_pu.item := a_upp
			l_new_st.item.clear_spell_chartab
			from
			until
				not (not (l_return) and then ((l_pf.item.item).to_integer_32 /= 0))
			loop
				if (l_pl.item.item).to_integer_32 = 0 then
					l_tmp := gettext (e_affform.item);
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
					Result := 0
					l_return := True
				elseif (l_pu.item.item).to_integer_32 = 0 then
					l_tmp := gettext (e_affform.item);
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
					Result := 0
					l_return := True
				end
				if not l_return then
					l_f := (create {P_MBYTE_STATIC}).mb_ptr2char_adv (l_pf)
					l_l := (create {P_MBYTE_STATIC}).mb_ptr2char_adv (l_pl)
					l_u := (create {P_MBYTE_STATIC}).mb_ptr2char_adv (l_pu)
					if l_f < 256 then
						l_new_st.item.st_isw[l_f] := (1).to_natural_8
					end
					if l_l < 256 then
						l_new_st.item.st_isw[l_l] := (1).to_natural_8
					end
					if l_u < 256 then
						l_new_st.item.st_isw[l_u] := (1).to_natural_8
					end
					if l_l < 256 then
						if l_l /= l_f then
							if l_f >= 256 then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (e_affrange.item)))).do_nothing
								Result := 0
								l_return := True
							end
							if not l_return then
								l_new_st.item.st_fold[l_l] := l_f.to_natural_8
							end
						end
					end
				end
				if not l_return and then (l_u < 256) then
					if l_u /= l_f then
						if l_f >= 256 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (e_affrange.item)))).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							l_new_st.item.st_fold[l_u] := l_f.to_natural_8
							l_new_st.item.st_isu[l_u] := (1).to_natural_8
							l_new_st.item.st_upper[l_f] := l_u.to_natural_8
						end
					end
				end
			end
			if not l_return then
				if (l_pl.item.item).to_integer_32 /= 0 then
					l_tmp___2 := gettext (e_affform.item);
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___2)).do_nothing
					Result := 0
					l_return := True
				elseif (l_pu.item.item).to_integer_32 /= 0 then
					l_tmp___2 := gettext (e_affform.item);
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___2)).do_nothing
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := (set_spell_finish (l_new_st))
			end
		end

	set_spell_charflags (a_flags___0: CE_POINTER [NATURAL_8]; a_cnt: INTEGER_32; a_fol: CE_POINTER [NATURAL_8])
		local
			l_new_st: CE_ARRAY [PD_SPELLTAB_S]
			l_i___0: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_c: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_SPELLTAB_S]} l_new_st.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			l_p___0.item := a_fol
			l_new_st.item.clear_spell_chartab
			l_i___0 := 0
			from
			until
				not (l_i___0 < 128)
			loop
				if l_i___0 < a_cnt then
					l_new_st.item.st_isw[l_i___0 + 128] := ((((a_flags___0[l_i___0]).to_integer_32).bit_and (1)) /= 0).to_integer.to_natural_8
					l_new_st.item.st_isu[l_i___0 + 128] := ((((a_flags___0[l_i___0]).to_integer_32).bit_and (2)) /= 0).to_integer.to_natural_8
				end
				if (l_p___0.item.item).to_integer_32 /= 0 then
					l_c := (create {P_MBYTE_STATIC}).mb_ptr2char_adv (l_p___0)
					l_new_st.item.st_fold[l_i___0 + 128] := l_c.to_natural_8
					if l_i___0 + 128 /= l_c then
						if (l_new_st.item.st_isu[l_i___0 + 128]).to_boolean then
							if l_c < 256 then
								l_new_st.item.st_upper[l_c] := (l_i___0 + 128).to_natural_8
							end
						end
					end
				end
				l_i___0 := l_i___0 + 1
			end
			set_spell_finish (l_new_st).do_nothing
		end

	set_spell_finish (a_new_st: CE_POINTER [PD_SPELLTAB_S]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			if did_set_spelltab.item.to_boolean then
				l_i___0 := 0
				from
				until
					not (not (l_return) and then (l_i___0 < 256))
				loop
					if (spelltab.item.item.st_isw[l_i___0]).to_integer_32 /= (a_new_st.item.st_isw[l_i___0]).to_integer_32 then
						l_tmp := gettext (ce_string ("E763: Word characters differ between spell files"));
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
						Result := 0
						l_return := True
					elseif (spelltab.item.item.st_isu[l_i___0]).to_integer_32 /= (a_new_st.item.st_isu[l_i___0]).to_integer_32 then
						l_tmp := gettext (ce_string ("E763: Word characters differ between spell files"));
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
						Result := 0
						l_return := True
					elseif (spelltab.item.item.st_fold[l_i___0]).to_integer_32 /= (a_new_st.item.st_fold[l_i___0]).to_integer_32 then
						l_tmp := gettext (ce_string ("E763: Word characters differ between spell files"));
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
						Result := 0
						l_return := True
					elseif (spelltab.item.item.st_upper[l_i___0]).to_integer_32 /= (a_new_st.item.st_upper[l_i___0]).to_integer_32 then
						l_tmp := gettext (ce_string ("E763: Word characters differ between spell files"));
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
						Result := 0
						l_return := True
					end
					if not l_return then
						l_i___0 := l_i___0 + 1
					end
				end
			else
				spelltab.item.item := (a_new_st.item).twin
				did_set_spelltab.item := 1
			end
			if not l_return then
				Result := 1
			end
		end

	spell_iswordp_nmw (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_c: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([a_p___0])
				if l_c > 255 then
					Result := (spell_mb_isword_class (((create {P_MBYTE_STATIC}).mb_get_class (a_p___0))))
					l_return := True
				end
				if not l_return then
					Result := (spelltab.item.item.st_isw[l_c]).to_integer_32
					l_return := True
				end
			end
			if not l_return then
				Result := (spelltab.item.item.st_isw[(a_p___0.item).to_integer_32]).to_integer_32
			end
		end

	spell_mb_isword_class (a_cl: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_cl >= 2 then
				if a_cl /= 8_304 then
					if a_cl /= 8_320 then
						l_tmp := 1
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	spell_casefold (a_str___1: CE_POINTER [NATURAL_8]; a_len: INTEGER_32; a_buf___6: CE_POINTER [NATURAL_8]; a_buflen: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_outi: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_c: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_len >= a_buflen then
						a_buf___6[0] := (('%/0/').code).to_natural_8
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 2 then -- if:
						l_outi := 0
						l_p___0.item := a_str___1
				when 3 then -- loop condition:
						if not (not (l_return) and then (((l_p___0.item).c_pointer.to_integer_32).to_natural_32 < ((a_str___1 + a_len).c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 4 then -- loop body:
						if l_outi + 21 > a_buflen then
							a_buf___6[l_outi] := (('%/0/').code).to_natural_8
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						l_c := (create {P_MBYTE_STATIC}).mb_cptr2char_adv (l_p___0)
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_c >= 128 then
							l_tmp___2 := ((create {P_MBYTE_STATIC}).utf_fold (l_c))
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if l_c < 256 then
							l_tmp___1 := (spelltab.item.item.st_fold[l_c]).to_integer_32
						else
							l_tmp___1 := (towlower (l_c.to_natural_32)).to_integer_32
						end
						l_tmp___2 := l_tmp___1
				when 9 then
						l_outi := l_outi + ((create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([l_tmp___2, a_buf___6 + l_outi]))
				when 10 then -- if done
						l_pos := -1 + 3 -- back to loop condition
				when 11 then -- loop done
						if not l_return then
							a_buf___6[l_outi] := (('%/0/').code).to_natural_8
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						l_i___0 := 0
						from
						until
							not (l_i___0 < a_len)
						loop
							a_buf___6[l_i___0] := spelltab.item.item.st_fold[(a_str___1[l_i___0]).to_integer_32]
							l_i___0 := l_i___0 + 1
						end
						a_buf___6[l_i___0] := (('%/0/').code).to_natural_8
				when 14 then -- if done | if done
					if not l_return then
						Result := 1
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_check_sps: INTEGER_32
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_f: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<4_096>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					sps_flags.item := 0
					sps_limit.item := 9_999
					l_p___0.item := (create {P_OPTION_STATIC}).p_sps.item.item
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_p___0.item.item).to_integer_32 /= 0)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:;
						(create {P_MISC2_STATIC}).copy_option_part (l_p___0, l_buf___6, 4_096, ce_string (",")).do_nothing
						l_f := 0
						if not ((l_buf___6[0]).to_integer_32 >= 48) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_buf___6[0]).to_integer_32 <= 57 then
							l_s.item := l_buf___6
							sps_limit.item := ((create {P_CHARSET_STATIC}).getdigits (l_s)).to_integer_32
							if (l_s.item.item).to_integer_32 /= 0 then
								if (l_s.item.item).to_integer_32 >= 48 then
									if not ((l_s.item.item).to_integer_32 <= 57) then
										l_f := -1
									end
								else
									l_f := -1
								end
							end
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("best"))) = 0 then
							l_f := 1
						elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("fast"))) = 0 then
							l_f := 2
						elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("double"))) = 0 then
							l_f := 4
						elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("expr:"), (5).to_natural_32)) /= 0 then
							if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("file:"), (5).to_natural_32)) /= 0 then
								l_f := -1
							end
						end
				when 6 then
						if l_f = -1 then
							sps_flags.item := 1
							sps_limit.item := 9_999
							Result := 0
							l_return := True
						elseif sps_flags.item /= 0 then
							if l_f /= 0 then
								sps_flags.item := 1
								sps_limit.item := 9_999
								Result := 0
								l_return := True
							end
						end
						if not l_return and then (l_f /= 0) then
							sps_flags.item := l_f
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					if not l_return then
						if sps_flags.item = 0 then
							sps_flags.item := 1
						end
						Result := 1
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_need_cap (a_lnum: INTEGER_32; a_col: INTEGER_32): INTEGER_32
		local
			l_need_cap: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_line_copy: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_endcol: INTEGER_32
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_REGMATCH_T]} l_regmatch___0.make (<<1>>)

			l_need_cap := 0
			l_line_copy := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if (((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_cap_prog).is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_line := (create {P_MEMLINE_STATIC}).ml_get_curline
				l_endcol := 0
				if ((create {P_CHARSET_STATIC}).skipwhite (l_line)).distance (l_line) >= a_col then
					if a_lnum = 1 then
						l_need_cap := 1
					else
						l_line := (create {P_MEMLINE_STATIC}).ml_get (a_lnum - 1)
						if (((create {P_CHARSET_STATIC}).skipwhite (l_line)).item).to_integer_32 = 0 then
							l_need_cap := 1
						else
							l_line_copy := (create {P_MISC1_STATIC}).concat_str (l_line, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
							l_line := l_line_copy
							l_endcol := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))).to_integer_32
						end
					end
				else
					l_endcol := a_col
				end
				if l_endcol > 0 then
					l_regmatch___0.item.regprog := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_cap_prog
					l_regmatch___0.item.rm_ic := 0
					l_p___0 := l_line + l_endcol
					from
					until
						(l_break)
					loop
						l_break := False
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___3 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_line, l_p___0 - 1])) + 1
						else
							l_tmp___3 := 1
						end
						l_p___0 := l_p___0 - l_tmp___3
						if l_p___0.is_equal (l_line) then
							l_break := True
						elseif (spell_iswordp_nmw (l_p___0)).to_boolean then
							l_break := True
						end
						if not (l_break) then
							if (l_regmatch___0.item.vim_regexec (l_p___0, 0)).to_boolean then
								if (l_regmatch___0.item.endp[0]).is_equal (l_line + l_endcol) then
									l_need_cap := 1
									l_break := True
								end
							end
						end
					end
					l_break := False
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_line_copy))
				Result := l_need_cap
			end
		end

	ex_spellrepall (a_eap: CE_POINTER [PD_EXARG])
		local
			l_pos___3: PD_POS_T
			l_frompat: CE_POINTER [NATURAL_8]
			l_addlen: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_save_ws: INTEGER_32
			l_prev_lnum___1: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pos___3 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
					l_save_ws := (create {P_OPTION_STATIC}).p_ws.item.item
					l_prev_lnum___1 := (0).to_integer_32
					if repl_from.item.is_void then
						l_tmp := gettext (ce_string ("E752: No previous spell replacement"));
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
						l_return := True
					elseif repl_to.item.is_void then
						l_tmp := gettext (ce_string ("E752: No previous spell replacement"));
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
						l_return := True
					end
					if not l_return then
						l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (repl_to.item))
						l_addlen := (l_tmp___0 - (strlen (create {CE_INTEGER_8_POINTER}.make_cast (repl_from.item)))).to_integer_32
						l_frompat := (create {P_MISC2_STATIC}).alloc ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (repl_from.item))) + {NATURAL_32} 7)
						if l_frompat.is_void then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_frompat), ce_string ("\V\<%%s\>"), repl_from.item]).do_nothing;
						(create {P_OPTION_STATIC}).p_ws.item.item := 0;
						(create {P_GLOBALS_STATIC}).sub_nsubs.item := 0;
						(create {P_GLOBALS_STATIC}).sub_nlines.item := (0).to_integer_32;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (0).to_integer_32
				when 2 then -- loop condition:
						if not (not (l_break) and then (not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean)) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if ((create {P_SEARCH_STATIC}).do_search (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('/').code, l_frompat, 1, 1_024, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))) = 0 then
							l_break := True
						elseif ((create {P_UNDO_STATIC}).u_save_cursor) = 0 then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						l_line := (create {P_MEMLINE_STATIC}).ml_get_curline
						if not (l_addlen <= 0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_line + (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col)), create {CE_INTEGER_8_POINTER}.make_cast (repl_to.item), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (repl_to.item))))) = 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						l_p___0 := (create {P_MISC2_STATIC}).alloc (((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))) + l_addlen.to_natural_32) + {NATURAL_32} 1)
						if l_p___0.is_void then
							l_break := True
						end
						if not (l_break) then
							memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_line), ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col).to_natural_32).do_nothing
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col)), create {CE_INTEGER_8_POINTER}.make_cast (repl_to.item)).do_nothing
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), create {CE_INTEGER_8_POINTER}.make_cast (((l_line + (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (repl_from.item))).to_integer_32))).do_nothing;
							(create {P_MEMLINE_STATIC}).ml_replace ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_p___0, 0).do_nothing;
							(create {P_MISC1_STATIC}).changed_bytes ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col)
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= l_prev_lnum___1 then
								(create {P_GLOBALS_STATIC}).sub_nlines.item := (create {P_GLOBALS_STATIC}).sub_nlines.item + 1
								l_prev_lnum___1 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
							end
							(create {P_GLOBALS_STATIC}).sub_nsubs.item := (create {P_GLOBALS_STATIC}).sub_nsubs.item + 1
						end
				when 9 then -- if done | if done
						if not (l_break) then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (repl_to.item))).to_integer_32
						end
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						l_break := False;
						(create {P_OPTION_STATIC}).p_ws.item.item := l_save_ws;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_pos___3.twin;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_frompat))
						if (create {P_GLOBALS_STATIC}).sub_nsubs.item = 0 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E753: Not found: %%s")))), repl_from.item).do_nothing
						else
							(create {P_EX_CMDS_STATIC}).do_sub_msg (0).do_nothing
						end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_find_suggest (a_badptr: CE_POINTER [NATURAL_8]; a_badlen: INTEGER_32; a_su: CE_POINTER [PD_SUGINFO_S]; a_maxcount, a_banbadword, a_need_cap, a_interactive: INTEGER_32)
		require
			not a_badptr.is_void
		local
			l_attr: CE_ARRAY [NATURAL_32]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_do_combine: INTEGER_32
			l_sps_copy: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_i___0: INTEGER_32
			l_lp: CE_POINTER [PD_LANGP_S]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_attr.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<4_096>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_NATURAL_8_POINTER} l_sps_copy.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_attr.item := {PC_HLF_T}.HLF_COUNT
					l_do_combine := 0
					memset (create {CE_VOID_POINTER}.make_cast (a_su), 0, (create {PD_SUGINFO_S}.make).structure_size.to_natural_32).do_nothing;
					(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga"))).item.ga_init2 (((create {PD_SUGGEST_S}.make).structure_size.to_natural_32).to_integer_32, 10);
					(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_sga"))).item.ga_init2 (((create {PD_SUGGEST_S}.make).structure_size.to_natural_32).to_integer_32, 10)
					if (a_badptr.item).to_integer_32 = 0 then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:;
						(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_banned"))).item.hash_init
						a_su.item.su_badptr := a_badptr
						if a_badlen /= 0 then
							a_su.item.su_badlen := a_badlen
						else
							a_su.item.su_badlen := ((create {P_GLOBALS_STATIC}).curwin.item).item.spell_check (a_su.item.su_badptr, l_attr, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0)
						end
						a_su.item.su_maxcount := a_maxcount
						a_su.item.su_maxscore := 350
						if a_su.item.su_badlen >= 250 then
							a_su.item.su_badlen := 249
						end
						(create {P_MISC2_STATIC}).vim_strncpy (a_su.item.su_badword, a_su.item.su_badptr, (a_su.item.su_badlen).to_natural_32)
						spell_casefold (a_su.item.su_badptr, a_su.item.su_badlen, a_su.item.su_fbadword, 250).do_nothing
						a_su.item.su_badflags := badword_captype (a_su.item.su_badptr, a_su.item.su_badptr + a_su.item.su_badlen)
						if a_need_cap.to_boolean then
							a_su.item.su_badflags := (a_su.item.su_badflags).bit_or ((2))
						end
						l_i___0 := 0
						from
						until
							not (not (l_break) and then (l_i___0 < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_s.b_langp.ga_len))
						loop
							l_break := False
							l_lp := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_s.b_langp.ga_data) + l_i___0
							if not (l_lp.item.lp_sallang).is_void then
								a_su.item.su_sallang := l_lp.item.lp_sallang
								l_break := True
							end
							if not (l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						if not (a_su.item.su_sallang).is_void then
							(a_su.item.su_sallang).item.spell_soundfold (a_su.item.su_fbadword, 1, a_su.item.su_sal_badword)
						end
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_c := ((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([a_su.item.su_badptr]))
						else
							l_c := ((a_su.item.su_badptr).item).to_integer_32
						end
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_c >= 128 then
							l_tmp___3 := ((create {P_MBYTE_STATIC}).utf_isupper (l_c))
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_c < 256 then
							l_tmp___2 := (spelltab.item.item.st_isu[l_c]).to_integer_32
						else
							l_tmp___2 := (iswupper (l_c.to_natural_32))
						end
						l_tmp___3 := l_tmp___2
				when 5 then
						if not l_tmp___3.to_boolean then
							if l_attr.item = {NATURAL_32} 41 then
								make_case_word (a_su.item.su_badword, l_buf___6, 2)
								a_su.item.add_suggestion (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), l_buf___6, a_su.item.su_badlen, 52, 0, 1, a_su.item.su_sallang, 0)
							end
						end
						if a_banbadword.to_boolean then
							add_banned (a_su, a_su.item.su_badword)
						end
						l_sps_copy := (create {P_MISC2_STATIC}).vim_strsave ((create {P_OPTION_STATIC}).p_sps.item.item)
						if l_sps_copy.is_void then
							l_return := True
						end
				when 6 then -- if done
					if not l_return then
						l_p___0.item := l_sps_copy
						from
						until
							(l_p___0.item.item).to_integer_32 = 0
						loop
							(create {P_MISC2_STATIC}).copy_option_part (l_p___0, l_buf___6, 4_096, ce_string (",")).do_nothing
							if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("expr:"), (5).to_natural_32)) = 0 then
								if not expr_busy.item.to_boolean then
									expr_busy.item := 1
									a_su.item.spell_suggest_expr (l_buf___6 + 5)
									expr_busy.item := 0
								end
							elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("file:"), (5).to_natural_32)) = 0 then
								spell_suggest_file (a_su, l_buf___6 + 5)
							else
								a_su.item.spell_suggest_intern (a_interactive)
								if ((sps_flags.item).bit_and (4)).to_boolean then
									l_do_combine := 1
								end
							end
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_sps_copy))
						if l_do_combine.to_boolean then
							a_su.item.score_combine
						end
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_suggest_file (a_su: CE_POINTER [PD_SUGINFO_S]; a_fname: CE_POINTER [NATURAL_8])
		local
			l_fd: CE_POINTER [SD_IO_FILE]
			l_line: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_cword: CE_ARRAY [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_line.make (<<500>>)
			create {CE_NATURAL_8_POINTER} l_p___0.make
			create {CE_NATURAL_8_ARRAY} l_cword.make (<<250>>)

			l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (a_fname), ce_string ("r"))
			if l_fd.is_void then
				(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_notopen.item))))), a_fname).do_nothing
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_continue := False
					if ((create {P_FILEIO_STATIC}).vim_fgets (l_line, 500, l_fd)).to_boolean then
						l_break := True
					elseif ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						l_break := True
					end
					if not (l_return or l_break or l_continue) then
						(create {P_MISC1_STATIC}).line_breakcheck
						l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (l_line, ('/').code)
						if l_p___0.is_void then
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) then
						l_tmp___0 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___0.item := (('%/0/').code).to_natural_8
						if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((a_su.item.su_badword)), create {CE_INTEGER_8_POINTER}.make_cast (l_line))) = 0 then
							l_len := 0
							from
							until
								not ((l_p___0[l_len]).to_integer_32 >= 32)
							loop
								l_len := l_len + 1
							end
							l_p___0[l_len] := (('%/0/').code).to_natural_8
							if (captype (l_p___0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))) = 0 then
								make_case_word (l_p___0, l_cword, a_su.item.su_badflags)
								l_p___0 := l_cword
							end
							a_su.item.add_suggestion (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), l_p___0, a_su.item.su_badlen, 30, 0, 1, a_su.item.su_sallang, 0)
						end
					end
				end
				l_break := False
				l_continue := False
				fclose (l_fd).do_nothing
				check_suggestions (a_su, create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")));
				(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga"))).item.cleanup_suggestions (a_su.item.su_maxscore, a_su.item.su_maxcount).do_nothing
			end
		end

	onecap_copy (a_word, a_wcopy: CE_POINTER [NATURAL_8]; a_upper: INTEGER_32)
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_c: INTEGER_32
			l_l: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_tmp___5: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.item := a_word
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_c := (create {P_MBYTE_STATIC}).mb_cptr2char_adv (l_p___0)
					else
						l_tmp := l_p___0.item
						l_p___0.item := l_p___0.item + 1
						l_c := (l_tmp.item).to_integer_32
					end
					if not (a_upper.to_boolean) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_c >= 128 then
							l_c := ((create {P_MBYTE_STATIC}).utf_toupper (l_c))
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_c < 256 then
							l_tmp___2 := (spelltab.item.item.st_upper[l_c]).to_integer_32
						else
							l_tmp___2 := (towupper (l_c.to_natural_32)).to_integer_32
						end
						l_c := l_tmp___2
				when 5 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_c >= 128 then
							l_c := ((create {P_MBYTE_STATIC}).utf_fold (l_c))
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___0:
						if l_c < 256 then
							l_tmp___5 := (spelltab.item.item.st_fold[l_c]).to_integer_32
						else
							l_tmp___5 := (towlower (l_c.to_natural_32)).to_integer_32
						end
						l_c := l_tmp___5
				when 10 then -- if done
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_l := (create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([l_c, a_wcopy])
					else
						l_l := 1
						a_wcopy[0] := l_c.to_natural_8
					end
					(create {P_MISC2_STATIC}).vim_strncpy (a_wcopy + l_l, l_p___0.item, ((250 - l_l) - 1).to_natural_32)
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	allcap_copy (a_word, a_wcopy: CE_POINTER [NATURAL_8])
		require
			not a_wcopy.is_void
		local
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_d: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := a_wcopy
					l_s.item := a_word
				when 1 then -- loop condition:
					if not (not (l_break) and then ((l_s.item.item).to_integer_32 /= 0)) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_c := (create {P_MBYTE_STATIC}).mb_cptr2char_adv (l_s)
						else
							l_tmp := l_s.item
							l_s.item := l_s.item + 1
							l_c := (l_tmp.item).to_integer_32
						end
						if not (((create {P_GLOBALS_STATIC}).enc_latin1like.item).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_c = 223 then
							l_c := ('S').code
							if l_d.distance (a_wcopy) >= 249 then
								l_break := True
							end
							if not (l_break) then
								l_tmp___0 := l_d
								l_d := l_d + 1
								l_tmp___0.item := l_c.to_natural_8
							end
						else
							l_pos := -1 + 5 -- goto _L___0
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else: | _L___0:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_c >= 128 then
							l_c := ((create {P_MBYTE_STATIC}).utf_toupper (l_c))
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if l_c < 256 then
							l_tmp___3 := (spelltab.item.item.st_upper[l_c]).to_integer_32
						else
							l_tmp___3 := (towupper (l_c.to_natural_32)).to_integer_32
						end
						l_c := l_tmp___3
				when 9 then -- if done
						if not (l_break) then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								if l_d.distance (a_wcopy) >= 229 then
									l_break := True
								end
								if not (l_break) then
									l_d := l_d + ((create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([l_c, l_d]))
								end
							else
								if l_d.distance (a_wcopy) >= 249 then
									l_break := True
								end
								if not (l_break) then
									l_tmp___5 := l_d
									l_d := l_d + 1
									l_tmp___5.item := l_c.to_natural_8
								end
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					l_break := False
					l_d.item := (('%/0/').code).to_natural_8
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	nofold_len (a_fword: CE_POINTER [NATURAL_8]; a_flen: INTEGER_32; a_word: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
		do
			l_i___0 := 0
			l_p___0 := a_fword
			from
			until
				not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < ((a_fword + a_flen).c_pointer.to_integer_32).to_natural_32)
			loop
				l_i___0 := l_i___0 + 1
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
				else
					l_tmp___0 := 1
				end
				l_p___0 := l_p___0 + l_tmp___0
			end
			l_p___0 := a_word
			from
			until
				not (l_i___0 > 0)
			loop
				l_i___0 := l_i___0 - 1
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					l_tmp___2 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
				else
					l_tmp___2 := 1
				end
				l_p___0 := l_p___0 + l_tmp___2
			end
			Result := (l_p___0.distance (a_word))
		end

	make_case_word (a_fword, a_cword: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32)
		do
			if ((a_flags___0).bit_and (4)).to_boolean then
				allcap_copy (a_fword, a_cword)
			elseif ((a_flags___0).bit_and (2)).to_boolean then
				onecap_copy (a_fword, a_cword, 1)
			else
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (a_cword), create {CE_INTEGER_8_POINTER}.make_cast (a_fword)).do_nothing
			end
		end

	check_suggestions (a_su: CE_POINTER [PD_SUGINFO_S]; a_gap: CE_POINTER [PD_GROWARRAY])
		require
			not a_gap.is_void
		local
			l_stp: CE_POINTER [PD_SUGGEST_S]
			l_i___0: INTEGER_32
			l_longword: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_attr: CE_ARRAY [NATURAL_32]
		do
			create {CE_NATURAL_8_ARRAY} l_longword.make (<<251>>)
			create {CE_NATURAL_32_ARRAY} l_attr.make (<<1>>)

			l_stp := create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (a_gap.item.ga_data) + 0
			l_i___0 := a_gap.item.ga_len - 1
			from
			until
				not (l_i___0 >= 0)
			loop
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_longword), create {CE_INTEGER_8_POINTER}.make_cast ((l_stp + l_i___0).item.st_word)).do_nothing
				l_len := (l_stp + l_i___0).item.st_wordlen;
				(create {P_MISC2_STATIC}).vim_strncpy (l_longword + l_len, a_su.item.su_badptr + (l_stp + l_i___0).item.st_orglen, (250 - l_len).to_natural_32)
				l_attr.item := {PC_HLF_T}.HLF_COUNT;
				((create {P_GLOBALS_STATIC}).curwin.item).item.spell_check (l_longword, l_attr, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0).do_nothing
				if l_attr.item /= {NATURAL_32} 41 then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((l_stp + l_i___0).item.st_word))
					a_gap.item.ga_len := (a_gap.item.ga_len) - 1
					if l_i___0 < a_gap.item.ga_len then
						memmove (create {CE_VOID_POINTER}.make_cast ((l_stp + l_i___0)), create {CE_VOID_POINTER}.make_cast (((l_stp + l_i___0) + 1)), (create {PD_SUGGEST_S}.make).structure_size.to_natural_32 * (a_gap.item.ga_len - l_i___0).to_natural_32).do_nothing
					end
				end
				l_i___0 := l_i___0 - 1
			end
		end

	add_banned (a_su: CE_POINTER [PD_SUGINFO_S]; a_word: CE_POINTER [NATURAL_8])
		require
			not a_word.is_void
		local
			l_s: CE_POINTER [NATURAL_8]
			l_hash: NATURAL_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_hash := (create {P_HASHTAB_STATIC}).hash_hash (a_word)
					l_hi___1 := (create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_banned"))).item.hash_lookup (a_word, l_hash)
					if not ((l_hi___1.item.hi_key).is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_s := (create {P_MISC2_STATIC}).vim_strsave (a_word)
						if not l_s.is_void then
							(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_banned"))).item.hash_add_item (l_hi___1, l_s, l_hash).do_nothing
						end
				when 5 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	sug_compare (a_s1, a_s2: CE_POINTER [ANY]): INTEGER_32
		local
			l_p1: CE_POINTER [PD_SUGGEST_S]
			l_p2: CE_POINTER [PD_SUGGEST_S]
			l_n: INTEGER_32
		do
			l_p1 := create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (a_s1)
			l_p2 := create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (a_s2)
			l_n := l_p1.item.st_score - l_p2.item.st_score
			if l_n = 0 then
				l_n := l_p1.item.st_altscore - l_p2.item.st_altscore
				if l_n = 0 then
					l_n := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p1.item.st_word), create {CE_INTEGER_8_POINTER}.make_cast (l_p2.item.st_word))
				end
			end
			Result := l_n
		end

	eval_soundfold (a_word: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_lp: CE_POINTER [PD_LANGP_S]
			l_sound: CE_ARRAY [NATURAL_8]
			l_lpi: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_sound.make (<<250>>)

			if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_spell).to_boolean then
				if ((((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_p_spl).item).to_integer_32 /= 0 then
					l_lpi := 0
					from
					until
						not (not (l_return) and then (l_lpi < ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_len))
					loop
						l_lp := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_data) + l_lpi
						if (l_lp.item.lp_slang).item.sl_sal.ga_len > 0 then
							(l_lp.item.lp_slang).item.spell_soundfold (a_word, 0, l_sound)
							Result := ((create {P_MISC2_STATIC}).vim_strsave (l_sound))
							l_return := True
						end
						if not l_return then
							l_lpi := l_lpi + 1
						end
					end
				end
			end
			if not l_return then
				Result := ((create {P_MISC2_STATIC}).vim_strsave (a_word))
			end
		end

	ex_spellinfo (a_eap: CE_POINTER [PD_EXARG])
		local
			l_lpi: INTEGER_32
			l_lp: CE_POINTER [PD_LANGP_S]
			l_p___0: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			if (((create {P_GLOBALS_STATIC}).curwin.item).item.no_spell_checking).to_boolean then
				l_return := True
			end
			if not l_return then
				(create {P_MESSAGE_STATIC}).msg_start
				l_lpi := 0
				from
				until
					(l_break)
				loop
					l_break := False
					if l_lpi < ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_len then
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_lp := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_data) + l_lpi;
						(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file: ")));
						(create {P_MESSAGE_STATIC}).msg_puts ((l_lp.item.lp_slang).item.sl_fname);
						(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
						l_p___0 := (l_lp.item.lp_slang).item.sl_info
						if not l_p___0.is_void then
							(create {P_MESSAGE_STATIC}).msg_puts (l_p___0);
							(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
						end
						l_lpi := l_lpi + 1
					end
				end
				l_break := False;
				(create {P_MESSAGE_STATIC}).msg_end.do_nothing
			end
		end

	ex_spelldump (a_eap: CE_POINTER [PD_EXARG])
		local
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
		do
			if (((create {P_GLOBALS_STATIC}).curwin.item).item.no_spell_checking).to_boolean then
				l_return := True
			end
			if not l_return then
				(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("new"))).do_nothing
				if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count = 1 then
					if (((create {P_MEMLINE_STATIC}).ml_get ((1).to_integer_32)).item).to_integer_32 = 0 then
						if not ((create {P_BUFFER_STATIC}).buf_valid ((create {P_GLOBALS_STATIC}).curbuf.item)).to_boolean then
							l_return := True
						end
					else
						l_return := True
					end
				else
					l_return := True
				end
			end
			if not l_return then
				if (a_eap.item.forceit).to_boolean then
					l_tmp___2 := 2
				else
					l_tmp___2 := 0
				end
				spell_dump_compl (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_tmp___2)
				if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count > 1 then
					(create {P_MEMLINE_STATIC}).ml_delete ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count, 0).do_nothing
				end
				(create {P_SCREEN_STATIC}).redraw_later (40)
			end
		end

	spell_dump_compl (a_pat: CE_POINTER [NATURAL_8]; a_ic: INTEGER_32; a_dir___0: CE_POINTER [INTEGER_32]; a_dumpflags_arg: INTEGER_32)
		local
			l_lp: CE_POINTER [PD_LANGP_S]
			l_slang: CE_POINTER [PD_SLANG_S]
			l_arridx: CE_ARRAY [INTEGER_32]
			l_curi: CE_ARRAY [INTEGER_32]
			l_word: CE_ARRAY [NATURAL_8]
			l_c: INTEGER_32
			l_byts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_lnum: INTEGER_32
			l_round: INTEGER_32
			l_depth___1: INTEGER_32
			l_n: INTEGER_32
			l_flags___0: INTEGER_32
			l_region_names: CE_POINTER [NATURAL_8]
			l_do_region: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_lpi: INTEGER_32
			l_dumpflags: INTEGER_32
			l_patlen: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_arridx.make (<<250>>)
			create {CE_INTEGER_32_ARRAY} l_curi.make (<<250>>)
			create {CE_NATURAL_8_ARRAY} l_word.make (<<250>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := (0).to_integer_32
					l_region_names := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_do_region := 1
					l_dumpflags := a_dumpflags_arg
					if not a_pat.is_void then
						if a_ic.to_boolean then
							l_dumpflags := (l_dumpflags).bit_or ((4))
						else
							l_n := captype (a_pat, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							if l_n = 2 then
								l_dumpflags := (l_dumpflags).bit_or ((8))
							elseif l_n = 4 then
								l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_pat))
								if l_tmp.to_integer_32 > ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([a_pat])) then
									l_dumpflags := (l_dumpflags).bit_or ((16))
								end
							end
						end
					end
					l_lpi := 0
					from
					until
						not (not (l_break) and then (l_lpi < ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_len))
					loop
						l_break := False
						l_lp := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_data) + l_lpi
						l_p___0 := (l_lp.item.lp_slang).item.sl_regions
						if (l_p___0[0]).to_integer_32 /= 0 then
							if l_region_names.is_void then
								l_region_names := l_p___0
							elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_region_names), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))) /= 0 then
								l_do_region := 0
								l_break := True
							end
						end
						if not (l_break) then
							l_lpi := l_lpi + 1
						end
					end
					l_break := False
					if l_do_region.to_boolean then
						if not l_region_names.is_void then
							if a_pat.is_void then
								(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, ce_string ("/regions=%%s"), l_region_names]).do_nothing
								l_tmp___2 := l_lnum
								l_lnum := l_lnum + 1;
								(create {P_MEMLINE_STATIC}).ml_append (l_tmp___2, (create {P_GLOBALS_STATIC}).IObuff.item, 0, 0).do_nothing
							end
						else
							l_do_region := 0
						end
					else
						l_do_region := 0
					end
					l_lpi := 0
				when 1 then -- loop condition:
					if not (not (l_return) and then (l_lpi < ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_len)) then
						l_pos := -1 + 38 -- skip loop
					end
				when 2 then -- loop body:
						l_continue := False
						l_lp := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_data) + l_lpi
						l_slang := l_lp.item.lp_slang
						if (l_slang.item.sl_fbyts).is_void then
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 37 -- skip if block
						end
				when 3 then -- if:
						if a_pat.is_void then
							(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, ce_string ("# file: %%s"), l_slang.item.sl_fname]).do_nothing
							l_tmp___3 := l_lnum
							l_lnum := l_lnum + 1;
							(create {P_MEMLINE_STATIC}).ml_append (l_tmp___3, (create {P_GLOBALS_STATIC}).IObuff.item, 0, 0).do_nothing
						end
						if not a_pat.is_void then
							if (l_slang.item.sl_pbyts).is_void then
								l_patlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_pat))).to_integer_32
							else
								l_patlen := -1
							end
						else
							l_patlen := -1
						end
						l_round := 1
				when 4 then -- loop condition:
						if not (not (l_return) and then (l_round <= 2)) then
							l_pos := -1 + 36 -- skip loop
						end
				when 5 then -- loop body:
						l_continue := False
						if l_round = 1 then
							l_dumpflags := (l_dumpflags).bit_and ((-2))
							l_byts := l_slang.item.sl_fbyts
							l_idxs := l_slang.item.sl_fidxs
						else
							l_dumpflags := (l_dumpflags).bit_or ((1))
							l_byts := l_slang.item.sl_kbyts
							l_idxs := l_slang.item.sl_kidxs
						end
						if l_byts.is_void then
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 35 -- skip if block
						end
				when 6 then -- if:
						l_depth___1 := 0
						l_arridx[0] := 0
						l_curi[0] := 1
				when 7 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 34 -- skip loop
						end
				when 8 then -- loop body:
						l_break := False
						if l_depth___1 >= 0 then
							if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								if not (a_pat.is_void) then
									if ((create {P_GLOBALS_STATIC}).compl_interrupted.item).to_boolean then
										l_break := True
									end
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 33 -- skip if block
						end
				when 9 then -- if:
						if not (l_curi[l_depth___1] > (l_byts[(l_arridx[l_depth___1])]).to_integer_32) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_depth___1 := l_depth___1 - 1;
						(create {P_MISC1_STATIC}).line_breakcheck;
						(create {P_EDIT_STATIC}).ins_compl_check_keys (50)
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 12 then -- else:
						l_n := l_arridx[l_depth___1] + l_curi[l_depth___1]
						l_curi[l_depth___1] := (l_curi[l_depth___1]) + 1
						l_c := (l_byts[l_n]).to_integer_32
						if l_c /= 0 then
							l_pos := -1 + 32 -- skip if block
						end
				when 13 then -- if:
						l_flags___0 := l_idxs[l_n]
						if l_round /= 2 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___1
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 16 then -- else:
						if ((l_flags___0).bit_and (128)) /= 0 then
							l_pos := -1 + 31 -- skip if block
						end
				when 17 then -- if: | _L___1:
						if ((l_flags___0).bit_and (512)) /= 0 then
							l_pos := -1 + 31 -- skip if block
						end
				when 18 then -- if:
						if not (l_do_region.to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 25 -- goto _L___0
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 21 then -- else:
						if ((l_flags___0).bit_and (1)) /= 0 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L___0
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 24 then -- else:
						if ((((l_flags___0.to_natural_32).bit_shift_right (16))).bit_and ((l_lp.item.lp_region).to_natural_32)) = {NATURAL_32} 0 then
							l_pos := -1 + 31 -- skip if block
						end
				when 25 then -- if: | _L___0:
						l_word[l_depth___1] := (('%/0/').code).to_natural_8
						if not l_do_region.to_boolean then
							l_flags___0 := (l_flags___0).bit_and ((-2))
						end
						l_c := ((l_flags___0.to_natural_32).bit_shift_right (24)).to_integer_32
						if l_c /= 0 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 29 -- goto _L
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 28 then -- else:
						if l_curi[l_depth___1] /= 2 then
							l_pos := -1 + 30 -- skip if block
						end
				when 29 then -- if: | _L:
						dump_word (l_slang, l_word, a_pat, a_dir___0, l_dumpflags, l_flags___0, l_lnum)
						if a_pat.is_void then
							l_lnum := l_lnum + 1
						end
				when 30 then -- if done
						if l_c /= 0 then
							l_lnum := l_slang.item.dump_prefixes (l_word, a_pat, a_dir___0, l_dumpflags, l_flags___0, l_lnum)
						end
				when 31 then -- if done | if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:
						l_tmp___5 := l_depth___1
						l_depth___1 := l_depth___1 + 1
						l_word[l_tmp___5] := l_c.to_natural_8
						l_arridx[l_depth___1] := l_idxs[l_n]
						l_curi[l_depth___1] := 1
						if l_depth___1 <= l_patlen then
							if ((create {P_MBYTE_STATIC}).mb_strnicmp (l_word, a_pat, l_depth___1.to_natural_32)) /= 0 then
								l_depth___1 := l_depth___1 - 1
							end
						end
				when 33 then -- if done | if done
						l_pos := -1 + 7 -- back to loop condition
				when 34 then -- loop done
						l_break := False
				when 35 then -- if done
						if (not l_return) then
							l_round := l_round + 1
						end
						l_pos := -1 + 4 -- back to loop condition
				when 36 then -- loop done
						l_continue := False
				when 37 then -- if done
						if (not l_return) then
							l_lpi := l_lpi + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 38 then -- loop done
					l_continue := False
				when 39 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dump_word (a_slang: CE_POINTER [PD_SLANG_S]; a_word, a_pat: CE_POINTER [NATURAL_8]; a_dir___0: CE_POINTER [INTEGER_32]; a_dumpflags, a_wordflags: INTEGER_32; a_lnum: INTEGER_32)
		local
			l_keepcap: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tw: CE_POINTER [NATURAL_8]
			l_cword: CE_ARRAY [NATURAL_8]
			l_badword: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_flags___0: INTEGER_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_tmp___5: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_cword.make (<<250>>)
			create {CE_NATURAL_8_ARRAY} l_badword.make (<<260>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_keepcap := 0
					l_flags___0 := a_wordflags
					if ((a_dumpflags).bit_and (8)).to_boolean then
						l_flags___0 := (l_flags___0).bit_or ((2))
					end
					if ((a_dumpflags).bit_and (16)).to_boolean then
						l_flags___0 := (l_flags___0).bit_or ((4))
					end
					if ((a_dumpflags).bit_and (1)) /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((l_flags___0).bit_and (198)) /= 0 then
							make_case_word (a_word, l_cword, l_flags___0)
							l_p___0 := l_cword
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_p___0 := a_word
						if ((a_dumpflags).bit_and (1)).to_boolean then
							if (((captype (a_word, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)))).bit_and (128)) = 0 then
								l_keepcap := 1
							elseif ((l_flags___0).bit_and (64)) /= 0 then
								l_keepcap := 1
							end
						end
				when 4 then
					l_tw := l_p___0
					if not (a_pat.is_void) then
						l_pos := -1 + 12 -- skip if block
					end
				when 5 then -- if:
						if not (((l_flags___0).bit_and (25)).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L___0
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if not (l_keepcap.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L___0:
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_badword), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0)).do_nothing
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_badword), ce_string ("/")).do_nothing
						if l_keepcap.to_boolean then
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_badword), ce_string ("=")).do_nothing
						end
						if ((l_flags___0).bit_and (16)).to_boolean then
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_badword), ce_string ("!")).do_nothing
						elseif ((l_flags___0).bit_and (8)).to_boolean then
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_badword), ce_string ("?")).do_nothing
						end
						if ((l_flags___0).bit_and (1)).to_boolean then
							l_i___0 := 0
							from
							until
								not (l_i___0 < 7)
							loop
								if ((l_flags___0).bit_and (((65_536).bit_shift_left (l_i___0)))).to_boolean then
									sprintf ([(create {CE_INTEGER_8_POINTER}.make_cast (l_badword) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_badword))).to_integer_32), ce_string ("%%d"), l_i___0 + 1]).do_nothing
								end
								l_i___0 := l_i___0 + 1
							end
						end
						l_p___0 := l_badword
				when 10 then -- if done
						if ((a_dumpflags).bit_and (2)).to_boolean then
							l_hi___1 := (create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_wordcount"))).item.hash_find (l_tw)
							if not ((l_hi___1.item.hi_key).is_void) then
								if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
									(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, ce_string ("%%s%T%%d"), l_tw, ((create {CE_CLASS_POINTER [PD_WORDCOUNT_S]}.make_cast ((l_hi___1.item.hi_key - (((dumwc.item.item.wc_word).distance ((create {CE_NATURAL_8_POINTER}.make_cast (dumwc.item)))).to_natural_32).to_integer_32))).item.wc_count).to_integer_32]).do_nothing
									l_p___0 := (create {P_GLOBALS_STATIC}).IObuff.item
								end
							end
						end
						(create {P_MEMLINE_STATIC}).ml_append (a_lnum, l_p___0, 0, 0).do_nothing
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						if ((a_dumpflags).bit_and (4)).to_boolean then
							l_tmp___5 := (((create {P_MBYTE_STATIC}).mb_strnicmp (l_p___0, a_pat, ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_pat))).to_integer_32).to_natural_32)) = 0).to_integer
						else
							l_tmp___5 := ((strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), create {CE_INTEGER_8_POINTER}.make_cast (a_pat), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_pat))))) = 0).to_integer
						end
						if l_tmp___5.to_boolean then
							if ((create {P_EDIT_STATIC}).ins_compl_add_infercase (l_p___0, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32, (create {P_OPTION_STATIC}).p_ic.item.item, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), a_dir___0.item, 0)) = 1 then
								a_dir___0.item := 1
							end
						end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_word_start (a_startcol: INTEGER_32): INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_col := 0
			if (((create {P_GLOBALS_STATIC}).curwin.item).item.no_spell_checking).to_boolean then
				Result := a_startcol
				l_return := True
			end
			if not l_return then
				l_line := (create {P_MEMLINE_STATIC}).ml_get_curline
				l_p___0 := l_line + a_startcol
				from
				until
					not (not (l_break) and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_line.c_pointer.to_integer_32).to_natural_32))
				loop
					l_break := False
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp___1 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_line, l_p___0 - 1])) + 1
					else
						l_tmp___1 := 1
					end
					l_p___0 := l_p___0 - l_tmp___1
					if (spell_iswordp_nmw (l_p___0)).to_boolean then
						l_break := True
					end
				end
				l_break := False
				from
				until
					not (not (l_break) and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_line.c_pointer.to_integer_32).to_natural_32))
				loop
					l_break := False
					l_col := l_p___0.distance (l_line)
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp___4 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_line, l_p___0 - 1])) + 1
					else
						l_tmp___4 := 1
					end
					l_p___0 := l_p___0 - l_tmp___4
					if not (((create {P_GLOBALS_STATIC}).curwin.item).item.spell_iswordp (l_p___0)).to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_col := 0
					end
				end
				l_break := False
				Result := l_col
			end
		end

	spell_expand_check_cap (a_col: INTEGER_32)
		do
			spell_expand_need_cap.item := check_need_cap ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, a_col)
		end

	expand_spelling (a_lnum: INTEGER_32; a_pat: CE_POINTER [NATURAL_8]; a_matchp: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		require
			not a_matchp.is_void
		local
			l_ga: CE_ARRAY [PD_GROWARRAY]
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)

			l_ga.item.spell_suggest_list (a_pat, 100, spell_expand_need_cap.item, 1)
			a_matchp.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data)
			Result := (l_ga.item.ga_len)
		end

feature {ANY} -- routine addresses

	spell_load_cb_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent spell_load_cb)
		end

	rep_compare_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rep_compare)
		end

	ex_spellrepall_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_spellrepall)
		end

	sug_compare_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent sug_compare)
		end

	ex_spellinfo_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_spellinfo)
		end

	ex_spelldump_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_spelldump)
		end

end
