class
	PD_SUGINFO_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_WCTYPE_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create su_ga.make
			create su_sga.make
			create {CE_NATURAL_8_POINTER} su_badptr.make
			create {CE_NATURAL_8_ARRAY} su_badword.make (<<250>>)
			create {CE_NATURAL_8_ARRAY} su_fbadword.make (<<250>>)
			create {CE_NATURAL_8_ARRAY} su_sal_badword.make (<<250>>)
			create su_banned.make
			create {CE_CLASS_POINTER [PD_SLANG_S]} su_sallang.make
			Precursor
		end

feature {ANY} -- fields

	su_ga: PD_GROWARRAY assign set_su_ga

	su_maxcount: INTEGER_32 assign set_su_maxcount

	su_maxscore: INTEGER_32 assign set_su_maxscore

	su_sfmaxscore: INTEGER_32 assign set_su_sfmaxscore

	su_sga: PD_GROWARRAY assign set_su_sga

	su_badptr: CE_POINTER [NATURAL_8] assign set_su_badptr

	su_badlen: INTEGER_32 assign set_su_badlen

	su_badflags: INTEGER_32 assign set_su_badflags

	su_badword: CE_ARRAY [NATURAL_8]

	su_fbadword: CE_ARRAY [NATURAL_8]

	su_sal_badword: CE_ARRAY [NATURAL_8]

	su_banned: PD_HASHTABLE_S assign set_su_banned

	su_sallang: CE_POINTER [PD_SLANG_S] assign set_su_sallang

feature {ANY} -- field setters

	set_su_ga (a_su_ga: PD_GROWARRAY)
		do
			su_ga := a_su_ga
			update_memory_field ("su_ga")
		end

	set_su_maxcount (a_su_maxcount: INTEGER_32)
		do
			su_maxcount := a_su_maxcount
			update_memory_field ("su_maxcount")
		end

	set_su_maxscore (a_su_maxscore: INTEGER_32)
		do
			su_maxscore := a_su_maxscore
			update_memory_field ("su_maxscore")
		end

	set_su_sfmaxscore (a_su_sfmaxscore: INTEGER_32)
		do
			su_sfmaxscore := a_su_sfmaxscore
			update_memory_field ("su_sfmaxscore")
		end

	set_su_sga (a_su_sga: PD_GROWARRAY)
		do
			su_sga := a_su_sga
			update_memory_field ("su_sga")
		end

	set_su_badptr (a_su_badptr: CE_POINTER [NATURAL_8])
		do
			su_badptr := a_su_badptr
			update_memory_field ("su_badptr")
		end

	set_su_badlen (a_su_badlen: INTEGER_32)
		do
			su_badlen := a_su_badlen
			update_memory_field ("su_badlen")
		end

	set_su_badflags (a_su_badflags: INTEGER_32)
		do
			su_badflags := a_su_badflags
			update_memory_field ("su_badflags")
		end

	set_su_banned (a_su_banned: PD_HASHTABLE_S)
		do
			su_banned := a_su_banned
			update_memory_field ("su_banned")
		end

	set_su_sallang (a_su_sallang: CE_POINTER [PD_SLANG_S])
		do
			su_sallang := a_su_sallang
			update_memory_field ("su_sallang")
		end

feature {PD_SUGINFO_S} -- private attributes

	dumsft: CE_STATIC [CE_ARRAY [PD_SFTWORD_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_SFTWORD_T]}.make (<<1>>)
		end

feature {ANY} -- public routines

	spell_suggest_expr (a_expr: CE_POINTER [NATURAL_8])
		require
			not a_expr.is_void
		local
			l_list: CE_POINTER [PD_LISTVAR_S]
			l_li: CE_POINTER [PD_LISTITEM_S]
			l_score: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			l_list := eval_spell_expr (su_badword, a_expr)
			update_class_fields -- Current might have been changed; synchronize
			if not l_list.is_void then
				l_li := l_list.item.lv_first
				from
				until
					l_li.is_void
				loop
					if (l_li.item.li_tv.v_type).to_integer_32 = 4 then
						l_score := get_spellword (l_li.item.li_tv.vval.v_list, l_p___0)
						update_class_fields -- Current might have been changed; synchronize
						if l_score >= 0 then
							if l_score <= su_maxscore then
								((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer))).item.add_suggestion (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), l_p___0.item, su_badlen, l_score, 0, 1, su_sallang, 0)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
					l_li := l_li.item.li_next
				end
				(create {P_EVAL_STATIC}).list_unref (l_list)
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_SPELL_STATIC}).check_suggestions ((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")))
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga"))).item.cleanup_suggestions (su_maxscore, su_maxcount).do_nothing
			update_class_fields -- Current might have been changed; synchronize
		end

	spell_find_cleanup
		local
			l_i___0: INTEGER_32
		do
			l_i___0 := 0
			from
			until
				not (l_i___0 < su_ga.ga_len)
			loop
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (su_ga.ga_data) + l_i___0).item.st_word))
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := l_i___0 + 1
			end
			(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga"))).item.ga_clear
			update_class_fields -- Current might have been changed; synchronize
			l_i___0 := 0
			from
			until
				not (l_i___0 < su_sga.ga_len)
			loop
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (su_sga.ga_data) + l_i___0).item.st_word))
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := l_i___0 + 1
			end
			(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_sga"))).item.ga_clear
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_banned"))).item.hash_clear_all (0)
			update_class_fields -- Current might have been changed; synchronize
		end

	suggest_try_special
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_c: INTEGER_32
			l_word: CE_ARRAY [NATURAL_8]
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_word.make (<<250>>)

			l_p___0 := (create {P_CHARSET_STATIC}).skiptowhite (su_fbadword)
			update_class_fields -- Current might have been changed; synchronize
			l_len := (l_p___0.distance (su_fbadword)).to_natural_32
			l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp = l_len then
				l_tmp___0 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (su_fbadword), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), l_len)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0 = 0 then
					l_c := (su_fbadword[l_len.to_integer_32]).to_integer_32
					su_fbadword[l_len.to_integer_32] := (('%/0/').code).to_natural_8
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_SPELL_STATIC}).make_case_word (su_fbadword, l_word, su_badflags)
					update_class_fields -- Current might have been changed; synchronize
					su_fbadword[l_len.to_integer_32] := l_c.to_natural_8
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer))).item.add_suggestion (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), l_word, su_badlen, 48, 0, 1, su_sallang, 0)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	suggest_try_change
		local
			l_fword: CE_ARRAY [NATURAL_8]
			l_n: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_lpi: INTEGER_32
			l_lp: CE_POINTER [PD_LANGP_S]
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_continue: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_fword.make (<<250>>)

			strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_fword), create {CE_INTEGER_8_POINTER}.make_cast (su_fbadword)).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fword))
			update_class_fields -- Current might have been changed; synchronize
			l_n := l_tmp.to_integer_32
			l_p___0 := su_badptr + su_badlen
			l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SPELL_STATIC}).spell_casefold (l_p___0, l_tmp___0.to_integer_32, l_fword + l_n, 250 - l_n).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_lpi := 0
			from
			until
				not (l_lpi < ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_len)
			loop
				l_continue := False
				l_lp := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_data) + l_lpi
				if ((l_lp.item.lp_slang).item.sl_fbyts).is_void then
					l_continue := True
				end
				if not (l_continue) then
					suggest_trie_walk ((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer)), l_lp, l_fword, 0)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_lpi := l_lpi + 1
			end
			l_continue := False
		end

	score_comp_sal
		local
			l_lp: CE_POINTER [PD_LANGP_S]
			l_badsound: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_stp: CE_POINTER [PD_SUGGEST_S]
			l_sstp: CE_POINTER [PD_SUGGEST_S]
			l_score: INTEGER_32
			l_lpi: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_badsound.make (<<250>>)

			l_tmp := (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_sga"))).item.ga_grow (su_ga.ga_len)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp = 0 then
				l_return := True
			end
			if not l_return then
				l_lpi := 0
				from
				until
					not (not (l_return or l_break) and then (l_lpi < ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_len))
				loop
					l_break := False
					l_lp := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_data) + l_lpi
					if (l_lp.item.lp_slang).item.sl_sal.ga_len > 0 then
						(l_lp.item.lp_slang).item.spell_soundfold (su_fbadword, 1, l_badsound)
						update_class_fields -- Current might have been changed; synchronize
						l_i___0 := 0
						from
						until
							not (l_i___0 < su_ga.ga_len)
						loop
							l_stp := create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (su_ga.ga_data) + l_i___0
							l_score := stp_sal_score (l_stp, (create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer)), l_lp.item.lp_slang, l_badsound)
							update_class_fields -- Current might have been changed; synchronize
							if l_score < 999_999 then
								l_sstp := create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (su_sga.ga_data) + su_sga.ga_len
								l_sstp.item.st_word := (create {P_MISC2_STATIC}).vim_strsave (l_stp.item.st_word)
								update_class_fields -- Current might have been changed; synchronize
								if not (l_sstp.item.st_word).is_void then
									l_sstp.item.st_wordlen := l_stp.item.st_wordlen
									update_class_fields -- Current might have been changed; synchronize
									l_sstp.item.st_score := l_score
									update_class_fields -- Current might have been changed; synchronize
									l_sstp.item.st_altscore := 0
									update_class_fields -- Current might have been changed; synchronize
									l_sstp.item.st_orglen := l_stp.item.st_orglen
									update_class_fields -- Current might have been changed; synchronize
									su_sga.ga_len := (su_sga.ga_len) + 1
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_i___0 := l_i___0 + 1
						end
						l_break := True
					end
					if not (l_return or l_break) then
						l_lpi := l_lpi + 1
					end
				end
				l_break := False
			end
		end

	score_combine
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_lp: CE_POINTER [PD_LANGP_S]
			l_stp: CE_POINTER [PD_SUGGEST_S]
			l_p___0: CE_POINTER [NATURAL_8]
			l_badsound: CE_ARRAY [NATURAL_8]
			l_round: INTEGER_32
			l_lpi: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_badsound.make (<<250>>)

			l_slang := create {CE_CLASS_POINTER [PD_SLANG_S]}.make_shared (default_pointer)
			l_lpi := 0
			from
			until
				not (not (l_return or l_break) and then (l_lpi < ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_len))
			loop
				l_break := False
				l_lp := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_data) + l_lpi
				if (l_lp.item.lp_slang).item.sl_sal.ga_len > 0 then
					l_slang := l_lp.item.lp_slang
					l_slang.item.spell_soundfold (su_fbadword, 1, l_badsound)
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := 0
					from
					until
						not (l_i___0 < su_ga.ga_len)
					loop
						l_stp := create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (su_ga.ga_data) + l_i___0
						l_stp.item.st_altscore := stp_sal_score (l_stp, (create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer)), l_slang, l_badsound)
						update_class_fields -- Current might have been changed; synchronize
						if l_stp.item.st_altscore = 999_999 then
							l_stp.item.st_score := (l_stp.item.st_score * 3 + 288) // 4
							update_class_fields -- Current might have been changed; synchronize
						else
							l_stp.item.st_score := (l_stp.item.st_score * 3 + l_stp.item.st_altscore) // 4
							update_class_fields -- Current might have been changed; synchronize
						end
						l_stp.item.st_salscore := 0
						update_class_fields -- Current might have been changed; synchronize
						l_i___0 := l_i___0 + 1
					end
					l_break := True
				end
				if not (l_return or l_break) then
					l_lpi := l_lpi + 1
				end
			end
			l_break := False
			if l_slang.is_void then
				(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga"))).item.cleanup_suggestions (su_maxscore, su_maxcount).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_i___0 := 0
				from
				until
					not (l_i___0 < su_sga.ga_len)
				loop
					l_stp := create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (su_sga.ga_data) + l_i___0
					l_stp.item.st_altscore := spell_edit_score (l_slang, su_badword, l_stp.item.st_word)
					update_class_fields -- Current might have been changed; synchronize
					if l_stp.item.st_score = 999_999 then
						l_stp.item.st_score := (2_016 + l_stp.item.st_altscore) // 8
						update_class_fields -- Current might have been changed; synchronize
					else
						l_stp.item.st_score := (l_stp.item.st_score * 7 + l_stp.item.st_altscore) // 8
						update_class_fields -- Current might have been changed; synchronize
					end
					l_stp.item.st_salscore := 1
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := l_i___0 + 1
				end
				(create {P_SPELL_STATIC}).check_suggestions ((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")))
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga"))).item.cleanup_suggestions (su_maxscore, su_maxcount).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SPELL_STATIC}).check_suggestions ((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_sga")))
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_sga"))).item.cleanup_suggestions (su_maxscore, su_maxcount).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_ga.item.ga_init2 (((create {PD_SUGINFO_S}.make).structure_size.to_natural_32).to_integer_32, 1)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := l_ga.item.ga_grow (su_ga.ga_len + su_sga.ga_len)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp = 0 then
					l_return := True
				end
			end
			if not l_return then
				l_stp := create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (l_ga.item.ga_data) + 0
				l_i___0 := 0
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if not (l_i___0 < su_ga.ga_len) then
						if not (l_i___0 < su_sga.ga_len) then
							l_break := True
						end
					end
					if not (l_return or l_break) then
						l_round := 1
						from
						until
							not (not (l_return) and then (l_round <= 2))
						loop
							if l_round = 1 then
								l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga"))
							else
								l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_sga"))
							end
							if l_i___0 < l_gap.item.ga_len then
								l_p___0 := (create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (l_gap.item.ga_data) + l_i___0).item.st_word
								l_j := 0
								from
								until
									not (not (l_break) and then (l_j < l_ga.item.ga_len))
								loop
									l_break := False
									l_tmp___0 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_stp + l_j).item.st_word), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___0 = 0 then
										l_break := True
									end
									if not (l_return or l_break) then
										l_j := l_j + 1
									end
								end
								l_break := False
								if l_j = l_ga.item.ga_len then
									l_tmp___1 := l_ga.item.ga_len
									l_ga.item.ga_len := (l_ga.item.ga_len) + 1
									update_class_fields -- Current might have been changed; synchronize
									l_stp[l_tmp___1] := (create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (l_gap.item.ga_data)[l_i___0]).twin
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_round := l_round + 1
						end
						l_i___0 := l_i___0 + 1
					end
				end
				l_break := False;
				(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga"))).item.ga_clear
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_sga"))).item.ga_clear
				update_class_fields -- Current might have been changed; synchronize
				if l_ga.item.ga_len > su_maxcount then
					l_i___0 := su_maxcount
					from
					until
						not (l_i___0 < l_ga.item.ga_len)
					loop
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((l_stp + l_i___0).item.st_word))
						update_class_fields -- Current might have been changed; synchronize
						l_i___0 := l_i___0 + 1
					end
					l_ga.item.ga_len := su_maxcount
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.su_ga := (l_ga.item).twin
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	add_suggestion (a_gap: CE_POINTER [PD_GROWARRAY]; a_goodword: CE_POINTER [NATURAL_8]; a_badlenarg, a_score, a_altscore, a_had_bonus: INTEGER_32; a_slang: CE_POINTER [PD_SLANG_S]; a_maxsf: INTEGER_32)
		local
			l_goodlen: INTEGER_32
			l_badlen: INTEGER_32
			l_stp: CE_POINTER [PD_SUGGEST_S]
			l_new_sug: CE_ARRAY [PD_SUGGEST_S]
			l_i___0: INTEGER_32
			l_pgood: CE_POINTER [NATURAL_8]
			l_pbad: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_SUGGEST_S]} l_new_sug.make (<<1>>)

			l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_goodword))
			update_class_fields -- Current might have been changed; synchronize
			l_pgood := a_goodword + l_tmp.to_integer_32
			l_pbad := su_badptr + a_badlenarg
			from
			until
				(l_break)
			loop
				l_break := False
				l_goodlen := l_pgood.distance (a_goodword)
				l_badlen := l_pbad.distance (su_badptr)
				if l_goodlen <= 0 then
					l_break := True
				elseif l_badlen <= 0 then
					l_break := True
				end
				if not (l_break) then
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp___0 := (create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([a_goodword, l_pgood - 1])
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := l_tmp___0 + 1
					else
						l_tmp___1 := 1
					end
					l_pgood := l_pgood - l_tmp___1
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp___2 := (create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([su_badptr, l_pbad - 1])
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___3 := l_tmp___2 + 1
					else
						l_tmp___3 := 1
					end
					l_pbad := l_pbad - l_tmp___3
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp___4 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_pgood])
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___5 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_pbad])
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___4 /= l_tmp___5 then
							l_break := True
						end
					elseif (l_pgood.item).to_integer_32 /= (l_pbad.item).to_integer_32 then
						l_break := True
					end
				end
			end
			l_break := False
			if l_badlen = 0 then
				if l_goodlen = 0 then
					l_return := True
				end
			end
			if not l_return then
				if a_gap.item.ga_len = 0 then
					l_i___0 := -1
				else
					l_stp := create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (a_gap.item.ga_data) + 0
					l_i___0 := a_gap.item.ga_len
					from
					until
						(l_break)
					loop
						l_break := False
						l_i___0 := l_i___0 - 1
						if not (l_i___0 >= 0) then
							l_break := True
						end
						if not (l_break) and then (l_stp.item.st_wordlen = l_goodlen) then
							if l_stp.item.st_orglen = l_badlen then
								l_tmp___6 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_stp.item.st_word), create {CE_INTEGER_8_POINTER}.make_cast (a_goodword), l_goodlen.to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___6 = 0 then
									if (l_stp.item.st_slang).is_void then
										l_stp.item.st_slang := a_slang
										update_class_fields -- Current might have been changed; synchronize
									end
									l_new_sug.item.st_score := a_score
									update_class_fields -- Current might have been changed; synchronize
									l_new_sug.item.st_altscore := a_altscore
									update_class_fields -- Current might have been changed; synchronize
									l_new_sug.item.st_had_bonus := a_had_bonus
									update_class_fields -- Current might have been changed; synchronize
									if l_stp.item.st_had_bonus /= a_had_bonus then
										if a_had_bonus.to_boolean then
											rescore_one ((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer)), l_stp)
											update_class_fields -- Current might have been changed; synchronize
										else
											l_new_sug.item.st_word := l_stp.item.st_word
											update_class_fields -- Current might have been changed; synchronize
											l_new_sug.item.st_wordlen := l_stp.item.st_wordlen
											update_class_fields -- Current might have been changed; synchronize
											l_new_sug.item.st_slang := l_stp.item.st_slang
											update_class_fields -- Current might have been changed; synchronize
											l_new_sug.item.st_orglen := l_badlen
											update_class_fields -- Current might have been changed; synchronize
											rescore_one ((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer)), l_new_sug)
											update_class_fields -- Current might have been changed; synchronize
										end
									end
									if l_stp.item.st_score > l_new_sug.item.st_score then
										l_stp.item.st_score := l_new_sug.item.st_score
										update_class_fields -- Current might have been changed; synchronize
										l_stp.item.st_altscore := l_new_sug.item.st_altscore
										update_class_fields -- Current might have been changed; synchronize
										l_stp.item.st_had_bonus := l_new_sug.item.st_had_bonus
										update_class_fields -- Current might have been changed; synchronize
									end
									l_break := True
								end
							end
						end
						if not (l_break) then
							l_stp := l_stp + 1
						end
					end
					l_break := False
				end
				if l_i___0 < 0 then
					l_tmp___10 := a_gap.item.ga_grow (1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___10 = 1 then
						l_stp := create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len
						l_stp.item.st_word := (create {P_MISC2_STATIC}).vim_strnsave (a_goodword, l_goodlen)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_stp.item.st_word).is_void then
							l_stp.item.st_wordlen := l_goodlen
							update_class_fields -- Current might have been changed; synchronize
							l_stp.item.st_score := a_score
							update_class_fields -- Current might have been changed; synchronize
							l_stp.item.st_altscore := a_altscore
							update_class_fields -- Current might have been changed; synchronize
							l_stp.item.st_had_bonus := a_had_bonus
							update_class_fields -- Current might have been changed; synchronize
							l_stp.item.st_orglen := l_badlen
							update_class_fields -- Current might have been changed; synchronize
							l_stp.item.st_slang := a_slang
							update_class_fields -- Current might have been changed; synchronize
							a_gap.item.ga_len := (a_gap.item.ga_len) + 1
							update_class_fields -- Current might have been changed; synchronize
							if su_maxcount < 130 then
								l_tmp___9 := 150
							else
								l_tmp___9 := su_maxcount + 20
							end
							if a_gap.item.ga_len > l_tmp___9 + 50 then
								if a_maxsf.to_boolean then
									if su_maxcount < 130 then
										l_tmp___7 := 150
									else
										l_tmp___7 := su_maxcount + 20
									end
									Current.su_sfmaxscore := a_gap.item.cleanup_suggestions (su_sfmaxscore, l_tmp___7)
									update_class_fields -- Current might have been changed; synchronize
								else
									l_i___0 := su_maxscore
									if su_maxcount < 130 then
										l_tmp___8 := 150
									else
										l_tmp___8 := su_maxcount + 20
									end
									Current.su_maxscore := a_gap.item.cleanup_suggestions (su_maxscore, l_tmp___8)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
					end
				end
			end
		end

	rescore_suggestions
		local
			l_i___0: INTEGER_32
		do
			if not su_sallang.is_void then
				l_i___0 := 0
				from
				until
					not (l_i___0 < su_ga.ga_len)
				loop
					rescore_one ((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_SUGGEST_S]}.make_cast (su_ga.ga_data) + l_i___0)
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := l_i___0 + 1
				end
			end
		end

	spell_suggest_intern (a_interactive: INTEGER_32)
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			suggest_load_files
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer))).item.suggest_try_special
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer))).item.suggest_try_change
			update_class_fields -- Current might have been changed; synchronize
			if (((create {P_SPELL_STATIC}).sps_flags.item).bit_and (4)).to_boolean then
				((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer))).item.score_comp_sal
				update_class_fields -- Current might have been changed; synchronize
			end
			if (((create {P_SPELL_STATIC}).sps_flags.item).bit_and (2)) = 0 then
				if (((create {P_SPELL_STATIC}).sps_flags.item).bit_and (1)).to_boolean then
					((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer))).item.rescore_suggestions
					update_class_fields -- Current might have been changed; synchronize
				end
				suggest_try_soundalike_prep
				update_class_fields -- Current might have been changed; synchronize
				Current.su_maxscore := 200
				update_class_fields -- Current might have been changed; synchronize
				Current.su_sfmaxscore := 1_050
				update_class_fields -- Current might have been changed; synchronize
				suggest_try_soundalike ((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer)))
				update_class_fields -- Current might have been changed; synchronize
				if su_maxcount < 130 then
					l_tmp___0 := 150
				else
					l_tmp___0 := su_maxcount + 20
				end
				if su_ga.ga_len < l_tmp___0 then
					Current.su_maxscore := 300
					update_class_fields -- Current might have been changed; synchronize
					suggest_try_soundalike ((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
					if su_maxcount < 130 then
						l_tmp := 150
					else
						l_tmp := su_maxcount + 20
					end
					if su_ga.ga_len < l_tmp then
						Current.su_maxscore := 400
						update_class_fields -- Current might have been changed; synchronize
						suggest_try_soundalike ((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer)))
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				Current.su_maxscore := su_sfmaxscore
				update_class_fields -- Current might have been changed; synchronize
				suggest_try_soundalike_finish
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_UI_STATIC}).ui_breakcheck
			update_class_fields -- Current might have been changed; synchronize
			if a_interactive.to_boolean then
				if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
					(create {P_GETCHAR_STATIC}).vgetc.do_nothing
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GLOBALS_STATIC}).got_int.item := 0
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if (((create {P_SPELL_STATIC}).sps_flags.item).bit_and (4)) = 0 then
				if su_ga.ga_len /= 0 then
					if (((create {P_SPELL_STATIC}).sps_flags.item).bit_and (1)).to_boolean then
						((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer))).item.rescore_suggestions
						update_class_fields -- Current might have been changed; synchronize
					end
					(create {P_SPELL_STATIC}).check_suggestions ((create {CE_CLASS_POINTER [PD_SUGINFO_S]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")))
					update_class_fields; -- Current might have been changed; synchronize
					(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga"))).item.cleanup_suggestions (su_maxscore, su_maxcount).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

feature {PD_SUGINFO_S} -- private routines

	rescore_one (a_su: CE_POINTER [PD_SUGINFO_S]; a_stp: CE_POINTER [PD_SUGGEST_S])
		require
			not a_stp.is_void
		local
			l_slang: CE_POINTER [PD_SLANG_S]
			l_sal_badword: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_sal_badword.make (<<250>>)

			l_slang := a_stp.item.st_slang
			if not l_slang.is_void then
				if l_slang.item.sl_sal.ga_len > 0 then
					if not (a_stp.item.st_had_bonus).to_boolean then
						if l_slang.is_equal (a_su.item.su_sallang) then
							l_p___0 := a_su.item.su_sal_badword
						else
							l_slang.item.spell_soundfold (a_su.item.su_fbadword, 1, l_sal_badword)
							l_p___0 := l_sal_badword
						end
						a_stp.item.st_altscore := stp_sal_score (a_stp, a_su, l_slang, l_p___0)
						if a_stp.item.st_altscore = 999_999 then
							a_stp.item.st_altscore := 288
						end
						a_stp.item.st_score := (3 * a_stp.item.st_score + a_stp.item.st_altscore) // 4
						a_stp.item.st_had_bonus := 1
					end
				end
			end
		end

	stp_sal_score (a_stp: CE_POINTER [PD_SUGGEST_S]; a_su: CE_POINTER [PD_SUGINFO_S]; a_slang: CE_POINTER [PD_SLANG_S]; a_badsound: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_stp.is_void
			not a_su.is_void
			not a_slang.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_pbad: CE_POINTER [NATURAL_8]
			l_pgood: CE_POINTER [NATURAL_8]
			l_badsound2: CE_ARRAY [NATURAL_8]
			l_fword: CE_ARRAY [NATURAL_8]
			l_goodsound: CE_ARRAY [NATURAL_8]
			l_goodword: CE_ARRAY [NATURAL_8]
			l_lendiff: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_badsound2.make (<<250>>)
			create {CE_NATURAL_8_ARRAY} l_fword.make (<<250>>)
			create {CE_NATURAL_8_ARRAY} l_goodsound.make (<<250>>)
			create {CE_NATURAL_8_ARRAY} l_goodword.make (<<250>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lendiff := a_su.item.su_badlen - a_stp.item.st_orglen
					if not (l_lendiff >= 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pbad := a_badsound
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 3 then -- else:;
						(create {P_SPELL_STATIC}).spell_casefold (a_su.item.su_badptr, a_stp.item.st_orglen, l_fword, 250).do_nothing
						if (a_su.item.su_badptr[a_su.item.su_badlen]).to_integer_32 /= 32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if (a_su.item.su_badptr[a_su.item.su_badlen]).to_integer_32 /= 9 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if (((create {P_CHARSET_STATIC}).skiptowhite (a_stp.item.st_word)).item).to_integer_32 = 0 then
							l_p___0 := l_fword
							from
							until
								(l_break)
							loop
								l_break := False
								l_p___0 := (create {P_CHARSET_STATIC}).skiptowhite (l_p___0)
								if (l_p___0.item).to_integer_32 = 0 then
									l_break := True
								end
								if not (l_break) then
									memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + 1)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 1)))) + {NATURAL_32} 1).do_nothing
								end
							end
							l_break := False
						end
				when 8 then -- if done
						a_slang.item.spell_soundfold (l_fword, 1, l_badsound2)
						l_pbad := l_badsound2
				when 9 then -- if done
					if l_lendiff > 0 then
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_goodword), create {CE_INTEGER_8_POINTER}.make_cast (a_stp.item.st_word)).do_nothing;
						(create {P_MISC2_STATIC}).vim_strncpy (l_goodword + a_stp.item.st_wordlen, (a_su.item.su_badptr + a_su.item.su_badlen) - l_lendiff, l_lendiff.to_natural_32)
						l_pgood := l_goodword
					else
						l_pgood := a_stp.item.st_word
					end
					a_slang.item.spell_soundfold (l_pgood, 0, l_goodsound)
					Result := (soundalike_score (l_goodsound, l_pbad))
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	eval_spell_expr (a_badword, a_expr: CE_POINTER [NATURAL_8]): CE_POINTER [PD_LISTVAR_S]
		require
			not a_expr.is_void
		local
			l_save_val: CE_ARRAY [PD_TYPVAL_T]
			l_rettv: CE_ARRAY [PD_TYPVAL_T]
			l_list: CE_POINTER [PD_LISTVAR_S]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
		do
			create {CE_CLASS_ARRAY [PD_TYPVAL_T]} l_save_val.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_TYPVAL_T]} l_rettv.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			l_list := create {CE_CLASS_POINTER [PD_LISTVAR_S]}.make_shared (default_pointer)
			l_p___0.item := ((create {P_CHARSET_STATIC}).skipwhite (a_expr));
			(create {P_EVAL_STATIC}).prepare_vimvar (34, l_save_val);
			(create {P_EVAL_STATIC}).vimvars.item[34].vv_di.di_tv.v_type := (2).to_integer_8;
			(create {P_EVAL_STATIC}).vimvars.item[34].vv_di.di_tv.vval.v_string := a_badword
			if (create {P_OPTION_STATIC}).p_verbose.item.item = 0 then
				(create {P_GLOBALS_STATIC}).emsg_off.item := (create {P_GLOBALS_STATIC}).emsg_off.item + 1
			end
			if ((create {P_EVAL_STATIC}).eval1 (l_p___0, l_rettv, 1)) = 1 then
				if (l_rettv.item.v_type).to_integer_32 /= 4 then
					(create {P_EVAL_STATIC}).clear_tv (l_rettv)
				else
					l_list := l_rettv.item.vval.v_list
				end
			end
			if (create {P_OPTION_STATIC}).p_verbose.item.item = 0 then
				(create {P_GLOBALS_STATIC}).emsg_off.item := (create {P_GLOBALS_STATIC}).emsg_off.item - 1
			end
			l_save_val.item.restore_vimvar (34)
			Result := l_list
		end

	get_spellword (a_list: CE_POINTER [PD_LISTVAR_S]; a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		require
			not a_list.is_void
		local
			l_li: CE_POINTER [PD_LISTITEM_S]
			l_return: BOOLEAN
		do
			l_li := a_list.item.lv_first
			if l_li.is_void then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				a_pp.item := (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (l_li.c_pointer + (create {PD_LISTITEM_S}.make).offset_of ("li_tv"))).item.get_tv_string
				l_li := l_li.item.li_next
				if l_li.is_void then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				Result := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (l_li.c_pointer + (create {PD_LISTITEM_S}.make).offset_of ("li_tv"))).item.get_tv_number).to_integer_32
			end
		end

	suggest_load_files
		local
			l_lp: CE_POINTER [PD_LANGP_S]
			l_lpi: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
			l_dotp: CE_POINTER [NATURAL_8]
			l_fd: CE_POINTER [SD_IO_FILE]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_timestamp: INTEGER_32
			l_wcount: INTEGER_32
			l_wordnr: INTEGER_32
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_c: INTEGER_32
			l_tmp___9: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<250>>)
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lpi := 0
				when 1 then -- loop condition:
					if not (not (l_return) and then (l_lpi < ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_len)) then
						l_pos := -1 + 24 -- skip loop
					end
				when 2 then -- loop body:
						l_continue := False
						l_lp := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_data) + l_lpi
						l_slang := l_lp.item.lp_slang
						if l_slang.item.sl_sugtime = 0 then
							l_pos := -1 + 23 -- skip if block
						end
				when 3 then -- if:
						if (l_slang.item.sl_sugloaded).to_boolean then
							l_pos := -1 + 23 -- skip if block
						end
				when 4 then -- if:
						l_slang.item.sl_sugloaded := 1
						l_dotp := (create {P_MISC2_STATIC}).vim_strrchr (l_slang.item.sl_fname, ('.').code)
						if l_dotp.is_void then
							l_continue := True
						elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_dotp), ce_string (".spl"))) /= 0 then
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 23 -- skip if block
						end
				when 5 then -- if:
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_dotp), ce_string (".sug")).do_nothing
						l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_slang.item.sl_fname), ce_string ("r"))
						if l_fd.is_void then
							l_pos := -1 + 22 -- goto nextone
						end
				when 6 then
						l_i___0 := 0
						from
						until
							not (l_i___0 < 6)
						loop
							l_buf___6[l_i___0] := (IO_getc (l_fd)).to_natural_8
							l_i___0 := l_i___0 + 1
						end
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("VIMsug"), (6).to_natural_32)) /= 0 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E778: This does not look like a .sug file: %%s")))), l_slang.item.sl_fname).do_nothing
							l_pos := -1 + 22 -- goto nextone
						end
				when 7 then
						l_c := IO_getc (l_fd)
						if l_c < 1 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E779: Old .sug file, needs to be updated: %%s")))), l_slang.item.sl_fname).do_nothing
							l_pos := -1 + 22 -- goto nextone
						elseif l_c > 1 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E780: .sug file is for newer version of Vim: %%s")))), l_slang.item.sl_fname).do_nothing
							l_pos := -1 + 22 -- goto nextone
						end
				when 8 then
						l_timestamp := (create {P_MISC2_STATIC}).get8ctime (l_fd)
						if l_timestamp /= l_slang.item.sl_sugtime then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E781: .sug file doesn%'t match .spl file: %%s")))), l_slang.item.sl_fname).do_nothing
							l_pos := -1 + 22 -- goto nextone
						end
				when 9 then
						if ((create {P_SPELL_STATIC}).spell_read_tree (l_fd, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sbyts")), create {CE_POINTER_POINTER [INTEGER_32]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sidxs")), 0, 0)) = 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | someerror:;
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E782: error while reading .sug file: %%s")))), l_slang.item.sl_fname).do_nothing
						l_slang.item.slang_clear_sug
						l_pos := -1 + 22 -- goto nextone
				when 11 then
						l_slang.item.sl_sugbuf := (create {P_SPELL_STATIC}).open_spellbuf
						if (l_slang.item.sl_sugbuf).is_void then
							l_pos := -1 + 10 -- goto someerror
						end
				when 12 then
						l_wcount := (create {P_MISC2_STATIC}).get4c (l_fd)
						if l_wcount < 0 then
							l_pos := -1 + 10 -- goto someerror
						end
				when 13 then
						l_ga.item.ga_init2 (1, 100)
						l_wordnr := 0
				when 14 then -- loop condition:
						if not (not (l_return) and then (l_wordnr < l_wcount)) then
							l_pos := -1 + 21 -- skip loop
						end
				when 15 then -- loop body:
						l_ga.item.ga_len := 0
				when 16 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 19 -- skip loop
						end
				when 17 then -- loop body:
						l_break := False
						l_c := IO_getc (l_fd)
						if l_c < 0 then
							l_pos := -1 + 10 -- goto someerror
						elseif (l_ga.item.ga_grow (1)) = 0 then
							l_pos := -1 + 10 -- goto someerror
						end
				when 18 then
						l_tmp___9 := l_ga.item.ga_len
						l_ga.item.ga_len := (l_ga.item.ga_len) + 1
						create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data)[l_tmp___9] := l_c.to_natural_8
						if l_c = 0 then
							l_break := True
						end
						l_pos := -1 + 16 -- back to loop condition
				when 19 then -- loop done
						l_break := False
						if ((l_slang.item.sl_sugbuf).item.ml_append_buf (l_wordnr.to_integer_32, create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data), l_ga.item.ga_len, 1)) = 0 then
							l_pos := -1 + 10 -- goto someerror
						end
				when 20 then
						l_wordnr := l_wordnr + 1
						l_pos := -1 + 14 -- back to loop condition
				when 21 then -- loop done
						l_ga.item.ga_clear
						tree_count_words (l_slang.item.sl_fbyts, l_slang.item.sl_fidxs)
						tree_count_words (l_slang.item.sl_sbyts, l_slang.item.sl_sidxs)
				when 22 then -- nextone:
						if not l_fd.is_void then
							fclose (l_fd).do_nothing
						end
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_dotp), ce_string (".spl")).do_nothing
				when 23 then -- if done | if done | if done
						if (not l_return) then
							l_lpi := l_lpi + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 24 then -- loop done
					l_continue := False
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tree_count_words (a_byts: CE_POINTER [NATURAL_8]; a_idxs: CE_POINTER [INTEGER_32])
		local
			l_depth___1: INTEGER_32
			l_arridx: CE_ARRAY [INTEGER_32]
			l_curi: CE_ARRAY [INTEGER_32]
			l_c: INTEGER_32
			l_n: INTEGER_32
			l_wordcount: CE_ARRAY [INTEGER_32]
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_arridx.make (<<250>>)
			create {CE_INTEGER_32_ARRAY} l_curi.make (<<250>>)
			create {CE_INTEGER_32_ARRAY} l_wordcount.make (<<250>>)

			l_arridx[0] := 0
			l_curi[0] := 1
			l_wordcount[0] := 0
			l_depth___1 := 0
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if l_depth___1 >= 0 then
					if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_return or l_break) then
					if l_curi[l_depth___1] > (a_byts[(l_arridx[l_depth___1])]).to_integer_32 then
						a_idxs[(l_arridx[l_depth___1])] := l_wordcount[l_depth___1]
						if l_depth___1 > 0 then
							l_wordcount[l_depth___1 - 1] := l_wordcount[l_depth___1 - 1] + (l_wordcount[l_depth___1])
						end
						l_depth___1 := l_depth___1 - 1;
						(create {P_MISC1_STATIC}).fast_breakcheck
					else
						l_n := l_arridx[l_depth___1] + l_curi[l_depth___1]
						l_curi[l_depth___1] := (l_curi[l_depth___1]) + 1
						l_c := (a_byts[l_n]).to_integer_32
						if l_c = 0 then
							l_wordcount[l_depth___1] := (l_wordcount[l_depth___1]) + 1
							from
							until
								(a_byts[(l_n + 1)]).to_integer_32 /= 0
							loop
								l_n := l_n + 1
								l_curi[l_depth___1] := (l_curi[l_depth___1]) + 1
							end
						else
							l_depth___1 := l_depth___1 + 1
							l_arridx[l_depth___1] := a_idxs[l_n]
							l_curi[l_depth___1] := 1
							l_wordcount[l_depth___1] := 0
						end
					end
				end
			end
			l_break := False
		end

	suggest_try_soundalike_prep
		local
			l_lp: CE_POINTER [PD_LANGP_S]
			l_lpi: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
		do
			l_lpi := 0
			from
			until
				not (l_lpi < ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_len)
			loop
				l_lp := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_data) + l_lpi
				l_slang := l_lp.item.lp_slang
				if l_slang.item.sl_sal.ga_len > 0 then
					if not (l_slang.item.sl_sbyts).is_void then
						(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sounddone"))).item.hash_init
					end
				end
				l_lpi := l_lpi + 1
			end
		end

	suggest_try_soundalike (a_su: CE_POINTER [PD_SUGINFO_S])
		local
			l_salword: CE_ARRAY [NATURAL_8]
			l_lp: CE_POINTER [PD_LANGP_S]
			l_lpi: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
		do
			create {CE_NATURAL_8_ARRAY} l_salword.make (<<250>>)

			l_lpi := 0
			from
			until
				not (l_lpi < ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_len)
			loop
				l_lp := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_data) + l_lpi
				l_slang := l_lp.item.lp_slang
				if l_slang.item.sl_sal.ga_len > 0 then
					if not (l_slang.item.sl_sbyts).is_void then
						l_slang.item.spell_soundfold (a_su.item.su_fbadword, 1, l_salword)
						suggest_trie_walk (a_su, l_lp, l_salword, 1)
					end
				end
				l_lpi := l_lpi + 1
			end
		end

	suggest_trie_walk (a_su: CE_POINTER [PD_SUGINFO_S]; a_lp: CE_POINTER [PD_LANGP_S]; a_fword: CE_POINTER [NATURAL_8]; a_soundfold: INTEGER_32)
		require
			not a_lp.is_void
		local
			l_tword: CE_ARRAY [NATURAL_8]
			l_stack: CE_ARRAY [PD_TRYSTATE_S]
			l_preword: CE_ARRAY [NATURAL_8]
			l_compflags: CE_ARRAY [NATURAL_8]
			l_sp: CE_POINTER [PD_TRYSTATE_S]
			l_newscore: INTEGER_32
			l_score: INTEGER_32
			l_byts: CE_POINTER [NATURAL_8]
			l_fbyts: CE_POINTER [NATURAL_8]
			l_pbyts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_fidxs: CE_POINTER [INTEGER_32]
			l_pidxs: CE_POINTER [INTEGER_32]
			l_depth___1: INTEGER_32
			l_c: INTEGER_32
			l_c2: INTEGER_32
			l_c3: INTEGER_32
			l_n: INTEGER_32
			l_flags___0: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_arridx: INTEGER_32
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_ftp: CE_POINTER [PD_FROMTO_S]
			l_fl: INTEGER_32
			l_tl: INTEGER_32
			l_repextra: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
			l_fword_ends: INTEGER_32
			l_goodword_ends: INTEGER_32
			l_breakcheckcount: INTEGER_32
			l_compound_ok: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___23: INTEGER_32
			l_tmp___26: INTEGER_32
			l_tmp___29: INTEGER_32
			l_try_compound: INTEGER_32
			l_try_split: INTEGER_32
			l_tmp___30: INTEGER_32
			l_l: INTEGER_32
			l_tmp___38: INTEGER_16
			l_tmp___39: NATURAL_8
			l_tmp___40: INTEGER_32
			l_tmp___48: INTEGER_32
			l_tmp___54: INTEGER_16
			l_tmp___55: NATURAL_8
			l_tmp___74: INTEGER_32
			l_tmp___79: INTEGER_32
			l_tmp___82: INTEGER_16
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_tword.make (<<250>>)
			create {CE_CLASS_ARRAY [PD_TRYSTATE_S]} l_stack.make (<<250>>)
			create {CE_NATURAL_8_ARRAY} l_preword.make (<<750>>)
			create {CE_NATURAL_8_ARRAY} l_compflags.make (<<250>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := 0
					l_fl := 0
					l_repextra := 0
					l_slang := a_lp.item.lp_slang
					l_breakcheckcount := 1_000
					l_depth___1 := 0
					l_sp := l_stack + 0
					memset (create {CE_VOID_POINTER}.make_cast (l_sp), 0, (create {PD_TRYSTATE_S}.make).structure_size.to_natural_32).do_nothing
					l_sp.item.ts_curi := (1).to_integer_16
					if a_soundfold.to_boolean then
						l_fbyts := l_slang.item.sl_sbyts
						l_byts := l_fbyts
						l_fidxs := l_slang.item.sl_sidxs
						l_idxs := l_fidxs
						l_pbyts := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_pidxs := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
						l_sp.item.ts_prefixdepth := (255).to_natural_8
						l_sp.item.ts_state := {PC_STATE_T}.STATE_START
					else
						l_fbyts := l_slang.item.sl_fbyts
						l_fidxs := l_slang.item.sl_fidxs
						l_pbyts := l_slang.item.sl_pbyts
						l_pidxs := l_slang.item.sl_pidxs
						if not l_pbyts.is_void then
							l_byts := l_pbyts
							l_idxs := l_pidxs
							l_sp.item.ts_prefixdepth := (254).to_natural_8
							l_sp.item.ts_state := {PC_STATE_T}.STATE_NOPREFIX
						else
							l_byts := l_fbyts
							l_idxs := l_fidxs
							l_sp.item.ts_prefixdepth := (255).to_natural_8
							l_sp.item.ts_state := {PC_STATE_T}.STATE_START
						end
					end
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 163 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if l_depth___1 >= 0 then
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 162 -- skip if block
						end
				when 3 then -- if:
						l_sp := l_stack + l_depth___1
						inspect (l_sp.item.ts_state).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 4
						when 1 then l_pos := -1 + 4
						when 2 then l_pos := -1 + 93
						when 3 then l_pos := -1 + 94
						when 4 then l_pos := -1 + 96
						when 5 then l_pos := -1 + 126
						when 6 then l_pos := -1 + 137
						when 7 then l_pos := -1 + 139
						when 8 then l_pos := -1 + 141
						when 9 then l_pos := -1 + 146
						when 10 then l_pos := -1 + 147
						when 11 then l_pos := -1 + 149
						when 12 then l_pos := -1 + 151
						when 13 then l_pos := -1 + 152
						when 14 then l_pos := -1 + 153
						when 15 then l_pos := -1 + 159
						when 16 then l_pos := -1 + 160
						else l_pos := -1 + 161
						end
				when 4 then -- switch 1, case 0 | switch 1, case 1
						l_arridx := l_sp.item.ts_arridx
						l_len := (l_byts[l_arridx]).to_integer_32
						l_arridx := l_arridx + (l_sp.item.ts_curi).to_integer_32
						if (l_sp.item.ts_prefixdepth).to_integer_32 /= 254 then
							l_pos := -1 + 11 -- skip if block
						end
				when 5 then -- if:
						l_n := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if l_n < l_len then
								if (l_byts[(l_arridx + l_n)]).to_integer_32 /= 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_n := l_n + 1
							end
						end
						l_break := False
						l_sp.item.ts_curi := ((l_sp.item.ts_curi).to_integer_32 + l_n).to_integer_16
						l_n := (l_sp.item.ts_state).to_integer_32
						l_sp.item.ts_state := {PC_STATE_T}.STATE_ENDNUL
						l_sp.item.ts_save_badflags := (a_su.item.su_badflags).to_natural_8
						if (l_byts[l_arridx]).to_integer_32 /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if l_n /= 1 then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_n := (create {P_SPELL_STATIC}).nofold_len (a_fword, (l_sp.item.ts_fidx).to_integer_32, a_su.item.su_badptr)
						else
							l_n := (l_sp.item.ts_fidx).to_integer_32
						end
						l_flags___0 := (create {P_SPELL_STATIC}).badword_captype (a_su.item.su_badptr, a_su.item.su_badptr + l_n)
						a_su.item.su_badflags := (create {P_SPELL_STATIC}).badword_captype (a_su.item.su_badptr + l_n, a_su.item.su_badptr + a_su.item.su_badlen)
						go_deeper (l_stack, l_depth___1, 0)
						l_depth___1 := l_depth___1 + 1
						l_sp := l_stack + l_depth___1
						l_sp.item.ts_prefixdepth := (l_depth___1 - 1).to_natural_8
						l_byts := l_fbyts
						l_idxs := l_fidxs
						l_sp.item.ts_arridx := 0
						l_tword[(l_sp.item.ts_twordlen).to_integer_32] := (('%/0/').code).to_natural_8;
						(create {P_SPELL_STATIC}).make_case_word (l_tword + (l_sp.item.ts_splitoff).to_integer_32, l_preword + (l_sp.item.ts_prewordlen).to_integer_32, l_flags___0)
						l_sp.item.ts_prewordlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_preword))).to_natural_8
						l_sp.item.ts_splitoff := l_sp.item.ts_twordlen
				when 10 then -- if done
						l_pos := -1 + 162 -- switch 1; break
				when 11 then
						if (l_sp.item.ts_curi).to_integer_32 > l_len then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_ENDNUL
							l_sp.item.ts_save_badflags := (a_su.item.su_badflags).to_natural_8
							l_pos := -1 + 162 -- switch 1; break
						elseif (l_byts[l_arridx]).to_integer_32 /= 0 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_ENDNUL
							l_sp.item.ts_save_badflags := (a_su.item.su_badflags).to_natural_8
							l_pos := -1 + 162 -- switch 1; break
						end
				when 12 then
						l_sp.item.ts_curi := ((l_sp.item.ts_curi).to_integer_32 + 1).to_integer_16
						l_flags___0 := l_idxs[l_arridx]
						if ((l_flags___0).bit_and (1_024)).to_boolean then
							l_pos := -1 + 162 -- switch 1; break
						end
				when 13 then
						if (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 = 0 then
							l_tmp___4 := 1
						else
							if a_soundfold.to_boolean then
								if (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 = 32 then
									l_tmp___0 := 1
								elseif (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 = 9 then
									l_tmp___0 := 1
								else
									l_tmp___0 := 0
								end
								l_tmp___3 := l_tmp___0
							else
								if (((create {P_GLOBALS_STATIC}).curwin.item).item.spell_iswordp (a_fword + (l_sp.item.ts_fidx).to_integer_32)).to_boolean then
									l_tmp___2 := 0
								else
									l_tmp___2 := 1
								end
								l_tmp___3 := l_tmp___2
							end
							if l_tmp___3.to_boolean then
								l_tmp___4 := 1
							else
								l_tmp___4 := 0
							end
						end
						l_fword_ends := l_tmp___4
						l_tword[(l_sp.item.ts_twordlen).to_integer_32] := (('%/0/').code).to_natural_8
						if not ((l_sp.item.ts_prefixdepth).to_integer_32 <= 253) then
							l_pos := -1 + 18 -- skip if block
						end
				when 14 then -- if:
						if (((l_sp.item.ts_flags).to_integer_32).bit_and (1)) /= 0 then
							l_pos := -1 + 18 -- skip if block
						end
				when 15 then -- if:
						l_n := l_stack[(l_sp.item.ts_prefixdepth).to_integer_32].ts_arridx
						l_tmp___5 := l_n
						l_n := l_n + 1
						l_len := (l_pbyts[l_tmp___5]).to_integer_32
						l_c := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if l_c < l_len then
								if (l_pbyts[(l_n + l_c)]).to_integer_32 /= 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_c := l_c + 1
							end
						end
						l_break := False
						if not (l_c > 0) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_c := (create {P_SPELL_STATIC}).valid_word_prefix (l_c, l_n, l_flags___0, l_tword + (l_sp.item.ts_splitoff).to_integer_32, l_slang, 0)
						if l_c = 0 then
							l_pos := -1 + 162 -- switch 1; break
						end
				when 17 then
						if ((l_c).bit_and (((1).bit_shift_left (24)))).to_boolean then
							l_flags___0 := (l_flags___0).bit_or ((8))
						end
						l_sp.item.ts_flags := (((l_sp.item.ts_flags).to_integer_32).bit_or (1)).to_natural_8
				when 18 then -- if done | if done | if done
						if (l_sp.item.ts_complen).to_integer_32 = (l_sp.item.ts_compsplit).to_integer_32 then
							if l_fword_ends.to_boolean then
								if ((l_flags___0).bit_and (512)).to_boolean then
									l_goodword_ends := 0
								else
									l_goodword_ends := 1
								end
							else
								l_goodword_ends := 1
							end
						else
							l_goodword_ends := 1
						end
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_compound_ok := 1
						if not ((l_sp.item.ts_complen).to_integer_32 > (l_sp.item.ts_compsplit).to_integer_32) then
							l_pos := -1 + 25 -- skip if block
						end
				when 19 then -- if:
						if not ((l_slang.item.sl_nobreak).to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if (l_sp.item.ts_fidx).to_integer_32 - (l_sp.item.ts_splitfidx).to_integer_32 = (l_sp.item.ts_twordlen).to_integer_32 - (l_sp.item.ts_splitoff).to_integer_32 then
							if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((a_fword + (l_sp.item.ts_splitfidx).to_integer_32)), create {CE_INTEGER_8_POINTER}.make_cast ((l_tword + (l_sp.item.ts_splitoff).to_integer_32)), ((l_sp.item.ts_fidx).to_integer_32 - (l_sp.item.ts_splitfidx).to_integer_32).to_natural_32)) = 0 then
								l_preword[(l_sp.item.ts_prewordlen).to_integer_32] := (('%/0/').code).to_natural_8
								l_newscore := score_wordcount_adj (l_slang, l_sp.item.ts_score, l_preword + (l_sp.item.ts_prewordlen).to_integer_32, ((l_sp.item.ts_prewordlen).to_integer_32 > 0).to_integer)
								if l_newscore <= a_su.item.su_maxscore then
									a_su.item.add_suggestion (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), l_preword, (l_sp.item.ts_splitfidx).to_integer_32 - l_repextra, l_newscore, 0, 0, a_lp.item.lp_sallang, 0)
								end
								l_pos := -1 + 162 -- switch 1; break
							end
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 22 then -- else:
						if (l_flags___0.to_natural_32).bit_shift_right (24) = {NATURAL_32} 0 then
							l_pos := -1 + 162 -- switch 1; break
						elseif (l_sp.item.ts_twordlen).to_integer_32 - (l_sp.item.ts_splitoff).to_integer_32 < l_slang.item.sl_compminlen then
							l_pos := -1 + 162 -- switch 1; break
						end
				when 23 then
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							if l_slang.item.sl_compminlen > 0 then
								if ((create {P_MBYTE_STATIC}).mb_charlen (l_tword + (l_sp.item.ts_splitoff).to_integer_32)) < l_slang.item.sl_compminlen then
									l_pos := -1 + 162 -- switch 1; break
								end
							end
						end
				when 24 then
						l_compflags[(l_sp.item.ts_complen).to_integer_32] := ((l_flags___0.to_natural_32).bit_shift_right (24)).to_natural_8
						l_compflags[(l_sp.item.ts_complen).to_integer_32 + 1] := (('%/0/').code).to_natural_8;
						(create {P_MISC2_STATIC}).vim_strncpy (l_preword + (l_sp.item.ts_prewordlen).to_integer_32, l_tword + (l_sp.item.ts_splitoff).to_integer_32, ((l_sp.item.ts_twordlen).to_integer_32 - (l_sp.item.ts_splitoff).to_integer_32).to_natural_32)
						if ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_comppat"))).item.match_checkcompoundpattern (l_preword, (l_sp.item.ts_prewordlen).to_integer_32)).to_boolean then
							l_compound_ok := 0
						end
						if l_compound_ok.to_boolean then
							l_p___0 := l_preword
							from
							until
								(l_break)
							loop
								l_break := False
								if (((create {P_CHARSET_STATIC}).skiptowhite (l_p___0)).item).to_integer_32 = 0 then
									l_break := True
								end
								if not (l_break) then
									l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (((create {P_CHARSET_STATIC}).skiptowhite (l_p___0)))
								end
							end
							l_break := False
							if l_fword_ends.to_boolean then
								if not (l_slang.item.can_compound (l_p___0, l_compflags + (l_sp.item.ts_compsplit).to_integer_32)).to_boolean then
									l_compound_ok := 0
								end
							end
						end
						l_p___0 := l_preword + (l_sp.item.ts_prewordlen).to_integer_32
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___13 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_preword, l_p___0 - 1])) + 1
						else
							l_tmp___13 := 1
						end
						l_p___0 := l_p___0 - l_tmp___13
				when 25 then -- if done
						if a_soundfold.to_boolean then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_preword + (l_sp.item.ts_prewordlen).to_integer_32)), create {CE_INTEGER_8_POINTER}.make_cast ((l_tword + (l_sp.item.ts_splitoff).to_integer_32))).do_nothing
						elseif ((l_flags___0).bit_and (128)).to_boolean then
							find_keepcap_word (l_slang, l_tword + (l_sp.item.ts_splitoff).to_integer_32, l_preword + (l_sp.item.ts_prewordlen).to_integer_32)
						else
							l_c := a_su.item.su_badflags
							if ((l_c).bit_and (4)).to_boolean then
								if a_su.item.su_badlen = ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([a_su.item.su_badptr])) then
									l_c := 2
								end
							end
							l_c := (l_c).bit_or (l_flags___0)
							if not l_p___0.is_void then
								if ((create {P_SPELL_STATIC}).spell_iswordp_nmw (l_p___0)).to_boolean then
									l_c := (l_c).bit_and ((-3))
								end
							end
							(create {P_SPELL_STATIC}).make_case_word (l_tword + (l_sp.item.ts_splitoff).to_integer_32, l_preword + (l_sp.item.ts_prewordlen).to_integer_32, l_c)
						end
						if a_soundfold.to_boolean then
							l_pos := -1 + 34 -- skip if block
						end
				when 26 then -- if:
						if ((l_flags___0).bit_and (16)).to_boolean then
							(create {P_SPELL_STATIC}).add_banned (a_su, l_preword + (l_sp.item.ts_prewordlen).to_integer_32)
							l_pos := -1 + 162 -- switch 1; break
						end
				when 27 then
						if (l_sp.item.ts_complen).to_integer_32 /= (l_sp.item.ts_compsplit).to_integer_32 then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						if (((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_banned"))).item.hash_find (l_preword + (l_sp.item.ts_prewordlen).to_integer_32)).item.hi_key).is_void then
							l_pos := -1 + 30 -- goto _L___1
						elseif (((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_banned"))).item.hash_find (l_preword + (l_sp.item.ts_prewordlen).to_integer_32)).item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item) then
							l_pos := -1 + 30 -- goto _L___1
						else
							l_pos := -1 + 32 -- goto _L___0
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 30 then -- else: | _L___1:
						if ((((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_banned"))).item.hash_find (l_preword)).item.hi_key).is_void) then
							l_pos := -1 + 34 -- skip if block
						end
				when 31 then -- if:
						if ((((create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_banned"))).item.hash_find (l_preword)).item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if: | _L___0:
						if (l_slang.item.sl_compprog).is_void then
							l_pos := -1 + 162 -- switch 1; break
						end
				when 33 then
						l_goodword_ends := 0
				when 34 then -- if done | if done | if done
						l_newscore := 0
						if not a_soundfold.to_boolean then
							if ((l_flags___0).bit_and (1)).to_boolean then
								if ((((l_flags___0.to_natural_32).bit_shift_right (16))).bit_and ((a_lp.item.lp_region).to_natural_32)) = {NATURAL_32} 0 then
									l_newscore := l_newscore + (200)
								end
							end
							if ((l_flags___0).bit_and (8)).to_boolean then
								l_newscore := l_newscore + (180)
							end
							if not ((create {P_SPELL_STATIC}).spell_valid_case (a_su.item.su_badflags, ((create {P_SPELL_STATIC}).captype (l_preword + (l_sp.item.ts_prewordlen).to_integer_32, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))))).to_boolean then
								l_newscore := l_newscore + (52)
							end
						end
						if not (l_fword_ends.to_boolean) then
							l_pos := -1 + 49 -- skip if block
						end
				when 35 then -- if:
						if not (l_goodword_ends.to_boolean) then
							l_pos := -1 + 49 -- skip if block
						end
				when 36 then -- if:
						if not ((l_sp.item.ts_fidx).to_integer_32 >= (l_sp.item.ts_fidxtry).to_integer_32) then
							l_pos := -1 + 49 -- skip if block
						end
				when 37 then -- if:
						if not (l_compound_ok.to_boolean) then
							l_pos := -1 + 49 -- skip if block
						end
				when 38 then -- if:
						if not (a_soundfold.to_boolean) then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						add_sound_suggest (a_su, l_preword, l_sp.item.ts_score, a_lp)
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 41 then -- else:
						if not ((l_sp.item.ts_fidx).to_integer_32 > 0) then
							l_pos := -1 + 49 -- skip if block
						end
				when 42 then -- if:
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___23 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([a_fword, l_p___0 - 1])) + 1
						else
							l_tmp___23 := 1
						end
						l_p___0 := l_p___0 - l_tmp___23
						if not (((create {P_GLOBALS_STATIC}).curwin.item).item.spell_iswordp (l_p___0)).to_boolean then
							l_p___0 := l_preword + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_preword))).to_integer_32
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___26 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_preword, l_p___0 - 1])) + 1
							else
								l_tmp___26 := 1
							end
							l_p___0 := l_p___0 - l_tmp___26
							if (((create {P_GLOBALS_STATIC}).curwin.item).item.spell_iswordp (l_p___0)).to_boolean then
								l_newscore := l_newscore + (103)
							end
						end
						l_score := score_wordcount_adj (l_slang, l_sp.item.ts_score + l_newscore, l_preword + (l_sp.item.ts_prewordlen).to_integer_32, ((l_sp.item.ts_prewordlen).to_integer_32 > 0).to_integer)
						if not (l_score <= a_su.item.su_maxscore) then
							l_pos := -1 + 49 -- skip if block
						end
				when 43 then -- if:
						a_su.item.add_suggestion (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), l_preword, (l_sp.item.ts_fidx).to_integer_32 - l_repextra, l_score, 0, 0, a_lp.item.lp_sallang, 0)
						if not (((a_su.item.su_badflags).bit_and (32)).to_boolean) then
							l_pos := -1 + 49 -- skip if block
						end
				when 44 then -- if:
						l_c := (create {P_SPELL_STATIC}).captype (l_preword, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						if l_c /= 0 then
							l_pos := -1 + 47 -- skip if block
						end
				when 45 then -- if:
						l_pos := -1 + 48 -- goto _L___2
				when 46 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 47 then -- else:
						if l_c /= 4 then
							l_pos := -1 + 49 -- skip if block
						end
				when 48 then -- if: | _L___2:
						if l_c = 0 then
							l_tmp___29 := 4
						else
							l_tmp___29 := 0
						end
						(create {P_SPELL_STATIC}).make_case_word (l_tword + (l_sp.item.ts_splitoff).to_integer_32, l_preword + (l_sp.item.ts_prewordlen).to_integer_32, l_tmp___29)
						a_su.item.add_suggestion (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), l_preword, (l_sp.item.ts_fidx).to_integer_32 - l_repextra, l_score + 52, 0, 0, a_lp.item.lp_sallang, 0)
				when 49 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not ((l_sp.item.ts_fidx).to_integer_32 >= (l_sp.item.ts_fidxtry).to_integer_32) then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:
						l_pos := -1 + 53 -- goto _L___10
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 92
				when 52 then -- else:
						if not (l_fword_ends.to_boolean) then
							l_pos := -1 + 92 -- skip if block
						end
				when 53 then -- if: | _L___10:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if:
						l_pos := -1 + 57 -- goto _L___9
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 92
				when 56 then -- else:
						if (l_sp.item.ts_tcharlen).to_integer_32 /= 0 then
							l_pos := -1 + 92 -- skip if block
						end
				when 57 then -- if: | _L___9:
						if (l_sp.item.ts_fidx).to_integer_32 - l_repextra < a_su.item.su_badlen then
							if not a_soundfold.to_boolean then
								l_tmp___30 := 1
							else
								l_tmp___30 := 0
							end
						else
							l_tmp___30 := 0
						end
						l_try_split := l_tmp___30
						l_try_compound := 0
						if a_soundfold.to_boolean then
							l_pos := -1 + 73 -- skip if block
						end
				when 58 then -- if:
						if (l_slang.item.sl_compprog).is_void then
							l_pos := -1 + 73 -- skip if block
						end
				when 59 then -- if:
						if (l_flags___0.to_natural_32).bit_shift_right (24) = {NATURAL_32} 0 then
							l_pos := -1 + 73 -- skip if block
						end
				when 60 then -- if:
						if not ((l_sp.item.ts_twordlen).to_integer_32 - (l_sp.item.ts_splitoff).to_integer_32 >= l_slang.item.sl_compminlen) then
							l_pos := -1 + 73 -- skip if block
						end
				when 61 then -- if:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_pos := -1 + 64 -- skip if block
						end
				when 62 then -- if:
						l_pos := -1 + 68 -- goto _L___4
				when 63 then -- if block done, skip else block:
						l_pos := -1 + 73
				when 64 then -- else:
						if l_slang.item.sl_compminlen /= 0 then
							l_pos := -1 + 67 -- skip if block
						end
				when 65 then -- if:
						l_pos := -1 + 68 -- goto _L___4
				when 66 then -- if block done, skip else block:
						l_pos := -1 + 73
				when 67 then -- else:
						if not (((create {P_MBYTE_STATIC}).mb_charlen (l_tword + (l_sp.item.ts_splitoff).to_integer_32)) >= l_slang.item.sl_compminlen) then
							l_pos := -1 + 73 -- skip if block
						end
				when 68 then -- if: | _L___4:
						if not (l_slang.item.sl_compsylmax < 250) then
							l_pos := -1 + 71 -- skip if block
						end
				when 69 then -- if:
						l_pos := -1 + 72 -- goto _L___3
				when 70 then -- if block done, skip else block:
						l_pos := -1 + 73
				when 71 then -- else:
						if not (((l_sp.item.ts_complen).to_integer_32 + 1) - (l_sp.item.ts_compsplit).to_integer_32 < l_slang.item.sl_compmax) then
							l_pos := -1 + 73 -- skip if block
						end
				when 72 then -- if: | _L___3:
						if (can_be_compound (l_sp, l_slang, l_compflags, ((l_flags___0.to_natural_32).bit_shift_right (24)).to_integer_32)).to_boolean then
							l_try_compound := 1
							l_compflags[(l_sp.item.ts_complen).to_integer_32] := ((l_flags___0.to_natural_32).bit_shift_right (24)).to_natural_8
							l_compflags[(l_sp.item.ts_complen).to_integer_32 + 1] := (('%/0/').code).to_natural_8
						end
				when 73 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if (l_slang.item.sl_nobreak).to_boolean then
							l_try_compound := 1
						elseif not l_fword_ends.to_boolean then
							if l_try_compound.to_boolean then
								if (((l_sp.item.ts_flags).to_integer_32).bit_and (2)) = 0 then
									l_try_compound := 0
									l_sp.item.ts_flags := (((l_sp.item.ts_flags).to_integer_32).bit_or (2)).to_natural_8
									l_sp.item.ts_curi := ((l_sp.item.ts_curi).to_integer_32 - 1).to_integer_16
									l_compflags[(l_sp.item.ts_complen).to_integer_32] := (('%/0/').code).to_natural_8
								else
									l_sp.item.ts_flags := (((l_sp.item.ts_flags).to_integer_32).bit_and (-3)).to_natural_8
								end
							else
								l_sp.item.ts_flags := (((l_sp.item.ts_flags).to_integer_32).bit_and (-3)).to_natural_8
							end
						else
							l_sp.item.ts_flags := (((l_sp.item.ts_flags).to_integer_32).bit_and (-3)).to_natural_8
						end
						if not (l_try_split.to_boolean) then
							l_pos := -1 + 76 -- skip if block
						end
				when 74 then -- if:
						l_pos := -1 + 77 -- goto _L___8
				when 75 then -- if block done, skip else block:
						l_pos := -1 + 92
				when 76 then -- else:
						if not (l_try_compound.to_boolean) then
							l_pos := -1 + 92 -- skip if block
						end
				when 77 then -- if: | _L___8:
						if l_try_compound.to_boolean then
							l_pos := -1 + 85 -- skip if block
						end
				when 78 then -- if:
						if l_fword_ends.to_boolean then
							l_pos := -1 + 81 -- skip if block
						end
				when 79 then -- if:
						l_pos := -1 + 82 -- goto _L___5
				when 80 then -- if block done, skip else block:
						l_pos := -1 + 85
				when 81 then -- else:
						if l_goodword_ends.to_boolean then
							l_pos := -1 + 85 -- skip if block
						end
				when 82 then -- if: | _L___5:
						if (l_sp.item.ts_complen).to_integer_32 = (l_sp.item.ts_compsplit).to_integer_32 then
							if ((l_flags___0).bit_and (512)).to_boolean then
								l_pos := -1 + 162 -- switch 1; break
							end
						end
				when 83 then
						l_p___0 := l_preword
						from
						until
							(l_break)
						loop
							l_break := False
							if (((create {P_CHARSET_STATIC}).skiptowhite (l_p___0)).item).to_integer_32 = 0 then
								l_break := True
							end
							if not (l_break) then
								l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (((create {P_CHARSET_STATIC}).skiptowhite (l_p___0)))
							end
						end
						l_break := False
						if (l_sp.item.ts_complen).to_integer_32 > (l_sp.item.ts_compsplit).to_integer_32 then
							if not (l_slang.item.can_compound (l_p___0, l_compflags + (l_sp.item.ts_compsplit).to_integer_32)).to_boolean then
								l_pos := -1 + 162 -- switch 1; break
							end
						end
				when 84 then
						if (l_slang.item.sl_nosplitsugs).to_boolean then
							l_newscore := l_newscore + (249)
						else
							l_newscore := l_newscore + (149)
						end
						l_newscore := score_wordcount_adj (l_slang, l_newscore, l_preword + (l_sp.item.ts_prewordlen).to_integer_32, 1)
				when 85 then -- if done | if done
						if not (l_stack[l_depth___1].ts_score + l_newscore < a_su.item.su_maxscore) then
							l_pos := -1 + 92 -- skip if block
						end
				when 86 then -- if:
						go_deeper (l_stack, l_depth___1, l_newscore)
						l_sp.item.ts_save_badflags := (a_su.item.su_badflags).to_natural_8
						l_sp.item.ts_state := {PC_STATE_T}.STATE_SPLITUNDO
						l_depth___1 := l_depth___1 + 1
						l_sp := l_stack + l_depth___1
						if not l_try_compound.to_boolean then
							if not l_fword_ends.to_boolean then
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_preword), ce_string (" ")).do_nothing
							end
						end
						l_sp.item.ts_prewordlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_preword))).to_natural_8
						l_sp.item.ts_splitoff := l_sp.item.ts_twordlen
						l_sp.item.ts_splitfidx := l_sp.item.ts_fidx
						if l_try_compound.to_boolean then
							l_pos := -1 + 89 -- skip if block
						end
				when 87 then -- if:
						if ((create {P_SPELL_STATIC}).spell_iswordp_nmw (a_fword + (l_sp.item.ts_fidx).to_integer_32)).to_boolean then
							l_pos := -1 + 89 -- goto _L___7
						else
							l_pos := -1 + 90 -- goto _L___6
						end
				when 88 then -- if block done, skip else block:
						l_pos := -1 + 91
				when 89 then -- else: | _L___7:
						if not (l_fword_ends.to_boolean) then
							l_pos := -1 + 91 -- skip if block
						end
				when 90 then -- if: | _L___6:
						if (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 /= 0 then
							if l_goodword_ends.to_boolean then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_l := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32]).to_integer_32
								else
									l_l := 1
								end
								if l_fword_ends.to_boolean then
									memmove (create {CE_VOID_POINTER}.make_cast ((l_preword + (l_sp.item.ts_prewordlen).to_integer_32)), create {CE_VOID_POINTER}.make_cast ((a_fword + (l_sp.item.ts_fidx).to_integer_32)), l_l.to_natural_32).do_nothing
									l_sp.item.ts_prewordlen := ((l_sp.item.ts_prewordlen).to_integer_32 + l_l).to_natural_8
									l_preword[(l_sp.item.ts_prewordlen).to_integer_32] := (('%/0/').code).to_natural_8
								else
									l_sp.item.ts_score := l_sp.item.ts_score - (56)
								end
								l_sp.item.ts_fidx := ((l_sp.item.ts_fidx).to_integer_32 + l_l).to_natural_8
							end
						end
				when 91 then -- if done
						if l_try_compound.to_boolean then
							l_sp.item.ts_complen := ((l_sp.item.ts_complen).to_integer_32 + 1).to_natural_8
						else
							l_sp.item.ts_compsplit := l_sp.item.ts_complen
						end
						l_sp.item.ts_prefixdepth := (255).to_natural_8
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_n := (create {P_SPELL_STATIC}).nofold_len (a_fword, (l_sp.item.ts_fidx).to_integer_32, a_su.item.su_badptr)
						else
							l_n := (l_sp.item.ts_fidx).to_integer_32
						end
						a_su.item.su_badflags := (create {P_SPELL_STATIC}).badword_captype (a_su.item.su_badptr + l_n, a_su.item.su_badptr + a_su.item.su_badlen)
						l_sp.item.ts_arridx := 0
						if not l_pbyts.is_void then
							l_byts := l_pbyts
							l_idxs := l_pidxs
							l_sp.item.ts_prefixdepth := (254).to_natural_8
							l_sp.item.ts_state := {PC_STATE_T}.STATE_NOPREFIX
						end
				when 92 then -- if done | if done | if done | if done | if done | if done
						l_pos := -1 + 162 -- switch 1; break
				when 93 then -- switch 1, case 2
						a_su.item.su_badflags := (l_sp.item.ts_save_badflags).to_integer_32
						l_sp.item.ts_state := {PC_STATE_T}.STATE_START
						l_byts := l_fbyts
						l_idxs := l_fidxs
						l_pos := -1 + 162 -- switch 1; break
				when 94 then -- switch 1, case 3
						a_su.item.su_badflags := (l_sp.item.ts_save_badflags).to_integer_32
						if (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 = 0 then
							if (l_sp.item.ts_tcharlen).to_integer_32 = 0 then
								l_sp.item.ts_state := {PC_STATE_T}.STATE_DEL
								l_pos := -1 + 162 -- switch 1; break
							end
						end
				when 95 then
						l_sp.item.ts_state := {PC_STATE_T}.STATE_PLAIN
				when 96 then -- switch 1, case 4
						l_arridx := l_sp.item.ts_arridx
						if not ((l_sp.item.ts_curi).to_integer_32 > (l_byts[l_arridx]).to_integer_32) then
							l_pos := -1 + 99 -- skip if block
						end
				when 97 then -- if:
						if (l_sp.item.ts_fidx).to_integer_32 >= (l_sp.item.ts_fidxtry).to_integer_32 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_DEL
						else
							l_sp.item.ts_state := {PC_STATE_T}.STATE_FINAL
						end
				when 98 then -- if block done, skip else block:
						l_pos := -1 + 125
				when 99 then -- else:
						l_tmp___38 := l_sp.item.ts_curi
						l_sp.item.ts_curi := ((l_sp.item.ts_curi).to_integer_32 + 1).to_integer_16
						l_arridx := l_arridx + l_tmp___38
						l_c := (l_byts[l_arridx]).to_integer_32
						if l_c = (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 then
							l_newscore := 0
						elseif (l_sp.item.ts_tcharlen).to_integer_32 > 0 then
							if (l_sp.item.ts_isdiff).to_integer_32 /= 0 then
								l_newscore := 0
							else
								l_newscore := 93
							end
						else
							l_newscore := 93
						end
						if l_newscore /= 0 then
							l_pos := -1 + 102 -- skip if block
						end
				when 100 then -- if:
						l_pos := -1 + 107 -- goto _L___15
				when 101 then -- if block done, skip else block:
						l_pos := -1 + 125
				when 102 then -- else:
						if not ((l_sp.item.ts_fidx).to_integer_32 >= (l_sp.item.ts_fidxtry).to_integer_32) then
							l_pos := -1 + 125 -- skip if block
						end
				when 103 then -- if:
						if (((l_sp.item.ts_flags).to_integer_32).bit_and (4)) /= 0 then
							l_pos := -1 + 106 -- skip if block
						end
				when 104 then -- if:
						l_pos := -1 + 107 -- goto _L___15
				when 105 then -- if block done, skip else block:
						l_pos := -1 + 125
				when 106 then -- else:
						if l_c = (a_fword[(l_sp.item.ts_delidx).to_integer_32]).to_integer_32 then
							l_pos := -1 + 125 -- skip if block
						end
				when 107 then -- if: | _L___15:
						if not (l_stack[l_depth___1].ts_score + l_newscore < a_su.item.su_maxscore) then
							l_pos := -1 + 125 -- skip if block
						end
				when 108 then -- if:
						go_deeper (l_stack, l_depth___1, l_newscore)
						l_depth___1 := l_depth___1 + 1
						l_sp := l_stack + l_depth___1
						l_sp.item.ts_fidx := ((l_sp.item.ts_fidx).to_integer_32 + 1).to_natural_8
						l_tmp___39 := l_sp.item.ts_twordlen
						l_sp.item.ts_twordlen := ((l_sp.item.ts_twordlen).to_integer_32 + 1).to_natural_8
						l_tword[l_tmp___39.to_integer_32] := l_c.to_natural_8
						l_sp.item.ts_arridx := l_idxs[l_arridx]
						if l_newscore = 93 then
							l_sp.item.ts_isdiff := (1).to_natural_8
						end
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 124 -- skip if block
						end
				when 109 then -- if:
						if (l_sp.item.ts_tcharlen).to_integer_32 = 0 then
							l_sp.item.ts_tcharidx := (0).to_natural_8
							l_sp.item.ts_tcharlen := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[l_c]).to_natural_8
							l_sp.item.ts_fcharstart := ((l_sp.item.ts_fidx).to_integer_32 - 1).to_natural_8
							if l_newscore /= 0 then
								l_sp.item.ts_isdiff := (1).to_natural_8
							else
								l_sp.item.ts_isdiff := (0).to_natural_8
							end
						elseif (l_sp.item.ts_isdiff).to_integer_32 = 2 then
							l_sp.item.ts_fidx := ((l_sp.item.ts_fidx).to_integer_32 - 1).to_natural_8
						end
						l_sp.item.ts_tcharidx := ((l_sp.item.ts_tcharidx).to_integer_32 + 1).to_natural_8
						if l_sp.item.ts_tcharidx /= (l_sp.item.ts_tcharlen).to_integer_32 then
							l_pos := -1 + 123 -- skip if block
						end
				when 110 then -- if:
						if (l_sp.item.ts_isdiff).to_integer_32 /= 1 then
							l_pos := -1 + 116 -- skip if block
						end
				when 111 then -- if:
						l_sp.item.ts_fidx := ((l_sp.item.ts_fcharstart).to_integer_32 + ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(a_fword[(l_sp.item.ts_fcharstart).to_integer_32]).to_integer_32]).to_integer_32).to_natural_8
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 114 -- skip if block
						end
				when 112 then -- if:
						if ((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([(l_tword + (l_sp.item.ts_twordlen).to_integer_32) - (l_sp.item.ts_tcharlen).to_integer_32])))).to_boolean then
							if ((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([a_fword + (l_sp.item.ts_fcharstart).to_integer_32])))).to_boolean then
								l_sp.item.ts_score := l_sp.item.ts_score - (60)
							else
								l_pos := -1 + 114 -- goto _L___12
							end
						else
							l_pos := -1 + 114 -- goto _L___12
						end
				when 113 then -- if block done, skip else block:
						l_pos := -1 + 115
				when 114 then -- else: | _L___12:
						if not a_soundfold.to_boolean then
							if (l_slang.item.sl_has_map).to_boolean then
								l_tmp___40 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([a_fword + (l_sp.item.ts_fcharstart).to_integer_32])
								if (similar_chars (l_slang, ((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([(l_tword + (l_sp.item.ts_twordlen).to_integer_32) - (l_sp.item.ts_tcharlen).to_integer_32])), l_tmp___40)).to_boolean then
									l_sp.item.ts_score := l_sp.item.ts_score - (60)
								end
							end
						end
				when 115 then -- if done | if block done, skip else block:
						l_pos := -1 + 122
				when 116 then -- else:
						if (l_sp.item.ts_isdiff).to_integer_32 /= 2 then
							l_pos := -1 + 122 -- skip if block
						end
				when 117 then -- if:
						if not ((l_sp.item.ts_twordlen).to_integer_32 > (l_sp.item.ts_tcharlen).to_integer_32) then
							l_pos := -1 + 122 -- skip if block
						end
				when 118 then -- if:
						l_p___0 := (l_tword + (l_sp.item.ts_twordlen).to_integer_32) - (l_sp.item.ts_tcharlen).to_integer_32
						l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0])
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 121 -- skip if block
						end
				when 119 then -- if:
						if ((create {P_MBYTE_STATIC}).utf_iscomposing (l_c)).to_boolean then
							l_sp.item.ts_score := l_sp.item.ts_score - (66)
						else
							l_pos := -1 + 121 -- goto _L___13
						end
				when 120 then -- if block done, skip else block:
						l_pos := -1 + 122
				when 121 then -- else: | _L___13:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___48 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_tword, l_p___0 - 1])) + 1
						else
							l_tmp___48 := 1
						end
						l_p___0 := l_p___0 - l_tmp___48
						if l_c = ((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0])) then
							l_sp.item.ts_score := l_sp.item.ts_score - (29)
						end
				when 122 then -- if done | if done | if done
						l_sp.item.ts_tcharlen := (0).to_natural_8
				when 123 then -- if done | if block done, skip else block:
						l_pos := -1 + 125
				when 124 then -- else:
						if l_newscore /= 0 then
							if not a_soundfold.to_boolean then
								if (l_slang.item.sl_has_map).to_boolean then
									if (similar_chars (l_slang, l_c, (a_fword[((l_sp.item.ts_fidx).to_integer_32 - 1)]).to_integer_32)).to_boolean then
										l_sp.item.ts_score := l_sp.item.ts_score - (60)
									end
								end
							end
						end
				when 125 then -- if done | if done | if done | if done | if done | if done
						l_pos := -1 + 162 -- switch 1; break
				when 126 then -- switch 1, case 5
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							if (l_sp.item.ts_tcharlen).to_integer_32 > 0 then
								l_sp.item.ts_state := {PC_STATE_T}.STATE_FINAL
								l_pos := -1 + 162 -- switch 1; break
							end
						end
				when 127 then
						l_sp.item.ts_state := {PC_STATE_T}.STATE_INS_PREP
						l_sp.item.ts_curi := (1).to_integer_16
						if a_soundfold.to_boolean then
							if (l_sp.item.ts_fidx).to_integer_32 = 0 then
								if (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 = 42 then
									l_newscore := 62
								else
									l_newscore := 94
								end
							else
								l_newscore := 94
							end
						else
							l_newscore := 94
						end
						if (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 = 0 then
							l_pos := -1 + 137 -- skip if block
						end
				when 128 then -- if:
						if not (l_stack[l_depth___1].ts_score + l_newscore < a_su.item.su_maxscore) then
							l_pos := -1 + 137 -- skip if block
						end
				when 129 then -- if:
						go_deeper (l_stack, l_depth___1, l_newscore)
						l_depth___1 := l_depth___1 + 1
						l_stack[l_depth___1].ts_flags := (((l_stack[l_depth___1].ts_flags).to_integer_32).bit_or (4)).to_natural_8
						l_stack[l_depth___1].ts_delidx := l_sp.item.ts_fidx
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 135 -- skip if block
						end
				when 130 then -- if:
						l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([a_fword + (l_sp.item.ts_fidx).to_integer_32])
						l_stack[l_depth___1].ts_fidx := ((l_stack[l_depth___1].ts_fidx).to_integer_32 + ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32]).to_integer_32).to_natural_8
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 133 -- skip if block
						end
				when 131 then -- if:
						if ((create {P_MBYTE_STATIC}).utf_iscomposing (l_c)).to_boolean then
							l_stack[l_depth___1].ts_score := l_stack[l_depth___1].ts_score - (66)
						else
							l_pos := -1 + 133 -- goto _L___16
						end
				when 132 then -- if block done, skip else block:
						l_pos := -1 + 134
				when 133 then -- else: | _L___16:
						if l_c = ((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([a_fword + (l_stack[l_depth___1].ts_fidx).to_integer_32])) then
							l_stack[l_depth___1].ts_score := l_stack[l_depth___1].ts_score - (28)
						end
				when 134 then -- if done | if block done, skip else block:
						l_pos := -1 + 136
				when 135 then -- else:
						l_stack[l_depth___1].ts_fidx := ((l_stack[l_depth___1].ts_fidx).to_integer_32 + 1).to_natural_8
						if (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 = (a_fword[((l_sp.item.ts_fidx).to_integer_32 + 1)]).to_integer_32 then
							l_stack[l_depth___1].ts_score := l_stack[l_depth___1].ts_score - (28)
						end
				when 136 then
						l_pos := -1 + 162 -- switch 1; break
				when 137 then -- if done | switch 1, case 6
						if (((l_sp.item.ts_flags).to_integer_32).bit_and (4)).to_boolean then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_SWAP
							l_pos := -1 + 162 -- switch 1; break
						end
				when 138 then
						l_n := l_sp.item.ts_arridx
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_sp.item.ts_curi).to_integer_32 > (l_byts[l_n]).to_integer_32 then
								l_sp.item.ts_state := {PC_STATE_T}.STATE_SWAP
								l_break := True
							end
							if not (l_break) and then ((l_byts[(l_n + (l_sp.item.ts_curi).to_integer_32)]).to_integer_32 /= 0) then
								l_sp.item.ts_state := {PC_STATE_T}.STATE_INS
								l_break := True
							end
							if not (l_break) then
								l_sp.item.ts_curi := ((l_sp.item.ts_curi).to_integer_32 + 1).to_integer_16
							end
						end
						l_break := False
						l_pos := -1 + 162 -- switch 1; break
				when 139 then -- switch 1, case 7
						l_n := l_sp.item.ts_arridx
						if (l_sp.item.ts_curi).to_integer_32 > (l_byts[l_n]).to_integer_32 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_SWAP
							l_pos := -1 + 162 -- switch 1; break
						end
				when 140 then
						l_tmp___54 := l_sp.item.ts_curi
						l_sp.item.ts_curi := ((l_sp.item.ts_curi).to_integer_32 + 1).to_integer_16
						l_n := l_n + l_tmp___54
						l_c := (l_byts[l_n]).to_integer_32
						if a_soundfold.to_boolean then
							if (l_sp.item.ts_twordlen).to_integer_32 = 0 then
								if l_c = 42 then
									l_newscore := 64
								else
									l_newscore := 96
								end
							else
								l_newscore := 96
							end
						else
							l_newscore := 96
						end
						if l_c /= (a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32 then
							if l_stack[l_depth___1].ts_score + l_newscore < a_su.item.su_maxscore then
								go_deeper (l_stack, l_depth___1, l_newscore)
								l_depth___1 := l_depth___1 + 1
								l_sp := l_stack + l_depth___1
								l_tmp___55 := l_sp.item.ts_twordlen
								l_sp.item.ts_twordlen := ((l_sp.item.ts_twordlen).to_integer_32 + 1).to_natural_8
								l_tword[l_tmp___55.to_integer_32] := l_c.to_natural_8
								l_sp.item.ts_arridx := l_idxs[l_n]
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_fl := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[l_c]).to_integer_32
									if l_fl > 1 then
										l_sp.item.ts_tcharlen := l_fl.to_natural_8
										l_sp.item.ts_tcharidx := (1).to_natural_8
										l_sp.item.ts_isdiff := (2).to_natural_8
									end
								else
									l_fl := 1
								end
								if l_fl = 1 then
									if (l_sp.item.ts_twordlen).to_integer_32 >= 2 then
										if (l_tword[(l_sp.item.ts_twordlen).to_integer_32 - 2]).to_integer_32 = l_c then
											l_sp.item.ts_score := l_sp.item.ts_score - (29)
										end
									end
								end
							end
						end
						l_pos := -1 + 162 -- switch 1; break
				when 141 then -- switch 1, case 8
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						l_c := (l_p___0.item).to_integer_32
						if l_c = 0 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_FINAL
							l_pos := -1 + 162 -- switch 1; break
						end
				when 142 then
						if not a_soundfold.to_boolean then
							if not (((create {P_GLOBALS_STATIC}).curwin.item).item.spell_iswordp (l_p___0)).to_boolean then
								l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
								l_pos := -1 + 162 -- switch 1; break
							end
						end
				when 143 then
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								l_n := ((create {P_MBYTE_STATIC}).utf_ptr2len (l_p___0))
							else
								l_n := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
							end
							l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0])
							if (l_p___0[l_n]).to_integer_32 = 0 then
								l_c2 := ('%/0/').code
							elseif not a_soundfold.to_boolean then
								if (((create {P_GLOBALS_STATIC}).curwin.item).item.spell_iswordp (l_p___0 + l_n)).to_boolean then
									l_c2 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0 + l_n])
								else
									l_c2 := l_c
								end
							else
								l_c2 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0 + l_n])
							end
						elseif (l_p___0[1]).to_integer_32 = 0 then
							l_c2 := ('%/0/').code
						elseif not a_soundfold.to_boolean then
							if (((create {P_GLOBALS_STATIC}).curwin.item).item.spell_iswordp (l_p___0 + 1)).to_boolean then
								l_c2 := (l_p___0[1]).to_integer_32
							else
								l_c2 := l_c
							end
						else
							l_c2 := (l_p___0[1]).to_integer_32
						end
						if l_c2 = 0 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
							l_pos := -1 + 162 -- switch 1; break
						end
				when 144 then
						if l_c = l_c2 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_SWAP3
							l_pos := -1 + 162 -- switch 1; break
						end
				when 145 then
						if l_c2 /= 0 then
							if l_stack[l_depth___1].ts_score + 75 < a_su.item.su_maxscore then
								go_deeper (l_stack, l_depth___1, 75)
								l_sp.item.ts_state := {PC_STATE_T}.STATE_UNSWAP
								l_depth___1 := l_depth___1 + 1
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_fl := (create {P_GLOBALS_STATIC}).mb_char2len.item.integer_32_item ([l_c2])
									memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + l_n)), l_fl.to_natural_32).do_nothing;
									(create {P_GLOBALS_STATIC}).mb_char2bytes.item.call ([l_c, l_p___0 + l_fl])
									l_stack[l_depth___1].ts_fidxtry := (((l_sp.item.ts_fidx).to_integer_32 + l_n) + l_fl).to_natural_8
								else
									l_p___0[0] := l_c2.to_natural_8
									l_p___0[1] := l_c.to_natural_8
									l_stack[l_depth___1].ts_fidxtry := ((l_sp.item.ts_fidx).to_integer_32 + 2).to_natural_8
								end
							else
								l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
							end
						else
							l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
						end
						l_pos := -1 + 162 -- switch 1; break
				when 146 then -- switch 1, case 9
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_n := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_p___0.item).to_integer_32]).to_integer_32
							l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0 + l_n])
							memmove (create {CE_VOID_POINTER}.make_cast ((l_p___0 + ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_p___0[l_n]).to_integer_32]).to_integer_32)), create {CE_VOID_POINTER}.make_cast (l_p___0), l_n.to_natural_32).do_nothing;
							(create {P_GLOBALS_STATIC}).mb_char2bytes.item.call ([l_c, l_p___0])
						else
							l_c := (l_p___0.item).to_integer_32
							l_p___0.item := l_p___0[1]
							l_p___0[1] := l_c.to_natural_8
						end
				when 147 then -- switch 1, case 10
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								l_n := ((create {P_MBYTE_STATIC}).utf_ptr2len (l_p___0))
							else
								l_n := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
							end
							l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0])
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								l_fl := ((create {P_MBYTE_STATIC}).utf_ptr2len (l_p___0 + l_n))
							else
								l_fl := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0 + l_n]))
							end
							l_c2 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0 + l_n])
							if not a_soundfold.to_boolean then
								if (((create {P_GLOBALS_STATIC}).curwin.item).item.spell_iswordp ((l_p___0 + l_n) + l_fl)).to_boolean then
									l_c3 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([(l_p___0 + l_n) + l_fl])
								else
									l_c3 := l_c
								end
							else
								l_c3 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([(l_p___0 + l_n) + l_fl])
							end
						else
							l_c := (l_p___0.item).to_integer_32
							l_c2 := (l_p___0[1]).to_integer_32
							if not a_soundfold.to_boolean then
								if (((create {P_GLOBALS_STATIC}).curwin.item).item.spell_iswordp (l_p___0 + 2)).to_boolean then
									l_c3 := (l_p___0[2]).to_integer_32
								else
									l_c3 := l_c
								end
							else
								l_c3 := (l_p___0[2]).to_integer_32
							end
						end
						if l_c = l_c3 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
							l_pos := -1 + 162 -- switch 1; break
						elseif l_c3 = 0 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
							l_pos := -1 + 162 -- switch 1; break
						end
				when 148 then
						if l_stack[l_depth___1].ts_score + 110 < a_su.item.su_maxscore then
							go_deeper (l_stack, l_depth___1, 110)
							l_sp.item.ts_state := {PC_STATE_T}.STATE_UNSWAP3
							l_depth___1 := l_depth___1 + 1
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tl := (create {P_GLOBALS_STATIC}).mb_char2len.item.integer_32_item ([l_c3])
								memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (((l_p___0 + l_n) + l_fl)), l_tl.to_natural_32).do_nothing;
								(create {P_GLOBALS_STATIC}).mb_char2bytes.item.call ([l_c2, l_p___0 + l_tl]);
								(create {P_GLOBALS_STATIC}).mb_char2bytes.item.call ([l_c, (l_p___0 + l_fl) + l_tl])
								l_stack[l_depth___1].ts_fidxtry := ((((l_sp.item.ts_fidx).to_integer_32 + l_n) + l_fl) + l_tl).to_natural_8
							else
								l_p___0[0] := l_p___0[2]
								l_p___0[2] := l_c.to_natural_8
								l_stack[l_depth___1].ts_fidxtry := ((l_sp.item.ts_fidx).to_integer_32 + 3).to_natural_8
							end
						else
							l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
						end
						l_pos := -1 + 162 -- switch 1; break
				when 149 then -- switch 1, case 11
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_n := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_p___0.item).to_integer_32]).to_integer_32
							l_c2 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0 + l_n])
							l_fl := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_p___0[l_n]).to_integer_32]).to_integer_32
							l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([(l_p___0 + l_n) + l_fl])
							l_tl := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_p___0[(l_n + l_fl)]).to_integer_32]).to_integer_32
							memmove (create {CE_VOID_POINTER}.make_cast (((l_p___0 + l_fl) + l_tl)), create {CE_VOID_POINTER}.make_cast (l_p___0), l_n.to_natural_32).do_nothing;
							(create {P_GLOBALS_STATIC}).mb_char2bytes.item.call ([l_c, l_p___0]);
							(create {P_GLOBALS_STATIC}).mb_char2bytes.item.call ([l_c2, l_p___0 + l_tl])
							l_p___0 := l_p___0 + l_tl
						else
							l_c := (l_p___0.item).to_integer_32
							l_p___0.item := l_p___0[2]
							l_p___0[2] := l_c.to_natural_8
							l_p___0 := l_p___0 + 1
						end
						if not a_soundfold.to_boolean then
							if not (((create {P_GLOBALS_STATIC}).curwin.item).item.spell_iswordp (l_p___0)).to_boolean then
								l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
								l_pos := -1 + 162 -- switch 1; break
							end
						end
				when 150 then
						if l_stack[l_depth___1].ts_score + 110 < a_su.item.su_maxscore then
							go_deeper (l_stack, l_depth___1, 110)
							l_sp.item.ts_state := {PC_STATE_T}.STATE_UNROT3L
							l_depth___1 := l_depth___1 + 1
							l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_n := ((create {P_MBYTE_STATIC}).utf_ptr2len (l_p___0))
								else
									l_n := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
								end
								l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0])
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_fl := ((create {P_MBYTE_STATIC}).utf_ptr2len (l_p___0 + l_n))
								else
									l_fl := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0 + l_n]))
								end
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_tmp___74 := ((create {P_MBYTE_STATIC}).utf_ptr2len ((l_p___0 + l_n) + l_fl))
								else
									l_tmp___74 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([(l_p___0 + l_n) + l_fl]))
								end
								l_fl := l_fl + l_tmp___74
								memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + l_n)), l_fl.to_natural_32).do_nothing;
								(create {P_GLOBALS_STATIC}).mb_char2bytes.item.call ([l_c, l_p___0 + l_fl])
								l_stack[l_depth___1].ts_fidxtry := (((l_sp.item.ts_fidx).to_integer_32 + l_n) + l_fl).to_natural_8
							else
								l_c := (l_p___0.item).to_integer_32
								l_p___0.item := l_p___0[1]
								l_p___0[1] := l_p___0[2]
								l_p___0[2] := l_c.to_natural_8
								l_stack[l_depth___1].ts_fidxtry := ((l_sp.item.ts_fidx).to_integer_32 + 3).to_natural_8
							end
						else
							l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
						end
						l_pos := -1 + 162 -- switch 1; break
				when 151 then -- switch 1, case 12
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_n := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_p___0.item).to_integer_32]).to_integer_32
							l_n := l_n + ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_p___0[l_n]).to_integer_32]).to_integer_32
							l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0 + l_n])
							l_tl := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_p___0[l_n]).to_integer_32]).to_integer_32
							memmove (create {CE_VOID_POINTER}.make_cast ((l_p___0 + l_tl)), create {CE_VOID_POINTER}.make_cast (l_p___0), l_n.to_natural_32).do_nothing;
							(create {P_GLOBALS_STATIC}).mb_char2bytes.item.call ([l_c, l_p___0])
						else
							l_c := (l_p___0[2]).to_integer_32
							l_p___0[2] := l_p___0[1]
							l_p___0[1] := l_p___0.item
							l_p___0.item := l_c.to_natural_8
						end
						if l_stack[l_depth___1].ts_score + 110 < a_su.item.su_maxscore then
							go_deeper (l_stack, l_depth___1, 110)
							l_sp.item.ts_state := {PC_STATE_T}.STATE_UNROT3R
							l_depth___1 := l_depth___1 + 1
							l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_n := ((create {P_MBYTE_STATIC}).utf_ptr2len (l_p___0))
								else
									l_n := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
								end
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_tmp___79 := ((create {P_MBYTE_STATIC}).utf_ptr2len (l_p___0 + l_n))
								else
									l_tmp___79 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0 + l_n]))
								end
								l_n := l_n + l_tmp___79
								l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0 + l_n])
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_tl := ((create {P_MBYTE_STATIC}).utf_ptr2len (l_p___0 + l_n))
								else
									l_tl := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0 + l_n]))
								end
								memmove (create {CE_VOID_POINTER}.make_cast ((l_p___0 + l_tl)), create {CE_VOID_POINTER}.make_cast (l_p___0), l_n.to_natural_32).do_nothing;
								(create {P_GLOBALS_STATIC}).mb_char2bytes.item.call ([l_c, l_p___0])
								l_stack[l_depth___1].ts_fidxtry := (((l_sp.item.ts_fidx).to_integer_32 + l_n) + l_tl).to_natural_8
							else
								l_c := (l_p___0[2]).to_integer_32
								l_p___0[2] := l_p___0[1]
								l_p___0[1] := l_p___0.item
								l_p___0.item := l_c.to_natural_8
								l_stack[l_depth___1].ts_fidxtry := ((l_sp.item.ts_fidx).to_integer_32 + 3).to_natural_8
							end
						else
							l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_INI
						end
						l_pos := -1 + 162 -- switch 1; break
				when 152 then -- switch 1, case 13
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0])
							l_tl := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_p___0.item).to_integer_32]).to_integer_32
							l_n := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_p___0[l_tl]).to_integer_32]).to_integer_32
							l_n := l_n + ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_p___0[(l_tl + l_n)]).to_integer_32]).to_integer_32
							memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + l_tl)), l_n.to_natural_32).do_nothing;
							(create {P_GLOBALS_STATIC}).mb_char2bytes.item.call ([l_c, l_p___0 + l_n])
						else
							l_c := (l_p___0.item).to_integer_32
							l_p___0.item := l_p___0[1]
							l_p___0[1] := l_p___0[2]
							l_p___0[2] := l_c.to_natural_8
						end
				when 153 then -- switch 1, case 14
						if not ((a_lp.item.lp_replang).is_void) then
							l_pos := -1 + 156 -- skip if block
						end
				when 154 then -- if:
						if not a_soundfold.to_boolean then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_FINAL
							l_pos := -1 + 162 -- switch 1; break
						else
							l_pos := -1 + 156 -- goto _L___17
						end
				when 155 then -- if block done, skip else block:
						l_pos := -1 + 157
				when 156 then -- else: | _L___17:
						if l_sp.item.ts_score + 65 >= a_su.item.su_maxscore then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_FINAL
							l_pos := -1 + 162 -- switch 1; break
						elseif (l_sp.item.ts_fidx).to_integer_32 < (l_sp.item.ts_fidxtry).to_integer_32 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_FINAL
							l_pos := -1 + 162 -- switch 1; break
						end
				when 157 then
						if a_soundfold.to_boolean then
							l_sp.item.ts_curi := l_slang.item.sl_repsal_first[(a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32]
						else
							l_sp.item.ts_curi := (a_lp.item.lp_replang).item.sl_rep_first[(a_fword[(l_sp.item.ts_fidx).to_integer_32]).to_integer_32]
						end
						if (l_sp.item.ts_curi).to_integer_32 < 0 then
							l_sp.item.ts_state := {PC_STATE_T}.STATE_FINAL
							l_pos := -1 + 162 -- switch 1; break
						end
				when 158 then
						l_sp.item.ts_state := {PC_STATE_T}.STATE_REP
				when 159 then -- switch 1, case 15
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						if a_soundfold.to_boolean then
							l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_repsal"))
						else
							l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared ((a_lp.item.lp_replang).c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_rep"))
						end
						from
						until
							not (not (l_break) and then ((l_sp.item.ts_curi).to_integer_32 < l_gap.item.ga_len))
						loop
							l_break := False
							l_tmp___82 := l_sp.item.ts_curi
							l_sp.item.ts_curi := ((l_sp.item.ts_curi).to_integer_32 + 1).to_integer_16
							l_ftp := create {CE_CLASS_POINTER [PD_FROMTO_S]}.make_cast (l_gap.item.ga_data) + l_tmp___82.to_integer_32
							if ((l_ftp.item.ft_from).item).to_integer_32 /= (l_p___0.item).to_integer_32 then
								l_sp.item.ts_curi := (l_gap.item.ga_len).to_integer_16
								l_break := True
							end
							if not (l_break) then
								if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_ftp.item.ft_from), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ftp.item.ft_from))))) = 0 then
									if l_stack[l_depth___1].ts_score + 65 < a_su.item.su_maxscore then
										go_deeper (l_stack, l_depth___1, 65)
										l_sp.item.ts_state := {PC_STATE_T}.STATE_REP_UNDO
										l_depth___1 := l_depth___1 + 1
										l_fl := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ftp.item.ft_from))).to_integer_32
										l_tl := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ftp.item.ft_to))).to_integer_32
										if l_fl /= l_tl then
											memmove (create {CE_VOID_POINTER}.make_cast ((l_p___0 + l_tl)), create {CE_VOID_POINTER}.make_cast ((l_p___0 + l_fl)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + l_fl)))) + {NATURAL_32} 1).do_nothing
											l_repextra := l_repextra + (l_tl - l_fl)
										end
										memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_ftp.item.ft_to), l_tl.to_natural_32).do_nothing
										l_stack[l_depth___1].ts_fidxtry := ((l_sp.item.ts_fidx).to_integer_32 + l_tl).to_natural_8
										l_stack[l_depth___1].ts_tcharlen := (0).to_natural_8
										l_break := True
									end
								end
							end
						end
						l_break := False
						if (l_sp.item.ts_curi).to_integer_32 >= l_gap.item.ga_len then
							if l_sp.item.ts_state = {NATURAL_32} 15 then
								l_sp.item.ts_state := {PC_STATE_T}.STATE_FINAL
							end
						end
						l_pos := -1 + 162 -- switch 1; break
				when 160 then -- switch 1, case 16
						if a_soundfold.to_boolean then
							l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_repsal"))
						else
							l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared ((a_lp.item.lp_replang).c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_rep"))
						end
						l_ftp := (create {CE_CLASS_POINTER [PD_FROMTO_S]}.make_cast (l_gap.item.ga_data) + (l_sp.item.ts_curi).to_integer_32) - 1
						l_fl := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ftp.item.ft_from))).to_integer_32
						l_tl := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ftp.item.ft_to))).to_integer_32
						l_p___0 := a_fword + (l_sp.item.ts_fidx).to_integer_32
						if l_fl /= l_tl then
							memmove (create {CE_VOID_POINTER}.make_cast ((l_p___0 + l_fl)), create {CE_VOID_POINTER}.make_cast ((l_p___0 + l_tl)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + l_tl)))) + {NATURAL_32} 1).do_nothing
							l_repextra := l_repextra - (l_tl - l_fl)
						end
						memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_ftp.item.ft_from), l_fl.to_natural_32).do_nothing
						l_sp.item.ts_state := {PC_STATE_T}.STATE_REP
						l_pos := -1 + 162 -- switch 1; break
				when 161 then -- switch 1, default:
						l_depth___1 := l_depth___1 - 1
						if l_depth___1 >= 0 then
							if (l_stack[l_depth___1].ts_prefixdepth).to_integer_32 = 254 then
								l_byts := l_pbyts
								l_idxs := l_pidxs
							end
						end
						l_breakcheckcount := l_breakcheckcount - 1
						if l_breakcheckcount = 0 then
							(create {P_UI_STATIC}).ui_breakcheck
							l_breakcheckcount := 1_000
						end
				when 162 then -- switch 1, done: | if done
						l_pos := -1 + 1 -- back to loop condition
				when 163 then -- loop done
					l_break := False
				when 164 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	can_be_compound (a_sp: CE_POINTER [PD_TRYSTATE_S]; a_slang: CE_POINTER [PD_SLANG_S]; a_compflags: CE_POINTER [NATURAL_8]; a_flag: INTEGER_32): INTEGER_32
		require
			not a_sp.is_void
			not a_slang.is_void
		local
			l_tmp: CE_POINTER [NATURAL_8]
			l_v: INTEGER_32
			l_return: BOOLEAN
		do
			if (a_sp.item.ts_complen).to_integer_32 = (a_sp.item.ts_compsplit).to_integer_32 then
				l_tmp := a_slang.item.sl_compstartflags
			else
				l_tmp := a_slang.item.sl_compallflags
			end
			if not ((create {P_SPELL_STATIC}).byte_in_str (l_tmp, a_flag)).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return and then (not (a_slang.item.sl_comprules).is_void) then
				if (a_sp.item.ts_complen).to_integer_32 > (a_sp.item.ts_compsplit).to_integer_32 then
					a_compflags[(a_sp.item.ts_complen).to_integer_32] := a_flag.to_natural_8
					a_compflags[((a_sp.item.ts_complen).to_integer_32 + 1)] := (('%/0/').code).to_natural_8
					l_v := a_slang.item.match_compoundrule (a_compflags + (a_sp.item.ts_compsplit).to_integer_32)
					a_compflags[(a_sp.item.ts_complen).to_integer_32] := (('%/0/').code).to_natural_8
					Result := l_v
					l_return := True
				end
			end
			if not l_return then
				Result := 1
			end
		end

	go_deeper (a_stack: CE_POINTER [PD_TRYSTATE_S]; a_depth___1, a_score_add: INTEGER_32)
		require
			not a_stack.is_void
		do
			a_stack[(a_depth___1 + 1)] := (a_stack[a_depth___1]).twin;
			(a_stack + (a_depth___1 + 1)).item.ts_state := {PC_STATE_T}.STATE_START;
			(a_stack + (a_depth___1 + 1)).item.ts_score := (a_stack + a_depth___1).item.ts_score + a_score_add;
			(a_stack + (a_depth___1 + 1)).item.ts_curi := (1).to_integer_16;
			(a_stack + (a_depth___1 + 1)).item.ts_flags := (0).to_natural_8
		end

	suggest_try_soundalike_finish
		local
			l_lp: CE_POINTER [PD_LANGP_S]
			l_lpi: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
			l_todo: INTEGER_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_return: BOOLEAN
		do
			l_lpi := 0
			from
			until
				not (not (l_return) and then (l_lpi < ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_len))
			loop
				l_lp := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_langp.ga_data) + l_lpi
				l_slang := l_lp.item.lp_slang
				if l_slang.item.sl_sal.ga_len > 0 then
					if not (l_slang.item.sl_sbyts).is_void then
						l_todo := (l_slang.item.sl_sounddone.ht_used).to_integer_32
						l_hi___1 := l_slang.item.sl_sounddone.ht_array
						from
						until
							not (l_todo > 0)
						loop
							if not ((l_hi___1.item.hi_key).is_void) then
								if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((l_hi___1.item.hi_key - ((dumsft.item.item.sft_word).distance ((create {CE_NATURAL_8_POINTER}.make_cast (dumsft.item)))))))
									l_todo := l_todo - 1
								end
							end
							l_hi___1 := l_hi___1 + 1
						end
						(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sounddone"))).item.hash_clear;
						(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sounddone"))).item.hash_init
					end
				end
				l_lpi := l_lpi + 1
			end
		end

	add_sound_suggest (a_su: CE_POINTER [PD_SUGINFO_S]; a_goodword: CE_POINTER [NATURAL_8]; a_score: INTEGER_32; a_lp: CE_POINTER [PD_LANGP_S])
		require
			not a_goodword.is_void
			not a_lp.is_void
		local
			l_slang: CE_POINTER [PD_SLANG_S]
			l_sfwordnr: INTEGER_32
			l_nrline: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_orgnr: INTEGER_32
			l_theword: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_wlen: INTEGER_32
			l_byts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_n: INTEGER_32
			l_wordcount: INTEGER_32
			l_wc: INTEGER_32
			l_goodscore: INTEGER_32
			l_hash: NATURAL_32
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_sft: CE_POINTER [PD_SFTWORD_T]
			l_bc: INTEGER_32
			l_gc: INTEGER_32
			l_limit: INTEGER_32
			l_tmp___3: INTEGER_32
			l_cword: CE_ARRAY [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_flags___0: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_nrline.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_theword.make (<<250>>)
			create {CE_NATURAL_8_ARRAY} l_cword.make (<<250>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_slang := a_lp.item.lp_slang
					l_hash := (create {P_HASHTAB_STATIC}).hash_hash (a_goodword)
					l_hi___1 := (create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sounddone"))).item.hash_lookup (a_goodword, l_hash)
					if not ((l_hi___1.item.hi_key).is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_sft := create {CE_CLASS_POINTER [PD_SFTWORD_T]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_SFTWORD_T}.make).structure_size.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_goodword))))))
						if not l_sft.is_void then
							l_sft.item.sft_score := a_score.to_integer_16
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_sft.item.sft_word)), create {CE_INTEGER_8_POINTER}.make_cast (a_goodword)).do_nothing;
							(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (l_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_sounddone"))).item.hash_add_item (l_hi___1, l_sft.item.sft_word, l_hash).do_nothing
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_sft := create {CE_CLASS_POINTER [PD_SFTWORD_T]}.make_cast ((l_hi___1.item.hi_key - ((dumsft.item.item.sft_word).distance ((create {CE_NATURAL_8_POINTER}.make_cast (dumsft.item))))))
						if a_score >= (l_sft.item.sft_score).to_integer_32 then
							l_return := True
						end
						if not l_return then
							l_sft.item.sft_score := a_score.to_integer_16
						end
				when 7 then -- if done
					if not l_return then
						l_sfwordnr := soundfold_find (l_slang, a_goodword)
						if l_sfwordnr < 0 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_intern2.item))))), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("add_sound_suggest()"))).do_nothing
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 48 -- skip if block
					end
				when 8 then -- if:
						l_nrline.item := (l_slang.item.sl_sugbuf).item.ml_get_buf ((l_sfwordnr + 1).to_integer_32, 0)
						l_orgnr := 0
				when 9 then -- loop condition:
						if not (not (l_return) and then ((l_nrline.item.item).to_integer_32 /= 0)) then
							l_pos := -1 + 48 -- skip loop
						end
				when 10 then -- loop body:
						l_orgnr := l_orgnr + (bytes2offset (l_nrline))
						l_byts := l_slang.item.sl_fbyts
						l_idxs := l_slang.item.sl_fidxs
						l_n := 0
						l_wlen := 0
						l_wordcount := 0
				when 11 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 19 -- skip loop
						end
				when 12 then -- loop body:
						l_break := False
						l_i___0 := 1
						if l_wordcount = l_orgnr then
							if (l_byts[(l_n + 1)]).to_integer_32 = 0 then
								l_break := True
							end
						end
						if (l_return or l_break) then
							l_pos := -1 + 18 -- skip if block
						end
				when 13 then -- if:
						if (l_byts[(l_n + 1)]).to_integer_32 = 0 then
							l_wordcount := l_wordcount + 1
						end
				when 14 then -- loop condition:
						if (l_byts[(l_n + l_i___0)]).to_integer_32 /= 0 then
							l_pos := -1 + 17 -- skip loop
						end
				when 15 then -- loop body:
						if l_i___0 > (l_byts[l_n]).to_integer_32 then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_theword + l_wlen)), ce_string ("BAD")).do_nothing
							l_pos := -1 + 20 -- goto badword
						end
				when 16 then
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 14 -- back to loop condition
				when 17 then -- loop done
						from
						until
							not (not (l_break) and then (l_i___0 < (l_byts[l_n]).to_integer_32))
						loop
							l_break := False
							l_wc := l_idxs[(l_idxs[(l_n + l_i___0)])]
							if l_wordcount + l_wc > l_orgnr then
								l_break := True
							end
							if not (l_break) then
								l_wordcount := l_wordcount + l_wc
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						l_tmp___3 := l_wlen
						l_wlen := l_wlen + 1
						l_theword[l_tmp___3] := l_byts[(l_n + l_i___0)]
						l_n := l_idxs[(l_n + l_i___0)]
				when 18 then -- if done
						l_pos := -1 + 11 -- back to loop condition
				when 19 then -- loop done
						l_break := False
				when 20 then -- badword:
						l_theword[l_wlen] := (('%/0/').code).to_natural_8
				when 21 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 47 -- skip loop
						end
				when 22 then -- loop body:
						l_break := False
						l_continue := False
						if l_i___0 <= (l_byts[l_n]).to_integer_32 then
							if (l_byts[(l_n + l_i___0)]).to_integer_32 /= 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_flags___0 := l_idxs[(l_n + l_i___0)]
							if ((l_flags___0).bit_and (1_024)).to_boolean then
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 46 -- skip if block
						end
				when 23 then -- if:
						if ((l_flags___0).bit_and (128)).to_boolean then
							find_keepcap_word (l_slang, l_theword, l_cword)
							l_p___0 := l_cword
						else
							l_flags___0 := (l_flags___0).bit_or ((a_su.item.su_badflags))
							if ((l_flags___0).bit_and (198)) /= 0 then
								(create {P_SPELL_STATIC}).make_case_word (l_theword, l_cword, l_flags___0)
								l_p___0 := l_cword
							else
								l_p___0 := l_theword
							end
						end
						if not ((((create {P_SPELL_STATIC}).sps_flags.item).bit_and (4)).to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						if a_score <= a_su.item.su_maxscore then
							a_su.item.add_suggestion (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_sga")), l_p___0, a_su.item.su_badlen, a_score, 0, 0, l_slang, 0)
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 26 then -- else:
						if ((l_flags___0).bit_and (1)).to_boolean then
							if ((((l_flags___0.to_natural_32).bit_shift_right (16))).bit_and ((a_lp.item.lp_region).to_natural_32)) = {NATURAL_32} 0 then
								l_goodscore := 200
							else
								l_goodscore := 0
							end
						else
							l_goodscore := 0
						end
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_gc := ((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0]))
						else
							l_gc := (l_p___0.item).to_integer_32
						end
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						if l_gc >= 128 then
							l_tmp___21 := ((create {P_MBYTE_STATIC}).utf_isupper (l_gc))
						else
							l_pos := -1 + 29 -- goto _L___3
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else: | _L___3:
						if l_gc < 256 then
							l_tmp___20 := ((create {P_SPELL_STATIC}).spelltab.item.item.st_isu[l_gc]).to_integer_32
						else
							l_tmp___20 := (iswupper (l_gc.to_natural_32))
						end
						l_tmp___21 := l_tmp___20
				when 30 then
						if not (l_tmp___21.to_boolean) then
							l_pos := -1 + 45 -- skip if block
						end
				when 31 then -- if:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_bc := ((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([a_su.item.su_badword]))
						else
							l_bc := (a_su.item.su_badword[0]).to_integer_32
						end
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						if l_bc >= 128 then
							l_tmp___9 := ((create {P_MBYTE_STATIC}).utf_isupper (l_bc))
						else
							l_pos := -1 + 34 -- goto _L___0
						end
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else: | _L___0:
						if l_bc < 256 then
							l_tmp___8 := ((create {P_SPELL_STATIC}).spelltab.item.item.st_isu[l_bc]).to_integer_32
						else
							l_tmp___8 := (iswupper (l_bc.to_natural_32))
						end
						l_tmp___9 := l_tmp___8
				when 35 then
						if l_tmp___9.to_boolean then
							l_pos := -1 + 45 -- skip if block
						end
				when 36 then -- if:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if l_bc >= 128 then
							l_tmp___13 := ((create {P_MBYTE_STATIC}).utf_fold (l_bc))
						else
							l_pos := -1 + 39 -- goto _L___1
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 39 then -- else: | _L___1:
						if l_bc < 256 then
							l_tmp___12 := ((create {P_SPELL_STATIC}).spelltab.item.item.st_fold[l_bc]).to_integer_32
						else
							l_tmp___12 := (towlower (l_bc.to_natural_32)).to_integer_32
						end
						l_tmp___13 := l_tmp___12
				when 40 then
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						if l_gc >= 128 then
							l_tmp___17 := ((create {P_MBYTE_STATIC}).utf_fold (l_gc))
						else
							l_pos := -1 + 43 -- goto _L___2
						end
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else: | _L___2:
						if l_gc < 256 then
							l_tmp___16 := ((create {P_SPELL_STATIC}).spelltab.item.item.st_fold[l_gc]).to_integer_32
						else
							l_tmp___16 := (towlower (l_gc.to_natural_32)).to_integer_32
						end
						l_tmp___17 := l_tmp___16
				when 44 then
						if l_tmp___13 /= l_tmp___17 then
							l_goodscore := l_goodscore + (26)
						end
				when 45 then -- if done | if done
						l_limit := ((4 * a_su.item.su_sfmaxscore - l_goodscore) - a_score) // 3
						if l_limit > 350 then
							l_goodscore := l_goodscore + (spell_edit_score (l_slang, a_su.item.su_badword, l_p___0))
						else
							l_goodscore := l_goodscore + (spell_edit_score_limit (l_slang, a_su.item.su_badword, l_p___0, l_limit))
						end
						if l_goodscore < 999_999 then
							l_goodscore := score_wordcount_adj (l_slang, l_goodscore, l_p___0, 0)
							l_goodscore := (3 * l_goodscore + a_score) // 4
							if l_goodscore <= a_su.item.su_sfmaxscore then
								a_su.item.add_suggestion (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_su.c_pointer + (create {PD_SUGINFO_S}.make).offset_of ("su_ga")), l_p___0, a_su.item.su_badlen, l_goodscore, a_score, 1, l_slang, 1)
							end
						end
				when 46 then -- if done | if done
						if (not l_break) then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 21 -- back to loop condition
				when 47 then -- loop done
						l_break := False
						l_continue := False
						l_pos := -1 + 9 -- back to loop condition
				when 48 then -- loop done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	score_wordcount_adj (a_slang: CE_POINTER [PD_SLANG_S]; a_score: INTEGER_32; a_word: CE_POINTER [NATURAL_8]; a_split: INTEGER_32): INTEGER_32
		local
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_wc: CE_POINTER [PD_WORDCOUNT_S]
			l_bonus: INTEGER_32
			l_newscore: INTEGER_32
			l_return: BOOLEAN
		do
			l_hi___1 := (create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_wordcount"))).item.hash_find (a_word)
			if not ((l_hi___1.item.hi_key).is_void) then
				if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
					l_wc := create {CE_CLASS_POINTER [PD_WORDCOUNT_S]}.make_cast ((l_hi___1.item.hi_key - ((((create {P_SPELL_STATIC}).dumwc.item.item.wc_word).distance ((create {CE_NATURAL_8_POINTER}.make_cast (((create {P_SPELL_STATIC}).dumwc.item))))).to_natural_32).to_integer_32))
					if (l_wc.item.wc_count).to_integer_32 < 10 then
						l_bonus := 30
					elseif (l_wc.item.wc_count).to_integer_32 < 100 then
						l_bonus := 40
					else
						l_bonus := 50
					end
					if a_split.to_boolean then
						l_newscore := a_score - l_bonus // 2
					else
						l_newscore := a_score - l_bonus
					end
					if l_newscore < 0 then
						Result := 0
						l_return := True
					end
					if not l_return then
						Result := l_newscore
						l_return := True
					end
				end
			end
			if not l_return then
				Result := a_score
			end
		end

	find_keepcap_word (a_slang: CE_POINTER [PD_SLANG_S]; a_fword, a_kword: CE_POINTER [NATURAL_8])
		require
			not a_slang.is_void
			not a_kword.is_void
		local
			l_uword: CE_ARRAY [NATURAL_8]
			l_depth___1: INTEGER_32
			l_tryidx: INTEGER_32
			l_arridx: CE_ARRAY [INTEGER_32]
			l_round: CE_ARRAY [INTEGER_32]
			l_fwordidx: CE_ARRAY [INTEGER_32]
			l_uwordidx: CE_ARRAY [INTEGER_32]
			l_kwordlen: CE_ARRAY [INTEGER_32]
			l_flen: INTEGER_32
			l_ulen: INTEGER_32
			l_l: INTEGER_32
			l_len: INTEGER_32
			l_c: INTEGER_32
			l_lo: INTEGER_32
			l_hi___1: INTEGER_32
			l_m: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_byts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_uword.make (<<250>>)
			create {CE_INTEGER_32_ARRAY} l_arridx.make (<<250>>)
			create {CE_INTEGER_32_ARRAY} l_round.make (<<250>>)
			create {CE_INTEGER_32_ARRAY} l_fwordidx.make (<<250>>)
			create {CE_INTEGER_32_ARRAY} l_uwordidx.make (<<250>>)
			create {CE_INTEGER_32_ARRAY} l_kwordlen.make (<<250>>)

			l_byts := a_slang.item.sl_kbyts
			l_idxs := a_slang.item.sl_kidxs
			if l_byts.is_void then
				a_kword.item := (('%/0/').code).to_natural_8
				l_return := True
			end
			if not l_return then
				(create {P_SPELL_STATIC}).allcap_copy (a_fword, l_uword)
				l_depth___1 := 0
				l_arridx[0] := 0
				l_round[0] := 0
				l_fwordidx[0] := 0
				l_uwordidx[0] := 0
				l_kwordlen[0] := 0
				from
				until
					not (not (l_return) and then (l_depth___1 >= 0))
				loop
					if (a_fword[(l_fwordidx[l_depth___1])]).to_integer_32 = 0 then
						if (l_byts[(l_arridx[l_depth___1] + 1)]).to_integer_32 = 0 then
							a_kword[(l_kwordlen[l_depth___1])] := (('%/0/').code).to_natural_8
							l_return := True
						end
						if not l_return then
							l_depth___1 := l_depth___1 - 1
						end
					else
						l_round[l_depth___1] := (l_round[l_depth___1]) + 1
						if l_round[l_depth___1] > 2 then
							l_depth___1 := l_depth___1 - 1
						else
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_flen := ((create {P_MBYTE_STATIC}).utf_ptr2len (a_fword + l_fwordidx[l_depth___1]))
								else
									l_flen := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([a_fword + l_fwordidx[l_depth___1]]))
								end
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_ulen := ((create {P_MBYTE_STATIC}).utf_ptr2len (l_uword + l_uwordidx[l_depth___1]))
								else
									l_ulen := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_uword + l_uwordidx[l_depth___1]]))
								end
							else
								l_flen := 1
								l_ulen := l_flen
							end
							if l_round[l_depth___1] = 1 then
								l_p___0 := a_fword + l_fwordidx[l_depth___1]
								l_l := l_flen
							else
								l_p___0 := l_uword + l_uwordidx[l_depth___1]
								l_l := l_ulen
							end
							l_tryidx := l_arridx[l_depth___1]
							from
							until
								not (not (l_return or l_break) and then (l_l > 0))
							loop
								l_break := False
								l_tmp___3 := l_tryidx
								l_tryidx := l_tryidx + 1
								l_len := (l_byts[l_tmp___3]).to_integer_32
								l_tmp___4 := l_p___0
								l_p___0 := l_p___0 + 1
								l_c := (l_tmp___4.item).to_integer_32
								l_lo := l_tryidx
								l_hi___1 := (l_tryidx + l_len) - 1
								from
								until
									not (not (l_break) and then (l_lo < l_hi___1))
								loop
									l_break := False
									l_m := (l_lo + l_hi___1) // 2
									if (l_byts[l_m]).to_integer_32 > l_c then
										l_hi___1 := l_m - 1
									elseif (l_byts[l_m]).to_integer_32 < l_c then
										l_lo := l_m + 1
									else
										l_hi___1 := l_m
										l_lo := l_hi___1
										l_break := True
									end
								end
								l_break := False
								if l_hi___1 < l_lo then
									l_break := True
								elseif (l_byts[l_lo]).to_integer_32 /= l_c then
									l_break := True
								end
								if not (l_return or l_break) then
									l_tryidx := l_idxs[l_lo]
									l_l := l_l - 1
								end
							end
							l_break := False
							if l_l = 0 then
								if l_round[l_depth___1] = 1 then
									strncpy (create {CE_INTEGER_8_POINTER}.make_cast ((a_kword + l_kwordlen[l_depth___1])), create {CE_INTEGER_8_POINTER}.make_cast ((a_fword + l_fwordidx[l_depth___1])), l_flen.to_natural_32).do_nothing
									l_kwordlen[l_depth___1 + 1] := l_kwordlen[l_depth___1] + l_flen
								else
									strncpy (create {CE_INTEGER_8_POINTER}.make_cast ((a_kword + l_kwordlen[l_depth___1])), create {CE_INTEGER_8_POINTER}.make_cast ((l_uword + l_uwordidx[l_depth___1])), l_ulen.to_natural_32).do_nothing
									l_kwordlen[l_depth___1 + 1] := l_kwordlen[l_depth___1] + l_ulen
								end
								l_fwordidx[l_depth___1 + 1] := l_fwordidx[l_depth___1] + l_flen
								l_uwordidx[l_depth___1 + 1] := l_uwordidx[l_depth___1] + l_ulen
								l_depth___1 := l_depth___1 + 1
								l_arridx[l_depth___1] := l_tryidx
								l_round[l_depth___1] := 0
							end
						end
					end
				end
			end
			if not l_return then
				a_kword.item := (('%/0/').code).to_natural_8
			end
		end

	spell_edit_score (a_slang: CE_POINTER [PD_SLANG_S]; a_badword, a_goodword: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_cnt: CE_POINTER [INTEGER_32]
			l_badlen: INTEGER_32
			l_goodlen: INTEGER_32
			l_j: INTEGER_32
			l_i___0: INTEGER_32
			l_t: INTEGER_32
			l_bc: INTEGER_32
			l_gc: INTEGER_32
			l_pbc: INTEGER_32
			l_pgc: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_wbadword: CE_ARRAY [INTEGER_32]
			l_wgoodword: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_wbadword.make (<<250>>)
			create {CE_INTEGER_32_ARRAY} l_wgoodword.make (<<250>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_p___0.item := a_badword
						l_badlen := 0
						from
						until
							(l_p___0.item.item).to_integer_32 = 0
						loop
							l_tmp := l_badlen
							l_badlen := l_badlen + 1
							l_wbadword[l_tmp] := (create {P_MBYTE_STATIC}).mb_cptr2char_adv (l_p___0)
						end
						l_tmp___0 := l_badlen
						l_badlen := l_badlen + 1
						l_wbadword[l_tmp___0] := 0
						l_p___0.item := a_goodword
						l_goodlen := 0
						from
						until
							(l_p___0.item.item).to_integer_32 = 0
						loop
							l_tmp___1 := l_goodlen
							l_goodlen := l_goodlen + 1
							l_wgoodword[l_tmp___1] := (create {P_MBYTE_STATIC}).mb_cptr2char_adv (l_p___0)
						end
						l_tmp___2 := l_goodlen
						l_goodlen := l_goodlen + 1
						l_wgoodword[l_tmp___2] := 0
					else
						l_badlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_badword))).to_integer_32 + 1
						l_goodlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_goodword))).to_integer_32 + 1
					end
					l_cnt := create {CE_INTEGER_32_POINTER}.make_cast (((create {P_MISC2_STATIC}).lalloc ((({PLATFORM}.Integer_32_bytes.to_natural_32 * (l_badlen + 1).to_natural_32) * (l_goodlen + 1).to_natural_32).to_natural_32, 1)))
					if l_cnt.is_void then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						l_cnt[0] := 0
						l_j := 1
						from
						until
							not (l_j <= l_goodlen)
						loop
							l_cnt[l_j * (l_badlen + 1)] := l_cnt[(l_j - 1) * (l_badlen + 1)] + 96
							l_j := l_j + 1
						end
						l_i___0 := 1
				when 2 then -- loop condition:
						if not (not (l_return) and then (l_i___0 <= l_badlen)) then
							l_pos := -1 + 19 -- skip loop
						end
				when 3 then -- loop body:
						l_cnt[l_i___0] := l_cnt[(l_i___0 - 1)] + 94
						l_j := 1
				when 4 then -- loop condition:
						if not (l_j <= l_goodlen) then
							l_pos := -1 + 18 -- skip loop
						end
				when 5 then -- loop body:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_bc := l_wbadword[l_i___0 - 1]
							l_gc := l_wgoodword[l_j - 1]
						else
							l_bc := (a_badword[(l_i___0 - 1)]).to_integer_32
							l_gc := (a_goodword[(l_j - 1)]).to_integer_32
						end
						if l_bc /= l_gc then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := l_cnt[((l_i___0 - 1) + (l_j - 1) * (l_badlen + 1))]
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 8 then -- else:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if l_bc >= 128 then
							l_tmp___10 := ((create {P_MBYTE_STATIC}).utf_fold (l_bc))
						else
							l_pos := -1 + 11 -- goto _L
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L:
						if l_bc < 256 then
							l_tmp___9 := ((create {P_SPELL_STATIC}).spelltab.item.item.st_fold[l_bc]).to_integer_32
						else
							l_tmp___9 := (towlower (l_bc.to_natural_32)).to_integer_32
						end
						l_tmp___10 := l_tmp___9
				when 12 then
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_gc >= 128 then
							l_tmp___14 := ((create {P_MBYTE_STATIC}).utf_fold (l_gc))
						else
							l_pos := -1 + 15 -- goto _L___0
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L___0:
						if l_gc < 256 then
							l_tmp___13 := ((create {P_SPELL_STATIC}).spelltab.item.item.st_fold[l_gc]).to_integer_32
						else
							l_tmp___13 := (towlower (l_gc.to_natural_32)).to_integer_32
						end
						l_tmp___14 := l_tmp___13
				when 16 then
						if l_tmp___10 = l_tmp___14 then
							l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := 52 + l_cnt[((l_i___0 - 1) + (l_j - 1) * (l_badlen + 1))]
						elseif not a_slang.is_void then
							if (a_slang.item.sl_has_map).to_boolean then
								if (similar_chars (a_slang, l_gc, l_bc)).to_boolean then
									l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := 33 + l_cnt[((l_i___0 - 1) + (l_j - 1) * (l_badlen + 1))]
								else
									l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := 93 + l_cnt[((l_i___0 - 1) + (l_j - 1) * (l_badlen + 1))]
								end
							else
								l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := 93 + l_cnt[((l_i___0 - 1) + (l_j - 1) * (l_badlen + 1))]
							end
						else
							l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := 93 + l_cnt[((l_i___0 - 1) + (l_j - 1) * (l_badlen + 1))]
						end
						if l_i___0 > 1 then
							if l_j > 1 then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_pbc := l_wbadword[l_i___0 - 2]
									l_pgc := l_wgoodword[l_j - 2]
								else
									l_pbc := (a_badword[(l_i___0 - 2)]).to_integer_32
									l_pgc := (a_goodword[(l_j - 2)]).to_integer_32
								end
								if l_bc = l_pgc then
									if l_pbc = l_gc then
										l_t := 75 + l_cnt[((l_i___0 - 2) + (l_j - 2) * (l_badlen + 1))]
										if l_t < l_cnt[(l_i___0 + l_j * (l_badlen + 1))] then
											l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := l_t
										end
									end
								end
							end
						end
						l_t := 94 + l_cnt[((l_i___0 - 1) + l_j * (l_badlen + 1))]
						if l_t < l_cnt[(l_i___0 + l_j * (l_badlen + 1))] then
							l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := l_t
						end
						l_t := 96 + l_cnt[(l_i___0 + (l_j - 1) * (l_badlen + 1))]
						if l_t < l_cnt[(l_i___0 + l_j * (l_badlen + 1))] then
							l_cnt[(l_i___0 + l_j * (l_badlen + 1))] := l_t
						end
				when 17 then -- if done
						l_j := l_j + 1
						l_pos := -1 + 4 -- back to loop condition
				when 18 then -- loop done
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 2 -- back to loop condition
				when 19 then -- loop done
						l_i___0 := l_cnt[((l_badlen - 1) + (l_goodlen - 1) * (l_badlen + 1))];
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cnt))
						Result := l_i___0
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	bytes2offset (a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		require
			not a_pp.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_nr: INTEGER_32
			l_c: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
		do
			l_p___0 := a_pp.item
			l_tmp := l_p___0
			l_p___0 := l_p___0 + 1
			l_c := (l_tmp.item).to_integer_32
			if ((l_c).bit_and (128)) = 0 then
				l_nr := l_c - 1
			elseif ((l_c).bit_and (192)) = 128 then
				l_nr := ((l_c).bit_and (63)) - 1
				l_tmp___0 := l_p___0
				l_p___0 := l_p___0 + 1
				l_nr := l_nr * 255 + ((l_tmp___0.item).to_integer_32 - 1)
			elseif ((l_c).bit_and (224)) = 192 then
				l_nr := ((l_c).bit_and (31)) - 1
				l_tmp___1 := l_p___0
				l_p___0 := l_p___0 + 1
				l_nr := l_nr * 255 + ((l_tmp___1.item).to_integer_32 - 1)
				l_tmp___2 := l_p___0
				l_p___0 := l_p___0 + 1
				l_nr := l_nr * 255 + ((l_tmp___2.item).to_integer_32 - 1)
			else
				l_nr := ((l_c).bit_and (15)) - 1
				l_tmp___3 := l_p___0
				l_p___0 := l_p___0 + 1
				l_nr := l_nr * 255 + ((l_tmp___3.item).to_integer_32 - 1)
				l_tmp___4 := l_p___0
				l_p___0 := l_p___0 + 1
				l_nr := l_nr * 255 + ((l_tmp___4.item).to_integer_32 - 1)
				l_tmp___5 := l_p___0
				l_p___0 := l_p___0 + 1
				l_nr := l_nr * 255 + ((l_tmp___5.item).to_integer_32 - 1)
			end
			a_pp.item := l_p___0
			Result := l_nr
		end

	soundfold_find (a_slang: CE_POINTER [PD_SLANG_S]; a_word: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_slang.is_void
			not a_word.is_void
		local
			l_arridx: INTEGER_32
			l_len: INTEGER_32
			l_wlen: INTEGER_32
			l_c: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_byts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_wordnr: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_arridx := 0
			l_wlen := 0
			l_ptr := a_word
			l_wordnr := 0
			l_byts := a_slang.item.sl_sbyts
			l_idxs := a_slang.item.sl_sidxs
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_tmp := l_arridx
				l_arridx := l_arridx + 1
				l_len := (l_byts[l_tmp]).to_integer_32
				l_c := (l_ptr[l_wlen]).to_integer_32
				if (l_byts[l_arridx]).to_integer_32 = 0 then
					if l_c = 0 then
						l_break := True
					end
					if not (l_return or l_break) then
						from
						until
							(l_break)
						loop
							l_break := False
							if l_len > 0 then
								if (l_byts[l_arridx]).to_integer_32 /= 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_arridx := l_arridx + 1
								l_len := l_len - 1
							end
						end
						l_break := False
						if l_len = 0 then
							Result := (-1)
							l_return := True
						end
						if not l_return then
							l_wordnr := l_wordnr + 1
						end
					end
				end
				if not (l_return or l_break) then
					if l_c = 0 then
						Result := (-1)
						l_return := True
					end
					if not l_return then
						if l_c = 9 then
							l_c := (' ').code
						end
						from
						until
							not (not (l_return) and then ((l_byts[l_arridx]).to_integer_32 < l_c))
						loop
							l_wordnr := l_wordnr + (l_idxs[(l_idxs[l_arridx])])
							l_arridx := l_arridx + 1
							l_len := l_len - 1
							if l_len = 0 then
								Result := (-1)
								l_return := True
							end
						end
					end
					if not l_return and then ((l_byts[l_arridx]).to_integer_32 /= l_c) then
						Result := (-1)
						l_return := True
					end
					if not l_return then
						l_arridx := l_idxs[l_arridx]
						l_wlen := l_wlen + 1
						if l_c = 32 then
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_ptr[l_wlen]).to_integer_32 /= 32 then
									if (l_ptr[l_wlen]).to_integer_32 /= 9 then
										l_break := True
									end
								end
								if not (l_return or l_break) then
									l_wlen := l_wlen + 1
								end
							end
							l_break := False
						end
					end
				end
			end
			if not l_return then
				l_break := False
				Result := l_wordnr
			end
		end

	soundalike_score (a_goodstart, a_badstart: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_goodstart.is_void
			not a_badstart.is_void
		local
			l_goodsound: CE_POINTER [NATURAL_8]
			l_badsound: CE_POINTER [NATURAL_8]
			l_goodlen: INTEGER_32
			l_badlen: INTEGER_32
			l_n: INTEGER_32
			l_pl: CE_POINTER [NATURAL_8]
			l_ps: CE_POINTER [NATURAL_8]
			l_pl2: CE_POINTER [NATURAL_8]
			l_ps2: CE_POINTER [NATURAL_8]
			l_score: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_goodsound := a_goodstart
					l_badsound := a_badstart
					l_score := 0
					if (l_badsound.item).to_integer_32 /= 42 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___2
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 3 then -- else:
						if (l_goodsound.item).to_integer_32 /= 42 then
							l_pos := -1 + 14 -- skip if block
						end
				when 4 then -- if: | _L___2:
						if (l_badsound.item).to_integer_32 = (l_goodsound.item).to_integer_32 then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						if (l_badsound[0]).to_integer_32 /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_goodsound[1]).to_integer_32 = 0 then
							Result := 94
							l_return := True
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if (l_goodsound[0]).to_integer_32 = 0 then
							if (l_badsound[1]).to_integer_32 = 0 then
								Result := 94
								l_return := True
							end
						end
				when 9 then
						if not l_return then
							if (l_badsound[0]).to_integer_32 = 0 then
								Result := 999_999
								l_return := True
							elseif (l_goodsound[0]).to_integer_32 = 0 then
								Result := 999_999
								l_return := True
							end
						end
						if not (not l_return and then ((l_badsound[1]).to_integer_32 /= (l_goodsound[1]).to_integer_32)) then
							l_pos := -1 + 14 -- skip if block
						end
				when 10 then -- if:
						if (l_badsound[1]).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (l_goodsound[1]).to_integer_32 /= 0 then
							if (l_badsound[2]).to_integer_32 /= (l_goodsound[2]).to_integer_32 then
								l_pos := -1 + 13 -- goto _L___1
							end
						else
							l_pos := -1 + 13 -- goto _L___1
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___1:
						l_score := 62
						if (l_badsound.item).to_integer_32 = 42 then
							l_badsound := l_badsound + 1
						else
							l_goodsound := l_goodsound + 1
						end
				when 14 then -- if done | if done | if done | if done
					if not l_return then
						l_goodlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_goodsound))).to_integer_32
						l_badlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_badsound))).to_integer_32
						l_n := l_goodlen - l_badlen
						if l_n < -2 then
							Result := 999_999
							l_return := True
						elseif l_n > 2 then
							Result := 999_999
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 19 -- skip if block
					end
				when 15 then -- if:
						if l_n > 0 then
							l_pl := l_goodsound
							l_ps := l_badsound
						else
							l_pl := l_badsound
							l_ps := l_goodsound
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_pl.item).to_integer_32 = (l_ps.item).to_integer_32 then
								if (l_pl.item).to_integer_32 = 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_pl := l_pl + 1
								l_ps := l_ps + 1
							end
						end
						l_break := False
						inspect l_n -- switch 1 head
						when -2 then l_pos := -1 + 16 -- -2
						when 2 then l_pos := -1 + 16
						when -1 then l_pos := -1 + 17 -- -1
						when 1 then l_pos := -1 + 17
						when 0 then l_pos := -1 + 18
						else l_pos := -1 + 19
						end
				when 16 then -- switch 1, case -2 | switch 1, case 2
						l_pl := l_pl + 1
						from
						until
							(l_pl.item).to_integer_32 /= (l_ps.item).to_integer_32
						loop
							l_pl := l_pl + 1
							l_ps := l_ps + 1
						end
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_pl + 1)), create {CE_INTEGER_8_POINTER}.make_cast (l_ps))) = 0 then
							Result := (l_score + 188)
							l_return := True
						end
						l_pos := -1 + 19 -- switch 1; break
				when 17 then -- switch 1, case -1 | switch 1, case 1
						l_pl2 := l_pl + 1
						l_ps2 := l_ps
						from
						until
							not (not (l_return) and then ((l_pl2.item).to_integer_32 = (l_ps2.item).to_integer_32))
						loop
							if (l_pl2.item).to_integer_32 = 0 then
								Result := (l_score + 94)
								l_return := True
							end
							if not l_return then
								l_pl2 := l_pl2 + 1
								l_ps2 := l_ps2 + 1
							end
						end
						if not l_return and then ((l_pl2[0]).to_integer_32 = (l_ps2[1]).to_integer_32) then
							if (l_pl2[1]).to_integer_32 = (l_ps2[0]).to_integer_32 then
								if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_pl2 + 2)), create {CE_INTEGER_8_POINTER}.make_cast ((l_ps2 + 2)))) = 0 then
									Result := ((l_score + 94) + 75)
									l_return := True
								end
							end
						end
						if not l_return then
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_pl2 + 1)), create {CE_INTEGER_8_POINTER}.make_cast ((l_ps2 + 1)))) = 0 then
								Result := ((l_score + 94) + 93)
								l_return := True
							end
						end
						if not l_return and then ((l_pl[0]).to_integer_32 = (l_ps[1]).to_integer_32) then
							if (l_pl[1]).to_integer_32 = (l_ps[0]).to_integer_32 then
								l_pl2 := l_pl + 2
								l_ps2 := l_ps + 2
								from
								until
									(l_pl2.item).to_integer_32 /= (l_ps2.item).to_integer_32
								loop
									l_pl2 := l_pl2 + 1
									l_ps2 := l_ps2 + 1
								end
								if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_pl2 + 1)), create {CE_INTEGER_8_POINTER}.make_cast (l_ps2))) = 0 then
									Result := ((l_score + 75) + 94)
									l_return := True
								end
							end
						end
						if not l_return then
							l_pl2 := l_pl + 1
							l_ps2 := l_ps + 1
							from
							until
								(l_pl2.item).to_integer_32 /= (l_ps2.item).to_integer_32
							loop
								l_pl2 := l_pl2 + 1
								l_ps2 := l_ps2 + 1
							end
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_pl2 + 1)), create {CE_INTEGER_8_POINTER}.make_cast (l_ps2))) = 0 then
								Result := ((l_score + 93) + 94)
								l_return := True
							end
						end
						l_pos := -1 + 19 -- switch 1; break
				when 18 then -- switch 1, case 0
						if (l_pl.item).to_integer_32 = 0 then
							Result := l_score
							l_return := True
						end
						if not l_return and then ((l_pl[0]).to_integer_32 = (l_ps[1]).to_integer_32) then
							if (l_pl[1]).to_integer_32 = (l_ps[0]).to_integer_32 then
								l_pl2 := l_pl + 2
								l_ps2 := l_ps + 2
								from
								until
									not (not (l_return) and then ((l_pl2.item).to_integer_32 = (l_ps2.item).to_integer_32))
								loop
									if (l_pl2.item).to_integer_32 = 0 then
										Result := (l_score + 75)
										l_return := True
									end
									if not l_return then
										l_pl2 := l_pl2 + 1
										l_ps2 := l_ps2 + 1
									end
								end
								if not l_return and then ((l_pl2[0]).to_integer_32 = (l_ps2[1]).to_integer_32) then
									if (l_pl2[1]).to_integer_32 = (l_ps2[0]).to_integer_32 then
										if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_pl2 + 2)), create {CE_INTEGER_8_POINTER}.make_cast ((l_ps2 + 2)))) = 0 then
											Result := ((l_score + 75) + 75)
											l_return := True
										end
									end
								end
								if not l_return then
									if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_pl2 + 1)), create {CE_INTEGER_8_POINTER}.make_cast ((l_ps2 + 1)))) = 0 then
										Result := ((l_score + 75) + 93)
										l_return := True
									end
								end
							end
						end
						if not l_return then
							l_pl2 := l_pl + 1
							l_ps2 := l_ps + 1
							from
							until
								not (not (l_return) and then ((l_pl2.item).to_integer_32 = (l_ps2.item).to_integer_32))
							loop
								if (l_pl2.item).to_integer_32 = 0 then
									Result := (l_score + 93)
									l_return := True
								end
								if not l_return then
									l_pl2 := l_pl2 + 1
									l_ps2 := l_ps2 + 1
								end
							end
						end
						if not l_return and then ((l_pl2[0]).to_integer_32 = (l_ps2[1]).to_integer_32) then
							if (l_pl2[1]).to_integer_32 = (l_ps2[0]).to_integer_32 then
								if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_pl2 + 2)), create {CE_INTEGER_8_POINTER}.make_cast ((l_ps2 + 2)))) = 0 then
									Result := ((l_score + 93) + 75)
									l_return := True
								end
							end
						end
						if not l_return then
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_pl2 + 1)), create {CE_INTEGER_8_POINTER}.make_cast ((l_ps2 + 1)))) = 0 then
								Result := ((l_score + 93) + 93)
								l_return := True
							end
						end
						if not l_return then
							l_pl2 := l_pl
							l_ps2 := l_ps + 1
							from
							until
								(l_pl2.item).to_integer_32 /= (l_ps2.item).to_integer_32
							loop
								l_pl2 := l_pl2 + 1
								l_ps2 := l_ps2 + 1
							end
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_pl2 + 1)), create {CE_INTEGER_8_POINTER}.make_cast (l_ps2))) = 0 then
								Result := ((l_score + 96) + 94)
								l_return := True
							end
						end
						if not l_return then
							l_pl2 := l_pl + 1
							l_ps2 := l_ps
							from
							until
								(l_pl2.item).to_integer_32 /= (l_ps2.item).to_integer_32
							loop
								l_pl2 := l_pl2 + 1
								l_ps2 := l_ps2 + 1
							end
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_pl2), create {CE_INTEGER_8_POINTER}.make_cast ((l_ps2 + 1)))) = 0 then
								Result := ((l_score + 96) + 94)
								l_return := True
							end
						end
						l_pos := -1 + 19 -- switch 1; break
				when 19 then -- switch 1, done: | if done
					if not l_return then
						Result := 999_999
					end
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_edit_score_limit (a_slang: CE_POINTER [PD_SLANG_S]; a_badword, a_goodword: CE_POINTER [NATURAL_8]; a_limit: INTEGER_32): INTEGER_32
		local
			l_stack: CE_ARRAY [PD_LIMITSCORE_T]
			l_stackidx: INTEGER_32
			l_bi: INTEGER_32
			l_gi: INTEGER_32
			l_bi2: INTEGER_32
			l_gi2: INTEGER_32
			l_bc: INTEGER_32
			l_gc: INTEGER_32
			l_score: INTEGER_32
			l_score_off: INTEGER_32
			l_minscore: INTEGER_32
			l_round: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_LIMITSCORE_T]} l_stack.make (<<10>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						Result := (spell_edit_score_limit_w (a_slang, a_badword, a_goodword, a_limit))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 35 -- skip if block
					end
				when 1 then -- if:
						l_stackidx := 0
						l_bi := 0
						l_gi := 0
						l_score := 0
						l_minscore := a_limit + 1
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 34 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
				when 4 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 9 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						l_bc := (a_badword[l_bi]).to_integer_32
						l_gc := (a_goodword[l_gi]).to_integer_32
						if l_bc /= l_gc then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_bc = 0 then
							if l_score < l_minscore then
								l_minscore := l_score
							end
							l_pos := -1 + 32 -- goto pop
						end
				when 7 then
						l_bi := l_bi + 1
						l_gi := l_gi + 1
				when 8 then -- if done
						l_pos := -1 + 4 -- back to loop condition
				when 9 then -- loop done
						l_break := False
						if l_gc /= 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 13 -- skip loop
						end
				when 11 then -- loop body:
						l_break := False
						l_score := l_score + (94)
						if l_score >= l_minscore then
							l_pos := -1 + 32 -- goto pop
						end
				when 12 then
						l_bi := l_bi + 1
						if (a_badword[l_bi]).to_integer_32 = 0 then
							l_break := True
						end
						l_pos := -1 + 10 -- back to loop condition
				when 13 then -- loop done
						l_break := False
						l_minscore := l_score
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 15 then -- else:
						if l_bc /= 0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 16 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 19 -- skip loop
						end
				when 17 then -- loop body:
						l_break := False
						l_score := l_score + (96)
						if l_score >= l_minscore then
							l_pos := -1 + 32 -- goto pop
						end
				when 18 then
						l_gi := l_gi + 1
						if (a_goodword[l_gi]).to_integer_32 = 0 then
							l_break := True
						end
						l_pos := -1 + 16 -- back to loop condition
				when 19 then -- loop done
						l_break := False
						l_minscore := l_score
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 21 then -- else:
						l_round := 0
						from
						until
							not (not (l_return) and then (l_round <= 1))
						loop
							if l_round = 0 then
								l_tmp___0 := 94
							else
								l_tmp___0 := 96
							end
							l_score_off := l_score + l_tmp___0
							if l_score_off < l_minscore then
								if l_score_off + 33 >= l_minscore then
									l_bi2 := (l_bi + 1) - l_round
									l_gi2 := l_gi + l_round
									from
									until
										not (not (l_break) and then ((a_goodword[l_gi2]).to_integer_32 = (a_badword[l_bi2]).to_integer_32))
									loop
										l_break := False
										if (a_goodword[l_gi2]).to_integer_32 = 0 then
											l_minscore := l_score_off
											l_break := True
										end
										if not (l_break) then
											l_bi2 := l_bi2 + 1
											l_gi2 := l_gi2 + 1
										end
									end
									l_break := False
								else
									l_stack[l_stackidx].badi := (l_bi + 1) - l_round
									l_stack[l_stackidx].goodi := l_gi + l_round
									l_stack[l_stackidx].score := l_score_off
									l_stackidx := l_stackidx + 1
								end
							end
							l_round := l_round + 1
						end
						if l_score + 75 < l_minscore then
							if l_gc = (a_badword[(l_bi + 1)]).to_integer_32 then
								if l_bc = (a_goodword[(l_gi + 1)]).to_integer_32 then
									l_gi := l_gi + (2)
									l_bi := l_bi + (2)
									l_score := l_score + (75)
									l_continue := True
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 31 -- skip if block
						end
				when 22 then -- if:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if l_bc >= 128 then
							l_tmp___5 := ((create {P_MBYTE_STATIC}).utf_fold (l_bc))
						else
							l_pos := -1 + 25 -- goto _L
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else: | _L:
						if l_bc < 256 then
							l_tmp___4 := ((create {P_SPELL_STATIC}).spelltab.item.item.st_fold[l_bc]).to_integer_32
						else
							l_tmp___4 := (towlower (l_bc.to_natural_32)).to_integer_32
						end
						l_tmp___5 := l_tmp___4
				when 26 then
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						if l_gc >= 128 then
							l_tmp___9 := ((create {P_MBYTE_STATIC}).utf_fold (l_gc))
						else
							l_pos := -1 + 29 -- goto _L___0
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else: | _L___0:
						if l_gc < 256 then
							l_tmp___8 := ((create {P_SPELL_STATIC}).spelltab.item.item.st_fold[l_gc]).to_integer_32
						else
							l_tmp___8 := (towlower (l_gc.to_natural_32)).to_integer_32
						end
						l_tmp___9 := l_tmp___8
				when 30 then
						if l_tmp___5 = l_tmp___9 then
							l_score := l_score + (52)
						elseif not a_slang.is_void then
							if (a_slang.item.sl_has_map).to_boolean then
								if (similar_chars (a_slang, l_gc, l_bc)).to_boolean then
									l_score := l_score + (33)
								else
									l_score := l_score + (93)
								end
							else
								l_score := l_score + (93)
							end
						else
							l_score := l_score + (93)
						end
						if l_score < l_minscore then
							l_gi := l_gi + 1
							l_bi := l_bi + 1
							l_continue := True
						end
				when 31 then -- if done | if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 33 -- skip if block
						end
				when 32 then -- if: | pop:
						if l_stackidx = 0 then
							l_break := True
						end
				when 33 then -- if done
						if not (l_return or l_break or l_continue) then
							l_stackidx := l_stackidx - 1
							l_gi := l_stack[l_stackidx].goodi
							l_bi := l_stack[l_stackidx].badi
							l_score := l_stack[l_stackidx].score
						end
						if (not l_return and not l_break) then
							
						end
						l_pos := -1 + 2 -- back to loop condition
				when 34 then -- loop done
						l_break := False
						l_continue := False
						if l_minscore > a_limit then
							Result := 999_999
							l_return := True
						end
				when 35 then -- if done
					if not l_return then
						Result := l_minscore
					end
				when 36 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_edit_score_limit_w (a_slang: CE_POINTER [PD_SLANG_S]; a_badword, a_goodword: CE_POINTER [NATURAL_8]; a_limit: INTEGER_32): INTEGER_32
		local
			l_stack: CE_ARRAY [PD_LIMITSCORE_T]
			l_stackidx: INTEGER_32
			l_bi: INTEGER_32
			l_gi: INTEGER_32
			l_bi2: INTEGER_32
			l_gi2: INTEGER_32
			l_bc: INTEGER_32
			l_gc: INTEGER_32
			l_score: INTEGER_32
			l_score_off: INTEGER_32
			l_minscore: INTEGER_32
			l_round: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_wbadword: CE_ARRAY [INTEGER_32]
			l_wgoodword: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_LIMITSCORE_T]} l_stack.make (<<10>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_wbadword.make (<<250>>)
			create {CE_INTEGER_32_ARRAY} l_wgoodword.make (<<250>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bi := 0
					l_p___0.item := a_badword
					from
					until
						(l_p___0.item.item).to_integer_32 = 0
					loop
						l_tmp := l_bi
						l_bi := l_bi + 1
						l_wbadword[l_tmp] := (create {P_MBYTE_STATIC}).mb_cptr2char_adv (l_p___0)
					end
					l_tmp___0 := l_bi
					l_bi := l_bi + 1
					l_wbadword[l_tmp___0] := 0
					l_gi := 0
					l_p___0.item := a_goodword
					from
					until
						(l_p___0.item.item).to_integer_32 = 0
					loop
						l_tmp___1 := l_gi
						l_gi := l_gi + 1
						l_wgoodword[l_tmp___1] := (create {P_MBYTE_STATIC}).mb_cptr2char_adv (l_p___0)
					end
					l_tmp___2 := l_gi
					l_gi := l_gi + 1
					l_wgoodword[l_tmp___2] := 0
					l_stackidx := 0
					l_bi := 0
					l_gi := 0
					l_score := 0
					l_minscore := a_limit + 1
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 33 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
				when 3 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 8 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						l_bc := l_wbadword[l_bi]
						l_gc := l_wgoodword[l_gi]
						if l_bc /= l_gc then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_bc = 0 then
							if l_score < l_minscore then
								l_minscore := l_score
							end
							l_pos := -1 + 31 -- goto pop
						end
				when 6 then
						l_bi := l_bi + 1
						l_gi := l_gi + 1
				when 7 then -- if done
						l_pos := -1 + 3 -- back to loop condition
				when 8 then -- loop done
						l_break := False
						if l_gc /= 0 then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 12 -- skip loop
						end
				when 10 then -- loop body:
						l_break := False
						l_score := l_score + (94)
						if l_score >= l_minscore then
							l_pos := -1 + 31 -- goto pop
						end
				when 11 then
						l_bi := l_bi + 1
						if l_wbadword[l_bi] = 0 then
							l_break := True
						end
						l_pos := -1 + 9 -- back to loop condition
				when 12 then -- loop done
						l_break := False
						l_minscore := l_score
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 14 then -- else:
						if l_bc /= 0 then
							l_pos := -1 + 20 -- skip if block
						end
				when 15 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 18 -- skip loop
						end
				when 16 then -- loop body:
						l_break := False
						l_score := l_score + (96)
						if l_score >= l_minscore then
							l_pos := -1 + 31 -- goto pop
						end
				when 17 then
						l_gi := l_gi + 1
						if l_wgoodword[l_gi] = 0 then
							l_break := True
						end
						l_pos := -1 + 15 -- back to loop condition
				when 18 then -- loop done
						l_break := False
						l_minscore := l_score
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 20 then -- else:
						l_round := 0
						from
						until
							not (not (l_return) and then (l_round <= 1))
						loop
							if l_round = 0 then
								l_tmp___3 := 94
							else
								l_tmp___3 := 96
							end
							l_score_off := l_score + l_tmp___3
							if l_score_off < l_minscore then
								if l_score_off + 33 >= l_minscore then
									l_bi2 := (l_bi + 1) - l_round
									l_gi2 := l_gi + l_round
									from
									until
										not (not (l_break) and then (l_wgoodword[l_gi2] = l_wbadword[l_bi2]))
									loop
										l_break := False
										if l_wgoodword[l_gi2] = 0 then
											l_minscore := l_score_off
											l_break := True
										end
										if not (l_break) then
											l_bi2 := l_bi2 + 1
											l_gi2 := l_gi2 + 1
										end
									end
									l_break := False
								else
									l_stack[l_stackidx].badi := (l_bi + 1) - l_round
									l_stack[l_stackidx].goodi := l_gi + l_round
									l_stack[l_stackidx].score := l_score_off
									l_stackidx := l_stackidx + 1
								end
							end
							l_round := l_round + 1
						end
						if l_score + 75 < l_minscore then
							if l_gc = l_wbadword[l_bi + 1] then
								if l_bc = l_wgoodword[l_gi + 1] then
									l_gi := l_gi + (2)
									l_bi := l_bi + (2)
									l_score := l_score + (75)
									l_continue := True
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 30 -- skip if block
						end
				when 21 then -- if:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if l_bc >= 128 then
							l_tmp___8 := ((create {P_MBYTE_STATIC}).utf_fold (l_bc))
						else
							l_pos := -1 + 24 -- goto _L
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L:
						if l_bc < 256 then
							l_tmp___7 := ((create {P_SPELL_STATIC}).spelltab.item.item.st_fold[l_bc]).to_integer_32
						else
							l_tmp___7 := (towlower (l_bc.to_natural_32)).to_integer_32
						end
						l_tmp___8 := l_tmp___7
				when 25 then
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if l_gc >= 128 then
							l_tmp___12 := ((create {P_MBYTE_STATIC}).utf_fold (l_gc))
						else
							l_pos := -1 + 28 -- goto _L___0
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else: | _L___0:
						if l_gc < 256 then
							l_tmp___11 := ((create {P_SPELL_STATIC}).spelltab.item.item.st_fold[l_gc]).to_integer_32
						else
							l_tmp___11 := (towlower (l_gc.to_natural_32)).to_integer_32
						end
						l_tmp___12 := l_tmp___11
				when 29 then
						if l_tmp___8 = l_tmp___12 then
							l_score := l_score + (52)
						elseif not a_slang.is_void then
							if (a_slang.item.sl_has_map).to_boolean then
								if (similar_chars (a_slang, l_gc, l_bc)).to_boolean then
									l_score := l_score + (33)
								else
									l_score := l_score + (93)
								end
							else
								l_score := l_score + (93)
							end
						else
							l_score := l_score + (93)
						end
						if l_score < l_minscore then
							l_gi := l_gi + 1
							l_bi := l_bi + 1
							l_continue := True
						end
				when 30 then -- if done | if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 32 -- skip if block
						end
				when 31 then -- if: | pop:
						if l_stackidx = 0 then
							l_break := True
						end
				when 32 then -- if done
						if not (l_return or l_break or l_continue) then
							l_stackidx := l_stackidx - 1
							l_gi := l_stack[l_stackidx].goodi
							l_bi := l_stack[l_stackidx].badi
							l_score := l_stack[l_stackidx].score
						end
						if (not l_return and not l_break) then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 33 then -- loop done
					l_break := False
					l_continue := False
					if l_minscore > a_limit then
						Result := 999_999
						l_return := True
					end
					if not l_return then
						Result := l_minscore
					end
				when 34 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	similar_chars (a_slang: CE_POINTER [PD_SLANG_S]; a_c1, a_c2: INTEGER_32): INTEGER_32
		local
			l_m1: INTEGER_32
			l_m2: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<21>>)

			if a_c1 >= 256 then
				l_buf___6[((create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([a_c1, l_buf___6]))] := (0).to_natural_8
				l_hi___1 := (create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_map_hash"))).item.hash_find (l_buf___6)
				if (l_hi___1.item.hi_key).is_void then
					l_m1 := 0
				elseif (l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item) then
					l_m1 := 0
				else
					l_m1 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([(l_hi___1.item.hi_key + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_hi___1.item.hi_key))).to_integer_32) + 1])
				end
			else
				l_m1 := a_slang.item.sl_map_array[a_c1]
			end
			if l_m1 = 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				if a_c2 >= 256 then
					l_buf___6[((create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([a_c2, l_buf___6]))] := (0).to_natural_8
					l_hi___1 := (create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_slang.c_pointer + (create {PD_SLANG_S}.make).offset_of ("sl_map_hash"))).item.hash_find (l_buf___6)
					if (l_hi___1.item.hi_key).is_void then
						l_m2 := 0
					elseif (l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item) then
						l_m2 := 0
					else
						l_m2 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([(l_hi___1.item.hi_key + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_hi___1.item.hi_key))).to_integer_32) + 1])
					end
				else
					l_m2 := a_slang.item.sl_map_array[a_c2]
				end
				Result := (l_m1 = l_m2).to_integer
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			su_ga := a_other.su_ga.twin
			su_maxcount := a_other.su_maxcount
			su_maxscore := a_other.su_maxscore
			su_sfmaxscore := a_other.su_sfmaxscore
			su_sga := a_other.su_sga.twin
			su_badptr := a_other.su_badptr
			su_badlen := a_other.su_badlen
			su_badflags := a_other.su_badflags
			su_badword := a_other.su_badword.twin
			su_fbadword := a_other.su_fbadword.twin
			su_sal_badword := a_other.su_sal_badword.twin
			su_banned := a_other.su_banned.twin
			su_sallang := a_other.su_sallang
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				su_ga.is_equal (a_other.su_ga) and
				su_maxcount = a_other.su_maxcount and
				su_maxscore = a_other.su_maxscore and
				su_sfmaxscore = a_other.su_sfmaxscore and
				su_sga.is_equal (a_other.su_sga) and
				su_badptr.is_equal (a_other.su_badptr) and
				su_badlen = a_other.su_badlen and
				su_badflags = a_other.su_badflags and
				su_badword.is_equal (a_other.su_badword) and
				su_fbadword.is_equal (a_other.su_fbadword) and
				su_sal_badword.is_equal (a_other.su_sal_badword) and
				su_banned.is_equal (a_other.su_banned) and
				su_sallang.is_equal (a_other.su_sallang)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("su_ga"),
					create {CE_STRUCTURE_FIELD}.make ("su_maxcount"),
					create {CE_STRUCTURE_FIELD}.make ("su_maxscore"),
					create {CE_STRUCTURE_FIELD}.make ("su_sfmaxscore"),
					create {CE_STRUCTURE_FIELD}.make ("su_sga"),
					create {CE_STRUCTURE_FIELD}.make ("su_badptr"),
					create {CE_STRUCTURE_FIELD}.make ("su_badlen"),
					create {CE_STRUCTURE_FIELD}.make ("su_badflags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("su_badword", <<250>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("su_fbadword", <<250>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("su_sal_badword", <<250>>),
					create {CE_STRUCTURE_FIELD}.make ("su_banned"),
					create {CE_STRUCTURE_FIELD}.make ("su_sallang")
				>>)
			init_structure_info
		end

end
