class
	PD_WINDOW_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_CTYPE_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_WCTYPE_STATIC
		redefine
			copy,
			is_equal
		end
	S_TERMCAP_STATIC
		redefine
			copy,
			is_equal
		end
	S_GTK_GTK_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_FILE_BUFFER]} w_buffer.make
			create {CE_CLASS_POINTER [PD_SYNBLOCK_T]} w_s.make
			create {CE_CLASS_POINTER [PD_WINDOW_S]} w_prev.make
			create {CE_CLASS_POINTER [PD_WINDOW_S]} w_next.make
			create {CE_CLASS_POINTER [PD_FRAME_S]} w_frame.make
			create w_cursor.make
			create w_valid_cursor.make
			create {CE_CLASS_POINTER [PD_W_LINE]} w_lines.make
			create w_folds.make
			create w_ru_cursor.make
			create {CE_CLASS_POINTER [PD_ARGLIST]} w_alist.make
			create {CE_NATURAL_8_POINTER} w_localdir.make
			create w_onebuf_opt.make
			create w_allbuf_opt.make
			create {CE_INTEGER_32_POINTER} w_p_cc_cols.make
			create w_winvar.make
			create w_vars.make
			create w_pcmark.make
			create w_prev_pcmark.make
			create {CE_CLASS_ARRAY [PD_XFILEMARK]} w_jumplist.make (<<100>>)
			create {CE_CLASS_POINTER [PD_MATCHITEM]} w_match_head.make
			create {CE_CLASS_ARRAY [PD_TAGGY]} w_tagstack.make (<<20>>)
			create {CE_CLASS_ARRAY [PD_GUISCROLLBAR]} w_scrollbars.make (<<2>>)
			create {CE_CLASS_POINTER [PD_QF_INFO_S]} w_llist.make
			create {CE_CLASS_POINTER [PD_QF_INFO_S]} w_llist_ref.make
			Precursor
		end

feature {ANY} -- fields

	w_buffer: CE_POINTER [PD_FILE_BUFFER] assign set_w_buffer

	w_s: CE_POINTER [PD_SYNBLOCK_T] assign set_w_s

	w_prev: CE_POINTER [PD_WINDOW_S] assign set_w_prev

	w_next: CE_POINTER [PD_WINDOW_S] assign set_w_next

	w_frame: CE_POINTER [PD_FRAME_S] assign set_w_frame

	w_cursor: PD_POS_T assign set_w_cursor

	w_curswant: INTEGER_32 assign set_w_curswant

	w_set_curswant: INTEGER_32 assign set_w_set_curswant

	w_old_visual_mode: INTEGER_8 assign set_w_old_visual_mode

	w_old_cursor_lnum: INTEGER_32 assign set_w_old_cursor_lnum

	w_old_cursor_fcol: INTEGER_32 assign set_w_old_cursor_fcol

	w_old_cursor_lcol: INTEGER_32 assign set_w_old_cursor_lcol

	w_old_visual_lnum: INTEGER_32 assign set_w_old_visual_lnum

	w_old_visual_col: INTEGER_32 assign set_w_old_visual_col

	w_old_curswant: INTEGER_32 assign set_w_old_curswant

	w_topline: INTEGER_32 assign set_w_topline

	w_topline_was_set: INTEGER_8 assign set_w_topline_was_set

	w_topfill: INTEGER_32 assign set_w_topfill

	w_old_topfill: INTEGER_32 assign set_w_old_topfill

	w_botfill: INTEGER_32 assign set_w_botfill

	w_old_botfill: INTEGER_32 assign set_w_old_botfill

	w_leftcol: INTEGER_32 assign set_w_leftcol

	w_skipcol: INTEGER_32 assign set_w_skipcol

	w_winrow: INTEGER_32 assign set_w_winrow

	w_height: INTEGER_32 assign set_w_height

	w_status_height: INTEGER_32 assign set_w_status_height

	w_wincol: INTEGER_32 assign set_w_wincol

	w_width: INTEGER_32 assign set_w_width

	w_vsep_width: INTEGER_32 assign set_w_vsep_width

	w_valid: INTEGER_32 assign set_w_valid

	w_valid_cursor: PD_POS_T assign set_w_valid_cursor

	w_valid_leftcol: INTEGER_32 assign set_w_valid_leftcol

	w_cline_height: INTEGER_32 assign set_w_cline_height

	w_cline_folded: INTEGER_32 assign set_w_cline_folded

	w_cline_row: INTEGER_32 assign set_w_cline_row

	w_virtcol: INTEGER_32 assign set_w_virtcol

	w_wrow: INTEGER_32 assign set_w_wrow

	w_wcol: INTEGER_32 assign set_w_wcol

	w_botline: INTEGER_32 assign set_w_botline

	w_empty_rows: INTEGER_32 assign set_w_empty_rows

	w_filler_rows: INTEGER_32 assign set_w_filler_rows

	w_lines_valid: INTEGER_32 assign set_w_lines_valid

	w_lines: CE_POINTER [PD_W_LINE] assign set_w_lines

	w_folds: PD_GROWARRAY assign set_w_folds

	w_fold_manual: INTEGER_8 assign set_w_fold_manual

	w_foldinvalid: INTEGER_8 assign set_w_foldinvalid

	w_nrwidth: INTEGER_32 assign set_w_nrwidth

	w_redr_type: INTEGER_32 assign set_w_redr_type

	w_upd_rows: INTEGER_32 assign set_w_upd_rows

	w_redraw_top: INTEGER_32 assign set_w_redraw_top

	w_redraw_bot: INTEGER_32 assign set_w_redraw_bot

	w_redr_status: INTEGER_32 assign set_w_redr_status

	w_ru_cursor: PD_POS_T assign set_w_ru_cursor

	w_ru_virtcol: INTEGER_32 assign set_w_ru_virtcol

	w_ru_topline: INTEGER_32 assign set_w_ru_topline

	w_ru_line_count: INTEGER_32 assign set_w_ru_line_count

	w_ru_topfill: INTEGER_32 assign set_w_ru_topfill

	w_ru_empty: INTEGER_8 assign set_w_ru_empty

	w_alt_fnum: INTEGER_32 assign set_w_alt_fnum

	w_alist: CE_POINTER [PD_ARGLIST] assign set_w_alist

	w_arg_idx: INTEGER_32 assign set_w_arg_idx

	w_arg_idx_invalid: INTEGER_32 assign set_w_arg_idx_invalid

	w_localdir: CE_POINTER [NATURAL_8] assign set_w_localdir

	w_onebuf_opt: PD_WINOPT_T assign set_w_onebuf_opt

	w_allbuf_opt: PD_WINOPT_T assign set_w_allbuf_opt

	w_p_stl_flags: NATURAL_32 assign set_w_p_stl_flags

	w_p_fde_flags: NATURAL_32 assign set_w_p_fde_flags

	w_p_fdt_flags: NATURAL_32 assign set_w_p_fdt_flags

	w_p_cc_cols: CE_POINTER [INTEGER_32] assign set_w_p_cc_cols

	w_scbind_pos: INTEGER_32 assign set_w_scbind_pos

	w_winvar: PD_DICTITEM_S assign set_w_winvar

	w_vars: PD_DICTVAR_S assign set_w_vars

	w_pcmark: PD_POS_T assign set_w_pcmark

	w_prev_pcmark: PD_POS_T assign set_w_prev_pcmark

	w_jumplist: CE_ARRAY [PD_XFILEMARK]

	w_jumplistlen: INTEGER_32 assign set_w_jumplistlen

	w_jumplistidx: INTEGER_32 assign set_w_jumplistidx

	w_changelistidx: INTEGER_32 assign set_w_changelistidx

	w_match_head: CE_POINTER [PD_MATCHITEM] assign set_w_match_head

	w_next_match_id: INTEGER_32 assign set_w_next_match_id

	w_tagstack: CE_ARRAY [PD_TAGGY]

	w_tagstackidx: INTEGER_32 assign set_w_tagstackidx

	w_tagstacklen: INTEGER_32 assign set_w_tagstacklen

	w_fraction: INTEGER_32 assign set_w_fraction

	w_prev_fraction_row: INTEGER_32 assign set_w_prev_fraction_row

	w_scrollbars: CE_ARRAY [PD_GUISCROLLBAR]

	w_nrwidth_line_count: INTEGER_32 assign set_w_nrwidth_line_count

	w_nrwidth_width: INTEGER_32 assign set_w_nrwidth_width

	w_llist: CE_POINTER [PD_QF_INFO_S] assign set_w_llist

	w_llist_ref: CE_POINTER [PD_QF_INFO_S] assign set_w_llist_ref

feature {ANY} -- field setters

	set_w_buffer (a_w_buffer: CE_POINTER [PD_FILE_BUFFER])
		do
			w_buffer := a_w_buffer
			update_memory_field ("w_buffer")
		end

	set_w_s (a_w_s: CE_POINTER [PD_SYNBLOCK_T])
		do
			w_s := a_w_s
			update_memory_field ("w_s")
		end

	set_w_prev (a_w_prev: CE_POINTER [PD_WINDOW_S])
		do
			w_prev := a_w_prev
			update_memory_field ("w_prev")
		end

	set_w_next (a_w_next: CE_POINTER [PD_WINDOW_S])
		do
			w_next := a_w_next
			update_memory_field ("w_next")
		end

	set_w_frame (a_w_frame: CE_POINTER [PD_FRAME_S])
		do
			w_frame := a_w_frame
			update_memory_field ("w_frame")
		end

	set_w_cursor (a_w_cursor: PD_POS_T)
		do
			w_cursor := a_w_cursor
			update_memory_field ("w_cursor")
		end

	set_w_curswant (a_w_curswant: INTEGER_32)
		do
			w_curswant := a_w_curswant
			update_memory_field ("w_curswant")
		end

	set_w_set_curswant (a_w_set_curswant: INTEGER_32)
		do
			w_set_curswant := a_w_set_curswant
			update_memory_field ("w_set_curswant")
		end

	set_w_old_visual_mode (a_w_old_visual_mode: INTEGER_8)
		do
			w_old_visual_mode := a_w_old_visual_mode
			update_memory_field ("w_old_visual_mode")
		end

	set_w_old_cursor_lnum (a_w_old_cursor_lnum: INTEGER_32)
		do
			w_old_cursor_lnum := a_w_old_cursor_lnum
			update_memory_field ("w_old_cursor_lnum")
		end

	set_w_old_cursor_fcol (a_w_old_cursor_fcol: INTEGER_32)
		do
			w_old_cursor_fcol := a_w_old_cursor_fcol
			update_memory_field ("w_old_cursor_fcol")
		end

	set_w_old_cursor_lcol (a_w_old_cursor_lcol: INTEGER_32)
		do
			w_old_cursor_lcol := a_w_old_cursor_lcol
			update_memory_field ("w_old_cursor_lcol")
		end

	set_w_old_visual_lnum (a_w_old_visual_lnum: INTEGER_32)
		do
			w_old_visual_lnum := a_w_old_visual_lnum
			update_memory_field ("w_old_visual_lnum")
		end

	set_w_old_visual_col (a_w_old_visual_col: INTEGER_32)
		do
			w_old_visual_col := a_w_old_visual_col
			update_memory_field ("w_old_visual_col")
		end

	set_w_old_curswant (a_w_old_curswant: INTEGER_32)
		do
			w_old_curswant := a_w_old_curswant
			update_memory_field ("w_old_curswant")
		end

	set_w_topline (a_w_topline: INTEGER_32)
		do
			w_topline := a_w_topline
			update_memory_field ("w_topline")
		end

	set_w_topline_was_set (a_w_topline_was_set: INTEGER_8)
		do
			w_topline_was_set := a_w_topline_was_set
			update_memory_field ("w_topline_was_set")
		end

	set_w_topfill (a_w_topfill: INTEGER_32)
		do
			w_topfill := a_w_topfill
			update_memory_field ("w_topfill")
		end

	set_w_old_topfill (a_w_old_topfill: INTEGER_32)
		do
			w_old_topfill := a_w_old_topfill
			update_memory_field ("w_old_topfill")
		end

	set_w_botfill (a_w_botfill: INTEGER_32)
		do
			w_botfill := a_w_botfill
			update_memory_field ("w_botfill")
		end

	set_w_old_botfill (a_w_old_botfill: INTEGER_32)
		do
			w_old_botfill := a_w_old_botfill
			update_memory_field ("w_old_botfill")
		end

	set_w_leftcol (a_w_leftcol: INTEGER_32)
		do
			w_leftcol := a_w_leftcol
			update_memory_field ("w_leftcol")
		end

	set_w_skipcol (a_w_skipcol: INTEGER_32)
		do
			w_skipcol := a_w_skipcol
			update_memory_field ("w_skipcol")
		end

	set_w_winrow (a_w_winrow: INTEGER_32)
		do
			w_winrow := a_w_winrow
			update_memory_field ("w_winrow")
		end

	set_w_height (a_w_height: INTEGER_32)
		do
			w_height := a_w_height
			update_memory_field ("w_height")
		end

	set_w_status_height (a_w_status_height: INTEGER_32)
		do
			w_status_height := a_w_status_height
			update_memory_field ("w_status_height")
		end

	set_w_wincol (a_w_wincol: INTEGER_32)
		do
			w_wincol := a_w_wincol
			update_memory_field ("w_wincol")
		end

	set_w_width (a_w_width: INTEGER_32)
		do
			w_width := a_w_width
			update_memory_field ("w_width")
		end

	set_w_vsep_width (a_w_vsep_width: INTEGER_32)
		do
			w_vsep_width := a_w_vsep_width
			update_memory_field ("w_vsep_width")
		end

	set_w_valid (a_w_valid: INTEGER_32)
		do
			w_valid := a_w_valid
			update_memory_field ("w_valid")
		end

	set_w_valid_cursor (a_w_valid_cursor: PD_POS_T)
		do
			w_valid_cursor := a_w_valid_cursor
			update_memory_field ("w_valid_cursor")
		end

	set_w_valid_leftcol (a_w_valid_leftcol: INTEGER_32)
		do
			w_valid_leftcol := a_w_valid_leftcol
			update_memory_field ("w_valid_leftcol")
		end

	set_w_cline_height (a_w_cline_height: INTEGER_32)
		do
			w_cline_height := a_w_cline_height
			update_memory_field ("w_cline_height")
		end

	set_w_cline_folded (a_w_cline_folded: INTEGER_32)
		do
			w_cline_folded := a_w_cline_folded
			update_memory_field ("w_cline_folded")
		end

	set_w_cline_row (a_w_cline_row: INTEGER_32)
		do
			w_cline_row := a_w_cline_row
			update_memory_field ("w_cline_row")
		end

	set_w_virtcol (a_w_virtcol: INTEGER_32)
		do
			w_virtcol := a_w_virtcol
			update_memory_field ("w_virtcol")
		end

	set_w_wrow (a_w_wrow: INTEGER_32)
		do
			w_wrow := a_w_wrow
			update_memory_field ("w_wrow")
		end

	set_w_wcol (a_w_wcol: INTEGER_32)
		do
			w_wcol := a_w_wcol
			update_memory_field ("w_wcol")
		end

	set_w_botline (a_w_botline: INTEGER_32)
		do
			w_botline := a_w_botline
			update_memory_field ("w_botline")
		end

	set_w_empty_rows (a_w_empty_rows: INTEGER_32)
		do
			w_empty_rows := a_w_empty_rows
			update_memory_field ("w_empty_rows")
		end

	set_w_filler_rows (a_w_filler_rows: INTEGER_32)
		do
			w_filler_rows := a_w_filler_rows
			update_memory_field ("w_filler_rows")
		end

	set_w_lines_valid (a_w_lines_valid: INTEGER_32)
		do
			w_lines_valid := a_w_lines_valid
			update_memory_field ("w_lines_valid")
		end

	set_w_lines (a_w_lines: CE_POINTER [PD_W_LINE])
		do
			w_lines := a_w_lines
			update_memory_field ("w_lines")
		end

	set_w_folds (a_w_folds: PD_GROWARRAY)
		do
			w_folds := a_w_folds
			update_memory_field ("w_folds")
		end

	set_w_fold_manual (a_w_fold_manual: INTEGER_8)
		do
			w_fold_manual := a_w_fold_manual
			update_memory_field ("w_fold_manual")
		end

	set_w_foldinvalid (a_w_foldinvalid: INTEGER_8)
		do
			w_foldinvalid := a_w_foldinvalid
			update_memory_field ("w_foldinvalid")
		end

	set_w_nrwidth (a_w_nrwidth: INTEGER_32)
		do
			w_nrwidth := a_w_nrwidth
			update_memory_field ("w_nrwidth")
		end

	set_w_redr_type (a_w_redr_type: INTEGER_32)
		do
			w_redr_type := a_w_redr_type
			update_memory_field ("w_redr_type")
		end

	set_w_upd_rows (a_w_upd_rows: INTEGER_32)
		do
			w_upd_rows := a_w_upd_rows
			update_memory_field ("w_upd_rows")
		end

	set_w_redraw_top (a_w_redraw_top: INTEGER_32)
		do
			w_redraw_top := a_w_redraw_top
			update_memory_field ("w_redraw_top")
		end

	set_w_redraw_bot (a_w_redraw_bot: INTEGER_32)
		do
			w_redraw_bot := a_w_redraw_bot
			update_memory_field ("w_redraw_bot")
		end

	set_w_redr_status (a_w_redr_status: INTEGER_32)
		do
			w_redr_status := a_w_redr_status
			update_memory_field ("w_redr_status")
		end

	set_w_ru_cursor (a_w_ru_cursor: PD_POS_T)
		do
			w_ru_cursor := a_w_ru_cursor
			update_memory_field ("w_ru_cursor")
		end

	set_w_ru_virtcol (a_w_ru_virtcol: INTEGER_32)
		do
			w_ru_virtcol := a_w_ru_virtcol
			update_memory_field ("w_ru_virtcol")
		end

	set_w_ru_topline (a_w_ru_topline: INTEGER_32)
		do
			w_ru_topline := a_w_ru_topline
			update_memory_field ("w_ru_topline")
		end

	set_w_ru_line_count (a_w_ru_line_count: INTEGER_32)
		do
			w_ru_line_count := a_w_ru_line_count
			update_memory_field ("w_ru_line_count")
		end

	set_w_ru_topfill (a_w_ru_topfill: INTEGER_32)
		do
			w_ru_topfill := a_w_ru_topfill
			update_memory_field ("w_ru_topfill")
		end

	set_w_ru_empty (a_w_ru_empty: INTEGER_8)
		do
			w_ru_empty := a_w_ru_empty
			update_memory_field ("w_ru_empty")
		end

	set_w_alt_fnum (a_w_alt_fnum: INTEGER_32)
		do
			w_alt_fnum := a_w_alt_fnum
			update_memory_field ("w_alt_fnum")
		end

	set_w_alist (a_w_alist: CE_POINTER [PD_ARGLIST])
		do
			w_alist := a_w_alist
			update_memory_field ("w_alist")
		end

	set_w_arg_idx (a_w_arg_idx: INTEGER_32)
		do
			w_arg_idx := a_w_arg_idx
			update_memory_field ("w_arg_idx")
		end

	set_w_arg_idx_invalid (a_w_arg_idx_invalid: INTEGER_32)
		do
			w_arg_idx_invalid := a_w_arg_idx_invalid
			update_memory_field ("w_arg_idx_invalid")
		end

	set_w_localdir (a_w_localdir: CE_POINTER [NATURAL_8])
		do
			w_localdir := a_w_localdir
			update_memory_field ("w_localdir")
		end

	set_w_onebuf_opt (a_w_onebuf_opt: PD_WINOPT_T)
		do
			w_onebuf_opt := a_w_onebuf_opt
			update_memory_field ("w_onebuf_opt")
		end

	set_w_allbuf_opt (a_w_allbuf_opt: PD_WINOPT_T)
		do
			w_allbuf_opt := a_w_allbuf_opt
			update_memory_field ("w_allbuf_opt")
		end

	set_w_p_stl_flags (a_w_p_stl_flags: NATURAL_32)
		do
			w_p_stl_flags := a_w_p_stl_flags
			update_memory_field ("w_p_stl_flags")
		end

	set_w_p_fde_flags (a_w_p_fde_flags: NATURAL_32)
		do
			w_p_fde_flags := a_w_p_fde_flags
			update_memory_field ("w_p_fde_flags")
		end

	set_w_p_fdt_flags (a_w_p_fdt_flags: NATURAL_32)
		do
			w_p_fdt_flags := a_w_p_fdt_flags
			update_memory_field ("w_p_fdt_flags")
		end

	set_w_p_cc_cols (a_w_p_cc_cols: CE_POINTER [INTEGER_32])
		do
			w_p_cc_cols := a_w_p_cc_cols
			update_memory_field ("w_p_cc_cols")
		end

	set_w_scbind_pos (a_w_scbind_pos: INTEGER_32)
		do
			w_scbind_pos := a_w_scbind_pos
			update_memory_field ("w_scbind_pos")
		end

	set_w_winvar (a_w_winvar: PD_DICTITEM_S)
		do
			w_winvar := a_w_winvar
			update_memory_field ("w_winvar")
		end

	set_w_vars (a_w_vars: PD_DICTVAR_S)
		do
			w_vars := a_w_vars
			update_memory_field ("w_vars")
		end

	set_w_pcmark (a_w_pcmark: PD_POS_T)
		do
			w_pcmark := a_w_pcmark
			update_memory_field ("w_pcmark")
		end

	set_w_prev_pcmark (a_w_prev_pcmark: PD_POS_T)
		do
			w_prev_pcmark := a_w_prev_pcmark
			update_memory_field ("w_prev_pcmark")
		end

	set_w_jumplistlen (a_w_jumplistlen: INTEGER_32)
		do
			w_jumplistlen := a_w_jumplistlen
			update_memory_field ("w_jumplistlen")
		end

	set_w_jumplistidx (a_w_jumplistidx: INTEGER_32)
		do
			w_jumplistidx := a_w_jumplistidx
			update_memory_field ("w_jumplistidx")
		end

	set_w_changelistidx (a_w_changelistidx: INTEGER_32)
		do
			w_changelistidx := a_w_changelistidx
			update_memory_field ("w_changelistidx")
		end

	set_w_match_head (a_w_match_head: CE_POINTER [PD_MATCHITEM])
		do
			w_match_head := a_w_match_head
			update_memory_field ("w_match_head")
		end

	set_w_next_match_id (a_w_next_match_id: INTEGER_32)
		do
			w_next_match_id := a_w_next_match_id
			update_memory_field ("w_next_match_id")
		end

	set_w_tagstackidx (a_w_tagstackidx: INTEGER_32)
		do
			w_tagstackidx := a_w_tagstackidx
			update_memory_field ("w_tagstackidx")
		end

	set_w_tagstacklen (a_w_tagstacklen: INTEGER_32)
		do
			w_tagstacklen := a_w_tagstacklen
			update_memory_field ("w_tagstacklen")
		end

	set_w_fraction (a_w_fraction: INTEGER_32)
		do
			w_fraction := a_w_fraction
			update_memory_field ("w_fraction")
		end

	set_w_prev_fraction_row (a_w_prev_fraction_row: INTEGER_32)
		do
			w_prev_fraction_row := a_w_prev_fraction_row
			update_memory_field ("w_prev_fraction_row")
		end

	set_w_nrwidth_line_count (a_w_nrwidth_line_count: INTEGER_32)
		do
			w_nrwidth_line_count := a_w_nrwidth_line_count
			update_memory_field ("w_nrwidth_line_count")
		end

	set_w_nrwidth_width (a_w_nrwidth_width: INTEGER_32)
		do
			w_nrwidth_width := a_w_nrwidth_width
			update_memory_field ("w_nrwidth_width")
		end

	set_w_llist (a_w_llist: CE_POINTER [PD_QF_INFO_S])
		do
			w_llist := a_w_llist
			update_memory_field ("w_llist")
		end

	set_w_llist_ref (a_w_llist_ref: CE_POINTER [PD_QF_INFO_S])
		do
			w_llist_ref := a_w_llist_ref
			update_memory_field ("w_llist_ref")
		end

feature {PD_WINDOW_S} -- private attributes

	fold_changed: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	recursive___4: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	at_end_str: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
		end

	checked_lnum: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (0).to_integer_32
		end

	checked_col: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	cap_col: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					-1
				>>)
		end

	capcol_lnum: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (0).to_integer_32
		end

	changedtick___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	current_id: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	current_trans_id: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	current_state_stored: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	current_finished: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	current_line_id: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	current_attr: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	try_next_column: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	next_match_m_endpos: CE_STATIC [PD_LPOS_T]
		once ("PROCESS")
			Result.item := create {PD_LPOS_T}.make
		end

	next_match_h_startpos: CE_STATIC [PD_LPOS_T]
		once ("PROCESS")
			Result.item := create {PD_LPOS_T}.make
		end

	next_match_h_endpos: CE_STATIC [PD_LPOS_T]
		once ("PROCESS")
			Result.item := create {PD_LPOS_T}.make
		end

	next_match_flags: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	next_match_eos_pos: CE_STATIC [PD_LPOS_T]
		once ("PROCESS")
			Result.item := create {PD_LPOS_T}.make
		end

	next_match_eoe_pos: CE_STATIC [PD_LPOS_T]
		once ("PROCESS")
			Result.item := create {PD_LPOS_T}.make
		end

	next_match_end_idx: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	next_match_extmatch: CE_STATIC [CE_POINTER [PD_REG_EXTMATCH_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_REG_EXTMATCH_T]}.make_shared (default_pointer)
		end

	depth___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	buflist_altfpos
		do
			((create {P_GLOBALS_STATIC}).curbuf.item).item.buflist_setfpos ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), w_cursor.lnum, w_cursor.col, 1)
			update_class_fields -- Current might have been changed; synchronize
		end

	build_stl_str_hl (a_out: CE_POINTER [NATURAL_8]; a_outlen: NATURAL_32; a_fmt: CE_POINTER [NATURAL_8]; a_use_sandbox, a_fillchar, a_maxwidth: INTEGER_32; a_hltab, a_tabtab: CE_POINTER [PD_STL_HLREC]): INTEGER_32
		require
			not a_out.is_void
			not a_fmt.is_void
		local
			l_fillchar: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_t: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_linecont: CE_POINTER [NATURAL_8]
			l_o_curwin: CE_POINTER [PD_WINDOW_S]
			l_o_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_empty_line: INTEGER_32
			l_virtcol: CE_ARRAY [INTEGER_32]
			l_l: INTEGER_32
			l_n: INTEGER_32
			l_prevchar_isflag: INTEGER_32
			l_prevchar_isitem: INTEGER_32
			l_itemisflag: INTEGER_32
			l_fillable: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			l_num: INTEGER_32
			l_width: INTEGER_32
			l_itemcnt: INTEGER_32
			l_curitem: INTEGER_32
			l_groupitem: CE_ARRAY [INTEGER_32]
			l_groupdepth: INTEGER_32
			l_item: CE_ARRAY [PD_STL_ITEM]
			l_minwid: INTEGER_32
			l_maxwid: INTEGER_32
			l_zeropad: INTEGER_32
			l_base: NATURAL_8
			l_opt: NATURAL_8
			l_tmp: CE_ARRAY [NATURAL_8]
			l_usefmt: CE_POINTER [NATURAL_8]
			l_sp: CE_POINTER [PD_STL_HLREC]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___12: INTEGER_32
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: CE_POINTER [NATURAL_8]
			l_tmp___20: CE_POINTER [NATURAL_8]
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_tmp___22: CE_POINTER [INTEGER_8]
			l_tmp___23: CE_POINTER [NATURAL_8]
			l_tmp___24: CE_POINTER [NATURAL_8]
			l_tmp___25: INTEGER_32
			l_tmp___26: CE_POINTER [NATURAL_8]
			l_tmp___27: INTEGER_32
			l_tmp___28: INTEGER_32
			l_tmp___29: INTEGER_32
			l_tmp___30: INTEGER_32
			l_tmp___31: INTEGER_32
			l_tmp___32: NATURAL_32
			l_tmp___33: INTEGER_32
			l_tmp___34: CE_POINTER [INTEGER_8]
			l_tmp___35: CE_POINTER [INTEGER_8]
			l_tmp___36: CE_POINTER [INTEGER_8]
			l_tmp___37: NATURAL_32
			l_tmp___38: INTEGER_32
			l_tmp___39: NATURAL_32
			l_tmp___40: CE_POINTER [INTEGER_8]
			l_tmp___41: CE_POINTER [INTEGER_8]
			l_tmp___42: CE_POINTER [INTEGER_8]
			l_tmp___43: CE_POINTER [INTEGER_8]
			l_tmp___44: CE_POINTER [INTEGER_8]
			l_tmp___45: INTEGER_32
			l_tmp___46: INTEGER_32
			l_tmp___47: INTEGER_32
			l_tmp___48: INTEGER_32
			l_tmp___49: INTEGER_32
			l_tmp___50: INTEGER_32
			l_tmp___51: CE_POINTER [NATURAL_8]
			l_tmp___52: INTEGER_32
			l_tmp___53: CE_POINTER [NATURAL_8]
			l_tmp___54: CE_POINTER [NATURAL_8]
			l_tmp___55: CE_POINTER [NATURAL_8]
			l_tmp___56: CE_POINTER [NATURAL_8]
			l_tmp___57: CE_POINTER [NATURAL_8]
			l_tmp___58: CE_POINTER [NATURAL_8]
			l_nbase: INTEGER_32
			l_tmp___59: INTEGER_32
			l_tmp___60: INTEGER_32
			l_nstr: CE_ARRAY [NATURAL_8]
			l_tmp___61: CE_POINTER [NATURAL_8]
			l_tmp___62: CE_POINTER [NATURAL_8]
			l_tmp___63: CE_POINTER [NATURAL_8]
			l_tmp___64: CE_POINTER [NATURAL_8]
			l_tmp___65: CE_POINTER [NATURAL_8]
			l_tmp___66: INTEGER_32
			l_tmp___67: INTEGER_32
			l_tmp___68: CE_POINTER [NATURAL_8]
			l_tmp___69: CE_POINTER [NATURAL_8]
			l_tmp___70: NATURAL_32
			l_tmp___71: INTEGER_32
			l_tmp___72: INTEGER_32
			l_tmp___73: CE_POINTER [NATURAL_8]
			l_tmp___74: CE_POINTER [NATURAL_8]
			l_tmp___75: INTEGER_32
			l_tmp___76: INTEGER_32
			l_tmp___77: NATURAL_32
			l_tmp___78: NATURAL_32
			l_tmp___79: CE_POINTER [NATURAL_8]
			l_tmp___80: INTEGER_32
			l_tmp___81: NATURAL_32
			l_tmp___82: NATURAL_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_t.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_virtcol.make (<<1>>)
			create {CE_NATURAL_8_POINTER} l_str___1.make
			create {CE_INTEGER_32_ARRAY} l_groupitem.make (<<80>>)
			create {CE_CLASS_ARRAY [PD_STL_ITEM]} l_item.make (<<80>>)
			create {CE_NATURAL_8_ARRAY} l_tmp.make (<<70>>)
			create {CE_NATURAL_8_ARRAY} l_nstr.make (<<20>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fillchar := a_fillchar
					l_usefmt := a_fmt
					if (a_fmt[0]).to_integer_32 = 37 then
						if (a_fmt[1]).to_integer_32 = 33 then
							l_usefmt := (create {P_EVAL_STATIC}).eval_to_string_safe (a_fmt + 2, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), a_use_sandbox)
							update_class_fields -- Current might have been changed; synchronize
							if l_usefmt.is_void then
								l_usefmt := a_fmt
							end
						end
					end
					if l_fillchar = 0 then
						l_fillchar := (' ').code
					else
						l_tmp___0 := (create {P_GLOBALS_STATIC}).mb_char2len.item.integer_32_item ([l_fillchar])
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0 > 1 then
							l_fillchar := ('-').code
						end
					end
					l_linecont := w_buffer.item.ml_get_buf (w_cursor.lnum, 0)
					update_class_fields -- Current might have been changed; synchronize
					l_empty_line := ((l_linecont.item).to_integer_32 = 0).to_integer
					l_groupdepth := 0
					l_p___0 := a_out
					l_curitem := 0
					l_prevchar_isflag := 1
					l_prevchar_isitem := 0
					l_s.item := l_usefmt
					update_class_fields -- Current might have been changed; synchronize
				when 1 then -- loop condition:
					if not (not (l_return or l_break) and then ((l_s.item.item).to_boolean)) then
						l_pos := -1 + 60 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						if (l_s.item.item).to_integer_32 /= 0 then
							if (l_s.item.item).to_integer_32 /= 37 then
								l_prevchar_isitem := 0
								l_prevchar_isflag := l_prevchar_isitem
							end
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_s.item.item).to_integer_32 /= 0 then
								if (l_s.item.item).to_integer_32 /= 37 then
									if not (((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 < ((a_out + a_outlen.to_integer_32).c_pointer.to_integer_32).to_natural_32) then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_tmp___1 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___2 := l_s.item
								l_s.item := l_s.item + 1
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___1.item := l_tmp___2.item
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						if (l_s.item.item).to_integer_32 = 0 then
							l_break := True
						elseif ((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 >= ((a_out + a_outlen.to_integer_32).c_pointer.to_integer_32).to_natural_32 then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_s.item := l_s.item + 1
							update_class_fields -- Current might have been changed; synchronize
							if (l_s.item.item).to_integer_32 = 37 then
								if ((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 >= ((a_out + a_outlen.to_integer_32).c_pointer.to_integer_32).to_natural_32 then
									l_break := True
								end
								if not (l_return or l_break or l_continue) then
									l_tmp___3 := l_p___0
									l_p___0 := l_p___0 + 1
									l_tmp___4 := l_s.item
									l_s.item := l_s.item + 1
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___3.item := l_tmp___4.item
									update_class_fields -- Current might have been changed; synchronize
									l_prevchar_isitem := 0
									l_prevchar_isflag := l_prevchar_isitem
									l_continue := True
								end
							end
						end
						if not (l_return or l_break or l_continue) and then ((l_s.item.item).to_integer_32 = 61) then
							l_s.item := l_s.item + 1
							update_class_fields -- Current might have been changed; synchronize
							if l_groupdepth > 0 then
								l_continue := True
							end
							if not (l_return or l_break or l_continue) then
								l_item[l_curitem].type := {PC_TYPE}.Middle
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___5 := l_curitem
								l_curitem := l_curitem + 1
								l_item[l_tmp___5].start := l_p___0
								update_class_fields -- Current might have been changed; synchronize
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) and then ((l_s.item.item).to_integer_32 = 60) then
							l_s.item := l_s.item + 1
							update_class_fields -- Current might have been changed; synchronize
							l_item[l_curitem].type := {PC_TYPE}.Trunc
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___6 := l_curitem
							l_curitem := l_curitem + 1
							l_item[l_tmp___6].start := l_p___0
							update_class_fields -- Current might have been changed; synchronize
							l_continue := True
						end
						if not (l_return or l_break or l_continue) and then ((l_s.item.item).to_integer_32 = 41) then
							l_s.item := l_s.item + 1
							update_class_fields -- Current might have been changed; synchronize
							if l_groupdepth < 1 then
								l_continue := True
							end
							if not (l_return or l_break or l_continue) then
								l_groupdepth := l_groupdepth - 1
								l_t.item := l_item[(l_groupitem[l_groupdepth])].start
								update_class_fields -- Current might have been changed; synchronize
								l_p___0.item := (('%/0/').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___7 := (create {P_CHARSET_STATIC}).vim_strsize (l_t.item)
								update_class_fields -- Current might have been changed; synchronize
								l_l := l_tmp___7.to_integer_32
								if l_curitem > l_groupitem[l_groupdepth] + 1 then
									if l_item[(l_groupitem[l_groupdepth])].minwid = 0 then
										l_n := (l_groupitem[l_groupdepth] + 1).to_integer_32
										from
										until
											not (not (l_break) and then (l_n < l_curitem.to_integer_32))
										loop
											l_break := False
											if l_item[l_n].type = {NATURAL_32} 0 then
												l_break := True
											end
											if not (l_break) then
												l_n := l_n + 1
											end
										end
										l_break := False
										if l_n = l_curitem.to_integer_32 then
											l_p___0 := l_t.item
											l_l := 0
										end
									end
								end
								if l_l > (l_item[(l_groupitem[l_groupdepth])].maxwid).to_integer_32 then
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_n := 0
										from
										until
											not (l_l >= (l_item[(l_groupitem[l_groupdepth])].maxwid).to_integer_32)
										loop
											l_tmp___8 := (create {P_CHARSET_STATIC}).ptr2cells (l_t.item + l_n)
											update_class_fields -- Current might have been changed; synchronize
											l_l := l_l - l_tmp___8.to_integer_32
											l_tmp___9 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_t.item + l_n])
											update_class_fields -- Current might have been changed; synchronize
											l_n := l_n + l_tmp___9.to_integer_32
										end
									else
										l_n := ((l_p___0.distance ((l_t.item))).to_integer_32 - (l_item[(l_groupitem[l_groupdepth])].maxwid).to_integer_32) + 1
									end
									l_t.item.item := (('<').code).to_natural_8
									update_class_fields -- Current might have been changed; synchronize
									memmove (create {CE_VOID_POINTER}.make_cast ((l_t.item + 1)), create {CE_VOID_POINTER}.make_cast ((l_t.item + l_n)), (l_p___0.distance ((l_t.item + l_n))).to_natural_32).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									l_p___0 := (l_p___0 - l_n) + 1
									from
									until
										(l_break)
									loop
										l_break := False
										l_l := l_l + 1
										if not (l_l < (l_item[(l_groupitem[l_groupdepth])].minwid).to_integer_32) then
											l_break := True
										end
										if not (l_break) then
											l_tmp___10 := l_p___0
											l_p___0 := l_p___0 + 1
											l_tmp___10.item := l_fillchar.to_natural_8
											update_class_fields -- Current might have been changed; synchronize
										end
									end
									l_break := False
									l_l := (l_groupitem[l_groupdepth] + 1).to_integer_32
									from
									until
										not (l_l < l_curitem.to_integer_32)
									loop
										l_item[l_l].start := l_item[l_l].start - l_n
										update_class_fields -- Current might have been changed; synchronize
										if ((l_item[l_l].start).c_pointer.to_integer_32).to_natural_32 < ((l_t.item).c_pointer.to_integer_32).to_natural_32 then
											l_item[l_l].start := l_t.item
											update_class_fields -- Current might have been changed; synchronize
										end
										l_l := l_l + 1
									end
								else
									l_tmp___14 := abs (l_item[(l_groupitem[l_groupdepth])].minwid)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___14.to_integer_32 > l_l then
										l_n := (l_item[(l_groupitem[l_groupdepth])].minwid).to_integer_32
										if l_n < 0 then
											l_n := 0 - l_n
											from
											until
												(l_break)
											loop
												l_break := False
												l_tmp___12 := l_l
												l_l := l_l + 1
												if l_tmp___12 < l_n then
													if not (((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 < ((a_out + a_outlen.to_integer_32).c_pointer.to_integer_32).to_natural_32) then
														l_break := True
													end
												else
													l_break := True
												end
												if not (l_break) then
													l_tmp___11 := l_p___0
													l_p___0 := l_p___0 + 1
													l_tmp___11.item := l_fillchar.to_natural_8
													update_class_fields -- Current might have been changed; synchronize
												end
											end
											l_break := False
										else
											memmove (create {CE_VOID_POINTER}.make_cast (((l_t.item + l_n) - l_l)), create {CE_VOID_POINTER}.make_cast (l_t.item), (l_p___0.distance ((l_t.item))).to_natural_32).do_nothing
											update_class_fields -- Current might have been changed; synchronize
											l_l := l_n - l_l
											if ((l_p___0 + l_l).c_pointer.to_integer_32).to_natural_32 >= ((a_out + a_outlen.to_integer_32).c_pointer.to_integer_32).to_natural_32 then
												l_l := (((a_out + a_outlen.to_integer_32).distance (l_p___0)) - 1).to_integer_32
											end
											l_p___0 := l_p___0 + l_l
											l_n := (l_groupitem[l_groupdepth] + 1).to_integer_32
											from
											until
												not (l_n < l_curitem.to_integer_32)
											loop
												l_item[l_n].start := l_item[l_n].start + l_l
												update_class_fields -- Current might have been changed; synchronize
												l_n := l_n + 1
											end
											from
											until
												not (l_l > 0)
											loop
												l_tmp___13 := l_t.item
												l_t.item := l_t.item + 1
												update_class_fields -- Current might have been changed; synchronize
												l_tmp___13.item := l_fillchar.to_natural_8
												update_class_fields -- Current might have been changed; synchronize
												l_l := l_l - 1
											end
										end
									end
								end
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							l_minwid := 0
							l_maxwid := 9_999
							l_zeropad := 0
							l_l := 1
							if (l_s.item.item).to_integer_32 = 48 then
								l_s.item := l_s.item + 1
								update_class_fields -- Current might have been changed; synchronize
								l_zeropad := 1
							end
							if (l_s.item.item).to_integer_32 = 45 then
								l_s.item := l_s.item + 1
								update_class_fields -- Current might have been changed; synchronize
								l_l := -1
							end
							if (l_s.item.item).to_integer_32 >= 48 then
								if (l_s.item.item).to_integer_32 <= 57 then
									l_tmp___15 := (create {P_CHARSET_STATIC}).getdigits (l_s)
									update_class_fields -- Current might have been changed; synchronize
									l_minwid := l_tmp___15.to_integer_32
									if l_minwid < 0 then
										l_minwid := 0
									end
								end
							end
							if (l_s.item.item).to_integer_32 = 42 then
								l_item[l_curitem].type := {PC_TYPE}.Highlight
								update_class_fields -- Current might have been changed; synchronize
								l_item[l_curitem].start := l_p___0
								update_class_fields -- Current might have been changed; synchronize
								if l_minwid > 9 then
									l_item[l_curitem].minwid := 1
									update_class_fields -- Current might have been changed; synchronize
								else
									l_item[l_curitem].minwid := l_minwid
									update_class_fields -- Current might have been changed; synchronize
								end
								l_s.item := l_s.item + 1
								update_class_fields -- Current might have been changed; synchronize
								l_curitem := l_curitem + 1
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if (l_s.item.item).to_integer_32 /= 84 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if (l_s.item.item).to_integer_32 /= 88 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if (l_s.item.item).to_integer_32 = 88 then
							if l_minwid = 0 then
								l_n := (l_curitem - 1).to_integer_32
								from
								until
									not (not (l_break) and then (l_n >= 0))
								loop
									l_break := False
									if l_item[l_n].type = {NATURAL_32} 5 then
										if l_item[l_n].minwid >= 0 then
											l_minwid := l_item[l_n].minwid
											l_break := True
										end
									end
									if not (l_break) then
										l_n := l_n - 1
									end
								end
								l_break := False
							else
								l_minwid := -l_minwid
							end
						end
						l_item[l_curitem].type := {PC_TYPE}.TabPage
						update_class_fields -- Current might have been changed; synchronize
						l_item[l_curitem].start := l_p___0
						update_class_fields -- Current might have been changed; synchronize
						l_item[l_curitem].minwid := l_minwid
						update_class_fields -- Current might have been changed; synchronize
						l_s.item := l_s.item + 1
						update_class_fields -- Current might have been changed; synchronize
						l_curitem := l_curitem + 1
						l_continue := True
				when 8 then -- if done | if done
						if not (l_return or l_break or l_continue) then
							if (l_s.item.item).to_integer_32 = 46 then
								l_s.item := l_s.item + 1
								update_class_fields -- Current might have been changed; synchronize
								if (l_s.item.item).to_integer_32 >= 48 then
									if (l_s.item.item).to_integer_32 <= 57 then
										l_tmp___16 := (create {P_CHARSET_STATIC}).getdigits (l_s)
										update_class_fields -- Current might have been changed; synchronize
										l_maxwid := l_tmp___16.to_integer_32
										if l_maxwid <= 0 then
											l_maxwid := 50
										end
									end
								end
							end
							if l_minwid > 50 then
								l_tmp___17 := 50
							else
								l_tmp___17 := l_minwid
							end
							l_minwid := (l_tmp___17.to_integer_32 * l_l).to_integer_32
							if (l_s.item.item).to_integer_32 = 40 then
								l_tmp___18 := l_groupdepth
								l_groupdepth := l_groupdepth + 1
								l_groupitem[l_tmp___18] := l_curitem
								update_class_fields -- Current might have been changed; synchronize
								l_item[l_curitem].type := {PC_TYPE}.Group
								update_class_fields -- Current might have been changed; synchronize
								l_item[l_curitem].start := l_p___0
								update_class_fields -- Current might have been changed; synchronize
								l_item[l_curitem].minwid := l_minwid
								update_class_fields -- Current might have been changed; synchronize
								l_item[l_curitem].maxwid := l_maxwid
								update_class_fields -- Current might have been changed; synchronize
								l_s.item := l_s.item + 1
								update_class_fields -- Current might have been changed; synchronize
								l_curitem := l_curitem + 1
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							l_tmp___19 := (create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("fFtcvVlLknoObBrRhHmYyWwMqpPaN{#")), (l_s.item.item).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___19.is_void then
								l_s.item := l_s.item + 1
								update_class_fields -- Current might have been changed; synchronize
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 43 -- skip if block
						end
				when 9 then -- if:
						l_tmp___20 := l_s.item
						l_s.item := l_s.item + 1
						update_class_fields -- Current might have been changed; synchronize
						l_opt := l_tmp___20.item
						l_base := (('D').code).to_natural_8
						l_itemisflag := 0
						l_fillable := 1
						l_num := -1
						l_str___1 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						inspect l_opt.to_integer_32 -- switch 1 head
						when 102 then l_pos := -1 + 10
						when 70 then l_pos := -1 + 10
						when 116 then l_pos := -1 + 10
						when 123 then l_pos := -1 + 11
						when 108 then l_pos := -1 + 13
						when 76 then l_pos := -1 + 14
						when 99 then l_pos := -1 + 15
						when 118 then l_pos := -1 + 16
						when 86 then l_pos := -1 + 16
						when 112 then l_pos := -1 + 18
						when 80 then l_pos := -1 + 19
						when 97 then l_pos := -1 + 20
						when 107 then l_pos := -1 + 21
						when 78 then l_pos := -1 + 22
						when 110 then l_pos := -1 + 23
						when 79 then l_pos := -1 + 24
						when 111 then l_pos := -1 + 25
						when 66 then l_pos := -1 + 26
						when 98 then l_pos := -1 + 27
						when 114 then l_pos := -1 + 28
						when 82 then l_pos := -1 + 28
						when 104 then l_pos := -1 + 29
						when 72 then l_pos := -1 + 29
						when 121 then l_pos := -1 + 30
						when 89 then l_pos := -1 + 31
						when 119 then l_pos := -1 + 32
						when 87 then l_pos := -1 + 32
						when 113 then l_pos := -1 + 33
						when 109 then l_pos := -1 + 34
						when 77 then l_pos := -1 + 34
						when 35 then l_pos := -1 + 42
						else l_pos := -1 + 43
						end
				when 10 then -- switch 1, case 102 | switch 1, case 70 | switch 1, case 116
						l_fillable := 0
						l_tmp___22 := w_buffer.item.buf_spname
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___22.is_void then
							l_tmp___21 := w_buffer.item.buf_spname
							update_class_fields -- Current might have been changed; synchronize
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item), l_tmp___21).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						else
							if l_opt.to_integer_32 = 70 then
								l_t.item := w_buffer.item.b_ffname
								update_class_fields -- Current might have been changed; synchronize
							else
								l_t.item := w_buffer.item.b_fname
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_MISC1_STATIC}).home_replace (w_buffer, l_t.item, (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096, 1)
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_CHARSET_STATIC}).trans_characters ((create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096)
						update_class_fields -- Current might have been changed; synchronize
						if l_opt.to_integer_32 /= 116 then
							l_str___1 := (create {P_GLOBALS_STATIC}).NameBuff.item.item
						else
							l_str___1 := (create {P_MISC1_STATIC}).gettail ((create {P_GLOBALS_STATIC}).NameBuff.item.item)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 43 -- switch 1; break
				when 11 then -- switch 1, case 123
						l_itemisflag := 1
						l_t.item := l_p___0
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_s.item.item).to_integer_32 /= 125 then
								if (l_s.item.item).to_integer_32 /= 0 then
									if not (((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 < ((a_out + a_outlen.to_integer_32).c_pointer.to_integer_32).to_natural_32) then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_tmp___23 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___24 := l_s.item
								l_s.item := l_s.item + 1
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___23.item := l_tmp___24.item
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						if (l_s.item.item).to_integer_32 /= 125 then
							l_pos := -1 + 43 -- switch 1; break
						end
				when 12 then
						l_s.item := l_s.item + 1
						update_class_fields -- Current might have been changed; synchronize
						l_p___0.item := (0).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_p___0 := l_t.item;
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_tmp), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (70).to_natural_32), ce_string ("%%d"), (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum]).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_EVAL_STATIC}).set_internal_string_var (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("actual_curbuf")), l_tmp)
						update_class_fields -- Current might have been changed; synchronize
						l_o_curbuf := (create {P_GLOBALS_STATIC}).curbuf.item
						l_o_curwin := (create {P_GLOBALS_STATIC}).curwin.item;
						(create {P_GLOBALS_STATIC}).curwin.item := (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).curbuf.item := w_buffer
						update_class_fields -- Current might have been changed; synchronize
						l_str___1 := (create {P_EVAL_STATIC}).eval_to_string_safe (l_p___0, l_t, a_use_sandbox)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).curwin.item := l_o_curwin
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).curbuf.item := l_o_curbuf
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_EVAL_STATIC}).do_unlet (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("g:actual_curbuf")), 1).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if not l_str___1.is_void then
							if (l_str___1.item).to_integer_32 /= 0 then
								l_tmp___26 := (create {P_CHARSET_STATIC}).skipdigits (l_str___1)
								update_class_fields -- Current might have been changed; synchronize
								if (l_tmp___26.item).to_integer_32 = 0 then
									l_tmp___25 := atoi (create {CE_INTEGER_8_POINTER}.make_cast (l_str___1))
									update_class_fields -- Current might have been changed; synchronize
									l_num := l_tmp___25.to_integer_32;
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_str___1))
									update_class_fields -- Current might have been changed; synchronize
									l_str___1 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
									l_itemisflag := 0
								end
							end
						end
						l_pos := -1 + 43 -- switch 1; break
				when 13 then -- switch 1, case 108
						if ((w_buffer.item.b_ml.ml_flags).bit_and (1)).to_boolean then
							l_num := 0
						else
							l_num := w_cursor.lnum
						end
						l_pos := -1 + 43 -- switch 1; break
				when 14 then -- switch 1, case 76
						l_num := w_buffer.item.b_ml.ml_line_count
						l_pos := -1 + 43 -- switch 1; break
				when 15 then -- switch 1, case 99
						if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
							if l_empty_line.to_boolean then
								l_num := 0
							else
								l_num := (w_cursor.col + 1).to_integer_32
							end
						else
							l_num := (w_cursor.col + 1).to_integer_32
						end
						l_pos := -1 + 43 -- switch 1; break
				when 16 then -- switch 1, case 118 | switch 1, case 86
						l_virtcol.item := w_virtcol
						update_class_fields -- Current might have been changed; synchronize
						if (w_onebuf_opt.wo_list).to_boolean then
							if (create {P_GLOBALS_STATIC}).lcs_tab1.item = 0 then
								w_onebuf_opt.wo_list := 0
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_virtcol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
								w_onebuf_opt.wo_list := 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_virtcol.item := l_virtcol.item + 1
						update_class_fields -- Current might have been changed; synchronize
						if l_opt.to_integer_32 = 86 then
							if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
								if l_empty_line.to_boolean then
									l_tmp___27 := 0
								else
									l_tmp___27 := w_cursor.col + 1
								end
							else
								l_tmp___27 := w_cursor.col + 1
							end
							if l_virtcol.item = l_tmp___27 then
								l_pos := -1 + 43 -- switch 1; break
							end
						end
				when 17 then
						l_num := (l_virtcol.item).to_integer_32
						l_pos := -1 + 43 -- switch 1; break
				when 18 then -- switch 1, case 112
						l_num := (((w_cursor.lnum * 100) // w_buffer.item.b_ml.ml_line_count).to_integer_32).to_integer_32
						l_pos := -1 + 43 -- switch 1; break
				when 19 then -- switch 1, case 80
						l_str___1 := l_tmp;
						((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.get_rel_pos (l_str___1, 70)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 43 -- switch 1; break
				when 20 then -- switch 1, case 97
						l_fillable := 0
						l_tmp[0] := (0).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___28 := (create {P_BUFFER_STATIC}).append_arg_number ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), l_tmp, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (70).to_natural_32).to_integer_32, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___28.to_boolean then
							l_str___1 := l_tmp
						end
						l_pos := -1 + 43 -- switch 1; break
				when 21 then -- switch 1, case 107
						l_fillable := 0
						l_tmp___29 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.get_keymap_str (l_tmp, 70)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___29.to_boolean then
							l_str___1 := l_tmp
						end
						l_pos := -1 + 43 -- switch 1; break
				when 22 then -- switch 1, case 78
						l_num := (create {P_GLOBALS_STATIC}).printer_page_num.item
						l_pos := -1 + 43 -- switch 1; break
				when 23 then -- switch 1, case 110
						l_num := (w_buffer.item.b_fnum).to_integer_32
						l_pos := -1 + 43 -- switch 1; break
				when 24 then -- switch 1, case 79
						l_base := (('X').code).to_natural_8
				when 25 then -- switch 1, case 111
						l_l := w_buffer.item.ml_find_line_or_offset (w_cursor.lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if ((w_buffer.item.b_ml.ml_flags).bit_and (1)).to_boolean then
							l_num := 0
						elseif l_l < 0 then
							l_num := 0
						else
							if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
								if l_empty_line.to_boolean then
									l_tmp___30 := 0
								else
									l_tmp___30 := w_cursor.col
								end
							else
								l_tmp___30 := w_cursor.col
							end
							l_num := (l_l + 1) + l_tmp___30.to_integer_32
						end
						l_pos := -1 + 43 -- switch 1; break
				when 26 then -- switch 1, case 66
						l_base := (('X').code).to_natural_8
				when 27 then -- switch 1, case 98
						l_tmp___32 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_linecont))
						update_class_fields -- Current might have been changed; synchronize
						if w_cursor.col > l_tmp___32.to_integer_32 then
							l_num := 0
						else
							l_tmp___31 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_linecont + w_cursor.col])
							update_class_fields -- Current might have been changed; synchronize
							l_num := l_tmp___31.to_integer_32
						end
						if l_num = 10 then
							l_num := 0
						elseif l_num = 13 then
							l_tmp___33 := w_buffer.item.get_fileformat
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___33 = 2 then
								l_num := (('%N').code).to_integer_32
							end
						end
						l_pos := -1 + 43 -- switch 1; break
				when 28 then -- switch 1, case 114 | switch 1, case 82
						l_itemisflag := 1
						if (w_buffer.item.b_p_ro).to_boolean then
							if l_opt.to_integer_32 = 82 then
								l_tmp___34 := ce_string (",RO")
							else
								l_tmp___34 := ce_string ("[RO]")
							end
							l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___34)
						end
						l_pos := -1 + 43 -- switch 1; break
				when 29 then -- switch 1, case 104 | switch 1, case 72
						l_itemisflag := 1
						if (w_buffer.item.b_help).to_boolean then
							if l_opt.to_integer_32 = 72 then
								l_tmp___36 := ce_string (",HLP")
							else
								l_tmp___35 := gettext (ce_string ("[Help]"))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___36 := l_tmp___35
							end
							l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___36)
						end
						l_pos := -1 + 43 -- switch 1; break
				when 30 then -- switch 1, case 121
						if ((w_buffer.item.b_p_ft).item).to_integer_32 /= 0 then
							l_tmp___37 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (w_buffer.item.b_p_ft))
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___37 < {NATURAL_32} 67 then
								(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_tmp), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (70).to_natural_32), ce_string ("[%%s]"), w_buffer.item.b_p_ft]).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_str___1 := l_tmp
							end
						end
						l_pos := -1 + 43 -- switch 1; break
				when 31 then -- switch 1, case 89
						l_itemisflag := 1
						if ((w_buffer.item.b_p_ft).item).to_integer_32 /= 0 then
							l_tmp___39 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (w_buffer.item.b_p_ft))
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___39 < {NATURAL_32} 68 then
								(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_tmp), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (70).to_natural_32), ce_string (",%%s"), w_buffer.item.b_p_ft]).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_t.item := l_tmp
								update_class_fields -- Current might have been changed; synchronize
								from
								until
									(l_t.item.item).to_integer_32 = 0
								loop
									l_tmp___38 := toupper ((l_t.item.item).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									l_t.item.item := l_tmp___38.to_natural_8
									update_class_fields -- Current might have been changed; synchronize
									l_t.item := l_t.item + 1
									update_class_fields -- Current might have been changed; synchronize
								end
								l_str___1 := l_tmp
							end
						end
						l_pos := -1 + 43 -- switch 1; break
				when 32 then -- switch 1, case 119 | switch 1, case 87
						l_itemisflag := 1
						if (w_onebuf_opt.wo_pvw).to_boolean then
							if l_opt.to_integer_32 = 87 then
								l_tmp___41 := ce_string (",PRV")
							else
								l_tmp___40 := gettext (ce_string ("[Preview]"))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___41 := l_tmp___40
							end
							l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___41)
						end
						l_pos := -1 + 43 -- switch 1; break
				when 33 then -- switch 1, case 113
						l_tmp___45 := w_buffer.item.bt_quickfix
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___45.to_boolean then
							if (not w_llist_ref.is_void) then
								l_tmp___42 := gettext ((create {P_BUFFER_STATIC}).msg_loclist.item)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___44 := l_tmp___42
							else
								l_tmp___43 := gettext ((create {P_BUFFER_STATIC}).msg_qflist.item)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___44 := l_tmp___43
							end
							l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___44)
						end
						l_pos := -1 + 43 -- switch 1; break
				when 34 then -- switch 1, case 109 | switch 1, case 77
						l_itemisflag := 1
						l_tmp___46 := w_buffer.item.bufIsChanged
						update_class_fields -- Current might have been changed; synchronize
						inspect ((l_opt.to_integer_32 = 77).to_integer + l_tmp___46 * 2) + (not (w_buffer.item.b_p_ma).to_boolean).to_integer * 4 -- switch 2 head
						when 2 then l_pos := -1 + 35
						when 3 then l_pos := -1 + 36
						when 4 then l_pos := -1 + 37
						when 5 then l_pos := -1 + 38
						when 6 then l_pos := -1 + 39
						when 7 then l_pos := -1 + 40
						else l_pos := -1 + 41
						end
				when 35 then -- switch 2, case 2
						l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("[+]"))
						l_pos := -1 + 41 -- switch 2; break
				when 36 then -- switch 2, case 3
						l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (",+"))
						l_pos := -1 + 41 -- switch 2; break
				when 37 then -- switch 2, case 4
						l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("[-]"))
						l_pos := -1 + 41 -- switch 2; break
				when 38 then -- switch 2, case 5
						l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (",-"))
						l_pos := -1 + 41 -- switch 2; break
				when 39 then -- switch 2, case 6
						l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("[+-]"))
						l_pos := -1 + 41 -- switch 2; break
				when 40 then -- switch 2, case 7
						l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (",+-"))
						l_pos := -1 + 41 -- switch 2; break
				when 41 then -- switch 2, done:
						l_pos := -1 + 43 -- switch 1; break
				when 42 then -- switch 1, case 35
						l_t.item := l_s.item
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_s.item.item).to_integer_32 /= 35 then
								if (l_s.item.item).to_integer_32 = 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_s.item := l_s.item + 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						if (l_s.item.item).to_integer_32 = 35 then
							l_item[l_curitem].type := {PC_TYPE}.Highlight
							update_class_fields -- Current might have been changed; synchronize
							l_item[l_curitem].start := l_p___0
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___47 := (create {P_SYNTAX_STATIC}).syn_namen2id (l_t.item, (l_s.item).distance ((l_t.item)))
							update_class_fields -- Current might have been changed; synchronize
							l_item[l_curitem].minwid := -l_tmp___47
							update_class_fields -- Current might have been changed; synchronize
							l_curitem := l_curitem + 1
						end
						l_s.item := l_s.item + 1
						update_class_fields -- Current might have been changed; synchronize
						l_continue := True
				when 43 then -- switch 1, done: | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 59 -- skip if block
						end
				when 44 then -- if:
						l_item[l_curitem].start := l_p___0
						update_class_fields -- Current might have been changed; synchronize
						l_item[l_curitem].type := {PC_TYPE}.Normal
						update_class_fields -- Current might have been changed; synchronize
						if l_str___1.is_void then
							l_pos := -1 + 58 -- skip if block
						end
				when 45 then -- if:
						if not ((l_str___1.item).to_boolean) then
							l_pos := -1 + 56 -- skip if block
						end
				when 46 then -- if:
						l_t.item := l_str___1
						update_class_fields -- Current might have been changed; synchronize
						if not (l_itemisflag.to_boolean) then
							l_pos := -1 + 54 -- skip if block
						end
				when 47 then -- if:
						if not ((l_t.item[0]).to_boolean) then
							l_pos := -1 + 53 -- skip if block
						end
				when 48 then -- if:
						if not ((l_t.item[1]).to_boolean) then
							l_pos := -1 + 53 -- skip if block
						end
				when 49 then -- if:
						if l_prevchar_isitem.to_boolean then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:
						if (l_t.item.item).to_integer_32 = 44 then
							l_t.item := l_t.item + 1
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 52 -- goto _L___0
						end
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 52 then -- else: | _L___0:
						if l_prevchar_isflag.to_boolean then
							if (l_t.item.item).to_integer_32 = 32 then
								l_t.item := l_t.item + 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 53 then -- if done | if done
						l_prevchar_isflag := 1
				when 54 then -- if done
						l_tmp___48 := (create {P_CHARSET_STATIC}).vim_strsize (l_t.item)
						update_class_fields -- Current might have been changed; synchronize
						l_l := l_tmp___48.to_integer_32
						if l_l > 0 then
							l_prevchar_isitem := 1
						end
						if l_l > l_maxwid.to_integer_32 then
							from
							until
								not (l_l >= l_maxwid.to_integer_32)
							loop
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___49 := (create {P_CHARSET_STATIC}).ptr2cells (l_t.item)
									update_class_fields -- Current might have been changed; synchronize
									l_l := l_l - l_tmp___49.to_integer_32
									l_tmp___50 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_t.item])
									update_class_fields -- Current might have been changed; synchronize
									l_t.item := l_t.item + l_tmp___50
									update_class_fields -- Current might have been changed; synchronize
								else
									l_tmp___51 := l_t.item
									l_t.item := l_t.item + 1
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___52 := (create {P_CHARSET_STATIC}).byte2cells ((l_tmp___51.item).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									l_l := l_l - l_tmp___52.to_integer_32
								end
							end
							if ((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 >= ((a_out + a_outlen.to_integer_32).c_pointer.to_integer_32).to_natural_32 then
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_tmp___53 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___53.item := (('<').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if not (l_return or l_break or l_continue) then
							if l_minwid > 0 then
								from
								until
									(l_break)
								loop
									l_break := False
									if l_l < l_minwid.to_integer_32 then
										if not (((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 < ((a_out + a_outlen.to_integer_32).c_pointer.to_integer_32).to_natural_32) then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										if l_l + 1 = l_minwid.to_integer_32 then
											if l_fillchar = 45 then
												if (l_t.item.item).to_integer_32 >= 48 then
													if (l_t.item.item).to_integer_32 <= 57 then
														l_tmp___54 := l_p___0
														l_p___0 := l_p___0 + 1
														l_tmp___54.item := ((' ').code).to_natural_8
														update_class_fields -- Current might have been changed; synchronize
													else
														l_tmp___55 := l_p___0
														l_p___0 := l_p___0 + 1
														l_tmp___55.item := l_fillchar.to_natural_8
														update_class_fields -- Current might have been changed; synchronize
													end
												else
													l_tmp___55 := l_p___0
													l_p___0 := l_p___0 + 1
													l_tmp___55.item := l_fillchar.to_natural_8
													update_class_fields -- Current might have been changed; synchronize
												end
											else
												l_tmp___55 := l_p___0
												l_p___0 := l_p___0 + 1
												l_tmp___55.item := l_fillchar.to_natural_8
												update_class_fields -- Current might have been changed; synchronize
											end
										else
											l_tmp___55 := l_p___0
											l_p___0 := l_p___0 + 1
											l_tmp___55.item := l_fillchar.to_natural_8
											update_class_fields -- Current might have been changed; synchronize
										end
										l_l := l_l + 1
									end
								end
								l_break := False
								l_minwid := 0
							else
								l_minwid := l_minwid * (-1)
							end
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_t.item.item).to_boolean then
									if not (((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 < ((a_out + a_outlen.to_integer_32).c_pointer.to_integer_32).to_natural_32) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_tmp___56 := l_p___0
									l_p___0 := l_p___0 + 1
									l_tmp___57 := l_t.item
									l_t.item := l_t.item + 1
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___56.item := l_tmp___57.item
									update_class_fields -- Current might have been changed; synchronize
									if l_fillable.to_boolean then
										if (l_p___0[-1]).to_integer_32 = 32 then
											if (l_t.item.item).to_integer_32 >= 48 then
												if (l_t.item.item).to_integer_32 <= 57 then
													if l_fillchar /= 45 then
														l_p___0[-1] := l_fillchar.to_natural_8
														update_class_fields -- Current might have been changed; synchronize
													end
												else
													l_p___0[-1] := l_fillchar.to_natural_8
													update_class_fields -- Current might have been changed; synchronize
												end
											else
												l_p___0[-1] := l_fillchar.to_natural_8
												update_class_fields -- Current might have been changed; synchronize
											end
										end
									end
								end
							end
							l_break := False
							from
							until
								(l_break)
							loop
								l_break := False
								if l_l < l_minwid.to_integer_32 then
									if not (((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 < ((a_out + a_outlen.to_integer_32).c_pointer.to_integer_32).to_natural_32) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_tmp___58 := l_p___0
									l_p___0 := l_p___0 + 1
									l_tmp___58.item := l_fillchar.to_natural_8
									update_class_fields -- Current might have been changed; synchronize
									l_l := l_l + 1
								end
							end
							l_break := False
						end
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 56 then -- else:
						l_pos := -1 + 58 -- goto _L___1
				when 57 then -- if done | if block done, skip else block:
						l_pos := -1 + 59
				when 58 then -- else: | _L___1:
						if l_num >= 0 then
							if l_base.to_integer_32 = 68 then
								l_tmp___60 := 10
							else
								if l_base.to_integer_32 = 79 then
									l_tmp___59 := 8
								else
									l_tmp___59 := 16
								end
								l_tmp___60 := l_tmp___59
							end
							l_nbase := l_tmp___60
							if ((l_p___0 + 20).c_pointer.to_integer_32).to_natural_32 >= ((a_out + a_outlen.to_integer_32).c_pointer.to_integer_32).to_natural_32 then
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_prevchar_isitem := 1
								l_t.item := l_nstr
								update_class_fields -- Current might have been changed; synchronize
								if l_opt.to_integer_32 = 86 then
									l_tmp___61 := l_t.item
									l_t.item := l_t.item + 1
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___61.item := (('-').code).to_natural_8
									update_class_fields -- Current might have been changed; synchronize
									l_minwid := l_minwid - 1
								end
								l_tmp___62 := l_t.item
								l_t.item := l_t.item + 1
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___62.item := (('%%').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								if l_zeropad.to_boolean then
									l_tmp___63 := l_t.item
									l_t.item := l_t.item + 1
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___63.item := (('0').code).to_natural_8
									update_class_fields -- Current might have been changed; synchronize
								end
								l_tmp___64 := l_t.item
								l_t.item := l_t.item + 1
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___64.item := (('*').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___65 := l_t.item
								l_t.item := l_t.item + 1
								update_class_fields -- Current might have been changed; synchronize
								if l_nbase = 16 then
									l_tmp___65.item := l_base
									update_class_fields -- Current might have been changed; synchronize
								else
									if l_nbase = 8 then
										l_tmp___66 := ('o').code
									else
										l_tmp___66 := ('d').code
									end
									l_tmp___65.item := l_tmp___66.to_natural_8
									update_class_fields -- Current might have been changed; synchronize
								end
								l_t.item.item := (0).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_n := l_num
								l_l := 1
								from
								until
									not (l_n >= l_nbase.to_integer_32)
								loop
									l_l := l_l + 1
									l_n := l_n // l_nbase.to_integer_32
								end
								if l_opt.to_integer_32 = 86 then
									l_l := l_l + 1
								end
								if l_l > l_maxwid.to_integer_32 then
									l_l := l_l + (2)
									l_n := l_l - l_maxwid.to_integer_32
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp___67 := l_l
										l_l := l_l - 1
										if not (l_tmp___67 > l_maxwid.to_integer_32) then
											l_break := True
										end
										if not (l_break) then
											l_num := l_num // l_nbase.to_integer_32
										end
									end
									l_break := False
									l_tmp___68 := l_t.item
									l_t.item := l_t.item + 1
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___68.item := (('>').code).to_natural_8
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___69 := l_t.item
									l_t.item := l_t.item + 1
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___69.item := (('%%').code).to_natural_8
									update_class_fields -- Current might have been changed; synchronize
									l_t.item.item := l_t.item[-3]
									update_class_fields -- Current might have been changed; synchronize
									l_t.item := l_t.item + 1
									update_class_fields -- Current might have been changed; synchronize
									l_t.item.item := (0).to_natural_8
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), a_outlen - (l_p___0.distance (a_out)).to_natural_32, create {CE_INTEGER_8_POINTER}.make_cast (l_nstr), 0, l_num, l_n]).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), a_outlen - (l_p___0.distance (a_out)).to_natural_32, create {CE_INTEGER_8_POINTER}.make_cast (l_nstr), l_minwid, l_num]).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
								l_tmp___70 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))
								update_class_fields -- Current might have been changed; synchronize
								l_p___0 := l_p___0 + l_tmp___70.to_integer_32
							end
						else
							l_item[l_curitem].type := {PC_TYPE}.Empty
							update_class_fields -- Current might have been changed; synchronize
						end
				when 59 then -- if done
						if not (l_return or l_break or l_continue) then
							if l_opt.to_integer_32 = 123 then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_str___1))
								update_class_fields -- Current might have been changed; synchronize
							end
							if l_num >= 0 then
								l_prevchar_isflag := 0
							elseif not l_itemisflag.to_boolean then
								if (not l_str___1.is_void) then
									if (l_str___1.item).to_boolean then
										l_prevchar_isflag := 0
									end
								end
							end
							l_curitem := l_curitem + 1
						end
						if (not l_return and not l_break) then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 60 then -- loop done
					l_break := False
					l_continue := False
					l_p___0.item := (('%/0/').code).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					l_itemcnt := l_curitem
					if not l_usefmt.is_equal (a_fmt) then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_usefmt))
						update_class_fields -- Current might have been changed; synchronize
					end
					l_width := (create {P_CHARSET_STATIC}).vim_strsize (a_out)
					update_class_fields -- Current might have been changed; synchronize
					if not (a_maxwidth > 0) then
						l_pos := -1 + 63 -- skip if block
					end
				when 61 then -- if:
						if l_width > a_maxwidth then
							l_l := 0
							if l_itemcnt = 0 then
								l_s.item := a_out
								update_class_fields -- Current might have been changed; synchronize
							else
								from
								until
									not (not (l_break) and then (l_l < l_itemcnt.to_integer_32))
								loop
									l_break := False
									if l_item[l_l].type = {NATURAL_32} 6 then
										l_s.item := l_item[l_l].start
										update_class_fields -- Current might have been changed; synchronize
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										l_l := l_l + 1
									end
								end
								l_break := False
								if l_l = l_itemcnt.to_integer_32 then
									l_s.item := l_item[0].start
									update_class_fields -- Current might have been changed; synchronize
									l_l := 0
								end
							end
							l_tmp___80 := (create {P_CHARSET_STATIC}).vim_strsize (l_s.item)
							update_class_fields -- Current might have been changed; synchronize
							if l_width - l_tmp___80 >= a_maxwidth then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_s.item := a_out
									update_class_fields -- Current might have been changed; synchronize
									l_width := 0
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp___71 := (create {P_CHARSET_STATIC}).ptr2cells (l_s.item)
										update_class_fields -- Current might have been changed; synchronize
										l_width := l_width + l_tmp___71
										if l_width >= a_maxwidth then
											l_break := True
										end
										if not (l_return or l_break or l_continue) then
											l_tmp___72 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s.item])
											update_class_fields -- Current might have been changed; synchronize
											l_s.item := l_s.item + l_tmp___72
											update_class_fields -- Current might have been changed; synchronize
										end
									end
									l_break := False
									from
									until
										(l_break)
									loop
										l_break := False
										l_width := l_width + 1
										if not (l_width < a_maxwidth) then
											l_break := True
										end
										if not (l_return or l_break or l_continue) then
											l_tmp___73 := l_s.item
											l_s.item := l_s.item + 1
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___73.item := l_fillchar.to_natural_8
											update_class_fields -- Current might have been changed; synchronize
										end
									end
									l_break := False
								else
									l_s.item := (a_out + a_maxwidth) - 1
									update_class_fields -- Current might have been changed; synchronize
								end
								l_l := 0
								from
								until
									not (not (l_break) and then (l_l < l_itemcnt.to_integer_32))
								loop
									l_break := False
									if ((l_item[l_l].start).c_pointer.to_integer_32).to_natural_32 > ((l_s.item).c_pointer.to_integer_32).to_natural_32 then
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										l_l := l_l + 1
									end
								end
								l_break := False
								l_itemcnt := l_l.to_integer_32
								l_tmp___74 := l_s.item
								l_s.item := l_s.item + 1
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___74.item := (('>').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_s.item.item := (0).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
							else
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_n := 0
									from
									until
										not (l_width >= a_maxwidth)
									loop
										l_tmp___75 := (create {P_CHARSET_STATIC}).ptr2cells (l_s.item + l_n)
										update_class_fields -- Current might have been changed; synchronize
										l_width := l_width - l_tmp___75
										l_tmp___76 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s.item + l_n])
										update_class_fields -- Current might have been changed; synchronize
										l_n := l_n + l_tmp___76.to_integer_32
									end
								else
									l_n := ((l_width - a_maxwidth) + 1).to_integer_32
								end
								l_p___0 := l_s.item + l_n
								l_tmp___77 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))
								update_class_fields -- Current might have been changed; synchronize
								memmove (create {CE_VOID_POINTER}.make_cast ((l_s.item + 1)), create {CE_VOID_POINTER}.make_cast (l_p___0), l_tmp___77 + {NATURAL_32} 1).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_s.item.item := (('<').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								from
								until
									(l_break)
								loop
									l_break := False
									l_width := l_width + 1
									if not (l_width < a_maxwidth) then
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										l_tmp___78 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s.item))
										update_class_fields -- Current might have been changed; synchronize
										l_s.item := l_s.item + l_tmp___78.to_integer_32
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___79 := l_s.item
										l_s.item := l_s.item + 1
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___79.item := l_fillchar.to_natural_8
										update_class_fields -- Current might have been changed; synchronize
										l_s.item.item := (('%/0/').code).to_natural_8
										update_class_fields -- Current might have been changed; synchronize
									end
								end
								l_break := False
								l_n := l_n - 1
								from
								until
									not (l_l < l_itemcnt.to_integer_32)
								loop
									if ((l_item[l_l].start - l_n).c_pointer.to_integer_32).to_natural_32 >= ((l_s.item).c_pointer.to_integer_32).to_natural_32 then
										l_item[l_l].start := l_item[l_l].start - l_n
										update_class_fields -- Current might have been changed; synchronize
									else
										l_item[l_l].start := l_s.item
										update_class_fields -- Current might have been changed; synchronize
									end
									l_l := l_l + 1
								end
							end
							l_width := a_maxwidth
						else
							l_pos := -1 + 63 -- goto _L___2
						end
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 64
				when 63 then -- else: | _L___2:
						if l_width < a_maxwidth then
							l_tmp___82 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_out))
							update_class_fields -- Current might have been changed; synchronize
							if ((l_tmp___82 + a_maxwidth.to_natural_32) - l_width.to_natural_32) + {NATURAL_32} 1 < a_outlen then
								l_l := 0
								from
								until
									not (not (l_break) and then (l_l < l_itemcnt.to_integer_32))
								loop
									l_break := False
									if l_item[l_l].type = {NATURAL_32} 3 then
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										l_l := l_l + 1
									end
								end
								l_break := False
								if l_l < l_itemcnt.to_integer_32 then
									l_p___0 := (l_item[l_l].start + a_maxwidth) - l_width
									l_tmp___81 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_item[l_l].start))
									update_class_fields -- Current might have been changed; synchronize
									memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_item[l_l].start), l_tmp___81 + {NATURAL_32} 1).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									l_s.item := l_item[l_l].start
									update_class_fields -- Current might have been changed; synchronize
									from
									until
										not (((l_s.item).c_pointer.to_integer_32).to_natural_32 < (l_p___0.c_pointer.to_integer_32).to_natural_32)
									loop
										l_s.item.item := l_fillchar.to_natural_8
										update_class_fields -- Current might have been changed; synchronize
										l_s.item := l_s.item + 1
										update_class_fields -- Current might have been changed; synchronize
									end
									l_l := l_l + 1
									from
									until
										not (l_l < l_itemcnt.to_integer_32)
									loop
										l_item[l_l].start := l_item[l_l].start + (a_maxwidth - l_width)
										update_class_fields -- Current might have been changed; synchronize
										l_l := l_l + 1
									end
									l_width := a_maxwidth
								end
							end
						end
				when 64 then
					if not a_hltab.is_void then
						l_sp := a_hltab
						l_l := 0
						from
						until
							not (l_l < l_itemcnt.to_integer_32)
						loop
							if l_item[l_l].type = {NATURAL_32} 4 then
								l_sp.item.start := l_item[l_l].start
								update_class_fields -- Current might have been changed; synchronize
								l_sp.item.userhl := l_item[l_l].minwid
								update_class_fields -- Current might have been changed; synchronize
								l_sp := l_sp + 1
							end
							l_l := l_l + 1
						end
						l_sp.item.start := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_sp.item.userhl := 0
						update_class_fields -- Current might have been changed; synchronize
					end
					if not a_tabtab.is_void then
						l_sp := a_tabtab
						l_l := 0
						from
						until
							not (l_l < l_itemcnt.to_integer_32)
						loop
							if l_item[l_l].type = {NATURAL_32} 5 then
								l_sp.item.start := l_item[l_l].start
								update_class_fields -- Current might have been changed; synchronize
								l_sp.item.userhl := l_item[l_l].minwid
								update_class_fields -- Current might have been changed; synchronize
								l_sp := l_sp + 1
							end
							l_l := l_l + 1
						end
						l_sp.item.start := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_sp.item.userhl := 0
						update_class_fields -- Current might have been changed; synchronize
					end
					Result := l_width
				when 65 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_rel_pos (a_buf___6: CE_POINTER [NATURAL_8]; a_buflen: INTEGER_32)
		local
			l_above: INTEGER_32
			l_below: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: INTEGER_32
		do
			l_above := w_topline - 1
			l_tmp := (create {P_DIFF_STATIC}).diff_check_fill ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), w_topline)
			update_class_fields -- Current might have been changed; synchronize
			l_above := l_above + (l_tmp - w_topfill).to_integer_32
			l_below := (w_buffer.item.b_ml.ml_line_count - w_botline) + 1
			if l_below <= 0 then
				if l_above = 0 then
					l_tmp___0 := gettext (ce_string ("All"))
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := l_tmp___0
				else
					l_tmp___1 := gettext (ce_string ("Bot"))
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := l_tmp___1
				end
				(create {P_MISC2_STATIC}).vim_strncpy (a_buf___6, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___2), (a_buflen - 1).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
			elseif l_above <= 0 then
				l_tmp___3 := gettext (ce_string ("Top"))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_strncpy (a_buf___6, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___3), (a_buflen - 1).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
			else
				if l_above > 1_000_000 then
					l_tmp___4 := (l_above // ((l_above + l_below) // 100)).to_integer_32
				else
					l_tmp___4 := ((l_above * 100) // (l_above + l_below)).to_integer_32
				end
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), a_buflen.to_natural_32, ce_string ("%%2d%%%%"), l_tmp___4]).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	win_lbr_chartabsize (a_s: CE_POINTER [NATURAL_8]; a_col: INTEGER_32; a_headp: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_s.is_void
		local
			l_s: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
			l_c: INTEGER_32
			l_size: INTEGER_32
			l_col2: INTEGER_32
			l_colmax: INTEGER_32
			l_added: INTEGER_32
			l_mb_added: INTEGER_32
			l_numberextra: INTEGER_32
			l_ps: CE_POINTER [NATURAL_8]
			l_tab_corr: INTEGER_32
			l_n: INTEGER_32
			l_tmp: INTEGER_32
			l_ts: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					l_col := a_col
					l_mb_added := 0
					l_tab_corr := ((l_s.item).to_integer_32 = 9).to_integer
					if not (w_onebuf_opt.wo_lbr).to_boolean then
						if ((create {P_OPTION_STATIC}).p_sbr.item.item.item).to_integer_32 = 0 then
							if (w_onebuf_opt.wo_wrap).to_boolean then
								l_tmp := (create {P_CHARSET_STATIC}).win_nolbr_chartabsize ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), l_s, l_col, a_headp)
								update_class_fields -- Current might have been changed; synchronize
								Result := l_tmp
								l_return := True
							end
							if not l_return then
								if (l_s.item).to_integer_32 = 9 then
									if not (w_onebuf_opt.wo_list).to_boolean then
										l_ts := (w_buffer.item.b_p_ts).to_integer_32
										Result := (l_ts - l_col \\ l_ts)
										l_return := True
									elseif ((create {P_GLOBALS_STATIC}).lcs_tab1.item).to_boolean then
										l_ts := (w_buffer.item.b_p_ts).to_integer_32
										Result := (l_ts - l_col \\ l_ts)
										l_return := True
									else
										l_tmp___0 := (create {P_CHARSET_STATIC}).ptr2cells (l_s)
										update_class_fields -- Current might have been changed; synchronize
										Result := l_tmp___0
										l_return := True
									end
								else
									l_tmp___0 := (create {P_CHARSET_STATIC}).ptr2cells (l_s)
									update_class_fields -- Current might have been changed; synchronize
									Result := l_tmp___0
									l_return := True
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l_size := win_chartabsize ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), l_s, l_col)
						update_class_fields -- Current might have been changed; synchronize
						l_c := (l_s.item).to_integer_32
						if not ((w_onebuf_opt.wo_lbr).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((create {P_GLOBALS_STATIC}).breakat_flags.item[(l_c.to_natural_8).to_integer_32]).to_boolean then
							if not ((create {P_GLOBALS_STATIC}).breakat_flags.item[(l_s[1]).to_integer_32]).to_boolean then
								if not (w_onebuf_opt.wo_list).to_boolean then
									if (w_onebuf_opt.wo_wrap).to_boolean then
										if w_width /= 0 then
											l_numberextra := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off
											update_class_fields -- Current might have been changed; synchronize
											l_col2 := l_col
											l_colmax := w_width - l_numberextra
											if l_col >= l_colmax then
												l_tmp___1 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off2
												update_class_fields -- Current might have been changed; synchronize
												l_n := l_colmax + l_tmp___1
												if l_n > 0 then
													l_colmax := l_colmax + (((l_col - l_colmax) // l_n + 1) * l_n)
												end
											end
											from
											until
												(l_break)
											loop
												l_break := False
												l_ps := l_s
												if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
													l_tmp___2 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s])
													update_class_fields -- Current might have been changed; synchronize
													l_tmp___3 := l_tmp___2
												else
													l_tmp___3 := 1
												end
												l_s := l_s + l_tmp___3
												l_c := (l_s.item).to_integer_32
												if l_c /= 0 then
													if not ((create {P_GLOBALS_STATIC}).breakat_flags.item[(l_c.to_natural_8).to_integer_32]).to_boolean then
														if not ((create {P_GLOBALS_STATIC}).breakat_flags.item[(l_c.to_natural_8).to_integer_32]).to_boolean then
															if l_col2 /= l_col then
																if ((create {P_GLOBALS_STATIC}).breakat_flags.item[(l_ps.item).to_integer_32]).to_boolean then
																	l_break := True
																end
															end
														else
															l_break := True
														end
													end
												else
													l_break := True
												end
												if not (l_break) then
													l_tmp___4 := win_chartabsize ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), l_s, l_col2)
													update_class_fields -- Current might have been changed; synchronize
													l_col2 := l_col2 + l_tmp___4
													if l_col2 >= l_colmax then
														l_size := l_colmax - l_col
														l_tab_corr := 0
														l_break := True
													end
												end
											end
											l_break := False
										else
											l_pos := -1 + 4 -- goto _L___3
										end
									else
										l_pos := -1 + 4 -- goto _L___3
									end
								else
									l_pos := -1 + 4 -- goto _L___3
								end
							else
								l_pos := -1 + 4 -- goto _L___3
							end
						else
							l_pos := -1 + 4 -- goto _L___3
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L___3:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							if l_size = 2 then
								if ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_s.item).to_integer_32]).to_integer_32 > 1 then
									if (w_onebuf_opt.wo_wrap).to_boolean then
										l_tmp___5 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.in_win_border (l_col)
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___5.to_boolean then
											l_size := l_size + 1
											l_mb_added := 1
										end
									end
								end
							end
						end
				when 5 then
						l_added := 0
						if ((create {P_OPTION_STATIC}).p_sbr.item.item.item).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 6 then -- if:
						if not ((w_onebuf_opt.wo_wrap).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 7 then -- if:
						if l_col = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 8 then -- if:
						l_numberextra := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off
						update_class_fields -- Current might have been changed; synchronize
						l_col := l_col + (l_numberextra + l_mb_added)
						if l_col >= w_width then
							l_col := l_col - w_width
							l_tmp___6 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off2
							update_class_fields -- Current might have been changed; synchronize
							l_numberextra := w_width - (l_numberextra - l_tmp___6)
							if l_numberextra > 0 then
								l_col := l_col \\ l_numberextra
							end
						end
						if l_col /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___4
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not (l_col + l_size > w_width) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L___4:
						l_added := (create {P_CHARSET_STATIC}).vim_strsize ((create {P_OPTION_STATIC}).p_sbr.item.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_tab_corr.to_boolean then
							l_size := (l_size.to_integer_32 + (l_added.to_integer_32 // w_buffer.item.b_p_ts) * w_buffer.item.b_p_ts).to_integer_32
						else
							l_size := l_size + l_added
						end
						if l_col /= 0 then
							l_added := 0
						end
				when 13 then -- if done | if done | if done | if done
						if not a_headp.is_void then
							a_headp.item := l_added + l_mb_added
							update_class_fields -- Current might have been changed; synchronize
						end
						Result := l_size
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	in_win_border (a_vcol: INTEGER_32): INTEGER_32
		local
			l_width1: INTEGER_32
			l_width2: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			if w_width = 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off
				update_class_fields -- Current might have been changed; synchronize
				l_width1 := w_width - l_tmp
				if a_vcol < l_width1 - 1 then
					Result := 0
					l_return := True
				end
			end
			if not l_return and then (a_vcol = l_width1 - 1) then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_tmp___0 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off2
				update_class_fields -- Current might have been changed; synchronize
				l_width2 := l_width1 + l_tmp___0
				if l_width2 <= 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := ((a_vcol - l_width1) \\ l_width2 = l_width2 - 1).to_integer
			end
		end

	getvcol (a_pos___3: CE_POINTER [PD_POS_T]; a_start___1, a_cursor, a_end: CE_POINTER [INTEGER_32])
		require
			not a_pos___3.is_void
		local
			l_vcol: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_posptr: CE_POINTER [NATURAL_8]
			l_incr: INTEGER_32
			l_head___0: CE_ARRAY [INTEGER_32]
			l_ts: INTEGER_32
			l_c: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_head___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ts := (w_buffer.item.b_p_ts).to_integer_32
					l_vcol := 0
					l_ptr := w_buffer.item.ml_get_buf (a_pos___3.item.lnum, 0)
					update_class_fields -- Current might have been changed; synchronize
					if (a_pos___3.item.col).to_integer_32 = 2_147_483_647 then
						l_posptr := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					else
						l_posptr := l_ptr + a_pos___3.item.col
					end
					if (w_onebuf_opt.wo_list).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (create {P_GLOBALS_STATIC}).lcs_tab1.item = 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___1:
						if not (w_onebuf_opt.wo_lbr).to_boolean then
							if ((create {P_OPTION_STATIC}).p_sbr.item.item.item).to_integer_32 = 0 then
								from
								until
									(l_break)
								loop
									l_break := False
									l_head___0.item := 0
									update_class_fields -- Current might have been changed; synchronize
									l_c := (l_ptr.item).to_integer_32
									if l_c = 0 then
										l_incr := 1
										l_break := True
									end
									if not (l_break) then
										if l_c = 9 then
											l_incr := l_ts - l_vcol \\ l_ts
										elseif ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
											if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
												if l_c >= 128 then
													l_incr := (create {P_MBYTE_STATIC}).utf_ptr2cells (l_ptr)
													update_class_fields -- Current might have been changed; synchronize
												else
													l_incr := (((create {P_GLOBALS_STATIC}).chartab.item[l_c]).to_integer_32).bit_and (7)
												end
											else
												l_incr := (((create {P_GLOBALS_STATIC}).chartab.item[l_c]).to_integer_32).bit_and (7)
											end
											if l_incr = 2 then
												if (w_onebuf_opt.wo_wrap).to_boolean then
													if ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_ptr.item).to_integer_32]).to_integer_32 > 1 then
														l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.in_win_border (l_vcol)
														update_class_fields -- Current might have been changed; synchronize
														if l_tmp.to_boolean then
															l_incr := l_incr + 1
															l_head___0.item := 1
															update_class_fields -- Current might have been changed; synchronize
														end
													end
												end
											end
										else
											l_incr := (((create {P_GLOBALS_STATIC}).chartab.item[l_c]).to_integer_32).bit_and (7)
										end
										if not l_posptr.is_void then
											if (l_ptr.c_pointer.to_integer_32).to_natural_32 >= (l_posptr.c_pointer.to_integer_32).to_natural_32 then
												l_break := True
											end
										end
									end
									if not (l_break) then
										l_vcol := l_vcol + l_incr
										if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
											l_tmp___0 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr])
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___1 := l_tmp___0
										else
											l_tmp___1 := 1
										end
										l_ptr := l_ptr + l_tmp___1
									end
								end
								l_break := False
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						from
						until
							(l_break)
						loop
							l_break := False
							l_head___0.item := 0
							update_class_fields -- Current might have been changed; synchronize
							l_incr := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_lbr_chartabsize (l_ptr, l_vcol, l_head___0)
							update_class_fields -- Current might have been changed; synchronize
							if (l_ptr.item).to_integer_32 = 0 then
								l_incr := 1
								l_break := True
							end
							if not (l_break) and then (not l_posptr.is_void) then
								if (l_ptr.c_pointer.to_integer_32).to_natural_32 >= (l_posptr.c_pointer.to_integer_32).to_natural_32 then
									l_break := True
								end
							end
							if not (l_break) then
								l_vcol := l_vcol + l_incr
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___2 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr])
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___3 := l_tmp___2
								else
									l_tmp___3 := 1
								end
								l_ptr := l_ptr + l_tmp___3
							end
						end
						l_break := False
				when 7 then -- if done
					if not a_start___1.is_void then
						a_start___1.item := l_vcol + l_head___0.item
						update_class_fields -- Current might have been changed; synchronize
					end
					if not a_end.is_void then
						a_end.item := (l_vcol + l_incr) - 1
						update_class_fields -- Current might have been changed; synchronize
					end
					if not a_cursor.is_void then
						if (l_ptr.item).to_integer_32 = 9 then
							if (((create {P_GLOBALS_STATIC}).State.item).bit_and (1)).to_boolean then
								if not (w_onebuf_opt.wo_list).to_boolean then
									l_tmp___4 := (create {P_MISC2_STATIC}).virtual_active
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___4.to_boolean then
										a_cursor.item := l_vcol + l_head___0.item
										update_class_fields -- Current might have been changed; synchronize
									elseif ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
										if ((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 = 101 then
											a_cursor.item := l_vcol + l_head___0.item
											update_class_fields -- Current might have been changed; synchronize
										else
											if a_pos___3.item.lnum /= (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum then
												l_tmp___6 := (a_pos___3.item.lnum < (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum).to_integer
											else
												if a_pos___3.item.col /= (create {P_GLOBALS_STATIC}).VIsual.item.item.col then
													l_tmp___5 := (a_pos___3.item.col < (create {P_GLOBALS_STATIC}).VIsual.item.item.col).to_integer
												else
													l_tmp___5 := (a_pos___3.item.coladd < (create {P_GLOBALS_STATIC}).VIsual.item.item.coladd).to_integer
												end
												l_tmp___6 := l_tmp___5
											end
											if l_tmp___6.to_boolean then
												a_cursor.item := l_vcol + l_head___0.item
												update_class_fields -- Current might have been changed; synchronize
											elseif a_pos___3.item.lnum = (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum then
												if a_pos___3.item.col = (create {P_GLOBALS_STATIC}).VIsual.item.item.col then
													if a_pos___3.item.coladd = (create {P_GLOBALS_STATIC}).VIsual.item.item.coladd then
														a_cursor.item := l_vcol + l_head___0.item
														update_class_fields -- Current might have been changed; synchronize
													else
														a_cursor.item := (l_vcol + l_incr) - 1
														update_class_fields -- Current might have been changed; synchronize
													end
												else
													a_cursor.item := (l_vcol + l_incr) - 1
													update_class_fields -- Current might have been changed; synchronize
												end
											else
												a_cursor.item := (l_vcol + l_incr) - 1
												update_class_fields -- Current might have been changed; synchronize
											end
										end
									else
										a_cursor.item := (l_vcol + l_incr) - 1
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									a_cursor.item := l_vcol + l_head___0.item
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								a_cursor.item := l_vcol + l_head___0.item
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							a_cursor.item := l_vcol + l_head___0.item
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getvvcol (a_pos___3: CE_POINTER [PD_POS_T]; a_start___1, a_cursor, a_end: CE_POINTER [INTEGER_32])
		require
			not a_pos___3.is_void
		local
			l_col: CE_ARRAY [INTEGER_32]
			l_coladd: INTEGER_32
			l_endadd: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: NATURAL_32
			l_tmp___3: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)

			l_tmp___3 := (create {P_MISC2_STATIC}).virtual_active
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___3.to_boolean then
				((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.getvcol (a_pos___3, l_col, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				l_coladd := a_pos___3.item.coladd
				l_endadd := 0
				l_ptr := w_buffer.item.ml_get_buf (a_pos___3.item.lnum, 0)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr))
				update_class_fields -- Current might have been changed; synchronize
				if a_pos___3.item.col < l_tmp___2.to_integer_32 then
					l_tmp := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_ptr + a_pos___3.item.col])
					update_class_fields -- Current might have been changed; synchronize
					l_c := l_tmp
					if l_c /= 9 then
						l_tmp___1 := (create {P_CHARSET_STATIC}).vim_isprintc (l_c)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1.to_boolean then
							l_tmp___0 := (create {P_CHARSET_STATIC}).char2cells (l_c)
							update_class_fields -- Current might have been changed; synchronize
							l_endadd := l_tmp___0 - 1
							if l_coladd > l_endadd then
								l_endadd := 0
							else
								l_coladd := 0
							end
						end
					end
				end
				l_col.item := l_col.item + l_coladd
				update_class_fields -- Current might have been changed; synchronize
				if not a_start___1.is_void then
					a_start___1.item := l_col.item
					update_class_fields -- Current might have been changed; synchronize
				end
				if not a_cursor.is_void then
					a_cursor.item := l_col.item
					update_class_fields -- Current might have been changed; synchronize
				end
				if not a_end.is_void then
					a_end.item := l_col.item + l_endadd
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.getvcol (a_pos___3, a_start___1, a_cursor, a_end)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	getvcols (a_pos1, a_pos2: CE_POINTER [PD_POS_T]; a_left, a_right: CE_POINTER [INTEGER_32])
		require
			not a_pos1.is_void
			not a_pos2.is_void
			not a_left.is_void
			not a_right.is_void
		local
			l_from1: CE_ARRAY [INTEGER_32]
			l_from2: CE_ARRAY [INTEGER_32]
			l_to1: CE_ARRAY [INTEGER_32]
			l_to2: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_from1.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_from2.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_to1.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_to2.make (<<1>>)

			if a_pos1.item.lnum /= a_pos2.item.lnum then
				l_tmp___0 := (a_pos1.item.lnum < a_pos2.item.lnum).to_integer
			else
				if a_pos1.item.col /= a_pos2.item.col then
					l_tmp := (a_pos1.item.col < a_pos2.item.col).to_integer
				else
					l_tmp := (a_pos1.item.coladd < a_pos2.item.coladd).to_integer
				end
				l_tmp___0 := l_tmp
			end
			if l_tmp___0.to_boolean then
				((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.getvvcol (a_pos1, l_from1, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_to1)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.getvvcol (a_pos2, l_from2, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_to2)
				update_class_fields -- Current might have been changed; synchronize
			else
				((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.getvvcol (a_pos2, l_from1, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_to1)
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.getvvcol (a_pos1, l_from2, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_to2)
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_from2.item < l_from1.item then
				a_left.item := l_from2.item
				update_class_fields -- Current might have been changed; synchronize
			else
				a_left.item := l_from1.item
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_to2.item > l_to1.item then
				if ((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 = 101 then
					if l_from2.item - 1 >= l_to1.item then
						a_right.item := l_from2.item - 1
						update_class_fields -- Current might have been changed; synchronize
					else
						a_right.item := l_to2.item
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					a_right.item := l_to2.item
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				a_right.item := l_to1.item
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	diff_buf_adjust
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_i___0: INTEGER_32
			l_break: BOOLEAN
		do
			if not (w_onebuf_opt.wo_diff).to_boolean then
				l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
				from
				until
					not (not (l_break) and then (not l_wp___0.is_void))
				loop
					l_break := False
					if (l_wp___0.item.w_buffer).is_equal (w_buffer) then
						if (l_wp___0.item.w_onebuf_opt.wo_diff).to_boolean then
							l_break := True
						end
					end
					if not (l_break) then
						l_wp___0 := l_wp___0.item.w_next
					end
				end
				l_break := False
				if l_wp___0.is_void then
					l_i___0 := (create {P_DIFF_STATIC}).diff_buf_idx (w_buffer)
					update_class_fields -- Current might have been changed; synchronize
					if l_i___0 /= 4 then
						(create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_i___0] := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).curtab.item.item.tp_diff_invalid := 1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_DIFF_STATIC}).diff_redraw (1)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			else
				(create {P_DIFF_STATIC}).diff_buf_add (w_buffer)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	diff_win_options (a_addbuf: INTEGER_32)
		local
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_tmp: CE_POINTER [NATURAL_8]
		do
			l_old_curwin___1 := (create {P_GLOBALS_STATIC}).curwin.item;
			(create {P_GLOBALS_STATIC}).curwin.item := (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_FOLD_STATIC}).newFoldLevel
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).curwin.item := l_old_curwin___1
			update_class_fields -- Current might have been changed; synchronize
			w_onebuf_opt.wo_diff := 1
			update_class_fields -- Current might have been changed; synchronize
			w_onebuf_opt.wo_crb := 1
			update_class_fields -- Current might have been changed; synchronize
			w_onebuf_opt.wo_scb := 1
			update_class_fields -- Current might have been changed; synchronize
			w_onebuf_opt.wo_wrap := 0
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).curwin.item := (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_OPTION_STATIC}).set_string_option_direct (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("fdm")), -1, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("diff")), 5, 0)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).curwin.item := l_old_curwin___1
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
			update_class_fields -- Current might have been changed; synchronize
			w_onebuf_opt.wo_fdc := ((create {P_GLOBALS_STATIC}).diff_foldcolumn.item).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			w_onebuf_opt.wo_fen := 1
			update_class_fields -- Current might have been changed; synchronize
			w_onebuf_opt.wo_fdl := 0
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.foldUpdateAll
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.changed_window_setting_win
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_sbo.item.item, ('h').code)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.is_void then
				(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("set sbo+=hor"))).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			if a_addbuf.to_boolean then
				(create {P_DIFF_STATIC}).diff_buf_add (w_buffer)
				update_class_fields -- Current might have been changed; synchronize
			end
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.redraw_win_later (40)
			update_class_fields -- Current might have been changed; synchronize
		end

	diff_check (a_lnum: INTEGER_32): INTEGER_32
		local
			l_idx: INTEGER_32
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			l_maxcount: INTEGER_32
			l_i___0: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_cmp: INTEGER_32
			l_tmp: INTEGER_32
			l_zero: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_buf___6 := w_buffer
			if ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diff_invalid).to_boolean then
				(create {P_DIFF_STATIC}).ex_diffupdate (create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
			end
			if ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_first_diff).is_void then
				Result := 0
				l_return := True
			elseif not (w_onebuf_opt.wo_diff).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				if a_lnum < 1 then
					Result := 0
					l_return := True
				elseif a_lnum > l_buf___6.item.b_ml.ml_line_count + 1 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_idx := (create {P_DIFF_STATIC}).diff_buf_idx (l_buf___6)
				update_class_fields -- Current might have been changed; synchronize
				if l_idx = 4 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasFoldingWin (a_lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_dp := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_first_diff
				from
				until
					not (not (l_break) and then (not l_dp.is_void))
				loop
					l_break := False
					if a_lnum <= l_dp.item.df_lnum[l_idx] + l_dp.item.df_count[l_idx] then
						l_break := True
					end
					if not (l_break) then
						l_dp := l_dp.item.df_next
					end
				end
				l_break := False
				if l_dp.is_void then
					Result := 0
					l_return := True
				elseif a_lnum < l_dp.item.df_lnum[l_idx] then
					Result := 0
					l_return := True
				end
			end
			if not l_return and then (a_lnum < l_dp.item.df_lnum[l_idx] + l_dp.item.df_count[l_idx]) then
				l_zero := 0
				l_cmp := 0
				l_i___0 := 0
				from
				until
					not (not (l_return) and then (l_i___0 < 4))
				loop
					if l_i___0 /= l_idx then
						if not ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_i___0]).is_void then
							if l_dp.item.df_count[l_i___0] = 0 then
								l_zero := 1
							else
								if l_dp.item.df_count[l_i___0] /= l_dp.item.df_count[l_idx] then
									Result := (-1)
									l_return := True
								end
								if not l_return then
									l_cmp := 1
								end
							end
						end
					end
					if not l_return then
						l_i___0 := l_i___0 + 1
					end
				end
				if not l_return and then (l_cmp.to_boolean) then
					l_i___0 := 0
					from
					until
						not (not (l_return) and then (l_i___0 < 4))
					loop
						if l_i___0 /= l_idx then
							if not ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_i___0]).is_void then
								if l_dp.item.df_count[l_i___0] /= 0 then
									l_tmp___0 := l_dp.item.diff_equal_entry (l_idx, l_i___0)
									update_class_fields -- Current might have been changed; synchronize
									if not l_tmp___0.to_boolean then
										Result := (-1)
										l_return := True
									end
								end
							end
						end
						if not l_return then
							l_i___0 := l_i___0 + 1
						end
					end
				end
				if not l_return and then (l_zero = 0) then
					Result := 0
					l_return := True
				end
				if not l_return then
					Result := (-2)
					l_return := True
				end
			end
			if not l_return and then (not (((create {P_DIFF_STATIC}).diff_flags.item).bit_and (1)).to_boolean) then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_maxcount := 0
				l_i___0 := 0
				from
				until
					not (l_i___0 < 4)
				loop
					if not ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_i___0]).is_void then
						if l_dp.item.df_count[l_i___0] > l_maxcount.to_integer_32 then
							l_maxcount := (l_dp.item.df_count[l_i___0]).to_integer_32
						end
					end
					l_i___0 := l_i___0 + 1
				end
				Result := (l_maxcount.to_integer_32 - l_dp.item.df_count[l_idx]).to_integer_32
			end
		end

	diff_set_topline (a_towin: CE_POINTER [PD_WINDOW_S])
		local
			l_frombuf: CE_POINTER [PD_FILE_BUFFER]
			l_lnum: INTEGER_32
			l_fromidx: INTEGER_32
			l_toidx: INTEGER_32
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			l_max_count: INTEGER_32
			l_i___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_frombuf := w_buffer
			l_lnum := w_topline
			l_fromidx := (create {P_DIFF_STATIC}).diff_buf_idx (l_frombuf)
			update_class_fields -- Current might have been changed; synchronize
			if l_fromidx = 4 then
				l_return := True
			end
			if not l_return then
				if ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diff_invalid).to_boolean then
					(create {P_DIFF_STATIC}).ex_diffupdate (create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer))
					update_class_fields -- Current might have been changed; synchronize
				end
				a_towin.item.w_topfill := 0
				update_class_fields -- Current might have been changed; synchronize
				l_dp := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_first_diff
				from
				until
					not (not (l_break) and then (not l_dp.is_void))
				loop
					l_break := False
					if l_lnum <= l_dp.item.df_lnum[l_fromidx] + l_dp.item.df_count[l_fromidx] then
						l_break := True
					end
					if not (l_break) then
						l_dp := l_dp.item.df_next
					end
				end
				l_break := False
				if l_dp.is_void then
					a_towin.item.w_topline := (a_towin.item.w_buffer).item.b_ml.ml_line_count - (l_frombuf.item.b_ml.ml_line_count - l_lnum)
					update_class_fields -- Current might have been changed; synchronize
				else
					l_toidx := (create {P_DIFF_STATIC}).diff_buf_idx (a_towin.item.w_buffer)
					update_class_fields -- Current might have been changed; synchronize
					if l_toidx = 4 then
						l_return := True
					end
					if not l_return then
						a_towin.item.w_topline := l_lnum + (l_dp.item.df_lnum[l_toidx] - l_dp.item.df_lnum[l_fromidx])
						update_class_fields -- Current might have been changed; synchronize
						if l_lnum >= l_dp.item.df_lnum[l_fromidx] then
							l_max_count := 0
							l_i___0 := 0
							from
							until
								not (l_i___0 < 4)
							loop
								if not ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_i___0]).is_void then
									if l_max_count.to_integer_32 < l_dp.item.df_count[l_i___0] then
										l_max_count := (l_dp.item.df_count[l_i___0]).to_integer_32
									end
								end
								l_i___0 := l_i___0 + 1
							end
							if l_dp.item.df_count[l_toidx] = l_dp.item.df_count[l_fromidx] then
								a_towin.item.w_topfill := w_topfill
								update_class_fields -- Current might have been changed; synchronize
							elseif l_dp.item.df_count[l_toidx] > l_dp.item.df_count[l_fromidx] then
								if l_lnum = l_dp.item.df_lnum[l_fromidx] + l_dp.item.df_count[l_fromidx] then
									if (l_max_count - w_topfill).to_integer_32 >= l_dp.item.df_count[l_toidx] then
										a_towin.item.w_topline := l_dp.item.df_lnum[l_toidx] + l_dp.item.df_count[l_toidx]
										update_class_fields -- Current might have been changed; synchronize
										a_towin.item.w_topfill := w_topfill
										update_class_fields -- Current might have been changed; synchronize
									else
										a_towin.item.w_topline := (l_dp.item.df_lnum[l_toidx] + l_max_count.to_integer_32) - w_topfill.to_integer_32
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							elseif a_towin.item.w_topline >= l_dp.item.df_lnum[l_toidx] + l_dp.item.df_count[l_toidx] then
								a_towin.item.w_topline := l_dp.item.df_lnum[l_toidx] + l_dp.item.df_count[l_toidx]
								update_class_fields -- Current might have been changed; synchronize
								if (((create {P_DIFF_STATIC}).diff_flags.item).bit_and (1)).to_boolean then
									if l_lnum = l_dp.item.df_lnum[l_fromidx] + l_dp.item.df_count[l_fromidx] then
										a_towin.item.w_topfill := w_topfill
										update_class_fields -- Current might have been changed; synchronize
									else
										a_towin.item.w_topfill := ((l_dp.item.df_lnum[l_fromidx] + l_max_count.to_integer_32) - l_lnum).to_integer_32
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
						end
					end
				end
			end
			if not l_return then
				a_towin.item.w_botfill := 0
				update_class_fields -- Current might have been changed; synchronize
				if a_towin.item.w_topline > (a_towin.item.w_buffer).item.b_ml.ml_line_count then
					a_towin.item.w_topline := (a_towin.item.w_buffer).item.b_ml.ml_line_count
					update_class_fields -- Current might have been changed; synchronize
					a_towin.item.w_botfill := 1
					update_class_fields -- Current might have been changed; synchronize
				end
				if a_towin.item.w_topline < 1 then
					a_towin.item.w_topline := (1).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					a_towin.item.w_topfill := 0
					update_class_fields -- Current might have been changed; synchronize
				end
				a_towin.item.invalidate_botline_win
				update_class_fields -- Current might have been changed; synchronize
				a_towin.item.changed_line_abv_curs_win
				update_class_fields -- Current might have been changed; synchronize
				a_towin.item.check_topfill (0)
				update_class_fields -- Current might have been changed; synchronize
				a_towin.item.hasFoldingWin (a_towin.item.w_topline, create {CE_INTEGER_32_POINTER}.make_shared (a_towin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_topline")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer)).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	diff_find_change (a_lnum: INTEGER_32; a_startp, a_endp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_line_org: CE_POINTER [NATURAL_8]
			l_line_new: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_si_org: INTEGER_32
			l_si_new: INTEGER_32
			l_ei_org: INTEGER_32
			l_ei_new: INTEGER_32
			l_dp: CE_POINTER [PD_DIFFBLOCK_S]
			l_idx: INTEGER_32
			l_off___0: INTEGER_32
			l_added: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: NATURAL_32
			l_tmp___6: NATURAL_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_added := 1
					l_tmp := w_buffer.item.ml_get_buf (a_lnum, 0)
					update_class_fields -- Current might have been changed; synchronize
					l_line_org := (create {P_MISC2_STATIC}).vim_strsave (l_tmp)
					update_class_fields -- Current might have been changed; synchronize
					if l_line_org.is_void then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_idx := (create {P_DIFF_STATIC}).diff_buf_idx (w_buffer)
						update_class_fields -- Current might have been changed; synchronize
						if l_idx = 4 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_line_org))
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_dp := (create {P_GLOBALS_STATIC}).curtab.item.item.tp_first_diff
						from
						until
							not (not (l_break) and then (not l_dp.is_void))
						loop
							l_break := False
							if a_lnum <= l_dp.item.df_lnum[l_idx] + l_dp.item.df_count[l_idx] then
								l_break := True
							end
							if not (l_break) then
								l_dp := l_dp.item.df_next
							end
						end
						l_break := False
						if l_dp.is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_line_org))
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						else
							l_tmp___0 := (create {P_DIFF_STATIC}).diff_check_sanity ((create {P_GLOBALS_STATIC}).curtab.item, l_dp)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___0 = 0 then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_line_org))
								update_class_fields -- Current might have been changed; synchronize
								Result := 0
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 46 -- skip if block
					end
				when 1 then -- if:
						l_off___0 := (a_lnum - l_dp.item.df_lnum[l_idx]).to_integer_32
						l_i___0 := 0
				when 2 then -- loop condition:
						if not (not (l_return) and then (l_i___0 < 4)) then
							l_pos := -1 + 45 -- skip loop
						end
				when 3 then -- loop body:
						l_continue := False
						if ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_i___0]).is_void then
							l_pos := -1 + 44 -- skip if block
						end
				when 4 then -- if:
						if l_i___0 = l_idx then
							l_pos := -1 + 44 -- skip if block
						end
				when 5 then -- if:
						if l_off___0.to_integer_32 >= l_dp.item.df_count[l_i___0] then
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 44 -- skip if block
						end
				when 6 then -- if:
						l_added := 0
						l_line_new := ((create {P_GLOBALS_STATIC}).curtab.item.item.tp_diffbuf[l_i___0]).item.ml_get_buf (l_dp.item.df_lnum[l_i___0] + l_off___0.to_integer_32, 0)
						update_class_fields -- Current might have been changed; synchronize
						l_si_new := 0
						l_si_org := l_si_new
				when 7 then -- loop condition:
						if not (not (l_break) and then ((l_line_org[l_si_org]).to_integer_32 /= 0)) then
							l_pos := -1 + 19 -- skip loop
						end
				when 8 then -- loop body:
						l_break := False
						if not ((((create {P_DIFF_STATIC}).diff_flags.item).bit_and (4)).to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 9 then -- if:
						if (l_line_org[l_si_org]).to_integer_32 /= 32 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L___1
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else:
						if (l_line_org[l_si_org]).to_integer_32 /= 9 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | _L___1:
						if (l_line_new[l_si_new]).to_integer_32 = 32 then
							l_tmp___1 := (create {P_CHARSET_STATIC}).skipwhite (l_line_org + l_si_org)
							update_class_fields -- Current might have been changed; synchronize
							l_si_org := l_tmp___1.distance (l_line_org)
							l_tmp___2 := (create {P_CHARSET_STATIC}).skipwhite (l_line_new + l_si_new)
							update_class_fields -- Current might have been changed; synchronize
							l_si_new := l_tmp___2.distance (l_line_new)
						elseif (l_line_new[l_si_new]).to_integer_32 = 9 then
							l_tmp___1 := (create {P_CHARSET_STATIC}).skipwhite (l_line_org + l_si_org)
							update_class_fields -- Current might have been changed; synchronize
							l_si_org := l_tmp___1.distance (l_line_org)
							l_tmp___2 := (create {P_CHARSET_STATIC}).skipwhite (l_line_new + l_si_new)
							update_class_fields -- Current might have been changed; synchronize
							l_si_new := l_tmp___2.distance (l_line_new)
						else
							l_pos := -1 + 17 -- goto _L___0
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_pos := -1 + 17 -- goto _L___0
				when 16 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L___0:
						if (l_line_org[l_si_org]).to_integer_32 /= (l_line_new[l_si_new]).to_integer_32 then
							l_break := True
						end
						if not (l_break) then
							l_si_org := l_si_org + 1
							l_si_new := l_si_new + 1
						end
				when 18 then
						l_pos := -1 + 7 -- back to loop condition
				when 19 then -- loop done
						l_break := False
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___3 := (create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_line_org, l_line_org + l_si_org])
							update_class_fields -- Current might have been changed; synchronize
							l_si_org := l_si_org - l_tmp___3
							l_tmp___4 := (create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_line_new, l_line_new + l_si_new])
							update_class_fields -- Current might have been changed; synchronize
							l_si_new := l_si_new - l_tmp___4
						end
						if a_startp.item > l_si_org then
							a_startp.item := l_si_org
							update_class_fields -- Current might have been changed; synchronize
						end
						if (l_line_org[l_si_org]).to_integer_32 = 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___6
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 22 then -- else:
						if (l_line_new[l_si_new]).to_integer_32 = 0 then
							l_pos := -1 + 44 -- skip if block
						end
				when 23 then -- if: | _L___6:
						l_tmp___5 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line_org))
						update_class_fields -- Current might have been changed; synchronize
						l_ei_org := l_tmp___5.to_integer_32
						l_tmp___6 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line_new))
						update_class_fields -- Current might have been changed; synchronize
						l_ei_new := l_tmp___6.to_integer_32
				when 24 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 43 -- skip loop
						end
				when 25 then -- loop body:
						l_break := False
						if l_ei_org >= a_startp.item then
							if l_ei_new >= l_si_new then
								if l_ei_org >= 0 then
									if not (l_ei_new >= 0) then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 42 -- skip if block
						end
				when 26 then -- if:
						if not ((((create {P_DIFF_STATIC}).diff_flags.item).bit_and (4)).to_boolean) then
							l_pos := -1 + 41 -- skip if block
						end
				when 27 then -- if:
						if (l_line_org[l_ei_org]).to_integer_32 /= 32 then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 31 -- goto _L___5
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 30 then -- else:
						if (l_line_org[l_ei_org]).to_integer_32 /= 9 then
							l_pos := -1 + 39 -- skip if block
						end
				when 31 then -- if: | _L___5:
						if (l_line_new[l_ei_new]).to_integer_32 /= 32 then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 35 -- goto _L___3
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 34 then -- else:
						if (l_line_new[l_ei_new]).to_integer_32 /= 9 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if: | _L___3:
						from
						until
							(l_break)
						loop
							l_break := False
							if l_ei_org >= a_startp.item then
								if (l_line_org[l_ei_org]).to_integer_32 /= 32 then
									if (l_line_org[l_ei_org]).to_integer_32 /= 9 then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_ei_org := l_ei_org - 1
							end
						end
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if l_ei_new >= l_si_new then
								if (l_line_new[l_ei_new]).to_integer_32 /= 32 then
									if (l_line_new[l_ei_new]).to_integer_32 /= 9 then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_ei_new := l_ei_new - 1
							end
						end
						l_break := False
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else:
						l_pos := -1 + 41 -- goto _L___4
				when 38 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 40
				when 39 then -- else:
						l_pos := -1 + 41 -- goto _L___4
				when 40 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else: | _L___4:
						if (l_line_org[l_ei_org]).to_integer_32 /= (l_line_new[l_ei_new]).to_integer_32 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_ei_org := l_ei_org - 1
							l_ei_new := l_ei_new - 1
						end
				when 42 then -- if done
						l_pos := -1 + 24 -- back to loop condition
				when 43 then -- loop done
						l_break := False
						if a_endp.item < l_ei_org then
							a_endp.item := l_ei_org
							update_class_fields -- Current might have been changed; synchronize
						end
				when 44 then -- if done | if done | if done | if done
						if (not l_return) then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 45 then -- loop done
						l_continue := False;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_line_org))
						update_class_fields -- Current might have been changed; synchronize
						Result := l_added
				when 46 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	editing_arg_idx: INTEGER_32
		local
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			if w_arg_idx >= w_alist.item.al_ga.ga_len then
				l_tmp___1 := 0
			elseif w_buffer.item.b_fnum /= (create {CE_CLASS_POINTER [PD_ARGENTRY]}.make_cast (w_alist.item.al_ga.ga_data) + w_arg_idx).item.ae_fnum then
				if (w_buffer.item.b_ffname).is_void then
					l_tmp___1 := 0
				else
					l_tmp := (create {CE_CLASS_POINTER [PD_ARGENTRY]}.make_cast (w_alist.item.al_ga.ga_data) + w_arg_idx).item.alist_name
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := (create {P_MISC1_STATIC}).fullpathcmp (l_tmp, w_buffer.item.b_ffname, 1)
					update_class_fields -- Current might have been changed; synchronize
					if ((l_tmp___0).bit_and (1)).to_boolean then
						l_tmp___1 := 1
					else
						l_tmp___1 := 0
					end
				end
			else
				l_tmp___1 := 1
			end
			Result := l_tmp___1
		end

	check_arg_idx
		local
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (w_alist.item.al_ga.ga_len > 1) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_tmp___1 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.editing_arg_idx
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1.to_boolean then
							l_pos := -1 + 3 -- goto _L
						else
							Current.w_arg_idx_invalid := 1
							update_class_fields -- Current might have been changed; synchronize
							if w_arg_idx /= w_alist.item.al_ga.ga_len - 1 then
								if (create {P_GLOBALS_STATIC}).arg_had_last.item = 0 then
									if w_alist.is_equal ((create {P_GLOBALS_STATIC}).global_alist.item) then
										if (create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_len > 0 then
											if w_arg_idx < (create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_len then
												if w_buffer.item.b_fnum = (create {CE_CLASS_POINTER [PD_ARGENTRY]}.make_cast ((create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_data) + ((create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_len - 1)).item.ae_fnum then
													(create {P_GLOBALS_STATIC}).arg_had_last.item := 1
													update_class_fields -- Current might have been changed; synchronize
												elseif not (w_buffer.item.b_ffname).is_void then
													l_tmp := (create {CE_CLASS_POINTER [PD_ARGENTRY]}.make_cast ((create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_data) + ((create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_len - 1)).item.alist_name
													update_class_fields -- Current might have been changed; synchronize
													l_tmp___0 := (create {P_MISC1_STATIC}).fullpathcmp (l_tmp, w_buffer.item.b_ffname, 1)
													update_class_fields -- Current might have been changed; synchronize
													if ((l_tmp___0).bit_and (1)).to_boolean then
														(create {P_GLOBALS_STATIC}).arg_had_last.item := 1
														update_class_fields -- Current might have been changed; synchronize
													end
												end
											end
										end
									end
								end
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						Current.w_arg_idx_invalid := 0
						update_class_fields -- Current might have been changed; synchronize
						if w_arg_idx = w_alist.item.al_ga.ga_len - 1 then
							if w_alist.is_equal ((create {P_GLOBALS_STATIC}).global_alist.item) then
								(create {P_GLOBALS_STATIC}).arg_had_last.item := 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_win_close (a_forceit: INTEGER_32; a_tp: CE_POINTER [PD_TABPAGE_S])
		local
			l_need_hide: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6 := w_buffer
					l_tmp := l_buf___6.item.bufIsChanged
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						if l_buf___6.item.b_nwindows <= 1 then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
					else
						l_tmp___0 := 0
					end
					l_need_hide := l_tmp___0
					if not (l_need_hide.to_boolean) then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_tmp___4 := l_buf___6.item.buf_hide
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___4.to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						if a_forceit.to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						if not (((create {P_OPTION_STATIC}).p_confirm.item.item).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (((create {P_GLOBALS_STATIC}).cmdmod.item.item.confirm).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						if ((create {P_OPTION_STATIC}).p_write.item.item).to_boolean then
							l_buf___6.item.dialog_changed (0)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___1 := (create {P_BUFFER_STATIC}).buf_valid (l_buf___6)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___1.to_boolean then
								l_tmp___2 := l_buf___6.item.bufIsChanged
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___2.to_boolean then
									l_return := True
								end
							end
							if not l_return then
								l_need_hide := 0
							end
						else
							l_tmp___3 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_nowrtmsg.item)))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___3)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_tmp___3 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_nowrtmsg.item)))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___3)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
				when 10 then -- if done | if done | if done | if done
					if not l_return then
						(create {P_GLOBALS_STATIC}).need_mouse_correct.item := 1
						update_class_fields -- Current might have been changed; synchronize
						if a_tp.is_void then
							if not l_need_hide.to_boolean then
								l_tmp___5 := l_buf___6.item.buf_hide
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___5.to_boolean then
									l_tmp___6 := 0
								else
									l_tmp___6 := 1
								end
							else
								l_tmp___6 := 0
							end
							(create {P_WINDOW_STATIC}).win_close ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), l_tmp___6)
							update_class_fields -- Current might have been changed; synchronize
						else
							if not l_need_hide.to_boolean then
								l_tmp___7 := l_buf___6.item.buf_hide
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___7.to_boolean then
									l_tmp___8 := 0
								else
									l_tmp___8 := 1
								end
							else
								l_tmp___8 := 0
							end
							((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_close_othertab (l_tmp___8, a_tp)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	copyFoldingState (a_wp_to: CE_POINTER [PD_WINDOW_S])
		require
			not a_wp_to.is_void
		do
			a_wp_to.item.w_fold_manual := w_fold_manual
			update_class_fields -- Current might have been changed; synchronize
			a_wp_to.item.w_foldinvalid := w_foldinvalid
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds"))).item.cloneFoldGrowArray (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_wp_to.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds")))
			update_class_fields -- Current might have been changed; synchronize
		end

	hasAnyFolding: INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			if (w_onebuf_opt.wo_fen).to_boolean then
				l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.foldmethodIsManual
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					if w_folds.ga_len > 0 then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 1
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	hasFoldingWin (a_lnum: INTEGER_32; a_firstp, a_lastp: CE_POINTER [INTEGER_32]; a_cache: INTEGER_32; a_infop: CE_POINTER [PD_FOLDINFO]): INTEGER_32
		local
			l_had_folded: INTEGER_32
			l_first___0: INTEGER_32
			l_last: INTEGER_32
			l_lnum_rel: INTEGER_32
			l_x___0: INTEGER_32
			l_fp: CE_ARRAY [CE_POINTER [PD_FOLD_T]]
			l_level: INTEGER_32
			l_use_level: CE_ARRAY [INTEGER_32]
			l_maybe_small: CE_ARRAY [INTEGER_32]
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_low_level: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_FOLD_T]} l_fp.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_use_level.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_maybe_small.make (<<1>>)

			l_had_folded := 0
			l_first___0 := (0).to_integer_32
			l_last := (0).to_integer_32
			l_lnum_rel := a_lnum
			l_level := 0
			l_use_level.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_maybe_small.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_low_level := 0;
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.checkupdate
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasAnyFolding
			update_class_fields -- Current might have been changed; synchronize
			if not l_tmp.to_boolean then
				if not a_infop.is_void then
					a_infop.item.fi_level := 0
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := 0
				l_return := True
			end
			if not l_return then
				if a_cache.to_boolean then
					l_x___0 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.find_wl_entry (a_lnum)
					update_class_fields -- Current might have been changed; synchronize
					if l_x___0 >= 0 then
						l_first___0 := (w_lines + l_x___0).item.wl_lnum
						l_last := (w_lines + l_x___0).item.wl_lastlnum
						l_had_folded := ((w_lines + l_x___0).item.wl_folded).to_integer_32
					end
				end
				if l_first___0 = 0 then
					l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds"))
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___0 := l_gap.item.foldFind (l_lnum_rel, l_fp)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___0.to_boolean then
							l_break := True
						end
						if not (l_break) then
							if l_lnum_rel = l_fp.item.item.fd_top then
								if l_low_level = 0 then
									l_low_level := l_level + 1
								end
							end
							l_first___0 := l_first___0 + (l_fp.item.item.fd_top)
							l_last := l_last + (l_fp.item.item.fd_top)
							l_had_folded := (create {P_FOLD_STATIC}).check_closed ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), l_fp.item, l_use_level, l_level, l_maybe_small, a_lnum - l_lnum_rel)
							update_class_fields -- Current might have been changed; synchronize
							if l_had_folded.to_boolean then
								l_last := l_last + (l_fp.item.item.fd_len - 1)
								l_break := True
							end
						end
						if not (l_break) then
							l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))
							l_lnum_rel := l_lnum_rel - (l_fp.item.item.fd_top)
							l_level := l_level + 1
						end
					end
					l_break := False
				end
				if not l_had_folded.to_boolean then
					if not a_infop.is_void then
						a_infop.item.fi_level := l_level
						update_class_fields -- Current might have been changed; synchronize
						a_infop.item.fi_lnum := (a_lnum - l_lnum_rel).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						if l_low_level = 0 then
							a_infop.item.fi_low_level := l_level
							update_class_fields -- Current might have been changed; synchronize
						else
							a_infop.item.fi_low_level := l_low_level
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if not a_lastp.is_void then
					a_lastp.item := l_last
					update_class_fields -- Current might have been changed; synchronize
				end
				if not a_firstp.is_void then
					a_firstp.item := l_first___0
					update_class_fields -- Current might have been changed; synchronize
				end
				if not a_infop.is_void then
					a_infop.item.fi_level := l_level + 1
					update_class_fields -- Current might have been changed; synchronize
					a_infop.item.fi_lnum := l_first___0.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					if l_low_level = 0 then
						a_infop.item.fi_low_level := l_level + 1
						update_class_fields -- Current might have been changed; synchronize
					else
						a_infop.item.fi_low_level := l_low_level
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				Result := 1
			end
		end

	foldedCount (a_lnum: INTEGER_32; a_infop: CE_POINTER [PD_FOLDINFO]): INTEGER_32
		local
			l_last: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_last.make (<<1>>)

			l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasFoldingWin (a_lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_last, 0, a_infop)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				Result := ((l_last.item - a_lnum) + 1)
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	foldmethodIsManual: INTEGER_32
		do
			Result := ((w_onebuf_opt.wo_fdm[3]).to_integer_32 = 117).to_integer
		end

	foldmethodIsIndent: INTEGER_32
		do
			Result := ((w_onebuf_opt.wo_fdm[0]).to_integer_32 = 105).to_integer
		end

	foldmethodIsExpr: INTEGER_32
		do
			Result := ((w_onebuf_opt.wo_fdm[1]).to_integer_32 = 120).to_integer
		end

	foldmethodIsMarker: INTEGER_32
		do
			Result := ((w_onebuf_opt.wo_fdm[2]).to_integer_32 = 114).to_integer
		end

	foldmethodIsSyntax: INTEGER_32
		do
			Result := ((w_onebuf_opt.wo_fdm[0]).to_integer_32 = 115).to_integer
		end

	foldmethodIsDiff: INTEGER_32
		do
			Result := ((w_onebuf_opt.wo_fdm[0]).to_integer_32 = 100).to_integer
		end

	newFoldLevelWin
		local
			l_fp: CE_POINTER [PD_FOLD_T]
			l_i___0: INTEGER_32
		do
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.checkupdate
			update_class_fields -- Current might have been changed; synchronize
			if w_fold_manual.to_boolean then
				l_fp := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (w_folds.ga_data)
				l_i___0 := 0
				from
				until
					not (l_i___0 < w_folds.ga_len)
				loop
					(l_fp + l_i___0).item.fd_flags := (2).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := l_i___0 + 1
				end
				Current.w_fold_manual := (0).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
			end
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.changed_window_setting_win
			update_class_fields -- Current might have been changed; synchronize
		end

	clearFolding
		do
			(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds"))).item.deleteFoldRecurse
			update_class_fields -- Current might have been changed; synchronize
			Current.w_foldinvalid := (0).to_integer_8
			update_class_fields -- Current might have been changed; synchronize
		end

	foldUpdate (a_top, a_bot: INTEGER_32)
		local
			l_fp: CE_ARRAY [CE_POINTER [PD_FOLD_T]]
			l_save_got_int: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_FOLD_T]} l_fp.make (<<1>>);

			(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds"))).item.foldFind (a_top, l_fp).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				(l_break)
			loop
				l_break := False
				if ((l_fp.item).c_pointer.to_integer_32).to_natural_32 < ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast ((create {P_GLOBALS_STATIC}).curwin.item.item.w_folds.ga_data) + (create {P_GLOBALS_STATIC}).curwin.item.item.w_folds.ga_len).c_pointer.to_integer_32).to_natural_32 then
					if not (l_fp.item.item.fd_top < a_bot) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_fp.item.item.fd_small := (2).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_fp.item := l_fp.item + 1
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_break := False
			l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.foldmethodIsIndent
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				l_save_got_int := (create {P_GLOBALS_STATIC}).got_int.item;
				(create {P_GLOBALS_STATIC}).got_int.item := 0
				update_class_fields -- Current might have been changed; synchronize
				foldUpdateIEMS ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), a_top, a_bot)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).got_int.item := ((create {P_GLOBALS_STATIC}).got_int.item).bit_or (l_save_got_int)
				update_class_fields -- Current might have been changed; synchronize
			else
				l_tmp___0 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.foldmethodIsExpr
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					l_save_got_int := (create {P_GLOBALS_STATIC}).got_int.item;
					(create {P_GLOBALS_STATIC}).got_int.item := 0
					update_class_fields -- Current might have been changed; synchronize
					foldUpdateIEMS ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), a_top, a_bot)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GLOBALS_STATIC}).got_int.item := ((create {P_GLOBALS_STATIC}).got_int.item).bit_or (l_save_got_int)
					update_class_fields -- Current might have been changed; synchronize
				else
					l_tmp___1 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.foldmethodIsMarker
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___1.to_boolean then
						l_save_got_int := (create {P_GLOBALS_STATIC}).got_int.item;
						(create {P_GLOBALS_STATIC}).got_int.item := 0
						update_class_fields -- Current might have been changed; synchronize
						foldUpdateIEMS ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), a_top, a_bot)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).got_int.item := ((create {P_GLOBALS_STATIC}).got_int.item).bit_or (l_save_got_int)
						update_class_fields -- Current might have been changed; synchronize
					else
						l_tmp___2 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.foldmethodIsDiff
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2.to_boolean then
							l_save_got_int := (create {P_GLOBALS_STATIC}).got_int.item;
							(create {P_GLOBALS_STATIC}).got_int.item := 0
							update_class_fields -- Current might have been changed; synchronize
							foldUpdateIEMS ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), a_top, a_bot)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).got_int.item := ((create {P_GLOBALS_STATIC}).got_int.item).bit_or (l_save_got_int)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___3 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.foldmethodIsSyntax
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___3.to_boolean then
								l_save_got_int := (create {P_GLOBALS_STATIC}).got_int.item;
								(create {P_GLOBALS_STATIC}).got_int.item := 0
								update_class_fields -- Current might have been changed; synchronize
								foldUpdateIEMS ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), a_top, a_bot)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_GLOBALS_STATIC}).got_int.item := ((create {P_GLOBALS_STATIC}).got_int.item).bit_or (l_save_got_int)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
				end
			end
		end

	foldUpdateAll
		do
			Current.w_foldinvalid := (1).to_integer_8
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.redraw_win_later (40)
			update_class_fields -- Current might have been changed; synchronize
		end

	find_wl_entry (a_lnum: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				not (not (l_return) and then (l_i___0 < w_lines_valid))
			loop
				if ((w_lines + l_i___0).item.wl_valid).to_boolean then
					if a_lnum < (w_lines + l_i___0).item.wl_lnum then
						Result := (-1)
						l_return := True
					end
					if not l_return and then (a_lnum <= (w_lines + l_i___0).item.wl_lastlnum) then
						Result := l_i___0
						l_return := True
					end
				end
				if not l_return then
					l_i___0 := l_i___0 + 1
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

	checkupdate
		do
			if w_foldinvalid.to_boolean then
				((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.foldUpdate ((1).to_integer_32, 2_147_483_647)
				update_class_fields -- Current might have been changed; synchronize
				Current.w_foldinvalid := (0).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	setManualFoldWin (a_lnum: INTEGER_32; a_opening, a_recurse___2: INTEGER_32; a_donep: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_lnum: INTEGER_32
			l_fp: CE_ARRAY [CE_POINTER [PD_FOLD_T]]
			l_fp2: CE_POINTER [PD_FOLD_T]
			l_found: CE_POINTER [PD_FOLD_T]
			l_j: INTEGER_32
			l_level: INTEGER_32
			l_use_level: INTEGER_32
			l_found_fold: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_next: INTEGER_32
			l_off___0: INTEGER_32
			l_done___2: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_FOLD_T]} l_fp.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := a_lnum
					l_found := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_shared (default_pointer)
					l_level := 0
					l_use_level := 0
					l_found_fold := 0
					l_next := 2_147_483_647
					l_off___0 := (0).to_integer_32
					l_done___2 := 0;
					((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.checkupdate
					update_class_fields -- Current might have been changed; synchronize
					l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds"))
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_tmp := l_gap.item.foldFind (l_lnum, l_fp)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp.to_boolean then
							if ((l_fp.item).c_pointer.to_integer_32).to_natural_32 < ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_gap.item.ga_data) + l_gap.item.ga_len).c_pointer.to_integer_32).to_natural_32 then
								l_next := l_fp.item.item.fd_top + l_off___0
							end
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if:
						l_found_fold := 1
						if ((l_fp.item + 1).c_pointer.to_integer_32).to_natural_32 < ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_gap.item.ga_data) + l_gap.item.ga_len).c_pointer.to_integer_32).to_natural_32 then
							l_next := (l_fp.item + 1).item.fd_top + l_off___0
						end
						if not (l_use_level.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if (l_fp.item.item.fd_flags).to_integer_32 /= 2 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_use_level := 1
						if l_level.to_integer_32 >= w_onebuf_opt.wo_fdl then
							l_fp.item.item.fd_flags := (1).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
						else
							l_fp.item.item.fd_flags := (0).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
						end
						l_fp2 := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_fp.item.item.fd_nested.ga_data)
						l_j := 0
						from
						until
							not (l_j < l_fp.item.item.fd_nested.ga_len)
						loop
							(l_fp2 + l_j).item.fd_flags := (2).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							l_j := l_j + 1
						end
				when 8 then -- if done
						if a_opening.to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if a_recurse___2.to_boolean then
							if (l_fp.item.item.fd_flags).to_integer_32 /= 1 then
								l_done___2 := (l_done___2).bit_or ((1))
								l_fp.item.item.fd_flags := (1).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_pos := -1 + 11 -- goto _L___0
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L___0:
						if (l_fp.item.item.fd_flags).to_integer_32 = 1 then
							if a_opening.to_boolean then
								l_fp.item.item.fd_flags := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_done___2 := (l_done___2).bit_or ((1))
								if a_recurse___2.to_boolean then
									foldOpenNested (l_fp.item)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_break := True
						end
				when 12 then -- if done
						if not (l_return or l_break) then
							l_found := l_fp.item
							l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))
							l_lnum := l_lnum - (l_fp.item.item.fd_top)
							l_off___0 := l_off___0 + (l_fp.item.item.fd_top)
							l_level := l_level + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					l_break := False
					if l_found_fold.to_boolean then
						if not a_opening.to_boolean then
							if not l_found.is_void then
								l_found.item.fd_flags := (1).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								l_done___2 := (l_done___2).bit_or ((1))
							end
						end
						Current.w_fold_manual := (1).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						if ((l_done___2).bit_and (1)).to_boolean then
							((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.changed_window_setting_win
							update_class_fields -- Current might have been changed; synchronize
						end
						l_done___2 := (l_done___2).bit_or ((2))
					elseif a_donep.is_void then
						if (c_pointer = ((create {P_GLOBALS_STATIC}).curwin.item).c_pointer) then
							l_tmp___0 := gettext ((create {P_FOLD_STATIC}).e_nofold.item)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if not a_donep.is_void then
						a_donep.item := (a_donep.item).bit_or (l_done___2)
						update_class_fields -- Current might have been changed; synchronize
					end
					Result := l_next
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_foldtext (a_lnum, a_lnume: INTEGER_32; a_foldinfo: CE_POINTER [PD_FOLDINFO]; a_buf___6: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_text: CE_POINTER [NATURAL_8]
			l_dashes: CE_ARRAY [NATURAL_8]
			l_save_curwin: CE_POINTER [PD_WINDOW_S]
			l_level: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_len: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_dashes.make (<<22>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					if ((w_onebuf_opt.wo_fdt).item).to_integer_32 = 0 then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:;
						(create {P_EVAL_STATIC}).set_vim_var_nr (22, a_lnum)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_EVAL_STATIC}).set_vim_var_nr (23, a_lnume)
						update_class_fields -- Current might have been changed; synchronize
						l_level := a_foldinfo.item.fi_level
						if l_level > ({PLATFORM}.Natural_8_bytes.to_natural_32 * (22).to_natural_32).to_integer_32 - 1 then
							l_level := ({PLATFORM}.Natural_8_bytes.to_natural_32 * (22).to_natural_32).to_integer_32 - 1
						end
						memset (create {CE_VOID_POINTER}.make_cast (l_dashes), ('-').code, l_level.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_dashes[l_level] := (('%/0/').code).to_natural_8
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_EVAL_STATIC}).set_vim_var_string (24, l_dashes, -1)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_EVAL_STATIC}).set_vim_var_nr (25, l_level.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						l_save_curwin := (create {P_GLOBALS_STATIC}).curwin.item;
						(create {P_GLOBALS_STATIC}).curwin.item := (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).curbuf.item := w_buffer
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).emsg_off.item := (create {P_GLOBALS_STATIC}).emsg_off.item + 1
						update_class_fields -- Current might have been changed; synchronize
						l_tmp := (create {P_OPTION_STATIC}).was_set_insecurely (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("foldtext")), 4)
						update_class_fields -- Current might have been changed; synchronize
						l_text := (create {P_EVAL_STATIC}).eval_to_string_safe (w_onebuf_opt.wo_fdt, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), l_tmp)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).emsg_off.item := (create {P_GLOBALS_STATIC}).emsg_off.item - 1
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).curwin.item := l_save_curwin
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_EVAL_STATIC}).set_vim_var_string (24, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), -1)
						update_class_fields -- Current might have been changed; synchronize
						if l_text.is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						l_p___0 := l_text
				when 3 then -- loop condition:
						if not (not (l_break) and then ((l_p___0.item).to_integer_32 /= 0)) then
							l_pos := -1 + 9 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_len := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
						update_class_fields -- Current might have been changed; synchronize
						if l_len > 1 then
							l_tmp___0 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0])
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___1 := (create {P_CHARSET_STATIC}).vim_isprintc (l_tmp___0)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___1.to_boolean then
								l_break := True
							end
							if not (l_break) then
								l_p___0 := l_p___0 + (l_len - 1)
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if (l_p___0.item).to_integer_32 = 9 then
							l_p___0.item := ((' ').code).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___2 := (create {P_CHARSET_STATIC}).ptr2cells (l_p___0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___2 > 1 then
								l_break := True
							end
						end
				when 8 then
						if not (l_break) then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 3 -- back to loop condition
				when 9 then -- loop done
						l_break := False
						if (l_p___0.item).to_integer_32 /= 0 then
							l_p___0 := (create {P_CHARSET_STATIC}).transstr (l_text)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_text))
							update_class_fields -- Current might have been changed; synchronize
							l_text := l_p___0
						end
				when 10 then -- if done | if done
					if l_text.is_void then
						l_tmp___3 := gettext (ce_string ("+--%%3ld lines folded "))
						update_class_fields -- Current might have been changed; synchronize
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), l_tmp___3, (a_lnume - a_lnum) + 1]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_text := a_buf___6
					end
					Result := l_text
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	parseMarker
		local
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
		do
			(create {P_FOLD_STATIC}).foldendmarker.item := (create {P_MISC2_STATIC}).vim_strchr (w_onebuf_opt.wo_fmr, (',').code)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_FOLD_STATIC}).foldendmarker.item;
			(create {P_FOLD_STATIC}).foldendmarker.item := (create {P_FOLD_STATIC}).foldendmarker.item + 1
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_FOLD_STATIC}).foldstartmarkerlen.item := l_tmp.distance ((w_onebuf_opt.wo_fmr))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_FOLD_STATIC}).foldendmarker.item))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_FOLD_STATIC}).foldendmarkerlen.item := l_tmp___0.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	copy_jumplist (a_to: CE_POINTER [PD_WINDOW_S])
		require
			not a_to.is_void
		local
			l_i___0: INTEGER_32
		do
			l_i___0 := 0
			from
			until
				not (l_i___0 < w_jumplistlen)
			loop
				a_to.item.w_jumplist[l_i___0] := (w_jumplist[l_i___0]).twin
				update_class_fields -- Current might have been changed; synchronize
				if not (w_jumplist[l_i___0].fname).is_void then
					a_to.item.w_jumplist[l_i___0].fname := (create {P_MISC2_STATIC}).vim_strsave (w_jumplist[l_i___0].fname)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_i___0 := l_i___0 + 1
			end
			a_to.item.w_jumplistlen := w_jumplistlen
			update_class_fields -- Current might have been changed; synchronize
			a_to.item.w_jumplistidx := w_jumplistidx
			update_class_fields -- Current might have been changed; synchronize
		end

	free_jumplist
		local
			l_i___0: INTEGER_32
		do
			l_i___0 := 0
			from
			until
				not (l_i___0 < w_jumplistlen)
			loop
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (w_jumplist[l_i___0].fname))
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := l_i___0 + 1
			end
		end

	set_last_cursor
		do
			w_buffer.item.b_last_cursor := w_cursor.twin
			update_class_fields -- Current might have been changed; synchronize
		end

	plines_win_nofill (a_lnum: INTEGER_32; a_winheight: INTEGER_32): INTEGER_32
		local
			l_lines___0: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			if not (w_onebuf_opt.wo_wrap).to_boolean then
				Result := 1
				l_return := True
			end
			if not l_return and then (w_width = 0) then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.lineFolded (a_lnum)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp = 1 then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				l_lines___0 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win_nofold (a_lnum)
				update_class_fields -- Current might have been changed; synchronize
				if a_winheight > 0 then
					if l_lines___0 > w_height then
						Result := w_height
						l_return := True
					end
				end
			end
			if not l_return then
				Result := l_lines___0
			end
		end

	plines_win_nofold (a_lnum: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
			l_width: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			l_s := w_buffer.item.ml_get_buf (a_lnum, 0)
			update_class_fields -- Current might have been changed; synchronize
			if (l_s.item).to_integer_32 = 0 then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_tmp := (create {P_CHARSET_STATIC}).win_linetabsize ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), l_s, (2_147_483_647).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				l_col := l_tmp.to_integer_32
				if (w_onebuf_opt.wo_list).to_boolean then
					if (create {P_GLOBALS_STATIC}).lcs_eol.item.item /= 0 then
						l_col := l_col + 1
					end
				end
				l_tmp___0 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off
				update_class_fields -- Current might have been changed; synchronize
				l_width := w_width - l_tmp___0
				if l_width <= 0 then
					Result := 32_000
					l_return := True
				end
			end
			if not l_return and then (l_col <= l_width.to_integer_32) then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_col := l_col - l_width.to_integer_32
				l_tmp___1 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off2
				update_class_fields -- Current might have been changed; synchronize
				l_width := l_width + l_tmp___1
				Result := ((l_col + (l_width - 1).to_integer_32) // l_width.to_integer_32 + 1).to_integer_32
			end
		end

	plines_win_col (a_lnum, a_column: INTEGER_32): INTEGER_32
		local
			l_column: INTEGER_32
			l_col: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_lines___0: INTEGER_32
			l_width: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_column := a_column
			l_lines___0 := 0
			l_lines___0 := (create {P_DIFF_STATIC}).diff_check_fill ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), a_lnum)
			update_class_fields -- Current might have been changed; synchronize
			if not (w_onebuf_opt.wo_wrap).to_boolean then
				Result := (l_lines___0 + 1)
				l_return := True
			end
			if not l_return and then (w_width = 0) then
				Result := (l_lines___0 + 1)
				l_return := True
			end
			if not l_return then
				l_s := w_buffer.item.ml_get_buf (a_lnum, 0)
				update_class_fields -- Current might have been changed; synchronize
				l_col := 0
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_s.item).to_integer_32 /= 0 then
						l_column := l_column - 1
						if not (l_column >= 0) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_lbr_chartabsize (l_s, l_col.to_integer_32, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_col := l_col + l_tmp.to_integer_32
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___0 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s])
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___1 := l_tmp___0
						else
							l_tmp___1 := 1
						end
						l_s := l_s + l_tmp___1
					end
				end
				l_break := False
				if (l_s.item).to_integer_32 = 9 then
					if (((create {P_GLOBALS_STATIC}).State.item).bit_and (1)).to_boolean then
						if not (w_onebuf_opt.wo_list).to_boolean then
							l_tmp___2 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_lbr_chartabsize (l_s, l_col.to_integer_32, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
							l_col := l_col + (l_tmp___2 - 1).to_integer_32
						elseif ((create {P_GLOBALS_STATIC}).lcs_tab1.item).to_boolean then
							l_tmp___2 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_lbr_chartabsize (l_s, l_col.to_integer_32, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
							l_col := l_col + (l_tmp___2 - 1).to_integer_32
						end
					end
				end
				l_tmp___3 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off
				update_class_fields -- Current might have been changed; synchronize
				l_width := w_width - l_tmp___3
				if l_width <= 0 then
					Result := 9_999
					l_return := True
				end
			end
			if not l_return then
				l_lines___0 := l_lines___0 + 1
				if l_col > l_width.to_integer_32 then
					l_tmp___4 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off2
					update_class_fields -- Current might have been changed; synchronize
					l_lines___0 := (l_lines___0.to_integer_32 + ((l_col - l_width.to_integer_32) // (l_width + l_tmp___4).to_integer_32 + 1)).to_integer_32
				end
				Result := l_lines___0
			end
		end

	get_cursor_rel_lnum (a_lnum: INTEGER_32): INTEGER_32
		local
			l_lnum: CE_ARRAY [INTEGER_32]
			l_cursor: INTEGER_32
			l_retval: INTEGER_32
			l_tmp: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_lnum.make (<<1>>)

			l_lnum.item := a_lnum
			update_class_fields -- Current might have been changed; synchronize
			l_cursor := w_cursor.lnum
			l_retval := (0).to_integer_32
			l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasAnyFolding
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				if l_lnum.item > l_cursor then
					from
					until
						not (l_lnum.item > l_cursor)
					loop
						(create {P_FOLD_STATIC}).hasFolding (l_lnum.item, l_lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if l_lnum.item > l_cursor then
							l_retval := l_retval + 1
						end
						l_lnum.item := l_lnum.item - 1
						update_class_fields -- Current might have been changed; synchronize
					end
				elseif l_lnum.item < l_cursor then
					from
					until
						not (l_lnum.item < l_cursor)
					loop
						(create {P_FOLD_STATIC}).hasFolding (l_lnum.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_lnum).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if l_lnum.item < l_cursor then
							l_retval := l_retval - 1
						end
						l_lnum.item := l_lnum.item + 1
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			else
				l_retval := l_lnum.item - l_cursor
			end
			Result := l_retval
		end

	comp_botline
		local
			l_n: INTEGER_32
			l_lnum: INTEGER_32
			l_done___2: INTEGER_32
			l_last: CE_ARRAY [INTEGER_32]
			l_folded: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_last.make (<<1>>);

			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.check_cursor_moved
			update_class_fields -- Current might have been changed; synchronize
			if ((w_valid).bit_and (16)).to_boolean then
				l_lnum := w_cursor.lnum
				l_done___2 := w_cline_row
			else
				l_lnum := w_topline
				l_done___2 := 0
			end
			from
			until
				not (not (l_break) and then (l_lnum <= w_buffer.item.b_ml.ml_line_count))
			loop
				l_break := False
				l_last.item := l_lnum
				update_class_fields -- Current might have been changed; synchronize
				l_folded := 0
				l_tmp___0 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasFoldingWin (l_lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_last, 1, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					l_n := 1
					l_folded := 1
				elseif l_lnum = w_topline then
					l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win_nofill (l_lnum, 1)
					update_class_fields -- Current might have been changed; synchronize
					l_n := l_tmp + w_topfill
				else
					l_n := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win (l_lnum, 1)
					update_class_fields -- Current might have been changed; synchronize
				end
				if l_lnum <= w_cursor.lnum then
					if l_last.item >= w_cursor.lnum then
						Current.w_cline_row := l_done___2
						update_class_fields -- Current might have been changed; synchronize
						Current.w_cline_height := l_n
						update_class_fields -- Current might have been changed; synchronize
						Current.w_cline_folded := l_folded
						update_class_fields -- Current might have been changed; synchronize
						Current.w_valid := (w_valid).bit_or ((24))
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				if l_done___2 + l_n > w_height then
					l_break := True
				end
				if not (l_break) then
					l_done___2 := l_done___2 + l_n
					l_lnum := l_last.item
					l_lnum := l_lnum + 1
				end
			end
			l_break := False
			Current.w_botline := l_lnum
			update_class_fields -- Current might have been changed; synchronize
			Current.w_valid := (w_valid).bit_or ((96))
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.set_empty_rows (l_done___2)
			update_class_fields -- Current might have been changed; synchronize
		end

	check_cursor_moved
		do
			if w_cursor.lnum /= w_valid_cursor.lnum then
				Current.w_valid := (w_valid).bit_and ((-160))
				update_class_fields -- Current might have been changed; synchronize
				Current.w_valid_cursor := w_cursor.twin
				update_class_fields -- Current might have been changed; synchronize
				Current.w_valid_leftcol := w_leftcol
				update_class_fields -- Current might have been changed; synchronize
			elseif w_cursor.col /= w_valid_cursor.col then
				Current.w_valid := (w_valid).bit_and ((-8))
				update_class_fields -- Current might have been changed; synchronize
				w_valid_cursor.col := w_cursor.col
				update_class_fields -- Current might have been changed; synchronize
				Current.w_valid_leftcol := w_leftcol
				update_class_fields -- Current might have been changed; synchronize
				w_valid_cursor.coladd := w_cursor.coladd
				update_class_fields -- Current might have been changed; synchronize
			elseif w_leftcol /= w_valid_leftcol then
				Current.w_valid := (w_valid).bit_and ((-8))
				update_class_fields -- Current might have been changed; synchronize
				w_valid_cursor.col := w_cursor.col
				update_class_fields -- Current might have been changed; synchronize
				Current.w_valid_leftcol := w_leftcol
				update_class_fields -- Current might have been changed; synchronize
				w_valid_cursor.coladd := w_cursor.coladd
				update_class_fields -- Current might have been changed; synchronize
			elseif w_cursor.coladd /= w_valid_cursor.coladd then
				Current.w_valid := (w_valid).bit_and ((-8))
				update_class_fields -- Current might have been changed; synchronize
				w_valid_cursor.col := w_cursor.col
				update_class_fields -- Current might have been changed; synchronize
				Current.w_valid_leftcol := w_leftcol
				update_class_fields -- Current might have been changed; synchronize
				w_valid_cursor.coladd := w_cursor.coladd
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	changed_window_setting_win
		do
			Current.w_lines_valid := 0
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.changed_line_abv_curs_win
			update_class_fields -- Current might have been changed; synchronize
			Current.w_valid := (w_valid).bit_and ((-225))
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.redraw_win_later (40)
			update_class_fields -- Current might have been changed; synchronize
		end

	set_topline (a_lnum: INTEGER_32)
		local
			l_lnum: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_lnum.make (<<1>>)

			l_lnum.item := a_lnum
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasFoldingWin (l_lnum.item, l_lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer)).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Current.w_botline := w_botline + (l_lnum.item - w_topline)
			update_class_fields -- Current might have been changed; synchronize
			Current.w_topline := l_lnum.item
			update_class_fields -- Current might have been changed; synchronize
			Current.w_topline_was_set := (1).to_integer_8
			update_class_fields -- Current might have been changed; synchronize
			Current.w_topfill := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.w_valid := (w_valid).bit_and ((-178))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SCREEN_STATIC}).redraw_later (10)
			update_class_fields -- Current might have been changed; synchronize
		end

	changed_cline_bef_curs_win
		do
			Current.w_valid := (w_valid).bit_and ((-144))
			update_class_fields -- Current might have been changed; synchronize
		end

	changed_line_abv_curs_win
		do
			Current.w_valid := (w_valid).bit_and ((-160))
			update_class_fields -- Current might have been changed; synchronize
		end

	validate_botline_win
		do
			if not ((w_valid).bit_and (32)).to_boolean then
				((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.comp_botline
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	invalidate_botline_win
		do
			Current.w_valid := (w_valid).bit_and ((-97))
			update_class_fields -- Current might have been changed; synchronize
		end

	approximate_botline_win
		do
			Current.w_valid := (w_valid).bit_and ((-33))
			update_class_fields -- Current might have been changed; synchronize
		end

	curs_rows (a_do_botline: INTEGER_32)
		local
			l_lnum: INTEGER_32
			l_i___0: INTEGER_32
			l_all_invalid: INTEGER_32
			l_valid: INTEGER_32
			l_fold_count: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := (create {P_SCREEN_STATIC}).redrawing
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						if w_lines_valid = 0 then
							l_tmp___0 := 1
						elseif (w_lines + 0).item.wl_lnum > w_topline then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
					else
						l_tmp___0 := 1
					end
					l_all_invalid := l_tmp___0
					l_i___0 := 0
					Current.w_cline_row := 0
					update_class_fields -- Current might have been changed; synchronize
					l_lnum := w_topline
				when 1 then -- loop condition:
					if not (not (l_break) and then (l_lnum < w_cursor.lnum)) then
						l_pos := -1 + 14 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						l_valid := 0
						if not l_all_invalid.to_boolean then
							if l_i___0 < w_lines_valid then
								if (w_lines + l_i___0).item.wl_lnum < l_lnum then
									l_continue := True
								elseif not ((w_lines + l_i___0).item.wl_valid).to_boolean then
									l_continue := True
								end
								if not (l_break or l_continue) then
									if (w_lines + l_i___0).item.wl_lnum = l_lnum then
										if not (w_buffer.item.b_mod_set).to_boolean then
											l_valid := 1
										elseif (w_lines + l_i___0).item.wl_lastlnum < w_cursor.lnum then
											l_valid := 1
										elseif w_buffer.item.b_mod_top > (w_lines + l_i___0).item.wl_lastlnum + 1 then
											l_valid := 1
										end
									elseif (w_lines + l_i___0).item.wl_lnum > l_lnum then
										l_i___0 := l_i___0 - 1
									end
								end
							end
						end
						if (l_break or l_continue) then
							l_pos := -1 + 13 -- skip if block
						end
				when 3 then -- if:
						if not (l_valid.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if l_lnum = w_topline then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L___0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if (w_onebuf_opt.wo_diff).to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L___0:
						l_lnum := (w_lines + l_i___0).item.wl_lastlnum + 1
						if l_lnum > w_cursor.lnum then
							l_break := True
						end
						if not (l_break or l_continue) then
							Current.w_cline_row := w_cline_row + ((w_lines + l_i___0).item.wl_size).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L
				when 11 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						l_fold_count := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.foldedCount (l_lnum, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if l_fold_count.to_boolean then
							l_lnum := l_lnum + l_fold_count
							if l_lnum > w_cursor.lnum then
								l_break := True
							end
							if not (l_break or l_continue) then
								Current.w_cline_row := w_cline_row + 1
								update_class_fields -- Current might have been changed; synchronize
							end
						elseif l_lnum = w_topline then
							l_tmp___1 := l_lnum
							l_lnum := l_lnum + 1
							l_tmp___2 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win_nofill (l_tmp___1, 1)
							update_class_fields -- Current might have been changed; synchronize
							Current.w_cline_row := w_cline_row + (l_tmp___2 + w_topfill)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___3 := l_lnum
							l_lnum := l_lnum + 1
							l_tmp___4 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win (l_tmp___3, 1)
							update_class_fields -- Current might have been changed; synchronize
							Current.w_cline_row := w_cline_row + l_tmp___4
							update_class_fields -- Current might have been changed; synchronize
						end
				when 13 then -- if done
						if (not l_break) then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 14 then -- loop done
					l_break := False
					l_continue := False;
					((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.check_cursor_moved
					update_class_fields -- Current might have been changed; synchronize
					if ((w_valid).bit_and (8)).to_boolean then
						l_pos := -1 + 31 -- skip if block
					end
				when 15 then -- if:
						if not (l_all_invalid.to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 26 -- goto _L___3
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 18 then -- else:
						if l_i___0 /= w_lines_valid then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 26 -- goto _L___3
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 21 then -- else:
						if not (l_i___0 < w_lines_valid) then
							l_pos := -1 + 30 -- skip if block
						end
				when 22 then -- if:
						if ((w_lines + l_i___0).item.wl_valid).to_boolean then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L___3
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 25 then -- else:
						if (w_lines + l_i___0).item.wl_lnum = w_cursor.lnum then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if: | _L___3:
						if w_cursor.lnum = w_topline then
							l_tmp___5 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win_nofill (w_cursor.lnum, 1)
							update_class_fields -- Current might have been changed; synchronize
							Current.w_cline_height := l_tmp___5 + w_topfill
							update_class_fields -- Current might have been changed; synchronize
						else
							Current.w_cline_height := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win (w_cursor.lnum, 1)
							update_class_fields -- Current might have been changed; synchronize
						end
						Current.w_cline_folded := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasFoldingWin (w_cursor.lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_pos := -1 + 30 -- goto _L___2
				when 29 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else: | _L___2:
						if l_i___0 > w_lines_valid then
							Current.w_cline_height := 0
							update_class_fields -- Current might have been changed; synchronize
							Current.w_cline_folded := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasFoldingWin (w_cursor.lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
						else
							Current.w_cline_height := ((w_lines + l_i___0).item.wl_size).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							Current.w_cline_folded := ((w_lines + l_i___0).item.wl_folded).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
				when 31 then -- if done | if done | if done
					Current.w_valid := (w_valid).bit_or ((24))
					update_class_fields -- Current might have been changed; synchronize
					if a_do_botline.to_boolean then
						if l_all_invalid.to_boolean then
							((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.validate_botline_win
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				when 32 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	validate_virtcol_win
		local
			l_tmp: INTEGER_32
		do
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.check_cursor_moved
			update_class_fields -- Current might have been changed; synchronize
			if not ((w_valid).bit_and (4)).to_boolean then
				((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.getvvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_virtcol")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				Current.w_valid := (w_valid).bit_or ((4))
				update_class_fields -- Current might have been changed; synchronize
				if (w_onebuf_opt.wo_cuc).to_boolean then
					l_tmp := (create {P_POPUPMNU_STATIC}).pum_visible
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp.to_boolean then
						((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.redraw_win_later (35)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
		end

	win_col_off: INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
		do
			if (w_onebuf_opt.wo_nu).to_boolean then
				l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.number_width
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := l_tmp + 1
			elseif (w_onebuf_opt.wo_rnu).to_boolean then
				l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.number_width
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := l_tmp + 1
			else
				l_tmp___0 := 0
			end
			if (create {P_GLOBALS_STATIC}).cmdwin_type.item = 0 then
				l_tmp___1 := 0
			elseif not (c_pointer = ((create {P_GLOBALS_STATIC}).curwin.item).c_pointer) then
				l_tmp___1 := 0
			else
				l_tmp___1 := 1
			end
			l_tmp___4 := (create {P_NETBEANS_STATIC}).netbeans_active
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___4.to_boolean then
				l_tmp___3 := 2
			elseif not (w_buffer.item.b_signlist).is_void then
				l_tmp___3 := 2
			else
				l_tmp___3 := 0
			end
			Result := (((l_tmp___0 + l_tmp___1).to_integer_32 + w_onebuf_opt.wo_fdc) + l_tmp___3.to_integer_32).to_integer_32
		end

	win_col_off2: INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((w_onebuf_opt.wo_nu).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((w_onebuf_opt.wo_rnu).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_tmp___0 := (create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('n').code)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___0.is_void then
							l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.number_width
							update_class_fields -- Current might have been changed; synchronize
							Result := (l_tmp + 1)
							l_return := True
						end
				when 5 then -- if done
					if not l_return then
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_topfill (a_down: INTEGER_32)
		local
			l_n: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (w_topfill > 0) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_n := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win_nofill (w_topline, 1)
						update_class_fields -- Current might have been changed; synchronize
						if not (w_topfill + l_n > w_height) then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						if not (a_down.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if w_topline > 1 then
							Current.w_topline := w_topline - 1
							update_class_fields -- Current might have been changed; synchronize
							Current.w_topfill := 0
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						Current.w_topfill := w_height - l_n
						update_class_fields -- Current might have been changed; synchronize
						if w_topfill < 0 then
							Current.w_topfill := 0
							update_class_fields -- Current might have been changed; synchronize
						end
				when 6 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_empty_rows (a_used: INTEGER_32)
		do
			Current.w_filler_rows := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_used = 0 then
				Current.w_empty_rows := 0
				update_class_fields -- Current might have been changed; synchronize
			else
				Current.w_empty_rows := w_height - a_used
				update_class_fields -- Current might have been changed; synchronize
				if w_botline <= w_buffer.item.b_ml.ml_line_count then
					Current.w_filler_rows := (create {P_DIFF_STATIC}).diff_check_fill ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), w_botline)
					update_class_fields -- Current might have been changed; synchronize
					if w_empty_rows > w_filler_rows then
						Current.w_empty_rows := w_empty_rows - w_filler_rows
						update_class_fields -- Current might have been changed; synchronize
					else
						Current.w_filler_rows := w_empty_rows
						update_class_fields -- Current might have been changed; synchronize
						Current.w_empty_rows := 0
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
		end

	find_ident_at_pos (a_lnum: INTEGER_32; a_startcol: INTEGER_32; a_string___0: CE_POINTER [CE_POINTER [NATURAL_8]]; a_find_type: INTEGER_32): INTEGER_32
		local
			l_startcol: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_col: CE_ARRAY [INTEGER_32]
			l_i___0: INTEGER_32
			l_this_class: INTEGER_32
			l_prev_class: INTEGER_32
			l_prevcol: CE_ARRAY [INTEGER_32]
			l_bn: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___22: INTEGER_32
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			l_tmp___25: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_prevcol.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_bn.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_startcol := a_startcol
					l_col.item := 0
					update_class_fields -- Current might have been changed; synchronize
					l_this_class := 0
					l_bn.item := 0
					update_class_fields -- Current might have been changed; synchronize
					l_ptr := w_buffer.item.ml_get_buf (a_lnum, 0)
					update_class_fields -- Current might have been changed; synchronize
					if ((a_find_type).bit_and (1)).to_boolean then
						l_i___0 := 0
					else
						l_i___0 := 1
					end
				when 1 then -- loop condition:
					if not (not (l_return or l_break) and then (l_i___0 < 2)) then
						l_pos := -1 + 20 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_col.item := l_startcol
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							from
							until
								not (not (l_break) and then ((l_ptr[l_col.item]).to_integer_32 /= 0))
							loop
								l_break := False
								if ((a_find_type).bit_and (4)).to_boolean then
									if (l_ptr[l_col.item]).to_integer_32 = 93 then
										l_break := True
									end
								end
								if not (l_break) then
									l_this_class := (create {P_MBYTE_STATIC}).mb_get_class (l_ptr + l_col.item)
									update_class_fields -- Current might have been changed; synchronize
									if l_this_class /= 0 then
										if l_i___0 = 1 then
											l_break := True
										elseif l_this_class /= 1 then
											l_break := True
										end
									end
								end
								if not (l_break) then
									l_tmp := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr + l_col.item])
									update_class_fields -- Current might have been changed; synchronize
									l_col.item := l_col.item + l_tmp
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_break := False
						else
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_ptr[l_col.item]).to_integer_32 /= 0 then
									if l_i___0 = 0 then
										l_tmp___0 := (create {P_CHARSET_STATIC}).vim_iswordc ((l_ptr[l_col.item]).to_integer_32)
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___0.to_boolean then
											l_tmp___1 := 0
										else
											l_tmp___1 := 1
										end
										l_tmp___3 := l_tmp___1
									else
										if (l_ptr[l_col.item]).to_integer_32 = 32 then
											l_tmp___2 := 1
										elseif (l_ptr[l_col.item]).to_integer_32 = 9 then
											l_tmp___2 := 1
										else
											l_tmp___2 := 0
										end
										l_tmp___3 := l_tmp___2
									end
									if l_tmp___3.to_boolean then
										if ((a_find_type).bit_and (4)).to_boolean then
											if (l_ptr[l_col.item]).to_integer_32 = 93 then
												l_break := True
											end
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_col.item := l_col.item + 1
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_break := False
						end
						l_bn.item := ((l_ptr[l_col.item]).to_integer_32 = 93).to_integer
						update_class_fields -- Current might have been changed; synchronize
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 3 then -- if:
						if ((a_find_type).bit_and (4)).to_boolean then
							if (l_ptr[l_col.item]).to_integer_32 = 93 then
								l_this_class := (create {P_MBYTE_STATIC}).mb_get_class (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("a")))
								update_class_fields -- Current might have been changed; synchronize
							else
								l_this_class := (create {P_MBYTE_STATIC}).mb_get_class (l_ptr + l_col.item)
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_this_class := (create {P_MBYTE_STATIC}).mb_get_class (l_ptr + l_col.item)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 4 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 16 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						if l_col.item > 0 then
							if l_this_class = 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 15 -- skip if block
						end
				when 6 then -- if:
						l_tmp___4 := (create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_ptr, (l_ptr + l_col.item) - 1])
						update_class_fields -- Current might have been changed; synchronize
						l_prevcol.item := (l_col.item - 1) - l_tmp___4
						update_class_fields -- Current might have been changed; synchronize
						l_prev_class := (create {P_MBYTE_STATIC}).mb_get_class (l_ptr + l_prevcol.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_this_class = l_prev_class then
							l_pos := -1 + 15 -- skip if block
						end
				when 7 then -- if:
						if l_i___0 /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 10 then -- else:
						if l_prev_class /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if not (((a_find_type).bit_and (1)).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if not ((a_find_type).bit_and (4)).to_boolean then
							l_break := True
						elseif l_prevcol.item = 0 then
							l_break := True
						else
							l_tmp___5 := find_is_eval_item (l_ptr + l_prevcol.item, l_prevcol, l_bn, -1)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___5.to_boolean then
								l_break := True
							end
						end
				when 15 then -- if done | if done | if done | if done
						if not (l_break) then
							l_col.item := l_prevcol.item
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 4 -- back to loop condition
				when 16 then -- loop done
						l_break := False
						if l_this_class > 2 then
							l_this_class := 2
						end
						if not ((a_find_type).bit_and (2)).to_boolean then
							l_break := True
						elseif l_this_class = 2 then
							l_break := True
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						from
						until
							(l_break)
						loop
							l_break := False
							if l_col.item > 0 then
								if l_i___0 = 0 then
									l_tmp___6 := (create {P_CHARSET_STATIC}).vim_iswordc ((l_ptr[(l_col.item - 1)]).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___9 := l_tmp___6
								else
									if (l_ptr[(l_col.item - 1)]).to_integer_32 = 32 then
										l_tmp___8 := 0
									elseif (l_ptr[(l_col.item - 1)]).to_integer_32 = 9 then
										l_tmp___8 := 0
									elseif not ((a_find_type).bit_and (1)).to_boolean then
										l_tmp___8 := 1
									else
										l_tmp___7 := (create {P_CHARSET_STATIC}).vim_iswordc ((l_ptr[(l_col.item - 1)]).to_integer_32)
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___7.to_boolean then
											l_tmp___8 := 0
										else
											l_tmp___8 := 1
										end
									end
									l_tmp___9 := l_tmp___8
								end
								if not l_tmp___9.to_boolean then
									if ((a_find_type).bit_and (4)).to_boolean then
										if l_col.item > 1 then
											l_tmp___10 := find_is_eval_item ((l_ptr + l_col.item) - 1, l_col, l_bn, -1)
											update_class_fields -- Current might have been changed; synchronize
											if not l_tmp___10.to_boolean then
												l_break := True
											end
										else
											l_break := True
										end
									else
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_col.item := l_col.item - 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						if not ((a_find_type).bit_and (2)).to_boolean then
							l_break := True
						else
							l_tmp___11 := (create {P_CHARSET_STATIC}).vim_iswordc ((l_ptr[l_col.item]).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___11.to_boolean then
								l_break := True
							end
						end
				when 19 then -- if done
						if not (l_return or l_break) then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 20 then -- loop done
					l_break := False
					if (l_ptr[l_col.item]).to_integer_32 /= 0 then
						l_pos := -1 + 23 -- skip if block
					end
				when 21 then -- if:
						l_pos := -1 + 25 -- goto _L___0
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 23 then -- else:
						if l_i___0 /= 0 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___16 := (l_this_class /= 2).to_integer
						else
							l_tmp___14 := (create {P_CHARSET_STATIC}).vim_iswordc ((l_ptr[l_col.item]).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___14.to_boolean then
								l_tmp___15 := 0
							else
								l_tmp___15 := 1
							end
							l_tmp___16 := l_tmp___15
						end
						if not (l_tmp___16.to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 25 then -- if: | _L___0:
						if ((a_find_type).bit_and (2)).to_boolean then
							l_tmp___12 := gettext (ce_string ("E348: No string under cursor"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___12)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___13 := gettext ((create {P_NORMAL_STATIC}).e_noident.item)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___13)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						Result := 0
						l_return := True
				when 26 then -- if done | if done
					if not l_return then
						l_ptr := l_ptr + (l_col.item)
						a_string___0.item := l_ptr
						update_class_fields -- Current might have been changed; synchronize
						l_bn.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_startcol := l_startcol - (l_col.item)
						l_col.item := 0
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_this_class := (create {P_MBYTE_STATIC}).mb_get_class (l_ptr)
							update_class_fields -- Current might have been changed; synchronize
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_ptr[l_col.item]).to_integer_32 /= 0 then
									if l_i___0 = 0 then
										l_tmp___18 := (create {P_MBYTE_STATIC}).mb_get_class (l_ptr + l_col.item)
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___20 := (l_tmp___18 = l_this_class).to_integer
									else
										l_tmp___19 := (create {P_MBYTE_STATIC}).mb_get_class (l_ptr + l_col.item)
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___20 := (l_tmp___19 /= 0).to_integer
									end
									if not l_tmp___20.to_boolean then
										if ((a_find_type).bit_and (4)).to_boolean then
											if l_col.item <= l_startcol then
												l_tmp___21 := find_is_eval_item (l_ptr + l_col.item, l_col, l_bn, 1)
												update_class_fields -- Current might have been changed; synchronize
												if not l_tmp___21.to_boolean then
													l_break := True
												end
											else
												l_break := True
											end
										else
											l_break := True
										end
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									l_tmp___17 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr + l_col.item])
									update_class_fields -- Current might have been changed; synchronize
									l_col.item := l_col.item + l_tmp___17
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_break := False
						else
							from
							until
								(l_break)
							loop
								l_break := False
								if l_i___0 = 0 then
									l_tmp___22 := (create {P_CHARSET_STATIC}).vim_iswordc ((l_ptr[l_col.item]).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___24 := l_tmp___22
								else
									if (l_ptr[l_col.item]).to_integer_32 /= 0 then
										if (l_ptr[l_col.item]).to_integer_32 = 32 then
											l_tmp___23 := 0
										elseif (l_ptr[l_col.item]).to_integer_32 = 9 then
											l_tmp___23 := 0
										else
											l_tmp___23 := 1
										end
									else
										l_tmp___23 := 0
									end
									l_tmp___24 := l_tmp___23
								end
								if not l_tmp___24.to_boolean then
									if ((a_find_type).bit_and (4)).to_boolean then
										if l_col.item <= l_startcol then
											l_tmp___25 := find_is_eval_item (l_ptr + l_col.item, l_col, l_bn, 1)
											update_class_fields -- Current might have been changed; synchronize
											if not l_tmp___25.to_boolean then
												l_break := True
											end
										else
											l_break := True
										end
									else
										l_break := True
									end
								end
								if not (l_return or l_break) then
									l_col.item := l_col.item + 1
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_break := False
						end
						Result := (l_col.item)
					end
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_colorcolumn: CE_POINTER [NATURAL_8]
		local
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_col: INTEGER_32
			l_count___2: INTEGER_32
			l_color_cols: CE_ARRAY [INTEGER_32]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_color_cols.make (<<256>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := 0
					l_j := 0
					l_s.item := w_onebuf_opt.wo_cc
					update_class_fields -- Current might have been changed; synchronize
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 16 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if (l_s.item.item).to_integer_32 /= 0 then
							if not (l_count___2 < 255) then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 15 -- skip if block
						end
				when 3 then -- if:
						if (l_s.item.item).to_integer_32 /= 45 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 6 then -- else:
						if (l_s.item.item).to_integer_32 /= 43 then
							l_pos := -1 + 11 -- skip if block
						end
				when 7 then -- if: | _L:
						if (l_s.item.item).to_integer_32 = 45 then
							l_col := -1
						else
							l_col := 1
						end
						l_s.item := l_s.item + 1
						update_class_fields -- Current might have been changed; synchronize
						if (l_s.item.item).to_integer_32 >= 48 then
							if not ((l_s.item.item).to_integer_32 <= 57) then
								Result := ((create {P_GLOBALS_STATIC}).e_invarg.item)
								l_return := True
							end
						else
							Result := ((create {P_GLOBALS_STATIC}).e_invarg.item)
							l_return := True
						end
						if l_return then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_tmp := (create {P_CHARSET_STATIC}).getdigits (l_s)
						update_class_fields -- Current might have been changed; synchronize
						l_col := (l_col.to_integer_32 * l_tmp).to_integer_32
						if w_buffer.item.b_p_tw = 0 then
							l_pos := -1 + 14 -- goto skip
						end
				when 9 then
						l_col := (l_col.to_integer_32 + w_buffer.item.b_p_tw).to_integer_32
						if l_col < 0 then
							l_pos := -1 + 14 -- goto skip
						end
				when 10 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						if (l_s.item.item).to_integer_32 >= 48 then
							if (l_s.item.item).to_integer_32 <= 57 then
								l_tmp___0 := (create {P_CHARSET_STATIC}).getdigits (l_s)
								update_class_fields -- Current might have been changed; synchronize
								l_col := l_tmp___0.to_integer_32
							else
								Result := ((create {P_GLOBALS_STATIC}).e_invarg.item)
								l_return := True
							end
						else
							Result := ((create {P_GLOBALS_STATIC}).e_invarg.item)
							l_return := True
						end
				when 12 then -- if done
						if l_return then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_tmp___1 := l_count___2
						l_count___2 := l_count___2 + 1
						l_color_cols[l_tmp___1] := l_col - 1
						update_class_fields -- Current might have been changed; synchronize
				when 14 then -- skip:
						if (l_s.item.item).to_integer_32 = 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							if (l_s.item.item).to_integer_32 /= 44 then
								Result := ((create {P_GLOBALS_STATIC}).e_invarg.item)
								l_return := True
							end
							if not l_return then
								l_s.item := l_s.item + 1
								update_class_fields -- Current might have been changed; synchronize
								if (l_s.item.item).to_integer_32 = 0 then
									Result := ((create {P_GLOBALS_STATIC}).e_invarg.item)
									l_return := True
								end
							end
						end
				when 15 then -- if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 16 then -- loop done
					if not l_return then
						l_break := False;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (w_p_cc_cols))
						update_class_fields -- Current might have been changed; synchronize
						if l_count___2 = 0 then
							Current.w_p_cc_cols := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___2 := (create {P_MISC2_STATIC}).alloc ({PLATFORM}.Integer_32_bytes.to_natural_32 * (l_count___2 + 1).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							Current.w_p_cc_cols := create {CE_INTEGER_32_POINTER}.make_cast (l_tmp___2)
							update_class_fields -- Current might have been changed; synchronize
							if not w_p_cc_cols.is_void then
								qsort (create {CE_VOID_POINTER}.make_cast (l_color_cols), l_count___2.to_natural_32, {PLATFORM}.Integer_32_bytes.to_natural_32, (create {P_OPTION_STATIC}).int_cmp_address)
								update_class_fields -- Current might have been changed; synchronize
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_count___2)
								loop
									if l_j = 0 then
										l_tmp___3 := l_j
										l_j := l_j + 1
										w_p_cc_cols[l_tmp___3] := l_color_cols[l_i___0]
										update_class_fields -- Current might have been changed; synchronize
									elseif w_p_cc_cols[(l_j - 1)] /= l_color_cols[l_i___0] then
										l_tmp___3 := l_j
										l_j := l_j + 1
										w_p_cc_cols[l_tmp___3] := l_color_cols[l_i___0]
										update_class_fields -- Current might have been changed; synchronize
									end
									l_i___0 := l_i___0 + 1
								end
								w_p_cc_cols[l_j] := -1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ll_get_or_alloc_list: CE_POINTER [PD_QF_INFO_S]
		local
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_tmp := w_buffer.item.bt_quickfix
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				if not w_llist_ref.is_void then
					Result := w_llist_ref
					l_return := True
				end
			end
			if not l_return then
				(create {P_QUICKFIX_STATIC}).ll_free_all (create {CE_POINTER_POINTER [PD_QF_INFO_S]}.make_shared (c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_llist_ref")))
				update_class_fields -- Current might have been changed; synchronize
				if w_llist.is_void then
					Current.w_llist := (create {P_QUICKFIX_STATIC}).ll_new_list
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := w_llist
			end
		end

	copy_loclist (a_to: CE_POINTER [PD_WINDOW_S])
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_idx: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [PD_QF_INFO_S]
			l_from_qfl: CE_POINTER [PD_QF_LIST_S]
			l_to_qfl: CE_POINTER [PD_QF_LIST_S]
			l_from_qfp: CE_POINTER [PD_QFLINE_S]
			l_prevp: CE_ARRAY [CE_POINTER [PD_QFLINE_S]]
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_QFLINE_S]} l_prevp.make (<<1>>)

			l_tmp := w_buffer.item.bt_quickfix
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				if not w_llist_ref.is_void then
					l_qi := w_llist_ref
				else
					l_qi := w_llist
				end
			else
				l_qi := w_llist
			end
			if l_qi.is_void then
				l_return := True
			end
			if not l_return then
				l_tmp___0 := (create {P_QUICKFIX_STATIC}).ll_new_list
				update_class_fields -- Current might have been changed; synchronize
				a_to.item.w_llist := l_tmp___0
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.is_void then
					l_return := True
				end
			end
			if not l_return then
				(a_to.item.w_llist).item.qf_listcount := l_qi.item.qf_listcount
				update_class_fields -- Current might have been changed; synchronize
				l_idx := 0
				from
				until
					not (not (l_return) and then (l_idx < l_qi.item.qf_listcount))
				loop
					(a_to.item.w_llist).item.qf_curlist := l_idx
					update_class_fields -- Current might have been changed; synchronize
					l_from_qfl := create {CE_CLASS_POINTER [PD_QF_LIST_S]}.make_shared (l_qi.c_pointer + (create {PD_QF_INFO_S}.make).offset_of ("qf_lists") + (create {PD_QF_LIST_S}.make).structure_size * (l_idx))
					l_to_qfl := create {CE_CLASS_POINTER [PD_QF_LIST_S]}.make_shared ((a_to.item.w_llist).c_pointer + (create {PD_QF_INFO_S}.make).offset_of ("qf_lists") + (create {PD_QF_LIST_S}.make).structure_size * (l_idx))
					l_to_qfl.item.qf_nonevalid := l_from_qfl.item.qf_nonevalid
					update_class_fields -- Current might have been changed; synchronize
					l_to_qfl.item.qf_count := 0
					update_class_fields -- Current might have been changed; synchronize
					l_to_qfl.item.qf_index := 0
					update_class_fields -- Current might have been changed; synchronize
					l_to_qfl.item.qf_start := create {CE_CLASS_POINTER [PD_QFLINE_S]}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					l_to_qfl.item.qf_ptr := create {CE_CLASS_POINTER [PD_QFLINE_S]}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
					if not (l_from_qfl.item.qf_title).is_void then
						l_to_qfl.item.qf_title := (create {P_MISC2_STATIC}).vim_strsave (l_from_qfl.item.qf_title)
						update_class_fields -- Current might have been changed; synchronize
					else
						l_to_qfl.item.qf_title := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
					end
					if (l_from_qfl.item.qf_count).to_boolean then
						l_prevp.item := create {CE_CLASS_POINTER [PD_QFLINE_S]}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_i___0 := 0
						l_from_qfp := l_from_qfl.item.qf_start
						from
						until
							not (not (l_return) and then (l_i___0 < l_from_qfl.item.qf_count))
						loop
							l_tmp___1 := (create {P_QUICKFIX_STATIC}).qf_add_entry (a_to.item.w_llist, l_prevp, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, l_from_qfp.item.qf_text, l_from_qfp.item.qf_lnum, l_from_qfp.item.qf_col, (l_from_qfp.item.qf_viscol).to_integer_32, l_from_qfp.item.qf_pattern, l_from_qfp.item.qf_nr, 0, (l_from_qfp.item.qf_valid).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___1 = 0 then
								qf_free_all (a_to)
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							end
							if not l_return then
								l_prevp.item.item.qf_fnum := l_from_qfp.item.qf_fnum
								update_class_fields -- Current might have been changed; synchronize
								l_prevp.item.item.qf_type := l_from_qfp.item.qf_type
								update_class_fields -- Current might have been changed; synchronize
								if (l_from_qfl.item.qf_ptr).is_equal (l_from_qfp) then
									l_to_qfl.item.qf_ptr := l_prevp.item
									update_class_fields -- Current might have been changed; synchronize
								end
								l_i___0 := l_i___0 + 1
								l_from_qfp := l_from_qfp.item.qf_next
							end
						end
					end
					if not l_return then
						l_to_qfl.item.qf_index := l_from_qfl.item.qf_index
						update_class_fields -- Current might have been changed; synchronize
						if l_to_qfl.item.qf_nonevalid = 1 then
							l_to_qfl.item.qf_ptr := l_to_qfl.item.qf_start
							update_class_fields -- Current might have been changed; synchronize
						end
						l_idx := l_idx + 1
					end
				end
			end
			if not l_return then
				(a_to.item.w_llist).item.qf_curlist := l_qi.item.qf_curlist
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	qf_current_entry: INTEGER_32
		local
			l_qi: CE_POINTER [PD_QF_INFO_S]
			l_tmp: INTEGER_32
		do
			l_qi := (create {P_QUICKFIX_STATIC}).ql_info.item
			l_tmp := w_buffer.item.bt_quickfix
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				if not w_llist_ref.is_void then
					l_qi := w_llist_ref
				end
			end
			Result := (l_qi.item.qf_lists[l_qi.item.qf_curlist].qf_index).to_integer_32
		end

	is_qf_win (a_qi: CE_POINTER [PD_QF_INFO_S]): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := w_buffer.item.bt_quickfix
					update_class_fields -- Current might have been changed; synchronize
					if not (l_tmp.to_boolean) then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if not (a_qi.is_equal ((create {P_QUICKFIX_STATIC}).ql_info.item)) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if w_llist_ref.is_void then
							Result := 1
							l_return := True
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if not a_qi.is_equal ((create {P_QUICKFIX_STATIC}).ql_info.item) then
							if w_llist_ref.is_equal (a_qi) then
								Result := 1
								l_return := True
							end
						end
				when 5 then -- if done
					if not l_return then
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	redraw_win_later (a_type: INTEGER_32)
		do
			if w_redr_type < a_type then
				Current.w_redr_type := a_type
				update_class_fields -- Current might have been changed; synchronize
				if a_type >= 40 then
					Current.w_lines_valid := 0
					update_class_fields -- Current might have been changed; synchronize
				end
				if (create {P_GLOBALS_STATIC}).must_redraw.item < a_type then
					(create {P_GLOBALS_STATIC}).must_redraw.item := a_type
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	win_update
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_type: INTEGER_32
			l_top_end: INTEGER_32
			l_mid_start: INTEGER_32
			l_mid_end: INTEGER_32
			l_bot_start: INTEGER_32
			l_scrolled_down: INTEGER_32
			l_cur: CE_POINTER [PD_MATCHITEM]
			l_top_to_mod: INTEGER_32
			l_row: INTEGER_32
			l_lnum: INTEGER_32
			l_idx: INTEGER_32
			l_srow: INTEGER_32
			l_eof: INTEGER_32
			l_didline: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_old_botline: INTEGER_32
			l_fold_count: INTEGER_32
			l_did_update: INTEGER_32
			l_syntax_last_parsed: INTEGER_32
			l_mod_top: CE_ARRAY [INTEGER_32]
			l_mod_bot: CE_ARRAY [INTEGER_32]
			l_save_got_int: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_lnumt: INTEGER_32
			l_lnumb: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_ln: CE_ARRAY [INTEGER_32]
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_from: INTEGER_32
			l_to: INTEGER_32
			l_fromc: CE_ARRAY [INTEGER_32]
			l_toc: CE_ARRAY [INTEGER_32]
			l_old_rows: INTEGER_32
			l_new_rows: INTEGER_32
			l_xtra_rows: INTEGER_32
			l_l: CE_ARRAY [INTEGER_32]
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_x___0: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___22: INTEGER_32
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			l_tmp___25: INTEGER_32
			l_tmp___26: INTEGER_32
			l_tmp___27: INTEGER_32
			l_tmp___28: INTEGER_32
			l_tmp___29: INTEGER_32
			l_tmp___30: INTEGER_32
			l_tmp___31: INTEGER_32
			l_tmp___32: INTEGER_32
			l_tmp___33: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_mod_top.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_mod_bot.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_ln.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_fromc.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_toc.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6 := w_buffer
					l_top_end := 0
					l_mid_start := 999
					l_mid_end := 0
					l_bot_start := 999
					l_scrolled_down := 0
					l_top_to_mod := 0
					l_eof := 0
					l_didline := 0
					l_old_botline := w_botline.to_integer_32
					l_did_update := 1
					l_syntax_last_parsed := (0).to_integer_32
					l_mod_top.item := (0).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_mod_bot.item := (0).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_type := w_redr_type
					if l_type = 40 then
						Current.w_redr_status := 1
						update_class_fields -- Current might have been changed; synchronize
						Current.w_lines_valid := 0
						update_class_fields -- Current might have been changed; synchronize
					end
					if w_height = 0 then
						Current.w_redr_type := 0
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return and then (w_width = 0) then
						((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.draw_vsep_win (0)
						update_class_fields -- Current might have been changed; synchronize
						Current.w_redr_type := 0
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if l_return then
						l_pos := -1 + 155 -- skip if block
					end
				when 1 then -- if:;
						((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.init_search_hl
						update_class_fields -- Current might have been changed; synchronize
						if (w_onebuf_opt.wo_nu).to_boolean then
							l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.number_width
							update_class_fields -- Current might have been changed; synchronize
							l_i___0 := l_tmp
						elseif (w_onebuf_opt.wo_rnu).to_boolean then
							l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.number_width
							update_class_fields -- Current might have been changed; synchronize
							l_i___0 := l_tmp
						else
							l_i___0 := 0
						end
						if w_nrwidth = l_i___0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_type := 40
						Current.w_nrwidth := l_i___0
						update_class_fields -- Current might have been changed; synchronize
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 4 then -- else:
						if not ((l_buf___6.item.b_mod_set).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_buf___6.item.b_mod_xlines /= 0 then
							if w_redraw_top /= 0 then
								l_type := 40
							else
								l_pos := -1 + 7 -- goto _L___2
							end
						else
							l_pos := -1 + 7 -- goto _L___2
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 7 then -- else: | _L___2:
						l_mod_top.item := w_redraw_top
						update_class_fields -- Current might have been changed; synchronize
						if w_redraw_bot /= 0 then
							l_mod_bot.item := w_redraw_bot + 1
							update_class_fields -- Current might have been changed; synchronize
						else
							l_mod_bot.item := (0).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
						Current.w_redraw_top := (0).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						Current.w_redraw_bot := (0).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						if not ((l_buf___6.item.b_mod_set).to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 8 then -- if:
						if l_mod_top.item /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not (l_mod_top.item > l_buf___6.item.b_mod_top) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						l_mod_top.item := l_buf___6.item.b_mod_top
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.syntax_present
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0.to_boolean then
							l_mod_top.item := l_mod_top.item - (l_buf___6.item.b_s.b_syn_sync_linebreaks)
							update_class_fields -- Current might have been changed; synchronize
							if l_mod_top.item < 1 then
								l_mod_top.item := (1).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 13 then -- if done
						if l_mod_bot.item = 0 then
							l_mod_bot.item := l_buf___6.item.b_mod_bot
							update_class_fields -- Current might have been changed; synchronize
						elseif l_mod_bot.item < l_buf___6.item.b_mod_bot then
							l_mod_bot.item := l_buf___6.item.b_mod_bot
							update_class_fields -- Current might have been changed; synchronize
						end
						if ((create {P_SCREEN_STATIC}).search_hl.item.item.rm.regprog).is_void then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_tmp___2 := ((create {P_SCREEN_STATIC}).search_hl.item.item.rm.regprog).item.re_multiline
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2.to_boolean then
							l_top_to_mod := 1
						else
							l_pos := -1 + 16 -- goto _L___0
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L___0:
						l_cur := w_match_head
						from
						until
							not (not (l_break) and then (not l_cur.is_void))
						loop
							l_break := False
							if not (l_cur.item.match.regprog).is_void then
								l_tmp___1 := (l_cur.item.match.regprog).item.re_multiline
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___1.to_boolean then
									l_top_to_mod := 1
									l_break := True
								end
							end
							if not (l_break) then
								l_cur := l_cur.item.next
							end
						end
						l_break := False
				when 17 then -- if done
						if l_mod_top.item /= 0 then
							l_tmp___3 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasAnyFolding
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___3.to_boolean then
								l_lnumt := w_topline
								l_lnumb := 2_147_483_647
								l_i___0 := 0
								from
								until
									not (l_i___0 < w_lines_valid)
								loop
									if ((w_lines + l_i___0).item.wl_valid).to_boolean then
										if (w_lines + l_i___0).item.wl_lastlnum < l_mod_top.item then
											l_lnumt := (w_lines + l_i___0).item.wl_lastlnum + 1
										end
										if l_lnumb = 2_147_483_647 then
											if (w_lines + l_i___0).item.wl_lnum >= l_mod_bot.item then
												l_lnumb := (w_lines + l_i___0).item.wl_lnum
												if w_onebuf_opt.wo_fdc > 0 then
													l_lnumb := l_lnumb + 1
												end
											end
										end
									end
									l_i___0 := l_i___0 + 1
								end
								((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasFoldingWin (l_mod_top.item, l_mod_top, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer)).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								if l_mod_top.item > l_lnumt then
									l_mod_top.item := l_lnumt
									update_class_fields -- Current might have been changed; synchronize
								end
								l_mod_bot.item := l_mod_bot.item - 1
								update_class_fields; -- Current might have been changed; synchronize
								((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasFoldingWin (l_mod_bot.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_mod_bot, 1, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer)).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_mod_bot.item := l_mod_bot.item + 1
								update_class_fields -- Current might have been changed; synchronize
								if l_mod_bot.item < l_lnumb then
									l_mod_bot.item := l_lnumb
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if l_mod_top.item /= 0 then
							if l_mod_top.item < w_topline then
								if l_mod_bot.item > w_topline then
									l_mod_top.item := w_topline
									update_class_fields -- Current might have been changed; synchronize
								else
									l_tmp___4 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.syntax_present
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___4.to_boolean then
										l_top_end := 1
									end
								end
							end
						end
						if l_mod_top.item /= 0 then
							if l_buf___6.item.b_mod_xlines /= 0 then
								if (w_onebuf_opt.wo_nu).to_boolean then
									l_mod_bot.item := 2_147_483_647
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
				when 18 then -- if done
						if l_type = 30 then
							l_j := 0
							l_i___0 := 0
							from
							until
								not (not (l_break) and then (l_i___0 < w_lines_valid))
							loop
								l_break := False
								l_j := l_j + ((w_lines + l_i___0).item.wl_size).to_integer_32
								if l_j >= w_upd_rows.to_integer_32 then
									l_top_end := l_j.to_integer_32
									l_break := True
								end
								if not (l_break) then
									l_i___0 := l_i___0 + 1
								end
							end
							l_break := False
							if l_top_end = 0 then
								l_type := 40
							else
								l_type := 10
							end
						end
						if ((create {P_GLOBALS_STATIC}).screen_cleared.item).to_boolean then
							(create {P_GLOBALS_STATIC}).screen_cleared.item := 2
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_type /= 10 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 28 -- goto _L___7
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 60
				when 21 then -- else:
						if l_type /= 35 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 28 -- goto _L___7
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 60
				when 24 then -- else:
						if l_type /= 20 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L___7
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 60
				when 27 then -- else:
						if l_type /= 25 then
							l_pos := -1 + 59 -- skip if block
						end
				when 28 then -- if: | _L___7:
						if w_botfill.to_boolean then
							l_pos := -1 + 57 -- skip if block
						end
				when 29 then -- if:
						if w_old_botfill.to_boolean then
							l_pos := -1 + 55 -- skip if block
						end
				when 30 then -- if:
						if l_mod_top.item = 0 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						if w_topline /= l_mod_top.item then
							l_pos := -1 + 33 -- goto _L___6
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 33 then -- else: | _L___6:
						if not (((w_lines + 0).item.wl_valid).to_boolean) then
							l_pos := -1 + 45 -- skip if block
						end
				when 34 then -- if:
						if not (w_topline < (w_lines + 0).item.wl_lnum) then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_pos := -1 + 39 -- goto _L___5
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 37 then -- else:
						if w_topline /= (w_lines + 0).item.wl_lnum then
							l_pos := -1 + 43 -- skip if block
						end
				when 38 then -- if:
						if not (w_topfill > w_old_topfill) then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if: | _L___5:
						l_tmp___5 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasAnyFolding
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___5.to_boolean then
							l_j := 0
							l_ln.item := w_topline
							update_class_fields -- Current might have been changed; synchronize
							from
							until
								not (not (l_break) and then (l_ln.item < (w_lines + 0).item.wl_lnum))
							loop
								l_break := False
								l_j := l_j + 1
								if l_j >= (w_height - 2).to_integer_32 then
									l_break := True
								end
								if not (l_break) then
									((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasFoldingWin (l_ln.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_ln, 1, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer)).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									l_ln.item := l_ln.item + 1
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_break := False
						else
							l_j := (w_lines + 0).item.wl_lnum - w_topline
						end
						if l_j < (w_height - 2).to_integer_32 then
							l_i___0 := plines_m_win ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), w_topline, (w_lines + 0).item.wl_lnum - 1)
							update_class_fields -- Current might have been changed; synchronize
							if (w_lines + 0).item.wl_lnum /= w_topline then
								l_tmp___6 := (create {P_DIFF_STATIC}).diff_check_fill ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), (w_lines + 0).item.wl_lnum)
								update_class_fields -- Current might have been changed; synchronize
								l_i___0 := l_i___0 + (l_tmp___6 - w_old_topfill)
							end
							if l_i___0 < w_height - 2 then
								if l_i___0 > 0 then
									(create {P_SCREEN_STATIC}).check_for_delay (0)
									update_class_fields -- Current might have been changed; synchronize
								end
								l_tmp___9 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_ins_lines (0, l_i___0, 0, ((c_pointer = ((create {P_GLOBALS_STATIC}).firstwin.item).c_pointer)).to_integer)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___9 = 1 then
									if w_lines_valid /= 0 then
										l_top_end := l_i___0
										l_scrolled_down := 1
										l_tmp___7 := (w_lines_valid.to_integer_32 + l_j).to_integer_32
										Current.w_lines_valid := l_tmp___7
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___7 > w_height then
											Current.w_lines_valid := w_height
											update_class_fields -- Current might have been changed; synchronize
										end
										l_idx := w_lines_valid
										from
										until
											not (l_idx.to_integer_32 - l_j >= 0)
										loop
											w_lines[l_idx] := (w_lines[(l_idx.to_integer_32 - l_j)]).twin
											update_class_fields -- Current might have been changed; synchronize
											l_idx := l_idx - 1
										end
										from
										until
											not (l_idx >= 0)
										loop
											l_tmp___8 := l_idx
											l_idx := l_idx - 1;
											(w_lines + l_tmp___8).item.wl_valid := (0).to_integer_8
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								else
									l_mid_start := 0
								end
							else
								l_mid_start := 0
							end
						else
							l_mid_start := 0
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else:
						l_pos := -1 + 45 -- goto _L___4
				when 42 then -- if done | if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else:
						l_pos := -1 + 45 -- goto _L___4
				when 44 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 53
				when 45 then -- else: | _L___4:
						l_j := -1
						l_row := 0
						l_i___0 := 0
						from
						until
							not (not (l_break) and then (l_i___0 < w_lines_valid))
						loop
							l_break := False
							if ((w_lines + l_i___0).item.wl_valid).to_boolean then
								if (w_lines + l_i___0).item.wl_lnum = w_topline then
									l_j := l_i___0.to_integer_32
									l_break := True
								end
							end
							if not (l_break) then
								l_row := l_row + ((w_lines + l_i___0).item.wl_size).to_integer_32
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						if l_j /= -1 then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						l_mid_start := 0
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 48 then -- else:
						if (w_lines + 0).item.wl_lnum = w_topline then
							l_row := l_row + w_old_topfill
						else
							l_tmp___10 := (create {P_DIFF_STATIC}).diff_check_fill ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), w_topline)
							update_class_fields -- Current might have been changed; synchronize
							l_row := l_row + l_tmp___10
						end
						l_row := l_row - w_topfill
						if l_row > 0 then
							(create {P_SCREEN_STATIC}).check_for_delay (0)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___11 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_del_lines (0, l_row, 0, ((c_pointer = ((create {P_GLOBALS_STATIC}).firstwin.item).c_pointer)).to_integer)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___11 = 1 then
								l_bot_start := w_height - l_row
							else
								l_mid_start := 0
							end
						end
						if l_row /= 0 then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						l_pos := -1 + 52 -- goto _L___3
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 51 then -- else:
						if not (l_bot_start < 999) then
							l_pos := -1 + 53 -- skip if block
						end
				when 52 then -- if: | _L___3:
						if w_lines_valid /= 0 then
							l_bot_start := 0
							l_idx := 0
							from
							until
								(l_break)
							loop
								l_break := False
								w_lines[l_idx] := (w_lines[l_j]).twin
								update_class_fields -- Current might have been changed; synchronize
								if l_row > 0 then
									if (l_bot_start + l_row) + ((w_lines + l_j).item.wl_size).to_integer_32 > w_height then
										Current.w_lines_valid := l_idx + 1
										update_class_fields -- Current might have been changed; synchronize
										l_break := True
									end
								end
								if not (l_break) then
									l_tmp___12 := l_idx
									l_idx := l_idx + 1
									l_bot_start := l_bot_start + ((w_lines + l_tmp___12).item.wl_size).to_integer_32
									l_j := l_j + 1
									if l_j >= w_lines_valid.to_integer_32 then
										Current.w_lines_valid := l_idx
										update_class_fields -- Current might have been changed; synchronize
										l_break := True
									end
								end
							end
							l_break := False
							if (w_onebuf_opt.wo_diff).to_boolean then
								if l_bot_start > 0 then
									l_tmp___13 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win_nofill (w_topline, 1)
									update_class_fields; -- Current might have been changed; synchronize
									(w_lines + 0).item.wl_size := (l_tmp___13 + w_topfill).to_natural_16
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
				when 53 then -- if done | if done | if done | if done
						if l_mid_start = 0 then
							l_mid_end := w_height
							if ((create {P_GLOBALS_STATIC}).lastwin.item).is_equal ((create {P_GLOBALS_STATIC}).firstwin.item) then
								if (create {P_GLOBALS_STATIC}).screen_cleared.item /= 1 then
									(create {P_SCREEN_STATIC}).screenclear
									update_class_fields -- Current might have been changed; synchronize
								end
								if ((create {P_GLOBALS_STATIC}).redraw_tabline.item).to_boolean then
									(create {P_SCREEN_STATIC}).draw_tabline
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if (create {P_GLOBALS_STATIC}).screen_cleared.item = 1 then
							(create {P_GLOBALS_STATIC}).must_redraw.item := 0
							update_class_fields -- Current might have been changed; synchronize
						end
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 56
				when 55 then -- else:
						l_mid_start := 0
						l_mid_end := w_height
				when 56 then -- if done | if block done, skip else block:
						l_pos := -1 + 58
				when 57 then -- else:
						l_mid_start := 0
						l_mid_end := w_height
				when 58 then -- if done | if block done, skip else block:
						l_pos := -1 + 60
				when 59 then -- else:
						l_mid_start := 0
						l_mid_end := w_height
				when 60 then -- if done | if done | if done
						if l_type = 35 then
							l_mid_start := 0
							l_mid_end := w_height
							l_type := 40
						end
						if not (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						if l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer) then
							l_pos := -1 + 65 -- goto _L___12
						else
							l_pos := -1 + 63 -- goto _L___13
						end
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 90
				when 63 then -- else: | _L___13:
						if w_old_cursor_lnum = 0 then
							l_pos := -1 + 90 -- skip if block
						end
				when 64 then -- if:
						if l_type = 40 then
							l_pos := -1 + 90 -- skip if block
						end
				when 65 then -- if: | _L___12:
						if not (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
							l_pos := -1 + 88 -- skip if block
						end
				when 66 then -- if:
						if not (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
							l_pos := -1 + 75 -- skip if block
						end
				when 67 then -- if:
						if (create {P_GLOBALS_STATIC}).VIsual_mode.item = w_old_visual_mode.to_integer_32 then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						l_pos := -1 + 71 -- goto _L___10
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 74
				when 70 then -- else:
						if l_type /= 25 then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if: | _L___10:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum then
							l_from := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
							l_to := (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum
						else
							l_from := (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum
							l_to := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
						end
						if w_old_cursor_lnum < l_from then
							l_from := w_old_cursor_lnum
						end
						if w_old_cursor_lnum > l_to then
							l_to := w_old_cursor_lnum
						end
						if w_old_visual_lnum < l_from then
							l_from := w_old_visual_lnum
						end
						if w_old_visual_lnum > l_to then
							l_to := w_old_visual_lnum
						end
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 74
				when 73 then -- else:
						l_pos := -1 + 75 -- goto _L___9
				when 74 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 80
				when 75 then -- else: | _L___9:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < w_old_cursor_lnum then
							l_from := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
							l_to := w_old_cursor_lnum
						else
							l_from := w_old_cursor_lnum
							l_to := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
							if l_from = 0 then
								l_from := l_to
							end
						end
						if (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum = w_old_visual_lnum then
							l_pos := -1 + 78 -- skip if block
						end
				when 76 then -- if:
						l_pos := -1 + 79 -- goto _L___8
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 80
				when 78 then -- else:
						if (create {P_GLOBALS_STATIC}).VIsual.item.item.col = w_old_visual_col then
							l_pos := -1 + 80 -- skip if block
						end
				when 79 then -- if: | _L___8:
						if w_old_visual_lnum < l_from then
							if w_old_visual_lnum /= 0 then
								l_from := w_old_visual_lnum
							end
						end
						if w_old_visual_lnum > l_to then
							l_to := w_old_visual_lnum
						end
						if (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum < l_from then
							l_from := (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum
						end
						if (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum > l_to then
							l_to := (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum
						end
				when 80 then -- if done | if done
						if (create {P_GLOBALS_STATIC}).VIsual_mode.item /= 22 then
							l_pos := -1 + 87 -- skip if block
						end
				when 81 then -- if:;
						((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.getvcols ((create {P_GLOBALS_STATIC}).VIsual.item, create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), l_fromc, l_toc)
						update_class_fields -- Current might have been changed; synchronize
						l_toc.item := l_toc.item + 1
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant).to_integer_32 = 2_147_483_647 then
							l_toc.item := (2_147_483_647).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_fromc.item = w_old_cursor_fcol then
							l_pos := -1 + 84 -- skip if block
						end
				when 82 then -- if:
						l_pos := -1 + 85 -- goto _L___11
				when 83 then -- if block done, skip else block:
						l_pos := -1 + 86
				when 84 then -- else:
						if l_toc.item = w_old_cursor_lcol then
							l_pos := -1 + 86 -- skip if block
						end
				when 85 then -- if: | _L___11:
						if l_from > (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum then
							l_from := (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum
						end
						if l_to < (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum then
							l_to := (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum
						end
				when 86 then -- if done
						Current.w_old_cursor_fcol := l_fromc.item
						update_class_fields -- Current might have been changed; synchronize
						Current.w_old_cursor_lcol := l_toc.item
						update_class_fields -- Current might have been changed; synchronize
				when 87 then -- if done | if block done, skip else block:
						l_pos := -1 + 89
				when 88 then -- else:
						if w_old_cursor_lnum < w_old_visual_lnum then
							l_from := w_old_cursor_lnum
							l_to := w_old_visual_lnum
						else
							l_from := w_old_visual_lnum
							l_to := w_old_cursor_lnum
						end
				when 89 then -- if done
						if l_from < w_topline then
							l_from := w_topline
						end
						if ((w_valid).bit_and (32)).to_boolean then
							if l_from >= w_botline then
								l_from := w_botline - 1
							end
							if l_to >= w_botline then
								l_to := w_botline - 1
							end
						end
						if l_mid_start > 0 then
							l_lnum := w_topline
							l_idx := 0
							l_srow := 0
							if l_scrolled_down.to_boolean then
								l_mid_start := l_top_end
							else
								l_mid_start := 0
							end
							from
							until
								(l_break)
							loop
								l_break := False
								if l_lnum < l_from then
									if not (l_idx < w_lines_valid) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									if ((w_lines + l_idx).item.wl_valid).to_boolean then
										l_mid_start := l_mid_start + ((w_lines + l_idx).item.wl_size).to_integer_32
									elseif not l_scrolled_down.to_boolean then
										l_srow := l_srow + ((w_lines + l_idx).item.wl_size).to_integer_32
									end
									l_idx := l_idx + 1
									if l_idx < w_lines_valid then
										if ((w_lines + l_idx).item.wl_valid).to_boolean then
											l_lnum := (w_lines + l_idx).item.wl_lnum
										else
											l_lnum := l_lnum + 1
										end
									else
										l_lnum := l_lnum + 1
									end
								end
							end
							l_break := False
							l_srow := l_srow + l_mid_start
							l_mid_end := w_height
							from
							until
								not (not (l_break) and then (l_idx < w_lines_valid))
							loop
								l_break := False
								if ((w_lines + l_idx).item.wl_valid).to_boolean then
									if (w_lines + l_idx).item.wl_lnum >= l_to + 1 then
										l_mid_end := l_srow
										l_break := True
									end
								end
								if not (l_break) then
									l_srow := l_srow + ((w_lines + l_idx).item.wl_size).to_integer_32
									l_idx := l_idx + 1
								end
							end
							l_break := False
						end
				when 90 then -- if done | if done
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							if l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer) then
								Current.w_old_visual_mode := ((create {P_GLOBALS_STATIC}).VIsual_mode.item).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								Current.w_old_cursor_lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
								update_class_fields -- Current might have been changed; synchronize
								Current.w_old_visual_lnum := (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum
								update_class_fields -- Current might have been changed; synchronize
								Current.w_old_visual_col := (create {P_GLOBALS_STATIC}).VIsual.item.item.col
								update_class_fields -- Current might have been changed; synchronize
								Current.w_old_curswant := (create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant
								update_class_fields -- Current might have been changed; synchronize
							else
								Current.w_old_visual_mode := (0).to_integer_8
								update_class_fields -- Current might have been changed; synchronize
								Current.w_old_cursor_lnum := (0).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								Current.w_old_visual_lnum := (0).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								Current.w_old_visual_col := 0
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							Current.w_old_visual_mode := (0).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							Current.w_old_cursor_lnum := (0).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							Current.w_old_visual_lnum := (0).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							Current.w_old_visual_col := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						l_save_got_int := (create {P_GLOBALS_STATIC}).got_int.item;
						(create {P_GLOBALS_STATIC}).got_int.item := 0
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SCREEN_STATIC}).win_foldinfo.item.item.fi_level := 0
						update_class_fields -- Current might have been changed; synchronize
						l_idx := 0
						l_row := 0
						l_srow := 0
						l_lnum := w_topline
				when 91 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 150 -- skip loop
						end
				when 92 then -- loop body:
						l_break := False
						if l_row = w_height then
							l_didline := 1
							l_break := True
						end
						if not (l_return or l_break) and then (l_lnum > l_buf___6.item.b_ml.ml_line_count) then
							l_eof := 1
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 149 -- skip if block
						end
				when 93 then -- if:
						l_srow := l_row
						if not (l_row < l_top_end) then
							l_pos := -1 + 96 -- skip if block
						end
				when 94 then -- if:
						l_pos := -1 + 125 -- goto _L___25
				when 95 then -- if block done, skip else block:
						l_pos := -1 + 149
				when 96 then -- else:
						if not (l_row >= l_mid_start) then
							l_pos := -1 + 99 -- skip if block
						end
				when 97 then -- if:
						if l_row < l_mid_end then
							l_pos := -1 + 125 -- goto _L___25
						else
							l_pos := -1 + 99 -- goto _L___27
						end
				when 98 then -- if block done, skip else block:
						l_pos := -1 + 149
				when 99 then -- else: | _L___27:
						if not (l_top_to_mod.to_boolean) then
							l_pos := -1 + 102 -- skip if block
						end
				when 100 then -- if:
						l_pos := -1 + 125 -- goto _L___25
				when 101 then -- if block done, skip else block:
						l_pos := -1 + 149
				when 102 then -- else:
						if not (l_idx >= w_lines_valid) then
							l_pos := -1 + 105 -- skip if block
						end
				when 103 then -- if:
						l_pos := -1 + 125 -- goto _L___25
				when 104 then -- if block done, skip else block:
						l_pos := -1 + 149
				when 105 then -- else:
						if not (l_row + ((w_lines + l_idx).item.wl_size).to_integer_32 > l_bot_start) then
							l_pos := -1 + 108 -- skip if block
						end
				when 106 then -- if:
						l_pos := -1 + 125 -- goto _L___25
				when 107 then -- if block done, skip else block:
						l_pos := -1 + 149
				when 108 then -- else:
						if l_mod_top.item = 0 then
							l_pos := -1 + 148 -- skip if block
						end
				when 109 then -- if:
						if l_lnum /= l_mod_top.item then
							l_pos := -1 + 112 -- skip if block
						end
				when 110 then -- if:
						l_pos := -1 + 125 -- goto _L___25
				when 111 then -- if block done, skip else block:
						l_pos := -1 + 147
				when 112 then -- else:
						if not (l_lnum >= l_mod_top.item) then
							l_pos := -1 + 146 -- skip if block
						end
				when 113 then -- if:
						if not (l_lnum < l_mod_bot.item) then
							l_pos := -1 + 116 -- skip if block
						end
				when 114 then -- if:
						l_pos := -1 + 125 -- goto _L___25
				when 115 then -- if block done, skip else block:
						l_pos := -1 + 145
				when 116 then -- else:
						if l_did_update /= 3 then
							l_pos := -1 + 119 -- skip if block
						end
				when 117 then -- if:
						l_pos := -1 + 125 -- goto _L___25
				when 118 then -- if block done, skip else block:
						l_pos := -1 + 145
				when 119 then -- else:
						if l_did_update /= 2 then
							l_pos := -1 + 144 -- skip if block
						end
				when 120 then -- if:
						l_tmp___26 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.syntax_present
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___26.to_boolean) then
							l_pos := -1 + 142 -- skip if block
						end
				when 121 then -- if:
						l_tmp___27 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.foldmethodIsSyntax
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___27.to_boolean) then
							l_pos := -1 + 124 -- skip if block
						end
				when 122 then -- if:
						l_tmp___28 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasAnyFolding
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___28.to_boolean then
							l_pos := -1 + 125 -- goto _L___25
						else
							l_pos := -1 + 124 -- goto _L___26
						end
				when 123 then -- if block done, skip else block:
						l_pos := -1 + 141
				when 124 then -- else: | _L___26:
						l_tmp___29 := syntax_check_changed (l_lnum)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___29.to_boolean) then
							l_pos := -1 + 140 -- skip if block
						end
				when 125 then -- if: | _L___25:
						if l_lnum = l_mod_top.item then
							l_top_to_mod := 0
						end
						if l_lnum /= l_mod_top.item then
							l_pos := -1 + 131 -- skip if block
						end
				when 126 then -- if:
						if l_mod_bot.item = 2_147_483_647 then
							l_pos := -1 + 131 -- skip if block
						end
				when 127 then -- if:
						if (create {P_GLOBALS_STATIC}).dollar_vcol.item = 0 then
							l_pos := -1 + 130 -- skip if block
						end
				when 128 then -- if:
						if l_mod_bot.item /= l_mod_top.item + 1 then
							l_pos := -1 + 130 -- goto _L___14
						end
				when 129 then -- if block done, skip else block:
						l_pos := -1 + 131
				when 130 then -- else: | _L___14:
						l_old_rows := 0
						l_new_rows := 0
						l_i___0 := l_idx
						from
						until
							not (not (l_return or l_break) and then (l_i___0 < w_lines_valid))
						loop
							l_break := False
							if ((w_lines + l_i___0).item.wl_valid).to_boolean then
								if (w_lines + l_i___0).item.wl_lnum = l_mod_bot.item then
									l_break := True
								end
							end
							if not (l_return or l_break) then
								l_old_rows := l_old_rows + ((w_lines + l_i___0).item.wl_size).to_integer_32
								if ((w_lines + l_i___0).item.wl_valid).to_boolean then
									if (w_lines + l_i___0).item.wl_lastlnum + 1 = l_mod_bot.item then
										l_i___0 := l_i___0 + 1
										from
										until
											(l_break)
										loop
											l_break := False
											if l_i___0 < w_lines_valid then
												if ((w_lines + l_i___0).item.wl_valid).to_boolean then
													l_break := True
												end
											else
												l_break := True
											end
											if not (l_break) then
												l_tmp___14 := l_i___0
												l_i___0 := l_i___0 + 1
												l_old_rows := l_old_rows + ((w_lines + l_tmp___14).item.wl_size).to_integer_32
											end
										end
										l_break := False
										l_break := True
									end
								end
							end
							if not (l_return or l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
						if l_i___0 >= w_lines_valid then
							l_bot_start := 0
						else
							l_j := l_idx.to_integer_32
							l_l.item := l_lnum
							update_class_fields -- Current might have been changed; synchronize
							from
							until
								not (not (l_break) and then (l_l.item < l_mod_bot.item))
							loop
								l_break := False
								l_tmp___17 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasFoldingWin (l_l.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_l, 1, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___17.to_boolean then
									l_new_rows := l_new_rows + 1
								elseif l_l.item = w_topline then
									l_tmp___15 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win_nofill (l_l.item, 1)
									update_class_fields -- Current might have been changed; synchronize
									l_new_rows := l_new_rows + (l_tmp___15 + w_topfill)
								else
									l_tmp___16 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win (l_l.item, 1)
									update_class_fields -- Current might have been changed; synchronize
									l_new_rows := l_new_rows + l_tmp___16
								end
								l_j := l_j + 1
								if l_new_rows > (w_height - l_row) - 2 then
									l_new_rows := 9_999
									l_break := True
								end
								if not (l_return or l_break) then
									l_l.item := l_l.item + 1
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_break := False
							l_xtra_rows := l_new_rows - l_old_rows
							if l_xtra_rows < 0 then
								if l_row - l_xtra_rows >= w_height - 2 then
									l_mod_bot.item := 2_147_483_647
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_SCREEN_STATIC}).check_for_delay (0)
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___18 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_del_lines (l_row, -l_xtra_rows, 0, 0)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___18 = 0 then
										l_mod_bot.item := 2_147_483_647
										update_class_fields -- Current might have been changed; synchronize
									else
										l_bot_start := w_height + l_xtra_rows
									end
								end
							elseif l_xtra_rows > 0 then
								if l_row + l_xtra_rows >= w_height - 2 then
									l_mod_bot.item := 2_147_483_647
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_SCREEN_STATIC}).check_for_delay (0)
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___19 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_ins_lines (l_row + l_old_rows, l_xtra_rows, 0, 0)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___19 = 0 then
										l_mod_bot.item := 2_147_483_647
										update_class_fields -- Current might have been changed; synchronize
									elseif l_top_end > l_row + l_old_rows then
										l_top_end := l_top_end + l_xtra_rows
									end
								end
							end
							if l_mod_bot.item /= 2_147_483_647 then
								if l_i___0.to_integer_32 /= l_j then
									if l_j < l_i___0.to_integer_32 then
										l_x___0 := l_row + l_new_rows
										from
										until
											(l_break)
										loop
											l_break := False
											if l_i___0 >= w_lines_valid then
												Current.w_lines_valid := l_j.to_integer_32
												update_class_fields -- Current might have been changed; synchronize
												l_break := True
											end
											if not (l_return or l_break) then
												w_lines[l_j] := (w_lines[l_i___0]).twin
												update_class_fields -- Current might have been changed; synchronize
												if l_x___0 + ((w_lines + l_j).item.wl_size).to_integer_32 > w_height then
													Current.w_lines_valid := (l_j + 1).to_integer_32
													update_class_fields -- Current might have been changed; synchronize
													l_break := True
												end
											end
											if not (l_return or l_break) then
												l_tmp___20 := l_j
												l_j := l_j + 1
												l_x___0 := l_x___0 + ((w_lines + l_tmp___20).item.wl_size).to_integer_32
												l_i___0 := l_i___0 + 1
											end
										end
										l_break := False
										if l_bot_start > l_x___0 then
											l_bot_start := l_x___0
										end
									else
										l_j := l_j - l_i___0.to_integer_32
										Current.w_lines_valid := (w_lines_valid.to_integer_32 + l_j).to_integer_32
										update_class_fields -- Current might have been changed; synchronize
										if w_lines_valid > w_height then
											Current.w_lines_valid := w_height
											update_class_fields -- Current might have been changed; synchronize
										end
										l_i___0 := w_lines_valid
										from
										until
											not (l_i___0.to_integer_32 - l_j >= l_idx.to_integer_32)
										loop
											w_lines[l_i___0] := (w_lines[(l_i___0.to_integer_32 - l_j)]).twin
											update_class_fields -- Current might have been changed; synchronize
											l_i___0 := l_i___0 - 1
										end
										from
										until
											not (l_i___0 >= l_idx)
										loop
											(w_lines + l_i___0).item.wl_size := (0).to_natural_16
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___21 := l_i___0
											l_i___0 := l_i___0 - 1;
											(w_lines + l_tmp___21).item.wl_valid := (0).to_integer_8
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								end
							end
						end
				when 131 then -- if done | if done
						l_fold_count := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.foldedCount (l_lnum, (create {P_SCREEN_STATIC}).win_foldinfo.item)
						update_class_fields -- Current might have been changed; synchronize
						if l_fold_count = 0 then
							l_pos := -1 + 134 -- skip if block
						end
				when 132 then -- if:;
						((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.fold_line (l_fold_count, (create {P_SCREEN_STATIC}).win_foldinfo.item, l_lnum, l_row)
						update_class_fields -- Current might have been changed; synchronize
						l_row := l_row + 1
						l_fold_count := l_fold_count - 1;
						(w_lines + l_idx).item.wl_folded := (1).to_integer_8
						update_class_fields; -- Current might have been changed; synchronize
						(w_lines + l_idx).item.wl_lastlnum := l_lnum + l_fold_count
						update_class_fields -- Current might have been changed; synchronize
						l_did_update := 3
				when 133 then -- if block done, skip else block:
						l_pos := -1 + 138
				when 134 then -- else:
						if not (l_idx < w_lines_valid) then
							l_pos := -1 + 137 -- skip if block
						end
				when 135 then -- if:
						if ((w_lines + l_idx).item.wl_valid).to_boolean then
							if (w_lines + l_idx).item.wl_lnum = l_lnum then
								if l_lnum > w_topline then
									if not (((create {P_OPTION_STATIC}).dy_flags.item.item).bit_and ({NATURAL_32} 1)).to_boolean then
										if l_srow + ((w_lines + l_idx).item.wl_size).to_integer_32 > w_height then
											l_tmp___23 := (create {P_DIFF_STATIC}).diff_check_fill ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), l_lnum)
											update_class_fields -- Current might have been changed; synchronize
											if l_tmp___23 = 0 then
												l_row := w_height + 1
											else
												l_pos := -1 + 137 -- goto _L___20
											end
										else
											l_pos := -1 + 137 -- goto _L___20
										end
									else
										l_pos := -1 + 137 -- goto _L___20
									end
								else
									l_pos := -1 + 137 -- goto _L___20
								end
							else
								l_pos := -1 + 137 -- goto _L___20
							end
						else
							l_pos := -1 + 137 -- goto _L___20
						end
				when 136 then -- if block done, skip else block:
						l_pos := -1 + 138
				when 137 then -- else: | _L___20:;
						((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.prepare_search_hl (l_lnum)
						update_class_fields -- Current might have been changed; synchronize
						if l_syntax_last_parsed /= 0 then
							if l_syntax_last_parsed + 1 < l_lnum then
								l_tmp___22 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.syntax_present
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___22.to_boolean then
									syntax_end_parsing (l_syntax_last_parsed + 1)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						l_row := win_line ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), l_lnum, l_srow, w_height, (l_mod_top.item = 0).to_integer)
						update_class_fields; -- Current might have been changed; synchronize
						(w_lines + l_idx).item.wl_folded := (0).to_integer_8
						update_class_fields; -- Current might have been changed; synchronize
						(w_lines + l_idx).item.wl_lastlnum := l_lnum
						update_class_fields -- Current might have been changed; synchronize
						l_did_update := 2
						l_syntax_last_parsed := l_lnum
				when 138 then -- if done;
						(w_lines + l_idx).item.wl_lnum := l_lnum
						update_class_fields; -- Current might have been changed; synchronize
						(w_lines + l_idx).item.wl_valid := (1).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						if l_row > w_height then
							if (create {P_GLOBALS_STATIC}).dollar_vcol.item = 0 then
								l_tmp___24 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win (l_lnum, 1)
								update_class_fields; -- Current might have been changed; synchronize
								(w_lines + l_idx).item.wl_size := l_tmp___24.to_natural_16
								update_class_fields -- Current might have been changed; synchronize
							end
							l_idx := l_idx + 1
							l_break := True
						end
						if not (l_return or l_break) then
							if (create {P_GLOBALS_STATIC}).dollar_vcol.item = 0 then
								(w_lines + l_idx).item.wl_size := (l_row - l_srow).to_natural_16
								update_class_fields -- Current might have been changed; synchronize
							end
							l_idx := l_idx + 1
							l_lnum := l_lnum + (l_fold_count + 1)
						end
				when 139 then -- if block done, skip else block:
						l_pos := -1 + 141
				when 140 then -- else:
						l_pos := -1 + 148 -- goto _L___22
				when 141 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 143
				when 142 then -- else:
						l_pos := -1 + 148 -- goto _L___22
				when 143 then -- if done | if block done, skip else block:
						l_pos := -1 + 145
				when 144 then -- else:
						l_pos := -1 + 148 -- goto _L___22
				when 145 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 147
				when 146 then -- else:
						l_pos := -1 + 148 -- goto _L___22
				when 147 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 149
				when 148 then -- else: | _L___22:
						l_tmp___25 := l_idx
						l_idx := l_idx + 1
						l_row := l_row + ((w_lines + l_tmp___25).item.wl_size).to_integer_32
						if l_row > w_height then
							l_break := True
						end
						if not (l_return or l_break) then
							l_lnum := (w_lines + (l_idx - 1)).item.wl_lastlnum + 1
							l_did_update := 1
						end
				when 149 then -- if done | if done | if done | if done | if done | if done
						if not (l_return or l_break) and then (l_lnum > l_buf___6.item.b_ml.ml_line_count) then
							l_eof := 1
							l_break := True
						end
						l_pos := -1 + 91 -- back to loop condition
				when 150 then -- loop done
						l_break := False
						if l_idx > w_lines_valid then
							Current.w_lines_valid := l_idx
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_syntax_last_parsed /= 0 then
							l_tmp___30 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.syntax_present
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___30.to_boolean then
								syntax_end_parsing (l_syntax_last_parsed + 1)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						Current.w_empty_rows := 0
						update_class_fields -- Current might have been changed; synchronize
						Current.w_filler_rows := 0
						update_class_fields -- Current might have been changed; synchronize
						if l_eof.to_boolean then
							l_pos := -1 + 153 -- skip if block
						end
				when 151 then -- if:
						if not l_didline.to_boolean then
							if l_lnum = w_topline then
								Current.w_botline := l_lnum + 1
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___31 := (create {P_DIFF_STATIC}).diff_check_fill ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), l_lnum)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___31 >= w_height - l_srow then
									Current.w_botline := l_lnum
									update_class_fields -- Current might have been changed; synchronize
									Current.w_filler_rows := w_height - l_srow
									update_class_fields -- Current might have been changed; synchronize
								elseif (((create {P_OPTION_STATIC}).dy_flags.item.item).bit_and ({NATURAL_32} 1)).to_boolean then
									(create {P_SCREEN_STATIC}).screen_fill ((w_winrow + w_height) - 1, w_winrow + w_height, (w_wincol + w_width) - 3, w_wincol + w_width, ('@').code, ('@').code, (create {P_GLOBALS_STATIC}).highlight_attr.item[1])
									update_class_fields; -- Current might have been changed; synchronize
									((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.set_empty_rows (l_srow)
									update_class_fields -- Current might have been changed; synchronize
									Current.w_botline := l_lnum
									update_class_fields -- Current might have been changed; synchronize
								else
									((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_draw_end (('@').code, (' ').code, l_srow, w_height, {PC_HLF_T}.HLF_AT)
									update_class_fields -- Current might have been changed; synchronize
									Current.w_botline := l_lnum
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						else
							l_pos := -1 + 153 -- goto _L___28
						end
				when 152 then -- if block done, skip else block:
						l_pos := -1 + 154
				when 153 then -- else: | _L___28:;
						((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.draw_vsep_win (l_row)
						update_class_fields -- Current might have been changed; synchronize
						if l_eof.to_boolean then
							Current.w_botline := l_buf___6.item.b_ml.ml_line_count + 1
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___32 := (create {P_DIFF_STATIC}).diff_check_fill ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), w_botline)
							update_class_fields -- Current might have been changed; synchronize
							l_j := l_tmp___32.to_integer_32
							if l_j > 0 then
								if not w_botfill.to_boolean then
									l_tmp___33 := (create {P_CHARSET_STATIC}).char2cells ((create {P_GLOBALS_STATIC}).fill_diff.item.item)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___33 > 1 then
										l_i___0 := ('-').code
									else
										l_i___0 := (create {P_GLOBALS_STATIC}).fill_diff.item.item
									end
									if l_row.to_integer_32 + l_j > w_height.to_integer_32 then
										l_j := (w_height - l_row).to_integer_32
									end
									((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_draw_end (l_i___0, l_i___0, l_row, l_row + l_j.to_integer_32, {PC_HLF_T}.HLF_DED)
									update_class_fields -- Current might have been changed; synchronize
									l_row := (l_row.to_integer_32 + l_j).to_integer_32
								end
							end
						elseif (create {P_GLOBALS_STATIC}).dollar_vcol.item = 0 then
							Current.w_botline := l_lnum
							update_class_fields -- Current might have been changed; synchronize
						end
						((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_draw_end (('~').code, (' ').code, l_row, w_height, {PC_HLF_T}.HLF_AT)
						update_class_fields -- Current might have been changed; synchronize
				when 154 then
						Current.w_redr_type := 0
						update_class_fields -- Current might have been changed; synchronize
						Current.w_old_topfill := w_topfill
						update_class_fields -- Current might have been changed; synchronize
						Current.w_old_botfill := w_botfill
						update_class_fields -- Current might have been changed; synchronize
						if (create {P_GLOBALS_STATIC}).dollar_vcol.item = 0 then
							Current.w_valid := (w_valid).bit_or ((32))
							update_class_fields -- Current might have been changed; synchronize
							if (c_pointer = ((create {P_GLOBALS_STATIC}).curwin.item).c_pointer) then
								if w_botline /= l_old_botline.to_integer_32 then
									if not recursive___4.item.to_boolean then
										recursive___4.item := 1;
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_and ((-129))
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_MOVE_STATIC}).update_topline
										update_class_fields -- Current might have been changed; synchronize
										if (create {P_GLOBALS_STATIC}).must_redraw.item /= 0 then
											l_i___0 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_mod_set;
											(create {P_GLOBALS_STATIC}).curbuf.item.item.b_mod_set := 0
											update_class_fields; -- Current might have been changed; synchronize
											((create {P_GLOBALS_STATIC}).curwin.item).item.win_update
											update_class_fields; -- Current might have been changed; synchronize
											(create {P_GLOBALS_STATIC}).must_redraw.item := 0
											update_class_fields; -- Current might have been changed; synchronize
											(create {P_GLOBALS_STATIC}).curbuf.item.item.b_mod_set := l_i___0
											update_class_fields -- Current might have been changed; synchronize
										end
										recursive___4.item := 0
									end
								end
							end
						end
						if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							(create {P_GLOBALS_STATIC}).got_int.item := l_save_got_int
							update_class_fields -- Current might have been changed; synchronize
						end
				when 155 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	draw_signcolumn: INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			if not (w_buffer.item.b_signlist).is_void then
				l_tmp___0 := 1
			else
				l_tmp := (create {P_NETBEANS_STATIC}).netbeans_active
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			end
			Result := l_tmp___0
		end

	win_draw_end (a_c1, a_c2, a_row, a_endrow: INTEGER_32; a_hl: NATURAL_32)
		local
			l_n: INTEGER_32
			l_nn: INTEGER_32
			l_nn___0: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_n := 0
			if (create {P_GLOBALS_STATIC}).cmdwin_type.item /= 0 then
				if (c_pointer = ((create {P_GLOBALS_STATIC}).curwin.item).c_pointer) then
					l_n := 1
					if l_n > w_width then
						l_n := w_width
					end
					(create {P_SCREEN_STATIC}).screen_fill (w_winrow + a_row, w_winrow + a_endrow, w_wincol, w_wincol + l_n, (create {P_GLOBALS_STATIC}).cmdwin_type.item, (' ').code, (create {P_GLOBALS_STATIC}).highlight_attr.item[1])
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if w_onebuf_opt.wo_fdc > 0 then
				l_nn := (l_n.to_integer_32 + w_onebuf_opt.wo_fdc).to_integer_32
				if l_nn > w_width then
					l_nn := w_width
				end
				(create {P_SCREEN_STATIC}).screen_fill (w_winrow + a_row, w_winrow + a_endrow, w_wincol + l_n, w_wincol + l_nn, (' ').code, (' ').code, (create {P_GLOBALS_STATIC}).highlight_attr.item[20])
				update_class_fields -- Current might have been changed; synchronize
				l_n := l_nn
			end
			l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.draw_signcolumn
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				l_nn___0 := l_n + 2
				if l_nn___0 > w_width then
					l_nn___0 := w_width
				end
				(create {P_SCREEN_STATIC}).screen_fill (w_winrow + a_row, w_winrow + a_endrow, w_wincol + l_n, w_wincol + l_nn___0, (' ').code, (' ').code, (create {P_GLOBALS_STATIC}).highlight_attr.item[26])
				update_class_fields -- Current might have been changed; synchronize
				l_n := l_nn___0
			end
			(create {P_SCREEN_STATIC}).screen_fill (w_winrow + a_row, w_winrow + a_endrow, w_wincol + l_n, w_wincol + w_width, a_c1, a_c2, (create {P_GLOBALS_STATIC}).highlight_attr.item[a_hl.to_integer_32])
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.set_empty_rows (a_row)
			update_class_fields -- Current might have been changed; synchronize
		end

	fold_line (a_fold_count: INTEGER_32; a_foldinfo: CE_POINTER [PD_FOLDINFO]; a_lnum: INTEGER_32; a_row: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_top: CE_POINTER [PD_POS_T]
			l_bot: CE_POINTER [PD_POS_T]
			l_lnume: INTEGER_32
			l_len: INTEGER_32
			l_text: CE_POINTER [NATURAL_8]
			l_fdc: INTEGER_32
			l_col: INTEGER_32
			l_txtcol: INTEGER_32
			l_off___0: INTEGER_32
			l_ri: INTEGER_32
			l_tmp: INTEGER_32
			l_w: INTEGER_32
			l_tmp___0: INTEGER_32
			l_num: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_cells: INTEGER_32
			l_u8c: INTEGER_32
			l_u8cc: CE_ARRAY [INTEGER_32]
			l_i___0: INTEGER_32
			l_idx: INTEGER_32
			l_c_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___3: NATURAL_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: NATURAL_32
			l_tmp___9: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<51>>)
			create {CE_INTEGER_32_ARRAY} l_u8cc.make (<<6>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnume := (a_lnum + a_fold_count) - 1
					l_off___0 := ((create {P_SCREEN_STATIC}).current_ScreenLine.item).distance (((create {P_GLOBALS_STATIC}).ScreenLines.item))
					l_col := 0
					if (create {P_GLOBALS_STATIC}).cmdwin_type.item /= 0 then
						if (c_pointer = ((create {P_GLOBALS_STATIC}).curwin.item).c_pointer) then
							(create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0] := ((create {P_GLOBALS_STATIC}).cmdwin_type.item).to_natural_8
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0] := ((create {P_GLOBALS_STATIC}).highlight_attr.item[1]).to_natural_16
							update_class_fields -- Current might have been changed; synchronize
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off___0] := (0).to_natural_32
								update_class_fields -- Current might have been changed; synchronize
							end
							l_col := l_col + 1
						end
					end
					l_fdc := (w_onebuf_opt.wo_fdc).to_integer_32
					if l_fdc > w_width - l_col then
						l_fdc := w_width - l_col
					end
					if l_fdc > 0 then
						((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.fill_foldcolumn (l_buf___6, 1, a_lnum)
						update_class_fields -- Current might have been changed; synchronize
						copy_text_attr (l_off___0 + l_col, l_buf___6, l_fdc, (create {P_GLOBALS_STATIC}).highlight_attr.item[20])
						update_class_fields -- Current might have been changed; synchronize
						l_col := l_col + l_fdc
					end
					l_ri := 0
					from
					until
						not (l_ri < w_width - l_col)
					loop
						(create {P_GLOBALS_STATIC}).ScreenAttrs.item[((l_off___0 + l_col) + l_ri)] := ((create {P_GLOBALS_STATIC}).highlight_attr.item[19]).to_natural_16
						update_class_fields -- Current might have been changed; synchronize
						l_ri := l_ri + 1
					end
					l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.draw_signcolumn
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						l_len := w_width - l_col
						if l_len > 0 then
							if l_len > 2 then
								l_len := 2
							end
							copy_text_attr (l_off___0 + l_col, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("  ")), l_len, (create {P_GLOBALS_STATIC}).highlight_attr.item[19])
							update_class_fields -- Current might have been changed; synchronize
							l_col := l_col + l_len
						end
					end
					if not ((w_onebuf_opt.wo_nu).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((w_onebuf_opt.wo_rnu).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_len := w_width - l_col
						if l_len > 0 then
							l_tmp___0 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.number_width
							update_class_fields -- Current might have been changed; synchronize
							l_w := l_tmp___0
							if l_len > l_w + 1 then
								l_len := l_w + 1
							end
							if (w_onebuf_opt.wo_nu).to_boolean then
								l_num := a_lnum
							else
								l_tmp___1 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.get_cursor_rel_lnum (a_lnum)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___2 := abs (l_tmp___1.to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
								l_num := l_tmp___2.to_integer_32
							end
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("%%*ld "), l_w, l_num]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							copy_text_attr (l_off___0 + l_col, l_buf___6, l_len, (create {P_GLOBALS_STATIC}).highlight_attr.item[19])
							update_class_fields -- Current might have been changed; synchronize
							l_col := l_col + l_len
						end
				when 5 then -- if done
					l_text := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.get_foldtext (a_lnum, l_lnume, a_foldinfo, l_buf___6)
					update_class_fields -- Current might have been changed; synchronize
					l_txtcol := l_col
					if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
						l_pos := -1 + 24 -- skip if block
					end
				when 6 then -- if:
						l_idx := l_off___0 + l_col
						l_p___0 := l_text
				when 7 then -- loop condition:
						if not (not (l_return or l_break) and then ((l_p___0.item).to_integer_32 /= 0)) then
							l_pos := -1 + 22 -- skip loop
						end
				when 8 then -- loop body:
						l_break := False
						l_cells := (create {P_GLOBALS_STATIC}).mb_ptr2cells.item.integer_32_item ([l_p___0])
						update_class_fields -- Current might have been changed; synchronize
						l_c_len := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
						update_class_fields -- Current might have been changed; synchronize
						if l_col + l_cells > w_width then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 21 -- skip if block
						end
				when 9 then -- if:;
						(create {P_GLOBALS_STATIC}).ScreenLines.item[l_idx] := l_p___0.item
						update_class_fields -- Current might have been changed; synchronize
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 10 then -- if:
						l_u8c := (create {P_MBYTE_STATIC}).utfc_ptr2char (l_p___0, l_u8cc)
						update_class_fields -- Current might have been changed; synchronize
						if not ((l_p___0.item).to_integer_32 < 128) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_u8cc[0] = 0 then
							(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_idx] := (0).to_natural_32
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 13 -- goto _L___0
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___0:;
						(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_idx] := l_u8c.to_natural_32
						update_class_fields -- Current might have been changed; synchronize
						l_i___0 := 0
						from
						until
							not (not (l_break) and then (l_i___0 < (create {P_GLOBALS_STATIC}).Screen_mco.item))
						loop
							l_break := False;
							((create {P_GLOBALS_STATIC}).ScreenLinesC.item[l_i___0])[l_idx] := (l_u8cc[l_i___0]).to_natural_32
							update_class_fields -- Current might have been changed; synchronize
							if l_u8cc[l_i___0] = 0 then
								l_break := True
							end
							if not (l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
				when 14 then
						if l_cells > 1 then
							(create {P_GLOBALS_STATIC}).ScreenLines.item[(l_idx + 1)] := (0).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else:
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 9_932 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if (l_p___0.item).to_integer_32 = 142 then
							(create {P_GLOBALS_STATIC}).ScreenLines2.item[l_idx] := l_p___0[1]
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 19 -- goto _L___1
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___1:
						if l_cells > 1 then
							(create {P_GLOBALS_STATIC}).ScreenLines.item[(l_idx + 1)] := l_p___0[1]
							update_class_fields -- Current might have been changed; synchronize
						end
				when 20 then -- if done
						l_col := l_col + l_cells
						l_idx := l_idx + l_cells
						l_p___0 := l_p___0 + l_c_len
				when 21 then -- if done
						l_pos := -1 + 7 -- back to loop condition
				when 22 then -- loop done
						l_break := False
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						l_tmp___3 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_text))
						update_class_fields -- Current might have been changed; synchronize
						l_len := l_tmp___3.to_integer_32
						if l_len > w_width - l_col then
							l_len := w_width - l_col
						end
						if l_len > 0 then
							strncpy (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_SCREEN_STATIC}).current_ScreenLine.item + l_col)), create {CE_INTEGER_8_POINTER}.make_cast (l_text), l_len.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_col := l_col + l_len
						end
				when 25 then -- if done
					from
					until
						not (l_col < w_width)
					loop
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							if (create {P_GLOBALS_STATIC}).fill_fold.item.item >= 128 then
								(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[(l_off___0 + l_col)] := ((create {P_GLOBALS_STATIC}).fill_fold.item.item).to_natural_32
								update_class_fields; -- Current might have been changed; synchronize
								((create {P_GLOBALS_STATIC}).ScreenLinesC.item[0])[(l_off___0 + l_col)] := (0).to_natural_32
								update_class_fields -- Current might have been changed; synchronize
							else
								(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[(l_off___0 + l_col)] := (0).to_natural_32
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_tmp___4 := l_col
						l_col := l_col + 1;
						(create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off___0 + l_tmp___4)] := ((create {P_GLOBALS_STATIC}).fill_fold.item.item).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
					end
					if not l_text.is_equal (l_buf___6) then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_text))
						update_class_fields -- Current might have been changed; synchronize
					end
					if not (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
						l_pos := -1 + 43 -- skip if block
					end
				when 26 then -- if:
						if not (w_buffer.is_equal ((create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer)) then
							l_pos := -1 + 43 -- skip if block
						end
				when 27 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum then
							l_tmp___6 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum).to_integer
						else
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col /= (create {P_GLOBALS_STATIC}).VIsual.item.item.col then
								l_tmp___5 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < (create {P_GLOBALS_STATIC}).VIsual.item.item.col).to_integer
							else
								l_tmp___5 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd < (create {P_GLOBALS_STATIC}).VIsual.item.item.coladd).to_integer
							end
							l_tmp___6 := l_tmp___5
						end
						if l_tmp___6.to_boolean then
							l_top := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
							l_bot := (create {P_GLOBALS_STATIC}).VIsual.item
						elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = (create {P_GLOBALS_STATIC}).VIsual.item.item.col then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd = (create {P_GLOBALS_STATIC}).VIsual.item.item.coladd then
									l_top := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
									l_bot := (create {P_GLOBALS_STATIC}).VIsual.item
								else
									l_top := (create {P_GLOBALS_STATIC}).VIsual.item
									l_bot := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
								end
							else
								l_top := (create {P_GLOBALS_STATIC}).VIsual.item
								l_bot := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
							end
						else
							l_top := (create {P_GLOBALS_STATIC}).VIsual.item
							l_bot := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
						end
						if not (a_lnum >= l_top.item.lnum) then
							l_pos := -1 + 43 -- skip if block
						end
				when 28 then -- if:
						if not (l_lnume <= l_bot.item.lnum) then
							l_pos := -1 + 43 -- skip if block
						end
				when 29 then -- if:
						if (create {P_GLOBALS_STATIC}).VIsual_mode.item = 118 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 42 -- goto _L___3
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 32 then -- else:
						if not (a_lnum > l_top.item.lnum) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 37 -- goto _L___4
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 35 then -- else:
						if a_lnum /= l_top.item.lnum then
							l_pos := -1 + 43 -- skip if block
						end
				when 36 then -- if:
						if l_top.item.col /= 0 then
							l_pos := -1 + 43 -- skip if block
						end
				when 37 then -- if: | _L___4:
						if not (l_lnume < l_bot.item.lnum) then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						l_pos := -1 + 42 -- goto _L___3
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 40 then -- else:
						if l_lnume /= l_bot.item.lnum then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						l_tmp___7 := w_buffer.item.ml_get_buf (l_lnume, 0)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___8 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___7))
						update_class_fields -- Current might have been changed; synchronize
						if not (l_bot.item.col - (((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 = 101).to_integer >= l_tmp___8.to_integer_32) then
							l_pos := -1 + 43 -- skip if block
						end
				when 42 then -- if: | _L___3:
						if (create {P_GLOBALS_STATIC}).VIsual_mode.item = 22 then
							if w_old_cursor_fcol + l_txtcol < w_width then
								if w_old_cursor_lcol + l_txtcol < w_width then
									l_len := w_old_cursor_lcol
								else
									l_len := w_width - l_txtcol
								end
								l_ri := 0
								from
								until
									not (l_ri < l_len - w_old_cursor_fcol)
								loop
									(create {P_GLOBALS_STATIC}).ScreenAttrs.item[((l_off___0 + (w_old_cursor_fcol + l_txtcol)) + l_ri)] := ((create {P_GLOBALS_STATIC}).highlight_attr.item[15]).to_natural_16
									update_class_fields -- Current might have been changed; synchronize
									l_ri := l_ri + 1
								end
							end
						else
							l_ri := 0
							from
							until
								not (l_ri < w_width - l_txtcol)
							loop
								(create {P_GLOBALS_STATIC}).ScreenAttrs.item[((l_off___0 + l_txtcol) + l_ri)] := ((create {P_GLOBALS_STATIC}).highlight_attr.item[15]).to_natural_16
								update_class_fields -- Current might have been changed; synchronize
								l_ri := l_ri + 1
							end
						end
				when 43 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
					if (w_onebuf_opt.wo_cuc).to_boolean then
						l_txtcol := l_txtcol + w_virtcol
						if (w_onebuf_opt.wo_wrap).to_boolean then
							l_txtcol := l_txtcol - w_skipcol
						else
							l_txtcol := l_txtcol - w_leftcol
						end
						if l_txtcol >= 0 then
							if l_txtcol < w_width then
								l_tmp___9 := (create {P_SYNTAX_STATIC}).hl_combine_attr (((create {P_GLOBALS_STATIC}).ScreenAttrs.item[(l_off___0 + l_txtcol)]).to_integer_32, (create {P_GLOBALS_STATIC}).highlight_attr.item[38])
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_GLOBALS_STATIC}).ScreenAttrs.item[(l_off___0 + l_txtcol)] := l_tmp___9.to_natural_16
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
					screen_line (a_row + w_winrow, w_wincol, w_width, w_width)
					update_class_fields -- Current might have been changed; synchronize
					if (c_pointer = ((create {P_GLOBALS_STATIC}).curwin.item).c_pointer) then
						if a_lnum <= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							if l_lnume >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_row := a_row
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_height := 1
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_folded := 1
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_or ((24))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
				when 44 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	fill_foldcolumn (a_p___0: CE_POINTER [NATURAL_8]; a_closed: INTEGER_32; a_lnum: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_level: INTEGER_32
			l_first_level: INTEGER_32
			l_empty: INTEGER_32
			l_tmp: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i___0 := 0;
					(create {P_MISC2_STATIC}).copy_spaces (a_p___0, (w_onebuf_opt.wo_fdc).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_level := (create {P_SCREEN_STATIC}).win_foldinfo.item.item.fi_level
					if not (l_level > 0) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if w_onebuf_opt.wo_fdc = 1 then
							l_empty := 0
						else
							l_empty := 1
						end
						l_first_level := ((((l_level.to_integer_32 - w_onebuf_opt.wo_fdc) - a_closed.to_integer_32) + 1) + l_empty.to_integer_32).to_integer_32
						if l_first_level < 1 then
							l_first_level := 1
						end
						l_i___0 := 0
				when 2 then -- loop condition:
						if not (not (l_break) and then ((l_i___0 + l_empty).to_integer_32 < w_onebuf_opt.wo_fdc)) then
							l_pos := -1 + 8 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if ((create {P_SCREEN_STATIC}).win_foldinfo.item.item.fi_lnum).to_integer_32 /= a_lnum then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_first_level + l_i___0 >= (create {P_SCREEN_STATIC}).win_foldinfo.item.item.fi_low_level then
							a_p___0[l_i___0] := (('-').code).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if l_first_level = 1 then
							a_p___0[l_i___0] := (('|').code).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
						elseif l_first_level + l_i___0 <= 9 then
							a_p___0[l_i___0] := ((48 + l_first_level) + l_i___0).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
						else
							a_p___0[l_i___0] := (('>').code).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
						end
				when 7 then
						if l_first_level + l_i___0 = l_level then
							l_break := True
						end
						if not (l_break) then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 8 then -- loop done
						l_break := False
				when 9 then -- if done
					if a_closed.to_boolean then
						if l_i___0.to_integer_32 >= w_onebuf_opt.wo_fdc then
							l_tmp := l_i___0 - 1
						else
							l_tmp := l_i___0
						end
						a_p___0[l_tmp] := (('+').code).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	draw_vsep_win (a_row: INTEGER_32)
		local
			l_hl: CE_ARRAY [INTEGER_32]
			l_c: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_hl.make (<<1>>)

			if w_vsep_width.to_boolean then
				l_c := (create {P_SCREEN_STATIC}).fillchar_vsep (l_hl)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SCREEN_STATIC}).screen_fill (w_winrow + a_row, w_winrow + w_height, w_wincol + w_width, (w_wincol + w_width) + 1, l_c, (' ').code, l_hl.item)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	stl_connected: INTEGER_32
		local
			l_fr: CE_POINTER [PD_FRAME_S]
			l_return, l_break: BOOLEAN
		do
			l_fr := w_frame
			from
			until
				not (not (l_return or l_break) and then (not (l_fr.item.fr_parent).is_void))
			loop
				l_break := False
				if ((l_fr.item.fr_parent).item.fr_layout).to_integer_32 = 2 then
					if not (l_fr.item.fr_next).is_void then
						l_break := True
					end
				elseif not (l_fr.item.fr_next).is_void then
					Result := 1
					l_return := True
				end
				if not (l_return or l_break) then
					l_fr := l_fr.item.fr_parent
				end
			end
			if not l_return then
				l_break := False
				Result := 0
			end
		end

	get_keymap_str (a_buf___6: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_s: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			l_return: BOOLEAN
		do
			if w_buffer.item.b_p_iminsert /= 1 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_old_curbuf := (create {P_GLOBALS_STATIC}).curbuf.item
				l_old_curwin___1 := (create {P_GLOBALS_STATIC}).curwin.item;
				(create {P_GLOBALS_STATIC}).curbuf.item := w_buffer
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).curwin.item := (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), ce_string ("b:keymap_name")).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).emsg_skip.item := (create {P_GLOBALS_STATIC}).emsg_skip.item + 1
				update_class_fields -- Current might have been changed; synchronize
				l_p___0 := (create {P_EVAL_STATIC}).eval_to_string (a_buf___6, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), 0)
				update_class_fields -- Current might have been changed; synchronize
				l_s := l_p___0;
				(create {P_GLOBALS_STATIC}).emsg_skip.item := (create {P_GLOBALS_STATIC}).emsg_skip.item - 1
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).curbuf.item := l_old_curbuf
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).curwin.item := l_old_curwin___1
				update_class_fields -- Current might have been changed; synchronize
				if l_p___0.is_void then
					l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lang"))
				elseif (l_p___0.item).to_integer_32 = 0 then
					l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lang"))
				end
				l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))
				update_class_fields -- Current might have been changed; synchronize
				if (l_tmp + {NATURAL_32} 3).to_integer_32 < a_len then
					sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), ce_string ("<%%s>"), l_p___0]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				else
					a_buf___6[0] := (('%/0/').code).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_s))
				update_class_fields -- Current might have been changed; synchronize
				Result := ((a_buf___6[0]).to_integer_32 /= 0).to_integer
			end
		end

	init_search_hl
		local
			l_cur: CE_POINTER [PD_MATCHITEM]
		do
			l_cur := w_match_head
			from
			until
				l_cur.is_void
			loop
				l_cur.item.hl.rm := (l_cur.item.match).twin
				update_class_fields -- Current might have been changed; synchronize
				if l_cur.item.hlg_id = 0 then
					l_cur.item.hl.attr := 0
					update_class_fields -- Current might have been changed; synchronize
				else
					l_cur.item.hl.attr := (create {P_SYNTAX_STATIC}).syn_id2attr (l_cur.item.hlg_id)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_cur.item.hl.buf := w_buffer
				update_class_fields -- Current might have been changed; synchronize
				l_cur.item.hl.lnum := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_cur.item.hl.first_lnum := (0).to_integer_32
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_EX_CMDS2_STATIC}).profile_setlimit ((create {P_OPTION_STATIC}).p_rdt.item.item, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl") + (create {PD_MATCH_T}.make).offset_of ("tm")))
				update_class_fields -- Current might have been changed; synchronize
				l_cur := l_cur.item.next
			end
			(create {P_SCREEN_STATIC}).search_hl.item.item.buf := w_buffer
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SCREEN_STATIC}).search_hl.item.item.lnum := (0).to_integer_32
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SCREEN_STATIC}).search_hl.item.item.first_lnum := (0).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	prepare_search_hl (a_lnum: INTEGER_32)
		local
			l_cur: CE_POINTER [PD_MATCHITEM]
			l_shl: CE_POINTER [PD_MATCH_T]
			l_shl_flag: INTEGER_32
			l_n: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_cur := w_match_head
			l_shl_flag := 0
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if l_cur.is_void then
					if l_shl_flag /= 0 then
						l_break := True
					end
				end
				if not (l_return or l_break) then
					if l_shl_flag = 0 then
						l_shl := (create {P_SCREEN_STATIC}).search_hl.item
						l_shl_flag := 1
					else
						l_shl := create {CE_CLASS_POINTER [PD_MATCH_T]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl"))
					end
					if not (l_shl.item.rm.regprog).is_void then
						if l_shl.item.lnum = 0 then
							l_tmp___0 := (l_shl.item.rm.regprog).item.re_multiline
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___0.to_boolean then
								if l_shl.item.first_lnum = 0 then
									l_shl.item.first_lnum := a_lnum
									update_class_fields -- Current might have been changed; synchronize
									from
									until
										not (not (l_break) and then (l_shl.item.first_lnum > w_topline))
									loop
										l_break := False
										l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasFoldingWin (l_shl.item.first_lnum - 1, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp.to_boolean then
											l_break := True
										end
										if not (l_break) then
											l_shl.item.first_lnum := (l_shl.item.first_lnum) - 1
											update_class_fields -- Current might have been changed; synchronize
										end
									end
									l_break := False
								end
								l_n := 0
								from
								until
									(l_break)
								loop
									l_break := False
									if l_shl.item.first_lnum < a_lnum then
										if (l_shl.item.rm.regprog).is_void then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										next_search_hl ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), l_shl, l_shl.item.first_lnum, l_n)
										update_class_fields -- Current might have been changed; synchronize
										if l_shl.item.lnum /= 0 then
											l_shl.item.first_lnum := (l_shl.item.lnum + l_shl.item.rm.endpos[0].lnum) - l_shl.item.rm.startpos[0].lnum
											update_class_fields -- Current might have been changed; synchronize
											l_n := l_shl.item.rm.endpos[0].col
										else
											l_shl.item.first_lnum := (l_shl.item.first_lnum) + 1
											update_class_fields -- Current might have been changed; synchronize
											l_n := 0
										end
									end
								end
								l_break := False
							end
						end
					end
					if not l_shl.is_equal ((create {P_SCREEN_STATIC}).search_hl.item) then
						if not l_cur.is_void then
							l_cur := l_cur.item.next
						end
					end
				end
			end
			l_break := False
		end

	linecopy (a_to, a_from: INTEGER_32)
		local
			l_off_to: NATURAL_32
			l_off_from: NATURAL_32
			l_i___0: INTEGER_32
		do
			l_off_to := (create {P_GLOBALS_STATIC}).LineOffset.item[a_to] + w_wincol.to_natural_32
			l_off_from := (create {P_GLOBALS_STATIC}).LineOffset.item[a_from] + w_wincol.to_natural_32
			memmove (create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenLines.item + l_off_to.to_integer_32)), create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenLines.item + l_off_from.to_integer_32)), w_width.to_natural_32 * {PLATFORM}.Natural_8_bytes.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
				memmove (create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenLinesUC.item + l_off_to.to_integer_32)), create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenLinesUC.item + l_off_from.to_integer_32)), w_width.to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := 0
				from
				until
					not (l_i___0.to_integer_32 < (create {P_OPTION_STATIC}).p_mco.item.item)
				loop
					memmove (create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenLinesC.item[l_i___0] + l_off_to.to_integer_32)), create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenLinesC.item[l_i___0] + l_off_from.to_integer_32)), w_width.to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := l_i___0 + 1
				end
			end
			if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 9_932 then
				memmove (create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenLines2.item + l_off_to.to_integer_32)), create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenLines2.item + l_off_from.to_integer_32)), w_width.to_natural_32 * {PLATFORM}.Natural_8_bytes.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			memmove (create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenAttrs.item + l_off_to.to_integer_32)), create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenAttrs.item + l_off_from.to_integer_32)), w_width.to_natural_32 * {PLATFORM}.Natural_16_bytes.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
		end

	win_ins_lines (a_row, a_line_count, a_invalid, a_mayclear: INTEGER_32): INTEGER_32
		local
			l_line_count: INTEGER_32
			l_did_delete: INTEGER_32
			l_nextrow: INTEGER_32
			l_lastrow: INTEGER_32
			l_retval: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line_count := a_line_count
					if a_invalid.to_boolean then
						Current.w_lines_valid := 0
						update_class_fields -- Current might have been changed; synchronize
					end
					if w_height < 5 then
						Result := 0
						l_return := True
					end
					if not l_return then
						if l_line_count > w_height - a_row then
							l_line_count := w_height - a_row
						end
						l_retval := win_do_lines ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), a_row, l_line_count, a_mayclear, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_retval /= 2 then
							Result := l_retval
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_did_delete := 0
						if w_next.is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (w_status_height.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_tmp := (create {P_SCREEN_STATIC}).screen_del_lines (0, (w_winrow + w_height) - l_line_count, l_line_count, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32, 0, create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp = 1 then
							l_did_delete := 1
						elseif (not w_next.is_void) then
							Result := 0
							l_return := True
						end
				when 6 then -- if done | if done
					if not l_return then
						if not l_did_delete.to_boolean then
							Current.w_redr_status := 1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
							update_class_fields -- Current might have been changed; synchronize
							l_nextrow := (w_winrow + w_height) + w_status_height
							l_lastrow := l_nextrow + l_line_count
							if l_lastrow.to_integer_32 > (create {P_GLOBALS_STATIC}).Rows.item.item then
								l_lastrow := ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32
							end
							(create {P_SCREEN_STATIC}).screen_fill (l_nextrow - l_line_count, l_lastrow - l_line_count, w_wincol, w_wincol + w_width, (' ').code, (' ').code, 0)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tmp___0 := (create {P_SCREEN_STATIC}).screen_ins_lines (0, w_winrow + a_row, l_line_count, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32, create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0 = 0 then
							if l_did_delete.to_boolean then
								Current.w_redr_status := 1
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_SCREEN_STATIC}).win_rest_invalid (w_next)
								update_class_fields -- Current might have been changed; synchronize
							end
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						Result := 1
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	win_del_lines (a_row, a_line_count, a_invalid, a_mayclear: INTEGER_32): INTEGER_32
		local
			l_line_count: INTEGER_32
			l_retval: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line_count := a_line_count
					if a_invalid.to_boolean then
						Current.w_lines_valid := 0
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_line_count > w_height - a_row then
						l_line_count := w_height - a_row
					end
					l_retval := win_do_lines ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), a_row, l_line_count, a_mayclear, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_retval /= 2 then
						Result := l_retval
						l_return := True
					end
					if not l_return then
						l_tmp := (create {P_SCREEN_STATIC}).screen_del_lines (0, w_winrow + a_row, l_line_count, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32, 0, create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp = 0 then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if w_next.is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						if not (w_status_height.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if not (((create {P_GLOBALS_STATIC}).cmdline_row.item).to_integer_32 < (create {P_GLOBALS_STATIC}).Rows.item.item - 1) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						l_tmp___0 := (create {P_SCREEN_STATIC}).screen_ins_lines (0, (w_winrow + w_height) - l_line_count, l_line_count, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32, create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0 = 0 then
							Current.w_redr_status := 1
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_SCREEN_STATIC}).win_rest_invalid (w_next)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:;
						(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
						update_class_fields -- Current might have been changed; synchronize
				when 11 then -- if done | if done
						Result := 1
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	number_width: INTEGER_32
		local
			l_n: INTEGER_32
			l_lnum: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if (w_onebuf_opt.wo_nu).to_boolean then
				l_lnum := w_buffer.item.b_ml.ml_line_count
			else
				l_lnum := w_height.to_integer_32
			end
			if l_lnum = w_nrwidth_line_count then
				Result := w_nrwidth_width
				l_return := True
			end
			if not l_return then
				Current.w_nrwidth_line_count := l_lnum
				update_class_fields -- Current might have been changed; synchronize
				l_n := 0
				from
				until
					(l_break)
				loop
					l_break := False
					l_lnum := l_lnum // (10)
					l_n := l_n + 1
					if not (l_lnum > 0) then
						l_break := True
					end
				end
				l_break := False
				if l_n.to_integer_32 < w_onebuf_opt.wo_nuw - 1 then
					l_n := (w_onebuf_opt.wo_nuw - 1).to_integer_32
				end
				Current.w_nrwidth_width := l_n
				update_class_fields -- Current might have been changed; synchronize
				Result := l_n
			end
		end

	spell_check (a_ptr: CE_POINTER [NATURAL_8]; a_attrp: CE_POINTER [NATURAL_32]; a_capcol: CE_POINTER [INTEGER_32]; a_docount: INTEGER_32): INTEGER_32
		require
			not a_ptr.is_void
		local
			l_mi: CE_ARRAY [PD_MATCHINF_S]
			l_nrlen: INTEGER_32
			l_c: INTEGER_32
			l_wrongcaplen: INTEGER_32
			l_lpi: INTEGER_32
			l_count_word: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: NATURAL_32
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_fp: CE_POINTER [NATURAL_8]
			l_save_result: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_MATCHINF_S]} l_mi.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_REGMATCH_T]} l_regmatch___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nrlen := 0
					l_wrongcaplen := 0
					l_count_word := a_docount
					if (a_ptr.item).to_integer_32 <= 32 then
						Result := 1
						l_return := True
					end
					if not l_return and then (w_s.item.b_langp.ga_len = 0) then
						Result := 1
						l_return := True
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						memset (create {CE_VOID_POINTER}.make_cast (l_mi), 0, (create {PD_MATCHINF_S}.make).structure_size.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if (a_ptr.item).to_integer_32 >= 48 then
							if (a_ptr.item).to_integer_32 <= 57 then
								if (a_ptr.item).to_integer_32 = 48 then
									if (a_ptr[1]).to_integer_32 = 120 then
										l_mi.item.mi_end := skiphex (a_ptr + 2)
										update_class_fields -- Current might have been changed; synchronize
									elseif (a_ptr[1]).to_integer_32 = 88 then
										l_mi.item.mi_end := skiphex (a_ptr + 2)
										update_class_fields -- Current might have been changed; synchronize
									else
										l_mi.item.mi_end := (create {P_CHARSET_STATIC}).skipdigits (a_ptr)
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									l_mi.item.mi_end := (create {P_CHARSET_STATIC}).skipdigits (a_ptr)
									update_class_fields -- Current might have been changed; synchronize
								end
								l_nrlen := (l_mi.item.mi_end).distance (a_ptr)
							end
						end
						l_mi.item.mi_word := a_ptr
						update_class_fields -- Current might have been changed; synchronize
						l_mi.item.mi_fend := a_ptr
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___7 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.spell_iswordp (l_mi.item.mi_fend)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___7.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_mi.item.mi_fend])
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___0 := l_tmp
							else
								l_tmp___0 := 1
							end
							l_mi.item.mi_fend := l_mi.item.mi_fend + l_tmp___0
							update_class_fields -- Current might have been changed; synchronize
							if ((l_mi.item.mi_fend).item).to_integer_32 /= 0 then
								l_tmp___1 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.spell_iswordp (l_mi.item.mi_fend)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___1.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
						end
						l_break := False
						if a_capcol.is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						if a_capcol.item /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						if (w_s.item.b_cap_prog).is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___2 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([a_ptr])
							update_class_fields -- Current might have been changed; synchronize
							l_c := l_tmp___2
						else
							l_c := (a_ptr.item).to_integer_32
						end
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_c >= 128 then
							l_tmp___3 := (create {P_MBYTE_STATIC}).utf_isupper (l_c)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___6 := l_tmp___3
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if l_c < 256 then
							l_tmp___5 := ((create {P_SPELL_STATIC}).spelltab.item.item.st_isu[l_c]).to_integer_32
						else
							l_tmp___4 := iswupper (l_c.to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___5 := l_tmp___4
						end
						l_tmp___6 := l_tmp___5
				when 9 then
						if not l_tmp___6.to_boolean then
							l_wrongcaplen := (l_mi.item.mi_fend).distance (a_ptr)
						end
				when 10 then -- if done | if done | if done | if done
						if not a_capcol.is_void then
							a_capcol.item := -1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_mi.item.mi_end := l_mi.item.mi_fend
						update_class_fields -- Current might have been changed; synchronize
						l_mi.item.mi_capflags := 0
						update_class_fields -- Current might have been changed; synchronize
						l_mi.item.mi_cend := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
						l_mi.item.mi_win := (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if ((l_mi.item.mi_fend).item).to_integer_32 /= 0 then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___8 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_mi.item.mi_fend])
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___9 := l_tmp___8
							else
								l_tmp___9 := 1
							end
							l_mi.item.mi_fend := l_mi.item.mi_fend + l_tmp___9
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_SPELL_STATIC}).spell_casefold (a_ptr, (l_mi.item.mi_fend).distance (a_ptr), l_mi.item.mi_fword, 251).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___10 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_mi.item.mi_fword)))
						update_class_fields -- Current might have been changed; synchronize
						l_mi.item.mi_fwordlen := l_tmp___10.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_mi.item.mi_result := 3
						update_class_fields -- Current might have been changed; synchronize
						l_mi.item.mi_result2 := 3
						update_class_fields -- Current might have been changed; synchronize
						l_lpi := 0
						from
						until
							not (l_lpi < w_s.item.b_langp.ga_len)
						loop
							l_continue := False
							l_mi.item.mi_lp := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (w_s.item.b_langp.ga_data) + l_lpi
							update_class_fields -- Current might have been changed; synchronize
							if (((l_mi.item.mi_lp).item.lp_slang).item.sl_fidxs).is_void then
								l_continue := True
							end
							if not (l_break or l_continue) then
								l_mi.item.find_word (0)
								update_class_fields -- Current might have been changed; synchronize
								l_mi.item.find_word (1)
								update_class_fields -- Current might have been changed; synchronize
								find_prefix (l_mi, 0)
								update_class_fields -- Current might have been changed; synchronize
								if (((l_mi.item.mi_lp).item.lp_slang).item.sl_nobreak).to_boolean then
									if l_mi.item.mi_result = 3 then
										if l_mi.item.mi_result2 /= 3 then
											l_mi.item.mi_result := l_mi.item.mi_result2
											update_class_fields -- Current might have been changed; synchronize
											l_mi.item.mi_end := l_mi.item.mi_end2
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								end
								if l_count_word.to_boolean then
									if l_mi.item.mi_result = 0 then
										(create {P_SPELL_STATIC}).count_common_word ((l_mi.item.mi_lp).item.lp_slang, a_ptr, (l_mi.item.mi_end).distance (a_ptr), 1)
										update_class_fields -- Current might have been changed; synchronize
										l_count_word := 0
									end
								end
							end
							l_lpi := l_lpi + 1
						end
						l_continue := False
						if l_mi.item.mi_result /= 0 then
							if l_nrlen > 0 then
								if l_mi.item.mi_result = 3 then
									Result := l_nrlen
									l_return := True
								elseif l_mi.item.mi_result = -1 then
									Result := l_nrlen
									l_return := True
								end
							else
								l_tmp___19 := (create {P_SPELL_STATIC}).spell_iswordp_nmw (a_ptr)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___19.to_boolean then
									if (l_mi.item.mi_end).is_equal (a_ptr) then
										if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
											l_tmp___13 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_mi.item.mi_end])
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___14 := l_tmp___13
										else
											l_tmp___14 := 1
										end
										l_mi.item.mi_end := l_mi.item.mi_end + l_tmp___14
										update_class_fields -- Current might have been changed; synchronize
									elseif l_mi.item.mi_result = 3 then
										if (((create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (w_s.item.b_langp.ga_data) + 0).item.lp_slang).item.sl_nobreak).to_boolean then
											l_save_result := l_mi.item.mi_result
											l_mi.item.mi_lp := create {CE_CLASS_POINTER [PD_LANGP_S]}.make_cast (w_s.item.b_langp.ga_data) + 0
											update_class_fields -- Current might have been changed; synchronize
											if not (((l_mi.item.mi_lp).item.lp_slang).item.sl_fidxs).is_void then
												l_p___0 := l_mi.item.mi_word
												l_fp := l_mi.item.mi_fword
												from
												until
													(l_break)
												loop
													l_break := False
													if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
														l_tmp___15 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
														update_class_fields -- Current might have been changed; synchronize
														l_tmp___16 := l_tmp___15
													else
														l_tmp___16 := 1
													end
													l_p___0 := l_p___0 + l_tmp___16
													if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
														l_tmp___17 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_fp])
														update_class_fields -- Current might have been changed; synchronize
														l_tmp___18 := l_tmp___17
													else
														l_tmp___18 := 1
													end
													l_fp := l_fp + l_tmp___18
													if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= ((l_mi.item.mi_end).c_pointer.to_integer_32).to_natural_32 then
														l_break := True
													end
													if not (l_break or l_continue) then
														l_mi.item.mi_compoff := l_fp.distance ((l_mi.item.mi_fword))
														update_class_fields -- Current might have been changed; synchronize
														l_mi.item.find_word (3)
														update_class_fields -- Current might have been changed; synchronize
														if l_mi.item.mi_result /= 3 then
															l_mi.item.mi_end := l_p___0
															update_class_fields -- Current might have been changed; synchronize
															l_break := True
														end
													end
												end
												l_break := False
												l_mi.item.mi_result := l_save_result
												update_class_fields -- Current might have been changed; synchronize
											end
										end
									end
								else
									if not a_capcol.is_void then
										if not (w_s.item.b_cap_prog).is_void then
											l_regmatch___0.item.regprog := w_s.item.b_cap_prog
											update_class_fields -- Current might have been changed; synchronize
											l_regmatch___0.item.rm_ic := 0
											update_class_fields -- Current might have been changed; synchronize
											l_tmp___11 := l_regmatch___0.item.vim_regexec (a_ptr, 0)
											update_class_fields -- Current might have been changed; synchronize
											if l_tmp___11.to_boolean then
												a_capcol.item := (l_regmatch___0.item.endp[0]).distance (a_ptr)
												update_class_fields -- Current might have been changed; synchronize
											end
										end
									end
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_tmp___12 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([a_ptr])
										update_class_fields -- Current might have been changed; synchronize
										Result := l_tmp___12
										l_return := True
									end
									if not l_return then
										Result := 1
										l_return := True
									end
								end
							end
							if not l_return then
								if l_mi.item.mi_result = 3 then
									a_attrp.item := {PC_HLF_T}.HLF_SPB
									update_class_fields -- Current might have been changed; synchronize
								elseif l_mi.item.mi_result = -1 then
									a_attrp.item := {PC_HLF_T}.HLF_SPB
									update_class_fields -- Current might have been changed; synchronize
								elseif l_mi.item.mi_result = 1 then
									a_attrp.item := {PC_HLF_T}.HLF_SPR
									update_class_fields -- Current might have been changed; synchronize
								else
									a_attrp.item := {PC_HLF_T}.HLF_SPL
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
				when 11 then -- if done
					if not l_return and then (l_wrongcaplen > 0) then
						if l_mi.item.mi_result = 0 then
							a_attrp.item := {PC_HLF_T}.HLF_SPC
							update_class_fields -- Current might have been changed; synchronize
							Result := l_wrongcaplen
							l_return := True
						elseif l_mi.item.mi_result = 1 then
							a_attrp.item := {PC_HLF_T}.HLF_SPC
							update_class_fields -- Current might have been changed; synchronize
							Result := l_wrongcaplen
							l_return := True
						end
					end
					if not l_return then
						Result := ((l_mi.item.mi_end).distance (a_ptr))
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	no_spell_checking: INTEGER_32
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			if not (w_onebuf_opt.wo_spell).to_boolean then
				l_tmp := gettext (ce_string ("E756: Spell checking is not enabled"))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
				l_return := True
			elseif ((w_s.item.b_p_spl).item).to_integer_32 = 0 then
				l_tmp := gettext (ce_string ("E756: Spell checking is not enabled"))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
				l_return := True
			elseif w_s.item.b_langp.ga_len = 0 then
				l_tmp := gettext (ce_string ("E756: Spell checking is not enabled"))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	spell_move_to (a_dir___0, a_allwords, a_curline: INTEGER_32; a_attrp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_lnum: INTEGER_32
			l_found_pos: PD_POS_T
			l_found_len: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_endp: CE_POINTER [NATURAL_8]
			l_attr: CE_ARRAY [NATURAL_32]
			l_len: INTEGER_32
			l_has_syntax: INTEGER_32
			l_tmp: INTEGER_32
			l_col: INTEGER_32
			l_can_spell: CE_ARRAY [INTEGER_32]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_buflen: INTEGER_32
			l_skip___0: INTEGER_32
			l_capcol: CE_ARRAY [INTEGER_32]
			l_found_one: INTEGER_32
			l_wrapped: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: NATURAL_32
			l_tmp___7: INTEGER_32
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: INTEGER_32
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: INTEGER_32
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create l_found_pos.make
			create {CE_NATURAL_32_ARRAY} l_attr.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_can_spell.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_capcol.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_found_len := 0
					l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.syntax_present
					update_class_fields -- Current might have been changed; synchronize
					l_has_syntax := l_tmp
					l_buf___6 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_buflen := 0
					l_skip___0 := 0
					l_capcol.item := -1
					update_class_fields -- Current might have been changed; synchronize
					l_found_one := 0
					l_wrapped := 0
					l_tmp___0 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.no_spell_checking
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___0.to_boolean then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 32 -- skip if block
					end
				when 1 then -- if:
						l_lnum := w_cursor.lnum
						l_found_pos.lnum := (0).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_found_pos.col := 0
						update_class_fields -- Current might have been changed; synchronize
						l_found_pos.coladd := 0
						update_class_fields -- Current might have been changed; synchronize
				when 2 then -- loop condition:
						if not (not (l_return or l_break) and then (not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean)) then
							l_pos := -1 + 32 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_line := w_buffer.item.ml_get_buf (l_lnum, 0)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))
						update_class_fields -- Current might have been changed; synchronize
						l_len := l_tmp___1.to_integer_32
						if l_buflen < (l_len + 250) + 2 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
							update_class_fields -- Current might have been changed; synchronize
							l_buflen := (l_len + 250) + 2
							l_buf___6 := (create {P_MISC2_STATIC}).alloc (l_buflen.to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_buf___6.is_void then
								l_break := True
							end
						end
						if (l_return or l_break) then
							l_pos := -1 + 31 -- skip if block
						end
				when 4 then -- if:
						if l_lnum = 1 then
							l_capcol.item := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_capcol.item = 0 then
							l_tmp___2 := (create {P_CHARSET_STATIC}).skipwhite (l_line)
							update_class_fields -- Current might have been changed; synchronize
							l_capcol.item := l_tmp___2.distance (l_line)
							update_class_fields -- Current might have been changed; synchronize
						elseif a_curline.to_boolean then
							if (c_pointer = ((create {P_GLOBALS_STATIC}).curwin.item).c_pointer) then
								l_tmp___3 := (create {P_CHARSET_STATIC}).skipwhite (l_line)
								update_class_fields -- Current might have been changed; synchronize
								l_col := l_tmp___3.distance (l_line)
								l_tmp___4 := (create {P_SPELL_STATIC}).check_need_cap (l_lnum, l_col)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___4.to_boolean then
									l_capcol.item := l_col
									update_class_fields -- Current might have been changed; synchronize
								end
								l_line := w_buffer.item.ml_get_buf (l_lnum, 0)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (l_line)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						if l_lnum < w_buffer.item.b_ml.ml_line_count then
							l_tmp___5 := w_buffer.item.ml_get_buf (l_lnum + 1, 0)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___6 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))
							update_class_fields -- Current might have been changed; synchronize
							spell_cat_line (l_buf___6 + l_tmp___6.to_integer_32, l_tmp___5, 250)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_p___0 := l_buf___6 + l_skip___0
						l_endp := l_buf___6 + l_len
				when 5 then -- loop condition:
						if not (not (l_return or l_break) and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_endp.c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 30 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						if a_dir___0 = -1 then
							if l_lnum = w_cursor.lnum then
								if not l_wrapped.to_boolean then
									if l_p___0.distance (l_buf___6) >= w_cursor.col then
										l_break := True
									end
								end
							end
						end
						if (l_return or l_break) then
							l_pos := -1 + 29 -- skip if block
						end
				when 7 then -- if:
						l_attr.item := {PC_HLF_T}.HLF_COUNT
						update_class_fields -- Current might have been changed; synchronize
						l_len := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.spell_check (l_p___0, l_attr, l_capcol, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_attr.item = {NATURAL_32} 41 then
							l_pos := -1 + 28 -- skip if block
						end
				when 8 then -- if:
						if not (a_allwords.to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___1
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 11 then -- else:
						if l_attr.item /= {NATURAL_32} 27 then
							l_pos := -1 + 28 -- skip if block
						end
				when 12 then -- if: | _L___1:
						if a_dir___0 /= -1 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 23 -- goto _L___0
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 15 then -- else:
						if l_lnum = w_cursor.lnum then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 23 -- goto _L___0
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 18 then -- else:
						if l_lnum /= w_cursor.lnum then
							l_pos := -1 + 27 -- skip if block
						end
				when 19 then -- if:
						if not (l_wrapped.to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___0
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 22 then -- else:
						if a_curline.to_boolean then
							l_tmp___7 := (l_p___0.distance (l_buf___6)) + l_len
						else
							l_tmp___7 := l_p___0.distance (l_buf___6)
						end
						if not (l_tmp___7 > w_cursor.col) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if: | _L___0:
						if l_has_syntax.to_boolean then
							l_col := l_p___0.distance (l_buf___6);
							((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.syn_get_id (l_lnum, l_col, 0, l_can_spell, 0).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							if not (l_can_spell.item).to_boolean then
								l_attr.item := {PC_HLF_T}.HLF_COUNT
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_can_spell.item := 1
							update_class_fields -- Current might have been changed; synchronize
						end
						if (l_can_spell.item).to_boolean then
							l_found_one := 1
							l_found_pos.lnum := l_lnum
							update_class_fields -- Current might have been changed; synchronize
							l_found_pos.col := l_p___0.distance (l_buf___6)
							update_class_fields -- Current might have been changed; synchronize
							l_found_pos.coladd := 0
							update_class_fields -- Current might have been changed; synchronize
							if a_dir___0 = 1 then
								Current.w_cursor := l_found_pos.twin
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
								update_class_fields -- Current might have been changed; synchronize
								if not a_attrp.is_void then
									a_attrp.item := l_attr.item
									update_class_fields -- Current might have been changed; synchronize
								end
								Result := l_len
								l_return := True
							elseif a_curline.to_boolean then
								l_found_pos.col := l_found_pos.col + l_len
								update_class_fields -- Current might have been changed; synchronize
							end
							if not l_return then
								l_found_len := l_len
							end
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_found_one := 1
				when 26 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else:
						l_found_one := 1
				when 28 then -- if done | if done | if done | if done | if done
						if not l_return then
							l_p___0 := l_p___0 + l_len
							l_capcol.item := l_capcol.item - l_len
							update_class_fields -- Current might have been changed; synchronize
						end
				when 29 then -- if done
						l_pos := -1 + 5 -- back to loop condition
				when 30 then -- loop done
						if not l_return then
							l_break := False
							if a_dir___0 = -1 then
								if l_found_pos.lnum /= 0 then
									Current.w_cursor := l_found_pos.twin
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
									update_class_fields -- Current might have been changed; synchronize
									Result := l_found_len
									l_return := True
								end
							end
						end
						if not l_return then
							if a_curline.to_boolean then
								l_break := True
							end
							if not (l_return or l_break) then
								if a_dir___0 = -1 then
									if l_lnum = w_cursor.lnum then
										if l_wrapped.to_boolean then
											l_break := True
										end
									end
									if not (l_return or l_break) then
										if l_lnum > 1 then
											l_lnum := l_lnum - 1
										elseif not ((create {P_OPTION_STATIC}).p_ws.item.item).to_boolean then
											l_break := True
										else
											l_lnum := w_buffer.item.b_ml.ml_line_count
											l_wrapped := 1
											l_tmp___9 := (create {P_OPTION_STATIC}).shortmess (('s').code)
											update_class_fields -- Current might have been changed; synchronize
											if not l_tmp___9.to_boolean then
												l_tmp___8 := gettext (((create {P_GLOBALS_STATIC}).top_bot_msg.item))
												update_class_fields; -- Current might have been changed; synchronize
												(create {P_MESSAGE_STATIC}).give_warning (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___8), 1)
												update_class_fields -- Current might have been changed; synchronize
											end
										end
									end
									if not (l_return or l_break) then
										l_capcol.item := -1
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									if l_lnum < w_buffer.item.b_ml.ml_line_count then
										l_lnum := l_lnum + 1
									elseif not ((create {P_OPTION_STATIC}).p_ws.item.item).to_boolean then
										l_break := True
									else
										l_lnum := (1).to_integer_32
										l_wrapped := 1
										l_tmp___11 := (create {P_OPTION_STATIC}).shortmess (('s').code)
										update_class_fields -- Current might have been changed; synchronize
										if not l_tmp___11.to_boolean then
											l_tmp___10 := gettext (((create {P_GLOBALS_STATIC}).bot_top_msg.item))
											update_class_fields; -- Current might have been changed; synchronize
											(create {P_MESSAGE_STATIC}).give_warning (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___10), 1)
											update_class_fields -- Current might have been changed; synchronize
										end
									end
									if not (l_return or l_break) and then (l_lnum = w_cursor.lnum) then
										if not l_found_one.to_boolean then
											l_break := True
										elseif l_wrapped.to_boolean then
											l_break := True
										end
									end
									if not (l_return or l_break) then
										if l_attr.item = {NATURAL_32} 41 then
											l_skip___0 := l_p___0.distance (l_endp)
										else
											l_skip___0 := 0
										end
										l_capcol.item := l_capcol.item - 1
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___12 := (create {P_CHARSET_STATIC}).skipwhite (l_line)
										update_class_fields -- Current might have been changed; synchronize
										if (l_tmp___12.item).to_integer_32 = 0 then
											l_capcol.item := 0
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								end
							end
							if not (l_return or l_break) then
								(create {P_MISC1_STATIC}).line_breakcheck
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 31 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 32 then -- loop done | if done
					if not l_return then
						l_break := False;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
						update_class_fields -- Current might have been changed; synchronize
						Result := 0
					end
				when 33 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clear_midword
		do
			memset (create {CE_VOID_POINTER}.make_cast ((w_s.item.b_spell_ismw)), 0, (256).to_natural_32).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (w_s.item.b_spell_ismw_mb))
			update_class_fields -- Current might have been changed; synchronize
			w_s.item.b_spell_ismw_mb := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
		end

	spell_iswordp (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_s: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_c: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				l_l := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(a_p___0.item).to_integer_32]).to_integer_32
				l_s := a_p___0
				if l_l = 1 then
					if (w_s.item.b_spell_ismw[(a_p___0.item).to_integer_32]).to_boolean then
						l_s := a_p___0 + 1
						l_l := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_s.item).to_integer_32]).to_integer_32
					end
				else
					l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([a_p___0])
					update_class_fields -- Current might have been changed; synchronize
					if l_c < 256 then
						l_tmp___1 := (w_s.item.b_spell_ismw[l_c]).to_integer_32
					else
						if not (w_s.item.b_spell_ismw_mb).is_void then
							l_tmp := (create {P_MISC2_STATIC}).vim_strchr (w_s.item.b_spell_ismw_mb, l_c)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp.is_void then
								l_tmp___0 := 1
							else
								l_tmp___0 := 0
							end
						else
							l_tmp___0 := 0
						end
						l_tmp___1 := l_tmp___0
					end
					if l_tmp___1.to_boolean then
						l_s := a_p___0 + l_l
						l_l := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(l_s.item).to_integer_32]).to_integer_32
					end
				end
				l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_s])
				update_class_fields -- Current might have been changed; synchronize
				if l_c > 255 then
					l_tmp___2 := (create {P_MBYTE_STATIC}).mb_get_class (l_s)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___3 := (create {P_SPELL_STATIC}).spell_mb_isword_class (l_tmp___2)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_tmp___3
					l_return := True
				end
				if not l_return then
					Result := ((create {P_SPELL_STATIC}).spelltab.item.item.st_isw[l_c]).to_integer_32
					l_return := True
				end
			end
			if not l_return then
				if (w_s.item.b_spell_ismw[(a_p___0.item).to_integer_32]).to_boolean then
					l_tmp___4 := (a_p___0[1]).to_integer_32
				else
					l_tmp___4 := (a_p___0[0]).to_integer_32
				end
				Result := ((create {P_SPELL_STATIC}).spelltab.item.item.st_isw[l_tmp___4]).to_integer_32
			end
		end

	syntax_start (a_lnum: INTEGER_32)
		local
			l_p___0: CE_POINTER [PD_SYN_STATE]
			l_last_valid: CE_POINTER [PD_SYN_STATE]
			l_last_min_valid: CE_POINTER [PD_SYN_STATE]
			l_sp: CE_POINTER [PD_SYN_STATE]
			l_prev: CE_POINTER [PD_SYN_STATE]
			l_parsed_lnum: INTEGER_32
			l_first_stored: INTEGER_32
			l_dist: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_last_valid := create {CE_CLASS_POINTER [PD_SYN_STATE]}.make_shared (default_pointer)
					l_last_min_valid := create {CE_CLASS_POINTER [PD_SYN_STATE]}.make_shared (default_pointer)
					l_prev := create {CE_CLASS_POINTER [PD_SYN_STATE]}.make_shared (default_pointer)
					if not ((create {P_SYNTAX_STATIC}).syn_block.item).is_equal (w_s) then
						(create {P_SYNTAX_STATIC}).invalidate_current_state
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SYNTAX_STATIC}).syn_buf.item := w_buffer
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SYNTAX_STATIC}).syn_block.item := w_s
						update_class_fields -- Current might have been changed; synchronize
					elseif changedtick___0.item /= (create {P_SYNTAX_STATIC}).syn_buf.item.item.b_changedtick then
						(create {P_SYNTAX_STATIC}).invalidate_current_state
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SYNTAX_STATIC}).syn_buf.item := w_buffer
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SYNTAX_STATIC}).syn_block.item := w_s
						update_class_fields -- Current might have been changed; synchronize
					end
					changedtick___0.item := (create {P_SYNTAX_STATIC}).syn_buf.item.item.b_changedtick;
					(create {P_SYNTAX_STATIC}).syn_win.item := (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))
					update_class_fields -- Current might have been changed; synchronize
					syn_stack_alloc
					update_class_fields -- Current might have been changed; synchronize
					if ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_array).is_void then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:;
						(create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_lasttick := (create {P_GLOBALS_STATIC}).display_tick.item
						update_class_fields -- Current might have been changed; synchronize
						if (create {P_SYNTAX_STATIC}).current_state.item.item.ga_itemsize /= 0 then
							if (create {P_SYNTAX_STATIC}).current_lnum.item < a_lnum then
								if (create {P_SYNTAX_STATIC}).current_lnum.item < (create {P_SYNTAX_STATIC}).syn_buf.item.item.b_ml.ml_line_count then
									syn_finish_line (0).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									if not current_state_stored.item.to_boolean then
										(create {P_SYNTAX_STATIC}).current_lnum.item := (create {P_SYNTAX_STATIC}).current_lnum.item + 1
										update_class_fields -- Current might have been changed; synchronize
										store_current_state.do_nothing
										update_class_fields -- Current might have been changed; synchronize
									end
									if (create {P_SYNTAX_STATIC}).current_lnum.item /= a_lnum then
										(create {P_SYNTAX_STATIC}).invalidate_current_state
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									(create {P_SYNTAX_STATIC}).invalidate_current_state
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								(create {P_SYNTAX_STATIC}).invalidate_current_state
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							(create {P_SYNTAX_STATIC}).invalidate_current_state
							update_class_fields -- Current might have been changed; synchronize
						end
						if (create {P_SYNTAX_STATIC}).current_state.item.item.ga_itemsize = 0 then
							if not ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_array).is_void then
								l_p___0 := (create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_first
								from
								until
									not (not (l_break) and then (not l_p___0.is_void))
								loop
									l_break := False
									if l_p___0.item.sst_lnum > a_lnum then
										l_break := True
									end
									if not (l_break) then
										if l_p___0.item.sst_lnum <= a_lnum then
											if l_p___0.item.sst_change_lnum = 0 then
												l_last_valid := l_p___0
												if l_p___0.item.sst_lnum >= a_lnum - (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_minlines then
													l_last_min_valid := l_p___0
												end
											end
										end
										l_p___0 := l_p___0.item.sst_next
									end
								end
								l_break := False
								if not l_last_min_valid.is_void then
									load_current_state (l_last_min_valid)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if (create {P_SYNTAX_STATIC}).current_state.item.item.ga_itemsize = 0 then
							syn_sync ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), a_lnum, l_last_valid)
							update_class_fields -- Current might have been changed; synchronize
							l_first_stored := (create {P_SYNTAX_STATIC}).current_lnum.item + (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_minlines
						else
							l_first_stored := (create {P_SYNTAX_STATIC}).current_lnum.item
						end
						if ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_len).to_integer_32 <= (create {P_GLOBALS_STATIC}).Rows.item.item then
							l_dist := 999_999
						else
							l_dist := ((create {P_SYNTAX_STATIC}).syn_buf.item.item.b_ml.ml_line_count // (((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_len).to_integer_32 - (create {P_GLOBALS_STATIC}).Rows.item.item) + 1).to_integer_32
						end
				when 2 then -- loop condition:
						if not (not (l_return or l_break) and then ((create {P_SYNTAX_STATIC}).current_lnum.item < a_lnum)) then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						syn_start_line
						update_class_fields -- Current might have been changed; synchronize
						syn_finish_line (0).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_SYNTAX_STATIC}).current_lnum.item := (create {P_SYNTAX_STATIC}).current_lnum.item + 1
						update_class_fields -- Current might have been changed; synchronize
						if not ((create {P_SYNTAX_STATIC}).current_lnum.item >= l_first_stored) then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if l_prev.is_void then
							l_prev := syn_stack_find_entry ((create {P_SYNTAX_STATIC}).current_lnum.item - 1)
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_prev.is_void then
							l_sp := (create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_first
						else
							l_sp := l_prev
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if not l_sp.is_void then
								if not (l_sp.item.sst_lnum < (create {P_SYNTAX_STATIC}).current_lnum.item) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_sp := l_sp.item.sst_next
							end
						end
						l_break := False
						if l_sp.is_void then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_sp.item.sst_lnum = (create {P_SYNTAX_STATIC}).current_lnum.item then
							l_tmp := syn_stack_equal (l_sp)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp.to_boolean then
								l_parsed_lnum := (create {P_SYNTAX_STATIC}).current_lnum.item
								l_prev := l_sp
								from
								until
									(l_break)
								loop
									l_break := False
									if not l_sp.is_void then
										if not (l_sp.item.sst_change_lnum <= l_parsed_lnum) then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										if l_sp.item.sst_lnum <= a_lnum then
											l_prev := l_sp
										elseif l_sp.item.sst_change_lnum = 0 then
											l_break := True
										end
									end
									if not (l_break) then
										l_sp.item.sst_change_lnum := (0).to_integer_32
										update_class_fields -- Current might have been changed; synchronize
										l_sp := l_sp.item.sst_next
									end
								end
								l_break := False
								load_current_state (l_prev)
								update_class_fields -- Current might have been changed; synchronize
							else
								l_pos := -1 + 7 -- goto _L___0
							end
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L___0:
						if l_prev.is_void then
							l_prev := store_current_state
							update_class_fields -- Current might have been changed; synchronize
						elseif (create {P_SYNTAX_STATIC}).current_lnum.item = a_lnum then
							l_prev := store_current_state
							update_class_fields -- Current might have been changed; synchronize
						elseif (create {P_SYNTAX_STATIC}).current_lnum.item >= l_prev.item.sst_lnum + l_dist.to_integer_32 then
							l_prev := store_current_state
							update_class_fields -- Current might have been changed; synchronize
						end
				when 8 then -- if done;
						(create {P_MISC1_STATIC}).line_breakcheck
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							(create {P_SYNTAX_STATIC}).current_lnum.item := a_lnum
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done
						l_break := False
						syn_start_line
						update_class_fields -- Current might have been changed; synchronize
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	reset_synblock
		do
			if not w_s.is_equal (create {CE_CLASS_POINTER [PD_SYNBLOCK_T]}.make_shared (w_buffer.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_s"))) then
				w_s.item.syntax_clear
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (w_s))
				update_class_fields -- Current might have been changed; synchronize
				Current.w_s := create {CE_CLASS_POINTER [PD_SYNBLOCK_T]}.make_shared (w_buffer.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_s"))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	syntax_present: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if w_s.item.b_syn_patterns.ga_len /= 0 then
				l_tmp := 1
			elseif w_s.item.b_syn_clusters.ga_len /= 0 then
				l_tmp := 1
			elseif w_s.item.b_keywtab.ht_used > {NATURAL_32} 0 then
				l_tmp := 1
			elseif w_s.item.b_keywtab_ic.ht_used > {NATURAL_32} 0 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	syn_get_id (a_lnum: INTEGER_32; a_col, a_trans___0: INTEGER_32; a_spellp: CE_POINTER [INTEGER_32]; a_keep_state: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if not w_buffer.is_equal ((create {P_SYNTAX_STATIC}).syn_buf.item) then
				((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.syntax_start (a_lnum)
				update_class_fields -- Current might have been changed; synchronize
			elseif a_lnum /= (create {P_SYNTAX_STATIC}).current_lnum.item then
				((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.syntax_start (a_lnum)
				update_class_fields -- Current might have been changed; synchronize
			elseif a_col < (create {P_SYNTAX_STATIC}).current_col.item then
				((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.syntax_start (a_lnum)
				update_class_fields -- Current might have been changed; synchronize
			end
			get_syntax_attr (a_col, a_spellp, a_keep_state).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			if a_trans___0.to_boolean then
				l_tmp := current_trans_id.item
			else
				l_tmp := current_id.item
			end
			Result := l_tmp
		end

	scroll_region_set (a_off___0: INTEGER_32)
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			l_tmp := tgoto (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_TERM_STATIC}).term_strings.item[6]), (w_winrow + w_height) - 1, w_winrow + a_off___0)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_TERM_STATIC}).out_str (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp))
			update_class_fields -- Current might have been changed; synchronize
			if (((create {P_TERM_STATIC}).term_strings.item[55]).item).to_integer_32 /= 0 then
				if w_width.to_integer_32 /= (create {P_GLOBALS_STATIC}).Columns.item.item then
					l_tmp___0 := tgoto (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_TERM_STATIC}).term_strings.item[55]), (w_wincol + w_width) - 1, w_wincol)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_TERM_STATIC}).out_str (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0))
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			(create {P_SCREEN_STATIC}).screen_start
			update_class_fields -- Current might have been changed; synchronize
		end

	set_mouse_topline
		do
			(create {P_TERM_STATIC}).orig_topline.item := w_topline
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_TERM_STATIC}).orig_topfill.item := w_topfill
			update_class_fields -- Current might have been changed; synchronize
		end

	mouse_comp_pos (a_rowp, a_colp: CE_POINTER [INTEGER_32]; a_lnump: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_rowp.is_void
			not a_colp.is_void
			not a_lnump.is_void
		local
			l_col: INTEGER_32
			l_row: INTEGER_32
			l_lnum: CE_ARRAY [INTEGER_32]
			l_retval: INTEGER_32
			l_off___0: INTEGER_32
			l_count___2: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_lnum.make (<<1>>)

			l_col := a_colp.item
			l_row := a_rowp.item
			l_retval := 0
			l_lnum.item := w_topline
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				not (not (l_break) and then (l_row > 0))
			loop
				l_break := False
				if (w_onebuf_opt.wo_diff).to_boolean then
					l_tmp___0 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasFoldingWin (l_lnum.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___0.to_boolean then
						l_count___2 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win (l_lnum.item, 1)
						update_class_fields -- Current might have been changed; synchronize
					else
						if l_lnum.item = w_topline then
							l_row := l_row - w_topfill
						else
							l_tmp := (create {P_DIFF_STATIC}).diff_check_fill ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), l_lnum.item)
							update_class_fields -- Current might have been changed; synchronize
							l_row := l_row - l_tmp
						end
						l_count___2 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win_nofill (l_lnum.item, 1)
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					l_count___2 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win (l_lnum.item, 1)
					update_class_fields -- Current might have been changed; synchronize
				end
				if l_count___2 > l_row then
					l_break := True
				end
				if not (l_break) then
					((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasFoldingWin (l_lnum.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_lnum, 1, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					if l_lnum.item = w_buffer.item.b_ml.ml_line_count then
						l_retval := 1
						l_break := True
					end
				end
				if not (l_break) then
					l_row := l_row - l_count___2
					l_lnum.item := l_lnum.item + 1
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_break := False
			if not l_retval.to_boolean then
				l_tmp___1 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___2 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off2
				update_class_fields -- Current might have been changed; synchronize
				l_off___0 := l_tmp___1 - l_tmp___2
				if l_col < l_off___0 then
					l_col := l_off___0
				end
				l_col := l_col + (l_row * (w_width - l_off___0))
				l_col := l_col + w_skipcol
			end
			if not (w_onebuf_opt.wo_wrap).to_boolean then
				l_col := l_col + w_leftcol
			end
			l_tmp___3 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off
			update_class_fields -- Current might have been changed; synchronize
			l_col := l_col - l_tmp___3
			if l_col < 0 then
				netbeans_gutter_click (l_lnum.item)
				update_class_fields -- Current might have been changed; synchronize
				l_col := 0
			end
			a_colp.item := l_col
			update_class_fields -- Current might have been changed; synchronize
			a_rowp.item := l_row
			update_class_fields -- Current might have been changed; synchronize
			a_lnump.item := l_lnum.item
			update_class_fields -- Current might have been changed; synchronize
			Result := l_retval
		end

	vcol2col (a_lnum: INTEGER_32; a_vcol: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_start___1: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_break: BOOLEAN
		do
			l_count___2 := 0
			l_ptr := w_buffer.item.ml_get_buf (a_lnum, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_start___1 := l_ptr
			from
			until
				(l_break)
			loop
				l_break := False
				if l_count___2 <= a_vcol then
					if (l_ptr.item).to_integer_32 = 0 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_lbr_chartabsize (l_ptr, l_count___2, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
					update_class_fields -- Current might have been changed; synchronize
					l_count___2 := l_count___2 + l_tmp
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp___0 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr])
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := l_tmp___0
					else
						l_tmp___1 := 1
					end
					l_ptr := l_ptr + l_tmp___1
				end
			end
			l_break := False
			Result := (l_ptr.distance (l_start___1))
		end

	win_init (a_oldp: CE_POINTER [PD_WINDOW_S]; a_flags___0: INTEGER_32)
		require
			not a_oldp.is_void
		local
			l_i___0: INTEGER_32
		do
			Current.w_buffer := a_oldp.item.w_buffer
			update_class_fields -- Current might have been changed; synchronize
			Current.w_s := create {CE_CLASS_POINTER [PD_SYNBLOCK_T]}.make_shared ((a_oldp.item.w_buffer).c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_s"))
			update_class_fields; -- Current might have been changed; synchronize
			(a_oldp.item.w_buffer).item.b_nwindows := ((a_oldp.item.w_buffer).item.b_nwindows) + 1
			update_class_fields -- Current might have been changed; synchronize
			Current.w_cursor := (a_oldp.item.w_cursor).twin
			update_class_fields -- Current might have been changed; synchronize
			Current.w_valid := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.w_curswant := a_oldp.item.w_curswant
			update_class_fields -- Current might have been changed; synchronize
			Current.w_set_curswant := a_oldp.item.w_set_curswant
			update_class_fields -- Current might have been changed; synchronize
			Current.w_topline := a_oldp.item.w_topline
			update_class_fields -- Current might have been changed; synchronize
			Current.w_topfill := a_oldp.item.w_topfill
			update_class_fields -- Current might have been changed; synchronize
			Current.w_leftcol := a_oldp.item.w_leftcol
			update_class_fields -- Current might have been changed; synchronize
			Current.w_pcmark := (a_oldp.item.w_pcmark).twin
			update_class_fields -- Current might have been changed; synchronize
			Current.w_prev_pcmark := (a_oldp.item.w_prev_pcmark).twin
			update_class_fields -- Current might have been changed; synchronize
			Current.w_alt_fnum := a_oldp.item.w_alt_fnum
			update_class_fields -- Current might have been changed; synchronize
			Current.w_wrow := a_oldp.item.w_wrow
			update_class_fields -- Current might have been changed; synchronize
			Current.w_fraction := a_oldp.item.w_fraction
			update_class_fields -- Current might have been changed; synchronize
			Current.w_prev_fraction_row := a_oldp.item.w_prev_fraction_row
			update_class_fields -- Current might have been changed; synchronize
			a_oldp.item.copy_jumplist ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)))
			update_class_fields -- Current might have been changed; synchronize
			if ((a_flags___0).bit_and (128)).to_boolean then
				Current.w_llist := create {CE_CLASS_POINTER [PD_QF_INFO_S]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				Current.w_llist_ref := create {CE_CLASS_POINTER [PD_QF_INFO_S]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			else
				a_oldp.item.copy_loclist ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)))
				update_class_fields -- Current might have been changed; synchronize
			end
			if not (a_oldp.item.w_localdir).is_void then
				Current.w_localdir := (create {P_MISC2_STATIC}).vim_strsave (a_oldp.item.w_localdir)
				update_class_fields -- Current might have been changed; synchronize
			end
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_oldp.item.w_tagstacklen)
			loop
				w_tagstack[l_i___0] := (a_oldp.item.w_tagstack[l_i___0]).twin
				update_class_fields -- Current might have been changed; synchronize
				if not (w_tagstack[l_i___0].tagname).is_void then
					w_tagstack[l_i___0].tagname := (create {P_MISC2_STATIC}).vim_strsave (w_tagstack[l_i___0].tagname)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_i___0 := l_i___0 + 1
			end
			Current.w_tagstackidx := a_oldp.item.w_tagstackidx
			update_class_fields -- Current might have been changed; synchronize
			Current.w_tagstacklen := a_oldp.item.w_tagstacklen
			update_class_fields -- Current might have been changed; synchronize
			a_oldp.item.copyFoldingState ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)))
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_init_some (a_oldp)
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.check_colorcolumn.do_nothing
			update_class_fields -- Current might have been changed; synchronize
		end

	win_init_some (a_oldp: CE_POINTER [PD_WINDOW_S])
		require
			not a_oldp.is_void
		do
			Current.w_alist := a_oldp.item.w_alist
			update_class_fields -- Current might have been changed; synchronize
			w_alist.item.al_refcount := (w_alist.item.al_refcount) + 1
			update_class_fields -- Current might have been changed; synchronize
			Current.w_arg_idx := a_oldp.item.w_arg_idx
			update_class_fields -- Current might have been changed; synchronize
			win_copy_options (a_oldp, (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)))
			update_class_fields -- Current might have been changed; synchronize
		end

	win_close_othertab (a_free_buf: INTEGER_32; a_tp: CE_POINTER [PD_TABPAGE_S])
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_dir___0: CE_ARRAY [INTEGER_32]
			l_ptp: CE_POINTER [PD_TABPAGE_S]
			l_free_tp: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_dir___0.make (<<1>>)

			l_ptp := create {CE_CLASS_POINTER [PD_TABPAGE_S]}.make_shared (default_pointer)
			l_free_tp := 0
			if a_free_buf.to_boolean then
				l_tmp := 2
			else
				l_tmp := 0
			end
			(create {P_BUFFER_STATIC}).close_buffer ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), w_buffer, l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			l_ptp := (create {P_GLOBALS_STATIC}).first_tabpage.item
			from
			until
				(l_break)
			loop
				l_break := False
				if not l_ptp.is_void then
					if l_ptp.is_equal (a_tp) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_ptp := l_ptp.item.tp_next
				end
			end
			l_break := False
			if l_ptp.is_void then
				l_return := True
			elseif a_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
				l_return := True
			end
			if not l_return then
				l_wp___0 := a_tp.item.tp_firstwin
				from
				until
					(l_break)
				loop
					l_break := False
					if not l_wp___0.is_void then
						if (l_wp___0.c_pointer = c_pointer) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_wp___0 := l_wp___0.item.w_next
					end
				end
				l_break := False
				if l_wp___0.is_void then
					l_return := True
				end
			end
			if not l_return then
				if a_tp.is_void then
					l_tmp___1 := (((create {P_GLOBALS_STATIC}).firstwin.item).is_equal ((create {P_GLOBALS_STATIC}).lastwin.item)).to_integer
				else
					l_tmp___1 := ((a_tp.item.tp_firstwin).is_equal (a_tp.item.tp_lastwin)).to_integer
				end
				if l_tmp___1.to_boolean then
					if a_tp.is_equal ((create {P_GLOBALS_STATIC}).first_tabpage.item) then
						(create {P_GLOBALS_STATIC}).first_tabpage.item := a_tp.item.tp_next
						update_class_fields -- Current might have been changed; synchronize
					else
						l_ptp := (create {P_GLOBALS_STATIC}).first_tabpage.item
						from
						until
							(l_break)
						loop
							l_break := False
							if not l_ptp.is_void then
								if (l_ptp.item.tp_next).is_equal (a_tp) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_ptp := l_ptp.item.tp_next
							end
						end
						l_break := False
						if l_ptp.is_void then
							l_tmp___0 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_intern2.item)))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("win_close_othertab()"))).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
						if not l_return then
							l_ptp.item.tp_next := a_tp.item.tp_next
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if not l_return then
						l_free_tp := 1
					end
				end
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_free_mem (l_dir___0, a_tp).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				if l_free_tp.to_boolean then
					free_tabpage (a_tp)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	win_free_mem (a_dirp: CE_POINTER [INTEGER_32]; a_tp: CE_POINTER [PD_TABPAGE_S]): CE_POINTER [PD_WINDOW_S]
		local
			l_frp: CE_POINTER [PD_FRAME_S]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			l_frp := w_frame
			l_wp___0 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.winframe_remove (a_dirp, a_tp)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_frp))
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_free (a_tp)
			update_class_fields -- Current might have been changed; synchronize
			if not a_tp.is_void then
				if (c_pointer = (a_tp.item.tp_curwin).c_pointer) then
					a_tp.item.tp_curwin := l_wp___0
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			Result := l_wp___0
		end

	winframe_remove (a_dirp: CE_POINTER [INTEGER_32]; a_tp: CE_POINTER [PD_TABPAGE_S]): CE_POINTER [PD_WINDOW_S]
		local
			l_frp: CE_POINTER [PD_FRAME_S]
			l_frp2: CE_POINTER [PD_FRAME_S]
			l_frp3: CE_POINTER [PD_FRAME_S]
			l_frp_close: CE_POINTER [PD_FRAME_S]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_row: CE_ARRAY [INTEGER_32]
			l_col: CE_ARRAY [INTEGER_32]
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_row.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)

			l_frp_close := w_frame
			if a_tp.is_void then
				l_tmp := (((create {P_GLOBALS_STATIC}).firstwin.item).is_equal ((create {P_GLOBALS_STATIC}).lastwin.item)).to_integer
			else
				l_tmp := ((a_tp.item.tp_firstwin).is_equal (a_tp.item.tp_lastwin)).to_integer
			end
			if l_tmp.to_boolean then
				Result := (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_frp2 := (create {P_WINDOW_STATIC}).win_altframe ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), a_tp)
				update_class_fields -- Current might have been changed; synchronize
				l_wp___0 := (create {P_WINDOW_STATIC}).frame2win (l_frp2)
				update_class_fields -- Current might have been changed; synchronize
				l_frp_close.item.frame_remove
				update_class_fields -- Current might have been changed; synchronize
				if ((l_frp_close.item.fr_parent).item.fr_layout).to_integer_32 = 2 then
					if not (l_frp2.item.fr_win).is_void then
						if ((l_frp2.item.fr_win).item.w_onebuf_opt.wo_wfh).to_boolean then
							l_frp := l_frp_close.item.fr_prev
							l_frp3 := l_frp_close.item.fr_next
							from
							until
								(l_break)
							loop
								l_break := False
								if l_frp.is_void then
									if l_frp3.is_void then
										l_break := True
									end
								end
								if not (l_break) and then (not l_frp.is_void) then
									if not (l_frp.item.fr_win).is_void then
										if not ((l_frp.item.fr_win).item.w_onebuf_opt.wo_wfh).to_boolean then
											l_frp2 := l_frp
											l_wp___0 := l_frp.item.fr_win
											l_break := True
										end
									end
									if not (l_break) then
										l_frp := l_frp.item.fr_prev
									end
								end
								if not (l_break) and then (not l_frp3.is_void) then
									if not (l_frp3.item.fr_win).is_void then
										if not ((l_frp3.item.fr_win).item.w_onebuf_opt.wo_wfh).to_boolean then
											l_frp2 := l_frp3
											l_wp___0 := l_frp3.item.fr_win
											l_break := True
										end
									end
									if not (l_break) then
										l_frp3 := l_frp3.item.fr_next
									end
								end
							end
							l_break := False
						end
					end
					if l_frp2.is_equal (l_frp_close.item.fr_next) then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
					l_frp2.item.frame_new_height (l_frp2.item.fr_height + l_frp_close.item.fr_height, l_tmp___0, 0)
					update_class_fields -- Current might have been changed; synchronize
					a_dirp.item := ('v').code
					update_class_fields -- Current might have been changed; synchronize
				else
					if not (l_frp2.item.fr_win).is_void then
						if ((l_frp2.item.fr_win).item.w_onebuf_opt.wo_wfw).to_boolean then
							l_frp := l_frp_close.item.fr_prev
							l_frp3 := l_frp_close.item.fr_next
							from
							until
								(l_break)
							loop
								l_break := False
								if l_frp.is_void then
									if l_frp3.is_void then
										l_break := True
									end
								end
								if not (l_break) and then (not l_frp.is_void) then
									if not (l_frp.item.fr_win).is_void then
										if not ((l_frp.item.fr_win).item.w_onebuf_opt.wo_wfw).to_boolean then
											l_frp2 := l_frp
											l_wp___0 := l_frp.item.fr_win
											l_break := True
										end
									end
									if not (l_break) then
										l_frp := l_frp.item.fr_prev
									end
								end
								if not (l_break) and then (not l_frp3.is_void) then
									if not (l_frp3.item.fr_win).is_void then
										if not ((l_frp3.item.fr_win).item.w_onebuf_opt.wo_wfw).to_boolean then
											l_frp2 := l_frp3
											l_wp___0 := l_frp3.item.fr_win
											l_break := True
										end
									end
									if not (l_break) then
										l_frp3 := l_frp3.item.fr_next
									end
								end
							end
							l_break := False
						end
					end
					if l_frp2.is_equal (l_frp_close.item.fr_next) then
						l_tmp___1 := 1
					else
						l_tmp___1 := 0
					end
					l_frp2.item.frame_new_width (l_frp2.item.fr_width + l_frp_close.item.fr_width, l_tmp___1, 0)
					update_class_fields -- Current might have been changed; synchronize
					a_dirp.item := ('h').code
					update_class_fields -- Current might have been changed; synchronize
				end
				if l_frp2.is_equal (l_frp_close.item.fr_next) then
					l_row.item := w_winrow
					update_class_fields -- Current might have been changed; synchronize
					l_col.item := w_wincol
					update_class_fields -- Current might have been changed; synchronize
					l_frp2.item.frame_comp_pos (l_row, l_col)
					update_class_fields -- Current might have been changed; synchronize
				end
				if (l_frp2.item.fr_next).is_void then
					if (l_frp2.item.fr_prev).is_void then
						(l_frp2.item.fr_parent).item.fr_layout := l_frp2.item.fr_layout
						update_class_fields; -- Current might have been changed; synchronize
						(l_frp2.item.fr_parent).item.fr_child := l_frp2.item.fr_child
						update_class_fields -- Current might have been changed; synchronize
						l_frp := l_frp2.item.fr_child
						from
						until
							l_frp.is_void
						loop
							l_frp.item.fr_parent := l_frp2.item.fr_parent
							update_class_fields -- Current might have been changed; synchronize
							l_frp := l_frp.item.fr_next
						end
						(l_frp2.item.fr_parent).item.fr_win := l_frp2.item.fr_win
						update_class_fields -- Current might have been changed; synchronize
						if not (l_frp2.item.fr_win).is_void then
							(l_frp2.item.fr_win).item.w_frame := l_frp2.item.fr_parent
							update_class_fields -- Current might have been changed; synchronize
						end
						l_frp := l_frp2.item.fr_parent;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_frp2))
						update_class_fields -- Current might have been changed; synchronize
						l_frp2 := l_frp.item.fr_parent
						if not l_frp2.is_void then
							if (l_frp2.item.fr_layout).to_integer_32 = (l_frp.item.fr_layout).to_integer_32 then
								if (l_frp2.item.fr_child).is_equal (l_frp) then
									l_frp2.item.fr_child := l_frp.item.fr_child
									update_class_fields -- Current might have been changed; synchronize
								end
								(l_frp.item.fr_child).item.fr_prev := l_frp.item.fr_prev
								update_class_fields -- Current might have been changed; synchronize
								if not (l_frp.item.fr_prev).is_void then
									(l_frp.item.fr_prev).item.fr_next := l_frp.item.fr_child
									update_class_fields -- Current might have been changed; synchronize
								end
								l_frp3 := l_frp.item.fr_child
								from
								until
									(l_break)
								loop
									l_break := False
									l_frp3.item.fr_parent := l_frp2
									update_class_fields -- Current might have been changed; synchronize
									if (l_frp3.item.fr_next).is_void then
										l_frp3.item.fr_next := l_frp.item.fr_next
										update_class_fields -- Current might have been changed; synchronize
										if not (l_frp.item.fr_next).is_void then
											(l_frp.item.fr_next).item.fr_prev := l_frp3
											update_class_fields -- Current might have been changed; synchronize
										end
										l_break := True
									end
									if not (l_break) then
										l_frp3 := l_frp3.item.fr_next
									end
								end
								l_break := False;
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_frp))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
				end
				Result := l_wp___0
			end
		end

	frame_fix_width
		do
			w_frame.item.fr_width := w_width + w_vsep_width
			update_class_fields -- Current might have been changed; synchronize
		end

	frame_fix_height
		do
			w_frame.item.fr_height := w_height + w_status_height
			update_class_fields -- Current might have been changed; synchronize
		end

	win_init_empty
		local
			l_tmp: INTEGER_32
		do
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.redraw_win_later (40)
			update_class_fields -- Current might have been changed; synchronize
			Current.w_lines_valid := 0
			update_class_fields -- Current might have been changed; synchronize
			w_cursor.lnum := (1).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := 0
			w_cursor.col := l_tmp
			update_class_fields -- Current might have been changed; synchronize
			Current.w_curswant := l_tmp
			update_class_fields -- Current might have been changed; synchronize
			w_cursor.coladd := 0
			update_class_fields -- Current might have been changed; synchronize
			w_pcmark.lnum := (1).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			w_pcmark.col := 0
			update_class_fields -- Current might have been changed; synchronize
			w_prev_pcmark.lnum := (0).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			w_prev_pcmark.col := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.w_topline := (1).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			Current.w_topfill := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.w_botline := (2).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	new_frame
		local
			l_frp: CE_POINTER [PD_FRAME_S]
			l_tmp: CE_POINTER [NATURAL_8]
		do
			l_tmp := (create {P_MISC2_STATIC}).alloc_clear ((create {PD_FRAME_S}.make).structure_size.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_frp := create {CE_CLASS_POINTER [PD_FRAME_S]}.make_cast (l_tmp)
			Current.w_frame := l_frp
			update_class_fields -- Current might have been changed; synchronize
			if not l_frp.is_void then
				l_frp.item.fr_layout := (0).to_integer_8
				update_class_fields -- Current might have been changed; synchronize
				l_frp.item.fr_win := (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	win_free (a_tp: CE_POINTER [PD_TABPAGE_S])
		local
			l_i___0: INTEGER_32
		do
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.clearFolding
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_EX_DOCMD_STATIC}).alist_unlink (w_alist)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_FILEIO_STATIC}).block_autocmds
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_OPTION_STATIC}).clear_winopt (create {CE_CLASS_POINTER [PD_WINOPT_T]}.make_shared (c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt")))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_OPTION_STATIC}).clear_winopt (create {CE_CLASS_POINTER [PD_WINOPT_T]}.make_shared (c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_allbuf_opt")))
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_vars") + (create {PD_DICTVAR_S}.make).offset_of ("dv_hashtab"))).item.vars_clear
			update_class_fields -- Current might have been changed; synchronize
			if (((create {P_GLOBALS_STATIC}).prevwin.item).c_pointer = c_pointer) then
				(create {P_GLOBALS_STATIC}).prevwin.item := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_free_lsize
			update_class_fields -- Current might have been changed; synchronize
			l_i___0 := 0
			from
			until
				not (l_i___0 < w_tagstacklen)
			loop
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (w_tagstack[l_i___0].tagname))
				update_class_fields -- Current might have been changed; synchronize
				l_i___0 := l_i___0 + 1
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (w_localdir))
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.clear_matches
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.free_jumplist
			update_class_fields -- Current might have been changed; synchronize
			qf_free_all ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)))
			update_class_fields -- Current might have been changed; synchronize
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				gui_mch_destroy_scrollbar (create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (0)))
				update_class_fields -- Current might have been changed; synchronize
				gui_mch_destroy_scrollbar (create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (1)))
				update_class_fields -- Current might have been changed; synchronize
			end
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.reset_synblock
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (w_p_cc_cols))
			update_class_fields -- Current might have been changed; synchronize
			if not (c_pointer = ((create {P_GLOBALS_STATIC}).aucmd_win.item).c_pointer) then
				((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_remove (a_tp)
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_FILEIO_STATIC}).unblock_autocmds
			update_class_fields -- Current might have been changed; synchronize
		end

	win_remove (a_tp: CE_POINTER [PD_TABPAGE_S])
		do
			if not w_prev.is_void then
				w_prev.item.w_next := w_next
				update_class_fields -- Current might have been changed; synchronize
			elseif a_tp.is_void then
				(create {P_GLOBALS_STATIC}).firstwin.item := w_next
				update_class_fields -- Current might have been changed; synchronize
			else
				a_tp.item.tp_firstwin := w_next
				update_class_fields -- Current might have been changed; synchronize
			end
			if not w_next.is_void then
				w_next.item.w_prev := w_prev
				update_class_fields -- Current might have been changed; synchronize
			elseif a_tp.is_void then
				(create {P_GLOBALS_STATIC}).lastwin.item := w_prev
				update_class_fields -- Current might have been changed; synchronize
			else
				a_tp.item.tp_lastwin := w_prev
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	win_alloc_lines: INTEGER_32
		local
			l_tmp: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			Current.w_lines_valid := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_MISC2_STATIC}).alloc_clear ((((create {P_GLOBALS_STATIC}).Rows.item.item).to_natural_32 * ((create {PD_W_LINE}.make).structure_size.to_natural_32).to_natural_32).to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			Current.w_lines := create {CE_CLASS_POINTER [PD_W_LINE]}.make_cast (l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			if w_lines.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := 1
			end
		end

	win_free_lsize
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (w_lines))
			update_class_fields -- Current might have been changed; synchronize
			Current.w_lines := create {CE_CLASS_POINTER [PD_W_LINE]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
		end

	win_setheight_win (a_height: INTEGER_32)
		local
			l_height: INTEGER_32
			l_row: INTEGER_32
		do
			l_height := a_height
			if (c_pointer = ((create {P_GLOBALS_STATIC}).curwin.item).c_pointer) then
				if l_height.to_integer_32 < (create {P_OPTION_STATIC}).p_wmh.item.item then
					l_height := ((create {P_OPTION_STATIC}).p_wmh.item.item).to_integer_32
				end
				if l_height = 0 then
					l_height := 1
				end
			end
			frame_setheight (w_frame, l_height + w_status_height)
			update_class_fields -- Current might have been changed; synchronize
			l_row := (create {P_WINDOW_STATIC}).win_comp_pos
			update_class_fields -- Current might have been changed; synchronize
			if ((create {P_GLOBALS_STATIC}).full_screen.item).to_boolean then
				if (create {P_GLOBALS_STATIC}).msg_scrolled.item = 0 then
					if l_row < (create {P_GLOBALS_STATIC}).cmdline_row.item then
						(create {P_SCREEN_STATIC}).screen_fill (l_row, (create {P_GLOBALS_STATIC}).cmdline_row.item, 0, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32, (' ').code, (' ').code, 0)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			(create {P_GLOBALS_STATIC}).cmdline_row.item := l_row
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).msg_row.item := l_row
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).msg_col.item := 0
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SCREEN_STATIC}).redraw_all_later (40)
			update_class_fields -- Current might have been changed; synchronize
		end

	win_setwidth_win (a_width: INTEGER_32)
		local
			l_width: INTEGER_32
		do
			l_width := a_width
			if (c_pointer = ((create {P_GLOBALS_STATIC}).curwin.item).c_pointer) then
				if l_width.to_integer_32 < (create {P_OPTION_STATIC}).p_wmw.item.item then
					l_width := ((create {P_OPTION_STATIC}).p_wmw.item.item).to_integer_32
				end
				if l_width = 0 then
					l_width := 1
				end
			end
			w_frame.item.frame_setwidth (l_width + w_vsep_width)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_WINDOW_STATIC}).win_comp_pos.do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SCREEN_STATIC}).redraw_all_later (40)
			update_class_fields -- Current might have been changed; synchronize
		end

	win_drag_status_line (a_offset: INTEGER_32)
		local
			l_offset: INTEGER_32
			l_curfr: CE_POINTER [PD_FRAME_S]
			l_fr: CE_POINTER [PD_FRAME_S]
			l_room: INTEGER_32
			l_row: INTEGER_32
			l_up: INTEGER_32
			l_n: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_offset := a_offset
			l_fr := w_frame
			l_curfr := l_fr
			if not l_fr.is_equal ((create {P_GLOBALS_STATIC}).topframe.item) then
				l_fr := l_fr.item.fr_parent
				if (l_fr.item.fr_layout).to_integer_32 /= 2 then
					l_curfr := l_fr
					if not l_fr.is_equal ((create {P_GLOBALS_STATIC}).topframe.item) then
						l_fr := l_fr.item.fr_parent
					end
				end
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if not l_curfr.is_equal ((create {P_GLOBALS_STATIC}).topframe.item) then
					if not ((l_curfr.item.fr_next).is_void) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					if not l_fr.is_equal ((create {P_GLOBALS_STATIC}).topframe.item) then
						l_fr := l_fr.item.fr_parent
					end
					l_curfr := l_fr
					if not l_fr.is_equal ((create {P_GLOBALS_STATIC}).topframe.item) then
						l_fr := l_fr.item.fr_parent
					end
				end
			end
			l_break := False
			if l_offset < 0 then
				l_up := 1
				l_offset := -l_offset
				if l_fr.is_equal (l_curfr) then
					l_tmp := l_fr.item.frame_minheight (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
					update_class_fields -- Current might have been changed; synchronize
					l_room := l_fr.item.fr_height - l_tmp
				else
					l_room := 0
					l_fr := l_fr.item.fr_child
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___0 := l_fr.item.frame_minheight (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_room := l_room + (l_fr.item.fr_height - l_tmp___0)
						if l_fr.is_equal (l_curfr) then
							l_break := True
						end
						if not (l_break) then
							l_fr := l_fr.item.fr_next
						end
					end
					l_break := False
				end
				l_fr := l_curfr.item.fr_next
			else
				l_up := 0
				l_room := ((create {P_GLOBALS_STATIC}).Rows.item.item - ((create {P_GLOBALS_STATIC}).cmdline_row.item).to_integer_32).to_integer_32
				if (l_curfr.item.fr_next).is_void then
					l_room := l_room - 1
				else
					l_room := (l_room.to_integer_32 - (create {P_OPTION_STATIC}).p_ch.item.item).to_integer_32
				end
				if l_room < 0 then
					l_room := 0
				end
				l_fr := l_curfr.item.fr_next
				from
				until
					l_fr.is_void
				loop
					l_tmp___1 := l_fr.item.frame_minheight (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
					update_class_fields -- Current might have been changed; synchronize
					l_room := l_room + (l_fr.item.fr_height - l_tmp___1)
					l_fr := l_fr.item.fr_next
				end
				l_fr := l_curfr
			end
			if l_room < l_offset then
				l_offset := l_room
			end
			if l_offset <= 0 then
				l_return := True
			end
			if not l_return then
				if not l_fr.is_void then
					l_fr.item.frame_new_height (l_fr.item.fr_height + l_offset, l_up, 0)
					update_class_fields -- Current might have been changed; synchronize
				end
				if l_up.to_boolean then
					l_fr := l_curfr
				else
					l_fr := l_curfr.item.fr_next
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if not l_fr.is_void then
						if not (l_offset > 0) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_n := l_fr.item.frame_minheight (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if l_fr.item.fr_height - l_offset <= l_n then
							l_offset := l_offset - (l_fr.item.fr_height - l_n)
							l_fr.item.frame_new_height (l_n, (not l_up.to_boolean).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_fr.item.frame_new_height (l_fr.item.fr_height - l_offset, (not l_up.to_boolean).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
					end
					if not (l_break) then
						if l_up.to_boolean then
							l_fr := l_fr.item.fr_prev
						else
							l_fr := l_fr.item.fr_next
						end
					end
				end
				l_break := False
				l_row := (create {P_WINDOW_STATIC}).win_comp_pos
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SCREEN_STATIC}).screen_fill (l_row, (create {P_GLOBALS_STATIC}).cmdline_row.item, 0, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32, (' ').code, (' ').code, 0)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).cmdline_row.item := l_row
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_OPTION_STATIC}).p_ch.item.item := (create {P_GLOBALS_STATIC}).Rows.item.item - ((create {P_GLOBALS_STATIC}).cmdline_row.item).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				if (create {P_OPTION_STATIC}).p_ch.item.item < 1 then
					(create {P_OPTION_STATIC}).p_ch.item.item := 1
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_GLOBALS_STATIC}).curtab.item.item.tp_ch_used := (create {P_OPTION_STATIC}).p_ch.item.item
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SCREEN_STATIC}).redraw_all_later (35)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SCREEN_STATIC}).showmode.do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	win_drag_vsep_line (a_offset: INTEGER_32)
		local
			l_offset: INTEGER_32
			l_curfr: CE_POINTER [PD_FRAME_S]
			l_fr: CE_POINTER [PD_FRAME_S]
			l_room: INTEGER_32
			l_left: INTEGER_32
			l_n: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_offset := a_offset
			l_fr := w_frame
			if l_fr.is_equal ((create {P_GLOBALS_STATIC}).topframe.item) then
				l_return := True
			end
			if not l_return then
				l_curfr := l_fr
				l_fr := l_fr.item.fr_parent
				if (l_fr.item.fr_layout).to_integer_32 /= 1 then
					if l_fr.is_equal ((create {P_GLOBALS_STATIC}).topframe.item) then
						l_return := True
					end
					if not l_return then
						l_curfr := l_fr
						l_fr := l_fr.item.fr_parent
					end
				end
			end
			if not l_return then
				from
				until
					not (not (l_break) and then ((l_curfr.item.fr_next).is_void))
				loop
					l_break := False
					if l_fr.is_equal ((create {P_GLOBALS_STATIC}).topframe.item) then
						l_break := True
					end
					if not (l_break) then
						l_curfr := l_fr
						l_fr := l_fr.item.fr_parent
						if not l_fr.is_equal ((create {P_GLOBALS_STATIC}).topframe.item) then
							l_curfr := l_fr
							l_fr := l_fr.item.fr_parent
						end
					end
				end
				l_break := False
				if l_offset < 0 then
					l_left := 1
					l_offset := -l_offset
					l_room := 0
					l_fr := l_fr.item.fr_child
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp := l_fr.item.frame_minwidth (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_room := l_room + (l_fr.item.fr_width - l_tmp)
						if l_fr.is_equal (l_curfr) then
							l_break := True
						end
						if not (l_break) then
							l_fr := l_fr.item.fr_next
						end
					end
					l_break := False
					l_fr := l_curfr.item.fr_next
				else
					l_left := 0
					l_room := 0
					l_fr := l_curfr.item.fr_next
					from
					until
						l_fr.is_void
					loop
						l_tmp___0 := l_fr.item.frame_minwidth (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_room := l_room + (l_fr.item.fr_width - l_tmp___0)
						l_fr := l_fr.item.fr_next
					end
					l_fr := l_curfr
				end
				if l_room < l_offset then
					l_offset := l_room
				end
				if l_offset <= 0 then
					l_return := True
				end
			end
			if not l_return then
				l_fr.item.frame_new_width (l_fr.item.fr_width + l_offset, l_left, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_left.to_boolean then
					l_fr := l_curfr
				else
					l_fr := l_curfr.item.fr_next
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if not l_fr.is_void then
						if not (l_offset > 0) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_n := l_fr.item.frame_minwidth (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						if l_fr.item.fr_width - l_offset <= l_n then
							l_offset := l_offset - (l_fr.item.fr_width - l_n)
							l_fr.item.frame_new_width (l_n, (not l_left.to_boolean).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_fr.item.frame_new_width (l_fr.item.fr_width - l_offset, (not l_left.to_boolean).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
					end
					if not (l_break) then
						if l_left.to_boolean then
							l_fr := l_fr.item.fr_prev
						else
							l_fr := l_fr.item.fr_next
						end
					end
				end
				l_break := False;
				(create {P_WINDOW_STATIC}).win_comp_pos.do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SCREEN_STATIC}).redraw_all_later (40)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	win_new_height (a_height: INTEGER_32)
		local
			l_height: INTEGER_32
			l_lnum: CE_ARRAY [INTEGER_32]
			l_sline: INTEGER_32
			l_line_size: INTEGER_32
			l_tmp: INTEGER_32
			l_rows: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_lnum.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_height := a_height
					if l_height < 0 then
						l_height := 0
					end
					if w_height = l_height then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if w_wrow /= w_prev_fraction_row then
							if w_height > 0 then
								Current.w_fraction := ((w_wrow.to_integer_32 * 16_384 + 8_192) // w_height.to_integer_32).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						Current.w_height := l_height
						update_class_fields -- Current might have been changed; synchronize
						Current.w_skipcol := 0
						update_class_fields -- Current might have been changed; synchronize
						if not (l_height > 0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if (w_onebuf_opt.wo_scb).to_boolean then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if not ((c_pointer = ((create {P_GLOBALS_STATIC}).curwin.item).c_pointer)) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						l_lnum.item := w_cursor.lnum
						update_class_fields -- Current might have been changed; synchronize
						if l_lnum.item < 1 then
							l_lnum.item := (1).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
						Current.w_wrow := ((w_fraction.to_integer_32 * l_height.to_integer_32 - 1) // 16_384).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win_col (l_lnum.item, (w_cursor.col).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						l_line_size := l_tmp - 1
						l_sline := w_wrow - l_line_size
						if l_sline >= 0 then
							l_tmp___0 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win (l_lnum.item, 0)
							update_class_fields -- Current might have been changed; synchronize
							l_rows := l_tmp___0
							if l_sline > w_height - l_rows then
								l_sline := w_height - l_rows
								Current.w_wrow := w_wrow - (l_rows - l_line_size)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if l_sline < 0 then
							Current.w_wrow := l_line_size
							update_class_fields -- Current might have been changed; synchronize
							if w_wrow >= w_height then
								l_tmp___4 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off
								update_class_fields -- Current might have been changed; synchronize
								if w_width - l_tmp___4 > 0 then
									l_tmp___1 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off
									update_class_fields -- Current might have been changed; synchronize
									Current.w_skipcol := w_skipcol + (w_width - l_tmp___1)
									update_class_fields -- Current might have been changed; synchronize
									Current.w_wrow := w_wrow - 1
									update_class_fields -- Current might have been changed; synchronize
									from
									until
										not (w_wrow >= w_height)
									loop
										l_tmp___2 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___3 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_col_off2
										update_class_fields -- Current might have been changed; synchronize
										Current.w_skipcol := w_skipcol + ((w_width - l_tmp___2) + l_tmp___3)
										update_class_fields -- Current might have been changed; synchronize
										Current.w_wrow := w_wrow - 1
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
						else
							from
							until
								(l_break)
							loop
								l_break := False
								if l_sline > 0 then
									if not (l_lnum.item > 1) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasFoldingWin (l_lnum.item, l_lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer)).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									if l_lnum.item = 1 then
										l_line_size := 1
										l_sline := l_sline - 1
										l_break := True
									end
								end
								if not (l_break) then
									l_lnum.item := l_lnum.item - 1
									update_class_fields -- Current might have been changed; synchronize
									if l_lnum.item = w_topline then
										l_tmp___5 := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win_nofill (l_lnum.item, 1)
										update_class_fields -- Current might have been changed; synchronize
										l_line_size := l_tmp___5 + w_topfill
									else
										l_line_size := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win (l_lnum.item, 1)
										update_class_fields -- Current might have been changed; synchronize
									end
									l_sline := l_sline - l_line_size
								end
							end
							l_break := False
							if l_sline < 0 then
								((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.hasFoldingWin (l_lnum.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_lnum, 1, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer)).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_lnum.item := l_lnum.item + 1
								update_class_fields -- Current might have been changed; synchronize
								Current.w_wrow := w_wrow - (l_line_size + l_sline)
								update_class_fields -- Current might have been changed; synchronize
							elseif l_sline > 0 then
								l_lnum.item := (1).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
								Current.w_wrow := w_wrow - l_sline
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.set_topline (l_lnum.item)
						update_class_fields -- Current might have been changed; synchronize
				when 7 then -- if done | if done
						if (c_pointer = ((create {P_GLOBALS_STATIC}).curwin.item).c_pointer) then
							if ((create {P_OPTION_STATIC}).p_so.item.item).to_boolean then
								(create {P_MOVE_STATIC}).update_topline
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_MOVE_STATIC}).curs_columns (0)
							update_class_fields -- Current might have been changed; synchronize
						end
						Current.w_prev_fraction_row := w_wrow
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.win_comp_scroll
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.redraw_win_later (35)
						update_class_fields -- Current might have been changed; synchronize
						Current.w_redr_status := 1
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.invalidate_botline_win
						update_class_fields -- Current might have been changed; synchronize
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	win_new_width (a_width: INTEGER_32)
		do
			Current.w_width := a_width
			update_class_fields -- Current might have been changed; synchronize
			Current.w_lines_valid := 0
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.changed_line_abv_curs_win
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.invalidate_botline_win
			update_class_fields -- Current might have been changed; synchronize
			if (c_pointer = ((create {P_GLOBALS_STATIC}).curwin.item).c_pointer) then
				(create {P_MOVE_STATIC}).update_topline
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MOVE_STATIC}).curs_columns (1)
				update_class_fields -- Current might have been changed; synchronize
			end
			((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.redraw_win_later (40)
			update_class_fields -- Current might have been changed; synchronize
			Current.w_redr_status := 1
			update_class_fields -- Current might have been changed; synchronize
		end

	win_comp_scroll
		do
			w_onebuf_opt.wo_scr := ((w_height.to_natural_32).bit_shift_right (1)).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			if w_onebuf_opt.wo_scr = 0 then
				w_onebuf_opt.wo_scr := 1
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	match_delete (a_id, a_perr: INTEGER_32): INTEGER_32
		local
			l_cur: CE_POINTER [PD_MATCHITEM]
			l_prev: CE_POINTER [PD_MATCHITEM]
			l_return, l_break: BOOLEAN
		do
			l_cur := w_match_head
			l_prev := l_cur
			if a_id < 1 then
				if a_perr = 1 then
					(create {P_MISC2_STATIC}).emsgn (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E802: Invalid ID: %%ld (must be greater than or equal to 1)")), a_id.to_integer_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := (-1)
				l_return := True
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					if not l_cur.is_void then
						if l_cur.item.id = a_id then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_prev := l_cur
						l_cur := l_cur.item.next
					end
				end
				l_break := False
				if l_cur.is_void then
					if a_perr = 1 then
						(create {P_MISC2_STATIC}).emsgn (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("E803: ID not found: %%ld")), a_id.to_integer_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				if l_cur.is_equal (l_prev) then
					Current.w_match_head := l_cur.item.next
					update_class_fields -- Current might have been changed; synchronize
				else
					l_prev.item.next := l_cur.item.next
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cur.item.match.regprog))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cur.item.pattern))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cur))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_SCREEN_STATIC}).redraw_later (35)
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

	clear_matches
		local
			l_m: CE_POINTER [PD_MATCHITEM]
		do
			from
			until
				w_match_head.is_void
			loop
				l_m := w_match_head.item.next;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (w_match_head.item.match.regprog))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (w_match_head.item.pattern))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (w_match_head))
				update_class_fields -- Current might have been changed; synchronize
				Current.w_match_head := l_m
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_SCREEN_STATIC}).redraw_later (35)
			update_class_fields -- Current might have been changed; synchronize
		end

	get_match (a_id: INTEGER_32): CE_POINTER [PD_MATCHITEM]
		local
			l_cur: CE_POINTER [PD_MATCHITEM]
			l_break: BOOLEAN
		do
			l_cur := w_match_head
			from
			until
				(l_break)
			loop
				l_break := False
				if not l_cur.is_void then
					if l_cur.item.id = a_id then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_cur := l_cur.item.next
				end
			end
			l_break := False
			Result := l_cur
		end

	gui_do_scrollbar (a_which, a_enable: INTEGER_32)
		local
			l_enable: INTEGER_32
			l_midcol: INTEGER_32
			l_has_midcol: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			l_enable := a_enable
			l_midcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wincol + (create {P_GLOBALS_STATIC}).curwin.item.item.w_width // 2
			if w_wincol <= l_midcol then
				if w_wincol + w_width >= l_midcol then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			l_has_midcol := l_tmp
			if (create {P_GUI_STATIC}).gui.item.item.which_scrollbars[1] /= (create {P_GUI_STATIC}).gui.item.item.which_scrollbars[0] then
				if not l_has_midcol.to_boolean then
					l_enable := 0
				end
			elseif l_midcol.to_integer_32 > (create {P_GLOBALS_STATIC}).Columns.item.item // 2 then
				if a_which = 0 then
					l_tmp___0 := (w_wincol /= 0).to_integer
				else
					l_tmp___0 := (not l_has_midcol.to_boolean).to_integer
				end
				if l_tmp___0.to_boolean then
					l_enable := 0
				end
			else
				if a_which = 1 then
					l_tmp___1 := ((w_wincol + w_width).to_integer_32 /= (create {P_GLOBALS_STATIC}).Columns.item.item).to_integer
				else
					l_tmp___1 := (not l_has_midcol.to_boolean).to_integer
				end
				if l_tmp___1.to_boolean then
					l_enable := 0
				end
			end
			(create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_scrollbars") + (create {PD_GUISCROLLBAR}.make).structure_size * (a_which))).item.gui_mch_enable_scrollbar (l_enable)
			update_class_fields -- Current might have been changed; synchronize
		end

	lineFolded (a_lnum: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.foldedCount (a_lnum, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
			Result := (l_tmp /= 0).to_integer
		end

	plines_win (a_lnum: INTEGER_32; a_winheight: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer))).item.plines_win_nofill (a_lnum, a_winheight)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_DIFF_STATIC}).diff_check_fill ((create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (c_pointer)), a_lnum)
			update_class_fields -- Current might have been changed; synchronize
			Result := (l_tmp + l_tmp___0)
		end

feature {PD_WINDOW_S} -- private routines

	qf_free_all (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_i___0: INTEGER_32
			l_qi: CE_POINTER [PD_QF_INFO_S]
		do
			l_qi := (create {P_QUICKFIX_STATIC}).ql_info.item
			if not a_wp___0.is_void then
				(create {P_QUICKFIX_STATIC}).ll_free_all (create {CE_POINTER_POINTER [PD_QF_INFO_S]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_llist")));
				(create {P_QUICKFIX_STATIC}).ll_free_all (create {CE_POINTER_POINTER [PD_QF_INFO_S]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_llist_ref")))
			else
				l_i___0 := 0
				from
				until
					not (l_i___0 < l_qi.item.qf_listcount)
				loop
					l_qi.item.qf_free (l_i___0)
					l_i___0 := l_i___0 + 1
				end
			end
		end

	win_do_lines (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_row, a_line_count, a_mayclear, a_del: INTEGER_32): INTEGER_32
		local
			l_retval: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_SCREEN_STATIC}).redrawing).to_boolean then
						if a_line_count <= 0 then
							Result := 0
							l_return := True
						end
					else
						Result := 0
						l_return := True
					end
					if not l_return and then (a_mayclear.to_boolean) then
						if (create {P_GLOBALS_STATIC}).Rows.item.item - a_line_count.to_integer_32 < 5 then
							if (a_wp___0.item.w_width).to_integer_32 = (create {P_GLOBALS_STATIC}).Columns.item.item then
								(create {P_SCREEN_STATIC}).screenclear
								Result := 0
								l_return := True
							end
						end
					end
					if not l_return and then (a_row + a_line_count >= a_wp___0.item.w_height) then
						(create {P_SCREEN_STATIC}).screen_fill (a_wp___0.item.w_winrow + a_row, a_wp___0.item.w_winrow + a_wp___0.item.w_height, a_wp___0.item.w_wincol, a_wp___0.item.w_wincol + a_wp___0.item.w_width, (' ').code, (' ').code, 0)
						Result := 1
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:;
						(create {P_GLOBALS_STATIC}).clear_cmdline.item := 1
						if not (((create {P_GLOBALS_STATIC}).scroll_region.item).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (a_wp___0.item.w_width).to_integer_32 = (create {P_GLOBALS_STATIC}).Columns.item.item then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if ((create {P_GLOBALS_STATIC}).scroll_region.item).to_boolean then
							if (a_wp___0.item.w_width).to_integer_32 = (create {P_GLOBALS_STATIC}).Columns.item.item then
								a_wp___0.item.scroll_region_set (a_row)
							elseif (((create {P_TERM_STATIC}).term_strings.item[55]).item).to_integer_32 /= 0 then
								a_wp___0.item.scroll_region_set (a_row)
							end
						end
						if a_del.to_boolean then
							l_retval := (create {P_SCREEN_STATIC}).screen_del_lines (a_wp___0.item.w_winrow + a_row, 0, a_line_count, a_wp___0.item.w_height - a_row, 0, a_wp___0)
						else
							l_retval := (create {P_SCREEN_STATIC}).screen_ins_lines (a_wp___0.item.w_winrow + a_row, 0, a_line_count, a_wp___0.item.w_height - a_row, a_wp___0)
						end
						if ((create {P_GLOBALS_STATIC}).scroll_region.item).to_boolean then
							if (a_wp___0.item.w_width).to_integer_32 = (create {P_GLOBALS_STATIC}).Columns.item.item then
								(create {P_TERM_STATIC}).scroll_region_reset
							elseif (((create {P_TERM_STATIC}).term_strings.item[55]).item).to_integer_32 /= 0 then
								(create {P_TERM_STATIC}).scroll_region_reset
							end
						end
						Result := l_retval
						l_return := True
				when 6 then -- if done | if done
					if not l_return and then (not (a_wp___0.item.w_next).is_void) then
						if ((create {P_OPTION_STATIC}).p_tf.item.item).to_boolean then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						Result := 2
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	win_chartabsize (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_p___0: CE_POINTER [NATURAL_8]; a_col: INTEGER_32): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_ts: INTEGER_32
			l_tmp: INTEGER_32
		do
			if (a_p___0.item).to_integer_32 = 9 then
				if not (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
					l_ts := ((a_wp___0.item.w_buffer).item.b_p_ts).to_integer_32
					Result := (l_ts - a_col \\ l_ts)
				elseif ((create {P_GLOBALS_STATIC}).lcs_tab1.item).to_boolean then
					l_ts := ((a_wp___0.item.w_buffer).item.b_p_ts).to_integer_32
					Result := (l_ts - a_col \\ l_ts)
				else
					l_tmp := (create {P_CHARSET_STATIC}).ptr2cells (a_p___0)
					Result := l_tmp
				end
			else
				l_tmp := (create {P_CHARSET_STATIC}).ptr2cells (a_p___0)
				Result := l_tmp
			end
		end

	skiphex (a_q: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_q.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			l_p___0 := a_q
			from
			until
				(l_break)
			loop
				l_break := False
				if not ((create {P_CHARSET_STATIC}).vim_isxdigit ((l_p___0.item).to_integer_32)).to_boolean then
					l_break := True
				end
				if not (l_break) then
					l_p___0 := l_p___0 + 1
				end
			end
			l_break := False
			Result := l_p___0
		end

	foldOpenNested (a_fpr: CE_POINTER [PD_FOLD_T])
		require
			not a_fpr.is_void
		local
			l_i___0: INTEGER_32
			l_fp: CE_POINTER [PD_FOLD_T]
		do
			l_fp := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_fpr.item.fd_nested.ga_data)
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_fpr.item.fd_nested.ga_len)
			loop
				foldOpenNested (l_fp + l_i___0);
				(l_fp + l_i___0).item.fd_flags := (0).to_integer_8
				l_i___0 := l_i___0 + 1
			end
		end

	foldUpdateIEMS (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_top, a_bot: INTEGER_32)
		local
			l_top: INTEGER_32
			l_bot: INTEGER_32
			l_start___1: INTEGER_32
			l_end: INTEGER_32
			l_fline: CE_ARRAY [PD_FLINE_T]
			l_getlevel: CE_ROUTINE
			l_level: INTEGER_32
			l_fp: CE_ARRAY [CE_POINTER [PD_FOLD_T]]
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_fpn: CE_ARRAY [CE_POINTER [PD_FOLD_T]]
			l_current_fdl: INTEGER_32
			l_fold_start_lnum: INTEGER_32
			l_lnum_rel: INTEGER_32
			l_fold_end_lnum: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_FLINE_T]} l_fline.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_FOLD_T]} l_fp.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_FOLD_T]} l_fpn.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_top := a_top
					l_bot := a_bot
					if (create {P_FOLD_STATIC}).invalid_top.item /= 0 then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if (a_wp___0.item.w_foldinvalid).to_boolean then
							l_top := (1).to_integer_32
							l_bot := (a_wp___0.item.w_buffer).item.b_ml.ml_line_count
							a_wp___0.item.w_foldinvalid := (0).to_integer_8;
							(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds"))).item.setSmallMaybe
						end
						if (a_wp___0.item.foldmethodIsDiff).to_boolean then
							if l_top > ((create {P_GLOBALS_STATIC}).diff_context.item).to_integer_32 then
								l_top := l_top - ((create {P_GLOBALS_STATIC}).diff_context.item).to_integer_32
							else
								l_top := (1).to_integer_32
							end
							l_bot := l_bot + ((create {P_GLOBALS_STATIC}).diff_context.item).to_integer_32
						end
						if l_top > (a_wp___0.item.w_buffer).item.b_ml.ml_line_count then
							l_top := (a_wp___0.item.w_buffer).item.b_ml.ml_line_count
						end
						fold_changed.item := 0
						l_fline.item.wp := a_wp___0
						l_fline.item.off := (0).to_integer_32
						l_fline.item.lvl := 0
						l_fline.item.lvl_next := -1
						l_fline.item.start := 0
						l_fline.item.end2 := 21
						l_fline.item.had_end := 21;
						(create {P_FOLD_STATIC}).invalid_top.item := l_top;
						(create {P_FOLD_STATIC}).invalid_bot.item := l_bot
						if (a_wp___0.item.foldmethodIsMarker).to_boolean then
							l_getlevel := (create {PD_FLINE_T_STATIC}).foldlevelMarker_address
							a_wp___0.item.parseMarker
							if l_top > 1 then
								l_level := (create {P_FOLD_STATIC}).foldLevelWin (a_wp___0, l_top - 1)
								l_fline.item.lnum := l_top - 1
								l_fline.item.lvl := l_level
								l_getlevel.call ([l_fline])
								if l_fline.item.lvl > l_level then
									l_fline.item.lvl := l_level - (l_fline.item.lvl - l_fline.item.lvl_next)
								else
									l_fline.item.lvl := l_fline.item.lvl_next
								end
							end
							l_fline.item.lnum := l_top
							l_getlevel.call ([l_fline])
						else
							l_fline.item.lnum := l_top
							if (a_wp___0.item.foldmethodIsExpr).to_boolean then
								l_getlevel := (create {PD_FLINE_T_STATIC}).foldlevelExpr_address
								if l_top > 1 then
									l_fline.item.lnum := (l_fline.item.lnum) - 1
								end
							elseif (a_wp___0.item.foldmethodIsSyntax).to_boolean then
								l_getlevel := (create {PD_FLINE_T_STATIC}).foldlevelSyntax_address
							elseif (a_wp___0.item.foldmethodIsDiff).to_boolean then
								l_getlevel := (create {PD_FLINE_T_STATIC}).foldlevelDiff_address
							else
								l_getlevel := (create {PD_FLINE_T_STATIC}).foldlevelIndent_address
							end
							l_fline.item.lvl := -1
							from
							until
								not (not (l_break) and then (not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean))
							loop
								l_break := False
								l_fline.item.lvl_next := -1
								l_getlevel.call ([l_fline])
								if l_fline.item.lvl >= 0 then
									l_break := True
								end
								if not (l_break) then
									l_fline.item.lnum := (l_fline.item.lnum) - 1
								end
							end
							l_break := False
						end
						if ((create {PD_FLINE_T_STATIC}).foldlevelSyntax_address).is_equal (l_getlevel) then
							l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds"))
							l_fpn.item := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_shared (default_pointer)
							l_current_fdl := 0
							l_fold_start_lnum := (0).to_integer_32
							l_lnum_rel := l_fline.item.lnum
							from
							until
								not (not (l_break) and then (l_current_fdl < l_fline.item.lvl))
							loop
								l_break := False
								if not (l_gap.item.foldFind (l_lnum_rel, l_fpn)).to_boolean then
									l_break := True
								end
								if not (l_break) then
									l_current_fdl := l_current_fdl + 1
									l_fold_start_lnum := l_fold_start_lnum + (l_fpn.item.item.fd_top)
									l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fpn.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))
									l_lnum_rel := l_lnum_rel - (l_fpn.item.item.fd_top)
								end
							end
							l_break := False
							if not (l_fpn.item).is_void then
								if l_current_fdl = l_fline.item.lvl then
									l_fold_end_lnum := l_fold_start_lnum + l_fpn.item.item.fd_len
									if l_fold_end_lnum > l_bot then
										l_bot := l_fold_end_lnum
									end
								end
							end
						end
						l_start___1 := l_fline.item.lnum
						l_end := l_bot
						if l_start___1 > l_end then
							if l_end < (a_wp___0.item.w_buffer).item.b_ml.ml_line_count then
								l_end := l_start___1
							end
						end
				when 2 then -- loop condition:
						if not (not (l_break) and then (not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if l_fline.item.lnum > (a_wp___0.item.w_buffer).item.b_ml.ml_line_count then
							l_break := True
						end
						if not (not (l_break) and then (l_fline.item.lnum > l_end)) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if not l_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelMarker_address) then
							if not l_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelSyntax_address) then
								if not l_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelExpr_address) then
									l_break := True
								end
							end
						end
						if (l_break) then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if:
						if not (l_start___1 <= l_end) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds"))).item.foldFind (l_end, l_fp)).to_boolean then
							if (l_fp.item.item.fd_top + l_fp.item.item.fd_len) - 1 > l_end then
								l_end := (l_fp.item.item.fd_top + l_fp.item.item.fd_len) - 1
							else
								l_pos := -1 + 8 -- goto _L___2
							end
						else
							l_pos := -1 + 8 -- goto _L___2
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else: | _L___2:
						if l_fline.item.lvl /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds"))).item.foldFind (l_fline.item.lnum, l_fp)).to_boolean then
							if l_fp.item.item.fd_top < l_fline.item.lnum then
								l_end := (l_fp.item.item.fd_top + l_fp.item.item.fd_len) - 1
							else
								l_pos := -1 + 11 -- goto _L___0
							end
						else
							l_pos := -1 + 11 -- goto _L___0
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L___0:
						if l_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelSyntax_address) then
							if ((create {P_FOLD_STATIC}).foldLevelWin (a_wp___0, l_fline.item.lnum)) /= l_fline.item.lvl then
								l_end := l_fline.item.lnum
							else
								l_break := True
							end
						else
							l_break := True
						end
				when 12 then -- if done | if done | if done
						if not (l_break) then
							if l_fline.item.lvl > 0 then
								(create {P_FOLD_STATIC}).invalid_top.item := l_fline.item.lnum;
								(create {P_FOLD_STATIC}).invalid_bot.item := l_end
								l_end := foldUpdateIEMSRecurse (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds")), 1, l_start___1, l_fline, l_getlevel, l_end, 2)
								l_start___1 := l_fline.item.lnum
							else
								if l_fline.item.lnum = (a_wp___0.item.w_buffer).item.b_ml.ml_line_count then
									l_break := True
								end
								if not (l_break) then
									l_fline.item.lnum := (l_fline.item.lnum) + 1
									l_fline.item.lvl := l_fline.item.lvl_next
									l_getlevel.call ([l_fline])
								end
							end
						end
						l_pos := -1 + 2 -- back to loop condition
				when 13 then -- loop done
						l_break := False
						foldRemove (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds")), l_start___1, l_end)
						if fold_changed.item.to_boolean then
							if (a_wp___0.item.w_onebuf_opt.wo_fen).to_boolean then
								a_wp___0.item.changed_window_setting_win
							end
						end
						if l_end /= l_bot then
							if a_wp___0.item.w_redraw_top = 0 then
								a_wp___0.item.w_redraw_top := l_top
							elseif a_wp___0.item.w_redraw_top > l_top then
								a_wp___0.item.w_redraw_top := l_top
							end
							if a_wp___0.item.w_redraw_bot < l_end then
								a_wp___0.item.w_redraw_bot := l_end
							end
						end
						(create {P_FOLD_STATIC}).invalid_top.item := (0).to_integer_32
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	foldUpdateIEMSRecurse (a_gap: CE_POINTER [PD_GROWARRAY]; a_level: INTEGER_32; a_startlnum: INTEGER_32; a_flp: CE_POINTER [PD_FLINE_T]; a_getlevel: CE_ROUTINE; a_bot: INTEGER_32; a_topflags: INTEGER_32): INTEGER_32
		require
			not a_flp.is_void
		local
			l_bot: INTEGER_32
			l_ll: INTEGER_32
			l_fp: CE_ARRAY [CE_POINTER [PD_FOLD_T]]
			l_fp2: CE_ARRAY [CE_POINTER [PD_FOLD_T]]
			l_lvl: INTEGER_32
			l_startlnum2: INTEGER_32
			l_firstlnum: INTEGER_32
			l_i___0: INTEGER_32
			l_finish: INTEGER_32
			l_linecount: INTEGER_32
			l_concat: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_FOLD_T]} l_fp.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_FOLD_T]} l_fp2.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bot := a_bot
					l_fp.item := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_shared (default_pointer)
					l_lvl := a_level
					l_startlnum2 := a_startlnum
					l_firstlnum := a_flp.item.lnum
					l_finish := 0
					l_linecount := ((a_flp.item.wp).item.w_buffer).item.b_ml.ml_line_count - a_flp.item.off
					if a_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelMarker_address) then
						if a_flp.item.start <= a_flp.item.lvl - a_level then
							if a_flp.item.lvl > 0 then
								a_gap.item.foldFind (a_startlnum - 1, l_fp).do_nothing
								if ((l_fp.item).c_pointer.to_integer_32).to_natural_32 >= ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len).c_pointer.to_integer_32).to_natural_32 then
									l_fp.item := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_shared (default_pointer)
								elseif l_fp.item.item.fd_top >= a_startlnum then
									l_fp.item := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_shared (default_pointer)
								end
							end
						end
					end
					a_flp.item.lnum_save := a_flp.item.lnum
				when 1 then -- loop condition:
					if not (not (l_return or l_break) and then (not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean)) then
						l_pos := -1 + 55 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False;
						(create {P_MISC1_STATIC}).line_breakcheck
						l_lvl := a_flp.item.lvl
						if l_lvl > 20 then
							l_lvl := 20
						end
						if a_flp.item.lnum > l_firstlnum then
							if a_level > l_lvl - a_flp.item.start then
								l_lvl := 0
							elseif a_level >= a_flp.item.had_end then
								l_lvl := 0
							end
						end
						if a_flp.item.lnum > l_bot then
							if not l_finish.to_boolean then
								if not (l_fp.item).is_void then
									if not a_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelMarker_address) then
										if not a_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelExpr_address) then
											if not a_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelSyntax_address) then
												l_break := True
											end
										end
									end
									if not (l_return or l_break) then
										l_i___0 := 0
										l_fp2.item := l_fp.item
										if l_lvl >= a_level then
											l_ll := a_flp.item.lnum - l_fp.item.item.fd_top
											from
											until
												(l_break)
											loop
												l_break := False
												if not ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp2.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))).item.foldFind (l_ll, l_fp2)).to_boolean then
													l_break := True
												end
												if not (l_break) then
													l_i___0 := l_i___0 + 1
													l_ll := l_ll - (l_fp2.item.item.fd_top)
												end
											end
											l_break := False
										end
										if l_lvl < a_level + l_i___0 then
											(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))).item.foldFind (a_flp.item.lnum - l_fp.item.item.fd_top, l_fp2).do_nothing
											if not (l_fp2.item).is_void then
												l_bot := ((l_fp2.item.item.fd_top + l_fp2.item.item.fd_len) - 1) + l_fp.item.item.fd_top
											end
										elseif l_fp.item.item.fd_top + l_fp.item.item.fd_len <= a_flp.item.lnum then
											if l_lvl >= a_level then
												l_finish := 1
											else
												l_break := True
											end
										else
											l_break := True
										end
									end
								end
							end
						end
						if (l_return or l_break) then
							l_pos := -1 + 54 -- skip if block
						end
				when 3 then -- if:
						if not ((l_fp.item).is_void) then
							l_pos := -1 + 48 -- skip if block
						end
				when 4 then -- if:
						if l_lvl = a_level then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 17 -- goto _L___5
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 7 then -- else:
						if not (a_flp.item.lnum_save >= l_bot) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 17 -- goto _L___5
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 10 then -- else:
						if a_flp.item.start = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 17 -- goto _L___5
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 13 then -- else:
						if not (a_flp.item.had_end <= 20) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___5
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 16 then -- else:
						if a_flp.item.lnum /= l_linecount then
							l_pos := -1 + 48 -- skip if block
						end
				when 17 then -- if: | _L___5:
						if not (not (l_return or l_break) and then (not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean)) then
							l_pos := -1 + 47 -- skip loop
						end
				when 18 then -- loop body:
						l_break := False
						if a_flp.item.start /= 0 then
							l_concat := 0
						elseif a_flp.item.had_end <= 20 then
							l_concat := 0
						else
							l_concat := 1
						end
						if not ((a_gap.item.foldFind (a_startlnum, l_fp)).to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 33 -- goto _L___2
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 21 then -- else:
						if not (((l_fp.item).c_pointer.to_integer_32).to_natural_32 < ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if l_fp.item.item.fd_top <= l_firstlnum then
							l_pos := -1 + 33 -- goto _L___2
						else
							l_pos := -1 + 24 -- goto _L___4
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 24 then -- else: | _L___4:
						if not ((a_gap.item.foldFind (l_firstlnum - l_concat.to_integer_32, l_fp)).to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 33 -- goto _L___2
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 27 then -- else:
						if not (((l_fp.item).c_pointer.to_integer_32).to_natural_32 < ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 45 -- skip if block
						end
				when 28 then -- if:
						if not (l_lvl < a_level) then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						if l_fp.item.item.fd_top < a_flp.item.lnum then
							l_pos := -1 + 33 -- goto _L___2
						else
							l_pos := -1 + 31 -- goto _L___3
						end
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 31 then -- else: | _L___3:
						if not (l_lvl >= a_level) then
							l_pos := -1 + 43 -- skip if block
						end
				when 32 then -- if:
						if not (l_fp.item.item.fd_top <= a_flp.item.lnum_save) then
							l_pos := -1 + 41 -- skip if block
						end
				when 33 then -- if: | _L___2:
						if not ((l_fp.item.item.fd_top + l_fp.item.item.fd_len) + l_concat.to_integer_32 > l_firstlnum) then
							l_pos := -1 + 39 -- skip if block
						end
				when 34 then -- if:
						if not (l_fp.item.item.fd_top >= a_startlnum) then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						if l_fp.item.item.fd_top /= l_firstlnum then
							if l_fp.item.item.fd_top > l_firstlnum then
								(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))).item.foldMarkAdjustRecurse ((0).to_integer_32, 2_147_483_647, l_fp.item.item.fd_top - l_firstlnum, 0)
							else
								(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))).item.foldMarkAdjustRecurse ((0).to_integer_32, (l_firstlnum - l_fp.item.item.fd_top) - 1, 2_147_483_647, l_fp.item.item.fd_top - l_firstlnum)
							end
							l_fp.item.item.fd_len := l_fp.item.item.fd_len + (l_fp.item.item.fd_top - l_firstlnum)
							l_fp.item.item.fd_top := l_firstlnum
							fold_changed.item := 1
						else
							l_pos := -1 + 37 -- goto _L
						end
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else: | _L:
						if a_flp.item.start /= 0 then
							if l_lvl = a_level then
								if l_fp.item.item.fd_top /= l_firstlnum then
									foldRemove (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested")), a_flp.item.lnum - l_fp.item.item.fd_top, a_flp.item.lnum - l_fp.item.item.fd_top)
									l_i___0 := (l_fp.item).distance ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data)))
									foldSplit (a_gap, l_i___0, a_flp.item.lnum, a_flp.item.lnum - 1)
									l_fp.item := (create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + l_i___0) + 1
									if a_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelMarker_address) then
										l_finish := 1
									elseif a_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelExpr_address) then
										l_finish := 1
									elseif a_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelSyntax_address) then
										l_finish := 1
									end
								end
							end
						end
				when 38 then
						l_break := True
				when 39 then -- if done
						if not (l_return or l_break) then
							if l_fp.item.item.fd_top >= a_startlnum then
								a_gap.item.deleteFoldEntry ((l_fp.item).distance ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data))), 1)
							else
								l_fp.item.item.fd_len := a_startlnum - l_fp.item.item.fd_top;
								(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))).item.foldMarkAdjustRecurse (l_fp.item.item.fd_len, 2_147_483_647, 2_147_483_647, 0)
								fold_changed.item := 1
							end
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else:
						l_pos := -1 + 45 -- goto _L___1
				when 42 then -- if done | if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else:
						l_pos := -1 + 45 -- goto _L___1
				when 44 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else: | _L___1:
						l_i___0 := (l_fp.item).distance ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data)))
						if (foldInsert (a_gap, l_i___0)) /= 1 then
							Result := l_bot
							l_return := True
						end
						if not l_return then
							l_fp.item := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + l_i___0
							l_fp.item.item.fd_top := l_firstlnum
							l_fp.item.item.fd_len := (l_bot - l_firstlnum) + 1
							if a_topflags = 0 then
								(a_flp.item.wp).item.w_fold_manual := (1).to_integer_8
								l_fp.item.item.fd_flags := (0).to_integer_8
							elseif l_i___0 <= 0 then
								l_fp.item.item.fd_flags := a_topflags.to_integer_8
								if a_topflags /= 2 then
									(a_flp.item.wp).item.w_fold_manual := (1).to_integer_8
								end
							else
								l_fp.item.item.fd_flags := (l_fp.item - 1).item.fd_flags
							end
							l_fp.item.item.fd_small := (2).to_integer_8
							if a_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelMarker_address) then
								l_finish := 1
							elseif a_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelExpr_address) then
								l_finish := 1
							elseif a_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelSyntax_address) then
								l_finish := 1
							end
							fold_changed.item := 1
							l_break := True
						end
				when 46 then -- if done | if done | if done
						l_pos := -1 + 17 -- back to loop condition
				when 47 then -- loop done
						if not l_return then
							l_break := False
						end
				when 48 then -- if done | if done | if done | if done | if done
						if l_return then
							l_pos := -1 + 54 -- skip if block
						end
				when 49 then -- if:
						if l_lvl < a_level then
							l_break := True
						elseif a_flp.item.lnum > l_linecount then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 54 -- skip if block
						end
				when 50 then -- if:
						if not (l_lvl > a_level) then
							l_pos := -1 + 53 -- skip if block
						end
				when 51 then -- if:
						if not (l_fp.item).is_void then
							if l_bot < a_flp.item.lnum then
								l_bot := a_flp.item.lnum
							end
							a_flp.item.lnum := a_flp.item.lnum_save - l_fp.item.item.fd_top
							a_flp.item.off := a_flp.item.off + (l_fp.item.item.fd_top)
							l_i___0 := (l_fp.item).distance ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data)))
							l_bot := foldUpdateIEMSRecurse (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested")), a_level + 1, l_startlnum2 - l_fp.item.item.fd_top, a_flp, a_getlevel, l_bot - l_fp.item.item.fd_top, (l_fp.item.item.fd_flags).to_integer_32)
							l_fp.item := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + l_i___0
							a_flp.item.lnum := a_flp.item.lnum + (l_fp.item.item.fd_top)
							a_flp.item.lnum_save := a_flp.item.lnum_save + (l_fp.item.item.fd_top)
							a_flp.item.off := a_flp.item.off - (l_fp.item.item.fd_top)
							l_bot := l_bot + (l_fp.item.item.fd_top)
							l_startlnum2 := a_flp.item.lnum
						else
							l_pos := -1 + 53 -- goto _L___6
						end
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 53 then -- else: | _L___6:
						a_flp.item.lnum := a_flp.item.lnum_save
						l_ll := a_flp.item.lnum + 1
						from
						until
							not (not (l_break) and then (not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean))
						loop
							l_break := False;
							(create {P_FOLD_STATIC}).prev_lnum___0.item := a_flp.item.lnum;
							(create {P_FOLD_STATIC}).prev_lnum_lvl.item := a_flp.item.lvl
							a_flp.item.lnum := (a_flp.item.lnum) + 1
							if a_flp.item.lnum > l_linecount then
								l_break := True
							end
							if not (l_return or l_break) then
								a_flp.item.lvl := a_flp.item.lvl_next
								a_getlevel.call ([a_flp])
								if a_flp.item.lvl >= 0 then
									l_break := True
								elseif a_flp.item.had_end <= 20 then
									l_break := True
								end
							end
						end
						l_break := False;
						(create {P_FOLD_STATIC}).prev_lnum___0.item := (0).to_integer_32
						if a_flp.item.lnum > l_linecount then
							l_break := True
						end
						if not (l_return or l_break) then
							a_flp.item.lnum_save := a_flp.item.lnum
							a_flp.item.lnum := l_ll
						end
				when 54 then -- if done | if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 55 then -- loop done
					if not l_return then
						l_break := False
						if (l_fp.item).is_void then
							Result := l_bot
							l_return := True
						end
					end
					if not l_return then
						if l_fp.item.item.fd_len < a_flp.item.lnum - l_fp.item.item.fd_top then
							l_fp.item.item.fd_len := a_flp.item.lnum - l_fp.item.item.fd_top
							l_fp.item.item.fd_small := (2).to_integer_8
							fold_changed.item := 1
						end
						foldRemove (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested")), l_startlnum2 - l_fp.item.item.fd_top, (a_flp.item.lnum - 1) - l_fp.item.item.fd_top)
						if l_lvl < a_level then
							if l_fp.item.item.fd_len /= a_flp.item.lnum - l_fp.item.item.fd_top then
								if l_fp.item.item.fd_top + l_fp.item.item.fd_len > l_bot + 1 then
									if a_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelMarker_address) then
										l_bot := (l_fp.item.item.fd_top + l_fp.item.item.fd_len) - 1
										l_fp.item.item.fd_len := a_flp.item.lnum - l_fp.item.item.fd_top
									elseif a_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelExpr_address) then
										l_bot := (l_fp.item.item.fd_top + l_fp.item.item.fd_len) - 1
										l_fp.item.item.fd_len := a_flp.item.lnum - l_fp.item.item.fd_top
									elseif a_getlevel.is_equal ((create {PD_FLINE_T_STATIC}).foldlevelSyntax_address) then
										l_bot := (l_fp.item.item.fd_top + l_fp.item.item.fd_len) - 1
										l_fp.item.item.fd_len := a_flp.item.lnum - l_fp.item.item.fd_top
									else
										l_i___0 := (l_fp.item).distance ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data)))
										foldSplit (a_gap, l_i___0, a_flp.item.lnum, l_bot)
										l_fp.item := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + l_i___0
									end
								else
									l_fp.item.item.fd_len := a_flp.item.lnum - l_fp.item.item.fd_top
								end
								fold_changed.item := 1
							end
						end
						from
						until
							(l_break)
						loop
							l_break := False
							l_fp2.item := l_fp.item + 1
							if ((l_fp2.item).c_pointer.to_integer_32).to_natural_32 >= ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len).c_pointer.to_integer_32).to_natural_32 then
								l_break := True
							elseif l_fp2.item.item.fd_top > a_flp.item.lnum then
								l_break := True
							end
							if not (l_return or l_break) and then (l_fp2.item.item.fd_top + l_fp2.item.item.fd_len > a_flp.item.lnum) then
								if l_fp2.item.item.fd_top < a_flp.item.lnum then
									(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp2.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))).item.foldMarkAdjustRecurse ((0).to_integer_32, (a_flp.item.lnum - l_fp2.item.item.fd_top) - 1, 2_147_483_647, l_fp2.item.item.fd_top - a_flp.item.lnum)
									l_fp2.item.item.fd_len := l_fp2.item.item.fd_len - (a_flp.item.lnum - l_fp2.item.item.fd_top)
									l_fp2.item.item.fd_top := a_flp.item.lnum
									fold_changed.item := 1
								end
								if l_lvl >= a_level then
									foldMerge (l_fp.item, a_gap, l_fp2.item)
								end
								l_break := True
							end
							if not (l_return or l_break) then
								fold_changed.item := 1
								a_gap.item.deleteFoldEntry ((l_fp2.item).distance ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data))), 1)
							end
						end
						l_break := False
						if l_bot < a_flp.item.lnum - 1 then
							l_bot := a_flp.item.lnum - 1
						end
						Result := l_bot
					end
				when 56 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	foldRemove (a_gap: CE_POINTER [PD_GROWARRAY]; a_top, a_bot: INTEGER_32)
		local
			l_fp: CE_ARRAY [CE_POINTER [PD_FOLD_T]]
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_FOLD_T]} l_fp.make (<<1>>)

			l_fp.item := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_shared (default_pointer)
			if a_bot < a_top then
				l_return := True
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					l_continue := False
					if (a_gap.item.foldFind (a_top, l_fp)).to_boolean then
						if l_fp.item.item.fd_top < a_top then
							foldRemove (create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested")), a_top - l_fp.item.item.fd_top, a_bot - l_fp.item.item.fd_top)
							if l_fp.item.item.fd_top + l_fp.item.item.fd_len > a_bot + 1 then
								foldSplit (a_gap, (l_fp.item).distance ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data))), a_top, a_bot)
							else
								l_fp.item.item.fd_len := a_top - l_fp.item.item.fd_top
							end
							fold_changed.item := 1
							l_continue := True
						end
					end
					if not (l_break or l_continue) then
						if ((l_fp.item).c_pointer.to_integer_32).to_natural_32 >= ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len).c_pointer.to_integer_32).to_natural_32 then
							l_break := True
						elseif l_fp.item.item.fd_top > a_bot then
							l_break := True
						end
					end
					if not (l_break or l_continue) and then (l_fp.item.item.fd_top >= a_top) then
						fold_changed.item := 1
						if (l_fp.item.item.fd_top + l_fp.item.item.fd_len) - 1 > a_bot then
							(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))).item.foldMarkAdjustRecurse ((0).to_integer_32, a_bot - l_fp.item.item.fd_top, 2_147_483_647, (l_fp.item.item.fd_top - a_bot) - 1)
							l_fp.item.item.fd_len := l_fp.item.item.fd_len - ((a_bot - l_fp.item.item.fd_top) + 1)
							l_fp.item.item.fd_top := a_bot + 1
							l_break := True
						end
						if not (l_break or l_continue) then
							a_gap.item.deleteFoldEntry ((l_fp.item).distance ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data))), 1)
						end
					end
					if (not l_break) then
						
					end
				end
				l_break := False
				l_continue := False
			end
		end

	foldSplit (a_gap: CE_POINTER [PD_GROWARRAY]; a_i___0: INTEGER_32; a_top, a_bot: INTEGER_32)
		require
			not a_gap.is_void
		local
			l_fp: CE_POINTER [PD_FOLD_T]
			l_fp2: CE_ARRAY [CE_POINTER [PD_FOLD_T]]
			l_gap1: CE_POINTER [PD_GROWARRAY]
			l_gap2: CE_POINTER [PD_GROWARRAY]
			l_idx: INTEGER_32
			l_len: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_FOLD_T]} l_fp2.make (<<1>>)

			if (foldInsert (a_gap, a_i___0 + 1)) = 0 then
				l_return := True
			end
			if not l_return then
				l_fp := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + a_i___0;
				(l_fp + 1).item.fd_top := a_bot + 1;
				(l_fp + 1).item.fd_len := l_fp.item.fd_len - ((l_fp + 1).item.fd_top - l_fp.item.fd_top);
				(l_fp + 1).item.fd_flags := l_fp.item.fd_flags;
				(l_fp + 1).item.fd_small := (2).to_integer_8
				l_fp.item.fd_small := (2).to_integer_8
				l_gap1 := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))
				l_gap2 := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared ((l_fp + 1).c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))
				l_gap1.item.foldFind ((a_bot + 1) - l_fp.item.fd_top, l_fp2).do_nothing
				l_len := (create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_gap1.item.ga_data) + l_gap1.item.ga_len).distance ((l_fp2.item))
				if l_len > 0 then
					if (l_gap2.item.ga_grow (l_len)) = 1 then
						l_idx := 0
						from
						until
							not (l_idx < l_len)
						loop
							create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_gap2.item.ga_data)[l_idx] := (l_fp2.item[l_idx]).twin;
							(create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_gap2.item.ga_data) + l_idx).item.fd_top := (create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_gap2.item.ga_data) + l_idx).item.fd_top - ((l_fp + 1).item.fd_top - l_fp.item.fd_top)
							l_idx := l_idx + 1
						end
						l_gap2.item.ga_len := l_len
						l_gap1.item.ga_len := l_gap1.item.ga_len - l_len
					end
				end
				l_fp.item.fd_len := a_top - l_fp.item.fd_top
				fold_changed.item := 1
			end
		end

	foldInsert (a_gap: CE_POINTER [PD_GROWARRAY]; a_i___0: INTEGER_32): INTEGER_32
		require
			not a_gap.is_void
		local
			l_fp: CE_POINTER [PD_FOLD_T]
			l_return: BOOLEAN
		do
			if (a_gap.item.ga_grow (1)) /= 1 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_fp := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data) + a_i___0
				if a_i___0 < a_gap.item.ga_len then
					memmove (create {CE_VOID_POINTER}.make_cast ((l_fp + 1)), create {CE_VOID_POINTER}.make_cast (l_fp), (create {PD_FOLD_T}.make).structure_size.to_natural_32 * (a_gap.item.ga_len - a_i___0).to_natural_32).do_nothing
				end
				a_gap.item.ga_len := (a_gap.item.ga_len) + 1;
				(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))).item.ga_init2 (((create {PD_FOLD_T}.make).structure_size.to_natural_32).to_integer_32, 10)
				Result := 1
			end
		end

	foldMerge (a_fp1: CE_POINTER [PD_FOLD_T]; a_gap: CE_POINTER [PD_GROWARRAY]; a_fp2: CE_POINTER [PD_FOLD_T])
		require
			not a_fp1.is_void
			not a_gap.is_void
			not a_fp2.is_void
		local
			l_fp3: CE_ARRAY [CE_POINTER [PD_FOLD_T]]
			l_fp4: CE_ARRAY [CE_POINTER [PD_FOLD_T]]
			l_idx: INTEGER_32
			l_gap1: CE_POINTER [PD_GROWARRAY]
			l_gap2: CE_POINTER [PD_GROWARRAY]
		do
			create {CE_POINTER_ARRAY [PD_FOLD_T]} l_fp3.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_FOLD_T]} l_fp4.make (<<1>>)

			l_gap1 := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_fp1.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))
			l_gap2 := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_fp2.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))
			if (l_gap1.item.foldFind (a_fp1.item.fd_len - 1, l_fp3)).to_boolean then
				if (l_gap2.item.foldFind (0, l_fp4)).to_boolean then
					foldMerge (l_fp3.item, l_gap2, l_fp4.item)
				end
			end
			if l_gap2.item.ga_len > 0 then
				if (l_gap1.item.ga_grow (l_gap2.item.ga_len)) = 1 then
					l_idx := 0
					from
					until
						not (l_idx < l_gap2.item.ga_len)
					loop
						create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_gap1.item.ga_data)[l_gap1.item.ga_len] := (create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_gap2.item.ga_data)[l_idx]).twin;
						(create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_gap1.item.ga_data) + l_gap1.item.ga_len).item.fd_top := (create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_gap1.item.ga_data) + l_gap1.item.ga_len).item.fd_top + (a_fp1.item.fd_len)
						l_gap1.item.ga_len := (l_gap1.item.ga_len) + 1
						l_idx := l_idx + 1
					end
					l_gap2.item.ga_len := 0
				end
			end
			a_fp1.item.fd_len := a_fp1.item.fd_len + (a_fp2.item.fd_len)
			a_gap.item.deleteFoldEntry (a_fp2.distance ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (a_gap.item.ga_data))), 1)
			fold_changed.item := 1
		end

	plines_m_win (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_first___0, a_last: INTEGER_32): INTEGER_32
		local
			l_first___0: INTEGER_32
			l_count___2: INTEGER_32
			l_x___0: INTEGER_32
		do
			l_first___0 := a_first___0
			l_count___2 := 0
			from
			until
				not (l_first___0 <= a_last)
			loop
				l_x___0 := (a_wp___0.item.foldedCount (l_first___0, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))).to_integer_32
				if l_x___0 > 0 then
					l_count___2 := l_count___2 + 1
					l_first___0 := l_first___0 + l_x___0.to_integer_32
				else
					if l_first___0 = a_wp___0.item.w_topline then
						l_count___2 := l_count___2 + ((a_wp___0.item.plines_win_nofill (l_first___0, 1)) + a_wp___0.item.w_topfill)
					else
						l_count___2 := l_count___2 + (a_wp___0.item.plines_win (l_first___0, 1))
					end
					l_first___0 := l_first___0 + 1
				end
			end
			Result := l_count___2
		end

	find_is_eval_item (a_ptr: CE_POINTER [NATURAL_8]; a_colp, a_bnp: CE_POINTER [INTEGER_32]; a_dir___0: INTEGER_32): INTEGER_32
		require
			not a_ptr.is_void
			not a_bnp.is_void
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_ptr.item).to_integer_32 /= 93 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_dir___0 = -1 then
							a_bnp.item := (a_bnp.item) + 1
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (a_ptr.item).to_integer_32 = 91 then
							if a_dir___0 = 1 then
								a_bnp.item := (a_bnp.item) + 1
							end
						end
				when 4 then
					if not (a_bnp.item > 0) then
						l_pos := -1 + 10 -- skip if block
					end
				when 5 then -- if:
						if (a_ptr.item).to_integer_32 /= 91 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if a_dir___0 = -1 then
							a_bnp.item := (a_bnp.item) - 1
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L___0:
						if (a_ptr.item).to_integer_32 = 93 then
							if a_dir___0 = 1 then
								a_bnp.item := (a_bnp.item) - 1
							end
						end
				when 9 then
						Result := 1
						l_return := True
				when 10 then -- if done
					if not l_return and then ((a_ptr.item).to_integer_32 = 46) then
						Result := 1
						l_return := True
					end
					if not l_return then
						if a_dir___0 = -1 then
							l_tmp := 0
						else
							l_tmp := 1
						end
						if (a_ptr[l_tmp]).to_integer_32 = 62 then
							if a_dir___0 = -1 then
								l_tmp___0 := -1
							else
								l_tmp___0 := 0
							end
							if (a_ptr[l_tmp___0]).to_integer_32 = 45 then
								a_colp.item := a_colp.item + a_dir___0
								Result := 1
								l_return := True
							end
						end
					end
					if not l_return then
						Result := 0
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	win_copy_options (a_wp_from, a_wp_to: CE_POINTER [PD_WINDOW_S])
		do
			(create {CE_CLASS_POINTER [PD_WINOPT_T]}.make_shared (a_wp_from.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt"))).item.copy_winopt (create {CE_CLASS_POINTER [PD_WINOPT_T]}.make_shared (a_wp_to.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt")));
			(create {CE_CLASS_POINTER [PD_WINOPT_T]}.make_shared (a_wp_from.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_allbuf_opt"))).item.copy_winopt (create {CE_CLASS_POINTER [PD_WINOPT_T]}.make_shared (a_wp_to.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_allbuf_opt")))
		end

	copy_text_attr (a_off___0: INTEGER_32; a_buf___6: CE_POINTER [NATURAL_8]; a_len, a_attr: INTEGER_32)
		local
			l_i___0: INTEGER_32
		do
			memmove (create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenLines.item + a_off___0)), create {CE_VOID_POINTER}.make_cast (a_buf___6), a_len.to_natural_32).do_nothing
			if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
				memset (create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).ScreenLinesUC.item + a_off___0)), 0, {PLATFORM}.Natural_32_bytes.to_natural_32 * a_len.to_natural_32).do_nothing
			end
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_len)
			loop
				(create {P_GLOBALS_STATIC}).ScreenAttrs.item[(a_off___0 + l_i___0)] := a_attr.to_natural_16
				l_i___0 := l_i___0 + 1
			end
		end

	win_line (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32; a_startrow, a_endrow, a_nochange: INTEGER_32): INTEGER_32
		local
			l_col: INTEGER_32
			l_off___0: NATURAL_32
			l_c: INTEGER_32
			l_vcol: INTEGER_32
			l_vcol_prev: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_row: INTEGER_32
			l_screen_row: INTEGER_32
			l_extra: CE_ARRAY [NATURAL_8]
			l_n_extra: INTEGER_32
			l_p_extra: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_c_extra: INTEGER_32
			l_extra_attr: INTEGER_32
			l_lcs_eol_one: INTEGER_32
			l_lcs_prec_todo: INTEGER_32
			l_saved_n_extra: INTEGER_32
			l_saved_p_extra: CE_POINTER [NATURAL_8]
			l_saved_c_extra: INTEGER_32
			l_saved_char_attr: INTEGER_32
			l_n_attr: INTEGER_32
			l_saved_attr2: INTEGER_32
			l_n_attr3: INTEGER_32
			l_saved_attr3: INTEGER_32
			l_n_skip: INTEGER_32
			l_fromcol: CE_ARRAY [INTEGER_32]
			l_tocol: CE_ARRAY [INTEGER_32]
			l_fromcol_prev: INTEGER_32
			l_noinvcur: INTEGER_32
			l_top: CE_POINTER [PD_POS_T]
			l_bot: CE_POINTER [PD_POS_T]
			l_lnum_in_visual_area: INTEGER_32
			l_pos___3: CE_ARRAY [PD_POS_T]
			l_v: INTEGER_32
			l_char_attr: INTEGER_32
			l_attr_pri: INTEGER_32
			l_area_highlighting: INTEGER_32
			l_attr: INTEGER_32
			l_area_attr: INTEGER_32
			l_search_attr: INTEGER_32
			l_vcol_save_attr: INTEGER_32
			l_syntax_attr: INTEGER_32
			l_has_syntax: INTEGER_32
			l_save_did_emsg: INTEGER_32
			l_eol_hl_off: INTEGER_32
			l_draw_color_col: INTEGER_32
			l_color_cols: CE_ARRAY [CE_POINTER [INTEGER_32]]
			l_has_spell: INTEGER_32
			l_nextline: CE_ARRAY [NATURAL_8]
			l_nextlinecol: INTEGER_32
			l_nextline_idx: INTEGER_32
			l_spell_attr: INTEGER_32
			l_word_end: INTEGER_32
			l_cur_checked_col: INTEGER_32
			l_extra_check: INTEGER_32
			l_multi_attr: INTEGER_32
			l_mb_l: INTEGER_32
			l_mb_c: INTEGER_32
			l_mb_utf8: INTEGER_32
			l_u8cc: CE_ARRAY [INTEGER_32]
			l_filler_lines: INTEGER_32
			l_filler_todo: INTEGER_32
			l_diff_hlf: NATURAL_32
			l_change_start___0: CE_ARRAY [INTEGER_32]
			l_change_end___0: CE_ARRAY [INTEGER_32]
			l_trailcol: INTEGER_32
			l_need_showbreak: INTEGER_32
			l_line_attr: INTEGER_32
			l_cur: CE_POINTER [PD_MATCHITEM]
			l_shl: CE_POINTER [PD_MATCH_T]
			l_shl_flag: INTEGER_32
			l_prevcol_hl_flag: INTEGER_32
			l_did_line_attr: INTEGER_32
			l_draw_state: INTEGER_32
			l_feedback_col: INTEGER_32
			l_feedback_old_attr: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_prev_ptr: CE_POINTER [NATURAL_8]
			l_tmp___14: INTEGER_32
			l_len: INTEGER_32
			l_linecol: INTEGER_32
			l_spell_hlf: CE_ARRAY [NATURAL_32]
			l_tmp___16: CE_POINTER [NATURAL_8]
			l_text_sign: NATURAL_32
			l_icon_sign: NATURAL_32
			l_num: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___38: CE_POINTER [NATURAL_8]
			l_can_spell: CE_ARRAY [INTEGER_32]
			l_tmp___41: CE_POINTER [INTEGER_32]
			l_prev_ptr___0: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_len___0: INTEGER_32
			l_spell_hlf___0: CE_ARRAY [NATURAL_32]
			l_tmp___42: INTEGER_32
			l_tmp___49: CE_POINTER [NATURAL_8]
			l_tcol: CE_ARRAY [INTEGER_32]
			l_tmp___53: INTEGER_32
			l_prevcol: INTEGER_32
			l_tmp___54: INTEGER_32
			l_n: INTEGER_32
			l_rightmost_vcol: INTEGER_32
			l_i___1: INTEGER_32
			l_tmp___57: NATURAL_32
			l_tmp___58: NATURAL_32
			l_tmp___59: NATURAL_32
			l_i___2: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_extra.make (<<18>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p_extra.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_fromcol.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_tocol.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_POS_T]} l_pos___3.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_32]} l_color_cols.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_nextline.make (<<300>>)
			create {CE_INTEGER_32_ARRAY} l_u8cc.make (<<6>>)
			create {CE_INTEGER_32_ARRAY} l_change_start___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_change_end___0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_spell_hlf.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_can_spell.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_spell_hlf___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_tcol.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := 0
					l_vcol := 0
					l_vcol_prev := -1
					l_n_extra := 0
					l_p_extra.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_c_extra := ('%/0/').code
					l_extra_attr := 0
					l_lcs_eol_one := (create {P_GLOBALS_STATIC}).lcs_eol.item.item
					l_lcs_prec_todo := (create {P_GLOBALS_STATIC}).lcs_prec.item.item
					l_saved_n_extra := 0
					l_saved_p_extra := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_saved_c_extra := 0
					l_saved_char_attr := 0
					l_n_attr := 0
					l_saved_attr2 := 0
					l_n_attr3 := 0
					l_saved_attr3 := 0
					l_n_skip := 0
					l_fromcol_prev := -2
					l_noinvcur := 0
					l_lnum_in_visual_area := 0
					l_char_attr := 0
					l_attr_pri := 0
					l_area_highlighting := 0
					l_attr := 0
					l_area_attr := 0
					l_search_attr := 0
					l_vcol_save_attr := 0
					l_syntax_attr := 0
					l_has_syntax := 0
					l_eol_hl_off := 0
					l_draw_color_col := 0
					l_color_cols.item := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
					l_has_spell := 0
					l_nextlinecol := 0
					l_nextline_idx := 0
					l_spell_attr := 0
					l_word_end := 0
					l_cur_checked_col := 0
					l_multi_attr := 0
					l_mb_l := 1
					l_mb_c := 0
					l_mb_utf8 := 0
					l_diff_hlf := {PC_HLF_T}.HLF_8
					l_change_start___0.item := 2_147_483_647
					l_change_end___0.item := -1
					l_trailcol := (2_147_483_647).to_integer_32
					l_need_showbreak := 0
					l_line_attr := 0
					l_did_line_attr := 0
					l_draw_state := 0
					l_feedback_col := 0
					l_feedback_old_attr := -1
					if a_startrow > a_endrow then
						Result := a_startrow
						l_return := True
					end
					if l_return then
						l_pos := -1 + 320 -- skip if block
					end
				when 1 then -- if:
						l_row := a_startrow
						l_screen_row := l_row + a_wp___0.item.w_winrow
						l_extra_check := a_wp___0.item.w_onebuf_opt.wo_lbr
						if (a_wp___0.item.syntax_present).to_boolean then
							if not ((a_wp___0.item.w_s).item.b_syn_error).to_boolean then
								l_save_did_emsg := (create {P_GLOBALS_STATIC}).did_emsg.item;
								(create {P_GLOBALS_STATIC}).did_emsg.item := 0
								a_wp___0.item.syntax_start (a_lnum)
								if ((create {P_GLOBALS_STATIC}).did_emsg.item).to_boolean then
									(a_wp___0.item.w_s).item.b_syn_error := 1
								else
									(create {P_GLOBALS_STATIC}).did_emsg.item := l_save_did_emsg
									l_has_syntax := 1
									l_extra_check := 1
								end
							end
						end
						l_color_cols.item := a_wp___0.item.w_p_cc_cols
						if not (l_color_cols.item).is_void then
							l_draw_color_col := advance_color_col (l_vcol.to_integer_32, l_color_cols)
						end
						if (a_wp___0.item.w_onebuf_opt.wo_spell).to_boolean then
							if (((a_wp___0.item.w_s).item.b_p_spl).item).to_integer_32 /= 0 then
								if (a_wp___0.item.w_s).item.b_langp.ga_len > 0 then
									if not ((create {CE_POINTER_POINTER [INTEGER_8]}.make_cast ((a_wp___0.item.w_s).item.b_langp.ga_data)).item).is_void then
										l_has_spell := 1
										l_extra_check := 1
										l_nextline[150] := (('%/0/').code).to_natural_8
										if a_lnum < (a_wp___0.item.w_buffer).item.b_ml.ml_line_count then
											l_line := (a_wp___0.item.w_buffer).item.ml_get_buf (a_lnum + 1, 0)
											spell_cat_line (l_nextline + 150, l_line, 150)
										end
										if a_lnum = checked_lnum.item then
											l_cur_checked_col := checked_col.item
										end
										checked_lnum.item := (0).to_integer_32
										if a_lnum /= capcol_lnum.item then
											cap_col.item.item := -1
										end
										if a_lnum = 1 then
											cap_col.item.item := 0
										end
										capcol_lnum.item := (0).to_integer_32
									end
								end
							end
						end
						l_fromcol.item := -10
						l_tocol.item := 2_147_483_647
						if not (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 2 then -- if:
						if not ((a_wp___0.item.w_buffer).is_equal ((create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer)) then
							l_pos := -1 + 18 -- skip if block
						end
				when 3 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum then
							l_tmp___1 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum).to_integer
						else
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col /= (create {P_GLOBALS_STATIC}).VIsual.item.item.col then
								l_tmp___0 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < (create {P_GLOBALS_STATIC}).VIsual.item.item.col).to_integer
							else
								l_tmp___0 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd < (create {P_GLOBALS_STATIC}).VIsual.item.item.coladd).to_integer
							end
							l_tmp___1 := l_tmp___0
						end
						if l_tmp___1.to_boolean then
							l_top := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
							l_bot := (create {P_GLOBALS_STATIC}).VIsual.item
						elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = (create {P_GLOBALS_STATIC}).VIsual.item.item.col then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd = (create {P_GLOBALS_STATIC}).VIsual.item.item.coladd then
									l_top := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
									l_bot := (create {P_GLOBALS_STATIC}).VIsual.item
								else
									l_top := (create {P_GLOBALS_STATIC}).VIsual.item
									l_bot := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
								end
							else
								l_top := (create {P_GLOBALS_STATIC}).VIsual.item
								l_bot := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
							end
						else
							l_top := (create {P_GLOBALS_STATIC}).VIsual.item
							l_bot := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
						end
						if a_lnum >= l_top.item.lnum then
							if a_lnum <= l_bot.item.lnum then
								l_tmp___2 := 1
							else
								l_tmp___2 := 0
							end
						else
							l_tmp___2 := 0
						end
						l_lnum_in_visual_area := l_tmp___2
						if (create {P_GLOBALS_STATIC}).VIsual_mode.item /= 22 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_lnum_in_visual_area.to_boolean then
							l_fromcol.item := a_wp___0.item.w_old_cursor_fcol
							l_tocol.item := a_wp___0.item.w_old_cursor_lcol
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 6 then -- else:
						if not (a_lnum > l_top.item.lnum) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_lnum <= l_bot.item.lnum then
							l_fromcol.item := 0
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if a_lnum = l_top.item.lnum then
							if (create {P_GLOBALS_STATIC}).VIsual_mode.item = 86 then
								l_fromcol.item := 0
							else
								a_wp___0.item.getvvcol (l_top, l_fromcol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
								if (l_top.item.gchar_pos) = 0 then
									l_tocol.item := l_fromcol.item + 1
								end
							end
						end
				when 10 then
						if (create {P_GLOBALS_STATIC}).VIsual_mode.item = 86 then
							l_pos := -1 + 16 -- skip if block
						end
				when 11 then -- if:
						if a_lnum /= l_bot.item.lnum then
							l_pos := -1 + 16 -- skip if block
						end
				when 12 then -- if:
						if ((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 /= 101 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_bot.item.col = 0 then
							if l_bot.item.coladd = 0 then
								l_fromcol.item := -10
								l_tocol.item := 2_147_483_647
							else
								l_pos := -1 + 15 -- goto _L___1
							end
						else
							l_pos := -1 + 15 -- goto _L___1
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L___1:
						if (l_bot.item.col).to_integer_32 = 2_147_483_647 then
							l_tocol.item := 2_147_483_647
						else
							l_pos___3.item := (l_bot.item).twin
							if ((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 = 101 then
								a_wp___0.item.getvvcol (l_pos___3, l_tocol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
							else
								a_wp___0.item.getvvcol (l_pos___3, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_tocol)
								l_tocol.item := l_tocol.item + 1
							end
						end
				when 16 then -- if done | if done | if done
						if not ((create {P_GLOBALS_STATIC}).highlight_match.item).to_boolean then
							if a_lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
								if a_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
									if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
										l_noinvcur := 1
									end
								end
							end
						end
						if l_fromcol.item >= 0 then
							l_area_highlighting := 1
							l_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[15]
							if ((create {P_GLOBALS_STATIC}).clip_star.item.item.available).to_boolean then
								if not ((create {P_GLOBALS_STATIC}).clip_star.item.item.owned).to_boolean then
									if ((create {P_UI_STATIC}).clip_isautosel).to_boolean then
										l_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[16]
									end
								end
							end
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_pos := -1 + 20 -- goto _L___2
				when 19 then -- if done | if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else: | _L___2:
						if ((create {P_GLOBALS_STATIC}).highlight_match.item).to_boolean then
							if a_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
								if a_lnum >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
									if a_lnum <= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + (create {P_GLOBALS_STATIC}).search_match_lines.item then
										if a_lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
											((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), l_fromcol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
										else
											l_fromcol.item := 0
										end
										if a_lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + (create {P_GLOBALS_STATIC}).search_match_lines.item then
											l_pos___3.item.lnum := a_lnum
											l_pos___3.item.col := (create {P_GLOBALS_STATIC}).search_match_endcol.item;
											((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (l_pos___3, l_tocol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
										else
											l_tocol.item := 2_147_483_647
										end
										if l_fromcol.item = l_tocol.item then
											l_tocol.item := l_fromcol.item + 1
										end
										l_area_highlighting := 1
										l_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[5]
									end
								end
							end
						end
				when 21 then
						l_filler_lines := a_wp___0.item.diff_check (a_lnum)
						if l_filler_lines < 0 then
							if l_filler_lines = -1 then
								if (a_wp___0.item.diff_find_change (a_lnum, l_change_start___0, l_change_end___0)).to_boolean then
									l_diff_hlf := {PC_HLF_T}.HLF_ADD
								elseif l_change_start___0.item = 0 then
									l_diff_hlf := {PC_HLF_T}.HLF_TXD
								else
									l_diff_hlf := {PC_HLF_T}.HLF_CHD
								end
							else
								l_diff_hlf := {PC_HLF_T}.HLF_ADD
							end
							l_filler_lines := 0
							l_area_highlighting := 1
						end
						if a_lnum = a_wp___0.item.w_topline then
							l_filler_lines := a_wp___0.item.w_topfill
						end
						l_filler_todo := l_filler_lines
						l_v := (buf_getsigntype (a_wp___0.item.w_buffer, a_lnum, 1)).to_integer_32
						if l_v /= 0 then
							l_line_attr := sign_get_attr (l_v.to_integer_32, 1)
						end
						if ((a_wp___0.item.w_buffer).item.bt_quickfix).to_boolean then
							if (a_wp___0.item.qf_current_entry) = a_lnum then
								l_line_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[6]
							end
						end
						if l_line_attr /= 0 then
							l_area_highlighting := 1
						end
						l_line := (a_wp___0.item.w_buffer).item.ml_get_buf (a_lnum, 0)
						l_ptr := l_line
						if l_has_spell.to_boolean then
							if cap_col.item.item = 0 then
								cap_col.item.item := ((create {P_CHARSET_STATIC}).skipwhite (l_line)).distance (l_line)
							end
							if (l_nextline[150]).to_integer_32 = 0 then
								l_nextlinecol := 2_147_483_647
								l_nextline_idx := 0
							else
								l_v := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))).to_integer_32
								if l_v < 150 then
									l_nextlinecol := 0
									memmove (create {CE_VOID_POINTER}.make_cast (l_nextline), create {CE_VOID_POINTER}.make_cast (l_line), l_v.to_natural_32).do_nothing
									memmove (create {CE_VOID_POINTER}.make_cast ((l_nextline + l_v)), create {CE_VOID_POINTER}.make_cast ((l_nextline + 150)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_nextline + 150)))) + {NATURAL_32} 1).do_nothing
									l_nextline_idx := (l_v + 1).to_integer_32
								else
									l_nextlinecol := (l_v - 150).to_integer_32
									memmove (create {CE_VOID_POINTER}.make_cast (l_nextline), create {CE_VOID_POINTER}.make_cast ((l_line + l_nextlinecol)), (150).to_natural_32).do_nothing
									l_nextline_idx := 151
								end
							end
						end
						if (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
							if ((create {P_GLOBALS_STATIC}).lcs_trail.item.item).to_boolean then
								l_trailcol := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr))).to_integer_32
								from
								until
									(l_break)
								loop
									l_break := False
									if l_trailcol > 0 then
										if (l_ptr[(l_trailcol - 1)]).to_integer_32 /= 32 then
											if (l_ptr[(l_trailcol - 1)]).to_integer_32 /= 9 then
												l_break := True
											end
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_trailcol := l_trailcol - 1
									end
								end
								l_break := False
								l_trailcol := l_trailcol + (l_ptr.distance (l_line))
								l_extra_check := 1
							end
						end
						if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
							l_v := (a_wp___0.item.w_skipcol).to_integer_32
						else
							l_v := (a_wp___0.item.w_leftcol).to_integer_32
						end
						if l_v > 0 then
							l_prev_ptr := l_ptr
							from
							until
								(l_break)
							loop
								l_break := False
								if l_vcol < l_v then
									if (l_ptr.item).to_integer_32 = 0 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_c := a_wp___0.item.win_lbr_chartabsize (l_ptr, l_vcol.to_integer_32, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
									l_vcol := l_vcol + l_c.to_integer_32
									l_prev_ptr := l_ptr
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_tmp___14 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr]))
									else
										l_tmp___14 := 1
									end
									l_ptr := l_ptr + l_tmp___14
								end
							end
							l_break := False
							if l_vcol < l_v then
								if (a_wp___0.item.w_onebuf_opt.wo_cuc).to_boolean then
									l_vcol := l_v
								elseif l_draw_color_col.to_boolean then
									l_vcol := l_v
								elseif ((create {P_MISC2_STATIC}).virtual_active).to_boolean then
									l_vcol := l_v
								elseif ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
									if (a_wp___0.item.w_buffer).is_equal ((create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer) then
										l_vcol := l_v
									end
								end
							end
							if l_vcol > l_v then
								l_vcol := l_vcol - l_c.to_integer_32
								l_ptr := l_prev_ptr
								l_n_skip := (l_v - l_vcol).to_integer_32
							end
							if (l_tocol.item).to_integer_32 <= l_vcol then
								l_fromcol.item := 0
							elseif l_fromcol.item >= 0 then
								if (l_fromcol.item).to_integer_32 < l_vcol then
									l_fromcol.item := l_vcol.to_integer_32
								end
							end
							if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
								l_need_showbreak := 1
							end
							if l_has_spell.to_boolean then
								l_linecol := l_ptr.distance (l_line)
								l_spell_hlf.item := {PC_HLF_T}.HLF_COUNT
								l_pos___3.item := (a_wp___0.item.w_cursor).twin
								a_wp___0.item.w_cursor.lnum := a_lnum
								a_wp___0.item.w_cursor.col := l_linecol
								l_len := a_wp___0.item.spell_move_to (1, 1, 1, l_spell_hlf)
								l_line := (a_wp___0.item.w_buffer).item.ml_get_buf (a_lnum, 0)
								l_ptr := l_line + l_linecol
								if l_len = 0 then
									l_spell_hlf.item := {PC_HLF_T}.HLF_COUNT
									l_tmp___16 := spell_to_word_end (l_ptr, a_wp___0)
									l_word_end := (l_tmp___16.distance (l_line)) + 1
								elseif a_wp___0.item.w_cursor.col > l_ptr.distance (l_line) then
									l_spell_hlf.item := {PC_HLF_T}.HLF_COUNT
									l_tmp___16 := spell_to_word_end (l_ptr, a_wp___0)
									l_word_end := (l_tmp___16.distance (l_line)) + 1
								else
									l_word_end := (a_wp___0.item.w_cursor.col + l_len) + 1
									if l_spell_hlf.item /= {NATURAL_32} 41 then
										l_spell_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[(l_spell_hlf.item).to_integer_32]
									end
								end
								a_wp___0.item.w_cursor := (l_pos___3.item).twin
								if l_has_syntax.to_boolean then
									a_wp___0.item.syntax_start (a_lnum)
								end
							end
						end
						if l_fromcol.item >= 0 then
							if l_noinvcur.to_boolean then
								if l_fromcol.item = a_wp___0.item.w_virtcol then
									l_fromcol_prev := l_fromcol.item
									l_fromcol.item := -1
								elseif l_fromcol.item < a_wp___0.item.w_virtcol then
									l_fromcol_prev := a_wp___0.item.w_virtcol
								end
							end
							if l_fromcol.item >= l_tocol.item then
								l_fromcol.item := -1
							end
						end
						l_cur := a_wp___0.item.w_match_head
						l_shl_flag := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if l_cur.is_void then
								if l_shl_flag /= 0 then
									l_break := True
								end
							end
							if not (l_break) then
								if l_shl_flag = 0 then
									l_shl := (create {P_SCREEN_STATIC}).search_hl.item
									l_shl_flag := 1
								else
									l_shl := create {CE_CLASS_POINTER [PD_MATCH_T]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl"))
								end
								l_shl.item.startcol := (2_147_483_647).to_integer_32
								l_shl.item.endcol := (2_147_483_647).to_integer_32
								l_shl.item.attr_cur := 0
								if not (l_shl.item.rm.regprog).is_void then
									l_v := (l_ptr.distance (l_line)).to_integer_32
									next_search_hl (a_wp___0, l_shl, a_lnum, l_v.to_integer_32)
									l_line := (a_wp___0.item.w_buffer).item.ml_get_buf (a_lnum, 0)
									l_ptr := l_line + l_v
									if l_shl.item.lnum /= 0 then
										if l_shl.item.lnum <= a_lnum then
											if l_shl.item.lnum = a_lnum then
												l_shl.item.startcol := l_shl.item.rm.startpos[0].col
											else
												l_shl.item.startcol := 0
											end
											if a_lnum = (l_shl.item.lnum + l_shl.item.rm.endpos[0].lnum) - l_shl.item.rm.startpos[0].lnum then
												l_shl.item.endcol := l_shl.item.rm.endpos[0].col
											else
												l_shl.item.endcol := (2_147_483_647).to_integer_32
											end
											if l_shl.item.startcol = l_shl.item.endcol then
												if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
													if (l_line[l_shl.item.endcol]).to_integer_32 /= 0 then
														l_shl.item.endcol := l_shl.item.endcol + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_line + l_shl.item.endcol]))
													else
														l_shl.item.endcol := (l_shl.item.endcol) + 1
													end
												else
													l_shl.item.endcol := (l_shl.item.endcol) + 1
												end
											end
											if (l_shl.item.startcol).to_integer_32 < l_v then
												l_shl.item.attr_cur := l_shl.item.attr
												l_search_attr := l_shl.item.attr
											end
											l_area_highlighting := 1
										end
									end
								end
								if not l_shl.is_equal ((create {P_SCREEN_STATIC}).search_hl.item) then
									if not l_cur.is_void then
										l_cur := l_cur.item.next
									end
								end
							end
						end
						l_break := False
						if (a_wp___0.item.w_onebuf_opt.wo_cul).to_boolean then
							if a_lnum = a_wp___0.item.w_cursor.lnum then
								if not ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
									l_line_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[39]
									l_area_highlighting := 1
								end
							end
						end
						l_off___0 := (((create {P_SCREEN_STATIC}).current_ScreenLine.item).distance (((create {P_GLOBALS_STATIC}).ScreenLines.item))).to_natural_32
						l_col := 0
				when 22 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 319 -- skip loop
						end
				when 23 then -- loop body:
						l_break := False
						if l_draw_state = 6 then
							l_pos := -1 + 45 -- skip if block
						end
				when 24 then -- if:
						if l_draw_state = 0 then
							if l_n_extra = 0 then
								l_draw_state := 1
								if (create {P_GLOBALS_STATIC}).cmdwin_type.item /= 0 then
									if a_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
										l_n_extra := 1
										l_c_extra := (create {P_GLOBALS_STATIC}).cmdwin_type.item
										l_char_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[1]
									end
								end
							end
						end
						if l_draw_state = 1 then
							if l_n_extra = 0 then
								l_draw_state := 2
								if a_wp___0.item.w_onebuf_opt.wo_fdc > 0 then
									a_wp___0.item.fill_foldcolumn (l_extra, 0, a_lnum)
									l_n_extra := (a_wp___0.item.w_onebuf_opt.wo_fdc).to_integer_32
									l_p_extra.item := l_extra
									l_p_extra.item[l_n_extra] := (('%/0/').code).to_natural_8
									l_c_extra := ('%/0/').code
									l_char_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[20]
								end
							end
						end
						if l_draw_state /= 2 then
							l_pos := -1 + 33 -- skip if block
						end
				when 25 then -- if:
						if l_n_extra /= 0 then
							l_pos := -1 + 33 -- skip if block
						end
				when 26 then -- if:
						l_draw_state := 3
						if not ((a_wp___0.item.draw_signcolumn).to_boolean) then
							l_pos := -1 + 33 -- skip if block
						end
				when 27 then -- if:
						if not (l_filler_todo <= 0) then
							l_pos := -1 + 33 -- skip if block
						end
				when 28 then -- if:
						l_c_extra := (' ').code
						l_char_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[26]
						l_n_extra := 2
						if l_row /= a_startrow then
							l_pos := -1 + 33 -- skip if block
						end
				when 29 then -- if:
						l_text_sign := (buf_getsigntype (a_wp___0.item.w_buffer, a_lnum, 3)).to_natural_32
						l_icon_sign := (buf_getsigntype (a_wp___0.item.w_buffer, a_lnum, 2)).to_natural_32
						if not (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						if l_icon_sign /= {NATURAL_32} 0 then
							l_c_extra := 1
							if (buf_signcount (a_wp___0.item.w_buffer, a_lnum)) > 1 then
								l_c_extra := 2
							end
							l_char_attr := l_icon_sign.to_integer_32
						else
							l_pos := -1 + 32 -- goto _L___3
						end
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else: | _L___3:
						if l_text_sign /= {NATURAL_32} 0 then
							l_p_extra.item := sign_get_text (l_text_sign.to_integer_32)
							if not (l_p_extra.item).is_void then
								l_c_extra := ('%/0/').code
								l_n_extra := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p_extra.item))).to_integer_32
							end
							l_char_attr := sign_get_attr (l_text_sign.to_integer_32, 0)
						end
				when 33 then -- if done | if done | if done | if done | if done
						if l_draw_state /= 3 then
							l_pos := -1 + 44 -- skip if block
						end
				when 34 then -- if:
						if l_n_extra /= 0 then
							l_pos := -1 + 44 -- skip if block
						end
				when 35 then -- if:
						l_draw_state := 4
						if not ((a_wp___0.item.w_onebuf_opt.wo_nu).to_boolean) then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						l_pos := -1 + 39 -- goto _L___5
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 38 then -- else:
						if not ((a_wp___0.item.w_onebuf_opt.wo_rnu).to_boolean) then
							l_pos := -1 + 44 -- skip if block
						end
				when 39 then -- if: | _L___5:
						if l_row /= a_startrow + l_filler_lines then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						l_pos := -1 + 43 -- goto _L___4
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 42 then -- else:
						if not (((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('n').code)).is_void) then
							l_pos := -1 + 44 -- skip if block
						end
				when 43 then -- if: | _L___4:
						if l_row = a_startrow + l_filler_lines then
							if (a_wp___0.item.w_onebuf_opt.wo_nu).to_boolean then
								l_num := a_lnum
							else
								l_num := (abs ((a_wp___0.item.get_cursor_rel_lnum (a_lnum)).to_integer_32)).to_integer_32
							end
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_extra), ce_string ("%%*ld "), (a_wp___0.item.number_width), l_num]).do_nothing
							if a_wp___0.item.w_skipcol > 0 then
								l_p_extra.item := l_extra
								from
								until
									(l_p_extra.item.item).to_integer_32 /= 32
								loop
									l_p_extra.item.item := (('-').code).to_natural_8
									l_p_extra.item := l_p_extra.item + 1
								end
							end
							l_p_extra.item := l_extra
							l_c_extra := ('%/0/').code
						else
							l_c_extra := (' ').code
						end
						l_n_extra := (a_wp___0.item.number_width) + 1
						l_char_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[9]
						if (a_wp___0.item.w_onebuf_opt.wo_cul).to_boolean then
							if a_lnum = a_wp___0.item.w_cursor.lnum then
								l_char_attr := (create {P_SYNTAX_STATIC}).hl_combine_attr ((create {P_GLOBALS_STATIC}).highlight_attr.item[39], l_char_attr)
							end
						end
				when 44 then -- if done | if done | if done | if done | if done
						if l_draw_state = 4 then
							if l_n_extra = 0 then
								l_draw_state := 5
								if l_filler_todo > 0 then
									if ((create {P_CHARSET_STATIC}).char2cells ((create {P_GLOBALS_STATIC}).fill_diff.item.item)) > 1 then
										l_c_extra := ('-').code
									else
										l_c_extra := (create {P_GLOBALS_STATIC}).fill_diff.item.item
									end
									l_n_extra := a_wp___0.item.w_width - l_col
									l_char_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[23]
								end
								if ((create {P_OPTION_STATIC}).p_sbr.item.item.item).to_integer_32 /= 0 then
									if l_need_showbreak.to_boolean then
										l_p_extra.item := (create {P_OPTION_STATIC}).p_sbr.item.item
										l_c_extra := ('%/0/').code
										l_n_extra := (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_sbr.item.item))).to_integer_32
										l_char_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[1]
										l_need_showbreak := 0
										if (l_tocol.item).to_integer_32 = l_vcol then
											l_tocol.item := l_tocol.item + l_n_extra
										end
									end
								end
							end
						end
						if l_draw_state = 5 then
							if l_n_extra = 0 then
								l_draw_state := 6
								if l_saved_n_extra.to_boolean then
									l_n_extra := l_saved_n_extra
									l_c_extra := l_saved_c_extra
									l_p_extra.item := l_saved_p_extra
									l_char_attr := l_saved_char_attr
								else
									l_char_attr := 0
								end
							end
						end
				when 45 then -- if done
						if (create {P_GLOBALS_STATIC}).dollar_vcol.item /= 0 then
							if a_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
								if a_lnum = a_wp___0.item.w_cursor.lnum then
									if l_vcol >= (a_wp___0.item.w_virtcol).to_integer_32 then
										if l_filler_todo <= 0 then
											screen_line (l_screen_row, a_wp___0.item.w_wincol, l_col, -a_wp___0.item.w_width)
											if (a_wp___0.item.w_onebuf_opt.wo_cuc).to_boolean then
												l_row := a_wp___0.item.w_cline_row + a_wp___0.item.w_cline_height
											else
												l_row := a_wp___0.item.w_height
											end
											l_break := True
										end
									end
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 258 -- skip if block
						end
				when 46 then -- if:
						if l_draw_state /= 6 then
							l_pos := -1 + 103 -- skip if block
						end
				when 47 then -- if:
						if not (l_area_highlighting.to_boolean) then
							l_pos := -1 + 103 -- skip if block
						end
				when 48 then -- if:
						if l_vcol /= (l_fromcol.item).to_integer_32 then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						l_area_attr := l_attr
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 51 then -- else:
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
						if l_vcol + 1 = (l_fromcol.item).to_integer_32 then
							if l_n_extra = 0 then
								if ((create {P_GLOBALS_STATIC}).mb_ptr2cells.item.integer_32_item ([l_ptr])) > 1 then
									l_area_attr := l_attr
								else
									l_pos := -1 + 54 -- goto _L___10
								end
							else
								l_pos := -1 + 54 -- goto _L___10
							end
						else
							l_pos := -1 + 54 -- goto _L___10
						end
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 54 then -- else: | _L___10:
						if l_vcol_prev.to_integer_32 /= l_fromcol_prev then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						if l_vcol_prev < l_vcol then
							if l_vcol < (l_tocol.item).to_integer_32 then
								l_area_attr := l_attr
							else
								l_pos := -1 + 57 -- goto _L___7
							end
						else
							l_pos := -1 + 57 -- goto _L___7
						end
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 57 then -- else: | _L___7:
						if l_area_attr /= 0 then
							if l_vcol = (l_tocol.item).to_integer_32 then
								l_area_attr := 0
							elseif l_noinvcur.to_boolean then
								if l_vcol.to_integer_32 = a_wp___0.item.w_virtcol then
									l_area_attr := 0
								end
							end
						end
				when 58 then -- if done | if done
						if l_n_extra.to_boolean then
							l_pos := -1 + 90 -- skip if block
						end
				when 59 then -- if:
						l_v := (l_ptr.distance (l_line)).to_integer_32
						l_cur := a_wp___0.item.w_match_head
						l_shl_flag := 0
				when 60 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 77 -- skip loop
						end
				when 61 then -- loop body:
						l_break := False
						if l_cur.is_void then
							if l_shl_flag /= 0 then
								l_break := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 76 -- skip if block
						end
				when 62 then -- if:
						if l_shl_flag /= 0 then
							l_pos := -1 + 68 -- skip if block
						end
				when 63 then -- if:
						if l_cur.is_void then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						if l_cur.item.priority > 0 then
							l_shl := (create {P_SCREEN_STATIC}).search_hl.item
							l_shl_flag := 1
						else
							l_pos := -1 + 66 -- goto _L___11
						end
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 66 then -- else: | _L___11:
						if l_cur.is_void then
							l_shl := (create {P_SCREEN_STATIC}).search_hl.item
							l_shl_flag := 1
						else
							l_shl := create {CE_CLASS_POINTER [PD_MATCH_T]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl"))
						end
				when 67 then -- if done | if block done, skip else block:
						l_pos := -1 + 69
				when 68 then -- else:
						l_shl := create {CE_CLASS_POINTER [PD_MATCH_T]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl"))
				when 69 then
						if not (not (l_break) and then (not (l_shl.item.rm.regprog).is_void)) then
							l_pos := -1 + 75 -- skip loop
						end
				when 70 then -- loop body:
						l_break := False
						l_continue := False
						if (l_shl.item.startcol).to_integer_32 = 2_147_483_647 then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if:
						if l_v >= (l_shl.item.startcol).to_integer_32 then
							if l_v < (l_shl.item.endcol).to_integer_32 then
								l_shl.item.attr_cur := l_shl.item.attr
							else
								l_pos := -1 + 73 -- goto _L___13
							end
						else
							l_pos := -1 + 73 -- goto _L___13
						end
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 74
				when 73 then -- else: | _L___13:
						if l_v = (l_shl.item.endcol).to_integer_32 then
							l_shl.item.attr_cur := 0
							next_search_hl (a_wp___0, l_shl, a_lnum, l_v.to_integer_32)
							l_line := (a_wp___0.item.w_buffer).item.ml_get_buf (a_lnum, 0)
							l_ptr := l_line + l_v
							if l_shl.item.lnum = a_lnum then
								l_shl.item.startcol := l_shl.item.rm.startpos[0].col
								if l_shl.item.rm.endpos[0].lnum = 0 then
									l_shl.item.endcol := l_shl.item.rm.endpos[0].col
								else
									l_shl.item.endcol := (2_147_483_647).to_integer_32
								end
								if l_shl.item.startcol = l_shl.item.endcol then
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_shl.item.endcol := l_shl.item.endcol + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_line + l_shl.item.endcol]))
									else
										l_shl.item.endcol := (l_shl.item.endcol) + 1
									end
								end
								l_continue := True
							end
						end
				when 74 then
						if not (l_break or l_continue) then
							l_break := True
						end
						l_pos := -1 + 69 -- back to loop condition
				when 75 then -- loop done
						l_break := False
						l_continue := False
						if not l_shl.is_equal ((create {P_SCREEN_STATIC}).search_hl.item) then
							if not l_cur.is_void then
								l_cur := l_cur.item.next
							end
						end
				when 76 then -- if done
						l_pos := -1 + 60 -- back to loop condition
				when 77 then -- loop done
						l_break := False
						l_search_attr := (create {P_SCREEN_STATIC}).search_hl.item.item.attr_cur
						l_cur := a_wp___0.item.w_match_head
						l_shl_flag := 0
				when 78 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 89 -- skip loop
						end
				when 79 then -- loop body:
						l_break := False
						if l_cur.is_void then
							if l_shl_flag /= 0 then
								l_break := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 88 -- skip if block
						end
				when 80 then -- if:
						if l_shl_flag /= 0 then
							l_pos := -1 + 86 -- skip if block
						end
				when 81 then -- if:
						if l_cur.is_void then
							l_pos := -1 + 84 -- skip if block
						end
				when 82 then -- if:
						if l_cur.item.priority > 0 then
							l_shl := (create {P_SCREEN_STATIC}).search_hl.item
							l_shl_flag := 1
						else
							l_pos := -1 + 84 -- goto _L___14
						end
				when 83 then -- if block done, skip else block:
						l_pos := -1 + 85
				when 84 then -- else: | _L___14:
						if l_cur.is_void then
							l_shl := (create {P_SCREEN_STATIC}).search_hl.item
							l_shl_flag := 1
						else
							l_shl := create {CE_CLASS_POINTER [PD_MATCH_T]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl"))
						end
				when 85 then -- if done | if block done, skip else block:
						l_pos := -1 + 87
				when 86 then -- else:
						l_shl := create {CE_CLASS_POINTER [PD_MATCH_T]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl"))
				when 87 then
						if l_shl.item.attr_cur /= 0 then
							l_search_attr := l_shl.item.attr_cur
						end
						if not l_shl.is_equal ((create {P_SCREEN_STATIC}).search_hl.item) then
							if not l_cur.is_void then
								l_cur := l_cur.item.next
							end
						end
				when 88 then -- if done
						l_pos := -1 + 78 -- back to loop condition
				when 89 then -- loop done
						l_break := False
				when 90 then -- if done
						if l_diff_hlf /= ({PC_HLF_T}.HLF_8) then
							if l_diff_hlf = {NATURAL_32} 22 then
								if l_ptr.distance (l_line) >= l_change_start___0.item then
									if l_n_extra = 0 then
										l_diff_hlf := {PC_HLF_T}.HLF_TXD
									end
								end
							end
							if l_diff_hlf = {NATURAL_32} 24 then
								if l_ptr.distance (l_line) > l_change_end___0.item then
									if l_n_extra = 0 then
										l_diff_hlf := {PC_HLF_T}.HLF_CHD
									end
								end
							end
							l_line_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[l_diff_hlf.to_integer_32]
						end
						l_attr_pri := 1
						if l_area_attr = 0 then
							l_pos := -1 + 93 -- skip if block
						end
				when 91 then -- if:
						l_char_attr := l_area_attr
				when 92 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 93 then -- else:
						if l_search_attr = 0 then
							l_pos := -1 + 96 -- skip if block
						end
				when 94 then -- if:
						l_char_attr := l_search_attr
				when 95 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 96 then -- else:
						if l_line_attr = 0 then
							l_pos := -1 + 102 -- skip if block
						end
				when 97 then -- if:
						if l_fromcol.item /= -10 then
							l_pos := -1 + 100 -- skip if block
						end
				when 98 then -- if:
						if (l_tocol.item).to_integer_32 = 2_147_483_647 then
							l_char_attr := l_line_attr
						else
							l_pos := -1 + 100 -- goto _L___16
						end
				when 99 then -- if block done, skip else block:
						l_pos := -1 + 101
				when 100 then -- else: | _L___16:
						if l_vcol < (l_fromcol.item).to_integer_32 then
							l_char_attr := l_line_attr
						elseif l_vcol_prev < l_fromcol_prev.to_integer_32 then
							l_char_attr := l_line_attr
						elseif l_vcol >= (l_tocol.item).to_integer_32 then
							l_char_attr := l_line_attr
						else
							l_pos := -1 + 102 -- goto _L___15
						end
				when 101 then -- if done | if block done, skip else block:
						l_pos := -1 + 103
				when 102 then -- else: | _L___15:
						l_attr_pri := 0
						if l_has_syntax.to_boolean then
							l_char_attr := l_syntax_attr
						else
							l_char_attr := 0
						end
				when 103 then -- if done | if done | if done | if done
						if not (l_n_extra > 0) then
							l_pos := -1 + 106 -- skip if block
						end
				when 104 then -- if:
						if l_c_extra /= 0 then
							l_c := l_c_extra
							l_mb_c := l_c
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								if ((create {P_GLOBALS_STATIC}).mb_char2len.item.integer_32_item ([l_c])) > 1 then
									l_mb_utf8 := 1
									l_u8cc[0] := 0
									l_c := 192
								else
									l_mb_utf8 := 0
								end
							else
								l_mb_utf8 := 0
							end
						else
							l_c := (l_p_extra.item.item).to_integer_32
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_mb_c := l_c
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_mb_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p_extra.item])
									l_mb_utf8 := 0
									if l_mb_l > l_n_extra then
										l_mb_l := 1
									elseif l_mb_l > 1 then
										l_mb_c := (create {P_MBYTE_STATIC}).utfc_ptr2char (l_p_extra.item, l_u8cc)
										l_mb_utf8 := 1
										l_c := 192
									end
								else
									l_mb_l := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[l_c]).to_integer_32
									if l_mb_l >= l_n_extra then
										l_mb_l := 1
									elseif l_mb_l > 1 then
										l_mb_c := ((l_c).bit_shift_left (8)) + (l_p_extra.item[1]).to_integer_32
									end
								end
								if l_mb_l = 0 then
									l_mb_l := 1
								end
								if l_col >= a_wp___0.item.w_width - 1 then
									if ((create {P_GLOBALS_STATIC}).mb_char2cells.item.integer_32_item ([l_mb_c])) = 2 then
										l_c := ('>').code
										l_mb_c := l_c
										l_mb_l := 1
										l_mb_utf8 := 0
										l_multi_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[1]
										l_n_extra := l_n_extra + 1
										l_p_extra.item := l_p_extra.item - 1
									else
										l_n_extra := l_n_extra - (l_mb_l - 1)
										l_p_extra.item := l_p_extra.item + (l_mb_l - 1)
									end
								else
									l_n_extra := l_n_extra - (l_mb_l - 1)
									l_p_extra.item := l_p_extra.item + (l_mb_l - 1)
								end
							end
							l_p_extra.item := l_p_extra.item + 1
						end
						l_n_extra := l_n_extra - 1
				when 105 then -- if block done, skip else block:
						l_pos := -1 + 197
				when 106 then -- else:
						l_c := (l_ptr.item).to_integer_32
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 128 -- skip if block
						end
				when 107 then -- if:
						l_mb_c := l_c
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 122 -- skip if block
						end
				when 108 then -- if:
						l_mb_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr])
						l_mb_utf8 := 0
						if l_mb_l > 1 then
							l_mb_c := (create {P_MBYTE_STATIC}).utfc_ptr2char (l_ptr, l_u8cc)
							if l_mb_c < 128 then
								l_c := l_mb_c
							end
							l_mb_utf8 := 1
							if ((create {P_MBYTE_STATIC}).utf_iscomposing (l_mb_c)).to_boolean then
								l_i___0 := (create {P_GLOBALS_STATIC}).Screen_mco.item - 1
								from
								until
									not (l_i___0 > 0)
								loop
									l_u8cc[l_i___0] := l_u8cc[l_i___0 - 1]
									l_i___0 := l_i___0 - 1
								end
								l_u8cc[0] := l_mb_c
								l_mb_c := (' ').code
							end
						end
						if l_mb_l /= 1 then
							l_pos := -1 + 111 -- skip if block
						end
				when 109 then -- if:
						if l_c >= 128 then
							l_pos := -1 + 118 -- goto _L___17
						else
							l_pos := -1 + 111 -- goto _L___20
						end
				when 110 then -- if block done, skip else block:
						l_pos := -1 + 121
				when 111 then -- else: | _L___20:
						if not (l_mb_l >= 1) then
							l_pos := -1 + 114 -- skip if block
						end
				when 112 then -- if:
						if l_mb_c = 0 then
							l_pos := -1 + 118 -- goto _L___17
						else
							l_pos := -1 + 114 -- goto _L___19
						end
				when 113 then -- if block done, skip else block:
						l_pos := -1 + 121
				when 114 then -- else: | _L___19:
						if not (l_mb_l > 1) then
							l_pos := -1 + 120 -- skip if block
						end
				when 115 then -- if:
						if not (((create {P_CHARSET_STATIC}).vim_isprintc (l_mb_c)).to_boolean) then
							l_pos := -1 + 118 -- skip if block
						end
				when 116 then -- if:
						l_pos := -1 + 120 -- goto _L___18
				when 117 then -- if block done, skip else block:
						l_pos := -1 + 119
				when 118 then -- else: | _L___17:;
						(create {P_CHARSET_STATIC}).transchar_hex (l_extra, l_mb_c)
						l_p_extra.item := l_extra
						l_c := (l_p_extra.item.item).to_integer_32
						l_mb_c := (create {P_MBYTE_STATIC}).mb_ptr2char_adv (l_p_extra)
						l_mb_utf8 := (l_c >= 128).to_integer
						l_n_extra := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p_extra.item))).to_integer_32
						l_c_extra := ('%/0/').code
						if l_area_attr = 0 then
							if l_search_attr = 0 then
								l_n_attr := l_n_extra + 1
								l_extra_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[0]
								l_saved_attr2 := l_char_attr
							end
						end
				when 119 then -- if done | if block done, skip else block:
						l_pos := -1 + 121
				when 120 then -- else: | _L___18:
						if l_mb_l = 0 then
							l_mb_l := 1
						end
				when 121 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 123
				when 122 then -- else:
						l_mb_l := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[l_c]).to_integer_32
						if l_mb_l = 0 then
							l_mb_l := 1
						elseif l_mb_l > 1 then
							if (l_ptr[1]).to_integer_32 >= 32 then
								l_mb_c := ((l_c).bit_shift_left (8)) + (l_ptr[1]).to_integer_32
							else
								if (l_ptr[1]).to_integer_32 = 0 then
									l_mb_l := 1;
									(create {P_CHARSET_STATIC}).transchar_nonprint (l_extra, l_c)
								else
									l_mb_l := 2
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_extra), ce_string ("XX")).do_nothing
								end
								l_p_extra.item := l_extra
								l_n_extra := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_extra))).to_integer_32 - 1
								l_c_extra := ('%/0/').code
								l_tmp___38 := l_p_extra.item
								l_p_extra.item := l_p_extra.item + 1
								l_c := (l_tmp___38.item).to_integer_32
								if l_area_attr = 0 then
									if l_search_attr = 0 then
										l_n_attr := l_n_extra + 1
										l_extra_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[0]
										l_saved_attr2 := l_char_attr
									end
								end
								l_mb_c := l_c
							end
						end
				when 123 then
						if not (l_col >= a_wp___0.item.w_width - 1) then
							l_pos := -1 + 126 -- skip if block
						end
				when 124 then -- if:
						if ((create {P_GLOBALS_STATIC}).mb_char2cells.item.integer_32_item ([l_mb_c])) = 2 then
							l_c := ('>').code
							l_mb_c := l_c
							l_mb_utf8 := 0
							l_mb_l := 1
							l_multi_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[1]
							l_ptr := l_ptr - 1
						else
							l_pos := -1 + 126 -- goto _L___21
						end
				when 125 then -- if block done, skip else block:
						l_pos := -1 + 127
				when 126 then -- else: | _L___21:
						if (l_ptr.item).to_integer_32 /= 0 then
							l_ptr := l_ptr + (l_mb_l - 1)
						end
				when 127 then
						if l_n_skip > 0 then
							if l_mb_l > 1 then
								if l_n_extra = 0 then
									l_n_extra := 1
									l_c_extra := ('<').code
									l_c := (' ').code
									if l_area_attr = 0 then
										if l_search_attr = 0 then
											l_n_attr := l_n_extra + 1
											l_extra_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[1]
											l_saved_attr2 := l_char_attr
										end
									end
									l_mb_c := l_c
									l_mb_utf8 := 0
									l_mb_l := 1
								end
							end
						end
				when 128 then -- if done
						l_ptr := l_ptr + 1
						if not ((a_wp___0.item.w_onebuf_opt.wo_list).to_boolean) then
							l_pos := -1 + 135 -- skip if block
						end
				when 129 then -- if:
						if l_c /= 160 then
							l_pos := -1 + 132 -- skip if block
						end
				when 130 then -- if:
						l_pos := -1 + 134 -- goto _L___22
				when 131 then -- if block done, skip else block:
						l_pos := -1 + 135
				when 132 then -- else:
						if not (l_mb_utf8.to_boolean) then
							l_pos := -1 + 135 -- skip if block
						end
				when 133 then -- if:
						if l_mb_c /= 160 then
							l_pos := -1 + 135 -- skip if block
						end
				when 134 then -- if: | _L___22:
						if ((create {P_GLOBALS_STATIC}).lcs_nbsp.item.item).to_boolean then
							l_c := (create {P_GLOBALS_STATIC}).lcs_nbsp.item.item
							if l_area_attr = 0 then
								if l_search_attr = 0 then
									l_n_attr := 1
									l_extra_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[0]
									l_saved_attr2 := l_char_attr
								end
							end
							l_mb_c := l_c
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								if ((create {P_GLOBALS_STATIC}).mb_char2len.item.integer_32_item ([l_c])) > 1 then
									l_mb_utf8 := 1
									l_u8cc[0] := 0
									l_c := 192
								else
									l_mb_utf8 := 0
								end
							else
								l_mb_utf8 := 0
							end
						end
				when 135 then -- if done | if done | if done
						if not (l_extra_check.to_boolean) then
							l_pos := -1 + 146 -- skip if block
						end
				when 136 then -- if:
						l_can_spell.item := 1
						l_v := (l_ptr.distance (l_line)).to_integer_32
						if l_has_syntax.to_boolean then
							if l_v > 0 then
								l_save_did_emsg := (create {P_GLOBALS_STATIC}).did_emsg.item;
								(create {P_GLOBALS_STATIC}).did_emsg.item := 0
								if l_has_spell.to_boolean then
									l_tmp___41 := l_can_spell
								else
									l_tmp___41 := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
								end
								l_syntax_attr := get_syntax_attr (l_v.to_integer_32 - 1, l_tmp___41, 0)
								if ((create {P_GLOBALS_STATIC}).did_emsg.item).to_boolean then
									(a_wp___0.item.w_s).item.b_syn_error := 1
									l_has_syntax := 0
								else
									(create {P_GLOBALS_STATIC}).did_emsg.item := l_save_did_emsg
								end
								l_line := (a_wp___0.item.w_buffer).item.ml_get_buf (a_lnum, 0)
								l_ptr := l_line + l_v
								if not l_attr_pri.to_boolean then
									l_char_attr := l_syntax_attr
								else
									l_char_attr := (create {P_SYNTAX_STATIC}).hl_combine_attr (l_syntax_attr, l_char_attr)
								end
							end
						end
						if not (l_has_spell.to_boolean) then
							l_pos := -1 + 145 -- skip if block
						end
				when 137 then -- if:
						if not (l_v >= l_word_end.to_integer_32) then
							l_pos := -1 + 145 -- skip if block
						end
				when 138 then -- if:
						if not (l_v > l_cur_checked_col.to_integer_32) then
							l_pos := -1 + 145 -- skip if block
						end
				when 139 then -- if:
						l_spell_attr := 0
						if not l_attr_pri.to_boolean then
							l_char_attr := l_syntax_attr
						end
						if l_c = 0 then
							l_pos := -1 + 145 -- skip if block
						end
				when 140 then -- if:
						if l_has_syntax.to_boolean then
							l_pos := -1 + 143 -- skip if block
						end
				when 141 then -- if:
						l_pos := -1 + 144 -- goto _L___23
				when 142 then -- if block done, skip else block:
						l_pos := -1 + 145
				when 143 then -- else:
						if not ((l_can_spell.item).to_boolean) then
							l_pos := -1 + 145 -- skip if block
						end
				when 144 then -- if: | _L___23:
						l_spell_hlf___0.item := {PC_HLF_T}.HLF_COUNT
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_prev_ptr___0 := l_ptr - l_mb_l
							l_v := l_v - (l_mb_l - 1).to_integer_32
						else
							l_prev_ptr___0 := l_ptr - 1
						end
						if (l_prev_ptr___0.distance (l_line)) - l_nextlinecol >= 0 then
							l_p___0 := (l_nextline + (l_prev_ptr___0.distance (l_line))) - l_nextlinecol
						else
							l_p___0 := l_prev_ptr___0
						end
						cap_col.item.item := cap_col.item.item - (l_prev_ptr___0.distance (l_line))
						l_len___0 := a_wp___0.item.spell_check (l_p___0, l_spell_hlf___0, cap_col.item, a_nochange)
						l_word_end := (l_v + l_len___0.to_integer_32).to_integer_32
						if l_spell_hlf___0.item /= {NATURAL_32} 41 then
							if (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)) /= 0 then
								if a_wp___0.item.w_cursor.lnum = a_lnum then
									if a_wp___0.item.w_cursor.col >= l_prev_ptr___0.distance (l_line) then
										if a_wp___0.item.w_cursor.col < l_word_end then
											l_spell_hlf___0.item := {PC_HLF_T}.HLF_COUNT;
											(create {P_GLOBALS_STATIC}).spell_redraw_lnum.item := a_lnum
										end
									end
								end
							end
						end
						if l_spell_hlf___0.item = {NATURAL_32} 41 then
							if not l_p___0.is_equal (l_prev_ptr___0) then
								if (l_p___0.distance (l_nextline)) + l_len___0 > l_nextline_idx then
									checked_lnum.item := a_lnum + 1
									checked_col.item := ((l_p___0.distance (l_nextline)) + l_len___0) - l_nextline_idx
								end
							end
						end
						if l_spell_hlf___0.item /= {NATURAL_32} 41 then
							l_spell_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[(l_spell_hlf___0.item).to_integer_32]
						end
						if cap_col.item.item > 0 then
							if not l_p___0.is_equal (l_prev_ptr___0) then
								if (l_p___0.distance (l_nextline)) + cap_col.item.item >= l_nextline_idx then
									capcol_lnum.item := a_lnum + 1
									cap_col.item.item := ((l_p___0.distance (l_nextline)) + cap_col.item.item) - l_nextline_idx
								else
									cap_col.item.item := cap_col.item.item + (l_prev_ptr___0.distance (l_line))
								end
							else
								cap_col.item.item := cap_col.item.item + (l_prev_ptr___0.distance (l_line))
							end
						end
				when 145 then -- if done | if done | if done | if done | if done
						if l_spell_attr /= 0 then
							if not l_attr_pri.to_boolean then
								l_char_attr := (create {P_SYNTAX_STATIC}).hl_combine_attr (l_char_attr, l_spell_attr)
							else
								l_char_attr := (create {P_SYNTAX_STATIC}).hl_combine_attr (l_spell_attr, l_char_attr)
							end
						end
						if (a_wp___0.item.w_onebuf_opt.wo_lbr).to_boolean then
							if ((create {P_GLOBALS_STATIC}).breakat_flags.item[(l_c.to_natural_8).to_integer_32]).to_boolean then
								if not ((create {P_GLOBALS_STATIC}).breakat_flags.item[(l_ptr.item).to_integer_32]).to_boolean then
									if not (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
										if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
											l_tmp___42 := l_mb_l
										else
											l_tmp___42 := 1
										end
										l_n_extra := (a_wp___0.item.win_lbr_chartabsize (l_ptr - l_tmp___42, l_vcol.to_integer_32, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))) - 1
										l_c_extra := (' ').code
										if l_c = 32 then
											l_c := (' ').code
										elseif l_c = 9 then
											l_c := (' ').code
										end
									end
								end
							end
						end
						if l_trailcol.to_integer_32 /= 2_147_483_647 then
							if (l_ptr.c_pointer.to_integer_32).to_natural_32 > ((l_line + l_trailcol).c_pointer.to_integer_32).to_natural_32 then
								if l_c = 32 then
									l_c := (create {P_GLOBALS_STATIC}).lcs_trail.item.item
									if not l_attr_pri.to_boolean then
										l_n_attr := 1
										l_extra_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[0]
										l_saved_attr2 := l_char_attr
									end
									l_mb_c := l_c
									if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
										if ((create {P_GLOBALS_STATIC}).mb_char2len.item.integer_32_item ([l_c])) > 1 then
											l_mb_utf8 := 1
											l_u8cc[0] := 0
											l_c := 192
										else
											l_mb_utf8 := 0
										end
									else
										l_mb_utf8 := 0
									end
								end
							end
						end
				when 146 then -- if done
						if ((((create {P_GLOBALS_STATIC}).chartab.item[(l_c).bit_and (255)]).to_integer_32).bit_and (16)).to_boolean then
							l_pos := -1 + 197 -- skip if block
						end
				when 147 then -- if:
						if l_c /= 9 then
							l_pos := -1 + 156 -- skip if block
						end
				when 148 then -- if:
						if (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
							l_pos := -1 + 151 -- skip if block
						end
				when 149 then -- if:
						l_pos := -1 + 152 -- goto _L___39
				when 150 then -- if block done, skip else block:
						l_pos := -1 + 155
				when 151 then -- else:
						if not (((create {P_GLOBALS_STATIC}).lcs_tab1.item).to_boolean) then
							l_pos := -1 + 154 -- skip if block
						end
				when 152 then -- if: | _L___39:
						l_n_extra := (((((a_wp___0.item.w_buffer).item.b_p_ts).to_integer_32).to_integer_32 - l_vcol \\ (((a_wp___0.item.w_buffer).item.b_p_ts).to_integer_32).to_integer_32) - 1).to_integer_32
						l_mb_utf8 := 0
						if (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
							l_c := (create {P_GLOBALS_STATIC}).lcs_tab1.item
							l_c_extra := (create {P_GLOBALS_STATIC}).lcs_tab2.item.item
							l_n_attr := l_n_extra + 1
							l_extra_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[0]
							l_saved_attr2 := l_char_attr
							l_mb_c := l_c
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								if ((create {P_GLOBALS_STATIC}).mb_char2len.item.integer_32_item ([l_c])) > 1 then
									l_mb_utf8 := 1
									l_u8cc[0] := 0
									l_c := 192
								end
							end
						else
							l_c_extra := (' ').code
							l_c := (' ').code
						end
				when 153 then -- if block done, skip else block:
						l_pos := -1 + 155
				when 154 then -- else:
						l_pos := -1 + 156 -- goto _L___38
				when 155 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 197
				when 156 then -- else: | _L___38:
						if l_c /= 0 then
							l_pos := -1 + 180 -- skip if block
						end
				when 157 then -- if:
						if not ((a_wp___0.item.w_onebuf_opt.wo_list).to_boolean) then
							l_pos := -1 + 160 -- skip if block
						end
				when 158 then -- if:
						if (create {P_GLOBALS_STATIC}).lcs_eol.item.item > 0 then
							l_pos := -1 + 170 -- goto _L___35
						else
							l_pos := -1 + 160 -- goto _L___37
						end
				when 159 then -- if block done, skip else block:
						l_pos := -1 + 179
				when 160 then -- else: | _L___37:
						if not (l_fromcol.item >= 0) then
							l_pos := -1 + 163 -- skip if block
						end
				when 161 then -- if:
						l_pos := -1 + 164 -- goto _L___36
				when 162 then -- if block done, skip else block:
						l_pos := -1 + 179
				when 163 then -- else:
						if not (l_fromcol_prev >= 0) then
							l_pos := -1 + 178 -- skip if block
						end
				when 164 then -- if: | _L___36:
						if not ((l_tocol.item).to_integer_32 > l_vcol) then
							l_pos := -1 + 176 -- skip if block
						end
				when 165 then -- if:
						if (create {P_GLOBALS_STATIC}).VIsual_mode.item = 22 then
							l_pos := -1 + 174 -- skip if block
						end
				when 166 then -- if:
						if not (l_col < a_wp___0.item.w_width) then
							l_pos := -1 + 172 -- skip if block
						end
				when 167 then -- if:
						if not (l_noinvcur.to_boolean) then
							l_pos := -1 + 170 -- skip if block
						end
				when 168 then -- if:
						if a_lnum = a_wp___0.item.w_cursor.lnum then
							if l_vcol.to_integer_32 = a_wp___0.item.w_virtcol then
								l_pos := -1 + 180 -- goto _L___32
							else
								l_pos := -1 + 170 -- goto _L___35
							end
						else
							l_pos := -1 + 170 -- goto _L___35
						end
				when 169 then -- if block done, skip else block:
						l_pos := -1 + 171
				when 170 then -- else: | _L___35:
						if l_lcs_eol_one >= 0 then
							if l_diff_hlf = ({PC_HLF_T}.HLF_8) then
								if l_line_attr = 0 then
									if l_area_highlighting.to_boolean then
										if ((create {P_MISC2_STATIC}).virtual_active).to_boolean then
											if (l_tocol.item).to_integer_32 /= 2_147_483_647 then
												if l_vcol < (l_tocol.item).to_integer_32 then
													l_n_extra := 0
												else
													l_p_extra.item := at_end_str.item
													l_n_extra := 1
													l_c_extra := ('%/0/').code
												end
											else
												l_p_extra.item := at_end_str.item
												l_n_extra := 1
												l_c_extra := ('%/0/').code
											end
										else
											l_p_extra.item := at_end_str.item
											l_n_extra := 1
											l_c_extra := ('%/0/').code
										end
									else
										l_p_extra.item := at_end_str.item
										l_n_extra := 1
										l_c_extra := ('%/0/').code
									end
								end
							end
							if (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
								l_c := (create {P_GLOBALS_STATIC}).lcs_eol.item.item
							else
								l_c := (' ').code
							end
							l_lcs_eol_one := -1
							l_ptr := l_ptr - 1
							if not l_attr_pri.to_boolean then
								l_extra_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[1]
								l_n_attr := 1
							end
							l_mb_c := l_c
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								if ((create {P_GLOBALS_STATIC}).mb_char2len.item.integer_32_item ([l_c])) > 1 then
									l_mb_utf8 := 1
									l_u8cc[0] := 0
									l_c := 192
								else
									l_mb_utf8 := 0
								end
							else
								l_mb_utf8 := 0
							end
						else
							l_pos := -1 + 180 -- goto _L___32
						end
				when 171 then -- if done | if block done, skip else block:
						l_pos := -1 + 173
				when 172 then -- else:
						l_pos := -1 + 180 -- goto _L___32
				when 173 then -- if done | if block done, skip else block:
						l_pos := -1 + 175
				when 174 then -- else:
						l_pos := -1 + 180 -- goto _L___32
				when 175 then -- if done | if block done, skip else block:
						l_pos := -1 + 177
				when 176 then -- else:
						l_pos := -1 + 180 -- goto _L___32
				when 177 then -- if done | if block done, skip else block:
						l_pos := -1 + 179
				when 178 then -- else:
						l_pos := -1 + 180 -- goto _L___32
				when 179 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 197
				when 180 then -- else: | _L___32:
						if l_c = 0 then
							l_pos := -1 + 183 -- skip if block
						end
				when 181 then -- if:
						l_p_extra.item := (create {P_CHARSET_STATIC}).transchar (l_c)
						l_n_extra := ((create {P_CHARSET_STATIC}).byte2cells (l_c)) - 1
						l_c_extra := ('%/0/').code
						l_tmp___49 := l_p_extra.item
						l_p_extra.item := l_p_extra.item + 1
						l_c := (l_tmp___49.item).to_integer_32
						if not l_attr_pri.to_boolean then
							l_n_attr := l_n_extra + 1
							l_extra_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[0]
							l_saved_attr2 := l_char_attr
						end
						l_mb_utf8 := 0
				when 182 then -- if block done, skip else block:
						l_pos := -1 + 197
				when 183 then -- else:
						if not (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
							l_pos := -1 + 192 -- skip if block
						end
				when 184 then -- if:
						if (create {P_GLOBALS_STATIC}).VIsual_mode.item /= 22 then
							l_pos := -1 + 187 -- skip if block
						end
				when 185 then -- if:
						l_pos := -1 + 188 -- goto _L___30
				when 186 then -- if block done, skip else block:
						l_pos := -1 + 191
				when 187 then -- else:
						if (create {P_GLOBALS_STATIC}).VIsual_mode.item /= 118 then
							l_pos := -1 + 190 -- skip if block
						end
				when 188 then -- if: | _L___30:
						if ((create {P_MISC2_STATIC}).virtual_active).to_boolean then
							if (l_tocol.item).to_integer_32 /= 2_147_483_647 then
								if l_vcol < (l_tocol.item).to_integer_32 then
									if l_col < a_wp___0.item.w_width then
										l_c := (' ').code
										l_ptr := l_ptr - 1
									else
										l_pos := -1 + 192 -- goto _L___29
									end
								else
									l_pos := -1 + 192 -- goto _L___29
								end
							else
								l_pos := -1 + 192 -- goto _L___29
							end
						else
							l_pos := -1 + 192 -- goto _L___29
						end
				when 189 then -- if block done, skip else block:
						l_pos := -1 + 191
				when 190 then -- else:
						l_pos := -1 + 192 -- goto _L___29
				when 191 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 197
				when 192 then -- else: | _L___29:
						if l_diff_hlf = ({PC_HLF_T}.HLF_8) then
							l_pos := -1 + 195 -- skip if block
						end
				when 193 then -- if:
						l_pos := -1 + 196 -- goto _L___24
				when 194 then -- if block done, skip else block:
						l_pos := -1 + 197
				when 195 then -- else:
						if l_line_attr = 0 then
							l_pos := -1 + 197 -- skip if block
						end
				when 196 then -- if: | _L___24:
						if l_col < a_wp___0.item.w_width then
							l_c := (' ').code
							l_ptr := l_ptr - 1
							l_did_line_attr := l_did_line_attr + 1
							if l_line_attr /= 0 then
								if l_char_attr = l_search_attr then
									if l_col > 0 then
										l_char_attr := l_line_attr
									end
								end
							end
							if l_diff_hlf = {NATURAL_32} 24 then
								l_diff_hlf := {PC_HLF_T}.HLF_CHD
								if l_attr = 0 then
									l_char_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[l_diff_hlf.to_integer_32]
								elseif l_char_attr /= l_attr then
									l_char_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[l_diff_hlf.to_integer_32]
								end
							end
						end
				when 197 then -- if done | if done | if done | if done | if done | if done | if done
						if l_n_attr > 0 then
							if l_draw_state = 6 then
								if not l_attr_pri.to_boolean then
									l_char_attr := l_extra_attr
								end
							end
						end
						if ((create {P_GLOBALS_STATIC}).xic.item).is_void then
							l_pos := -1 + 207 -- skip if block
						end
				when 198 then -- if:
						if a_lnum /= a_wp___0.item.w_cursor.lnum then
							l_pos := -1 + 207 -- skip if block
						end
				when 199 then -- if:
						if not ((((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean) then
							l_pos := -1 + 207 -- skip if block
						end
				when 200 then -- if:
						if ((create {P_OPTION_STATIC}).p_imdisable.item.item).to_boolean then
							l_pos := -1 + 207 -- skip if block
						end
				when 201 then -- if:
						if not (((create {P_MBYTE_STATIC}).im_is_preediting).to_boolean) then
							l_pos := -1 + 207 -- skip if block
						end
				when 202 then -- if:
						if l_draw_state /= 6 then
							l_pos := -1 + 207 -- skip if block
						end
				when 203 then -- if:
						if ((create {P_GLOBALS_STATIC}).preedit_end_col.item).to_integer_32 = 2_147_483_647 then
							((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), l_tcol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						else
							l_tcol.item := (create {P_GLOBALS_STATIC}).preedit_end_col.item
						end
						if not (((create {P_GLOBALS_STATIC}).preedit_start_col.item.item).to_integer_32 <= l_vcol) then
							l_pos := -1 + 206 -- skip if block
						end
				when 204 then -- if:
						if l_vcol < (l_tcol.item).to_integer_32 then
							if l_feedback_old_attr < 0 then
								l_feedback_col := 0
								l_feedback_old_attr := l_char_attr
							end
							l_char_attr := (create {P_MBYTE_STATIC}).im_get_feedback_attr (l_feedback_col)
							if l_char_attr < 0 then
								l_char_attr := l_feedback_old_attr
							end
							l_feedback_col := l_feedback_col + 1
						else
							l_pos := -1 + 206 -- goto _L___40
						end
				when 205 then -- if block done, skip else block:
						l_pos := -1 + 207
				when 206 then -- else: | _L___40:
						if l_feedback_old_attr >= 0 then
							l_char_attr := l_feedback_old_attr
							l_feedback_old_attr := -1
							l_feedback_col := 0
						end
				when 207 then -- if done | if done | if done | if done | if done | if done
						if l_lcs_prec_todo /= 0 then
							if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
								l_tmp___53 := (a_wp___0.item.w_skipcol > 0).to_integer
							else
								l_tmp___53 := (a_wp___0.item.w_leftcol > 0).to_integer
							end
							if l_tmp___53.to_boolean then
								if l_filler_todo <= 0 then
									if l_draw_state > 4 then
										if l_c /= 0 then
											l_c := (create {P_GLOBALS_STATIC}).lcs_prec.item.item
											l_lcs_prec_todo := ('%/0/').code
											l_mb_c := l_c
											if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
												if ((create {P_GLOBALS_STATIC}).mb_char2len.item.integer_32_item ([l_c])) > 1 then
													l_mb_utf8 := 1
													l_u8cc[0] := 0
													l_c := 192
												else
													l_mb_utf8 := 0
												end
											else
												l_mb_utf8 := 0
											end
											if not l_attr_pri.to_boolean then
												l_saved_attr3 := l_char_attr
												l_char_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[1]
												l_n_attr3 := 1
											end
										end
									end
								end
							end
						end
						if l_c /= 0 then
							l_pos := -1 + 210 -- skip if block
						end
				when 208 then -- if:
						l_pos := -1 + 211 -- goto _L___47
				when 209 then -- if block done, skip else block:
						l_pos := -1 + 244
				when 210 then -- else:
						if l_did_line_attr /= 1 then
							l_pos := -1 + 244 -- skip if block
						end
				when 211 then -- if: | _L___47:
						l_prevcol := (l_ptr.distance (l_line)).to_integer_32 - (l_c = 0).to_integer
						if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
							l_tmp___54 := a_wp___0.item.w_skipcol
						else
							l_tmp___54 := a_wp___0.item.w_leftcol
						end
						if l_tmp___54.to_integer_32 > l_prevcol then
							l_prevcol := l_prevcol + 1
						end
						l_prevcol_hl_flag := 0
						if l_prevcol = ((create {P_SCREEN_STATIC}).search_hl.item.item.startcol).to_integer_32 then
							l_prevcol_hl_flag := 1
						else
							l_cur := a_wp___0.item.w_match_head
							from
							until
								not (not (l_break) and then (not l_cur.is_void))
							loop
								l_break := False
								if l_prevcol = (l_cur.item.hl.startcol).to_integer_32 then
									l_prevcol_hl_flag := 1
									l_break := True
								end
								if not (l_return or l_break or l_continue) then
									l_cur := l_cur.item.next
								end
							end
							l_break := False
						end
						if (create {P_GLOBALS_STATIC}).lcs_eol.item.item /= l_lcs_eol_one then
							l_pos := -1 + 244 -- skip if block
						end
				when 212 then -- if:
						if l_area_attr = 0 then
							l_pos := -1 + 227 -- skip if block
						end
				when 213 then -- if:
						if l_vcol /= (l_fromcol.item).to_integer_32 then
							l_pos := -1 + 225 -- skip if block
						end
				when 214 then -- if:
						if (create {P_GLOBALS_STATIC}).VIsual_mode.item = 22 then
							l_pos := -1 + 217 -- skip if block
						end
				when 215 then -- if:
						l_pos := -1 + 221 -- goto _L___45
				when 216 then -- if block done, skip else block:
						l_pos := -1 + 224
				when 217 then -- else:
						if a_lnum /= (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum then
							l_pos := -1 + 220 -- skip if block
						end
				when 218 then -- if:
						l_pos := -1 + 221 -- goto _L___45
				when 219 then -- if block done, skip else block:
						l_pos := -1 + 224
				when 220 then -- else:
						if a_lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							l_pos := -1 + 223 -- skip if block
						end
				when 221 then -- if: | _L___45:
						if l_c = 0 then
							l_pos := -1 + 229 -- goto _L___42
						else
							l_pos := -1 + 227 -- goto _L___46
						end
				when 222 then -- if block done, skip else block:
						l_pos := -1 + 224
				when 223 then -- else:
						l_pos := -1 + 227 -- goto _L___46
				when 224 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 226
				when 225 then -- else:
						l_pos := -1 + 227 -- goto _L___46
				when 226 then -- if done | if block done, skip else block:
						l_pos := -1 + 244
				when 227 then -- else: | _L___46:
						if l_prevcol_hl_flag /= 1 then
							l_pos := -1 + 244 -- skip if block
						end
				when 228 then -- if:
						if not (l_did_line_attr <= 1) then
							l_pos := -1 + 244 -- skip if block
						end
				when 229 then -- if: | _L___42:
						l_n := 0
						if l_col >= a_wp___0.item.w_width then
							l_n := -1
						end
						if l_n /= 0 then
							l_off___0 := l_off___0 + l_n.to_natural_32
							l_col := l_col + l_n
						else
							(create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0.to_integer_32] := ((' ').code).to_natural_8
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off___0.to_integer_32] := (0).to_natural_32
							end
						end
						if l_area_attr /= 0 then
							l_pos := -1 + 243 -- skip if block
						end
				when 230 then -- if:
						l_char_attr := (create {P_SCREEN_STATIC}).search_hl.item.item.attr
						l_cur := a_wp___0.item.w_match_head
						l_shl_flag := 0
				when 231 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 242 -- skip loop
						end
				when 232 then -- loop body:
						l_break := False
						if l_cur.is_void then
							if l_shl_flag /= 0 then
								l_break := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 241 -- skip if block
						end
				when 233 then -- if:
						if l_shl_flag /= 0 then
							l_pos := -1 + 239 -- skip if block
						end
				when 234 then -- if:
						if l_cur.is_void then
							l_pos := -1 + 237 -- skip if block
						end
				when 235 then -- if:
						if l_cur.item.priority > 0 then
							l_shl := (create {P_SCREEN_STATIC}).search_hl.item
							l_shl_flag := 1
						else
							l_pos := -1 + 237 -- goto _L___41
						end
				when 236 then -- if block done, skip else block:
						l_pos := -1 + 238
				when 237 then -- else: | _L___41:
						if l_cur.is_void then
							l_shl := (create {P_SCREEN_STATIC}).search_hl.item
							l_shl_flag := 1
						else
							l_shl := create {CE_CLASS_POINTER [PD_MATCH_T]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl"))
						end
				when 238 then -- if done | if block done, skip else block:
						l_pos := -1 + 240
				when 239 then -- else:
						l_shl := create {CE_CLASS_POINTER [PD_MATCH_T]}.make_shared (l_cur.c_pointer + (create {PD_MATCHITEM}.make).offset_of ("hl"))
				when 240 then
						if ((l_ptr.distance (l_line)) - 1).to_integer_32 = (l_shl.item.startcol).to_integer_32 then
							l_char_attr := l_shl.item.attr
						end
						if not l_shl.is_equal ((create {P_SCREEN_STATIC}).search_hl.item) then
							if not l_cur.is_void then
								l_cur := l_cur.item.next
							end
						end
				when 241 then -- if done
						l_pos := -1 + 231 -- back to loop condition
				when 242 then -- loop done
						l_break := False
				when 243 then -- if done;
						(create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0.to_integer_32] := l_char_attr.to_natural_16
						l_col := l_col + 1
						l_off___0 := l_off___0 + 1
						l_vcol := l_vcol + 1
						l_eol_hl_off := 1
				when 244 then -- if done | if done | if done | if done | if done
						if l_c /= 0 then
							l_pos := -1 + 258 -- skip if block
						end
				when 245 then -- if:
						if l_eol_hl_off > 0 then
							if l_vcol - l_eol_hl_off.to_integer_32 = (a_wp___0.item.w_virtcol).to_integer_32 then
								if a_lnum = a_wp___0.item.w_cursor.lnum then
									l_col := l_col - 1
									l_off___0 := l_off___0 - 1
									l_vcol := l_vcol - 1
								end
							end
						end
						if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
							l_v := (a_wp___0.item.w_skipcol).to_integer_32
						else
							l_v := (a_wp___0.item.w_leftcol).to_integer_32
						end
						if l_vcol < (l_v + l_col.to_integer_32) - (a_wp___0.item.win_col_off).to_integer_32 then
							l_vcol := (l_v + l_col.to_integer_32) - (a_wp___0.item.win_col_off).to_integer_32
						end
						if l_draw_color_col.to_boolean then
							l_draw_color_col := advance_color_col (l_vcol.to_integer_32, l_color_cols)
						end
						if not ((a_wp___0.item.w_onebuf_opt.wo_cuc).to_boolean) then
							l_pos := -1 + 248 -- skip if block
						end
				when 246 then -- if:
						if (a_wp___0.item.w_virtcol).to_integer_32 >= l_vcol - l_eol_hl_off.to_integer_32 then
							if (a_wp___0.item.w_virtcol).to_integer_32 < (a_wp___0.item.w_width * ((l_row - a_startrow) + 1)).to_integer_32 + l_v then
								if a_lnum /= a_wp___0.item.w_cursor.lnum then
									l_pos := -1 + 249 -- goto _L___49
								else
									l_pos := -1 + 248 -- goto _L___52
								end
							else
								l_pos := -1 + 248 -- goto _L___52
							end
						else
							l_pos := -1 + 248 -- goto _L___52
						end
				when 247 then -- if block done, skip else block:
						l_pos := -1 + 257
				when 248 then -- else: | _L___52:
						if not (l_draw_color_col.to_boolean) then
							l_pos := -1 + 257 -- skip if block
						end
				when 249 then -- if: | _L___49:
						l_rightmost_vcol := 0
						if (a_wp___0.item.w_onebuf_opt.wo_cuc).to_boolean then
							l_rightmost_vcol := a_wp___0.item.w_virtcol
						end
						if l_draw_color_col.to_boolean then
							l_i___1 := 0
							from
							until
								not (l_color_cols.item[l_i___1] >= 0)
							loop
								if l_rightmost_vcol < l_color_cols.item[l_i___1] then
									l_rightmost_vcol := l_color_cols.item[l_i___1]
								end
								l_i___1 := l_i___1 + 1
							end
						end
				when 250 then -- loop condition:
						if not (not (l_break) and then (l_col < a_wp___0.item.w_width)) then
							l_pos := -1 + 256 -- skip loop
						end
				when 251 then -- loop body:
						l_break := False;
						(create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0.to_integer_32] := ((' ').code).to_natural_8
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off___0.to_integer_32] := (0).to_natural_32
						end
						l_col := l_col + 1
						if l_draw_color_col.to_boolean then
							l_draw_color_col := advance_color_col (l_vcol.to_integer_32, l_color_cols)
						end
						if not ((a_wp___0.item.w_onebuf_opt.wo_cuc).to_boolean) then
							l_pos := -1 + 254 -- skip if block
						end
				when 252 then -- if:
						if l_vcol = (a_wp___0.item.w_virtcol).to_integer_32 then
							l_tmp___57 := l_off___0
							l_off___0 := l_off___0 + 1;
							(create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_tmp___57.to_integer_32] := ((create {P_GLOBALS_STATIC}).highlight_attr.item[38]).to_natural_16
						else
							l_pos := -1 + 254 -- goto _L___48
						end
				when 253 then -- if block done, skip else block:
						l_pos := -1 + 255
				when 254 then -- else: | _L___48:
						if l_draw_color_col.to_boolean then
							if l_vcol = (l_color_cols.item.item).to_integer_32 then
								l_tmp___58 := l_off___0
								l_off___0 := l_off___0 + 1;
								(create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_tmp___58.to_integer_32] := ((create {P_GLOBALS_STATIC}).highlight_attr.item[40]).to_natural_16
							else
								l_tmp___59 := l_off___0
								l_off___0 := l_off___0 + 1;
								(create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_tmp___59.to_integer_32] := (0).to_natural_16
							end
						else
							l_tmp___59 := l_off___0
							l_off___0 := l_off___0 + 1;
							(create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_tmp___59.to_integer_32] := (0).to_natural_16
						end
				when 255 then
						if l_vcol >= l_rightmost_vcol.to_integer_32 then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_vcol := l_vcol + 1
						end
						l_pos := -1 + 250 -- back to loop condition
				when 256 then -- loop done
						l_break := False
				when 257 then -- if done
						screen_line (l_screen_row, a_wp___0.item.w_wincol, l_col, a_wp___0.item.w_width)
						l_row := l_row + 1
						if a_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
							if a_lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_row := a_startrow;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_height := l_row - a_startrow;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_folded := 0;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_or ((24))
							end
						end
						l_break := True
				when 258 then -- if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 318 -- skip if block
						end
				when 259 then -- if:
						if not (((create {P_GLOBALS_STATIC}).lcs_ext.item.item).to_boolean) then
							l_pos := -1 + 275 -- skip if block
						end
				when 260 then -- if:
						if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
							l_pos := -1 + 275 -- skip if block
						end
				when 261 then -- if:
						if not (l_filler_todo <= 0) then
							l_pos := -1 + 275 -- skip if block
						end
				when 262 then -- if:
						if l_col /= a_wp___0.item.w_width - 1 then
							l_pos := -1 + 275 -- skip if block
						end
				when 263 then -- if:
						if (l_ptr.item).to_integer_32 = 0 then
							l_pos := -1 + 266 -- skip if block
						end
				when 264 then -- if:
						l_pos := -1 + 274 -- goto _L___54
				when 265 then -- if block done, skip else block:
						l_pos := -1 + 275
				when 266 then -- else:
						if not ((a_wp___0.item.w_onebuf_opt.wo_list).to_boolean) then
							l_pos := -1 + 269 -- skip if block
						end
				when 267 then -- if:
						if l_lcs_eol_one > 0 then
							l_pos := -1 + 274 -- goto _L___54
						else
							l_pos := -1 + 269 -- goto _L___55
						end
				when 268 then -- if block done, skip else block:
						l_pos := -1 + 275
				when 269 then -- else: | _L___55:
						if not (l_n_extra.to_boolean) then
							l_pos := -1 + 275 -- skip if block
						end
				when 270 then -- if:
						if l_c_extra = 0 then
							l_pos := -1 + 273 -- skip if block
						end
				when 271 then -- if:
						l_pos := -1 + 274 -- goto _L___54
				when 272 then -- if block done, skip else block:
						l_pos := -1 + 275
				when 273 then -- else:
						if (l_p_extra.item.item).to_integer_32 = 0 then
							l_pos := -1 + 275 -- skip if block
						end
				when 274 then -- if: | _L___54:
						l_c := (create {P_GLOBALS_STATIC}).lcs_ext.item.item
						l_char_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[1]
						l_mb_c := l_c
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).mb_char2len.item.integer_32_item ([l_c])) > 1 then
								l_mb_utf8 := 1
								l_u8cc[0] := 0
								l_c := 192
							else
								l_mb_utf8 := 0
							end
						else
							l_mb_utf8 := 0
						end
				when 275 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if l_draw_color_col.to_boolean then
							l_draw_color_col := advance_color_col (l_vcol.to_integer_32, l_color_cols)
						end
						l_vcol_save_attr := -1
						if l_draw_state /= 6 then
							l_pos := -1 + 281 -- skip if block
						end
				when 276 then -- if:
						if l_lnum_in_visual_area.to_boolean then
							l_pos := -1 + 281 -- skip if block
						end
				when 277 then -- if:
						if not ((a_wp___0.item.w_onebuf_opt.wo_cuc).to_boolean) then
							l_pos := -1 + 280 -- skip if block
						end
				when 278 then -- if:
						if l_vcol = (a_wp___0.item.w_virtcol).to_integer_32 then
							if a_lnum /= a_wp___0.item.w_cursor.lnum then
								l_vcol_save_attr := l_char_attr
								l_char_attr := (create {P_SYNTAX_STATIC}).hl_combine_attr (l_char_attr, (create {P_GLOBALS_STATIC}).highlight_attr.item[38])
							else
								l_pos := -1 + 280 -- goto _L___57
							end
						else
							l_pos := -1 + 280 -- goto _L___57
						end
				when 279 then -- if block done, skip else block:
						l_pos := -1 + 281
				when 280 then -- else: | _L___57:
						if l_draw_color_col.to_boolean then
							if l_vcol = (l_color_cols.item.item).to_integer_32 then
								l_vcol_save_attr := l_char_attr
								l_char_attr := (create {P_SYNTAX_STATIC}).hl_combine_attr (l_char_attr, (create {P_GLOBALS_STATIC}).highlight_attr.item[40])
							end
						end
				when 281 then -- if done | if done
						l_vcol_prev := l_vcol
						if not (l_draw_state < 6) then
							l_pos := -1 + 284 -- skip if block
						end
				when 282 then -- if:
						l_pos := -1 + 285 -- goto _L___58
				when 283 then -- if block done, skip else block:
						l_pos := -1 + 288
				when 284 then -- else:
						if not (l_n_skip <= 0) then
							l_pos := -1 + 287 -- skip if block
						end
				when 285 then -- if: | _L___58:;
						(create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0.to_integer_32] := l_c.to_natural_8
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 9_932 then
							if ((l_mb_c).bit_and (65_280)) = 36_352 then
								(create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0.to_integer_32] := (142).to_natural_8
							end
							(create {P_GLOBALS_STATIC}).ScreenLines2.item[l_off___0.to_integer_32] := ((l_mb_c).bit_and (255)).to_natural_8
						elseif ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							if l_mb_utf8.to_boolean then
								(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off___0.to_integer_32] := l_mb_c.to_natural_32
								if ((l_c).bit_and (255)) = 0 then
									(create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0.to_integer_32] := (128).to_natural_8
								end
								l_i___2 := 0
								from
								until
									not (not (l_break) and then (l_i___2 < (create {P_GLOBALS_STATIC}).Screen_mco.item))
								loop
									l_break := False;
									((create {P_GLOBALS_STATIC}).ScreenLinesC.item[l_i___2])[l_off___0.to_integer_32] := (l_u8cc[l_i___2]).to_natural_32
									if l_u8cc[l_i___2] = 0 then
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										l_i___2 := l_i___2 + 1
									end
								end
								l_break := False
							else
								(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off___0.to_integer_32] := (0).to_natural_32
							end
						end
						if l_multi_attr.to_boolean then
							(create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0.to_integer_32] := l_multi_attr.to_natural_16
							l_multi_attr := 0
						else
							(create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off___0.to_integer_32] := l_char_attr.to_natural_16
						end
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).mb_char2cells.item.integer_32_item ([l_mb_c])) > 1 then
								l_off___0 := l_off___0 + 1
								l_col := l_col + 1
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									(create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0.to_integer_32] := (0).to_natural_8
								else
									(create {P_GLOBALS_STATIC}).ScreenLines.item[l_off___0.to_integer_32] := ((l_mb_c).bit_and (255)).to_natural_8
								end
								l_vcol := l_vcol + 1
								if (l_tocol.item).to_integer_32 = l_vcol then
									l_tocol.item := l_tocol.item + 1
								end
							end
						end
						l_off___0 := l_off___0 + 1
						l_col := l_col + 1
				when 286 then -- if block done, skip else block:
						l_pos := -1 + 288
				when 287 then -- else:
						l_n_skip := l_n_skip - 1
				when 288 then -- if done
						if l_draw_state > 4 then
							if l_filler_todo <= 0 then
								l_vcol := l_vcol + 1
							end
						end
						if l_vcol_save_attr >= 0 then
							l_char_attr := l_vcol_save_attr
						end
						if l_draw_state > 4 then
							if l_n_attr3 > 0 then
								l_n_attr3 := l_n_attr3 - 1
								if l_n_attr3 = 0 then
									l_char_attr := l_saved_attr3
								end
							end
						end
						if l_n_attr > 0 then
							if l_draw_state = 6 then
								l_n_attr := l_n_attr - 1
								if l_n_attr = 0 then
									l_char_attr := l_saved_attr2
								end
							end
						end
						if not (l_col >= a_wp___0.item.w_width) then
							l_pos := -1 + 318 -- skip if block
						end
				when 289 then -- if:
						if (l_ptr.item).to_integer_32 = 0 then
							l_pos := -1 + 292 -- skip if block
						end
				when 290 then -- if:
						l_pos := -1 + 303 -- goto _L___62
				when 291 then -- if block done, skip else block:
						l_pos := -1 + 318
				when 292 then -- else:
						if not (l_filler_todo > 0) then
							l_pos := -1 + 295 -- skip if block
						end
				when 293 then -- if:
						l_pos := -1 + 303 -- goto _L___62
				when 294 then -- if block done, skip else block:
						l_pos := -1 + 318
				when 295 then -- else:
						if not ((a_wp___0.item.w_onebuf_opt.wo_list).to_boolean) then
							l_pos := -1 + 298 -- skip if block
						end
				when 296 then -- if:
						if (create {P_GLOBALS_STATIC}).lcs_eol.item.item /= 0 then
							if not (l_p_extra.item).is_equal (at_end_str.item) then
								l_pos := -1 + 303 -- goto _L___62
							else
								l_pos := -1 + 298 -- goto _L___64
							end
						else
							l_pos := -1 + 298 -- goto _L___64
						end
				when 297 then -- if block done, skip else block:
						l_pos := -1 + 318
				when 298 then -- else: | _L___64:
						if l_n_extra = 0 then
							l_pos := -1 + 318 -- skip if block
						end
				when 299 then -- if:
						if l_c_extra = 0 then
							l_pos := -1 + 302 -- skip if block
						end
				when 300 then -- if:
						l_pos := -1 + 303 -- goto _L___62
				when 301 then -- if block done, skip else block:
						l_pos := -1 + 318
				when 302 then -- else:
						if (l_p_extra.item.item).to_integer_32 = 0 then
							l_pos := -1 + 318 -- skip if block
						end
				when 303 then -- if: | _L___62:
						screen_line (l_screen_row, a_wp___0.item.w_wincol, l_col, a_wp___0.item.w_width)
						l_row := l_row + 1
						l_screen_row := l_screen_row + 1
						if (a_wp___0.item.w_onebuf_opt.wo_wrap).to_boolean then
							l_pos := -1 + 306 -- skip if block
						end
				when 304 then -- if:
						if l_filler_todo <= 0 then
							l_break := True
						else
							l_pos := -1 + 306 -- goto _L___59
						end
				when 305 then -- if block done, skip else block:
						l_pos := -1 + 307
				when 306 then -- else: | _L___59:
						if l_lcs_eol_one = -1 then
							l_break := True
						end
				when 307 then
						if not (l_return or l_break or l_continue) then
							if l_draw_state /= 6 then
								if l_filler_todo <= 0 then
									a_wp___0.item.win_draw_end (('@').code, (' ').code, l_row, a_wp___0.item.w_height, {PC_HLF_T}.HLF_AT)
									a_wp___0.item.draw_vsep_win (l_row)
									l_row := a_endrow
								end
							end
							if l_row = a_endrow then
								l_row := l_row + 1
								l_break := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 318 -- skip if block
						end
				when 308 then -- if:
						if (create {P_SCREEN_STATIC}).screen_cur_row.item /= l_screen_row - 1 then
							l_pos := -1 + 317 -- skip if block
						end
				when 309 then -- if:
						if not (l_filler_todo <= 0) then
							l_pos := -1 + 317 -- skip if block
						end
				when 310 then -- if:
						if (a_wp___0.item.w_width).to_integer_32 /= (create {P_GLOBALS_STATIC}).Columns.item.item then
							l_pos := -1 + 317 -- skip if block
						end
				when 311 then -- if:;
						(create {P_GLOBALS_STATIC}).LineWraps.item[(l_screen_row - 1)] := (1).to_natural_8
						if not (((create {P_OPTION_STATIC}).p_tf.item.item).to_boolean) then
							l_pos := -1 + 317 -- skip if block
						end
				when 312 then -- if:
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							l_pos := -1 + 317 -- skip if block
						end
				when 313 then -- if:
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 316 -- skip if block
						end
				when 314 then -- if:
						if ((create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([(create {P_GLOBALS_STATIC}).LineOffset.item[l_screen_row], (create {P_GLOBALS_STATIC}).LineOffset.item[l_screen_row] + ((create {P_GLOBALS_STATIC}).screen_Columns.item).to_natural_32])) /= 2 then
							if ((create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([((create {P_GLOBALS_STATIC}).LineOffset.item[(l_screen_row - 1)] + (((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32).to_natural_32) - {NATURAL_32} 2, (create {P_GLOBALS_STATIC}).LineOffset.item[l_screen_row] + ((create {P_GLOBALS_STATIC}).screen_Columns.item).to_natural_32])) /= 2 then
								l_pos := -1 + 316 -- goto _L___60
							end
						end
				when 315 then -- if block done, skip else block:
						l_pos := -1 + 317
				when 316 then -- else: | _L___60:
						if (create {P_SCREEN_STATIC}).screen_cur_col.item /= a_wp___0.item.w_width then
							(create {P_SCREEN_STATIC}).screen_char (((create {P_GLOBALS_STATIC}).LineOffset.item[(l_screen_row - 1)] + ((create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32) - {NATURAL_32} 1, l_screen_row - 1, ((create {P_GLOBALS_STATIC}).Columns.item.item - 1).to_integer_32)
						end
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[((create {P_GLOBALS_STATIC}).ScreenLines.item[(((create {P_GLOBALS_STATIC}).LineOffset.item[(l_screen_row - 1)]).to_natural_32 + ((create {P_GLOBALS_STATIC}).Columns.item.item - 1).to_natural_32).to_integer_32]).to_integer_32]).to_integer_32 > 1 then
								(create {P_TERM_STATIC}).out_char (((' ').code).to_natural_32)
							else
								(create {P_TERM_STATIC}).out_char (((create {P_GLOBALS_STATIC}).ScreenLines.item[(((create {P_GLOBALS_STATIC}).LineOffset.item[(l_screen_row - 1)]).to_natural_32 + ((create {P_GLOBALS_STATIC}).Columns.item.item - 1).to_natural_32).to_integer_32]).to_natural_32)
							end
						else
							(create {P_TERM_STATIC}).out_char (((create {P_GLOBALS_STATIC}).ScreenLines.item[(((create {P_GLOBALS_STATIC}).LineOffset.item[(l_screen_row - 1)]).to_natural_32 + ((create {P_GLOBALS_STATIC}).Columns.item.item - 1).to_natural_32).to_integer_32]).to_natural_32)
						end
						(create {P_GLOBALS_STATIC}).ScreenAttrs.item[((create {P_GLOBALS_STATIC}).LineOffset.item[l_screen_row]).to_integer_32] := (-1).to_natural_16;
						(create {P_SCREEN_STATIC}).screen_start
				when 317 then -- if done | if done | if done | if done | if done
						l_col := 0
						l_off___0 := (((create {P_SCREEN_STATIC}).current_ScreenLine.item).distance (((create {P_GLOBALS_STATIC}).ScreenLines.item))).to_natural_32
						l_draw_state := 0
						l_saved_n_extra := l_n_extra
						l_saved_p_extra := l_p_extra.item
						l_saved_c_extra := l_c_extra
						l_saved_char_attr := l_char_attr
						l_n_extra := 0
						l_lcs_prec_todo := (create {P_GLOBALS_STATIC}).lcs_prec.item.item
						if l_filler_todo <= 0 then
							l_need_showbreak := 1
						end
						l_filler_todo := l_filler_todo - 1
						if l_filler_todo = 0 then
							if (a_wp___0.item.w_botfill).to_boolean then
								l_break := True
							end
						end
				when 318 then -- if done | if done | if done | if done | if done | if done | if done | if done
						l_pos := -1 + 22 -- back to loop condition
				when 319 then -- loop done
						l_break := False
						if (((create {P_CHARSET_STATIC}).skipwhite (l_line)).item).to_integer_32 = 0 then
							capcol_lnum.item := a_lnum + 1
							cap_col.item.item := 0
						end
						Result := l_row
				when 320 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	screen_line (a_row, a_coloff, a_endcol, a_clear_width: INTEGER_32)
		local
			l_off_from: NATURAL_32
			l_off_to: NATURAL_32
			l_max_off_from: NATURAL_32
			l_max_off_to: NATURAL_32
			l_col: INTEGER_32
			l_hl: CE_ARRAY [INTEGER_32]
			l_force: INTEGER_32
			l_redraw_this: INTEGER_32
			l_redraw_next: INTEGER_32
			l_clear_next: INTEGER_32
			l_char_cells: INTEGER_32
			l_tmp___0: INTEGER_32
			l_i___0: INTEGER_32
			l_startCol: INTEGER_32
			l_prev_cells: INTEGER_32
			l_off___0: NATURAL_32
			l_max_off: NATURAL_32
			l_c: INTEGER_32
			l_tmp___7: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_hl.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_col := 0
					l_force := 0
					l_redraw_this := 1
					l_clear_next := 0;
					(create {P_UI_STATIC}).clip_may_clear_selection (a_row, a_row)
					l_off_from := (((create {P_SCREEN_STATIC}).current_ScreenLine.item).distance (((create {P_GLOBALS_STATIC}).ScreenLines.item))).to_natural_32
					l_off_to := (create {P_GLOBALS_STATIC}).LineOffset.item[a_row] + a_coloff.to_natural_32
					l_max_off_from := l_off_from + ((create {P_GLOBALS_STATIC}).screen_Columns.item).to_natural_32
					l_max_off_to := (create {P_GLOBALS_STATIC}).LineOffset.item[a_row] + ((create {P_GLOBALS_STATIC}).screen_Columns.item).to_natural_32
					l_redraw_next := char_needs_redraw (l_off_from.to_integer_32, l_off_to.to_integer_32, a_endcol - l_col)
				when 1 then -- loop condition:
					if not (not (l_return) and then (l_col < a_endcol)) then
						l_pos := -1 + 24 -- skip loop
					end
				when 2 then -- loop body:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							if l_col + 1 < a_endcol then
								l_char_cells := (create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([l_off_from, l_max_off_from])
							else
								l_char_cells := 1
							end
						else
							l_char_cells := 1
						end
						l_redraw_this := l_redraw_next
						if l_force.to_boolean then
							l_tmp___0 := 1
						elseif (char_needs_redraw ((l_off_from + l_char_cells.to_natural_32).to_integer_32, (l_off_to + l_char_cells.to_natural_32).to_integer_32, (a_endcol - l_col) - l_char_cells)).to_boolean then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
						l_redraw_next := l_tmp___0
						if l_redraw_next.to_boolean then
							if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
								l_hl.item := ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[(l_off_to + l_char_cells.to_natural_32).to_integer_32]).to_integer_32
								if l_hl.item > 63 then
									l_hl.item := (create {P_SYNTAX_STATIC}).syn_attr2attr (l_hl.item)
								end
								if ((l_hl.item).bit_and (2)).to_boolean then
									l_redraw_this := 1
								end
							end
						end
						if not (l_redraw_this.to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 3 then -- if:
						if ((create {P_OPTION_STATIC}).p_wiv.item.item).to_boolean then
							if not l_force.to_boolean then
								if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
									if ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off_to.to_integer_32]).to_integer_32 /= 0 then
										if ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off_from.to_integer_32]).to_integer_32 /= ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off_to.to_integer_32]).to_integer_32 then
											(create {P_SCREEN_STATIC}).windgoto (a_row, l_col + a_coloff);
											(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[1]);
											(create {P_SCREEN_STATIC}).screen_start
											l_force := 1
											l_redraw_next := 1
											if l_col + a_coloff > 0 then
												if ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[(l_off_to - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 0 then
													(create {P_SCREEN_STATIC}).screen_attr.item := ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[(l_off_to - {NATURAL_32} 1).to_integer_32]).to_integer_32;
													(create {P_TERM_STATIC}).term_windgoto (a_row, l_col + a_coloff);
													(create {P_SCREEN_STATIC}).screen_stop_highlight
												else
													(create {P_SCREEN_STATIC}).screen_attr.item := 0
												end
											else
												(create {P_SCREEN_STATIC}).screen_attr.item := 0
											end
										end
									end
								end
							end
						end
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if l_char_cells /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_col + 1 < a_endcol then
							if ((create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([l_off_to, l_max_off_to])) > 1 then
								(create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off_to + {NATURAL_32} 1).to_integer_32] := (0).to_natural_8
								l_redraw_next := 1
							else
								l_pos := -1 + 7 -- goto _L___0
							end
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L___0:
						if l_char_cells = 2 then
							if l_col + 2 < a_endcol then
								if ((create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([l_off_to, l_max_off_to])) = 1 then
									if ((create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([l_off_to + {NATURAL_32} 1, l_max_off_to])) > 1 then
										(create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off_to + {NATURAL_32} 2).to_integer_32] := (0).to_natural_8
										l_redraw_next := 1
									end
								end
							end
						end
				when 8 then
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 9_932 then
							(create {P_GLOBALS_STATIC}).ScreenLines2.item[l_off_to.to_integer_32] := (create {P_GLOBALS_STATIC}).ScreenLines2.item[l_off_from.to_integer_32]
						end
				when 9 then -- if done
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						if l_col + l_char_cells /= a_endcol then
							l_pos := -1 + 15 -- skip if block
						end
				when 11 then -- if:
						if l_char_cells /= 1 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if ((create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([l_off_to, l_max_off_to])) > 1 then
							l_clear_next := 1
						else
							l_pos := -1 + 14 -- goto _L___1
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L___1:
						if l_char_cells = 2 then
							if ((create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([l_off_to, l_max_off_to])) = 1 then
								if ((create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([l_off_to + {NATURAL_32} 1, l_max_off_to])) > 1 then
									l_clear_next := 1
								end
							end
						end
				when 15 then -- if done | if done;
						(create {P_GLOBALS_STATIC}).ScreenLines.item[l_off_to.to_integer_32] := (create {P_GLOBALS_STATIC}).ScreenLines.item[l_off_from.to_integer_32]
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off_to.to_integer_32] := (create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off_from.to_integer_32]
							if (create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off_from.to_integer_32] /= {NATURAL_32} 0 then
								l_i___0 := 0
								from
								until
									not (l_i___0 < (create {P_GLOBALS_STATIC}).Screen_mco.item)
								loop
									((create {P_GLOBALS_STATIC}).ScreenLinesC.item[l_i___0])[l_off_to.to_integer_32] := ((create {P_GLOBALS_STATIC}).ScreenLinesC.item[l_i___0])[l_off_from.to_integer_32]
									l_i___0 := l_i___0 + 1
								end
							end
						end
						if l_char_cells = 2 then
							(create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off_to + {NATURAL_32} 1).to_integer_32] := (create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off_from + {NATURAL_32} 1).to_integer_32]
						end
						if not (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L___2
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 18 then -- else:
						if not (((create {P_GLOBALS_STATIC}).term_is_xterm.item).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 19 then -- if: | _L___2:
						l_hl.item := ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off_to.to_integer_32]).to_integer_32
						if l_hl.item > 63 then
							l_hl.item := (create {P_SYNTAX_STATIC}).syn_attr2attr (l_hl.item)
						end
						if ((l_hl.item).bit_and (2)).to_boolean then
							l_redraw_next := 1
						end
				when 20 then -- if done;
						(create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off_to.to_integer_32] := (create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off_from.to_integer_32]
						if l_char_cells = 2 then
							(create {P_GLOBALS_STATIC}).ScreenAttrs.item[(l_off_to + {NATURAL_32} 1).to_integer_32] := (create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off_from.to_integer_32]
						end
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 0 then
							if l_char_cells = 2 then
								(create {P_SCREEN_STATIC}).screen_char_2 (l_off_to, a_row, l_col + a_coloff)
							else
								(create {P_SCREEN_STATIC}).screen_char (l_off_to, a_row, l_col + a_coloff)
							end
						else
							(create {P_SCREEN_STATIC}).screen_char (l_off_to, a_row, l_col + a_coloff)
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						if ((create {P_OPTION_STATIC}).p_wiv.item.item).to_boolean then
							if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
								if l_col + a_coloff > 0 then
									if ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off_to.to_integer_32]).to_integer_32 = ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[(l_off_to - {NATURAL_32} 1).to_integer_32]).to_integer_32 then
										(create {P_SCREEN_STATIC}).screen_attr.item := 0
									elseif (create {P_SCREEN_STATIC}).screen_attr.item /= 0 then
										(create {P_SCREEN_STATIC}).screen_stop_highlight
									end
								end
							end
						end
				when 23 then -- if done
						l_off_to := l_off_to + l_char_cells.to_natural_32
						l_off_from := l_off_from + l_char_cells.to_natural_32
						l_col := l_col + l_char_cells
						l_pos := -1 + 1 -- back to loop condition
				when 24 then -- loop done
					if l_clear_next.to_boolean then
						(create {P_GLOBALS_STATIC}).ScreenLines.item[l_off_to.to_integer_32] := ((' ').code).to_natural_8
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off_to.to_integer_32] := (0).to_natural_32
						end
						(create {P_SCREEN_STATIC}).screen_char (l_off_to, a_row, l_col + a_coloff)
					end
					if not (a_clear_width > 0) then
						l_pos := -1 + 37 -- skip if block
					end
				when 25 then -- if:
						l_startCol := l_col
						from
						until
							(l_break)
						loop
							l_break := False
							if l_col < a_clear_width then
								if ((create {P_GLOBALS_STATIC}).ScreenLines.item[l_off_to.to_integer_32]).to_integer_32 = 32 then
									if ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off_to.to_integer_32]).to_integer_32 = 0 then
										if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
											if (create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off_to.to_integer_32] /= {NATURAL_32} 0 then
												l_break := True
											end
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_off_to := l_off_to + 1
								l_col := l_col + 1
							end
						end
						l_break := False
						if not (l_col < a_clear_width) then
							l_pos := -1 + 37 -- skip if block
						end
				when 26 then -- if:
						if not (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
							l_pos := -1 + 36 -- skip if block
						end
				when 27 then -- if:
						if not (l_col > l_startCol) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 31 -- goto _L___4
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 30 then -- else:
						if l_redraw_this.to_boolean then
							l_pos := -1 + 36 -- skip if block
						end
				when 31 then -- if: | _L___4:
						l_hl.item := ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off_to.to_integer_32]).to_integer_32
						if not (l_hl.item > 63) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 35 -- goto _L___3
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 34 then -- else:
						if not (((l_hl.item).bit_and (2)).to_boolean) then
							l_pos := -1 + 36 -- skip if block
						end
				when 35 then -- if: | _L___3:
						l_prev_cells := 1
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).ScreenLines.item[(l_off_to - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 0 then
								l_prev_cells := 2
							else
								l_prev_cells := 1
							end
						elseif (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 0 then
							l_off___0 := (create {P_GLOBALS_STATIC}).LineOffset.item[a_row]
							l_max_off := (create {P_GLOBALS_STATIC}).LineOffset.item[a_row] + ((create {P_GLOBALS_STATIC}).screen_Columns.item).to_natural_32
							from
							until
								not (l_off___0 < l_off_to)
							loop
								l_prev_cells := (create {P_GLOBALS_STATIC}).mb_off2cells.item.integer_32_item ([l_off___0, l_max_off])
								l_off___0 := l_off___0 + l_prev_cells.to_natural_32
							end
						end
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 0 then
							if l_prev_cells > 1 then
								(create {P_SCREEN_STATIC}).screen_char_2 (l_off_to - l_prev_cells.to_natural_32, a_row, (l_col + a_coloff) - l_prev_cells)
							else
								(create {P_SCREEN_STATIC}).screen_char (l_off_to - l_prev_cells.to_natural_32, a_row, (l_col + a_coloff) - l_prev_cells)
							end
						else
							(create {P_SCREEN_STATIC}).screen_char (l_off_to - l_prev_cells.to_natural_32, a_row, (l_col + a_coloff) - l_prev_cells)
						end
				when 36 then -- if done | if done | if done | if done;
						(create {P_SCREEN_STATIC}).screen_fill (a_row, a_row + 1, l_col + a_coloff, a_clear_width + a_coloff, (' ').code, (' ').code, 0)
						l_off_to := l_off_to + (a_clear_width - l_col).to_natural_32
						l_col := a_clear_width
				when 37 then -- if done | if done
					if not (a_clear_width > 0) then
						l_pos := -1 + 49 -- skip if block
					end
				when 38 then -- if:
						if not ((l_col + a_coloff).to_integer_32 < (create {P_GLOBALS_STATIC}).Columns.item.item) then
							l_pos := -1 + 48 -- skip if block
						end
				when 39 then -- if:
						l_c := (create {P_SCREEN_STATIC}).fillchar_vsep (l_hl)
						if ((create {P_GLOBALS_STATIC}).ScreenLines.item[l_off_to.to_integer_32]).to_integer_32 = l_c then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						l_pos := -1 + 46 -- goto _L___5
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 42 then -- else:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						if l_c >= 128 then
							l_tmp___7 := l_c
						else
							l_tmp___7 := 0
						end
						if ((create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off_to.to_integer_32]).to_integer_32 /= l_tmp___7 then
							l_pos := -1 + 46 -- goto _L___5
						else
							l_pos := -1 + 45 -- goto _L___6
						end
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 45 then -- else: | _L___6:
						if ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off_to.to_integer_32]).to_integer_32 = l_hl.item then
							l_pos := -1 + 47 -- skip if block
						end
				when 46 then -- if: | _L___5:;
						(create {P_GLOBALS_STATIC}).ScreenLines.item[l_off_to.to_integer_32] := l_c.to_natural_8;
						(create {P_GLOBALS_STATIC}).ScreenAttrs.item[l_off_to.to_integer_32] := (l_hl.item).to_natural_16
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							if l_c >= 128 then
								(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off_to.to_integer_32] := l_c.to_natural_32;
								((create {P_GLOBALS_STATIC}).ScreenLinesC.item[0])[l_off_to.to_integer_32] := (0).to_natural_32
							else
								(create {P_GLOBALS_STATIC}).ScreenLinesUC.item[l_off_to.to_integer_32] := (0).to_natural_32
							end
						end
						(create {P_SCREEN_STATIC}).screen_char (l_off_to, a_row, l_col + a_coloff)
				when 47 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 49
				when 48 then -- else:;
						(create {P_GLOBALS_STATIC}).LineWraps.item[a_row] := (0).to_natural_8
				when 49 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	next_search_hl (a_win: CE_POINTER [PD_WINDOW_S]; a_shl: CE_POINTER [PD_MATCH_T]; a_lnum: INTEGER_32; a_mincol: INTEGER_32)
		require
			not a_shl.is_void
		local
			l_l: INTEGER_32
			l_matchcol: INTEGER_32
			l_nmatched: INTEGER_32
			l_ml: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_shl.item.lnum /= 0 then
						l_l := (a_shl.item.lnum + a_shl.item.rm.endpos[0].lnum) - a_shl.item.rm.startpos[0].lnum
						if a_lnum > l_l then
							a_shl.item.lnum := (0).to_integer_32
						elseif a_lnum < l_l then
							l_return := True
						elseif a_shl.item.rm.endpos[0].col > a_mincol then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 25 -- skip if block
					end
				when 1 then -- if:;
						(create {P_GLOBALS_STATIC}).called_emsg.item := 0
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 24 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if ((create {P_EX_CMDS2_STATIC}).profile_passed_limit (create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (a_shl.c_pointer + (create {PD_MATCH_T}.make).offset_of ("tm")))).to_boolean then
							a_shl.item.lnum := (0).to_integer_32
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 17 -- skip if block
						end
				when 4 then -- if:
						if a_shl.item.lnum /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_matchcol := 0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 7 then -- else:
						if not (((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('c').code)).is_void) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 10 then -- else:
						if a_shl.item.rm.endpos[0].lnum /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 11 then -- if:
						if not (a_shl.item.rm.endpos[0].col <= a_shl.item.rm.startpos[0].col) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if: | _L:
						l_matchcol := a_shl.item.rm.startpos[0].col
						l_ml := ((a_shl.item.buf).item.ml_get_buf (a_lnum, 0)) + l_matchcol
						if (l_ml.item).to_integer_32 = 0 then
							l_matchcol := l_matchcol + 1
							a_shl.item.lnum := (0).to_integer_32
							l_break := True
						end
						if not (l_break) then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_matchcol := l_matchcol + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ml]))
							else
								l_matchcol := l_matchcol + 1
							end
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_matchcol := a_shl.item.rm.endpos[0].col
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_matchcol := a_shl.item.rm.endpos[0].col
				when 17 then -- if done | if done | if done
						if (l_break) then
							l_pos := -1 + 23 -- skip if block
						end
				when 18 then -- if:
						a_shl.item.lnum := a_lnum
						l_nmatched := (create {CE_CLASS_POINTER [PD_REGMMATCH_T]}.make_shared (a_shl.c_pointer + (create {PD_MATCH_T}.make).offset_of ("rm"))).item.vim_regexec_multi (a_win, a_shl.item.buf, a_lnum, l_matchcol, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (a_shl.c_pointer + (create {PD_MATCH_T}.make).offset_of ("tm")))
						if not (((create {P_GLOBALS_STATIC}).called_emsg.item).to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L___0
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 21 then -- else:
						if not (((create {P_GLOBALS_STATIC}).got_int.item).to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 22 then -- if: | _L___0:
						if a_shl.is_equal ((create {P_SCREEN_STATIC}).search_hl.item) then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_shl.item.rm.regprog));
							(create {P_GLOBALS_STATIC}).no_hlsearch.item := 1
						end
						a_shl.item.rm.regprog := create {CE_CLASS_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
						a_shl.item.lnum := (0).to_integer_32;
						(create {P_GLOBALS_STATIC}).got_int.item := 0
						l_break := True
				when 23 then -- if done | if done
						if not (l_break) and then (l_nmatched = 0) then
							a_shl.item.lnum := (0).to_integer_32
							l_break := True
						end
						if not (l_break) then
							if a_shl.item.rm.startpos[0].lnum > 0 then
								a_shl.item.lnum := a_shl.item.lnum + (a_shl.item.rm.startpos[0].lnum)
								l_break := True
							elseif a_shl.item.rm.startpos[0].col >= a_mincol then
								a_shl.item.lnum := a_shl.item.lnum + (a_shl.item.rm.startpos[0].lnum)
								l_break := True
							elseif l_nmatched > 1 then
								a_shl.item.lnum := a_shl.item.lnum + (a_shl.item.rm.startpos[0].lnum)
								l_break := True
							elseif a_shl.item.rm.endpos[0].col > a_mincol then
								a_shl.item.lnum := a_shl.item.lnum + (a_shl.item.rm.startpos[0].lnum)
								l_break := True
							end
						end
						l_pos := -1 + 2 -- back to loop condition
				when 24 then -- loop done
						l_break := False
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	spell_cat_line (a_buf___6, a_line: CE_POINTER [NATURAL_8]; a_maxlen: INTEGER_32)
		require
			not a_line.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_break: BOOLEAN
		do
			l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (a_line)
			from
			until
				(l_break)
			loop
				l_break := False
				if ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("*#/%"%T")), (l_p___0.item).to_integer_32)).is_void then
					l_break := True
				end
				if not (l_break) then
					l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_p___0 + 1)
				end
			end
			l_break := False
			if (l_p___0.item).to_integer_32 /= 0 then
				l_n := (l_p___0.distance (a_line)) + 1
				if l_n < a_maxlen - 1 then
					memset (create {CE_VOID_POINTER}.make_cast (a_buf___6), (' ').code, l_n.to_natural_32).do_nothing;
					(create {P_MISC2_STATIC}).vim_strncpy (a_buf___6 + l_n, l_p___0, ((a_maxlen - 1) - l_n).to_natural_32)
				end
			end
		end

	get_syntax_attr (a_col: INTEGER_32; a_can_spell: CE_POINTER [INTEGER_32]; a_keep_state: INTEGER_32): INTEGER_32
		local
			l_attr: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_attr := 0
			if not a_can_spell.is_void then
				if (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_spell = 0 then
					a_can_spell.item := ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_spell_cluster_id = 0).to_integer
				else
					a_can_spell.item := ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_spell = 1).to_integer
				end
			end
			if ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_array).is_void then
				Result := 0
				l_return := True
			end
			if not l_return and then ((create {P_SYNTAX_STATIC}).syn_buf.item.item.b_p_smc > 0) then
				if a_col >= ((create {P_SYNTAX_STATIC}).syn_buf.item.item.b_p_smc).to_integer_32 then
					(create {P_SYNTAX_STATIC}).clear_current_state
					current_id.item := 0
					current_trans_id.item := 0
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if (create {P_SYNTAX_STATIC}).current_state.item.item.ga_itemsize = 0 then
					validate_current_state
				end
				from
				until
					not ((create {P_SYNTAX_STATIC}).current_col.item <= a_col)
				loop
					if (create {P_SYNTAX_STATIC}).current_col.item = a_col then
						l_tmp := a_keep_state
					else
						l_tmp := 0
					end
					l_attr := syn_current_attr (0, 1, a_can_spell, l_tmp);
					(create {P_SYNTAX_STATIC}).current_col.item := (create {P_SYNTAX_STATIC}).current_col.item + 1
				end
				Result := l_attr
			end
		end

	buf_getsigntype (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_lnum: INTEGER_32; a_type: INTEGER_32): INTEGER_32
		require
			not a_buf___6.is_void
		local
			l_sign: CE_POINTER [PD_SIGNLIST]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sign := a_buf___6.item.b_signlist
				when 1 then -- loop condition:
					if not (not (l_return) and then (not l_sign.is_void)) then
						l_pos := -1 + 14 -- skip loop
					end
				when 2 then -- loop body:
						if l_sign.item.lnum /= a_lnum then
							l_pos := -1 + 13 -- skip if block
						end
				when 3 then -- if:
						if a_type /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (l_sign.item.typenr)
						l_return := True
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if a_type /= 2 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if not ((create {P_EX_CMDS_STATIC}).sign_get_image (l_sign.item.typenr)).is_void then
							Result := (l_sign.item.typenr)
							l_return := True
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else: | _L___0:
						if a_type /= 3 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if not (sign_get_text (l_sign.item.typenr)).is_void then
							Result := (l_sign.item.typenr)
							l_return := True
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if a_type = 1 then
							if (sign_get_attr (l_sign.item.typenr, 1)) /= 0 then
								Result := (l_sign.item.typenr)
								l_return := True
							end
						end
				when 13 then -- if done | if done | if done
						if not l_return then
							l_sign := l_sign.item.next
						end
						l_pos := -1 + 1 -- back to loop condition
				when 14 then -- loop done
					if not l_return then
						Result := 0
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	sign_get_attr (a_typenr, a_line: INTEGER_32): INTEGER_32
		local
			l_sp: CE_POINTER [PD_SIGN]
			l_return, l_break: BOOLEAN
		do
			l_sp := (create {P_EX_CMDS_STATIC}).first_sign.item
			from
			until
				not (not (l_return or l_break) and then (not l_sp.is_void))
			loop
				l_break := False
				if l_sp.item.sn_typenr = a_typenr then
					if a_line.to_boolean then
						if l_sp.item.sn_line_hl > 0 then
							Result := ((create {P_SYNTAX_STATIC}).syn_id2attr (l_sp.item.sn_line_hl))
							l_return := True
						end
					elseif l_sp.item.sn_text_hl > 0 then
						Result := ((create {P_SYNTAX_STATIC}).syn_id2attr (l_sp.item.sn_text_hl))
						l_return := True
					end
					if not l_return then
						l_break := True
					end
				end
				if not (l_return or l_break) then
					l_sp := l_sp.item.sn_next
				end
			end
			if not l_return then
				l_break := False
				Result := 0
			end
		end

	sign_get_text (a_typenr: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_sp: CE_POINTER [PD_SIGN]
			l_return: BOOLEAN
		do
			l_sp := (create {P_EX_CMDS_STATIC}).first_sign.item
			from
			until
				not (not (l_return) and then (not l_sp.is_void))
			loop
				if l_sp.item.sn_typenr = a_typenr then
					Result := (l_sp.item.sn_text)
					l_return := True
				end
				if not l_return then
					l_sp := l_sp.item.sn_next
				end
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
		end

	buf_signcount (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_lnum: INTEGER_32): INTEGER_32
		require
			not a_buf___6.is_void
		local
			l_sign: CE_POINTER [PD_SIGNLIST]
			l_count___2: INTEGER_32
		do
			l_count___2 := 0
			l_sign := a_buf___6.item.b_signlist
			from
			until
				l_sign.is_void
			loop
				if l_sign.item.lnum = a_lnum then
					if not ((create {P_EX_CMDS_STATIC}).sign_get_image (l_sign.item.typenr)).is_void then
						l_count___2 := l_count___2 + 1
					end
				end
				l_sign := l_sign.item.next
			end
			Result := l_count___2
		end

	advance_color_col (a_vcol: INTEGER_32; a_color_cols: CE_POINTER [CE_POINTER [INTEGER_32]]): INTEGER_32
		require
			not a_color_cols.is_void
		local
			l_break: BOOLEAN
		do
			from
			until
				(l_break)
			loop
				l_break := False
				if (a_color_cols.item).item >= 0 then
					if not (a_vcol > (a_color_cols.item).item) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					a_color_cols.item := (a_color_cols.item) + 1
				end
			end
			l_break := False
			Result := ((a_color_cols.item).item >= 0).to_integer
		end

	char_needs_redraw (a_off_from, a_off_to, a_cols: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_cols > 0) then
						l_pos := -1 + 25 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_GLOBALS_STATIC}).ScreenLines.item[a_off_from]).to_integer_32 = ((create {P_GLOBALS_STATIC}).ScreenLines.item[a_off_to]).to_integer_32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						Result := 1
						l_return := True
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 4 then -- else:
						if ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[a_off_from]).to_integer_32 = ((create {P_GLOBALS_STATIC}).ScreenAttrs.item[a_off_to]).to_integer_32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						Result := 1
						l_return := True
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 7 then -- else:
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 8 then -- if:
						if not (((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[((create {P_GLOBALS_STATIC}).ScreenLines.item[a_off_from]).to_integer_32]).to_integer_32 > 1) then
							l_pos := -1 + 15 -- skip if block
						end
				when 9 then -- if:
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 9_932 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if ((create {P_GLOBALS_STATIC}).ScreenLines.item[a_off_from]).to_integer_32 = 142 then
							l_tmp___0 := (((create {P_GLOBALS_STATIC}).ScreenLines2.item[a_off_from]).to_integer_32 /= ((create {P_GLOBALS_STATIC}).ScreenLines2.item[a_off_to]).to_integer_32).to_integer
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if a_cols > 1 then
							if ((create {P_GLOBALS_STATIC}).ScreenLines.item[(a_off_from + 1)]).to_integer_32 /= ((create {P_GLOBALS_STATIC}).ScreenLines.item[(a_off_to + 1)]).to_integer_32 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
						l_tmp___0 := l_tmp
				when 13 then
						if l_tmp___0.to_boolean then
							Result := 1
							l_return := True
						else
							l_pos := -1 + 17 -- goto _L___2
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_pos := -1 + 17 -- goto _L___2
				when 16 then -- if done | if block done, skip else block:
						l_pos := -1 + 25
				when 17 then -- else: | _L___2:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 18 then -- if:
						if (create {P_GLOBALS_STATIC}).ScreenLinesUC.item[a_off_from] = (create {P_GLOBALS_STATIC}).ScreenLinesUC.item[a_off_to] then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						Result := 1
						l_return := True
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else:
						if (create {P_GLOBALS_STATIC}).ScreenLinesUC.item[a_off_from] = {NATURAL_32} 0 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if (comp_char_differs (a_off_from, a_off_to)).to_boolean then
							Result := 1
							l_return := True
						else
							l_pos := -1 + 24 -- goto _L___0
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L___0:
						if a_cols > 1 then
							if ((create {P_GLOBALS_STATIC}).ScreenLines.item[(a_off_from + 1)]).to_integer_32 /= ((create {P_GLOBALS_STATIC}).ScreenLines.item[(a_off_to + 1)]).to_integer_32 then
								Result := 1
								l_return := True
							end
						end
				when 25 then -- if done | if done | if done | if done | if done | if done
					if not l_return then
						Result := 0
					end
				when 26 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	comp_char_differs (a_off_from, a_off_to: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				not (not (l_return or l_break) and then (l_i___0 < (create {P_GLOBALS_STATIC}).Screen_mco.item))
			loop
				l_break := False
				if ((create {P_GLOBALS_STATIC}).ScreenLinesC.item[l_i___0])[a_off_from] /= ((create {P_GLOBALS_STATIC}).ScreenLinesC.item[l_i___0])[a_off_to] then
					Result := 1
					l_return := True
				end
				if not l_return then
					if ((create {P_GLOBALS_STATIC}).ScreenLinesC.item[l_i___0])[a_off_from] = {NATURAL_32} 0 then
						l_break := True
					end
					if not (l_return or l_break) then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 0
			end
		end

	find_prefix (a_mip: CE_POINTER [PD_MATCHINF_S]; a_mode: INTEGER_32)
		require
			not a_mip.is_void
		local
			l_arridx: INTEGER_32
			l_len: INTEGER_32
			l_wlen: INTEGER_32
			l_flen: INTEGER_32
			l_c: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_lo: INTEGER_32
			l_hi___1: INTEGER_32
			l_m: INTEGER_32
			l_slang: CE_POINTER [PD_SLANG_S]
			l_byts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_arridx := 0
			l_wlen := 0
			l_slang := (a_mip.item.mi_lp).item.lp_slang
			l_byts := l_slang.item.sl_pbyts
			if l_byts.is_void then
				l_return := True
			end
			if not l_return then
				l_ptr := a_mip.item.mi_fword
				l_flen := a_mip.item.mi_fwordlen
				if a_mode = 3 then
					l_ptr := l_ptr + (a_mip.item.mi_compoff)
					l_flen := l_flen - (a_mip.item.mi_compoff)
				end
				l_idxs := l_slang.item.sl_pidxs
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if l_flen = 0 then
						if ((a_mip.item.mi_fend).item).to_integer_32 /= 0 then
							l_flen := a_mip.item.fold_more
						end
					end
					l_tmp := l_arridx
					l_arridx := l_arridx + 1
					l_len := (l_byts[l_tmp]).to_integer_32
					if (l_byts[l_arridx]).to_integer_32 = 0 then
						a_mip.item.mi_prefarridx := l_arridx
						a_mip.item.mi_prefcnt := l_len
						from
						until
							(l_break)
						loop
							l_break := False
							if l_len > 0 then
								if (l_byts[l_arridx]).to_integer_32 /= 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_arridx := l_arridx + 1
								l_len := l_len - 1
							end
						end
						l_break := False
						a_mip.item.mi_prefcnt := a_mip.item.mi_prefcnt - l_len
						a_mip.item.mi_prefixlen := l_wlen
						if a_mode = 3 then
							a_mip.item.mi_prefixlen := a_mip.item.mi_prefixlen + (a_mip.item.mi_compoff)
						end
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							a_mip.item.mi_cprefixlen := (create {P_SPELL_STATIC}).nofold_len (a_mip.item.mi_fword, a_mip.item.mi_prefixlen, a_mip.item.mi_word)
						else
							a_mip.item.mi_cprefixlen := a_mip.item.mi_prefixlen
						end
						a_mip.item.find_word (2)
						if l_len = 0 then
							l_break := True
						end
					end
					if not (l_return or l_break) and then ((l_ptr[l_wlen]).to_integer_32 = 0) then
						l_break := True
					end
					if not (l_return or l_break) then
						l_c := (l_ptr[l_wlen]).to_integer_32
						l_lo := l_arridx
						l_hi___1 := (l_arridx + l_len) - 1
						from
						until
							not (not (l_break) and then (l_lo < l_hi___1))
						loop
							l_break := False
							l_m := (l_lo + l_hi___1) // 2
							if (l_byts[l_m]).to_integer_32 > l_c then
								l_hi___1 := l_m - 1
							elseif (l_byts[l_m]).to_integer_32 < l_c then
								l_lo := l_m + 1
							else
								l_hi___1 := l_m
								l_lo := l_hi___1
								l_break := True
							end
						end
						l_break := False
						if l_hi___1 < l_lo then
							l_break := True
						elseif (l_byts[l_lo]).to_integer_32 /= l_c then
							l_break := True
						end
					end
					if not (l_return or l_break) then
						l_arridx := l_idxs[l_lo]
						l_wlen := l_wlen + 1
						l_flen := l_flen - 1
					end
				end
				l_break := False
			end
		end

	spell_to_word_end (a_start___1: CE_POINTER [NATURAL_8]; a_win: CE_POINTER [PD_WINDOW_S]): CE_POINTER [NATURAL_8]
		require
			not a_start___1.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_p___0 := a_start___1
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_p___0.item).to_integer_32 /= 0 then
					if not (a_win.item.spell_iswordp (l_p___0)).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
					else
						l_tmp___0 := 1
					end
					l_p___0 := l_p___0 + l_tmp___0
				end
			end
			l_break := False
			Result := l_p___0
		end

	syn_sync (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_start_lnum: INTEGER_32; a_last_valid: CE_POINTER [PD_SYN_STATE])
		local
			l_start_lnum: INTEGER_32
			l_curbuf_save: CE_POINTER [PD_FILE_BUFFER]
			l_curwin_save: CE_POINTER [PD_WINDOW_S]
			l_cursor_save: PD_POS_T
			l_idx: INTEGER_32
			l_lnum: INTEGER_32
			l_end_lnum: INTEGER_32
			l_break_lnum: INTEGER_32
			l_had_sync_point: INTEGER_32
			l_cur_si: CE_POINTER [PD_STATE_ITEM]
			l_spp: CE_POINTER [PD_SYN_PATTERN]
			l_line: CE_POINTER [NATURAL_8]
			l_found_flags: INTEGER_32
			l_found_match_idx: INTEGER_32
			l_found_current_lnum: INTEGER_32
			l_found_current_col: INTEGER_32
			l_found_m_endpos: PD_LPOS_T
			l_prev_current_col: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			create l_found_m_endpos.make

			l_start_lnum := a_start_lnum
			l_found_flags := 0
			l_found_match_idx := 0
			l_found_current_lnum := (0).to_integer_32
			l_found_current_col := 0;
			(create {P_SYNTAX_STATIC}).invalidate_current_state
			if (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_minlines > l_start_lnum then
				l_start_lnum := (1).to_integer_32
			else
				if (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_minlines = 1 then
					l_lnum := (1).to_integer_32
				elseif (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_minlines < 10 then
					l_lnum := (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_minlines * 2
				else
					l_lnum := ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_minlines * 3) // 2
				end
				if (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_maxlines /= 0 then
					if l_lnum > (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_maxlines then
						l_lnum := (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_maxlines
					end
				end
				if l_lnum >= l_start_lnum then
					l_start_lnum := (1).to_integer_32
				else
					l_start_lnum := l_start_lnum - l_lnum
				end
			end
			(create {P_SYNTAX_STATIC}).current_lnum.item := l_start_lnum
			if (((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_flags).bit_and (1)).to_boolean then
				l_curwin_save := (create {P_GLOBALS_STATIC}).curwin.item;
				(create {P_GLOBALS_STATIC}).curwin.item := a_wp___0
				l_curbuf_save := (create {P_GLOBALS_STATIC}).curbuf.item;
				(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_SYNTAX_STATIC}).syn_buf.item
				from
				until
					not (not (l_break) and then (l_start_lnum > 1))
				loop
					l_break := False
					l_line := (create {P_MEMLINE_STATIC}).ml_get (l_start_lnum - 1)
					if (l_line.item).to_integer_32 = 0 then
						l_break := True
					elseif ((l_line + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))).to_integer_32)[-1]).to_integer_32 /= 92 then
						l_break := True
					end
					if not (l_break) then
						l_start_lnum := l_start_lnum - 1
					end
				end
				l_break := False;
				(create {P_SYNTAX_STATIC}).current_lnum.item := l_start_lnum
				l_cursor_save := (a_wp___0.item.w_cursor).twin
				a_wp___0.item.w_cursor.lnum := l_start_lnum
				a_wp___0.item.w_cursor.col := 0
				if not ((create {P_MISC1_STATIC}).find_start_comment (((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_maxlines).to_integer_32)).is_void then
					l_idx := (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_patterns.ga_len
					from
					until
						(l_break)
					loop
						l_break := False
						l_idx := l_idx - 1
						if not (l_idx >= 0) then
							l_break := True
						end
						if not (l_break) and then (((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_patterns.ga_data) + l_idx).item.sp_syn.id).to_integer_32 = ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_id).to_integer_32) then
							if ((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_patterns.ga_data) + l_idx).item.sp_type).to_integer_32 = 2 then
								validate_current_state
								if (push_current_state (l_idx)) = 1 then
									(create {P_SYNTAX_STATIC}).update_si_attr ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len - 1)
								end
								l_break := True
							end
						end
					end
					l_break := False
				end
				a_wp___0.item.w_cursor := l_cursor_save.twin;
				(create {P_GLOBALS_STATIC}).curwin.item := l_curwin_save;
				(create {P_GLOBALS_STATIC}).curbuf.item := l_curbuf_save
			elseif (((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_flags).bit_and (2)).to_boolean then
				if (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_maxlines /= 0 then
					if l_start_lnum > (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_maxlines then
						l_break_lnum := l_start_lnum - (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_sync_maxlines
					else
						l_break_lnum := (0).to_integer_32
					end
				else
					l_break_lnum := (0).to_integer_32
				end
				l_found_m_endpos.lnum := (0).to_integer_32
				l_found_m_endpos.col := 0
				l_end_lnum := l_start_lnum
				l_lnum := l_start_lnum
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_continue := False
					l_lnum := l_lnum - 1
					if not (l_lnum > l_break_lnum) then
						l_break := True
					end
					if not (l_return or l_break or l_continue) then
						(create {P_MISC1_STATIC}).line_breakcheck
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							(create {P_SYNTAX_STATIC}).invalidate_current_state;
							(create {P_SYNTAX_STATIC}).current_lnum.item := l_start_lnum
							l_break := True
						end
					end
					if not (l_return or l_break or l_continue) and then (not a_last_valid.is_void) then
						if l_lnum = a_last_valid.item.sst_lnum then
							load_current_state (a_last_valid)
							l_break := True
						end
					end
					if not (l_return or l_break or l_continue) and then (l_lnum > 1) then
						if (syn_match_linecont (l_lnum - 1)).to_boolean then
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) then
						validate_current_state;
						(create {P_SYNTAX_STATIC}).current_lnum.item := l_lnum
						from
						until
							not (not (l_return) and then ((create {P_SYNTAX_STATIC}).current_lnum.item < l_end_lnum))
						loop
							syn_start_line
							from
							until
								(l_break)
							loop
								l_break := False
								l_had_sync_point := syn_finish_line (1)
								if l_had_sync_point.to_boolean then
									if ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len).to_boolean then
										l_cur_si := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len - 1)
										if l_cur_si.item.si_m_endpos.lnum > l_start_lnum then
											(create {P_SYNTAX_STATIC}).current_lnum.item := l_end_lnum
											l_break := True
										end
										if not (l_break) then
											if l_cur_si.item.si_idx < 0 then
												l_found_flags := 0
												l_found_match_idx := -1
											else
												l_spp := create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_patterns.ga_data) + l_cur_si.item.si_idx
												l_found_flags := l_spp.item.sp_flags
												l_found_match_idx := l_spp.item.sp_sync_idx
											end
											l_found_current_lnum := (create {P_SYNTAX_STATIC}).current_lnum.item
											l_found_current_col := (create {P_SYNTAX_STATIC}).current_col.item
											l_found_m_endpos := (l_cur_si.item.si_m_endpos).twin
											if l_found_m_endpos.lnum > (create {P_SYNTAX_STATIC}).current_lnum.item then
												(create {P_SYNTAX_STATIC}).current_lnum.item := l_found_m_endpos.lnum;
												(create {P_SYNTAX_STATIC}).current_col.item := l_found_m_endpos.col
												if (create {P_SYNTAX_STATIC}).current_lnum.item >= l_end_lnum then
													l_break := True
												end
											elseif l_found_m_endpos.col > (create {P_SYNTAX_STATIC}).current_col.item then
												(create {P_SYNTAX_STATIC}).current_col.item := l_found_m_endpos.col
											else
												(create {P_SYNTAX_STATIC}).current_col.item := (create {P_SYNTAX_STATIC}).current_col.item + 1
											end
										end
										if not (l_break) then
											l_prev_current_col := (create {P_SYNTAX_STATIC}).current_col.item
											if (((create {P_SYNTAX_STATIC}).syn_getcurline)[(create {P_SYNTAX_STATIC}).current_col.item]).to_integer_32 /= 0 then
												(create {P_SYNTAX_STATIC}).current_col.item := (create {P_SYNTAX_STATIC}).current_col.item + 1
											end
											(create {P_SYNTAX_STATIC}).check_state_ends;
											(create {P_SYNTAX_STATIC}).current_col.item := l_prev_current_col
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
							end
							l_break := False;
							(create {P_SYNTAX_STATIC}).current_lnum.item := (create {P_SYNTAX_STATIC}).current_lnum.item + 1
						end
						if l_found_flags.to_boolean then
							(create {P_SYNTAX_STATIC}).clear_current_state
							if l_found_match_idx >= 0 then
								if (push_current_state (l_found_match_idx)) = 1 then
									(create {P_SYNTAX_STATIC}).update_si_attr ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len - 1)
								end
							end
							if ((l_found_flags).bit_and (16)).to_boolean then
								if ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len).to_boolean then
									l_cur_si := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len - 1)
									l_cur_si.item.si_h_startpos.lnum := l_found_current_lnum
									l_cur_si.item.si_h_startpos.col := l_found_current_col
									l_cur_si.item.update_si_end ((create {P_SYNTAX_STATIC}).current_col.item, 1);
									(create {P_SYNTAX_STATIC}).check_keepend
								end
								(create {P_SYNTAX_STATIC}).current_col.item := l_found_m_endpos.col;
								(create {P_SYNTAX_STATIC}).current_lnum.item := l_found_m_endpos.lnum
								syn_finish_line (0).do_nothing;
								(create {P_SYNTAX_STATIC}).current_lnum.item := (create {P_SYNTAX_STATIC}).current_lnum.item + 1
							else
								(create {P_SYNTAX_STATIC}).current_lnum.item := l_start_lnum
							end
							l_break := True
						end
					end
					if not (l_return or l_break or l_continue) then
						l_end_lnum := l_lnum;
						(create {P_SYNTAX_STATIC}).invalidate_current_state
					end
				end
				l_break := False
				l_continue := False
				if l_lnum <= l_break_lnum then
					(create {P_SYNTAX_STATIC}).invalidate_current_state;
					(create {P_SYNTAX_STATIC}).current_lnum.item := l_break_lnum + 1
				end
			end
			validate_current_state
		end

	syn_start_line
		do
			current_finished.item := 0;
			(create {P_SYNTAX_STATIC}).current_col.item := 0
			if (create {P_SYNTAX_STATIC}).current_state.item.item.ga_len > 0 then
				(create {P_SYNTAX_STATIC}).syn_update_ends (1)
			end
			(create {P_SYNTAX_STATIC}).next_match_idx.item := -1
			current_line_id.item := current_line_id.item + 1
		end

	load_current_state (a_from: CE_POINTER [PD_SYN_STATE])
		require
			not a_from.is_void
		local
			l_i___0: INTEGER_32
			l_bp___0: CE_POINTER [PD_BUF_STATE]
		do
			(create {P_SYNTAX_STATIC}).clear_current_state
			validate_current_state;
			(create {P_SYNTAX_STATIC}).keepend_level.item := -1
			if (a_from.item.sst_stacksize).to_boolean then
				if (((create {P_SYNTAX_STATIC}).current_state.item).item.ga_grow (a_from.item.sst_stacksize)) /= 0 then
					if a_from.item.sst_stacksize > 7 then
						l_bp___0 := create {CE_CLASS_POINTER [PD_BUF_STATE]}.make_cast (a_from.item.sst_union.sst_ga.ga_data)
					else
						l_bp___0 := a_from.item.sst_union.sst_stack
					end
					l_i___0 := 0
					from
					until
						not (l_i___0 < a_from.item.sst_stacksize)
					loop
						(create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_idx := (l_bp___0 + l_i___0).item.bs_idx;
						(create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_flags := ((l_bp___0 + l_i___0).item.bs_flags).to_integer_32;
						(create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_extmatch := (create {P_REGEXP_STATIC}).ref_extmatch ((l_bp___0 + l_i___0).item.bs_extmatch)
						if (create {P_SYNTAX_STATIC}).keepend_level.item < 0 then
							if (((create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_flags).bit_and (1_024)).to_boolean then
								(create {P_SYNTAX_STATIC}).keepend_level.item := l_i___0
							end
						end
						(create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_ends := 0;
						(create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_m_lnum := 0
						if (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_idx >= 0 then
							(create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_next_list := (create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_patterns.ga_data) + (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_idx).item.sp_next_list
						else
							(create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_next_list := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
						end
						(create {P_SYNTAX_STATIC}).update_si_attr (l_i___0)
						l_i___0 := l_i___0 + 1
					end
					(create {P_SYNTAX_STATIC}).current_state.item.item.ga_len := a_from.item.sst_stacksize
				end
			end
			(create {P_SYNTAX_STATIC}).current_next_list.item := a_from.item.sst_next_list;
			(create {P_SYNTAX_STATIC}).current_next_flags.item := a_from.item.sst_next_flags;
			(create {P_SYNTAX_STATIC}).current_lnum.item := a_from.item.sst_lnum
		end

	validate_current_state
		do
			(create {P_SYNTAX_STATIC}).current_state.item.item.ga_itemsize := ((create {PD_STATE_ITEM}.make).structure_size.to_natural_32).to_integer_32;
			(create {P_SYNTAX_STATIC}).current_state.item.item.ga_growsize := 3
		end

	syn_match_linecont (a_lnum: INTEGER_32): INTEGER_32
		local
			l_regmatch___0: CE_ARRAY [PD_REGMMATCH_T]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_REGMMATCH_T]} l_regmatch___0.make (<<1>>)

			if not ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_linecont_prog).is_void then
				l_regmatch___0.item.rmm_ic := (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_linecont_ic
				l_regmatch___0.item.regprog := (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_linecont_prog
				Result := (l_regmatch___0.item.syn_regexec (a_lnum, 0))
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	syn_stack_alloc
		local
			l_len: INTEGER_32
			l_to: CE_POINTER [PD_SYN_STATE]
			l_from: CE_POINTER [PD_SYN_STATE]
			l_sstp: CE_POINTER [PD_SYN_STATE]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := (create {P_SYNTAX_STATIC}).syn_buf.item.item.b_ml.ml_line_count // 16 + (create {P_GLOBALS_STATIC}).Rows.item.item * 2
					if l_len < 150 then
						l_len := 150
					elseif l_len > 1_000 then
						l_len := 1_000
					end
					if not (((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_len).to_integer_32 > l_len * 2) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_len).to_integer_32 < l_len) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_len := (create {P_SYNTAX_STATIC}).syn_buf.item.item.b_ml.ml_line_count
						l_len := (l_len + l_len // 2) // 16 + (create {P_GLOBALS_STATIC}).Rows.item.item * 2
						if l_len < 150 then
							l_len := 150
						elseif l_len > 1_000 then
							l_len := 1_000
						end
						if not ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_array).is_void then
							from
							until
								(l_break)
							loop
								l_break := False
								if (((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_len - (create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_freecount) + 2).to_integer_32 > l_len then
									if not (syn_stack_cleanup).to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
							end
							l_break := False
							if l_len < (((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_len - (create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_freecount) + 2).to_integer_32 then
								l_len := (((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_len - (create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_freecount) + 2).to_integer_32
							end
						end
						l_sstp := create {CE_CLASS_POINTER [PD_SYN_STATE]}.make_cast (((create {P_MISC2_STATIC}).alloc_clear ((l_len.to_natural_32 * ((create {PD_SYN_STATE}.make).structure_size.to_natural_32).to_natural_32).to_natural_32)))
						if l_sstp.is_void then
							l_return := True
						end
						if not l_return then
							l_to := l_sstp - 1
							if not ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_array).is_void then
								l_from := (create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_first
								from
								until
									l_from.is_void
								loop
									l_to := l_to + 1
									l_to.item := (l_from.item).twin
									l_to.item.sst_next := l_to + 1
									l_from := l_from.item.sst_next
								end
							end
							if not l_to.is_equal (l_sstp - 1) then
								l_to.item.sst_next := create {CE_CLASS_POINTER [PD_SYN_STATE]}.make_shared (default_pointer);
								(create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_first := l_sstp;
								(create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_freecount := ((l_len - (l_to.distance (l_sstp)).to_integer_32) - 1).to_integer_32
							else
								(create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_first := create {CE_CLASS_POINTER [PD_SYN_STATE]}.make_shared (default_pointer);
								(create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_freecount := l_len.to_integer_32
							end
							(create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_firstfree := l_to + 1
							from
							until
								(l_break)
							loop
								l_break := False
								l_to := l_to + 1
								if not ((l_to.c_pointer.to_integer_32).to_natural_32 < ((l_sstp + l_len).c_pointer.to_integer_32).to_natural_32) then
									l_break := True
								end
								if not (l_break) then
									l_to.item.sst_next := l_to + 1
								end
							end
							l_break := False;
							((l_sstp + l_len) - 1).item.sst_next := create {CE_CLASS_POINTER [PD_SYN_STATE]}.make_shared (default_pointer);
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_array));
							(create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_array := l_sstp;
							(create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_len := l_len.to_integer_32
						end
				when 5 then -- if done
					if not l_return then
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	syntax_end_parsing (a_lnum: INTEGER_32)
		local
			l_sp: CE_POINTER [PD_SYN_STATE]
		do
			l_sp := syn_stack_find_entry (a_lnum)
			if not l_sp.is_void then
				if l_sp.item.sst_lnum < a_lnum then
					l_sp := l_sp.item.sst_next
				end
			end
			if not l_sp.is_void then
				if l_sp.item.sst_change_lnum /= 0 then
					l_sp.item.sst_change_lnum := a_lnum
				end
			end
		end

	syntax_check_changed (a_lnum: INTEGER_32): INTEGER_32
		local
			l_retval: INTEGER_32
			l_sp: CE_POINTER [PD_SYN_STATE]
		do
			l_retval := 1
			if (create {P_SYNTAX_STATIC}).current_state.item.item.ga_itemsize /= 0 then
				if a_lnum = (create {P_SYNTAX_STATIC}).current_lnum.item + 1 then
					l_sp := syn_stack_find_entry (a_lnum)
					if not l_sp.is_void then
						if l_sp.item.sst_lnum = a_lnum then
							syn_finish_line (0).do_nothing
							if (syn_stack_equal (l_sp)).to_boolean then
								l_retval := 0
							end
							(create {P_SYNTAX_STATIC}).current_lnum.item := (create {P_SYNTAX_STATIC}).current_lnum.item + 1
							store_current_state.do_nothing
						end
					end
				end
			end
			Result := l_retval
		end

	syn_finish_line (a_syncing: INTEGER_32): INTEGER_32
		local
			l_cur_si: CE_POINTER [PD_STATE_ITEM]
			l_prev_current_col: INTEGER_32
			l_return: BOOLEAN
		do
			if not current_finished.item.to_boolean then
				from
				until
					not (not (l_return) and then (not current_finished.item.to_boolean))
				loop
					syn_current_attr (a_syncing, 0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0).do_nothing
					if a_syncing.to_boolean then
						if ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len).to_boolean then
							l_cur_si := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len - 1)
							if l_cur_si.item.si_idx >= 0 then
								if (((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_patterns.ga_data) + l_cur_si.item.si_idx).item.sp_flags).bit_and (48)).to_boolean then
									Result := 1
									l_return := True
								end
							end
							if not l_return then
								l_prev_current_col := (create {P_SYNTAX_STATIC}).current_col.item
								if (((create {P_SYNTAX_STATIC}).syn_getcurline)[(create {P_SYNTAX_STATIC}).current_col.item]).to_integer_32 /= 0 then
									(create {P_SYNTAX_STATIC}).current_col.item := (create {P_SYNTAX_STATIC}).current_col.item + 1
								end
								(create {P_SYNTAX_STATIC}).check_state_ends;
								(create {P_SYNTAX_STATIC}).current_col.item := l_prev_current_col
							end
						end
					end
					if not l_return then
						(create {P_SYNTAX_STATIC}).current_col.item := (create {P_SYNTAX_STATIC}).current_col.item + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	store_current_state: CE_POINTER [PD_SYN_STATE]
		local
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [PD_SYN_STATE]
			l_bp___0: CE_POINTER [PD_BUF_STATE]
			l_cur_si: CE_POINTER [PD_STATE_ITEM]
			l_sp: CE_POINTER [PD_SYN_STATE]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sp := (syn_stack_find_entry ((create {P_SYNTAX_STATIC}).current_lnum.item))
					l_i___0 := (create {P_SYNTAX_STATIC}).current_state.item.item.ga_len - 1
					from
					until
						not (not (l_break) and then (l_i___0 >= 0))
					loop
						l_break := False
						l_cur_si := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0
						if l_cur_si.item.si_h_startpos.lnum >= (create {P_SYNTAX_STATIC}).current_lnum.item then
							l_break := True
						elseif l_cur_si.item.si_m_endpos.lnum >= (create {P_SYNTAX_STATIC}).current_lnum.item then
							l_break := True
						elseif l_cur_si.item.si_h_endpos.lnum >= (create {P_SYNTAX_STATIC}).current_lnum.item then
							l_break := True
						elseif (l_cur_si.item.si_end_idx).to_boolean then
							if l_cur_si.item.si_eoe_pos.lnum >= (create {P_SYNTAX_STATIC}).current_lnum.item then
								l_break := True
							end
						end
						if not (l_break) then
							l_i___0 := l_i___0 - 1
						end
					end
					l_break := False
					if not (l_i___0 >= 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not l_sp.is_void then
							if ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_first).is_equal (l_sp) then
								(create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_first := l_sp.item.sst_next
							else
								l_p___0 := (create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_first
								from
								until
									not (not (l_break) and then (not l_p___0.is_void))
								loop
									l_break := False
									if (l_p___0.item.sst_next).is_equal (l_sp) then
										l_break := True
									end
									if not (l_break) then
										l_p___0 := l_p___0.item.sst_next
									end
								end
								l_break := False
								if not l_p___0.is_void then
									l_p___0.item.sst_next := l_sp.item.sst_next
								end
							end
							((create {P_SYNTAX_STATIC}).syn_block.item).item.syn_stack_free_entry (l_sp)
							l_sp := create {CE_CLASS_POINTER [PD_SYN_STATE]}.make_shared (default_pointer)
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if not (l_sp.is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if l_sp.item.sst_lnum = (create {P_SYNTAX_STATIC}).current_lnum.item then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if (create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_freecount = 0 then
							syn_stack_cleanup.do_nothing
							l_sp := syn_stack_find_entry ((create {P_SYNTAX_STATIC}).current_lnum.item)
						end
						if (create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_freecount = 0 then
							l_sp := create {CE_CLASS_POINTER [PD_SYN_STATE]}.make_shared (default_pointer)
						else
							l_p___0 := (create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_firstfree;
							(create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_firstfree := l_p___0.item.sst_next;
							(create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_freecount := ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_freecount) - 1
							if l_sp.is_void then
								l_p___0.item.sst_next := (create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_first;
								(create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_first := l_p___0
							else
								l_p___0.item.sst_next := l_sp.item.sst_next
								l_sp.item.sst_next := l_p___0
							end
							l_sp := l_p___0
							l_sp.item.sst_stacksize := 0
							l_sp.item.sst_lnum := (create {P_SYNTAX_STATIC}).current_lnum.item
						end
				when 8 then -- if done | if done
					if not l_sp.is_void then
						l_sp.item.clear_syn_state
						l_sp.item.sst_stacksize := (create {P_SYNTAX_STATIC}).current_state.item.item.ga_len
						if (create {P_SYNTAX_STATIC}).current_state.item.item.ga_len > 7 then
							(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_sp.c_pointer + (create {PD_SYN_STATE}.make).offset_of ("sst_union") + (create {PD_SST_UNION}.make).offset_of ("sst_ga"))).item.ga_init2 (((create {PD_BUF_STATE}.make).structure_size.to_natural_32).to_integer_32, 1)
							if ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_sp.c_pointer + (create {PD_SYN_STATE}.make).offset_of ("sst_union") + (create {PD_SST_UNION}.make).offset_of ("sst_ga"))).item.ga_grow ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len)) = 0 then
								l_sp.item.sst_stacksize := 0
							else
								l_sp.item.sst_union.sst_ga.ga_len := (create {P_SYNTAX_STATIC}).current_state.item.item.ga_len
							end
							l_bp___0 := create {CE_CLASS_POINTER [PD_BUF_STATE]}.make_cast (l_sp.item.sst_union.sst_ga.ga_data)
						else
							l_bp___0 := l_sp.item.sst_union.sst_stack
						end
						l_i___0 := 0
						from
						until
							not (l_i___0 < l_sp.item.sst_stacksize)
						loop
							(l_bp___0 + l_i___0).item.bs_idx := (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_idx;
							(l_bp___0 + l_i___0).item.bs_flags := ((create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_flags).to_integer_32;
							(l_bp___0 + l_i___0).item.bs_extmatch := (create {P_REGEXP_STATIC}).ref_extmatch ((create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_extmatch)
							l_i___0 := l_i___0 + 1
						end
						l_sp.item.sst_next_flags := (create {P_SYNTAX_STATIC}).current_next_flags.item
						l_sp.item.sst_next_list := (create {P_SYNTAX_STATIC}).current_next_list.item
						l_sp.item.sst_tick := (create {P_GLOBALS_STATIC}).display_tick.item
						l_sp.item.sst_change_lnum := (0).to_integer_32
					end
					current_state_stored.item := 1
					Result := l_sp
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	syn_stack_find_entry (a_lnum: INTEGER_32): CE_POINTER [PD_SYN_STATE]
		local
			l_p___0: CE_POINTER [PD_SYN_STATE]
			l_prev: CE_POINTER [PD_SYN_STATE]
			l_return, l_break: BOOLEAN
		do
			l_prev := create {CE_CLASS_POINTER [PD_SYN_STATE]}.make_shared (default_pointer)
			l_p___0 := (create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_first
			from
			until
				not (not (l_return or l_break) and then (not l_p___0.is_void))
			loop
				l_break := False
				if l_p___0.item.sst_lnum = a_lnum then
					Result := l_p___0
					l_return := True
				end
				if not l_return then
					if l_p___0.item.sst_lnum > a_lnum then
						l_break := True
					end
					if not (l_return or l_break) then
						l_prev := l_p___0
						l_p___0 := l_p___0.item.sst_next
					end
				end
			end
			if not l_return then
				l_break := False
				Result := l_prev
			end
		end

	syn_stack_cleanup: INTEGER_32
		local
			l_p___0: CE_POINTER [PD_SYN_STATE]
			l_prev: CE_POINTER [PD_SYN_STATE]
			l_tick: NATURAL_16
			l_above: INTEGER_32
			l_dist: INTEGER_32
			l_retval: INTEGER_32
			l_return: BOOLEAN
		do
			l_retval := 0
			if ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_array).is_void then
				Result := l_retval
				l_return := True
			elseif ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_first).is_void then
				Result := l_retval
				l_return := True
			end
			if not l_return then
				if ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_len).to_integer_32 <= (create {P_GLOBALS_STATIC}).Rows.item.item then
					l_dist := 999_999
				else
					l_dist := ((create {P_SYNTAX_STATIC}).syn_buf.item.item.b_ml.ml_line_count // (((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_len).to_integer_32 - (create {P_GLOBALS_STATIC}).Rows.item.item) + 1).to_integer_32
				end
				l_tick := (create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_lasttick
				l_above := 0
				l_prev := (create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_first
				l_p___0 := l_prev.item.sst_next
				from
				until
					l_p___0.is_void
				loop
					if l_prev.item.sst_lnum + l_dist.to_integer_32 > l_p___0.item.sst_lnum then
						if (l_p___0.item.sst_tick).to_integer_32 > ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_lasttick).to_integer_32 then
							if not l_above.to_boolean then
								l_tick := l_p___0.item.sst_tick
							elseif (l_p___0.item.sst_tick).to_integer_32 < l_tick.to_integer_32 then
								l_tick := l_p___0.item.sst_tick
							end
							l_above := 1
						elseif not l_above.to_boolean then
							if (l_p___0.item.sst_tick).to_integer_32 < l_tick.to_integer_32 then
								l_tick := l_p___0.item.sst_tick
							end
						end
					end
					l_prev := l_p___0
					l_p___0 := l_p___0.item.sst_next
				end
				l_prev := (create {P_SYNTAX_STATIC}).syn_block.item.item.b_sst_first
				l_p___0 := l_prev.item.sst_next
				from
				until
					l_p___0.is_void
				loop
					if (l_p___0.item.sst_tick).to_integer_32 = l_tick.to_integer_32 then
						if l_prev.item.sst_lnum + l_dist.to_integer_32 > l_p___0.item.sst_lnum then
							l_prev.item.sst_next := l_p___0.item.sst_next;
							((create {P_SYNTAX_STATIC}).syn_block.item).item.syn_stack_free_entry (l_p___0)
							l_p___0 := l_prev
							l_retval := 1
						end
					end
					l_prev := l_p___0
					l_p___0 := l_p___0.item.sst_next
				end
				Result := l_retval
			end
		end

	syn_stack_equal (a_sp: CE_POINTER [PD_SYN_STATE]): INTEGER_32
		require
			not a_sp.is_void
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_bp___0: CE_POINTER [PD_BUF_STATE]
			l_six: CE_POINTER [PD_REG_EXTMATCH_T]
			l_bsx: CE_POINTER [PD_REG_EXTMATCH_T]
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if a_sp.item.sst_stacksize = (create {P_SYNTAX_STATIC}).current_state.item.item.ga_len then
				if (a_sp.item.sst_next_list).is_equal ((create {P_SYNTAX_STATIC}).current_next_list.item) then
					if a_sp.item.sst_stacksize > 7 then
						l_bp___0 := create {CE_CLASS_POINTER [PD_BUF_STATE]}.make_cast (a_sp.item.sst_union.sst_ga.ga_data)
					else
						l_bp___0 := a_sp.item.sst_union.sst_stack
					end
					l_i___0 := (create {P_SYNTAX_STATIC}).current_state.item.item.ga_len
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_i___0 := l_i___0 - 1
						if not (l_i___0 >= 0) then
							l_break := True
						end
						if not (l_return or l_break) and then ((l_bp___0 + l_i___0).item.bs_idx /= (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_idx) then
							l_break := True
						end
						if not (l_return or l_break) and then (not ((l_bp___0 + l_i___0).item.bs_extmatch).is_equal ((create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_extmatch)) then
							l_bsx := (l_bp___0 + l_i___0).item.bs_extmatch
							l_six := (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_extmatch
							if l_bsx.is_void then
								l_break := True
							elseif l_six.is_void then
								l_break := True
							end
							if not (l_return or l_break) then
								l_j := 0
								from
								until
									not (not (l_break) and then (l_j < 10))
								loop
									l_break := False
									if not (l_bsx.item.matches[l_j]).is_equal (l_six.item.matches[l_j]) then
										if (l_bsx.item.matches[l_j]).is_void then
											l_break := True
										elseif (l_six.item.matches[l_j]).is_void then
											l_break := True
										end
										if not (l_break) then
											if ((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_patterns.ga_data) + (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_idx).item.sp_ic).to_boolean then
												l_tmp___1 := (((create {P_MBYTE_STATIC}).mb_strnicmp (l_bsx.item.matches[l_j], l_six.item.matches[l_j], (2_147_483_647).to_natural_32)) /= 0).to_integer
											else
												l_tmp___1 := ((strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_bsx.item.matches[l_j]), create {CE_INTEGER_8_POINTER}.make_cast (l_six.item.matches[l_j]))) /= 0).to_integer
											end
											if l_tmp___1.to_boolean then
												l_break := True
											end
										end
									end
									if not (l_break) then
										l_j := l_j + 1
									end
								end
								l_break := False
								if l_j /= 10 then
									l_break := True
								end
							end
						end
					end
					l_break := False
					if l_i___0 < 0 then
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	syn_current_attr (a_syncing, a_displaying: INTEGER_32; a_can_spell: CE_POINTER [INTEGER_32]; a_keep_state: INTEGER_32): INTEGER_32
		local
			l_syn_id: INTEGER_32
			l_endpos: CE_ARRAY [PD_LPOS_T]
			l_hl_startpos: CE_ARRAY [PD_LPOS_T]
			l_hl_endpos: CE_ARRAY [PD_LPOS_T]
			l_eos_pos: CE_ARRAY [PD_LPOS_T]
			l_eoe_pos: CE_ARRAY [PD_LPOS_T]
			l_end_idx: CE_ARRAY [INTEGER_32]
			l_idx: INTEGER_32
			l_spp: CE_POINTER [PD_SYN_PATTERN]
			l_cur_si: CE_POINTER [PD_STATE_ITEM]
			l_sip: CE_POINTER [PD_STATE_ITEM]
			l_startcol: INTEGER_32
			l_endcol: CE_ARRAY [INTEGER_32]
			l_flags___0: CE_ARRAY [INTEGER_32]
			l_cchar: CE_ARRAY [INTEGER_32]
			l_next_list: CE_ARRAY [CE_POINTER [INTEGER_16]]
			l_found_match: INTEGER_32
			l_do_keywords: INTEGER_32
			l_regmatch___0: CE_ARRAY [PD_REGMMATCH_T]
			l_pos___3: CE_ARRAY [PD_LPOS_T]
			l_lc_col: INTEGER_32
			l_cur_extmatch: CE_POINTER [PD_REG_EXTMATCH_T]
			l_line: CE_POINTER [NATURAL_8]
			l_keep_next_list: INTEGER_32
			l_zero_width_next_list: INTEGER_32
			l_zero_width_next_ga: CE_ARRAY [PD_GROWARRAY]
			l_tmp: INTEGER_32
			l_tmp___3: INTEGER_32
			l_startpos: CE_ARRAY [PD_LPOS_T]
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_lspp: CE_POINTER [PD_SYN_PATTERN]
			l_tmp___11: INTEGER_32
			l_sps: CE_ARRAY [PD_SP_SYN]
			l_tmp___14: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_LPOS_T]} l_endpos.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_LPOS_T]} l_hl_startpos.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_LPOS_T]} l_hl_endpos.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_LPOS_T]} l_eos_pos.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_LPOS_T]} l_eoe_pos.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_end_idx.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_endcol.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_flags___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_cchar.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_16]} l_next_list.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_REGMMATCH_T]} l_regmatch___0.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_LPOS_T]} l_pos___3.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_zero_width_next_ga.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_LPOS_T]} l_startpos.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_SP_SYN]} l_sps.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sip := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_shared (default_pointer)
					l_cur_extmatch := create {CE_CLASS_POINTER [PD_REG_EXTMATCH_T]}.make_shared (default_pointer)
					l_zero_width_next_list := 0
					l_line := (create {P_SYNTAX_STATIC}).syn_getcurline
					if (l_line[(create {P_SYNTAX_STATIC}).current_col.item]).to_integer_32 = 0 then
						if (create {P_SYNTAX_STATIC}).current_col.item /= 0 then
							if (create {P_SYNTAX_STATIC}).next_match_idx.item >= 0 then
								if (create {P_SYNTAX_STATIC}).next_match_col.item >= (create {P_SYNTAX_STATIC}).current_col.item then
									if ((create {P_SYNTAX_STATIC}).next_match_col.item).to_integer_32 /= 2_147_483_647 then
										push_next_match (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_shared (default_pointer)).do_nothing
									end
								end
							end
							current_finished.item := 1
							current_state_stored.item := 0
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 68 -- skip if block
					end
				when 1 then -- if:
						if (l_line[(create {P_SYNTAX_STATIC}).current_col.item]).to_integer_32 = 0 then
							current_finished.item := 1
							current_state_stored.item := 0
						elseif (l_line[((create {P_SYNTAX_STATIC}).current_col.item + 1)]).to_integer_32 = 0 then
							current_finished.item := 1
							current_state_stored.item := 0
						end
						if try_next_column.item.to_boolean then
							(create {P_SYNTAX_STATIC}).next_match_idx.item := -1
							try_next_column.item := 0
						end
						if not a_syncing.to_boolean then
							if (create {P_SYNTAX_STATIC}).syn_block.item.item.b_keywtab.ht_used > {NATURAL_32} 0 then
								l_tmp := 1
							elseif (create {P_SYNTAX_STATIC}).syn_block.item.item.b_keywtab_ic.ht_used > {NATURAL_32} 0 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
						l_do_keywords := l_tmp
						l_zero_width_next_ga.item.ga_init2 (({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32, 10)
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 54 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_found_match := 0
						l_keep_next_list := 0
						l_syn_id := 0
						if ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len).to_boolean then
							l_cur_si := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len - 1)
						else
							l_cur_si := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_shared (default_pointer)
						end
						if not (((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_containedin).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L___4
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 6 then -- else:
						if not (l_cur_si.is_void) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___4
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 9 then -- else:
						if (l_cur_si.item.si_cont_list).is_void then
							l_pos := -1 + 45 -- skip if block
						end
				when 10 then -- if: | _L___4:
						if not (l_do_keywords.to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 11 then -- if:
						l_line := (create {P_SYNTAX_STATIC}).syn_getcurline
						if not ((vim_iswordc_buf (l_line + (create {P_SYNTAX_STATIC}).current_col.item, (create {P_SYNTAX_STATIC}).syn_buf.item)).to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 12 then -- if:
						if (create {P_SYNTAX_STATIC}).current_col.item /= 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___3 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_line, (l_line + (create {P_SYNTAX_STATIC}).current_col.item) - 1]))
						else
							l_tmp___3 := 0
						end
						if (vim_iswordc_buf (((l_line + (create {P_SYNTAX_STATIC}).current_col.item) - 1) - l_tmp___3, (create {P_SYNTAX_STATIC}).syn_buf.item)).to_boolean then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L:
						l_syn_id := check_keyword_id (l_line, (create {P_SYNTAX_STATIC}).current_col.item, l_endcol, l_flags___0, l_next_list, l_cur_si, l_cchar)
						if l_syn_id /= 0 then
							if (push_current_state (-1)) = 1 then
								l_cur_si := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len - 1)
								l_cur_si.item.si_m_startcol := (create {P_SYNTAX_STATIC}).current_col.item
								l_cur_si.item.si_h_startpos.lnum := (create {P_SYNTAX_STATIC}).current_lnum.item
								l_cur_si.item.si_h_startpos.col := 0
								l_cur_si.item.si_m_endpos.lnum := (create {P_SYNTAX_STATIC}).current_lnum.item
								l_cur_si.item.si_m_endpos.col := l_endcol.item
								l_cur_si.item.si_h_endpos.lnum := (create {P_SYNTAX_STATIC}).current_lnum.item
								l_cur_si.item.si_h_endpos.col := l_endcol.item
								l_cur_si.item.si_ends := 1
								l_cur_si.item.si_end_idx := 0
								l_cur_si.item.si_flags := l_flags___0.item
								l_cur_si.item.si_id := l_syn_id
								l_cur_si.item.si_trans_id := l_syn_id
								if ((l_flags___0.item).bit_and (2)).to_boolean then
									if (create {P_SYNTAX_STATIC}).current_state.item.item.ga_len < 2 then
										l_cur_si.item.si_attr := 0
										l_cur_si.item.si_trans_id := 0
									else
										l_cur_si.item.si_attr := (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len - 2)).item.si_attr
										l_cur_si.item.si_trans_id := (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len - 2)).item.si_trans_id
									end
								else
									l_cur_si.item.si_attr := (create {P_SYNTAX_STATIC}).syn_id2attr (l_syn_id)
								end
								l_cur_si.item.si_cont_list := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
								l_cur_si.item.si_next_list := l_next_list.item;
								(create {P_SYNTAX_STATIC}).check_keepend
							else
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_next_list.item))
							end
						end
				when 17 then -- if done | if done | if done
						if l_syn_id /= 0 then
							l_pos := -1 + 45 -- skip if block
						end
				when 18 then -- if:
						if not (((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_patterns.ga_len).to_boolean) then
							l_pos := -1 + 45 -- skip if block
						end
				when 19 then -- if:
						if not ((create {P_SYNTAX_STATIC}).next_match_idx.item < 0) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___3
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 22 then -- else:
						if not ((create {P_SYNTAX_STATIC}).next_match_col.item < (create {P_SYNTAX_STATIC}).current_col.item) then
							l_pos := -1 + 44 -- skip if block
						end
				when 23 then -- if: | _L___3:;
						(create {P_SYNTAX_STATIC}).next_match_idx.item := 0;
						(create {P_SYNTAX_STATIC}).next_match_col.item := 2_147_483_647
						l_idx := (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_patterns.ga_len
				when 24 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 43 -- skip loop
						end
				when 25 then -- loop body:
						l_break := False
						l_continue := False
						l_idx := l_idx - 1
						if not (l_idx >= 0) then
							l_break := True
						end
						if (l_break or l_continue) then
							l_pos := -1 + 42 -- skip if block
						end
				when 26 then -- if:
						l_spp := create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_patterns.ga_data) + l_idx
						if (l_spp.item.sp_syncing).to_integer_32 /= a_syncing then
							l_pos := -1 + 42 -- skip if block
						end
				when 27 then -- if:
						if not (a_displaying.to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 31 -- goto _L___2
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 30 then -- else:
						if ((l_spp.item.sp_flags).bit_and (4_096)).to_boolean then
							l_pos := -1 + 42 -- skip if block
						end
				when 31 then -- if: | _L___2:
						if (l_spp.item.sp_type).to_integer_32 /= 1 then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 35 -- goto _L___1
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 34 then -- else:
						if (l_spp.item.sp_type).to_integer_32 /= 2 then
							l_pos := -1 + 42 -- skip if block
						end
				when 35 then -- if: | _L___1:
						if not ((create {P_SYNTAX_STATIC}).current_next_list.item).is_void then
							l_tmp___10 := (in_id_list (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_shared (default_pointer), (create {P_SYNTAX_STATIC}).current_next_list.item, create {CE_CLASS_POINTER [PD_SP_SYN]}.make_shared (l_spp.c_pointer + (create {PD_SYN_PATTERN}.make).offset_of ("sp_syn")), 0))
						else
							if l_cur_si.is_void then
								l_tmp___9 := (not ((l_spp.item.sp_flags).bit_and (1)).to_boolean).to_integer
							else
								l_tmp___9 := (in_id_list (l_cur_si, l_cur_si.item.si_cont_list, create {CE_CLASS_POINTER [PD_SP_SYN]}.make_shared (l_spp.c_pointer + (create {PD_SYN_PATTERN}.make).offset_of ("sp_syn")), (l_spp.item.sp_flags).bit_and (1)))
							end
							l_tmp___10 := l_tmp___9
						end
						if not (l_tmp___10.to_boolean) then
							l_pos := -1 + 42 -- skip if block
						end
				when 36 then -- if:
						if l_spp.item.sp_line_id = current_line_id.item then
							if l_spp.item.sp_startcol >= (create {P_SYNTAX_STATIC}).next_match_col.item then
								l_continue := True
							end
						end
						if not (l_break or l_continue) then
							l_spp.item.sp_line_id := current_line_id.item
							l_lc_col := (create {P_SYNTAX_STATIC}).current_col.item - l_spp.item.sp_offsets[6]
							if l_lc_col < 0 then
								l_lc_col := 0
							end
							l_regmatch___0.item.rmm_ic := l_spp.item.sp_ic
							l_regmatch___0.item.regprog := l_spp.item.sp_prog
							if not (l_regmatch___0.item.syn_regexec ((create {P_SYNTAX_STATIC}).current_lnum.item, l_lc_col)).to_boolean then
								l_spp.item.sp_startcol := 2_147_483_647
								l_continue := True
							end
						end
						if not (l_break or l_continue) then
							syn_add_start_off (l_pos___3, l_regmatch___0, l_spp, 0, -1)
							if l_pos___3.item.lnum > (create {P_SYNTAX_STATIC}).current_lnum.item then
								l_spp.item.sp_startcol := 2_147_483_647
								l_continue := True
							end
						end
						if not (l_break or l_continue) then
							l_startcol := l_pos___3.item.col
							l_spp.item.sp_startcol := l_startcol
							if l_startcol >= (create {P_SYNTAX_STATIC}).next_match_col.item then
								l_continue := True
							end
						end
						if not (l_break or l_continue) then
							if (did_match_already (l_idx, l_zero_width_next_ga)).to_boolean then
								try_next_column.item := 1
								l_continue := True
							end
						end
						if (l_break or l_continue) then
							l_pos := -1 + 41 -- skip if block
						end
				when 37 then -- if:
						l_endpos.item.lnum := l_regmatch___0.item.endpos[0].lnum
						l_endpos.item.col := l_regmatch___0.item.endpos[0].col
						syn_add_start_off (l_hl_startpos, l_regmatch___0, l_spp, 2, -1)
						l_eos_pos.item.syn_add_end_off (l_regmatch___0, l_spp, 4, 0);
						(create {P_REGEXP_STATIC}).unref_extmatch (l_cur_extmatch)
						l_cur_extmatch := (create {P_GLOBALS_STATIC}).re_extmatch_out.item;
						(create {P_GLOBALS_STATIC}).re_extmatch_out.item := create {CE_CLASS_POINTER [PD_REG_EXTMATCH_T]}.make_shared (default_pointer)
						l_flags___0.item := 0
						l_eoe_pos.item.lnum := (0).to_integer_32
						l_eoe_pos.item.col := 0
						l_end_idx.item := 0
						l_hl_endpos.item.lnum := (0).to_integer_32
						if (l_spp.item.sp_type).to_integer_32 /= 2 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if ((l_spp.item.sp_flags).bit_and (4)).to_boolean then
							l_startpos.item := (l_endpos.item).twin;
							(create {P_SYNTAX_STATIC}).find_endpos (l_idx, l_startpos, l_endpos, l_hl_endpos, l_flags___0, l_eoe_pos, l_end_idx, l_cur_extmatch)
							if l_endpos.item.lnum = 0 then
								l_continue := True
							end
						else
							l_pos := -1 + 40 -- goto _L___0
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else: | _L___0:
						if (l_spp.item.sp_type).to_integer_32 = 1 then
							l_hl_endpos.item.syn_add_end_off (l_regmatch___0, l_spp, 3, 0)
							l_endpos.item.syn_add_end_off (l_regmatch___0, l_spp, 1, 0)
							if l_endpos.item.lnum = (create {P_SYNTAX_STATIC}).current_lnum.item then
								if l_endpos.item.col + a_syncing < l_startcol then
									if l_regmatch___0.item.startpos[0].col = l_regmatch___0.item.endpos[0].col then
										try_next_column.item := 1
									end
									l_continue := True
								end
							end
						end
				when 41 then -- if done
						if not (l_break or l_continue) then
							if l_hl_startpos.item.lnum = (create {P_SYNTAX_STATIC}).current_lnum.item then
								if l_hl_startpos.item.col < l_startcol then
									l_hl_startpos.item.col := l_startcol
								end
							end
							(create {P_SYNTAX_STATIC}).limit_pos_zero (l_hl_endpos, l_endpos);
							(create {P_SYNTAX_STATIC}).next_match_idx.item := l_idx;
							(create {P_SYNTAX_STATIC}).next_match_col.item := l_startcol
							next_match_m_endpos.item := (l_endpos.item).twin
							next_match_h_endpos.item := (l_hl_endpos.item).twin
							next_match_h_startpos.item := (l_hl_startpos.item).twin
							next_match_flags.item := l_flags___0.item
							next_match_eos_pos.item := (l_eos_pos.item).twin
							next_match_eoe_pos.item := (l_eoe_pos.item).twin
							next_match_end_idx.item := l_end_idx.item;
							(create {P_REGEXP_STATIC}).unref_extmatch (next_match_extmatch.item)
							next_match_extmatch.item := l_cur_extmatch
							l_cur_extmatch := create {CE_CLASS_POINTER [PD_REG_EXTMATCH_T]}.make_shared (default_pointer)
						end
				when 42 then -- if done | if done | if done | if done | if done | if done
						if (not l_break) then
							
						end
						l_pos := -1 + 24 -- back to loop condition
				when 43 then -- loop done
						l_break := False
						l_continue := False
				when 44 then -- if done
						if (create {P_SYNTAX_STATIC}).next_match_idx.item >= 0 then
							if (create {P_SYNTAX_STATIC}).next_match_col.item = (create {P_SYNTAX_STATIC}).current_col.item then
								l_lspp := create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_patterns.ga_data) + (create {P_SYNTAX_STATIC}).next_match_idx.item
								if next_match_m_endpos.item.lnum = (create {P_SYNTAX_STATIC}).current_lnum.item then
									if next_match_m_endpos.item.col = (create {P_SYNTAX_STATIC}).current_col.item then
										if not (l_lspp.item.sp_next_list).is_void then
											(create {P_SYNTAX_STATIC}).current_next_list.item := l_lspp.item.sp_next_list;
											(create {P_SYNTAX_STATIC}).current_next_flags.item := l_lspp.item.sp_flags
											l_keep_next_list := 1
											l_zero_width_next_list := 1
											if (l_zero_width_next_ga.item.ga_grow (1)) = 1 then
												l_tmp___11 := l_zero_width_next_ga.item.ga_len
												l_zero_width_next_ga.item.ga_len := (l_zero_width_next_ga.item.ga_len) + 1
												create {CE_INTEGER_32_POINTER}.make_cast (l_zero_width_next_ga.item.ga_data)[l_tmp___11] := (create {P_SYNTAX_STATIC}).next_match_idx.item
											end
											(create {P_SYNTAX_STATIC}).next_match_idx.item := -1
										else
											l_cur_si := push_next_match (l_cur_si)
										end
									else
										l_cur_si := push_next_match (l_cur_si)
									end
								else
									l_cur_si := push_next_match (l_cur_si)
								end
								l_found_match := 1
							end
						end
				when 45 then -- if done | if done | if done | if done
						if ((create {P_SYNTAX_STATIC}).current_next_list.item).is_void then
							l_pos := -1 + 53 -- skip if block
						end
				when 46 then -- if:
						if l_keep_next_list.to_boolean then
							l_pos := -1 + 53 -- skip if block
						end
				when 47 then -- if:
						if l_found_match.to_boolean then
							l_pos := -1 + 52 -- skip if block
						end
				when 48 then -- if:
						l_line := (create {P_SYNTAX_STATIC}).syn_getcurline
						if not ((((create {P_SYNTAX_STATIC}).current_next_flags.item).bit_and (256)).to_boolean) then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						if (l_line[(create {P_SYNTAX_STATIC}).current_col.item]).to_integer_32 = 32 then
							l_break := True
						elseif (l_line[(create {P_SYNTAX_STATIC}).current_col.item]).to_integer_32 = 9 then
							l_break := True
						else
							l_pos := -1 + 51 -- goto _L___5
						end
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 51 then -- else: | _L___5:
						if (((create {P_SYNTAX_STATIC}).current_next_flags.item).bit_and (512)).to_boolean then
							if (l_line.item).to_integer_32 = 0 then
								l_break := True
							end
						end
				when 52 then -- if done
						if not (l_return or l_break or l_continue) then
							(create {P_SYNTAX_STATIC}).current_next_list.item := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer);
							(create {P_SYNTAX_STATIC}).next_match_idx.item := -1
							if not l_zero_width_next_list.to_boolean then
								l_found_match := 1
							end
						end
				when 53 then -- if done | if done
						if not (l_return or l_break or l_continue) and then (not l_found_match.to_boolean) then
							l_break := True
						end
						l_pos := -1 + 2 -- back to loop condition
				when 54 then -- loop done
						l_break := False
						current_attr.item := 0
						current_id.item := 0
						current_trans_id.item := 0
						if l_cur_si.is_void then
							l_pos := -1 + 66 -- skip if block
						end
				when 55 then -- if:
						l_idx := (create {P_SYNTAX_STATIC}).current_state.item.item.ga_len - 1
				when 56 then -- loop condition:
						if not (not (l_break) and then (l_idx >= 0)) then
							l_pos := -1 + 64 -- skip loop
						end
				when 57 then -- loop body:
						l_break := False
						l_sip := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_idx
						if not ((create {P_SYNTAX_STATIC}).current_lnum.item > l_sip.item.si_h_startpos.lnum) then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						l_pos := -1 + 62 -- goto _L___6
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 60 then -- else:
						if (create {P_SYNTAX_STATIC}).current_lnum.item /= l_sip.item.si_h_startpos.lnum then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						if not ((create {P_SYNTAX_STATIC}).current_col.item >= l_sip.item.si_h_startpos.col) then
							l_pos := -1 + 63 -- skip if block
						end
				when 62 then -- if: | _L___6:
						if l_sip.item.si_h_endpos.lnum = 0 then
							current_attr.item := l_sip.item.si_attr
							current_id.item := l_sip.item.si_id
							current_trans_id.item := l_sip.item.si_trans_id
							l_break := True
						elseif (create {P_SYNTAX_STATIC}).current_lnum.item < l_sip.item.si_h_endpos.lnum then
							current_attr.item := l_sip.item.si_attr
							current_id.item := l_sip.item.si_id
							current_trans_id.item := l_sip.item.si_trans_id
							l_break := True
						elseif (create {P_SYNTAX_STATIC}).current_lnum.item = l_sip.item.si_h_endpos.lnum then
							if (create {P_SYNTAX_STATIC}).current_col.item < l_sip.item.si_h_endpos.col then
								current_attr.item := l_sip.item.si_attr
								current_id.item := l_sip.item.si_id
								current_trans_id.item := l_sip.item.si_trans_id
								l_break := True
							end
						end
				when 63 then -- if done | if done
						if not (l_return or l_break or l_continue) then
							l_idx := l_idx - 1
						end
						l_pos := -1 + 56 -- back to loop condition
				when 64 then -- loop done
						l_break := False
						if not a_can_spell.is_void then
							if (create {P_SYNTAX_STATIC}).syn_block.item.item.b_spell_cluster_id = 0 then
								if (create {P_SYNTAX_STATIC}).syn_block.item.item.b_nospell_cluster_id = 0 then
									a_can_spell.item := ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_spell /= 2).to_integer
								elseif current_trans_id.item = 0 then
									a_can_spell.item := ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_spell /= 2).to_integer
								else
									l_sps.item.inc_tag := 0
									l_sps.item.id := ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_nospell_cluster_id).to_integer_16
									l_sps.item.cont_in_list := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
									if (in_id_list (l_sip, l_sip.item.si_cont_list, l_sps, 0)).to_boolean then
										l_tmp___14 := 0
									else
										l_tmp___14 := 1
									end
									a_can_spell.item := l_tmp___14
								end
							elseif current_trans_id.item = 0 then
								a_can_spell.item := ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_spell = 1).to_integer
							else
								l_sps.item.inc_tag := 0
								l_sps.item.id := ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_spell_cluster_id).to_integer_16
								l_sps.item.cont_in_list := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
								a_can_spell.item := in_id_list (l_sip, l_sip.item.si_cont_list, l_sps, 0)
								if (create {P_SYNTAX_STATIC}).syn_block.item.item.b_nospell_cluster_id /= 0 then
									l_sps.item.id := ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_nospell_cluster_id).to_integer_16
									if (in_id_list (l_sip, l_sip.item.si_cont_list, l_sps, 0)).to_boolean then
										a_can_spell.item := 0
									end
								end
							end
						end
						if not a_syncing.to_boolean then
							if not a_keep_state.to_boolean then
								(create {P_SYNTAX_STATIC}).check_state_ends
								if (create {P_SYNTAX_STATIC}).current_state.item.item.ga_len > 0 then
									if (((create {P_SYNTAX_STATIC}).syn_getcurline)[(create {P_SYNTAX_STATIC}).current_col.item]).to_integer_32 /= 0 then
										(create {P_SYNTAX_STATIC}).current_col.item := (create {P_SYNTAX_STATIC}).current_col.item + 1;
										(create {P_SYNTAX_STATIC}).check_state_ends;
										(create {P_SYNTAX_STATIC}).current_col.item := (create {P_SYNTAX_STATIC}).current_col.item - 1
									end
								end
							end
						end
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 66 then -- else:
						if not a_can_spell.is_void then
							if (create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_spell = 0 then
								a_can_spell.item := ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_spell_cluster_id = 0).to_integer
							else
								a_can_spell.item := ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_spell = 1).to_integer
							end
						end
				when 67 then -- if done
						if not ((create {P_SYNTAX_STATIC}).current_next_list.item).is_void then
							if (((create {P_SYNTAX_STATIC}).syn_getcurline)[((create {P_SYNTAX_STATIC}).current_col.item + 1)]).to_integer_32 = 0 then
								if not (((create {P_SYNTAX_STATIC}).current_next_flags.item).bit_and (640)).to_boolean then
									(create {P_SYNTAX_STATIC}).current_next_list.item := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
								end
							end
						end
						if l_zero_width_next_ga.item.ga_len > 0 then
							l_zero_width_next_ga.item.ga_clear
						end
						(create {P_REGEXP_STATIC}).unref_extmatch ((create {P_GLOBALS_STATIC}).re_extmatch_out.item);
						(create {P_GLOBALS_STATIC}).re_extmatch_out.item := create {CE_CLASS_POINTER [PD_REG_EXTMATCH_T]}.make_shared (default_pointer);
						(create {P_REGEXP_STATIC}).unref_extmatch (l_cur_extmatch)
						Result := current_attr.item
				when 68 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	did_match_already (a_idx: INTEGER_32; a_gap: CE_POINTER [PD_GROWARRAY]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i___0 := (create {P_SYNTAX_STATIC}).current_state.item.item.ga_len
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_i___0 := l_i___0 - 1
				if not (l_i___0 >= 0) then
					l_break := True
				end
				if not (l_return or l_break) and then ((create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_m_startcol = (create {P_SYNTAX_STATIC}).current_col.item) then
					if (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_m_lnum = ((create {P_SYNTAX_STATIC}).current_lnum.item).to_integer_32 then
						if (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + l_i___0).item.si_idx = a_idx then
							Result := 1
							l_return := True
						end
					end
				end
			end
			if not l_return then
				l_break := False
				l_i___0 := a_gap.item.ga_len
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_i___0 := l_i___0 - 1
					if not (l_i___0 >= 0) then
						l_break := True
					end
					if not (l_return or l_break) and then (create {CE_INTEGER_32_POINTER}.make_cast (a_gap.item.ga_data)[l_i___0] = a_idx) then
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 0
			end
		end

	push_next_match (a_cur_si: CE_POINTER [PD_STATE_ITEM]): CE_POINTER [PD_STATE_ITEM]
		local
			l_cur_si: CE_POINTER [PD_STATE_ITEM]
			l_spp: CE_POINTER [PD_SYN_PATTERN]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cur_si := a_cur_si
					l_spp := create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_patterns.ga_data) + (create {P_SYNTAX_STATIC}).next_match_idx.item
					if (push_current_state ((create {P_SYNTAX_STATIC}).next_match_idx.item)) /= 1 then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_cur_si := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len - 1)
						l_cur_si.item.si_h_startpos := next_match_h_startpos.item.twin
						l_cur_si.item.si_m_startcol := (create {P_SYNTAX_STATIC}).current_col.item
						l_cur_si.item.si_m_lnum := ((create {P_SYNTAX_STATIC}).current_lnum.item).to_integer_32
						l_cur_si.item.si_flags := (l_spp.item.sp_flags).to_integer_32
						l_cur_si.item.si_next_list := l_spp.item.sp_next_list
						l_cur_si.item.si_extmatch := (create {P_REGEXP_STATIC}).ref_extmatch (next_match_extmatch.item)
						if (l_spp.item.sp_type).to_integer_32 /= 2 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not ((l_spp.item.sp_flags).bit_and (4)).to_boolean then
							l_cur_si.item.update_si_end (next_match_m_endpos.item.col, 1);
							(create {P_SYNTAX_STATIC}).check_keepend
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_cur_si.item.si_m_endpos := next_match_m_endpos.item.twin
						l_cur_si.item.si_h_endpos := next_match_h_endpos.item.twin
						l_cur_si.item.si_ends := 1
						l_cur_si.item.si_flags := (l_cur_si.item.si_flags).bit_or (next_match_flags.item)
						l_cur_si.item.si_eoe_pos := next_match_eoe_pos.item.twin
						l_cur_si.item.si_end_idx := next_match_end_idx.item
				when 5 then
						if (create {P_SYNTAX_STATIC}).keepend_level.item < 0 then
							if ((l_cur_si.item.si_flags).bit_and (1_024)).to_boolean then
								(create {P_SYNTAX_STATIC}).keepend_level.item := (create {P_SYNTAX_STATIC}).current_state.item.item.ga_len - 1
							end
						end
						(create {P_SYNTAX_STATIC}).check_keepend;
						(create {P_SYNTAX_STATIC}).update_si_attr ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len - 1)
						if (l_spp.item.sp_type).to_integer_32 = 2 then
							if (l_spp.item.sp_syn_match_id).to_integer_32 /= 0 then
								if (push_current_state ((create {P_SYNTAX_STATIC}).next_match_idx.item)) = 1 then
									l_cur_si := create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len - 1)
									l_cur_si.item.si_h_startpos := next_match_h_startpos.item.twin
									l_cur_si.item.si_m_startcol := (create {P_SYNTAX_STATIC}).current_col.item
									l_cur_si.item.si_m_lnum := ((create {P_SYNTAX_STATIC}).current_lnum.item).to_integer_32
									l_cur_si.item.si_m_endpos := next_match_eos_pos.item.twin
									l_cur_si.item.si_h_endpos := next_match_eos_pos.item.twin
									l_cur_si.item.si_ends := 1
									l_cur_si.item.si_end_idx := 0
									l_cur_si.item.si_flags := 64
									l_cur_si.item.si_next_list := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer);
									(create {P_SYNTAX_STATIC}).check_keepend;
									(create {P_SYNTAX_STATIC}).update_si_attr ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len - 1)
								end
							end
						end
				when 6 then -- if done;
					(create {P_SYNTAX_STATIC}).next_match_idx.item := -1
					Result := l_cur_si
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	push_current_state (a_idx: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (((create {P_SYNTAX_STATIC}).current_state.item).item.ga_grow (1)) = 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				memset (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + (create {P_SYNTAX_STATIC}).current_state.item.item.ga_len)), 0, (create {PD_STATE_ITEM}.make).structure_size.to_natural_32).do_nothing;
				(create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data) + (create {P_SYNTAX_STATIC}).current_state.item.item.ga_len).item.si_idx := a_idx;
				(create {P_SYNTAX_STATIC}).current_state.item.item.ga_len := ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_len) + 1
				Result := 1
			end
		end

	syn_add_start_off (a_result___2: CE_POINTER [PD_LPOS_T]; a_regmatch___0: CE_POINTER [PD_REGMMATCH_T]; a_spp: CE_POINTER [PD_SYN_PATTERN]; a_idx, a_extra: INTEGER_32)
		require
			not a_result___2.is_void
			not a_regmatch___0.is_void
			not a_spp.is_void
		local
			l_col: INTEGER_32
			l_off___0: INTEGER_32
			l_base: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_break: BOOLEAN
		do
			if (((a_spp.item.sp_off_flags).to_integer_32).bit_and (((1).bit_shift_left ((a_idx + 7))))).to_boolean then
				a_result___2.item.lnum := a_regmatch___0.item.endpos[0].lnum
				l_col := a_regmatch___0.item.endpos[0].col
				l_off___0 := a_spp.item.sp_offsets[a_idx] + a_extra
			else
				a_result___2.item.lnum := a_regmatch___0.item.startpos[0].lnum
				l_col := a_regmatch___0.item.startpos[0].col
				l_off___0 := a_spp.item.sp_offsets[a_idx]
			end
			if a_result___2.item.lnum > (create {P_SYNTAX_STATIC}).syn_buf.item.item.b_ml.ml_line_count then
				a_result___2.item.lnum := (create {P_SYNTAX_STATIC}).syn_buf.item.item.b_ml.ml_line_count
				l_col := (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((((create {P_SYNTAX_STATIC}).syn_buf.item).item.ml_get_buf (a_result___2.item.lnum, 0))))).to_integer_32
			end
			if l_off___0 /= 0 then
				l_base := ((create {P_SYNTAX_STATIC}).syn_buf.item).item.ml_get_buf (a_result___2.item.lnum, 0)
				l_p___0 := l_base + l_col
				if l_off___0 > 0 then
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___3 := l_off___0
						l_off___0 := l_off___0 - 1
						if l_tmp___3.to_boolean then
							if (l_p___0.item).to_integer_32 = 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___2 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
							else
								l_tmp___2 := 1
							end
							l_p___0 := l_p___0 + l_tmp___2
						end
					end
					l_break := False
				elseif l_off___0 < 0 then
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___6 := l_off___0
						l_off___0 := l_off___0 + 1
						if l_tmp___6.to_boolean then
							if not ((l_base.c_pointer.to_integer_32).to_natural_32 < (l_p___0.c_pointer.to_integer_32).to_natural_32) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___5 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_base, l_p___0 - 1])) + 1
							else
								l_tmp___5 := 1
							end
							l_p___0 := l_p___0 - l_tmp___5
						end
					end
					l_break := False
				end
				l_col := l_p___0.distance (l_base)
			end
			a_result___2.item.col := l_col
		end

	check_keyword_id (a_line: CE_POINTER [NATURAL_8]; a_startcol: INTEGER_32; a_endcolp: CE_POINTER [INTEGER_32]; a_flagsp: CE_POINTER [INTEGER_32]; a_next_listp: CE_POINTER [CE_POINTER [INTEGER_16]]; a_cur_si: CE_POINTER [PD_STATE_ITEM]; a_ccharp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_kp: CE_POINTER [PD_KEYENTRY]
			l_kwp: CE_POINTER [NATURAL_8]
			l_round: INTEGER_32
			l_kwlen: INTEGER_32
			l_keyword: CE_ARRAY [NATURAL_8]
			l_ht: CE_POINTER [PD_HASHTABLE_S]
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_keyword.make (<<81>>)

			l_kwp := a_line + a_startcol
			l_kwlen := 0
			from
			until
				(l_break)
			loop
				l_break := False
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					l_kwlen := l_kwlen + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_kwp + l_kwlen]))
				else
					l_kwlen := l_kwlen + 1
				end
				if not (vim_iswordc_buf (l_kwp + l_kwlen, (create {P_SYNTAX_STATIC}).syn_buf.item)).to_boolean then
					l_break := True
				end
			end
			l_break := False
			if l_kwlen > 80 then
				Result := 0
				l_return := True
			end
			if not l_return then
				(create {P_MISC2_STATIC}).vim_strncpy (l_keyword, l_kwp, l_kwlen.to_natural_32)
				l_round := 1
				from
				until
					not (not (l_return) and then (l_round <= 2))
				loop
					l_continue := False
					if l_round = 1 then
						l_ht := create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared ((create {P_SYNTAX_STATIC}).syn_block.item.c_pointer + (create {PD_SYNBLOCK_T}.make).offset_of ("b_keywtab"))
					else
						l_ht := create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared ((create {P_SYNTAX_STATIC}).syn_block.item.c_pointer + (create {PD_SYNBLOCK_T}.make).offset_of ("b_keywtab_ic"))
					end
					if l_ht.item.ht_used = {NATURAL_32} 0 then
						l_continue := True
					end
					if not (l_return or l_break or l_continue) then
						if l_round = 2 then
							(create {P_CHARSET_STATIC}).str_foldcase (l_kwp, l_kwlen, l_keyword, 81).do_nothing
						end
						l_hi___1 := l_ht.item.hash_find (l_keyword)
						if not ((l_hi___1.item.hi_key).is_void) then
							if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
								l_kp := create {CE_CLASS_POINTER [PD_KEYENTRY]}.make_cast ((l_hi___1.item.hi_key - (((create {P_SYNTAX_STATIC}).dumkey.item.item.keyword).distance ((create {CE_NATURAL_8_POINTER}.make_cast (((create {P_SYNTAX_STATIC}).dumkey.item)))))))
								from
								until
									not (not (l_return) and then (not l_kp.is_void))
								loop
									if not ((create {P_SYNTAX_STATIC}).current_next_list.item).is_void then
										l_tmp___4 := (in_id_list (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_shared (default_pointer), (create {P_SYNTAX_STATIC}).current_next_list.item, create {CE_CLASS_POINTER [PD_SP_SYN]}.make_shared (l_kp.c_pointer + (create {PD_KEYENTRY}.make).offset_of ("k_syn")), 0))
									else
										if a_cur_si.is_void then
											l_tmp___3 := (not ((l_kp.item.flags).bit_and (1)).to_boolean).to_integer
										else
											l_tmp___3 := (in_id_list (a_cur_si, a_cur_si.item.si_cont_list, create {CE_CLASS_POINTER [PD_SP_SYN]}.make_shared (l_kp.c_pointer + (create {PD_KEYENTRY}.make).offset_of ("k_syn")), (l_kp.item.flags).bit_and (1)))
										end
										l_tmp___4 := l_tmp___3
									end
									if l_tmp___4.to_boolean then
										a_endcolp.item := a_startcol + l_kwlen
										a_flagsp.item := (l_kp.item.flags).to_integer_32
										a_next_listp.item := l_kp.item.next_list
										Result := (l_kp.item.k_syn.id).to_integer_32
										l_return := True
									end
									if not l_return then
										l_kp := l_kp.item.ke_next
									end
								end
							end
						end
					end
					if (not l_return) then
						l_round := l_round + 1
					end
				end
			end
			if not l_return then
				l_continue := False
				Result := 0
			end
		end

	vim_iswordc_buf (a_p___0: CE_POINTER [NATURAL_8]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				if ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(a_p___0.item).to_integer_32]).to_integer_32 > 1 then
					Result := (((create {P_MBYTE_STATIC}).mb_get_class (a_p___0)) >= 2).to_integer
					l_return := True
				end
			end
			if not l_return then
				Result := ((((a_buf___6.item.b_chartab[(((a_p___0.item).to_natural_32).bit_shift_right (3)).to_integer_32]).to_integer_32).bit_and (((1).bit_shift_left ((((a_p___0.item).to_integer_32).bit_and (7)))))) /= 0).to_integer
			end
		end

	in_id_list (a_cur_si: CE_POINTER [PD_STATE_ITEM]; a_list: CE_POINTER [INTEGER_16]; a_ssp: CE_POINTER [PD_SP_SYN]; a_contained: INTEGER_32): INTEGER_32
		require
			not a_ssp.is_void
		local
			l_cur_si: CE_POINTER [PD_STATE_ITEM]
			l_list: CE_POINTER [INTEGER_16]
			l_retval: INTEGER_32
			l_scl_list: CE_POINTER [INTEGER_16]
			l_item: INTEGER_16
			l_id: INTEGER_16
			l_r: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_cur_si := a_cur_si
			l_list := a_list
			l_id := a_ssp.item.id
			if not l_cur_si.is_void then
				if not (a_ssp.item.cont_in_list).is_void then
					if not ((l_cur_si.item.si_flags).bit_and (64)).to_boolean then
						from
						until
							(l_break)
						loop
							l_break := False
							if ((l_cur_si.item.si_flags).bit_and (65_536)).to_boolean then
								if not ((l_cur_si.c_pointer.to_integer_32).to_natural_32 > ((create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_cast ((create {P_SYNTAX_STATIC}).current_state.item.item.ga_data)).c_pointer.to_integer_32).to_natural_32) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_cur_si := l_cur_si - 1
							end
						end
						l_break := False
						if l_cur_si.item.si_idx >= 0 then
							if (in_id_list (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_shared (default_pointer), a_ssp.item.cont_in_list, create {CE_CLASS_POINTER [PD_SP_SYN]}.make_shared ((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_patterns.ga_data) + l_cur_si.item.si_idx).c_pointer + (create {PD_SYN_PATTERN}.make).offset_of ("sp_syn")), ((create {CE_CLASS_POINTER [PD_SYN_PATTERN]}.make_cast ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_patterns.ga_data) + l_cur_si.item.si_idx).item.sp_flags).bit_and (1))).to_boolean then
								Result := 1
								l_return := True
							end
						end
					end
				end
			end
			if not l_return and then (l_list.is_void) then
				Result := 0
				l_return := True
			end
			if not l_return and then ((l_list.c_pointer.to_integer_32).to_natural_32 = ((create {CE_INTEGER_16_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32) then
				Result := (not a_contained.to_boolean).to_integer
				l_return := True
			end
			if not l_return then
				l_item := l_list.item
				if l_item.to_integer_32 >= 10_000 then
					if l_item.to_integer_32 < 25_000 then
						if l_item.to_integer_32 < 15_000 then
							if l_item.to_integer_32 - 10_000 /= a_ssp.item.inc_tag then
								Result := 0
								l_return := True
							end
						elseif l_item.to_integer_32 < 20_000 then
							if l_item.to_integer_32 - 15_000 /= a_ssp.item.inc_tag then
								Result := 0
								l_return := True
							elseif a_contained.to_boolean then
								Result := 0
								l_return := True
							end
						elseif l_item.to_integer_32 - 20_000 /= a_ssp.item.inc_tag then
							Result := 0
							l_return := True
						elseif not a_contained.to_boolean then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_list := l_list + 1
							l_item := l_list.item
							l_retval := 0
						end
					else
						l_retval := 1
					end
				else
					l_retval := 1
				end
			end
			if not l_return then
				from
				until
					not (not (l_return) and then (l_item.to_integer_32 /= 0))
				loop
					if l_item.to_integer_32 = l_id.to_integer_32 then
						Result := l_retval
						l_return := True
					end
					if not l_return and then (l_item.to_integer_32 >= 25_000) then
						l_scl_list := (create {CE_CLASS_POINTER [PD_SYN_CLUSTER_S]}.make_cast ((create {P_SYNTAX_STATIC}).syn_block.item.item.b_syn_clusters.ga_data) + (l_item.to_integer_32 - 25_000)).item.scl_list
						if not l_scl_list.is_void then
							if depth___0.item < 30 then
								depth___0.item := depth___0.item + 1
								l_r := in_id_list (create {CE_CLASS_POINTER [PD_STATE_ITEM]}.make_shared (default_pointer), l_scl_list, a_ssp, a_contained)
								depth___0.item := depth___0.item - 1
								if l_r.to_boolean then
									Result := l_retval
									l_return := True
								end
							end
						end
					end
					if not l_return then
						l_list := l_list + 1
						l_item := l_list.item
					end
				end
			end
			if not l_return then
				Result := (not l_retval.to_boolean).to_integer
			end
		end

	free_tabpage (a_tp: CE_POINTER [PD_TABPAGE_S])
		require
			not a_tp.is_void
		local
			l_idx: INTEGER_32
		do
			a_tp.item.diff_clear
			l_idx := 0
			from
			until
				not (l_idx < 2)
			loop
				a_tp.item.clear_snapshot (l_idx)
				l_idx := l_idx + 1
			end
			(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_tp.c_pointer + (create {PD_TABPAGE_S}.make).offset_of ("tp_vars") + (create {PD_DICTVAR_S}.make).offset_of ("dv_hashtab"))).item.vars_clear;
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_tp))
		end

	frame_setheight (a_curfrp: CE_POINTER [PD_FRAME_S]; a_height: INTEGER_32)
		require
			not a_curfrp.is_void
		local
			l_height: INTEGER_32
			l_room: INTEGER_32
			l_take: INTEGER_32
			l_room_cmdline: INTEGER_32
			l_run: INTEGER_32
			l_frp: CE_POINTER [PD_FRAME_S]
			l_h: INTEGER_32
			l_room_reserved: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_height := a_height
					if a_curfrp.item.fr_height = l_height then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 28 -- skip if block
					end
				when 1 then -- if:
						if not ((a_curfrp.item.fr_parent).is_void) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_height.to_integer_32 > ((create {P_GLOBALS_STATIC}).Rows.item.item - (create {P_OPTION_STATIC}).p_ch.item.item) - ((create {P_WINDOW_STATIC}).tabline_height).to_integer_32 then
							l_height := (((create {P_GLOBALS_STATIC}).Rows.item.item - (create {P_OPTION_STATIC}).p_ch.item.item) - ((create {P_WINDOW_STATIC}).tabline_height).to_integer_32).to_integer_32
						end
						if l_height > 0 then
							a_curfrp.item.frame_new_height (l_height, 0, 0)
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 4 then -- else:
						if ((a_curfrp.item.fr_parent).item.fr_layout).to_integer_32 /= 1 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_h := (a_curfrp.item.fr_parent).item.frame_minheight (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						if l_height < l_h then
							l_height := l_h
						end
						frame_setheight (a_curfrp.item.fr_parent, l_height)
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 7 then -- else:
						l_run := 1
				when 8 then -- loop condition:
						if not (not (l_return or l_break) and then (l_run <= 2)) then
							l_pos := -1 + 16 -- skip loop
						end
				when 9 then -- loop body:
						l_break := False
						l_room := 0
						l_room_reserved := 0
						l_frp := (a_curfrp.item.fr_parent).item.fr_child
						from
						until
							l_frp.is_void
						loop
							if not l_frp.is_equal (a_curfrp) then
								if not (l_frp.item.fr_win).is_void then
									if ((l_frp.item.fr_win).item.w_onebuf_opt.wo_wfh).to_boolean then
										l_room_reserved := l_room_reserved + (l_frp.item.fr_height)
									end
								end
							end
							l_room := l_room + (l_frp.item.fr_height)
							if not l_frp.is_equal (a_curfrp) then
								l_room := l_room - (l_frp.item.frame_minheight (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)))
							end
							l_frp := l_frp.item.fr_next
						end
						if (a_curfrp.item.fr_width).to_integer_32 /= (create {P_GLOBALS_STATIC}).Columns.item.item then
							l_room_cmdline := 0
						else
							l_room_cmdline := (((create {P_GLOBALS_STATIC}).Rows.item.item - (create {P_OPTION_STATIC}).p_ch.item.item) - (((create {P_GLOBALS_STATIC}).lastwin.item.item.w_winrow + (create {P_GLOBALS_STATIC}).lastwin.item.item.w_height) + (create {P_GLOBALS_STATIC}).lastwin.item.item.w_status_height).to_integer_32).to_integer_32
							if l_room_cmdline < 0 then
								l_room_cmdline := 0
							end
						end
						if l_height <= l_room + l_room_cmdline then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						if l_run /= 2 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if (a_curfrp.item.fr_width).to_integer_32 /= (create {P_GLOBALS_STATIC}).Columns.item.item then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if l_height > l_room + l_room_cmdline then
							l_height := l_room + l_room_cmdline
						end
						l_break := True
				when 15 then -- if done | if done
						if not (l_return or l_break) then
							frame_setheight (a_curfrp.item.fr_parent, ((l_height + ((a_curfrp.item.fr_parent).item.frame_minheight (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer + -1)))) - ((create {P_OPTION_STATIC}).p_wmh.item.item).to_integer_32) - 1)
							l_run := l_run + 1
						end
						l_pos := -1 + 8 -- back to loop condition
				when 16 then -- loop done
						l_break := False
						l_take := l_height - a_curfrp.item.fr_height
						if l_height > (l_room + l_room_cmdline) - l_room_reserved then
							l_room_reserved := (l_room + l_room_cmdline) - l_height
						end
						if l_take < 0 then
							if l_room - a_curfrp.item.fr_height < l_room_reserved then
								l_room_reserved := 0
							end
						end
						if l_take > 0 then
							if l_room_cmdline > 0 then
								if l_take < l_room_cmdline then
									l_room_cmdline := l_take
								end
								l_take := l_take - l_room_cmdline;
								(create {P_GLOBALS_STATIC}).topframe.item.item.fr_height := (create {P_GLOBALS_STATIC}).topframe.item.item.fr_height + l_room_cmdline
							end
						end
						a_curfrp.item.frame_new_height (l_height, 0, 0)
						l_run := 0
				when 17 then -- loop condition:
						if not (not (l_return) and then (l_run < 2)) then
							l_pos := -1 + 28 -- skip loop
						end
				when 18 then -- loop body:
						if l_run = 0 then
							l_frp := a_curfrp.item.fr_next
						else
							l_frp := a_curfrp.item.fr_prev
						end
				when 19 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 27 -- skip loop
						end
				when 20 then -- loop body:
						l_break := False
						if not l_frp.is_void then
							if l_take = 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 26 -- skip if block
						end
				when 21 then -- if:
						l_h := l_frp.item.frame_minheight (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
						if not (l_room_reserved > 0) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if not (l_frp.item.fr_win).is_void then
							if ((l_frp.item.fr_win).item.w_onebuf_opt.wo_wfh).to_boolean then
								if l_room_reserved >= l_frp.item.fr_height then
									l_room_reserved := l_room_reserved - (l_frp.item.fr_height)
								else
									if l_frp.item.fr_height - l_room_reserved > l_take then
										l_room_reserved := l_frp.item.fr_height - l_take
									end
									l_take := l_take - (l_frp.item.fr_height - l_room_reserved)
									l_frp.item.frame_new_height (l_room_reserved, 0, 0)
									l_room_reserved := 0
								end
							else
								l_pos := -1 + 24 -- goto _L___1
							end
						else
							l_pos := -1 + 24 -- goto _L___1
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L___1:
						if l_frp.item.fr_height - l_take < l_h then
							l_take := l_take - (l_frp.item.fr_height - l_h)
							l_frp.item.frame_new_height (l_h, 0, 0)
						else
							l_frp.item.frame_new_height (l_frp.item.fr_height - l_take, 0, 0)
							l_take := 0
						end
				when 25 then
						if l_run = 0 then
							l_frp := l_frp.item.fr_next
						else
							l_frp := l_frp.item.fr_prev
						end
				when 26 then -- if done
						l_pos := -1 + 19 -- back to loop condition
				when 27 then -- loop done
						l_break := False
						l_run := l_run + 1
						l_pos := -1 + 17 -- back to loop condition
				when 28 then -- loop done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gui_mch_destroy_scrollbar (a_sb: CE_POINTER [PD_GUISCROLLBAR])
		require
			not a_sb.is_void
		do
			if not (a_sb.item.id).is_void then
				gtk_widget_destroy (a_sb.item.id)
				a_sb.item.id := create {CE_CLASS_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
			end
			(create {P_GUI_GTK_X11_STATIC}).gui_mch_update
		end

	netbeans_gutter_click (a_lnum: INTEGER_32)
		local
			l_p___0: CE_POINTER [PD_SIGNLIST]
			l_tail: CE_POINTER [PD_SIGNLIST]
			l_return, l_break: BOOLEAN
		do
			if (create {P_NETBEANS_STATIC}).nbsock.item.item = -1 then
				l_return := True
			end
			if not l_return then
				l_p___0 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_signlist
				from
				until
					not (not (l_return or l_break) and then (not l_p___0.is_void))
				loop
					l_break := False
					if l_p___0.item.lnum = a_lnum then
						if (not (l_p___0.item.next).is_void) then
							if (l_p___0.item.next).item.lnum = a_lnum then
								if (not (l_p___0.item.prev).is_void) then
									(l_p___0.item.prev).item.next := l_p___0.item.next
								else
									(create {P_GLOBALS_STATIC}).curbuf.item.item.b_signlist := l_p___0.item.next
								end
								(l_p___0.item.next).item.prev := l_p___0.item.prev
								l_tail := l_p___0.item.next
								from
								until
									(l_break)
								loop
									l_break := False
									if (not (l_tail.item.next).is_void) then
										if (l_tail.item.next).item.lnum = a_lnum then
											if not ((l_tail.item.next).item.id < 1_000_000) then
												l_break := True
											end
										else
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_tail := l_tail.item.next
									end
								end
								l_break := False
								l_p___0.item.next := l_tail.item.next
								if (not (l_tail.item.next).is_void) then
									(l_tail.item.next).item.prev := l_p___0
								end
								l_p___0.item.prev := l_tail
								l_tail.item.next := l_p___0;
								(create {P_SCREEN_STATIC}).update_debug_sign ((create {P_GLOBALS_STATIC}).curbuf.item, a_lnum)
								l_break := True
							end
						end
					end
					if not (l_return or l_break) then
						l_p___0 := l_p___0.item.next
					end
				end
				l_break := False
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			w_buffer := a_other.w_buffer
			w_s := a_other.w_s
			w_prev := a_other.w_prev
			w_next := a_other.w_next
			w_frame := a_other.w_frame
			w_cursor := a_other.w_cursor.twin
			w_curswant := a_other.w_curswant
			w_set_curswant := a_other.w_set_curswant
			w_old_visual_mode := a_other.w_old_visual_mode
			w_old_cursor_lnum := a_other.w_old_cursor_lnum
			w_old_cursor_fcol := a_other.w_old_cursor_fcol
			w_old_cursor_lcol := a_other.w_old_cursor_lcol
			w_old_visual_lnum := a_other.w_old_visual_lnum
			w_old_visual_col := a_other.w_old_visual_col
			w_old_curswant := a_other.w_old_curswant
			w_topline := a_other.w_topline
			w_topline_was_set := a_other.w_topline_was_set
			w_topfill := a_other.w_topfill
			w_old_topfill := a_other.w_old_topfill
			w_botfill := a_other.w_botfill
			w_old_botfill := a_other.w_old_botfill
			w_leftcol := a_other.w_leftcol
			w_skipcol := a_other.w_skipcol
			w_winrow := a_other.w_winrow
			w_height := a_other.w_height
			w_status_height := a_other.w_status_height
			w_wincol := a_other.w_wincol
			w_width := a_other.w_width
			w_vsep_width := a_other.w_vsep_width
			w_valid := a_other.w_valid
			w_valid_cursor := a_other.w_valid_cursor.twin
			w_valid_leftcol := a_other.w_valid_leftcol
			w_cline_height := a_other.w_cline_height
			w_cline_folded := a_other.w_cline_folded
			w_cline_row := a_other.w_cline_row
			w_virtcol := a_other.w_virtcol
			w_wrow := a_other.w_wrow
			w_wcol := a_other.w_wcol
			w_botline := a_other.w_botline
			w_empty_rows := a_other.w_empty_rows
			w_filler_rows := a_other.w_filler_rows
			w_lines_valid := a_other.w_lines_valid
			w_lines := a_other.w_lines
			w_folds := a_other.w_folds.twin
			w_fold_manual := a_other.w_fold_manual
			w_foldinvalid := a_other.w_foldinvalid
			w_nrwidth := a_other.w_nrwidth
			w_redr_type := a_other.w_redr_type
			w_upd_rows := a_other.w_upd_rows
			w_redraw_top := a_other.w_redraw_top
			w_redraw_bot := a_other.w_redraw_bot
			w_redr_status := a_other.w_redr_status
			w_ru_cursor := a_other.w_ru_cursor.twin
			w_ru_virtcol := a_other.w_ru_virtcol
			w_ru_topline := a_other.w_ru_topline
			w_ru_line_count := a_other.w_ru_line_count
			w_ru_topfill := a_other.w_ru_topfill
			w_ru_empty := a_other.w_ru_empty
			w_alt_fnum := a_other.w_alt_fnum
			w_alist := a_other.w_alist
			w_arg_idx := a_other.w_arg_idx
			w_arg_idx_invalid := a_other.w_arg_idx_invalid
			w_localdir := a_other.w_localdir
			w_onebuf_opt := a_other.w_onebuf_opt.twin
			w_allbuf_opt := a_other.w_allbuf_opt.twin
			w_p_stl_flags := a_other.w_p_stl_flags
			w_p_fde_flags := a_other.w_p_fde_flags
			w_p_fdt_flags := a_other.w_p_fdt_flags
			w_p_cc_cols := a_other.w_p_cc_cols
			w_scbind_pos := a_other.w_scbind_pos
			w_winvar := a_other.w_winvar.twin
			w_vars := a_other.w_vars.twin
			w_pcmark := a_other.w_pcmark.twin
			w_prev_pcmark := a_other.w_prev_pcmark.twin
			w_jumplist := a_other.w_jumplist.twin
			w_jumplistlen := a_other.w_jumplistlen
			w_jumplistidx := a_other.w_jumplistidx
			w_changelistidx := a_other.w_changelistidx
			w_match_head := a_other.w_match_head
			w_next_match_id := a_other.w_next_match_id
			w_tagstack := a_other.w_tagstack.twin
			w_tagstackidx := a_other.w_tagstackidx
			w_tagstacklen := a_other.w_tagstacklen
			w_fraction := a_other.w_fraction
			w_prev_fraction_row := a_other.w_prev_fraction_row
			w_scrollbars := a_other.w_scrollbars.twin
			w_nrwidth_line_count := a_other.w_nrwidth_line_count
			w_nrwidth_width := a_other.w_nrwidth_width
			w_llist := a_other.w_llist
			w_llist_ref := a_other.w_llist_ref
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				w_buffer.is_equal (a_other.w_buffer) and
				w_s.is_equal (a_other.w_s) and
				w_prev.is_equal (a_other.w_prev) and
				w_next.is_equal (a_other.w_next) and
				w_frame.is_equal (a_other.w_frame) and
				w_cursor.is_equal (a_other.w_cursor) and
				w_curswant = a_other.w_curswant and
				w_set_curswant = a_other.w_set_curswant and
				w_old_visual_mode = a_other.w_old_visual_mode and
				w_old_cursor_lnum = a_other.w_old_cursor_lnum and
				w_old_cursor_fcol = a_other.w_old_cursor_fcol and
				w_old_cursor_lcol = a_other.w_old_cursor_lcol and
				w_old_visual_lnum = a_other.w_old_visual_lnum and
				w_old_visual_col = a_other.w_old_visual_col and
				w_old_curswant = a_other.w_old_curswant and
				w_topline = a_other.w_topline and
				w_topline_was_set = a_other.w_topline_was_set and
				w_topfill = a_other.w_topfill and
				w_old_topfill = a_other.w_old_topfill and
				w_botfill = a_other.w_botfill and
				w_old_botfill = a_other.w_old_botfill and
				w_leftcol = a_other.w_leftcol and
				w_skipcol = a_other.w_skipcol and
				w_winrow = a_other.w_winrow and
				w_height = a_other.w_height and
				w_status_height = a_other.w_status_height and
				w_wincol = a_other.w_wincol and
				w_width = a_other.w_width and
				w_vsep_width = a_other.w_vsep_width and
				w_valid = a_other.w_valid and
				w_valid_cursor.is_equal (a_other.w_valid_cursor) and
				w_valid_leftcol = a_other.w_valid_leftcol and
				w_cline_height = a_other.w_cline_height and
				w_cline_folded = a_other.w_cline_folded and
				w_cline_row = a_other.w_cline_row and
				w_virtcol = a_other.w_virtcol and
				w_wrow = a_other.w_wrow and
				w_wcol = a_other.w_wcol and
				w_botline = a_other.w_botline and
				w_empty_rows = a_other.w_empty_rows and
				w_filler_rows = a_other.w_filler_rows and
				w_lines_valid = a_other.w_lines_valid and
				w_lines.is_equal (a_other.w_lines) and
				w_folds.is_equal (a_other.w_folds) and
				w_fold_manual = a_other.w_fold_manual and
				w_foldinvalid = a_other.w_foldinvalid and
				w_nrwidth = a_other.w_nrwidth and
				w_redr_type = a_other.w_redr_type and
				w_upd_rows = a_other.w_upd_rows and
				w_redraw_top = a_other.w_redraw_top and
				w_redraw_bot = a_other.w_redraw_bot and
				w_redr_status = a_other.w_redr_status and
				w_ru_cursor.is_equal (a_other.w_ru_cursor) and
				w_ru_virtcol = a_other.w_ru_virtcol and
				w_ru_topline = a_other.w_ru_topline and
				w_ru_line_count = a_other.w_ru_line_count and
				w_ru_topfill = a_other.w_ru_topfill and
				w_ru_empty = a_other.w_ru_empty and
				w_alt_fnum = a_other.w_alt_fnum and
				w_alist.is_equal (a_other.w_alist) and
				w_arg_idx = a_other.w_arg_idx and
				w_arg_idx_invalid = a_other.w_arg_idx_invalid and
				w_localdir.is_equal (a_other.w_localdir) and
				w_onebuf_opt.is_equal (a_other.w_onebuf_opt) and
				w_allbuf_opt.is_equal (a_other.w_allbuf_opt) and
				w_p_stl_flags = a_other.w_p_stl_flags and
				w_p_fde_flags = a_other.w_p_fde_flags and
				w_p_fdt_flags = a_other.w_p_fdt_flags and
				w_p_cc_cols.is_equal (a_other.w_p_cc_cols) and
				w_scbind_pos = a_other.w_scbind_pos and
				w_winvar.is_equal (a_other.w_winvar) and
				w_vars.is_equal (a_other.w_vars) and
				w_pcmark.is_equal (a_other.w_pcmark) and
				w_prev_pcmark.is_equal (a_other.w_prev_pcmark) and
				w_jumplist.is_equal (a_other.w_jumplist) and
				w_jumplistlen = a_other.w_jumplistlen and
				w_jumplistidx = a_other.w_jumplistidx and
				w_changelistidx = a_other.w_changelistidx and
				w_match_head.is_equal (a_other.w_match_head) and
				w_next_match_id = a_other.w_next_match_id and
				w_tagstack.is_equal (a_other.w_tagstack) and
				w_tagstackidx = a_other.w_tagstackidx and
				w_tagstacklen = a_other.w_tagstacklen and
				w_fraction = a_other.w_fraction and
				w_prev_fraction_row = a_other.w_prev_fraction_row and
				w_scrollbars.is_equal (a_other.w_scrollbars) and
				w_nrwidth_line_count = a_other.w_nrwidth_line_count and
				w_nrwidth_width = a_other.w_nrwidth_width and
				w_llist.is_equal (a_other.w_llist) and
				w_llist_ref.is_equal (a_other.w_llist_ref)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("w_buffer"),
					create {CE_STRUCTURE_FIELD}.make ("w_s"),
					create {CE_STRUCTURE_FIELD}.make ("w_prev"),
					create {CE_STRUCTURE_FIELD}.make ("w_next"),
					create {CE_STRUCTURE_FIELD}.make ("w_frame"),
					create {CE_STRUCTURE_FIELD}.make ("w_cursor"),
					create {CE_STRUCTURE_FIELD}.make ("w_curswant"),
					create {CE_STRUCTURE_FIELD}.make ("w_set_curswant"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_visual_mode"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_cursor_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_cursor_fcol"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_cursor_lcol"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_visual_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_visual_col"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_curswant"),
					create {CE_STRUCTURE_FIELD}.make ("w_topline"),
					create {CE_STRUCTURE_FIELD}.make ("w_topline_was_set"),
					create {CE_STRUCTURE_FIELD}.make ("w_topfill"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_topfill"),
					create {CE_STRUCTURE_FIELD}.make ("w_botfill"),
					create {CE_STRUCTURE_FIELD}.make ("w_old_botfill"),
					create {CE_STRUCTURE_FIELD}.make ("w_leftcol"),
					create {CE_STRUCTURE_FIELD}.make ("w_skipcol"),
					create {CE_STRUCTURE_FIELD}.make ("w_winrow"),
					create {CE_STRUCTURE_FIELD}.make ("w_height"),
					create {CE_STRUCTURE_FIELD}.make ("w_status_height"),
					create {CE_STRUCTURE_FIELD}.make ("w_wincol"),
					create {CE_STRUCTURE_FIELD}.make ("w_width"),
					create {CE_STRUCTURE_FIELD}.make ("w_vsep_width"),
					create {CE_STRUCTURE_FIELD}.make ("w_valid"),
					create {CE_STRUCTURE_FIELD}.make ("w_valid_cursor"),
					create {CE_STRUCTURE_FIELD}.make ("w_valid_leftcol"),
					create {CE_STRUCTURE_FIELD}.make ("w_cline_height"),
					create {CE_STRUCTURE_FIELD}.make ("w_cline_folded"),
					create {CE_STRUCTURE_FIELD}.make ("w_cline_row"),
					create {CE_STRUCTURE_FIELD}.make ("w_virtcol"),
					create {CE_STRUCTURE_FIELD}.make ("w_wrow"),
					create {CE_STRUCTURE_FIELD}.make ("w_wcol"),
					create {CE_STRUCTURE_FIELD}.make ("w_botline"),
					create {CE_STRUCTURE_FIELD}.make ("w_empty_rows"),
					create {CE_STRUCTURE_FIELD}.make ("w_filler_rows"),
					create {CE_STRUCTURE_FIELD}.make ("w_lines_valid"),
					create {CE_STRUCTURE_FIELD}.make ("w_lines"),
					create {CE_STRUCTURE_FIELD}.make ("w_folds"),
					create {CE_STRUCTURE_FIELD}.make ("w_fold_manual"),
					create {CE_STRUCTURE_FIELD}.make ("w_foldinvalid"),
					create {CE_STRUCTURE_FIELD}.make ("w_nrwidth"),
					create {CE_STRUCTURE_FIELD}.make ("w_redr_type"),
					create {CE_STRUCTURE_FIELD}.make ("w_upd_rows"),
					create {CE_STRUCTURE_FIELD}.make ("w_redraw_top"),
					create {CE_STRUCTURE_FIELD}.make ("w_redraw_bot"),
					create {CE_STRUCTURE_FIELD}.make ("w_redr_status"),
					create {CE_STRUCTURE_FIELD}.make ("w_ru_cursor"),
					create {CE_STRUCTURE_FIELD}.make ("w_ru_virtcol"),
					create {CE_STRUCTURE_FIELD}.make ("w_ru_topline"),
					create {CE_STRUCTURE_FIELD}.make ("w_ru_line_count"),
					create {CE_STRUCTURE_FIELD}.make ("w_ru_topfill"),
					create {CE_STRUCTURE_FIELD}.make ("w_ru_empty"),
					create {CE_STRUCTURE_FIELD}.make ("w_alt_fnum"),
					create {CE_STRUCTURE_FIELD}.make ("w_alist"),
					create {CE_STRUCTURE_FIELD}.make ("w_arg_idx"),
					create {CE_STRUCTURE_FIELD}.make ("w_arg_idx_invalid"),
					create {CE_STRUCTURE_FIELD}.make ("w_localdir"),
					create {CE_STRUCTURE_FIELD}.make ("w_onebuf_opt"),
					create {CE_STRUCTURE_FIELD}.make ("w_allbuf_opt"),
					create {CE_STRUCTURE_FIELD}.make ("w_p_stl_flags"),
					create {CE_STRUCTURE_FIELD}.make ("w_p_fde_flags"),
					create {CE_STRUCTURE_FIELD}.make ("w_p_fdt_flags"),
					create {CE_STRUCTURE_FIELD}.make ("w_p_cc_cols"),
					create {CE_STRUCTURE_FIELD}.make ("w_scbind_pos"),
					create {CE_STRUCTURE_FIELD}.make ("w_winvar"),
					create {CE_STRUCTURE_FIELD}.make ("w_vars"),
					create {CE_STRUCTURE_FIELD}.make ("w_pcmark"),
					create {CE_STRUCTURE_FIELD}.make ("w_prev_pcmark"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("w_jumplist", <<100>>),
					create {CE_STRUCTURE_FIELD}.make ("w_jumplistlen"),
					create {CE_STRUCTURE_FIELD}.make ("w_jumplistidx"),
					create {CE_STRUCTURE_FIELD}.make ("w_changelistidx"),
					create {CE_STRUCTURE_FIELD}.make ("w_match_head"),
					create {CE_STRUCTURE_FIELD}.make ("w_next_match_id"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("w_tagstack", <<20>>),
					create {CE_STRUCTURE_FIELD}.make ("w_tagstackidx"),
					create {CE_STRUCTURE_FIELD}.make ("w_tagstacklen"),
					create {CE_STRUCTURE_FIELD}.make ("w_fraction"),
					create {CE_STRUCTURE_FIELD}.make ("w_prev_fraction_row"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("w_scrollbars", <<2>>),
					create {CE_STRUCTURE_FIELD}.make ("w_nrwidth_line_count"),
					create {CE_STRUCTURE_FIELD}.make ("w_nrwidth_width"),
					create {CE_STRUCTURE_FIELD}.make ("w_llist"),
					create {CE_STRUCTURE_FIELD}.make ("w_llist_ref")
				>>)
			init_structure_info
		end

end
